/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/charCode","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/code/electron-main/main"],le=function(V){for(var e=[],i=0,o=V.length;i<o;i++)e[i]=ce[V[i]];return e};define(ce[138],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=i,e.$hb=o,e.$ib=E,e.$jb=D,e.$kb=R,e.$lb=P,e.$mb=y,e.$ob=h,e.$pb=d,e.$qb=g,e.$rb=b,e.$sb=u;function i(m,p){const $=o(m,p);if($!==-1)return m[$]}function o(m,p,$=m.length-1){for(let w=$;w>=0;w--){const v=m[w];if(p(v))return w}return-1}function E(m,p){const $=D(m,p);return $===-1?void 0:m[$]}function D(m,p,$=0,w=m.length){let v=$,S=w;for(;v<S;){const r=Math.floor((v+S)/2);p(m[r])?v=r+1:S=r}return v-1}function R(m,p){const $=P(m,p);return $===m.length?void 0:m[$]}function P(m,p,$=0,w=m.length){let v=$,S=w;for(;v<S;){const r=Math.floor((v+S)/2);p(m[r])?S=r:v=r+1}return v}function y(m,p,$=0,w=m.length){const v=P(m,p,$,w);return v===m.length?-1:v}class c{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(c.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!p(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const $=D(this.e,p,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$nb=c;function h(m,p){if(m.length===0)return;let $=m[0];for(let w=1;w<m.length;w++){const v=m[w];p(v,$)>0&&($=v)}return $}function d(m,p){if(m.length===0)return;let $=m[0];for(let w=1;w<m.length;w++){const v=m[w];p(v,$)>=0&&($=v)}return $}function g(m,p){return h(m,($,w)=>-p($,w))}function b(m,p){if(m.length===0)return-1;let $=0;for(let w=1;w<m.length;w++){const v=m[w];p(v,m[$])>0&&($=w)}return $}function u(m,p){for(const $ of m){const w=p($);if(w!==void 0)return w}}}),define(ce[39],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(o){o[o.Null=0]="Null",o[o.Backspace=8]="Backspace",o[o.Tab=9]="Tab",o[o.LineFeed=10]="LineFeed",o[o.CarriageReturn=13]="CarriageReturn",o[o.Space=32]="Space",o[o.ExclamationMark=33]="ExclamationMark",o[o.DoubleQuote=34]="DoubleQuote",o[o.Hash=35]="Hash",o[o.DollarSign=36]="DollarSign",o[o.PercentSign=37]="PercentSign",o[o.Ampersand=38]="Ampersand",o[o.SingleQuote=39]="SingleQuote",o[o.OpenParen=40]="OpenParen",o[o.CloseParen=41]="CloseParen",o[o.Asterisk=42]="Asterisk",o[o.Plus=43]="Plus",o[o.Comma=44]="Comma",o[o.Dash=45]="Dash",o[o.Period=46]="Period",o[o.Slash=47]="Slash",o[o.Digit0=48]="Digit0",o[o.Digit1=49]="Digit1",o[o.Digit2=50]="Digit2",o[o.Digit3=51]="Digit3",o[o.Digit4=52]="Digit4",o[o.Digit5=53]="Digit5",o[o.Digit6=54]="Digit6",o[o.Digit7=55]="Digit7",o[o.Digit8=56]="Digit8",o[o.Digit9=57]="Digit9",o[o.Colon=58]="Colon",o[o.Semicolon=59]="Semicolon",o[o.LessThan=60]="LessThan",o[o.Equals=61]="Equals",o[o.GreaterThan=62]="GreaterThan",o[o.QuestionMark=63]="QuestionMark",o[o.AtSign=64]="AtSign",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.OpenSquareBracket=91]="OpenSquareBracket",o[o.Backslash=92]="Backslash",o[o.CloseSquareBracket=93]="CloseSquareBracket",o[o.Caret=94]="Caret",o[o.Underline=95]="Underline",o[o.BackTick=96]="BackTick",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.OpenCurlyBrace=123]="OpenCurlyBrace",o[o.Pipe=124]="Pipe",o[o.CloseCurlyBrace=125]="CloseCurlyBrace",o[o.Tilde=126]="Tilde",o[o.NoBreakSpace=160]="NoBreakSpace",o[o.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",o[o.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",o[o.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",o[o.U_Combining_Tilde=771]="U_Combining_Tilde",o[o.U_Combining_Macron=772]="U_Combining_Macron",o[o.U_Combining_Overline=773]="U_Combining_Overline",o[o.U_Combining_Breve=774]="U_Combining_Breve",o[o.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",o[o.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",o[o.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",o[o.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",o[o.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",o[o.U_Combining_Caron=780]="U_Combining_Caron",o[o.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",o[o.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",o[o.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",o[o.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",o[o.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",o[o.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",o[o.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",o[o.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",o[o.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",o[o.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",o[o.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",o[o.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",o[o.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",o[o.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",o[o.U_Combining_Horn=795]="U_Combining_Horn",o[o.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",o[o.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",o[o.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",o[o.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",o[o.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",o[o.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",o[o.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",o[o.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",o[o.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",o[o.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",o[o.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",o[o.U_Combining_Cedilla=807]="U_Combining_Cedilla",o[o.U_Combining_Ogonek=808]="U_Combining_Ogonek",o[o.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",o[o.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",o[o.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",o[o.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",o[o.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",o[o.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",o[o.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",o[o.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",o[o.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",o[o.U_Combining_Low_Line=818]="U_Combining_Low_Line",o[o.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",o[o.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",o[o.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",o[o.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",o[o.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",o[o.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",o[o.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",o[o.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",o[o.U_Combining_Square_Below=827]="U_Combining_Square_Below",o[o.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",o[o.U_Combining_X_Above=829]="U_Combining_X_Above",o[o.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",o[o.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",o[o.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",o[o.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",o[o.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",o[o.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",o[o.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",o[o.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",o[o.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",o[o.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",o[o.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",o[o.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",o[o.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",o[o.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",o[o.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",o[o.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",o[o.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",o[o.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",o[o.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",o[o.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",o[o.U_Combining_Fermata=850]="U_Combining_Fermata",o[o.U_Combining_X_Below=851]="U_Combining_X_Below",o[o.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",o[o.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",o[o.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",o[o.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",o[o.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",o[o.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",o[o.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",o[o.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",o[o.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",o[o.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",o[o.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",o[o.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",o[o.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",o[o.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",o[o.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",o[o.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",o[o.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",o[o.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",o[o.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",o[o.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",o[o.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",o[o.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",o[o.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",o[o.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",o[o.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",o[o.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",o[o.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",o[o.LINE_SEPARATOR=8232]="LINE_SEPARATOR",o[o.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",o[o.NEXT_LINE=133]="NEXT_LINE",o[o.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",o[o.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",o[o.U_DIAERESIS=168]="U_DIAERESIS",o[o.U_MACRON=175]="U_MACRON",o[o.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",o[o.U_CEDILLA=184]="U_CEDILLA",o[o.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",o[o.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",o[o.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",o[o.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",o[o.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",o[o.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",o[o.U_BREVE=728]="U_BREVE",o[o.U_DOT_ABOVE=729]="U_DOT_ABOVE",o[o.U_RING_ABOVE=730]="U_RING_ABOVE",o[o.U_OGONEK=731]="U_OGONEK",o[o.U_SMALL_TILDE=732]="U_SMALL_TILDE",o[o.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",o[o.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",o[o.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",o[o.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",o[o.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",o[o.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",o[o.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",o[o.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",o[o.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",o[o.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",o[o.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",o[o.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",o[o.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",o[o.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",o[o.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",o[o.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",o[o.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",o[o.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",o[o.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",o[o.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",o[o.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",o[o.U_GREEK_TONOS=900]="U_GREEK_TONOS",o[o.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",o[o.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",o[o.U_GREEK_PSILI=8127]="U_GREEK_PSILI",o[o.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",o[o.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",o[o.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",o[o.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",o[o.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",o[o.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",o[o.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",o[o.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",o[o.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",o[o.U_GREEK_VARIA=8175]="U_GREEK_VARIA",o[o.U_GREEK_OXIA=8189]="U_GREEK_OXIA",o[o.U_GREEK_DASIA=8190]="U_GREEK_DASIA",o[o.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",o[o.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",o[o.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",o[o.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",o[o.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",o[o.U_OVERLINE=8254]="U_OVERLINE",o[o.UTF8_BOM=65279]="UTF8_BOM",o[o.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",o[o.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(ce[139],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=i,e.$L=o,e.$M=E,e.$N=D;function i(R,P){const y=Object.create(null);for(const c of R){const h=P(c);let d=y[h];d||(d=y[h]=[]),d.push(c)}return y}function o(R,P){const y=[],c=[];for(const h of R)P.has(h)||y.push(h);for(const h of P)R.has(h)||c.push(h);return{removed:y,added:c}}function E(R,P){const y=[],c=[];for(const[h,d]of R)P.has(h)||y.push(d);for(const[h,d]of P)R.has(h)||c.push(d);return{removed:y,added:c}}function D(R,P){const y=new Set;for(const c of P)R.has(c)&&y.add(c);return y}}),define(ce[140],le([0,1,39]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.$fu=e.$eu=e.$du=void 0;function o(y,c){const h=Math.pow(10,c);return Math.round(y*h)/h}class E{constructor(c,h,d,g=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=o(Math.max(Math.min(1,g),0),3)}static equals(c,h){return c.r===h.r&&c.g===h.g&&c.b===h.b&&c.a===h.a}}e.$du=E;class D{constructor(c,h,d,g){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=o(Math.max(Math.min(1,h),0),3),this.l=o(Math.max(Math.min(1,d),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(c,h){return c.h===h.h&&c.s===h.s&&c.l===h.l&&c.a===h.a}static fromRGBA(c){const h=c.r/255,d=c.g/255,g=c.b/255,b=c.a,u=Math.max(h,d,g),m=Math.min(h,d,g);let p=0,$=0;const w=(m+u)/2,v=u-m;if(v>0){switch($=Math.min(w<=.5?v/(2*w):v/(2-2*w),1),u){case h:p=(d-g)/v+(d<g?6:0);break;case d:p=(g-h)/v+2;break;case g:p=(h-d)/v+4;break}p*=60,p=Math.round(p)}return new D(p,$,w,b)}static i(c,h,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?c+(h-c)*6*d:d<1/2?h:d<2/3?c+(h-c)*(2/3-d)*6:c}static toRGBA(c){const h=c.h/360,{s:d,l:g,a:b}=c;let u,m,p;if(d===0)u=m=p=g;else{const $=g<.5?g*(1+d):g+d-g*d,w=2*g-$;u=D.i(w,$,h+1/3),m=D.i(w,$,h),p=D.i(w,$,h-1/3)}return new E(Math.round(u*255),Math.round(m*255),Math.round(p*255),b)}}e.$eu=D;class R{constructor(c,h,d,g){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=o(Math.max(Math.min(1,h),0),3),this.v=o(Math.max(Math.min(1,d),0),3),this.a=o(Math.max(Math.min(1,g),0),3)}static equals(c,h){return c.h===h.h&&c.s===h.s&&c.v===h.v&&c.a===h.a}static fromRGBA(c){const h=c.r/255,d=c.g/255,g=c.b/255,b=Math.max(h,d,g),u=Math.min(h,d,g),m=b-u,p=b===0?0:m/b;let $;return m===0?$=0:b===h?$=((d-g)/m%6+6)%6:b===d?$=(g-h)/m+2:$=(h-d)/m+4,new R(Math.round($*60),p,b,c.a)}static toRGBA(c){const{h,s:d,v:g,a:b}=c,u=g*d,m=u*(1-Math.abs(h/60%2-1)),p=g-u;let[$,w,v]=[0,0,0];return h<60?($=u,w=m):h<120?($=m,w=u):h<180?(w=u,v=m):h<240?(w=m,v=u):h<300?($=m,v=u):h<=360&&($=u,v=m),$=Math.round(($+p)*255),w=Math.round((w+p)*255),v=Math.round((v+p)*255),new E($,w,v,b)}}e.$fu=R;class P{static fromHex(c){return P.Format.CSS.parseHex(c)||P.red}static equals(c,h){return!c&&!h?!0:!c||!h?!1:c.equals(h)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof E)this.rgba=c;else if(c instanceof D)this.i=c,this.rgba=D.toRGBA(c);else if(c instanceof R)this.j=c,this.rgba=R.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&E.equals(this.rgba,c.rgba)&&D.equals(this.hsla,c.hsla)&&R.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=P.k(this.rgba.r),h=P.k(this.rgba.g),d=P.k(this.rgba.b),g=.2126*c+.7152*h+.0722*d;return o(g,4)}static k(c){const h=c/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(c){const h=this.getRelativeLuminance(),d=c.getRelativeLuminance();return h>d?(h+.05)/(d+.05):(d+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const h=this.getRelativeLuminance(),d=c.getRelativeLuminance();return h>d}isDarkerThan(c){const h=this.getRelativeLuminance(),d=c.getRelativeLuminance();return h<d}lighten(c){return new P(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new P(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:h,g:d,b:g,a:b}=this.rgba;return new P(new E(h,d,g,b*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new P(new E(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const h=c.rgba,d=this.rgba.a,g=h.a,b=d+g*(1-d);if(b<1e-6)return P.transparent;const u=this.rgba.r*d/b+h.r*g*(1-d)/b,m=this.rgba.g*d/b+h.g*g*(1-d)/b,p=this.rgba.b*d/b+h.b*g*(1-d)/b;return new P(new E(u,m,p,b))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:h,g:d,b:g,a:b}=this.rgba;return new P(new E(c.rgba.r-b*(c.rgba.r-h),c.rgba.g-b*(c.rgba.g-d),c.rgba.b-b*(c.rgba.b-g),1))}flatten(...c){const h=c.reduceRight((d,g)=>P.o(g,d));return P.o(this,h)}static o(c,h){const d=1-c.rgba.a;return new P(new E(d*h.rgba.r+c.rgba.a*c.rgba.r,d*h.rgba.g+c.rgba.a*c.rgba.g,d*h.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=P.Format.CSS.format(this)),this.u}static getLighterColor(c,h,d){if(c.isLighterThan(h))return c;d=d||.5;const g=c.getRelativeLuminance(),b=h.getRelativeLuminance();return d=d*(b-g)/b,c.lighten(d)}static getDarkerColor(c,h,d){if(c.isDarkerThan(h))return c;d=d||.5;const g=c.getRelativeLuminance(),b=h.getRelativeLuminance();return d=d*(g-b)/g,c.darken(d)}static{this.white=new P(new E(255,255,255,1))}static{this.black=new P(new E(0,0,0,1))}static{this.red=new P(new E(255,0,0,1))}static{this.blue=new P(new E(0,0,255,1))}static{this.green=new P(new E(0,255,0,1))}static{this.cyan=new P(new E(0,255,255,1))}static{this.lightgrey=new P(new E(211,211,211,1))}static{this.transparent=new P(new E(0,0,0,0))}}e.$gu=P,function(y){let c;(function(h){let d;(function(g){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:y.Format.CSS.formatRGBA(n)}g.formatRGB=b;function u(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}g.formatRGBA=u;function m(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(n)}g.formatHSL=m;function p(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}g.formatHSLA=p;function $(n){const a=n.toString(16);return a.length!==2?"0"+a:a}function w(n){return`#${$(n.rgba.r)}${$(n.rgba.g)}${$(n.rgba.b)}`}g.formatHex=w;function v(n,a=!1){return a&&n.rgba.a===1?y.Format.CSS.formatHex(n):`#${$(n.rgba.r)}${$(n.rgba.g)}${$(n.rgba.b)}${$(Math.round(n.rgba.a*255))}`}g.formatHexA=v;function S(n){return n.isOpaque()?y.Format.CSS.formatHex(n):y.Format.CSS.formatRGBA(n)}g.format=S;function r(n){const a=n.length;if(a===0||n.charCodeAt(0)!==i.CharCode.Hash)return null;if(a===7){const s=16*t(n.charCodeAt(1))+t(n.charCodeAt(2)),l=16*t(n.charCodeAt(3))+t(n.charCodeAt(4)),f=16*t(n.charCodeAt(5))+t(n.charCodeAt(6));return new y(new E(s,l,f,1))}if(a===9){const s=16*t(n.charCodeAt(1))+t(n.charCodeAt(2)),l=16*t(n.charCodeAt(3))+t(n.charCodeAt(4)),f=16*t(n.charCodeAt(5))+t(n.charCodeAt(6)),k=16*t(n.charCodeAt(7))+t(n.charCodeAt(8));return new y(new E(s,l,f,k/255))}if(a===4){const s=t(n.charCodeAt(1)),l=t(n.charCodeAt(2)),f=t(n.charCodeAt(3));return new y(new E(16*s+s,16*l+l,16*f+f))}if(a===5){const s=t(n.charCodeAt(1)),l=t(n.charCodeAt(2)),f=t(n.charCodeAt(3)),k=t(n.charCodeAt(4));return new y(new E(16*s+s,16*l+l,16*f+f,(16*k+k)/255))}return null}g.parseHex=r;function t(n){switch(n){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(d=h.CSS||(h.CSS={}))})(c=y.Format||(y.Format={}))}(P||(e.$gu=P={}))}),define(ce[52],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=o,e.$0h=E,e.$$h=D;function i(R){return(P,y,c)=>{let h=null,d=null;if(typeof c.value=="function"?(h="value",d=c.value):typeof c.get=="function"&&(h="get",d=c.get),!d)throw new Error("not supported");c[h]=R(d,y)}}function o(R,P,y){let c=null,h=null;if(typeof y.value=="function"?(c="value",h=y.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(c="get",h=y.get),!h)throw new Error("not supported");const d=`$memoize$${P}`;y[c]=function(...g){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,g)}),this[d]}}function E(R,P,y){return i((c,h)=>{const d=`$debounce$${h}`,g=`$debounce$result$${h}`;return function(...b){this[g]||(this[g]=y?y():void 0),clearTimeout(this[d]),P&&(this[g]=P(this[g],...b),b=[this[g]]),this[d]=setTimeout(()=>{c.apply(this,b),this[g]=y?y():void 0},R)}})}function D(R,P,y){return i((c,h)=>{const d=`$throttle$timer$${h}`,g=`$throttle$result$${h}`,b=`$throttle$lastRun$${h}`,u=`$throttle$pending$${h}`;return function(...m){if(this[g]||(this[g]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...m)),this[u])return;const p=this[b]+R;p<=Date.now()?(this[b]=Date.now(),c.apply(this,[this[g]]),this[g]=y?y():void 0):(this[u]=!0,this[d]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),c.apply(this,[this[g]]),this[g]=y?y():void 0},p-Date.now()))}})}}),define(ce[16],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=o,e.$1=E,e.$2=D,e.$3=R,e.$4=P,e.$5=c,e.$7=d,e.$8=g,e.$9=b,e.$$=m;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?v.isErrorNoTelemetry(t)?new v(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=i,e.$Y=new i;function o(r){e.$Y.setUnexpectedErrorHandler(r)}function E(r){if(!r||typeof r!="object")return!1;const t=r;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(r){c(r)||e.$Y.onUnexpectedError(r)}function R(r){c(r)||e.$Y.onUnexpectedExternalError(r)}function P(r){if(r instanceof Error){const{name:t,message:n}=r,a=r.stacktrace||r.stack;return{$isError:!0,name:t,message:n,stack:a,noTelemetry:v.isErrorNoTelemetry(r)}}return r}const y="Canceled";function c(r){return r instanceof h?!0:r instanceof Error&&r.name===y&&r.message===y}class h extends Error{constructor(){super(y),this.name=this.message}}e.$6=h;function d(){const r=new Error(y);return r.name=r.message,r}function g(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function b(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class u extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=u;function m(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$_=p;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$ab=$;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=w;class v extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof v)return t;const n=new v;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$cb=v;class S extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.$db=S}),define(ce[22],le([0,1,16,138]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=E,e.$ub=D,e.$vb=R,e.$wb=P,e.$xb=y,e.$yb=c,e.$zb=h,e.$Ab=d,e.$Bb=g,e.$Cb=b,e.$Db=u,e.$Eb=m,e.$Fb=p,e.top=$,e.$Hb=w,e.$Ib=S,e.$Jb=r,e.$Kb=t,e.$Lb=n,e.$Mb=a,e.$Nb=s,e.$Ob=l,e.$Pb=f,e.$Qb=k,e.$Rb=I,e.$Sb=O,e.$Tb=L,e.$Ub=T,e.$Vb=A,e.$Wb=M,e.$Xb=z,e.$Yb=C,e.$Zb=B,e.$1b=re,e.$2b=_,e.$3b=se,e.$4b=K,e.$5b=ee,e.$6b=H,e.$7b=x,e.$8b=ae,e.$$b=ne;function E(W,q=0){return W[W.length-(1+q)]}function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}function R(W,q,Q=(X,Y)=>X===Y){if(W===q)return!0;if(!W||!q||W.length!==q.length)return!1;for(let X=0,Y=W.length;X<Y;X++)if(!Q(W[X],q[X]))return!1;return!0}function P(W,q){const Q=W.length-1;q<Q&&(W[q]=W[Q]),W.pop()}function y(W,q,Q){return c(W.length,X=>Q(W[X],q))}function c(W,q){let Q=0,X=W-1;for(;Q<=X;){const Y=(Q+X)/2|0,ie=q(Y);if(ie<0)Q=Y+1;else if(ie>0)X=Y-1;else return Y}return-(Q+1)}function h(W,q,Q){if(W=W|0,W>=q.length)throw new TypeError("invalid index");const X=q[Math.floor(q.length*Math.random())],Y=[],ie=[],de=[];for(const me of q){const pe=Q(me,X);pe<0?Y.push(me):pe>0?ie.push(me):de.push(me)}return W<Y.length?h(W,Y,Q):W<Y.length+de.length?de[0]:h(W-(Y.length+de.length),ie,Q)}function d(W,q){const Q=[];let X;for(const Y of W.slice(0).sort(q))!X||q(X[0],Y)!==0?(X=[Y],Q.push(X)):X.push(Y);return Q}function*g(W,q){let Q,X;for(const Y of W)X!==void 0&&q(X,Y)?Q.push(Y):(Q&&(yield Q),Q=[Y]),X=Y;Q&&(yield Q)}function b(W,q){for(let Q=0;Q<=W.length;Q++)q(Q===0?void 0:W[Q-1],Q===W.length?void 0:W[Q])}function u(W,q){for(let Q=0;Q<W.length;Q++)q(Q===0?void 0:W[Q-1],W[Q],Q+1===W.length?void 0:W[Q+1])}function m(W,q,Q){const X=[];function Y(me,pe,Ie){if(pe===0&&Ie.length===0)return;const ke=X[X.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=pe,ke.toInsert.push(...Ie)):X.push({start:me,deleteCount:pe,toInsert:Ie})}let ie=0,de=0;for(;;){if(ie===W.length){Y(ie,0,q.slice(de));break}if(de===q.length){Y(ie,W.length-ie,[]);break}const me=W[ie],pe=q[de],Ie=Q(me,pe);Ie===0?(ie+=1,de+=1):Ie<0?(Y(ie,1,[]),ie+=1):Ie>0&&(Y(ie,0,[pe]),de+=1)}return X}function p(W,q,Q){const X=m(W,q,Q),Y=[],ie=[];for(const de of X)Y.push(...W.slice(de.start,de.start+de.deleteCount)),ie.push(...de.toInsert);return{removed:Y,added:ie}}function $(W,q,Q){if(Q===0)return[];const X=W.slice(0,Q).sort(q);return v(W,q,X,Q,W.length),X}function w(W,q,Q,X,Y){return Q===0?Promise.resolve([]):new Promise((ie,de)=>{(async()=>{const me=W.length,pe=W.slice(0,Q).sort(q);for(let Ie=Q,ke=Math.min(Q+X,me);Ie<me;Ie=ke,ke=Math.min(ke+X,me)){if(Ie>Q&&await new Promise(Pe=>setTimeout(Pe)),Y&&Y.isCancellationRequested)throw new i.$6;v(W,q,pe,Ie,ke)}return pe})().then(ie,de)})}function v(W,q,Q,X,Y){for(const ie=Q.length;X<Y;X++){const de=W[X];if(q(de,Q[ie-1])<0){Q.pop();const me=(0,o.$lb)(Q,pe=>q(de,pe)<0);Q.splice(me,0,de)}}}function S(W){return W.filter(q=>!!q)}function r(W){let q=0;for(let Q=0;Q<W.length;Q++)W[Q]&&(W[q]=W[Q],q+=1);W.length=q}function t(W,q,Q){W.splice(Q,0,W.splice(q,1)[0])}function n(W){return!Array.isArray(W)||W.length===0}function a(W){return Array.isArray(W)&&W.length>0}function s(W,q=Q=>Q){const Q=new Set;return W.filter(X=>{const Y=q(X);return Q.has(Y)?!1:(Q.add(Y),!0)})}function l(W){const q=new Set;return Q=>{const X=W(Q);return q.has(X)?!1:(q.add(X),!0)}}function f(W,q){return W.length>0?W[0]:q}function k(W,q){return W.length>0?W[W.length-1]:q}function I(W,q,Q=(X,Y)=>X===Y){let X=0;for(let Y=0,ie=Math.min(W.length,q.length);Y<ie&&Q(W[Y],q[Y]);Y++)X++;return X}function O(W,q){let Q=typeof q=="number"?W:0;typeof q=="number"?Q=W:(Q=0,q=W);const X=[];if(Q<=q)for(let Y=Q;Y<q;Y++)X.push(Y);else for(let Y=Q;Y>q;Y--)X.push(Y);return X}function L(W,q,Q){return W.reduce((X,Y)=>(X[q(Y)]=Q?Q(Y):Y,X),Object.create(null))}function T(W,q){return W.push(q),()=>A(W,q)}function A(W,q){const Q=W.indexOf(q);if(Q>-1)return W.splice(Q,1),q}function M(W,q,Q){const X=W.slice(0,q),Y=W.slice(q);return X.concat(Q,Y)}function z(W,q){let Q;if(typeof q=="number"){let X=q;Q=()=>{const Y=Math.sin(X++)*179426549;return Y-Math.floor(Y)}}else Q=Math.random;for(let X=W.length-1;X>0;X-=1){const Y=Math.floor(Q()*(X+1)),ie=W[X];W[X]=W[Y],W[Y]=ie}}function C(W,q){const Q=W.indexOf(q);Q>-1&&(W.splice(Q,1),W.unshift(q))}function B(W,q){const Q=W.indexOf(q);Q>-1&&(W.splice(Q,1),W.push(q))}function re(W,q){for(const Q of q)W.push(Q)}function _(W,q){return Array.isArray(W)?W.map(q):q(W)}function se(W){return Array.isArray(W)?W:[W]}function K(W){return W[Math.floor(Math.random()*W.length)]}function ee(W,q,Q){const X=j(W,q),Y=W.length,ie=Q.length;W.length=Y+ie;for(let de=Y-1;de>=X;de--)W[de+ie]=W[de];for(let de=0;de<ie;de++)W[de+X]=Q[de]}function H(W,q,Q,X){const Y=j(W,q);let ie=W.splice(Y,Q);return ie===void 0&&(ie=[]),ee(W,Y,X),ie}function j(W,q){return q<0?Math.max(q+W.length,0):Math.min(q,W.length)}var U;(function(W){function q(ie){return ie<0}W.isLessThan=q;function Q(ie){return ie<=0}W.isLessThanOrEqual=Q;function X(ie){return ie>0}W.isGreaterThan=X;function Y(ie){return ie===0}W.isNeitherLessOrGreaterThan=Y,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(U||(e.CompareResult=U={}));function x(W,q){return(Q,X)=>q(W(Q),W(X))}function ae(...W){return(q,Q)=>{for(const X of W){const Y=X(q,Q);if(!U.isNeitherLessOrGreaterThan(Y))return Y}return U.neitherLessOrGreaterThan}}const G=(W,q)=>W-q;e.$9b=G;const he=(W,q)=>(0,e.$9b)(W?1:0,q?1:0);e.$0b=he;function ne(W){return(q,Q)=>-W(q,Q)}class Z{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let Q=this.c;for(;Q<this.g.length&&q(this.g[Q]);)Q++;const X=Q===this.c?null:this.g.slice(this.c,Q);return this.c=Q,X}takeFromEndWhile(q){let Q=this.d;for(;Q>=0&&q(this.g[Q]);)Q--;const X=Q===this.d?null:this.g.slice(Q+1,this.d+1);return this.d=Q,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const Q=this.g.slice(this.c,this.c+q);return this.c+=q,Q}}e.$_b=Z;class F{static{this.empty=new F(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(Q=>(q(Q),!0))}toArray(){const q=[];return this.iterate(Q=>(q.push(Q),!0)),q}filter(q){return new F(Q=>this.iterate(X=>q(X)?Q(X):!0))}map(q){return new F(Q=>this.iterate(X=>Q(q(X))))}some(q){let Q=!1;return this.iterate(X=>(Q=q(X),!Q)),Q}findFirst(q){let Q;return this.iterate(X=>q(X)?(Q=X,!1):!0),Q}findLast(q){let Q;return this.iterate(X=>(q(X)&&(Q=X),!0)),Q}findLastMaxBy(q){let Q,X=!0;return this.iterate(Y=>((X||U.isGreaterThan(q(Y,Q)))&&(X=!1,Q=Y),!0)),Q}}e.$ac=F;class N{constructor(q){this.c=q}static createSortPermutation(q,Q){const X=Array.from(q.keys()).sort((Y,ie)=>Q(q[Y],q[ie]));return new N(X)}apply(q){return q.map((Q,X)=>q[this.c[X]])}inverse(){const q=this.c.slice();for(let Q=0;Q<this.c.length;Q++)q[this.c[Q]]=Q;return new N(q)}}e.$bc=N}),define(ce[141],le([0,1,16]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=o,e.$fd=E,e.$gd=D,e.$hd=R,e.$id=P,e.$jd=y;function o(c,h){if(!c)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function E(c,h="Unreachable"){throw new Error(h)}function D(c,h="unexpected state"){if(!c)throw new i.$db(`Assertion Failed: ${h}`)}function R(c){c||(0,i.$2)(new i.$db("Soft Assertion Failed"))}function P(c){if(!c()){debugger;c(),(0,i.$2)(new i.$db("Assertion Failed"))}}function y(c,h){let d=0;for(;d<c.length-1;){const g=c[d],b=c[d+1];if(!h(g,b))return!1;d++}return!0}}),define(ce[89],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=i;function i(o,E){const D=this;let R=!1,P;return function(){if(R)return P;if(R=!0,E)try{P=o.apply(D,arguments)}finally{E()}else P=o.apply(D,arguments);return P}}}),define(ce[76],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(o){function E(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}o.is=E;const D=Object.freeze([]);function R(){return D}o.empty=R;function*P(n){yield n}o.single=P;function y(n){return E(n)?n:P(n)}o.wrap=y;function c(n){return n||D}o.from=c;function*h(n){for(let a=n.length-1;a>=0;a--)yield n[a]}o.reverse=h;function d(n){return!n||n[Symbol.iterator]().next().done===!0}o.isEmpty=d;function g(n){return n[Symbol.iterator]().next().value}o.first=g;function b(n,a){let s=0;for(const l of n)if(a(l,s++))return!0;return!1}o.some=b;function u(n,a){for(const s of n)if(a(s))return s}o.find=u;function*m(n,a){for(const s of n)a(s)&&(yield s)}o.filter=m;function*p(n,a){let s=0;for(const l of n)yield a(l,s++)}o.map=p;function*$(n,a){let s=0;for(const l of n)yield*a(l,s++)}o.flatMap=$;function*w(...n){for(const a of n)yield*a}o.concat=w;function v(n,a,s){let l=s;for(const f of n)l=a(l,f);return l}o.reduce=v;function*S(n,a,s=n.length){for(a<0&&(a+=n.length),s<0?s+=n.length:s>n.length&&(s=n.length);a<s;a++)yield n[a]}o.slice=S;function r(n,a=Number.POSITIVE_INFINITY){const s=[];if(a===0)return[s,n];const l=n[Symbol.iterator]();for(let f=0;f<a;f++){const k=l.next();if(k.done)return[s,o.empty()];s.push(k.value)}return[s,{[Symbol.iterator](){return l}}]}o.consume=r;async function t(n){const a=[];for await(const s of n)a.push(s);return Promise.resolve(a)}o.asyncToArray=t})(i||(e.Iterable=i={}))}),define(ce[40],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=R,e.$Tn=d,e.$Un=g,e.$Vn=b,e.$Wn=u,e.$Xn=m,e.$Yn=p,e.$Zn=$,e.$1n=w,e.$2n=v,e.$3n=S,e.$4n=r;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var o;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(o||(e.SyntaxKind=o={}));var E;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function R(t,n=!1){let a=0;const s=t.length;let l="",f=0,k=o.Unknown,I=i.None;function O(B){let re=0,_=0;for(;re<B;){const se=t.charCodeAt(a);if(se>=h._0&&se<=h._9)_=_*16+se-h._0;else if(se>=h.A&&se<=h.F)_=_*16+se-h.A+10;else if(se>=h.a&&se<=h.f)_=_*16+se-h.a+10;else break;a++,re++}return re<B&&(_=-1),_}function L(B){a=B,l="",f=0,k=o.Unknown,I=i.None}function T(){const B=a;if(t.charCodeAt(a)===h._0)a++;else for(a++;a<t.length&&c(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===h.dot)if(a++,a<t.length&&c(t.charCodeAt(a)))for(a++;a<t.length&&c(t.charCodeAt(a));)a++;else return I=i.UnexpectedEndOfNumber,t.substring(B,a);let re=a;if(a<t.length&&(t.charCodeAt(a)===h.E||t.charCodeAt(a)===h.e))if(a++,(a<t.length&&t.charCodeAt(a)===h.plus||t.charCodeAt(a)===h.minus)&&a++,a<t.length&&c(t.charCodeAt(a))){for(a++;a<t.length&&c(t.charCodeAt(a));)a++;re=a}else I=i.UnexpectedEndOfNumber;return t.substring(B,re)}function A(){let B="",re=a;for(;;){if(a>=s){B+=t.substring(re,a),I=i.UnexpectedEndOfString;break}const _=t.charCodeAt(a);if(_===h.doubleQuote){B+=t.substring(re,a),a++;break}if(_===h.backslash){if(B+=t.substring(re,a),a++,a>=s){I=i.UnexpectedEndOfString;break}switch(t.charCodeAt(a++)){case h.doubleQuote:B+='"';break;case h.backslash:B+="\\";break;case h.slash:B+="/";break;case h.b:B+="\b";break;case h.f:B+="\f";break;case h.n:B+=`
`;break;case h.r:B+="\r";break;case h.t:B+="	";break;case h.u:{const K=O(4);K>=0?B+=String.fromCharCode(K):I=i.InvalidUnicode;break}default:I=i.InvalidEscapeCharacter}re=a;continue}if(_>=0&&_<=31)if(y(_)){B+=t.substring(re,a),I=i.UnexpectedEndOfString;break}else I=i.InvalidCharacter;a++}return B}function M(){if(l="",I=i.None,f=a,a>=s)return f=s,k=o.EOF;let B=t.charCodeAt(a);if(P(B)){do a++,l+=String.fromCharCode(B),B=t.charCodeAt(a);while(P(B));return k=o.Trivia}if(y(B))return a++,l+=String.fromCharCode(B),B===h.carriageReturn&&t.charCodeAt(a)===h.lineFeed&&(a++,l+=`
`),k=o.LineBreakTrivia;switch(B){case h.openBrace:return a++,k=o.OpenBraceToken;case h.closeBrace:return a++,k=o.CloseBraceToken;case h.openBracket:return a++,k=o.OpenBracketToken;case h.closeBracket:return a++,k=o.CloseBracketToken;case h.colon:return a++,k=o.ColonToken;case h.comma:return a++,k=o.CommaToken;case h.doubleQuote:return a++,l=A(),k=o.StringLiteral;case h.slash:{const re=a-1;if(t.charCodeAt(a+1)===h.slash){for(a+=2;a<s&&!y(t.charCodeAt(a));)a++;return l=t.substring(re,a),k=o.LineCommentTrivia}if(t.charCodeAt(a+1)===h.asterisk){a+=2;const _=s-1;let se=!1;for(;a<_;){if(t.charCodeAt(a)===h.asterisk&&t.charCodeAt(a+1)===h.slash){a+=2,se=!0;break}a++}return se||(a++,I=i.UnexpectedEndOfComment),l=t.substring(re,a),k=o.BlockCommentTrivia}return l+=String.fromCharCode(B),a++,k=o.Unknown}case h.minus:if(l+=String.fromCharCode(B),a++,a===s||!c(t.charCodeAt(a)))return k=o.Unknown;case h._0:case h._1:case h._2:case h._3:case h._4:case h._5:case h._6:case h._7:case h._8:case h._9:return l+=T(),k=o.NumericLiteral;default:for(;a<s&&z(B);)a++,B=t.charCodeAt(a);if(f!==a){switch(l=t.substring(f,a),l){case"true":return k=o.TrueKeyword;case"false":return k=o.FalseKeyword;case"null":return k=o.NullKeyword}return k=o.Unknown}return l+=String.fromCharCode(B),a++,k=o.Unknown}}function z(B){if(P(B)||y(B))return!1;switch(B){case h.closeBrace:case h.closeBracket:case h.openBrace:case h.openBracket:case h.doubleQuote:case h.colon:case h.comma:case h.slash:return!1}return!0}function C(){let B;do B=M();while(B>=o.LineCommentTrivia&&B<=o.Trivia);return B}return{setPosition:L,getPosition:()=>a,scan:n?C:M,getToken:()=>k,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>a-f,getTokenError:()=>I}}function P(t){return t===h.space||t===h.tab||t===h.verticalTab||t===h.formFeed||t===h.nonBreakingSpace||t===h.ogham||t>=h.enQuad&&t<=h.zeroWidthSpace||t===h.narrowNoBreakSpace||t===h.mathematicalSpace||t===h.ideographicSpace||t===h.byteOrderMark}function y(t){return t===h.lineFeed||t===h.carriageReturn||t===h.lineSeparator||t===h.paragraphSeparator}function c(t){return t>=h._0&&t<=h._9}var h;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(h||(h={}));function d(t,n){const a=[],s=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(O,L,T,A){f.value=O,f.offset=L,f.length=T,f.type=A,f.colonOffset=void 0,l=f}try{v(t,{onObjectBegin:(O,L)=>{if(n<=O)throw s;l=void 0,k=n>O,a.push("")},onObjectProperty:(O,L,T)=>{if(n<L||(I(O,L,T,"property"),a[a.length-1]=O,n<=L+T))throw s},onObjectEnd:(O,L)=>{if(n<=O)throw s;l=void 0,a.pop()},onArrayBegin:(O,L)=>{if(n<=O)throw s;l=void 0,a.push(0)},onArrayEnd:(O,L)=>{if(n<=O)throw s;l=void 0,a.pop()},onLiteralValue:(O,L,T)=>{if(n<L||(I(O,L,T,r(O)),n<=L+T))throw s},onSeparator:(O,L,T)=>{if(n<=L)throw s;if(O===":"&&l&&l.type==="property")l.colonOffset=L,k=!1,l=void 0;else if(O===","){const A=a[a.length-1];typeof A=="number"?a[a.length-1]=A+1:(k=!0,a[a.length-1]=""),l=void 0}}})}catch(O){if(O!==s)throw O}return{path:a,previousNode:l,isAtPropertyKey:k,matches:O=>{let L=0;for(let T=0;L<O.length&&T<a.length;T++)if(O[L]===a[T]||O[L]==="*")L++;else if(O[L]!=="**")return!1;return L===O.length}}}function g(t,n=[],a=D.DEFAULT){let s=null,l=[];const f=[];function k(O){Array.isArray(l)?l.push(O):s!==null&&(l[s]=O)}return v(t,{onObjectBegin:()=>{const O={};k(O),f.push(l),l=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const O=[];k(O),f.push(l),l=O,s=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:k,onError:(O,L,T)=>{n.push({error:O,offset:L,length:T})}},a),l[0]}function b(t,n=[],a=D.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(O){s.type==="property"&&(s.length=O-s.offset,s=s.parent)}function f(O){return s.children.push(O),O}v(t,{onObjectBegin:O=>{s=f({type:"object",offset:O,length:-1,parent:s,children:[]})},onObjectProperty:(O,L,T)=>{s=f({type:"property",offset:L,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:O,offset:L,length:T,parent:s})},onObjectEnd:(O,L)=>{s.length=O+L-s.offset,s=s.parent,l(O+L)},onArrayBegin:(O,L)=>{s=f({type:"array",offset:O,length:-1,parent:s,children:[]})},onArrayEnd:(O,L)=>{s.length=O+L-s.offset,s=s.parent,l(O+L)},onLiteralValue:(O,L,T)=>{f({type:r(O),offset:L,length:T,parent:s,value:O}),l(L+T)},onSeparator:(O,L,T)=>{s.type==="property"&&(O===":"?s.colonOffset=L:O===","&&l(L))},onError:(O,L,T)=>{n.push({error:O,offset:L,length:T})}},a);const I=s.children[0];return I&&delete I.parent,I}function u(t,n){if(!t)return;let a=t;for(const s of n)if(typeof s=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const f of a.children)if(Array.isArray(f.children)&&f.children[0].value===s){a=f.children[1],l=!0;break}if(!l)return}else{const l=s;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}function m(t){if(!t.parent||!t.parent.children)return[];const n=m(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;n.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&n.push(a)}return n}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const n=Object.create(null);for(const a of t.children){const s=a.children[1];s&&(n[a.children[0].value]=p(s))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,n,a=!1){return n>=t.offset&&n<t.offset+t.length||a&&n===t.offset+t.length}function w(t,n,a=!1){if($(t,n,a)){const s=t.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=n;l++){const f=w(s[l],n,a);if(f)return f}return t}}function v(t,n,a=D.DEFAULT){const s=R(t,!1);function l(ae){return ae?()=>ae(s.getTokenOffset(),s.getTokenLength()):()=>!0}function f(ae){return ae?G=>ae(G,s.getTokenOffset(),s.getTokenLength()):()=>!0}const k=l(n.onObjectBegin),I=f(n.onObjectProperty),O=l(n.onObjectEnd),L=l(n.onArrayBegin),T=l(n.onArrayEnd),A=f(n.onLiteralValue),M=f(n.onSeparator),z=l(n.onComment),C=f(n.onError),B=a&&a.disallowComments,re=a&&a.allowTrailingComma;function _(){for(;;){const ae=s.scan();switch(s.getTokenError()){case i.InvalidUnicode:se(E.InvalidUnicode);break;case i.InvalidEscapeCharacter:se(E.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:se(E.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:B||se(E.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:se(E.UnexpectedEndOfString);break;case i.InvalidCharacter:se(E.InvalidCharacter);break}switch(ae){case o.LineCommentTrivia:case o.BlockCommentTrivia:B?se(E.InvalidCommentToken):z();break;case o.Unknown:se(E.InvalidSymbol);break;case o.Trivia:case o.LineBreakTrivia:break;default:return ae}}}function se(ae,G=[],he=[]){if(C(ae),G.length+he.length>0){let ne=s.getToken();for(;ne!==o.EOF;){if(G.indexOf(ne)!==-1){_();break}else if(he.indexOf(ne)!==-1)break;ne=_()}}}function K(ae){const G=s.getTokenValue();return ae?A(G):I(G),_(),!0}function ee(){switch(s.getToken()){case o.NumericLiteral:{let ae=0;try{ae=JSON.parse(s.getTokenValue()),typeof ae!="number"&&(se(E.InvalidNumberFormat),ae=0)}catch{se(E.InvalidNumberFormat)}A(ae);break}case o.NullKeyword:A(null);break;case o.TrueKeyword:A(!0);break;case o.FalseKeyword:A(!1);break;default:return!1}return _(),!0}function H(){return s.getToken()!==o.StringLiteral?(se(E.PropertyNameExpected,[],[o.CloseBraceToken,o.CommaToken]),!1):(K(!1),s.getToken()===o.ColonToken?(M(":"),_(),x()||se(E.ValueExpected,[],[o.CloseBraceToken,o.CommaToken])):se(E.ColonExpected,[],[o.CloseBraceToken,o.CommaToken]),!0)}function j(){k(),_();let ae=!1;for(;s.getToken()!==o.CloseBraceToken&&s.getToken()!==o.EOF;){if(s.getToken()===o.CommaToken){if(ae||se(E.ValueExpected,[],[]),M(","),_(),s.getToken()===o.CloseBraceToken&&re)break}else ae&&se(E.CommaExpected,[],[]);H()||se(E.ValueExpected,[],[o.CloseBraceToken,o.CommaToken]),ae=!0}return O(),s.getToken()!==o.CloseBraceToken?se(E.CloseBraceExpected,[o.CloseBraceToken],[]):_(),!0}function U(){L(),_();let ae=!1;for(;s.getToken()!==o.CloseBracketToken&&s.getToken()!==o.EOF;){if(s.getToken()===o.CommaToken){if(ae||se(E.ValueExpected,[],[]),M(","),_(),s.getToken()===o.CloseBracketToken&&re)break}else ae&&se(E.CommaExpected,[],[]);x()||se(E.ValueExpected,[],[o.CloseBracketToken,o.CommaToken]),ae=!0}return T(),s.getToken()!==o.CloseBracketToken?se(E.CloseBracketExpected,[o.CloseBracketToken],[]):_(),!0}function x(){switch(s.getToken()){case o.OpenBracketToken:return U();case o.OpenBraceToken:return j();case o.StringLiteral:return K(!0);default:return ee()}}return _(),s.getToken()===o.EOF?a.allowEmptyContent?!0:(se(E.ValueExpected,[],[]),!1):x()?(s.getToken()!==o.EOF&&se(E.EndOfFileExpected,[],[]),!0):(se(E.ValueExpected,[],[]),!1)}function S(t,n){const a=R(t),s=[];let l,f=0,k;do switch(k=a.getPosition(),l=a.scan(),l){case o.LineCommentTrivia:case o.BlockCommentTrivia:case o.EOF:f!==k&&s.push(t.substring(f,k)),n!==void 0&&s.push(a.getTokenValue().replace(/[^\r\n]/g,n)),f=a.getPosition();break}while(l!==o.EOF);return s.join("")}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[142],le([0,1,40]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=o,e.$6n=E,e.$7n=P,e.$8n=y;function o(c,h,d){let g,b,u,m,p;if(h){for(m=h.offset,p=m+h.length,u=m;u>0&&!y(c,u-1);)u--;let k=p;for(;k<c.length&&!y(c,k);)k++;b=c.substring(u,k),g=R(b,d)}else b=c,g=0,u=0,m=0,p=c.length;const $=P(d,c);let w=!1,v=0,S;d.insertSpaces?S=D(" ",d.tabSize||4):S="	";const r=(0,i.$Sn)(b,!1);let t=!1;function n(){return $+D(S,g+v)}function a(){let k=r.scan();for(w=!1;k===i.SyntaxKind.Trivia||k===i.SyntaxKind.LineBreakTrivia;)w=w||k===i.SyntaxKind.LineBreakTrivia,k=r.scan();return t=k===i.SyntaxKind.Unknown||r.getTokenError()!==i.ScanError.None,k}const s=[];function l(k,I,O){!t&&I<p&&O>m&&c.substring(I,O)!==k&&s.push({offset:I,length:O-I,content:k})}let f=a();if(f!==i.SyntaxKind.EOF){const k=r.getTokenOffset()+u,I=D(S,g);l(I,u,k)}for(;f!==i.SyntaxKind.EOF;){let k=r.getTokenOffset()+r.getTokenLength()+u,I=a(),O="";for(;!w&&(I===i.SyntaxKind.LineCommentTrivia||I===i.SyntaxKind.BlockCommentTrivia);){const T=r.getTokenOffset()+u;l(" ",k,T),k=r.getTokenOffset()+r.getTokenLength()+u,O=I===i.SyntaxKind.LineCommentTrivia?n():"",I=a()}if(I===i.SyntaxKind.CloseBraceToken)f!==i.SyntaxKind.OpenBraceToken&&(v--,O=n());else if(I===i.SyntaxKind.CloseBracketToken)f!==i.SyntaxKind.OpenBracketToken&&(v--,O=n());else{switch(f){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:v++,O=n();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:O=n();break;case i.SyntaxKind.BlockCommentTrivia:w?O=n():O=" ";break;case i.SyntaxKind.ColonToken:O=" ";break;case i.SyntaxKind.StringLiteral:if(I===i.SyntaxKind.ColonToken){O="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:I===i.SyntaxKind.LineCommentTrivia||I===i.SyntaxKind.BlockCommentTrivia?O=" ":I!==i.SyntaxKind.CommaToken&&I!==i.SyntaxKind.EOF&&(t=!0);break;case i.SyntaxKind.Unknown:t=!0;break}w&&(I===i.SyntaxKind.LineCommentTrivia||I===i.SyntaxKind.BlockCommentTrivia)&&(O=n())}const L=r.getTokenOffset()+u;l(O,k,L),f=I}return s}function E(c,h){const d=JSON.stringify(c,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?d.replace(/\r\n|\r|\n/g,h.eol):d}function D(c,h){let d="";for(let g=0;g<h;g++)d+=c;return d}function R(c,h){let d=0,g=0;const b=h.tabSize||4;for(;d<c.length;){const u=c.charAt(d);if(u===" ")g++;else if(u==="	")g+=b;else break;d++}return Math.floor(g/b)}function P(c,h){for(let d=0;d<h.length;d++){const g=h.charAt(d);if(g==="\r")return d+1<h.length&&h.charAt(d+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return c&&c.eol||`
`}function y(c,h){return`\r
`.indexOf(c.charAt(h))!==-1}}),define(ce[108],le([0,1,40,142]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=E,e.$0n=D,e.$$n=R,e.$_n=P,e.$ao=y;function E(c,h,d){return D(c,h,void 0,d)}function D(c,h,d,g,b){const u=h.slice(),m=[],p=(0,i.$Vn)(c,m);let $,w;for(;u.length>0&&(w=u.pop(),$=(0,i.$Wn)(p,u),$===void 0&&d!==void 0);)typeof w=="string"?d={[w]:d}:d=[d];if($)if($.type==="object"&&typeof w=="string"&&Array.isArray($.children)){const v=(0,i.$Wn)($,[w]);if(v!==void 0)if(d===void 0){if(!v.parent)throw new Error("Malformed AST");const S=$.children.indexOf(v.parent);let r,t=v.parent.offset+v.parent.length;if(S>0){const n=$.children[S-1];r=n.offset+n.length}else r=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return R(c,{offset:r,length:t-r,content:""},g)}else return R(c,{offset:v.offset,length:v.length,content:JSON.stringify(d)},g);else{if(d===void 0)return[];const S=`${JSON.stringify(w)}: ${JSON.stringify(d)}`,r=b?b($.children.map(n=>n.children[0].value)):$.children.length;let t;if(r>0){const n=$.children[r-1];t={offset:n.offset+n.length,length:0,content:","+S}}else $.children.length===0?t={offset:$.offset+1,length:0,content:S}:t={offset:$.offset+1,length:0,content:S+","};return R(c,t,g)}}else if($.type==="array"&&typeof w=="number"&&Array.isArray($.children))if(d!==void 0){const v=`${JSON.stringify(d)}`;let S;if($.children.length===0||w===0)S={offset:$.offset+1,length:0,content:$.children.length===0?v:v+","};else{const r=w===-1||w>$.children.length?$.children.length:w,t=$.children[r-1];S={offset:t.offset+t.length,length:0,content:","+v}}return R(c,S,g)}else{const v=w,S=$.children[v];let r;if($.children.length===1)r={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===v){const t=$.children[v-1],n=t.offset+t.length,a=$.offset+$.length;r={offset:n,length:a-2-n,content:""}}else r={offset:S.offset,length:$.children[v+1].offset-S.offset,content:""};return R(c,r,g)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${$.type}`);else return d===void 0?[]:R(c,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(d)},g)}function R(c,h,d){let g=P(c,h),b=h.offset,u=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;b>0&&!(0,o.$8n)(g,b-1);)b--;for(;u<g.length&&!(0,o.$8n)(g,u);)u++}const m=(0,o.$5n)(g,{offset:b,length:u-b},d);for(let $=m.length-1;$>=0;$--){const w=m[$];g=P(g,w),b=Math.min(b,w.offset),u=Math.max(u,w.offset+w.length),u+=w.content.length-w.length}const p=c.length-(g.length-u)-b;return[{offset:b,length:p,content:g.substring(b,u)}]}function P(c,h){return c.substring(0,h.offset)+h.content+c.substring(h.offset+h.length)}function y(c,h){const d=h.slice(0).sort((b,u)=>{const m=b.offset-u.offset;return m===0?b.length-u.length:m});let g=c.length;for(let b=d.length-1;b>=0;b--){const u=d[b];if(u.offset+u.length<=g)c=P(c,u);else throw new Error("Overlapping edit");g=u.offset}return c}}),define(ce[65],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class i{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=i}),define(ce[109],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(D){this.element=D,this.next=i.Undefined,this.prev=i.Undefined}}class o{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let D=this.a;for(;D!==i.Undefined;){const R=D.next;D.prev=i.Undefined,D.next=i.Undefined,D=R}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,R){const P=new i(D);if(this.a===i.Undefined)this.a=P,this.b=P;else if(R){const c=this.b;this.b=P,P.prev=c,c.next=P}else{const c=this.a;this.a=P,P.next=c,c.prev=P}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(P))}}shift(){if(this.a!==i.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==i.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==i.Undefined&&D.next!==i.Undefined){const R=D.prev;R.next=D.next,D.next.prev=R}else D.prev===i.Undefined&&D.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):D.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):D.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==i.Undefined;)yield D.element,D=D.next}}e.$6c=o}),define(ce[32],le([0,1]),function(V,e){"use strict";var i,o,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=D,e.$zc=R,e.$Ac=P,e.$Jc=S;function D(r,t,n){let a=r.get(t);return a===void 0&&(a=n,r.set(t,a)),a}function R(r){const t=[];return r.forEach((n,a)=>{t.push(`${a} => ${n}`)}),`Map(${r.size}) {${t.join(", ")}}`}function P(r){const t=[];return r.forEach(n=>{t.push(n)}),`Set(${r.size}) {${t.join(", ")}}`}class y{constructor(t,n){this.uri=t,this.value=n}}function c(r){return Array.isArray(r)}class h{static{this.c=t=>t.toString()}constructor(t,n){if(this[i]="ResourceMap",t instanceof h)this.d=new Map(t.d),this.e=n??h.c;else if(c(t)){this.d=new Map,this.e=n??h.c;for(const[a,s]of t)this.set(a,s)}else this.d=new Map,this.e=t??h.c}set(t,n){return this.d.set(this.e(t),new y(t,n)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,n){typeof n<"u"&&(t=t.bind(n));for(const[a,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=h;class d{constructor(t,n){this[o]="ResourceSet",!t||typeof t=="function"?this.c=new h(t):(this.c=new h(n),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,n){this.c.forEach((a,s)=>t.call(n,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=d;var g;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(g||(e.Touch=g={}));class b{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,n=g.None){const a=this.c.get(t);if(a)return n!==g.None&&this.m(a,n),a.value}set(t,n,a=g.None){let s=this.c.get(t);if(s)s.value=n,a!==g.None&&this.m(s,a);else{switch(s={key:t,value:n,next:void 0,previous:void 0},a){case g.None:this.k(s);break;case g.AsOld:this.j(s);break;case g.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const n=this.c.get(t);if(n)return this.c.delete(t),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,n){const a=this.g;let s=this.d;for(;s;){if(n?t.bind(n)(s.value,s.key,this):t(s.value,s.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,n=this.g;let a=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:a.key,done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return s}values(){const t=this,n=this.g;let a=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:a.value,done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return s}entries(){const t=this,n=this.g;let a=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const l={value:[a.key,a.value],done:!1};return a=a.next,l}else return{value:void 0,done:!0}}};return s}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let n=this.d,a=this.size;for(;n&&a>t;)this.c.delete(n.key),n=n.next,a--;this.d=n,this.f=a,n&&(n.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let n=this.e,a=this.size;for(;n&&a>t;)this.c.delete(n.key),n=n.previous,a--;this.e=n,this.f=a,n&&(n.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const n=t.next,a=t.previous;if(!n||!a)throw new Error("Invalid list");n.previous=a,a.next=n}t.next=void 0,t.previous=void 0,this.g++}m(t,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==g.AsOld&&n!==g.AsNew)){if(n===g.AsOld){if(t===this.d)return;const a=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(a.previous=s,s.next=a),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(n===g.AsNew){if(t===this.e)return;const a=t.next,s=t.previous;t===this.d?(a.previous=void 0,this.d=a):(a.previous=s,s.next=a),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((n,a)=>{t.push([a,n])}),t}fromJSON(t){this.clear();for(const[n,a]of t)this.set(n,a)}}e.$Dc=b;class u extends b{constructor(t,n=1){super(),this.n=t,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,n=g.AsNew){return super.get(t,n)}peek(t){return super.get(t,g.None)}set(t,n){return super.set(t,n,g.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends u{constructor(t,n=1){super(t,n)}q(t){this.h(t)}set(t,n){return super.set(t,n),this.p(),this}}e.$Ec=m;class p extends u{constructor(t,n=1){super(t,n)}q(t){this.i(t)}set(t,n){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,n),this}}e.$Fc=p;class ${constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let n=this.c.get(t)||0;return n===0?!1:(n--,n===0?this.c.delete(t):this.c.set(t,n),!0)}has(t){return this.c.has(t)}}e.$Gc=$;class w{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[n,a]of t)this.set(n,a)}clear(){this.c.clear(),this.d.clear()}set(t,n){this.c.set(t,n),this.d.set(n,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const n=this.c.get(t);return n===void 0?!1:(this.c.delete(t),this.d.delete(n),!0)}forEach(t,n){this.c.forEach((a,s)=>{t.call(n,a,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=w;class v{constructor(){this.c=new Map}add(t,n){let a=this.c.get(t);a||(a=new Set,this.c.set(t,a)),a.add(n)}delete(t,n){const a=this.c.get(t);a&&(a.delete(n),a.size===0&&this.c.delete(t))}forEach(t,n){const a=this.c.get(t);a&&a.forEach(n)}get(t){const n=this.c.get(t);return n||new Set}}e.$Ic=v;function S(r,t){if(r===t)return!0;if(r.size!==t.size)return!1;for(const[n,a]of r)if(!t.has(n)||t.get(n)!==a)return!1;for(const[n]of t)if(!r.has(n))return!1;return!0}}),define(ce[2],le([0,1,22,139,32,89,76]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=h,e.$Mc=d,e.$Nc=g,e.$Oc=m,e.$Pc=p,e.$Qc=$,e.$Rc=w,e.$Sc=v,e.$Tc=S,e.$4c=O;const P=!1;let y=null;class c{constructor(){this.b=new Map}static{this.a=0}c(A){let M=this.b.get(A);return M||(M={parent:null,source:null,isSingleton:!1,value:A,idx:c.a++},this.b.set(A,M)),M}trackDisposable(A){const M=this.c(A);M.source||(M.source=new Error().stack)}setParent(A,M){const z=this.c(A);z.parent=M}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,M){const z=M.get(A);if(z)return z;const C=A.parent?this.f(this.c(A.parent),M):A;return M.set(A,C),C}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,A).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(A=10,M){let z;if(M)z=M;else{const se=new Map,K=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,se).isSingleton);if(K.length===0)return;const ee=new Set(K.map(H=>H.value));if(z=K.filter(H=>!(H.parent&&ee.has(H.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function C(se){function K(H,j){for(;H.length>0&&j.some(U=>typeof U=="string"?U===H[0]:H[0].match(U));)H.shift()}const ee=se.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const B=new E.$Ic;for(const se of z){const K=C(se);for(let ee=0;ee<=K.length;ee++)B.add(K.slice(0,ee).join(`
`),se)}z.sort((0,i.$7b)(se=>se.idx,i.$9b));let re="",_=0;for(const se of z.slice(0,A)){_++;const K=C(se),ee=[];for(let H=0;H<K.length;H++){let j=K[H];j=`(shared with ${B.get(K.slice(0,H+1).join(`
`)).size}/${z.length} leaks) at ${j}`;const x=B.get(K.slice(0,H).join(`
`)),ae=(0,o.$K)([...x].map(G=>C(G)[H]),G=>G);delete ae[K[H]];for(const[G,he]of Object.entries(ae))ee.unshift(`    - stacktraces of ${he.length} other leaks continue with ${G}`);ee.unshift(j)}re+=`


==================== Leaking disposable ${_}/${z.length}: ${se.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return z.length>A&&(re+=`


... and ${z.length-A} more leaking disposables

`),{leaks:z,details:re}}}e.$Kc=c;function h(T){y=T}if(P){const T="__is_disposable_tracked__";h(new class{trackDisposable(A){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[T]||console.log(M)},3e3)}setParent(A,M){if(A&&A!==t.None)try{A[T]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[T]=!0}catch{}}markAsSingleton(A){}})}function d(T){return y?.trackDisposable(T),T}function g(T){y?.markAsDisposed(T)}function b(T,A){y?.setParent(T,A)}function u(T,A){if(y)for(const M of T)y.setParent(M,A)}function m(T){return y?.markAsSingleton(T),T}function p(T){return typeof T=="object"&&T!==null&&typeof T.dispose=="function"&&T.dispose.length===0}function $(T){if(R.Iterable.is(T)){const A=[];for(const M of T)if(M)try{M.dispose()}catch(z){A.push(z)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function w(T){for(const A of T)p(A)&&A.dispose();return[]}function v(...T){const A=S(()=>$(T));return u(T,A),A}function S(T){const A=d({dispose:(0,D.$eb)(()=>{g(A),T()})});return A}class r{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return b(A,this),this.g?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),b(A,null))}}e.$Uc=r;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new r,d(this),b(this.q,this)}dispose(){g(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Vc=t;class n{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&b(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&b(A,null),A}}e.$Wc=n;class a{constructor(A){this.a=new n,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=a;class s{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=s;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(A){let M=A;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,g(this))},this}}e.$Zc=l;class f{constructor(){this.a=new Map}acquire(A,...M){let z=this.a.get(A);z||(z={counter:0,object:this.b(A,...M)},this.a.set(A,z));const{object:C}=z,B=(0,D.$eb)(()=>{--z.counter===0&&(this.c(A,z.object),this.a.delete(A))});return z.counter++,{object:C,dispose:B}}}e.$1c=f;class k{constructor(A){this.a=A}async acquire(A,...M){const z=this.a.acquire(A,...M);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(C){throw z.dispose(),C}}}e.$2c=k;class I{constructor(A){this.object=A}dispose(){}}e.$3c=I;function O(T){const A=new r;try{T(A)}finally{A.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,M,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(A)?.dispose(),this.a.set(A,M)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}deleteAndLeak(A){const M=this.a.get(A);return this.a.delete(A),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=L}),define(ce[90],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(o){o[o.Uri=1]="Uri",o[o.Regexp=2]="Regexp",o[o.ScmResource=3]="ScmResource",o[o.ScmResourceGroup=4]="ScmResourceGroup",o[o.ScmProvider=5]="ScmProvider",o[o.CommentController=6]="CommentController",o[o.CommentThread=7]="CommentThread",o[o.CommentThreadInstance=8]="CommentThreadInstance",o[o.CommentThreadReply=9]="CommentThreadReply",o[o.CommentNode=10]="CommentNode",o[o.CommentThreadNode=11]="CommentThreadNode",o[o.TimelineActionContext=12]="TimelineActionContext",o[o.NotebookCellActionContext=13]="NotebookCellActionContext",o[o.NotebookActionContext=14]="NotebookActionContext",o[o.TerminalContext=15]="TerminalContext",o[o.TestItemContext=16]="TestItemContext",o[o.Date=17]="Date",o[o.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(ce[77],le([0,1,32]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=void 0,e.$lm=E,e.$mm=R;const o=new i.$Ec(1e4);function E(c){return y(c,"NFC",o)}const D=new i.$Ec(1e4);function R(c){return y(c,"NFD",D)}const P=/[^\u0000-\u0080]/;function y(c,h,d){if(!c)return c;const g=d.get(c);if(g)return g;let b;return P.test(c)?b=c.normalize(h):b=c,d.set(c,b),b}e.$nm=function(){const c=/[\u0300-\u036f]/g;return function(h){return R(h).replace(c,"")}}()}),define(ce[143],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0,e.$Jm=i,e.rot=o,e.$Om=P;function i(y,c,h){return Math.min(Math.max(y,c),h)}function o(y,c){return(c+y%c)%c}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Lm=E;class D{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Mm=D;class R{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const h=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nm=R;function P(y,c,h,d,g,b,u,m){const p=u-h,$=m-d,w=g-h,v=b-d,S=y-h,r=c-d,t=p*p+$*$,n=p*w+$*v,a=p*S+$*r,s=w*w+v*v,l=w*S+v*r,f=1/(t*s-n*n),k=(s*a-n*l)*f,I=(t*l-n*a)*f;return k>=0&&I>=0&&k+I<1}}),function(){function V(E){const D=[];typeof E=="number"&&D.push("code/timeOrigin",E);function R(y){D.push(y,Date.now())}function P(){const y=[];for(let c=0;c<D.length;c+=2)y.push({name:D[c],startTime:D[c+1]});return y}return{mark:R,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))D.push({name:R.name,startTime:Math.round(E+R.startTime)});return D}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function i(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var o;typeof global=="object"?o=global:typeof self=="object"?o=self:o={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(o)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(o):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),o.perf=i(o))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var o in i)(typeof exports=="object"?exports:V)[o]=i[o]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function i(o){if(e[o])return e[o].exports;var E=e[o]={i:o,l:!1,exports:{}};return V[o].call(E.exports,E,E.exports,i),E.l=!0,E.exports}return i.m=V,i.c=e,i.d=function(o,E,D){i.o(o,E)||Object.defineProperty(o,E,{enumerable:!0,get:D})},i.r=function(o){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(o,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(o,"__esModule",{value:!0})},i.t=function(o,E){if(1&E&&(o=i(o)),8&E||4&E&&typeof o=="object"&&o&&o.__esModule)return o;var D=Object.create(null);if(i.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:o}),2&E&&typeof o!="string")for(var R in o)i.d(D,R,function(P){return o[P]}.bind(null,R));return D},i.n=function(o){var E=o&&o.__esModule?function(){return o.default}:function(){return o};return i.d(E,"a",E),E},i.o=function(o,E){return Object.prototype.hasOwnProperty.call(o,E)},i.p="",i(i.s=0)}([function(V,e,i){(function(o){var E;e=V.exports=he,E=typeof o=="object"&&o.env&&o.env.NODE_DEBUG&&/\bsemver\b/i.test(o.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],c=0,h=c++;y[h]="0|[1-9]\\d*";var d=c++;y[d]="[0-9]+";var g=c++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=c++;y[b]="("+y[h]+")\\.("+y[h]+")\\.("+y[h]+")";var u=c++;y[u]="("+y[d]+")\\.("+y[d]+")\\.("+y[d]+")";var m=c++;y[m]="(?:"+y[h]+"|"+y[g]+")";var p=c++;y[p]="(?:"+y[d]+"|"+y[g]+")";var $=c++;y[$]="(?:-("+y[m]+"(?:\\."+y[m]+")*))";var w=c++;y[w]="(?:-?("+y[p]+"(?:\\."+y[p]+")*))";var v=c++;y[v]="[0-9A-Za-z-]+";var S=c++;y[S]="(?:\\+("+y[v]+"(?:\\."+y[v]+")*))";var r=c++,t="v?"+y[b]+y[$]+"?"+y[S]+"?";y[r]="^"+t+"$";var n="[v=\\s]*"+y[u]+y[w]+"?"+y[S]+"?",a=c++;y[a]="^"+n+"$";var s=c++;y[s]="((?:<|>)?=?)";var l=c++;y[l]=y[d]+"|x|X|\\*";var f=c++;y[f]=y[h]+"|x|X|\\*";var k=c++;y[k]="[v=\\s]*("+y[f]+")(?:\\.("+y[f]+")(?:\\.("+y[f]+")(?:"+y[$]+")?"+y[S]+"?)?)?";var I=c++;y[I]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[w]+")?"+y[S]+"?)?)?";var O=c++;y[O]="^"+y[s]+"\\s*"+y[k]+"$";var L=c++;y[L]="^"+y[s]+"\\s*"+y[I]+"$";var T=c++;y[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=c++;y[A]="(?:~>?)";var M=c++;y[M]="(\\s*)"+y[A]+"\\s+",P[M]=new RegExp(y[M],"g");var z=c++;y[z]="^"+y[A]+y[k]+"$";var C=c++;y[C]="^"+y[A]+y[I]+"$";var B=c++;y[B]="(?:\\^)";var re=c++;y[re]="(\\s*)"+y[B]+"\\s+",P[re]=new RegExp(y[re],"g");var _=c++;y[_]="^"+y[B]+y[k]+"$";var se=c++;y[se]="^"+y[B]+y[I]+"$";var K=c++;y[K]="^"+y[s]+"\\s*("+n+")$|^$";var ee=c++;y[ee]="^"+y[s]+"\\s*("+t+")$|^$";var H=c++;y[H]="(\\s*)"+y[s]+"\\s*("+n+"|"+y[k]+")",P[H]=new RegExp(y[H],"g");var j=c++;y[j]="^\\s*("+y[k]+")\\s+-\\s+("+y[k]+")\\s*$";var U=c++;y[U]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var x=c++;y[x]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)E(ae,y[ae]),P[ae]||(P[ae]=new RegExp(y[ae]));function G(J,ue){if(J instanceof he)return J;if(typeof J!="string"||J.length>D||!(ue?P[a]:P[r]).test(J))return null;try{return new he(J,ue)}catch{return null}}function he(J,ue){if(J instanceof he){if(J.loose===ue)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof he))return new he(J,ue);E("SemVer",J,ue),this.loose=ue;var fe=J.trim().match(ue?P[a]:P[r]);if(!fe)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Re=+be;if(Re>=0&&Re<R)return Re}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=G,e.valid=function(J,ue){var fe=G(J,ue);return fe?fe.version:null},e.clean=function(J,ue){var fe=G(J.trim().replace(/^[=v]+/,""),ue);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(J){return E("SemVer.compare",this.version,this.loose,J),J instanceof he||(J=new he(J,this.loose)),this.compareMain(J)||this.comparePre(J)},he.prototype.compareMain=function(J){return J instanceof he||(J=new he(J,this.loose)),Z(this.major,J.major)||Z(this.minor,J.minor)||Z(this.patch,J.patch)},he.prototype.comparePre=function(J){if(J instanceof he||(J=new he(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ue=0;do{var fe=this.prerelease[ue],be=J.prerelease[ue];if(E("prerelease compare",ue,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return Z(fe,be)}while(++ue)},he.prototype.inc=function(J,ue){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ue,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(J,fe).inc(ue,be).version}catch{return null}},e.diff=function(J,ue){if(q(J,ue))return null;var fe=G(J),be=G(ue);if(fe.prerelease.length||be.prerelease.length){for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return"pre"+Re;return"prerelease"}for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==be[Re])return Re},e.compareIdentifiers=Z;var ne=/^[0-9]+$/;function Z(J,ue){var fe=ne.test(J),be=ne.test(ue);return fe&&be&&(J=+J,ue=+ue),fe&&!be?-1:be&&!fe?1:J<ue?-1:J>ue?1:0}function F(J,ue,fe){return new he(J,fe).compare(new he(ue,fe))}function N(J,ue,fe){return F(J,ue,fe)>0}function W(J,ue,fe){return F(J,ue,fe)<0}function q(J,ue,fe){return F(J,ue,fe)===0}function Q(J,ue,fe){return F(J,ue,fe)!==0}function X(J,ue,fe){return F(J,ue,fe)>=0}function Y(J,ue,fe){return F(J,ue,fe)<=0}function ie(J,ue,fe,be){var Re;switch(ue){case"===":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),Re=J===fe;break;case"!==":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),Re=J!==fe;break;case"":case"=":case"==":Re=q(J,fe,be);break;case"!=":Re=Q(J,fe,be);break;case">":Re=N(J,fe,be);break;case">=":Re=X(J,fe,be);break;case"<":Re=W(J,fe,be);break;case"<=":Re=Y(J,fe,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Re}function de(J,ue){if(J instanceof de){if(J.loose===ue)return J;J=J.value}if(!(this instanceof de))return new de(J,ue);E("comparator",J,ue),this.loose=ue,this.parse(J),this.semver===me?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(J,ue){return Z(ue,J)},e.major=function(J,ue){return new he(J,ue).major},e.minor=function(J,ue){return new he(J,ue).minor},e.patch=function(J,ue){return new he(J,ue).patch},e.compare=F,e.compareLoose=function(J,ue){return F(J,ue,!0)},e.rcompare=function(J,ue,fe){return F(ue,J,fe)},e.sort=function(J,ue){return J.sort(function(fe,be){return e.compare(fe,be,ue)})},e.rsort=function(J,ue){return J.sort(function(fe,be){return e.rcompare(fe,be,ue)})},e.gt=N,e.lt=W,e.eq=q,e.neq=Q,e.gte=X,e.lte=Y,e.cmp=ie,e.Comparator=de;var me={};function pe(J,ue){if(J instanceof pe)return J.loose===ue?J:new pe(J.raw,ue);if(J instanceof de)return new pe(J.value,ue);if(!(this instanceof pe))return new pe(J,ue);if(this.loose=ue,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function ke(J,ue,fe,be,Re,We,Fe,Oe,Be,xe,Je,qe,Qe){return((ue=Ie(fe)?"":Ie(be)?">="+fe+".0.0":Ie(Re)?">="+fe+"."+be+".0":">="+ue)+" "+(Oe=Ie(Be)?"":Ie(xe)?"<"+(+Be+1)+".0.0":Ie(Je)?"<"+Be+"."+(+xe+1)+".0":qe?"<="+Be+"."+xe+"."+Je+"-"+qe:"<="+Oe)).trim()}function Pe(J,ue){for(var fe=0;fe<J.length;fe++)if(!J[fe].test(ue))return!1;if(ue.prerelease.length){for(fe=0;fe<J.length;fe++)if(E(J[fe].semver),J[fe].semver!==me&&J[fe].semver.prerelease.length>0){var be=J[fe].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function De(J,ue,fe){try{ue=new pe(ue,fe)}catch{return!1}return ue.test(J)}function $e(J,ue,fe,be){var Re,We,Fe,Oe,Be;switch(J=new he(J,be),ue=new pe(ue,be),fe){case">":Re=N,We=Y,Fe=W,Oe=">",Be=">=";break;case"<":Re=W,We=X,Fe=N,Oe="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(J,ue,be))return!1;for(var xe=0;xe<ue.set.length;++xe){var Je=ue.set[xe],qe=null,Qe=null;if(Je.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),qe=qe||Xe,Qe=Qe||Xe,Re(Xe.semver,qe.semver,be)?qe=Xe:Fe(Xe.semver,Qe.semver,be)&&(Qe=Xe)}),qe.operator===Oe||qe.operator===Be||(!Qe.operator||Qe.operator===Oe)&&We(J,Qe.semver)||Qe.operator===Be&&Fe(J,Qe.semver))return!1}return!0}de.prototype.parse=function(J){var ue=this.loose?P[K]:P[ee],fe=J.match(ue);if(!fe)throw new TypeError("Invalid comparator: "+J);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(J){return E("Comparator.test",J,this.loose),this.semver===me||(typeof J=="string"&&(J=new he(J,this.loose)),ie(J,this.operator,this.semver,this.loose))},de.prototype.intersects=function(J,ue){if(!(J instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new pe(J.value,ue),De(this.value,fe,ue);if(J.operator==="")return fe=new pe(this.value,ue),De(J.semver,fe,ue);var be=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),We=this.semver.version===J.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Oe=ie(this.semver,"<",J.semver,ue)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Be=ie(this.semver,">",J.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return be||Re||We&&Fe||Oe||Be},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(J){var ue=this.loose;J=J.trim(),E("range",J,ue);var fe=ue?P[U]:P[j];J=J.replace(fe,ke),E("hyphen replace",J),J=J.replace(P[H],"$1$2$3"),E("comparator trim",J,P[H]),J=(J=(J=J.replace(P[M],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var be=ue?P[K]:P[ee],Re=J.split(" ").map(function(We){return function(Fe,Oe){return E("comp",Fe),Fe=function(Be,xe){return Be.trim().split(/\s+/).map(function(Je){return function(qe,Qe){E("caret",qe,Qe);var Xe=Qe?P[se]:P[_];return qe.replace(Xe,function(Ke,Ce,te,ge,we){var ye;return E("caret",qe,Ke,Ce,te,ge,we),Ie(Ce)?ye="":Ie(te)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ie(ge)?ye=Ce==="0"?">="+Ce+"."+te+".0 <"+Ce+"."+(+te+1)+".0":">="+Ce+"."+te+".0 <"+(+Ce+1)+".0.0":we?(E("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),ye=Ce==="0"?te==="0"?">="+Ce+"."+te+"."+ge+we+" <"+Ce+"."+te+"."+(+ge+1):">="+Ce+"."+te+"."+ge+we+" <"+Ce+"."+(+te+1)+".0":">="+Ce+"."+te+"."+ge+we+" <"+(+Ce+1)+".0.0"):(E("no pr"),ye=Ce==="0"?te==="0"?">="+Ce+"."+te+"."+ge+" <"+Ce+"."+te+"."+(+ge+1):">="+Ce+"."+te+"."+ge+" <"+Ce+"."+(+te+1)+".0":">="+Ce+"."+te+"."+ge+" <"+(+Ce+1)+".0.0"),E("caret return",ye),ye})}(Je,xe)}).join(" ")}(Fe,Oe),E("caret",Fe),Fe=function(Be,xe){return Be.trim().split(/\s+/).map(function(Je){return function(qe,Qe){var Xe=Qe?P[C]:P[z];return qe.replace(Xe,function(Ke,Ce,te,ge,we){var ye;return E("tilde",qe,Ke,Ce,te,ge,we),Ie(Ce)?ye="":Ie(te)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ie(ge)?ye=">="+Ce+"."+te+".0 <"+Ce+"."+(+te+1)+".0":we?(E("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),ye=">="+Ce+"."+te+"."+ge+we+" <"+Ce+"."+(+te+1)+".0"):ye=">="+Ce+"."+te+"."+ge+" <"+Ce+"."+(+te+1)+".0",E("tilde return",ye),ye})}(Je,xe)}).join(" ")}(Fe,Oe),E("tildes",Fe),Fe=function(Be,xe){return E("replaceXRanges",Be,xe),Be.split(/\s+/).map(function(Je){return function(qe,Qe){qe=qe.trim();var Xe=Qe?P[L]:P[O];return qe.replace(Xe,function(Ke,Ce,te,ge,we,ye){E("xRange",qe,Ke,Ce,te,ge,we,ye);var Me=Ie(te),Ue=Me||Ie(ge),Ze=Ue||Ie(we);return Ce==="="&&Ze&&(Ce=""),Me?Ke=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ze?(Ue&&(ge=0),Ze&&(we=0),Ce===">"?(Ce=">=",Ue?(te=+te+1,ge=0,we=0):Ze&&(ge=+ge+1,we=0)):Ce==="<="&&(Ce="<",Ue?te=+te+1:ge=+ge+1),Ke=Ce+te+"."+ge+"."+we):Ue?Ke=">="+te+".0.0 <"+(+te+1)+".0.0":Ze&&(Ke=">="+te+"."+ge+".0 <"+te+"."+(+ge+1)+".0"),E("xRange return",Ke),Ke})}(Je,xe)}).join(" ")}(Fe,Oe),E("xrange",Fe),Fe=function(Be,xe){return E("replaceStars",Be,xe),Be.trim().replace(P[x],"")}(Fe,Oe),E("stars",Fe),Fe}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(We){return!!We.match(be)})),Re=Re.map(function(We){return new de(We,ue)})},pe.prototype.intersects=function(J,ue){if(!(J instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return J.set.some(function(Re){return Re.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(J,ue){return new pe(J,ue).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new he(J,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Pe(this.set[ue],J))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(J,ue,fe){var be=null,Re=null;try{var We=new pe(ue,fe)}catch{return null}return J.forEach(function(Fe){We.test(Fe)&&(be&&Re.compare(Fe)!==-1||(Re=new he(be=Fe,fe)))}),be},e.minSatisfying=function(J,ue,fe){var be=null,Re=null;try{var We=new pe(ue,fe)}catch{return null}return J.forEach(function(Fe){We.test(Fe)&&(be&&Re.compare(Fe)!==1||(Re=new he(be=Fe,fe)))}),be},e.validRange=function(J,ue){try{return new pe(J,ue).range||"*"}catch{return null}},e.ltr=function(J,ue,fe){return $e(J,ue,"<",fe)},e.gtr=function(J,ue,fe){return $e(J,ue,">",fe)},e.outside=$e,e.prerelease=function(J,ue){var fe=G(J,ue);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(J,ue,fe){return J=new pe(J,fe),ue=new pe(ue,fe),J.intersects(ue)},e.coerce=function(J){if(J instanceof he)return J;if(typeof J!="string")return null;var ue=J.match(P[T]);return ue==null?null:G((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,i(1))},function(V,e){var i,o,E=V.exports={};function D(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function P(p){if(i===setTimeout)return setTimeout(p,0);if((i===D||!i)&&setTimeout)return i=setTimeout,setTimeout(p,0);try{return i(p,0)}catch{try{return i.call(null,p,0)}catch{return i.call(this,p,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:D}catch{i=D}try{o=typeof clearTimeout=="function"?clearTimeout:R}catch{o=R}})();var y,c=[],h=!1,d=-1;function g(){h&&y&&(h=!1,y.length?c=y.concat(c):d=-1,c.length&&b())}function b(){if(!h){var p=P(g);h=!0;for(var $=c.length;$;){for(y=c,c=[];++d<$;)y&&y[d].run();d=-1,$=c.length}y=null,h=!1,function(w){if(o===clearTimeout)return clearTimeout(w);if((o===R||!o)&&clearTimeout)return o=clearTimeout,clearTimeout(w);try{o(w)}catch{try{return o.call(null,w)}catch{return o.call(this,w)}}}(p)}}function u(p,$){this.fun=p,this.array=$}function m(){}E.nextTick=function(p){var $=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)$[w-1]=arguments[w];c.push(new u(p,$)),c.length!==1||h||P(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=m,E.addListener=m,E.once=m,E.off=m,E.removeListener=m,E.removeAllListeners=m,E.emit=m,E.prependListener=m,E.prependOnceListener=m,E.listeners=function(p){return[]},E.binding=function(p){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(p){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(ce[144],le([0,1]),function(V,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0;class o{constructor(P,y,c){this.level=P,this.key=y,this.value=c,this.forward=[]}}const E=void 0;class D{constructor(P,y=2**16){this.comparator=P,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new o(this.c,E,E)}get size(){return this.f}clear(){this.e=new o(this.c,E,E),this.f=0}has(P){return!!D.g(this,P,this.comparator)}get(P){return D.g(this,P,this.comparator)?.value}set(P,y){return D.h(this,P,y,this.comparator)&&(this.f+=1),this}delete(P){const y=D.k(this,P,this.comparator);return y&&(this.f-=1),y}forEach(P,y){let c=this.e.forward[0];for(;c;)P.call(y,c.value,c.key,this),c=c.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",y=this.e.forward[0];for(;y;)P+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return P}static g(P,y,c){let h=P.e;for(let d=P.d-1;d>=0;d--)for(;h.forward[d]&&c(h.forward[d].key,y)<0;)h=h.forward[d];if(h=h.forward[0],h&&c(h.key,y)===0)return h}static h(P,y,c,h){const d=[];let g=P.e;for(let b=P.d-1;b>=0;b--){for(;g.forward[b]&&h(g.forward[b].key,y)<0;)g=g.forward[b];d[b]=g}if(g=g.forward[0],g&&h(g.key,y)===0)return g.value=c,!1;{const b=D.j(P);if(b>P.d){for(let u=P.d;u<b;u++)d[u]=P.e;P.d=b}g=new o(b,y,c);for(let u=0;u<b;u++)g.forward[u]=d[u].forward[u],d[u].forward[u]=g;return!0}}static j(P,y=.5){let c=1;for(;Math.random()<y&&c<P.c;)c+=1;return c}static k(P,y,c){const h=[];let d=P.e;for(let g=P.d-1;g>=0;g--){for(;d.forward[g]&&c(d.forward[g].key,y)<0;)d=d.forward[g];h[g]=d}if(d=d.forward[0],!d||c(d.key,y)!==0)return!1;for(let g=0;g<P.d&&h[g].forward[g]===d;g++)h[g].forward[g]=d.forward[g];for(;P.d>0&&P.e.forward[P.d-1]===E;)P.d-=1;return!0}}e.$Ms=D}),define(ce[66],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class o{static create(D){return new o(D)}constructor(D){this.c=i&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=o}),define(ce[3],le([0,1,16,89,2,109,66]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=b;const P=!1,y=!1,c=!1;var h;(function(C){C.None=()=>E.$Vc.None;function B(ke){if(c){const{onDidAddListener:Pe}=ke,De=m.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),Pe?.()}}}function re(ke,Pe){return G(ke,()=>{},0,void 0,!0,void 0,Pe)}C.defer=re;function _(ke){return(Pe,De=null,$e)=>{let J=!1,ue;return ue=ke(fe=>{if(!J)return ue?ue.dispose():J=!0,Pe.call(De,fe)},null,$e),J&&ue.dispose(),ue}}C.once=_;function se(ke,Pe,De){return x(($e,J=null,ue)=>ke(fe=>$e.call(J,Pe(fe)),null,ue),De)}C.map=se;function K(ke,Pe,De){return x(($e,J=null,ue)=>ke(fe=>{Pe(fe),$e.call(J,fe)},null,ue),De)}C.forEach=K;function ee(ke,Pe,De){return x(($e,J=null,ue)=>ke(fe=>Pe(fe)&&$e.call(J,fe),null,ue),De)}C.filter=ee;function H(ke){return ke}C.signal=H;function j(...ke){return(Pe,De=null,$e)=>{const J=(0,E.$Sc)(...ke.map(ue=>ue(fe=>Pe.call(De,fe))));return ae(J,$e)}}C.any=j;function U(ke,Pe,De,$e){let J=De;return se(ke,ue=>(J=Pe(J,ue),J),$e)}C.reduce=U;function x(ke,Pe){let De;const $e={onWillAddFirstListener(){De=ke(J.fire,J)},onDidRemoveLastListener(){De?.dispose()}};Pe||B($e);const J=new n($e);return Pe?.add(J),J.event}function ae(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function G(ke,Pe,De=100,$e=!1,J=!1,ue,fe){let be,Re,We,Fe=0,Oe;const Be={leakWarningThreshold:ue,onWillAddFirstListener(){be=ke(Je=>{Fe++,Re=Pe(Re,Je),$e&&!We&&(xe.fire(Re),Re=void 0),Oe=()=>{const qe=Re;Re=void 0,We=void 0,(!$e||Fe>1)&&xe.fire(qe),Fe=0},typeof De=="number"?(clearTimeout(We),We=setTimeout(Oe,De)):We===void 0&&(We=0,queueMicrotask(Oe))})},onWillRemoveListener(){J&&Fe>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};fe||B(Be);const xe=new n(Be);return fe?.add(xe),xe.event}C.debounce=G;function he(ke,Pe=0,De){return C.debounce(ke,($e,J)=>$e?($e.push(J),$e):[J],Pe,void 0,!0,void 0,De)}C.accumulate=he;function ne(ke,Pe=($e,J)=>$e===J,De){let $e=!0,J;return ee(ke,ue=>{const fe=$e||!Pe(ue,J);return $e=!1,J=ue,fe},De)}C.latch=ne;function Z(ke,Pe,De){return[C.filter(ke,Pe,De),C.filter(ke,$e=>!Pe($e),De)]}C.split=Z;function F(ke,Pe=!1,De=[],$e){let J=De.slice(),ue=ke(Re=>{J?J.push(Re):be.fire(Re)});$e&&$e.add(ue);const fe=()=>{J?.forEach(Re=>be.fire(Re)),J=null},be=new n({onWillAddFirstListener(){ue||(ue=ke(Re=>be.fire(Re)),$e&&$e.add(ue))},onDidAddFirstListener(){J&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return $e&&$e.add(be),be.event}C.buffer=F;function N(ke,Pe){return($e,J,ue)=>{const fe=Pe(new q);return ke(function(be){const Re=fe.evaluate(be);Re!==W&&$e.call(J,Re)},void 0,ue)}}C.chain=N;const W=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(De=>(Pe(De),De)),this}filter(Pe){return this.f.push(De=>Pe(De)?De:W),this}reduce(Pe,De){let $e=De;return this.f.push(J=>($e=Pe($e,J),$e)),this}latch(Pe=(De,$e)=>De===$e){let De=!0,$e;return this.f.push(J=>{const ue=De||!Pe(J,$e);return De=!1,$e=J,ue?J:W}),this}evaluate(Pe){for(const De of this.f)if(Pe=De(Pe),Pe===W)break;return Pe}}function Q(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),J=()=>ke.on(Pe,$e),ue=()=>ke.removeListener(Pe,$e),fe=new n({onWillAddFirstListener:J,onDidRemoveLastListener:ue});return fe.event}C.fromNodeEventEmitter=Q;function X(ke,Pe,De=$e=>$e){const $e=(...be)=>fe.fire(De(...be)),J=()=>ke.addEventListener(Pe,$e),ue=()=>ke.removeEventListener(Pe,$e),fe=new n({onWillAddFirstListener:J,onDidRemoveLastListener:ue});return fe.event}C.fromDOMEventEmitter=X;function Y(ke){return new Promise(Pe=>_(ke)(Pe))}C.toPromise=Y;function ie(ke){const Pe=new n;return ke.then(De=>{Pe.fire(De)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}C.fromPromise=ie;function de(ke,Pe,De){return Pe(De),ke($e=>Pe($e))}C.runAndSubscribe=de;class me{constructor(Pe,De){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};De||B($e),this.emitter=new n($e),De&&De.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,De){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(ke,Pe){return new me(ke,Pe).emitter.event}C.fromObservable=pe;function Ie(ke){return(Pe,De,$e)=>{let J=0,ue=!1;const fe={beginUpdate(){J++},endUpdate(){J--,J===0&&(ke.reportChanges(),ue&&(ue=!1,Pe.call(De)))},handlePossibleChange(){},handleChange(){ue=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof E.$Uc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}C.fromObservableLight=Ie})(h||(e.Event=h={}));class d{static{this.all=new Set}static{this.f=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${d.f++}`,d.all.add(this)}start(B){this.g=new R.$fe,this.listenerCount=B}stop(){if(this.g){const B=this.g.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this.g=void 0}}}e.$he=d;let g=-1;function b(C){const B=g;return g=C,{dispose(){g=B}}}class u{constructor(B,re,_=Math.random().toString(18).slice(2,5)){this.h=B,this.threshold=re,this.name=_,this.g=0}dispose(){this.f?.clear()}check(B,re){const _=this.threshold;if(_<=0||re<_)return;this.f||(this.f=new Map);const se=this.f.get(B.value)||0;if(this.f.set(B.value,se+1),this.g-=1,this.g<=0){this.g=_*.5;const[K,ee]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${re} listeners already. MOST frequent listener (${ee}):`;console.warn(H),console.warn(K);const j=new p(H,K);this.h(j)}return()=>{const K=this.f.get(B.value)||0;this.f.set(B.value,K-1)}}getMostFrequentStack(){if(!this.f)return;let B,re=0;for(const[_,se]of this.f)(!B||re<se)&&(B=[_,se],re=se);return B}}class m{static create(){const B=new Error;return new m(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p extends Error{constructor(B,re){super(B),this.name="ListenerLeakError",this.stack=re}}e.$je=p;class $ extends Error{constructor(B,re){super(B),this.name="ListenerRefusalError",this.stack=re}}e.$ke=$;let w=0;class v{constructor(B){this.value=B,this.id=w++}}const S=2,r=(C,B)=>{if(C instanceof v)B(C);else for(let re=0;re<C.length;re++){const _=C[re];_&&B(_)}};let t;if(P){const C=[];setInterval(()=>{C.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(C.join(`
`)),C.length=0)},3e3),t=new FinalizationRegistry(B=>{typeof B=="string"&&C.push(B)})}class n{constructor(B){this.z=0,this.f=B,this.g=g>0||this.f?.leakWarningThreshold?new u(B?.onListenerError??i.$2,this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(y){const B=this.u;queueMicrotask(()=>{r(B,re=>re.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(B,re,_)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const U=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],x=new $(`${j}. HINT: Stack shows most frequent listener (${U[1]}-times)`,U[0]);return(this.f?.onListenerError||i.$2)(x),E.$Vc.None}if(this.m)return E.$Vc.None;re&&(B=B.bind(re));const se=new v(B);let K,ee;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(se.stack=m.create(),K=this.g.check(se.stack,this.z+1)),y&&(se.stack=ee??m.create()),this.u?this.u instanceof v?(this.w??=new s,this.u=[this.u,se]):this.u.push(se):(this.f?.onWillAddFirstListener?.(this),this.u=se,this.f?.onDidAddFirstListener?.(this)),this.z++;const H=(0,E.$Tc)(()=>{t?.unregister(H),K?.(),this.A(se)});if(_ instanceof E.$Uc?_.add(H):Array.isArray(_)&&_.push(H),t){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),U=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);t.register(H,U?.[2]??j,H)}return H},this.q}A(B){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const re=this.u,_=re.indexOf(B);if(_===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,re[_]=void 0;const se=this.w.current===this;if(this.z*S<=re.length){let K=0;for(let ee=0;ee<re.length;ee++)re[ee]?re[K++]=re[ee]:se&&(this.w.end--,K<this.w.i&&this.w.i--);re.length=K}}B(B,re){if(!B)return;const _=this.f?.onListenerError||i.$2;if(!_){B.value(re);return}try{B.value(re)}catch(se){_(se)}}C(B){const re=B.current.u;for(;B.i<B.end;)this.B(re[B.i++],B.value);B.reset()}fire(B){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof v)this.B(this.u,B);else{const re=this.w;re.enqueue(this,B,this.u.length),this.C(re)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const a=()=>new s;e.$me=a;class s{constructor(){this.i=-1,this.end=0}enqueue(B,re,_){this.i=0,this.end=_,this.current=B,this.value=re}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class l extends n{async fireAsync(B,re,_){if(this.u)for(this.h||(this.h=new D.$6c),r(this.u,se=>this.h.push([se.value,B]));this.h.size>0&&!re.isCancellationRequested;){const[se,K]=this.h.shift(),ee=[],H={...K,token:re,waitUntil:j=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");_&&(j=_(j,se)),ee.push(j)}};try{se(H)}catch(j){(0,i.$2)(j);continue}Object.freeze(ee),await Promise.allSettled(ee).then(j=>{for(const U of j)U.status==="rejected"&&(0,i.$2)(U.reason)})}}}e.$ne=l;class f extends n{get isPaused(){return this.h!==0}constructor(B){super(B),this.h=0,this.s=new D.$6c,this.t=B?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const B=Array.from(this.s);this.s.clear(),super.fire(this.t(B))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(B){this.z&&(this.h!==0?this.s.push(B):super.fire(B))}}e.$oe=f;class k extends f{constructor(B){super(B),this.k=B.delay??100}fire(B){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(B)}}e.$pe=k;class I extends n{constructor(B){super(B),this.h=[],this.k=B?.merge}fire(B){this.hasListeners()&&(this.h.push(B),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(re=>super.fire(re)),this.h=[]}))}}e.$qe=I;class O{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(B){const re={event:B,listener:null};this.h.push(re),this.g&&this.m(re);const _=()=>{this.g&&this.o(re);const se=this.h.indexOf(re);this.h.splice(se,1)};return(0,E.$Tc)((0,o.$eb)(_))}j(){this.g=!0,this.h.forEach(B=>this.m(B))}k(){this.g=!1,this.h.forEach(B=>this.o(B))}m(B){B.listener=B.event(re=>this.f.fire(re))}o(B){B.listener?.dispose(),B.listener=null}dispose(){this.f.dispose();for(const B of this.h)B.listener?.dispose();this.h=[]}}e.$re=O;class L{constructor(B,re,_,se){this.f=new E.$Uc;const K=this.f.add(new O),ee=this.f.add(new E.$5c);function H(j){ee.set(j,K.add(se(j)))}for(const j of B)H(j);this.f.add(re(j=>{H(j)})),this.f.add(_(j=>{ee.deleteAndDispose(j)})),this.event=K.event}dispose(){this.f.dispose()}}e.$se=L;class T{constructor(){this.f=[]}wrapEvent(B,re,_){return(se,K,ee)=>B(H=>{const j=this.f[this.f.length-1];if(!re){j?j.buffers.push(()=>se.call(K,H)):se.call(K,H);return}const U=j;if(!U){se.call(K,re(_,H));return}U.items??=[],U.items.push(H),U.buffers.length===0&&j.buffers.push(()=>{U.reducedResult??=_?U.items.reduce(re,_):U.items.reduce(re),se.call(K,U.reducedResult)})},void 0,ee)}bufferEvents(B){const re={buffers:new Array};this.f.push(re);const _=B();return this.f.pop(),re.buffers.forEach(se=>se()),_}}e.$te=T;class A{constructor(){this.f=!1,this.g=h.None,this.h=E.$Vc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(B){this.g=B,this.f&&(this.h.dispose(),this.h=B(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=A;class M{static const(B){return new z(B)}constructor(B){this.g=B,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(B){B!==this.g&&(this.g=B,this.f.fire(void 0))}}e.$ve=M;class z{constructor(B){this.value=B,this.onDidChange=h.None}}}),define(ce[23],le([0,1,3]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=P;const o=Object.freeze(function(y,c){const h=setTimeout(y.bind(c),0);return{dispose(){clearTimeout(h)}}});var E;(function(y){function c(h){return h===y.None||h===y.Cancelled||h instanceof D?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}y.isCancellationToken=c,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:o})})(E||(e.CancellationToken=E={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?o:(this.b||(this.b=new i.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=E.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=E.None}}e.$we=R;function P(y){const c=new R;return y.add({dispose(){c.cancel()}}),c.token}}),define(ce[145],le([0,1,23]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=E;class o{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$we,c=this.b(y.token);return this.a={promise:c,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$9e=o;function E(P){return P}class D{constructor(y,c){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=E):(this.c=c,this.d=y.getCacheKey)}get(y){const c=this.d(y);return this.b!==c&&(this.b=c,this.a=this.c(y)),this.a}}e.$$e=D;class R{get cachedValues(){return this.a}constructor(y,c){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=E):(this.c=c,this.d=y.getCacheKey)}get(y){const c=this.d(y);if(this.b.has(c))return this.b.get(c);const h=this.c(y);return this.a.set(y,h),this.b.set(c,h),h}}e.$_e=R}),define(ce[67],le([0,1,16,2]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=E,e.$ze=D,e.$Ae=R,e.$Be=P,e.$Ce=c,e.$De=h,e.$Ee=d,e.$Fe=g,e.$Ge=b,e.$He=u,e.$Ie=m,e.$Je=p,e.$Ke=$,e.$Le=w,e.$Me=v;function E(S){const r=S;return r?typeof r.read=="function":!1}function D(S){const r=S;return r?[r.on,r.pause,r.resume,r.destroy].every(t=>typeof t=="function"):!1}function R(S){const r=S;return r?D(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}function P(S,r){return new y(S,r)}class y{constructor(r,t){this.e=r,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(r){if(!this.a.destroyed){if(this.a.flowing)this.g(r);else if(this.b.data.push(r),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(r){this.a.destroyed||(this.a.flowing?this.h(r):this.b.error.push(r))}end(r){this.a.destroyed||(typeof r<"u"&&this.write(r),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(r){this.c.data.slice(0).forEach(t=>t(r))}h(r){this.c.error.length===0?(0,i.$2)(r):this.c.error.slice(0).forEach(t=>t(r))}i(){this.c.end.slice(0).forEach(r=>r())}on(r,t){if(!this.a.destroyed)switch(r){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(r,t){if(this.a.destroyed)return;let n;switch(r){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const a=n.indexOf(t);a>=0&&n.splice(a,1)}}j(){if(this.b.data.length>0){const r=this.e(this.b.data);this.g(r),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const r of this.b.error)this.h(r);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(S,r){const t=[];let n;for(;(n=S.read())!==null;)t.push(n);return r(t)}function h(S,r,t){const n=[];let a;for(;(a=S.read())!==null&&n.length<t;)n.push(a);return a===null&&n.length>0?r(n):{read:()=>{if(n.length>0)return n.shift();if(typeof a<"u"){const s=a;return a=void 0,s}return S.read()}}}function d(S,r){return new Promise((t,n)=>{const a=[];g(S,{onData:s=>{r&&a.push(s)},onError:s=>{r?n(s):t(void 0)},onEnd:()=>{t(r?r(a):void 0)}})})}function g(S,r,t){S.on("error",n=>{t?.isCancellationRequested||r.onError(n)}),S.on("end",()=>{t?.isCancellationRequested||r.onEnd()}),S.on("data",n=>{t?.isCancellationRequested||r.onData(n)})}function b(S,r){return new Promise((t,n)=>{const a=new o.$Uc,s=[],l=I=>{if(s.push(I),s.length>r)return a.dispose(),S.pause(),t({stream:S,buffer:s,ended:!1})},f=I=>(a.dispose(),n(I)),k=()=>(a.dispose(),t({stream:S,buffer:s,ended:!0}));a.add((0,o.$Tc)(()=>S.removeListener("error",f))),S.on("error",f),a.add((0,o.$Tc)(()=>S.removeListener("end",k))),S.on("end",k),a.add((0,o.$Tc)(()=>S.removeListener("data",l))),S.on("data",l)})}function u(S,r){const t=P(r);return t.end(S),t}function m(){const S=P(()=>{throw new Error("not supported")});return S.end(),S}function p(S){let r=!1;return{read:()=>r?null:(r=!0,S)}}function $(S,r,t){const n=P(t);return g(S,{onData:a=>n.write(r.data(a)),onError:a=>n.error(r.error?r.error(a):a),onEnd:()=>n.end()}),n}function w(S,r,t){let n=!1;return{read:()=>{const a=r.read();return n?a:(n=!0,a!==null?t([S,a]):S)}}}function v(S,r,t){let n=!1;const a=P(t);return g(r,{onData:s=>n?a.write(s):(n=!0,a.write(t([S,s]))),onError:s=>a.error(s),onEnd:()=>{n||(n=!0,a.write(S)),a.end()}}),a}});var Dt=this&&this.__createBinding||(Object.create?function(V,e,i,o){o===void 0&&(o=i);var E=Object.getOwnPropertyDescriptor(e,i);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(V,o,E)}:function(V,e,i,o){o===void 0&&(o=i),V[o]=e[i]}),At=this&&this.__setModuleDefault||(Object.create?function(V,e){Object.defineProperty(V,"default",{enumerable:!0,value:e})}:function(V,e){V.default=e}),Ae=this&&this.__importStar||function(V){if(V&&V.__esModule)return V;var e={};if(V!=null)for(var i in V)i!=="default"&&Object.prototype.hasOwnProperty.call(V,i)&&Dt(e,V,i);return At(e,V),e};define(ce[17],le([0,1,65,67]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=c,e.$Pe=h,e.$Qe=d,e.$Re=g,e.$Se=b,e.$Te=u,e.$Ue=m,e.$Ve=p,e.$We=$,e.$Xe=w,e.$Ye=v,e.$Ze=S,e.$1e=r,e.$2e=t,e.$3e=n,e.$4e=a,e.$5e=s,e.$6e=l,e.$7e=f,e.$8e=O,o=Ae(o);const E=typeof Buffer<"u",D=new i.$W(()=>new Uint8Array(256));let R,P;class y{static alloc(T){return E?new y(Buffer.allocUnsafe(T)):new y(new Uint8Array(T))}static wrap(T){return E&&!Buffer.isBuffer(T)&&(T=Buffer.from(T.buffer,T.byteOffset,T.byteLength)),new y(T)}static fromString(T,A){return!(A?.dontUseNodeBuffer||!1)&&E?new y(Buffer.from(T)):(R||(R=new TextEncoder),new y(R.encode(T)))}static fromByteArray(T){const A=y.alloc(T.length);for(let M=0,z=T.length;M<z;M++)A.buffer[M]=T[M];return A}static concat(T,A){if(typeof A>"u"){A=0;for(let C=0,B=T.length;C<B;C++)A+=T[C].byteLength}const M=y.alloc(A);let z=0;for(let C=0,B=T.length;C<B;C++){const re=T[C];M.set(re,z),z+=re.byteLength}return M}constructor(T){this.buffer=T,this.byteLength=this.buffer.byteLength}clone(){const T=y.alloc(this.byteLength);return T.set(this),T}toString(){return E?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(T,A){return new y(this.buffer.subarray(T,A))}set(T,A){if(T instanceof y)this.buffer.set(T.buffer,A);else if(T instanceof Uint8Array)this.buffer.set(T,A);else if(T instanceof ArrayBuffer)this.buffer.set(new Uint8Array(T),A);else if(ArrayBuffer.isView(T))this.buffer.set(new Uint8Array(T.buffer,T.byteOffset,T.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(T){return g(this.buffer,T)}writeUInt32BE(T,A){b(this.buffer,T,A)}readUInt32LE(T){return u(this.buffer,T)}writeUInt32LE(T,A){m(this.buffer,T,A)}readUInt8(T){return p(this.buffer,T)}writeUInt8(T,A){$(this.buffer,T,A)}indexOf(T,A=0){return c(this.buffer,T instanceof y?T.buffer:T,A)}}e.$Ne=y;function c(L,T,A=0){const M=T.byteLength,z=L.byteLength;if(M===0)return 0;if(M===1)return L.indexOf(T[0]);if(M>z-A)return-1;const C=D.value;C.fill(T.length);for(let se=0;se<T.length;se++)C[T[se]]=T.length-se-1;let B=A+T.length-1,re=B,_=-1;for(;B<z;)if(L[B]===T[re]){if(re===0){_=B;break}B--,re--}else B+=Math.max(T.length-re,C[L[B]]),re=T.length-1;return _}function h(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0}function d(L,T,A){L[A+0]=T&255,T=T>>>8,L[A+1]=T&255}function g(L,T){return L[T]*2**24+L[T+1]*2**16+L[T+2]*2**8+L[T+3]}function b(L,T,A){L[A+3]=T,T=T>>>8,L[A+2]=T,T=T>>>8,L[A+1]=T,T=T>>>8,L[A]=T}function u(L,T){return L[T+0]<<0>>>0|L[T+1]<<8>>>0|L[T+2]<<16>>>0|L[T+3]<<24>>>0}function m(L,T,A){L[A+0]=T&255,T=T>>>8,L[A+1]=T&255,T=T>>>8,L[A+2]=T&255,T=T>>>8,L[A+3]=T&255}function p(L,T){return L[T]}function $(L,T,A){L[A]=T}function w(L){return o.$Ce(L,T=>y.concat(T))}function v(L){return o.$Je(L)}function S(L){return o.$Ee(L,T=>y.concat(T))}async function r(L){return L.ended?y.concat(L.buffer):y.concat([...L.buffer,await S(L.stream)])}function t(L){return o.$He(L,T=>y.concat(T))}function n(L){return o.$Ke(L,{data:T=>typeof T=="string"?y.fromString(T):y.wrap(T)},T=>y.concat(T))}function a(L){return o.$Be(T=>y.concat(T),L)}function s(L,T){return o.$Le(L,T,A=>y.concat(A))}function l(L,T){return o.$Me(L,T,A=>y.concat(A))}function f(L){let T=0,A=0,M=0;const z=new Uint8Array(Math.floor(L.length/4*3)),C=re=>{switch(A){case 3:z[M++]=T|re,A=0;break;case 2:z[M++]=T|re>>>2,T=re<<6,A=3;break;case 1:z[M++]=T|re>>>4,T=re<<4,A=2;break;default:T=re<<2,A=1}};for(let re=0;re<L.length;re++){const _=L.charCodeAt(re);if(_>=65&&_<=90)C(_-65);else if(_>=97&&_<=122)C(_-97+26);else if(_>=48&&_<=57)C(_-48+52);else if(_===43||_===45)C(62);else if(_===47||_===95)C(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${L[re]}`)}}const B=M;for(;A>0;)C(0);return y.wrap(z).slice(0,B)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:L},T=!0,A=!1){const M=A?I:k;let z="";const C=L.byteLength%3;let B=0;for(;B<L.byteLength-C;B+=3){const re=L[B+0],_=L[B+1],se=L[B+2];z+=M[re>>>2],z+=M[(re<<4|_>>>4)&63],z+=M[(_<<2|se>>>6)&63],z+=M[se&63]}if(C===1){const re=L[B+0];z+=M[re>>>2],z+=M[re<<4&63],T&&(z+="==")}else if(C===2){const re=L[B+0],_=L[B+1];z+=M[re>>>2],z+=M[(re<<4|_>>>4)&63],z+=M[_<<2&63],T&&(z+="=")}return z}}),define(ce[146],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(ce[12],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=i,e.$fg=o,e.$gg=E,e.$hg=D,e.$ig=R,e.$jg=P,e.$kg=y,e.$lg=c,e.$mg=h,e.$ng=d,e.$og=g,e.$pg=b,e.$qg=u,e.$rg=p,e.$sg=$,e.$tg=w,e.$ug=v,e.$vg=S;function i(r){return typeof r=="string"}function o(r){return Array.isArray(r)&&r.every(t=>i(t))}function E(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}function D(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}function R(r){return typeof r=="number"&&!isNaN(r)}function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}function y(r){return r===!0||r===!1}function c(r){return typeof r>"u"}function h(r){return!d(r)}function d(r){return c(r)||r===null}function g(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function b(r){if(d(r))throw new Error("Assertion Failed: argument is undefined or null");return r}function u(...r){const t=[];for(let n=0;n<r.length;n++){const a=r[n];if(d(a))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(a)}return t}const m=Object.prototype.hasOwnProperty;function p(r){if(!E(r))return!1;for(const t in r)if(m.call(r,t))return!1;return!0}function $(r){return typeof r=="function"}function w(...r){return r.length>0&&r.every($)}function v(r,t){const n=Math.min(r.length,t.length);for(let a=0;a<n;a++)S(r[a],t[a])}function S(r,t){if(i(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(r instanceof t)return}catch{}if(!d(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ce[110],le([0,1,12]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=E,e.$Zj=D;const o=Object.create(null);function E(R,P){if((0,i.$eg)(P)){const y=o[P];if(y===void 0)throw new Error(`${R} references an unknown codicon: ${P}`);P=y}return o[R]=P,{id:R}}function D(){return o}}),define(ce[147],le([0,1,110]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=void 0,e.$1j={add:(0,i.$Yj)("add",6e4),plus:(0,i.$Yj)("plus",6e4),gistNew:(0,i.$Yj)("gist-new",6e4),repoCreate:(0,i.$Yj)("repo-create",6e4),lightbulb:(0,i.$Yj)("lightbulb",60001),lightBulb:(0,i.$Yj)("light-bulb",60001),repo:(0,i.$Yj)("repo",60002),repoDelete:(0,i.$Yj)("repo-delete",60002),gistFork:(0,i.$Yj)("gist-fork",60003),repoForked:(0,i.$Yj)("repo-forked",60003),gitPullRequest:(0,i.$Yj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Yj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Yj)("record-keys",60005),keyboard:(0,i.$Yj)("keyboard",60005),tag:(0,i.$Yj)("tag",60006),gitPullRequestLabel:(0,i.$Yj)("git-pull-request-label",60006),tagAdd:(0,i.$Yj)("tag-add",60006),tagRemove:(0,i.$Yj)("tag-remove",60006),person:(0,i.$Yj)("person",60007),personFollow:(0,i.$Yj)("person-follow",60007),personOutline:(0,i.$Yj)("person-outline",60007),personFilled:(0,i.$Yj)("person-filled",60007),gitBranch:(0,i.$Yj)("git-branch",60008),gitBranchCreate:(0,i.$Yj)("git-branch-create",60008),gitBranchDelete:(0,i.$Yj)("git-branch-delete",60008),sourceControl:(0,i.$Yj)("source-control",60008),mirror:(0,i.$Yj)("mirror",60009),mirrorPublic:(0,i.$Yj)("mirror-public",60009),star:(0,i.$Yj)("star",60010),starAdd:(0,i.$Yj)("star-add",60010),starDelete:(0,i.$Yj)("star-delete",60010),starEmpty:(0,i.$Yj)("star-empty",60010),comment:(0,i.$Yj)("comment",60011),commentAdd:(0,i.$Yj)("comment-add",60011),alert:(0,i.$Yj)("alert",60012),warning:(0,i.$Yj)("warning",60012),search:(0,i.$Yj)("search",60013),searchSave:(0,i.$Yj)("search-save",60013),logOut:(0,i.$Yj)("log-out",60014),signOut:(0,i.$Yj)("sign-out",60014),logIn:(0,i.$Yj)("log-in",60015),signIn:(0,i.$Yj)("sign-in",60015),eye:(0,i.$Yj)("eye",60016),eyeUnwatch:(0,i.$Yj)("eye-unwatch",60016),eyeWatch:(0,i.$Yj)("eye-watch",60016),circleFilled:(0,i.$Yj)("circle-filled",60017),primitiveDot:(0,i.$Yj)("primitive-dot",60017),closeDirty:(0,i.$Yj)("close-dirty",60017),debugBreakpoint:(0,i.$Yj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Yj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Yj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Yj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Yj)("primitive-square",60018),edit:(0,i.$Yj)("edit",60019),pencil:(0,i.$Yj)("pencil",60019),info:(0,i.$Yj)("info",60020),issueOpened:(0,i.$Yj)("issue-opened",60020),gistPrivate:(0,i.$Yj)("gist-private",60021),gitForkPrivate:(0,i.$Yj)("git-fork-private",60021),lock:(0,i.$Yj)("lock",60021),mirrorPrivate:(0,i.$Yj)("mirror-private",60021),close:(0,i.$Yj)("close",60022),removeClose:(0,i.$Yj)("remove-close",60022),x:(0,i.$Yj)("x",60022),repoSync:(0,i.$Yj)("repo-sync",60023),sync:(0,i.$Yj)("sync",60023),clone:(0,i.$Yj)("clone",60024),desktopDownload:(0,i.$Yj)("desktop-download",60024),beaker:(0,i.$Yj)("beaker",60025),microscope:(0,i.$Yj)("microscope",60025),vm:(0,i.$Yj)("vm",60026),deviceDesktop:(0,i.$Yj)("device-desktop",60026),file:(0,i.$Yj)("file",60027),fileText:(0,i.$Yj)("file-text",60027),more:(0,i.$Yj)("more",60028),ellipsis:(0,i.$Yj)("ellipsis",60028),kebabHorizontal:(0,i.$Yj)("kebab-horizontal",60028),mailReply:(0,i.$Yj)("mail-reply",60029),reply:(0,i.$Yj)("reply",60029),organization:(0,i.$Yj)("organization",60030),organizationFilled:(0,i.$Yj)("organization-filled",60030),organizationOutline:(0,i.$Yj)("organization-outline",60030),newFile:(0,i.$Yj)("new-file",60031),fileAdd:(0,i.$Yj)("file-add",60031),newFolder:(0,i.$Yj)("new-folder",60032),fileDirectoryCreate:(0,i.$Yj)("file-directory-create",60032),trash:(0,i.$Yj)("trash",60033),trashcan:(0,i.$Yj)("trashcan",60033),history:(0,i.$Yj)("history",60034),clock:(0,i.$Yj)("clock",60034),folder:(0,i.$Yj)("folder",60035),fileDirectory:(0,i.$Yj)("file-directory",60035),symbolFolder:(0,i.$Yj)("symbol-folder",60035),logoGithub:(0,i.$Yj)("logo-github",60036),markGithub:(0,i.$Yj)("mark-github",60036),github:(0,i.$Yj)("github",60036),terminal:(0,i.$Yj)("terminal",60037),console:(0,i.$Yj)("console",60037),repl:(0,i.$Yj)("repl",60037),zap:(0,i.$Yj)("zap",60038),symbolEvent:(0,i.$Yj)("symbol-event",60038),error:(0,i.$Yj)("error",60039),stop:(0,i.$Yj)("stop",60039),variable:(0,i.$Yj)("variable",60040),symbolVariable:(0,i.$Yj)("symbol-variable",60040),array:(0,i.$Yj)("array",60042),symbolArray:(0,i.$Yj)("symbol-array",60042),symbolModule:(0,i.$Yj)("symbol-module",60043),symbolPackage:(0,i.$Yj)("symbol-package",60043),symbolNamespace:(0,i.$Yj)("symbol-namespace",60043),symbolObject:(0,i.$Yj)("symbol-object",60043),symbolMethod:(0,i.$Yj)("symbol-method",60044),symbolFunction:(0,i.$Yj)("symbol-function",60044),symbolConstructor:(0,i.$Yj)("symbol-constructor",60044),symbolBoolean:(0,i.$Yj)("symbol-boolean",60047),symbolNull:(0,i.$Yj)("symbol-null",60047),symbolNumeric:(0,i.$Yj)("symbol-numeric",60048),symbolNumber:(0,i.$Yj)("symbol-number",60048),symbolStructure:(0,i.$Yj)("symbol-structure",60049),symbolStruct:(0,i.$Yj)("symbol-struct",60049),symbolParameter:(0,i.$Yj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Yj)("symbol-type-parameter",60050),symbolKey:(0,i.$Yj)("symbol-key",60051),symbolText:(0,i.$Yj)("symbol-text",60051),symbolReference:(0,i.$Yj)("symbol-reference",60052),goToFile:(0,i.$Yj)("go-to-file",60052),symbolEnum:(0,i.$Yj)("symbol-enum",60053),symbolValue:(0,i.$Yj)("symbol-value",60053),symbolRuler:(0,i.$Yj)("symbol-ruler",60054),symbolUnit:(0,i.$Yj)("symbol-unit",60054),activateBreakpoints:(0,i.$Yj)("activate-breakpoints",60055),archive:(0,i.$Yj)("archive",60056),arrowBoth:(0,i.$Yj)("arrow-both",60057),arrowDown:(0,i.$Yj)("arrow-down",60058),arrowLeft:(0,i.$Yj)("arrow-left",60059),arrowRight:(0,i.$Yj)("arrow-right",60060),arrowSmallDown:(0,i.$Yj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Yj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Yj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Yj)("arrow-small-up",60064),arrowUp:(0,i.$Yj)("arrow-up",60065),bell:(0,i.$Yj)("bell",60066),bold:(0,i.$Yj)("bold",60067),book:(0,i.$Yj)("book",60068),bookmark:(0,i.$Yj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Yj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Yj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Yj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Yj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Yj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Yj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Yj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Yj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Yj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Yj)("briefcase",60076),broadcast:(0,i.$Yj)("broadcast",60077),browser:(0,i.$Yj)("browser",60078),bug:(0,i.$Yj)("bug",60079),calendar:(0,i.$Yj)("calendar",60080),caseSensitive:(0,i.$Yj)("case-sensitive",60081),check:(0,i.$Yj)("check",60082),checklist:(0,i.$Yj)("checklist",60083),chevronDown:(0,i.$Yj)("chevron-down",60084),chevronLeft:(0,i.$Yj)("chevron-left",60085),chevronRight:(0,i.$Yj)("chevron-right",60086),chevronUp:(0,i.$Yj)("chevron-up",60087),chromeClose:(0,i.$Yj)("chrome-close",60088),chromeMaximize:(0,i.$Yj)("chrome-maximize",60089),chromeMinimize:(0,i.$Yj)("chrome-minimize",60090),chromeRestore:(0,i.$Yj)("chrome-restore",60091),circleOutline:(0,i.$Yj)("circle-outline",60092),circle:(0,i.$Yj)("circle",60092),debugBreakpointUnverified:(0,i.$Yj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Yj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Yj)("circle-slash",60093),circuitBoard:(0,i.$Yj)("circuit-board",60094),clearAll:(0,i.$Yj)("clear-all",60095),clippy:(0,i.$Yj)("clippy",60096),closeAll:(0,i.$Yj)("close-all",60097),cloudDownload:(0,i.$Yj)("cloud-download",60098),cloudUpload:(0,i.$Yj)("cloud-upload",60099),code:(0,i.$Yj)("code",60100),collapseAll:(0,i.$Yj)("collapse-all",60101),colorMode:(0,i.$Yj)("color-mode",60102),commentDiscussion:(0,i.$Yj)("comment-discussion",60103),creditCard:(0,i.$Yj)("credit-card",60105),dash:(0,i.$Yj)("dash",60108),dashboard:(0,i.$Yj)("dashboard",60109),database:(0,i.$Yj)("database",60110),debugContinue:(0,i.$Yj)("debug-continue",60111),debugDisconnect:(0,i.$Yj)("debug-disconnect",60112),debugPause:(0,i.$Yj)("debug-pause",60113),debugRestart:(0,i.$Yj)("debug-restart",60114),debugStart:(0,i.$Yj)("debug-start",60115),debugStepInto:(0,i.$Yj)("debug-step-into",60116),debugStepOut:(0,i.$Yj)("debug-step-out",60117),debugStepOver:(0,i.$Yj)("debug-step-over",60118),debugStop:(0,i.$Yj)("debug-stop",60119),debug:(0,i.$Yj)("debug",60120),deviceCameraVideo:(0,i.$Yj)("device-camera-video",60121),deviceCamera:(0,i.$Yj)("device-camera",60122),deviceMobile:(0,i.$Yj)("device-mobile",60123),diffAdded:(0,i.$Yj)("diff-added",60124),diffIgnored:(0,i.$Yj)("diff-ignored",60125),diffModified:(0,i.$Yj)("diff-modified",60126),diffRemoved:(0,i.$Yj)("diff-removed",60127),diffRenamed:(0,i.$Yj)("diff-renamed",60128),diff:(0,i.$Yj)("diff",60129),diffSidebyside:(0,i.$Yj)("diff-sidebyside",60129),discard:(0,i.$Yj)("discard",60130),editorLayout:(0,i.$Yj)("editor-layout",60131),emptyWindow:(0,i.$Yj)("empty-window",60132),exclude:(0,i.$Yj)("exclude",60133),extensions:(0,i.$Yj)("extensions",60134),eyeClosed:(0,i.$Yj)("eye-closed",60135),fileBinary:(0,i.$Yj)("file-binary",60136),fileCode:(0,i.$Yj)("file-code",60137),fileMedia:(0,i.$Yj)("file-media",60138),filePdf:(0,i.$Yj)("file-pdf",60139),fileSubmodule:(0,i.$Yj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Yj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Yj)("file-symlink-file",60142),fileZip:(0,i.$Yj)("file-zip",60143),files:(0,i.$Yj)("files",60144),filter:(0,i.$Yj)("filter",60145),flame:(0,i.$Yj)("flame",60146),foldDown:(0,i.$Yj)("fold-down",60147),foldUp:(0,i.$Yj)("fold-up",60148),fold:(0,i.$Yj)("fold",60149),folderActive:(0,i.$Yj)("folder-active",60150),folderOpened:(0,i.$Yj)("folder-opened",60151),gear:(0,i.$Yj)("gear",60152),gift:(0,i.$Yj)("gift",60153),gistSecret:(0,i.$Yj)("gist-secret",60154),gist:(0,i.$Yj)("gist",60155),gitCommit:(0,i.$Yj)("git-commit",60156),gitCompare:(0,i.$Yj)("git-compare",60157),compareChanges:(0,i.$Yj)("compare-changes",60157),gitMerge:(0,i.$Yj)("git-merge",60158),githubAction:(0,i.$Yj)("github-action",60159),githubAlt:(0,i.$Yj)("github-alt",60160),globe:(0,i.$Yj)("globe",60161),grabber:(0,i.$Yj)("grabber",60162),graph:(0,i.$Yj)("graph",60163),gripper:(0,i.$Yj)("gripper",60164),heart:(0,i.$Yj)("heart",60165),home:(0,i.$Yj)("home",60166),horizontalRule:(0,i.$Yj)("horizontal-rule",60167),hubot:(0,i.$Yj)("hubot",60168),inbox:(0,i.$Yj)("inbox",60169),issueReopened:(0,i.$Yj)("issue-reopened",60171),issues:(0,i.$Yj)("issues",60172),italic:(0,i.$Yj)("italic",60173),jersey:(0,i.$Yj)("jersey",60174),json:(0,i.$Yj)("json",60175),kebabVertical:(0,i.$Yj)("kebab-vertical",60176),key:(0,i.$Yj)("key",60177),law:(0,i.$Yj)("law",60178),lightbulbAutofix:(0,i.$Yj)("lightbulb-autofix",60179),linkExternal:(0,i.$Yj)("link-external",60180),link:(0,i.$Yj)("link",60181),listOrdered:(0,i.$Yj)("list-ordered",60182),listUnordered:(0,i.$Yj)("list-unordered",60183),liveShare:(0,i.$Yj)("live-share",60184),loading:(0,i.$Yj)("loading",60185),location:(0,i.$Yj)("location",60186),mailRead:(0,i.$Yj)("mail-read",60187),mail:(0,i.$Yj)("mail",60188),markdown:(0,i.$Yj)("markdown",60189),megaphone:(0,i.$Yj)("megaphone",60190),mention:(0,i.$Yj)("mention",60191),milestone:(0,i.$Yj)("milestone",60192),gitPullRequestMilestone:(0,i.$Yj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Yj)("mortar-board",60193),move:(0,i.$Yj)("move",60194),multipleWindows:(0,i.$Yj)("multiple-windows",60195),mute:(0,i.$Yj)("mute",60196),noNewline:(0,i.$Yj)("no-newline",60197),note:(0,i.$Yj)("note",60198),octoface:(0,i.$Yj)("octoface",60199),openPreview:(0,i.$Yj)("open-preview",60200),package:(0,i.$Yj)("package",60201),paintcan:(0,i.$Yj)("paintcan",60202),pin:(0,i.$Yj)("pin",60203),play:(0,i.$Yj)("play",60204),run:(0,i.$Yj)("run",60204),plug:(0,i.$Yj)("plug",60205),preserveCase:(0,i.$Yj)("preserve-case",60206),preview:(0,i.$Yj)("preview",60207),project:(0,i.$Yj)("project",60208),pulse:(0,i.$Yj)("pulse",60209),question:(0,i.$Yj)("question",60210),quote:(0,i.$Yj)("quote",60211),radioTower:(0,i.$Yj)("radio-tower",60212),reactions:(0,i.$Yj)("reactions",60213),references:(0,i.$Yj)("references",60214),refresh:(0,i.$Yj)("refresh",60215),regex:(0,i.$Yj)("regex",60216),remoteExplorer:(0,i.$Yj)("remote-explorer",60217),remote:(0,i.$Yj)("remote",60218),remove:(0,i.$Yj)("remove",60219),replaceAll:(0,i.$Yj)("replace-all",60220),replace:(0,i.$Yj)("replace",60221),repoClone:(0,i.$Yj)("repo-clone",60222),repoForcePush:(0,i.$Yj)("repo-force-push",60223),repoPull:(0,i.$Yj)("repo-pull",60224),repoPush:(0,i.$Yj)("repo-push",60225),report:(0,i.$Yj)("report",60226),requestChanges:(0,i.$Yj)("request-changes",60227),rocket:(0,i.$Yj)("rocket",60228),rootFolderOpened:(0,i.$Yj)("root-folder-opened",60229),rootFolder:(0,i.$Yj)("root-folder",60230),rss:(0,i.$Yj)("rss",60231),ruby:(0,i.$Yj)("ruby",60232),saveAll:(0,i.$Yj)("save-all",60233),saveAs:(0,i.$Yj)("save-as",60234),save:(0,i.$Yj)("save",60235),screenFull:(0,i.$Yj)("screen-full",60236),screenNormal:(0,i.$Yj)("screen-normal",60237),searchStop:(0,i.$Yj)("search-stop",60238),server:(0,i.$Yj)("server",60240),settingsGear:(0,i.$Yj)("settings-gear",60241),settings:(0,i.$Yj)("settings",60242),shield:(0,i.$Yj)("shield",60243),smiley:(0,i.$Yj)("smiley",60244),sortPrecedence:(0,i.$Yj)("sort-precedence",60245),splitHorizontal:(0,i.$Yj)("split-horizontal",60246),splitVertical:(0,i.$Yj)("split-vertical",60247),squirrel:(0,i.$Yj)("squirrel",60248),starFull:(0,i.$Yj)("star-full",60249),starHalf:(0,i.$Yj)("star-half",60250),symbolClass:(0,i.$Yj)("symbol-class",60251),symbolColor:(0,i.$Yj)("symbol-color",60252),symbolConstant:(0,i.$Yj)("symbol-constant",60253),symbolEnumMember:(0,i.$Yj)("symbol-enum-member",60254),symbolField:(0,i.$Yj)("symbol-field",60255),symbolFile:(0,i.$Yj)("symbol-file",60256),symbolInterface:(0,i.$Yj)("symbol-interface",60257),symbolKeyword:(0,i.$Yj)("symbol-keyword",60258),symbolMisc:(0,i.$Yj)("symbol-misc",60259),symbolOperator:(0,i.$Yj)("symbol-operator",60260),symbolProperty:(0,i.$Yj)("symbol-property",60261),wrench:(0,i.$Yj)("wrench",60261),wrenchSubaction:(0,i.$Yj)("wrench-subaction",60261),symbolSnippet:(0,i.$Yj)("symbol-snippet",60262),tasklist:(0,i.$Yj)("tasklist",60263),telescope:(0,i.$Yj)("telescope",60264),textSize:(0,i.$Yj)("text-size",60265),threeBars:(0,i.$Yj)("three-bars",60266),thumbsdown:(0,i.$Yj)("thumbsdown",60267),thumbsup:(0,i.$Yj)("thumbsup",60268),tools:(0,i.$Yj)("tools",60269),triangleDown:(0,i.$Yj)("triangle-down",60270),triangleLeft:(0,i.$Yj)("triangle-left",60271),triangleRight:(0,i.$Yj)("triangle-right",60272),triangleUp:(0,i.$Yj)("triangle-up",60273),twitter:(0,i.$Yj)("twitter",60274),unfold:(0,i.$Yj)("unfold",60275),unlock:(0,i.$Yj)("unlock",60276),unmute:(0,i.$Yj)("unmute",60277),unverified:(0,i.$Yj)("unverified",60278),verified:(0,i.$Yj)("verified",60279),versions:(0,i.$Yj)("versions",60280),vmActive:(0,i.$Yj)("vm-active",60281),vmOutline:(0,i.$Yj)("vm-outline",60282),vmRunning:(0,i.$Yj)("vm-running",60283),watch:(0,i.$Yj)("watch",60284),whitespace:(0,i.$Yj)("whitespace",60285),wholeWord:(0,i.$Yj)("whole-word",60286),window:(0,i.$Yj)("window",60287),wordWrap:(0,i.$Yj)("word-wrap",60288),zoomIn:(0,i.$Yj)("zoom-in",60289),zoomOut:(0,i.$Yj)("zoom-out",60290),listFilter:(0,i.$Yj)("list-filter",60291),listFlat:(0,i.$Yj)("list-flat",60292),listSelection:(0,i.$Yj)("list-selection",60293),selection:(0,i.$Yj)("selection",60293),listTree:(0,i.$Yj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Yj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Yj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Yj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Yj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Yj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Yj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Yj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Yj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Yj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Yj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Yj)("symbol-string",60301),debugReverseContinue:(0,i.$Yj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Yj)("debug-step-back",60303),debugRestartFrame:(0,i.$Yj)("debug-restart-frame",60304),debugAlt:(0,i.$Yj)("debug-alt",60305),callIncoming:(0,i.$Yj)("call-incoming",60306),callOutgoing:(0,i.$Yj)("call-outgoing",60307),menu:(0,i.$Yj)("menu",60308),expandAll:(0,i.$Yj)("expand-all",60309),feedback:(0,i.$Yj)("feedback",60310),gitPullRequestReviewer:(0,i.$Yj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Yj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Yj)("ungroup-by-ref-type",60312),account:(0,i.$Yj)("account",60313),gitPullRequestAssignee:(0,i.$Yj)("git-pull-request-assignee",60313),bellDot:(0,i.$Yj)("bell-dot",60314),debugConsole:(0,i.$Yj)("debug-console",60315),library:(0,i.$Yj)("library",60316),output:(0,i.$Yj)("output",60317),runAll:(0,i.$Yj)("run-all",60318),syncIgnored:(0,i.$Yj)("sync-ignored",60319),pinned:(0,i.$Yj)("pinned",60320),githubInverted:(0,i.$Yj)("github-inverted",60321),serverProcess:(0,i.$Yj)("server-process",60322),serverEnvironment:(0,i.$Yj)("server-environment",60323),pass:(0,i.$Yj)("pass",60324),issueClosed:(0,i.$Yj)("issue-closed",60324),stopCircle:(0,i.$Yj)("stop-circle",60325),playCircle:(0,i.$Yj)("play-circle",60326),record:(0,i.$Yj)("record",60327),debugAltSmall:(0,i.$Yj)("debug-alt-small",60328),vmConnect:(0,i.$Yj)("vm-connect",60329),cloud:(0,i.$Yj)("cloud",60330),merge:(0,i.$Yj)("merge",60331),export:(0,i.$Yj)("export",60332),graphLeft:(0,i.$Yj)("graph-left",60333),magnet:(0,i.$Yj)("magnet",60334),notebook:(0,i.$Yj)("notebook",60335),redo:(0,i.$Yj)("redo",60336),checkAll:(0,i.$Yj)("check-all",60337),pinnedDirty:(0,i.$Yj)("pinned-dirty",60338),passFilled:(0,i.$Yj)("pass-filled",60339),circleLargeFilled:(0,i.$Yj)("circle-large-filled",60340),circleLarge:(0,i.$Yj)("circle-large",60341),circleLargeOutline:(0,i.$Yj)("circle-large-outline",60341),combine:(0,i.$Yj)("combine",60342),gather:(0,i.$Yj)("gather",60342),table:(0,i.$Yj)("table",60343),variableGroup:(0,i.$Yj)("variable-group",60344),typeHierarchy:(0,i.$Yj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Yj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Yj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Yj)("git-pull-request-create",60348),runAbove:(0,i.$Yj)("run-above",60349),runBelow:(0,i.$Yj)("run-below",60350),notebookTemplate:(0,i.$Yj)("notebook-template",60351),debugRerun:(0,i.$Yj)("debug-rerun",60352),workspaceTrusted:(0,i.$Yj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Yj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Yj)("workspace-unknown",60355),terminalCmd:(0,i.$Yj)("terminal-cmd",60356),terminalDebian:(0,i.$Yj)("terminal-debian",60357),terminalLinux:(0,i.$Yj)("terminal-linux",60358),terminalPowershell:(0,i.$Yj)("terminal-powershell",60359),terminalTmux:(0,i.$Yj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Yj)("terminal-ubuntu",60361),terminalBash:(0,i.$Yj)("terminal-bash",60362),arrowSwap:(0,i.$Yj)("arrow-swap",60363),copy:(0,i.$Yj)("copy",60364),personAdd:(0,i.$Yj)("person-add",60365),filterFilled:(0,i.$Yj)("filter-filled",60366),wand:(0,i.$Yj)("wand",60367),debugLineByLine:(0,i.$Yj)("debug-line-by-line",60368),inspect:(0,i.$Yj)("inspect",60369),layers:(0,i.$Yj)("layers",60370),layersDot:(0,i.$Yj)("layers-dot",60371),layersActive:(0,i.$Yj)("layers-active",60372),compass:(0,i.$Yj)("compass",60373),compassDot:(0,i.$Yj)("compass-dot",60374),compassActive:(0,i.$Yj)("compass-active",60375),azure:(0,i.$Yj)("azure",60376),issueDraft:(0,i.$Yj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Yj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Yj)("git-pull-request-draft",60379),debugAll:(0,i.$Yj)("debug-all",60380),debugCoverage:(0,i.$Yj)("debug-coverage",60381),runErrors:(0,i.$Yj)("run-errors",60382),folderLibrary:(0,i.$Yj)("folder-library",60383),debugContinueSmall:(0,i.$Yj)("debug-continue-small",60384),beakerStop:(0,i.$Yj)("beaker-stop",60385),graphLine:(0,i.$Yj)("graph-line",60386),graphScatter:(0,i.$Yj)("graph-scatter",60387),pieChart:(0,i.$Yj)("pie-chart",60388),bracket:(0,i.$Yj)("bracket",60175),bracketDot:(0,i.$Yj)("bracket-dot",60389),bracketError:(0,i.$Yj)("bracket-error",60390),lockSmall:(0,i.$Yj)("lock-small",60391),azureDevops:(0,i.$Yj)("azure-devops",60392),verifiedFilled:(0,i.$Yj)("verified-filled",60393),newline:(0,i.$Yj)("newline",60394),layout:(0,i.$Yj)("layout",60395),layoutActivitybarLeft:(0,i.$Yj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Yj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Yj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Yj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Yj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Yj)("layout-panel-right",60401),layoutPanel:(0,i.$Yj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Yj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Yj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Yj)("layout-statusbar",60405),layoutMenubar:(0,i.$Yj)("layout-menubar",60406),layoutCentered:(0,i.$Yj)("layout-centered",60407),target:(0,i.$Yj)("target",60408),indent:(0,i.$Yj)("indent",60409),recordSmall:(0,i.$Yj)("record-small",60410),errorSmall:(0,i.$Yj)("error-small",60411),terminalDecorationError:(0,i.$Yj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Yj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Yj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Yj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Yj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Yj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Yj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Yj)("layout-sidebar-left-off",60418),blank:(0,i.$Yj)("blank",60419),heartFilled:(0,i.$Yj)("heart-filled",60420),map:(0,i.$Yj)("map",60421),mapHorizontal:(0,i.$Yj)("map-horizontal",60421),foldHorizontal:(0,i.$Yj)("fold-horizontal",60421),mapFilled:(0,i.$Yj)("map-filled",60422),mapHorizontalFilled:(0,i.$Yj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Yj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Yj)("circle-small",60423),bellSlash:(0,i.$Yj)("bell-slash",60424),bellSlashDot:(0,i.$Yj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Yj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Yj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Yj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Yj)("search-fuzzy",60429),commentDraft:(0,i.$Yj)("comment-draft",60430),send:(0,i.$Yj)("send",60431),sparkle:(0,i.$Yj)("sparkle",60432),insert:(0,i.$Yj)("insert",60433),mic:(0,i.$Yj)("mic",60434),thumbsdownFilled:(0,i.$Yj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Yj)("thumbsup-filled",60436),coffee:(0,i.$Yj)("coffee",60437),snake:(0,i.$Yj)("snake",60438),game:(0,i.$Yj)("game",60439),vr:(0,i.$Yj)("vr",60440),chip:(0,i.$Yj)("chip",60441),piano:(0,i.$Yj)("piano",60442),music:(0,i.$Yj)("music",60443),micFilled:(0,i.$Yj)("mic-filled",60444),repoFetch:(0,i.$Yj)("repo-fetch",60445),copilot:(0,i.$Yj)("copilot",60446),lightbulbSparkle:(0,i.$Yj)("lightbulb-sparkle",60447),robot:(0,i.$Yj)("robot",60448),sparkleFilled:(0,i.$Yj)("sparkle-filled",60449),diffSingle:(0,i.$Yj)("diff-single",60450),diffMultiple:(0,i.$Yj)("diff-multiple",60451),surroundWith:(0,i.$Yj)("surround-with",60452),share:(0,i.$Yj)("share",60453),gitStash:(0,i.$Yj)("git-stash",60454),gitStashApply:(0,i.$Yj)("git-stash-apply",60455),gitStashPop:(0,i.$Yj)("git-stash-pop",60456),vscode:(0,i.$Yj)("vscode",60457),vscodeInsiders:(0,i.$Yj)("vscode-insiders",60458),codeOss:(0,i.$Yj)("code-oss",60459),runCoverage:(0,i.$Yj)("run-coverage",60460),runAllCoverage:(0,i.$Yj)("run-all-coverage",60461),coverage:(0,i.$Yj)("coverage",60462),githubProject:(0,i.$Yj)("github-project",60463),mapVertical:(0,i.$Yj)("map-vertical",60464),foldVertical:(0,i.$Yj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Yj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Yj)("fold-vertical-filled",60465),goToSearch:(0,i.$Yj)("go-to-search",60466),percentage:(0,i.$Yj)("percentage",60467),sortPercentage:(0,i.$Yj)("sort-percentage",60467),attach:(0,i.$Yj)("attach",60468)}}),define(ce[78],le([0,1,110,147]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=void 0,e.$2j=E;function E(){return Object.values(e.$4j)}e.$3j={dialogError:(0,i.$Yj)("dialog-error","error"),dialogWarning:(0,i.$Yj)("dialog-warning","warning"),dialogInfo:(0,i.$Yj)("dialog-info","info"),dialogClose:(0,i.$Yj)("dialog-close","close"),treeItemExpanded:(0,i.$Yj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Yj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Yj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Yj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Yj)("tree-item-loading","loading"),menuSelection:(0,i.$Yj)("menu-selection","check"),menuSubmenu:(0,i.$Yj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Yj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Yj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Yj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Yj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Yj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Yj)("toolbar-more","more"),quickInputBack:(0,i.$Yj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Yj)("drop-down-button",60084),symbolCustomColor:(0,i.$Yj)("symbol-customcolor",60252),exportIcon:(0,i.$Yj)("export",60332),workspaceUnspecified:(0,i.$Yj)("workspace-unspecified",60355),newLine:(0,i.$Yj)("newline",60394),thumbsDownFilled:(0,i.$Yj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Yj)("thumbsup-filled",60436),gitFetch:(0,i.$Yj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Yj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Yj)("debug-breakpoint-pending",60377)},e.$4j={...o.$1j,...e.$3j}}),define(ce[35],le([0,1,12]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=o,e.$co=E,e.$do=R,e.$eo=y,e.$fo=c,e.$go=h,e.$ho=d,e.$io=g,e.$jo=b,e.$ko=u,e.$lo=m,e.$mo=p,e.$no=$;function o(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const v=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([S,r])=>{v[S]=r&&typeof r=="object"?o(r):r}),v}function E(w){if(!w||typeof w!="object")return w;const v=[w];for(;v.length>0;){const S=v.shift();Object.freeze(S);for(const r in S)if(D.call(S,r)){const t=S[r];typeof t=="object"&&!Object.isFrozen(t)&&!(0,i.$hg)(t)&&v.push(t)}}return w}const D=Object.prototype.hasOwnProperty;function R(w,v){return P(w,v,new Set)}function P(w,v,S){if((0,i.$ng)(w))return w;const r=v(w);if(typeof r<"u")return r;if(Array.isArray(w)){const t=[];for(const n of w)t.push(P(n,v,S));return t}if((0,i.$gg)(w)){if(S.has(w))throw new Error("Cannot clone recursive data-structure");S.add(w);const t={};for(const n in w)D.call(w,n)&&(t[n]=P(w[n],v,S));return S.delete(w),t}return w}function y(w,v,S=!0){return(0,i.$gg)(w)?((0,i.$gg)(v)&&Object.keys(v).forEach(r=>{r in w?S&&((0,i.$gg)(w[r])&&(0,i.$gg)(v[r])?y(w[r],v[r],S):w[r]=v[r]):w[r]=v[r]}),w):v}function c(w,v){if(w===v)return!0;if(w==null||v===null||v===void 0||typeof w!=typeof v||typeof w!="object"||Array.isArray(w)!==Array.isArray(v))return!1;let S,r;if(Array.isArray(w)){if(w.length!==v.length)return!1;for(S=0;S<w.length;S++)if(!c(w[S],v[S]))return!1}else{const t=[];for(r in w)t.push(r);t.sort();const n=[];for(r in v)n.push(r);if(n.sort(),!c(t,n))return!1;for(S=0;S<t.length;S++)if(!c(w[t[S]],v[t[S]]))return!1}return!0}function h(w){const v=new Set;return JSON.stringify(w,(S,r)=>{if((0,i.$gg)(r)||Array.isArray(r)){if(v.has(r))return"[Circular]";v.add(r)}return typeof r=="bigint"?`[BigInt ${r.toString()}]`:r})}function d(w,v){const S=Object.create(null);return!w||!v||Object.keys(v).forEach(t=>{const n=w[t],a=v[t];c(n,a)||(S[t]=a)}),S}function g(w,v){const S=v.toLowerCase(),r=Object.keys(w).find(t=>t.toLowerCase()===S);return r?w[r]:w[v]}function b(w,v){const S=Object.create(null);for(const[r,t]of Object.entries(w))v(r,t)&&(S[r]=t);return S}function u(w){let v=[];for(;Object.prototype!==w;)v=v.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return v}function m(w){const v=[];for(const S of u(w))typeof w[S]=="function"&&v.push(S);return v}function p(w,v){const S=t=>function(){const n=Array.prototype.slice.call(arguments,0);return v(t,n)},r={};for(const t of w)r[t]=S(t);return r}function $(w,v){const S={};for(const[r,t]of Object.entries(w))S[r]=v(t,r);return S}}),define(ce[111],le([0,1,78]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=E;var o;(function(R){function P(y){return y&&typeof y=="object"&&typeof y.id=="string"}R.isThemeColor=P})(o||(e.ThemeColor=o={}));function E(R){return{id:R}}var D;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function y(w){const v=P.exec(w.id);if(!v)return y(i.$4j.error);const[,S,r]=v,t=["codicon","codicon-"+S];return r&&t.push("codicon-modifier-"+r.substring(1)),t}R.asClassNameArray=y;function c(w){return y(w).join(" ")}R.asClassName=c;function h(w){return"."+y(w).join(".")}R.asCSSSelector=h;function d(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(typeof w.color>"u"||o.isThemeColor(w.color))}R.isThemeIcon=d;const g=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(w){const v=g.exec(w);if(!v)return;const[,S]=v;return{id:S}}R.fromString=b;function u(w){return{id:w}}R.fromId=u;function m(w,v){let S=w.id;const r=S.lastIndexOf("~");return r!==-1&&(S=S.substring(0,r)),v&&(S=`${S}~${v}`),{id:S}}R.modify=m;function p(w){const v=w.id.lastIndexOf("~");if(v!==-1)return w.id.substring(v+1)}R.getModifier=p;function $(w,v){return w.id===v.id&&w.color?.id===v.color?.id}R.isEqual=$})(D||(e.ThemeIcon=D={}))}),define(ce[148],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=o,e.$bf=E;var i;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function o(D){return D<0?0:D>i.MAX_UINT_8?i.MAX_UINT_8:D|0}function E(D){return D<0?0:D>i.MAX_UINT_32?i.MAX_UINT_32:D|0}}),define(ce[26],le([0,1,145,39,65,148]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=R,e.$df=y,e.$ef=h,e.$ff=d,e.$gf=g,e.$hf=b,e.$if=u,e.$jf=m,e.$kf=p,e.$lf=$,e.$mf=w,e.$nf=v,e.$of=S,e.$pf=r,e.$qf=t,e.$rf=n,e.$sf=a,e.$tf=s,e.$uf=l,e.$vf=f,e.$wf=k,e.$xf=I,e.$yf=O,e.$zf=L,e.$Af=T,e.$Bf=A,e.$Cf=M,e.$Df=z,e.$Ef=C,e.$Ff=B,e.$Gf=re,e.$Hf=_,e.$If=se,e.$Jf=K,e.$Kf=ee,e.$Lf=H,e.$Mf=j,e.$Pf=G,e.$Qf=he,e.$Rf=ne,e.$Sf=Z,e.$Tf=W,e.$Uf=Q,e.$Wf=X,e.$Xf=Y,e.$Yf=ie,e.$Zf=de,e.$1f=pe,e.$2f=Ie,e.$3f=Pe,e.$5f=De,e.$6f=$e,e.$7f=J,e.$8f=ue,e.$9f=fe,e.$0f=be,e.$$f=Re,e.$_f=We,e.$ag=Je;function R(te){return!te||typeof te!="string"?!0:te.trim().length===0}const P=/{(\d+)}/g;function y(te,...ge){return ge.length===0?te:te.replace(P,function(we,ye){const Me=parseInt(ye,10);return isNaN(Me)||Me<0||Me>=ge.length?we:ge[Me]})}const c=/{([^}]+)}/g;function h(te,ge){return Object.keys(ge).length===0?te:te.replace(c,(we,ye)=>ge[ye]??we)}function d(te){return te.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function g(te){return te.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function u(te,ge){let we=0,ye=te.indexOf(ge);for(;ye!==-1;)we++,ye=te.indexOf(ge,ye+ge.length);return we}function m(te,ge,we="\u2026"){return te.length<=ge?te:`${te.substr(0,ge)}${we}`}function p(te,ge,we="\u2026"){if(te.length<=ge)return te;const ye=Math.ceil(ge/2)-we.length/2,Me=Math.floor(ge/2)-we.length/2;return`${te.substr(0,ye)}${we}${te.substr(te.length-Me)}`}function $(te,ge=" "){const we=w(te,ge);return v(we,ge)}function w(te,ge){if(!te||!ge)return te;const we=ge.length;if(we===0||te.length===0)return te;let ye=0;for(;te.indexOf(ge,ye)===ye;)ye=ye+we;return te.substring(ye)}function v(te,ge){if(!te||!ge)return te;const we=ge.length,ye=te.length;if(we===0||ye===0)return te;let Me=ye,Ue=-1;for(;Ue=te.lastIndexOf(ge,Me-1),!(Ue===-1||Ue+we!==Me);){if(Ue===0)return"";Me=Ue}return te.substring(0,Me)}function S(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function r(te){return te.replace(/\*/g,"")}function t(te,ge,we={}){if(!te)throw new Error("Cannot create regex from empty string");ge||(te=b(te)),we.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ye="";return we.global&&(ye+="g"),we.matchCase||(ye+="i"),we.multiline&&(ye+="m"),we.unicode&&(ye+="u"),new RegExp(te,ye)}function n(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function a(te){return te.split(/\r\n|\r|\n/)}function s(te){const ge=[],we=te.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(we.length/2);ye++)ge.push(we[2*ye]+(we[2*ye+1]??""));return ge}function l(te){for(let ge=0,we=te.length;ge<we;ge++){const ye=te.charCodeAt(ge);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return ge}return-1}function f(te,ge=0,we=te.length){for(let ye=ge;ye<we;ye++){const Me=te.charCodeAt(ye);if(Me!==o.CharCode.Space&&Me!==o.CharCode.Tab)return te.substring(ge,ye)}return te.substring(ge,we)}function k(te,ge=te.length-1){for(let we=ge;we>=0;we--){const ye=te.charCodeAt(we);if(ye!==o.CharCode.Space&&ye!==o.CharCode.Tab)return we}return-1}function I(te,ge,we){const ye=[];let Me=0;for(const Ue of te.matchAll(ge)){if(ye.push(te.slice(Me,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Me=Ue.index+Ue[0].length,ye.push(we(Ue[0],...Ue.slice(1),Ue.index,te,Ue.groups))}return ye.push(te.slice(Me)),Promise.all(ye).then(Ue=>Ue.join(""))}function O(te,ge){return te<ge?-1:te>ge?1:0}function L(te,ge,we=0,ye=te.length,Me=0,Ue=ge.length){for(;we<ye&&Me<Ue;we++,Me++){const rt=te.charCodeAt(we),at=ge.charCodeAt(Me);if(rt<at)return-1;if(rt>at)return 1}const Ze=ye-we,lt=Ue-Me;return Ze<lt?-1:Ze>lt?1:0}function T(te,ge){return A(te,ge,0,te.length,0,ge.length)}function A(te,ge,we=0,ye=te.length,Me=0,Ue=ge.length){for(;we<ye&&Me<Ue;we++,Me++){let rt=te.charCodeAt(we),at=ge.charCodeAt(Me);if(rt===at)continue;if(rt>=128||at>=128)return L(te.toLowerCase(),ge.toLowerCase(),we,ye,Me,Ue);z(rt)&&(rt-=32),z(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const Ze=ye-we,lt=Ue-Me;return Ze<lt?-1:Ze>lt?1:0}function M(te){return te>=o.CharCode.Digit0&&te<=o.CharCode.Digit9}function z(te){return te>=o.CharCode.a&&te<=o.CharCode.z}function C(te){return te>=o.CharCode.A&&te<=o.CharCode.Z}function B(te,ge){return te.length===ge.length&&A(te,ge)===0}function re(te,ge){const we=ge.length;return ge.length>te.length?!1:A(te,ge,0,we)===0}function _(te,ge){const we=Math.min(te.length,ge.length);let ye;for(ye=0;ye<we;ye++)if(te.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return we}function se(te,ge){const we=Math.min(te.length,ge.length);let ye;const Me=te.length-1,Ue=ge.length-1;for(ye=0;ye<we;ye++)if(te.charCodeAt(Me-ye)!==ge.charCodeAt(Ue-ye))return ye;return we}function K(te){return 55296<=te&&te<=56319}function ee(te){return 56320<=te&&te<=57343}function H(te,ge){return(te-55296<<10)+(ge-56320)+65536}function j(te,ge,we){const ye=te.charCodeAt(we);if(K(ye)&&we+1<ge){const Me=te.charCodeAt(we+1);if(ee(Me))return H(ye,Me)}return ye}function U(te,ge){const we=te.charCodeAt(ge-1);if(ee(we)&&ge>1){const ye=te.charCodeAt(ge-2);if(K(ye))return H(ye,we)}return we}class x{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=U(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Nf=x;class ae{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new x(ge,we)}nextGraphemeLength(){const ge=Be.getInstance(),we=this.c,ye=we.offset;let Me=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Ue=we.offset,Ze=ge.getGraphemeBreakType(we.nextCodePoint());if(Fe(Me,Ze)){we.setOffset(Ue);break}Me=Ze}return we.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),we=this.c,ye=we.offset;let Me=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Ue=we.offset,Ze=ge.getGraphemeBreakType(we.prevCodePoint());if(Fe(Ze,Me)){we.setOffset(Ue);break}Me=Ze}return ye-we.offset}eol(){return this.c.eol()}}e.$Of=ae;function G(te,ge){return new ae(te,ge).nextGraphemeLength()}function he(te,ge){return new ae(te,ge).prevGraphemeLength()}function ne(te,ge){ge>0&&ee(te.charCodeAt(ge))&&ge--;const we=ge+G(te,ge);return[we-he(te,we),we]}function Z(te){const ge=new ae(te);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let F;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(te){return F||(F=N()),F.test(te)}const q=/^[\t\n\r\x20-\x7E]*$/;function Q(te){return q.test(te)}e.$Vf=/[\u2028\u2029]/;function X(te){return e.$Vf.test(te)}function Y(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function ie(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function de(te,ge,we=""){const ye=te.trimStart();if(ye.length<ge)return ye;const Me=/\b/g;let Ue=0;for(;Me.test(ye)&&!(ye.length-Me.lastIndex<ge);)Ue=Me.lastIndex,Me.lastIndex+=1;return Ue===0?ye:we+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(te){let ge=0;for(const we of te.matchAll(me))ge!==we.index&&(yield{isCode:!1,str:te.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==te.length&&(yield{isCode:!1,str:te.substring(ge)})}function Ie(te){return te&&(te=te.replace(me,"")),te}const ke=/\\\[.*?\\\]/g;function Pe(te){return Ie(te).replace(ke,"")}e.$4f=String.fromCharCode(o.CharCode.UTF8_BOM);function De(te){return!!(te&&te.length>0&&te.charCodeAt(0)===o.CharCode.UTF8_BOM)}function $e(te){return De(te)?te.substr(1):te}function J(te,ge){if(!te||!ge||te.length<ge.length)return!1;const we=ge.length,ye=te.toLowerCase();let Me=0,Ue=-1;for(;Me<we;){const Ze=ye.indexOf(ge[Me],Ue+1);if(Ze<0)return!1;Ue=Ze,Me++}return!0}function ue(te,ge=!1){return te?(ge&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function fe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function be(te,ge=1){if(ge===0)return"";let we=-1;do we=te.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?te:(te[we-1]==="\r"&&we--,te.substr(0,we))}function Re(te){const ge=o.CharCode.Z-o.CharCode.A+1;return te=te%(2*ge),te<ge?String.fromCharCode(o.CharCode.a+te):String.fromCharCode(o.CharCode.A+te-ge)}function We(te){return Be.getInstance().getGraphemeBreakType(te)}function Fe(te,ge){return te===Oe.Other?ge!==Oe.Extend&&ge!==Oe.SpacingMark:te===Oe.CR&&ge===Oe.LF?!1:te===Oe.Control||te===Oe.CR||te===Oe.LF||ge===Oe.Control||ge===Oe.CR||ge===Oe.LF?!0:!(te===Oe.L&&(ge===Oe.L||ge===Oe.V||ge===Oe.LV||ge===Oe.LVT)||(te===Oe.LV||te===Oe.V)&&(ge===Oe.V||ge===Oe.T)||(te===Oe.LVT||te===Oe.T)&&ge===Oe.T||ge===Oe.Extend||ge===Oe.ZWJ||ge===Oe.SpacingMark||te===Oe.Prepend||te===Oe.ZWJ&&ge===Oe.Extended_Pictographic||te===Oe.Regional_Indicator&&ge===Oe.Regional_Indicator)}var Oe;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=xe()}getGraphemeBreakType(ge){if(ge<32)return ge===o.CharCode.LineFeed?Oe.LF:ge===o.CharCode.CarriageReturn?Oe.CR:Oe.Control;if(ge<127)return Oe.Other;const we=this.d,ye=we.length/3;let Me=1;for(;Me<=ye;)if(ge<we[3*Me])Me=2*Me;else if(ge>we[3*Me+1])Me=2*Me+1;else return we[3*Me+2];return Oe.Other}}function xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(te,ge){if(te===0)return 0;const we=qe(te,ge);if(we!==void 0)return we;const ye=new x(ge,te);return ye.prevCodePoint(),ye.offset}function qe(te,ge){const we=new x(ge,te);let ye=we.prevCodePoint();for(;Qe(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(we.offset===0)return;ye=we.prevCodePoint()}if(!ie(ye))return;let Me=we.offset;return Me>0&&we.prevCodePoint()===Xe.zwj&&(Me=we.offset),Me}function Qe(te){return 127995<=te&&te<=127999}var Xe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$bg="\xA0";class Ke{static{this.c=new E.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$$e({getCacheKey:JSON.stringify},ge=>{function we(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let Ze=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);Ze.length===0&&(Ze=["_default"]);let lt;for(const tt of Ze){const ut=we(Ue[tt]);lt=Me(lt,ut)}const rt=we(Ue._common),at=ye(rt,lt);return new Ke(at)})}static getInstance(ge){return Ke.d.get(Array.from(ge))}static{this.e=new E.$W(()=>Object.keys(Ke.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const ye=ge.codePointAt(we);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=Ke;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const ye=ge.codePointAt(we);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$dg=Ce}),define(ce[46],le([0,1,26]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=o,e.$tj=E,e.$uj=D,e.$vj=P,e.$xj=m,i=Ae(i);function o($){return E($,0)}function E($,w){switch(typeof $){case"object":return $===null?D(349,w):Array.isArray($)?y($,w):c($,w);case"string":return P($,w);case"boolean":return R($,w);case"number":return D($,w);case"undefined":return D(937,w);default:return D(617,w)}}function D($,w){return(w<<5)-w+$|0}function R($,w){return D($?433:863,w)}function P($,w){w=D(149417,w);for(let v=0,S=$.length;v<S;v++)w=D($.charCodeAt(v),w);return w}function y($,w){return w=D(104579,w),$.reduce((v,S)=>E(S,v),w)}function c($,w){return w=D(181387,w),Object.keys($).sort().reduce((v,S)=>(v=P(S,v),E($[S],v)),w)}class h{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=E(w,this.g),this.g}}e.$wj=h;var d;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function g($,w,v=32){const S=v-w,r=~((1<<S)-1);return($<<w|(r&$)>>>S)>>>0}function b($,w=0,v=$.byteLength,S=0){for(let r=0;r<v;r++)$[w+r]=S}function u($,w,v="0"){for(;$.length<w;)$=v+$;return $}function m($,w=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(v=>v.toString(16).padStart(2,"0")).join(""):u(($>>>0).toString(16),w/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const v=w.length;if(v===0)return;const S=this.p;let r=this.r,t=this.u,n,a;for(t!==0?(n=t,a=-1,t=0):(n=w.charCodeAt(0),a=0);;){let s=n;if(i.$Jf(n))if(a+1<v){const l=w.charCodeAt(a+1);i.$Kf(l)?(a++,s=i.$Lf(n,l)):s=d.UNICODE_REPLACEMENT}else{t=n;break}else i.$Kf(n)&&(s=d.UNICODE_REPLACEMENT);if(r=this.w(S,r,s),a++,a<v)n=w.charCodeAt(a);else break}this.r=r,this.u=t}w(w,v,S){return S<128?w[v++]=S:S<2048?(w[v++]=192|(S&1984)>>>6,w[v++]=128|(S&63)>>>0):S<65536?(w[v++]=224|(S&61440)>>>12,w[v++]=128|(S&4032)>>>6,w[v++]=128|(S&63)>>>0):(w[v++]=240|(S&1835008)>>>18,w[v++]=128|(S&258048)>>>12,w[v++]=128|(S&4032)>>>6,w[v++]=128|(S&63)>>>0),v>=d.BLOCK_SIZE&&(this.y(),v-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,w[0]=w[d.BLOCK_SIZE+0],w[1]=w[d.BLOCK_SIZE+1],w[2]=w[d.BLOCK_SIZE+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=p.g,v=this.q;for(let k=0;k<64;k+=4)w.setUint32(k,v.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)w.setUint32(k,g(w.getUint32(k-12,!1)^w.getUint32(k-32,!1)^w.getUint32(k-56,!1)^w.getUint32(k-64,!1),1),!1);let S=this.h,r=this.l,t=this.m,n=this.n,a=this.o,s,l,f;for(let k=0;k<80;k++)k<20?(s=r&t|~r&n,l=1518500249):k<40?(s=r^t^n,l=1859775393):k<60?(s=r&t|r&n|t&n,l=2400959708):(s=r^t^n,l=3395469782),f=g(S,5)+s+a+l+w.getUint32(k*4,!1)&4294967295,a=n,n=t,t=g(r,30),r=S,S=f;this.h=this.h+S&4294967295,this.l=this.l+r&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+a&4294967295}}e.$yj=p}),define(ce[79],le([0,1,26]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Ae(i);var o;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(o||(o={})),function(E){const D="error",R="warning",P="warn",y="info",c="ignore";function h(g){return g?i.$Ff(D,g)?E.Error:i.$Ff(R,g)||i.$Ff(P,g)?E.Warning:i.$Ff(y,g)?E.Info:E.Ignore:E.Ignore}E.fromValue=h;function d(g){switch(g){case E.Error:return D;case E.Warning:return R;case E.Info:return y;default:return c}}E.toString=d}(o||(o={})),e.default=o}),define(ce[61],le([0,1,22,39,26]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class D{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const m=u.charCodeAt(0),p=this.b.charCodeAt(this.c);return m-p}value(){return this.b[this.c]}}e.$Gi=D;class R{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===o.CharCode.Period)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,E.$zf)(u,this.b,0,u.length,this.c,this.d):(0,E.$Bf)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=R;class P{constructor(u=!0,m=!0){this.f=u,this.g=m}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let m=u.length-1;m>=0;m--,this.c--){const p=this.b.charCodeAt(m);if(!(p===o.CharCode.Slash||this.f&&p===o.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===o.CharCode.Slash||this.f&&m===o.CharCode.Backslash)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,E.$zf)(u,this.b,0,u.length,this.d,this.e):(0,E.$Bf)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=P;var y;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(y||(y={}));class c{constructor(u,m){this.f=u,this.g=m,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new P(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(y.Path)),this.g(u)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===y.Scheme)return(0,E.$Af)(u,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,E.$Af)(u,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(u);if(this.d[this.e]===y.Query)return(0,E.$yf)(u,this.c.query);if(this.d[this.e]===y.Fragment)return(0,E.$yf)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}e.$Ji=c;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(d||(d={}));class g{static forUris(u=()=>!1,m=()=>!1){return new g(new c(u,m))}static forPaths(u=!1){return new g(new P(void 0,!u))}static forStrings(){return new g(new D)}static forConfigKeys(){return new g(new R)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,m){if(m){const p=m.slice(0);(0,i.$Xb)(p);for(const $ of p)this.set($,u)}else{const p=u.slice(0);(0,i.$Xb)(p);for(const $ of p)this.set($[0],$[1])}}set(u,m){const p=this.b.reset(u);let $;this.c||(this.c=new h,this.c.segment=p.value());const w=[];for($=this.c;;){const S=p.cmp($.segment);if(S>0)$.left||($.left=new h,$.left.segment=p.value()),w.push([d.Left,$]),$=$.left;else if(S<0)$.right||($.right=new h,$.right.segment=p.value()),w.push([d.Right,$]),$=$.right;else if(p.hasNext())p.next(),$.mid||($.mid=new h,$.mid.segment=p.value()),w.push([d.Mid,$]),$=$.mid;else break}const v=$.value;$.value=m,$.key=u;for(let S=w.length-1;S>=0;S--){const r=w[S][1];r.updateHeight();const t=r.balanceFactor();if(t<-1||t>1){const n=w[S][0],a=w[S+1][0];if(n===d.Right&&a===d.Right)w[S][1]=r.rotateLeft();else if(n===d.Left&&a===d.Left)w[S][1]=r.rotateRight();else if(n===d.Right&&a===d.Left)r.right=w[S+1][1]=w[S+1][1].rotateRight(),w[S][1]=r.rotateLeft();else if(n===d.Left&&a===d.Right)r.left=w[S+1][1]=w[S+1][1].rotateLeft(),w[S][1]=r.rotateRight();else throw new Error;if(S>0)switch(w[S-1][0]){case d.Left:w[S-1][1].left=w[S][1];break;case d.Right:w[S-1][1].right=w[S][1];break;case d.Mid:w[S-1][1].mid=w[S][1];break}else this.c=w[0][1]}}return v}get(u){return this.d(u)?.value}d(u){const m=this.b.reset(u);let p=this.c;for(;p;){const $=m.cmp(p.segment);if($>0)p=p.left;else if($<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else break}return p}has(u){const m=this.d(u);return!(m?.value===void 0&&m?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,m){const p=this.b.reset(u),$=[];let w=this.c;for(;w;){const v=p.cmp(w.segment);if(v>0)$.push([d.Left,w]),w=w.left;else if(v<0)$.push([d.Right,w]),w=w.right;else if(p.hasNext())p.next(),$.push([d.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const v=this.f(w.right);if(v.key){const{key:S,value:r,segment:t}=v;this.e(v.key,!1),w.key=S,w.value=r,w.segment=t}}else{const v=w.left??w.right;if($.length>0){const[S,r]=$[$.length-1];switch(S){case d.Left:r.left=v;break;case d.Mid:r.mid=v;break;case d.Right:r.right=v;break}}else this.c=v}for(let v=$.length-1;v>=0;v--){const S=$[v][1];S.updateHeight();const r=S.balanceFactor();if(r>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),$[v][1]=S.rotateLeft()):r<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),$[v][1]=S.rotateRight()),v>0)switch($[v-1][0]){case d.Left:$[v-1][1].left=$[v][1];break;case d.Right:$[v-1][1].right=$[v][1];break;case d.Mid:$[v-1][1].mid=$[v][1];break}else this.c=$[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const m=this.b.reset(u);let p=this.c,$;for(;p;){const w=m.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(m.hasNext())m.next(),$=p.value||$,p=p.mid;else break}return p&&p.value||$}findSuperstr(u){return this.g(u,!1)}g(u,m){const p=this.b.reset(u);let $=this.c;for(;$;){const w=p.cmp($.segment);if(w>0)$=$.left;else if(w<0)$=$.right;else if(p.hasNext())p.next(),$=$.mid;else return $.mid?this.h($.mid):m?$.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[m,p]of this)u(p,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const m=[];return this.j(u,m),m[Symbol.iterator]()}j(u,m){u&&(u.left&&this.j(u.left,m),u.value&&m.push([u.key,u.value]),u.mid&&this.j(u.mid,m),u.right&&this.j(u.right,m))}_isBalanced(){const u=m=>{if(!m)return!0;const p=m.balanceFactor();return p<-1||p>1?!1:u(m.left)&&u(m.right)};return u(this.c)}}e.$Ki=g}),define(ce[33],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=o;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(E){return i.test(E)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(P){for(let y=0;y<P.length;y++)P[y]=Math.floor(Math.random()*256);return P};const D=new Uint8Array(16),R=[];for(let P=0;P<256;P++)R.push(P.toString(16).padStart(2,"0"));return function(){E(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,c="";return c+=R[D[y++]],c+=R[D[y++]],c+=R[D[y++]],c+=R[D[y++]],c+="-",c+=R[D[y++]],c+=R[D[y++]],c+="-",c+=R[D[y++]],c+=R[D[y++]],c+="-",c+=R[D[y++]],c+=R[D[y++]],c+="-",c+=R[D[y++]],c+=R[D[y++]],c+=R[D[y++]],c+=R[D[y++]],c+=R[D[y++]],c+=R[D[y++]],c}}()}),define(ce[149],le([0,1,91,47,89]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4W=D,i=Ae(i),o=Ae(o);async function D(R,P){if(await new Promise((h,d)=>{const g=o.createReadStream(R),b=i.createHash("sha256");g.pipe(b);const u=(0,E.$eb)((m,p)=>{g.removeAllListeners(),b.removeAllListeners(),m?d(m):h(p)});g.once("error",u),g.once("end",u),b.once("error",u),b.once("data",m=>u(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}}),define(ce[150],le([0,1,27]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=D;const o=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(R){const P=R.replace(/\-/g,":").toLowerCase();return!o.has(P)}function D(){const R=(0,i.networkInterfaces)();for(const P in R){const y=R[P];if(y){for(const{mac:c}of y)if(E(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[112],le([0,1,92]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=void 0,e.$3g=o,e.$5g=D,i=Ae(i);function o(P,y,c,h=1){let d=!1;return new Promise(g=>{const b=setTimeout(()=>{if(!d)return d=!0,g(0)},c);E(P,y,h,u=>{if(!d)return d=!0,clearTimeout(b),g(u)})})}function E(P,y,c,h){if(y===0)return h(0);const d=new i.Socket;d.once("connect",()=>(R(d),E(P+c,y-1,c,h))),d.once("data",()=>{}),d.once("error",g=>(R(d),g.code!=="ECONNREFUSED"?E(P+c,y-1,c,h):h(P))),d.connect(P,"127.0.0.1")}e.$4g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(P,y,c,h="127.0.0.1"){let d=!1,g,b=1;const u=i.createServer({pauseOnConnect:!0});function m(p,$){d||(d=!0,u.removeAllListeners(),u.close(),g&&clearTimeout(g),$(p))}return new Promise(p=>{g=setTimeout(()=>{m(0,p)},c),u.on("listening",()=>{m(P,p)}),u.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&b<y?(P++,b++,u.listen(P,h)):m(0,p)}),u.on("close",()=>{m(0,p)}),u.listen(P,h)})}function R(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(y){console.error(y)}}}),function(){function V(){function e(){return process.uncHostAllowlist}function i(y){const c=new Set;if(Array.isArray(y))for(const h of y)typeof h=="string"&&c.add(h);return Array.from(c)}function o(){const y=e();return y?Array.from(y):[]}function E(y){if(process.platform!=="win32")return;const c=e();if(c)if(typeof y=="string")c.add(y.toLowerCase());else for(const h of i(y))E(h)}function D(y){if(typeof y!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let h;for(const d of c){if(y.indexOf(d)!==0)continue;const b=y.indexOf("\\",d.length);if(b===-1)continue;const u=y.substring(d.length,b);if(u){h=u;break}}return h}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:o,addUNCHostToAllowlist:E,getUNCHost:D,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return V()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=V():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ce[151],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0W=e.$9W=void 0,e.$9W="vscode:contextmenu",e.$0W="vscode:onCloseContextMenu"}),define(ce[152],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eX=void 0;class i{constructor(E,D){this.a=E,this.onMessage=D}send(E){try{this.a.send("vscode:message",E.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$eX=i}),define(ce[153],le([11,10]),function(V,e){return V.create("vs/base/common/date",e)}),define(ce[154],le([0,1,153]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=c,e.$1m=h,e.$2m=d;const o=60,E=o*60,D=E*24,R=D*7,P=D*30,y=D*365;function c(g,b,u,m){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,i.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!m&&p<30)return(0,i.localize)(1,null);let $;return p<o?($=p,b?$===1?u?(0,i.localize)(2,null,$):(0,i.localize)(3,null,$):u?(0,i.localize)(4,null,$):(0,i.localize)(5,null,$):$===1?u?(0,i.localize)(6,null,$):(0,i.localize)(7,null,$):u?(0,i.localize)(8,null,$):(0,i.localize)(9,null,$)):p<E?($=Math.floor(p/o),b?$===1?u?(0,i.localize)(10,null,$):(0,i.localize)(11,null,$):u?(0,i.localize)(12,null,$):(0,i.localize)(13,null,$):$===1?u?(0,i.localize)(14,null,$):(0,i.localize)(15,null,$):u?(0,i.localize)(16,null,$):(0,i.localize)(17,null,$)):p<D?($=Math.floor(p/E),b?$===1?u?(0,i.localize)(18,null,$):(0,i.localize)(19,null,$):u?(0,i.localize)(20,null,$):(0,i.localize)(21,null,$):$===1?u?(0,i.localize)(22,null,$):(0,i.localize)(23,null,$):u?(0,i.localize)(24,null,$):(0,i.localize)(25,null,$)):p<R?($=Math.floor(p/D),b?$===1?(0,i.localize)(26,null,$):(0,i.localize)(27,null,$):$===1?(0,i.localize)(28,null,$):(0,i.localize)(29,null,$)):p<P?($=Math.floor(p/R),b?$===1?u?(0,i.localize)(30,null,$):(0,i.localize)(31,null,$):u?(0,i.localize)(32,null,$):(0,i.localize)(33,null,$):$===1?u?(0,i.localize)(34,null,$):(0,i.localize)(35,null,$):u?(0,i.localize)(36,null,$):(0,i.localize)(37,null,$)):p<y?($=Math.floor(p/P),b?$===1?u?(0,i.localize)(38,null,$):(0,i.localize)(39,null,$):u?(0,i.localize)(40,null,$):(0,i.localize)(41,null,$):$===1?u?(0,i.localize)(42,null,$):(0,i.localize)(43,null,$):u?(0,i.localize)(44,null,$):(0,i.localize)(45,null,$)):($=Math.floor(p/y),b?$===1?u?(0,i.localize)(46,null,$):(0,i.localize)(47,null,$):u?(0,i.localize)(48,null,$):(0,i.localize)(49,null,$):$===1?u?(0,i.localize)(50,null,$):(0,i.localize)(51,null,$):u?(0,i.localize)(52,null,$):(0,i.localize)(53,null,$))}function h(g,b){const u=Math.abs(g/1e3);return u<1?b?(0,i.localize)(54,null,g):(0,i.localize)(55,null,g):u<o?b?(0,i.localize)(56,null,Math.round(g)/1e3):(0,i.localize)(57,null,Math.round(g)/1e3):u<E?b?(0,i.localize)(58,null,Math.round(g/(1e3*o))):(0,i.localize)(59,null,Math.round(g/(1e3*o))):u<D?b?(0,i.localize)(60,null,Math.round(g/(1e3*E))):(0,i.localize)(61,null,Math.round(g/(1e3*E))):(0,i.localize)(62,null,Math.round(g/(1e3*D)))}function d(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[155],le([11,10]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(ce[53],le([0,1,22,12,155]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=y,e.$qj=c,e.$rj=h,i=Ae(i),o=Ae(o),E=Ae(E);function D(d,g){return g&&(d.stack||d.stacktrace)?E.localize(0,null,P(d),R(d.stack)||R(d.stacktrace)):P(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function P(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?E.localize(1,null,d.message):d.message||E.localize(2,null)}function y(d=null,g=!1){if(!d)return E.localize(3,null);if(Array.isArray(d)){const b=i.$Ib(d),u=y(b[0],g);return b.length>1?E.localize(4,null,u,b.length):u}if(o.$eg(d))return d;if(d.detail){const b=d.detail;if(b.error)return D(b.error,g);if(b.exception)return D(b.exception,g)}return d.stack?D(d,g):d.message?d.message:E.localize(5,null)}function c(d){const g=d;return g instanceof Error&&Array.isArray(g.actions)}function h(d,g){let b;return typeof d=="string"?b=new Error(d):b=d,b.actions=g,b}}),define(ce[156],le([11,10]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(ce[157],le([0,1,156,40]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=E;function E(D){switch(D){case o.ParseErrorCode.InvalidSymbol:return(0,i.localize)(0,null);case o.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(1,null);case o.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(2,null);case o.ParseErrorCode.ValueExpected:return(0,i.localize)(3,null);case o.ParseErrorCode.ColonExpected:return(0,i.localize)(4,null);case o.ParseErrorCode.CommaExpected:return(0,i.localize)(5,null);case o.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(6,null);case o.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(7,null);case o.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(8,null);default:return""}}}),define(ce[158],le([11,10]),function(V,e){return V.create("vs/base/common/platform",e)}),define(ce[4],le([0,1,158]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=n,e.$D=I,e.$J=O,i=Ae(i),e.$g="en";let o=!1,E=!1,D=!1,R=!1,P=!1,y=!1,c=!1,h=!1,d=!1,g=!1,b,u=e.$g,m=e.$g,p,$;const w=globalThis;let v;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?v=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const S=typeof v?.versions?.electron=="string",r=S&&v?.type==="renderer";if(typeof v=="object"){o=v.platform==="win32",E=v.platform==="darwin",D=v.platform==="linux",R=D&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,c=S,d=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$g,u=e.$g;const L=v.env.VSCODE_NLS_CONFIG;if(L)try{const T=JSON.parse(L),A=T.availableLanguages["*"];b=T.locale,m=T.osLocale,u=A||e.$g,p=T._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!r?($=navigator.userAgent,o=$.indexOf("Windows")>=0,E=$.indexOf("Macintosh")>=0,h=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=$.indexOf("Linux")>=0,g=$?.indexOf("Mobi")>=0,y=!0,b=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,u=b,m=navigator.language):console.error("Unable to resolve platform.");var t;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(t||(e.Platform=t={}));function n(L){switch(L){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let a=t.Web;E?a=t.Mac:o?a=t.Windows:D&&(a=t.Linux),e.$i=o,e.$j=E,e.$k=D,e.$l=R,e.$m=P,e.$n=c,e.$o=y,e.$p=y&&typeof w.importScripts=="function",e.$q=e.$p?w.origin:void 0,e.$r=h,e.$s=g,e.$t=d,e.$u=a,e.$v=$,e.$w=u;var s;(function(L){function T(){return e.$w}L.value=T;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}L.isDefaultVariant=A;function M(){return e.$w==="en"}L.isDefault=M})(s||(e.Language=s={})),e.$x=b,e.$y=m,e.$z=p,e.$A=typeof w.postMessage=="function"&&!w.importScripts,e.$B=(()=>{if(e.$A){const L=[];w.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let M=0,z=L.length;M<z;M++){const C=L[M];if(C.id===A.data.vscodeScheduleAsyncWork){L.splice(M,1),C.callback();return}}});let T=0;return A=>{const M=++T;L.push({id:M,callback:A}),w.postMessage({vscodeScheduleAsyncWork:M},"*")}}return L=>setTimeout(L)})();var l;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=E||h?l.Macintosh:o?l.Windows:l.Linux;let f=!0,k=!1;function I(){if(!k){k=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,f=new Uint16Array(L.buffer)[0]===513}return f}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function O(L){return parseFloat(L)>=20}}),define(ce[36],le([0,1,4]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let o;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const D=E.process;o={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?o={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:o={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=o.cwd,e.env=o.env,e.$ec=o.platform,e.$fc=o.arch}),define(ce[9],le([0,1,36]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,i=Ae(i);const o=65,E=97,D=90,R=122,P=46,y=47,c=92,h=58,d=63;class g extends Error{constructor(n,a,s){let l;typeof a=="string"&&a.indexOf("not ")===0?(l="must not be",a=a.replace(/^not /,"")):l="must be";const f=n.indexOf(".")!==-1?"property":"argument";let k=`The "${n}" ${f} ${l} of type ${a}`;k+=`. Received type ${typeof s}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function b(t,n){if(t===null||typeof t!="object")throw new g(n,"Object",t)}function u(t,n){if(typeof t!="string")throw new g(n,"string",t)}const m=i.$ec==="win32";function p(t){return t===y||t===c}function $(t){return t===y}function w(t){return t>=o&&t<=D||t>=E&&t<=R}function v(t,n,a,s){let l="",f=0,k=-1,I=0,O=0;for(let L=0;L<=t.length;++L){if(L<t.length)O=t.charCodeAt(L);else{if(s(O))break;O=y}if(s(O)){if(!(k===L-1||I===1))if(I===2){if(l.length<2||f!==2||l.charCodeAt(l.length-1)!==P||l.charCodeAt(l.length-2)!==P){if(l.length>2){const T=l.lastIndexOf(a);T===-1?(l="",f=0):(l=l.slice(0,T),f=l.length-1-l.lastIndexOf(a)),k=L,I=0;continue}else if(l.length!==0){l="",f=0,k=L,I=0;continue}}n&&(l+=l.length>0?`${a}..`:"..",f=2)}else l.length>0?l+=`${a}${t.slice(k+1,L)}`:l=t.slice(k+1,L),f=L-k-1;k=L,I=0}else O===P&&I!==-1?++I:I=-1}return l}function S(t,n){b(n,"pathObject");const a=n.dir||n.root,s=n.base||`${n.name||""}${n.ext||""}`;return a?a===n.root?`${a}${s}`:`${a}${t}${s}`:s}e.$gc={resolve(...t){let n="",a="",s=!1;for(let l=t.length-1;l>=-1;l--){let f;if(l>=0){if(f=t[l],u(f,"path"),f.length===0)continue}else n.length===0?f=i.cwd():(f=i.env[`=${n}`]||i.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==n.toLowerCase()&&f.charCodeAt(2)===c)&&(f=`${n}\\`));const k=f.length;let I=0,O="",L=!1;const T=f.charCodeAt(0);if(k===1)p(T)&&(I=1,L=!0);else if(p(T))if(L=!0,p(f.charCodeAt(1))){let A=2,M=A;for(;A<k&&!p(f.charCodeAt(A));)A++;if(A<k&&A!==M){const z=f.slice(M,A);for(M=A;A<k&&p(f.charCodeAt(A));)A++;if(A<k&&A!==M){for(M=A;A<k&&!p(f.charCodeAt(A));)A++;(A===k||A!==M)&&(O=`\\\\${z}\\${f.slice(M,A)}`,I=A)}}}else I=1;else w(T)&&f.charCodeAt(1)===h&&(O=f.slice(0,2),I=2,k>2&&p(f.charCodeAt(2))&&(L=!0,I=3));if(O.length>0)if(n.length>0){if(O.toLowerCase()!==n.toLowerCase())continue}else n=O;if(s){if(n.length>0)break}else if(a=`${f.slice(I)}\\${a}`,s=L,L&&n.length>0)break}return a=v(a,!s,"\\",p),s?`${n}\\${a}`:`${n}${a}`||"."},normalize(t){u(t,"path");const n=t.length;if(n===0)return".";let a=0,s,l=!1;const f=t.charCodeAt(0);if(n===1)return $(f)?"\\":t;if(p(f))if(l=!0,p(t.charCodeAt(1))){let I=2,O=I;for(;I<n&&!p(t.charCodeAt(I));)I++;if(I<n&&I!==O){const L=t.slice(O,I);for(O=I;I<n&&p(t.charCodeAt(I));)I++;if(I<n&&I!==O){for(O=I;I<n&&!p(t.charCodeAt(I));)I++;if(I===n)return`\\\\${L}\\${t.slice(O)}\\`;I!==O&&(s=`\\\\${L}\\${t.slice(O,I)}`,a=I)}}}else a=1;else w(f)&&t.charCodeAt(1)===h&&(s=t.slice(0,2),a=2,n>2&&p(t.charCodeAt(2))&&(l=!0,a=3));let k=a<n?v(t.slice(a),!l,"\\",p):"";return k.length===0&&!l&&(k="."),k.length>0&&p(t.charCodeAt(n-1))&&(k+="\\"),s===void 0?l?`\\${k}`:k:l?`${s}\\${k}`:`${s}${k}`},isAbsolute(t){u(t,"path");const n=t.length;if(n===0)return!1;const a=t.charCodeAt(0);return p(a)||n>2&&w(a)&&t.charCodeAt(1)===h&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,a;for(let f=0;f<t.length;++f){const k=t[f];u(k,"path"),k.length>0&&(n===void 0?n=a=k:n+=`\\${k}`)}if(n===void 0)return".";let s=!0,l=0;if(typeof a=="string"&&p(a.charCodeAt(0))){++l;const f=a.length;f>1&&p(a.charCodeAt(1))&&(++l,f>2&&(p(a.charCodeAt(2))?++l:s=!1))}if(s){for(;l<n.length&&p(n.charCodeAt(l));)l++;l>=2&&(n=`\\${n.slice(l)}`)}return e.$gc.normalize(n)},relative(t,n){if(u(t,"from"),u(n,"to"),t===n)return"";const a=e.$gc.resolve(t),s=e.$gc.resolve(n);if(a===s||(t=a.toLowerCase(),n=s.toLowerCase(),t===n))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===c;)l++;let f=t.length;for(;f-1>l&&t.charCodeAt(f-1)===c;)f--;const k=f-l;let I=0;for(;I<n.length&&n.charCodeAt(I)===c;)I++;let O=n.length;for(;O-1>I&&n.charCodeAt(O-1)===c;)O--;const L=O-I,T=k<L?k:L;let A=-1,M=0;for(;M<T;M++){const C=t.charCodeAt(l+M);if(C!==n.charCodeAt(I+M))break;C===c&&(A=M)}if(M!==T){if(A===-1)return s}else{if(L>T){if(n.charCodeAt(I+M)===c)return s.slice(I+M+1);if(M===2)return s.slice(I+M)}k>T&&(t.charCodeAt(l+M)===c?A=M:M===2&&(A=3)),A===-1&&(A=0)}let z="";for(M=l+A+1;M<=f;++M)(M===f||t.charCodeAt(M)===c)&&(z+=z.length===0?"..":"\\..");return I+=A,z.length>0?`${z}${s.slice(I,O)}`:(s.charCodeAt(I)===c&&++I,s.slice(I,O))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$gc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===c){if(n.charCodeAt(1)===c){const a=n.charCodeAt(2);if(a!==d&&a!==P)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(w(n.charCodeAt(0))&&n.charCodeAt(1)===h&&n.charCodeAt(2)===c)return`\\\\?\\${n}`;return t},dirname(t){u(t,"path");const n=t.length;if(n===0)return".";let a=-1,s=0;const l=t.charCodeAt(0);if(n===1)return p(l)?t:".";if(p(l)){if(a=s=1,p(t.charCodeAt(1))){let I=2,O=I;for(;I<n&&!p(t.charCodeAt(I));)I++;if(I<n&&I!==O){for(O=I;I<n&&p(t.charCodeAt(I));)I++;if(I<n&&I!==O){for(O=I;I<n&&!p(t.charCodeAt(I));)I++;if(I===n)return t;I!==O&&(a=s=I+1)}}}}else w(l)&&t.charCodeAt(1)===h&&(a=n>2&&p(t.charCodeAt(2))?3:2,s=a);let f=-1,k=!0;for(let I=n-1;I>=s;--I)if(p(t.charCodeAt(I))){if(!k){f=I;break}}else k=!1;if(f===-1){if(a===-1)return".";f=a}return t.slice(0,f)},basename(t,n){n!==void 0&&u(n,"ext"),u(t,"path");let a=0,s=-1,l=!0,f;if(t.length>=2&&w(t.charCodeAt(0))&&t.charCodeAt(1)===h&&(a=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let k=n.length-1,I=-1;for(f=t.length-1;f>=a;--f){const O=t.charCodeAt(f);if(p(O)){if(!l){a=f+1;break}}else I===-1&&(l=!1,I=f+1),k>=0&&(O===n.charCodeAt(k)?--k===-1&&(s=f):(k=-1,s=I))}return a===s?s=I:s===-1&&(s=t.length),t.slice(a,s)}for(f=t.length-1;f>=a;--f)if(p(t.charCodeAt(f))){if(!l){a=f+1;break}}else s===-1&&(l=!1,s=f+1);return s===-1?"":t.slice(a,s)},extname(t){u(t,"path");let n=0,a=-1,s=0,l=-1,f=!0,k=0;t.length>=2&&t.charCodeAt(1)===h&&w(t.charCodeAt(0))&&(n=s=2);for(let I=t.length-1;I>=n;--I){const O=t.charCodeAt(I);if(p(O)){if(!f){s=I+1;break}continue}l===-1&&(f=!1,l=I+1),O===P?a===-1?a=I:k!==1&&(k=1):a!==-1&&(k=-1)}return a===-1||l===-1||k===0||k===1&&a===l-1&&a===s+1?"":t.slice(a,l)},format:S.bind(null,"\\"),parse(t){u(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const a=t.length;let s=0,l=t.charCodeAt(0);if(a===1)return p(l)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(p(l)){if(s=1,p(t.charCodeAt(1))){let A=2,M=A;for(;A<a&&!p(t.charCodeAt(A));)A++;if(A<a&&A!==M){for(M=A;A<a&&p(t.charCodeAt(A));)A++;if(A<a&&A!==M){for(M=A;A<a&&!p(t.charCodeAt(A));)A++;A===a?s=A:A!==M&&(s=A+1)}}}}else if(w(l)&&t.charCodeAt(1)===h){if(a<=2)return n.root=n.dir=t,n;if(s=2,p(t.charCodeAt(2))){if(a===3)return n.root=n.dir=t,n;s=3}}s>0&&(n.root=t.slice(0,s));let f=-1,k=s,I=-1,O=!0,L=t.length-1,T=0;for(;L>=s;--L){if(l=t.charCodeAt(L),p(l)){if(!O){k=L+1;break}continue}I===-1&&(O=!1,I=L+1),l===P?f===-1?f=L:T!==1&&(T=1):f!==-1&&(T=-1)}return I!==-1&&(f===-1||T===0||T===1&&f===I-1&&f===k+1?n.base=n.name=t.slice(k,I):(n.name=t.slice(k,f),n.base=t.slice(k,I),n.ext=t.slice(f,I))),k>0&&k!==s?n.dir=t.slice(0,k-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const r=(()=>{if(m){const t=/\\/g;return()=>{const n=i.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>i.cwd()})();e.$hc={resolve(...t){let n="",a=!1;for(let s=t.length-1;s>=-1&&!a;s--){const l=s>=0?t[s]:r();u(l,"path"),l.length!==0&&(n=`${l}/${n}`,a=l.charCodeAt(0)===y)}return n=v(n,!a,"/",$),a?`/${n}`:n.length>0?n:"."},normalize(t){if(u(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===y,a=t.charCodeAt(t.length-1)===y;return t=v(t,!n,"/",$),t.length===0?n?"/":a?"./":".":(a&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return u(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let n;for(let a=0;a<t.length;++a){const s=t[a];u(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.$hc.normalize(n)},relative(t,n){if(u(t,"from"),u(n,"to"),t===n||(t=e.$hc.resolve(t),n=e.$hc.resolve(n),t===n))return"";const a=1,s=t.length,l=s-a,f=1,k=n.length-f,I=l<k?l:k;let O=-1,L=0;for(;L<I;L++){const A=t.charCodeAt(a+L);if(A!==n.charCodeAt(f+L))break;A===y&&(O=L)}if(L===I)if(k>I){if(n.charCodeAt(f+L)===y)return n.slice(f+L+1);if(L===0)return n.slice(f+L)}else l>I&&(t.charCodeAt(a+L)===y?O=L:L===0&&(O=0));let T="";for(L=a+O+1;L<=s;++L)(L===s||t.charCodeAt(L)===y)&&(T+=T.length===0?"..":"/..");return`${T}${n.slice(f+O)}`},toNamespacedPath(t){return t},dirname(t){if(u(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===y;let a=-1,s=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===y){if(!s){a=l;break}}else s=!1;return a===-1?n?"/":".":n&&a===1?"//":t.slice(0,a)},basename(t,n){n!==void 0&&u(n,"ext"),u(t,"path");let a=0,s=-1,l=!0,f;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let k=n.length-1,I=-1;for(f=t.length-1;f>=0;--f){const O=t.charCodeAt(f);if(O===y){if(!l){a=f+1;break}}else I===-1&&(l=!1,I=f+1),k>=0&&(O===n.charCodeAt(k)?--k===-1&&(s=f):(k=-1,s=I))}return a===s?s=I:s===-1&&(s=t.length),t.slice(a,s)}for(f=t.length-1;f>=0;--f)if(t.charCodeAt(f)===y){if(!l){a=f+1;break}}else s===-1&&(l=!1,s=f+1);return s===-1?"":t.slice(a,s)},extname(t){u(t,"path");let n=-1,a=0,s=-1,l=!0,f=0;for(let k=t.length-1;k>=0;--k){const I=t.charCodeAt(k);if(I===y){if(!l){a=k+1;break}continue}s===-1&&(l=!1,s=k+1),I===P?n===-1?n=k:f!==1&&(f=1):n!==-1&&(f=-1)}return n===-1||s===-1||f===0||f===1&&n===s-1&&n===a+1?"":t.slice(n,s)},format:S.bind(null,"/"),parse(t){u(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const a=t.charCodeAt(0)===y;let s;a?(n.root="/",s=1):s=0;let l=-1,f=0,k=-1,I=!0,O=t.length-1,L=0;for(;O>=s;--O){const T=t.charCodeAt(O);if(T===y){if(!I){f=O+1;break}continue}k===-1&&(I=!1,k=O+1),T===P?l===-1?l=O:L!==1&&(L=1):l!==-1&&(L=-1)}if(k!==-1){const T=f===0&&a?1:f;l===-1||L===0||L===1&&l===k-1&&l===f+1?n.base=n.name=t.slice(T,k):(n.name=t.slice(T,l),n.base=t.slice(T,k),n.ext=t.slice(l,k))}return f>0?n.dir=t.slice(0,f-1):a&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=m?e.$gc.normalize:e.$hc.normalize,e.$jc=m?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=m?e.$gc.join:e.$hc.join,e.$lc=m?e.$gc.resolve:e.$hc.resolve,e.$mc=m?e.$gc.relative:e.$hc.relative,e.$nc=m?e.$gc.dirname:e.$hc.dirname,e.$oc=m?e.$gc.basename:e.$hc.basename,e.$pc=m?e.$gc.extname:e.$hc.extname,e.$qc=m?e.$gc.format:e.$hc.format,e.$rc=m?e.$gc.parse:e.$hc.parse,e.$sc=m?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=m?e.$gc.sep:e.$hc.sep,e.$uc=m?e.$gc.delimiter:e.$hc.delimiter}),define(ce[31],le([0,1,39,9,4,26,12]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=P,e.$xg=y,e.$yg=c,e.$zg=h,e.$Ag=d,e.$Bg=m,e.$Cg=p,e.$Dg=$,e.$Eg=w,e.$Fg=v,e.$Gg=S,e.$Hg=r,e.$Ig=t,e.$Jg=n,e.$Kg=a,e.$Lg=s,e.$Mg=k;function P(I){return I===i.CharCode.Slash||I===i.CharCode.Backslash}function y(I){return I.replace(/[\\/]/g,o.$hc.sep)}function c(I){return I.indexOf("/")===-1&&(I=y(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function h(I,O=o.$hc.sep){if(!I)return"";const L=I.length,T=I.charCodeAt(0);if(P(T)){if(P(I.charCodeAt(1))&&!P(I.charCodeAt(2))){let M=3;const z=M;for(;M<L&&!P(I.charCodeAt(M));M++);if(z!==M&&!P(I.charCodeAt(M+1))){for(M+=1;M<L;M++)if(P(I.charCodeAt(M)))return I.slice(0,M+1).replace(/[\\/]/g,O)}}return O}else if(w(T)&&I.charCodeAt(1)===i.CharCode.Colon)return P(I.charCodeAt(2))?I.slice(0,2)+O:I.slice(0,2);let A=I.indexOf("://");if(A!==-1){for(A+=3;A<L;A++)if(P(I.charCodeAt(A)))return I.slice(0,A+1)}return""}function d(I){if(!E.$i||!I||I.length<5)return!1;let O=I.charCodeAt(0);if(O!==i.CharCode.Backslash||(O=I.charCodeAt(1),O!==i.CharCode.Backslash))return!1;let L=2;const T=L;for(;L<I.length&&(O=I.charCodeAt(L),O!==i.CharCode.Backslash);L++);return!(T===L||(O=I.charCodeAt(L+1),isNaN(O)||O===i.CharCode.Backslash))}const g=/[\\/:\*\?"<>\|]/g,b=/[/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(I,O=E.$i){const L=O?g:b;return!(!I||I.length===0||/^\s+$/.test(I)||(L.lastIndex=0,L.test(I))||O&&u.test(I)||I==="."||I===".."||O&&I[I.length-1]==="."||O&&I.length!==I.trim().length||I.length>255)}function p(I,O,L){const T=I===O;return!L||T?T:!I||!O?!1:(0,D.$Ff)(I,O)}function $(I,O,L,T=o.sep){if(I===O)return!0;if(!I||!O||O.length>I.length)return!1;if(L){if(!(0,D.$Gf)(I,O))return!1;if(O.length===I.length)return!0;let M=O.length;return O.charAt(O.length-1)===T&&M--,I.charAt(M)===T}return O.charAt(O.length-1)!==T&&(O+=T),I.indexOf(O)===0}function w(I){return I>=i.CharCode.A&&I<=i.CharCode.Z||I>=i.CharCode.a&&I<=i.CharCode.z}function v(I,O){return E.$i&&I.endsWith(":")&&(I+=o.sep),(0,o.$jc)(I)||(I=(0,o.$kc)(O,I)),I=(0,o.$ic)(I),S(I)}function S(I){return E.$i?(I=(0,D.$nf)(I,o.sep),I.endsWith(":")&&(I+=o.sep)):(I=(0,D.$nf)(I,o.sep),I||(I=o.sep)),I}function r(I){const O=(0,o.$ic)(I);return E.$i?I.length>3?!1:t(O)&&(I.length===2||O.charCodeAt(2)===i.CharCode.Backslash):O===o.$hc.sep}function t(I,O=E.$i){return O?w(I.charCodeAt(0))&&I.charCodeAt(1)===i.CharCode.Colon:!1}function n(I,O=E.$i){return t(I,O)?I[0]:void 0}function a(I,O,L){return O.length>I.length?-1:I===O?0:(L&&(I=I.toLowerCase(),O=O.toLowerCase()),I.indexOf(O))}function s(I){const O=I.split(":");let L,T,A;for(const M of O){const z=Number(M);(0,R.$ig)(z)?T===void 0?T=z:A===void 0&&(A=z):L=L?[L,M].join(":"):M}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:T!==void 0?T:void 0,column:A!==void 0?A:T!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(I,O,L=8){let T="";for(let M=0;M<L;M++){let z;M===0&&E.$i&&!O&&(L===3||L===4)?z=f:z=l,T+=z.charAt(Math.floor(Math.random()*z.length))}let A;return O?A=`${O}-${T}`:A=T,I?(0,o.$kc)(I,A):A}}),define(ce[80],le([0,1,4]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=D,e.$km=R;var o;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(o||(e.Source=o={}));var E;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function D(P,...y){const c=y.reduce((g,b)=>(g[b]=!0,g),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(g=>!c[g]).forEach(g=>{for(let b=0;b<h.length;b++)if(g.search(h[b])!==-1){delete P[g];break}})}function R(P){P&&(delete P.DEBUG,i.$j&&delete P.DYLD_LIBRARY_PATH,i.$k&&delete P.LD_PRELOAD)}}),define(ce[7],le([0,1,39,90,9,4]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=p,e.$xc=t,E=Ae(E);const R=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function c(f,k){if(!f.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!R.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!P.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(f,k){return!f&&!k?"file":f}function d(f,k){switch(f){case"https":case"http":case"file":k?k[0]!==b&&(k=b+k):k=b;break}return k}const g="",b="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(k){return k instanceof m?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,I,O,L,T,A=!1){typeof k=="object"?(this.scheme=k.scheme||g,this.authority=k.authority||g,this.path=k.path||g,this.query=k.query||g,this.fragment=k.fragment||g):(this.scheme=h(k,A),this.authority=I||g,this.path=d(this.scheme,O||g),this.query=L||g,this.fragment=T||g,c(this,A))}get fsPath(){return t(this,!1)}with(k){if(!k)return this;let{scheme:I,authority:O,path:L,query:T,fragment:A}=k;return I===void 0?I=this.scheme:I===null&&(I=g),O===void 0?O=this.authority:O===null&&(O=g),L===void 0?L=this.path:L===null&&(L=g),T===void 0?T=this.query:T===null&&(T=g),A===void 0?A=this.fragment:A===null&&(A=g),I===this.scheme&&O===this.authority&&L===this.path&&T===this.query&&A===this.fragment?this:new w(I,O,L,T,A)}static parse(k,I=!1){const O=u.exec(k);return O?new w(O[2]||g,l(O[4]||g),l(O[5]||g),l(O[7]||g),l(O[9]||g),I):new w(g,g,g,g,g)}static file(k){let I=g;if(D.$i&&(k=k.replace(/\\/g,b)),k[0]===b&&k[1]===b){const O=k.indexOf(b,2);O===-1?(I=k.substring(2),k=b):(I=k.substring(2,O),k=k.substring(O)||b)}return new w("file",I,k,g,g)}static from(k,I){return new w(k.scheme,k.authority,k.path,k.query,k.fragment,I)}static joinPath(k,...I){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return D.$i&&k.scheme==="file"?O=m.file(E.$gc.join(t(k,!0),...I)).path:O=E.$hc.join(k.path,...I),k.with({path:O})}toString(k=!1){return n(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof m)return k;{const I=new w(k);return I._formatted=k.external??null,I._fsPath=k._sep===$?k.fsPath??null:null,I}}else return k}}e.URI=m;function p(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}const $=D.$i?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(k=!1){return k?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const k={$mid:o.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=$),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const v={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function S(f,k,I){let O,L=-1;for(let T=0;T<f.length;T++){const A=f.charCodeAt(T);if(A>=i.CharCode.a&&A<=i.CharCode.z||A>=i.CharCode.A&&A<=i.CharCode.Z||A>=i.CharCode.Digit0&&A<=i.CharCode.Digit9||A===i.CharCode.Dash||A===i.CharCode.Period||A===i.CharCode.Underline||A===i.CharCode.Tilde||k&&A===i.CharCode.Slash||I&&A===i.CharCode.OpenSquareBracket||I&&A===i.CharCode.CloseSquareBracket||I&&A===i.CharCode.Colon)L!==-1&&(O+=encodeURIComponent(f.substring(L,T)),L=-1),O!==void 0&&(O+=f.charAt(T));else{O===void 0&&(O=f.substr(0,T));const M=v[A];M!==void 0?(L!==-1&&(O+=encodeURIComponent(f.substring(L,T)),L=-1),O+=M):L===-1&&(L=T)}}return L!==-1&&(O+=encodeURIComponent(f.substring(L))),O!==void 0?O:f}function r(f){let k;for(let I=0;I<f.length;I++){const O=f.charCodeAt(I);O===i.CharCode.Hash||O===i.CharCode.QuestionMark?(k===void 0&&(k=f.substr(0,I)),k+=v[O]):k!==void 0&&(k+=f[I])}return k!==void 0?k:f}function t(f,k){let I;return f.authority&&f.path.length>1&&f.scheme==="file"?I=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===i.CharCode.Slash&&(f.path.charCodeAt(1)>=i.CharCode.A&&f.path.charCodeAt(1)<=i.CharCode.Z||f.path.charCodeAt(1)>=i.CharCode.a&&f.path.charCodeAt(1)<=i.CharCode.z)&&f.path.charCodeAt(2)===i.CharCode.Colon?k?I=f.path.substr(1):I=f.path[1].toLowerCase()+f.path.substr(2):I=f.path,D.$i&&(I=I.replace(/\//g,"\\")),I}function n(f,k){const I=k?r:S;let O="",{scheme:L,authority:T,path:A,query:M,fragment:z}=f;if(L&&(O+=L,O+=":"),(T||L==="file")&&(O+=b,O+=b),T){let C=T.indexOf("@");if(C!==-1){const B=T.substr(0,C);T=T.substr(C+1),C=B.lastIndexOf(":"),C===-1?O+=I(B,!1,!1):(O+=I(B.substr(0,C),!1,!1),O+=":",O+=I(B.substr(C+1),!1,!0)),O+="@"}T=T.toLowerCase(),C=T.lastIndexOf(":"),C===-1?O+=I(T,!1,!0):(O+=I(T.substr(0,C),!1,!0),O+=T.substr(C))}if(A){if(A.length>=3&&A.charCodeAt(0)===i.CharCode.Slash&&A.charCodeAt(2)===i.CharCode.Colon){const C=A.charCodeAt(1);C>=i.CharCode.A&&C<=i.CharCode.Z&&(A=`/${String.fromCharCode(C+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===i.CharCode.Colon){const C=A.charCodeAt(0);C>=i.CharCode.A&&C<=i.CharCode.Z&&(A=`${String.fromCharCode(C+32)}:${A.substr(2)}`)}O+=I(A,!0,!1)}return M&&(O+="?",O+=I(M,!1,!1)),z&&(O+="#",O+=k?z:S(z,!1,!1)),O}function a(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+a(f.substr(3)):f}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(f){return f.match(s)?f.replace(s,k=>a(k)):f}}),define(ce[159],le([0,1,7]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=o,e.$0q=E,e.$$q=D,e.log=P;function o(c){const h=c;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function E(c){const h=[];let d;try{const g=JSON.parse(c.arguments),b=g[g.length-1];b&&b.__$stack&&(g.pop(),d=b.__$stack),h.push(...g)}catch{h.push("Unable to log remote console arguments",c.arguments)}return{args:h,stack:d}}function D(c){if(typeof c!="string")return D(E(c).stack);const h=c;if(h){const d=R(h),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(g&&g.length===4)return{uri:i.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}function R(c){if(!c)return c;const h=c.indexOf(`
`);return h===-1?c:c.substring(0,h)}function P(c,h){const{args:d,stack:g}=E(c),b=typeof d[0]=="string"&&d.length===1;let u=R(g);u&&(u=`(${u.trim()})`);let m=[];if(typeof d[0]=="string"?u&&b?m=[`%c[${h}] %c${d[0]} %c${u}`,y("blue"),y(""),y("grey")]:m=[`%c[${h}] %c${d[0]}`,y("blue"),y(""),...d.slice(1)]:m=[`%c[${h}]%`,y("blue"),...d],u&&!b&&m.push(u),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,m)}function y(c){return`color: ${c}`}}),define(ce[81],le([0,1,17,7,90]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=D,e.$ai=R,e.$bi=y;function D(c){return JSON.stringify(c,P)}function R(c){let h=JSON.parse(c);return h=y(h),h}function P(c,h){return h instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:h.source,flags:h.flags}:h}function y(c,h=0){if(!c||h>200)return c;if(typeof c=="object"){switch(c.$mid){case E.MarshalledId.Uri:return o.URI.revive(c);case E.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case E.MarshalledId.Date:return new Date(c.source)}if(c instanceof i.$Ne||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let d=0;d<c.length;++d)c[d]=y(c[d],h+1);else for(const d in c)Object.hasOwnProperty.call(c,d)&&(c[d]=y(c[d],h+1))}return c}}),define(ce[13],le([0,1,16,4,26,7,9]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=y,e.$Og=c,e.$Sg=d,i=Ae(i),o=Ae(o),R=Ae(R);var P;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",u.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.commentsInput="comment",u.codeSetting="code-setting"})(P||(e.Schemas=P={}));function y(u,m){return D.URI.isUri(u)?(0,E.$Ff)(u.scheme,m):(0,E.$Gf)(u,m+":")}function c(u,...m){return m.some(p=>y(u,p))}e.$Pg="vscode-tkn",e.$Qg="tkn";class h{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,p){this.f=d(m,p)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,P.vscodeRemoteResource)}set(m,p,$){this.a[m]=p,this.b[m]=$}setConnectionToken(m,p){this.c[m]=p}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(r){return i.$2(r),m}const p=m.authority;let $=this.a[p];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const w=this.b[p],v=this.c[p];let S=`path=${encodeURIComponent(m.path)}`;return typeof v=="string"&&(S+=`&${e.$Qg}=${encodeURIComponent(v)}`),D.URI.from({scheme:o.$o?this.d:P.vscodeRemoteResource,authority:`${$}:${w}`,path:this.g,query:S})}}e.$Rg=new h;function d(u,m){return R.$hc.join(m??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class g{static{this.a=e.$Xg}asBrowserUri(m){const p=this.b(m,V);return this.uriToBrowserUri(p)}uriToBrowserUri(m){return m.scheme===P.vscodeRemote?e.$Rg.rewrite(m):m.scheme===P.file&&(o.$m||o.$q===`${P.vscodeFileResource}://${g.a}`)?m.with({scheme:P.vscodeFileResource,authority:m.authority||g.a,query:null,fragment:null}):m}asFileUri(m){const p=this.b(m,V);return this.uriToFileUri(p)}uriToFileUri(m){return m.scheme===P.vscodeFileResource?m.with({scheme:P.file,authority:m.authority!==g.a?m.authority:null,query:null,fragment:null}):m}b(m,p){return D.URI.isUri(m)?m:D.URI.parse(p.toUrl(m))}}e.$Yg=new g;var b;(function(u){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(m.get("3"));const p="vscode-coi";function $(v){let S;typeof v=="string"?S=new URL(v).searchParams:v instanceof URL?S=v.searchParams:D.URI.isUri(v)&&(S=new URL(v.toString(!0)).searchParams);const r=S?.get(p);if(r)return m.get(r)}u.getHeadersFromQuery=$;function w(v,S,r){if(!globalThis.crossOriginIsolated)return;const t=S&&r?"3":r?"2":"1";v instanceof URLSearchParams?v.set(p,t):v[p]=t}u.addSearchParam=w})(b||(e.COI=b={}))}),define(ce[19],le([0,1,39,31,13,9,4,26,7]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=c,e.$oh=d,e.$ph=b,o=Ae(o),D=Ae(D);function c(u){return(0,y.$xc)(u,!0)}class h{constructor(m){this.a=m}compare(m,p,$=!1){return m===p?0:(0,P.$yf)(this.getComparisonKey(m,$),this.getComparisonKey(p,$))}isEqual(m,p,$=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,$)===this.getComparisonKey(p,$)}getComparisonKey(m,p=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,p,$=!1){if(m.scheme===p.scheme){if(m.scheme===E.Schemas.file)return o.$Dg(c(m),c(p),this.a(m))&&m.query===p.query&&($||m.fragment===p.fragment);if((0,e.$kh)(m.authority,p.authority))return o.$Dg(m.path,p.path,this.a(m),"/")&&m.query===p.query&&($||m.fragment===p.fragment)}return!1}joinPath(m,...p){return y.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.$ch)(m)||m.authority}basename(m){return D.$hc.basename(m.path)}extname(m){return D.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===E.Schemas.file?p=y.URI.file(D.$nc(c(m))).path:(p=D.$hc.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===E.Schemas.file?p=y.URI.file(D.$ic(c(m))).path:p=D.$hc.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.$kh)(m.authority,p.authority))return;if(m.scheme===E.Schemas.file){const v=D.$mc(c(m),c(p));return R.$i?o.$xg(v):v}let $=m.path||"/";const w=p.path||"/";if(this.a(m)){let v=0;for(const S=Math.min($.length,w.length);v<S&&!($.charCodeAt(v)!==w.charCodeAt(v)&&$.charAt(v).toLowerCase()!==w.charAt(v).toLowerCase());v++);$=w.substr(0,v)+$.substr(v)}return D.$hc.relative($,w)}resolvePath(m,p){if(m.scheme===E.Schemas.file){const $=y.URI.file(D.$lc(c(m),p));return m.with({authority:$.authority,path:$.path})}return p=o.$yg(p),m.with({path:D.$hc.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,P.$Ff)(m,p)}hasTrailingPathSeparator(m,p=D.sep){if(m.scheme===E.Schemas.file){const $=c(m);return $.length>o.$zg($).length&&$[$.length-1]===p}else{const $=m.path;return $.length>1&&$.charCodeAt($.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=D.sep){return(0,e.$lh)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=D.sep){let $=!1;if(m.scheme===E.Schemas.file){const w=c(m);$=w!==void 0&&w.length===o.$zg(w).length&&w[w.length-1]===p}else{p="/";const w=m.path;$=w.length===1&&w.charCodeAt(w.length-1)===i.CharCode.Slash}return!$&&!(0,e.$lh)(m,p)?m.with({path:m.path+"/"}):m}}e.$7g=h,e.$8g=new h(()=>!1),e.$9g=new h(u=>u.scheme===E.Schemas.file?!R.$k:!0),e.$0g=new h(u=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function d(u,m){const p=[];for(let $=0;$<u.length;$++){const w=m(u[$]);u.some((v,S)=>S===$?!1:(0,e.$_g)(w,m(v)))||p.push(u[$])}return p}var g;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function m(p){const $=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(S=>{const[r,t]=S.split(":");r&&t&&$.set(r,t)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&$.set(u.META_DATA_MIME,v),$}u.parseMetaData=m})(g||(e.DataUri=g={}));function b(u,m,p){if(m){let $=u.path;return $&&$[0]!==D.$hc.sep&&($=D.$hc.sep+$),u.with({scheme:p,authority:m,path:$})}return u.with({scheme:p})}}),define(ce[8],le([0,1,23,16,3,2,19,4,146,65]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=h,e.$rh=d,e.$sh=g,e.$th=b,e.$uh=u,e.$vh=m,e.$wh=p,e.$xh=$,e.$Fh=f,e.$Gh=k,e.$Hh=I,e.$Ih=O,e.$Jh=L,e.$Yh=j,e.$7h=q;function h(X){return!!X&&typeof X.then=="function"}function d(X){const Y=new i.$we,ie=X(Y.token),de=new Promise((me,pe)=>{const Ie=Y.token.onCancellationRequested(()=>{Ie.dispose(),pe(new o.$6)});Promise.resolve(ie).then(ke=>{Ie.dispose(),Y.dispose(),me(ke)},ke=>{Ie.dispose(),Y.dispose(),pe(ke)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(me,pe){return de.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function g(X,Y,ie){return new Promise((de,me)=>{const pe=Y.onCancellationRequested(()=>{pe.dispose(),de(ie)});X.then(de,me).finally(()=>pe.dispose())})}function b(X,Y){return new Promise((ie,de)=>{const me=Y.onCancellationRequested(()=>{me.dispose(),de(new o.$6)});X.then(ie,de).finally(()=>me.dispose())})}async function u(X){let Y=-1;const ie=X.map((de,me)=>de.then(pe=>(Y=me,pe)));try{return await Promise.race(ie)}finally{X.forEach((de,me)=>{me!==Y&&de.cancel()})}}function m(X,Y,ie){let de;const me=setTimeout(()=>{de?.(void 0),ie?.()},Y);return Promise.race([X.finally(()=>clearTimeout(me)),new Promise(pe=>de=pe)])}function p(X){return new Promise((Y,ie)=>{const de=X();h(de)?de.then(Y,ie):Y(de)})}function $(){let X,Y;return{promise:new Promise((de,me)=>{X=de,Y=me}),resolve:X,reject:Y}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const ie=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(ie,ie).then(de)})}return new Promise((ie,de)=>{this.b.then(ie,de)})}return this.a=Y(),new Promise((ie,de)=>{this.a.then(me=>{this.a=null,ie(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$yh=w;class v{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$zh=v;class S{constructor(){this.a=new Map}queue(Y,ie){const me=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Y)===me&&this.a.delete(Y)});return this.a.set(Y,me),me}}e.$Ah=S;const r=(X,Y)=>{let ie=!0;const de=setTimeout(()=>{ie=!1,Y()},X);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(de),ie=!1}}},t=X=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,X())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class n{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ie=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=ie===y.$ge?t(de):r(ie,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new o.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=n;class a{constructor(Y){this.a=new n(Y),this.b=new w}trigger(Y,ie){return this.a.trigger(()=>this.b.queue(Y),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=a;class s{constructor(){this.a=!1,this.b=new Promise((Y,ie)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=s;class l extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Eh=l;function f(X,Y){return Y?new Promise((ie,de)=>{const me=setTimeout(()=>{pe.dispose(),ie()},X),pe=Y.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),de(new o.$6)})}):d(ie=>f(X,ie))}function k(X,Y=0,ie){const de=setTimeout(()=>{X(),ie&&me.dispose()},Y),me=(0,D.$Tc)(()=>{clearTimeout(de),ie?.deleteAndLeak(me)});return ie?.add(me),me}function I(X){const Y=[];let ie=0;const de=X.length;function me(){return ie<de?X[ie++]():null}function pe(Ie){Ie!=null&&Y.push(Ie);const ke=me();return ke?ke.then(pe):Promise.resolve(Y)}return Promise.resolve(null).then(pe)}function O(X,Y=de=>!!de,ie=null){let de=0;const me=X.length,pe=()=>{if(de>=me)return Promise.resolve(ie);const Ie=X[de++];return Promise.resolve(Ie()).then(Pe=>Y(Pe)?Promise.resolve(Pe):pe())};return pe()}function L(X,Y=de=>!!de,ie=null){if(X.length===0)return Promise.resolve(ie);let de=X.length;const me=()=>{de=-1;for(const pe of X)pe.cancel?.()};return new Promise((pe,Ie)=>{for(const ke of X)ke.then(Pe=>{--de>=0&&Y(Pe)?(me(),pe(Pe)):de===0&&pe(ie)}).catch(Pe=>{--de>=0&&(me(),Ie(Pe))})})}class T{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new E.$le}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,de)=>{this.g.push({factory:Y,c:ie,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const ie=Y.factory();ie.then(Y.c,Y.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=T;class A extends T{constructor(){super(1)}}e.$Lh=A;class M{constructor(){this.a=new U,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Mh=M;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new G;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,ie=R.$8g){const de=ie.getComparisonKey(Y);return this.a.get(de)?.size??0}queueFor(Y,ie,de=R.$8g){const me=de.getComparisonKey(Y);let pe=this.a.get(me);if(!pe){pe=new A;const Ie=this.f++,ke=E.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$5c),this.d.set(Ie,ke),this.a.set(me,pe)}return pe.queue(ie)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=z;class C{constructor(Y,ie){this.b=!1,this.a=-1,typeof Y=="function"&&typeof ie=="number"&&this.setIfNotSet(Y,ie)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ie){if(this.b)throw new o.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ie)}setIfNotSet(Y,ie){if(this.b)throw new o.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ie))}}e.$Oh=C;class B{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,ie,de=globalThis){if(this.f)throw new o.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{Y()},ie);this.d=(0,D.$Tc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=B;class re{constructor(Y,ie){this.b=-1,this.a=Y,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=re;class _{constructor(Y,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=_;class se extends re{constructor(Y,ie){super(Y,ie),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Sh=se;class K extends D.$Vc{constructor(Y,ie){super(),this.g=Y,this.h=ie,this.a=[],this.b=this.B(new D.$Wc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Y)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(X,Y)=>{(0,P.$B)(()=>{if(ie)return;const de=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$Vh=(X,Y,ie)=>{const de=X.requestIdleCallback(Y,typeof ie=="number"?{timeout:ie}:void 0);let me=!1;return{dispose(){me||(me=!0,X.cancelIdleCallback(de))}}},e.$Uh=X=>(0,e.$Vh)(globalThis,X)}();class ee{constructor(Y,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Vh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ee;class H extends ee{constructor(Y){super(globalThis,Y)}}e.$Xh=H;async function j(X,Y,ie){let de;for(let me=0;me<ie;me++)try{return await X()}catch(pe){de=pe,await f(Y)}throw de}class U{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,ie,de){return this.a={taskId:Y,cancel:()=>de?.(),promise:ie},ie.then(()=>this.d(Y),()=>this.d(Y)),ie}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:ie,resolve:de,reject:me}=$();this.b={run:Y,promise:ie,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=U;class x{constructor(Y,ie=()=>Date.now()){this.d=Y,this.f=ie,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$1h=x;var ae;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(ae||(ae={}));class G{get isRejected(){return this.d?.outcome===ae.Rejected}get isResolved(){return this.d?.outcome===ae.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ae.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,ie)=>{this.a=Y,this.b=ie})}complete(Y){return new Promise(ie=>{this.a(Y),this.d={outcome:ae.Resolved,value:Y},ie()})}error(Y){return new Promise(ie=>{this.b(Y),this.d={outcome:ae.Rejected,value:Y},ie()})}cancel(){return this.error(new o.$6)}}e.$2h=G;var he;(function(X){async function Y(de){let me;const pe=await Promise.all(de.map(Ie=>Ie.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return pe}X.settled=Y;function ie(de){return new Promise(async(me,pe)=>{try{await de(me,pe)}catch(Ie){pe(Ie)}})}X.withAsyncBody=ie})(he||(e.Promises=he={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new o.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=ne;class Z{constructor(Y){this.b=Y,this.a=new c.$W(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=Z;var F;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(F||(F={}));class N{static fromArray(Y){return new N(ie=>{ie.emitMany(Y)})}static fromPromise(Y){return new N(async ie=>{ie.emitMany(await Y)})}static fromPromises(Y){return new N(async ie=>{await Promise.all(Y.map(async de=>ie.emitOne(await de)))})}static merge(Y){return new N(async ie=>{await Promise.all(Y.map(async de=>{for await(const me of de)ie.emitOne(me)}))})}static{this.EMPTY=N.fromArray([])}constructor(Y,ie){this.a=F.Initial,this.b=[],this.d=null,this.f=ie,this.g=new E.$le,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(Y(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===F.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===F.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,ie){return new N(async de=>{for await(const me of Y)de.emitOne(ie(me))})}map(Y){return N.map(this,Y)}static filter(Y,ie){return new N(async de=>{for await(const me of Y)ie(me)&&de.emitOne(me)})}filter(Y){return N.filter(this,Y)}static coalesce(Y){return N.filter(Y,ie=>!!ie)}coalesce(){return N.coalesce(this)}static async toPromise(Y){const ie=[];for await(const de of Y)ie.push(de);return ie}toPromise(){return N.toPromise(this)}h(Y){this.a===F.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===F.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===F.Initial&&(this.a=F.DoneOK,this.g.fire())}l(Y){this.a===F.Initial&&(this.a=F.DoneError,this.d=Y,this.g.fire())}}e.$5h=N;class W extends N{constructor(Y,ie){super(ie),this.m=Y}cancel(){this.m.cancel()}}e.$6h=W;function q(X){const Y=new i.$we,ie=X(Y.token);return new W(Y,async de=>{const me=Y.token.onCancellationRequested(()=>{me.dispose(),Y.dispose(),de.reject(new o.$6)});try{for await(const pe of ie){if(Y.token.isCancellationRequested)return;de.emitOne(pe)}me.dispose(),Y.dispose()}catch(pe){me.dispose(),Y.dispose(),de.reject(pe)}})}class Q{constructor(Y){this.a=new G,this.b=new N(me=>{if(ie){me.reject(ie);return}return de&&me.emitMany(de),this.d=pe=>me.reject(pe),this.f=pe=>me.emitOne(pe),this.a.p},Y);let ie,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{ie||(ie=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$8h=Q}),define(ce[113],le([0,1,22,8,39,31,32,9,4,26]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=h,e.$wk=m,e.$xk=M,e.$yk=z,e.$zk=C,e.$Ak=B,e.$Bk=re,e.$Ck=ee;function h(){return Object.create(null)}e.$uk="**",e.$vk="/";const d="[/\\\\]",g="[^/\\\\]",b=/\//g;function u(H,j){switch(H){case 0:return"";case 1:return`${g}*?`;default:return`(?:${d}|${g}+${d}${j?`|${d}${g}+`:""})*?`}}function m(H,j){if(!H)return[];const U=[];let x=!1,ae=!1,G="";for(const he of H){switch(he){case j:if(!x&&!ae){U.push(G),G="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}G+=he}return G&&U.push(G),U}function p(H){if(!H)return"";let j="";const U=m(H,e.$vk);if(U.every(x=>x===e.$uk))j=".*";else{let x=!1;U.forEach((ae,G)=>{if(ae===e.$uk){if(x)return;j+=u(2,G===U.length-1)}else{let he=!1,ne="",Z=!1,F="";for(const N of ae){if(N!=="}"&&he){ne+=N;continue}if(Z&&(N!=="]"||!F)){let W;N==="-"?W=N:(N==="^"||N==="!")&&!F?W="^":N===e.$vk?W="":W=(0,c.$hf)(N),F+=W;continue}switch(N){case"{":he=!0;continue;case"[":Z=!0;continue;case"}":{const q=`(?:${m(ne,",").map(Q=>p(Q)).join("|")})`;j+=q,he=!1,ne="";break}case"]":{j+="["+F+"]",Z=!1,F="";break}case"?":j+=g;continue;case"*":j+=u(1);continue;default:j+=(0,c.$hf)(N)}}G<U.length-1&&(U[G+1]!==e.$uk||G+2<U.length)&&(j+=d)}x=ae===e.$uk})}return j}const $=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.$Ec(1e4),a=function(){return!1},s=function(){return null};function l(H,j){if(!H)return s;let U;typeof H!="string"?U=H.pattern:U=H,U=U.trim();const x=`${U}_${!!j.trimForExclusions}`;let ae=n.get(x);if(ae)return f(ae,H);let G;return $.test(U)?ae=I(U.substr(4),U):(G=w.exec(k(U,j)))?ae=O(G[1],U):(j.trimForExclusions?S:v).test(U)?ae=L(U,j):(G=r.exec(k(U,j)))?ae=T(G[1].substr(1),U,!0):(G=t.exec(k(U,j)))?ae=T(G[1],U,!1):ae=A(U),n.set(x,ae),f(ae,H)}function f(H,j){if(typeof j=="string")return H;const U=function(x,ae){return(0,D.$Dg)(x,j.base,!y.$k)?H((0,c.$mf)(x.substr(j.base.length),P.sep),ae):null};return U.allBasenames=H.allBasenames,U.allPaths=H.allPaths,U.basenames=H.basenames,U.patterns=H.patterns,U}function k(H,j){return j.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function I(H,j){return function(U,x){return typeof U=="string"&&U.endsWith(H)?j:null}}function O(H,j){const U=`/${H}`,x=`\\${H}`,ae=function(he,ne){return typeof he!="string"?null:ne?ne===H?j:null:he===H||he.endsWith(U)||he.endsWith(x)?j:null},G=[H];return ae.basenames=G,ae.patterns=[j],ae.allBasenames=G,ae}function L(H,j){const U=K(H.slice(1,-1).split(",").map(ne=>l(ne,j)).filter(ne=>ne!==s),H),x=U.length;if(!x)return s;if(x===1)return U[0];const ae=function(ne,Z){for(let F=0,N=U.length;F<N;F++)if(U[F](ne,Z))return H;return null},G=U.find(ne=>!!ne.allBasenames);G&&(ae.allBasenames=G.allBasenames);const he=U.reduce((ne,Z)=>Z.allPaths?ne.concat(Z.allPaths):ne,[]);return he.length&&(ae.allPaths=he),ae}function T(H,j,U){const x=P.sep===P.$hc.sep,ae=x?H:H.replace(b,P.sep),G=P.sep+ae,he=P.$hc.sep+H;let ne;return U?ne=function(Z,F){return typeof Z=="string"&&(Z===ae||Z.endsWith(G)||!x&&(Z===H||Z.endsWith(he)))?j:null}:ne=function(Z,F){return typeof Z=="string"&&(Z===ae||!x&&Z===H)?j:null},ne.allPaths=[(U?"*/":"./")+H],ne}function A(H){try{const j=new RegExp(`^${p(H)}$`);return function(U){return j.lastIndex=0,typeof U=="string"&&j.test(U)?H:null}}catch{return s}}function M(H,j,U){return!H||typeof j!="string"?!1:z(H)(j,void 0,U)}function z(H,j={}){if(!H)return a;if(typeof H=="string"||C(H)){const U=l(H,j);if(U===s)return a;const x=function(ae,G){return!!U(ae,G)};return U.allBasenames&&(x.allBasenames=U.allBasenames),U.allPaths&&(x.allPaths=U.allPaths),x}return _(H,j)}function C(H){const j=H;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function B(H){return H.allBasenames||[]}function re(H){return H.allPaths||[]}function _(H,j){const U=K(Object.getOwnPropertyNames(H).map(ne=>se(ne,H[ne],j)).filter(ne=>ne!==s)),x=U.length;if(!x)return s;if(!U.some(ne=>!!ne.requiresSiblings)){if(x===1)return U[0];const ne=function(N,W){let q;for(let Q=0,X=U.length;Q<X;Q++){const Y=U[Q](N,W);if(typeof Y=="string")return Y;(0,o.$qh)(Y)&&(q||(q=[]),q.push(Y))}return q?(async()=>{for(const Q of q){const X=await Q;if(typeof X=="string")return X}return null})():null},Z=U.find(N=>!!N.allBasenames);Z&&(ne.allBasenames=Z.allBasenames);const F=U.reduce((N,W)=>W.allPaths?N.concat(W.allPaths):N,[]);return F.length&&(ne.allPaths=F),ne}const ae=function(ne,Z,F){let N,W;for(let q=0,Q=U.length;q<Q;q++){const X=U[q];X.requiresSiblings&&F&&(Z||(Z=(0,P.$oc)(ne)),N||(N=Z.substr(0,Z.length-(0,P.$pc)(ne).length)));const Y=X(ne,Z,N,F);if(typeof Y=="string")return Y;(0,o.$qh)(Y)&&(W||(W=[]),W.push(Y))}return W?(async()=>{for(const q of W){const Q=await q;if(typeof Q=="string")return Q}return null})():null},G=U.find(ne=>!!ne.allBasenames);G&&(ae.allBasenames=G.allBasenames);const he=U.reduce((ne,Z)=>Z.allPaths?ne.concat(Z.allPaths):ne,[]);return he.length&&(ae.allPaths=he),ae}function se(H,j,U){if(j===!1)return s;const x=l(H,U);if(x===s)return s;if(typeof j=="boolean")return x;if(j){const ae=j.when;if(typeof ae=="string"){const G=(he,ne,Z,F)=>{if(!F||!x(he,ne))return null;const N=ae.replace("$(basename)",()=>Z),W=F(N);return(0,o.$qh)(W)?W.then(q=>q?H:null):W?H:null};return G.requiresSiblings=!0,G}}return x}function K(H,j){const U=H.filter(ne=>!!ne.basenames);if(U.length<2)return H;const x=U.reduce((ne,Z)=>{const F=Z.basenames;return F?ne.concat(F):ne},[]);let ae;if(j){ae=[];for(let ne=0,Z=x.length;ne<Z;ne++)ae.push(j)}else ae=U.reduce((ne,Z)=>{const F=Z.patterns;return F?ne.concat(F):ne},[]);const G=function(ne,Z){if(typeof ne!="string")return null;if(!Z){let N;for(N=ne.length;N>0;N--){const W=ne.charCodeAt(N-1);if(W===E.CharCode.Slash||W===E.CharCode.Backslash)break}Z=ne.substr(N)}const F=x.indexOf(Z);return F!==-1?ae[F]:null};G.basenames=x,G.patterns=ae,G.allBasenames=x;const he=H.filter(ne=>!ne.basenames);return he.push(G),he}function ee(H,j){return(0,i.$vb)(H,j,(U,x)=>typeof U=="string"&&typeof x=="string"?U===x:typeof U!="string"&&typeof x!="string"?U.base===x.base&&U.pattern===x.pattern:!1)}}),define(ce[48],le([0,1,22,31,9,4,19,26]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=y,e.$Sw=h,e.$Tw=g,e.$Uw=b,e.$Vw=$,e.$Ww=v,e.$Xw=S,e.$Yw=r,e.$Zw=t,e.$1w=n;function y(s,l){const{os:f,tildify:k,relative:I}=l;if(I){const T=c(s,I,f);if(typeof T=="string")return T}let O=s.fsPath;if(f===D.OperatingSystem.Windows&&!D.$i?O=O.replace(/\//g,"\\"):f!==D.OperatingSystem.Windows&&D.$i&&(O=O.replace(/\\/g,"/")),f!==D.OperatingSystem.Windows&&k?.userHome){const T=k.userHome.fsPath;let A;s.scheme!==k.userHome.scheme&&s.path[0]===E.$hc.sep&&s.path[1]!==E.$hc.sep?A=k.userHome.with({path:s.path}).fsPath:A=O,O=g(A,T,f)}return(f===D.OperatingSystem.Windows?E.$gc:E.$hc).normalize(h(O,f===D.OperatingSystem.Windows))}function c(s,l,f){const k=f===D.OperatingSystem.Windows?E.$gc:E.$hc,I=f===D.OperatingSystem.Linux?R.$8g:R.$0g,O=l.getWorkspace(),L=(0,i.$Pb)(O.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===E.$hc.sep&&s.path[1]!==E.$hc.sep&&(s=L.uri.with({path:s.path}));const T=l.getWorkspaceFolder(s);if(!T)return;let A;if(I.isEqual(T.uri,s)?A="":A=I.relativePath(T.uri,s)??"",A&&(A=k.normalize(A)),O.folders.length>1&&!l.noPrefix){const M=T.name?T.name:I.basenameOrAuthority(T.uri);A=A?`${M} \u2022 ${A}`:M}return A}function h(s,l=D.$i){return(0,o.$Ig)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}let d=Object.create(null);function g(s,l,f=D.OS){if(f===D.OperatingSystem.Windows||!s||!l)return s;let k=d.original===l?d.normalized:void 0;k||(k=l,D.$i&&(k=(0,o.$xg)(k)),k=`${(0,P.$nf)(k,E.$hc.sep)}${E.$hc.sep}`,d={original:l,normalized:k});let I=s;return D.$i&&(I=(0,o.$xg)(I)),(f===D.OperatingSystem.Linux?I.startsWith(k):(0,P.$Gf)(I,k))?`~/${I.substr(k.length)}`:s}function b(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}const u="\u2026",m="\\\\",p="~";function $(s,l=E.sep){const f=new Array(s.length);let k=!1;for(let I=0;I<s.length;I++){const O=s[I];if(O===""){f[I]=`.${l}`;continue}if(!O){f[I]=O;continue}k=!0;let L="",T=O;T.indexOf(m)===0?(L=T.substr(0,T.indexOf(m)+m.length),T=T.substr(T.indexOf(m)+m.length)):T.indexOf(l)===0?(L=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length)):T.indexOf(p)===0&&(L=T.substr(0,T.indexOf(p)+p.length),T=T.substr(T.indexOf(p)+p.length));const A=T.split(l);for(let M=1;k&&M<=A.length;M++)for(let z=A.length-M;k&&z>=0;z--){k=!1;let C=A.slice(z,z+M).join(l);for(let B=0;!k&&B<s.length;B++)if(B!==I&&s[B]&&s[B].indexOf(C)>-1){const re=z+M===A.length,_=z>0&&s[B].indexOf(l)>-1?l+C:C,se=s[B].endsWith(_);k=!re||se}if(!k){let B="";(A[0].endsWith(":")||L!=="")&&(z===1&&(z=0,M++,C=A[0]+l+C),z>0&&(B=A[0]+l),B=L+B),z>0&&(B=B+u+l),B=B+C,z+M<A.length&&(B=B+l+u),f[I]=B}}k&&(f[I]=O)}return f}var w;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function v(s,l=Object.create(null)){const f=[];let k=!1,I="";for(const O of s)if(O==="$"||k&&O==="{")I&&f.push({value:I,type:w.TEXT}),I="",k=!0;else if(O==="}"&&k){const L=l[I];if(typeof L=="string")L.length&&f.push({value:L,type:w.VARIABLE});else if(L){const T=f[f.length-1];(!T||T.type!==w.SEPARATOR)&&f.push({value:L.label,type:w.SEPARATOR})}I="",k=!1}else I+=O;return I&&!k&&f.push({value:I,type:w.TEXT}),f.filter((O,L)=>{if(O.type===w.SEPARATOR){const T=f[L-1],A=f[L+1];return[T,A].every(M=>M&&(M.type===w.VARIABLE||M.type===w.TEXT)&&M.value.length>0)}return!0}).map(O=>O.value).join("")}function S(s,l){return D.$j||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):s.replace(/&&|&/g,f=>f==="&"?"&&":"&")}function r(s,l){return D.$j||l?s.replace(/\(&&\w\)|&&/g,""):D.$i?s.replace(/&&|&/g,f=>f==="&"?"&&":"&"):s.replace(/&&/g,"_")}function t(s){return s.replace(/&/g,"&&")}function n(s){if(s.endsWith("]")){const l=s.lastIndexOf(" [",s.length-2);if(l!==-1){const f=a(s.substring(0,l)),k=s.substring(l);return{name:f.name+k,parentPath:f.parentPath}}}return a(s)}function a(s){const l=s.indexOf("/")!==-1?E.$hc:E.$gc,f=l.basename(s),k=l.dirname(s);return f.length?{name:f,parentPath:k}:{name:k,parentPath:""}}}),define(ce[160],le([0,1,17,90,7]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=y,e.$Ln=h,e.$Mn=d;function D(g){return g.toJSON()}class R{constructor(b){this.a=b}transformIncoming(b){const u=this.a.transformIncoming(b);return u===b?b:D(E.URI.from(u))}transformOutgoing(b){const u=this.a.transformOutgoing(b);return u===b?b:D(E.URI.from(u))}transformOutgoingURI(b){const u=this.a.transformOutgoing(b);return u===b?b:E.URI.from(u)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$In=R,e.$Jn=new class{transformIncoming(g){return g}transformOutgoing(g){return g}transformOutgoingURI(g){return g}transformOutgoingScheme(g){return g}};function P(g,b,u){if(!g||u>200)return null;if(typeof g=="object"){if(g instanceof E.URI)return b.transformOutgoing(g);for(const m in g)if(Object.hasOwnProperty.call(g,m)){const p=P(g[m],b,u+1);p!==null&&(g[m]=p)}}return null}function y(g,b){const u=P(g,b,0);return u===null?g:u}function c(g,b,u,m){if(!g||m>200)return null;if(typeof g=="object"){if(g.$mid===o.MarshalledId.Uri)return u?E.URI.revive(b.transformIncoming(g)):b.transformIncoming(g);if(g instanceof i.$Ne)return null;for(const p in g)if(Object.hasOwnProperty.call(g,p)){const $=c(g[p],b,u,m+1);$!==null&&(g[p]=$)}}return null}function h(g,b){const u=c(g,b,!1,0);return u===null?g:u}function d(g,b){const u=c(g,b,!0,0);return u===null?g:u}}),define(ce[93],le([0,1,27,61,33,150,4]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$Pn=y,e.$Qn=d,e.$Rn=g,E=Ae(E),e.$On=new class{c(b){return this.a||(this.a=o.$Ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,u=0;const m=(0,i.networkInterfaces)();for(const p in m){const $=m[p];if($)for(const{mac:w,internal:v}of $)v||(u+=1,this.c(w.toUpperCase())&&(b+=1))}this.b=u>0?b/u:0}return this.b}};let P;async function y(b){return P||(P=(async()=>await c(b)||E.$1g())()),P}async function c(b){try{const u=await new Promise((p,$)=>{V(["crypto"],p,$)}).then(Ae),m=(0,D.$Nn)();return u.createHash("sha256").update(m,"utf8").digest("hex")}catch(u){b(u);return}}const h="Software\\Microsoft\\SQMClient";async function d(b){if(R.$i){const u=await new Promise((m,p)=>{V(["@vscode/windows-registry"],m,p)}).then(Ae);try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(m){return b(m),""}}return""}async function g(b){try{return await(await new Promise((p,$)=>{V(["@vscode/deviceid"],p,$)}).then(Ae)).getDeviceId()}catch(u){return b(u),""}}}),define(ce[21],le([0,1,47,27,161,8,31,77,9,4,19,7]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=v,e.whenDeleted=t,e.configureFlushOnWrite=f,e.writeFileSync=I,i=Ae(i);var g;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(g||(e.RimRafMode=g={}));async function b(_,se=g.UNLINK,K){if((0,R.$Hg)(_))throw new Error("rimraf - will refuse to recursively delete root");return se===g.UNLINK?m(_):u(_,K)}async function u(_,se=(0,R.$Mg)((0,o.tmpdir)())){try{try{await i.promises.rename(_,se)}catch(K){return K.code==="ENOENT"?void 0:m(_)}m(se).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function m(_){return i.promises.rm(_,{recursive:!0,force:!0,maxRetries:3})}function p(_){if((0,R.$Hg)(_))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}async function $(_,se){return S(await(se?w(_):i.promises.readdir(_)))}async function w(_){try{return await i.promises.readdir(_,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const se=[],K=await $(_);for(const ee of K){let H=!1,j=!1,U=!1;try{const x=await e.Promises.lstat((0,y.$kc)(_,ee));H=x.isFile(),j=x.isDirectory(),U=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}se.push({name:ee,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>U})}return se}function v(_){return S(i.readdirSync(_))}function S(_){return _.map(se=>typeof se=="string"?c.$j?(0,P.$lm)(se):se:(se.name=c.$j?(0,P.$lm)(se.name):se.name,se))}async function r(_){const se=await $(_),K=[];for(const ee of se)await n.existsDirectory((0,y.$kc)(_,ee))&&K.push(ee);return K}function t(_,se=1e3){return new Promise(K=>{let ee=!1;const H=setInterval(()=>{ee||(ee=!0,i.access(_,j=>{ee=!1,j&&(clearInterval(H),K(void 0))}))},se)})}var n;(function(_){async function se(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$i&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw x}throw U}}_.stat=se;async function K(H){try{const{stat:j,symbolicLink:U}=await _.stat(H);return j.isFile()&&U?.dangling!==!0}catch{}return!1}_.existsFile=K;async function ee(H){try{const{stat:j,symbolicLink:U}=await _.stat(H);return j.isDirectory()&&U?.dangling!==!0}catch{}return!1}_.existsDirectory=ee})(n||(e.SymlinkSupport=n={}));const a=new D.$Nh;function s(_,se,K){return a.queueFor(d.URI.file(_),()=>{const ee=O(K);return new Promise((H,j)=>k(_,se,ee,U=>U?j(U):H()))},h.$9g)}let l=!0;function f(_){l=_}function k(_,se,K,ee){if(!l)return i.writeFile(_,se,{mode:K.mode,flag:K.flag},ee);i.open(_,K.flag,K.mode,(H,j)=>{if(H)return ee(H);i.writeFile(j,se,U=>{if(U)return i.close(j,()=>ee(U));i.fdatasync(j,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),f(!1)),i.close(j,ae=>ee(ae))))})})}function I(_,se,K){const ee=O(K);if(!l)return i.writeFileSync(_,se,{mode:ee.mode,flag:ee.flag});const H=i.openSync(_,ee.flag,ee.mode);try{i.writeFileSync(H,se);try{i.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),f(!1)}}finally{i.closeSync(H)}}function O(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function L(_,se,K=6e4){if(_!==se)try{c.$i&&typeof K=="number"?await T(_,se,Date.now(),K):await i.promises.rename(_,se)}catch(ee){if(_.toLowerCase()!==se.toLowerCase()&&ee.code==="EXDEV"||_.endsWith("."))await A(_,se,{preserveSymlinks:!1}),await b(_,g.MOVE);else throw ee}}async function T(_,se,K,ee,H=0){try{return await i.promises.rename(_,se)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-K>=ee)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${j}`),j;if(H===0){let U=!1;try{const{stat:x}=await n.stat(se);x.isFile()||(U=!0)}catch{}if(U)throw j}return await(0,D.$Fh)(Math.min(100,H*10)),T(_,se,K,ee,H+1)}}async function A(_,se,K){return z(_,se,{root:{source:_,target:se},options:K,handledSourcePaths:new Set})}const M=511;async function z(_,se,K){if(K.handledSourcePaths.has(_))return;K.handledSourcePaths.add(_);const{stat:ee,symbolicLink:H}=await n.stat(_);if(H){if(K.options.preserveSymlinks)try{return await re(_,se,K)}catch{}if(H.dangling)return}return ee.isDirectory()?C(_,se,ee.mode&M,K):B(_,se,ee.mode&M)}async function C(_,se,K,ee){await e.Promises.mkdir(se,{recursive:!0,mode:K});const H=await $(_);for(const j of H)await z((0,y.$kc)(_,j),(0,y.$kc)(se,j),ee)}async function B(_,se,K){await e.Promises.copyFile(_,se),await e.Promises.chmod(se,K)}async function re(_,se,K){let ee=await e.Promises.readlink(_);(0,R.$Dg)(ee,K.root.source,!c.$k)&&(ee=(0,y.$kc)(K.root.target,ee.substr(K.root.source.length+1))),await e.Promises.symlink(ee,se)}e.Promises=new class{get access(){return i.promises.access}get stat(){return i.promises.stat}get lstat(){return i.promises.lstat}get utimes(){return i.promises.utimes}get read(){return(_,se,K,ee,H)=>new Promise((j,U)=>{i.read(_,se,K,ee,H,(x,ae,G)=>x?U(x):j({bytesRead:ae,buffer:G}))})}get readFile(){return i.promises.readFile}get write(){return(_,se,K,ee,H)=>new Promise((j,U)=>{i.write(_,se,K,ee,H,(x,ae,G)=>x?U(x):j({bytesWritten:ae,buffer:G}))})}get appendFile(){return i.promises.appendFile}get fdatasync(){return(0,E.promisify)(i.fdatasync)}get truncate(){return i.promises.truncate}get copyFile(){return i.promises.copyFile}get open(){return(0,E.promisify)(i.open)}get close(){return(0,E.promisify)(i.close)}get symlink(){return i.promises.symlink}get readlink(){return i.promises.readlink}get chmod(){return i.promises.chmod}get mkdir(){return i.promises.mkdir}get unlink(){return i.promises.unlink}get rmdir(){return i.promises.rmdir}get realpath(){return(0,E.promisify)(i.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return b}get rename(){return L}get copy(){return A}}}),define(ce[114],le([0,1,47,9,4,26,21]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=P,e.$fr=y,e.$gr=c,e.$hr=h,i=Ae(i);function P(g){if(E.$k)return g;const b=(0,o.$nc)(g);if(g===b)return g;const u=((0,o.$oc)(g)||g).toLowerCase();try{const p=(0,R.readdirSync)(b).filter($=>$.toLowerCase()===u);if(p.length===1){const $=P(b);if($)return(0,o.$kc)($,p[0])}else if(p.length>1){const $=p.indexOf(u);if($>=0){const w=P(b);if(w)return(0,o.$kc)(w,p[$])}}}catch{}return null}async function y(g,b){if(E.$k)return g;const u=(0,o.$nc)(g);if(g===u)return g;const m=((0,o.$oc)(g)||g).toLowerCase();try{if(b?.isCancellationRequested)return null;const $=(await R.Promises.readdir(u)).filter(w=>w.toLowerCase()===m);if($.length===1){const w=await y(u,b);if(w)return(0,o.$kc)(w,$[0])}else if($.length>1){const w=$.indexOf(m);if(w>=0){const v=await y(u,b);if(v)return(0,o.$kc)(v,$[w])}}}catch{}return null}async function c(g){try{return await R.Promises.realpath(g)}catch{const u=d(g);return await R.Promises.access(u,i.constants.R_OK),u}}function h(g){try{return i.realpathSync(g)}catch{const u=d(g);return i.accessSync(u,i.constants.R_OK),u}}function d(g){return(0,D.$nf)((0,o.$ic)(g),o.sep)}}),define(ce[115],le([0,1,27,9,21]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=w,e.$vm=v,i=Ae(i),o=Ae(o),E=Ae(E);const D=/^\d+$/,R=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(y||(y={}));let c;switch(process.arch){case"ia32":c=y.x86;break;case"arm":case"arm64":c=y.ARM;break;default:c=y.x64;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?y.ARM:y.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=y.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=y.x86:h=y.x64;class d{constructor(r,t,n){this.exePath=r,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:S=!1}={}){return S?c===y.x64?process.env["ProgramFiles(x86)"]||null:h===y.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:S=!1,findPreview:r=!1}={}){const t=g({useAlternateBitness:S});if(!t)return null;const n=o.$kc(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(n))return null;let a=-1,s=null;for(const k of await E.Promises.readdir(n)){let I=-1;if(r){const L=k.indexOf("-");if(L<0)continue;const T=k.substring(0,L);if(!D.test(T)||k.substring(L+1)!=="preview")continue;I=parseInt(T,10)}else{if(!D.test(k))continue;I=parseInt(k,10)}if(I<=a)continue;const O=o.$kc(n,k,"pwsh.exe");await E.SymlinkSupport.existsFile(O)&&(s=O,a=I)}if(!s)return null;const l=t.includes("x86")?" (x86)":"",f=r?" Preview":"";return new d(s,`PowerShell${f}${l}`,!0)}async function u({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const r=o.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=S?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const a of await E.Promises.readdir(r))if(t.test(a)){const s=o.$kc(r,a,"pwsh.exe");return new d(s,n)}return null}function m(){const S=o.$kc(i.homedir(),".dotnet","tools","pwsh.exe");return new d(S,".NET Core PowerShell Global Tool")}function p(){const S=o.$kc(process.env.windir,c===y.x86&&h!==y.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(S,"Windows PowerShell",!0)}async function*$(){let S=await b();S&&(yield S),S=await b({useAlternateBitness:!0}),S&&(yield S),S=await u(),S&&(yield S),S=m(),S&&(yield S),S=await b({findPreview:!0}),S&&(yield S),S=await u({findPreview:!0}),S&&(yield S),S=await b({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=p(),S&&(yield S)}async function*w(){for await(const S of $())await S.exists()&&(yield S)}async function v(){for await(const S of w())return S;return null}}),define(ce[94],le([0,1,9,4,36,80,12,21]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=y,e.$xm=c,i=Ae(i),o=Ae(o),E=Ae(E),R=Ae(R),P=Ae(P),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function y(d=E.env){return d.comspec||"cmd.exe"}function c(d){let g=[],b=!1;const u=function(m){if(b){g.push(m);return}(!d.send(m,$=>{if($&&console.error($),b=!1,g.length>0){const w=g.slice(0);g=[],w.forEach(v=>u(v))}})||o.$i)&&(b=!0)};return{send:u}}var h;(function(d){async function g(b,u,m){if(i.$jc(b))return b;if(u===void 0&&(u=E.cwd()),i.$nc(b)!=="."||(m===void 0&&R.$eg(E.env.PATH)&&(m=E.env.PATH.split(i.$uc)),m===void 0||m.length===0))return i.$kc(u,b);async function $(w){if(await P.Promises.exists(w)){let v;try{v=await P.Promises.stat(w)}catch(S){S.message.startsWith("EACCES")&&(v=await P.Promises.lstat(w))}return v?!v.isDirectory():!1}return!1}for(const w of m){let v;if(i.$jc(w)?v=i.$kc(w,b):v=i.$kc(u,w,b),await $(v))return v;let S=v+".com";if(await $(S)||(S=v+".exe",await $(S)))return S}return i.$kc(u,b)}d.findExecutable=g})(h||(e.win32=h={}))}),define(ce[116],le([0,1,49,13]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=E;function E(R){return new Promise((P,y)=>{let c;const h=new Map;function d(b,u,m,p,$){const w=h.get(u);if(b===R||w){const v={name:g(m),cmd:m,pid:b,ppid:u,load:p,mem:$};h.set(b,v),b===R&&(c=v),w&&(w.children||(w.children=[]),w.children.push(v),w.children.length>1&&(w.children=w.children.sort((S,r)=>S.pid-r.pid)))}}function g(b){const u=/--utility-sub-type=network/i,m=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec(b))return"electron-crash-reporter";if(p.exec(b))return"winpty-agent";if($.exec(b))return"conpty-agent";let v=w.exec(b);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?u.exec(b)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const S=/[a-zA-Z-]+\.js/g;let r="";do v=S.exec(b),v&&(r+=v+" ");while(v);return r&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron-nodejs (${r})`:b}if(process.platform==="win32"){const b=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,m)=>{V(["@vscode/windows-process-tree"],u,m)}).then(Ae).then(u=>{u.getProcessList(R,m=>{if(!m){y(new Error(`Root process ${R} not found`));return}u.getProcessCpuUsage(m,p=>{const $=new Map;p.forEach(w=>{const v=b(w.commandLine||"");$.set(w.pid,{name:g(v),cmd:v,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),c=$.get(R),c?($.forEach(w=>{const v=$.get(w.ppid);v&&(v.children||(v.children=[]),v.children.push(w))}),$.forEach(w=>{w.children&&(w.children=w.children.sort((v,S)=>v.pid-S.pid))}),P(c)):y(new Error(`Root process ${R} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let b=function(){let u=[c];const m=[];for(;u.length;){const $=u.shift();$&&(m.push($.pid),$.children&&(u=u.concat($.children)))}let p=JSON.stringify(o.$Yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+m.join(" "),(0,i.exec)(p,{},($,w,v)=>{if($||v)y($||new Error(v.toString()));else{const S=w.toString().split(`
`);for(let r=0;r<m.length;r++){const t=h.get(m[r]);t.load=parseFloat(S[r])}if(!c){y(new Error(`Root process ${R} not found`));return}P(c)}})};(0,i.exec)("which ps",{},(u,m,p)=>{if(u||p)if(process.platform!=="linux")y(u||new Error(p.toString()));else{const $=JSON.stringify(o.$Yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)($,{},(w,v,S)=>{w||S?y(w||new Error(S.toString())):(D(v,d),b())})}else{const $=m.toString().trim();(0,i.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,S,r)=>{v||r&&!r.includes("screen size is bogus")?y(v||new Error(r.toString())):(D(S,d),process.platform==="linux"?b():c?P(c):y(new Error(`Root process ${R} not found`)))})}})}})}function D(R,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=R.toString().split(`
`);for(const h of c){const d=y.exec(h.trim());d&&d.length===6&&P(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(ce[117],le([0,1,27,4,115,94]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=R,o=Ae(o),D=Ae(D);async function R(d,g){return d===o.OperatingSystem.Windows?o.$i?h():D.$wm(g):y(d,g)}let P=null;function y(d,g){if(o.$k&&d===o.OperatingSystem.Macintosh||o.$j&&d===o.OperatingSystem.Linux)return"/bin/bash";if(!P){let b;if(o.$i)b="/bin/bash";else{if(b=g.SHELL,!b)try{b=(0,i.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}P=b}return P}let c=null;async function h(){return c||(c=(await(0,E.$vm)()).exePath),c}});var Se=this&&this.__decorate||function(V,e,i,o){var E=arguments.length,D=E<3?e:o===null?o=Object.getOwnPropertyDescriptor(e,i):o,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,i,o);else for(var P=V.length-1;P>=0;P--)(R=V[P])&&(D=(E<3?R(D):E>3?R(e,i,D):R(e,i))||D);return E>3&&D&&Object.defineProperty(e,i,D),D};define(ce[44],le([0,1,22,8,17,23,52,16,3,2,81,26,12]),function(V,e,i,o,E,D,R,P,y,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=f,e.$fi=k,e.$ki=M,e.$li=z,d=Ae(d);var b;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(b||(b={}));function u(H){switch(H){case b.Promise:return"req";case b.PromiseCancel:return"cancel";case b.EventListen:return"subscribe";case b.EventDispose:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m||(m={}));function p(H){switch(H){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var $;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})($||($={}));function w(H){let j=0;for(let U=0;;U+=7){const x=H.read(1);if(j|=(x.buffer[0]&127)<<U,!(x.buffer[0]&128))return j}}const v=a(0);function S(H,j){if(j===0){H.write(v);return}let U=0;for(let ae=j;ae!==0;ae=ae>>>7)U++;const x=E.$Ne.alloc(U);for(let ae=0;j!==0;ae++)x.buffer[ae]=j&127,j=j>>>7,j>0&&(x.buffer[ae]|=128);H.write(x)}class r{constructor(j){this.b=j,this.a=0}read(j){const U=this.b.slice(this.a,this.a+j);return this.a+=U.byteLength,U}}e.$ci=r;class t{constructor(){this.a=[]}get buffer(){return E.$Ne.concat(this.a)}write(j){this.a.push(j)}}e.$di=t;var n;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(n||(n={}));function a(H){const j=E.$Ne.alloc(1);return j.writeUInt8(H,0),j}const s={Undefined:a(n.Undefined),String:a(n.String),Buffer:a(n.Buffer),VSBuffer:a(n.VSBuffer),Array:a(n.Array),Object:a(n.Object),Uint:a(n.Int)},l=typeof Buffer<"u";function f(H,j){if(typeof j>"u")H.write(s.Undefined);else if(typeof j=="string"){const U=E.$Ne.fromString(j);H.write(s.String),S(H,U.byteLength),H.write(U)}else if(l&&Buffer.isBuffer(j)){const U=E.$Ne.wrap(j);H.write(s.Buffer),S(H,U.byteLength),H.write(U)}else if(j instanceof E.$Ne)H.write(s.VSBuffer),S(H,j.byteLength),H.write(j);else if(Array.isArray(j)){H.write(s.Array),S(H,j.length);for(const U of j)f(H,U)}else if(typeof j=="number"&&(j|0)===j)H.write(s.Uint),S(H,j);else{const U=E.$Ne.fromString(JSON.stringify(j));H.write(s.Object),S(H,U.byteLength),H.write(U)}}function k(H){switch(H.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return H.read(w(H)).toString();case n.Buffer:return H.read(w(H)).buffer;case n.VSBuffer:return H.read(w(H));case n.Array:{const U=w(H),x=[];for(let ae=0;ae<U;ae++)x.push(k(H));return x}case n.Object:return JSON.parse(H.read(w(H)).toString());case n.Int:return w(H)}}class I{constructor(j,U,x=null,ae=1e3){this.h=j,this.j=U,this.k=x,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:m.Initialize})}registerChannel(j,U){this.b.set(j,U),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case m.Initialize:{const U=this.o([j.type]);this.k?.logOutgoing(U,0,O.OtherSide,p(j.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const U=this.o([j.type,j.id],j.data);this.k?.logOutgoing(U,j.id,O.OtherSide,p(j.type),j.data);return}}}o(j,U=void 0){const x=new t;return f(x,j),f(x,U),this.p(x.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const U=new r(j),x=k(U),ae=k(U),G=x[0];switch(G){case b.Promise:return this.k?.logIncoming(j.byteLength,x[1],O.OtherSide,`${u(G)}: ${x[2]}.${x[3]}`,ae),this.s({type:G,id:x[1],channelName:x[2],name:x[3],arg:ae});case b.EventListen:return this.k?.logIncoming(j.byteLength,x[1],O.OtherSide,`${u(G)}: ${x[2]}.${x[3]}`,ae),this.t({type:G,id:x[1],channelName:x[2],name:x[3],arg:ae});case b.PromiseCancel:return this.k?.logIncoming(j.byteLength,x[1],O.OtherSide,`${u(G)}`),this.u({type:G,id:x[1]});case b.EventDispose:return this.k?.logIncoming(j.byteLength,x[1],O.OtherSide,`${u(G)}`),this.u({type:G,id:x[1]})}}s(j){const U=this.b.get(j.channelName);if(!U){this.v(j);return}const x=new D.$we;let ae;try{ae=U.call(this.j,j.name,j.arg,x.token)}catch(ne){ae=Promise.reject(ne)}const G=j.id;ae.then(ne=>{this.m({id:G,data:ne,type:m.PromiseSuccess})},ne=>{ne instanceof Error?this.m({id:G,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split(`
`):void 0},type:m.PromiseError}):this.m({id:G,data:ne,type:m.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,c.$Tc)(()=>x.cancel());this.d.set(j.id,he)}t(j){const U=this.b.get(j.channelName);if(!U){this.v(j);return}const x=j.id,G=U.listen(this.j,j.name,j.arg)(he=>this.m({id:x,data:he,type:m.EventFire}));this.d.set(j.id,G)}u(j){const U=this.d.get(j.id);U&&(U.dispose(),this.d.delete(j.id))}v(j){let U=this.g.get(j.channelName);U||(U=[],this.g.set(j.channelName,U));const x=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===b.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:m.PromiseError})},this.l);U.push({request:j,timeoutTimer:x})}w(j){const U=this.g.get(j);if(U){for(const x of U)switch(clearTimeout(x.timeoutTimer),x.request.type){case b.Promise:this.s(x.request);break;case b.EventListen:this.t(x.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$gi=I;var O;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class L{constructor(j,U=null){this.l=j,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=U}getChannel(j){const U=this;return{call(x,ae,G){return U.a?Promise.reject(new P.$6):U.m(j,x,ae,G)},listen(x,ae){return U.a?y.Event.None:U.o(j,x,ae)}}}m(j,U,x,ae=D.CancellationToken.None){const G=this.g++,he=b.Promise,ne={id:G,type:he,channelName:j,name:U,arg:x};if(ae.isCancellationRequested)return Promise.reject(new P.$6);let Z;return new Promise((N,W)=>{if(ae.isCancellationRequested)return W(new P.$6);const q=()=>{const ie=de=>{switch(de.type){case m.PromiseSuccess:this.f.delete(G),N(de.data);break;case m.PromiseError:{this.f.delete(G);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,W(me);break}case m.PromiseErrorObj:this.f.delete(G),W(de.data);break}};this.f.set(G,ie),this.p(ne)};let Q=null;this.b===$.Idle?q():(Q=(0,o.$rh)(ie=>this.u()),Q.then(()=>{Q=null,q()}));const X=()=>{Q?(Q.cancel(),Q=null):this.p({id:G,type:b.PromiseCancel}),W(new P.$6)},Y=ae.onCancellationRequested(X);Z=(0,c.$Sc)((0,c.$Tc)(X),Y),this.d.add(Z)}).finally(()=>{Z.dispose(),this.d.delete(Z)})}o(j,U,x){const ae=this.g++,G=b.EventListen,he={id:ae,type:G,channelName:j,name:U,arg:x};let ne=null;const Z=new y.$le({onWillAddFirstListener:()=>{ne=(0,o.$rh)(N=>this.u()),ne.then(()=>{ne=null,this.d.add(Z),this.p(he)})},onDidRemoveLastListener:()=>{ne?(ne.cancel(),ne=null):(this.d.delete(Z),this.p({id:ae,type:b.EventDispose}))}}),F=N=>Z.fire(N.data);return this.f.set(ae,F),Z.event}p(j){switch(j.type){case b.Promise:case b.EventListen:{const U=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(U,j.id,O.LocalSide,`${u(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case b.PromiseCancel:case b.EventDispose:{const U=this.q([j.type,j.id]);this.j?.logOutgoing(U,j.id,O.LocalSide,u(j.type));return}}}q(j,U=void 0){const x=new t;return f(x,j),f(x,U),this.r(x.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const U=new r(j),x=k(U),ae=k(U),G=x[0];switch(G){case m.Initialize:return this.j?.logIncoming(j.byteLength,0,O.LocalSide,p(G)),this.t({type:x[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,x[1],O.LocalSide,p(G),ae),this.t({type:x[0],id:x[1],data:ae})}}t(j){if(j.type===m.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$hi=L,Se([R.$9h],L.prototype,"onDidInitializePromise",null);class T{get connections(){const j=[];return this.f.forEach(U=>j.push(U)),j}constructor(j,U,x){this.a=new Map,this.f=new Set,this.g=new y.$le,this.onDidAddConnection=this.g.event,this.h=new y.$le,this.onDidRemoveConnection=this.h.event,this.j=new c.$Uc,this.j.add(j(({protocol:ae,onDidClientDisconnect:G})=>{const he=y.Event.once(ae.onMessage);this.j.add(he(ne=>{const Z=new r(ne),F=k(Z),N=new I(ae,F,U,x),W=new L(ae,U);this.a.forEach((Q,X)=>N.registerChannel(X,Q));const q={channelServer:N,channelClient:W,ctx:F};this.f.add(q),this.g.fire(q),this.j.add(G(()=>{N.dispose(),W.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(j,U){const x=this;return{call(ae,G,he){let ne;if((0,g.$sg)(U)){const F=(0,i.$4b)(x.connections.filter(U));ne=F?Promise.resolve(F):y.Event.toPromise(y.Event.filter(x.onDidAddConnection,U))}else ne=U.routeCall(x,ae,G);const Z=ne.then(F=>F.channelClient.getChannel(j));return M(Z).call(ae,G,he)},listen(ae,G){if((0,g.$sg)(U))return x.k(j,U,ae,G);const he=U.routeEvent(x,ae,G).then(ne=>ne.channelClient.getChannel(j));return M(he).listen(ae,G)}}}k(j,U,x,ae){const G=this;let he;const ne=new y.$le({onWillAddFirstListener:()=>{he=new c.$Uc;const Z=new y.$re,F=new Map,N=q=>{const X=q.channelClient.getChannel(j).listen(x,ae),Y=Z.add(X);F.set(q,Y)},W=q=>{const Q=F.get(q);Q&&(Q.dispose(),F.delete(q))};G.connections.filter(U).forEach(N),y.Event.filter(G.onDidAddConnection,U)(N,void 0,he),G.onDidRemoveConnection(W,void 0,he),Z.event(ne.fire,ne,he),he.add(Z)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return ne.event}registerChannel(j,U){this.a.set(j,U);for(const x of this.f)x.channelServer.registerChannel(j,U)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=T;class A{constructor(j,U,x=null){const ae=new t;f(ae,U),j.send(ae.buffer),this.a=new L(j,x),this.d=new I(j,U,x)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,U){this.d.registerChannel(j,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=A;function M(H){return{call(j,U,x){return H.then(ae=>ae.call(j,U,x))},listen(j,U){const x=new y.$ue;return H.then(ae=>x.input=ae.listen(j,U)),x.event}}}function z(H){let j=!1;return{call(U,x,ae){return j?H.call(U,x,ae):(0,o.$Fh)(0).then(()=>j=!0).then(()=>H.call(U,x,ae))},listen(U,x){if(j)return H.listen(U,x);const ae=new y.$ue;return(0,o.$Fh)(0).then(()=>j=!0).then(()=>ae.input=H.listen(U,x)),ae.event}}}class C{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const U of j.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await y.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$mi=C;var B;(function(H){function j(G,he,ne){const Z=G,F=ne&&ne.disableMarshalling,N=new Map;for(const W in Z)x(W)&&N.set(W,y.Event.buffer(Z[W],!0,void 0,he));return new class{listen(W,q,Q){const X=N.get(q);if(X)return X;const Y=Z[q];if(typeof Y=="function"){if(ae(q))return Y.call(Z,Q);if(x(q))return N.set(q,y.Event.buffer(Z[q],!0,void 0,he)),N.get(q)}throw new P.$cb(`Event not found: ${q}`)}call(W,q,Q){const X=Z[q];if(typeof X=="function"){if(!F&&Array.isArray(Q))for(let ie=0;ie<Q.length;ie++)Q[ie]=(0,h.$bi)(Q[ie]);let Y=X.apply(Z,Q);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new P.$cb(`Method not found: ${q}`)}}}H.fromService=j;function U(G,he){const ne=he&&he.disableMarshalling;return new Proxy({},{get(Z,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):ae(F)?function(N){return G.listen(F,N)}:x(F)?G.listen(F):async function(...N){let W;he&&!(0,g.$ng)(he.context)?W=[he.context,...N]:W=N;const q=await G.call(F,W);return ne?q:(0,h.$bi)(q)};throw new P.$cb(`Property not found: ${String(F)}`)}})}H.toService=U;function x(G){return G[0]==="o"&&G[1]==="n"&&d.$Ef(G.charCodeAt(2))}function ae(G){return/^onDynamic/.test(G)&&d.$Ef(G.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const j=H.toString();if(j!=="[object Object]")return j}return H}function se(H){return Array.isArray(H)?H.map(_):_(H)}function K(H,j,U,x,ae,G,he){he=se(he);const ne=re[ae],Z=ne[x%ne.length];let F=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Z}`];/\($/.test(G)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class ee{constructor(j,U){this.d=j,this.f=U,this.a=0,this.b=0}logOutgoing(j,U,x,ae,G){this.b+=j,K(this.d,this.b,j,U,x,ae,G)}logIncoming(j,U,x,ae,G){this.a+=j,K(this.f,this.a,j,U,x,ae,G)}}e.$ni=ee}),define(ce[162],le([0,1,17,3,44]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cX=e.$bX=void 0;class D{constructor(y){this.a=y,this.onMessage=o.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?i.$Ne.wrap(c.data):i.$Ne.alloc(0)),y.start()}send(y){this.a.postMessage(y.buffer)}disconnect(){this.a.close()}}e.$bX=D;class R extends E.$ji{constructor(y,c){const h=new D(y);super(h,c),this.b=h}dispose(){this.b.disconnect(),super.dispose()}}e.$cX=R}),define(ce[118],le([0,1,17,3,2,44]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.ProtocolConstants=e.$oi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var P;(function(s){s.enableDiagnostics=!1,s.records=[];const l=new WeakMap;let f=0;function k(O,L){if(!l.has(O)){const T=String(++f);l.set(O,T)}return l.get(O)}function I(O,L,T,A){if(!s.enableDiagnostics)return;const M=k(O,L);if(A instanceof i.$Ne||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const z=i.$Ne.alloc(A.byteLength);z.set(A),s.records.push({timestamp:Date.now(),id:M,label:L,type:T,buff:z})}else s.records.push({timestamp:Date.now(),id:M,label:L,type:T,data:A})}s.traceSocketEvent=I})(P||(e.SocketDiagnostics=P={}));var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let c=null;function h(){return c||(c=i.$Ne.alloc(0)),c}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,f){if(l===0)return h();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const L=this.a[0];return f&&(this.a.shift(),this.b-=l),L}if(this.a[0].byteLength>l){const L=this.a[0].slice(0,l);return f&&(this.a[0]=this.a[0].slice(l),this.b-=l),L}const k=i.$Ne.alloc(l);let I=0,O=0;for(;l>0;){const L=this.a[O];if(L.byteLength>l){const T=L.slice(0,l);k.set(T,I),I+=l,f&&(this.a[O]=L.slice(l),this.b-=l),l-=l}else k.set(L,I),I+=L.byteLength,f?(this.a.shift(),this.b-=L.byteLength):O++,l-=L.byteLength}return k}}e.$oi=d;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(g||(g={}));function b(s){switch(s){case g.None:return"None";case g.Regular:return"Regular";case g.Control:return"Control";case g.Ack:return"Ack";case g.Disconnect:return"Disconnect";case g.ReplayRequest:return"ReplayRequest";case g.Pause:return"PauseWriting";case g.Resume:return"ResumeWriting";case g.KeepAlive:return"KeepAlive"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(u||(e.ProtocolConstants=u={}));class m{constructor(l,f,k,I){this.type=l,this.id=f,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends E.$Vc{constructor(l){super(),this.f=this.B(new o.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:u.HeaderLength,messageType:g.None,id:0,ack:0},this.a=l,this.b=!1,this.c=new d,this.B(this.a.onData(f=>this.acceptChunk(f))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const f=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=f.readUInt32BE(9),this.g.messageType=f.readUInt8(0),this.g.id=f.readUInt32BE(1),this.g.ack=f.readUInt32BE(5),this.a.traceSocketEvent(R.ProtocolHeaderRead,{messageType:b(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,O=this.g.ack;if(this.g.readHead=!0,this.g.readLen=u.HeaderLength,this.g.messageType=g.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(R.ProtocolMessageRead,f),this.f.fire(new m(k,I,O,f)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const f=i.$Ne.alloc(u.HeaderLength);f.writeUInt8(l.type,0),f.writeUInt32BE(l.id,1),f.writeUInt32BE(l.ack,5),f.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent(R.ProtocolHeaderWrite,{messageType:b(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent(R.ProtocolMessageWrite,l.data),this.j(f,l.data)}g(l,f){const k=this.f===0;return this.d.push(l,f),this.f+=l.byteLength+f.byteLength,k}h(){const l=i.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,f){this.g(l,f)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent(R.ProtocolWrite,{byteLength:l.byteLength}),this.c.write(l)}}class w extends E.$Vc{constructor(l){super(),this.f=new o.$le,this.onMessage=this.f.event,this.g=new o.$le,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new $(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(f=>{f.type===g.Regular&&this.f.fire(f.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new m(g.Regular,0,0,l))}}e.$pi=w;class v extends D.$ji{static fromSocket(l,f){return new v(new w(l),f)}get onDidDispose(){return this.b.onDidDispose}constructor(l,f,k=null){super(l,f,k),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$qi=v;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$ri=S;class r{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,f=this.a;for(;f;)f=f.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let f=0,k=this.a;for(;k;)l[f++]=k.data,k=k.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const f=new r(l);if(!this.a){this.a=f,this.b=f;return}this.b.next=f,this.b=f}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const l=Date.now();for(let f=0;f<n.a;f++)this.c[f]=l-1e3*f;setInterval(()=>{for(let f=n.a;f>=1;f--)this.c[f]=this.c[f-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),f=(1+n.a)*1e3;let k=0;for(let I=0;I<n.a;I++)l-this.c[I]<=f&&k++;return 1-k/n.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new S,this.onControlMessage=this.u.event,this.v=new S,this.onMessage=this.v.event,this.w=new S,this.onDidDispose=this.w.event,this.x=new S,this.onSocketClose=this.x.event,this.y=new S,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??n.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new E.$Uc,this.o=l.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},u.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new m(g.Disconnect,0,0,h());this.p.write(l),this.p.flush()}sendPause(){const l=new m(g.Pause,0,0,h());this.p.write(l)}sendResume(){const l=new m(g.Resume,0,0,h());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,f){this.a=!0,this.r.dispose(),this.r=new E.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(f)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new m(g.Ack,0,this.h,h());this.p.write(l);const f=this.b.toArray();for(let k=0,I=f.length;k<I;k++)this.p.write(f[k]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const f=this.b.peek();if(f&&f.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case g.None:break;case g.Regular:{if(l.id>this.g)if(l.id!==this.g+1){const f=Date.now();f-this.m>1e4&&(this.m=f,this.p.write(new m(g.ReplayRequest,0,0,h())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case g.Control:{this.u.fire(l.data);break}case g.Ack:break;case g.Disconnect:{this.w.fire();break}case g.ReplayRequest:{const f=this.b.toArray();for(let k=0,I=f.length;k<I;k++)this.p.write(f[k]);this.B();break}case g.Pause:{this.p.pause();break}case g.Resume:{this.p.resume();break}case g.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const f=++this.c;this.h=this.g;const k=new m(g.Regular,f,this.h,l);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(l){const f=new m(g.Control,0,0,l);this.p.write(f)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=u.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},u.AcknowledgeTime-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),f=Date.now()-l.writtenTime,k=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(f>=u.TimeoutTime&&k>=u.TimeoutTime&&I>=u.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:f,timeSinceLastReceivedSomeData:k});return}const O=Math.max(u.TimeoutTime-f,u.TimeoutTime-k,u.TimeoutTime-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},O)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new m(g.Ack,0,this.h,h());this.p.write(l)}D(){this.h=this.g;const l=new m(g.KeepAlive,0,this.h,h());this.p.write(l)}}e.$si=a}),define(ce[37],le([0,1,14,16,13]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$W=void 0;class D{constructor(){this.a=new WeakMap}on(P,y){const c=(h,...d)=>{this.b(P,h)&&y(h,...d)};return this.a.set(y,c),i.ipcMain.on(P,c),this}once(P,y){return i.ipcMain.once(P,(c,...h)=>{this.b(P,c)&&y(c,...h)}),this}handle(P,y){return i.ipcMain.handle(P,(c,...h)=>this.b(P,c)?y(c,...h):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return i.ipcMain.removeHandler(P),this}removeListener(P,y){const c=this.a.get(y);return c&&(i.ipcMain.removeListener(P,c),this.a.delete(y)),this}b(P,y){if(!P||!P.startsWith("vscode:"))return(0,o.$2)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const c=y.senderFrame,h=c.url;if(!h||h==="about:blank")return!0;let d="unknown";try{d=new URL(h).host}catch{return(0,o.$2)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${h}'.`),!1}return d!==E.$Xg?((0,o.$2)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${d}'.`),!1):c.parent!==null?((0,o.$2)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${d}' is not a main frame.`),!1):!0}}e.$$W=new D}),define(ce[163],le([0,1,14,37,151]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_W=D;function D(){o.$$W.on(E.$9W,(P,y,c,h,d)=>{const g=R(P,h,c);g.popup({x:d?d.x:void 0,y:d?d.y:void 0,positioningItem:d?d.positioningItem:void 0,callback:()=>{g&&P.sender.send(E.$0W,y)}})})}function R(P,y,c){const h=new i.Menu;return c.forEach(d=>{let g;d.type==="separator"?g=new i.MenuItem({type:d.type}):Array.isArray(d.submenu)?g=new i.MenuItem({submenu:R(P,y,d.submenu),label:d.label}):g=new i.MenuItem({label:d.label,type:d.type,accelerator:d.accelerator,checked:d.checked,enabled:d.enabled,visible:d.visible,click:(b,u,m)=>P.sender.send(y,d.id,m)}),h.append(g)}),h}}),define(ce[164],le([0,1,37,17,3,2,44,152]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fX=void 0;function y(h,d){const g=E.Event.fromNodeEventEmitter(i.$$W,d,(u,m)=>({event:u,message:m})),b=E.Event.filter(g,({event:u})=>u.sender.id===h);return E.Event.map(b,({message:u})=>u&&o.$Ne.wrap(u))}class c extends R.$ii{static{this.b=new Map}static d(){const d=E.Event.fromNodeEventEmitter(i.$$W,"vscode:hello",({sender:g})=>g);return E.Event.map(d,g=>{const b=g.id;c.b.get(b)?.dispose();const m=new E.$le;c.b.set(b,(0,D.$Tc)(()=>m.fire()));const p=y(b,"vscode:message"),$=E.Event.any(E.Event.signal(y(b,"vscode:disconnect")),m.event);return{protocol:new P.$eX(g,p),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$fX=c}),define(ce[119],le([0,1,37,3,33,162]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gX=void 0,e.$hX=P;class R extends D.$cX{constructor(c,h){super({addEventListener:(d,g)=>c.addListener(d,g),removeEventListener:(d,g)=>c.removeListener(d,g),postMessage:d=>c.postMessage(d),start:()=>c.start(),close:()=>c.close()},h)}}e.$gX=R;async function P(y){if(y.isDestroyed()||y.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,E.$1g)();y.webContents.send("vscode:createMessageChannel",c);const h=o.Event.fromNodeEventEmitter(i.$$W,"vscode:createMessageChannelResult",(g,b)=>({nonce:b,port:g.ports[0]})),{port:d}=await o.Event.toPromise(o.Event.once(o.Event.filter(h,g=>g.nonce===c)));return d}}),define(ce[165],le([0,1,49,8,17,23,159,16,3,2,35,94,80,44]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,P=Ae(P);class u extends b.$gi{constructor($){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",w=>E.$Ne.wrap(Buffer.from(w,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$ar=u;class m{constructor($,w){this.i=$,this.j=w,this.c=new Set,this.g=new Map,this.h=new y.$le,this.onDidProcessExit=this.h.event;const v=w&&w.timeout?w.timeout:6e4;this.b=new o.$Bh(v),this.d=null,this.f=null}getChannel($){const w=this;return{call(v,S,r){return w.k($,v,S,r)},listen(v,S){return w.l($,v,S)}}}k($,w,v,S=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(P.$7());this.b.cancel();const r=this.n($),t=(0,o.$rh)(s=>r.call(w,v,s)),n=S.onCancellationRequested(()=>t.cancel()),a=(0,c.$Tc)(()=>t.cancel());return this.c.add(a),t.finally(()=>{n.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,w,v){if(!this.b)return y.Event.None;this.b.cancel();let S;const r=new y.$le({onWillAddFirstListener:()=>{S=this.n($).listen(w,v)(r.fire,r),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return r.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,h.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(f=>!/^--inspect(-brk)?=/.test(f)).filter(f=>!f.startsWith("--vscode-"))),(0,g.$km)(w.env),this.d=(0,i.fork)(this.i,$,w);const v=new y.$le,r=y.Event.fromNodeEventEmitter(this.d,"message",f=>f)(f=>{if((0,R.$9q)(f)){(0,R.log)(f,`IPC Library: ${this.j.serverName}`);return}v.fire(E.$Ne.wrap(Buffer.from(f,"base64")))}),t=this.j.useQueue?(0,d.$xm)(this.d):this.d,n=f=>this.d&&this.d.connected&&t.send(f.buffer.toString("base64")),a=v.event,s={send:n,onMessage:a};this.f=new b.$hi(s);const l=()=>this.o();process.once("exit",l),this.d.on("error",f=>console.warn('IPC "'+this.j.serverName+'" errored with '+f)),this.d.on("exit",(f,k)=>{process.removeListener("exit",l),r.dispose(),this.c.forEach(I=>(0,c.$Qc)(I)),this.c.clear(),f!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+f+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:f,signal:k})})}return this.f}n($){let w=this.g.get($);return w||(w=this.m.getChannel($),this.g.set($,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=m}),define(ce[120],le([0,1,8,3,2,81,12]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=y;var P;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function y(g){const b=g;return b?.changed instanceof Map||b?.deleted instanceof Set}var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class h extends E.$Vc{static{this.a=100}constructor(b,u=Object.create(null)){super(),this.r=b,this.s=u,this.b=this.B(new o.$oe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new i.$Ch(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((u,m)=>this.w(m,u)),b.deleted?.forEach(u=>this.w(u,void 0))}finally{this.b.resume()}}w(b,u){if(this.c===c.Closed)return;let m=!1;(0,R.$ng)(u)?m=this.f.delete(b):this.f.get(b)!==u&&(this.f.set(b,u),m=!0),m&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,u){const m=this.f.get(b);return(0,R.$ng)(m)?u:m}getBoolean(b,u){const m=this.get(b);return(0,R.$ng)(m)?u:m==="true"}getNumber(b,u){const m=this.get(b);return(0,R.$ng)(m)?u:parseInt(m,10)}getObject(b,u){const m=this.get(b);return(0,R.$ng)(m)?u:(0,D.$ai)(m)}async set(b,u,m=!1){if(this.c===c.Closed)return;if((0,R.$ng)(u))return this.delete(b,m);const p=(0,R.$gg)(u)||Array.isArray(u)?(0,D.$_h)(u):String(u);if(this.f.get(b)!==p)return this.f.set(b,p),this.j.set(b,p),this.h.delete(b),this.b.fire({key:b,external:m}),this.D()}async delete(b,u=!1){if(!(this.c===c.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:u}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===c.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$0p=h;class d{constructor(){this.onDidChangeItemsExternal=o.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((u,m)=>this.a.set(m,u)),b.delete?.forEach(u=>this.a.delete(u))}async optimize(){}async close(){}}e.$$p=d}),define(ce[166],le([0,1,8,3,32,9,21]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DX=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return o.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,d=Object.create(null)){this.g=h,this.h=d,this.c=(0,D.$oc)(this.g),this.d=new y(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,d=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(b=>d.set(b.key,b.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems(h){const d=await this.f;return this.j(d,h)}j(h,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,E.$zc)(d.insert):"0"}), delete(${d.delete?(0,E.$Ac)(d.delete):"0"})`),this.t(h,()=>{const g=d.insert,b=d.delete;if(g&&g.size>0){const u=[];u.push([]);let m=0;g.forEach((p,$)=>{let w=u[m];w.length>P.b&&(m++,w=[],u.push(w)),w.push($,p)}),u.forEach(p=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,$=>$.run(p),()=>{const $=[];let w=0;return g.forEach((v,S)=>{$.push(S),w+=v.length}),`Keys: ${$.join(", ")} Length: ${w}`})})}if(b&&b.size){const u=[];u.push([]);let m=0;b.forEach(p=>{let $=u[m];$.length>P.b&&(m++,$=[],u.push($)),$.push(p)}),u.forEach(p=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,$=>$.run(p),()=>{const $=[];return b.forEach(w=>{$.push(w)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,h)}k(h,d){return new Promise((g,b)=>{h.db.close(u=>(u&&this.o(h,`[storage ${this.c}] close(): ${u}`),this.g===P.IN_MEMORY_PATH?g():!h.isErroneous&&!h.isInMemory?this.l().then(g,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),g())):typeof d=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const p=()=>this.k(m,void 0);return this.j(m,{insert:d()}).then(()=>p(),$=>(p(),Promise.reject($)))})).then(g,b):b(u||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return R.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const d=await this.f,g=await this.r(d,h?"PRAGMA integrity_check":"PRAGMA quick_check"),b=h?g.integrity_check:g.quick_check;return d.isErroneous?`${b} (last error: ${d.lastError})`:d.isInMemory?`${b} (in-memory!)`:b}async n(h,d=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${d})`);try{return await this.p(h)}catch(g){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&d)return await(0,i.$Fh)(P.a),this.n(h,!1);try{await R.Promises.unlink(h);try{await R.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(b){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${b}`),this.p(P.IN_MEMORY_PATH)}}}o(h,d){h.isErroneous=!0,h.lastError=d,this.d.error(d)}p(h){return new Promise((d,g)=>{new Promise((b,u)=>{V(["@vscode/sqlite3"],b,u)}).then(Ae).then(b=>{const u={db:new(this.d.isTracing?b.verbose().Database:b.Database)(h,m=>m?u.db&&m.code!=="SQLITE_CANTOPEN"?u.db.close(()=>g(m)):g(m):this.q(u,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(u),p=>u.db.close(()=>g(p)))),isInMemory:h===P.IN_MEMORY_PATH};u.db.on("error",m=>this.o(u,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&u.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},g)})}q(h,d){return new Promise((g,b)=>{h.db.exec(d,u=>u?(this.o(h,`[storage ${this.c}] exec(): ${u}`),b(u)):g())})}r(h,d){return new Promise((g,b)=>{h.db.get(d,(u,m)=>u?(this.o(h,`[storage ${this.c}] get(): ${u}`),b(u)):g(m))})}s(h,d){return new Promise((g,b)=>{h.db.all(d,(u,m)=>u?(this.o(h,`[storage ${this.c}] all(): ${u}`),b(u)):g(m))})}t(h,d){return new Promise((g,b)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),d(),h.db.run("END TRANSACTION",u=>u?(this.o(h,`[storage ${this.c}] transaction(): ${u}`),b(u)):g())})})}u(h,d,g,b){const u=h.db.prepare(d),m=p=>{this.o(h,`[storage ${this.c}] prepare(): ${p} (${d}). Details: ${b()}`)};u.on("error",m),g(u),u.finalize(p=>{p&&m(p),u.removeListener("error",m)})}}e.$DX=P;class y{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[y.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(ce[167],le([11,10]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(ce[168],le([11,10]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[169],le([11,10]),function(V,e){return V.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[170],le([11,10]),function(V,e){return V.create("vs/platform/contextkey/common/scanner",e)}),define(ce[171],le([11,10]),function(V,e){return V.create("vs/platform/dialogs/common/dialogs",e)}),define(ce[172],le([11,10]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ce[173],le([11,10]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(ce[174],le([11,10]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(ce[175],le([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[176],le([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[177],le([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[178],le([11,10]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[179],le([11,10]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ce[180],le([11,10]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(ce[181],le([11,10]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(ce[182],le([11,10]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(ce[183],le([11,10]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ce[184],le([11,10]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[185],le([11,10]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ce[186],le([11,10]),function(V,e){return V.create("vs/platform/log/common/log",e)}),define(ce[187],le([11,10]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(ce[188],le([11,10]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ce[189],le([11,10]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(ce[190],le([11,10]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(ce[191],le([11,10]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[192],le([11,10]),function(V,e){return V.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ce[193],le([11,10]),function(V,e){return V.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ce[194],le([11,10]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(ce[195],le([11,10]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[196],le([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ce[197],le([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ce[198],le([11,10]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(ce[199],le([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ce[200],le([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ce[201],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gb=i,e.$5gb=o;function i(E){return E&&E.hasOwnProperty("folderUri")}function o(E){return E&&E.hasOwnProperty("workspace")}}),define(ce[202],le([0,1,7]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=o,e.$Gdc=E,e.$Hdc=D;function o(R){return typeof R?.backupFolder=="string"}function E(R){let P=[];try{Array.isArray(R.workspaces)&&(P=R.workspaces.map(y=>({workspace:{id:y.id,configPath:i.URI.parse(y.configURIPath)},remoteAuthority:y.remoteAuthority})))}catch{}return P}function D(R){let P=[];try{Array.isArray(R.folders)&&(P=R.folders.map(y=>({folderUri:i.URI.parse(y.folderUri),remoteAuthority:y.remoteAuthority})))}catch{}return P}}),define(ce[203],le([0,1,39,16,170]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var D;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(D||(e.TokenType=D={}));function R(...h){switch(h.length){case 1:return(0,E.localize)(0,null,h[0]);case 2:return(0,E.localize)(1,null,h[0],h[1]);case 3:return(0,E.localize)(2,null,h[0],h[1],h[2]);default:return}}const P=(0,E.localize)(3,null),y=(0,E.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return d.isTripleEq?"===":"==";case D.NotEq:return d.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return d.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return d.lexeme;case D.QuotedStr:return d.lexeme;case D.Error:return d.lexeme;case D.EOF:return"EOF";default:throw(0,o.$9)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case i.CharCode.OpenParen:this.k(D.LParen);break;case i.CharCode.CloseParen:this.k(D.RParen);break;case i.CharCode.ExclamationMark:if(this.h(i.CharCode.Equals)){const g=this.h(i.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:g})}else this.k(D.Neg);break;case i.CharCode.SingleQuote:this.o();break;case i.CharCode.Slash:this.q();break;case i.CharCode.Equals:if(this.h(i.CharCode.Equals)){const g=this.h(i.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:g})}else this.h(i.CharCode.Tilde)?this.k(D.RegexOp):this.l(R("==","=~"));break;case i.CharCode.LessThan:this.k(this.h(i.CharCode.Equals)?D.LtEq:D.Lt);break;case i.CharCode.GreaterThan:this.k(this.h(i.CharCode.Equals)?D.GtEq:D.Gt);break;case i.CharCode.Ampersand:this.h(i.CharCode.Ampersand)?this.k(D.And):this.l(R("&&"));break;case i.CharCode.Pipe:this.h(i.CharCode.Pipe)?this.k(D.Or):this.l(R("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?i.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const g=this.d,b=this.c.substring(this.d,this.e),u={type:D.Error,offset:this.d,lexeme:b};this.g.push({offset:g,lexeme:b,additionalInfo:d}),this.f.push(u)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const g=this.c.substring(this.d,this.e),b=c.b.get(g);b?this.k(b):this.f.push({type:D.Str,lexeme:g,offset:this.d})}}o(){for(;this.j()!==i.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,g=!1,b=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(y);return}const m=this.c.charCodeAt(d);if(g)g=!1;else if(m===i.CharCode.Slash&&!b){d++;break}else m===i.CharCode.OpenSquareBracket?b=!0:m===i.CharCode.Backslash?g=!0:m===i.CharCode.CloseSquareBracket&&(b=!1);d++}for(;d<this.c.length&&c.a.has(this.c.charCodeAt(d));)d++;this.e=d;const u=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=c}),define(ce[204],le([0,1,3,2]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;class E{constructor(){this.a=new i.$le,this.b=new i.$le,this.c=new i.$le,this.d=new i.$le}static{this.ChannelName="extensionhostdebugservice"}call(P,y,c){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(P,y,c){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Uo=E;class D extends o.$Vc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,y,c){this.b.call("attach",[P,y,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,y){this.b.call("terminate",[P,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,y){return this.b.call("openExtensionDevelopmentHostWindow",[P,y])}}e.$Vo=D}),define(ce[205],le([0,1,154,52,13,9,36,19,7]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$5m=h,e.$6m=d,e.$3m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,D.$nc)(E.$Yg.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,D.$kc)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,P.$fh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$fh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const b=(0,i.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$kc)(this.userDataPath,"logs",b)}return y.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$fh)(y.URI.file((0,D.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$fh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$fh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$fh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=R.env.VSCODE_PORTABLE;return b?y.URI.file((0,D.$kc)(b,"argv.json")):(0,P.$fh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,D.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,D.$lc)(b):(0,D.$ic)((0,D.$kc)(E.$Yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const b=this.args["extensions-download-dir"];return b?y.URI.file((0,D.$lc)(b)):y.URI.file((0,D.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,D.$lc)(b);const u=R.env.VSCODE_EXTENSIONS;if(u)return u;const m=R.env.VSCODE_PORTABLE;return m?(0,D.$kc)(m,"extensions"):(0,P.$fh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(u=>/^[^:/?#]+?:\/\//.test(u)?y.URI.parse(u):y.URI.file((0,D.$ic)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?y.URI.parse(b):y.URI.file((0,D.$ic)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(b=>!e.$3m.test(b))}get extensionLogLevel(){const b=[];for(const u of this.args.log||[]){const m=e.$3m.exec(u);m&&m[1]&&m[2]&&b.push([m[1],m[2]])}return b.length?b:void 0}get serviceMachineIdResource(){return(0,P.$fh)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=R.env.VSCODE_PORTABLE;return b?y.URI.file((0,D.$kc)(b,"policy.json")):(0,P.$fh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(b){this.args.continueOn=b}get args(){return this.a}constructor(b,u,m){this.a=b,this.b=u,this.c=m,this.editSessionId=this.args.editSessionId}}e.$4m=c,Se([o.$9h],c.prototype,"appRoot",null),Se([o.$9h],c.prototype,"userHome",null),Se([o.$9h],c.prototype,"userDataPath",null),Se([o.$9h],c.prototype,"appSettingsHome",null),Se([o.$9h],c.prototype,"tmpDir",null),Se([o.$9h],c.prototype,"cacheHome",null),Se([o.$9h],c.prototype,"stateResource",null),Se([o.$9h],c.prototype,"userRoamingDataHome",null),Se([o.$9h],c.prototype,"userDataSyncHome",null),Se([o.$9h],c.prototype,"sync",null),Se([o.$9h],c.prototype,"machineSettingsResource",null),Se([o.$9h],c.prototype,"workspaceStorageHome",null),Se([o.$9h],c.prototype,"localHistoryHome",null),Se([o.$9h],c.prototype,"keyboardLayoutResource",null),Se([o.$9h],c.prototype,"argvResource",null),Se([o.$9h],c.prototype,"isExtensionDevelopment",null),Se([o.$9h],c.prototype,"untitledWorkspacesHome",null),Se([o.$9h],c.prototype,"builtinExtensionsPath",null),Se([o.$9h],c.prototype,"extensionsPath",null),Se([o.$9h],c.prototype,"extensionDevelopmentLocationURI",null),Se([o.$9h],c.prototype,"extensionDevelopmentKind",null),Se([o.$9h],c.prototype,"extensionTestsLocationURI",null),Se([o.$9h],c.prototype,"debugExtensionHost",null),Se([o.$9h],c.prototype,"logLevel",null),Se([o.$9h],c.prototype,"extensionLogLevel",null),Se([o.$9h],c.prototype,"serviceMachineIdResource",null),Se([o.$9h],c.prototype,"disableTelemetry",null),Se([o.$9h],c.prototype,"disableWorkspaceTrust",null),Se([o.$9h],c.prototype,"useInMemorySecretStorage",null),Se([o.$9h],c.prototype,"policyFile",null);function h(g,b){return d(g["inspect-extensions"],g["inspect-brk-extensions"],5870,b,g.debugId,g.extensionEnvironment)}function d(g,b,u,m,p,$){const v=Number(b||g)||(m?null:u),S=v?!!b:!1;let r;if($)try{r=JSON.parse($)}catch{}return{port:v,break:S,debugId:p,env:r}}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[121],le([0,1,316,4,173]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$Bm=P,e.$Cm=c,e.$Dm=b,e.$Em=u,i=et(i);const D={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.$zm=["tunnel","serve-web"],e.$Am={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,p,$=R){const w=m.find(f=>f.length>0&&f[0]!=="-"),v={},S=["_"],r=[],t={};let n;for(const f in p){const k=p[f];k.type==="subcommand"?f===w&&(n=k):(k.alias&&(v[f]=k.alias),k.type==="string"||k.type==="string[]"?(S.push(f),k.deprecates&&S.push(...k.deprecates)):k.type==="boolean"&&(r.push(f),k.deprecates&&r.push(...k.deprecates)),k.global&&(t[f]=k))}if(n&&w){const f=t;for(const L in n.options)f[L]=n.options[L];const k=m.filter(L=>L!==w),I=$.getSubcommandReporter?$.getSubcommandReporter(w):void 0,O=P(k,f,I);return{[w]:O,_:[]}}const a=(0,i.default)(m,{string:S,boolean:r,alias:v}),s={},l=a;s._=a._.map(f=>String(f)).filter(f=>f.length>0),delete l._;for(const f in p){const k=p[f];if(k.type==="subcommand")continue;k.alias&&delete l[k.alias];let I=l[f];if(k.deprecates)for(const O of k.deprecates)l.hasOwnProperty(O)&&(I||(I=l[O],I&&$.onDeprecatedOption(O,k.deprecationMessage||(0,E.localize)(39,null,f))),delete l[O]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const O=I.filter(L=>L.length>0);O.length!==I.length&&($.onEmptyValue(f),I=O.length>0?O:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),$.onMultipleValues(f,I)):!I&&!k.allowEmptyValue&&($.onEmptyValue(f),I=void 0));s[f]=I,k.deprecationMessage&&$.onDeprecatedOption(f,k.deprecationMessage)}delete l[f]}for(const f in l)$.onUnknownOption(f);return s}function y(m,p){let $="";return p.args&&(Array.isArray(p.args)?$=` <${p.args.join("> <")}>`:$=` <${p.args}>`),p.alias?`-${p.alias} --${m}${$}`:`--${m}${$}`}function c(m,p){const $=[];for(const w in m){const v=m[w],S=y(w,v);$.push([S,v.description])}return h($,p)}function h(m,p){const w=m.reduce((r,t)=>Math.max(r,t[0].length),12)+2+1;if(p-w<25)return m.reduce((r,t)=>r.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const v=p-w-1,S=[];for(const r of m){const t=r[0],n=g(r[1],v),a=d(w-t.length-2);S.push("  "+t+a+n[0]);for(let s=1;s<n.length;s++)S.push(d(w)+n[s])}return S}function d(m){return" ".repeat(m)}function g(m,p){const $=[];for(;m.length;){const w=m.length<p?m.length:m.lastIndexOf(" ",p),v=m.slice(0,w).trim();m=m.slice(w),$.push(v)}return $}function b(m,p,$,w,v){const S=process.stdout.isTTY&&process.stdout.columns||80,r=v?.noInputFiles!==!0?`[${(0,E.localize)(40,null)}...]`:"",t=[`${m} ${$}`];t.push(""),t.push(`${(0,E.localize)(41,null)}: ${p} [${(0,E.localize)(42,null)}]${r}`),t.push(""),v?.noPipe!==!0&&(o.$i?t.push((0,E.localize)(43,null,p)):t.push((0,E.localize)(44,null,p)),t.push(""));const n={},a=[];for(const s in w){const l=w[s];if(l.type==="subcommand")l.description&&a.push({command:s,description:l.description});else if(l.description&&l.cat){let f=n[l.cat];f||(n[l.cat]=f={}),f[s]=l}}for(const s in n){const l=s,f=n[l];f&&(t.push(D[l]),t.push(...c(f,S)),t.push(""))}return a.length&&(t.push((0,E.localize)(45,null)),t.push(...h(a.map(s=>[s.command,s.description]),S)),t.push("")),t.join(`
`)}function u(m,p){return`${m||(0,E.localize)(46,null)}
${p||(0,E.localize)(47,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[68],le([0,1,317,174,121]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=P,e.$Gm=y,e.$Hm=c,e.$Im=h,i=et(i);function D(d,g){const b=(v,S)=>{console.warn((0,o.localize)(0,null,v,S))},u=v=>{console.warn((0,o.localize)(1,null,v))},m=(v,S)=>{console.warn((0,o.localize)(2,null,v,S))},p=v=>({onUnknownOption:S=>{E.$zm.includes(v)||console.warn((0,o.localize)(3,null,S,v))},onMultipleValues:b,onEmptyValue:u,onDeprecatedOption:m,getSubcommandReporter:E.$zm.includes(v)?p:void 0}),$={onUnknownOption:v=>{console.warn((0,o.localize)(4,null,v))},onMultipleValues:b,onEmptyValue:u,onDeprecatedOption:m,getSubcommandReporter:p},w=(0,E.$Bm)(d,E.$Am,g?$:void 0);return w.goto&&w._.forEach(v=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(v),(0,o.localize)(5,null))),w}function R(d){const g=d.findIndex(b=>!/^-/.test(b));if(g>-1)return[...d.slice(0,g),...d.slice(g+1)]}function P(d){let[,...g]=d;process.env.VSCODE_DEV&&(g=R(g)||[]);const b=!h(process.env);return D(g,b)}function y(d){let[,,...g]=d;return process.env.VSCODE_DEV&&(g=R(g)||[]),D(g,!0)}function c(d,...g){const b=d.indexOf("--");return b===-1?d.push(...g):d.splice(b,0,...g),d}function h(d){return d.VSCODE_CLI==="1"}}),function(){"use strict";function V(e,i,o){function E(R,P){const y=D(R,P),c=[y];return e.isAbsolute(y)||c.unshift(o),e.resolve(...c)}function D(R,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const h=R["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(d,"AppData","Roaming")}break;case"darwin":c=e.join(i.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:E}}if(typeof define=="function")define(ce[206],le([122,27,36]),function(e,i,o){return V(e,i,o.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=V(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[95],le([0,1,27,205,206]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$8m=R,e.$9m=P;class D extends o.$4m{constructor(c,h){super(c,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,E.getUserDataPath)(c,h.nameShort)},h)}}e.$7m=D;function R(y,c){return(0,o.$6m)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,c,y.extensionEnvironment)}function P(y,c){return(0,o.$6m)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,c,y.extensionEnvironment)}}),define(ce[207],le([0,1,47,27,31]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=D;function D(R){const P=(0,E.$Mg)((0,o.tmpdir)());try{return(0,i.writeFileSync)(P,""),R&&console.log(`Marker file for --wait created: ${P}`),P}catch(y){R&&console.error(`Failed to create marker file for --wait: ${y}`);return}}}),define(ce[208],le([0,1,12,176]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=E;function E(R,P,y,c){try{D(R,P,y,c)}catch(h){R.error(h?.message??h)}return P}function D(R,P,y,c){const h=(d,g,b)=>{const u=d[g];if((0,i.$eg)(u)){const m=u,p=m.length;if(p>1&&m[0]==="%"&&m[p-1]==="%"){const $=m.substr(1,p-2);let w=y[$];w===void 0&&c&&(w=c[$]);const v=typeof w=="string"?w:w?.message,S=c?.[$],r=typeof S=="string"?S:S?.message;if(!v){r||R.warn(`[${P.name}]: ${(0,o.localize)(0,null,$)}`);return}if(b&&(g==="title"||g==="category")&&r&&r!==v){const t={value:v,original:r};d[g]=t}else d[g]=v}}else if((0,i.$gg)(u))for(const m in u)u.hasOwnProperty(m)&&(m==="commands"?h(u,m,!0):h(u,m,b));else if(Array.isArray(u))for(let m=0;m<u.length;m++)h(u,m,b)};for(const d in P)P.hasOwnProperty(d)&&h(P,d)}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[209],le([0,1,19,79,178,210]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=y,e.$Up=c,e.$Vp=h,e.$Wp=d,e.$Xp=g,e.$Yp=b,e.$Zp=u,o=et(o),E=Ae(E),D=Ae(D);const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function y($){return $=$.trim(),$==="*"||R.test($)}function c($){if(!y($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=$.match(R);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function h($){if(!$)return null;const w=$.majorBase,v=$.majorMustEqual,S=$.minorBase;let r=$.minorMustEqual;const t=$.patchBase;let n=$.patchMustEqual;$.hasCaret&&(w===0||(r=!1),n=!1);let a=0;if($.preRelease){const s=P.exec($.preRelease);if(s){const[,l,f,k]=s;a=Date.UTC(Number(l),Number(f)-1,Number(k))}}return{majorBase:w,majorMustEqual:v,minorBase:S,minorMustEqual:r,patchBase:t,patchMustEqual:n,isMinimum:$.hasGreaterEquals,notBefore:a}}function d($,w,v){let S;typeof $=="string"?S=h(c($)):S=$;let r;w instanceof Date?r=w.getTime():typeof w=="string"&&(r=new Date(w).getTime());let t;if(typeof v=="string"?t=h(c(v)):t=v,!S||!t)return!1;const n=S.majorBase,a=S.minorBase,s=S.patchBase;let l=t.majorBase,f=t.minorBase,k=t.patchBase;const I=t.notBefore;let O=t.majorMustEqual,L=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?n>l?!0:n<l?!1:a>f?!0:a<f||r&&r<I?!1:s>=k:(n===1&&l===0&&(!O||!L||!T)&&(l=1,f=0,k=0,O=!0,L=!1,T=!1),n<l?!1:n>l?!O:a<f?!1:a>f?!L:s<k?!1:s>k?!T:!(r&&r<I))}function g($,w,v,S,r){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([o.default.Error,E.localize(0,null)]),t;if(typeof S.name!="string")return t.push([o.default.Error,E.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([o.default.Error,E.localize(2,null,"version")]),t;if(!S.engines)return t.push([o.default.Error,E.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([o.default.Error,E.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!p(S.extensionDependencies))return t.push([o.default.Error,E.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!p(S.activationEvents))return t.push([o.default.Error,E.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([o.default.Error,E.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([o.default.Warning,E.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([o.default.Error,E.localize(9,null,"main")]),t;{const s=(0,i.$fh)(v,S.main);(0,i.$_g)(s,v)||t.push([o.default.Warning,E.localize(10,null,s.path,v.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([o.default.Error,E.localize(11,null,"browser")]),t;{const s=(0,i.$fh)(v,S.browser);(0,i.$_g)(s,v)||t.push([o.default.Warning,E.localize(12,null,s.path,v.path)])}}if(!D.valid(S.version))return t.push([o.default.Error,E.localize(13,null)]),t;const n=[];if(!b($,w,S,r,n))for(const s of n)t.push([o.default.Error,s]);return t}function b($,w,v,S,r){return S||typeof v.main>"u"&&typeof v.browser>"u"?!0:m($,w,v.engines.vscode,r)}function u($,w,v){return $==="*"||m(w,v,$)}function m($,w,v,S=[]){const r=h(c(v));if(!r)return S.push(E.localize(14,null,v)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return S.push(E.localize(15,null,v)),!1}else if(!r.majorMustEqual)return S.push(E.localize(16,null,v)),!1;return d($,w,r)?!0:(S.push(E.localize(17,null,$,v)),!1)}function p($){if(!Array.isArray($))return!1;for(let w=0,v=$.length;w<v;w++)if(typeof $[w]!="string")return!1;return!0}}),define(ce[82],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class i{constructor(E,D=[],R=!1){this.ctor=E,this.staticArguments=D,this.supportsDelayedInstantiation=R}}e.$Bi=i}),define(ce[211],le([0,1,82]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=D,e.$Ls=R;const o=[];var E;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function D(P,y,c){y instanceof i.$Bi||(y=new i.$Bi(y,[],!!c)),o.push([P,y])}function R(){return o}}),define(ce[212],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class i{constructor(D,R){this.key=D,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$nr=i;class o{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const R of this.a.values())R.outgoing.size===0&&D.push(R);return D}insertEdge(D,R){const P=this.lookupOrInsertNode(D),y=this.lookupOrInsertNode(R);P.outgoing.set(y.key,y),y.incoming.set(P.key,P)}removeNode(D){const R=this.b(D);this.a.delete(R);for(const P of this.a.values())P.outgoing.delete(R),P.incoming.delete(R)}lookupOrInsertNode(D){const R=this.b(D);let P=this.a.get(R);return P||(P=new i(R,D),this.a.set(R,P)),P}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[R,P]of this.a)D.push(`${R}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,R]of this.a){const P=new Set([D]),y=this.c(R,P);if(y)return y}}c(D,R){for(const[P,y]of D.outgoing){if(R.has(P))return[...R,P].join(" -> ");R.add(P);const c=this.c(y,R);if(c)return c;R.delete(P)}}}e.$or=o}),define(ce[6],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=E,e.$Fi=D;var i;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function P(y){return y[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=P})(i||(e._util=i={})),e.$Di=E("instantiationService");function o(R,P,y){P[i.DI_TARGET]===P?P[i.DI_DEPENDENCIES].push({id:R,index:y}):(P[i.DI_DEPENDENCIES]=[{id:R,index:y}],P[i.DI_TARGET]=P)}function E(R){if(i.serviceIds.has(R))return i.serviceIds.get(R);const P=function(y,c,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");o(P,y,h)};return P.toString=()=>R,i.serviceIds.set(R,P),P}function D(R){return R}}),define(ce[83],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0,e.$zec=(0,i.$Ei)("auxiliaryWindowsMainService")}),define(ce[69],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0,e.$Idc=(0,i.$Ei)("backupMainService")}),define(ce[18],le([0,1,12,7,6]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=D,e.$aj=R,e.$bj=y,e.$cj=c,e.$dj=h,e.$ej=d,e.$fj=g,e.$gj=u,e.$hj=m,e.$ij=p,i=Ae(i),e.$$i=(0,E.$Ei)("configurationService");function D($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof o.URI)}function R($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof o.URI)}var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function y($){switch($){case P.APPLICATION:return"APPLICATION";case P.USER:return"USER";case P.USER_LOCAL:return"USER_LOCAL";case P.USER_REMOTE:return"USER_REMOTE";case P.WORKSPACE:return"WORKSPACE";case P.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case P.DEFAULT:return"DEFAULT";case P.MEMORY:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function h($,w){const v=Object.create(null);for(const S in $)d(v,S,$[S],w);return v}function d($,w,v,S){const r=w.split("."),t=r.pop();let n=$;for(let a=0;a<r.length;a++){const s=r[a];let l=n[s];switch(typeof l){case"undefined":l=n[s]=Object.create(null);break;case"object":if(l===null){S(`Ignoring ${w} as ${r.slice(0,a+1).join(".")} is null`);return}break;default:S(`Ignoring ${w} as ${r.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}n=l}if(typeof n=="object"&&n!==null)try{n[t]=v}catch{S(`Ignoring ${w} as ${r.join(".")} is ${JSON.stringify(n)}`)}else S(`Ignoring ${w} as ${r.join(".")} is ${JSON.stringify(n)}`)}function g($,w){const v=w.split(".");b($,v)}function b($,w){const v=w.shift();if(w.length===0){delete $[v];return}if(Object.keys($).indexOf(v)!==-1){const S=$[v];typeof S=="object"&&!Array.isArray(S)&&(b(S,w),Object.keys(S).length===0&&delete $[v])}}function u($,w,v){function S(n,a){let s=n;for(const l of a){if(typeof s!="object"||s===null)return;s=s[l]}return s}const r=w.split("."),t=S($,r);return typeof t>"u"?v:t}function m($,w,v){Object.keys(w).forEach(S=>{S!=="__proto__"&&(S in $?i.$gg($[S])&&i.$gg(w[S])?m($[S],w[S],v):v&&($[S]=w[S]):$[S]=w[S])})}function p($){return $.replace(/[\[\]]/g,"")}}),define(ce[123],le([0,1,39,4,26,203,6,169,16]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=h,e.$Dj=a,e.$Ej=s,e.$Xj=G;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",o.$j),c.set("isLinux",o.$k),c.set("isWindows",o.$i),c.set("isWeb",o.$o),c.set("isMacNative",o.$j&&!o.$o),c.set("isEdge",o.$H),c.set("isFirefox",o.$F),c.set("isChrome",o.$E),c.set("isSafari",o.$G);function h(Z,F){if(c.get(Z)!==void 0)throw(0,y.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Z,F)}const d=Object.prototype.hasOwnProperty;var g;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(g||(e.ContextKeyExprType=g={}));const b={regexParsingWithErrorRecovery:!0},u=(0,P.localize)(0,null),m=(0,P.localize)(1,null),p=(0,P.localize)(2,null),$=(0,P.localize)(3,null),w=(0,P.localize)(4,null),v=(0,P.localize)(5,null),S=(0,P.localize)(6,null),r=(0,P.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=b){this.k=F,this.d=new D.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const W=this.D(),q=W.type===D.TokenType.Str?v:void 0;throw this.h.push({message:w,offset:W.offset,lexeme:D.$zj.getLexeme(W),additionalInfo:q}),t.c}return N}catch(N){if(N!==t.c)throw N;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(D.TokenType.Or);){const N=this.o();F.push(N)}return F.length===1?F[0]:n.or(...F)}o(){const F=[this.s()];for(;this.y(D.TokenType.And);){const N=this.s();F.push(N)}return F.length===1?F[0]:n.and(...F)}s(){if(this.y(D.TokenType.Neg)){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),f.INSTANCE;case D.TokenType.False:return this.z(),k.INSTANCE;case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N?.negate()}case D.TokenType.Str:return this.z(),M.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case D.TokenType.True:return this.z(),n.true();case D.TokenType.False:return this.z(),n.false();case D.TokenType.LParen:{this.z();const N=this.l();return this.A(D.TokenType.RParen,$),N}case D.TokenType.Str:{const N=F.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==D.TokenType.RegexStr)throw this.B("REGEX",q);const Q=q.lexeme,X=Q.lastIndexOf("/"),Y=X===Q.length-1?void 0:this.w(Q.substring(X+1));let ie;try{ie=new RegExp(Q.substring(1,X),Y)}catch{throw this.B("REGEX",q)}return se.create(N,ie)}switch(q.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const Q=[q.lexeme];this.z();let X=this.D(),Y=0;for(let Ie=0;Ie<q.lexeme.length;Ie++)q.lexeme.charCodeAt(Ie)===i.CharCode.OpenParen?Y++:q.lexeme.charCodeAt(Ie)===i.CharCode.CloseParen&&Y--;for(;!this.E()&&X.type!==D.TokenType.And&&X.type!==D.TokenType.Or;){switch(X.type){case D.TokenType.LParen:Y++;break;case D.TokenType.RParen:Y--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Ie=0;Ie<X.lexeme.length;Ie++)X.lexeme.charCodeAt(Ie)===i.CharCode.OpenParen?Y++:q.lexeme.charCodeAt(Ie)===i.CharCode.CloseParen&&Y--}if(Y<0)break;Q.push(D.$zj.getLexeme(X)),this.z(),X=this.D()}const ie=Q.join(""),de=ie.lastIndexOf("/"),me=de===ie.length-1?void 0:this.w(ie.substring(de+1));let pe;try{pe=new RegExp(ie.substring(1,de),me)}catch{throw this.B("REGEX",q)}return n.regex(N,pe)}case D.TokenType.QuotedStr:{const Q=q.lexeme;this.z();let X=null;if(!(0,E.$cf)(Q)){const Y=Q.indexOf("/"),ie=Q.lastIndexOf("/");if(Y!==ie&&Y>=0){const de=Q.slice(Y+1,ie),me=Q[ie+1]==="i"?"i":"";try{X=new RegExp(de,me)}catch{throw this.B("REGEX",q)}}}if(X===null)throw this.B("REGEX",q);return se.create(N,X)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,p);const q=this.u();return n.notIn(N,q)}switch(this.D().type){case D.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return n.equals(N,q);switch(q){case"true":return n.has(N);case"false":return n.not(N);default:return n.equals(N,q)}}case D.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===D.TokenType.QuotedStr)return n.notEquals(N,q);switch(q){case"true":return n.not(N);case"false":return n.has(N);default:return n.notEquals(N,q)}}case D.TokenType.Lt:return this.z(),re.create(N,this.u());case D.TokenType.LtEq:return this.z(),_.create(N,this.u());case D.TokenType.Gt:return this.z(),C.create(N,this.u());case D.TokenType.GtEq:return this.z(),B.create(N,this.u());case D.TokenType.In:return this.z(),n.in(N,this.u());default:return n.has(N)}}case D.TokenType.EOF:throw this.h.push({message:S,offset:F.offset,lexeme:"",additionalInfo:r}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),F.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,N){if(this.C(F))return this.z();throw this.B(N,this.D())}B(F,N,W){const q=(0,P.localize)(8,null,F,D.$zj.getLexeme(N)),Q=N.offset,X=D.$zj.getLexeme(N);return this.h.push({message:q,offset:Q,lexeme:X,additionalInfo:W}),t.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Bj=t;class n{static false(){return f.INSTANCE}static true(){return k.INSTANCE}static has(F){return I.create(F)}static equals(F,N){return O.create(F,N)}static notEquals(F,N){return A.create(F,N)}static regex(F,N){return se.create(F,N)}static in(F,N){return L.create(F,N)}static notIn(F,N){return T.create(F,N)}static not(F){return M.create(F)}static and(...F){return H.create(F,null,!0)}static or(...F){return j.create(F,null,!0)}static greater(F,N){return C.create(F,N)}static greaterEquals(F,N){return B.create(F,N)}static smaller(F,N){return re.create(F,N)}static smallerEquals(F,N){return _.create(F,N)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.$Cj=n;function a(Z){const F=new t({regexParsingWithErrorRecovery:!1});return Z.map(N=>(F.parse(N),F.lexingErrors.length>0?F.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,P.localize)(9,null,W.additionalInfo):(0,P.localize)(10,null),offset:W.offset,length:W.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function s(Z,F){const N=Z?Z.substituteConstants():void 0,W=F?F.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}function l(Z,F){return Z.cmp(F)}class f{static{this.INSTANCE=new f}constructor(){this.type=g.False}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return k.INSTANCE}}e.$Fj=f;class k{static{this.INSTANCE=new k}constructor(){this.type=g.True}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return f.INSTANCE}}e.$Gj=k;class I{static create(F,N=null){const W=c.get(F);return typeof W=="boolean"?W?k.INSTANCE:f.INSTANCE:new I(F,N)}constructor(F,N){this.key=F,this.c=N,this.type=g.Defined}cmp(F){return F.type!==this.type?this.type-F.type:x(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=c.get(this.key);return typeof F=="boolean"?F?k.INSTANCE:f.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Hj=I;class O{static create(F,N,W=null){if(typeof N=="boolean")return N?I.create(F,W):M.create(F,W);const q=c.get(F);return typeof q=="boolean"?N===(q?"true":"false")?k.INSTANCE:f.INSTANCE:new O(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Equals}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=c.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?k.INSTANCE:f.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Ij=O;class L{static create(F,N){return new L(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.In,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.f),W=F.getValue(this.d);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?d.call(N,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Jj=L;class T{static create(F,N){return new T(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.NotIn,this.c=L.create(F,N)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=T;class A{static create(F,N,W=null){if(typeof N=="boolean")return N?M.create(F,W):I.create(F,W);const q=c.get(F);return typeof q=="boolean"?N===(q?"true":"false")?f.INSTANCE:k.INSTANCE:new A(F,N,W)}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.NotEquals}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=c.get(this.c);if(typeof F=="boolean"){const N=F?"true":"false";return this.d===N?f.INSTANCE:k.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Lj=A;class M{static create(F,N=null){const W=c.get(F);return typeof W=="boolean"?W?f.INSTANCE:k.INSTANCE:new M(F,N)}constructor(F,N){this.c=F,this.d=N,this.type=g.Not}cmp(F){return F.type!==this.type?this.type-F.type:x(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=c.get(this.c);return typeof F=="boolean"?F?f.INSTANCE:k.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Mj=M;function z(Z,F){if(typeof Z=="string"){const N=parseFloat(Z);isNaN(N)||(Z=N)}return typeof Z=="string"||typeof Z=="number"?F(Z):f.INSTANCE}class C{static create(F,N,W=null){return z(N,q=>new C(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Greater}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Nj=C;class B{static create(F,N,W=null){return z(N,q=>new B(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.GreaterEquals}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Oj=B;class re{static create(F,N,W=null){return z(N,q=>new re(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.Smaller}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Pj=re;class _{static create(F,N,W=null){return z(N,q=>new _(F,q,W))}constructor(F,N,W){this.c=F,this.d=N,this.f=W,this.type=g.SmallerEquals}cmp(F){return F.type!==this.type?this.type-F.type:ae(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Qj=_;class se{static create(F,N){return new se(F,N)}constructor(F,N){this.d=F,this.f=N,this.type=g.Regex,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return N<W?-1:N>W?1:0}equals(F){if(F.type===this.type){const N=this.f?this.f.source:"",W=F.f?F.f.source:"";return this.d===F.d&&N===W}return!1}substituteConstants(){return this}evaluate(F){const N=F.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Rj=se;class K{static create(F){return new K(F)}constructor(F){this.c=F,this.type=g.NotRegex}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new K(this.c.map(F))}negate(){return this.c}}e.$Sj=K;function ee(Z){let F=null;for(let N=0,W=Z.length;N<W;N++){const q=Z[N].substituteConstants();if(Z[N]!==q&&F===null){F=[];for(let Q=0;Q<N;Q++)F[Q]=Z[Q]}F!==null&&(F[N]=q)}return F===null?Z:F}class H{static create(F,N,W){return H.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=g.And}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const q=l(this.expr[N],F.expr[N]);if(q!==0)return q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:H.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(F))return!1;return!0}static d(F,N,W){const q=[];let Q=!1;for(const X of F)if(X){if(X.type===g.True){Q=!0;continue}if(X.type===g.False)return f.INSTANCE;if(X.type===g.And){q.push(...X.expr);continue}q.push(X)}if(q.length===0&&Q)return k.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(l);for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];for(;q.length>1;){const X=q[q.length-1];if(X.type!==g.Or)break;q.pop();const Y=q.pop(),ie=q.length===0,de=j.create(X.expr.map(me=>H.create([me,Y],null,W)),null,ie);de&&(q.push(de),q.sort(l))}if(q.length===1)return q[0];if(W){for(let X=0;X<q.length;X++)for(let Y=X+1;Y<q.length;Y++)if(q[X].negate().equals(q[Y]))return f.INSTANCE;if(q.length===1)return q[0]}return new H(q,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new H(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());this.c=j.create(F,this,!0)}return this.c}}e.$Tj=H;class j{static create(F,N,W){return j.d(F,N,W)}constructor(F,N){this.expr=F,this.c=N,this.type=g.Or}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const q=l(this.expr[N],F.expr[N]);if(q!==0)return q}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(F.expr[N]))return!1;return!0}return!1}substituteConstants(){const F=ee(this.expr);return F===this.expr?this:j.create(F,this.c,!1)}evaluate(F){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(F))return!0;return!1}static d(F,N,W){let q=[],Q=!1;if(F){for(let X=0,Y=F.length;X<Y;X++){const ie=F[X];if(ie){if(ie.type===g.False){Q=!0;continue}if(ie.type===g.True)return k.INSTANCE;if(ie.type===g.Or){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&Q)return f.INSTANCE;q.sort(l)}if(q.length!==0){if(q.length===1)return q[0];for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];if(W){for(let X=0;X<q.length;X++)for(let Y=X+1;Y<q.length;Y++)if(q[X].negate().equals(q[Y]))return k.INSTANCE;if(q.length===1)return q[0]}return new j(q,N)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const N of this.expr)F.push(...N.keys());return F}map(F){return new j(this.expr.map(N=>N.map(F)),null)}negate(){if(!this.c){const F=[];for(const N of this.expr)F.push(N.negate());for(;F.length>1;){const N=F.shift(),W=F.shift(),q=[];for(const Q of ne(N))for(const X of ne(W))q.push(H.create([Q,X],null,!1));F.unshift(j.create(q,null,!1))}this.c=j.create(F,this,!0)}return this.c}}e.$Uj=j;class U extends I{static{this.d=[]}static all(){return U.d.values()}constructor(F,N,W){super(F,null),this.f=N,typeof W=="object"?U.d.push({...W,key:F}):W!==!0&&U.d.push({key:F,description:W,type:N!=null?typeof N:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return O.create(this.key,F)}notEqualsTo(F){return A.create(this.key,F)}}e.$Vj=U,e.$Wj=(0,R.$Ei)("contextKeyService");function x(Z,F){return Z<F?-1:Z>F?1:0}function ae(Z,F,N,W){return Z<N?-1:Z>N?1:F<W?-1:F>W?1:0}function G(Z,F){if(Z.type===g.False||F.type===g.True)return!0;if(Z.type===g.Or)return F.type===g.Or?he(Z.expr,F.expr):!1;if(F.type===g.Or){for(const N of F.expr)if(G(Z,N))return!0;return!1}if(Z.type===g.And){if(F.type===g.And)return he(F.expr,Z.expr);for(const N of Z.expr)if(G(N,F))return!0;return!1}return Z.equals(F)}function he(Z,F){let N=0,W=0;for(;N<Z.length&&W<F.length;){const q=Z[N].cmp(F[W]);if(q<0)return!1;q===0&&N++,W++}return N===Z.length}function ne(Z){return Z.type===g.Or?Z.expr:[Z]}}),define(ce[96],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Rm=e.ID=void 0,e.$Sm=o,e.ID="diagnosticsService",e.$Rm=(0,i.$Ei)(e.ID);function o(D){return!!D.hostName&&!!D.errorMessage}class E{async getPerformanceInfo(R,P){return{}}async getSystemInfo(R,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,P){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.$Tm=E});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[124],le([0,1,19,79,171,6,48,4,35]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$4w=e.$3w=e.$2w=void 0,e.$5w=b,e.$6w=u,o=et(o),e.$2w=(0,D.$Ei)("dialogService");var c;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(c||(c={}));class h{a(p){return this.d(p,c.Confirmation)}b(p){return this.d(p,c.Prompt)}c(p){return this.d(p,c.Input)}d(p,$){const w=[];switch($){case c.Confirmation:{const v=p;v.primaryButton?w.push(v.primaryButton):w.push((0,E.localize)(0,null)),v.cancelButton?w.push(v.cancelButton):w.push((0,E.localize)(1,null));break}case c.Prompt:{const v=p;Array.isArray(v.buttons)&&v.buttons.length>0&&w.push(...v.buttons.map(S=>S.label)),v.cancelButton&&(v.cancelButton===!0?w.push((0,E.localize)(2,null)):typeof v.cancelButton=="string"?w.push(v.cancelButton):v.cancelButton.label?w.push(v.cancelButton.label):w.push((0,E.localize)(3,null))),w.length===0&&w.push((0,E.localize)(4,null));break}case c.Input:{const v=p;v.primaryButton?w.push(v.primaryButton):w.push((0,E.localize)(5,null)),v.cancelButton?w.push(v.cancelButton):w.push((0,E.localize)(6,null));break}}return w}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===o.default.Info?"info":p===o.default.Error?"error":p===o.default.Warning?"warning":"none"}f(p,$,w){const v=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&v.push(p.cancelButton);let S=v[$]?.run({checkboxChecked:w});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:w}}}e.$3w=h,e.$4w=(0,D.$Ei)("fileDialogService");var d;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const g=10;function b(m){const p=[];return p.push(...m.slice(0,g).map($=>typeof $=="string"?$:(0,i.$ch)($))),m.length>g&&(m.length-g===1?p.push((0,E.localize)(7,null)):p.push((0,E.localize)(8,null,m.length-g))),p.push(""),p.join(`
`)}function u(m,p){const $=(0,y.$bo)(m);let w=($.buttons??[]).map(t=>(0,R.$Yw)(t)),v=(m.buttons||[]).map((t,n)=>n),S=0,r=$.cancelId??w.length-1;if(w.length>1){const t=typeof r=="number"?w[r]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&w.length>1&&r!==1){w.splice(r,1),w.splice(1,0,t);const n=v[r];v.splice(r,1),v.splice(1,0,n),r=1}P.$k&&w.length>1&&(w=w.reverse(),v=v.reverse(),S=w.length-1,typeof t=="string"&&(r=S-1))}else if(P.$i&&typeof t=="string"&&w.length>1&&r!==w.length-1){w.splice(r,1),w.push(t);const n=v[r];v.splice(r,1),v.push(n),r=w.length-1}}return $.buttons=w,$.defaultId=S,$.cancelId=r,$.noLink=!0,$.title=$.title||p.nameLong,{options:$,buttonIndeces:v}}}),define(ce[97],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$TX=e.$SX=void 0,e.$UX=D,e.$VX=R,e.$SX=(0,i.$Ei)("encryptionService"),e.$TX=(0,i.$Ei)("encryptionMainService");var o;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(o||(e.PasswordStoreCLIOption=o={}));var E;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(E||(e.KnownStorageProvider=E={}));function D(P){return P===E.kwallet||P===E.kwallet5||P===E.kwallet6}function R(P){return P===E.gnomeAny||P===E.gnomeLibsecret||P===E.gnomeKeyring}}),define(ce[38],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,i.$Ei)("environmentService"),e.$Mi=(0,i.$Fi)(e.$Li)}),define(ce[213],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=void 0,e.$oec=(0,i.$Ei)("extensionHostStarter"),e.$pec="extensionHostStarter"}),define(ce[214],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=e.$G8b=void 0,e.$G8b=(0,i.$Ei)("externalTerminal"),e.$H8b="Terminal.app"}),define(ce[215],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0,e.$rec=(0,i.$Ei)("externalTerminal")}),define(ce[216],le([0,1,49,52,13,9,4,80,21,94,179,214]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=e.$sec=void 0,i=Ae(i),D=Ae(D),R=Ae(R),y=Ae(y),c=Ae(c),h=Ae(h);const g=h.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends b{static{this.b="cmd.exe"}openTerminal(r,t){return this.spawnTerminal(i,r,c.$wm(),t)}spawnTerminal(r,t,n,a){const s=t.windowsExec||u.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const l=D.$oc(s,".exe").toLowerCase();if(l==="cmder")return r.spawn(s,a?[a]:void 0),Promise.resolve(void 0);const f=["/c","start","/wait"];return s.indexOf(" ")>=0&&f.push('""'),f.push(s),l==="wt"&&f.push("-d ."),new Promise((k,I)=>{const O=$(process),L=r.spawn(n,f,{cwd:a,env:O,detached:!0});L.on("error",I),L.on("exit",()=>k())})}async runInTerminal(r,t,n,a,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:u.getDefaultTerminalWindows(),f=await u.f();return new Promise((k,I)=>{const O=`"${t} - ${g}"`,L=`"${n.join('" "')}" & pause`,T=Object.assign({},$(process),a);Object.keys(T).filter(B=>T[B]===null).forEach(B=>delete T[B]);const A={cwd:t,env:T,windowsVerbatimArguments:!0};let M,z;D.$oc(l,".exe")==="wt"?(M=l,z=["-d",".",u.b,"/c",L]):f?(M=f,z=["-d",".",l,"/c",L]):(M=u.b,z=["/c","start",O,"/wait",l,"/c",`"${L}"`]),i.spawn(M,z,A).on("error",B=>{I(w(B))}),k(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return u.d}static async f(){try{const r=await c.win32.findExecutable("wt");return await y.Promises.exists(r)?r:void 0}catch{return}}}e.$sec=u,Se([o.$9h],u,"f",null);class m extends b{static{this.b="/usr/bin/osascript"}openTerminal(r,t){return this.spawnTerminal(i,r,t)}runInTerminal(r,t,n,a,s){const l=s.osxExec||d.$H8b;return new Promise((f,k)=>{if(l===d.$H8b||l==="iTerm.app"){const I=l===d.$H8b?"TerminalHelper":"iTermHelper",L=[E.$Yg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",r||g,"-w",t];for(const M of n)L.push("-a"),L.push(M);if(a){const M=Object.assign({},$(process),a);for(const z in M){const C=M[z];C===null?(L.push("-u"),L.push(z)):(L.push("-e"),L.push(`${z}=${C}`))}}let T="";const A=i.spawn(m.b,L);A.on("error",M=>{k(w(M))}),A.stderr.on("data",M=>{T+=M.toString()}),A.on("exit",M=>{if(M===0)f(void 0);else if(T){const z=T.split(`
`,1);k(new Error(z[0]))}else k(new Error(h.localize(1,null,I,M)))})}else k(new Error(h.localize(2,null,l)))})}spawnTerminal(r,t,n){const a=t.osxExec||d.$H8b;return new Promise((s,l)=>{const f=["-a",a];n&&f.push(n);const k=$(process),I=r.spawn("/usr/bin/open",f,{cwd:n,env:k});I.on("error",l),I.on("exit",()=>s())})}}e.$tec=m;class p extends b{static{this.b=h.localize(3,null)}openTerminal(r,t){return this.spawnTerminal(i,r,t)}runInTerminal(r,t,n,a,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((f,k)=>{const I=[];l.then(O=>{O.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const L=`${v(n)}; echo; read -p "${p.b}" -n1;`;I.push(`''${L}''`);const T=Object.assign({},$(process),a);Object.keys(T).filter(C=>T[C]===null).forEach(C=>delete T[C]);const A={cwd:t,env:T};let M="";const z=i.spawn(O,I,A);z.on("error",C=>{k(w(C))}),z.stderr.on("data",C=>{M+=C.toString()}),z.on("exit",C=>{if(C===0)f(void 0);else if(M){const B=M.split(`
`,1);k(new Error(B[0]))}else k(new Error(h.localize(4,null,O,C)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!R.$k)p.d=Promise.resolve("xterm");else{const r=await y.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{r?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(r,t,n){const a=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{a.then(f=>{const k=$(process),I=r.spawn(f,[],{cwd:n,env:k});I.on("error",l),I.on("exit",()=>s())})})}}e.$uec=p;function $(S){const r={...S.env};return(0,P.$jm)(r),r}function w(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(h.localize(5,null,S.path)):S}function v(S){let r="";for(const t of S)t.indexOf(" ")>=0?r+='"'+t+'"':r+=t,r+=" ";return r}}),define(ce[15],le([0,1,61,9,26,12,7,181,6,4,13,65]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=g,e.$al=p,e.$bl=w,e.$cl=v,e.$dl=S,e.$el=r,e.$fl=t,e.$gl=n,e.$hl=a,e.$il=s,e.$jl=l,e.$ll=I,e.$ml=O,e.$nl=L,e.$ol=T,e.$pl=A,e.$sl=re,e.$El=j,e.$Fl=U,e.$Hl=ae,e.$$k=(0,y.$Ei)("fileService");function g(G){return G.create===!0}var b;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var u;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var m;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function p(G){const he=G;return!!he&&typeof he.onDidChange=="function"}var $;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function w(G){return!!(G.capabilities&$.FileReadWrite)}function v(G){return!!(G.capabilities&$.FileFolderCopy)}function S(G){return!!(G.capabilities&$.FileClone)}function r(G){return!!(G.capabilities&$.FileOpenReadWriteClose)}function t(G){return!!(G.capabilities&$.FileReadStream)}function n(G){return w(G)?!!(G.capabilities&$.FileAtomicRead):!1}function a(G){return w(G)?!!(G.capabilities&$.FileAtomicWrite):!1}function s(G){return!!(G.capabilities&$.FileAtomicDelete)}function l(G){return!!(G.capabilities&$.Readonly)}var f;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(f||(e.FileSystemProviderErrorCode=f={}));class k extends Error{static create(he,ne){const Z=new k(he.toString(),ne);return L(Z,ne),Z}constructor(he,ne){super(he),this.code=ne}}e.$kl=k;function I(G,he){return k.create(G,he)}function O(G){return G||I((0,P.localize)(0,null),f.Unknown)}function L(G,he){return G.name=he?`${he} (FileSystemError)`:"FileSystemError",G}function T(G){if(!G)return f.Unknown;if(G instanceof k)return G.code;const he=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!he)return f.Unknown;switch(he[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}function A(G){if(G instanceof _)return G.fileOperationResult;switch(T(G)){case f.FileNotFound:return ee.FILE_NOT_FOUND;case f.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case f.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case f.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case f.NoPermissions:return ee.FILE_PERMISSION_DENIED;case f.FileExists:return ee.FILE_MOVE_CONFLICT;case f.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var M;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class z{constructor(he,ne,Z){this.resource=he,this.operation=ne,this.target=Z}isOperation(he){return this.operation===he}}e.$ql=z;var C;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(C||(e.FileChangeType=C={}));class B{static{this.a=null}constructor(he,ne){this.c=ne,this.b=void 0,this.d=new d.$W(()=>{const Z=i.$Ki.forUris(()=>this.c);return Z.fill(this.rawAdded.map(F=>[F,!0])),Z}),this.f=new d.$W(()=>{const Z=i.$Ki.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(F=>[F,!0])),Z}),this.g=new d.$W(()=>{const Z=i.$Ki.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(F=>[F,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of he){switch(Z.type){case C.ADDED:this.rawAdded.push(Z.resource);break;case C.UPDATED:this.rawUpdated.push(Z.resource);break;case C.DELETED:this.rawDeleted.push(Z.resource);break}this.b!==B.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=B.a):this.b!==void 0&&(this.b=B.a))}}contains(he,...ne){return this.h(he,{includeChildren:!1},...ne)}affects(he,...ne){return this.h(he,{includeChildren:!0},...ne)}h(he,ne,...Z){if(!he)return!1;const F=Z.length>0;return!!((!F||Z.includes(C.ADDED))&&(this.d.value.get(he)||ne.includeChildren&&this.d.value.findSuperstr(he))||(!F||Z.includes(C.UPDATED))&&(this.f.value.get(he)||ne.includeChildren&&this.f.value.findSuperstr(he))||(!F||Z.includes(C.DELETED))&&(this.g.value.findSubstr(he)||ne.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$rl=B;function re(G,he,ne){return!G||!he||G===he||he.length>G.length?!1:(he.charAt(he.length-1)!==o.sep&&(he+=o.sep),ne?(0,E.$Gf)(G,he):G.indexOf(he)===0)}class _ extends Error{constructor(he,ne,Z){super(he),this.fileOperationResult=ne,this.options=Z}}e.$tl=_;class se extends _{constructor(he,ne,Z,F){super(he,ne,F),this.fileOperationResult=ne,this.size=Z}}e.$ul=se;class K extends _{constructor(he,ne,Z){super(he,ee.FILE_NOT_MODIFIED_SINCE,Z),this.stat=ne}}e.$vl=K;var ee;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var H;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$Dl="";function j(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function U(G,he){if(!he.hasProvider(R.URI.from({scheme:G.scheme})))return new Promise(ne=>{const Z=he.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===G.scheme&&F.added&&(Z.dispose(),ne())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(he){return(0,D.$ig)(he)||(he=0),he<x.KB?(0,P.localize)(1,null,he.toFixed(0)):he<x.MB?(0,P.localize)(2,null,(he/x.KB).toFixed(2)):he<x.GB?(0,P.localize)(3,null,(he/x.MB).toFixed(2)):he<x.TB?(0,P.localize)(4,null,(he/x.GB).toFixed(2)):(0,P.localize)(5,null,(he/x.TB).toFixed(2))}}e.$Gl=x;function ae(G){const he=typeof G=="string"||G?.scheme===h.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===h.Schemas.file?1024*x.MB:he?10*x.MB:c.$o?50*x.MB:1024*x.MB}}),define(ce[125],le([0,1,17,16,182,15]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=R;async function R(h,d,g,b,u,m){let p;try{await P(h,d,g,b,u,m)}catch($){p=$}finally{p&&u.errorTransformer&&(p=u.errorTransformer(p)),typeof p<"u"&&g.error(p),g.end()}}async function P(h,d,g,b,u,m){y(m);const p=await h.open(d,{create:!1});try{y(m);let $=0,w=0,v=u&&typeof u.length=="number"?u.length:void 0,S=i.$Ne.alloc(Math.min(u.bufferSize,typeof v=="number"?v:u.bufferSize)),r=u&&typeof u.position=="number"?u.position:0,t=0;do w=await h.read(p,r,S.buffer,t,S.byteLength-t),r+=w,t+=w,$+=w,typeof v=="number"&&(v-=w),t===S.byteLength&&(await g.write(b(S)),S=i.$Ne.alloc(Math.min(u.bufferSize,typeof v=="number"?v:u.bufferSize)),t=0);while(w>0&&(typeof v!="number"||v>0)&&y(m)&&c($,u));if(t>0){let n=t;typeof v=="number"&&(n=Math.min(t,v)),g.write(b(S.slice(0,n)))}}catch($){throw(0,D.$ml)($)}finally{await h.close(p)}}function y(h){if(h.isCancellationRequested)throw(0,o.$7)();return!0}function c(h,d){if(typeof d?.limits?.size=="number"&&h>d.limits.size)throw(0,D.$ll)((0,E.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[62],le([0,1,113,2,9,4,7,15]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=y,e.$Xq=c,e.$2q=b,e.$3q=u,e.$4q=m,e.$5q=p,e.$6q=w,e.$7q=v;function y(S){return typeof S.correlationId=="number"}function c(S){return S.recursive===!0}class h extends o.$Vc{static{this.a=5}constructor(r,t,n,a){super(),this.h=r,this.j=t,this.m=n,this.n=a,this.c=this.B(new o.$Wc),this.f=void 0,this.g=0}s(){const r=new o.$Uc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(t=>this.h(t))),r.add(this.b.onDidLogMessage(t=>this.j(t))),r.add(this.b.onDidError(t=>this.t(t.error,t.request)))}t(r,t){this.u(r,t)?this.g<h.a&&this.f?(this.y(`restarting watcher after unexpected error: ${r}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${r}`):this.y(r)}u(r,t){return!(!this.n.restartOnError||t||r.indexOf("No space left on device")!==-1||r.indexOf("EMFILE")!==-1)}w(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}y(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}z(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=h;class d extends h{constructor(r,t,n){super(r,t,n,{type:"node.js",restartOnError:!1})}}e.$Zq=d;class g extends h{constructor(r,t,n){super(r,t,n,{type:"universal",restartOnError:!0})}}e.$1q=g;function b(S){return S.map(r=>({type:r.type,resource:R.URI.revive(r.resource),cId:r.cId}))}function u(S){const r=new $;for(const t of S)r.processEvent(t);return r.coalesce()}function m(S,r){return typeof r=="string"&&!r.startsWith(i.$uk)&&!(0,E.$jc)(r)?{base:S,pattern:r}:r}function p(S,r){const t=[];for(const n of r)t.push((0,i.$yk)(m(S,n)));return t}class ${constructor(){this.a=new Set,this.b=new Map}c(r){return D.$k?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const t=this.b.get(this.c(r));let n=!1;if(t){const a=t.type,s=r.type;t.resource.fsPath!==r.resource.fsPath&&(r.type===P.FileChangeType.DELETED||r.type===P.FileChangeType.ADDED)?n=!0:a===P.FileChangeType.ADDED&&s===P.FileChangeType.DELETED?(this.b.delete(this.c(r)),this.a.delete(t)):a===P.FileChangeType.DELETED&&s===P.FileChangeType.ADDED?t.type=P.FileChangeType.UPDATED:a===P.FileChangeType.ADDED&&s===P.FileChangeType.UPDATED||(t.type=s)}else n=!0;n&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],t=[];return Array.from(this.a).filter(n=>n.type!==P.FileChangeType.DELETED?(r.push(n),!1):!0).sort((n,a)=>n.resource.fsPath.length-a.resource.fsPath.length).filter(n=>t.some(a=>(0,P.$sl)(n.resource.fsPath,a,!D.$k))?!1:(t.push(n.resource.fsPath),!0)).concat(r)}}function w(S,r){if(typeof r=="number")switch(S.type){case P.FileChangeType.ADDED:return(r&P.FileChangeFilter.ADDED)===0;case P.FileChangeType.DELETED:return(r&P.FileChangeFilter.DELETED)===0;case P.FileChangeType.UPDATED:return(r&P.FileChangeFilter.UPDATED)===0}return!1}function v(S){if(typeof S=="number"){const r=[];return S&P.FileChangeFilter.ADDED&&r.push("Added"),S&P.FileChangeFilter.DELETED&&r.push("Deleted"),S&P.FileChangeFilter.UPDATED&&r.push("Updated"),r.length===0?"<all>":`[${r.join(", ")}]`}return"<none>"}}),define(ce[217],le([0,1,17,53,16,3,2,67,33,15,62]),function(V,e,i,o,E,D,R,P,y,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=void 0,e.$CQ="localFilesystem";class d extends R.$Vc{constructor(b,u){super(),this.a=b,this.b=u,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$le),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$le),this.onDidWatchError=this.g.event,this.h=(0,y.$1g)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(b){return this.a.call("stat",[b])}readdir(b){return this.a.call("readdir",[b])}async readFile(b,u){const{buffer:m}=await this.a.call("readFile",[b,u]);return m}readFileStream(b,u,m){const p=(0,P.$Be)(w=>i.$Ne.concat(w.map(v=>i.$Ne.wrap(v))).buffer),$=new R.$Uc;return $.add(this.a.listen("readFileStream",[b,u])(w=>{if(w instanceof i.$Ne)p.write(w.buffer);else{if(w==="end")p.end();else{let v;if(w instanceof Error)v=w;else{const S=w;v=(0,c.$ll)(S.message??(0,o.$pj)(S),S.code??c.FileSystemProviderErrorCode.Unknown)}p.error(v),p.end()}$.dispose()}})),$.add(m.onCancellationRequested(()=>{p.error((0,E.$7)()),p.end(),$.dispose()})),p}writeFile(b,u,m){return this.a.call("writeFile",[b,i.$Ne.wrap(u),m])}open(b,u){return this.a.call("open",[b,u])}close(b){return this.a.call("close",[b])}async read(b,u,m,p,$){const[w,v]=await this.a.call("read",[b,u,$]);return m.set(w.buffer.slice(0,v),p),v}write(b,u,m,p,$){return this.a.call("write",[b,u,i.$Ne.wrap(m),p,$])}mkdir(b){return this.a.call("mkdir",[b])}delete(b,u){return this.a.call("delete",[b,u])}rename(b,u,m){return this.a.call("rename",[b,u,m])}copy(b,u,m){return this.a.call("copy",[b,u,m])}cloneFile(b,u){return this.a.call("cloneFile",[b,u])}j(){this.B(this.a.listen("fileChange",[this.h])(b=>{if(Array.isArray(b)){const u=b;this.f.fire((0,h.$2q)(u))}else{const u=b;this.g.fire(u)}}))}watch(b,u){const m=(0,y.$1g)();return this.a.call("watch",[this.h,m,b,u]),(0,R.$Tc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$DQ=d}),define(ce[218],le([0,1,47,2,62,3,15,7,8]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class c extends o.$Vc{constructor(){super(),this.a=this.B(new D.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new o.$5c),this.m=new Set,this.n=this.B(new y.$Ch(this.y())),this.r=5007,this.s=new y.$2h,this.R=!1,this.B(this.f(d=>this.t(d)))}t(d){this.u(d)&&this.z(d)}u(d){return(0,E.$Wq)(d)}async watch(d){this.s.isSettled||this.s.complete(),this.s=new y.$2h;try{this.h.clear(),this.g.clear();for(const g of d)this.u(g)?this.h.set(g.correlationId,g):this.g.add(g);for(const[g]of this.j)this.h.has(g)||(this.j.deleteAndDispose(g),this.m.delete(g));return await this.w(!1)}finally{this.s.complete()}}w(d){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))]),d?this.y():0)}y(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async z(d){if(this.j.has(d.correlationId))return;const g=new o.$Uc;this.j.set(d.correlationId,g),await this.s.p,!g.isDisposed&&(this.D(d,g),this.w(!0))}C(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.w(!1)}D(d,g){this.F(d,g)?(this.P(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.G(d,g),this.m.add(d.correlationId))}F(d,g){const b=this.O?.subscribe(d.path,(u,m)=>{g.isDisposed||(u?this.D(d,g):m?.type===R.FileChangeType.ADDED&&this.H(d))});return b?(g.add(b),!0):!1}G(d,g){let b=!1;const u=(m,p)=>{if(g.isDisposed)return;const $=this.I(m),w=this.I(p),v=b;b=$,!$&&(w||v)&&this.H(d)};this.P(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,i.watchFile)(d.path,{persistent:!1,interval:this.r},u)}catch(m){this.Q(`fs.watchFile() failed with error ${m} on path ${d.path} (correlationId: ${d.correlationId})`)}g.add((0,o.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,i.unwatchFile)(d.path,u)}catch(m){this.Q(`fs.unwatchFile() failed with error ${m} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}H(d){this.P(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const g={resource:P.URI.file(d.path),type:R.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([g]),this.J(g,d),this.C(d)}I(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(d,g){if(this.R){const b=` >> normalized ${d.type===R.FileChangeType.ADDED?"[ADDED]":d.type===R.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.L(b,g)}}L(d,g){this.R&&this.P(`${d}${typeof g.correlationId=="number"?` <${g.correlationId}> `:""}`)}M(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,E.$7q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.R=d}}e.$dr=c}),define(ce[219],le([0,1,47,8,23,31,2,77,9,4,19,7,114,21,15,62]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=$;class p extends R.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(v,S,r,t,n,a){super(),this.s=v,this.t=S,this.u=r,this.w=t,this.y=n,this.z=a,this.c=this.B(new o.$Th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new o.$Sh(s=>this.M(s),p.b)),this.g=(0,m.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,m.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,m.$Wq)(this.s)?this.s.filter:void 0,this.m=new E.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const v=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await b.Promises.stat(v);if(this.m.token.isCancellationRequested)return;this.B(await this.G(v,S.isDirectory()))}catch(v){v.code!=="ENOENT"?this.O(v):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${v})`),this.D()}}D(){this.r=!0,this.w?.()}async F(v){let S=v.path;try{S=await b.Promises.realpath(v.path),v.path===S&&(S=await(0,g.$fr)(v.path,this.m.token)??v.path),v.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${S})`)}catch{}return S}async G(v,S){const r=new R.$Uc;return this.H(v,S,r)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(v,S,r)),r}H(v,S,r){if(S)return!1;const t=d.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(a,s)=>{if(!r.isDisposed)if(a){const l=await this.G(v,S);r.isDisposed?l.dispose():r.add(l)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:s.type,cId:this.s.correlationId},!0)});return n?(r.add(n),!0):!1}async I(v,S,r){if(c.$j&&(0,D.$Dg)(v,"/Volumes/",!0)){this.O(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new E.$we(this.m.token);r.add((0,R.$Tc)(()=>t.dispose(!0)));const n=new R.$Uc;r.add(n);try{const a=d.URI.file(this.s.path),s=(0,y.$oc)(v),l=(0,i.watch)(v);n.add((0,R.$Tc)(()=>{l.removeAllListeners(),l.close()})),this.Q(`Started watching: '${v}'`);const f=new Set;if(S)try{for(const I of await b.Promises.readdir(v))f.add(I)}catch(I){this.O(I)}if(t.token.isCancellationRequested)return;const k=new Map;n.add((0,R.$Tc)(()=>{for(const[,I]of k)I.dispose();k.clear()})),l.on("error",(I,O)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${v} for changes using fs.watch() (${I}, ${O})`),this.D())}),l.on("change",(I,O)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${I}"] ${O}`);let L="";if(O&&(L=O.toString(),c.$j&&(L=(0,P.$lm)(L))),!(!L||I!=="change"&&I!=="rename"))if(S)if(I==="rename"){k.get(L)?.dispose();const T=setTimeout(async()=>{if(k.delete(L),L===s&&!await b.Promises.exists(v)){this.J(a);return}if(t.token.isCancellationRequested)return;const A=await this.N((0,y.$kc)(v,L));if(t.token.isCancellationRequested)return;let M;A?f.has(L)?M=u.FileChangeType.UPDATED:(M=u.FileChangeType.ADDED,f.add(L)):(f.delete(L),M=u.FileChangeType.DELETED),this.L({resource:(0,h.$fh)(a,L),type:M,cId:this.s.correlationId})},p.a);k.set(L,(0,R.$Tc)(()=>clearTimeout(T)))}else{let T;f.has(L)?T=u.FileChangeType.UPDATED:(T=u.FileChangeType.ADDED,f.add(L)),this.L({resource:(0,h.$fh)(a,L),type:T,cId:this.s.correlationId})}else if(I==="rename"||L!==s){const T=setTimeout(async()=>{const A=await b.Promises.exists(v);t.token.isCancellationRequested||(A?(this.L({resource:a,type:u.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(v,!1))):this.J(a))},p.a);n.clear(),n.add((0,R.$Tc)(()=>clearTimeout(T)))}else this.L({resource:a,type:u.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(a){t.token.isCancellationRequested||this.O(`Failed to watch ${v} for changes using fs.watch() (${a.toString()})`),this.D()}}J(v){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:v,type:u.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(v,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${v.type===u.FileChangeType.ADDED?"[ADDED]":v.type===u.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`),!S&&this.g.some(r=>r(v.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${v.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(r=>r(v.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${v.resource.fsPath}`):this.f.work(v))}M(v){const S=(0,m.$3q)(v),r=[];for(const n of S){if((0,m.$6q)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}r.push(n)}if(r.length===0)return;if(this.z)for(const n of r)this.R(` >> normalized ${n.type===u.FileChangeType.ADDED?"[ADDED]":n.type===u.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(v){if(c.$k)return b.Promises.exists(v);try{const S=(0,y.$oc)(v);return(await b.Promises.readdir((0,y.$nc)(v))).some(t=>t===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(v){this.z=v}O(v){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}P(v){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}Q(v){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}R(v){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${v}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=p;async function $(w,v,S,r,t=512){const n=await b.Promises.open(w,"r"),a=Buffer.allocUnsafe(t),s=new E.$we(r);let l,f=!1;const k={path:w,excludes:[],recursive:!1},I=new p(k,void 0,O=>{(async()=>{for(const{type:L}of O)if(L===u.FileChangeType.UPDATED){if(f)return;f=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:T}=await b.Promises.read(n,a,0,t,null);if(!T||s.token.isCancellationRequested)break;v(a.slice(0,T))}}catch(T){l=new Error(T),s.dispose(!0)}finally{f=!1}}})()});return await I.ready,S(),new Promise((O,L)=>{s.token.onCancellationRequested(async()=>{I.dispose();try{await b.Promises.close(n)}catch(T){l=new Error(T)}l?L(l):O()})})}}),define(ce[220],le([0,1,3,113,218,4,219,31]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class y extends E.$dr{constructor(h){super(),this.O=h,this.onDidError=i.Event.None,this.watchers=new Set}async N(h){h=this.Z(h);const d=[],g=new Set(Array.from(this.watchers));for(const b of h){const u=this.W(b);u&&(0,o.$Ck)(u.request.excludes,b.excludes)&&(0,o.$Ck)(u.request.includes,b.includes)?g.delete(u):d.push(b)}d.length&&this.P(`Request to start watching: ${d.map(b=>this.M(b)).join(",")}`),g.size&&this.P(`Request to stop watching: ${Array.from(g).map(b=>this.M(b.request)).join(",")}`);for(const b of g)this.Y(b);for(const b of d)this.X(b)}W(h){for(const d of this.watchers)if(typeof h.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===h.correlationId)return d}else if((0,P.$Cg)(d.request.path,h.path,!D.$k))return d}X(h){const d=new R.$ir(h,this.O,b=>this.a.fire(b),()=>this.c.fire(h),b=>this.b.fire(b),this.R),g={request:h,instance:d};this.watchers.add(g)}async stop(){await super.stop();for(const h of this.watchers)this.Y(h)}Y(h){this.P("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}Z(h){const d=new Map;for(const g of h){const b=D.$k?g.path:g.path.toLowerCase();let u=d.get(g.correlationId);u||(u=new Map,d.set(g.correlationId,u)),u.has(b)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(g)}`),u.set(b,g)}return Array.from(d.values()).map(g=>Array.from(g.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const d of this.watchers)d.instance.setVerboseLogging(h)}P(h,d){this.R&&this.b.fire({type:"trace",message:this.bb(h,d)})}Q(h){this.b.fire({type:"warn",message:this.bb(h)})}bb(h,d){return d?`[File Watcher (node.js)] ${h} (${this.M(d.request)})`:`[File Watcher (node.js)] ${h}`}}e.$kr=y}),define(ce[221],le([0,1,62,220]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class E extends i.$Zq{constructor(R,P,y){super(R,P,y),this.s()}r(R){return R.add(new o.$kr(void 0))}}e.$lr=E}),define(ce[222],le([0,1,13,44,165,62]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class R extends D.$1q{constructor(y,c,h){super(y,c,h),this.s()}r(y){const c=y.add(new E.$br(i.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(c.onDidProcessExit(({code:h,signal:d})=>this.t(`terminated by itself with code ${h}, signal: ${d} (ETERM)`))),o.ProxyChannel.toService((0,o.$li)(c.getChannel("watcher")))}}e.$cr=R}),define(ce[98],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class i{constructor(...E){this.a=new Map;for(const[D,R]of E)this.set(D,R)}set(E,D){const R=this.a.get(E);return this.a.set(E,D),R}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ci=i}),define(ce[223],le([0,1,8,16,2,82,212,6,98,109]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const h=!1;class d extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class g{constructor(p=new y.$Ci,$=!1,w,v=h){this.i=p,this.j=$,this.k=w,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$Di,this),this._globalGraph=v?w?._globalGraph??new R.$or(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Qc)(this.h),this.h.clear();for(const p of this.g)(0,E.$Pc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p,$){this.m();const w=this,v=new class extends g{dispose(){w.h.delete(v),super.dispose()}}(p,this.j,this,this.l);return this.h.add(v),$?.add(v),v}invokeFunction(p,...$){this.m();const w=u.traceInvocation(this.l,p);let v=!1;try{return p({get:r=>{if(v)throw(0,o.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(r,w);if(!t)throw new Error(`[invokeFunction] unknown service '${r}'`);return t}},...$)}finally{v=!0,w.stop()}}createInstance(p,...$){this.m();let w,v;return p instanceof D.$Bi?(w=u.traceCreation(this.l,p.ctor),v=this.o(p.ctor,p.staticArguments.concat($),w)):(w=u.traceCreation(this.l,p),v=this.o(p,$,w)),w.stop(),v}o(p,$=[],w){const v=P._util.getServiceDependencies(p).sort((t,n)=>t.index-n.index),S=[];for(const t of v){const n=this.s(t.id,w);n||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(n)}const r=v.length>0?v[0].index:$.length;if($.length!==r){console.trace(`[createInstance] First service dependency of ${p.name} at position ${r+1} conflicts with ${$.length} static arguments`);const t=r-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,r)}return Reflect.construct(p,$.concat(S))}q(p,$){if(this.i.get(p)instanceof D.$Bi)this.i.set(p,$);else if(this.k)this.k.q(p,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const $=this.i.get(p);return!$&&this.k?this.k.r(p):$}s(p,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const w=this.r(p);return w instanceof D.$Bi?this.u(p,w,$.branch(p,!0)):($.branch(p,!1),w)}u(p,$,w){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,$,w)}finally{this.t.delete(p)}}v(p,$,w){const v=new R.$or(t=>t.id.toString());let S=0;const r=[{id:p,desc:$,_trace:w}];for(;r.length;){const t=r.pop();if(v.lookupOrInsertNode(t),S++>1e3)throw new d(v);for(const n of P._util.getServiceDependencies(t.desc.ctor)){const a=this.r(n.id);if(a||this.y(`[createInstance] ${p} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),a instanceof D.$Bi){const s={id:n.id,desc:a,_trace:t._trace.branch(n.id,!0)};v.insertEdge(t,s),r.push(s)}}}for(;;){const t=v.roots();if(t.length===0){if(!v.isEmpty())throw new d(v);break}for(const{data:n}of t){if(this.r(n.id)instanceof D.$Bi){const s=this.w(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.q(n.id,s)}v.removeNode(n)}}return this.r(p)}w(p,$,w=[],v,S){if(this.i.get(p)instanceof D.$Bi)return this.x(p,$,w,v,S,this.g);if(this.k)return this.k.w(p,$,w,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(p,$,w=[],v,S,r){if(v){const t=new g(void 0,this.j,this,this.l);t.c=String(p);const n=new Map,a=new i.$Xh(()=>{const s=t.o($,w,S);for(const[l,f]of n){const k=s[l];if(typeof k=="function")for(const I of f)I.disposable=k.apply(s,I.listener)}return n.clear(),r.add(s),s});return new Proxy(Object.create(null),{get(s,l){if(!a.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let I=n.get(l);return I||(I=new c.$6c,n.set(l,I)),(L,T,A)=>{if(a.isInitialized)return a.value[l](L,T,A);{const M={listener:[L,T,A],disposable:void 0},z=I.push(M);return(0,E.$Tc)(()=>{z(),M.disposable?.dispose()})}}}if(l in s)return s[l];const f=a.value;let k=f[l];return typeof k!="function"||(k=k.bind(f),s[l]=k),k},set(s,l,f){return a.value[l]=f,!0},getPrototypeOf(s){return $.prototype}})}else{const t=this.o($,w,S);return r.add(t),t}}y(p,$){if($&&console.warn(p),this.j)throw new Error(p)}}e.$pr=g;var b;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(b||(b={}));class u{static{this.all=new Set}static{this.c=new class extends u{constructor(){super(b.None,null)}stop(){}branch(){return this}}}static traceInvocation(p,$){return p?new u(b.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u.c}static traceCreation(p,$){return p?new u(b.Creation,$.name):u.c}static{this.f=0}constructor(p,$){this.type=p,this.name=$,this.g=Date.now(),this.h=[]}branch(p,$){const w=new u(b.Branch,p.toString());return this.h.push([p,$,w]),w}stop(){const p=Date.now()-this.g;u.f+=p;let $=!1;function w(S,r){const t=[],n=new Array(S+1).join("	");for(const[a,s,l]of r.h)if(s&&l){$=!0,t.push(`${n}CREATES -> ${a}`);const f=w(S+1,l);f&&t.push(f)}else t.push(`${n}uses -> ${a}`);return t.join(`
`)}const v=[`${this.type===b.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${u.f.toFixed(2)}ms)`];(p>2||$)&&u.all.add(v.join(`
`))}}e.$qr=u}),define(ce[224],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=e.IssueSource=e.IssueType=void 0;var o;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(o||(e.IssueType=o={}));var E;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(E||(e.IssueSource=E={})),e.$a$b=(0,i.$Ei)("issueService")}),define(ce[5],le([0,1,186,53,3,46,2,32,4,19,12,7,123,6]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=m,e.log=$,e.$mk=k,e.$nk=I,e.$ok=O,e.$pk=L,i=Ae(i),e.$$j=(0,b.$Ei)("logService"),e.$_j=(0,b.$Ei)("loggerService");function u(){return new Date().toISOString()}function m(T){return(0,h.$ig)(T)}var p;(function(T){T[T.Off=0]="Off",T[T.Trace=1]="Trace",T[T.Debug=2]="Debug",T[T.Info=3]="Info",T[T.Warning=4]="Warning",T[T.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$bk=p.Info;function $(T,A,M){switch(A){case p.Trace:T.trace(M);break;case p.Debug:T.debug(M);break;case p.Info:T.info(M);break;case p.Warning:T.warn(M);break;case p.Error:T.error(M);break;case p.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function w(T,A=!1){let M="";for(let z=0;z<T.length;z++){let C=T[z];if(C instanceof Error&&(C=(0,o.$pj)(C,A)),typeof C=="object")try{C=JSON.stringify(C)}catch{}M+=(z>0?" ":"")+C}return M}class v extends R.$Vc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new E.$le),this.onDidChangeLogLevel=this.c.event}setLevel(A){this.b!==A&&(this.b=A,this.c.fire(this.b))}getLevel(){return this.b}f(A){return this.b!==p.Off&&this.b<=A}}e.$dk=v;class S extends v{constructor(A){super(),this.h=A}f(A){return this.h||super.f(A)}trace(A,...M){this.f(p.Trace)&&this.g(p.Trace,w([A,...M],!0))}debug(A,...M){this.f(p.Debug)&&this.g(p.Debug,w([A,...M]))}info(A,...M){this.f(p.Info)&&this.g(p.Info,w([A,...M]))}warn(A,...M){this.f(p.Warning)&&this.g(p.Warning,w([A,...M]))}error(A,...M){if(this.f(p.Error))if(A instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=A.stack,this.g(p.Error,w(z))}else this.g(p.Error,w([A,...M]))}flush(){}}e.$ek=S;class r extends v{constructor(A=e.$bk){super(),this.setLevel(A),this.g=!y.$i}trace(A,...M){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,A,...M):console.log(`[main ${u()}]`,A,...M))}debug(A,...M){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,A,...M):console.log(`[main ${u()}]`,A,...M))}info(A,...M){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,A,...M):console.log(`[main ${u()}]`,A,...M))}warn(A,...M){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,A,...M):console.warn(`[main ${u()}]`,A,...M))}error(A,...M){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,A,...M):console.error(`[main ${u()}]`,A,...M))}flush(){}}e.$fk=r;class t extends v{constructor(A=e.$bk,M=!0){super(),this.g=M,this.setLevel(A)}trace(A,...M){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",A,...M):console.log(A,...M))}debug(A,...M){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",A,...M):console.log(A,...M))}info(A,...M){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",A,...M):console.log(A,...M))}warn(A,...M){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",A,...M):console.log(A,...M))}error(A,...M){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",A,...M):console.error(A,...M))}flush(){}}e.$gk=t;class n extends v{constructor(A,M=e.$bk){super(),this.g=A,this.setLevel(M)}trace(A,...M){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(A),...M])}debug(A,...M){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(A),...M])}info(A,...M){this.f(p.Info)&&this.g.log(p.Info,[this.h(A),...M])}warn(A,...M){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(A),...M])}error(A,...M){this.f(p.Error)&&this.g.log(p.Error,[this.h(A),...M])}h(A){return typeof A=="string"?A:(0,o.$pj)(A,this.f(p.Trace))}flush(){}}e.$hk=n;class a extends v{constructor(A){super(),this.g=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const M of this.g)M.setLevel(A);super.setLevel(A)}trace(A,...M){for(const z of this.g)z.trace(A,...M)}debug(A,...M){for(const z of this.g)z.debug(A,...M)}info(A,...M){for(const z of this.g)z.info(A,...M)}warn(A,...M){for(const z of this.g)z.warn(A,...M)}error(A,...M){for(const z of this.g)z.error(A,...M)}flush(){for(const A of this.g)A.flush()}dispose(){for(const A of this.g)A.dispose();super.dispose()}}e.$ik=a;class s extends R.$Vc{constructor(A,M,z){if(super(),this.h=A,this.j=M,this.b=new P.$Bc,this.c=this.B(new E.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$le),this.onDidChangeVisibility=this.g.event,z)for(const C of z)this.b.set(C.resource,{logger:void 0,info:C})}m(A){return(0,h.$eg)(A)?[...this.b.values()].find(M=>M.info.id===A):this.b.get(A)}getLogger(A){return this.m(A)?.logger}createLogger(A,M){const z=this.n(A),C=(0,h.$eg)(A)?A:M?.id??(0,D.$sj)(z.toString()).toString(16);let B=this.b.get(z)?.logger;const re=M?.logLevel==="always"?p.Trace:M?.logLevel;B||(B=this.s(z,re??this.getLogLevel(z)??this.h,{...M,id:C}));const _={logger:B,info:{resource:z,id:C,logLevel:re,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(_.info),this.b.set(z,_),B}n(A){return(0,h.$eg)(A)?(0,c.$fh)(this.j,`${A}.log`):A}setLogLevel(A,M){if(d.URI.isUri(A)){const z=A,C=M,B=this.b.get(z);B&&C!==B.info.logLevel&&(B.info.logLevel=C===this.h?void 0:C,B.logger?.setLevel(C),this.b.set(B.info.resource,B),this.f.fire([z,C]))}else{this.h=A;for(const[z,C]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&C.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(A,M){const z=this.m(A);z&&M!==!z.info.hidden&&(z.info.hidden=!M,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,M]))}getLogLevel(A){let M;return A&&(M=this.b.get(A)?.info.logLevel),M??this.h}registerLogger(A){const M=this.b.get(A.resource);M?M.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this.b.set(A.resource,{info:A,logger:void 0}),this.c.fire({added:[A],removed:[]}))}deregisterLogger(A){const M=this.b.get(A);M&&(M.logger&&M.logger.dispose(),this.b.delete(A),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const A of this.b.values())yield A.info}getRegisteredLogger(A){return this.b.get(A)?.info}dispose(){this.b.forEach(A=>A.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=s;class l{constructor(){this.onDidChangeLogLevel=new E.$le().event}setLevel(A){}getLevel(){return p.Info}trace(A,...M){}debug(A,...M){}info(A,...M){}warn(A,...M){}error(A,...M){}critical(A,...M){}dispose(){}flush(){}}e.$kk=l;class f extends l{}e.$lk=f;function k(T){if(T.verbose)return p.Trace;if(typeof T.logLevel=="string"){const A=L(T.logLevel.toLowerCase());if(A!==void 0)return A}return e.$bk}function I(T){switch(T){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function O(T){switch(T){case p.Trace:return{original:"Trace",value:i.localize(0,null)};case p.Debug:return{original:"Debug",value:i.localize(1,null)};case p.Info:return{original:"Info",value:i.localize(2,null)};case p.Warning:return{original:"Warning",value:i.localize(3,null)};case p.Error:return{original:"Error",value:i.localize(4,null)};case p.Off:return{original:"Off",value:i.localize(5,null)}}}function L(T){switch(T){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$qk=new g.$Vj("logLevel",I(p.Info))});var oe=this&&this.__param||function(V,e){return function(i,o){e(i,o,V)}};define(ce[225],le([0,1,14,4,97,5]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;const R=i.safeStorage;let P=class{constructor(c){this.a=c,i.app.commandLine.getSwitchValue("password-store")===E.PasswordStoreCLIOption.basic&&R.setUsePlainTextEncryption?.(!0)}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value.");try{const h=JSON.stringify(R.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),h}catch(h){throw this.a.error(h),h}}async decrypt(c){let h;try{if(h=JSON.parse(c),!h.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const d=Buffer.from(h.data);this.a.trace("[EncryptionMainService] Decrypting value.");const g=R.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),g}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(o.$i)return Promise.resolve(E.KnownStorageProvider.dplib);if(o.$j)return Promise.resolve(E.KnownStorageProvider.keychainAccess);if(R.getSelectedStorageBackend)try{const c=R.getSelectedStorageBackend();return Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(E.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(o.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(o.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$nec=P,e.$nec=P=Se([oe(0,D.$$j)],P)}),define(ce[226],le([0,1,22,8,16,3,31,2,9,62,5]),function(V,e,i,o,E,D,R,P,y,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class d extends P.$Vc{constructor(b,u){super(),this.a=b,this.b=u,this.c=this.B(new D.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new o.$Ch(0)),this.w=[],this.y=this.B(new o.$Ch(0))}watch(b,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(b,u):this.z(b,u)}n(b,u){const m={path:this.J(b),excludes:u.excludes,includes:u.includes,recursive:u.recursive,filter:u.filter,correlationId:u.correlationId},p=(0,i.$Ub)(this.j,m);return this.r(),(0,P.$Tc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,E.$2)(b))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,c.$2q)(u)),u=>this.G(u),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const u of this.j)(0,c.$Xq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const u of this.j)(0,c.$Xq)(u)&&b.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,u){const m={path:this.J(b),excludes:u.excludes,includes:u.includes,recursive:!1,filter:u.filter,correlationId:u.correlationId},p=(0,i.$Ub)(this.w,m);return this.C(),(0,P.$Tc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,E.$2)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,c.$2q)(b)),b=>this.G(b),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.H(b)}H(b){this.a[b.type](b.message)}I(b){return(0,y.$ic)(b.fsPath)}J(b){const u=this.I(b);return(0,R.$Gg)(u)}}e.$8q=d}),define(ce[227],le([0,1,22,8,17,23,3,46,76,2,61,13,70,19,67,180,15,125,5,16]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let r=class extends c.$Vc{static{S=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new R.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new R.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new R.$le),this.Y=this.B(new R.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new R.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new o.$Nh)}registerProvider(n,a){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${n}`);const s=new c.$Uc;return this.h.set(n,a),this.c.fire({added:!0,scheme:n,provider:a}),s.add(a.onDidChangeFile(l=>{const f=new p.$rl(l,!this.S(a));this.X.fire(f),f.hasCorrelation()||this.Y.fire(f)})),typeof a.onDidWatchError=="function"&&s.add(a.onDidWatchError(l=>this.Z.fire(new Error(l)))),s.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:n}))),(0,c.$Tc)(()=>{this.c.fire({added:!1,scheme:n,provider:a}),this.h.delete(n),(0,c.$Qc)(s)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const a=[];this.f.fire({scheme:n,join(s){a.push(s)}}),!this.h.has(n)&&await o.Promises.settled(a)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,a){const s=this.h.get(n.scheme);return!!(s&&s.capabilities&a)}listCapabilities(){return y.Iterable.map(this.h,([n,a])=>({scheme:n,capabilities:a.capabilities}))}async j(n){if(!(0,b.$jh)(n))throw new p.$tl((0,m.localize)(0,null,this.sb(n)),p.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const a=this.h.get(n.scheme);if(!a){const s=new v.$cb;throw s.message=(0,m.localize)(1,null,n.toString()),s}return a}async m(n){const a=await this.j(n);if((0,p.$el)(a)||(0,p.$bl)(a)||(0,p.$fl)(a))return a;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const a=await this.j(n);if((0,p.$el)(a)||(0,p.$bl)(a))return a;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,a){try{return await this.s(n,a)}catch(s){throw(0,p.$ol)(s)===p.FileSystemProviderErrorCode.FileNotFound?new p.$tl((0,m.localize)(2,null,this.sb(n)),p.FileOperationResult.FILE_NOT_FOUND):(0,p.$ml)(s)}}async s(n,a){const s=await this.j(n),l=this.S(s),f=a?.resolveTo,k=a?.resolveSingleChildDescendants,I=a?.resolveMetadata,O=await s.stat(n);let L;return this.t(s,n,O,void 0,!!I,(T,A)=>(L||(L=h.$Ki.forUris(()=>!l),L.set(n,!0),f&&L.fill(!0,f)),L.get(T.resource)||L.findSuperstr(T.resource.with({query:null,fragment:null}))?!0:T.isDirectory&&k?A===1:!1))}async t(n,a,s,l,f,k){const{providerExtUri:I}=this.R(n),O={resource:a,name:I.basename(a),isFile:(s.type&p.FileType.File)!==0,isDirectory:(s.type&p.FileType.Directory)!==0,isSymbolicLink:(s.type&p.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&p.FilePermission.Readonly)||!!(n.capabilities&p.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&p.FilePermission.Locked),etag:(0,p.$El)({mtime:s.mtime,size:s.size}),children:void 0};if(O.isDirectory&&k(O,l)){try{const L=await n.readdir(a),T=await o.Promises.settled(L.map(async([A,M])=>{try{const z=I.joinPath(a,A),C=f?await n.stat(z):{type:M};return await this.t(n,z,C,L.length,f,k)}catch(z){return this.b.trace(z),null}}));O.children=(0,i.$Ib)(T)}catch(L){this.b.trace(L),O.children=[]}return O}return O}async resolveAll(n){return o.Promises.settled(n.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(n){const a=await this.j(n),s=await a.stat(n);return this.t(a,n,s,void 0,!0,()=>!1)}async exists(n){const a=await this.j(n);try{return!!await a.stat(n)}catch{return!1}}async canCreateFile(n,a){try{await this.u(n,a)}catch(s){return s}return!0}async u(n,a){if(!a?.overwrite&&await this.exists(n))throw new p.$tl((0,m.localize)(3,null,this.sb(n)),p.FileOperationResult.FILE_MODIFIED_SINCE,a)}async createFile(n,a=E.$Ne.fromString(""),s){await this.u(n,s);const l=await this.writeFile(n,a);return this.r.fire(new p.$ql(n,p.FileOperation.CREATE,l)),l}async writeFile(n,a,s){const l=this.qb(await this.n(n),n),{providerExtUri:f}=this.R(l);let k=s;if((0,p.$hl)(l)&&!k?.atomic){const I=l.enforceAtomicWriteFile?.(n);I&&(k={...s,atomic:I})}try{await this.w(l,n,k)||await this.U(l,f.dirname(n));let O;if((0,p.$bl)(l)&&!(a instanceof E.$Ne))if((0,u.$ze)(a)){const L=await(0,u.$Ge)(a,3);L.ended?O=E.$Ne.concat(L.buffer):O=L}else O=(0,u.$De)(a,L=>E.$Ne.concat(L),3);else O=a;!(0,p.$el)(l)||(0,p.$bl)(l)&&O instanceof E.$Ne||(0,p.$bl)(l)&&(0,p.$hl)(l)&&k?.atomic?await this.hb(l,n,k,O):await this.db(l,n,k,O instanceof E.$Ne?(0,E.$Ye)(O):O),this.r.fire(new p.$ql(n,p.FileOperation.WRITE))}catch(I){throw new p.$tl((0,m.localize)(4,null,this.sb(n),(0,p.$ml)(I).toString()),(0,p.$pl)(I),k)}return this.resolve(n,{resolveMetadata:!0})}async w(n,a,s){const l=!!s?.unlock;if(l&&!(n.capabilities&p.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(5,null,this.sb(a)));if(!!s?.atomic){if(!(n.capabilities&p.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(6,null,this.sb(a)));if(!(n.capabilities&p.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(7,null,this.sb(a)));if(l)throw new Error((0,m.localize)(8,null,this.sb(a)))}let k;try{k=await n.stat(a)}catch{return}if(k.type&p.FileType.Directory)throw new p.$tl((0,m.localize)(9,null,this.sb(a)),p.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(a,k),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==p.$Dl&&typeof k.mtime=="number"&&typeof k.size=="number"&&s.mtime<k.mtime&&s.etag!==(0,p.$El)({mtime:s.mtime,size:k.size}))throw new p.$tl((0,m.localize)(10,null),p.FileOperationResult.FILE_MODIFIED_SINCE,s);return k}async readFile(n,a,s){const l=await this.m(n);return a?.atomic?this.z(l,n,a,s):this.C(l,n,a,s)}async z(n,a,s,l){return new Promise((f,k)=>{this.cb.queueFor(a,async()=>{try{const I=await this.C(n,a,s,l);f(I)}catch(I){k(I)}},this.R(n).providerExtUri)})}async C(n,a,s,l){const f=await this.D(n,a,{...s,preferUnbuffered:!0},l);return{...f,value:await(0,E.$Ze)(f.value)}}async readFileStream(n,a,s){const l=await this.m(n);return this.D(l,n,a,s)}async D(n,a,s,l){const f=new D.$we(l);let k=s;(0,p.$gl)(n)&&n.enforceAtomicReadFile?.(a)&&(k={...s,atomic:!0});const I=this.J(a,k).then(L=>L,L=>{throw f.dispose(!0),L});let O;try{return typeof k?.etag=="string"&&k.etag!==p.$Dl&&await I,k?.atomic&&(0,p.$gl)(n)||!((0,p.$el)(n)||(0,p.$fl)(n))||(0,p.$bl)(n)&&k?.preferUnbuffered?O=this.I(n,a,k):(0,p.$fl)(n)?O=this.G(n,a,f.token,k):O=this.H(n,a,f.token,k),O.on("end",()=>f.dispose()),O.on("error",()=>f.dispose()),{...await I,value:O}}catch(L){throw O&&await(0,u.$Ee)(O),this.F(L,a,k)}}F(n,a,s){const l=(0,m.localize)(11,null,this.sb(a),(0,p.$ml)(n).toString());return n instanceof p.$vl?new p.$vl(l,n.stat,s):n instanceof p.$ul?new p.$ul(l,n.fileOperationResult,n.size,n.options):new p.$tl(l,(0,p.$pl)(n),s)}G(n,a,s,l=Object.create(null)){const f=n.readFileStream(a,l,s);return(0,u.$Ke)(f,{data:k=>k instanceof E.$Ne?k:E.$Ne.wrap(k),error:k=>this.F(k,a,l)},k=>E.$Ne.concat(k))}H(n,a,s,l=Object.create(null)){const f=(0,E.$4e)();return(0,$.$Uq)(n,a,f,k=>k,{...l,bufferSize:this.a,errorTransformer:k=>this.F(k,a,l)},s),f}I(n,a,s){const l=(0,u.$Be)(f=>E.$Ne.concat(f));return(async()=>{try{let f;s?.atomic&&(0,p.$gl)(n)?f=await n.readFile(a,{atomic:!0}):f=await n.readFile(a),typeof s?.position=="number"&&(f=f.slice(s.position)),typeof s?.length=="number"&&(f=f.slice(0,s.length)),this.L(a,f.byteLength,s),l.end(E.$Ne.wrap(f))}catch(f){l.error(f),l.end()}})(),l}async J(n,a){const s=await this.resolve(n,{resolveMetadata:!0});if(s.isDirectory)throw new p.$tl((0,m.localize)(12,null,this.sb(n)),p.FileOperationResult.FILE_IS_DIRECTORY,a);if(typeof a?.etag=="string"&&a.etag!==p.$Dl&&a.etag===s.etag)throw new p.$vl((0,m.localize)(13,null),s,a);return this.L(n,s.size,a),s}L(n,a,s){if(typeof s?.limits?.size=="number"&&a>s.limits.size)throw new p.$ul((0,m.localize)(14,null,this.sb(n)),p.FileOperationResult.FILE_TOO_LARGE,a,s)}async canMove(n,a,s){return this.M(n,a,"move",s)}async canCopy(n,a,s){return this.M(n,a,"copy",s)}async M(n,a,s,l){if(n.toString()!==a.toString())try{const f=s==="move"?this.qb(await this.n(n),n):await this.m(n),k=this.qb(await this.n(a),a);await this.Q(f,n,k,a,s,l)}catch(f){return f}return!0}async move(n,a,s){const l=this.qb(await this.n(n),n),f=this.qb(await this.n(a),a),k=await this.N(l,n,f,a,"move",!!s),I=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new p.$ql(n,k==="move"?p.FileOperation.MOVE:p.FileOperation.COPY,I)),I}async copy(n,a,s){const l=await this.m(n),f=this.qb(await this.n(a),a),k=await this.N(l,n,f,a,"copy",!!s),I=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new p.$ql(n,k==="copy"?p.FileOperation.COPY:p.FileOperation.MOVE,I)),I}async N(n,a,s,l,f,k){if(a.toString()===l.toString())return f;const{exists:I,isSameResourceWithDifferentPathCase:O}=await this.Q(n,a,s,l,f,k);if(I&&!O&&k&&await this.del(l,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(l)),f==="copy"){if(n===s&&(0,p.$cl)(n))await n.copy(a,l,{overwrite:k});else{const L=await this.resolve(a);L.isDirectory?await this.P(n,L,s,l):await this.O(n,a,s,l)}return f}else return n===s?(await n.rename(a,l,{overwrite:k}),f):(await this.N(n,a,s,l,"copy",k),await this.del(a,{recursive:!0}),"copy")}async O(n,a,s,l){if((0,p.$el)(n)&&(0,p.$el)(s))return this.jb(n,a,s,l);if((0,p.$el)(n)&&(0,p.$bl)(s))return this.pb(n,a,s,l);if((0,p.$bl)(n)&&(0,p.$el)(s))return this.nb(n,a,s,l);if((0,p.$bl)(n)&&(0,p.$bl)(s))return this.lb(n,a,s,l)}async P(n,a,s,l){await s.mkdir(l),Array.isArray(a.children)&&await o.Promises.settled(a.children.map(async f=>{const k=this.R(s).providerExtUri.joinPath(l,f.name);return f.isDirectory?this.P(n,await this.resolve(f.resource),s,k):this.O(n,f.resource,s,k)}))}async Q(n,a,s,l,f,k){let I=!1;if(n===s){const{providerExtUri:L,isPathCaseSensitive:T}=this.R(n);if(T||(I=L.isEqual(a,l)),I&&f==="copy")throw new Error((0,m.localize)(15,null,this.sb(a),this.sb(l)));if(!I&&L.isEqualOrParent(l,a))throw new Error((0,m.localize)(16,null,this.sb(a),this.sb(l)))}const O=await this.exists(l);if(O&&!I){if(!k)throw new p.$tl((0,m.localize)(17,null,this.sb(a),this.sb(l)),p.FileOperationResult.FILE_MOVE_CONFLICT);if(n===s){const{providerExtUri:L}=this.R(n);if(L.isEqualOrParent(a,l))throw new Error((0,m.localize)(18,null,this.sb(a),this.sb(l)))}}return{exists:O,isSameResourceWithDifferentPathCase:I}}R(n){const a=this.S(n);return{providerExtUri:a?b.$8g:b.$0g,isPathCaseSensitive:a}}S(n){return!!(n.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const a=this.qb(await this.j(n),n);await this.U(a,n);const s=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$ql(n,p.FileOperation.CREATE,s)),s}async U(n,a){const s=[],{providerExtUri:l}=this.R(n);for(;!l.isEqual(a,l.dirname(a));)try{if(!((await n.stat(a)).type&p.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(a)));break}catch(f){if((0,p.$ol)(f)!==p.FileSystemProviderErrorCode.FileNotFound)throw f;s.push(l.basename(a)),a=l.dirname(a)}for(let f=s.length-1;f>=0;f--){a=l.joinPath(a,s[f]);try{await n.mkdir(a)}catch(k){if((0,p.$ol)(k)!==p.FileSystemProviderErrorCode.FileExists)throw k}}}async canDelete(n,a){try{await this.W(n,a)}catch(s){return s}return!0}async W(n,a){const s=this.qb(await this.j(n),n),l=!!a?.useTrash;if(l&&!(s.capabilities&p.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(20,null,this.sb(n)));const f=a?.atomic;if(f&&!(s.capabilities&p.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(21,null,this.sb(n)));if(l&&f)throw new Error((0,m.localize)(22,null,this.sb(n)));let k;try{k=await s.stat(n)}catch{}if(k)this.rb(n,k);else throw new p.$tl((0,m.localize)(23,null,this.sb(n)),p.FileOperationResult.FILE_NOT_FOUND);if(!!!a?.recursive){const O=await this.resolve(n);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(n)))}return s}async del(n,a){const s=await this.W(n,a);let l=a;if((0,p.$il)(s)&&!l?.atomic){const O=s.enforceAtomicDelete?.(n);O&&(l={...a,atomic:O})}const f=!!l?.useTrash,k=!!l?.recursive,I=l?.atomic??!1;await s.delete(n,{recursive:k,useTrash:f,atomic:I}),this.r.fire(new p.$ql(n,p.FileOperation.DELETE))}async cloneFile(n,a){const s=await this.j(n),l=this.qb(await this.n(a),a);if(!(s===l&&this.R(s).providerExtUri.isEqual(n,a)))return s===l&&(0,p.$dl)(s)?s.cloneFile(n,a):(await this.U(l,this.R(l).providerExtUri.dirname(a)),s===l&&(0,p.$cl)(s)?this.cb.queueFor(n,()=>s.copy(n,a,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(n,()=>this.O(s,n,l,a),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(n,a){return this.watch(n,{...a,correlationId:S.ab++})}watch(n,a={recursive:!1,excludes:[]}){const s=new c.$Uc;let l=!1,f=()=>{l=!0};s.add((0,c.$Tc)(()=>f())),(async()=>{try{const I=await this.bb(n,a);l?(0,c.$Qc)(I):f=()=>(0,c.$Qc)(I)}catch(I){this.b.error(I)}})();const k=a.correlationId;if(typeof k=="number"){const I=s.add(new R.$le);return s.add(this.X.event(L=>{L.correlates(k)&&I.fire(L)})),{onDidChange:I.event,dispose:()=>s.dispose()}}return s}async bb(n,a){const s=await this.j(n),l=(0,P.$sj)([this.R(s).providerExtUri.getComparisonKey(n),a]);let f=this.$.get(l);return f||(f={count:0,disposable:s.watch(n,a)},this.$.set(l,f)),f.count+=1,(0,c.$Tc)(()=>{f&&(f.count--,f.count===0&&((0,c.$Qc)(f.disposable),this.$.delete(l)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,c.$Qc)(n.disposable);this.$.clear()}async db(n,a,s,l){return this.cb.queueFor(a,async()=>{const f=await n.open(a,{create:!0,unlock:s?.unlock??!1});try{(0,u.$ze)(l)||(0,u.$Ae)(l)?await this.eb(n,f,l):await this.fb(n,f,l)}catch(k){throw(0,p.$ml)(k)}finally{await n.close(f)}},this.R(n).providerExtUri)}async eb(n,a,s){let l=0,f;if((0,u.$Ae)(s)){if(s.buffer.length>0){const k=E.$Ne.concat(s.buffer);await this.gb(n,a,k,k.byteLength,l,0),l+=k.byteLength}if(s.ended)return;f=s.stream}else f=s;return new Promise((k,I)=>{(0,u.$Fe)(f,{onData:async O=>{f.pause();try{await this.gb(n,a,O,O.byteLength,l,0)}catch(L){return I(L)}l+=O.byteLength,setTimeout(()=>f.resume())},onError:O=>I(O),onEnd:()=>k()})})}async fb(n,a,s){let l=0,f;for(;(f=s.read())!==null;)await this.gb(n,a,f,f.byteLength,l,0),l+=f.byteLength}async gb(n,a,s,l,f,k){let I=0;for(;I<l;){const O=await n.write(a,f+I,s.buffer,k+I,l-I);I+=O}}async hb(n,a,s,l){return this.cb.queueFor(a,()=>this.ib(n,a,s,l),this.R(n).providerExtUri)}async ib(n,a,s,l){let f;l instanceof E.$Ne?f=l:(0,u.$ze)(l)?f=await(0,E.$Ze)(l):(0,u.$Ae)(l)?f=await(0,E.$1e)(l):f=(0,E.$Xe)(l),await n.writeFile(a,f.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(n,a,s,l){return this.cb.queueFor(l,()=>this.kb(n,a,s,l),this.R(s).providerExtUri)}async kb(n,a,s,l){let f,k;try{f=await n.open(a,{create:!1}),k=await s.open(l,{create:!0,unlock:!1});const I=E.$Ne.alloc(this.a);let O=0,L=0,T=0;do T=await n.read(f,O,I.buffer,L,I.byteLength-L),await this.gb(s,k,I,T,O,L),O+=T,L+=T,L===I.byteLength&&(L=0);while(T>0)}catch(I){throw(0,p.$ml)(I)}finally{await o.Promises.settled([typeof f=="number"?n.close(f):Promise.resolve(),typeof k=="number"?s.close(k):Promise.resolve()])}}async lb(n,a,s,l){return this.cb.queueFor(l,()=>this.mb(n,a,s,l),this.R(s).providerExtUri)}async mb(n,a,s,l){return s.writeFile(l,await n.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,a,s,l){return this.cb.queueFor(l,()=>this.ob(n,a,s,l),this.R(s).providerExtUri)}async ob(n,a,s,l){const f=await s.open(l,{create:!0,unlock:!1});try{const k=await n.readFile(a);await this.gb(s,f,E.$Ne.wrap(k),k.byteLength,0,0)}catch(k){throw(0,p.$ml)(k)}finally{await s.close(f)}}async pb(n,a,s,l){const f=await(0,E.$Ze)(this.H(n,a,D.CancellationToken.None));await this.hb(s,l,void 0,f)}qb(n,a){if(n.capabilities&p.FileSystemProviderCapabilities.Readonly)throw new p.$tl((0,m.localize)(25,null,this.sb(a)),p.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,a){if((a.permissions??0)&p.FilePermission.Readonly)throw new p.$tl((0,m.localize)(26,null,this.sb(n)),p.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===d.Schemas.file?n.fsPath:n.toString(!0)}};e.$Vq=r,e.$Vq=r=S=Se([oe(0,w.$$j)],r)}),define(ce[99],le([0,1,8,32,17,3,31,2,9,4,19,67,21,184,15,125,226,222,221]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class v extends p.$8q{static{this.L=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=D.Event.None,this.P=new o.$Bc(n=>h.$9g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=u.FileSystemProviderCapabilities.FileReadWrite|u.FileSystemProviderCapabilities.FileOpenReadWriteClose|u.FileSystemProviderCapabilities.FileReadStream|u.FileSystemProviderCapabilities.FileFolderCopy|u.FileSystemProviderCapabilities.FileWriteUnlock|u.FileSystemProviderCapabilities.FileAtomicRead|u.FileSystemProviderCapabilities.FileAtomicWrite|u.FileSystemProviderCapabilities.FileAtomicDelete|u.FileSystemProviderCapabilities.FileClone,c.$k&&(this.M|=u.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(r){try{const{stat:t,symbolicLink:n}=await g.SymlinkSupport.stat(this.I(r));return{type:this.O(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:u.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await g.Promises.readdir(this.I(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async a=>{try{let s;a.isSymbolicLink()?s=(await this.stat((0,h.$fh)(r,a.name))).type:s=this.O(a),n.push([a.name,s])}catch(s){this.a.trace(s)}})),n}catch(t){throw this.hb(t)}}O(r,t){let n;return t?.dangling?n=u.FileType.Unknown:r.isFile()?n=u.FileType.File:r.isDirectory()?n=u.FileType.Directory:n=u.FileType.Unknown,t&&(n|=u.FileType.SymbolicLink),n}async Q(r){const t=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const a=new i.$Dh;return this.P.set(r,a),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,P.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(r)===a&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),a.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),n=await this.Q(r));const a=this.I(r);return await g.Promises.readFile(a)}catch(a){throw this.hb(a)}finally{n?.dispose()}}R(r){v.L&&this.a.trace(r)}readFileStream(r,t,n){const a=(0,d.$Be)(s=>E.$Ne.concat(s.map(l=>E.$Ne.wrap(l))).buffer);return(0,m.$Uq)(this,r,a,s=>s.buffer,{...t,bufferSize:256*1024},n),a}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(r)?this.U(r,(0,h.$fh)((0,h.$eh)(r),`${(0,h.$ch)(r)}${n.atomic.postfix}`),t,n):this.W(r,t,n)}async S(r){try{const t=this.I(r),{symbolicLink:n}=await g.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async U(r,t,n,a){const s=new P.$Uc;try{s.add(await this.Q(r)),s.add(await this.Q(t)),await this.W(t,n,a,!0);try{await this.rename(t,r,{overwrite:!0})}catch(l){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{s.dispose()}}async W(r,t,n,a){let s;try{const l=this.I(r);if(!n.create||!n.overwrite){if(await g.Promises.exists(l)){if(!n.overwrite)throw(0,u.$ll)((0,b.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,u.$ll)((0,b.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(r,{create:!0,unlock:n.unlock},a),await this.write(s,0,t,0,t.byteLength)}catch(l){throw await this.ib(r,l)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(r){v.$=r}async open(r,t,n){const a=this.I(r);let s;(0,u.$_k)(t)&&!n&&(s=await this.Q(r));let l;try{if((0,u.$_k)(t)&&t.unlock)try{const{stat:k}=await g.SymlinkSupport.stat(a);k.mode&128||await g.Promises.chmod(a,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let f;if((0,u.$_k)(t)){if(c.$i)try{await g.Promises.truncate(a,0),f="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}f||(f="w")}else f="r";l=await g.Promises.open(a,f)}catch(f){throw s?.dispose(),(0,u.$_k)(t)?await this.ib(r,f):this.hb(f)}if(this.X.set(l,0),(0,u.$_k)(t)&&this.Z.set(l,r),s){const f=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${a})`),this.Y.set(l,s),f&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${a})`),f.dispose())}return l}async close(r){const t=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&v.$)try{await g.Promises.fdatasync(r)}catch(n){v.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(r)}catch(n){throw this.hb(n)}finally{t&&(this.Y.get(r)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,a,s){const l=this.ab(r,t);let f=null;try{f=(await g.Promises.read(r,n,a,s,l)).bytesRead}catch(k){throw this.hb(k)}finally{this.bb(r,l,f)}return f}ab(r,t){return t===this.X.get(r)?null:t}bb(r,t,n){const a=this.X.get(r);typeof a=="number"&&(typeof t=="number"||(typeof n=="number"?this.X.set(r,a+n):this.X.delete(r)))}async write(r,t,n,a,s){return(0,i.$Yh)(()=>this.cb(r,t,n,a,s),100,3)}async cb(r,t,n,a,s){const l=this.ab(r,t);let f=null;try{f=(await g.Promises.write(r,n,a,s,l)).bytesWritten}catch(k){throw await this.ib(this.Z.get(r),k)}finally{this.bb(r,l,f)}return f}async mkdir(r){try{await g.Promises.mkdir(this.I(r))}catch(t){throw this.hb(t)}}async delete(r,t){try{const n=this.I(r);if(t.recursive){let a;t?.atomic!==!1&&t.atomic.postfix&&(a=(0,y.$kc)((0,y.$nc)(n),`${(0,y.$oc)(n)}${t.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,a)}else try{await g.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let s=!1;try{const{stat:l,symbolicLink:f}=await g.SymlinkSupport.stat(n);s=l.isDirectory()&&!f}catch{}if(s)await g.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.hb(n)}}async rename(r,t,n){const a=this.I(r),s=this.I(t);if(a!==s)try{await this.db(r,t,"move",n.overwrite),await g.Promises.rename(a,s)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,b.localize)(2,null,(0,y.$oc)(a),(0,y.$oc)((0,y.$nc)(s)),l.toString()))),this.hb(l)}}async copy(r,t,n){const a=this.I(r),s=this.I(t);if(a!==s)try{await this.db(r,t,"copy",n.overwrite),await g.Promises.copy(a,s,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,b.localize)(3,null,(0,y.$oc)(a),(0,y.$oc)((0,y.$nc)(s)),l.toString()))),this.hb(l)}}async db(r,t,n,a){const s=this.I(r),l=this.I(t);let f=!1;if(!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive)||(f=(0,R.$Cg)(s,l,!0)),f){if(n==="copy")throw(0,u.$ll)((0,b.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.N(r);if(!I)throw(0,u.$ll)((0,b.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const O=await this.N(t);if(O){if(!a)throw(0,u.$ll)((0,b.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);I.type&u.FileType.File&&O.type&u.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.eb(r,t,!1)}async eb(r,t,n){const a=this.I(r),s=this.I(t),l=!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.$Cg)(a,s,!l))return;const f=new P.$Uc;try{f.add(await this.Q(r)),f.add(await this.Q(t)),n&&await g.Promises.mkdir((0,y.$nc)(s),{recursive:!0}),await g.Promises.copyFile(a,s)}catch(k){if(k.code==="ENOENT"&&!n)return this.eb(r,t,!0);throw this.hb(k)}finally{f.dispose()}}t(r,t,n){return new $.$cr(a=>r(a),a=>t(a),n)}F(r,t,n){return new w.$lr(a=>r(a),a=>t(a),n)}hb(r){if(r instanceof u.$kl)return r;let t=r,n;switch(r.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=u.FileSystemProviderErrorCode.Unknown;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.$ll)(t,n)}async ib(r,t){let n=this.hb(t);if(r&&n.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await g.SymlinkSupport.stat(this.I(r));a.mode&128||(n=(0,u.$ll)(t,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$mr=v}),define(ce[228],le([0,1,3,99,2,17,67,23]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;class y extends E.$Vc{constructor(d,g){super(),this.a=d,this.b=g,this.F=new Map,this.G=new Map}call(d,g,b){const u=this.c(d);switch(g){case"stat":return this.g(u,b[0]);case"readdir":return this.h(u,b[0]);case"open":return this.r(u,b[0],b[1]);case"close":return this.s(b[0]);case"read":return this.t(b[0],b[1],b[2]);case"readFile":return this.j(u,b[0],b[1]);case"write":return this.u(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.n(u,b[0],b[1],b[2]);case"rename":return this.z(u,b[0],b[1],b[2]);case"copy":return this.C(u,b[0],b[1],b[2]);case"cloneFile":return this.D(u,b[0],b[1]);case"mkdir":return this.w(u,b[0]);case"delete":return this.y(u,b[0],b[1]);case"watch":return this.I(u,b[0],b[1],b[2],b[3]);case"unwatch":return this.J(b[0],b[1])}throw new Error(`IPC Command ${g} not found`)}listen(d,g,b){const u=this.c(d);switch(g){case"fileChange":return this.H(u,b[0]);case"readFileStream":return this.m(u,b[0],b[1])}throw new Error(`Unknown event ${g}`)}g(d,g){const b=this.f(d,g,!0);return this.a.stat(b)}h(d,g){const b=this.f(d,g);return this.a.readdir(b)}async j(d,g,b){const u=this.f(d,g,!0),m=await this.a.readFile(u,b);return D.$Ne.wrap(m)}m(d,g,b){const u=this.f(d,g,!0),m=new P.$we,p=new i.$le({onDidRemoveLastListener:()=>{m.cancel()}}),$=this.a.readFileStream(u,b,m.token);return(0,R.$Fe)($,{onData:w=>p.fire(D.$Ne.wrap(w)),onError:w=>p.fire(w),onEnd:()=>{p.fire("end"),p.dispose(),m.dispose()}}),p.event}n(d,g,b,u){const m=this.f(d,g);return this.a.writeFile(m,b.buffer,u)}r(d,g,b){const u=this.f(d,g,!0);return this.a.open(u,b)}s(d){return this.a.close(d)}async t(d,g,b){const u=D.$Ne.alloc(b),p=await this.a.read(d,g,u.buffer,0,b);return[u,p]}u(d,g,b,u,m){return this.a.write(d,g,b.buffer,u,m)}w(d,g){const b=this.f(d,g);return this.a.mkdir(b)}y(d,g,b){const u=this.f(d,g);return this.a.delete(u,b)}z(d,g,b,u){const m=this.f(d,g),p=this.f(d,b);return this.a.rename(m,p,u)}C(d,g,b,u){const m=this.f(d,g),p=this.f(d,b);return this.a.copy(m,p,u)}D(d,g,b){const u=this.f(d,g),m=this.f(d,b);return this.a.cloneFile(u,m)}H(d,g){const b=new i.$le({onWillAddFirstListener:()=>{this.F.set(g,this.L(d,b))},onDidRemoveLastListener:()=>{(0,E.$Qc)(this.F.get(g)),this.F.delete(g)}});return b.event}async I(d,g,b,u,m){const p=this.F.get(g);if(p){const $=this.f(d,u),w=p.watch(b,$,m);this.G.set(g+b,w)}}async J(d,g){const b=d+g,u=this.G.get(b);u&&((0,E.$Qc)(u),this.G.delete(b))}dispose(){super.dispose();for(const[,d]of this.G)d.dispose();this.G.clear();for(const[,d]of this.F)d.dispose();this.F.clear()}}e.$Ws=y;class c extends E.$Vc{constructor(d,g,b,u){super(),this.c=d,this.f=b,this.g=u,this.a=new Map,this.b=this.B(new o.$mr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(g)}h(d){const g=this.B(new i.$le);this.B(g.event(b=>{d.fire(b.map(u=>({resource:this.c.transformOutgoingURI(u.resource),type:u.type,cId:u.cId})))})),this.B(this.b.onDidChangeFile(b=>g.fire(b))),this.B(this.b.onDidWatchError(b=>d.fire(b)))}j(d){}m(d){}watch(d,g,b){const u=this.m(this.g);return Array.isArray(u)&&(b.excludes=[...b.excludes,...u]),this.a.set(d,this.b.watch(g,b)),(0,E.$Tc)(()=>{(0,E.$Qc)(this.a.get(d)),this.a.delete(d)})}dispose(){for(const[,d]of this.a)d.dispose();this.a.clear(),super.dispose()}}e.$Xs=c}),define(ce[229],le([0,1,14,183,4,7,15,9,228,160,53]),function(V,e,i,o,E,D,R,P,y,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class d extends y.$Ws{constructor(u,m,p){super(u,m),this.M=p}c(u){return c.$Jn}f(u,m){return D.URI.revive(m)}async y(u,m,p){if(!p.useTrash)return super.y(u,m,p);const $=this.f(u,m),w=(0,P.$ic)($.fsPath);try{await i.shell.trashItem(w)}catch(v){throw(0,R.$ll)(E.$i?(0,o.localize)(0,null,(0,P.$oc)(w),(0,h.$pj)(v)):(0,o.localize)(1,null,(0,P.$oc)(w),(0,h.$pj)(v)),R.FileSystemProviderErrorCode.Unknown)}}L(u,m){return new g(u,m,this.b,this.M)}}e.$vec=d;class g extends y.$Xs{watch(u,m,p){if(p.recursive)throw(0,R.$ll)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(u,m,p)}}}),define(ce[230],le([0,1,5]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=void 0;class o extends i.$ek{constructor(D=i.$bk){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(R=>{this.n?.setLevel(R)}))}set logger(D){this.n=D;for(const{level:R,message:P}of this.m)(0,i.log)(D,R,P);this.m=[]}g(D,R){this.n?(0,i.log)(this.n,D,R):this.getLevel()<=D&&this.m.push({level:D,message:R})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$cbc=o}),define(ce[231],le([0,1,7,3,5,2]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=void 0;class R extends E.$jk{constructor(d,g,b,u,m){super(g,b,u),this.r=d,this.t=m,this.B(m.listen("onDidChangeLogLevel",d)(p=>{(0,E.$ak)(p)?super.setLogLevel(p):super.setLogLevel(i.URI.revive(p[0]),p[1])})),this.B(m.listen("onDidChangeVisibility",d)(([p,$])=>super.setVisibility(i.URI.revive(p),$))),this.B(m.listen("onDidChangeLoggers",d)(({added:p,removed:$})=>{for(const w of p)super.registerLogger({...w,resource:i.URI.revive(w.resource)});for(const w of $)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new E.$hk({log:(d,g)=>{this.t.call("consoleLog",[d,g])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,g){super.setLogLevel(d,g),this.t.call("setLogLevel",[d,g])}setVisibility(d,g){super.setVisibility(d,g),this.t.call("setVisibility",[this.n(d),g])}s(d,g,b){return new P(this.t,d,g,b,this.r)}static setLogLevel(d,g,b){return d.call("setLogLevel",[g,b])}}e.$ms=R;class P extends E.$ek{constructor(d,g,b,u,m){super(u?.logLevel==="always"),this.r=d,this.s=g,this.m=!1,this.n=[],this.setLevel(b),this.r.call("createLogger",[g,u,m]).then(()=>{this.u(this.n),this.m=!0})}g(d,g){const b=[[d,g]];this.m?this.u(b):this.n.push(...b)}u(d){this.r.call("log",[this.s,d])}}class y{constructor(d,g){this.a=d,this.b=g}listen(d,g){const b=this.b(d);switch(g){case"onDidChangeLoggers":return o.Event.map(this.a.onDidChangeLoggers,u=>({added:[...u.added].map(m=>this.c(m,b)),removed:[...u.removed].map(m=>this.c(m,b))}));case"onDidChangeVisibility":return o.Event.map(this.a.onDidChangeVisibility,u=>[b.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return o.Event.map(this.a.onDidChangeLogLevel,u=>(0,E.$ak)(u)?u:[b.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${g}`)}async call(d,g,b){const u=this.b(d);switch(g){case"setLogLevel":return(0,E.$ak)(b[0])?this.a.setLogLevel(b[0]):this.a.setLogLevel(i.URI.revive(u.transformIncoming(b[0][0])),b[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,u)))}throw new Error(`Call not found: ${g}`)}c(d,g){return{...d,resource:g.transformOutgoingURI(d.resource)}}}e.$ns=y;class c extends D.$Vc{constructor(d,g){super(),g.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(b=>g.call("setLogLevel",[b]))),g.call("getRegisteredLoggers").then(b=>{for(const u of b)d.registerLogger({...u,resource:i.URI.revive(u.resource)})}),this.B(g.listen("onDidChangeVisibility")(([b,u])=>d.setVisibility(i.URI.revive(b),u))),this.B(g.listen("onDidChangeLoggers")(({added:b,removed:u})=>{for(const m of b)d.registerLogger({...m,resource:i.URI.revive(m.resource)});for(const m of u)d.deregisterLogger(m.resource)}))}}e.$os=c}),define(ce[232],le([0,1,2,5]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;class E extends i.$Vc{constructor(R,P=[]){super(),this.a=new o.$ik([R,...P]),this.B(R.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...P){this.a.trace(R,...P)}debug(R,...P){this.a.debug(R,...P)}info(R,...P){this.a.info(R,...P)}warn(R,...P){this.a.warn(R,...P)}error(R,...P){this.a.error(R,...P)}flush(){this.a.flush()}}e.$UQ=E}),define(ce[233],le([0,1,32,7,5]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class D{constructor(P){this.b=P,this.a=new i.$Bc}listen(P,y,c){switch(y){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${y}`)}async call(P,y,c){switch(y){case"createLogger":this.c(o.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(o.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,E.$ak)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(o.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(o.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:o.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(o.URI.revive(c[0]))}throw new Error(`Call not found: ${y}`)}c(P,y,c){this.a.set(P,this.b.createLogger(P,y,c))}d(P,y){let c=console.log;switch(P){case E.LogLevel.Error:c=console.error;break;case E.LogLevel.Warning:c=console.warn;break;case E.LogLevel.Info:c=console.info;break}c.call(console,...y)}e(P,y){const c=this.a.get(P);if(!c)throw new Error("Create the logger before logging");for(const[h,d]of y)(0,E.log)(c,h,d)}}e.$sfc=D}),define(ce[234],le([0,1,15,5]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;var E;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(E||(E={}));async function D(c,h,d,g,b){try{const u=await new Promise((p,$)=>{V(["@vscode/spdlog"],p,$)}).then(Ae);u.setFlushOn(E.Trace);const m=await u.createAsyncRotatingLogger(c,h,d,g);return b?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(u){console.error(u)}return null}function R(c,h,d){switch(h){case o.LogLevel.Trace:c.trace(d);break;case o.LogLevel.Debug:c.debug(d);break;case o.LogLevel.Info:c.info(d);break;case o.LogLevel.Warning:c.warn(d);break;case o.LogLevel.Error:c.error(d);break;case o.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function P(c,h){switch(h){case o.LogLevel.Trace:c.setLevel(E.Trace);break;case o.LogLevel.Debug:c.setLevel(E.Debug);break;case o.LogLevel.Info:c.setLevel(E.Info);break;case o.LogLevel.Warning:c.setLevel(E.Warning);break;case o.LogLevel.Error:c.setLevel(E.Error);break;case o.LogLevel.Off:c.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class y extends o.$ek{constructor(h,d,g,b,u){super(),this.m=[],this.setLevel(u),this.n=this.s(h,d,g,b),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s(h,d,g,b){const u=g?6:1,m=30/u*i.$Gl.MB,p=await D(h,d,m,u,b);if(p){this.r=p,P(this.r,this.getLevel());for(const{level:$,message:w}of this.m)R(this.r,$,w);this.m=[]}}g(h,d){this.r?R(this.r,h,d):this.getLevel()<=h&&this.m.push({level:h,message:d})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$JQ=y}),define(ce[235],le([0,1,33,5,234]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=void 0;class D extends o.$jk{s(P,y,c){return new E.$JQ((0,i.$1g)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,y)}}e.$KQ=D}),define(ce[71],le([0,1,32,3,6,5,235]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0,e.$3dc=(0,E.$Fi)(D.$_j);class P extends R.$KQ{constructor(){super(...arguments),this.u=new i.$Bc}createLogger(c,h,d){d!==void 0&&this.u.set(this.n(c),d);try{return super.createLogger(c,h)}catch(g){throw this.u.delete(this.n(c)),g}}registerLogger(c,h){h!==void 0&&this.u.set(c.resource,h),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const h=[];for(const d of super.getRegisteredLoggers())c===this.u.get(d.resource)&&h.push(d);return h}getOnDidChangeLogLevelEvent(c){return o.Event.filter(this.onDidChangeLogLevel,h=>(0,D.$ak)(h)||this.w(h[0],c))}getOnDidChangeVisibilityEvent(c){return o.Event.filter(this.onDidChangeVisibility,([h])=>this.w(h,c))}getOnDidChangeLoggersEvent(c){return o.Event.filter(o.Event.map(this.onDidChangeLoggers,h=>({added:[...h.added].filter(g=>this.w(g.resource,c)),removed:[...h.removed].filter(g=>this.w(g.resource,c))})),h=>h.added.length>0||h.removed.length>0)}deregisterLoggers(c){for(const[h,d]of this.u)d===c&&this.deregisterLogger(h)}w(c,h){const d=this.u.get(c);return d===void 0||d===h}dispose(){super.dispose(),this.u.clear()}}e.$4dc=P}),define(ce[236],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=i,e.$Jec=o,e.$Kec=E,e.$Lec=D;function i(R){return R.submenu!==void 0}function o(R){return R.id==="vscode.menubar.separator"}function E(R){return R.uri!==void 0}function D(R){return!i(R)&&!o(R)&&!E(R)}}),define(ce[41],le([0,1,3,76,2,6]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,D.$Ei)("policy");class R extends E.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const h=Object.keys(this.f).length;return this.f={...c,...this.f},h!==Object.keys(this.f).length&&await this.j(c),o.Iterable.reduce(this.g.entries(),(d,[g,b])=>({...d,[g]:b}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return o.Iterable.reduce(Object.entries(this.f),(c,[h,d])=>({...c,[h]:{definition:d,value:this.g.get(h)}}),{})}}e.$ro=R;class P{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=P}),define(ce[237],le([0,1,8,3,76,12,15,5,41]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;function c(d,g){const b=[];for(const u of new Set(E.Iterable.concat(d.keys(),g.keys())))d.get(u)!==g.get(u)&&b.push(u);return b}let h=class extends y.$ro{constructor(g,b,u){super(),this.m=g,this.n=b,this.s=u,this.c=this.B(new i.$Ch(500));const m=o.Event.filter(b.onDidFilesChange,p=>p.affects(g));this.B(b.watch(g)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const b=await this.n.readFile(this.m),u=JSON.parse(b.value.toString());if(!(0,D.$gg)(u))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(u))this.f[m]&&g.set(m,u[m])}catch(b){b.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",b)}return g}async w(){const g=await this.u(),b=c(this.g,g);this.g=g,b.length>0&&this.h.fire(b)}};e.$Lfc=h,e.$Lfc=h=Se([oe(1,R.$$k),oe(2,P.$$j)],h)}),define(ce[238],le([0,1,3,2,41]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=void 0;class D{constructor(y){this.b=y,this.a=new o.$Uc}listen(y,c){switch(c){case"onDidChange":return i.Event.map(this.b.onDidChange,h=>h.reduce((d,g)=>({...d,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(y,c,h){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(h)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$hfc=D;class R extends E.$ro{constructor(y,c){super(),this.a=c;for(const h in y){const{definition:d,value:g}=y[h];this.f[h]=d,g!==void 0&&this.g.set(h,g)}this.a.listen("onDidChange")(h=>{for(const d in h){const g=h[d];g===null?this.g.delete(d):this.g.set(d,g)}this.h.fire(Object.keys(h))})}async j(y){const c=await this.a.call("updatePolicyDefinitions",y);for(const h in c)this.g.set(h,c[h])}}e.$ifc=R}),define(ce[239],le([0,1,41,8,2,5]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let R=class extends i.$ro{constructor(y,c){super(),this.m=y,this.n=c,this.a=new o.$yh,this.b=this.B(new E.$Wc)}async j(y){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(y).length} policy definitions`);const{createWatcher:c}=await new Promise((h,d)=>{V(["@vscode/policy-watcher"],h,d)}).then(Ae);await this.a.queue(()=>new Promise((h,d)=>{try{this.b.value=c(this.n,y,g=>{this.t(g),h()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),d(g)}}))}t(y){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(y)}`);for(const c in y){const h=y[c];h===void 0?this.g.delete(c):this.g.set(c,h)}this.h.fire(Object.keys(y))}};e.$Kfc=R,e.$Kfc=R=Se([oe(0,D.$$j)],R)}),define(ce[84],le([0,1,36]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const D=E.context.configuration();if(D)o=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:D.version})}}else o={},Object.keys(o).length===0&&Object.assign(o,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(ce[28],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,i.$Ei)("productService"),e.$sk="vscode://schemas/vscode-product"}),define(ce[240],le([0,1,8,5]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let E=class{constructor(R,P,y){this.a=R,this.b=P,this.c=y}async inspect(R){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$Fh)(R);const y=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),y.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.$yec=E,e.$yec=E=Se([oe(2,o.$$j)],E)}),define(ce[85],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0,e.$Ldc=(0,i.$Ei)("protocolMainService")}),define(ce[45],le([0,1,141,12]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,i=Ae(i),o=Ae(o);class E{constructor(){this.a=new Map}add(R,P){i.ok(o.$eg(R)),i.ok(o.$gg(P)),i.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,P)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$oo=new E}),define(ce[241],le([0,1,3,45]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,o=Ae(o),e.$po={JSONContribution:"base.contributions.json"};function E(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this.b=new i.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,c){this.a[E(y)]=c,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const R=new D;o.$oo.add(e.$po.JSONContribution,R)}),define(ce[54],le([0,1,22,3,12,168,18,241,45]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=m,e.$Fo=p,e.$Go=$,e.$Ho=v,e.$Io=S,E=Ae(E),D=Ae(D);var c;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$to={Configuration:"base.contributions.configuration"};var h;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const d=y.$oo.as(P.$po.JSONContribution);class g{constructor(){this.h=new Set,this.i=new o.$le,this.onDidSchemaChange=this.i.event,this.j=new o.$le,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const a=new Set;this.n(t,n,a),d.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const n=new Set;this.o(t,n),d.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const a=new Set;this.o(n,a),this.n(t,!1,a),d.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const a=[];for(const{overrides:s,source:l}of t)for(const f in s)if(n.add(f),e.$Do.test(f)){const k=this.a.get(f),I=k?.valuesSources??new Map;if(l)for(const A of Object.keys(s[f]))I.set(A,l);const O={...k?.value||{},...s[f]};this.a.set(f,{source:l,value:O,valuesSources:I});const L=(0,R.$ij)(f),T={type:"object",default:O,description:D.localize(1,null,L),$ref:e.$Ao,defaultDefaultValue:O,source:E.$eg(l)?void 0:l,defaultValueSource:l};a.push(...m(f)),this.d[f]=T,this.b.properties[f]=T}else{this.a.set(f,{value:s[f],source:l});const k=this.d[f];k&&(this.w(f,k),this.r(f,k))}this.m(a)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:a,source:s}of t)for(const l in a){const f=this.a.get(l),k=E.$eg(s)?s:s?.id,I=E.$eg(f?.source)?f?.source:f?.source?.id;if(k===I)if(n.add(l),this.a.delete(l),e.$Do.test(l))delete this.d[l],delete this.b.properties[l];else{const O=this.d[l];O&&(this.w(l,O),this.r(l,O))}}this.u()}deltaConfiguration(t){let n=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,a){t.forEach(s=>{this.p(s,n,s.extensionInfo,s.restrictedProperties,void 0,a),this.c.push(s),this.q(s)})}o(t,n){const a=s=>{if(s.properties)for(const l in s.properties){n.add(l);const f=this.d[l];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[l],this.s(l,s.properties[l])}s.allOf?.forEach(l=>a(l))};for(const s of t){a(s);const l=this.c.indexOf(s);l!==-1&&this.c.splice(l,1)}}p(t,n=!0,a,s,l=h.WINDOW,f){l=E.$ng(t.scope)?l:t.scope;const k=t.properties;if(k)for(const O in k){const L=k[O];if(n&&v(O,L)){delete k[O];continue}if(L.source=a,L.defaultDefaultValue=k[O].default,this.w(O,L),e.$Do.test(O)?L.scope=void 0:(L.scope=E.$ng(L.scope)?l:L.scope,L.restricted=E.$ng(L.restricted)?!!s?.includes(O):L.restricted),k[O].hasOwnProperty("included")&&!k[O].included){this.f[O]=k[O],delete k[O];continue}else this.d[O]=k[O],k[O].policy?.name&&this.e.set(k[O].policy.name,O);!k[O].deprecationMessage&&k[O].markdownDeprecationMessage&&(k[O].deprecationMessage=k[O].markdownDeprecationMessage),f.add(O)}const I=t.allOf;if(I)for(const O of I)this.p(O,n,a,s,l,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=a=>{const s=a.properties;if(s)for(const f in s)this.r(f,s[f]);a.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$uo.properties[t]=n,n.scope){case h.APPLICATION:e.$vo.properties[t]=n;break;case h.MACHINE:e.$wo.properties[t]=n;break;case h.MACHINE_OVERRIDABLE:e.$xo.properties[t]=n;break;case h.WINDOW:e.$yo.properties[t]=n;break;case h.RESOURCE:e.$zo.properties[t]=n;break;case h.LANGUAGE_OVERRIDABLE:e.$zo.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$uo.properties[t],n.scope){case h.APPLICATION:delete e.$vo.properties[t];break;case h.MACHINE:delete e.$wo.properties[t];break;case h.MACHINE_OVERRIDABLE:delete e.$xo.properties[t];break;case h.WINDOW:delete e.$yo.properties[t];break;case h.RESOURCE:case h.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,a={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$Ao};this.w(n,a),e.$uo.properties[n]=a,e.$vo.properties[n]=a,e.$wo.properties[n]=a,e.$xo.properties[n]=a,e.$yo.properties[n]=a,e.$zo.properties[n]=a}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=t,e.$vo.patternProperties[e.$Co]=t,e.$wo.patternProperties[e.$Co]=t,e.$xo.patternProperties[e.$Co]=t,e.$yo.patternProperties[e.$Co]=t,e.$zo.patternProperties[e.$Co]=t,this.i.fire()}w(t,n){const a=this.a.get(t);let s=a?.value,l=a?.source;E.$lg(s)&&(s=n.defaultDefaultValue,l=void 0),E.$lg(s)&&(s=$(n.type)),n.default=s,n.defaultValueSource=l}}const b="\\[([^\\]]+)\\]",u=new RegExp(b,"g");e.$Co=`^(${b})+$`,e.$Do=new RegExp(e.$Co);function m(r){const t=[];if(e.$Do.test(r)){let n=u.exec(r);for(;n?.length;){const a=n[1].trim();a&&t.push(a),n=u.exec(r)}}return(0,i.$Nb)(t)}function p(r){return r.reduce((t,n)=>`${t}[${n}]`,"")}function $(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new g;y.$oo.add(e.$to.Configuration,w);function v(r,t){return r.trim()?e.$Do.test(r)?D.localize(7,null,r):w.getConfigurationProperties()[r]!==void 0?D.localize(8,null,r):t.policy?.name&&w.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,r,t.policy?.name,w.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}function S(){const r=[],t=w.getConfigurationProperties();for(const n of Object.keys(t))r.push([n,t[n].scope]);return r.push(["launch",h.RESOURCE]),r.push(["task",h.RESOURCE]),r}}),define(ce[126],le([0,1,22,3,40,2,32,35,12,7,18,54,15,45]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=S,i=Ae(i),E=Ae(E),P=Ae(P),y=Ae(y);function u(a){return Object.isFrozen(a)?a:P.$co(a)}class m{static createEmptyModel(s){return new m({},[],[],void 0,s)}constructor(s,l,f,k,I){this.b=s,this.c=l,this.d=f,this.raw=k,this.f=I,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof m)return l;const f=new p("",this.f);return f.parseRaw(l),f.configurationModel});this.g=s.reduce((l,f)=>f===l?f:l.merge(f),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,h.$gj)(this.contents,s):this.contents}inspect(s,l){const f=this;return{get value(){return u(f.rawConfiguration.getValue(s))},get override(){return l?u(f.rawConfiguration.getOverrideValue(s,l)):void 0},get merged(){return u(l?f.rawConfiguration.override(l).getValue(s):f.rawConfiguration.getValue(s))},get overrides(){const k=[];for(const{contents:I,identifiers:O,keys:L}of f.rawConfiguration.overrides){const T=new m(I,L,[],void 0,f.f).getValue(s);T!==void 0&&k.push({identifiers:O,value:T})}return k.length?u(k):void 0}}}getOverrideValue(s,l){const f=this.j(l);return f?s?(0,h.$gj)(f,s):f:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const f of this.overrides)f.identifiers.includes(s)&&l.push(...f.keys);return i.$Nb(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return i.$Nb(s)}override(s){let l=this.a.get(s);return l||(l=this.h(s),this.a.set(s,l)),l}merge(...s){const l=P.$bo(this.contents),f=P.$bo(this.overrides),k=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const O of s)if(I.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.i(l,O.contents);for(const L of O.overrides){const[T]=f.filter(A=>i.$vb(A.identifiers,L.identifiers));T?(this.i(T.contents,L.contents),T.keys.push(...L.keys),T.keys=i.$Nb(T.keys)):f.push(P.$bo(L))}for(const L of O.keys)k.indexOf(L)===-1&&k.push(L)}return new m(l,k,f,I.every(O=>O instanceof m)?void 0:I,this.f)}h(s){const l=this.j(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const f={};for(const k of i.$Nb([...Object.keys(this.contents),...Object.keys(l)])){let I=this.contents[k];const O=l[k];O&&(typeof I=="object"&&typeof O=="object"?(I=P.$bo(I),this.i(I,O)):I=O),f[k]=I}return new m(f,this.keys,this.overrides,void 0,this.f)}i(s,l){for(const f of Object.keys(l)){if(f in s&&y.$gg(s[f])&&y.$gg(l[f])){this.i(s[f],l[f]);continue}s[f]=P.$bo(l[f])}}j(s){let l=null,f=null;const k=I=>{I&&(f?this.i(f,I):f=P.$bo(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?l=I.contents:I.identifiers.includes(s)&&k(I.contents);return k(l),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.k(s,l,!0)}setValue(s,l){this.k(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,h.$fj)(this.contents,s),d.$Do.test(s)&&this.overrides.splice(this.overrides.findIndex(f=>i.$vb(f.identifiers,(0,d.$Eo)(s))),1))}k(s,l,f){(0,h.$ej)(this.contents,s,l,k=>this.f.error(k)),f=f||this.keys.indexOf(s)===-1,f&&this.keys.push(s),d.$Do.test(s)&&this.overrides.push({identifiers:(0,d.$Eo)(s),keys:Object.keys(this.contents[s]),contents:(0,h.$dj)(this.contents[s],k=>this.f.error(k))})}}e.$Jo=m;class p{constructor(s,l){this.f=s,this.g=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!y.$ng(s)){const f=this.h(s);this.parseRaw(f,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:f,keys:k,overrides:I,restricted:O,hasExcludedProperties:L}=this.i(s,l);this.b=new m(f,k,I,L?[s]:void 0,this.g),this.c=O||[]}h(s){let l={},f=null,k=[];const I=[],O=[];function L(A){Array.isArray(k)?k.push(A):f!==null&&(k[f]=A)}const T={onObjectBegin:()=>{const A={};L(A),I.push(k),k=A,f=null},onObjectProperty:A=>{f=A},onObjectEnd:()=>{k=I.pop()},onArrayBegin:()=>{const A=[];L(A),I.push(k),k=A,f=null},onArrayEnd:()=>{k=I.pop()},onLiteralValue:L,onError:(A,M,z)=>{O.push({error:A,offset:M,length:z})}};if(s)try{E.$2n(s,T),l=k[0]||{}}catch(A){this.g.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return l}i(s,l){const f=b.$oo.as(d.$to.Configuration).getConfigurationProperties(),k=this.j(s,f,!0,l);s=k.raw;const I=(0,h.$dj)(s,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`)),O=Object.keys(s),L=this.l(s,T=>this.g.error(`Conflict in settings file ${this.f}: ${T}`));return{contents:I,keys:O,overrides:L,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(s,l,f,k){let I=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const O={},L=[];for(const T in s)if(d.$Do.test(T)&&f){const A=this.j(s[T],l,!1,k);O[T]=A.raw,I=I||A.hasExcludedProperties,L.push(...A.restricted)}else{const A=l[T],M=A?typeof A.scope<"u"?A.scope:d.ConfigurationScope.WINDOW:void 0;A?.restricted&&L.push(T),!k.exclude?.includes(T)&&(k.include?.includes(T)||(M===void 0||k.scopes===void 0||k.scopes.includes(M))&&!(k.skipRestricted&&A?.restricted))?O[T]=s[T]:I=!0}return{raw:O,restricted:L,hasExcludedProperties:I}}l(s,l){const f=[];for(const k of Object.keys(s))if(d.$Do.test(k)){const I={};for(const O in s[k])I[O]=s[k][O];f.push({identifiers:(0,d.$Eo)(k),keys:Object.keys(I),contents:(0,h.$dj)(I,l)})}return f}}e.$Ko=p;class $ extends D.$Vc{constructor(s,l,f,k,I){super(),this.c=s,this.f=l,this.g=k,this.h=I,this.b=this.B(new o.$le),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),I),this.B(this.g.watch(f.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(o.Event.any(o.Event.filter(this.g.onDidFilesChange,O=>O.contains(this.c)),o.Event.filter(this.g.onDidRunOperation,O=>(O.isOperation(g.FileOperation.CREATE)||O.isOperation(g.FileOperation.COPY)||O.isOperation(g.FileOperation.DELETE)||O.isOperation(g.FileOperation.WRITE))&&f.isEqual(O.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=$;class w{constructor(s,l,f,k,I,O,L,T,A,M,z,C,B){this.a=s,this.b=l,this.c=f,this.overrideIdentifiers=k,this.d=I,this.f=O,this.g=L,this.h=T,this.i=A,this.j=M,this.k=z,this.l=C,this.m=B}get value(){return u(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class v{constructor(s,l,f,k,I,O,L,T,A,M){this.j=s,this.l=l,this.m=f,this.n=k,this.p=I,this.q=O,this.r=L,this.s=T,this.t=A,this.u=M,this.h=null,this.i=new R.$Bc,this.v=null}getValue(s,l,f){return this.w(s,l,f).getValue(s)}updateValue(s,l,f={}){let k;f.resource?(k=this.t.get(f.resource),k||(k=m.createEmptyModel(this.u),this.t.set(f.resource,k))):k=this.s,l===void 0?k.removeValue(s):k.setValue(s,l),f.resource||(this.h=null)}inspect(s,l,f){const k=this.w(s,l,f),I=this.A(l.resource,f),O=l.resource?this.t.get(l.resource)||this.s:this.s,L=new Set;for(const T of k.overrides)for(const A of T.identifiers)k.getOverrideValue(s,A)!==void 0&&L.add(A);return new w(s,l,k.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this.q:void 0,I||void 0,O)}keys(s){const l=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,l){this.r.set(s,l),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const f=[];if(!l){const{added:k,updated:I,removed:O}=t(this.j,s);l=[...k,...I,...O]}for(const k of l)for(const I of(0,d.$Eo)(k)){const O=this.j.getKeysForOverrideIdentifier(I),L=s.getKeysForOverrideIdentifier(I),T=[...L.filter(A=>O.indexOf(A)===-1),...O.filter(A=>L.indexOf(A)===-1),...O.filter(A=>!P.$fo(this.j.override(I).getValue(A),s.override(I).getValue(A)))];f.push([I,T])}return this.updateDefaultConfiguration(s),{keys:l,overrides:f}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:f,removed:k}=t(this.l,s),I=[...l,...f,...k];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:f,removed:k,overrides:I}=t(this.applicationConfiguration,s),O=[...l,...f,...k];return O.length&&this.updateApplicationConfiguration(s),{keys:O,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:f,removed:k,overrides:I}=t(this.localUserConfiguration,s),O=[...l,...f,...k];return O.length&&this.updateLocalUserConfiguration(s),{keys:O,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:f,removed:k,overrides:I}=t(this.remoteUserConfiguration,s),O=[...l,...f,...k];return O.length&&this.updateRemoteUserConfiguration(s),{keys:O,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:f,removed:k,overrides:I}=t(this.workspaceConfiguration,s),O=[...l,...f,...k];return O.length&&this.updateWorkspaceConfiguration(s),{keys:O,overrides:I}}compareAndUpdateFolderConfiguration(s,l){const f=this.folderConfigurations.get(s),{added:k,updated:I,removed:O,overrides:L}=t(f,l),T=[...k,...I,...O];return(T.length||!f)&&this.updateFolderConfiguration(s,l),{keys:T,overrides:L}}compareAndDeleteFolderConfiguration(s){const l=this.folderConfigurations.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:f,updated:k,removed:I,overrides:O}=t(l,void 0);return{keys:[...f,...k,...I],overrides:O}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,l,f){let k=this.x(l,f);return l.overrideIdentifier&&(k=k.override(l.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(k=k.merge(this.l)),k}x({resource:s},l){let f=this.y();if(l&&s){const k=l.getFolder(s);k&&(f=this.z(k.uri)||f);const I=this.t.get(s);I&&(f=f.merge(I))}return f}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let l=this.i.get(s);if(!l){const f=this.y(),k=this.r.get(s);k?(l=f.merge(k),this.i.set(s,l)):l=f}return l}A(s,l){if(l&&s){const f=l.getFolder(s);if(f)return this.r.get(f.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,l)=>{const{contents:f,overrides:k,keys:I}=this.r.get(l);return s.push([l,{contents:f,overrides:k,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.q.keys.forEach(l=>s.add(l)),this.r.forEach(l=>l.keys.forEach(f=>s.add(f))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.q.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.r.forEach(l=>l.getAllOverrideIdentifiers().forEach(f=>s.add(f))),[...s.values()]}D(s){const l=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(f=>l.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(f=>l.add(f)),this.q.getKeysForOverrideIdentifier(s).forEach(f=>l.add(f)),this.r.forEach(f=>f.getKeysForOverrideIdentifier(s).forEach(k=>l.add(k))),[...l.values()]}static parse(s,l){const f=this.E(s.defaults,l),k=this.E(s.policy,l),I=this.E(s.application,l),O=this.E(s.user,l),L=this.E(s.workspace,l),T=s.folders.reduce((A,M)=>(A.set(c.URI.revive(M[0]),this.E(M[1],l)),A),new R.$Bc);return new v(f,k,I,O,m.createEmptyModel(l),L,T,m.createEmptyModel(l),new R.$Bc,l)}static E(s,l){return new m(s.contents,s.keys,s.overrides,void 0,l)}}e.$Mo=v;function S(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const s=new Set,l=new Map;for(const k of a)k.keys.forEach(I=>s.add(I)),k.overrides.forEach(([I,O])=>{const L=(0,R.$yc)(l,I,new Set);O.forEach(T=>L.add(T))});const f=[];return l.forEach((k,I)=>f.push([I,[...k.values()]])),{keys:[...s.values()],overrides:f}}class r{constructor(s,l,f,k,I){this.change=s,this.f=l,this.g=f,this.h=k,this.i=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const O of s.keys)this.affectedKeys.add(O);for(const[,O]of s.overrides)for(const L of O)this.affectedKeys.add(L);this.d=this.a;for(const O of this.affectedKeys)this.d+=O+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=v.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,l){const f=this.a+s,k=this.d.indexOf(f);if(k<0)return!1;const I=k+f.length;if(I>=this.d.length)return!1;const O=this.d.charCodeAt(I);if(O!==this.b&&O!==this.c)return!1;if(l){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,T=this.g.getValue(s,l,this.h);return!P.$fo(L,T)}return!0}}e.$Oo=r;function t(a,s){const{added:l,removed:f,updated:k}=n(s?.rawConfiguration,a?.rawConfiguration),I=[],O=a?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const T=L.filter(A=>!O.includes(A));for(const A of T)I.push([A,s.getKeysForOverrideIdentifier(A)])}if(a){const T=O.filter(A=>!L.includes(A));for(const A of T)I.push([A,a.getKeysForOverrideIdentifier(A)])}if(s&&a){for(const T of O)if(L.includes(T)){const A=n({contents:a.getOverrideValue(void 0,T)||{},keys:a.getKeysForOverrideIdentifier(T)},{contents:s.getOverrideValue(void 0,T)||{},keys:s.getKeysForOverrideIdentifier(T)});I.push([T,[...A.added,...A.removed,...A.updated]])}}return{added:l,removed:f,updated:k,overrides:I}}function n(a,s){const l=a?s?a.keys.filter(I=>s.keys.indexOf(I)===-1):[...a.keys]:[],f=s?a?s.keys.filter(I=>a.keys.indexOf(I)===-1):[...s.keys]:[],k=[];if(a&&s){for(const I of s.keys)if(a.keys.indexOf(I)!==-1){const O=(0,h.$gj)(s.contents,I),L=(0,h.$gj)(a.contents,I);P.$fo(O,L)||k.push(I)}}return{added:l,removed:f,updated:k}}}),define(ce[242],le([0,1,22,3,2,35,12,126,54,5,41,45]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=void 0;class g extends E.$Vc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new o.$le),this.onDidChangeConfiguration=this.a.event,this.b=P.$Jo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$oo.as(y.$to.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:$})=>this.f(Array.from(p),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,$){this.j(p,d.$oo.as(y.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=P.$Jo.createEmptyModel(this.c);const p=d.$oo.as(y.$to.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,$){const w=this.g();for(const v of p){const S=w[v],r=$[v];S!==void 0?this.b.addValue(v,S):r?this.b.addValue(v,r.default):this.b.removeValue(v)}}}e.$Po=g;class b{constructor(){this.onDidChangeConfiguration=o.Event.None,this.configurationModel=P.$Jo.createEmptyModel(new c.$lk)}async initialize(){return this.configurationModel}}e.$Qo=b;let u=class extends E.$Vc{get configurationModel(){return this.b}constructor(p,$,w){super(),this.c=p,this.f=$,this.g=w,this.a=this.B(new o.$le),this.onDidChangeConfiguration=this.a.event,this.b=P.$Jo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const $={},w=[],v=d.$oo.as(y.$to.Configuration).getConfigurationProperties();for(const S of p){const r=v[S];if(!r){w.push(S);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}w.push(S),$[r.policy.name]={type:r.type}}}return(0,R.$rg)($)||await this.f.updatePolicyDefinitions($),w}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const $=d.$oo.as(y.$to.Configuration).getPolicyConfigurations(),w=(0,i.$Ib)(p.map(v=>$.get(v)));this.m(w,!0)}m(p,$){this.g.trace("PolicyConfiguration#update",p);const w=d.$oo.as(y.$to.Configuration).getConfigurationProperties(),v=[],S=this.b.isEmpty();for(const r of p){const t=w[r]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(S?n!==void 0:!(0,D.$fo)(this.b.getValue(r),n))&&v.push([r,n])}else this.b.getValue(r)!==void 0&&v.push([r,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const r=this.b;this.b=P.$Jo.createEmptyModel(this.g);for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,n]of v)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);$&&this.a.fire(this.b)}}};e.$Ro=u,e.$Ro=u=Se([oe(1,h.$qo),oe(2,c.$$j)],u)}),define(ce[243],le([0,1,22,8,17,3,40,108,2,32,35,4,19,18,126,54,242,15,41]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;class v extends y.$Vc{constructor(t,n,a,s){super(),this.m=t,this.n=s,this.h=this.B(new D.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Po(s)),this.c=a instanceof w.$so?new p.$Qo:this.B(new p.$Ro(this.b,a,s)),this.f=this.B(new u.$Lo(this.m,{},g.$9g,n,s)),this.a=new u.$Mo(this.b.configurationModel,this.c.configurationModel,u.$Jo.createEmptyModel(s),u.$Jo.createEmptyModel(s),u.$Jo.createEmptyModel(s),u.$Jo.createEmptyModel(s),new c.$Bc,u.$Jo.createEmptyModel(s),new c.$Bc,s),this.j=new S(t,n,this),this.g=this.B(new o.$Qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:f})=>this.s(l,f))),this.B(this.c.onDidChangeConfiguration(l=>this.t(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,n,a]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$Mo(t,n,u.$Jo.createEmptyModel(this.n),a,u.$Jo.createEmptyModel(this.n),u.$Jo.createEmptyModel(this.n),new c.$Bc,u.$Jo.createEmptyModel(this.n),new c.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,n){const a=typeof t=="string"?t:void 0,s=(0,b.$_i)(t)?t:(0,b.$_i)(n)?n:{};return this.a.getValue(a,s,void 0)}async updateValue(t,n,a,s,l){const f=(0,b.$aj)(a)?a:(0,b.$_i)(a)?{resource:a.resource,overrideIdentifiers:a.overrideIdentifier?[a.overrideIdentifier]:void 0}:void 0,k=f?s:a;if(k!==void 0&&k!==b.ConfigurationTarget.USER_LOCAL&&k!==b.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${k}.`);f?.overrideIdentifiers&&(f.overrideIdentifiers=(0,i.$Nb)(f.overrideIdentifiers),f.overrideIdentifiers=f.overrideIdentifiers.length?f.overrideIdentifiers:void 0);const I=this.inspect(t,{resource:f?.resource,overrideIdentifier:f?.overrideIdentifiers?f.overrideIdentifiers[0]:void 0});if(I.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,h.$fo)(n,I.defaultValue)&&(n=void 0),f?.overrideIdentifiers?.length&&f.overrideIdentifiers.length>1){const L=f.overrideIdentifiers.sort(),T=this.a.localUserConfiguration.overrides.find(A=>(0,i.$vb)([...A.identifiers].sort(),L));T&&(f.overrideIdentifiers=T.identifiers)}const O=f?.overrideIdentifiers?.length?[(0,m.$Fo)(f.overrideIdentifiers),t]:[t];await this.j.write(O,n),await this.reloadConfiguration()}inspect(t,n={}){return this.a.inspect(t,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const n=this.a.toData(),a=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(a,n,b.ConfigurationTarget.USER)}s(t,n){const a=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(t,n);this.u(s,a,b.ConfigurationTarget.DEFAULT)}t(t){const n=this.a.toData(),a=this.a.compareAndUpdatePolicyConfiguration(t);this.u(a,n,b.ConfigurationTarget.DEFAULT)}u(t,n,a){const s=new u.$Oo(t,{data:n},this.a,void 0,this.n);s.source=a,this.h.fire(s)}}e.$So=v;class S{constructor(t,n,a){this.b=t,this.c=n,this.d=a,this.a=new o.$Lh}write(t,n){return this.a.queue(()=>this.e(t,n))}async e(t,n){let a;try{a=(await this.c.readFile(this.b)).value.toString()}catch(f){if(f.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)a="{}";else throw f}const s=[];if((0,R.$Un)(a,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const l=this.f(a,t,n);a=(0,P.$ao)(a,l),await this.c.writeFile(this.b,E.$Ne.fromString(a))}f(t,n,a){const{tabSize:s,insertSpaces:l,eol:f}=this.h;if(!n.length){const k=JSON.stringify(a,null,l?" ".repeat(s):"	");return[{content:k,length:k.length,offset:0}]}return(0,P.$0n)(t,n,a,{tabSize:s,insertSpaces:l,eol:f})}get h(){if(!this.g){let t=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(t=n),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[244],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=e.$yfc=e.$xfc=void 0,e.$xfc="request",e.$yfc="remoteResourceHandler";class i{async routeCall(E,D,R){if(D!==e.$xfc)throw new Error(`Call not found: ${D}`);const P=R[0];if(P?.authority){const y=E.connections.find(c=>c.ctx===P.authority);if(y)return y}throw new Error("Caller not found")}routeEvent(E,D){throw new Error(`Event not found: ${D}`)}}e.$zfc=i}),define(ce[245],le([0,1,16,6]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=c,e.$Pl=(0,o.$Ei)("remoteAuthorityResolverService");var E;(function(h){h[h.WebSocket=0]="WebSocket",h[h.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class D{constructor(d){this.id=d,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=D;class R{constructor(d,g){this.host=d,this.port=g,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=R;var P;(function(h){h.Unknown="Unknown",h.NotAvailable="NotAvailable",h.TemporarilyNotAvailable="TemporarilyNotAvailable",h.NoResolverFound="NoResolverFound",h.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class y extends i.$cb{static isNotAvailable(d){return d instanceof y&&d._code===P.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof y&&d._code===P.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof y&&d._code===P.NoResolverFound}static isInvalidAuthority(d){return d instanceof y&&d._code===P.InvalidAuthority}static isHandled(d){return d instanceof y&&d.isHandled}constructor(d,g=P.Unknown,b){super(d),this._message=d,this._code=g,this._detail=b,this.isHandled=g===P.NotAvailable&&b===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Sl=y;function c(h){const d=h.indexOf("+");return d===-1?h:h.substring(0,d)}}),define(ce[246],le([0,1,8,17,23,16,3,2,13,70,66,33,118,245]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Yl=I,e.$Zl=O,e.$1l=T,c=Ae(c);const u=30*1e3;var m;(function(ne){ne[ne.Management=1]="Management",ne[ne.ExtensionHost=2]="ExtensionHost",ne[ne.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function p(ne){switch(ne){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function $(ne){const Z=new E.$we;return setTimeout(()=>Z.cancel(),ne),Z.token}function w(ne,Z){if(ne.isCancellationRequested||Z.isCancellationRequested)return E.CancellationToken.Cancelled;const F=new E.$we;return ne.onCancellationRequested(()=>F.cancel()),Z.onCancellationRequested(()=>F.cancel()),F.token}class v{get didTimeout(){return this.c==="timedout"}constructor(Z){this.c="pending",this.d=new P.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$xh)(),Z.isCancellationRequested?this.h():this.d.add(Z.onCancellationRequested(()=>this.h()))}registerDisposable(Z){this.c==="pending"?this.d.add(Z):Z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Z))}reject(Z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Z))}}function S(ne,Z){const F=new v(Z);return F.registerDisposable(ne.onControlMessage(N=>{const W=JSON.parse(N.toString()),q=j(W);q?F.reject(q):F.resolve(W)})),F.promise}function r(ne,Z,F,N,W,q,Q,X){const Y=new v(X),ie=h.$fe.create(!1);return ne.info(`Creating a socket (${Q})...`),c.mark(`code/willCreateSocket/${q}`),Z.connect(F,N,W,Q).then(de=>{Y.didTimeout?(c.mark(`code/didCreateSocketError/${q}`),ne.info(`Creating a socket (${Q}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(c.mark(`code/didCreateSocketOK/${q}`),ne.info(`Creating a socket (${Q}) was successful after ${ie.elapsed()} ms.`),Y.resolve(de))},de=>{c.mark(`code/didCreateSocketError/${q}`),ne.info(`Creating a socket (${Q}) returned an error after ${ie.elapsed()} ms.`),ne.error(de),Y.reject(de)}),Y.promise}function t(ne,Z){const F=new v(Z);return ne.then(N=>{F.didTimeout||F.resolve(N)},N=>{F.didTimeout||F.reject(N)}),F.promise}async function n(ne,Z,F,N){const W=G(ne,Z);ne.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let q;try{q=await r(ne.logService,ne.remoteSocketFactoryService,ne.connectTo,y.$Rg.getServerRootPath(),`reconnectionToken=${ne.reconnectionToken}&reconnection=${ne.reconnectionProtocol?"true":"false"}`,p(Z),`renderer-${p(Z)}-${ne.reconnectionToken}`,N)}catch(de){throw ne.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),ne.logService.error(de),de}ne.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let Q,X;ne.reconnectionProtocol?(ne.reconnectionProtocol.beginAcceptReconnection(q,null),Q=ne.reconnectionProtocol,X=!1):(Q=new g.$si({socket:q}),X=!0),ne.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const Y=await t(ne.signService.createNewMessage((0,d.$1g)()),N),ie={type:"auth",auth:ne.connectionToken||"00000000000000000000",data:Y.data};Q.sendControl(o.$Ne.fromString(JSON.stringify(ie)));try{const de=await S(Q,w(N,$(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(ne.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(ne.signService.validate(Y,de.signedData),N)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const pe=await t(ne.signService.sign(de.data),N),Ie={type:"connectionType",commit:ne.commit,signedData:pe,desiredConnectionType:Z};return F&&(Ie.args=F),ne.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(o.$Ne.fromString(JSON.stringify(Ie))),{protocol:Q,ownsProtocol:X}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(ne.logService.error(`${W} the handshake timed out. Error:`),ne.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(ne.logService.error(`${W} received error control message when negotiating connection. Error:`),ne.logService.error(de)),X&&H(Q),de}}async function a(ne,Z,F,N){const W=Date.now(),q=G(ne,Z),{protocol:Q,ownsProtocol:X}=await n(ne,Z,F,N),Y=new v(N);return Y.registerDisposable(Q.onControlMessage(ie=>{const de=JSON.parse(ie.toString()),me=j(de);me?(ne.logService.error(`${q} received error control message when negotiating connection. Error:`),ne.logService.error(me),X&&H(Q),Y.reject(me)):(ne.reconnectionProtocol?.endAcceptReconnection(),ne.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${he(W)}!`),Y.resolve({protocol:Q,firstMessage:de}))})),Y.promise}async function s(ne,Z){const{protocol:F}=await a(ne,m.Management,void 0,Z);return{protocol:F}}async function l(ne,Z,F){const{protocol:N,firstMessage:W}=await a(ne,m.ExtensionHost,Z,F),q=W&&W.debugPort;return{protocol:N,debugPort:q}}async function f(ne,Z,F){const N=Date.now(),W=G(ne,m.Tunnel),{protocol:q}=await n(ne,m.Tunnel,Z,F);return ne.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${he(N)}!`),q}async function k(ne,Z,F){const{connectTo:N,connectionToken:W}=await ne.addressProvider.getAddress();return{commit:ne.commit,quality:ne.quality,connectTo:N,connectionToken:W,reconnectionToken:Z,reconnectionProtocol:F,remoteSocketFactoryService:ne.remoteSocketFactoryService,signService:ne.signService,logService:ne.logService}}async function I(ne,Z,F){return L(ne,async N=>{const{protocol:W}=await s(N,E.CancellationToken.None);return new K(ne,Z,F,N.reconnectionToken,W)})}async function O(ne,Z){return L(ne,async F=>{const{protocol:N,debugPort:W}=await l(F,Z,E.CancellationToken.None);return new ee(ne,Z,F.reconnectionToken,N,W)})}async function L(ne,Z){for(let N=1;;N++)try{const W=(0,d.$1g)(),q=await k(ne,W,null);return await Z(q)}catch(W){if(N<5)ne.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),ne.logService.error(W);else throw ne.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ne.logService.error(W),se.triggerPermanentFailure(0,0,b.$Sl.isHandled(W)),W}}async function T(ne,Z,F){const N=await k(ne,(0,d.$1g)(),null);return await f(N,{host:Z,port:F},E.CancellationToken.None)}function A(ne){return(0,i.$rh)(Z=>new Promise((F,N)=>{const W=setTimeout(F,ne*1e3);Z.onCancellationRequested(()=>{clearTimeout(W),F()})}))}var M;(function(ne){ne[ne.ConnectionLost=0]="ConnectionLost",ne[ne.ReconnectionWait=1]="ReconnectionWait",ne[ne.ReconnectionRunning=2]="ReconnectionRunning",ne[ne.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ne[ne.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class z{constructor(Z,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=F,this.type=M.ConnectionLost}}e.$2l=z;class C{constructor(Z,F,N,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=F,this.durationSeconds=N,this.c=W,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$3l=C;class B{constructor(Z,F,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ReconnectionRunning}}e.$4l=B;class re{constructor(Z,F,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=F,this.attempt=N,this.type=M.ConnectionGain}}e.$5l=re;class _{constructor(Z,F,N,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=F,this.attempt=N,this.handled=W,this.type=M.ReconnectionPermanentFailure}}e.$6l=_;class se extends P.$Vc{static triggerPermanentFailure(Z,F,N){this._permanentFailure=!0,this.f=Z,this.g=F,this.h=N,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Z=>Z.y())}static debugPauseSocketWriting(){this.j.forEach(Z=>Z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||se._permanentFailure}constructor(Z,F,N,W,q){super(),this.t=Z,this.u=F,this.reconnectionToken=N,this.protocol=W,this.w=q,this.m=this.B(new R.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new re(this.reconnectionToken,0,0)),this.B(W.onSocketClose(Q=>{const X=ae(this.t,this.reconnectionToken,!0);Q?Q.type===g.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${X} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.u.logService.error(Q.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.u.logService.error(Q.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(Q=>{const X=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.y()})),se.j.push(this),this.B((0,P.$Tc)(()=>{const Q=se.j.indexOf(this);Q>=0&&se.j.splice(Q,1)})),this.n&&this.D(se.f,se.g,se.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Z=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const W=N<F.length?F[N]:F[F.length-1];try{if(W>0){const Q=A(W);this.m.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,Q)),this.u.logService.info(`${Z} waiting for ${W} seconds before reconnecting...`);try{await Q}catch{}}if(this.n){this.u.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.u.logService.info(`${Z} resolving connection...`);const q=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Z} connecting to ${q.connectTo}...`),await this.G(q,$(u)),this.u.logService.info(`${Z} reconnected!`),this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.u.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(b.$Sl.isTemporarilyNotAvailable(q)){this.u.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.u.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((0,D.$5)(q)){this.u.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if(q instanceof b.$Sl){this.u.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,b.$Sl.isHandled(q));break}this.u.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.n&&!this.s)}C(Z,F,N){this.w?se.triggerPermanentFailure(Z,F,N):this.D(Z,F,N)}D(Z,F,N){this.m.fire(new _(this.reconnectionToken,Z,F,N)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7l=se;class K extends se{constructor(Z,F,N,W,q){super(m.Management,Z,W,q,!0),this.client=this.B(new g.$qi(q,{remoteAuthority:F,clientId:N},Z.ipcLogger))}async G(Z,F){await s(Z,F)}}e.$8l=K;class ee extends se{constructor(Z,F,N,W,q){super(m.ExtensionHost,Z,N,W,!1),this.H=F,this.debugPort=q}async G(Z,F){await l(Z,this.H,F)}}e.$9l=ee;function H(ne){try{ne.acceptDisconnect();const Z=ne.getSocket();ne.dispose(),Z.dispose()}catch(Z){(0,D.$2)(Z)}}function j(ne){if(ne&&ne.type==="error"){const Z=new Error(`Connection error: ${ne.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function U(ne,Z){for(;ne.length<Z;)ne+=" ";return ne}function x(ne,Z){return`[remote-connection][${U(p(ne),13)}][${Z.substr(0,5)}\u2026]`}function ae(ne,Z,F){return`${x(ne,Z)}[${F?"reconnect":"initial"}]`}function G(ne,Z){return`${ae(Z,ne.reconnectionToken,!!ne.reconnectionProtocol)}[${ne.connectTo}]`}function he(ne){return`${Date.now()-ne} ms`}}),define(ce[72],le([0,1,13]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=o,e.$gn=E,e.$hn=D,e.$in=R;function o(y){return y.scheme===i.Schemas.vscodeRemote?y.authority:void 0}function E(y){if(!y)return;const c=y.indexOf("+");return c<0?y:y.substr(0,c)}function D(y){const{host:c,port:h}=P(y);if(typeof h>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:h}}function R(y,c){let{host:h,port:d}=P(y);return typeof d>"u"&&(d=c),{host:h,port:d}}function P(y){const c=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const h=y.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const d=y.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:y,port:void 0}}}),define(ce[100],le([0,1,26,6,72]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=D,e.$sn=d,e.$tn=g,e.$un=b,e.$vn=u,i=Ae(i),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function D(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$on=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(R||(e.ExtensionType=R={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class y{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,$){if(typeof p>"u"||p===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof p=="string"||typeof $=="string"){const w=typeof p=="string"?p:p.value,v=typeof $=="string"?$:$.value;return i.$Ff(w,v)}return p._lower===$._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$pn=y;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const $ of p)this.add($)}add(p){this.c.add(y.toKey(p))}delete(p){return this.c.delete(y.toKey(p))}has(p){return this.c.has(y.toKey(p))}}e.$qn=c;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(y.toKey(p))}get(p){return this.c.get(y.toKey(p))}has(p){return this.c.has(y.toKey(p))}set(p,$){this.c.set(y.toKey(p),$)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=h;function d(m){return g(m)}function g(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}function b(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}function u(m,p){if(p){const $=`onResolveRemoteAuthority:${(0,E.$gn)(p)}`;return!!m.activationEvents?.includes($)}return!1}e.$wn=(0,o.$Ei)("IBuiltinExtensionsScannerService")}),define(ce[127],le([0,1,4,175,100,6]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=P,e.$bp=y,e.$cp=c,e.$dp=h,e.$ep=d,e.$fp=g,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var R;(function(r){r.COMMAND="command",r.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function P(r){switch(r){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function y(r){switch(r){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function c(r,t){switch(r){case i.Platform.Windows:return t==="x64"?E.TargetPlatform.WIN32_X64:t==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case i.Platform.Linux:return t==="x64"?E.TargetPlatform.LINUX_X64:t==="arm64"?E.TargetPlatform.LINUX_ARM64:t==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?E.TargetPlatform.ALPINE_X64:t==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case i.Platform.Mac:return t==="x64"?E.TargetPlatform.DARWIN_X64:t==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case i.Platform.Web:return E.TargetPlatform.WEB}}function h(r,t){return t===E.TargetPlatform.WEB&&!r.includes(E.TargetPlatform.WEB)}function d(r,t,n){return h(t,n)?!1:r===E.TargetPlatform.UNDEFINED||r===E.TargetPlatform.UNIVERSAL?!0:r===E.TargetPlatform.UNKNOWN?!1:r===n}function g(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}var b;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var u;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var m;(function(r){r.Install="install",r.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var p;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$gp=(0,D.$Ei)("extensionGalleryService");var $;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed",r.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class w extends Error{constructor(t,n){super(t),this.code=n,this.name=n}}e.$hp=w;var v;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.DownloadFailedWriting="DownloadFailedWriting",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.ScanningExtension="ScanningExtension",r.ReadUninstalled="ReadUninstalled",r.UnsetUninstalled="UnsetUninstalled",r.Delete="Delete",r.Rename="Rename",r.IntializeDefaultProfile="IntializeDefaultProfile",r.AddToProfile="AddToProfile",r.InstalledExtensionNotFound="InstalledExtensionNotFound",r.PostInstall="PostInstall",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Cancelled="Cancelled",r.Unknown="Unknown",r.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));class S extends Error{constructor(t,n){super(t),this.code=n,this.name=n}}e.$ip=S,e.$jp=(0,D.$Ei)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,D.$Ei)("IGlobalExtensionEnablementService"),e.$np=(0,D.$Ei)("IExtensionTipsService"),e.$op=(0,o.localize2)(0,"Extensions"),e.$pp=(0,o.localize2)(1,"Preferences")}),define(ce[247],le([0,1,2,6]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul=(0,o.$Ei)("remoteSocketFactoryService");class E{constructor(){this.a={}}register(R,P){return this.a[R]??=[],this.a[R].push(P),(0,i.$Tc)(()=>{const y=this.a[R]?.indexOf(P);typeof y=="number"&&y>=0&&this.a[R]?.splice(y,1)})}b(R){return(this.a[R.type]||[]).find(y=>y.supports(R))}connect(R,P,y,c){const h=this.b(R);if(!h)throw new Error(`No socket factory found for ${R}`);return h.connect(R,P,y,c)}}e.$Vl=E}),define(ce[248],le([0,1,27,49,21,122]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=P,i=Ae(i),o=Ae(o),D=Ae(D);let R;async function P(b=!1){return(R===void 0||b)&&(R=y()),R}async function y(){const b=c();if(b===void 0)return!1;if(b>=22e3){const u=d();if(u)return new Promise(m=>{o.execFile(u,["--status"],p=>m(!p))})}else{const u=g();if(u)try{if((await E.Promises.stat(u)).isFile())return!0}catch{}}return!1}function c(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());if(b)return parseInt(b[3])}function h(b){const u=process.env.SystemRoot;if(u){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(u,m?"Sysnative":"System32",b)}}function d(){return h("wsl.exe")}function g(){return h("lxss\\LxssManager.dll")}}),define(ce[55],le([0,1,17,16,2,189,54,6,5,45]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=g,e.$4p=b,e.$5p=u,e.$6p=m,e.$7p=p,e.$8p=$,e.$1p=(0,P.$Ei)("requestService");class h{constructor(r){this.b=r}toJSON(){if(!this.a){const r=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?r[t]="*****":r[t]=this.b[t];this.a=r}return this.a}}class d extends E.$Vc{constructor(r){super(),this.b=0,this.a=r.createLogger("network",{name:(0,D.localize)(0,null),when:y.$qk.isEqualTo((0,y.$nk)(y.LogLevel.Trace)).serialize()})}async c(r,t,n){const a=`${r} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new h(t.headers??{}));try{const s=await n();return this.a.trace(`${a} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${a} - error`,t.type,(0,o.$$)(s)),s}}}e.$2p=d;function g(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function b(S){return S.res.statusCode===204}async function u(S){return b(S)?null:(await(0,i.$Ze)(S.stream)).toString()}async function m(S){if(!g(S))throw new Error("Server returned "+S.res.statusCode);return u(S)}async function p(S){if(!g(S))throw new Error("Server returned "+S.res.statusCode);if(b(S))return null;const t=(await(0,i.$Ze)(S.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}function $(S){v(S)}let w;function v(S){const r=c.$oo.as(R.$to.Configuration),t=w;w={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},r.updateConfigurations({add:[w],remove:t?[t]:[]})}v(R.ConfigurationScope.APPLICATION)}),define(ce[249],le([0,1,17,23]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0;class E{constructor(P){this.a=P}listen(P,y){throw new Error("Invalid listen")}call(P,y,c,h=o.CancellationToken.None){switch(y){case"request":return this.a.request(c[0],h).then(async({res:d,stream:g})=>{const b=await(0,i.$Ze)(g);return[{statusCode:d.statusCode,headers:d.headers},b]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$8r=E;class D{constructor(P){this.a=P}async request(P,y){const[c,h]=await this.a.call("request",[P],y);return{res:c,stream:(0,i.$2e)(h)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$9r=D}),define(ce[250],le([0,1,251,12]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=D;function E(R,P){return R.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:R.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function D(R,P,y={}){const c=(0,i.parse)(R),h=y.proxyUrl||E(c,P);if(!h)return null;const d=(0,i.parse)(h);if(!/^https?:$/.test(d.protocol||""))return null;const g={host:d.hostname||"",port:(d.port?+d.port:0)||(d.protocol==="https"?443:80),auth:d.auth,rejectUnauthorized:(0,o.$kg)(y.strictSSL)?y.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((b,u)=>{V(["http-proxy-agent"],b,u)}).then(Ae)).HttpProxyAgent(h,g):new(await new Promise((b,u)=>{V(["https-proxy-agent"],b,u)}).then(Ae)).HttpsProxyAgent(h,g)}}),define(ce[252],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=e.$Rec=void 0,e.$Rec={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Sec={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Tec={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[101],le([0,1,49,9,190,23,53,16,4,33,117,68,8,143]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=m;let u;async function m($,w,v,S){return v["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$Im)(S)&&!v["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$Im)(S)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=g.Promises.withAsyncBody(async(r,t)=>{const n=new D.$we;let a=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(a=(0,b.$Jm)(s,1,120)*1e3);const l=setTimeout(()=>{n.dispose(!0),t(new Error((0,E.localize)(0,null)))},a);try{r(await p(w,n.token))}catch(f){!(0,P.$5)(f)&&!n.token.isCancellationRequested?t(new Error((0,E.localize)(1,null,(0,R.$pj)(f)))):r({})}finally{clearTimeout(l),n.dispose()}})),u)}async function p($,w){const v=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",v);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",S);const r=(0,c.$1g)().replace(/-/g,"").substr(0,12),t=new RegExp(r+"({.*})"+r),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",n);const a=await(0,h.$ym)(y.OS,n);return $.trace("getUnixShellEnvironment#shell",a),new Promise((s,l)=>{if(w.isCancellationRequested)return l(new P.$6);const f=(0,o.$oc)(a);let k,I;const O="";/^pwsh(-preview)?$/.test(f)?(k=`& '${process.execPath}' ${O} -p '''${r}'' + JSON.stringify(process.env) + ''${r}'''`,I=["-Login","-Command"]):f==="nu"?(k=`^'${process.execPath}' ${O} -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,I=["-i","-l","-c"]):f==="xonsh"?(k=`import os, json; print("${r}", json.dumps(dict(os.environ)), "${r}")`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${O} -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,f==="tcsh"||f==="csh"?I=["-ic"]:I=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const L=(0,i.spawn)(a,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});w.onCancellationRequested(()=>(L.kill(),l(new P.$6))),L.on("error",M=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,R.$pj)(M)),l(M)});const T=[];L.stdout.on("data",M=>T.push(M));const A=[];L.stderr.on("data",M=>A.push(M)),L.on("close",(M,z)=>{const C=Buffer.concat(T).toString("utf8");$.trace("getUnixShellEnvironment#raw",C);const B=Buffer.concat(A).toString("utf8");if(B.trim()&&$.trace("getUnixShellEnvironment#stderr",B),M||z)return l(new Error((0,E.localize)(2,null,M,z)));const re=t.exec(C),_=re?re[1]:"{}";try{const se=JSON.parse(_);v?se.ELECTRON_RUN_AS_NODE=v:delete se.ELECTRON_RUN_AS_NODE,S?se.ELECTRON_NO_ATTACH_CONSOLE=S:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",se),s(se)}catch(se){$.error("getUnixShellEnvironment#errorCaught",(0,R.$pj)(se)),l(se)}})})}}),define(ce[253],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(E){try{const D=await this.c();if(D){const R=String(i.a++);return this.b.set(R,D),{id:R,data:D.createNewMessage(E)}}}catch{}return{id:"",data:E}}async validate(E,D){if(!E.id)return!0;const R=this.b.get(E.id);if(!R)return!1;this.b.delete(E.id);try{return R.validate(D)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(E){try{return await this.d(E)}catch{}return E}}e.$Eac=i}),define(ce[102],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl="signService",e.$Xl=(0,i.$Ei)(e.$Wl)}),define(ce[254],le([0,1,253]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class o extends i.$Eac{c(){return this.h().then(D=>new D.validator)}d(D){return this.h().then(R=>new R.signer().sign(D))}h(){return new Promise((D,R)=>V(["vsda"],D,R))}}e.$Jfc=o}),define(ce[34],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=void 0,e.$LQ=(0,i.$Ei)("stateReadService"),e.$MQ=(0,i.$Ei)("stateService")}),define(ce[128],le([0,1,8,17,2,12,38,15,5]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.$OQ=e.$NQ=e.SaveStrategy=void 0;var c;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class h extends E.$Vc{constructor(u,m,p,$){super(),this.h=u,this.j=m,this.m=p,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new i.$Ch(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==P.FileOperationResult.FILE_NOT_FOUND&&this.m.error(u)}}getItem(u,m){const p=this.a[u];return(0,D.$ng)(p)?m:p}setItem(u,m){this.setItems([{key:u,data:m}])}setItems(u){let m=!1;for(const{key:p,data:$}of u)this.a[p]!==$&&((0,D.$ng)($)?(0,D.$lg)(this.a[p])||(this.a[p]=void 0,m=!0):(this.a[p]=$,m=!0));m&&this.s()}removeItem(u){(0,D.$lg)(this.a[u])||(this.a[u]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.n.writeFile(this.h,o.$Ne.fromString(u),{atomic:{postfix:".vsctmp"}}),this.b=u}catch(m){this.m.error(m)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$NQ=h;let d=class extends E.$Vc{constructor(u,m,p,$){super(),this.a=this.B(new h(m.stateResource,u,p,$))}async init(){await this.a.init()}getItem(u,m){return this.a.getItem(u,m)}};e.$OQ=d,e.$OQ=d=Se([oe(1,R.$Li),oe(2,y.$$j),oe(3,P.$$k)],d);class g extends d{setItem(u,m){this.a.setItem(u,m)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.$PQ=g}),define(ce[129],le([0,1,4,36,33]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=R,e.$rp=P;function D(y){if(i.$u===i.Platform.Linux&&/^penguin(\.|$)/i.test(y))return"chromebook"}function R(y,c,h,d,g,b,u,m,p,$){const w=Object.create(null);w["common.machineId"]=b,w["common.sqmId"]=u,w["common.devDeviceId"]=m,w.sessionID=(0,E.$1g)()+Date.now(),w.commitHash=d,w.version=g,w["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,i.$h)(i.$u),w["common.nodePlatform"]=o.$ec,w["common.nodeArch"]=h,w["common.product"]=$||"desktop",p&&(w["common.msftInternal"]=p);let v=0;const S=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),i.$l&&(w["common.snap"]="true");const r=D(c);return r&&(w["common.platformDetail"]=r),w}function P(y){const c=o.env.USERDNSDOMAIN;if(!c)return!1;const h=c.toLowerCase();return y.some(d=>h===d)}}),define(ce[24],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,i.$Ei)("telemetryService"),e.$$l=(0,i.$Ei)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var o;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(o||(e.TelemetryLevel=o={}));var E;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(ce[255],le([0,1,27,8,40,13,9,4,66,7,93,21,116,96,15,28,24]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Rs=w,e.$Ss=S,e.$Ts=r,i=Ae(i);const $=new Map;async function w(n,a){const s=`${n}::${a.join(":")}`,l=$.get(s);if(l)return l;const f=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],k=new Map,I=new Map,O=2e4;function L(A,M,z,C){const B=M.substring(A.length+1);return o.Promises.withAsyncBody(async re=>{let _;C.readdirCount++;try{_=await d.Promises.readdir(M,{withFileTypes:!0})}catch{re();return}if(C.count>=O){C.count+=_.length,C.maxReached=!0,re();return}let se=_.length;if(se===0){re();return}let K=_;C.count+_.length>O&&(C.maxReached=!0,se=O-C.count,K=_.slice(0,se)),C.count+=_.length;for(const ee of K)if(ee.isDirectory()){if(z.includes(ee.name)||await L(A,(0,R.$kc)(M,ee.name),z,C),--se===0){re();return}}else{const H=ee.name.lastIndexOf(".");if(H>=0){const j=ee.name.substring(H+1);j&&k.set(j,(k.get(j)??0)+1)}for(const j of f)j.relativePathPattern?.test(B)!==!1&&j.filePattern.test(ee.name)&&I.set(j.tag,(I.get(j.tag)??0)+1);if(--se===0){re();return}}})}const T=o.Promises.withAsyncBody(async A=>{const M={count:0,maxReached:!1,readdirCount:0},z=new y.$fe(!0);await L(n,n,a,M);const C=await r(n);A({configFiles:v(I),fileTypes:v(k),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:C,totalScanTime:z.elapsed(),totalReaddirCount:M.readdirCount})});return $.set(s,T),T}function v(n){return Array.from(n.entries(),([a,s])=>({name:a,count:s})).sort((a,s)=>s.count-a.count)}function S(){const n={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/u.$Gl.GB).toFixed(2)}GB (${(i.freemem()/u.$Gl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$On.value()*100)}%`},a=i.cpus();return a&&a.length>0&&(n.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),n}async function r(n){try{const a=new Map,s=(0,R.$kc)(n,".vscode","launch.json"),l=await d.Promises.readFile(s),f=[],k=(0,E.$Un)(l.toString(),f);if(f.length)return console.log(`Unable to parse ${s}`),[];if((0,E.$4n)(k)==="object"&&k.configurations)for(const I of k.configurations){const O=I.type;O&&(a.has(O)?a.set(O,a.get(O)+1):a.set(O,1))}return v(a)}catch{return[]}}let t=class{constructor(a,s){this.c=a,this.d=s}f(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}g(a){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const l=i.cpus();return l&&l.length>0&&s.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),s.push(`Memory (System):  ${(i.totalmem()/u.$Gl.GB).toFixed(2)}GB (${(i.freemem()/u.$Gl.GB).toFixed(2)}GB free)`),P.$i||s.push(`Load (avg):       ${i.loadavg().map(f=>Math.round(f)).join(", ")}`),s.push(`VM:               ${Math.round(h.$On.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,g.$Qs)(a.mainPID),this.k(a)]).then(async l=>{let[f,k]=l,I=this.m(a,f);return s.forEach(O=>{if((0,b.$Sm)(O))I+=`
${O.errorMessage}`,k+=`
${O.errorMessage}`;else if(I+=`

Remote: ${O.hostName}`,O.processes&&(I+=`
${this.m(a,O.processes)}`),O.workspaceMetadata){k+=`
|  Remote: ${O.hostName}`;for(const L of Object.keys(O.workspaceMetadata)){const T=O.workspaceMetadata[L];let A=`${T.fileCount} files`;T.maxFilesReached&&(A=`more than ${A}`),k+=`|    Folder (${L}): ${A}`,k+=this.h(T)}}}),{processInfo:I,workspaceInfo:k}})}async getSystemInfo(a,s){const{memory:l,vmHint:f,os:k,cpus:I}=S(),O={os:k,memory:l,cpus:I,vmHint:f,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return P.$i||(O.load=`${i.loadavg().map(L=>Math.round(L)).join(", ")}`),P.$k&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(a,s){const l=[];return(0,g.$Qs)(a.mainPID).then(async f=>(l.push(""),l.push(this.g(a)),l.push(""),l.push(this.m(a,f)),a.windows.some(k=>k.folderURIs&&k.folderURIs.length>0&&!k.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(a))),s.forEach(k=>{if((0,b.$Sm)(k))l.push(`
${k.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${k.hostName}`),l.push(this.f(k.machineInfo)),k.processes&&l.push(this.m(a,k.processes)),k.workspaceMetadata)for(const I of Object.keys(k.workspaceMetadata)){const O=k.workspaceMetadata[I];let L=`${O.fileCount} files`;O.maxFilesReached&&(L=`more than ${L}`),l.push(`Folder (${I}): ${L}`),l.push(this.h(O))}}),l.push(""),l.push(""),l.join(`
`)))}h(a){const s=[];let f=0;const k=(T,A)=>{const M=` ${T}(${A})`;f+M.length>60?(s.push(I),I="|                 ",f=I.length):f+=M.length,I+=M};let I="|      File types:";const O=10,L=a.fileTypes.length>O?O:a.fileTypes.length;for(let T=0;T<L;T++){const A=a.fileTypes[T];k(A.name,A.count)}if(s.push(I),a.configFiles.length>=0&&(I="|      Conf files:",f=0,a.configFiles.forEach(T=>{k(T.name,T.count)}),s.push(I)),a.launchConfigFiles.length>0){let T="|      Launch Configs:";a.launchConfigFiles.forEach(A=>{const M=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;T+=M}),s.push(T)}return s.join(`
`)}j(a){const s=Math.max(...Object.keys(a).map(l=>l.length));return Object.keys(a).map(l=>`${l}:  ${" ".repeat(s-l.length)}  ${a[l]}`).join(`
                  `)}k(a){const s=[],l=[];return a.windows.forEach(f=>{f.folderURIs.length===0||f.remoteAuthority||(s.push(`|  Window (${f.title})`),f.folderURIs.forEach(k=>{const I=c.URI.revive(k);if(I.scheme===D.Schemas.file){const O=I.fsPath;l.push(w(O,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,R.$oc)(O)}): ${T}`),s.push(this.h(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${O} (${L.toString()})`)}))}else s.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(f=>s.join(`
`)).catch(f=>`Unable to collect workspace stats: ${f}`)}m(a,s){const l=new Map;a.windows.forEach(k=>l.set(k.pid,`window [${k.id}] (${k.title})`)),a.pidToNames.forEach(({pid:k,name:I})=>l.set(k,I));const f=[];return f.push("CPU %	Mem MB	   PID	Process"),s&&this.n(a.mainPID,l,f,s,0),f.join(`
`)}n(a,s,l,f,k){const I=k===0;let O;I?O=f.pid===a?`${this.d.applicationName} main`:"remote agent":s.has(f.pid)?O=s.get(f.pid):O=`${"  ".repeat(k)} ${f.name}`;const L=process.platform==="win32"?f.mem:i.totalmem()*(f.mem/100);l.push(`${f.load.toFixed(0).padStart(5," ")}	${(L/u.$Gl.MB).toFixed(0).padStart(6," ")}	${f.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(f.children)&&f.children.forEach(T=>this.n(a,s,l,T,k+1))}async getWorkspaceFileExtensions(a){const s=new Set;for(const{uri:l}of a.folders){const f=c.URI.revive(l);if(f.scheme!==D.Schemas.file)continue;const k=f.fsPath;try{(await w(k,["node_modules",".git"])).fileTypes.forEach(O=>s.add(O.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const l=c.URI.revive(s);if(l.scheme!==D.Schemas.file)continue;const f=l.fsPath;try{const k=await w(f,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),k.fileTypes.forEach(I=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:I.name,count:I.count})}),k.launchConfigFiles.forEach(I=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:I.name,count:I.count})}),k.configFiles.forEach(I=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:I.name,count:I.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:k.totalScanTime,reachedLimit:k.maxFilesReached,fileCount:k.fileCount,readdirCount:k.totalReaddirCount})}catch{}}}};e.$Us=t,e.$Us=t=Se([oe(0,p.$0l),oe(1,m.$rk)],t)}),define(ce[256],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=void 0;class i{constructor(D){this.b=D}listen(D,R){throw new Error(`Event not found: ${R}`)}call(D,R,{eventName:P,data:y}){return this.b.forEach(c=>c.log(P,y)),Promise.resolve(null)}}e.$Wec=i;class o{constructor(D){this.b=D}log(D,R){return this.b.call("log",{eventName:D,data:R}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Xec=o}),define(ce[56],le([0,1,35,12,72,129,24]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=h,e.$Ap=d,e.$Bp=g,e.$Cp=b,e.$Dp=m,e.$Ep=$,e.$Fp=w,e.$Gp=r;class P{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$sp=P;class y{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=y,e.$up=new y;class c{async publicLog(n,a,s){}async publicLogError(n,a,s){}}e.$vp=c,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function h(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}function d(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function g(t){const n=t.getValue(R.$gm),a=t.getValue(R.$hm);if(t.getValue(R.$im)===!1||a===!1)return R.TelemetryLevel.NONE;switch(n??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function b(t){const n={},a={},s={};p(t,s);for(let l in s){l=l.length>150?l.substr(l.length-149):l;const f=s[l];typeof f=="number"?a[l]=f:typeof f=="boolean"?a[l]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${f.length}`),n[l]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(n[l]=f)}return{properties:n,measurements:a}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(t){if(!t)return"none";const n=(0,E.$gn)(t);return u.has(n)?n:"other"}function p(t,n,a=0,s){if(t)for(const l of Object.getOwnPropertyNames(t)){const f=t[l],k=s?s+l:l;Array.isArray(f)?n[k]=(0,i.$go)(f):f instanceof Date?n[k]=f.toISOString():(0,o.$gg)(f)?a<2?p(f,n,a+1,k+"."):n[k]=(0,i.$go)(f):n[k]=f}}function $(t,n){const a=t.msftInternalDomains||[],s=n.getValue("telemetry.internalTesting");return(0,D.$rp)(a)||s}function w(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function v(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const s=[];for(const I of n)for(;;){const O=I.exec(t);if(!O)break;s.push([O.index,I.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(a="";;){const I=f.exec(t);if(!I)break;const O=s.some(([L,T])=>I.index<T&&L<f.lastIndex);!l.test(I[0])&&!O&&(a+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=f.lastIndex)}return k<t.length&&(a+=t.substr(k)),a}function S(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function r(t,n){return(0,i.$do)(t,a=>{if(a instanceof P||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let s=a.replaceAll("%20"," ");s=v(s,n);for(const l of n)s=s.replace(l,"");return s=S(s),s}})}}),define(ce[130],le([0,1,26,127,100,4,7,16,36,56]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=h,e.$Jp=u,e.$Kp=m,e.$Lp=p,e.$Mp=$,e.$Np=w,e.$Op=v,e.$Pp=S,e.$Rp=r,e.$Sp=n;function h(a,s){return a.uuid&&s.uuid?a.uuid===s.uuid:a.id===s.id?!0:(0,i.$Af)(a.id,s.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const l=s.manifest?s.manifest.version:s.version,f=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,l,f)}static parse(s){const l=d.exec(s);return l&&l[1]&&l[2]?new g({id:l[1]},l[2],l[4]||void 0):null}constructor(s,l,f=E.TargetPlatform.UNDEFINED){this.identifier=s,this.version=l,this.targetPlatform=f,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?h(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Ip=g;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(a){const s=b.exec(a);return s&&s[1]?[p(s[1]),s[2]]:[p(a),void 0]}function m(a,s){return`${a}.${s}`}function p(a){return a.toLowerCase()}function $(a,s){return p(m(a??E.$ln,s))}function w(a,s){const l=[],f=k=>{for(const I of l)if(I.some(O=>h(s(O),s(k))))return I;return null};for(const k of a){const I=f(k);I?I.push(k):l.push([k])}return l}function v(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function S(a){return{id:new c.$sp(a.identifier.id),name:new c.$sp(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Qp=new E.$pn("pprice.better-merge");function r(a,s){const l=[],f=s.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const k=f.shift();if(k&&l.every(I=>!h(I.identifier,{id:k}))){const I=a.filter(O=>h(O.identifier,{id:k}));I.length===1&&(l.push(I[0]),f.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function t(a,s){if(!D.$k)return!1;let l;try{l=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){s.debug("Error while getting the os-release file.",(0,P.$$)(k))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(a,s){const l=await t(a,s),f=(0,o.$cp)(l?"alpine":D.$u,y.$fc);return s.debug("ComputeTargetPlatform:",f),f}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[257],le([0,1,2,35,4,26,191,18,54,84,28,45,24,56]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,c=et(c);let u=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,w,v){this.k=w,this.l=v,this.d={},this.i=new i.$Uc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=g.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,D.$hf)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$hf)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(g.$gm)||S.affectsConfiguration(g.$im)||S.affectsConfiguration(g.$hm))&&this.m()}))}setExperimentProperty($,w){this.d[$]=w}m(){let $=(0,b.$Bp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const v=w.usage?g.TelemetryLevel.USAGE:w.error?g.TelemetryLevel.ERROR:g.TelemetryLevel.NONE;$=Math.min($,v)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,w,v){this.g<w||(v=(0,o.$eo)(v,this.d),v=(0,b.$Gp)(v,this.j),v=(0,o.$eo)(v,this.c),this.b.forEach(S=>S.log($,v)))}publicLog($,w){this.n($,g.TelemetryLevel.USAGE,w)}publicLog2($,w){this.publicLog($,w)}publicLogError($,w){this.h&&this.n($,g.TelemetryLevel.ERROR,w)}publicLogError2($,w){this.publicLogError($,w)}};e.$as=u,e.$as=u=Se([oe(1,P.$$i),oe(2,h.$rk)],u);function m(){const p=(0,R.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=E.$o?"":(0,R.localize)(3,null),v=(0,R.localize)(4,null),S=(0,R.localize)(5,null),r=(0,R.localize)(6,null),t=(0,R.localize)(7,null),n=`
|       | ${v} | ${S} | ${r} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,R.localize)(8,null);return`
${p} ${$} ${w}

&nbsp;

${t}
${n}

&nbsp;

${a}
`}d.$oo.as(y.$to.Configuration).registerConfiguration({id:g.$fm,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[g.$gm]:{type:"string",enum:[g.TelemetryConfiguration.ON,g.TelemetryConfiguration.ERROR,g.TelemetryConfiguration.CRASH,g.TelemetryConfiguration.OFF],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:m(),default:g.TelemetryConfiguration.ON,restricted:!0,scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$oo.as(y.$to.Configuration).registerConfiguration({id:g.$fm,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[g.$im]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,R.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,R.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${g.$gm}#\``),scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[258],le([0,1,4,93,24]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=D,e.$nfc=R,e.$ofc=P;async function D(y,c){let h=y.getItem(E.$cm);return(typeof h!="string"||i.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,o.$Pn)(c.error.bind(c))),h}async function R(y,c){let h=y.getItem(E.$dm);return typeof h!="string"&&(h=await(0,o.$Qn)(c.error.bind(c))),h}async function P(y,c){let h=y.getItem(E.$em);return typeof h!="string"&&(h=await(0,o.$Rn)(c.error.bind(c))),h}}),define(ce[259],le([0,1,24,258]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=E,e.$qfc=D,e.$rfc=R;async function E(P,y){const c=await(0,o.$mfc)(P,y);return P.setItem(i.$cm,c),c}async function D(P,y){const c=await(0,o.$nfc)(P,y);return P.setItem(i.$dm,c),c}async function R(P,y){const c=await(0,o.$ofc)(P,y);return P.setItem(i.$em,c),c}}),define(ce[131],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(o){o[o.Replace=1]="Replace",o[o.Append=2]="Append",o[o.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(ce[260],le([0,1,4,131]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;const E=new Map([[o.EnvironmentVariableMutatorType.Append,"APPEND"],[o.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[o.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(h){this.collections=h,this.a=new Map,this.b=new Map,h.forEach((d,g)=>{this.d(d,g);const b=d.map.entries();let u=b.next();for(;!u.done;){const m=u.value[1],p=u.value[0];let $=this.a.get(p);if($||($=[],this.a.set(p,$)),$.length>0&&$[0].type===o.EnvironmentVariableMutatorType.Replace){u=b.next();continue}const w={extensionIdentifier:g,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};w.scope||delete w.scope,$.unshift(w),u=b.next()}})}async applyToProcessEnvironment(h,d,g){let b;i.$i&&(b={},Object.keys(h).forEach(u=>b[u.toLowerCase()]=u));for(const[u,m]of this.getVariableMap(d)){const p=i.$i&&b[u.toLowerCase()]||u;for(const $ of m){const w=g?await g($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case o.EnvironmentVariableMutatorType.Append:h[p]=(h[p]||"")+w;break;case o.EnvironmentVariableMutatorType.Prepend:h[p]=w+(h[p]||"");break;case o.EnvironmentVariableMutatorType.Replace:h[p]=w;break}if($.options?.applyAtShellIntegration??!1){const v=`VSCODE_ENV_${E.get($.type)}`;h[v]=(h[v]?h[v]+":":"")+u+"="+this.c(w)}}}}c(h){return h.replaceAll(":","\\x3a")}diff(h,d){const g=new Map,b=new Map,u=new Map;if(h.getVariableMap(d).forEach((m,p)=>{const $=this.getVariableMap(d).get(p),w=P(m,$);w&&g.set(p,w)}),this.getVariableMap(d).forEach((m,p)=>{const $=h.getVariableMap(d).get(p),w=P(m,$);w&&u.set(p,w)}),this.getVariableMap(d).forEach((m,p)=>{const $=h.getVariableMap(d).get(p),w=y(m,$);w&&b.set(p,w)}),!(g.size===0&&b.size===0&&u.size===0))return{added:g,changed:b,removed:u}}getVariableMap(h){const d=new Map;for(const g of this.a.values()){const b=g.filter(u=>R(u,h));b.length>0&&d.set(b[0].variable,b)}return d}getDescriptionMap(h){const d=new Map;for(const g of this.b.values()){const b=g.filter(u=>R(u,h,!0));for(const u of b)d.set(u.extensionIdentifier,u.description)}return d}d(h,d){if(!h.descriptionMap)return;const g=h.descriptionMap.entries();let b=g.next();for(;!b.done;){const u=b.value[1],m=b.value[0];let p=this.b.get(m);p||(p=[],this.b.set(m,p));const $={extensionIdentifier:d,scope:u.scope,description:u.description};$.scope||delete $.scope,p.push($),b=g.next()}}}e.$Es=D;function R(c,h,d=!1){return c.scope?!!(c.scope.workspaceFolder&&h?.workspaceFolder&&c.scope.workspaceFolder.index===h.workspaceFolder.index):d?h===c.scope:!0}function P(c,h){if(!h)return c;const d=new Set;h.forEach(b=>d.add(b.extensionIdentifier));const g=[];return c.forEach(b=>{d.has(b.extensionIdentifier)||g.push(b)}),g.length===0?void 0:g}function y(c,h){if(!h)return;const d=new Map;h.forEach(b=>d.set(b.extensionIdentifier,b));const g=[];return c.forEach(b=>{const u=d.get(b.extensionIdentifier);u&&(b.type!==u.type||b.value!==u.value||b.scope?.workspaceFolder?.index!==u.scope?.workspaceFolder?.index)&&g.push(u)}),g.length===0?void 0:g}}),define(ce[261],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=i,e.$zs=o,e.$As=E,e.$Bs=D,e.$Cs=R,e.$Ds=P;function i(y){return[...y.entries()]}function o(y){return y?[...y.entries()]:[]}function E(y){return new Map(y)}function D(y){return new Map(y??[])}function R(y){return Array.from(y.entries()).map(c=>[c[0],i(c[1].map),o(c[1].descriptionMap)])}function P(y){return new Map(y.map(c=>[c[0],{map:E(c[1]),descriptionMap:D(c[2])}]))}}),define(ce[262],le([0,1,8,23,3,2,5]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0;let P=class extends D.$Vc{constructor(c,h){super(),this.h=h,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$le),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,D.$Tc)(()=>{for(const d of this.f.values())(0,D.$Qc)(d)}))}createRequest(c){return new Promise((h,d)=>{const g=++this.a;this.c.set(g,h),this.g.fire({requestId:g,...c});const b=new o.$we;(0,i.$Fh)(this.b,b.token).then(()=>d(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,D.$Tc)(()=>b.cancel())])})}acceptReply(c,h){const d=this.c.get(c);d?(this.c.delete(c),(0,D.$Qc)(this.f.get(c)||[]),this.f.delete(c),d(h)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$ps=P,e.$ps=P=Se([oe(1,R.$$j)],P)}),define(ce[73],le([0,1,6,123,45]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$is=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hs=void 0,e.$hs=new o.$Vj("terminalTabFocusMode",!1,!0);var D;(function(r){r.AutomationProfile="terminal.integrated.automationProfile.",r.DefaultProfile="terminal.integrated.defaultProfile.",r.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var R;(function(r){r.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",r.AutomationProfileLinux="terminal.integrated.automationProfile.linux",r.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",r.AutomationProfileWindows="terminal.integrated.automationProfile.windows",r.ProfilesWindows="terminal.integrated.profiles.windows",r.ProfilesMacOs="terminal.integrated.profiles.osx",r.ProfilesLinux="terminal.integrated.profiles.linux",r.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",r.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",r.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",r.UseWslProfiles="terminal.integrated.useWslProfiles",r.TabsDefaultColor="terminal.integrated.tabs.defaultColor",r.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",r.TabsEnabled="terminal.integrated.tabs.enabled",r.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",r.TabsHideCondition="terminal.integrated.tabs.hideCondition",r.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",r.TabsShowActions="terminal.integrated.tabs.showActions",r.TabsLocation="terminal.integrated.tabs.location",r.TabsFocusMode="terminal.integrated.tabs.focusMode",r.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",r.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",r.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",r.CopyOnSelection="terminal.integrated.copyOnSelection",r.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",r.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",r.FontFamily="terminal.integrated.fontFamily",r.FontSize="terminal.integrated.fontSize",r.LetterSpacing="terminal.integrated.letterSpacing",r.LineHeight="terminal.integrated.lineHeight",r.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",r.TabStopWidth="terminal.integrated.tabStopWidth",r.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",r.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",r.BellDuration="terminal.integrated.bellDuration",r.FontWeight="terminal.integrated.fontWeight",r.FontWeightBold="terminal.integrated.fontWeightBold",r.CursorBlinking="terminal.integrated.cursorBlinking",r.CursorStyle="terminal.integrated.cursorStyle",r.CursorStyleInactive="terminal.integrated.cursorStyleInactive",r.CursorWidth="terminal.integrated.cursorWidth",r.Scrollback="terminal.integrated.scrollback",r.DetectLocale="terminal.integrated.detectLocale",r.DefaultLocation="terminal.integrated.defaultLocation",r.GpuAcceleration="terminal.integrated.gpuAcceleration",r.TerminalTitleSeparator="terminal.integrated.tabs.separator",r.TerminalTitle="terminal.integrated.tabs.title",r.TerminalDescription="terminal.integrated.tabs.description",r.RightClickBehavior="terminal.integrated.rightClickBehavior",r.MiddleClickBehavior="terminal.integrated.middleClickBehavior",r.Cwd="terminal.integrated.cwd",r.ConfirmOnExit="terminal.integrated.confirmOnExit",r.ConfirmOnKill="terminal.integrated.confirmOnKill",r.EnableBell="terminal.integrated.enableBell",r.EnableVisualBell="terminal.integrated.enableVisualBell",r.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",r.AllowChords="terminal.integrated.allowChords",r.AllowMnemonics="terminal.integrated.allowMnemonics",r.TabFocusMode="terminal.integrated.tabFocusMode",r.EnvMacOs="terminal.integrated.env.osx",r.EnvLinux="terminal.integrated.env.linux",r.EnvWindows="terminal.integrated.env.windows",r.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",r.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",r.ShowExitAlert="terminal.integrated.showExitAlert",r.SplitCwd="terminal.integrated.splitCwd",r.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",r.WordSeparators="terminal.integrated.wordSeparators",r.EnableFileLinks="terminal.integrated.enableFileLinks",r.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",r.UnicodeVersion="terminal.integrated.unicodeVersion",r.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",r.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",r.HideOnStartup="terminal.integrated.hideOnStartup",r.CustomGlyphs="terminal.integrated.customGlyphs",r.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",r.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",r.InheritEnv="terminal.integrated.inheritEnv",r.ShowLinkHover="terminal.integrated.showLinkHover",r.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",r.AutoReplies="terminal.integrated.autoReplies",r.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",r.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",r.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",r.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",r.EnableImages="terminal.integrated.enableImages",r.SmoothScrolling="terminal.integrated.smoothScrolling",r.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",r.FocusAfterRun="terminal.integrated.focusAfterRun",r.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",r.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",r.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var P;(function(r){r.PowerShell="pwsh",r.Bash="bash",r.Fish="fish",r.Sh="sh",r.Csh="csh",r.Ksh="ksh",r.Zsh="zsh",r.Python="python"})(P||(e.PosixShellType=P={}));var y;(function(r){r.CommandPrompt="cmd",r.PowerShell="pwsh",r.Wsl="wsl",r.GitBash="gitbash",r.Python="python"})(y||(e.WindowsShellType=y={}));var c;(function(r){r[r.Api=0]="Api",r[r.Process=1]="Process",r[r.Sequence=2]="Sequence",r[r.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var h;(function(r){r.LocalPty="localPty",r.PtyHost="ptyHost",r.PtyHostWindow="ptyHostWindow",r.Logger="logger",r.Heartbeat="heartbeat"})(h||(e.TerminalIpcChannels=h={}));var d;(function(r){r.Cwd="cwd",r.InitialCwd="initialCwd",r.FixedDimensions="fixedDimensions",r.Title="title",r.ShellType="shellType",r.HasChildProcesses="hasChildProcesses",r.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",r.OverrideDimensions="overrideDimensions",r.FailedShellIntegrationActivation="failedShellIntegrationActivation",r.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={})),e.$is=(0,i.$Ei)("ptyService");var g;(function(r){r[r.BeatInterval=5e3]="BeatInterval",r[r.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",r[r.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",r[r.SecondWaitMultiplier=1]="SecondWaitMultiplier",r[r.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(g||(e.HeartbeatConstants=g={}));var b;(function(r){r[r.Panel=1]="Panel",r[r.Editor=2]="Editor"})(b||(e.TerminalLocation=b={}));var u;(function(r){r.TerminalView="view",r.Editor="editor"})(u||(e.TerminalLocationString=u={}));var m;(function(r){r[r.GraceTime=6e4]="GraceTime",r[r.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var p;(function(r){r[r.HighWatermarkChars=1e5]="HighWatermarkChars",r[r.LowWatermarkChars=5e3]="LowWatermarkChars",r[r.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var $;(function(r){r.GitBash="Git Bash",r.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var w;(function(r){r[r.Off=0]="Off",r[r.FinalTerm=1]="FinalTerm",r[r.VSCode=2]="VSCode"})(w||(e.ShellIntegrationStatus=w={}));var v;(function(r){r[r.Unknown=0]="Unknown",r[r.Shutdown=1]="Shutdown",r[r.Process=2]="Process",r[r.User=3]="User",r[r.Extension=4]="Extension"})(v||(e.TerminalExitReason=v={})),e.$js={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const n=this.b(t.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}E.$oo.add(e.$js.Backend,new S),e.$ks=(0,i.$Ei)("localPtyService"),e.$ls=(0,i.$Ei)("terminalLogService")}),define(ce[263],le([0,1,78,7,193,111]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=R,e.$rs=c,e.$ss=h,e.$ts=d;function R(g,b){const u=[{name:null,description:(0,E.localize)(0,null)}];return u.push(...g.map(m=>({name:m.profileName,description:P(m)}))),b&&u.push(...b.map(m=>({name:m.title,description:y(m)}))),{values:u.map(m=>m.name),markdownDescriptions:u.map(m=>m.description)}}function P(g){let b=`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:i.$4j.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?b+=`
- args: "${g.args}"`:b+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(b+=`
- overrideName: ${g.overrideName}`),g.color&&(b+=`
- color: ${g.color}`),g.env&&(b+=`
- env: ${JSON.stringify(g.env)}`),b}function y(g){return`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:i.$4j.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function c(g,b){if(!g&&!b)return!0;if(typeof g=="string"&&typeof b=="string")return g===b;if(Array.isArray(g)&&Array.isArray(b)){if(g.length!==b.length)return!1;for(let u=0;u<g.length;u++)if(g[u]!==b[u])return!1;return!0}return!1}function h(g,b){if(!g&&!b)return!0;if(!g||!b)return!1;if(D.ThemeIcon.isThemeIcon(g)&&D.ThemeIcon.isThemeIcon(b))return g.id===b.id&&g.color===b.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof b=="object"&&"light"in b&&"dark"in b){const u=g,m=b;if((o.URI.isUri(u.light)||d(u.light))&&(o.URI.isUri(u.dark)||d(u.dark))&&(o.URI.isUri(m.light)||d(m.light))&&(o.URI.isUri(m.dark)||d(m.dark)))return u.light.path===m.light.path&&u.dark.path===m.dark.path}if(o.URI.isUri(g)&&o.URI.isUri(b)||d(g)||d(b)){const u=g,m=b;return u.path===m.path&&u.scheme===m.scheme}return!1}function d(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}}),define(ce[264],le([0,1,78,4,192,54,45,73,263]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=void 0,e.$ws=u,e.$xs=p,e.$us={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$vs={type:"string",enum:Array.from((0,i.$2j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,i.$2j)(),$=>`$(${$.id})`)};const c={args:{description:(0,E.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(1,null),type:"boolean"},icon:{description:(0,E.localize)(2,null),...e.$vs},color:{description:(0,E.localize)(3,null),...e.$us},env:{markdownDescription:(0,E.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(5,null),type:["string","array"],items:{type:"string"}},...c}},d={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(6,null),type:["string"],items:{type:"string"}},...c}};function g($){const w=$===o.Platform.Linux?"linux":$===o.Platform.Mac?"osx":"windows";return(0,E.localize)(7,null,(0,o.$h)($),'```json\n"terminal.integrated.profile.'+w+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,E.localize)(8,null),type:"object",properties:{[P.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[P.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[P.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[P.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:g(o.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(12,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(13,null),type:"string"},id:{description:(0,E.localize)(14,null),type:"string"},title:{description:(0,E.localize)(15,null),type:"string"},...c}},{type:"null"},h]}},[P.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:g(o.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(16,null),type:"string"},id:{description:(0,E.localize)(17,null),type:"string"},title:{description:(0,E.localize)(18,null),type:"string"},...c}},{type:"null"},h]}},[P.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:g(o.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(19,null),type:"string"},id:{description:(0,E.localize)(20,null),type:"string"},title:{description:(0,E.localize)(21,null),type:"string"},...c}},{type:"null"},h]}},[P.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(22,null),type:"boolean",default:!0},[P.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,E.localize)(23,null),type:"boolean",default:!0},[P.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(24,null),type:"number",default:100},[P.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,E.localize)(25,null),type:"boolean",default:!0},[P.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){R.$oo.as(D.$to.Configuration).registerConfiguration(b),p()}let m;function p($,w){const v=R.$oo.as(D.$to.Configuration);let S;$&&(S=(0,y.$qs)($?.profiles,w));const r=m;m={id:"terminal",order:100,title:(0,E.localize)(27,null),type:"object",properties:{[P.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(28,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[P.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(29,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[P.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(30,null),type:["string","null"],default:null,enum:$?.os===o.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:$?.os===o.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[m],remove:r?[r]:[]})}}),define(ce[265],le([0,1,27,13,35,9,4,36,26,12,21,131,261,260]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=u,e.$Gs=m,e.$Hs=p,i=Ae(i),D=Ae(D),P=Ae(P),h=Ae(h);function u(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let k=0;return f&&f.length===4&&(k=parseInt(f[3])),k}async function m(f,k,I,O=P.env,L=h.Promises.exists){if(D.$jc(f))return await L(f)?f:void 0;if(k===void 0&&(k=P.cwd()),D.$nc(f)!=="."){const z=D.$kc(k,f);return await L(z)?z:void 0}const A=(0,E.$io)(O,"PATH");if(I===void 0&&(0,c.$eg)(A)&&(I=A.split(D.$uc)),I===void 0||I.length===0){const z=D.$kc(k,f);return await L(z)?z:void 0}for(const z of I){let C;if(D.$jc(z)?C=D.$kc(z,f):C=D.$kc(k,z,f),await L(C))return C;if(R.$i){let B=C+".com";if(await L(B)||(B=C+".exe",await L(B)))return B}}const M=D.$kc(k,f);return await L(M)?M:void 0}function p(f,k,I,O,L){const T=R.$i&&(!k.windowsEnableConpty||u()<18309);if(!k.shellIntegration.enabled||!f.executable||f.isFeatureTerminal&&!f.forceShellIntegration||f.ignoreShellIntegration||T)return;const A=f.args,M=P.$ec==="win32"?D.$oc(f.executable).toLowerCase():D.$oc(f.executable),z=D.$nc(o.$Yg.asFileUri("").fsPath);let C;const B={VSCODE_INJECTION:"1"};if(k.shellIntegration.nonce&&(B.VSCODE_NONCE=k.shellIntegration.nonce),R.$i){if(M==="pwsh.exe"||M==="powershell.exe")return!A||s(A)?C=v.get(w.WindowsPwsh):a(A)&&(C=v.get(w.WindowsPwshLogin)),C?(C=[...C],C[C.length-1]=(0,y.$df)(C[C.length-1],z,""),k.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:C,envMixin:B}):void 0;if(M==="bash.exe")return!A||A.length===0?C=v.get(w.Bash):l(A)&&(B.VSCODE_SHELL_LOGIN="1",$(k,B),C=v.get(w.Bash)),C?(C=[...C],C[C.length-1]=(0,y.$df)(C[C.length-1],z),{newArgs:C,envMixin:B}):void 0;O.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(M){case"bash":return!A||A.length===0?C=v.get(w.Bash):l(A)&&(B.VSCODE_SHELL_LOGIN="1",$(k,B),C=v.get(w.Bash)),C?(C=[...C],C[C.length-1]=(0,y.$df)(C[C.length-1],z),{newArgs:C,envMixin:B}):void 0;case"fish":{const re=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",_=D.$kc(z,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${re}:${_}`,$(k,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!A||s(A)?C=v.get(w.Pwsh):a(A)&&(C=v.get(w.PwshLogin)),C?(k.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),C=[...C],C[C.length-1]=(0,y.$df)(C[C.length-1],z,""),{newArgs:C,envMixin:B}):void 0;case"zsh":{if(!A||A.length===0?C=v.get(w.Zsh):l(A)?(C=v.get(w.ZshLogin),$(k,B)):(A===v.get(w.Zsh)||A===v.get(w.ZshLogin))&&(C=A),!C)return;C=[...C],C[C.length-1]=(0,y.$df)(C[C.length-1],z);let re;try{re=i.userInfo().username}catch{re="unknown"}const _=D.$kc(i.tmpdir(),`${re}-${L.applicationName}-zsh`);B.ZDOTDIR=_;const se=I?.ZDOTDIR??i.homedir()??"~";B.USER_ZDOTDIR=se;const K=[];return K.push({source:D.$kc(z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$kc(_,".zshrc")}),K.push({source:D.$kc(z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$kc(_,".zprofile")}),K.push({source:D.$kc(z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$kc(_,".zshenv")}),K.push({source:D.$kc(z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$kc(_,".zlogin")}),{newArgs:C,envMixin:B,filesToCopy:K}}}O.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}function $(f,k){if(R.$j&&f.environmentVariableCollections){const I=(0,g.$Ds)(f.environmentVariableCollections),L=new b.$Es(I).getVariableMap({workspaceFolder:f.workspaceFolder}).get("PATH"),T=[];if(L)for(const A of L)A.type===d.EnvironmentVariableMutatorType.Prepend&&T.push(A.value);T.length>0&&(k.VSCODE_PATH_PREFIX=T.join(""))}}var w;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(w||(w={}));const v=new Map;v.set(w.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(w.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),v.set(w.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),v.set(w.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),v.set(w.Zsh,["-i"]),v.set(w.ZshLogin,["-il"]),v.set(w.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],r=["--login","-l"],t=["-i","--interactive"],n=["-nol","-nologo"];function a(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(n.includes(f[0].toLowerCase())||n.includes(f[1].toLowerCase()))}function s(f){return typeof f=="string"?n.includes(f.toLowerCase()):f.length===0||f?.length===1&&n.includes(f[0].toLowerCase())}function l(f){return typeof f!="string"&&(f=f.filter(k=>!t.includes(k.toLowerCase()))),f==="string"&&r.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&r.includes(f[0].toLowerCase())}}),define(ce[266],le([0,1,49,78,9,4,12,21,115,73,265,122]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=m,i=Ae(i),P=Ae(P);var g;(function(k){k.UnixShellsPath="/etc/shells"})(g||(g={}));let b,u=!0;function m(k,I,O,L,T=process.env,A,M,z,C){return A=A||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},D.$i?p(O,A,T,M,L.getValue(c.TerminalSettingId.UseWslProfiles)!==!1,k&&typeof k=="object"?{...k}:L.getValue(c.TerminalSettingId.ProfilesWindows),typeof I=="string"?I:L.getValue(c.TerminalSettingId.DefaultProfileWindows),C,z):s(A,M,O,k&&typeof k=="object"?{...k}:L.getValue(D.$k?c.TerminalSettingId.ProfilesLinux:c.TerminalSettingId.ProfilesMacOs),typeof I=="string"?I:L.getValue(D.$k?c.TerminalSettingId.DefaultProfileLinux:c.TerminalSettingId.DefaultProfileMacOs),C,z,T)}async function p(k,I,O,L,T,A,M,z,C){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let _=!1;(0,h.$Fs)()>=16299&&(_=!0),await S(z);const se=new Map;if(k){se.set("PowerShell",{source:c.ProfileSource.Pwsh,icon:o.$4j.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:o.$4j.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:c.ProfileSource.GitBash,isAutoDetected:!0}),se.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:o.$4j.terminalCmd,isAutoDetected:!0}),se.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),se.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:o.$4j.terminalBash,isAutoDetected:!0});const ee=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;se.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",ee],requiresPath:process.env.CMDER_ROOT?ee:{path:ee,isUnsafe:!0},isAutoDetected:!0})}l(A,se);const K=await $(se.entries(),M,I,O,L,C);if(k&&T)try{const ee=await n(`${re}\\${_?"wsl":"bash"}.exe`,M);for(const H of ee)(!A||!(H.profileName in A))&&K.push(H)}catch{u&&(L?.trace("WSL is not installed, so could not detect WSL profiles"),u=!1)}return K}async function $(k,I,O,L=process.env,T,A){const M=[];for(const[z,C]of k)M.push(w(z,C,I,O,L,T,A));return(await Promise.all(M)).filter(z=>!!z)}async function w(k,I,O,L,T=process.env,A,M){if(I===null)return;let z,C,B;if("source"in I&&!("path"in I)){const K=b?.get(I.source);if(!K)return;z=K.paths,C=I.args||K.args,I.icon?B=v(I.icon):K.icon&&(B=K.icon)}else z=Array.isArray(I.path)?I.path:[I.path],C=D.$i||Array.isArray(I.args)?I.args:void 0,B=v(I.icon);let re;if(M){const K=z.map(H=>typeof H=="string"?H:H.path),ee=await M(K);re=new Array(z.length);for(let H=0;H<z.length;H++)typeof z[H]=="string"?re[H]=ee[H]:re[H]={path:ee[H],isUnsafe:!0}}else re=z.slice();let _;if(I.requiresPath){let K;if((0,R.$eg)(I.requiresPath)?K=I.requiresPath:(K=I.requiresPath.path,I.requiresPath.isUnsafe&&(_=K)),!await L.existsFile(K))return}const se=await f(k,O,re,L,T,C,I.env,I.overrideName,I.isAutoDetected,_);if(!se){A?.debug("Terminal profile not validated",k,z);return}return se.isAutoDetected=I.isAutoDetected,se.icon=B,se.color=I.color,se}function v(k){return typeof k=="string"?{id:k}:k}async function S(k){if(b&&!k)return;const[I,O]=await Promise.all([r(),k||t()]);b=new Map,b.set(c.ProfileSource.GitBash,{profileName:"Git Bash",paths:I,args:["--login","-i"]}),b.set(c.ProfileSource.Pwsh,{profileName:"PowerShell",paths:O,icon:o.$4j.terminalPowershell})}async function r(){const k=new Set,I=await(0,h.$Gs)("git.exe");if(I){const T=(0,d.dirname)(I);k.add((0,d.resolve)(T,"../.."))}function O(T,A){A&&T.add(A)}O(k,process.env.ProgramW6432),O(k,process.env.ProgramFiles),O(k,process.env["ProgramFiles(X86)"]),O(k,`${process.env.LocalAppData}\\Program`);const L=[];for(const T of k)L.push(`${T}\\Git\\bin\\bash.exe`,`${T}\\Git\\usr\\bin\\bash.exe`,`${T}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function t(){const k=[];for await(const I of(0,y.$um)())k.push(I.exePath);return k}async function n(k,I){const O=[],L=await new Promise((M,z)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,B)=>{if(C)return z("Problem occurred when getting wsl distros");M(B)})});if(!L)return[];const T=new RegExp(/[\r?\n]/),A=L.split(T).filter(M=>M.trim().length>0&&M!=="");for(const M of A){if(M===""||M.startsWith("docker-desktop"))continue;const z=`${M} (WSL)`,C={profileName:z,path:k,args:["-d",`${M}`],isDefault:z===I,icon:a(M),isAutoDetected:!1};O.push(C)}return O}function a(k){return k.includes("Ubuntu")?o.$4j.terminalUbuntu:k.includes("Debian")?o.$4j.terminalDebian:o.$4j.terminalLinux}async function s(k,I,O,L,T,A,M,z){const C=new Map;if(O&&await k.existsFile(g.UnixShellsPath)){const B=(await k.readFile(g.UnixShellsPath)).toString(),re=(A||B.split(`
`)).map(se=>{const K=se.indexOf("#");return K===-1?se:se.substring(0,K)}).filter(se=>se.trim().length>0),_=new Map;for(const se of re){let K=(0,E.$oc)(se),ee=_.get(K)||0;ee++,ee>1&&(K=`${K} (${ee})`),_.set(K,ee),C.set(K,{path:se,isAutoDetected:!0})}}return l(L,C),await $(C.entries(),T,k,z,I,M)}function l(k,I){if(k)for(const[O,L]of Object.entries(k))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?I.delete(O):(L.icon=L.icon||I.get(O)?.icon,I.set(O,L))}async function f(k,I,O,L,T,A,M,z,C,B){if(O.length===0)return Promise.resolve(void 0);const re=O.shift();if(re==="")return f(k,I,O,L,T,A,M,z,C);const _=typeof re!="string"&&re.isUnsafe,se=typeof re=="string"?re:re.path,K={profileName:k,path:se,args:A,env:M,overrideName:z,isAutoDetected:C,isDefault:k===I,isUnsafePath:_,requiresUnsafePath:B};if((0,E.$oc)(se)===se){const H=T.PATH?T.PATH.split(E.$uc):void 0,j=await(0,h.$Gs)(se,void 0,H,void 0,L.existsFile);return j?(K.path=j,K.isFromPath=!0,K):f(k,I,O,L,T,A)}return await L.existsFile((0,E.$ic)(se))?K:f(k,I,O,L,T,A,M,z,C)}}),define(ce[267],le([0,1,3,2,4,44,18,5,231,101,262,73,264,266,117,66]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;var p;(function(w){w[w.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let $=class extends o.$Vc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(v,S,r,t){super(),this.M=v,this.N=S,this.O=r,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$le),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$le),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$le),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$le),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$le),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$le),this.onProcessData=this.D.event,this.F=this.B(new i.$le),this.onProcessReady=this.F.event,this.G=this.B(new i.$le),this.onProcessReplay=this.G.event,this.H=this.B(new i.$le),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$le),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$le),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$le),this.onProcessExit=this.L.event,(0,g.$ws)(),this.B(this.M),this.B((0,o.$Tc)(()=>this.W())),this.j=this.B(new h.$ps(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(i.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(d.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$i)return process.env;try{return await(0,c.$Pm)(this.N,this.O,{_:[]},process.env)}catch(v){return this.O.error("ptyHost was unable to resolve shell environment",v),{}}}U(){const v=this.M.start(),S=v.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(S.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(v.onDidProcessExit(n=>{this.u.fire(n.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${n.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${n.code}, giving up`))}));const t=D.ProxyChannel.toService(S.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(n=>this.D.fire(n))),this.B(t.onProcessReady(n=>this.F.fire(n))),this.B(t.onProcessExit(n=>this.L.fire(n))),this.B(t.onDidChangeProperty(n=>this.J.fire(n))),this.B(t.onProcessReplay(n=>this.G.fire(n))),this.B(t.onProcessOrphanQuestion(n=>this.H.fire(n))),this.B(t.onDidRequestDetach(n=>this.I.fire(n))),this.B(new y.$os(this.P,S.getChannel(d.TerminalIpcChannels.Logger))),this.a=v,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async n=>{n.affectsConfiguration(d.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[v,t]}async createProcess(v,S,r,t,n,a,s,l,f,k,I){const O=setTimeout(()=>this.$(),d.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(v,S,r,t,n,a,s,l,f,k,I);return clearTimeout(O),L}updateTitle(v,S,r){return this.f.updateTitle(v,S,r)}updateIcon(v,S,r,t){return this.f.updateIcon(v,S,r,t)}attachToProcess(v){return this.f.attachToProcess(v)}detachFromProcess(v,S){return this.f.detachFromProcess(v,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(v){return this.f.start(v)}shutdown(v,S){return this.f.shutdown(v,S)}input(v,S){return this.f.input(v,S)}processBinary(v,S){return this.f.processBinary(v,S)}resize(v,S,r){return this.f.resize(v,S,r)}clearBuffer(v){return this.f.clearBuffer(v)}acknowledgeDataEvent(v,S){return this.f.acknowledgeDataEvent(v,S)}setUnicodeVersion(v,S){return this.f.setUnicodeVersion(v,S)}getInitialCwd(v){return this.f.getInitialCwd(v)}getCwd(v){return this.f.getCwd(v)}async getLatency(){const v=new m.$fe,S=await this.f.getLatency();return v.stop(),[{label:"ptyhostservice<->ptyhost",latency:v.elapsed()},...S]}orphanQuestionReply(v){return this.f.orphanQuestionReply(v)}installAutoReply(v,S){return this.f.installAutoReply(v,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(v){return this.f.uninstallAutoReply(v)}getDefaultSystemShell(v){return this.g?.getDefaultSystemShell(v)??(0,u.$ym)(v??E.OS,process.env)}async getProfiles(v,S,r,t=!1){const n=await this.S();return(0,b.$Is)(S,r,t,this.N,n,void 0,this.O,this.bb.bind(this,v))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(v,S){return this.f.getWslPath(v,S)}getRevivedPtyNewId(v,S){return this.f.getRevivedPtyNewId(v,S)}setTerminalLayoutInfo(v){return this.f.setTerminalLayoutInfo(v)}async getTerminalLayoutInfo(v){return this.g?.getTerminalLayoutInfo(v)}async requestDetachInstance(v,S){return this.f.requestDetachInstance(v,S)}async acceptDetachInstanceReply(v,S){return this.f.acceptDetachInstanceReply(v,S)}async freePortKillProcess(v){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(v)}async serializeTerminalState(v){return this.f.serializeTerminalState(v)}async reviveTerminalProcesses(v,S,r){return this.f.reviveTerminalProcesses(v,S,r)}async refreshProperty(v,S){return this.f.refreshProperty(v,S)}async updateProperty(v,S,r){return this.f.updateProperty(v,S,r)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(v){this.ab(),this.s=setTimeout(()=>this.Y(),v?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(v,S){return this.j.createRequest({workspaceId:v,originalText:S})}async acceptPtyHostResolvedVariables(v,S){this.j.acceptReply(v,S)}};e.$Js=$,e.$Js=$=Se([oe(1,R.$$i),oe(2,P.$$j),oe(3,P.$_j)],$)}),define(ce[74],le([0,1,14,3,2,4,18,6,34]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;const c="#FFFFFF",h="#1E1E1E",d="#000000",g="#FFFFFF",b="theme",u="themeBackground",m="windowSplash";var p;(function(w){w.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",w.SYSTEM_COLOR_THEME="window.systemColorTheme"})(p||(p={})),e.$Mdc=(0,P.$Ei)("themeMainService");let $=class extends E.$Vc{constructor(v,S){super(),this.b=v,this.c=S,this.a=this.B(new o.$le),this.onDidChangeColorScheme=this.a.event,D.$k||this.B(this.c.onDidChangeConfiguration(r=>{(r.affectsConfiguration(p.SYSTEM_COLOR_THEME)||r.affectsConfiguration(p.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(o.Event.fromNodeEventEmitter(i.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$k||this.c.getValue(p.DETECT_COLOR_SCHEME))i.nativeTheme.themeSource="system";else switch(this.c.getValue(p.SYSTEM_COLOR_THEME)){case"dark":i.nativeTheme.themeSource="dark";break;case"light":i.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.nativeTheme.themeSource="light";break;case"vs-dark":i.nativeTheme.themeSource="dark";break;default:i.nativeTheme.themeSource="system"}break;default:i.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$i){if(i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$j){if(i.nativeTheme.shouldUseInvertedColorScheme||i.nativeTheme.shouldUseHighContrastColors)return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$k&&i.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?d:g;let S=this.b.getItem(u,null);if(!S)switch(this.g()){case"vs":S=c;break;case"hc-black":S=d;break;case"hc-light":S=g;break;default:S=h}return D.$j&&S.toUpperCase()===h&&(S="#171717"),S}g(){switch(this.b.getItem(b,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(v,S){this.b.setItems([{key:b,data:S.baseTheme},{key:u,data:S.colorInfo.background},{key:m,data:S}]),typeof v=="number"&&this.h(v,S),this.f()}h(v,S){for(const r of i.BrowserWindow.getAllWindows())if(r.id===v){r.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$Ndc=$,e.$Ndc=$=Se([oe(0,y.$MQ),oe(1,R.$$i)],$)}),define(ce[132],le([0,1,3,2,4,7,18,6,5]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=d,e.$zw=b,e.$Aw=u,e.$Cw=m,e.$Ew=p,e.$Fw=$,e.$ww=(0,P.$Ei)("tunnelService"),e.$xw=(0,P.$Ei)("sharedTunnelsService");var c;(function(S){S.Http="http",S.Https="https"})(c||(e.TunnelProtocol=c={}));var h;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(h||(e.TunnelPrivacyId=h={}));function d(S){return!!S.forwardPort}var g;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function b(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(r)return{address:r[1],port:+r[2]}}function u(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const r=S.query.split("&");for(const t of r){const n=t.split("=")[1];if(/^https?:/.exec(n)){const a=b(D.URI.parse(n));if(a)return a}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(S){return e.$Bw.indexOf(S)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(S){return e.$Dw.indexOf(S)>=0}function $(S,r,t,n){if(t===E.OperatingSystem.Windows)return!1;if(t===E.OperatingSystem.Macintosh&&p(r)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(a?.length===4&&parseInt(a[1])>=18)return!1}return S<1024}class w{constructor(r,t,n){this.remoteAddress=r,this.localAddress=t,this.b=n,this.a=new i.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=w;let v=class extends o.$Vc{constructor(r,t){super(),this.r=r,this.s=t,this.a=new i.$le,this.onTunnelOpened=this.a.event,this.b=new i.$le,this.onTunnelClosed=this.b.event,this.c=new i.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const r=this.s.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.g=r,r?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.h=r.elevation,this.m=r.privacyOptions,this.j=r.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const r=[],t=Array.from(this.f.values());for(const n of t){const a=Array.from(n.values());for(const s of a){const l=await s.value;l&&typeof l!="string"&&r.push(l)}}return r}async dispose(){super.dispose();for(const r of this.f.values()){for(const{value:t}of r.values())await t.then(n=>typeof n!="string"?n?.dispose():void 0);r.clear()}this.f.clear()}setEnvironmentTunnel(r,t,n,a,s){this.z(r,t,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:t,localAddress:n,privacy:a,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,t){(p(r)||m(r))&&(r=e.$Bw[0]);const n=this.D(r,t);if(n)return++n.refcount,n.value}openTunnel(r,t,n,a,s,l=!1,f,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${n} on local port ${s}.`);const I=this.g??r;if(!I)return;if(t||(t="localhost"),a||(a=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const O=this.F(I,t,n,a,s,l,f,k);return O?O.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,n),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const T=this.w(L);return(L.tunnelRemoteHost!==t||L.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),f&&L.privacy!==f&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(T),T}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),O)}w(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const t=this.f.get(r.tunnelRemoteHost);if(t){const n=t.get(r.tunnelRemotePort);n&&(n.refcount--,await this.y(r.tunnelRemoteHost,r.tunnelRemotePort,n))}}}}async y(r,t,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${t}.`);const a=n.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(r)&&this.f.get(r).delete(t),a}}async closeTunnel(r,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${t} `);const n=this.f.get(r);if(n&&n.has(t)){const a=n.get(t);a.refcount=0,await this.y(r,t,a)}}z(r,t,n){this.f.has(r)||this.f.set(r,new Map),this.f.get(r).set(t,{refcount:1,value:n})}async C(r,t){const n=this.f.get(r);if(n){const a=n.get(t),s=a?await a.value:void 0;(!s||typeof s=="string")&&n.delete(t),n.size===0&&this.f.delete(r)}}D(r,t){const n=[r];m(r)?(n.push(...e.$Bw),n.push(...e.$Dw)):p(r)&&n.push(...e.$Dw);const a=n.map(s=>this.f.get(s));for(const s of a){const l=s?.get(t);if(l)return l}}canTunnel(r){return!!b(r)}G(r,t,n,a,s,l,f){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${n} on local port ${a}.`);const k=n;this.n.add(k);const I=a===void 0?n:a,O={elevationRequired:s?this.isPortPrivileged(I):!1},L={remoteAddress:{host:t,port:n},localAddressPort:a,privacy:l,public:l?l!==h.Private:void 0,protocol:f},T=r.forwardPort(L,O);return T?(this.z(t,n,T),T.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),T}};e.$Hw=v,e.$Hw=v=Se([oe(0,y.$$j),oe(1,R.$$i)],v)}),define(ce[50],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0X=e.$9X=e.DisablementReason=e.UpdateType=e.StateType=void 0;var o;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.Disabled="disabled",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(o||(e.StateType=o={}));var E;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(E||(e.UpdateType=E={}));var D;(function(R){R[R.NotBuilt=0]="NotBuilt",R[R.DisabledByEnvironment=1]="DisabledByEnvironment",R[R.ManuallyDisabled=2]="ManuallyDisabled",R[R.MissingConfiguration=3]="MissingConfiguration",R[R.InvalidConfiguration=4]="InvalidConfiguration",R[R.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$9X={Uninitialized:{type:o.Uninitialized},Disabled:R=>({type:o.Disabled,reason:R}),Idle:(R,P)=>({type:o.Idle,updateType:R,error:P}),CheckingForUpdates:R=>({type:o.CheckingForUpdates,explicit:R}),AvailableForDownload:R=>({type:o.AvailableForDownload,update:R}),Downloading:{type:o.Downloading},Downloaded:R=>({type:o.Downloaded,update:R}),Updating:R=>({type:o.Updating,update:R}),Ready:R=>({type:o.Ready,update:R})},e.$0X=(0,i.$Ei)("updateService")}),define(ce[268],le([0,1,4,194,54,45]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$oo.as(E.$to.Configuration).registerConfiguration({id:"update",order:15,title:(0,o.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,o.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,o.localize)(2,null),(0,o.localize)(3,null),(0,o.localize)(4,null),(0,o.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:E.ConfigurationScope.APPLICATION,description:(0,o.localize)(6,null),deprecationMessage:(0,o.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,title:(0,o.localize)(8,null),description:(0,o.localize)(9,null),included:i.$i&&!i.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:E.ConfigurationScope.APPLICATION,description:(0,o.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ce[269],le([0,1,3,50]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=e.$Yec=void 0;class E{constructor(P){this.a=P}listen(P,y){switch(y){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${y}`)}call(P,y,c){switch(y){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${y}`)}}e.$Yec=E;class D{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new i.$le,this.onStateChange=this.a.event,this.b=o.$9X.Uninitialized,this.c.listen("onStateChange")(y=>this.state=y),this.c.call("_getInitialState").then(y=>this.state=y)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$Zec=D}),define(ce[42],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,i.$Ei)("IUriIdentityService")}),define(ce[270],le([0,1,42,211,15,19,144,3,2]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let h=class{constructor(g){this.g=g,this.c=new y.$Uc,this.f=2**16;const b=new Map,u=m=>{let p=b.get(m.scheme);return p===void 0&&(p=g.hasProvider(m)&&!this.g.hasCapability(m,E.FileSystemProviderCapabilities.PathCaseSensitive),b.set(m.scheme,p)),p};this.c.add(P.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(m=>{b.delete(m.scheme)})),this.extUri=new D.$7g(u),this.d=new R.$Ms((m,p)=>this.extUri.compare(m,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.$gh)(g));const b=this.d.get(g);return b?b.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((u,m)=>u[1].time<m[1].time?1:u[1].time>m[1].time?-1:0);c._clock=0,this.d.clear();const b=this.f*.5;for(let u=0;u<b;u++)this.d.set(g[u][0],g[u][1].touch())}};e.$Ns=h,e.$Ns=h=Se([oe(0,E.$$k)],h),(0,o.$Ks)(i.$Il,h,o.InstantiationType.Delayed)}),define(ce[133],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZX=void 0,e.$ZX=(0,i.$Ei)("urlService")}),define(ce[271],le([0,1,7]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=e.$7ec=void 0;class o{constructor(P){this.a=P}listen(P,y){throw new Error(`Event not found: ${y}`)}call(P,y,c){switch(y){case"handleURL":return this.a.handleURL(i.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${y}`)}}e.$7ec=o;class E{constructor(P){this.a=P}handleURL(P,y){return this.a.call("handleURL",[P.toJSON(),y])}}e.$8ec=E;class D{constructor(P,y){this.a=P,this.b=y}async routeCall(P,y,c,h){if(y!=="handleURL")throw new Error(`Call not found: ${y}`);if(Array.isArray(c)&&c.length>0){const d=i.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const g=/\bwindowId=(\d+)/.exec(d.query);if(g){const b=g[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${b}"`,d.toString(!0));const u=new RegExp(`window:${b}`),m=P.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),u.test(p.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,y,c,h)}routeEvent(P,y){throw new Error(`Event not found: ${y}`)}}e.$9ec=D}),define(ce[272],le([0,1,8,2,7,28]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2X=e.$1X=void 0;class R extends o.$Vc{constructor(){super(...arguments),this.a=new Set}open(c,h){const d=[...this.a.values()];return(0,i.$Ih)(d.map(g=>()=>g.handleURL(c,h)),void 0,!1).then(g=>g||!1)}registerHandler(c){return this.a.add(c),(0,o.$Tc)(()=>this.a.delete(c))}}e.$1X=R;let P=class extends R{constructor(c){super(),this.b=c}create(c){let{authority:h,path:d,query:g,fragment:b}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return h&&d&&d.indexOf("/")!==0&&(d=`/${d}`),E.URI.from({scheme:this.b.urlProtocol,authority:h,path:d,query:g,fragment:b})}};e.$2X=P,e.$2X=P=Se([oe(0,D.$rk)],P)}),define(ce[273],le([0,1,14,8,3,2,4,7]),function(V,e,i,o,E,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class y extends D.$Vc{constructor(h,d,g,b,u,m){if(super(),this.c=d,this.f=m,this.a=[],this.b=0,h&&(m.trace("ElectronURLListener initialUrisToHandle:",h.map(w=>w.originalUrl)),this.a=h),R.$i){const w=b.isBuilt?[]:[`"${b.appRoot}"`];w.push("--open-url","--"),i.app.setAsDefaultProtocolClient(u.urlProtocol,process.execPath,w)}const p=E.Event.map(E.Event.fromNodeEventEmitter(i.app,"open-url",(w,v)=>({event:w,url:v})),({event:w,url:v})=>(w.preventDefault(),v));this.B(p(w=>{const v=this.g(w);v&&this.c.open(v,{originalUrl:w})})),g.getWindows().filter(w=>w.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(E.Event.once(g.onDidSignalReadyWindow)(()=>this.h())))}g(h){try{return P.URI.parse(h)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const h=[];for(const d of this.a)await this.c.open(d.uri,{originalUrl:d.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),h.push(d));h.length!==0&&(this.a=h,(0,o.$Gh)(()=>this.h(),500,this.q))}}e.$0ec=y}),define(ce[274],le([0,1,3,2,15,61,32]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class P extends o.$Vc{constructor(c,h,d,g,b,u){super(),this.f=c,this.g=h,this.h=d,this.j=g,this.m=b,this.n=u,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$le),this.onDidChangeFile=this.a.event,this.b=D.$Ki.forUris(()=>!(this.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new R.$Cc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,h){return this.g.open(this.t(c),h)}close(c){return this.g.close(c)}read(c,h,d,g,b){return this.g.read(c,h,d,g,b)}write(c,h,d,g,b){return this.g.write(c,h,d,g,b)}watch(c,h){this.b.set(c,c);const d=this.g.watch(this.t(c),h);return(0,o.$Tc)(()=>{this.b.delete(c),d.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,h,d){return this.g.rename(this.t(c),this.t(h),d)}readFile(c,h){return this.g.readFile(this.t(c),h)}readFileStream(c,h,d){return this.g.readFileStream(this.t(c),h,d)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,h,d){return this.g.writeFile(this.t(c),h,d)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,h){return this.g.delete(this.t(c),h)}copy(c,h,d){if((0,E.$cl)(this.g))return this.g.copy(this.t(c),this.t(h),d);throw new Error("copy not supported")}cloneFile(c,h){if((0,E.$dl)(this.g))return this.g.cloneFile(this.t(c),this.t(h));throw new Error("clone not supported")}s(c){const h=[];for(const d of c){if(d.resource.scheme!==this.f)continue;const g=this.u(d.resource);this.b.findSubstr(g)&&h.push({resource:g,type:d.type,cId:d.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Mfc=P}),define(ce[275],le([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0,e.$tfc="utilityProcessWorker"}),define(ce[276],le([0,1,6]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0,e.$$ec=(0,i.$Ei)("webviewManagerService")}),define(ce[277],le([0,1,14,2,13,7]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class R extends o.$Vc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const y=this.b.bind(this);i.protocol.registerFileProtocol(E.Schemas.vscodeWebview,y)}b(y,c){try{const h=D.URI.parse(y.url),d=R.a.get(h.path);if(typeof d=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${d}`,b=E.$Yg.asFileUri(g);return c({path:b.fsPath,headers:{...E.COI.getHeadersFromQuery(y.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$_ec=R}),define(ce[57],le([0,1,4]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$TD=void 0,e.$UD=o,e.$VD=E,e.$WD=D,e.$XD=R,e.$YD=P,e.$ZD=d,e.$1D=g,e.$2D=b,e.$4D=u,e.$5D=m,e.$6D=p,e.$TD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function o($){return typeof $.parentId=="number"}function E($){return!!$.workspaceUri}function D($){return!!$.folderUri}function R($){return!!$.fileUri}function P($){const w=g($),v=$.getValue("window.menuBarVisibility");return v==="default"||w&&v==="compact"||i.$j&&i.$m?"classic":v}var y;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(y||(e.TitleBarSetting=y={}));var c;(function($){$.NATIVE="native",$.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var h;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(h||(e.CustomTitleBarVisibility=h={}));function d($,w){return!0}function g($,w){return w||(w=b($)),w===c.NATIVE}function b($){if(i.$o)return c.CUSTOM;const w=$.getValue("window");if(w){if(i.$j&&w.nativeTabs===!0||i.$j&&w.nativeFullScreen===!1)return c.NATIVE;const r=w.titleBarStyle;if(r===c.NATIVE||r===c.CUSTOM)return r}return i.$k?c.NATIVE:c.CUSTOM}e.$3D=35;function u($){return!(!i.$i||i.$o||g($))}function m($){const w=$.getValue("window");return!w||typeof w.nativeFullScreen!="boolean"||w.nativeTabs?!0:w.nativeFullScreen!==!1}function p($=0){return Math.pow(1.2,$)}}),define(ce[51],le([0,1,14]),function(V,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Cdc=e.$Bdc=e.UnloadReason=e.LoadReason=void 0;var o;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(o||(e.LoadReason=o={}));var E;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(E||(e.UnloadReason=E={}));const D=function(c=P.Normal){return{width:1024,height:768,mode:c}};e.$Bdc=D;const R=function(){const d=i.screen.getPrimaryDisplay().workArea,g=Math.max(d.x+d.width/2-800/2,0),b=Math.max(d.y+d.height/2-600/2,0);return{x:g,y:b,width:800,height:600,mode:P.Normal}};e.$Cdc=R;var P;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(P||(e.WindowMode=P={}));var y;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(y||(e.WindowError=y={}))}),define(ce[278],le([0,1,8,3,2]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class D extends E.$Vc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:y,getActiveWindowId:c}){super(),this.a=this.B(new E.$Uc),o.Event.latch(o.Event.any(P,y))(this.f,this,this.a),this.b=(0,i.$rh)(()=>c()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$ffc=D}),define(ce[30],le([0,1,198,9,61,19,7,6,13]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=c,e.$Pi=h,e.$Si=d,e.$Ti=g,e.$Ui=b,e.$Vi=m,e.$Wi=p,e.$Zi=v,e.$5i=S,e.$6i=r,e.$8i=t,e.$9i=n,e.$0i=a,e.$Ni=(0,P.$Ei)("contextService");function c(s){const l=s;return typeof l?.id=="string"&&R.URI.isUri(l.uri)}function h(s){return typeof s?.id=="string"&&!c(s)&&!g(s)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function d(s,l){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,o.$oc)(s)}:l?e.$Qi:e.$Ri;const f=s;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}function g(s){const l=s;return typeof l?.id=="string"&&R.URI.isUri(l.configPath)}function b(s){const l=s;if(l?.uri)return{id:l.id,uri:R.URI.revive(l.uri)};const f=s;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(s?.id)return{id:s.id}}var u;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(u||(e.WorkbenchState=u={}));function m(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function p(s){const l=s;return!!(l&&typeof l=="object"&&R.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class ${constructor(l,f,k,I,O){this.h=l,this.j=k,this.k=I,this.l=O,this.c=E.$Ki.forUris(this.l,()=>!0),this.folders=f}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=E.$Ki.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=$;class w{constructor(l,f){this.raw=f,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,D.$fh)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=w;function v(s){return new w({uri:s,index:0,name:(0,D.$bh)(s)},{uri:s.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,i.localize)(0,null),extensions:[e.$1i]}],e.$4i="workspace.json";function S(s,l){return D.$9g.isEqualOrParent(s,l.untitledWorkspacesHome)}function r(s){let l;return R.URI.isUri(s)?l=s:l=s.configuration,l?.scheme===y.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$7i}function n(s,l){return!S(s,l)&&!r(s)}function a(s){return(typeof s=="string"?(0,o.$pc)(s):(0,D.$dh)(s))===e.$2i}}),define(ce[58],le([0,1,14,8,46,48,2,77,4,21,172,124,6,5,28,30]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=void 0,e.$Jdc=(0,g.$Ei)("dialogMainService");let p=class{constructor(w,v){this.d=w,this.e=v,this.a=new Map,this.b=new Map,this.c=new o.$Lh}pickFileFolder(w,v){return this.f({...w,pickFolders:!0,pickFiles:!0,title:(0,h.localize)(0,null)},v)}pickFolder(w,v){return this.f({...w,pickFolders:!0,title:(0,h.localize)(1,null)},v)}pickFile(w,v){return this.f({...w,pickFiles:!0,title:(0,h.localize)(2,null)},v)}pickWorkspace(w,v){const S=(0,h.localize)(3,null),r=(0,D.$Yw)((0,h.localize)(4,null)),t=m.$3i;return this.f({...w,pickFiles:!0,title:S,filters:t,buttonLabel:r},v)}async f(w,v){const S={title:w.title,buttonLabel:w.buttonLabel,filters:w.filters,defaultPath:w.defaultPath};(typeof w.pickFiles=="boolean"||typeof w.pickFolders=="boolean")&&(S.properties=void 0,w.pickFiles&&w.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",w.pickFolders?"openDirectory":"openFile","createDirectory"]),y.$j&&S.properties.push("treatPackageAsDirectory");const r=await this.showOpenDialog(S,(v||i.BrowserWindow.getFocusedWindow())??void 0);if(r&&r.filePaths&&r.filePaths.length>0)return r.filePaths}g(w){if(w){let v=this.b.get(w.id);return v||(v=new o.$Lh,this.b.set(w.id,v)),v}else return this.c}showMessageBox(w,v){return this.g(v).queue(async()=>{const{options:S,buttonIndeces:r}=(0,d.$6w)(w,this.e);let t;return v?t=await i.dialog.showMessageBox(v,S):t=await i.dialog.showMessageBox(S),{response:r[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(w,v){const S=this.j(w,v);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(v).queue(async()=>{let r;return v?r=await i.dialog.showSaveDialog(v,w):r=await i.dialog.showSaveDialog(w),r.filePath=this.h(r.filePath),r})}finally{(0,R.$Qc)(S)}}h(w){return w&&y.$j&&(w=(0,P.$lm)(w)),w}i(w){return w.map(v=>this.h(v))}async showOpenDialog(w,v){w.defaultPath&&(await c.Promises.exists(w.defaultPath)||(w.defaultPath=void 0));const S=this.j(w,v);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(v).queue(async()=>{let r;return v?r=await i.dialog.showOpenDialog(v,w):r=await i.dialog.showOpenDialog(w),r.filePaths=this.i(r.filePaths),r})}finally{(0,R.$Qc)(S)}}j(w,v){if(!v)return R.$Vc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",w);let S=this.a.get(v.id);S||(S=new Set,this.a.set(v.id,S));const r=(0,E.$sj)(w);if(!S.has(r))return this.d.trace("[DialogMainService]: new file dialog lock created",w),S.add(r),(0,R.$Tc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",w),S?.delete(r),S?.size===0&&this.a.delete(v.id)})}};e.$Kdc=p,e.$Kdc=p=Se([oe(0,b.$$j),oe(1,u.$rk)],p)}),define(ce[279],le([0,1,3,2,81,30]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class R extends o.$Vc{static{this.a=100}constructor(y,c){super(),this.f=y,this.g=c,this.b=this.B(new i.$le),this.c=new Map,this.h(c.applicationStorage,this.b)}h(y,c){this.B(i.Event.debounce(y.onDidChangeStorage,(h,d)=>(h?h.push(d):h=[d],h),R.a)(h=>{h.length&&c.fire(this.j(h,y))}))}j(y,c){const h=new Map,d=new Set;return y.forEach(g=>{const b=c.get(g.key);typeof b=="string"?h.set(g.key,b):d.add(g.key)}),{changed:Array.from(h.entries()),deleted:Array.from(d.values())}}listen(y,c,h){switch(c){case"onDidChangeStorage":{const d=h.profile?(0,E.$bi)(h.profile):void 0;if(!d)return this.b.event;let g=this.c.get(d.id);return g||(g=this.B(new i.$le),this.h(this.g.profileStorage(d),g),this.c.set(d.id,g)),g.event}}throw new Error(`Event not found: ${c}`)}async call(y,c,h){const d=h.profile?(0,E.$bi)(h.profile):void 0,g=(0,D.$Ui)(h.workspace),b=await this.m(d,g);switch(c){case"getItems":return Array.from(b.items.entries());case"updateItems":{const u=h;if(u.insert)for(const[m,p]of u.insert)b.set(m,p);u.delete?.forEach(m=>b.delete(m));break}case"optimize":return b.optimize();case"isUsed":{const u=h.payload;if(typeof u=="string")return this.g.isUsed(u)}default:throw new Error(`Call not found: ${c}`)}}async m(y,c){let h;c?h=this.g.workspaceStorage(c):y?h=this.g.profileStorage(y):h=this.g.applicationStorage;try{await h.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":y?"profile":"application"} storage due to ${d}`)}return h}}e.$Vec=R}),define(ce[43],le([0,1,46,3,2,19,7,195,38,15,6,5,30,32,42,8,33,26,12]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=S,e.$Ll=r,e.$Ml=t;var v;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function S(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&R.URI.isUri(l.location)&&R.URI.isUri(l.globalStorageHome)&&R.URI.isUri(l.settingsResource)&&R.URI.isUri(l.keybindingsResource)&&R.URI.isUri(l.tasksResource)&&R.URI.isUri(l.snippetsHome)&&R.URI.isUri(l.extensionsResource))}e.$Kl=(0,h.$Ei)("IUserDataProfilesService");function r(s,l){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:l}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:l}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:l}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:l}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:l}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:l}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:l}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:l}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,l,f,k,I,O){return{id:s,name:l,location:f,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:O&&I?.useDefaultFlags?.globalState?O.globalStorageHome:(0,D.$fh)(f,"globalStorage"),settingsResource:O&&I?.useDefaultFlags?.settings?O.settingsResource:(0,D.$fh)(f,"settings.json"),keybindingsResource:O&&I?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,D.$fh)(f,"keybindings.json"),tasksResource:O&&I?.useDefaultFlags?.tasks?O.tasksResource:(0,D.$fh)(f,"tasks.json"),snippetsHome:O&&I?.useDefaultFlags?.snippets?O.snippetsHome:(0,D.$fh)(f,"snippets"),extensionsResource:O&&I?.useDefaultFlags?.extensions?O.extensionsResource:(0,D.$fh)(f,"extensions.json"),cacheHome:(0,D.$fh)(k,s),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let n=class extends E.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,f,k,I){super(),this.t=l,this.u=f,this.w=k,this.y=I,this.f=!0,this.h=this.B(new o.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new o.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new o.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new o.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new b.$Bc,workspaces:new b.$Bc,emptyWindows:new Map},this.profilesHome=(0,D.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),f=[l];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,w.$eg)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}f.push(t((0,D.$ch)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},l))}}catch(O){this.y.error(O)}const k=new b.$Bc,I=new Map;if(f.length)try{const O=this.Q();if(O.workspaces)for(const[L,T]of Object.entries(O.workspaces)){const A=R.URI.parse(L),M=f.find(z=>z.id===T);M&&k.set(A,M)}if(O.emptyWindows)for(const[L,T]of Object.entries(O.emptyWindows)){const A=f.find(M=>M.id===T);A&&I.set(L,A)}}catch(O){this.y.error(O)}this.z={profiles:f,workspaces:k,emptyWindows:I}}return this.z}D(){const l=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const f="Temp",k=new RegExp(`${(0,$.$hf)(f)}\\s(\\d+)`);let I=0;for(const L of this.profiles){const T=k.exec(L.name),A=T?parseInt(T[1]):0;I=A>I?A:I}const O=`${f} ${I+1}`;return this.createProfile((0,i.$sj)((0,p.$1g)()).toString(16),O,{transient:!0},l)}async createNamedProfile(l,f,k){return this.createProfile((0,i.$sj)((0,p.$1g)()).toString(16),l,f,k)}async createProfile(l,f,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(l,f,k);return I&&await this.setProfileForWorkspace(I,O),O}async F(l,f,k){if(!(0,w.$eg)(f)||!f)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(f);return I||(I=(async()=>{try{if(this.profiles.find(A=>A.name===f||A.id===l))throw new Error(`Profile with ${f} name already exists`);const L=t(l,f,(0,D.$fh)(this.profilesHome,l),this.g,k,this.defaultProfile);await this.u.createFolder(L.location);const T=[];return this.j.fire({profile:L,join(A){T.push(A)}}),await m.Promises.settled(T),this.I([L],[],[]),L}finally{this.r.delete(f)}})(),this.r.set(f,I)),I}async updateProfile(l,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);return k=t(k.id,f.name??k.name,k.location,this.g,{shortName:f.shortName??k.shortName,icon:f.icon===null?void 0:f.icon??k.icon,transient:f.transient??k.isTransient,useDefaultFlags:f.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const f=this.profiles.find(I=>I.id===l.id);if(!f)throw new Error(`Profile '${l.name}' does not exist`);const k=[];this.m.fire({profile:f,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])f.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])f.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[f],[]);try{await this.u.del(f.cacheHome,{recursive:!0})}catch(I){(0,c.$pl)(I)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(I)}}async setProfileForWorkspace(l,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===f.id);if(!k)throw new Error(`Profile '${f.name}' does not exist`);this.L(l,k)}unsetWorkspace(l,f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,f)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(f=>f.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,f.resource))).map(f=>this.u.del(f.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(f=>!this.H(f));await Promise.allSettled(l.map(f=>this.removeProfile(f)))}getProfileForWorkspace(l){const f=this.G(l),k=R.URI.isUri(f)?this.C.workspaces.get(f):this.C.emptyWindows.get(f);return k||((0,g.$Oi)(l)?this.s.folders.get(l.uri):(0,g.$Ti)(l)?this.s.workspaces.get(l.configPath):this.s.emptyWindows.get(l.id))}G(l){return(0,g.$Oi)(l)?l.uri:(0,g.$Ti)(l)?l.configPath:l.id}H(l){return!!([...this.C.emptyWindows.values()].some(f=>this.w.extUri.isEqual(f.location,l.location))||[...this.C.workspaces.values()].some(f=>this.w.extUri.isEqual(f.location,l.location))||[...this.s.emptyWindows.values()].some(f=>this.w.extUri.isEqual(f.location,l.location))||[...this.s.workspaces.values()].some(f=>this.w.extUri.isEqual(f.location,l.location))||[...this.s.folders.values()].some(f=>this.w.extUri.isEqual(f.location,l.location)))}I(l,f,k){const I=[...this.profiles,...l],O=[],L=this.s.profiles;this.s.profiles=[];for(let T of I){if(T.isDefault||f.some(M=>T.id===M.id))continue;T=k.find(M=>T.id===M.id)??T;const A=L.find(M=>T.id===M.id);if(T.isTransient)this.s.profiles.push(T);else{if(A){for(const[M,z]of this.s.emptyWindows.entries())if(T.id===z.id){this.L({id:M},T);break}for(const[M,z]of this.s.workspaces.entries())if(T.id===z.id){this.L({id:"",configPath:M},T);break}for(const[M,z]of this.s.folders.entries())if(T.id===z.id){this.L({id:"",uri:M},T);break}}O.push({location:T.location,name:T.name,shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags})}}this.P(O),this.z=void 0,this.J(l,f,k)}J(l,f,k){this.h.fire({added:l,removed:f,updated:k,all:this.profiles})}L(l,f,k){if(k=f?.isTransient?!0:k,k)(0,g.$Oi)(l)?(this.s.folders.delete(l.uri),f&&this.s.folders.set(l.uri,f)):(0,g.$Ti)(l)?(this.s.workspaces.delete(l.configPath),f&&this.s.workspaces.set(l.configPath,f)):(this.s.emptyWindows.delete(l.id),f&&this.s.emptyWindows.set(l.id,f));else{this.L(l,void 0,!0);const I=this.G(l);R.URI.isUri(I)?(this.C.workspaces.delete(I),f&&this.C.workspaces.set(I,f)):(this.C.emptyWindows.delete(I),f&&this.C.emptyWindows.set(I,f)),this.M()}}M(){const l={};for(const[k,I]of this.C.workspaces.entries())l[k.toString()]=I.id;const f={};for(const[k,I]of this.C.emptyWindows.entries())f[k.toString()]=I.id;this.R({workspaces:l,emptyWindows:f}),this.z=void 0}N(l){const f={},k=this.D();if(l.workspaces)for(const[O,L]of Object.entries(l.workspaces)){const T=R.URI.parse(L);f[O]=this.w.extUri.isEqual(T,k.location)?k.id:this.w.extUri.basename(T)}const I={};if(l.emptyWindows)for(const[O,L]of Object.entries(l.emptyWindows)){const T=R.URI.parse(L);I[O]=this.w.extUri.isEqual(T,k.location)?k.id:this.w.extUri.basename(T)}return{workspaces:f,emptyWindows:I}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Nl=n,e.$Nl=n=Se([oe(0,y.$Li),oe(1,c.$$k),oe(2,u.$Il),oe(3,d.$$j)],n);class a extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Ol=a}),define(ce[86],le([0,1,8,17,2,3,32,7,127,130,15,6,5,43,42,12,16,24]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class v extends Error{constructor(a,s){super(a),this.code=s}}e.$Bq=v,e.$Cq=(0,d.$Ei)("IExtensionsProfileScannerService");let S=class extends E.$Vc{constructor(a,s,l,f,k,I){super(),this.j=a,this.m=s,this.n=l,this.r=f,this.s=k,this.t=I,this.b=this.B(new D.$le),this.onAddExtensions=this.b.event,this.c=this.B(new D.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$le),this.onDidRemoveExtensions=this.g.event,this.h=new R.$Bc}scanProfileExtensions(a,s){return this.u(a,void 0,s)}async addExtensionsToProfile(a,s,l){const f=[],k=[];try{return await this.u(s,I=>{const O=[];if(l)O.push(...I);else for(const L of I)a.some(([T])=>(0,c.$Hp)(T.identifier,L.identifier)&&T.manifest.version!==L.version)?f.push(L):O.push(L);for(const[L,T]of a){const A=O.findIndex(z=>(0,c.$Hp)(z.identifier,L.identifier)&&z.version===L.manifest.version),M={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:T};A===-1?(k.push(M),O.push(M)):O.splice(A,1,M)}return k.length&&this.b.fire({extensions:k,profileLocation:s}),f.length&&this.f.fire({extensions:f,profileLocation:s}),O}),k.length&&this.c.fire({extensions:k,profileLocation:s}),f.length&&this.g.fire({extensions:f,profileLocation:s}),k}catch(I){throw k.length&&this.c.fire({extensions:k,error:I,profileLocation:s}),f.length&&this.g.fire({extensions:f,error:I,profileLocation:s}),I}}async updateMetadata(a,s){const l=[];return await this.u(s,f=>{const k=[];for(const I of f){const O=a.find(([L])=>(0,c.$Hp)(L.identifier,I.identifier)&&L.manifest.version===I.version);O&&(I.metadata={...I.metadata,...O[1]},l.push(I)),k.push(I)}return k}),l}async removeExtensionFromProfile(a,s){const l=[];try{await this.u(s,f=>{const k=[];for(const I of f)(0,c.$Hp)(I.identifier,a.identifier)?l.push(I):k.push(I);return l.length&&this.f.fire({extensions:l,profileLocation:s}),k}),l.length&&this.g.fire({extensions:l,profileLocation:s})}catch(f){throw l.length&&this.g.fire({extensions:l,error:f,profileLocation:s}),f}}async u(a,s,l){return this.F(a).queue(async()=>{let f=[],k;try{const I=await this.m.readFile(a);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,h.$pl)(I)!==h.FileOperationResult.FILE_NOT_FOUND)throw I;if(this.r.extUri.isEqual(a,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&l?.bailOutWhenFileNotFound)throw new v((0,p.$$)(I),w.ERROR_PROFILE_NOT_FOUND)}if(k){Array.isArray(k)||this.w(a);let I=!1;for(const O of k){r(O)||this.w(a);let L;if((0,m.$eg)(O.relativeLocation)&&O.relativeLocation)L=this.z(O.relativeLocation);else if((0,m.$eg)(O.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{L=P.URI.revive(O.location);const T=this.y(L);T&&(I=!0,O.relativeLocation=T)}(0,m.$lg)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(I=!0,O.metadata.hasPreReleaseVersion=!0),f.push({identifier:O.identifier,location:L,version:O.version,metadata:O.metadata})}I&&await this.m.writeFile(a,o.$Ne.fromString(JSON.stringify(k)))}if(s){f=s(f);const I=f.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(a,o.$Ne.fromString(JSON.stringify(I)))}return f})}w(a){const s=new v(`Invalid extensions content in ${a.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(a){return this.r.extUri.isEqual(this.r.extUri.dirname(a),this.j)?this.r.extUri.basename(a):void 0}z(a){return this.r.extUri.joinPath(this.j,a)}async D(){return this.C||(this.C=(async()=>{const a=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let l;try{l=(await this.m.readFile(a)).value.toString()}catch(k){if((0,h.$pl)(k)===h.FileOperationResult.FILE_NOT_FOUND)return;throw k}this.t.info("Migrating extensions from old default profile location",a.toString());let f;try{const k=JSON.parse(l);Array.isArray(k)&&k.every(I=>r(I))?f=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(f)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,o.$Ne.fromString(JSON.stringify(f)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",a.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,h.$pl)(k)===h.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",a.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(a)}catch(k){(0,h.$pl)(k)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}try{await this.m.del(s)}catch(k){(0,h.$pl)(k)!==h.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}return f})()),this.C}F(a){let s=this.h.get(a);return s||(s=new i.$Lh,this.h.set(a,s)),s}};e.$Dq=S,e.$Dq=S=Se([oe(1,h.$$k),oe(2,b.$Kl),oe(3,u.$Il),oe(4,$.$0l),oe(5,g.$$j)],S);function r(n){return(0,m.$gg)(n)&&(0,y.$fp)(n.identifier)&&(t(n.location)||(0,m.$eg)(n.location)&&n.location)&&((0,m.$lg)(n.relativeLocation)||(0,m.$eg)(n.relativeLocation))&&n.version&&(0,m.$eg)(n.version)}function t(n){return n?(0,m.$eg)(n.path)&&(0,m.$eg)(n.scheme):!1}});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[134],le([0,1,22,8,35,17,16,40,157,2,13,9,4,19,210,79,12,7,177,38,130,100,209,15,6,5,28,3,81,86,43,42,208]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s,l,f,k,I,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Iq=e.$Hq=e.$Gq=e.Translations=void 0,e.$Jq=re,E=Ae(E),d=Ae(d),g=Ae(g),u=Ae(u),m=et(m);var A;(function(se){function K(ee,H){if(ee===H)return!0;const j=Object.keys(ee),U=new Set;for(const x of Object.keys(H))U.add(x);if(j.length!==U.size)return!1;for(const x of j){if(ee[x]!==H[x])return!1;U.delete(x)}return U.size===0}se.equals=K})(A||(e.Translations=A={})),e.$Gq=(0,a.$Ei)("IExtensionsScannerService");let M=class extends c.$Vc{constructor(K,ee,H,j,U,x,ae,G,he,ne,Z,F){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ee,this.r=H,this.s=j,this.t=U,this.u=x,this.w=ae,this.y=G,this.z=he,this.C=ne,this.D=Z,this.F=F,this.g=this.B(new f.$le),this.onDidChangeCache=this.g.event,this.h=(0,b.$fh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(C,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(r.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(r.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Sp)(this.w,this.y)),this.G}async scanAllExtensions(K,ee,H){const[j,U]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ee)]),x=H?await this.scanExtensionsUnderDevelopment(K,[...j,...U]):[];return this.L(j,U,x,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ee=[];ee.push(this.M(!!K.useCache,K.language)),ee.push(this.N(K.language,!!K.checkControlFile));const[H,j]=await Promise.all(ee);return this.J([...H,...j],r.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ee=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ee);const H=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(ee,!!K.profileLocation,r.ExtensionType.User,!K.includeUninstalled,K.language,!0,H,K.productVersion??this.R()),U=K.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let x;try{x=await U.scanExtensions(j)}catch(ae){if(ae instanceof I.$Bq&&ae.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),x=await U.scanExtensions(j);else throw ae}return x=await this.J(x,r.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",x.length),x}async scanExtensionsUnderDevelopment(K,ee){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===h.Schemas.file).map(async j=>{const U=await this.P(j,!1,r.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(U)).map(ae=>(ae.type=ee.find(G=>(0,S.$Hp)(G.identifier,ae.identifier))?.type??ae.type,this.n.validate(ae,U)))}))).flat();return this.J(H,"development",K,!0)}return[]}async scanExistingExtension(K,ee,H){const j=await this.P(K,!1,ee,!0,H.language,!0,void 0,H.productVersion??this.R()),U=await this.n.scanExtension(j);return!U||!H.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(K,ee,H){const j=await this.P(K,!1,ee,!0,H.language,!0,void 0,H.productVersion??this.R()),U=await this.n.scanOneOrMultipleExtensions(j);return this.J(U,ee,H,!0)}async scanMultipleExtensions(K,ee,H){const j=[];return await Promise.all(K.map(async U=>{const x=await this.scanOneOrMultipleExtensions(U,ee,H);j.push(...x)})),this.J(j,ee,H,!0)}async scanMetadata(K){const ee=(0,b.$fh)(K,"package.json"),H=(await this.w.readFile(ee)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(K,ee){const H=(0,b.$fh)(K,"package.json"),j=(await this.w.readFile(H)).value.toString(),U=JSON.parse(j);ee.isMachineScoped===!1&&delete ee.isMachineScoped,ee.isBuiltin===!1&&delete ee.isBuiltin,U.__metadata={...U.__metadata,...ee},await this.w.writeFile((0,b.$fh)(K,"package.json"),D.$Ne.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof I.$Bq&&K.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(ee=>[ee,ee.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Ne.fromString(JSON.stringify([])))}catch(ee){(0,n.$pl)(ee)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$$)(ee))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,ee,H,j){return H.includeAllVersions||(K=this.L(ee===r.ExtensionType.System?K:void 0,ee===r.ExtensionType.User?K:void 0,ee==="development"?K:void 0,await this.getTargetPlatform(),j)),H.includeInvalid||(K=K.filter(U=>U.isValid)),K.sort((U,x)=>{const ae=d.$oc(U.location.fsPath),G=d.$oc(x.location.fsPath);return ae<G?-1:ae>G?1:0})}L(K,ee,H,j,U){const x=(G,he,ne)=>{if(G.isValid&&!he.isValid)return!1;if(G.isValid===he.isValid){if(U&&u.gt(G.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(u.eq(G.manifest.version,he.manifest.version)){if(G.type===r.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return ne?this.y.warn(`Overwriting user extension ${G.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${he.location.path}.`),!0},ae=new r.$rn;return K?.forEach(G=>{const he=ae.get(G.identifier.id);(!he||x(he,G,!1))&&ae.set(G.identifier.id,G)}),ee?.forEach(G=>{const he=ae.get(G.identifier.id);if(!he&&K&&G.type===r.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!he||x(he,G,!1))&&ae.set(G.identifier.id,G)}),H?.forEach(G=>{const he=ae.get(G.identifier.id);(!he||x(he,G,!0))&&ae.set(G.identifier.id,G),ae.set(G.identifier.id,G)}),[...ae.values()]}async M(K,ee){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,r.ExtensionType.System,!0,ee,!0,void 0,this.R()),U=await(K&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",U.length),U}async N(K,ee){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const j=ee?await this.O():{},U=[],x=$.URI.file(d.$ic(d.$kc(h.$Yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of H){const he=j[G.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":U.push((0,b.$fh)(x,G.name));break;default:U.push($.URI.file(he));break}}const ae=await Promise.all(U.map(async G=>this.n.scanExtension(await this.P(G,!1,r.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ae.length),(0,i.$Ib)(ae)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,ee,H,j,U,x,ae,G){const he=await this.f(U??g.$w),ne=await this.Q(K),Z=ee&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=Z?await this.Q(Z):void 0;return new z(K,ne,Z,F,ee,ae,H,j,x,G.version,G.date,this.C.commit,!this.z.isBuilt,U,he)}async Q(K){try{const ee=await this.w.stat(K);if(typeof ee.mtime=="number")return ee.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Hq=M,e.$Hq=M=Se([oe(4,O.$Kl),oe(5,I.$Cq),oe(6,n.$$k),oe(7,s.$$j),oe(8,v.$Li),oe(9,l.$rk),oe(10,L.$Il),oe(11,a.$Di)],M);class z{constructor(K,ee,H,j,U,x,ae,G,he,ne,Z,F,N,W,q){this.location=K,this.mtime=ee,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=j,this.profile=U,this.profileScanOptions=x,this.type=ae,this.excludeObsolete=G,this.validate=he,this.productVersion=ne,this.productDate=Z,this.productCommit=F,this.devMode=N,this.language=W,this.translations=q}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ee){return(0,b.$$g)(K.location,ee.location)&&K.mtime===ee.mtime&&(0,b.$$g)(K.applicationExtensionslocation,ee.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ee.applicationExtensionslocationMtime&&K.profile===ee.profile&&E.$fo(K.profileScanOptions,ee.profileScanOptions)&&K.type===ee.type&&K.excludeObsolete===ee.excludeObsolete&&K.validate===ee.validate&&K.productVersion===ee.productVersion&&K.productDate===ee.productDate&&K.productCommit===ee.productCommit&&K.devMode===ee.devMode&&K.language===ee.language&&A.equals(K.translations,ee.translations)}}e.$Iq=z;let C=class extends c.$Vc{constructor(K,ee,H,j,U){super(),this.f=K,this.g=ee,this.h=H,this.j=j,this.m=U}async scanExtensions(K){const ee=K.profile?await this.r(K):await this.n(K);let H={};if(K.excludeObsolete&&K.type===r.ExtensionType.User)try{const j=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(j)}catch{}return(0,p.$rg)(H)?ee:ee.filter(j=>!H[S.$Ip.create(j).toString()])}async n(K){const ee=await this.j.resolve(K.location);if(!ee.children?.length)return[];const H=await Promise.all(ee.children.map(async j=>{if(!j.isDirectory||K.type===r.ExtensionType.User&&(0,b.$ch)(j.resource).indexOf(".")===0)return null;const U=new z(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(U)}));return(0,i.$Ib)(H).sort((j,U)=>j.location.path<U.location.path?-1:1)}async r(K){let ee=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){ee=ee.filter(j=>!j.metadata?.isApplicationScoped);const H=await this.s(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);ee.push(...H)}return ee}async s(K,ee,H){const j=await this.g.scanProfileExtensions(K,H.profileScanOptions);if(!j.length)return[];const U=await Promise.all(j.map(async x=>{if(ee(x)){const ae=new z(x.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ae,x.metadata)}return null}));return(0,i.$Ib)(U)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,b.$fh)(K.location,"package.json"))){const ee=await this.scanExtension(K);return ee?[ee]:[]}else return await this.scanExtensions(K)}catch(ee){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,R.$$)(ee)),[]}}async scanExtension(K,ee){try{let H=await this.scanExtensionManifest(K.location);if(H){H.publisher||(H.publisher=r.$ln),ee=ee??H.__metadata,delete H.__metadata;const j=(0,S.$Mp)(H.publisher,H.name),U=ee?.id?{id:j,uuid:ee.id}:{id:j},x=ee?.isSystem?r.ExtensionType.System:K.type,ae=x===r.ExtensionType.System||!!ee?.isBuiltin;H=await this.t(K.location,H,z.createNlsConfiguration(K));const G={type:x,identifier:U,manifest:H,location:K.location,isBuiltin:ae,targetPlatform:ee?.targetPlatform??r.TargetPlatform.UNDEFINED,publisherDisplayName:ee?.publisherDisplayName,metadata:ee,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(H){K.type!==r.ExtensionType.System&&this.m.error(H)}return null}validate(K,ee){let H=!0;const j=(0,t.$Xp)(ee.productVersion,ee.productDate,ee.location,K.manifest,K.isBuiltin);for(const[U,x]of j)U===m.default.Error&&(H=!1,this.m.error(this.z(ee.location,x)));return K.isValid=H,K.validations=j,K}async scanExtensionManifest(K){const ee=(0,b.$fh)(K,"package.json");let H;try{H=(await this.j.readFile(ee)).value.toString()}catch(U){return(0,n.$pl)(U)!==n.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(K,(0,w.localize)(0,null,ee.path,U.message))),null}let j;try{j=JSON.parse(H)}catch{const x=[];(0,P.$Un)(H,x);for(const ae of x)this.m.error(this.z(K,(0,w.localize)(1,null,ee.path,ae.offset,ae.length,(0,y.$Eq)(ae.error))));return null}return(0,P.$4n)(j)!=="object"?(this.m.error(this.z(K,(0,w.localize)(2,null,ee.path))),null):j}async t(K,ee,H){const j=await this.u(K,ee,H);if(j)try{const U=[],x=await this.w(j.default,U);if(U.length>0)return U.forEach(G=>{this.m.error(this.z(K,(0,w.localize)(3,null,j.default?.path,(0,y.$Eq)(G.error))))}),ee;if((0,P.$4n)(j)!=="object")return this.m.error(this.z(K,(0,w.localize)(4,null,j.default?.path))),ee;const ae=j.values||Object.create(null);return(0,T.$Fq)(this.m,ee,ae,x)}catch{}return ee}async u(K,ee,H){const j=(0,b.$fh)(K,"package.nls.json"),U=(he,ne)=>{ne.forEach(Z=>{this.m.error(this.z(K,(0,w.localize)(5,null,he?.path,(0,y.$Eq)(Z.error))))})},x=he=>{this.m.error(this.z(K,(0,w.localize)(6,null,he?.path)))},ae=`${ee.publisher}.${ee.name}`,G=H.translations[ae];if(G)try{const he=$.URI.file(G),ne=(await this.j.readFile(he)).value.toString(),Z=[],F=(0,P.$Un)(ne,Z);return Z.length>0?(U(he,Z),{values:void 0,default:j}):(0,P.$4n)(F)!=="object"?(x(he),{values:void 0,default:j}):{values:F.contents?F.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.j.exists(j))return;let ne;try{ne=await this.y(K,H)}catch{return}if(!ne.localized)return{values:void 0,default:ne.original};try{const Z=(await this.j.readFile(ne.localized)).value.toString(),F=[],N=(0,P.$Un)(Z,F);return F.length>0?(U(ne.localized,F),{values:void 0,default:ne.original}):(0,P.$4n)(N)!=="object"?(x(ne.localized),{values:void 0,default:ne.original}):{values:N,default:ne.original}}catch{return{values:void 0,default:ne.original}}}}async w(K,ee){if(K)try{const H=(await this.j.readFile(K)).value.toString();return(0,P.$Un)(H,ee)}catch{}}y(K,ee){return new Promise((H,j)=>{const U=x=>{const ae=(0,b.$fh)(K,`package.nls.${x}.json`);this.j.exists(ae).then(G=>{G&&H({localized:ae,original:(0,b.$fh)(K,"package.nls.json")});const he=x.lastIndexOf("-");he===-1?H({localized:(0,b.$fh)(K,"package.nls.json"),original:null}):(x=x.substring(0,he),U(x))})};if(ee.devMode||ee.pseudo||!ee.language)return H({localized:(0,b.$fh)(K,"package.nls.json"),original:null});U(ee.language)})}z(K,ee){return`[${K.path}]: ${ee}`}};C=Se([oe(1,I.$Cq),oe(2,L.$Il),oe(3,n.$$k),oe(4,s.$$j)],C);let B=class extends C{constructor(K,ee,H,j,U,x,ae){super(ee,j,U,x,ae),this.G=K,this.H=H,this.D=this.B(new o.$Ch(3e3)),this.F=this.B(new f.$le),this.onDidChangeCache=this.F.event}async scanExtensions(K){const ee=this.M(K),H=await this.I(ee);if(this.C=K,H&&H.input&&z.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",K.type===r.ExtensionType.System?"system":"user",K.location.toString()),this.D.trigger(()=>this.L()),H.result.map(U=>(U.location=$.URI.revive(U.location),U));const j=await super.scanExtensions(K);return await this.J(ee,{input:K,result:j}),j}async I(K){try{const ee=await this.j.readFile(K),H=JSON.parse(ee.value.toString());return{result:H.result,input:(0,k.$bi)(H.input)}}catch(ee){this.m.debug("Error while reading the extension cache file:",K.path,(0,R.$$)(ee))}return null}async J(K,ee){try{await this.j.writeFile(K,D.$Ne.fromString(JSON.stringify(ee)))}catch(H){this.m.debug("Error while writing the extension cache file:",K.path,(0,R.$$)(H))}}async L(){if(!this.C)return;const K=this.M(this.C),ee=await this.I(K);if(!ee)return;const H=ee.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!E.$fo(j,H))try{this.m.info("Invalidating Cache",H,j),await this.j.del(K),this.F.fire()}catch(U){this.m.error(U)}}M(K){const ee=this.N(K);return this.h.extUri.joinPath(ee.cacheHome,K.type===r.ExtensionType.System?r.$kn:r.$jn)}N(K){return K.type===r.ExtensionType.System?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ee=>this.h.extUri.isEqual(K.location,ee.extensionsResource))??this.G:this.H.defaultProfile}};B=Se([oe(2,O.$Kl),oe(3,I.$Cq),oe(4,L.$Il),oe(5,n.$$k),oe(6,s.$$j)],B);function re(se,K){const ee=(0,S.$Kp)(se.manifest.publisher,se.manifest.name);return{id:ee,identifier:new r.$pn(ee),isBuiltin:se.type===r.ExtensionType.System,isUserBuiltin:se.type===r.ExtensionType.User&&se.isBuiltin,isUnderDevelopment:K,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,publisherDisplayName:se.publisherDisplayName,...se.manifest}}class _ extends M{constructor(K,ee,H,j,U,x,ae,G,he,ne,Z,F){super(K,ee,(0,b.$fh)(H,".vscode-oss-dev","extensions","control.json"),j,U,x,ae,G,he,ne,Z,F),this.S=(async()=>{if(g.$z)try{const N=await this.w.readFile($.URI.file(g.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Kq=_}),define(ce[280],le([0,1,5,43,42,24,86,15,38,7]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0;let h=class extends R.$Dq{constructor(g,b,u,m,p,$){super(c.URI.file(g.extensionsPath),b,u,m,p,$)}};e.$TQ=h,e.$TQ=h=Se([oe(0,y.$Mi),oe(1,P.$$k),oe(2,o.$Kl),oe(3,E.$Il),oe(4,D.$0l),oe(5,i.$$j)],h)}),define(ce[281],le([0,1,7,38,86,134,15,6,5,28,42,43]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;let g=class extends D.$Kq{constructor(u,m,p,$,w,v,S,r){super(i.URI.file(w.builtinExtensionsPath),i.URI.file(w.extensionsPath),w.userHome,u.defaultProfile,u,m,p,$,w,v,S,r)}};e.$jfc=g,e.$jfc=g=Se([oe(0,d.$Kl),oe(1,E.$Cq),oe(2,R.$$k),oe(3,y.$$j),oe(4,o.$Mi),oe(5,c.$rk),oe(6,h.$Il),oe(7,P.$Di)],g)}),define(ce[282],le([0,1,14,2,13,9,4,61,7,33,37,38,5,43]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;let u=class extends o.$Vc{constructor(p,$,w){super(),this.c=p,this.f=w,this.a=P.$Ki.forPaths(!R.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=i.session;p.protocol.registerFileProtocol(E.Schemas.vscodeFileResource,($,w)=>this.j($,w)),p.protocol.interceptFileProtocol(E.Schemas.file,($,w)=>this.h($,w)),this.B((0,o.$Tc)(()=>{p.protocol.unregisterProtocol(E.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(E.Schemas.file)}))}addValidFileRoot(p){const $=(0,D.$ic)(p);return this.a.get($)?o.$Vc.None:(this.a.set($,!0),(0,o.$Tc)(()=>this.a.delete($)))}h(p,$){const w=y.URI.parse(p.url);return this.f.error(`Refused to load resource ${w.fsPath} from ${E.Schemas.file}: protocol (original URL: ${p.url})`),$({error:-3})}j(p,$){const w=this.m(p);let v;return this.c.crossOriginIsolated&&((0,D.$oc)(w)==="workbench.html"||(0,D.$oc)(w)==="workbench-dev.html"?v=E.COI.CoopAndCoep:v=E.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(w)?$({path:w,headers:v}):this.b.has((0,D.$pc)(w).toLowerCase())?$({path:w}):(this.f.error(`${E.Schemas.vscodeFileResource}: Refused to load resource ${w} from ${E.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),$({error:-3}))}m(p){const $=y.URI.parse(p.url),w=E.$Yg.uriToFileUri($);return(0,D.$ic)(w.fsPath)}createIPCObjectUrl(){let p;const $=y.URI.from({scheme:"vscode",path:(0,c.$1g)()}),w=$.toString(),v=async()=>p;return h.$$W.handle(w,v),this.f.trace(`IPC Object URL: Registered new channel ${w}.`),{resource:$,update:S=>p=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${w}.`),h.$$W.removeHandler(w)}}}};e.$Dfc=u,e.$Dfc=u=Se([oe(0,d.$Mi),oe(1,b.$Kl),oe(2,g.$$j)],u)}),define(ce[63],le([0,1,8,3,2,70,12,120,6,43]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=b,e.$eq=m,e.$gq=$,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,y.$Ei)("storageService");var h;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var d;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function b(w){const v=w.get(e.$aq);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class u extends E.$Vc{static{this.a=60*1e3}constructor(v={flushInterval:u.a}){super(),this.m=v,this.b=this.B(new o.$oe),this.c=this.B(new o.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new o.$le),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,S,r){return o.Event.filter(this.b.event,t=>t.scope===v&&(S===void 0||t.key===S),r)}n(){this.j.value=(0,i.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,S){const{key:r,external:t}=S;if(r===e.$aq){switch(v){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:r,target:this.J(v)[r],external:t})}w(v){this.f.fire({reason:v})}get(v,S,r){return this.P(S)?.get(v,r)}getBoolean(v,S,r){return this.P(S)?.getBoolean(v,r)}getNumber(v,S,r){return this.P(S)?.getNumber(v,r)}getObject(v,S,r){return this.P(S)?.getObject(v,r)}storeAll(v,S){this.y(()=>{for(const r of v)this.store(r.key,r.value,r.scope,r.target,S)})}store(v,S,r,t,n=!1){if((0,R.$ng)(S)){this.remove(v,r,n);return}this.y(()=>{this.z(v,r,t),this.P(r)?.set(v,S,n)})}remove(v,S,r=!1){this.y(()=>{this.z(v,S,void 0),this.P(S)?.delete(v,r)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,S){const r=[],t=this.J(v);for(const n of Object.keys(t))t[n]===S&&r.push(n);return r}z(v,S,r,t=!1){const n=this.J(S);typeof r=="number"?n[v]!==r&&(n[v]=r,this.P(S)?.set(e.$aq,JSON.stringify(n),t)):typeof n[v]=="number"&&(delete n[v],this.P(S)?.set(e.$aq,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(v){switch(v){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(v){const S=this.P(v);return S?b(S):Object.create(null)}isNew(v){return this.getBoolean(e.$_p,v)===!0}async flush(v=h.NONE){this.f.fire({reason:v});const S=this.P(d.APPLICATION),r=this.P(d.PROFILE),t=this.P(d.WORKSPACE);switch(v){case h.NONE:await i.Promises.settled([S?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await i.Promises.settled([S?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(d.APPLICATION)?.items??new Map,S=this.P(d.PROFILE)?.items??new Map,r=this.P(d.WORKSPACE)?.items??new Map;return $(v,S,r,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,S){return this.w(h.NONE),(0,c.$Jl)(v)?this.R(v,S):this.S(v,S)}M(v,S){return!(v.id===S.id||m(S)&&m(v))}N(v,S,r){this.y(()=>{const t=new Set;for(const[n,a]of v)t.add(n),S.get(n)!==a&&this.u(r,{key:n,external:!0});for(const[n]of S.items)t.has(n)||this.u(r,{key:n,external:!0})})}}e.$dq=u;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class p extends u{constructor(){super(),this.U=this.B(new P.$0p(new P.$$p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$0p(new P.$$p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$0p(new P.$$p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(d.WORKSPACE,v))),this.B(this.W.onDidChangeStorage(v=>this.u(d.PROFILE,v))),this.B(this.U.onDidChangeStorage(v=>this.u(d.APPLICATION,v)))}P(v){switch(v){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(v){switch(v){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$fq=p;async function $(w,v,S,r,t,n){const a=A=>{try{return JSON.parse(A)}catch{return A}},s=new Map,l=new Map;w.forEach((A,M)=>{s.set(M,A),l.set(M,a(A))});const f=new Map,k=new Map;v.forEach((A,M)=>{f.set(M,A),k.set(M,a(A))});const I=new Map,O=new Map;S.forEach((A,M)=>{I.set(M,A),O.set(M,a(A))}),console.group(r!==t?`Storage: Application (path: ${r})`:`Storage: Application & Profile (path: ${r}, default profile)`);const L=[];if(s.forEach((A,M)=>{L.push({key:M,value:A})}),console.table(L),console.groupEnd(),console.log(l),r!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];f.forEach((M,z)=>{A.push({key:z,value:M})}),console.table(A),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${n})`);const T=[];I.forEach((A,M)=>{T.push({key:M,value:A})}),console.table(T),console.groupEnd(),console.log(O)}}),define(ce[283],le([0,1,17,33,63]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=D;async function D(R,P,y){let c=y&&y.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(c)return c;try{const d=(await P.readFile(R.serviceMachineIdResource)).value.toString();c=(0,o.$Zg)(d)?d:null}catch{c=null}if(!c){c=(0,o.$1g)();try{await P.writeFile(R.serviceMachineIdResource,i.$Ne.fromString(c))}catch{}}return y?.store("storage.serviceMachineId",c,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),c}}),define(ce[284],le([0,1,283,24,56]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=D;async function D(R,P,y,c,h,d,g){const b={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${P.nameShort})`};if((0,E.$zp)(P,y)&&(0,E.$Bp)(c)===o.TelemetryLevel.USAGE){const u=await(0,i.$hq)(y,h,d);b["X-Market-User-Id"]=u,b["VSCode-SessionId"]=g.machineId||u}return b}}),define(ce[285],le([0,1,22,8,3,2,9,66,7,21,120,166,5,63,24,30,13]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=e.$0dc=void 0;class $ extends D.$Vc{static{this.a=2e3}get storage(){return this.f}constructor(a,s){super(),this.m=a,this.n=s,this.b=this.B(new E.$le),this.onDidChangeStorage=this.b.event,this.c=this.B(new E.$le),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$0p(new h.$$p,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new o.$2h,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const a=this.B(await this.t());this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(l=>this.b.fire(l))),await this.s(a);const s=a.getBoolean(b.$_p);s===void 0?a.set(b.$_p,!0):s&&a.set(b.$_p,!1)}catch(a){this.m.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===g.LogLevel.Trace?a=>this.m.trace(a):void 0,logError:a=>this.m.error(a)}}s(a){return a.init()}get items(){return this.f.items}get(a,s){return this.f.get(a,s)}set(a,s){return this.f.set(a,s)}delete(a){return this.f.delete(a)}optimize(){return this.f.optimize()}async close(){const a=new P.$fe(!1);await this.w(),a.stop(),a.elapsed()>$.a&&await this.u(a),this.c.fire()}async u(a){if(this.path)try{const s=(0,i.top)(Array.from(this.f.items.entries()).map(([f,k])=>({key:f,length:k.length})),(f,k)=>k.length-f.length,5).map(f=>`${f.key}:${f.length}`).join(", "),l=(await this.n.stat(y.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${l}b, Large Keys: ${s}`)}catch(s){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class w extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,R.$kc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,w.y)}constructor(a,s,l,f){super(l,f),this.z=a,this.C=s}async t(){return new h.$0p(new d.$DX(this.path??d.$DX.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class v extends w{constructor(a,s,l,f){super(a,s,l,f)}}e.$0dc=v;class S extends w{constructor(a,s,l,f){super(s.defaultProfile,a,l,f)}async s(a){await super.s(a),this.G(a)}G(a){a.get(u.$am,void 0)===void 0&&a.set(u.$am,new Date().toUTCString());const l=a.get(u.$_l,void 0),f=new Date().toUTCString();a.set(u.$bm,typeof l>"u"?null:l),a.set(u.$_l,f)}}e.$$dc=S;class r extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,R.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,r.y)}constructor(a,s,l,f,k){super(l,k),this.C=a,this.D=s,this.F=f}async t(){const{storageFilePath:a,wasCreated:s}=await this.H();return new h.$0p(new d.$DX(a,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:s?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:d.$DX.IN_MEMORY_PATH,wasCreated:!0};const a=(0,R.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),s=(0,R.$kc)(a,r.y);return await c.Promises.exists(a)?{storageFilePath:s,wasCreated:!1}:(await c.Promises.mkdir(a,{recursive:!0}),this.I(a),{storageFilePath:s,wasCreated:!0})}async I(a){let s;if((0,m.$Oi)(this.C)?s={folder:this.C.uri.toString()}:(0,m.$Ti)(this.C)&&(s={workspace:this.C.configPath.toString()}),s)try{const l=(0,R.$kc)(a,r.z);await c.Promises.exists(l)||await c.Promises.writeFile(l,JSON.stringify(s,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$_dc=r;class t extends ${get path(){}async t(){return new h.$0p(new h.$$p,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$aec=t}),define(ce[286],le([0,1,3,2,63]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class D extends o.$Vc{constructor(P,y,c){super(),this.b=P,this.c=y,this.f=c;const h=this.B(new o.$Wc);this.a=this.B(new i.$le({onWillAddFirstListener:()=>h.value=this.g(),onDidRemoveLastListener:()=>h.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new o.$Uc;return P.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(y,c)=>(y?y.push(c.key):y=[c.key],y),100)(y=>this.h(y))),P.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(y,c)=>{y||(y=new Map);let h=y.get(c.profile.id);return h||y.set(c.profile.id,h={profile:c.profile,keys:[],storage:c.storage}),h.keys.push(c.key),y},100)(y=>this.j(y))),P}h(P){const y=P.includes(E.$aq)?[this.c.defaultProfile]:[],c=[];if(P=P.filter(h=>h!==E.$aq),P.length){const h=(0,E.$cq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:P.map(d=>({key:d,scope:E.StorageScope.PROFILE,target:h[d]}))})}this.m(y,c)}j(P){const y=[],c=new Map;for(const[h,d]of P.entries()){d.keys.includes(E.$aq)&&y.push(d.profile);const g=d.keys.filter(b=>b!==E.$aq);if(g.length){const b=(0,E.$cq)(d.storage.storage);c.set(h,{profile:d.profile,changes:g.map(u=>({key:u,scope:E.StorageScope.PROFILE,target:b[u]}))})}}this.m(y,[...c.values()])}m(P,y){(P.length||y.length)&&this.a.fire({valueChanges:y,targetChanges:P})}listen(P,y,c){switch(y){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${y}`)}async call(P,y){throw new Error(`Call not found: ${y}`)}}e.$lfc=D}),define(ce[287],le([0,1,7,38,15,5,34,42,43,12,128]),function(V,e,i,o,E,D,R,P,y,c,h){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=void 0;let b=class extends y.$Nl{static{d=this}static{this.a="profileAssociationsMigration"}constructor($,w,v,S,r){super(v,S,w,r),this.U=$,this.W=v}O(){return this.U.getItem(d.b,[]).map(w=>({...w,location:(0,c.$eg)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):i.URI.revive(w.location)}))}Q(){const $=this.U.getItem(d.c,{});return this.U.getItem(d.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$QQ=b,e.$QQ=b=d=Se([oe(0,R.$LQ),oe(1,P.$Il),oe(2,o.$Mi),oe(3,E.$$k),oe(4,D.$$j)],b);let u=g=class extends b{constructor($,w,v,S,r){super($,w,v,S,r),this.$=$}P($){$.length?this.$.setItem(g.b,$.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(g.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(g.c,$):this.$.removeItem(g.c)}Q(){const $="workspaceAndProfileInfo",w=this.$.getItem($,void 0);if(w){this.$.removeItem($);const S=w.reduce((r,{workspace:t,profile:n})=>(r[i.URI.revive(t).toString()]=i.URI.revive(n).toString(),r),{});this.$.setItem(g.c,{workspaces:S})}const v=super.Q();return this.$.getItem(g.a,!1)||(this.R(v),this.$.setItem(g.a,!0)),v}};e.$RQ=u,e.$RQ=u=g=Se([oe(0,R.$MQ),oe(1,P.$Il),oe(2,o.$Mi),oe(3,E.$$k),oe(4,D.$$j)],u);let m=class extends u{constructor($,w,v,S){super(new h.$PQ(h.SaveStrategy.IMMEDIATE,w,S,v),$,w,v,S)}async init(){return await this.$.init(),super.init()}};e.$SQ=m,e.$SQ=m=Se([oe(0,P.$Il),oe(1,o.$Mi),oe(2,E.$$k),oe(3,D.$$j)],m)}),define(ce[59],le([0,1,38,15,6,5,42,43,287,34]),function(V,e,i,o,E,D,R,P,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0,e.$Rdc=(0,E.$Fi)(P.$Kl);let h=class extends y.$RQ{constructor(g,b,u,m,p){super(g,b,u,m,p)}getAssociatedEmptyWindows(){const g=[];for(const b of this.C.emptyWindows.keys())g.push({id:b});return g}};e.$Sdc=h,e.$Sdc=h=Se([oe(0,c.$MQ),oe(1,R.$Il),oe(2,i.$Mi),oe(3,o.$$k),oe(4,D.$$j)],h)}),define(ce[135],le([0,1,19,7,30]),function(V,e,i,o,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=D,e.$Udc=R,e.$Vdc=P;async function D(y,c,h){for(const g of y){const b=g.openedWorkspace;if((0,E.$Ti)(b)){const u=await h(b);if(u){if(u.folders.some(m=>i.$9g.isEqualOrParent(c,m.uri)))return g}else if(i.$9g.isEqualOrParent(c,b.configPath))return g}}const d=y.filter(g=>(0,E.$Oi)(g.openedWorkspace)&&i.$9g.isEqualOrParent(c,g.openedWorkspace.uri));if(d.length)return d.sort((g,b)=>-(g.openedWorkspace.uri.path.length-b.openedWorkspace.uri.path.length))[0]}function R(y,c){for(const h of y)if((0,E.$Ti)(h.openedWorkspace)&&i.$9g.isEqual(h.openedWorkspace.configPath,c)||(0,E.$Oi)(h.openedWorkspace)&&i.$9g.isEqual(h.openedWorkspace.uri,c))return h}function P(y,c){const h=d=>c.some(g=>i.$9g.isEqual(o.URI.file(g),o.URI.file(d)));for(const d of y)if(d.config?.extensionDevelopmentPath?.some(g=>h(g)))return d}}),define(ce[103],le([0,1,31,40,108,48,13,9,4,19,7,6,72,30]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gb=void 0,e.$7gb=u,e.$8gb=m,e.$9gb=p,e.$0gb=$,e.$$gb=S,e.$_gb=t,e.$ahb=n,e.$bhb=k,e.$chb=I,o=Ae(o),E=Ae(E),e.$6gb=(0,d.$Ei)("workspacesService");function u(O){return O.hasOwnProperty("workspace")}function m(O){return O.hasOwnProperty("folderUri")}function p(O){return O.hasOwnProperty("fileUri")}function $(O){return w(O)||v(O)}function w(O){const L=O;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function v(O){const L=O;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(O,L,T,A,M){if(O.scheme!==A.scheme)return{name:T,uri:O.toString(!0)};let z=L?void 0:M.relativePath(A,O);if(z!==void 0)z.length===0?z=".":y.$i&&(z=r(z));else if(O.scheme===R.Schemas.file)z=O.fsPath,y.$i&&(z=r(z));else if(M.isEqualAuthority(O.authority,A.authority))z=O.path;else return{name:T,uri:O.toString(!0)};return{name:T,path:z}}function r(O){return O=(0,D.$Sw)(O),(0,i.$Ag)(O)||(O=(0,i.$xg)(O)),O}function t(O,L,T){const A=[],M=new Set,z=T.dirname(L);for(const C of O){let B;if(w(C))C.path&&(B=T.resolvePath(z,C.path));else if(v(C))try{B=h.URI.parse(C.uri),B.path[0]!==P.$hc.sep&&(B=B.with({path:P.$hc.sep+B.path}))}catch(re){console.warn(re)}if(B){const re=T.getComparisonKey(B);if(!M.has(re)){M.add(re);const _=C.name||T.basenameOrAuthority(B);A.push(new b.$Yi({uri:B,name:_,index:A.length},C))}}}return A}function n(O,L,T,A,M){const z=a(L,O),C=M.dirname(L),B=M.dirname(A),re=[];for(const ee of z.folders){const H=w(ee)?M.resolvePath(C,ee.path):h.URI.parse(ee.uri);let j;T?j=!1:j=!w(ee)||(0,P.$jc)(ee.path),re.push(S(H,j,ee.name,B,M))}const _={insertSpaces:!1,tabSize:4,eol:y.$k||y.$j?`
`:`\r
`},se=E.$0n(O,["folders"],re,_);let K=E.$ao(O,se);return(0,c.$kh)(z.remoteAuthority,(0,g.$fn)(A))&&(K=E.$ao(K,E.$9n(K,["remoteAuthority"],_))),K}function a(O,L){const T=o.$Un(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(A=>$(A));else throw new Error(`${O} looks like an invalid workspace file.`);return T}function s(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function l(O){return typeof O.folderUri=="string"}function f(O){return typeof O.fileUri=="string"}function k(O,L){const T={workspaces:[],files:[]};if(O){const A=function(z,C){for(let B=0;B<z.length;B++)try{C(z[B],B)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(z[B])}: ${re.toString()}. Skip entry.`)}},M=O;Array.isArray(M.entries)&&A(M.entries,z=>{const C=z.label,B=z.remoteAuthority;s(z)?T.workspaces.push({label:C,remoteAuthority:B,workspace:{id:z.workspace.id,configPath:h.URI.parse(z.workspace.configPath)}}):l(z)?T.workspaces.push({label:C,remoteAuthority:B,folderUri:h.URI.parse(z.folderUri)}):f(z)&&T.files.push({label:C,remoteAuthority:B,fileUri:h.URI.parse(z.fileUri)})})}return T}function I(O){const L={entries:[]};for(const T of O.workspaces)m(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of O.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}}),define(ce[104],le([0,1,91,13,4,19]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0,e.$Xdc=R,e.$Ydc=P,e.$Zdc=y,e.$Wdc=128/4;function R(c){function h(){let d=c.scheme===o.Schemas.file?(0,D.$6g)(c):c.toString();return E.$k||(d=d.toLowerCase()),(0,i.createHash)("md5").update(d).digest("hex")}return{id:h(),configPath:c}}function P(c,h){function d(){if(c.scheme!==o.Schemas.file)return(0,i.createHash)("md5").update(c.toString()).digest("hex");if(!h)return;let b;return E.$k?b=h.ino:E.$j?b=h.birthtime.getTime():E.$i&&(typeof h.birthtimeMs=="number"?b=Math.floor(h.birthtimeMs):b=h.birthtime.getTime()),(0,i.createHash)("md5").update(c.fsPath).update(b?String(b):"").digest("hex")}const g=d();if(typeof g=="string")return{id:g,uri:c}}function y(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ce[105],le([0,1,91,92,27,288,17,16,3,2,9,4,33,44,118]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$vi=e.$ui=e.$ti=void 0,e.$wi=s,e.$xi=l,e.$zi=I,e.$Ai=O;const m=3e4;class p{traceSocketEvent(T,A){u.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,T,A)}constructor(T,A=""){this.f=!0,this.debugLabel=A,this.socket=T,this.traceSocketEvent(u.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=z=>{if(this.traceSocketEvent(u.SocketDiagnosticsEventType.Error,{code:z?.code,message:z?.message}),z){if(z.code==="EPIPE")return;(0,P.$2)(z)}},this.socket.on("error",this.a);let M;this.b=z=>{this.traceSocketEvent(u.SocketDiagnosticsEventType.Close,{hadError:z}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(u.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>T.destroy(),m)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(T){const A=M=>{this.traceSocketEvent(u.SocketDiagnosticsEventType.Read,M),T(R.$Ne.wrap(M))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(T){const A=M=>{T({type:u.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(T){const A=()=>{T()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(T){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(u.SocketDiagnosticsEventType.Write,T),this.socket.write(T.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,P.$2)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,P.$2)(A)}}end(){this.traceSocketEvent(u.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(u.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((T,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(u.SocketDiagnosticsEventType.NodeDrainEnd),T();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(u.SocketDiagnosticsEventType.NodeDrainEnd),T()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ti=p;var $;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var w;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(w||(w={}));class v extends c.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(T,A){this.socket.traceSocketEvent(T,A)}constructor(T,A,M,z){super(),this.f=this.B(new y.$le),this.g=this.B(new y.$le),this.h=!1,this.j={state:w.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=T,this.traceSocketEvent(u.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:M?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new S(this,A,M,z,this.f,(C,B)=>this.m(C,B))),this.B(this.a.onError(C=>{console.error(C),(0,P.$2)(C),this.g.fire({type:u.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:C})})),this.b=new u.$oi,this.B(this.socket.onData(C=>this.n(C))),this.B(this.socket.onClose(async C=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(C)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(T){return this.f.event(T)}onClose(T){return this.g.event(T)}onEnd(T){return this.socket.onEnd(T)}write(T){let A=0;for(;A<T.byteLength;)this.a.writeMessage(T.slice(A,Math.min(A+$.MaxWebSocketMessageLength,T.byteLength)),{compressed:!0,opcode:2}),A+=$.MaxWebSocketMessageLength}m(T,{compressed:A,opcode:M}){if(this.h)return;this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,T);let z=$.MinHeaderByteSize;T.byteLength<126?z+=0:T.byteLength<2**16?z+=2:z+=8;const C=R.$Ne.alloc(z),B=A?64:0,re=M&15;if(C.writeUInt8(128|B|re,0),T.byteLength<126)C.writeUInt8(T.byteLength,1);else if(T.byteLength<2**16){C.writeUInt8(126,1);let _=1;C.writeUInt8(T.byteLength>>>8&255,++_),C.writeUInt8(T.byteLength>>>0&255,++_)}else{C.writeUInt8(127,1);let _=1;C.writeUInt8(0,++_),C.writeUInt8(0,++_),C.writeUInt8(0,++_),C.writeUInt8(0,++_),C.writeUInt8(T.byteLength>>>24&255,++_),C.writeUInt8(T.byteLength>>>16&255,++_),C.writeUInt8(T.byteLength>>>8&255,++_),C.writeUInt8(T.byteLength>>>0&255,++_)}this.socket.write(R.$Ne.concat([C,T]))}end(){this.h=!0,this.socket.end()}n(T){if(T.byteLength!==0){for(this.b.acceptChunk(T);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const A=this.b.peek(this.j.readLen),M=A.readUInt8(0),z=(M&128)>>>7,C=(M&64)>>>6,B=M&15,re=A.readUInt8(1),_=(re&128)>>>7,se=re&127;this.j.state=w.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(_?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!C),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=B,this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const A=this.b.read(this.j.readLen),M=A.readUInt8(1),z=(M&128)>>>7;let C=M&127,B=1;C===126?C=A.readUInt8(++B)*2**8+A.readUInt8(++B):C===127&&(C=A.readUInt8(++B)*0+A.readUInt8(++B)*0+A.readUInt8(++B)*0+A.readUInt8(++B)*0+A.readUInt8(++B)*2**24+A.readUInt8(++B)*2**16+A.readUInt8(++B)*2**8+A.readUInt8(++B));let re=0;z&&(re=A.readUInt8(++B)*2**24+A.readUInt8(++B)*2**16+A.readUInt8(++B)*2**8+A.readUInt8(++B)),this.j.state=w.ReadBody,this.j.readLen=C,this.j.mask=re,this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const A=this.b.read(this.j.readLen);this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,A),n(A,this.j.mask),this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,A),this.j.state=w.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(u.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ui=v;class S extends c.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Ne.alloc(0)}constructor(T,A,M,z,C,B){super(),this.n=T,this.r=C,this.s=B,this.a=this.B(new y.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new r(this.n,z,M,{windowBits:15})),this.f=this.B(new t(this.n,{windowBits:15})),this.B(this.b.onError(re=>this.a.fire(re))),this.B(this.f.onError(re=>this.a.fire(re)))):(this.b=null,this.f=null)}writeMessage(T,A){this.g.push({data:T,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:T,options:A}=this.g.shift();if(this.f&&A.compressed){const M=await this.w(this.f,T);this.s(M,A)}else this.s(T,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(T,A){return new Promise((M,z)=>{T.write(A),T.flush(C=>M(C))})}acceptFrame(T,A,M){this.h.push({data:T,isCompressed:A,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const T=this.h.shift();if(this.b&&T.isCompressed){const A=await this.C(this.b,T.data,T.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(T.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(T,A,M){return new Promise((z,C)=>{T.write(A),M&&T.write(R.$Ne.fromByteArray([0,0,255,255])),T.flush(B=>z(B))})}}class r extends c.$Vc{get recordedInflateBytes(){return this.j?R.$Ne.concat(this.f):R.$Ne.alloc(0)}constructor(T,A,M,z){super(),this.h=T,this.j=A,this.a=this.B(new y.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(z),this.b.on("error",C=>{this.h.traceSocketEvent(u.SocketDiagnosticsEventType.zlibInflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.h.traceSocketEvent(u.SocketDiagnosticsEventType.zlibInflateData,C),this.g.push(R.$Ne.wrap(C))}),M&&(this.h.traceSocketEvent(u.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(u.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(T){this.j&&this.f.push(T.clone()),this.h.traceSocketEvent(u.SocketDiagnosticsEventType.zlibInflateWrite,T),this.b.write(T.buffer)}flush(T){this.b.flush(()=>{this.h.traceSocketEvent(u.SocketDiagnosticsEventType.zlibInflateFlushFired);const A=R.$Ne.concat(this.g);this.g.length=0,T(A)})}}class t extends c.$Vc{constructor(T,A){super(),this.g=T,this.a=this.B(new y.$le),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(u.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(u.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(R.$Ne.wrap(M))})}write(T){this.g.traceSocketEvent(u.SocketDiagnosticsEventType.zlibDeflateWrite,T.buffer),this.b.write(T.buffer)}flush(T){this.b.flush(2,()=>{this.g.traceSocketEvent(u.SocketDiagnosticsEventType.zlibDeflateFlushFired);let A=R.$Ne.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),T(A)})}}function n(L,T){if(T===0)return;const A=L.byteLength>>>2;for(let _=0;_<A;_++){const se=L.readUInt32BE(_*4);L.writeUInt32BE(se^T,_*4)}const M=A*4,z=L.byteLength-M,C=T>>>24&255,B=T>>>16&255,re=T>>>8&255;z>=1&&L.writeUInt8(L.readUInt8(M)^C,M),z>=2&&L.writeUInt8(L.readUInt8(M+1)^B,M+1),z>=3&&L.writeUInt8(L.readUInt8(M+2)^re,M+2)}e.$vi=process.env.XDG_RUNTIME_DIR;const a={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function s(){const L=(0,g.$1g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const T=process.platform!=="darwin"&&e.$vi?e.$vi:(0,E.tmpdir)(),A=(0,h.$kc)(T,`vscode-ipc-${L}.sock`);return f(A),A}function l(L,T,A){const z=(0,i.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${z}-${A}-${T}-sock`;const C=A.substr(0,4),B=T.substr(0,6);let re;return process.platform!=="darwin"&&e.$vi&&!process.env.VSCODE_PORTABLE?re=(0,h.$kc)(e.$vi,`vscode-${z}-${C}-${B}.sock`):re=(0,h.$kc)(L,`${C}-${B}.sock`),f(re),re}function f(L){const T=a[d.$u];typeof T=="number"&&L.length>=T&&console.warn(`WARNING: IPC handle "${L}" is longer than ${T} chars, try a shorter --user-data-dir`)}class k extends b.$ii{static b(T){const A=y.Event.fromNodeEventEmitter(T,"connection");return y.Event.map(A,M=>({protocol:new u.$pi(new p(M,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(M,"close"))}))}constructor(T){super(k.b(T)),this.d=T}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$yi=k;function I(L){return new Promise((T,A)=>{const M=(0,o.createServer)();M.on("error",A),M.listen(L,()=>{M.removeListener("error",A),T(new k(M))})})}function O(L,T){return new Promise((A,M)=>{const z=(0,o.createConnection)(L,()=>{z.removeListener("error",M),A(u.$qi.fromSocket(new p(z,`ipc-client${T}`),T))});z.once("error",M)})}}),define(ce[25],le([0,1,52,9,4,105,38,95,6]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=void 0,e.$Ddc=(0,y.$Fi)(R.$Li);class c extends P.$7m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,o.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,o.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$xi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,o.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(E.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const g=d.slice(0,-17);if(this.d[g])continue;process.env[g]&&(this.d[g]=process.env[g]),process.env[d]?process.env[g]=process.env[d]:delete process.env[g]}}}restoreSnapExportedVariables(){if(E.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$Edc=c,Se([i.$9h],c.prototype,"cachedLanguagesPath",null),Se([i.$9h],c.prototype,"backupHome",null),Se([i.$9h],c.prototype,"mainIPCHandle",null),Se([i.$9h],c.prototype,"mainLockfile",null),Se([i.$9h],c.prototype,"disableUpdates",null),Se([i.$9h],c.prototype,"crossOriginIsolated",null),Se([i.$9h],c.prototype,"codeCachePath",null),Se([i.$9h],c.prototype,"useCodeCache",null)}),define(ce[289],le([0,1,91,31,13,9,4,19,21,202,18,25,34,15,5,201,30,104]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;let v=class{static{w=this}static{this.a="backupWorkspaces"}constructor(r,t,n,a){this.j=r,this.k=t,this.l=n,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$9g,this.i={isEqual:(s,l)=>(0,o.$Cg)(s,l,!R.$k)}}async initialize(){const r=this.m.getItem(w.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(r.emptyWindows),this.d=await this.u((0,c.$Gdc)(r)),this.e=await this.v((0,c.$Hdc)(r)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==b.$xl.OFF}q(){return this.s()===b.$xl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||b.$xl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(r,t){this.d.some(a=>r.workspace.id===a.workspace.id)||(this.d.push(r),this.C());const n=(0,D.$kc)(this.c,r.workspace.id);return t?this.t(n,t).then(()=>n):n}async t(r,t){if(await y.Promises.exists(r)&&await this.z(r),await y.Promises.exists(t))try{await y.Promises.rename(t,r,!1)}catch(n){this.l.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(r){return this.e.some(t=>this.h.isEqual(r.folderUri,t.folderUri))||(this.e.push(r),this.C()),(0,D.$kc)(this.c,this.D(r))}registerEmptyWindowBackup(r){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,r.backupFolder))||(this.g.push(r),this.C()),(0,D.$kc)(this.c,r.backupFolder)}async u(r){if(!Array.isArray(r))return[];const t=new Set,n=[];for(const a of r){const s=a.workspace;if(!(0,p.$Ti)(s))return[];if(!t.has(s.id)){t.add(s.id);const l=(0,D.$kc)(this.c,s.id);await this.B(l)?s.configPath.scheme!==E.Schemas.file||await y.Promises.exists(s.configPath.fsPath)?n.push(a):await this.z(l):await this.x(l)}}return n}async v(r){if(!Array.isArray(r))return[];const t=[],n=new Set;for(const a of r){const s=a.folderUri,l=this.h.getComparisonKey(s);if(!n.has(l)){n.add(l);const f=(0,D.$kc)(this.c,this.D(a));await this.B(f)?s.scheme!==E.Schemas.file||await y.Promises.exists(s.fsPath)?t.push(a):await this.z(f):await this.x(f)}}return t}async w(r){if(!Array.isArray(r))return[];const t=[],n=new Set;for(const a of r){const s=a.backupFolder;if(typeof s!="string")return[];if(!n.has(s)){n.add(s);const l=(0,D.$kc)(this.c,s);await this.B(l)?t.push(a):await this.x(l)}}return t}async x(r){try{await y.Promises.rm(r,y.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let r=(0,$.$Zdc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,r.id));)r=(0,$.$Zdc)();return{backupFolder:r.id}}async z(r){const t=this.y(),n=(0,D.$kc)(this.c,t.backupFolder);try{await y.Promises.rename(r,n,!1)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const r=[];for(const t of this.d)await this.A(t)&&r.push(t);for(const t of this.e)await this.A(t)&&r.push(t);return r}A(r){let t;return(0,c.$Fdc)(r)?t=(0,D.$kc)(this.c,r.backupFolder):(0,m.$4gb)(r)?t=(0,D.$kc)(this.c,this.D(r)):t=(0,D.$kc)(this.c,r.workspace.id),this.B(t)}async B(r){try{const t=await y.Promises.readdir(r);for(const n of t)try{if((await y.Promises.readdir((0,D.$kc)(r,n))).length>0)return!0}catch{}}catch{}return!1}C(){const r={workspaces:this.d.map(({workspace:t,remoteAuthority:n})=>{const a={id:t.id,configURIPath:t.configPath.toString()};return n&&(a.remoteAuthority=n),a}),folders:this.e.map(({folderUri:t,remoteAuthority:n})=>{const a={folderUri:t.toString()};return n&&(a.remoteAuthority=n),a}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:n})=>{const a={backupFolder:t};return n&&(a.remoteAuthority=n),a})};this.m.setItem(w.a,r)}D(r){const t=r.folderUri;let n;return t.scheme===E.Schemas.file?n=R.$k?t.fsPath:t.fsPath.toLowerCase():n=t.toString().toLowerCase(),(0,i.createHash)("md5").update(n).digest("hex")}};e.$gec=v,e.$gec=v=w=Se([oe(0,d.$Ddc),oe(1,h.$$i),oe(2,u.$$j),oe(3,g.$MQ)],v)}),define(ce[20],le([0,1,14,37,8,3,2,4,36,12,6,5,34,51,25]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.LifecycleMainPhase=e.ShutdownReason=e.$8dc=void 0,e.$8dc=(0,h.$Ei)("lifecycleMainService");var p;(function(v){v[v.QUIT=1]="QUIT",v[v.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var $;(function(v){v[v.Starting=1]="Starting",v[v.Ready=2]="Ready",v[v.AfterWindowOpen=3]="AfterWindowOpen",v[v.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let w=class extends R.$Vc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,r,t){super(),this.F=S,this.G=r,this.H=t,this.c=this.B(new D.$le),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$le),this.onWillShutdown=this.f.event,this.g=this.B(new D.$le),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$le),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=$.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when($.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(p.QUIT))};i.app.addListener("before-quit",S);const r=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&i.app.quit()};i.app.addListener("window-all-closed",r),i.app.once("will-quit",t=>{this.S("Lifecycle#app.on(will-quit) - begin"),t.preventDefault(),this.L(p.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.app.removeListener("before-quit",S),i.app.removeListener("window-all-closed",r),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.app.quit()})})}L(S){if(this.y)return this.y;const r=this.F;this.S("Lifecycle#onWillShutdown.fire()");const t=[];return this.f.fire({reason:S,join(n,a){r.trace(`Lifecycle#onWillShutdown - begin '${n}'`),t.push(a.finally(()=>{r.trace(`Lifecycle#onWillShutdown - end '${n}'`)}))}}),this.y=(async()=>{try{await E.Promises.settled(t)}catch(n){this.F.error(n)}try{await this.G.close()}catch(n){this.F.error(n)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const r=this.C.get(this.n);r&&(r.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let r=this.C.get(S);r||(r=new E.$Dh,this.C.set(S,r)),await r.wait()}registerWindow(S){const r=new R.$Uc;this.t++,r.add(S.onWillLoad(n=>this.g.fire({window:S,workspace:n.workspace,reason:n.reason})));const t=(0,c.$pg)(S.win);r.add(D.Event.fromNodeEventEmitter(t,"close")(n=>{const a=S.id;if(this.r.has(a)){this.r.delete(a);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),n.preventDefault(),this.unload(S,b.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(a);return}this.r.add(a),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this.h.fire(S),S.close()})})),r.add(D.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,r.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(p.QUIT)}))}registerAuxWindow(S){const r=(0,c.$pg)(S.win),t=new R.$Uc;t.add(D.Event.fromNodeEventEmitter(r,"close")(n=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),n.preventDefault())})),t.add(D.Event.fromNodeEventEmitter(r,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),t.dispose()}))}async reload(S,r){await this.unload(S,b.UnloadReason.RELOAD)||S.reload(r)}unload(S,r){const t=this.z.get(S.id);if(t)return t;const n=this.M(S,r).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,n),n}async M(S,r){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const t=this.j?b.UnloadReason.QUIT:r,n=await this.P(S,t);return n?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(n)):(await this.Q(S,t),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,r){return new Promise(t=>{const n=this.s++,a=`vscode:ok${n}`,s=`vscode:cancel${n}`;o.$$W.once(a,()=>{t(!1)}),o.$$W.once(s,()=>{t(!0)}),S.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:s,reason:r})})}Q(S,r){return new Promise(t=>{const a=`vscode:reply${this.s++}`;o.$$W.once(a,()=>t()),S.send("vscode:onWillUnload",{replyChannel:a,reason:r})})}quit(S){return this.R(S).then(r=>{if(!r&&S)try{if(P.$i){const t=(0,y.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.F.error(t)}return r})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(m.b,!0),this.u=new Promise(r=>{this.w=r,this.S("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const r=process.argv.slice(1);if(S?.addArgs&&r.push(...S.addArgs),S?.removeArgs)for(const a of S.removeArgs){const s=r.indexOf(a);s>=0&&r.splice(s,1)}const t=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:r}))};i.app.once("quit",t),await this.quit(!0)&&i.app.removeListener("quit",t)}async kill(S){this.S("Lifecycle#kill()"),await this.L(p.KILL),await Promise.race([(0,E.$Fh)(1e3),(async()=>{for(const r of i.BrowserWindow.getAllWindows())if(r&&!r.isDestroyed()){let t;r.webContents&&!r.webContents.isDestroyed()?t=new Promise(n=>r.once("closed",n)):t=Promise.resolve(),r.destroy(),await t}})()]),i.app.exit(S)}};e.$9dc=w,e.$9dc=w=m=Se([oe(0,d.$$j),oe(1,g.$MQ),oe(2,u.$Ddc)],w)}),define(ce[290],le([0,1,4,3,2,6,20]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=void 0,i=Ae(i),e.$Dec=(0,D.$Ei)("keyboardLayoutMainService");let P=class extends E.$Vc{constructor(h){super(),this.a=this.B(new o.$le),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,h.when(R.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const h=await new Promise((d,g)=>{V(["native-keymap"],d,g)}).then(Ae);this.c=y(h),i.$t||h.onDidChangeKeyboardLayout(()=>{this.c=y(h),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Eec=P,e.$Eec=P=Se([oe(0,R.$8dc)],P);function y(c){const h=c.getKeyMap(),d=c.getCurrentKeyboardLayout();return{keyboardMapping:h,keyboardLayoutInfo:d}}}),define(ce[291],le([0,1,251,8,17,16,12,18,38,101,5,55,250,288]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,e.$_r=p;let u=class extends d.$2p{constructor(w,v,S,r){super(r),this.m=w,this.n=v,this.r=S,this.s(),this.B(w.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,v){const{f:S,g:r}=this;let t;try{t=await(0,c.$Pm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$$)(s)))}const n={...process.env,...t},a=w.agent?w.agent:await(0,g.$0r)(w.url||"",n,{proxyUrl:S,strictSSL:r});return w.agent=a,w.strictSSL=r,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>p(w,v))}async resolveProxy(w){}async loadCertificates(){return(await new Promise((v,S)=>{V(["@vscode/proxy-agent"],v,S)}).then(Ae)).loadSystemCertificates({log:this.r})}};e.$$r=u,e.$$r=u=Se([oe(0,P.$$i),oe(1,y.$Mi),oe(2,h.$$j),oe(3,h.$_j)],u);async function m($){return((0,i.parse)($.url).protocol==="https:"?await new Promise((S,r)=>{V(["https"],S,r)}).then(Ae):await new Promise((S,r)=>{V(["http"],S,r)}).then(Ae)).request}async function p($,w){return o.Promises.withAsyncBody(async(v,S)=>{const r=(0,i.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await m($),n={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,R.$kg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(n.auth=$.user+":"+$.password);const a=t(n,s=>{const l=(0,R.$ig)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&l>0&&s.headers.location)p({...$,url:s.headers.location,followRedirects:l-1},w).then(v,S);else{let f=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(f=s.pipe((0,b.createGunzip)())),v({res:s,stream:(0,E.$3e)(f)})}});a.on("error",S),$.timeout&&a.setTimeout($.timeout),$.isChromiumNetwork&&a.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&a.write($.data),a.end(),w.onCancellationRequested(()=>{a.abort(),S(new D.$6)})})}}),define(ce[292],le([0,1,14,291]),function(V,e,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;function E(R){return i.net.request}class D extends o.$$r{request(P,y){return super.request({...P||{},getRawRequest:E,isChromiumNetwork:!0},y)}}e.$Ifc=D}),define(ce[87],le([0,1,7,3,2,38,15,6,20,5,63,285,43,59,42,13]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=e.$dec=e.$cec=e.$bec=void 0,e.$bec=(0,P.$Ei)("storageMainService");let p=class extends E.$Vc{constructor(v,S,r,t,n,a){super(),this.c=v,this.f=S,this.g=r,this.h=t,this.j=n,this.m=a,this.a=void 0,this.b=this.B(new o.$le),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(y.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(v=>{v.window.profile&&this.profileStorage(v.window.profile).init(),v.workspace&&this.workspaceStorage(v.workspace).init()})),this.B(this.h.onWillShutdown(v=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=v.reason,v.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)v.join("profileStorage",S.close());for(const[,S]of this.w)v.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(v=>{v.join((async()=>{await this.j.exists(v.profile.globalStorageHome)||await this.j.createFolder(v.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(v=>{const S=this.t.get(v.profile.id);S&&v.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const v=new d.$$dc(this.n(),this.g,this.c,this.j);return this.B(o.Event.once(v.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),v}profileStorage(v){if((0,h.$eq)(v))return this.applicationStorage;let S=this.t.get(v.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${v.name})`),S=this.B(this.u(v)),this.t.set(v.id,S);const r=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:v})));this.B(o.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${v.name})`),this.t.delete(v.id),r.dispose()}))}return S}u(v){return this.a===y.ShutdownReason.KILL?new d.$aec(this.c,this.j):new d.$0dc(v,this.n(),this.c,this.j)}workspaceStorage(v){let S=this.w.get(v.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${v.id})`),S=this.B(this.y(v)),this.w.set(v.id,S),this.B(o.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${v.id})`),this.w.delete(v.id)}))),S}y(v){return this.a===y.ShutdownReason.KILL?new d.$aec(this.c,this.j):new d.$_dc(v,this.n(),this.c,this.f,this.j)}isUsed(v){const S=i.URI.file(v);for(const r of[this.applicationStorage,...this.t.values(),...this.w.values()])if(r.path&&this.m.extUri.isEqualOrParent(i.URI.file(r.path),S))return!0;return!1}};e.$cec=p,e.$cec=p=Se([oe(0,c.$$j),oe(1,D.$Li),oe(2,b.$Rdc),oe(3,y.$8dc),oe(4,R.$$k),oe(5,u.$Il)],p),e.$dec=(0,P.$Ei)("applicationStorageMainService");let $=class extends h.$dq{constructor(v,S){super(),this.s=v,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(v){if(v===h.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(v){if(v===h.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$eec=$,e.$eec=$=Se([oe(0,g.$Kl),oe(1,e.$bec)],$)}),define(ce[293],le([0,1,92,27,112,105,8,2,4,18,5,28,246,247,102,132,17]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=e.$Ffc=e.$Efc=void 0,i=Ae(i),o=Ae(o);async function $(t,n,a,s,l){let f;for(let k=3;k&&(f?.dispose(),f=await new w(t,n,a,s,l).waitForReady(),!(l&&E.$4g[l]||!E.$4g[f.tunnelLocalPort]));k--);return f}class w extends P.$Vc{constructor(n,a,s,l,f){super(),this.m=a,this.n=f,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=i.createServer(),this.c=new R.$Dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,a=(0,m.$Ew)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,E.$5g)(n,2,1e3,a),l=null;return this.b.listen(s,this.m),await this.c.wait(),l=this.b.address(),l||(s=0,this.b.listen(s,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(n){n.pause();const a=(0,m.$Cw)(this.tunnelRemoteHost)||(0,m.$Ew)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,g.$1l)(this.a,a,this.tunnelRemotePort),l=s.getSocket(),f=s.readEntireBuffer();s.dispose(),f.byteLength>0&&n.write(f.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),l.end()}),n.on("close",()=>l.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),l instanceof D.$ti?l.socket.destroy():l.end()}),l instanceof D.$ti?this.t(n,l):this.s(n,l),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),l.end()})}s(n,a){a.onClose(()=>n.destroy()),a.onEnd(()=>n.end()),a.onData(s=>n.write(s.buffer)),n.on("data",s=>a.write(p.$Ne.wrap(s))),n.resume()}t(n,a){const s=a.socket;s.on("end",()=>n.end()),s.on("close",()=>n.end()),s.on("error",()=>{n.destroy()}),s.pipe(n),n.pipe(s)}}e.$Efc=w;let v=class extends m.$Hw{constructor(n,a,s,l,f){super(a,f),this.H=n,this.I=s,this.J=l}isPortPrivileged(n){return(0,m.$Fw)(n,this.t,y.OS,o.release())}F(n,a,s,l,f,k,I,O){const L=this.D(a,s);if(L)return++L.refcount,L.value;if((0,m.$yw)(n))return this.G(n,a,s,f,k,I,O);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${s} on local port ${f}.`);const T={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},A=$(T,l,a,s,f);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(a,s,A),A}}};e.$Ffc=v,e.$Ffc=v=Se([oe(0,b.$Ul),oe(1,h.$$j),oe(2,u.$Xl),oe(3,d.$rk),oe(4,c.$$i)],v);let S=class extends v{constructor(n,a,s,l,f){super(n,a,s,l,f)}};e.$Gfc=S,e.$Gfc=S=Se([oe(0,b.$Ul),oe(1,h.$$j),oe(2,u.$Xl),oe(3,d.$rk),oe(4,c.$$i)],S);let r=class extends P.$Vc{constructor(n,a,s,l,f){super(),this.b=n,this.c=a,this.f=s,this.g=l,this.h=f,this.a=new Map}async openTunnel(n,a,s,l,f,k,I,O,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${l} on local port ${k}.`),!this.a.has(n)){const T=new S(this.b,this.c,this.g,this.f,this.h);this.B(T),this.a.set(n,T),T.onTunnelClosed(async()=>{(await T.tunnels).length===0&&(T.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(a,s,l,f,k,I,O,L)}};e.$Hfc=r,e.$Hfc=r=Se([oe(0,b.$Ul),oe(1,h.$$j),oe(2,d.$rk),oe(3,u.$Xl),oe(4,c.$$i)],r)}),define(ce[106],le([0,1,8,23,3,18,25,20,5,28,55,50]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0,e.$1ec=g;function g(u,m,p){return`${p.updateUrl}/api/update/${u}/${m}/${p.commit}`}let b=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,p,$,w,v,S){this.f=m,this.g=p,this.h=$,this.i=w,this.j=v,this.k=S,this.b=d.$9X.Uninitialized,this.c=new E.$le,this.onStateChange=this.c.event,m.when(P.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(d.$9X.Disabled(d.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(d.$9X.Disabled(d.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(d.$9X.Disabled(d.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),p=this.m(m);if(!p){this.d(d.$9X.Disabled(d.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(d.$9X.Disabled(d.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(d.$9X.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,i.$Fh)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},o.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(m){}q(){return d.UpdateType.Archive}r(){}};e.$2ec=b,e.$2ec=b=Se([oe(0,P.$8dc),oe(1,D.$$i),oe(2,R.$Ddc),oe(3,h.$1p),oe(4,y.$$j),oe(5,c.$rk)],b)}),define(ce[294],le([0,1,14,52,3,46,2,18,25,20,5,28,55,24,50,106]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0,i=Ae(i);let p=class extends m.$2ec{get v(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"error",(w,v)=>v)}get w(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return E.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(w,v,S,r)=>({version:S,productVersion:S,timestamp:r}))}constructor(w,v,S,r,t,n,a){super(w,v,r,t,n,a),this.z=S,this.u=new R.$Uc,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==u.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(w){this.z.publicLog2("update:error",{messageHash:String((0,D.$sj)(String(w)))}),this.j.error("UpdateService error:",w);const v=this.state.type===u.StateType.CheckingForUpdates&&this.state.explicit?w:void 0;this.d(u.$9X.Idle(u.UpdateType.Archive,v))}s(w){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,m.$1ec)(v,w,this.k);try{i.autoUpdater.setFeedURL({url:S})}catch(r){this.j.error("Failed to set update feed URL",r);return}return S}t(w){this.d(u.$9X.CheckingForUpdates(w)),i.autoUpdater.checkForUpdates()}E(){this.state.type===u.StateType.CheckingForUpdates&&this.d(u.$9X.Downloading)}F(w){this.state.type===u.StateType.Downloading&&(this.d(u.$9X.Downloaded(w)),this.z.publicLog2("update:downloaded",{version:w.version}),this.d(u.$9X.Ready(w)))}G(){this.state.type===u.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.$9X.Idle(u.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$3ec=p,Se([o.$9h],p.prototype,"v",null),Se([o.$9h],p.prototype,"w",null),Se([o.$9h],p.prototype,"x",null),Se([o.$9h],p.prototype,"y",null),e.$3ec=p=Se([oe(0,c.$8dc),oe(1,P.$$i),oe(2,b.$0l),oe(3,y.$Ddc),oe(4,g.$1p),oe(5,h.$$j),oe(6,d.$rk)],p)}),define(ce[295],le([0,1,49,47,8,3,9,25,20,5,24,50]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0,R=Ae(R);let g=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,p,$){if(this.f=m,this.g=$,this.a=d.$9X.Uninitialized,this.b=new D.$le,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$9X.Idle(this.k())),this.h(30*1e3).then(void 0,w=>this.g.error(w))}h(m=60*60*1e3){return(0,E.$Fh)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===d.StateType.Idle&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===d.StateType.AvailableForDownload&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===d.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==d.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return d.UpdateType.Snap}l(){}async _applySpecificUpdate(m){}};g=Se([oe(0,y.$8dc),oe(1,P.$Ddc),oe(2,c.$$j)],g);let b=class extends g{constructor(m,p,$,w,v,S){super($,w,v),this.o=m,this.p=p,this.q=S;const r=(0,o.watch)(R.$nc(this.o)),t=D.Event.fromNodeEventEmitter(r,"change",(l,f)=>f),n=D.Event.filter(t,l=>l==="current"),s=D.Event.debounce(n,(l,f)=>f,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{s.dispose(),r.close()})}m(){this.d(d.$9X.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(d.$9X.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$9X.Idle(d.UpdateType.Snap)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$9X.Idle(d.UpdateType.Snap,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+R.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise(($,w)=>(0,o.realpath)(`${R.$nc(this.o)}/current`,(v,S)=>v?w(v):$(S))),p=R.$oc(m);return this.p!==p}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$5ec=b,e.$5ec=b=Se([oe(2,y.$8dc),oe(3,P.$Ddc),oe(4,c.$$j),oe(5,h.$0l)],b)}),define(ce[29],le([0,1,14,4,6,51,57,74,28,18,25,9,140]),function(V,e,i,o,E,D,R,P,y,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Odc=void 0,e.$Pdc=u,e.$Qdc=m,e.$Odc=(0,E.$Ei)("windowsMainService");var b;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(b||(e.OpenContext=b={}));function u($,w,v){const S=$.get(P.$Mdc),r=$.get(y.$rk),t=$.get(c.$$i),n=$.get(h.$Ddc),a=t.getValue("window"),s={backgroundColor:S.getBackgroundColor(),minWidth:R.$TD.WIDTH,minHeight:R.$TD.HEIGHT,title:r.nameLong,show:w.mode!==D.WindowMode.Maximized&&w.mode!==D.WindowMode.Fullscreen,x:w.x,y:w.y,width:w.width,height:w.height,webPreferences:{...v,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,R.$6D)(w.zoomLevel??a?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(o.$k?s.icon=(0,d.$kc)(n.appRoot,"resources/linux/code.png"):o.$i&&!n.isBuilt&&(s.icon=(0,d.$kc)(n.appRoot,"resources/win32/code_150x150.png")),o.$j&&(s.acceptFirstMouse=!0,a?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),o.$j&&!(0,R.$5D)(t)&&(s.fullscreenable=!1),o.$j&&a?.nativeTabs===!0&&(s.tabbingIdentifier=r.nameShort),!(0,R.$1D)(t)&&(s.titleBarStyle="hidden",o.$j||(s.frame=!1),(0,R.$4D)(t))){const k=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),I=g.$gu.fromHex(k).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:k,symbolColor:I}}return s}function m($){let w,v=Number.MIN_VALUE;for(const S of $)S.lastFocusTime>v&&(v=S.lastFocusTime,w=S);return w}var p;(function($){function w(S,r,t=i.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,r),typeof r.x!="number"||typeof r.y!="number"||typeof r.width!="number"||typeof r.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(r.width<=0||r.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const s=v(t[0]);if(S.trace("window#validateWindowState: single monitor working area",s),s){let l=function(){!r||typeof r.x!="number"||typeof r.y!="number"||!s||(r.x<s.x&&(r.x=s.x),r.y<s.y&&(r.y=s.y))};l(),r.width>s.width&&(r.width=s.width),r.height>s.height&&(r.height=s.height),r.x>s.x+s.width-128&&(r.x=s.x+s.width-r.width),r.y>s.y+s.height-128&&(r.y=s.y+s.height-r.height),l()}return r}if(r.display&&r.mode===D.WindowMode.Fullscreen){const s=t.find(l=>l.id===r.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const l=(0,D.$Bdc)(D.WindowMode.Fullscreen);return l.x=s.bounds.x,l.y=s.bounds.y,l}}let n,a;try{n=i.screen.getDisplayMatching({x:r.x,y:r.y,width:r.width,height:r.height}),a=v(n),S.trace("window#validateWindowState: multi-monitor working area",a)}catch(s){S.error("window#validateWindowState: error finding display for window state",s)}if(n&&a&&r.x+r.width>a.x&&r.y+r.height>a.y&&r.x<a.x+a.width&&r.y<a.y+a.height)return r;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=w;function v(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(p||(e.WindowStateValidator=p={}))}),define(ce[296],le([0,1,14,23,3,46,2,33,97,5,63,87,29]),function(V,e,i,o,E,D,R,P,y,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;var b;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let u=class extends R.$Vc{constructor(p,$,w,v){super(),this.g=p,this.h=$,this.j=w,this.m=v,this.a="proxy-credentials://",this.b=void 0,this.c=b.Initial,this.f=void 0,this.n()}n(){const p=E.Event.fromNodeEventEmitter(i.app,"login",($,w,v,S,r)=>({event:$,webContents:w,req:v,authInfo:S,callback:r}));this.B(p(this.r,this))}async r({event:p,authInfo:$,req:w,callback:v}){if(!$.isProxy)return;if(!this.b&&this.c===b.LoginDialogShown&&w.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{S=await this.b}finally{this.b=void 0}}v(S?.username,S?.password)}async s(p){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(p);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(p){this.g.trace("auth#doResolveProxyCredentials - enter",p);const $=String((0,D.$sj)({scheme:p.scheme,host:p.host,port:p.port}));let w,v;try{const n=this.m.get(this.a+$,h.StorageScope.APPLICATION);if(n){const a=JSON.parse(await this.j.decrypt(n));w=a.username,v=a.password}}catch(n){this.g.error(n)}if(this.c!==b.StoredCredentialsUsed&&typeof w=="string"&&typeof v=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=b.StoredCredentialsUsed,{username:w,password:v};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const r={authInfo:p,username:this.f?.username??w,password:this.f?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,P.$1g)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",o.CancellationToken.None,r),this.c=b.LoginDialogShown;const t=await new Promise(n=>{const a=async(s,l,f)=>{if(l===r.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",a),f){const k={username:f.username,password:f.password};try{if(f.remember){const I=await this.j.encrypt(JSON.stringify(k));this.m.store(this.a+$,I,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.m.remove(this.a+$,h.StorageScope.APPLICATION)}catch(I){this.g.error(I)}n({username:k.username,password:k.password})}else n(void 0)};S.win?.webContents.on("ipc-message",a)});return this.f=t,t}};e.$fec=u,e.$fec=u=Se([oe(0,c.$$j),oe(1,g.$Odc),oe(2,y.$TX),oe(3,d.$dec)],u)}),define(ce[297],le([0,1,92,204,121,29]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class R extends o.$Uo{constructor(y){super(),this.f=y}call(y,c,h){return c==="openExtensionDevelopmentHostWindow"?this.g(h[0],h[1]):super.call(y,c,h)}async g(y,c){const h=(0,E.$Bm)(y,E.$Am);h.debugRenderer=c;const d=h.extensionDevelopmentPath;if(!d)return{success:!1};const[g]=await this.f.openExtensionDevelopmentHostWindow(d,{context:D.OpenContext.API,cli:h,forceProfile:h.profile,forceTempProfile:h["profile-temp"]});if(!c)return{success:!0};const b=g.win;if(!b)return{success:!0};const u=b.webContents.debugger;let m=u.isAttached()?1/0:0;const p=(0,i.createServer)($=>{m++===0&&u.attach();let w=!1;const v=t=>{w||$.write(JSON.stringify(t)+"\0")},S=(t,n,a,s)=>v({method:n,params:a,sessionId:s});b.on("close",()=>{u.removeListener("message",S),$.end(),w=!0}),u.addListener("message",S);let r=Buffer.alloc(0);$.on("data",t=>{r=Buffer.concat([r,t]);for(let n=r.indexOf(0);n!==-1;n=r.indexOf(0)){let a;try{const s=r.slice(0,n).toString("utf8");r=r.slice(n+1),a=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}u.sendCommand(a.method,a.params,a.sessionId).then(s=>v({id:a.id,sessionId:a.sessionId,result:s})).catch(s=>v({id:a.id,sessionId:a.sessionId,error:{code:0,message:s.message}}))}}),$.on("error",t=>{console.error("error on cdp pipe:",t)}),$.on("close",()=>{w=!0,--m===0&&u.detach()})});return await new Promise($=>p.listen(0,$)),b.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.$hec=R}),define(ce[298],le([0,1,14,22,4,7,21,18,68,6,5,133,29]),function(V,e,i,o,E,D,R,P,y,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=e.$Gec=e.ID=void 0,e.ID="launchMainService",e.$Gec=(0,c.$Ei)(e.ID);let b=class{constructor(m,p,$,w){this.a=m,this.b=p,this.c=$,this.d=w}async start(m,p){this.a.trace("Received data from other instance: ",m,p),E.$j&&i.app.focus({steal:!0});const $=this.e(m);if($.length){let w=Promise.resolve();if(this.b.getWindowCount()===0){const v=(0,o.$Pb)(await this.b.openEmptyWindow({context:g.OpenContext.DESKTOP}));v&&(w=v.ready())}w.then(()=>{for(const{uri:v,originalUrl:S}of $)this.c.open(v,{originalUrl:S})})}else return this.f(m,p)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,o.$Ib)(m._urls.map(p=>{try{return{uri:D.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(m,p){const $=(0,y.$Im)(p)?g.OpenContext.CLI:g.OpenContext.DESKTOP;let w=[];const v=m.wait&&m.waitMarkerFilePath?D.URI.file(m.waitMarkerFilePath):void 0,S=m.remote||void 0,r={context:$,cli:m,userEnv:m["preserve-env"]||$===g.OpenContext.CLI?p:void 0,waitMarkerFileURI:v,remoteAuthority:S,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,r);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let t=!1;if(m["new-window"]||r.forceProfile||r.forceTempProfile)t=!0;else if(m["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!E.$j}if(t)w=await this.b.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const n=this.b.getLastActiveWindow();n?(this.b.openExistingWindow(n,r),w=[n]):w=await this.b.open({...r,forceEmpty:!0})}}else w=await this.b.open({...r,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(v&&w.length===1&&w[0])return Promise.race([w[0].whenClosedOrLoaded,(0,R.whenDeleted)(v.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Hec=b,e.$Hec=b=Se([oe(0,h.$$j),oe(1,g.$Odc),oe(2,d.$ZX),oe(3,P.$$i)],b)}),define(ce[299],le([0,1,2,20,51,59,30,8,29]),function(V,e,i,o,E,D,R,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;let c=class extends i.$Vc{constructor(d,g,b){super(),this.a=g,this.b=b,this.B(d.onWillLoadWindow(u=>{u.reason===E.LoadReason.LOAD&&this.c(u.window)})),this.B(d.onBeforeCloseWindow(u=>this.c(u))),this.B(new P.$Qh(()=>this.g(),30*1e3)).schedule()}async c(d){const g=this.f(d),b=this.a.getProfileForWorkspace(g);b?.isTransient&&(this.a.unsetWorkspace(g,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,R.$Si)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const g=this.b.getWindows().map(b=>this.f(b));for(const b of d)g.some(u=>u.id===b.id)||this.a.unsetWorkspace(b,!1)}};e.$kfc=c,e.$kfc=c=Se([oe(0,o.$8dc),oe(1,D.$Rdc),oe(2,y.$Odc)],c)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[64],le([0,1,14,2,3,5,318,8,13,29,79,24,20,80,35,4,107]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=void 0,h=et(h);function w(r){return typeof r.responseWindowId=="number"}let v=class extends o.$Vc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,n,a){super(),this.w=t,this.y=n,this.z=a,this.c=String(++$.a),this.f=this.B(new E.$le),this.onStdout=this.f.event,this.g=this.B(new E.$le),this.onStderr=this.g.event,this.h=this.B(new E.$le),this.onMessage=this.h.event,this.j=this.B(new E.$le),this.onSpawn=this.j.event,this.m=this.B(new E.$le),this.onExit=this.m.event,this.n=this.B(new E.$le),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,n){let a;switch(this.t?.correlationId?a=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:a=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,n){case h.default.Error:this.w.error(a);break;case h.default.Warning:this.w.warn(a);break;case h.default.Info:this.w.trace(a);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",h.default.Error),!1):!0}start(t){const n=this.F(t);return n&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",h.default.Info),n}F(t){if(!this.D())return!1;this.t=t;const n=`${this.t.type}-${this.c}`,a=y.$Yg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],l=this.t.execArgv??[],f=this.t.allowLoadingUnsignedLibraries,k=this.t.forceAllocationsToV8Sandbox,I="pipe",O=this.G(t);return this.C("creating new...",h.default.Info),this.r=i.utilityProcess.fork(a,s,{serviceName:n,env:O,execArgv:l,allowLoadingUnsignedLibraries:f,forceAllocationsToV8Sandbox:k,stdio:I}),this.H(this.r,this.t,n),!0}G(t){const n=t.env?{...t.env}:{...(0,u.$bo)(process.env)};n.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(n.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),n.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,m.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?n.NODE_DISABLE_UNC_ACCESS_CHECKS="1":n.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,b.$km)(n);for(const a of Object.keys(n))n[a]=String(n[a]);return n}H(t,n,a){if(t.stdout){const s=new R.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stdout,"data")(l=>this.f.fire(typeof l=="string"?l:s.write(l))))}if(t.stderr){const s=new R.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stderr,"data")(l=>this.g.fire(typeof l=="string"?l:s.write(l))))}this.B(E.Event.fromNodeEventEmitter(t,"message")(s=>this.h.fire(s))),this.B(E.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:w(n)?`${n.type} [${n.responseWindowId}]`:n.type}),this.C("successfully created",h.default.Info),this.j.fire(t.pid)})),this.B(E.Event.fromNodeEventEmitter(t,"exit")(s=>{const l=this.I(s)?0:s;this.C(`received exit event with code ${l}`,h.default.Info),this.m.fire({pid:this.s,code:l,signal:"unknown"}),this.J()})),this.B(E.Event.fromNodeEventEmitter(i.app,"child-process-gone",(s,l)=>({event:s,details:l}))(({details:s})=>{s.type==="Utility"&&s.name===a&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,h.default.Error),this.y.publicLog2("utilityprocesscrash",{type:n.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(t,n){const a=this.B(this.h.event(s=>{s===t&&(a.dispose(),n())}))}postMessage(t,n){return this.r?(this.r.postMessage(t,n),!0):!1}connect(t){const{port1:n,port2:a}=new i.MessageChannelMain;return this.postMessage(t,[a]),n}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",h.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",h.default.Info),this.r.kill()?(this.C("successfully killed the process",h.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",h.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",h.default.Info),await Promise.race([E.Event.toPromise(this.onExit),(0,P.$Fh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,h.default.Info),this.kill()))}};e.$iec=v,e.$iec=v=$=Se([oe(0,D.$$j),oe(1,d.$0l),oe(2,g.$8dc)],v);let S=class extends v{constructor(t,n,a,s){super(t,a,s),this.L=n}start(t){const n=this.L.getWindowById(t.responseWindowId);if(!n?.win||n.win.isDestroyed()||n.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",h.default.Error),!0;if(!super.F(t))return!1;this.M(n.win,t);const s=this.connect(t.payload);return n.win.webContents.postMessage(t.responseChannel,t.responseNonce,[s]),!0}M(t,n){n.windowLifecycleBound&&(this.B(E.Event.filter(this.z.onWillLoadWindow,a=>a.window.win===t)(()=>this.kill())),this.B(E.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$jec=S,e.$jec=S=Se([oe(0,D.$$j),oe(1,c.$Odc),oe(2,d.$0l),oe(3,g.$8dc)],S)}),define(ce[300],le([0,1,8,16,3,2,20,5,24,64,29]),function(V,e,i,o,E,D,R,P,y,c,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;let g=class extends D.$Vc{static{d=this}static{this.a=0}constructor(u,m,p,$){super(),this.f=u,this.g=m,this.h=p,this.j=$,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(u){const m=this.b.get(u);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(u){return this.m(u).onStdout}onDynamicStderr(u){return this.m(u).onStderr}onDynamicMessage(u){return this.m(u).onMessage}onDynamicExit(u){return this.m(u).onExit}async createExtensionHost(){if(this.c)throw(0,o.$7)();const u=String(++d.a),m=new c.$jec(this.f,this.h,this.j,this.g);this.b.set(u,m);const p=m.onExit(({pid:$,code:w,signal:v})=>{p.dispose(),this.f.info(`Extension host with pid ${$} exited with code: ${w}, signal: ${v}.`),setTimeout(()=>{m.dispose(),this.b.delete(u)}),setTimeout(()=>{try{process.kill($,0),this.f.error(`Extension host with pid ${$} still exists, forcefully killing it...`),process.kill($)}catch{}},1e3)});return{id:u}}async start(u,m){if(this.c)throw(0,o.$7)();const p=this.m(u);return p.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:u}),{pid:await E.Event.toPromise(p.onSpawn)}}async enableInspectPort(u){if(this.c)throw(0,o.$7)();const m=this.b.get(u);return m?m.enableInspectPort():!1}async kill(u){if(this.c)throw(0,o.$7)();const m=this.b.get(u);m&&m.kill()}async _killAllNow(){for(const[,u]of this.b)u.kill()}async _waitForAllExit(u){const m=[];for(const[,p]of this.b)m.push(p.waitForExit(u));return i.Promises.settled(m).then(()=>{})}};e.$qec=g,e.$qec=g=d=Se([oe(0,P.$$j),oe(1,R.$8dc),oe(2,h.$Odc),oe(3,y.$0l)],g)}),define(ce[301],le([0,1,37,8,2,25,20,5,43,41,71,64,56,95,12,252,3]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;let $=class extends E.$Vc{constructor(v,S,r,t,n,a,s,l,f){super(),this.g=v,this.h=S,this.j=r,this.m=t,this.n=n,this.r=a,this.s=s,this.t=l,this.u=f,this.a=new o.$Dh,this.b=void 0,this.c=void 0,this.f=this.B(new p.$le),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){i.$$W.on(m.$Sec.request,(v,S)=>this.y(v,S,m.$Sec.response)),i.$$W.on(m.$Tec.request,(v,S)=>this.y(v,S,m.$Tec.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(v,S,r){this.s.trace(`[SharedProcess] onWindowConnection for: ${r}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(r);if(v.sender.isDestroyed())return t.close();v.sender.postMessage(r,S,[t])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$Rec.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const v=new o.$2h;this.b?.once(m.$Rec.initDone,()=>v.complete()),await v.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const v=new o.$2h;this.b?.once(m.$Rec.ipcReady,()=>v.complete()),await v.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new d.$iec(this.s,g.$up,this.r)),this.c=this.b.onMessage(r=>{typeof r.warning=="string"?this.s.warn(r.warning):typeof r.error=="string"&&this.s.error(r.error)});const v=(0,b.$9m)(this.m.args,this.m.isBuilt);let S;v.port&&(S=["--nolazy"],v.break?S.push(`--inspect-brk=${v.port}`):S.push(`--inspect=${v.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(v){return await this.F,(0,u.$pg)(this.b).connect(v)}};e.$Uec=$,e.$Uec=$=Se([oe(3,D.$Ddc),oe(4,y.$Kl),oe(5,R.$8dc),oe(6,P.$$j),oe(7,h.$3dc),oe(8,c.$qo)],$)}),define(ce[302],le([0,1,25,95,20,5,56,73,64,119,37,2,3,35,18,13]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;let p=class extends d.$Vc{constructor(w,v,S,r,t){super(),this.f=w,this.g=v,this.h=S,this.j=r,this.m=t,this.a=void 0,this.b=new g.$le,this.onRequestConnection=this.b.event,this.c=new g.$le,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),h.$$W.on("vscode:createPtyHostMessageChannel",(n,a)=>this.r(n,a)),this.B((0,d.$Tc)(()=>{h.$$W.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new y.$iec(this.m,R.$up,this.j);const w=(0,o.$8m)(this.h.args,this.h.isBuilt),v=w.port?["--nolazy",`--inspect${w.break?"-brk":""}=${w.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:v,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),r=new c.$gX(S,"ptyHost"),t=new d.$Uc;return t.add(r),t.add((0,d.$Tc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:r,store:t,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const w={...(0,b.$bo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},v=this.g.getValue(P.TerminalSettingId.DeveloperPtyHostLatency);v&&typeof v=="number"&&(w.VSCODE_LATENCY=String(v));const S=this.g.getValue(P.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&(w.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),w}r(w,v){this.b.fire();const S=this.a.connect();if(w.sender.isDestroyed()){S.close();return}w.sender.postMessage("vscode:createPtyHostMessageChannelResult",v,[S])}};e.$wfc=p,e.$wfc=p=Se([oe(1,u.$$i),oe(2,i.$Ddc),oe(3,E.$8dc),oe(4,D.$$j)],p)}),define(ce[303],le([0,1,2,6,5,29,64,24,46,3,8,20]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0,e.$ufc=(0,o.$Ei)("utilityProcessWorker");let g=class extends i.$Vc{constructor(m,p,$,w){super(),this.b=m,this.c=p,this.f=$,this.g=w,this.a=new Map}async createWorker(m){const p=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const $=this.h(m);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(m));const w=new b(this.b,this.c,this.f,this.g,m);if(!w.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,w);const v=new h.$2h;return c.Event.once(w.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete($),v.complete({reason:S})}),v.p}h(m){return(0,y.$sj)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const p=this.h(m),$=this.a.get(p);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),$.kill(),$.dispose(),this.a.delete(p))}};e.$vfc=g,e.$vfc=g=Se([oe(0,E.$$j),oe(1,D.$Odc),oe(2,P.$0l),oe(3,d.$8dc)],g);let b=class extends i.$Vc{constructor(m,p,$,w,v){super(),this.c=m,this.f=p,this.g=$,this.h=w,this.j=v,this.a=this.B(new c.$le),this.onDidTerminate=this.a.event,this.b=this.B(new R.$jec(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};b=Se([oe(0,E.$$j),oe(1,D.$Odc),oe(2,P.$0l),oe(3,d.$8dc)],b)}),define(ce[304],le([0,1,14,3,2,277,29]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;let P=class extends E.$Vc{constructor(c){super(),this.b=c,this.a=this.B(new o.$le),this.onFoundInFrame=this.a.event,this.B(new D.$_ec)}async setIgnoreMenuShortcuts(c,h){let d;if(typeof c.windowId=="number"){const{windowId:g}=c,b=this.b.getWindowById(g);if(!b?.win)throw new Error(`Invalid windowId: ${g}`);d=b.win.webContents}else{const{webContentsId:g}=c;if(d=i.webContents.fromId(g),!d)throw new Error(`Invalid webContentsId: ${g}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts(h)}async findInFrame(c,h,d,g){const u=this.c(c,h);if(typeof u.findInFrame=="function"){u.findInFrame(d,{findNext:g.findNext,forward:g.forward});const m=(p,$)=>{$.finalUpdate&&(this.a.fire($),u.removeListener("found-in-frame",m))};u.on("found-in-frame",m)}}async stopFindInFrame(c,h,d){const b=this.c(c,h);typeof b.stopFindInFrame=="function"&&b.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(c,h){const d=this.b.getWindowById(c.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${c}`);const g=d.win.webContents.mainFrame.framesInSubtree.find(b=>b.name===h);if(!g)throw new Error(`Unknown frame: ${h}`);return g}};e.$afc=P,e.$afc=P=Se([oe(0,R.$Odc)],P)}),define(ce[305],le([0,1,14,2,4,19,7,18,20,5,34,29,51,30]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0,e.$cfc=p,e.$dfc=w;let m=class extends o.$Vc{static{u=this}static{this.a="windowsState"}get state(){return this.b}constructor(r,t,n,a,s){super(),this.g=r,this.h=t,this.j=n,this.m=a,this.n=s,this.b=p(this.h.getItem(u.a)),this.c=void 0,this.f=!1,this.r()}r(){i.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(r=>this.u(r))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(r=>{r.newCount-r.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(r=>this.u(r)))}s(){this.f=!0,this.t()}t(){const r=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(l=>!l.isExtensionDevelopmentHost)),s&&(t.lastActiveWindow=this.w(s),t.lastActiveWindow.uiState.mode===g.WindowMode.Fullscreen&&r.add(t.lastActiveWindow.uiState.display))}const n=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);n&&(t.lastPluginDevelopmentHostWindow=this.w(n),t.lastPluginDevelopmentHostWindow.uiState.mode===g.WindowMode.Fullscreen&&(r.has(t.lastPluginDevelopmentHostWindow.uiState.display)?E.$j&&!n.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=g.WindowMode.Normal):r.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const l=this.w(s);return l.uiState.mode===g.WindowMode.Fullscreen&&(r.has(l.uiState.display)?E.$j&&l.windowId!==t.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(l.uiState.mode=g.WindowMode.Normal):r.add(l.uiState.display)),l}));const a=w(t);this.h.setItem(u.a,a),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",a)}u(r){if(this.j.quitRequested)return;const t=this.w(r);r.isExtensionDevelopmentHost&&!r.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!r.isExtensionDevelopmentHost&&r.openedWorkspace&&this.b.openedWindows.forEach(n=>{const a=(0,b.$Ti)(r.openedWorkspace)&&n.workspace?.id===r.openedWorkspace.id,s=(0,b.$Oi)(r.openedWorkspace)&&n.folderUri&&D.$9g.isEqual(n.folderUri,r.openedWorkspace.uri);(a||s)&&(n.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(r){return{windowId:r.id,workspace:(0,b.$Ti)(r.openedWorkspace)?r.openedWorkspace:void 0,folderUri:(0,b.$Oi)(r.openedWorkspace)?r.openedWorkspace.uri:void 0,backupPath:r.backupPath,remoteAuthority:r.remoteAuthority,uiState:r.serializeWindowState()}}getNewWindowState(r){const t=this.z(r),n=this.n.getValue("window");if(t.mode===g.WindowMode.Fullscreen){let a;t.hasDefaultState?a=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):a=!!(this.j.wasRestarted||n?.restoreFullscreen),a||(t.mode=g.WindowMode.Normal)}return t}z(r){const t=this.g.getLastActiveWindow();if(!r.extensionTestsPath){if(r.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=r.workspace;if((0,b.$Ti)(k)){const O=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===k.id).map(L=>L.uiState);if(O.length)return O[0]}if((0,b.$Oi)(k)){const O=this.state.openedWindows.filter(L=>L.folderUri&&D.$9g.isEqual(L.folderUri,k.uri)).map(L=>L.uiState);if(O.length)return O[0]}else if(r.backupPath){const O=this.state.openedWindows.filter(L=>L.backupPath===r.backupPath).map(L=>L.uiState);if(O.length)return O[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let n;const a=i.screen.getAllDisplays();if(a.length===1)n=a[0];else{if(E.$j){const k=i.screen.getCursorScreenPoint();n=i.screen.getDisplayNearestPoint(k)}!n&&t&&(n=i.screen.getDisplayMatching(t.getBounds())),n||(n=i.screen.getPrimaryDisplay()||a[0])}let s=(0,g.$Bdc)();s.x=Math.round(n.bounds.x+n.bounds.width/2-s.width/2),s.y=Math.round(n.bounds.y+n.bounds.height/2-s.height/2);const l=this.n.getValue("window");let f=!0;if(l?.newWindowDimensions){if(l.newWindowDimensions==="maximized")s.mode=g.WindowMode.Maximized,f=!1;else if(l.newWindowDimensions==="fullscreen")s.mode=g.WindowMode.Fullscreen,f=!1;else if((l.newWindowDimensions==="inherit"||l.newWindowDimensions==="offset")&&t){const k=t.serializeWindowState();k.mode===g.WindowMode.Fullscreen?s.mode=g.WindowMode.Fullscreen:s={...k,zoomLevel:void 0},f=s.mode!==g.WindowMode.Fullscreen&&l.newWindowDimensions==="offset"}}return f&&(s=this.C(s)),s.hasDefaultState=!0,s}C(r){if(this.g.getWindows().length===0)return r;r.x=typeof r.x=="number"?r.x:0,r.y=typeof r.y=="number"?r.y:0;const t=this.g.getWindows().map(n=>n.getBounds());for(;t.some(n=>n.x===r.x||n.y===r.y);)r.x+=30,r.y+=30;return r}};e.$bfc=m,e.$bfc=m=u=Se([oe(0,d.$Odc),oe(1,h.$MQ),oe(2,y.$8dc),oe(3,c.$$j),oe(4,P.$$i)],m);function p(S){const r={openedWindows:[]},t=S||{openedWindows:[]};return t.lastActiveWindow&&(r.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(r.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(r.openedWindows=t.openedWindows.map(n=>$(n))),r}function $(S){const r={uiState:S.uiState};return S.backupPath&&(r.backupPath=S.backupPath),S.remoteAuthority&&(r.remoteAuthority=S.remoteAuthority),S.folder&&(r.folderUri=R.URI.parse(S.folder)),S.workspaceIdentifier&&(r.workspace={id:S.workspaceIdentifier.id,configPath:R.URI.parse(S.workspaceIdentifier.configURIPath)}),r}function w(S){return{lastActiveWindow:S.lastActiveWindow&&v(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&v(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(r=>v(r))}}function v(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(ce[60],le([0,1,14,3,40,2,13,9,19,21,200,69,58,25,6,5,59,135,30,103,104]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=e.$1dc=void 0,e.$1dc=(0,u.$Ei)("workspacesManagementMainService");let r=class extends D.$Vc{constructor(n,a,s,l,f){super(),this.g=n,this.h=a,this.j=s,this.m=l,this.n=f,this.a=this.B(new o.$le),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new o.$le),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const n=(await c.Promises.readdir(this.c.with({scheme:R.Schemas.file}).fsPath)).map(a=>(0,y.$fh)(this.c,a,w.$4i));for(const a of n){const s=(0,S.$Xdc)(a),l=await this.resolveLocalWorkspace(a);l?this.f.push({workspace:s,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(n){n.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${n}).`)}}resolveLocalWorkspace(n){return this.r(n,a=>c.Promises.readFile(a,"utf8"))}r(n,a){if(this.s(n)&&n.scheme===R.Schemas.file)try{const s=a(n.fsPath);return s instanceof Promise?s.then(l=>this.t(n,l),l=>{}):this.t(n,s)}catch{return}}s(n){return(0,w.$5i)(n,this.g)||(0,w.$0i)(n)}t(n,a){try{const s=this.u(n,a),l=(0,S.$Xdc)(n);return{id:l.id,configPath:l.configPath,folders:(0,v.$_gb)(s.folders,l.configPath,y.$9g),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}u(n,a){const s=(0,E.$Un)(a);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(l=>(0,v.$0gb)(l));else throw new Error(`${n.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(n,a){const{workspace:s,storedWorkspace:l}=this.w(n,a),f=s.configPath.fsPath;return await c.Promises.mkdir((0,P.$nc)(f),{recursive:!0}),await c.Promises.writeFile(f,JSON.stringify(l,null,"	")),this.f.push({workspace:s,remoteAuthority:a}),s}w(n=[],a){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,y.$fh)(this.c,s),f=(0,y.$fh)(l,w.$4i),k=[];for(const I of n)k.push((0,v.$$gb)(I.uri,!0,I.name,l,y.$9g));return{workspace:(0,S.$Xdc)(f),storedWorkspace:{folders:k,remoteAuthority:a}}}async getWorkspaceIdentifier(n){return(0,S.$Xdc)(n)}isUntitledWorkspace(n){return(0,w.$5i)(n.configPath,this.g)}async deleteUntitledWorkspace(n){this.isUntitledWorkspace(n)&&(await this.y(n),this.j.isEnabled()&&this.j.unsetWorkspace(n),this.a.fire(n))}async y(n){const a=(0,y.$6g)(n.configPath);try{await c.Promises.rm((0,P.$nc)(a));const s=(0,P.$kc)(this.g.workspaceStorageHome.with({scheme:R.Schemas.file}).fsPath,n.id);await c.Promises.exists(s)&&await c.Promises.writeFile((0,P.$kc)(s,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==n.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${a} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(n,a,s){if(!n||!n.win||!n.isReady||!await this.z(n,a,s))return;const f=await this.C(n,(0,S.$Xdc)(s));if(f)return this.b.fire({window:n,workspace:f.workspace}),f}async z(n,a,s){return s?(0,w.$Ti)(n.openedWorkspace)&&y.$9g.isEqual(n.openedWorkspace.configPath,s)?!1:(0,$.$Udc)(a,s)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(0,null)],message:(0,h.localize)(1,null,(0,y.$ch)(s)),detail:(0,h.localize)(2,null)},i.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(n,a){if(!n.config)return;n.focus();let s;return n.config.extensionDevelopmentPath||(n.config.backupPath?s=await this.m.registerWorkspaceBackup({workspace:a,remoteAuthority:n.remoteAuthority},n.config.backupPath):s=this.m.registerWorkspaceBackup({workspace:a,remoteAuthority:n.remoteAuthority})),(0,w.$Ti)(n.openedWorkspace)&&this.isUntitledWorkspace(n.openedWorkspace)&&await this.deleteUntitledWorkspace(n.openedWorkspace),n.config.workspace=a,n.config.backupPath=s,{workspace:a,backupPath:s}}};e.$2dc=r,e.$2dc=r=Se([oe(0,b.$Ddc),oe(1,m.$$j),oe(2,p.$Rdc),oe(3,d.$Idc),oe(4,g.$Jdc)],r)}),define(ce[136],le([0,1,14,37,23,6,29,30,60,12,5,64]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=e.ID=void 0,e.ID="diagnosticsMainService",e.$lec=(0,D.$Ei)(e.ID);let g=class{constructor(u,m,p){this.a=u,this.b=m,this.c=p}async getRemoteDiagnostics(u){const m=this.a.getWindows();return(await Promise.all(m.map(async $=>{const w=$.remoteAuthority;if(!w)return;const v=`vscode:getDiagnosticInfoResponse${$.id}`,S={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(r=>{$.sendWhenReady("vscode:getDiagnosticInfo",E.CancellationToken.None,{replyChannel:v,args:S}),o.$$W.once(v,(t,n)=>{n||r({hostName:w,errorMessage:`Unable to resolve connection to '${w}'.`}),r(n)}),setTimeout(()=>{r({hostName:w,errorMessage:`Connection to '${w}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const u=[];for(const p of i.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(p.id);$?u.push(await this.d($)):u.push(this.e(p))}const m=[];for(const{pid:p,name:$}of d.$iec.getAll())m.push({pid:p,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,pidToNames:m,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(u){const m=await this.f(u),p=(0,c.$pg)(u.win);return this.e(p,m,u.remoteAuthority)}e(u,m=[],p){return{id:u.id,pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:m,remoteAuthority:p}}async f(u){const m=[],p=u.openedWorkspace;if((0,P.$Oi)(p))m.push(p.uri);else if((0,P.$Ti)(p)){const $=await this.b.resolveLocalWorkspace(p.configPath);$&&$.folders.forEach(v=>{m.push(v.uri)})}return m}};e.$mec=g,e.$mec=g=Se([oe(0,R.$Odc),oe(1,y.$1dc),oe(2,h.$$j)],g)}),define(ce[75],le([0,1,49,14,27,161,52,3,2,13,9,4,7,114,93,21,112,188,58,25,6,20,5,28,74,29,30,60,17,248,240,83,16]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s,l,f,k,I,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0,e.$Aec=(0,S.$Ei)("nativeHostMainService");let A=class extends y.$Vc{constructor(z,C,B,re,_,se,K,ee,H){super(),this.a=z,this.b=C,this.c=B,this.f=re,this.g=_,this.h=se,this.j=K,this.m=ee,this.n=H,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:U,y:x})=>({windowId:j.id,x:U,y:x})),P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:j,x:U,y:x})=>({windowId:j.id,x:U,y:x}))),this.onDidMaximizeWindow=P.Event.any(P.Event.map(this.a.onDidMaximizeWindow,j=>j.id),P.Event.map(this.b.onDidMaximizeWindow,j=>j.id)),this.onDidUnmaximizeWindow=P.Event.any(P.Event.map(this.a.onDidUnmaximizeWindow,j=>j.id),P.Event.map(this.b.onDidUnmaximizeWindow,j=>j.id)),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.a.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen})),P.Event.map(this.b.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,U)=>U.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,U)=>U.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-blur",(j,U)=>this.b.getWindowByWebContents(U.webContents)),j=>!!j),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(o.app,"browser-window-focus",(j,U)=>this.b.getWindowByWebContents(U.webContents)),j=>!!j),j=>j.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(o.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$le),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(o.screen,"display-metrics-changed",(j,U,x)=>x),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),P.Event.fromNodeEventEmitter(o.screen,"display-added"),P.Event.fromNodeEventEmitter(o.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(z,C){const B=this.a.getWindows().map(_=>({id:_.id,workspace:_.openedWorkspace??(0,l.$Si)(_.backupPath,_.isExtensionDevelopmentHost),title:_.win?.getTitle()??"",filename:_.getRepresentedFilename(),dirty:_.isDocumentEdited()})),re=[];return C.includeAuxiliaryWindows&&re.push(...this.b.getWindows().map(_=>({id:_.id,parentId:_.parentId,title:_.win?.getTitle()??"",filename:_.getRepresentedFilename()}))),[...B,...re]}async getWindowCount(z){return this.a.getWindowCount()}async getActiveWindowId(z){const C=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(C)return C.id}openWindow(z,C,B){return Array.isArray(C)?this.s(z,C,B):this.t(z,C)}async s(z,C,B=Object.create(null)){C.length>0&&await this.a.open({context:s.OpenContext.API,contextWindowId:z,urisToOpen:C,cli:this.g.args,forceNewWindow:B.forceNewWindow,forceReuseWindow:B.forceReuseWindow,preferNewWindow:B.preferNewWindow,diffMode:B.diffMode,mergeMode:B.mergeMode,addMode:B.addMode,gotoLineMode:B.gotoLineMode,noRecentEntry:B.noRecentEntry,waitMarkerFileURI:B.waitMarkerFileURI,remoteAuthority:B.remoteAuthority||void 0,forceProfile:B.forceProfile,forceTempProfile:B.forceTempProfile})}async t(z,C){await this.a.openEmptyWindow({context:s.OpenContext.API,contextWindowId:z},C)}async isFullScreen(z,C){return this.C(C?.targetWindowId,z)?.isFullScreen??!1}async toggleFullScreen(z,C){this.C(C?.targetWindowId,z)?.toggleFullScreen()}async handleTitleDoubleClick(z,C){this.C(C?.targetWindowId,z)?.handleTitleDoubleClick()}async getCursorScreenPoint(z){const C=o.screen.getCursorScreenPoint(),B=o.screen.getDisplayNearestPoint(C);return{point:C,display:B.bounds}}async isMaximized(z,C){return this.C(C?.targetWindowId,z)?.win?.isMaximized()??!1}async maximizeWindow(z,C){this.C(C?.targetWindowId,z)?.win?.maximize()}async unmaximizeWindow(z,C){this.C(C?.targetWindowId,z)?.win?.unmaximize()}async minimizeWindow(z,C){this.C(C?.targetWindowId,z)?.win?.minimize()}async moveWindowTop(z,C){this.C(C?.targetWindowId,z)?.win?.moveTop()}async positionWindow(z,C,B){const re=this.C(B?.targetWindowId,z);if(re?.win){if(re.win.isFullScreen()){const _=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(re.win,"leave-full-screen")));re.win.setFullScreen(!1),await _}re.win.setBounds(C)}}async updateWindowControls(z,C){this.C(C?.targetWindowId,z)?.updateWindowControls(C)}async focusWindow(z,C){this.C(C?.targetWindowId,z)?.focus({force:C?.force??!1})}async setMinimumSize(z,C,B){const re=this.D(z);if(re?.win){const[_,se]=re.win.getSize(),[K,ee]=re.win.getMinimumSize(),[H,j]=[C??K,B??ee],[U,x]=[Math.max(_,H),Math.max(se,j)];(K!==H||ee!==j)&&re.win.setMinimumSize(H,j),(_!==U||se!==x)&&re.win.setSize(U,x)}}async saveWindowSplash(z,C){this.m.saveWindowSplash(z,C)}async installShellCommand(z){const{source:C,target:B}=await this.u();try{const{symbolicLink:re}=await m.SymlinkSupport.stat(C);if(re&&!re.dangling){const _=await(0,b.$gr)(C);if(B===_)return}await m.Promises.unlink(C)}catch(re){if(re.code!=="ENOENT")throw re}try{await m.Promises.symlink(B,C)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:_}=await this.showMessageBox(z,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(_===1)throw new T.$6;try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${B}' '${C}'\\" with administrator privileges"`;await(0,D.promisify)(i.exec)(se)}catch{throw new Error((0,$.localize)(3,null,C))}}}async uninstallShellCommand(z){const{source:C}=await this.u();try{await m.Promises.unlink(C)}catch(B){switch(B.code){case"EACCES":{const{response:re}=await this.showMessageBox(z,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(re===1)throw new T.$6;try{const _=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,D.promisify)(i.exec)(_)}catch{throw new Error((0,$.localize)(7,null,C))}break}case"ENOENT":break;default:throw B}}}async u(){const z=(0,h.$lc)(this.g.appRoot,"bin","code"),C=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(z))throw new Error((0,$.localize)(8,null,z));return{source:C,target:z}}async showMessageBox(z,C){const B=this.C(C?.targetWindowId,z);return this.c.showMessageBox(C,B?.win??void 0)}async showSaveDialog(z,C){const B=this.C(C?.targetWindowId,z);return this.c.showSaveDialog(C,B?.win??void 0)}async showOpenDialog(z,C){const B=this.C(C?.targetWindowId,z);return this.c.showOpenDialog(C,B?.win??void 0)}async pickFileFolderAndOpen(z,C){const B=await this.c.pickFileFolder(C);B&&await this.w(await Promise.all(B.map(async re=>await m.SymlinkSupport.existsDirectory(re)?{folderUri:g.URI.file(re)}:{fileUri:g.URI.file(re)})),C,z)}async pickFolderAndOpen(z,C){const B=await this.c.pickFolder(C);B&&await this.w(B.map(re=>({folderUri:g.URI.file(re)})),C,z)}async pickFileAndOpen(z,C){const B=await this.c.pickFile(C);B&&await this.w(B.map(re=>({fileUri:g.URI.file(re)})),C,z)}async pickWorkspaceAndOpen(z,C){const B=await this.c.pickWorkspace(C);B&&await this.w(B.map(re=>({workspaceUri:g.URI.file(re)})),C,z)}async w(z,C,B){await this.a.open({context:s.OpenContext.DIALOG,contextWindowId:B,cli:this.g.args,urisToOpen:z,forceNewWindow:C.forceNewWindow})}async showItemInFolder(z,C){o.shell.showItemInFolder(C)}async setRepresentedFilename(z,C,B){this.C(B?.targetWindowId,z)?.setRepresentedFilename(C)}async setDocumentEdited(z,C,B){this.C(B?.targetWindowId,z)?.setDocumentEdited(C)}async openExternal(z,C){return this.g.unsetSnapExportedVariables(),o.shell.openExternal(C),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(z,C){return o.shell.trashItem(C)}async isAdmin(){let z;return d.$i?z=(await new Promise((C,B)=>{V(["native-is-elevated"],C,B)}).then(Ae)).default():z=process.getuid?.()===0,z}async writeElevated(z,C,B,re){const _=await new Promise((se,K)=>{V(["@vscode/sudo-prompt"],se,K)}).then(Ae);return new Promise((se,K)=>{const ee=[`"${this.z}"`];re?.unlock&&ee.push("--file-chmod"),ee.push("--file-write",`"${C.fsPath}"`,`"${B.fsPath}"`);const H={name:this.j.nameLong.replace("-",""),icns:d.$j&&this.g.isBuilt?(0,h.$kc)((0,h.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};_.exec(ee.join(" "),H,(j,U,x)=>{U&&this.h.trace(`[sudo-prompt] received stdout: ${U}`),x&&this.h.trace(`[sudo-prompt] received stderr: ${x}`),j?K(j):se(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:o.app.runningUnderARM64Translation}get z(){return d.$i?this.g.isBuilt?(0,h.$kc)((0,h.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$kc)(this.g.appRoot,"scripts","code-cli.bat"):d.$k?this.g.isBuilt?(0,h.$kc)((0,h.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$kc)(this.g.appRoot,"bin","code"):(0,h.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,E.totalmem)(),freemem:(0,E.freemem)(),loadavg:(0,E.loadavg)()}}async getOSProperties(){return{arch:(0,E.arch)(),platform:(0,E.platform)(),release:(0,E.release)(),type:(0,E.type)(),cpus:(0,E.cpus)()}}async getOSVirtualMachineHint(){return u.$On.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,I.$xec)()}async getProcessId(z){return this.C(void 0,z)?.win?.webContents.getOSProcessId()}async killProcess(z,C,B){process.kill(C,B)}async readClipboardText(z,C){return o.clipboard.readText(C)}async writeClipboardText(z,C,B){return o.clipboard.writeText(C,B)}async readClipboardFindText(z){return o.clipboard.readFindText()}async writeClipboardFindText(z,C){return o.clipboard.writeFindText(C)}async writeClipboardBuffer(z,C,B,re){return o.clipboard.writeBuffer(C,Buffer.from(B.buffer),re)}async readClipboardBuffer(z,C){return k.$Ne.wrap(o.clipboard.readBuffer(C))}async hasClipboard(z,C,B){return o.clipboard.has(C,B)}async newWindowTab(){await this.a.open({context:s.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){o.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){o.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){o.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){o.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){o.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,C){this.D(z)?.updateTouchBar(C)}async notifyReady(z){this.D(z)?.setReady()}async relaunch(z,C){return this.f.relaunch(C)}async reload(z,C){const B=this.D(z);if(B){if((0,l.$Ti)(B.openedWorkspace)){const re=B.openedWorkspace.configPath;if(re.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(re))?.transient)return this.openWindow(B.id,{forceReuseWindow:!0})}return this.f.reload(B,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(z,C){return this.C(C?.targetWindowId,z)?.win?.close()}async quit(z){const C=this.a.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&C.win?C.win.close():this.f.quit()}async exit(z,C){await this.f.kill(C)}async resolveProxy(z,C){return this.D(z)?.win?.webContents?.session?.resolveProxy(C)}async loadCertificates(z){return(await new Promise((B,re)=>{V(["@vscode/proxy-agent"],B,re)}).then(Ae)).loadSystemCertificates({log:this.h})}findFreePort(z,C,B,re,_=1){return(0,p.$3g)(C,B,re,_)}async openDevTools(z,C){this.C(C?.targetWindowId,z)?.win?.webContents.openDevTools(C?.mode?{mode:C.mode,activate:C.activate}:void 0)}async toggleDevTools(z,C){this.C(C?.targetWindowId,z)?.win?.webContents.toggleDevTools()}async profileRenderer(z,C,B){const re=this.D(z);if(!re||!re.win)throw new Error;return await new O.$yec(re.win,C,this.h).inspect(B)}async windowsGetStringRegKey(z,C,B,re){if(!d.$i)return;const _=await new Promise((se,K)=>{V(["@vscode/windows-registry"],se,K)}).then(Ae);try{return _.GetStringRegKey(C,B,re)}catch{return}}C(z,C){return this.D(z)??this.F(z)??this.D(C)}D(z){if(typeof z=="number")return this.a.getWindowById(z)}F(z){if(typeof z!="number")return;const C=o.webContents.fromId(z);if(C)return this.b.getWindowByWebContents(C)}};e.$Bec=A,Se([R.$9h],A.prototype,"z",null),e.$Bec=A=Se([oe(0,s.$Odc),oe(1,L.$zec),oe(2,w.$Jdc),oe(3,r.$8dc),oe(4,v.$Ddc),oe(5,t.$$j),oe(6,n.$rk),oe(7,a.$Mdc),oe(8,f.$1dc)],A)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[306],le([0,1,14,27,8,23,31,2,13,4,116,37,185,96,136,58,25,5,75,84,28,85,34,64,57,29]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0,v=et(v);const f="issue.processExplorerWindowState";let k=class{static{l=this}static{this.a="#1E1E1E"}constructor(L,T,A,M,z,C,B,re,_,se,K){this.g=L,this.h=T,this.i=A,this.j=M,this.k=z,this.l=C,this.m=B,this.n=re,this.o=_,this.p=se,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){d.$$W.on("vscode:listProcesses",async L=>{const T=[];try{T.push({name:(0,g.localize)(0,null),rootProcess:await(0,h.$Qs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(M=>{(0,b.$Sm)(M)?T.push({name:M.hostName,rootProcess:M}):M.processes&&T.push({name:M.hostName,rootProcess:M.processes})})}catch(A){this.i.error(`Listing processes failed: ${A}`)}this.t(L,"vscode:listProcessesResponse",T)}),d.$$W.on("vscode:workbenchCommand",(L,T)=>{const{id:A,from:M,args:z}=T;let C;switch(M){case"processExplorer":C=this.f;break;default:throw new Error(`Unexpected command source: ${M}`)}C?.webContents.send("vscode:runAction",{id:A,from:M,args:z})}),d.$$W.on("vscode:closeProcessExplorer",L=>{this.d?.close()}),d.$$W.on("vscode:pidToNameRequest",async L=>{const T=await this.k.getMainDiagnostics(),A=[];for(const M of T.windows)A.push([M.pid,`window [${M.id}] (${M.title})`]);for(const{pid:M,name:z}of n.$iec.getAll())A.push([M,z]);this.t(L,"vscode:pidToNameResponse",A)})}async openReporter(L){if(this.b)this.b&&this.s(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const T=new P.$Uc,A=T.add(this.n.createIPCObjectUrl()),M=this.v(this.c,700,800);this.b=this.u(M,A,{backgroundColor:L.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:L.zoomLevel,alwaysOnTop:!1},"issue-reporter"),A.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:L,disableExtensions:!!this.h.disableExtensions,os:{type:(0,o.type)(),arch:(0,o.arch)(),release:(0,o.release)()},product:v.default}),this.b.loadURL(y.$Yg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,T.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,T.dispose())})}}async openProcessExplorer(L){if(!this.d&&(this.f=i.BrowserWindow.getFocusedWindow(),this.f)){const T=new P.$Uc,A=T.add(this.n.createIPCObjectUrl()),M=this.p.getItem(f,void 0),z=I(M)?M:this.v(this.f,800,500);this.d=this.u(z,A,{backgroundColor:L.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:L.zoomLevel,alwaysOnTop:!0},"process-explorer"),A.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:L,product:v.default}),this.d.loadURL(y.$Yg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,T.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,T.dispose())});const C=()=>{if(!this.d)return;const B=this.d.getSize(),re=this.d.getPosition();if(!B||!re)return;const _={width:B[0],height:B[1],x:re[0],y:re[1]};this.p.setItem(f,_)};this.d.on("moved",C),this.d.on("resized",C)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const L=await i.contentTracing.stopRecording(`${(0,R.$Mg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,L),buttons:[(0,g.localize)(5,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,L)}async getSystemStatus(){const[L,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(L,T)}async $getSystemInfo(){const[L,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(L,T)}async $getPerformanceInfo(){try{const[L,T]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(L,T)}catch(L){throw this.i.warn("issueService#getPerformanceInfo ",L.message),L}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(L){this.i.error(L)}}async $showConfirmCloseDialog(){if(this.b){const{response:L}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.b);L===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:L}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.b);return L===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");return L}async $sendReporterMenu(L,T){const A=this.issueReporterWindowCheck(),M="vscode:triggerReporterMenu",z=new D.$we;return A.sendWhenReady(M,z.token,{replyChannel:M,extensionId:L,extensionName:T}),await(0,E.$vh)(new Promise(B=>d.$$W.once(`vscode:triggerReporterMenuResponse:${L}`,(re,_)=>B(_))),5e3,()=>{this.i.error(`Error: Extension ${L} timed out waiting for menu response`),z.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(L){L.isMinimized()&&L.restore(),L.focus()}t(L,T,...A){L.sender.isDestroyed()||L.sender.send(T,...A)}u(L,T,A,M){const z=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:L.width,height:L.height,minWidth:300,minHeight:200,x:L.x,y:L.y,title:A.title,backgroundColor:A.backgroundColor||l.a,webPreferences:{preload:y.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${T.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.$6D)(A.zoomLevel),sandbox:!0},alwaysOnTop:A.alwaysOnTop,experimentalDarkMode:!0});return z.setMenuBarVisibility(!1),z}v(L,T,A){let M;const z=i.screen.getAllDisplays();if(z.length===1)M=z[0];else{if(c.$j){const re=i.screen.getCursorScreenPoint();M=i.screen.getDisplayNearestPoint(re)}!M&&L&&(M=i.screen.getDisplayMatching(L.getBounds())),M||(M=i.screen.getPrimaryDisplay()||z[0])}const C=M.bounds,B={width:T,height:A,x:C.x+C.width/2-T/2,y:C.y+C.height/2-A/2};return C.width>0&&C.height>0&&(B.x<C.x&&(B.x=C.x),B.y<C.y&&(B.y=C.y),B.x>C.x+C.width&&(B.x=C.x),B.y>C.y+C.height&&(B.y=C.y),B.width>C.width&&(B.width=C.width),B.height>C.height&&(B.height=C.height)),B}};e.$Cec=k,e.$Cec=k=l=Se([oe(1,p.$Ddc),oe(2,$.$$j),oe(3,b.$Rm),oe(4,u.$lec),oe(5,m.$Jdc),oe(6,w.$Aec),oe(7,r.$Ldc),oe(8,S.$rk),oe(9,t.$MQ),oe(10,s.$Odc)],k);function I(O){return typeof O!="object"||O===null?!1:"x"in O&&"y"in O&&"width"in O&&"height"in O}}),define(ce[307],le([0,1,23,18,25,20,5,75,28,55,24,50,106]),function(V,e,i,o,E,D,R,P,y,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;let b=class extends g.$2ec{constructor(m,p,$,w,v,S,r,t){super(m,p,w,v,S,t),this.e=$,this.u=r}s(m){return(0,g.$1ec)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(d.$9X.CheckingForUpdates(m)),this.i.request({url:this.a},i.CancellationToken.None).then(c.$7p).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(d.$9X.Idle(d.UpdateType.Archive))):this.d(d.$9X.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const $=m?p.message||p:void 0;this.d(d.$9X.Idle(d.UpdateType.Archive,$))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(d.$9X.Idle(d.UpdateType.Archive))}};e.$4ec=b,e.$4ec=b=Se([oe(0,D.$8dc),oe(1,o.$$i),oe(2,h.$0l),oe(3,E.$Ddc),oe(4,c.$1p),oe(5,R.$$j),oe(6,P.$Aec),oe(7,y.$rk)],b)}),define(ce[308],le([0,1,49,47,27,8,23,52,46,9,7,149,21,18,25,15,20,5,75,28,55,24,50,106]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0,o=Ae(o),c=Ae(c),g=Ae(g);async function a(k,I=1e3){for(;!k();)await(0,D.$Fh)(I)}let s;function l(){return typeof s>"u"&&(s=o.existsSync(c.$kc(c.$nc(process.execPath),"unins000.exe"))?t.UpdateType.Setup:t.UpdateType.Archive),s}let f=class extends n.$2ec{get cachePath(){const I=c.$kc((0,E.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return g.Promises.mkdir(I,{recursive:!0}).then(()=>I)}constructor(I,O,L,T,A,M,z,C,B){super(I,O,T,A,M,B),this.u=L,this.v=z,this.w=C,I.setRelaunchHandler(this)}handleRelaunch(I){return I?.addArgs||I?.removeArgs||this.state.type!==t.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$9X.Disabled(t.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(I){let O=`win32-${process.arch}`;return l()===t.UpdateType.Archive?O+="-archive":this.k.target==="user"&&(O+="-user"),(0,n.$1ec)(O,I,this.k)}t(I){this.a&&(this.d(t.$9X.CheckingForUpdates(I)),this.i.request({url:this.a},R.CancellationToken.None).then(S.$7p).then(O=>{const L=l();return!O||!O.url||!O.version||!O.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!I}),this.d(t.$9X.Idle(L)),Promise.resolve(null)):L===t.UpdateType.Archive?(this.d(t.$9X.AvailableForDownload(O)),Promise.resolve(null)):(this.d(t.$9X.Downloading),this.C(O.version).then(()=>this.B(O.version).then(T=>g.Promises.exists(T).then(A=>{if(A)return Promise.resolve(T);const M=`${T}.tmp`;return this.i.request({url:O.url},R.CancellationToken.None).then(z=>this.v.writeFile(h.URI.file(M),z.stream)).then(O.sha256hash?()=>(0,d.$4W)(M,O.sha256hash):()=>{}).then(()=>g.Promises.rename(M,T,!1)).then(()=>T)})).then(T=>{this.e={packagePath:T},this.d(t.$9X.Downloaded(O)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$9X.Ready(O))})))}).then(void 0,O=>{this.u.publicLog2("update:error",{messageHash:String((0,y.$sj)(String(O)))}),this.j.error(O);const L=I?O.message||O:void 0;this.d(t.$9X.Idle(l(),L))}))}async o(I){I.update.url&&this.w.openExternal(void 0,I.update.url),this.d(t.$9X.Idle(l()))}async B(I){const O=await this.cachePath;return c.$kc(O,`CodeSetup-${this.k.quality}-${I}.exe`)}async C(I=null){const O=I?M=>!new RegExp(`${this.k.quality}-${I}\\.exe$`).test(M):()=>!0,L=await this.cachePath,A=(await g.Promises.readdir(L)).filter(O).map(async M=>{try{await g.Promises.unlink(c.$kc(L,M))}catch{}});await Promise.all(A)}async p(){if(this.state.type!==t.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const I=this.state.update;this.d(t.$9X.Updating(I));const O=await this.cachePath;this.e.updateFilePath=c.$kc(O,`CodeSetup-${this.k.quality}-${I.version}.flag`),await g.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$9X.Idle(l()))});const T=`${this.k.win32MutexName}-ready`,A=await new Promise((M,z)=>{V(["@vscode/windows-mutex"],M,z)}).then(Ae);a(()=>A.isActive(T)).then(()=>this.d(t.$9X.Ready(I)))}r(){this.state.type!==t.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?o.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return l()}async _applySpecificUpdate(I){if(this.state.type!==t.StateType.Idle)return;const O=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(t.$9X.Downloading),this.e={packagePath:I},this.d(t.$9X.Downloaded(L)),O?this.k.target==="user"&&this.p():this.d(t.$9X.Ready(L))}};e.$6ec=f,Se([P.$9h],f.prototype,"cachePath",null),e.$6ec=f=Se([oe(0,p.$8dc),oe(1,b.$$i),oe(2,r.$0l),oe(3,u.$Ddc),oe(4,S.$1p),oe(5,$.$$j),oe(6,m.$$k),oe(7,w.$Aec),oe(8,v.$rk)],f)}),define(ce[137],le([0,1,14,8,23,53,3,2,13,70,4,7,196,27,69,18,58,25,68,15,20,5,28,85,284,87,24,111,74,57,29,30,60,51,41,34,59,71,22,6]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s,l,f,k,I,O,L,T,A,M,z,C,B,re,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=void 0;var se;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(se||(se={}));class K extends P.$Vc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(R.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(R.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(R.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(R.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(R.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(R.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const U=!(0,I.$1D)(this.r);if(h.$j&&U&&j.setSheetOffset((0,h.$J)((0,b.release)())?28:22),U&&(h.$i&&(0,I.$4D)(this.r)||h.$j)){const x=this.s.getItem(K.D);x?this.updateWindowControls({height:x}):this.updateWindowControls({height:I.$3D})}h.$i&&U&&j.hookWindowMessage(278,()=>{const[ae,G]=j.getPosition(),he=i.screen.getCursorScreenPoint(),ne=he.x-ae,Z=he.y-G;return!(ne>30&&Z>=0&&Z<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:ne,y:Z})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),h.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,U,x,ae){super(),this.r=j,this.s=U,this.t=x,this.u=ae,this.a=this.B(new R.$le),this.onDidClose=this.a.event,this.b=this.B(new R.$le),this.onDidMaximize=this.b.event,this.c=this.B(new R.$le),this.onDidUnmaximize=this.c.event,this.f=this.B(new R.$le),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new R.$le),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new R.$le),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,I.$4D)(this.r),this.G=void 0,this.H=void 0}w(j,U=i.screen.getAllDisplays().length>0){const x=this.r.getValue("window"),ae=h.$j&&x?.nativeTabs===!0;(h.$j||h.$i)&&U&&(!ae||i.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===A.WindowMode.Maximized||j.mode===A.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===A.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){h.$j?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return h.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){h.$j&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return h.$j?!!this.win?.isDocumentEdited():!!this.C}focus(j){h.$j&&j?.force&&i.app.focus({steal:!0});const U=this.win;U&&(U.isMinimized()&&U.restore(),U.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(h.$j)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const U=this.win;if(U){if(j.height&&this.s.setItem(ee.D,j.height),h.$i&&this.F)U.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(h.$j&&j.height!==void 0){const x=(j.height-15)/2;x?U.setWindowButtonPosition({x,y:x}):U.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,U){(0,I.$5D)(this.r)?this.J(j,U):this.M(j)}get isFullScreen(){if(h.$j&&typeof this.G=="boolean")return this.G;const j=this.win,U=j?.isFullScreen(),x=j?.isSimpleFullScreen();return!!(U||x)}J(j,U){const x=this.win;x?.isSimpleFullScreen()&&x?.setSimpleFullScreen(!1),this.L(j,U)}L(j,U){if(h.$j){this.G=j;const ae=this.H=new o.$2h;(async()=>{const G=await Promise.race([ae.p,(0,o.$Fh)(1e4).then(()=>!1)]);this.H===ae&&(this.G=void 0,this.H=void 0,!G&&j&&U&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const U=this.win;U?.isFullScreen()&&this.L(!1,!1),U?.setSimpleFullScreen(j),U?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$5dc=K;let ee=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Si)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,U,x,ae,G,he,ne,Z,F,N,W,q,Q,X,Y,ie,de,me,pe,Ie,ke){super(N,Ie,ae,U),this.fb=x,this.gb=G,this.hb=he,this.ib=ne,this.jb=Z,this.kb=F,this.lb=W,this.mb=q,this.nb=Q,this.ob=X,this.pb=Y,this.qb=ie,this.rb=de,this.sb=me,this.tb=pe,this.N=this.B(new R.$le),this.onWillLoad=this.N.event,this.O=this.B(new R.$le),this.onDidSignalReady=this.O.event,this.P=this.B(new R.$le),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=se.NONE;{const[Pe,De]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(O.$Pdc,this.U,{preload:y.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,De),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=se.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===se.READY}get whenClosedOrLoaded(){return new Promise(j=>{function U(){x.dispose(),ae.dispose(),j()}const x=this.onDidClose(()=>U()),ae=this.onWillLoad(()=>U())})}vb(){this.B(R.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(A.WindowError.UNRESPONSIVE))),this.B(R.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(U,x)=>x)(U=>this.yb(A.WindowError.PROCESS_GONE,{...U}))),this.B(R.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(U,x,ae)=>({exitCode:x,reason:ae}))(({exitCode:U,reason:x})=>this.yb(A.WindowError.LOAD,{reason:x,exitCode:U}))),this.B(R.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(U=>U.preventDefault())),this.B(R.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",E.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",E.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(U=>this.Bb(U))),this.B(this.mb.onDidDeleteUntitledWorkspace(U=>this.Ab(U)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(U,x)=>{const ae=await this.xb();x({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,ae)})})}xb(){return this.wb||(this.wb=(0,a.$iq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,U){switch(j){case A.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case A.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case A.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:U?.reason,code:U?.exitCode}),j){case A.WindowError.UNRESPONSIVE:case A.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===A.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:x,checkboxChecked:ae}=await this.pb.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null),(0,g.localize)(2,null)],message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null),checkboxLabel:this.S?.workspace?(0,g.localize)(5,null):void 0},this.m);if(x!==2){const G=x===0;await this.zb(G,ae)}}else if(j===A.WindowError.PROCESS_GONE){let x;U?x=(0,g.localize)(7,null,U.reason,U.exitCode??"<unknown>"):x=(0,g.localize)(6,null);const{response:ae,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,g.localize)(8,null):(0,g.localize)(9,null),(0,g.localize)(10,null)],message:x,detail:this.S?.workspace?(0,g.localize)(11,null):(0,g.localize)(12,null),checkboxLabel:this.S?.workspace?(0,g.localize)(13,null):void 0},this.m),he=ae===0;await this.zb(he,G)}break}}async zb(j,U){const x=this.S?.workspace;if(U&&x)try{const ae=this.kb.workspaceStorage(x);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.u.error(ae)}this.P.fire();try{if(j&&this.S){let ae,G;(0,L.$Oi)(x)?ae={folderUri:x.uri}:(0,L.$Ti)(x)?ae={workspaceUri:x.configPath}:G=!0,(0,re.$Pb)(await this.tb.open({context:O.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const U=this.Gb();U!==this.W&&(this.W=U,this.Hb(U))}if(!j||j.affectsConfiguration("http.proxy")){let U=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const x=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.Z||x!==this.$)){this.Z=U,this.$=x;const ae=U||"",G=x?`${x},<local>`:"<local>";this.u.trace(`Setting proxy to '${ae}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""}),typeof i.app.setProxy=="function"&&i.app.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(j){h.$j&&j.win&&this.m.addTabbedWindow(j.win)}load(j,U=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!U.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,U),this.ub===se.NONE?this.S=j:this.db=j,this.ub=se.NAVIGATING,this.m.loadURL(y.$Yg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const x=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new o.$Qh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:U.isReload?A.LoadReason.RELOAD:x?A.LoadReason.LOAD:A.LoadReason.INITIAL})}Cb(j,U){const x=(this.S??this.db)?.userEnv;if(x){const ae=(0,w.$Im)(x)&&!(0,w.$Im)(j.userEnv),G=this.isExtensionDevelopmentHost;(ae||G)&&(j.userEnv={...x,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(j["disable-extensions"]=U.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const U=Object.assign({},this.S);U.workspace=await this.Db(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&j&&(U.verbose=j.verbose,U.debugId=j.debugId,U.extensionEnvironment=j.extensionEnvironment,U["inspect-extensions"]=j["inspect-extensions"],U["inspect-brk-extensions"]=j["inspect-brk-extensions"],U["extensions-dir"]=j["extensions-dir"]),U.accessibilitySupport=i.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.gb.serialize(),U.continueOn=this.t.continueOn,U.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},U.logLevel=this.fb.getLogLevel(),U.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Ti)(j.workspace)){const U=j.workspace.configPath;if(U.scheme===y.Schemas.file&&!await this.ib.exists(U))return}else if((0,L.$Oi)(j.workspace)){const U=j.workspace.uri;if(U.scheme===y.Schemas.file&&!await this.ib.exists(U))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,A.$Bdc)();if(this.isFullScreen){let x;try{x=i.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,A.$Bdc)();return{mode:A.WindowMode.Fullscreen,display:x?x.id:void 0,width:this.U.width||ae.width,height:this.U.height||ae.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let U;if(!h.$j&&this.m.isMaximized()?U=A.WindowMode.Maximized:U=A.WindowMode.Normal,U===A.WindowMode.Maximized?j.mode=A.WindowMode.Maximized:j.mode=A.WindowMode.Normal,U===A.WindowMode.Normal||U===A.WindowMode.Maximized){let x;U===A.WindowMode.Normal?x=this.getBounds():x=this.m.getNormalBounds(),j.x=x.x,j.y=x.y,j.width=x.width,j.height=x.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let U=!1;if(j){this.ab=j.zoomLevel;try{const x=i.screen.getAllDisplays();U=x.length>1,j=O.WindowStateValidator.validateWindowState(this.u,j,x)}catch(x){this.u.warn(`Unexpected error validating window state: ${x}
${x.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,A.$Bdc)(),U]}getBounds(){const[j,U]=this.m.getPosition(),[x,ae]=this.m.getSize();return{x:j,y:U,width:x,height:ae}}I(j,U){super.I(j,U),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",E.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,I.$YD)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,U=!0){h.$j||(j==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,g.localize)(14,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const U=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!U),this.m.autoHideMenuBar=U;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,U,...x){this.isReady?this.send(j,...x):this.ready().then(()=>{U.isCancellationRequested||this.send(j,...x)})}send(j,...U){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...U)}catch(x){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,D.$pj)(x)}`)}}}updateTouchBar(j){h.$j&&this.Y.forEach((U,x)=>{const ae=j[x];U.segments=this.Mb(ae)})}Kb(){if(h.$j){for(let j=0;j<10;j++){const U=this.Lb();this.Y.push(U)}this.m.setTouchBar(new i.TouchBar({items:this.Y}))}}Lb(j=[]){const U=this.Mb(j),x=new i.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",E.CancellationToken.None,{id:x.segments[ae].id,from:"touchbar"})}});return x}Mb(j=[]){return j.map(x=>{let ae;x.icon&&!f.ThemeIcon.isThemeIcon(x.icon)&&x.icon?.dark?.scheme===y.Schemas.file&&(ae=i.nativeImage.createFromPath(d.URI.revive(x.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let G;return typeof x.title=="string"?G=x.title:G=x.title.value,{id:x.id,label:ae?void 0:G,icon:ae}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$6dc=ee,e.$6dc=ee=Se([oe(1,r.$$j),oe(2,B.$3dc),oe(3,$.$Ddc),oe(4,M.$qo),oe(5,C.$Rdc),oe(6,v.$$k),oe(7,s.$dec),oe(8,s.$bec),oe(9,m.$$i),oe(10,k.$Mdc),oe(11,T.$1dc),oe(12,u.$Idc),oe(13,l.$0l),oe(14,p.$Jdc),oe(15,S.$8dc),oe(16,t.$rk),oe(17,n.$Ldc),oe(18,O.$Odc),oe(19,z.$MQ),oe(20,_.$Di)],ee)}),define(ce[309],le([0,1,14,4,18,25,20,5,34,57,51,137]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;let g=class extends d.$5dc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(u,m,p,$,w,v){super($,w,m,p),this.O=u,this.P=v,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(u){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),u&&!this.N&&(this.N=!0,this.w({x:u.x,y:u.y,width:u.width,height:u.height,mode:u.show===!1?h.WindowMode.Maximized:h.WindowMode.Normal})))}Q(){if(this.m)return;const u=i.BrowserWindow.fromWebContents(this.O);u&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(u),u.setMenu(null),(o.$i||o.$k)&&(0,c.$1D)(this.r)&&u.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(u){return this.O.id===u.id}};e.$7dc=g,e.$7dc=g=Se([oe(1,D.$Ddc),oe(2,P.$$j),oe(3,E.$$i),oe(4,y.$MQ),oe(5,R.$8dc)],g)}),define(ce[310],le([0,1,14,3,2,13,37,309,6,5,51,29]),function(V,e,i,o,E,D,R,P,y,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;let g=class extends E.$Vc{constructor(u,m){super(),this.h=u,this.j=m,this.a=this.B(new o.$le),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new o.$le),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new o.$le),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new o.$le),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(u,m)=>{const p=this.getWindowByWebContents(m.webContents);if(p)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const $=new E.$Uc;$.add(o.Event.fromNodeEventEmitter(m.webContents,"did-create-window",(w,v)=>({browserWindow:w,details:v}))(({browserWindow:w,details:v})=>{const S=this.getWindowByWebContents(w.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(v.options))})),$.add(o.Event.fromNodeEventEmitter(m,"closed")(()=>$.dispose()))}}),R.$$W.handle("vscode:registerAuxiliaryWindow",async(u,m)=>{const p=this.getWindowByWebContents(u.sender);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=m),u.sender.id})}createWindow(u){return this.h.invokeFunction(d.$Pdc,this.n(u),{preload:D.$Yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(u){const m={},p=u.features.split(",");for(const w of p){const[v,S]=w.split("=");switch(v){case"width":m.width=parseInt(S,10);break;case"height":m.height=parseInt(S,10);break;case"left":m.x=parseInt(S,10);break;case"top":m.y=parseInt(S,10);break;case"window-maximized":m.mode=h.WindowMode.Maximized;break;case"window-fullscreen":m.mode=h.WindowMode.Fullscreen;break}}const $=d.WindowStateValidator.validateWindowState(this.j,m)??(0,h.$Cdc)();return this.j.trace("[aux window] using window state",$),$}registerWindow(u){const m=new E.$Uc,p=this.h.createInstance(P.$7dc,u);this.g.set(p.id,p),m.add((0,E.$Tc)(()=>this.g.delete(p.id))),m.add(p.onDidMaximize(()=>this.a.fire(p))),m.add(p.onDidUnmaximize(()=>this.b.fire(p))),m.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),m.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),m.add(p.onDidTriggerSystemContextMenu(({x:$,y:w})=>this.f.fire({window:p,x:$,y:w}))),o.Event.once(p.onDidClose)(()=>m.dispose())}getWindowByWebContents(u){const m=this.g.get(u.id);return m?.matches(u)?m:void 0}getFocusedWindow(){const u=i.BrowserWindow.getFocusedWindow();if(u)return this.getWindowByWebContents(u.webContents)}getLastActiveWindow(){return(0,d.$Qdc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Afc=g,e.$Afc=g=Se([oe(0,y.$Di),oe(1,c.$$j)],g)}),define(ce[88],le([0,1,14,22,8,3,48,2,13,4,19,7,21,199,6,20,5,63,87,103,30,60,32,58]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0,e.$Mec=(0,u.$Ei)("workspacesHistoryMainService");let s=class extends P.$Vc{static{a=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(f,k,I,O,L){super(),this.f=f,this.g=k,this.h=I,this.j=O,this.m=L,this.c=this.B(new D.$le),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new E.$Ch(800)),this.n()}n(){this.h.when(m.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace,remoteAuthority:f.window.remoteAuthority}])))}async addRecentlyOpened(f){let k=[],I=[];for(const L of f)if((0,v.$7gb)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(k,L.workspace)&&k.push(L);else if((0,v.$8gb)(L))this.y(k,L.folderUri)||k.push(L);else{const T=this.z(I,L.fileUri),A=L.fileUri.scheme===y.Schemas.file&&a.G.indexOf((0,h.$ch)(L.fileUri))>=0;!T&&!A&&(I.push(L),c.$i&&L.fileUri.scheme===y.Schemas.file&&i.app.addRecentDocument(L.fileUri.fsPath))}const O=await this.r({workspaces:k,files:I});k=O.workspaces,I=O.files,k.length>a.a&&(k.length=a.a),I.length>a.a&&(I.length=a.a),await this.t({workspaces:k,files:I}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(f){const k=T=>{const A=this.u(T);for(const M of f)if(h.$9g.isEqual(M,A))return!1;return!0},I=await this.getRecentlyOpened(),O=I.workspaces.filter(k),L=I.files.filter(k);(O.length!==I.workspaces.length||L.length!==I.files.length)&&(await this.t({files:L,workspaces:O}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(f){if(f?.confirm){const{response:k}=await this.m.showMessageBox({type:"warning",buttons:[(0,b.localize)(0,null),(0,b.localize)(1,null)],message:(0,b.localize)(2,null),detail:(0,b.localize)(3,null),cancelId:1});if(k!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(f){const k=new t.$Bc(L=>h.$9g.getComparisonKey(L));if(f?.workspaces)for(const L of f.workspaces)k.set(this.u(L),L);const I=new t.$Bc(L=>h.$9g.getComparisonKey(L));if(f?.files)for(const L of f.files)I.set(this.u(L),L);const O=await this.s();for(const L of O.workspaces){const T=k.get(this.u(L));T?T.label=T.label??L.label:k.set(this.u(L),L)}for(const L of O.files){const T=I.get(this.u(L));T?T.label=T.label??L.label:I.set(this.u(L),L)}return{workspaces:[...k.values()],files:[...I.values()]}}async s(){await this.j.whenReady;let f;const k=this.j.get(a.b,$.StorageScope.APPLICATION);if(typeof k=="string")try{f=JSON.parse(k)}catch(I){this.f.error("Unexpected error parsing opened paths list",I)}return(0,v.$bhb)(f,this.f)}async t(f){await this.j.whenReady,this.j.store(a.b,JSON.stringify((0,v.$chb)(f)),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}u(f){return(0,v.$8gb)(f)?f.folderUri:(0,v.$9gb)(f)?f.fileUri:f.workspace.configPath}w(f,k){return!!f.find(I=>(0,v.$7gb)(I)&&I.workspace.id===k.id)}y(f,k){return!!f.find(I=>(0,v.$8gb)(I)&&h.$9g.isEqual(I.folderUri,k))}z(f,k){return!!f.find(I=>h.$9g.isEqual(I.fileUri,k))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,b.localize)(4,null),description:(0,b.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const k=[];for(const L of i.app.getJumpListSettings().removedItems){const T=L.args;if(T){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(T);A&&k.push(d.URI.parse(A[2]))}}await this.removeRecentlyOpened(k);let I=!1;const O=(0,o.$Ib)((await this.getRecentlyOpened()).workspaces.slice(0,a.F).map(L=>{const T=(0,v.$7gb)(L)?L.workspace:L.folderUri,{title:A,description:M}=this.L(T,L.label);let z;return d.URI.isUri(T)?z=`--folder-uri "${T.toString()}"`:(I=!0,z=`--file-uri "${T.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:M.substr(0,255),program:process.execPath,args:z,iconPath:"explorer.exe",iconIndex:0}}));O.length>0&&f.push({type:"custom",name:I?(0,b.localize)(6,null):(0,b.localize)(7,null),items:O})}f.push({type:"recent"});try{const k=i.app.setJumpList(f);k&&k!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${k}`)}catch(k){this.f.warn("updateWindowsJumpList#setJumpList",k)}}L(f,k){if(k)return{title:(0,R.$1w)(k).name,description:k};if(d.URI.isUri(f))return{title:(0,h.$ch)(f),description:this.M(f)};if(this.g.isUntitledWorkspace(f))return{title:(0,b.localize)(8,null),description:""};let I=(0,h.$ch)(f.configPath);return I.endsWith(S.$1i)&&(I=I.substr(0,I.length-S.$1i.length-1)),{title:(0,b.localize)(9,null,I),description:this.M(f.configPath)}}M(f){return f.scheme==="file"?(0,R.$Sw)(f.fsPath):f.toString()}async N(){if(!c.$j)return;i.app.clearRecentDocuments();const f=await this.getRecentlyOpened(),k=[];let I=0;for(let L=0;L<f.workspaces.length&&I<a.C;L++){const T=this.u(f.workspaces[L]);if(T.scheme===y.Schemas.file){const A=(0,h.$6g)(T);await g.Promises.exists(A)&&(k.push(A),I++)}}const O=[];for(let L=0;L<f.files.length&&I<a.D;L++){const T=this.u(f.files[L]);if(T.scheme===y.Schemas.file){const A=(0,h.$6g)(T);if(a.G.includes((0,h.$ch)(T))||k.includes(A))continue;await g.Promises.exists(A)&&(O.push(A),I++)}}O.reverse().forEach(L=>i.app.addRecentDocument(L)),k.reverse().forEach(L=>i.app.addRecentDocument(L))}};e.$Nec=s,e.$Nec=s=a=Se([oe(0,p.$$j),oe(1,r.$1dc),oe(2,m.$8dc),oe(3,w.$dec),oe(4,n.$Jdc)],s)}),define(ce[311],le([0,1,14,8,23,48,4,7,187,83,18,25,20,5,236,75,28,34,24,50,57,29,88,2]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0,y=Ae(y);const s="menu";let l=class extends n.$Vc{static{a=this}static{this.a="lastKnownMenubarData"}constructor(I,O,L,T,A,M,z,C,B,re,_,se){super(),this.t=I,this.u=O,this.w=L,this.y=T,this.z=A,this.C=M,this.D=z,this.F=C,this.G=B,this.H=re,this.I=_,this.J=se,this.s=Object.create(null),this.h=new o.$Qh(()=>this.R(),0),this.j=new o.$Qh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(R.$j||(0,S.$1D)(O))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const I=this.D.getItem(a.a);I&&(I.menus&&(this.n=I.menus),I.keybindings&&(this.r=I.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,z,C)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:r.OpenContext.MENU,contextWindowId:z?.id})},this.s["workbench.action.newWindow"]=(M,z,C)=>this.w.openEmptyWindow({context:r.OpenContext.MENU,contextWindowId:z?.id}),this.s["workbench.action.files.openFileFolder"]=(M,z,C)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(M,z,C)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(M,z,C)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(C),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const I=this.I.youTubeUrl;I&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(I,"openYouTubeUrl"));const O=this.I.requestFeatureUrl;O&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(O,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const T=this.I.licenseUrl;T&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(R.$w){const M=T.indexOf("?")>0?"&":"?";this.ob(`${T}${M}lang=${R.$w}`,"openLicenseUrl")}else this.ob(T,"openLicenseUrl")});const A=this.I.privacyStatementUrl;A&&T&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(A,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(I=>this.S(I))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const I=this.u.getValue("window.enableMenuBarMnemonics");return typeof I!="boolean"?!0:I}get P(){if(!R.$j)return!1;const I=this.u.getValue("window.nativeTabs");return typeof I!="boolean"?!1:I}updateMenu(I,O){this.n=I.menus,this.r=I.keybindings,this.D.setItem(a.a,I),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(I){R.$j&&(I.oldCount===0&&I.newCount>0||I.oldCount>0&&I.newCount===0)&&(this.f=I.newCount===0,this.Q())}U(){if(!R.$j)return;const I=i.BrowserWindow.getFocusedWindow();this.g=!I||!!this.J.getWindowByWebContents(I.webContents),this.Q()}W(){const I=i.Menu.getApplicationMenu();if(I&&this.m.push(I),Object.keys(this.n).length===0){this.X(R.$j?new i.Menu:null);return}const O=new i.Menu;let L;if(R.$j){const A=new i.Menu;L=new i.MenuItem({label:this.I.nameShort,submenu:A}),this.Y(A),O.append(L)}if(R.$j&&!this.c){this.c=!0;const A=new i.Menu;A.append(new i.MenuItem({label:this.qb(y.localize(0,null)),click:()=>this.w.openEmptyWindow({context:r.OpenContext.DOCK})})),i.app.dock.setMenu(A)}if(this.$("File")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(1,null)),submenu:A});this.bb(A,"File"),O.append(M)}if(this.$("Edit")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(2,null)),submenu:A});this.bb(A,"Edit"),O.append(M)}if(this.$("Selection")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(3,null)),submenu:A});this.bb(A,"Selection"),O.append(M)}if(this.$("View")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(4,null)),submenu:A});this.bb(A,"View"),O.append(M)}if(this.$("Go")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(5,null)),submenu:A});this.bb(A,"Go"),O.append(M)}if(this.$("Run")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(6,null)),submenu:A});this.bb(A,"Run"),O.append(M)}if(this.$("Terminal")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(7,null)),submenu:A});this.bb(A,"Terminal"),O.append(M)}let T;if(this.$("Window")){const A=new i.Menu;T=new i.MenuItem({label:this.qb(y.localize(8,null)),submenu:A,role:"window"}),this.hb(A)}if(T&&O.append(T),this.$("Help")){const A=new i.Menu,M=new i.MenuItem({label:this.qb(y.localize(9,null)),submenu:A,role:"help"});this.bb(A,"Help"),O.append(M)}O.items&&O.items.length>0?this.X(O):this.X(null),this.j.schedule()}X(I){if(i.Menu.setApplicationMenu(I),I)for(const O of this.J.getWindows())O.win?.setMenu(null)}Y(I){const O=this.jb(y.localize(10,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let T;if(this.$("Preferences")){const se=new i.Menu;this.bb(se,"Preferences"),T=new i.MenuItem({label:this.qb(y.localize(11,null)),submenu:se})}const A=new i.Menu,M=new i.MenuItem({label:y.localize(12,null),role:"services",submenu:A}),z=new i.MenuItem({label:y.localize(13,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),C=new i.MenuItem({label:y.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new i.MenuItem({label:y.localize(15,null),role:"unhide"}),re=new i.MenuItem(this.nb("workbench.action.quit",{label:y.localize(16,null,this.I.nameLong),click:async(se,K,ee)=>{const H=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||H?.win?.isMinimized())&&await this.Z(ee)&&this.H.quit(void 0)}})),_=[O];_.push(...L),T&&_.push(f(),T),_.push(f(),M,f(),z,C,B,f(),re),_.forEach(se=>I.append(se))}async Z(I){if(this.w.getWindowCount()===0)return!0;const O=this.u.getValue("window.confirmBeforeClose");if(O==="always"||O==="keyboardOnly"&&this.fb(I)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[y.localize(17,null),y.localize(18,null)],message:y.localize(19,null)});return L===0}return!0}$(I){if(!R.$j&&!(0,S.$1D)(this.u))return!1;switch(I){case"File":case"Help":if(R.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[I];case"Window":if(R.$j)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[I]}}ab(I,O){O.forEach(L=>{if((0,u.$Jec)(L))I.append(f());else if((0,u.$Iec)(L)){const T=new i.Menu,A=new i.MenuItem({label:this.qb(L.label),submenu:T});this.ab(T,L.submenu.items),I.append(A)}else(0,u.$Kec)(L)?I.append(this.db(L)):(0,u.$Lec)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(I),R.$j?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?I.append(new i.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):I.append(this.jb(L.label,L.id,!1,L.checked)):I.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):I.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(I,O){this.n&&this.n[O]&&this.ab(I,this.n[O].items)}cb(I){const O=this.ib();O.length&&(O.forEach(L=>I.append(L)),I.append(f()))}db(I){const O=P.URI.revive(I.uri),L=I.id,T=L==="openRecentFile"?{fileUri:O}:L==="openRecentWorkspace"?{workspaceUri:O}:{folderUri:O};return new i.MenuItem(this.nb(L,{label:I.label,click:async(A,M,z)=>{const C=this.eb(z);(await this.w.open({context:r.OpenContext.MENU,cli:this.y.args,urisToOpen:[T],forceNewWindow:C,gotoLineMode:!1,remoteAuthority:I.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([O])}},!1))}eb(I){return!!(I&&(!R.$j&&(I.ctrlKey||I.shiftKey)||R.$j&&(I.metaKey||I.altKey)))}fb(I){return!!(I.triggeredByAccelerator||I.altKey||I.ctrlKey||I.metaKey||I.shiftKey)}gb(I,O,L){const T={label:this.qb(I),role:L,enabled:!0};return new i.MenuItem(this.mb(O,T))}hb(I){const O=new i.MenuItem({label:y.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new i.MenuItem({label:y.localize(21,null),role:"zoom",enabled:this.w.getWindowCount()>0}),T=new i.MenuItem({label:y.localize(22,null),role:"front",enabled:this.w.getWindowCount()>0}),A=this.jb(y.localize(23,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(f()),M.push(this.jb(y.localize(24,null),"workbench.action.newWindowTab")),M.push(this.gb(y.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(y.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(y.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(y.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[O,L,f(),A,...M,f(),T].forEach(z=>I.append(z))}ib(){switch(this.t.state.type){case v.StateType.Idle:return[new i.MenuItem({label:this.qb(y.localize(29,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case v.StateType.CheckingForUpdates:return[new i.MenuItem({label:y.localize(30,null),enabled:!1})];case v.StateType.AvailableForDownload:return[new i.MenuItem({label:this.qb(y.localize(31,null)),click:()=>{this.t.downloadUpdate()}})];case v.StateType.Downloading:return[new i.MenuItem({label:y.localize(32,null),enabled:!1})];case v.StateType.Downloaded:return R.$j?[]:[new i.MenuItem({label:this.qb(y.localize(33,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case v.StateType.Updating:return[new i.MenuItem({label:y.localize(34,null),enabled:!1})];case v.StateType.Ready:return[new i.MenuItem({label:this.qb(y.localize(35,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(I,O,L,T){const A=this.qb(I),M=typeof O=="function"?O:(_,se,K)=>{const ee=_?_.userSettingsLabel:null;let H=O;Array.isArray(O)&&(H=this.eb(K)?O[1]:O[0]),ee&&K.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:ee}):this.lb({type:"commandId",commandId:H})},z=typeof L=="boolean"?L:this.w.getWindowCount()>0,C=typeof T=="boolean"?T:!1,B={label:A,click:M,enabled:z};C&&(B.type="checkbox",B.checked=C);let re;return typeof O=="string"?re=O:Array.isArray(O)&&(re=O[0]),R.$j&&(re==="editor.action.clipboardCutAction"?B.role="cut":re==="editor.action.clipboardCopyAction"?B.role="copy":re==="editor.action.clipboardPasteAction"&&(B.role="paste"),re==="undo"?B.click=this.kb(M,{inDevTools:_=>_.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?B.click=this.kb(M,{inDevTools:_=>_.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(B.click=this.kb(M,{inDevTools:_=>_.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.mb(re,B))}kb(I,O){return(L,T,A)=>{const M=i.BrowserWindow.getFocusedWindow();if(!M)return O.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return O.inDevTools(M.webContents.devToolsWebContents);I(L,T||M,A)}}lb(I){let O=i.BrowserWindow.getFocusedWindow();if(O){const T=this.J.getWindowByWebContents(O.webContents);T&&(O=this.w.getWindowById(T.parentId)?.win??null)}if(!O){const T=this.w.getLastActiveWindow();T?.win?.isMinimized()&&(O=T.win)}const L=O?this.w.getWindowById(O.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",I),R.$j&&!this.y.isBuilt&&!L.isReady&&(I.type==="commandId"&&I.commandId==="workbench.action.toggleDevTools"||I.type!=="commandId"&&I.userSettingsLabel==="alt+cmd+i"))return!1;if(I.type==="commandId"){const T={id:I.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",E.CancellationToken.None,T)}else{const T={userSettingsLabel:I.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",E.CancellationToken.None,T)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",I),!1}mb(I,O){const L=typeof I=="string"?this.r[I]:void 0;if(L?.label){if(L.isNative!==!1)O.accelerator=L.label,O.userSettingsLabel=L.userSettingsLabel;else if(typeof O.label=="string"){const T=O.label.indexOf("[");T>=0?O.label=`${O.label.substr(0,T)} [${L.label}]`:O.label=`${O.label} [${L.label}]`}}else O.accelerator=void 0;return O}nb(I,O,L=!O.accelerator){L&&(O=this.mb(I,O));const T=O.click;return O.click=(A,M,z)=>{this.pb(I),T?.(A,M,z)},O}ob(I,O){this.H.openExternal(void 0,I),this.pb(O)}pb(I){this.z.publicLog2("workbenchActionExecuted",{id:I,from:s})}qb(I){return(0,D.$Xw)(I,!this.O)}};e.$Oec=l,e.$Oec=l=a=Se([oe(0,v.$0X),oe(1,h.$$i),oe(2,r.$Odc),oe(3,d.$Ddc),oe(4,w.$0l),oe(5,t.$Mec),oe(6,$.$MQ),oe(7,g.$8dc),oe(8,b.$$j),oe(9,m.$Aec),oe(10,p.$rk),oe(11,c.$zec)],l);function f(){return new i.MenuItem({type:"separator"})}}),define(ce[312],le([0,1,6,20,5,311,2]),function(V,e,i,o,E,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0,e.$Pec=(0,i.$Ei)("menubarMainService");let P=class extends R.$Vc{constructor(c,h,d){super(),this.b=c,this.c=h,this.f=d,this.a=this.g()}async g(){return await this.c.when(o.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$Oec))}async updateMenubar(c,h){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(h,c)}};e.$Qec=P,e.$Qec=P=Se([oe(0,i.$Di),oe(1,o.$8dc),oe(2,E.$$j)],P)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[313],le([0,1,14,21,107,27,22,23,39,3,31,48,2,13,9,70,4,36,19,12,7,197,69,18,58,25,15,6,20,5,84,85,72,34,57,137,29,135,305,30,104,88,60,51,74,41,59,71,83]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s,l,f,k,I,O,L,T,A,M,z,C,B,re,_,se,K,ee,H,j,U,x,ae,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0,O=et(O);function he(F){return(0,_.$Ti)(F?.workspace)}function ne(F){return(0,_.$Oi)(F?.workspace)}let Z=class extends g.$Vc{constructor(N,W,q,Q,X,Y,ie,de,me,pe,Ie,ke,Pe,De,$e,J,ue,fe,be,Re,We){super(),this.s=N,this.t=W,this.u=q,this.w=Q,this.z=X,this.C=Y,this.D=ie,this.F=de,this.G=me,this.H=pe,this.I=Ie,this.J=ke,this.L=Pe,this.M=De,this.N=$e,this.O=J,this.P=ue,this.Q=fe,this.R=be,this.S=Re,this.U=We,this.a=this.B(new c.$le),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$le),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$le),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$le),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$le),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$le),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$le),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$le),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new re.$bfc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(N=>this.b.fire(N.window))),this.B(this.onDidSignalReadyWindow(N=>{if(N.config?.extensionDevelopmentPath||N.config?.extensionTestsPath){const W=new g.$Uc;if(W.add(c.Event.any(N.onDidClose,N.onDidDestroy)(()=>W.dispose())),N.config.extensionDevelopmentPath)for(const q of N.config.extensionDevelopmentPath)W.add(this.R.addValidFileRoot(q));N.config.extensionTestsPath&&W.add(this.R.addValidFileRoot(N.config.extensionTestsPath))}}))}openEmptyWindow(N,W){const q=this.G.args,Q=W?.remoteAuthority||void 0,X=!0,Y=W?.forceReuseWindow,ie=!Y;return this.open({...N,cli:q,forceEmpty:X,forceNewWindow:ie,forceReuseWindow:Y,remoteAuthority:Q,forceTempProfile:W?.forceTempProfile,forceProfile:W?.forceProfile})}openExistingWindow(N,W){N.focus(),this.X(W,[N])}async open(N){this.z.trace("windowsManager#open"),N.addMode&&(N.initialStartup||!this.getLastActiveWindow())&&(N.addMode=!1);const W=[],q=[],Q=[],X=[],Y=[];let ie,de=0;const me=await this.db(N);this.z.trace("windowsManager#open pathsToOpen",me);for(const De of me)ne(De)?N.addMode?W.push(De):q.push(De):he(De)?Q.push(De):De.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),ie.filesToOpenOrCreate.push(De)):De.backupPath?Y.push({backupFolder:(0,u.$oc)(De.backupPath),remoteAuthority:De.remoteAuthority}):de++;N.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),N.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&N.waitMarkerFileURI&&(ie.filesToWait={paths:(0,R.$Ib)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:N.waitMarkerFileURI}),N.initialStartup?(X.push(...this.N.getUntitledWorkspaces()),Q.push(...X),Y.push(...this.J.getEmptyWindowBackups())):Y.length=0;const{windows:pe,filesOpenedInWindow:Ie}=await this.Y(N,Q,q,Y,de,ie,W);if(this.z.trace(`windowsManager#open used window count ${pe.length} (workspacesToOpen: ${Q.length}, foldersToOpen: ${q.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${de})`),pe.length>1)if(Ie)Ie.focus();else{const De=this.r.state.lastActiveWindow&&!N.forceEmpty&&!N.cli._.length&&!N.cli["file-uri"]&&!N.cli["folder-uri"]&&!(N.urisToOpen&&N.urisToOpen.length);let $e=!0,J=!0;if(De){const ue=pe.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),$e=!1,J=!1)}if($e)for(let ue=pe.length-1;ue>=0;ue--){const fe=pe[ue];if(!(fe.openedWorkspace&&X.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&Y.some(be=>fe.backupPath&&be.backupFolder===(0,u.$oc)(fe.backupPath)))){fe.focus(),J=!1;break}}J&&pe[pe.length-1].focus()}const ke=ie&&ie.filesToDiff.length>0,Pe=ie&&ie.filesToMerge.length>0;if(!pe.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Pe&&!N.noRecentEntry){const De=[];for(const $e of me)he($e)&&!$e.transient?De.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):ne($e)?De.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&De.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(De)}return this.X(N,pe),pe}X(N,W){const q=N.waitMarkerFileURI;N.context===C.OpenContext.CLI&&q&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.Q.del(q)}catch{}})()}async Y(N,W,q,Q,X,Y,ie){const de=[];let me;function pe(ue,fe){de.push(ue),fe&&(me=ue,Y=void 0)}let{openFolderInNewWindow:Ie,openFilesInNewWindow:ke}=this.pb(N);if(!N.initialStartup&&ie.length>0){const ue=ie[0].remoteAuthority,fe=this.vb(ue);fe&&pe(this.ab(fe,ie.map(be=>be.workspace.uri)))}const Pe=q.length+W.length+Q.length;if(Y&&Pe===0){const ue=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0]||Y.filesToMerge[3],fe=this.getWindows().filter(Re=>Y&&(0,w.$kh)(Re.remoteAuthority,Y.remoteAuthority));let be;ue?.fileUri&&!ke&&((N.context===C.OpenContext.DESKTOP||N.context===C.OpenContext.CLI||N.context===C.OpenContext.DOCK)&&(be=await(0,B.$Tdc)(fe,ue.fileUri,async Re=>Re.configPath.scheme===b.Schemas.file?this.N.resolveLocalWorkspace(Re.configPath):void 0)),be||(be=this.wb(fe))),be?(0,_.$Ti)(be.openedWorkspace)?W.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,_.$Oi)(be.openedWorkspace)?q.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):pe(this.Z(N,be,Y),!0):pe(await this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:N.forceNewTabbedWindow,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile}),!0)}const De=(0,R.$Nb)(W,ue=>ue.workspace.id);if(De.length>0){const ue=(0,R.$Ib)(De.map(fe=>(0,B.$Udc)(this.getWindows(),fe.workspace.configPath)));if(ue.length>0){const fe=ue[0],be=(0,w.$kh)(Y?.remoteAuthority,fe.remoteAuthority)?Y:void 0;pe(this.Z(N,fe,be),!!be),Ie=!0}for(const fe of De){if(ue.some(We=>We.openedWorkspace&&We.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Re=(0,w.$kh)(Y?.remoteAuthority,be)?Y:void 0;pe(await this.cb(N,fe,Ie,Re),!!Re),Ie=!0}}const $e=(0,R.$Nb)(q,ue=>w.$9g.getComparisonKey(ue.workspace.uri));if($e.length>0){const ue=(0,R.$Ib)($e.map(fe=>(0,B.$Udc)(this.getWindows(),fe.workspace.uri)));if(ue.length>0){const fe=ue[0],be=(0,w.$kh)(Y?.remoteAuthority,fe.remoteAuthority)?Y:void 0;pe(this.Z(N,fe,be),!!be),Ie=!0}for(const fe of $e){if(ue.some(We=>(0,_.$Oi)(We.openedWorkspace)&&w.$9g.isEqual(We.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Re=(0,w.$kh)(Y?.remoteAuthority,be)?Y:void 0;pe(await this.cb(N,fe,Ie,Re),!!Re),Ie=!0}}const J=(0,R.$Nb)(Q,ue=>ue.backupFolder);if(J.length>0)for(const ue of J){const fe=ue.remoteAuthority,be=(0,w.$kh)(Y?.remoteAuthority,fe)?Y:void 0;pe(await this.bb(N,!0,fe,be,ue),!!be),Ie=!0}if(de.length===0||Y){Y&&!X&&X++;const ue=Y?Y.remoteAuthority:N.remoteAuthority;for(let fe=0;fe<X;fe++)pe(await this.bb(N,Ie,ue,Y),!!Y),Ie=!0}return{windows:(0,R.$Nb)(de),filesOpenedInWindow:me}}Z(N,W,q){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:q}),this.$(W);const Q={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToMerge:q?.filesToMerge,filesToWait:q?.filesToWait,termProgram:N?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",P.CancellationToken.None,Q),W}$(N){let W=N;const q=i.BrowserWindow.getFocusedWindow();if(q&&q.id!==N.id){const Q=this.U.getWindowByWebContents(q.webContents);Q&&Q.parentId===N.id&&(W=Q)}W.focus()}ab(N,W){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),N.focus();const q={foldersToAdd:W};return N.sendWhenReady("vscode:addFolders",P.CancellationToken.None,q),N}bb(N,W,q,Q,X){this.z.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:q,filesToOpen:Q,forceNewWindow:W});let Y;return!W&&typeof N.contextWindowId=="number"&&(Y=this.getWindowById(N.contextWindowId)),this.qb({userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:q,forceNewWindow:W,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:Q,windowToUse:Y,emptyWindowBackupInfo:X,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}cb(N,W,q,Q,X){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:Q}),!q&&!X&&typeof N.contextWindowId=="number"&&(X=this.getWindowById(N.contextWindowId)),this.qb({workspace:W.workspace,userEnv:N.userEnv,cli:N.cli,initialStartup:N.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:N.forceNewTabbedWindow,filesToOpen:Q,windowToUse:X,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile})}async db(N){let W,q=!1,Q=!1;if(N.urisToOpen&&N.urisToOpen.length>0?(W=await this.eb(N),q=!0):N.forceEmpty?W=[Object.create(null)]:N.cli._.length||N.cli["folder-uri"]||N.cli["file-uri"]?(W=await this.fb(N.cli),W.length===0&&W.push(Object.create(null)),q=!0):(W=await this.hb(),W.length===0&&W.push(Object.create(null)),Q=!0),!N.addMode&&q){const X=W.filter(Y=>ne(Y));if(X.length>1){const Y=X[0].remoteAuthority;if(X.every(ie=>(0,w.$kh)(ie.remoteAuthority,Y))){const ie=await this.N.createUntitledWorkspace(X.map(de=>({uri:de.workspace.uri})));W.push({workspace:ie,remoteAuthority:Y}),W=W.filter(de=>!ne(de))}}}if(N.initialStartup&&!Q&&this.L.getValue("window")?.restoreWindows==="preserve"){const X=await this.hb();W.unshift(...X.filter(Y=>he(Y)||ne(Y)||Y.backupPath))}return W}async eb(N){const W={gotoLineMode:N.gotoLineMode,remoteAuthority:N.remoteAuthority},q=await Promise.all((0,R.$Ib)(N.urisToOpen||[]).map(async Q=>{const X=await this.jb(Q,W);if(X)return X.label=Q.label,X;const Y=this.lb(Q);this.P.showMessageBox({type:"info",buttons:[(0,r.localize)(0,null)],message:Y.scheme===b.Schemas.file?(0,r.localize)(1,null):(0,r.localize)(2,null),detail:Y.scheme===b.Schemas.file?(0,r.localize)(3,null,(0,d.$Rw)(Y,{os:p.OS,tildify:this.G})):(0,r.localize)(4,null,Y.toString(!0))},i.BrowserWindow.getFocusedWindow()??void 0)}));return(0,R.$Ib)(q)}async fb(N){const W=[],q={ignoreFileNotFound:!0,gotoLineMode:N.goto,remoteAuthority:N.remote||void 0,forceOpenWorkspaceAsFile:N.diff&&N._.length===2||N.merge&&N._.length===4},Q=N["folder-uri"];if(Q){const ie=await Promise.all(Q.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},q)}));W.push(...(0,R.$Ib)(ie))}const X=N["file-uri"];if(X){const ie=await Promise.all(X.map(de=>{const me=this.gb(de);if(me)return this.jb((0,_.$0i)(de)?{workspaceUri:me}:{fileUri:me},q)}));W.push(...(0,R.$Ib)(ie))}const Y=await Promise.all(N._.map(ie=>q.remoteAuthority?this.ob(ie,q):this.mb(ie,q)));return W.push(...(0,R.$Ib)(Y)),W}gb(N){try{const W=S.URI.parse(N);if(!W.scheme){this.z.error(`Invalid URI input string, scheme missing: ${N}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.z.error(`Invalid URI input string: ${N}, ${W.message}`)}}async hb(){const N=this.ib();switch(N){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];N!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const q=await Promise.all(W.map(async Q=>{if(Q.workspace){const X=await this.jb({workspaceUri:Q.workspace.configPath},{remoteAuthority:Q.remoteAuthority,rejectTransientWorkspaces:!0});if(he(X))return X}else if(Q.folderUri){const X=await this.jb({folderUri:Q.folderUri},{remoteAuthority:Q.remoteAuthority});if(ne(X))return X}else if(N!=="folders"&&Q.backupPath)return{backupPath:Q.backupPath,remoteAuthority:Q.remoteAuthority}}));return(0,R.$Ib)(q)}}}ib(){let N;return this.I.wasRestarted?N="all":(N=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(N)||(N="all")),N}async jb(N,W=Object.create(null)){const q=this.lb(N);return q.scheme===b.Schemas.file?((0,M.$XD)(N)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.mb(q.fsPath,W)):this.kb(N,W)}kb(N,W){let q=this.lb(N);const Q=(0,T.$fn)(q)||W.remoteAuthority;if(q=(0,w.$mh)((0,w.$gh)(q)),(0,M.$XD)(N)){if(W.gotoLineMode){const{path:X,line:Y,column:ie}=(0,h.$Lg)(q.path);return{fileUri:q.with({path:X}),options:{selection:Y?{startLineNumber:Y,startColumn:ie||1}:void 0},remoteAuthority:Q}}return{fileUri:q,remoteAuthority:Q}}else if((0,M.$VD)(N))return{workspace:(0,se.$Xdc)(q),remoteAuthority:Q};return{workspace:(0,se.$Ydc)(q),remoteAuthority:Q}}lb(N){return(0,M.$VD)(N)?N.workspaceUri:(0,M.$WD)(N)?N.folderUri:N.fileUri}async mb(N,W,q){let Q,X;W.gotoLineMode&&({path:N,line:Q,column:X}=(0,h.$Lg)(N)),N=(0,h.$Fg)((0,u.$ic)(N),(0,$.cwd)());try{const Y=await o.Promises.stat(N);if(Y.isFile()){if(!W.forceOpenWorkspaceAsFile){const ie=await this.N.resolveLocalWorkspace(S.URI.file(N));if(ie)return ie.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:l.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:S.URI.file(N),type:l.FileType.File,exists:!0,options:{selection:Q?{startLineNumber:Q,startColumn:X||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,se.$Ydc)(S.URI.file(N),Y),type:l.FileType.Directory,exists:!0};if(!p.$i&&N==="/dev/null")return{fileUri:S.URI.file(N),type:l.FileType.File,exists:!0}}}catch(Y){if(Y.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!q)return this.nb(N,W);const ie=S.URI.file(N);if(this.M.removeRecentlyOpened([ie]),W.ignoreFileNotFound)return{fileUri:ie,type:l.FileType.File,exists:!1}}}async nb(N,W){const q=S.URI.file(N),{response:Q,checkboxChecked:X}=await this.P.showMessageBox({type:"warning",buttons:[(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],message:(0,r.localize)(8,null,q.authority),detail:(0,r.localize)(9,null,(0,d.$Rw)(q,{os:p.OS,tildify:this.G})),checkboxLabel:(0,r.localize)(10,null,q.authority),cancelId:1});if(Q===0){if((0,E.addUNCHostToAllowlist)(q.authority),X){const Y={channel:"vscode:configureAllowedUNCHost",args:q.authority};this.sendToFocused(Y.channel,Y.args),this.sendToOpeningWindow(Y.channel,Y.args)}return this.mb(N,W,!0)}if(Q===2)return i.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(N,W)}ob(N,W){const q=N.charCodeAt(0),Q=W.remoteAuthority;let X,Y;W.gotoLineMode&&({path:N,line:X,column:Y}=(0,h.$Lg)(N)),q!==y.CharCode.Slash&&((0,h.$Eg)(q)&&N.charCodeAt(N.charCodeAt(1))===y.CharCode.Colon&&(N=(0,h.$xg)(N)),N=`/${N}`);const ie=S.URI.from({scheme:b.Schemas.vscodeRemote,authority:Q,path:N});if(N.charCodeAt(N.length-1)!==y.CharCode.Slash){if((0,_.$0i)(N))return W.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Y||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,se.$Xdc)(ie),remoteAuthority:Q};if(W.gotoLineMode||u.$hc.basename(N).indexOf(".")!==-1)return{fileUri:ie,options:{selection:X?{startLineNumber:X,startColumn:Y||1}:void 0},remoteAuthority:Q}}return{workspace:(0,se.$Ydc)(ie),remoteAuthority:Q}}pb(N){const W=this.L.getValue("window"),q=W?.openFoldersInNewWindow||"default",Q=W?.openFilesInNewWindow||"off";let X=(N.preferNewWindow||N.forceNewWindow)&&!N.forceReuseWindow;!N.forceNewWindow&&!N.forceReuseWindow&&(q==="on"||q==="off")&&(X=q==="on");let Y=!1;return N.forceNewWindow||N.forceReuseWindow?Y=!!N.forceNewWindow&&!N.forceReuseWindow:(p.$j?N.context===C.OpenContext.DOCK&&(Y=!0):N.context!==C.OpenContext.DIALOG&&N.context!==C.OpenContext.MENU&&!(N.userEnv&&N.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!N.cli.extensionDevelopmentPath&&(Q==="on"||Q==="off")&&(Y=Q==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:Y}}async openExtensionDevelopmentHostWindow(N,W){const q=(0,B.$Vdc)(this.getWindows(),N);if(q)return this.I.reload(q,W.cli),q.focus(),[q];let Q=W.cli["folder-uri"]||[],X=W.cli["file-uri"]||[],Y=W.cli._;if(!Y.length&&!Q.length&&!X.length&&!W.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,pe=me?.workspace??me?.folderUri;pe&&(S.URI.isUri(pe)?pe.scheme===b.Schemas.file?Y=[pe.fsPath]:Q=[pe.toString()]:pe.configPath.scheme===b.Schemas.file?Y=[(0,w.$6g)(pe.configPath)]:X=[pe.configPath.toString()])}let ie=W.remoteAuthority;for(const me of N)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const pe=S.URI.parse(me),Ie=(0,T.$fn)(pe);Ie&&(ie?(0,w.$kh)(Ie,ie)||this.z.error("more than one extension development path authority"):ie=Ie)}Y=Y.filter(me=>{const pe=S.URI.file(me);return(0,B.$Udc)(this.getWindows(),pe)?!1:(0,w.$kh)((0,T.$fn)(pe),ie)}),Q=Q.filter(me=>{const pe=this.gb(me);return pe&&(0,B.$Udc)(this.getWindows(),pe)?!1:pe?(0,w.$kh)((0,T.$fn)(pe),ie):!1}),X=X.filter(me=>{const pe=this.gb(me);return pe&&(0,B.$Udc)(this.getWindows(),pe)?!1:pe?(0,w.$kh)((0,T.$fn)(pe),ie):!1}),W.cli._=Y,W.cli["folder-uri"]=Q,W.cli["file-uri"]=X;const de={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!Y.length&&!Q.length&&!X.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:ie,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(de)}async qb(N){const W=this.L.getValue("window"),q=this.getLastActiveWindow(),X=(W?.newWindowProfile?this.H.profiles.find(de=>de.name===W.newWindowProfile):void 0)??q?.profile??this.H.defaultProfile;let Y;!N.forceNewWindow&&!N.forceNewTabbedWindow&&(Y=N.windowToUse||q,Y&&Y.focus());const ie={...this.G.args,...N.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:N.emptyWindowBackupInfo?(0,u.$kc)(this.G.backupHome,N.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:X},homeDir:this.G.userHome.with({scheme:b.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:b.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:N.remoteAuthority,workspace:N.workspace,userEnv:{...this.w,...N.userEnv},filesToOpenOrCreate:N.filesToOpen?.filesToOpenOrCreate,filesToDiff:N.filesToOpen?.filesToDiff,filesToMerge:N.filesToOpen?.filesToMerge,filesToWait:N.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:b.Schemas.file}).fsPath,product:O.default,isInitialStartup:N.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:i.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(Y){const de=Y.config;!ie.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(ie.extensionDevelopmentPath=de.extensionDevelopmentPath,ie.extensionDevelopmentKind=de.extensionDevelopmentKind,ie["enable-proposed-api"]=de["enable-proposed-api"],ie.verbose=de.verbose,ie["inspect-extensions"]=de["inspect-extensions"],ie["inspect-brk-extensions"]=de["inspect-brk-extensions"],ie.debugId=de.debugId,ie.extensionEnvironment=de.extensionEnvironment,ie["extensions-dir"]=de["extensions-dir"],ie["disable-extensions"]=de["disable-extensions"]),ie.loggers={global:ie.loggers.global,window:de?.loggers.window??ie.loggers.window}}else{const de=this.r.getNewWindowState(ie);(0,m.mark)("code/willCreateCodeWindow");const me=Y=this.O.createInstance(z.$6dc,{state:de,extensionDevelopmentPath:ie.extensionDevelopmentPath,isExtensionTestHost:!!ie.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),N.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const pe=new g.$Uc;pe.add(me.onDidSignalReady(()=>this.b.fire(me))),pe.add(c.Event.once(me.onDidClose)(()=>this.tb(me,pe))),pe.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),pe.add(me.onDidMaximize(()=>this.g.fire(me))),pe.add(me.onDidUnmaximize(()=>this.h.fire(me))),pe.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),pe.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),pe.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const Ie=(0,v.$pg)(me.win?.webContents);Ie.removeAllListeners("devtools-reload-page"),pe.add(c.Event.fromNodeEventEmitter(Ie,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return ie.windowId=Y.id,Y.isReady?this.I.unload(Y,H.UnloadReason.LOAD).then(async de=>{de||await this.rb(Y,ie,N,X)}):await this.rb(Y,ie,N,X),Y}async rb(N,W,q,Q){if(W.extensionDevelopmentPath||((0,_.$Ti)(W.workspace)?W.backupPath=this.J.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,_.$Oi)(W.workspace)?W.backupPath=this.J.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.J.registerEmptyWindowBackup({backupFolder:q.emptyWindowBackupInfo?.backupFolder??(0,se.$Zdc)().id,remoteAuthority:W.remoteAuthority})),this.H.isEnabled()){const X=W.workspace??(0,_.$Si)(W.backupPath,!1),Y=this.sb(q,X,Q),ie=Y instanceof Promise?await Y:Y;W.profiles.profile=ie,W.extensionDevelopmentPath||await this.H.setProfileForWorkspace(X,ie)}N.load(W)}sb(N,W,q){return N.forceProfile?this.H.profiles.find(Q=>Q.name===N.forceProfile)??this.H.createNamedProfile(N.forceProfile):N.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(W)??q}tb(N,W){this.n.delete(N.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}ub(N){this.n.delete(N.id),this.c.fire(N)}getFocusedWindow(){const N=i.BrowserWindow.getFocusedWindow();if(N)return this.getWindowById(N.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(N){return this.wb(this.getWindows().filter(W=>(0,w.$kh)(W.remoteAuthority,N)))}wb(N){return(0,C.$Qdc)(N)}sendToFocused(N,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(N,P.CancellationToken.None,...W)}sendToOpeningWindow(N,...W){this.B(c.Event.once(this.onDidSignalReadyWindow)(q=>{q.sendWhenReady(N,P.CancellationToken.None,...W)}))}sendToAll(N,W,q){for(const Q of this.getWindows())q&&q.indexOf(Q.id)>=0||Q.sendWhenReady(N,P.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(N){return this.n.get(N)}getWindowByWebContents(N){const W=i.BrowserWindow.fromWebContents(N);if(!W)return;const q=this.getWindowById(W.id);return q?.matches(N)?q:void 0}};e.$efc=Z,e.$efc=Z=Se([oe(4,I.$$j),oe(5,ae.$3dc),oe(6,A.$MQ),oe(7,U.$qo),oe(8,s.$Ddc),oe(9,x.$Rdc),oe(10,k.$8dc),oe(11,t.$Idc),oe(12,n.$$i),oe(13,K.$Mec),oe(14,ee.$1dc),oe(15,f.$Di),oe(16,a.$Jdc),oe(17,l.$$k),oe(18,L.$Ldc),oe(19,j.$Mdc),oe(20,G.$zec)],Z)}),define(ce[314],le([0,1,69,29,88,60]),function(V,e,i,o,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;let R=class{constructor(y,c,h,d){this.a=y,this.b=c,this.c=h,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(y,c){const h=this.b.getWindowById(y);if(h)return this.a.enterWorkspace(h,this.b.getWindows(),c)}createUntitledWorkspace(y,c,h){return this.a.createUntitledWorkspace(c,h)}deleteUntitledWorkspace(y,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(y,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(y){return this.c.getRecentlyOpened()}addRecentlyOpened(y,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(y,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(y){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$gfc=R,e.$gfc=R=Se([oe(0,D.$1dc),oe(1,o.$Odc),oe(2,E.$Mec),oe(3,i.$Idc)],R)}),define(ce[315],le([0,1,14,107,37,27,17,53,16,31,3,40,48,2,13,9,4,12,7,33,163,44,164,119,296,167,69,289,18,297,96,136,58,97,225,25,68,101,213,300,215,216,217,15,229,99,82,6,98,224,306,290,298,20,5,312,75,28,72,301,102,34,279,87,129,24,256,257,56,50,269,294,307,295,308,133,271,272,273,276,304,57,29,313,278,30,103,88,314,60,41,238,59,249,55,86,134,281,299,286,8,259,280,233,71,303,275,22,73,302,267,244,65,83,310,77]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s,l,f,k,I,O,L,T,A,M,z,C,B,re,_,se,K,ee,H,j,U,x,ae,G,he,ne,Z,F,N,W,q,Q,X,Y,ie,de,me,pe,Ie,ke,Pe,De,$e,J,ue,fe,be,Re,We,Fe,Oe,Be,xe,Je,qe,Qe,Xe,Ke,Ce,te,ge,we,ye,Me,Ue,Ze,lt,rt,at,tt,ut,ct,ft,gt,Rt,$t,wt,Ot,Tt,Lt,pt,jt,Et,dt,Mt,Ft,bt,Nt,St,Ct,kt){"use strict";var yt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;let vt=class extends b.$Vc{static{yt=this}static{this.a={[u.Schemas.file]:"security.promptForLocalFileProtocolHandling",[u.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Te,Le,je,ve,Ee,He,Ve,Ge,Ne,Ye,ze,_e){super(),this.g=Te,this.h=Le,this.j=je,this.m=ve,this.n=Ee,this.s=He,this.t=Ve,this.u=Ge,this.w=Ne,this.y=Ye,this.z=ze,this.C=_e,this.D(),this.F()}D(){const Te=Ne=>Ne?.startsWith(`${u.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Ne,Ye,ze,_e)=>Te(_e.requestingUrl)?ze(Le.has(Ye)):ze(!1)),i.session.defaultSession.setPermissionCheckHandler((Ne,Ye,ze,_e)=>Te(_e.requestingUrl)?Le.has(Ye):!1);const je=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,u.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Ne=>{for(let Ye=Ne;Ye;Ye=Ye.parent)if(Ye.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Ee=Ne=>Ne.resourceType==="xhr"||ve(Ne.frame),He=Ne=>{const Ye=Ne.frame;if(!Ye||!this.b)return!1;const ze=i.BrowserWindow.getAllWindows();for(const _e of ze)if(Ye.processId===_e.webContents.mainFrame.processId)return!0;return!1},Ve=(Ne,Ye)=>{if(Ne.path!=="/index.html")return!0;const ze=Ye.frame;if(!ze||!this.b)return!1;for(const _e of this.b.getWindows())if(_e.win&&ze.processId===_e.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Ne,Ye)=>{const ze=w.URI.parse(Ne.url);return ze.scheme===u.Schemas.vscodeWebview&&!Ve(ze,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),Ye({cancel:!0})):ze.scheme===u.Schemas.vscodeFileResource&&!He(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),Ye({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?Ye({cancel:!Ee(Ne)}):Ye({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,Ye)=>{const ze=Ne.responseHeaders,_e=ze["content-type"]||ze["Content-Type"];if(_e&&Array.isArray(_e)){const it=w.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],Ye({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(u.Schemas.vscodeRemoteResource)&&_e.some(ot=>ot.toLowerCase().includes("image/svg")))return Ye({cancel:!Ee(Ne)})}return Ye({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,Ye)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Ne.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],Ye({cancel:!1,responseHeaders:ze})}return Ye({cancel:!1})});const Ge=i.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,m.$kc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,o.disableUNCAccessRestrictions)():(0,o.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,y.setUnexpectedErrorHandler)(je=>this.H(je)),process.on("uncaughtException",je=>{(0,y.$1)(je)||(0,y.$2)(je)}),process.on("unhandledRejection",je=>(0,y.$2)(je)),h.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,S.$_W)(),i.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),i.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ke.OpenContext.DOCK})}),i.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${u.Schemas.vscodeFileResource}://${u.$Xg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Ee=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ve.setWindowOpenHandler(Ee=>Ee.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ee)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ee.url}}`),this.f?.openExternal(void 0,Ee.url),{action:"deny"}))});let Te=[],Le;i.app.on("open-file",(je,ve)=>{ve=(0,kt.$lm)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Te.push((0,ge.$0i)(ve)?{workspaceUri:w.URI.file(ve)}:{fileUri:w.URI.file(ve)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.b?.open({context:Ke.OpenContext.DOCK,cli:this.s.args,urisToOpen:Te,gotoLineMode:!1,preferNewWindow:!0}),Te=[],Le=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ke.OpenContext.DESKTOP})}),E.$$W.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Ee,He;return ve?.config?(Ee=ve.config,He={...process.env,...ve.config.userEnv}):(Ee=this.s.args,He=process.env),this.X(Ee,He,!1)}),E.$$W.handle("vscode:writeNlsFile",(je,ve,Ee)=>{const He=this.G([ve]);if(!He||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(He,R.$Ne.fromString(Ee))}),E.$$W.handle("vscode:readNlsFile",async(je,...ve)=>{const Ee=this.G(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ee)).value.toString()}),E.$$W.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),E.$$W.on("vscode:openDevTools",je=>je.sender.openDevTools()),E.$$W.on("vscode:reloadWindow",je=>je.sender.reload()),E.$$W.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Ee=this.b?.getWindowByWebContents(je.sender);Ee&&Ee.notifyZoomLevel(ve)})}G(Te){let Le;for(const je of Te)typeof je=="string"&&(typeof Le!="string"?Le=je:Le=(0,m.$kc)(Le,je));if(!(typeof Le!="string"||!(0,m.$jc)(Le)||!(0,c.$Dg)(Le,this.s.cachedLanguagesPath,!p.$k)))return w.URI.file(Le)}H(Te){if(Te){const Le={message:`[uncaught exception in main]: ${Te.message}`,stack:Te.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.m.error(`[uncaught exception in main]: ${Te}`),Te.stack&&this.m.error(Te.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Te=this.z.win32AppUserModelId;p.$i&&Te&&i.app.setAppUserModelId(Te);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Le=new t.$fX;h.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===N.ShutdownReason.KILL&&Le.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Ee]=await Promise.all([(0,wt.$pfc)(this.w,this.m),(0,wt.$qfc)(this.w,this.m),(0,wt.$rfc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:He,sharedProcessClient:Ve}=this.P(je,ve,Ee),Ge=await this.Q(je,ve,Ee,He);this.B(Ge.createInstance(a.$fec)),this.B(Ge.createInstance(gt.$kfc)),Ge.invokeFunction(ze=>this.R(ze,Le,Ve));const Ne=await Ge.invokeFunction(ze=>this.I(ze,Le));this.J(Le),this.t.phase=N.LifecycleMainPhase.Ready,await Ge.invokeFunction(ze=>this.S(ze,Ne)),this.t.phase=N.LifecycleMainPhase.AfterWindowOpen,this.U(),this.B(new $t.$Qh(()=>{this.B((0,$t.$Uh)(()=>this.t.phase=N.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async I(Te,Le){const je=this.b=Te.get(Ke.$Odc),ve=Te.get(Oe.$ZX),Ee=this.f=Te.get(Q.$Aec),He=Te.get(T.$Jdc),Ve=this;ve.registerHandler({async handleURL(it,ot){return Ve.O(je,He,ve,it,ot)}});const Ge=this.B(new te.$ffc({onDidOpenMainWindow:Ee.onDidOpenMainWindow,onDidFocusMainWindow:Ee.onDidFocusMainWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ne=new r.$mi(it=>Ge.getActiveClientId().then(ot=>it===ot)),Ye=new Be.$9ec(Ne,this.m),ze=Le.getChannel("urlHandler",Ye);ve.registerHandler(new Be.$8ec(ze));const _e=await this.L(je,He);return this.B(new Je.$0ec(_e?.urls,ve,je,this.s,this.z,this.m)),_e}J(Te){const Le=()=>({statusCode:404,data:"Not found"}),je=new Nt.$W(()=>Te.getChannel(bt.$yfc,new bt.$zfc));i.protocol.registerBufferProtocol(u.Schemas.vscodeManagedRemoteResource,(ve,Ee)=>{const He=w.URI.parse(ve.url);if(!He.authority.startsWith("window:"))return Ee(Le());je.value.call(bt.$xfc,[He]).then(Ve=>Ee({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),Ee({statusCode:500,data:String(Ve)})})})}async L(Te,Le){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Ee=[...je,...ve].map(Ge=>{try{return{uri:w.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),He=[],Ve=[];for(const Ge of Ee){if(!Ge)continue;const Ne=this.N(Ge.uri);if(Ne)if(await this.M(Ne,Te,Le)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),Ne),He.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ve.push(Ge)}return{urls:Ve,openables:He}}async M(Te,Le,je){let ve,Ee;if((0,Xe.$VD)(Te)?(ve=Te.workspaceUri,Ee=(0,s.localize)(0,null,ve.scheme===u.Schemas.file?(0,g.$Rw)(ve,{os:p.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Xe.$WD)(Te)?(ve=Te.folderUri,Ee=(0,s.localize)(1,null,ve.scheme===u.Schemas.file?(0,g.$Rw)(ve,{os:p.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Te.fileUri,Ee=(0,s.localize)(2,null,ve.scheme===u.Schemas.file?(0,g.$Rw)(ve,{os:p.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==u.Schemas.file&&ve.scheme!==u.Schemas.vscodeRemote||this.u.getValue(yt.a[ve.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ge}=await je.showMessageBox({type:"warning",buttons:[(0,s.localize)(3,null),(0,s.localize)(4,null)],message:Ee,detail:(0,s.localize)(5,null),checkboxLabel:ve.scheme===u.Schemas.file?(0,s.localize)(6,null):(0,s.localize)(7,null),cancelId:1});if(Ve!==0)return!0;if(Ge){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===u.Schemas.file?"local":"remote"};Le.sendToFocused(Ne.channel,Ne.args),Le.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}N(Te){if(Te.path){if(Te.authority===u.Schemas.file){const Le=w.URI.file(Te.fsPath);return(0,ge.$0i)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(Te.authority===u.Schemas.vscodeRemote){const Le=Te.path.indexOf(m.$hc.sep,1);if(Le!==-1){const je=Te.path.substring(1,Le),ve=Te.path.substring(Le);let Ee=Te.query;const He=new URLSearchParams(Te.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),Ee=He.toString());const Ve=w.URI.from({scheme:u.Schemas.vscodeRemote,authority:je,path:ve,query:Ee,fragment:Te.fragment});return(0,ge.$0i)(ve)?{workspaceUri:Ve}:/:[\d]+$/.test(ve)?{fileUri:Ve}:{folderUri:Ve}}}}}async O(Te,Le,je,ve,Ee){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Ee),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:w.URI.parse(ve.query).path,query:""}));let He=!1;const Ve=new URLSearchParams(ve.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Ve.delete("windowId"),ve=ve.with({query:Ve.toString()}),He=!0):p.$j&&Te.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),He=!0);const Ge=Ve.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Ve.delete("continueOn"),ve=ve.with({query:Ve.toString()}),this.s.continueOn=Ge??void 0);const Ne=this.N(ve);return Ne?await this.M(Ne,Te,Le)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,ve.toString(!0)),(0,Et.$Pb)(await Te.open({context:Ke.OpenContext.API,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Pb)(await Te.open({context:Ke.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Y.$fn)(ve)}))?.ready(),je.open(ve,Ee)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Ee),!1)}P(Te,Le,je){const ve=this.B(this.j.createInstance(ie.$Uec,Te,Le,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Ee=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new n.$gX(Ve,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Ee))(),sharedProcessClient:Ee}}async Q(Te,Le,je,ve){const Ee=new G.$Ci;switch(process.platform){case"win32":Ee.set(ue.$0X,new x.$Bi(Fe.$6ec));break;case"linux":p.$l?Ee.set(ue.$0X,new x.$Bi(We.$5ec,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(ue.$0X,new x.$Bi(Re.$4ec));break;case"darwin":Ee.set(ue.$0X,new x.$Bi(be.$3ec));break}Ee.set(Ke.$Odc,new x.$Bi(Ce.$efc,[Te,Le,je,this.h],!1)),Ee.set(St.$zec,new x.$Bi(Ct.$Afc,void 0,!1));const He=new T.$Kdc(this.m,this.z);Ee.set(T.$Jdc,He),Ee.set(F.$Gec,new x.$Bi(F.$Hec,void 0,!1)),Ee.set(L.$lec,new x.$Bi(L.$mec,void 0,!1)),Ee.set(O.$Rm,r.ProxyChannel.toService((0,r.$ki)(ve.then(ze=>ze.getChannel("diagnostics"))))),Ee.set(he.$a$b,new x.$Bi(ne.$Cec,[this.h])),Ee.set(A.$TX,new x.$Bi(M.$nec)),Ee.set(Z.$Dec,new x.$Bi(Z.$Eec)),Ee.set(Q.$Aec,new x.$Bi(Q.$Bec,void 0,!1)),Ee.set(qe.$$ec,new x.$Bi(Qe.$afc)),Ee.set(q.$Pec,new x.$Bi(q.$Qec)),Ee.set(re.$oec,new x.$Bi(_.$qec)),Ee.set(Ie.$bec,new x.$Bi(Ie.$cec)),Ee.set(Ie.$dec,new x.$Bi(Ie.$eec));const Ve=new Mt.$wfc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ge=new Ft.$Js(Ve,this.u,this.m,this.n);Ee.set(dt.$ks,Ge),p.$i?Ee.set(se.$rec,new x.$Bi(K.$sec)):p.$j?Ee.set(se.$rec,new x.$Bi(K.$tec)):p.$k&&Ee.set(se.$rec,new x.$Bi(K.$uec));const Ne=new f.$gec(this.s,this.u,this.m,this.w);Ee.set(l.$Idc,Ne);const Ye=new Ue.$2dc(this.s,this.m,this.C,Ne,He);if(Ee.set(Ue.$1dc,Ye),Ee.set(we.$6gb,new x.$Bi(Me.$gfc,void 0,!1)),Ee.set(ye.$Mec,new x.$Bi(ye.$Nec,void 0,!1)),Ee.set(Oe.$ZX,new x.$Bi(xe.$2X,void 0,!1)),(0,J.$zp)(this.z,this.s)){const ze=(0,J.$Ep)(this.z,this.u),_e=(0,r.$ki)(ve.then(mt=>mt.getChannel("telemetryAppender"))),it=new De.$Xec(_e),ot=(0,ke.$qp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,Te,Le,je,ze),nt=(0,J.$Fp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Ee.set(Pe.$0l,new x.$Bi($e.$as,[ht],!1))}else Ee.set(Pe.$0l,J.$up);return Ee.set(ut.$Cq,new x.$Bi(Ot.$TQ,void 0,!0)),Ee.set(ct.$Gq,new x.$Bi(ft.$jfc,void 0,!0)),Ee.set(pt.$ufc,new x.$Bi(pt.$vfc,void 0,!0)),await $t.Promises.settled([Ne.initialize(),Ye.initialize()]),this.j.createChild(Ee)}R(Te,Le,je){const ve=this.B(new b.$Uc),Ee=r.ProxyChannel.fromService(Te.get(F.$Gec),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Ee);const He=r.ProxyChannel.fromService(Te.get(L.$lec),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const Ve=ve.add(new lt.$hfc(Te.get(Ze.$qo)));Le.registerChannel("policy",Ve),je.then(st=>st.registerChannel("policy",Ve));const Ge=this.y.getProvider(u.Schemas.file);(0,$.$og)(Ge instanceof U.$mr);const Ne=ve.add(new j.$vec(Ge,this.m,this.s));Le.registerChannel(ee.$CQ,Ne),je.then(st=>st.registerChannel(ee.$CQ,Ne));const Ye=r.ProxyChannel.fromService(Te.get(rt.$Rdc),ve);Le.registerChannel("userDataProfiles",Ye),je.then(st=>st.registerChannel("userDataProfiles",Ye));const ze=new at.$8r(Te.get(tt.$1p));je.then(st=>st.registerChannel("request",ze));const _e=new fe.$Yec(Te.get(ue.$0X));Le.registerChannel("update",_e);const it=r.ProxyChannel.fromService(Te.get(he.$a$b),ve);Le.registerChannel("issue",it);const ot=r.ProxyChannel.fromService(Te.get(A.$TX),ve);Le.registerChannel("encryption",ot);const nt=r.ProxyChannel.fromService(Te.get(de.$Xl),ve);Le.registerChannel("sign",nt);const ht=r.ProxyChannel.fromService(Te.get(Z.$Dec),ve);Le.registerChannel("keyboardLayout",ht),this.f=Te.get(Q.$Aec);const mt=r.ProxyChannel.fromService(this.f,ve);Le.registerChannel("nativeHost",mt),je.then(st=>st.registerChannel("nativeHost",mt));const Wt=r.ProxyChannel.fromService(Te.get(we.$6gb),ve);Le.registerChannel("workspaces",Wt);const Bt=r.ProxyChannel.fromService(Te.get(q.$Pec),ve);Le.registerChannel("menubar",Bt);const Ut=r.ProxyChannel.fromService(Te.get(Oe.$ZX),ve);Le.registerChannel("url",Ut);const zt=r.ProxyChannel.fromService(Te.get(qe.$$ec),ve);Le.registerChannel("webview",zt);const Pt=ve.add(new pe.$Vec(this.m,Te.get(Ie.$bec)));Le.registerChannel("storage",Pt),je.then(st=>st.registerChannel("storage",Pt));const qt=ve.add(new Rt.$lfc(Te.get(Ie.$bec),Te.get(rt.$Rdc),this.m));je.then(st=>st.registerChannel("profileStorageListener",qt));const Ht=r.ProxyChannel.fromService(Te.get(dt.$ks),ve);Le.registerChannel(dt.TerminalIpcChannels.LocalPty,Ht);const Yt=r.ProxyChannel.fromService(Te.get(se.$rec),ve);Le.registerChannel("externalTerminal",Yt);const It=new Tt.$sfc(Te.get(Lt.$3dc));Le.registerChannel("logger",It),je.then(st=>st.registerChannel("logger",It));const Vt=new I.$hec(Te.get(Ke.$Odc));Le.registerChannel("extensionhostdebugservice",Vt);const xt=r.ProxyChannel.fromService(Te.get(re.$oec),ve);Le.registerChannel(re.$pec,xt);const Gt=r.ProxyChannel.fromService(Te.get(pt.$ufc),ve);Le.registerChannel(jt.$tfc,Gt)}async S(Te,Le){const je=this.b=Te.get(Ke.$Odc);this.c=Te.get(St.$zec);const ve=(0,C.$Im)(process.env)?Ke.OpenContext.CLI:Ke.OpenContext.DESKTOP,Ee=this.s.args;if(Le){if(Le.openables.length>0)return je.open({context:ve,cli:Ee,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,Ve=Ee._.length,Ge=!!Ee["folder-uri"],Ne=!!Ee["file-uri"],Ye=Ee["skip-add-to-recently-opened"]===!0,ze=Ee.wait&&Ee.waitMarkerFilePath?w.URI.file(Ee.waitMarkerFilePath):void 0,_e=Ee.remote||void 0,it=Ee.profile,ot=Ee["profile-temp"];if(!Ve&&!Ge&&!Ne){if(Ee["new-window"]||it||ot)return je.open({context:ve,cli:Ee,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ye,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot});if(He.length)return je.open({context:Ke.OpenContext.DOCK,cli:Ee,urisToOpen:He.map(nt=>(nt=(0,kt.$lm)(nt),(0,ge.$0i)(nt)?{workspaceUri:w.URI.file(nt)}:{fileUri:w.URI.file(nt)})),noRecentEntry:Ye,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Ee,forceNewWindow:Ee["new-window"],diffMode:Ee.diff,mergeMode:Ee.merge,noRecentEntry:Ye,waitMarkerFileURI:ze,gotoLineMode:Ee.goto,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot})}U(){this.W(),i.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Te,Le)=>{Le({url:Te.url.replace(/^vscode-remote-resource:/,"http:"),method:Te.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Te=this.z.win32MutexName;if(p.$i&&Te)try{const Le=await new Promise((ve,Ee)=>{V(["@vscode/windows-mutex"],ve,Ee)}).then(Ae),je=new Le.Mutex(Te);h.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Le){this.m.error(Le)}}async X(Te,Le,je){try{return await(0,B.$Pm)(this.u,this.m,Te,Le)}catch(ve){const Ee=(0,P.$pj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ee):this.m.error(Ee)}return{}}async Y(){try{const Le=(await this.y.readFile(this.s.argvResource)).value.toString(),je=JSON.parse((0,d.$3n)(Le)),Ee=(0,J.$Bp)(this.u)>=Pe.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ee},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.$1g)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,R.$Ne.fromString(Ve))}else{const He=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ee},`);He!==Le&&await this.y.writeFile(this.s.argvResource,R.$Ne.fromString(He))}}catch(Te){this.m.error(Te)}}};e.$Bfc=vt,e.$Bfc=vt=yt=Se([oe(2,ae.$Di),oe(3,W.$$j),oe(4,W.$_j),oe(5,z.$Ddc),oe(6,N.$8dc),oe(7,k.$$i),oe(8,me.$MQ),oe(9,H.$$k),oe(10,X.$rk),oe(11,rt.$Rdc)],vt)});var et=this&&this.__importDefault||function(V){return V&&V.__esModule?V:{default:V}};define(ce[319],le([0,1,14,47,7,22,8,53,16,31,3,48,13,9,70,4,36,26,21,44,105,315,10,18,243,255,25,68,207,15,227,99,82,223,98,20,230,5,84,28,85,282,132,293,55,292,102,254,34,56,74,59,41,239,237,2,42,270,71,232,124,128,274,107,268]),function(V,e,i,o,E,D,R,P,y,c,h,d,g,b,u,m,p,$,w,v,S,r,t,n,a,s,l,f,k,I,O,L,T,A,M,z,C,B,re,_,se,K,ee,H,j,U,x,ae,G,he,ne,Z,F,N,W,q,Q,X,Y,ie,de,me,pe,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),re=et(re);class ke{main(){try{this.a()}catch($e){console.error($e.message),i.app.exit(1)}}async a(){(0,y.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,J,ue,fe,be,Re,We,Fe]=this.b();try{try{await this.d(ue,Fe,fe,be,We)}catch(Oe){throw this.g(ue,We,Oe),Oe}await $e.invokeFunction(async Oe=>{const Be=Oe.get(B.$$j),xe=Oe.get(z.$8dc),Je=Oe.get(I.$$k),qe=Oe.get(B.$_j),Qe=await this.f(Be,ue,xe,$e,We,!0);return w.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Xe=>{Be.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Re.logger=qe.createLogger("main",{name:(0,t.localize)(0,null)}),h.Event.once(xe.onWillShutdown)(Xe=>{Je.dispose(),fe.dispose(),Xe.join("instanceLockfile",w.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),$e.createInstance(r.$Bfc,Qe,J).startup()})}catch(Oe){$e.invokeFunction(this.j,Oe)}}b(){const $e=new M.$Ci,J=new q.$Uc;process.once("exit",()=>J.dispose());const ue={_serviceBrand:void 0,...re.default};$e.set(_.$rk,ue);const fe=new l.$Edc(this.k(),ue),be=this.c(fe);$e.set(l.$Ddc,fe);const Re=new Y.$4dc((0,B.$mk)(fe),fe.logsHome);$e.set(Y.$3dc,Re);const We=new C.$cbc(Re.getLogLevel()),Fe=J.add(new ie.$UQ(We,[new B.$fk(Re.getLogLevel())]));$e.set(B.$$j,Fe);const Oe=new O.$Vq(Fe);$e.set(I.$$k,Oe);const Be=new L.$mr(Fe);Oe.registerProvider(g.Schemas.file,Be);const xe=new X.$Ns(Oe);$e.set(Q.$Il,xe);const Je=new me.$PQ(me.SaveStrategy.DELAYED,fe,Fe,Oe);$e.set(G.$LQ,Je),$e.set(G.$MQ,Je);const qe=new Z.$Sdc(Je,xe,fe,Oe,Fe);$e.set(Z.$Rdc,qe),Oe.registerProvider(g.Schemas.vscodeUserData,new pe.$Mfc(g.Schemas.file,Be,g.Schemas.vscodeUserData,qe,xe,Fe));const Qe=m.$i&&ue.win32RegValueName?J.add(new N.$Kfc(Fe,ue.win32RegValueName)):fe.policyFile?J.add(new W.$Lfc(fe.policyFile,Oe,Fe)):new F.$so;$e.set(F.$qo,Qe);const Xe=new a.$So(qe.defaultProfile.settingsResource,Oe,Qe,Fe);return $e.set(n.$$i,Xe),$e.set(z.$8dc,new T.$Bi(z.$9dc,void 0,!1)),$e.set(j.$1p,new T.$Bi(U.$Ifc,void 0,!0)),$e.set(ne.$Mdc,new T.$Bi(ne.$Ndc)),$e.set(x.$Xl,new T.$Bi(ae.$Jfc,void 0,!1)),$e.set(ee.$ww,new T.$Bi(H.$Gfc)),$e.set(se.$Ldc,new K.$Dfc(fe,qe,Fe)),[new A.$pr($e,!0),be,fe,Xe,Je,We,ue,qe]}c($e){const J={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const fe=process.env[ue];typeof fe=="string"&&(J[ue]=fe)}),Object.assign(process.env,J),J}async d($e,J,ue,fe,be){await R.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:g.Schemas.file}).fsPath,J.defaultProfile.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:g.Schemas.file}).fsPath,$e.backupHome].map(Re=>Re?w.Promises.mkdir(Re,{recursive:!0}):void 0)),fe.init(),ue.initialize()]),J.init()}e($e){if(m.$i){const J=(0,Ie.getUNCHost)($e);J&&(0,Ie.addUNCHostToAllowlist)(J)}return $e}async f($e,J,ue,fe,be,Re){let We;try{(0,u.mark)("code/willStartMainServer"),We=await(0,S.$zi)(J.mainIPCHandle),(0,u.mark)("code/didStartMainServer"),h.Event.once(ue.onWillShutdown)(()=>We.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.g(J,be,Fe),Fe;let Oe;try{Oe=await(0,S.$Ai)(J.mainIPCHandle,"main")}catch(qe){if(!Re||m.$i||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,t.localize)(1,null,be.nameShort),(0,t.localize)(2,null),be),qe;try{(0,o.unlinkSync)(J.mainIPCHandle)}catch(Qe){throw $e.warn("Could not delete obsolete instance handle",Qe),Qe}return this.f($e,J,ue,fe,be,!1)}if(J.extensionTestsLocationURI&&!J.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Oe.dispose(),new Error(qe)}let Be;!J.args.wait&&!J.args.status&&(Be=setTimeout(()=>{this.h((0,t.localize)(3,null,be.nameShort),(0,t.localize)(4,null),be)},1e4));const xe=v.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Je=v.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(J.args.status)return fe.invokeFunction(async()=>{const qe=new s.$Us(he.$up,be),Qe=await Je.getMainDiagnostics(),Xe=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await qe.getDiagnostics(Qe,Xe);throw console.log(Ke),new y.$bb});throw m.$i&&await this.i(xe,$e),$e.trace("Sending env to running instance..."),await xe.start(J.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new y.$bb("Sent env to running instance. Terminating...")}if(J.args.status)throw console.log((0,t.localize)(5,null,be.nameShort)),new y.$bb("Terminating...");return process.env.VSCODE_PID=String(process.pid),We}g($e,J,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const fe=(0,D.$Ib)([$e.userDataPath,$e.extensionsPath,S.$vi]).map(be=>(0,d.$Rw)(E.URI.file(be),{os:m.OS,tildify:$e}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$pj)(ue),fe.join(`
`)),J)}}h($e,J,ue){i.dialog.showMessageBoxSync((0,de.$6w)({type:"warning",buttons:[(0,t.localize)(8,null)],message:$e,detail:J},ue).options)}async i($e,J){if(m.$i){const ue=await $e.getMainProcessId();J.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((fe,be)=>{V(["windows-foreground-love"],fe,be)}).then(Ae)).allowSetForegroundWindow(ue)}catch(fe){J.error(fe)}}}j($e,J){const ue=$e.get(B.$$j),fe=$e.get(z.$8dc);let be=0;J&&(J.isExpected?J.message&&ue.trace(J.message):(be=1,J.stack?ue.error(J.stack):ue.error(`Startup error: ${J.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,f.$Fm)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const J=(0,k.$Cfc)($e.verbose);J&&((0,f.$Hm)(process.argv,"--waitMarkerFilePath",J),$e.waitMarkerFilePath=J)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const J=this.m($e._,$e.goto);$e._=J}return $e}m($e,J){const ue=(0,p.cwd)(),fe=$e.map(We=>{let Fe=String(We),Oe;J&&(Oe=(0,c.$Lg)(Fe),Fe=Oe.path),Fe&&(Fe=this.n(ue,Fe));const Be=(0,c.$Fg)(Fe,ue),xe=(0,b.$oc)(Be);return xe&&!(0,c.$Bg)(xe)?null:J&&Oe?(Oe.path=Be,this.o(Oe)):Be}),be=m.$i||m.$j,Re=(0,D.$Nb)(fe,We=>We&&be?We.toLowerCase():We||"");return(0,D.$Ib)(Re)}n($e,J){return m.$i&&(J=(0,$.$nf)(J,'"')),J=(0,$.$lf)((0,$.$lf)(J," "),"	"),m.$i&&(J=(0,b.$lc)($e,J),J=(0,$.$nf)(J,".")),J}o($e){const J=[$e.path];return typeof $e.line=="number"&&J.push(String($e.line)),typeof $e.column=="number"&&J.push(String($e.column)),J.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fc357074a7bba115fe44683d3f6050c63e591683/core/vs/code/electron-main/main.js.map
