/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","vs/platform/extensions/common/extensions","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],P=0,a=ne.length;P<a;P++)e[P]=le[ne[P]];return e};define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=void 0,e.$U=!1;var P;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class a{static get(){const L=new Map,C=new Map,k=new Map,A=new Map;function w(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function S(c,g){const b=c.get(g.detail);b&&(b>=0||c.set(g.detail,b+g.timestamp))}let m=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(m=ne.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of m)switch(c.type){case P.BeginLoadingScript:w(L,c);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:S(L,c);break;case P.BeginInvokeFactory:w(C,c);break;case P.EndInvokeFactory:S(C,c);break;case P.NodeBeginNativeRequire:w(k,c);break;case P.NodeEndNativeRequire:S(k,c);break;case P.NodeBeginEvaluatingScript:w(A,c);break;case P.NodeEndEvaluatingScript:S(A,c);break}let h=0;k.forEach(c=>h+=c);function $(c){const g=[];return c.forEach((b,f)=>g.push([f,b])),g}return{amdLoad:$(L),amdInvoke:$(C),nodeRequire:$(k),nodeEval:$(A),nodeRequireTotal:h}}static toMarkdownTable(L,C){let k="";const A=[];return L.forEach((w,S)=>{A[S]=w.length}),C.forEach(w=>{w.forEach((S,m)=>{typeof S>"u"&&(S=w[m]="-");const h=S.toString().length;A[m]=Math.max(h,A[m])})}),L.forEach((w,S)=>{k+=`| ${w+" ".repeat(A[S]-w.toString().length)} `}),k+=`|
`,L.forEach((w,S)=>{k+=`| ${"-".repeat(A[S])} `}),k+=`|
`,C.forEach(w=>{w.forEach((S,m)=>{typeof S<"u"&&(k+=`| ${S+" ".repeat(A[m]-S.toString().length)} `)}),k+=`|
`}),k}}e.$V=a}),define(le[130],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=P,e.$hb=a,e.$ib=N,e.$jb=L,e.$kb=C,e.$lb=k,e.$mb=A,e.$ob=S,e.$pb=m,e.$qb=h,e.$rb=$,e.$sb=c;function P(g,b){const f=a(g,b);if(f!==-1)return g[f]}function a(g,b,f=g.length-1){for(let p=f;p>=0;p--){const I=g[p];if(b(I))return p}return-1}function N(g,b){const f=L(g,b);return f===-1?void 0:g[f]}function L(g,b,f=0,p=g.length){let I=f,d=p;for(;I<d;){const u=Math.floor((I+d)/2);b(g[u])?I=u+1:d=u}return I-1}function C(g,b){const f=k(g,b);return f===g.length?void 0:g[f]}function k(g,b,f=0,p=g.length){let I=f,d=p;for(;I<d;){const u=Math.floor((I+d)/2);b(g[u])?d=u:I=u+1}return I}function A(g,b,f=0,p=g.length){const I=k(g,b,f,p);return I===g.length?-1:I}class w{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(w.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!b(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const f=L(this.e,b,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$nb=w;function S(g,b){if(g.length===0)return;let f=g[0];for(let p=1;p<g.length;p++){const I=g[p];b(I,f)>0&&(f=I)}return f}function m(g,b){if(g.length===0)return;let f=g[0];for(let p=1;p<g.length;p++){const I=g[p];b(I,f)>=0&&(f=I)}return f}function h(g,b){return S(g,(f,p)=>-b(f,p))}function $(g,b){if(g.length===0)return-1;let f=0;for(let p=1;p<g.length;p++){const I=g[p];b(I,g[f])>0&&(f=p)}return f}function c(g,b){for(const f of g){const p=b(f);if(p!==void 0)return p}}}),define(le[39],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(le[131],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=P,e.$L=a,e.$M=N,e.$N=L;function P(C,k){const A=Object.create(null);for(const w of C){const S=k(w);let m=A[S];m||(m=A[S]=[]),m.push(w)}return A}function a(C,k){const A=[],w=[];for(const S of C)k.has(S)||A.push(S);for(const S of k)C.has(S)||w.push(S);return{removed:A,added:w}}function N(C,k){const A=[],w=[];for(const[S,m]of C)k.has(S)||A.push(m);for(const[S,m]of k)C.has(S)||w.push(m);return{removed:A,added:w}}function L(C,k){const A=new Set;for(const w of k)C.has(w)&&A.add(w);return A}}),define(le[88],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=a,e.$0h=N,e.$$h=L;function P(C){return(k,A,w)=>{let S=null,m=null;if(typeof w.value=="function"?(S="value",m=w.value):typeof w.get=="function"&&(S="get",m=w.get),!m)throw new Error("not supported");w[S]=C(m,A)}}function a(C,k,A){let w=null,S=null;if(typeof A.value=="function"?(w="value",S=A.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof A.get=="function"&&(w="get",S=A.get),!S)throw new Error("not supported");const m=`$memoize$${k}`;A[w]=function(...h){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,h)}),this[m]}}function N(C,k,A){return P((w,S)=>{const m=`$debounce$${S}`,h=`$debounce$result$${S}`;return function(...$){this[h]||(this[h]=A?A():void 0),clearTimeout(this[m]),k&&(this[h]=k(this[h],...$),$=[this[h]]),this[m]=setTimeout(()=>{w.apply(this,$),this[h]=A?A():void 0},C)}})}function L(C,k,A){return P((w,S)=>{const m=`$throttle$timer$${S}`,h=`$throttle$result$${S}`,$=`$throttle$lastRun$${S}`,c=`$throttle$pending$${S}`;return function(...g){if(this[h]||(this[h]=A?A():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),k&&(this[h]=k(this[h],...g)),this[c])return;const b=this[$]+C;b<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[h]]),this[h]=A?A():void 0):(this[c]=!0,this[m]=setTimeout(()=>{this[c]=!1,this[$]=Date.now(),w.apply(this,[this[h]]),this[h]=A?A():void 0},b-Date.now()))}})}}),define(le[8],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=a,e.$1=N,e.$2=L,e.$3=C,e.$4=k,e.$5=w,e.$7=m,e.$8=h,e.$9=$,e.$$=g;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?I.isErrorNoTelemetry(t)?new I(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=P,e.$Y=new P;function a(u){e.$Y.setUnexpectedErrorHandler(u)}function N(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function L(u){w(u)||e.$Y.onUnexpectedError(u)}function C(u){w(u)||e.$Y.onUnexpectedExternalError(u)}function k(u){if(u instanceof Error){const{name:t,message:s}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:s,stack:r,noTelemetry:I.isErrorNoTelemetry(u)}}return u}const A="Canceled";function w(u){return u instanceof S?!0:u instanceof Error&&u.name===A&&u.message===A}class S extends Error{constructor(){super(A),this.name=this.message}}e.$6=S;function m(){const u=new Error(A);return u.name=u.message,u}function h(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function $(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=c;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$_=b;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$ab=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=p;class I extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof I)return t;const s=new I;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$cb=I;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$db=d}),define(le[19],he([0,1,8,130]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=N,e.$ub=L,e.$vb=C,e.$wb=k,e.$xb=A,e.$yb=w,e.$zb=S,e.$Ab=m,e.$Bb=h,e.$Cb=$,e.$Db=c,e.$Eb=g,e.$Fb=b,e.top=f,e.$Hb=p,e.$Ib=d,e.$Jb=u,e.$Kb=t,e.$Lb=s,e.$Mb=r,e.$Nb=i,e.$Ob=n,e.$Pb=o,e.$Qb=l,e.$Rb=y,e.$Sb=R,e.$Tb=O,e.$Ub=E,e.$Vb=v,e.$Wb=T,e.$Xb=U,e.$Yb=F,e.$Zb=M,e.$1b=X,e.$2b=K,e.$3b=Q,e.$4b=G,e.$5b=ie,e.$6b=V,e.$7b=re,e.$8b=ce,e.$$b=J;function N(j,W=0){return j[j.length-(1+W)]}function L(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}function C(j,W,te=(_,Y)=>_===Y){if(j===W)return!0;if(!j||!W||j.length!==W.length)return!1;for(let _=0,Y=j.length;_<Y;_++)if(!te(j[_],W[_]))return!1;return!0}function k(j,W){const te=j.length-1;W<te&&(j[W]=j[te]),j.pop()}function A(j,W,te){return w(j.length,_=>te(j[_],W))}function w(j,W){let te=0,_=j-1;for(;te<=_;){const Y=(te+_)/2|0,ae=W(Y);if(ae<0)te=Y+1;else if(ae>0)_=Y-1;else return Y}return-(te+1)}function S(j,W,te){if(j=j|0,j>=W.length)throw new TypeError("invalid index");const _=W[Math.floor(W.length*Math.random())],Y=[],ae=[],ue=[];for(const ge of W){const we=te(ge,_);we<0?Y.push(ge):we>0?ae.push(ge):ue.push(ge)}return j<Y.length?S(j,Y,te):j<Y.length+ue.length?ue[0]:S(j-(Y.length+ue.length),ae,te)}function m(j,W){const te=[];let _;for(const Y of j.slice(0).sort(W))!_||W(_[0],Y)!==0?(_=[Y],te.push(_)):_.push(Y);return te}function*h(j,W){let te,_;for(const Y of j)_!==void 0&&W(_,Y)?te.push(Y):(te&&(yield te),te=[Y]),_=Y;te&&(yield te)}function $(j,W){for(let te=0;te<=j.length;te++)W(te===0?void 0:j[te-1],te===j.length?void 0:j[te])}function c(j,W){for(let te=0;te<j.length;te++)W(te===0?void 0:j[te-1],j[te],te+1===j.length?void 0:j[te+1])}function g(j,W,te){const _=[];function Y(ge,we,Ee){if(we===0&&Ee.length===0)return;const pe=_[_.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=we,pe.toInsert.push(...Ee)):_.push({start:ge,deleteCount:we,toInsert:Ee})}let ae=0,ue=0;for(;;){if(ae===j.length){Y(ae,0,W.slice(ue));break}if(ue===W.length){Y(ae,j.length-ae,[]);break}const ge=j[ae],we=W[ue],Ee=te(ge,we);Ee===0?(ae+=1,ue+=1):Ee<0?(Y(ae,1,[]),ae+=1):Ee>0&&(Y(ae,0,[we]),ue+=1)}return _}function b(j,W,te){const _=g(j,W,te),Y=[],ae=[];for(const ue of _)Y.push(...j.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:Y,added:ae}}function f(j,W,te){if(te===0)return[];const _=j.slice(0,te).sort(W);return I(j,W,_,te,j.length),_}function p(j,W,te,_,Y){return te===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const ge=j.length,we=j.slice(0,te).sort(W);for(let Ee=te,pe=Math.min(te+_,ge);Ee<ge;Ee=pe,pe=Math.min(pe+_,ge)){if(Ee>te&&await new Promise(be=>setTimeout(be)),Y&&Y.isCancellationRequested)throw new P.$6;I(j,W,we,Ee,pe)}return we})().then(ae,ue)})}function I(j,W,te,_,Y){for(const ae=te.length;_<Y;_++){const ue=j[_];if(W(ue,te[ae-1])<0){te.pop();const ge=(0,a.$lb)(te,we=>W(ue,we)<0);te.splice(ge,0,ue)}}}function d(j){return j.filter(W=>!!W)}function u(j){let W=0;for(let te=0;te<j.length;te++)j[te]&&(j[W]=j[te],W+=1);j.length=W}function t(j,W,te){j.splice(te,0,j.splice(W,1)[0])}function s(j){return!Array.isArray(j)||j.length===0}function r(j){return Array.isArray(j)&&j.length>0}function i(j,W=te=>te){const te=new Set;return j.filter(_=>{const Y=W(_);return te.has(Y)?!1:(te.add(Y),!0)})}function n(j){const W=new Set;return te=>{const _=j(te);return W.has(_)?!1:(W.add(_),!0)}}function o(j,W){return j.length>0?j[0]:W}function l(j,W){return j.length>0?j[j.length-1]:W}function y(j,W,te=(_,Y)=>_===Y){let _=0;for(let Y=0,ae=Math.min(j.length,W.length);Y<ae&&te(j[Y],W[Y]);Y++)_++;return _}function R(j,W){let te=typeof W=="number"?j:0;typeof W=="number"?te=j:(te=0,W=j);const _=[];if(te<=W)for(let Y=te;Y<W;Y++)_.push(Y);else for(let Y=te;Y>W;Y--)_.push(Y);return _}function O(j,W,te){return j.reduce((_,Y)=>(_[W(Y)]=te?te(Y):Y,_),Object.create(null))}function E(j,W){return j.push(W),()=>v(j,W)}function v(j,W){const te=j.indexOf(W);if(te>-1)return j.splice(te,1),W}function T(j,W,te){const _=j.slice(0,W),Y=j.slice(W);return _.concat(te,Y)}function U(j,W){let te;if(typeof W=="number"){let _=W;te=()=>{const Y=Math.sin(_++)*179426549;return Y-Math.floor(Y)}}else te=Math.random;for(let _=j.length-1;_>0;_-=1){const Y=Math.floor(te()*(_+1)),ae=j[_];j[_]=j[Y],j[Y]=ae}}function F(j,W){const te=j.indexOf(W);te>-1&&(j.splice(te,1),j.unshift(W))}function M(j,W){const te=j.indexOf(W);te>-1&&(j.splice(te,1),j.push(W))}function X(j,W){for(const te of W)j.push(te)}function K(j,W){return Array.isArray(j)?j.map(W):W(j)}function Q(j){return Array.isArray(j)?j:[j]}function G(j){return j[Math.floor(Math.random()*j.length)]}function ie(j,W,te){const _=z(j,W),Y=j.length,ae=te.length;j.length=Y+ae;for(let ue=Y-1;ue>=_;ue--)j[ue+ae]=j[ue];for(let ue=0;ue<ae;ue++)j[ue+_]=te[ue]}function V(j,W,te,_){const Y=z(j,W);let ae=j.splice(Y,te);return ae===void 0&&(ae=[]),ie(j,Y,_),ae}function z(j,W){return W<0?Math.max(W+j.length,0):Math.min(W,j.length)}var ee;(function(j){function W(ae){return ae<0}j.isLessThan=W;function te(ae){return ae<=0}j.isLessThanOrEqual=te;function _(ae){return ae>0}j.isGreaterThan=_;function Y(ae){return ae===0}j.isNeitherLessOrGreaterThan=Y,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function re(j,W){return(te,_)=>W(j(te),j(_))}function ce(...j){return(W,te)=>{for(const _ of j){const Y=_(W,te);if(!ee.isNeitherLessOrGreaterThan(Y))return Y}return ee.neitherLessOrGreaterThan}}const q=(j,W)=>j-W;e.$9b=q;const x=(j,W)=>(0,e.$9b)(j?1:0,W?1:0);e.$0b=x;function J(j){return(W,te)=>-j(W,te)}class H{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let te=this.c;for(;te<this.g.length&&W(this.g[te]);)te++;const _=te===this.c?null:this.g.slice(this.c,te);return this.c=te,_}takeFromEndWhile(W){let te=this.d;for(;te>=0&&W(this.g[te]);)te--;const _=te===this.d?null:this.g.slice(te+1,this.d+1);return this.d=te,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const te=this.g.slice(this.c,this.c+W);return this.c+=W,te}}e.$_b=H;class D{static{this.empty=new D(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(te=>(W(te),!0))}toArray(){const W=[];return this.iterate(te=>(W.push(te),!0)),W}filter(W){return new D(te=>this.iterate(_=>W(_)?te(_):!0))}map(W){return new D(te=>this.iterate(_=>te(W(_))))}some(W){let te=!1;return this.iterate(_=>(te=W(_),!te)),te}findFirst(W){let te;return this.iterate(_=>W(_)?(te=_,!1):!0),te}findLast(W){let te;return this.iterate(_=>(W(_)&&(te=_),!0)),te}findLastMaxBy(W){let te,_=!0;return this.iterate(Y=>((_||ee.isGreaterThan(W(Y,te)))&&(_=!1,te=Y),!0)),te}}e.$ac=D;class B{constructor(W){this.c=W}static createSortPermutation(W,te){const _=Array.from(W.keys()).sort((Y,ae)=>te(W[Y],W[ae]));return new B(_)}apply(W){return W.map((te,_)=>W[this.c[_]])}inverse(){const W=this.c.slice();for(let te=0;te<this.c.length;te++)W[this.c[te]]=te;return new B(W)}}e.$bc=B}),define(le[132],he([0,1,8]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$fd=N,e.$gd=L,e.$hd=C,e.$id=k,e.$jd=A;function a(w,S){if(!w)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function N(w,S="Unreachable"){throw new Error(S)}function L(w,S="unexpected state"){if(!w)throw new P.$db(`Assertion Failed: ${S}`)}function C(w){w||(0,P.$2)(new P.$db("Soft Assertion Failed"))}function k(w){if(!w()){debugger;w(),(0,P.$2)(new P.$db("Assertion Failed"))}}function A(w,S){let m=0;for(;m<w.length-1;){const h=w[m],$=w[m+1];if(!S(h,$))return!1;m++}return!0}}),define(le[89],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=P;function P(a,N){const L=this;let C=!1,k;return function(){if(C)return k;if(C=!0,N)try{k=a.apply(L,arguments)}finally{N()}else k=a.apply(L,arguments);return k}}}),define(le[63],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(a){function N(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}a.is=N;const L=Object.freeze([]);function C(){return L}a.empty=C;function*k(s){yield s}a.single=k;function A(s){return N(s)?s:k(s)}a.wrap=A;function w(s){return s||L}a.from=w;function*S(s){for(let r=s.length-1;r>=0;r--)yield s[r]}a.reverse=S;function m(s){return!s||s[Symbol.iterator]().next().done===!0}a.isEmpty=m;function h(s){return s[Symbol.iterator]().next().value}a.first=h;function $(s,r){let i=0;for(const n of s)if(r(n,i++))return!0;return!1}a.some=$;function c(s,r){for(const i of s)if(r(i))return i}a.find=c;function*g(s,r){for(const i of s)r(i)&&(yield i)}a.filter=g;function*b(s,r){let i=0;for(const n of s)yield r(n,i++)}a.map=b;function*f(s,r){let i=0;for(const n of s)yield*r(n,i++)}a.flatMap=f;function*p(...s){for(const r of s)yield*r}a.concat=p;function I(s,r,i){let n=i;for(const o of s)n=r(n,o);return n}a.reduce=I;function*d(s,r,i=s.length){for(r<0&&(r+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);r<i;r++)yield s[r]}a.slice=d;function u(s,r=Number.POSITIVE_INFINITY){const i=[];if(r===0)return[i,s];const n=s[Symbol.iterator]();for(let o=0;o<r;o++){const l=n.next();if(l.done)return[i,a.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return n}}]}a.consume=u;async function t(s){const r=[];for await(const i of s)r.push(i);return Promise.resolve(r)}a.asyncToArray=t})(P||(e.Iterable=P={}))}),define(le[34],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=C,e.$Tn=m,e.$Un=h,e.$Vn=$,e.$Wn=c,e.$Xn=g,e.$Yn=b,e.$Zn=f,e.$1n=p,e.$2n=I,e.$3n=d,e.$4n=u;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var a;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var N;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function C(t,s=!1){let r=0;const i=t.length;let n="",o=0,l=a.Unknown,y=P.None;function R(M){let X=0,K=0;for(;X<M;){const Q=t.charCodeAt(r);if(Q>=S._0&&Q<=S._9)K=K*16+Q-S._0;else if(Q>=S.A&&Q<=S.F)K=K*16+Q-S.A+10;else if(Q>=S.a&&Q<=S.f)K=K*16+Q-S.a+10;else break;r++,X++}return X<M&&(K=-1),K}function O(M){r=M,n="",o=0,l=a.Unknown,y=P.None}function E(){const M=r;if(t.charCodeAt(r)===S._0)r++;else for(r++;r<t.length&&w(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===S.dot)if(r++,r<t.length&&w(t.charCodeAt(r)))for(r++;r<t.length&&w(t.charCodeAt(r));)r++;else return y=P.UnexpectedEndOfNumber,t.substring(M,r);let X=r;if(r<t.length&&(t.charCodeAt(r)===S.E||t.charCodeAt(r)===S.e))if(r++,(r<t.length&&t.charCodeAt(r)===S.plus||t.charCodeAt(r)===S.minus)&&r++,r<t.length&&w(t.charCodeAt(r))){for(r++;r<t.length&&w(t.charCodeAt(r));)r++;X=r}else y=P.UnexpectedEndOfNumber;return t.substring(M,X)}function v(){let M="",X=r;for(;;){if(r>=i){M+=t.substring(X,r),y=P.UnexpectedEndOfString;break}const K=t.charCodeAt(r);if(K===S.doubleQuote){M+=t.substring(X,r),r++;break}if(K===S.backslash){if(M+=t.substring(X,r),r++,r>=i){y=P.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case S.doubleQuote:M+='"';break;case S.backslash:M+="\\";break;case S.slash:M+="/";break;case S.b:M+="\b";break;case S.f:M+="\f";break;case S.n:M+=`
`;break;case S.r:M+="\r";break;case S.t:M+="	";break;case S.u:{const G=R(4);G>=0?M+=String.fromCharCode(G):y=P.InvalidUnicode;break}default:y=P.InvalidEscapeCharacter}X=r;continue}if(K>=0&&K<=31)if(A(K)){M+=t.substring(X,r),y=P.UnexpectedEndOfString;break}else y=P.InvalidCharacter;r++}return M}function T(){if(n="",y=P.None,o=r,r>=i)return o=i,l=a.EOF;let M=t.charCodeAt(r);if(k(M)){do r++,n+=String.fromCharCode(M),M=t.charCodeAt(r);while(k(M));return l=a.Trivia}if(A(M))return r++,n+=String.fromCharCode(M),M===S.carriageReturn&&t.charCodeAt(r)===S.lineFeed&&(r++,n+=`
`),l=a.LineBreakTrivia;switch(M){case S.openBrace:return r++,l=a.OpenBraceToken;case S.closeBrace:return r++,l=a.CloseBraceToken;case S.openBracket:return r++,l=a.OpenBracketToken;case S.closeBracket:return r++,l=a.CloseBracketToken;case S.colon:return r++,l=a.ColonToken;case S.comma:return r++,l=a.CommaToken;case S.doubleQuote:return r++,n=v(),l=a.StringLiteral;case S.slash:{const X=r-1;if(t.charCodeAt(r+1)===S.slash){for(r+=2;r<i&&!A(t.charCodeAt(r));)r++;return n=t.substring(X,r),l=a.LineCommentTrivia}if(t.charCodeAt(r+1)===S.asterisk){r+=2;const K=i-1;let Q=!1;for(;r<K;){if(t.charCodeAt(r)===S.asterisk&&t.charCodeAt(r+1)===S.slash){r+=2,Q=!0;break}r++}return Q||(r++,y=P.UnexpectedEndOfComment),n=t.substring(X,r),l=a.BlockCommentTrivia}return n+=String.fromCharCode(M),r++,l=a.Unknown}case S.minus:if(n+=String.fromCharCode(M),r++,r===i||!w(t.charCodeAt(r)))return l=a.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return n+=E(),l=a.NumericLiteral;default:for(;r<i&&U(M);)r++,M=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return l=a.TrueKeyword;case"false":return l=a.FalseKeyword;case"null":return l=a.NullKeyword}return l=a.Unknown}return n+=String.fromCharCode(M),r++,l=a.Unknown}}function U(M){if(k(M)||A(M))return!1;switch(M){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function F(){let M;do M=T();while(M>=a.LineCommentTrivia&&M<=a.Trivia);return M}return{setPosition:O,getPosition:()=>r,scan:s?F:T,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>y}}function k(t){return t===S.space||t===S.tab||t===S.verticalTab||t===S.formFeed||t===S.nonBreakingSpace||t===S.ogham||t>=S.enQuad&&t<=S.zeroWidthSpace||t===S.narrowNoBreakSpace||t===S.mathematicalSpace||t===S.ideographicSpace||t===S.byteOrderMark}function A(t){return t===S.lineFeed||t===S.carriageReturn||t===S.lineSeparator||t===S.paragraphSeparator}function w(t){return t>=S._0&&t<=S._9}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function m(t,s){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function y(R,O,E,v){o.value=R,o.offset=O,o.length=E,o.type=v,o.colonOffset=void 0,n=o}try{I(t,{onObjectBegin:(R,O)=>{if(s<=R)throw i;n=void 0,l=s>R,r.push("")},onObjectProperty:(R,O,E)=>{if(s<O||(y(R,O,E,"property"),r[r.length-1]=R,s<=O+E))throw i},onObjectEnd:(R,O)=>{if(s<=R)throw i;n=void 0,r.pop()},onArrayBegin:(R,O)=>{if(s<=R)throw i;n=void 0,r.push(0)},onArrayEnd:(R,O)=>{if(s<=R)throw i;n=void 0,r.pop()},onLiteralValue:(R,O,E)=>{if(s<O||(y(R,O,E,u(R)),s<=O+E))throw i},onSeparator:(R,O,E)=>{if(s<=O)throw i;if(R===":"&&n&&n.type==="property")n.colonOffset=O,l=!1,n=void 0;else if(R===","){const v=r[r.length-1];typeof v=="number"?r[r.length-1]=v+1:(l=!0,r[r.length-1]=""),n=void 0}}})}catch(R){if(R!==i)throw R}return{path:r,previousNode:n,isAtPropertyKey:l,matches:R=>{let O=0;for(let E=0;O<R.length&&E<r.length;E++)if(R[O]===r[E]||R[O]==="*")O++;else if(R[O]!=="**")return!1;return O===R.length}}}function h(t,s=[],r=L.DEFAULT){let i=null,n=[];const o=[];function l(R){Array.isArray(n)?n.push(R):i!==null&&(n[i]=R)}return I(t,{onObjectBegin:()=>{const R={};l(R),o.push(n),n=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const R=[];l(R),o.push(n),n=R,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(R,O,E)=>{s.push({error:R,offset:O,length:E})}},r),n[0]}function $(t,s=[],r=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function o(R){return i.children.push(R),R}I(t,{onObjectBegin:R=>{i=o({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,O,E)=>{i=o({type:"property",offset:O,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:O,length:E,parent:i})},onObjectEnd:(R,O)=>{i.length=R+O-i.offset,i=i.parent,n(R+O)},onArrayBegin:(R,O)=>{i=o({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,O)=>{i.length=R+O-i.offset,i=i.parent,n(R+O)},onLiteralValue:(R,O,E)=>{o({type:u(R),offset:O,length:E,parent:i,value:R}),n(O+E)},onSeparator:(R,O,E)=>{i.type==="property"&&(R===":"?i.colonOffset=O:R===","&&n(O))},onError:(R,O,E)=>{s.push({error:R,offset:O,length:E})}},r);const y=i.children[0];return y&&delete y.parent,y}function c(t,s){if(!t)return;let r=t;for(const i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function g(t){if(!t.parent||!t.parent.children)return[];const s=g(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const s=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=b(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}function p(t,s,r=!1){if(f(t,s,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const o=p(i[n],s,r);if(o)return o}return t}}function I(t,s,r=L.DEFAULT){const i=C(t,!1);function n(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(ce){return ce?q=>ce(q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(s.onObjectBegin),y=o(s.onObjectProperty),R=n(s.onObjectEnd),O=n(s.onArrayBegin),E=n(s.onArrayEnd),v=o(s.onLiteralValue),T=o(s.onSeparator),U=n(s.onComment),F=o(s.onError),M=r&&r.disallowComments,X=r&&r.allowTrailingComma;function K(){for(;;){const ce=i.scan();switch(i.getTokenError()){case P.InvalidUnicode:Q(N.InvalidUnicode);break;case P.InvalidEscapeCharacter:Q(N.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:Q(N.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:M||Q(N.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:Q(N.UnexpectedEndOfString);break;case P.InvalidCharacter:Q(N.InvalidCharacter);break}switch(ce){case a.LineCommentTrivia:case a.BlockCommentTrivia:M?Q(N.InvalidCommentToken):U();break;case a.Unknown:Q(N.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ce}}}function Q(ce,q=[],x=[]){if(F(ce),q.length+x.length>0){let J=i.getToken();for(;J!==a.EOF;){if(q.indexOf(J)!==-1){K();break}else if(x.indexOf(J)!==-1)break;J=K()}}}function G(ce){const q=i.getTokenValue();return ce?v(q):y(q),K(),!0}function ie(){switch(i.getToken()){case a.NumericLiteral:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(Q(N.InvalidNumberFormat),ce=0)}catch{Q(N.InvalidNumberFormat)}v(ce);break}case a.NullKeyword:v(null);break;case a.TrueKeyword:v(!0);break;case a.FalseKeyword:v(!1);break;default:return!1}return K(),!0}function V(){return i.getToken()!==a.StringLiteral?(Q(N.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(G(!1),i.getToken()===a.ColonToken?(T(":"),K(),re()||Q(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):Q(N.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function z(){l(),K();let ce=!1;for(;i.getToken()!==a.CloseBraceToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||Q(N.ValueExpected,[],[]),T(","),K(),i.getToken()===a.CloseBraceToken&&X)break}else ce&&Q(N.CommaExpected,[],[]);V()||Q(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ce=!0}return R(),i.getToken()!==a.CloseBraceToken?Q(N.CloseBraceExpected,[a.CloseBraceToken],[]):K(),!0}function ee(){O(),K();let ce=!1;for(;i.getToken()!==a.CloseBracketToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||Q(N.ValueExpected,[],[]),T(","),K(),i.getToken()===a.CloseBracketToken&&X)break}else ce&&Q(N.CommaExpected,[],[]);re()||Q(N.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ce=!0}return E(),i.getToken()!==a.CloseBracketToken?Q(N.CloseBracketExpected,[a.CloseBracketToken],[]):K(),!0}function re(){switch(i.getToken()){case a.OpenBracketToken:return ee();case a.OpenBraceToken:return z();case a.StringLiteral:return G(!0);default:return ie()}}return K(),i.getToken()===a.EOF?r.allowEmptyContent?!0:(Q(N.ValueExpected,[],[]),!1):re()?(i.getToken()!==a.EOF&&Q(N.EndOfFileExpected,[],[]),!0):(Q(N.ValueExpected,[],[]),!1)}function d(t,s){const r=C(t),i=[];let n,o=0,l;do switch(l=r.getPosition(),n=r.scan(),n){case a.LineCommentTrivia:case a.BlockCommentTrivia:case a.EOF:o!==l&&i.push(t.substring(o,l)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(n!==a.EOF);return i.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[45],he([0,1,34]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=a,e.$6n=N,e.$7n=k,e.$8n=A;function a(w,S,m){let h,$,c,g,b;if(S){for(g=S.offset,b=g+S.length,c=g;c>0&&!A(w,c-1);)c--;let l=b;for(;l<w.length&&!A(w,l);)l++;$=w.substring(c,l),h=C($,m)}else $=w,h=0,c=0,g=0,b=w.length;const f=k(m,w);let p=!1,I=0,d;m.insertSpaces?d=L(" ",m.tabSize||4):d="	";const u=(0,P.$Sn)($,!1);let t=!1;function s(){return f+L(d,h+I)}function r(){let l=u.scan();for(p=!1;l===P.SyntaxKind.Trivia||l===P.SyntaxKind.LineBreakTrivia;)p=p||l===P.SyntaxKind.LineBreakTrivia,l=u.scan();return t=l===P.SyntaxKind.Unknown||u.getTokenError()!==P.ScanError.None,l}const i=[];function n(l,y,R){!t&&y<b&&R>g&&w.substring(y,R)!==l&&i.push({offset:y,length:R-y,content:l})}let o=r();if(o!==P.SyntaxKind.EOF){const l=u.getTokenOffset()+c,y=L(d,h);n(y,c,l)}for(;o!==P.SyntaxKind.EOF;){let l=u.getTokenOffset()+u.getTokenLength()+c,y=r(),R="";for(;!p&&(y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia);){const E=u.getTokenOffset()+c;n(" ",l,E),l=u.getTokenOffset()+u.getTokenLength()+c,R=y===P.SyntaxKind.LineCommentTrivia?s():"",y=r()}if(y===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(I--,R=s());else if(y===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(I--,R=s());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:I++,R=s();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:R=s();break;case P.SyntaxKind.BlockCommentTrivia:p?R=s():R=" ";break;case P.SyntaxKind.ColonToken:R=" ";break;case P.SyntaxKind.StringLiteral:if(y===P.SyntaxKind.ColonToken){R="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia?R=" ":y!==P.SyntaxKind.CommaToken&&y!==P.SyntaxKind.EOF&&(t=!0);break;case P.SyntaxKind.Unknown:t=!0;break}p&&(y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia)&&(R=s())}const O=u.getTokenOffset()+c;n(R,l,O),o=y}return i}function N(w,S){const m=JSON.stringify(w,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?m.replace(/\r\n|\r|\n/g,S.eol):m}function L(w,S){let m="";for(let h=0;h<S;h++)m+=w;return m}function C(w,S){let m=0,h=0;const $=S.tabSize||4;for(;m<w.length;){const c=w.charAt(m);if(c===" ")h++;else if(c==="	")h+=$;else break;m++}return Math.floor(h/$)}function k(w,S){for(let m=0;m<S.length;m++){const h=S.charAt(m);if(h==="\r")return m+1<S.length&&S.charAt(m+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return w&&w.eol||`
`}function A(w,S){return`\r
`.indexOf(w.charAt(S))!==-1}}),define(le[64],he([0,1,34,45]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=N,e.$0n=L,e.$$n=C,e.$_n=k,e.$ao=A;function N(w,S,m){return L(w,S,void 0,m)}function L(w,S,m,h,$){const c=S.slice(),g=[],b=(0,P.$Vn)(w,g);let f,p;for(;c.length>0&&(p=c.pop(),f=(0,P.$Wn)(b,c),f===void 0&&m!==void 0);)typeof p=="string"?m={[p]:m}:m=[m];if(f)if(f.type==="object"&&typeof p=="string"&&Array.isArray(f.children)){const I=(0,P.$Wn)(f,[p]);if(I!==void 0)if(m===void 0){if(!I.parent)throw new Error("Malformed AST");const d=f.children.indexOf(I.parent);let u,t=I.parent.offset+I.parent.length;if(d>0){const s=f.children[d-1];u=s.offset+s.length}else u=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return C(w,{offset:u,length:t-u,content:""},h)}else return C(w,{offset:I.offset,length:I.length,content:JSON.stringify(m)},h);else{if(m===void 0)return[];const d=`${JSON.stringify(p)}: ${JSON.stringify(m)}`,u=$?$(f.children.map(s=>s.children[0].value)):f.children.length;let t;if(u>0){const s=f.children[u-1];t={offset:s.offset+s.length,length:0,content:","+d}}else f.children.length===0?t={offset:f.offset+1,length:0,content:d}:t={offset:f.offset+1,length:0,content:d+","};return C(w,t,h)}}else if(f.type==="array"&&typeof p=="number"&&Array.isArray(f.children))if(m!==void 0){const I=`${JSON.stringify(m)}`;let d;if(f.children.length===0||p===0)d={offset:f.offset+1,length:0,content:f.children.length===0?I:I+","};else{const u=p===-1||p>f.children.length?f.children.length:p,t=f.children[u-1];d={offset:t.offset+t.length,length:0,content:","+I}}return C(w,d,h)}else{const I=p,d=f.children[I];let u;if(f.children.length===1)u={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===I){const t=f.children[I-1],s=t.offset+t.length,r=f.offset+f.length;u={offset:s,length:r-2-s,content:""}}else u={offset:d.offset,length:f.children[I+1].offset-d.offset,content:""};return C(w,u,h)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${f.type}`);else return m===void 0?[]:C(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(m)},h)}function C(w,S,m){let h=k(w,S),$=S.offset,c=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;$>0&&!(0,a.$8n)(h,$-1);)$--;for(;c<h.length&&!(0,a.$8n)(h,c);)c++}const g=(0,a.$5n)(h,{offset:$,length:c-$},m);for(let f=g.length-1;f>=0;f--){const p=g[f];h=k(h,p),$=Math.min($,p.offset),c=Math.max(c,p.offset+p.length),c+=p.content.length-p.length}const b=w.length-(h.length-c)-$;return[{offset:$,length:b,content:h.substring($,c)}]}function k(w,S){return w.substring(0,S.offset)+S.content+w.substring(S.offset+S.length)}function A(w,S){const m=S.slice(0).sort(($,c)=>{const g=$.offset-c.offset;return g===0?$.length-c.length:g});let h=w.length;for(let $=m.length-1;$>=0;$--){const c=m[$];if(c.offset+c.length<=h)w=k(w,c);else throw new Error("Overlapping edit");h=c.offset}return w}}),define(le[54],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class P{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=P}),define(le[90],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(L){this.element=L,this.next=P.Undefined,this.prev=P.Undefined}}class a{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let L=this.a;for(;L!==P.Undefined;){const C=L.next;L.prev=P.Undefined,L.next=P.Undefined,L=C}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,C){const k=new P(L);if(this.a===P.Undefined)this.a=k,this.b=k;else if(C){const w=this.b;this.b=k,k.prev=w,w.next=k}else{const w=this.a;this.a=k,k.next=w,w.prev=k}this.c+=1;let A=!1;return()=>{A||(A=!0,this.e(k))}}shift(){if(this.a!==P.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==P.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==P.Undefined&&L.next!==P.Undefined){const C=L.prev;C.next=L.next,L.next.prev=C}else L.prev===P.Undefined&&L.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):L.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):L.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==P.Undefined;)yield L.element,L=L.next}}e.$6c=a}),define(le[35],he([0,1]),function(ne,e){"use strict";var P,a,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=L,e.$zc=C,e.$Ac=k,e.$Jc=d;function L(u,t,s){let r=u.get(t);return r===void 0&&(r=s,u.set(t,r)),r}function C(u){const t=[];return u.forEach((s,r)=>{t.push(`${r} => ${s}`)}),`Map(${u.size}) {${t.join(", ")}}`}function k(u){const t=[];return u.forEach(s=>{t.push(s)}),`Set(${u.size}) {${t.join(", ")}}`}class A{constructor(t,s){this.uri=t,this.value=s}}function w(u){return Array.isArray(u)}class S{static{this.c=t=>t.toString()}constructor(t,s){if(this[P]="ResourceMap",t instanceof S)this.d=new Map(t.d),this.e=s??S.c;else if(w(t)){this.d=new Map,this.e=s??S.c;for(const[r,i]of t)this.set(r,i)}else this.d=new Map,this.e=t??S.c}set(t,s){return this.d.set(this.e(t),new A(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[r,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=S;class m{constructor(t,s){this[a]="ResourceSet",!t||typeof t=="function"?this.c=new S(t):(this.c=new S(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((r,i)=>t.call(s,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=m;var h;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class ${constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=h.None){const r=this.c.get(t);if(r)return s!==h.None&&this.m(r,s),r.value}set(t,s,r=h.None){let i=this.c.get(t);if(i)i.value=s,r!==h.None&&this.m(i,r);else{switch(i={key:t,value:s,next:void 0,previous:void 0},r){case h.None:this.k(i);break;case h.AsOld:this.j(i);break;case h.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const r=this.g;let i=this.d;for(;i;){if(s?t.bind(s)(i.value,i.key,this):t(i.value,i.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.key,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.value,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:[r.key,r.value],done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.next,r--;this.d=s,this.f=r,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.previous,r--;this.e=s,this.f=r,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,r=t.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==h.AsOld&&s!==h.AsNew)){if(s===h.AsOld){if(t===this.d)return;const r=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(r.previous=i,i.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===h.AsNew){if(t===this.e)return;const r=t.next,i=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=i,i.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,r)=>{t.push([r,s])}),t}fromJSON(t){this.clear();for(const[s,r]of t)this.set(s,r)}}e.$Dc=$;class c extends ${constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=h.AsNew){return super.get(t,s)}peek(t){return super.get(t,h.None)}set(t,s){return super.set(t,s,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends c{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Ec=g;class b extends c{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Fc=b;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Gc=f;class p{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,r]of t)this.set(s,r)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((r,i)=>{t.call(s,r,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=p;class I{constructor(){this.c=new Map}add(t,s){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(s)}delete(t,s){const r=this.c.get(t);r&&(r.delete(s),r.size===0&&this.c.delete(t))}forEach(t,s){const r=this.c.get(t);r&&r.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Ic=I;function d(u,t){if(u===t)return!0;if(u.size!==t.size)return!1;for(const[s,r]of u)if(!t.has(s)||t.get(s)!==r)return!1;for(const[s]of t)if(!u.has(s))return!1;return!0}}),define(le[2],he([0,1,19,131,35,89,63]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=S,e.$Mc=m,e.$Nc=h,e.$Oc=g,e.$Pc=b,e.$Qc=f,e.$Rc=p,e.$Sc=I,e.$Tc=d,e.$4c=R;const k=!1;let A=null;class w{constructor(){this.b=new Map}static{this.a=0}c(v){let T=this.b.get(v);return T||(T={parent:null,source:null,isSingleton:!1,value:v,idx:w.a++},this.b.set(v,T)),T}trackDisposable(v){const T=this.c(v);T.source||(T.source=new Error().stack)}setParent(v,T){const U=this.c(v);U.parent=T}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,T){const U=T.get(v);if(U)return U;const F=v.parent?this.f(this.c(v.parent),T):v;return T.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,T){let U;if(T)U=T;else{const Q=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,Q).isSingleton);if(G.length===0)return;const ie=new Set(G.map(V=>V.value));if(U=G.filter(V=>!(V.parent&&ie.has(V.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(Q){function G(V,z){for(;V.length>0&&z.some(ee=>typeof ee=="string"?ee===V[0]:V[0].match(ee));)V.shift()}const ie=Q.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new N.$Ic;for(const Q of U){const G=F(Q);for(let ie=0;ie<=G.length;ie++)M.add(G.slice(0,ie).join(`
`),Q)}U.sort((0,P.$7b)(Q=>Q.idx,P.$9b));let X="",K=0;for(const Q of U.slice(0,v)){K++;const G=F(Q),ie=[];for(let V=0;V<G.length;V++){let z=G[V];z=`(shared with ${M.get(G.slice(0,V+1).join(`
`)).size}/${U.length} leaks) at ${z}`;const re=M.get(G.slice(0,V).join(`
`)),ce=(0,a.$K)([...re].map(q=>F(q)[V]),q=>q);delete ce[G[V]];for(const[q,x]of Object.entries(ce))ie.unshift(`    - stacktraces of ${x.length} other leaks continue with ${q}`);ie.unshift(z)}X+=`


==================== Leaking disposable ${K}/${U.length}: ${Q.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return U.length>v&&(X+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:X}}}e.$Kc=w;function S(E){A=E}if(k){const E="__is_disposable_tracked__";S(new class{trackDisposable(v){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[E]||console.log(T)},3e3)}setParent(v,T){if(v&&v!==t.None)try{v[E]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[E]=!0}catch{}}markAsSingleton(v){}})}function m(E){return A?.trackDisposable(E),E}function h(E){A?.markAsDisposed(E)}function $(E,v){A?.setParent(E,v)}function c(E,v){if(A)for(const T of E)A.setParent(T,v)}function g(E){return A?.markAsSingleton(E),E}function b(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function f(E){if(C.Iterable.is(E)){const v=[];for(const T of E)if(T)try{T.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function p(E){for(const v of E)b(v)&&v.dispose();return[]}function I(...E){const v=d(()=>f(E));return c(E,v),v}function d(E){const v=m({dispose:(0,L.$eb)(()=>{h(v),E()})});return v}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return $(v,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),$(v,null))}}e.$Uc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,m(this),$(this.q,this)}dispose(){h(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Vc=t;class s{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&$(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&$(v,null),v}}e.$Wc=s;class r{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class i{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(v){let T=v;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,h(this))},this}}e.$Zc=n;class o{constructor(){this.a=new Map}acquire(v,...T){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...T)},this.a.set(v,U));const{object:F}=U,M=(0,L.$eb)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:F,dispose:M}}}e.$1c=o;class l{constructor(v){this.a=v}async acquire(v,...T){const U=this.a.acquire(v,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$2c=l;class y{constructor(v){this.object=v}dispose(){}}e.$3c=y;function R(E){const v=new u;try{E(v)}finally{v.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,T)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const T=this.a.get(v);return this.a.delete(v),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=O}),define(le[65],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(le[91],he([0,1,35]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=void 0,e.$lm=N,e.$mm=C;const a=new P.$Ec(1e4);function N(w){return A(w,"NFC",a)}const L=new P.$Ec(1e4);function C(w){return A(w,"NFD",L)}const k=/[^\u0000-\u0080]/;function A(w,S,m){if(!w)return w;const h=m.get(w);if(h)return h;let $;return k.test(w)?$=w.normalize(S):$=w,m.set(w,$),$}e.$nm=function(){const w=/[\u0300-\u036f]/g;return function(S){return C(S).replace(w,"")}}()}),function(){function ne(N){const L=[];typeof N=="number"&&L.push("code/timeOrigin",N);function C(A){L.push(A,Date.now())}function k(){const A=[];for(let w=0;w<L.length;w+=2)A.push({name:L[w],startTime:L[w+1]});return A}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(N+C.startTime)});return L}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function P(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=P(a))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var a in P)(typeof exports=="object"?exports:ne)[a]=P[a]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function P(a){if(e[a])return e[a].exports;var N=e[a]={i:a,l:!1,exports:{}};return ne[a].call(N.exports,N,N.exports,P),N.l=!0,N.exports}return P.m=ne,P.c=e,P.d=function(a,N,L){P.o(a,N)||Object.defineProperty(a,N,{enumerable:!0,get:L})},P.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},P.t=function(a,N){if(1&N&&(a=P(a)),8&N||4&N&&typeof a=="object"&&a&&a.__esModule)return a;var L=Object.create(null);if(P.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:a}),2&N&&typeof a!="string")for(var C in a)P.d(L,C,function(k){return a[k]}.bind(null,C));return L},P.n=function(a){var N=a&&a.__esModule?function(){return a.default}:function(){return a};return P.d(N,"a",N),N},P.o=function(a,N){return Object.prototype.hasOwnProperty.call(a,N)},P.p="",P(P.s=0)}([function(ne,e,P){(function(a){var N;e=ne.exports=x,N=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],A=e.src=[],w=0,S=w++;A[S]="0|[1-9]\\d*";var m=w++;A[m]="[0-9]+";var h=w++;A[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;A[$]="("+A[S]+")\\.("+A[S]+")\\.("+A[S]+")";var c=w++;A[c]="("+A[m]+")\\.("+A[m]+")\\.("+A[m]+")";var g=w++;A[g]="(?:"+A[S]+"|"+A[h]+")";var b=w++;A[b]="(?:"+A[m]+"|"+A[h]+")";var f=w++;A[f]="(?:-("+A[g]+"(?:\\."+A[g]+")*))";var p=w++;A[p]="(?:-?("+A[b]+"(?:\\."+A[b]+")*))";var I=w++;A[I]="[0-9A-Za-z-]+";var d=w++;A[d]="(?:\\+("+A[I]+"(?:\\."+A[I]+")*))";var u=w++,t="v?"+A[$]+A[f]+"?"+A[d]+"?";A[u]="^"+t+"$";var s="[v=\\s]*"+A[c]+A[p]+"?"+A[d]+"?",r=w++;A[r]="^"+s+"$";var i=w++;A[i]="((?:<|>)?=?)";var n=w++;A[n]=A[m]+"|x|X|\\*";var o=w++;A[o]=A[S]+"|x|X|\\*";var l=w++;A[l]="[v=\\s]*("+A[o]+")(?:\\.("+A[o]+")(?:\\.("+A[o]+")(?:"+A[f]+")?"+A[d]+"?)?)?";var y=w++;A[y]="[v=\\s]*("+A[n]+")(?:\\.("+A[n]+")(?:\\.("+A[n]+")(?:"+A[p]+")?"+A[d]+"?)?)?";var R=w++;A[R]="^"+A[i]+"\\s*"+A[l]+"$";var O=w++;A[O]="^"+A[i]+"\\s*"+A[y]+"$";var E=w++;A[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=w++;A[v]="(?:~>?)";var T=w++;A[T]="(\\s*)"+A[v]+"\\s+",k[T]=new RegExp(A[T],"g");var U=w++;A[U]="^"+A[v]+A[l]+"$";var F=w++;A[F]="^"+A[v]+A[y]+"$";var M=w++;A[M]="(?:\\^)";var X=w++;A[X]="(\\s*)"+A[M]+"\\s+",k[X]=new RegExp(A[X],"g");var K=w++;A[K]="^"+A[M]+A[l]+"$";var Q=w++;A[Q]="^"+A[M]+A[y]+"$";var G=w++;A[G]="^"+A[i]+"\\s*("+s+")$|^$";var ie=w++;A[ie]="^"+A[i]+"\\s*("+t+")$|^$";var V=w++;A[V]="(\\s*)"+A[i]+"\\s*("+s+"|"+A[l]+")",k[V]=new RegExp(A[V],"g");var z=w++;A[z]="^\\s*("+A[l]+")\\s+-\\s+("+A[l]+")\\s*$";var ee=w++;A[ee]="^\\s*("+A[y]+")\\s+-\\s+("+A[y]+")\\s*$";var re=w++;A[re]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)N(ce,A[ce]),k[ce]||(k[ce]=new RegExp(A[ce]));function q(oe,de){if(oe instanceof x)return oe;if(typeof oe!="string"||oe.length>L||!(de?k[r]:k[u]).test(oe))return null;try{return new x(oe,de)}catch{return null}}function x(oe,de){if(oe instanceof x){if(oe.loose===de)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof x))return new x(oe,de);N("SemVer",oe,de),this.loose=de;var me=oe.trim().match(de?k[r]:k[u]);if(!me)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<C)return Oe}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(oe,de){var me=q(oe,de);return me?me.version:null},e.clean=function(oe,de){var me=q(oe.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(oe){return N("SemVer.compare",this.version,this.loose,oe),oe instanceof x||(oe=new x(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},x.prototype.compareMain=function(oe){return oe instanceof x||(oe=new x(oe,this.loose)),H(this.major,oe.major)||H(this.minor,oe.minor)||H(this.patch,oe.patch)},x.prototype.comparePre=function(oe){if(oe instanceof x||(oe=new x(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=oe.prerelease[de];if(N("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return H(me,Pe)}while(++de)},x.prototype.inc=function(oe,de){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new x(oe,me).inc(de,Pe).version}catch{return null}},e.diff=function(oe,de){if(W(oe,de))return null;var me=q(oe),Pe=q(de);if(me.prerelease.length||Pe.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=H;var J=/^[0-9]+$/;function H(oe,de){var me=J.test(oe),Pe=J.test(de);return me&&Pe&&(oe=+oe,de=+de),me&&!Pe?-1:Pe&&!me?1:oe<de?-1:oe>de?1:0}function D(oe,de,me){return new x(oe,me).compare(new x(de,me))}function B(oe,de,me){return D(oe,de,me)>0}function j(oe,de,me){return D(oe,de,me)<0}function W(oe,de,me){return D(oe,de,me)===0}function te(oe,de,me){return D(oe,de,me)!==0}function _(oe,de,me){return D(oe,de,me)>=0}function Y(oe,de,me){return D(oe,de,me)<=0}function ae(oe,de,me,Pe){var Oe;switch(de){case"===":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),Oe=oe===me;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),Oe=oe!==me;break;case"":case"=":case"==":Oe=W(oe,me,Pe);break;case"!=":Oe=te(oe,me,Pe);break;case">":Oe=B(oe,me,Pe);break;case">=":Oe=_(oe,me,Pe);break;case"<":Oe=j(oe,me,Pe);break;case"<=":Oe=Y(oe,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function ue(oe,de){if(oe instanceof ue){if(oe.loose===de)return oe;oe=oe.value}if(!(this instanceof ue))return new ue(oe,de);N("comparator",oe,de),this.loose=de,this.parse(oe),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(oe,de){return H(de,oe)},e.major=function(oe,de){return new x(oe,de).major},e.minor=function(oe,de){return new x(oe,de).minor},e.patch=function(oe,de){return new x(oe,de).patch},e.compare=D,e.compareLoose=function(oe,de){return D(oe,de,!0)},e.rcompare=function(oe,de,me){return D(de,oe,me)},e.sort=function(oe,de){return oe.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(oe,de){return oe.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=B,e.lt=j,e.eq=W,e.neq=te,e.gte=_,e.lte=Y,e.cmp=ae,e.Comparator=ue;var ge={};function we(oe,de){if(oe instanceof we)return oe.loose===de?oe:new we(oe.raw,de);if(oe instanceof ue)return new we(oe.value,de);if(!(this instanceof we))return new we(oe,de);if(this.loose=de,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ee(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function pe(oe,de,me,Pe,Oe,Fe,Ce,Ae,Ue,qe,He,Me,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(Oe)?">="+me+"."+Pe+".0":">="+de)+" "+(Ae=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+qe+1)+".0":Me?"<="+Ue+"."+qe+"."+He+"-"+Me:"<="+Ae)).trim()}function be(oe,de){for(var me=0;me<oe.length;me++)if(!oe[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<oe.length;me++)if(N(oe[me].semver),oe[me].semver!==ge&&oe[me].semver.prerelease.length>0){var Pe=oe[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(oe,de,me){try{de=new we(de,me)}catch{return!1}return de.test(oe)}function Ie(oe,de,me,Pe){var Oe,Fe,Ce,Ae,Ue;switch(oe=new x(oe,Pe),de=new we(de,Pe),me){case">":Oe=B,Fe=Y,Ce=j,Ae=">",Ue=">=";break;case"<":Oe=j,Fe=_,Ce=B,Ae="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(oe,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],Me=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new ue(">=0.0.0")),Me=Me||ze,Be=Be||ze,Oe(ze.semver,Me.semver,Pe)?Me=ze:Ce(ze.semver,Be.semver,Pe)&&(Be=ze)}),Me.operator===Ae||Me.operator===Ue||(!Be.operator||Be.operator===Ae)&&Fe(oe,Be.semver)||Be.operator===Ue&&Ce(oe,Be.semver))return!1}return!0}ue.prototype.parse=function(oe){var de=this.loose?k[G]:k[ie],me=oe.match(de);if(!me)throw new TypeError("Invalid comparator: "+oe);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new x(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(oe){return N("Comparator.test",oe,this.loose),this.semver===ge||(typeof oe=="string"&&(oe=new x(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(oe,de){if(!(oe instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(oe.value,de),Se(this.value,me,de);if(oe.operator==="")return me=new we(this.value,de),Se(oe.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Fe=this.semver.version===oe.semver.version,Ce=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Ae=ae(this.semver,"<",oe.semver,de)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ue=ae(this.semver,">",oe.semver,de)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Pe||Oe||Fe&&Ce||Ae||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(oe){var de=this.loose;oe=oe.trim(),N("range",oe,de);var me=de?k[ee]:k[z];oe=oe.replace(me,pe),N("hyphen replace",oe),oe=oe.replace(k[V],"$1$2$3"),N("comparator trim",oe,k[V]),oe=(oe=(oe=oe.replace(k[T],"$1~")).replace(k[X],"$1^")).split(/\s+/).join(" ");var Pe=de?k[G]:k[ie],Oe=oe.split(" ").map(function(Fe){return function(Ce,Ae){return N("comp",Ce),Ce=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){N("caret",Me,Be);var ze=Be?k[Q]:k[K];return Me.replace(ze,function(We,Ne,se,fe,$e){var ye;return N("caret",Me,We,Ne,se,fe,$e),Ee(Ne)?ye="":Ee(se)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ee(fe)?ye=Ne==="0"?">="+Ne+"."+se+".0 <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+".0 <"+(+Ne+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ne==="0"?se==="0"?">="+Ne+"."+se+"."+fe+$e+" <"+Ne+"."+se+"."+(+fe+1):">="+Ne+"."+se+"."+fe+$e+" <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+"."+fe+$e+" <"+(+Ne+1)+".0.0"):(N("no pr"),ye=Ne==="0"?se==="0"?">="+Ne+"."+se+"."+fe+" <"+Ne+"."+se+"."+(+fe+1):">="+Ne+"."+se+"."+fe+" <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+"."+fe+" <"+(+Ne+1)+".0.0"),N("caret return",ye),ye})}(He,qe)}).join(" ")}(Ce,Ae),N("caret",Ce),Ce=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){var ze=Be?k[F]:k[U];return Me.replace(ze,function(We,Ne,se,fe,$e){var ye;return N("tilde",Me,We,Ne,se,fe,$e),Ee(Ne)?ye="":Ee(se)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ee(fe)?ye=">="+Ne+"."+se+".0 <"+Ne+"."+(+se+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ne+"."+se+"."+fe+$e+" <"+Ne+"."+(+se+1)+".0"):ye=">="+Ne+"."+se+"."+fe+" <"+Ne+"."+(+se+1)+".0",N("tilde return",ye),ye})}(He,qe)}).join(" ")}(Ce,Ae),N("tildes",Ce),Ce=function(Ue,qe){return N("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(Me,Be){Me=Me.trim();var ze=Be?k[O]:k[R];return Me.replace(ze,function(We,Ne,se,fe,$e,ye){N("xRange",Me,We,Ne,se,fe,$e,ye);var Le=Ee(se),Te=Le||Ee(fe),je=Te||Ee($e);return Ne==="="&&je&&(Ne=""),Le?We=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&je?(Te&&(fe=0),je&&($e=0),Ne===">"?(Ne=">=",Te?(se=+se+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Ne==="<="&&(Ne="<",Te?se=+se+1:fe=+fe+1),We=Ne+se+"."+fe+"."+$e):Te?We=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),N("xRange return",We),We})}(He,qe)}).join(" ")}(Ce,Ae),N("xrange",Ce),Ce=function(Ue,qe){return N("replaceStars",Ue,qe),Ue.trim().replace(k[re],"")}(Ce,Ae),N("stars",Ce),Ce}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Fe){return!!Fe.match(Pe)})),Oe=Oe.map(function(Fe){return new ue(Fe,de)})},we.prototype.intersects=function(oe,de){if(!(oe instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return oe.set.some(function(Oe){return Oe.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(oe,de){return new we(oe,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new x(oe,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],oe))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(oe,de,me){var Pe=null,Oe=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Ce){Fe.test(Ce)&&(Pe&&Oe.compare(Ce)!==-1||(Oe=new x(Pe=Ce,me)))}),Pe},e.minSatisfying=function(oe,de,me){var Pe=null,Oe=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Ce){Fe.test(Ce)&&(Pe&&Oe.compare(Ce)!==1||(Oe=new x(Pe=Ce,me)))}),Pe},e.validRange=function(oe,de){try{return new we(oe,de).range||"*"}catch{return null}},e.ltr=function(oe,de,me){return Ie(oe,de,"<",me)},e.gtr=function(oe,de,me){return Ie(oe,de,">",me)},e.outside=Ie,e.prerelease=function(oe,de){var me=q(oe,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(oe,de,me){return oe=new we(oe,me),de=new we(de,me),oe.intersects(de)},e.coerce=function(oe){if(oe instanceof x)return oe;if(typeof oe!="string")return null;var de=oe.match(k[E]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(ne,e){var P,a,N=ne.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(b){if(P===setTimeout)return setTimeout(b,0);if((P===L||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:L}catch{P=L}try{a=typeof clearTimeout=="function"?clearTimeout:C}catch{a=C}})();var A,w=[],S=!1,m=-1;function h(){S&&A&&(S=!1,A.length?w=A.concat(w):m=-1,w.length&&$())}function $(){if(!S){var b=k(h);S=!0;for(var f=w.length;f;){for(A=w,w=[];++m<f;)A&&A[m].run();m=-1,f=w.length}A=null,S=!1,function(p){if(a===clearTimeout)return clearTimeout(p);if((a===C||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(p);try{a(p)}catch{try{return a.call(null,p)}catch{return a.call(this,p)}}}(b)}}function c(b,f){this.fun=b,this.array=f}function g(){}N.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];w.push(new c(b,f)),w.length!==1||S||k($)},c.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=g,N.addListener=g,N.once=g,N.off=g,N.removeListener=g,N.removeAllListeners=g,N.emit=g,N.prependListener=g,N.prependOnceListener=g,N.listeners=function(b){return[]},N.binding=function(b){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(b){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(le[133],he([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0;class a{constructor(k,A,w){this.level=k,this.key=A,this.value=w,this.forward=[]}}const N=void 0;class L{constructor(k,A=2**16){this.comparator=k,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(A)|0),this.e=new a(this.c,N,N)}get size(){return this.f}clear(){this.e=new a(this.c,N,N),this.f=0}has(k){return!!L.g(this,k,this.comparator)}get(k){return L.g(this,k,this.comparator)?.value}set(k,A){return L.h(this,k,A,this.comparator)&&(this.f+=1),this}delete(k){const A=L.k(this,k,this.comparator);return A&&(this.f-=1),A}forEach(k,A){let w=this.e.forward[0];for(;w;)k.call(A,w.value,w.key,this),w=w.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",A=this.e.forward[0];for(;A;)k+=`node(${A.key}, ${A.value}, lvl:${A.level})`,A=A.forward[0];return k}static g(k,A,w){let S=k.e;for(let m=k.d-1;m>=0;m--)for(;S.forward[m]&&w(S.forward[m].key,A)<0;)S=S.forward[m];if(S=S.forward[0],S&&w(S.key,A)===0)return S}static h(k,A,w,S){const m=[];let h=k.e;for(let $=k.d-1;$>=0;$--){for(;h.forward[$]&&S(h.forward[$].key,A)<0;)h=h.forward[$];m[$]=h}if(h=h.forward[0],h&&S(h.key,A)===0)return h.value=w,!1;{const $=L.j(k);if($>k.d){for(let c=k.d;c<$;c++)m[c]=k.e;k.d=$}h=new a($,A,w);for(let c=0;c<$;c++)h.forward[c]=m[c].forward[c],m[c].forward[c]=h;return!0}}static j(k,A=.5){let w=1;for(;Math.random()<A&&w<k.c;)w+=1;return w}static k(k,A,w){const S=[];let m=k.e;for(let h=k.d-1;h>=0;h--){for(;m.forward[h]&&w(m.forward[h].key,A)<0;)m=m.forward[h];S[h]=m}if(m=m.forward[0],!m||w(m.key,A)!==0)return!1;for(let h=0;h<k.d&&S[h].forward[h]===m;h++)S[h].forward[h]=m.forward[h];for(;k.d>0&&k.e.forward[k.d-1]===N;)k.d-=1;return!0}}e.$Ms=L}),define(le[55],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(L){return new a(L)}constructor(L){this.c=P&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=a}),define(le[3],he([0,1,8,89,2,90,55]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=$;const k=!1,A=!1,w=!1;var S;(function(F){F.None=()=>N.$Vc.None;function M(pe){if(w){const{onDidAddListener:be}=pe,Se=g.create();let Ie=0;pe.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function X(pe,be){return q(pe,()=>{},0,void 0,!0,void 0,be)}F.defer=X;function K(pe){return(be,Se=null,Ie)=>{let oe=!1,de;return de=pe(me=>{if(!oe)return de?de.dispose():oe=!0,be.call(Se,me)},null,Ie),oe&&de.dispose(),de}}F.once=K;function Q(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>Ie.call(oe,be(me)),null,de),Se)}F.map=Q;function G(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>{be(me),Ie.call(oe,me)},null,de),Se)}F.forEach=G;function ie(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>be(me)&&Ie.call(oe,me),null,de),Se)}F.filter=ie;function V(pe){return pe}F.signal=V;function z(...pe){return(be,Se=null,Ie)=>{const oe=(0,N.$Sc)(...pe.map(de=>de(me=>be.call(Se,me))));return ce(oe,Ie)}}F.any=z;function ee(pe,be,Se,Ie){let oe=Se;return Q(pe,de=>(oe=be(oe,de),oe),Ie)}F.reduce=ee;function re(pe,be){let Se;const Ie={onWillAddFirstListener(){Se=pe(oe.fire,oe)},onDidRemoveLastListener(){Se?.dispose()}};be||M(Ie);const oe=new s(Ie);return be?.add(oe),oe.event}function ce(pe,be){return be instanceof Array?be.push(pe):be&&be.add(pe),pe}function q(pe,be,Se=100,Ie=!1,oe=!1,de,me){let Pe,Oe,Fe,Ce=0,Ae;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=pe(He=>{Ce++,Oe=be(Oe,He),Ie&&!Fe&&(qe.fire(Oe),Oe=void 0),Ae=()=>{const Me=Oe;Oe=void 0,Fe=void 0,(!Ie||Ce>1)&&qe.fire(Me),Ce=0},typeof Se=="number"?(clearTimeout(Fe),Fe=setTimeout(Ae,Se)):Fe===void 0&&(Fe=0,queueMicrotask(Ae))})},onWillRemoveListener(){oe&&Ce>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,Pe.dispose()}};me||M(Ue);const qe=new s(Ue);return me?.add(qe),qe.event}F.debounce=q;function x(pe,be=0,Se){return F.debounce(pe,(Ie,oe)=>Ie?(Ie.push(oe),Ie):[oe],be,void 0,!0,void 0,Se)}F.accumulate=x;function J(pe,be=(Ie,oe)=>Ie===oe,Se){let Ie=!0,oe;return ie(pe,de=>{const me=Ie||!be(de,oe);return Ie=!1,oe=de,me},Se)}F.latch=J;function H(pe,be,Se){return[F.filter(pe,be,Se),F.filter(pe,Ie=>!be(Ie),Se)]}F.split=H;function D(pe,be=!1,Se=[],Ie){let oe=Se.slice(),de=pe(Oe=>{oe?oe.push(Oe):Pe.fire(Oe)});Ie&&Ie.add(de);const me=()=>{oe?.forEach(Oe=>Pe.fire(Oe)),oe=null},Pe=new s({onWillAddFirstListener(){de||(de=pe(Oe=>Pe.fire(Oe)),Ie&&Ie.add(de))},onDidAddFirstListener(){oe&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}F.buffer=D;function B(pe,be){return(Ie,oe,de)=>{const me=be(new W);return pe(function(Pe){const Oe=me.evaluate(Pe);Oe!==j&&Ie.call(oe,Oe)},void 0,de)}}F.chain=B;const j=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:j),this}reduce(be,Se){let Ie=Se;return this.f.push(oe=>(Ie=be(Ie,oe),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(oe=>{const de=Se||!be(oe,Ie);return Se=!1,Ie=oe,de?oe:j}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===j)break;return be}}function te(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.on(be,Ie),de=()=>pe.removeListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}F.fromNodeEventEmitter=te;function _(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.addEventListener(be,Ie),de=()=>pe.removeEventListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}F.fromDOMEventEmitter=_;function Y(pe){return new Promise(be=>K(pe)(be))}F.toPromise=Y;function ae(pe){const be=new s;return pe.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}F.fromPromise=ae;function ue(pe,be,Se){return be(Se),pe(Ie=>be(Ie))}F.runAndSubscribe=ue;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||M(Ie),this.emitter=new s(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(pe,be){return new ge(pe,be).emitter.event}F.fromObservable=we;function Ee(pe){return(be,Se,Ie)=>{let oe=0,de=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(pe.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};pe.addObserver(me),pe.reportChanges();const Pe={dispose(){pe.removeObserver(me)}};return Ie instanceof N.$Uc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}F.fromObservableLight=Ee})(S||(e.Event=S={}));class m{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${m.f++}`,m.all.add(this)}start(M){this.g=new C.$fe,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$he=m;let h=-1;function $(F){const M=h;return h=F,{dispose(){h=M}}}class c{constructor(M,X,K=Math.random().toString(18).slice(2,5)){this.h=M,this.threshold=X,this.name=K,this.g=0}dispose(){this.f?.clear()}check(M,X){const K=this.threshold;if(K<=0||X<K)return;this.f||(this.f=new Map);const Q=this.f.get(M.value)||0;if(this.f.set(M.value,Q+1),this.g-=1,this.g<=0){this.g=K*.5;const[G,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(G);const z=new b(V,G);this.h(z)}return()=>{const G=this.f.get(M.value)||0;this.f.set(M.value,G-1)}}getMostFrequentStack(){if(!this.f)return;let M,X=0;for(const[K,Q]of this.f)(!M||X<Q)&&(M=[K,Q],X=Q);return M}}class g{static create(){const M=new Error;return new g(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b extends Error{constructor(M,X){super(M),this.name="ListenerLeakError",this.stack=X}}e.$je=b;class f extends Error{constructor(M,X){super(M),this.name="ListenerRefusalError",this.stack=X}}e.$ke=f;let p=0;class I{constructor(M){this.value=M,this.id=p++}}const d=2,u=(F,M)=>{if(F instanceof I)M(F);else for(let X=0;X<F.length;X++){const K=F[X];K&&M(K)}};let t;if(k){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),t=new FinalizationRegistry(M=>{typeof M=="string"&&F.push(M)})}class s{constructor(M){this.z=0,this.f=M,this.g=h>0||this.f?.leakWarningThreshold?new c(M?.onListenerError??P.$2,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(A){const M=this.u;queueMicrotask(()=>{u(M,X=>X.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,X,K)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new f(`${z}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||P.$2)(re),N.$Vc.None}if(this.m)return N.$Vc.None;X&&(M=M.bind(X));const Q=new I(M);let G,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Q.stack=g.create(),G=this.g.check(Q.stack,this.z+1)),A&&(Q.stack=ie??g.create()),this.u?this.u instanceof I?(this.w??=new i,this.u=[this.u,Q]):this.u.push(Q):(this.f?.onWillAddFirstListener?.(this),this.u=Q,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,N.$Tc)(()=>{t?.unregister(V),G?.(),this.A(Q)});if(K instanceof N.$Uc?K.add(V):Array.isArray(K)&&K.push(V),t){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);t.register(V,ee?.[2]??z,V)}return V},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const X=this.u,K=X.indexOf(M);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,X[K]=void 0;const Q=this.w.current===this;if(this.z*d<=X.length){let G=0;for(let ie=0;ie<X.length;ie++)X[ie]?X[G++]=X[ie]:Q&&(this.w.end--,G<this.w.i&&this.w.i--);X.length=G}}B(M,X){if(!M)return;const K=this.f?.onListenerError||P.$2;if(!K){M.value(X);return}try{M.value(X)}catch(Q){K(Q)}}C(M){const X=M.current.u;for(;M.i<M.end;)this.B(X[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof I)this.B(this.u,M);else{const X=this.w;X.enqueue(this,M,this.u.length),this.C(X)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=s;const r=()=>new i;e.$me=r;class i{constructor(){this.i=-1,this.end=0}enqueue(M,X,K){this.i=0,this.end=K,this.current=M,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends s{async fireAsync(M,X,K){if(this.u)for(this.h||(this.h=new L.$6c),u(this.u,Q=>this.h.push([Q.value,M]));this.h.size>0&&!X.isCancellationRequested;){const[Q,G]=this.h.shift(),ie=[],V={...G,token:X,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");K&&(z=K(z,Q)),ie.push(z)}};try{Q(V)}catch(z){(0,P.$2)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,P.$2)(ee.reason)})}}}e.$ne=n;class o extends s{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new L.$6c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$oe=o;class l extends o{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$pe=l;class y extends s{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}e.$qe=y;class R{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const X={event:M,listener:null};this.h.push(X),this.g&&this.m(X);const K=()=>{this.g&&this.o(X);const Q=this.h.indexOf(X);this.h.splice(Q,1)};return(0,N.$Tc)((0,a.$eb)(K))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(X=>this.f.fire(X))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$re=R;class O{constructor(M,X,K,Q){this.f=new N.$Uc;const G=this.f.add(new R),ie=this.f.add(new N.$5c);function V(z){ie.set(z,G.add(Q(z)))}for(const z of M)V(z);this.f.add(X(z=>{V(z)})),this.f.add(K(z=>{ie.deleteAndDispose(z)})),this.event=G.event}dispose(){this.f.dispose()}}e.$se=O;class E{constructor(){this.f=[]}wrapEvent(M,X,K){return(Q,G,ie)=>M(V=>{const z=this.f[this.f.length-1];if(!X){z?z.buffers.push(()=>Q.call(G,V)):Q.call(G,V);return}const ee=z;if(!ee){Q.call(G,X(K,V));return}ee.items??=[],ee.items.push(V),ee.buffers.length===0&&z.buffers.push(()=>{ee.reducedResult??=K?ee.items.reduce(X,K):ee.items.reduce(X),Q.call(G,ee.reducedResult)})},void 0,ie)}bufferEvents(M){const X={buffers:new Array};this.f.push(X);const K=M();return this.f.pop(),X.buffers.forEach(Q=>Q()),K}}e.$te=E;class v{constructor(){this.f=!1,this.g=S.None,this.h=N.$Vc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=v;class T{static const(M){return new U(M)}constructor(M){this.g=M,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$ve=T;class U{constructor(M){this.value=M,this.onDidChange=S.None}}}),define(le[26],he([0,1,3]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=k;const a=Object.freeze(function(A,w){const S=setTimeout(A.bind(w),0);return{dispose(){clearTimeout(S)}}});var N;(function(A){function w(S){return S===A.None||S===A.Cancelled||S instanceof L?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}A.isCancellationToken=w,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(N||(e.CancellationToken=N={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new P.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=N.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=N.None}}e.$we=C;function k(A){const w=new C;return A.add({dispose(){w.cancel()}}),w.token}}),define(le[134],he([0,1,26]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=N;class a{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new P.$we,w=this.b(A.token);return this.a={promise:w,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.$9e=a;function N(k){return k}class L{constructor(A,w){this.a=void 0,this.b=void 0,typeof A=="function"?(this.c=A,this.d=N):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);return this.b!==w&&(this.b=w,this.a=this.c(A)),this.a}}e.$$e=L;class C{get cachedValues(){return this.a}constructor(A,w){this.a=new Map,this.b=new Map,typeof A=="function"?(this.c=A,this.d=N):(this.c=w,this.d=A.getCacheKey)}get(A){const w=this.d(A);if(this.b.has(w))return this.b.get(w);const S=this.c(A);return this.a.set(A,S),this.b.set(w,S),S}}e.$_e=C}),define(le[51],he([0,1,8,2]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=N,e.$ze=L,e.$Ae=C,e.$Be=k,e.$Ce=w,e.$De=S,e.$Ee=m,e.$Fe=h,e.$Ge=$,e.$He=c,e.$Ie=g,e.$Je=b,e.$Ke=f,e.$Le=p,e.$Me=I;function N(d){const u=d;return u?typeof u.read=="function":!1}function L(d){const u=d;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function C(d){const u=d;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function k(d,u){return new A(d,u)}class A{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$2)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let s;switch(u){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(d,u){const t=[];let s;for(;(s=d.read())!==null;)t.push(s);return u(t)}function S(d,u,t){const s=[];let r;for(;(r=d.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?u(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return d.read()}}}function m(d,u){return new Promise((t,s)=>{const r=[];h(d,{onData:i=>{u&&r.push(i)},onError:i=>{u?s(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}function h(d,u,t){d.on("error",s=>{t?.isCancellationRequested||u.onError(s)}),d.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),d.on("data",s=>{t?.isCancellationRequested||u.onData(s)})}function $(d,u){return new Promise((t,s)=>{const r=new a.$Uc,i=[],n=y=>{if(i.push(y),i.length>u)return r.dispose(),d.pause(),t({stream:d,buffer:i,ended:!1})},o=y=>(r.dispose(),s(y)),l=()=>(r.dispose(),t({stream:d,buffer:i,ended:!0}));r.add((0,a.$Tc)(()=>d.removeListener("error",o))),d.on("error",o),r.add((0,a.$Tc)(()=>d.removeListener("end",l))),d.on("end",l),r.add((0,a.$Tc)(()=>d.removeListener("data",n))),d.on("data",n)})}function c(d,u){const t=k(u);return t.end(d),t}function g(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}function b(d){let u=!1;return{read:()=>u?null:(u=!0,d)}}function f(d,u,t){const s=k(t);return h(d,{onData:r=>s.write(u.data(r)),onError:r=>s.error(u.error?u.error(r):r),onEnd:()=>s.end()}),s}function p(d,u,t){let s=!1;return{read:()=>{const r=u.read();return s?r:(s=!0,r!==null?t([d,r]):d)}}}function I(d,u,t){let s=!1;const r=k(t);return h(u,{onData:i=>s?r.write(i):(s=!0,r.write(t([d,i]))),onError:i=>r.error(i),onEnd:()=>{s||(s=!0,r.write(d)),r.end()}}),r}});var Ot=this&&this.__createBinding||(Object.create?function(ne,e,P,a){a===void 0&&(a=P);var N=Object.getOwnPropertyDescriptor(e,P);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ne,a,N)}:function(ne,e,P,a){a===void 0&&(a=P),ne[a]=e[P]}),Lt=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),ke=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var P in ne)P!=="default"&&Object.prototype.hasOwnProperty.call(ne,P)&&Ot(e,ne,P);return Lt(e,ne),e};define(le[15],he([0,1,54,51]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=w,e.$Pe=S,e.$Qe=m,e.$Re=h,e.$Se=$,e.$Te=c,e.$Ue=g,e.$Ve=b,e.$We=f,e.$Xe=p,e.$Ye=I,e.$Ze=d,e.$1e=u,e.$2e=t,e.$3e=s,e.$4e=r,e.$5e=i,e.$6e=n,e.$7e=o,e.$8e=R,a=ke(a);const N=typeof Buffer<"u",L=new P.$W(()=>new Uint8Array(256));let C,k;class A{static alloc(E){return N?new A(Buffer.allocUnsafe(E)):new A(new Uint8Array(E))}static wrap(E){return N&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new A(E)}static fromString(E,v){return!(v?.dontUseNodeBuffer||!1)&&N?new A(Buffer.from(E)):(C||(C=new TextEncoder),new A(C.encode(E)))}static fromByteArray(E){const v=A.alloc(E.length);for(let T=0,U=E.length;T<U;T++)v.buffer[T]=E[T];return v}static concat(E,v){if(typeof v>"u"){v=0;for(let F=0,M=E.length;F<M;F++)v+=E[F].byteLength}const T=A.alloc(v);let U=0;for(let F=0,M=E.length;F<M;F++){const X=E[F];T.set(X,U),U+=X.byteLength}return T}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=A.alloc(this.byteLength);return E.set(this),E}toString(){return N?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(E,v){return new A(this.buffer.subarray(E,v))}set(E,v){if(E instanceof A)this.buffer.set(E.buffer,v);else if(E instanceof Uint8Array)this.buffer.set(E,v);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),v);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return h(this.buffer,E)}writeUInt32BE(E,v){$(this.buffer,E,v)}readUInt32LE(E){return c(this.buffer,E)}writeUInt32LE(E,v){g(this.buffer,E,v)}readUInt8(E){return b(this.buffer,E)}writeUInt8(E,v){f(this.buffer,E,v)}indexOf(E,v=0){return w(this.buffer,E instanceof A?E.buffer:E,v)}}e.$Ne=A;function w(O,E,v=0){const T=E.byteLength,U=O.byteLength;if(T===0)return 0;if(T===1)return O.indexOf(E[0]);if(T>U-v)return-1;const F=L.value;F.fill(E.length);for(let Q=0;Q<E.length;Q++)F[E[Q]]=E.length-Q-1;let M=v+E.length-1,X=M,K=-1;for(;M<U;)if(O[M]===E[X]){if(X===0){K=M;break}M--,X--}else M+=Math.max(E.length-X,F[O[M]]),X=E.length-1;return K}function S(O,E){return O[E+0]<<0>>>0|O[E+1]<<8>>>0}function m(O,E,v){O[v+0]=E&255,E=E>>>8,O[v+1]=E&255}function h(O,E){return O[E]*2**24+O[E+1]*2**16+O[E+2]*2**8+O[E+3]}function $(O,E,v){O[v+3]=E,E=E>>>8,O[v+2]=E,E=E>>>8,O[v+1]=E,E=E>>>8,O[v]=E}function c(O,E){return O[E+0]<<0>>>0|O[E+1]<<8>>>0|O[E+2]<<16>>>0|O[E+3]<<24>>>0}function g(O,E,v){O[v+0]=E&255,E=E>>>8,O[v+1]=E&255,E=E>>>8,O[v+2]=E&255,E=E>>>8,O[v+3]=E&255}function b(O,E){return O[E]}function f(O,E,v){O[v]=E}function p(O){return a.$Ce(O,E=>A.concat(E))}function I(O){return a.$Je(O)}function d(O){return a.$Ee(O,E=>A.concat(E))}async function u(O){return O.ended?A.concat(O.buffer):A.concat([...O.buffer,await d(O.stream)])}function t(O){return a.$He(O,E=>A.concat(E))}function s(O){return a.$Ke(O,{data:E=>typeof E=="string"?A.fromString(E):A.wrap(E)},E=>A.concat(E))}function r(O){return a.$Be(E=>A.concat(E),O)}function i(O,E){return a.$Le(O,E,v=>A.concat(v))}function n(O,E){return a.$Me(O,E,v=>A.concat(v))}function o(O){let E=0,v=0,T=0;const U=new Uint8Array(Math.floor(O.length/4*3)),F=X=>{switch(v){case 3:U[T++]=E|X,v=0;break;case 2:U[T++]=E|X>>>2,E=X<<6,v=3;break;case 1:U[T++]=E|X>>>4,E=X<<4,v=2;break;default:E=X<<2,v=1}};for(let X=0;X<O.length;X++){const K=O.charCodeAt(X);if(K>=65&&K<=90)F(K-65);else if(K>=97&&K<=122)F(K-97+26);else if(K>=48&&K<=57)F(K-48+52);else if(K===43||K===45)F(62);else if(K===47||K===95)F(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${O[X]}`)}}const M=T;for(;v>0;)F(0);return A.wrap(U).slice(0,M)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:O},E=!0,v=!1){const T=v?y:l;let U="";const F=O.byteLength%3;let M=0;for(;M<O.byteLength-F;M+=3){const X=O[M+0],K=O[M+1],Q=O[M+2];U+=T[X>>>2],U+=T[(X<<4|K>>>4)&63],U+=T[(K<<2|Q>>>6)&63],U+=T[Q&63]}if(F===1){const X=O[M+0];U+=T[X>>>2],U+=T[X<<4&63],E&&(U+="==")}else if(F===2){const X=O[M+0],K=O[M+1];U+=T[X>>>2],U+=T[(X<<4|K>>>4)&63],U+=T[K<<2&63],E&&(U+="=")}return U}}),define(le[135],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(le[13],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=P,e.$fg=a,e.$gg=N,e.$hg=L,e.$ig=C,e.$jg=k,e.$kg=A,e.$lg=w,e.$mg=S,e.$ng=m,e.$og=h,e.$pg=$,e.$qg=c,e.$rg=b,e.$sg=f,e.$tg=p,e.$ug=I,e.$vg=d;function P(u){return typeof u=="string"}function a(u){return Array.isArray(u)&&u.every(t=>P(t))}function N(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}function L(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}function C(u){return typeof u=="number"&&!isNaN(u)}function k(u){return!!u&&typeof u[Symbol.iterator]=="function"}function A(u){return u===!0||u===!1}function w(u){return typeof u>"u"}function S(u){return!m(u)}function m(u){return w(u)||u===null}function h(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(u){if(m(u))throw new Error("Assertion Failed: argument is undefined or null");return u}function c(...u){const t=[];for(let s=0;s<u.length;s++){const r=u[s];if(m(r))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(r)}return t}const g=Object.prototype.hasOwnProperty;function b(u){if(!N(u))return!1;for(const t in u)if(g.call(u,t))return!1;return!0}function f(u){return typeof u=="function"}function p(...u){return u.length>0&&u.every(f)}function I(u,t){const s=Math.min(u.length,t.length);for(let r=0;r<s;r++)d(u[r],t[r])}function d(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(u instanceof t)return}catch{}if(!m(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=a,e.$co=N,e.$do=C,e.$eo=A,e.$fo=w,e.$go=S,e.$ho=m,e.$io=h,e.$jo=$,e.$ko=c,e.$lo=g,e.$mo=b,e.$no=f;function a(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const I=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([d,u])=>{I[d]=u&&typeof u=="object"?a(u):u}),I}function N(p){if(!p||typeof p!="object")return p;const I=[p];for(;I.length>0;){const d=I.shift();Object.freeze(d);for(const u in d)if(L.call(d,u)){const t=d[u];typeof t=="object"&&!Object.isFrozen(t)&&!(0,P.$hg)(t)&&I.push(t)}}return p}const L=Object.prototype.hasOwnProperty;function C(p,I){return k(p,I,new Set)}function k(p,I,d){if((0,P.$ng)(p))return p;const u=I(p);if(typeof u<"u")return u;if(Array.isArray(p)){const t=[];for(const s of p)t.push(k(s,I,d));return t}if((0,P.$gg)(p)){if(d.has(p))throw new Error("Cannot clone recursive data-structure");d.add(p);const t={};for(const s in p)L.call(p,s)&&(t[s]=k(p[s],I,d));return d.delete(p),t}return p}function A(p,I,d=!0){return(0,P.$gg)(p)?((0,P.$gg)(I)&&Object.keys(I).forEach(u=>{u in p?d&&((0,P.$gg)(p[u])&&(0,P.$gg)(I[u])?A(p[u],I[u],d):p[u]=I[u]):p[u]=I[u]}),p):I}function w(p,I){if(p===I)return!0;if(p==null||I===null||I===void 0||typeof p!=typeof I||typeof p!="object"||Array.isArray(p)!==Array.isArray(I))return!1;let d,u;if(Array.isArray(p)){if(p.length!==I.length)return!1;for(d=0;d<p.length;d++)if(!w(p[d],I[d]))return!1}else{const t=[];for(u in p)t.push(u);t.sort();const s=[];for(u in I)s.push(u);if(s.sort(),!w(t,s))return!1;for(d=0;d<t.length;d++)if(!w(p[t[d]],I[t[d]]))return!1}return!0}function S(p){const I=new Set;return JSON.stringify(p,(d,u)=>{if((0,P.$gg)(u)||Array.isArray(u)){if(I.has(u))return"[Circular]";I.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function m(p,I){const d=Object.create(null);return!p||!I||Object.keys(I).forEach(t=>{const s=p[t],r=I[t];w(s,r)||(d[t]=r)}),d}function h(p,I){const d=I.toLowerCase(),u=Object.keys(p).find(t=>t.toLowerCase()===d);return u?p[u]:p[I]}function $(p,I){const d=Object.create(null);for(const[u,t]of Object.entries(p))I(u,t)&&(d[u]=t);return d}function c(p){let I=[];for(;Object.prototype!==p;)I=I.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return I}function g(p){const I=[];for(const d of c(p))typeof p[d]=="function"&&I.push(d);return I}function b(p,I){const d=t=>function(){const s=Array.prototype.slice.call(arguments,0);return I(t,s)},u={};for(const t of p)u[t]=d(t);return u}function f(p,I){const d={};for(const[u,t]of Object.entries(p))d[u]=I(t,u);return d}}),define(le[136],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=a,e.$bf=N;var P;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function a(L){return L<0?0:L>P.MAX_UINT_8?P.MAX_UINT_8:L|0}function N(L){return L<0?0:L>P.MAX_UINT_32?P.MAX_UINT_32:L|0}}),define(le[27],he([0,1,134,39,54,136]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=C,e.$df=A,e.$ef=S,e.$ff=m,e.$gf=h,e.$hf=$,e.$if=c,e.$jf=g,e.$kf=b,e.$lf=f,e.$mf=p,e.$nf=I,e.$of=d,e.$pf=u,e.$qf=t,e.$rf=s,e.$sf=r,e.$tf=i,e.$uf=n,e.$vf=o,e.$wf=l,e.$xf=y,e.$yf=R,e.$zf=O,e.$Af=E,e.$Bf=v,e.$Cf=T,e.$Df=U,e.$Ef=F,e.$Ff=M,e.$Gf=X,e.$Hf=K,e.$If=Q,e.$Jf=G,e.$Kf=ie,e.$Lf=V,e.$Mf=z,e.$Pf=q,e.$Qf=x,e.$Rf=J,e.$Sf=H,e.$Tf=j,e.$Uf=te,e.$Wf=_,e.$Xf=Y,e.$Yf=ae,e.$Zf=ue,e.$1f=we,e.$2f=Ee,e.$3f=be,e.$5f=Se,e.$6f=Ie,e.$7f=oe,e.$8f=de,e.$9f=me,e.$0f=Pe,e.$$f=Oe,e.$_f=Fe,e.$ag=He;function C(se){return!se||typeof se!="string"?!0:se.trim().length===0}const k=/{(\d+)}/g;function A(se,...fe){return fe.length===0?se:se.replace(k,function($e,ye){const Le=parseInt(ye,10);return isNaN(Le)||Le<0||Le>=fe.length?$e:fe[Le]})}const w=/{([^}]+)}/g;function S(se,fe){return Object.keys(fe).length===0?se:se.replace(w,($e,ye)=>fe[ye]??$e)}function m(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function h(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function g(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function b(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Le=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Le)}`}function f(se,fe=" "){const $e=p(se,fe);return I($e,fe)}function p(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function I(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Le=ye,Te=-1;for(;Te=se.lastIndexOf(fe,Le-1),!(Te===-1||Te+$e!==Le);){if(Te===0)return"";Le=Te}return se.substring(0,Le)}function d(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(se){return se.replace(/\*/g,"")}function t(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=$(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function s(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function r(se){return se.split(/\r\n|\r|\n/)}function i(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return fe}return-1}function o(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Le=se.charCodeAt(ye);if(Le!==a.CharCode.Space&&Le!==a.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function l(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function y(se,fe,$e){const ye=[];let Le=0;for(const Te of se.matchAll(fe)){if(ye.push(se.slice(Le,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Le=Te.index+Te[0].length,ye.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ye.push(se.slice(Le)),Promise.all(ye).then(Te=>Te.join(""))}function R(se,fe){return se<fe?-1:se>fe?1:0}function O(se,fe,$e=0,ye=se.length,Le=0,Te=fe.length){for(;$e<ye&&Le<Te;$e++,Le++){const Je=se.charCodeAt($e),Qe=fe.charCodeAt(Le);if(Je<Qe)return-1;if(Je>Qe)return 1}const je=ye-$e,xe=Te-Le;return je<xe?-1:je>xe?1:0}function E(se,fe){return v(se,fe,0,se.length,0,fe.length)}function v(se,fe,$e=0,ye=se.length,Le=0,Te=fe.length){for(;$e<ye&&Le<Te;$e++,Le++){let Je=se.charCodeAt($e),Qe=fe.charCodeAt(Le);if(Je===Qe)continue;if(Je>=128||Qe>=128)return O(se.toLowerCase(),fe.toLowerCase(),$e,ye,Le,Te);U(Je)&&(Je-=32),U(Qe)&&(Qe-=32);const Ve=Je-Qe;if(Ve!==0)return Ve}const je=ye-$e,xe=Te-Le;return je<xe?-1:je>xe?1:0}function T(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function U(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function F(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function M(se,fe){return se.length===fe.length&&v(se,fe)===0}function X(se,fe){const $e=fe.length;return fe.length>se.length?!1:v(se,fe,0,$e)===0}function K(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function Q(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Le=se.length-1,Te=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Le-ye)!==fe.charCodeAt(Te-ye))return ye;return $e}function G(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function V(se,fe){return(se-55296<<10)+(fe-56320)+65536}function z(se,fe,$e){const ye=se.charCodeAt($e);if(G(ye)&&$e+1<fe){const Le=se.charCodeAt($e+1);if(ie(Le))return V(ye,Le)}return ye}function ee(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(G(ye))return V(ye,$e)}return $e}class re{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=L.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Nf=re;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new re(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Le=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Ce(Le,je)){$e.setOffset(Te);break}Le=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Le=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Ce(je,Le)){$e.setOffset(Te);break}Le=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Of=ce;function q(se,fe){return new ce(se,fe).nextGraphemeLength()}function x(se,fe){return new ce(se,fe).prevGraphemeLength()}function J(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+q(se,fe);return[$e-x(se,$e),$e]}function H(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(se){return D||(D=B()),D.test(se)}const W=/^[\t\n\r\x20-\x7E]*$/;function te(se){return W.test(se)}e.$Vf=/[\u2028\u2029]/;function _(se){return e.$Vf.test(se)}function Y(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ae(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ue(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Le=/\b/g;let Te=0;for(;Le.test(ye)&&!(ye.length-Le.lastIndex<fe);)Te=Le.lastIndex,Le.lastIndex+=1;return Te===0?ye:$e+ye.substring(Te).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const pe=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(pe,"")}e.$4f=String.fromCharCode(a.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Ie(se){return Se(se)?se.substr(1):se}function oe(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Le=0,Te=-1;for(;Le<$e;){const je=ye.indexOf(fe[Le],Te+1);if(je<0)return!1;Te=je,Le++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Oe(se){const fe=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-fe)}function Fe(se){return Ue.getInstance().getGraphemeBreakType(se)}function Ce(se,fe){return se===Ae.Other?fe!==Ae.Extend&&fe!==Ae.SpacingMark:se===Ae.CR&&fe===Ae.LF?!1:se===Ae.Control||se===Ae.CR||se===Ae.LF||fe===Ae.Control||fe===Ae.CR||fe===Ae.LF?!0:!(se===Ae.L&&(fe===Ae.L||fe===Ae.V||fe===Ae.LV||fe===Ae.LVT)||(se===Ae.LV||se===Ae.V)&&(fe===Ae.V||fe===Ae.T)||(se===Ae.LVT||se===Ae.T)&&fe===Ae.T||fe===Ae.Extend||fe===Ae.ZWJ||fe===Ae.SpacingMark||se===Ae.Prepend||se===Ae.ZWJ&&fe===Ae.Extended_Pictographic||se===Ae.Regional_Indicator&&fe===Ae.Regional_Indicator)}var Ae;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===a.CharCode.LineFeed?Ae.LF:fe===a.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(fe<127)return Ae.Other;const $e=this.d,ye=$e.length/3;let Le=1;for(;Le<=ye;)if(fe<$e[3*Le])Le=2*Le;else if(fe>$e[3*Le+1])Le=2*Le+1;else return $e[3*Le+2];return Ae.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(se,fe){if(se===0)return 0;const $e=Me(se,fe);if($e!==void 0)return $e;const ye=new re(fe,se);return ye.prevCodePoint(),ye.offset}function Me(se,fe){const $e=new re(fe,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ae(ye))return;let Le=$e.offset;return Le>0&&$e.prevCodePoint()===ze.zwj&&(Le=$e.offset),Le}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$bg="\xA0";class We{static{this.c=new N.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$$e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Ye=0;Ye<Ve.length;Ye+=2)_e.set(Ve[Ye],Ve[Ye+1]);return _e}function ye(Ve,_e){const Ye=new Map(Ve);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Le(Ve,_e){if(!Ve)return _e;const Ye=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Ye.set(nt,at);return Ye}const Te=this.c.value;let je=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Te);je.length===0&&(je=["_default"]);let xe;for(const Ve of je){const _e=$e(Te[Ve]);xe=Le(xe,_e)}const Je=$e(Te._common),Qe=ye(Je,xe);return new We(Qe)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new N.$W(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=We;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(fe){return Ne.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$dg=Ne}),define(le[56],he([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=a,e.$tj=N,e.$uj=L,e.$vj=k,e.$xj=g,P=ke(P);function a(f){return N(f,0)}function N(f,p){switch(typeof f){case"object":return f===null?L(349,p):Array.isArray(f)?A(f,p):w(f,p);case"string":return k(f,p);case"boolean":return C(f,p);case"number":return L(f,p);case"undefined":return L(937,p);default:return L(617,p)}}function L(f,p){return(p<<5)-p+f|0}function C(f,p){return L(f?433:863,p)}function k(f,p){p=L(149417,p);for(let I=0,d=f.length;I<d;I++)p=L(f.charCodeAt(I),p);return p}function A(f,p){return p=L(104579,p),f.reduce((I,d)=>N(d,I),p)}function w(f,p){return p=L(181387,p),Object.keys(f).sort().reduce((I,d)=>(I=k(d,I),N(f[d],I)),p)}class S{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=N(p,this.g),this.g}}e.$wj=S;var m;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function h(f,p,I=32){const d=I-p,u=~((1<<d)-1);return(f<<p|(u&f)>>>d)>>>0}function $(f,p=0,I=f.byteLength,d=0){for(let u=0;u<I;u++)f[p+u]=d}function c(f,p,I="0"){for(;f.length<p;)f=I+f;return f}function g(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(I=>I.toString(16).padStart(2,"0")).join(""):c((f>>>0).toString(16),p/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(m.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const I=p.length;if(I===0)return;const d=this.p;let u=this.r,t=this.u,s,r;for(t!==0?(s=t,r=-1,t=0):(s=p.charCodeAt(0),r=0);;){let i=s;if(P.$Jf(s))if(r+1<I){const n=p.charCodeAt(r+1);P.$Kf(n)?(r++,i=P.$Lf(s,n)):i=m.UNICODE_REPLACEMENT}else{t=s;break}else P.$Kf(s)&&(i=m.UNICODE_REPLACEMENT);if(u=this.w(d,u,i),r++,r<I)s=p.charCodeAt(r);else break}this.r=u,this.u=t}w(p,I,d){return d<128?p[I++]=d:d<2048?(p[I++]=192|(d&1984)>>>6,p[I++]=128|(d&63)>>>0):d<65536?(p[I++]=224|(d&61440)>>>12,p[I++]=128|(d&4032)>>>6,p[I++]=128|(d&63)>>>0):(p[I++]=240|(d&1835008)>>>18,p[I++]=128|(d&258048)>>>12,p[I++]=128|(d&4032)>>>6,p[I++]=128|(d&63)>>>0),I>=m.BLOCK_SIZE&&(this.y(),I-=m.BLOCK_SIZE,this.t+=m.BLOCK_SIZE,p[0]=p[m.BLOCK_SIZE+0],p[1]=p[m.BLOCK_SIZE+1],p[2]=p[m.BLOCK_SIZE+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,m.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,I=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,h(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let d=this.h,u=this.l,t=this.m,s=this.n,r=this.o,i,n,o;for(let l=0;l<80;l++)l<20?(i=u&t|~u&s,n=1518500249):l<40?(i=u^t^s,n=1859775393):l<60?(i=u&t|u&s|t&s,n=2400959708):(i=u^t^s,n=3395469782),o=h(d,5)+i+r+n+p.getUint32(l*4,!1)&4294967295,r=s,s=t,t=h(u,30),u=d,d=o;this.h=this.h+d&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.$yj=b}),define(le[92],he([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=ke(P);var a;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(a||(a={})),function(N){const L="error",C="warning",k="warn",A="info",w="ignore";function S(h){return h?P.$Ff(L,h)?N.Error:P.$Ff(C,h)||P.$Ff(k,h)?N.Warning:P.$Ff(A,h)?N.Info:N.Ignore:N.Ignore}N.fromValue=S;function m(h){switch(h){case N.Error:return L;case N.Warning:return C;case N.Info:return A;default:return w}}N.toString=m}(a||(a={})),e.default=a}),define(le[52],he([0,1,19,39,27]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class L{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const g=c.charCodeAt(0),b=this.b.charCodeAt(this.c);return g-b}value(){return this.b[this.c]}}e.$Gi=L;class C{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$zf)(c,this.b,0,c.length,this.c,this.d):(0,N.$Bf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=C;class k{constructor(c=!0,g=!0){this.f=c,this.g=g}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let g=c.length-1;g>=0;g--,this.c--){const b=this.b.charCodeAt(g);if(!(b===a.CharCode.Slash||this.f&&b===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===a.CharCode.Slash||this.f&&g===a.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$zf)(c,this.b,0,c.length,this.d,this.e):(0,N.$Bf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=k;var A;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(A||(A={}));class w{constructor(c,g){this.f=c,this.g=g,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(A.Scheme),this.c.authority&&this.d.push(A.Authority),this.c.path&&(this.b=new k(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(A.Path)),this.g(c)||(this.c.query&&this.d.push(A.Query),this.c.fragment&&this.d.push(A.Fragment)),this.e=0,this}next(){return this.d[this.e]===A.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===A.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===A.Scheme)return(0,N.$Af)(c,this.c.scheme);if(this.d[this.e]===A.Authority)return(0,N.$Af)(c,this.c.authority);if(this.d[this.e]===A.Path)return this.b.cmp(c);if(this.d[this.e]===A.Query)return(0,N.$yf)(c,this.c.query);if(this.d[this.e]===A.Fragment)return(0,N.$yf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===A.Scheme)return this.c.scheme;if(this.d[this.e]===A.Authority)return this.c.authority;if(this.d[this.e]===A.Path)return this.b.value();if(this.d[this.e]===A.Query)return this.c.query;if(this.d[this.e]===A.Fragment)return this.c.fragment;throw new Error}}e.$Ji=w;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(m||(m={}));class h{static forUris(c=()=>!1,g=()=>!1){return new h(new w(c,g))}static forPaths(c=!1){return new h(new k(void 0,!c))}static forStrings(){return new h(new L)}static forConfigKeys(){return new h(new C)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,g){if(g){const b=g.slice(0);(0,P.$Xb)(b);for(const f of b)this.set(f,c)}else{const b=c.slice(0);(0,P.$Xb)(b);for(const f of b)this.set(f[0],f[1])}}set(c,g){const b=this.b.reset(c);let f;this.c||(this.c=new S,this.c.segment=b.value());const p=[];for(f=this.c;;){const d=b.cmp(f.segment);if(d>0)f.left||(f.left=new S,f.left.segment=b.value()),p.push([m.Left,f]),f=f.left;else if(d<0)f.right||(f.right=new S,f.right.segment=b.value()),p.push([m.Right,f]),f=f.right;else if(b.hasNext())b.next(),f.mid||(f.mid=new S,f.mid.segment=b.value()),p.push([m.Mid,f]),f=f.mid;else break}const I=f.value;f.value=g,f.key=c;for(let d=p.length-1;d>=0;d--){const u=p[d][1];u.updateHeight();const t=u.balanceFactor();if(t<-1||t>1){const s=p[d][0],r=p[d+1][0];if(s===m.Right&&r===m.Right)p[d][1]=u.rotateLeft();else if(s===m.Left&&r===m.Left)p[d][1]=u.rotateRight();else if(s===m.Right&&r===m.Left)u.right=p[d+1][1]=p[d+1][1].rotateRight(),p[d][1]=u.rotateLeft();else if(s===m.Left&&r===m.Right)u.left=p[d+1][1]=p[d+1][1].rotateLeft(),p[d][1]=u.rotateRight();else throw new Error;if(d>0)switch(p[d-1][0]){case m.Left:p[d-1][1].left=p[d][1];break;case m.Right:p[d-1][1].right=p[d][1];break;case m.Mid:p[d-1][1].mid=p[d][1];break}else this.c=p[0][1]}}return I}get(c){return this.d(c)?.value}d(c){const g=this.b.reset(c);let b=this.c;for(;b;){const f=g.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(g.hasNext())g.next(),b=b.mid;else break}return b}has(c){const g=this.d(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,g){const b=this.b.reset(c),f=[];let p=this.c;for(;p;){const I=b.cmp(p.segment);if(I>0)f.push([m.Left,p]),p=p.left;else if(I<0)f.push([m.Right,p]),p=p.right;else if(b.hasNext())b.next(),f.push([m.Mid,p]),p=p.mid;else break}if(p){if(g?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const I=this.f(p.right);if(I.key){const{key:d,value:u,segment:t}=I;this.e(I.key,!1),p.key=d,p.value=u,p.segment=t}}else{const I=p.left??p.right;if(f.length>0){const[d,u]=f[f.length-1];switch(d){case m.Left:u.left=I;break;case m.Mid:u.mid=I;break;case m.Right:u.right=I;break}}else this.c=I}for(let I=f.length-1;I>=0;I--){const d=f[I][1];d.updateHeight();const u=d.balanceFactor();if(u>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),f[I][1]=d.rotateLeft()):u<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),f[I][1]=d.rotateRight()),I>0)switch(f[I-1][0]){case m.Left:f[I-1][1].left=f[I][1];break;case m.Right:f[I-1][1].right=f[I][1];break;case m.Mid:f[I-1][1].mid=f[I][1];break}else this.c=f[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this.b.reset(c);let b=this.c,f;for(;b;){const p=g.cmp(b.segment);if(p>0)b=b.left;else if(p<0)b=b.right;else if(g.hasNext())g.next(),f=b.value||f,b=b.mid;else break}return b&&b.value||f}findSuperstr(c){return this.g(c,!1)}g(c,g){const b=this.b.reset(c);let f=this.c;for(;f;){const p=b.cmp(f.segment);if(p>0)f=f.left;else if(p<0)f=f.right;else if(b.hasNext())b.next(),f=f.mid;else return f.mid?this.h(f.mid):g?f.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[g,b]of this)c(b,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const g=[];return this.j(c,g),g[Symbol.iterator]()}j(c,g){c&&(c.left&&this.j(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this.j(c.mid,g),c.right&&this.j(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const b=g.balanceFactor();return b<-1||b>1?!1:c(g.left)&&c(g.right)};return c(this.c)}}e.$Ki=h}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=a;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(N){return P.test(N)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(k){for(let A=0;A<k.length;A++)k[A]=Math.floor(Math.random()*256);return k};const L=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){N(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let A=0,w="";return w+=C[L[A++]],w+=C[L[A++]],w+=C[L[A++]],w+=C[L[A++]],w+="-",w+=C[L[A++]],w+=C[L[A++]],w+="-",w+=C[L[A++]],w+=C[L[A++]],w+="-",w+=C[L[A++]],w+=C[L[A++]],w+="-",w+=C[L[A++]],w+=C[L[A++]],w+=C[L[A++]],w+=C[L[A++]],w+=C[L[A++]],w+=C[L[A++]],w}}()}),define(le[137],he([0,1,38]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=L;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(C){const k=C.replace(/\-/g,":").toLowerCase();return!a.has(k)}function L(){const C=(0,P.networkInterfaces)();for(const k in C){const A=C[k];if(A){for(const{mac:w}of A)if(N(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[138],he([0,1,276,15]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5W=void 0;class N extends P.Transform{constructor(C){if(super(),typeof C=="number")this.b=C,this.c=1;else{const k=Buffer.isBuffer(C)?C:Buffer.from(C);this.b=k.length===1?k[0]:k,this.c=k.length}}_transform(C,k,A){this.a?this.a=Buffer.concat([this.a,C]):this.a=C;let w=0;for(;w<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,w):(0,a.$Oe)(this.a,this.b,w);if(S===-1)break;this.push(this.a.slice(w,S+this.c)),w=S+this.c}this.a=w===this.a.length?void 0:this.a.slice(w),A()}_flush(C){this.a&&this.push(this.a),C()}}e.$5W=N}),define(le[139],he([0,1,66]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=void 0,e.$3g=a,e.$5g=L,P=ke(P);function a(k,A,w,S=1){let m=!1;return new Promise(h=>{const $=setTimeout(()=>{if(!m)return m=!0,h(0)},w);N(k,A,S,c=>{if(!m)return m=!0,clearTimeout($),h(c)})})}function N(k,A,w,S){if(A===0)return S(0);const m=new P.Socket;m.once("connect",()=>(C(m),N(k+w,A-1,w,S))),m.once("data",()=>{}),m.once("error",h=>(C(m),h.code!=="ECONNREFUSED"?N(k+w,A-1,w,S):S(k))),m.connect(k,"127.0.0.1")}e.$4g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(k,A,w,S="127.0.0.1"){let m=!1,h,$=1;const c=P.createServer({pauseOnConnect:!0});function g(b,f){m||(m=!0,c.removeAllListeners(),c.close(),h&&clearTimeout(h),f(b))}return new Promise(b=>{h=setTimeout(()=>{g(0,b)},w),c.on("listening",()=>{g(k,b)}),c.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&$<A?(k++,$++,c.listen(k,S)):g(0,b)}),c.on("close",()=>{g(0,b)}),c.listen(k,S)})}function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(A){console.error(A)}}}),define(le[140],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kX=P;function P(a){return!!a.parentPort}}),define(le[141],he([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[67],he([0,1,141]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=w,e.$1m=S,e.$2m=m;const a=60,N=a*60,L=N*24,C=L*7,k=L*30,A=L*365;function w(h,$,c,g){typeof h!="number"&&(h=h.getTime());const b=Math.round((new Date().getTime()-h)/1e3);if(b<-30)return(0,P.localize)(0,null,w(new Date().getTime()+b*1e3,!1));if(!g&&b<30)return(0,P.localize)(1,null);let f;return b<a?(f=b,$?f===1?c?(0,P.localize)(2,null,f):(0,P.localize)(3,null,f):c?(0,P.localize)(4,null,f):(0,P.localize)(5,null,f):f===1?c?(0,P.localize)(6,null,f):(0,P.localize)(7,null,f):c?(0,P.localize)(8,null,f):(0,P.localize)(9,null,f)):b<N?(f=Math.floor(b/a),$?f===1?c?(0,P.localize)(10,null,f):(0,P.localize)(11,null,f):c?(0,P.localize)(12,null,f):(0,P.localize)(13,null,f):f===1?c?(0,P.localize)(14,null,f):(0,P.localize)(15,null,f):c?(0,P.localize)(16,null,f):(0,P.localize)(17,null,f)):b<L?(f=Math.floor(b/N),$?f===1?c?(0,P.localize)(18,null,f):(0,P.localize)(19,null,f):c?(0,P.localize)(20,null,f):(0,P.localize)(21,null,f):f===1?c?(0,P.localize)(22,null,f):(0,P.localize)(23,null,f):c?(0,P.localize)(24,null,f):(0,P.localize)(25,null,f)):b<C?(f=Math.floor(b/L),$?f===1?(0,P.localize)(26,null,f):(0,P.localize)(27,null,f):f===1?(0,P.localize)(28,null,f):(0,P.localize)(29,null,f)):b<k?(f=Math.floor(b/C),$?f===1?c?(0,P.localize)(30,null,f):(0,P.localize)(31,null,f):c?(0,P.localize)(32,null,f):(0,P.localize)(33,null,f):f===1?c?(0,P.localize)(34,null,f):(0,P.localize)(35,null,f):c?(0,P.localize)(36,null,f):(0,P.localize)(37,null,f)):b<A?(f=Math.floor(b/k),$?f===1?c?(0,P.localize)(38,null,f):(0,P.localize)(39,null,f):c?(0,P.localize)(40,null,f):(0,P.localize)(41,null,f):f===1?c?(0,P.localize)(42,null,f):(0,P.localize)(43,null,f):c?(0,P.localize)(44,null,f):(0,P.localize)(45,null,f)):(f=Math.floor(b/A),$?f===1?c?(0,P.localize)(46,null,f):(0,P.localize)(47,null,f):c?(0,P.localize)(48,null,f):(0,P.localize)(49,null,f):f===1?c?(0,P.localize)(50,null,f):(0,P.localize)(51,null,f):c?(0,P.localize)(52,null,f):(0,P.localize)(53,null,f))}function S(h,$){const c=Math.abs(h/1e3);return c<1?$?(0,P.localize)(54,null,h):(0,P.localize)(55,null,h):c<a?$?(0,P.localize)(56,null,Math.round(h)/1e3):(0,P.localize)(57,null,Math.round(h)/1e3):c<N?$?(0,P.localize)(58,null,Math.round(h/(1e3*a))):(0,P.localize)(59,null,Math.round(h/(1e3*a))):c<L?$?(0,P.localize)(60,null,Math.round(h/(1e3*N))):(0,P.localize)(61,null,Math.round(h/(1e3*N))):(0,P.localize)(62,null,Math.round(h/(1e3*L)))}function m(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[142],he([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[41],he([0,1,19,13,142]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=A,e.$qj=w,e.$rj=S,P=ke(P),a=ke(a),N=ke(N);function L(m,h){return h&&(m.stack||m.stacktrace)?N.localize(0,null,k(m),C(m.stack)||C(m.stacktrace)):k(m)}function C(m){return Array.isArray(m)?m.join(`
`):m}function k(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?N.localize(1,null,m.message):m.message||N.localize(2,null)}function A(m=null,h=!1){if(!m)return N.localize(3,null);if(Array.isArray(m)){const $=P.$Ib(m),c=A($[0],h);return $.length>1?N.localize(4,null,c,$.length):c}if(a.$eg(m))return m;if(m.detail){const $=m.detail;if($.error)return L($.error,h);if($.exception)return L($.exception,h)}return m.stack?L(m,h):m.message?m.message:N.localize(5,null)}function w(m){const h=m;return h instanceof Error&&Array.isArray(h.actions)}function S(m,h){let $;return typeof m=="string"?$=new Error(m):$=m,$.actions=h,$}}),define(le[143],he([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[144],he([0,1,143,34]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=N;function N(L){switch(L){case a.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case a.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case a.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case a.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case a.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case a.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case a.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case a.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(le[145],he([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,145]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=y,e.$J=R,P=ke(P),e.$g="en";let a=!1,N=!1,L=!1,C=!1,k=!1,A=!1,w=!1,S=!1,m=!1,h=!1,$,c=e.$g,g=e.$g,b,f;const p=globalThis;let I;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?I=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const d=typeof I?.versions?.electron=="string",u=d&&I?.type==="renderer";if(typeof I=="object"){a=I.platform==="win32",N=I.platform==="darwin",L=I.platform==="linux",C=L&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,w=d,m=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,c=e.$g;const O=I.env.VSCODE_NLS_CONFIG;if(O)try{const E=JSON.parse(O),v=E.availableLanguages["*"];$=E.locale,g=E.osLocale,c=v||e.$g,b=E._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!u?(f=navigator.userAgent,a=f.indexOf("Windows")>=0,N=f.indexOf("Macintosh")>=0,S=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=f.indexOf("Linux")>=0,h=f?.indexOf("Mobi")>=0,A=!0,$=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,c=$,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(O){switch(O){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let r=t.Web;N?r=t.Mac:a?r=t.Windows:L&&(r=t.Linux),e.$i=a,e.$j=N,e.$k=L,e.$l=C,e.$m=k,e.$n=w,e.$o=A,e.$p=A&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=S,e.$s=h,e.$t=m,e.$u=r,e.$v=f,e.$w=c;var i;(function(O){function E(){return e.$w}O.value=E;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}O.isDefaultVariant=v;function T(){return e.$w==="en"}O.isDefault=T})(i||(e.Language=i={})),e.$x=$,e.$y=g,e.$z=b,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const O=[];p.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let T=0,U=O.length;T<U;T++){const F=O[T];if(F.id===v.data.vscodeScheduleAsyncWork){O.splice(T,1),F.callback();return}}});let E=0;return v=>{const T=++E;O.push({id:T,callback:v}),p.postMessage({vscodeScheduleAsyncWork:T},"*")}}return O=>setTimeout(O)})();var n;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=N||S?n.Macintosh:a?n.Windows:n.Linux;let o=!0,l=!1;function y(){if(!l){l=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,o=new Uint16Array(O.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(O){return parseFloat(O)>=20}}),define(le[36],he([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const L=N.process;a={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$ec=a.platform,e.$fc=a.arch}),define(le[146],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LW=C;var a;(function(k){k.UNKNOWN="UNKNOWN",k.CINNAMON="CINNAMON",k.DEEPIN="DEEPIN",k.GNOME="GNOME",k.KDE3="KDE3",k.KDE4="KDE4",k.KDE5="KDE5",k.KDE6="KDE6",k.PANTHEON="PANTHEON",k.UNITY="UNITY",k.XFCE="XFCE",k.UKUI="UKUI",k.LXQT="LXQT"})(a||(a={}));const N="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function C(){const k=P.env[N];if(k){const w=k.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of w)switch(S){case"Unity":{const m=P.env.DESKTOP_SESSION;return m&&m.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const m=P.env[L];return m==="5"?a.KDE5:m==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const A=P.env.DESKTOP_SESSION;if(A)switch(A){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return L in P.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?a.GNOME:"KDE_FULL_SESSION"in P.env?L in P.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(le[14],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,P=ke(P);const a=65,N=97,L=90,C=122,k=46,A=47,w=92,S=58,m=63;class h extends Error{constructor(s,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${o} ${n} of type ${r}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,s){if(t===null||typeof t!="object")throw new h(s,"Object",t)}function c(t,s){if(typeof t!="string")throw new h(s,"string",t)}const g=P.$ec==="win32";function b(t){return t===A||t===w}function f(t){return t===A}function p(t){return t>=a&&t<=L||t>=N&&t<=C}function I(t,s,r,i){let n="",o=0,l=-1,y=0,R=0;for(let O=0;O<=t.length;++O){if(O<t.length)R=t.charCodeAt(O);else{if(i(R))break;R=A}if(i(R)){if(!(l===O-1||y===1))if(y===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const E=n.lastIndexOf(r);E===-1?(n="",o=0):(n=n.slice(0,E),o=n.length-1-n.lastIndexOf(r)),l=O,y=0;continue}else if(n.length!==0){n="",o=0,l=O,y=0;continue}}s&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(l+1,O)}`:n=t.slice(l+1,O),o=O-l-1;l=O,y=0}else R===k&&y!==-1?++y:y=-1}return n}function d(t,s){$(s,"pathObject");const r=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let s="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],c(o,"path"),o.length===0)continue}else s.length===0?o=P.cwd():(o=P.env[`=${s}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===w)&&(o=`${s}\\`));const l=o.length;let y=0,R="",O=!1;const E=o.charCodeAt(0);if(l===1)b(E)&&(y=1,O=!0);else if(b(E))if(O=!0,b(o.charCodeAt(1))){let v=2,T=v;for(;v<l&&!b(o.charCodeAt(v));)v++;if(v<l&&v!==T){const U=o.slice(T,v);for(T=v;v<l&&b(o.charCodeAt(v));)v++;if(v<l&&v!==T){for(T=v;v<l&&!b(o.charCodeAt(v));)v++;(v===l||v!==T)&&(R=`\\\\${U}\\${o.slice(T,v)}`,y=v)}}}else y=1;else p(E)&&o.charCodeAt(1)===S&&(R=o.slice(0,2),y=2,l>2&&b(o.charCodeAt(2))&&(O=!0,y=3));if(R.length>0)if(s.length>0){if(R.toLowerCase()!==s.toLowerCase())continue}else s=R;if(i){if(s.length>0)break}else if(r=`${o.slice(y)}\\${r}`,i=O,O&&s.length>0)break}return r=I(r,!i,"\\",b),i?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){c(t,"path");const s=t.length;if(s===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(s===1)return f(o)?"\\":t;if(b(o))if(n=!0,b(t.charCodeAt(1))){let y=2,R=y;for(;y<s&&!b(t.charCodeAt(y));)y++;if(y<s&&y!==R){const O=t.slice(R,y);for(R=y;y<s&&b(t.charCodeAt(y));)y++;if(y<s&&y!==R){for(R=y;y<s&&!b(t.charCodeAt(y));)y++;if(y===s)return`\\\\${O}\\${t.slice(R)}\\`;y!==R&&(i=`\\\\${O}\\${t.slice(R,y)}`,r=y)}}}else r=1;else p(o)&&t.charCodeAt(1)===S&&(i=t.slice(0,2),r=2,s>2&&b(t.charCodeAt(2))&&(n=!0,r=3));let l=r<s?I(t.slice(r),!n,"\\",b):"";return l.length===0&&!n&&(l="."),l.length>0&&b(t.charCodeAt(s-1))&&(l+="\\"),i===void 0?n?`\\${l}`:l:n?`${i}\\${l}`:`${i}${l}`},isAbsolute(t){c(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return b(r)||s>2&&p(r)&&t.charCodeAt(1)===S&&b(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let o=0;o<t.length;++o){const l=t[o];c(l,"path"),l.length>0&&(s===void 0?s=r=l:s+=`\\${l}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&b(r.charCodeAt(0))){++n;const o=r.length;o>1&&b(r.charCodeAt(1))&&(++n,o>2&&(b(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&b(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$gc.normalize(s)},relative(t,s){if(c(t,"from"),c(s,"to"),t===s)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(s);if(r===i||(t=r.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===w;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===w;)o--;const l=o-n;let y=0;for(;y<s.length&&s.charCodeAt(y)===w;)y++;let R=s.length;for(;R-1>y&&s.charCodeAt(R-1)===w;)R--;const O=R-y,E=l<O?l:O;let v=-1,T=0;for(;T<E;T++){const F=t.charCodeAt(n+T);if(F!==s.charCodeAt(y+T))break;F===w&&(v=T)}if(T!==E){if(v===-1)return i}else{if(O>E){if(s.charCodeAt(y+T)===w)return i.slice(y+T+1);if(T===2)return i.slice(y+T)}l>E&&(t.charCodeAt(n+T)===w?v=T:T===2&&(v=3)),v===-1&&(v=0)}let U="";for(T=n+v+1;T<=o;++T)(T===o||t.charCodeAt(T)===w)&&(U+=U.length===0?"..":"\\..");return y+=v,U.length>0?`${U}${i.slice(y,R)}`:(i.charCodeAt(y)===w&&++y,i.slice(y,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$gc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const r=s.charCodeAt(2);if(r!==m&&r!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(p(s.charCodeAt(0))&&s.charCodeAt(1)===S&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return t},dirname(t){c(t,"path");const s=t.length;if(s===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(s===1)return b(n)?t:".";if(b(n)){if(r=i=1,b(t.charCodeAt(1))){let y=2,R=y;for(;y<s&&!b(t.charCodeAt(y));)y++;if(y<s&&y!==R){for(R=y;y<s&&b(t.charCodeAt(y));)y++;if(y<s&&y!==R){for(R=y;y<s&&!b(t.charCodeAt(y));)y++;if(y===s)return t;y!==R&&(r=i=y+1)}}}}else p(n)&&t.charCodeAt(1)===S&&(r=s>2&&b(t.charCodeAt(2))?3:2,i=r);let o=-1,l=!0;for(let y=s-1;y>=i;--y)if(b(t.charCodeAt(y))){if(!l){o=y;break}}else l=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,s){s!==void 0&&c(s,"ext"),c(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let l=s.length-1,y=-1;for(o=t.length-1;o>=r;--o){const R=t.charCodeAt(o);if(b(R)){if(!n){r=o+1;break}}else y===-1&&(n=!1,y=o+1),l>=0&&(R===s.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=y))}return r===i?i=y:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(b(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){c(t,"path");let s=0,r=-1,i=0,n=-1,o=!0,l=0;t.length>=2&&t.charCodeAt(1)===S&&p(t.charCodeAt(0))&&(s=i=2);for(let y=t.length-1;y>=s;--y){const R=t.charCodeAt(y);if(b(R)){if(!o){i=y+1;break}continue}n===-1&&(o=!1,n=y+1),R===k?r===-1?r=y:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||n===-1||l===0||l===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:d.bind(null,"\\"),parse(t){c(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return b(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(b(n)){if(i=1,b(t.charCodeAt(1))){let v=2,T=v;for(;v<r&&!b(t.charCodeAt(v));)v++;if(v<r&&v!==T){for(T=v;v<r&&b(t.charCodeAt(v));)v++;if(v<r&&v!==T){for(T=v;v<r&&!b(t.charCodeAt(v));)v++;v===r?i=v:v!==T&&(i=v+1)}}}}else if(p(n)&&t.charCodeAt(1)===S){if(r<=2)return s.root=s.dir=t,s;if(i=2,b(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let o=-1,l=i,y=-1,R=!0,O=t.length-1,E=0;for(;O>=i;--O){if(n=t.charCodeAt(O),b(n)){if(!R){l=O+1;break}continue}y===-1&&(R=!1,y=O+1),n===k?o===-1?o=O:E!==1&&(E=1):o!==-1&&(E=-1)}return y!==-1&&(o===-1||E===0||E===1&&o===y-1&&o===l+1?s.base=s.name=t.slice(l,y):(s.name=t.slice(l,o),s.base=t.slice(l,y),s.ext=t.slice(o,y))),l>0&&l!==i?s.dir=t.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(g){const t=/\\/g;return()=>{const s=P.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>P.cwd()})();e.$hc={resolve(...t){let s="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();c(n,"path"),n.length!==0&&(s=`${n}/${s}`,r=n.charCodeAt(0)===A)}return s=I(s,!r,"/",f),r?`/${s}`:s.length>0?s:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===A,r=t.charCodeAt(t.length-1)===A;return t=I(t,!s,"/",f),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===A},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const i=t[r];c(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$hc.normalize(s)},relative(t,s){if(c(t,"from"),c(s,"to"),t===s||(t=e.$hc.resolve(t),s=e.$hc.resolve(s),t===s))return"";const r=1,i=t.length,n=i-r,o=1,l=s.length-o,y=n<l?n:l;let R=-1,O=0;for(;O<y;O++){const v=t.charCodeAt(r+O);if(v!==s.charCodeAt(o+O))break;v===A&&(R=O)}if(O===y)if(l>y){if(s.charCodeAt(o+O)===A)return s.slice(o+O+1);if(O===0)return s.slice(o+O)}else n>y&&(t.charCodeAt(r+O)===A?R=O:O===0&&(R=0));let E="";for(O=r+R+1;O<=i;++O)(O===i||t.charCodeAt(O)===A)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(o+R)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===A;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===A){if(!i){r=n;break}}else i=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&c(s,"ext"),c(t,"path");let r=0,i=-1,n=!0,o;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let l=s.length-1,y=-1;for(o=t.length-1;o>=0;--o){const R=t.charCodeAt(o);if(R===A){if(!n){r=o+1;break}}else y===-1&&(n=!1,y=o+1),l>=0&&(R===s.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=y))}return r===i?i=y:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===A){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){c(t,"path");let s=-1,r=0,i=-1,n=!0,o=0;for(let l=t.length-1;l>=0;--l){const y=t.charCodeAt(l);if(y===A){if(!n){r=l+1;break}continue}i===-1&&(n=!1,i=l+1),y===k?s===-1?s=l:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===r+1?"":t.slice(s,i)},format:d.bind(null,"/"),parse(t){c(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===A;let i;r?(s.root="/",i=1):i=0;let n=-1,o=0,l=-1,y=!0,R=t.length-1,O=0;for(;R>=i;--R){const E=t.charCodeAt(R);if(E===A){if(!y){o=R+1;break}continue}l===-1&&(y=!1,l=R+1),E===k?n===-1?n=R:O!==1&&(O=1):n!==-1&&(O=-1)}if(l!==-1){const E=o===0&&r?1:o;n===-1||O===0||O===1&&n===l-1&&n===o+1?s.base=s.name=t.slice(E,l):(s.name=t.slice(E,n),s.base=t.slice(E,l),s.ext=t.slice(n,l))}return o>0?s.dir=t.slice(0,o-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=g?e.$gc.normalize:e.$hc.normalize,e.$jc=g?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=g?e.$gc.join:e.$hc.join,e.$lc=g?e.$gc.resolve:e.$hc.resolve,e.$mc=g?e.$gc.relative:e.$hc.relative,e.$nc=g?e.$gc.dirname:e.$hc.dirname,e.$oc=g?e.$gc.basename:e.$hc.basename,e.$pc=g?e.$gc.extname:e.$hc.extname,e.$qc=g?e.$gc.format:e.$hc.format,e.$rc=g?e.$gc.parse:e.$hc.parse,e.$sc=g?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=g?e.$gc.sep:e.$hc.sep,e.$uc=g?e.$gc.delimiter:e.$hc.delimiter}),define(le[42],he([0,1,39,14,5,27,13]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=k,e.$xg=A,e.$yg=w,e.$zg=S,e.$Ag=m,e.$Bg=g,e.$Cg=b,e.$Dg=f,e.$Eg=p,e.$Fg=I,e.$Gg=d,e.$Hg=u,e.$Ig=t,e.$Jg=s,e.$Kg=r,e.$Lg=i,e.$Mg=l;function k(y){return y===P.CharCode.Slash||y===P.CharCode.Backslash}function A(y){return y.replace(/[\\/]/g,a.$hc.sep)}function w(y){return y.indexOf("/")===-1&&(y=A(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function S(y,R=a.$hc.sep){if(!y)return"";const O=y.length,E=y.charCodeAt(0);if(k(E)){if(k(y.charCodeAt(1))&&!k(y.charCodeAt(2))){let T=3;const U=T;for(;T<O&&!k(y.charCodeAt(T));T++);if(U!==T&&!k(y.charCodeAt(T+1))){for(T+=1;T<O;T++)if(k(y.charCodeAt(T)))return y.slice(0,T+1).replace(/[\\/]/g,R)}}return R}else if(p(E)&&y.charCodeAt(1)===P.CharCode.Colon)return k(y.charCodeAt(2))?y.slice(0,2)+R:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<O;v++)if(k(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function m(y){if(!N.$i||!y||y.length<5)return!1;let R=y.charCodeAt(0);if(R!==P.CharCode.Backslash||(R=y.charCodeAt(1),R!==P.CharCode.Backslash))return!1;let O=2;const E=O;for(;O<y.length&&(R=y.charCodeAt(O),R!==P.CharCode.Backslash);O++);return!(E===O||(R=y.charCodeAt(O+1),isNaN(R)||R===P.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,$=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(y,R=N.$i){const O=R?h:$;return!(!y||y.length===0||/^\s+$/.test(y)||(O.lastIndex=0,O.test(y))||R&&c.test(y)||y==="."||y===".."||R&&y[y.length-1]==="."||R&&y.length!==y.trim().length||y.length>255)}function b(y,R,O){const E=y===R;return!O||E?E:!y||!R?!1:(0,L.$Ff)(y,R)}function f(y,R,O,E=a.sep){if(y===R)return!0;if(!y||!R||R.length>y.length)return!1;if(O){if(!(0,L.$Gf)(y,R))return!1;if(R.length===y.length)return!0;let T=R.length;return R.charAt(R.length-1)===E&&T--,y.charAt(T)===E}return R.charAt(R.length-1)!==E&&(R+=E),y.indexOf(R)===0}function p(y){return y>=P.CharCode.A&&y<=P.CharCode.Z||y>=P.CharCode.a&&y<=P.CharCode.z}function I(y,R){return N.$i&&y.endsWith(":")&&(y+=a.sep),(0,a.$jc)(y)||(y=(0,a.$kc)(R,y)),y=(0,a.$ic)(y),d(y)}function d(y){return N.$i?(y=(0,L.$nf)(y,a.sep),y.endsWith(":")&&(y+=a.sep)):(y=(0,L.$nf)(y,a.sep),y||(y=a.sep)),y}function u(y){const R=(0,a.$ic)(y);return N.$i?y.length>3?!1:t(R)&&(y.length===2||R.charCodeAt(2)===P.CharCode.Backslash):R===a.$hc.sep}function t(y,R=N.$i){return R?p(y.charCodeAt(0))&&y.charCodeAt(1)===P.CharCode.Colon:!1}function s(y,R=N.$i){return t(y,R)?y[0]:void 0}function r(y,R,O){return R.length>y.length?-1:y===R?0:(O&&(y=y.toLowerCase(),R=R.toLowerCase()),y.indexOf(R))}function i(y){const R=y.split(":");let O,E,v;for(const T of R){const U=Number(T);(0,C.$ig)(U)?E===void 0?E=U:v===void 0&&(v=U):O=O?[O,T].join(":"):T}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:E!==void 0?E:void 0,column:v!==void 0?v:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(y,R,O=8){let E="";for(let T=0;T<O;T++){let U;T===0&&N.$i&&!R&&(O===3||O===4)?U=o:U=n,E+=U.charAt(Math.floor(Math.random()*U.length))}let v;return R?v=`${R}-${E}`:v=E,y?(0,a.$kc)(y,v):v}}),define(le[147],he([0,1,14]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$5s=L,e.$6s=C,e.$7s=k,e.$8s=w,e.$4s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(S){const m=(0,P.$pc)(S),h=a[m.toLowerCase()];return h!==void 0?h:C(S)}function C(S){const m=(0,P.$pc)(S);return N[m.toLowerCase()]}function k(S){for(const m in N)if(N[m]===S)return m}const A=/^(.+)\/(.+?)(;.+)?$/;function w(S,m){const h=A.exec(S);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:m?void 0:S}}),define(le[93],he([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=L,e.$km=C;var a;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(a||(e.Source=a={}));var N;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function L(k,...A){const w=A.reduce((h,$)=>(h[$]=!0,h),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(h=>!w[h]).forEach(h=>{for(let $=0;$<S.length;$++)if(h.search(S[$])!==-1){delete k[h];break}})}function C(k){k&&(delete k.DEBUG,P.$j&&delete k.DYLD_LIBRARY_PATH,P.$k&&delete k.LD_PRELOAD)}}),define(le[9],he([0,1,39,65,14,5]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=b,e.$xc=t,N=ke(N);const C=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function w(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!C.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!k.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,l){return!o&&!l?"file":o}function m(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==$&&(l=$+l):l=$;break}return l}const h="",$="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(l){return l instanceof g?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,y,R,O,E,v=!1){typeof l=="object"?(this.scheme=l.scheme||h,this.authority=l.authority||h,this.path=l.path||h,this.query=l.query||h,this.fragment=l.fragment||h):(this.scheme=S(l,v),this.authority=y||h,this.path=m(this.scheme,R||h),this.query=O||h,this.fragment=E||h,w(this,v))}get fsPath(){return t(this,!1)}with(l){if(!l)return this;let{scheme:y,authority:R,path:O,query:E,fragment:v}=l;return y===void 0?y=this.scheme:y===null&&(y=h),R===void 0?R=this.authority:R===null&&(R=h),O===void 0?O=this.path:O===null&&(O=h),E===void 0?E=this.query:E===null&&(E=h),v===void 0?v=this.fragment:v===null&&(v=h),y===this.scheme&&R===this.authority&&O===this.path&&E===this.query&&v===this.fragment?this:new p(y,R,O,E,v)}static parse(l,y=!1){const R=c.exec(l);return R?new p(R[2]||h,n(R[4]||h),n(R[5]||h),n(R[7]||h),n(R[9]||h),y):new p(h,h,h,h,h)}static file(l){let y=h;if(L.$i&&(l=l.replace(/\\/g,$)),l[0]===$&&l[1]===$){const R=l.indexOf($,2);R===-1?(y=l.substring(2),l=$):(y=l.substring(2,R),l=l.substring(R)||$)}return new p("file",y,l,h,h)}static from(l,y){return new p(l.scheme,l.authority,l.path,l.query,l.fragment,y)}static joinPath(l,...y){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return L.$i&&l.scheme==="file"?R=g.file(N.$gc.join(t(l,!0),...y)).path:R=N.$hc.join(l.path,...y),l.with({path:R})}toString(l=!1){return s(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof g)return l;{const y=new p(l);return y._formatted=l.external??null,y._fsPath=l._sep===f?l.fsPath??null:null,y}}else return l}}e.URI=g;function b(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const f=L.$i?1:void 0;class p extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(l=!1){return l?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const l={$mid:a.MarshalledId.Uri};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=f),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const I={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function d(o,l,y){let R,O=-1;for(let E=0;E<o.length;E++){const v=o.charCodeAt(E);if(v>=P.CharCode.a&&v<=P.CharCode.z||v>=P.CharCode.A&&v<=P.CharCode.Z||v>=P.CharCode.Digit0&&v<=P.CharCode.Digit9||v===P.CharCode.Dash||v===P.CharCode.Period||v===P.CharCode.Underline||v===P.CharCode.Tilde||l&&v===P.CharCode.Slash||y&&v===P.CharCode.OpenSquareBracket||y&&v===P.CharCode.CloseSquareBracket||y&&v===P.CharCode.Colon)O!==-1&&(R+=encodeURIComponent(o.substring(O,E)),O=-1),R!==void 0&&(R+=o.charAt(E));else{R===void 0&&(R=o.substr(0,E));const T=I[v];T!==void 0?(O!==-1&&(R+=encodeURIComponent(o.substring(O,E)),O=-1),R+=T):O===-1&&(O=E)}}return O!==-1&&(R+=encodeURIComponent(o.substring(O))),R!==void 0?R:o}function u(o){let l;for(let y=0;y<o.length;y++){const R=o.charCodeAt(y);R===P.CharCode.Hash||R===P.CharCode.QuestionMark?(l===void 0&&(l=o.substr(0,y)),l+=I[R]):l!==void 0&&(l+=o[y])}return l!==void 0?l:o}function t(o,l){let y;return o.authority&&o.path.length>1&&o.scheme==="file"?y=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===P.CharCode.Slash&&(o.path.charCodeAt(1)>=P.CharCode.A&&o.path.charCodeAt(1)<=P.CharCode.Z||o.path.charCodeAt(1)>=P.CharCode.a&&o.path.charCodeAt(1)<=P.CharCode.z)&&o.path.charCodeAt(2)===P.CharCode.Colon?l?y=o.path.substr(1):y=o.path[1].toLowerCase()+o.path.substr(2):y=o.path,L.$i&&(y=y.replace(/\//g,"\\")),y}function s(o,l){const y=l?u:d;let R="",{scheme:O,authority:E,path:v,query:T,fragment:U}=o;if(O&&(R+=O,R+=":"),(E||O==="file")&&(R+=$,R+=$),E){let F=E.indexOf("@");if(F!==-1){const M=E.substr(0,F);E=E.substr(F+1),F=M.lastIndexOf(":"),F===-1?R+=y(M,!1,!1):(R+=y(M.substr(0,F),!1,!1),R+=":",R+=y(M.substr(F+1),!1,!0)),R+="@"}E=E.toLowerCase(),F=E.lastIndexOf(":"),F===-1?R+=y(E,!1,!0):(R+=y(E.substr(0,F),!1,!0),R+=E.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===P.CharCode.Slash&&v.charCodeAt(2)===P.CharCode.Colon){const F=v.charCodeAt(1);F>=P.CharCode.A&&F<=P.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===P.CharCode.Colon){const F=v.charCodeAt(0);F>=P.CharCode.A&&F<=P.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}R+=y(v,!0,!1)}return T&&(R+="?",R+=y(T,!1,!1)),U&&(R+="#",R+=l?U:d(U,!1,!1)),R}function r(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+r(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(i)?o.replace(i,l=>r(l)):o}}),define(le[148],he([0,1,9]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=a,e.$0q=N,e.$$q=L,e.log=k;function a(w){const S=w;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function N(w){const S=[];let m;try{const h=JSON.parse(w.arguments),$=h[h.length-1];$&&$.__$stack&&(h.pop(),m=$.__$stack),S.push(...h)}catch{S.push("Unable to log remote console arguments",w.arguments)}return{args:S,stack:m}}function L(w){if(typeof w!="string")return L(N(w).stack);const S=w;if(S){const m=C(S),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(h&&h.length===4)return{uri:P.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function C(w){if(!w)return w;const S=w.indexOf(`
`);return S===-1?w:w.substring(0,S)}function k(w,S){const{args:m,stack:h}=N(w),$=typeof m[0]=="string"&&m.length===1;let c=C(h);c&&(c=`(${c.trim()})`);let g=[];if(typeof m[0]=="string"?c&&$?g=[`%c[${S}] %c${m[0]} %c${c}`,A("blue"),A(""),A("grey")]:g=[`%c[${S}] %c${m[0]}`,A("blue"),A(""),...m.slice(1)]:g=[`%c[${S}]%`,A("blue"),...m],c&&!$&&g.push(c),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}function A(w){return`color: ${w}`}}),define(le[68],he([0,1,15,9,65]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=L,e.$ai=C,e.$bi=A;function L(w){return JSON.stringify(w,k)}function C(w){let S=JSON.parse(w);return S=A(S),S}function k(w,S){return S instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function A(w,S=0){if(!w||S>200)return w;if(typeof w=="object"){switch(w.$mid){case N.MarshalledId.Uri:return a.URI.revive(w);case N.MarshalledId.Regexp:return new RegExp(w.source,w.flags);case N.MarshalledId.Date:return new Date(w.source)}if(w instanceof P.$Ne||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let m=0;m<w.length;++m)w[m]=A(w[m],S+1);else for(const m in w)Object.hasOwnProperty.call(w,m)&&(w[m]=A(w[m],S+1))}return w}}),define(le[23],he([0,1,8,5,27,9,14]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=A,e.$Og=w,e.$Sg=m,P=ke(P),a=ke(a),C=ke(C);var k;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(k||(e.Schemas=k={}));function A(c,g){return L.URI.isUri(c)?(0,N.$Ff)(c.scheme,g):(0,N.$Gf)(c,g+":")}function w(c,...g){return g.some(b=>A(c,b))}e.$Pg="vscode-tkn",e.$Qg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,b){this.f=m(g,b)}getServerRootPath(){return this.f}get g(){return C.$hc.join(this.f,k.vscodeRemoteResource)}set(g,b,f){this.a[g]=b,this.b[g]=f}setConnectionToken(g,b){this.c[g]=b}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(u){return P.$2(u),g}const b=g.authority;let f=this.a[b];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const p=this.b[b],I=this.c[b];let d=`path=${encodeURIComponent(g.path)}`;return typeof I=="string"&&(d+=`&${e.$Qg}=${encodeURIComponent(I)}`),L.URI.from({scheme:a.$o?this.d:k.vscodeRemoteResource,authority:`${f}:${p}`,path:this.g,query:d})}}e.$Rg=new S;function m(c,g){return C.$hc.join(g??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class h{static{this.a=e.$Xg}asBrowserUri(g){const b=this.b(g,ne);return this.uriToBrowserUri(b)}uriToBrowserUri(g){return g.scheme===k.vscodeRemote?e.$Rg.rewrite(g):g.scheme===k.file&&(a.$m||a.$q===`${k.vscodeFileResource}://${h.a}`)?g.with({scheme:k.vscodeFileResource,authority:g.authority||h.a,query:null,fragment:null}):g}asFileUri(g){const b=this.b(g,ne);return this.uriToFileUri(b)}uriToFileUri(g){return g.scheme===k.vscodeFileResource?g.with({scheme:k.file,authority:g.authority!==h.a?g.authority:null,query:null,fragment:null}):g}b(g,b){return L.URI.isUri(g)?g:L.URI.parse(b.toUrl(g))}}e.$Yg=new h;var $;(function(c){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(g.get("3"));const b="vscode-coi";function f(I){let d;typeof I=="string"?d=new URL(I).searchParams:I instanceof URL?d=I.searchParams:L.URI.isUri(I)&&(d=new URL(I.toString(!0)).searchParams);const u=d?.get(b);if(u)return g.get(u)}c.getHeadersFromQuery=f;function p(I,d,u){if(!globalThis.crossOriginIsolated)return;const t=d&&u?"3":u?"2":"1";I instanceof URLSearchParams?I.set(b,t):I[b]=t}c.addSearchParam=p})($||(e.COI=$={}))}),define(le[149],he([0,1,129,23,5,9]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=S,N=ke(N);class C{constructor(h,$,c){this.id=h,this.dependencies=$,this.callback=c}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,$,c)=>{typeof h!="string"&&(c=$,$=h,h=null),(typeof $!="object"||!Array.isArray($))&&(c=$,$=null),this.c.push(new C(h,$,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const $=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!$)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(h){return new Promise(($,c)=>{const g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript");const b=()=>{g.removeEventListener("load",f),g.removeEventListener("error",p)},f=I=>{b(),$(this.c.pop())},p=I=>{b(),c(I)};g.addEventListener("load",f),g.addEventListener("error",p),this.f&&(h=this.f.createScriptURL(h)),g.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(g)})}i(h){return new Promise(($,c)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),$(this.c.pop())}catch(g){c(g)}})}async j(h){try{const $=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,g=globalThis._VSCODE_NODE_MODULES.module,b=L.URI.parse(h).fsPath,f=$.readFileSync(b).toString(),p=g.wrap(f.replace(/^#!.*/,""));return new c.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const A=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function S(m,h,$){if(P.$U){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[m]&&(m=w[m]);const c=`${m}/${h}`;if(A.has(c))return A.get(c);let g;if(/^\w[\w\d+.-]*:\/\//.test(c))g=c;else{const I=`${$&&!N.$o?a.$Vg:a.$Ug}/${c}`;g=a.$Yg.asBrowserUri(I).toString(!0)}const b=k.INSTANCE.load(g);return A.set(c,b),b}else return await new Promise((c,g)=>{ne([m],c,g)}).then(ke)}}),define(le[21],he([0,1,39,42,23,14,5,27,9]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=w,e.$oh=m,e.$ph=$,a=ke(a),L=ke(L);function w(c){return(0,A.$xc)(c,!0)}class S{constructor(g){this.a=g}compare(g,b,f=!1){return g===b?0:(0,k.$yf)(this.getComparisonKey(g,f),this.getComparisonKey(b,f))}isEqual(g,b,f=!1){return g===b?!0:!g||!b?!1:this.getComparisonKey(g,f)===this.getComparisonKey(b,f)}getComparisonKey(g,b=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,b,f=!1){if(g.scheme===b.scheme){if(g.scheme===N.Schemas.file)return a.$Dg(w(g),w(b),this.a(g))&&g.query===b.query&&(f||g.fragment===b.fragment);if((0,e.$kh)(g.authority,b.authority))return a.$Dg(g.path,b.path,this.a(g),"/")&&g.query===b.query&&(f||g.fragment===b.fragment)}return!1}joinPath(g,...b){return A.URI.joinPath(g,...b)}basenameOrAuthority(g){return(0,e.$ch)(g)||g.authority}basename(g){return L.$hc.basename(g.path)}extname(g){return L.$hc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let b;return g.scheme===N.Schemas.file?b=A.URI.file(L.$nc(w(g))).path:(b=L.$hc.dirname(g.path),g.authority&&b.length&&b.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${g.toString})) resulted in a relative path`),b="/")),g.with({path:b})}normalizePath(g){if(!g.path.length)return g;let b;return g.scheme===N.Schemas.file?b=A.URI.file(L.$ic(w(g))).path:b=L.$hc.normalize(g.path),g.with({path:b})}relativePath(g,b){if(g.scheme!==b.scheme||!(0,e.$kh)(g.authority,b.authority))return;if(g.scheme===N.Schemas.file){const I=L.$mc(w(g),w(b));return C.$i?a.$xg(I):I}let f=g.path||"/";const p=b.path||"/";if(this.a(g)){let I=0;for(const d=Math.min(f.length,p.length);I<d&&!(f.charCodeAt(I)!==p.charCodeAt(I)&&f.charAt(I).toLowerCase()!==p.charAt(I).toLowerCase());I++);f=p.substr(0,I)+f.substr(I)}return L.$hc.relative(f,p)}resolvePath(g,b){if(g.scheme===N.Schemas.file){const f=A.URI.file(L.$lc(w(g),b));return g.with({authority:f.authority,path:f.path})}return b=a.$yg(b),g.with({path:L.$hc.resolve(g.path,b)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,b){return g===b||g!==void 0&&b!==void 0&&(0,k.$Ff)(g,b)}hasTrailingPathSeparator(g,b=L.sep){if(g.scheme===N.Schemas.file){const f=w(g);return f.length>a.$zg(f).length&&f[f.length-1]===b}else{const f=g.path;return f.length>1&&f.charCodeAt(f.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,b=L.sep){return(0,e.$lh)(g,b)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,b=L.sep){let f=!1;if(g.scheme===N.Schemas.file){const p=w(g);f=p!==void 0&&p.length===a.$zg(p).length&&p[p.length-1]===b}else{b="/";const p=g.path;f=p.length===1&&p.charCodeAt(p.length-1)===P.CharCode.Slash}return!f&&!(0,e.$lh)(g,b)?g.with({path:g.path+"/"}):g}}e.$7g=S,e.$8g=new S(()=>!1),e.$9g=new S(c=>c.scheme===N.Schemas.file?!C.$k:!0),e.$0g=new S(c=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function m(c,g){const b=[];for(let f=0;f<c.length;f++){const p=g(c[f]);c.some((I,d)=>d===f?!1:(0,e.$_g)(p,g(I)))||b.push(c[f])}return b}var h;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(b){const f=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,t]=d.split(":");u&&t&&f.set(u,t)});const I=b.path.substring(0,b.path.indexOf(";"));return I&&f.set(c.META_DATA_MIME,I),f}c.parseMetaData=g})(h||(e.DataUri=h={}));function $(c,g,b){if(g){let f=c.path;return f&&f[0]!==L.$hc.sep&&(f=L.$hc.sep+f),c.with({scheme:b,authority:g,path:f})}return c.with({scheme:b})}}),define(le[6],he([0,1,26,8,3,2,21,5,135,54]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=S,e.$rh=m,e.$sh=h,e.$th=$,e.$uh=c,e.$vh=g,e.$wh=b,e.$xh=f,e.$Fh=o,e.$Gh=l,e.$Hh=y,e.$Ih=R,e.$Jh=O,e.$Yh=z,e.$7h=W;function S(_){return!!_&&typeof _.then=="function"}function m(_){const Y=new P.$we,ae=_(Y.token),ue=new Promise((ge,we)=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),we(new a.$6)});Promise.resolve(ae).then(pe=>{Ee.dispose(),Y.dispose(),ge(pe)},pe=>{Ee.dispose(),Y.dispose(),we(pe)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,we){return ue.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function h(_,Y,ae){return new Promise((ue,ge)=>{const we=Y.onCancellationRequested(()=>{we.dispose(),ue(ae)});_.then(ue,ge).finally(()=>we.dispose())})}function $(_,Y){return new Promise((ae,ue)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),ue(new a.$6)});_.then(ae,ue).finally(()=>ge.dispose())})}async function c(_){let Y=-1;const ae=_.map((ue,ge)=>ue.then(we=>(Y=ge,we)));try{return await Promise.race(ae)}finally{_.forEach((ue,ge)=>{ge!==Y&&ue.cancel()})}}function g(_,Y,ae){let ue;const ge=setTimeout(()=>{ue?.(void 0),ae?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(we=>ue=we)])}function b(_){return new Promise((Y,ae)=>{const ue=_();S(ue)?ue.then(Y,ae):Y(ue)})}function f(){let _,Y;return{promise:new Promise((ue,ge)=>{_=ue,Y=ge}),resolve:_,reject:Y}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const ae=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(ae,ae).then(ue)})}return new Promise((ae,ue)=>{this.b.then(ae,ue)})}return this.a=Y(),new Promise((ae,ue)=>{this.a.then(ge=>{this.a=null,ae(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$yh=p;class I{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$zh=I;class d{constructor(){this.a=new Map}queue(Y,ae){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$Ah=d;const u=(_,Y)=>{let ae=!0;const ue=setTimeout(()=>{ae=!1,Y()},_);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(ue),ae=!1}}},t=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class s{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ae=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,we)=>{this.d=ge,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=ae===A.$ge?t(ue):u(ae,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=s;class r{constructor(Y){this.a=new s(Y),this.b=new p}trigger(Y,ae){return this.a.trigger(()=>this.b.queue(Y),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=r;class i{constructor(){this.a=!1,this.b=new Promise((Y,ae)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=i;class n extends i{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Eh=n;function o(_,Y){return Y?new Promise((ae,ue)=>{const ge=setTimeout(()=>{we.dispose(),ae()},_),we=Y.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),ue(new a.$6)})}):m(ae=>o(_,ae))}function l(_,Y=0,ae){const ue=setTimeout(()=>{_(),ae&&ge.dispose()},Y),ge=(0,L.$Tc)(()=>{clearTimeout(ue),ae?.deleteAndLeak(ge)});return ae?.add(ge),ge}function y(_){const Y=[];let ae=0;const ue=_.length;function ge(){return ae<ue?_[ae++]():null}function we(Ee){Ee!=null&&Y.push(Ee);const pe=ge();return pe?pe.then(we):Promise.resolve(Y)}return Promise.resolve(null).then(we)}function R(_,Y=ue=>!!ue,ae=null){let ue=0;const ge=_.length,we=()=>{if(ue>=ge)return Promise.resolve(ae);const Ee=_[ue++];return Promise.resolve(Ee()).then(be=>Y(be)?Promise.resolve(be):we())};return we()}function O(_,Y=ue=>!!ue,ae=null){if(_.length===0)return Promise.resolve(ae);let ue=_.length;const ge=()=>{ue=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ee)=>{for(const pe of _)pe.then(be=>{--ue>=0&&Y(be)?(ge(),we(be)):ue===0&&we(ae)}).catch(be=>{--ue>=0&&(ge(),Ee(be))})})}class E{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new N.$le}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,ue)=>{this.g.push({factory:Y,c:ae,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const ae=Y.factory();ae.then(Y.c,Y.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=E;class v extends E{constructor(){super(1)}}e.$Lh=v;class T{constructor(){this.a=new ee,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Mh=T;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new q;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,ae=C.$8g){const ue=ae.getComparisonKey(Y);return this.a.get(ue)?.size??0}queueFor(Y,ae,ue=C.$8g){const ge=ue.getComparisonKey(Y);let we=this.a.get(ge);if(!we){we=new v;const Ee=this.f++,pe=N.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$5c),this.d.set(Ee,pe),this.a.set(ge,we)}return we.queue(ae)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=U;class F{constructor(Y,ae){this.b=!1,this.a=-1,typeof Y=="function"&&typeof ae=="number"&&this.setIfNotSet(Y,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ae){if(this.b)throw new a.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ae)}setIfNotSet(Y,ae){if(this.b)throw new a.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ae))}}e.$Oh=F;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,ae,ue=globalThis){if(this.f)throw new a.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{Y()},ae);this.d=(0,L.$Tc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=M;class X{constructor(Y,ae){this.b=-1,this.a=Y,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=X;class K{constructor(Y,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=K;class Q extends X{constructor(Y,ae){super(Y,ae),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Sh=Q;class G extends L.$Vc{constructor(Y,ae){super(),this.g=Y,this.h=ae,this.a=[],this.b=this.B(new L.$Wc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Y)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(_,Y)=>{(0,k.$B)(()=>{if(ae)return;const ue=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Vh=(_,Y,ae)=>{const ue=_.requestIdleCallback(Y,typeof ae=="number"?{timeout:ae}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Uh=_=>(0,e.$Vh)(globalThis,_)}();class ie{constructor(Y,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Vh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ie;class V extends ie{constructor(Y){super(globalThis,Y)}}e.$Xh=V;async function z(_,Y,ae){let ue;for(let ge=0;ge<ae;ge++)try{return await _()}catch(we){ue=we,await o(Y)}throw ue}class ee{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,ae,ue){return this.a={taskId:Y,cancel:()=>ue?.(),promise:ae},ae.then(()=>this.d(Y),()=>this.d(Y)),ae}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:ae,resolve:ue,reject:ge}=f();this.b={run:Y,promise:ae,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=ee;class re{constructor(Y,ae=()=>Date.now()){this.d=Y,this.f=ae,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$1h=re;var ce;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ce||(ce={}));class q{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,ae)=>{this.a=Y,this.b=ae})}complete(Y){return new Promise(ae=>{this.a(Y),this.d={outcome:ce.Resolved,value:Y},ae()})}error(Y){return new Promise(ae=>{this.b(Y),this.d={outcome:ce.Rejected,value:Y},ae()})}cancel(){return this.error(new a.$6)}}e.$2h=q;var x;(function(_){async function Y(ue){let ge;const we=await Promise.all(ue.map(Ee=>Ee.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return we}_.settled=Y;function ae(ue){return new Promise(async(ge,we)=>{try{await ue(ge,we)}catch(Ee){we(Ee)}})}_.withAsyncBody=ae})(x||(e.Promises=x={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new a.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=J;class H{constructor(Y){this.b=Y,this.a=new w.$W(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=H;var D;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(D||(D={}));class B{static fromArray(Y){return new B(ae=>{ae.emitMany(Y)})}static fromPromise(Y){return new B(async ae=>{ae.emitMany(await Y)})}static fromPromises(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>ae.emitOne(await ue)))})}static merge(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>{for await(const ge of ue)ae.emitOne(ge)}))})}static{this.EMPTY=B.fromArray([])}constructor(Y,ae){this.a=D.Initial,this.b=[],this.d=null,this.f=ae,this.g=new N.$le,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,ae){return new B(async ue=>{for await(const ge of Y)ue.emitOne(ae(ge))})}map(Y){return B.map(this,Y)}static filter(Y,ae){return new B(async ue=>{for await(const ge of Y)ae(ge)&&ue.emitOne(ge)})}filter(Y){return B.filter(this,Y)}static coalesce(Y){return B.filter(Y,ae=>!!ae)}coalesce(){return B.coalesce(this)}static async toPromise(Y){const ae=[];for await(const ue of Y)ae.push(ue);return ae}toPromise(){return B.toPromise(this)}h(Y){this.a===D.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===D.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(Y){this.a===D.Initial&&(this.a=D.DoneError,this.d=Y,this.g.fire())}}e.$5h=B;class j extends B{constructor(Y,ae){super(ae),this.m=Y}cancel(){this.m.cancel()}}e.$6h=j;function W(_){const Y=new P.$we,ae=_(Y.token);return new j(Y,async ue=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),ue.reject(new a.$6)});try{for await(const we of ae){if(Y.token.isCancellationRequested)return;ue.emitOne(we)}ge.dispose(),Y.dispose()}catch(we){ge.dispose(),Y.dispose(),ue.reject(we)}})}class te{constructor(Y){this.a=new q,this.b=new B(ge=>{if(ae){ge.reject(ae);return}return ue&&ge.emitMany(ue),this.d=we=>ge.reject(we),this.f=we=>ge.emitOne(we),this.a.p},Y);let ae,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{ae||(ae=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$8h=te}),define(le[94],he([0,1,19,6,39,42,35,14,5,27]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=S,e.$wk=g,e.$xk=T,e.$yk=U,e.$zk=F,e.$Ak=M,e.$Bk=X,e.$Ck=ie;function S(){return Object.create(null)}e.$uk="**",e.$vk="/";const m="[/\\\\]",h="[^/\\\\]",$=/\//g;function c(V,z){switch(V){case 0:return"";case 1:return`${h}*?`;default:return`(?:${m}|${h}+${m}${z?`|${m}${h}+`:""})*?`}}function g(V,z){if(!V)return[];const ee=[];let re=!1,ce=!1,q="";for(const x of V){switch(x){case z:if(!re&&!ce){ee.push(q),q="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}q+=x}return q&&ee.push(q),ee}function b(V){if(!V)return"";let z="";const ee=g(V,e.$vk);if(ee.every(re=>re===e.$uk))z=".*";else{let re=!1;ee.forEach((ce,q)=>{if(ce===e.$uk){if(re)return;z+=c(2,q===ee.length-1)}else{let x=!1,J="",H=!1,D="";for(const B of ce){if(B!=="}"&&x){J+=B;continue}if(H&&(B!=="]"||!D)){let j;B==="-"?j=B:(B==="^"||B==="!")&&!D?j="^":B===e.$vk?j="":j=(0,w.$hf)(B),D+=j;continue}switch(B){case"{":x=!0;continue;case"[":H=!0;continue;case"}":{const W=`(?:${g(J,",").map(te=>b(te)).join("|")})`;z+=W,x=!1,J="";break}case"]":{z+="["+D+"]",H=!1,D="";break}case"?":z+=h;continue;case"*":z+=c(1);continue;default:z+=(0,w.$hf)(B)}}q<ee.length-1&&(ee[q+1]!==e.$uk||q+2<ee.length)&&(z+=m)}re=ce===e.$uk})}return z}const f=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new C.$Ec(1e4),r=function(){return!1},i=function(){return null};function n(V,z){if(!V)return i;let ee;typeof V!="string"?ee=V.pattern:ee=V,ee=ee.trim();const re=`${ee}_${!!z.trimForExclusions}`;let ce=s.get(re);if(ce)return o(ce,V);let q;return f.test(ee)?ce=y(ee.substr(4),ee):(q=p.exec(l(ee,z)))?ce=R(q[1],ee):(z.trimForExclusions?d:I).test(ee)?ce=O(ee,z):(q=u.exec(l(ee,z)))?ce=E(q[1].substr(1),ee,!0):(q=t.exec(l(ee,z)))?ce=E(q[1],ee,!1):ce=v(ee),s.set(re,ce),o(ce,V)}function o(V,z){if(typeof z=="string")return V;const ee=function(re,ce){return(0,L.$Dg)(re,z.base,!A.$k)?V((0,w.$mf)(re.substr(z.base.length),k.sep),ce):null};return ee.allBasenames=V.allBasenames,ee.allPaths=V.allPaths,ee.basenames=V.basenames,ee.patterns=V.patterns,ee}function l(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function y(V,z){return function(ee,re){return typeof ee=="string"&&ee.endsWith(V)?z:null}}function R(V,z){const ee=`/${V}`,re=`\\${V}`,ce=function(x,J){return typeof x!="string"?null:J?J===V?z:null:x===V||x.endsWith(ee)||x.endsWith(re)?z:null},q=[V];return ce.basenames=q,ce.patterns=[z],ce.allBasenames=q,ce}function O(V,z){const ee=G(V.slice(1,-1).split(",").map(J=>n(J,z)).filter(J=>J!==i),V),re=ee.length;if(!re)return i;if(re===1)return ee[0];const ce=function(J,H){for(let D=0,B=ee.length;D<B;D++)if(ee[D](J,H))return V;return null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function E(V,z,ee){const re=k.sep===k.$hc.sep,ce=re?V:V.replace($,k.sep),q=k.sep+ce,x=k.$hc.sep+V;let J;return ee?J=function(H,D){return typeof H=="string"&&(H===ce||H.endsWith(q)||!re&&(H===V||H.endsWith(x)))?z:null}:J=function(H,D){return typeof H=="string"&&(H===ce||!re&&H===V)?z:null},J.allPaths=[(ee?"*/":"./")+V],J}function v(V){try{const z=new RegExp(`^${b(V)}$`);return function(ee){return z.lastIndex=0,typeof ee=="string"&&z.test(ee)?V:null}}catch{return i}}function T(V,z,ee){return!V||typeof z!="string"?!1:U(V)(z,void 0,ee)}function U(V,z={}){if(!V)return r;if(typeof V=="string"||F(V)){const ee=n(V,z);if(ee===i)return r;const re=function(ce,q){return!!ee(ce,q)};return ee.allBasenames&&(re.allBasenames=ee.allBasenames),ee.allPaths&&(re.allPaths=ee.allPaths),re}return K(V,z)}function F(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(V){return V.allBasenames||[]}function X(V){return V.allPaths||[]}function K(V,z){const ee=G(Object.getOwnPropertyNames(V).map(J=>Q(J,V[J],z)).filter(J=>J!==i)),re=ee.length;if(!re)return i;if(!ee.some(J=>!!J.requiresSiblings)){if(re===1)return ee[0];const J=function(B,j){let W;for(let te=0,_=ee.length;te<_;te++){const Y=ee[te](B,j);if(typeof Y=="string")return Y;(0,a.$qh)(Y)&&(W||(W=[]),W.push(Y))}return W?(async()=>{for(const te of W){const _=await te;if(typeof _=="string")return _}return null})():null},H=ee.find(B=>!!B.allBasenames);H&&(J.allBasenames=H.allBasenames);const D=ee.reduce((B,j)=>j.allPaths?B.concat(j.allPaths):B,[]);return D.length&&(J.allPaths=D),J}const ce=function(J,H,D){let B,j;for(let W=0,te=ee.length;W<te;W++){const _=ee[W];_.requiresSiblings&&D&&(H||(H=(0,k.$oc)(J)),B||(B=H.substr(0,H.length-(0,k.$pc)(J).length)));const Y=_(J,H,B,D);if(typeof Y=="string")return Y;(0,a.$qh)(Y)&&(j||(j=[]),j.push(Y))}return j?(async()=>{for(const W of j){const te=await W;if(typeof te=="string")return te}return null})():null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function Q(V,z,ee){if(z===!1)return i;const re=n(V,ee);if(re===i)return i;if(typeof z=="boolean")return re;if(z){const ce=z.when;if(typeof ce=="string"){const q=(x,J,H,D)=>{if(!D||!re(x,J))return null;const B=ce.replace("$(basename)",()=>H),j=D(B);return(0,a.$qh)(j)?j.then(W=>W?V:null):j?V:null};return q.requiresSiblings=!0,q}}return re}function G(V,z){const ee=V.filter(J=>!!J.basenames);if(ee.length<2)return V;const re=ee.reduce((J,H)=>{const D=H.basenames;return D?J.concat(D):J},[]);let ce;if(z){ce=[];for(let J=0,H=re.length;J<H;J++)ce.push(z)}else ce=ee.reduce((J,H)=>{const D=H.patterns;return D?J.concat(D):J},[]);const q=function(J,H){if(typeof J!="string")return null;if(!H){let B;for(B=J.length;B>0;B--){const j=J.charCodeAt(B-1);if(j===N.CharCode.Slash||j===N.CharCode.Backslash)break}H=J.substr(B)}const D=re.indexOf(H);return D!==-1?ce[D]:null};q.basenames=re,q.patterns=ce,q.allBasenames=re;const x=V.filter(J=>!J.basenames);return x.push(q),x}function ie(V,z){return(0,P.$vb)(V,z,(ee,re)=>typeof ee=="string"&&typeof re=="string"?ee===re:typeof ee!="string"&&typeof re!="string"?ee.base===re.base&&ee.pattern===re.pattern:!1)}}),define(le[95],he([0,1,15,65,9]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=A,e.$Ln=S,e.$Mn=m;function L(h){return h.toJSON()}class C{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:L(N.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:L(N.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:N.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$In=C,e.$Jn=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function k(h,$,c){if(!h||c>200)return null;if(typeof h=="object"){if(h instanceof N.URI)return $.transformOutgoing(h);for(const g in h)if(Object.hasOwnProperty.call(h,g)){const b=k(h[g],$,c+1);b!==null&&(h[g]=b)}}return null}function A(h,$){const c=k(h,$,0);return c===null?h:c}function w(h,$,c,g){if(!h||g>200)return null;if(typeof h=="object"){if(h.$mid===a.MarshalledId.Uri)return c?N.URI.revive($.transformIncoming(h)):$.transformIncoming(h);if(h instanceof P.$Ne)return null;for(const b in h)if(Object.hasOwnProperty.call(h,b)){const f=w(h[b],$,c,g+1);f!==null&&(h[b]=f)}}return null}function S(h,$){const c=w(h,$,!1,0);return c===null?h:c}function m(h,$){const c=w(h,$,!0,0);return c===null?h:c}}),define(le[150],he([0,1,38,52,32,137,5]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$Pn=A,e.$Qn=m,e.$Rn=h,N=ke(N),e.$On=new class{c($){return this.a||(this.a=a.$Ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,c=0;const g=(0,P.networkInterfaces)();for(const b in g){const f=g[b];if(f)for(const{mac:p,internal:I}of f)I||(c+=1,this.c(p.toUpperCase())&&($+=1))}this.b=c>0?$/c:0}return this.b}};let k;async function A($){return k||(k=(async()=>await w($)||N.$1g())()),k}async function w($){try{const c=await new Promise((b,f)=>{ne(["crypto"],b,f)}).then(ke),g=(0,L.$Nn)();return c.createHash("sha256").update(g,"utf8").digest("hex")}catch(c){$(c);return}}const S="Software\\Microsoft\\SQMClient";async function m($){if(C.$i){const c=await new Promise((g,b)=>{ne(["@vscode/windows-registry"],g,b)}).then(ke);try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(g){return $(g),""}}return""}async function h($){try{return await(await new Promise((b,f)=>{ne(["@vscode/deviceid"],b,f)}).then(ke)).getDeviceId()}catch(c){return $(c),""}}}),define(le[151],he([0,1,46,152,14,36]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6W=S,e.$7W=m;const C="XDG_SESSION_TYPE",k="WAYLAND_DISPLAY",A="XDG_RUNTIME_DIR";var w;(function(h){h.Wayland="wayland",h.XWayland="xwayland",h.X11="x11",h.Unknown="unknown"})(w||(w={}));async function S(h){const $=L.env[C];if($)return $===w.Wayland||$===w.X11?$:w.Unknown;if(L.env[k]){const g=L.env[A];if(g){const b=(0,N.$kc)(g,"wayland-0");try{return await(0,a.access)(b,P.constants.R_OK),w.Wayland}catch(f){return h(f),w.Unknown}}else return w.Unknown}else return w.X11}function m(h,$){if($)switch($){case"auto":return h;case"x11":return h===w.Wayland?w.XWayland:w.X11;case"wayland":return w.Wayland;default:return w.Unknown}else return h===w.Wayland?w.XWayland:w.X11}}),define(le[153],he([0,1,46,152,277,5]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=C,L=ke(L);async function C(k){if(L.$j||L.$i)return;let A;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{A=await(0,a.open)(w,P.constants.R_OK);break}catch{}if(!A){k("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const m of(0,N.createInterface)({input:A.createReadStream(),crlfDelay:1/0})){if(!m.includes("="))continue;const h=m.split("=")[0].toUpperCase().trim();if(w.has(h)){const $=m.split("=")[1].replace(/"/g,"").toLowerCase().trim();h==="ID"||h==="DISTRIB_ID"?S.id=$:h==="ID_LIKE"?S.id_like=$:(h==="VERSION_ID"||h==="DISTRIB_RELEASE")&&(S.version_id=$)}}return S}catch(w){k(w)}}}),define(le[31],he([0,1,46,38,278,6,42,91,14,5,21,9]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=b,e.readdirSync=I,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=y,P=ke(P);var h;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function $(K,Q=h.UNLINK,G){if((0,C.$Hg)(K))throw new Error("rimraf - will refuse to recursively delete root");return Q===h.UNLINK?g(K):c(K,G)}async function c(K,Q=(0,C.$Mg)((0,a.tmpdir)())){try{try{await P.promises.rename(K,Q)}catch(G){return G.code==="ENOENT"?void 0:g(K)}g(Q).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(K){return P.promises.rm(K,{recursive:!0,force:!0,maxRetries:3})}function b(K){if((0,C.$Hg)(K))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function f(K,Q){return d(await(Q?p(K):P.promises.readdir(K)))}async function p(K){try{return await P.promises.readdir(K,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const Q=[],G=await f(K);for(const ie of G){let V=!1,z=!1,ee=!1;try{const re=await e.Promises.lstat((0,A.$kc)(K,ie));V=re.isFile(),z=re.isDirectory(),ee=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Q.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>ee})}return Q}function I(K){return d(P.readdirSync(K))}function d(K){return K.map(Q=>typeof Q=="string"?w.$j?(0,k.$lm)(Q):Q:(Q.name=w.$j?(0,k.$lm)(Q.name):Q.name,Q))}async function u(K){const Q=await f(K),G=[];for(const ie of Q)await s.existsDirectory((0,A.$kc)(K,ie))&&G.push(ie);return G}function t(K,Q=1e3){return new Promise(G=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,P.access(K,z=>{ie=!1,z&&(clearInterval(V),G(void 0))}))},Q)})}var s;(function(K){async function Q(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(w.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw re}throw ee}}K.stat=Q;async function G(V){try{const{stat:z,symbolicLink:ee}=await K.stat(V);return z.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=G;async function ie(V){try{const{stat:z,symbolicLink:ee}=await K.stat(V);return z.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=ie})(s||(e.SymlinkSupport=s={}));const r=new L.$Nh;function i(K,Q,G){return r.queueFor(m.URI.file(K),()=>{const ie=R(G);return new Promise((V,z)=>l(K,Q,ie,ee=>ee?z(ee):V()))},S.$9g)}let n=!0;function o(K){n=K}function l(K,Q,G,ie){if(!n)return P.writeFile(K,Q,{mode:G.mode,flag:G.flag},ie);P.open(K,G.flag,G.mode,(V,z)=>{if(V)return ie(V);P.writeFile(z,Q,ee=>{if(ee)return P.close(z,()=>ie(ee));P.fdatasync(z,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),P.close(z,ce=>ie(ce))))})})}function y(K,Q,G){const ie=R(G);if(!n)return P.writeFileSync(K,Q,{mode:ie.mode,flag:ie.flag});const V=P.openSync(K,ie.flag,ie.mode);try{P.writeFileSync(V,Q);try{P.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{P.closeSync(V)}}function R(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function O(K,Q,G=6e4){if(K!==Q)try{w.$i&&typeof G=="number"?await E(K,Q,Date.now(),G):await P.promises.rename(K,Q)}catch(ie){if(K.toLowerCase()!==Q.toLowerCase()&&ie.code==="EXDEV"||K.endsWith("."))await v(K,Q,{preserveSymlinks:!1}),await $(K,h.MOVE);else throw ie}}async function E(K,Q,G,ie,V=0){try{return await P.promises.rename(K,Q)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-G>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let ee=!1;try{const{stat:re}=await s.stat(Q);re.isFile()||(ee=!0)}catch{}if(ee)throw z}return await(0,L.$Fh)(Math.min(100,V*10)),E(K,Q,G,ie,V+1)}}async function v(K,Q,G){return U(K,Q,{root:{source:K,target:Q},options:G,handledSourcePaths:new Set})}const T=511;async function U(K,Q,G){if(G.handledSourcePaths.has(K))return;G.handledSourcePaths.add(K);const{stat:ie,symbolicLink:V}=await s.stat(K);if(V){if(G.options.preserveSymlinks)try{return await X(K,Q,G)}catch{}if(V.dangling)return}return ie.isDirectory()?F(K,Q,ie.mode&T,G):M(K,Q,ie.mode&T)}async function F(K,Q,G,ie){await e.Promises.mkdir(Q,{recursive:!0,mode:G});const V=await f(K);for(const z of V)await U((0,A.$kc)(K,z),(0,A.$kc)(Q,z),ie)}async function M(K,Q,G){await e.Promises.copyFile(K,Q),await e.Promises.chmod(Q,G)}async function X(K,Q,G){let ie=await e.Promises.readlink(K);(0,C.$Dg)(ie,G.root.source,!w.$k)&&(ie=(0,A.$kc)(G.root.target,ie.substr(G.root.source.length+1))),await e.Promises.symlink(ie,Q)}e.Promises=new class{get access(){return P.promises.access}get stat(){return P.promises.stat}get lstat(){return P.promises.lstat}get utimes(){return P.promises.utimes}get read(){return(K,Q,G,ie,V)=>new Promise((z,ee)=>{P.read(K,Q,G,ie,V,(re,ce,q)=>re?ee(re):z({bytesRead:ce,buffer:q}))})}get readFile(){return P.promises.readFile}get write(){return(K,Q,G,ie,V)=>new Promise((z,ee)=>{P.write(K,Q,G,ie,V,(re,ce,q)=>re?ee(re):z({bytesWritten:ce,buffer:q}))})}get appendFile(){return P.promises.appendFile}get fdatasync(){return(0,N.promisify)(P.fdatasync)}get truncate(){return P.promises.truncate}get copyFile(){return P.promises.copyFile}get open(){return(0,N.promisify)(P.open)}get close(){return(0,N.promisify)(P.close)}get symlink(){return P.promises.symlink}get readlink(){return P.promises.readlink}get chmod(){return P.promises.chmod}get mkdir(){return P.promises.mkdir}get unlink(){return P.promises.unlink}get rmdir(){return P.promises.rmdir}get realpath(){return(0,N.promisify)(P.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return $}get rename(){return O}get copy(){return v}}}),define(le[154],he([0,1,46,14,5,27,31]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=k,e.$fr=A,e.$gr=w,e.$hr=S,P=ke(P);function k(h){if(N.$k)return h;const $=(0,a.$nc)(h);if(h===$)return h;const c=((0,a.$oc)(h)||h).toLowerCase();try{const b=(0,C.readdirSync)($).filter(f=>f.toLowerCase()===c);if(b.length===1){const f=k($);if(f)return(0,a.$kc)(f,b[0])}else if(b.length>1){const f=b.indexOf(c);if(f>=0){const p=k($);if(p)return(0,a.$kc)(p,b[f])}}}catch{}return null}async function A(h,$){if(N.$k)return h;const c=(0,a.$nc)(h);if(h===c)return h;const g=((0,a.$oc)(h)||h).toLowerCase();try{if($?.isCancellationRequested)return null;const f=(await C.Promises.readdir(c)).filter(p=>p.toLowerCase()===g);if(f.length===1){const p=await A(c,$);if(p)return(0,a.$kc)(p,f[0])}else if(f.length>1){const p=f.indexOf(g);if(p>=0){const I=await A(c,$);if(I)return(0,a.$kc)(I,f[p])}}}catch{}return null}async function w(h){try{return await C.Promises.realpath(h)}catch{const c=m(h);return await C.Promises.access(c,P.constants.R_OK),c}}function S(h){try{return P.realpathSync(h)}catch{const c=m(h);return P.accessSync(c,P.constants.R_OK),c}}function m(h){return(0,L.$nf)((0,a.$ic)(h),a.sep)}}),define(le[155],he([0,1,14,5,36,93,13,31]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=A,e.$xm=w,P=ke(P),a=ke(a),N=ke(N),C=ke(C),k=ke(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function A(m=N.env){return m.comspec||"cmd.exe"}function w(m){let h=[],$=!1;const c=function(g){if($){h.push(g);return}(!m.send(g,f=>{if(f&&console.error(f),$=!1,h.length>0){const p=h.slice(0);h=[],p.forEach(I=>c(I))}})||a.$i)&&($=!0)};return{send:c}}var S;(function(m){async function h($,c,g){if(P.$jc($))return $;if(c===void 0&&(c=N.cwd()),P.$nc($)!=="."||(g===void 0&&C.$eg(N.env.PATH)&&(g=N.env.PATH.split(P.$uc)),g===void 0||g.length===0))return P.$kc(c,$);async function f(p){if(await k.Promises.exists(p)){let I;try{I=await k.Promises.stat(p)}catch(d){d.message.startsWith("EACCES")&&(I=await k.Promises.lstat(p))}return I?!I.isDirectory():!1}return!1}for(const p of g){let I;if(P.$jc(p)?I=P.$kc(p,$):I=P.$kc(c,p,$),await f(I))return I;let d=I+".com";if(await f(d)||(d=I+".exe",await f(d)))return d}return P.$kc(c,$)}m.findExecutable=h})(S||(e.win32=S={}))}),define(le[156],he([0,1,69,23]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=N;function N(C){return new Promise((k,A)=>{let w;const S=new Map;function m($,c,g,b,f){const p=S.get(c);if($===C||p){const I={name:h(g),cmd:g,pid:$,ppid:c,load:b,mem:f};S.set($,I),$===C&&(w=I),p&&(p.children||(p.children=[]),p.children.push(I),p.children.length>1&&(p.children=p.children.sort((d,u)=>d.pid-u.pid)))}}function h($){const c=/--utility-sub-type=network/i,g=/--crashes-directory/i,b=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(g.exec($))return"electron-crash-reporter";if(b.exec($))return"winpty-agent";if(f.exec($))return"conpty-agent";let I=p.exec($);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?c.exec($)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const d=/[a-zA-Z-]+\.js/g;let u="";do I=d.exec($),I&&(u+=I+" ");while(I);return u&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${u})`:$}if(process.platform==="win32"){const $=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,g)=>{ne(["@vscode/windows-process-tree"],c,g)}).then(ke).then(c=>{c.getProcessList(C,g=>{if(!g){A(new Error(`Root process ${C} not found`));return}c.getProcessCpuUsage(g,b=>{const f=new Map;b.forEach(p=>{const I=$(p.commandLine||"");f.set(p.pid,{name:h(I),cmd:I,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=f.get(C),w?(f.forEach(p=>{const I=f.get(p.ppid);I&&(I.children||(I.children=[]),I.children.push(p))}),f.forEach(p=>{p.children&&(p.children=p.children.sort((I,d)=>I.pid-d.pid))}),k(w)):A(new Error(`Root process ${C} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let $=function(){let c=[w];const g=[];for(;c.length;){const f=c.shift();f&&(g.push(f.pid),f.children&&(c=c.concat(f.children)))}let b=JSON.stringify(a.$Yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+g.join(" "),(0,P.exec)(b,{},(f,p,I)=>{if(f||I)A(f||new Error(I.toString()));else{const d=p.toString().split(`
`);for(let u=0;u<g.length;u++){const t=S.get(g[u]);t.load=parseFloat(d[u])}if(!w){A(new Error(`Root process ${C} not found`));return}k(w)}})};(0,P.exec)("which ps",{},(c,g,b)=>{if(c||b)if(process.platform!=="linux")A(c||new Error(b.toString()));else{const f=JSON.stringify(a.$Yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(f,{},(p,I,d)=>{p||d?A(p||new Error(d.toString())):(L(I,m),$())})}else{const f=g.toString().trim();(0,P.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,d,u)=>{I||u&&!u.includes("screen size is bogus")?A(I||new Error(u.toString())):(L(d,m),process.platform==="linux"?$():w?k(w):A(new Error(`Root process ${C} not found`)))})}})}})}function L(C,k){const A=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=C.toString().split(`
`);for(const S of w){const m=A.exec(S.trim());m&&m.length===6&&k(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}});var ve=this&&this.__decorate||function(ne,e,P,a){var N=arguments.length,L=N<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,P):a,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ne,e,P,a);else for(var k=ne.length-1;k>=0;k--)(C=ne[k])&&(L=(N<3?C(L):N>3?C(e,P,L):C(e,P))||L);return N>3&&L&&Object.defineProperty(e,P,L),L};define(le[43],he([0,1,19,6,15,26,88,8,3,2,68,27,13]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=o,e.$fi=l,e.$ki=T,e.$li=U,m=ke(m);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function c(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var g;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(g||(g={}));function b(V){switch(V){case g.Initialize:return"init";case g.PromiseSuccess:return"reply:";case g.PromiseError:case g.PromiseErrorObj:return"replyErr:";case g.EventFire:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function p(V){let z=0;for(let ee=0;;ee+=7){const re=V.read(1);if(z|=(re.buffer[0]&127)<<ee,!(re.buffer[0]&128))return z}}const I=r(0);function d(V,z){if(z===0){V.write(I);return}let ee=0;for(let ce=z;ce!==0;ce=ce>>>7)ee++;const re=N.$Ne.alloc(ee);for(let ce=0;z!==0;ce++)re.buffer[ce]=z&127,z=z>>>7,z>0&&(re.buffer[ce]|=128);V.write(re)}class u{constructor(z){this.b=z,this.a=0}read(z){const ee=this.b.slice(this.a,this.a+z);return this.a+=ee.byteLength,ee}}e.$ci=u;class t{constructor(){this.a=[]}get buffer(){return N.$Ne.concat(this.a)}write(z){this.a.push(z)}}e.$di=t;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function r(V){const z=N.$Ne.alloc(1);return z.writeUInt8(V,0),z}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},n=typeof Buffer<"u";function o(V,z){if(typeof z>"u")V.write(i.Undefined);else if(typeof z=="string"){const ee=N.$Ne.fromString(z);V.write(i.String),d(V,ee.byteLength),V.write(ee)}else if(n&&Buffer.isBuffer(z)){const ee=N.$Ne.wrap(z);V.write(i.Buffer),d(V,ee.byteLength),V.write(ee)}else if(z instanceof N.$Ne)V.write(i.VSBuffer),d(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(i.Array),d(V,z.length);for(const ee of z)o(V,ee)}else if(typeof z=="number"&&(z|0)===z)V.write(i.Uint),d(V,z);else{const ee=N.$Ne.fromString(JSON.stringify(z));V.write(i.Object),d(V,ee.byteLength),V.write(ee)}}function l(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(p(V)).toString();case s.Buffer:return V.read(p(V)).buffer;case s.VSBuffer:return V.read(p(V));case s.Array:{const ee=p(V),re=[];for(let ce=0;ce<ee;ce++)re.push(l(V));return re}case s.Object:return JSON.parse(V.read(p(V)).toString());case s.Int:return p(V)}}class y{constructor(z,ee,re=null,ce=1e3){this.h=z,this.j=ee,this.k=re,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:g.Initialize})}registerChannel(z,ee){this.b.set(z,ee),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case g.Initialize:{const ee=this.o([z.type]);this.k?.logOutgoing(ee,0,R.OtherSide,b(z.type));return}case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:{const ee=this.o([z.type,z.id],z.data);this.k?.logOutgoing(ee,z.id,R.OtherSide,b(z.type),z.data);return}}}o(z,ee=void 0){const re=new t;return o(re,z),o(re,ee),this.p(re.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const ee=new u(z),re=l(ee),ce=l(ee),q=re[0];switch(q){case $.Promise:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}: ${re[2]}.${re[3]}`,ce),this.s({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case $.EventListen:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}: ${re[2]}.${re[3]}`,ce),this.t({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}`),this.u({type:q,id:re[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}`),this.u({type:q,id:re[1]})}}s(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const re=new L.$we;let ce;try{ce=ee.call(this.j,z.name,z.arg,re.token)}catch(J){ce=Promise.reject(J)}const q=z.id;ce.then(J=>{this.m({id:q,data:J,type:g.PromiseSuccess})},J=>{J instanceof Error?this.m({id:q,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split(`
`):void 0},type:g.PromiseError}):this.m({id:q,data:J,type:g.PromiseErrorObj})}).finally(()=>{x.dispose(),this.d.delete(z.id)});const x=(0,w.$Tc)(()=>re.cancel());this.d.set(z.id,x)}t(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const re=z.id,q=ee.listen(this.j,z.name,z.arg)(x=>this.m({id:re,data:x,type:g.EventFire}));this.d.set(z.id,q)}u(z){const ee=this.d.get(z.id);ee&&(ee.dispose(),this.d.delete(z.id))}v(z){let ee=this.g.get(z.channelName);ee||(ee=[],this.g.set(z.channelName,ee));const re=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:g.PromiseError})},this.l);ee.push({request:z,timeoutTimer:re})}w(z){const ee=this.g.get(z);if(ee){for(const re of ee)switch(clearTimeout(re.timeoutTimer),re.request.type){case $.Promise:this.s(re.request);break;case $.EventListen:this.t(re.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Qc)(this.d.values()),this.d.clear()}}e.$gi=y;var R;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class O{constructor(z,ee=null){this.l=z,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new A.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ee}getChannel(z){const ee=this;return{call(re,ce,q){return ee.a?Promise.reject(new k.$6):ee.m(z,re,ce,q)},listen(re,ce){return ee.a?A.Event.None:ee.o(z,re,ce)}}}m(z,ee,re,ce=L.CancellationToken.None){const q=this.g++,x=$.Promise,J={id:q,type:x,channelName:z,name:ee,arg:re};if(ce.isCancellationRequested)return Promise.reject(new k.$6);let H;return new Promise((B,j)=>{if(ce.isCancellationRequested)return j(new k.$6);const W=()=>{const ae=ue=>{switch(ue.type){case g.PromiseSuccess:this.f.delete(q),B(ue.data);break;case g.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,j(ge);break}case g.PromiseErrorObj:this.f.delete(q),j(ue.data);break}};this.f.set(q,ae),this.p(J)};let te=null;this.b===f.Idle?W():(te=(0,a.$rh)(ae=>this.u()),te.then(()=>{te=null,W()}));const _=()=>{te?(te.cancel(),te=null):this.p({id:q,type:$.PromiseCancel}),j(new k.$6)},Y=ce.onCancellationRequested(_);H=(0,w.$Sc)((0,w.$Tc)(_),Y),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(z,ee,re){const ce=this.g++,q=$.EventListen,x={id:ce,type:q,channelName:z,name:ee,arg:re};let J=null;const H=new A.$le({onWillAddFirstListener:()=>{J=(0,a.$rh)(B=>this.u()),J.then(()=>{J=null,this.d.add(H),this.p(x)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(H),this.p({id:ce,type:$.EventDispose}))}}),D=B=>H.fire(B.data);return this.f.set(ce,D),H.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const ee=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(ee,z.id,R.LocalSide,`${c(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const ee=this.q([z.type,z.id]);this.j?.logOutgoing(ee,z.id,R.LocalSide,c(z.type));return}}}q(z,ee=void 0){const re=new t;return o(re,z),o(re,ee),this.r(re.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const ee=new u(z),re=l(ee),ce=l(ee),q=re[0];switch(q){case g.Initialize:return this.j?.logIncoming(z.byteLength,0,R.LocalSide,b(q)),this.t({type:re[0]});case g.PromiseSuccess:case g.PromiseError:case g.EventFire:case g.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,re[1],R.LocalSide,b(q),ce),this.t({type:re[0],id:re[1],data:ce})}}t(z){if(z.type===g.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return A.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Qc)(this.d.values()),this.d.clear()}}e.$hi=O,ve([C.$9h],O.prototype,"onDidInitializePromise",null);class E{get connections(){const z=[];return this.f.forEach(ee=>z.push(ee)),z}constructor(z,ee,re){this.a=new Map,this.f=new Set,this.g=new A.$le,this.onDidAddConnection=this.g.event,this.h=new A.$le,this.onDidRemoveConnection=this.h.event,this.j=new w.$Uc,this.j.add(z(({protocol:ce,onDidClientDisconnect:q})=>{const x=A.Event.once(ce.onMessage);this.j.add(x(J=>{const H=new u(J),D=l(H),B=new y(ce,D,ee,re),j=new O(ce,ee);this.a.forEach((te,_)=>B.registerChannel(_,te));const W={channelServer:B,channelClient:j,ctx:D};this.f.add(W),this.g.fire(W),this.j.add(q(()=>{B.dispose(),j.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(z,ee){const re=this;return{call(ce,q,x){let J;if((0,h.$sg)(ee)){const D=(0,P.$4b)(re.connections.filter(ee));J=D?Promise.resolve(D):A.Event.toPromise(A.Event.filter(re.onDidAddConnection,ee))}else J=ee.routeCall(re,ce,q);const H=J.then(D=>D.channelClient.getChannel(z));return T(H).call(ce,q,x)},listen(ce,q){if((0,h.$sg)(ee))return re.k(z,ee,ce,q);const x=ee.routeEvent(re,ce,q).then(J=>J.channelClient.getChannel(z));return T(x).listen(ce,q)}}}k(z,ee,re,ce){const q=this;let x;const J=new A.$le({onWillAddFirstListener:()=>{x=new w.$Uc;const H=new A.$re,D=new Map,B=W=>{const _=W.channelClient.getChannel(z).listen(re,ce),Y=H.add(_);D.set(W,Y)},j=W=>{const te=D.get(W);te&&(te.dispose(),D.delete(W))};q.connections.filter(ee).forEach(B),A.Event.filter(q.onDidAddConnection,ee)(B,void 0,x),q.onDidRemoveConnection(j,void 0,x),H.event(J.fire,J,x),x.add(H)},onDidRemoveLastListener:()=>{x?.dispose(),x=void 0}});return J.event}registerChannel(z,ee){this.a.set(z,ee);for(const re of this.f)re.channelServer.registerChannel(z,ee)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=E;class v{constructor(z,ee,re=null){const ce=new t;o(ce,ee),z.send(ce.buffer),this.a=new O(z,re),this.d=new y(z,ee,re)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,ee){this.d.registerChannel(z,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=v;function T(V){return{call(z,ee,re){return V.then(ce=>ce.call(z,ee,re))},listen(z,ee){const re=new A.$ue;return V.then(ce=>re.input=ce.listen(z,ee)),re.event}}}function U(V){let z=!1;return{call(ee,re,ce){return z?V.call(ee,re,ce):(0,a.$Fh)(0).then(()=>z=!0).then(()=>V.call(ee,re,ce))},listen(ee,re){if(z)return V.listen(ee,re);const ce=new A.$ue;return(0,a.$Fh)(0).then(()=>z=!0).then(()=>ce.input=V.listen(ee,re)),ce.event}}}class F{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const ee of z.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await A.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$mi=F;var M;(function(V){function z(q,x,J){const H=q,D=J&&J.disableMarshalling,B=new Map;for(const j in H)re(j)&&B.set(j,A.Event.buffer(H[j],!0,void 0,x));return new class{listen(j,W,te){const _=B.get(W);if(_)return _;const Y=H[W];if(typeof Y=="function"){if(ce(W))return Y.call(H,te);if(re(W))return B.set(W,A.Event.buffer(H[W],!0,void 0,x)),B.get(W)}throw new k.$cb(`Event not found: ${W}`)}call(j,W,te){const _=H[W];if(typeof _=="function"){if(!D&&Array.isArray(te))for(let ae=0;ae<te.length;ae++)te[ae]=(0,S.$bi)(te[ae]);let Y=_.apply(H,te);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new k.$cb(`Method not found: ${W}`)}}}V.fromService=z;function ee(q,x){const J=x&&x.disableMarshalling;return new Proxy({},{get(H,D){if(typeof D=="string")return x?.properties?.has(D)?x.properties.get(D):ce(D)?function(B){return q.listen(D,B)}:re(D)?q.listen(D):async function(...B){let j;x&&!(0,h.$ng)(x.context)?j=[x.context,...B]:j=B;const W=await q.call(D,j);return J?W:(0,S.$bi)(W)};throw new k.$cb(`Property not found: ${String(D)}`)}})}V.toService=ee;function re(q){return q[0]==="o"&&q[1]==="n"&&m.$Ef(q.charCodeAt(2))}function ce(q){return/^onDynamic/.test(q)&&m.$Ef(q.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function Q(V){return Array.isArray(V)?V.map(K):K(V)}function G(V,z,ee,re,ce,q,x){x=Q(x);const J=X[ce],H=J[re%J.length];let D=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(q)?(D=D.concat(x),D.push(")")):D.push(x),console.log.apply(console,D)}class ie{constructor(z,ee){this.d=z,this.f=ee,this.a=0,this.b=0}logOutgoing(z,ee,re,ce,q){this.b+=z,G(this.d,this.b,z,ee,re,ce,q)}logIncoming(z,ee,re,ce,q){this.a+=z,G(this.f,this.a,z,ee,re,ce,q)}}e.$ni=ie}),define(le[70],he([0,1,15,3,2,43]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.ProtocolConstants=e.$oi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function l(R,O){if(!n.has(R)){const E=String(++o);n.set(R,E)}return n.get(R)}function y(R,O,E,v){if(!i.enableDiagnostics)return;const T=l(R,O);if(v instanceof P.$Ne||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=P.$Ne.alloc(v.byteLength);U.set(v),i.records.push({timestamp:Date.now(),id:T,label:O,type:E,buff:U})}else i.records.push({timestamp:Date.now(),id:T,label:O,type:E,data:v})}i.traceSocketEvent=y})(k||(e.SocketDiagnostics=k={}));var A;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(A||(e.SocketCloseEventType=A={}));let w=null;function S(){return w||(w=P.$Ne.alloc(0)),w}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return S();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const O=this.a[0];return o&&(this.a.shift(),this.b-=n),O}if(this.a[0].byteLength>n){const O=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),O}const l=P.$Ne.alloc(n);let y=0,R=0;for(;n>0;){const O=this.a[R];if(O.byteLength>n){const E=O.slice(0,n);l.set(E,y),y+=n,o&&(this.a[R]=O.slice(n),this.b-=n),n-=n}else l.set(O,y),y+=O.byteLength,o?(this.a.shift(),this.b-=O.byteLength):R++,n-=O.byteLength}return l}}e.$oi=m;var h;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(h||(h={}));function $(i){switch(i){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var c;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class g{constructor(n,o,l,y){this.type=n,this.id=o,this.ack=l,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends N.$Vc{constructor(n){super(),this.f=this.B(new a.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:c.HeaderLength,messageType:h.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new m,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent(C.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const l=this.g.messageType,y=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=c.HeaderLength,this.g.messageType=h.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(C.ProtocolMessageRead,o),this.f.fire(new g(l,y,R,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Ne.alloc(c.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(C.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(C.ProtocolMessageWrite,n.data),this.j(o,n.data)}g(n,o){const l=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,l}h(){const n=P.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(C.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class p extends N.$Vc{constructor(n){super(),this.f=new a.$le,this.onMessage=this.f.event,this.g=new a.$le,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(o=>{o.type===h.Regular&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new g(h.Regular,0,0,n))}}e.$pi=p;class I extends L.$ji{static fromSocket(n,o){return new I(new p(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,l=null){super(n,o,l),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$qi=I;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ri=d;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,l=this.a;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new u(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<s.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=s.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+s.a)*1e3;let l=0;for(let y=0;y<s.a;y++)n-this.c[y]<=o&&l++;return 1-l/s.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Uc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},c.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new g(h.Disconnect,0,0,S());this.p.write(n),this.p.flush()}sendPause(){const n=new g(h.Pause,0,0,S());this.p.write(n)}sendResume(){const n=new g(h.Resume,0,0,S());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new N.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new g(h.Ack,0,this.h,S());this.p.write(n);const o=this.b.toArray();for(let l=0,y=o.length;l<y;l++)this.p.write(o[l]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case h.None:break;case h.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new g(h.ReplayRequest,0,0,S())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case h.Control:{this.u.fire(n.data);break}case h.Ack:break;case h.Disconnect:{this.w.fire();break}case h.ReplayRequest:{const o=this.b.toArray();for(let l=0,y=o.length;l<y;l++)this.p.write(o[l]);this.B();break}case h.Pause:{this.p.pause();break}case h.Resume:{this.p.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const l=new g(h.Regular,o,this.h,n);this.b.push(l),this.a||(this.p.write(l),this.B())}sendControl(n){const o=new g(h.Control,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=c.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},c.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,l=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(o>=c.TimeoutTime&&l>=c.TimeoutTime&&y>=c.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:l});return}const R=Math.max(c.TimeoutTime-o,c.TimeoutTime-l,c.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new g(h.Ack,0,this.h,S());this.p.write(n)}D(){this.h=this.g;const n=new g(h.KeepAlive,0,this.h,S());this.p.write(n)}}e.$si=r}),define(le[96],he([0,1,69,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,k=ke(k);class c extends $.$gi{constructor(f){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:A.Event.fromNodeEventEmitter(process,"message",p=>N.$Ne.wrap(Buffer.from(p,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$ar=c;class g{constructor(f,p){this.i=f,this.j=p,this.c=new Set,this.g=new Map,this.h=new A.$le,this.onDidProcessExit=this.h.event;const I=p&&p.timeout?p.timeout:6e4;this.b=new a.$Bh(I),this.d=null,this.f=null}getChannel(f){const p=this;return{call(I,d,u){return p.k(f,I,d,u)},listen(I,d){return p.l(f,I,d)}}}k(f,p,I,d=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(k.$7());this.b.cancel();const u=this.n(f),t=(0,a.$rh)(i=>u.call(p,I,i)),s=d.onCancellationRequested(()=>t.cancel()),r=(0,w.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{s.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,p,I){if(!this.b)return A.Event.None;this.b.cancel();let d;const u=new A.$le({onWillAddFirstListener:()=>{d=this.n(f).listen(p,I)(u.fire,u),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,S.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$km)(p.env),this.d=(0,P.fork)(this.i,f,p);const I=new A.$le,u=A.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.$9q)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}I.fire(N.$Ne.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,m.$xm)(this.d):this.d,s=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),r=I.event,i={send:s,onMessage:r};this.f=new $.$hi(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",n),u.dispose(),this.c.forEach(y=>(0,w.$Qc)(y)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(f){let p=this.g.get(f);return p||(p=this.m.getChannel(f),this.g.set(f,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=g}),define(le[157],he([0,1,140,15,43,3,13,19]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lX=void 0,e.$mX=S;class A{constructor(h){this.a=h,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?a.$Ne.wrap($.data):a.$Ne.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}class w extends N.$ii{static b(h){(0,C.$og)((0,P.$kX)(process),"Electron Utility Process");const $=new L.$le;return process.parentPort.on("message",c=>{if(h?.handledClientConnection(c))return;const g=(0,k.$Pb)(c.ports);g&&$.fire(g)}),L.Event.map($.event,c=>({protocol:new A(c),onDidClientDisconnect:L.Event.fromNodeEventEmitter(c,"close")}))}constructor(h){super(w.b(h))}}e.$lX=w;function S(m,h,$){const c=g=>{g.data===h&&(m.removeListener("message",c),$())};m.on("message",c)}}),define(le[71],he([0,1,6,3,2,68,13]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=A;var k;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function A(h){const $=h;return $?.changed instanceof Map||$?.deleted instanceof Set}var w;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(w||(e.StorageState=w={}));class S extends N.$Vc{static{this.a=100}constructor($,c=Object.create(null)){super(),this.r=$,this.s=c,this.b=this.B(new a.$oe),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new P.$Ch(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((c,g)=>this.w(g,c)),$.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w($,c){if(this.c===w.Closed)return;let g=!1;(0,C.$ng)(c)?g=this.f.delete($):this.f.get($)!==c&&(this.f.set($,c),g=!0),g&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,c){const g=this.f.get($);return(0,C.$ng)(g)?c:g}getBoolean($,c){const g=this.get($);return(0,C.$ng)(g)?c:g==="true"}getNumber($,c){const g=this.get($);return(0,C.$ng)(g)?c:parseInt(g,10)}getObject($,c){const g=this.get($);return(0,C.$ng)(g)?c:(0,L.$ai)(g)}async set($,c,g=!1){if(this.c===w.Closed)return;if((0,C.$ng)(c))return this.delete($,g);const b=(0,C.$gg)(c)||Array.isArray(c)?(0,L.$_h)(c):String(c);if(this.f.get($)!==b)return this.f.set($,b),this.j.set($,b),this.h.delete($),this.b.fire({key:$,external:g}),this.D()}async delete($,c=!1){if(!(this.c===w.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:c}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===w.Closed||this.m))return this.D($)}async D($){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$0p=S;class m{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((c,g)=>this.a.set(g,c)),$.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$$p=m}),define(le[158],he([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[72],he([0,1,46,6,14,13,31,158]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0,e.zip=b,e.$wq=f,e.$xq=I,N=ke(N),k=ke(k),e.$tq="end of central directory record signature not found";const A=new RegExp(e.$tq);class w extends Error{constructor(u,t){let s=t.message;switch(u){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=u,this.cause=t}}e.$uq=w;function S(d){const u=d.externalFileAttributes>>16||33188;return[448,56,7].map(t=>u&t).reduce((t,s)=>t+s,u&61440)}function m(d){if(d instanceof w)return d;let u;return A.test(d.message)&&(u="CorruptZip"),new w(u,d)}function h(d,u,t,s,r,i){const n=N.$nc(u),o=N.$kc(s,n);if(!o.startsWith(s))return Promise.reject(new Error(k.localize(0,null,u)));const l=N.$kc(s,u);let y;return i.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(C.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,O)=>{if(!i.isCancellationRequested)try{y=(0,P.createWriteStream)(l,{mode:t}),y.once("close",()=>R()),y.once("error",O),d.once("error",O),d.pipe(y)}catch(E){O(E)}}))}function $(d,u,t,s){let r=(0,a.$rh)(()=>Promise.resolve()),i=0;const n=s.onCancellationRequested(()=>{r.cancel(),d.close()});return new Promise((o,l)=>{const y=new a.$zh,R=O=>{O.isCancellationRequested||(i++,d.readEntry())};d.once("error",l),d.once("close",()=>r.then(()=>{s.isCancellationRequested||d.entryCount===i?o():l(new w("Incomplete",new Error(k.localize(1,null,i,d.entryCount))))},l)),d.readEntry(),d.on("entry",O=>{if(s.isCancellationRequested)return;if(!t.sourcePathRegex.test(O.fileName)){R(s);return}const E=O.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(E)){const U=N.$kc(u,E);r=(0,a.$rh)(F=>C.Promises.mkdir(U,{recursive:!0}).then(()=>R(F)).then(void 0,l));return}const v=g(d,O),T=S(O);r=(0,a.$rh)(U=>y.queue(()=>v.then(F=>h(F,E,T,u,t,U).then(()=>R(U)))).then(null,l))})}).finally(()=>n.dispose())}async function c(d,u=!1){const{open:t}=await new Promise((s,r)=>{ne(["yauzl"],s,r)}).then(ke);return new Promise((s,r)=>{t(d,u?{lazyEntries:!0}:void 0,(i,n)=>{i?r(m(i)):s((0,L.$pg)(n))})})}function g(d,u){return new Promise((t,s)=>{d.openReadStream(u,(r,i)=>{r?s(m(r)):t((0,L.$pg)(i))})})}async function b(d,u){const{ZipFile:t}=await new Promise((s,r)=>{ne(["yazl"],s,r)}).then(ke);return new Promise((s,r)=>{const i=new t;u.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const n=(0,P.createWriteStream)(d);i.outputStream.pipe(n),i.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>s(d))})}function f(d,u,t={},s){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=c(d,!0);return t.overwrite&&(i=i.then(n=>C.Promises.rm(u).then(()=>n))),i.then(n=>$(n,u,{sourcePathRegex:r},s))}function p(d,u){return c(d).then(t=>new Promise((s,r)=>{t.on("entry",i=>{i.fileName===u&&g(t,i).then(n=>s(n),n=>r(n))}),t.once("close",()=>r(new Error(k.localize(2,null,u))))}))}function I(d,u){return p(d,u).then(t=>new Promise((s,r)=>{const i=[];t.once("error",r),t.on("data",n=>i.push(n)),t.on("end",()=>s(Buffer.concat(i)))}))}}),define(le[159],he([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[160],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[161],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[162],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[163],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[164],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[165],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[166],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[167],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[168],he([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[169],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[170],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[171],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[172],he([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[173],he([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[174],he([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(le[175],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[176],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[177],he([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[178],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[179],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[180],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[181],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[182],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[183],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[184],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[185],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[186],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[187],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[188],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[189],he([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[190],he([0,1,39,8,161]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function C(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const k=(0,N.localize)(3,null),A=(0,N.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return m.isTripleEq?"===":"==";case L.NotEq:return m.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return m.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return m.lexeme;case L.QuotedStr:return m.lexeme;case L.Error:return m.lexeme;case L.EOF:return"EOF";default:throw(0,a.$9)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(L.LParen);break;case P.CharCode.CloseParen:this.k(L.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const h=this.h(P.CharCode.Equals);this.f.push({type:L.NotEq,offset:this.d,isTripleEq:h})}else this.k(L.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const h=this.h(P.CharCode.Equals);this.f.push({type:L.Eq,offset:this.d,isTripleEq:h})}else this.h(P.CharCode.Tilde)?this.k(L.RegexOp):this.l(C("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?L.LtEq:L.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?L.GtEq:L.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(L.And):this.l(C("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(L.Or):this.l(C("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(L.EOF),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const h=this.d,$=this.c.substring(this.d,this.e),c={type:L.Error,offset:this.d,lexeme:$};this.g.push({offset:h,lexeme:$,additionalInfo:m}),this.f.push(c)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const h=this.c.substring(this.d,this.e),$=w.b.get(h);$?this.k($):this.f.push({type:L.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:L.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,h=!1,$=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(A);return}const g=this.c.charCodeAt(m);if(h)h=!1;else if(g===P.CharCode.Slash&&!$){m++;break}else g===P.CharCode.OpenSquareBracket?$=!0:g===P.CharCode.Backslash?h=!0:g===P.CharCode.CloseSquareBracket&&($=!1);m++}for(;m<this.c.length&&w.a.has(this.c.charCodeAt(m));)m++;this.e=m;const c=this.c.substring(this.d,this.e);this.f.push({type:L.RegexStr,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=w}),define(le[191],he([0,1,67,88,23,14,36,21,9]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$5m=S,e.$6m=m,e.$3m=/^([^.]+\..+)[:=](.+)$/;class w{get appRoot(){return(0,L.$nc)(N.$Yg.asFileUri("").fsPath)}get userHome(){return A.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return A.URI.file((0,L.$kc)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.b.tmpDir)}get cacheHome(){return A.URI.file(this.userDataPath)}get stateResource(){return(0,k.$fh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$fh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,P.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$kc)(this.userDataPath,"logs",$)}return A.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$fh)(A.URI.file((0,L.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$fh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$fh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$fh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=C.env.VSCODE_PORTABLE;return $?A.URI.file((0,L.$kc)($,"argv.json")):(0,k.$fh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,L.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,L.$lc)($):(0,L.$ic)((0,L.$kc)(N.$Yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?A.URI.file((0,L.$lc)($)):A.URI.file((0,L.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,L.$lc)($);const c=C.env.VSCODE_EXTENSIONS;if(c)return c;const g=C.env.VSCODE_PORTABLE;return g?(0,L.$kc)(g,"extensions"):(0,k.$fh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(c=>/^[^:/?#]+?:\/\//.test(c)?A.URI.parse(c):A.URI.file((0,L.$ic)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?A.URI.parse($):A.URI.file((0,L.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$3m.test($))}get extensionLogLevel(){const $=[];for(const c of this.args.log||[]){const g=e.$3m.exec(c);g&&g[1]&&g[2]&&$.push([g[1],g[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,k.$fh)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=C.env.VSCODE_PORTABLE;return $?A.URI.file((0,L.$kc)($,"policy.json")):(0,k.$fh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,c,g){this.a=$,this.b=c,this.c=g,this.editSessionId=this.args.editSessionId}}e.$4m=w,ve([a.$9h],w.prototype,"appRoot",null),ve([a.$9h],w.prototype,"userHome",null),ve([a.$9h],w.prototype,"userDataPath",null),ve([a.$9h],w.prototype,"appSettingsHome",null),ve([a.$9h],w.prototype,"tmpDir",null),ve([a.$9h],w.prototype,"cacheHome",null),ve([a.$9h],w.prototype,"stateResource",null),ve([a.$9h],w.prototype,"userRoamingDataHome",null),ve([a.$9h],w.prototype,"userDataSyncHome",null),ve([a.$9h],w.prototype,"sync",null),ve([a.$9h],w.prototype,"machineSettingsResource",null),ve([a.$9h],w.prototype,"workspaceStorageHome",null),ve([a.$9h],w.prototype,"localHistoryHome",null),ve([a.$9h],w.prototype,"keyboardLayoutResource",null),ve([a.$9h],w.prototype,"argvResource",null),ve([a.$9h],w.prototype,"isExtensionDevelopment",null),ve([a.$9h],w.prototype,"untitledWorkspacesHome",null),ve([a.$9h],w.prototype,"builtinExtensionsPath",null),ve([a.$9h],w.prototype,"extensionsPath",null),ve([a.$9h],w.prototype,"extensionDevelopmentLocationURI",null),ve([a.$9h],w.prototype,"extensionDevelopmentKind",null),ve([a.$9h],w.prototype,"extensionTestsLocationURI",null),ve([a.$9h],w.prototype,"debugExtensionHost",null),ve([a.$9h],w.prototype,"logLevel",null),ve([a.$9h],w.prototype,"extensionLogLevel",null),ve([a.$9h],w.prototype,"serviceMachineIdResource",null),ve([a.$9h],w.prototype,"disableTelemetry",null),ve([a.$9h],w.prototype,"disableWorkspaceTrust",null),ve([a.$9h],w.prototype,"useInMemorySecretStorage",null),ve([a.$9h],w.prototype,"policyFile",null);function S(h,$){return m(h["inspect-extensions"],h["inspect-brk-extensions"],5870,$,h.debugId,h.extensionEnvironment)}function m(h,$,c,g,b,f){const I=Number($||h)||(g?null:c),d=I?!!$:!1;let u;if(f)try{u=JSON.parse(f)}catch{}return{port:I,break:d,debugId:b,env:u}}}),function(){"use strict";function ne(e,P,a){function N(C,k){const A=L(C,k),w=[A];return e.isAbsolute(A)||w.unshift(a),e.resolve(...w)}function L(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const A=process.env.VSCODE_PORTABLE;if(A)return e.join(A,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,k);const S=C["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(m,"AppData","Roaming")}break;case"darwin":w=e.join(P.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,k)}return{getUserDataPath:N}}if(typeof define=="function")define(le[192],he([279,38,36]),function(e,P,a){return ne(e,P,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ne(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[193],he([0,1,38,191,192]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$8m=C,e.$9m=k;class L extends a.$4m{constructor(w,S){super(w,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,N.getUserDataPath)(w,S.nameShort)},S)}}e.$7m=L;function C(A,w){return(0,a.$6m)(A["inspect-ptyhost"],A["inspect-brk-ptyhost"],5877,w,A.extensionEnvironment)}function k(A,w){return(0,a.$6m)(A["inspect-sharedprocess"],A["inspect-brk-sharedprocess"],5879,w,A.extensionEnvironment)}}),define(le[194],he([0,1,13,164]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=N;function N(C,k,A,w){try{L(C,k,A,w)}catch(S){C.error(S?.message??S)}return k}function L(C,k,A,w){const S=(m,h,$)=>{const c=m[h];if((0,P.$eg)(c)){const g=c,b=g.length;if(b>1&&g[0]==="%"&&g[b-1]==="%"){const f=g.substr(1,b-2);let p=A[f];p===void 0&&w&&(p=w[f]);const I=typeof p=="string"?p:p?.message,d=w?.[f],u=typeof d=="string"?d:d?.message;if(!I){u||C.warn(`[${k.name}]: ${(0,a.localize)(0,null,f)}`);return}if($&&(h==="title"||h==="category")&&u&&u!==I){const t={value:I,original:u};m[h]=t}else m[h]=I}}else if((0,P.$gg)(c))for(const g in c)c.hasOwnProperty(g)&&(g==="commands"?S(c,g,!0):S(c,g,$));else if(Array.isArray(c))for(let g=0;g<c.length;g++)S(c,g,$)};for(const m in k)k.hasOwnProperty(m)&&S(k,m)}}),define(le[195],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=e.$xgc=void 0;class P{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$xgc=P;class a{constructor(L){this.a=L}listen(L,C){throw new Error(`Event not found: ${C}`)}call(L,C,k){switch(C){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${C}`)}}e.$ygc=a});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[73],he([0,1,21,92,168,57]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=A,e.$Up=w,e.$Vp=S,e.$Wp=m,e.$Xp=h,e.$Yp=$,e.$Zp=c,a=it(a),N=ke(N),L=ke(L);const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||C.test(f)}function w(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}function S(f){if(!f)return null;const p=f.majorBase,I=f.majorMustEqual,d=f.minorBase;let u=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(p===0||(u=!1),s=!1);let r=0;if(f.preRelease){const i=k.exec(f.preRelease);if(i){const[,n,o,l]=i;r=Date.UTC(Number(n),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:I,minorBase:d,minorMustEqual:u,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:r}}function m(f,p,I){let d;typeof f=="string"?d=S(w(f)):d=f;let u;p instanceof Date?u=p.getTime():typeof p=="string"&&(u=new Date(p).getTime());let t;if(typeof I=="string"?t=S(w(I)):t=I,!d||!t)return!1;const s=d.majorBase,r=d.minorBase,i=d.patchBase;let n=t.majorBase,o=t.minorBase,l=t.patchBase;const y=t.notBefore;let R=t.majorMustEqual,O=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:r>o?!0:r<o||u&&u<y?!1:i>=l:(s===1&&n===0&&(!R||!O||!E)&&(n=1,o=0,l=0,R=!0,O=!1,E=!1),s<n?!1:s>n?!R:r<o?!1:r>o?!O:i<l?!1:i>l?!E:!(u&&u<y))}function h(f,p,I,d,u){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([a.default.Error,N.localize(0,null)]),t;if(typeof d.name!="string")return t.push([a.default.Error,N.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([a.default.Error,N.localize(2,null,"version")]),t;if(!d.engines)return t.push([a.default.Error,N.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([a.default.Error,N.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!b(d.extensionDependencies))return t.push([a.default.Error,N.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!b(d.activationEvents))return t.push([a.default.Error,N.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([a.default.Error,N.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([a.default.Warning,N.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([a.default.Error,N.localize(9,null,"main")]),t;{const i=(0,P.$fh)(I,d.main);(0,P.$_g)(i,I)||t.push([a.default.Warning,N.localize(10,null,i.path,I.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([a.default.Error,N.localize(11,null,"browser")]),t;{const i=(0,P.$fh)(I,d.browser);(0,P.$_g)(i,I)||t.push([a.default.Warning,N.localize(12,null,i.path,I.path)])}}if(!L.valid(d.version))return t.push([a.default.Error,N.localize(13,null)]),t;const s=[];if(!$(f,p,d,u,s))for(const i of s)t.push([a.default.Error,i]);return t}function $(f,p,I,d,u){return d||typeof I.main>"u"&&typeof I.browser>"u"?!0:g(f,p,I.engines.vscode,u)}function c(f,p,I){return f==="*"||g(p,I,f)}function g(f,p,I,d=[]){const u=S(w(I));if(!u)return d.push(N.localize(14,null,I)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return d.push(N.localize(15,null,I)),!1}else if(!u.majorMustEqual)return d.push(N.localize(16,null,I)),!1;return m(f,p,u)?!0:(d.push(N.localize(17,null,f,I)),!1)}function b(f){if(!Array.isArray(f))return!1;for(let p=0,I=f.length;p<I;p++)if(typeof f[p]!="string")return!1;return!0}}),define(le[74],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class P{constructor(N,L=[],C=!1){this.ctor=N,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.$Bi=P}),define(le[196],he([0,1,74]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=L,e.$Ls=C;const a=[];var N;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function L(k,A,w){A instanceof P.$Bi||(A=new P.$Bi(A,[],!!w)),a.push([k,A])}function C(){return a}}),define(le[197],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class P{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$nr=P;class a{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const k=this.lookupOrInsertNode(L),A=this.lookupOrInsertNode(C);k.outgoing.set(A.key,A),A.incoming.set(k.key,k)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let k=this.a.get(C);return k||(k=new P(C,L),this.a.set(C,k)),k}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,k]of this.a)L.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const k=new Set([L]),A=this.c(C,k);if(A)return A}}c(L,C){for(const[k,A]of L.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const w=this.c(A,C);if(w)return w;C.delete(k)}}}e.$or=a}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=N,e.$Fi=L;var P;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(A){return A[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(P||(e._util=P={})),e.$Di=N("instantiationService");function a(C,k,A){k[P.DI_TARGET]===k?k[P.DI_DEPENDENCIES].push({id:C,index:A}):(k[P.DI_DEPENDENCIES]=[{id:C,index:A}],k[P.DI_TARGET]=k)}function N(C){if(P.serviceIds.has(C))return P.serviceIds.get(C);const k=function(A,w,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(k,A,S)};return k.toString=()=>C,P.serviceIds.set(C,k),k}function L(C){return C}}),define(le[198],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0,e.$0fc=(0,P.$Ei)("checksumService")}),define(le[22],he([0,1,13,9,4]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=L,e.$aj=C,e.$bj=A,e.$cj=w,e.$dj=S,e.$ej=m,e.$fj=h,e.$gj=c,e.$hj=g,e.$ij=b,P=ke(P),e.$$i=(0,N.$Ei)("configurationService");function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof a.URI)}function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof a.URI)}var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function A(f){switch(f){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function w(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function S(f,p){const I=Object.create(null);for(const d in f)m(I,d,f[d],p);return I}function m(f,p,I,d){const u=p.split("."),t=u.pop();let s=f;for(let r=0;r<u.length;r++){const i=u[r];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":if(n===null){d(`Ignoring ${p} as ${u.slice(0,r+1).join(".")} is null`);return}break;default:d(`Ignoring ${p} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=I}catch{d(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(s)}`)}else d(`Ignoring ${p} as ${u.join(".")} is ${JSON.stringify(s)}`)}function h(f,p){const I=p.split(".");$(f,I)}function $(f,p){const I=p.shift();if(p.length===0){delete f[I];return}if(Object.keys(f).indexOf(I)!==-1){const d=f[I];typeof d=="object"&&!Array.isArray(d)&&($(d,p),Object.keys(d).length===0&&delete f[I])}}function c(f,p,I){function d(s,r){let i=s;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=p.split("."),t=d(f,u);return typeof t>"u"?I:t}function g(f,p,I){Object.keys(p).forEach(d=>{d!=="__proto__"&&(d in f?P.$gg(f[d])&&P.$gg(p[d])?g(f[d],p[d],I):I&&(f[d]=p[d]):f[d]=p[d])})}function b(f){return f.replace(/[\[\]]/g,"")}}),define(le[97],he([0,1,39,5,27,190,4,160,8]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=S,e.$Dj=r,e.$Ej=i,e.$Xj=q;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",a.$j),w.set("isLinux",a.$k),w.set("isWindows",a.$i),w.set("isWeb",a.$o),w.set("isMacNative",a.$j&&!a.$o),w.set("isEdge",a.$H),w.set("isFirefox",a.$F),w.set("isChrome",a.$E),w.set("isSafari",a.$G);function S(H,D){if(w.get(H)!==void 0)throw(0,A.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(H,D)}const m=Object.prototype.hasOwnProperty;var h;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const $={regexParsingWithErrorRecovery:!0},c=(0,k.localize)(0,null),g=(0,k.localize)(1,null),b=(0,k.localize)(2,null),f=(0,k.localize)(3,null),p=(0,k.localize)(4,null),I=(0,k.localize)(5,null),d=(0,k.localize)(6,null),u=(0,k.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=$){this.k=D,this.d=new L.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const B=this.l();if(!this.E()){const j=this.D(),W=j.type===L.TokenType.Str?I:void 0;throw this.h.push({message:p,offset:j.offset,lexeme:L.$zj.getLexeme(j),additionalInfo:W}),t.c}return B}catch(B){if(B!==t.c)throw B;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(L.TokenType.Or);){const B=this.o();D.push(B)}return D.length===1?D[0]:s.or(...D)}o(){const D=[this.s()];for(;this.y(L.TokenType.And);){const B=this.s();D.push(B)}return D.length===1?D[0]:s.and(...D)}s(){if(this.y(L.TokenType.Neg)){const D=this.D();switch(D.type){case L.TokenType.True:return this.z(),o.INSTANCE;case L.TokenType.False:return this.z(),l.INSTANCE;case L.TokenType.LParen:{this.z();const B=this.l();return this.A(L.TokenType.RParen,f),B?.negate()}case L.TokenType.Str:return this.z(),T.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case L.TokenType.True:return this.z(),s.true();case L.TokenType.False:return this.z(),s.false();case L.TokenType.LParen:{this.z();const B=this.l();return this.A(L.TokenType.RParen,f),B}case L.TokenType.Str:{const B=D.lexeme;if(this.z(),this.y(L.TokenType.RegexOp)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==L.TokenType.RegexStr)throw this.B("REGEX",W);const te=W.lexeme,_=te.lastIndexOf("/"),Y=_===te.length-1?void 0:this.w(te.substring(_+1));let ae;try{ae=new RegExp(te.substring(1,_),Y)}catch{throw this.B("REGEX",W)}return Q.create(B,ae)}switch(W.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const te=[W.lexeme];this.z();let _=this.D(),Y=0;for(let Ee=0;Ee<W.lexeme.length;Ee++)W.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Y++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Y--;for(;!this.E()&&_.type!==L.TokenType.And&&_.type!==L.TokenType.Or;){switch(_.type){case L.TokenType.LParen:Y++;break;case L.TokenType.RParen:Y--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let Ee=0;Ee<_.lexeme.length;Ee++)_.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Y++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Y--}if(Y<0)break;te.push(L.$zj.getLexeme(_)),this.z(),_=this.D()}const ae=te.join(""),ue=ae.lastIndexOf("/"),ge=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let we;try{we=new RegExp(ae.substring(1,ue),ge)}catch{throw this.B("REGEX",W)}return s.regex(B,we)}case L.TokenType.QuotedStr:{const te=W.lexeme;this.z();let _=null;if(!(0,N.$cf)(te)){const Y=te.indexOf("/"),ae=te.lastIndexOf("/");if(Y!==ae&&Y>=0){const ue=te.slice(Y+1,ae),ge=te[ae+1]==="i"?"i":"";try{_=new RegExp(ue,ge)}catch{throw this.B("REGEX",W)}}}if(_===null)throw this.B("REGEX",W);return Q.create(B,_)}default:throw this.B("REGEX",this.D())}}if(this.y(L.TokenType.Not)){this.A(L.TokenType.In,b);const W=this.u();return s.notIn(B,W)}switch(this.D().type){case L.TokenType.Eq:{this.z();const W=this.u();if(this.x().type===L.TokenType.QuotedStr)return s.equals(B,W);switch(W){case"true":return s.has(B);case"false":return s.not(B);default:return s.equals(B,W)}}case L.TokenType.NotEq:{this.z();const W=this.u();if(this.x().type===L.TokenType.QuotedStr)return s.notEquals(B,W);switch(W){case"true":return s.not(B);case"false":return s.has(B);default:return s.notEquals(B,W)}}case L.TokenType.Lt:return this.z(),X.create(B,this.u());case L.TokenType.LtEq:return this.z(),K.create(B,this.u());case L.TokenType.Gt:return this.z(),F.create(B,this.u());case L.TokenType.GtEq:return this.z(),M.create(B,this.u());case L.TokenType.In:return this.z(),s.in(B,this.u());default:return s.has(B)}}case L.TokenType.EOF:throw this.h.push({message:d,offset:D.offset,lexeme:"",additionalInfo:u}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this.z(),D.lexeme;case L.TokenType.True:return this.z(),"true";case L.TokenType.False:return this.z(),"false";case L.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,B){if(this.C(D))return this.z();throw this.B(B,this.D())}B(D,B,j){const W=(0,k.localize)(8,null,D,L.$zj.getLexeme(B)),te=B.offset,_=L.$zj.getLexeme(B);return this.h.push({message:W,offset:te,lexeme:_,additionalInfo:j}),t.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===L.TokenType.EOF}}e.$Bj=t;class s{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(D){return y.create(D)}static equals(D,B){return R.create(D,B)}static notEquals(D,B){return v.create(D,B)}static regex(D,B){return Q.create(D,B)}static in(D,B){return O.create(D,B)}static notIn(D,B){return E.create(D,B)}static not(D){return T.create(D)}static and(...D){return V.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,B){return F.create(D,B)}static greaterEquals(D,B){return M.create(D,B)}static smaller(D,B){return X.create(D,B)}static smallerEquals(D,B){return K.create(D,B)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Cj=s;function r(H){const D=new t({regexParsingWithErrorRecovery:!1});return H.map(B=>(D.parse(B),D.lexingErrors.length>0?D.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,k.localize)(9,null,j.additionalInfo):(0,k.localize)(10,null),offset:j.offset,length:j.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function i(H,D){const B=H?H.substituteConstants():void 0,j=D?D.substituteConstants():void 0;return!B&&!j?!0:!B||!j?!1:B.equals(j)}function n(H,D){return H.cmp(D)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return l.INSTANCE}}e.$Fj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=h.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Gj=l;class y{static create(D,B=null){const j=w.get(D);return typeof j=="boolean"?j?l.INSTANCE:o.INSTANCE:new y(D,B)}constructor(D,B){this.key=D,this.c=B,this.type=h.Defined}cmp(D){return D.type!==this.type?this.type-D.type:re(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=w.get(this.key);return typeof D=="boolean"?D?l.INSTANCE:o.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$Hj=y;class R{static create(D,B,j=null){if(typeof B=="boolean")return B?y.create(D,j):T.create(D,j);const W=w.get(D);return typeof W=="boolean"?B===(W?"true":"false")?l.INSTANCE:o.INSTANCE:new R(D,B,j)}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=w.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?l.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ij=R;class O{static create(D,B){return new O(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.f),j=D.getValue(this.d);return Array.isArray(B)?B.includes(j):typeof j=="string"&&typeof B=="object"&&B!==null?m.call(B,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Jj=O;class E{static create(D,B){return new E(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.NotIn,this.c=O.create(D,B)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=E;class v{static create(D,B,j=null){if(typeof B=="boolean")return B?T.create(D,j):y.create(D,j);const W=w.get(D);return typeof W=="boolean"?B===(W?"true":"false")?o.INSTANCE:l.INSTANCE:new v(D,B,j)}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=w.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?o.INSTANCE:l.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Lj=v;class T{static create(D,B=null){const j=w.get(D);return typeof j=="boolean"?j?o.INSTANCE:l.INSTANCE:new T(D,B)}constructor(D,B){this.c=D,this.d=B,this.type=h.Not}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=w.get(this.c);return typeof D=="boolean"?D?o.INSTANCE:l.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Mj=T;function U(H,D){if(typeof H=="string"){const B=parseFloat(H);isNaN(B)||(H=B)}return typeof H=="string"||typeof H=="number"?D(H):o.INSTANCE}class F{static create(D,B,j=null){return U(B,W=>new F(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Nj=F;class M{static create(D,B,j=null){return U(B,W=>new M(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Oj=M;class X{static create(D,B,j=null){return U(B,W=>new X(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Pj=X;class K{static create(D,B,j=null){return U(B,W=>new K(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Qj=K;class Q{static create(D,B){return new Q(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const B=this.f?this.f.source:"",j=D.f?D.f.source:"";return B<j?-1:B>j?1:0}equals(D){if(D.type===this.type){const B=this.f?this.f.source:"",j=D.f?D.f.source:"";return this.d===D.d&&B===j}return!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Rj=Q;class G{static create(D){return new G(D)}constructor(D){this.c=D,this.type=h.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new G(this.c.map(D))}negate(){return this.c}}e.$Sj=G;function ie(H){let D=null;for(let B=0,j=H.length;B<j;B++){const W=H[B].substituteConstants();if(H[B]!==W&&D===null){D=[];for(let te=0;te<B;te++)D[te]=H[te]}D!==null&&(D[B]=W)}return D===null?H:D}class V{static create(D,B,j){return V.d(D,B,j)}constructor(D,B){this.expr=D,this.c=B,this.type=h.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const W=n(this.expr[B],D.expr[B]);if(W!==0)return W}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:V.create(D,this.c,!1)}evaluate(D){for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].evaluate(D))return!1;return!0}static d(D,B,j){const W=[];let te=!1;for(const _ of D)if(_){if(_.type===h.True){te=!0;continue}if(_.type===h.False)return o.INSTANCE;if(_.type===h.And){W.push(..._.expr);continue}W.push(_)}if(W.length===0&&te)return l.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(n);for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];for(;W.length>1;){const _=W[W.length-1];if(_.type!==h.Or)break;W.pop();const Y=W.pop(),ae=W.length===0,ue=z.create(_.expr.map(ge=>V.create([ge,Y],null,j)),null,ae);ue&&(W.push(ue),W.sort(n))}if(W.length===1)return W[0];if(j){for(let _=0;_<W.length;_++)for(let Y=_+1;Y<W.length;Y++)if(W[_].negate().equals(W[Y]))return o.INSTANCE;if(W.length===1)return W[0]}return new V(W,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new V(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Tj=V;class z{static create(D,B,j){return z.d(D,B,j)}constructor(D,B){this.expr=D,this.c=B,this.type=h.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const W=n(this.expr[B],D.expr[B]);if(W!==0)return W}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let B=0,j=this.expr.length;B<j;B++)if(this.expr[B].evaluate(D))return!0;return!1}static d(D,B,j){let W=[],te=!1;if(D){for(let _=0,Y=D.length;_<Y;_++){const ae=D[_];if(ae){if(ae.type===h.False){te=!0;continue}if(ae.type===h.True)return l.INSTANCE;if(ae.type===h.Or){W=W.concat(ae.expr);continue}W.push(ae)}}if(W.length===0&&te)return o.INSTANCE;W.sort(n)}if(W.length!==0){if(W.length===1)return W[0];for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];if(j){for(let _=0;_<W.length;_++)for(let Y=_+1;Y<W.length;Y++)if(W[_].negate().equals(W[Y]))return l.INSTANCE;if(W.length===1)return W[0]}return new z(W,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new z(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());for(;D.length>1;){const B=D.shift(),j=D.shift(),W=[];for(const te of J(B))for(const _ of J(j))W.push(V.create([te,_],null,!1));D.unshift(z.create(W,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Uj=z;class ee extends y{static{this.d=[]}static all(){return ee.d.values()}constructor(D,B,j){super(D,null),this.f=B,typeof j=="object"?ee.d.push({...j,key:D}):j!==!0&&ee.d.push({key:D,description:j,type:B!=null?typeof B:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return R.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Vj=ee,e.$Wj=(0,C.$Ei)("contextKeyService");function re(H,D){return H<D?-1:H>D?1:0}function ce(H,D,B,j){return H<B?-1:H>B?1:D<j?-1:D>j?1:0}function q(H,D){if(H.type===h.False||D.type===h.True)return!0;if(H.type===h.Or)return D.type===h.Or?x(H.expr,D.expr):!1;if(D.type===h.Or){for(const B of D.expr)if(q(H,B))return!0;return!1}if(H.type===h.And){if(D.type===h.And)return x(D.expr,H.expr);for(const B of H.expr)if(q(B,D))return!0;return!1}return H.equals(D)}function x(H,D){let B=0,j=0;for(;B<H.length&&j<D.length;){const W=H[B].cmp(D[j]);if(W<0)return!1;W===0&&B++,j++}return B===H.length}function J(H){return H.type===h.Or?H.expr:[H]}}),define(le[98],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Rm=e.ID=void 0,e.$Sm=a,e.ID="diagnosticsService",e.$Rm=(0,P.$Ei)(e.ID);function a(L){return!!L.hostName&&!!L.errorMessage}class N{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$Tm=N}),define(le[99],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=void 0,e.$Wo=(0,P.$Ei)("downloadService")}),define(le[16],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,P.$Ei)("environmentService"),e.$Mi=(0,P.$Fi)(e.$Li)}),define(le[75],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$z5b=N;var a;(function(C){C[C.FILE=1]="FILE",C[C.WORKSPACE=2]="WORKSPACE",C[C.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function N(C){switch(C){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var L;(function(C){C.Ignored="ignored",C.Cancelled="cancelled",C.TooMany="toomany",C.IncompatibleWindow="incompatibleWindow",C.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$A5b=(0,P.$Ei)("IExtensionRecommendationNotificationService")}),define(le[7],he([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=h,e.$al=b,e.$bl=p,e.$cl=I,e.$dl=d,e.$el=u,e.$fl=t,e.$gl=s,e.$hl=r,e.$il=i,e.$jl=n,e.$ll=y,e.$ml=R,e.$nl=O,e.$ol=E,e.$pl=v,e.$sl=X,e.$El=z,e.$Fl=ee,e.$Hl=ce,e.$$k=(0,A.$Ei)("fileService");function h(q){return q.create===!0}var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var c;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function b(q){const x=q;return!!x&&typeof x.onDidChange=="function"}var f;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function p(q){return!!(q.capabilities&f.FileReadWrite)}function I(q){return!!(q.capabilities&f.FileFolderCopy)}function d(q){return!!(q.capabilities&f.FileClone)}function u(q){return!!(q.capabilities&f.FileOpenReadWriteClose)}function t(q){return!!(q.capabilities&f.FileReadStream)}function s(q){return p(q)?!!(q.capabilities&f.FileAtomicRead):!1}function r(q){return p(q)?!!(q.capabilities&f.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&f.FileAtomicDelete)}function n(q){return!!(q.capabilities&f.Readonly)}var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class l extends Error{static create(x,J){const H=new l(x.toString(),J);return O(H,J),H}constructor(x,J){super(x),this.code=J}}e.$kl=l;function y(q,x){return l.create(q,x)}function R(q){return q||y((0,k.localize)(0,null),o.Unknown)}function O(q,x){return q.name=x?`${x} (FileSystemError)`:"FileSystemError",q}function E(q){if(!q)return o.Unknown;if(q instanceof l)return q.code;const x=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!x)return o.Unknown;switch(x[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function v(q){if(q instanceof K)return q.fileOperationResult;switch(E(q)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var T;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class U{constructor(x,J,H){this.resource=x,this.operation=J,this.target=H}isOperation(x){return this.operation===x}}e.$ql=U;var F;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(x,J){this.c=J,this.b=void 0,this.d=new m.$W(()=>{const H=P.$Ki.forUris(()=>this.c);return H.fill(this.rawAdded.map(D=>[D,!0])),H}),this.f=new m.$W(()=>{const H=P.$Ki.forUris(()=>this.c);return H.fill(this.rawUpdated.map(D=>[D,!0])),H}),this.g=new m.$W(()=>{const H=P.$Ki.forUris(()=>this.c);return H.fill(this.rawDeleted.map(D=>[D,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of x){switch(H.type){case F.ADDED:this.rawAdded.push(H.resource);break;case F.UPDATED:this.rawUpdated.push(H.resource);break;case F.DELETED:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(x,...J){return this.h(x,{includeChildren:!1},...J)}affects(x,...J){return this.h(x,{includeChildren:!0},...J)}h(x,J,...H){if(!x)return!1;const D=H.length>0;return!!((!D||H.includes(F.ADDED))&&(this.d.value.get(x)||J.includeChildren&&this.d.value.findSuperstr(x))||(!D||H.includes(F.UPDATED))&&(this.f.value.get(x)||J.includeChildren&&this.f.value.findSuperstr(x))||(!D||H.includes(F.DELETED))&&(this.g.value.findSubstr(x)||J.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$rl=M;function X(q,x,J){return!q||!x||q===x||x.length>q.length?!1:(x.charAt(x.length-1)!==a.sep&&(x+=a.sep),J?(0,N.$Gf)(q,x):q.indexOf(x)===0)}class K extends Error{constructor(x,J,H){super(x),this.fileOperationResult=J,this.options=H}}e.$tl=K;class Q extends K{constructor(x,J,H,D){super(x,J,D),this.fileOperationResult=J,this.size=H}}e.$ul=Q;class G extends K{constructor(x,J,H){super(x,ie.FILE_NOT_MODIFIED_SINCE,H),this.stat=J}}e.$vl=G;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Dl="";function z(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function ee(q,x){if(!x.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(J=>{const H=x.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===q.scheme&&D.added&&(H.dispose(),J())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(x){return(0,L.$ig)(x)||(x=0),x<re.KB?(0,k.localize)(1,null,x.toFixed(0)):x<re.MB?(0,k.localize)(2,null,(x/re.KB).toFixed(2)):x<re.GB?(0,k.localize)(3,null,(x/re.MB).toFixed(2)):x<re.TB?(0,k.localize)(4,null,(x/re.GB).toFixed(2)):(0,k.localize)(5,null,(x/re.TB).toFixed(2))}}e.$Gl=re;function ce(q){const x=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*re.MB:x?10*re.MB:w.$o?50*re.MB:1024*re.MB}});var Z=this&&this.__param||function(ne,e){return function(P,a){e(P,a,ne)}};define(le[199],he([0,1,76,51,7]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;let L=class{constructor(k){this.a=k}async checksum(k){const A=(await this.a.readFileStream(k)).value;return new Promise((w,S)=>{const m=(0,P.createHash)("sha256");(0,a.$Fe)(A,{onData:h=>m.update(h.buffer),onError:h=>S(h),onEnd:()=>w(m.digest("base64").replace(/=+$/,""))})})}};e.$$fc=L,e.$$fc=L=ve([Z(0,N.$$k)],L)}),define(le[100],he([0,1,15,8,171,7]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=C;async function C(S,m,h,$,c,g){let b;try{await k(S,m,h,$,c,g)}catch(f){b=f}finally{b&&c.errorTransformer&&(b=c.errorTransformer(b)),typeof b<"u"&&h.error(b),h.end()}}async function k(S,m,h,$,c,g){A(g);const b=await S.open(m,{create:!1});try{A(g);let f=0,p=0,I=c&&typeof c.length=="number"?c.length:void 0,d=P.$Ne.alloc(Math.min(c.bufferSize,typeof I=="number"?I:c.bufferSize)),u=c&&typeof c.position=="number"?c.position:0,t=0;do p=await S.read(b,u,d.buffer,t,d.byteLength-t),u+=p,t+=p,f+=p,typeof I=="number"&&(I-=p),t===d.byteLength&&(await h.write($(d)),d=P.$Ne.alloc(Math.min(c.bufferSize,typeof I=="number"?I:c.bufferSize)),t=0);while(p>0&&(typeof I!="number"||I>0)&&A(g)&&w(f,c));if(t>0){let s=t;typeof I=="number"&&(s=Math.min(t,I)),h.write($(d.slice(0,s)))}}catch(f){throw(0,L.$ml)(f)}finally{await S.close(b)}}function A(S){if(S.isCancellationRequested)throw(0,a.$7)();return!0}function w(S,m){if(typeof m?.limits?.size=="number"&&S>m.limits.size)throw(0,L.$ll)((0,N.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[47],he([0,1,94,2,14,5,9,7]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=A,e.$Xq=w,e.$2q=$,e.$3q=c,e.$4q=g,e.$5q=b,e.$6q=p,e.$7q=I;function A(d){return typeof d.correlationId=="number"}function w(d){return d.recursive===!0}class S extends a.$Vc{static{this.a=5}constructor(u,t,s,r){super(),this.h=u,this.j=t,this.m=s,this.n=r,this.c=this.B(new a.$Wc),this.f=void 0,this.g=0}s(){const u=new a.$Uc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(t=>this.h(t))),u.add(this.b.onDidLogMessage(t=>this.j(t))),u.add(this.b.onDidError(t=>this.t(t.error,t.request)))}t(u,t){this.u(u,t)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${u}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${u}`):this.y(u)}u(u,t){return!(!this.n.restartOnError||t||u.indexOf("No space left on device")!==-1||u.indexOf("EMFILE")!==-1)}w(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}y(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}z(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=S;class m extends S{constructor(u,t,s){super(u,t,s,{type:"node.js",restartOnError:!1})}}e.$Zq=m;class h extends S{constructor(u,t,s){super(u,t,s,{type:"universal",restartOnError:!0})}}e.$1q=h;function $(d){return d.map(u=>({type:u.type,resource:C.URI.revive(u.resource),cId:u.cId}))}function c(d){const u=new f;for(const t of d)u.processEvent(t);return u.coalesce()}function g(d,u){return typeof u=="string"&&!u.startsWith(P.$uk)&&!(0,N.$jc)(u)?{base:d,pattern:u}:u}function b(d,u){const t=[];for(const s of u)t.push((0,P.$yk)(g(d,s)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(u){return L.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const t=this.b.get(this.c(u));let s=!1;if(t){const r=t.type,i=u.type;t.resource.fsPath!==u.resource.fsPath&&(u.type===k.FileChangeType.DELETED||u.type===k.FileChangeType.ADDED)?s=!0:r===k.FileChangeType.ADDED&&i===k.FileChangeType.DELETED?(this.b.delete(this.c(u)),this.a.delete(t)):r===k.FileChangeType.DELETED&&i===k.FileChangeType.ADDED?t.type=k.FileChangeType.UPDATED:r===k.FileChangeType.ADDED&&i===k.FileChangeType.UPDATED||(t.type=i)}else s=!0;s&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],t=[];return Array.from(this.a).filter(s=>s.type!==k.FileChangeType.DELETED?(u.push(s),!1):!0).sort((s,r)=>s.resource.fsPath.length-r.resource.fsPath.length).filter(s=>t.some(r=>(0,k.$sl)(s.resource.fsPath,r,!L.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(u)}}function p(d,u){if(typeof u=="number")switch(d.type){case k.FileChangeType.ADDED:return(u&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(u&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(u&k.FileChangeFilter.UPDATED)===0}return!1}function I(d){if(typeof d=="number"){const u=[];return d&k.FileChangeFilter.ADDED&&u.push("Added"),d&k.FileChangeFilter.DELETED&&u.push("Deleted"),d&k.FileChangeFilter.UPDATED&&u.push("Updated"),u.length===0?"<all>":`[${u.join(", ")}]`}return"<none>"}}),define(le[200],he([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,P,a,N,L,C,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=void 0,e.$CQ="localFilesystem";class m extends C.$Vc{constructor($,c){super(),this.a=$,this.b=c,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$le),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$le),this.onDidWatchError=this.g.event,this.h=(0,A.$1g)(),this.j()}get capabilities(){return this.c||(this.c=w.FileSystemProviderCapabilities.FileReadWrite|w.FileSystemProviderCapabilities.FileOpenReadWriteClose|w.FileSystemProviderCapabilities.FileReadStream|w.FileSystemProviderCapabilities.FileFolderCopy|w.FileSystemProviderCapabilities.FileWriteUnlock|w.FileSystemProviderCapabilities.FileAtomicRead|w.FileSystemProviderCapabilities.FileAtomicWrite|w.FileSystemProviderCapabilities.FileAtomicDelete|w.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=w.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=w.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,c){const{buffer:g}=await this.a.call("readFile",[$,c]);return g}readFileStream($,c,g){const b=(0,k.$Be)(p=>P.$Ne.concat(p.map(I=>P.$Ne.wrap(I))).buffer),f=new C.$Uc;return f.add(this.a.listen("readFileStream",[$,c])(p=>{if(p instanceof P.$Ne)b.write(p.buffer);else{if(p==="end")b.end();else{let I;if(p instanceof Error)I=p;else{const d=p;I=(0,w.$ll)(d.message??(0,a.$pj)(d),d.code??w.FileSystemProviderErrorCode.Unknown)}b.error(I),b.end()}f.dispose()}})),f.add(g.onCancellationRequested(()=>{b.error((0,N.$7)()),b.end(),f.dispose()})),b}writeFile($,c,g){return this.a.call("writeFile",[$,P.$Ne.wrap(c),g])}open($,c){return this.a.call("open",[$,c])}close($){return this.a.call("close",[$])}async read($,c,g,b,f){const[p,I]=await this.a.call("read",[$,c,f]);return g.set(p.buffer.slice(0,I),b),I}write($,c,g,b,f){return this.a.call("write",[$,c,P.$Ne.wrap(g),b,f])}mkdir($){return this.a.call("mkdir",[$])}delete($,c){return this.a.call("delete",[$,c])}rename($,c,g){return this.a.call("rename",[$,c,g])}copy($,c,g){return this.a.call("copy",[$,c,g])}cloneFile($,c){return this.a.call("cloneFile",[$,c])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const c=$;this.f.fire((0,S.$2q)(c))}else{const c=$;this.g.fire(c)}}))}watch($,c){const g=(0,A.$1g)();return this.a.call("watch",[this.h,g,$,c]),(0,C.$Tc)(()=>this.a.call("unwatch",[this.h,g]))}}e.$DQ=m}),define(le[201],he([0,1,46,2,47,3,7,9,6]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class w extends a.$Vc{constructor(){super(),this.a=this.B(new L.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new L.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$5c),this.m=new Set,this.n=this.B(new A.$Ch(this.y())),this.r=5007,this.s=new A.$2h,this.R=!1,this.B(this.f(m=>this.t(m)))}t(m){this.u(m)&&this.z(m)}u(m){return(0,N.$Wq)(m)}async watch(m){this.s.isSettled||this.s.complete(),this.s=new A.$2h;try{this.h.clear(),this.g.clear();for(const h of m)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(m){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),m?this.y():0)}y(){return 800}isSuspended(m){return typeof m.correlationId!="number"?!1:this.m.has(m.correlationId)?"polling":this.j.has(m.correlationId)}async z(m){if(this.j.has(m.correlationId))return;const h=new a.$Uc;this.j.set(m.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(m,h),this.w(!0))}C(m){this.j.deleteAndDispose(m.correlationId),this.m.delete(m.correlationId),this.w(!1)}D(m,h){this.F(m,h)?(this.P(`reusing an existing recursive watcher to monitor ${m.path}`),this.m.delete(m.correlationId)):(this.G(m,h),this.m.add(m.correlationId))}F(m,h){const $=this.O?.subscribe(m.path,(c,g)=>{h.isDisposed||(c?this.D(m,h):g?.type===C.FileChangeType.ADDED&&this.H(m))});return $?(h.add($),!0):!1}G(m,h){let $=!1;const c=(g,b)=>{if(h.isDisposed)return;const f=this.I(g),p=this.I(b),I=$;$=f,!f&&(p||I)&&this.H(m)};this.P(`starting fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.watchFile)(m.path,{persistent:!1,interval:this.r},c)}catch(g){this.Q(`fs.watchFile() failed with error ${g} on path ${m.path} (correlationId: ${m.correlationId})`)}h.add((0,a.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${m.path} (correlationId: ${m.correlationId})`);try{(0,P.unwatchFile)(m.path,c)}catch(g){this.Q(`fs.unwatchFile() failed with error ${g} on path ${m.path} (correlationId: ${m.correlationId})`)}}))}H(m){this.P(`detected ${m.path} exists again, resuming watcher (correlationId: ${m.correlationId})`);const h={resource:k.URI.file(m.path),type:C.FileChangeType.ADDED,cId:m.correlationId};this.a.fire([h]),this.J(h,m),this.C(m)}I(m){return m.ctimeMs===0&&m.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(m,h){if(this.R){const $=` >> normalized ${m.type===C.FileChangeType.ADDED?"[ADDED]":m.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`;this.L($,h)}}L(m,h){this.R&&this.P(`${m}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(m){return`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, filter: ${(0,N.$7q)(m.filter)}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`}async setVerboseLogging(m){this.R=m}}e.$dr=w}),define(le[202],he([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=f;class b extends C.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(I,d,u,t,s,r){super(),this.s=I,this.t=d,this.u=u,this.w=t,this.y=s,this.z=r,this.c=this.B(new a.$Th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new a.$Sh(i=>this.M(i),b.b)),this.g=(0,g.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,g.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,g.$Wq)(this.s)?this.s.filter:void 0,this.m=new N.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const I=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const d=await $.Promises.stat(I);if(this.m.token.isCancellationRequested)return;this.B(await this.G(I,d.isDirectory()))}catch(I){I.code!=="ENOENT"?this.O(I):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${I})`),this.D()}}D(){this.r=!0,this.w?.()}async F(I){let d=I.path;try{d=await $.Promises.realpath(I.path),I.path===d&&(d=await(0,h.$fr)(I.path,this.m.token)??I.path),I.path!==d&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${d})`)}catch{}return d}async G(I,d){const u=new C.$Uc;return this.H(I,d,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(I,d,u)),u}H(I,d,u){if(d)return!1;const t=m.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(r,i)=>{if(!u.isDisposed)if(r){const n=await this.G(I,d);u.isDisposed?n.dispose():u.add(n)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:i.type,cId:this.s.correlationId},!0)});return s?(u.add(s),!0):!1}async I(I,d,u){if(w.$j&&(0,L.$Dg)(I,"/Volumes/",!0)){this.O(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new N.$we(this.m.token);u.add((0,C.$Tc)(()=>t.dispose(!0)));const s=new C.$Uc;u.add(s);try{const r=m.URI.file(this.s.path),i=(0,A.$oc)(I),n=(0,P.watch)(I);s.add((0,C.$Tc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${I}'`);const o=new Set;if(d)try{for(const y of await $.Promises.readdir(I))o.add(y)}catch(y){this.O(y)}if(t.token.isCancellationRequested)return;const l=new Map;s.add((0,C.$Tc)(()=>{for(const[,y]of l)y.dispose();l.clear()})),n.on("error",(y,R)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${I} for changes using fs.watch() (${y}, ${R})`),this.D())}),n.on("change",(y,R)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${R}`);let O="";if(R&&(O=R.toString(),w.$j&&(O=(0,k.$lm)(O))),!(!O||y!=="change"&&y!=="rename"))if(d)if(y==="rename"){l.get(O)?.dispose();const E=setTimeout(async()=>{if(l.delete(O),O===i&&!await $.Promises.exists(I)){this.J(r);return}if(t.token.isCancellationRequested)return;const v=await this.N((0,A.$kc)(I,O));if(t.token.isCancellationRequested)return;let T;v?o.has(O)?T=c.FileChangeType.UPDATED:(T=c.FileChangeType.ADDED,o.add(O)):(o.delete(O),T=c.FileChangeType.DELETED),this.L({resource:(0,S.$fh)(r,O),type:T,cId:this.s.correlationId})},b.a);l.set(O,(0,C.$Tc)(()=>clearTimeout(E)))}else{let E;o.has(O)?E=c.FileChangeType.UPDATED:(E=c.FileChangeType.ADDED,o.add(O)),this.L({resource:(0,S.$fh)(r,O),type:E,cId:this.s.correlationId})}else if(y==="rename"||O!==i){const E=setTimeout(async()=>{const v=await $.Promises.exists(I);t.token.isCancellationRequested||(v?(this.L({resource:r,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(I,!1))):this.J(r))},b.a);s.clear(),s.add((0,C.$Tc)(()=>clearTimeout(E)))}else this.L({resource:r,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(r){t.token.isCancellationRequested||this.O(`Failed to watch ${I} for changes using fs.watch() (${r.toString()})`),this.D()}}J(I){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:I,type:c.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(I,d=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${I.type===c.FileChangeType.ADDED?"[ADDED]":I.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!d&&this.g.some(u=>u(I.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${I.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(u=>u(I.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${I.resource.fsPath}`):this.f.work(I))}M(I){const d=(0,g.$3q)(I),u=[];for(const s of d){if((0,g.$6q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}u.push(s)}if(u.length===0)return;if(this.z)for(const s of u)this.R(` >> normalized ${s.type===c.FileChangeType.ADDED?"[ADDED]":s.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(I){if(w.$k)return $.Promises.exists(I);try{const d=(0,A.$oc)(I);return(await $.Promises.readdir((0,A.$nc)(I))).some(t=>t===d)}catch(d){return this.Q(d),!1}}setVerboseLogging(I){this.z=I}O(I){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}P(I){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}Q(I){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}R(I){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${I}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=b;async function f(p,I,d,u,t=512){const s=await $.Promises.open(p,"r"),r=Buffer.allocUnsafe(t),i=new N.$we(u);let n,o=!1;const l={path:p,excludes:[],recursive:!1},y=new b(l,void 0,R=>{(async()=>{for(const{type:O}of R)if(O===c.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:E}=await $.Promises.read(s,r,0,t,null);if(!E||i.token.isCancellationRequested)break;I(r.slice(0,E))}}catch(E){n=new Error(E),i.dispose(!0)}finally{o=!1}}})()});return await y.ready,d(),new Promise((R,O)=>{i.token.onCancellationRequested(async()=>{y.dispose();try{await $.Promises.close(s)}catch(E){n=new Error(E)}n?O(n):R()})})}}),define(le[203],he([0,1,3,94,201,5,202,42]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class A extends N.$dr{constructor(S){super(),this.O=S,this.onDidError=P.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const m=[],h=new Set(Array.from(this.watchers));for(const $ of S){const c=this.W($);c&&(0,a.$Ck)(c.request.excludes,$.excludes)&&(0,a.$Ck)(c.request.includes,$.includes)?h.delete(c):m.push($)}m.length&&this.P(`Request to start watching: ${m.map($=>this.M($)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map($=>this.M($.request)).join(",")}`);for(const $ of h)this.Y($);for(const $ of m)this.X($)}W(S){for(const m of this.watchers)if(typeof S.correlationId=="number"||typeof m.request.correlationId=="number"){if(m.request.correlationId===S.correlationId)return m}else if((0,k.$Cg)(m.request.path,S.path,!L.$k))return m}X(S){const m=new C.$ir(S,this.O,$=>this.a.fire($),()=>this.c.fire(S),$=>this.b.fire($),this.R),h={request:S,instance:m};this.watchers.add(h)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const m=new Map;for(const h of S){const $=L.$k?h.path:h.path.toLowerCase();let c=m.get(h.correlationId);c||(c=new Map,m.set(h.correlationId,c)),c.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),c.set($,h)}return Array.from(m.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const m of this.watchers)m.instance.setVerboseLogging(S)}P(S,m){this.R&&this.b.fire({type:"trace",message:this.bb(S,m)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,m){return m?`[File Watcher (node.js)] ${S} (${this.M(m.request)})`:`[File Watcher (node.js)] ${S}`}}e.$kr=A}),define(le[204],he([0,1,47,203]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class N extends P.$Zq{constructor(C,k,A){super(C,k,A),this.s()}r(C){return C.add(new a.$kr(void 0))}}e.$lr=N}),define(le[205],he([0,1,23,43,96,47]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class C extends L.$1q{constructor(A,w,S){super(A,w,S),this.s()}r(A){const w=A.add(new N.$br(P.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return A.add(w.onDidProcessExit(({code:S,signal:m})=>this.t(`terminated by itself with code ${S}, signal: ${m} (ETERM)`))),a.ProxyChannel.toService((0,a.$li)(w.getChannel("watcher")))}}e.$cr=C}),define(le[77],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class P{constructor(...N){this.a=new Map;for(const[L,C]of N)this.set(L,C)}set(N,L){const C=this.a.get(N);return this.a.set(N,L),C}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Ci=P}),define(le[206],he([0,1,6,8,2,74,197,4,77,90]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const S=!1;class m extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class h{constructor(b=new A.$Ci,f=!1,p,I=S){this.i=b,this.j=f,this.k=p,this.l=I,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Di,this),this._globalGraph=I?p?._globalGraph??new C.$or(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Qc)(this.h),this.h.clear();for(const b of this.g)(0,N.$Pc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,f){this.m();const p=this,I=new class extends h{dispose(){p.h.delete(I),super.dispose()}}(b,this.j,this,this.l);return this.h.add(I),f?.add(I),I}invokeFunction(b,...f){this.m();const p=c.traceInvocation(this.l,b);let I=!1;try{return b({get:u=>{if(I)throw(0,a.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(u,p);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...f)}finally{I=!0,p.stop()}}createInstance(b,...f){this.m();let p,I;return b instanceof L.$Bi?(p=c.traceCreation(this.l,b.ctor),I=this.o(b.ctor,b.staticArguments.concat(f),p)):(p=c.traceCreation(this.l,b),I=this.o(b,f,p)),p.stop(),I}o(b,f=[],p){const I=k._util.getServiceDependencies(b).sort((t,s)=>t.index-s.index),d=[];for(const t of I){const s=this.s(t.id,p);s||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(s)}const u=I.length>0?I[0].index:f.length;if(f.length!==u){console.trace(`[createInstance] First service dependency of ${b.name} at position ${u+1} conflicts with ${f.length} static arguments`);const t=u-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,u)}return Reflect.construct(b,f.concat(d))}q(b,f){if(this.i.get(b)instanceof L.$Bi)this.i.set(b,f);else if(this.k)this.k.q(b,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const f=this.i.get(b);return!f&&this.k?this.k.r(b):f}s(b,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.r(b);return p instanceof L.$Bi?this.u(b,p,f.branch(b,!0)):(f.branch(b,!1),p)}u(b,f,p){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,f,p)}finally{this.t.delete(b)}}v(b,f,p){const I=new C.$or(t=>t.id.toString());let d=0;const u=[{id:b,desc:f,_trace:p}];for(;u.length;){const t=u.pop();if(I.lookupOrInsertNode(t),d++>1e3)throw new m(I);for(const s of k._util.getServiceDependencies(t.desc.ctor)){const r=this.r(s.id);if(r||this.y(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof L.$Bi){const i={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};I.insertEdge(t,i),u.push(i)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new m(I);break}for(const{data:s}of t){if(this.r(s.id)instanceof L.$Bi){const i=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,i)}I.removeNode(s)}}return this.r(b)}w(b,f,p=[],I,d){if(this.i.get(b)instanceof L.$Bi)return this.x(b,f,p,I,d,this.g);if(this.k)return this.k.w(b,f,p,I,d);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(b,f,p=[],I,d,u){if(I){const t=new h(void 0,this.j,this,this.l);t.c=String(b);const s=new Map,r=new P.$Xh(()=>{const i=t.o(f,p,d);for(const[n,o]of s){const l=i[n];if(typeof l=="function")for(const y of o)y.disposable=l.apply(i,y.listener)}return s.clear(),u.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let y=s.get(n);return y||(y=new w.$6c,s.set(n,y)),(O,E,v)=>{if(r.isInitialized)return r.value[n](O,E,v);{const T={listener:[O,E,v],disposable:void 0},U=y.push(T);return(0,N.$Tc)(()=>{U(),T.disposable?.dispose()})}}}if(n in i)return i[n];const o=r.value;let l=o[n];return typeof l!="function"||(l=l.bind(o),i[n]=l),l},set(i,n,o){return r.value[n]=o,!0},getPrototypeOf(i){return f.prototype}})}else{const t=this.o(f,p,d);return u.add(t),t}}y(b,f){if(f&&console.warn(b),this.j)throw new Error(b)}}e.$pr=h;var $;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})($||($={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,f){return b?new c($.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(b,f){return b?new c($.Creation,f.name):c.c}static{this.f=0}constructor(b,f){this.type=b,this.name=f,this.g=Date.now(),this.h=[]}branch(b,f){const p=new c($.Branch,b.toString());return this.h.push([b,f,p]),p}stop(){const b=Date.now()-this.g;c.f+=b;let f=!1;function p(d,u){const t=[],s=new Array(d+1).join("	");for(const[r,i,n]of u.h)if(i&&n){f=!0,t.push(`${s}CREATES -> ${r}`);const o=p(d+1,n);o&&t.push(o)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const I=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(b>2||f)&&c.all.add(I.join(`
`))}}e.$qr=c}),define(le[58],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=void 0,e.$Nfc=(0,P.$Ei)("mainProcessService");class a{constructor(L,C){this.a=L,this.b=C}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,C){this.a.registerChannel(L,C)}}e.$Ofc=a}),define(le[10],he([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=g,e.log=f,e.$mk=l,e.$nk=y,e.$ok=R,e.$pk=O,P=ke(P),e.$$j=(0,$.$Ei)("logService"),e.$_j=(0,$.$Ei)("loggerService");function c(){return new Date().toISOString()}function g(E){return(0,S.$ig)(E)}var b;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$bk=b.Info;function f(E,v,T){switch(v){case b.Trace:E.trace(T);break;case b.Debug:E.debug(T);break;case b.Info:E.info(T);break;case b.Warning:E.warn(T);break;case b.Error:E.error(T);break;case b.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function p(E,v=!1){let T="";for(let U=0;U<E.length;U++){let F=E[U];if(F instanceof Error&&(F=(0,a.$pj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}T+=(U>0?" ":"")+F}return T}class I extends C.$Vc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new N.$le),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==b.Off&&this.b<=v}}e.$dk=I;class d extends I{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...T){this.f(b.Trace)&&this.g(b.Trace,p([v,...T],!0))}debug(v,...T){this.f(b.Debug)&&this.g(b.Debug,p([v,...T]))}info(v,...T){this.f(b.Info)&&this.g(b.Info,p([v,...T]))}warn(v,...T){this.f(b.Warning)&&this.g(b.Warning,p([v,...T]))}error(v,...T){if(this.f(b.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(b.Error,p(U))}else this.g(b.Error,p([v,...T]))}flush(){}}e.$ek=d;class u extends I{constructor(v=e.$bk){super(),this.setLevel(v),this.g=!A.$i}trace(v,...T){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,v,...T):console.log(`[main ${c()}]`,v,...T))}debug(v,...T){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,v,...T):console.log(`[main ${c()}]`,v,...T))}info(v,...T){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,v,...T):console.log(`[main ${c()}]`,v,...T))}warn(v,...T){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,v,...T):console.warn(`[main ${c()}]`,v,...T))}error(v,...T){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,v,...T):console.error(`[main ${c()}]`,v,...T))}flush(){}}e.$fk=u;class t extends I{constructor(v=e.$bk,T=!0){super(),this.g=T,this.setLevel(v)}trace(v,...T){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...T):console.log(v,...T))}debug(v,...T){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...T):console.log(v,...T))}info(v,...T){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...T):console.log(v,...T))}warn(v,...T){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...T):console.log(v,...T))}error(v,...T){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...T):console.error(v,...T))}flush(){}}e.$gk=t;class s extends I{constructor(v,T=e.$bk){super(),this.g=v,this.setLevel(T)}trace(v,...T){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(v),...T])}debug(v,...T){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(v),...T])}info(v,...T){this.f(b.Info)&&this.g.log(b.Info,[this.h(v),...T])}warn(v,...T){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(v),...T])}error(v,...T){this.f(b.Error)&&this.g.log(b.Error,[this.h(v),...T])}h(v){return typeof v=="string"?v:(0,a.$pj)(v,this.f(b.Trace))}flush(){}}e.$hk=s;class r extends I{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const T of this.g)T.setLevel(v);super.setLevel(v)}trace(v,...T){for(const U of this.g)U.trace(v,...T)}debug(v,...T){for(const U of this.g)U.debug(v,...T)}info(v,...T){for(const U of this.g)U.info(v,...T)}warn(v,...T){for(const U of this.g)U.warn(v,...T)}error(v,...T){for(const U of this.g)U.error(v,...T)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$ik=r;class i extends C.$Vc{constructor(v,T,U){if(super(),this.h=v,this.j=T,this.b=new k.$Bc,this.c=this.B(new N.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$le),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,S.$eg)(v)?[...this.b.values()].find(T=>T.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,T){const U=this.n(v),F=(0,S.$eg)(v)?v:T?.id??(0,L.$sj)(U.toString()).toString(16);let M=this.b.get(U)?.logger;const X=T?.logLevel==="always"?b.Trace:T?.logLevel;M||(M=this.s(U,X??this.getLogLevel(U)??this.h,{...T,id:F}));const K={logger:M,info:{resource:U,id:F,logLevel:X,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(K.info),this.b.set(U,K),M}n(v){return(0,S.$eg)(v)?(0,w.$fh)(this.j,`${v}.log`):v}setLogLevel(v,T){if(m.URI.isUri(v)){const U=v,F=T,M=this.b.get(U);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([U,F]))}else{this.h=v;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,T){const U=this.m(v);U&&T!==!U.info.hidden&&(U.info.hidden=!T,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,T]))}getLogLevel(v){let T;return v&&(T=this.b.get(v)?.info.logLevel),T??this.h}registerLogger(v){const T=this.b.get(v.resource);T?T.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const T=this.b.get(v);T&&(T.logger&&T.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=i;class n{constructor(){this.onDidChangeLogLevel=new N.$le().event}setLevel(v){}getLevel(){return b.Info}trace(v,...T){}debug(v,...T){}info(v,...T){}warn(v,...T){}error(v,...T){}critical(v,...T){}dispose(){}flush(){}}e.$kk=n;class o extends n{}e.$lk=o;function l(E){if(E.verbose)return b.Trace;if(typeof E.logLevel=="string"){const v=O(E.logLevel.toLowerCase());if(v!==void 0)return v}return e.$bk}function y(E){switch(E){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function R(E){switch(E){case b.Trace:return{original:"Trace",value:P.localize(0,null)};case b.Debug:return{original:"Debug",value:P.localize(1,null)};case b.Info:return{original:"Info",value:P.localize(2,null)};case b.Warning:return{original:"Warning",value:P.localize(3,null)};case b.Error:return{original:"Error",value:P.localize(4,null)};case b.Off:return{original:"Off",value:P.localize(5,null)}}}function O(E){switch(E){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$qk=new h.$Vj("logLevel",y(b.Info))}),define(le[207],he([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,P,a,N,L,C,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;let m=class extends N.$Vc{constructor($,c){super(),this.a=$,this.b=c,this.B(new P.$Qh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,k.$ch)(this.a.logsHome),c=(0,k.$eh)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,f=(await A.Promises.readdir(c)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==$),p=f.slice(0,Math.max(0,f.length-9));p.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(I=>A.Promises.rm((0,C.$kc)(c,I)))))}catch($){(0,a.$2)($)}}};e.$8fc=m,e.$8fc=m=ve([Z(0,w.$Li),Z(1,S.$$j)],m)}),define(le[208],he([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,P,a,N,L,C,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class m extends k.$Vc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new L.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Ch(0)),this.w=[],this.y=this.B(new a.$Ch(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const g={path:this.J($),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},b=(0,P.$Ub)(this.j,g);return this.r(),(0,k.$Tc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,N.$2)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,w.$2q)(c)),c=>this.G(c),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,w.$Xq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,w.$Xq)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const g={path:this.J($),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},b=(0,P.$Ub)(this.w,g);return this.C(),(0,k.$Tc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,N.$2)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,w.$2q)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,A.$ic)($.fsPath)}J($){const c=this.I($);return(0,C.$Gg)(c)}}e.$8q=m}),define(le[209],he([0,1,19,6,15,26,3,56,63,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let u=class extends w.$Vc{static{d=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new C.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$le),this.Y=this.B(new C.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Nh)}registerProvider(s,r){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const i=new w.$Uc;return this.h.set(s,r),this.c.fire({added:!0,scheme:s,provider:r}),i.add(r.onDidChangeFile(n=>{const o=new b.$rl(n,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:s}))),(0,w.$Tc)(()=>{this.c.fire({added:!1,scheme:s,provider:r}),this.h.delete(s),(0,w.$Qc)(i)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const r=[];this.f.fire({scheme:s,join(i){r.push(i)}}),!this.h.has(s)&&await a.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,r){const i=this.h.get(s.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return A.Iterable.map(this.h,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async j(s){if(!(0,$.$jh)(s))throw new b.$tl((0,g.localize)(0,null,this.sb(s)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const r=this.h.get(s.scheme);if(!r){const i=new I.$cb;throw i.message=(0,g.localize)(1,null,s.toString()),i}return r}async m(s){const r=await this.j(s);if((0,b.$el)(r)||(0,b.$bl)(r)||(0,b.$fl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const r=await this.j(s);if((0,b.$el)(r)||(0,b.$bl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.s(s,r)}catch(i){throw(0,b.$ol)(i)===b.FileSystemProviderErrorCode.FileNotFound?new b.$tl((0,g.localize)(2,null,this.sb(s)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$ml)(i)}}async s(s,r){const i=await this.j(s),n=this.S(i),o=r?.resolveTo,l=r?.resolveSingleChildDescendants,y=r?.resolveMetadata,R=await i.stat(s);let O;return this.t(i,s,R,void 0,!!y,(E,v)=>(O||(O=S.$Ki.forUris(()=>!n),O.set(s,!0),o&&O.fill(!0,o)),O.get(E.resource)||O.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&l?v===1:!1))}async t(s,r,i,n,o,l){const{providerExtUri:y}=this.R(s),R={resource:r,name:y.basename(r),isFile:(i.type&b.FileType.File)!==0,isDirectory:(i.type&b.FileType.Directory)!==0,isSymbolicLink:(i.type&b.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&b.FilePermission.Readonly)||!!(s.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&b.FilePermission.Locked),etag:(0,b.$El)({mtime:i.mtime,size:i.size}),children:void 0};if(R.isDirectory&&l(R,n)){try{const O=await s.readdir(r),E=await a.Promises.settled(O.map(async([v,T])=>{try{const U=y.joinPath(r,v),F=o?await s.stat(U):{type:T};return await this.t(s,U,F,O.length,o,l)}catch(U){return this.b.trace(U),null}}));R.children=(0,P.$Ib)(E)}catch(O){this.b.trace(O),R.children=[]}return R}return R}async resolveAll(s){return a.Promises.settled(s.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.j(s),i=await r.stat(s);return this.t(r,s,i,void 0,!0,()=>!1)}async exists(s){const r=await this.j(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.u(s,r)}catch(i){return i}return!0}async u(s,r){if(!r?.overwrite&&await this.exists(s))throw new b.$tl((0,g.localize)(3,null,this.sb(s)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(s,r=N.$Ne.fromString(""),i){await this.u(s,i);const n=await this.writeFile(s,r);return this.r.fire(new b.$ql(s,b.FileOperation.CREATE,n)),n}async writeFile(s,r,i){const n=this.qb(await this.n(s),s),{providerExtUri:o}=this.R(n);let l=i;if((0,b.$hl)(n)&&!l?.atomic){const y=n.enforceAtomicWriteFile?.(s);y&&(l={...i,atomic:y})}try{await this.w(n,s,l)||await this.U(n,o.dirname(s));let R;if((0,b.$bl)(n)&&!(r instanceof N.$Ne))if((0,c.$ze)(r)){const O=await(0,c.$Ge)(r,3);O.ended?R=N.$Ne.concat(O.buffer):R=O}else R=(0,c.$De)(r,O=>N.$Ne.concat(O),3);else R=r;!(0,b.$el)(n)||(0,b.$bl)(n)&&R instanceof N.$Ne||(0,b.$bl)(n)&&(0,b.$hl)(n)&&l?.atomic?await this.hb(n,s,l,R):await this.db(n,s,l,R instanceof N.$Ne?(0,N.$Ye)(R):R),this.r.fire(new b.$ql(s,b.FileOperation.WRITE))}catch(y){throw new b.$tl((0,g.localize)(4,null,this.sb(s),(0,b.$ml)(y).toString()),(0,b.$pl)(y),l)}return this.resolve(s,{resolveMetadata:!0})}async w(s,r,i){const n=!!i?.unlock;if(n&&!(s.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,g.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(s.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,g.localize)(6,null,this.sb(r)));if(!(s.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,g.localize)(7,null,this.sb(r)));if(n)throw new Error((0,g.localize)(8,null,this.sb(r)))}let l;try{l=await s.stat(r)}catch{return}if(l.type&b.FileType.Directory)throw new b.$tl((0,g.localize)(9,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(r,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==b.$Dl&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,b.$El)({mtime:i.mtime,size:l.size}))throw new b.$tl((0,g.localize)(10,null),b.FileOperationResult.FILE_MODIFIED_SINCE,i);return l}async readFile(s,r,i){const n=await this.m(s);return r?.atomic?this.z(n,s,r,i):this.C(n,s,r,i)}async z(s,r,i,n){return new Promise((o,l)=>{this.cb.queueFor(r,async()=>{try{const y=await this.C(s,r,i,n);o(y)}catch(y){l(y)}},this.R(s).providerExtUri)})}async C(s,r,i,n){const o=await this.D(s,r,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,N.$Ze)(o.value)}}async readFileStream(s,r,i){const n=await this.m(s);return this.D(n,s,r,i)}async D(s,r,i,n){const o=new L.$we(n);let l=i;(0,b.$gl)(s)&&s.enforceAtomicReadFile?.(r)&&(l={...i,atomic:!0});const y=this.J(r,l).then(O=>O,O=>{throw o.dispose(!0),O});let R;try{return typeof l?.etag=="string"&&l.etag!==b.$Dl&&await y,l?.atomic&&(0,b.$gl)(s)||!((0,b.$el)(s)||(0,b.$fl)(s))||(0,b.$bl)(s)&&l?.preferUnbuffered?R=this.I(s,r,l):(0,b.$fl)(s)?R=this.G(s,r,o.token,l):R=this.H(s,r,o.token,l),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await y,value:R}}catch(O){throw R&&await(0,c.$Ee)(R),this.F(O,r,l)}}F(s,r,i){const n=(0,g.localize)(11,null,this.sb(r),(0,b.$ml)(s).toString());return s instanceof b.$vl?new b.$vl(n,s.stat,i):s instanceof b.$ul?new b.$ul(n,s.fileOperationResult,s.size,s.options):new b.$tl(n,(0,b.$pl)(s),i)}G(s,r,i,n=Object.create(null)){const o=s.readFileStream(r,n,i);return(0,c.$Ke)(o,{data:l=>l instanceof N.$Ne?l:N.$Ne.wrap(l),error:l=>this.F(l,r,n)},l=>N.$Ne.concat(l))}H(s,r,i,n=Object.create(null)){const o=(0,N.$4e)();return(0,f.$Uq)(s,r,o,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,r,n)},i),o}I(s,r,i){const n=(0,c.$Be)(o=>N.$Ne.concat(o));return(async()=>{try{let o;i?.atomic&&(0,b.$gl)(s)?o=await s.readFile(r,{atomic:!0}):o=await s.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(r,o.byteLength,i),n.end(N.$Ne.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(s,r){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new b.$tl((0,g.localize)(12,null,this.sb(s)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$Dl&&r.etag===i.etag)throw new b.$vl((0,g.localize)(13,null),i,r);return this.L(s,i.size,r),i}L(s,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new b.$ul((0,g.localize)(14,null,this.sb(s)),b.FileOperationResult.FILE_TOO_LARGE,r,i)}async canMove(s,r,i){return this.M(s,r,"move",i)}async canCopy(s,r,i){return this.M(s,r,"copy",i)}async M(s,r,i,n){if(s.toString()!==r.toString())try{const o=i==="move"?this.qb(await this.n(s),s):await this.m(s),l=this.qb(await this.n(r),r);await this.Q(o,s,l,r,i,n)}catch(o){return o}return!0}async move(s,r,i){const n=this.qb(await this.n(s),s),o=this.qb(await this.n(r),r),l=await this.N(n,s,o,r,"move",!!i),y=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$ql(s,l==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,y)),y}async copy(s,r,i){const n=await this.m(s),o=this.qb(await this.n(r),r),l=await this.N(n,s,o,r,"copy",!!i),y=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$ql(s,l==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,y)),y}async N(s,r,i,n,o,l){if(r.toString()===n.toString())return o;const{exists:y,isSameResourceWithDifferentPathCase:R}=await this.Q(s,r,i,n,o,l);if(y&&!R&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),o==="copy"){if(s===i&&(0,b.$cl)(s))await s.copy(r,n,{overwrite:l});else{const O=await this.resolve(r);O.isDirectory?await this.P(s,O,i,n):await this.O(s,r,i,n)}return o}else return s===i?(await s.rename(r,n,{overwrite:l}),o):(await this.N(s,r,i,n,"copy",l),await this.del(r,{recursive:!0}),"copy")}async O(s,r,i,n){if((0,b.$el)(s)&&(0,b.$el)(i))return this.jb(s,r,i,n);if((0,b.$el)(s)&&(0,b.$bl)(i))return this.pb(s,r,i,n);if((0,b.$bl)(s)&&(0,b.$el)(i))return this.nb(s,r,i,n);if((0,b.$bl)(s)&&(0,b.$bl)(i))return this.lb(s,r,i,n)}async P(s,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await a.Promises.settled(r.children.map(async o=>{const l=this.R(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(s,await this.resolve(o.resource),i,l):this.O(s,o.resource,i,l)}))}async Q(s,r,i,n,o,l){let y=!1;if(s===i){const{providerExtUri:O,isPathCaseSensitive:E}=this.R(s);if(E||(y=O.isEqual(r,n)),y&&o==="copy")throw new Error((0,g.localize)(15,null,this.sb(r),this.sb(n)));if(!y&&O.isEqualOrParent(n,r))throw new Error((0,g.localize)(16,null,this.sb(r),this.sb(n)))}const R=await this.exists(n);if(R&&!y){if(!l)throw new b.$tl((0,g.localize)(17,null,this.sb(r),this.sb(n)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(s===i){const{providerExtUri:O}=this.R(s);if(O.isEqualOrParent(r,n))throw new Error((0,g.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:y}}R(s){const r=this.S(s);return{providerExtUri:r?$.$8g:$.$0g,isPathCaseSensitive:r}}S(s){return!!(s.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const r=this.qb(await this.j(s),s);await this.U(r,s);const i=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$ql(s,b.FileOperation.CREATE,i)),i}async U(s,r){const i=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await s.stat(r)).type&b.FileType.Directory))throw new Error((0,g.localize)(19,null,this.sb(r)));break}catch(o){if((0,b.$ol)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(r)),r=n.dirname(r)}for(let o=i.length-1;o>=0;o--){r=n.joinPath(r,i[o]);try{await s.mkdir(r)}catch(l){if((0,b.$ol)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(s,r){try{await this.W(s,r)}catch(i){return i}return!0}async W(s,r){const i=this.qb(await this.j(s),s),n=!!r?.useTrash;if(n&&!(i.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,g.localize)(20,null,this.sb(s)));const o=r?.atomic;if(o&&!(i.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,g.localize)(21,null,this.sb(s)));if(n&&o)throw new Error((0,g.localize)(22,null,this.sb(s)));let l;try{l=await i.stat(s)}catch{}if(l)this.rb(s,l);else throw new b.$tl((0,g.localize)(23,null,this.sb(s)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const R=await this.resolve(s);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,g.localize)(24,null,this.sb(s)))}return i}async del(s,r){const i=await this.W(s,r);let n=r;if((0,b.$il)(i)&&!n?.atomic){const R=i.enforceAtomicDelete?.(s);R&&(n={...r,atomic:R})}const o=!!n?.useTrash,l=!!n?.recursive,y=n?.atomic??!1;await i.delete(s,{recursive:l,useTrash:o,atomic:y}),this.r.fire(new b.$ql(s,b.FileOperation.DELETE))}async cloneFile(s,r){const i=await this.j(s),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(s,r)))return i===n&&(0,b.$dl)(i)?i.cloneFile(s,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,b.$cl)(i)?this.cb.queueFor(s,()=>i.copy(s,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(s,()=>this.O(i,s,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:d.ab++})}watch(s,r={recursive:!1,excludes:[]}){const i=new w.$Uc;let n=!1,o=()=>{n=!0};i.add((0,w.$Tc)(()=>o())),(async()=>{try{const y=await this.bb(s,r);n?(0,w.$Qc)(y):o=()=>(0,w.$Qc)(y)}catch(y){this.b.error(y)}})();const l=r.correlationId;if(typeof l=="number"){const y=i.add(new C.$le);return i.add(this.X.event(O=>{O.correlates(l)&&y.fire(O)})),{onDidChange:y.event,dispose:()=>i.dispose()}}return i}async bb(s,r){const i=await this.j(s),n=(0,k.$sj)([this.R(i).providerExtUri.getComparisonKey(s),r]);let o=this.$.get(n);return o||(o={count:0,disposable:i.watch(s,r)},this.$.set(n,o)),o.count+=1,(0,w.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,w.$Qc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,w.$Qc)(s.disposable);this.$.clear()}async db(s,r,i,n){return this.cb.queueFor(r,async()=>{const o=await s.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,c.$ze)(n)||(0,c.$Ae)(n)?await this.eb(s,o,n):await this.fb(s,o,n)}catch(l){throw(0,b.$ml)(l)}finally{await s.close(o)}},this.R(s).providerExtUri)}async eb(s,r,i){let n=0,o;if((0,c.$Ae)(i)){if(i.buffer.length>0){const l=N.$Ne.concat(i.buffer);await this.gb(s,r,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,y)=>{(0,c.$Fe)(o,{onData:async R=>{o.pause();try{await this.gb(s,r,R,R.byteLength,n,0)}catch(O){return y(O)}n+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>y(R),onEnd:()=>l()})})}async fb(s,r,i){let n=0,o;for(;(o=i.read())!==null;)await this.gb(s,r,o,o.byteLength,n,0),n+=o.byteLength}async gb(s,r,i,n,o,l){let y=0;for(;y<n;){const R=await s.write(r,o+y,i.buffer,l+y,n-y);y+=R}}async hb(s,r,i,n){return this.cb.queueFor(r,()=>this.ib(s,r,i,n),this.R(s).providerExtUri)}async ib(s,r,i,n){let o;n instanceof N.$Ne?o=n:(0,c.$ze)(n)?o=await(0,N.$Ze)(n):(0,c.$Ae)(n)?o=await(0,N.$1e)(n):o=(0,N.$Xe)(n),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(s,r,i,n){return this.cb.queueFor(n,()=>this.kb(s,r,i,n),this.R(i).providerExtUri)}async kb(s,r,i,n){let o,l;try{o=await s.open(r,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const y=N.$Ne.alloc(this.a);let R=0,O=0,E=0;do E=await s.read(o,R,y.buffer,O,y.byteLength-O),await this.gb(i,l,y,E,R,O),R+=E,O+=E,O===y.byteLength&&(O=0);while(E>0)}catch(y){throw(0,b.$ml)(y)}finally{await a.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(s,r,i,n){return this.cb.queueFor(n,()=>this.mb(s,r,i,n),this.R(i).providerExtUri)}async mb(s,r,i,n){return i.writeFile(n,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,r,i,n){return this.cb.queueFor(n,()=>this.ob(s,r,i,n),this.R(i).providerExtUri)}async ob(s,r,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await s.readFile(r);await this.gb(i,o,N.$Ne.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$ml)(l)}finally{await i.close(o)}}async pb(s,r,i,n){const o=await(0,N.$Ze)(this.H(s,r,L.CancellationToken.None));await this.hb(i,n,void 0,o)}qb(s,r){if(s.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$tl((0,g.localize)(25,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$tl((0,g.localize)(26,null,this.sb(s)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===m.Schemas.file?s.fsPath:s.toString(!0)}};e.$Vq=u,e.$Vq=u=d=ve([Z(0,p.$$j)],u)}),define(le[210],he([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,208,205,204]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class I extends b.$8q{static{this.L=!1}constructor(u,t){super(u,t),this.onDidChangeCapabilities=L.Event.None,this.P=new a.$Bc(s=>S.$9g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,w.$k&&(this.M|=c.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.I(u));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:c.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const t=await h.Promises.readdir(this.I(u),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async r=>{try{let i;r.isSymbolicLink()?i=(await this.stat((0,S.$fh)(u,r.name))).type:i=this.O(r),s.push([r.name,i])}catch(i){this.a.trace(i)}})),s}catch(t){throw this.hb(t)}}O(u,t){let s;return t?.dangling?s=c.FileType.Unknown:u.isFile()?s=c.FileType.File:u.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,t&&(s|=c.FileType.SymbolicLink),s}async Q(u){const t=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const r=new P.$Dh;return this.P.set(u,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,k.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(u)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(u,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),s=await this.Q(u));const r=this.I(u);return await h.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{s?.dispose()}}R(u){I.L&&this.a.trace(u)}readFileStream(u,t,s){const r=(0,m.$Be)(i=>N.$Ne.concat(i.map(n=>N.$Ne.wrap(n))).buffer);return(0,g.$Uq)(this,u,r,i=>i.buffer,{...t,bufferSize:256*1024},s),r}async writeFile(u,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(u)?this.U(u,(0,S.$fh)((0,S.$eh)(u),`${(0,S.$ch)(u)}${s.atomic.postfix}`),t,s):this.W(u,t,s)}async S(u){try{const t=this.I(u),{symbolicLink:s}=await h.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(u,t,s,r){const i=new k.$Uc;try{i.add(await this.Q(u)),i.add(await this.Q(t)),await this.W(t,s,r,!0);try{await this.rename(t,u,{overwrite:!0})}catch(n){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{i.dispose()}}async W(u,t,s,r){let i;try{const n=this.I(u);if(!s.create||!s.overwrite){if(await h.Promises.exists(n)){if(!s.overwrite)throw(0,c.$ll)((0,$.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.$ll)((0,$.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(u,{create:!0,unlock:s.unlock},r),await this.write(i,0,t,0,t.byteLength)}catch(n){throw await this.ib(u,n)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(u){I.$=u}async open(u,t,s){const r=this.I(u);let i;(0,c.$_k)(t)&&!s&&(i=await this.Q(u));let n;try{if((0,c.$_k)(t)&&t.unlock)try{const{stat:l}=await h.SymlinkSupport.stat(r);l.mode&128||await h.Promises.chmod(r,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}let o;if((0,c.$_k)(t)){if(w.$i)try{await h.Promises.truncate(r,0),o="r+"}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}o||(o="w")}else o="r";n=await h.Promises.open(r,o)}catch(o){throw i?.dispose(),(0,c.$_k)(t)?await this.ib(u,o):this.hb(o)}if(this.X.set(n,0),(0,c.$_k)(t)&&this.Z.set(n,u),i){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${r})`),this.Y.set(n,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${r})`),o.dispose())}return n}async close(u){const t=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&I.$)try{await h.Promises.fdatasync(u)}catch(s){I.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(u)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(u)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),t.dispose())}}async read(u,t,s,r,i){const n=this.ab(u,t);let o=null;try{o=(await h.Promises.read(u,s,r,i,n)).bytesRead}catch(l){throw this.hb(l)}finally{this.bb(u,n,o)}return o}ab(u,t){return t===this.X.get(u)?null:t}bb(u,t,s){const r=this.X.get(u);typeof r=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(u,r+s):this.X.delete(u)))}async write(u,t,s,r,i){return(0,P.$Yh)(()=>this.cb(u,t,s,r,i),100,3)}async cb(u,t,s,r,i){const n=this.ab(u,t);let o=null;try{o=(await h.Promises.write(u,s,r,i,n)).bytesWritten}catch(l){throw await this.ib(this.Z.get(u),l)}finally{this.bb(u,n,o)}return o}async mkdir(u){try{await h.Promises.mkdir(this.I(u))}catch(t){throw this.hb(t)}}async delete(u,t){try{const s=this.I(u);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,A.$kc)((0,A.$nc)(s),`${(0,A.$oc)(s)}${t.atomic.postfix}`)),await h.Promises.rm(s,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let i=!1;try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(s);i=n.isDirectory()&&!o}catch{}if(i)await h.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.hb(s)}}async rename(u,t,s){const r=this.I(u),i=this.I(t);if(r!==i)try{await this.db(u,t,"move",s.overwrite),await h.Promises.rename(r,i)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(2,null,(0,A.$oc)(r),(0,A.$oc)((0,A.$nc)(i)),n.toString()))),this.hb(n)}}async copy(u,t,s){const r=this.I(u),i=this.I(t);if(r!==i)try{await this.db(u,t,"copy",s.overwrite),await h.Promises.copy(r,i,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(3,null,(0,A.$oc)(r),(0,A.$oc)((0,A.$nc)(i)),n.toString()))),this.hb(n)}}async db(u,t,s,r){const i=this.I(u),n=this.I(t);let o=!1;if(!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,C.$Cg)(i,n,!0)),o){if(s==="copy")throw(0,c.$ll)((0,$.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const y=await this.N(u);if(!y)throw(0,c.$ll)((0,$.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(t);if(R){if(!r)throw(0,c.$ll)((0,$.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);y.type&c.FileType.File&&R.type&c.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,t){return this.eb(u,t,!1)}async eb(u,t,s){const r=this.I(u),i=this.I(t),n=!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive);if((0,C.$Cg)(r,i,!n))return;const o=new k.$Uc;try{o.add(await this.Q(u)),o.add(await this.Q(t)),s&&await h.Promises.mkdir((0,A.$nc)(i),{recursive:!0}),await h.Promises.copyFile(r,i)}catch(l){if(l.code==="ENOENT"&&!s)return this.eb(u,t,!0);throw this.hb(l)}finally{o.dispose()}}t(u,t,s){return new f.$cr(r=>u(r),r=>t(r),s)}F(u,t,s){return new p.$lr(r=>u(r),r=>t(r),s)}hb(u){if(u instanceof c.$kl)return u;let t=u,s;switch(u.code){case"ENOENT":s=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=c.FileSystemProviderErrorCode.Unknown;break;default:s=c.FileSystemProviderErrorCode.Unknown}return(0,c.$ll)(t,s)}async ib(u,t){let s=this.hb(t);if(u&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(u));r.mode&128||(s=(0,c.$ll)(t,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$mr=I}),define(le[102],he([0,1,3,2,4,10]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,N.$Ei)("sharedProcessLifecycleService");let C=class extends a.$Vc{constructor(A){super(),this.b=A,this.a=this.B(new P.$le),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$vgc=C,e.$vgc=C=ve([Z(0,L.$$j)],C)}),define(le[211],he([0,1,9,3,10,2]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=void 0;class C extends N.$jk{constructor(m,h,$,c,g){super(h,$,c),this.r=m,this.t=g,this.B(g.listen("onDidChangeLogLevel",m)(b=>{(0,N.$ak)(b)?super.setLogLevel(b):super.setLogLevel(P.URI.revive(b[0]),b[1])})),this.B(g.listen("onDidChangeVisibility",m)(([b,f])=>super.setVisibility(P.URI.revive(b),f))),this.B(g.listen("onDidChangeLoggers",m)(({added:b,removed:f})=>{for(const p of b)super.registerLogger({...p,resource:P.URI.revive(p.resource)});for(const p of f)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new N.$hk({log:(m,h)=>{this.t.call("consoleLog",[m,h])}})}registerLogger(m){super.registerLogger(m),this.t.call("registerLogger",[m,this.r])}deregisterLogger(m){super.deregisterLogger(m),this.t.call("deregisterLogger",[m,this.r])}setLogLevel(m,h){super.setLogLevel(m,h),this.t.call("setLogLevel",[m,h])}setVisibility(m,h){super.setVisibility(m,h),this.t.call("setVisibility",[this.n(m),h])}s(m,h,$){return new k(this.t,m,h,$,this.r)}static setLogLevel(m,h,$){return m.call("setLogLevel",[h,$])}}e.$ms=C;class k extends N.$ek{constructor(m,h,$,c,g){super(c?.logLevel==="always"),this.r=m,this.s=h,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[h,c,g]).then(()=>{this.u(this.n),this.m=!0})}g(m,h){const $=[[m,h]];this.m?this.u($):this.n.push(...$)}u(m){this.r.call("log",[this.s,m])}}class A{constructor(m,h){this.a=m,this.b=h}listen(m,h){const $=this.b(m);switch(h){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(g=>this.c(g,$)),removed:[...c.removed].map(g=>this.c(g,$))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,c=>[$.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,c=>(0,N.$ak)(c)?c:[$.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${h}`)}async call(m,h,$){const c=this.b(m);switch(h){case"setLogLevel":return(0,N.$ak)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(P.URI.revive(c.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,c)))}throw new Error(`Call not found: ${h}`)}c(m,h){return{...m,resource:h.transformOutgoingURI(m.resource)}}}e.$ns=A;class w extends L.$Vc{constructor(m,h){super(),h.call("setLogLevel",[m.getLogLevel()]),this.B(m.onDidChangeLogLevel($=>h.call("setLogLevel",[$]))),h.call("getRegisteredLoggers").then($=>{for(const c of $)m.registerLogger({...c,resource:P.URI.revive(c.resource)})}),this.B(h.listen("onDidChangeVisibility")(([$,c])=>m.setVisibility(P.URI.revive($),c))),this.B(h.listen("onDidChangeLoggers")(({added:$,removed:c})=>{for(const g of $)m.registerLogger({...g,resource:P.URI.revive(g.resource)});for(const g of c)m.deregisterLogger(g.resource)}))}}e.$os=w}),define(le[212],he([0,1,2,10]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;class N extends P.$Vc{constructor(C,k=[]){super(),this.a=new a.$ik([C,...k]),this.B(C.onDidChangeLogLevel(A=>this.setLevel(A)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.$UQ=N}),define(le[59],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0,e.$wec=(0,P.$Ei)("nativeHostService")}),define(le[213],he([0,1,43,58]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;let N=class{constructor(C,k){return this.windowId=C,P.ProxyChannel.toService(k.getChannel("nativeHost"),{context:C,properties:(()=>{const A=new Map;return A.set("windowId",C),A})()})}};e.$Qfc=N,e.$Qfc=N=ve([Z(1,a.$Nfc)],N)}),define(le[60],he([0,1,3,63,2,4]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,L.$Ei)("policy");class C extends N.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const S=Object.keys(this.f).length;return this.f={...w,...this.f},S!==Object.keys(this.f).length&&await this.j(w),a.Iterable.reduce(this.g.entries(),(m,[h,$])=>({...m,[h]:$}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(w,[S,m])=>({...w,[S]:{definition:m,value:this.g.get(S)}}),{})}}e.$ro=C;class k{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=k}),define(le[214],he([0,1,3,2,60]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=void 0;class L{constructor(A){this.b=A,this.a=new a.$Uc}listen(A,w){switch(w){case"onDidChange":return P.Event.map(this.b.onDidChange,S=>S.reduce((m,h)=>({...m,[h]:this.b.getPolicyValue(h)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(A,w,S){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.$hfc=L;class C extends N.$ro{constructor(A,w){super(),this.a=w;for(const S in A){const{definition:m,value:h}=A[S];this.f[S]=m,h!==void 0&&this.g.set(S,h)}this.a.listen("onDidChange")(S=>{for(const m in S){const h=S[m];h===null?this.g.delete(m):this.g.set(m,h)}this.h.fire(Object.keys(S))})}async j(A){const w=await this.a.call("updatePolicyDefinitions",A);for(const S in w)this.g.set(S,w[S])}}e.$ifc=C}),define(le[103],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const L=N.context.configuration();if(L)a=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:L.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(le[24],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,P.$Ei)("productService"),e.$sk="vscode://schemas/vscode-product"}),define(le[215],he([0,1,6,8,2,14,31,10,24]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;let w=class extends N.$Vc{constructor(m,h,$){super(),this.b=h,this.c=$,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this.B(new P.$Qh(()=>{this.f(m)},3e4)).schedule()}async f(m){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),$=(0,L.$nc)(m),c=(0,L.$oc)(m),g=await C.Promises.readdir($);await Promise.all(g.map(async b=>{if(b===c)return;const f=(0,L.$kc)($,b),p=await C.Promises.stat(f);if(p.isDirectory()&&h-p.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${b}.`),C.Promises.rm(f)}))}catch(h){(0,a.$2)(h)}}};e.$5fc=w,e.$5fc=w=ve([Z(1,A.$rk),Z(2,k.$$j)],w)}),define(le[216],he([0,1,6,8,2,14,31,16,10,24]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;let S=class extends N.$Vc{constructor(h,$,c){super(),this.b=h,this.c=$,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new P.$Qh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),$=JSON.parse(await C.Promises.readFile((0,L.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const p of Object.keys($)){const I=$[p];h[`${I.hash}.${p}`]=!0}const c=(0,L.$kc)(this.b.userDataPath,"clp");if(!await C.Promises.exists(c))return;const b=await C.Promises.readdir(c);for(const p of b){if(h[p]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${p}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${p}`),await C.Promises.rm((0,L.$kc)(c,p))}const f=Date.now();for(const p of Object.keys(h)){const I=(0,L.$kc)(c,p),d=await C.Promises.readdir(I);for(const u of d){if(u==="tcf.json")continue;const t=(0,L.$kc)(I,u),s=await C.Promises.stat(t);s.isDirectory()&&f-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$kc)(p,u)}`),await C.Promises.rm(t))}}}catch(h){(0,a.$2)(h)}}};e.$6fc=S,e.$6fc=S=ve([Z(0,k.$Mi),Z(1,A.$$j),Z(2,w.$rk)],S)}),define(le[217],he([0,1,14,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$JG=void 0,e.$JG=(0,a.$Ei)("IV8InspectProfilingService");var N;(function(L){function C(A){return!!(A.samples&&A.timeDeltas)}L.isValidProfile=C;function k(A,w="noAbsolutePaths"){for(const S of A.nodes)S.callFrame&&S.callFrame.url&&((0,P.$jc)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,P.$kc)(w,(0,P.$oc)(S.callFrame.url)));return A}L.rewriteAbsolutePaths=k})(N||(e.Utils=N={}))}),define(le[218],he([0,1,32]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class a{constructor(){this.a=new Map}async startProfiling(L){const k=await(await new Promise((w,S)=>{ne(["v8-inspect-profiler"],w,S)}).then(ke)).startProfiling({host:L.host,port:L.port,checkForPaused:!0}),A=(0,P.$1g)();return this.a.set(A,k),A}async stopProfiling(L){const C=this.a.get(L);if(!C)throw new Error(`UNKNOWN session '${L}'`);const k=await C.stop();return this.a.delete(L),k.profile}}e.$kgc=a}),define(le[44],he([0,1,132,13]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,P=ke(P),a=ke(a);class N{constructor(){this.a=new Map}add(C,k){P.ok(a.$eg(C)),P.ok(a.$gg(k)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$oo=new N}),define(le[104],he([0,1,3,44]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,a=ke(a),e.$po={JSONContribution:"base.contributions.json"};function N(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this.b=new P.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(A,w){this.a[N(A)]=w,this.b.fire(A)}notifySchemaChanged(A){this.b.fire(A)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;a.$oo.add(e.$po.JSONContribution,C)}),define(le[48],he([0,1,19,3,13,159,22,104,44]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=g,e.$Fo=b,e.$Go=f,e.$Ho=I,e.$Io=d,N=ke(N),L=ke(L);var w;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$to={Configuration:"base.contributions.configuration"};var S;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const m=A.$oo.as(k.$po.JSONContribution);class h{constructor(){this.h=new Set,this.i=new a.$le,this.onDidSchemaChange=this.i.event,this.j=new a.$le,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.n(t,s,r),m.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.o(t,s),m.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.o(s,r),this.n(t,!1,r),m.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(s.add(o),e.$Do.test(o)){const l=this.a.get(o),y=l?.valuesSources??new Map;if(n)for(const v of Object.keys(i[o]))y.set(v,n);const R={...l?.value||{},...i[o]};this.a.set(o,{source:n,value:R,valuesSources:y});const O=(0,C.$ij)(o),E={type:"object",default:R,description:L.localize(1,null,O),$ref:e.$Ao,defaultDefaultValue:R,source:N.$eg(n)?void 0:n,defaultValueSource:n};r.push(...g(o)),this.d[o]=E,this.b.properties[o]=E}else{this.a.set(o,{value:i[o],source:n});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(r)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),l=N.$eg(i)?i:i?.id,y=N.$eg(o?.source)?o?.source:o?.source?.id;if(l===y)if(s.add(n),this.a.delete(n),e.$Do.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,r){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,s){const r=i=>{if(i.properties)for(const n in i.properties){s.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,r,i,n=S.WINDOW,o){n=N.$ng(t.scope)?n:t.scope;const l=t.properties;if(l)for(const R in l){const O=l[R];if(s&&I(R,O)){delete l[R];continue}if(O.source=r,O.defaultDefaultValue=l[R].default,this.w(R,O),e.$Do.test(R)?O.scope=void 0:(O.scope=N.$ng(O.scope)?n:O.scope,O.restricted=N.$ng(O.restricted)?!!i?.includes(R):O.restricted),l[R].hasOwnProperty("included")&&!l[R].included){this.f[R]=l[R],delete l[R];continue}else this.d[R]=l[R],l[R].policy?.name&&this.e.set(l[R].policy.name,R);!l[R].deprecationMessage&&l[R].markdownDeprecationMessage&&(l[R].deprecationMessage=l[R].markdownDeprecationMessage),o.add(R)}const y=t.allOf;if(y)for(const R of y)this.p(R,s,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$uo.properties[t]=s,s.scope){case S.APPLICATION:e.$vo.properties[t]=s;break;case S.MACHINE:e.$wo.properties[t]=s;break;case S.MACHINE_OVERRIDABLE:e.$xo.properties[t]=s;break;case S.WINDOW:e.$yo.properties[t]=s;break;case S.RESOURCE:e.$zo.properties[t]=s;break;case S.LANGUAGE_OVERRIDABLE:e.$zo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$uo.properties[t],s.scope){case S.APPLICATION:delete e.$vo.properties[t];break;case S.MACHINE:delete e.$wo.properties[t];break;case S.MACHINE_OVERRIDABLE:delete e.$xo.properties[t];break;case S.WINDOW:delete e.$yo.properties[t];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Ao};this.w(s,r),e.$uo.properties[s]=r,e.$vo.properties[s]=r,e.$wo.properties[s]=r,e.$xo.properties[s]=r,e.$yo.properties[s]=r,e.$zo.properties[s]=r}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=t,e.$vo.patternProperties[e.$Co]=t,e.$wo.patternProperties[e.$Co]=t,e.$xo.patternProperties[e.$Co]=t,e.$yo.patternProperties[e.$Co]=t,e.$zo.patternProperties[e.$Co]=t,this.i.fire()}w(t,s){const r=this.a.get(t);let i=r?.value,n=r?.source;N.$lg(i)&&(i=s.defaultDefaultValue,n=void 0),N.$lg(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const $="\\[([^\\]]+)\\]",c=new RegExp($,"g");e.$Co=`^(${$})+$`,e.$Do=new RegExp(e.$Co);function g(u){const t=[];if(e.$Do.test(u)){let s=c.exec(u);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=c.exec(u)}}return(0,P.$Nb)(t)}function b(u){return u.reduce((t,s)=>`${t}[${s}]`,"")}function f(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new h;A.$oo.add(e.$to.Configuration,p);function I(u,t){return u.trim()?e.$Do.test(u)?L.localize(7,null,u):p.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,u,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}function d(){const u=[],t=p.getConfigurationProperties();for(const s of Object.keys(t))u.push([s,t[s].scope]);return u.push(["launch",S.RESOURCE]),u.push(["task",S.RESOURCE]),u}}),define(le[78],he([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=d,P=ke(P),N=ke(N),k=ke(k),A=ke(A);function c(r){return Object.isFrozen(r)?r:k.$co(r)}class g{static createEmptyModel(i){return new g({},[],[],void 0,i)}constructor(i,n,o,l,y){this.b=i,this.c=n,this.d=o,this.raw=l,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof g)return n;const o=new b("",this.f);return o.parseRaw(n),o.configurationModel});this.g=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$gj)(this.contents,i):this.contents}inspect(i,n){const o=this;return{get value(){return c(o.rawConfiguration.getValue(i))},get override(){return n?c(o.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return c(n?o.rawConfiguration.override(n).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const l=[];for(const{contents:y,identifiers:R,keys:O}of o.rawConfiguration.overrides){const E=new g(y,O,[],void 0,o.f).getValue(i);E!==void 0&&l.push({identifiers:R,value:E})}return l.length?c(l):void 0}}}getOverrideValue(i,n){const o=this.j(n);return o?i?(0,S.$gj)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return P.$Nb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return P.$Nb(i)}override(i){let n=this.a.get(i);return n||(n=this.h(i),this.a.set(i,n)),n}merge(...i){const n=k.$bo(this.contents),o=k.$bo(this.overrides),l=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const R of i)if(y.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(n,R.contents);for(const O of R.overrides){const[E]=o.filter(v=>P.$vb(v.identifiers,O.identifiers));E?(this.i(E.contents,O.contents),E.keys.push(...O.keys),E.keys=P.$Nb(E.keys)):o.push(k.$bo(O))}for(const O of R.keys)l.indexOf(O)===-1&&l.push(O)}return new g(n,l,o,y.every(R=>R instanceof g)?void 0:y,this.f)}h(i){const n=this.j(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const l of P.$Nb([...Object.keys(this.contents),...Object.keys(n)])){let y=this.contents[l];const R=n[l];R&&(typeof y=="object"&&typeof R=="object"?(y=k.$bo(y),this.i(y,R)):y=R),o[l]=y}return new g(o,this.keys,this.overrides,void 0,this.f)}i(i,n){for(const o of Object.keys(n)){if(o in i&&A.$gg(i[o])&&A.$gg(n[o])){this.i(i[o],n[o]);continue}i[o]=k.$bo(n[o])}}j(i){let n=null,o=null;const l=y=>{y&&(o?this.i(o,y):o=k.$bo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===i?n=y.contents:y.identifiers.includes(i)&&l(y.contents);return l(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.k(i,n,!0)}setValue(i,n){this.k(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.$fj)(this.contents,i),m.$Do.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>P.$vb(o.identifiers,(0,m.$Eo)(i))),1))}k(i,n,o){(0,S.$ej)(this.contents,i,n,l=>this.f.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.$Do.test(i)&&this.overrides.push({identifiers:(0,m.$Eo)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$dj)(this.contents[i],l=>this.f.error(l))})}}e.$Jo=g;class b{constructor(i,n){this.f=i,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!A.$ng(i)){const o=this.h(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:l,overrides:y,restricted:R,hasExcludedProperties:O}=this.i(i,n);this.b=new g(o,l,y,O?[i]:void 0,this.g),this.c=R||[]}h(i){let n={},o=null,l=[];const y=[],R=[];function O(v){Array.isArray(l)?l.push(v):o!==null&&(l[o]=v)}const E={onObjectBegin:()=>{const v={};O(v),y.push(l),l=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{l=y.pop()},onArrayBegin:()=>{const v=[];O(v),y.push(l),l=v,o=null},onArrayEnd:()=>{l=y.pop()},onLiteralValue:O,onError:(v,T,U)=>{R.push({error:v,offset:T,length:U})}};if(i)try{N.$2n(i,E),n=l[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return n}i(i,n){const o=$.$oo.as(m.$to.Configuration).getConfigurationProperties(),l=this.j(i,o,!0,n);i=l.raw;const y=(0,S.$dj)(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(i),O=this.l(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:y,keys:R,overrides:O,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(i,n,o,l){let y=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:y};const R={},O=[];for(const E in i)if(m.$Do.test(E)&&o){const v=this.j(i[E],n,!1,l);R[E]=v.raw,y=y||v.hasExcludedProperties,O.push(...v.restricted)}else{const v=n[E],T=v?typeof v.scope<"u"?v.scope:m.ConfigurationScope.WINDOW:void 0;v?.restricted&&O.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(T===void 0||l.scopes===void 0||l.scopes.includes(T))&&!(l.skipRestricted&&v?.restricted))?R[E]=i[E]:y=!0}return{raw:R,restricted:O,hasExcludedProperties:y}}l(i,n){const o=[];for(const l of Object.keys(i))if(m.$Do.test(l)){const y={};for(const R in i[l])y[R]=i[l][R];o.push({identifiers:(0,m.$Eo)(l),keys:Object.keys(y),contents:(0,S.$dj)(y,n)})}return o}}e.$Ko=b;class f extends L.$Vc{constructor(i,n,o,l,y){super(),this.c=i,this.f=n,this.g=l,this.h=y,this.b=this.B(new a.$le),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),y),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(h.FileOperation.CREATE)||R.isOperation(h.FileOperation.COPY)||R.isOperation(h.FileOperation.DELETE)||R.isOperation(h.FileOperation.WRITE))&&o.isEqual(R.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=f;class p{constructor(i,n,o,l,y,R,O,E,v,T,U,F,M){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=l,this.d=y,this.f=R,this.g=O,this.h=E,this.i=v,this.j=T,this.k=U,this.l=F,this.m=M}get value(){return c(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class I{constructor(i,n,o,l,y,R,O,E,v,T){this.j=i,this.l=n,this.m=o,this.n=l,this.p=y,this.q=R,this.r=O,this.s=E,this.t=v,this.u=T,this.h=null,this.i=new C.$Bc,this.v=null}getValue(i,n,o){return this.w(i,n,o).getValue(i)}updateValue(i,n,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=g.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,n===void 0?l.removeValue(i):l.setValue(i,n),o.resource||(this.h=null)}inspect(i,n,o){const l=this.w(i,n,o),y=this.A(n.resource,o),R=n.resource?this.t.get(n.resource)||this.s:this.s,O=new Set;for(const E of l.overrides)for(const v of E.identifiers)l.getOverrideValue(i,v)!==void 0&&O.add(v);return new p(i,n,l.getValue(i),O.size?[...O]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,y||void 0,R)}keys(i){const n=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,n){this.r.set(i,n),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:l,updated:y,removed:R}=t(this.j,i);n=[...l,...y,...R]}for(const l of n)for(const y of(0,m.$Eo)(l)){const R=this.j.getKeysForOverrideIdentifier(y),O=i.getKeysForOverrideIdentifier(y),E=[...O.filter(v=>R.indexOf(v)===-1),...R.filter(v=>O.indexOf(v)===-1),...R.filter(v=>!k.$fo(this.j.override(y).getValue(v),i.override(y).getValue(v)))];o.push([y,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:l}=t(this.l,i),y=[...n,...o,...l];return y.length&&this.updatePolicyConfiguration(i),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.applicationConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateApplicationConfiguration(i),{keys:R,overrides:y}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.localUserConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateLocalUserConfiguration(i),{keys:R,overrides:y}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.remoteUserConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateRemoteUserConfiguration(i),{keys:R,overrides:y}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.workspaceConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateWorkspaceConfiguration(i),{keys:R,overrides:y}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:l,updated:y,removed:R,overrides:O}=t(o,n),E=[...l,...y,...R];return(E.length||!o)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:O}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:y,overrides:R}=t(n,void 0);return{keys:[...o,...l,...y],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,n,o){let l=this.x(n,o);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(l=l.merge(this.l)),l}x({resource:i},n){let o=this.y();if(n&&i){const l=n.getFolder(i);l&&(o=this.z(l.uri)||o);const y=this.t.get(i);y&&(o=o.merge(y))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let n=this.i.get(i);if(!n){const o=this.y(),l=this.r.get(i);l?(n=o.merge(l),this.i.set(i,n)):n=o}return n}A(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,n)=>{const{contents:o,overrides:l,keys:y}=this.r.get(n);return i.push([n,{contents:o,overrides:l,keys:y}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.q.keys.forEach(n=>i.add(n)),this.r.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const n=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i,n){const o=this.E(i.defaults,n),l=this.E(i.policy,n),y=this.E(i.application,n),R=this.E(i.user,n),O=this.E(i.workspace,n),E=i.folders.reduce((v,T)=>(v.set(w.URI.revive(T[0]),this.E(T[1],n)),v),new C.$Bc);return new I(o,l,y,R,g.createEmptyModel(n),O,E,g.createEmptyModel(n),new C.$Bc,n)}static E(i,n){return new g(i.contents,i.keys,i.overrides,void 0,n)}}e.$Mo=I;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,n=new Map;for(const l of r)l.keys.forEach(y=>i.add(y)),l.overrides.forEach(([y,R])=>{const O=(0,C.$yc)(n,y,new Set);R.forEach(E=>O.add(E))});const o=[];return n.forEach((l,y)=>o.push([y,[...l.values()]])),{keys:[...i.values()],overrides:o}}class u{constructor(i,n,o,l,y){this.change=i,this.f=n,this.g=o,this.h=l,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of i.keys)this.affectedKeys.add(R);for(const[,R]of i.overrides)for(const O of R)this.affectedKeys.add(O);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=I.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,n){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const y=l+o.length;if(y>=this.d.length)return!1;const R=this.d.charCodeAt(y);if(R!==this.b&&R!==this.c)return!1;if(n){const O=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!k.$fo(O,E)}return!0}}e.$Oo=u;function t(r,i){const{added:n,removed:o,updated:l}=s(i?.rawConfiguration,r?.rawConfiguration),y=[],R=r?.getAllOverrideIdentifiers()||[],O=i?.getAllOverrideIdentifiers()||[];if(i){const E=O.filter(v=>!R.includes(v));for(const v of E)y.push([v,i.getKeysForOverrideIdentifier(v)])}if(r){const E=R.filter(v=>!O.includes(v));for(const v of E)y.push([v,r.getKeysForOverrideIdentifier(v)])}if(i&&r){for(const E of R)if(O.includes(E)){const v=s({contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});y.push([E,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:o,updated:l,overrides:y}}function s(r,i){const n=r?i?r.keys.filter(y=>i.keys.indexOf(y)===-1):[...r.keys]:[],o=i?r?i.keys.filter(y=>r.keys.indexOf(y)===-1):[...i.keys]:[],l=[];if(r&&i){for(const y of i.keys)if(r.keys.indexOf(y)!==-1){const R=(0,S.$gj)(i.contents,y),O=(0,S.$gj)(r.contents,y);k.$fo(R,O)||l.push(y)}}return{added:n,removed:o,updated:l}}}),define(le[219],he([0,1,19,3,2,30,13,78,48,10,60,44]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=void 0;class h extends N.$Vc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new a.$le),this.onDidChangeConfiguration=this.a.event,this.b=k.$Jo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(m.$oo.as(A.$to.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:f})=>this.f(Array.from(b),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,f){this.j(b,m.$oo.as(A.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=k.$Jo.createEmptyModel(this.c);const b=m.$oo.as(A.$to.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,f){const p=this.g();for(const I of b){const d=p[I],u=f[I];d!==void 0?this.b.addValue(I,d):u?this.b.addValue(I,u.default):this.b.removeValue(I)}}}e.$Po=h;class ${constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=k.$Jo.createEmptyModel(new w.$lk)}async initialize(){return this.configurationModel}}e.$Qo=$;let c=class extends N.$Vc{get configurationModel(){return this.b}constructor(b,f,p){super(),this.c=b,this.f=f,this.g=p,this.a=this.B(new a.$le),this.onDidChangeConfiguration=this.a.event,this.b=k.$Jo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const f={},p=[],I=m.$oo.as(A.$to.Configuration).getConfigurationProperties();for(const d of b){const u=I[d];if(!u){p.push(d);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}p.push(d),f[u.policy.name]={type:u.type}}}return(0,C.$rg)(f)||await this.f.updatePolicyDefinitions(f),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const f=m.$oo.as(A.$to.Configuration).getPolicyConfigurations(),p=(0,P.$Ib)(b.map(I=>f.get(I)));this.m(p,!0)}m(b,f){this.g.trace("PolicyConfiguration#update",b);const p=m.$oo.as(A.$to.Configuration).getConfigurationProperties(),I=[],d=this.b.isEmpty();for(const u of b){const t=p[u]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(d?s!==void 0:!(0,L.$fo)(this.b.getValue(u),s))&&I.push([u,s])}else this.b.getValue(u)!==void 0&&I.push([u,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const u=this.b;this.b=k.$Jo.createEmptyModel(this.g);for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,s]of I)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};e.$Ro=c,e.$Ro=c=ve([Z(1,S.$qo),Z(2,w.$$j)],c)}),define(le[220],he([0,1,19,6,15,3,34,64,2,35,30,5,21,22,78,48,219,7,60]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;class I extends A.$Vc{constructor(t,s,r,i){super(),this.m=t,this.n=i,this.h=this.B(new L.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$Po(i)),this.c=r instanceof p.$so?new b.$Qo:this.B(new b.$Ro(this.b,r,i)),this.f=this.B(new c.$Lo(this.m,{},h.$9g,s,i)),this.a=new c.$Mo(this.b.configurationModel,this.c.configurationModel,c.$Jo.createEmptyModel(i),c.$Jo.createEmptyModel(i),c.$Jo.createEmptyModel(i),c.$Jo.createEmptyModel(i),new w.$Bc,c.$Jo.createEmptyModel(i),new w.$Bc,i),this.j=new d(t,s,this),this.g=this.B(new a.$Qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,s,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$Mo(t,s,c.$Jo.createEmptyModel(this.n),r,c.$Jo.createEmptyModel(this.n),c.$Jo.createEmptyModel(this.n),new w.$Bc,c.$Jo.createEmptyModel(this.n),new w.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,s){const r=typeof t=="string"?t:void 0,i=(0,$.$_i)(t)?t:(0,$.$_i)(s)?s:{};return this.a.getValue(r,i,void 0)}async updateValue(t,s,r,i,n){const o=(0,$.$aj)(r)?r:(0,$.$_i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?i:r;if(l!==void 0&&l!==$.ConfigurationTarget.USER_LOCAL&&l!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Nb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const y=this.inspect(t,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,S.$fo)(s,y.defaultValue)&&(s=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const O=o.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(v=>(0,P.$vb)([...v.identifiers].sort(),O));E&&(o.overrideIdentifiers=E.identifiers)}const R=o?.overrideIdentifiers?.length?[(0,g.$Fo)(o.overrideIdentifiers),t]:[t];await this.j.write(R,s),await this.reloadConfiguration()}inspect(t,s={}){return this.a.inspect(t,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const s=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(r,s,$.ConfigurationTarget.USER)}s(t,s){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(t,s);this.u(i,r,$.ConfigurationTarget.DEFAULT)}t(t){const s=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(t);this.u(r,s,$.ConfigurationTarget.DEFAULT)}u(t,s,r){const i=new c.$Oo(t,{data:s},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}e.$So=I;class d{constructor(t,s,r){this.b=t,this.c=s,this.d=r,this.a=new a.$Lh}write(t,s){return this.a.queue(()=>this.e(t,s))}async e(t,s){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const i=[];if((0,C.$Un)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,t,s);r=(0,k.$ao)(r,n),await this.c.writeFile(this.b,N.$Ne.fromString(r))}f(t,s,r){const{tabSize:i,insertSpaces:n,eol:o}=this.h;if(!s.length){const l=JSON.stringify(r,null,n?" ".repeat(i):"	");return[{content:l,length:l.length,offset:0}]}return(0,k.$0n)(t,s,r,{tabSize:i,insertSpaces:n,eol:o})}get h(){if(!this.g){let t=m.OS===m.OperatingSystem.Linux||m.OS===m.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(t=s),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[221],he([0,1,15,3,2,70]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=e.$owb=e.$nwb=void 0,e.$pwb=k;const C=(w,S,m)=>{const h=new Uint8Array(16);for(let g=0;g<16;g++)h[g]=Math.round(Math.random()*256);const $=(0,P.$8e)(P.$Ne.wrap(h));return[`GET ws://localhost${w}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$nwb=C,e.$owb=P.$Ne.fromString(`\r
\r
`);async function k(w,S,m,h,$){w.write(P.$Ne.fromString((0,e.$nwb)(S,m,h)));const c=new N.$Uc;try{return await new Promise((g,b)=>{let f;c.add(w.onData(p=>{f?f=P.$Ne.concat([f,p],f.byteLength+p.byteLength):f=p;const I=f.indexOf(e.$owb);if(I===-1)return;g(w),w.pauseData();const d=f.slice(I+e.$owb.byteLength);d.byteLength&&$.onData.fire(d)})),c.add(w.onClose(p=>b(p??new Error("socket closed")))),c.add(w.onEnd(()=>b(new Error("socket ended"))))})}catch(g){throw w.dispose(),g}finally{c.dispose()}}class A extends N.$Vc{constructor(S,m){super(),this.g=S,this.a=this.B(new a.$oe),this.onData=(...h)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...h)),this.b=this.B(new a.$le),this.onDidDispose=this.b.event,this.f=!1,this.B(m.onData),this.B(m.onData.event(h=>this.a.fire(h))),this.onClose=this.B(m.onClose).event,this.onEnd=this.B(m.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,m){L.SocketDiagnostics.traceSocketEvent(this,this.g,S,m)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$qwb=A}),define(le[105],he([0,1,8,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=w,e.$Pl=(0,a.$Ei)("remoteAuthorityResolverService");var N;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class L{constructor(m){this.id=m,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=L;class C{constructor(m,h){this.host=m,this.port=h,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=C;var k;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class A extends P.$cb{static isNotAvailable(m){return m instanceof A&&m._code===k.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof A&&m._code===k.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof A&&m._code===k.NoResolverFound}static isInvalidAuthority(m){return m instanceof A&&m._code===k.InvalidAuthority}static isHandled(m){return m instanceof A&&m.isHandled}constructor(m,h=k.Unknown,$){super(m),this._message=m,this._code=h,this._detail=$,this.isHandled=h===k.NotAvailable&&$===!0,Object.setPrototypeOf(this,A.prototype)}}e.$Sl=A;function w(S){const m=S.indexOf("+");return m===-1?S:S.substring(0,m)}}),define(le[222],he([0,1,6,15,26,8,3,2,23,101,55,32,70,105]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Yl=y,e.$Zl=R,e.$1l=E,w=ke(w);const c=30*1e3;var g;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function b(J){switch(J){case g.Management:return"Management";case g.ExtensionHost:return"ExtensionHost";case g.Tunnel:return"Tunnel"}}function f(J){const H=new N.$we;return setTimeout(()=>H.cancel(),J),H.token}function p(J,H){if(J.isCancellationRequested||H.isCancellationRequested)return N.CancellationToken.Cancelled;const D=new N.$we;return J.onCancellationRequested(()=>D.cancel()),H.onCancellationRequested(()=>D.cancel()),D.token}class I{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new k.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,P.$xh)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function d(J,H){const D=new I(H);return D.registerDisposable(J.onControlMessage(B=>{const j=JSON.parse(B.toString()),W=z(j);W?D.reject(W):D.resolve(j)})),D.promise}function u(J,H,D,B,j,W,te,_){const Y=new I(_),ae=S.$fe.create(!1);return J.info(`Creating a socket (${te})...`),w.mark(`code/willCreateSocket/${W}`),H.connect(D,B,j,te).then(ue=>{Y.didTimeout?(w.mark(`code/didCreateSocketError/${W}`),J.info(`Creating a socket (${te}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(w.mark(`code/didCreateSocketOK/${W}`),J.info(`Creating a socket (${te}) was successful after ${ae.elapsed()} ms.`),Y.resolve(ue))},ue=>{w.mark(`code/didCreateSocketError/${W}`),J.info(`Creating a socket (${te}) returned an error after ${ae.elapsed()} ms.`),J.error(ue),Y.reject(ue)}),Y.promise}function t(J,H){const D=new I(H);return J.then(B=>{D.didTimeout||D.resolve(B)},B=>{D.didTimeout||D.reject(B)}),D.promise}async function s(J,H,D,B){const j=q(J,H);J.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let W;try{W=await u(J.logService,J.remoteSocketFactoryService,J.connectTo,A.$Rg.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,b(H),`renderer-${b(H)}-${J.reconnectionToken}`,B)}catch(ue){throw J.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let te,_;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(W,null),te=J.reconnectionProtocol,_=!1):(te=new h.$si({socket:W}),_=!0),J.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const Y=await t(J.signService.createNewMessage((0,m.$1g)()),B),ae={type:"auth",auth:J.connectionToken||"00000000000000000000",data:Y.data};te.sendControl(a.$Ne.fromString(JSON.stringify(ae)));try{const ue=await d(te,p(B,f(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(J.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(J.signService.validate(Y,ue.signedData),B)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const we=await t(J.signService.sign(ue.data),B),Ee={type:"connectionType",commit:J.commit,signedData:we,desiredConnectionType:H};return D&&(Ee.args=D),J.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(a.$Ne.fromString(JSON.stringify(Ee))),{protocol:te,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${j} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${j} received error control message when negotiating connection. Error:`),J.logService.error(ue)),_&&V(te),ue}}async function r(J,H,D,B){const j=Date.now(),W=q(J,H),{protocol:te,ownsProtocol:_}=await s(J,H,D,B),Y=new I(B);return Y.registerDisposable(te.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),ge=z(ue);ge?(J.logService.error(`${W} received error control message when negotiating connection. Error:`),J.logService.error(ge),_&&V(te),Y.reject(ge)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${x(j)}!`),Y.resolve({protocol:te,firstMessage:ue}))})),Y.promise}async function i(J,H){const{protocol:D}=await r(J,g.Management,void 0,H);return{protocol:D}}async function n(J,H,D){const{protocol:B,firstMessage:j}=await r(J,g.ExtensionHost,H,D),W=j&&j.debugPort;return{protocol:B,debugPort:W}}async function o(J,H,D){const B=Date.now(),j=q(J,g.Tunnel),{protocol:W}=await s(J,g.Tunnel,H,D);return J.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${x(B)}!`),W}async function l(J,H,D){const{connectTo:B,connectionToken:j}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:B,connectionToken:j,reconnectionToken:H,reconnectionProtocol:D,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function y(J,H,D){return O(J,async B=>{const{protocol:j}=await i(B,N.CancellationToken.None);return new G(J,H,D,B.reconnectionToken,j)})}async function R(J,H){return O(J,async D=>{const{protocol:B,debugPort:j}=await n(D,H,N.CancellationToken.None);return new ie(J,H,D.reconnectionToken,B,j)})}async function O(J,H){for(let B=1;;B++)try{const j=(0,m.$1g)(),W=await l(J,j,null);return await H(W)}catch(j){if(B<5)J.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(j);else throw J.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(j),Q.triggerPermanentFailure(0,0,$.$Sl.isHandled(j)),j}}async function E(J,H,D){const B=await l(J,(0,m.$1g)(),null);return await o(B,{host:H,port:D},N.CancellationToken.None)}function v(J){return(0,P.$rh)(H=>new Promise((D,B)=>{const j=setTimeout(D,J*1e3);H.onCancellationRequested(()=>{clearTimeout(j),D()})}))}var T;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(H,D){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.type=T.ConnectionLost}}e.$2l=U;class F{constructor(H,D,B,j){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.durationSeconds=B,this.c=j,this.type=T.ReconnectionWait}skipWait(){this.c.cancel()}}e.$3l=F;class M{constructor(H,D,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=T.ReconnectionRunning}}e.$4l=M;class X{constructor(H,D,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=T.ConnectionGain}}e.$5l=X;class K{constructor(H,D,B,j){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.handled=j,this.type=T.ReconnectionPermanentFailure}}e.$6l=K;class Q extends k.$Vc{static triggerPermanentFailure(H,D,B){this._permanentFailure=!0,this.f=H,this.g=D,this.h=B,this.j.forEach(j=>j.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(H,D,B,j,W){super(),this.t=H,this.u=D,this.reconnectionToken=B,this.protocol=j,this.w=W,this.m=this.B(new C.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(j.onSocketClose(te=>{const _=ce(this.t,this.reconnectionToken,!0);te?te.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${_} received socket close event (hadError: ${te.hadError}).`),te.error&&this.u.logService.error(te.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.u.logService.error(te.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(j.onSocketTimeout(te=>{const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,k.$Tc)(()=>{const te=Q.j.indexOf(this);te>=0&&Q.j.splice(te,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const j=B<D.length?D[B]:D[D.length-1];try{if(j>0){const te=v(j);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,te)),this.u.logService.info(`${H} waiting for ${j} seconds before reconnecting...`);try{await te}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${H} resolving connection...`);const W=await l(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${W.connectTo}...`),await this.G(W,f(c)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if($.$Sl.isTemporarilyNotAvailable(W)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((0,L.$5)(W)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if(W instanceof $.$Sl){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,$.$Sl.isHandled(W));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(H,D,B){this.w?Q.triggerPermanentFailure(H,D,B):this.D(H,D,B)}D(H,D,B){this.m.fire(new K(this.reconnectionToken,H,D,B)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7l=Q;class G extends Q{constructor(H,D,B,j,W){super(g.Management,H,j,W,!0),this.client=this.B(new h.$qi(W,{remoteAuthority:D,clientId:B},H.ipcLogger))}async G(H,D){await i(H,D)}}e.$8l=G;class ie extends Q{constructor(H,D,B,j,W){super(g.ExtensionHost,H,B,j,!1),this.H=D,this.debugPort=W}async G(H,D){await n(H,this.H,D)}}e.$9l=ie;function V(J){try{J.acceptDisconnect();const H=J.getSocket();J.dispose(),H.dispose()}catch(H){(0,L.$2)(H)}}function z(J){if(J&&J.type==="error"){const H=new Error(`Connection error: ${J.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function ee(J,H){for(;J.length<H;)J+=" ";return J}function re(J,H){return`[remote-connection][${ee(b(J),13)}][${H.substr(0,5)}\u2026]`}function ce(J,H,D){return`${re(J,H)}[${D?"reconnect":"initial"}]`}function q(J,H){return`${ce(H,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function x(J){return`${Date.now()-J} ms`}}),define(le[106],he([0,1,23]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=a,e.$gn=N,e.$hn=L,e.$in=C;function a(A){return A.scheme===P.Schemas.vscodeRemote?A.authority:void 0}function N(A){if(!A)return;const w=A.indexOf("+");return w<0?A:A.substr(0,w)}function L(A){const{host:w,port:S}=k(A);if(typeof S>"u")throw new Error(`Invalid remote authority: ${A}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:S}}function C(A,w){let{host:S,port:m}=k(A);return typeof m>"u"&&(m=w),{host:S,port:m}}function k(A){const w=A.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const S=A.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=A.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:A,port:void 0}}}),define(le[37],he([0,1,27,4,106]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=L,e.$sn=m,e.$tn=h,e.$un=$,e.$vn=c,P=ke(P),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function L(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$on=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(C||(e.ExtensionType=C={}));var k;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class A{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,f){if(typeof b>"u"||b===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof b=="string"||typeof f=="string"){const p=typeof b=="string"?b:b.value,I=typeof f=="string"?f:f.value;return P.$Ff(p,I)}return b._lower===f._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$pn=A;class w{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const f of b)this.add(f)}add(b){this.c.add(A.toKey(b))}delete(b){return this.c.delete(A.toKey(b))}has(b){return this.c.has(A.toKey(b))}}e.$qn=w;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(A.toKey(b))}get(b){return this.c.get(A.toKey(b))}has(b){return this.c.has(A.toKey(b))}set(b,f){this.c.set(A.toKey(b),f)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=S;function m(g){return h(g)}function h(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function $(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function c(g,b){if(b){const f=`onResolveRemoteAuthority:${(0,N.$gn)(b)}`;return!!g.activationEvents?.includes(f)}return!1}e.$wn=(0,a.$Ei)("IBuiltinExtensionsScannerService")}),define(le[28],he([0,1,5,163,37,4]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=k,e.$bp=A,e.$cp=w,e.$dp=S,e.$ep=m,e.$fp=h,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var C;(function(u){u.COMMAND="command",u.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function k(u){switch(u){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function A(u){switch(u){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function w(u,t){switch(u){case P.Platform.Windows:return t==="x64"?N.TargetPlatform.WIN32_X64:t==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Linux:return t==="x64"?N.TargetPlatform.LINUX_X64:t==="arm64"?N.TargetPlatform.LINUX_ARM64:t==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?N.TargetPlatform.ALPINE_X64:t==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Mac:return t==="x64"?N.TargetPlatform.DARWIN_X64:t==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Web:return N.TargetPlatform.WEB}}function S(u,t){return t===N.TargetPlatform.WEB&&!u.includes(N.TargetPlatform.WEB)}function m(u,t,s){return S(t,s)?!1:u===N.TargetPlatform.UNDEFINED||u===N.TargetPlatform.UNIVERSAL?!0:u===N.TargetPlatform.UNKNOWN?!1:u===s}function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var $;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var c;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var b;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$gp=(0,L.$Ei)("extensionGalleryService");var f;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed",u.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class p extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$hp=p;var I;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.DownloadFailedWriting="DownloadFailedWriting",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.ScanningExtension="ScanningExtension",u.ReadUninstalled="ReadUninstalled",u.UnsetUninstalled="UnsetUninstalled",u.Delete="Delete",u.Rename="Rename",u.IntializeDefaultProfile="IntializeDefaultProfile",u.AddToProfile="AddToProfile",u.InstalledExtensionNotFound="InstalledExtensionNotFound",u.PostInstall="PostInstall",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class d extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$ip=d,e.$jp=(0,L.$Ei)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,L.$Ei)("IGlobalExtensionEnablementService"),e.$np=(0,L.$Ei)("IExtensionTipsService"),e.$op=(0,a.localize2)(0,"Extensions"),e.$pp=(0,a.localize2)(1,"Preferences")}),define(le[223],he([0,1,3,2,30,9,95,28]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=void 0;function A(b,f){return b?L.URI.revive(f?f.transformIncoming(b):b):void 0}function w(b,f){return f?f.transformOutgoingURI(b):b}function S(b,f){f=f||C.$Jn;const p=b.manifest;return{...(0,C.$Mn)({...b,manifest:void 0},f),manifest:p}}function m(b,f){return b?.profileLocation?(0,C.$Mn)(b,f??C.$Jn):b}function h(b,f){return f?(0,N.$do)(b,p=>p instanceof L.URI?f.transformOutgoingURI(p):void 0):b}class ${constructor(f,p){this.a=f,this.b=p,this.onInstallExtension=P.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,p){const I=this.b(f);switch(p){case"onInstallExtension":return P.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?w(d.profileLocation,I):d.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,d=>d.map(u=>({...u,local:u.local?h(u.local,I):u.local,profileLocation:u.profileLocation?w(u.profileLocation,I):u.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?w(d.profileLocation,I):d.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?w(d.profileLocation,I):d.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,d=>({local:h(d.local,I),profileLocation:w(d.profileLocation,I)}))}throw new Error("Invalid listen")}async call(f,p,I){const d=this.b(f);switch(p){case"zip":{const u=S(I[0],d),t=await this.a.zip(u);return w(t,d)}case"unzip":return this.a.unzip(A(I[0],d));case"install":return this.a.install(A(I[0],d),m(I[1],d));case"installFromLocation":return this.a.installFromLocation(A(I[0],d),A(I[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(I[0],A(I[1],d),A(I[2],d));case"getManifest":return this.a.getManifest(A(I[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(I[0]);case"installFromGallery":return this.a.installFromGallery(I[0],m(I[1],d));case"installGalleryExtensions":{const u=I[0];return this.a.installGalleryExtensions(u.map(({extension:t,options:s})=>({extension:t,options:m(s,d)??{}})))}case"uninstall":return this.a.uninstall(S(I[0],d),m(I[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(I[0],d));case"getInstalled":return(await this.a.getInstalled(I[0],A(I[1],d),I[2])).map(t=>h(t,d));case"toggleAppliationScope":{const u=await this.a.toggleAppliationScope(S(I[0],d),A(I[1],d));return h(u,d)}case"copyExtensions":return this.a.copyExtensions(A(I[0],d),A(I[1],d));case"updateMetadata":{const u=await this.a.updateMetadata(S(I[0],d),I[1],A(I[2],d));return h(u,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(I[0],I[1],I[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$qq=$;class c extends a.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new P.$le),this.f=this.B(new P.$le),this.g=this.B(new P.$le),this.h=this.B(new P.$le),this.j=this.B(new P.$le),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?L.URI.revive(p.source):p.source,profileLocation:L.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(I=>({...I,local:I.local?S(I.local,null):I.local,source:this.r(I.source)?L.URI.revive(I.source):I.source,profileLocation:L.URI.revive(I.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:L.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:L.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.n(this.j,{profileLocation:L.URI.revive(p.profileLocation),local:S(p.local,null)})))}n(f,p){f.fire(p)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const p=await this.getTargetPlatform();return f.allTargetPlatforms.some(I=>(0,k.$ep)(I,f.allTargetPlatforms,p))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(p=>L.URI.revive(p)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,p){return Promise.resolve(this.m.call("install",[f,p])).then(I=>S(I,null))}installFromLocation(f,p){return Promise.resolve(this.m.call("installFromLocation",[f,p])).then(I=>S(I,null))}async installExtensionsFromProfile(f,p,I){return(await this.m.call("installExtensionsFromProfile",[f,p,I])).map(u=>S(u,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,p){return Promise.resolve(this.m.call("installFromGallery",[f,p])).then(I=>S(I,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(I=>({...I,local:I.local?S(I.local,null):I.local,source:this.r(I.source)?L.URI.revive(I.source):I.source,profileLocation:L.URI.revive(I.profileLocation)}))}uninstall(f,p){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,p]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(p=>S(p,null))}getInstalled(f=null,p,I){return Promise.resolve(this.m.call("getInstalled",[f,p,I])).then(d=>d.map(u=>S(u,null)))}updateMetadata(f,p,I){return Promise.resolve(this.m.call("updateMetadata",[f,p,I])).then(d=>S(d,null))}toggleAppliationScope(f,p){return this.m.call("toggleAppliationScope",[f,p]).then(I=>S(I,null))}copyExtensions(f,p){return this.m.call("copyExtensions",[f,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,p,I){const d=await this.m.call("download",[f,p,I]);return L.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$rq=c;class g{constructor(f){this.a=f}listen(f,p){throw new Error("Invalid listen")}call(f,p,I){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$sq=g}),define(le[224],he([0,1,2,37,7]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class L extends P.$Vc{constructor(k,A,w,S,m){super(),this.a=k,this.b=A,this.c=w,this.f=m,this.B(S.onDidInstallExtensions(h=>this.g(h))),this.B(S.onDidUninstallExtension(h=>this.h(h)))}g(k){for(const A of k)A.local&&this.invalidate(A.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const A of this.a.profiles)this.c.extUri.isEqual(A.extensionsResource,k)&&await this.j(A);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,a.$jn))}catch(A){(0,N.$pl)(A)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(A)}}}e.$Pq=L}),define(le[79],he([0,1,26,2,5,173,28,4]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=void 0,e.$4r=A;function A(S){return S.tags.find(m=>m.startsWith("lp-"))?.split("lp-")[1]}e.$5r=(0,k.$Ei)("languagePackService");let w=class extends a.$Vc{constructor(m){super(),this.c=m}async getAvailableLanguages(){const m=new P.$we;setTimeout(()=>m.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const c=h.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(b=>b.startsWith("lp-"))).map(g=>{const b=g.properties.localizedLanguages?.[0],f=A(g);return{...this.f(f,b,g),extensionId:g.identifier.id,galleryExtension:g}});return c.push(this.f("en","English")),c}f(m,h,$){const c=h??m;let g;if(c!==m&&(g=`(${m})`),m.toLowerCase()===N.$w.toLowerCase()&&(g??="",g+=(0,L.localize)(0,null)),$?.installCount){g??="";const b=$.installCount;let f;b>1e6?f=`${Math.floor(b/1e5)/10}M`:b>1e3?f=`${Math.floor(b/1e3)}K`:f=String(b),g+=` $(cloud-download) ${f}`}return{id:m,label:c,description:g}}};e.$6r=w,e.$6r=w=ve([Z(0,C.$gp)],w)}),define(le[225],he([0,1,2,79]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;let N=class extends P.$Vc{constructor(C){super(),this.a=C,this.b()}b(){this.a.update()}};e.$7fc=N,e.$7fc=N=ve([Z(0,a.$5r)],N)}),define(le[107],he([0,1,2,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul=(0,a.$Ei)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(C,k){return this.a[C]??=[],this.a[C].push(k),(0,P.$Tc)(()=>{const A=this.a[C]?.indexOf(k);typeof A=="number"&&A>=0&&this.a[C]?.splice(A,1)})}b(C){return(this.a[C.type]||[]).find(A=>A.supports(C))}connect(C,k,A,w){const S=this.b(C);if(!S)throw new Error(`No socket factory found for ${C}`);return S.connect(C,k,A,w)}}e.$Vl=N}),define(le[226],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=void 0,e.$hgc=(0,P.$Ei)("sharedProcessTunnelService"),e.$igc="sharedProcessTunnel"}),define(le[108],he([0,1,4,175]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=e.$qgc=e.$pgc=e.$ogc=e.TunnelStates=e.$ngc=e.$mgc=void 0,e.$mgc=(0,P.$Ei)("IRemoteTunnelService"),e.$ngc={active:!1};var N;(function(L){L.disconnected=C=>({type:"disconnected",onTokenFailed:C}),L.connected=(C,k)=>({type:"connected",info:C,serviceInstallFailed:k}),L.connecting=C=>({type:"connecting",progress:C}),L.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$ogc="remote.tunnels.access",e.$pgc=e.$ogc+".hostNameOverride",e.$qgc=e.$ogc+".preventSleep",e.$rgc="remoteTunnelService",e.$sgc=(0,a.localize)(0,null)}),define(le[61],he([0,1,15,8,2,177,48,4,10,44]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=h,e.$4p=$,e.$5p=c,e.$6p=g,e.$7p=b,e.$8p=f,e.$1p=(0,k.$Ei)("requestService");class S{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class m extends N.$Vc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,L.localize)(0,null),when:A.$qk.isEqualTo((0,A.$nk)(A.LogLevel.Trace)).serialize()})}async c(u,t,s){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new S(t.headers??{}));try{const i=await s();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,a.$$)(i)),i}}}e.$2p=m;function h(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function $(d){return d.res.statusCode===204}async function c(d){return $(d)?null:(await(0,P.$Ze)(d.stream)).toString()}async function g(d){if(!h(d))throw new Error("Server returned "+d.res.statusCode);return c(d)}async function b(d){if(!h(d))throw new Error("Server returned "+d.res.statusCode);if($(d))return null;const t=(await(0,P.$Ze)(d.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function f(d){I(d)}let p;function I(d){const u=w.$oo.as(C.$to.Configuration),t=p;p={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[p],remove:t?[t]:[]})}I(C.ConfigurationScope.APPLICATION)}),define(le[227],he([0,1,26,23,7,61]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=void 0;let C=class{constructor(A,w){this.a=A,this.b=w}async download(A,w,S=P.CancellationToken.None){if(A.scheme===a.Schemas.file||A.scheme===a.Schemas.vscodeRemote){await this.b.copy(A,w);return}const m={type:"GET",url:A.toString(!0)},h=await this.a.request(m,S);if(h.res.statusCode===200)await this.b.writeFile(w,h.stream);else{const $=await(0,L.$6p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${$}`)}}};e.$0Q=C,e.$0Q=C=ve([Z(0,L.$1p),Z(1,N.$$k)],C)}),define(le[228],he([0,1,15,26]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=void 0;class N{constructor(k){this.a=k}listen(k,A){throw new Error("Invalid listen")}call(k,A,w,S=a.CancellationToken.None){switch(A){case"request":return this.a.request(w[0],S).then(async({res:m,stream:h})=>{const $=await(0,P.$Ze)(h);return[{statusCode:m.statusCode,headers:m.headers},$]});case"resolveProxy":return this.a.resolveProxy(w[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$8r=N;class L{constructor(k){this.a=k}async request(k,A){const[w,S]=await this.a.call("request",[k],A);return{res:w,stream:(0,P.$2e)(S)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$9r=L}),define(le[229],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=e.$Rec=void 0,e.$Rec={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Sec={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Tec={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[230],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const L=await this.c();if(L){const C=String(P.a++);return this.b.set(C,L),{id:C,data:L.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,L){if(!N.id)return!0;const C=this.b.get(N.id);if(!C)return!1;this.b.delete(N.id);try{return C.validate(L)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$Eac=P}),define(le[109],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl="signService",e.$Xl=(0,P.$Ei)(e.$Wl)}),define(le[231],he([0,1,230]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class a extends P.$Eac{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(C=>new C.signer().sign(L))}h(){return new Promise((L,C)=>ne(["vsda"],L,C))}}e.$Jfc=a}),define(le[80],he([0,1,3,2]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ULb=e.$TLb=e.$SLb=e.$RLb=void 0;class N extends a.$Vc{constructor(m,h,$){super(),this.a=m,this.b=h,this.c=$}async getItems(){const m={profile:this.b,workspace:this.c},h=await this.a.call("getItems",m);return new Map(h)}updateItems(m){const h={profile:this.b,workspace:this.c};return m.insert&&(h.insert=Array.from(m.insert.entries())),m.delete&&(h.delete=Array.from(m.delete.values())),this.a.call("updateItems",h)}optimize(){const m={profile:this.b,workspace:this.c};return this.a.call("optimize",m)}}class L extends N{constructor(m,h){super(m,h,void 0),this.f=this.B(new P.$le),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(m=>this.h(m)))}h(m){(Array.isArray(m.changed)||Array.isArray(m.deleted))&&this.f.fire({changed:m.changed?new Map(m.changed):void 0,deleted:m.deleted?new Set(m.deleted):void 0})}}class C extends L{constructor(m){super(m,void 0)}async close(){this.dispose()}}e.$RLb=C;class k extends L{constructor(m,h){super(m,h)}async close(){this.dispose()}}e.$SLb=k;class A extends N{constructor(m,h){super(m,void 0,h),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.$TLb=A;class w{constructor(m){this.a=m}isUsed(m){const h={payload:m,profile:void 0,workspace:void 0};return this.a.call("isUsed",h)}}e.$ULb=w}),define(le[110],he([0,1,5,36,32]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=C,e.$rp=k;function L(A){if(P.$u===P.Platform.Linux&&/^penguin(\.|$)/i.test(A))return"chromebook"}function C(A,w,S,m,h,$,c,g,b,f){const p=Object.create(null);p["common.machineId"]=$,p["common.sqmId"]=c,p["common.devDeviceId"]=g,p.sessionID=(0,N.$1g)()+Date.now(),p.commitHash=m,p.version=h,p["common.platformVersion"]=(A||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,P.$h)(P.$u),p["common.nodePlatform"]=a.$ec,p["common.nodeArch"]=S,p["common.product"]=f||"desktop",b&&(p["common.msftInternal"]=b);let I=0;const d=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),P.$l&&(p["common.snap"]="true");const u=L(w);return u&&(p["common.platformDetail"]=u),p}function k(A){const w=a.env.USERDNSDOMAIN;if(!w)return!1;const S=w.toLowerCase();return A.some(m=>S===m)}}),define(le[18],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,P.$Ei)("telemetryService"),e.$$l=(0,P.$Ei)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var a;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var N;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(le[232],he([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Rs=p,e.$Ss=d,e.$Ts=u,P=ke(P);const f=new Map;async function p(s,r){const i=`${s}::${r.join(":")}`,n=f.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,y=new Map,R=2e4;function O(v,T,U,F){const M=T.substring(v.length+1);return a.Promises.withAsyncBody(async X=>{let K;F.readdirCount++;try{K=await m.Promises.readdir(T,{withFileTypes:!0})}catch{X();return}if(F.count>=R){F.count+=K.length,F.maxReached=!0,X();return}let Q=K.length;if(Q===0){X();return}let G=K;F.count+K.length>R&&(F.maxReached=!0,Q=R-F.count,G=K.slice(0,Q)),F.count+=K.length;for(const ie of G)if(ie.isDirectory()){if(U.includes(ie.name)||await O(v,(0,C.$kc)(T,ie.name),U,F),--Q===0){X();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const z=ie.name.substring(V+1);z&&l.set(z,(l.get(z)??0)+1)}for(const z of o)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test(ie.name)&&y.set(z.tag,(y.get(z.tag)??0)+1);if(--Q===0){X();return}}})}const E=a.Promises.withAsyncBody(async v=>{const T={count:0,maxReached:!1,readdirCount:0},U=new A.$fe(!0);await O(s,s,r,T);const F=await u(s);v({configFiles:I(y),fileTypes:I(l),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:F,totalScanTime:U.elapsed(),totalReaddirCount:T.readdirCount})});return f.set(i,E),E}function I(s){return Array.from(s.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function d(){const s={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/c.$Gl.GB).toFixed(2)}GB (${(P.freemem()/c.$Gl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.$On.value()*100)}%`},r=P.cpus();return r&&r.length>0&&(s.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),s}async function u(s){try{const r=new Map,i=(0,C.$kc)(s,".vscode","launch.json"),n=await m.Promises.readFile(i),o=[],l=(0,N.$Un)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,N.$4n)(l)==="object"&&l.configurations)for(const y of l.configurations){const R=y.type;R&&(r.has(R)?r.set(R,r.get(R)+1):r.set(R,1))}return I(r)}catch{return[]}}let t=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/c.$Gl.GB).toFixed(2)}GB (${(P.freemem()/c.$Gl.GB).toFixed(2)}GB free)`),k.$i||i.push(`Load (avg):       ${P.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(S.$On.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,h.$Qs)(r.mainPID),this.k(r)]).then(async n=>{let[o,l]=n,y=this.m(r,o);return i.forEach(R=>{if((0,$.$Sm)(R))y+=`
${R.errorMessage}`,l+=`
${R.errorMessage}`;else if(y+=`

Remote: ${R.hostName}`,R.processes&&(y+=`
${this.m(r,R.processes)}`),R.workspaceMetadata){l+=`
|  Remote: ${R.hostName}`;for(const O of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[O];let v=`${E.fileCount} files`;E.maxFilesReached&&(v=`more than ${v}`),l+=`|    Folder (${O}): ${v}`,l+=this.h(E)}}}),{processInfo:y,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:n,vmHint:o,os:l,cpus:y}=d(),R={os:l,memory:n,cpus:y,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return k.$i||(R.load=`${P.loadavg().map(O=>Math.round(O)).join(", ")}`),k.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(r,i){const n=[];return(0,h.$Qs)(r.mainPID).then(async o=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,o)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),i.forEach(l=>{if((0,$.$Sm)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.f(l.machineInfo)),l.processes&&n.push(this.m(r,l.processes)),l.workspaceMetadata)for(const y of Object.keys(l.workspaceMetadata)){const R=l.workspaceMetadata[y];let O=`${R.fileCount} files`;R.maxFilesReached&&(O=`more than ${O}`),n.push(`Folder (${y}): ${O}`),n.push(this.h(R))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const i=[];let o=0;const l=(E,v)=>{const T=` ${E}(${v})`;o+T.length>60?(i.push(y),y="|                 ",o=y.length):o+=T.length,y+=T};let y="|      File types:";const R=10,O=r.fileTypes.length>R?R:r.fileTypes.length;for(let E=0;E<O;E++){const v=r.fileTypes[E];l(v.name,v.count)}if(i.push(y),r.configFiles.length>=0&&(y="|      Conf files:",o=0,r.configFiles.forEach(E=>{l(E.name,E.count)}),i.push(y)),r.launchConfigFiles.length>0){let E="|      Launch Configs:";r.launchConfigFiles.forEach(v=>{const T=v.count>1?` ${v.name}(${v.count})`:` ${v.name}`;E+=T}),i.push(E)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const i=[],n=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const y=w.URI.revive(l);if(y.scheme===L.Schemas.file){const R=y.fsPath;n.push(p(R,["node_modules",".git"]).then(O=>{let E=`${O.fileCount} files`;O.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,C.$oc)(R)}): ${E}`),i.push(this.h(O))}).catch(O=>{i.push(`|      Error: Unable to collect workspace stats for folder ${R} (${O.toString()})`)}))}else i.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,i){const n=new Map;r.windows.forEach(l=>n.set(l.pid,`window [${l.id}] (${l.title})`)),r.pidToNames.forEach(({pid:l,name:y})=>n.set(l,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,n,o,i,0),o.join(`
`)}n(r,i,n,o,l){const y=l===0;let R;y?R=o.pid===r?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?R=i.get(o.pid):R=`${"  ".repeat(l)} ${o.name}`;const O=process.platform==="win32"?o.mem:P.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(O/c.$Gl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(o.children)&&o.children.forEach(E=>this.n(r,i,n,E,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:n}of r.folders){const o=w.URI.revive(n);if(o.scheme!==L.Schemas.file)continue;const l=o.fsPath;try{(await p(l,["node_modules",".git"])).fileTypes.forEach(R=>i.add(R.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const n=w.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const o=n.fsPath;try{const l=await p(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:l.totalScanTime,reachedLimit:l.maxFilesReached,fileCount:l.fileCount,readdirCount:l.totalReaddirCount})}catch{}}}};e.$Us=t,e.$Us=t=ve([Z(0,b.$0l),Z(1,g.$rk)],t)}),define(le[111],he([0,1,8,4,10,18]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=e.ExtensionSignatureVerificationCode=e.$mq=void 0,e.$mq=(0,a.$Ei)("IExtensionSignatureVerificationService");var C;(function(w){w.Success="Success",w.RequiredArgumentMissing="RequiredArgumentMissing",w.InvalidArgument="InvalidArgument",w.PackageIsUnreadable="PackageIsUnreadable",w.UnhandledException="UnhandledException",w.SignatureManifestIsMissing="SignatureManifestIsMissing",w.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",w.SignatureIsMissing="SignatureIsMissing",w.SignatureIsUnreadable="SignatureIsUnreadable",w.CertificateIsUnreadable="CertificateIsUnreadable",w.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",w.FileAlreadyExists="FileAlreadyExists",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",w.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",w.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",w.SignatureIsInvalid="SignatureIsInvalid",w.SignatureManifestIsInvalid="SignatureManifestIsInvalid",w.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",w.EntryIsMissing="EntryIsMissing",w.EntryIsTampered="EntryIsTampered",w.Untrusted="Untrusted",w.CertificateRevoked="CertificateRevoked",w.SignatureIsNotValid="SignatureIsNotValid",w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(C||(e.ExtensionSignatureVerificationCode=C={}));class k extends Error{constructor(S){super(S),this.code=S}}e.$nq=k;let A=class{constructor(S,m){this.b=S,this.c=m}d(){return this.a||(this.a=new Promise((S,m)=>ne(["@vscode/vsce-sign"],async h=>S(h),m))),this.a}async verify(S,m,h,$){let c;const g=S.identifier.id;try{c=await this.d()}catch(I){return this.b.error("Could not load vsce-sign module",(0,P.$$)(I)),this.b.info(`Extension signature verification is not done: ${g}`),!1}const b=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${g}...`),f=await c.verify(m,h,this.b.getLevel()===N.LogLevel.Trace)}catch(I){f={code:C.UnknownError,didExecute:!1,output:(0,P.$$)(I)}}const p=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${g}: ${f.code}. Executed: ${f.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${g}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:g,extensionVersion:S.version,code:f.code,internalCode:f.internalCode,duration:p,didExecute:f.didExecute,clientTargetPlatform:$}),f.code===C.Success)return!0;throw new k(f.code)}};e.$oq=A,e.$oq=A=ve([Z(0,N.$$j),Z(1,L.$0l)],A)}),define(le[112],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=void 0;class P{constructor(L){this.b=L}listen(L,C){throw new Error(`Event not found: ${C}`)}call(L,C,{eventName:k,data:A}){return this.b.forEach(w=>w.log(k,A)),Promise.resolve(null)}}e.$Wec=P;class a{constructor(L){this.b=L}log(L,C){return this.b.call("log",{eventName:L,data:C}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Xec=a}),define(le[49],he([0,1,30,13,106,110,18]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=S,e.$Ap=m,e.$Bp=h,e.$Cp=$,e.$Dp=g,e.$Ep=f,e.$Fp=p,e.$Gp=u;class k{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$sp=k;class A{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=A,e.$up=new A;class w{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.$vp=w,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function S(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function m(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function h(t){const s=t.getValue(C.$gm),r=t.getValue(C.$hm);if(t.getValue(C.$im)===!1||r===!1)return C.TelemetryLevel.NONE;switch(s??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function $(t){const s={},r={},i={};b(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(t){if(!t)return"none";const s=(0,N.$gn)(t);return c.has(s)?s:"other"}function b(t,s,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const o=t[n],l=i?i+n:n;Array.isArray(o)?s[l]=(0,P.$go)(o):o instanceof Date?s[l]=o.toISOString():(0,a.$gg)(o)?r<2?b(o,s,r+1,l+"."):s[l]=(0,P.$go)(o):s[l]=o}}function f(t,s){const r=t.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,L.$rp)(r)||i}function p(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function I(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const y of s)for(;;){const R=y.exec(t);if(!R)break;i.push([R.index,y.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const y=o.exec(t);if(!y)break;const R=i.some(([O,E])=>y.index<E&&O<o.lastIndex);!n.test(y[0])&&!R&&(r+=t.substring(l,y.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<t.length&&(r+=t.substr(l)),r}function d(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function u(t,s){return(0,P.$do)(t,r=>{if(r instanceof k||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=I(i,s);for(const n of s)i=i.replace(n,"");return i=d(i),i}})}}),define(le[33],he([0,1,27,28,37,5,9,8,36,49]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=S,e.$Jp=c,e.$Kp=g,e.$Lp=b,e.$Mp=f,e.$Np=p,e.$Op=I,e.$Pp=d,e.$Rp=u,e.$Sp=s;function S(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$Af)(r.id,i.id)===0}const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new h(i.identifier,n,o)}static parse(i){const n=m.exec(i);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o=N.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof h?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Ip=h;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(r){const i=$.exec(r);return i&&i[1]?[b(i[1]),i[2]]:[b(r),void 0]}function g(r,i){return`${r}.${i}`}function b(r){return r.toLowerCase()}function f(r,i){return b(g(r??N.$ln,i))}function p(r,i){const n=[],o=l=>{for(const y of n)if(y.some(R=>S(i(R),i(l))))return y;return null};for(const l of r){const y=o(l);y?y.push(l):n.push([l])}return n}function I(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function d(r){return{id:new w.$sp(r.identifier.id),name:new w.$sp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Qp=new N.$pn("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(y=>!S(y.identifier,{id:l}))){const y=r.filter(R=>S(R.identifier,{id:l}));y.length===1&&(n.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(r,i){if(!L.$k)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,k.$$)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,i){const n=await t(r,i),o=(0,a.$cp)(n?"alpine":L.$u,A.$fc);return i.debug("ComputeTargetPlatform:",o),o}}),define(le[233],he([0,1,26,28,33,37]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=C;async function C(k,A,w,S,m){try{const h=await k.getExtensionsControlManifest();if(!h.deprecated)return;const $=await k.getInstalled(L.ExtensionType.User);for(const[c,g]of Object.entries(h.deprecated)){if(!g?.extension)continue;const{id:b,autoMigrate:f,preRelease:p}=g.extension;if(!f)continue;const I=$.find(u=>(0,N.$Hp)(u.identifier,{id:c}));if(!I)continue;const d=(await A.getExtensions([{id:b,preRelease:p}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!d){m.info(`Skipping migrating '${I.identifier.id}' extension because, the comaptible target '${b}' extension is not found`);continue}try{m.info(`Migrating '${I.identifier.id}' extension to '${b}' extension...`);const u=!S.getDisabledExtensions().some(s=>(0,N.$Hp)(s,I.identifier));await k.uninstall(I),m.info(`Uninstalled the unsupported extension '${I.identifier.id}'`);let t=$.find(s=>(0,N.$Hp)(s.identifier,{id:b}));(!t||!t.isPreReleaseVersion&&u)&&(t=await k.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:I.isMachineScoped,operation:a.InstallOperation.Migrate}),m.info(`Installed the pre-release extension '${t.identifier.id}'`),u||(await S.disableExtension(t.identifier),m.info(`Disabled the pre-release extension '${t.identifier.id}' because the unsupported extension '${I.identifier.id}' is disabled`)),f.storage&&(w.addToMigrationList((0,N.$Kp)(I.manifest.publisher,I.manifest.name),(0,N.$Kp)(t.manifest.publisher,t.manifest.name)),m.info("Added pre-release extension to the storage migration list"))),m.info(`Migrated '${I.identifier.id}' extension to '${b}' extension.`)}catch(u){m.error(u)}}}catch(h){m.error(h)}}}),define(le[234],he([0,1,3,2,35,33,37,7]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class A extends a.$Vc{constructor(S,m,h,$,c,g,b){super(),this.f=S,this.g=m,this.h=h,this.j=$,this.m=c,this.n=g,this.r=b,this.a=this.B(new P.$le),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new a.$5c),this.s().then(null,f=>b.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map(m=>(this.c.set(m.id,(0,a.$Sc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(S){for(const m of S.extensions)this.I(this.L(m.identifier,m.version),S.profileLocation)}async y(S){for(const m of S.extensions){const h=this.L(m.identifier,m.version);S.error?this.J(h,S.profileLocation):this.I(h,S.profileLocation)}}async z(S){for(const m of S.extensions)this.J(this.L(m.identifier,m.version),S.profileLocation)}async C(S){const m=[],h=[];for(const $ of S.extensions){const c=this.L($.identifier,$.version);S.error?this.I(c,S.profileLocation):(this.J(c,S.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),h.push(this.f.scanInstalledExtensionAtLocation($.location).then(g=>{g?m.push(g):this.r.info("Extension not found at the location",$.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(h),m.length&&await this.H(m)}catch($){this.r.error($)}}D(S){for(const m of this.h.profiles)S.contains(m.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(S){const m=[],h=[],$=await this.j.scanProfileExtensions(S),c=new Set,g=new Set;for(const[b,f]of this.b)f.has(S)&&g.add(b);for(const b of $){const f=this.L(b.identifier,b.version);c.add(f),g.has(f)||(m.push(b.identifier),this.I(f,S))}for(const b of g)if(!c.has(b)){const f=this.M(b);f&&(h.push(f.identifier),this.J(b,S))}(m.length||h.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:S}:void 0,removed:h.length?{extensions:h,profileLocation:S}:void 0})}async G(S){const m=await this.j.scanProfileExtensions(S);for(const h of m)this.I(this.L(h.identifier,h.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,m){let h=this.b.get(S);h||this.b.set(S,h=new N.$Cc($=>this.m.extUri.getComparisonKey($))),h.add(m)}J(S,m){const h=this.b.get(S);h&&h.delete(m),h?.size||this.b.delete(S)}L(S,m){return`${C.$pn.toKey(S.id)}@${m}`}M(S){const[m,h]=(0,L.$Jp)(S);return h?{identifier:{id:m},version:h}:void 0}}e.$Qq=A}),define(le[235],he([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;let g=class extends $.$6r{constructor(I,d,u,t){super(u),this.h=I,this.j=t,this.g=this.B(new b(d,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(I,d){const t=(await this.g.getLanguagePacks())[d];if(!t){this.j.warn(`No language pack found for ${d}`);return}const s=t.translations[I];return s?c.URI.file(s):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),d=Object.keys(I).map(u=>{const t=I[u];return{...this.f(u,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((u,t)=>u.label.localeCompare(t.label)),d}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const d=await this.g.getLanguagePacks();Object.keys(d).some(u=>d[u]&&d[u].extensions.some(t=>(0,m.$Hp)(t.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(d);return!(0,a.$vb)(Object.keys(I),Object.keys(u))}};e.$7r=g,e.$7r=g=ve([Z(0,S.$jp),Z(1,w.$Mi),Z(2,S.$gp),Z(3,h.$$j)],g);let b=class extends L.$Vc{constructor(I,d){super(),this.j=d,this.c={},this.f=(0,k.$kc)(I.userDataPath,"languagepacks.json"),this.g=new N.$Lh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(d=>{Object.keys(d).forEach(u=>delete d[u]),this.m(d,...I)}).then(()=>this.c)}m(I,...d){for(const u of d)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(I,u);Object.keys(I).forEach(u=>this.r(I[u]))}n(I,d){const u=d.identifier,t=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const s of t)if(d.location.scheme===C.Schemas.file&&f(s)){let r=I[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},I[s.languageId]=r);const i=r.extensions.filter(n=>(0,m.$Hp)(n.extensionIdentifier,u))[0];i?i.version=d.manifest.version:r.extensions.push({extensionIdentifier:u,version:d.manifest.version});for(const n of s.translations)r.translations[n.id]=(0,k.$kc)(d.location.fsPath,n.path)}}r(I){if(I){const d=(0,P.createHash)("md5");for(const u of I.extensions)d.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);I.hash=d.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let d=null;return A.Promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(d=I(u),u)).then(u=>{for(const s of Object.keys(u))u[s]||delete u[s];this.c=u,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),A.Promises.writeFile(this.f,t)}).then(()=>d,u=>this.j.error(u))})}};b=ve([Z(0,w.$Mi),Z(1,h.$$j)],b);function f(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const I of p.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(le[236],he([0,1,149,8,30,49]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function A(S,m,h){const $=await(0,P.$oE)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,P.$oE)("@microsoft/1ds-post-js","dist/ms.post.js"),g=new $.AppInsightsCore,b=new c.PostChannel,f={instrumentationKey:S,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(h){f.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[b.identifier]=p}return g.initialize(f,[]),g.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',m&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),g}class w{constructor(m,h,$,c,g){this.e=m,this.f=h,this.g=$,this.h=g,this.c=C,this.d=k,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(m){if(this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=A(this.a,this.e,this.h)),this.b.then(h=>{m(h)},h=>{(0,a.$2)(h),console.error(h)})}}log(m,h){if(!this.a)return;h=(0,N.$eo)(h,this.g),h=(0,L.$Cp)(h);const $=this.f+"/"+m;try{this.i(c=>{c.pluginVersionString=h?.properties.version??"Unknown",c.track({name:$,baseData:{name:$,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.$HQ=w}),define(le[113],he([0,1,2,178,16,10,24,49]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;let A=class extends P.$Vc{constructor(S,m,h,$,c=""){super(),this.b=c;const g=m.getLogger(k.$wp);if(g)this.a=this.B(g);else{const f=(0,k.$Ap)($,h)?" (Not Sent)":"",p=()=>(0,k.$zp)($,h)&&S.getLevel()===L.LogLevel.Trace;this.a=this.B(m.createLogger(k.$wp,{name:(0,a.localize)(0,null,f),hidden:!p()})),this.B(S.onDidChangeLogLevel(()=>m.setVisibility(k.$wp,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,m){this.a.trace(`${this.b}telemetry/${S}`,(0,k.$Cp)(m))}};e.$bcc=A,e.$bcc=A=ve([Z(0,L.$$j),Z(1,L.$_j),Z(2,N.$Li),Z(3,C.$rk)],A)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[114],he([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,w=it(w);let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,p,I){this.k=p,this.l=I,this.d={},this.i=new P.$Uc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,L.$hf)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$hf)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(h.$gm)||d.affectsConfiguration(h.$im)||d.affectsConfiguration(h.$hm))&&this.m()}))}setExperimentProperty(f,p){this.d[f]=p}m(){let f=(0,$.$Bp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const I=p.usage?h.TelemetryLevel.USAGE:p.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,I)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,p,I){this.g<p||(I=(0,a.$eo)(I,this.d),I=(0,$.$Gp)(I,this.j),I=(0,a.$eo)(I,this.c),this.b.forEach(d=>d.log(f,I)))}publicLog(f,p){this.n(f,h.TelemetryLevel.USAGE,p)}publicLog2(f,p){this.publicLog(f,p)}publicLogError(f,p){this.h&&this.n(f,h.TelemetryLevel.ERROR,p)}publicLogError2(f,p){this.publicLogError(f,p)}};e.$as=c,e.$as=c=ve([Z(1,k.$$i),Z(2,S.$rk)],c);function g(){const b=(0,C.localize)(0,null,w.default.nameLong),f=w.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=N.$o?"":(0,C.localize)(3,null),I=(0,C.localize)(4,null),d=(0,C.localize)(5,null),u=(0,C.localize)(6,null),t=(0,C.localize)(7,null),s=`
|       | ${I} | ${d} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${b} ${f} ${p}

&nbsp;

${t}
${s}

&nbsp;

${r}
`}m.$oo.as(A.$to.Configuration).registerConfiguration({id:h.$fm,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[h.$gm]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:g(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),m.$oo.as(A.$to.Configuration).registerConfiguration({id:h.$fm,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[h.$im]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,C.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,C.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${h.$gm}#\``),scope:A.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[237],he([0,1,15,26,280,236]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=void 0,N=ke(N);async function C(S,m){const h=await m.request(S,a.CancellationToken.None),$=(await(0,P.$Ze)(h.stream)).toString(),c=h.res.statusCode??200;return{headers:h.res.headers,statusCode:c,responseData:$}}async function k(S){const m={method:S.type,headers:S.headers};return new Promise(($,c)=>{const g=N.request(S.url??"",m,b=>{b.on("data",function(f){$({headers:b.headers,statusCode:b.statusCode??200,responseData:f.toString()})}),b.on("error",function(f){c(f)})});g.write(S.data,b=>{b&&c(b)}),g.end()})}async function A(S,m,h){const $=typeof m.data=="string"?m.data:new TextDecoder().decode(m.data),c={type:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data).toString()},url:m.urlString,data:$};try{const g=S?await C(c,S):await k(c);h(g.statusCode,g.headers,g.responseData)}catch{h(0,{})}}class w extends L.$HQ{constructor(m,h,$,c,g){const b={sendPOST:(f,p)=>{A(m,f,p)}};super(h,$,c,g,b)}}e.$IQ=w}),define(le[238],he([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;let h=class{constructor(c,g,b,f,p,I){this.b=c,this.c=g,this.d=b,this.e=f,this.f=p,this.g=I,this.a=new Map}h(c){if(!this.a.has(c.id)){const g=Object.create(null);g["common.vscodemachineid"]=this.c.machineId,g["common.vscodesessionid"]=this.c.sessionId;const b=[c.id,JSON.stringify(g),c.aiKey],p=new a.$br(P.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new w.$Xec(p),new S.$bcc(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new m.$as({appenders:I,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,g,b){this.h(c).publicLog(g,b)}publicLogError(c,g,b){this.h(c).publicLogError(g,b)}};e.$_fc=h,e.$_fc=h=ve([Z(0,N.$$i),Z(1,A.$0l),Z(2,C.$$j),Z(3,C.$_j),Z(4,L.$Li),Z(5,k.$rk)],h)}),define(le[81],he([0,1,3,2,5,9,22,4,10]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=m,e.$zw=$,e.$Aw=c,e.$Cw=g,e.$Ew=b,e.$Fw=f,e.$ww=(0,k.$Ei)("tunnelService"),e.$xw=(0,k.$Ei)("sharedTunnelsService");var w;(function(d){d.Http="http",d.Https="https"})(w||(e.TunnelProtocol=w={}));var S;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(S||(e.TunnelPrivacyId=S={}));function m(d){return!!d.forwardPort}var h;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function $(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(u)return{address:u[1],port:+u[2]}}function c(d){if(d.scheme!=="http"&&d.scheme!=="https"||!d.query)return;const u=d.query.split("&");for(const t of u){const s=t.split("=")[1];if(/^https?:/.exec(s)){const r=$(L.URI.parse(s));if(r)return r}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(d){return e.$Bw.indexOf(d)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(d){return e.$Dw.indexOf(d)>=0}function f(d,u,t,s){if(t===N.OperatingSystem.Windows)return!1;if(t===N.OperatingSystem.Macintosh&&b(u)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(r?.length===4&&parseInt(r[1])>=18)return!1}return d<1024}class p{constructor(u,t,s){this.remoteAddress=u,this.localAddress=t,this.b=s,this.a=new P.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=p;let I=class extends a.$Vc{constructor(u,t){super(),this.r=u,this.s=t,this.a=new P.$le,this.onTunnelOpened=this.a.event,this.b=new P.$le,this.onTunnelClosed=this.b.event,this.c=new P.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const u=this.s.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.g=u,u?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.h=u.elevation,this.m=u.privacyOptions,this.j=u.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const u=[],t=Array.from(this.f.values());for(const s of t){const r=Array.from(s.values());for(const i of r){const n=await i.value;n&&typeof n!="string"&&u.push(n)}}return u}async dispose(){super.dispose();for(const u of this.f.values()){for(const{value:t}of u.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);u.clear()}this.f.clear()}setEnvironmentTunnel(u,t,s,r,i){this.z(u,t,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:t,localAddress:s,privacy:r,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,t){(b(u)||g(u))&&(u=e.$Bw[0]);const s=this.D(u,t);if(s)return++s.refcount,s.value}openTunnel(u,t,s,r,i,n=!1,o,l){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${i}.`);const y=this.g??u;if(!y)return;if(t||(t="localhost"),r||(r=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(y,t,s,r,i,n,o,l);return R?R.then(O=>{if(O){if(typeof O=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),O}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.w(O);return(O.tunnelRemoteHost!==t||O.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&O.privacy!==o&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const t=this.f.get(u.tunnelRemoteHost);if(t){const s=t.get(u.tunnelRemotePort);s&&(s.refcount--,await this.y(u.tunnelRemoteHost,u.tunnelRemotePort,s))}}}}async y(u,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${t}.`);const r=s.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.f.has(u)&&this.f.get(u).delete(t),r}}async closeTunnel(u,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${t} `);const s=this.f.get(u);if(s&&s.has(t)){const r=s.get(t);r.refcount=0,await this.y(u,t,r)}}z(u,t,s){this.f.has(u)||this.f.set(u,new Map),this.f.get(u).set(t,{refcount:1,value:s})}async C(u,t){const s=this.f.get(u);if(s){const r=s.get(t),i=r?await r.value:void 0;(!i||typeof i=="string")&&s.delete(t),s.size===0&&this.f.delete(u)}}D(u,t){const s=[u];g(u)?(s.push(...e.$Bw),s.push(...e.$Dw)):b(u)&&s.push(...e.$Dw);const r=s.map(i=>this.f.get(i));for(const i of r){const n=i?.get(t);if(n)return n}}canTunnel(u){return!!$(u)}G(u,t,s,r,i,n,o){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${r}.`);const l=s;this.n.add(l);const y=r===void 0?s:r,R={elevationRequired:i?this.isPortPrivileged(y):!1},O={remoteAddress:{host:t,port:s},localAddressPort:r,privacy:n,public:n?n!==S.Private:void 0,protocol:o},E=u.forwardPort(O,R);return E?(this.z(t,s,E),E.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(l)})):this.n.delete(l),E}};e.$Hw=I,e.$Hw=I=ve([Z(0,A.$$j),Z(1,C.$$i)],I)}),define(le[239],he([0,1,10,81,2,8,6]),function(ne,e,P,a,N,L,C){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class A extends N.$Vc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new C.$2h),this.b.p)}setAddress(m){this.a=m,this.b&&(this.b.complete(m),this.b=null)}setTunnel(m){this.B(m)}}let w=class extends N.$Vc{static{k=this}static{this.a=0}constructor(m,h){super(),this.f=m,this.g=h,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(m=>m.dispose())}async createTunnel(){return{id:String(++k.a)}}async startTunnel(m,h,$,c,g,b,f){const p=new A,I=await Promise.resolve(this.f.openTunnel(m,p,$,c,g,b,f));if(!I||typeof I=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${c} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this.c.has(h))throw this.c.delete(h),p.dispose(),await I.dispose(),(0,L.$7)();return p.setTunnel(I),this.b.set(h,p),this.g.info(`[SharedProcessTunnelService] Created tunnel ${h}: ${I.localAddress} (local) to ${$}:${c} (remote).`),{tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress}}async setAddress(m,h){const $=this.b.get(m);$&&$.setAddress(h)}async destroyTunnel(m){const h=this.b.get(m);if(h){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${m}.`),this.b.delete(m),await h.dispose();return}this.c.add(m)}};e.$jgc=w,e.$jgc=w=k=ve([Z(0,a.$xw),Z(1,P.$$j)],w)}),define(le[29],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,P.$Ei)("IUriIdentityService")}),define(le[240],he([0,1,29,196,7,21,133,3,2]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;class w{static{this._clock=0}constructor(h){this.uri=h,this.time=w._clock++}touch(){return this.time=w._clock++,this}}let S=class{constructor(h){this.g=h,this.c=new A.$Uc,this.f=2**16;const $=new Map,c=g=>{let b=$.get(g.scheme);return b===void 0&&(b=h.hasProvider(g)&&!this.g.hasCapability(g,N.FileSystemProviderCapabilities.PathCaseSensitive),$.set(g.scheme,b)),b};this.c.add(k.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(g=>{$.delete(g.scheme)})),this.extUri=new L.$7g(c),this.d=new C.$Ms((g,b)=>this.extUri.compare(g,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,L.$gh)(h));const $=this.d.get(h);return $?$.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new w(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((c,g)=>c[1].time<g[1].time?1:c[1].time>g[1].time?-1:0);w._clock=0,this.d.clear();const $=this.f*.5;for(let c=0;c<$;c++)this.d.set(h[c][0],h[c][1].touch())}};e.$Ns=S,e.$Ns=S=ve([Z(0,N.$$k)],S),(0,a.$Ks)(P.$Il,S,a.InstantiationType.Delayed)}),define(le[241],he([0,1,3,2,7,52,35]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class k extends a.$Vc{constructor(w,S,m,h,$,c){super(),this.f=w,this.g=S,this.h=m,this.j=h,this.m=$,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$le),this.onDidChangeFile=this.a.event,this.b=L.$Ki.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new C.$Cc(g=>this.m.extUri.getComparisonKey(this.t(g))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(g=>this.s(g)))}r(){this.c.clear();for(const w of this.j.profiles)this.c.add(w.settingsResource),this.c.add(w.keybindingsResource),this.c.add(w.tasksResource),this.c.add(w.extensionsResource)}open(w,S){return this.g.open(this.t(w),S)}close(w){return this.g.close(w)}read(w,S,m,h,$){return this.g.read(w,S,m,h,$)}write(w,S,m,h,$){return this.g.write(w,S,m,h,$)}watch(w,S){this.b.set(w,w);const m=this.g.watch(this.t(w),S);return(0,a.$Tc)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.g.stat(this.t(w))}mkdir(w){return this.g.mkdir(this.t(w))}rename(w,S,m){return this.g.rename(this.t(w),this.t(S),m)}readFile(w,S){return this.g.readFile(this.t(w),S)}readFileStream(w,S,m){return this.g.readFileStream(this.t(w),S,m)}readdir(w){return this.g.readdir(this.t(w))}enforceAtomicReadFile(w){return this.c.has(w)}writeFile(w,S,m){return this.g.writeFile(this.t(w),S,m)}enforceAtomicWriteFile(w){return this.c.has(w)?{postfix:".vsctmp"}:!1}delete(w,S){return this.g.delete(this.t(w),S)}copy(w,S,m){if((0,N.$cl)(this.g))return this.g.copy(this.t(w),this.t(S),m);throw new Error("copy not supported")}cloneFile(w,S){if((0,N.$dl)(this.g))return this.g.cloneFile(this.t(w),this.t(S));throw new Error("clone not supported")}s(w){const S=[];for(const m of w){if(m.resource.scheme!==this.f)continue;const h=this.u(m.resource);this.b.findSubstr(h)&&S.push({resource:h,type:m.type,cId:m.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(w){return w.with({scheme:this.f})}u(w){return w.with({scheme:this.h})}}e.$Mfc=k}),define(le[82],he([0,1,64]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$xLb=N,e.$yLb=L;function a(C,k,A,w){const S=(0,P.$0n)(C,k,A,w)[0];return S&&(C=C.substring(0,S.offset)+S.content+C.substring(S.offset+S.length)),C}function N(C,k,A){let w=A;for(;w>=0;){if(C.charAt(w)===k.charAt(k.length-1)&&k.length===1)return w+1;if(w--,k.length===2&&w>=0&&C.charAt(w)===k.charAt(0))return w+2}return 0}function L(C,k,A){let w=A;for(;w>=0;)if(C.charAt(w)===k.charAt(k.length-1)&&k.length===1||(w++,k.length===2&&w>=0&&C.charAt(w)===k.charAt(1)))return w;return C.length-1}}),define(le[242],he([0,1,30,57,13]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=L,a=ke(a);function L($,c,g,b,f,p){const I=[],d=[],u=[];if(!c){const M=$.filter(({identifier:X})=>f.every(K=>K.toLowerCase()!==X.id.toLowerCase()));return{local:{added:I,removed:d,updated:u},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}$=$.map(m),c=c.map(m),g=g?g.map(m):null;const t=new Map,s=M=>{M.uuid&&t.set(M.id.toLowerCase(),M.uuid)};$.forEach(({identifier:M})=>s(M)),c.forEach(({identifier:M})=>s(M)),g?.forEach(({identifier:M})=>s(M)),b?.forEach(({identifier:M})=>s(M)),p?.forEach(M=>s(M));const r=M=>{const X=M.identifier.uuid||t.get(M.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${M.identifier.id.toLowerCase()}`},i=(M,X)=>(M.set(r(X),X),M),n=$.reduce(i,new Map),o=c.reduce(i,new Map),l=c.reduce((M,X)=>i(M,(0,P.$bo)(X)),new Map),y=g?g.reduce(i,new Map):null,R=b.reduce(i,new Map),O=f.reduce((M,X)=>{const K=t.get(X.toLowerCase());return M.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)},new Set),E=p?p.reduce((M,{id:X,uuid:K})=>(K=K??t.get(X.toLowerCase()),M.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)),new Set):null,v=C(n,o,O,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const M=C(y,n,O,!1),X=C(y,o,O,!0),K=(Q,G,ie,V)=>{let z,ee,re;return G.installed?(z=V.pinned,re=V.preRelease,z&&(ee=V.version)):(z=ie.pinned,re=ie.preRelease,z&&(ee=ie.version)),z===void 0&&(z=G.pinned,z&&(ee=G.version)),re===void 0&&(re=G.preRelease),{...V,installed:G.installed||ie.installed,pinned:z,preRelease:re,version:ee??(ie.version&&(!G.installed||a.gt(ie.version,G.version))?ie.version:G.version),state:A(G,ie,y?.get(Q))}};for(const Q of X.removed.values()){const G=n.get(Q);if(!G)continue;const ie=(0,N.$pg)(y?.get(Q)),V=E&&!E.has(Q)&&ie.installed;G.installed&&V?d.push(G.identifier):l.set(Q,G)}for(const Q of X.added.values()){const G=(0,N.$pg)(o.get(Q)),ie=n.get(Q);if(ie){if(v.updated.has(Q)){const V=K(Q,ie,G,G);k(ie,G,!1,!1)||u.push(h(V,Q)),l.set(Q,V)}}else G.installed&&I.push(h(G,Q))}for(const Q of X.updated.values()){const G=(0,N.$pg)(o.get(Q)),ie=(0,N.$pg)(y?.get(Q)),V=n.get(Q);if(V)if(E&&!E.has(Q)&&ie.installed&&V.installed&&!G.installed)d.push(V.identifier);else{const ee=K(Q,V,G,G);u.push(h(ee,Q)),l.set(Q,ee)}else G.installed&&I.push(h(G,Q))}for(const Q of M.added.values())X.added.has(Q)||l.set(Q,(0,N.$pg)(n.get(Q)));for(const Q of M.updated.values()){if(X.removed.has(Q)||X.updated.has(Q))continue;const G=(0,N.$pg)(n.get(Q)),ie=(0,N.$pg)(o.get(Q));l.set(Q,K(Q,G,ie,G))}for(const Q of M.removed.values())X.updated.has(Q)||X.removed.has(Q)||R.has(Q)||(0,N.$pg)(o.get(Q)).installed&&E&&(E.has(Q)||!(0,N.$pg)(y?.get(Q)).installed||l.delete(Q))}const T=[],U=C(o,l,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&l.forEach((M,X)=>T.push(h(M,X))),{local:{added:I,removed:d,updated:u},remote:F?{added:[...U.added].map(M=>l.get(M)),updated:[...U.updated].map(M=>l.get(M)),removed:[...U.removed].map(M=>o.get(M)),all:T}:null}}function C($,c,g,b){const f=$?[...$.keys()].filter(t=>!g.has(t)):[],p=[...c.keys()].filter(t=>!g.has(t)),I=p.filter(t=>!f.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),d=f.filter(t=>!p.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),u=new Set;for(const t of f){if(d.has(t))continue;const s=$.get(t),r=c.get(t);(!r||!k(s,r,b,!0))&&u.add(t)}return{added:I,removed:d,updated:u}}function k($,c,g,b){return!($.disabled!==c.disabled||!!$.isApplicationScoped!=!!c.isApplicationScoped||b&&$.installed!==c.installed||$.installed&&c.installed&&($.preRelease!==c.preRelease||$.pinned!==c.pinned||c.pinned&&$.version!==c.version)||!S($.state,c.state)||g&&$.version!==c.version)}function A($,c,g){const b=$.state,f=c.state,p=g?.state;if(!c.version||b&&a.gt($.version,c.version))return b;if(f&&a.gt(c.version,$.version)||!b)return f;if(!f)return b;const I=(0,P.$bo)(b),d=p?w(p,f):{added:Object.keys(f).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set},u=p?w(p,b):{added:Object.keys(b).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set};for(const t of[...d.added.values(),...d.updated.values()])I[t]=f[t];for(const t of d.removed.values())u.updated.has(t)||delete I[t];return I}function w($,c){const g=Object.keys($),b=Object.keys(c),f=b.filter(d=>!g.includes(d)).reduce((d,u)=>(d.add(u),d),new Set),p=g.filter(d=>!b.includes(d)).reduce((d,u)=>(d.add(u),d),new Set),I=new Set;for(const d of g){if(p.has(d))continue;const u=$[d],t=c[d];(0,P.$fo)(u,t)||I.add(d)}return{added:f,removed:p,updated:I}}function S($={},c={}){const{added:g,removed:b,updated:f}=w($,c);return g.size===0&&b.size===0&&f.size===0}function m($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function h($,c){const g={...$,identifier:{id:$.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete g.disabled,$.installed||delete g.installed,$.state||delete g.state,$.isApplicationScoped||delete g.isApplicationScoped,g}}),define(le[115],he([0,1,19,22,4]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ONb=e.$NNb=void 0,e.$NNb=(0,N.$Ei)("IIgnoredExtensionsManagementService");let L=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==k&&S!==`-${k}`),A&&w.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(k,A){let w=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return w=w.filter(S=>S!==k&&S!==`-${k}`),A&&w.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(k){const A=k.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),w=this.b().map(h=>h.toLowerCase()),S=[],m=[];if(Array.isArray(w))for(const h of w)h.startsWith("-")?m.push(h.substring(1)):S.push(h);return(0,P.$Nb)([...A,...S].filter(h=>!m.includes(h)))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(A=>A.toLowerCase())}};e.$ONb=L,e.$ONb=L=ve([Z(0,a.$$i)],L)}),define(le[243],he([0,1,19,34,30,97,82]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=A,N=ke(N),C=ke(C);function k(d){return(0,a.$Un)(d)||[]}async function A(d,u,t,s,r){const i=k(d),n=k(u),o=t?k(t):null,l=[...i,...n,...o||[]].map(K=>K.key),y=await r.resolveUserBindings(l),R=S(i,n,o,y);if(!R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!R.hasLocalForwarded&&R.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const O=h(i),E=h(n),v=o?h(o):null,T=c(O,E,y),U=v?c(v,O,y):{added:[...O.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},F=v?c(v,E,y):{added:[...E.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},M=w(T,U,F);let X=d;for(const K of M.removed.values())M.conflicts.has(K)||(X=p(X,K,s));for(const K of M.added.values()){if(M.conflicts.has(K))continue;const Q=E.get(K);if(Q.some(G=>G.command!==`-${K}`&&R.conflicts.has(y[G.key]))){M.conflicts.add(K);continue}X=f(X,Q,s)}for(const K of M.updated.values()){if(M.conflicts.has(K))continue;const Q=E.get(K);if(Q.some(G=>G.command!==`-${K}`&&R.conflicts.has(y[G.key]))){M.conflicts.add(K);continue}X=I(X,K,Q,s)}return{mergeContent:X,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function w(d,u,t){const s=new Set,r=new Set,i=new Set,n=new Set;for(const o of u.removed.values())t.updated.has(o)&&n.add(o);for(const o of t.removed.values())n.has(o)||(u.updated.has(o)?n.add(o):r.add(o));for(const o of u.added.values())n.has(o)||t.added.has(o)&&d.updated.has(o)&&n.add(o);for(const o of t.added.values())n.has(o)||(u.added.has(o)?d.updated.has(o)&&n.add(o):s.add(o));for(const o of u.updated.values())n.has(o)||t.updated.has(o)&&d.updated.has(o)&&n.add(o);for(const o of t.updated.values())n.has(o)||(u.updated.has(o)?d.updated.has(o)&&n.add(o):i.add(o));return{added:s,removed:r,updated:i,conflicts:n}}function S(d,u,t,s){const r=new Set,i=m(d,s),n=m(u,s),o=t?m(t,s):null,l=$(i,n);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const y=o?$(o,i):{added:[...i.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const R=o?$(o,n):{added:[...n.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(R.added.size===0&&R.removed.size===0&&R.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:O,removed:E,updated:v,conflicts:T}=w(l,y,R);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:O,removed:E,updated:v,conflicts:T}}function m(d,u){const t=new Map;for(const s of d){const r=u[s.key];let i=t.get(r);i||(i=[],t.set(r,i)),i.push(s)}return t}function h(d){const u=new Map;for(const t of d){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=u.get(s);r||(r=[],u.set(s,r)),r.push(t)}return u}function $(d,u){const t=[...d.keys()],s=[...u.keys()],r=s.filter(o=>!t.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=t.filter(o=>!s.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),n=new Set;for(const o of t){if(i.has(o))continue;const l=d.get(o).map(R=>({...R,key:o})),y=u.get(o).map(R=>({...R,key:o}));(0,P.$vb)(l,y,(R,O)=>b(R,O))||n.add(o)}return{added:r,removed:i,updated:n}}function c(d,u,t){const s=[...d.keys()],r=[...u.keys()],i=r.filter(l=>!s.includes(l)).reduce((l,y)=>(l.add(y),l),new Set),n=s.filter(l=>!r.includes(l)).reduce((l,y)=>(l.add(y),l),new Set),o=new Set;for(const l of s){if(n.has(l))continue;const y=d.get(l).map(O=>({...O,key:t[O.key]})),R=u.get(l).map(O=>({...O,key:t[O.key]}));g(y,R)||o.add(l)}return{added:i,removed:n,updated:o}}function g(d,u){return!(!(0,P.$vb)(d.filter(({command:t})=>t[0]!=="-"),u.filter(({command:t})=>t[0]!=="-"),(t,s)=>b(t,s))||!(0,P.$vb)(d.filter(({command:t})=>t[0]==="-"),u.filter(({command:t})=>t[0]==="-"),(t,s)=>b(t,s)))}function b(d,u){if(d.command!==u.command||d.key!==u.key)return!1;const t=L.$Cj.deserialize(d.when),s=L.$Cj.deserialize(u.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!N.$fo(d.args,u.args))}function f(d,u,t){for(const s of u)d=C.edit(d,[-1],s,t);return d}function p(d,u,t){const s=k(d);for(let r=s.length-1;r>=0;r--)(s[r].command===u||s[r].command===`-${u}`)&&(d=C.edit(d,[r],void 0,t));return d}function I(d,u,t,s){const r=k(d),i=r.findIndex(n=>n.command===u||n.command===`-${u}`);for(let n=r.length-1;n>=0;n--)(r[n].command===u||r[n].command===`-${u}`)&&(d=C.edit(d,[n],void 0,s));for(let n=t.length-1;n>=0;n--)d=C.edit(d,[i],t[n],s);return d}}),define(le[244],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=P,e.$6ac=N;function P(L,C,k){const A={},w={},S=new Set;if(!C)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const m=a(L,C);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:A,updated:w,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=a(k,L),$=a(k,C),c={},g={},b=new Set,f=new Set;for(const p of h.removed.values())$.updated.has(p)?A[p]=C[p]:b.add(p);for(const p of $.removed.values())f.has(p)||(h.updated.has(p)?f.add(p):S.add(p));for(const p of h.updated.values())f.has(p)||($.updated.has(p)?m.updated.has(p)&&f.add(p):g[p]=L[p]);for(const p of $.updated.values())f.has(p)||(h.updated.has(p)?m.updated.has(p)&&f.add(p):L[p]!==void 0&&(w[p]=C[p]));for(const p of h.added.values())f.has(p)||($.added.has(p)?m.updated.has(p)&&f.add(p):c[p]=L[p]);for(const p of $.added.values())f.has(p)||(h.added.has(p)?m.updated.has(p)&&f.add(p):A[p]=C[p]);return{local:{added:A,removed:[...S.values()],updated:w},remote:{added:c,removed:[...b.values()],updated:g},conflicts:[...f.values()]}}function a(L,C){const k=L?Object.keys(L):[],A=C?Object.keys(C):[],w=A.filter(h=>!k.includes(h)).reduce((h,$)=>(h.add($),h),new Set),S=k.filter(h=>!A.includes(h)).reduce((h,$)=>(h.add($),h),new Set),m=new Set;for(const h of k){if(S.has(h))continue;const $=L[h],c=C[h];$!==c&&m.add(h)}return{added:w,removed:S,updated:m}}function N(L,C){const{added:k,removed:A,updated:w}=a(L,C);return k.size===0&&A.size===0&&w.size===0}}),define(le[245],he([0,1,30]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=a;function a(L,C,k,A){const w={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!C){const h=L.filter(({id:$})=>!A.includes($));return h.length?S.added=h:S=null,{local:w,remote:S}}const m=N(L,C,A);if(m.added.length>0||m.removed.length>0||m.updated.length>0){const h=N(k,L,A),$=N(k,C,A);for(const c of $.removed){const g=L.find(b=>b.id===c);g&&w.removed.push(g)}for(const c of $.added){const g=C.find(b=>b.id===c);h.added.includes(c)?m.updated.includes(c)&&w.updated.push(g):w.added.push(g)}for(const c of $.updated)w.updated.push(C.find(g=>g.id===c));for(const c of h.added)$.added.includes(c)||S.added.push(L.find(g=>g.id===c));for(const c of h.updated)$.removed.includes(c)||$.updated.includes(c)||S.updated.push(L.find(g=>g.id===c));for(const c of h.removed){const g=C.find(b=>b.id===c);g&&S.removed.push(g)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:w,remote:S}}function N(L,C,k){L=L?L.filter(({id:$})=>!k.includes($)):[],C=C.filter(({id:$})=>!k.includes($));const A=L.map(({id:$})=>$),w=C.map(({id:$})=>$),S=w.filter($=>!A.includes($)),m=A.filter($=>!w.includes($)),h=[];for(const{id:$,name:c,shortName:g,icon:b,useDefaultFlags:f}of L){if(m.includes($))continue;const p=C.find(I=>I.id===$);(!p||p.name!==c||p.shortName!==g||p.icon!==b||!(0,P.$fo)(p.useDefaultFlags,f))&&h.push($)}return{added:S,removed:m,updated:h}}}),define(le[25],he([0,1,19,13,185,48,28,4,104,44]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mb=e.$0mb=e.$9mb=e.$8mb=e.$7mb=e.$6mb=e.$5mb=e.$4mb=e.$3mb=e.$1mb=e.MergeState=e.Change=e.SyncStatus=e.$Zmb=e.$Ymb=e.$Xmb=e.UserDataSyncErrorCode=e.$Vmb=e.$Umb=e.$Tmb=e.$Smb=e.$Rmb=e.$Omb=e.SyncResource=e.$Lmb=e.$Kmb=void 0,e.$Imb=S,e.$Jmb=m,e.$Mmb=h,e.$Nmb=$,e.$Pmb=g,e.$Qmb=b,e.$Wmb=f,e.$2mb=i;function S(){const n=w.$oo.as(L.$to.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function m(){const n=w.$oo.as(L.$to.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(R=>!!n[R].ignoreSync),l=Object.keys(n).filter(R=>n[R].scope===L.ConfigurationScope.MACHINE||n[R].scope===L.ConfigurationScope.MACHINE_OVERRIDABLE),y=S();return(0,P.$Nb)([...o,...l,...y])}e.$Kmb="settingsSync",e.$Lmb="settingsSync.keybindingsPerPlatform";function h(){const n="vscode://schemas/ignoredSettings",o=w.$oo.as(L.$to.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$Lmb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:L.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:C.$6o,errorMessage:(0,N.localize)(3,null)}],default:[],scope:L.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:L.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=w.$oo.as(A.$po.JSONContribution),y=()=>{const R=S(),O=m(),E=Object.keys(L.$uo.properties).filter(U=>!O.includes(U)),v=O.filter(U=>!R.includes(U)),T={items:{type:"string",enum:[...E,...v.map(U=>`-${U}`)]}};l.registerSchema(n,T)};return o.onDidUpdateConfiguration(()=>y())}function $(n){return n&&(0,a.$gg)(n)&&(0,a.$eg)(n.id)&&Array.isArray(n.scopes)}var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$Omb=[c.Settings,c.Keybindings,c.Snippets,c.Tasks,c.Extensions,c.GlobalState,c.Profiles];function g(n,...o){return n?[n,...o]:o}function b(n,o,l,y){return y.joinPath(l.userDataSyncHome,...g(n,o,`lastSync${o}.json`))}e.$Rmb=(0,k.$Ei)("IUserDataSyncStoreManagementService"),e.$Smb=(0,k.$Ei)("IUserDataSyncStoreService"),e.$Tmb=(0,k.$Ei)("IUserDataSyncLocalStoreService"),e.$Umb="x-operation-id",e.$Vmb="X-Execution-Id";function f(n){const o={};return o[e.$Vmb]=n,o}var p;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(p||(e.UserDataSyncErrorCode=p={}));class I extends Error{constructor(o,l,y,R){super(o),this.code=l,this.resource=y,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Xmb=I;class d extends I{constructor(o,l,y,R,O){super(o,y,void 0,O),this.url=l,this.serverCode=R}}e.$Ymb=d;class u extends I{constructor(o,l){super(o,l)}}e.$Zmb=u,function(n){function o(l){if(l instanceof n)return l;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(y&&y[1]){const R=y[2]==="unknown"?void 0:y[2],O=y[3]==="unknown"?void 0:y[3];return new n(l.message,y[1],R,O)}return new n(l.message,p.Unknown)}n.toUserDataSyncError=o}(I||(e.$Xmb=I={}));var t;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var s;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(s||(e.Change=s={}));var r;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(r||(e.MergeState=r={})),e.$1mb="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.$3mb=(0,k.$Ei)("IUserDataSyncEnablementService"),e.$4mb=(0,k.$Ei)("IUserDataSyncService"),e.$5mb=(0,k.$Ei)("IUserDataSyncResourceProviderService"),e.$6mb=(0,k.$Ei)("IUserDataAutoSyncService"),e.$7mb=(0,k.$Ei)("IUserDataSyncUtilService"),e.$8mb=(0,k.$Ei)("IUserDataSyncLogService"),e.$9mb="userDataSync",e.$0mb="vscode-userdata-sync",e.$$mb="preview"}),define(le[246],he([0,1,30,25]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Mb=N,P=ke(P);function N(C,k,A,w,S){if(!k)return{remote:{added:Object.keys(C),removed:[],updated:[],all:Object.keys(C).length>0?C:null},local:{added:{},removed:[],updated:{}}};const m=L(C,k);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const h=A?L(A,k):{added:Object.keys(k).reduce((p,I)=>(p.add(I),p),new Set),removed:new Set,updated:new Set},$=A?L(A,C):{added:Object.keys(C).reduce((p,I)=>(p.add(I),p),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},g=P.$bo(k),b=!A;for(const p of $.added.values())p!==a.$1mb&&b&&h.added.has(p)||(g[p]=C[p]);for(const p of $.updated.values())g[p]=C[p];for(const p of $.removed.values())w.unregistered.includes(p)||delete g[p];for(const p of h.added.values()){const I=k[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(A&&$.added.has(p))continue;const d=C[p];d&&d.value===I.value||p===a.$1mb&&b&&$.added.has(p)||(d?c.updated[p]=I:c.added[p]=I)}for(const p of h.updated.values()){const I=k[p];if(w.machine.includes(p)){S.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(p)||$.removed.has(p))continue;const d=C[p];d&&d.value===I.value||(c.updated[p]=I)}for(const p of h.removed.values()){if(w.machine.includes(p)){S.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}$.updated.has(p)||$.removed.has(p)||c.removed.push(p)}const f=L(k,g);return{local:c,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:g}}}function L(C,k){const A=Object.keys(C),w=Object.keys(k),S=w.filter($=>!A.includes($)).reduce(($,c)=>($.add(c),$),new Set),m=A.filter($=>!w.includes($)).reduce(($,c)=>($.add(c),$),new Set),h=new Set;for(const $ of A){if(m.has($))continue;const c=C[$],g=k[$];P.$fo(c,g)||h.add($)}return{added:S,removed:m,updated:h}}}),define(le[247],he([0,1,19,34,64,45,30,82,25]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zLb=w,e.$ALb=h,e.$BLb=$,e.$CLb=c,e.$DLb=b,e.$ELb=p,C=ke(C),k=ke(k);function w(l,y,R){let O=[];R?O=m(R):O=S(y);const E=[],v=[...(0,A.$Imb)()];if(Array.isArray(O))for(const T of O)T.startsWith("-")?v.push(T.substring(1)):E.push(T);return(0,P.$Nb)([...l,...E].filter(T=>!v.includes(T)))}function S(l){let y=l.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=l.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:l.getValue("settingsSync.ignoredSettings")||[]}function m(l){const y=(0,a.$Un)(l);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function h(l,y){const R=(0,a.$Un)(l)||{};let O="{}";for(const E of Object.keys(R)){const v=(0,N.$0n)(O,[E],R[E],y);O=(0,N.$ao)(O,v)}return O}function $(l,y,R,O){if(R.length){const E=o(y),v=(0,a.$Un)(y)||{},T=(0,a.$Un)(l);if(!T)return l;const U=[];for(const F of R){const M=v[F],X=T[F];M===void 0?l=k.edit(l,[F],void 0,O):X!==void 0?l=k.edit(l,[F],M,O):U.push(t(F,E))}U.sort((F,M)=>F.startOffset-M.startOffset),U.forEach(F=>l=p(F.setting.key,y,l,O))}return l}function c(l,y,R,O,E,v){const T=$(l,y,O,v),U=R!==T,F=R!==y;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:$(y,l,O,v),remoteContent:null,hasConflicts:!1};if(R===null&&b(l)){const D=g(l,y,O)?null:$(y,l,O,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let M=l,X=y;const K=(0,a.$Un)(l),Q=(0,a.$Un)(y),G=R?(0,a.$Un)(R):null,ie=O.reduce((D,B)=>(D.add(B),D),new Set),V=f(K,Q,ie),z=f(G,K,ie),ee=f(G,Q,ie),re=new Map,ce=new Set,q=D=>{ce.add(D);const B=E.filter(({key:j})=>j===D)[0];B?(M=k.edit(M,[D],B.value,v),X=k.edit(X,[D],B.value,v)):re.set(D,{key:D,localValue:K[D],remoteValue:Q[D]})};for(const D of z.removed.values())ee.updated.has(D)?q(D):X=k.edit(X,[D],void 0,v);for(const D of ee.removed.values())ce.has(D)||(z.updated.has(D)?q(D):M=k.edit(M,[D],void 0,v));for(const D of z.updated.values())ce.has(D)||(ee.updated.has(D)?V.updated.has(D)&&q(D):X=k.edit(X,[D],K[D],v));for(const D of ee.updated.values())ce.has(D)||(z.updated.has(D)?V.updated.has(D)&&q(D):M=k.edit(M,[D],Q[D],v));for(const D of z.added.values())ce.has(D)||(ee.added.has(D)?V.updated.has(D)&&q(D):X=p(D,M,X,v));for(const D of ee.added.values())ce.has(D)||(z.added.has(D)?V.updated.has(D)&&q(D):M=p(D,X,M,v));const x=re.size>0||!g(M,X,O),J=x||!g(M,l,[]),H=x||!g(X,y,[]);return{localContent:J?M:null,remoteContent:H?X:null,conflictsSettings:[...re.values()],hasConflicts:x}}function g(l,y,R){if(l===y)return!0;const O=(0,a.$Un)(l),E=(0,a.$Un)(y),v=R.reduce((F,M)=>(F.add(M),F),new Set),T=o(l).filter(F=>!(F.setting&&v.has(F.setting.key))),U=o(y).filter(F=>!(F.setting&&v.has(F.setting.key)));if(T.length!==U.length)return!1;for(let F=0;F<T.length;F++){const M=T[F],X=U[F];if(M.setting&&X.setting){if(M.setting.key!==X.setting.key||!C.$fo(O[M.setting.key],E[M.setting.key]))return!1}else if(!M.setting&&!X.setting){if(M.value!==X.value)return!1}else return!1}return!0}function b(l){return l?o(l).length===0:!0}function f(l,y,R){const O=l?Object.keys(l).filter(F=>!R.has(F)):[],E=Object.keys(y).filter(F=>!R.has(F)),v=E.filter(F=>!O.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),T=O.filter(F=>!E.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),U=new Set;if(l)for(const F of O){if(T.has(F))continue;const M=l[F],X=y[F];C.$fo(M,X)||U.add(F)}return{added:v,removed:T,updated:U}}function p(l,y,R,O){const E=(0,a.$Un)(y),v=o(y),T=o(R),U=I(l,v,T);return d(R,l,E[l],U,T,O)}function I(l,y,R){const O=y.findIndex(v=>v.setting?.key===l),E=y[O-1];if(E){if(E.setting){const T=t(E.setting.key,R);if(T)return{index:R.indexOf(T),insertAfter:!0}}else{const T=s(O,y);if(T){const U=t(T.setting.key,R);if(U){const F=r(R.indexOf(U),R),M=i(y,T,y[O]);if(F){const X=i(R,U,F),K=n(M,X);return K?{index:R.indexOf(K),insertAfter:!0}:{index:R.indexOf(F),insertAfter:!1}}else{const X=i(R,U,R[R.length-1]),K=n(M,X);return K?{index:R.indexOf(K),insertAfter:!0}:{index:R.length-1,insertAfter:!0}}}}}const v=y[O+1];if(v)if(v.setting){const T=t(v.setting.key,R);if(T)return{index:R.indexOf(T),insertAfter:!1}}else{const T=r(O,y);if(T){const U=t(T.setting.key,R);if(U){const F=s(R.indexOf(U),R),M=i(y,y[O],T);if(F){const X=i(R,F,U),K=n(M.reverse(),X.reverse());return K?{index:R.indexOf(K),insertAfter:!1}:{index:R.indexOf(F),insertAfter:!0}}else{const X=i(R,R[0],U),K=n(M.reverse(),X.reverse());return K?{index:R.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:R.length-1,insertAfter:!0}}function d(l,y,R,O,E,v){let T;return O.index===-1?T=(0,N.$0n)(l,[y],R,v):T=u(l,y,R,O,E,v).map(U=>(0,N.$$n)(l,U,v)[0]),(0,N.$ao)(l,T)}function u(l,y,R,O,E,v){const T=`${JSON.stringify(y)}: ${JSON.stringify(R)}`,U=(0,L.$7n)(v,l),F=E[O.index];if(O.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+T});else{const X=r(O.index,E),K=s(O.index,E),Q=K?.setting?.commaOffset;K&&Q===void 0&&M.push({offset:K.endOffset,length:0,content:","});const G=Q!==void 0&&Q>F.endOffset;M.push({offset:G?Q+1:F.endOffset,length:0,content:X?U+T+",":U+T})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:T+","}];const M=(E[O.index-1]&&!E[O.index-1].setting?U:"")+T+(r(O.index,E)?",":"")+U;return[{offset:F.startOffset,length:0,content:M}]}}function t(l,y){return y.filter(R=>R.setting?.key===l)[0]}function s(l,y){for(let R=l-1;R>=0;R--)if(y[R].setting)return y[R]}function r(l,y){for(let R=l+1;R<y.length;R++)if(y[R].setting)return y[R]}function i(l,y,R){const O=l.indexOf(y),E=l.indexOf(R);return l.filter((v,T)=>O<T&&T<E)}function n(l,y){if(l.length&&y.length){let R=0;for(;R<y.length&&R<l.length;R++)if(l[R].value!==y[R].value)return y[R-1];return y[R-1]}}function o(l){const y=[];let R=-1,O,E;const v={onObjectBegin:T=>{R++},onObjectProperty:(T,U,F)=>{R===0&&(O=U,E=T)},onObjectEnd:(T,U)=>{R--,R===0&&y.push({startOffset:O,endOffset:T+U,value:l.substring(O,T+U),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(T,U)=>{R++},onArrayEnd:(T,U)=>{R--,R===0&&y.push({startOffset:O,endOffset:T+U,value:l.substring(O,T+U),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(T,U,F)=>{R===0&&y.push({startOffset:O,endOffset:U+F,value:l.substring(O,U+F),setting:{key:E,commaOffset:void 0}})},onSeparator:(T,U,F)=>{if(R===0&&T===","){let M=y.length-1;for(;M>=0&&!y[M].setting;M--);const X=y[M];X&&y.splice(M,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:U}})}},onComment:(T,U)=>{R===0&&y.push({startOffset:T,endOffset:T+U,value:l.substring(T,T+U)})}};return(0,a.$2n)(l,v),y}}),define(le[83],he([0,1,3,2,4,25]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kLb=e.$jLb=void 0,e.$jLb=(0,N.$Ei)("IUserDataSyncAccountService");let C=class extends a.$Vc{get account(){return this.a}constructor(A,w){super(),this.g=A,this.h=w,this.b=this.B(new P.$le),this.onDidChangeAccount=this.b.event,this.c=this.B(new P.$le),this.onTokenFailed=this.c.event,this.f=!1,this.B(A.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S===L.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(A.onTokenSucceed(()=>this.f=!1))}async updateAccount(A){(A&&this.a?A.token!==this.a.token||A.authenticationProviderId!==this.a.authenticationProviderId:A!==this.a)&&(this.a=A,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(A))}};e.$kLb=C,e.$kLb=C=ve([Z(0,L.$Smb),Z(1,L.$8mb)],C)}),define(le[248],he([0,1,21,186,16,10,25]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PNb=void 0;let k=class extends L.$dk{constructor(w,S){super(),this.g=this.B(w.createLogger((0,P.$fh)(S.logsHome,`${C.$9mb}.log`),{id:C.$9mb,name:(0,a.localize)(0,null)}))}trace(w,...S){this.g.trace(w,...S)}debug(w,...S){this.g.debug(w,...S)}info(w,...S){this.g.info(w,...S)}warn(w,...S){this.g.warn(w,...S)}error(w,...S){this.g.error(w,...S)}flush(){this.g.flush()}};e.$PNb=k,e.$PNb=k=ve([Z(0,L.$_j),Z(1,N.$Li)],k)}),define(le[249],he([0,1,6,3,2]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class L extends N.$Vc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:A,getActiveWindowId:w}){super(),this.a=this.B(new N.$Uc),a.Event.latch(a.Event.any(k,A))(this.f,this,this.a),this.b=(0,P.$rh)(()=>w()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$ffc=L}),define(le[116],he([0,1,189,14,52,21,9,4,23]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=w,e.$Pi=S,e.$Si=m,e.$Ti=h,e.$Ui=$,e.$Vi=g,e.$Wi=b,e.$Zi=I,e.$5i=d,e.$6i=u,e.$8i=t,e.$9i=s,e.$0i=r,e.$Ni=(0,k.$Ei)("contextService");function w(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}function S(i){return typeof i?.id=="string"&&!w(i)&&!h(i)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function m(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,a.$oc)(i)}:n?e.$Qi:e.$Ri;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(i){const n=i;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}function $(i){const n=i;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var c;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function b(i){const n=i;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,l,y,R){this.h=n,this.j=l,this.k=y,this.l=R,this.c=N.$Ki.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=N.$Ki.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=f;class p{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.$fh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=p;function I(i){return new p({uri:i,index:0,name:(0,L.$bh)(i)},{uri:i.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,P.localize)(0,null),extensions:[e.$1i]}],e.$4i="workspace.json";function d(i,n){return L.$9g.isEqualOrParent(i,n.untitledWorkspacesHome)}function u(i){let n;return C.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===A.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$7i}function s(i,n){return!d(i,n)&&!u(i)}function r(i){return(typeof i=="string"?(0,a.$pc)(i):(0,L.$dh)(i))===e.$2i}}),define(le[20],he([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=d,e.$Ll=u,e.$Ml=t;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Kl=(0,S.$Ei)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:n}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,o,l,y,R){return{id:i,name:n,location:o,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:R&&y?.useDefaultFlags?.globalState?R.globalStorageHome:(0,L.$fh)(o,"globalStorage"),settingsResource:R&&y?.useDefaultFlags?.settings?R.settingsResource:(0,L.$fh)(o,"settings.json"),keybindingsResource:R&&y?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,L.$fh)(o,"keybindings.json"),tasksResource:R&&y?.useDefaultFlags?.tasks?R.tasksResource:(0,L.$fh)(o,"tasks.json"),snippetsHome:R&&y?.useDefaultFlags?.snippets?R.snippetsHome:(0,L.$fh)(o,"snippets"),extensionsResource:R&&y?.useDefaultFlags?.extensions?R.extensionsResource:(0,L.$fh)(o,"extensions.json"),cacheHome:(0,L.$fh)(l,i),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let s=class extends N.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,l,y){super(),this.t=n,this.u=o,this.w=l,this.y=y,this.f=!0,this.h=this.B(new a.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Bc,workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,L.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,p.$eg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(t((0,L.$ch)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const l=new $.$Bc,y=new Map;if(o.length)try{const R=this.Q();if(R.workspaces)for(const[O,E]of Object.entries(R.workspaces)){const v=C.URI.parse(O),T=o.find(U=>U.id===E);T&&l.set(v,T)}if(R.emptyWindows)for(const[O,E]of Object.entries(R.emptyWindows)){const v=o.find(T=>T.id===E);v&&y.set(O,v)}}catch(R){this.y.error(R)}this.z={profiles:o,workspaces:l,emptyWindows:y}}return this.z}D(){const n=t("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,f.$hf)(o)}\\s(\\d+)`);let y=0;for(const O of this.profiles){const E=l.exec(O.name),v=E?parseInt(E[1]):0;y=v>y?v:y}const R=`${o} ${y+1}`;return this.createProfile((0,P.$sj)((0,b.$1g)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,P.$sj)((0,b.$1g)()).toString(16),n,o,l)}async createProfile(n,o,l,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,o,l);return y&&await this.setProfileForWorkspace(y,R),R}async F(n,o,l){if(!(0,p.$eg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(o);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===o||v.id===n))throw new Error(`Profile with ${o} name already exists`);const O=t(n,o,(0,L.$fh)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(O.location);const E=[];return this.j.fire({profile:O,join(v){E.push(v)}}),await g.Promises.settled(E),this.I([O],[],[]),O}finally{this.r.delete(o)}})(),this.r.set(o,y)),y}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(y=>y.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(y=>y.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:o,join(y){l.push(y)}});try{await Promise.allSettled(l)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(y){(0,w.$pl)(y)!==w.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(y=>y.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),l=C.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return l||((0,h.$Oi)(n)?this.s.folders.get(n.uri):(0,h.$Ti)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,h.$Oi)(n)?n.uri:(0,h.$Ti)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,l){const y=[...this.profiles,...n],R=[],O=this.s.profiles;this.s.profiles=[];for(let E of y){if(E.isDefault||o.some(T=>E.id===T.id))continue;E=l.find(T=>E.id===T.id)??E;const v=O.find(T=>E.id===T.id);if(E.isTransient)this.s.profiles.push(E);else{if(v){for(const[T,U]of this.s.emptyWindows.entries())if(E.id===U.id){this.L({id:T},E);break}for(const[T,U]of this.s.workspaces.entries())if(E.id===U.id){this.L({id:"",configPath:T},E);break}for(const[T,U]of this.s.folders.entries())if(E.id===U.id){this.L({id:"",uri:T},E);break}}R.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(n,o,l)}J(n,o,l){this.h.fire({added:n,removed:o,updated:l,all:this.profiles})}L(n,o,l){if(l=o?.isTransient?!0:l,l)(0,h.$Oi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,h.$Ti)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const y=this.G(n);C.URI.isUri(y)?(this.C.workspaces.delete(y),o&&this.C.workspaces.set(y,o)):(this.C.emptyWindows.delete(y),o&&this.C.emptyWindows.set(y,o)),this.M()}}M(){const n={};for(const[l,y]of this.C.workspaces.entries())n[l.toString()]=y.id;const o={};for(const[l,y]of this.C.emptyWindows.entries())o[l.toString()]=y.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},l=this.D();if(n.workspaces)for(const[R,O]of Object.entries(n.workspaces)){const E=C.URI.parse(O);o[R]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}const y={};if(n.emptyWindows)for(const[R,O]of Object.entries(n.emptyWindows)){const E=C.URI.parse(O);y[R]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}return{workspaces:o,emptyWindows:y}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nl=s,e.$Nl=s=ve([Z(0,A.$Li),Z(1,w.$$k),Z(2,c.$Il),Z(3,m.$$j)],s);class r extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ol=r}),define(le[250],he([0,1,6,2,20]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;let L=class extends a.$Vc{constructor(k){super(),this.B(new P.$Qh(()=>{k.cleanUp()},10*1e3)).schedule()}};e.$lgc=L,e.$lgc=L=ve([Z(0,N.$Kl)],L)}),define(le[84],he([0,1,19,6,26,8,3,2,5,13,9,162,28,33,37,10,24,18,29,20]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$yq=void 0,e.$zq=u,m=ke(m);let d=class extends k.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,n,o,l,y,R){super(),this.z=i,this.C=n,this.D=o,this.F=l,this.G=y,this.H=R,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$le),this.s=this.B(new C.$le),this.t=this.B(new C.$le),this.u=this.B(new C.$le),this.w=this.B(new C.$le),this.y=[],this.B((0,k.$Tc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,h.$ep)(o,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const l=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:y})=>(0,$.$Hp)(y,i.identifier));if(l?.local)return l?.local;throw l?.error?l.error:new h.$ip(`Unknown error while installing extension ${i.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(o){throw u(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new h.$ip(m.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(i.map(async({extension:l,options:y})=>{try{const R=await this.N(l,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.G.version,date:this.G.date});o.push({...R,options:y})}catch(R){n.push({identifier:l.identifier,operation:h.InstallOperation.Install,source:l,error:R,profileLocation:y.profileLocation??this.X()})}})),o.length&&n.push(...await this.I(o)),n}async uninstall(i,n={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,n)}async toggleAppliationScope(i,n){if((0,c.$sn)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,n));for(const l of this.H.profiles){const y=(await this.getInstalled(c.ExtensionType.User,l.extensionsResource)).find(R=>(0,$.$Hp)(R.identifier,i.identifier));y?this.w.fire({local:y,profileLocation:l.extensionsResource}):this.u.fire({identifier:i.identifier,profileLocation:l.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:h.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const n=new Map,o=new Map,l=[],y=(O,E)=>`${$.$Ip.create(O).toString()}-${E.toString()}`,R=(O,E,v,T)=>{const U=this.Y(O,E,v),F=`${(0,$.$Mp)(O.publisher,O.name)}-${v.profileLocation.toString()}`;o.set(F,{task:U,root:T}),this.n.fire({identifier:U.identifier,source:E,profileLocation:v.profileLocation}),this.F.info("Installing extension:",U.identifier.id,v),S.URI.isUri(E)||this.j.set(y(E,v.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:O,extension:E,options:v}of i){const T=v.isApplicationScoped||v.isBuiltin||(0,c.$sn)(O),U={...v,installOnlyNewlyAddedFromExtensionPack:v.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(E),isApplicationScoped:T,profileLocation:T?this.H.defaultProfile.extensionsResource:v.profileLocation??this.X(),productVersion:v.productVersion??{version:this.G.version,date:this.G.date}},F=S.URI.isUri(E)?void 0:this.j.get(y(E,U.profileLocation));F?(this.F.info("Extension is already requested to install",F.task.identifier.id,U.profileLocation.toString()),l.push(F.task.waitUntilTaskIsFinished())):R(O,E,U,void 0)}return await Promise.all([...o.values()].map(async({task:O})=>{if(O.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const E=await this.M(O.identifier,O.manifest,!!O.options.installOnlyNewlyAddedFromExtensionPack,!!O.options.installPreReleaseVersion,O.options.profileLocation,O.options.productVersion),v=await this.getInstalled(void 0,O.options.profileLocation,O.options.productVersion),T={...O.options,context:{...O.options.context,[h.$$o]:!0}};for(const{gallery:U,manifest:F}of(0,P.$Nb)(E,({gallery:M})=>M.identifier.id)){if(o.has(`${U.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const M=this.j.get(y(U,T.profileLocation));if(M){if(this.J(O,M.task)){const X=M.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,O.identifier.id,T.profileLocation.toString()),M.waitingTasks.push(O),l.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,K=>K.some(Q=>(0,$.$Hp)(Q.identifier,X)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,O.identifier.id,T.profileLocation.toString()),!K.find(G=>(0,$.$Hp)(G.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else v.some(({identifier:X})=>(0,$.$Hp)(X,U.identifier))||R(F,U,T,O)}}catch(E){if(S.URI.isUri(O.source))(0,P.$Mb)(O.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",O.identifier.id,E.message),(0,P.$Mb)(O.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",O.identifier.id,E.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),E}})),await this.L([...o.entries()].map(async([O,{task:E}])=>{const v=new Date().getTime();let T;try{T=await E.run(),await this.L(this.y.map(U=>U.postInstall(T,E.source,E.options,N.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(U){const F=u(U);throw S.URI.isUri(E.source)||t(this.C,E.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Pp)(E.source),error:F,source:E.options.context?.[h.$0o]}),n.set(O,{error:F,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:E.options.isApplicationScoped}),this.F.error("Error while installing the extension",E.identifier.id,(0,L.$$)(F),E.options.profileLocation.toString()),F}if(!S.URI.isUri(E.source)){const U=E.operation===h.InstallOperation.Update,F=U?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(t(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Pp)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-v,durationSinceUpdate:F,source:E.options.context?.[h.$0o]}),A.$o&&E.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,h.StatisticType.Install)}catch{}}n.set(O,{local:T,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:T.isApplicationScoped})})),l.length&&await this.L(l),[...n.values()]}catch(O){const E=(U,F,M)=>{const X=[];U.manifest.extensionDependencies?.length&&X.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&X.push(...U.manifest.extensionPack);for(const K of X){if(M.includes(K.toLowerCase()))continue;M.push(K.toLowerCase());const Q=n.get(`${K.toLowerCase()}-${F.toString()}`);Q?.local&&(M=E(Q.local,F,M))}return M},v=U=>({identifier:U.identifier,operation:h.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:O}),T=[];for(const[U,{task:F,root:M}]of o){const X=n.get(U);X?X.local&&M&&!n.get(`${M.identifier.id.toLowerCase()}-${F.options.profileLocation.toString()}`)?.local&&(T.push(this.Z(X.local,{versionOnly:!0,profileLocation:F.options.profileLocation})),n.set(U,v(F))):(F.cancel(),n.set(U,v(F)))}for(const[U,{task:F}]of o){const M=n.get(U);if(!M?.local||F.options.donotIncludePackAndDependencies)continue;E(M.local,F.options.profileLocation,[M.local.identifier.id.toLowerCase()]).slice(1).some(K=>o.has(`${K.toLowerCase()}-${F.options.profileLocation.toString()}`)&&!n.get(`${K.toLowerCase()}-${F.options.profileLocation.toString()}`)?.local)&&(T.push(this.Z(M.local,{versionOnly:!0,profileLocation:F.options.profileLocation})),n.set(U,v(F)))}throw T.length&&await Promise.allSettled(T.map(async U=>{try{await U.run(),this.F.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,L.$$)(F))}})),O}finally{for(const{task:O}of o.values())O.source&&!S.URI.isUri(O.source)&&this.j.delete(y(O.source,O.options.profileLocation));if(n.size){const O=[...n.values()];for(const E of O)E.local&&this.F.info("Extension installed successfully:",E.identifier.id,E.profileLocation.toString());this.s.fire(O)}}}J(i,n){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(n)||l.some(y=>this.J(y,n)))||o===n&&l[0]&&!this.J(i,l[0]))return!1;return!0}async L(i,n){const o=[],l=[],y=await Promise.allSettled(i);for(const O of y)O.status==="fulfilled"?o.push(O.value):l.push(u(O.reason,n));if(!l.length)return o;if(l.length===1)throw l[0];let R=new h.$ip("",h.ExtensionManagementErrorCode.Unknown);for(const O of l)R=new h.$ip(R.message?`${R.message}, ${O.message}`:O.message,O.code!==h.ExtensionManagementErrorCode.Unknown&&O.code!==h.ExtensionManagementErrorCode.Internal?O.code:R.code);throw R}async M(i,n,o,l,y,R){if(!this.z.isEnabled())return[];const O=await this.getInstalled(void 0,y,R),E=[],v=[],T=async(U,F)=>{E.push(U);const M=F.extensionDependencies||[],X=[...M];if(F.extensionPack){const K=o?O.find(Q=>(0,$.$Hp)(Q.identifier,U)):void 0;for(const Q of F.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(G=>(0,$.$Hp)({id:G},{id:Q}))||X.every(G=>!(0,$.$Hp)({id:G},{id:Q}))&&X.push(Q)}if(X.length){const K=X.filter(Q=>E.every(G=>!(0,$.$Hp)(G,{id:Q})));if(K.length){const Q=await this.z.getExtensions(K.map(G=>({id:G,preRelease:l})),N.CancellationToken.None);for(const G of Q){if(E.find(z=>(0,$.$Hp)(z,G.identifier)))continue;const ie=M.some(z=>(0,$.$Hp)({id:z},G.identifier));let V;try{V=await this.N(G,!1,l,R)}catch(z){if(ie)throw z;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,L.$$)(z));continue}v.push({gallery:V.extension,manifest:V.manifest}),await T(V.extension.identifier,V.manifest)}}}};return await T(i,n),v}async N(i,n,o,l){let y;const R=await this.getExtensionsControlManifest();if(R.malicious.some(v=>(0,$.$Hp)(i.identifier,v)))throw new h.$ip(m.localize(1,null,i.identifier.id),h.ExtensionManagementErrorCode.Malicious);const O=R.deprecated[i.identifier.id.toLowerCase()];if(O?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${O.extension.id}' extension instead.`),y=(await this.z.getExtensions([{id:O.extension.id,preRelease:O.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:l},N.CancellationToken.None))[0],!y)throw new h.$ip(m.localize(2,null,i.identifier.id,O.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const v=await this.getTargetPlatform();throw new h.$ip(m.localize(3,null,i.identifier.id,this.G.nameLong,(0,h.$ap)(v)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.O(i,n,o,l),!y)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],N.CancellationToken.None))[0]?new h.$ip(m.localize(4,null,i.displayName??i.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$ip(m.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",y.identifier.id);const E=await this.z.getManifest(y,N.CancellationToken.None);if(E===null)throw new h.$ip(`Missing manifest for extension ${y.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(E.version!==y.version)throw new h.$ip(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:E}}async O(i,n,o,l){const y=await this.getTargetPlatform();let R=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(R=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:y,compatible:!0,productVersion:l},N.CancellationToken.None))[0]||null),!R&&await this.z.isExtensionCompatible(i,o,y,l)&&(R=i),R||(n?R=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:y,compatible:!0,productVersion:l},N.CancellationToken.None))[0]||null:R=await this.z.getCompatibleExtension(i,o,y,l)),R}async P(i,n){const o={...n,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},l=T=>`${T.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(l(i.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const R=T=>{const U=this.Z(T,o);return this.m.set(l(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped}),U},O=(T,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Op)(T),error:U}),this.u.fire({identifier:T.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:T.isApplicationScoped})},E=[],v=[];try{E.push(R(i));const T=await this.getInstalled(c.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const U=this.S(i,T);for(const F of U)this.m.has(l(F.identifier))?this.F.info("Extensions is already requested to uninstall",F.identifier.id):E.push(R(F))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(E.map(U=>U.extension),T,i),await this.L(E.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,o,N.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,h.StatisticType.Uninstall)}catch{}O(U.extension)}catch(F){const M=u(F);throw O(U.extension,M),M}finally{v.push(U)}}))}catch(T){const U=u(T);for(const F of E){try{F.cancel()}catch{}v.includes(F)||O(F.extension,U)}throw U}finally{for(const T of E)this.m.delete(l(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}Q(i,n,o){for(const l of i){const y=this.U(l,n);if(y.length){const R=y.filter(O=>!i.some(E=>(0,$.$Hp)(E.identifier,O.identifier)));if(R.length)throw new Error(this.R(l,R,o))}}}R(i,n,o){return o===i?n.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(i,n,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const y=n.filter(O=>!O.isBuiltin&&l.some(E=>(0,$.$Hp)({id:E},O.identifier))),R=[];for(const O of y)R.push(...this.S(O,n,o));return[...y,...R]}return[]}U(i,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,$.$Hp)({id:l},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$$)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$yq=d,e.$yq=d=ve([Z(0,h.$gp),Z(1,f.$0l),Z(2,p.$Il),Z(3,g.$$j),Z(4,b.$rk),Z(5,I.$Kl)],d);function u(r,i){if(r instanceof h.$ip)return r;let n;return r instanceof h.$hp?n=new h.$ip(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.$ip(r.message,(0,L.$5)(r)?h.ExtensionManagementErrorCode.Cancelled:i??h.ExtensionManagementErrorCode.Internal),n.stack=r.stack,n}function t(r,i,{extensionData:n,verificationStatus:o,duration:l,error:y,source:R,durationSinceUpdate:O}){let E,v;(0,w.$mg)(o)&&(o===!0?o="Verified":(o===!1||(E=h.ExtensionManagementErrorCode.Signature,v=o),o="Unverified")),y&&(E=y.code,y.code===h.ExtensionManagementErrorCode.Signature&&(v=y.message)),r.publicLog(i,{...n,verificationStatus:o,success:!y,duration:l,errorcode:E,errorcodeDetail:v,durationSinceUpdate:O,source:R})}class s{constructor(){this.d=new a.$Dh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$rh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$rh)(i=>new Promise((n,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new L.$6)})})),this.d.open()),this.g.cancel()}}e.$Aq=s}),define(le[53],he([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class I extends Error{constructor(r,i){super(r),this.code=i}}e.$Bq=I,e.$Cq=(0,m.$Ei)("IExtensionsProfileScannerService");let d=class extends N.$Vc{constructor(r,i,n,o,l,y){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=l,this.t=y,this.b=this.B(new L.$le),this.onAddExtensions=this.b.event,this.c=this.B(new L.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$le),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,n){const o=[],l=[];try{return await this.u(i,y=>{const R=[];if(n)R.push(...y);else for(const O of y)r.some(([E])=>(0,w.$Hp)(E.identifier,O.identifier)&&E.manifest.version!==O.version)?o.push(O):R.push(O);for(const[O,E]of r){const v=R.findIndex(U=>(0,w.$Hp)(U.identifier,O.identifier)&&U.version===O.manifest.version),T={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:E};v===-1?(l.push(T),R.push(T)):R.splice(v,1,T)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),R}),l.length&&this.c.fire({extensions:l,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),l}catch(y){throw l.length&&this.c.fire({extensions:l,error:y,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:y,profileLocation:i}),y}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const l=[];for(const y of o){const R=r.find(([O])=>(0,w.$Hp)(O.identifier,y.identifier)&&O.manifest.version===y.version);R&&(y.metadata={...y.metadata,...R[1]},n.push(y)),l.push(y)}return l}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const l=[];for(const y of o)(0,w.$Hp)(y.identifier,r.identifier)?n.push(y):l.push(y);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],l;try{const y=await this.m.readFile(r);l=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,S.$pl)(y)!==S.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,b.$$)(y),p.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.w(r);let y=!1;for(const R of l){u(R)||this.w(r);let O;if((0,g.$eg)(R.relativeLocation)&&R.relativeLocation)O=this.z(R.relativeLocation);else if((0,g.$eg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{O=k.URI.revive(R.location);const E=this.y(O);E&&(y=!0,R.relativeLocation=E)}(0,g.$lg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(y=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:O,version:R.version,metadata:R.metadata})}y&&await this.m.writeFile(r,a.$Ne.fromString(JSON.stringify(l)))}if(i){o=i(o);const y=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(r,a.$Ne.fromString(JSON.stringify(y)))}return o})}w(r){const i=new I(`Invalid extensions content in ${r.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(l){if((0,S.$pl)(l)===S.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(y=>u(y))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Ne.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$pl)(l)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(r)}catch(l){(0,S.$pl)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$pl)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Lh,this.h.set(r,i)),i}};e.$Dq=d,e.$Dq=d=ve([Z(1,S.$$k),Z(2,$.$Kl),Z(3,c.$Il),Z(4,f.$0l),Z(5,h.$$j)],d);function u(s){return(0,g.$gg)(s)&&(0,A.$fp)(s.identifier)&&(t(s.location)||(0,g.$eg)(s.location)&&s.location)&&((0,g.$lg)(s.relativeLocation)||(0,g.$eg)(s.relativeLocation))&&s.version&&(0,g.$eg)(s.version)}function t(s){return s?(0,g.$eg)(s.path)&&(0,g.$eg)(s.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[85],he([0,1,19,6,30,15,8,34,144,2,23,14,5,21,57,92,13,9,165,16,33,37,73,7,4,10,24,3,68,53,20,29,194]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t,s,r,i,n,o,l,y,R,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Iq=e.$Hq=e.$Gq=e.Translations=void 0,e.$Jq=X,N=ke(N),m=ke(m),h=ke(h),c=ke(c),g=it(g);var v;(function(Q){function G(ie,V){if(ie===V)return!0;const z=Object.keys(ie),ee=new Set;for(const re of Object.keys(V))ee.add(re);if(z.length!==ee.size)return!1;for(const re of z){if(ie[re]!==V[re])return!1;ee.delete(re)}return ee.size===0}Q.equals=G})(v||(e.Translations=v={})),e.$Gq=(0,r.$Ei)("IExtensionsScannerService");let T=class extends w.$Vc{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=ee,this.u=re,this.w=ce,this.y=q,this.z=x,this.C=J,this.D=H,this.F=D,this.g=this.B(new o.$le),this.onDidChangeCache=this.g.event,this.h=(0,$.$fh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(u.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(u.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Sp)(this.w,this.y)),this.G}async scanAllExtensions(G,ie,V){const[z,ee]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(ie)]),re=V?await this.scanExtensionsUnderDevelopment(G,[...z,...ee]):[];return this.L(z,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const ie=[];ie.push(this.M(!!G.useCache,G.language)),ie.push(this.N(G.language,!!G.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],u.ExtensionType.System,G,!1)}async scanUserExtensions(G){const ie=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!G.profileLocation,u.ExtensionType.User,!G.includeUninstalled,G.language,!0,V,G.productVersion??this.R()),ee=G.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let re;try{re=await ee.scanExtensions(z)}catch(ce){if(ce instanceof y.$Bq&&ce.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),re=await ee.scanExtensions(z);else throw ce}return re=await this.J(re,u.ExtensionType.User,G,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(G,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const ee=await this.P(z,!1,u.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=ie.find(q=>(0,d.$Hp)(q.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,ee)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanExtension(z);return!ee||!V.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(z);return this.J(ee,ie,V,!0)}async scanMultipleExtensions(G,ie,V){const z=[];return await Promise.all(G.map(async ee=>{const re=await this.scanOneOrMultipleExtensions(ee,ie,V);z.push(...re)})),this.J(z,ie,V,!0)}async scanMetadata(G){const ie=(0,$.$fh)(G,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,ie){const V=(0,$.$fh)(G,"package.json"),z=(await this.w.readFile(V)).value.toString(),ee=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,$.$fh)(G,"package.json"),L.$Ne.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof y.$Bq&&G.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Ne.fromString(JSON.stringify([])))}catch(ie){(0,s.$pl)(ie)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$$)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,ie,V,z){return V.includeAllVersions||(G=this.L(ie===u.ExtensionType.System?G:void 0,ie===u.ExtensionType.User?G:void 0,ie==="development"?G:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(G=G.filter(ee=>ee.isValid)),G.sort((ee,re)=>{const ce=m.$oc(ee.location.fsPath),q=m.$oc(re.location.fsPath);return ce<q?-1:ce>q?1:0})}L(G,ie,V,z,ee){const re=(q,x,J)=>{if(q.isValid&&!x.isValid)return!1;if(q.isValid===x.isValid){if(ee&&c.gt(q.manifest.version,x.manifest.version))return this.y.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(c.eq(q.manifest.version,x.manifest.version)){if(q.type===u.ExtensionType.System)return this.y.debug(`Skipping extension ${x.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===z)return this.y.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${q.location.path} with ${x.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${x.location.path}.`),!0},ce=new u.$rn;return G?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),ie?.forEach(q=>{const x=ce.get(q.identifier.id);if(!x&&G&&q.type===u.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),V?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!0))&&ce.set(q.identifier.id,q),ce.set(q.identifier.id,q)}),[...ce.values()]}async M(G,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,u.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(G,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},ee=[],re=f.URI.file(m.$ic(m.$kc(S.$Yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of V){const x=z[q.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ee.push((0,$.$fh)(re,q.name));break;default:ee.push(f.URI.file(x));break}}const ce=await Promise.all(ee.map(async q=>this.n.scanExtension(await this.P(q,!1,u.ExtensionType.System,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,P.$Ib)(ce)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,ie,V,z,ee,re,ce,q){const x=await this.f(ee??h.$w),J=await this.Q(G),H=ie&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=H?await this.Q(H):void 0;return new U(G,J,H,D,ie,ce,V,z,re,q.version,q.date,this.C.commit,!this.z.isBuilt,ee,x)}async Q(G){try{const ie=await this.w.stat(G);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Hq=T,e.$Hq=T=ve([Z(4,R.$Kl),Z(5,y.$Cq),Z(6,s.$$k),Z(7,i.$$j),Z(8,I.$Li),Z(9,n.$rk),Z(10,O.$Il),Z(11,r.$Di)],T);class U{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D,B,j,W){this.location=G,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=ee,this.profileScanOptions=re,this.type=ce,this.excludeObsolete=q,this.validate=x,this.productVersion=J,this.productDate=H,this.productCommit=D,this.devMode=B,this.language=j,this.translations=W}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,ie){return(0,$.$$g)(G.location,ie.location)&&G.mtime===ie.mtime&&(0,$.$$g)(G.applicationExtensionslocation,ie.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&G.profile===ie.profile&&N.$fo(G.profileScanOptions,ie.profileScanOptions)&&G.type===ie.type&&G.excludeObsolete===ie.excludeObsolete&&G.validate===ie.validate&&G.productVersion===ie.productVersion&&G.productDate===ie.productDate&&G.productCommit===ie.productCommit&&G.devMode===ie.devMode&&G.language===ie.language&&v.equals(G.translations,ie.translations)}}e.$Iq=U;let F=class extends w.$Vc{constructor(G,ie,V,z,ee){super(),this.f=G,this.g=ie,this.h=V,this.j=z,this.m=ee}async scanExtensions(G){const ie=G.profile?await this.r(G):await this.n(G);let V={};if(G.excludeObsolete&&G.type===u.ExtensionType.User)try{const z=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(z)}catch{}return(0,b.$rg)(V)?ie:ie.filter(z=>!V[d.$Ip.create(z).toString()])}async n(G){const ie=await this.j.resolve(G.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||G.type===u.ExtensionType.User&&(0,$.$ch)(z.resource).indexOf(".")===0)return null;const ee=new U(z.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ee)}));return(0,P.$Ib)(V).sort((z,ee)=>z.location.path<ee.location.path?-1:1)}async r(G){let ie=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.s(G.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,G);ie.push(...V)}return ie}async s(G,ie,V){const z=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!z.length)return[];const ee=await Promise.all(z.map(async re=>{if(ie(re)){const ce=new U(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ce,re.metadata)}return null}));return(0,P.$Ib)(ee)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,$.$fh)(G.location,"package.json"))){const ie=await this.scanExtension(G);return ie?[ie]:[]}else return await this.scanExtensions(G)}catch(ie){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,C.$$)(ie)),[]}}async scanExtension(G,ie){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=u.$ln),ie=ie??V.__metadata,delete V.__metadata;const z=(0,d.$Mp)(V.publisher,V.name),ee=ie?.id?{id:z,uuid:ie.id}:{id:z},re=ie?.isSystem?u.ExtensionType.System:G.type,ce=re===u.ExtensionType.System||!!ie?.isBuiltin;V=await this.t(G.location,V,U.createNlsConfiguration(G));const q={type:re,identifier:ee,manifest:V,location:G.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??u.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return G.validate?this.validate(q,G):q}}catch(V){G.type!==u.ExtensionType.System&&this.m.error(V)}return null}validate(G,ie){let V=!0;const z=(0,t.$Xp)(ie.productVersion,ie.productDate,ie.location,G.manifest,G.isBuiltin);for(const[ee,re]of z)ee===g.default.Error&&(V=!1,this.m.error(this.z(ie.location,re)));return G.isValid=V,G.validations=z,G}async scanExtensionManifest(G){const ie=(0,$.$fh)(G,"package.json");let V;try{V=(await this.j.readFile(ie)).value.toString()}catch(ee){return(0,s.$pl)(ee)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(G,(0,p.localize)(0,null,ie.path,ee.message))),null}let z;try{z=JSON.parse(V)}catch{const re=[];(0,k.$Un)(V,re);for(const ce of re)this.m.error(this.z(G,(0,p.localize)(1,null,ie.path,ce.offset,ce.length,(0,A.$Eq)(ce.error))));return null}return(0,k.$4n)(z)!=="object"?(this.m.error(this.z(G,(0,p.localize)(2,null,ie.path))),null):z}async t(G,ie,V){const z=await this.u(G,ie,V);if(z)try{const ee=[],re=await this.w(z.default,ee);if(ee.length>0)return ee.forEach(q=>{this.m.error(this.z(G,(0,p.localize)(3,null,z.default?.path,(0,A.$Eq)(q.error))))}),ie;if((0,k.$4n)(z)!=="object")return this.m.error(this.z(G,(0,p.localize)(4,null,z.default?.path))),ie;const ce=z.values||Object.create(null);return(0,E.$Fq)(this.m,ie,ce,re)}catch{}return ie}async u(G,ie,V){const z=(0,$.$fh)(G,"package.nls.json"),ee=(x,J)=>{J.forEach(H=>{this.m.error(this.z(G,(0,p.localize)(5,null,x?.path,(0,A.$Eq)(H.error))))})},re=x=>{this.m.error(this.z(G,(0,p.localize)(6,null,x?.path)))},ce=`${ie.publisher}.${ie.name}`,q=V.translations[ce];if(q)try{const x=f.URI.file(q),J=(await this.j.readFile(x)).value.toString(),H=[],D=(0,k.$Un)(J,H);return H.length>0?(ee(x,H),{values:void 0,default:z}):(0,k.$4n)(D)!=="object"?(re(x),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let J;try{J=await this.y(G,V)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const H=(await this.j.readFile(J.localized)).value.toString(),D=[],B=(0,k.$Un)(H,D);return D.length>0?(ee(J.localized,D),{values:void 0,default:J.original}):(0,k.$4n)(B)!=="object"?(re(J.localized),{values:void 0,default:J.original}):{values:B,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(G,ie){if(G)try{const V=(await this.j.readFile(G)).value.toString();return(0,k.$Un)(V,ie)}catch{}}y(G,ie){return new Promise((V,z)=>{const ee=re=>{const ce=(0,$.$fh)(G,`package.nls.${re}.json`);this.j.exists(ce).then(q=>{q&&V({localized:ce,original:(0,$.$fh)(G,"package.nls.json")});const x=re.lastIndexOf("-");x===-1?V({localized:(0,$.$fh)(G,"package.nls.json"),original:null}):(re=re.substring(0,x),ee(re))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,$.$fh)(G,"package.nls.json"),original:null});ee(ie.language)})}z(G,ie){return`[${G.path}]: ${ie}`}};F=ve([Z(1,y.$Cq),Z(2,O.$Il),Z(3,s.$$k),Z(4,i.$$j)],F);let M=class extends F{constructor(G,ie,V,z,ee,re,ce){super(ie,z,ee,re,ce),this.G=G,this.H=V,this.D=this.B(new a.$Ch(3e3)),this.F=this.B(new o.$le),this.onDidChangeCache=this.F.event}async scanExtensions(G){const ie=this.M(G),V=await this.I(ie);if(this.C=G,V&&V.input&&U.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",G.type===u.ExtensionType.System?"system":"user",G.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const z=await super.scanExtensions(G);return await this.J(ie,{input:G,result:z}),z}async I(G){try{const ie=await this.j.readFile(G),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,l.$bi)(V.input)}}catch(ie){this.m.debug("Error while reading the extension cache file:",G.path,(0,C.$$)(ie))}return null}async J(G,ie){try{await this.j.writeFile(G,L.$Ne.fromString(JSON.stringify(ie)))}catch(V){this.m.debug("Error while writing the extension cache file:",G.path,(0,C.$$)(V))}}async L(){if(!this.C)return;const G=this.M(this.C),ie=await this.I(G);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$fo(z,V))try{this.m.info("Invalidating Cache",V,z),await this.j.del(G),this.F.fire()}catch(ee){this.m.error(ee)}}M(G){const ie=this.N(G);return this.h.extUri.joinPath(ie.cacheHome,G.type===u.ExtensionType.System?u.$kn:u.$jn)}N(G){return G.type===u.ExtensionType.System?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ie=>this.h.extUri.isEqual(G.location,ie.extensionsResource))??this.G:this.H.defaultProfile}};M=ve([Z(2,R.$Kl),Z(3,y.$Cq),Z(4,O.$Il),Z(5,s.$$k),Z(6,i.$$j)],M);function X(Q,G){const ie=(0,d.$Kp)(Q.manifest.publisher,Q.manifest.name);return{id:ie,identifier:new u.$pn(ie),isBuiltin:Q.type===u.ExtensionType.System,isUserBuiltin:Q.type===u.ExtensionType.User&&Q.isBuiltin,isUnderDevelopment:G,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,publisherDisplayName:Q.publisherDisplayName,...Q.manifest}}class K extends T{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D){super(G,ie,(0,$.$fh)(V,".vscode-oss-dev","extensions","control.json"),z,ee,re,ce,q,x,J,H,D),this.S=(async()=>{if(h.$z)try{const B=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Kq=K}),define(le[251],he([0,1,69,6,41,3,2,23,14,31,10,20]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let h=class extends C.$Vc{constructor(c,g){super(),this.b=c,this.f=g,this.a=new a.$Kh(5)}async postUninstall(c){const g=this.g(c,"uninstall");g&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(g.script,"uninstall",g.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(b)}}));try{await w.Promises.rm(this.m(c))}catch(b){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(b)}}g(c,g){const b=`vscode:${g}`;if(c.location.scheme===k.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const f=c.manifest.scripts[b].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:(0,A.$kc)(c.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(c,g,b,f,p){return new Promise((I,d)=>{const u=this.j(c,g,b,p);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?d(r):I(void 0)};u.on("error",r=>{s((0,N.$pj)(r)||"Unknown")}),u.on("exit",(r,i)=>{s(r?`post-${g} process exited with code ${r}`:void 0)}),f&&(t=setTimeout(()=>{t=null,u.kill(),d("timed out")},5e3))})}j(c,g,b,f){const p={silent:!0,execArgv:void 0},I=(0,P.fork)(c,[`--type=extension-post-${g}`,...b],p);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(I.stdout,"data"),u=L.Event.fromNodeEventEmitter(I.stderr,"data");this.B(d(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${g}`,r))),this.B(u(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${g}`,r)));const t=L.Event.any(L.Event.map(d,r=>({data:`%c${r}`,format:[""]}),this.q),L.Event.map(u,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return L.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),I}m(c){return(0,A.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$Oq=h,e.$Oq=h=ve([Z(0,m.$Kl),Z(1,S.$$j)],h)}),define(le[117],he([0,1,72,167,84,28]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=C,e.$Mq=k;function C(A){let w=L.ExtensionManagementErrorCode.Extract;return A instanceof P.$uq&&(A.type==="CorruptZip"?w=L.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(w=L.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$zq)(A,w)}async function k(A){let w;try{w=await(0,P.$xq)(A,"extension/package.json")}catch(S){throw C(S)}try{return JSON.parse(w.toString("utf8"))}catch{throw new L.$ip((0,a.localize)(0,null),L.ExtensionManagementErrorCode.Invalid)}}}),define(le[252],he([0,1,6,8,2,23,21,57,13,32,31,72,22,16,84,28,33,117,111,7,10,18]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0,k=ke(k);let s=class extends N.$Vc{static{t=this}static{this.c=".sigzip"}constructor(i,n,o,l,y,R,O){super(),this.h=n,this.j=o,this.m=l,this.n=y,this.r=R,this.t=O,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,n,o,l){await this.g;const y=await this.w(i,n);let R=!1;if(o&&this.u(i)){let O;try{O=await this.y(i)}catch(E){try{await this.delete(y)}catch(v){this.t.error(v)}throw E}try{R=await this.n.verify(i,y.fsPath,O.fsPath,l)}catch(E){if(R=E.code,R===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(y)}catch(v){this.t.error(v)}throw new g.$ip(m.$tq,g.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(O)}catch(E){this.t.error(E)}}}return{location:y,verificationStatus:R}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,A.$kg)(n)?n:!0}async w(i,n){try{const o=(0,C.$fh)(this.extensionsDownloadDir,this.G(i)),l=await this.C(i,"vsix",async()=>{await this.z(i,o,y=>this.j.download(i,y,n));try{await this.D(o.fsPath,"extension/package.json")}catch(y){try{await this.h.del(o)}catch(R){this.t.warn(`Error while deleting: ${o.path}`,(0,a.$$)(R))}throw y}},2);return l>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:l}),o}catch(o){throw(0,c.$zq)(o,g.ExtensionManagementErrorCode.Download)}}async y(i){try{const n=(0,C.$fh)(this.extensionsDownloadDir,`.${(0,w.$1g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,n);try{await this.D(n.fsPath,".signature.p7s")}catch(l){try{await this.h.del(n)}catch(y){this.t.warn(`Error while deleting: ${n.path}`,(0,a.$$)(y))}throw l}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),n}catch(n){throw(0,c.$zq)(n,g.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,n,o){if(await this.h.exists(n))return;if(n.scheme!==L.Schemas.file){await o(n);return}const l=(0,C.$fh)(this.extensionsDownloadDir,`.${(0,w.$1g)()}`);try{await o(l)}catch(y){try{await this.h.del(l)}catch{}throw y}try{await S.Promises.rename(l.fsPath,n.fsPath,2*60*1e3)}catch(y){try{await this.h.del(l)}catch{}let R=!1;try{R=await this.h.exists(n)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,a.$$)(y)}. Deleted the file from downloaded location`,l.path),y}}async C(i,n,o,l){let y=1;for(;;)try{return await o(),y}catch(R){if(y++>l)throw R;this.t.warn(`Failed downloading ${n}. ${(0,a.$$)(R)}. Retry again...`,i.identifier.id)}}async D(i,n){try{await(0,m.$xq)(i,n)}catch(o){throw(0,f.$Lq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],o=[],l=[];for(const O of i.children)if(O.name.endsWith(t.c))l.push(O.resource);else{const E=b.$Ip.parse(O.name);E&&o.push([E,O])}const y=(0,b.$Np)(o,([O])=>O),R=[];for(const O of y)O.sort((E,v)=>k.rcompare(E[0].version,v[0].version)),n.push(...O.slice(1).map(E=>E[1].resource)),R.push(O[0][1]);R.sort((O,E)=>O.mtime-E.mtime),n.push(...R.slice(0,Math.max(0,R.length-this.f)).map(O=>O.resource)),n.push(...l),await P.Promises.settled(n.map(O=>(this.t.trace("Deleting from cache",O.path),this.h.del(O))))}}catch(i){this.t.error(i)}}G(i){return this.f?b.$Ip.create(i).toString().toLowerCase():(0,w.$1g)()}};e.$Nq=s,e.$Nq=s=t=ve([Z(0,$.$Mi),Z(1,I.$$k),Z(2,g.$gp),Z(3,h.$$i),Z(4,p.$mq),Z(5,u.$0l),Z(6,d.$$j)],s)}),define(le[118],he([0,1,6,15,26,41,8,3,56,2,35,23,14,21,57,13,9,32,31,72,166,99,16,84,28,33,53,85,252,251,117,224,234,37,73,7,4,10,24,18,29,20]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t,s,r,i,n,o,l,y,R,O,E,v,T,U,F,M,X,K,Q,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0,h=ke(h),c=ke(c),p=ke(p),d=ke(d),e.$Rq=(0,F.$Fi)(r.$jp);const ie=".vsctmp";let V=class extends s.$yq{constructor(q,x,J,H,D,B,j,W,te,_,Y,ae){super(q,x,Y,J,_,ae),this.eb=D,this.fb=B,this.gb=j,this.hb=W,this.ib=te,this.db=new Map,this.tb=new S.$Cc;const ue=this.B(W.createInstance(y.$Oq));this.ab=this.B(W.createInstance(z,we=>ue.postUninstall(we))),this.bb=this.B(new O.$Pq(ae,te,Y,this,this.F)),this.cb=this.B(W.createInstance(l.$Nq));const ge=this.B(new E.$Qq(this,this.eb,ae,B,Y,te,J));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Sp)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.rb(q),J=await(0,I.zip)((0,$.$fh)(this.cb.extensionsDownloadDir,(0,f.$1g)()).fsPath,x);return b.URI.file(J)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:x,cleanup:J}=await this.lb(q),H=h.$lc(x.fsPath);try{return await(0,R.$Mq)(H)}finally{await J()}}getInstalled(q,x=this.H.defaultProfile.extensionsResource,J={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,x,J)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,x={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:J,cleanup:H}=await this.lb(q);try{const D=await(0,R.$Mq)(h.$lc(J.fsPath)),B=(0,i.$Mp)(D.publisher,D.name);if(D.engines&&D.engines.vscode&&!(0,T.$Zp)(D.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,B,this.G.version));const W=(await this.I([{manifest:D,extension:J,options:x}])).find(({identifier:te})=>(0,i.$Hp)(te,{id:B}));if(W?.local)return W.local;throw W?.error?W.error:(0,s.$zq)(new Error(`Unknown error while installing extension ${B}`))}finally{await H()}}async installFromLocation(q,x){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const J=await this.ab.scanUserExtensionAtLocation(q);if(!J||!J.manifest.name||!J.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[J,{source:"resource"}]],x),this.F.info("Successfully installed extension",J.identifier.id,x.toString()),J}async installExtensionsFromProfile(q,x,J){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,x.toString(),J.toString());const H=(await this.getInstalled(v.ExtensionType.User,x)).filter(D=>q.some(B=>(0,i.$Hp)(B,D.identifier)));if(H.length){const D=await Promise.all(H.map(B=>this.ab.scanMetadata(B,x)));await this.wb(H.map((B,j)=>[B,D[j]]),J),this.F.info("Successfully installed extensions",H.map(B=>B.identifier.id),J.toString())}return H}async updateMetadata(q,x,J){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0,x.hasPreReleaseVersion=!0),x.isMachineScoped===!1&&(x.isMachineScoped=void 0),x.isBuiltin===!1&&(x.isBuiltin=void 0),x.pinned===!1&&(x.pinned=void 0),q=await this.ab.updateMetadata(q,x,J),this.bb.invalidate(J),this.w.fire({local:q,profileLocation:J}),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const x=await this.getTargetPlatform(),[J]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:x,compatible:!0},N.CancellationToken.None);if(!J)throw new Error(d.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(H){throw new Error(d.localize(3,null,(0,L.$pj)(H)))}return this.installFromGallery(J)}$(q,x,J,H){return this.ab.copyExtension(q,x,J,H)}copyExtensions(q,x){return this.ab.copyExtensions(q,x,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,x,J){const{location:H}=await this.cb.download(q,x,!J);return H}async lb(q){if(q.scheme===m.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const x=(0,$.$fh)(this.cb.extensionsDownloadDir,(0,f.$1g)());return await this.gb.download(q,x),this.F.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.ib.del(x)}catch(H){this.F.error(H)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,x,J){const H=x instanceof b.URI?new i.$Ip({id:(0,i.$Mp)(q.publisher,q.name)},q.version):i.$Ip.create(x);return this.hb.createInstance(ee,H,q,x,J,(D,B)=>{if(x instanceof b.URI)return this.qb(H,x,J,B);let j=this.db.get(H.toString());return j||(this.db.set(H.toString(),j=this.pb(H,x,D,J,B)),j.finally(()=>this.db.delete(H.toString()))),j},this.ab)}Z(q,x){return new re(q,x.profileLocation,this.fb)}async pb(q,x,J,H,D){const{verificationStatus:B,location:j}=await this.cb.download(x,J,!H.donotVerifySignature,H.context?.[r.$_o]);try{if(D.isCancellationRequested)throw new C.$6;return await(0,R.$Mq)(j.fsPath),{local:await this.ab.extractUserExtension(q,j.fsPath,{id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName,targetPlatform:x.properties.targetPlatform,isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,preRelease:(0,g.$kg)(H.preRelease)?H.preRelease:H.installPreReleaseVersion||x.properties.isPreReleaseVersion,source:"gallery"},!1,D),verificationStatus:B}}catch(W){try{await this.cb.delete(j)}catch(te){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,C.$$)(te))}throw(0,s.$zq)(W)}}async qb(q,x,J,H){return{local:await this.ab.extractUserExtension(q,h.$lc(x.fsPath),{isApplicationScoped:J.isApplicationScoped,isMachineScoped:J.isMachineScoped,isBuiltin:J.isBuiltin,installedTimestamp:Date.now(),pinned:J.installGivenVersion?!0:!!J.pinned,source:"vsix"},!0,H)}}async rb(q){const x=async H=>{let D=await p.Promises.readdir(H);D=D.map(W=>h.$kc(H,W));const B=await Promise.all(D.map(W=>p.Promises.stat(W)));let j=Promise.resolve([]);return B.forEach((W,te)=>{const _=D[te];W.isFile()&&(j=j.then(Y=>[...Y,_])),W.isDirectory()&&(j=j.then(Y=>x(_).then(ae=>[...Y,...ae])))}),j};return(await x(q.location.fsPath)).map(H=>({path:`extension/${h.$mc(q.location.fsPath,H)}`,localPath:H}))}async sb({added:q,removed:x}){if(x){const J=q&&this.D.extUri.isEqual(x.profileLocation,q.profileLocation)?x.extensions.filter(H=>q.extensions.every(D=>!(0,i.$Hp)(D,H))):x.extensions;for(const H of J)this.F.info("Extensions removed from another source",H.id,x.profileLocation.toString()),this.u.fire({identifier:H,profileLocation:x.profileLocation})}if(q){const H=(await this.getInstalled(v.ExtensionType.User,q.profileLocation)).filter(D=>q.extensions.some(B=>(0,i.$Hp)(B,D.identifier)));this.s.fire(H.map(D=>(this.F.info("Extensions added from another source",D.identifier.id,q.profileLocation.toString()),{identifier:D.identifier,local:D,profileLocation:q.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(x=>this.tb.add(x)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const x of q.children??[])x.isDirectory&&this.tb.add(x.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(x=>this.vb(x)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,U.FileChangeType.ADDED))return;const x=[];for(const J of q.rawAdded){if(this.tb.has(J)||!this.D.extUri.isEqual(this.D.extUri.dirname(J),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(J,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(J).startsWith(".")||!(await this.ib.stat(J)).isDirectory)continue;const H=await this.ab.scanUserExtensionAtLocation(J);H&&H.installedTimestamp===void 0&&(this.tb.add(J),x.push(H))}x.length&&(await this.wb(x.map(J=>[J,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",x.map(J=>J.identifier.id)))}async wb(q,x){const J=q.map(H=>H[0]);await this.xb(J),await this.fb.addExtensionsToProfile(q,x),this.s.fire(J.map(H=>({local:H,identifier:H.identifier,operation:r.InstallOperation.None,profileLocation:x})))}async xb(q){const x=await this.ab.getUninstalledExtensions();for(const J of q){const H=i.$Ip.create(J);x[H.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",H.id),await this.ab.setInstalled(H),this.F.info("Removed the extension from uninstalled list:",H.id))}}};e.$Sq=V,e.$Sq=V=ve([Z(0,r.$gp),Z(1,K.$0l),Z(2,M.$$j),Z(3,t.$Mi),Z(4,o.$Gq),Z(5,n.$Cq),Z(6,u.$Wo),Z(7,F.$Di),Z(8,U.$$k),Z(9,X.$rk),Z(10,Q.$Il),Z(11,G.$Kl)],V);let z=class extends w.$Vc{constructor(q,x,J,H,D,B){super(),this.n=q,this.s=x,this.t=J,this.u=H,this.w=D,this.y=B,this.h=this.B(new k.$le),this.onExtract=this.h.event,this.c=(0,$.$fh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Lh}async cleanUp(){await this.I(),await this.H()}async scanExtensions(q,x,J){try{const H={includeInvalid:!0,profileLocation:x,productVersion:J};let D=[];return q===null||q===v.ExtensionType.System?(this.j||(this.j=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},H,!1).finally(()=>this.j=void 0)),D.push(...await this.j)):q===v.ExtensionType.User&&(this.m||(this.m=this.t.scanUserExtensions(H).finally(()=>this.m=void 0)),D.push(...await this.m)),D=q!==null?D.filter(B=>B.type===q):D,await Promise.all(D.map(B=>this.G(B)))}catch(H){throw(0,s.$zq)(H,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const x=await this.t.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(x.map(J=>this.G(J)))}catch(x){throw(0,s.$zq)(x,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const x=await this.t.scanExistingExtension(q,v.ExtensionType.User,{includeInvalid:!0});if(x)return await this.G(x)}catch(x){this.y.error(x)}return null}async extractUserExtension(q,x,J,H,D){const B=q.toString(),j=b.URI.file(h.$kc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$1g)()}`)),W=b.URI.file(h.$kc(this.t.userExtensionsLocation.fsPath,B));let te=await this.s.exists(W);if(te&&H){try{await this.C(q.id,W,"removeExisting")}catch{throw new r.$ip(d.localize(4,null,W.fsPath,q.id),r.ExtensionManagementErrorCode.Delete)}te=!1}if(te)try{await this.t.updateMetadata(W,J)}catch(_){throw(0,s.$zq)(_,r.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(D.isCancellationRequested)throw new C.$6;try{this.y.trace(`Started extracting the extension from ${x} to ${W.fsPath}`),await(0,I.$wq)(x,j.fsPath,{sourcePath:"extension",overwrite:!0},D),this.y.info(`Extracted extension to ${W}:`,q.id)}catch(_){throw(0,R.$Lq)(_)}try{await this.t.updateMetadata(j,J)}catch(_){throw(0,s.$zq)(_,r.ExtensionManagementErrorCode.UpdateMetadata)}if(D.isCancellationRequested)throw new C.$6;try{this.y.trace(`Started renaming the extension from ${j.fsPath} to ${W.fsPath}`),await this.F(j.fsPath,W.fsPath),this.y.info("Renamed to",W.fsPath)}catch(_){if(_.code==="ENOTEMPTY"){this.y.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.y.info(`Rename failed because of ${(0,C.$$)(_)}. Deleted from extracted location`,j),_}this.h.fire(W)}catch(_){try{await this.s.del(j,{recursive:!0})}catch{}throw _}return this.scanLocalExtension(W,v.ExtensionType.User)}async scanMetadata(q,x){return x?(await this.z(q,x))?.metadata:this.t.scanMetadata(q.location)}async z(q,x){return(await this.u.scanProfileExtensions(x)).find(H=>(0,i.$Hp)(H.identifier,q.identifier))}async updateMetadata(q,x,J){try{J?await this.u.updateMetadata([[q,x]],J):await this.t.updateMetadata(q.location,x)}catch(H){throw(0,s.$zq)(H,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(q.location,q.type,J)}async getUninstalledExtensions(){try{return await this.D()}catch(q){throw(0,s.$zq)(q,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const x=q.map(J=>i.$Ip.create(J));await this.D(J=>x.forEach(H=>{J[H.toString()]=!0,this.y.info("Marked extension as uninstalled",H.toString())}))}async setInstalled(q){try{await this.D(x=>delete x[q.toString()])}catch(x){throw(0,s.$zq)(x,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,x){if(this.w.extUri.isEqualOrParent(q.location,this.t.userExtensionsLocation))return this.C(q.identifier.id,q.location,x)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.D(x=>delete x[i.$Ip.create(q).toString()])}async copyExtension(q,x,J,H){const D=await this.z(q,x),B=await this.z(q,J);if(H={...D?.metadata,...H},B)if(this.w.extUri.isEqual(B.location,q.location))await this.u.updateMetadata([[q,{...B.metadata,...H}]],J);else{const j=await this.scanLocalExtension(B.location,q.type,J);await this.u.removeExtensionFromProfile(j,J),await this.u.addExtensionsToProfile([[q,{...B.metadata,...H}]],J)}else await this.u.addExtensionsToProfile([[q,H]],J);return this.scanLocalExtension(q.location,q.type,J)}async copyExtensions(q,x,J){const H=await this.scanExtensions(v.ExtensionType.User,q,J),D=await Promise.all(H.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,q)]));await this.u.addExtensionsToProfile(D,x)}async C(q,x,J){this.y.trace(`Deleting ${J} extension from disk`,q,x.fsPath);const H=this.w.extUri.joinPath(this.w.extUri.dirname(x),`${this.w.extUri.basename(x)}.${(0,A.$sj)((0,f.$1g)()).toString(16)}${ie}`);await this.F(x.fsPath,H.fsPath),await this.s.del(H,{recursive:!0}),this.y.info(`Deleted ${J} extension from disk`,q,x.fsPath)}D(q){return this.g.queue(async()=>{let x;try{x=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(H){if((0,U.$pl)(H)!==U.FileOperationResult.FILE_NOT_FOUND)throw H}let J={};if(x)try{J=JSON.parse(x)}catch{}return q&&(q(J),Object.keys(J).length?await this.s.writeFile(this.c,a.$Ne.fromString(JSON.stringify(J))):await this.s.del(this.c)),J})}async F(q,x){try{await p.Promises.rename(q,x,2*60*1e3)}catch(J){throw(0,s.$zq)(J,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(q,x,J){try{if(J){const D=(await this.t.scanUserExtensions({profileLocation:J})).find(B=>this.w.extUri.isEqual(B.location,q));if(D)return await this.G(D)}else{const H=await this.t.scanExistingExtension(q,x,{includeInvalid:!0});if(H)return await this.G(H)}throw new r.$ip(d.localize(5,null,q.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(H){throw(0,s.$zq)(H,r.ExtensionManagementErrorCode.ScanningExtension)}}async G(q){const x=await this.s.resolve(q.location);let J,H;return x.children&&(J=x.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,H=x.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:J,changelogUrl:H,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async H(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.y.debug("No uninstalled extensions found.");return}this.y.debug("Removing uninstalled extensions:",Object.keys(q));const x=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),J=new Set;for(const D of x)q[i.$Ip.create(D).toString()]||J.add(D.identifier.id.toLowerCase());try{const D=(0,i.$Np)(x,B=>B.identifier);await P.Promises.settled(D.map(async B=>{const j=B.sort((W,te)=>c.rcompare(W.manifest.version,te.manifest.version))[0];J.has(j.identifier.id.toLowerCase())||await this.n(await this.G(j))}))}catch(D){this.y.error(D)}const H=x.filter(D=>D.metadata&&q[i.$Ip.create(D).toString()]);await Promise.allSettled(H.map(D=>this.removeUninstalledExtension(D)))}async I(){this.y.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.s.resolve(this.t.userExtensionsLocation)}catch(x){(0,U.$pl)(x)!==U.FileOperationResult.FILE_NOT_FOUND&&this.y.error(x);return}if(q?.children)try{await Promise.allSettled(q.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(ie))){this.y.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.s.del(x.resource,{recursive:!0}),this.y.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(J){(0,U.$pl)(J)!==U.FileOperationResult.FILE_NOT_FOUND&&this.y.error(J)}}}))}catch{}}};e.$Tq=z,e.$Tq=z=ve([Z(1,U.$$k),Z(2,o.$Gq),Z(3,n.$Cq),Z(4,Q.$Il),Z(5,M.$$j)],z);let ee=class extends s.$Aq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,x,J,H,D,B,j,W,te,_,Y,ae){super(),this.l=q,this.manifest=x,this.source=J,this.options=H,this.m=D,this.n=B,this.o=j,this.p=W,this.q=te,this.s=_,this.t=Y,this.u=ae,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(q){const J=(await this.n.scanExtensions(v.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(j=>(0,i.$Hp)(j.identifier,this.identifier));J&&(this.j=r.InstallOperation.Update);const H={isApplicationScoped:this.options.isApplicationScoped||J?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||J?.isMachineScoped,isBuiltin:this.options.isBuiltin||J?.isBuiltin,isSystem:J?.type===v.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??J?.pinned,source:this.source instanceof b.URI?"vsix":"gallery"};let D;if(this.source instanceof b.URI)if(J){if(this.l.equals(new i.$Ip(J.identifier,J.manifest.version)))try{await this.n.removeExtension(J,"existing")}catch{throw new Error(d.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const j=await this.w(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(H.id=this.source.identifier.uuid,H.publisherId=this.source.publisherId,H.publisherDisplayName=this.source.publisherDisplayName,H.targetPlatform=this.source.properties.targetPlatform,H.updated=!!J,H.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,H.hasPreReleaseVersion=J?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,H.preRelease=(0,g.$kg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||J?.preRelease,J&&J.type!==v.ExtensionType.System&&J.manifest.version===this.source.version)return this.n.updateMetadata(J,H,this.options.profileLocation);D=await this.w(this.l)}if(q.isCancellationRequested)throw(0,s.$zq)(new C.$6);if(!D){const j=await this.m(this.operation,q);D=j.local,this.k=j.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,s.$zq)(j,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,s.$zq)(new C.$6);try{await this.t.addExtensionsToProfile([[D,H]],this.options.profileLocation,!D.isValid)}catch(j){throw(0,s.$zq)(j,r.ExtensionManagementErrorCode.AddToProfile)}const B=await this.n.scanLocalExtension(D.location,v.ExtensionType.User,this.options.profileLocation);if(!B)throw new r.$ip("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof b.URI&&this.x(D,q),B}async w(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(H=>i.$Ip.create(H).equals(q))):void 0}async x(q,x){try{let[J]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],x);if(J||([J]=await this.p.getExtensions([{id:q.identifier.id}],x)),J){const H={id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,H,this.options.profileLocation)}}catch{}}};ee=ve([Z(6,Q.$Il),Z(7,r.$gp),Z(8,G.$Kl),Z(9,o.$Gq),Z(10,n.$Cq),Z(11,M.$$j)],ee);class re extends s.$Aq{constructor(q,x,J){super(),this.extension=q,this.j=x,this.k=J}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[253],he([0,1,10,20,29,18,53,7,16,9]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0;let S=class extends C.$Dq{constructor(h,$,c,g,b,f){super(w.URI.file(h.extensionsPath),$,c,g,b,f)}};e.$TQ=S,e.$TQ=S=ve([Z(0,A.$Mi),Z(1,k.$$k),Z(2,a.$Kl),Z(3,N.$Il),Z(4,L.$0l),Z(5,P.$$j)],S)}),define(le[254],he([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;let h=class extends L.$Kq{constructor(c,g,b,f,p,I,d,u){super(P.URI.file(p.builtinExtensionsPath),P.URI.file(p.extensionsPath),p.userHome,c.defaultProfile,c,g,b,f,p,I,d,u)}};e.$jfc=h,e.$jfc=h=ve([Z(0,m.$Kl),Z(1,N.$Cq),Z(2,C.$$k),Z(3,A.$$j),Z(4,a.$Mi),Z(5,w.$rk),Z(6,S.$Il),Z(7,k.$Di)],h)}),define(le[17],he([0,1,6,3,2,101,13,71,4,20]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=$,e.$eq=g,e.$gq=f,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,A.$Ei)("storageService");var S;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var m;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var h;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function $(p){const I=p.get(e.$aq);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class c extends N.$Vc{static{this.a=60*1e3}constructor(I={flushInterval:c.a}){super(),this.m=I,this.b=this.B(new a.$oe),this.c=this.B(new a.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$le),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,d,u){return a.Event.filter(this.b.event,t=>t.scope===I&&(d===void 0||t.key===d),u)}n(){this.j.value=(0,P.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,d){const{key:u,external:t}=d;if(u===e.$aq){switch(I){case m.APPLICATION:this.H=void 0;break;case m.PROFILE:this.F=void 0;break;case m.WORKSPACE:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:u,target:this.J(I)[u],external:t})}w(I){this.f.fire({reason:I})}get(I,d,u){return this.P(d)?.get(I,u)}getBoolean(I,d,u){return this.P(d)?.getBoolean(I,u)}getNumber(I,d,u){return this.P(d)?.getNumber(I,u)}getObject(I,d,u){return this.P(d)?.getObject(I,u)}storeAll(I,d){this.y(()=>{for(const u of I)this.store(u.key,u.value,u.scope,u.target,d)})}store(I,d,u,t,s=!1){if((0,C.$ng)(d)){this.remove(I,u,s);return}this.y(()=>{this.z(I,u,t),this.P(u)?.set(I,d,s)})}remove(I,d,u=!1){this.y(()=>{this.z(I,d,void 0),this.P(d)?.delete(I,u)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,d){const u=[],t=this.J(I);for(const s of Object.keys(t))t[s]===d&&u.push(s);return u}z(I,d,u,t=!1){const s=this.J(d);typeof u=="number"?s[I]!==u&&(s[I]=u,this.P(d)?.set(e.$aq,JSON.stringify(s),t)):typeof s[I]=="number"&&(delete s[I],this.P(d)?.set(e.$aq,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(m.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(m.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(m.APPLICATION)),this.H}J(I){switch(I){case m.APPLICATION:return this.I;case m.PROFILE:return this.G;default:return this.D}}L(I){const d=this.P(I);return d?$(d):Object.create(null)}isNew(I){return this.getBoolean(e.$_p,I)===!0}async flush(I=S.NONE){this.f.fire({reason:I});const d=this.P(m.APPLICATION),u=this.P(m.PROFILE),t=this.P(m.WORKSPACE);switch(I){case S.NONE:await P.Promises.settled([d?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await P.Promises.settled([d?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(m.APPLICATION)?.items??new Map,d=this.P(m.PROFILE)?.items??new Map,u=this.P(m.WORKSPACE)?.items??new Map;return f(I,d,u,this.Q(m.APPLICATION)??"",this.Q(m.PROFILE)??"",this.Q(m.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,d){return this.w(S.NONE),(0,w.$Jl)(I)?this.R(I,d):this.S(I,d)}M(I,d){return!(I.id===d.id||g(d)&&g(I))}N(I,d,u){this.y(()=>{const t=new Set;for(const[s,r]of I)t.add(s),d.get(s)!==r&&this.u(u,{key:s,external:!0});for(const[s]of d.items)t.has(s)||this.u(u,{key:s,external:!0})})}}e.$dq=c;function g(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class b extends c{constructor(){super(),this.U=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$0p(new k.$$p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(m.WORKSPACE,I))),this.B(this.W.onDidChangeStorage(I=>this.u(m.PROFILE,I))),this.B(this.U.onDidChangeStorage(I=>this.u(m.APPLICATION,I)))}P(I){switch(I){case m.APPLICATION:return this.U;case m.PROFILE:return this.W;default:return this.X}}Q(I){switch(I){case m.APPLICATION:return"inMemory (application)";case m.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$fq=b;async function f(p,I,d,u,t,s){const r=v=>{try{return JSON.parse(v)}catch{return v}},i=new Map,n=new Map;p.forEach((v,T)=>{i.set(T,v),n.set(T,r(v))});const o=new Map,l=new Map;I.forEach((v,T)=>{o.set(T,v),l.set(T,r(v))});const y=new Map,R=new Map;d.forEach((v,T)=>{y.set(T,v),R.set(T,r(v))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const O=[];if(i.forEach((v,T)=>{O.push({key:T,value:v})}),console.table(O),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const v=[];o.forEach((T,U)=>{v.push({key:U,value:T})}),console.table(v),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${s})`);const E=[];y.forEach((v,T)=>{E.push({key:T,value:v})}),console.table(E),console.groupEnd(),console.log(R)}}),define(le[119],he([0,1,3,2,13,28,33,17]),function(ne,e,P,a,N,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iLb=e.$hLb=void 0;let A=class extends a.$Vc{constructor(m,h){super(),this.a=new P.$le,this.onDidChangeEnablement=this.a.event,this.b=this.B(new w(m)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(h.onDidInstallExtensions($=>$.forEach(({local:c,operation:g})=>{c&&g===L.InstallOperation.Migrate&&this.f(c.identifier)})))}async enableExtension(m,h){return this.f(m)?(this.a.fire({extensions:[m],source:h}),!0):!1}async disableExtension(m,h){return this.c(m)?(this.a.fire({extensions:[m],source:h}),!0):!1}getDisabledExtensions(){return this.h(L.$kp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(m){const h=this.getDisabledExtensions();return h.every($=>!(0,C.$Hp)($,m))?(h.push(m),this.g(h),!0):!1}f(m){const h=this.getDisabledExtensions();for(let $=0;$<h.length;$++){const c=h[$];if((0,C.$Hp)(c,m))return h.splice($,1),this.g(h),!0}return!1}g(m){this.j(L.$kp,m)}h(m){return this.b.get(m,k.StorageScope.PROFILE)}j(m,h){this.b.set(m,h,k.StorageScope.PROFILE)}};e.$hLb=A,e.$hLb=A=ve([Z(0,k.$bq),Z(1,L.$jp)],A);class w extends a.$Vc{constructor(m){super(),this.c=m,this.a=Object.create(null),this.b=this.B(new P.$le),this.onDidChange=this.b.event,this.B(m.onDidChangeValue(k.StorageScope.PROFILE,void 0,this.B(new a.$Uc))(h=>this.f(h)))}get(m,h){let $;return h===k.StorageScope.PROFILE?((0,N.$ng)(this.a[m])&&(this.a[m]=this.g(m,h)),$=this.a[m]):$=this.g(m,h),JSON.parse($)}set(m,h,$){const c=JSON.stringify(h.map(({id:b,uuid:f})=>({id:b,uuid:f})));this.g(m,$)!==c&&($===k.StorageScope.PROFILE&&(h.length?this.a[m]=c:delete this.a[m]),this.h(m,h.length?c:void 0,$))}f(m){if(!(0,N.$ng)(this.a[m.key])&&this.g(m.key,m.scope)!==this.a[m.key]){const $=this.get(m.key,m.scope);delete this.a[m.key];const c=this.get(m.key,m.scope),g=$.filter(f=>!c.some(p=>(0,C.$Hp)(f,p))),b=c.filter(f=>!$.some(p=>(0,C.$Hp)(p,f)));(g.length||b.length)&&this.b.fire([...g,...b])}}g(m,h){return this.c.get(m,h,"[]")}h(m,h,$){h?this.c.store(m,h,$,k.StorageTarget.MACHINE):this.c.remove(m,$)}}e.$iLb=w}),define(le[86],he([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,P,a,N,L,C,k,A,w,S){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=void 0,e.$iw=(0,P.$Ei)("IExtensionStorageService");const h=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends N.$Vc{static{m=this}static{this.a=512*1024}static b(g){return`extensionKeys/${(0,C.$Lp)(g.id)}@${g.version}`}static c(g){const b=h.exec(g);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(g,b){const f=await g.getInstalled(),p=[];for(const[I,d]of m.f(b)){const u=f.find(t=>(0,C.$Hp)(t.identifier,{id:I}))?.manifest.version;for(const t of d)u!==t&&p.push(m.b({id:I,version:t}))}for(const I of p)b.remove(I,L.StorageScope.PROFILE)}static f(g){const b=new Map,f=g.keys(L.StorageScope.PROFILE,L.StorageTarget.MACHINE);for(const p of f){const I=m.c(p);if(I){let d=b.get(I.id.toLowerCase());d||b.set(I.id.toLowerCase(),d=[]),d.push(I.version)}}return b}constructor(g,b,f){super(),this.j=g,this.m=b,this.n=f,this.g=this.B(new a.$le),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=m.f(g),this.B(this.j.onDidChangeValue(L.StorageScope.PROFILE,void 0,this.B(new N.$Uc))(p=>this.r(p)))}r(g){if(this.h.has(g.key.toLowerCase())){this.g.fire();return}const b=m.c(g.key);if(b){if(this.j.get(g.key,L.StorageScope.PROFILE)===void 0)this.h.delete(b.id.toLowerCase());else{let f=this.h.get(b.id.toLowerCase());f||this.h.set(b.id.toLowerCase(),f=[]),f.push(b.version),this.g.fire()}return}}s(g){if((0,S.$eg)(g))return g;const b=g.manifest?g.manifest.publisher:g.publisher,f=g.manifest?g.manifest.name:g.name;return(0,C.$Kp)(b,f)}getExtensionState(g,b){const f=this.s(g),p=this.getExtensionStateRaw(g,b);if(p)try{return JSON.parse(p)}catch(I){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${b}): ${I}`)}}getExtensionStateRaw(g,b){const f=this.s(g),p=this.j.get(f,b?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE);return p&&p?.length>m.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${b}): ${p.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),p}setExtensionState(g,b,f){const p=this.s(g);b===void 0?this.j.remove(p,f?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE):this.j.store(p,JSON.stringify(b),f?L.StorageScope.PROFILE:L.StorageScope.WORKSPACE,L.StorageTarget.MACHINE)}setKeysForSync(g,b){this.j.store(m.b(g),JSON.stringify(b),L.StorageScope.PROFILE,L.StorageTarget.MACHINE)}getKeysForSync(g){const b=this.m.extensionSyncedKeys?.[g.id.toLowerCase()],f=this.j.get(m.b(g),L.StorageScope.PROFILE),p=f?JSON.parse(f):void 0;return p&&b?(0,A.$Nb)([...p,...b]):p||b}addToMigrationList(g,b){if(g!==b){const f=this.t.filter(p=>!p.includes(g)&&!p.includes(b));f.push([g,b]),this.t=f}}getSourceExtensionToMigrate(g){const b=this.t.find(([,f])=>g===f);return b?b[0]:void 0}get t(){const g=this.j.get("extensionStorage.migrationList",L.StorageScope.APPLICATION,"[]");try{const b=JSON.parse(g);if(Array.isArray(b))return b}catch{}return[]}set t(g){g.length?this.j.store("extensionStorage.migrationList",JSON.stringify(g),L.StorageScope.APPLICATION,L.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",L.StorageScope.APPLICATION)}};e.$jw=$,e.$jw=$=m=ve([Z(0,L.$bq),Z(1,k.$rk),Z(2,w.$$j)],$)}),define(le[255],he([0,1,2,28,86,233,118,10,17]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let w=class extends P.$Vc{constructor(m,h,$,c,g,b){super(),m.cleanUp(),(0,L.$S5b)(m,h,$,c,b),N.$jw.removeOutdatedExtensionVersions(m,g)}};e.$tgc=w,e.$tgc=w=ve([Z(0,C.$Rq),Z(1,a.$gp),Z(2,N.$iw),Z(3,a.$mp),Z(4,A.$bq),Z(5,k.$$j)],w)}),define(le[256],he([0,1,19,2,21,9,7,24,6,3,14,5,36,33,75,37,17]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;let f=class extends a.$Vc{constructor(t,s){super(),this.b=t,this.c=s,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,r])=>this.a.set(r.configPath,r))}getConfigBasedTips(t){return this.f(t)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(t){const s=[];for(const[r,i]of this.a)if(!(i.configScheme&&i.configScheme!==t.scheme))try{const n=(await this.b.readFile((0,N.$fh)(t,r))).value.toString();for(const[o,l]of Object.entries(i.recommendations))(!l.contentPattern||new RegExp(l.contentPattern,"mig").test(n))&&s.push({extensionId:o,extensionName:l.name,configName:i.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})}catch{}return s}};e.$Ncc=f,e.$Ncc=f=ve([Z(0,C.$$k),Z(1,k.$rk)],f);const p="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";class d extends f{constructor(t,s,r,i,n,o,l,y){super(l,y),this.r=t,this.s=s,this.t=r,this.u=i,this.w=n,this.z=o,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,y.exeBasedExtensionTips&&Object.entries(y.exeBasedExtensionTips).forEach(([R,O])=>{const E=[],v=[],T=[];Object.entries(O.recommendations).forEach(([U,F])=>{F.important?O.important?E.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):v.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):T.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),E.length&&this.g.set(R,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:E}),v.length&&this.h.set(R,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:v}),T.length&&this.j.set(R,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:T})}),(0,A.$Gh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const t=await this.O(this.g),s=await this.O(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const t=await this.O(this.g),s=await this.O(this.h),r=await this.u.getInstalled();this.m=this.D(t,r),this.n=this.D(s,r)}D(t,s){const r=new Map;t.forEach(y=>r.set(y.extensionId.toLowerCase(),y));const{installed:i,uninstalled:n}=this.N([...r.keys()],s);for(const y of i){const R=r.get(y);R&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:y,exeName:R.exeName})}for(const y of n){const R=r.get(y);R&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:y,exeName:R.exeName})}const o=this.L(),l=new Map;for(const y of n){const R=r.get(y);if(R&&(!o[R.exeName]||!o[R.exeName].includes(R.extensionId))){let O=l.get(R.exeName);O||(O=[],l.set(R.exeName,O)),O.push(R)}}return l}F(){if(this.m.size===0)return;const[t,s]=[...this.m.entries()][0];this.H(s).then(r=>{switch(r){case c.RecommendationsNotificationResult.Accepted:this.M(s[0].exeName,s);break;case c.RecommendationsNotificationResult.Ignored:this.m.delete(t);break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const i=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case c.RecommendationsNotificationResult.TooMany:{const i=this.B(new a.$Wc);i.value=(0,A.$Gh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const t=this.I(),s=Date.now()-t,r=7*24*60*60*1e3;if(s<r){const o=this.B(new a.$Wc);o.value=(0,A.$Gh)(()=>{o.dispose(),this.G()},r-s);return}const[i,n]=[...this.n.entries()][0];this.H(n).then(o=>{switch(o){case c.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(i),this.M(n[0].exeName,n);const l=this.B(new a.$Wc);l.value=(0,A.$Gh)(()=>{l.dispose(),this.G()},r);break}case c.RecommendationsNotificationResult.Ignored:this.n.delete(i),this.G();break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const l=w.Event.once(w.Event.latch(w.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(l(()=>this.G()));break}case c.RecommendationsNotificationResult.TooMany:{const l=this.B(new a.$Wc);l.value=(0,A.$Gh)(()=>{l.dispose(),this.G()},60*60*1e3);break}}})}async H(t){const s=await this.u.getInstalled(g.ExtensionType.User),r=t.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>s.every(o=>!(0,$.$Hp)(o.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:r,source:c.RecommendationSource.EXE,name:t[0].exeFriendlyName,searchValue:`@exe:"${t[0].exeName}"`})}I(){let t=this.w.getNumber(I,b.StorageScope.APPLICATION);return t||(t=Date.now(),this.J(t)),t}J(t){this.w.store(I,t,b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(p,b.StorageScope.APPLICATION,"{}"))}M(t,s){const r=this.L();r[t]=s.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(r),b.StorageScope.APPLICATION,b.StorageTarget.USER)}N(t,s){const r=[],i=[],n=s.reduce((o,l)=>(o.add(l.identifier.id.toLowerCase()),o),new Set);return t.forEach(o=>{n.has(o.toLowerCase())?r.push(o):i.push(o)}),{installed:r,uninstalled:i}}async O(t){const s=[],r=new Map;for(const i of t.keys()){const n=t.get(i);if(!n||!(0,P.$Mb)(n.recommendations))continue;const o=[];m.$i?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>h.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>h.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>h.env.ProgramFiles).replace("%APPDATA%",()=>h.env.APPDATA).replace("%WINDIR%",()=>h.env.WINDIR)):(o.push((0,S.$kc)("/usr/local/bin",i)),o.push((0,S.$kc)("/usr/bin",i)),o.push((0,S.$kc)(this.r.fsPath,i)));for(const l of o){let y=r.get(l);if(y===void 0&&(y=await this.b.exists(L.URI.file(l)),r.set(l,y)),y)for(const{extensionId:R,extensionName:O,isExtensionPack:E,whenNotInstalled:v}of n.recommendations)s.push({extensionId:R,extensionName:O,isExtensionPack:E,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:v})}}return s}}e.$Occ=d}),define(le[257],he([0,1,28,7,24,16,75,59,17,18,256]),function(ne,e,P,a,N,L,C,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;let m=class extends S.$Occ{constructor($,c,g,b,f,p,I,d){super($.userHome,f,c,g,b,p,I,d)}};e.$Agc=m,e.$Agc=m=ve([Z(0,L.$Mi),Z(1,w.$0l),Z(2,P.$jp),Z(3,A.$bq),Z(4,k.$wec),Z(5,C.$A5b),Z(6,a.$$k),Z(7,N.$rk)],m)}),define(le[50],he([0,1,15,32,17]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=L;async function L(C,k,A){let w=A&&A.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(w)return w;try{const m=(await k.readFile(C.serviceMachineIdResource)).value.toString();w=(0,a.$Zg)(m)?m:null}catch{w=null}if(!w){w=(0,a.$1g)();try{await k.writeFile(C.serviceMachineIdResource,P.$Ne.fromString(w))}catch{}}return A?.store("storage.serviceMachineId",w,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),w}}),define(le[258],he([0,1,50,18,49]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=L;async function L(C,k,A,w,S,m,h){const $={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${k.nameShort})`};if((0,N.$zp)(k,A)&&(0,N.$Bp)(w)===a.TelemetryLevel.USAGE){const c=await(0,P.$hq)(A,S,m);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=h.machineId||c}return $}}),define(le[259],he([0,1,19,26,8,5,36,13,9,22,16,28,33,37,73,7,10,24,61,258,17,18,55]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0,e.$jq=ce;const s=L.$o?$.TargetPlatform.WEB:(0,m.$cp)(L.$u,C.$fc),r="X-Market-Search-Activity-Id";var i;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...B){return String(B.reduce((j,W)=>j|W,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},O={pageNumber:1,pageSize:10,sortBy:m.SortBy.NoneOrRelevance,sortOrder:m.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(j=O){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,W=this.d.pageSize){return new E({...this.d,pageNumber:j,pageSize:W})}withFilter(j,...W){const te=[...this.d.criteria,...W.length?W.map(_=>({filterType:j,value:_})):[{filterType:j}]];return new E({...this.d,criteria:te})}withSortBy(j){return new E({...this.d,sortBy:j})}withSortOrder(j){return new E({...this.d,sortOrder:j})}withFlags(...j){return new E({...this.d,flags:j.reduce((W,te)=>W|te,0)})}withAssetTypes(...j){return new E({...this.d,assetTypes:j})}withSource(j){return new E({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Y,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:j,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Y}],assetTypes:ue,flags:ae}}get searchText(){const j=this.d.criteria.filter(W=>W.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(B,j){const W=(B||[]).filter(te=>te.statisticName===j)[0];return W?W.value:0}function T(B){const j="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(te=>te.assetType.indexOf(j)===0).reduce((te,_)=>{const Y=M(B,_.assetType);return Y&&te.push([_.assetType.substring(j.length),Y]),te},[])}function U(B){if(B.properties){const j=B.properties.filter(_=>_.key===l.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=j.filter(_=>W.test(_.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return M(B,l.Repository)}function F(B){return{uri:`${B.fallbackAssetUri}/${l.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${l.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function M(B,j){return B.files.filter(te=>te.assetType===j)[0]?{uri:`${B.assetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function X(B,j){const W=B.properties?B.properties.filter(_=>_.key===j):[],te=W.length>0&&W[0].value;return te?te.split(",").map(_=>(0,h.$Lp)(_)):[]}function K(B){const j=B.properties?B.properties.filter(W=>W.key===y.Engine):[];return j.length>0&&j[0].value||""}function Q(B){const j=B.properties?B.properties.filter(W=>W.key===y.PreRelease):[];return j.length>0&&j[0].value==="true"}function G(B){const j=B.properties?B.properties.filter(te=>te.key===y.LocalizedLanguages):[],W=j.length>0&&j[0].value||"";return W?W.split(","):[]}function ie(B){return B.properties?.find(j=>j.key===y.SponsorLink)?.value}function V(B){return B.properties?.find(j=>j.key===y.SupportLink)?.value}function z(B){return B.indexOf("preview")!==-1}function ee(B){return B.targetPlatform?(0,m.$bp)(B.targetPlatform):$.TargetPlatform.UNDEFINED}function re(B){const j=(0,P.$Nb)(B.versions.map(ee)),W=!!B.tags?.includes(m.$8o),te=j.indexOf($.TargetPlatform.WEB);return W?te===-1&&j.push($.TargetPlatform.WEB):te!==-1&&j.splice(te,1),j}function ce(B,j){for(let W=0;W<B.length;W++){const te=B[W];if(te.version===B[W-1]?.version){let _=W;if(ee(te)===j)for(;_>0&&B[_-1].version===te.version;)_--;_!==W&&(B.splice(W,1),B.splice(_,0,te))}}return B}function q(B,j,W){B.telemetryData={index:j,querySource:W,queryActivityId:B.queryContext?.[r]}}function x(B,j,W,te){const _=B.versions[0],Y={manifest:M(j,l.Manifest),readme:M(j,l.Details),changelog:M(j,l.Changelog),license:M(j,l.License),repository:U(j),download:F(j),icon:M(j,l.Icon),signature:M(j,l.Signature),coreTranslations:T(j)};return{type:"gallery",identifier:{id:(0,h.$Mp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:j.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(_),description:B.shortDescription??"",installCount:v(B.statistics,"install"),rating:v(B.statistics,"averagerating"),ratingCount:v(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:W,assets:Y,properties:{dependencies:X(j,y.Dependency),extensionPack:X(j,y.ExtensionPack),engine:K(j),localizedLanguages:G(j),targetPlatform:ee(j),isPreReleaseVersion:Q(j)},hasPreReleaseVersion:Q(_),hasReleaseVersion:!0,preview:z(B.flags),isSigned:!!Y.signature,queryContext:te,supportLink:V(_)}}let J=class{constructor(j,W,te,_,Y,ae,ue,ge){this.k=W,this.l=te,this.n=_,this.o=Y,this.q=ae,this.u=ue,this.w=ge;const we=ue.extensionsGallery,Ee=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=Ee?we.servicePPEUrl:we?.serviceUrl,this.g=Ee?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,I.$iq)(ue.version,ue,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,W,te){const _=a.CancellationToken.isCancellationToken(W)?{}:W,Y=a.CancellationToken.isCancellationToken(W)?W:te,ae=[],ue=[],ge=[],we=[];let Ee=!0;for(const Se of j){Se.uuid?ue.push(Se.uuid):ae.push(Se.id);const Ie=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),Ee=Ee&&!!Se.hasPreRelease&&!Ie}if(!ue.length&&!ae.length)return[];let pe=new E().withPage(1,j.length);ue.length&&(pe=pe.withFilter(o.ExtensionId,...ue)),ae.length&&(pe=pe.withFilter(o.ExtensionName,...ae)),(_.queryAllVersions||Ee)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:be}=await this.z(pe,{targetPlatform:_.targetPlatform??s,includePreRelease:ge,versions:we,compatible:!!_.compatible,productVersion:_.productVersion??{version:this.u.version,date:this.u.date}},Y);return _.source&&be.forEach((Se,Ie)=>q(Se,Ie,_.source)),be}async getCompatibleExtension(j,W,te,_={version:this.u.version,date:this.u.date}){if((0,m.$dp)(j.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(j,W,te))return j;const Y=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,j.identifier.uuid),{extensions:ae}=await this.z(Y,{targetPlatform:te,compatible:!0,includePreRelease:W,productVersion:_},a.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(j,W,te,_={version:this.u.version,date:this.u.date}){if(!(0,m.$ep)(j.properties.targetPlatform,j.allTargetPlatforms,te)||!W&&j.properties.isPreReleaseVersion)return!1;let Y=j.properties.engine;if(!Y){const ae=await this.getManifest(j,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Y=ae.engines.vscode}return(0,c.$Zp)(Y,_.version,_.date)}async y(j,W,te,_,Y,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,m.$ep)(ee(W),Y,ae)||te!=="any"&&Q(W)!==(te==="prerelease"))return!1;if(_)try{const ge=await this.E(j,W);if(!(0,c.$Zp)(ge,ue.version,ue.date))return!1}catch(ge){return this.l.error(`Error while getting the engine for the version ${W.version}.`,(0,N.$$)(ge)),!1}return!0}async query(j,W){let te=j.text||"";const _=j.pageSize??50;let Y=new E().withPage(1,_);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(o.Category,be||pe),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(o.Tag,be||pe),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(o.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Y=Y.withFilter(o.SearchText,te)),Y=Y.withSortBy(m.SortBy.NoneOrRelevance)):j.ids?Y=Y.withFilter(o.ExtensionId,...j.ids):j.names?Y=Y.withFilter(o.ExtensionName,...j.names):Y=Y.withSortBy(m.SortBy.InstallCount),typeof j.sortBy=="number"&&(Y=Y.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(Y=Y.withSortOrder(j.sortOrder)),j.source&&(Y=Y.withSource(j.source));const ae=async(Ee,pe)=>{const{extensions:be,total:Se}=await this.z(Ee,{targetPlatform:s,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.u.version,date:this.u.date}},pe);return be.forEach((Ie,oe)=>q(Ie,(Ee.pageNumber-1)*Ee.pageSize+oe,j.source)),{extensions:be,total:Se}},{extensions:ue,total:ge}=await ae(Y,W),we=async(Ee,pe)=>{if(pe.isCancellationRequested)throw new N.$6;const{extensions:be}=await ae(Y.withPage(Ee+1),pe);return be};return{firstPage:ue,total:ge,pageSize:Y.pageSize,getPage:we}}async z(j,W,te){const _=j.flags;j.flags&i.IncludeLatestVersionOnly&&j.flags&i.IncludeVersions&&(j=j.withFlags(j.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(j.flags&i.IncludeLatestVersionOnly)&&!(j.flags&i.IncludeVersions)&&(j=j.withFlags(j.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(j=j.withFlags(j.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),j=j.withFlags(j.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:Y,total:ae,context:ue}=await this.B(j,te);if(!(j.flags&i.IncludeLatestVersionOnly)){const pe=[];for(const be of Y){const Se=await this.A(be,W,ue);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const we=[],Ee=new Map;for(let pe=0;pe<Y.length;pe++){const be=Y[pe],Se={id:(0,h.$Mp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ie=(0,k.$kg)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(de=>(0,h.$Hp)(de,Se))?.includePreRelease;if(W.compatible&&(0,m.$dp)(re(be),W.targetPlatform))continue;const oe=await this.A(be,W,ue);!oe||oe.properties.isPreReleaseVersion&&(!Ie||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==W.targetPlatform&&oe.hasPreReleaseVersion?Ee.set(be.extensionId,pe):we.push([pe,oe])}if(Ee.size){const pe=new t.$fe,be=new E().withFlags(_&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ee.size).withFilter(o.ExtensionId,...Ee.keys()),{extensions:Se}=await this.z(be,W,te);this.o.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:Ee.size});for(const Ie of Se){const oe=Ee.get(Ie.identifier.uuid);we.push([oe,Ie])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:ae}}async A(j,W,te){const _={id:(0,h.$Mp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},Y=W.versions?.find(we=>(0,h.$Hp)(we,_))?.version,ae=(0,k.$kg)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(we=>(0,h.$Hp)(we,_))?.includePreRelease,ue=re(j),ge=ce(j.versions,W.targetPlatform);if(W.compatible&&(0,m.$dp)(ue,W.targetPlatform))return null;for(let we=0;we<ge.length;we++){const Ee=ge[we];if(!(Y&&Ee.version!==Y)){if(await this.y((0,h.$Mp)(j.publisher.publisherName,j.extensionName),Ee,ae?"any":"release",W.compatible,ue,W.targetPlatform,W.productVersion))return x(j,Ee,ue,te);if(Y&&Ee.version===Y)return null}}return Y||W.compatible?null:x(j,j.versions[0],ue)}async B(j,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(i.Unpublished));const te=await this.j,_=JSON.stringify(j.raw),Y={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},ae=new t.$fe;let ue,ge,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&j.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:Y},W),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const Ee=await(0,p.$7p)(ue);if(Ee){const pe=Ee.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(Ee){if((0,N.$5)(Ee))throw ge=m.ExtensionGalleryErrorCode.Cancelled,Ee;{const pe=(0,N.$$)(Ee);throw ge=pe.startsWith("XHR timeout")?m.ExtensionGalleryErrorCode.Timeout:m.ExtensionGalleryErrorCode.Failed,new m.$hp(pe,ge)}}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(_.length),duration:ae.elapsed(),success:!!ue&&(0,p.$3p)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(j,W,te,_){if(!this.isEnabled())return;const Y=L.$o?this.x(`/itemName/${j}.${W}/version/${te}/statType/${_===m.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${W}/${te}/stats?statType=${_}`),ae=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:Y,headers:ge},a.CancellationToken.None)}catch{}}async download(j,W,te){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const _=(0,h.$Pp)(j),Y=new Date().getTime(),ae=te===m.InstallOperation.Install?"install":te===m.InstallOperation.Update?"update":"",ue=ae?{uri:`${j.assets.download.uri}${A.URI.parse(j.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${j.assets.download.fallbackUri}${A.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:j.assets.download,ge=j.queryContext?.[r]?{[r]:j.queryContext[r]}:void 0,we=await this.D(j.identifier.id,ue,l.VSIX,ge?{headers:ge}:void 0);try{await this.q.writeFile(W,we.stream)}catch(Ee){try{await this.q.del(W)}catch(pe){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,N.$$)(pe))}throw new m.$hp((0,N.$$)(Ee),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{..._,duration:new Date().getTime()-Y})}async downloadSignatureArchive(j,W){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const te=await this.D(j.identifier.id,j.assets.signature,l.Signature);try{await this.q.writeFile(W,te.stream)}catch(_){try{await this.q.del(W)}catch(Y){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,N.$$)(Y))}throw new m.$hp((0,N.$$)(_),m.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,W){if(j.assets.readme){const te=await this.D(j.identifier.id,j.assets.readme,l.Details,{},W);return await(0,p.$6p)(te)||""}return""}async getManifest(j,W){if(j.assets.manifest){const te=await this.D(j.identifier.id,j.assets.manifest,l.Manifest,{},W),_=await(0,p.$6p)(te);return _?JSON.parse(_):null}return null}async C(j,W,te){const _=M(W,l.Manifest);if(!_)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ae=await this.D(j,_,l.Manifest,{headers:Y});return await(0,p.$7p)(ae)}async getCoreTranslation(j,W){const te=j.assets.coreTranslations.filter(_=>_[0]===W.toUpperCase())[0];if(te){const _=await this.D(j.identifier.id,te[1],te[0]),Y=await(0,p.$6p)(_);return Y?JSON.parse(Y):null}return null}async getChangelog(j,W){if(j.assets.changelog){const te=await this.D(j.identifier.id,j.assets.changelog,l.Changelog,{},W);return await(0,p.$6p)(te)||""}return""}async getAllCompatibleVersions(j,W,te){let _=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?_=_.withFilter(o.ExtensionId,j.identifier.uuid):_=_.withFilter(o.ExtensionName,j.identifier.id);const{galleryExtensions:Y}=await this.B(_,a.CancellationToken.None);if(!Y.length)return[];const ae=re(Y[0]);if((0,m.$dp)(ae,te))return[];const ue=[];await Promise.all(Y[0].versions.map(async Ee=>{try{await this.y(j.identifier.id,Ee,W?"any":"release",!0,ae,te)&&ue.push(Ee)}catch{}}));const ge=[],we=new Set;for(const Ee of ce(ue,te))we.has(Ee.version)||(we.add(Ee.version),ge.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:Q(Ee)}));return ge}async D(j,W,te,_={},Y=a.CancellationToken.None){const ae=await this.j,ue={type:"GET"},ge={...ae,..._.headers||{}};_={..._,...ue,headers:ge};const we=W.uri,Ee=W.fallbackUri,pe={..._,url:we};try{const be=await this.k.request(pe,Y);if(be.res.statusCode===200)return be;const Se=await(0,p.$6p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,N.$5)(be))throw be;const Se=(0,N.$$)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:j,assetType:te,message:Se});const Ie={..._,url:Ee};return this.k.request(Ie,Y)}}async E(j,W){let te=K(W);if(!te){this.o.publicLog2("galleryService:engineFallback",{extension:j,version:W.version});const _=await this.C(j,W,a.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},a.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,p.$7p)(j),te=[],_={},Y=[];if(W){for(const ae of W.malicious)te.push({id:ae});if(W.migrateToPreRelease)for(const[ae,ue]of Object.entries(W.migrateToPreRelease))(!ue.engine||(0,c.$Zp)(ue.engine,this.u.version,this.u.date))&&(_[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ae,ue]of Object.entries(W.deprecated))ue&&(_[ae.toLowerCase()]=(0,k.$kg)(ue)?{}:ue);if(W.search)for(const ae of W.search)Y.push(ae)}return{malicious:te,deprecated:_,search:Y}}};J=ve([Z(1,p.$1p),Z(2,b.$$j),Z(3,S.$Li),Z(4,u.$0l),Z(5,g.$$k),Z(6,f.$rk),Z(7,w.$$i)],J);let H=class extends J{constructor(j,W,te,_,Y,ae,ue,ge){super(j,W,te,_,Y,ae,ue,ge)}};e.$kq=H,e.$kq=H=ve([Z(0,d.$bq),Z(1,p.$1p),Z(2,b.$$j),Z(3,S.$Li),Z(4,u.$0l),Z(5,g.$$k),Z(6,f.$rk),Z(7,w.$$i)],H);let D=class extends J{constructor(j,W,te,_,Y,ae,ue){super(void 0,j,W,te,_,Y,ae,ue)}};e.$lq=D,e.$lq=D=ve([Z(0,p.$1p),Z(1,b.$$j),Z(2,S.$Li),Z(3,u.$0l),Z(4,g.$$k),Z(5,f.$rk),Z(6,w.$$i)],D)}),define(le[260],he([0,1,108,3,18,16,2,10,14,69,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;const u=[P.$pgc,P.$qgc],t="remoteTunnelSession",s="remoteTunnelIsService";let r=class extends C.$Vc{constructor(l,y,R,O,E,v,T){super(),this.y=l,this.z=y,this.C=R,this.D=v,this.F=T,this.f=new a.$le,this.onDidTokenFailed=this.f.event,this.g=new a.$le,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$le,this.onDidChangeMode=this.h.event,this.n=P.$ngc,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(O.createLogger((0,d.$fh)(R.logsHome,`${P.$rgc}.log`),{id:P.$rgc,name:P.$sgc})),this.t=new h.$Bh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,k.$nk)(U)))),this.B(E.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{u.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=P.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(l){this.s=l,this.g.fire(l)}H(l){n(this.n,l)||(this.n=l,this.S(l),this.h.fire(this.n),l.active?(this.j.info(`Session updated: ${l.session.accountLabel} (${l.session.providerId}) (service=${l.asService})`),l.session.token&&this.j.info(`Session token updated: ${l.session.accountLabel} (${l.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(l){if(this.w)return this.s;this.w=!0,this.H(l);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let l;m.$j?l=this.C.appRoot:l=(0,A.$nc)((0,A.$nc)(this.C.appRoot)),this.u=(0,A.$kc)(l,"bin",`${this.z.tunnelApplicationName}${m.$i?".exe":""}`)}return this.u}async startTunnel(l){if(n(this.n,l)&&this.s.type!=="disconnected")return this.s;this.H(l);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const l=this.n.asService;this.H(P.$ngc);try{l&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(l){this.j.error(l)}this.G(P.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let l="",y=!1;const R=(F,M)=>{M?this.j.error(F):l+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(P.TunnelStates.connecting((0,g.localize)(0,null)))},O=this.O("status",["status"],R);this.r=O;try{if(await O,this.r!==O)return;let F;try{F=JSON.parse(l.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(l.trim())}`),this.G(P.TunnelStates.disconnected());return}if(y=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(P.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(P.TunnelStates.disconnected());return}finally{this.r===O&&(this.r=void 0)}const E=this.n.active?this.n.session:void 0;if(E&&E.token){const F=E.token;this.G(P.TunnelStates.connecting((0,g.localize)(1,null,E.accountLabel,E.providerId)));const M=(K,Q)=>{K=K.replaceAll(F,"*".repeat(4)),R(K,Q)},X=this.O("login",["user","login","--provider",E.providerId,"--log",(0,k.$nk)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:F});this.r=X;try{if(await X,this.r!==X)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(E),this.G(P.TunnelStates.disconnected(E));return}}const v=this.Q();v?this.G(P.TunnelStates.connecting((0,g.localize)(2,null,v))):this.G(P.TunnelStates.connecting((0,g.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,k.$nk)(this.j.getLevel())];v?T.push("--name",v):T.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!y&&(U=await this.M(T)===!1),this.N(E,T,U)}async M(l){let y;try{y=await this.O("serviceInstall",["service","install",...l])}catch(R){this.j.error(R),y=1}if(y!==0){const R=(0,g.localize)(4,null);return this.j.warn(R),this.G(P.TunnelStates.connecting(R)),!1}return!0}async N(l,y,R){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let O=!1;const E=this.O("tunnel",y,(v,T)=>{T?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(O=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:O};this.G(P.TunnelStates.connected(F,R))}else v.match(/error refreshing token/)&&(E.cancel(),this.f.fire(l),this.G(P.TunnelStates.disconnected(l)))});this.r=E,E.finally(()=>{E===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=P.$ngc,this.G(P.TunnelStates.disconnected()))})}O(l,y,R=this.I,O){return(0,h.$rh)(E=>new Promise((v,T)=>{E.isCancellationRequested&&v(-1);let U;const F=["ignore","pipe","pipe"];if(E.onCancellationRequested(()=>{U&&(this.j.info(`${l} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)R(`Building tunnel CLI from sources and run
`,!1),R(`${l} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),U=(0,w.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,A.$kc)(this.C.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...O}});else{R(`Running tunnel CLI
`,!1);const M=this.J();R(`${l} Spawning: ${M} tunnel ${y.join(" ")}
`,!1),U=(0,w.spawn)(M,["tunnel",...y],{cwd:(0,b.homedir)(),stdio:F,env:{...process.env,...O}})}U.stdout.pipe(new I.$5W(`
`)).on("data",M=>{if(U){const X=M.toString();R(X,!1)}}),U.stderr.pipe(new I.$5W(`
`)).on("data",M=>{if(U){const X=M.toString();R(X,!0)}}),U.on("exit",M=>{U&&(R(`${l} exit(${U.pid}): + ${M} `,!1),U=void 0,v(M||0))}),U.on("error",M=>{U&&(R(`${l} error(${U.pid}): + ${M} `,!0),U=void 0,T())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(P.$qgc)}Q(){let l=this.D.getValue(P.$pgc)||(0,b.hostname)();return l=l.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),l||void 0}R(){try{const l=this.F.get(t,f.StorageScope.APPLICATION),y=this.F.getBoolean(s,f.StorageScope.APPLICATION,!1);if(l){const R=JSON.parse(l);if(R&&(0,p.$eg)(R.accountLabel)&&(0,p.$eg)(R.sessionId)&&(0,p.$eg)(R.providerId))return{active:!0,session:R,asService:y};this.j.error("Problems restoring session from storage, invalid format",R)}}catch(l){this.j.error("Problems restoring session from storage",l)}return P.$ngc}S(l){if(l.active){const y={providerId:l.session.providerId,sessionId:l.session.sessionId,accountLabel:l.session.accountLabel};this.F.store(t,JSON.stringify(y),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(s,l.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(t,f.StorageScope.APPLICATION),this.F.remove(s,f.StorageScope.APPLICATION)}};e.$wgc=r,e.$wgc=r=ve([Z(0,N.$0l),Z(1,S.$rk),Z(2,L.$Mi),Z(3,k.$_j),Z(4,$.$ugc),Z(5,c.$$i),Z(6,f.$bq)],r);function i(o,l){return o&&l?o.sessionId===l.sessionId&&o.providerId===l.providerId&&o.token===l.token:o===l}const n=(o,l)=>o.active!==l.active?!1:o.active&&l.active?o.asService===l.asService&&i(o.session,l.session):!0}),define(le[261],he([0,1,6,2,23,21,71,17,80,20]),function(ne,e,P,a,N,L,C,k,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class S extends k.$dq{constructor(h,$,c,g){super(),this.bb=h,this.cb=$,this.db=c,this.eb=g,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Uc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Uc),this.ab=this.hb(this.bb)}fb(){const h=this.B(new A.$RLb(this.db.getChannel("storage"))),$=this.B(new C.$0p(h));return this.B($.onDidChangeStorage(c=>this.u(k.StorageScope.APPLICATION,c))),$}gb(h){this.X.clear(),this.W=h;let $;if((0,k.$eq)(h))$=this.U;else{const c=this.X.add(new A.$SLb(this.db.getChannel("storage"),h));$=this.X.add(new C.$0p(c))}return this.X.add($.onDidChangeStorage(c=>this.u(k.StorageScope.PROFILE,c))),$}hb(h){this.$.clear(),this.Z=h?.id;let $;if(h){const c=this.$.add(new A.$TLb(this.db.getChannel("storage"),h));$=this.$.add(new C.$0p(c)),this.$.add($.onDidChangeStorage(g=>this.u(k.StorageScope.WORKSPACE,g)))}return $}async O(){await P.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(h){switch(h){case k.StorageScope.APPLICATION:return this.U;case k.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(h){switch(h){case k.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case k.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$fh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(k.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(h){if(!this.M(this.W,h))return;const $=this.Y,c=$.items;$!==this.U&&await $.close(),this.Y=this.gb(h),await this.Y.init(),this.N(c,this.Y,k.StorageScope.PROFILE)}async S(h,$){const c=this.ab,g=c?.items??new Map;await c?.close(),this.ab=this.hb(h),await this.ab.init(),this.N(g,this.ab,k.StorageScope.WORKSPACE)}hasScope(h){return(0,w.$Jl)(h)?this.W.id===h.id:this.Z===h.id}}e.$Bgc=S}),define(le[262],he([0,1,3,2,20,95]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=e.$1Q=void 0;class C{constructor(w,S){this.a=w,this.b=S}listen(w,S){const m=this.b(w);switch(S){case"onDidChangeProfiles":return P.Event.map(this.a.onDidChangeProfiles,h=>({all:h.all.map($=>(0,L.$Kn)({...$},m)),added:h.added.map($=>(0,L.$Kn)({...$},m)),removed:h.removed.map($=>(0,L.$Kn)({...$},m)),updated:h.updated.map($=>(0,L.$Kn)({...$},m))}))}throw new Error(`Invalid listen ${S}`)}async call(w,S,m){const h=this.b(w);switch(S){case"createProfile":{const $=await this.a.createProfile(m[0],m[1],m[2]);return(0,L.$Kn)({...$},h)}case"updateProfile":{let $=(0,N.$Ll)((0,L.$Ln)(m[0],h),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,m[1]),(0,L.$Kn)({...$},h)}case"removeProfile":{const $=(0,N.$Ll)((0,L.$Ln)(m[0],h),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${S}`)}}e.$1Q=C;class k extends a.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,S,m){super(),this.profilesHome=S,this.f=m,this.a=[],this.b=this.B(new P.$le),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(h=>(0,N.$Ll)(h,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(h=>{const $=h.added.map(b=>(0,N.$Ll)(b,this.profilesHome.scheme)),c=h.removed.map(b=>(0,N.$Ll)(b,this.profilesHome.scheme)),g=h.updated.map(b=>(0,N.$Ll)(b,this.profilesHome.scheme));this.a=h.all.map(b=>(0,N.$Ll)(b,this.profilesHome.scheme)),this.b.fire({added:$,removed:c,updated:g,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,S,m){const h=await this.f.call("createNamedProfile",[w,S,m]);return(0,N.$Ll)(h,this.profilesHome.scheme)}async createProfile(w,S,m,h){const $=await this.f.call("createProfile",[w,S,m,h]);return(0,N.$Ll)($,this.profilesHome.scheme)}async createTransientProfile(w){const S=await this.f.call("createTransientProfile",[w]);return(0,N.$Ll)(S,this.profilesHome.scheme)}async setProfileForWorkspace(w,S){await this.f.call("setProfileForWorkspace",[w,S])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,S){const m=await this.f.call("updateProfile",[w,S]);return(0,N.$Ll)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$2Q=k}),define(le[62],he([0,1,2,71,4,17,3,80,20]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XLb=e.$WLb=e.$VLb=void 0,e.$VLb=(0,N.$Ei)("IUserDataProfileStorageService");let w=class extends P.$Vc{constructor($){super(),this.a=$}async readStorageData($){return this.withProfileScopedStorageService($,async c=>this.b(c))}async updateStorageData($,c,g){return this.withProfileScopedStorageService($,async b=>this.c(b,c,g))}async withProfileScopedStorageService($,c){if(this.a.hasScope($))return c(this.a);const g=await this.g($),b=new m(g);try{await b.initialize();const f=await c(b);return await b.flush(),f}finally{b.dispose(),await this.f(g)}}b($){const c=new Map,g=b=>{for(const f of $.keys(L.StorageScope.PROFILE,b))c.set(f,{value:$.get(f,L.StorageScope.PROFILE),target:b})};return g(L.StorageTarget.USER),g(L.StorageTarget.MACHINE),c}c($,c,g){$.storeAll(Array.from(c.entries()).map(([b,f])=>({key:b,value:f,scope:L.StorageScope.PROFILE,target:g})),!0)}async f($){try{await $.close()}finally{(0,P.$Pc)($)&&$.dispose()}}};e.$WLb=w,e.$WLb=w=ve([Z(0,L.$bq)],w);class S extends w{constructor($,c,g,b){super(g),this.j=$;const f=$.getChannel("profileStorageListener"),p=this.B(new P.$Wc);this.h=this.B(new C.$le({onWillAddFirstListener:()=>{p.value=f.listen("onDidChange")(I=>{b.trace("profile storage changes",I),this.h.fire({targetChanges:I.targetChanges.map(d=>(0,A.$Ll)(d,c.profilesHome.scheme)),valueChanges:I.valueChanges.map(d=>({...d,profile:(0,A.$Ll)(d.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>p.value=void 0})),this.onDidChange=this.h.event}async g($){const c=this.j.getChannel("storage");return(0,L.$eq)($)?new k.$RLb(c):new k.$SLb(c,$)}}e.$XLb=S;class m extends L.$dq{constructor($){super({flushInterval:100}),this.s=this.B(new a.$0p($))}O(){return this.s.init()}P($){return $===L.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[263],he([0,1,17,10,20,58,62]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;let k=class extends C.$XLb{constructor(w,S,m,h){super(w,S,m,h)}};e.$ggc=k,e.$ggc=k=ve([Z(0,L.$Nfc),Z(1,N.$Kl),Z(2,P.$bq),Z(3,a.$$j)],k)}),define(le[40],he([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Mb=e.$4Mb=e.$3Mb=e.$2Mb=void 0,e.$YMb=t,e.$ZMb=s,e.$1Mb=r;function t(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||s(y.syncData)))}function s(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function r(y,R){return`${(0,w.$9f)(y)}${R.isDefault?"":` (${R.name})`}`}let i=class extends A.$Vc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(R,O,E,v,T,U,F,M,X,K,Q,G){super(),this.syncResource=R,this.collection=O,this.G=E,this.H=v,this.I=T,this.J=U,this.L=F,this.M=M,this.N=X,this.O=K,this.P=Q,this.c=null,this.m=d.SyncStatus.Idle,this.n=this.B(new C.$le),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new C.$le),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Ch(50)),this.w=this.B(new C.$le),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=r(R.syncResource,R.profile),this.h=G.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,d.$Pmb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource)),this.g=this.h.joinPath(this.f,d.$$mb),this.y=(0,d.$Qmb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource,v,this.h),this.j=(0,b.$hq)(v,E,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===d.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const R=await this.c;this.c=null;const O=await this.Y(R.remoteUserData,R.lastSyncUserData,!0,this.ob());this.S(O)}else{this.O.trace(`${this.D}: Checking for local changes...`);const R=await this.getLastSyncUserData();(R?await this.ub(R):!0)&&this.w.fire()}}S(R){this.m!==R&&(this.m=R,this.n.fire(R))}async sync(R,O={}){await this.U(R,!0,this.ob(),O)}async preview(R,O,E={}){return this.U(R,!1,O,E)}async apply(R,O={}){try{this.F={...O};const E=await this.ab(R);return this.S(E),this.c}finally{this.F={}}}async U(R,O,E,v){try{if(this.F={...v},this.status===d.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===d.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(d.SyncStatus.Syncing);let T=d.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),F=await this.X(R,U);return T=await this.Y(F,U,O,E),T===d.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T===d.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(R){const O=this.kb(R);if(!O)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(d.SyncStatus.Syncing);const E=await this.getLastSyncUserData(),v=await this.X(null,E),T=await this.W(v),U=await this.qb({ref:v.ref,syncData:O},E,T,this.ob(),L.CancellationToken.None),F=[];for(const M of U){const X=await this.sb(M,M.remoteResource,void 0,L.CancellationToken.None),{remoteChange:K}=await this.sb(M,M.previewResource,M.remoteContent,L.CancellationToken.None);F.push([M,{...X,remoteChange:K!==d.Change.None?K:d.Change.Modified}])}await this.tb(v,E,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(d.SyncStatus.Idle)}return!0}async W(R){const O=await this.j;return!!R.syncData?.machineId&&R.syncData.machineId===O}async X(R,O){if(O){const E=R?R[this.resource]:void 0;if(O.ref===E||E===void 0&&O.syncData===null)return O}return this.getRemoteUserData(O)}async Y(R,O,E,v){if(R.syncData&&R.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$Xmb((0,m.localize)(0,null,this.resource,this.pb,R.syncData.version),d.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(R,O,E,v)}catch(T){if(T instanceof d.$Xmb)switch(T.code){case d.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(R,O,E,v);case d.UserDataSyncErrorCode.Conflict:case d.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),R=await this.getRemoteUserData(null),O=await this.getLastSyncUserData(),this.Y(R,O,E,v)}throw T}}async Z(R,O,E,v){try{const T=await this.W(R),U=!T&&O===null&&this.gb()!==void 0,F=E&&!U;this.c||(this.c=(0,a.$rh)(X=>this.eb(R,O,T,F,v,X)));let M=await this.c;if(E&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of M.resourcePreviews)M=await this.accept(X.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:X})=>X===d.MergeState.Conflict)?d.SyncStatus.HasConflicts:E?await this.ab(!1):d.SyncStatus.Syncing}catch(T){throw this.c=null,T}}async merge(R){return await this.$(R,async O=>{const E=await this.rb(O,L.CancellationToken.None);await this.G.writeFile(O.previewResource,N.$Ne.fromString(E?.content||""));const v=E&&!E.hasConflicts?await this.sb(O,O.previewResource,void 0,L.CancellationToken.None):void 0;return O.acceptResult=v,O.mergeState=E.hasConflicts?d.MergeState.Conflict:v?d.MergeState.Accepted:d.MergeState.Preview,O.localChange=v?v.localChange:E.localChange,O.remoteChange=v?v.remoteChange:E.remoteChange,O}),this.c}async accept(R,O){return await this.$(R,async E=>{const v=await this.sb(E,R,O,L.CancellationToken.None);return E.acceptResult=v,E.mergeState=d.MergeState.Accepted,E.localChange=v.localChange,E.remoteChange=v.remoteChange,E}),this.c}async discard(R){return await this.$(R,async O=>{const E=await this.rb(O,L.CancellationToken.None);return await this.G.writeFile(O.previewResource,N.$Ne.fromString(E.content||"")),O.acceptResult=void 0,O.mergeState=d.MergeState.Preview,O.localChange=E.localChange,O.remoteChange=E.remoteChange,O}),this.c}async $(R,O){if(!this.c)return;let E=await this.c;const v=E.resourcePreviews.findIndex(({localResource:T,remoteResource:U,previewResource:F})=>this.h.isEqual(T,R)||this.h.isEqual(U,R)||this.h.isEqual(F,R));v!==-1&&(this.c=(0,a.$rh)(async T=>{const U=[...E.resourcePreviews];return U[v]=await O(U[v]),{...E,resourcePreviews:U}}),E=await this.c,this.cb(E.resourcePreviews),E.resourcePreviews.some(({mergeState:T})=>T===d.MergeState.Conflict)?this.S(d.SyncStatus.HasConflicts):this.S(d.SyncStatus.Syncing))}async ab(R){if(!this.c)return d.SyncStatus.Idle;const O=await this.c;return O.resourcePreviews.some(({mergeState:E})=>E===d.MergeState.Conflict)?d.SyncStatus.HasConflicts:O.resourcePreviews.some(({mergeState:E})=>E!==d.MergeState.Accepted)?d.SyncStatus.Syncing:(await this.tb(O.remoteUserData,O.lastSyncUserData,O.resourcePreviews.map(E=>[E,E.acceptResult]),R),this.c=null,await this.bb(),d.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(R){const O=R.filter(({mergeState:E})=>E===d.MergeState.Conflict);(0,P.$vb)(this.s,O,(E,v)=>this.h.isEqual(E.previewResource,v.previewResource))||(this.s=O,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const R=await this.getLastSyncUserData();return!!R&&R.syncData!==null}async db(R){const O=this.c?await this.c:null;if(O)for(const E of O.resourcePreviews){if(this.h.isEqual(E.acceptedResource,R))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,R))return E.remoteContent;if(this.h.isEqual(E.localResource,R))return E.localContent;if(this.h.isEqual(E.baseResource,R))return E.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(R){(0,c.$pl)(R)!==c.FileOperationResult.FILE_NOT_FOUND&&this.O.error(R)}}async eb(R,O,E,v,T,U){const F=await this.qb(R,O,E,T,U),M=[];for(const X of F){const K=X.previewResource.with({scheme:d.$0mb,authority:"accepted"});if(X.localChange===d.Change.None&&X.remoteChange===d.Change.None)M.push({...X,acceptedResource:K,acceptResult:{content:null,localChange:d.Change.None,remoteChange:d.Change.None},mergeState:d.MergeState.Accepted});else{const Q=v?await this.rb(X,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(X.previewResource,N.$Ne.fromString(Q?.content||""));const G=Q&&!Q.hasConflicts?await this.sb(X,X.previewResource,void 0,U):void 0;M.push({...X,acceptResult:G,mergeState:Q?.hasConflicts?d.MergeState.Conflict:G?d.MergeState.Accepted:d.MergeState.Preview,localChange:G?G.localChange:Q?Q.localChange:X.localChange,remoteChange:G?G.remoteChange:Q?Q.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:R,lastSyncUserData:O,resourcePreviews:M,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let R=this.gb();if(R||(R=await this.jb()),!R)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const O=JSON.parse(R),E=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!O.version&&!!E&&O.version!==E,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${O.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let v,T=1;for(;v===void 0&&T++<6;)try{const U=await this.hb();U&&(U.ref===O.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof c.$tl&&U.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof d.$Xmb)throw U;this.O.error(U,T)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,O.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:O.ref,syncData:v})}catch(U){if(U instanceof d.$Xmb&&U.code===d.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...O,syncData:v}}async fb(R,O={}){if(O.ref||O.version)throw new Error("Cannot have core properties as additional");const E=this.M.getResourceSyncStateVersion(this.resource),v={ref:R.ref,version:E,...O};this.I.store(this.z,JSON.stringify(v),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(R)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const R=(await this.G.readFile(this.y)).value.toString();try{const O=R?JSON.parse(R):void 0;if(t(O))return O}catch(O){this.O.error(O)}}async ib(R){await this.G.writeFile(this.y,N.$Ne.fromString(JSON.stringify(R)))}async jb(){try{const R=await this.G.readFile(this.y),O=JSON.parse(R.value.toString());await this.G.del(this.y),O.ref&&O.content!==void 0?(this.I.store(this.z,JSON.stringify({...O,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:O.ref,syncData:O.content===null?null:JSON.parse(O.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,O)}catch(R){R instanceof c.$tl&&R.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(R)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(R){const{ref:O,content:E}=await this.lb(R);let v=null;return E!==null&&(v=this.kb(E)),{ref:O,syncData:v}}kb(R){try{const O=JSON.parse(R);if(s(O))return O}catch(O){this.O.error(O)}throw new d.$Xmb((0,m.localize)(1,null),d.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(R){const O=R?{ref:R.ref,content:R.syncData?JSON.stringify(R.syncData):null}:null;return this.J.readResource(this.resource,O,this.collection,this.F)}async mb(R,O){const E=await this.j,v={version:this.pb,machineId:E,content:R};try{return O=await this.J.writeResource(this.resource,JSON.stringify(v),O,this.collection,this.F),{ref:O,syncData:v}}catch(T){throw T instanceof d.$Xmb&&T.code===d.UserDataSyncErrorCode.TooLarge&&(T=new d.$Xmb(T.message,T.code,this.resource)),T}}async nb(R){const O={version:this.pb,content:R};return this.L.writeResource(this.resource,JSON.stringify(O),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==d.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(d.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$Kmb)}};e.$2Mb=i,e.$2Mb=i=ve([Z(2,c.$$k),Z(3,$.$Li),Z(4,f.$bq),Z(5,d.$Smb),Z(6,d.$Tmb),Z(7,d.$3mb),Z(8,p.$0l),Z(9,d.$8mb),Z(10,h.$$i),Z(11,I.$Il)],i);let n=class extends i{constructor(R,O,E,v,T,U,F,M,X,K,Q,G,ie){super(O,E,v,T,U,F,M,X,K,Q,G,ie),this.r=R,this.B(this.G.watch(this.h.dirname(R))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(R,O,E){try{O?await this.G.writeFile(this.r,N.$Ne.fromString(R),E?void 0:O):await this.G.createFile(this.r,N.$Ne.fromString(R),{overwrite:E})}catch(v){throw v instanceof c.$tl&&v.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND||v instanceof c.$tl&&v.fileOperationResult===c.FileOperationResult.FILE_MODIFIED_SINCE?new d.$Xmb(v.message,d.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(R){if(!(R instanceof c.$tl&&R.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND))throw R}}yb(R){R.contains(this.r)&&this.Q()}};e.$3Mb=n,e.$3Mb=n=ve([Z(3,c.$$k),Z(4,$.$Li),Z(5,f.$bq),Z(6,d.$Smb),Z(7,d.$Tmb),Z(8,d.$3mb),Z(9,p.$0l),Z(10,d.$8mb),Z(11,h.$$i),Z(12,I.$Il)],n);let o=class extends n{constructor(R,O,E,v,T,U,F,M,X,K,Q,G,ie,V){super(R,O,E,v,T,U,F,M,X,K,Q,ie,V),this.zb=G,this.Bb=void 0}Ab(R,O){const E=[],v=(0,k.$Un)(R,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,S.$lg)(v)&&O!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$4Mb=o,e.$4Mb=o=ve([Z(3,c.$$k),Z(4,$.$Li),Z(5,f.$bq),Z(6,d.$Smb),Z(7,d.$Tmb),Z(8,d.$3mb),Z(9,p.$0l),Z(10,d.$8mb),Z(11,d.$7mb),Z(12,h.$$i),Z(13,I.$Il)],o);let l=class{constructor(R,O,E,v,T,U,F){this.resource=R,this.g=O,this.h=E,this.j=v,this.k=T,this.l=U,this.d=F.extUri,this.f=(0,d.$Qmb)(void 0,this.resource,E,this.d)}async initialize({ref:R,content:O}){if(!O){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(O);if(E)try{await this.o({ref:R,syncData:E})}catch(v){this.j.error(v)}}m(R){try{const O=JSON.parse(R);if(s(O))return O}catch(O){this.j.error(O)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(R,O={}){if(O.ref||O.version)throw new Error("Cannot have core properties as additional");const E={ref:R.ref,version:void 0,...O};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Ne.fromString(JSON.stringify(R)))}};e.$5Mb=l,e.$5Mb=l=ve([Z(1,u.$Kl),Z(2,$.$Li),Z(3,g.$$j),Z(4,c.$$k),Z(5,f.$bq),Z(6,I.$Il)],l)}),define(le[120],he([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,37,7,4,77,10,17,18,29,20,40,242,115,25,62]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t,s,r,i,n,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=e.$Uac=void 0,e.$Sac=R,e.$Tac=O;async function y(U,F){const M=JSON.parse(U.content);if(U.version===1||U.version===2){const X=(await F.getInstalled(g.ExtensionType.System)).filter(K=>K.isBuiltin);for(const K of M)U.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),U.version===2&&X.every(Q=>!(0,$.$Hp)(Q.identifier,K.identifier))&&(K.installed=!0)}return M}function R(U){return JSON.parse(U.content)}function O(U,F){return U.sort((M,X)=>!M.identifier.uuid&&X.identifier.uuid?-1:M.identifier.uuid&&!X.identifier.uuid?1:(0,A.$yf)(M.identifier.id,X.identifier.id)),F?(0,C.$6n)(U,{}):JSON.stringify(U)}let E=class extends r.$2Mb{constructor(F,M,X,K,Q,G,ie,V,z,ee,re,ce,q,x,J,H,D){super({syncResource:o.SyncResource.Extensions,profile:F},M,K,X,Q,G,ie,ce,q,ee,re,J),this.Cb=V,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$0mb,authority:"base"}),this.yb=this.wb.with({scheme:o.$0mb,authority:"local"}),this.zb=this.wb.with({scheme:o.$0mb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$0mb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:j})=>!!j)),L.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),L.Event.filter(H.onDidChange,B=>B.valueChanges.some(({profile:j,changes:W})=>this.syncResource.profile.id===j.id&&W.some(te=>te.key===h.$kp))),x.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,M){const X=F.syncData?await y(F.syncData,this.Cb):null,K=M?.skippedExtensions??[],Q=M?.builtinExtensions??null,G=M?.syncData?await y(M.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);X?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:ee}=(0,i.$Rac)(ie,X,G,K,V,Q),re={local:z,remote:ee,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ee!==null?o.Change.Modified:o.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:K,builtinExtensions:Q,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:X,remoteContent:X?this.Ob(X,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(F){const M=F.syncData?await y(F.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,i.$Rac)(X,M,M,F.skippedExtensions||[],K,F.builtinExtensions||[]);return Q!==null}Hb(F,M,X,K){const Q=[...M,...X],G=new Set,ie=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};Q.forEach(({identifier:V})=>ie(V)),K.forEach(ie);for(const V of F)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||Q.push(V);return this.Ob(Q,!1)}async rb(F,M){return{...F.previewResult,hasConflicts:!1}}async sb(F,M,X,K){if(this.h.isEqual(M,this.yb))return this.Kb(F);if(this.h.isEqual(M,this.zb))return this.Lb(F);if(this.h.isEqual(M,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(M),K=(0,i.$Rac)(F.localExtensions,null,null,F.skippedExtensions,X,F.builtinExtensions),{local:Q,remote:G}=K;return{content:F.localContent,local:Q,remote:G,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:G!==null?o.Change.Modified:o.Change.None}}async Lb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(M),K=F.remoteContent?JSON.parse(F.remoteContent):null;if(K!==null){const Q=(0,i.$Rac)(F.localExtensions,K,F.localExtensions,[],X,F.builtinExtensions),{local:G,remote:ie}=Q;return{content:F.remoteContent,local:G,remote:ie,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async tb(F,M,X,K){let{skippedExtensions:Q,builtinExtensions:G,localExtensions:ie}=X[0][0];const{local:V,remote:z,localChange:ee,remoteChange:re}=X[0][1];if(ee===o.Change.None&&re===o.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==o.Change.None&&(await this.nb(JSON.stringify(ie)),Q=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,Q,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(z.all);F=await this.mb(ce,K?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(q=>q.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(q=>q.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(q=>q.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(ie,G),await this.fb(F,{skippedExtensions:Q,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ce=>ce.identifier.id))}.`:""}`))}Nb(F,M){const X=new Set,K=[];for(const Q of F)X.add(Q.identifier.id.toLowerCase()),Q.installed||K.push(Q.identifier);if(M)for(const Q of M)X.has(Q.id.toLowerCase())||K.push(Q);return K}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const M=await this.db(F);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(F,M){return O(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$Uac=E,e.$Uac=E=ve([Z(2,S.$Li),Z(3,b.$$k),Z(4,d.$bq),Z(5,o.$Smb),Z(6,o.$Tmb),Z(7,h.$jp),Z(8,n.$NNb),Z(9,o.$8mb),Z(10,w.$$i),Z(11,o.$3mb),Z(12,u.$0l),Z(13,c.$iw),Z(14,t.$Il),Z(15,l.$VLb),Z(16,f.$Di)],E);let v=class{constructor(F,M,X,K,Q,G){this.a=F,this.b=M,this.c=X,this.d=K,this.f=Q,this.g=G}async getLocalExtensions(F){const M=await this.a.getInstalled(void 0,F.extensionsResource),X=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(F,async(Q,G)=>{const ie=Q.getDisabledExtensions();return M.map(V=>{const{identifier:z,isBuiltin:ee,manifest:re,preRelease:ce,pinned:q,isApplicationScoped:x}=V,J={identifier:z,preRelease:ce,version:re.version,pinned:!!q};x&&!(0,g.$sn)(re)&&(J.isApplicationScoped=x),ie.some(H=>(0,$.$Hp)(H,z))&&(J.disabled=!0),ee||(J.installed=!0);try{const H=G.getKeysForSync({id:z.id,version:re.version});if(H){const D=G.getExtensionState(V,!0)||{};J.state=Object.keys(D).reduce((B,j)=>(H.includes(j)&&(B[j]=D[j]),B),{})}}catch(H){this.g.info(`${(0,r.$1Mb)(o.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,N.$$)(H))}return J})}),ignoredExtensions:X}}async updateLocalExtensions(F,M,X,K,Q){const G=(0,r.$1Mb)(o.SyncResource.Extensions,Q),ie=[],V=new Map,z=[],ee=[],re=await this.a.getInstalled(void 0,Q.extensionsResource);if((F.length||X.length)&&await this.j(Q,async(x,J)=>{await P.Promises.settled([...F,...X].map(async H=>{const D=re.find(W=>(0,$.$Hp)(W.identifier,H.identifier));if(D&&D.isBuiltin){H.state&&D.manifest.version===H.version&&this.h(H.state,D,D.manifest.version,J),x.getDisabledExtensions().some(te=>(0,$.$Hp)(te,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id),await x.disableExtension(H.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id),await x.enableExtension(H.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id))),z.push(H.identifier);return}const B=H.pinned?H.version:void 0,j=(await this.c.getExtensions([{...H.identifier,version:B,preRelease:B?void 0:H.preRelease}],a.CancellationToken.None))[0];if(H.state&&(D?D.manifest.version===H.version:j)&&this.h(H.state,D||j,D?.manifest.version,J),j)try{x.getDisabledExtensions().some(te=>(0,$.$Hp)(te,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id,j.version),await x.disableExtension(j.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id,j.version)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id,j.version),await x.enableExtension(j.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id,j.version))),(!D||D.preRelease!==H.preRelease||D.pinned!==H.pinned||B&&D.manifest.version!==B)&&(await this.a.canInstall(j)?(ie.push({extension:j,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:H.pinned&&!!H.version,pinned:H.pinned,installPreReleaseVersion:H.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:H.isApplicationScoped,context:{[h.$9o]:!0,[h.$0o]:h.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(j.identifier.id.toLowerCase(),H)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),ee.push(H)))}catch(W){ee.push(H),this.g.error(W),this.g.info(`${G}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else ee.push(H),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,H.identifier.id)}))}),M.length){const x=re.filter(({identifier:J,isBuiltin:H})=>!H&&M.some(D=>(0,$.$Hp)(J,D)));await P.Promises.settled(x.map(async J=>{this.g.trace(`${G}: Uninstalling local extension...`,J.identifier.id),await this.a.uninstall(J,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,J.identifier.id),z.push(J.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:x,local:J,error:H,source:D}of ce){const B=D;if(J)this.g.info(`${G}: Installed extension.`,x.id,B.version),z.push(x);else{const j=V.get(x.id.toLowerCase());j&&(ee.push(j),this.g.info(`${G}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),H instanceof h.$ip&&[h.ExtensionManagementErrorCode.Incompatible,h.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(H.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):H&&this.g.error(H)}}const q=[];for(const x of K)z.some(J=>(0,$.$Hp)(J,x.identifier))||q.push(x);for(const x of ee)q.some(J=>(0,$.$Hp)(J.identifier,x.identifier))||q.push(x);return q}h(F,M,X,K){const Q=K.getExtensionState(M,!0)||{},G=X?K.getKeysForSync({id:M.identifier.id,version:X}):void 0;G?G.forEach(ie=>{Q[ie]=F[ie]}):Object.keys(F).forEach(ie=>Q[ie]=F[ie]),K.setExtensionState(M,Q,!0)}async j(F,M){return this.b.withProfileScopedStorageService(F,async X=>{const K=new k.$Uc,Q=K.add(this.f.createChild(new p.$Ci([d.$bq,X]))),G=K.add(Q.createInstance(m.$hLb)),ie=K.add(Q.createInstance(c.$jw));try{return await M(G,ie)}finally{K.dispose()}})}};e.$Vac=v,e.$Vac=v=ve([Z(0,h.$jp),Z(1,l.$VLb),Z(2,h.$gp),Z(3,n.$NNb),Z(4,f.$Di),Z(5,o.$8mb)],v);let T=class extends r.$5Mb{constructor(F,M,X,K,Q,G,ie,V){super(o.SyncResource.Extensions,K,Q,G,X,ie,V),this.p=F,this.q=M}async t(F){return F.syncData?await y(F.syncData,this.p):null}u(F,M){const X=[],K=[],Q=[];for(const G of F){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const ie=M.find(V=>(0,$.$Hp)(V.identifier,G.identifier));ie?(X.push(ie),G.disabled&&Q.push(G.identifier)):G.installed&&(K.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&Q.push(G.identifier))}return{installedExtensions:X,newExtensions:K,disabledExtensions:Q,remoteExtensions:F}}};e.$Wac=T,e.$Wac=T=ve([Z(0,h.$jp),Z(1,n.$NNb),Z(2,b.$$k),Z(3,s.$Kl),Z(4,S.$Li),Z(5,I.$$j),Z(6,d.$bq),Z(7,t.$Il)],T)}),define(le[121],he([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,246,25,20,62,4]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Mb=e.$0Mb=e.$9Mb=e.$8Mb=void 0,e.$7Mb=n;const r="globalState.argv.",i=["locale"];function n(E,v){const T=E.storage?Object.keys(E.storage).sort():[],U={};return T.forEach(F=>U[F]=E.storage[F]),E.storage=U,v?(0,C.$6n)(E,{}):JSON.stringify(E)}const o=1;let l=class extends f.$2Mb{constructor(v,T,U,F,M,X,K,Q,G,ie,V,z,ee,re){super({syncResource:d.SyncResource.GlobalState,profile:v},T,F,Q,z,M,X,G,ie,K,V,ee),this.Bb=U,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$0mb,authority:"base"}),this.xb=this.vb.with({scheme:d.$0mb,authority:"local"}),this.yb=this.vb.with({scheme:d.$0mb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$0mb,authority:"accepted"}),this.Ab=re.createInstance(y),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(F.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),N.Event.filter(U.onDidChange,ce=>!!(ce.targetChanges.some(q=>this.syncResource.profile.id===q.id)||ce.valueChanges.some(({profile:q,changes:x})=>this.syncResource.profile.id===q.id&&x.some(J=>J.target===c.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,T,U){const F=v.syncData?JSON.parse(v.syncData.content):null;T=T===null&&U?v:T;const M=T&&T.syncData?JSON.parse(T.syncData.content):null,X=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(M),{local:Q,remote:G}=(0,I.$6Mb)(X.storage,F?F.storage:null,M?M.storage:null,K,this.O),ie={content:null,local:Q,remote:G,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?d.Change.Modified:d.Change.None,remoteChange:G.all!==null?d.Change.Modified:d.Change.None},V=n(X,!1);return[{baseResource:this.wb,baseContent:M?n(M,!1):V,localResource:this.xb,localContent:V,localUserData:X,remoteResource:this.yb,remoteContent:F?n(F,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(v){const T=v.syncData?JSON.parse(v.syncData.content):null;if(T===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(T),{remote:M}=(0,I.$6Mb)(U.storage,T.storage,T.storage,F,this.O);return M.all!==null}async rb(v,T){return{...v.previewResult,hasConflicts:!1}}async sb(v,T,U,F){if(this.h.isEqual(T,this.xb))return this.Gb(v);if(this.h.isEqual(T,this.yb))return this.Hb(v);if(this.h.isEqual(T,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:d.Change.None,remoteChange:d.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const T=JSON.parse(v.remoteContent),{local:U,remote:F}=(0,I.$6Mb)(v.localUserData.storage,T.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?d.Change.Modified:d.Change.None,remoteChange:F!==null?d.Change.Modified:d.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:d.Change.None,remoteChange:d.Change.None}}async tb(v,T,U,F){const{localUserData:M}=U[0][0],{local:X,remote:K,localChange:Q,remoteChange:G}=U[0][1];if(Q===d.Change.None&&G===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==d.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(X,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==d.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:K.all});v=await this.mb(ie,F?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}T?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const T=await this.db(v);return T&&n(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const T=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[K,Q]of T)Q.target===c.StorageTarget.USER?U.push(K):Q.target===c.StorageTarget.MACHINE&&F.push(K);const M=[...U,...F],X=v?.storage?Object.keys(v.storage).filter(K=>!K.startsWith(r)&&!M.includes(K)&&T.get(K)!==void 0):[];if(!k.$o){const K=[...d.$Omb.map(Q=>(0,d.$2mb)(Q)),d.$1mb];X.push(...K),F.push(...K)}return{user:U,machine:F,unregistered:X}}};e.$8Mb=l,e.$8Mb=l=ve([Z(2,t.$VLb),Z(3,m.$$k),Z(4,d.$Smb),Z(5,d.$Tmb),Z(6,d.$8mb),Z(7,S.$Li),Z(8,d.$3mb),Z(9,g.$0l),Z(10,w.$$i),Z(11,c.$bq),Z(12,b.$Il),Z(13,s.$Di)],l);let y=class{constructor(v,T,U,F){this.a=v,this.b=T,this.c=U,this.d=F}async getLocalGlobalState(v){const T={};if(v.isDefault){const F=await this.f(),M=(0,L.$Un)(F);for(const X of i)M[X]!==void 0&&(T[`${r}${X}`]={version:1,value:M[X]})}const U=await this.c.readStorageData(v);for(const[F,M]of U)M.value&&M.target===c.StorageTarget.USER&&(T[F]={version:1,value:M.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$$)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:T,updated:U},F){const M=(0,f.$1Mb)(d.SyncResource.GlobalState,F),X={},K=new Map,Q=await this.c.readStorageData(F),G=(ie,V)=>{for(const z of ie){if(z.startsWith(r)){X[z.substring(r.length)]=V?V[z].value:void 0;continue}if(V){const ee=V[z];ee.value!==Q.get(z)?.value&&K.set(z,ee.value)}else Q.get(z)!==void 0&&K.set(z,void 0)}};if(G(Object.keys(v),v),G(Object.keys(U),U),G(T),Object.keys(X).length){this.d.trace(`${M}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(X))V=(0,p.edit)(V,[z],X[z],{});ie!==V&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,P.$Ne.fromString(V)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}K.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(F,K,c.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...K.keys()]))}};e.$9Mb=y,e.$9Mb=y=ve([Z(0,m.$$k),Z(1,S.$Li),Z(2,t.$VLb),Z(3,d.$8mb)],y);let R=class extends f.$5Mb{constructor(v,T,U,F,M,X){super(d.SyncResource.GlobalState,U,F,M,T,v,X)}async o(v){const T=v.syncData?JSON.parse(v.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const M of Object.keys(T.storage))M.startsWith(r)?U[M.substring(r.length)]=T.storage[M].value:this.l.get(M,c.StorageScope.PROFILE)===void 0&&(F[M]=T.storage[M].value);if(Object.keys(U).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const X of Object.keys(U))M=(0,p.edit)(M,[X],U[X],{});await this.k.writeFile(this.h.argvResource,P.$Ne.fromString(M))}if(Object.keys(F).length){const M=[];for(const X of Object.keys(F))M.push({key:X,value:F[X],scope:c.StorageScope.PROFILE,target:c.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$0Mb=R,e.$0Mb=R=ve([Z(0,c.$bq),Z(1,m.$$k),Z(2,u.$Kl),Z(3,S.$Li),Z(4,d.$8mb),Z(5,b.$Il)],R);let O=class{constructor(v,T,U,F,M){this.a=v,this.b=T,this.c=U,this.d=F,this.f=M}getSyncStoreType(v){return this.h(v)?.storage[d.$1mb]?.value}async sync(v){const T=(0,d.$Wmb)((0,A.$1g)());try{return await this.g(v,T)}catch(U){if(U instanceof d.$Xmb)switch(U.code){case d.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,T)}throw U}}async g(v,T){const U=await this.a.readResource(d.SyncResource.GlobalState,null,void 0,T),F=this.h(U)||{storage:{}};F.storage[d.$1mb]={value:v,version:o};const M=await(0,$.$hq)(this.c,this.d,this.b),X={version:o,machineId:M,content:n(F,!1)};await this.a.writeResource(d.SyncResource.GlobalState,JSON.stringify(X),U.ref,void 0,T)}h({content:v}){if(!v)return null;const T=JSON.parse(v);if((0,f.$ZMb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$$Mb=O,e.$$Mb=O=ve([Z(1,c.$bq),Z(2,S.$Li),Z(3,m.$$k),Z(4,h.$$j)],O)}),define(le[122],he([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,243,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=e.$Zac=void 0,e.$Yac=I;function I(t,s,r){try{const i=JSON.parse(t);if(!s)return(0,k.$lg)(i.all)?null:i.all;switch(C.OS){case C.OperatingSystem.Macintosh:return(0,k.$lg)(i.mac)?null:i.mac;case C.OperatingSystem.Linux:return(0,k.$lg)(i.linux)?null:i.linux;case C.OperatingSystem.Windows:return(0,k.$lg)(i.windows)?null:i.windows}}catch(i){return r.error(i),null}}let d=class extends b.$4Mb{constructor(s,r,i,n,o,l,y,R,O,E,v,T,U){super(s.keybindingsResource,{syncResource:p.SyncResource.Keybindings,profile:s},r,R,O,E,i,n,y,T,o,v,l,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:p.$0mb,authority:"base"}),this.Gb=this.Eb.with({scheme:p.$0mb,authority:"local"}),this.Hb=this.Eb.with({scheme:p.$0mb,authority:"remote"}),this.Ib=this.Eb.with({scheme:p.$0mb,authority:"accepted"}),this.B(N.Event.filter(l.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(s,r,i,n){const o=s.syncData?I(s.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;r=r===null&&i?s:r;const l=r?this.Ob(r):null,y=await this.vb(),R=await this.Cb();let O=null,E=!1,v=!1,T=!1;if(o){let M=y?y.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new p.$Xmb((0,A.localize)(0,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==M||l!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const X=await(0,f.$Xac)(M,o,l,R,this.zb);X.hasChanges&&(O=X.mergeContent,T=X.hasConflicts,E=T||X.mergeContent!==M,v=T||X.mergeContent!==o)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),O=y.value.toString(),v=!0);const U={content:T?l:O,localChange:E?y?p.Change.Modified:p.Change.Added:p.Change.None,remoteChange:v?p.Change.Modified:p.Change.None,hasConflicts:T},F=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:l,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(s){const r=this.Ob(s);if(r===null)return!0;const i=await this.vb(),n=i?i.value.toString():"",o=await this.Cb(),l=await(0,f.$Xac)(n||"[]",r,r,o,this.zb);return l.hasConflicts||l.mergeContent!==r}async rb(s,r){return s.previewResult}async sb(s,r,i,n){if(this.h.isEqual(r,this.Gb))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:p.Change.None,remoteChange:p.Change.Modified};if(this.h.isEqual(r,this.Hb))return{content:s.remoteContent,localChange:p.Change.Modified,remoteChange:p.Change.None};if(this.h.isEqual(r,this.Eb))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:p.Change.Modified,remoteChange:p.Change.Modified};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(s,r,i,n){const{fileContent:o}=i[0][0];let{content:l,localChange:y,remoteChange:R}=i[0][1];if(y===p.Change.None&&R===p.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.Ab(l,!0)))throw new p.$Xmb((0,A.localize)(1,null),p.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(y!==p.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(l||"[]",o,n),this.O.info(`${this.D}: Updated local keybindings`)),R!==p.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const O=this.Pb(l||"[]",s.syncData?.content);s=await this.mb(O,n?null:s.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}r?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(s,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.vb();if(s){const r=(0,L.$Un)(s.value.toString());if((0,P.$Mb)(r))return!0}}catch(s){if(s.fileOperationResult!==m.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.Hb,s)||this.h.isEqual(this.Fb,s)||this.h.isEqual(this.Gb,s)||this.h.isEqual(this.Ib,s)?this.db(s):null}Ob(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.Qb()?null:I(s.syncData.content,this.Qb(),this.O)}Pb(s,r){let i={};try{i=JSON.parse(r||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete i.all:i.all=s,C.OS){case C.OperatingSystem.Macintosh:i.mac=s;break;case C.OperatingSystem.Linux:i.linux=s;break;case C.OperatingSystem.Windows:i.windows=s;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(p.$Lmb)}};e.$Zac=d,e.$Zac=d=ve([Z(2,p.$Smb),Z(3,p.$Tmb),Z(4,p.$8mb),Z(5,w.$$i),Z(6,p.$3mb),Z(7,m.$$k),Z(8,S.$Li),Z(9,h.$bq),Z(10,p.$7mb),Z(11,$.$0l),Z(12,c.$Il)],d);let u=class extends b.$5Mb{constructor(s,r,i,n,o,l){super(p.SyncResource.Keybindings,r,i,n,s,o,l)}async o(s){const r=s.syncData?this.p(s.syncData.content):null;if(!r){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Ne.fromString(r)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource),r=(0,L.$Un)(s.value.toString());return!(0,P.$Mb)(r)}catch(s){return s.fileOperationResult===m.FileOperationResult.FILE_NOT_FOUND}}p(s){try{return I(s,!0,this.j)}catch(r){return this.j.error(r),null}}};e.$1ac=u,e.$1ac=u=ve([Z(0,m.$$k),Z(1,g.$Kl),Z(2,S.$Li),Z(3,p.$8mb),Z(4,h.$bq),Z(5,c.$Il)],u)}),define(le[123],he([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,247,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0,e.$2ac=p;function f(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function p(u){const t=JSON.parse(u);return f(t)?t:{settings:u}}let I=class extends c.$4Mb{constructor(t,s,r,i,n,o,l,y,R,O,E,v,T,U){super(t.settingsResource,{syncResource:b.SyncResource.Settings,profile:t},s,r,i,n,o,l,E,v,y,R,O,U),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:b.$0mb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$0mb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$0mb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$0mb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),r=await this.X(t,s),i=this.Lb(r),n=new C.$Ko(b.$Kmb,this.O);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(b.$Kmb)||{}}async qb(t,s,r){const i=await this.vb(),n=await this.Cb(),o=this.Lb(t);s=s===null&&r?t:s;const l=s?this.Lb(s):null,y=await this.Pb();let R=null,O=!1,E=!1,v=!1;if(o){let M=i?i.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const X=(0,g.$CLb)(M,o.settings,l?l.settings:null,y,[],n);R=X.localContent||X.remoteContent,O=X.localContent!==null,E=X.remoteContent!==null,v=X.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),R=i.value.toString().trim()||"{}",this.Qb(R),E=!0);const T=i?i.value.toString():null,U=l?.settings??null,F={content:v?U:R,localChange:O?b.Change.Modified:b.Change.None,remoteChange:E?b.Change.Modified:b.Change.None,hasConflicts:v};return[{fileContent:i,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:T,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(t){const s=this.Lb(t);if(s===null)return!0;const r=await this.vb(),i=r?r.value.toString().trim():"",n=await this.Pb(),o=await this.Cb();return(0,g.$CLb)(i||"{}",s.settings,s.settings,n,[],o).remoteContent!==null}async rb(t,s){const r=await this.Cb(),i=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,g.$BLb)(t.previewResult.content,"{}",i,r):null}}async sb(t,s,r,i){const n=await this.Cb(),o=await this.Pb();if(this.h.isEqual(s,this.localResource))return{content:t.fileContent?(0,g.$BLb)(t.fileContent.value.toString(),"{}",o,n):null,localChange:b.Change.None,remoteChange:b.Change.Modified};if(this.h.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,g.$BLb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:b.Change.Modified,remoteChange:b.Change.None};if(this.h.isEqual(s,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,g.$BLb)(r,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:b.Change.Modified,remoteChange:b.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(t,s,r,i){const{fileContent:n}=r[0][0];let{content:o,localChange:l,remoteChange:y}=r[0][1];if(l===b.Change.None&&y===b.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),l!==b.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(o,n,i),await this.P.reloadConfiguration(L.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),y!==b.Change.None){const R=await this.Cb(),O=this.Lb(t),E=await this.Pb(o);o=(0,g.$BLb)(o,O?O.settings:"{}",E,R),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),i?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}s?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,g.$DLb)(t.value.toString())}catch(t){if(t.fileOperationResult!==w.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let s=await super.db(t);if(s){const r=await this.Cb(),i=await this.Pb();s=(0,g.$BLb)(s,"{}",i,r)}return s}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return p(t)}catch(s){this.O.error(s)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const r=this.B(a.Event.any(a.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),a.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{r.dispose(),this.Ob=void 0}))}const s=await this.Ob;return(0,g.$zLb)(s,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new b.$Xmb((0,N.localize)(0,null),b.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$3ac=I,e.$3ac=I=ve([Z(2,w.$$k),Z(3,k.$Li),Z(4,S.$bq),Z(5,b.$Smb),Z(6,b.$Tmb),Z(7,b.$8mb),Z(8,b.$7mb),Z(9,L.$$i),Z(10,b.$3mb),Z(11,m.$0l),Z(12,A.$jp),Z(13,h.$Il)],I);let d=class extends c.$5Mb{constructor(t,s,r,i,n,o){super(b.SyncResource.Settings,s,r,i,t,n,o)}async o(t){const s=t.syncData?this.p(t.syncData.content):null;if(!s){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,P.$Ne.fromString(s.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,g.$DLb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===w.FileOperationResult.FILE_NOT_FOUND}}p(t){try{return p(t)}catch(s){this.j.error(s)}return null}};e.$4ac=d,e.$4ac=d=ve([Z(0,w.$$k),Z(1,$.$Kl),Z(2,k.$Li),Z(3,b.$8mb),Z(4,S.$bq),Z(5,h.$Il)],d)}),define(le[124],he([0,1,15,3,30,22,16,7,17,18,29,20,40,244,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=e.$8ac=void 0,e.$7ac=g;function g(p){return JSON.parse(p.content)}let b=class extends h.$2Mb{constructor(I,d,u,t,s,r,i,n,o,l,y,R){super({syncResource:c.SyncResource.Snippets,profile:I},d,t,u,s,r,i,l,y,n,o,R),this.pb=1,this.vb=I.snippetsHome,this.B(this.G.watch(u.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,O=>O.affects(this.vb))(()=>this.Q()))}async qb(I,d,u){const t=await this.Hb(),s=this.Gb(t),r=I.syncData?this.Fb(I.syncData):null;d=d===null&&u?I:d;const i=d&&d.syncData?this.Fb(d.syncData):null;r?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$5ac)(s,r,i);return this.Bb(n,t,r||{},i||{})}async ub(I){const d=I.syncData?this.Fb(I.syncData):null;if(d===null)return!0;const u=await this.Hb(),t=this.Gb(u),s=(0,$.$5ac)(t,d,d);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async rb(I,d){return I.previewResult}async sb(I,d,u,t){if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$0mb,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:c.Change.None,remoteChange:I.fileContent?I.remoteContent!==null?c.Change.Modified:c.Change.Added:c.Change.Deleted};if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$0mb,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?c.Change.Modified:c.Change.Added:c.Change.Deleted,remoteChange:c.Change.None};if(this.h.isEqualOrParent(d,this.g))return u===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:u,localChange:u===null?I.fileContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified,remoteChange:u===null?I.remoteContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(I,d,u,t){const s=u.map(([r,i])=>({...r,acceptResult:i}));s.every(({localChange:r,remoteChange:i})=>r===c.Change.None&&i===c.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==c.Change.None)&&(await this.Cb(s),await this.Db(s,t)),s.some(({remoteChange:r})=>r!==c.Change.None)&&(I=await this.Eb(s,I,t)),d?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.G.del(r)}catch{}}Bb(I,d,u,t){const s=new Map;for(const r of Object.keys(I.local.added)){const i={content:I.local.added[r],hasConflicts:!1,localChange:c.Change.Added,remoteChange:c.Change.None};s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of Object.keys(I.local.updated)){const i={content:I.local.updated[r],hasConflicts:!1,localChange:c.Change.Modified,remoteChange:c.Change.None},n=d[r]?d[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:d[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of I.local.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.Deleted,remoteChange:c.Change.None},n=d[r]?d[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:d[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of Object.keys(I.remote.added)){const i={content:I.remote.added[r],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Added},n=d[r]?d[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:d[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of Object.keys(I.remote.updated)){const i={content:I.remote.updated[r],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Modified},n=d[r]?d[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:d[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of I.remote.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Deleted};s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of I.conflicts){const i={content:t[r]??null,hasConflicts:!0,localChange:d[r]?c.Change.Modified:c.Change.Added,remoteChange:u[r]?c.Change.Modified:c.Change.Added},n=d[r]?d[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:d[r]||null,localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:u[r]||null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}for(const r of Object.keys(d))if(!s.has(r)){const i={content:d[r]?d[r].value.toString():null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.None},n=d[r]?d[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"local"}),fileContent:d[r]||null,localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"remote"}),remoteContent:u[r]||null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$0mb,authority:"accepted"})})}return[...s.values()]}async resolveContent(I){return this.h.isEqualOrParent(I,this.g.with({scheme:c.$0mb,authority:"remote"}))||this.h.isEqualOrParent(I,this.g.with({scheme:c.$0mb,authority:"local"}))||this.h.isEqualOrParent(I,this.g.with({scheme:c.$0mb,authority:"base"}))||this.h.isEqualOrParent(I,this.g.with({scheme:c.$0mb,authority:"accepted"}))?this.db(I):null}async hasLocalData(){try{const I=await this.Hb();if(Object.keys(I).length)return!0}catch{}return!1}async Cb(I){const d={};for(const u of I)u.fileContent&&(d[this.h.basename(u.localResource)]=u.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(I,d){for(const{fileContent:u,acceptResult:t,localResource:s,remoteResource:r,localChange:i}of I)if(i!==c.Change.None){const n=r?this.h.basename(r):this.h.basename(s),o=this.h.joinPath(this.vb,n);i===c.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):i===c.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,P.$Ne.fromString(t.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,P.$Ne.fromString(t.content),d?void 0:u),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(I,d,u){const t=d.syncData?this.Fb(d.syncData):{},s=(0,N.$bo)(t);for(const{acceptResult:r,localResource:i,remoteResource:n,remoteChange:o}of I)if(o!==c.Change.None){const l=i?this.h.basename(i):this.h.basename(n);o===c.Change.Deleted?delete s[l]:s[l]=r.content}return(0,$.$6ac)(t,s)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(s),u?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(I){return g(I)}Gb(I){const d={};for(const u of Object.keys(I))d[u]=I[u].value.toString();return d}async Hb(){const I={};let d;try{d=await this.G.resolve(this.vb)}catch(u){if(u instanceof k.$tl&&u.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND)return I;throw u}for(const u of d.children||[]){const t=u.resource,s=this.h.extname(t);if(s===".json"||s===".code-snippets"){const r=this.h.relativePath(this.vb,t),i=await this.G.readFile(t);I[r]=i}}return I}};e.$8ac=b,e.$8ac=b=ve([Z(2,C.$Li),Z(3,k.$$k),Z(4,A.$bq),Z(5,c.$Smb),Z(6,c.$Tmb),Z(7,c.$8mb),Z(8,L.$$i),Z(9,c.$3mb),Z(10,w.$0l),Z(11,S.$Il)],b);let f=class extends h.$5Mb{constructor(I,d,u,t,s,r){super(c.SyncResource.Snippets,d,u,t,I,s,r)}async o(I){const d=I.syncData?JSON.parse(I.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(d)){const s=d[t];if(s){const r=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(r,P.$Ne.fromString(s)),this.j.info("Created snippet",this.d.basename(r))}}await this.n(I)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===k.FileOperationResult.FILE_NOT_FOUND}}};e.$9ac=f,e.$9ac=f=ve([Z(0,k.$$k),Z(1,m.$Kl),Z(2,C.$Li),Z(3,c.$8mb),Z(4,A.$bq),Z(5,S.$Il)],f)}),define(le[125],he([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.$$ac=void 0,e.$0ac=h;function h(b,f){try{return JSON.parse(b).tasks??null}catch(p){return f.error(p),null}}let $=class extends S.$3Mb{constructor(f,p,I,d,u,t,s,r,i,n,o,l){super(f.tasksResource,{syncResource:m.SyncResource.Tasks,profile:f},p,r,i,n,I,d,s,o,u,t,l),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:m.$0mb,authority:"base"}),this.Cb=this.Ab.with({scheme:m.$0mb,authority:"local"}),this.Db=this.Ab.with({scheme:m.$0mb,authority:"remote"}),this.Eb=this.Ab.with({scheme:m.$0mb,authority:"accepted"})}async qb(f,p,I,d){const u=f.syncData?h(f.syncData.content,this.O):null;p=p===null&&I?f:p;const t=p?.syncData?h(p.syncData.content,this.O):null,s=await this.vb();let r=null,i=!1,n=!1,o=!1;if(f.syncData){const R=s?s.value.toString():null;if(!t||t!==R||t!==u){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const O=g(R,u,t);r=O.content,o=O.hasConflicts,i=O.hasLocalChanged,n=O.hasRemoteChanged}}else s&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),r=s.value.toString(),n=!0);const l={content:o?t:r,localChange:i?s?m.Change.Modified:m.Change.Added:m.Change.None,remoteChange:n?m.Change.Modified:m.Change.None,hasConflicts:o},y=s?s.value.toString():null;return[{fileContent:s,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:y,localChange:l.localChange,remoteResource:this.Db,remoteContent:u,remoteChange:l.remoteChange,previewResource:this.Ab,previewResult:l,acceptedResource:this.Eb}]}async ub(f){const p=f?.syncData?h(f.syncData.content,this.O):null;if(p===null)return!0;const I=await this.vb(),d=I?I.value.toString():null,u=g(d,p,p);return u.hasLocalChanged||u.hasRemoteChanged}async rb(f,p){return f.previewResult}async sb(f,p,I,d){if(this.h.isEqual(p,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:m.Change.None,remoteChange:m.Change.Modified};if(this.h.isEqual(p,this.Db))return{content:f.remoteContent,localChange:m.Change.Modified,remoteChange:m.Change.None};if(this.h.isEqual(p,this.Ab))return I===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:I,localChange:m.Change.Modified,remoteChange:m.Change.Modified};throw new Error(`Invalid Resource: ${p.toString()}`)}async tb(f,p,I,d){const{fileContent:u}=I[0][0],{content:t,localChange:s,remoteChange:r}=I[0][1];if(s===m.Change.None&&r===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),s!==m.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),u&&await this.nb(JSON.stringify(this.Kb(u.value.toString()))),t?await this.wb(t,u,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),r!==m.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(t));f=await this.mb(i,d?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}p?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$$ac=$,e.$$ac=$=ve([Z(2,m.$Smb),Z(3,m.$Tmb),Z(4,m.$8mb),Z(5,a.$$i),Z(6,m.$3mb),Z(7,L.$$k),Z(8,N.$Li),Z(9,C.$bq),Z(10,k.$0l),Z(11,A.$Il)],$);let c=class extends S.$5Mb{constructor(f,p,I,d,u,t){super(m.SyncResource.Tasks,p,I,d,f,u,t),this.c=this.g.defaultProfile.tasksResource}async o(f){const p=f.syncData?h(f.syncData.content,this.j):null;if(!p){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,P.$Ne.fromString(p)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$_ac=c,e.$_ac=c=ve([Z(0,L.$$k),Z(1,w.$Kl),Z(2,N.$Li),Z(3,m.$8mb),Z(4,C.$bq),Z(5,A.$Il)],c);function g(b,f,p){if(b===null&&f===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(b===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=p!==b,d=p!==f;return!I&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!d?{content:b,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!I?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:b,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[126],he([0,1,45,22,16,7,17,18,29,20,40,245,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0,e.$Tcc=c,e.$Ucc=g;let $=class extends S.$2Mb{constructor(f,p,I,d,u,t,s,r,i,n,o,l,y){super({syncResource:h.SyncResource.Profiles,profile:f},p,d,u,t,s,r,o,l,i,n,y),this.vb=I,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:h.$0mb,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.$0mb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.$0mb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.$0mb,authority:"accepted"}),this.B(I.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?g(f.syncData):null}async getRemoteSyncedProfiles(f){const p=await this.getLastSyncUserData(),I=await this.X(f,p);return I?.syncData?g(I.syncData):null}async qb(f,p,I){if(!this.vb.isEnabled())throw new h.$Xmb("Cannot sync profiles because they are disabled",h.UserDataSyncErrorCode.LocalError);const d=f.syncData?g(f.syncData):null,u=p?.syncData?g(p.syncData):null,t=this.Db(),{local:s,remote:r}=(0,m.$Rcc)(t,d,u,[]),i={local:s,remote:r,content:u?this.Eb(u):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:r!==null?h.Change.Modified:h.Change.None},n=c(t,!1);return[{baseResource:this.baseResource,baseContent:u?this.Eb(u):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const p=f?.syncData?g(f.syncData):null,I=this.Db(),{remote:d}=(0,m.$Rcc)(I,p,p,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(f,p){return{...f.previewResult,hasConflicts:!1}}async sb(f,p,I,d){if(this.h.isEqual(p,this.localResource))return this.Ab(f);if(this.h.isEqual(p,this.remoteResource))return this.Bb(f);if(this.h.isEqual(p,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async Ab(f){const p=this.Db(),I=(0,m.$Rcc)(p,null,null,[]),{local:d,remote:u}=I;return{content:f.localContent,local:d,remote:u,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:u!==null?h.Change.Modified:h.Change.None}}async Bb(f){const p=f.remoteContent?JSON.parse(f.remoteContent):null,I=[],d=[];for(const u of this.Db()){const t=p?.find(s=>s.id===u.id);t&&(I.push({id:u.id,name:u.name,collection:t.collection}),d.push(u))}if(p!==null){const u=(0,m.$Rcc)(d,p,I,[]),{local:t,remote:s}=u;return{content:f.remoteContent,local:t,remote:s,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:s!==null?h.Change.Modified:h.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:h.Change.None,remoteChange:h.Change.None}}async tb(f,p,I,d){const{local:u,remote:t,localChange:s,remoteChange:r}=I[0][1];s===h.Change.None&&r===h.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=I[0][0].remoteProfiles||[];if(i.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new h.$Xmb("Too many profiles to sync. Please remove some profiles and try again.",h.UserDataSyncErrorCode.LocalTooManyProfiles);if(s!==h.Change.None&&(await this.nb(c(this.Db(),!1)),await Promise.all(u.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(u.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(u.updated.map(async n=>{const o=this.vb.profiles.find(l=>l.id===n.id);o?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),r!==h.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],o=i.length+(t?.added.length??0)<=20;if(o)for(const l of t?.added||[]){const y=await this.J.createCollection(this.F);n.push(y),i.push({id:l.id,name:l.name,collection:y,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const l of t?.removed||[])i.splice(i.findIndex(({id:y})=>l.id===y),1);for(const l of t?.updated||[]){const y=i.find(({id:R})=>l.id===R);y&&i.splice(i.indexOf(y),1,{...y,id:l.id,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,d?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(l=>l.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(l=>l.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(l=>l.name))}.`:""}`)}catch(l){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of n)await this.J.deleteCollection(y,this.F)}throw l}for(const l of t?.removed||[])await this.J.deleteCollection(l.collection,this.F)}p?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,p){return this.mb(this.Eb(f),p)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const p=await this.db(f);return p&&(0,P.$6n)(JSON.parse(p),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((p,I)=>p.name.localeCompare(I.name)))}};e.$Scc=$,e.$Scc=$=ve([Z(2,w.$Kl),Z(3,L.$$k),Z(4,N.$Li),Z(5,C.$bq),Z(6,h.$Smb),Z(7,h.$Tmb),Z(8,h.$8mb),Z(9,a.$$i),Z(10,h.$3mb),Z(11,k.$0l),Z(12,A.$Il)],$);function c(b,f){const p=[...b].sort((I,d)=>I.name.localeCompare(d.name)).map(I=>({id:I.id,name:I.name}));return f?(0,P.$6n)(p,{}):JSON.stringify(p)}function g(b){return JSON.parse(b.content)}}),define(le[264],he([0,1,3,2,5,16,17,18,25]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;const w="sync.enable";let S=class extends a.$Vc{constructor(h,$,c,g){super(),this.c=h,this.f=$,this.g=c,this.h=g,this.a=new P.$le,this.onDidChangeEnablement=this.a.event,this.b=new P.$le,this.onDidChangeResourceEnablement=this.b.event,this.B(h.onDidChangeValue(C.StorageScope.APPLICATION,void 0,this.B(new a.$Uc))(b=>this.m(b)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(w,C.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||(this.f.publicLog2(w,{enabled:h}),this.c.store(w,h,C.StorageScope.APPLICATION,C.StorageTarget.MACHINE))}isResourceEnabled(h){return this.c.getBoolean((0,A.$2mb)(h),C.StorageScope.APPLICATION,!0)}setResourceEnablement(h,$){if(this.isResourceEnabled(h)!==$){const c=(0,A.$2mb)(h);this.j(c,$)}}getResourceSyncStateVersion(h){}j(h,$){this.c.store(h,$,C.StorageScope.APPLICATION,N.$o?C.StorageTarget.USER:C.StorageTarget.MACHINE)}m(h){if(w===h.key){this.a.fire(this.isEnabled());return}const $=A.$Omb.filter(c=>(0,A.$2mb)(c)===h.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$Fcc=S,e.$Fcc=S=ve([Z(0,C.$bq),Z(1,k.$0l),Z(2,L.$Li),Z(3,A.$Rmb)],S)}),define(le[265],he([0,1,6,15,67,2,21,22,16,7,20,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let h=class extends L.$Vc{constructor(c,g,b,f,p){super(),this.a=c,this.b=g,this.c=b,this.f=f,this.g=p,this.h()}async h(){for(const g of this.g.profiles)for(const b of m.$Omb)try{await this.m(this.j(b,g.isDefault?void 0:g.id))}catch(f){this.f.error(f)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(g){(0,w.$pl)(g)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g);return}if(c.children){for(const g of c.children)if(g.isDirectory&&!this.g.profiles.some(b=>b.id===g.name))try{this.f.info("Deleting non existing profile from backup",g.resource.path),await this.b.del(g.resource,{recursive:!0})}catch(b){this.f.error(b)}}}async getAllResourceRefs(c,g,b){const f=this.j(c,g,b);try{const p=await this.b.resolve(f);if(p.children)return p.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(p){if((0,w.$pl)(p)!==w.FileOperationResult.FILE_NOT_FOUND)throw p}return[]}async resolveResourceContent(c,g,b,f){const p=this.j(c,b,f),I=(0,C.$fh)(p,g);try{return(await this.b.readFile(I)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(c,g,b,f,p){const I=this.j(c,f,p),d=(0,C.$fh)(I,`${(0,N.$2m)(b).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,a.$Ne.fromString(g))}catch(u){this.f.error(u)}}j(c,g,b=this.a.userDataSyncHome){return(0,C.$fh)(b,...g?[g,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const g=await this.b.resolve(c);if(g.children){const b=g.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let p=b.filter(d=>Date.now()-this.n(d)>f);const I=b.length-p.length;I<10&&(p=p.slice(10-I)),await P.Promises.settled(p.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(g){this.f.error(g)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$Qcc=h,e.$Qcc=h=ve([Z(0,A.$Li),Z(1,w.$$k),Z(2,k.$$i),Z(3,m.$8mb),Z(4,S.$Kl)],h)}),define(le[87],he([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmb=e.$Fmb=void 0,e.$Gmb=u,e.$Fmb=(0,w.$Ei)("IUserDataSyncMachinesService");const g="sync.currentMachineName",b="Safari",f="Chrome",p="Edge",I="Firefox",d="Android";function u(r){switch(r){case b:case f:case p:case I:case d:case(0,N.$h)(N.Platform.Web):return!0}return!1}function t(){return N.$G?b:N.$E?f:N.$H?p:N.$F?I:N.$I?d:(0,N.$h)(N.$o?N.Platform.Web:N.$u)}let s=class extends a.$Vc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(i,n,o,l,y,R){super(),this.h=o,this.j=l,this.m=y,this.n=R,this.c=this.B(new P.$le),this.onDidChange=this.c.event,this.g=null,this.f=(0,m.$hq)(i,n,o)}async getMachines(i){const n=await this.f;return(await this.s(i)).machines.map(l=>({...l,isCurrent:l.id===n}))}async addCurrentMachine(i){const n=await this.f,o=await this.s(i);o.machines.some(({id:l})=>l===n)||(o.machines.push({id:n,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(i){const n=await this.f,o=await this.s(i),l=o.machines.filter(({id:y})=>y!==n);l.length!==o.machines.length&&(o.machines=l,await this.t(o))}async renameMachine(i,n,o){const l=await this.s(o),y=l.machines.find(({id:R})=>R===i);if(y){y.name=n,await this.t(l);const R=await this.f;i===R&&this.h.store(g,n,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.s();for(const[o,l]of i){const y=n.machines.find(R=>R.id===o);y&&(y.disabled=l?void 0:!0)}await this.t(n)}r(i){const n=this.h.get(g,h.StorageScope.APPLICATION);if(n)return n;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,l=new RegExp(`${(0,L.$hf)(o)}\\s#(\\d+)`);let y=0;for(const R of i){const O=l.exec(R.name),E=O?parseInt(O[1]):0;y=E>y?E:y}return`${o} #${y+1}`}async s(i){this.g=await this.u(i);const n=this.w(this.g);if(n.version!==c.a)throw new Error((0,C.localize)(0,null,this.n.nameLong));return n}async t(i){const n=JSON.stringify(i),o=await this.j.writeResource(c.b,n,this.g?.ref||null);this.g={ref:o,content:n},this.c.fire()}async u(i){if(this.g){const n=i&&i.latest?i.latest[c.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.m.error(n)}return{version:c.a,machines:[]}}};e.$Hmb=s,e.$Hmb=s=c=ve([Z(0,k.$Li),Z(1,A.$$k),Z(2,h.$bq),Z(3,$.$Smb),Z(4,$.$8mb),Z(5,S.$rk)],s)}),define(le[266],he([0,1,6,67,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;const p="sync.disableMachineEventually",I="sync.sessionId",d="sync.storeUrl",u="sync.productQuality";let t=class extends k.$Vc{get n(){const i=this.H.get(d,$.StorageScope.APPLICATION);return i?S.URI.parse(i):void 0}set n(i){i?this.H.store(d,i.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(d,$.StorageScope.APPLICATION)}get s(){return this.H.get(u,$.StorageScope.APPLICATION)}set s(i){i?this.H.store(u,i,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(u,$.StorageScope.APPLICATION)}constructor(i,n,o,l,y,R,O,E,v,T){super(),this.u=n,this.w=o,this.y=l,this.z=y,this.C=R,this.D=O,this.F=E,this.G=v,this.H=T,this.a=this.B(new k.$Wc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new C.$le),this.onError=this.h.event,this.S=[],this.f=this.B(new P.$Ch(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,w.$$g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(O.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(C.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:n}=this.L();i?this.a.value===void 0&&(this.a.value=new s(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$2m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,n,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(I,$.StorageScope.APPLICATION),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(l){if(this.C.error(l),n)this.M(!1);else throw l}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const n=g.$Xmb.toUserDataSyncError(i);n instanceof g.$Zmb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===g.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===g.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===g.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===g.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===g.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===g.UserDataSyncErrorCode.UpgradeRequired||n.code===g.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===g.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===g.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===g.UserDataSyncErrorCode.ServiceChanged||n.code===g.UserDataSyncErrorCode.DefaultServiceChanged?A.$o&&n.code===g.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(p,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,P.$Fh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(p,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(p,$.StorageScope.APPLICATION)}async triggerSync(i,n,o){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const l=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:l}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$Wcc=t,e.$Wcc=t=ve([Z(0,h.$rk),Z(1,g.$Rmb),Z(2,g.$Smb),Z(3,g.$3mb),Z(4,g.$4mb),Z(5,g.$8mb),Z(6,b.$jLb),Z(7,c.$0l),Z(8,f.$Fmb),Z(9,$.$bq)],t);class s extends k.$Vc{static{this.a="Interval"}constructor(i,n,o,l,y,R,O,E,v){super(),this.m=i,this.n=n,this.r=o,this.s=l,this.u=y,this.w=R,this.y=O,this.z=E,this.C=v,this.b=this.B(new k.$Wc),this.c=this.B(new C.$le),this.onDidStartSync=this.c.event,this.f=this.B(new C.$le),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,k.$Tc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(s.a,!1)}D(){this.b.value=(0,P.$Gh)(()=>{this.sync(s.a,!1),this.b.value=void 0},this.n)}sync(i,n){const o=(0,P.$rh)(async l=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,L.$5)(y))return}return this.H(i,n,l)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,w.$$g)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!i&&(!(0,w.$$g)(n.defaultUrl,i.defaultUrl)||!(0,w.$$g)(n.insidersUrl,i.insidersUrl)||!(0,w.$$g)(n.stableUrl,i.stableUrl))}async H(i,n,o){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let l;try{await this.I(n,o)}catch(y){if(this.y.error(y),l=y,g.$Xmb.toUserDataSyncError(y).code===g.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,o),l=void 0}catch(R){this.y.error(R),l=R}}this.f.fire(l)}async I(i,n){if(this.h=await this.u.createSyncTask(this.g,i),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new g.$Zmb((0,m.localize)(0,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$Zmb((0,m.localize)(1,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$Zmb((0,m.localize)(2,null),g.UserDataSyncErrorCode.TurnedOff);const o=this.C.get(I,$.StorageScope.APPLICATION);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new g.$Zmb((0,m.localize)(3,null),g.UserDataSyncErrorCode.DefaultServiceChanged):new g.$Zmb((0,m.localize)(4,null),g.UserDataSyncErrorCode.ServiceChanged):new g.$Zmb((0,m.localize)(5,null),g.UserDataSyncErrorCode.SessionExpired);const l=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const y=l.find(O=>O.isCurrent);if(y?.disabled)throw new g.$Zmb((0,m.localize)(6,null),g.UserDataSyncErrorCode.TurnedOff);const R=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-R}),this.g===null)try{this.g=await this.s.manifest(null)}catch(O){throw new g.$Zmb((0,N.$pj)(O),O instanceof g.$Xmb?O.code:g.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==o&&this.C.store(I,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[267],he([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;let r=class{static{s=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,o,l,y,R,O,E,v,T,U){this.e=n,this.f=o,this.g=l,this.h=R,this.i=O,this.j=E,this.k=v,this.l=T,this.n=U,this.d=y.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(w.SyncResource.Profiles,null,void 0);if(n.content){const o=this.L(n.content,w.SyncResource.Profiles);return(0,d.$Ucc)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.f.getAllResourceRefs(w.SyncResource.Profiles,void 0,n);if(o.length){const l=await this.f.resolveResourceContent(w.SyncResource.Profiles,o[0].ref,void 0,n);if(l){const y=this.L(l,w.SyncResource.Profiles);return(0,d.$Ucc)(y)}}return[]}async getLocalSyncedMachines(n){const o=await this.f.getAllResourceRefs("machines",void 0,n);if(o.length){const l=await this.f.resolveResourceContent("machines",o[0].ref,void 0,n);if(l)return JSON.parse(l).machines.map(R=>({...R,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.e.getAllResourceRefs(n,o?.collection)).map(({created:y,ref:R})=>({created:y,uri:this.J({remote:!0,syncResource:n,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:R,node:void 0})}))}async getLocalSyncResourceHandles(n,o,l){return(await this.f.getAllResourceRefs(n,o?.collection,l)).map(({created:R,ref:O})=>({created:R,uri:this.J({remote:!1,syncResource:n,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:O,node:void 0,location:l})}))}resolveUserDataSyncResource({uri:n}){const o=this.K(n),l=o?this.k.profiles.find(y=>y.id===o.profile):void 0;return o&&l?{profile:l,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.K(n);if(!o)return[];const l=this.k.profiles.find(y=>y.id===o.profile);switch(o.syncResource){case w.SyncResource.Settings:return this.s(n,l);case w.SyncResource.Keybindings:return this.u(n,l);case w.SyncResource.Tasks:return this.w(n,l);case w.SyncResource.Snippets:return this.y(n,l);case w.SyncResource.GlobalState:return this.D(n,l);case w.SyncResource.Extensions:return this.A(n,l);case w.SyncResource.Profiles:return this.G(n,l);case w.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.K(n);if(o){if(o.remote){if(o.ref){const{content:l}=await this.M(o.syncResource,o.ref,o.collection);if(l)return this.L(l,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const l=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(l)return this.L(l,o.syncResource)?.machineId}return}return(0,C.$hq)(this.h,this.j,this.i)}}async resolveContent(n){const o=this.K(n);if(!o||o.node===s.a)return null;if(o.ref){const l=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&l?this.q(o.syncResource,l,o.node):l}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(n,o,l,y,R){if(n){const{content:O}=await this.M(o,y,l);return O}return this.f.resolveResourceContent(o,y,l,R)}q(n,o,l){const y=this.L(o,n);switch(n){case w.SyncResource.Settings:return this.t(y,l);case w.SyncResource.Keybindings:return this.v(y,l);case w.SyncResource.Tasks:return this.x(y,l);case w.SyncResource.Snippets:return this.z(y,l);case w.SyncResource.GlobalState:return this.E(y,l);case w.SyncResource.Extensions:return this.B(y,l);case w.SyncResource.Profiles:return this.H(y,l);case w.SyncResource.WorkspaceState:return null}}async r(n,o){const l=this.k.profiles.find(y=>y.id===o);if(!l)return null;switch(n){case w.SyncResource.GlobalState:return this.F(l);case w.SyncResource.Extensions:return this.C(l);case w.SyncResource.Profiles:return this.I(l);case w.SyncResource.Settings:return null;case w.SyncResource.Keybindings:return null;case w.SyncResource.Tasks:return null;case w.SyncResource.Snippets:return null;case w.SyncResource.WorkspaceState:return null}}s(n,o){const l=this.d.joinPath(n,"settings.json"),y=o?o.settingsResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}t(n,o){switch(o){case"settings.json":return(0,$.$2ac)(n.content).settings}return null}u(n,o){const l=this.d.joinPath(n,"keybindings.json"),y=o?o.keybindingsResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}v(n,o){switch(o){case"keybindings.json":return(0,c.$Yac)(n.content,!!this.l.getValue(w.$Lmb),this.g)}return null}w(n,o){const l=this.d.joinPath(n,"tasks.json"),y=o?o.tasksResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}x(n,o){switch(o){case"tasks.json":return(0,b.$0ac)(n.content,this.g)}return null}async y(n,o){const l=await this.resolveContent(n);if(l){const y=this.L(l,w.SyncResource.Snippets);if(y){const R=(0,h.$7ac)(y),O=[];for(const E of Object.keys(R)){const v=this.d.joinPath(n,E),T=o?this.d.joinPath(o.snippetsHome,E):this.d.joinPath(n,s.a);O.push({resource:v,comparableResource:T})}return O}}return[]}z(n,o){return(0,h.$7ac)(n)[o]||null}A(n,o){const l=this.d.joinPath(n,"extensions.json"),y=o?this.J({remote:!1,syncResource:w.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}B(n,o){switch(o){case"extensions.json":return(0,f.$Tac)((0,f.$Sac)(n),!0)}return null}async C(n){const{localExtensions:o}=await this.n.createInstance(f.$Vac).getLocalExtensions(n);return(0,f.$Tac)(o,!0)}D(n,o){const l=this.d.joinPath(n,"globalState.json"),y=o?this.J({remote:!1,syncResource:w.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}E(n,o){switch(o){case"globalState.json":return(0,p.$7Mb)(JSON.parse(n.content),!0)}return null}async F(n){const o=await this.n.createInstance(p.$9Mb).getLocalGlobalState(n);return(0,p.$7Mb)(o,!0)}G(n,o){const l=this.d.joinPath(n,"profiles.json"),y=this.J({remote:!1,syncResource:w.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:l,comparableResource:y}]}H(n,o){switch(o){case"profiles.json":return(0,u.$6n)(JSON.parse(n.content),{})}return null}async I(n){return(0,d.$Tcc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(n){const o=n.remote?s.b:s.c,l=[];return n.location&&(l.push(`scheme:${n.location.scheme}`),l.push(`authority:${n.location.authority}`),l.push((0,t.$lf)(n.location.path,"/"))),l.push(`syncResource:${n.syncResource}`),l.push(`profile:${n.profile}`),n.collection&&l.push(`collection:${n.collection}`),n.ref&&l.push(`ref:${n.ref}`),n.node&&l.push(n.node),this.d.joinPath(P.URI.from({scheme:w.$0mb,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...l)}K(n){if(n.scheme!==w.$0mb)return;const o=[];for(;n.path!=="/";)o.unshift(this.d.basename(n)),n=this.d.dirname(n);if(o.length<2)return;const l=n.authority===s.b;let y,R;const O=[];let E,v,T,U,F;for(;o.length;){const M=o.shift();M.startsWith("scheme:")?y=M.substring(7):M.startsWith("authority:")?R=M.substring(10):M.startsWith("syncResource:")?E=M.substring(13):M.startsWith("profile:")?v=M.substring(8):M.startsWith("collection:")?T=M.substring(11):M.startsWith("ref:")?U=M.substring(4):E?F=M:O.push(M)}return{remote:l,syncResource:E,profile:v,collection:T,ref:U,node:F,location:y&&R!==void 0?this.d.joinPath(P.URI.from({scheme:y,authority:R,query:n.query,fragment:n.fragment,path:"/"}),...O):void 0}}L(n,o){try{const l=JSON.parse(n);if((0,m.$ZMb)(l))return l}catch(l){this.g.error(l)}throw new w.$Xmb((0,a.localize)(0,null),w.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async M(n,o,l){const y=await this.e.resolveResourceContent(n,o,l);return{ref:o,content:y}}};e.$zdc=r,e.$zdc=r=s=ve([Z(0,w.$Smb),Z(1,w.$Tmb),Z(2,w.$8mb),Z(3,A.$Il),Z(4,N.$Li),Z(5,k.$bq),Z(6,L.$$k),Z(7,S.$Kl),Z(8,g.$$i),Z(9,I.$Di)],r)}),define(le[268],he([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;const n="sync.lastSyncTime";let o=class extends k.$Vc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(E,v,T,U,F,M,X,K,Q,G,ie){super(),this.C=E,this.D=v,this.F=T,this.G=U,this.H=F,this.I=M,this.J=X,this.L=K,this.M=Q,this.N=G,this.O=ie,this.f=i.SyncStatus.Uninitialized,this.g=this.B(new C.$le),this.onDidChangeStatus=this.g.event,this.h=this.B(new C.$le),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new C.$le),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new C.$le),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new C.$le),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new C.$le),this.onDidResetLocal=this.w.event,this.y=this.B(new C.$le),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,g.StorageScope.APPLICATION,void 0),this.B((0,k.$Tc)(()=>this.cb())),this.B(new a.$Qh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(E,v){this.db(),this.H.info("Sync started.");const T=new Date().getTime(),U=(0,S.$1g)();try{const K=(0,i.$Wmb)(U);v&&(K["Cache-Control"]="no-cache"),E=await this.D.manifest(E,K)}catch(K){const Q=i.$Xmb.toUserDataSyncError(K);throw R(Q,U,this.F,this.I),Q}const F=!1,M=this;let X;return{manifest:E,async run(){if(F)throw new Error("Can run a task only once");X=(0,a.$rh)(K=>M.P(E,!1,U,K)),await X.finally(()=>X=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),M.ab()},stop(){return X?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new i.$Xmb("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const E=new Date().getTime(),v=(0,S.$1g)(),T=(0,i.$Wmb)(v);let U;try{U=await this.D.manifest(null,T)}catch(X){const K=i.$Xmb.toUserDataSyncError(X);throw R(K,v,this.F,this.I),K}await this.resetLocal();const F=this,M=new N.$we;return{id:v,async merge(){return F.P(U,!0,v,M.token)},async apply(){try{try{await F.R(U,v,M.token)}catch(X){if(i.$Xmb.toUserDataSyncError(X).code===i.UserDataSyncErrorCode.MethodNotFound)F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,v,M.token);else throw X}}catch(X){throw F.H.error(X),X}F.H.info(`Sync done. Took ${new Date().getTime()-E}ms`),F.ab()},async stop(){M.cancel(),await F.U(),await F.resetLocal()}}}async P(E,v,T,U){this.n=[];try{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,E,v,T,U));const M=F.enabled.find(X=>X.resource===i.SyncResource.Profiles);if(M){const X=await M.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(X,E,v,T,U)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Idle),this.r.fire(this.n)}}async Q(E,v,T,U,F){for(const M of E){if(F.isCancellationRequested)return;const X=this.M.profiles.find(Q=>Q.id===M.id);if(!X){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const K=this.getOrCreateActiveProfileSynchronizer(X,M);this.n.push(...await this.S(K,v,T,U,F))}for(const[M,X]of this.z.entries())this.M.profiles.some(K=>K.id===X[0].profile.id)||(await X[0].resetLocal(),X[1].dispose(),this.z.delete(M))}async R(E,v,T){const U=this.bb();for(const Q of U){if(T.isCancellationRequested)return;await Q.apply(v,T)}const F=U.find(Q=>Q.profile.isDefault);if(!F)return;const M=F.enabled.find(Q=>Q.resource===i.SyncResource.Profiles);if(!M)return;const K=(await M.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(Q=>U.every(G=>G.profile.id!==Q.id));K.length&&await this.Q(K,E,!1,v,T)}async S(E,v,T,U,F){return(await E.sync(v,T,U,F)).map(([X,K])=>({profile:E.profile,syncResource:X,error:K}))}async U(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(E=>E.stop()))}async resolveContent(E){const v=await this.N.resolveContent(E);if(v)return v;for(const T of this.bb())for(const U of T.enabled){const F=await U.resolveContent(E);if(F)return F}return null}async replace(E){this.db();const v=this.N.resolveUserDataSyncResource(E);if(!v)return;const T=await this.resolveContent(E.uri);T&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(T),!0})}async accept(E,v,T,U){this.db(),await this.X(E.profile,async F=>{if(E.syncResource===F.resource)return await F.accept(v,T),U&&await F.apply((0,w.$kg)(U)?!1:U.force,(0,i.$Wmb)((0,S.$1g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==i.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(E){this.H.error(E)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,g.StorageScope.APPLICATION);for(const[E]of this.z.values())try{await E.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const E=this.J.keys(g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),v=[];for(const U of E){if(!U.endsWith(".lastSyncUserData"))continue;const F=U.split(".");F.length===3&&v.push([U,F[0]])}if(!v.length)return;const T=new k.$Uc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=T.add(this.G.createInstance(l,this.M.defaultProfile,void 0)));const F=U.enabled.find(K=>K.resource===i.SyncResource.Profiles);if(!F)return;const X=(await F.getLastSyncedProfiles())?.map(K=>K.collection)??[];for(const[K,Q]of v)X.includes(Q)||(this.H.info(`Removing last sync state for stale profile: ${Q}`),this.J.remove(K,g.StorageScope.APPLICATION))}finally{T.dispose()}}async cleanUpRemoteData(){const E=await this.N.getRemoteSyncedProfiles(),v=E.map(M=>M.collection),T=await this.D.getAllCollections(),U=T.filter(M=>!v.includes(M));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const F=E.filter(M=>T.includes(M.collection));if(F.length!==E.length){const M=this.G.createInstance(r.$Scc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(E){this.db();const v=await this.D.getActivityData();await this.C.writeFile(E,v)}async extractActivityData(E,v){const T=(await this.C.readFile(E)).value.toString(),U=JSON.parse(T);if(U.resources)for(const F in U.resources)for(const M of U.resources[F])await this.O.writeResource(F,M.content,new Date(M.created*1e3),void 0,v);if(U.collections)for(const F in U.collections)for(const M in U.collections[F].resources)for(const X of U.collections[F].resources?.[M]??[])await this.O.writeResource(M,X.content,new Date(X.created*1e3),F,v)}async X(E,v){const T=new k.$Uc;try{const U=this.z.get(E.id);if(U){const Q=await this.Y(U[0],v,T);return(0,w.$lg)(Q)?null:Q}if(E.isDefault){const Q=T.add(this.G.createInstance(l,E,void 0)),G=await this.Y(Q,v,T);return(0,w.$lg)(G)?null:G}if(this.M.isEnabled())return null;const F=T.add(this.G.createInstance(r.$Scc,E,void 0)),M=await this.D.manifest(null),K=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(Q=>Q.id===E.id);if(K){const Q=T.add(this.G.createInstance(l,E,K.collection)),G=await this.Y(Q,v,T);return(0,w.$lg)(G)?null:G}return null}finally{T.dispose()}}async Y(E,v,T){const U=[...E.enabled,...E.disabled.reduce((F,M)=>(M!==i.SyncResource.WorkspaceState&&F.push(T.add(E.createSynchronizer(M))),F),[])];for(const F of U){const M=await v(F);if(!(0,w.$lg)(M))return M}}Z(E){const v=this.f;this.f!==E&&(this.f=E,this.g.fire(E),v===i.SyncStatus.HasConflicts&&this.ab())}$(){const E=this.bb().map(v=>v.conflicts).flat();(0,P.$vb)(this.j,E,(v,T)=>v.profile.id===T.profile.id&&v.syncResource===T.syncResource&&(0,P.$vb)(v.conflicts,T.conflicts,(U,F)=>(0,A.$$g)(U.previewResource,F.previewResource)))||(this.j=E,this.m.fire(E))}ab(){this.status===i.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(E,v){let T=this.z.get(E.id);if(T&&T[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(E.id)),!T){const U=new k.$Uc,F=U.add(this.G.createInstance(l,E,v?.collection));U.add(F.onDidChangeStatus(M=>this.Z(M))),U.add(F.onDidChangeConflicts(M=>this.$())),U.add(F.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(E.id,T=[F,U])}return T[0]}bb(){const E=[];for(const[v]of this.z.values())E.push(v);return E}cb(){this.z.forEach(([,E])=>E.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Vcc=o,e.$Vcc=o=ve([Z(0,$.$$k),Z(1,i.$Smb),Z(2,i.$Rmb),Z(3,c.$Di),Z(4,i.$8mb),Z(5,b.$0l),Z(6,g.$bq),Z(7,i.$3mb),Z(8,f.$Kl),Z(9,i.$5mb),Z(10,i.$Tmb)],o);let l=class extends k.$Vc{get enabled(){return this.f.sort((E,v)=>E[1]-v[1]).map(([E])=>E)}get disabled(){return i.$Omb.filter(E=>!this.r.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.m}constructor(E,v,T,U,F,M,X,K,Q,G){super(),this.profile=E,this.collection=v,this.r=T,this.t=U,this.u=F,this.w=M,this.y=X,this.z=K,this.C=Q,this.D=G,this.f=[],this.g=i.SyncStatus.Idle,this.h=this.B(new C.$le),this.onDidChangeStatus=this.h.event,this.j=this.B(new C.$le),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new C.$le),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,k.$Tc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.$Omb)T.isResourceEnabled(ie)&&this.G(ie)}F(E,v){v?this.G(E):this.H(E)}G(E){if(this.f.some(([F])=>F.resource===E))return;if(E===i.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(E===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||E===i.SyncResource.WorkspaceState)return;if(E!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[E]){this.z.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const v=new k.$Uc,T=v.add(this.createSynchronizer(E));v.add(T.onDidChangeStatus(()=>this.L())),v.add(T.onDidChangeConflicts(()=>this.M())),v.add(T.onDidChangeLocal(()=>this.j.fire(E)));const U=this.N(E);this.f.push([T,U,v])}H(E){const v=this.f.findIndex(([T])=>T.resource===E);if(v!==-1){const[[T,,U]]=this.f.splice(v,1);U.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(E){switch(E){case i.SyncResource.Settings:return this.t.createInstance(u.$3ac,this.profile,this.collection);case i.SyncResource.Keybindings:return this.t.createInstance(d.$Zac,this.profile,this.collection);case i.SyncResource.Snippets:return this.t.createInstance(t.$8ac,this.profile,this.collection);case i.SyncResource.Tasks:return this.t.createInstance(s.$$ac,this.profile,this.collection);case i.SyncResource.GlobalState:return this.t.createInstance(I.$8Mb,this.profile,this.collection);case i.SyncResource.Extensions:return this.t.createInstance(p.$Uac,this.profile,this.collection);case i.SyncResource.Profiles:return this.t.createInstance(r.$Scc,this.profile,this.collection)}}async sync(E,v,T,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],X=(0,i.$Wmb)(T),K=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,Q=v?await this.I(K):{};for(const G of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(v){const ie=await G.preview(K,Q,X);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==i.Change.None||V.remoteChange!==i.Change.None)&&V.mergeState===i.MergeState.Preview&&await G.merge(V.previewResource)}else await G.sync(K,X)}catch(ie){const V=i.$Xmb.toUserDataSyncError(ie);if(R(V,T,this.w,this.y),y(ie))throw V;this.z.error(ie),this.z.error(`${G.resource}: ${(0,L.$pj)(ie)}`),M.push([G.resource,V])}}return M}finally{this.L()}}async apply(E,v){const T=(0,i.$Wmb)(E);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,T)}catch(F){const M=i.$Xmb.toUserDataSyncError(F);if(R(M,E,this.w,this.y),y(F))throw M;this.z.error(F),this.z.error(`${U.resource}: ${(0,L.$pj)(F)}`)}}}async stop(){for(const E of this.enabled)try{E.status!==i.SyncStatus.Idle&&await E.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(v){this.z.error(`${E.resource}: ${(0,L.$pj)(v)}`),this.z.error(v)}}async I(E){if(!this.profile.isDefault)return{};const v=this.D.getValue(i.$Kmb),T=this.enabled.find(U=>U instanceof u.$3ac);if(T){const U=await T.getRemoteUserDataSyncConfiguration(E);return{...v,...U}}return v}J(E){this.g!==E&&(this.g=E,this.h.fire(E))}L(){return this.M(),this.enabled.some(E=>E.status===i.SyncStatus.HasConflicts)?this.J(i.SyncStatus.HasConflicts):this.enabled.some(E=>E.status===i.SyncStatus.Syncing)?this.J(i.SyncStatus.Syncing):this.J(i.SyncStatus.Idle)}M(){const E=this.enabled.filter(v=>v.status===i.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,P.$vb)(this.m,E,(v,T)=>v.syncResource===T.syncResource&&(0,P.$vb)(v.conflicts,T.conflicts,(U,F)=>(0,A.$$g)(U.previewResource,F.previewResource)))||(this.m=E,this.n.fire(E))}N(E){switch(E){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};l=ve([Z(2,i.$3mb),Z(3,c.$Di),Z(4,h.$gp),Z(5,i.$Rmb),Z(6,b.$0l),Z(7,i.$8mb),Z(8,f.$Kl),Z(9,m.$$i)],l);function y(O){if(O instanceof i.$Xmb)switch(O.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function R(O,E,v,T){T.publicLog2("sync/error",{code:O.code,serverCode:O instanceof i.$Ymb?String(O.serverCode):void 0,url:O instanceof i.$Ymb?O.url:void 0,resource:O.resource,executionId:E,service:v.userDataSyncStore.url.toString()})}}),define(le[269],he([0,1,3,2,9,20,25]),function(ne,e,P,a,N,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=void 0;function k(h,$){return{...h,profile:(0,L.$Ll)(h.profile,$.profilesHome.scheme)}}function A(h){return{created:h.created,uri:N.URI.revive(h.uri)}}class w{constructor($,c,g){this.c=$,this.d=c,this.f=g,this.a=new Map,this.b=new P.$le}listen($,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call($,c,g){try{return await this.g($,c,g)}catch(b){throw this.f.error(b),b}}async g($,c,g){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(g[0]));case"accept":return this.c.accept(k(g[0],this.d),N.URI.revive(g[1]),g[2],g[3]);case"replace":return this.c.replace(A(g[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(g[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(g[0]),N.URI.revive(g[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const b=c.substring(11),f=g[0],p=this.h(f);switch(g=g.slice(1),b){case"merge":return p.merge();case"apply":return p.apply().then(()=>this.a.delete(this.j(p.id)));case"stop":return p.stop().finally(()=>this.a.delete(this.j(p.id)))}}throw new Error("Invalid call")}h($){const c=this.a.get(this.j($));if(!c)throw new Error(`Manual sync taks not found: ${$}`);return c}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$egc=w;let S=class extends a.$Vc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,c){super(),this.n=c,this.b=C.SyncStatus.Uninitialized,this.c=this.B(new P.$le),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new P.$le),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new P.$le),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new P.$le),this.onSyncErrors=this.m.event,this.a={call(g,b,f){return $.call(g,b,f).then(null,p=>{throw C.$Xmb.toUserDataSyncError(p)})},listen(g,b){return $.listen(g,b)}},this.a.call("_getInitialData").then(([g,b,f])=>{this.s(g),this.t(b),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(p=>this.s(p))),this.B(this.a.listen("onDidChangeLastSyncTime")(p=>this.u(p)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.t(g))),this.B(this.a.listen("onSyncErrors")(g=>this.m.fire(g.map(b=>({...b,error:C.$Xmb.toUserDataSyncError(b.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),c=this;return new m($,{async call(b,f,p){return c.a.call(`manualSync/${b}`,[$,...Array.isArray(f)?f:[f]],p)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,c,g,b){return this.a.call("accept",[$,c,g,b])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,c){return this.a.call("extractActivityData",[$,c])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(c=>({syncResource:c.syncResource,profile:(0,L.$Ll)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(g=>({...g,baseResource:N.URI.revive(g.baseResource),localResource:N.URI.revive(g.localResource),remoteResource:N.URI.revive(g.remoteResource),previewResource:N.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$fgc=S,e.$fgc=S=ve([Z(1,L.$Kl)],S);class m extends a.$Vc{constructor($,c){super(),this.id=$,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[127],he([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,61,50,17,25]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XMb=e.$WMb=e.$VMb=e.$UMb=e.$TMb=void 0;const u="configurationSync.store",t="sync.previous.store",s="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let l=class extends C.$Vc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$1mb,I.StorageScope.APPLICATION)}set c(T){this.h.store(d.$1mb,T,I.StorageScope.APPLICATION,A.$o?I.StorageTarget.USER:I.StorageTarget.MACHINE)}constructor(T,U,F){super(),this.f=T,this.g=U,this.h=F,this.a=this.B(new L.$le),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new C.$Uc);this.B(L.Event.filter(F.onDidChangeValue(I.StorageScope.APPLICATION,d.$1mb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[u]),this.a.fire()}m(T){if(T&&(T=A.$o&&T.web?{...T,...T.web}:T,(0,S.$eg)(T.url)&&(0,S.$gg)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(U=>Array.isArray(T.authenticationProviders[U].scopes)))){const U=T,F=!!U.canSwitch,M=U.url===U.insidersUrl?"insiders":"stable",X=(F?this.c:void 0)||M,K=X==="insiders"?U.insidersUrl:X==="stable"?U.stableUrl:U.url;return{url:m.URI.parse(K),type:X,defaultType:M,defaultUrl:m.URI.parse(U.url),stableUrl:m.URI.parse(U.stableUrl),insidersUrl:m.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((Q,G)=>(Q.push({id:G,scopes:U.authenticationProviders[G].scopes}),Q),[])}}}};e.$TMb=l,e.$TMb=l=ve([Z(0,b.$rk),Z(1,$.$$i),Z(2,I.$bq)],l);let y=class extends l{constructor(T,U,F){super(T,U,F);const M=this.h.get(t,I.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const X=this.f[u];X?this.h.store(t,JSON.stringify(X),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE):this.h.remove(t,I.StorageScope.APPLICATION)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$UMb=y,e.$UMb=y=ve([Z(0,b.$rk),Z(1,$.$$i),Z(2,I.$bq)],y);let R=class extends C.$Vc{get donotMakeRequestsUntil(){return this.j}constructor(T,U,F,M,X,K,Q){super(),this.n=F,this.r=M,this.s=Q,this.g=this.B(new L.$le),this.onTokenFailed=this.g.event,this.h=this.B(new L.$le),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$le),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,p.$hq)(X,K,Q).then(G=>{const ie={"X-Client-Name":`${U.applicationName}${A.$o?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.f=new E(n,o,this.n,this.r),this.u(),this.B((0,C.$Tc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,U){this.b={token:T,type:U}}t(T){this.a=T?(0,w.$fh)(T,"v1"):void 0}u(){const T=this.s.getNumber(s,I.StorageScope.APPLICATION);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(s,this.j.getTime(),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),this.w=(0,P.$rh)(U=>(0,P.$Fh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(s,I.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,w.$fh)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:T},[],a.CancellationToken.None);return(await(0,f.$7p)(F))?.map(({id:M})=>M)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,w.$fh)(this.a,"collection").toString();T={...T},T["Content-Type"]=k.$4s.text;const F=await this.D(U,{type:"POST",headers:T},[],a.CancellationToken.None),M=await(0,f.$6p)(F);if(!M)throw new d.$Ymb("Server did not return the collection id",U,d.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[d.$Umb]);return M}async deleteCollection(T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=T?(0,w.$fh)(this.a,"collection",T).toString():(0,w.$fh)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(T,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,T),M={},X=await this.D(F.toString(),{type:"GET",headers:M},[],a.CancellationToken.None);return(await(0,f.$7p)(X)||[]).map(({url:Q,created:G})=>({ref:(0,w.$hh)(F,F.with({path:Q})),created:G*1e3}))}async resolveResourceContent(T,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,w.$fh)(this.z(this.a,F,T),U).toString();M={...M},M["Cache-Control"]="no-cache";const K=await this.D(X,{type:"GET",headers:M},[],a.CancellationToken.None);return await(0,f.$6p)(K)}async deleteResource(T,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=U!==null?(0,w.$fh)(this.z(this.a,F,T),U).toString():this.z(this.a,F,T).toString(),X={};await this.D(M,{type:"DELETE",headers:X},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,w.$fh)(this.a,"resource").toString(),U={"Content-Type":k.$4s.text};await this.D(T,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(T,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,w.$fh)(this.z(this.a,F,T),"latest").toString();M={...M},M["Cache-Control"]="no-cache",U&&(M["If-None-Match"]=U.ref);const K=await this.D(X,{type:"GET",headers:M},[304],a.CancellationToken.None);let Q=null;if(K.res.statusCode===304&&(Q=U),Q===null){const G=K.res.headers.etag;if(!G)throw new d.$Ymb("Server did not return the ref",X,d.UserDataSyncErrorCode.NoRef,K.res.statusCode,K.res.headers[d.$Umb]);const ie=await(0,f.$6p)(K);if(!ie&&K.res.statusCode===304)throw new d.$Ymb("Empty response",X,d.UserDataSyncErrorCode.EmptyResponse,K.res.statusCode,K.res.headers[d.$Umb]);Q={ref:G,content:ie}}return Q}async writeResource(T,U,F,M,X={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,M,T).toString();X={...X},X["Content-Type"]=k.$4s.text,F&&(X["If-Match"]=F);const Q=await this.D(K,{type:"POST",data:U,headers:X},[],a.CancellationToken.None),G=Q.res.headers.etag;if(!G)throw new d.$Ymb("Server did not return the ref",K,d.UserDataSyncErrorCode.NoRef,Q.res.statusCode,Q.res.headers[d.$Umb]);return G}async manifest(T,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,w.$fh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",T&&(U["If-None-Match"]=T.ref);const M=await this.D(F,{type:"GET",headers:U},[304],a.CancellationToken.None);let X=null;if(M.res.statusCode===304&&(X=T),!X){const Q=M.res.headers.etag;if(!Q)throw new d.$Ymb("Server did not return the ref",F,d.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[d.$Umb]);const G=await(0,f.$6p)(M);if(!G&&M.res.statusCode===304)throw new d.$Ymb("Empty response",F,d.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[d.$Umb]);G&&(X={...JSON.parse(G),ref:Q})}const K=this.s.get(r,I.StorageScope.APPLICATION);return K&&X&&K!==X.session&&this.C(),X===null&&K&&this.C(),X&&this.s.store(r,X.session,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),X}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,w.$fh)(this.a,"download").toString(),U={},F=await this.D(T,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,f.$3p)(F))throw new d.$Ymb("Server returned "+F.res.statusCode,T,d.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[d.$Umb]);if((0,f.$4p)(F))throw new d.$Ymb("Empty response",T,d.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[d.$Umb]);return F.stream}z(T,U,F){return U?(0,w.$fh)(T,"collection",U,"resource",F):(0,w.$fh)(T,"resource",F)}C(){this.s.remove(r,I.StorageScope.APPLICATION),this.s.remove(i,I.StorageScope.APPLICATION)}async D(T,U,F,M){if(!this.b)throw new d.$Ymb("No Auth Token Available",T,d.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$Ymb(`${U.type} request '${T}' failed because of too many requests (429).`,T,d.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const X=await this.c;U.headers={...U.headers||{},...X,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:T,type:U.type,headers:{...U.headers,authorization:void 0}});let K;try{K=await this.f.request(T,U,M)}catch(z){if(!(z instanceof d.$Ymb)){let ee=d.UserDataSyncErrorCode.RequestFailed;const re=(0,N.$$)(z).toLowerCase();re.includes("xhr timeout")?ee=d.UserDataSyncErrorCode.RequestTimeout:re.includes("protocol")&&re.includes("not supported")?ee=d.UserDataSyncErrorCode.RequestProtocolNotSupported:re.includes("request path contains unescaped characters")?ee=d.UserDataSyncErrorCode.RequestPathNotEscaped:re.includes("headers must be an object")?ee=d.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$5)(z)&&(ee=d.UserDataSyncErrorCode.RequestCanceled),z=new d.$Ymb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),z}const Q=K.res.headers[d.$Umb],G={url:T,status:K.res.statusCode,"execution-id":U.headers[d.$Vmb],"operation-id":Q},ie=(0,f.$3p)(K)||K.res.statusCode&&F.includes(K.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",G):(V=await(0,f.$5p)(K)||"",this.r.info("Request failed",G,V)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire(d.UserDataSyncErrorCode.Unauthorized),new d.$Ymb(`${U.type} request '${T}' failed because of Unauthorized (401).`,T,d.UserDataSyncErrorCode.Unauthorized,K.res.statusCode,Q);if(K.res.statusCode===403)throw this.g.fire(d.UserDataSyncErrorCode.Forbidden),new d.$Ymb(`${U.type} request '${T}' failed because the access is forbidden (403).`,T,d.UserDataSyncErrorCode.Forbidden,K.res.statusCode,Q)}if(this.h.fire(),K.res.statusCode===404)throw new d.$Ymb(`${U.type} request '${T}' failed because the requested resource is not found (404).`,T,d.UserDataSyncErrorCode.NotFound,K.res.statusCode,Q);if(K.res.statusCode===405)throw new d.$Ymb(`${U.type} request '${T}' failed because the requested endpoint is not found (405). ${V}`,T,d.UserDataSyncErrorCode.MethodNotFound,K.res.statusCode,Q);if(K.res.statusCode===409)throw new d.$Ymb(`${U.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,d.UserDataSyncErrorCode.Conflict,K.res.statusCode,Q);if(K.res.statusCode===410)throw new d.$Ymb(`${U.type} request '${T}' failed because the requested resource is not longer available (410).`,T,d.UserDataSyncErrorCode.Gone,K.res.statusCode,Q);if(K.res.statusCode===412)throw new d.$Ymb(`${U.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,d.UserDataSyncErrorCode.PreconditionFailed,K.res.statusCode,Q);if(K.res.statusCode===413)throw new d.$Ymb(`${U.type} request '${T}' failed because of too large payload (413).`,T,d.UserDataSyncErrorCode.TooLarge,K.res.statusCode,Q);if(K.res.statusCode===426)throw new d.$Ymb(`${U.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,d.UserDataSyncErrorCode.UpgradeRequired,K.res.statusCode,Q);if(K.res.statusCode===429){const z=K.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new d.$Ymb(`${U.type} request '${T}' failed because of too many requests (429).`,T,d.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,K.res.statusCode,Q)):new d.$Ymb(`${U.type} request '${T}' failed because of too many requests (429).`,T,d.UserDataSyncErrorCode.TooManyRequests,K.res.statusCode,Q)}if(!ie)throw new d.$Ymb("Server returned "+K.res.statusCode,T,d.UserDataSyncErrorCode.Unknown,K.res.statusCode,Q);return K}F(T){let U=this.s.get(i,I.StorageScope.APPLICATION);U===void 0&&(U=(0,h.$1g)(),this.s.store(i,U,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)),T["X-Machine-Session-Id"]=U;const F=this.s.get(r,I.StorageScope.APPLICATION);F!==void 0&&(T["X-User-Session-Id"]=F)}};e.$VMb=R,e.$VMb=R=ve([Z(1,b.$rk),Z(2,f.$1p),Z(3,d.$8mb),Z(4,c.$Li),Z(5,g.$$k),Z(6,I.$bq)],R);let O=class extends R{constructor(T,U,F,M,X,K,Q){super(T.userDataSyncStore?.url,U,F,M,X,K,Q),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$WMb=O,e.$WMb=O=ve([Z(0,d.$Rmb),Z(1,b.$rk),Z(2,f.$1p),Z(3,d.$8mb),Z(4,c.$Li),Z(5,g.$$k),Z(6,I.$bq)],O);class E{constructor(T,U,F,M){this.c=T,this.d=U,this.f=F,this.g=M,this.a=[],this.b=void 0}request(T,U,F){if(this.h()&&this.i(),U.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$Ymb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,d.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$XMb=E}),define(le[270],he([0,1,3,2,9,22,24,17,127]),function(ne,e,P,a,N,L,C,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=e.$cgc=e.$bgc=e.$agc=void 0;class w{constructor(c){this.a=c}listen(c,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${g}`)}call(c,g,b){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(b)}throw new Error("Invalid call")}}e.$agc=w;class S extends a.$Vc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new P.$le),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(g=>{this.a=g,this.B(this.c.listen("onDidChangeAccount")(b=>{this.a=b,this.b.fire(b)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$bgc=S;class m{constructor(c){this.a=c}listen(c,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${g}`)}call(c,g,b){switch(g){case"switch":return this.a.switch(b[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$cgc=m;let h=class extends A.$TMb{constructor(c,g,b,f){super(g,b,f),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:N.URI.revive(c.url),type:c.type,defaultUrl:N.URI.revive(c.defaultUrl),insidersUrl:N.URI.revive(c.insidersUrl),stableUrl:N.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$dgc=h,e.$dgc=h=ve([Z(1,C.$rk),Z(2,L.$$i),Z(3,k.$bq)],h)}),define(le[271],he([0,1,3,59,24,17,18,266,25,83,87]),function(ne,e,P,a,N,L,C,k,A,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;let m=class extends k.$Wcc{constructor($,c,g,b,f,p,I,d,u,t,s){super($,c,g,b,f,I,d,u,t,s),this.B(P.Event.debounce(P.Event.any(P.Event.map(p.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(p.onDidOpenMainWindow,()=>"windowOpen")),(r,i)=>r?[...r,i]:[i],1e3)(r=>this.triggerSync(r,!0,!1)))}};e.$zgc=m,e.$zgc=m=ve([Z(0,N.$rk),Z(1,A.$Rmb),Z(2,A.$Smb),Z(3,A.$3mb),Z(4,A.$4mb),Z(5,a.$wec),Z(6,A.$8mb),Z(7,w.$jLb),Z(8,C.$0l),Z(9,S.$Fmb),Z(10,L.$bq)],m)}),define(le[272],he([0,1,76,23,5,21]),function(ne,e,P,a,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0,e.$Xdc=C,e.$Ydc=k,e.$Zdc=A,e.$Wdc=128/4;function C(w){function S(){let m=w.scheme===a.Schemas.file?(0,L.$6g)(w):w.toString();return N.$k||(m=m.toLowerCase()),(0,P.createHash)("md5").update(m).digest("hex")}return{id:S(),configPath:w}}function k(w,S){function m(){if(w.scheme!==a.Schemas.file)return(0,P.createHash)("md5").update(w.toString()).digest("hex");if(!S)return;let $;return N.$k?$=S.ino:N.$j?$=S.birthtime.getTime():N.$i&&(typeof S.birthtimeMs=="number"?$=Math.floor(S.birthtimeMs):$=S.birthtime.getTime()),(0,P.createHash)("md5").update(w.fsPath).update($?String($):"").digest("hex")}const h=m();if(typeof h=="string")return{id:h,uri:w}}function A(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[273],he([0,1,6,8,2,14,31,16,10,80,116,272,59,58,23]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;let g=class extends N.$Vc{constructor(f,p,I,d){super(),this.a=f,this.b=p,this.c=I,this.f=d,this.B(new P.$Qh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,p=await C.Promises.readdir(f),I=new w.$ULb(this.f.getChannel("storage"));await Promise.all(p.map(async d=>{const u=(0,L.$kc)(f,d);d.length===m.$Wdc||d===S.$Qi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(r=>r.workspace?.id===d)||await I.isUsed(u)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await C.Promises.rm(u))}))}catch(f){(0,a.$2)(f)}}};e.$9fc=g,e.$9fc=g=ve([Z(0,k.$Mi),Z(1,A.$$j),Z(2,h.$wec),Z(3,$.$Nfc)],g)}),define(le[128],he([0,1,76,66,38,281,15,8,3,2,14,5,32,43,70]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$vi=e.$ui=e.$ti=void 0,e.$wi=i,e.$xi=n,e.$zi=y,e.$Ai=R;const g=3e4;class b{traceSocketEvent(E,v){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,v)}constructor(E,v=""){this.f=!0,this.debugLabel=v,this.socket=E,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(c.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,k.$2)(U)}},this.socket.on("error",this.a);let T;this.b=U=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,T&&clearTimeout(T)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,T=setTimeout(()=>E.destroy(),g)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const v=T=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Read,T),E(C.$Ne.wrap(T))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(E){const v=T=>{E({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:T,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(E){const v=()=>{E()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(c.SocketDiagnosticsEventType.Write,E),this.socket.write(E.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,k.$2)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,k.$2)(v)}}end(){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((E,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),E();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),E()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.$ti=b;var f;(function(O){O[O.MinHeaderByteSize=2]="MinHeaderByteSize",O[O.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var p;(function(O){O[O.PeekHeader=1]="PeekHeader",O[O.ReadHeader=2]="ReadHeader",O[O.ReadBody=3]="ReadBody",O[O.Fin=4]="Fin"})(p||(p={}));class I extends w.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,v){this.socket.traceSocketEvent(E,v)}constructor(E,v,T,U){super(),this.f=this.B(new A.$le),this.g=this.B(new A.$le),this.h=!1,this.j={state:p.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:T?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new d(this,v,T,U,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,k.$2)(F),this.g.fire({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new c.$oi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let v=0;for(;v<E.byteLength;)this.a.writeMessage(E.slice(v,Math.min(v+f.MaxWebSocketMessageLength,E.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(E,{compressed:v,opcode:T}){if(this.h)return;this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,E);let U=f.MinHeaderByteSize;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const F=C.$Ne.alloc(U),M=v?64:0,X=T&15;if(F.writeUInt8(128|M|X,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let K=1;F.writeUInt8(E.byteLength>>>8&255,++K),F.writeUInt8(E.byteLength>>>0&255,++K)}else{F.writeUInt8(127,1);let K=1;F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(E.byteLength>>>24&255,++K),F.writeUInt8(E.byteLength>>>16&255,++K),F.writeUInt8(E.byteLength>>>8&255,++K),F.writeUInt8(E.byteLength>>>0&255,++K)}this.socket.write(C.$Ne.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===p.PeekHeader){const v=this.b.peek(this.j.readLen),T=v.readUInt8(0),U=(T&128)>>>7,F=(T&64)>>>6,M=T&15,X=v.readUInt8(1),K=(X&128)>>>7,Q=X&127;this.j.state=p.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(K?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===p.ReadHeader){const v=this.b.read(this.j.readLen),T=v.readUInt8(1),U=(T&128)>>>7;let F=T&127,M=1;F===126?F=v.readUInt8(++M)*2**8+v.readUInt8(++M):F===127&&(F=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let X=0;U&&(X=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=p.ReadBody,this.j.readLen=F,this.j.mask=X,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===p.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),s(v,this.j.mask),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=p.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await A.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ui=I;class d extends w.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$Ne.alloc(0)}constructor(E,v,T,U,F,M){super(),this.n=E,this.r=F,this.s=M,this.a=this.B(new A.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new A.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new A.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new u(this.n,U,T,{windowBits:15})),this.f=this.B(new t(this.n,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(E,v){this.g.push({data:E,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:v}=this.g.shift();if(this.f&&v.compressed){const T=await this.w(this.f,E);this.s(T,v)}else this.s(E,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,v){return new Promise((T,U)=>{E.write(v),E.flush(F=>T(F))})}acceptFrame(E,v,T){this.h.push({data:E,isCompressed:v,isLastFrameOfMessage:T}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const v=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,v,T){return new Promise((U,F)=>{E.write(v),T&&E.write(C.$Ne.fromByteArray([0,0,255,255])),E.flush(M=>U(M))})}}class u extends w.$Vc{get recordedInflateBytes(){return this.j?C.$Ne.concat(this.f):C.$Ne.alloc(0)}constructor(E,v,T,U){super(),this.h=E,this.j=v,this.a=this.B(new A.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(C.$Ne.wrap(F))}),T&&(this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialWrite,T.buffer),this.b.write(T.buffer),this.b.flush(()=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateWrite,E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=C.$Ne.concat(this.g);this.g.length=0,E(v)})}}class t extends w.$Vc{constructor(E,v){super(),this.g=E,this.a=this.B(new A.$le),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",T=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateError,{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateData,T),this.f.push(C.$Ne.wrap(T))})}write(E){this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateWrite,E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=C.$Ne.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),E(v)})}}function s(O,E){if(E===0)return;const v=O.byteLength>>>2;for(let K=0;K<v;K++){const Q=O.readUInt32BE(K*4);O.writeUInt32BE(Q^E,K*4)}const T=v*4,U=O.byteLength-T,F=E>>>24&255,M=E>>>16&255,X=E>>>8&255;U>=1&&O.writeUInt8(O.readUInt8(T)^F,T),U>=2&&O.writeUInt8(O.readUInt8(T+1)^M,T+1),U>=3&&O.writeUInt8(O.readUInt8(T+2)^X,T+2)}e.$vi=process.env.XDG_RUNTIME_DIR;const r={[m.Platform.Linux]:107,[m.Platform.Mac]:103};function i(){const O=(0,h.$1g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${O}-sock`;const E=process.platform!=="darwin"&&e.$vi?e.$vi:(0,N.tmpdir)(),v=(0,S.$kc)(E,`vscode-ipc-${O}.sock`);return o(v),v}function n(O,E,v){const U=(0,P.createHash)("sha256").update(O).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${E}-sock`;const F=v.substr(0,4),M=E.substr(0,6);let X;return process.platform!=="darwin"&&e.$vi&&!process.env.VSCODE_PORTABLE?X=(0,S.$kc)(e.$vi,`vscode-${U}-${F}-${M}.sock`):X=(0,S.$kc)(O,`${F}-${M}.sock`),o(X),X}function o(O){const E=r[m.$u];typeof E=="number"&&O.length>=E&&console.warn(`WARNING: IPC handle "${O}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends $.$ii{static b(E){const v=A.Event.fromNodeEventEmitter(E,"connection");return A.Event.map(v,T=>({protocol:new c.$pi(new b(T,"ipc-server-connection")),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(T,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$yi=l;function y(O){return new Promise((E,v)=>{const T=(0,a.createServer)();T.on("error",v),T.listen(O,()=>{T.removeListener("error",v),E(new l(T))})})}function R(O,E){return new Promise((v,T)=>{const U=(0,a.createConnection)(O,()=>{U.removeListener("error",T),v(c.$qi.fromSocket(new b(U,`ipc-client${E}`),E))});U.once("error",T)})}}),define(le[274],he([0,1,66,128,221]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0,P=ke(P),e.$Cgc=new class{supports(L){return!0}connect({host:L,port:C},k,A,w){return new Promise((S,m)=>{const h=P.createConnection({host:L,port:C},()=>{h.removeListener("error",m),h.write((0,N.$nwb)(k,A,w));const $=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(h.off("data",$),S(new a.$ti(h,w)))};h.on("data",$)});h.setNoDelay(!0),h.once("error",m)})}}}),define(le[275],he([0,1,66,38,139,128,6,2,5,22,10,24,222,107,109,81,15]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=e.$Ffc=e.$Efc=void 0,P=ke(P),a=ke(a);async function f(t,s,r,i,n){let o;for(let l=3;l&&(o?.dispose(),o=await new p(t,s,r,i,n).waitForReady(),!(n&&N.$4g[n]||!N.$4g[o.tunnelLocalPort]));l--);return o}class p extends k.$Vc{constructor(s,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=P.createServer(),this.c=new C.$Dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=l=>this.r(l),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,r=(0,g.$Ew)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,N.$5g)(s,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(s){s.pause();const r=(0,g.$Cw)(this.tunnelRemoteHost)||(0,g.$Ew)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,h.$1l)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&s.write(o.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),n.end()}),s.on("close",()=>n.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),n instanceof L.$ti?n.socket.destroy():n.end()}),n instanceof L.$ti?this.t(s,n):this.s(s,n),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),n.end()})}s(s,r){r.onClose(()=>s.destroy()),r.onEnd(()=>s.end()),r.onData(i=>s.write(i.buffer)),s.on("data",i=>r.write(b.$Ne.wrap(i))),s.resume()}t(s,r){const i=r.socket;i.on("end",()=>s.end()),i.on("close",()=>s.end()),i.on("error",()=>{s.destroy()}),i.pipe(s),s.pipe(i)}}e.$Efc=p;let I=class extends g.$Hw{constructor(s,r,i,n,o){super(r,o),this.H=s,this.I=i,this.J=n}isPortPrivileged(s){return(0,g.$Fw)(s,this.t,A.OS,a.release())}F(s,r,i,n,o,l,y,R){const O=this.D(r,i);if(O)return++O.refcount,O.value;if((0,g.$yw)(s))return this.G(s,r,i,o,l,y,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const E={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(E,n,r,i,o);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(r,i,v),v}}};e.$Ffc=I,e.$Ffc=I=ve([Z(0,$.$Ul),Z(1,S.$$j),Z(2,c.$Xl),Z(3,m.$rk),Z(4,w.$$i)],I);let d=class extends I{constructor(s,r,i,n,o){super(s,r,i,n,o)}};e.$Gfc=d,e.$Gfc=d=ve([Z(0,$.$Ul),Z(1,S.$$j),Z(2,c.$Xl),Z(3,m.$rk),Z(4,w.$$i)],d);let u=class extends k.$Vc{constructor(s,r,i,n,o){super(),this.b=s,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(s,r,i,n,o,l,y,R,O){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${l}.`),!this.a.has(s)){const E=new d(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(s,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(r,i,n,o,l,y,R,O)}};e.$Hfc=u,e.$Hfc=u=ve([Z(0,$.$Ul),Z(1,S.$$j),Z(2,m.$rk),Z(3,c.$Xl),Z(4,w.$$i)],u)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[282],he([0,1,38,41,8,2,23,9,19,3,43,157,215,216,225,207,273,198,199,22,220,98,232,99,227,16,119,259,28,111,223,118,75,7,209,210,74,4,206,77,79,235,10,211,103,24,61,17,110,18,112,113,114,49,238,86,115,25,83,265,270,248,87,264,268,269,127,62,263,249,109,231,81,275,226,239,29,240,5,241,200,218,217,85,254,20,53,214,60,262,237,250,108,267,255,11,212,102,260,253,228,195,59,213,271,257,58,261,107,105,274,193,229,153,146,151]),function(ne,e,P,a,N,L,C,k,A,w,S,m,h,$,c,g,b,f,p,I,d,u,t,s,r,i,n,o,l,y,R,O,E,v,T,U,F,M,X,K,Q,G,ie,V,z,ee,re,ce,q,x,J,H,D,B,j,W,te,_,Y,ae,ue,ge,we,Ee,pe,be,Se,Ie,oe,de,me,Pe,Oe,Fe,Ce,Ae,Ue,qe,He,Me,Be,ze,We,Ne,se,fe,$e,ye,Le,Te,je,xe,Je,Qe,Ve,_e,Ye,nt,at,At,Nt,Tt,Ct,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends L.$Vc{constructor(Re){super(),this.f=Re,this.a=this.B(new m.$lX(this)),this.b=void 0,this.c=this.B(new w.$le),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,m.$mX)(process.parentPort,ht.$Rec.exit,De)}async init(){const Re=await this.h();(0,_.$Mmb)(),Re.invokeFunction(De=>{const Ke=De.get(ie.$$j),Ge=De.get(x.$0l),et=De.get(fe.$Kl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,L.$Sc)(Re.createInstance(h.$5fc,this.f.codeCachePath),Re.createInstance($.$6fc),Re.createInstance(b.$9fc),Re.createInstance(g.$8fc),Re.createInstance(c.$7fc),Re.createInstance(Ve.$tgc),Re.createInstance(xe.$lgc)))}async h(){const Re=new K.$Ci,De={_serviceBrand:void 0,...z.default};Re.set(ee.$rk,De);const Ke=new S.$mi(Ze=>Ze==="main"),Ge=new yt.$Ofc(this.a,Ke);Re.set(yt.$Nfc,Ge);const et=this.f.policiesData?new ye.$ifc(this.f.policiesData,Ge.getChannel("policy")):new Le.$so;Re.set(Le.$qo,et);const Xe=new Bt.$7m(this.f.args,De);Re.set(i.$Mi,Xe);const ot=new V.$ms(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:k.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Re.set(ie.$_j,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(0,null)})),$t=this.B(new ie.$gk(ft.getLevel())),tt=this.B(new Ye.$UQ(ft,[$t]));Re.set(ie.$$j,tt),this.b=this.B(new nt.$vgc(tt)),Re.set(nt.$ugc,this.b);const st=this.B(new T.$Vq(tt));Re.set(v.$$k,st);const pt=this.B(new U.$mr(tt));st.registerProvider(C.Schemas.file,pt);const dt=new qe.$Ns(st);Re.set(Ue.$Il,dt);const rt=this.B(new Te.$2Q(this.f.profiles.all,k.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Kl,rt);const wt=this.B(new Me.$Mfc(C.Schemas.file,this.B(new Be.$DQ(Ge.getChannel(Be.$CQ),{pathCaseSensitive:He.$k})),C.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(C.Schemas.vscodeUserData,wt);const ct=this.B(new d.$So(rt.defaultProfile.settingsResource,st,et,tt));Re.set(I.$$i,ct);const bt=new Mt.$Bgc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(ce.$bq,bt),this.B((0,L.$Tc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Nt.$9r(Ge.getChannel("request"));Re.set(re.$1p,It),Re.set(f.$0fc,new F.$Bi(p.$$fc,void 0,!1)),Re.set(We.$JG,new F.$Bi(ze.$kgc,void 0,!1));const Rt=new Dt.$Qfc(-1,Ge);Re.set(Ct.$wec,Rt),Re.set(s.$Wo,new F.$Bi(r.$0Q,void 0,!0));const Gt=this.B(new de.$ffc(Rt)),Kt=new S.$mi(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Re.set(E.$A5b,new Tt.$xgc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,B.$Ep)(De,ct);if((0,B.$zp)(De,Xe)){const Ze=new H.$bcc(tt,ot,Xe,De);if(lt.push(Ze),!(0,B.$Ap)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new je.$IQ(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,L.$Tc)(()=>mt.flush())),lt.push(mt)}gt=new D.$as({appenders:lt,commonProperties:(0,q.$qp)((0,P.release)(),(0,P.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,B.$Fp)(Xe)},ct,De)}else{gt=B.$up;const Ze=B.$yp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new J.$Wec(lt)),Re.set(x.$0l,gt);const Jt=new j.$_fc(ct,gt,tt,ot,Xe,De);Re.set(x.$$l,Jt),Re.set($e.$Cq,new F.$Bi(At.$TQ,void 0,!0)),Re.set(Ne.$Gq,new F.$Bi(se.$jfc,void 0,!0)),Re.set(y.$mq,new F.$Bi(y.$oq,void 0,!0)),Re.set(O.$Rq,new F.$Bi(O.$Sq,void 0,!0)),Re.set(l.$gp,new F.$Bi(o.$kq,void 0,!0)),Re.set(l.$np,new F.$Bi(Ft.$Agc,void 0,!1)),Re.set(Q.$5r,new F.$Bi(G.$7r,void 0,!1)),Re.set(u.$Rm,new F.$Bi(t.$Us,void 0,!1)),Re.set(Y.$jLb,new F.$Bi(Y.$kLb,void 0,!0)),Re.set(_.$8mb,new F.$Bi(ge.$PNb,void 0,!0)),Re.set(_.$7mb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(l.$mp,new F.$Bi(n.$hLb,void 0,!1)),Re.set(te.$NNb,new F.$Bi(te.$ONb,void 0,!0)),Re.set(W.$iw,new F.$Bi(W.$jw)),Re.set(_.$Rmb,new F.$Bi(Se.$UMb,void 0,!0)),Re.set(_.$Smb,new F.$Bi(Se.$WMb,void 0,!0)),Re.set(we.$Fmb,new F.$Bi(we.$Hmb,void 0,!0)),Re.set(_.$Tmb,new F.$Bi(ae.$Qcc,void 0,!1)),Re.set(_.$3mb,new F.$Bi(Ee.$Fcc,void 0,!0)),Re.set(_.$4mb,new F.$Bi(pe.$Vcc,void 0,!1)),Re.set(Ie.$VLb,new F.$Bi(oe.$ggc,void 0,!0)),Re.set(_.$5mb,new F.$Bi(Qe.$zdc,void 0,!0)),Re.set(me.$Xl,new F.$Bi(Pe.$Jfc,void 0,!1));const kt=new vt.$Vl;return Re.set(vt.$Ul,kt),kt.register(jt.RemoteConnectionType.WebSocket,qt.$Cgc),Re.set(Oe.$xw,new F.$Bi(Fe.$Hfc)),Re.set(Ce.$hgc,new F.$Bi(Ae.$jgc)),Re.set(Je.$mgc,new F.$Bi(at.$wgc)),new X.$pr(Re)}j(Re){const De=new R.$qq(Re.get(l.$jp),()=>null);this.a.registerChannel("extensions",De);const Ke=S.ProxyChannel.fromService(Re.get(Q.$5r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=S.ProxyChannel.fromService(Re.get(u.$Rm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new R.$sq(Re.get(l.$np));this.a.registerChannel("extensionTipsService",et);const Xe=S.ProxyChannel.fromService(Re.get(f.$0fc),this.q);this.a.registerChannel("checksum",Xe);const ot=S.ProxyChannel.fromService(Re.get(We.$JG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=S.ProxyChannel.fromService(Re.get(we.$Fmb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=S.ProxyChannel.fromService(Re.get(x.$$l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ue.$agc(Re.get(Y.$jLb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ue.$cgc(Re.get(_.$Rmb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$egc(Re.get(_.$4mb),Re.get(fe.$Kl),Re.get(ie.$$j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(M.$Di).createInstance(Ut.$zgc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(Re.get(_.$5mb),this.q));const rt=S.ProxyChannel.fromService(Re.get(Ce.$hgc),this.q);this.a.registerChannel(Ce.$igc,rt);const wt=S.ProxyChannel.fromService(Re.get(Je.$mgc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,N.$2)(De)),process.on("unhandledRejection",De=>(0,N.$2)(De)),(0,N.setUnexpectedErrorHandler)(De=>{const Ke=(0,a.$pj)(De,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(He.$k){const[Ke,Ge]=await Promise.all([(0,zt.$2g)(De.error.bind(De)),(0,Et.$6W)(De.error.bind(De))]),et=(0,Wt.$LW)(),Xe=(0,Et.$7W)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$Tec.response)return!1;const De=(0,A.$Pb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$Rec.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$Rec.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fc357074a7bba115fe44683d3f6050c63e591683/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
