/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","vs/base/common/lazy","vs/base/common/buffer","fs","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/ternarySearchTree","vs/base/parts/sandbox/node/electronTypes","vs/nls","vs/nls!vs/platform/files/node/watcher/watcherMain","vs/base/common/process","vs/base/common/processes","vs/base/common/network","vs/base/node/extpath","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],Ee=function(ae){for(var e=[],g=0,t=ae.length;g<t;g++)e[g]=_e[ae[g]];return e};define(_e[38],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=g,e.$hb=t,e.$ib=W,e.$jb=M,e.$kb=X,e.$lb=k,e.$mb=U,e.$ob=N,e.$pb=A,e.$qb=I,e.$rb=F,e.$sb=o;function g(r,$){const m=t(r,$);if(m!==-1)return r[m]}function t(r,$,m=r.length-1){for(let f=m;f>=0;f--){const _=r[f];if($(_))return f}return-1}function W(r,$){const m=M(r,$);return m===-1?void 0:r[m]}function M(r,$,m=0,f=r.length){let _=m,y=f;for(;_<y;){const s=Math.floor((_+y)/2);$(r[s])?_=s+1:y=s}return _-1}function X(r,$){const m=k(r,$);return m===r.length?void 0:r[m]}function k(r,$,m=0,f=r.length){let _=m,y=f;for(;_<y;){const s=Math.floor((_+y)/2);$(r[s])?y=s:_=s+1}return _}function U(r,$,m=0,f=r.length){const _=k(r,$,m,f);return _===r.length?-1:_}class S{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(S.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!$(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const m=M(this.e,$,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$nb=S;function N(r,$){if(r.length===0)return;let m=r[0];for(let f=1;f<r.length;f++){const _=r[f];$(_,m)>0&&(m=_)}return m}function A(r,$){if(r.length===0)return;let m=r[0];for(let f=1;f<r.length;f++){const _=r[f];$(_,m)>=0&&(m=_)}return m}function I(r,$){return N(r,(m,f)=>-$(m,f))}function F(r,$){if(r.length===0)return-1;let m=0;for(let f=1;f<r.length;f++){const _=r[f];$(_,r[m])>0&&(m=f)}return m}function o(r,$){for(const m of r){const f=$(m);if(f!==void 0)return f}}}),define(_e[11],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var g;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(g||(e.CharCode=g={}))}),define(_e[39],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=g,e.$L=t,e.$M=W,e.$N=M;function g(X,k){const U=Object.create(null);for(const S of X){const N=k(S);let A=U[N];A||(A=U[N]=[]),A.push(S)}return U}function t(X,k){const U=[],S=[];for(const N of X)k.has(N)||U.push(N);for(const N of k)X.has(N)||S.push(N);return{removed:U,added:S}}function W(X,k){const U=[],S=[];for(const[N,A]of X)k.has(N)||U.push(A);for(const[N,A]of k)X.has(N)||S.push(A);return{removed:U,added:S}}function M(X,k){const U=new Set;for(const S of k)X.has(S)&&U.add(S);return U}}),define(_e[40],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=t,e.$0h=W,e.$$h=M;function g(X){return(k,U,S)=>{let N=null,A=null;if(typeof S.value=="function"?(N="value",A=S.value):typeof S.get=="function"&&(N="get",A=S.get),!A)throw new Error("not supported");S[N]=X(A,U)}}function t(X,k,U){let S=null,N=null;if(typeof U.value=="function"?(S="value",N=U.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof U.get=="function"&&(S="get",N=U.get),!N)throw new Error("not supported");const A=`$memoize$${k}`;U[S]=function(...I){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,I)}),this[A]}}function W(X,k,U){return g((S,N)=>{const A=`$debounce$${N}`,I=`$debounce$result$${N}`;return function(...F){this[I]||(this[I]=U?U():void 0),clearTimeout(this[A]),k&&(this[I]=k(this[I],...F),F=[this[I]]),this[A]=setTimeout(()=>{S.apply(this,F),this[I]=U?U():void 0},X)}})}function M(X,k,U){return g((S,N)=>{const A=`$throttle$timer$${N}`,I=`$throttle$result$${N}`,F=`$throttle$lastRun$${N}`,o=`$throttle$pending$${N}`;return function(...r){if(this[I]||(this[I]=U?U():void 0),(this[F]===null||this[F]===void 0)&&(this[F]=-Number.MAX_VALUE),k&&(this[I]=k(this[I],...r)),this[o])return;const $=this[F]+X;$<=Date.now()?(this[F]=Date.now(),S.apply(this,[this[I]]),this[I]=U?U():void 0):(this[o]=!0,this[A]=setTimeout(()=>{this[o]=!1,this[F]=Date.now(),S.apply(this,[this[I]]),this[I]=U?U():void 0},$-Date.now()))}})}}),define(_e[9],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=t,e.$1=W,e.$2=M,e.$3=X,e.$4=k,e.$5=S,e.$7=A,e.$8=I,e.$9=F,e.$$=r;class g{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?_.isErrorNoTelemetry(n)?new _(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$X=g,e.$Y=new g;function t(s){e.$Y.setUnexpectedErrorHandler(s)}function W(s){if(!s||typeof s!="object")return!1;const n=s;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function M(s){S(s)||e.$Y.onUnexpectedError(s)}function X(s){S(s)||e.$Y.onUnexpectedExternalError(s)}function k(s){if(s instanceof Error){const{name:n,message:i}=s,l=s.stacktrace||s.stack;return{$isError:!0,name:n,message:i,stack:l,noTelemetry:_.isErrorNoTelemetry(s)}}return s}const U="Canceled";function S(s){return s instanceof N?!0:s instanceof Error&&s.name===U&&s.message===U}class N extends Error{constructor(){super(U),this.name=this.message}}e.$6=N;function A(){const s=new Error(U);return s.name=s.message,s}function I(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function F(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class o extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=o;function r(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$_=$;class m extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$ab=m;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=f;class _ extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof _)return n;const i=new _;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$cb=_;class y extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,y.prototype)}}e.$db=y}),define(_e[12],Ee([0,1,9,38]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=W,e.$ub=M,e.$vb=X,e.$wb=k,e.$xb=U,e.$yb=S,e.$zb=N,e.$Ab=A,e.$Bb=I,e.$Cb=F,e.$Db=o,e.$Eb=r,e.$Fb=$,e.top=m,e.$Hb=f,e.$Ib=y,e.$Jb=s,e.$Kb=n,e.$Lb=i,e.$Mb=l,e.$Nb=c,e.$Ob=T,e.$Pb=h,e.$Qb=w,e.$Rb=u,e.$Sb=P,e.$Tb=D,e.$Ub=b,e.$Vb=d,e.$Wb=K,e.$Xb=re,e.$Yb=x,e.$Zb=V,e.$1b=se,e.$2b=Q,e.$3b=te,e.$4b=oe,e.$5b=ce,e.$6b=R,e.$7b=j,e.$8b=Y,e.$$b=ee;function W(p,q=0){return p[p.length-(1+q)]}function M(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}function X(p,q,H=(B,E)=>B===E){if(p===q)return!0;if(!p||!q||p.length!==q.length)return!1;for(let B=0,E=p.length;B<E;B++)if(!H(p[B],q[B]))return!1;return!0}function k(p,q){const H=p.length-1;q<H&&(p[q]=p[H]),p.pop()}function U(p,q,H){return S(p.length,B=>H(p[B],q))}function S(p,q){let H=0,B=p-1;for(;H<=B;){const E=(H+B)/2|0,z=q(E);if(z<0)H=E+1;else if(z>0)B=E-1;else return E}return-(H+1)}function N(p,q,H){if(p=p|0,p>=q.length)throw new TypeError("invalid index");const B=q[Math.floor(q.length*Math.random())],E=[],z=[],J=[];for(const ne of q){const $e=H(ne,B);$e<0?E.push(ne):$e>0?z.push(ne):J.push(ne)}return p<E.length?N(p,E,H):p<E.length+J.length?J[0]:N(p-(E.length+J.length),z,H)}function A(p,q){const H=[];let B;for(const E of p.slice(0).sort(q))!B||q(B[0],E)!==0?(B=[E],H.push(B)):B.push(E);return H}function*I(p,q){let H,B;for(const E of p)B!==void 0&&q(B,E)?H.push(E):(H&&(yield H),H=[E]),B=E;H&&(yield H)}function F(p,q){for(let H=0;H<=p.length;H++)q(H===0?void 0:p[H-1],H===p.length?void 0:p[H])}function o(p,q){for(let H=0;H<p.length;H++)q(H===0?void 0:p[H-1],p[H],H+1===p.length?void 0:p[H+1])}function r(p,q,H){const B=[];function E(ne,$e,De){if($e===0&&De.length===0)return;const he=B[B.length-1];he&&he.start+he.deleteCount===ne?(he.deleteCount+=$e,he.toInsert.push(...De)):B.push({start:ne,deleteCount:$e,toInsert:De})}let z=0,J=0;for(;;){if(z===p.length){E(z,0,q.slice(J));break}if(J===q.length){E(z,p.length-z,[]);break}const ne=p[z],$e=q[J],De=H(ne,$e);De===0?(z+=1,J+=1):De<0?(E(z,1,[]),z+=1):De>0&&(E(z,0,[$e]),J+=1)}return B}function $(p,q,H){const B=r(p,q,H),E=[],z=[];for(const J of B)E.push(...p.slice(J.start,J.start+J.deleteCount)),z.push(...J.toInsert);return{removed:E,added:z}}function m(p,q,H){if(H===0)return[];const B=p.slice(0,H).sort(q);return _(p,q,B,H,p.length),B}function f(p,q,H,B,E){return H===0?Promise.resolve([]):new Promise((z,J)=>{(async()=>{const ne=p.length,$e=p.slice(0,H).sort(q);for(let De=H,he=Math.min(H+B,ne);De<ne;De=he,he=Math.min(he+B,ne)){if(De>H&&await new Promise(fe=>setTimeout(fe)),E&&E.isCancellationRequested)throw new g.$6;_(p,q,$e,De,he)}return $e})().then(z,J)})}function _(p,q,H,B,E){for(const z=H.length;B<E;B++){const J=p[B];if(q(J,H[z-1])<0){H.pop();const ne=(0,t.$lb)(H,$e=>q(J,$e)<0);H.splice(ne,0,J)}}}function y(p){return p.filter(q=>!!q)}function s(p){let q=0;for(let H=0;H<p.length;H++)p[H]&&(p[q]=p[H],q+=1);p.length=q}function n(p,q,H){p.splice(H,0,p.splice(q,1)[0])}function i(p){return!Array.isArray(p)||p.length===0}function l(p){return Array.isArray(p)&&p.length>0}function c(p,q=H=>H){const H=new Set;return p.filter(B=>{const E=q(B);return H.has(E)?!1:(H.add(E),!0)})}function T(p){const q=new Set;return H=>{const B=p(H);return q.has(B)?!1:(q.add(B),!0)}}function h(p,q){return p.length>0?p[0]:q}function w(p,q){return p.length>0?p[p.length-1]:q}function u(p,q,H=(B,E)=>B===E){let B=0;for(let E=0,z=Math.min(p.length,q.length);E<z&&H(p[E],q[E]);E++)B++;return B}function P(p,q){let H=typeof q=="number"?p:0;typeof q=="number"?H=p:(H=0,q=p);const B=[];if(H<=q)for(let E=H;E<q;E++)B.push(E);else for(let E=H;E>q;E--)B.push(E);return B}function D(p,q,H){return p.reduce((B,E)=>(B[q(E)]=H?H(E):E,B),Object.create(null))}function b(p,q){return p.push(q),()=>d(p,q)}function d(p,q){const H=p.indexOf(q);if(H>-1)return p.splice(H,1),q}function K(p,q,H){const B=p.slice(0,q),E=p.slice(q);return B.concat(H,E)}function re(p,q){let H;if(typeof q=="number"){let B=q;H=()=>{const E=Math.sin(B++)*179426549;return E-Math.floor(E)}}else H=Math.random;for(let B=p.length-1;B>0;B-=1){const E=Math.floor(H()*(B+1)),z=p[B];p[B]=p[E],p[E]=z}}function x(p,q){const H=p.indexOf(q);H>-1&&(p.splice(H,1),p.unshift(q))}function V(p,q){const H=p.indexOf(q);H>-1&&(p.splice(H,1),p.push(q))}function se(p,q){for(const H of q)p.push(H)}function Q(p,q){return Array.isArray(p)?p.map(q):q(p)}function te(p){return Array.isArray(p)?p:[p]}function oe(p){return p[Math.floor(Math.random()*p.length)]}function ce(p,q,H){const B=a(p,q),E=p.length,z=H.length;p.length=E+z;for(let J=E-1;J>=B;J--)p[J+z]=p[J];for(let J=0;J<z;J++)p[J+B]=H[J]}function R(p,q,H,B){const E=a(p,q);let z=p.splice(E,H);return z===void 0&&(z=[]),ce(p,E,B),z}function a(p,q){return q<0?Math.max(q+p.length,0):Math.min(q,p.length)}var O;(function(p){function q(z){return z<0}p.isLessThan=q;function H(z){return z<=0}p.isLessThanOrEqual=H;function B(z){return z>0}p.isGreaterThan=B;function E(z){return z===0}p.isNeitherLessOrGreaterThan=E,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(O||(e.CompareResult=O={}));function j(p,q){return(H,B)=>q(p(H),p(B))}function Y(...p){return(q,H)=>{for(const B of p){const E=B(q,H);if(!O.isNeitherLessOrGreaterThan(E))return E}return O.neitherLessOrGreaterThan}}const v=(p,q)=>p-q;e.$9b=v;const Z=(p,q)=>(0,e.$9b)(p?1:0,q?1:0);e.$0b=Z;function ee(p){return(q,H)=>-p(q,H)}class ie{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let H=this.c;for(;H<this.g.length&&q(this.g[H]);)H++;const B=H===this.c?null:this.g.slice(this.c,H);return this.c=H,B}takeFromEndWhile(q){let H=this.d;for(;H>=0&&q(this.g[H]);)H--;const B=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const H=this.g.slice(this.c,this.c+q);return this.c+=q,H}}e.$_b=ie;class le{static{this.empty=new le(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(H=>(q(H),!0))}toArray(){const q=[];return this.iterate(H=>(q.push(H),!0)),q}filter(q){return new le(H=>this.iterate(B=>q(B)?H(B):!0))}map(q){return new le(H=>this.iterate(B=>H(q(B))))}some(q){let H=!1;return this.iterate(B=>(H=q(B),!H)),H}findFirst(q){let H;return this.iterate(B=>q(B)?(H=B,!1):!0),H}findLast(q){let H;return this.iterate(B=>(q(B)&&(H=B),!0)),H}findLastMaxBy(q){let H,B=!0;return this.iterate(E=>((B||O.isGreaterThan(q(E,H)))&&(B=!1,H=E),!0)),H}}e.$ac=le;class de{constructor(q){this.c=q}static createSortPermutation(q,H){const B=Array.from(q.keys()).sort((E,z)=>H(q[E],q[z]));return new de(B)}apply(q){return q.map((H,B)=>q[this.c[B]])}inverse(){const q=this.c.slice();for(let H=0;H<this.c.length;H++)q[this.c[H]]=H;return new de(q)}}e.$bc=de}),define(_e[26],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=g;function g(t,W){const M=this;let X=!1,k;return function(){if(X)return k;if(X=!0,W)try{k=t.apply(M,arguments)}finally{W()}else k=t.apply(M,arguments);return k}}}),define(_e[41],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(t){function W(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=W;const M=Object.freeze([]);function X(){return M}t.empty=X;function*k(i){yield i}t.single=k;function U(i){return W(i)?i:k(i)}t.wrap=U;function S(i){return i||M}t.from=S;function*N(i){for(let l=i.length-1;l>=0;l--)yield i[l]}t.reverse=N;function A(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=A;function I(i){return i[Symbol.iterator]().next().value}t.first=I;function F(i,l){let c=0;for(const T of i)if(l(T,c++))return!0;return!1}t.some=F;function o(i,l){for(const c of i)if(l(c))return c}t.find=o;function*r(i,l){for(const c of i)l(c)&&(yield c)}t.filter=r;function*$(i,l){let c=0;for(const T of i)yield l(T,c++)}t.map=$;function*m(i,l){let c=0;for(const T of i)yield*l(T,c++)}t.flatMap=m;function*f(...i){for(const l of i)yield*l}t.concat=f;function _(i,l,c){let T=c;for(const h of i)T=l(T,h);return T}t.reduce=_;function*y(i,l,c=i.length){for(l<0&&(l+=i.length),c<0?c+=i.length:c>i.length&&(c=i.length);l<c;l++)yield i[l]}t.slice=y;function s(i,l=Number.POSITIVE_INFINITY){const c=[];if(l===0)return[c,i];const T=i[Symbol.iterator]();for(let h=0;h<l;h++){const w=T.next();if(w.done)return[c,t.empty()];c.push(w.value)}return[c,{[Symbol.iterator](){return T}}]}t.consume=s;async function n(i){const l=[];for await(const c of i)l.push(c);return Promise.resolve(l)}t.asyncToArray=n})(g||(e.Iterable=g={}))}),define(_e[15],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class g{constructor(W){this.d=W,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(W){this.c=W}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=g}),define(_e[42],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class g{static{this.Undefined=new g(void 0)}constructor(M){this.element=M,this.next=g.Undefined,this.prev=g.Undefined}}class t{constructor(){this.a=g.Undefined,this.b=g.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===g.Undefined}clear(){let M=this.a;for(;M!==g.Undefined;){const X=M.next;M.prev=g.Undefined,M.next=g.Undefined,M=X}this.a=g.Undefined,this.b=g.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,X){const k=new g(M);if(this.a===g.Undefined)this.a=k,this.b=k;else if(X){const S=this.b;this.b=k,k.prev=S,S.next=k}else{const S=this.a;this.a=k,k.next=S,S.prev=k}this.c+=1;let U=!1;return()=>{U||(U=!0,this.e(k))}}shift(){if(this.a!==g.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==g.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==g.Undefined&&M.next!==g.Undefined){const X=M.prev;X.next=M.next,M.next.prev=X}else M.prev===g.Undefined&&M.next===g.Undefined?(this.a=g.Undefined,this.b=g.Undefined):M.next===g.Undefined?(this.b=this.b.prev,this.b.next=g.Undefined):M.prev===g.Undefined&&(this.a=this.a.next,this.a.prev=g.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==g.Undefined;)yield M.element,M=M.next}}e.$6c=t}),define(_e[20],Ee([0,1]),function(ae,e){"use strict";var g,t,W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=X,e.$Ac=k,e.$Jc=y;function M(s,n,i){let l=s.get(n);return l===void 0&&(l=i,s.set(n,l)),l}function X(s){const n=[];return s.forEach((i,l)=>{n.push(`${l} => ${i}`)}),`Map(${s.size}) {${n.join(", ")}}`}function k(s){const n=[];return s.forEach(i=>{n.push(i)}),`Set(${s.size}) {${n.join(", ")}}`}class U{constructor(n,i){this.uri=n,this.value=i}}function S(s){return Array.isArray(s)}class N{static{this.c=n=>n.toString()}constructor(n,i){if(this[g]="ResourceMap",n instanceof N)this.d=new Map(n.d),this.e=i??N.c;else if(S(n)){this.d=new Map,this.e=i??N.c;for(const[l,c]of n)this.set(l,c)}else this.d=new Map,this.e=n??N.c}set(n,i){return this.d.set(this.e(n),new U(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[l,c]of this.d)n(c.value,c.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Bc=N;class A{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new N(n):(this.c=new N(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((l,c)=>n.call(i,c,c,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=A;var I;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class F{constructor(){this[W]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=I.None){const l=this.c.get(n);if(l)return i!==I.None&&this.m(l,i),l.value}set(n,i,l=I.None){let c=this.c.get(n);if(c)c.value=i,l!==I.None&&this.m(c,l);else{switch(c={key:n,value:i,next:void 0,previous:void 0},l){case I.None:this.k(c);break;case I.AsOld:this.j(c);break;case I.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(n,c),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const l=this.g;let c=this.d;for(;c;){if(i?n.bind(i)(c.value,c.key,this):n(c.value,c.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const T={value:l.key,done:!1};return l=l.next,T}else return{value:void 0,done:!0}}};return c}values(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const T={value:l.value,done:!1};return l=l.next,T}else return{value:void 0,done:!0}}};return c}entries(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const T={value:[l.key,l.value],done:!1};return l=l.next,T}else return{value:void 0,done:!0}}};return c}[(W=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.next,l--;this.d=i,this.f=l,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.previous,l--;this.e=i,this.f=l,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,l=n.previous;if(!i||!l)throw new Error("Invalid list");i.previous=l,l.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==I.AsOld&&i!==I.AsNew)){if(i===I.AsOld){if(n===this.d)return;const l=n.next,c=n.previous;n===this.e?(c.next=void 0,this.e=c):(l.previous=c,c.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===I.AsNew){if(n===this.e)return;const l=n.next,c=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=c,c.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,l)=>{n.push([l,i])}),n}fromJSON(n){this.clear();for(const[i,l]of n)this.set(i,l)}}e.$Dc=F;class o extends F{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=I.AsNew){return super.get(n,i)}peek(n){return super.get(n,I.None)}set(n,i){return super.set(n,i,I.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends o{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Ec=r;class $ extends o{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Fc=$;class m{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Gc=m;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,l]of n)this.set(i,l)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((l,c)=>{n.call(i,l,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=f;class _{constructor(){this.c=new Map}add(n,i){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(i)}delete(n,i){const l=this.c.get(n);l&&(l.delete(i),l.size===0&&this.c.delete(n))}forEach(n,i){const l=this.c.get(n);l&&l.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Ic=_;function y(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[i,l]of s)if(!n.has(i)||n.get(i)!==l)return!1;for(const[i]of n)if(!s.has(i))return!1;return!0}}),define(_e[4],Ee([0,1,12,39,20,26,41]),function(ae,e,g,t,W,M,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=N,e.$Mc=A,e.$Nc=I,e.$Oc=r,e.$Pc=$,e.$Qc=m,e.$Rc=f,e.$Sc=_,e.$Tc=y,e.$4c=P;const k=!1;let U=null;class S{constructor(){this.b=new Map}static{this.a=0}c(d){let K=this.b.get(d);return K||(K={parent:null,source:null,isSingleton:!1,value:d,idx:S.a++},this.b.set(d,K)),K}trackDisposable(d){const K=this.c(d);K.source||(K.source=new Error().stack)}setParent(d,K){const re=this.c(d);re.parent=K}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,K){const re=K.get(d);if(re)return re;const x=d.parent?this.f(this.c(d.parent),K):d;return K.set(d,x),x}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,re])=>re.source!==null&&!this.f(re,d).isSingleton).flatMap(([re])=>re)}computeLeakingDisposables(d=10,K){let re;if(K)re=K;else{const te=new Map,oe=[...this.b.values()].filter(R=>R.source!==null&&!this.f(R,te).isSingleton);if(oe.length===0)return;const ce=new Set(oe.map(R=>R.value));if(re=oe.filter(R=>!(R.parent&&ce.has(R.parent))),re.length===0)throw new Error("There are cyclic diposable chains!")}if(!re)return;function x(te){function oe(R,a){for(;R.length>0&&a.some(O=>typeof O=="string"?O===R[0]:R[0].match(O));)R.shift()}const ce=te.source.split(`
`).map(R=>R.trim().replace("at ","")).filter(R=>R!=="");return oe(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const V=new W.$Ic;for(const te of re){const oe=x(te);for(let ce=0;ce<=oe.length;ce++)V.add(oe.slice(0,ce).join(`
`),te)}re.sort((0,g.$7b)(te=>te.idx,g.$9b));let se="",Q=0;for(const te of re.slice(0,d)){Q++;const oe=x(te),ce=[];for(let R=0;R<oe.length;R++){let a=oe[R];a=`(shared with ${V.get(oe.slice(0,R+1).join(`
`)).size}/${re.length} leaks) at ${a}`;const j=V.get(oe.slice(0,R).join(`
`)),Y=(0,t.$K)([...j].map(v=>x(v)[R]),v=>v);delete Y[oe[R]];for(const[v,Z]of Object.entries(Y))ce.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${v}`);ce.unshift(a)}se+=`


==================== Leaking disposable ${Q}/${re.length}: ${te.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return re.length>d&&(se+=`


... and ${re.length-d} more leaking disposables

`),{leaks:re,details:se}}}e.$Kc=S;function N(b){U=b}if(k){const b="__is_disposable_tracked__";N(new class{trackDisposable(d){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[b]||console.log(K)},3e3)}setParent(d,K){if(d&&d!==n.None)try{d[b]=!0}catch{}}markAsDisposed(d){if(d&&d!==n.None)try{d[b]=!0}catch{}}markAsSingleton(d){}})}function A(b){return U?.trackDisposable(b),b}function I(b){U?.markAsDisposed(b)}function F(b,d){U?.setParent(b,d)}function o(b,d){if(U)for(const K of b)U.setParent(K,d)}function r(b){return U?.markAsSingleton(b),b}function $(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function m(b){if(X.Iterable.is(b)){const d=[];for(const K of b)if(K)try{K.dispose()}catch(re){d.push(re)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function f(b){for(const d of b)$(d)&&d.dispose();return[]}function _(...b){const d=y(()=>m(b));return o(b,d),d}function y(b){const d=A({dispose:(0,M.$eb)(()=>{I(d),b()})});return d}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return F(d,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),F(d,null))}}e.$Uc=s;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,A(this),F(this.q,this)}dispose(){I(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Vc=n;class i{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&F(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&F(d,null),d}}e.$Wc=i;class l{constructor(d){this.a=new i,this.b=!1,this.a.value=d}get value(){return this.a.value}set value(d){this.b||d===this.a.value||(this.a.value=d)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=l;class c{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=c;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(d){let K=d;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,I(this))},this}}e.$Zc=T;class h{constructor(){this.a=new Map}acquire(d,...K){let re=this.a.get(d);re||(re={counter:0,object:this.b(d,...K)},this.a.set(d,re));const{object:x}=re,V=(0,M.$eb)(()=>{--re.counter===0&&(this.c(d,re.object),this.a.delete(d))});return re.counter++,{object:x,dispose:V}}}e.$1c=h;class w{constructor(d){this.a=d}async acquire(d,...K){const re=this.a.acquire(d,...K);try{return{object:await re.object,dispose:()=>re.dispose()}}catch(x){throw re.dispose(),x}}}e.$2c=w;class u{constructor(d){this.object=d}dispose(){}}e.$3c=u;function P(b){const d=new s;try{b(d)}finally{d.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,K,re=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),re||this.a.get(d)?.dispose(),this.a.set(d,K)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}deleteAndLeak(d){const K=this.a.get(d);return this.a.delete(d),K}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=D}),define(_e[27],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var g;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(g||(e.MarshalledId=g={}))}),define(_e[21],Ee([0,1,20]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=void 0,e.$lm=W,e.$mm=X;const t=new g.$Ec(1e4);function W(S){return U(S,"NFC",t)}const M=new g.$Ec(1e4);function X(S){return U(S,"NFD",M)}const k=/[^\u0000-\u0080]/;function U(S,N,A){if(!S)return S;const I=A.get(S);if(I)return I;let F;return k.test(S)?F=S.normalize(N):F=S,A.set(S,F),F}e.$nm=function(){const S=/[\u0300-\u036f]/g;return function(N){return X(N).replace(S,"")}}()}),define(_e[43],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const g=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(M){return new t(M)}constructor(M){this.c=g&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=t}),define(_e[6],Ee([0,1,9,26,4,42,43]),function(ae,e,g,t,W,M,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=F;const k=!1,U=!1,S=!1;var N;(function(x){x.None=()=>W.$Vc.None;function V(he){if(S){const{onDidAddListener:fe}=he,be=r.create();let ge=0;he.onDidAddListener=()=>{++ge===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),fe?.()}}}function se(he,fe){return v(he,()=>{},0,void 0,!0,void 0,fe)}x.defer=se;function Q(he){return(fe,be=null,ge)=>{let we=!1,ye;return ye=he(Re=>{if(!we)return ye?ye.dispose():we=!0,fe.call(be,Re)},null,ge),we&&ye.dispose(),ye}}x.once=Q;function te(he,fe,be){return j((ge,we=null,ye)=>he(Re=>ge.call(we,fe(Re)),null,ye),be)}x.map=te;function oe(he,fe,be){return j((ge,we=null,ye)=>he(Re=>{fe(Re),ge.call(we,Re)},null,ye),be)}x.forEach=oe;function ce(he,fe,be){return j((ge,we=null,ye)=>he(Re=>fe(Re)&&ge.call(we,Re),null,ye),be)}x.filter=ce;function R(he){return he}x.signal=R;function a(...he){return(fe,be=null,ge)=>{const we=(0,W.$Sc)(...he.map(ye=>ye(Re=>fe.call(be,Re))));return Y(we,ge)}}x.any=a;function O(he,fe,be,ge){let we=be;return te(he,ye=>(we=fe(we,ye),we),ge)}x.reduce=O;function j(he,fe){let be;const ge={onWillAddFirstListener(){be=he(we.fire,we)},onDidRemoveLastListener(){be?.dispose()}};fe||V(ge);const we=new i(ge);return fe?.add(we),we.event}function Y(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function v(he,fe,be=100,ge=!1,we=!1,ye,Re){let Ie,Ue,pe,Be=0,Ae;const Pe={leakWarningThreshold:ye,onWillAddFirstListener(){Ie=he(Ge=>{Be++,Ue=fe(Ue,Ge),ge&&!pe&&(je.fire(Ue),Ue=void 0),Ae=()=>{const Ke=Ue;Ue=void 0,pe=void 0,(!ge||Be>1)&&je.fire(Ke),Be=0},typeof be=="number"?(clearTimeout(pe),pe=setTimeout(Ae,be)):pe===void 0&&(pe=0,queueMicrotask(Ae))})},onWillRemoveListener(){we&&Be>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,Ie.dispose()}};Re||V(Pe);const je=new i(Pe);return Re?.add(je),je.event}x.debounce=v;function Z(he,fe=0,be){return x.debounce(he,(ge,we)=>ge?(ge.push(we),ge):[we],fe,void 0,!0,void 0,be)}x.accumulate=Z;function ee(he,fe=(ge,we)=>ge===we,be){let ge=!0,we;return ce(he,ye=>{const Re=ge||!fe(ye,we);return ge=!1,we=ye,Re},be)}x.latch=ee;function ie(he,fe,be){return[x.filter(he,fe,be),x.filter(he,ge=>!fe(ge),be)]}x.split=ie;function le(he,fe=!1,be=[],ge){let we=be.slice(),ye=he(Ue=>{we?we.push(Ue):Ie.fire(Ue)});ge&&ge.add(ye);const Re=()=>{we?.forEach(Ue=>Ie.fire(Ue)),we=null},Ie=new i({onWillAddFirstListener(){ye||(ye=he(Ue=>Ie.fire(Ue)),ge&&ge.add(ye))},onDidAddFirstListener(){we&&(fe?setTimeout(Re):Re())},onDidRemoveLastListener(){ye&&ye.dispose(),ye=null}});return ge&&ge.add(Ie),Ie.event}x.buffer=le;function de(he,fe){return(ge,we,ye)=>{const Re=fe(new q);return he(function(Ie){const Ue=Re.evaluate(Ie);Ue!==p&&ge.call(we,Ue)},void 0,ye)}}x.chain=de;const p=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(be=>(fe(be),be)),this}filter(fe){return this.f.push(be=>fe(be)?be:p),this}reduce(fe,be){let ge=be;return this.f.push(we=>(ge=fe(ge,we),ge)),this}latch(fe=(be,ge)=>be===ge){let be=!0,ge;return this.f.push(we=>{const ye=be||!fe(we,ge);return be=!1,ge=we,ye?we:p}),this}evaluate(fe){for(const be of this.f)if(fe=be(fe),fe===p)break;return fe}}function H(he,fe,be=ge=>ge){const ge=(...Ie)=>Re.fire(be(...Ie)),we=()=>he.on(fe,ge),ye=()=>he.removeListener(fe,ge),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:ye});return Re.event}x.fromNodeEventEmitter=H;function B(he,fe,be=ge=>ge){const ge=(...Ie)=>Re.fire(be(...Ie)),we=()=>he.addEventListener(fe,ge),ye=()=>he.removeEventListener(fe,ge),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:ye});return Re.event}x.fromDOMEventEmitter=B;function E(he){return new Promise(fe=>Q(he)(fe))}x.toPromise=E;function z(he){const fe=new i;return he.then(be=>{fe.fire(be)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}x.fromPromise=z;function J(he,fe,be){return fe(be),he(ge=>fe(ge))}x.runAndSubscribe=J;class ne{constructor(fe,be){this._observable=fe,this.f=0,this.g=!1;const ge={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};be||V(ge),this.emitter=new i(ge),be&&be.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,be){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(he,fe){return new ne(he,fe).emitter.event}x.fromObservable=$e;function De(he){return(fe,be,ge)=>{let we=0,ye=!1;const Re={beginUpdate(){we++},endUpdate(){we--,we===0&&(he.reportChanges(),ye&&(ye=!1,fe.call(be)))},handlePossibleChange(){},handleChange(){ye=!0}};he.addObserver(Re),he.reportChanges();const Ie={dispose(){he.removeObserver(Re)}};return ge instanceof W.$Uc?ge.add(Ie):Array.isArray(ge)&&ge.push(Ie),Ie}}x.fromObservableLight=De})(N||(e.Event=N={}));class A{static{this.all=new Set}static{this.f=0}constructor(V){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${V}_${A.f++}`,A.all.add(this)}start(V){this.g=new X.$fe,this.listenerCount=V}stop(){if(this.g){const V=this.g.elapsed();this.durations.push(V),this.elapsedOverall+=V,this.invocationCount+=1,this.g=void 0}}}e.$he=A;let I=-1;function F(x){const V=I;return I=x,{dispose(){I=V}}}class o{constructor(V,se,Q=Math.random().toString(18).slice(2,5)){this.h=V,this.threshold=se,this.name=Q,this.g=0}dispose(){this.f?.clear()}check(V,se){const Q=this.threshold;if(Q<=0||se<Q)return;this.f||(this.f=new Map);const te=this.f.get(V.value)||0;if(this.f.set(V.value,te+1),this.g-=1,this.g<=0){this.g=Q*.5;const[oe,ce]=this.getMostFrequentStack(),R=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${ce}):`;console.warn(R),console.warn(oe);const a=new $(R,oe);this.h(a)}return()=>{const oe=this.f.get(V.value)||0;this.f.set(V.value,oe-1)}}getMostFrequentStack(){if(!this.f)return;let V,se=0;for(const[Q,te]of this.f)(!V||se<te)&&(V=[Q,te],se=te);return V}}class r{static create(){const V=new Error;return new r(V.stack??"")}constructor(V){this.value=V}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class $ extends Error{constructor(V,se){super(V),this.name="ListenerLeakError",this.stack=se}}e.$je=$;class m extends Error{constructor(V,se){super(V),this.name="ListenerRefusalError",this.stack=se}}e.$ke=m;let f=0;class _{constructor(V){this.value=V,this.id=f++}}const y=2,s=(x,V)=>{if(x instanceof _)V(x);else for(let se=0;se<x.length;se++){const Q=x[se];Q&&V(Q)}};let n;if(k){const x=[];setInterval(()=>{x.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(x.join(`
`)),x.length=0)},3e3),n=new FinalizationRegistry(V=>{typeof V=="string"&&x.push(V)})}class i{constructor(V){this.z=0,this.f=V,this.g=I>0||this.f?.leakWarningThreshold?new o(V?.onListenerError??g.$2,this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(U){const V=this.u;queueMicrotask(()=>{s(V,se=>se.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(V,se,Q)=>{if(this.g&&this.z>this.g.threshold**2){const a=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(a);const O=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],j=new m(`${a}. HINT: Stack shows most frequent listener (${O[1]}-times)`,O[0]);return(this.f?.onListenerError||g.$2)(j),W.$Vc.None}if(this.m)return W.$Vc.None;se&&(V=V.bind(se));const te=new _(V);let oe,ce;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(te.stack=r.create(),oe=this.g.check(te.stack,this.z+1)),U&&(te.stack=ce??r.create()),this.u?this.u instanceof _?(this.w??=new c,this.u=[this.u,te]):this.u.push(te):(this.f?.onWillAddFirstListener?.(this),this.u=te,this.f?.onDidAddFirstListener?.(this)),this.z++;const R=(0,W.$Tc)(()=>{n?.unregister(R),oe?.(),this.A(te)});if(Q instanceof W.$Uc?Q.add(R):Array.isArray(Q)&&Q.push(R),n){const a=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),O=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(a);n.register(R,O?.[2]??a,R)}return R},this.q}A(V){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const se=this.u,Q=se.indexOf(V);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,se[Q]=void 0;const te=this.w.current===this;if(this.z*y<=se.length){let oe=0;for(let ce=0;ce<se.length;ce++)se[ce]?se[oe++]=se[ce]:te&&(this.w.end--,oe<this.w.i&&this.w.i--);se.length=oe}}B(V,se){if(!V)return;const Q=this.f?.onListenerError||g.$2;if(!Q){V.value(se);return}try{V.value(se)}catch(te){Q(te)}}C(V){const se=V.current.u;for(;V.i<V.end;)this.B(se[V.i++],V.value);V.reset()}fire(V){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof _)this.B(this.u,V);else{const se=this.w;se.enqueue(this,V,this.u.length),this.C(se)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=i;const l=()=>new c;e.$me=l;class c{constructor(){this.i=-1,this.end=0}enqueue(V,se,Q){this.i=0,this.end=Q,this.current=V,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class T extends i{async fireAsync(V,se,Q){if(this.u)for(this.h||(this.h=new M.$6c),s(this.u,te=>this.h.push([te.value,V]));this.h.size>0&&!se.isCancellationRequested;){const[te,oe]=this.h.shift(),ce=[],R={...oe,token:se,waitUntil:a=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");Q&&(a=Q(a,te)),ce.push(a)}};try{te(R)}catch(a){(0,g.$2)(a);continue}Object.freeze(ce),await Promise.allSettled(ce).then(a=>{for(const O of a)O.status==="rejected"&&(0,g.$2)(O.reason)})}}}e.$ne=T;class h extends i{get isPaused(){return this.h!==0}constructor(V){super(V),this.h=0,this.s=new M.$6c,this.t=V?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const V=Array.from(this.s);this.s.clear(),super.fire(this.t(V))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(V){this.z&&(this.h!==0?this.s.push(V):super.fire(V))}}e.$oe=h;class w extends h{constructor(V){super(V),this.k=V.delay??100}fire(V){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(V)}}e.$pe=w;class u extends i{constructor(V){super(V),this.h=[],this.k=V?.merge}fire(V){this.hasListeners()&&(this.h.push(V),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$qe=u;class P{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(V){const se={event:V,listener:null};this.h.push(se),this.g&&this.m(se);const Q=()=>{this.g&&this.o(se);const te=this.h.indexOf(se);this.h.splice(te,1)};return(0,W.$Tc)((0,t.$eb)(Q))}j(){this.g=!0,this.h.forEach(V=>this.m(V))}k(){this.g=!1,this.h.forEach(V=>this.o(V))}m(V){V.listener=V.event(se=>this.f.fire(se))}o(V){V.listener?.dispose(),V.listener=null}dispose(){this.f.dispose();for(const V of this.h)V.listener?.dispose();this.h=[]}}e.$re=P;class D{constructor(V,se,Q,te){this.f=new W.$Uc;const oe=this.f.add(new P),ce=this.f.add(new W.$5c);function R(a){ce.set(a,oe.add(te(a)))}for(const a of V)R(a);this.f.add(se(a=>{R(a)})),this.f.add(Q(a=>{ce.deleteAndDispose(a)})),this.event=oe.event}dispose(){this.f.dispose()}}e.$se=D;class b{constructor(){this.f=[]}wrapEvent(V,se,Q){return(te,oe,ce)=>V(R=>{const a=this.f[this.f.length-1];if(!se){a?a.buffers.push(()=>te.call(oe,R)):te.call(oe,R);return}const O=a;if(!O){te.call(oe,se(Q,R));return}O.items??=[],O.items.push(R),O.buffers.length===0&&a.buffers.push(()=>{O.reducedResult??=Q?O.items.reduce(se,Q):O.items.reduce(se),te.call(oe,O.reducedResult)})},void 0,ce)}bufferEvents(V){const se={buffers:new Array};this.f.push(se);const Q=V();return this.f.pop(),se.buffers.forEach(te=>te()),Q}}e.$te=b;class d{constructor(){this.f=!1,this.g=N.None,this.h=W.$Vc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(V){this.g=V,this.f&&(this.h.dispose(),this.h=V(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=d;class K{static const(V){return new re(V)}constructor(V){this.g=V,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(V){V!==this.g&&(this.g=V,this.f.fire(void 0))}}e.$ve=K;class re{constructor(V){this.value=V,this.onDidChange=N.None}}}),define(_e[13],Ee([0,1,6]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=k;const t=Object.freeze(function(U,S){const N=setTimeout(U.bind(S),0);return{dispose(){clearTimeout(N)}}});var W;(function(U){function S(N){return N===U.None||N===U.Cancelled||N instanceof M?!0:!N||typeof N!="object"?!1:typeof N.isCancellationRequested=="boolean"&&typeof N.onCancellationRequested=="function"}U.isCancellationToken=S,U.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),U.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(W||(e.CancellationToken=W={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new g.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class X{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=W.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=W.None}}e.$we=X;function k(U){const S=new X;return U.add({dispose(){S.cancel()}}),S.token}}),define(_e[44],Ee([0,1,13]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=W;class t{constructor(U){this.b=U,this.a=null}get(){if(this.a)return this.a;const U=new g.$we,S=this.b(U.token);return this.a={promise:S,dispose:()=>{this.a=null,U.cancel(),U.dispose()}},this.a}}e.$9e=t;function W(k){return k}class M{constructor(U,S){this.a=void 0,this.b=void 0,typeof U=="function"?(this.c=U,this.d=W):(this.c=S,this.d=U.getCacheKey)}get(U){const S=this.d(U);return this.b!==S&&(this.b=S,this.a=this.c(U)),this.a}}e.$$e=M;class X{get cachedValues(){return this.a}constructor(U,S){this.a=new Map,this.b=new Map,typeof U=="function"?(this.c=U,this.d=W):(this.c=S,this.d=U.getCacheKey)}get(U){const S=this.d(U);if(this.b.has(S))return this.b.get(S);const N=this.c(U);return this.a.set(U,N),this.b.set(S,N),N}}e.$_e=X}),define(_e[45],Ee([0,1,9,4]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=W,e.$ze=M,e.$Ae=X,e.$Be=k,e.$Ce=S,e.$De=N,e.$Ee=A,e.$Fe=I,e.$Ge=F,e.$He=o,e.$Ie=r,e.$Je=$,e.$Ke=m,e.$Le=f,e.$Me=_;function W(y){const s=y;return s?typeof s.read=="function":!1}function M(y){const s=y;return s?[s.on,s.pause,s.resume,s.destroy].every(n=>typeof n=="function"):!1}function X(y){const s=y;return s?M(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function k(y,s){return new U(y,s)}class U{constructor(s,n){this.e=s,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(n=>n(s))}h(s){this.c.error.length===0?(0,g.$2)(s):this.c.error.slice(0).forEach(n=>n(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,n){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(s,n){if(this.a.destroyed)return;let i;switch(s){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const l=i.indexOf(n);l>=0&&i.splice(l,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(y,s){const n=[];let i;for(;(i=y.read())!==null;)n.push(i);return s(n)}function N(y,s,n){const i=[];let l;for(;(l=y.read())!==null&&i.length<n;)i.push(l);return l===null&&i.length>0?s(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l<"u"){const c=l;return l=void 0,c}return y.read()}}}function A(y,s){return new Promise((n,i)=>{const l=[];I(y,{onData:c=>{s&&l.push(c)},onError:c=>{s?i(c):n(void 0)},onEnd:()=>{n(s?s(l):void 0)}})})}function I(y,s,n){y.on("error",i=>{n?.isCancellationRequested||s.onError(i)}),y.on("end",()=>{n?.isCancellationRequested||s.onEnd()}),y.on("data",i=>{n?.isCancellationRequested||s.onData(i)})}function F(y,s){return new Promise((n,i)=>{const l=new t.$Uc,c=[],T=u=>{if(c.push(u),c.length>s)return l.dispose(),y.pause(),n({stream:y,buffer:c,ended:!1})},h=u=>(l.dispose(),i(u)),w=()=>(l.dispose(),n({stream:y,buffer:c,ended:!0}));l.add((0,t.$Tc)(()=>y.removeListener("error",h))),y.on("error",h),l.add((0,t.$Tc)(()=>y.removeListener("end",w))),y.on("end",w),l.add((0,t.$Tc)(()=>y.removeListener("data",T))),y.on("data",T)})}function o(y,s){const n=k(s);return n.end(y),n}function r(){const y=k(()=>{throw new Error("not supported")});return y.end(),y}function $(y){let s=!1;return{read:()=>s?null:(s=!0,y)}}function m(y,s,n){const i=k(n);return I(y,{onData:l=>i.write(s.data(l)),onError:l=>i.error(s.error?s.error(l):l),onEnd:()=>i.end()}),i}function f(y,s,n){let i=!1;return{read:()=>{const l=s.read();return i?l:(i=!0,l!==null?n([y,l]):y)}}}function _(y,s,n){let i=!1;const l=k(n);return I(s,{onData:c=>i?l.write(c):(i=!0,l.write(n([y,c]))),onError:c=>l.error(c),onEnd:()=>{i||(i=!0,l.write(y)),l.end()}}),l}});var Xe=this&&this.__createBinding||(Object.create?function(ae,e,g,t){t===void 0&&(t=g);var W=Object.getOwnPropertyDescriptor(e,g);(!W||("get"in W?!e.__esModule:W.writable||W.configurable))&&(W={enumerable:!0,get:function(){return e[g]}}),Object.defineProperty(ae,t,W)}:function(ae,e,g,t){t===void 0&&(t=g),ae[t]=e[g]}),Qe=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),Le=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var g in ae)g!=="default"&&Object.prototype.hasOwnProperty.call(ae,g)&&Xe(e,ae,g);return Qe(e,ae),e};define(_e[16],Ee([0,1,15,45]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=S,e.$Pe=N,e.$Qe=A,e.$Re=I,e.$Se=F,e.$Te=o,e.$Ue=r,e.$Ve=$,e.$We=m,e.$Xe=f,e.$Ye=_,e.$Ze=y,e.$1e=s,e.$2e=n,e.$3e=i,e.$4e=l,e.$5e=c,e.$6e=T,e.$7e=h,e.$8e=P,t=Le(t);const W=typeof Buffer<"u",M=new g.$W(()=>new Uint8Array(256));let X,k;class U{static alloc(b){return W?new U(Buffer.allocUnsafe(b)):new U(new Uint8Array(b))}static wrap(b){return W&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new U(b)}static fromString(b,d){return!(d?.dontUseNodeBuffer||!1)&&W?new U(Buffer.from(b)):(X||(X=new TextEncoder),new U(X.encode(b)))}static fromByteArray(b){const d=U.alloc(b.length);for(let K=0,re=b.length;K<re;K++)d.buffer[K]=b[K];return d}static concat(b,d){if(typeof d>"u"){d=0;for(let x=0,V=b.length;x<V;x++)d+=b[x].byteLength}const K=U.alloc(d);let re=0;for(let x=0,V=b.length;x<V;x++){const se=b[x];K.set(se,re),re+=se.byteLength}return K}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=U.alloc(this.byteLength);return b.set(this),b}toString(){return W?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(b,d){return new U(this.buffer.subarray(b,d))}set(b,d){if(b instanceof U)this.buffer.set(b.buffer,d);else if(b instanceof Uint8Array)this.buffer.set(b,d);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),d);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return I(this.buffer,b)}writeUInt32BE(b,d){F(this.buffer,b,d)}readUInt32LE(b){return o(this.buffer,b)}writeUInt32LE(b,d){r(this.buffer,b,d)}readUInt8(b){return $(this.buffer,b)}writeUInt8(b,d){m(this.buffer,b,d)}indexOf(b,d=0){return S(this.buffer,b instanceof U?b.buffer:b,d)}}e.$Ne=U;function S(D,b,d=0){const K=b.byteLength,re=D.byteLength;if(K===0)return 0;if(K===1)return D.indexOf(b[0]);if(K>re-d)return-1;const x=M.value;x.fill(b.length);for(let te=0;te<b.length;te++)x[b[te]]=b.length-te-1;let V=d+b.length-1,se=V,Q=-1;for(;V<re;)if(D[V]===b[se]){if(se===0){Q=V;break}V--,se--}else V+=Math.max(b.length-se,x[D[V]]),se=b.length-1;return Q}function N(D,b){return D[b+0]<<0>>>0|D[b+1]<<8>>>0}function A(D,b,d){D[d+0]=b&255,b=b>>>8,D[d+1]=b&255}function I(D,b){return D[b]*2**24+D[b+1]*2**16+D[b+2]*2**8+D[b+3]}function F(D,b,d){D[d+3]=b,b=b>>>8,D[d+2]=b,b=b>>>8,D[d+1]=b,b=b>>>8,D[d]=b}function o(D,b){return D[b+0]<<0>>>0|D[b+1]<<8>>>0|D[b+2]<<16>>>0|D[b+3]<<24>>>0}function r(D,b,d){D[d+0]=b&255,b=b>>>8,D[d+1]=b&255,b=b>>>8,D[d+2]=b&255,b=b>>>8,D[d+3]=b&255}function $(D,b){return D[b]}function m(D,b,d){D[d]=b}function f(D){return t.$Ce(D,b=>U.concat(b))}function _(D){return t.$Je(D)}function y(D){return t.$Ee(D,b=>U.concat(b))}async function s(D){return D.ended?U.concat(D.buffer):U.concat([...D.buffer,await y(D.stream)])}function n(D){return t.$He(D,b=>U.concat(b))}function i(D){return t.$Ke(D,{data:b=>typeof b=="string"?U.fromString(b):U.wrap(b)},b=>U.concat(b))}function l(D){return t.$Be(b=>U.concat(b),D)}function c(D,b){return t.$Le(D,b,d=>U.concat(d))}function T(D,b){return t.$Me(D,b,d=>U.concat(d))}function h(D){let b=0,d=0,K=0;const re=new Uint8Array(Math.floor(D.length/4*3)),x=se=>{switch(d){case 3:re[K++]=b|se,d=0;break;case 2:re[K++]=b|se>>>2,b=se<<6,d=3;break;case 1:re[K++]=b|se>>>4,b=se<<4,d=2;break;default:b=se<<2,d=1}};for(let se=0;se<D.length;se++){const Q=D.charCodeAt(se);if(Q>=65&&Q<=90)x(Q-65);else if(Q>=97&&Q<=122)x(Q-97+26);else if(Q>=48&&Q<=57)x(Q-48+52);else if(Q===43||Q===45)x(62);else if(Q===47||Q===95)x(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${D[se]}`)}}const V=K;for(;d>0;)x(0);return U.wrap(re).slice(0,V)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:D},b=!0,d=!1){const K=d?u:w;let re="";const x=D.byteLength%3;let V=0;for(;V<D.byteLength-x;V+=3){const se=D[V+0],Q=D[V+1],te=D[V+2];re+=K[se>>>2],re+=K[(se<<4|Q>>>4)&63],re+=K[(Q<<2|te>>>6)&63],re+=K[te&63]}if(x===1){const se=D[V+0];re+=K[se>>>2],re+=K[se<<4&63],b&&(re+="==")}else if(x===2){const se=D[V+0],Q=D[V+1];re+=K[se>>>2],re+=K[(se<<4|Q>>>4)&63],re+=K[Q<<2&63],b&&(re+="=")}return re}}),define(_e[46],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(_e[10],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=g,e.$fg=t,e.$gg=W,e.$hg=M,e.$ig=X,e.$jg=k,e.$kg=U,e.$lg=S,e.$mg=N,e.$ng=A,e.$og=I,e.$pg=F,e.$qg=o,e.$rg=$,e.$sg=m,e.$tg=f,e.$ug=_,e.$vg=y;function g(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(n=>g(n))}function W(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function M(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}function X(s){return typeof s=="number"&&!isNaN(s)}function k(s){return!!s&&typeof s[Symbol.iterator]=="function"}function U(s){return s===!0||s===!1}function S(s){return typeof s>"u"}function N(s){return!A(s)}function A(s){return S(s)||s===null}function I(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function F(s){if(A(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function o(...s){const n=[];for(let i=0;i<s.length;i++){const l=s[i];if(A(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(l)}return n}const r=Object.prototype.hasOwnProperty;function $(s){if(!W(s))return!1;for(const n in s)if(r.call(s,n))return!1;return!0}function m(s){return typeof s=="function"}function f(...s){return s.length>0&&s.every(m)}function _(s,n){const i=Math.min(s.length,n.length);for(let l=0;l<i;l++)y(s[l],n[l])}function y(s,n){if(g(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(m(n)){try{if(s instanceof n)return}catch{}if(!A(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(_e[47],Ee([0,1,10]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=t,e.$co=W,e.$do=X,e.$eo=U,e.$fo=S,e.$go=N,e.$ho=A,e.$io=I,e.$jo=F,e.$ko=o,e.$lo=r,e.$mo=$,e.$no=m;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const _=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([y,s])=>{_[y]=s&&typeof s=="object"?t(s):s}),_}function W(f){if(!f||typeof f!="object")return f;const _=[f];for(;_.length>0;){const y=_.shift();Object.freeze(y);for(const s in y)if(M.call(y,s)){const n=y[s];typeof n=="object"&&!Object.isFrozen(n)&&!(0,g.$hg)(n)&&_.push(n)}}return f}const M=Object.prototype.hasOwnProperty;function X(f,_){return k(f,_,new Set)}function k(f,_,y){if((0,g.$ng)(f))return f;const s=_(f);if(typeof s<"u")return s;if(Array.isArray(f)){const n=[];for(const i of f)n.push(k(i,_,y));return n}if((0,g.$gg)(f)){if(y.has(f))throw new Error("Cannot clone recursive data-structure");y.add(f);const n={};for(const i in f)M.call(f,i)&&(n[i]=k(f[i],_,y));return y.delete(f),n}return f}function U(f,_,y=!0){return(0,g.$gg)(f)?((0,g.$gg)(_)&&Object.keys(_).forEach(s=>{s in f?y&&((0,g.$gg)(f[s])&&(0,g.$gg)(_[s])?U(f[s],_[s],y):f[s]=_[s]):f[s]=_[s]}),f):_}function S(f,_){if(f===_)return!0;if(f==null||_===null||_===void 0||typeof f!=typeof _||typeof f!="object"||Array.isArray(f)!==Array.isArray(_))return!1;let y,s;if(Array.isArray(f)){if(f.length!==_.length)return!1;for(y=0;y<f.length;y++)if(!S(f[y],_[y]))return!1}else{const n=[];for(s in f)n.push(s);n.sort();const i=[];for(s in _)i.push(s);if(i.sort(),!S(n,i))return!1;for(y=0;y<n.length;y++)if(!S(f[n[y]],_[n[y]]))return!1}return!0}function N(f){const _=new Set;return JSON.stringify(f,(y,s)=>{if((0,g.$gg)(s)||Array.isArray(s)){if(_.has(s))return"[Circular]";_.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function A(f,_){const y=Object.create(null);return!f||!_||Object.keys(_).forEach(n=>{const i=f[n],l=_[n];S(i,l)||(y[n]=l)}),y}function I(f,_){const y=_.toLowerCase(),s=Object.keys(f).find(n=>n.toLowerCase()===y);return s?f[s]:f[_]}function F(f,_){const y=Object.create(null);for(const[s,n]of Object.entries(f))_(s,n)&&(y[s]=n);return y}function o(f){let _=[];for(;Object.prototype!==f;)_=_.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return _}function r(f){const _=[];for(const y of o(f))typeof f[y]=="function"&&_.push(y);return _}function $(f,_){const y=n=>function(){const i=Array.prototype.slice.call(arguments,0);return _(n,i)},s={};for(const n of f)s[n]=y(n);return s}function m(f,_){const y={};for(const[s,n]of Object.entries(f))y[s]=_(n,s);return y}}),define(_e[48],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=t,e.$bf=W;var g;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g||(e.Constants=g={}));function t(M){return M<0?0:M>g.MAX_UINT_8?g.MAX_UINT_8:M|0}function W(M){return M<0?0:M>g.MAX_UINT_32?g.MAX_UINT_32:M|0}}),define(_e[7],Ee([0,1,44,11,15,48]),function(ae,e,g,t,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=X,e.$df=U,e.$ef=N,e.$ff=A,e.$gf=I,e.$hf=F,e.$if=o,e.$jf=r,e.$kf=$,e.$lf=m,e.$mf=f,e.$nf=_,e.$of=y,e.$pf=s,e.$qf=n,e.$rf=i,e.$sf=l,e.$tf=c,e.$uf=T,e.$vf=h,e.$wf=w,e.$xf=u,e.$yf=P,e.$zf=D,e.$Af=b,e.$Bf=d,e.$Cf=K,e.$Df=re,e.$Ef=x,e.$Ff=V,e.$Gf=se,e.$Hf=Q,e.$If=te,e.$Jf=oe,e.$Kf=ce,e.$Lf=R,e.$Mf=a,e.$Pf=v,e.$Qf=Z,e.$Rf=ee,e.$Sf=ie,e.$Tf=p,e.$Uf=H,e.$Wf=B,e.$Xf=E,e.$Yf=z,e.$Zf=J,e.$1f=$e,e.$2f=De,e.$3f=fe,e.$5f=be,e.$6f=ge,e.$7f=we,e.$8f=ye,e.$9f=Re,e.$0f=Ie,e.$$f=Ue,e.$_f=pe,e.$ag=Ge;function X(L){return!L||typeof L!="string"?!0:L.trim().length===0}const k=/{(\d+)}/g;function U(L,...G){return G.length===0?L:L.replace(k,function(C,ue){const me=parseInt(ue,10);return isNaN(me)||me<0||me>=G.length?C:G[me]})}const S=/{([^}]+)}/g;function N(L,G){return Object.keys(G).length===0?L:L.replace(S,(C,ue)=>G[ue]??C)}function A(L){return L.replace(/[<>"'&]/g,G=>{switch(G){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return G})}function I(L){return L.replace(/[<>&]/g,function(G){switch(G){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return G}})}function F(L){return L.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function o(L,G){let C=0,ue=L.indexOf(G);for(;ue!==-1;)C++,ue=L.indexOf(G,ue+G.length);return C}function r(L,G,C="\u2026"){return L.length<=G?L:`${L.substr(0,G)}${C}`}function $(L,G,C="\u2026"){if(L.length<=G)return L;const ue=Math.ceil(G/2)-C.length/2,me=Math.floor(G/2)-C.length/2;return`${L.substr(0,ue)}${C}${L.substr(L.length-me)}`}function m(L,G=" "){const C=f(L,G);return _(C,G)}function f(L,G){if(!L||!G)return L;const C=G.length;if(C===0||L.length===0)return L;let ue=0;for(;L.indexOf(G,ue)===ue;)ue=ue+C;return L.substring(ue)}function _(L,G){if(!L||!G)return L;const C=G.length,ue=L.length;if(C===0||ue===0)return L;let me=ue,ve=-1;for(;ve=L.lastIndexOf(G,me-1),!(ve===-1||ve+C!==me);){if(ve===0)return"";me=ve}return L.substring(0,me)}function y(L){return L.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(L){return L.replace(/\*/g,"")}function n(L,G,C={}){if(!L)throw new Error("Cannot create regex from empty string");G||(L=F(L)),C.wholeWord&&(/\B/.test(L.charAt(0))||(L="\\b"+L),/\B/.test(L.charAt(L.length-1))||(L=L+"\\b"));let ue="";return C.global&&(ue+="g"),C.matchCase||(ue+="i"),C.multiline&&(ue+="m"),C.unicode&&(ue+="u"),new RegExp(L,ue)}function i(L){return L.source==="^"||L.source==="^$"||L.source==="$"||L.source==="^\\s*$"?!1:!!(L.exec("")&&L.lastIndex===0)}function l(L){return L.split(/\r\n|\r|\n/)}function c(L){const G=[],C=L.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(C.length/2);ue++)G.push(C[2*ue]+(C[2*ue+1]??""));return G}function T(L){for(let G=0,C=L.length;G<C;G++){const ue=L.charCodeAt(G);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return G}return-1}function h(L,G=0,C=L.length){for(let ue=G;ue<C;ue++){const me=L.charCodeAt(ue);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return L.substring(G,ue)}return L.substring(G,C)}function w(L,G=L.length-1){for(let C=G;C>=0;C--){const ue=L.charCodeAt(C);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return C}return-1}function u(L,G,C){const ue=[];let me=0;for(const ve of L.matchAll(G)){if(ue.push(L.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,ue.push(C(ve[0],...ve.slice(1),ve.index,L,ve.groups))}return ue.push(L.slice(me)),Promise.all(ue).then(ve=>ve.join(""))}function P(L,G){return L<G?-1:L>G?1:0}function D(L,G,C=0,ue=L.length,me=0,ve=G.length){for(;C<ue&&me<ve;C++,me++){const Se=L.charCodeAt(C),ke=G.charCodeAt(me);if(Se<ke)return-1;if(Se>ke)return 1}const Te=ue-C,Fe=ve-me;return Te<Fe?-1:Te>Fe?1:0}function b(L,G){return d(L,G,0,L.length,0,G.length)}function d(L,G,C=0,ue=L.length,me=0,ve=G.length){for(;C<ue&&me<ve;C++,me++){let Se=L.charCodeAt(C),ke=G.charCodeAt(me);if(Se===ke)continue;if(Se>=128||ke>=128)return D(L.toLowerCase(),G.toLowerCase(),C,ue,me,ve);re(Se)&&(Se-=32),re(ke)&&(ke-=32);const Oe=Se-ke;if(Oe!==0)return Oe}const Te=ue-C,Fe=ve-me;return Te<Fe?-1:Te>Fe?1:0}function K(L){return L>=t.CharCode.Digit0&&L<=t.CharCode.Digit9}function re(L){return L>=t.CharCode.a&&L<=t.CharCode.z}function x(L){return L>=t.CharCode.A&&L<=t.CharCode.Z}function V(L,G){return L.length===G.length&&d(L,G)===0}function se(L,G){const C=G.length;return G.length>L.length?!1:d(L,G,0,C)===0}function Q(L,G){const C=Math.min(L.length,G.length);let ue;for(ue=0;ue<C;ue++)if(L.charCodeAt(ue)!==G.charCodeAt(ue))return ue;return C}function te(L,G){const C=Math.min(L.length,G.length);let ue;const me=L.length-1,ve=G.length-1;for(ue=0;ue<C;ue++)if(L.charCodeAt(me-ue)!==G.charCodeAt(ve-ue))return ue;return C}function oe(L){return 55296<=L&&L<=56319}function ce(L){return 56320<=L&&L<=57343}function R(L,G){return(L-55296<<10)+(G-56320)+65536}function a(L,G,C){const ue=L.charCodeAt(C);if(oe(ue)&&C+1<G){const me=L.charCodeAt(C+1);if(ce(me))return R(ue,me)}return ue}function O(L,G){const C=L.charCodeAt(G-1);if(ce(C)&&G>1){const ue=L.charCodeAt(G-2);if(oe(ue))return R(ue,C)}return C}class j{get offset(){return this.e}constructor(G,C=0){this.c=G,this.d=G.length,this.e=C}setOffset(G){this.e=G}prevCodePoint(){const G=O(this.c,this.e);return this.e-=G>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,G}nextCodePoint(){const G=a(this.c,this.d,this.e);return this.e+=G>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,G}eol(){return this.e>=this.d}}e.$Nf=j;class Y{get offset(){return this.c.offset}constructor(G,C=0){this.c=new j(G,C)}nextGraphemeLength(){const G=Pe.getInstance(),C=this.c,ue=C.offset;let me=G.getGraphemeBreakType(C.nextCodePoint());for(;!C.eol();){const ve=C.offset,Te=G.getGraphemeBreakType(C.nextCodePoint());if(Be(me,Te)){C.setOffset(ve);break}me=Te}return C.offset-ue}prevGraphemeLength(){const G=Pe.getInstance(),C=this.c,ue=C.offset;let me=G.getGraphemeBreakType(C.prevCodePoint());for(;C.offset>0;){const ve=C.offset,Te=G.getGraphemeBreakType(C.prevCodePoint());if(Be(Te,me)){C.setOffset(ve);break}me=Te}return ue-C.offset}eol(){return this.c.eol()}}e.$Of=Y;function v(L,G){return new Y(L,G).nextGraphemeLength()}function Z(L,G){return new Y(L,G).prevGraphemeLength()}function ee(L,G){G>0&&ce(L.charCodeAt(G))&&G--;const C=G+v(L,G);return[C-Z(L,C),C]}function ie(L){const G=new Y(L);let C=0;for(;!G.eol();)C++,G.nextGraphemeLength();return C}let le;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function p(L){return le||(le=de()),le.test(L)}const q=/^[\t\n\r\x20-\x7E]*$/;function H(L){return q.test(L)}e.$Vf=/[\u2028\u2029]/;function B(L){return e.$Vf.test(L)}function E(L){return L>=11904&&L<=55215||L>=63744&&L<=64255||L>=65281&&L<=65374}function z(L){return L>=127462&&L<=127487||L===8986||L===8987||L===9200||L===9203||L>=9728&&L<=10175||L===11088||L===11093||L>=127744&&L<=128591||L>=128640&&L<=128764||L>=128992&&L<=129008||L>=129280&&L<=129535||L>=129648&&L<=129782}function J(L,G,C=""){const ue=L.trimStart();if(ue.length<G)return ue;const me=/\b/g;let ve=0;for(;me.test(ue)&&!(ue.length-me.lastIndex<G);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?ue:C+ue.substring(ve).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(L){let G=0;for(const C of L.matchAll(ne))G!==C.index&&(yield{isCode:!1,str:L.substring(G,C.index)}),yield{isCode:!0,str:C[0]},G=C.index+C[0].length;G!==L.length&&(yield{isCode:!1,str:L.substring(G)})}function De(L){return L&&(L=L.replace(ne,"")),L}const he=/\\\[.*?\\\]/g;function fe(L){return De(L).replace(he,"")}e.$4f=String.fromCharCode(t.CharCode.UTF8_BOM);function be(L){return!!(L&&L.length>0&&L.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ge(L){return be(L)?L.substr(1):L}function we(L,G){if(!L||!G||L.length<G.length)return!1;const C=G.length,ue=L.toLowerCase();let me=0,ve=-1;for(;me<C;){const Te=ue.indexOf(G[me],ve+1);if(Te<0)return!1;ve=Te,me++}return!0}function ye(L,G=!1){return L?(G&&(L=L.replace(/\\./g,"")),L.toLowerCase()!==L):!1}function Re(L){return L.charAt(0).toUpperCase()+L.slice(1)}function Ie(L,G=1){if(G===0)return"";let C=-1;do C=L.indexOf(`
`,C+1),G--;while(G>0&&C>=0);return C===-1?L:(L[C-1]==="\r"&&C--,L.substr(0,C))}function Ue(L){const G=t.CharCode.Z-t.CharCode.A+1;return L=L%(2*G),L<G?String.fromCharCode(t.CharCode.a+L):String.fromCharCode(t.CharCode.A+L-G)}function pe(L){return Pe.getInstance().getGraphemeBreakType(L)}function Be(L,G){return L===Ae.Other?G!==Ae.Extend&&G!==Ae.SpacingMark:L===Ae.CR&&G===Ae.LF?!1:L===Ae.Control||L===Ae.CR||L===Ae.LF||G===Ae.Control||G===Ae.CR||G===Ae.LF?!0:!(L===Ae.L&&(G===Ae.L||G===Ae.V||G===Ae.LV||G===Ae.LVT)||(L===Ae.LV||L===Ae.V)&&(G===Ae.V||G===Ae.T)||(L===Ae.LVT||L===Ae.T)&&G===Ae.T||G===Ae.Extend||G===Ae.ZWJ||G===Ae.SpacingMark||L===Ae.Prepend||L===Ae.ZWJ&&G===Ae.Extended_Pictographic||L===Ae.Regional_Indicator&&G===Ae.Regional_Indicator)}var Ae;(function(L){L[L.Other=0]="Other",L[L.Prepend=1]="Prepend",L[L.CR=2]="CR",L[L.LF=3]="LF",L[L.Control=4]="Control",L[L.Extend=5]="Extend",L[L.Regional_Indicator=6]="Regional_Indicator",L[L.SpacingMark=7]="SpacingMark",L[L.L=8]="L",L[L.V=9]="V",L[L.T=10]="T",L[L.LV=11]="LV",L[L.LVT=12]="LVT",L[L.ZWJ=13]="ZWJ",L[L.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(e.GraphemeBreakType=Ae={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=je()}getGraphemeBreakType(G){if(G<32)return G===t.CharCode.LineFeed?Ae.LF:G===t.CharCode.CarriageReturn?Ae.CR:Ae.Control;if(G<127)return Ae.Other;const C=this.d,ue=C.length/3;let me=1;for(;me<=ue;)if(G<C[3*me])me=2*me;else if(G>C[3*me+1])me=2*me+1;else return C[3*me+2];return Ae.Other}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(L,G){if(L===0)return 0;const C=Ke(L,G);if(C!==void 0)return C;const ue=new j(G,L);return ue.prevCodePoint(),ue.offset}function Ke(L,G){const C=new j(G,L);let ue=C.prevCodePoint();for(;Je(ue)||ue===He.emojiVariantSelector||ue===He.enclosingKeyCap;){if(C.offset===0)return;ue=C.prevCodePoint()}if(!z(ue))return;let me=C.offset;return me>0&&C.prevCodePoint()===He.zwj&&(me=C.offset),me}function Je(L){return 127995<=L&&L<=127999}var He;(function(L){L[L.zwj=8205]="zwj",L[L.emojiVariantSelector=65039]="emojiVariantSelector",L[L.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.$bg="\xA0";class qe{static{this.c=new W.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new g.$$e({getCacheKey:JSON.stringify},G=>{function C(Oe){const Me=new Map;for(let Ne=0;Ne<Oe.length;Ne+=2)Me.set(Oe[Ne],Oe[Ne+1]);return Me}function ue(Oe,Me){const Ne=new Map(Oe);for(const[ze,Ve]of Me)Ne.set(ze,Ve);return Ne}function me(Oe,Me){if(!Oe)return Me;const Ne=new Map;for(const[ze,Ve]of Oe)Me.has(ze)&&Ne.set(ze,Ve);return Ne}const ve=this.c.value;let Te=G.filter(Oe=>!Oe.startsWith("_")&&Oe in ve);Te.length===0&&(Te=["_default"]);let Fe;for(const Oe of Te){const Me=C(ve[Oe]);Fe=me(Fe,Me)}const Se=C(ve._common),ke=ue(Se,Fe);return new qe(ke)})}static getInstance(G){return qe.d.get(Array.from(G))}static{this.e=new W.$W(()=>Object.keys(qe.c.value).filter(G=>!G.startsWith("_")))}static getLocales(){return qe.e.value}constructor(G){this.f=G}isAmbiguous(G){return this.f.has(G)}containsAmbiguousCharacter(G){for(let C=0;C<G.length;C++){const ue=G.codePointAt(C);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(G){return this.f.get(G)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=qe;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(G){return We.e().has(G)}static containsInvisibleCharacter(G){for(let C=0;C<G.length;C++){const ue=G.codePointAt(C);if(typeof ue=="number"&&We.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return We.e()}}e.$dg=We}),define(_e[28],Ee([0,1,12,11,7]),function(ae,e,g,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class M{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const r=o.charCodeAt(0),$=this.b.charCodeAt(this.c);return r-$}value(){return this.b[this.c]}}e.$Gi=M;class X{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,W.$zf)(o,this.b,0,o.length,this.c,this.d):(0,W.$Bf)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=X;class k{constructor(o=!0,r=!0){this.f=o,this.g=r}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let r=o.length-1;r>=0;r--,this.c--){const $=this.b.charCodeAt(r);if(!($===t.CharCode.Slash||this.f&&$===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,W.$zf)(o,this.b,0,o.length,this.d,this.e):(0,W.$Bf)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=k;var U;(function(F){F[F.Scheme=1]="Scheme",F[F.Authority=2]="Authority",F[F.Path=3]="Path",F[F.Query=4]="Query",F[F.Fragment=5]="Fragment"})(U||(U={}));class S{constructor(o,r){this.f=o,this.g=r,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(U.Scheme),this.c.authority&&this.d.push(U.Authority),this.c.path&&(this.b=new k(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(U.Path)),this.g(o)||(this.c.query&&this.d.push(U.Query),this.c.fragment&&this.d.push(U.Fragment)),this.e=0,this}next(){return this.d[this.e]===U.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===U.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===U.Scheme)return(0,W.$Af)(o,this.c.scheme);if(this.d[this.e]===U.Authority)return(0,W.$Af)(o,this.c.authority);if(this.d[this.e]===U.Path)return this.b.cmp(o);if(this.d[this.e]===U.Query)return(0,W.$yf)(o,this.c.query);if(this.d[this.e]===U.Fragment)return(0,W.$yf)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===U.Scheme)return this.c.scheme;if(this.d[this.e]===U.Authority)return this.c.authority;if(this.d[this.e]===U.Path)return this.b.value();if(this.d[this.e]===U.Query)return this.c.query;if(this.d[this.e]===U.Fragment)return this.c.fragment;throw new Error}}e.$Ji=S;class N{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(F){F[F.Left=-1]="Left",F[F.Mid=0]="Mid",F[F.Right=1]="Right"})(A||(A={}));class I{static forUris(o=()=>!1,r=()=>!1){return new I(new S(o,r))}static forPaths(o=!1){return new I(new k(void 0,!o))}static forStrings(){return new I(new M)}static forConfigKeys(){return new I(new X)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,r){if(r){const $=r.slice(0);(0,g.$Xb)($);for(const m of $)this.set(m,o)}else{const $=o.slice(0);(0,g.$Xb)($);for(const m of $)this.set(m[0],m[1])}}set(o,r){const $=this.b.reset(o);let m;this.c||(this.c=new N,this.c.segment=$.value());const f=[];for(m=this.c;;){const y=$.cmp(m.segment);if(y>0)m.left||(m.left=new N,m.left.segment=$.value()),f.push([A.Left,m]),m=m.left;else if(y<0)m.right||(m.right=new N,m.right.segment=$.value()),f.push([A.Right,m]),m=m.right;else if($.hasNext())$.next(),m.mid||(m.mid=new N,m.mid.segment=$.value()),f.push([A.Mid,m]),m=m.mid;else break}const _=m.value;m.value=r,m.key=o;for(let y=f.length-1;y>=0;y--){const s=f[y][1];s.updateHeight();const n=s.balanceFactor();if(n<-1||n>1){const i=f[y][0],l=f[y+1][0];if(i===A.Right&&l===A.Right)f[y][1]=s.rotateLeft();else if(i===A.Left&&l===A.Left)f[y][1]=s.rotateRight();else if(i===A.Right&&l===A.Left)s.right=f[y+1][1]=f[y+1][1].rotateRight(),f[y][1]=s.rotateLeft();else if(i===A.Left&&l===A.Right)s.left=f[y+1][1]=f[y+1][1].rotateLeft(),f[y][1]=s.rotateRight();else throw new Error;if(y>0)switch(f[y-1][0]){case A.Left:f[y-1][1].left=f[y][1];break;case A.Right:f[y-1][1].right=f[y][1];break;case A.Mid:f[y-1][1].mid=f[y][1];break}else this.c=f[0][1]}}return _}get(o){return this.d(o)?.value}d(o){const r=this.b.reset(o);let $=this.c;for(;$;){const m=r.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(r.hasNext())r.next(),$=$.mid;else break}return $}has(o){const r=this.d(o);return!(r?.value===void 0&&r?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,r){const $=this.b.reset(o),m=[];let f=this.c;for(;f;){const _=$.cmp(f.segment);if(_>0)m.push([A.Left,f]),f=f.left;else if(_<0)m.push([A.Right,f]),f=f.right;else if($.hasNext())$.next(),m.push([A.Mid,f]),f=f.mid;else break}if(f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const _=this.f(f.right);if(_.key){const{key:y,value:s,segment:n}=_;this.e(_.key,!1),f.key=y,f.value=s,f.segment=n}}else{const _=f.left??f.right;if(m.length>0){const[y,s]=m[m.length-1];switch(y){case A.Left:s.left=_;break;case A.Mid:s.mid=_;break;case A.Right:s.right=_;break}}else this.c=_}for(let _=m.length-1;_>=0;_--){const y=m[_][1];y.updateHeight();const s=y.balanceFactor();if(s>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),m[_][1]=y.rotateLeft()):s<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),m[_][1]=y.rotateRight()),_>0)switch(m[_-1][0]){case A.Left:m[_-1][1].left=m[_][1];break;case A.Right:m[_-1][1].right=m[_][1];break;case A.Mid:m[_-1][1].mid=m[_][1];break}else this.c=m[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const r=this.b.reset(o);let $=this.c,m;for(;$;){const f=r.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(r.hasNext())r.next(),m=$.value||m,$=$.mid;else break}return $&&$.value||m}findSuperstr(o){return this.g(o,!1)}g(o,r){const $=this.b.reset(o);let m=this.c;for(;m;){const f=$.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if($.hasNext())$.next(),m=m.mid;else return m.mid?this.h(m.mid):r?m.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[r,$]of this)o($,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const r=[];return this.j(o,r),r[Symbol.iterator]()}j(o,r){o&&(o.left&&this.j(o.left,r),o.value&&r.push([o.key,o.value]),o.mid&&this.j(o.mid,r),o.right&&this.j(o.right,r))}_isBalanced(){const o=r=>{if(!r)return!0;const $=r.balanceFactor();return $<-1||$>1?!1:o(r.left)&&o(r.right)};return o(this.c)}}e.$Ki=I}),define(_e[29],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kX=g;function g(t){return!!t.parentPort}}),define(_e[49],Ee([30,31]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(_e[50],Ee([0,1,12,10,49]),function(ae,e,g,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=U,e.$qj=S,e.$rj=N,g=Le(g),t=Le(t),W=Le(W);function M(A,I){return I&&(A.stack||A.stacktrace)?W.localize(0,null,k(A),X(A.stack)||X(A.stacktrace)):k(A)}function X(A){return Array.isArray(A)?A.join(`
`):A}function k(A){return A.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${A.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?W.localize(1,null,A.message):A.message||W.localize(2,null)}function U(A=null,I=!1){if(!A)return W.localize(3,null);if(Array.isArray(A)){const F=g.$Ib(A),o=U(F[0],I);return F.length>1?W.localize(4,null,o,F.length):o}if(t.$eg(A))return A;if(A.detail){const F=A.detail;if(F.error)return M(F.error,I);if(F.exception)return M(F.exception,I)}return A.stack?M(A,I):A.message?A.message:W.localize(5,null)}function S(A){const I=A;return I instanceof Error&&Array.isArray(I.actions)}function N(A,I){let F;return typeof A=="string"?F=new Error(A):F=A,F.actions=I,F}}),define(_e[51],Ee([30,31]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(_e[2],Ee([0,1,51]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=i,e.$D=u,e.$J=P,g=Le(g),e.$g="en";let t=!1,W=!1,M=!1,X=!1,k=!1,U=!1,S=!1,N=!1,A=!1,I=!1,F,o=e.$g,r=e.$g,$,m;const f=globalThis;let _;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?_=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(_=process);const y=typeof _?.versions?.electron=="string",s=y&&_?.type==="renderer";if(typeof _=="object"){t=_.platform==="win32",W=_.platform==="darwin",M=_.platform==="linux",X=M&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,S=y,A=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,F=e.$g,o=e.$g;const D=_.env.VSCODE_NLS_CONFIG;if(D)try{const b=JSON.parse(D),d=b.availableLanguages["*"];F=b.locale,r=b.osLocale,o=d||e.$g,$=b._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!s?(m=navigator.userAgent,t=m.indexOf("Windows")>=0,W=m.indexOf("Macintosh")>=0,N=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,I=m?.indexOf("Mobi")>=0,U=!0,F=g.getConfiguredDefaultLocale(g.localize(0,null))||e.$g,o=F,r=navigator.language):console.error("Unable to resolve platform.");var n;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(D){switch(D){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let l=n.Web;W?l=n.Mac:t?l=n.Windows:M&&(l=n.Linux),e.$i=t,e.$j=W,e.$k=M,e.$l=X,e.$m=k,e.$n=S,e.$o=U,e.$p=U&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=N,e.$s=I,e.$t=A,e.$u=l,e.$v=m,e.$w=o;var c;(function(D){function b(){return e.$w}D.value=b;function d(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}D.isDefaultVariant=d;function K(){return e.$w==="en"}D.isDefault=K})(c||(e.Language=c={})),e.$x=F,e.$y=r,e.$z=$,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const D=[];f.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let K=0,re=D.length;K<re;K++){const x=D[K];if(x.id===d.data.vscodeScheduleAsyncWork){D.splice(K,1),x.callback();return}}});let b=0;return d=>{const K=++b;D.push({id:K,callback:d}),f.postMessage({vscodeScheduleAsyncWork:K},"*")}}return D=>setTimeout(D)})();var T;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(T||(e.OperatingSystem=T={})),e.OS=W||N?T.Macintosh:t?T.Windows:T.Linux;let h=!0,w=!1;function u(){if(!w){w=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,h=new Uint16Array(D.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function P(D){return parseFloat(D)>=20}}),define(_e[32],Ee([0,1,2]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let t;const W=globalThis.vscode;if(typeof W<"u"&&typeof W.process<"u"){const M=W.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return g.$i?"win32":g.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$ec=t.platform,e.$fc=t.arch}),define(_e[3],Ee([0,1,32]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,g=Le(g);const t=65,W=97,M=90,X=122,k=46,U=47,S=92,N=58,A=63;class I extends Error{constructor(i,l,c){let T;typeof l=="string"&&l.indexOf("not ")===0?(T="must not be",l=l.replace(/^not /,"")):T="must be";const h=i.indexOf(".")!==-1?"property":"argument";let w=`The "${i}" ${h} ${T} of type ${l}`;w+=`. Received type ${typeof c}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function F(n,i){if(n===null||typeof n!="object")throw new I(i,"Object",n)}function o(n,i){if(typeof n!="string")throw new I(i,"string",n)}const r=g.$ec==="win32";function $(n){return n===U||n===S}function m(n){return n===U}function f(n){return n>=t&&n<=M||n>=W&&n<=X}function _(n,i,l,c){let T="",h=0,w=-1,u=0,P=0;for(let D=0;D<=n.length;++D){if(D<n.length)P=n.charCodeAt(D);else{if(c(P))break;P=U}if(c(P)){if(!(w===D-1||u===1))if(u===2){if(T.length<2||h!==2||T.charCodeAt(T.length-1)!==k||T.charCodeAt(T.length-2)!==k){if(T.length>2){const b=T.lastIndexOf(l);b===-1?(T="",h=0):(T=T.slice(0,b),h=T.length-1-T.lastIndexOf(l)),w=D,u=0;continue}else if(T.length!==0){T="",h=0,w=D,u=0;continue}}i&&(T+=T.length>0?`${l}..`:"..",h=2)}else T.length>0?T+=`${l}${n.slice(w+1,D)}`:T=n.slice(w+1,D),h=D-w-1;w=D,u=0}else P===k&&u!==-1?++u:u=-1}return T}function y(n,i){F(i,"pathObject");const l=i.dir||i.root,c=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${c}`:`${l}${n}${c}`:c}e.$gc={resolve(...n){let i="",l="",c=!1;for(let T=n.length-1;T>=-1;T--){let h;if(T>=0){if(h=n[T],o(h,"path"),h.length===0)continue}else i.length===0?h=g.cwd():(h=g.env[`=${i}`]||g.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==i.toLowerCase()&&h.charCodeAt(2)===S)&&(h=`${i}\\`));const w=h.length;let u=0,P="",D=!1;const b=h.charCodeAt(0);if(w===1)$(b)&&(u=1,D=!0);else if($(b))if(D=!0,$(h.charCodeAt(1))){let d=2,K=d;for(;d<w&&!$(h.charCodeAt(d));)d++;if(d<w&&d!==K){const re=h.slice(K,d);for(K=d;d<w&&$(h.charCodeAt(d));)d++;if(d<w&&d!==K){for(K=d;d<w&&!$(h.charCodeAt(d));)d++;(d===w||d!==K)&&(P=`\\\\${re}\\${h.slice(K,d)}`,u=d)}}}else u=1;else f(b)&&h.charCodeAt(1)===N&&(P=h.slice(0,2),u=2,w>2&&$(h.charCodeAt(2))&&(D=!0,u=3));if(P.length>0)if(i.length>0){if(P.toLowerCase()!==i.toLowerCase())continue}else i=P;if(c){if(i.length>0)break}else if(l=`${h.slice(u)}\\${l}`,c=D,D&&i.length>0)break}return l=_(l,!c,"\\",$),c?`${i}\\${l}`:`${i}${l}`||"."},normalize(n){o(n,"path");const i=n.length;if(i===0)return".";let l=0,c,T=!1;const h=n.charCodeAt(0);if(i===1)return m(h)?"\\":n;if($(h))if(T=!0,$(n.charCodeAt(1))){let u=2,P=u;for(;u<i&&!$(n.charCodeAt(u));)u++;if(u<i&&u!==P){const D=n.slice(P,u);for(P=u;u<i&&$(n.charCodeAt(u));)u++;if(u<i&&u!==P){for(P=u;u<i&&!$(n.charCodeAt(u));)u++;if(u===i)return`\\\\${D}\\${n.slice(P)}\\`;u!==P&&(c=`\\\\${D}\\${n.slice(P,u)}`,l=u)}}}else l=1;else f(h)&&n.charCodeAt(1)===N&&(c=n.slice(0,2),l=2,i>2&&$(n.charCodeAt(2))&&(T=!0,l=3));let w=l<i?_(n.slice(l),!T,"\\",$):"";return w.length===0&&!T&&(w="."),w.length>0&&$(n.charCodeAt(i-1))&&(w+="\\"),c===void 0?T?`\\${w}`:w:T?`${c}\\${w}`:`${c}${w}`},isAbsolute(n){o(n,"path");const i=n.length;if(i===0)return!1;const l=n.charCodeAt(0);return $(l)||i>2&&f(l)&&n.charCodeAt(1)===N&&$(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,l;for(let h=0;h<n.length;++h){const w=n[h];o(w,"path"),w.length>0&&(i===void 0?i=l=w:i+=`\\${w}`)}if(i===void 0)return".";let c=!0,T=0;if(typeof l=="string"&&$(l.charCodeAt(0))){++T;const h=l.length;h>1&&$(l.charCodeAt(1))&&(++T,h>2&&($(l.charCodeAt(2))?++T:c=!1))}if(c){for(;T<i.length&&$(i.charCodeAt(T));)T++;T>=2&&(i=`\\${i.slice(T)}`)}return e.$gc.normalize(i)},relative(n,i){if(o(n,"from"),o(i,"to"),n===i)return"";const l=e.$gc.resolve(n),c=e.$gc.resolve(i);if(l===c||(n=l.toLowerCase(),i=c.toLowerCase(),n===i))return"";let T=0;for(;T<n.length&&n.charCodeAt(T)===S;)T++;let h=n.length;for(;h-1>T&&n.charCodeAt(h-1)===S;)h--;const w=h-T;let u=0;for(;u<i.length&&i.charCodeAt(u)===S;)u++;let P=i.length;for(;P-1>u&&i.charCodeAt(P-1)===S;)P--;const D=P-u,b=w<D?w:D;let d=-1,K=0;for(;K<b;K++){const x=n.charCodeAt(T+K);if(x!==i.charCodeAt(u+K))break;x===S&&(d=K)}if(K!==b){if(d===-1)return c}else{if(D>b){if(i.charCodeAt(u+K)===S)return c.slice(u+K+1);if(K===2)return c.slice(u+K)}w>b&&(n.charCodeAt(T+K)===S?d=K:K===2&&(d=3)),d===-1&&(d=0)}let re="";for(K=T+d+1;K<=h;++K)(K===h||n.charCodeAt(K)===S)&&(re+=re.length===0?"..":"\\..");return u+=d,re.length>0?`${re}${c.slice(u,P)}`:(c.charCodeAt(u)===S&&++u,c.slice(u,P))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$gc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===S){if(i.charCodeAt(1)===S){const l=i.charCodeAt(2);if(l!==A&&l!==k)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(f(i.charCodeAt(0))&&i.charCodeAt(1)===N&&i.charCodeAt(2)===S)return`\\\\?\\${i}`;return n},dirname(n){o(n,"path");const i=n.length;if(i===0)return".";let l=-1,c=0;const T=n.charCodeAt(0);if(i===1)return $(T)?n:".";if($(T)){if(l=c=1,$(n.charCodeAt(1))){let u=2,P=u;for(;u<i&&!$(n.charCodeAt(u));)u++;if(u<i&&u!==P){for(P=u;u<i&&$(n.charCodeAt(u));)u++;if(u<i&&u!==P){for(P=u;u<i&&!$(n.charCodeAt(u));)u++;if(u===i)return n;u!==P&&(l=c=u+1)}}}}else f(T)&&n.charCodeAt(1)===N&&(l=i>2&&$(n.charCodeAt(2))?3:2,c=l);let h=-1,w=!0;for(let u=i-1;u>=c;--u)if($(n.charCodeAt(u))){if(!w){h=u;break}}else w=!1;if(h===-1){if(l===-1)return".";h=l}return n.slice(0,h)},basename(n,i){i!==void 0&&o(i,"ext"),o(n,"path");let l=0,c=-1,T=!0,h;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===N&&(l=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let w=i.length-1,u=-1;for(h=n.length-1;h>=l;--h){const P=n.charCodeAt(h);if($(P)){if(!T){l=h+1;break}}else u===-1&&(T=!1,u=h+1),w>=0&&(P===i.charCodeAt(w)?--w===-1&&(c=h):(w=-1,c=u))}return l===c?c=u:c===-1&&(c=n.length),n.slice(l,c)}for(h=n.length-1;h>=l;--h)if($(n.charCodeAt(h))){if(!T){l=h+1;break}}else c===-1&&(T=!1,c=h+1);return c===-1?"":n.slice(l,c)},extname(n){o(n,"path");let i=0,l=-1,c=0,T=-1,h=!0,w=0;n.length>=2&&n.charCodeAt(1)===N&&f(n.charCodeAt(0))&&(i=c=2);for(let u=n.length-1;u>=i;--u){const P=n.charCodeAt(u);if($(P)){if(!h){c=u+1;break}continue}T===-1&&(h=!1,T=u+1),P===k?l===-1?l=u:w!==1&&(w=1):l!==-1&&(w=-1)}return l===-1||T===-1||w===0||w===1&&l===T-1&&l===c+1?"":n.slice(l,T)},format:y.bind(null,"\\"),parse(n){o(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.length;let c=0,T=n.charCodeAt(0);if(l===1)return $(T)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if($(T)){if(c=1,$(n.charCodeAt(1))){let d=2,K=d;for(;d<l&&!$(n.charCodeAt(d));)d++;if(d<l&&d!==K){for(K=d;d<l&&$(n.charCodeAt(d));)d++;if(d<l&&d!==K){for(K=d;d<l&&!$(n.charCodeAt(d));)d++;d===l?c=d:d!==K&&(c=d+1)}}}}else if(f(T)&&n.charCodeAt(1)===N){if(l<=2)return i.root=i.dir=n,i;if(c=2,$(n.charCodeAt(2))){if(l===3)return i.root=i.dir=n,i;c=3}}c>0&&(i.root=n.slice(0,c));let h=-1,w=c,u=-1,P=!0,D=n.length-1,b=0;for(;D>=c;--D){if(T=n.charCodeAt(D),$(T)){if(!P){w=D+1;break}continue}u===-1&&(P=!1,u=D+1),T===k?h===-1?h=D:b!==1&&(b=1):h!==-1&&(b=-1)}return u!==-1&&(h===-1||b===0||b===1&&h===u-1&&h===w+1?i.base=i.name=n.slice(w,u):(i.name=n.slice(w,h),i.base=n.slice(w,u),i.ext=n.slice(h,u))),w>0&&w!==c?i.dir=n.slice(0,w-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(r){const n=/\\/g;return()=>{const i=g.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>g.cwd()})();e.$hc={resolve(...n){let i="",l=!1;for(let c=n.length-1;c>=-1&&!l;c--){const T=c>=0?n[c]:s();o(T,"path"),T.length!==0&&(i=`${T}/${i}`,l=T.charCodeAt(0)===U)}return i=_(i,!l,"/",m),l?`/${i}`:i.length>0?i:"."},normalize(n){if(o(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U,l=n.charCodeAt(n.length-1)===U;return n=_(n,!i,"/",m),n.length===0?i?"/":l?"./":".":(l&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return o(n,"path"),n.length>0&&n.charCodeAt(0)===U},join(...n){if(n.length===0)return".";let i;for(let l=0;l<n.length;++l){const c=n[l];o(c,"path"),c.length>0&&(i===void 0?i=c:i+=`/${c}`)}return i===void 0?".":e.$hc.normalize(i)},relative(n,i){if(o(n,"from"),o(i,"to"),n===i||(n=e.$hc.resolve(n),i=e.$hc.resolve(i),n===i))return"";const l=1,c=n.length,T=c-l,h=1,w=i.length-h,u=T<w?T:w;let P=-1,D=0;for(;D<u;D++){const d=n.charCodeAt(l+D);if(d!==i.charCodeAt(h+D))break;d===U&&(P=D)}if(D===u)if(w>u){if(i.charCodeAt(h+D)===U)return i.slice(h+D+1);if(D===0)return i.slice(h+D)}else T>u&&(n.charCodeAt(l+D)===U?P=D:D===0&&(P=0));let b="";for(D=l+P+1;D<=c;++D)(D===c||n.charCodeAt(D)===U)&&(b+=b.length===0?"..":"/..");return`${b}${i.slice(h+P)}`},toNamespacedPath(n){return n},dirname(n){if(o(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U;let l=-1,c=!0;for(let T=n.length-1;T>=1;--T)if(n.charCodeAt(T)===U){if(!c){l=T;break}}else c=!1;return l===-1?i?"/":".":i&&l===1?"//":n.slice(0,l)},basename(n,i){i!==void 0&&o(i,"ext"),o(n,"path");let l=0,c=-1,T=!0,h;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let w=i.length-1,u=-1;for(h=n.length-1;h>=0;--h){const P=n.charCodeAt(h);if(P===U){if(!T){l=h+1;break}}else u===-1&&(T=!1,u=h+1),w>=0&&(P===i.charCodeAt(w)?--w===-1&&(c=h):(w=-1,c=u))}return l===c?c=u:c===-1&&(c=n.length),n.slice(l,c)}for(h=n.length-1;h>=0;--h)if(n.charCodeAt(h)===U){if(!T){l=h+1;break}}else c===-1&&(T=!1,c=h+1);return c===-1?"":n.slice(l,c)},extname(n){o(n,"path");let i=-1,l=0,c=-1,T=!0,h=0;for(let w=n.length-1;w>=0;--w){const u=n.charCodeAt(w);if(u===U){if(!T){l=w+1;break}continue}c===-1&&(T=!1,c=w+1),u===k?i===-1?i=w:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||c===-1||h===0||h===1&&i===c-1&&i===l+1?"":n.slice(i,c)},format:y.bind(null,"/"),parse(n){o(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.charCodeAt(0)===U;let c;l?(i.root="/",c=1):c=0;let T=-1,h=0,w=-1,u=!0,P=n.length-1,D=0;for(;P>=c;--P){const b=n.charCodeAt(P);if(b===U){if(!u){h=P+1;break}continue}w===-1&&(u=!1,w=P+1),b===k?T===-1?T=P:D!==1&&(D=1):T!==-1&&(D=-1)}if(w!==-1){const b=h===0&&l?1:h;T===-1||D===0||D===1&&T===w-1&&T===h+1?i.base=i.name=n.slice(b,w):(i.name=n.slice(b,T),i.base=n.slice(b,w),i.ext=n.slice(T,w))}return h>0?i.dir=n.slice(0,h-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=r?e.$gc.normalize:e.$hc.normalize,e.$jc=r?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=r?e.$gc.join:e.$hc.join,e.$lc=r?e.$gc.resolve:e.$hc.resolve,e.$mc=r?e.$gc.relative:e.$hc.relative,e.$nc=r?e.$gc.dirname:e.$hc.dirname,e.$oc=r?e.$gc.basename:e.$hc.basename,e.$pc=r?e.$gc.extname:e.$hc.extname,e.$qc=r?e.$gc.format:e.$hc.format,e.$rc=r?e.$gc.parse:e.$hc.parse,e.$sc=r?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=r?e.$gc.sep:e.$hc.sep,e.$uc=r?e.$gc.delimiter:e.$hc.delimiter}),define(_e[14],Ee([0,1,11,3,2,7,10]),function(ae,e,g,t,W,M,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=k,e.$xg=U,e.$yg=S,e.$zg=N,e.$Ag=A,e.$Bg=r,e.$Cg=$,e.$Dg=m,e.$Eg=f,e.$Fg=_,e.$Gg=y,e.$Hg=s,e.$Ig=n,e.$Jg=i,e.$Kg=l,e.$Lg=c,e.$Mg=w;function k(u){return u===g.CharCode.Slash||u===g.CharCode.Backslash}function U(u){return u.replace(/[\\/]/g,t.$hc.sep)}function S(u){return u.indexOf("/")===-1&&(u=U(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function N(u,P=t.$hc.sep){if(!u)return"";const D=u.length,b=u.charCodeAt(0);if(k(b)){if(k(u.charCodeAt(1))&&!k(u.charCodeAt(2))){let K=3;const re=K;for(;K<D&&!k(u.charCodeAt(K));K++);if(re!==K&&!k(u.charCodeAt(K+1))){for(K+=1;K<D;K++)if(k(u.charCodeAt(K)))return u.slice(0,K+1).replace(/[\\/]/g,P)}}return P}else if(f(b)&&u.charCodeAt(1)===g.CharCode.Colon)return k(u.charCodeAt(2))?u.slice(0,2)+P:u.slice(0,2);let d=u.indexOf("://");if(d!==-1){for(d+=3;d<D;d++)if(k(u.charCodeAt(d)))return u.slice(0,d+1)}return""}function A(u){if(!W.$i||!u||u.length<5)return!1;let P=u.charCodeAt(0);if(P!==g.CharCode.Backslash||(P=u.charCodeAt(1),P!==g.CharCode.Backslash))return!1;let D=2;const b=D;for(;D<u.length&&(P=u.charCodeAt(D),P!==g.CharCode.Backslash);D++);return!(b===D||(P=u.charCodeAt(D+1),isNaN(P)||P===g.CharCode.Backslash))}const I=/[\\/:\*\?"<>\|]/g,F=/[/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(u,P=W.$i){const D=P?I:F;return!(!u||u.length===0||/^\s+$/.test(u)||(D.lastIndex=0,D.test(u))||P&&o.test(u)||u==="."||u===".."||P&&u[u.length-1]==="."||P&&u.length!==u.trim().length||u.length>255)}function $(u,P,D){const b=u===P;return!D||b?b:!u||!P?!1:(0,M.$Ff)(u,P)}function m(u,P,D,b=t.sep){if(u===P)return!0;if(!u||!P||P.length>u.length)return!1;if(D){if(!(0,M.$Gf)(u,P))return!1;if(P.length===u.length)return!0;let K=P.length;return P.charAt(P.length-1)===b&&K--,u.charAt(K)===b}return P.charAt(P.length-1)!==b&&(P+=b),u.indexOf(P)===0}function f(u){return u>=g.CharCode.A&&u<=g.CharCode.Z||u>=g.CharCode.a&&u<=g.CharCode.z}function _(u,P){return W.$i&&u.endsWith(":")&&(u+=t.sep),(0,t.$jc)(u)||(u=(0,t.$kc)(P,u)),u=(0,t.$ic)(u),y(u)}function y(u){return W.$i?(u=(0,M.$nf)(u,t.sep),u.endsWith(":")&&(u+=t.sep)):(u=(0,M.$nf)(u,t.sep),u||(u=t.sep)),u}function s(u){const P=(0,t.$ic)(u);return W.$i?u.length>3?!1:n(P)&&(u.length===2||P.charCodeAt(2)===g.CharCode.Backslash):P===t.$hc.sep}function n(u,P=W.$i){return P?f(u.charCodeAt(0))&&u.charCodeAt(1)===g.CharCode.Colon:!1}function i(u,P=W.$i){return n(u,P)?u[0]:void 0}function l(u,P,D){return P.length>u.length?-1:u===P?0:(D&&(u=u.toLowerCase(),P=P.toLowerCase()),u.indexOf(P))}function c(u){const P=u.split(":");let D,b,d;for(const K of P){const re=Number(K);(0,X.$ig)(re)?b===void 0?b=re:d===void 0&&(d=re):D=D?[D,K].join(":"):K}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:b!==void 0?b:void 0,column:d!==void 0?d:b!==void 0?1:void 0}}const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(u,P,D=8){let b="";for(let K=0;K<D;K++){let re;K===0&&W.$i&&!P&&(D===3||D===4)?re=h:re=T,b+=re.charAt(Math.floor(Math.random()*re.length))}let d;return P?d=`${P}-${b}`:d=b,u?(0,t.$kc)(u,d):d}}),define(_e[33],Ee([0,1,2]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=M,e.$km=X;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t||(e.Source=t={}));var W;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(W||(e.TerminateResponseCode=W={}));function M(k,...U){const S=U.reduce((I,F)=>(I[F]=!0,I),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(I=>!S[I]).forEach(I=>{for(let F=0;F<N.length;F++)if(I.search(N[F])!==-1){delete k[I];break}})}function X(k){k&&(delete k.DEBUG,g.$j&&delete k.DYLD_LIBRARY_PATH,g.$k&&delete k.LD_PRELOAD)}}),define(_e[5],Ee([0,1,11,27,3,2]),function(ae,e,g,t,W,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=$,e.$xc=n,W=Le(W);const X=/^\w[\w\d+.-]*$/,k=/^\//,U=/^\/\//;function S(h,w){if(!h.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!X.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!k.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function N(h,w){return!h&&!w?"file":h}function A(h,w){switch(h){case"https":case"http":case"file":w?w[0]!==F&&(w=F+w):w=F;break}return w}const I="",F="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(w){return w instanceof r?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,u,P,D,b,d=!1){typeof w=="object"?(this.scheme=w.scheme||I,this.authority=w.authority||I,this.path=w.path||I,this.query=w.query||I,this.fragment=w.fragment||I):(this.scheme=N(w,d),this.authority=u||I,this.path=A(this.scheme,P||I),this.query=D||I,this.fragment=b||I,S(this,d))}get fsPath(){return n(this,!1)}with(w){if(!w)return this;let{scheme:u,authority:P,path:D,query:b,fragment:d}=w;return u===void 0?u=this.scheme:u===null&&(u=I),P===void 0?P=this.authority:P===null&&(P=I),D===void 0?D=this.path:D===null&&(D=I),b===void 0?b=this.query:b===null&&(b=I),d===void 0?d=this.fragment:d===null&&(d=I),u===this.scheme&&P===this.authority&&D===this.path&&b===this.query&&d===this.fragment?this:new f(u,P,D,b,d)}static parse(w,u=!1){const P=o.exec(w);return P?new f(P[2]||I,T(P[4]||I),T(P[5]||I),T(P[7]||I),T(P[9]||I),u):new f(I,I,I,I,I)}static file(w){let u=I;if(M.$i&&(w=w.replace(/\\/g,F)),w[0]===F&&w[1]===F){const P=w.indexOf(F,2);P===-1?(u=w.substring(2),w=F):(u=w.substring(2,P),w=w.substring(P)||F)}return new f("file",u,w,I,I)}static from(w,u){return new f(w.scheme,w.authority,w.path,w.query,w.fragment,u)}static joinPath(w,...u){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return M.$i&&w.scheme==="file"?P=r.file(W.$gc.join(n(w,!0),...u)).path:P=W.$hc.join(w.path,...u),w.with({path:P})}toString(w=!1){return i(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof r)return w;{const u=new f(w);return u._formatted=w.external??null,u._fsPath=w._sep===m?w.fsPath??null:null,u}}else return w}}e.URI=r;function $(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const m=M.$i?1:void 0;class f extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(w=!1){return w?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const w={$mid:t.MarshalledId.Uri};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=m),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const _={[g.CharCode.Colon]:"%3A",[g.CharCode.Slash]:"%2F",[g.CharCode.QuestionMark]:"%3F",[g.CharCode.Hash]:"%23",[g.CharCode.OpenSquareBracket]:"%5B",[g.CharCode.CloseSquareBracket]:"%5D",[g.CharCode.AtSign]:"%40",[g.CharCode.ExclamationMark]:"%21",[g.CharCode.DollarSign]:"%24",[g.CharCode.Ampersand]:"%26",[g.CharCode.SingleQuote]:"%27",[g.CharCode.OpenParen]:"%28",[g.CharCode.CloseParen]:"%29",[g.CharCode.Asterisk]:"%2A",[g.CharCode.Plus]:"%2B",[g.CharCode.Comma]:"%2C",[g.CharCode.Semicolon]:"%3B",[g.CharCode.Equals]:"%3D",[g.CharCode.Space]:"%20"};function y(h,w,u){let P,D=-1;for(let b=0;b<h.length;b++){const d=h.charCodeAt(b);if(d>=g.CharCode.a&&d<=g.CharCode.z||d>=g.CharCode.A&&d<=g.CharCode.Z||d>=g.CharCode.Digit0&&d<=g.CharCode.Digit9||d===g.CharCode.Dash||d===g.CharCode.Period||d===g.CharCode.Underline||d===g.CharCode.Tilde||w&&d===g.CharCode.Slash||u&&d===g.CharCode.OpenSquareBracket||u&&d===g.CharCode.CloseSquareBracket||u&&d===g.CharCode.Colon)D!==-1&&(P+=encodeURIComponent(h.substring(D,b)),D=-1),P!==void 0&&(P+=h.charAt(b));else{P===void 0&&(P=h.substr(0,b));const K=_[d];K!==void 0?(D!==-1&&(P+=encodeURIComponent(h.substring(D,b)),D=-1),P+=K):D===-1&&(D=b)}}return D!==-1&&(P+=encodeURIComponent(h.substring(D))),P!==void 0?P:h}function s(h){let w;for(let u=0;u<h.length;u++){const P=h.charCodeAt(u);P===g.CharCode.Hash||P===g.CharCode.QuestionMark?(w===void 0&&(w=h.substr(0,u)),w+=_[P]):w!==void 0&&(w+=h[u])}return w!==void 0?w:h}function n(h,w){let u;return h.authority&&h.path.length>1&&h.scheme==="file"?u=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===g.CharCode.Slash&&(h.path.charCodeAt(1)>=g.CharCode.A&&h.path.charCodeAt(1)<=g.CharCode.Z||h.path.charCodeAt(1)>=g.CharCode.a&&h.path.charCodeAt(1)<=g.CharCode.z)&&h.path.charCodeAt(2)===g.CharCode.Colon?w?u=h.path.substr(1):u=h.path[1].toLowerCase()+h.path.substr(2):u=h.path,M.$i&&(u=u.replace(/\//g,"\\")),u}function i(h,w){const u=w?s:y;let P="",{scheme:D,authority:b,path:d,query:K,fragment:re}=h;if(D&&(P+=D,P+=":"),(b||D==="file")&&(P+=F,P+=F),b){let x=b.indexOf("@");if(x!==-1){const V=b.substr(0,x);b=b.substr(x+1),x=V.lastIndexOf(":"),x===-1?P+=u(V,!1,!1):(P+=u(V.substr(0,x),!1,!1),P+=":",P+=u(V.substr(x+1),!1,!0)),P+="@"}b=b.toLowerCase(),x=b.lastIndexOf(":"),x===-1?P+=u(b,!1,!0):(P+=u(b.substr(0,x),!1,!0),P+=b.substr(x))}if(d){if(d.length>=3&&d.charCodeAt(0)===g.CharCode.Slash&&d.charCodeAt(2)===g.CharCode.Colon){const x=d.charCodeAt(1);x>=g.CharCode.A&&x<=g.CharCode.Z&&(d=`/${String.fromCharCode(x+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===g.CharCode.Colon){const x=d.charCodeAt(0);x>=g.CharCode.A&&x<=g.CharCode.Z&&(d=`${String.fromCharCode(x+32)}:${d.substr(2)}`)}P+=u(d,!0,!1)}return K&&(P+="?",P+=u(K,!1,!1)),re&&(P+="#",P+=w?re:y(re,!1,!1)),P}function l(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+l(h.substr(3)):h}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(h){return h.match(c)?h.replace(c,w=>l(w)):h}}),define(_e[52],Ee([0,1,5]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=t,e.$0q=W,e.$$q=M,e.log=k;function t(S){const N=S;return N&&typeof N.type=="string"&&typeof N.severity=="string"}function W(S){const N=[];let A;try{const I=JSON.parse(S.arguments),F=I[I.length-1];F&&F.__$stack&&(I.pop(),A=F.__$stack),N.push(...I)}catch{N.push("Unable to log remote console arguments",S.arguments)}return{args:N,stack:A}}function M(S){if(typeof S!="string")return M(W(S).stack);const N=S;if(N){const A=X(N),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(A||"");if(I&&I.length===4)return{uri:g.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}function X(S){if(!S)return S;const N=S.indexOf(`
`);return N===-1?S:S.substring(0,N)}function k(S,N){const{args:A,stack:I}=W(S),F=typeof A[0]=="string"&&A.length===1;let o=X(I);o&&(o=`(${o.trim()})`);let r=[];if(typeof A[0]=="string"?o&&F?r=[`%c[${N}] %c${A[0]} %c${o}`,U("blue"),U(""),U("grey")]:r=[`%c[${N}] %c${A[0]}`,U("blue"),U(""),...A.slice(1)]:r=[`%c[${N}]%`,U("blue"),...A],o&&!F&&r.push(o),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,r)}function U(S){return`color: ${S}`}}),define(_e[53],Ee([0,1,16,5,27]),function(ae,e,g,t,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=M,e.$ai=X,e.$bi=U;function M(S){return JSON.stringify(S,k)}function X(S){let N=JSON.parse(S);return N=U(N),N}function k(S,N){return N instanceof RegExp?{$mid:W.MarshalledId.Regexp,source:N.source,flags:N.flags}:N}function U(S,N=0){if(!S||N>200)return S;if(typeof S=="object"){switch(S.$mid){case W.MarshalledId.Uri:return t.URI.revive(S);case W.MarshalledId.Regexp:return new RegExp(S.source,S.flags);case W.MarshalledId.Date:return new Date(S.source)}if(S instanceof g.$Ne||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let A=0;A<S.length;++A)S[A]=U(S[A],N+1);else for(const A in S)Object.hasOwnProperty.call(S,A)&&(S[A]=U(S[A],N+1))}return S}}),define(_e[34],Ee([0,1,9,2,7,5,3]),function(ae,e,g,t,W,M,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=U,e.$Og=S,e.$Sg=A,g=Le(g),t=Le(t),X=Le(X);var k;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",o.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm",o.commentsInput="comment",o.codeSetting="code-setting"})(k||(e.Schemas=k={}));function U(o,r){return M.URI.isUri(o)?(0,W.$Ff)(o.scheme,r):(0,W.$Gf)(o,r+":")}function S(o,...r){return r.some($=>U(o,$))}e.$Pg="vscode-tkn",e.$Qg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,$){this.f=A(r,$)}getServerRootPath(){return this.f}get g(){return X.$hc.join(this.f,k.vscodeRemoteResource)}set(r,$,m){this.a[r]=$,this.b[r]=m}setConnectionToken(r,$){this.c[r]=$}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(s){return g.$2(s),r}const $=r.authority;let m=this.a[$];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const f=this.b[$],_=this.c[$];let y=`path=${encodeURIComponent(r.path)}`;return typeof _=="string"&&(y+=`&${e.$Qg}=${encodeURIComponent(_)}`),M.URI.from({scheme:t.$o?this.d:k.vscodeRemoteResource,authority:`${m}:${f}`,path:this.g,query:y})}}e.$Rg=new N;function A(o,r){return X.$hc.join(r??"/",`${o.quality??"oss"}-${o.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class I{static{this.a=e.$Xg}asBrowserUri(r){const $=this.b(r,ae);return this.uriToBrowserUri($)}uriToBrowserUri(r){return r.scheme===k.vscodeRemote?e.$Rg.rewrite(r):r.scheme===k.file&&(t.$m||t.$q===`${k.vscodeFileResource}://${I.a}`)?r.with({scheme:k.vscodeFileResource,authority:r.authority||I.a,query:null,fragment:null}):r}asFileUri(r){const $=this.b(r,ae);return this.uriToFileUri($)}uriToFileUri(r){return r.scheme===k.vscodeFileResource?r.with({scheme:k.file,authority:r.authority!==I.a?r.authority:null,query:null,fragment:null}):r}b(r,$){return M.URI.isUri(r)?r:M.URI.parse($.toUrl(r))}}e.$Yg=new I;var F;(function(o){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(r.get("3"));const $="vscode-coi";function m(_){let y;typeof _=="string"?y=new URL(_).searchParams:_ instanceof URL?y=_.searchParams:M.URI.isUri(_)&&(y=new URL(_.toString(!0)).searchParams);const s=y?.get($);if(s)return r.get(s)}o.getHeadersFromQuery=m;function f(_,y,s){if(!globalThis.crossOriginIsolated)return;const n=y&&s?"3":s?"2":"1";_ instanceof URLSearchParams?_.set($,n):_[$]=n}o.addSearchParam=f})(F||(e.COI=F={}))}),define(_e[22],Ee([0,1,11,14,34,3,2,7,5]),function(ae,e,g,t,W,M,X,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=S,e.$oh=A,e.$ph=F,t=Le(t),M=Le(M);function S(o){return(0,U.$xc)(o,!0)}class N{constructor(r){this.a=r}compare(r,$,m=!1){return r===$?0:(0,k.$yf)(this.getComparisonKey(r,m),this.getComparisonKey($,m))}isEqual(r,$,m=!1){return r===$?!0:!r||!$?!1:this.getComparisonKey(r,m)===this.getComparisonKey($,m)}getComparisonKey(r,$=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:$?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,$,m=!1){if(r.scheme===$.scheme){if(r.scheme===W.Schemas.file)return t.$Dg(S(r),S($),this.a(r))&&r.query===$.query&&(m||r.fragment===$.fragment);if((0,e.$kh)(r.authority,$.authority))return t.$Dg(r.path,$.path,this.a(r),"/")&&r.query===$.query&&(m||r.fragment===$.fragment)}return!1}joinPath(r,...$){return U.URI.joinPath(r,...$)}basenameOrAuthority(r){return(0,e.$ch)(r)||r.authority}basename(r){return M.$hc.basename(r.path)}extname(r){return M.$hc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let $;return r.scheme===W.Schemas.file?$=U.URI.file(M.$nc(S(r))).path:($=M.$hc.dirname(r.path),r.authority&&$.length&&$.charCodeAt(0)!==g.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),$="/")),r.with({path:$})}normalizePath(r){if(!r.path.length)return r;let $;return r.scheme===W.Schemas.file?$=U.URI.file(M.$ic(S(r))).path:$=M.$hc.normalize(r.path),r.with({path:$})}relativePath(r,$){if(r.scheme!==$.scheme||!(0,e.$kh)(r.authority,$.authority))return;if(r.scheme===W.Schemas.file){const _=M.$mc(S(r),S($));return X.$i?t.$xg(_):_}let m=r.path||"/";const f=$.path||"/";if(this.a(r)){let _=0;for(const y=Math.min(m.length,f.length);_<y&&!(m.charCodeAt(_)!==f.charCodeAt(_)&&m.charAt(_).toLowerCase()!==f.charAt(_).toLowerCase());_++);m=f.substr(0,_)+m.substr(_)}return M.$hc.relative(m,f)}resolvePath(r,$){if(r.scheme===W.Schemas.file){const m=U.URI.file(M.$lc(S(r),$));return r.with({authority:m.authority,path:m.path})}return $=t.$yg($),r.with({path:M.$hc.resolve(r.path,$)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,$){return r===$||r!==void 0&&$!==void 0&&(0,k.$Ff)(r,$)}hasTrailingPathSeparator(r,$=M.sep){if(r.scheme===W.Schemas.file){const m=S(r);return m.length>t.$zg(m).length&&m[m.length-1]===$}else{const m=r.path;return m.length>1&&m.charCodeAt(m.length-1)===g.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,$=M.sep){return(0,e.$lh)(r,$)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,$=M.sep){let m=!1;if(r.scheme===W.Schemas.file){const f=S(r);m=f!==void 0&&f.length===t.$zg(f).length&&f[f.length-1]===$}else{$="/";const f=r.path;m=f.length===1&&f.charCodeAt(f.length-1)===g.CharCode.Slash}return!m&&!(0,e.$lh)(r,$)?r.with({path:r.path+"/"}):r}}e.$7g=N,e.$8g=new N(()=>!1),e.$9g=new N(o=>o.scheme===W.Schemas.file?!X.$k:!0),e.$0g=new N(o=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function A(o,r){const $=[];for(let m=0;m<o.length;m++){const f=r(o[m]);o.some((_,y)=>y===m?!1:(0,e.$_g)(f,r(_)))||$.push(o[m])}return $}var I;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function r($){const m=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach(y=>{const[s,n]=y.split(":");s&&n&&m.set(s,n)});const _=$.path.substring(0,$.path.indexOf(";"));return _&&m.set(o.META_DATA_MIME,_),m}o.parseMetaData=r})(I||(e.DataUri=I={}));function F(o,r,$){if(r){let m=o.path;return m&&m[0]!==M.$hc.sep&&(m=M.$hc.sep+m),o.with({scheme:$,authority:r,path:m})}return o.with({scheme:$})}}),define(_e[8],Ee([0,1,13,9,6,4,22,2,46,15]),function(ae,e,g,t,W,M,X,k,U,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=N,e.$rh=A,e.$sh=I,e.$th=F,e.$uh=o,e.$vh=r,e.$wh=$,e.$xh=m,e.$Fh=h,e.$Gh=w,e.$Hh=u,e.$Ih=P,e.$Jh=D,e.$Yh=a,e.$7h=q;function N(B){return!!B&&typeof B.then=="function"}function A(B){const E=new g.$we,z=B(E.token),J=new Promise((ne,$e)=>{const De=E.token.onCancellationRequested(()=>{De.dispose(),$e(new t.$6)});Promise.resolve(z).then(he=>{De.dispose(),E.dispose(),ne(he)},he=>{De.dispose(),E.dispose(),$e(he)})});return new class{cancel(){E.cancel(),E.dispose()}then(ne,$e){return J.then(ne,$e)}catch(ne){return this.then(void 0,ne)}finally(ne){return J.finally(ne)}}}function I(B,E,z){return new Promise((J,ne)=>{const $e=E.onCancellationRequested(()=>{$e.dispose(),J(z)});B.then(J,ne).finally(()=>$e.dispose())})}function F(B,E){return new Promise((z,J)=>{const ne=E.onCancellationRequested(()=>{ne.dispose(),J(new t.$6)});B.then(z,J).finally(()=>ne.dispose())})}async function o(B){let E=-1;const z=B.map((J,ne)=>J.then($e=>(E=ne,$e)));try{return await Promise.race(z)}finally{B.forEach((J,ne)=>{ne!==E&&J.cancel()})}}function r(B,E,z){let J;const ne=setTimeout(()=>{J?.(void 0),z?.()},E);return Promise.race([B.finally(()=>clearTimeout(ne)),new Promise($e=>J=$e)])}function $(B){return new Promise((E,z)=>{const J=B();N(J)?J.then(E,z):E(J)})}function m(){let B,E;return{promise:new Promise((J,ne)=>{B=J,E=ne}),resolve:B,reject:E}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(E){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=E,!this.b){const z=()=>{if(this.b=null,this.f)return;const J=this.queue(this.d);return this.d=null,J};this.b=new Promise(J=>{this.a.then(z,z).then(J)})}return new Promise((z,J)=>{this.b.then(z,J)})}return this.a=E(),new Promise((z,J)=>{this.a.then(ne=>{this.a=null,z(ne)},ne=>{this.a=null,J(ne)})})}dispose(){this.f=!0}}e.$yh=f;class _{constructor(){this.a=Promise.resolve(null)}queue(E){return this.a=this.a.then(()=>E(),()=>E())}}e.$zh=_;class y{constructor(){this.a=new Map}queue(E,z){const ne=(this.a.get(E)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(E)===ne&&this.a.delete(E)});return this.a.set(E,ne),ne}}e.$Ah=y;const s=(B,E)=>{let z=!0;const J=setTimeout(()=>{z=!1,E()},B);return{isTriggered:()=>z,dispose:()=>{clearTimeout(J),z=!1}}},n=B=>{let E=!0;return queueMicrotask(()=>{E&&(E=!1,B())}),{isTriggered:()=>E,dispose:()=>{E=!1}}};class i{constructor(E){this.defaultDelay=E,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(E,z=this.defaultDelay){this.g=E,this.h(),this.b||(this.b=new Promise((ne,$e)=>{this.d=ne,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const J=()=>{this.a=null,this.d?.(null)};return this.a=z===U.$ge?n(J):s(z,J),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=i;class l{constructor(E){this.a=new i(E),this.b=new f}trigger(E,z){return this.a.trigger(()=>this.b.queue(E),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=l;class c{constructor(){this.a=!1,this.b=new Promise((E,z)=>{this.d=E})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=c;class T extends c{constructor(E){super(),this.f=setTimeout(()=>this.open(),E)}open(){clearTimeout(this.f),super.open()}}e.$Eh=T;function h(B,E){return E?new Promise((z,J)=>{const ne=setTimeout(()=>{$e.dispose(),z()},B),$e=E.onCancellationRequested(()=>{clearTimeout(ne),$e.dispose(),J(new t.$6)})}):A(z=>h(B,z))}function w(B,E=0,z){const J=setTimeout(()=>{B(),z&&ne.dispose()},E),ne=(0,M.$Tc)(()=>{clearTimeout(J),z?.deleteAndLeak(ne)});return z?.add(ne),ne}function u(B){const E=[];let z=0;const J=B.length;function ne(){return z<J?B[z++]():null}function $e(De){De!=null&&E.push(De);const he=ne();return he?he.then($e):Promise.resolve(E)}return Promise.resolve(null).then($e)}function P(B,E=J=>!!J,z=null){let J=0;const ne=B.length,$e=()=>{if(J>=ne)return Promise.resolve(z);const De=B[J++];return Promise.resolve(De()).then(fe=>E(fe)?Promise.resolve(fe):$e())};return $e()}function D(B,E=J=>!!J,z=null){if(B.length===0)return Promise.resolve(z);let J=B.length;const ne=()=>{J=-1;for(const $e of B)$e.cancel?.()};return new Promise(($e,De)=>{for(const he of B)he.then(fe=>{--J>=0&&E(fe)?(ne(),$e(fe)):J===0&&$e(z)}).catch(fe=>{--J>=0&&(ne(),De(fe))})})}class b{constructor(E){this.a=0,this.b=!1,this.f=E,this.g=[],this.d=0,this.h=new W.$le}whenIdle(){return this.size>0?W.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(E){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((z,J)=>{this.g.push({factory:E,c:z,e:J}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const E=this.g.shift();this.d++;const z=E.factory();z.then(E.c,E.e),z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=b;class d extends b{constructor(){super(1)}}e.$Lh=d;class K{constructor(){this.a=new O,this.b=0}queue(E){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,E())):this.a.run(this.b++,E())}}e.$Mh=K;class re{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const E=new v;return this.b.add(E),E.p}g(){for(const[,E]of this.a)if(E.size>0)return!1;return!0}queueSize(E,z=X.$8g){const J=z.getComparisonKey(E);return this.a.get(J)?.size??0}queueFor(E,z,J=X.$8g){const ne=J.getComparisonKey(E);let $e=this.a.get(ne);if(!$e){$e=new d;const De=this.f++,he=W.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$5c),this.d.set(De,he),this.a.set(ne,$e)}return $e.queue(z)}h(){this.g()&&this.j()}j(){for(const E of this.b)E.complete();this.b.clear()}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=re;class x{constructor(E,z){this.b=!1,this.a=-1,typeof E=="function"&&typeof z=="number"&&this.setIfNotSet(E,z)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(E,z){if(this.b)throw new t.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,E()},z)}setIfNotSet(E,z){if(this.b)throw new t.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,E()},z))}}e.$Oh=x;class V{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(E,z,J=globalThis){if(this.f)throw new t.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=J.setInterval(()=>{E()},z);this.d=(0,M.$Tc)(()=>{J.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=V;class se{constructor(E,z){this.b=-1,this.a=E,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(E=this.d){this.cancel(),this.b=setTimeout(this.f,E)}get delay(){return this.d}set delay(E){this.d=E}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=se;class Q{constructor(E,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=E,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(E=this.b){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(E/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=Q;class te extends se{constructor(E,z){super(E,z),this.j=[]}work(E){this.j.push(E),this.isScheduled()||this.schedule()}h(){const E=this.j;this.j=[],this.a?.(E)}dispose(){this.j=[],super.dispose()}}e.$Sh=te;class oe extends M.$Vc{constructor(E,z){super(),this.g=E,this.h=z,this.a=[],this.b=this.B(new M.$Wc),this.f=!1}get pending(){return this.a.length}work(E){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+E.length>this.g.maxBufferedWork)return!1}else if(this.pending+E.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of E)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(B,E)=>{(0,k.$B)(()=>{if(z)return;const J=Date.now()+15;E(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.$Vh=(B,E,z)=>{const J=B.requestIdleCallback(E,typeof z=="number"?{timeout:z}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,B.cancelIdleCallback(J))}}},e.$Uh=B=>(0,e.$Vh)(globalThis,B)}();class ce{constructor(E,z){this.g=!1,this.d=()=>{try{this.j=z()}catch(J){this.l=J}finally{this.g=!0}},this.f=(0,e.$Vh)(E,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ce;class R extends ce{constructor(E){super(globalThis,E)}}e.$Xh=R;async function a(B,E,z){let J;for(let ne=0;ne<z;ne++)try{return await B()}catch($e){J=$e,await h(E)}throw J}class O{isRunning(E){return typeof E=="number"?this.a?.taskId===E:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(E,z,J){return this.a={taskId:E,cancel:()=>J?.(),promise:z},z.then(()=>this.d(E),()=>this.d(E)),z}d(E){this.a&&E===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const E=this.b;this.b=void 0,E.run().then(E.promiseResolve,E.promiseReject)}}queue(E){if(this.b)this.b.run=E;else{const{promise:z,resolve:J,reject:ne}=m();this.b={run:E,promise:z,promiseResolve:J,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=O;class j{constructor(E,z=()=>Date.now()){this.d=E,this.f=z,this.a=0,this.b=0}increment(){const E=this.f();return E-this.a>this.d&&(this.a=E,this.b=0),this.b++,this.b}}e.$1h=j;var Y;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(Y||(Y={}));class v{get isRejected(){return this.d?.outcome===Y.Rejected}get isResolved(){return this.d?.outcome===Y.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Y.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((E,z)=>{this.a=E,this.b=z})}complete(E){return new Promise(z=>{this.a(E),this.d={outcome:Y.Resolved,value:E},z()})}error(E){return new Promise(z=>{this.b(E),this.d={outcome:Y.Rejected,value:E},z()})}cancel(){return this.error(new t.$6)}}e.$2h=v;var Z;(function(B){async function E(J){let ne;const $e=await Promise.all(J.map(De=>De.then(he=>he,he=>{ne||(ne=he)})));if(typeof ne<"u")throw ne;return $e}B.settled=E;function z(J){return new Promise(async(ne,$e)=>{try{await J(ne,$e)}catch(De){$e(De)}})}B.withAsyncBody=z})(Z||(e.Promises=Z={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(E){this.a=void 0,this.b=void 0,this.d=!1,this.promise=E.then(z=>(this.a=z,this.d=!0,z),z=>{throw this.b=z,this.d=!0,z})}requireValue(){if(!this.d)throw new t.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=ee;class ie{constructor(E){this.b=E,this.a=new S.$W(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=ie;var le;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(le||(le={}));class de{static fromArray(E){return new de(z=>{z.emitMany(E)})}static fromPromise(E){return new de(async z=>{z.emitMany(await E)})}static fromPromises(E){return new de(async z=>{await Promise.all(E.map(async J=>z.emitOne(await J)))})}static merge(E){return new de(async z=>{await Promise.all(E.map(async J=>{for await(const ne of J)z.emitOne(ne)}))})}static{this.EMPTY=de.fromArray([])}constructor(E,z){this.a=le.Initial,this.b=[],this.d=null,this.f=z,this.g=new W.$le,queueMicrotask(async()=>{const J={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(E(J)),this.k()}catch(ne){this.l(ne)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let E=0;return{next:async()=>{do{if(this.a===le.DoneError)throw this.d;if(E<this.b.length)return{done:!1,value:this.b[E++]};if(this.a===le.DoneOK)return{done:!0,value:void 0};await W.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(E,z){return new de(async J=>{for await(const ne of E)J.emitOne(z(ne))})}map(E){return de.map(this,E)}static filter(E,z){return new de(async J=>{for await(const ne of E)z(ne)&&J.emitOne(ne)})}filter(E){return de.filter(this,E)}static coalesce(E){return de.filter(E,z=>!!z)}coalesce(){return de.coalesce(this)}static async toPromise(E){const z=[];for await(const J of E)z.push(J);return z}toPromise(){return de.toPromise(this)}h(E){this.a===le.Initial&&(this.b.push(E),this.g.fire())}j(E){this.a===le.Initial&&(this.b=this.b.concat(E),this.g.fire())}k(){this.a===le.Initial&&(this.a=le.DoneOK,this.g.fire())}l(E){this.a===le.Initial&&(this.a=le.DoneError,this.d=E,this.g.fire())}}e.$5h=de;class p extends de{constructor(E,z){super(z),this.m=E}cancel(){this.m.cancel()}}e.$6h=p;function q(B){const E=new g.$we,z=B(E.token);return new p(E,async J=>{const ne=E.token.onCancellationRequested(()=>{ne.dispose(),E.dispose(),J.reject(new t.$6)});try{for await(const $e of z){if(E.token.isCancellationRequested)return;J.emitOne($e)}ne.dispose(),E.dispose()}catch($e){ne.dispose(),E.dispose(),J.reject($e)}})}class H{constructor(E){this.a=new v,this.b=new de(ne=>{if(z){ne.reject(z);return}return J&&ne.emitMany(J),this.d=$e=>ne.reject($e),this.f=$e=>ne.emitOne($e),this.a.p},E);let z,J;this.f=ne=>{J||(J=[]),J.push(ne)},this.d=ne=>{z||(z=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(E){this.d(E),this.a.complete()}emitOne(E){this.f(E)}}e.$8h=H}),define(_e[23],Ee([0,1,12,8,11,14,20,3,2,7]),function(ae,e,g,t,W,M,X,k,U,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=N,e.$wk=r,e.$xk=K,e.$yk=re,e.$zk=x,e.$Ak=V,e.$Bk=se,e.$Ck=ce;function N(){return Object.create(null)}e.$uk="**",e.$vk="/";const A="[/\\\\]",I="[^/\\\\]",F=/\//g;function o(R,a){switch(R){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${a?`|${A}${I}+`:""})*?`}}function r(R,a){if(!R)return[];const O=[];let j=!1,Y=!1,v="";for(const Z of R){switch(Z){case a:if(!j&&!Y){O.push(v),v="";continue}break;case"{":j=!0;break;case"}":j=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}v+=Z}return v&&O.push(v),O}function $(R){if(!R)return"";let a="";const O=r(R,e.$vk);if(O.every(j=>j===e.$uk))a=".*";else{let j=!1;O.forEach((Y,v)=>{if(Y===e.$uk){if(j)return;a+=o(2,v===O.length-1)}else{let Z=!1,ee="",ie=!1,le="";for(const de of Y){if(de!=="}"&&Z){ee+=de;continue}if(ie&&(de!=="]"||!le)){let p;de==="-"?p=de:(de==="^"||de==="!")&&!le?p="^":de===e.$vk?p="":p=(0,S.$hf)(de),le+=p;continue}switch(de){case"{":Z=!0;continue;case"[":ie=!0;continue;case"}":{const q=`(?:${r(ee,",").map(H=>$(H)).join("|")})`;a+=q,Z=!1,ee="";break}case"]":{a+="["+le+"]",ie=!1,le="";break}case"?":a+=I;continue;case"*":a+=o(1);continue;default:a+=(0,S.$hf)(de)}}v<O.length-1&&(O[v+1]!==e.$uk||v+2<O.length)&&(a+=A)}j=Y===e.$uk})}return a}const m=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new X.$Ec(1e4),l=function(){return!1},c=function(){return null};function T(R,a){if(!R)return c;let O;typeof R!="string"?O=R.pattern:O=R,O=O.trim();const j=`${O}_${!!a.trimForExclusions}`;let Y=i.get(j);if(Y)return h(Y,R);let v;return m.test(O)?Y=u(O.substr(4),O):(v=f.exec(w(O,a)))?Y=P(v[1],O):(a.trimForExclusions?y:_).test(O)?Y=D(O,a):(v=s.exec(w(O,a)))?Y=b(v[1].substr(1),O,!0):(v=n.exec(w(O,a)))?Y=b(v[1],O,!1):Y=d(O),i.set(j,Y),h(Y,R)}function h(R,a){if(typeof a=="string")return R;const O=function(j,Y){return(0,M.$Dg)(j,a.base,!U.$k)?R((0,S.$mf)(j.substr(a.base.length),k.sep),Y):null};return O.allBasenames=R.allBasenames,O.allPaths=R.allPaths,O.basenames=R.basenames,O.patterns=R.patterns,O}function w(R,a){return a.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function u(R,a){return function(O,j){return typeof O=="string"&&O.endsWith(R)?a:null}}function P(R,a){const O=`/${R}`,j=`\\${R}`,Y=function(Z,ee){return typeof Z!="string"?null:ee?ee===R?a:null:Z===R||Z.endsWith(O)||Z.endsWith(j)?a:null},v=[R];return Y.basenames=v,Y.patterns=[a],Y.allBasenames=v,Y}function D(R,a){const O=oe(R.slice(1,-1).split(",").map(ee=>T(ee,a)).filter(ee=>ee!==c),R),j=O.length;if(!j)return c;if(j===1)return O[0];const Y=function(ee,ie){for(let le=0,de=O.length;le<de;le++)if(O[le](ee,ie))return R;return null},v=O.find(ee=>!!ee.allBasenames);v&&(Y.allBasenames=v.allBasenames);const Z=O.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return Z.length&&(Y.allPaths=Z),Y}function b(R,a,O){const j=k.sep===k.$hc.sep,Y=j?R:R.replace(F,k.sep),v=k.sep+Y,Z=k.$hc.sep+R;let ee;return O?ee=function(ie,le){return typeof ie=="string"&&(ie===Y||ie.endsWith(v)||!j&&(ie===R||ie.endsWith(Z)))?a:null}:ee=function(ie,le){return typeof ie=="string"&&(ie===Y||!j&&ie===R)?a:null},ee.allPaths=[(O?"*/":"./")+R],ee}function d(R){try{const a=new RegExp(`^${$(R)}$`);return function(O){return a.lastIndex=0,typeof O=="string"&&a.test(O)?R:null}}catch{return c}}function K(R,a,O){return!R||typeof a!="string"?!1:re(R)(a,void 0,O)}function re(R,a={}){if(!R)return l;if(typeof R=="string"||x(R)){const O=T(R,a);if(O===c)return l;const j=function(Y,v){return!!O(Y,v)};return O.allBasenames&&(j.allBasenames=O.allBasenames),O.allPaths&&(j.allPaths=O.allPaths),j}return Q(R,a)}function x(R){const a=R;return a?typeof a.base=="string"&&typeof a.pattern=="string":!1}function V(R){return R.allBasenames||[]}function se(R){return R.allPaths||[]}function Q(R,a){const O=oe(Object.getOwnPropertyNames(R).map(ee=>te(ee,R[ee],a)).filter(ee=>ee!==c)),j=O.length;if(!j)return c;if(!O.some(ee=>!!ee.requiresSiblings)){if(j===1)return O[0];const ee=function(de,p){let q;for(let H=0,B=O.length;H<B;H++){const E=O[H](de,p);if(typeof E=="string")return E;(0,t.$qh)(E)&&(q||(q=[]),q.push(E))}return q?(async()=>{for(const H of q){const B=await H;if(typeof B=="string")return B}return null})():null},ie=O.find(de=>!!de.allBasenames);ie&&(ee.allBasenames=ie.allBasenames);const le=O.reduce((de,p)=>p.allPaths?de.concat(p.allPaths):de,[]);return le.length&&(ee.allPaths=le),ee}const Y=function(ee,ie,le){let de,p;for(let q=0,H=O.length;q<H;q++){const B=O[q];B.requiresSiblings&&le&&(ie||(ie=(0,k.$oc)(ee)),de||(de=ie.substr(0,ie.length-(0,k.$pc)(ee).length)));const E=B(ee,ie,de,le);if(typeof E=="string")return E;(0,t.$qh)(E)&&(p||(p=[]),p.push(E))}return p?(async()=>{for(const q of p){const H=await q;if(typeof H=="string")return H}return null})():null},v=O.find(ee=>!!ee.allBasenames);v&&(Y.allBasenames=v.allBasenames);const Z=O.reduce((ee,ie)=>ie.allPaths?ee.concat(ie.allPaths):ee,[]);return Z.length&&(Y.allPaths=Z),Y}function te(R,a,O){if(a===!1)return c;const j=T(R,O);if(j===c)return c;if(typeof a=="boolean")return j;if(a){const Y=a.when;if(typeof Y=="string"){const v=(Z,ee,ie,le)=>{if(!le||!j(Z,ee))return null;const de=Y.replace("$(basename)",()=>ie),p=le(de);return(0,t.$qh)(p)?p.then(q=>q?R:null):p?R:null};return v.requiresSiblings=!0,v}}return j}function oe(R,a){const O=R.filter(ee=>!!ee.basenames);if(O.length<2)return R;const j=O.reduce((ee,ie)=>{const le=ie.basenames;return le?ee.concat(le):ee},[]);let Y;if(a){Y=[];for(let ee=0,ie=j.length;ee<ie;ee++)Y.push(a)}else Y=O.reduce((ee,ie)=>{const le=ie.patterns;return le?ee.concat(le):ee},[]);const v=function(ee,ie){if(typeof ee!="string")return null;if(!ie){let de;for(de=ee.length;de>0;de--){const p=ee.charCodeAt(de-1);if(p===W.CharCode.Slash||p===W.CharCode.Backslash)break}ie=ee.substr(de)}const le=j.indexOf(ie);return le!==-1?Y[le]:null};v.basenames=j,v.patterns=Y,v.allBasenames=j;const Z=R.filter(ee=>!ee.basenames);return Z.push(v),Z}function ce(R,a){return(0,g.$vb)(R,a,(O,j)=>typeof O=="string"&&typeof j=="string"?O===j:typeof O!="string"&&typeof j!="string"?O.base===j.base&&O.pattern===j.pattern:!1)}}),define(_e[24],Ee([0,1,17,54,64,8,14,21,3,2,22,5]),function(ae,e,g,t,W,M,X,k,U,S,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=_,e.whenDeleted=n,e.configureFlushOnWrite=h,e.writeFileSync=u,g=Le(g);var I;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(I||(e.RimRafMode=I={}));async function F(Q,te=I.UNLINK,oe){if((0,X.$Hg)(Q))throw new Error("rimraf - will refuse to recursively delete root");return te===I.UNLINK?r(Q):o(Q,oe)}async function o(Q,te=(0,X.$Mg)((0,t.tmpdir)())){try{try{await g.promises.rename(Q,te)}catch(oe){return oe.code==="ENOENT"?void 0:r(Q)}r(te).catch(oe=>{})}catch(oe){if(oe.code!=="ENOENT")throw oe}}async function r(Q){return g.promises.rm(Q,{recursive:!0,force:!0,maxRetries:3})}function $(Q){if((0,X.$Hg)(Q))throw new Error("rimraf - will refuse to recursively delete root");g.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}async function m(Q,te){return y(await(te?f(Q):g.promises.readdir(Q)))}async function f(Q){try{return await g.promises.readdir(Q,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const te=[],oe=await m(Q);for(const ce of oe){let R=!1,a=!1,O=!1;try{const j=await e.Promises.lstat((0,U.$kc)(Q,ce));R=j.isFile(),a=j.isDirectory(),O=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}te.push({name:ce,isFile:()=>R,isDirectory:()=>a,isSymbolicLink:()=>O})}return te}function _(Q){return y(g.readdirSync(Q))}function y(Q){return Q.map(te=>typeof te=="string"?S.$j?(0,k.$lm)(te):te:(te.name=S.$j?(0,k.$lm)(te.name):te.name,te))}async function s(Q){const te=await m(Q),oe=[];for(const ce of te)await i.existsDirectory((0,U.$kc)(Q,ce))&&oe.push(ce);return oe}function n(Q,te=1e3){return new Promise(oe=>{let ce=!1;const R=setInterval(()=>{ce||(ce=!0,g.access(Q,a=>{ce=!1,a&&(clearInterval(R),oe(void 0))}))},te)})}var i;(function(Q){async function te(R){let a;try{if(a=await e.Promises.lstat(R),!a.isSymbolicLink())return{stat:a}}catch{}try{return{stat:await e.Promises.stat(R),symbolicLink:a?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};if(S.$i&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(R)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};throw j}throw O}}Q.stat=te;async function oe(R){try{const{stat:a,symbolicLink:O}=await Q.stat(R);return a.isFile()&&O?.dangling!==!0}catch{}return!1}Q.existsFile=oe;async function ce(R){try{const{stat:a,symbolicLink:O}=await Q.stat(R);return a.isDirectory()&&O?.dangling!==!0}catch{}return!1}Q.existsDirectory=ce})(i||(e.SymlinkSupport=i={}));const l=new M.$Nh;function c(Q,te,oe){return l.queueFor(A.URI.file(Q),()=>{const ce=P(oe);return new Promise((R,a)=>w(Q,te,ce,O=>O?a(O):R()))},N.$9g)}let T=!0;function h(Q){T=Q}function w(Q,te,oe,ce){if(!T)return g.writeFile(Q,te,{mode:oe.mode,flag:oe.flag},ce);g.open(Q,oe.flag,oe.mode,(R,a)=>{if(R)return ce(R);g.writeFile(a,te,O=>{if(O)return g.close(a,()=>ce(O));g.fdatasync(a,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),h(!1)),g.close(a,Y=>ce(Y))))})})}function u(Q,te,oe){const ce=P(oe);if(!T)return g.writeFileSync(Q,te,{mode:ce.mode,flag:ce.flag});const R=g.openSync(Q,ce.flag,ce.mode);try{g.writeFileSync(R,te);try{g.fdatasyncSync(R)}catch(a){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",a),h(!1)}}finally{g.closeSync(R)}}function P(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function D(Q,te,oe=6e4){if(Q!==te)try{S.$i&&typeof oe=="number"?await b(Q,te,Date.now(),oe):await g.promises.rename(Q,te)}catch(ce){if(Q.toLowerCase()!==te.toLowerCase()&&ce.code==="EXDEV"||Q.endsWith("."))await d(Q,te,{preserveSymlinks:!1}),await F(Q,I.MOVE);else throw ce}}async function b(Q,te,oe,ce,R=0){try{return await g.promises.rename(Q,te)}catch(a){if(a.code!=="EACCES"&&a.code!=="EPERM"&&a.code!=="EBUSY")throw a;if(Date.now()-oe>=ce)throw console.error(`[node.js fs] rename failed after ${R} retries with error: ${a}`),a;if(R===0){let O=!1;try{const{stat:j}=await i.stat(te);j.isFile()||(O=!0)}catch{}if(O)throw a}return await(0,M.$Fh)(Math.min(100,R*10)),b(Q,te,oe,ce,R+1)}}async function d(Q,te,oe){return re(Q,te,{root:{source:Q,target:te},options:oe,handledSourcePaths:new Set})}const K=511;async function re(Q,te,oe){if(oe.handledSourcePaths.has(Q))return;oe.handledSourcePaths.add(Q);const{stat:ce,symbolicLink:R}=await i.stat(Q);if(R){if(oe.options.preserveSymlinks)try{return await se(Q,te,oe)}catch{}if(R.dangling)return}return ce.isDirectory()?x(Q,te,ce.mode&K,oe):V(Q,te,ce.mode&K)}async function x(Q,te,oe,ce){await e.Promises.mkdir(te,{recursive:!0,mode:oe});const R=await m(Q);for(const a of R)await re((0,U.$kc)(Q,a),(0,U.$kc)(te,a),ce)}async function V(Q,te,oe){await e.Promises.copyFile(Q,te),await e.Promises.chmod(te,oe)}async function se(Q,te,oe){let ce=await e.Promises.readlink(Q);(0,X.$Dg)(ce,oe.root.source,!S.$k)&&(ce=(0,U.$kc)(oe.root.target,ce.substr(oe.root.source.length+1))),await e.Promises.symlink(ce,te)}e.Promises=new class{get access(){return g.promises.access}get stat(){return g.promises.stat}get lstat(){return g.promises.lstat}get utimes(){return g.promises.utimes}get read(){return(Q,te,oe,ce,R)=>new Promise((a,O)=>{g.read(Q,te,oe,ce,R,(j,Y,v)=>j?O(j):a({bytesRead:Y,buffer:v}))})}get readFile(){return g.promises.readFile}get write(){return(Q,te,oe,ce,R)=>new Promise((a,O)=>{g.write(Q,te,oe,ce,R,(j,Y,v)=>j?O(j):a({bytesWritten:Y,buffer:v}))})}get appendFile(){return g.promises.appendFile}get fdatasync(){return(0,W.promisify)(g.fdatasync)}get truncate(){return g.promises.truncate}get copyFile(){return g.promises.copyFile}get open(){return(0,W.promisify)(g.open)}get close(){return(0,W.promisify)(g.close)}get symlink(){return g.promises.symlink}get readlink(){return g.promises.readlink}get chmod(){return g.promises.chmod}get mkdir(){return g.promises.mkdir}get unlink(){return g.promises.unlink}get rmdir(){return g.promises.rmdir}get realpath(){return(0,W.promisify)(g.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return s}get writeFile(){return c}get rm(){return F}get rename(){return D}get copy(){return d}}}),define(_e[35],Ee([0,1,17,3,2,7,24]),function(ae,e,g,t,W,M,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=k,e.$fr=U,e.$gr=S,e.$hr=N,g=Le(g);function k(I){if(W.$k)return I;const F=(0,t.$nc)(I);if(I===F)return I;const o=((0,t.$oc)(I)||I).toLowerCase();try{const $=(0,X.readdirSync)(F).filter(m=>m.toLowerCase()===o);if($.length===1){const m=k(F);if(m)return(0,t.$kc)(m,$[0])}else if($.length>1){const m=$.indexOf(o);if(m>=0){const f=k(F);if(f)return(0,t.$kc)(f,$[m])}}}catch{}return null}async function U(I,F){if(W.$k)return I;const o=(0,t.$nc)(I);if(I===o)return I;const r=((0,t.$oc)(I)||I).toLowerCase();try{if(F?.isCancellationRequested)return null;const m=(await X.Promises.readdir(o)).filter(f=>f.toLowerCase()===r);if(m.length===1){const f=await U(o,F);if(f)return(0,t.$kc)(f,m[0])}else if(m.length>1){const f=m.indexOf(r);if(f>=0){const _=await U(o,F);if(_)return(0,t.$kc)(_,m[f])}}}catch{}return null}async function S(I){try{return await X.Promises.realpath(I)}catch{const o=A(I);return await X.Promises.access(o,g.constants.R_OK),o}}function N(I){try{return g.realpathSync(I)}catch{const o=A(I);return g.accessSync(o,g.constants.R_OK),o}}function A(I){return(0,M.$nf)((0,t.$ic)(I),t.sep)}}),define(_e[55],Ee([0,1,3,2,32,33,10,24]),function(ae,e,g,t,W,M,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=U,e.$xm=S,g=Le(g),t=Le(t),W=Le(W),X=Le(X),k=Le(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function U(A=W.env){return A.comspec||"cmd.exe"}function S(A){let I=[],F=!1;const o=function(r){if(F){I.push(r);return}(!A.send(r,m=>{if(m&&console.error(m),F=!1,I.length>0){const f=I.slice(0);I=[],f.forEach(_=>o(_))}})||t.$i)&&(F=!0)};return{send:o}}var N;(function(A){async function I(F,o,r){if(g.$jc(F))return F;if(o===void 0&&(o=W.cwd()),g.$nc(F)!=="."||(r===void 0&&X.$eg(W.env.PATH)&&(r=W.env.PATH.split(g.$uc)),r===void 0||r.length===0))return g.$kc(o,F);async function m(f){if(await k.Promises.exists(f)){let _;try{_=await k.Promises.stat(f)}catch(y){y.message.startsWith("EACCES")&&(_=await k.Promises.lstat(f))}return _?!_.isDirectory():!1}return!1}for(const f of r){let _;if(g.$jc(f)?_=g.$kc(f,F):_=g.$kc(o,f,F),await m(_))return _;let y=_+".com";if(await m(y)||(y=_+".exe",await m(y)))return y}return g.$kc(o,F)}A.findExecutable=I})(N||(e.win32=N={}))});var Ye=this&&this.__decorate||function(ae,e,g,t){var W=arguments.length,M=W<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,g):t,X;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ae,e,g,t);else for(var k=ae.length-1;k>=0;k--)(X=ae[k])&&(M=(W<3?X(M):W>3?X(e,g,M):X(e,g))||M);return W>3&&M&&Object.defineProperty(e,g,M),M};define(_e[25],Ee([0,1,12,8,16,13,40,9,6,4,53,7,10]),function(ae,e,g,t,W,M,X,k,U,S,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=h,e.$fi=w,e.$ki=K,e.$li=re,A=Le(A);var F;(function(R){R[R.Promise=100]="Promise",R[R.PromiseCancel=101]="PromiseCancel",R[R.EventListen=102]="EventListen",R[R.EventDispose=103]="EventDispose"})(F||(F={}));function o(R){switch(R){case F.Promise:return"req";case F.PromiseCancel:return"cancel";case F.EventListen:return"subscribe";case F.EventDispose:return"unsubscribe"}}var r;(function(R){R[R.Initialize=200]="Initialize",R[R.PromiseSuccess=201]="PromiseSuccess",R[R.PromiseError=202]="PromiseError",R[R.PromiseErrorObj=203]="PromiseErrorObj",R[R.EventFire=204]="EventFire"})(r||(r={}));function $(R){switch(R){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var m;(function(R){R[R.Uninitialized=0]="Uninitialized",R[R.Idle=1]="Idle"})(m||(m={}));function f(R){let a=0;for(let O=0;;O+=7){const j=R.read(1);if(a|=(j.buffer[0]&127)<<O,!(j.buffer[0]&128))return a}}const _=l(0);function y(R,a){if(a===0){R.write(_);return}let O=0;for(let Y=a;Y!==0;Y=Y>>>7)O++;const j=W.$Ne.alloc(O);for(let Y=0;a!==0;Y++)j.buffer[Y]=a&127,a=a>>>7,a>0&&(j.buffer[Y]|=128);R.write(j)}class s{constructor(a){this.b=a,this.a=0}read(a){const O=this.b.slice(this.a,this.a+a);return this.a+=O.byteLength,O}}e.$ci=s;class n{constructor(){this.a=[]}get buffer(){return W.$Ne.concat(this.a)}write(a){this.a.push(a)}}e.$di=n;var i;(function(R){R[R.Undefined=0]="Undefined",R[R.String=1]="String",R[R.Buffer=2]="Buffer",R[R.VSBuffer=3]="VSBuffer",R[R.Array=4]="Array",R[R.Object=5]="Object",R[R.Int=6]="Int"})(i||(i={}));function l(R){const a=W.$Ne.alloc(1);return a.writeUInt8(R,0),a}const c={Undefined:l(i.Undefined),String:l(i.String),Buffer:l(i.Buffer),VSBuffer:l(i.VSBuffer),Array:l(i.Array),Object:l(i.Object),Uint:l(i.Int)},T=typeof Buffer<"u";function h(R,a){if(typeof a>"u")R.write(c.Undefined);else if(typeof a=="string"){const O=W.$Ne.fromString(a);R.write(c.String),y(R,O.byteLength),R.write(O)}else if(T&&Buffer.isBuffer(a)){const O=W.$Ne.wrap(a);R.write(c.Buffer),y(R,O.byteLength),R.write(O)}else if(a instanceof W.$Ne)R.write(c.VSBuffer),y(R,a.byteLength),R.write(a);else if(Array.isArray(a)){R.write(c.Array),y(R,a.length);for(const O of a)h(R,O)}else if(typeof a=="number"&&(a|0)===a)R.write(c.Uint),y(R,a);else{const O=W.$Ne.fromString(JSON.stringify(a));R.write(c.Object),y(R,O.byteLength),R.write(O)}}function w(R){switch(R.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return R.read(f(R)).toString();case i.Buffer:return R.read(f(R)).buffer;case i.VSBuffer:return R.read(f(R));case i.Array:{const O=f(R),j=[];for(let Y=0;Y<O;Y++)j.push(w(R));return j}case i.Object:return JSON.parse(R.read(f(R)).toString());case i.Int:return f(R)}}class u{constructor(a,O,j=null,Y=1e3){this.h=a,this.j=O,this.k=j,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(v=>this.q(v)),this.m({type:r.Initialize})}registerChannel(a,O){this.b.set(a,O),setTimeout(()=>this.w(a),0)}m(a){switch(a.type){case r.Initialize:{const O=this.o([a.type]);this.k?.logOutgoing(O,0,P.OtherSide,$(a.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const O=this.o([a.type,a.id],a.data);this.k?.logOutgoing(O,a.id,P.OtherSide,$(a.type),a.data);return}}}o(a,O=void 0){const j=new n;return h(j,a),h(j,O),this.p(j.buffer)}p(a){try{return this.h.send(a),a.byteLength}catch{return 0}}q(a){const O=new s(a),j=w(O),Y=w(O),v=j[0];switch(v){case F.Promise:return this.k?.logIncoming(a.byteLength,j[1],P.OtherSide,`${o(v)}: ${j[2]}.${j[3]}`,Y),this.s({type:v,id:j[1],channelName:j[2],name:j[3],arg:Y});case F.EventListen:return this.k?.logIncoming(a.byteLength,j[1],P.OtherSide,`${o(v)}: ${j[2]}.${j[3]}`,Y),this.t({type:v,id:j[1],channelName:j[2],name:j[3],arg:Y});case F.PromiseCancel:return this.k?.logIncoming(a.byteLength,j[1],P.OtherSide,`${o(v)}`),this.u({type:v,id:j[1]});case F.EventDispose:return this.k?.logIncoming(a.byteLength,j[1],P.OtherSide,`${o(v)}`),this.u({type:v,id:j[1]})}}s(a){const O=this.b.get(a.channelName);if(!O){this.v(a);return}const j=new M.$we;let Y;try{Y=O.call(this.j,a.name,a.arg,j.token)}catch(ee){Y=Promise.reject(ee)}const v=a.id;Y.then(ee=>{this.m({id:v,data:ee,type:r.PromiseSuccess})},ee=>{ee instanceof Error?this.m({id:v,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split(`
`):void 0},type:r.PromiseError}):this.m({id:v,data:ee,type:r.PromiseErrorObj})}).finally(()=>{Z.dispose(),this.d.delete(a.id)});const Z=(0,S.$Tc)(()=>j.cancel());this.d.set(a.id,Z)}t(a){const O=this.b.get(a.channelName);if(!O){this.v(a);return}const j=a.id,v=O.listen(this.j,a.name,a.arg)(Z=>this.m({id:j,data:Z,type:r.EventFire}));this.d.set(a.id,v)}u(a){const O=this.d.get(a.id);O&&(O.dispose(),this.d.delete(a.id))}v(a){let O=this.g.get(a.channelName);O||(O=[],this.g.set(a.channelName,O));const j=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===F.Promise&&this.m({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.l}ms`,stack:void 0},type:r.PromiseError})},this.l);O.push({request:a,timeoutTimer:j})}w(a){const O=this.g.get(a);if(O){for(const j of O)switch(clearTimeout(j.timeoutTimer),j.request.type){case F.Promise:this.s(j.request);break;case F.EventListen:this.t(j.request);break}this.g.delete(a)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Qc)(this.d.values()),this.d.clear()}}e.$gi=u;var P;(function(R){R[R.LocalSide=0]="LocalSide",R[R.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class D{constructor(a,O=null){this.l=a,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new U.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(j=>this.s(j)),this.j=O}getChannel(a){const O=this;return{call(j,Y,v){return O.a?Promise.reject(new k.$6):O.m(a,j,Y,v)},listen(j,Y){return O.a?U.Event.None:O.o(a,j,Y)}}}m(a,O,j,Y=M.CancellationToken.None){const v=this.g++,Z=F.Promise,ee={id:v,type:Z,channelName:a,name:O,arg:j};if(Y.isCancellationRequested)return Promise.reject(new k.$6);let ie;return new Promise((de,p)=>{if(Y.isCancellationRequested)return p(new k.$6);const q=()=>{const z=J=>{switch(J.type){case r.PromiseSuccess:this.f.delete(v),de(J.data);break;case r.PromiseError:{this.f.delete(v);const ne=new Error(J.data.message);ne.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ne.name=J.data.name,p(ne);break}case r.PromiseErrorObj:this.f.delete(v),p(J.data);break}};this.f.set(v,z),this.p(ee)};let H=null;this.b===m.Idle?q():(H=(0,t.$rh)(z=>this.u()),H.then(()=>{H=null,q()}));const B=()=>{H?(H.cancel(),H=null):this.p({id:v,type:F.PromiseCancel}),p(new k.$6)},E=Y.onCancellationRequested(B);ie=(0,S.$Sc)((0,S.$Tc)(B),E),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o(a,O,j){const Y=this.g++,v=F.EventListen,Z={id:Y,type:v,channelName:a,name:O,arg:j};let ee=null;const ie=new U.$le({onWillAddFirstListener:()=>{ee=(0,t.$rh)(de=>this.u()),ee.then(()=>{ee=null,this.d.add(ie),this.p(Z)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(ie),this.p({id:Y,type:F.EventDispose}))}}),le=de=>ie.fire(de.data);return this.f.set(Y,le),ie.event}p(a){switch(a.type){case F.Promise:case F.EventListen:{const O=this.q([a.type,a.id,a.channelName,a.name],a.arg);this.j?.logOutgoing(O,a.id,P.LocalSide,`${o(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case F.PromiseCancel:case F.EventDispose:{const O=this.q([a.type,a.id]);this.j?.logOutgoing(O,a.id,P.LocalSide,o(a.type));return}}}q(a,O=void 0){const j=new n;return h(j,a),h(j,O),this.r(j.buffer)}r(a){try{return this.l.send(a),a.byteLength}catch{return 0}}s(a){const O=new s(a),j=w(O),Y=w(O),v=j[0];switch(v){case r.Initialize:return this.j?.logIncoming(a.byteLength,0,P.LocalSide,$(v)),this.t({type:j[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.j?.logIncoming(a.byteLength,j[1],P.LocalSide,$(v),Y),this.t({type:j[0],id:j[1],data:Y})}}t(a){if(a.type===r.Initialize){this.b=m.Idle,this.k.fire();return}this.f.get(a.id)?.(a)}get onDidInitializePromise(){return U.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Qc)(this.d.values()),this.d.clear()}}e.$hi=D,Ye([X.$9h],D.prototype,"onDidInitializePromise",null);class b{get connections(){const a=[];return this.f.forEach(O=>a.push(O)),a}constructor(a,O,j){this.a=new Map,this.f=new Set,this.g=new U.$le,this.onDidAddConnection=this.g.event,this.h=new U.$le,this.onDidRemoveConnection=this.h.event,this.j=new S.$Uc,this.j.add(a(({protocol:Y,onDidClientDisconnect:v})=>{const Z=U.Event.once(Y.onMessage);this.j.add(Z(ee=>{const ie=new s(ee),le=w(ie),de=new u(Y,le,O,j),p=new D(Y,O);this.a.forEach((H,B)=>de.registerChannel(B,H));const q={channelServer:de,channelClient:p,ctx:le};this.f.add(q),this.g.fire(q),this.j.add(v(()=>{de.dispose(),p.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(a,O){const j=this;return{call(Y,v,Z){let ee;if((0,I.$sg)(O)){const le=(0,g.$4b)(j.connections.filter(O));ee=le?Promise.resolve(le):U.Event.toPromise(U.Event.filter(j.onDidAddConnection,O))}else ee=O.routeCall(j,Y,v);const ie=ee.then(le=>le.channelClient.getChannel(a));return K(ie).call(Y,v,Z)},listen(Y,v){if((0,I.$sg)(O))return j.k(a,O,Y,v);const Z=O.routeEvent(j,Y,v).then(ee=>ee.channelClient.getChannel(a));return K(Z).listen(Y,v)}}}k(a,O,j,Y){const v=this;let Z;const ee=new U.$le({onWillAddFirstListener:()=>{Z=new S.$Uc;const ie=new U.$re,le=new Map,de=q=>{const B=q.channelClient.getChannel(a).listen(j,Y),E=ie.add(B);le.set(q,E)},p=q=>{const H=le.get(q);H&&(H.dispose(),le.delete(q))};v.connections.filter(O).forEach(de),U.Event.filter(v.onDidAddConnection,O)(de,void 0,Z),v.onDidRemoveConnection(p,void 0,Z),ie.event(ee.fire,ee,Z),Z.add(ie)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return ee.event}registerChannel(a,O){this.a.set(a,O);for(const j of this.f)j.channelServer.registerChannel(a,O)}dispose(){this.j.dispose();for(const a of this.f)a.channelClient.dispose(),a.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=b;class d{constructor(a,O,j=null){const Y=new n;h(Y,O),a.send(Y.buffer),this.a=new D(a,j),this.d=new u(a,O,j)}getChannel(a){return this.a.getChannel(a)}registerChannel(a,O){this.d.registerChannel(a,O)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=d;function K(R){return{call(a,O,j){return R.then(Y=>Y.call(a,O,j))},listen(a,O){const j=new U.$ue;return R.then(Y=>j.input=Y.listen(a,O)),j.event}}}function re(R){let a=!1;return{call(O,j,Y){return a?R.call(O,j,Y):(0,t.$Fh)(0).then(()=>a=!0).then(()=>R.call(O,j,Y))},listen(O,j){if(a)return R.listen(O,j);const Y=new U.$ue;return(0,t.$Fh)(0).then(()=>a=!0).then(()=>Y.input=R.listen(O,j)),Y.event}}}class x{constructor(a){this.a=a}routeCall(a){return this.b(a)}routeEvent(a){return this.b(a)}async b(a){for(const O of a.connections)if(await Promise.resolve(this.a(O.ctx)))return Promise.resolve(O);return await U.Event.toPromise(a.onDidAddConnection),await this.b(a)}}e.$mi=x;var V;(function(R){function a(v,Z,ee){const ie=v,le=ee&&ee.disableMarshalling,de=new Map;for(const p in ie)j(p)&&de.set(p,U.Event.buffer(ie[p],!0,void 0,Z));return new class{listen(p,q,H){const B=de.get(q);if(B)return B;const E=ie[q];if(typeof E=="function"){if(Y(q))return E.call(ie,H);if(j(q))return de.set(q,U.Event.buffer(ie[q],!0,void 0,Z)),de.get(q)}throw new k.$cb(`Event not found: ${q}`)}call(p,q,H){const B=ie[q];if(typeof B=="function"){if(!le&&Array.isArray(H))for(let z=0;z<H.length;z++)H[z]=(0,N.$bi)(H[z]);let E=B.apply(ie,H);return E instanceof Promise||(E=Promise.resolve(E)),E}throw new k.$cb(`Method not found: ${q}`)}}}R.fromService=a;function O(v,Z){const ee=Z&&Z.disableMarshalling;return new Proxy({},{get(ie,le){if(typeof le=="string")return Z?.properties?.has(le)?Z.properties.get(le):Y(le)?function(de){return v.listen(le,de)}:j(le)?v.listen(le):async function(...de){let p;Z&&!(0,I.$ng)(Z.context)?p=[Z.context,...de]:p=de;const q=await v.call(le,p);return ee?q:(0,N.$bi)(q)};throw new k.$cb(`Property not found: ${String(le)}`)}})}R.toService=O;function j(v){return v[0]==="o"&&v[1]==="n"&&A.$Ef(v.charCodeAt(2))}function Y(v){return/^onDynamic/.test(v)&&A.$Ef(v.charCodeAt(9))}})(V||(e.ProxyChannel=V={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(R){if(Array.isArray(R))return R;if(R&&typeof R=="object"&&typeof R.toString=="function"){const a=R.toString();if(a!=="[object Object]")return a}return R}function te(R){return Array.isArray(R)?R.map(Q):Q(R)}function oe(R,a,O,j,Y,v,Z){Z=te(Z);const ee=se[Y],ie=ee[j%ee.length];let le=[`%c[${R}]%c[${String(a).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${v}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(v)?(le=le.concat(Z),le.push(")")):le.push(Z),console.log.apply(console,le)}class ce{constructor(a,O){this.d=a,this.f=O,this.a=0,this.b=0}logOutgoing(a,O,j,Y,v){this.b+=a,oe(this.d,this.b,a,O,j,Y,v)}logIncoming(a,O,j,Y,v){this.a+=a,oe(this.f,this.a,a,O,j,Y,v)}}e.$ni=ce}),define(_e[56],Ee([0,1,65,8,16,13,52,9,6,4,47,55,33,25]),function(ae,e,g,t,W,M,X,k,U,S,N,A,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,k=Le(k);class o extends F.$gi{constructor(m){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:U.Event.fromNodeEventEmitter(process,"message",f=>W.$Ne.wrap(Buffer.from(f,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$ar=o;class r{constructor(m,f){this.i=m,this.j=f,this.c=new Set,this.g=new Map,this.h=new U.$le,this.onDidProcessExit=this.h.event;const _=f&&f.timeout?f.timeout:6e4;this.b=new t.$Bh(_),this.d=null,this.f=null}getChannel(m){const f=this;return{call(_,y,s){return f.k(m,_,y,s)},listen(_,y){return f.l(m,_,y)}}}k(m,f,_,y=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(k.$7());this.b.cancel();const s=this.n(m),n=(0,t.$rh)(c=>s.call(f,_,c)),i=y.onCancellationRequested(()=>n.cancel()),l=(0,S.$Tc)(()=>n.cancel());return this.c.add(l),n.finally(()=>{i.dispose(),this.c.delete(l),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(m,f,_){if(!this.b)return U.Event.None;this.b.cancel();let y;const s=new U.$le({onWillAddFirstListener:()=>{y=this.n(m).listen(f,_)(s.fire,s),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,N.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,I.$km)(f.env),this.d=(0,g.fork)(this.i,m,f);const _=new U.$le,s=U.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,X.$9q)(h)){(0,X.log)(h,`IPC Library: ${this.j.serverName}`);return}_.fire(W.$Ne.wrap(Buffer.from(h,"base64")))}),n=this.j.useQueue?(0,A.$xm)(this.d):this.d,i=h=>this.d&&this.d.connected&&n.send(h.buffer.toString("base64")),l=_.event,c={send:i,onMessage:l};this.f=new F.$hi(c);const T=()=>this.o();process.once("exit",T),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,w)=>{process.removeListener("exit",T),s.dispose(),this.c.forEach(u=>(0,S.$Qc)(u)),this.c.clear(),h!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:w})})}return this.f}n(m){let f=this.g.get(m);return f||(f=this.m.getChannel(m),this.g.set(m,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=r}),define(_e[57],Ee([0,1,29,16,25,6,10,12]),function(ae,e,g,t,W,M,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lX=void 0,e.$mX=N;class U{constructor(I){this.a=I,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",F=>F.data?t.$Ne.wrap(F.data):t.$Ne.alloc(0)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}class S extends W.$ii{static b(I){(0,X.$og)((0,g.$kX)(process),"Electron Utility Process");const F=new M.$le;return process.parentPort.on("message",o=>{if(I?.handledClientConnection(o))return;const r=(0,k.$Pb)(o.ports);r&&F.fire(r)}),M.Event.map(F.event,o=>({protocol:new U(o),onDidClientDisconnect:M.Event.fromNodeEventEmitter(o,"close")}))}constructor(I){super(S.b(I))}}e.$lX=S;function N(A,I,F){const o=r=>{r.data===I&&(A.removeListener("message",o),F())};A.on("message",o)}}),define(_e[58],Ee([30,31]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(_e[59],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=W,e.$Fi=M;var g;(function(X){X.serviceIds=new Map,X.DI_TARGET="$di$target",X.DI_DEPENDENCIES="$di$dependencies";function k(U){return U[X.DI_DEPENDENCIES]||[]}X.getServiceDependencies=k})(g||(e._util=g={})),e.$Di=W("instantiationService");function t(X,k,U){k[g.DI_TARGET]===k?k[g.DI_DEPENDENCIES].push({id:X,index:U}):(k[g.DI_DEPENDENCIES]=[{id:X,index:U}],k[g.DI_TARGET]=k)}function W(X){if(g.serviceIds.has(X))return g.serviceIds.get(X);const k=function(U,S,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,U,N)};return k.toString=()=>X,g.serviceIds.set(X,k),k}function M(X){return X}}),define(_e[18],Ee([0,1,28,3,7,10,5,58,59,2,34,15]),function(ae,e,g,t,W,M,X,k,U,S,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=I,e.$al=$,e.$bl=f,e.$cl=_,e.$dl=y,e.$el=s,e.$fl=n,e.$gl=i,e.$hl=l,e.$il=c,e.$jl=T,e.$ll=u,e.$ml=P,e.$nl=D,e.$ol=b,e.$pl=d,e.$sl=se,e.$El=a,e.$Fl=O,e.$Hl=Y,e.$$k=(0,U.$Ei)("fileService");function I(v){return v.create===!0}var F;(function(v){v[v.Unknown=0]="Unknown",v[v.File=1]="File",v[v.Directory=2]="Directory",v[v.SymbolicLink=64]="SymbolicLink"})(F||(e.FileType=F={}));var o;(function(v){v[v.Readonly=1]="Readonly",v[v.Locked=2]="Locked"})(o||(e.FilePermission=o={}));var r;(function(v){v[v.UPDATED=2]="UPDATED",v[v.ADDED=4]="ADDED",v[v.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function $(v){const Z=v;return!!Z&&typeof Z.onDidChange=="function"}var m;(function(v){v[v.None=0]="None",v[v.FileReadWrite=2]="FileReadWrite",v[v.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",v[v.FileReadStream=16]="FileReadStream",v[v.FileFolderCopy=8]="FileFolderCopy",v[v.PathCaseSensitive=1024]="PathCaseSensitive",v[v.Readonly=2048]="Readonly",v[v.Trash=4096]="Trash",v[v.FileWriteUnlock=8192]="FileWriteUnlock",v[v.FileAtomicRead=16384]="FileAtomicRead",v[v.FileAtomicWrite=32768]="FileAtomicWrite",v[v.FileAtomicDelete=65536]="FileAtomicDelete",v[v.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(v){return!!(v.capabilities&m.FileReadWrite)}function _(v){return!!(v.capabilities&m.FileFolderCopy)}function y(v){return!!(v.capabilities&m.FileClone)}function s(v){return!!(v.capabilities&m.FileOpenReadWriteClose)}function n(v){return!!(v.capabilities&m.FileReadStream)}function i(v){return f(v)?!!(v.capabilities&m.FileAtomicRead):!1}function l(v){return f(v)?!!(v.capabilities&m.FileAtomicWrite):!1}function c(v){return!!(v.capabilities&m.FileAtomicDelete)}function T(v){return!!(v.capabilities&m.Readonly)}var h;(function(v){v.FileExists="EntryExists",v.FileNotFound="EntryNotFound",v.FileNotADirectory="EntryNotADirectory",v.FileIsADirectory="EntryIsADirectory",v.FileExceedsStorageQuota="EntryExceedsStorageQuota",v.FileTooLarge="EntryTooLarge",v.FileWriteLocked="EntryWriteLocked",v.NoPermissions="NoPermissions",v.Unavailable="Unavailable",v.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class w extends Error{static create(Z,ee){const ie=new w(Z.toString(),ee);return D(ie,ee),ie}constructor(Z,ee){super(Z),this.code=ee}}e.$kl=w;function u(v,Z){return w.create(v,Z)}function P(v){return v||u((0,k.localize)(0,null),h.Unknown)}function D(v,Z){return v.name=Z?`${Z} (FileSystemError)`:"FileSystemError",v}function b(v){if(!v)return h.Unknown;if(v instanceof w)return v.code;const Z=/^(.+) \(FileSystemError\)$/.exec(v.name);if(!Z)return h.Unknown;switch(Z[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function d(v){if(v instanceof Q)return v.fileOperationResult;switch(b(v)){case h.FileNotFound:return ce.FILE_NOT_FOUND;case h.FileIsADirectory:return ce.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ce.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ce.FILE_WRITE_LOCKED;case h.NoPermissions:return ce.FILE_PERMISSION_DENIED;case h.FileExists:return ce.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ce.FILE_TOO_LARGE;default:return ce.FILE_OTHER_ERROR}}var K;(function(v){v[v.CREATE=0]="CREATE",v[v.DELETE=1]="DELETE",v[v.MOVE=2]="MOVE",v[v.COPY=3]="COPY",v[v.WRITE=4]="WRITE"})(K||(e.FileOperation=K={}));class re{constructor(Z,ee,ie){this.resource=Z,this.operation=ee,this.target=ie}isOperation(Z){return this.operation===Z}}e.$ql=re;var x;(function(v){v[v.UPDATED=0]="UPDATED",v[v.ADDED=1]="ADDED",v[v.DELETED=2]="DELETED"})(x||(e.FileChangeType=x={}));class V{static{this.a=null}constructor(Z,ee){this.c=ee,this.b=void 0,this.d=new A.$W(()=>{const ie=g.$Ki.forUris(()=>this.c);return ie.fill(this.rawAdded.map(le=>[le,!0])),ie}),this.f=new A.$W(()=>{const ie=g.$Ki.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(le=>[le,!0])),ie}),this.g=new A.$W(()=>{const ie=g.$Ki.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(le=>[le,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of Z){switch(ie.type){case x.ADDED:this.rawAdded.push(ie.resource);break;case x.UPDATED:this.rawUpdated.push(ie.resource);break;case x.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==V.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(Z,...ee){return this.h(Z,{includeChildren:!1},...ee)}affects(Z,...ee){return this.h(Z,{includeChildren:!0},...ee)}h(Z,ee,...ie){if(!Z)return!1;const le=ie.length>0;return!!((!le||ie.includes(x.ADDED))&&(this.d.value.get(Z)||ee.includeChildren&&this.d.value.findSuperstr(Z))||(!le||ie.includes(x.UPDATED))&&(this.f.value.get(Z)||ee.includeChildren&&this.f.value.findSuperstr(Z))||(!le||ie.includes(x.DELETED))&&(this.g.value.findSubstr(Z)||ee.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$rl=V;function se(v,Z,ee){return!v||!Z||v===Z||Z.length>v.length?!1:(Z.charAt(Z.length-1)!==t.sep&&(Z+=t.sep),ee?(0,W.$Gf)(v,Z):v.indexOf(Z)===0)}class Q extends Error{constructor(Z,ee,ie){super(Z),this.fileOperationResult=ee,this.options=ie}}e.$tl=Q;class te extends Q{constructor(Z,ee,ie,le){super(Z,ee,le),this.fileOperationResult=ee,this.size=ie}}e.$ul=te;class oe extends Q{constructor(Z,ee,ie){super(Z,ce.FILE_NOT_MODIFIED_SINCE,ie),this.stat=ee}}e.$vl=oe;var ce;(function(v){v[v.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",v[v.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",v[v.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",v[v.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",v[v.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",v[v.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",v[v.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",v[v.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",v[v.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",v[v.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",v[v.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var R;(function(v){v[v.FILE=0]="FILE",v[v.FOLDER=1]="FOLDER",v[v.ROOT_FOLDER=2]="ROOT_FOLDER"})(R||(e.FileKind=R={})),e.$Dl="";function a(v){if(!(typeof v.size!="number"||typeof v.mtime!="number"))return v.mtime.toString(29)+v.size.toString(31)}async function O(v,Z){if(!Z.hasProvider(X.URI.from({scheme:v.scheme})))return new Promise(ee=>{const ie=Z.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===v.scheme&&le.added&&(ie.dispose(),ee())})})}class j{static{this.KB=1024}static{this.MB=j.KB*j.KB}static{this.GB=j.MB*j.KB}static{this.TB=j.GB*j.KB}static formatSize(Z){return(0,M.$ig)(Z)||(Z=0),Z<j.KB?(0,k.localize)(1,null,Z.toFixed(0)):Z<j.MB?(0,k.localize)(2,null,(Z/j.KB).toFixed(2)):Z<j.GB?(0,k.localize)(3,null,(Z/j.MB).toFixed(2)):Z<j.TB?(0,k.localize)(4,null,(Z/j.GB).toFixed(2)):(0,k.localize)(5,null,(Z/j.TB).toFixed(2))}}e.$Gl=j;function Y(v){const Z=typeof v=="string"||v?.scheme===N.Schemas.vscodeRemote;return typeof v!="string"&&v?.scheme===N.Schemas.file?1024*j.MB:Z?10*j.MB:S.$o?50*j.MB:1024*j.MB}}),define(_e[19],Ee([0,1,23,4,3,2,5,18]),function(ae,e,g,t,W,M,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=U,e.$Xq=S,e.$2q=F,e.$3q=o,e.$4q=r,e.$5q=$,e.$6q=f,e.$7q=_;function U(y){return typeof y.correlationId=="number"}function S(y){return y.recursive===!0}class N extends t.$Vc{static{this.a=5}constructor(s,n,i,l){super(),this.h=s,this.j=n,this.m=i,this.n=l,this.c=this.B(new t.$Wc),this.f=void 0,this.g=0}s(){const s=new t.$Uc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(n=>this.h(n))),s.add(this.b.onDidLogMessage(n=>this.j(n))),s.add(this.b.onDidError(n=>this.t(n.error,n.request)))}t(s,n){this.u(s,n)?this.g<N.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,n){return!(!this.n.restartOnError||n||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=N;class A extends N{constructor(s,n,i){super(s,n,i,{type:"node.js",restartOnError:!1})}}e.$Zq=A;class I extends N{constructor(s,n,i){super(s,n,i,{type:"universal",restartOnError:!0})}}e.$1q=I;function F(y){return y.map(s=>({type:s.type,resource:X.URI.revive(s.resource),cId:s.cId}))}function o(y){const s=new m;for(const n of y)s.processEvent(n);return s.coalesce()}function r(y,s){return typeof s=="string"&&!s.startsWith(g.$uk)&&!(0,W.$jc)(s)?{base:y,pattern:s}:s}function $(y,s){const n=[];for(const i of s)n.push((0,g.$yk)(r(y,i)));return n}class m{constructor(){this.a=new Set,this.b=new Map}c(s){return M.$k?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const n=this.b.get(this.c(s));let i=!1;if(n){const l=n.type,c=s.type;n.resource.fsPath!==s.resource.fsPath&&(s.type===k.FileChangeType.DELETED||s.type===k.FileChangeType.ADDED)?i=!0:l===k.FileChangeType.ADDED&&c===k.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(n)):l===k.FileChangeType.DELETED&&c===k.FileChangeType.ADDED?n.type=k.FileChangeType.UPDATED:l===k.FileChangeType.ADDED&&c===k.FileChangeType.UPDATED||(n.type=c)}else i=!0;i&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],n=[];return Array.from(this.a).filter(i=>i.type!==k.FileChangeType.DELETED?(s.push(i),!1):!0).sort((i,l)=>i.resource.fsPath.length-l.resource.fsPath.length).filter(i=>n.some(l=>(0,k.$sl)(i.resource.fsPath,l,!M.$k))?!1:(n.push(i.resource.fsPath),!0)).concat(s)}}function f(y,s){if(typeof s=="number")switch(y.type){case k.FileChangeType.ADDED:return(s&k.FileChangeFilter.ADDED)===0;case k.FileChangeType.DELETED:return(s&k.FileChangeFilter.DELETED)===0;case k.FileChangeType.UPDATED:return(s&k.FileChangeFilter.UPDATED)===0}return!1}function _(y){if(typeof y=="number"){const s=[];return y&k.FileChangeFilter.ADDED&&s.push("Added"),y&k.FileChangeFilter.DELETED&&s.push("Deleted"),y&k.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(_e[36],Ee([0,1,17,4,19,6,18,5,8]),function(ae,e,g,t,W,M,X,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class S extends t.$Vc{constructor(){super(),this.a=this.B(new M.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$5c),this.m=new Set,this.n=this.B(new U.$Ch(this.y())),this.r=5007,this.s=new U.$2h,this.R=!1,this.B(this.f(A=>this.t(A)))}t(A){this.u(A)&&this.z(A)}u(A){return(0,W.$Wq)(A)}async watch(A){this.s.isSettled||this.s.complete(),this.s=new U.$2h;try{this.h.clear(),this.g.clear();for(const I of A)this.u(I)?this.h.set(I.correlationId,I):this.g.add(I);for(const[I]of this.j)this.h.has(I)||(this.j.deleteAndDispose(I),this.m.delete(I));return await this.w(!1)}finally{this.s.complete()}}w(A){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(I=>!this.j.has(I.correlationId))]),A?this.y():0)}y(){return 800}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async z(A){if(this.j.has(A.correlationId))return;const I=new t.$Uc;this.j.set(A.correlationId,I),await this.s.p,!I.isDisposed&&(this.D(A,I),this.w(!0))}C(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.w(!1)}D(A,I){this.F(A,I)?(this.P(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.G(A,I),this.m.add(A.correlationId))}F(A,I){const F=this.O?.subscribe(A.path,(o,r)=>{I.isDisposed||(o?this.D(A,I):r?.type===X.FileChangeType.ADDED&&this.H(A))});return F?(I.add(F),!0):!1}G(A,I){let F=!1;const o=(r,$)=>{if(I.isDisposed)return;const m=this.I(r),f=this.I($),_=F;F=m,!m&&(f||_)&&this.H(A)};this.P(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,g.watchFile)(A.path,{persistent:!1,interval:this.r},o)}catch(r){this.Q(`fs.watchFile() failed with error ${r} on path ${A.path} (correlationId: ${A.correlationId})`)}I.add((0,t.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,g.unwatchFile)(A.path,o)}catch(r){this.Q(`fs.unwatchFile() failed with error ${r} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}H(A){this.P(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const I={resource:k.URI.file(A.path),type:X.FileChangeType.ADDED,cId:A.correlationId};this.a.fire([I]),this.J(I,A),this.C(A)}I(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(A,I){if(this.R){const F=` >> normalized ${A.type===X.FileChangeType.ADDED?"[ADDED]":A.type===X.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.L(F,I)}}L(A,I){this.R&&this.P(`${A}${typeof I.correlationId=="number"?` <${I.correlationId}> `:""}`)}M(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,W.$7q)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.R=A}}e.$dr=S}),define(_e[37],Ee([0,1,17,8,13,14,4,21,3,2,22,5,35,24,18,19]),function(ae,e,g,t,W,M,X,k,U,S,N,A,I,F,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=m;class $ extends X.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(_,y,s,n,i,l){super(),this.s=_,this.t=y,this.u=s,this.w=n,this.y=i,this.z=l,this.c=this.B(new t.$Th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.u(c))),this.f=this.B(new t.$Sh(c=>this.M(c),$.b)),this.g=(0,r.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,r.$Wq)(this.s)?this.s.filter:void 0,this.m=new W.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const _=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const y=await F.Promises.stat(_);if(this.m.token.isCancellationRequested)return;this.B(await this.G(_,y.isDirectory()))}catch(_){_.code!=="ENOENT"?this.O(_):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${_})`),this.D()}}D(){this.r=!0,this.w?.()}async F(_){let y=_.path;try{y=await F.Promises.realpath(_.path),_.path===y&&(y=await(0,I.$fr)(_.path,this.m.token)??_.path),_.path!==y&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${_.path}, real: ${y})`)}catch{}return y}async G(_,y){const s=new X.$Uc;return this.H(_,y,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(_,y,s)),s}H(_,y,s){if(y)return!1;const n=A.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(l,c)=>{if(!s.isDisposed)if(l){const T=await this.G(_,y);s.isDisposed?T.dispose():s.add(T)}else c&&(typeof c.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:n,type:c.type,cId:this.s.correlationId},!0)});return i?(s.add(i),!0):!1}async I(_,y,s){if(S.$j&&(0,M.$Dg)(_,"/Volumes/",!0)){this.O(`Refusing to watch ${_} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new W.$we(this.m.token);s.add((0,X.$Tc)(()=>n.dispose(!0)));const i=new X.$Uc;s.add(i);try{const l=A.URI.file(this.s.path),c=(0,U.$oc)(_),T=(0,g.watch)(_);i.add((0,X.$Tc)(()=>{T.removeAllListeners(),T.close()})),this.Q(`Started watching: '${_}'`);const h=new Set;if(y)try{for(const u of await F.Promises.readdir(_))h.add(u)}catch(u){this.O(u)}if(n.token.isCancellationRequested)return;const w=new Map;i.add((0,X.$Tc)(()=>{for(const[,u]of w)u.dispose();w.clear()})),T.on("error",(u,P)=>{n.token.isCancellationRequested||(this.O(`Failed to watch ${_} for changes using fs.watch() (${u}, ${P})`),this.D())}),T.on("change",(u,P)=>{if(n.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${P}`);let D="";if(P&&(D=P.toString(),S.$j&&(D=(0,k.$lm)(D))),!(!D||u!=="change"&&u!=="rename"))if(y)if(u==="rename"){w.get(D)?.dispose();const b=setTimeout(async()=>{if(w.delete(D),D===c&&!await F.Promises.exists(_)){this.J(l);return}if(n.token.isCancellationRequested)return;const d=await this.N((0,U.$kc)(_,D));if(n.token.isCancellationRequested)return;let K;d?h.has(D)?K=o.FileChangeType.UPDATED:(K=o.FileChangeType.ADDED,h.add(D)):(h.delete(D),K=o.FileChangeType.DELETED),this.L({resource:(0,N.$fh)(l,D),type:K,cId:this.s.correlationId})},$.a);w.set(D,(0,X.$Tc)(()=>clearTimeout(b)))}else{let b;h.has(D)?b=o.FileChangeType.UPDATED:(b=o.FileChangeType.ADDED,h.add(D)),this.L({resource:(0,N.$fh)(l,D),type:b,cId:this.s.correlationId})}else if(u==="rename"||D!==c){const b=setTimeout(async()=>{const d=await F.Promises.exists(_);n.token.isCancellationRequested||(d?(this.L({resource:l,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(_,!1))):this.J(l))},$.a);i.clear(),i.add((0,X.$Tc)(()=>clearTimeout(b)))}else this.L({resource:l,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(l){n.token.isCancellationRequested||this.O(`Failed to watch ${_} for changes using fs.watch() (${l.toString()})`),this.D()}}J(_){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:_,type:o.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(_,y=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${_.type===o.FileChangeType.ADDED?"[ADDED]":_.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${_.resource.fsPath}`),!y&&this.g.some(s=>s(_.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${_.resource.fsPath}`):!y&&this.h&&this.h.length>0&&!this.h.some(s=>s(_.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${_.resource.fsPath}`):this.f.work(_))}M(_){const y=(0,r.$3q)(_),s=[];for(const i of y){if((0,r.$6q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}s.push(i)}if(s.length===0)return;if(this.z)for(const i of s)this.R(` >> normalized ${i.type===o.FileChangeType.ADDED?"[ADDED]":i.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(_){if(S.$k)return F.Promises.exists(_);try{const y=(0,U.$oc)(_);return(await F.Promises.readdir((0,U.$nc)(_))).some(n=>n===y)}catch(y){return this.Q(y),!1}}setVerboseLogging(_){this.z=_}O(_){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${_}`})}P(_){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${_}`})}Q(_){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${_}`})}R(_){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${_}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=$;async function m(f,_,y,s,n=512){const i=await F.Promises.open(f,"r"),l=Buffer.allocUnsafe(n),c=new W.$we(s);let T,h=!1;const w={path:f,excludes:[],recursive:!1},u=new $(w,void 0,P=>{(async()=>{for(const{type:D}of P)if(D===o.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:b}=await F.Promises.read(i,l,0,n,null);if(!b||c.token.isCancellationRequested)break;_(l.slice(0,b))}}catch(b){T=new Error(b),c.dispose(!0)}finally{h=!1}}})()});return await u.ready,y(),new Promise((P,D)=>{c.token.onCancellationRequested(async()=>{u.dispose();try{await F.Promises.close(i)}catch(b){T=new Error(b)}T?D(T):P()})})}}),define(_e[60],Ee([0,1,6,23,36,2,37,14]),function(ae,e,g,t,W,M,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class U extends W.$dr{constructor(N){super(),this.O=N,this.onDidError=g.Event.None,this.watchers=new Set}async N(N){N=this.Z(N);const A=[],I=new Set(Array.from(this.watchers));for(const F of N){const o=this.W(F);o&&(0,t.$Ck)(o.request.excludes,F.excludes)&&(0,t.$Ck)(o.request.includes,F.includes)?I.delete(o):A.push(F)}A.length&&this.P(`Request to start watching: ${A.map(F=>this.M(F)).join(",")}`),I.size&&this.P(`Request to stop watching: ${Array.from(I).map(F=>this.M(F.request)).join(",")}`);for(const F of I)this.Y(F);for(const F of A)this.X(F)}W(N){for(const A of this.watchers)if(typeof N.correlationId=="number"||typeof A.request.correlationId=="number"){if(A.request.correlationId===N.correlationId)return A}else if((0,k.$Cg)(A.request.path,N.path,!M.$k))return A}X(N){const A=new X.$ir(N,this.O,F=>this.a.fire(F),()=>this.c.fire(N),F=>this.b.fire(F),this.R),I={request:N,instance:A};this.watchers.add(I)}async stop(){await super.stop();for(const N of this.watchers)this.Y(N)}Y(N){this.P("stopping file watcher",N),this.watchers.delete(N),N.instance.dispose()}Z(N){const A=new Map;for(const I of N){const F=M.$k?I.path:I.path.toLowerCase();let o=A.get(I.correlationId);o||(o=new Map,A.set(I.correlationId,o)),o.has(F)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(I)}`),o.set(F,I)}return Array.from(A.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(N){super.setVerboseLogging(N);for(const A of this.watchers)A.instance.setVerboseLogging(N)}P(N,A){this.R&&this.b.fire({type:"trace",message:this.bb(N,A)})}Q(N){this.b.fire({type:"warn",message:this.bb(N)})}bb(N,A){return A?`[File Watcher (node.js)] ${N} (${this.M(A.request)})`:`[File Watcher (node.js)] ${N}`}}e.$kr=U}),define(_e[61],Ee([0,1,66,17,54,5,8,13,50,6,14,23,36,28,21,3,2,35,37,18,19,4]),function(ae,e,g,t,W,M,X,k,U,S,N,A,I,F,o,r,$,m,f,_,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=e.$fkc=void 0,g=Le(g);class n extends s.$Vc{get failed(){return this.c}get stopped(){return this.f}constructor(c,T,h,w,u,P){super(),this.ready=c,this.request=T,this.restarts=h,this.token=w,this.worker=u,this.m=P,this.a=this.B(new S.$le),this.onDidStop=this.a.event,this.b=this.B(new S.$le),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,y.$5q)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,y.$5q)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,s.$Tc)(()=>this.j.clear()))}subscribe(c,T){c=M.URI.file(c).fsPath;let h=this.j.get(c);return h||(h=new Set,this.j.set(c,h)),h.add(T),(0,s.$Tc)(()=>{const w=this.j.get(c);w&&(w.delete(T),w.size===0&&this.j.delete(c))})}get subscriptionsCount(){return this.j.size}notifyFileChange(c,T){const h=this.j.get(c);if(h)for(const w of h)w(T)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(c){return!this.g||this.g.length===0?!0:this.g.some(T=>T(c))}exclude(c){return!!this.h?.some(T=>T(c))}async stop(c){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:c}),this.dispose()}}}e.$fkc=n;class i extends I.$dr{static{this.S=new Map([["create",_.FileChangeType.ADDED],["update",_.FileChangeType.UPDATED],["delete",_.FileChangeType.DELETED]])}static{this.U=$.$i?"windows":$.$k?"inotify":"fs-events"}static{this.X=75}constructor(){super(),this.W=this.B(new S.$le),this.onDidError=this.W.event,this.watchers=new Set,this.Y=this.B(new X.$Th({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},c=>this.a.fire(c))),this.Z=!1,this.$()}$(){process.on("uncaughtException",c=>this.nb(c)),process.on("unhandledRejection",c=>this.nb(c))}async N(c){c=this.qb(c);const T=[],h=new Set(Array.from(this.watchers));for(const w of c){const u=this.bb(w);u&&(0,A.$Ck)(u.request.excludes,w.excludes)&&(0,A.$Ck)(u.request.includes,w.includes)&&u.request.pollingInterval===w.pollingInterval?h.delete(u):T.push(w)}T.length&&this.P(`Request to start watching: ${T.map(w=>this.M(w)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(w=>this.M(w.request)).join(",")}`);for(const w of h)await this.pb(w);for(const w of T)w.pollingInterval?this.cb(w,w.pollingInterval):this.db(w)}bb(c){for(const T of this.watchers)if(this.u(c)||this.u(T.request)){if(T.request.correlationId===c.correlationId)return T}else if((0,N.$Cg)(T.request.path,c.path,!$.$k))return T}cb(c,T,h=0){const w=new k.$we,u=new X.$2h,P=(0,N.$Mg)((0,W.tmpdir)(),"vscode-watcher-snapshot"),D=new n(u.p,c,h,w.token,new X.$Sh(V=>this.gb(V,D),i.X),async()=>{w.dispose(!0),D.worker.flush(),D.worker.dispose(),x.dispose(),(0,t.unlinkSync)(P)});this.watchers.add(D);const{realPath:b,realPathDiffers:d,realPathLength:K}=this.ib(c);this.P(`Started watching: '${b}' with polling interval '${T}'`);let re=0;const x=new X.$Qh(async()=>{if(re++,!w.token.isCancellationRequested){if(re>1){const V=await g.getEventsSince(b,P,{ignore:c.excludes,backend:i.U});if(w.token.isCancellationRequested)return;this.eb(V,D,d,K)}await g.writeSnapshot(b,P,{ignore:c.excludes,backend:i.U}),re===1&&u.complete(),!w.token.isCancellationRequested&&x.schedule()}},T);x.schedule(0)}db(c,T=0){const h=new k.$we,w=new X.$2h,u=new n(w.p,c,T,h.token,new X.$Sh(d=>this.gb(d,u),i.X),async()=>{h.dispose(!0),u.worker.flush(),u.worker.dispose(),await(await w.p)?.unsubscribe()});this.watchers.add(u);const{realPath:P,realPathDiffers:D,realPathLength:b}=this.ib(c);g.subscribe(P,(d,K)=>{u.token.isCancellationRequested||(d&&this.nb(d,c),this.eb(K,u,D,b))},{backend:i.U,ignore:u.request.excludes}).then(d=>{this.P(`Started watching: '${P}' with backend '${i.U}'`),w.complete(d)}).catch(d=>{this.nb(d,c),w.complete(void 0),u.notifyWatchFailed(),this.c.fire(c)})}eb(c,T,h,w){if(c.length===0)return;this.jb(c,T.request,h,w);const u=this.fb(T,c);for(const P of u)T.worker.work(P)}fb(c,T){const h=[];for(const{path:w,type:u}of T){const P=i.S.get(u);this.R&&this.L(`${P===_.FileChangeType.ADDED?"[ADDED]":P===_.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w}`,c.request),c.include(w)?h.push({type:P,resource:M.URI.file(w),cId:c.request.correlationId}):this.R&&this.L(` >> ignored (not included) ${w}`,c.request)}return h}gb(c,T){const h=(0,y.$3q)(c),{events:w,rootDeleted:u}=this.kb(h,T);this.hb(w,T),u&&this.lb(T)}hb(c,T){if(c.length===0)return;this.Y.work(c)?this.Y.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.Y.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,T):this.Q(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}ib(c){let T=c.path,h=!1,w=c.path.length;try{T=(0,m.$hr)(c.path),c.path===T&&(T=(0,m.$er)(c.path)??c.path),c.path!==T&&(w=T.length,h=!0,this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${T})`))}catch{}return{realPath:T,realPathDiffers:h,realPathLength:w}}jb(c,T,h,w){for(const u of c)$.$j&&(u.path=(0,o.$lm)(u.path)),$.$i&&T.path.length<=3&&(u.path=(0,r.$ic)(u.path)),h&&(u.path=T.path+u.path.substr(w))}kb(c,T){const h=[];let w=!1;const u=this.u(T.request)?T.request.filter:void 0;for(const P of c){if(T.subscriptionsCount>0&&T.notifyFileChange(P.resource.fsPath,P),w=P.type===_.FileChangeType.DELETED&&(0,N.$Cg)(P.resource.fsPath,T.request.path,!$.$k),(0,y.$6q)(P,u)||w&&!this.u(T.request)){this.R&&this.L(` >> ignored (filtered) ${P.resource.fsPath}`,T.request);continue}this.J(P,T.request),h.push(P)}return{events:h,rootDeleted:w}}lb(c){this.Q("Watcher shutdown because watched path got deleted",c);let T=!1;this.u(c.request)||(T=this.mb(c)),T||(c.notifyWatchFailed(),this.c.fire(c.request))}mb(c){const T=(0,r.$nc)(c.request.path);if((0,t.existsSync)(T)){this.P("Trying to watch on the parent path to restart the watcher...",c);const h=new f.$ir({path:T,excludes:[],recursive:!1,correlationId:c.request.correlationId},void 0,w=>{if(!c.token.isCancellationRequested){for(const{resource:u,type:P}of w)if((0,N.$Cg)(u.fsPath,c.request.path,!$.$k)&&(P===_.FileChangeType.ADDED||P===_.FileChangeType.UPDATED)&&this.rb(c.request.path)){this.Q("Watcher restarts because watched path got created again",c),h.dispose(),this.ob(c);break}}},void 0,w=>this.b.fire(w),this.R);return c.token.onCancellationRequested(()=>h.dispose()),!0}return!1}nb(c,T){const h=(0,U.$pj)(c);h.indexOf("No space left on device")!==-1?this.Z||(this.ub("Inotify limit reached (ENOSPC)",T),this.Z=!0):(this.ub(`Unexpected error: ${h} (EUNKNOWN)`,T),this.W.fire({request:T,error:h}))}async stop(){await super.stop();for(const c of this.watchers)await this.pb(c)}ob(c,T=800){const h=new X.$Qh(async()=>{if(c.token.isCancellationRequested)return;const w=new X.$2h;try{await this.pb(c,w.p),c.request.pollingInterval?this.cb(c.request,c.request.pollingInterval,c.restarts+1):this.db(c.request,c.restarts+1)}finally{w.complete()}},T);h.schedule(),c.token.onCancellationRequested(()=>h.dispose())}async pb(c,T){this.P("stopping file watcher",c),this.watchers.delete(c);try{await c.stop(T)}catch(h){this.ub(`Unexpected error stopping watcher: ${(0,U.$pj)(h)}`,c.request)}}qb(c,T=!0){c.sort((u,P)=>u.path.length-P.path.length);const h=new Map;for(const u of c){if(u.excludes.includes(A.$uk))continue;const P=$.$k?u.path:u.path.toLowerCase();let D=h.get(u.correlationId);D||(D=new Map,h.set(u.correlationId,D)),D.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),D.set(P,u)}const w=[];for(const u of h.values()){const P=F.$Ki.forPaths(!$.$k);for(const D of u.values()){if(P.findSubstr(D.path))try{if((0,m.$hr)(D.path)===D.path){this.P(`ignoring a request for watching who's parent is already watched: ${this.M(D)}`);continue}}catch(b){this.P(`ignoring a request for watching who's realpath failed to resolve: ${this.M(D)} (error: ${b})`),this.c.fire(D);continue}if(T&&!this.rb(D.path)){this.c.fire(D);continue}P.set(D.path,D)}w.push(...Array.from(P).map(([,D])=>D))}return w}rb(c){try{if(!(0,t.statSync)(c).isDirectory())return this.P(`ignoring a path for watching that is a file and not a folder: ${c}`),!1}catch(T){return this.P(`ignoring a path for watching who's stat info failed to resolve: ${c} (error: ${T})`),!1}return!0}subscribe(c,T){for(const h of this.watchers){if(h.failed||!(0,N.$Dg)(c,h.request.path,!$.$k)||h.exclude(c)||!h.include(c))continue;const w=new s.$Uc;return w.add(S.Event.once(h.onDidStop)(async u=>{await u.joinRestart,!w.isDisposed&&T(!0)})),w.add(S.Event.once(h.onDidFail)(()=>T(!0))),w.add(h.subscribe(c,u=>T(null,u))),w}}P(c,T){this.R&&this.b.fire({type:"trace",message:this.vb(c,T?.request)})}Q(c,T){this.b.fire({type:"warn",message:this.vb(c,T?.request)})}ub(c,T){this.b.fire({type:"error",message:this.vb(c,T)})}vb(c,T){return T?`[File Watcher (parcel)] ${c} (path: ${T.path})`:`[File Watcher (parcel)] ${c}`}get O(){return this}}e.$gkc=i}),define(_e[62],Ee([0,1,19]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=t;function t(o,r,$){const m=[],f=U(o.filter(K=>K.recursive)),_=f.filter(K=>r.isSuspended(K)===!1),y=f.filter(K=>r.isSuspended(K)==="polling"),s=f.filter(K=>r.isSuspended(K)===!0),n=M(f,r),i=X(r),l=U(o.filter(K=>!K.recursive)),c=l.filter(K=>$.isSuspended(K)===!1),T=l.filter(K=>$.isSuspended(K)==="polling"),h=l.filter(K=>$.isSuspended(K)===!0),w=M(l,$),u=k($);m.push("[Summary]"),m.push(`- Recursive Requests:     total: ${f.length}, suspended: ${n.suspended}, polling: ${n.polling}`),m.push(`- Non-Recursive Requests: total: ${l.length}, suspended: ${w.suspended}, polling: ${w.polling}`),m.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${i.active}, failed: ${i.failed}, stopped: ${i.stopped}`),m.push(`- Non-Recursive Watchers: total: ${$.watchers.size}, active: ${u.active}, failed: ${u.failed}, reusing: ${u.reusing}`),m.push(`- I/O Handles Impact:     total: ${n.polling+w.polling+i.active+u.active}`),m.push(`
[Recursive Requests (${f.length}, suspended: ${n.suspended}, polling: ${n.polling})]:`);const P=[];for(const K of[_,y,s].flat())N(P,K,r);m.push(...W(P));const D=[];I(D,r),m.push(...W(D)),m.push(`
[Non-Recursive Requests (${l.length}, suspended: ${w.suspended}, polling: ${w.polling})]:`);const b=[];for(const K of[c,T,h].flat())N(b,K,$);m.push(...W(b));const d=[];return F(d,$),m.push(...W(d)),`

[File Watcher] request stats:

${m.join(`
`)}

`}function W(o){let r=0;for(const $ of o)r=Math.max(r,$.split("	")[0].length);for(let $=0;$<o.length;$++){const f=o[$].split("	");if(f.length===2){const _=" ".repeat(r-f[0].length);o[$]=`${f[0]}${_}	${f[1]}`}}return o}function M(o,r){let $=0,m=0;for(const f of o){const _=r.isSuspended(f);_!==!1&&(m++,_==="polling"&&$++)}return{suspended:m,polling:$}}function X(o){let r=0,$=0,m=0;for(const f of o.watchers.values())!f.failed&&!f.stopped&&r++,f.failed&&$++,f.stopped&&m++;return{active:r,failed:$,stopped:m}}function k(o){let r=0,$=0,m=0;for(const f of o.watchers)!f.instance.failed&&!f.instance.isReusingRecursiveWatcher&&r++,f.instance.failed&&$++,f.instance.isReusingRecursiveWatcher&&m++;return{active:r,failed:$,reusing:m}}function U(o){return o.sort((r,$)=>{const m=S(r)?r.path:r.request.path,f=S($)?$.path:$.request.path,_=Math.min(m.length,f.length);for(let y=0;y<_;y++)if(m[y]!==f[y])return m[y]<f[y]?-1:1;return m.length-f.length}),o}function S(o){return typeof o?.path=="string"}function N(o,r,$){const m=[],f=$.isSuspended(r);f!==!1&&(f==="polling"?m.push("[SUSPENDED <polling>]"):m.push("[SUSPENDED <non-polling>]")),o.push(` ${r.path}	${m.length>0?m.join(" ")+" ":""}(${A(r)})`)}function A(o){return`excludes: ${o.excludes.length>0?o.excludes:"<none>"}, includes: ${o.includes&&o.includes.length>0?JSON.stringify(o.includes):"<all>"}, filter: ${(0,g.$7q)(o.filter)}, correlationId: ${typeof o.correlationId=="number"?o.correlationId:"<none>"}`}function I(o,r){const $=U(Array.from(r.watchers.values())),{active:m,failed:f,stopped:_}=X(r);o.push(`
[Recursive Watchers (${$.length}, active: ${m}, failed: ${f}, stopped: ${_})]:`);for(const y of $){const s=[];y.failed&&s.push("[FAILED]"),y.stopped&&s.push("[STOPPED]"),y.subscriptionsCount>0&&s.push(`[SUBSCRIBED:${y.subscriptionsCount}]`),y.restarts>0&&s.push(`[RESTARTED:${y.restarts}]`),o.push(` ${y.request.path}	${s.length>0?s.join(" ")+" ":""}(${A(y.request)})`)}}function F(o,r){const $=U(Array.from(r.watchers.values())),m=$.filter(i=>!i.instance.failed&&!i.instance.isReusingRecursiveWatcher),f=$.filter(i=>i.instance.failed),_=$.filter(i=>i.instance.isReusingRecursiveWatcher),{active:y,failed:s,reusing:n}=k(r);o.push(`
[Non-Recursive Watchers (${$.length}, active: ${y}, failed: ${s}, reusing: ${n})]:`);for(const i of[m,f,_].flat()){const l=[];i.instance.failed&&l.push("[FAILED]"),i.instance.isReusingRecursiveWatcher&&l.push("[REUSING]"),o.push(` ${i.request.path}	${l.length>0?l.join(" ")+" ":""}(${A(i.request)})`)}}}),define(_e[63],Ee([0,1,4,6,61,60,8,62]),function(ae,e,g,t,W,M,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;class U extends g.$Vc{constructor(){super(...arguments),this.a=this.B(new W.$gkc),this.b=this.B(new M.$kr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$le),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(N){this.f=N;let A;try{await this.a.watch(N.filter(I=>I.recursive))}catch(I){A=I}try{await this.b.watch(N.filter(I=>!I.recursive))}catch(I){A||(A=I)}if(A)throw A}async setVerboseLogging(N){N&&this.f.length>0&&this.c.fire({type:"trace",message:(0,k.$hkc)(this.f,this.a,this.b)}),await X.Promises.settled([this.a.setVerboseLogging(N),this.b.setVerboseLogging(N)])}async stop(){await X.Promises.settled([this.a.stop(),this.b.stop()])}}e.$ikc=U}),define(_e[67],Ee([0,1,4,25,56,57,29,63]),function(ae,e,g,t,W,M,X,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;(0,X.$kX)(process)?U=new M.$lX:U=new W.$ar("watcher");const S=new k.$ikc;U.registerChannel("watcher",t.ProxyChannel.fromService(S,new g.$Uc))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fc357074a7bba115fe44683d3f6050c63e591683/core/vs/platform/files/node/watcher/watcherMain.js.map
