/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ce){for(var e=[],r=0,h=ce.length;r<h;r++)e[r]=Ee[ce[r]];return e};define(Ee[173],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=void 0,e.$U=!1;var r;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,N=new Map,T=new Map,$=new Map;function l(b,c){b.has(c.detail)||b.set(c.detail,-c.timestamp)}function I(b,c){const g=b.get(c.detail);g&&(g>=0||b.set(c.detail,g+c.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((b,c)=>b.timestamp-c.timestamp));for(const b of E)switch(b.type){case r.BeginLoadingScript:l(R,b);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,b);break;case r.BeginInvokeFactory:l(N,b);break;case r.EndInvokeFactory:I(N,b);break;case r.NodeBeginNativeRequire:l(T,b);break;case r.NodeEndNativeRequire:I(T,b);break;case r.NodeBeginEvaluatingScript:l($,b);break;case r.NodeEndEvaluatingScript:I($,b);break}let u=0;T.forEach(b=>u+=b);function k(b){const c=[];return b.forEach((g,f)=>c.push([f,g])),c}return{amdLoad:k(R),amdInvoke:k(N),nodeRequire:k(T),nodeEval:k($),nodeRequireTotal:u}}static toMarkdownTable(R,N){let T="";const $=[];return R.forEach((l,I)=>{$[I]=l.length}),N.forEach(l=>{l.forEach((I,E)=>{typeof I>"u"&&(I=l[E]="-");const u=I.toString().length;$[E]=Math.max(u,$[E])})}),R.forEach((l,I)=>{T+=`| ${l+" ".repeat($[I]-l.toString().length)} `}),T+=`|
`,R.forEach((l,I)=>{T+=`| ${"-".repeat($[I])} `}),T+=`|
`,N.forEach(l=>{l.forEach((I,E)=>{typeof I<"u"&&(T+=`| ${I+" ".repeat($[E]-I.toString().length)} `)}),T+=`|
`}),T}}e.$V=h}),define(Ee[132],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=r,e.$hb=h,e.$ib=A,e.$jb=R,e.$kb=N,e.$lb=T,e.$mb=$,e.$ob=I,e.$pb=E,e.$qb=u,e.$rb=k,e.$sb=b;function r(c,g){const f=h(c,g);if(f!==-1)return c[f]}function h(c,g,f=c.length-1){for(let m=f;m>=0;m--){const n=c[m];if(g(n))return m}return-1}function A(c,g){const f=R(c,g);return f===-1?void 0:c[f]}function R(c,g,f=0,m=c.length){let n=f,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(c[i])?n=i+1:o=i}return n-1}function N(c,g){const f=T(c,g);return f===c.length?void 0:c[f]}function T(c,g,f=0,m=c.length){let n=f,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(c[i])?o=i:n=i+1}return n}function $(c,g,f=0,m=c.length){const n=T(c,g,f,m);return n===c.length?-1:n}class l{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(l.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!g(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const f=R(this.e,g,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$nb=l;function I(c,g){if(c.length===0)return;let f=c[0];for(let m=1;m<c.length;m++){const n=c[m];g(n,f)>0&&(f=n)}return f}function E(c,g){if(c.length===0)return;let f=c[0];for(let m=1;m<c.length;m++){const n=c[m];g(n,f)>=0&&(f=n)}return f}function u(c,g){return I(c,(f,m)=>-g(f,m))}function k(c,g){if(c.length===0)return-1;let f=0;for(let m=1;m<c.length;m++){const n=c[m];g(n,c[f])>0&&(f=m)}return f}function b(c,g){for(const f of c){const m=g(f);if(m!==void 0)return m}}}),define(Ee[27],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Ee[79],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=r,e.$L=h,e.$M=A,e.$N=R;function r(N,T){const $=Object.create(null);for(const l of N){const I=T(l);let E=$[I];E||(E=$[I]=[]),E.push(l)}return $}function h(N,T){const $=[],l=[];for(const I of N)T.has(I)||$.push(I);for(const I of T)N.has(I)||l.push(I);return{removed:$,added:l}}function A(N,T){const $=[],l=[];for(const[I,E]of N)T.has(I)||$.push(E);for(const[I,E]of T)N.has(I)||l.push(E);return{removed:$,added:l}}function R(N,T){const $=new Set;for(const l of T)N.has(l)&&$.add(l);return $}}),define(Ee[59],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=h,e.$0h=A,e.$$h=R;function r(N){return(T,$,l)=>{let I=null,E=null;if(typeof l.value=="function"?(I="value",E=l.value):typeof l.get=="function"&&(I="get",E=l.get),!E)throw new Error("not supported");l[I]=N(E,$)}}function h(N,T,$){let l=null,I=null;if(typeof $.value=="function"?(l="value",I=$.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(l="get",I=$.get),!I)throw new Error("not supported");const E=`$memoize$${T}`;$[l]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[E]}}function A(N,T,$){return r((l,I)=>{const E=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...k){this[u]||(this[u]=$?$():void 0),clearTimeout(this[E]),T&&(this[u]=T(this[u],...k),k=[this[u]]),this[E]=setTimeout(()=>{l.apply(this,k),this[u]=$?$():void 0},N)}})}function R(N,T,$){return r((l,I)=>{const E=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,b=`$throttle$pending$${I}`;return function(...c){if(this[u]||(this[u]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...c)),this[b])return;const g=this[k]+N;g<=Date.now()?(this[k]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[k]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0},g-Date.now()))}})}}),define(Ee[14],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=h,e.$1=A,e.$2=R,e.$3=N,e.$4=T,e.$5=l,e.$7=E,e.$8=u,e.$9=k,e.$$=c;class r{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=r,e.$Y=new r;function h(i){e.$Y.setUnexpectedErrorHandler(i)}function A(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(i){l(i)||e.$Y.onUnexpectedError(i)}function N(i){l(i)||e.$Y.onUnexpectedExternalError(i)}function T(i){if(i instanceof Error){const{name:t,message:s}=i,d=i.stacktrace||i.stack;return{$isError:!0,name:t,message:s,stack:d,noTelemetry:n.isErrorNoTelemetry(i)}}return i}const $="Canceled";function l(i){return i instanceof I?!0:i instanceof Error&&i.name===$&&i.message===$}class I extends Error{constructor(){super($),this.name=this.message}}e.$6=I;function E(){const i=new Error($);return i.name=i.message,i}function u(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function k(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class b extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=b;function c(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$_=g;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$ab=f;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=m;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$cb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$db=o}),define(Ee[19],Se([1,0,14,132]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=A,e.$ub=R,e.$vb=N,e.$wb=T,e.$xb=$,e.$yb=l,e.$zb=I,e.$Ab=E,e.$Bb=u,e.$Cb=k,e.$Db=b,e.$Eb=c,e.$Fb=g,e.top=f,e.$Hb=m,e.$Ib=o,e.$Jb=i,e.$Kb=t,e.$Lb=s,e.$Mb=d,e.$Nb=a,e.$Ob=w,e.$Pb=y,e.$Qb=S,e.$Rb=D,e.$Sb=P,e.$Tb=C,e.$Ub=p,e.$Vb=v,e.$Wb=O,e.$Xb=L,e.$Yb=F,e.$Zb=j,e.$1b=B,e.$2b=M,e.$3b=z,e.$4b=_,e.$5b=re,e.$6b=U,e.$7b=ee,e.$8b=ue,e.$$b=$e;function A(oe,te=0){return oe[oe.length-(1+te)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function N(oe,te,le=(he,Z)=>he===Z){if(oe===te)return!0;if(!oe||!te||oe.length!==te.length)return!1;for(let he=0,Z=oe.length;he<Z;he++)if(!le(oe[he],te[he]))return!1;return!0}function T(oe,te){const le=oe.length-1;te<le&&(oe[te]=oe[le]),oe.pop()}function $(oe,te,le){return l(oe.length,he=>le(oe[he],te))}function l(oe,te){let le=0,he=oe-1;for(;le<=he;){const Z=(le+he)/2|0,ae=te(Z);if(ae<0)le=Z+1;else if(ae>0)he=Z-1;else return Z}return-(le+1)}function I(oe,te,le){if(oe=oe|0,oe>=te.length)throw new TypeError("invalid index");const he=te[Math.floor(te.length*Math.random())],Z=[],ae=[],pe=[];for(const be of te){const Me=le(be,he);Me<0?Z.push(be):Me>0?ae.push(be):pe.push(be)}return oe<Z.length?I(oe,Z,le):oe<Z.length+pe.length?pe[0]:I(oe-(Z.length+pe.length),ae,le)}function E(oe,te){const le=[];let he;for(const Z of oe.slice(0).sort(te))!he||te(he[0],Z)!==0?(he=[Z],le.push(he)):he.push(Z);return le}function*u(oe,te){let le,he;for(const Z of oe)he!==void 0&&te(he,Z)?le.push(Z):(le&&(yield le),le=[Z]),he=Z;le&&(yield le)}function k(oe,te){for(let le=0;le<=oe.length;le++)te(le===0?void 0:oe[le-1],le===oe.length?void 0:oe[le])}function b(oe,te){for(let le=0;le<oe.length;le++)te(le===0?void 0:oe[le-1],oe[le],le+1===oe.length?void 0:oe[le+1])}function c(oe,te,le){const he=[];function Z(be,Me,ze){if(Me===0&&ze.length===0)return;const ke=he[he.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Me,ke.toInsert.push(...ze)):he.push({start:be,deleteCount:Me,toInsert:ze})}let ae=0,pe=0;for(;;){if(ae===oe.length){Z(ae,0,te.slice(pe));break}if(pe===te.length){Z(ae,oe.length-ae,[]);break}const be=oe[ae],Me=te[pe],ze=le(be,Me);ze===0?(ae+=1,pe+=1):ze<0?(Z(ae,1,[]),ae+=1):ze>0&&(Z(ae,0,[Me]),pe+=1)}return he}function g(oe,te,le){const he=c(oe,te,le),Z=[],ae=[];for(const pe of he)Z.push(...oe.slice(pe.start,pe.start+pe.deleteCount)),ae.push(...pe.toInsert);return{removed:Z,added:ae}}function f(oe,te,le){if(le===0)return[];const he=oe.slice(0,le).sort(te);return n(oe,te,he,le,oe.length),he}function m(oe,te,le,he,Z){return le===0?Promise.resolve([]):new Promise((ae,pe)=>{(async()=>{const be=oe.length,Me=oe.slice(0,le).sort(te);for(let ze=le,ke=Math.min(le+he,be);ze<be;ze=ke,ke=Math.min(ke+he,be)){if(ze>le&&await new Promise(Ie=>setTimeout(Ie)),Z&&Z.isCancellationRequested)throw new r.$6;n(oe,te,Me,ze,ke)}return Me})().then(ae,pe)})}function n(oe,te,le,he,Z){for(const ae=le.length;he<Z;he++){const pe=oe[he];if(te(pe,le[ae-1])<0){le.pop();const be=(0,h.$lb)(le,Me=>te(pe,Me)<0);le.splice(be,0,pe)}}}function o(oe){return oe.filter(te=>!!te)}function i(oe){let te=0;for(let le=0;le<oe.length;le++)oe[le]&&(oe[te]=oe[le],te+=1);oe.length=te}function t(oe,te,le){oe.splice(le,0,oe.splice(te,1)[0])}function s(oe){return!Array.isArray(oe)||oe.length===0}function d(oe){return Array.isArray(oe)&&oe.length>0}function a(oe,te=le=>le){const le=new Set;return oe.filter(he=>{const Z=te(he);return le.has(Z)?!1:(le.add(Z),!0)})}function w(oe){const te=new Set;return le=>{const he=oe(le);return te.has(he)?!1:(te.add(he),!0)}}function y(oe,te){return oe.length>0?oe[0]:te}function S(oe,te){return oe.length>0?oe[oe.length-1]:te}function D(oe,te,le=(he,Z)=>he===Z){let he=0;for(let Z=0,ae=Math.min(oe.length,te.length);Z<ae&&le(oe[Z],te[Z]);Z++)he++;return he}function P(oe,te){let le=typeof te=="number"?oe:0;typeof te=="number"?le=oe:(le=0,te=oe);const he=[];if(le<=te)for(let Z=le;Z<te;Z++)he.push(Z);else for(let Z=le;Z>te;Z--)he.push(Z);return he}function C(oe,te,le){return oe.reduce((he,Z)=>(he[te(Z)]=le?le(Z):Z,he),Object.create(null))}function p(oe,te){return oe.push(te),()=>v(oe,te)}function v(oe,te){const le=oe.indexOf(te);if(le>-1)return oe.splice(le,1),te}function O(oe,te,le){const he=oe.slice(0,te),Z=oe.slice(te);return he.concat(le,Z)}function L(oe,te){let le;if(typeof te=="number"){let he=te;le=()=>{const Z=Math.sin(he++)*179426549;return Z-Math.floor(Z)}}else le=Math.random;for(let he=oe.length-1;he>0;he-=1){const Z=Math.floor(le()*(he+1)),ae=oe[he];oe[he]=oe[Z],oe[Z]=ae}}function F(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.unshift(te))}function j(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.push(te))}function B(oe,te){for(const le of te)oe.push(le)}function M(oe,te){return Array.isArray(oe)?oe.map(te):te(oe)}function z(oe){return Array.isArray(oe)?oe:[oe]}function _(oe){return oe[Math.floor(Math.random()*oe.length)]}function re(oe,te,le){const he=G(oe,te),Z=oe.length,ae=le.length;oe.length=Z+ae;for(let pe=Z-1;pe>=he;pe--)oe[pe+ae]=oe[pe];for(let pe=0;pe<ae;pe++)oe[pe+he]=le[pe]}function U(oe,te,le,he){const Z=G(oe,te);let ae=oe.splice(Z,le);return ae===void 0&&(ae=[]),re(oe,Z,he),ae}function G(oe,te){return te<0?Math.max(te+oe.length,0):Math.min(te,oe.length)}var K;(function(oe){function te(ae){return ae<0}oe.isLessThan=te;function le(ae){return ae<=0}oe.isLessThanOrEqual=le;function he(ae){return ae>0}oe.isGreaterThan=he;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function ee(oe,te){return(le,he)=>te(oe(le),oe(he))}function ue(...oe){return(te,le)=>{for(const he of oe){const Z=he(te,le);if(!K.isNeitherLessOrGreaterThan(Z))return Z}return K.neitherLessOrGreaterThan}}const ne=(oe,te)=>oe-te;e.$9b=ne;const De=(oe,te)=>(0,e.$9b)(oe?1:0,te?1:0);e.$0b=De;function $e(oe){return(te,le)=>-oe(te,le)}class J{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.g.length&&te(this.g[le]);)le++;const he=le===this.c?null:this.g.slice(this.c,le);return this.c=le,he}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.g[le]);)le--;const he=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,he}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const le=this.g.slice(this.c,this.c+te);return this.c+=te,le}}e.$_b=J;class W{static{this.empty=new W(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new W(le=>this.iterate(he=>te(he)?le(he):!0))}map(te){return new W(le=>this.iterate(he=>le(te(he))))}some(te){let le=!1;return this.iterate(he=>(le=te(he),!le)),le}findFirst(te){let le;return this.iterate(he=>te(he)?(le=he,!1):!0),le}findLast(te){let le;return this.iterate(he=>(te(he)&&(le=he),!0)),le}findLastMaxBy(te){let le,he=!0;return this.iterate(Z=>((he||K.isGreaterThan(te(Z,le)))&&(he=!1,le=Z),!0)),le}}e.$ac=W;class se{constructor(te){this.c=te}static createSortPermutation(te,le){const he=Array.from(te.keys()).sort((Z,ae)=>le(te[Z],te[ae]));return new se(he)}apply(te){return te.map((le,he)=>te[this.c[he]])}inverse(){const te=this.c.slice();for(let le=0;le<this.c.length;le++)te[this.c[le]]=le;return new se(te)}}e.$bc=se}),define(Ee[66],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$fd=A,e.$gd=R,e.$hd=N,e.$id=T,e.$jd=$;function h(l,I){if(!l)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function A(l,I="Unreachable"){throw new Error(I)}function R(l,I="unexpected state"){if(!l)throw new r.$db(`Assertion Failed: ${I}`)}function N(l){l||(0,r.$2)(new r.$db("Soft Assertion Failed"))}function T(l){if(!l()){debugger;l(),(0,r.$2)(new r.$db("Assertion Failed"))}}function $(l,I){let E=0;for(;E<l.length-1;){const u=l[E],k=l[E+1];if(!I(u,k))return!1;E++}return!0}});var Un=this&&this.__createBinding||(Object.create?function(ce,e,r,h){h===void 0&&(h=r);var A=Object.getOwnPropertyDescriptor(e,r);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ce,h,A)}:function(ce,e,r,h){h===void 0&&(h=r),ce[h]=e[r]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),We=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var r in ce)r!=="default"&&Object.prototype.hasOwnProperty.call(ce,r)&&Un(e,ce,r);return Wn(e,ce),e};define(Ee[174],Se([1,0,19]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=A,e.$9c=R,e.$0c=N,e.$$c=T,e.$_c=$,e.$ad=l,r=We(r);const h=(k,b)=>k===b;e.$7c=h;function A(k=e.$7c){return(b,c)=>r.$vb(b,c,k)}function R(){return(k,b)=>JSON.stringify(k)===JSON.stringify(b)}function N(){return(k,b)=>k.equals(b)}function T(k,b,c){if(c!==void 0){const g=k;return g==null||b===void 0||b===null?b===g:c(g,b)}else{const g=k;return(f,m)=>f==null||m===void 0||m===null?m===f:g(f,m)}}function $(k,b){if(k===b)return!0;if(Array.isArray(k)&&Array.isArray(b)){if(k.length!==b.length)return!1;for(let c=0;c<k.length;c++)if(!$(k[c],b[c]))return!1;return!0}if(k&&typeof k=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const c=k,g=b,f=Object.keys(c),m=Object.keys(g),n=new Set(m);if(f.length!==m.length)return!1;for(const o of f)if(!n.has(o)||!$(c[o],g[o]))return!1;return!0}return!1}function l(k){return JSON.stringify(u(k))}let I=0;const E=new WeakMap;function u(k){if(Array.isArray(k))return k.map(u);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const b=k,c=Object.create(null);for(const g of Object.keys(b).sort())c[g]=u(b[g]);return c}else{let b=E.get(k);return b===void 0&&(b=I++,E.set(k,b)),b+"----2b76a038c20c4bcc"}return k}}),define(Ee[80],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=r;function r(h,A){const R=this;let N=!1,T;return function(){if(N)return T;if(N=!0,A)try{T=h.apply(R,arguments)}finally{A()}else T=h.apply(R,arguments);return T}}}),define(Ee[133],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0;class r{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$zP=r,e.$AP=new r("id#")}),define(Ee[40],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}h.is=A;const R=Object.freeze([]);function N(){return R}h.empty=N;function*T(s){yield s}h.single=T;function $(s){return A(s)?s:T(s)}h.wrap=$;function l(s){return s||R}h.from=l;function*I(s){for(let d=s.length-1;d>=0;d--)yield s[d]}h.reverse=I;function E(s){return!s||s[Symbol.iterator]().next().done===!0}h.isEmpty=E;function u(s){return s[Symbol.iterator]().next().value}h.first=u;function k(s,d){let a=0;for(const w of s)if(d(w,a++))return!0;return!1}h.some=k;function b(s,d){for(const a of s)if(d(a))return a}h.find=b;function*c(s,d){for(const a of s)d(a)&&(yield a)}h.filter=c;function*g(s,d){let a=0;for(const w of s)yield d(w,a++)}h.map=g;function*f(s,d){let a=0;for(const w of s)yield*d(w,a++)}h.flatMap=f;function*m(...s){for(const d of s)yield*d}h.concat=m;function n(s,d,a){let w=a;for(const y of s)w=d(w,y);return w}h.reduce=n;function*o(s,d,a=s.length){for(d<0&&(d+=s.length),a<0?a+=s.length:a>s.length&&(a=s.length);d<a;d++)yield s[d]}h.slice=o;function i(s,d=Number.POSITIVE_INFINITY){const a=[];if(d===0)return[a,s];const w=s[Symbol.iterator]();for(let y=0;y<d;y++){const S=w.next();if(S.done)return[a,h.empty()];a.push(S.value)}return[a,{[Symbol.iterator](){return w}}]}h.consume=i;async function t(s){const d=[];for await(const a of s)d.push(a);return Promise.resolve(d)}h.asyncToArray=t})(r||(e.Iterable=r={}))}),define(Ee[175],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=N,e.$Tn=E,e.$Un=u,e.$Vn=k,e.$Wn=b,e.$Xn=c,e.$Yn=g,e.$Zn=f,e.$1n=m,e.$2n=n,e.$3n=o,e.$4n=i;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function N(t,s=!1){let d=0;const a=t.length;let w="",y=0,S=h.Unknown,D=r.None;function P(j){let B=0,M=0;for(;B<j;){const z=t.charCodeAt(d);if(z>=I._0&&z<=I._9)M=M*16+z-I._0;else if(z>=I.A&&z<=I.F)M=M*16+z-I.A+10;else if(z>=I.a&&z<=I.f)M=M*16+z-I.a+10;else break;d++,B++}return B<j&&(M=-1),M}function C(j){d=j,w="",y=0,S=h.Unknown,D=r.None}function p(){const j=d;if(t.charCodeAt(d)===I._0)d++;else for(d++;d<t.length&&l(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===I.dot)if(d++,d<t.length&&l(t.charCodeAt(d)))for(d++;d<t.length&&l(t.charCodeAt(d));)d++;else return D=r.UnexpectedEndOfNumber,t.substring(j,d);let B=d;if(d<t.length&&(t.charCodeAt(d)===I.E||t.charCodeAt(d)===I.e))if(d++,(d<t.length&&t.charCodeAt(d)===I.plus||t.charCodeAt(d)===I.minus)&&d++,d<t.length&&l(t.charCodeAt(d))){for(d++;d<t.length&&l(t.charCodeAt(d));)d++;B=d}else D=r.UnexpectedEndOfNumber;return t.substring(j,B)}function v(){let j="",B=d;for(;;){if(d>=a){j+=t.substring(B,d),D=r.UnexpectedEndOfString;break}const M=t.charCodeAt(d);if(M===I.doubleQuote){j+=t.substring(B,d),d++;break}if(M===I.backslash){if(j+=t.substring(B,d),d++,d>=a){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(d++)){case I.doubleQuote:j+='"';break;case I.backslash:j+="\\";break;case I.slash:j+="/";break;case I.b:j+="\b";break;case I.f:j+="\f";break;case I.n:j+=`
`;break;case I.r:j+="\r";break;case I.t:j+="	";break;case I.u:{const _=P(4);_>=0?j+=String.fromCharCode(_):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}B=d;continue}if(M>=0&&M<=31)if($(M)){j+=t.substring(B,d),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;d++}return j}function O(){if(w="",D=r.None,y=d,d>=a)return y=a,S=h.EOF;let j=t.charCodeAt(d);if(T(j)){do d++,w+=String.fromCharCode(j),j=t.charCodeAt(d);while(T(j));return S=h.Trivia}if($(j))return d++,w+=String.fromCharCode(j),j===I.carriageReturn&&t.charCodeAt(d)===I.lineFeed&&(d++,w+=`
`),S=h.LineBreakTrivia;switch(j){case I.openBrace:return d++,S=h.OpenBraceToken;case I.closeBrace:return d++,S=h.CloseBraceToken;case I.openBracket:return d++,S=h.OpenBracketToken;case I.closeBracket:return d++,S=h.CloseBracketToken;case I.colon:return d++,S=h.ColonToken;case I.comma:return d++,S=h.CommaToken;case I.doubleQuote:return d++,w=v(),S=h.StringLiteral;case I.slash:{const B=d-1;if(t.charCodeAt(d+1)===I.slash){for(d+=2;d<a&&!$(t.charCodeAt(d));)d++;return w=t.substring(B,d),S=h.LineCommentTrivia}if(t.charCodeAt(d+1)===I.asterisk){d+=2;const M=a-1;let z=!1;for(;d<M;){if(t.charCodeAt(d)===I.asterisk&&t.charCodeAt(d+1)===I.slash){d+=2,z=!0;break}d++}return z||(d++,D=r.UnexpectedEndOfComment),w=t.substring(B,d),S=h.BlockCommentTrivia}return w+=String.fromCharCode(j),d++,S=h.Unknown}case I.minus:if(w+=String.fromCharCode(j),d++,d===a||!l(t.charCodeAt(d)))return S=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return w+=p(),S=h.NumericLiteral;default:for(;d<a&&L(j);)d++,j=t.charCodeAt(d);if(y!==d){switch(w=t.substring(y,d),w){case"true":return S=h.TrueKeyword;case"false":return S=h.FalseKeyword;case"null":return S=h.NullKeyword}return S=h.Unknown}return w+=String.fromCharCode(j),d++,S=h.Unknown}}function L(j){if(T(j)||$(j))return!1;switch(j){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function F(){let j;do j=O();while(j>=h.LineCommentTrivia&&j<=h.Trivia);return j}return{setPosition:C,getPosition:()=>d,scan:s?F:O,getToken:()=>S,getTokenValue:()=>w,getTokenOffset:()=>y,getTokenLength:()=>d-y,getTokenError:()=>D}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function $(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function l(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,s){const d=[],a=new Object;let w;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(P,C,p,v){y.value=P,y.offset=C,y.length=p,y.type=v,y.colonOffset=void 0,w=y}try{n(t,{onObjectBegin:(P,C)=>{if(s<=P)throw a;w=void 0,S=s>P,d.push("")},onObjectProperty:(P,C,p)=>{if(s<C||(D(P,C,p,"property"),d[d.length-1]=P,s<=C+p))throw a},onObjectEnd:(P,C)=>{if(s<=P)throw a;w=void 0,d.pop()},onArrayBegin:(P,C)=>{if(s<=P)throw a;w=void 0,d.push(0)},onArrayEnd:(P,C)=>{if(s<=P)throw a;w=void 0,d.pop()},onLiteralValue:(P,C,p)=>{if(s<C||(D(P,C,p,i(P)),s<=C+p))throw a},onSeparator:(P,C,p)=>{if(s<=C)throw a;if(P===":"&&w&&w.type==="property")w.colonOffset=C,S=!1,w=void 0;else if(P===","){const v=d[d.length-1];typeof v=="number"?d[d.length-1]=v+1:(S=!0,d[d.length-1]=""),w=void 0}}})}catch(P){if(P!==a)throw P}return{path:d,previousNode:w,isAtPropertyKey:S,matches:P=>{let C=0;for(let p=0;C<P.length&&p<d.length;p++)if(P[C]===d[p]||P[C]==="*")C++;else if(P[C]!=="**")return!1;return C===P.length}}}function u(t,s=[],d=R.DEFAULT){let a=null,w=[];const y=[];function S(P){Array.isArray(w)?w.push(P):a!==null&&(w[a]=P)}return n(t,{onObjectBegin:()=>{const P={};S(P),y.push(w),w=P,a=null},onObjectProperty:P=>{a=P},onObjectEnd:()=>{w=y.pop()},onArrayBegin:()=>{const P=[];S(P),y.push(w),w=P,a=null},onArrayEnd:()=>{w=y.pop()},onLiteralValue:S,onError:(P,C,p)=>{s.push({error:P,offset:C,length:p})}},d),w[0]}function k(t,s=[],d=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(P){a.type==="property"&&(a.length=P-a.offset,a=a.parent)}function y(P){return a.children.push(P),P}n(t,{onObjectBegin:P=>{a=y({type:"object",offset:P,length:-1,parent:a,children:[]})},onObjectProperty:(P,C,p)=>{a=y({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:P,offset:C,length:p,parent:a})},onObjectEnd:(P,C)=>{a.length=P+C-a.offset,a=a.parent,w(P+C)},onArrayBegin:(P,C)=>{a=y({type:"array",offset:P,length:-1,parent:a,children:[]})},onArrayEnd:(P,C)=>{a.length=P+C-a.offset,a=a.parent,w(P+C)},onLiteralValue:(P,C,p)=>{y({type:i(P),offset:C,length:p,parent:a,value:P}),w(C+p)},onSeparator:(P,C,p)=>{a.type==="property"&&(P===":"?a.colonOffset=C:P===","&&w(C))},onError:(P,C,p)=>{s.push({error:P,offset:C,length:p})}},d);const D=a.children[0];return D&&delete D.parent,D}function b(t,s){if(!t)return;let d=t;for(const a of s)if(typeof a=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let w=!1;for(const y of d.children)if(Array.isArray(y.children)&&y.children[0].value===a){d=y.children[1],w=!0;break}if(!w)return}else{const w=a;if(d.type!=="array"||w<0||!Array.isArray(d.children)||w>=d.children.length)return;d=d.children[w]}return d}function c(t){if(!t.parent||!t.parent.children)return[];const s=c(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;s.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&s.push(d)}return s}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const s=Object.create(null);for(const d of t.children){const a=d.children[1];a&&(s[d.children[0].value]=g(a))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,d=!1){return s>=t.offset&&s<t.offset+t.length||d&&s===t.offset+t.length}function m(t,s,d=!1){if(f(t,s,d)){const a=t.children;if(Array.isArray(a))for(let w=0;w<a.length&&a[w].offset<=s;w++){const y=m(a[w],s,d);if(y)return y}return t}}function n(t,s,d=R.DEFAULT){const a=N(t,!1);function w(ue){return ue?()=>ue(a.getTokenOffset(),a.getTokenLength()):()=>!0}function y(ue){return ue?ne=>ue(ne,a.getTokenOffset(),a.getTokenLength()):()=>!0}const S=w(s.onObjectBegin),D=y(s.onObjectProperty),P=w(s.onObjectEnd),C=w(s.onArrayBegin),p=w(s.onArrayEnd),v=y(s.onLiteralValue),O=y(s.onSeparator),L=w(s.onComment),F=y(s.onError),j=d&&d.disallowComments,B=d&&d.allowTrailingComma;function M(){for(;;){const ue=a.scan();switch(a.getTokenError()){case r.InvalidUnicode:z(A.InvalidUnicode);break;case r.InvalidEscapeCharacter:z(A.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:z(A.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||z(A.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:z(A.UnexpectedEndOfString);break;case r.InvalidCharacter:z(A.InvalidCharacter);break}switch(ue){case h.LineCommentTrivia:case h.BlockCommentTrivia:j?z(A.InvalidCommentToken):L();break;case h.Unknown:z(A.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ue}}}function z(ue,ne=[],De=[]){if(F(ue),ne.length+De.length>0){let $e=a.getToken();for(;$e!==h.EOF;){if(ne.indexOf($e)!==-1){M();break}else if(De.indexOf($e)!==-1)break;$e=M()}}}function _(ue){const ne=a.getTokenValue();return ue?v(ne):D(ne),M(),!0}function re(){switch(a.getToken()){case h.NumericLiteral:{let ue=0;try{ue=JSON.parse(a.getTokenValue()),typeof ue!="number"&&(z(A.InvalidNumberFormat),ue=0)}catch{z(A.InvalidNumberFormat)}v(ue);break}case h.NullKeyword:v(null);break;case h.TrueKeyword:v(!0);break;case h.FalseKeyword:v(!1);break;default:return!1}return M(),!0}function U(){return a.getToken()!==h.StringLiteral?(z(A.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(_(!1),a.getToken()===h.ColonToken?(O(":"),M(),ee()||z(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):z(A.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function G(){S(),M();let ue=!1;for(;a.getToken()!==h.CloseBraceToken&&a.getToken()!==h.EOF;){if(a.getToken()===h.CommaToken){if(ue||z(A.ValueExpected,[],[]),O(","),M(),a.getToken()===h.CloseBraceToken&&B)break}else ue&&z(A.CommaExpected,[],[]);U()||z(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ue=!0}return P(),a.getToken()!==h.CloseBraceToken?z(A.CloseBraceExpected,[h.CloseBraceToken],[]):M(),!0}function K(){C(),M();let ue=!1;for(;a.getToken()!==h.CloseBracketToken&&a.getToken()!==h.EOF;){if(a.getToken()===h.CommaToken){if(ue||z(A.ValueExpected,[],[]),O(","),M(),a.getToken()===h.CloseBracketToken&&B)break}else ue&&z(A.CommaExpected,[],[]);ee()||z(A.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ue=!0}return p(),a.getToken()!==h.CloseBracketToken?z(A.CloseBracketExpected,[h.CloseBracketToken],[]):M(),!0}function ee(){switch(a.getToken()){case h.OpenBracketToken:return K();case h.OpenBraceToken:return G();case h.StringLiteral:return _(!0);default:return re()}}return M(),a.getToken()===h.EOF?d.allowEmptyContent?!0:(z(A.ValueExpected,[],[]),!1):ee()?(a.getToken()!==h.EOF&&z(A.EndOfFileExpected,[],[]),!0):(z(A.ValueExpected,[],[]),!1)}function o(t,s){const d=N(t),a=[];let w,y=0,S;do switch(S=d.getPosition(),w=d.scan(),w){case h.LineCommentTrivia:case h.BlockCommentTrivia:case h.EOF:y!==S&&a.push(t.substring(y,S)),s!==void 0&&a.push(d.getTokenValue().replace(/[^\r\n]/g,s)),y=d.getPosition();break}while(w!==h.EOF);return a.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[49],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class r{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=r}),define(Ee[81],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const N=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=N}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,N){const T=new r(R);if(this.a===r.Undefined)this.a=T,this.b=T;else if(N){const l=this.b;this.b=T,T.prev=l,l.next=T}else{const l=this.a;this.a=T,T.next=l,l.prev=T}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(T))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const N=R.prev;N.next=R.next,R.next.prev=N}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$6c=h}),define(Ee[29],Se([1,0]),function(ce,e){"use strict";var r,h,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=N,e.$Ac=T,e.$Jc=o;function R(i,t,s){let d=i.get(t);return d===void 0&&(d=s,i.set(t,d)),d}function N(i){const t=[];return i.forEach((s,d)=>{t.push(`${d} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}function T(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}class ${constructor(t,s){this.uri=t,this.value=s}}function l(i){return Array.isArray(i)}class I{static{this.c=t=>t.toString()}constructor(t,s){if(this[r]="ResourceMap",t instanceof I)this.d=new Map(t.d),this.e=s??I.c;else if(l(t)){this.d=new Map,this.e=s??I.c;for(const[d,a]of t)this.set(d,a)}else this.d=new Map,this.e=t??I.c}set(t,s){return this.d.set(this.e(t),new $(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[d,a]of this.d)t(a.value,a.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=I;class E{constructor(t,s){this[h]="ResourceSet",!t||typeof t=="function"?this.c=new I(t):(this.c=new I(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((d,a)=>t.call(s,a,a,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=E;var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class k{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=u.None){const d=this.c.get(t);if(d)return s!==u.None&&this.m(d,s),d.value}set(t,s,d=u.None){let a=this.c.get(t);if(a)a.value=s,d!==u.None&&this.m(a,d);else{switch(a={key:t,value:s,next:void 0,previous:void 0},d){case u.None:this.k(a);break;case u.AsOld:this.j(a);break;case u.AsNew:this.k(a);break;default:this.k(a);break}this.c.set(t,a),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const d=this.g;let a=this.d;for(;a;){if(s?t.bind(s)(a.value,a.key,this):t(a.value,a.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,s=this.g;let d=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.key,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return a}values(){const t=this,s=this.g;let d=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.value,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return a}entries(){const t=this,s=this.g;let d=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:[d.key,d.value],done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,d=this.size;for(;s&&d>t;)this.c.delete(s.key),s=s.next,d--;this.d=s,this.f=d,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,d=this.size;for(;s&&d>t;)this.c.delete(s.key),s=s.previous,d--;this.e=s,this.f=d,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,d=t.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==u.AsOld&&s!==u.AsNew)){if(s===u.AsOld){if(t===this.d)return;const d=t.next,a=t.previous;t===this.e?(a.next=void 0,this.e=a):(d.previous=a,a.next=d),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===u.AsNew){if(t===this.e)return;const d=t.next,a=t.previous;t===this.d?(d.previous=void 0,this.d=d):(d.previous=a,a.next=d),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,d)=>{t.push([d,s])}),t}fromJSON(t){this.clear();for(const[s,d]of t)this.set(s,d)}}e.$Dc=k;class b extends k{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=u.AsNew){return super.get(t,s)}peek(t){return super.get(t,u.None)}set(t,s){return super.set(t,s,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends b{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Ec=c;class g extends b{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Fc=g;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Gc=f;class m{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,d]of t)this.set(s,d)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((d,a)=>{t.call(s,d,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=m;class n{constructor(){this.c=new Map}add(t,s){let d=this.c.get(t);d||(d=new Set,this.c.set(t,d)),d.add(s)}delete(t,s){const d=this.c.get(t);d&&(d.delete(s),d.size===0&&this.c.delete(t))}forEach(t,s){const d=this.c.get(t);d&&d.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Ic=n;function o(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[s,d]of i)if(!t.has(s)||t.get(s)!==d)return!1;for(const[s]of t)if(!i.has(s))return!1;return!0}}),define(Ee[3],Se([1,0,19,79,29,80,40]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=I,e.$Mc=E,e.$Nc=u,e.$Oc=c,e.$Pc=g,e.$Qc=f,e.$Rc=m,e.$Sc=n,e.$Tc=o,e.$4c=P;const T=!1;let $=null;class l{constructor(){this.b=new Map}static{this.a=0}c(v){let O=this.b.get(v);return O||(O={parent:null,source:null,isSingleton:!1,value:v,idx:l.a++},this.b.set(v,O)),O}trackDisposable(v){const O=this.c(v);O.source||(O.source=new Error().stack)}setParent(v,O){const L=this.c(v);L.parent=O}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,O){const L=O.get(v);if(L)return L;const F=v.parent?this.f(this.c(v.parent),O):v;return O.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,v).isSingleton).flatMap(([L])=>L)}computeLeakingDisposables(v=10,O){let L;if(O)L=O;else{const z=new Map,_=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,z).isSingleton);if(_.length===0)return;const re=new Set(_.map(U=>U.value));if(L=_.filter(U=>!(U.parent&&re.has(U.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function F(z){function _(U,G){for(;U.length>0&&G.some(K=>typeof K=="string"?K===U[0]:U[0].match(K));)U.shift()}const re=z.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return _(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const j=new A.$Ic;for(const z of L){const _=F(z);for(let re=0;re<=_.length;re++)j.add(_.slice(0,re).join(`
`),z)}L.sort((0,r.$7b)(z=>z.idx,r.$9b));let B="",M=0;for(const z of L.slice(0,v)){M++;const _=F(z),re=[];for(let U=0;U<_.length;U++){let G=_[U];G=`(shared with ${j.get(_.slice(0,U+1).join(`
`)).size}/${L.length} leaks) at ${G}`;const ee=j.get(_.slice(0,U).join(`
`)),ue=(0,h.$K)([...ee].map(ne=>F(ne)[U]),ne=>ne);delete ue[_[U]];for(const[ne,De]of Object.entries(ue))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(G)}B+=`


==================== Leaking disposable ${M}/${L.length}: ${z.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return L.length>v&&(B+=`


... and ${L.length-v} more leaking disposables

`),{leaks:L,details:B}}}e.$Kc=l;function I(p){$=p}if(T){const p="__is_disposable_tracked__";I(new class{trackDisposable(v){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(O)},3e3)}setParent(v,O){if(v&&v!==t.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function E(p){return $?.trackDisposable(p),p}function u(p){$?.markAsDisposed(p)}function k(p,v){$?.setParent(p,v)}function b(p,v){if($)for(const O of p)$.setParent(O,v)}function c(p){return $?.markAsSingleton(p),p}function g(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function f(p){if(N.Iterable.is(p)){const v=[];for(const O of p)if(O)try{O.dispose()}catch(L){v.push(L)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function m(p){for(const v of p)g(v)&&v.dispose();return[]}function n(...p){const v=o(()=>f(p));return b(p,v),v}function o(p){const v=E({dispose:(0,R.$eb)(()=>{u(v),p()})});return v}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return k(v,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),k(v,null))}}e.$Uc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,E(this),k(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Vc=t;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&k(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&k(v,null),v}}e.$Wc=s;class d{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=d;class a{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=a;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(v){let O=v;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,u(this))},this}}e.$Zc=w;class y{constructor(){this.a=new Map}acquire(v,...O){let L=this.a.get(v);L||(L={counter:0,object:this.b(v,...O)},this.a.set(v,L));const{object:F}=L,j=(0,R.$eb)(()=>{--L.counter===0&&(this.c(v,L.object),this.a.delete(v))});return L.counter++,{object:F,dispose:j}}}e.$1c=y;class S{constructor(v){this.a=v}async acquire(v,...O){const L=this.a.acquire(v,...O);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(F){throw L.dispose(),F}}}e.$2c=S;class D{constructor(v){this.object=v}dispose(){}}e.$3c=D;function P(p){const v=new i;try{p(v)}finally{v.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,O,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(v)?.dispose(),this.a.set(v,O)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const O=this.a.get(v);return this.a.delete(v),O}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=C}),function(ce,e){typeof define=="function"&&define.amd?define(Ee[176],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(te,le){for(var he=0;he<le.length;he++){var Z=le[he];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(te,Z.key,Z)}}function r(te,le,he){return le&&e(te.prototype,le),he&&e(te,he),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,le){if(te){if(typeof te=="string")return A(te,le);var he=Object.prototype.toString.call(te).slice(8,-1);if(he==="Object"&&te.constructor&&(he=te.constructor.name),he==="Map"||he==="Set")return Array.from(te);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return A(te,le)}}function A(te,le){(le==null||le>te.length)&&(le=te.length);for(var he=0,Z=new Array(le);he<le;he++)Z[he]=te[he];return Z}function R(te,le){var he=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(he)return(he=he.call(te)).next.bind(he);if(Array.isArray(te)||(he=h(te))||le&&te&&typeof te.length=="number"){he&&(te=he);var Z=0;return function(){return Z>=te.length?{done:!0}:{done:!1,value:te[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=N();function T(te){ce.defaults=te}var $=/[&<>"']/,l=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return u[le]};function b(te,le){if(le){if($.test(te))return te.replace(l,k)}else if(I.test(te))return te.replace(E,k);return te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(te){return te.replace(c,function(le,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var f=/(^|[^\[])\^/g;function m(te,le){te=typeof te=="string"?te:te.source,le=le||"";var he={replace:function(ae,pe){return pe=pe.source||pe,pe=pe.replace(f,"$1"),te=te.replace(ae,pe),he},getRegex:function(){return new RegExp(te,le)}};return he}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(te,le,he){if(te){var Z;try{Z=decodeURIComponent(g(he)).replace(n,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!o.test(he)&&(he=w(le,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,le){t[" "+te]||(s.test(te)?t[" "+te]=te+"/":t[" "+te]=P(te,"/",!0)),te=t[" "+te];var he=te.indexOf(":")===-1;return le.substring(0,2)==="//"?he?le:te.replace(d,"$1")+le:le.charAt(0)==="/"?he?le:te.replace(a,"$1")+le:te+le}var y={exec:function(){}};function S(te){for(var le=1,he,Z;le<arguments.length;le++){he=arguments[le];for(Z in he)Object.prototype.hasOwnProperty.call(he,Z)&&(te[Z]=he[Z])}return te}function D(te,le){var he=te.replace(/\|/g,function(pe,be,Me){for(var ze=!1,ke=be;--ke>=0&&Me[ke]==="\\";)ze=!ze;return ze?"|":" |"}),Z=he.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function P(te,le,he){var Z=te.length;if(Z===0)return"";for(var ae=0;ae<Z;){var pe=te.charAt(Z-ae-1);if(pe===le&&!he)ae++;else if(pe!==le&&he)ae++;else break}return te.slice(0,Z-ae)}function C(te,le){if(te.indexOf(le[1])===-1)return-1;for(var he=te.length,Z=0,ae=0;ae<he;ae++)if(te[ae]==="\\")ae++;else if(te[ae]===le[0])Z++;else if(te[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function p(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,le){if(le<1)return"";for(var he="";le>1;)le&1&&(he+=te),le>>=1,te+=te;return he+te}function O(te,le,he,Z){var ae=le.href,pe=le.title?b(le.title):null,be=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Z.state.inLink=!0;var Me={type:"link",raw:he,href:ae,title:pe,text:be,tokens:Z.inlineTokens(be)};return Z.state.inLink=!1,Me}return{type:"image",raw:he,href:ae,title:pe,text:b(be)}}function L(te,le){var he=te.match(/^(\s+)(?:```)/);if(he===null)return le;var Z=he[1];return le.split(`
`).map(function(ae){var pe=ae.match(/^\s+/);if(pe===null)return ae;var be=pe[0];return be.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var F=function(){function te(he){this.options=he||ce.defaults}var le=te.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var pe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:P(pe,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var pe=ae[0],be=L(pe,ae[3]||"");return{type:"code",raw:pe,lang:ae[2]?ae[2].trim():ae[2],text:be}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var pe=ae[2].trim();if(/#$/.test(pe)){var be=P(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var pe=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var pe,be,Me,ze,ke,Ie,Te,V,q,Q,x,fe,we=ae[1].trim(),Oe=we.length>1,Ge={type:"list",raw:"",ordered:Oe,start:Oe?+we.slice(0,-1):"",loose:!1,items:[]};we=Oe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Oe?we:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(fe=!1,!(!(ae=Ke.exec(Z))||this.rules.block.hr.test(Z)));){if(pe=ae[0],Z=Z.substring(pe.length),V=ae[2].split(`
`,1)[0],q=Z.split(`
`,1)[0],this.options.pedantic?(ze=2,x=V.trimLeft()):(ze=ae[2].search(/[^ ]/),ze=ze>4?1:ze,x=V.slice(ze),ze+=ae[1].length),Ie=!1,!V&&/^ *$/.test(q)&&(pe+=q+`
`,Z=Z.substring(q.length+1),fe=!0),!fe)for(var tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");Z&&(Q=Z.split(`
`,1)[0],V=Q,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(V)||nt.test(V)||tt.test(V)||rt.test(Z)));){if(V.search(/[^ ]/)>=ze||!V.trim())x+=`
`+V.slice(ze);else if(!Ie)x+=`
`+V;else break;!Ie&&!V.trim()&&(Ie=!0),pe+=Q+`
`,Z=Z.substring(Q.length+1)}Ge.loose||(Te?Ge.loose=!0:/\n *\n *$/.test(pe)&&(Te=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(x),be&&(Me=be[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:pe,task:!!be,checked:Me,loose:!1,text:x}),Ge.raw+=pe}Ge.items[Ge.items.length-1].raw=pe.trimRight(),Ge.items[Ge.items.length-1].text=x.trimRight(),Ge.raw=Ge.raw.trimRight();var ct=Ge.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,Ge.items[ke].tokens=this.lexer.blockTokens(Ge.items[ke].text,[]);var $t=Ge.items[ke].tokens.filter(function(at){return at.type==="space"}),ht=$t.every(function(at){for(var Pe=at.raw.split(""),Be=0,Ye=R(Pe),Le;!(Le=Ye()).done;){var Fe=Le.value;if(Fe===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&$t.length&&ht&&(Ge.loose=!0,Ge.items[ke].loose=!0)}return Ge}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var pe={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ae[0]):b(ae[0]);pe.type="paragraph",pe.text=be,pe.tokens=this.lexer.inline(be)}return pe}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var pe=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var pe={type:"table",header:D(ae[1]).map(function(Te){return{text:Te}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ae[0];var be=pe.align.length,Me,ze,ke,Ie;for(Me=0;Me<be;Me++)/^ *-+: *$/.test(pe.align[Me])?pe.align[Me]="right":/^ *:-+: *$/.test(pe.align[Me])?pe.align[Me]="center":/^ *:-+ *$/.test(pe.align[Me])?pe.align[Me]="left":pe.align[Me]=null;for(be=pe.rows.length,Me=0;Me<be;Me++)pe.rows[Me]=D(pe.rows[Me],pe.header.length).map(function(Te){return{text:Te}});for(be=pe.header.length,ze=0;ze<be;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for(be=pe.rows.length,ze=0;ze<be;ze++)for(Ie=pe.rows[ze],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return pe}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var pe=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:b(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):b(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var pe=ae[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=P(pe.slice(0,-1),"\\");if((pe.length-be.length)%2===0)return}else{var Me=C(ae[2],"()");if(Me>-1){var ze=ae[0].indexOf("!")===0?5:4,ke=ze+ae[1].length+Me;ae[2]=ae[2].substring(0,Me),ae[0]=ae[0].substring(0,ke).trim(),ae[3]=""}}var Ie=ae[2],Te="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);V&&(Ie=V[1],Te=V[3])}else Te=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),O(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var pe;if((pe=this.rules.inline.reflink.exec(Z))||(pe=this.rules.inline.nolink.exec(Z))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ae[be.toLowerCase()],!be||!be.href){var Me=pe[0].charAt(0);return{type:"text",raw:Me,text:Me}}return O(pe,be,pe[0],this.lexer)}},le.emStrong=function(Z,ae,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(Z);if(be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=be[1]||be[2]||"";if(!Me||Me&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=be[0].length-1,ke,Ie,Te=ze,V=0,q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ae=ae.slice(-1*Z.length+ze);(be=q.exec(ae))!=null;)if(ke=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ke){if(Ie=ke.length,be[3]||be[4]){Te+=Ie;continue}else if((be[5]||be[6])&&ze%3&&!((ze+Ie)%3)){V+=Ie;continue}if(Te-=Ie,!(Te>0)){if(Ie=Math.min(Ie,Ie+Te+V),Math.min(ze,Ie)%2){var Q=Z.slice(1,ze+be.index+Ie);return{type:"em",raw:Z.slice(0,ze+be.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var x=Z.slice(2,ze+be.index+Ie-1);return{type:"strong",raw:Z.slice(0,ze+be.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var pe=ae[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Me=/^ /.test(pe)&&/ $/.test(pe);return be&&Me&&(pe=pe.substring(1,pe.length-1)),pe=b(pe,!0),{type:"codespan",raw:ae[0],text:pe}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var pe=this.rules.inline.autolink.exec(Z);if(pe){var be,Me;return pe[2]==="@"?(be=b(this.options.mangle?ae(pe[1]):pe[1]),Me="mailto:"+be):(be=b(pe[1]),Me=be),{type:"link",raw:pe[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},le.url=function(Z,ae){var pe;if(pe=this.rules.inline.url.exec(Z)){var be,Me;if(pe[2]==="@")be=b(this.options.mangle?ae(pe[0]):pe[0]),Me="mailto:"+be;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);be=b(pe[0]),pe[1]==="www."?Me="http://"+be:Me=be}return{type:"link",raw:pe[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},le.inlineText=function(Z,ae){var pe=this.rules.inline.text.exec(Z);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):b(pe[0]):pe[0]:be=b(this.options.smartypants?ae(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=m(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=m(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=m(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=m(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=m(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=m(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=m(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=m(B.reflink).replace("label",B._label).replace("ref",j._label).getRegex(),B.nolink=m(B.nolink).replace("ref",j._label).getRegex(),B.reflinkSearch=m(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=S({},B),B.pedantic=S({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=S({},B.normal,{escape:m(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=m(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=S({},B.gfm,{br:m(B.br).replace("{2,}","*").getRegex(),text:m(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(te){var le="",he,Z,ae=te.length;for(he=0;he<ae;he++)Z=te.charCodeAt(he),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var _=function(){function te(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ce.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:j.normal,inline:B.normal};this.options.pedantic?(Z.block=j.pedantic,Z.inline=B.pedantic):this.options.gfm&&(Z.block=j.gfm,this.options.breaks?Z.inline=B.breaks:Z.inline=B.gfm),this.tokenizer.rules=Z}te.lex=function(Z,ae){var pe=new te(ae);return pe.lex(Z)},te.lexInline=function(Z,ae){var pe=new te(ae);return pe.inlineTokens(Z)};var le=te.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var pe=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Te,V,q){return V+"    ".repeat(q.length)});for(var be,Me,ze,ke;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(be=Te.call({lexer:pe},Z,ae))?(Z=Z.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.space(Z)){Z=Z.substring(be.raw.length),be.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(be);continue}if(be=this.tokenizer.code(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be);continue}if(be=this.tokenizer.fences(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.heading(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.hr(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.blockquote(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.list(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.html(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.def(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.lheading(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(ze=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,V=Z.slice(1),q=void 0;pe.options.extensions.startBlock.forEach(function(Q){q=Q.call({lexer:this},V),typeof q=="number"&&q>=0&&(Te=Math.min(Te,q))}),Te<1/0&&Te>=0&&(ze=Z.substring(0,Te+1))}(),this.state.top&&(be=this.tokenizer.paragraph(ze))){Me=ae[ae.length-1],ke&&Me.type==="paragraph"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be),ke=ze.length!==Z.length,Z=Z.substring(be.raw.length);continue}if(be=this.tokenizer.text(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be);continue}if(Z){var Ie="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var pe=this;ae===void 0&&(ae=[]);var be,Me,ze,ke=Z,Ie,Te,V;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Te||(V=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(be=x.call({lexer:pe},Z,ae))?(Z=Z.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.escape(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.tag(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.link(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.emStrong(Z,ke,V)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.codespan(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.br(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.del(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.autolink(Z,z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Z,z))){Z=Z.substring(be.raw.length),ae.push(be);continue}if(ze=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=Z.slice(1),we=void 0;pe.options.extensions.startInline.forEach(function(Oe){we=Oe.call({lexer:this},fe),typeof we=="number"&&we>=0&&(x=Math.min(x,we))}),x<1/0&&x>=0&&(ze=Z.substring(0,x+1))}(),be=this.tokenizer.inlineText(ze,M)){Z=Z.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(V=be.raw.slice(-1)),Te=!0,Me=ae[ae.length-1],Me&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(Z){var Q="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return ae},r(te,null,[{key:"rules",get:function(){return{block:j,inline:B}}}]),te}(),re=function(){function te(he){this.options=he||ce.defaults}var le=te.prototype;return le.code=function(Z,ae,pe){var be=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Z,be);Me!=null&&Me!==Z&&(pe=!0,Z=Me)}return Z=Z.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+b(be,!0)+'">'+(pe?Z:b(Z,!0))+`</code></pre>
`:"<pre><code>"+(pe?Z:b(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,pe,be){if(this.options.headerIds){var Me=this.options.headerPrefix+be.slug(pe);return"<h"+ae+' id="'+Me+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,pe){var be=ae?"ol":"ul",Me=ae&&pe!==1?' start="'+pe+'"':"";return"<"+be+Me+`>
`+Z+"</"+be+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var pe=ae.header?"th":"td",be=ae.align?"<"+pe+' align="'+ae.align+'">':"<"+pe+">";return be+Z+("</"+pe+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,pe){if(Z=i(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var be='<a href="'+b(Z)+'"';return ae&&(be+=' title="'+ae+'"'),be+=">"+pe+"</a>",be},le.image=function(Z,ae,pe){if(Z=i(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var be='<img src="'+Z+'" alt="'+pe+'"';return ae&&(be+=' title="'+ae+'"'),be+=this.options.xhtml?"/>":">",be},le.text=function(Z){return Z},te}(),U=function(){function te(){}var le=te.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,pe){return""+pe},le.image=function(Z,ae,pe){return""+pe},le.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var pe=Z,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[Z];do be++,pe=Z+"-"+be;while(this.seen.hasOwnProperty(pe))}return ae||(this.seen[Z]=be,this.seen[pe]=0),pe},le.slug=function(Z,ae){ae===void 0&&(ae={});var pe=this.serialize(Z);return this.getNextSafeSlug(pe,ae.dryrun)},te}(),K=function(){function te(he){this.options=he||ce.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new U,this.slugger=new G}te.parse=function(Z,ae){var pe=new te(ae);return pe.parse(Z)},te.parseInline=function(Z,ae){var pe=new te(ae);return pe.parseInline(Z)};var le=te.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var pe="",be,Me,ze,ke,Ie,Te,V,q,Q,x,fe,we,Oe,Ge,Ke,tt,rt,ot,nt,ct=Z.length;for(be=0;be<ct;be++){if(x=Z[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(nt=this.options.extensions.renderers[x.type].call({parser:this},x),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=nt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,g(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(q="",V="",ke=x.header.length,Me=0;Me<ke;Me++)V+=this.renderer.tablecell(this.parseInline(x.header[Me].tokens),{header:!0,align:x.align[Me]});for(q+=this.renderer.tablerow(V),Q="",ke=x.rows.length,Me=0;Me<ke;Me++){for(Te=x.rows[Me],V="",Ie=Te.length,ze=0;ze<Ie;ze++)V+=this.renderer.tablecell(this.parseInline(Te[ze].tokens),{header:!1,align:x.align[ze]});Q+=this.renderer.tablerow(V)}pe+=this.renderer.table(q,Q);continue}case"blockquote":{Q=this.parse(x.tokens),pe+=this.renderer.blockquote(Q);continue}case"list":{for(fe=x.ordered,we=x.start,Oe=x.loose,ke=x.items.length,Q="",Me=0;Me<ke;Me++)Ke=x.items[Me],tt=Ke.checked,rt=Ke.task,Ge="",Ke.task&&(ot=this.renderer.checkbox(tt),Oe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ot+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ot+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ke.tokens,Oe),Q+=this.renderer.listitem(Ge,rt,tt);pe+=this.renderer.list(Q,fe,we);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(Q=x.tokens?this.parseInline(x.tokens):x.text;be+1<ct&&Z[be+1].type==="text";)x=Z[++be],Q+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=ae?this.renderer.paragraph(Q):Q;continue}default:{var $t='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},le.parseInline=function(Z,ae){ae=ae||this.renderer;var pe="",be,Me,ze,ke=Z.length;for(be=0;be<ke;be++){if(Me=Z[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(ze=this.options.extensions.renderers[Me.type].call({parser:this},Me),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){pe+=ze||"";continue}switch(Me.type){case"escape":{pe+=ae.text(Me.text);break}case"html":{pe+=ae.html(Me.text);break}case"link":{pe+=ae.link(Me.href,Me.title,this.parseInline(Me.tokens,ae));break}case"image":{pe+=ae.image(Me.href,Me.title,Me.text);break}case"strong":{pe+=ae.strong(this.parseInline(Me.tokens,ae));break}case"em":{pe+=ae.em(this.parseInline(Me.tokens,ae));break}case"codespan":{pe+=ae.codespan(Me.text);break}case"br":{pe+=ae.br();break}case"del":{pe+=ae.del(this.parseInline(Me.tokens,ae));break}case"text":{pe+=ae.text(Me.text);break}default:{var Ie='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},te}();function ee(te,le,he){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(he=le,le=null),le=S({},ee.defaults,le||{}),p(le),he){var Z=le.highlight,ae;try{ae=_.lex(te,le)}catch(ke){return he(ke)}var pe=function(Ie){var Te;if(!Ie)try{le.walkTokens&&ee.walkTokens(ae,le.walkTokens),Te=K.parse(ae,le)}catch(V){Ie=V}return le.highlight=Z,Ie?he(Ie):he(null,Te)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return pe();var be=0;ee.walkTokens(ae,function(ke){ke.type==="code"&&(be++,setTimeout(function(){Z(ke.text,ke.lang,function(Ie,Te){if(Ie)return pe(Ie);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}function Me(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(ke.message+"",!0)+"</pre>";throw ke}try{var ze=_.lex(te,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(ze,le.walkTokens)).then(function(){return K.parse(ze,le)}).catch(Me);ee.walkTokens(ze,le.walkTokens)}return K.parse(ze,le)}catch(ke){Me(ke)}}ee.options=ee.setOptions=function(te){return S(ee.defaults,te),T(ee.defaults),ee},ee.getDefaults=N,ee.defaults=ce.defaults,ee.use=function(){for(var te=arguments.length,le=new Array(te),he=0;he<te;he++)le[he]=arguments[he];var Z=S.apply(void 0,[{}].concat(le)),ae=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(be){if(be.extensions&&(pe=!0,be.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=ae.renderers?ae.renderers[ze.name]:null;ke?ae.renderers[ze.name]=function(){for(var Ie=arguments.length,Te=new Array(Ie),V=0;V<Ie;V++)Te[V]=arguments[V];var q=ze.renderer.apply(this,Te);return q===!1&&(q=ke.apply(this,Te)),q}:ae.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[ze.level]?ae[ze.level].unshift(ze.tokenizer):ae[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?ae.startBlock?ae.startBlock.push(ze.start):ae.startBlock=[ze.start]:ze.level==="inline"&&(ae.startInline?ae.startInline.push(ze.start):ae.startInline=[ze.start]))}ze.childTokens&&(ae.childTokens[ze.name]=ze.childTokens)})),be.renderer&&function(){var ze=ee.defaults.renderer||new re,ke=function(V){var q=ze[V];ze[V]=function(){for(var Q=arguments.length,x=new Array(Q),fe=0;fe<Q;fe++)x[fe]=arguments[fe];var we=be.renderer[V].apply(ze,x);return we===!1&&(we=q.apply(ze,x)),we}};for(var Ie in be.renderer)ke(Ie);Z.renderer=ze}(),be.tokenizer&&function(){var ze=ee.defaults.tokenizer||new F,ke=function(V){var q=ze[V];ze[V]=function(){for(var Q=arguments.length,x=new Array(Q),fe=0;fe<Q;fe++)x[fe]=arguments[fe];var we=be.tokenizer[V].apply(ze,x);return we===!1&&(we=q.apply(ze,x)),we}};for(var Ie in be.tokenizer)ke(Ie);Z.tokenizer=ze}(),be.walkTokens){var Me=ee.defaults.walkTokens;Z.walkTokens=function(ze){var ke=[];return ke.push(be.walkTokens.call(this,ze)),Me&&(ke=ke.concat(Me.call(this,ze))),ke}}pe&&(Z.extensions=ae),ee.setOptions(Z)})},ee.walkTokens=function(te,le){for(var he=[],Z=function(){var Me=pe.value;switch(he=he.concat(le.call(ee,Me)),Me.type){case"table":{for(var ze=R(Me.header),ke;!(ke=ze()).done;){var Ie=ke.value;he=he.concat(ee.walkTokens(Ie.tokens,le))}for(var Te=R(Me.rows),V;!(V=Te()).done;)for(var q=V.value,Q=R(q),x;!(x=Q()).done;){var fe=x.value;he=he.concat(ee.walkTokens(fe.tokens,le))}break}case"list":{he=he.concat(ee.walkTokens(Me.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Me.type]?ee.defaults.extensions.childTokens[Me.type].forEach(function(we){he=he.concat(ee.walkTokens(Me[we],le))}):Me.tokens&&(he=he.concat(ee.walkTokens(Me.tokens,le)))}},ae=R(te),pe;!(pe=ae()).done;)Z();return he},ee.parseInline=function(te,le){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=S({},ee.defaults,le||{}),p(le);try{var he=_.lexInline(te,le);return le.walkTokens&&ee.walkTokens(he,le.walkTokens),K.parseInline(he,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(Z.message+"",!0)+"</pre>";throw Z}},ee.Parser=K,ee.parser=K.parse,ee.Renderer=re,ee.TextRenderer=U,ee.Lexer=_,ee.lexer=_.lex,ee.Tokenizer=F,ee.Slugger=G,ee.parse=ee;var ue=ee.options,ne=ee.setOptions,De=ee.use,$e=ee.walkTokens,J=ee.parseInline,W=ee,se=K.parse,oe=_.lex;ce.Lexer=_,ce.Parser=K,ce.Renderer=re,ce.Slugger=G,ce.TextRenderer=U,ce.Tokenizer=F,ce.getDefaults=N,ce.lexer=oe,ce.marked=ee,ce.options=ue,ce.parse=W,ce.parseInline=J,ce.parser=se,ce.setOptions=ne,ce.use=De,ce.walkTokens=$e,Object.defineProperty(ce,"__esModule",{value:!0})}),define(Ee[41],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Ee[177],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=r;function r(c){const g=R(c);if(g&&g.length>0)return new Uint32Array(g)}let h=0;const A=new Uint32Array(10);function R(c){if(h=0,N(c,E,$.InitialConsonant),h>0||(N(c,u,$.Vowel),h>0)||(N(c,k,$.FinalConsonant),h>0)||(N(c,b,$.CompatibilityJamo),h))return A.subarray(0,h);if(c>=44032&&c<=55203){const g=c-44032,f=g%588,m=Math.floor(g/588),n=Math.floor(f/28),o=f%28-1;if(m<E.length?N(m,E,0):$.InitialConsonant+m-$.CompatibilityJamo<b.length&&N($.InitialConsonant+m,b,$.CompatibilityJamo),n<u.length?N(n,u,0):$.Vowel+n-$.CompatibilityJamo<b.length&&N($.Vowel+n-$.CompatibilityJamo,b,$.CompatibilityJamo),o>=0&&(o<k.length?N(o,k,0):$.FinalConsonant+o-$.CompatibilityJamo<b.length&&N($.FinalConsonant+o-$.CompatibilityJamo,b,$.CompatibilityJamo)),h>0)return A.subarray(0,h)}}function N(c,g,f){c>=f&&c<f+g.length&&T(g[c-f])}function T(c){c!==l.NUL&&(A[h++]=c&255,c>>8&&(A[h++]=c>>8&255),c>>16&&(A[h++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var l;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(l||(l={}));var I;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),u=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l]),k=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,I.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),b=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.E,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,l.Q,I.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l])}),define(Ee[82],Se([1,0,29]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=void 0,e.$lm=A,e.$mm=N;const h=new r.$Ec(1e4);function A(l){return $(l,"NFC",h)}const R=new r.$Ec(1e4);function N(l){return $(l,"NFD",R)}const T=/[^\u0000-\u0080]/;function $(l,I,E){if(!l)return l;const u=E.get(l);if(u)return u;let k;return T.test(l)?k=l.normalize(I):k=l,E.set(l,k),k}e.$nm=function(){const l=/[\u0300-\u036f]/g;return function(I){return N(I).replace(l,"")}}()}),define(Ee[134],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0,e.$Jm=r,e.rot=h,e.$Om=T;function r($,l,I){return Math.min(Math.max($,l),I)}function h($,l){return(l+$%l)%l}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Lm=A;class R{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Mm=R;class N{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const I=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nm=N;function T($,l,I,E,u,k,b,c){const g=b-I,f=c-E,m=u-I,n=k-E,o=$-I,i=l-E,t=g*g+f*f,s=g*m+f*n,d=g*o+f*i,a=m*m+n*n,w=m*o+n*i,y=1/(t*a-s*s),S=(a*d-s*w)*y,D=(t*w-s*d)*y;return S>=0&&D>=0&&S+D<1}}),define(Ee[178],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=u;class r{constructor(b,c,g){this.owner=b,this.debugNameSource=c,this.referenceFn=g}getDebugName(b){return R(b,this)}}e.$bd=r;const h=new Map,A=new WeakMap;function R(k,b){const c=A.get(k);if(c)return c;const g=N(k,b);if(g){let f=h.get(g)??0;f++,h.set(g,f);const m=f===1?g:`${g}#${f}`;return A.set(k,m),m}}function N(k,b){const c=A.get(k);if(c)return c;const g=b.owner?I(b.owner)+".":"";let f;const m=b.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(f=m(),f!==void 0)return g+f}else return g+m;const n=b.referenceFn;if(n!==void 0&&(f=u(n),f!==void 0))return g+f;if(b.owner!==void 0){const o=T(b.owner,k);if(o!==void 0)return g+o}}function T(k,b){for(const c in k)if(k[c]===b)return c}const $=new Map,l=new WeakMap;function I(k){const b=l.get(k);if(b)return b;const c=E(k);let g=$.get(c)??0;g++,$.set(c,g);const f=g===1?c:`${c}#${g}`;return l.set(k,f),f}function E(k){const b=k.constructor;return b?b.name:"Object"}function u(k){const b=k.toString(),g=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(g?g[1]:void 0)?.trim()}}),define(Ee[179],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=h,e.$Ld=A;let r;function h(c){r=c}function A(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(g){return N([T(k("|  ",this.a)),g])}c(g){return g.hadValue?g.didChange?[T(" "),l(I(g.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),l(I(g.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),l(I(g.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(g,f){console.log(...this.b([$("observable value changed"),l(g.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges(g){if(g.size!==0)return l(" (changed deps: "+[...g].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(g){const f=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),f.apply(g,[m,n]))}handleDerivedRecomputed(g,f){const m=this.d.get(g);console.log(...this.b([$("derived recomputed"),l(g.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(m),{data:[{fn:g._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(g,f){console.log(...this.b([$("observable from event triggered"),l(g.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:g._getValue}]}]))}handleAutorunCreated(g){const f=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),f.apply(g,[m,n]))}handleAutorunTriggered(g){const f=this.d.get(g);console.log(...this.b([$("autorun"),l(g.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:g._runFn}]}])),f.clear(),this.a++}handleAutorunFinished(g){this.a--}handleBeginTransaction(g){let f=g.getDebugName();f===void 0&&(f=""),console.log(...this.b([$("transaction"),l(f,{color:"BlueViolet"}),{data:[{fn:g._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=R;function N(c){const g=new Array,f=[];let m="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(m+=`%c${i.text}`,g.push(i.style),i.data&&f.push(...i.data)):"data"in i&&f.push(...i.data)}n(c);const o=[m,...g];return o.push(...f),o}function T(c){return l(c,{color:"black"})}function $(c){return l(b(`${c}: `,10),{color:"black",bold:!0})}function l(c,g={color:"black"}){function f(n){return Object.entries(n).reduce((o,[i,t])=>`${o}${i}:${t};`,"")}const m={color:g.color};return g.strikeThrough&&(m["text-decoration"]="line-through"),g.bold&&(m["font-weight"]="bold"),{text:c,style:f(m)}}function I(c,g){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=g?`"${c}"`:`"${c.substr(0,g-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?E(c,g):u(c,g);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function E(c,g){let f="[ ",m=!0;for(const n of c){if(m||(f+=", "),f.length-5>g){f+="...";break}m=!1,f+=`${I(n,g-f.length)}`}return f+=" ]",f}function u(c,g){let f="{ ",m=!0;for(const[n,o]of Object.entries(c)){if(m||(f+=", "),f.length-5>g){f+="...";break}m=!1,f+=`${n}: ${I(o,g-f.length)}`}return f+=" }",f}function k(c,g){let f="";for(let m=1;m<=g;m++)f+=c;return f}function b(c,g){for(;c.length<g;)c+=" ";return c}}),define(Ee[180],Se([1,0,174,178,179]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=N,e.$Wd=$,e.$Xd=I,e.$1d=k,e.$2d=c,e.$3d=g,e.$4d=f,e.$6d=n,e.$8d=i;let R;function N(s){R=s}let T;function $(s){T=s}let l;function I(s){l=s}class E{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,a){const w=a===void 0?void 0:d,y=a===void 0?d:a;return l({owner:w,debugName:()=>{const S=(0,h.$dd)(y);if(S!==void 0)return S;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(P)return`${this.debugName}.${P[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:y},S=>y(this.read(S),S))}recomputeInitiallyAndOnChange(d,a){return d.add(R(this,a)),this}keepObserved(d){return d.add(T(this)),this}get a(){return this.get()}}e.$Yd=E;class u extends E{constructor(){super(...arguments),this.b=new Set}addObserver(d){const a=this.b.size;this.b.add(d),a===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=u;function k(s,d){const a=new m(s,d);try{s(a)}finally{a.finish()}}let b;function c(s){if(b)s(b);else{const d=new m(s,void 0);b=d;try{s(d)}finally{d.finish(),b=void 0}}}async function g(s,d){const a=new m(s,d);try{await s(a)}finally{a.finish()}}function f(s,d,a){s?d(s):k(d,a)}class m{constructor(d,a){this._fn=d,this.b=a,this.a=[],(0,A.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$dd)(this._fn)}updateObserver(d,a){this.a.push({observer:d,observable:a}),d.beginUpdate(a)}finish(){const d=this.a;for(let a=0;a<d.length;a++){const{observer:w,observable:y}=d[a];w.endUpdate(y)}this.a=null,(0,A.$Ld)()?.handleEndTransaction()}}e.$5d=m;function n(s,d){let a;return typeof s=="string"?a=new h.$bd(void 0,s,void 0):a=new h.$bd(s,void 0,void 0),new o(a,d,r.$7c)}class o extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,a,w){super(),this.e=d,this.g=w,this.d=a}get(){return this.d}set(d,a,w){if(w===void 0&&this.g(this.d,d))return;let y;a||(a=y=new m(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(d),(0,A.$Ld)()?.handleObservableChanged(this,{oldValue:S,newValue:d,change:w,didChange:!0,hadValue:!0});for(const D of this.b)a.updateObserver(D,this),D.handleChange(this,w)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$7d=o;function i(s,d){let a;return typeof s=="string"?a=new h.$bd(void 0,s,void 0):a=new h.$bd(s,void 0,void 0),new t(a,d,r.$7c)}class t extends o{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$9d=t}),function(){function ce(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function N($){R.push($,Date.now())}function T(){const $=[];for(let l=0;l<R.length;l+=2)$.push({name:R[l],startTime:R[l+1]});return $}return{mark:N,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const N of performance.getEntriesByType("mark"))R.push({name:N.name,startTime:Math.round(A+N.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function r(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(Ee[181],Se([1,0,40]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=void 0;const h=Symbol("unset");class A{constructor(){this.a=new N,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert($,l,I){this.d($,E=>E._value=l,I)}mutate($,l){this.d($,I=>I._value=l(I._value===h?void 0:I._value))}mutatePath($,l){this.d($,()=>{},I=>l(I))}delete($){const l=this.c($);if(!l)return;let I=l.length-1;const E=l[I].node._value;if(E!==h){for(this.b--,l[I].node._value=h;I>0;I--){const{node:u,part:k}=l[I];if(u.children?.size||u._value!==h)break;l[I-1].node.children.delete(k)}return E}}*deleteRecursive($){const l=this.c($);if(!l)return;const I=l[l.length-1].node;for(let E=l.length-1;E>0;E--){const u=l[E-1];if(u.node.children.delete(l[E].part),u.node.children.size>0||u.node._value!==h)break}for(const E of R(I))E._value!==h&&(this.b--,yield E._value)}find($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return;l=E}return l._value===h?void 0:l._value}hasKeyOrParent($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return!1;if(E._value!==h)return!0;l=E}return!1}hasKeyOrChildren($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return!1;l=E}return!0}hasKey($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return!1;l=E}return l._value!==h}c($){const l=[{part:"",node:this.a}];let I=0;for(const E of $){const u=l[I].node.children?.get(E);if(!u)return;l.push({part:E,node:u}),I++}return l}d($,l,I){let E=this.a;for(const b of $){if(E.children)if(E.children.has(b))E=E.children.get(b);else{const c=new N;E.children.set(b,c),E=c}else{const c=new N;E.children=new Map([[b,c]]),E=c}I?.(E)}const u=E._value===h?0:1;l(E);const k=E._value===h?0:1;this.b+=k-u}*values(){for(const{_value:$}of R(this.a))$!==h&&(yield $)}}e.$NI=A;function*R(T){const $=[T];for(;$.length>0;){const l=$.pop();if(yield l,l.children)for(const I of l.children.values())$.push(I)}}class N{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:ce)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function r(h){if(e[h])return e[h].exports;var A=e[h]={i:h,l:!1,exports:{}};return ce[h].call(A.exports,A,A.exports,r),A.l=!0,A.exports}return r.m=ce,r.c=e,r.d=function(h,A,R){r.o(h,A)||Object.defineProperty(h,A,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,A){if(1&A&&(h=r(h)),8&A||4&A&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&A&&typeof h!="string")for(var N in h)r.d(R,N,function(T){return h[T]}.bind(null,N));return R},r.n=function(h){var A=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(A,"a",A),A},r.o=function(h,A){return Object.prototype.hasOwnProperty.call(h,A)},r.p="",r(r.s=0)}([function(ce,e,r){(function(h){var A;e=ce.exports=De,A=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],l=0,I=l++;$[I]="0|[1-9]\\d*";var E=l++;$[E]="[0-9]+";var u=l++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=l++;$[k]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var b=l++;$[b]="("+$[E]+")\\.("+$[E]+")\\.("+$[E]+")";var c=l++;$[c]="(?:"+$[I]+"|"+$[u]+")";var g=l++;$[g]="(?:"+$[E]+"|"+$[u]+")";var f=l++;$[f]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var m=l++;$[m]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var n=l++;$[n]="[0-9A-Za-z-]+";var o=l++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var i=l++,t="v?"+$[k]+$[f]+"?"+$[o]+"?";$[i]="^"+t+"$";var s="[v=\\s]*"+$[b]+$[m]+"?"+$[o]+"?",d=l++;$[d]="^"+s+"$";var a=l++;$[a]="((?:<|>)?=?)";var w=l++;$[w]=$[E]+"|x|X|\\*";var y=l++;$[y]=$[I]+"|x|X|\\*";var S=l++;$[S]="[v=\\s]*("+$[y]+")(?:\\.("+$[y]+")(?:\\.("+$[y]+")(?:"+$[f]+")?"+$[o]+"?)?)?";var D=l++;$[D]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[m]+")?"+$[o]+"?)?)?";var P=l++;$[P]="^"+$[a]+"\\s*"+$[S]+"$";var C=l++;$[C]="^"+$[a]+"\\s*"+$[D]+"$";var p=l++;$[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=l++;$[v]="(?:~>?)";var O=l++;$[O]="(\\s*)"+$[v]+"\\s+",T[O]=new RegExp($[O],"g");var L=l++;$[L]="^"+$[v]+$[S]+"$";var F=l++;$[F]="^"+$[v]+$[D]+"$";var j=l++;$[j]="(?:\\^)";var B=l++;$[B]="(\\s*)"+$[j]+"\\s+",T[B]=new RegExp($[B],"g");var M=l++;$[M]="^"+$[j]+$[S]+"$";var z=l++;$[z]="^"+$[j]+$[D]+"$";var _=l++;$[_]="^"+$[a]+"\\s*("+s+")$|^$";var re=l++;$[re]="^"+$[a]+"\\s*("+t+")$|^$";var U=l++;$[U]="(\\s*)"+$[a]+"\\s*("+s+"|"+$[S]+")",T[U]=new RegExp($[U],"g");var G=l++;$[G]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var K=l++;$[K]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ee=l++;$[ee]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)A(ue,$[ue]),T[ue]||(T[ue]=new RegExp($[ue]));function ne(q,Q){if(q instanceof De)return q;if(typeof q!="string"||q.length>R||!(Q?T[d]:T[i]).test(q))return null;try{return new De(q,Q)}catch{return null}}function De(q,Q){if(q instanceof De){if(q.loose===Q)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof De))return new De(q,Q);A("SemVer",q,Q),this.loose=Q;var x=q.trim().match(Q?T[d]:T[i]);if(!x)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<N)return we}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(q,Q){var x=ne(q,Q);return x?x.version:null},e.clean=function(q,Q){var x=ne(q.trim().replace(/^[=v]+/,""),Q);return x?x.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(q){return A("SemVer.compare",this.version,this.loose,q),q instanceof De||(q=new De(q,this.loose)),this.compareMain(q)||this.comparePre(q)},De.prototype.compareMain=function(q){return q instanceof De||(q=new De(q,this.loose)),J(this.major,q.major)||J(this.minor,q.minor)||J(this.patch,q.patch)},De.prototype.comparePre=function(q){if(q instanceof De||(q=new De(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Q=0;do{var x=this.prerelease[Q],fe=q.prerelease[Q];if(A("prerelease compare",Q,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return J(x,fe)}while(++Q)},De.prototype.inc=function(q,Q){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Q,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new De(q,x).inc(Q,fe).version}catch{return null}},e.diff=function(q,Q){if(te(q,Q))return null;var x=ne(q),fe=ne(Q);if(x.prerelease.length||fe.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return we},e.compareIdentifiers=J;var $e=/^[0-9]+$/;function J(q,Q){var x=$e.test(q),fe=$e.test(Q);return x&&fe&&(q=+q,Q=+Q),x&&!fe?-1:fe&&!x?1:q<Q?-1:q>Q?1:0}function W(q,Q,x){return new De(q,x).compare(new De(Q,x))}function se(q,Q,x){return W(q,Q,x)>0}function oe(q,Q,x){return W(q,Q,x)<0}function te(q,Q,x){return W(q,Q,x)===0}function le(q,Q,x){return W(q,Q,x)!==0}function he(q,Q,x){return W(q,Q,x)>=0}function Z(q,Q,x){return W(q,Q,x)<=0}function ae(q,Q,x,fe){var we;switch(Q){case"===":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q===x;break;case"!==":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q!==x;break;case"":case"=":case"==":we=te(q,x,fe);break;case"!=":we=le(q,x,fe);break;case">":we=se(q,x,fe);break;case">=":we=he(q,x,fe);break;case"<":we=oe(q,x,fe);break;case"<=":we=Z(q,x,fe);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function pe(q,Q){if(q instanceof pe){if(q.loose===Q)return q;q=q.value}if(!(this instanceof pe))return new pe(q,Q);A("comparator",q,Q),this.loose=Q,this.parse(q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(q,Q){return J(Q,q)},e.major=function(q,Q){return new De(q,Q).major},e.minor=function(q,Q){return new De(q,Q).minor},e.patch=function(q,Q){return new De(q,Q).patch},e.compare=W,e.compareLoose=function(q,Q){return W(q,Q,!0)},e.rcompare=function(q,Q,x){return W(Q,q,x)},e.sort=function(q,Q){return q.sort(function(x,fe){return e.compare(x,fe,Q)})},e.rsort=function(q,Q){return q.sort(function(x,fe){return e.rcompare(x,fe,Q)})},e.gt=se,e.lt=oe,e.eq=te,e.neq=le,e.gte=he,e.lte=Z,e.cmp=ae,e.Comparator=pe;var be={};function Me(q,Q){if(q instanceof Me)return q.loose===Q?q:new Me(q.raw,Q);if(q instanceof pe)return new Me(q.value,Q);if(!(this instanceof Me))return new Me(q,Q);if(this.loose=Q,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function ze(q){return!q||q.toLowerCase()==="x"||q==="*"}function ke(q,Q,x,fe,we,Oe,Ge,Ke,tt,rt,ot,nt,ct){return((Q=ze(x)?"":ze(fe)?">="+x+".0.0":ze(we)?">="+x+"."+fe+".0":">="+Q)+" "+(Ke=ze(tt)?"":ze(rt)?"<"+(+tt+1)+".0.0":ze(ot)?"<"+tt+"."+(+rt+1)+".0":nt?"<="+tt+"."+rt+"."+ot+"-"+nt:"<="+Ke)).trim()}function Ie(q,Q){for(var x=0;x<q.length;x++)if(!q[x].test(Q))return!1;if(Q.prerelease.length){for(x=0;x<q.length;x++)if(A(q[x].semver),q[x].semver!==be&&q[x].semver.prerelease.length>0){var fe=q[x].semver;if(fe.major===Q.major&&fe.minor===Q.minor&&fe.patch===Q.patch)return!0}return!1}return!0}function Te(q,Q,x){try{Q=new Me(Q,x)}catch{return!1}return Q.test(q)}function V(q,Q,x,fe){var we,Oe,Ge,Ke,tt;switch(q=new De(q,fe),Q=new Me(Q,fe),x){case">":we=se,Oe=Z,Ge=oe,Ke=">",tt=">=";break;case"<":we=oe,Oe=he,Ge=se,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(q,Q,fe))return!1;for(var rt=0;rt<Q.set.length;++rt){var ot=Q.set[rt],nt=null,ct=null;if(ot.forEach(function($t){$t.semver===be&&($t=new pe(">=0.0.0")),nt=nt||$t,ct=ct||$t,we($t.semver,nt.semver,fe)?nt=$t:Ge($t.semver,ct.semver,fe)&&(ct=$t)}),nt.operator===Ke||nt.operator===tt||(!ct.operator||ct.operator===Ke)&&Oe(q,ct.semver)||ct.operator===tt&&Ge(q,ct.semver))return!1}return!0}pe.prototype.parse=function(q){var Q=this.loose?T[_]:T[re],x=q.match(Q);if(!x)throw new TypeError("Invalid comparator: "+q);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new De(x[2],this.loose):this.semver=be},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(q){return A("Comparator.test",q,this.loose),this.semver===be||(typeof q=="string"&&(q=new De(q,this.loose)),ae(q,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(q,Q){if(!(q instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Me(q.value,Q),Te(this.value,x,Q);if(q.operator==="")return x=new Me(this.value,Q),Te(q.semver,x,Q);var fe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Oe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ke=ae(this.semver,"<",q.semver,Q)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),tt=ae(this.semver,">",q.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return fe||we||Oe&&Ge||Ke||tt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(q){var Q=this.loose;q=q.trim(),A("range",q,Q);var x=Q?T[K]:T[G];q=q.replace(x,ke),A("hyphen replace",q),q=q.replace(T[U],"$1$2$3"),A("comparator trim",q,T[U]),q=(q=(q=q.replace(T[O],"$1~")).replace(T[B],"$1^")).split(/\s+/).join(" ");var fe=Q?T[_]:T[re],we=q.split(" ").map(function(Oe){return function(Ge,Ke){return A("comp",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,ct){A("caret",nt,ct);var $t=ct?T[z]:T[M];return nt.replace($t,function(ht,at,Pe,Be,Ye){var Le;return A("caret",nt,ht,at,Pe,Be,Ye),ze(at)?Le="":ze(Pe)?Le=">="+at+".0.0 <"+(+at+1)+".0.0":ze(Be)?Le=at==="0"?">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+".0 <"+(+at+1)+".0.0":Ye?(A("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),Le=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+Be+Ye+" <"+at+"."+Pe+"."+(+Be+1):">="+at+"."+Pe+"."+Be+Ye+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+Be+Ye+" <"+(+at+1)+".0.0"):(A("no pr"),Le=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+Be+" <"+at+"."+Pe+"."+(+Be+1):">="+at+"."+Pe+"."+Be+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+Be+" <"+(+at+1)+".0.0"),A("caret return",Le),Le})}(ot,rt)}).join(" ")}(Ge,Ke),A("caret",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,ct){var $t=ct?T[F]:T[L];return nt.replace($t,function(ht,at,Pe,Be,Ye){var Le;return A("tilde",nt,ht,at,Pe,Be,Ye),ze(at)?Le="":ze(Pe)?Le=">="+at+".0.0 <"+(+at+1)+".0.0":ze(Be)?Le=">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":Ye?(A("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),Le=">="+at+"."+Pe+"."+Be+Ye+" <"+at+"."+(+Pe+1)+".0"):Le=">="+at+"."+Pe+"."+Be+" <"+at+"."+(+Pe+1)+".0",A("tilde return",Le),Le})}(ot,rt)}).join(" ")}(Ge,Ke),A("tildes",Ge),Ge=function(tt,rt){return A("replaceXRanges",tt,rt),tt.split(/\s+/).map(function(ot){return function(nt,ct){nt=nt.trim();var $t=ct?T[C]:T[P];return nt.replace($t,function(ht,at,Pe,Be,Ye,Le){A("xRange",nt,ht,at,Pe,Be,Ye,Le);var Fe=ze(Pe),X=Fe||ze(Be),de=X||ze(Ye);return at==="="&&de&&(at=""),Fe?ht=at===">"||at==="<"?"<0.0.0":"*":at&&de?(X&&(Be=0),de&&(Ye=0),at===">"?(at=">=",X?(Pe=+Pe+1,Be=0,Ye=0):de&&(Be=+Be+1,Ye=0)):at==="<="&&(at="<",X?Pe=+Pe+1:Be=+Be+1),ht=at+Pe+"."+Be+"."+Ye):X?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de&&(ht=">="+Pe+"."+Be+".0 <"+Pe+"."+(+Be+1)+".0"),A("xRange return",ht),ht})}(ot,rt)}).join(" ")}(Ge,Ke),A("xrange",Ge),Ge=function(tt,rt){return A("replaceStars",tt,rt),tt.trim().replace(T[ee],"")}(Ge,Ke),A("stars",Ge),Ge}(Oe,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Oe){return!!Oe.match(fe)})),we=we.map(function(Oe){return new pe(Oe,Q)})},Me.prototype.intersects=function(q,Q){if(!(q instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return q.set.some(function(we){return we.every(function(Oe){return fe.intersects(Oe,Q)})})})})},e.toComparators=function(q,Q){return new Me(q,Q).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new De(q,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ie(this.set[Q],q))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(q,Q,x){var fe=null,we=null;try{var Oe=new Me(Q,x)}catch{return null}return q.forEach(function(Ge){Oe.test(Ge)&&(fe&&we.compare(Ge)!==-1||(we=new De(fe=Ge,x)))}),fe},e.minSatisfying=function(q,Q,x){var fe=null,we=null;try{var Oe=new Me(Q,x)}catch{return null}return q.forEach(function(Ge){Oe.test(Ge)&&(fe&&we.compare(Ge)!==1||(we=new De(fe=Ge,x)))}),fe},e.validRange=function(q,Q){try{return new Me(q,Q).range||"*"}catch{return null}},e.ltr=function(q,Q,x){return V(q,Q,"<",x)},e.gtr=function(q,Q,x){return V(q,Q,">",x)},e.outside=V,e.prerelease=function(q,Q){var x=ne(q,Q);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(q,Q,x){return q=new Me(q,x),Q=new Me(Q,x),q.intersects(Q)},e.coerce=function(q){if(q instanceof De)return q;if(typeof q!="string")return null;var Q=q.match(T[p]);return Q==null?null:ne((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,r(1))},function(ce,e){var r,h,A=ce.exports={};function R(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function T(g){if(r===setTimeout)return setTimeout(g,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(g,0);try{return r(g,0)}catch{try{return r.call(null,g,0)}catch{return r.call(this,g,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:N}catch{h=N}})();var $,l=[],I=!1,E=-1;function u(){I&&$&&(I=!1,$.length?l=$.concat(l):E=-1,l.length&&k())}function k(){if(!I){var g=T(u);I=!0;for(var f=l.length;f;){for($=l,l=[];++E<f;)$&&$[E].run();E=-1,f=l.length}$=null,I=!1,function(m){if(h===clearTimeout)return clearTimeout(m);if((h===N||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(m);try{h(m)}catch{try{return h.call(null,m)}catch{return h.call(this,m)}}}(g)}}function b(g,f){this.fun=g,this.array=f}function c(){}A.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];l.push(new b(g,f)),l.length!==1||I||T(k)},b.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=c,A.addListener=c,A.once=c,A.off=c,A.removeListener=c,A.removeAllListeners=c,A.emit=c,A.prependListener=c,A.prependOnceListener=c,A.listeners=function(g){return[]},A.binding=function(g){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(g){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ee[43],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=h}),define(Ee[4],Se([1,0,14,80,3,81,43]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=k;const T=!1,$=!1,l=!1;var I;(function(F){F.None=()=>A.$Vc.None;function j(ke){if(l){const{onDidAddListener:Ie}=ke,Te=c.create();let V=0;ke.onDidAddListener=()=>{++V===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),Ie?.()}}}function B(ke,Ie){return ne(ke,()=>{},0,void 0,!0,void 0,Ie)}F.defer=B;function M(ke){return(Ie,Te=null,V)=>{let q=!1,Q;return Q=ke(x=>{if(!q)return Q?Q.dispose():q=!0,Ie.call(Te,x)},null,V),q&&Q.dispose(),Q}}F.once=M;function z(ke,Ie,Te){return ee((V,q=null,Q)=>ke(x=>V.call(q,Ie(x)),null,Q),Te)}F.map=z;function _(ke,Ie,Te){return ee((V,q=null,Q)=>ke(x=>{Ie(x),V.call(q,x)},null,Q),Te)}F.forEach=_;function re(ke,Ie,Te){return ee((V,q=null,Q)=>ke(x=>Ie(x)&&V.call(q,x),null,Q),Te)}F.filter=re;function U(ke){return ke}F.signal=U;function G(...ke){return(Ie,Te=null,V)=>{const q=(0,A.$Sc)(...ke.map(Q=>Q(x=>Ie.call(Te,x))));return ue(q,V)}}F.any=G;function K(ke,Ie,Te,V){let q=Te;return z(ke,Q=>(q=Ie(q,Q),q),V)}F.reduce=K;function ee(ke,Ie){let Te;const V={onWillAddFirstListener(){Te=ke(q.fire,q)},onDidRemoveLastListener(){Te?.dispose()}};Ie||j(V);const q=new s(V);return Ie?.add(q),q.event}function ue(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function ne(ke,Ie,Te=100,V=!1,q=!1,Q,x){let fe,we,Oe,Ge=0,Ke;const tt={leakWarningThreshold:Q,onWillAddFirstListener(){fe=ke(ot=>{Ge++,we=Ie(we,ot),V&&!Oe&&(rt.fire(we),we=void 0),Ke=()=>{const nt=we;we=void 0,Oe=void 0,(!V||Ge>1)&&rt.fire(nt),Ge=0},typeof Te=="number"?(clearTimeout(Oe),Oe=setTimeout(Ke,Te)):Oe===void 0&&(Oe=0,queueMicrotask(Ke))})},onWillRemoveListener(){q&&Ge>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,fe.dispose()}};x||j(tt);const rt=new s(tt);return x?.add(rt),rt.event}F.debounce=ne;function De(ke,Ie=0,Te){return F.debounce(ke,(V,q)=>V?(V.push(q),V):[q],Ie,void 0,!0,void 0,Te)}F.accumulate=De;function $e(ke,Ie=(V,q)=>V===q,Te){let V=!0,q;return re(ke,Q=>{const x=V||!Ie(Q,q);return V=!1,q=Q,x},Te)}F.latch=$e;function J(ke,Ie,Te){return[F.filter(ke,Ie,Te),F.filter(ke,V=>!Ie(V),Te)]}F.split=J;function W(ke,Ie=!1,Te=[],V){let q=Te.slice(),Q=ke(we=>{q?q.push(we):fe.fire(we)});V&&V.add(Q);const x=()=>{q?.forEach(we=>fe.fire(we)),q=null},fe=new s({onWillAddFirstListener(){Q||(Q=ke(we=>fe.fire(we)),V&&V.add(Q))},onDidAddFirstListener(){q&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return V&&V.add(fe),fe.event}F.buffer=W;function se(ke,Ie){return(V,q,Q)=>{const x=Ie(new te);return ke(function(fe){const we=x.evaluate(fe);we!==oe&&V.call(q,we)},void 0,Q)}}F.chain=se;const oe=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Te=>(Ie(Te),Te)),this}filter(Ie){return this.f.push(Te=>Ie(Te)?Te:oe),this}reduce(Ie,Te){let V=Te;return this.f.push(q=>(V=Ie(V,q),V)),this}latch(Ie=(Te,V)=>Te===V){let Te=!0,V;return this.f.push(q=>{const Q=Te||!Ie(q,V);return Te=!1,V=q,Q?q:oe}),this}evaluate(Ie){for(const Te of this.f)if(Ie=Te(Ie),Ie===oe)break;return Ie}}function le(ke,Ie,Te=V=>V){const V=(...fe)=>x.fire(Te(...fe)),q=()=>ke.on(Ie,V),Q=()=>ke.removeListener(Ie,V),x=new s({onWillAddFirstListener:q,onDidRemoveLastListener:Q});return x.event}F.fromNodeEventEmitter=le;function he(ke,Ie,Te=V=>V){const V=(...fe)=>x.fire(Te(...fe)),q=()=>ke.addEventListener(Ie,V),Q=()=>ke.removeEventListener(Ie,V),x=new s({onWillAddFirstListener:q,onDidRemoveLastListener:Q});return x.event}F.fromDOMEventEmitter=he;function Z(ke){return new Promise(Ie=>M(ke)(Ie))}F.toPromise=Z;function ae(ke){const Ie=new s;return ke.then(Te=>{Ie.fire(Te)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}F.fromPromise=ae;function pe(ke,Ie,Te){return Ie(Te),ke(V=>Ie(V))}F.runAndSubscribe=pe;class be{constructor(Ie,Te){this._observable=Ie,this.f=0,this.g=!1;const V={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Te||j(V),this.emitter=new s(V),Te&&Te.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Te){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Me(ke,Ie){return new be(ke,Ie).emitter.event}F.fromObservable=Me;function ze(ke){return(Ie,Te,V)=>{let q=0,Q=!1;const x={beginUpdate(){q++},endUpdate(){q--,q===0&&(ke.reportChanges(),Q&&(Q=!1,Ie.call(Te)))},handlePossibleChange(){},handleChange(){Q=!0}};ke.addObserver(x),ke.reportChanges();const fe={dispose(){ke.removeObserver(x)}};return V instanceof A.$Uc?V.add(fe):Array.isArray(V)&&V.push(fe),fe}}F.fromObservableLight=ze})(I||(e.Event=I={}));class E{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${E.f++}`,E.all.add(this)}start(j){this.g=new N.$fe,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$he=E;let u=-1;function k(F){const j=u;return u=F,{dispose(){u=j}}}class b{constructor(j,B,M=Math.random().toString(18).slice(2,5)){this.h=j,this.threshold=B,this.name=M,this.g=0}dispose(){this.f?.clear()}check(j,B){const M=this.threshold;if(M<=0||B<M)return;this.f||(this.f=new Map);const z=this.f.get(j.value)||0;if(this.f.set(j.value,z+1),this.g-=1,this.g<=0){this.g=M*.5;const[_,re]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${re}):`;console.warn(U),console.warn(_);const G=new g(U,_);this.h(G)}return()=>{const _=this.f.get(j.value)||0;this.f.set(j.value,_-1)}}getMostFrequentStack(){if(!this.f)return;let j,B=0;for(const[M,z]of this.f)(!j||B<z)&&(j=[M,z],B=z);return j}}class c{static create(){const j=new Error;return new c(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(j,B){super(j),this.name="ListenerLeakError",this.stack=B}}e.$je=g;class f extends Error{constructor(j,B){super(j),this.name="ListenerRefusalError",this.stack=B}}e.$ke=f;let m=0;class n{constructor(j){this.value=j,this.id=m++}}const o=2,i=(F,j)=>{if(F instanceof n)j(F);else for(let B=0;B<F.length;B++){const M=F[B];M&&j(M)}};let t;if(T){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),t=new FinalizationRegistry(j=>{typeof j=="string"&&F.push(j)})}class s{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new b(j?.onListenerError??r.$2,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{i(j,B=>B.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,B,M)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const K=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new f(`${G}. HINT: Stack shows most frequent listener (${K[1]}-times)`,K[0]);return(this.f?.onListenerError||r.$2)(ee),A.$Vc.None}if(this.m)return A.$Vc.None;B&&(j=j.bind(B));const z=new n(j);let _,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(z.stack=c.create(),_=this.g.check(z.stack,this.z+1)),$&&(z.stack=re??c.create()),this.u?this.u instanceof n?(this.w??=new a,this.u=[this.u,z]):this.u.push(z):(this.f?.onWillAddFirstListener?.(this),this.u=z,this.f?.onDidAddFirstListener?.(this)),this.z++;const U=(0,A.$Tc)(()=>{t?.unregister(U),_?.(),this.A(z)});if(M instanceof A.$Uc?M.add(U):Array.isArray(M)&&M.push(U),t){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),K=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);t.register(U,K?.[2]??G,U)}return U},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const B=this.u,M=B.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,B[M]=void 0;const z=this.w.current===this;if(this.z*o<=B.length){let _=0;for(let re=0;re<B.length;re++)B[re]?B[_++]=B[re]:z&&(this.w.end--,_<this.w.i&&this.w.i--);B.length=_}}B(j,B){if(!j)return;const M=this.f?.onListenerError||r.$2;if(!M){j.value(B);return}try{j.value(B)}catch(z){M(z)}}C(j){const B=j.current.u;for(;j.i<j.end;)this.B(B[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const B=this.w;B.enqueue(this,j,this.u.length),this.C(B)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=s;const d=()=>new a;e.$me=d;class a{constructor(){this.i=-1,this.end=0}enqueue(j,B,M){this.i=0,this.end=M,this.current=j,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class w extends s{async fireAsync(j,B,M){if(this.u)for(this.h||(this.h=new R.$6c),i(this.u,z=>this.h.push([z.value,j]));this.h.size>0&&!B.isCancellationRequested;){const[z,_]=this.h.shift(),re=[],U={..._,token:B,waitUntil:G=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");M&&(G=M(G,z)),re.push(G)}};try{z(U)}catch(G){(0,r.$2)(G);continue}Object.freeze(re),await Promise.allSettled(re).then(G=>{for(const K of G)K.status==="rejected"&&(0,r.$2)(K.reason)})}}}e.$ne=w;class y extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$6c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$oe=y;class S extends y{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$pe=S;class D extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}e.$qe=D;class P{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const B={event:j,listener:null};this.h.push(B),this.g&&this.m(B);const M=()=>{this.g&&this.o(B);const z=this.h.indexOf(B);this.h.splice(z,1)};return(0,A.$Tc)((0,h.$eb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(B=>this.f.fire(B))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$re=P;class C{constructor(j,B,M,z){this.f=new A.$Uc;const _=this.f.add(new P),re=this.f.add(new A.$5c);function U(G){re.set(G,_.add(z(G)))}for(const G of j)U(G);this.f.add(B(G=>{U(G)})),this.f.add(M(G=>{re.deleteAndDispose(G)})),this.event=_.event}dispose(){this.f.dispose()}}e.$se=C;class p{constructor(){this.f=[]}wrapEvent(j,B,M){return(z,_,re)=>j(U=>{const G=this.f[this.f.length-1];if(!B){G?G.buffers.push(()=>z.call(_,U)):z.call(_,U);return}const K=G;if(!K){z.call(_,B(M,U));return}K.items??=[],K.items.push(U),K.buffers.length===0&&G.buffers.push(()=>{K.reducedResult??=M?K.items.reduce(B,M):K.items.reduce(B),z.call(_,K.reducedResult)})},void 0,re)}bufferEvents(j){const B={buffers:new Array};this.f.push(B);const M=j();return this.f.pop(),B.buffers.forEach(z=>z()),M}}e.$te=p;class v{constructor(){this.f=!1,this.g=I.None,this.h=A.$Vc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=v;class O{static const(j){return new L(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$ve=O;class L{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(Ee[21],Se([1,0,4]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=T;const h=Object.freeze(function($,l){const I=setTimeout($.bind(l),0);return{dispose(){clearTimeout(I)}}});var A;(function($){function l(I){return I===$.None||I===$.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}$.isCancellationToken=l,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$we=N;function T($){const l=new N;return $.add({dispose(){l.cancel()}}),l.token}}),define(Ee[182],Se([1,0,21]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=A;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new r.$we,l=this.b($.token);return this.a={promise:l,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$9e=h;function A(T){return T}class R{constructor($,l){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);return this.b!==l&&(this.b=l,this.a=this.c($)),this.a}}e.$$e=R;class N{get cachedValues(){return this.a}constructor($,l){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);if(this.b.has(l))return this.b.get(l);const I=this.c($);return this.a.set($,I),this.b.set(l,I),I}}e.$_e=N}),define(Ee[183],Se([1,0,4,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$$s=e.$0s=e.$9s=e.ScrollbarVisibility=void 0;var A;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(A||(e.ScrollbarVisibility=A={}));class R{constructor(b,c,g,f,m,n,o){this.c=b,this._scrollStateBrand=void 0,this.c&&(c=c|0,g=g|0,f=f|0,m=m|0,n=n|0,o=o|0),this.rawScrollLeft=f,this.rawScrollTop=o,c<0&&(c=0),f+c>g&&(f=g-c),f<0&&(f=0),m<0&&(m=0),o+m>n&&(o=n-m),o<0&&(o=0),this.width=c,this.scrollWidth=g,this.scrollLeft=f,this.height=m,this.scrollHeight=n,this.scrollTop=o}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,c){return new R(this.c,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new R(this.c,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,c){const g=this.width!==b.width,f=this.scrollWidth!==b.scrollWidth,m=this.scrollLeft!==b.scrollLeft,n=this.height!==b.height,o=this.scrollHeight!==b.scrollHeight,i=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:c,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:f,scrollLeftChanged:m,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:i}}}e.$9s=R;class N extends h.$Vc{constructor(b){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$le),this.onScroll=this.j.event,this.c=b.smoothScrollDuration,this.f=b.scheduleAtNextAnimationFrame,this.g=new R(b.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(b){this.c=b}validateScrollPosition(b){return this.g.withScrollPosition(b)}getScrollDimensions(){return this.g}setScrollDimensions(b,c){const g=this.g.withScrollDimensions(b,c);this.n(g,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(b){const c=this.g.withScrollPosition(b);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(b,c){if(this.c===0)return this.setScrollPositionNow(b);if(this.h){b={scrollLeft:typeof b.scrollLeft>"u"?this.h.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this.h.to.scrollTop:b.scrollTop};const g=this.g.withScrollPosition(b);if(this.h.to.scrollLeft===g.scrollLeft&&this.h.to.scrollTop===g.scrollTop)return;let f;c?f=new I(this.h.from,g,this.h.startTime,this.h.duration):f=this.h.combine(this.g,g,this.c),this.h.dispose(),this.h=f}else{const g=this.g.withScrollPosition(b);this.h=I.start(this.g,g,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const b=this.h.tick(),c=this.g.withScrollPosition(b);if(this.n(c,!0),!!this.h){if(b.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(b,c){const g=this.g;g.equals(b)||(this.g=b,this.j.fire(this.g.createScrollEvent(g,c)))}}e.$0s=N;class T{constructor(b,c,g){this.scrollLeft=b,this.scrollTop=c,this.isDone=g}}e.$$s=T;function $(k,b){const c=b-k;return function(g){return k+c*u(g)}}function l(k,b,c){return function(g){return g<c?k(g/c):b((g-c)/(1-c))}}class I{constructor(b,c,g,f){this.from=b,this.to=c,this.duration=f,this.startTime=g,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(b,c,g){if(Math.abs(b-c)>2.5*g){let m,n;return b<c?(m=b+.75*g,n=c-.75*g):(m=b-.75*g,n=c+.75*g),l($(b,m),$(n,c),.33)}return $(b,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(b){const c=(b-this.startTime)/this.duration;if(c<1){const g=this.c(c),f=this.d(c);return new T(g,f,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,c,g){return I.start(b,c,g)}static start(b,c,g){g=g+10;const f=Date.now()-10;return new I(b,c,f,g)}}e.$_s=I;function E(k){return Math.pow(k,3)}function u(k){return 1-E(1-k)}}),define(Ee[104],Se([1,0,14,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=A,e.$ze=R,e.$Ae=N,e.$Be=T,e.$Ce=l,e.$De=I,e.$Ee=E,e.$Fe=u,e.$Ge=k,e.$He=b,e.$Ie=c,e.$Je=g,e.$Ke=f,e.$Le=m,e.$Me=n;function A(o){const i=o;return i?typeof i.read=="function":!1}function R(o){const i=o;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function N(o){const i=o;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function T(o,i){return new $(o,i)}class ${constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,r.$2)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let s;switch(i){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(t);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(o,i){const t=[];let s;for(;(s=o.read())!==null;)t.push(s);return i(t)}function I(o,i,t){const s=[];let d;for(;(d=o.read())!==null&&s.length<t;)s.push(d);return d===null&&s.length>0?i(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const a=d;return d=void 0,a}return o.read()}}}function E(o,i){return new Promise((t,s)=>{const d=[];u(o,{onData:a=>{i&&d.push(a)},onError:a=>{i?s(a):t(void 0)},onEnd:()=>{t(i?i(d):void 0)}})})}function u(o,i,t){o.on("error",s=>{t?.isCancellationRequested||i.onError(s)}),o.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),o.on("data",s=>{t?.isCancellationRequested||i.onData(s)})}function k(o,i){return new Promise((t,s)=>{const d=new h.$Uc,a=[],w=D=>{if(a.push(D),a.length>i)return d.dispose(),o.pause(),t({stream:o,buffer:a,ended:!1})},y=D=>(d.dispose(),s(D)),S=()=>(d.dispose(),t({stream:o,buffer:a,ended:!0}));d.add((0,h.$Tc)(()=>o.removeListener("error",y))),o.on("error",y),d.add((0,h.$Tc)(()=>o.removeListener("end",S))),o.on("end",S),d.add((0,h.$Tc)(()=>o.removeListener("data",w))),o.on("data",w)})}function b(o,i){const t=T(i);return t.end(o),t}function c(){const o=T(()=>{throw new Error("not supported")});return o.end(),o}function g(o){let i=!1;return{read:()=>i?null:(i=!0,o)}}function f(o,i,t){const s=T(t);return u(o,{onData:d=>s.write(i.data(d)),onError:d=>s.error(i.error?i.error(d):d),onEnd:()=>s.end()}),s}function m(o,i,t){let s=!1;return{read:()=>{const d=i.read();return s?d:(s=!0,d!==null?t([o,d]):o)}}}function n(o,i,t){let s=!1;const d=T(t);return u(i,{onData:a=>s?d.write(a):(s=!0,d.write(t([o,a]))),onError:a=>d.error(a),onEnd:()=>{s||(s=!0,d.write(o)),d.end()}}),d}}),define(Ee[22],Se([1,0,49,104]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=l,e.$Pe=I,e.$Qe=E,e.$Re=u,e.$Se=k,e.$Te=b,e.$Ue=c,e.$Ve=g,e.$We=f,e.$Xe=m,e.$Ye=n,e.$Ze=o,e.$1e=i,e.$2e=t,e.$3e=s,e.$4e=d,e.$5e=a,e.$6e=w,e.$7e=y,e.$8e=P,h=We(h);const A=typeof Buffer<"u",R=new r.$W(()=>new Uint8Array(256));let N,T;class ${static alloc(p){return A?new $(Buffer.allocUnsafe(p)):new $(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new $(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&A?new $(Buffer.from(p)):(N||(N=new TextEncoder),new $(N.encode(p)))}static fromByteArray(p){const v=$.alloc(p.length);for(let O=0,L=p.length;O<L;O++)v.buffer[O]=p[O];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let F=0,j=p.length;F<j;F++)v+=p[F].byteLength}const O=$.alloc(v);let L=0;for(let F=0,j=p.length;F<j;F++){const B=p[F];O.set(B,L),L+=B.byteLength}return O}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=$.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(p,v){return new $(this.buffer.subarray(p,v))}set(p,v){if(p instanceof $)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,v){k(this.buffer,p,v)}readUInt32LE(p){return b(this.buffer,p)}writeUInt32LE(p,v){c(this.buffer,p,v)}readUInt8(p){return g(this.buffer,p)}writeUInt8(p,v){f(this.buffer,p,v)}indexOf(p,v=0){return l(this.buffer,p instanceof $?p.buffer:p,v)}}e.$Ne=$;function l(C,p,v=0){const O=p.byteLength,L=C.byteLength;if(O===0)return 0;if(O===1)return C.indexOf(p[0]);if(O>L-v)return-1;const F=R.value;F.fill(p.length);for(let z=0;z<p.length;z++)F[p[z]]=p.length-z-1;let j=v+p.length-1,B=j,M=-1;for(;j<L;)if(C[j]===p[B]){if(B===0){M=j;break}j--,B--}else j+=Math.max(p.length-B,F[C[j]]),B=p.length-1;return M}function I(C,p){return C[p+0]<<0>>>0|C[p+1]<<8>>>0}function E(C,p,v){C[v+0]=p&255,p=p>>>8,C[v+1]=p&255}function u(C,p){return C[p]*2**24+C[p+1]*2**16+C[p+2]*2**8+C[p+3]}function k(C,p,v){C[v+3]=p,p=p>>>8,C[v+2]=p,p=p>>>8,C[v+1]=p,p=p>>>8,C[v]=p}function b(C,p){return C[p+0]<<0>>>0|C[p+1]<<8>>>0|C[p+2]<<16>>>0|C[p+3]<<24>>>0}function c(C,p,v){C[v+0]=p&255,p=p>>>8,C[v+1]=p&255,p=p>>>8,C[v+2]=p&255,p=p>>>8,C[v+3]=p&255}function g(C,p){return C[p]}function f(C,p,v){C[v]=p}function m(C){return h.$Ce(C,p=>$.concat(p))}function n(C){return h.$Je(C)}function o(C){return h.$Ee(C,p=>$.concat(p))}async function i(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await o(C.stream)])}function t(C){return h.$He(C,p=>$.concat(p))}function s(C){return h.$Ke(C,{data:p=>typeof p=="string"?$.fromString(p):$.wrap(p)},p=>$.concat(p))}function d(C){return h.$Be(p=>$.concat(p),C)}function a(C,p){return h.$Le(C,p,v=>$.concat(v))}function w(C,p){return h.$Me(C,p,v=>$.concat(v))}function y(C){let p=0,v=0,O=0;const L=new Uint8Array(Math.floor(C.length/4*3)),F=B=>{switch(v){case 3:L[O++]=p|B,v=0;break;case 2:L[O++]=p|B>>>2,p=B<<6,v=3;break;case 1:L[O++]=p|B>>>4,p=B<<4,v=2;break;default:p=B<<2,v=1}};for(let B=0;B<C.length;B++){const M=C.charCodeAt(B);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${C[B]}`)}}const j=O;for(;v>0;)F(0);return $.wrap(L).slice(0,j)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:C},p=!0,v=!1){const O=v?D:S;let L="";const F=C.byteLength%3;let j=0;for(;j<C.byteLength-F;j+=3){const B=C[j+0],M=C[j+1],z=C[j+2];L+=O[B>>>2],L+=O[(B<<4|M>>>4)&63],L+=O[(M<<2|z>>>6)&63],L+=O[z&63]}if(F===1){const B=C[j+0];L+=O[B>>>2],L+=O[B<<4&63],p&&(L+="==")}else if(F===2){const B=C[j+0],M=C[j+1];L+=O[B>>>2],L+=O[(B<<4|M>>>4)&63],L+=O[M<<2&63],p&&(L+="=")}return L}}),define(Ee[184],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(Ee[18],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=r,e.$fg=h,e.$gg=A,e.$hg=R,e.$ig=N,e.$jg=T,e.$kg=$,e.$lg=l,e.$mg=I,e.$ng=E,e.$og=u,e.$pg=k,e.$qg=b,e.$rg=g,e.$sg=f,e.$tg=m,e.$ug=n,e.$vg=o;function r(i){return typeof i=="string"}function h(i){return Array.isArray(i)&&i.every(t=>r(t))}function A(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function R(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function N(i){return typeof i=="number"&&!isNaN(i)}function T(i){return!!i&&typeof i[Symbol.iterator]=="function"}function $(i){return i===!0||i===!1}function l(i){return typeof i>"u"}function I(i){return!E(i)}function E(i){return l(i)||i===null}function u(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function k(i){if(E(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function b(...i){const t=[];for(let s=0;s<i.length;s++){const d=i[s];if(E(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(d)}return t}const c=Object.prototype.hasOwnProperty;function g(i){if(!A(i))return!1;for(const t in i)if(c.call(i,t))return!1;return!0}function f(i){return typeof i=="function"}function m(...i){return i.length>0&&i.every(f)}function n(i,t){const s=Math.min(i.length,t.length);for(let d=0;d<s;d++)o(i[d],t[d])}function o(i,t){if(r(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(i instanceof t)return}catch{}if(!E(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[105],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=A,e.$Zj=R;const h=Object.create(null);function A(N,T){if((0,r.$eg)(T)){const $=h[T];if($===void 0)throw new Error(`${N} references an unknown codicon: ${T}`);T=$}return h[N]=T,{id:N}}function R(){return h}}),define(Ee[185],Se([1,0,105]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=void 0,e.$1j={add:(0,r.$Yj)("add",6e4),plus:(0,r.$Yj)("plus",6e4),gistNew:(0,r.$Yj)("gist-new",6e4),repoCreate:(0,r.$Yj)("repo-create",6e4),lightbulb:(0,r.$Yj)("lightbulb",60001),lightBulb:(0,r.$Yj)("light-bulb",60001),repo:(0,r.$Yj)("repo",60002),repoDelete:(0,r.$Yj)("repo-delete",60002),gistFork:(0,r.$Yj)("gist-fork",60003),repoForked:(0,r.$Yj)("repo-forked",60003),gitPullRequest:(0,r.$Yj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Yj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Yj)("record-keys",60005),keyboard:(0,r.$Yj)("keyboard",60005),tag:(0,r.$Yj)("tag",60006),gitPullRequestLabel:(0,r.$Yj)("git-pull-request-label",60006),tagAdd:(0,r.$Yj)("tag-add",60006),tagRemove:(0,r.$Yj)("tag-remove",60006),person:(0,r.$Yj)("person",60007),personFollow:(0,r.$Yj)("person-follow",60007),personOutline:(0,r.$Yj)("person-outline",60007),personFilled:(0,r.$Yj)("person-filled",60007),gitBranch:(0,r.$Yj)("git-branch",60008),gitBranchCreate:(0,r.$Yj)("git-branch-create",60008),gitBranchDelete:(0,r.$Yj)("git-branch-delete",60008),sourceControl:(0,r.$Yj)("source-control",60008),mirror:(0,r.$Yj)("mirror",60009),mirrorPublic:(0,r.$Yj)("mirror-public",60009),star:(0,r.$Yj)("star",60010),starAdd:(0,r.$Yj)("star-add",60010),starDelete:(0,r.$Yj)("star-delete",60010),starEmpty:(0,r.$Yj)("star-empty",60010),comment:(0,r.$Yj)("comment",60011),commentAdd:(0,r.$Yj)("comment-add",60011),alert:(0,r.$Yj)("alert",60012),warning:(0,r.$Yj)("warning",60012),search:(0,r.$Yj)("search",60013),searchSave:(0,r.$Yj)("search-save",60013),logOut:(0,r.$Yj)("log-out",60014),signOut:(0,r.$Yj)("sign-out",60014),logIn:(0,r.$Yj)("log-in",60015),signIn:(0,r.$Yj)("sign-in",60015),eye:(0,r.$Yj)("eye",60016),eyeUnwatch:(0,r.$Yj)("eye-unwatch",60016),eyeWatch:(0,r.$Yj)("eye-watch",60016),circleFilled:(0,r.$Yj)("circle-filled",60017),primitiveDot:(0,r.$Yj)("primitive-dot",60017),closeDirty:(0,r.$Yj)("close-dirty",60017),debugBreakpoint:(0,r.$Yj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Yj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Yj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Yj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Yj)("primitive-square",60018),edit:(0,r.$Yj)("edit",60019),pencil:(0,r.$Yj)("pencil",60019),info:(0,r.$Yj)("info",60020),issueOpened:(0,r.$Yj)("issue-opened",60020),gistPrivate:(0,r.$Yj)("gist-private",60021),gitForkPrivate:(0,r.$Yj)("git-fork-private",60021),lock:(0,r.$Yj)("lock",60021),mirrorPrivate:(0,r.$Yj)("mirror-private",60021),close:(0,r.$Yj)("close",60022),removeClose:(0,r.$Yj)("remove-close",60022),x:(0,r.$Yj)("x",60022),repoSync:(0,r.$Yj)("repo-sync",60023),sync:(0,r.$Yj)("sync",60023),clone:(0,r.$Yj)("clone",60024),desktopDownload:(0,r.$Yj)("desktop-download",60024),beaker:(0,r.$Yj)("beaker",60025),microscope:(0,r.$Yj)("microscope",60025),vm:(0,r.$Yj)("vm",60026),deviceDesktop:(0,r.$Yj)("device-desktop",60026),file:(0,r.$Yj)("file",60027),fileText:(0,r.$Yj)("file-text",60027),more:(0,r.$Yj)("more",60028),ellipsis:(0,r.$Yj)("ellipsis",60028),kebabHorizontal:(0,r.$Yj)("kebab-horizontal",60028),mailReply:(0,r.$Yj)("mail-reply",60029),reply:(0,r.$Yj)("reply",60029),organization:(0,r.$Yj)("organization",60030),organizationFilled:(0,r.$Yj)("organization-filled",60030),organizationOutline:(0,r.$Yj)("organization-outline",60030),newFile:(0,r.$Yj)("new-file",60031),fileAdd:(0,r.$Yj)("file-add",60031),newFolder:(0,r.$Yj)("new-folder",60032),fileDirectoryCreate:(0,r.$Yj)("file-directory-create",60032),trash:(0,r.$Yj)("trash",60033),trashcan:(0,r.$Yj)("trashcan",60033),history:(0,r.$Yj)("history",60034),clock:(0,r.$Yj)("clock",60034),folder:(0,r.$Yj)("folder",60035),fileDirectory:(0,r.$Yj)("file-directory",60035),symbolFolder:(0,r.$Yj)("symbol-folder",60035),logoGithub:(0,r.$Yj)("logo-github",60036),markGithub:(0,r.$Yj)("mark-github",60036),github:(0,r.$Yj)("github",60036),terminal:(0,r.$Yj)("terminal",60037),console:(0,r.$Yj)("console",60037),repl:(0,r.$Yj)("repl",60037),zap:(0,r.$Yj)("zap",60038),symbolEvent:(0,r.$Yj)("symbol-event",60038),error:(0,r.$Yj)("error",60039),stop:(0,r.$Yj)("stop",60039),variable:(0,r.$Yj)("variable",60040),symbolVariable:(0,r.$Yj)("symbol-variable",60040),array:(0,r.$Yj)("array",60042),symbolArray:(0,r.$Yj)("symbol-array",60042),symbolModule:(0,r.$Yj)("symbol-module",60043),symbolPackage:(0,r.$Yj)("symbol-package",60043),symbolNamespace:(0,r.$Yj)("symbol-namespace",60043),symbolObject:(0,r.$Yj)("symbol-object",60043),symbolMethod:(0,r.$Yj)("symbol-method",60044),symbolFunction:(0,r.$Yj)("symbol-function",60044),symbolConstructor:(0,r.$Yj)("symbol-constructor",60044),symbolBoolean:(0,r.$Yj)("symbol-boolean",60047),symbolNull:(0,r.$Yj)("symbol-null",60047),symbolNumeric:(0,r.$Yj)("symbol-numeric",60048),symbolNumber:(0,r.$Yj)("symbol-number",60048),symbolStructure:(0,r.$Yj)("symbol-structure",60049),symbolStruct:(0,r.$Yj)("symbol-struct",60049),symbolParameter:(0,r.$Yj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Yj)("symbol-type-parameter",60050),symbolKey:(0,r.$Yj)("symbol-key",60051),symbolText:(0,r.$Yj)("symbol-text",60051),symbolReference:(0,r.$Yj)("symbol-reference",60052),goToFile:(0,r.$Yj)("go-to-file",60052),symbolEnum:(0,r.$Yj)("symbol-enum",60053),symbolValue:(0,r.$Yj)("symbol-value",60053),symbolRuler:(0,r.$Yj)("symbol-ruler",60054),symbolUnit:(0,r.$Yj)("symbol-unit",60054),activateBreakpoints:(0,r.$Yj)("activate-breakpoints",60055),archive:(0,r.$Yj)("archive",60056),arrowBoth:(0,r.$Yj)("arrow-both",60057),arrowDown:(0,r.$Yj)("arrow-down",60058),arrowLeft:(0,r.$Yj)("arrow-left",60059),arrowRight:(0,r.$Yj)("arrow-right",60060),arrowSmallDown:(0,r.$Yj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Yj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Yj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Yj)("arrow-small-up",60064),arrowUp:(0,r.$Yj)("arrow-up",60065),bell:(0,r.$Yj)("bell",60066),bold:(0,r.$Yj)("bold",60067),book:(0,r.$Yj)("book",60068),bookmark:(0,r.$Yj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Yj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Yj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Yj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Yj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Yj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Yj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Yj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Yj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Yj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Yj)("briefcase",60076),broadcast:(0,r.$Yj)("broadcast",60077),browser:(0,r.$Yj)("browser",60078),bug:(0,r.$Yj)("bug",60079),calendar:(0,r.$Yj)("calendar",60080),caseSensitive:(0,r.$Yj)("case-sensitive",60081),check:(0,r.$Yj)("check",60082),checklist:(0,r.$Yj)("checklist",60083),chevronDown:(0,r.$Yj)("chevron-down",60084),chevronLeft:(0,r.$Yj)("chevron-left",60085),chevronRight:(0,r.$Yj)("chevron-right",60086),chevronUp:(0,r.$Yj)("chevron-up",60087),chromeClose:(0,r.$Yj)("chrome-close",60088),chromeMaximize:(0,r.$Yj)("chrome-maximize",60089),chromeMinimize:(0,r.$Yj)("chrome-minimize",60090),chromeRestore:(0,r.$Yj)("chrome-restore",60091),circleOutline:(0,r.$Yj)("circle-outline",60092),circle:(0,r.$Yj)("circle",60092),debugBreakpointUnverified:(0,r.$Yj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Yj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Yj)("circle-slash",60093),circuitBoard:(0,r.$Yj)("circuit-board",60094),clearAll:(0,r.$Yj)("clear-all",60095),clippy:(0,r.$Yj)("clippy",60096),closeAll:(0,r.$Yj)("close-all",60097),cloudDownload:(0,r.$Yj)("cloud-download",60098),cloudUpload:(0,r.$Yj)("cloud-upload",60099),code:(0,r.$Yj)("code",60100),collapseAll:(0,r.$Yj)("collapse-all",60101),colorMode:(0,r.$Yj)("color-mode",60102),commentDiscussion:(0,r.$Yj)("comment-discussion",60103),creditCard:(0,r.$Yj)("credit-card",60105),dash:(0,r.$Yj)("dash",60108),dashboard:(0,r.$Yj)("dashboard",60109),database:(0,r.$Yj)("database",60110),debugContinue:(0,r.$Yj)("debug-continue",60111),debugDisconnect:(0,r.$Yj)("debug-disconnect",60112),debugPause:(0,r.$Yj)("debug-pause",60113),debugRestart:(0,r.$Yj)("debug-restart",60114),debugStart:(0,r.$Yj)("debug-start",60115),debugStepInto:(0,r.$Yj)("debug-step-into",60116),debugStepOut:(0,r.$Yj)("debug-step-out",60117),debugStepOver:(0,r.$Yj)("debug-step-over",60118),debugStop:(0,r.$Yj)("debug-stop",60119),debug:(0,r.$Yj)("debug",60120),deviceCameraVideo:(0,r.$Yj)("device-camera-video",60121),deviceCamera:(0,r.$Yj)("device-camera",60122),deviceMobile:(0,r.$Yj)("device-mobile",60123),diffAdded:(0,r.$Yj)("diff-added",60124),diffIgnored:(0,r.$Yj)("diff-ignored",60125),diffModified:(0,r.$Yj)("diff-modified",60126),diffRemoved:(0,r.$Yj)("diff-removed",60127),diffRenamed:(0,r.$Yj)("diff-renamed",60128),diff:(0,r.$Yj)("diff",60129),diffSidebyside:(0,r.$Yj)("diff-sidebyside",60129),discard:(0,r.$Yj)("discard",60130),editorLayout:(0,r.$Yj)("editor-layout",60131),emptyWindow:(0,r.$Yj)("empty-window",60132),exclude:(0,r.$Yj)("exclude",60133),extensions:(0,r.$Yj)("extensions",60134),eyeClosed:(0,r.$Yj)("eye-closed",60135),fileBinary:(0,r.$Yj)("file-binary",60136),fileCode:(0,r.$Yj)("file-code",60137),fileMedia:(0,r.$Yj)("file-media",60138),filePdf:(0,r.$Yj)("file-pdf",60139),fileSubmodule:(0,r.$Yj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Yj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Yj)("file-symlink-file",60142),fileZip:(0,r.$Yj)("file-zip",60143),files:(0,r.$Yj)("files",60144),filter:(0,r.$Yj)("filter",60145),flame:(0,r.$Yj)("flame",60146),foldDown:(0,r.$Yj)("fold-down",60147),foldUp:(0,r.$Yj)("fold-up",60148),fold:(0,r.$Yj)("fold",60149),folderActive:(0,r.$Yj)("folder-active",60150),folderOpened:(0,r.$Yj)("folder-opened",60151),gear:(0,r.$Yj)("gear",60152),gift:(0,r.$Yj)("gift",60153),gistSecret:(0,r.$Yj)("gist-secret",60154),gist:(0,r.$Yj)("gist",60155),gitCommit:(0,r.$Yj)("git-commit",60156),gitCompare:(0,r.$Yj)("git-compare",60157),compareChanges:(0,r.$Yj)("compare-changes",60157),gitMerge:(0,r.$Yj)("git-merge",60158),githubAction:(0,r.$Yj)("github-action",60159),githubAlt:(0,r.$Yj)("github-alt",60160),globe:(0,r.$Yj)("globe",60161),grabber:(0,r.$Yj)("grabber",60162),graph:(0,r.$Yj)("graph",60163),gripper:(0,r.$Yj)("gripper",60164),heart:(0,r.$Yj)("heart",60165),home:(0,r.$Yj)("home",60166),horizontalRule:(0,r.$Yj)("horizontal-rule",60167),hubot:(0,r.$Yj)("hubot",60168),inbox:(0,r.$Yj)("inbox",60169),issueReopened:(0,r.$Yj)("issue-reopened",60171),issues:(0,r.$Yj)("issues",60172),italic:(0,r.$Yj)("italic",60173),jersey:(0,r.$Yj)("jersey",60174),json:(0,r.$Yj)("json",60175),kebabVertical:(0,r.$Yj)("kebab-vertical",60176),key:(0,r.$Yj)("key",60177),law:(0,r.$Yj)("law",60178),lightbulbAutofix:(0,r.$Yj)("lightbulb-autofix",60179),linkExternal:(0,r.$Yj)("link-external",60180),link:(0,r.$Yj)("link",60181),listOrdered:(0,r.$Yj)("list-ordered",60182),listUnordered:(0,r.$Yj)("list-unordered",60183),liveShare:(0,r.$Yj)("live-share",60184),loading:(0,r.$Yj)("loading",60185),location:(0,r.$Yj)("location",60186),mailRead:(0,r.$Yj)("mail-read",60187),mail:(0,r.$Yj)("mail",60188),markdown:(0,r.$Yj)("markdown",60189),megaphone:(0,r.$Yj)("megaphone",60190),mention:(0,r.$Yj)("mention",60191),milestone:(0,r.$Yj)("milestone",60192),gitPullRequestMilestone:(0,r.$Yj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Yj)("mortar-board",60193),move:(0,r.$Yj)("move",60194),multipleWindows:(0,r.$Yj)("multiple-windows",60195),mute:(0,r.$Yj)("mute",60196),noNewline:(0,r.$Yj)("no-newline",60197),note:(0,r.$Yj)("note",60198),octoface:(0,r.$Yj)("octoface",60199),openPreview:(0,r.$Yj)("open-preview",60200),package:(0,r.$Yj)("package",60201),paintcan:(0,r.$Yj)("paintcan",60202),pin:(0,r.$Yj)("pin",60203),play:(0,r.$Yj)("play",60204),run:(0,r.$Yj)("run",60204),plug:(0,r.$Yj)("plug",60205),preserveCase:(0,r.$Yj)("preserve-case",60206),preview:(0,r.$Yj)("preview",60207),project:(0,r.$Yj)("project",60208),pulse:(0,r.$Yj)("pulse",60209),question:(0,r.$Yj)("question",60210),quote:(0,r.$Yj)("quote",60211),radioTower:(0,r.$Yj)("radio-tower",60212),reactions:(0,r.$Yj)("reactions",60213),references:(0,r.$Yj)("references",60214),refresh:(0,r.$Yj)("refresh",60215),regex:(0,r.$Yj)("regex",60216),remoteExplorer:(0,r.$Yj)("remote-explorer",60217),remote:(0,r.$Yj)("remote",60218),remove:(0,r.$Yj)("remove",60219),replaceAll:(0,r.$Yj)("replace-all",60220),replace:(0,r.$Yj)("replace",60221),repoClone:(0,r.$Yj)("repo-clone",60222),repoForcePush:(0,r.$Yj)("repo-force-push",60223),repoPull:(0,r.$Yj)("repo-pull",60224),repoPush:(0,r.$Yj)("repo-push",60225),report:(0,r.$Yj)("report",60226),requestChanges:(0,r.$Yj)("request-changes",60227),rocket:(0,r.$Yj)("rocket",60228),rootFolderOpened:(0,r.$Yj)("root-folder-opened",60229),rootFolder:(0,r.$Yj)("root-folder",60230),rss:(0,r.$Yj)("rss",60231),ruby:(0,r.$Yj)("ruby",60232),saveAll:(0,r.$Yj)("save-all",60233),saveAs:(0,r.$Yj)("save-as",60234),save:(0,r.$Yj)("save",60235),screenFull:(0,r.$Yj)("screen-full",60236),screenNormal:(0,r.$Yj)("screen-normal",60237),searchStop:(0,r.$Yj)("search-stop",60238),server:(0,r.$Yj)("server",60240),settingsGear:(0,r.$Yj)("settings-gear",60241),settings:(0,r.$Yj)("settings",60242),shield:(0,r.$Yj)("shield",60243),smiley:(0,r.$Yj)("smiley",60244),sortPrecedence:(0,r.$Yj)("sort-precedence",60245),splitHorizontal:(0,r.$Yj)("split-horizontal",60246),splitVertical:(0,r.$Yj)("split-vertical",60247),squirrel:(0,r.$Yj)("squirrel",60248),starFull:(0,r.$Yj)("star-full",60249),starHalf:(0,r.$Yj)("star-half",60250),symbolClass:(0,r.$Yj)("symbol-class",60251),symbolColor:(0,r.$Yj)("symbol-color",60252),symbolConstant:(0,r.$Yj)("symbol-constant",60253),symbolEnumMember:(0,r.$Yj)("symbol-enum-member",60254),symbolField:(0,r.$Yj)("symbol-field",60255),symbolFile:(0,r.$Yj)("symbol-file",60256),symbolInterface:(0,r.$Yj)("symbol-interface",60257),symbolKeyword:(0,r.$Yj)("symbol-keyword",60258),symbolMisc:(0,r.$Yj)("symbol-misc",60259),symbolOperator:(0,r.$Yj)("symbol-operator",60260),symbolProperty:(0,r.$Yj)("symbol-property",60261),wrench:(0,r.$Yj)("wrench",60261),wrenchSubaction:(0,r.$Yj)("wrench-subaction",60261),symbolSnippet:(0,r.$Yj)("symbol-snippet",60262),tasklist:(0,r.$Yj)("tasklist",60263),telescope:(0,r.$Yj)("telescope",60264),textSize:(0,r.$Yj)("text-size",60265),threeBars:(0,r.$Yj)("three-bars",60266),thumbsdown:(0,r.$Yj)("thumbsdown",60267),thumbsup:(0,r.$Yj)("thumbsup",60268),tools:(0,r.$Yj)("tools",60269),triangleDown:(0,r.$Yj)("triangle-down",60270),triangleLeft:(0,r.$Yj)("triangle-left",60271),triangleRight:(0,r.$Yj)("triangle-right",60272),triangleUp:(0,r.$Yj)("triangle-up",60273),twitter:(0,r.$Yj)("twitter",60274),unfold:(0,r.$Yj)("unfold",60275),unlock:(0,r.$Yj)("unlock",60276),unmute:(0,r.$Yj)("unmute",60277),unverified:(0,r.$Yj)("unverified",60278),verified:(0,r.$Yj)("verified",60279),versions:(0,r.$Yj)("versions",60280),vmActive:(0,r.$Yj)("vm-active",60281),vmOutline:(0,r.$Yj)("vm-outline",60282),vmRunning:(0,r.$Yj)("vm-running",60283),watch:(0,r.$Yj)("watch",60284),whitespace:(0,r.$Yj)("whitespace",60285),wholeWord:(0,r.$Yj)("whole-word",60286),window:(0,r.$Yj)("window",60287),wordWrap:(0,r.$Yj)("word-wrap",60288),zoomIn:(0,r.$Yj)("zoom-in",60289),zoomOut:(0,r.$Yj)("zoom-out",60290),listFilter:(0,r.$Yj)("list-filter",60291),listFlat:(0,r.$Yj)("list-flat",60292),listSelection:(0,r.$Yj)("list-selection",60293),selection:(0,r.$Yj)("selection",60293),listTree:(0,r.$Yj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Yj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Yj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Yj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Yj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Yj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Yj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Yj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Yj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Yj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Yj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Yj)("symbol-string",60301),debugReverseContinue:(0,r.$Yj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Yj)("debug-step-back",60303),debugRestartFrame:(0,r.$Yj)("debug-restart-frame",60304),debugAlt:(0,r.$Yj)("debug-alt",60305),callIncoming:(0,r.$Yj)("call-incoming",60306),callOutgoing:(0,r.$Yj)("call-outgoing",60307),menu:(0,r.$Yj)("menu",60308),expandAll:(0,r.$Yj)("expand-all",60309),feedback:(0,r.$Yj)("feedback",60310),gitPullRequestReviewer:(0,r.$Yj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Yj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Yj)("ungroup-by-ref-type",60312),account:(0,r.$Yj)("account",60313),gitPullRequestAssignee:(0,r.$Yj)("git-pull-request-assignee",60313),bellDot:(0,r.$Yj)("bell-dot",60314),debugConsole:(0,r.$Yj)("debug-console",60315),library:(0,r.$Yj)("library",60316),output:(0,r.$Yj)("output",60317),runAll:(0,r.$Yj)("run-all",60318),syncIgnored:(0,r.$Yj)("sync-ignored",60319),pinned:(0,r.$Yj)("pinned",60320),githubInverted:(0,r.$Yj)("github-inverted",60321),serverProcess:(0,r.$Yj)("server-process",60322),serverEnvironment:(0,r.$Yj)("server-environment",60323),pass:(0,r.$Yj)("pass",60324),issueClosed:(0,r.$Yj)("issue-closed",60324),stopCircle:(0,r.$Yj)("stop-circle",60325),playCircle:(0,r.$Yj)("play-circle",60326),record:(0,r.$Yj)("record",60327),debugAltSmall:(0,r.$Yj)("debug-alt-small",60328),vmConnect:(0,r.$Yj)("vm-connect",60329),cloud:(0,r.$Yj)("cloud",60330),merge:(0,r.$Yj)("merge",60331),export:(0,r.$Yj)("export",60332),graphLeft:(0,r.$Yj)("graph-left",60333),magnet:(0,r.$Yj)("magnet",60334),notebook:(0,r.$Yj)("notebook",60335),redo:(0,r.$Yj)("redo",60336),checkAll:(0,r.$Yj)("check-all",60337),pinnedDirty:(0,r.$Yj)("pinned-dirty",60338),passFilled:(0,r.$Yj)("pass-filled",60339),circleLargeFilled:(0,r.$Yj)("circle-large-filled",60340),circleLarge:(0,r.$Yj)("circle-large",60341),circleLargeOutline:(0,r.$Yj)("circle-large-outline",60341),combine:(0,r.$Yj)("combine",60342),gather:(0,r.$Yj)("gather",60342),table:(0,r.$Yj)("table",60343),variableGroup:(0,r.$Yj)("variable-group",60344),typeHierarchy:(0,r.$Yj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Yj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Yj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Yj)("git-pull-request-create",60348),runAbove:(0,r.$Yj)("run-above",60349),runBelow:(0,r.$Yj)("run-below",60350),notebookTemplate:(0,r.$Yj)("notebook-template",60351),debugRerun:(0,r.$Yj)("debug-rerun",60352),workspaceTrusted:(0,r.$Yj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Yj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Yj)("workspace-unknown",60355),terminalCmd:(0,r.$Yj)("terminal-cmd",60356),terminalDebian:(0,r.$Yj)("terminal-debian",60357),terminalLinux:(0,r.$Yj)("terminal-linux",60358),terminalPowershell:(0,r.$Yj)("terminal-powershell",60359),terminalTmux:(0,r.$Yj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Yj)("terminal-ubuntu",60361),terminalBash:(0,r.$Yj)("terminal-bash",60362),arrowSwap:(0,r.$Yj)("arrow-swap",60363),copy:(0,r.$Yj)("copy",60364),personAdd:(0,r.$Yj)("person-add",60365),filterFilled:(0,r.$Yj)("filter-filled",60366),wand:(0,r.$Yj)("wand",60367),debugLineByLine:(0,r.$Yj)("debug-line-by-line",60368),inspect:(0,r.$Yj)("inspect",60369),layers:(0,r.$Yj)("layers",60370),layersDot:(0,r.$Yj)("layers-dot",60371),layersActive:(0,r.$Yj)("layers-active",60372),compass:(0,r.$Yj)("compass",60373),compassDot:(0,r.$Yj)("compass-dot",60374),compassActive:(0,r.$Yj)("compass-active",60375),azure:(0,r.$Yj)("azure",60376),issueDraft:(0,r.$Yj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Yj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Yj)("git-pull-request-draft",60379),debugAll:(0,r.$Yj)("debug-all",60380),debugCoverage:(0,r.$Yj)("debug-coverage",60381),runErrors:(0,r.$Yj)("run-errors",60382),folderLibrary:(0,r.$Yj)("folder-library",60383),debugContinueSmall:(0,r.$Yj)("debug-continue-small",60384),beakerStop:(0,r.$Yj)("beaker-stop",60385),graphLine:(0,r.$Yj)("graph-line",60386),graphScatter:(0,r.$Yj)("graph-scatter",60387),pieChart:(0,r.$Yj)("pie-chart",60388),bracket:(0,r.$Yj)("bracket",60175),bracketDot:(0,r.$Yj)("bracket-dot",60389),bracketError:(0,r.$Yj)("bracket-error",60390),lockSmall:(0,r.$Yj)("lock-small",60391),azureDevops:(0,r.$Yj)("azure-devops",60392),verifiedFilled:(0,r.$Yj)("verified-filled",60393),newline:(0,r.$Yj)("newline",60394),layout:(0,r.$Yj)("layout",60395),layoutActivitybarLeft:(0,r.$Yj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Yj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Yj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Yj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Yj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Yj)("layout-panel-right",60401),layoutPanel:(0,r.$Yj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Yj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Yj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Yj)("layout-statusbar",60405),layoutMenubar:(0,r.$Yj)("layout-menubar",60406),layoutCentered:(0,r.$Yj)("layout-centered",60407),target:(0,r.$Yj)("target",60408),indent:(0,r.$Yj)("indent",60409),recordSmall:(0,r.$Yj)("record-small",60410),errorSmall:(0,r.$Yj)("error-small",60411),terminalDecorationError:(0,r.$Yj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Yj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Yj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Yj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Yj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Yj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Yj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Yj)("layout-sidebar-left-off",60418),blank:(0,r.$Yj)("blank",60419),heartFilled:(0,r.$Yj)("heart-filled",60420),map:(0,r.$Yj)("map",60421),mapHorizontal:(0,r.$Yj)("map-horizontal",60421),foldHorizontal:(0,r.$Yj)("fold-horizontal",60421),mapFilled:(0,r.$Yj)("map-filled",60422),mapHorizontalFilled:(0,r.$Yj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Yj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Yj)("circle-small",60423),bellSlash:(0,r.$Yj)("bell-slash",60424),bellSlashDot:(0,r.$Yj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Yj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Yj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Yj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Yj)("search-fuzzy",60429),commentDraft:(0,r.$Yj)("comment-draft",60430),send:(0,r.$Yj)("send",60431),sparkle:(0,r.$Yj)("sparkle",60432),insert:(0,r.$Yj)("insert",60433),mic:(0,r.$Yj)("mic",60434),thumbsdownFilled:(0,r.$Yj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Yj)("thumbsup-filled",60436),coffee:(0,r.$Yj)("coffee",60437),snake:(0,r.$Yj)("snake",60438),game:(0,r.$Yj)("game",60439),vr:(0,r.$Yj)("vr",60440),chip:(0,r.$Yj)("chip",60441),piano:(0,r.$Yj)("piano",60442),music:(0,r.$Yj)("music",60443),micFilled:(0,r.$Yj)("mic-filled",60444),repoFetch:(0,r.$Yj)("repo-fetch",60445),copilot:(0,r.$Yj)("copilot",60446),lightbulbSparkle:(0,r.$Yj)("lightbulb-sparkle",60447),robot:(0,r.$Yj)("robot",60448),sparkleFilled:(0,r.$Yj)("sparkle-filled",60449),diffSingle:(0,r.$Yj)("diff-single",60450),diffMultiple:(0,r.$Yj)("diff-multiple",60451),surroundWith:(0,r.$Yj)("surround-with",60452),share:(0,r.$Yj)("share",60453),gitStash:(0,r.$Yj)("git-stash",60454),gitStashApply:(0,r.$Yj)("git-stash-apply",60455),gitStashPop:(0,r.$Yj)("git-stash-pop",60456),vscode:(0,r.$Yj)("vscode",60457),vscodeInsiders:(0,r.$Yj)("vscode-insiders",60458),codeOss:(0,r.$Yj)("code-oss",60459),runCoverage:(0,r.$Yj)("run-coverage",60460),runAllCoverage:(0,r.$Yj)("run-all-coverage",60461),coverage:(0,r.$Yj)("coverage",60462),githubProject:(0,r.$Yj)("github-project",60463),mapVertical:(0,r.$Yj)("map-vertical",60464),foldVertical:(0,r.$Yj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Yj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Yj)("fold-vertical-filled",60465),goToSearch:(0,r.$Yj)("go-to-search",60466),percentage:(0,r.$Yj)("percentage",60467),sortPercentage:(0,r.$Yj)("sort-percentage",60467),attach:(0,r.$Yj)("attach",60468)}}),define(Ee[83],Se([1,0,105,185]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=void 0,e.$2j=A;function A(){return Object.values(e.$4j)}e.$3j={dialogError:(0,r.$Yj)("dialog-error","error"),dialogWarning:(0,r.$Yj)("dialog-warning","warning"),dialogInfo:(0,r.$Yj)("dialog-info","info"),dialogClose:(0,r.$Yj)("dialog-close","close"),treeItemExpanded:(0,r.$Yj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Yj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Yj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Yj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Yj)("tree-item-loading","loading"),menuSelection:(0,r.$Yj)("menu-selection","check"),menuSubmenu:(0,r.$Yj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Yj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Yj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Yj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Yj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Yj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Yj)("toolbar-more","more"),quickInputBack:(0,r.$Yj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Yj)("drop-down-button",60084),symbolCustomColor:(0,r.$Yj)("symbol-customcolor",60252),exportIcon:(0,r.$Yj)("export",60332),workspaceUnspecified:(0,r.$Yj)("workspace-unspecified",60355),newLine:(0,r.$Yj)("newline",60394),thumbsDownFilled:(0,r.$Yj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Yj)("thumbsup-filled",60436),gitFetch:(0,r.$Yj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Yj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Yj)("debug-breakpoint-pending",60377)},e.$4j={...h.$1j,...e.$3j}}),define(Ee[25],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=h,e.$co=A,e.$do=N,e.$eo=$,e.$fo=l,e.$go=I,e.$ho=E,e.$io=u,e.$jo=k,e.$ko=b,e.$lo=c,e.$mo=g,e.$no=f;function h(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([o,i])=>{n[o]=i&&typeof i=="object"?h(i):i}),n}function A(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const i in o)if(R.call(o,i)){const t=o[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.$hg)(t)&&n.push(t)}}return m}const R=Object.prototype.hasOwnProperty;function N(m,n){return T(m,n,new Set)}function T(m,n,o){if((0,r.$ng)(m))return m;const i=n(m);if(typeof i<"u")return i;if(Array.isArray(m)){const t=[];for(const s of m)t.push(T(s,n,o));return t}if((0,r.$gg)(m)){if(o.has(m))throw new Error("Cannot clone recursive data-structure");o.add(m);const t={};for(const s in m)R.call(m,s)&&(t[s]=T(m[s],n,o));return o.delete(m),t}return m}function $(m,n,o=!0){return(0,r.$gg)(m)?((0,r.$gg)(n)&&Object.keys(n).forEach(i=>{i in m?o&&((0,r.$gg)(m[i])&&(0,r.$gg)(n[i])?$(m[i],n[i],o):m[i]=n[i]):m[i]=n[i]}),m):n}function l(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let o,i;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(o=0;o<m.length;o++)if(!l(m[o],n[o]))return!1}else{const t=[];for(i in m)t.push(i);t.sort();const s=[];for(i in n)s.push(i);if(s.sort(),!l(t,s))return!1;for(o=0;o<t.length;o++)if(!l(m[t[o]],n[t[o]]))return!1}return!0}function I(m){const n=new Set;return JSON.stringify(m,(o,i)=>{if((0,r.$gg)(i)||Array.isArray(i)){if(n.has(i))return"[Circular]";n.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function E(m,n){const o=Object.create(null);return!m||!n||Object.keys(n).forEach(t=>{const s=m[t],d=n[t];l(s,d)||(o[t]=d)}),o}function u(m,n){const o=n.toLowerCase(),i=Object.keys(m).find(t=>t.toLowerCase()===o);return i?m[i]:m[n]}function k(m,n){const o=Object.create(null);for(const[i,t]of Object.entries(m))n(i,t)&&(o[i]=t);return o}function b(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}function c(m){const n=[];for(const o of b(m))typeof m[o]=="function"&&n.push(o);return n}function g(m,n){const o=t=>function(){const s=Array.prototype.slice.call(arguments,0);return n(t,s)},i={};for(const t of m)i[t]=o(t);return i}function f(m,n){const o={};for(const[i,t]of Object.entries(m))o[i]=n(t,i);return o}}),define(Ee[50],Se([1,0,83]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=A;var h;(function(N){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}N.isThemeColor=T})(h||(e.ThemeColor=h={}));function A(N){return{id:N}}var R;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function $(m){const n=T.exec(m.id);if(!n)return $(r.$4j.error);const[,o,i]=n,t=["codicon","codicon-"+o];return i&&t.push("codicon-modifier-"+i.substring(1)),t}N.asClassNameArray=$;function l(m){return $(m).join(" ")}N.asClassName=l;function I(m){return"."+$(m).join(".")}N.asCSSSelector=I;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||h.isThemeColor(m.color))}N.isThemeIcon=E;const u=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function k(m){const n=u.exec(m);if(!n)return;const[,o]=n;return{id:o}}N.fromString=k;function b(m){return{id:m}}N.fromId=b;function c(m,n){let o=m.id;const i=o.lastIndexOf("~");return i!==-1&&(o=o.substring(0,i)),n&&(o=`${o}~${n}`),{id:o}}N.modify=c;function g(m){const n=m.id.lastIndexOf("~");if(n!==-1)return m.id.substring(n+1)}N.getModifier=g;function f(m,n){return m.id===n.id&&m.color?.id===n.color?.id}N.isEqual=f})(R||(e.ThemeIcon=R={}))}),define(Ee[84],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=h,e.$bf=A;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function A(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(Ee[13],Se([1,0,182,27,49,84]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=N,e.$df=$,e.$ef=I,e.$ff=E,e.$gf=u,e.$hf=k,e.$if=b,e.$jf=c,e.$kf=g,e.$lf=f,e.$mf=m,e.$nf=n,e.$of=o,e.$pf=i,e.$qf=t,e.$rf=s,e.$sf=d,e.$tf=a,e.$uf=w,e.$vf=y,e.$wf=S,e.$xf=D,e.$yf=P,e.$zf=C,e.$Af=p,e.$Bf=v,e.$Cf=O,e.$Df=L,e.$Ef=F,e.$Ff=j,e.$Gf=B,e.$Hf=M,e.$If=z,e.$Jf=_,e.$Kf=re,e.$Lf=U,e.$Mf=G,e.$Pf=ne,e.$Qf=De,e.$Rf=$e,e.$Sf=J,e.$Tf=oe,e.$Uf=le,e.$Wf=he,e.$Xf=Z,e.$Yf=ae,e.$Zf=pe,e.$1f=Me,e.$2f=ze,e.$3f=Ie,e.$5f=Te,e.$6f=V,e.$7f=q,e.$8f=Q,e.$9f=x,e.$0f=fe,e.$$f=we,e.$_f=Oe,e.$ag=ot;function N(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const T=/{(\d+)}/g;function $(Pe,...Be){return Be.length===0?Pe:Pe.replace(T,function(Ye,Le){const Fe=parseInt(Le,10);return isNaN(Fe)||Fe<0||Fe>=Be.length?Ye:Be[Fe]})}const l=/{([^}]+)}/g;function I(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(l,(Ye,Le)=>Be[Le]??Ye)}function E(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function k(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Pe,Be){let Ye=0,Le=Pe.indexOf(Be);for(;Le!==-1;)Ye++,Le=Pe.indexOf(Be,Le+Be.length);return Ye}function c(Pe,Be,Ye="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${Ye}`}function g(Pe,Be,Ye="\u2026"){if(Pe.length<=Be)return Pe;const Le=Math.ceil(Be/2)-Ye.length/2,Fe=Math.floor(Be/2)-Ye.length/2;return`${Pe.substr(0,Le)}${Ye}${Pe.substr(Pe.length-Fe)}`}function f(Pe,Be=" "){const Ye=m(Pe,Be);return n(Ye,Be)}function m(Pe,Be){if(!Pe||!Be)return Pe;const Ye=Be.length;if(Ye===0||Pe.length===0)return Pe;let Le=0;for(;Pe.indexOf(Be,Le)===Le;)Le=Le+Ye;return Pe.substring(Le)}function n(Pe,Be){if(!Pe||!Be)return Pe;const Ye=Be.length,Le=Pe.length;if(Ye===0||Le===0)return Pe;let Fe=Le,X=-1;for(;X=Pe.lastIndexOf(Be,Fe-1),!(X===-1||X+Ye!==Fe);){if(X===0)return"";Fe=X}return Pe.substring(0,Fe)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function t(Pe,Be,Ye={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=k(Pe)),Ye.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Le="";return Ye.global&&(Le+="g"),Ye.matchCase||(Le+="i"),Ye.multiline&&(Le+="m"),Ye.unicode&&(Le+="u"),new RegExp(Pe,Le)}function s(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function a(Pe){const Be=[],Ye=Pe.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(Ye.length/2);Le++)Be.push(Ye[2*Le]+(Ye[2*Le+1]??""));return Be}function w(Pe){for(let Be=0,Ye=Pe.length;Be<Ye;Be++){const Le=Pe.charCodeAt(Be);if(Le!==h.CharCode.Space&&Le!==h.CharCode.Tab)return Be}return-1}function y(Pe,Be=0,Ye=Pe.length){for(let Le=Be;Le<Ye;Le++){const Fe=Pe.charCodeAt(Le);if(Fe!==h.CharCode.Space&&Fe!==h.CharCode.Tab)return Pe.substring(Be,Le)}return Pe.substring(Be,Ye)}function S(Pe,Be=Pe.length-1){for(let Ye=Be;Ye>=0;Ye--){const Le=Pe.charCodeAt(Ye);if(Le!==h.CharCode.Space&&Le!==h.CharCode.Tab)return Ye}return-1}function D(Pe,Be,Ye){const Le=[];let Fe=0;for(const X of Pe.matchAll(Be)){if(Le.push(Pe.slice(Fe,X.index)),X.index===void 0)throw new Error("match.index should be defined");Fe=X.index+X[0].length,Le.push(Ye(X[0],...X.slice(1),X.index,Pe,X.groups))}return Le.push(Pe.slice(Fe)),Promise.all(Le).then(X=>X.join(""))}function P(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function C(Pe,Be,Ye=0,Le=Pe.length,Fe=0,X=Be.length){for(;Ye<Le&&Fe<X;Ye++,Fe++){const Ze=Pe.charCodeAt(Ye),_e=Be.charCodeAt(Fe);if(Ze<_e)return-1;if(Ze>_e)return 1}const de=Le-Ye,Ce=X-Fe;return de<Ce?-1:de>Ce?1:0}function p(Pe,Be){return v(Pe,Be,0,Pe.length,0,Be.length)}function v(Pe,Be,Ye=0,Le=Pe.length,Fe=0,X=Be.length){for(;Ye<Le&&Fe<X;Ye++,Fe++){let Ze=Pe.charCodeAt(Ye),_e=Be.charCodeAt(Fe);if(Ze===_e)continue;if(Ze>=128||_e>=128)return C(Pe.toLowerCase(),Be.toLowerCase(),Ye,Le,Fe,X);L(Ze)&&(Ze-=32),L(_e)&&(_e-=32);const lt=Ze-_e;if(lt!==0)return lt}const de=Le-Ye,Ce=X-Fe;return de<Ce?-1:de>Ce?1:0}function O(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function L(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function F(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,Be){return Pe.length===Be.length&&v(Pe,Be)===0}function B(Pe,Be){const Ye=Be.length;return Be.length>Pe.length?!1:v(Pe,Be,0,Ye)===0}function M(Pe,Be){const Ye=Math.min(Pe.length,Be.length);let Le;for(Le=0;Le<Ye;Le++)if(Pe.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return Ye}function z(Pe,Be){const Ye=Math.min(Pe.length,Be.length);let Le;const Fe=Pe.length-1,X=Be.length-1;for(Le=0;Le<Ye;Le++)if(Pe.charCodeAt(Fe-Le)!==Be.charCodeAt(X-Le))return Le;return Ye}function _(Pe){return 55296<=Pe&&Pe<=56319}function re(Pe){return 56320<=Pe&&Pe<=57343}function U(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function G(Pe,Be,Ye){const Le=Pe.charCodeAt(Ye);if(_(Le)&&Ye+1<Be){const Fe=Pe.charCodeAt(Ye+1);if(re(Fe))return U(Le,Fe)}return Le}function K(Pe,Be){const Ye=Pe.charCodeAt(Be-1);if(re(Ye)&&Be>1){const Le=Pe.charCodeAt(Be-2);if(_(Le))return U(Le,Ye)}return Ye}class ee{get offset(){return this.e}constructor(Be,Ye=0){this.c=Be,this.d=Be.length,this.e=Ye}setOffset(Be){this.e=Be}prevCodePoint(){const Be=K(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=G(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Nf=ee;class ue{get offset(){return this.c.offset}constructor(Be,Ye=0){this.c=new ee(Be,Ye)}nextGraphemeLength(){const Be=tt.getInstance(),Ye=this.c,Le=Ye.offset;let Fe=Be.getGraphemeBreakType(Ye.nextCodePoint());for(;!Ye.eol();){const X=Ye.offset,de=Be.getGraphemeBreakType(Ye.nextCodePoint());if(Ge(Fe,de)){Ye.setOffset(X);break}Fe=de}return Ye.offset-Le}prevGraphemeLength(){const Be=tt.getInstance(),Ye=this.c,Le=Ye.offset;let Fe=Be.getGraphemeBreakType(Ye.prevCodePoint());for(;Ye.offset>0;){const X=Ye.offset,de=Be.getGraphemeBreakType(Ye.prevCodePoint());if(Ge(de,Fe)){Ye.setOffset(X);break}Fe=de}return Le-Ye.offset}eol(){return this.c.eol()}}e.$Of=ue;function ne(Pe,Be){return new ue(Pe,Be).nextGraphemeLength()}function De(Pe,Be){return new ue(Pe,Be).prevGraphemeLength()}function $e(Pe,Be){Be>0&&re(Pe.charCodeAt(Be))&&Be--;const Ye=Be+ne(Pe,Be);return[Ye-De(Pe,Ye),Ye]}function J(Pe){const Be=new ue(Pe);let Ye=0;for(;!Be.eol();)Ye++,Be.nextGraphemeLength();return Ye}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Pe){return W||(W=se()),W.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return te.test(Pe)}e.$Vf=/[\u2028\u2029]/;function he(Pe){return e.$Vf.test(Pe)}function Z(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function ae(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,Be,Ye=""){const Le=Pe.trimStart();if(Le.length<Be)return Le;const Fe=/\b/g;let X=0;for(;Fe.test(Le)&&!(Le.length-Fe.lastIndex<Be);)X=Fe.lastIndex,Fe.lastIndex+=1;return X===0?Le:Ye+Le.substring(X).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Me(Pe){let Be=0;for(const Ye of Pe.matchAll(be))Be!==Ye.index&&(yield{isCode:!1,str:Pe.substring(Be,Ye.index)}),yield{isCode:!0,str:Ye[0]},Be=Ye.index+Ye[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function ze(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const ke=/\\\[.*?\\\]/g;function Ie(Pe){return ze(Pe).replace(ke,"")}e.$4f=String.fromCharCode(h.CharCode.UTF8_BOM);function Te(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function V(Pe){return Te(Pe)?Pe.substr(1):Pe}function q(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const Ye=Be.length,Le=Pe.toLowerCase();let Fe=0,X=-1;for(;Fe<Ye;){const de=Le.indexOf(Be[Fe],X+1);if(de<0)return!1;X=de,Fe++}return!0}function Q(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,Be=1){if(Be===0)return"";let Ye=-1;do Ye=Pe.indexOf(`
`,Ye+1),Be--;while(Be>0&&Ye>=0);return Ye===-1?Pe:(Pe[Ye-1]==="\r"&&Ye--,Pe.substr(0,Ye))}function we(Pe){const Be=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*Be),Pe<Be?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-Be)}function Oe(Pe){return tt.getInstance().getGraphemeBreakType(Pe)}function Ge(Pe,Be){return Pe===Ke.Other?Be!==Ke.Extend&&Be!==Ke.SpacingMark:Pe===Ke.CR&&Be===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||Be===Ke.Control||Be===Ke.CR||Be===Ke.LF?!0:!(Pe===Ke.L&&(Be===Ke.L||Be===Ke.V||Be===Ke.LV||Be===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(Be===Ke.V||Be===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&Be===Ke.T||Be===Ke.Extend||Be===Ke.ZWJ||Be===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&Be===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&Be===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=rt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Ke.LF:Be===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(Be<127)return Ke.Other;const Ye=this.d,Le=Ye.length/3;let Fe=1;for(;Fe<=Le;)if(Be<Ye[3*Fe])Fe=2*Fe;else if(Be>Ye[3*Fe+1])Fe=2*Fe+1;else return Ye[3*Fe+2];return Ke.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Pe,Be){if(Pe===0)return 0;const Ye=nt(Pe,Be);if(Ye!==void 0)return Ye;const Le=new ee(Be,Pe);return Le.prevCodePoint(),Le.offset}function nt(Pe,Be){const Ye=new ee(Be,Pe);let Le=Ye.prevCodePoint();for(;ct(Le)||Le===$t.emojiVariantSelector||Le===$t.enclosingKeyCap;){if(Ye.offset===0)return;Le=Ye.prevCodePoint()}if(!ae(Le))return;let Fe=Ye.offset;return Fe>0&&Ye.prevCodePoint()===$t.zwj&&(Fe=Ye.offset),Fe}function ct(Pe){return 127995<=Pe&&Pe<=127999}var $t;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})($t||($t={})),e.$bg="\xA0";class ht{static{this.c=new A.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$$e({getCacheKey:JSON.stringify},Be=>{function Ye(lt){const ft=new Map;for(let kt=0;kt<lt.length;kt+=2)ft.set(lt[kt],lt[kt+1]);return ft}function Le(lt,ft){const kt=new Map(lt);for(const[Tt,Ut]of ft)kt.set(Tt,Ut);return kt}function Fe(lt,ft){if(!lt)return ft;const kt=new Map;for(const[Tt,Ut]of lt)ft.has(Tt)&&kt.set(Tt,Ut);return kt}const X=this.c.value;let de=Be.filter(lt=>!lt.startsWith("_")&&lt in X);de.length===0&&(de=["_default"]);let Ce;for(const lt of de){const ft=Ye(X[lt]);Ce=Fe(Ce,ft)}const Ze=Ye(X._common),_e=Le(Ze,Ce);return new ht(_e)})}static getInstance(Be){return ht.d.get(Array.from(Be))}static{this.e=new A.$W(()=>Object.keys(ht.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ht.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Ye=0;Ye<Be.length;Ye++){const Le=Be.codePointAt(Ye);if(typeof Le=="number"&&this.isAmbiguous(Le))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=ht;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(Be){return at.e().has(Be)}static containsInvisibleCharacter(Be){for(let Ye=0;Ye<Be.length;Ye++){const Le=Be.codePointAt(Ye);if(typeof Le=="number"&&at.isInvisibleCharacter(Le))return!0}return!1}static get codePoints(){return at.e()}}e.$dg=at}),define(Ee[135],Se([1,0,27,29,177,13]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.FuzzyScore=e.$Gk=e.$Fk=void 0,e.or=N,e.$Hk=$,e.$Ik=l,e.$Jk=u,e.$Kk=S,e.$Lk=D,e.$Mk=L,e.$Nk=F,e.$Ok=j,e.$Pk=B,e.$Qk=se,e.$Sk=he,e.$Tk=pe,e.$Uk=be,R=We(R);function N(...ke){return function(Ie,Te){for(let V=0,q=ke.length;V<q;V++){const Q=ke[V](Ie,Te);if(Q)return Q}return null}}e.$Fk=T.bind(void 0,!1),e.$Gk=T.bind(void 0,!0);function T(ke,Ie,Te){if(!Te||Te.length<Ie.length)return null;let V;return ke?V=R.$Gf(Te,Ie):V=Te.indexOf(Ie)===0,V?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function $(ke,Ie){const Te=Ie.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function l(ke,Ie){return I(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function I(ke,Ie,Te,V){if(Te===ke.length)return[];if(V===Ie.length)return null;if(ke[Te]===Ie[V]){let q=null;return(q=I(ke,Ie,Te+1,V+1))?i({start:V,end:V+1},q):null}return I(ke,Ie,Te,V+1)}function E(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function u(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function k(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function b(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>c.add(ke.charCodeAt(0)));function g(ke){return b(ke)||c.has(ke)}function f(ke,Ie){return ke===Ie||g(ke)&&g(Ie)}const m=new Map;function n(ke){if(m.has(ke))return m.get(ke);let Ie;const Te=(0,A.$Dk)(ke);return Te&&(Ie=Te),m.set(ke,Ie),Ie}function o(ke){return E(ke)||u(ke)||k(ke)}function i(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function t(ke,Ie){for(let Te=Ie;Te<ke.length;Te++){const V=ke.charCodeAt(Te);if(u(V)||k(V)||Te>0&&!o(ke.charCodeAt(Te-1)))return Te}return ke.length}function s(ke,Ie,Te,V){if(Te===ke.length)return[];if(V===Ie.length)return null;if(ke[Te]!==Ie[V].toLowerCase())return null;{let q=null,Q=V+1;for(q=s(ke,Ie,Te+1,V+1);!q&&(Q=t(Ie,Q))<Ie.length;)q=s(ke,Ie,Te+1,Q),Q++;return q===null?null:i({start:V,end:V+1},q)}}function d(ke){let Ie=0,Te=0,V=0,q=0,Q=0;for(let Ge=0;Ge<ke.length;Ge++)Q=ke.charCodeAt(Ge),u(Q)&&Ie++,E(Q)&&Te++,o(Q)&&V++,k(Q)&&q++;const x=Ie/ke.length,fe=Te/ke.length,we=V/ke.length,Oe=q/ke.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:we,numericPercent:Oe}}function a(ke){const{upperPercent:Ie,lowerPercent:Te}=ke;return Te===0&&Ie>.6}function w(ke){const{upperPercent:Ie,lowerPercent:Te,alphaPercent:V,numericPercent:q}=ke;return Te>.2&&Ie<.8&&V>.6&&q<.2}function y(ke){let Ie=0,Te=0,V=0,q=0;for(let Q=0;Q<ke.length;Q++)V=ke.charCodeAt(Q),u(V)&&Ie++,E(V)&&Te++,b(V)&&q++;return(Ie===0||Te===0)&&q===0?ke.length<=30:Ie<=5}function S(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!y(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Te=d(Ie);if(!w(Te)){if(!a(Te))return null;Ie=Ie.toLowerCase()}let V=null,q=0;for(ke=ke.toLowerCase();q<Ie.length&&(V=s(ke,Ie,0,q))===null;)q=t(Ie,q+1);return V}function D(ke,Ie,Te=!1){if(!Ie||Ie.length===0)return null;let V=null,q=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(V=P(ke,Ie,0,q,Te),V===null);)q=C(Ie,q+1);return V}function P(ke,Ie,Te,V,q){let Q=0;if(Te===ke.length)return[];if(V===Ie.length)return null;if(!f(ke.charCodeAt(Te),Ie.charCodeAt(V))){const we=n(ke.charCodeAt(Te));if(!we)return null;for(let Oe=0;Oe<we.length;Oe++)if(!f(we[Oe],Ie.charCodeAt(V+Oe)))return null;Q+=we.length-1}let x=null,fe=V+Q+1;if(x=P(ke,Ie,Te+1,fe,q),!q)for(;!x&&(fe=C(Ie,fe))<Ie.length;)x=P(ke,Ie,Te+1,fe,q),fe++;if(!x)return null;if(ke.charCodeAt(Te)!==Ie.charCodeAt(V)){const we=n(ke.charCodeAt(Te));if(!we)return x;for(let Oe=0;Oe<we.length;Oe++)if(we[Oe]!==Ie.charCodeAt(V+Oe))return x}return i({start:V,end:V+Q+1},x)}function C(ke,Ie){for(let Te=Ie;Te<ke.length;Te++)if(g(ke.charCodeAt(Te))||Te>0&&g(ke.charCodeAt(Te-1)))return Te;return ke.length}const p=N(e.$Gk,S,$),v=N(e.$Gk,S,l),O=new h.$Ec(1e4);function L(ke,Ie,Te=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let V=O.get(ke);V||(V=new RegExp(R.$of(ke),"i"),O.set(ke,V));const q=V.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Te?v(ke,Ie):p(ke,Ie)}function F(ke,Ie){const Te=he(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?B(Te):null}function j(ke,Ie,Te,V,q,Q){const x=Math.min(13,ke.length);for(;Te<x;Te++){const fe=he(ke,Ie,Te,V,q,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,Q]}function B(ke){if(typeof ke>"u")return[];const Ie=[],Te=ke[1];for(let V=ke.length-1;V>1;V--){const q=ke[V]+Te,Q=Ie[Ie.length-1];Q&&Q.end===q?Q.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const M=128;function z(){const ke=[],Ie=[];for(let Te=0;Te<=M;Te++)Ie[Te]=0;for(let Te=0;Te<=M;Te++)ke.push(Ie.slice(0));return ke}function _(ke){const Ie=[];for(let Te=0;Te<=ke;Te++)Ie[Te]=0;return Ie}const re=_(2*M),U=_(2*M),G=z(),K=z(),ee=z(),ue=!1;function ne(ke,Ie,Te,V,q){function Q(fe,we,Oe=" "){for(;fe.length<we;)fe=Oe+fe;return fe}let x=` |   |${V.split("").map(fe=>Q(fe,3)).join("|")}
`;for(let fe=0;fe<=Te;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=ke[fe].slice(0,q+1).map(we=>Q(we.toString(),3)).join("|")+`
`;return x}function De(ke,Ie,Te,V){ke=ke.substr(Ie),Te=Te.substr(V),console.log(ne(K,ke,ke.length,Te,Te.length)),console.log(ne(ee,ke,ke.length,Te,Te.length)),console.log(ne(G,ke,ke.length,Te,Te.length))}function $e(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Te=ke.codePointAt(Ie);switch(Te){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Yf(Te)}}function J(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(ke,Ie,Te){return Ie[ke]!==Te[ke]}function se(ke,Ie,Te,V,q,Q,x=!1){for(;Ie<Te&&q<Q;)ke[Ie]===V[q]&&(x&&(re[Ie]=q),Ie+=1),q+=1;return Ie===Te}var oe;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var te;(function(ke){ke.Default=[-100,0];function Ie(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Ie})(te||(e.FuzzyScore=te={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Te){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Te}}e.$Rk=le;function he(ke,Ie,Te,V,q,Q,x=le.default){const fe=ke.length>M?M:ke.length,we=V.length>M?M:V.length;if(Te>=fe||Q>=we||fe-Te>we-Q||!se(Ie,Te,fe,q,Q,we,!0))return;Z(fe,we,Te,Q,Ie,q);let Oe=1,Ge=1,Ke=Te,tt=Q;const rt=[!1];for(Oe=1,Ke=Te;Ke<fe;Oe++,Ke++){const ht=re[Ke],at=U[Ke],Pe=Ke+1<fe?U[Ke+1]:we;for(Ge=ht-Q+1,tt=ht;tt<Pe;Ge++,tt++){let Be=Number.MIN_SAFE_INTEGER,Ye=!1;tt<=at&&(Be=ae(ke,Ie,Ke,Te,V,q,tt,we,Q,G[Oe-1][Ge-1]===0,rt));let Le=0;Be!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Le=Be+K[Oe-1][Ge-1]);const Fe=tt>ht,X=Fe?K[Oe][Ge-1]+(G[Oe][Ge-1]>0?-5:0):0,de=tt>ht+1&&G[Oe][Ge-1]>0,Ce=de?K[Oe][Ge-2]+(G[Oe][Ge-2]>0?-5:0):0;if(de&&(!Fe||Ce>=X)&&(!Ye||Ce>=Le))K[Oe][Ge]=Ce,ee[Oe][Ge]=oe.LeftLeft,G[Oe][Ge]=0;else if(Fe&&(!Ye||X>=Le))K[Oe][Ge]=X,ee[Oe][Ge]=oe.Left,G[Oe][Ge]=0;else if(Ye)K[Oe][Ge]=Le,ee[Oe][Ge]=oe.Diag,G[Oe][Ge]=G[Oe-1][Ge-1]+1;else throw new Error("not possible")}}if(ue&&De(ke,Te,V,Q),!rt[0]&&!x.firstMatchCanBeWeak)return;Oe--,Ge--;const ot=[K[Oe][Ge],Q];let nt=0,ct=0;for(;Oe>=1;){let ht=Ge;do{const at=ee[Oe][ht];if(at===oe.LeftLeft)ht=ht-2;else if(at===oe.Left)ht=ht-1;else break}while(ht>=1);nt>1&&Ie[Te+Oe-1]===q[Q+Ge-1]&&!W(ht+Q-1,V,q)&&nt+1>G[Oe][ht]&&(ht=Ge),ht===Ge?nt++:nt=1,ct||(ct=ht),Oe--,Ge=ht-1,ot.push(Ge)}we-Q===fe&&x.boostFullMatch&&(ot[0]+=2);const $t=ct-fe;return ot[0]-=$t,ot}function Z(ke,Ie,Te,V,q,Q){let x=ke-1,fe=Ie-1;for(;x>=Te&&fe>=V;)q[x]===Q[fe]&&(U[x]=fe,x--),fe--}function ae(ke,Ie,Te,V,q,Q,x,fe,we,Oe,Ge){if(Ie[Te]!==Q[x])return Number.MIN_SAFE_INTEGER;let Ke=1,tt=!1;return x===Te-V?Ke=ke[Te]===q[x]?7:5:W(x,q,Q)&&(x===0||!W(x-1,q,Q))?(Ke=ke[Te]===q[x]?7:5,tt=!0):$e(Q,x)&&(x===0||!$e(Q,x-1))?Ke=5:($e(Q,x-1)||J(Q,x-1))&&(Ke=5,tt=!0),Ke>1&&Te===V&&(Ge[0]=!0),tt||(tt=W(x,q,Q)||$e(Q,x-1)||J(Q,x-1)),Te===V?x>we&&(Ke-=tt?3:5):Oe?Ke+=tt?2:0:Ke+=tt?0:1,x+1===fe&&(Ke-=tt?3:5),Ke}function pe(ke,Ie,Te,V,q,Q,x){return Me(ke,Ie,Te,V,q,Q,!0,x)}function be(ke,Ie,Te,V,q,Q,x){return Me(ke,Ie,Te,V,q,Q,!1,x)}function Me(ke,Ie,Te,V,q,Q,x,fe){let we=he(ke,Ie,Te,V,q,Q,fe);if(we&&!x)return we;if(ke.length>=3){const Oe=Math.min(7,ke.length-1);for(let Ge=Te+1;Ge<Oe;Ge++){const Ke=ze(ke,Ge);if(Ke){const tt=he(Ke,Ke.toLowerCase(),Te,V,q,Q,fe);tt&&(tt[0]-=3,(!we||tt[0]>we[0])&&(we=tt))}}}return we}function ze(ke,Ie){if(Ie+1>=ke.length)return;const Te=ke[Ie],V=ke[Ie+1];if(Te!==V)return ke.slice(0,Ie)+V+Te+ke.slice(Ie+2)}}),define(Ee[60],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=h,e.$tj=A,e.$uj=R,e.$vj=T,e.$xj=c,r=We(r);function h(f){return A(f,0)}function A(f,m){switch(typeof f){case"object":return f===null?R(349,m):Array.isArray(f)?$(f,m):l(f,m);case"string":return T(f,m);case"boolean":return N(f,m);case"number":return R(f,m);case"undefined":return R(937,m);default:return R(617,m)}}function R(f,m){return(m<<5)-m+f|0}function N(f,m){return R(f?433:863,m)}function T(f,m){m=R(149417,m);for(let n=0,o=f.length;n<o;n++)m=R(f.charCodeAt(n),m);return m}function $(f,m){return m=R(104579,m),f.reduce((n,o)=>A(o,n),m)}function l(f,m){return m=R(181387,m),Object.keys(f).sort().reduce((n,o)=>(n=T(o,n),A(f[o],n)),m)}class I{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=A(m,this.g),this.g}}e.$wj=I;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function u(f,m,n=32){const o=n-m,i=~((1<<o)-1);return(f<<m|(i&f)>>>o)>>>0}function k(f,m=0,n=f.byteLength,o=0){for(let i=0;i<n;i++)f[m+i]=o}function b(f,m,n="0"){for(;f.length<m;)f=n+f;return f}function c(f,m=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(n=>n.toString(16).padStart(2,"0")).join(""):b((f>>>0).toString(16),m/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const n=m.length;if(n===0)return;const o=this.p;let i=this.r,t=this.u,s,d;for(t!==0?(s=t,d=-1,t=0):(s=m.charCodeAt(0),d=0);;){let a=s;if(r.$Jf(s))if(d+1<n){const w=m.charCodeAt(d+1);r.$Kf(w)?(d++,a=r.$Lf(s,w)):a=E.UNICODE_REPLACEMENT}else{t=s;break}else r.$Kf(s)&&(a=E.UNICODE_REPLACEMENT);if(i=this.w(o,i,a),d++,d<n)s=m.charCodeAt(d);else break}this.r=i,this.u=t}w(m,n,o){return o<128?m[n++]=o:o<2048?(m[n++]=192|(o&1984)>>>6,m[n++]=128|(o&63)>>>0):o<65536?(m[n++]=224|(o&61440)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0):(m[n++]=240|(o&1835008)>>>18,m[n++]=128|(o&258048)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0),n>=E.BLOCK_SIZE&&(this.y(),n-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,m[0]=m[E.BLOCK_SIZE+0],m[1]=m[E.BLOCK_SIZE+1],m[2]=m[E.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=g.g,n=this.q;for(let S=0;S<64;S+=4)m.setUint32(S,n.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)m.setUint32(S,u(m.getUint32(S-12,!1)^m.getUint32(S-32,!1)^m.getUint32(S-56,!1)^m.getUint32(S-64,!1),1),!1);let o=this.h,i=this.l,t=this.m,s=this.n,d=this.o,a,w,y;for(let S=0;S<80;S++)S<20?(a=i&t|~i&s,w=1518500249):S<40?(a=i^t^s,w=1859775393):S<60?(a=i&t|i&s|t&s,w=2400959708):(a=i^t^s,w=3395469782),y=u(o,5)+a+d+w+m.getUint32(S*4,!1)&4294967295,d=s,s=t,t=u(i,30),i=o,o=y;this.h=this.h+o&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$yj=g}),define(Ee[136],Se([1,0,135,13,50]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=$,e.$Wk=I,e.$Xk=u,e.$Yk=k,e.$Zk=c,e.$1k=g;const R="$(",N=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${N.source}`,"g");function $(f){return f.replace(T,(m,n)=>n?m:`\\${m}`)}const l=new RegExp(`\\\\${N.source}`,"g");function I(f){return f.replace(l,m=>`\\${m}`)}const E=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function u(f){return f.indexOf(R)===-1?f:f.replace(E,(m,n,o,i)=>o?m:n||i||"")}function k(f){return f?f.replace(/\$\((.*?)\)/g,(m,n)=>` ${n} `).trim():""}const b=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(f){b.lastIndex=0;let m="";const n=[];let o=0;for(;;){const i=b.lastIndex,t=b.exec(f),s=f.substring(i,t?.index);if(s.length>0){m+=s;for(let d=0;d<s.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:m,iconOffsets:n}}function g(f,m,n=!1){const{text:o,iconOffsets:i}=m;if(!i||i.length===0)return(0,r.$Mk)(f,o,n);const t=(0,h.$mf)(o," "),s=o.length-t.length,d=(0,r.$Mk)(f,t,n);if(d)for(const a of d){const w=i[a.start+s]+s;a.start+=w,a.end+=w}return d}}),define(Ee[44],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=We(r);var h;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(h||(h={})),function(A){const R="error",N="warning",T="warn",$="info",l="ignore";function I(u){return u?r.$Ff(R,u)?A.Error:r.$Ff(N,u)||r.$Ff(T,u)?A.Warning:r.$Ff($,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=I;function E(u){switch(u){case A.Error:return R;case A.Warning:return N;case A.Info:return $;default:return l}}A.toString=E}(h||(h={})),e.default=h}),define(Ee[85],Se([1,0,19,27,13]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class R{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const c=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return c-g}value(){return this.b[this.c]}}e.$Gi=R;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,A.$zf)(b,this.b,0,b.length,this.c,this.d):(0,A.$Bf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=N;class T{constructor(b=!0,c=!0){this.f=b,this.g=c}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let c=b.length-1;c>=0;c--,this.c--){const g=this.b.charCodeAt(c);if(!(g===h.CharCode.Slash||this.f&&g===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===h.CharCode.Slash||this.f&&c===h.CharCode.Backslash)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,A.$zf)(b,this.b,0,b.length,this.d,this.e):(0,A.$Bf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=T;var $;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})($||($={}));class l{constructor(b,c){this.f=b,this.g=c,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push($.Path)),this.g(b)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===$.Scheme)return(0,A.$Af)(b,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,A.$Af)(b,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(b);if(this.d[this.e]===$.Query)return(0,A.$yf)(b,this.c.query);if(this.d[this.e]===$.Fragment)return(0,A.$yf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ji=l;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(E||(E={}));class u{static forUris(b=()=>!1,c=()=>!1){return new u(new l(b,c))}static forPaths(b=!1){return new u(new T(void 0,!b))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,c){if(c){const g=c.slice(0);(0,r.$Xb)(g);for(const f of g)this.set(f,b)}else{const g=b.slice(0);(0,r.$Xb)(g);for(const f of g)this.set(f[0],f[1])}}set(b,c){const g=this.b.reset(b);let f;this.c||(this.c=new I,this.c.segment=g.value());const m=[];for(f=this.c;;){const o=g.cmp(f.segment);if(o>0)f.left||(f.left=new I,f.left.segment=g.value()),m.push([E.Left,f]),f=f.left;else if(o<0)f.right||(f.right=new I,f.right.segment=g.value()),m.push([E.Right,f]),f=f.right;else if(g.hasNext())g.next(),f.mid||(f.mid=new I,f.mid.segment=g.value()),m.push([E.Mid,f]),f=f.mid;else break}const n=f.value;f.value=c,f.key=b;for(let o=m.length-1;o>=0;o--){const i=m[o][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const s=m[o][0],d=m[o+1][0];if(s===E.Right&&d===E.Right)m[o][1]=i.rotateLeft();else if(s===E.Left&&d===E.Left)m[o][1]=i.rotateRight();else if(s===E.Right&&d===E.Left)i.right=m[o+1][1]=m[o+1][1].rotateRight(),m[o][1]=i.rotateLeft();else if(s===E.Left&&d===E.Right)i.left=m[o+1][1]=m[o+1][1].rotateLeft(),m[o][1]=i.rotateRight();else throw new Error;if(o>0)switch(m[o-1][0]){case E.Left:m[o-1][1].left=m[o][1];break;case E.Right:m[o-1][1].right=m[o][1];break;case E.Mid:m[o-1][1].mid=m[o][1];break}else this.c=m[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const c=this.b.reset(b);let g=this.c;for(;g;){const f=c.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else break}return g}has(b){const c=this.d(b);return!(c?.value===void 0&&c?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,c){const g=this.b.reset(b),f=[];let m=this.c;for(;m;){const n=g.cmp(m.segment);if(n>0)f.push([E.Left,m]),m=m.left;else if(n<0)f.push([E.Right,m]),m=m.right;else if(g.hasNext())g.next(),f.push([E.Mid,m]),m=m.mid;else break}if(m){if(c?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:o,value:i,segment:t}=n;this.e(n.key,!1),m.key=o,m.value=i,m.segment=t}}else{const n=m.left??m.right;if(f.length>0){const[o,i]=f[f.length-1];switch(o){case E.Left:i.left=n;break;case E.Mid:i.mid=n;break;case E.Right:i.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const o=f[n][1];o.updateHeight();const i=o.balanceFactor();if(i>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),f[n][1]=o.rotateLeft()):i<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),f[n][1]=o.rotateRight()),n>0)switch(f[n-1][0]){case E.Left:f[n-1][1].left=f[n][1];break;case E.Right:f[n-1][1].right=f[n][1];break;case E.Mid:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const c=this.b.reset(b);let g=this.c,f;for(;g;){const m=c.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(c.hasNext())c.next(),f=g.value||f,g=g.mid;else break}return g&&g.value||f}findSuperstr(b){return this.g(b,!1)}g(b,c){const g=this.b.reset(b);let f=this.c;for(;f;){const m=g.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else return f.mid?this.h(f.mid):c?f.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[c,g]of this)b(g,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const c=[];return this.j(b,c),c[Symbol.iterator]()}j(b,c){b&&(b.left&&this.j(b.left,c),b.value&&c.push([b.key,b.value]),b.mid&&this.j(b.mid,c),b.right&&this.j(b.right,c))}_isBalanced(){const b=c=>{if(!c)return!0;const g=c.balanceFactor();return g<-1||g>1?!1:b(c.left)&&b(c.right)};return b(this.c)}}e.$Ki=u}),define(Ee[32],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(A){return r.test(A)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),N=[];for(let T=0;T<256;T++)N.push(T.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,l="";return l+=N[R[$++]],l+=N[R[$++]],l+=N[R[$++]],l+=N[R[$++]],l+="-",l+=N[R[$++]],l+=N[R[$++]],l+="-",l+=N[R[$++]],l+=N[R[$++]],l+="-",l+=N[R[$++]],l+=N[R[$++]],l+="-",l+=N[R[$++]],l+=N[R[$++]],l+=N[R[$++]],l+=N[R[$++]],l+=N[R[$++]],l+=N[R[$++]],l}}()}),define(Ee[186],Se([1,0,19,40,32]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ju=void 0,e.$hu=R,e.$iu=N,e.$ku=l;function R(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function N(E,u,k){const b={id:(0,A.$1g)(),name:E,uri:u,data:k};return{asString:async()=>"",asFile:()=>b,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const k of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const k=[...this.a.keys()];return h.Iterable.some(this,([b,c])=>c.asFile())&&k.push("files"),I($(u),k)}get(u){return this.a.get(this.b(u))?.[0]}append(u,k){const b=this.a.get(u);b?b.push(k):this.a.set(this.b(u),[k])}replace(u,k){this.a.set(this.b(u),[k])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,k]of this.a)for(const b of k)yield[u,b]}b(u){return $(u)}}e.$ju=T;function $(E){return E.toLowerCase()}function l(E,u){return I($(E),u.map($))}function I(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const k=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[b,c,g]=k;return g==="*"?u.some(f=>f.startsWith(c+"/")):!1}e.$lu=Object.freeze({create:E=>(0,r.$Nb)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$lu.split(E).filter(u=>!u.startsWith("#"))})}),define(Ee[187],Se([1,0,67]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=void 0,e.$3g=h,e.$5g=R,r=We(r);function h(T,$,l,I=1){let E=!1;return new Promise(u=>{const k=setTimeout(()=>{if(!E)return E=!0,u(0)},l);A(T,$,I,b=>{if(!E)return E=!0,clearTimeout(k),u(b)})})}function A(T,$,l,I){if($===0)return I(0);const E=new r.Socket;E.once("connect",()=>(N(E),A(T+l,$-1,l,I))),E.once("data",()=>{}),E.once("error",u=>(N(E),u.code!=="ECONNREFUSED"?A(T+l,$-1,l,I):I(T))),E.connect(T,"127.0.0.1")}e.$4g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(T,$,l,I="127.0.0.1"){let E=!1,u,k=1;const b=r.createServer({pauseOnConnect:!0});function c(g,f){E||(E=!0,b.removeAllListeners(),b.close(),u&&clearTimeout(u),f(g))}return new Promise(g=>{u=setTimeout(()=>{c(0,g)},l),b.on("listening",()=>{c(T,g)}),b.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&k<$?(T++,k++,b.listen(T,I)):c(0,g)}),b.on("close",()=>{c(0,g)}),b.listen(T,I)})}function N(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch($){console.error($)}}}),define(Ee[137],Se([1,0,84]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=e.$_t=void 0;class h{constructor(T){const $=(0,r.$af)(T);this.c=$,this.a=h.d($),this.b=new Map}static d(T){const $=new Uint8Array(256);return $.fill(T),$}set(T,$){const l=(0,r.$af)($);T>=0&&T<256?this.a[T]=l:this.b.set(T,l)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$_t=h;var A;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new h(A.False)}add(T){this.a.set(T,A.True)}has(T){return this.a.get(T)===A.True}clear(){return this.a.clear()}}e.$au=R}),define(Ee[188],Se([1,0,27]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ru=A;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function A(R){let N=0,T=0,$=0,l=h.Unknown;for(let I=0,E=R.length;I<E;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(N===0&&(T=I),N++,I+1<E&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(l|=h.CRLF,I++):l|=h.Invalid,$=I+1):u===r.CharCode.LineFeed&&(l|=h.LF,N===0&&(T=I),N++,$=I+1)}return N===0&&(T=R.length),[N,T,R.length-$,l]}}),define(Ee[53],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0;class r{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new r(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return r.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const N=A.lineNumber|0,T=R.lineNumber|0;if(N===T){const $=A.column|0,l=R.column|0;return $-l}return N-T}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Gt=r}),define(Ee[31],Se([1,0,53]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0;class h{constructor(R,N,T,$){R>T||R===T&&N>$?(this.startLineNumber=T,this.startColumn=$,this.endLineNumber=R,this.endColumn=N):(this.startLineNumber=R,this.startColumn=N,this.endLineNumber=T,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<R.startColumn||N.lineNumber===R.endLineNumber&&N.column>R.endColumn)}static strictContainsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<=R.startColumn||N.lineNumber===R.endLineNumber&&N.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<=R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,N){let T,$,l,I;return N.startLineNumber<R.startLineNumber?(T=N.startLineNumber,$=N.startColumn):N.startLineNumber===R.startLineNumber?(T=N.startLineNumber,$=Math.min(N.startColumn,R.startColumn)):(T=R.startLineNumber,$=R.startColumn),N.endLineNumber>R.endLineNumber?(l=N.endLineNumber,I=N.endColumn):N.endLineNumber===R.endLineNumber?(l=N.endLineNumber,I=Math.max(N.endColumn,R.endColumn)):(l=R.endLineNumber,I=R.endColumn),new h(T,$,l,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,N){let T=R.startLineNumber,$=R.startColumn,l=R.endLineNumber,I=R.endColumn;const E=N.startLineNumber,u=N.startColumn,k=N.endLineNumber,b=N.endColumn;return T<E?(T=E,$=u):T===E&&($=Math.max($,u)),l>k?(l=k,I=b):l===k&&(I=Math.min(I,b)),T>l||T===l&&$>I?null:new h(T,$,l,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,N){return!R&&!N?!0:!!R&&!!N&&R.startLineNumber===N.startLineNumber&&R.startColumn===N.startColumn&&R.endLineNumber===N.endLineNumber&&R.endColumn===N.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Gt(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Gt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,N){return new h(this.startLineNumber,this.startColumn,R,N)}setStartPosition(R,N){return new h(R,N,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,N=R){return new h(R.lineNumber,R.column,N.lineNumber,N.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<R.startColumn)}static areIntersecting(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<=N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,N){if(R&&N){const l=R.startLineNumber|0,I=N.startLineNumber|0;if(l===I){const E=R.startColumn|0,u=N.startColumn|0;if(E===u){const k=R.endLineNumber|0,b=N.endLineNumber|0;if(k===b){const c=R.endColumn|0,g=N.endColumn|0;return c-g}return k-b}return E-u}return l-I}return(R?1:0)-(N?1:0)}static compareRangesUsingEnds(R,N){return R.endLineNumber===N.endLineNumber?R.endColumn===N.endColumn?R.startLineNumber===N.startLineNumber?R.startColumn-N.startColumn:R.startLineNumber-N.startLineNumber:R.endColumn-N.endColumn:R.endLineNumber-N.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Ht=h}),define(Ee[189],Se([1,0,31]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0;class h{static insert(R,N){return{range:new r.$Ht(R.lineNumber,R.column,R.lineNumber,R.column),text:N,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,N){return{range:R,text:N}}static replaceMove(R,N){return{range:R,text:N,forceMoveMarkers:!0}}}e.$It=h}),define(Ee[190],Se([1,0,53,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.SelectionDirection=void 0;var A;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends h.$Ht{constructor(T,$,l,I){super(T,$,l,I),this.selectionStartLineNumber=T,this.selectionStartColumn=$,this.positionLineNumber=l,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,$){return T.selectionStartLineNumber===$.selectionStartLineNumber&&T.selectionStartColumn===$.selectionStartColumn&&T.positionLineNumber===$.positionLineNumber&&T.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?A.LTR:A.RTL}setEndPosition(T,$){return this.getDirection()===A.LTR?new R(this.startLineNumber,this.startColumn,T,$):new R(T,$,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Gt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Gt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,$){return this.getDirection()===A.LTR?new R(T,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,$)}static fromPositions(T,$=T){return new R(T.lineNumber,T.column,$.lineNumber,$.column)}static fromRange(T,$){return $===A.LTR?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,$){if(T&&!$||!T&&$)return!1;if(!T&&!$)return!0;if(T.length!==$.length)return!1;for(let l=0,I=T.length;l<I;l++)if(!this.selectionsEqual(T[l],$[l]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,$,l,I,E){return E===A.LTR?new R(T,$,l,I):new R(l,I,T,$)}}e.$Jt=R}),define(Ee[191],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$et={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[192],Se([1,0,27,29,137]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.WordCharacterClass=void 0,e.$cu=$;var R;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class N extends A.$_t{constructor(I,E){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,k=I.length;u<k;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,E){let u=null;for(const k of this.h(I)){if(k.index>E)break;u=k}return u}findNextIntlWordAtOrAfterOffset(I,E){for(const u of this.h(I))if(!(u.index<E))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const E=[];for(const u of I)this.k(u)&&E.push(u);return E}k(I){return!!I.isWordLike}}e.$bu=N;const T=new h.$Ec(10);function $(l,I){const E=`${l}/${I.join(",")}`;let u=T.get(E);return u||(u=new N(l,I),T.set(E,u)),u}}),define(Ee[138],Se([1,0,40,3,81]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0,e.$ht=N,e.$it=$,e.$jt=l,e.$ft="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(E=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$ft)E.indexOf(k)>=0||(u+="\\"+k);return u+="\\s]+)",new RegExp(u,"g")}e.$gt=R();function N(E){let u=e.$gt;if(E&&E instanceof RegExp)if(E.global)u=E;else{let k="g";E.ignoreCase&&(k+="i"),E.multiline&&(k+="m"),E.unicode&&(k+="u"),u=new RegExp(E.source,k)}return u.lastIndex=0,u}const T=new A.$6c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(E){const u=T.unshift(E);return(0,h.$Tc)(u)}function l(E,u,k,b,c){if(u=N(u),c||(c=r.Iterable.first(T)),k.length>c.maxLen){let o=E-c.maxLen/2;return o<0?o=0:b+=o,k=k.substring(o,E+c.maxLen/2),l(E,u,k,b,c)}const g=Date.now(),f=E-1-b;let m=-1,n=null;for(let o=1;!(Date.now()-g>=c.timeBudget);o++){const i=f-c.windowSize*o;u.lastIndex=Math.max(0,i);const t=I(u,k,f,m);if(!t&&n||(n=t,i<=0))break;m=i}if(n){const o={word:n[0],startColumn:b+1+n.index,endColumn:b+1+n.index+n[0].length};return u.lastIndex=0,o}return null}function I(E,u,k,b){let c;for(;c=E.exec(u);){const g=c.index||0;if(g<=k&&E.lastIndex>=k)return c;if(b>0&&g>b)return null}return null}}),define(Ee[106],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var A;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(A||(e.ColorId=A={}));var R;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var N;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(N||(e.MetadataConsts=N={}));class T{static getLanguageId(l){return(l&N.LANGUAGEID_MASK)>>>N.LANGUAGEID_OFFSET}static getTokenType(l){return(l&N.TOKEN_TYPE_MASK)>>>N.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&N.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&N.FONT_STYLE_MASK)>>>N.FONT_STYLE_OFFSET}static getForeground(l){return(l&N.FOREGROUND_MASK)>>>N.FOREGROUND_OFFSET}static getBackground(l){return(l&N.BACKGROUND_MASK)>>>N.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let E="mtk"+this.getForeground(l);const u=this.getFontStyle(l);return u&h.Italic&&(E+=" mtki"),u&h.Bold&&(E+=" mtkb"),u&h.Underline&&(E+=" mtku"),u&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(l,I){const E=this.getForeground(l),u=this.getFontStyle(l);let k=`color: ${I[E]};`;u&h.Italic&&(k+="font-style: italic;"),u&h.Bold&&(k+="font-weight: bold;");let b="";return u&h.Underline&&(b+=" underline"),u&h.Strikethrough&&(b+=" line-through"),b&&(k+=`text-decoration:${b};`),k}static getPresentationFromMetadata(l){const I=this.getForeground(l),E=this.getFontStyle(l);return{foreground:I,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$nu=T}),define(Ee[193],Se([1,0,27,106]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.IndentAction=void 0;var A;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(A||(e.IndentAction=A={}));class R{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let I=0,E=l.notIn.length;I<E;I++)switch(l.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(l,I){if(l.getTokenCount()===0)return!0;const E=l.findTokenIndexAtOffset(I-2),u=l.getStandardTokenType(E);return this.isOK(u)}g(l,I){for(let E=l;E<=I;E++){const u=String.fromCharCode(E);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Ou=R;class N{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of l)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Pu=N;function T($,l,I){$.has(l)?$.get(l).push(I):$.set(l,[I])}}),define(Ee[194],Se([1,0,27,137]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3=e.$F3=e.State=void 0,e.$H3=k;var A;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class R{constructor(c,g,f){const m=new Uint8Array(c*g);for(let n=0,o=c*g;n<o;n++)m[n]=f;this.a=m,this.rows=c,this.cols=g}get(c,g){return this.a[c*this.cols+g]}set(c,g,f){this.a[c*this.cols+g]=f}}class N{constructor(c){let g=0,f=A.Invalid;for(let n=0,o=c.length;n<o;n++){const[i,t,s]=c[n];t>g&&(g=t),i>f&&(f=i),s>f&&(f=s)}g++,f++;const m=new R(f,g,A.Invalid);for(let n=0,o=c.length;n<o;n++){const[i,t,s]=c[n];m.set(i,t,s)}this.a=m,this.b=g}nextState(c,g){return g<0||g>=this.b?A.Invalid:this.a.get(c,g)}}e.$F3=N;let T=null;function $(){return T===null&&(T=new N([[A.Start,r.CharCode.h,A.H],[A.Start,r.CharCode.H,A.H],[A.Start,r.CharCode.f,A.F],[A.Start,r.CharCode.F,A.F],[A.H,r.CharCode.t,A.HT],[A.H,r.CharCode.T,A.HT],[A.HT,r.CharCode.t,A.HTT],[A.HT,r.CharCode.T,A.HTT],[A.HTT,r.CharCode.p,A.HTTP],[A.HTT,r.CharCode.P,A.HTTP],[A.HTTP,r.CharCode.s,A.BeforeColon],[A.HTTP,r.CharCode.S,A.BeforeColon],[A.HTTP,r.CharCode.Colon,A.AfterColon],[A.F,r.CharCode.i,A.FI],[A.F,r.CharCode.I,A.FI],[A.FI,r.CharCode.l,A.FIL],[A.FI,r.CharCode.L,A.FIL],[A.FIL,r.CharCode.e,A.BeforeColon],[A.FIL,r.CharCode.E,A.BeforeColon],[A.BeforeColon,r.CharCode.Colon,A.AfterColon],[A.AfterColon,r.CharCode.Slash,A.AlmostThere],[A.AlmostThere,r.CharCode.Slash,A.End]])),T}var l;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let I=null;function E(){if(I===null){I=new h.$_t(l.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<b.length;g++)I.set(b.charCodeAt(g),l.ForceTermination);const c=".,;:";for(let g=0;g<c.length;g++)I.set(c.charCodeAt(g),l.CannotEndIn)}return I}class u{static a(c,g,f,m,n){let o=n-1;do{const i=g.charCodeAt(o);if(c.get(i)!==l.CannotEndIn)break;o--}while(o>m);if(m>0){const i=g.charCodeAt(m-1),t=g.charCodeAt(o);(i===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||i===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||i===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:f,startColumn:m+1,endLineNumber:f,endColumn:o+2},url:g.substring(m,o+1)}}static computeLinks(c,g=$()){const f=E(),m=[];for(let n=1,o=c.getLineCount();n<=o;n++){const i=c.getLineContent(n),t=i.length;let s=0,d=0,a=0,w=A.Start,y=!1,S=!1,D=!1,P=!1;for(;s<t;){let C=!1;const p=i.charCodeAt(s);if(w===A.Accept){let v;switch(p){case r.CharCode.OpenParen:y=!0,v=l.None;break;case r.CharCode.CloseParen:v=y?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:D=!0,S=!0,v=l.None;break;case r.CharCode.CloseSquareBracket:D=!1,v=S?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:P=!0,v=l.None;break;case r.CharCode.CloseCurlyBrace:v=P?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:a===p?v=l.ForceTermination:a===r.CharCode.SingleQuote||a===r.CharCode.DoubleQuote||a===r.CharCode.BackTick?v=l.None:v=l.ForceTermination;break;case r.CharCode.Asterisk:v=a===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:v=a===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:v=D?l.None:l.ForceTermination;break;default:v=f.get(p)}v===l.ForceTermination&&(m.push(u.a(f,i,n,d,s)),C=!0)}else if(w===A.End){let v;p===r.CharCode.OpenSquareBracket?(S=!0,v=l.None):v=f.get(p),v===l.ForceTermination?C=!0:w=A.Accept}else w=g.nextState(w,p),w===A.Invalid&&(C=!0);C&&(w=A.Start,y=!1,S=!1,P=!1,d=s+1,a=p),s++}w===A.Accept&&m.push(u.a(f,i,n,d,t))}return m}}e.$G3=u;function k(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:u.computeLinks(b)}}),define(Ee[54],Se([1,0,25]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$9v=e.$8v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$0v=b,e.$bw=o;var h;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var A;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var N;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(N||(e.MinimapSectionHeaderStyle=N={}));var T;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var $;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var l;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var I;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.$fo)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$8v=E;class u{constructor(t,s){this._findMatchBrand=void 0,this.range=t,this.matches=s}}e.$9v=u;var k;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k||(e.TrackedRangeStickiness=k={}));function b(i){return i&&typeof i.read=="function"}var c;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var g;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class f{constructor(t,s,d,a,w,y){this.identifier=t,this.range=s,this.text=d,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=w,this._isTracked=y}}e.$$v=f;class m{constructor(t,s,d){this.regex=t,this.wordSeparators=s,this.simpleSearch=d}}e.$_v=m;class n{constructor(t,s,d){this.reverseEdits=t,this.changes=s,this.trimAutoWhitespaceLineNumbers=d}}e.$aw=n;function o(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(Ee[195],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.NodeColor=e.$YC=void 0,e.$1C=A,e.$2C=R,e.$3C=l,e.$4C=I,e.$5C=E,e.$6C=u,e.$7C=k,e.$8C=b;class r{constructor(g,f){this.piece=g,this.color=f,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$ZC)return A(this.right);let g=this;for(;g.parent!==e.$ZC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$ZC?e.$ZC:g.parent}prev(){if(this.left!==e.$ZC)return R(this.left);let g=this;for(;g.parent!==e.$ZC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$ZC?e.$ZC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$YC=r;var h;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$ZC=new r(null,h.Black),e.$ZC.parent=e.$ZC,e.$ZC.left=e.$ZC,e.$ZC.right=e.$ZC,e.$ZC.color=h.Black;function A(c){for(;c.left!==e.$ZC;)c=c.left;return c}function R(c){for(;c.right!==e.$ZC;)c=c.right;return c}function N(c){return c===e.$ZC?0:c.size_left+c.piece.length+N(c.right)}function T(c){return c===e.$ZC?0:c.lf_left+c.piece.lineFeedCnt+T(c.right)}function $(){e.$ZC.parent=e.$ZC}function l(c,g){const f=g.right;f.size_left+=g.size_left+(g.piece?g.piece.length:0),f.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=f.left,f.left!==e.$ZC&&(f.left.parent=g),f.parent=g.parent,g.parent===e.$ZC?c.root=f:g.parent.left===g?g.parent.left=f:g.parent.right=f,f.left=g,g.parent=f}function I(c,g){const f=g.left;g.left=f.right,f.right!==e.$ZC&&(f.right.parent=g),f.parent=g.parent,g.size_left-=f.size_left+(f.piece?f.piece.length:0),g.lf_left-=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),g.parent===e.$ZC?c.root=f:g===g.parent.right?g.parent.right=f:g.parent.left=f,f.right=g,g.parent=f}function E(c,g){let f,m;if(g.left===e.$ZC?(m=g,f=m.right):g.right===e.$ZC?(m=g,f=m.left):(m=A(g.right),f=m.right),m===c.root){c.root=f,f.color=h.Black,g.detach(),$(),c.root.parent=e.$ZC;return}const n=m.color===h.Red;if(m===m.parent.left?m.parent.left=f:m.parent.right=f,m===g?(f.parent=m.parent,b(c,f)):(m.parent===g?f.parent=m:f.parent=m.parent,b(c,f),m.left=g.left,m.right=g.right,m.parent=g.parent,m.color=g.color,g===c.root?c.root=m:g===g.parent.left?g.parent.left=m:g.parent.right=m,m.left!==e.$ZC&&(m.left.parent=m),m.right!==e.$ZC&&(m.right.parent=m),m.size_left=g.size_left,m.lf_left=g.lf_left,b(c,m)),g.detach(),f.parent.left===f){const i=N(f),t=T(f);if(i!==f.parent.size_left||t!==f.parent.lf_left){const s=i-f.parent.size_left,d=t-f.parent.lf_left;f.parent.size_left=i,f.parent.lf_left=t,k(c,f.parent,s,d)}}if(b(c,f.parent),n){$();return}let o;for(;f!==c.root&&f.color===h.Black;)f===f.parent.left?(o=f.parent.right,o.color===h.Red&&(o.color=h.Black,f.parent.color=h.Red,l(c,f.parent),o=f.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,f=f.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,I(c,o),o=f.parent.right),o.color=f.parent.color,f.parent.color=h.Black,o.right.color=h.Black,l(c,f.parent),f=c.root)):(o=f.parent.left,o.color===h.Red&&(o.color=h.Black,f.parent.color=h.Red,I(c,f.parent),o=f.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,f=f.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,l(c,o),o=f.parent.left),o.color=f.parent.color,f.parent.color=h.Black,o.left.color=h.Black,I(c,f.parent),f=c.root));f.color=h.Black,$()}function u(c,g){for(b(c,g);g!==c.root&&g.parent.color===h.Red;)if(g.parent===g.parent.parent.left){const f=g.parent.parent.right;f.color===h.Red?(g.parent.color=h.Black,f.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,l(c,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,I(c,g.parent.parent))}else{const f=g.parent.parent.left;f.color===h.Red?(g.parent.color=h.Black,f.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,I(c,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,l(c,g.parent.parent))}c.root.color=h.Black}function k(c,g,f,m){for(;g!==c.root&&g!==e.$ZC;)g.parent.left===g&&(g.parent.size_left+=f,g.parent.lf_left+=m),g=g.parent}function b(c,g){let f=0,m=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,f=N(g.left)-g.size_left,m=T(g.left)-g.lf_left,g.size_left+=f,g.lf_left+=m;g!==c.root&&(f!==0||m!==0);)g.parent.left===g&&(g.parent.size_left+=f,g.parent.lf_left+=m),g=g.parent}}}),define(Ee[196],Se([1,0,19,84]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=void 0;class A{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,l){$=(0,h.$bf)($);const I=this.a,E=this.b,u=l.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($),$+u),this.a.set(l,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue($,l){return $=(0,h.$bf)($),l=(0,h.$bf)(l),this.a[$]===l?!1:(this.a[$]=l,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,l){$=(0,h.$bf)($),l=(0,h.$bf)(l);const I=this.a,E=this.b;if($>=I.length)return!1;const u=I.length-$;return l>=u&&(l=u),l===0?!1:(this.a=new Uint32Array(I.length-l),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($+l),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$bf)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),$>=this.a.length&&($=this.a.length-1);for(let I=l;I<=$;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let l=0,I=this.a.length-1,E=0,u=0,k=0;for(;l<=I;)if(E=l+(I-l)/2|0,u=this.b[E],k=u-this.a[E],$<k)I=E-1;else if($>=u)l=E+1;else break;return new N(E,$-k)}}e.$ew=A;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const l=this.e[$],I=l>0?this.d[l-1]:0;return new N(l,$-I)}removeValues($,l){this.a.splice($,l),this.f($)}insertValues($,l){this.a=(0,r.$Wb)(this.a,$,l),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,l=this.a.length;$<l;$++){const I=this.a[$],E=$>0?this.d[$-1]:0;this.d[$]=E+I;for(let u=0;u<I;u++)this.e[E+u]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,l){this.a[$]!==l&&(this.a[$]=l,this.f($))}}e.$fw=R;class N{constructor($,l){this.index=$,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=l}}e.$gw=N}),define(Ee[197],Se([1,0,13,53,196]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=void 0;class R{constructor(T,$,l,I){this.d=T,this.f=$,this.g=l,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const $=T.changes;for(const l of $)this.o(l.range),this.p(new h.$Gt(l.range.startLineNumber,l.range.startColumn),l.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,$=this.f.length,l=new Uint32Array($);for(let I=0;I<$;I++)l[I]=this.f[I].length+T;this.j=new A.$ew(l)}}n(T,$){this.f[T]=$,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,$){if($.length===0)return;const l=(0,r.$sf)($);if(l.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+l[0]+this.f[T.lineNumber-1].substring(T.column-1));return}l[l.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+l[0]);const I=new Uint32Array(l.length-1);for(let E=1;E<l.length;E++)this.f.splice(T.lineNumber+E-1,0,l[E]),I[E-1]=l[E].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,I)}}e.$hw=R}),define(Ee[107],Se([1,0,27,13,192,53,31,54]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.$_C=e.$9C=void 0,e.$0C=I,e.$$C=E,e.$aD=g,h=We(h);const $=999;class l{constructor(n,o,i,t){this.searchString=n,this.isRegex=o,this.matchCase=i,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=I(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$qf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let i=!this.isRegex&&!n;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new T.$_v(o,this.wordSeparators?(0,A.$cu)(this.wordSeparators,[]):null,i?this.searchString:null)}}e.$9C=l;function I(m){if(!m||m.length===0)return!1;for(let n=0,o=m.length;n<o;n++){const i=m.charCodeAt(n);if(i===r.CharCode.LineFeed)return!0;if(i===r.CharCode.Backslash){if(n++,n>=o)break;const t=m.charCodeAt(n);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function E(m,n,o){if(!o)return new T.$9v(m,null);const i=[];for(let t=0,s=n.length;t<s;t++)i[t]=n[t];return new T.$9v(m,i)}class u{constructor(n){const o=[];let i=0;for(let t=0,s=n.length;t<s;t++)n.charCodeAt(t)===r.CharCode.LineFeed&&(o[i++]=t);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let i=0,t=o.length-1;if(t===-1||n<=o[0])return 0;for(;i<t;){const s=i+((t-i)/2>>0);o[s]>=n?t=s-1:o[s+1]>=n?(i=s,t=s):i=s+1}return i+1}}class k{static findMatches(n,o,i,t,s){const d=o.parseSearchRequest();return d?d.regex.multiline?this.b(n,i,new f(d.wordSeparators,d.regex),t,s):this.c(n,i,d,t,s):[]}static a(n,o,i,t,s,d){let a,w=0;t?(w=t.findLineFeedCountBeforeOffset(s),a=o+s+w):a=o+s;let y;if(t){const C=t.findLineFeedCountBeforeOffset(s+d.length)-w;y=a+d.length+C}else y=a+d.length;const S=n.getPositionAt(a),D=n.getPositionAt(y);return new N.$Ht(S.lineNumber,S.column,D.lineNumber,D.column)}static b(n,o,i,t,s){const d=n.getOffsetAt(o.getStartPosition()),a=n.getValueInRange(o,T.EndOfLinePreference.LF),w=n.getEOL()===`\r
`?new u(a):null,y=[];let S=0,D;for(i.reset(0);D=i.next(a);)if(y[S++]=E(this.a(n,d,a,w,D.index,D[0]),D,t),S>=s)return y;return y}static c(n,o,i,t,s){const d=[];let a=0;if(o.startLineNumber===o.endLineNumber){const y=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return a=this.d(i,y,o.startLineNumber,o.startColumn-1,a,d,t,s),d}const w=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);a=this.d(i,w,o.startLineNumber,o.startColumn-1,a,d,t,s);for(let y=o.startLineNumber+1;y<o.endLineNumber&&a<s;y++)a=this.d(i,n.getLineContent(y),y,0,a,d,t,s);if(a<s){const y=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);a=this.d(i,y,o.endLineNumber,0,a,d,t,s)}return d}static d(n,o,i,t,s,d,a,w){const y=n.wordSeparators;if(!a&&n.simpleSearch){const P=n.simpleSearch,C=P.length,p=o.length;let v=-C;for(;(v=o.indexOf(P,v+C))!==-1;)if((!y||g(y,o,p,v,C))&&(d[s++]=new T.$9v(new N.$Ht(i,v+1+t,i,v+1+C+t),null),s>=w))return s;return s}const S=new f(n.wordSeparators,n.regex);let D;S.reset(0);do if(D=S.next(o),D&&(d[s++]=E(new N.$Ht(i,D.index+1+t,i,D.index+1+D[0].length+t),D,a),s>=w))return s;while(D);return s}static findNextMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const d=new f(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,i,d,t):this.f(n,i,d,t)}static e(n,o,i,t){const s=new R.$Gt(o.lineNumber,1),d=n.getOffsetAt(s),a=n.getLineCount(),w=n.getValueInRange(new N.$Ht(s.lineNumber,s.column,a,n.getLineMaxColumn(a)),T.EndOfLinePreference.LF),y=n.getEOL()===`\r
`?new u(w):null;i.reset(o.column-1);const S=i.next(w);return S?E(this.a(n,d,w,y,S.index,S[0]),S,t):o.lineNumber!==1||o.column!==1?this.e(n,new R.$Gt(1,1),i,t):null}static f(n,o,i,t){const s=n.getLineCount(),d=o.lineNumber,a=n.getLineContent(d),w=this.g(i,a,d,o.column,t);if(w)return w;for(let y=1;y<=s;y++){const S=(d+y-1)%s,D=n.getLineContent(S+1),P=this.g(i,D,S+1,1,t);if(P)return P}return null}static g(n,o,i,t,s){n.reset(t-1);const d=n.next(o);return d?E(new N.$Ht(i,d.index+1,i,d.index+1+d[0].length),d,s):null}static findPreviousMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const d=new f(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,i,d,t):this.j(n,i,d,t)}static h(n,o,i,t){const s=this.b(n,new N.$Ht(1,1,o.lineNumber,o.column),i,t,10*$);if(s.length>0)return s[s.length-1];const d=n.getLineCount();return o.lineNumber!==d||o.column!==n.getLineMaxColumn(d)?this.h(n,new R.$Gt(d,n.getLineMaxColumn(d)),i,t):null}static j(n,o,i,t){const s=n.getLineCount(),d=o.lineNumber,a=n.getLineContent(d).substring(0,o.column-1),w=this.k(i,a,d,t);if(w)return w;for(let y=1;y<=s;y++){const S=(s+d-y-1)%s,D=n.getLineContent(S+1),P=this.k(i,D,S+1,t);if(P)return P}return null}static k(n,o,i,t){let s=null,d;for(n.reset(0);d=n.next(o);)s=E(new N.$Ht(i,d.index+1,i,d.index+1+d[0].length),d,t);return s}}e.$_C=k;function b(m,n,o,i,t){if(i===0)return!0;const s=n.charCodeAt(i-1);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const d=n.charCodeAt(i);if(m.get(d)!==A.WordCharacterClass.Regular)return!0}return!1}function c(m,n,o,i,t){if(i+t===o)return!0;const s=n.charCodeAt(i+t);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const d=n.charCodeAt(i+t-1);if(m.get(d)!==A.WordCharacterClass.Regular)return!0}return!1}function g(m,n,o,i,t){return b(m,n,o,i,t)&&c(m,n,o,i,t)}class f{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let i;do{if(this.b+this.c===o||(i=this.a.exec(n),!i))return null;const t=i.index,s=i[0].length;if(t===this.b&&s===this.c){if(s===0){h.$Mf(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=t,this.c=s,!this._wordSeparators||g(this._wordSeparators,n,o,t,s))return i}while(i);return null}}e.$bD=f}),define(Ee[139],Se([1,0,27,53,31,54,195,107]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.$eD=void 0,e.$cD=E,e.$dD=u;const $=65535;function l(m){let n;return m[m.length-1]<65536?n=new Uint16Array(m.length):n=new Uint32Array(m.length),n.set(m,0),n}class I{constructor(n,o,i,t,s){this.lineStarts=n,this.cr=o,this.lf=i,this.crlf=t,this.isBasicASCII=s}}function E(m,n=!0){const o=[0];let i=1;for(let t=0,s=m.length;t<s;t++){const d=m.charCodeAt(t);d===r.CharCode.CarriageReturn?t+1<s&&m.charCodeAt(t+1)===r.CharCode.LineFeed?(o[i++]=t+2,t++):o[i++]=t+1:d===r.CharCode.LineFeed&&(o[i++]=t+1)}return n?l(o):o}function u(m,n){m.length=0,m[0]=0;let o=1,i=0,t=0,s=0,d=!0;for(let w=0,y=n.length;w<y;w++){const S=n.charCodeAt(w);S===r.CharCode.CarriageReturn?w+1<y&&n.charCodeAt(w+1)===r.CharCode.LineFeed?(s++,m[o++]=w+2,w++):(i++,m[o++]=w+1):S===r.CharCode.LineFeed?(t++,m[o++]=w+1):d&&S!==r.CharCode.Tab&&(S<32||S>126)&&(d=!1)}const a=new I(l(m),i,t,s,d);return m.length=0,a}class k{constructor(n,o,i,t,s){this.bufferIndex=n,this.start=o,this.end=i,this.lineFeedCnt=t,this.length=s}}e.$eD=k;class b{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$fD=b;class c{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==N.$ZC&&n.iterate(n.root,i=>(i!==N.$ZC&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const i=this.b;for(let t=0;t<i.length;t++){const s=i[t];if(s.node.parent===null||s.nodeStartOffset>=n){i[t]=null,o=!0;continue}}if(o){const t=[];for(const s of i)s!==null&&t.push(s);this.b=t}}}class f{constructor(n,o,i){this.create(n,o,i)}create(n,o,i){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$ZC,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=i;let t=null;for(let s=0,d=n.length;s<d;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=E(n[s].buffer));const a=new k(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),t=this.S(t,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,i=o-Math.floor(o/3),t=i*2;let s="",d=0;const a=[];if(this.iterate(this.root,w=>{const y=this.R(w),S=y.length;if(d<=i||d+S<t)return s+=y,d+=S,!0;const D=s.replace(/\r\n|\r|\n/g,n);return a.push(new b(D,E(D))),s=y,d=S,!0}),d>0){const w=s.replace(/\r\n|\r|\n/g,n);a.push(new b(w,E(w)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new c(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,t=>{if(t===N.$ZC)return!0;const s=this.R(t),d=s.length,a=n.G(o),w=n.G(o+d),y=n.getValueInRange2(a,w);return o+=d,s===y})}getOffsetAt(n,o){let i=0,t=this.root;for(;t!==N.$ZC;)if(t.left!==N.$ZC&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const s=this.B(t,n-t.lf_left-2);return i+=s+o-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,i=0;const t=n;for(;o!==N.$ZC;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(i+=o.lf_left+s.index,s.index===0){const d=this.getOffsetAt(i+1,1),a=t-d;return new h.$Gt(i+1,a+1)}return new h.$Gt(i+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,i+=o.lf_left+o.piece.lineFeedCnt,o.right===N.$ZC){const s=this.getOffsetAt(i+1,1),d=t-n-s;return new h.$Gt(i+1,d+1)}else o=o.right;return new h.$Gt(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(i,t);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const a=n.node,w=this.a[a.piece.bufferIndex].buffer,y=this.u(a.piece.bufferIndex,a.piece.start);return w.substring(y+n.remainder,y+o.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,s=this.u(i.piece.bufferIndex,i.piece.start);let d=t.substring(s+n.remainder,s+i.piece.length);for(i=i.next();i!==N.$ZC;){const a=this.a[i.piece.bufferIndex].buffer,w=this.u(i.piece.bufferIndex,i.piece.start);if(i===o.node){d+=a.substring(w,w+o.remainder);break}else d+=a.substr(w,i.piece.length);i=i.next()}return d}getLinesContent(){const n=[];let o=0,i="",t=!1;return this.iterate(this.root,s=>{if(s===N.$ZC)return!0;const d=s.piece;let a=d.length;if(a===0)return!0;const w=this.a[d.bufferIndex].buffer,y=this.a[d.bufferIndex].lineStarts,S=d.start.line,D=d.end.line;let P=y[S]+d.start.column;if(t&&(w.charCodeAt(P)===r.CharCode.LineFeed&&(P++,a--),n[o++]=i,i="",t=!1,a===0))return!0;if(S===D)return!this.f&&w.charCodeAt(P+a-1)===r.CharCode.CarriageReturn?(t=!0,i+=w.substr(P,a-1)):i+=w.substr(P,a),!0;i+=this.f?w.substring(P,Math.max(P,y[S+1]-this.e)):w.substring(P,y[S+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;for(let C=S+1;C<D;C++)i=this.f?w.substring(y[C],y[C+1]-this.e):w.substring(y[C],y[C+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;return!this.f&&w.charCodeAt(y[D]+d.end.column-1)===r.CharCode.CarriageReturn?(t=!0,d.end.column===0?o--:i=w.substr(y[D],d.end.column-1)):i=w.substr(y[D],d.end.column),!0}),t&&(n[o++]=i,i=""),n[o++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const i=this.a[o.piece.bufferIndex],t=this.u(o.piece.bufferIndex,o.piece.start);return i.buffer.charCodeAt(t)}else{const o=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(t)}}getLineCharCode(n,o){const i=this.H(n,o+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}getNearestChunk(n){const o=this.G(n);if(o.remainder===o.node.piece.length){const i=o.node.next();if(!i||i===N.$ZC)return"";const t=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return t.buffer.substring(s,s+i.piece.length)}else{const i=this.a[o.node.piece.bufferIndex],t=this.u(o.node.piece.bufferIndex,o.node.piece.start),s=t+o.remainder,d=t+o.node.piece.length;return i.buffer.substring(s,d)}}findMatchesInNode(n,o,i,t,s,d,a,w,y,S,D){const P=this.a[n.piece.bufferIndex],C=this.u(n.piece.bufferIndex,n.piece.start),p=this.u(n.piece.bufferIndex,s),v=this.u(n.piece.bufferIndex,d);let O;const L={line:0,column:0};let F,j;o._wordSeparators?(F=P.buffer.substring(p,v),j=B=>B+p,o.reset(0)):(F=P.buffer,j=B=>B,o.reset(p));do if(O=o.next(F),O){if(j(O.index)>=v)return S;this.s(n,j(O.index)-C,L);const B=this.t(n.piece.bufferIndex,s,L),M=L.line===s.line?L.column-s.column+t:L.column+1,z=M+O[0].length;if(D[S++]=(0,T.$$C)(new A.$Ht(i+B,M,i+B,z),O,w),j(O.index)+O[0].length>=v||S>=y)return S}while(O);return S}findMatchesLineByLine(n,o,i,t){const s=[];let d=0;const a=new T.$bD(o.wordSeparators,o.regex);let w=this.H(n.startLineNumber,n.startColumn);if(w===null)return[];const y=this.H(n.endLineNumber,n.endColumn);if(y===null)return[];let S=this.s(w.node,w.remainder);const D=this.s(y.node,y.remainder);if(w.node===y.node)return this.findMatchesInNode(w.node,a,n.startLineNumber,n.startColumn,S,D,o,i,t,d,s),s;let P=n.startLineNumber,C=w.node;for(;C!==y.node;){const v=this.t(C.piece.bufferIndex,S,C.piece.end);if(v>=1){const L=this.a[C.piece.bufferIndex].lineStarts,F=this.u(C.piece.bufferIndex,C.piece.start),j=L[S.line+v],B=P===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(C,a,P,B,S,this.s(C,j-F),o,i,t,d,s),d>=t)return s;P+=v}const O=P===n.startLineNumber?n.startColumn-1:0;if(P===n.endLineNumber){const L=this.getLineContent(P).substring(O,n.endColumn-1);return d=this.n(o,a,L,n.endLineNumber,O,d,s,i,t),s}if(d=this.n(o,a,this.getLineContent(P).substr(O),P,O,d,s,i,t),d>=t)return s;P++,w=this.H(P,1),C=w.node,S=this.s(w.node,w.remainder)}if(P===n.endLineNumber){const v=P===n.startLineNumber?n.startColumn-1:0,O=this.getLineContent(P).substring(v,n.endColumn-1);return d=this.n(o,a,O,n.endLineNumber,v,d,s,i,t),s}const p=P===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(y.node,a,P,p,S,D,o,i,t,d,s),s}n(n,o,i,t,s,d,a,w,y){const S=n.wordSeparators;if(!w&&n.simpleSearch){const P=n.simpleSearch,C=P.length,p=i.length;let v=-C;for(;(v=i.indexOf(P,v+C))!==-1;)if((!S||(0,T.$aD)(S,i,p,v,C))&&(a[d++]=new R.$9v(new A.$Ht(t,v+1+s,t,v+1+C+s),null),d>=y))return d;return d}let D;o.reset(0);do if(D=o.next(i),D&&(a[d++]=(0,T.$$C)(new A.$Ht(t,D.index+1+s,t,D.index+1+D[0].length+s),D,w),d>=y))return d;while(D);return d}insert(n,o,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==N.$ZC){const{node:t,remainder:s,nodeStartOffset:d}=this.G(n),a=t.piece,w=a.bufferIndex,y=this.s(t,s);if(t.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&d+a.length===n&&o.length<$){this.F(t,o),this.y();return}if(d===n)this.o(o,t),this.h.validate(n);else if(d+t.piece.length>n){const S=[];let D=new k(a.bufferIndex,y,a.end,this.t(a.bufferIndex,y,a.end),this.u(w,a.end)-this.u(w,y));if(this.K()&&this.M(o)&&this.I(t,s)===10){const v={line:D.start.line+1,column:0};D=new k(D.bufferIndex,v,D.end,this.t(D.bufferIndex,v,D.end),D.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(t,s-1)===13){const v=this.s(t,s-1);this.C(t,v),o="\r"+o,t.piece.length===0&&S.push(t)}else this.C(t,y);else this.C(t,y);const P=this.w(o);D.length>0&&this.S(t,D);let C=t;for(let p=0;p<P.length;p++)C=this.S(C,P[p]);this.v(S)}else this.q(o,t)}else{const t=this.w(o);let s=this.T(null,t[0]);for(let d=1;d<t.length;d++)s=this.S(s,t[d])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===N.$ZC)return;const i=this.G(n),t=this.G(n+o),s=i.node,d=t.node;if(s===d){const P=this.s(s,i.remainder),C=this.s(s,t.remainder);if(i.nodeStartOffset===n){if(o===s.piece.length){const p=s.next();(0,N.$5C)(this,s),this.N(p),this.y();return}this.D(s,C),this.h.validate(n),this.N(s),this.y();return}if(i.nodeStartOffset+s.piece.length===n+o){this.C(s,P),this.O(s),this.y();return}this.E(s,P,C),this.y();return}const a=[],w=this.s(s,i.remainder);this.C(s,w),this.h.validate(n),s.piece.length===0&&a.push(s);const y=this.s(d,t.remainder);this.D(d,y),d.piece.length===0&&a.push(d);const S=s.next();for(let P=S;P!==N.$ZC&&P!==d;P=P.next())a.push(P);const D=s.piece.length===0?s.prev():s;this.v(a),this.O(D),this.y()}o(n,o){const i=[];if(this.K()&&this.M(n)&&this.L(o)){const d=o.piece,a={line:d.start.line+1,column:0},w=new k(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),d.length-1);o.piece=w,n+=`
`,(0,N.$7C)(this,o,-1,-1),o.piece.length===0&&i.push(o)}const t=this.w(n);let s=this.T(o,t[t.length-1]);for(let d=t.length-2;d>=0;d--)s=this.T(s,t[d]);this.N(s),this.v(i)}q(n,o){this.Q(n,o)&&(n+=`
`);const i=this.w(n),t=this.S(o,i[0]);let s=t;for(let d=1;d<i.length;d++)s=this.S(s,i[d]);this.N(t)}s(n,o,i){const t=n.piece,s=n.piece.bufferIndex,d=this.a[s].lineStarts,w=d[t.start.line]+t.start.column+o;let y=t.start.line,S=t.end.line,D=0,P=0,C=0;for(;y<=S&&(D=y+(S-y)/2|0,C=d[D],D!==S);)if(P=d[D+1],w<C)S=D-1;else if(w>=P)y=D+1;else break;return i?(i.line=D,i.column=w-C,null):{line:D,column:w-C}}t(n,o,i){if(i.column===0)return i.line-o.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-o.line;const s=t[i.line+1],d=t[i.line]+i.column;if(s>d+1)return i.line-o.line;const a=d-1;return this.a[n].buffer.charCodeAt(a)===13?i.line-o.line+1:i.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,N.$5C)(this,n[o])}w(n){if(n.length>$){const S=[];for(;n.length>$;){const P=n.charCodeAt($-1);let C;P===r.CharCode.CarriageReturn||P>=55296&&P<=56319?(C=n.substring(0,$-1),n=n.substring($-1)):(C=n.substring(0,$),n=n.substring($));const p=E(C);S.push(new k(this.a.length,{line:0,column:0},{line:p.length-1,column:C.length-p[p.length-1]},p.length-1,C.length)),this.a.push(new b(C,p))}const D=E(n);return S.push(new k(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new b(n,D)),S}let o=this.a[0].buffer.length;const i=E(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let S=0;S<i.length;S++)i[S]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let S=0;S<i.length;S++)i[S]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,a=s-this.a[0].lineStarts[d],w={line:d,column:a},y=new k(0,t,w,this.t(0,t,w),s-o);return this.g=w,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let i=this.root,t="";const s=this.h.get2(n);if(s){i=s.node;const d=this.B(i,n-s.nodeStartLineNumber-1),a=this.a[i.piece.bufferIndex].buffer,w=this.u(i.piece.bufferIndex,i.piece.start);if(s.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=a.substring(w+d,w+i.piece.length);else{const y=this.B(i,n-s.nodeStartLineNumber);return a.substring(w+d,w+y-o)}}else{let d=0;const a=n;for(;i!==N.$ZC;)if(i.left!==N.$ZC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const w=this.B(i,n-i.lf_left-2),y=this.B(i,n-i.lf_left-1),S=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);return d+=i.size_left,this.h.set({node:i,nodeStartOffset:d,nodeStartLineNumber:a-(n-1-i.lf_left)}),S.substring(D+w,D+y-o)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const w=this.B(i,n-i.lf_left-2),y=this.a[i.piece.bufferIndex].buffer,S=this.u(i.piece.bufferIndex,i.piece.start);t=y.substring(S+w,S+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,d+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==N.$ZC;){const d=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const a=this.B(i,0),w=this.u(i.piece.bufferIndex,i.piece.start);return t+=d.substring(w,w+a-o),t}else{const a=this.u(i.piece.bufferIndex,i.piece.start);t+=d.substr(a,i.piece.length)}i=i.next()}return t}y(){let n=this.root,o=1,i=0;for(;n!==N.$ZC;)o+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=i,this.h.validate(this.c)}A(n,o){const i=n.piece,t=this.s(n,o),s=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===o){const d=this.t(n.piece.bufferIndex,i.start,t);if(d!==s)return{index:d,remainder:0}}return{index:s,remainder:t.column}}B(n,o){if(o<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,s=i.start.line+o+1;return s>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[s]-t[i.start.line]-i.start.column}C(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.end),d=o,a=this.u(i.bufferIndex,d),w=this.t(i.bufferIndex,i.start,d),y=w-t,S=a-s,D=i.length+S;n.piece=new k(i.bufferIndex,i.start,d,w,D),(0,N.$7C)(this,n,S,y)}D(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.start),d=o,a=this.t(i.bufferIndex,d,i.end),w=this.u(i.bufferIndex,d),y=a-t,S=s-w,D=i.length+S;n.piece=new k(i.bufferIndex,d,i.end,a,D),(0,N.$7C)(this,n,S,y)}E(n,o,i){const t=n.piece,s=t.start,d=t.end,a=t.length,w=t.lineFeedCnt,y=o,S=this.t(t.bufferIndex,t.start,y),D=this.u(t.bufferIndex,o)-this.u(t.bufferIndex,s);n.piece=new k(t.bufferIndex,t.start,y,S,D),(0,N.$7C)(this,n,D-a,S-w);const P=new k(t.bufferIndex,i,d,this.t(t.bufferIndex,i,d),this.u(t.bufferIndex,d)-this.u(t.bufferIndex,i)),C=this.S(n,P);this.N(C)}F(n,o){this.Q(o,n)&&(o+=`
`);const i=this.K()&&this.L(o)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=o;const s=E(o,!1);for(let C=0;C<s.length;C++)s[C]+=t;if(i){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const d=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[d],w={line:d,column:a},y=n.piece.length+o.length,S=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,w),P=D-S;n.piece=new k(n.piece.bufferIndex,n.piece.start,w,D,y),this.g=w,(0,N.$7C)(this,n,o.length,P)}G(n){let o=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;o!==N.$ZC;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){t+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:t};return this.h.set(s),s}else n-=o.size_left+o.piece.length,t+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let i=this.root,t=0;for(;i!==N.$ZC;)if(i.left!==N.$ZC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const s=this.B(i,n-i.lf_left-2),d=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(s+o-1,d),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const s=this.B(i,n-i.lf_left-2);if(s+o-1<=i.piece.length)return{node:i,remainder:s+o-1,nodeStartOffset:t};o-=i.piece.length-s;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==N.$ZC;){if(i.piece.lineFeedCnt>0){const s=this.B(i,0),d=this.J(i);return{node:i,remainder:Math.min(o-1,s),nodeStartOffset:d}}else if(i.piece.length>=o-1){const s=this.J(i);return{node:i,remainder:o-1,nodeStartOffset:s}}else o-=i.piece.length;i=i.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+o;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$ZC||n.piece.lineFeedCnt===0)return!1;const o=n.piece,i=this.a[o.bufferIndex].lineStarts,t=o.start.line,s=i[t]+o.start.column;return t===i.length-1||i[t+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$ZC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new k(n.piece.bufferIndex,n.piece.start,s,a,d),(0,N.$7C)(this,n,-1,-1),n.piece.length===0&&i.push(n);const w={line:o.piece.start.line+1,column:0},y=o.piece.length-1,S=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new k(o.piece.bufferIndex,w,o.piece.end,S,y),(0,N.$7C)(this,o,-1,-1),o.piece.length===0&&i.push(o);const D=this.w(`\r
`);this.S(n,D[0]);for(let P=0;P<i.length;P++)(0,N.$5C)(this,i[P])}Q(n,o){if(this.K()&&this.M(n)){const i=o.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,N.$5C)(this,i);else{const t=i.piece,s={line:t.start.line+1,column:0},d=t.length-1,a=this.t(t.bufferIndex,s,t.end);i.piece=new k(t.bufferIndex,s,t.end,a,d),(0,N.$7C)(this,i,-1,-1)}return!0}}return!1}iterate(n,o){if(n===N.$ZC)return o(N.$ZC);const i=this.iterate(n.left,o);return i&&o(n)&&this.iterate(n.right,o)}R(n){if(n===N.$ZC)return"";const o=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return o.buffer.substring(t,s)}getPieceContent(n){const o=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return o.buffer.substring(i,t)}S(n,o){const i=new N.$YC(o,N.NodeColor.Red);if(i.left=N.$ZC,i.right=N.$ZC,i.parent=N.$ZC,i.size_left=0,i.lf_left=0,this.root===N.$ZC)this.root=i,i.color=N.NodeColor.Black;else if(n.right===N.$ZC)n.right=i,i.parent=n;else{const s=(0,N.$1C)(n.right);s.left=i,i.parent=s}return(0,N.$6C)(this,i),i}T(n,o){const i=new N.$YC(o,N.NodeColor.Red);if(i.left=N.$ZC,i.right=N.$ZC,i.parent=N.$ZC,i.size_left=0,i.lf_left=0,this.root===N.$ZC)this.root=i,i.color=N.NodeColor.Black;else if(n.left===N.$ZC)n.left=i,i.parent=n;else{const t=(0,N.$2C)(n.left);t.right=i,i.parent=t}return(0,N.$6C)(this,i),i}U(n){let o="";return this.iterate(n,i=>(o+=this.R(i),!0)),o}}e.$gD=f}),define(Ee[198],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$=e.$K$=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const N=this.a.get(R);return this.a.delete(R),N}}addDragOperationTransfer(R,N){this.a.set(R,N)}}e.$K$=r;class h{constructor(R){this.identifier=R}}e.$L$=h}),define(Ee[199],Se([1,0,4,3,106]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$le,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,l){return this.a.set($,l),this.handleChange([$]),(0,h.$Tc)(()=>{this.a.get($)===l&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,l){this.b.get($)?.dispose();const I=new N(this,$,l);return this.b.set($,I),(0,h.$Tc)(()=>{const E=this.b.get($);!E||E!==I||(this.b.delete($),E.dispose())})}async getOrCreate($){const l=this.get($);if(l)return l;const I=this.b.get($);return!I||I.isResolved?null:(await I.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const I=this.b.get($);return!!(!I||I.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>A.ColorId.DefaultBackground?this.d[A.ColorId.DefaultBackground]:null}}e.$qu=R;class N extends h.$Vc{get isResolved(){return this.c}constructor($,l,I){super(),this.f=$,this.g=l,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Ee[200],Se([7,8]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(Ee[201],Se([1,0,4,3,200]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=void 0,e.$oj=I,A=We(A);class R extends h.$Vc{constructor(u,k="",b="",c=!0,g){super(),this.j=this.B(new r.$le),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=k,this.w=b,this.z=c,this.D=g}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,k){this.D&&await this.D(u)}}e.$jj=R;class N extends h.$Vc{constructor(){super(...arguments),this.f=this.B(new r.$le),this.onWillRun=this.f.event,this.m=this.B(new r.$le),this.onDidRun=this.m.event}async run(u,k){if(!u.enabled)return;this.f.fire({action:u});let b;try{await this.u(u,k)}catch(c){b=c}this.m.fire({action:u,error:b})}async u(u,k){await u.run(k)}}e.$kj=N;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let k=[];for(const b of u)b.length&&(k.length?k=[...k,new T,...b]:k=b);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$lj=T;class ${get actions(){return this.a}constructor(u,k,b,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=k,this.class=c,this.a=b}async run(){}}e.$mj=$;class l extends R{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,A.localize(0,null),void 0,!1)}}e.$nj=l;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u)}}}),define(Ee[202],Se([7,8]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(Ee[203],Se([1,0,202]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=l,e.$1m=I,e.$2m=E;const h=60,A=h*60,R=A*24,N=R*7,T=R*30,$=R*365;function l(u,k,b,c){typeof u!="number"&&(u=u.getTime());const g=Math.round((new Date().getTime()-u)/1e3);if(g<-30)return(0,r.localize)(0,null,l(new Date().getTime()+g*1e3,!1));if(!c&&g<30)return(0,r.localize)(1,null);let f;return g<h?(f=g,k?f===1?b?(0,r.localize)(2,null,f):(0,r.localize)(3,null,f):b?(0,r.localize)(4,null,f):(0,r.localize)(5,null,f):f===1?b?(0,r.localize)(6,null,f):(0,r.localize)(7,null,f):b?(0,r.localize)(8,null,f):(0,r.localize)(9,null,f)):g<A?(f=Math.floor(g/h),k?f===1?b?(0,r.localize)(10,null,f):(0,r.localize)(11,null,f):b?(0,r.localize)(12,null,f):(0,r.localize)(13,null,f):f===1?b?(0,r.localize)(14,null,f):(0,r.localize)(15,null,f):b?(0,r.localize)(16,null,f):(0,r.localize)(17,null,f)):g<R?(f=Math.floor(g/A),k?f===1?b?(0,r.localize)(18,null,f):(0,r.localize)(19,null,f):b?(0,r.localize)(20,null,f):(0,r.localize)(21,null,f):f===1?b?(0,r.localize)(22,null,f):(0,r.localize)(23,null,f):b?(0,r.localize)(24,null,f):(0,r.localize)(25,null,f)):g<N?(f=Math.floor(g/R),k?f===1?(0,r.localize)(26,null,f):(0,r.localize)(27,null,f):f===1?(0,r.localize)(28,null,f):(0,r.localize)(29,null,f)):g<T?(f=Math.floor(g/N),k?f===1?b?(0,r.localize)(30,null,f):(0,r.localize)(31,null,f):b?(0,r.localize)(32,null,f):(0,r.localize)(33,null,f):f===1?b?(0,r.localize)(34,null,f):(0,r.localize)(35,null,f):b?(0,r.localize)(36,null,f):(0,r.localize)(37,null,f)):g<$?(f=Math.floor(g/T),k?f===1?b?(0,r.localize)(38,null,f):(0,r.localize)(39,null,f):b?(0,r.localize)(40,null,f):(0,r.localize)(41,null,f):f===1?b?(0,r.localize)(42,null,f):(0,r.localize)(43,null,f):b?(0,r.localize)(44,null,f):(0,r.localize)(45,null,f)):(f=Math.floor(g/$),k?f===1?b?(0,r.localize)(46,null,f):(0,r.localize)(47,null,f):b?(0,r.localize)(48,null,f):(0,r.localize)(49,null,f):f===1?b?(0,r.localize)(50,null,f):(0,r.localize)(51,null,f):b?(0,r.localize)(52,null,f):(0,r.localize)(53,null,f))}function I(u,k){const b=Math.abs(u/1e3);return b<1?k?(0,r.localize)(54,null,u):(0,r.localize)(55,null,u):b<h?k?(0,r.localize)(56,null,Math.round(u)/1e3):(0,r.localize)(57,null,Math.round(u)/1e3):b<A?k?(0,r.localize)(58,null,Math.round(u/(1e3*h))):(0,r.localize)(59,null,Math.round(u/(1e3*h))):b<R?k?(0,r.localize)(60,null,Math.round(u/(1e3*A))):(0,r.localize)(61,null,Math.round(u/(1e3*A))):(0,r.localize)(62,null,Math.round(u/(1e3*R)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[204],Se([7,8]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(Ee[55],Se([1,0,19,18,204]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=$,e.$qj=l,e.$rj=I,r=We(r),h=We(h),A=We(A);function R(E,u){return u&&(E.stack||E.stacktrace)?A.localize(0,null,T(E),N(E.stack)||N(E.stacktrace)):T(E)}function N(E){return Array.isArray(E)?E.join(`
`):E}function T(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function $(E=null,u=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const k=r.$Ib(E),b=$(k[0],u);return k.length>1?A.localize(4,null,b,k.length):b}if(h.$eg(E))return E;if(E.detail){const k=E.detail;if(k.error)return R(k.error,u);if(k.exception)return R(k.exception,u)}return E.stack?R(E,u):E.message?E.message:A.localize(5,null)}function l(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function I(E,u){let k;return typeof E=="string"?k=new Error(E):k=E,k.actions=u,k}}),define(Ee[205],Se([7,8]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(Ee[11],Se([1,0,205]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=D,e.$J=P,r=We(r),e.$g="en";let h=!1,A=!1,R=!1,N=!1,T=!1,$=!1,l=!1,I=!1,E=!1,u=!1,k,b=e.$g,c=e.$g,g,f;const m=globalThis;let n;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?n=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",i=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",A=n.platform==="darwin",R=n.platform==="linux",N=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,l=o,E=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,b=e.$g;const C=n.env.VSCODE_NLS_CONFIG;if(C)try{const p=JSON.parse(C),v=p.availableLanguages["*"];k=p.locale,c=p.osLocale,b=v||e.$g,g=p._translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!i?(f=navigator.userAgent,h=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,I=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=f.indexOf("Linux")>=0,u=f?.indexOf("Mobi")>=0,$=!0,k=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,b=k,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(C){switch(C){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let d=t.Web;A?d=t.Mac:h?d=t.Windows:R&&(d=t.Linux),e.$i=h,e.$j=A,e.$k=R,e.$l=N,e.$m=T,e.$n=l,e.$o=$,e.$p=$&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=I,e.$s=u,e.$t=E,e.$u=d,e.$v=f,e.$w=b;var a;(function(C){function p(){return e.$w}C.value=p;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}C.isDefaultVariant=v;function O(){return e.$w==="en"}C.isDefault=O})(a||(e.Language=a={})),e.$x=k,e.$y=c,e.$z=g,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const C=[];m.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let O=0,L=C.length;O<L;O++){const F=C[O];if(F.id===v.data.vscodeScheduleAsyncWork){C.splice(O,1),F.callback();return}}});let p=0;return v=>{const O=++p;C.push({id:O,callback:v}),m.postMessage({vscodeScheduleAsyncWork:O},"*")}}return C=>setTimeout(C)})();var w;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(w||(e.OperatingSystem=w={})),e.OS=A||I?w.Macintosh:h?w.Windows:w.Linux;let y=!0,S=!1;function D(){if(!S){S=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,y=new Uint16Array(C.buffer)[0]===513}return y}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function P(C){return parseFloat(C)>=20}}),define(Ee[56],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$ec=h.platform,e.$fc=h.arch}),define(Ee[16],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,r=We(r);const h=65,A=97,R=90,N=122,T=46,$=47,l=92,I=58,E=63;class u extends Error{constructor(s,d,a){let w;typeof d=="string"&&d.indexOf("not ")===0?(w="must not be",d=d.replace(/^not /,"")):w="must be";const y=s.indexOf(".")!==-1?"property":"argument";let S=`The "${s}" ${y} ${w} of type ${d}`;S+=`. Received type ${typeof a}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,s){if(t===null||typeof t!="object")throw new u(s,"Object",t)}function b(t,s){if(typeof t!="string")throw new u(s,"string",t)}const c=r.$ec==="win32";function g(t){return t===$||t===l}function f(t){return t===$}function m(t){return t>=h&&t<=R||t>=A&&t<=N}function n(t,s,d,a){let w="",y=0,S=-1,D=0,P=0;for(let C=0;C<=t.length;++C){if(C<t.length)P=t.charCodeAt(C);else{if(a(P))break;P=$}if(a(P)){if(!(S===C-1||D===1))if(D===2){if(w.length<2||y!==2||w.charCodeAt(w.length-1)!==T||w.charCodeAt(w.length-2)!==T){if(w.length>2){const p=w.lastIndexOf(d);p===-1?(w="",y=0):(w=w.slice(0,p),y=w.length-1-w.lastIndexOf(d)),S=C,D=0;continue}else if(w.length!==0){w="",y=0,S=C,D=0;continue}}s&&(w+=w.length>0?`${d}..`:"..",y=2)}else w.length>0?w+=`${d}${t.slice(S+1,C)}`:w=t.slice(S+1,C),y=C-S-1;S=C,D=0}else P===T&&D!==-1?++D:D=-1}return w}function o(t,s){k(s,"pathObject");const d=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${a}`:`${d}${t}${a}`:a}e.$gc={resolve(...t){let s="",d="",a=!1;for(let w=t.length-1;w>=-1;w--){let y;if(w>=0){if(y=t[w],b(y,"path"),y.length===0)continue}else s.length===0?y=r.cwd():(y=r.env[`=${s}`]||r.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==s.toLowerCase()&&y.charCodeAt(2)===l)&&(y=`${s}\\`));const S=y.length;let D=0,P="",C=!1;const p=y.charCodeAt(0);if(S===1)g(p)&&(D=1,C=!0);else if(g(p))if(C=!0,g(y.charCodeAt(1))){let v=2,O=v;for(;v<S&&!g(y.charCodeAt(v));)v++;if(v<S&&v!==O){const L=y.slice(O,v);for(O=v;v<S&&g(y.charCodeAt(v));)v++;if(v<S&&v!==O){for(O=v;v<S&&!g(y.charCodeAt(v));)v++;(v===S||v!==O)&&(P=`\\\\${L}\\${y.slice(O,v)}`,D=v)}}}else D=1;else m(p)&&y.charCodeAt(1)===I&&(P=y.slice(0,2),D=2,S>2&&g(y.charCodeAt(2))&&(C=!0,D=3));if(P.length>0)if(s.length>0){if(P.toLowerCase()!==s.toLowerCase())continue}else s=P;if(a){if(s.length>0)break}else if(d=`${y.slice(D)}\\${d}`,a=C,C&&s.length>0)break}return d=n(d,!a,"\\",g),a?`${s}\\${d}`:`${s}${d}`||"."},normalize(t){b(t,"path");const s=t.length;if(s===0)return".";let d=0,a,w=!1;const y=t.charCodeAt(0);if(s===1)return f(y)?"\\":t;if(g(y))if(w=!0,g(t.charCodeAt(1))){let D=2,P=D;for(;D<s&&!g(t.charCodeAt(D));)D++;if(D<s&&D!==P){const C=t.slice(P,D);for(P=D;D<s&&g(t.charCodeAt(D));)D++;if(D<s&&D!==P){for(P=D;D<s&&!g(t.charCodeAt(D));)D++;if(D===s)return`\\\\${C}\\${t.slice(P)}\\`;D!==P&&(a=`\\\\${C}\\${t.slice(P,D)}`,d=D)}}}else d=1;else m(y)&&t.charCodeAt(1)===I&&(a=t.slice(0,2),d=2,s>2&&g(t.charCodeAt(2))&&(w=!0,d=3));let S=d<s?n(t.slice(d),!w,"\\",g):"";return S.length===0&&!w&&(S="."),S.length>0&&g(t.charCodeAt(s-1))&&(S+="\\"),a===void 0?w?`\\${S}`:S:w?`${a}\\${S}`:`${a}${S}`},isAbsolute(t){b(t,"path");const s=t.length;if(s===0)return!1;const d=t.charCodeAt(0);return g(d)||s>2&&m(d)&&t.charCodeAt(1)===I&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,d;for(let y=0;y<t.length;++y){const S=t[y];b(S,"path"),S.length>0&&(s===void 0?s=d=S:s+=`\\${S}`)}if(s===void 0)return".";let a=!0,w=0;if(typeof d=="string"&&g(d.charCodeAt(0))){++w;const y=d.length;y>1&&g(d.charCodeAt(1))&&(++w,y>2&&(g(d.charCodeAt(2))?++w:a=!1))}if(a){for(;w<s.length&&g(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return e.$gc.normalize(s)},relative(t,s){if(b(t,"from"),b(s,"to"),t===s)return"";const d=e.$gc.resolve(t),a=e.$gc.resolve(s);if(d===a||(t=d.toLowerCase(),s=a.toLowerCase(),t===s))return"";let w=0;for(;w<t.length&&t.charCodeAt(w)===l;)w++;let y=t.length;for(;y-1>w&&t.charCodeAt(y-1)===l;)y--;const S=y-w;let D=0;for(;D<s.length&&s.charCodeAt(D)===l;)D++;let P=s.length;for(;P-1>D&&s.charCodeAt(P-1)===l;)P--;const C=P-D,p=S<C?S:C;let v=-1,O=0;for(;O<p;O++){const F=t.charCodeAt(w+O);if(F!==s.charCodeAt(D+O))break;F===l&&(v=O)}if(O!==p){if(v===-1)return a}else{if(C>p){if(s.charCodeAt(D+O)===l)return a.slice(D+O+1);if(O===2)return a.slice(D+O)}S>p&&(t.charCodeAt(w+O)===l?v=O:O===2&&(v=3)),v===-1&&(v=0)}let L="";for(O=w+v+1;O<=y;++O)(O===y||t.charCodeAt(O)===l)&&(L+=L.length===0?"..":"\\..");return D+=v,L.length>0?`${L}${a.slice(D,P)}`:(a.charCodeAt(D)===l&&++D,a.slice(D,P))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$gc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const d=s.charCodeAt(2);if(d!==E&&d!==T)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===I&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return t},dirname(t){b(t,"path");const s=t.length;if(s===0)return".";let d=-1,a=0;const w=t.charCodeAt(0);if(s===1)return g(w)?t:".";if(g(w)){if(d=a=1,g(t.charCodeAt(1))){let D=2,P=D;for(;D<s&&!g(t.charCodeAt(D));)D++;if(D<s&&D!==P){for(P=D;D<s&&g(t.charCodeAt(D));)D++;if(D<s&&D!==P){for(P=D;D<s&&!g(t.charCodeAt(D));)D++;if(D===s)return t;D!==P&&(d=a=D+1)}}}}else m(w)&&t.charCodeAt(1)===I&&(d=s>2&&g(t.charCodeAt(2))?3:2,a=d);let y=-1,S=!0;for(let D=s-1;D>=a;--D)if(g(t.charCodeAt(D))){if(!S){y=D;break}}else S=!1;if(y===-1){if(d===-1)return".";y=d}return t.slice(0,y)},basename(t,s){s!==void 0&&b(s,"ext"),b(t,"path");let d=0,a=-1,w=!0,y;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(d=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let S=s.length-1,D=-1;for(y=t.length-1;y>=d;--y){const P=t.charCodeAt(y);if(g(P)){if(!w){d=y+1;break}}else D===-1&&(w=!1,D=y+1),S>=0&&(P===s.charCodeAt(S)?--S===-1&&(a=y):(S=-1,a=D))}return d===a?a=D:a===-1&&(a=t.length),t.slice(d,a)}for(y=t.length-1;y>=d;--y)if(g(t.charCodeAt(y))){if(!w){d=y+1;break}}else a===-1&&(w=!1,a=y+1);return a===-1?"":t.slice(d,a)},extname(t){b(t,"path");let s=0,d=-1,a=0,w=-1,y=!0,S=0;t.length>=2&&t.charCodeAt(1)===I&&m(t.charCodeAt(0))&&(s=a=2);for(let D=t.length-1;D>=s;--D){const P=t.charCodeAt(D);if(g(P)){if(!y){a=D+1;break}continue}w===-1&&(y=!1,w=D+1),P===T?d===-1?d=D:S!==1&&(S=1):d!==-1&&(S=-1)}return d===-1||w===-1||S===0||S===1&&d===w-1&&d===a+1?"":t.slice(d,w)},format:o.bind(null,"\\"),parse(t){b(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.length;let a=0,w=t.charCodeAt(0);if(d===1)return g(w)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(g(w)){if(a=1,g(t.charCodeAt(1))){let v=2,O=v;for(;v<d&&!g(t.charCodeAt(v));)v++;if(v<d&&v!==O){for(O=v;v<d&&g(t.charCodeAt(v));)v++;if(v<d&&v!==O){for(O=v;v<d&&!g(t.charCodeAt(v));)v++;v===d?a=v:v!==O&&(a=v+1)}}}}else if(m(w)&&t.charCodeAt(1)===I){if(d<=2)return s.root=s.dir=t,s;if(a=2,g(t.charCodeAt(2))){if(d===3)return s.root=s.dir=t,s;a=3}}a>0&&(s.root=t.slice(0,a));let y=-1,S=a,D=-1,P=!0,C=t.length-1,p=0;for(;C>=a;--C){if(w=t.charCodeAt(C),g(w)){if(!P){S=C+1;break}continue}D===-1&&(P=!1,D=C+1),w===T?y===-1?y=C:p!==1&&(p=1):y!==-1&&(p=-1)}return D!==-1&&(y===-1||p===0||p===1&&y===D-1&&y===S+1?s.base=s.name=t.slice(S,D):(s.name=t.slice(S,y),s.base=t.slice(S,D),s.ext=t.slice(y,D))),S>0&&S!==a?s.dir=t.slice(0,S-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(c){const t=/\\/g;return()=>{const s=r.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$hc={resolve(...t){let s="",d=!1;for(let a=t.length-1;a>=-1&&!d;a--){const w=a>=0?t[a]:i();b(w,"path"),w.length!==0&&(s=`${w}/${s}`,d=w.charCodeAt(0)===$)}return s=n(s,!d,"/",f),d?`/${s}`:s.length>0?s:"."},normalize(t){if(b(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!s,"/",f),t.length===0?s?"/":d?"./":".":(d&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return b(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let s;for(let d=0;d<t.length;++d){const a=t[d];b(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.$hc.normalize(s)},relative(t,s){if(b(t,"from"),b(s,"to"),t===s||(t=e.$hc.resolve(t),s=e.$hc.resolve(s),t===s))return"";const d=1,a=t.length,w=a-d,y=1,S=s.length-y,D=w<S?w:S;let P=-1,C=0;for(;C<D;C++){const v=t.charCodeAt(d+C);if(v!==s.charCodeAt(y+C))break;v===$&&(P=C)}if(C===D)if(S>D){if(s.charCodeAt(y+C)===$)return s.slice(y+C+1);if(C===0)return s.slice(y+C)}else w>D&&(t.charCodeAt(d+C)===$?P=C:C===0&&(P=0));let p="";for(C=d+P+1;C<=a;++C)(C===a||t.charCodeAt(C)===$)&&(p+=p.length===0?"..":"/..");return`${p}${s.slice(y+P)}`},toNamespacedPath(t){return t},dirname(t){if(b(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$;let d=-1,a=!0;for(let w=t.length-1;w>=1;--w)if(t.charCodeAt(w)===$){if(!a){d=w;break}}else a=!1;return d===-1?s?"/":".":s&&d===1?"//":t.slice(0,d)},basename(t,s){s!==void 0&&b(s,"ext"),b(t,"path");let d=0,a=-1,w=!0,y;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let S=s.length-1,D=-1;for(y=t.length-1;y>=0;--y){const P=t.charCodeAt(y);if(P===$){if(!w){d=y+1;break}}else D===-1&&(w=!1,D=y+1),S>=0&&(P===s.charCodeAt(S)?--S===-1&&(a=y):(S=-1,a=D))}return d===a?a=D:a===-1&&(a=t.length),t.slice(d,a)}for(y=t.length-1;y>=0;--y)if(t.charCodeAt(y)===$){if(!w){d=y+1;break}}else a===-1&&(w=!1,a=y+1);return a===-1?"":t.slice(d,a)},extname(t){b(t,"path");let s=-1,d=0,a=-1,w=!0,y=0;for(let S=t.length-1;S>=0;--S){const D=t.charCodeAt(S);if(D===$){if(!w){d=S+1;break}continue}a===-1&&(w=!1,a=S+1),D===T?s===-1?s=S:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||a===-1||y===0||y===1&&s===a-1&&s===d+1?"":t.slice(s,a)},format:o.bind(null,"/"),parse(t){b(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.charCodeAt(0)===$;let a;d?(s.root="/",a=1):a=0;let w=-1,y=0,S=-1,D=!0,P=t.length-1,C=0;for(;P>=a;--P){const p=t.charCodeAt(P);if(p===$){if(!D){y=P+1;break}continue}S===-1&&(D=!1,S=P+1),p===T?w===-1?w=P:C!==1&&(C=1):w!==-1&&(C=-1)}if(S!==-1){const p=y===0&&d?1:y;w===-1||C===0||C===1&&w===S-1&&w===y+1?s.base=s.name=t.slice(p,S):(s.name=t.slice(p,w),s.base=t.slice(p,S),s.ext=t.slice(w,S))}return y>0?s.dir=t.slice(0,y-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[140],Se([1,0,49,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=T,e.$ur=$,e.$vr=l,e.$wr=I,e.$xr=E,e.$yr=u,e.$zr=k,e.$Ar=b,e.$Br=c,e.$Cr=g,e.$Dr=w,e.$Er=y,e.$Fr=S;const A=new r.$W(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new r.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),N=new r.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(D,P,C=!1){const p=D||"",v=P||"",O=A.value.collator.compare(p,v);return A.value.collatorIsNumeric&&O===0&&p!==v?p<v?-1:1:O}function $(D,P){const C=R.value.collator;return D=D||"",P=P||"",o(C,D,P)}function l(D,P){const C=R.value.collator;return D=D||"",P=P||"",d(D,P)||o(C,D,P)}function I(D,P){const C=R.value.collator;return D=D||"",P=P||"",s(D,P)||o(C,D,P)}function E(D,P){return D=D||"",P=P||"",D===P?0:D<P?-1:1}function u(D,P){const[C,p]=m(D),[v,O]=m(P);let L=A.value.collator.compare(p,O);if(L===0){if(A.value.collatorIsNumeric&&p!==O)return p<O?-1:1;if(L=A.value.collator.compare(C,v),A.value.collatorIsNumeric&&L===0&&C!==v)return C<v?-1:1}return L}function k(D,P){D=D||"",P=P||"";const C=n(D),p=n(P),v=R.value.collator,O=N.value.collator;return o(O,C,p)||o(v,D,P)}function b(D,P){D=D||"",P=P||"";const C=n(D),p=n(P),v=R.value.collator,O=N.value.collator;return o(O,C,p)||d(D,P)||o(v,D,P)}function c(D,P){D=D||"",P=P||"";const C=n(D),p=n(P),v=R.value.collator,O=N.value.collator;return o(O,C,p)||s(D,P)||o(v,D,P)}function g(D,P){D=D||"",P=P||"";const C=n(D).toLowerCase(),p=n(P).toLowerCase();return C!==p?C<p?-1:1:D!==P?D<P?-1:1:0}const f=/^(.*?)(\.([^.]*))?$/;function m(D,P=!1){const C=D?f.exec(D):[];let p=[C&&C[1]||"",C&&C[3]||""];return P&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function n(D){const P=D?f.exec(D):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function o(D,P,C){const p=D.compare(P,C);return p!==0?p:P.length!==C.length?P.length<C.length?-1:1:0}function i(D){const P=D.charAt(0);return P.toLocaleUpperCase()!==P}function t(D){const P=D.charAt(0);return P.toLocaleLowerCase()!==P}function s(D,P){return i(D)&&t(P)?-1:t(D)&&i(P)?1:0}function d(D,P){return t(D)&&i(P)?-1:i(D)&&t(P)?1:0}function a(D,P,C=!1){return C||(D=D&&D.toLowerCase(),P=P&&P.toLowerCase()),D===P?0:D<P?-1:1}function w(D,P,C=!1){const p=D.split(h.sep),v=P.split(h.sep),O=p.length-1,L=v.length-1;let F,j;for(let B=0;;B++){if(F=O===B,j=L===B,F&&j)return T(p[B],v[B],C);if(F)return-1;if(j)return 1;const M=a(p[B],v[B],C);if(M!==0)return M}}function y(D,P,C){const p=D.toLowerCase(),v=P.toLowerCase(),O=S(D,P,C);if(O)return O;const L=p.endsWith(C),F=v.endsWith(C);if(L!==F)return L?-1:1;const j=T(p,v);return j!==0?j:p.localeCompare(v)}function S(D,P,C){const p=D.toLowerCase(),v=P.toLowerCase(),O=p.startsWith(C),L=v.startsWith(C);if(O!==L)return O?-1:1;if(O&&L){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(Ee[33],Se([1,0,27,16,11,13,18]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=T,e.$xg=$,e.$yg=l,e.$zg=I,e.$Ag=E,e.$Bg=c,e.$Cg=g,e.$Dg=f,e.$Eg=m,e.$Fg=n,e.$Gg=o,e.$Hg=i,e.$Ig=t,e.$Jg=s,e.$Kg=d,e.$Lg=a,e.$Mg=S;function T(D){return D===r.CharCode.Slash||D===r.CharCode.Backslash}function $(D){return D.replace(/[\\/]/g,h.$hc.sep)}function l(D){return D.indexOf("/")===-1&&(D=$(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function I(D,P=h.$hc.sep){if(!D)return"";const C=D.length,p=D.charCodeAt(0);if(T(p)){if(T(D.charCodeAt(1))&&!T(D.charCodeAt(2))){let O=3;const L=O;for(;O<C&&!T(D.charCodeAt(O));O++);if(L!==O&&!T(D.charCodeAt(O+1))){for(O+=1;O<C;O++)if(T(D.charCodeAt(O)))return D.slice(0,O+1).replace(/[\\/]/g,P)}}return P}else if(m(p)&&D.charCodeAt(1)===r.CharCode.Colon)return T(D.charCodeAt(2))?D.slice(0,2)+P:D.slice(0,2);let v=D.indexOf("://");if(v!==-1){for(v+=3;v<C;v++)if(T(D.charCodeAt(v)))return D.slice(0,v+1)}return""}function E(D){if(!A.$i||!D||D.length<5)return!1;let P=D.charCodeAt(0);if(P!==r.CharCode.Backslash||(P=D.charCodeAt(1),P!==r.CharCode.Backslash))return!1;let C=2;const p=C;for(;C<D.length&&(P=D.charCodeAt(C),P!==r.CharCode.Backslash);C++);return!(p===C||(P=D.charCodeAt(C+1),isNaN(P)||P===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,k=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(D,P=A.$i){const C=P?u:k;return!(!D||D.length===0||/^\s+$/.test(D)||(C.lastIndex=0,C.test(D))||P&&b.test(D)||D==="."||D===".."||P&&D[D.length-1]==="."||P&&D.length!==D.trim().length||D.length>255)}function g(D,P,C){const p=D===P;return!C||p?p:!D||!P?!1:(0,R.$Ff)(D,P)}function f(D,P,C,p=h.sep){if(D===P)return!0;if(!D||!P||P.length>D.length)return!1;if(C){if(!(0,R.$Gf)(D,P))return!1;if(P.length===D.length)return!0;let O=P.length;return P.charAt(P.length-1)===p&&O--,D.charAt(O)===p}return P.charAt(P.length-1)!==p&&(P+=p),D.indexOf(P)===0}function m(D){return D>=r.CharCode.A&&D<=r.CharCode.Z||D>=r.CharCode.a&&D<=r.CharCode.z}function n(D,P){return A.$i&&D.endsWith(":")&&(D+=h.sep),(0,h.$jc)(D)||(D=(0,h.$kc)(P,D)),D=(0,h.$ic)(D),o(D)}function o(D){return A.$i?(D=(0,R.$nf)(D,h.sep),D.endsWith(":")&&(D+=h.sep)):(D=(0,R.$nf)(D,h.sep),D||(D=h.sep)),D}function i(D){const P=(0,h.$ic)(D);return A.$i?D.length>3?!1:t(P)&&(D.length===2||P.charCodeAt(2)===r.CharCode.Backslash):P===h.$hc.sep}function t(D,P=A.$i){return P?m(D.charCodeAt(0))&&D.charCodeAt(1)===r.CharCode.Colon:!1}function s(D,P=A.$i){return t(D,P)?D[0]:void 0}function d(D,P,C){return P.length>D.length?-1:D===P?0:(C&&(D=D.toLowerCase(),P=P.toLowerCase()),D.indexOf(P))}function a(D){const P=D.split(":");let C,p,v;for(const O of P){const L=Number(O);(0,N.$ig)(L)?p===void 0?p=L:v===void 0&&(v=L):C=C?[C,O].join(":"):O}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(D,P,C=8){let p="";for(let O=0;O<C;O++){let L;O===0&&A.$i&&!P&&(C===3||C===4)?L=y:L=w,p+=L.charAt(Math.floor(Math.random()*L.length))}let v;return P?v=`${P}-${p}`:v=p,D?(0,h.$kc)(D,v):v}}),define(Ee[141],Se([1,0,27,140,135,60,16,11,13]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=E,e.$Hr=f,e.$Ir=a,e.$Jr=p,e.$Kr=B,e.$Lr=z;const l=0,I=[l,[]];function E(_,re,U,G){if(!_||!re)return I;const K=_.length,ee=re.length;if(K<ee)return I;const ue=_.toLowerCase();return u(re,U,ee,_,ue,K,G)}function u(_,re,U,G,K,ee,ue){const ne=[],De=[];for(let se=0;se<U;se++){const oe=se*ee,te=oe-ee,le=se>0,he=_[se],Z=re[se];for(let ae=0;ae<ee;ae++){const pe=ae>0,be=oe+ae,Me=be-1,ze=te+ae-1,ke=pe?ne[Me]:0,Ie=le&&pe?ne[ze]:0,Te=le&&pe?De[ze]:0;let V;!Ie&&le?V=0:V=k(he,Z,G,K,ae,Te),V&&Ie+V>=ke&&(ue||le||K.startsWith(re,ae))?(De[be]=Te+1,ne[be]=Ie+V):(De[be]=l,ne[be]=ke)}}const $e=[];let J=U-1,W=ee-1;for(;J>=0&&W>=0;){const se=J*ee+W;De[se]===l||($e.push(W),J--),W--}return[ne[U*ee-1],$e.reverse()]}function k(_,re,U,G,K,ee){let ue=0;if(!b(re,G[K]))return ue;if(ue+=1,ee>0&&(ue+=ee*5),_===U[K]&&(ue+=1),K===0)ue+=8;else{const ne=c(U.charCodeAt(K-1));ne?ue+=ne:(0,A.$Jk)(U.charCodeAt(K))&&ee===0&&(ue+=2)}return ue}function b(_,re){return _===re?!0:_==="/"||_==="\\"?re==="/"||re==="\\":!1}function c(_){switch(_){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const g=[void 0,[]];function f(_,re,U=0,G=0){const K=re;return K.values&&K.values.length>1?m(_,K.values,U,G):n(_,re,U,G)}function m(_,re,U,G){let K=0;const ee=[];for(const ue of re){const[ne,De]=n(_,ue,U,G);if(typeof ne!="number")return g;K+=ne,ee.push(...De)}return[K,P(ee)]}function n(_,re,U,G){const K=(0,A.$Sk)(re.original,re.originalLowercase,U,_,_.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?[K[0],(0,A.$Pk)(K)]:g}const o=Object.freeze({score:0}),i=1<<18,t=1<<17,s=65536;function d(_,re,U,G){const K=G.values?G.values:[G];return(0,R.$sj)({[G.normalized]:{values:K.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:_,description:re,allowNonContiguousMatches:U}})}function a(_,re,U,G,K){if(!_||!re.normalized)return o;const ee=G.getItemLabel(_);if(!ee)return o;const ue=G.getItemDescription(_),ne=d(ee,ue,U,re),De=K[ne];if(De)return De;const $e=w(ee,ue,G.getItemPath(_),re,U);return K[ne]=$e,$e}function w(_,re,U,G,K){const ee=!U||!G.containsPathSeparator;return U&&(T.$k?G.pathNormalized===U:(0,$.$Ff)(G.pathNormalized,U))?{score:i,labelMatch:[{start:0,end:_.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:G.values&&G.values.length>1?y(_,re,U,G.values,ee,K):S(_,re,U,G,ee,K)}function y(_,re,U,G,K,ee){let ue=0;const ne=[],De=[];for(const $e of G){const{score:J,labelMatch:W,descriptionMatch:se}=S(_,re,U,$e,K,ee);if(J===l)return o;ue+=J,W&&ne.push(...W),se&&De.push(...se)}return{score:ue,labelMatch:P(ne),descriptionMatch:P(De)}}function S(_,re,U,G,K,ee){if(K||!re){const[ue,ne]=E(_,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(ue){const De=(0,A.$Gk)(G.normalized,_);let $e;if(De){$e=t;const J=Math.round(G.normalized.length/_.length*100);$e+=J}else $e=s;return{score:$e+ue,labelMatch:De||D(ne)}}}if(re){let ue=re;U&&(ue=`${re}${N.sep}`);const ne=ue.length,De=`${ue}${_}`,[$e,J]=E(De,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const W=D(J),se=[],oe=[];return W.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),oe.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):oe.push(te)}),{score:$e,labelMatch:se,descriptionMatch:oe}}}return o}function D(_){const re=[];if(!_)return re;let U;for(const G of _)U&&U.end===G?U.end+=1:(U={start:G,end:G+1},re.push(U));return re}function P(_){const re=_.sort((K,ee)=>K.start-ee.start),U=[];let G;for(const K of re)!G||!C(G,K)?(G=K,U.push(K)):(G.start=Math.min(G.start,K.start),G.end=Math.max(G.end,K.end));return U}function C(_,re){return!(_.end<re.start||re.end<_.start)}function p(_,re,U,G,K,ee){const ue=a(_,U,G,K,ee),ne=a(re,U,G,K,ee),De=ue.score,$e=ne.score;if((De===i||$e===i)&&De!==$e)return De===i?-1:1;if(De>s||$e>s){if(De!==$e)return De>$e?-1:1;if(De<t&&$e<t){const he=O(ue.labelMatch,ne.labelMatch);if(he!==0)return he}const te=K.getItemLabel(_)||"",le=K.getItemLabel(re)||"";if(te.length!==le.length)return te.length-le.length}if(De!==$e)return De>$e?-1:1;const J=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(J&&!W)return-1;if(W&&!J)return 1;const se=v(_,ue,K),oe=v(re,ne,K);return se&&oe&&se!==oe?oe>se?-1:1:L(_,re,U,K)}function v(_,re,U){let G=-1,K=-1;if(re.descriptionMatch&&re.descriptionMatch.length?G=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(G=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(K=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=U.getItemDescription(_);ee&&(K+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(K=re.descriptionMatch[re.descriptionMatch.length-1].end);return K-G}function O(_,re){if(!_&&!re||(!_||!_.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!_||!_.length)return 1;const U=_[0].start,K=_[_.length-1].end-U,ee=re[0].start,ne=re[re.length-1].end-ee;return K===ne?0:ne<K?1:-1}function L(_,re,U,G){const K=G.getItemLabel(_)||"",ee=G.getItemLabel(re)||"",ue=G.getItemDescription(_),ne=G.getItemDescription(re),De=K.length+(ue?ue.length:0),$e=ee.length+(ne?ne.length:0);if(De!==$e)return De-$e;const J=G.getItemPath(_),W=G.getItemPath(re);return J&&W&&J.length!==W.length?J.length-W.length:K!==ee?(0,h.$Er)(K,ee,U.normalized):ue&&ne&&ue!==ne?(0,h.$Er)(ue,ne,U.normalized):J&&W&&J!==W?(0,h.$Er)(J,W,U.normalized):0}function F(_){return _.startsWith('"')&&_.endsWith('"')}const j=" ";function B(_){typeof _!="string"&&(_="");const re=_.toLowerCase(),{pathNormalized:U,normalized:G,normalizedLowercase:K}=M(_),ee=U.indexOf(N.sep)>=0,ue=F(_);let ne;const De=_.split(j);if(De.length>1)for(const $e of De){const J=F($e),{pathNormalized:W,normalized:se,normalizedLowercase:oe}=M($e);se&&(ne||(ne=[]),ne.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:oe,expectContiguousMatch:J}))}return{original:_,originalLowercase:re,pathNormalized:U,normalized:G,normalizedLowercase:K,values:ne,containsPathSeparator:ee,expectContiguousMatch:ue}}function M(_){let re;T.$i?re=_.replace(/\//g,N.sep):re=_.replace(/\\/g,N.sep);const U=(0,$.$pf)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:U,normalizedLowercase:U.toLowerCase()}}function z(_){return Array.isArray(_)?B(_.map(re=>re.original).join(j)):B(_.original)}}),define(Ee[108],Se([1,0,16]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$5s=R,e.$6s=N,e.$7s=T,e.$8s=l,e.$4s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const E=(0,r.$pc)(I),u=h[E.toLowerCase()];return u!==void 0?u:N(I)}function N(I){const E=(0,r.$pc)(I);return A[E.toLowerCase()]}function T(I){for(const E in A)if(A[E]===I)return E}const $=/^(.+)\/(.+?)(;.+)?$/;function l(I,E){const u=$.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:I}}),define(Ee[109],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=R,e.$km=N;var h;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(h||(e.Source=h={}));var A;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R(T,...$){const l=$.reduce((u,k)=>(u[k]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(u=>!l[u]).forEach(u=>{for(let k=0;k<I.length;k++)if(u.search(I[k])!==-1){delete T[u];break}})}function N(T){T&&(delete T.DEBUG,r.$j&&delete T.DYLD_LIBRARY_PATH,r.$k&&delete T.LD_PRELOAD)}}),define(Ee[2],Se([1,0,27,41,16,11]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=g,e.$xc=t,A=We(A);const N=/^\w[\w\d+.-]*$/,T=/^\//,$=/^\/\//;function l(y,S){if(!y.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!N.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!T.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,S){return!y&&!S?"file":y}function E(y,S){switch(y){case"https":case"http":case"file":S?S[0]!==k&&(S=k+S):S=k;break}return S}const u="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(S){return S instanceof c?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,D,P,C,p,v=!1){typeof S=="object"?(this.scheme=S.scheme||u,this.authority=S.authority||u,this.path=S.path||u,this.query=S.query||u,this.fragment=S.fragment||u):(this.scheme=I(S,v),this.authority=D||u,this.path=E(this.scheme,P||u),this.query=C||u,this.fragment=p||u,l(this,v))}get fsPath(){return t(this,!1)}with(S){if(!S)return this;let{scheme:D,authority:P,path:C,query:p,fragment:v}=S;return D===void 0?D=this.scheme:D===null&&(D=u),P===void 0?P=this.authority:P===null&&(P=u),C===void 0?C=this.path:C===null&&(C=u),p===void 0?p=this.query:p===null&&(p=u),v===void 0?v=this.fragment:v===null&&(v=u),D===this.scheme&&P===this.authority&&C===this.path&&p===this.query&&v===this.fragment?this:new m(D,P,C,p,v)}static parse(S,D=!1){const P=b.exec(S);return P?new m(P[2]||u,w(P[4]||u),w(P[5]||u),w(P[7]||u),w(P[9]||u),D):new m(u,u,u,u,u)}static file(S){let D=u;if(R.$i&&(S=S.replace(/\\/g,k)),S[0]===k&&S[1]===k){const P=S.indexOf(k,2);P===-1?(D=S.substring(2),S=k):(D=S.substring(2,P),S=S.substring(P)||k)}return new m("file",D,S,u,u)}static from(S,D){return new m(S.scheme,S.authority,S.path,S.query,S.fragment,D)}static joinPath(S,...D){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return R.$i&&S.scheme==="file"?P=c.file(A.$gc.join(t(S,!0),...D)).path:P=A.$hc.join(S.path,...D),S.with({path:P})}toString(S=!1){return s(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof c)return S;{const D=new m(S);return D._formatted=S.external??null,D._fsPath=S._sep===f?S.fsPath??null:null,D}}else return S}}e.URI=c;function g(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const f=R.$i?1:void 0;class m extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(S=!1){return S?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const S={$mid:h.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=f),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(y,S,D){let P,C=-1;for(let p=0;p<y.length;p++){const v=y.charCodeAt(p);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||S&&v===r.CharCode.Slash||D&&v===r.CharCode.OpenSquareBracket||D&&v===r.CharCode.CloseSquareBracket||D&&v===r.CharCode.Colon)C!==-1&&(P+=encodeURIComponent(y.substring(C,p)),C=-1),P!==void 0&&(P+=y.charAt(p));else{P===void 0&&(P=y.substr(0,p));const O=n[v];O!==void 0?(C!==-1&&(P+=encodeURIComponent(y.substring(C,p)),C=-1),P+=O):C===-1&&(C=p)}}return C!==-1&&(P+=encodeURIComponent(y.substring(C))),P!==void 0?P:y}function i(y){let S;for(let D=0;D<y.length;D++){const P=y.charCodeAt(D);P===r.CharCode.Hash||P===r.CharCode.QuestionMark?(S===void 0&&(S=y.substr(0,D)),S+=n[P]):S!==void 0&&(S+=y[D])}return S!==void 0?S:y}function t(y,S){let D;return y.authority&&y.path.length>1&&y.scheme==="file"?D=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===r.CharCode.Slash&&(y.path.charCodeAt(1)>=r.CharCode.A&&y.path.charCodeAt(1)<=r.CharCode.Z||y.path.charCodeAt(1)>=r.CharCode.a&&y.path.charCodeAt(1)<=r.CharCode.z)&&y.path.charCodeAt(2)===r.CharCode.Colon?S?D=y.path.substr(1):D=y.path[1].toLowerCase()+y.path.substr(2):D=y.path,R.$i&&(D=D.replace(/\//g,"\\")),D}function s(y,S){const D=S?i:o;let P="",{scheme:C,authority:p,path:v,query:O,fragment:L}=y;if(C&&(P+=C,P+=":"),(p||C==="file")&&(P+=k,P+=k),p){let F=p.indexOf("@");if(F!==-1){const j=p.substr(0,F);p=p.substr(F+1),F=j.lastIndexOf(":"),F===-1?P+=D(j,!1,!1):(P+=D(j.substr(0,F),!1,!1),P+=":",P+=D(j.substr(F+1),!1,!0)),P+="@"}p=p.toLowerCase(),F=p.lastIndexOf(":"),F===-1?P+=D(p,!1,!0):(P+=D(p.substr(0,F),!1,!0),P+=p.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const F=v.charCodeAt(1);F>=r.CharCode.A&&F<=r.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const F=v.charCodeAt(0);F>=r.CharCode.A&&F<=r.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}P+=D(v,!0,!1)}return O&&(P+="?",P+=D(O,!1,!1)),L&&(P+="#",P+=S?L:o(L,!1,!1)),P}function d(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+d(y.substr(3)):y}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(y){return y.match(a)?y.replace(a,S=>d(S)):y}}),define(Ee[206],Se([1,0,2]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=h,e.$0q=A,e.$$q=R,e.log=T;function h(l){const I=l;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function A(l){const I=[];let E;try{const u=JSON.parse(l.arguments),k=u[u.length-1];k&&k.__$stack&&(u.pop(),E=k.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",l.arguments)}return{args:I,stack:E}}function R(l){if(typeof l!="string")return R(A(l).stack);const I=l;if(I){const E=N(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function N(l){if(!l)return l;const I=l.indexOf(`
`);return I===-1?l:l.substring(0,I)}function T(l,I){const{args:E,stack:u}=A(l),k=typeof E[0]=="string"&&E.length===1;let b=N(u);b&&(b=`(${b.trim()})`);let c=[];if(typeof E[0]=="string"?b&&k?c=[`%c[${I}] %c${E[0]} %c${b}`,$("blue"),$(""),$("grey")]:c=[`%c[${I}] %c${E[0]}`,$("blue"),$(""),...E.slice(1)]:c=[`%c[${I}]%`,$("blue"),...E],b&&!k&&c.push(b),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,c)}function $(l){return`color: ${l}`}}),define(Ee[57],Se([1,0,22,2,41]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=R,e.$ai=N,e.$bi=$;function R(l){return JSON.stringify(l,T)}function N(l){let I=JSON.parse(l);return I=$(I),I}function T(l,I){return I instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function $(l,I=0){if(!l||I>200)return l;if(typeof l=="object"){switch(l.$mid){case A.MarshalledId.Uri:return h.URI.revive(l);case A.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case A.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.$Ne||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let E=0;E<l.length;++E)l[E]=$(l[E],I+1);else for(const E in l)Object.hasOwnProperty.call(l,E)&&(l[E]=$(l[E],I+1))}return l}}),define(Ee[15],Se([1,0,14,11,13,2,16]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=$,e.$Og=l,e.$Sg=E,r=We(r),h=We(h),N=We(N);var T;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(b,c){return R.URI.isUri(b)?(0,A.$Ff)(b.scheme,c):(0,A.$Gf)(b,c+":")}function l(b,...c){return c.some(g=>$(b,g))}e.$Pg="vscode-tkn",e.$Qg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=E(c,g)}getServerRootPath(){return this.f}get g(){return N.$hc.join(this.f,T.vscodeRemoteResource)}set(c,g,f){this.a[c]=g,this.b[c]=f}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(i){return r.$2(i),c}const g=c.authority;let f=this.a[g];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const m=this.b[g],n=this.c[g];let o=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(o+=`&${e.$Qg}=${encodeURIComponent(n)}`),R.URI.from({scheme:h.$o?this.d:T.vscodeRemoteResource,authority:`${f}:${m}`,path:this.g,query:o})}}e.$Rg=new I;function E(b,c){return N.$hc.join(c??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class u{static{this.a=e.$Xg}asBrowserUri(c){const g=this.b(c,ce);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===T.vscodeRemote?e.$Rg.rewrite(c):c.scheme===T.file&&(h.$m||h.$q===`${T.vscodeFileResource}://${u.a}`)?c.with({scheme:T.vscodeFileResource,authority:c.authority||u.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,ce);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===T.vscodeFileResource?c.with({scheme:T.file,authority:c.authority!==u.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return R.URI.isUri(c)?c:R.URI.parse(g.toUrl(c))}}e.$Yg=new u;var k;(function(b){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function f(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:R.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const i=o?.get(g);if(i)return c.get(i)}b.getHeadersFromQuery=f;function m(n,o,i){if(!globalThis.crossOriginIsolated)return;const t=o&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(g,t):n[g]=t}b.addSearchParam=m})(k||(e.COI=k={}))}),define(Ee[207],Se([1,0,173,15,11,2]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=I,A=We(A);class N{constructor(u,k,b){this.id=u,this.dependencies=k,this.callback=b}}class T{static{this.INSTANCE=new T}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,k,b)=>{typeof u!="string"&&(b=k,k=u,u=null),(typeof k!="object"||!Array.isArray(k))&&(b=k,k=null),this.c.push(new N(u,k,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const k=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!k)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(u){return new Promise((k,b)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",f),c.removeEventListener("error",m)},f=n=>{g(),k(this.c.pop())},m=n=>{g(),b(n)};c.addEventListener("load",f),c.addEventListener("error",m),this.f&&(u=this.f.createScriptURL(u)),c.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(u){return new Promise((k,b)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),k(this.c.pop())}catch(c){b(c)}})}async j(u){try{const k=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse(u).fsPath,f=k.readFileSync(g).toString(),m=c.wrap(f.replace(/^#!.*/,""));return new b.Script(m).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const $=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function I(E,u,k){if(r.$U){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[E]&&(E=l[E]);const b=`${E}/${u}`;if($.has(b))return $.get(b);let c;if(/^\w[\w\d+.-]*:\/\//.test(b))c=b;else{const n=`${k&&!A.$o?h.$Vg:h.$Ug}/${b}`;c=h.$Yg.asBrowserUri(n).toString(!0)}const g=T.INSTANCE.load(c);return $.set(b,g),g}else return await new Promise((b,c)=>{ce([E],b,c)}).then(We)}}),define(Ee[23],Se([1,0,27,33,15,16,11,13,2]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=l,e.$oh=E,e.$ph=k,h=We(h),R=We(R);function l(b){return(0,$.$xc)(b,!0)}class I{constructor(c){this.a=c}compare(c,g,f=!1){return c===g?0:(0,T.$yf)(this.getComparisonKey(c,f),this.getComparisonKey(g,f))}isEqual(c,g,f=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,f)===this.getComparisonKey(g,f)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,f=!1){if(c.scheme===g.scheme){if(c.scheme===A.Schemas.file)return h.$Dg(l(c),l(g),this.a(c))&&c.query===g.query&&(f||c.fragment===g.fragment);if((0,e.$kh)(c.authority,g.authority))return h.$Dg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(f||c.fragment===g.fragment)}return!1}joinPath(c,...g){return $.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$ch)(c)||c.authority}basename(c){return R.$hc.basename(c.path)}extname(c){return R.$hc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===A.Schemas.file?g=$.URI.file(R.$nc(l(c))).path:(g=R.$hc.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===A.Schemas.file?g=$.URI.file(R.$ic(l(c))).path:g=R.$hc.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$kh)(c.authority,g.authority))return;if(c.scheme===A.Schemas.file){const n=R.$mc(l(c),l(g));return N.$i?h.$xg(n):n}let f=c.path||"/";const m=g.path||"/";if(this.a(c)){let n=0;for(const o=Math.min(f.length,m.length);n<o&&!(f.charCodeAt(n)!==m.charCodeAt(n)&&f.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);f=m.substr(0,n)+f.substr(n)}return R.$hc.relative(f,m)}resolvePath(c,g){if(c.scheme===A.Schemas.file){const f=$.URI.file(R.$lc(l(c),g));return c.with({authority:f.authority,path:f.path})}return g=h.$yg(g),c.with({path:R.$hc.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,T.$Ff)(c,g)}hasTrailingPathSeparator(c,g=R.sep){if(c.scheme===A.Schemas.file){const f=l(c);return f.length>h.$zg(f).length&&f[f.length-1]===g}else{const f=c.path;return f.length>1&&f.charCodeAt(f.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=R.sep){return(0,e.$lh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=R.sep){let f=!1;if(c.scheme===A.Schemas.file){const m=l(c);f=m!==void 0&&m.length===h.$zg(m).length&&m[m.length-1]===g}else{g="/";const m=c.path;f=m.length===1&&m.charCodeAt(m.length-1)===r.CharCode.Slash}return!f&&!(0,e.$lh)(c,g)?c.with({path:c.path+"/"}):c}}e.$7g=I,e.$8g=new I(()=>!1),e.$9g=new I(b=>b.scheme===A.Schemas.file?!N.$k:!0),e.$0g=new I(b=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function E(b,c){const g=[];for(let f=0;f<b.length;f++){const m=c(b[f]);b.some((n,o)=>o===f?!1:(0,e.$_g)(m,c(n)))||g.push(b[f])}return g}var u;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function c(g){const f=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[i,t]=o.split(":");i&&t&&f.set(i,t)});const n=g.path.substring(0,g.path.indexOf(";"));return n&&f.set(b.META_DATA_MIME,n),f}b.parseMetaData=c})(u||(e.DataUri=u={}));function k(b,c,g){if(c){let f=b.path;return f&&f[0]!==R.$hc.sep&&(f=R.$hc.sep+f),b.with({scheme:g,authority:c,path:f})}return b.with({scheme:g})}}),define(Ee[9],Se([1,0,21,14,4,3,23,11,184,49]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=I,e.$rh=E,e.$sh=u,e.$th=k,e.$uh=b,e.$vh=c,e.$wh=g,e.$xh=f,e.$Fh=y,e.$Gh=S,e.$Hh=D,e.$Ih=P,e.$Jh=C,e.$Yh=G,e.$7h=te;function I(he){return!!he&&typeof he.then=="function"}function E(he){const Z=new r.$we,ae=he(Z.token),pe=new Promise((be,Me)=>{const ze=Z.token.onCancellationRequested(()=>{ze.dispose(),Me(new h.$6)});Promise.resolve(ae).then(ke=>{ze.dispose(),Z.dispose(),be(ke)},ke=>{ze.dispose(),Z.dispose(),Me(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(be,Me){return pe.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return pe.finally(be)}}}function u(he,Z,ae){return new Promise((pe,be)=>{const Me=Z.onCancellationRequested(()=>{Me.dispose(),pe(ae)});he.then(pe,be).finally(()=>Me.dispose())})}function k(he,Z){return new Promise((ae,pe)=>{const be=Z.onCancellationRequested(()=>{be.dispose(),pe(new h.$6)});he.then(ae,pe).finally(()=>be.dispose())})}async function b(he){let Z=-1;const ae=he.map((pe,be)=>pe.then(Me=>(Z=be,Me)));try{return await Promise.race(ae)}finally{he.forEach((pe,be)=>{be!==Z&&pe.cancel()})}}function c(he,Z,ae){let pe;const be=setTimeout(()=>{pe?.(void 0),ae?.()},Z);return Promise.race([he.finally(()=>clearTimeout(be)),new Promise(Me=>pe=Me)])}function g(he){return new Promise((Z,ae)=>{const pe=he();I(pe)?pe.then(Z,ae):Z(pe)})}function f(){let he,Z;return{promise:new Promise((pe,be)=>{he=pe,Z=be}),resolve:he,reject:Z}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ae=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(ae,ae).then(pe)})}return new Promise((ae,pe)=>{this.b.then(ae,pe)})}return this.a=Z(),new Promise((ae,pe)=>{this.a.then(be=>{this.a=null,ae(be)},be=>{this.a=null,pe(be)})})}dispose(){this.f=!0}}e.$yh=m;class n{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$zh=n;class o{constructor(){this.a=new Map}queue(Z,ae){const be=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Z)===be&&this.a.delete(Z)});return this.a.set(Z,be),be}}e.$Ah=o;const i=(he,Z)=>{let ae=!0;const pe=setTimeout(()=>{ae=!1,Z()},he);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(pe),ae=!1}}},t=he=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,he())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class s{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ae=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((be,Me)=>{this.d=be,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=ae===$.$ge?t(pe):i(ae,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=s;class d{constructor(Z){this.a=new s(Z),this.b=new m}trigger(Z,ae){return this.a.trigger(()=>this.b.queue(Z),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=d;class a{constructor(){this.a=!1,this.b=new Promise((Z,ae)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=a;class w extends a{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Eh=w;function y(he,Z){return Z?new Promise((ae,pe)=>{const be=setTimeout(()=>{Me.dispose(),ae()},he),Me=Z.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),pe(new h.$6)})}):E(ae=>y(he,ae))}function S(he,Z=0,ae){const pe=setTimeout(()=>{he(),ae&&be.dispose()},Z),be=(0,R.$Tc)(()=>{clearTimeout(pe),ae?.deleteAndLeak(be)});return ae?.add(be),be}function D(he){const Z=[];let ae=0;const pe=he.length;function be(){return ae<pe?he[ae++]():null}function Me(ze){ze!=null&&Z.push(ze);const ke=be();return ke?ke.then(Me):Promise.resolve(Z)}return Promise.resolve(null).then(Me)}function P(he,Z=pe=>!!pe,ae=null){let pe=0;const be=he.length,Me=()=>{if(pe>=be)return Promise.resolve(ae);const ze=he[pe++];return Promise.resolve(ze()).then(Ie=>Z(Ie)?Promise.resolve(Ie):Me())};return Me()}function C(he,Z=pe=>!!pe,ae=null){if(he.length===0)return Promise.resolve(ae);let pe=he.length;const be=()=>{pe=-1;for(const Me of he)Me.cancel?.()};return new Promise((Me,ze)=>{for(const ke of he)ke.then(Ie=>{--pe>=0&&Z(Ie)?(be(),Me(Ie)):pe===0&&Me(ae)}).catch(Ie=>{--pe>=0&&(be(),ze(Ie))})})}class p{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new A.$le}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,pe)=>{this.g.push({factory:Z,c:ae,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ae=Z.factory();ae.then(Z.c,Z.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=p;class v extends p{constructor(){super(1)}}e.$Lh=v;class O{constructor(){this.a=new K,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Mh=O;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new ne;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ae=N.$8g){const pe=ae.getComparisonKey(Z);return this.a.get(pe)?.size??0}queueFor(Z,ae,pe=N.$8g){const be=pe.getComparisonKey(Z);let Me=this.a.get(be);if(!Me){Me=new v;const ze=this.f++,ke=A.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(ze,ke),this.a.set(be,Me)}return Me.queue(ae)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=L;class F{constructor(Z,ae){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ae=="number"&&this.setIfNotSet(Z,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ae){if(this.b)throw new h.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ae)}setIfNotSet(Z,ae){if(this.b)throw new h.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ae))}}e.$Oh=F;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ae,pe=globalThis){if(this.f)throw new h.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=pe.setInterval(()=>{Z()},ae);this.d=(0,R.$Tc)(()=>{pe.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=j;class B{constructor(Z,ae){this.b=-1,this.a=Z,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=B;class M{constructor(Z,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=M;class z extends B{constructor(Z,ae){super(Z,ae),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Sh=z;class _ extends R.$Vc{constructor(Z,ae){super(),this.g=Z,this.h=ae,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Z)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(he,Z)=>{(0,T.$B)(()=>{if(ae)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Vh=(he,Z,ae)=>{const pe=he.requestIdleCallback(Z,typeof ae=="number"?{timeout:ae}:void 0);let be=!1;return{dispose(){be||(be=!0,he.cancelIdleCallback(pe))}}},e.$Uh=he=>(0,e.$Vh)(globalThis,he)}();class re{constructor(Z,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Vh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=re;class U extends re{constructor(Z){super(globalThis,Z)}}e.$Xh=U;async function G(he,Z,ae){let pe;for(let be=0;be<ae;be++)try{return await he()}catch(Me){pe=Me,await y(Z)}throw pe}class K{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ae,pe){return this.a={taskId:Z,cancel:()=>pe?.(),promise:ae},ae.then(()=>this.d(Z),()=>this.d(Z)),ae}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ae,resolve:pe,reject:be}=f();this.b={run:Z,promise:ae,promiseResolve:pe,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=K;class ee{constructor(Z,ae=()=>Date.now()){this.d=Z,this.f=ae,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$1h=ee;var ue;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ue||(ue={}));class ne{get isRejected(){return this.d?.outcome===ue.Rejected}get isResolved(){return this.d?.outcome===ue.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ue.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ae)=>{this.a=Z,this.b=ae})}complete(Z){return new Promise(ae=>{this.a(Z),this.d={outcome:ue.Resolved,value:Z},ae()})}error(Z){return new Promise(ae=>{this.b(Z),this.d={outcome:ue.Rejected,value:Z},ae()})}cancel(){return this.error(new h.$6)}}e.$2h=ne;var De;(function(he){async function Z(pe){let be;const Me=await Promise.all(pe.map(ze=>ze.then(ke=>ke,ke=>{be||(be=ke)})));if(typeof be<"u")throw be;return Me}he.settled=Z;function ae(pe){return new Promise(async(be,Me)=>{try{await pe(be,Me)}catch(ze){Me(ze)}})}he.withAsyncBody=ae})(De||(e.Promises=De={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new h.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=$e;class J{constructor(Z){this.b=Z,this.a=new l.$W(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=J;var W;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(Z){return new se(ae=>{ae.emitMany(Z)})}static fromPromise(Z){return new se(async ae=>{ae.emitMany(await Z)})}static fromPromises(Z){return new se(async ae=>{await Promise.all(Z.map(async pe=>ae.emitOne(await pe)))})}static merge(Z){return new se(async ae=>{await Promise.all(Z.map(async pe=>{for await(const be of pe)ae.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(Z,ae){this.a=W.Initial,this.b=[],this.d=null,this.f=ae,this.g=new A.$le,queueMicrotask(async()=>{const pe={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(Z(pe)),this.k()}catch(be){this.l(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ae){return new se(async pe=>{for await(const be of Z)pe.emitOne(ae(be))})}map(Z){return se.map(this,Z)}static filter(Z,ae){return new se(async pe=>{for await(const be of Z)ae(be)&&pe.emitOne(be)})}filter(Z){return se.filter(this,Z)}static coalesce(Z){return se.filter(Z,ae=>!!ae)}coalesce(){return se.coalesce(this)}static async toPromise(Z){const ae=[];for await(const pe of Z)ae.push(pe);return ae}toPromise(){return se.toPromise(this)}h(Z){this.a===W.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===W.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(Z){this.a===W.Initial&&(this.a=W.DoneError,this.d=Z,this.g.fire())}}e.$5h=se;class oe extends se{constructor(Z,ae){super(ae),this.m=Z}cancel(){this.m.cancel()}}e.$6h=oe;function te(he){const Z=new r.$we,ae=he(Z.token);return new oe(Z,async pe=>{const be=Z.token.onCancellationRequested(()=>{be.dispose(),Z.dispose(),pe.reject(new h.$6)});try{for await(const Me of ae){if(Z.token.isCancellationRequested)return;pe.emitOne(Me)}be.dispose(),Z.dispose()}catch(Me){be.dispose(),Z.dispose(),pe.reject(Me)}})}class le{constructor(Z){this.a=new ne,this.b=new se(be=>{if(ae){be.reject(ae);return}return pe&&be.emitMany(pe),this.d=Me=>be.reject(Me),this.f=Me=>be.emitOne(Me),this.a.p},Z);let ae,pe;this.f=be=>{pe||(pe=[]),pe.push(be)},this.d=be=>{ae||(ae=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$8h=le}),define(Ee[39],Se([1,0,19,9,27,33,29,16,11,13]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=I,e.$wk=c,e.$xk=O,e.$yk=L,e.$zk=F,e.$Ak=j,e.$Bk=B,e.$Ck=re;function I(){return Object.create(null)}e.$uk="**",e.$vk="/";const E="[/\\\\]",u="[^/\\\\]",k=/\//g;function b(U,G){switch(U){case 0:return"";case 1:return`${u}*?`;default:return`(?:${E}|${u}+${E}${G?`|${E}${u}+`:""})*?`}}function c(U,G){if(!U)return[];const K=[];let ee=!1,ue=!1,ne="";for(const De of U){switch(De){case G:if(!ee&&!ue){K.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ne+=De}return ne&&K.push(ne),K}function g(U){if(!U)return"";let G="";const K=c(U,e.$vk);if(K.every(ee=>ee===e.$uk))G=".*";else{let ee=!1;K.forEach((ue,ne)=>{if(ue===e.$uk){if(ee)return;G+=b(2,ne===K.length-1)}else{let De=!1,$e="",J=!1,W="";for(const se of ue){if(se!=="}"&&De){$e+=se;continue}if(J&&(se!=="]"||!W)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!W?oe="^":se===e.$vk?oe="":oe=(0,l.$hf)(se),W+=oe;continue}switch(se){case"{":De=!0;continue;case"[":J=!0;continue;case"}":{const te=`(?:${c($e,",").map(le=>g(le)).join("|")})`;G+=te,De=!1,$e="";break}case"]":{G+="["+W+"]",J=!1,W="";break}case"?":G+=u;continue;case"*":G+=b(1);continue;default:G+=(0,l.$hf)(se)}}ne<K.length-1&&(K[ne+1]!==e.$uk||ne+2<K.length)&&(G+=E)}ee=ue===e.$uk})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new N.$Ec(1e4),d=function(){return!1},a=function(){return null};function w(U,G){if(!U)return a;let K;typeof U!="string"?K=U.pattern:K=U,K=K.trim();const ee=`${K}_${!!G.trimForExclusions}`;let ue=s.get(ee);if(ue)return y(ue,U);let ne;return f.test(K)?ue=D(K.substr(4),K):(ne=m.exec(S(K,G)))?ue=P(ne[1],K):(G.trimForExclusions?o:n).test(K)?ue=C(K,G):(ne=i.exec(S(K,G)))?ue=p(ne[1].substr(1),K,!0):(ne=t.exec(S(K,G)))?ue=p(ne[1],K,!1):ue=v(K),s.set(ee,ue),y(ue,U)}function y(U,G){if(typeof G=="string")return U;const K=function(ee,ue){return(0,R.$Dg)(ee,G.base,!$.$k)?U((0,l.$mf)(ee.substr(G.base.length),T.sep),ue):null};return K.allBasenames=U.allBasenames,K.allPaths=U.allPaths,K.basenames=U.basenames,K.patterns=U.patterns,K}function S(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function D(U,G){return function(K,ee){return typeof K=="string"&&K.endsWith(U)?G:null}}function P(U,G){const K=`/${U}`,ee=`\\${U}`,ue=function(De,$e){return typeof De!="string"?null:$e?$e===U?G:null:De===U||De.endsWith(K)||De.endsWith(ee)?G:null},ne=[U];return ue.basenames=ne,ue.patterns=[G],ue.allBasenames=ne,ue}function C(U,G){const K=_(U.slice(1,-1).split(",").map($e=>w($e,G)).filter($e=>$e!==a),U),ee=K.length;if(!ee)return a;if(ee===1)return K[0];const ue=function($e,J){for(let W=0,se=K.length;W<se;W++)if(K[W]($e,J))return U;return null},ne=K.find($e=>!!$e.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const De=K.reduce(($e,J)=>J.allPaths?$e.concat(J.allPaths):$e,[]);return De.length&&(ue.allPaths=De),ue}function p(U,G,K){const ee=T.sep===T.$hc.sep,ue=ee?U:U.replace(k,T.sep),ne=T.sep+ue,De=T.$hc.sep+U;let $e;return K?$e=function(J,W){return typeof J=="string"&&(J===ue||J.endsWith(ne)||!ee&&(J===U||J.endsWith(De)))?G:null}:$e=function(J,W){return typeof J=="string"&&(J===ue||!ee&&J===U)?G:null},$e.allPaths=[(K?"*/":"./")+U],$e}function v(U){try{const G=new RegExp(`^${g(U)}$`);return function(K){return G.lastIndex=0,typeof K=="string"&&G.test(K)?U:null}}catch{return a}}function O(U,G,K){return!U||typeof G!="string"?!1:L(U)(G,void 0,K)}function L(U,G={}){if(!U)return d;if(typeof U=="string"||F(U)){const K=w(U,G);if(K===a)return d;const ee=function(ue,ne){return!!K(ue,ne)};return K.allBasenames&&(ee.allBasenames=K.allBasenames),K.allPaths&&(ee.allPaths=K.allPaths),ee}return M(U,G)}function F(U){const G=U;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(U){return U.allBasenames||[]}function B(U){return U.allPaths||[]}function M(U,G){const K=_(Object.getOwnPropertyNames(U).map($e=>z($e,U[$e],G)).filter($e=>$e!==a)),ee=K.length;if(!ee)return a;if(!K.some($e=>!!$e.requiresSiblings)){if(ee===1)return K[0];const $e=function(se,oe){let te;for(let le=0,he=K.length;le<he;le++){const Z=K[le](se,oe);if(typeof Z=="string")return Z;(0,h.$qh)(Z)&&(te||(te=[]),te.push(Z))}return te?(async()=>{for(const le of te){const he=await le;if(typeof he=="string")return he}return null})():null},J=K.find(se=>!!se.allBasenames);J&&($e.allBasenames=J.allBasenames);const W=K.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return W.length&&($e.allPaths=W),$e}const ue=function($e,J,W){let se,oe;for(let te=0,le=K.length;te<le;te++){const he=K[te];he.requiresSiblings&&W&&(J||(J=(0,T.$oc)($e)),se||(se=J.substr(0,J.length-(0,T.$pc)($e).length)));const Z=he($e,J,se,W);if(typeof Z=="string")return Z;(0,h.$qh)(Z)&&(oe||(oe=[]),oe.push(Z))}return oe?(async()=>{for(const te of oe){const le=await te;if(typeof le=="string")return le}return null})():null},ne=K.find($e=>!!$e.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const De=K.reduce(($e,J)=>J.allPaths?$e.concat(J.allPaths):$e,[]);return De.length&&(ue.allPaths=De),ue}function z(U,G,K){if(G===!1)return a;const ee=w(U,K);if(ee===a)return a;if(typeof G=="boolean")return ee;if(G){const ue=G.when;if(typeof ue=="string"){const ne=(De,$e,J,W)=>{if(!W||!ee(De,$e))return null;const se=ue.replace("$(basename)",()=>J),oe=W(se);return(0,h.$qh)(oe)?oe.then(te=>te?U:null):oe?U:null};return ne.requiresSiblings=!0,ne}}return ee}function _(U,G){const K=U.filter($e=>!!$e.basenames);if(K.length<2)return U;const ee=K.reduce(($e,J)=>{const W=J.basenames;return W?$e.concat(W):$e},[]);let ue;if(G){ue=[];for(let $e=0,J=ee.length;$e<J;$e++)ue.push(G)}else ue=K.reduce(($e,J)=>{const W=J.patterns;return W?$e.concat(W):$e},[]);const ne=function($e,J){if(typeof $e!="string")return null;if(!J){let se;for(se=$e.length;se>0;se--){const oe=$e.charCodeAt(se-1);if(oe===A.CharCode.Slash||oe===A.CharCode.Backslash)break}J=$e.substr(se)}const W=ee.indexOf(J);return W!==-1?ue[W]:null};ne.basenames=ee,ne.patterns=ue,ne.allBasenames=ee;const De=U.filter($e=>!$e.basenames);return De.push(ne),De}function re(U,G){return(0,r.$vb)(U,G,(K,ee)=>typeof K=="string"&&typeof ee=="string"?K===ee:typeof K!="string"&&typeof ee!="string"?K.base===ee.base&&K.pattern===ee.pattern:!1)}}),define(Ee[86],Se([1,0,14,136,23,13,2]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.MarkdownStringTextNewlineStyle=void 0,e.$3k=l,e.$4k=I,e.$5k=E,e.$6k=u,e.$7k=k,e.$8k=b,e.$9k=c,e.$0k=g;var T;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,r.$8)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Vk)(m):m).replace(/([ \t]+)/g,(o,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===T.Break?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+=`
${k(n,m)}
`,this}appendLink(m,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(m,n){const o=new RegExp((0,R.$hf)(n),"g");return m.replace(o,(i,t)=>m.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$2k=$;function l(f){return I(f)?!f.value:Array.isArray(f)?f.every(l):!0}function I(f){return f instanceof $?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function E(f,m){return f===m?!0:!f||!m?!1:f.value===m.value&&f.isTrusted===m.isTrusted&&f.supportThemeIcons===m.supportThemeIcons&&f.supportHtml===m.supportHtml&&(f.baseUri===m.baseUri||!!f.baseUri&&!!m.baseUri&&(0,A.$$g)(N.URI.from(f.baseUri),N.URI.from(m.baseUri)))}function u(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(f,m){const n=f.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${m}`,f,`${"`".repeat(o)}`].join(`
`)}function b(f){return f.replace(/"/g,"&quot;")}function c(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(f){const m=[],n=f.split("|").map(i=>i.trim());f=n[0];const o=n[1];if(o){const i=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),s=i?i[1]:"",d=t?t[1]:"",a=isFinite(parseInt(d)),w=isFinite(parseInt(s));a&&m.push(`width="${d}"`),w&&m.push(`height="${s}"`)}return{href:f,dimensions:m}}}),define(Ee[110],Se([1,0,19,33,16,11,23,13]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=$,e.$Sw=I,e.$Tw=u,e.$Uw=k,e.$Vw=f,e.$Ww=n,e.$Xw=o,e.$Yw=i,e.$Zw=t,e.$1w=s;function $(a,w){const{os:y,tildify:S,relative:D}=w;if(D){const p=l(a,D,y);if(typeof p=="string")return p}let P=a.fsPath;if(y===R.OperatingSystem.Windows&&!R.$i?P=P.replace(/\//g,"\\"):y!==R.OperatingSystem.Windows&&R.$i&&(P=P.replace(/\\/g,"/")),y!==R.OperatingSystem.Windows&&S?.userHome){const p=S.userHome.fsPath;let v;a.scheme!==S.userHome.scheme&&a.path[0]===A.$hc.sep&&a.path[1]!==A.$hc.sep?v=S.userHome.with({path:a.path}).fsPath:v=P,P=u(v,p,y)}return(y===R.OperatingSystem.Windows?A.$gc:A.$hc).normalize(I(P,y===R.OperatingSystem.Windows))}function l(a,w,y){const S=y===R.OperatingSystem.Windows?A.$gc:A.$hc,D=y===R.OperatingSystem.Linux?N.$8g:N.$0g,P=w.getWorkspace(),C=(0,r.$Pb)(P.folders);if(!C)return;a.scheme!==C.uri.scheme&&a.path[0]===A.$hc.sep&&a.path[1]!==A.$hc.sep&&(a=C.uri.with({path:a.path}));const p=w.getWorkspaceFolder(a);if(!p)return;let v;if(D.isEqual(p.uri,a)?v="":v=D.relativePath(p.uri,a)??"",v&&(v=S.normalize(v)),P.folders.length>1&&!w.noPrefix){const O=p.name?p.name:D.basenameOrAuthority(p.uri);v=v?`${O} \u2022 ${v}`:O}return v}function I(a,w=R.$i){return(0,h.$Ig)(a,w)?a.charAt(0).toUpperCase()+a.slice(1):a}let E=Object.create(null);function u(a,w,y=R.OS){if(y===R.OperatingSystem.Windows||!a||!w)return a;let S=E.original===w?E.normalized:void 0;S||(S=w,R.$i&&(S=(0,h.$xg)(S)),S=`${(0,T.$nf)(S,A.$hc.sep)}${A.$hc.sep}`,E={original:w,normalized:S});let D=a;return R.$i&&(D=(0,h.$xg)(D)),(y===R.OperatingSystem.Linux?D.startsWith(S):(0,T.$Gf)(D,S))?`~/${D.substr(S.length)}`:a}function k(a,w){return a.replace(/^~($|\/|\\)/,`${w}$1`)}const b="\u2026",c="\\\\",g="~";function f(a,w=A.sep){const y=new Array(a.length);let S=!1;for(let D=0;D<a.length;D++){const P=a[D];if(P===""){y[D]=`.${w}`;continue}if(!P){y[D]=P;continue}S=!0;let C="",p=P;p.indexOf(c)===0?(C=p.substr(0,p.indexOf(c)+c.length),p=p.substr(p.indexOf(c)+c.length)):p.indexOf(w)===0?(C=p.substr(0,p.indexOf(w)+w.length),p=p.substr(p.indexOf(w)+w.length)):p.indexOf(g)===0&&(C=p.substr(0,p.indexOf(g)+g.length),p=p.substr(p.indexOf(g)+g.length));const v=p.split(w);for(let O=1;S&&O<=v.length;O++)for(let L=v.length-O;S&&L>=0;L--){S=!1;let F=v.slice(L,L+O).join(w);for(let j=0;!S&&j<a.length;j++)if(j!==D&&a[j]&&a[j].indexOf(F)>-1){const B=L+O===v.length,M=L>0&&a[j].indexOf(w)>-1?w+F:F,z=a[j].endsWith(M);S=!B||z}if(!S){let j="";(v[0].endsWith(":")||C!=="")&&(L===1&&(L=0,O++,F=v[0]+w+F),L>0&&(j=v[0]+w),j=C+j),L>0&&(j=j+b+w),j=j+F,L+O<v.length&&(j=j+w+b),y[D]=j}}S&&(y[D]=P)}return y}var m;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function n(a,w=Object.create(null)){const y=[];let S=!1,D="";for(const P of a)if(P==="$"||S&&P==="{")D&&y.push({value:D,type:m.TEXT}),D="",S=!0;else if(P==="}"&&S){const C=w[D];if(typeof C=="string")C.length&&y.push({value:C,type:m.VARIABLE});else if(C){const p=y[y.length-1];(!p||p.type!==m.SEPARATOR)&&y.push({value:C.label,type:m.SEPARATOR})}D="",S=!1}else D+=P;return D&&!S&&y.push({value:D,type:m.TEXT}),y.filter((P,C)=>{if(P.type===m.SEPARATOR){const p=y[C-1],v=y[C+1];return[p,v].every(O=>O&&(O.type===m.VARIABLE||O.type===m.TEXT)&&O.value.length>0)}return!0}).map(P=>P.value).join("")}function o(a,w){return R.$j||w?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):a.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function i(a,w){return R.$j||w?a.replace(/\(&&\w\)|&&/g,""):R.$i?a.replace(/&&|&/g,y=>y==="&"?"&&":"&"):a.replace(/&&/g,"_")}function t(a){return a.replace(/&/g,"&&")}function s(a){if(a.endsWith("]")){const w=a.lastIndexOf(" [",a.length-2);if(w!==-1){const y=d(a.substring(0,w)),S=a.substring(w);return{name:y.name+S,parentPath:y.parentPath}}}return d(a)}function d(a){const w=a.indexOf("/")!==-1?A.$hc:A.$gc,y=w.basename(a),S=w.dirname(a);return y.length?{name:y,parentPath:S}:{name:S,parentPath:""}}}),define(Ee[142],Se([1,0,22,41,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=$,e.$Ln=I,e.$Mn=E;function R(u){return u.toJSON()}class N{constructor(k){this.a=k}transformIncoming(k){const b=this.a.transformIncoming(k);return b===k?k:R(A.URI.from(b))}transformOutgoing(k){const b=this.a.transformOutgoing(k);return b===k?k:R(A.URI.from(b))}transformOutgoingURI(k){const b=this.a.transformOutgoing(k);return b===k?k:A.URI.from(b)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$In=N,e.$Jn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,k,b){if(!u||b>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return k.transformOutgoing(u);for(const c in u)if(Object.hasOwnProperty.call(u,c)){const g=T(u[c],k,b+1);g!==null&&(u[c]=g)}}return null}function $(u,k){const b=T(u,k,0);return b===null?u:b}function l(u,k,b,c){if(!u||c>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return b?A.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof r.$Ne)return null;for(const g in u)if(Object.hasOwnProperty.call(u,g)){const f=l(u[g],k,b,c+1);f!==null&&(u[g]=f)}}return null}function I(u,k){const b=l(u,k,!1,0);return b===null?u:b}function E(u,k){const b=l(u,k,!0,0);return b===null?u:b}}),define(Ee[34],Se([1,0,61,68,410,9,33,82,16,11,23,2]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=y,e.writeFileSync=D,r=We(r);var u;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function k(M,z=u.UNLINK,_){if((0,N.$Hg)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===u.UNLINK?c(M):b(M,_)}async function b(M,z=(0,N.$Mg)((0,h.tmpdir)())){try{try{await r.promises.rename(M,z)}catch(_){return _.code==="ENOENT"?void 0:c(M)}c(z).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function c(M){return r.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function g(M){if((0,N.$Hg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function f(M,z){return o(await(z?m(M):r.promises.readdir(M)))}async function m(M){try{return await r.promises.readdir(M,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const z=[],_=await f(M);for(const re of _){let U=!1,G=!1,K=!1;try{const ee=await e.Promises.lstat((0,$.$kc)(M,re));U=ee.isFile(),G=ee.isDirectory(),K=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}z.push({name:re,isFile:()=>U,isDirectory:()=>G,isSymbolicLink:()=>K})}return z}function n(M){return o(r.readdirSync(M))}function o(M){return M.map(z=>typeof z=="string"?l.$j?(0,T.$lm)(z):z:(z.name=l.$j?(0,T.$lm)(z.name):z.name,z))}async function i(M){const z=await f(M),_=[];for(const re of z)await s.existsDirectory((0,$.$kc)(M,re))&&_.push(re);return _}function t(M,z=1e3){return new Promise(_=>{let re=!1;const U=setInterval(()=>{re||(re=!0,r.access(M,G=>{re=!1,G&&(clearInterval(U),_(void 0))}))},z)})}var s;(function(M){async function z(U){let G;try{if(G=await e.Promises.lstat(U),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(l.$i&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw K}}M.stat=z;async function _(U){try{const{stat:G,symbolicLink:K}=await M.stat(U);return G.isFile()&&K?.dangling!==!0}catch{}return!1}M.existsFile=_;async function re(U){try{const{stat:G,symbolicLink:K}=await M.stat(U);return G.isDirectory()&&K?.dangling!==!0}catch{}return!1}M.existsDirectory=re})(s||(e.SymlinkSupport=s={}));const d=new R.$Nh;function a(M,z,_){return d.queueFor(E.URI.file(M),()=>{const re=P(_);return new Promise((U,G)=>S(M,z,re,K=>K?G(K):U()))},I.$9g)}let w=!0;function y(M){w=M}function S(M,z,_,re){if(!w)return r.writeFile(M,z,{mode:_.mode,flag:_.flag},re);r.open(M,_.flag,_.mode,(U,G)=>{if(U)return re(U);r.writeFile(G,z,K=>{if(K)return r.close(G,()=>re(K));r.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),y(!1)),r.close(G,ue=>re(ue))))})})}function D(M,z,_){const re=P(_);if(!w)return r.writeFileSync(M,z,{mode:re.mode,flag:re.flag});const U=r.openSync(M,re.flag,re.mode);try{r.writeFileSync(U,z);try{r.fdatasyncSync(U)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),y(!1)}}finally{r.closeSync(U)}}function P(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function C(M,z,_=6e4){if(M!==z)try{l.$i&&typeof _=="number"?await p(M,z,Date.now(),_):await r.promises.rename(M,z)}catch(re){if(M.toLowerCase()!==z.toLowerCase()&&re.code==="EXDEV"||M.endsWith("."))await v(M,z,{preserveSymlinks:!1}),await k(M,u.MOVE);else throw re}}async function p(M,z,_,re,U=0){try{return await r.promises.rename(M,z)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-_>=re)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${G}`),G;if(U===0){let K=!1;try{const{stat:ee}=await s.stat(z);ee.isFile()||(K=!0)}catch{}if(K)throw G}return await(0,R.$Fh)(Math.min(100,U*10)),p(M,z,_,re,U+1)}}async function v(M,z,_){return L(M,z,{root:{source:M,target:z},options:_,handledSourcePaths:new Set})}const O=511;async function L(M,z,_){if(_.handledSourcePaths.has(M))return;_.handledSourcePaths.add(M);const{stat:re,symbolicLink:U}=await s.stat(M);if(U){if(_.options.preserveSymlinks)try{return await B(M,z,_)}catch{}if(U.dangling)return}return re.isDirectory()?F(M,z,re.mode&O,_):j(M,z,re.mode&O)}async function F(M,z,_,re){await e.Promises.mkdir(z,{recursive:!0,mode:_});const U=await f(M);for(const G of U)await L((0,$.$kc)(M,G),(0,$.$kc)(z,G),re)}async function j(M,z,_){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,_)}async function B(M,z,_){let re=await e.Promises.readlink(M);(0,N.$Dg)(re,_.root.source,!l.$k)&&(re=(0,$.$kc)(_.root.target,re.substr(_.root.source.length+1))),await e.Promises.symlink(re,z)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(M,z,_,re,U)=>new Promise((G,K)=>{r.read(M,z,_,re,U,(ee,ue,ne)=>ee?K(ee):G({bytesRead:ue,buffer:ne}))})}get readFile(){return r.promises.readFile}get write(){return(M,z,_,re,U)=>new Promise((G,K)=>{r.write(M,z,_,re,U,(ee,ue,ne)=>ee?K(ee):G({bytesWritten:ue,buffer:ne}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,A.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,A.promisify)(r.open)}get close(){return(0,A.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,A.promisify)(r.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return i}get writeFile(){return a}get rm(){return k}get rename(){return C}get copy(){return v}}}),define(Ee[111],Se([1,0,61,16,11,13,34]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=T,e.$fr=$,e.$gr=l,e.$hr=I,r=We(r);function T(u){if(A.$k)return u;const k=(0,h.$nc)(u);if(u===k)return u;const b=((0,h.$oc)(u)||u).toLowerCase();try{const g=(0,N.readdirSync)(k).filter(f=>f.toLowerCase()===b);if(g.length===1){const f=T(k);if(f)return(0,h.$kc)(f,g[0])}else if(g.length>1){const f=g.indexOf(b);if(f>=0){const m=T(k);if(m)return(0,h.$kc)(m,g[f])}}}catch{}return null}async function $(u,k){if(A.$k)return u;const b=(0,h.$nc)(u);if(u===b)return u;const c=((0,h.$oc)(u)||u).toLowerCase();try{if(k?.isCancellationRequested)return null;const f=(await N.Promises.readdir(b)).filter(m=>m.toLowerCase()===c);if(f.length===1){const m=await $(b,k);if(m)return(0,h.$kc)(m,f[0])}else if(f.length>1){const m=f.indexOf(c);if(m>=0){const n=await $(b,k);if(n)return(0,h.$kc)(n,f[m])}}}catch{}return null}async function l(u){try{return await N.Promises.realpath(u)}catch{const b=E(u);return await N.Promises.access(b,r.constants.R_OK),b}}function I(u){try{return r.realpathSync(u)}catch{const b=E(u);return r.accessSync(b,r.constants.R_OK),b}}function E(u){return(0,R.$nf)((0,h.$ic)(u),h.sep)}}),define(Ee[112],Se([1,0,16,11,56,109,18,34]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=$,e.$xm=l,r=We(r),h=We(h),A=We(A),N=We(N),T=We(T),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(E=A.env){return E.comspec||"cmd.exe"}function l(E){let u=[],k=!1;const b=function(c){if(k){u.push(c);return}(!E.send(c,f=>{if(f&&console.error(f),k=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(n=>b(n))}})||h.$i)&&(k=!0)};return{send:b}}var I;(function(E){async function u(k,b,c){if(r.$jc(k))return k;if(b===void 0&&(b=A.cwd()),r.$nc(k)!=="."||(c===void 0&&N.$eg(A.env.PATH)&&(c=A.env.PATH.split(r.$uc)),c===void 0||c.length===0))return r.$kc(b,k);async function f(m){if(await T.Promises.exists(m)){let n;try{n=await T.Promises.stat(m)}catch(o){o.message.startsWith("EACCES")&&(n=await T.Promises.lstat(m))}return n?!n.isDirectory():!1}return!1}for(const m of c){let n;if(r.$jc(m)?n=r.$kc(m,k):n=r.$kc(b,m,k),await f(n))return n;let o=n+".com";if(await f(o)||(o=n+".exe",await f(o)))return o}return r.$kc(b,k)}E.findExecutable=u})(I||(e.win32=I={}))});var Qe=this&&this.__decorate||function(ce,e,r,h){var A=arguments.length,R=A<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ce,e,r,h);else for(var T=ce.length-1;T>=0;T--)(N=ce[T])&&(R=(A<3?N(R):A>3?N(e,r,R):N(e,r))||R);return A>3&&R&&Object.defineProperty(e,r,R),R};define(Ee[87],Se([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=y,e.$fi=S,e.$ki=O,e.$li=L,E=We(E);var k;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(k||(k={}));function b(U){switch(U){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var c;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(c||(c={}));function g(U){switch(U){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var f;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(f||(f={}));function m(U){let G=0;for(let K=0;;K+=7){const ee=U.read(1);if(G|=(ee.buffer[0]&127)<<K,!(ee.buffer[0]&128))return G}}const n=d(0);function o(U,G){if(G===0){U.write(n);return}let K=0;for(let ue=G;ue!==0;ue=ue>>>7)K++;const ee=A.$Ne.alloc(K);for(let ue=0;G!==0;ue++)ee.buffer[ue]=G&127,G=G>>>7,G>0&&(ee.buffer[ue]|=128);U.write(ee)}class i{constructor(G){this.b=G,this.a=0}read(G){const K=this.b.slice(this.a,this.a+G);return this.a+=K.byteLength,K}}e.$ci=i;class t{constructor(){this.a=[]}get buffer(){return A.$Ne.concat(this.a)}write(G){this.a.push(G)}}e.$di=t;var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(s||(s={}));function d(U){const G=A.$Ne.alloc(1);return G.writeUInt8(U,0),G}const a={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},w=typeof Buffer<"u";function y(U,G){if(typeof G>"u")U.write(a.Undefined);else if(typeof G=="string"){const K=A.$Ne.fromString(G);U.write(a.String),o(U,K.byteLength),U.write(K)}else if(w&&Buffer.isBuffer(G)){const K=A.$Ne.wrap(G);U.write(a.Buffer),o(U,K.byteLength),U.write(K)}else if(G instanceof A.$Ne)U.write(a.VSBuffer),o(U,G.byteLength),U.write(G);else if(Array.isArray(G)){U.write(a.Array),o(U,G.length);for(const K of G)y(U,K)}else if(typeof G=="number"&&(G|0)===G)U.write(a.Uint),o(U,G);else{const K=A.$Ne.fromString(JSON.stringify(G));U.write(a.Object),o(U,K.byteLength),U.write(K)}}function S(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(m(U)).toString();case s.Buffer:return U.read(m(U)).buffer;case s.VSBuffer:return U.read(m(U));case s.Array:{const K=m(U),ee=[];for(let ue=0;ue<K;ue++)ee.push(S(U));return ee}case s.Object:return JSON.parse(U.read(m(U)).toString());case s.Int:return m(U)}}class D{constructor(G,K,ee=null,ue=1e3){this.h=G,this.j=K,this.k=ee,this.l=ue,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:c.Initialize})}registerChannel(G,K){this.b.set(G,K),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case c.Initialize:{const K=this.o([G.type]);this.k?.logOutgoing(K,0,P.OtherSide,g(G.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const K=this.o([G.type,G.id],G.data);this.k?.logOutgoing(K,G.id,P.OtherSide,g(G.type),G.data);return}}}o(G,K=void 0){const ee=new t;return y(ee,G),y(ee,K),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const K=new i(G),ee=S(K),ue=S(K),ne=ee[0];switch(ne){case k.Promise:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,ue),this.s({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case k.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,ue),this.t({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case k.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}`),this.u({type:ne,id:ee[1]});case k.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}`),this.u({type:ne,id:ee[1]})}}s(G){const K=this.b.get(G.channelName);if(!K){this.v(G);return}const ee=new R.$we;let ue;try{ue=K.call(this.j,G.name,G.arg,ee.token)}catch($e){ue=Promise.reject($e)}const ne=G.id;ue.then($e=>{this.m({id:ne,data:$e,type:c.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:ne,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:ne,data:$e,type:c.PromiseErrorObj})}).finally(()=>{De.dispose(),this.d.delete(G.id)});const De=(0,l.$Tc)(()=>ee.cancel());this.d.set(G.id,De)}t(G){const K=this.b.get(G.channelName);if(!K){this.v(G);return}const ee=G.id,ne=K.listen(this.j,G.name,G.arg)(De=>this.m({id:ee,data:De,type:c.EventFire}));this.d.set(G.id,ne)}u(G){const K=this.d.get(G.id);K&&(K.dispose(),this.d.delete(G.id))}v(G){let K=this.g.get(G.channelName);K||(K=[],this.g.set(G.channelName,K));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===k.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);K.push({request:G,timeoutTimer:ee})}w(G){const K=this.g.get(G);if(K){for(const ee of K)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case k.Promise:this.s(ee.request);break;case k.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$gi=D;var P;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class C{constructor(G,K=null){this.l=G,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=K}getChannel(G){const K=this;return{call(ee,ue,ne){return K.a?Promise.reject(new T.$6):K.m(G,ee,ue,ne)},listen(ee,ue){return K.a?$.Event.None:K.o(G,ee,ue)}}}m(G,K,ee,ue=R.CancellationToken.None){const ne=this.g++,De=k.Promise,$e={id:ne,type:De,channelName:G,name:K,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new T.$6);let J;return new Promise((se,oe)=>{if(ue.isCancellationRequested)return oe(new T.$6);const te=()=>{const ae=pe=>{switch(pe.type){case c.PromiseSuccess:this.f.delete(ne),se(pe.data);break;case c.PromiseError:{this.f.delete(ne);const be=new Error(pe.data.message);be.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,be.name=pe.data.name,oe(be);break}case c.PromiseErrorObj:this.f.delete(ne),oe(pe.data);break}};this.f.set(ne,ae),this.p($e)};let le=null;this.b===f.Idle?te():(le=(0,h.$rh)(ae=>this.u()),le.then(()=>{le=null,te()}));const he=()=>{le?(le.cancel(),le=null):this.p({id:ne,type:k.PromiseCancel}),oe(new T.$6)},Z=ue.onCancellationRequested(he);J=(0,l.$Sc)((0,l.$Tc)(he),Z),this.d.add(J)}).finally(()=>{J.dispose(),this.d.delete(J)})}o(G,K,ee){const ue=this.g++,ne=k.EventListen,De={id:ue,type:ne,channelName:G,name:K,arg:ee};let $e=null;const J=new $.$le({onWillAddFirstListener:()=>{$e=(0,h.$rh)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(J),this.p(De)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(J),this.p({id:ue,type:k.EventDispose}))}}),W=se=>J.fire(se.data);return this.f.set(ue,W),J.event}p(G){switch(G.type){case k.Promise:case k.EventListen:{const K=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(K,G.id,P.LocalSide,`${b(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case k.PromiseCancel:case k.EventDispose:{const K=this.q([G.type,G.id]);this.j?.logOutgoing(K,G.id,P.LocalSide,b(G.type));return}}}q(G,K=void 0){const ee=new t;return y(ee,G),y(ee,K),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const K=new i(G),ee=S(K),ue=S(K),ne=ee[0];switch(ne){case c.Initialize:return this.j?.logIncoming(G.byteLength,0,P.LocalSide,g(ne)),this.t({type:ee[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],P.LocalSide,g(ne),ue),this.t({type:ee[0],id:ee[1],data:ue})}}t(G){if(G.type===c.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$hi=C,Qe([N.$9h],C.prototype,"onDidInitializePromise",null);class p{get connections(){const G=[];return this.f.forEach(K=>G.push(K)),G}constructor(G,K,ee){this.a=new Map,this.f=new Set,this.g=new $.$le,this.onDidAddConnection=this.g.event,this.h=new $.$le,this.onDidRemoveConnection=this.h.event,this.j=new l.$Uc,this.j.add(G(({protocol:ue,onDidClientDisconnect:ne})=>{const De=$.Event.once(ue.onMessage);this.j.add(De($e=>{const J=new i($e),W=S(J),se=new D(ue,W,K,ee),oe=new C(ue,K);this.a.forEach((le,he)=>se.registerChannel(he,le));const te={channelServer:se,channelClient:oe,ctx:W};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{se.dispose(),oe.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,K){const ee=this;return{call(ue,ne,De){let $e;if((0,u.$sg)(K)){const W=(0,r.$4b)(ee.connections.filter(K));$e=W?Promise.resolve(W):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,K))}else $e=K.routeCall(ee,ue,ne);const J=$e.then(W=>W.channelClient.getChannel(G));return O(J).call(ue,ne,De)},listen(ue,ne){if((0,u.$sg)(K))return ee.k(G,K,ue,ne);const De=K.routeEvent(ee,ue,ne).then($e=>$e.channelClient.getChannel(G));return O(De).listen(ue,ne)}}}k(G,K,ee,ue){const ne=this;let De;const $e=new $.$le({onWillAddFirstListener:()=>{De=new l.$Uc;const J=new $.$re,W=new Map,se=te=>{const he=te.channelClient.getChannel(G).listen(ee,ue),Z=J.add(he);W.set(te,Z)},oe=te=>{const le=W.get(te);le&&(le.dispose(),W.delete(te))};ne.connections.filter(K).forEach(se),$.Event.filter(ne.onDidAddConnection,K)(se,void 0,De),ne.onDidRemoveConnection(oe,void 0,De),J.event($e.fire,$e,De),De.add(J)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return $e.event}registerChannel(G,K){this.a.set(G,K);for(const ee of this.f)ee.channelServer.registerChannel(G,K)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=p;class v{constructor(G,K,ee=null){const ue=new t;y(ue,K),G.send(ue.buffer),this.a=new C(G,ee),this.d=new D(G,K,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,K){this.d.registerChannel(G,K)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=v;function O(U){return{call(G,K,ee){return U.then(ue=>ue.call(G,K,ee))},listen(G,K){const ee=new $.$ue;return U.then(ue=>ee.input=ue.listen(G,K)),ee.event}}}function L(U){let G=!1;return{call(K,ee,ue){return G?U.call(K,ee,ue):(0,h.$Fh)(0).then(()=>G=!0).then(()=>U.call(K,ee,ue))},listen(K,ee){if(G)return U.listen(K,ee);const ue=new $.$ue;return(0,h.$Fh)(0).then(()=>G=!0).then(()=>ue.input=U.listen(K,ee)),ue.event}}}class F{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const K of G.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$mi=F;var j;(function(U){function G(ne,De,$e){const J=ne,W=$e&&$e.disableMarshalling,se=new Map;for(const oe in J)ee(oe)&&se.set(oe,$.Event.buffer(J[oe],!0,void 0,De));return new class{listen(oe,te,le){const he=se.get(te);if(he)return he;const Z=J[te];if(typeof Z=="function"){if(ue(te))return Z.call(J,le);if(ee(te))return se.set(te,$.Event.buffer(J[te],!0,void 0,De)),se.get(te)}throw new T.$cb(`Event not found: ${te}`)}call(oe,te,le){const he=J[te];if(typeof he=="function"){if(!W&&Array.isArray(le))for(let ae=0;ae<le.length;ae++)le[ae]=(0,I.$bi)(le[ae]);let Z=he.apply(J,le);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new T.$cb(`Method not found: ${te}`)}}}U.fromService=G;function K(ne,De){const $e=De&&De.disableMarshalling;return new Proxy({},{get(J,W){if(typeof W=="string")return De?.properties?.has(W)?De.properties.get(W):ue(W)?function(se){return ne.listen(W,se)}:ee(W)?ne.listen(W):async function(...se){let oe;De&&!(0,u.$ng)(De.context)?oe=[De.context,...se]:oe=se;const te=await ne.call(W,oe);return $e?te:(0,I.$bi)(te)};throw new T.$cb(`Property not found: ${String(W)}`)}})}U.toService=K;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Ef(ne.charCodeAt(2))}function ue(ne){return/^onDynamic/.test(ne)&&E.$Ef(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const G=U.toString();if(G!=="[object Object]")return G}return U}function z(U){return Array.isArray(U)?U.map(M):M(U)}function _(U,G,K,ee,ue,ne,De){De=z(De);const $e=B[ue],J=$e[ee%$e.length];let W=[`%c[${U}]%c[${String(G).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${J}`];/\($/.test(ne)?(W=W.concat(De),W.push(")")):W.push(De),console.log.apply(console,W)}class re{constructor(G,K){this.d=G,this.f=K,this.a=0,this.b=0}logOutgoing(G,K,ee,ue,ne){this.b+=G,_(this.d,this.b,G,K,ee,ue,ne)}logIncoming(G,K,ee,ue,ne){this.a+=G,_(this.f,this.a,G,K,ee,ue,ne)}}e.$ni=re}),define(Ee[69],Se([1,0,22,4,3,87]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.ProtocolConstants=e.$oi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var T;(function(a){a.enableDiagnostics=!1,a.records=[];const w=new WeakMap;let y=0;function S(P,C){if(!w.has(P)){const p=String(++y);w.set(P,p)}return w.get(P)}function D(P,C,p,v){if(!a.enableDiagnostics)return;const O=S(P,C);if(v instanceof r.$Ne||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const L=r.$Ne.alloc(v.byteLength);L.set(v),a.records.push({timestamp:Date.now(),id:O,label:C,type:p,buff:L})}else a.records.push({timestamp:Date.now(),id:O,label:C,type:p,data:v})}a.traceSocketEvent=D})(T||(e.SocketDiagnostics=T={}));var $;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let l=null;function I(){return l||(l=r.$Ne.alloc(0)),l}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,y){if(w===0)return I();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const C=this.a[0];return y&&(this.a.shift(),this.b-=w),C}if(this.a[0].byteLength>w){const C=this.a[0].slice(0,w);return y&&(this.a[0]=this.a[0].slice(w),this.b-=w),C}const S=r.$Ne.alloc(w);let D=0,P=0;for(;w>0;){const C=this.a[P];if(C.byteLength>w){const p=C.slice(0,w);S.set(p,D),D+=w,y&&(this.a[P]=C.slice(w),this.b-=w),w-=w}else S.set(C,D),D+=C.byteLength,y?(this.a.shift(),this.b-=C.byteLength):P++,w-=C.byteLength}return S}}e.$oi=E;var u;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(u||(u={}));function k(a){switch(a){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var b;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",a[a.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class c{constructor(w,y,S,D){this.type=w,this.id=y,this.ack=S,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.$Vc{constructor(w){super(),this.f=this.B(new h.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:b.HeaderLength,messageType:u.None,id:0,ack:0},this.a=w,this.b=!1,this.c=new E,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(N.ProtocolHeaderRead,{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,D=this.g.id,P=this.g.ack;if(this.g.readHead=!0,this.g.readLen=b.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(N.ProtocolMessageRead,y),this.f.fire(new c(S,D,P,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=r.$Ne.alloc(b.HeaderLength);y.writeUInt8(w.type,0),y.writeUInt32BE(w.id,1),y.writeUInt32BE(w.ack,5),y.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent(N.ProtocolHeaderWrite,{messageType:k(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent(N.ProtocolMessageWrite,w.data),this.j(y,w.data)}g(w,y){const S=this.f===0;return this.d.push(w,y),this.f+=w.byteLength+y.byteLength,S}h(){const w=r.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,y){this.g(w,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent(N.ProtocolWrite,{byteLength:w.byteLength}),this.c.write(w)}}class m extends A.$Vc{constructor(w){super(),this.f=new h.$le,this.onMessage=this.f.event,this.g=new h.$le,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new f(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(y=>{y.type===u.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new c(u.Regular,0,0,w))}}e.$pi=m;class n extends R.$ji{static fromSocket(w,y){return new n(new m(w),y)}get onDidDispose(){return this.b.onDidDispose}constructor(w,y,S=null){super(w,y,S),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.$qi=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.$ri=o;class i{constructor(w){this.data=w,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let w=0,y=this.a;for(;y;)y=y.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let y=0,S=this.a;for(;S;)w[y++]=S.data,S=S.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const y=new i(w);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const w=Date.now();for(let y=0;y<s.a;y++)this.c[y]=w-1e3*y;setInterval(()=>{for(let y=s.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),y=(1+s.a)*1e3;let S=0;for(let D=0;D<s.a;D++)w-this.c[D]<=y&&S++;return 1-S/s.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=w.loadEstimator??s.getInstance(),this.t=w.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Uc,this.o=w.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.t?this.l=setInterval(()=>{this.D()},b.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new c(u.Disconnect,0,0,I());this.p.write(w),this.p.flush()}sendPause(){const w=new c(u.Pause,0,0,I());this.p.write(w)}sendResume(){const w=new c(u.Resume,0,0,I());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,y){this.a=!0,this.r.dispose(),this.r=new A.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.h=this.g;const w=new c(u.Ack,0,this.h,I());this.p.write(w);const y=this.b.toArray();for(let S=0,D=y.length;S<D;S++)this.p.write(y[S]);this.B()}acceptDisconnect(){this.w.fire()}z(w){if(w.ack>this.d){this.d=w.ack;do{const y=this.b.peek();if(y&&y.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case u.None:break;case u.Regular:{if(w.id>this.g)if(w.id!==this.g+1){const y=Date.now();y-this.m>1e4&&(this.m=y,this.p.write(new c(u.ReplayRequest,0,0,I())))}else this.g=w.id,this.j=Date.now(),this.A(),this.v.fire(w.data);break}case u.Control:{this.u.fire(w.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const y=this.b.toArray();for(let S=0,D=y.length;S<D;S++)this.p.write(y[S]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const y=++this.c;this.h=this.g;const S=new c(u.Regular,y,this.h,w);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(w){const y=new c(u.Control,0,0,w);this.p.write(y)}A(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=b.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},b.AcknowledgeTime-w+5)}B(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),y=Date.now()-w.writtenTime,S=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(y>=b.TimeoutTime&&S>=b.TimeoutTime&&D>=b.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:S});return}const P=Math.max(b.TimeoutTime-y,b.TimeoutTime-S,b.TimeoutTime-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},P)}C(){if(this.g<=this.h)return;this.h=this.g;const w=new c(u.Ack,0,this.h,I());this.p.write(w)}D(){this.h=this.g;const w=new c(u.KeepAlive,0,this.h,I());this.p.write(w)}}e.$si=d}),define(Ee[208],Se([1,0,58,9,22,21,206,14,4,3,25,112,109,87]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0,T=We(T);class b extends k.$gi{constructor(f){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",m=>A.$Ne.wrap(Buffer.from(m,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$ar=b;class c{constructor(f,m){this.i=f,this.j=m,this.c=new Set,this.g=new Map,this.h=new $.$le,this.onDidProcessExit=this.h.event;const n=m&&m.timeout?m.timeout:6e4;this.b=new h.$Bh(n),this.d=null,this.f=null}getChannel(f){const m=this;return{call(n,o,i){return m.k(f,n,o,i)},listen(n,o){return m.l(f,n,o)}}}k(f,m,n,o=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.$7());this.b.cancel();const i=this.n(f),t=(0,h.$rh)(a=>i.call(m,n,a)),s=o.onCancellationRequested(()=>t.cancel()),d=(0,l.$Tc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,m,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const i=new $.$le({onWillAddFirstListener:()=>{o=this.n(f).listen(m,n)(i.fire,i),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,I.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,u.$km)(m.env),this.d=(0,r.fork)(this.i,f,m);const n=new $.$le,i=$.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,N.$9q)(y)){(0,N.log)(y,`IPC Library: ${this.j.serverName}`);return}n.fire(A.$Ne.wrap(Buffer.from(y,"base64")))}),t=this.j.useQueue?(0,E.$xm)(this.d):this.d,s=y=>this.d&&this.d.connected&&t.send(y.buffer.toString("base64")),d=n.event,a={send:s,onMessage:d};this.f=new k.$hi(a);const w=()=>this.o();process.once("exit",w),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,S)=>{process.removeListener("exit",w),i.dispose(),this.c.forEach(D=>(0,l.$Qc)(D)),this.c.clear(),y!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:S})})}return this.f}n(f){let m=this.g.get(f);return m||(m=this.m.getChannel(f),this.g.set(f,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$br=c}),define(Ee[209],Se([1,0,9,4,3,57,18]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=$;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(u){const k=u;return k?.changed instanceof Map||k?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(e.StorageState=l={}));class I extends A.$Vc{static{this.a=100}constructor(k,b=Object.create(null)){super(),this.r=k,this.s=b,this.b=this.B(new h.$oe),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new r.$Ch(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((b,c)=>this.w(c,b)),k.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(k,b){if(this.c===l.Closed)return;let c=!1;(0,N.$ng)(b)?c=this.f.delete(k):this.f.get(k)!==b&&(this.f.set(k,b),c=!0),c&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,b){const c=this.f.get(k);return(0,N.$ng)(c)?b:c}getBoolean(k,b){const c=this.get(k);return(0,N.$ng)(c)?b:c==="true"}getNumber(k,b){const c=this.get(k);return(0,N.$ng)(c)?b:parseInt(c,10)}getObject(k,b){const c=this.get(k);return(0,N.$ng)(c)?b:(0,R.$ai)(c)}async set(k,b,c=!1){if(this.c===l.Closed)return;if((0,N.$ng)(b))return this.delete(k,c);const g=(0,N.$gg)(b)||Array.isArray(b)?(0,R.$_h)(b):String(b);if(this.f.get(k)!==g)return this.f.set(k,g),this.j.set(k,g),this.h.delete(k),this.b.fire({key:k,external:c}),this.D()}async delete(k,b=!1){if(!(this.c===l.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:b}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===l.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$0p=I;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((b,c)=>this.a.set(c,b)),k.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$$p=E}),define(Ee[210],Se([1,0,13,11,22]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9t=void 0,e.$7t=I,e.$8t=E,r=We(r),h=We(h),A=We(A);let R;function N(){return R||(R=new TextDecoder("UTF-16LE")),R}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let l;function I(){return l||(l=h.$D()?N():$()),l}function E(b,c,g){const f=new Uint16Array(b.buffer,c,g);return g>0&&(f[0]===65279||f[0]===65534)?u(b,c,g):N().decode(f)}function u(b,c,g){const f=[];let m=0;for(let n=0;n<g;n++){const o=A.$Pe(b,c);c+=2,f[m++]=String.fromCharCode(o)}return f.join("")}class k{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return I().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||r.$Jf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let f=0;f<g;f++)this.b[this.d++]=c.charCodeAt(f)}}e.$9t=k}),define(Ee[211],Se([1,0,22,210]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=void 0,e.$$t=N,r=We(r);function A($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,I,E,u){this.oldPosition=l,this.oldText=I,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(l){return 4+2*l.length}static c(l,I,E){const u=I.length;r.$Se(l,u,E),E+=4;for(let k=0;k<u;k++)r.$Qe(l,I.charCodeAt(k),E),E+=2;return E}static d(l,I){const E=r.$Re(l,I);return I+=4,(0,h.$8t)(l,I,E)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(l,I){return r.$Se(l,this.oldPosition,I),I+=4,r.$Se(l,this.newPosition,I),I+=4,I=R.c(l,this.oldText,I),I=R.c(l,this.newText,I),I}static read(l,I,E){const u=r.$Re(l,I);I+=4;const k=r.$Re(l,I);I+=4;const b=R.d(l,I);I+=R.a(b);const c=R.d(l,I);return I+=R.a(c),E.push(new R(u,b,k,c)),I}}e.$0t=R;function N($,l){return $===null||$.length===0?l:new T($,l).compress()}class T{constructor(l,I){this.a=l,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let l=0,I=0,E=this.n(l),u=this.l(I);for(;l<this.f||I<this.h;){if(E===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(E),E=this.n(++l);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++I);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++l);continue}if(u.oldPosition<E.newPosition){const[f,m]=T.r(u,E.newPosition-u.oldPosition);this.k(f),u=m;continue}if(E.newPosition<u.oldPosition){const[f,m]=T.q(E,u.oldPosition-E.newPosition);this.m(f),E=m;continue}let c,g;if(u.oldEnd===E.newEnd)c=E,g=u,E=this.n(++l),u=this.l(++I);else if(u.oldEnd<E.newEnd){const[f,m]=T.q(E,u.oldLength);c=f,g=u,E=m,u=this.l(++I)}else{const[f,m]=T.r(u,E.newLength);c=E,g=f,E=this.n(++l),u=m}this.d[this.e++]=new R(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const k=T.s(this.d);return T.t(k)}k(l){this.d[this.e++]=T.o(this.g,l),this.j+=l.newLength-l.oldLength}l(l){return l<this.h?this.c[l]:null}m(l){this.d[this.e++]=T.p(this.j,l),this.g+=l.newLength-l.oldLength}n(l){return l<this.f?this.a[l]:null}static o(l,I){return new R(I.oldPosition-l,I.oldText,I.newPosition,I.newText)}static p(l,I){return new R(I.oldPosition,I.oldText,I.newPosition+l,I.newText)}static q(l,I){const E=l.newText.substr(0,I),u=l.newText.substr(I);return[new R(l.oldPosition,l.oldText,l.newPosition,E),new R(l.oldEnd,"",l.newPosition+I,u)]}static r(l,I){const E=l.oldText.substr(0,I),u=l.oldText.substr(I);return[new R(l.oldPosition,E,l.newPosition,l.newText),new R(l.oldPosition+I,u,l.newEnd,"")]}static s(l){if(l.length===0)return l;const I=[];let E=0,u=l[0];for(let k=1;k<l.length;k++){const b=l[k];u.oldEnd===b.oldPosition?u=new R(u.oldPosition,u.oldText+b.oldText,u.newPosition,u.newText+b.newText):(I[E++]=u,u=b)}return I[E++]=u,I}static t(l){if(l.length===0)return l;const I=[];let E=0;for(let u=0;u<l.length;u++){const k=l[u];k.oldText!==k.newText&&(I[E++]=k)}return I}}}),define(Ee[212],Se([1,0,39,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=A,e.$pu=R;function A(N,T,$,l,I,E){if(Array.isArray(N)){let u=0;for(const k of N){const b=A(k,T,$,l,I,E);if(b===10)return b;b>u&&(u=b)}return u}else{if(typeof N=="string")return l?N==="*"?5:N===$?10:0:0;if(N){const{language:u,pattern:k,scheme:b,hasAccessToAllModels:c,notebookType:g}=N;if(!l&&!c)return 0;g&&I&&(T=I);let f=0;if(b)if(b===T.scheme)f=10;else if(b==="*")f=5;else return 0;if(u)if(u===$)f=10;else if(u==="*")f=Math.max(f,5);else return 0;if(g)if(g===E)f=10;else if(g==="*"&&E!==void 0)f=Math.max(f,5);else return 0;if(k){let m;if(typeof k=="string"?m=k:m={...k,base:(0,h.$ic)(k.base)},m===T.fsPath||(0,r.$xk)(m,T.fsPath))f=10;else return 0}return f}else return 0}}function R(N){return typeof N=="string"?!1:Array.isArray(N)?N.some(R):!!N.notebookType}}),define(Ee[213],Se([1,0,4,13,31,54,139,188,211,3]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=void 0,h=We(h);class I extends l.$Vc{constructor(u,k,b,c,g,f,m){super(),this.m=this.B(new r.$le),this.onDidChangeContent=this.m.event,this.f=k,this.j=!f,this.g=c,this.h=g,this.c=new N.$gD(u,b,m)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,k){return this.c.getOffsetAt(u,k)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,k){const b=u+k,c=this.getPositionAt(u),g=this.getPositionAt(b);return new A.$Ht(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange(u,k=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const b=this.n(k);return this.c.getValueInRange(u,b)}getValueLengthInRange(u,k=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const b=this.getOffsetAt(u.startLineNumber,u.startColumn),c=this.getOffsetAt(u.endLineNumber,u.endColumn);let g=0;const f=this.n(k),m=this.getEOL();if(f.length!==m.length){const n=f.length-m.length,o=u.endLineNumber-u.startLineNumber;g=n*o}return c-b+g}getCharacterCountInRange(u,k=R.EndOfLinePreference.TextDefined){if(this.j){let b=0;const c=u.startLineNumber,g=u.endLineNumber;for(let f=c;f<=g;f++){const m=this.getLineContent(f),n=f===c?u.startColumn-1:0,o=f===g?u.endColumn-1:m.length;for(let i=n;i<o;i++)h.$Jf(m.charCodeAt(i))?(b=b+1,i=i+1):b=b+1}return b+=this.n(k).length*(g-c),b}return this.getValueLengthInRange(u,k)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,k){return this.c.getLineCharCode(u,k)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const k=h.$uf(this.getLineContent(u));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(u){const k=h.$wf(this.getLineContent(u));return k===-1?0:k+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,k,b){let c=this.g,g=this.h,f=this.j,m=!0,n=[];for(let w=0;w<u.length;w++){const y=u[w];m&&y._isTracked&&(m=!1);const S=y.range;if(y.text){let v=!0;f||(v=!h.$Uf(y.text),f=v),!c&&v&&(c=h.$Tf(y.text)),!g&&v&&(g=h.$Wf(y.text))}let D="",P=0,C=0,p=0;if(y.text){let v;[P,C,p,v]=(0,T.$ru)(y.text);const O=this.getEOL(),L=O===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;v===T.StringEOL.Unknown||v===L?D=y.text:D=y.text.replace(/\r\n|\r|\n/g,O)}n[w]={sortIndex:w,identifier:y.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:D,eolCount:P,firstLineLength:C,lastLineLength:p,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(I.u);let o=!1;for(let w=0,y=n.length-1;w<y;w++){const S=n[w].range.getEndPosition(),D=n[w+1].range.getStartPosition();if(D.isBeforeOrEqual(S)){if(D.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}m&&(n=this.s(n));const i=b||k?I._getInverseEditRanges(n):[],t=[];if(k)for(let w=0;w<n.length;w++){const y=n[w],S=i[w];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let D=S.startLineNumber;D<=S.endLineNumber;D++){let P="";D===S.startLineNumber&&(P=this.getLineContent(y.range.startLineNumber),h.$uf(P)!==-1)||t.push({lineNumber:D,oldContent:P})}}let s=null;if(b){let w=0;s=[];for(let y=0;y<n.length;y++){const S=n[y],D=i[y],P=this.getValueInRange(S.range),C=S.rangeOffset+w;w+=S.text.length-P.length,s[y]={sortIndex:S.sortIndex,identifier:S.identifier,range:D,text:P,textChange:new $.$0t(S.rangeOffset,P,C,S.text)}}o||s.sort((y,S)=>y.sortIndex-S.sortIndex)}this.g=c,this.h=g,this.j=f;const d=this.t(n);let a=null;if(k&&t.length>0){t.sort((w,y)=>y.lineNumber-w.lineNumber),a=[];for(let w=0,y=t.length;w<y;w++){const S=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===S)continue;const D=t[w].oldContent,P=this.getLineContent(S);P.length===0||P===D||h.$uf(P)!==-1||a.push(S)}}return this.m.fire(),new R.$aw(s,d,a)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let k=!1;const b=u[0].range,c=u[u.length-1].range,g=new A.$Ht(b.startLineNumber,b.startColumn,c.endLineNumber,c.endColumn);let f=b.startLineNumber,m=b.startColumn;const n=[];for(let d=0,a=u.length;d<a;d++){const w=u[d],y=w.range;k=k||w.forceMoveMarkers,n.push(this.getValueInRange(new A.$Ht(f,m,y.startLineNumber,y.startColumn))),w.text.length>0&&n.push(w.text),f=y.endLineNumber,m=y.endColumn}const o=n.join(""),[i,t,s]=(0,T.$ru)(o);return{sortIndex:0,identifier:u[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,R.EndOfLinePreference.TextDefined),text:o,eolCount:i,firstLineLength:t,lastLineLength:s,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const k=[];for(let b=0;b<u.length;b++){const c=u[b],g=c.range.startLineNumber,f=c.range.startColumn,m=c.range.endLineNumber,n=c.range.endColumn;if(g===m&&f===n&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const o=new A.$Ht(g,f,m,n);k.push({range:o,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return k}findMatchesLineByLine(u,k,b,c){return this.c.findMatchesLineByLine(u,k,b,c)}getPieceTree(){return this.c}static _getInverseEditRange(u,k){const b=u.startLineNumber,c=u.startColumn,[g,f,m]=(0,T.$ru)(k);let n;if(k.length>0){const o=g+1;o===1?n=new A.$Ht(b,c,b,c+f):n=new A.$Ht(b,c,b+o-1,m+1)}else n=new A.$Ht(b,c,b,c);return n}static _getInverseEditRanges(u){const k=[];let b=0,c=0,g=null;for(let f=0,m=u.length;f<m;f++){const n=u[f];let o,i;g?g.range.endLineNumber===n.range.startLineNumber?(o=b,i=c+(n.range.startColumn-g.range.endColumn)):(o=b+(n.range.startLineNumber-g.range.endLineNumber),i=n.range.startColumn):(o=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new A.$Ht(o,i,o,i+n.firstLineLength):t=new A.$Ht(o,i,o+s-1,n.lastLineLength+1)}else t=new A.$Ht(o,i,o,i);b=t.endLineNumber,c=t.endColumn,k.push(t),g=n}return k}static u(u,k){const b=A.$Ht.compareRangesUsingEnds(u.range,k.range);return b===0?u.sortIndex-k.sortIndex:b}static w(u,k){const b=A.$Ht.compareRangesUsingEnds(u.range,k.range);return b===0?k.sortIndex-u.sortIndex:-b}}e.$hD=I}),define(Ee[214],Se([1,0,27,13,54,139,213]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0,h=We(h);class T{constructor(I,E,u,k,b,c,g,f,m){this.a=I,this.b=E,this.c=u,this.d=k,this.e=b,this.f=c,this.g=g,this.h=f,this.j=m}k(I){const E=this.c+this.d+this.e,u=this.c+this.e;return E===0?I===A.DefaultEndOfLine.LF?`
`:`\r
`:u>E/2?`\r
`:`
`}create(I){const E=this.k(I),u=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let b=0,c=u.length;b<c;b++){const g=u[b].buffer.replace(/\r\n|\r|\n/g,E),f=(0,R.$cD)(g);u[b]=new R.$fD(g,f)}const k=new N.$hD(u,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$5f(I)&&(this.b=h.$4f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===r.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,R.$dD)(this.e,I);this.a.push(new R.$fD(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Tf(I)),this.k||(this.k=h.$Wf(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,R.$cD)(I.buffer);I.lineStarts=E,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$iD=$}),define(Ee[143],Se([1,0,22,11]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcb=$,e.$Hcb=I,h=We(h);var A;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(A||(A={}));function R(E){for(let u=0,k=E.length;u<k;u+=4){const b=E[u+0],c=E[u+1],g=E[u+2],f=E[u+3];E[u+0]=f,E[u+1]=g,E[u+2]=c,E[u+3]=b}}function N(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$D()||R(u),r.$Ne.wrap(u)}function T(E){const u=E.buffer;if(h.$D()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const k=new Uint8Array(u.byteLength);return k.set(u),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(E){const u=new Uint32Array(l(E));let k=0;if(u[k++]=E.id,E.type==="full")u[k++]=A.Full,u[k++]=E.data.length,u.set(E.data,k),k+=E.data.length;else{u[k++]=A.Delta,u[k++]=E.deltas.length;for(const b of E.deltas)u[k++]=b.start,u[k++]=b.deleteCount,b.data?(u[k++]=b.data.length,u.set(b.data,k),k+=b.data.length):u[k++]=0}return N(u)}function l(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const k of E.deltas)k.data&&(u+=k.data.length)}return u}function I(E){const u=T(E);let k=0;const b=u[k++];if(u[k++]===A.Full){const m=u[k++],n=u.subarray(k,k+m);return k+=m,{id:b,type:"full",data:n}}const g=u[k++],f=[];for(let m=0;m<g;m++){const n=u[k++],o=u[k++],i=u[k++];let t;i>0&&(t=u.subarray(k,k+i),k+=i),f[m]={start:n,deleteCount:o,data:t}}return{id:b,type:"delta",deltas:f}}}),define(Ee[215],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/config/editorOptions",e)}),define(Ee[216],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(Ee[88],Se([1,0,83,2,189,31,199,216]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ju=e.$Iu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Hu=e.$Gu=e.SymbolKinds=e.SymbolTag=e.$Eu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Cu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Bu=e.$Au=e.$zu=void 0,e.$Du=d,e.$Fu=w;class ${constructor(G,K,ee){this.offset=G,this.type=K,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$zu=$;class l{constructor(G,K){this.tokens=G,this.endState=K,this._tokenizationResultBrand=void 0}}e.$Au=l;class I{constructor(G,K){this.tokens=G,this.endState=K,this._encodedTokenizationResultBrand=void 0}}e.$Bu=I;var E;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var u;(function(U){U[U.Method=0]="Method",U[U.Function=1]="Function",U[U.Constructor=2]="Constructor",U[U.Field=3]="Field",U[U.Variable=4]="Variable",U[U.Class=5]="Class",U[U.Struct=6]="Struct",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Event=10]="Event",U[U.Operator=11]="Operator",U[U.Unit=12]="Unit",U[U.Value=13]="Value",U[U.Constant=14]="Constant",U[U.Enum=15]="Enum",U[U.EnumMember=16]="EnumMember",U[U.Keyword=17]="Keyword",U[U.Text=18]="Text",U[U.Color=19]="Color",U[U.File=20]="File",U[U.Reference=21]="Reference",U[U.Customcolor=22]="Customcolor",U[U.Folder=23]="Folder",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue",U[U.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var k;(function(U){const G=new Map;G.set(u.Method,r.$4j.symbolMethod),G.set(u.Function,r.$4j.symbolFunction),G.set(u.Constructor,r.$4j.symbolConstructor),G.set(u.Field,r.$4j.symbolField),G.set(u.Variable,r.$4j.symbolVariable),G.set(u.Class,r.$4j.symbolClass),G.set(u.Struct,r.$4j.symbolStruct),G.set(u.Interface,r.$4j.symbolInterface),G.set(u.Module,r.$4j.symbolModule),G.set(u.Property,r.$4j.symbolProperty),G.set(u.Event,r.$4j.symbolEvent),G.set(u.Operator,r.$4j.symbolOperator),G.set(u.Unit,r.$4j.symbolUnit),G.set(u.Value,r.$4j.symbolValue),G.set(u.Enum,r.$4j.symbolEnum),G.set(u.Constant,r.$4j.symbolConstant),G.set(u.Enum,r.$4j.symbolEnum),G.set(u.EnumMember,r.$4j.symbolEnumMember),G.set(u.Keyword,r.$4j.symbolKeyword),G.set(u.Snippet,r.$4j.symbolSnippet),G.set(u.Text,r.$4j.symbolText),G.set(u.Color,r.$4j.symbolColor),G.set(u.File,r.$4j.symbolFile),G.set(u.Reference,r.$4j.symbolReference),G.set(u.Customcolor,r.$4j.symbolCustomColor),G.set(u.Folder,r.$4j.symbolFolder),G.set(u.TypeParameter,r.$4j.symbolTypeParameter),G.set(u.User,r.$4j.account),G.set(u.Issue,r.$4j.issues);function K(ne){let De=G.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=r.$4j.symbolProperty),De}U.toIcon=K;const ee=new Map;ee.set("method",u.Method),ee.set("function",u.Function),ee.set("constructor",u.Constructor),ee.set("field",u.Field),ee.set("variable",u.Variable),ee.set("class",u.Class),ee.set("struct",u.Struct),ee.set("interface",u.Interface),ee.set("module",u.Module),ee.set("property",u.Property),ee.set("event",u.Event),ee.set("operator",u.Operator),ee.set("unit",u.Unit),ee.set("value",u.Value),ee.set("constant",u.Constant),ee.set("enum",u.Enum),ee.set("enum-member",u.EnumMember),ee.set("enumMember",u.EnumMember),ee.set("keyword",u.Keyword),ee.set("snippet",u.Snippet),ee.set("text",u.Text),ee.set("color",u.Color),ee.set("file",u.File),ee.set("reference",u.Reference),ee.set("customcolor",u.Customcolor),ee.set("folder",u.Folder),ee.set("type-parameter",u.TypeParameter),ee.set("typeParameter",u.TypeParameter),ee.set("account",u.User),ee.set("issue",u.Issue);function ue(ne,De){let $e=ee.get(ne);return typeof $e>"u"&&!De&&($e=u.Property),$e}U.fromString=ue})(k||(e.CompletionItemKinds=k={}));var b;(function(U){U[U.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var c;(function(U){U[U.None=0]="None",U[U.KeepWhitespace=1]="KeepWhitespace",U[U.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var g;(function(U){U[U.Word=0]="Word",U[U.Line=1]="Line",U[U.Suggest=2]="Suggest"})(g||(e.PartialAcceptTriggerKind=g={}));var f;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var m;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class n{constructor(G,K,ee,ue){this.range=G,this.text=K,this.completionKind=ee,this.isSnippetText=ue}equals(G){return R.$Ht.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Cu=n;var o;(function(U){U[U.Invoke=1]="Invoke",U[U.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var i;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var t;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var s;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function d(U){return U&&h.URI.isUri(U.uri)&&R.$Ht.isIRange(U.range)&&(R.$Ht.isIRange(U.originSelectionRange)||R.$Ht.isIRange(U.targetSelectionRange))}var a;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(a||(e.SymbolKind=a={})),e.$Eu={[a.Array]:(0,T.localize)(0,null),[a.Boolean]:(0,T.localize)(1,null),[a.Class]:(0,T.localize)(2,null),[a.Constant]:(0,T.localize)(3,null),[a.Constructor]:(0,T.localize)(4,null),[a.Enum]:(0,T.localize)(5,null),[a.EnumMember]:(0,T.localize)(6,null),[a.Event]:(0,T.localize)(7,null),[a.Field]:(0,T.localize)(8,null),[a.File]:(0,T.localize)(9,null),[a.Function]:(0,T.localize)(10,null),[a.Interface]:(0,T.localize)(11,null),[a.Key]:(0,T.localize)(12,null),[a.Method]:(0,T.localize)(13,null),[a.Module]:(0,T.localize)(14,null),[a.Namespace]:(0,T.localize)(15,null),[a.Null]:(0,T.localize)(16,null),[a.Number]:(0,T.localize)(17,null),[a.Object]:(0,T.localize)(18,null),[a.Operator]:(0,T.localize)(19,null),[a.Package]:(0,T.localize)(20,null),[a.Property]:(0,T.localize)(21,null),[a.String]:(0,T.localize)(22,null),[a.Struct]:(0,T.localize)(23,null),[a.TypeParameter]:(0,T.localize)(24,null),[a.Variable]:(0,T.localize)(25,null)};function w(U,G){return(0,T.localize)(26,null,U,e.$Eu[G])}var y;(function(U){U[U.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var S;(function(U){const G=new Map;G.set(a.File,r.$4j.symbolFile),G.set(a.Module,r.$4j.symbolModule),G.set(a.Namespace,r.$4j.symbolNamespace),G.set(a.Package,r.$4j.symbolPackage),G.set(a.Class,r.$4j.symbolClass),G.set(a.Method,r.$4j.symbolMethod),G.set(a.Property,r.$4j.symbolProperty),G.set(a.Field,r.$4j.symbolField),G.set(a.Constructor,r.$4j.symbolConstructor),G.set(a.Enum,r.$4j.symbolEnum),G.set(a.Interface,r.$4j.symbolInterface),G.set(a.Function,r.$4j.symbolFunction),G.set(a.Variable,r.$4j.symbolVariable),G.set(a.Constant,r.$4j.symbolConstant),G.set(a.String,r.$4j.symbolString),G.set(a.Number,r.$4j.symbolNumber),G.set(a.Boolean,r.$4j.symbolBoolean),G.set(a.Array,r.$4j.symbolArray),G.set(a.Object,r.$4j.symbolObject),G.set(a.Key,r.$4j.symbolKey),G.set(a.Null,r.$4j.symbolNull),G.set(a.EnumMember,r.$4j.symbolEnumMember),G.set(a.Struct,r.$4j.symbolStruct),G.set(a.Event,r.$4j.symbolEvent),G.set(a.Operator,r.$4j.symbolOperator),G.set(a.TypeParameter,r.$4j.symbolTypeParameter);function K(ee){let ue=G.get(ee);return ue||(console.info("No codicon found for SymbolKind "+ee),ue=r.$4j.symbolProperty),ue}U.toIcon=K})(S||(e.SymbolKinds=S={}));class D{static asEditOperation(G){return A.$It.replace(R.$Ht.lift(G.range),G.text)}}e.$Gu=D;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(G){switch(G){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(G)}constructor(G){this.value=G}}e.$Hu=P;var C;(function(U){U[U.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var p;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(U){function G(K){return!K||typeof K!="object"?!1:typeof K.id=="string"&&typeof K.title=="string"}U.is=G})(v||(e.Command=v={}));var O;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(O||(e.CommentThreadCollapsibleState=O={}));var L;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(L||(e.CommentThreadState=L={}));var F;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(F||(e.CommentThreadApplicability=F={}));var j;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var B;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(B||(e.CommentState=B={}));var M;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class z{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Iu=z,e.$Ju=new N.$qu;var _;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(_||(e.ExternalUriOpenerPriority=_={}));var re;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(Ee[217],Se([7,8]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[218],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[219],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[220],Se([7,8]),function(ce,e){return ce.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[221],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[222],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[223],Se([7,8]),function(ce,e){return ce.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[224],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(Ee[225],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(Ee[226],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[227],Se([7,8]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(Ee[228],Se([7,8]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(Ee[229],Se([7,8]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(Ee[230],Se([7,8]),function(ce,e){return ce.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[231],Se([7,8]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[232],Se([7,8]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(Ee[233],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[234],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[235],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[236],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[237],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[238],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[239],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[240],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[241],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[242],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[243],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[244],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[245],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[246],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/configuration",e)}),define(Ee[247],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(Ee[248],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/views",e)}),define(Ee[249],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[250],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[251],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[252],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[253],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[254],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[255],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[256],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ee[257],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[258],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[259],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[260],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[261],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[262],Se([1,0,27,14,219]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function N(...I){switch(I.length){case 1:return(0,A.localize)(0,null,I[0]);case 2:return(0,A.localize)(1,null,I[0],I[1]);case 3:return(0,A.localize)(2,null,I[0],I[1],I[2]);default:return}}const T=(0,A.localize)(3,null),$=(0,A.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return E.isTripleEq?"===":"==";case R.NotEq:return E.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return E.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return E.lexeme;case R.QuotedStr:return E.lexeme;case R.Error:return E.lexeme;case R.EOF:return"EOF";default:throw(0,h.$9)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(N("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(N("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(N("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const u=this.d,k=this.c.substring(this.d,this.e),b={type:R.Error,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:E}),this.f.push(b)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const u=this.c.substring(this.d,this.e),k=l.b.get(u);k?this.k(k):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,u=!1,k=!1;for(;;){if(E>=this.c.length){this.e=E,this.l($);return}const c=this.c.charCodeAt(E);if(u)u=!1;else if(c===r.CharCode.Slash&&!k){E++;break}else c===r.CharCode.OpenSquareBracket?k=!0:c===r.CharCode.Backslash?u=!0:c===r.CharCode.CloseSquareBracket&&(k=!1);E++}for(;E<this.c.length&&l.a.has(this.c.charCodeAt(E));)E++;this.e=E;const b=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=l});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[263],Se([1,0,23,44,222,411]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=$,e.$Up=l,e.$Vp=I,e.$Wp=E,e.$Xp=u,e.$Yp=k,e.$Zp=b,h=zt(h),A=We(A),R=We(R);const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function $(f){return f=f.trim(),f==="*"||N.test(f)}function l(f){if(!$(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=f.match(N);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function I(f){if(!f)return null;const m=f.majorBase,n=f.majorMustEqual,o=f.minorBase;let i=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(m===0||(i=!1),s=!1);let d=0;if(f.preRelease){const a=T.exec(f.preRelease);if(a){const[,w,y,S]=a;d=Date.UTC(Number(w),Number(y)-1,Number(S))}}return{majorBase:m,majorMustEqual:n,minorBase:o,minorMustEqual:i,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:d}}function E(f,m,n){let o;typeof f=="string"?o=I(l(f)):o=f;let i;m instanceof Date?i=m.getTime():typeof m=="string"&&(i=new Date(m).getTime());let t;if(typeof n=="string"?t=I(l(n)):t=n,!o||!t)return!1;const s=o.majorBase,d=o.minorBase,a=o.patchBase;let w=t.majorBase,y=t.minorBase,S=t.patchBase;const D=t.notBefore;let P=t.majorMustEqual,C=t.minorMustEqual,p=t.patchMustEqual;return t.isMinimum?s>w?!0:s<w?!1:d>y?!0:d<y||i&&i<D?!1:a>=S:(s===1&&w===0&&(!P||!C||!p)&&(w=1,y=0,S=0,P=!0,C=!1,p=!1),s<w?!1:s>w?!P:d<y?!1:d>y?!C:a<S?!1:a>S?!p:!(i&&i<D))}function u(f,m,n,o,i){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([h.default.Error,A.localize(0,null)]),t;if(typeof o.name!="string")return t.push([h.default.Error,A.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([h.default.Error,A.localize(2,null,"version")]),t;if(!o.engines)return t.push([h.default.Error,A.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([h.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!g(o.extensionDependencies))return t.push([h.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!g(o.activationEvents))return t.push([h.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([h.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([h.default.Warning,A.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([h.default.Error,A.localize(9,null,"main")]),t;{const a=(0,r.$fh)(n,o.main);(0,r.$_g)(a,n)||t.push([h.default.Warning,A.localize(10,null,a.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([h.default.Error,A.localize(11,null,"browser")]),t;{const a=(0,r.$fh)(n,o.browser);(0,r.$_g)(a,n)||t.push([h.default.Warning,A.localize(12,null,a.path,n.path)])}}if(!R.valid(o.version))return t.push([h.default.Error,A.localize(13,null)]),t;const s=[];if(!k(f,m,o,i,s))for(const a of s)t.push([h.default.Error,a]);return t}function k(f,m,n,o,i){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:c(f,m,n.engines.vscode,i)}function b(f,m,n){return f==="*"||c(m,n,f)}function c(f,m,n,o=[]){const i=I(l(n));if(!i)return o.push(A.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return o.push(A.localize(15,null,n)),!1}else if(!i.majorMustEqual)return o.push(A.localize(16,null,n)),!1;return E(f,m,i)?!0:(o.push(A.localize(17,null,f,n)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let m=0,n=f.length;m<n;m++)if(typeof f[m]!="string")return!1;return!0}}),define(Ee[113],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class r{constructor(A,R=[],N=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=N}}e.$Bi=r}),define(Ee[89],Se([1,0,113]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=R,e.$Ls=N;const h=[];var A;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R(T,$,l){$ instanceof r.$Bi||($=new r.$Bi($,[],!!l)),h.push([T,$])}function N(){return h}}),define(Ee[264],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class r{constructor(R,N){this.key=R,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$nr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const N of this.a.values())N.outgoing.size===0&&R.push(N);return R}insertEdge(R,N){const T=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(N);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(R){const N=this.b(R);this.a.delete(N);for(const T of this.a.values())T.outgoing.delete(N),T.incoming.delete(N)}lookupOrInsertNode(R){const N=this.b(R);let T=this.a.get(N);return T||(T=new r(N,R),this.a.set(N,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[N,T]of this.a)R.push(`${N}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,N]of this.a){const T=new Set([R]),$=this.c(N,T);if($)return $}}c(R,N){for(const[T,$]of R.outgoing){if(N.has(T))return[...N,T].join(" -> ");N.add(T);const l=this.c($,N);if(l)return l;N.delete(T)}}}e.$or=h}),define(Ee[5],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=A,e.$Fi=R;var r;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function T($){return $[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=T})(r||(e._util=r={})),e.$Di=A("instantiationService");function h(N,T,$){T[r.DI_TARGET]===T?T[r.DI_DEPENDENCIES].push({id:N,index:$}):(T[r.DI_DEPENDENCIES]=[{id:N,index:$}],T[r.DI_TARGET]=T)}function A(N){if(r.serviceIds.has(N))return r.serviceIds.get(N);const T=function($,l,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(T,$,I)};return T.toString=()=>N,r.serviceIds.set(N,T),T}function R(N){return N}}),define(Ee[45],Se([1,0,18,2,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=R,e.$aj=N,e.$bj=$,e.$cj=l,e.$dj=I,e.$ej=E,e.$fj=u,e.$gj=b,e.$hj=c,e.$ij=g,r=We(r),e.$$i=(0,A.$Ei)("configurationService");function R(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof h.URI)}function N(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof h.URI)}var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(f){switch(f){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function I(f,m){const n=Object.create(null);for(const o in f)E(n,o,f[o],m);return n}function E(f,m,n,o){const i=m.split("."),t=i.pop();let s=f;for(let d=0;d<i.length;d++){const a=i[d];let w=s[a];switch(typeof w){case"undefined":w=s[a]=Object.create(null);break;case"object":if(w===null){o(`Ignoring ${m} as ${i.slice(0,d+1).join(".")} is null`);return}break;default:o(`Ignoring ${m} as ${i.slice(0,d+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}function u(f,m){const n=m.split(".");k(f,n)}function k(f,m){const n=m.shift();if(m.length===0){delete f[n];return}if(Object.keys(f).indexOf(n)!==-1){const o=f[n];typeof o=="object"&&!Array.isArray(o)&&(k(o,m),Object.keys(o).length===0&&delete f[n])}}function b(f,m,n){function o(s,d){let a=s;for(const w of d){if(typeof a!="object"||a===null)return;a=a[w]}return a}const i=m.split("."),t=o(f,i);return typeof t>"u"?n:t}function c(f,m,n){Object.keys(m).forEach(o=>{o!=="__proto__"&&(o in f?r.$gg(f[o])&&r.$gg(m[o])?c(f[o],m[o],n):n&&(f[o]=m[o]):f[o]=m[o])})}function g(f){return f.replace(/[\[\]]/g,"")}}),define(Ee[36],Se([1,0,27,11,13,262,5,218,14]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=I,e.$Dj=d,e.$Ej=a,e.$Xj=ne;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",h.$j),l.set("isLinux",h.$k),l.set("isWindows",h.$i),l.set("isWeb",h.$o),l.set("isMacNative",h.$j&&!h.$o),l.set("isEdge",h.$H),l.set("isFirefox",h.$F),l.set("isChrome",h.$E),l.set("isSafari",h.$G);function I(J,W){if(l.get(J)!==void 0)throw(0,$.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(J,W)}const E=Object.prototype.hasOwnProperty;var u;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},b=(0,T.localize)(0,null),c=(0,T.localize)(1,null),g=(0,T.localize)(2,null),f=(0,T.localize)(3,null),m=(0,T.localize)(4,null),n=(0,T.localize)(5,null),o=(0,T.localize)(6,null),i=(0,T.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=k){this.k=W,this.d=new R.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const oe=this.D(),te=oe.type===R.TokenType.Str?n:void 0;throw this.h.push({message:m,offset:oe.offset,lexeme:R.$zj.getLexeme(oe),additionalInfo:te}),t.c}return se}catch(se){if(se!==t.c)throw se;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();W.push(se)}return W.length===1?W[0]:s.or(...W)}o(){const W=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();W.push(se)}return W.length===1?W[0]:s.and(...W)}s(){if(this.y(R.TokenType.Neg)){const W=this.D();switch(W.type){case R.TokenType.True:return this.z(),y.INSTANCE;case R.TokenType.False:return this.z(),S.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,f),se?.negate()}case R.TokenType.Str:return this.z(),O.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case R.TokenType.True:return this.z(),s.true();case R.TokenType.False:return this.z(),s.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,f),se}case R.TokenType.Str:{const se=W.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const le=te.lexeme,he=le.lastIndexOf("/"),Z=he===le.length-1?void 0:this.w(le.substring(he+1));let ae;try{ae=new RegExp(le.substring(1,he),Z)}catch{throw this.B("REGEX",te)}return z.create(se,ae)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const le=[te.lexeme];this.z();let he=this.D(),Z=0;for(let ze=0;ze<te.lexeme.length;ze++)te.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&Z--;for(;!this.E()&&he.type!==R.TokenType.And&&he.type!==R.TokenType.Or;){switch(he.type){case R.TokenType.LParen:Z++;break;case R.TokenType.RParen:Z--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let ze=0;ze<he.lexeme.length;ze++)he.lexeme.charCodeAt(ze)===r.CharCode.OpenParen?Z++:te.lexeme.charCodeAt(ze)===r.CharCode.CloseParen&&Z--}if(Z<0)break;le.push(R.$zj.getLexeme(he)),this.z(),he=this.D()}const ae=le.join(""),pe=ae.lastIndexOf("/"),be=pe===ae.length-1?void 0:this.w(ae.substring(pe+1));let Me;try{Me=new RegExp(ae.substring(1,pe),be)}catch{throw this.B("REGEX",te)}return s.regex(se,Me)}case R.TokenType.QuotedStr:{const le=te.lexeme;this.z();let he=null;if(!(0,A.$cf)(le)){const Z=le.indexOf("/"),ae=le.lastIndexOf("/");if(Z!==ae&&Z>=0){const pe=le.slice(Z+1,ae),be=le[ae+1]==="i"?"i":"";try{he=new RegExp(pe,be)}catch{throw this.B("REGEX",te)}}}if(he===null)throw this.B("REGEX",te);return z.create(se,he)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,g);const te=this.u();return s.notIn(se,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.equals(se,te);switch(te){case"true":return s.has(se);case"false":return s.not(se);default:return s.equals(se,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.notEquals(se,te);switch(te){case"true":return s.not(se);case"false":return s.has(se);default:return s.notEquals(se,te)}}case R.TokenType.Lt:return this.z(),B.create(se,this.u());case R.TokenType.LtEq:return this.z(),M.create(se,this.u());case R.TokenType.Gt:return this.z(),F.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),s.in(se,this.u());default:return s.has(se)}}case R.TokenType.EOF:throw this.h.push({message:o,offset:W.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),W.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,se){if(this.C(W))return this.z();throw this.B(se,this.D())}B(W,se,oe){const te=(0,T.localize)(8,null,W,R.$zj.getLexeme(se)),le=se.offset,he=R.$zj.getLexeme(se);return this.h.push({message:te,offset:le,lexeme:he,additionalInfo:oe}),t.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Bj=t;class s{static false(){return y.INSTANCE}static true(){return S.INSTANCE}static has(W){return D.create(W)}static equals(W,se){return P.create(W,se)}static notEquals(W,se){return v.create(W,se)}static regex(W,se){return z.create(W,se)}static in(W,se){return C.create(W,se)}static notIn(W,se){return p.create(W,se)}static not(W){return O.create(W)}static and(...W){return U.create(W,null,!0)}static or(...W){return G.create(W,null,!0)}static greater(W,se){return F.create(W,se)}static greaterEquals(W,se){return j.create(W,se)}static smaller(W,se){return B.create(W,se)}static smallerEquals(W,se){return M.create(W,se)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Cj=s;function d(J){const W=new t({regexParsingWithErrorRecovery:!1});return J.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,T.localize)(9,null,oe.additionalInfo):(0,T.localize)(10,null),offset:oe.offset,length:oe.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function a(J,W){const se=J?J.substituteConstants():void 0,oe=W?W.substituteConstants():void 0;return!se&&!oe?!0:!se||!oe?!1:se.equals(oe)}function w(J,W){return J.cmp(W)}class y{static{this.INSTANCE=new y}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Fj=y;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return y.INSTANCE}}e.$Gj=S;class D{static create(W,se=null){const oe=l.get(W);return typeof oe=="boolean"?oe?S.INSTANCE:y.INSTANCE:new D(W,se)}constructor(W,se){this.key=W,this.c=se,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?S.INSTANCE:y.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$Hj=D;class P{static create(W,se,oe=null){if(typeof se=="boolean")return se?D.create(W,oe):O.create(W,oe);const te=l.get(W);return typeof te=="boolean"?se===(te?"true":"false")?S.INSTANCE:y.INSTANCE:new P(W,se,oe)}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=l.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?S.INSTANCE:y.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ij=P;class C{static create(W,se){return new C(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.f),oe=W.getValue(this.d);return Array.isArray(se)?se.includes(oe):typeof oe=="string"&&typeof se=="object"&&se!==null?E.call(se,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Jj=C;class p{static create(W,se){return new p(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.NotIn,this.c=C.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=p;class v{static create(W,se,oe=null){if(typeof se=="boolean")return se?O.create(W,oe):D.create(W,oe);const te=l.get(W);return typeof te=="boolean"?se===(te?"true":"false")?y.INSTANCE:S.INSTANCE:new v(W,se,oe)}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=l.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?y.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Lj=v;class O{static create(W,se=null){const oe=l.get(W);return typeof oe=="boolean"?oe?y.INSTANCE:S.INSTANCE:new O(W,se)}constructor(W,se){this.c=W,this.d=se,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=l.get(this.c);return typeof W=="boolean"?W?y.INSTANCE:S.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Mj=O;function L(J,W){if(typeof J=="string"){const se=parseFloat(J);isNaN(se)||(J=se)}return typeof J=="string"||typeof J=="number"?W(J):y.INSTANCE}class F{static create(W,se,oe=null){return L(se,te=>new F(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Nj=F;class j{static create(W,se,oe=null){return L(se,te=>new j(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Oj=j;class B{static create(W,se,oe=null){return L(se,te=>new B(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Pj=B;class M{static create(W,se,oe=null){return L(se,te=>new M(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Qj=M;class z{static create(W,se){return new z(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const se=this.f?this.f.source:"",oe=W.f?W.f.source:"";return se<oe?-1:se>oe?1:0}equals(W){if(W.type===this.type){const se=this.f?this.f.source:"",oe=W.f?W.f.source:"";return this.d===W.d&&se===oe}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.$Rj=z;class _{static create(W){return new _(W)}constructor(W){this.c=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new _(this.c.map(W))}negate(){return this.c}}e.$Sj=_;function re(J){let W=null;for(let se=0,oe=J.length;se<oe;se++){const te=J[se].substituteConstants();if(J[se]!==te&&W===null){W=[];for(let le=0;le<se;le++)W[le]=J[le]}W!==null&&(W[se]=te)}return W===null?J:W}class U{static create(W,se,oe){return U.d(W,se,oe)}constructor(W,se){this.expr=W,this.c=se,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:U.create(W,this.c,!1)}evaluate(W){for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static d(W,se,oe){const te=[];let le=!1;for(const he of W)if(he){if(he.type===u.True){le=!0;continue}if(he.type===u.False)return y.INSTANCE;if(he.type===u.And){te.push(...he.expr);continue}te.push(he)}if(te.length===0&&le)return S.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(w);for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];for(;te.length>1;){const he=te[te.length-1];if(he.type!==u.Or)break;te.pop();const Z=te.pop(),ae=te.length===0,pe=G.create(he.expr.map(be=>U.create([be,Z],null,oe)),null,ae);pe&&(te.push(pe),te.sort(w))}if(te.length===1)return te[0];if(oe){for(let he=0;he<te.length;he++)for(let Z=he+1;Z<te.length;Z++)if(te[he].negate().equals(te[Z]))return y.INSTANCE;if(te.length===1)return te[0]}return new U(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new U(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());this.c=G.create(W,this,!0)}return this.c}}e.$Tj=U;class G{static create(W,se,oe){return G.d(W,se,oe)}constructor(W,se){this.expr=W,this.c=se,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:G.create(W,this.c,!1)}evaluate(W){for(let se=0,oe=this.expr.length;se<oe;se++)if(this.expr[se].evaluate(W))return!0;return!1}static d(W,se,oe){let te=[],le=!1;if(W){for(let he=0,Z=W.length;he<Z;he++){const ae=W[he];if(ae){if(ae.type===u.False){le=!0;continue}if(ae.type===u.True)return S.INSTANCE;if(ae.type===u.Or){te=te.concat(ae.expr);continue}te.push(ae)}}if(te.length===0&&le)return y.INSTANCE;te.sort(w)}if(te.length!==0){if(te.length===1)return te[0];for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];if(oe){for(let he=0;he<te.length;he++)for(let Z=he+1;Z<te.length;Z++)if(te[he].negate().equals(te[Z]))return S.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new G(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),oe=W.shift(),te=[];for(const le of $e(se))for(const he of $e(oe))te.push(U.create([le,he],null,!1));W.unshift(G.create(te,null,!1))}this.c=G.create(W,this,!0)}return this.c}}e.$Uj=G;class K extends D{static{this.d=[]}static all(){return K.d.values()}constructor(W,se,oe){super(W,null),this.f=se,typeof oe=="object"?K.d.push({...oe,key:W}):oe!==!0&&K.d.push({key:W,description:oe,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return v.create(this.key,W)}}e.$Vj=K,e.$Wj=(0,N.$Ei)("contextKeyService");function ee(J,W){return J<W?-1:J>W?1:0}function ue(J,W,se,oe){return J<se?-1:J>se?1:W<oe?-1:W>oe?1:0}function ne(J,W){if(J.type===u.False||W.type===u.True)return!0;if(J.type===u.Or)return W.type===u.Or?De(J.expr,W.expr):!1;if(W.type===u.Or){for(const se of W.expr)if(ne(J,se))return!0;return!1}if(J.type===u.And){if(W.type===u.And)return De(W.expr,J.expr);for(const se of J.expr)if(ne(se,W))return!0;return!1}return J.equals(W)}function De(J,W){let se=0,oe=0;for(;se<J.length&&oe<W.length;){const te=J[se].cmp(W[oe]);if(te<0)return!1;te===0&&se++,oe++}return se===J.length}function $e(J){return J.type===u.Or?J.expr:[J]}}),define(Ee[265],Se([1,0,36,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$lt=e.AccessibilitySupport=e.$kt=void 0,e.$mt=R,e.$kt=(0,h.$Ei)("accessibilityService");var A;(function(N){N[N.Unknown=0]="Unknown",N[N.Disabled=1]="Disabled",N[N.Enabled=2]="Enabled"})(A||(e.AccessibilitySupport=A={})),e.$lt=new r.$Vj("accessibilityModeEnabled",!1);function R(N){return N&&typeof N=="object"&&typeof N.label=="string"&&(typeof N.role>"u"||typeof N.role=="string")}e.$nt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[114],Se([1,0,19,25,11,183,84,191,138,215,265]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=s,e.stringSet=w,e.cursorStyleToString=L,e.filterValidationDecorations=Ie,r=We(r),h=We(h),A=We(A),l=We(l);var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(de){this.c=de}hasChanged(de){return this.c[de]}}e.ConfigurationChangedEvent=u;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class b{constructor(de,Ce,Ze,_e){this.id=de,this.name=Ce,this.defaultValue=Ze,this.schema=_e}applyUpdate(de,Ce){return g(de,Ce)}compute(de,Ce,Ze){return Ze}}class c{constructor(de,Ce){this.newValue=de,this.didChange=Ce}}e.ApplyUpdateResult=c;function g(X,de){if(typeof X!="object"||typeof de!="object"||!X||!de)return new c(de,X!==de);if(Array.isArray(X)||Array.isArray(de)){const Ze=Array.isArray(X)&&Array.isArray(de)&&r.$vb(X,de);return new c(de,!Ze)}let Ce=!1;for(const Ze in de)if(de.hasOwnProperty(Ze)){const _e=g(X[Ze],de[Ze]);_e.didChange&&(X[Ze]=_e.newValue,Ce=!0)}return new c(X,Ce)}class f{constructor(de){this.schema=void 0,this.id=de,this.name="_never_",this.defaultValue=void 0}applyUpdate(de,Ce){return g(de,Ce)}validate(de){return this.defaultValue}}class m{constructor(de,Ce,Ze,_e){this.id=de,this.name=Ce,this.defaultValue=Ze,this.schema=_e}applyUpdate(de,Ce){return g(de,Ce)}validate(de){return typeof de>"u"?this.defaultValue:de}compute(de,Ce,Ze){return Ze}}function n(X,de){return typeof X>"u"?de:X==="false"?!1:!!X}class o extends m{constructor(de,Ce,Ze,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Ze),super(de,Ce,Ze,_e)}validate(de){return n(de,this.defaultValue)}}function i(X,de,Ce,Ze){if(typeof X>"u")return de;let _e=parseInt(X,10);return isNaN(_e)?de:(_e=Math.max(Ce,_e),_e=Math.min(Ze,_e),_e|0)}class t extends m{static clampedInt(de,Ce,Ze,_e){return i(de,Ce,Ze,_e)}constructor(de,Ce,Ze,_e,lt,ft=void 0){typeof ft<"u"&&(ft.type="integer",ft.default=Ze,ft.minimum=_e,ft.maximum=lt),super(de,Ce,Ze,ft),this.minimum=_e,this.maximum=lt}validate(de){return t.clampedInt(de,this.defaultValue,this.minimum,this.maximum)}}function s(X,de,Ce,Ze){if(typeof X>"u")return de;const _e=d.float(X,de);return d.clamp(_e,Ce,Ze)}class d extends m{static clamp(de,Ce,Ze){return de<Ce?Ce:de>Ze?Ze:de}static float(de,Ce){if(typeof de=="number")return de;if(typeof de>"u")return Ce;const Ze=parseFloat(de);return isNaN(Ze)?Ce:Ze}constructor(de,Ce,Ze,_e,lt){typeof lt<"u"&&(lt.type="number",lt.default=Ze),super(de,Ce,Ze,lt),this.validationFn=_e}validate(de){return this.validationFn(d.float(de,this.defaultValue))}}class a extends m{static string(de,Ce){return typeof de!="string"?Ce:de}constructor(de,Ce,Ze,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Ze),super(de,Ce,Ze,_e)}validate(de){return a.string(de,this.defaultValue)}}function w(X,de,Ce,Ze){return typeof X!="string"?de:Ze&&X in Ze?Ze[X]:Ce.indexOf(X)===-1?de:X}class y extends m{constructor(de,Ce,Ze,_e,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Ze),super(de,Ce,Ze,lt),this.c=_e}validate(de){return w(de,this.defaultValue,this.c)}}class S extends b{constructor(de,Ce,Ze,_e,lt,ft,kt=void 0){typeof kt<"u"&&(kt.type="string",kt.enum=lt,kt.default=_e),super(de,Ce,Ze,kt),this.c=lt,this.d=ft}validate(de){return typeof de!="string"?this.defaultValue:this.c.indexOf(de)===-1?this.defaultValue:this.d(de)}}function D(X){switch(X){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class P extends b{constructor(){super(Fe.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(de){switch(de){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(de,Ce,Ze){return Ze===I.AccessibilitySupport.Unknown?de.accessibilitySupport:Ze}}class C extends b{constructor(){const de={insertSpace:!0,ignoreEmptyLines:!0};super(Fe.comments,"comments",de,{"editor.comments.insertSpace":{type:"boolean",default:de.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:de.ignoreEmptyLines,description:l.localize(5,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(X){switch(X){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var O;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(O||(e.TextEditorCursorStyle=O={}));function L(X){switch(X){case O.Line:return"line";case O.Block:return"block";case O.Underline:return"underline";case O.LineThin:return"line-thin";case O.BlockOutline:return"block-outline";case O.UnderlineThin:return"underline-thin"}}function F(X){switch(X){case"line":return O.Line;case"block":return O.Block;case"underline":return O.Underline;case"line-thin":return O.LineThin;case"block-outline":return O.BlockOutline;case"underline-thin":return O.UnderlineThin}}class j extends f{constructor(){super(Fe.editorClassName)}compute(de,Ce,Ze){const _e=["monaco-editor"];return Ce.get(Fe.extraEditorClassName)&&_e.push(Ce.get(Fe.extraEditorClassName)),de.extraEditorClassName&&_e.push(de.extraEditorClassName),Ce.get(Fe.mouseStyle)==="default"?_e.push("mouse-default"):Ce.get(Fe.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ce.get(Fe.showUnused)&&_e.push("showUnused"),Ce.get(Fe.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class B extends o{constructor(){super(Fe.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(de,Ce,Ze){return Ze&&de.emptySelectionClipboard}}class M extends b{constructor(){const de={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Fe.find,"find",de,{"editor.find.cursorMoveOnType":{type:"boolean",default:de.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:de.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:de.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:de.globalFindClipboard,description:l.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:de.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:de.loop,description:l.localize(18,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof de.seedSearchStringFromSelection=="boolean"?de.seedSearchStringFromSelection?"always":"never":w(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof de.autoFindInSelection=="boolean"?de.autoFindInSelection?"always":"never":w(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class z extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Fe.fontLigatures,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"||de.length===0?z.OFF:de==="true"?z.ON:de:de?z.ON:z.OFF}}e.EditorFontLigatures=z;class _ extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Fe.fontVariations,"fontVariations",_.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"?_.OFF:de==="true"?_.TRANSLATE:de:de?_.TRANSLATE:_.OFF}compute(de,Ce,Ze){return de.fontInfo.fontVariationSettings}}e.EditorFontVariations=_;class re extends f{constructor(){super(Fe.fontInfo)}compute(de,Ce,Ze){return de.fontInfo}}class U extends m{constructor(){super(Fe.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(de){const Ce=d.float(de,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ce,6,100)}compute(de,Ce,Ze){return de.fontInfo.fontSize}}class G extends b{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Fe.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(de){return de==="normal"||de==="bold"?de:String(t.clampedInt(de,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class K extends b{constructor(){const de={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:de.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Fe.gotoLocation,"gotoLocation",de,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:de.alternativeDefinitionCommand,enum:Ze,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:de.alternativeTypeDefinitionCommand,enum:Ze,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:de.alternativeDeclarationCommand,enum:Ze,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:de.alternativeImplementationCommand,enum:Ze,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:de.alternativeReferenceCommand,enum:Ze,description:l.localize(41,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:a.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:a.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:a.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:a.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:a.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends b{constructor(){const de={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Fe.hover,"hover",de,{"editor.hover.enabled":{type:"boolean",default:de.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:de.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:de.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:de.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:de.above,description:l.localize(46,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:t.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var ue;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class ne extends f{constructor(){super(Fe.layoutInfo)}compute(de,Ce,Ze){return ne.computeLayout(Ce,{memory:de.memory,outerWidth:de.outerWidth,outerHeight:de.outerHeight,isDominatedByLongLines:de.isDominatedByLongLines,lineHeight:de.fontInfo.lineHeight,viewLineCount:de.viewLineCount,lineNumbersDigitCount:de.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:de.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:de.fontInfo.maxDigitWidth,pixelRatio:de.pixelRatio,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(de){const Ce=de.height/de.lineHeight,Ze=Math.floor(de.paddingTop/de.lineHeight);let _e=Math.floor(de.paddingBottom/de.lineHeight);de.scrollBeyondLastLine&&(_e=Math.max(_e,Ce-1));const lt=(Ze+de.viewLineCount+_e)/(de.pixelRatio*de.height),ft=Math.floor(de.viewLineCount/lt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:_e,desiredRatio:lt,minimapLineCount:ft}}static c(de,Ce){const Ze=de.outerWidth,_e=de.outerHeight,lt=de.pixelRatio;if(!de.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const ft=Ce.stableMinimapLayoutInput,kt=ft&&de.outerHeight===ft.outerHeight&&de.lineHeight===ft.lineHeight&&de.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&de.pixelRatio===ft.pixelRatio&&de.scrollBeyondLastLine===ft.scrollBeyondLastLine&&de.paddingTop===ft.paddingTop&&de.paddingBottom===ft.paddingBottom&&de.minimap.enabled===ft.minimap.enabled&&de.minimap.side===ft.minimap.side&&de.minimap.size===ft.minimap.size&&de.minimap.showSlider===ft.minimap.showSlider&&de.minimap.renderCharacters===ft.minimap.renderCharacters&&de.minimap.maxColumn===ft.minimap.maxColumn&&de.minimap.scale===ft.minimap.scale&&de.verticalScrollbarWidth===ft.verticalScrollbarWidth&&de.isViewportWrapping===ft.isViewportWrapping,Tt=de.lineHeight,Ut=de.typicalHalfwidthCharacterWidth,ui=de.scrollBeyondLastLine,it=de.minimap.renderCharacters;let Ct=lt>=2?Math.round(de.minimap.scale*2):de.minimap.scale;const Yt=de.minimap.maxColumn,mt=de.minimap.size,bt=de.minimap.side,hi=de.verticalScrollbarWidth,ei=de.viewLineCount,Wt=de.remainingWidth,wt=de.isViewportWrapping,Vt=it?2:3;let Qt=Math.floor(lt*_e);const Zt=Qt/lt;let xe=!1,$i=!1,ti=Vt*Ct,si=Ct/lt,Dt=1;if(mt==="fill"||mt==="fit"){const{typicalViewportLineCount:qt,extraLinesBeforeFirstLine:Jt,extraLinesBeyondLastLine:di,desiredRatio:jt,minimapLineCount:vt}=ne.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:ui,paddingTop:de.paddingTop,paddingBottom:de.paddingBottom,height:_e,lineHeight:Tt,pixelRatio:lt});if(ei/vt>1)xe=!0,$i=!0,Ct=1,ti=1,si=Ct/lt;else{let Lt=!1,It=Ct+1;if(mt==="fit"){const Xt=Math.ceil((Jt+ei+di)*ti);wt&&kt&&Wt<=Ce.stableFitRemainingWidth?(Lt=!0,It=Ce.stableFitMaxMinimapScale):Lt=Xt>Qt}if(mt==="fill"||Lt){xe=!0;const Xt=Ct;ti=Math.min(Tt*lt,Math.max(1,Math.floor(1/jt))),wt&&kt&&Wt<=Ce.stableFitRemainingWidth&&(It=Ce.stableFitMaxMinimapScale),Ct=Math.min(It,Math.max(1,Math.floor(ti/Vt))),Ct>Xt&&(Dt=Math.min(2,Ct/Xt)),si=Ct/lt/Dt,Qt=Math.ceil(Math.max(qt,Jt+ei+di)*ti),wt?(Ce.stableMinimapLayoutInput=de,Ce.stableFitRemainingWidth=Wt,Ce.stableFitMaxMinimapScale=Ct):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Kt=Math.floor(Yt*si),Nt=Math.min(Kt,Math.max(0,Math.floor((Wt-hi-2)*si/(Ut+si)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(lt*Nt);const ii=Ft/lt;Ft=Math.floor(Ft*Dt);const ni=it?ue.Text:ue.Blocks,oi=bt==="left"?0:Ze-Nt-hi;return{renderMinimap:ni,minimapLeft:oi,minimapWidth:Nt,minimapHeightIsEditorHeight:xe,minimapIsSampling:$i,minimapScale:Ct,minimapLineHeight:ti,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:Qt,minimapCanvasOuterWidth:ii,minimapCanvasOuterHeight:Zt}}static computeLayout(de,Ce){const Ze=Ce.outerWidth|0,_e=Ce.outerHeight|0,lt=Ce.lineHeight|0,ft=Ce.lineNumbersDigitCount|0,kt=Ce.typicalHalfwidthCharacterWidth,Tt=Ce.maxDigitWidth,Ut=Ce.pixelRatio,ui=Ce.viewLineCount,it=de.get(Fe.wordWrapOverride2),Ct=it==="inherit"?de.get(Fe.wordWrapOverride1):it,Yt=Ct==="inherit"?de.get(Fe.wordWrap):Ct,mt=de.get(Fe.wordWrapColumn),bt=Ce.isDominatedByLongLines,hi=de.get(Fe.glyphMargin),ei=de.get(Fe.lineNumbers).renderType!==ze.Off,Wt=de.get(Fe.lineNumbersMinChars),wt=de.get(Fe.scrollBeyondLastLine),Vt=de.get(Fe.padding),Qt=de.get(Fe.minimap),Zt=de.get(Fe.scrollbar),xe=Zt.verticalScrollbarSize,$i=Zt.verticalHasArrows,ti=Zt.arrowSize,si=Zt.horizontalScrollbarSize,Dt=de.get(Fe.folding),Kt=de.get(Fe.showFoldingControls)!=="never";let Nt=de.get(Fe.lineDecorationsWidth);Dt&&Kt&&(Nt+=16);let Ft=0;if(ei){const pi=Math.max(ft,Wt);Ft=Math.round(pi*Tt)}let ii=0;hi&&(ii=lt*Ce.glyphMarginDecorationLaneCount);let ni=0,oi=ni+ii,qt=oi+Ft,Jt=qt+Nt;const di=Ze-ii-Ft-Nt;let jt=!1,vt=!1,Pt=-1;Ct==="inherit"&&bt?(jt=!0,vt=!0):Yt==="on"||Yt==="bounded"?vt=!0:Yt==="wordWrapColumn"&&(Pt=mt);const Lt=ne.c({outerWidth:Ze,outerHeight:_e,lineHeight:lt,typicalHalfwidthCharacterWidth:kt,pixelRatio:Ut,scrollBeyondLastLine:wt,paddingTop:Vt.top,paddingBottom:Vt.bottom,minimap:Qt,verticalScrollbarWidth:xe,viewLineCount:ui,remainingWidth:di,isViewportWrapping:vt},Ce.memory||new k);Lt.renderMinimap!==ue.None&&Lt.minimapLeft===0&&(ni+=Lt.minimapWidth,oi+=Lt.minimapWidth,qt+=Lt.minimapWidth,Jt+=Lt.minimapWidth);const It=di-Lt.minimapWidth,Xt=Math.max(1,Math.floor((It-xe-2)/kt)),Ht=$i?ti:0;return vt&&(Pt=Math.max(1,Xt),Yt==="bounded"&&(Pt=Math.min(Pt,mt))),{width:Ze,height:_e,glyphMarginLeft:ni,glyphMarginWidth:ii,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:oi,lineNumbersWidth:Ft,decorationsLeft:qt,decorationsWidth:Nt,contentLeft:Jt,contentWidth:It,minimap:Lt,viewportColumn:Xt,isWordWrapMinified:jt,isViewportWrapping:vt,wrappingColumn:Pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:si,overviewRuler:{top:Ht,width:xe,height:_e-2*Ht,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends b{constructor(){super(Fe.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(de){return w(de,"simple",["simple","advanced"])}compute(de,Ce,Ze){return Ce.get(Fe.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Ze}}var $e;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class J extends b{constructor(){const de={enabled:$e.On};super(Fe.lightbulb,"lightbulb",de,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:de.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{enabled:w(de.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class W extends b{constructor(){const de={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Fe.stickyScroll,"stickyScroll",de,{"editor.stickyScroll.enabled":{type:"boolean",default:de.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:de.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:de.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:de.scrollWithEditor,description:l.localize(57,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends b{constructor(){const de={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Fe.inlayHints,"inlayHints",de,{"editor.inlayHints.enabled":{type:"string",default:de.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:de.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:de.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:de.padding,description:l.localize(65,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:w(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class oe extends b{constructor(){super(Fe.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(de){return typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)?-parseFloat(de.substring(0,de.length-2)):t.clampedInt(de,this.defaultValue,0,1e3)}compute(de,Ce,Ze){return Ze<0?t.clampedInt(-Ze*de.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ze}}class te extends d{constructor(){super(Fe.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,de=>d.clamp(de,0,150),{markdownDescription:l.localize(66,null)})}compute(de,Ce,Ze){return de.fontInfo.lineHeight}}class le extends b{constructor(){const de={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Fe.minimap,"minimap",de,{"editor.minimap.enabled":{type:"boolean",default:de.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:de.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:de.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:de.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:de.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:de.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:de.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:de.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:de.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:de.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:de.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:de.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:w(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ce.side,this.defaultValue.side,["right","left"]),showSlider:w(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Ce.scale,1,1,3),maxColumn:t.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(X){return X==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class Z extends b{constructor(){super(Fe.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{top:t.clampedInt(Ce.top,0,0,1e3),bottom:t.clampedInt(Ce.bottom,0,0,1e3)}}}class ae extends b{constructor(){const de={enabled:!0,cycle:!0};super(Fe.parameterHints,"parameterHints",de,{"editor.parameterHints.enabled":{type:"boolean",default:de.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:de.cycle,description:l.localize(85,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class pe extends f{constructor(){super(Fe.pixelRatio)}compute(de,Ce,Ze){return de.pixelRatio}}class be extends b{constructor(){super(Fe.placeholder,"placeholder",void 0)}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de:this.defaultValue}}class Me extends b{constructor(){const de={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(Fe.quickSuggestions,"quickSuggestions",de,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:de.strings,description:l.localize(89,null)},comments:{anyOf:Ce,default:de.comments,description:l.localize(90,null)},other:{anyOf:Ce,default:de.other,description:l.localize(91,null)}},default:de,markdownDescription:l.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=de}validate(de){if(typeof de=="boolean"){const Ut=de?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!de||typeof de!="object")return this.defaultValue;const{other:Ce,comments:Ze,strings:_e}=de,lt=["on","inline","off"];let ft,kt,Tt;return typeof Ce=="boolean"?ft=Ce?"on":"off":ft=w(Ce,this.defaultValue.other,lt),typeof Ze=="boolean"?kt=Ze?"on":"off":kt=w(Ze,this.defaultValue.comments,lt),typeof _e=="boolean"?Tt=_e?"on":"off":Tt=w(_e,this.defaultValue.strings,lt),{other:ft,comments:kt,strings:Tt}}}var ze;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends b{constructor(){super(Fe.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(de){let Ce=this.defaultValue.renderType,Ze=this.defaultValue.renderFn;return typeof de<"u"&&(typeof de=="function"?(Ce=ze.Custom,Ze=de):de==="interval"?Ce=ze.Interval:de==="relative"?Ce=ze.Relative:de==="on"?Ce=ze.On:Ce=ze.Off),{renderType:Ce,renderFn:Ze}}}function Ie(X){const de=X.get(Fe.renderValidationDecorations);return de==="editable"?X.get(Fe.readOnly):de!=="on"}class Te extends b{constructor(){const de=[],Ce={type:"number",description:l.localize(98,null)};super(Fe.rulers,"rulers",de,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:de,description:l.localize(100,null)})}validate(de){if(Array.isArray(de)){const Ce=[];for(const Ze of de)if(typeof Ze=="number")Ce.push({column:t.clampedInt(Ze,0,0,1e4),color:null});else if(Ze&&typeof Ze=="object"){const _e=Ze;Ce.push({column:t.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ce.sort((Ze,_e)=>Ze.column-_e.column),Ce}return this.defaultValue}}class V extends b{constructor(){super(Fe.readOnlyMessage,"readOnlyMessage",void 0)}validate(de){return!de||typeof de!="object"?this.defaultValue:de}}function q(X,de){if(typeof X!="string")return de;switch(X){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class Q extends b{constructor(){const de={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Fe.scrollbar,"scrollbar",de,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:de.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:de.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:de.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:de.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de,Ze=t.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=t.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:q(Ce.vertical,this.defaultValue.vertical),horizontal:q(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ze,horizontalSliderSize:t.clampedInt(Ce.horizontalSliderSize,Ze,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:t.clampedInt(Ce.verticalSliderSize,_e,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends b{constructor(){const de={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Fe.unicodeHighlighting,"unicodeHighlight",de,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:de.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:de.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:de.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:de.allowedLocales,description:l.localize(119,null)}})}applyUpdate(de,Ce){let Ze=!1;Ce.allowedCharacters&&de&&(h.$fo(de.allowedCharacters,Ce.allowedCharacters)||(de={...de,allowedCharacters:Ce.allowedCharacters},Ze=!0)),Ce.allowedLocales&&de&&(h.$fo(de.allowedLocales,Ce.allowedLocales)||(de={...de,allowedLocales:Ce.allowedLocales},Ze=!0));const _e=super.applyUpdate(de,Ce);return Ze?new c(_e.newValue,!0):_e}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{nonBasicASCII:Ke(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(de.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(de.allowedLocales,this.defaultValue.allowedLocales)}}c(de,Ce){if(typeof de!="object"||!de)return Ce;const Ze={};for(const[_e,lt]of Object.entries(de))lt===!0&&(Ze[_e]=!0);return Ze}}class fe extends b{constructor(){const de={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Fe.inlineSuggest,"inlineSuggest",de,{"editor.inlineSuggest.enabled":{type:"boolean",default:de.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:de.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(126,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:w(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class we extends b{constructor(){const de={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Fe.inlineEdit,"experimentalInlineEdit",de,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:de.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:de.backgroundColoring,description:l.localize(133,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Oe extends b{constructor(){const de={enabled:T.$et.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$et.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Fe.bracketPairColorization,"bracketPairColorization",de,{"editor.bracketPairColorization.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:de.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends b{constructor(){const de={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Fe.guides,"guides",de,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:de.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:de.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:de.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:de.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:de.highlightActiveIndentation,description:l.localize(149,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{bracketPairs:Ke(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(X,de,Ce){const Ze=Ce.indexOf(X);return Ze===-1?de:Ce[Ze]}class tt extends b{constructor(){const de={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Fe.suggest,"suggest",de,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:de.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:de.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:de.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:de.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:de.selectionMode,markdownDescription:l.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:de.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:de.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:de.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:de.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:de.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertMode:w(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:w(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class rt extends b{constructor(){super(Fe.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(de.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(de.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends b{constructor(){const de=[];super(Fe.wordSegmenterLocales,"wordSegmenterLocales",de,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(de){if(typeof de=="string"&&(de=[de]),Array.isArray(de)){const Ce=[];for(const Ze of de)if(typeof Ze=="string")try{Intl.Segmenter.supportedLocalesOf(Ze).length>0&&Ce.push(Ze)}catch{}return Ce}return this.defaultValue}}var nt;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ct extends b{constructor(){super(Fe.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(de){switch(de){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(de,Ce,Ze){return Ce.get(Fe.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Ze}}class $t extends f{constructor(){super(Fe.wrappingInfo)}compute(de,Ce,Ze){const _e=Ce.get(Fe.layoutInfo);return{isDominatedByLongLines:de.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class ht extends b{constructor(){const de={enabled:!0,showDropSelector:"afterDrop"};super(Fe.dropIntoEditor,"dropIntoEditor",de,{"editor.dropIntoEditor.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:w(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends b{constructor(){const de={enabled:!0,showPasteSelector:"afterPaste"};super(Fe.pasteAs,"pasteAs",de,{"editor.pasteAs.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:w(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?Be:A.$k?Ye:Pe,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(X){return e.editorOptionsRegistry[X.id]=X,X}var Fe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.placeholder=88]="placeholder",X[X.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",X[X.quickSuggestions=90]="quickSuggestions",X[X.quickSuggestionsDelay=91]="quickSuggestionsDelay",X[X.readOnly=92]="readOnly",X[X.readOnlyMessage=93]="readOnlyMessage",X[X.renameOnType=94]="renameOnType",X[X.renderControlCharacters=95]="renderControlCharacters",X[X.renderFinalNewline=96]="renderFinalNewline",X[X.renderLineHighlight=97]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=99]="renderValidationDecorations",X[X.renderWhitespace=100]="renderWhitespace",X[X.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",X[X.roundedSelection=102]="roundedSelection",X[X.rulers=103]="rulers",X[X.scrollbar=104]="scrollbar",X[X.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=106]="scrollBeyondLastLine",X[X.scrollPredominantAxis=107]="scrollPredominantAxis",X[X.selectionClipboard=108]="selectionClipboard",X[X.selectionHighlight=109]="selectionHighlight",X[X.selectOnLineNumbers=110]="selectOnLineNumbers",X[X.showFoldingControls=111]="showFoldingControls",X[X.showUnused=112]="showUnused",X[X.snippetSuggestions=113]="snippetSuggestions",X[X.smartSelect=114]="smartSelect",X[X.smoothScrolling=115]="smoothScrolling",X[X.stickyScroll=116]="stickyScroll",X[X.stickyTabStops=117]="stickyTabStops",X[X.stopRenderingLineAfter=118]="stopRenderingLineAfter",X[X.suggest=119]="suggest",X[X.suggestFontSize=120]="suggestFontSize",X[X.suggestLineHeight=121]="suggestLineHeight",X[X.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",X[X.suggestSelection=123]="suggestSelection",X[X.tabCompletion=124]="tabCompletion",X[X.tabIndex=125]="tabIndex",X[X.unicodeHighlighting=126]="unicodeHighlighting",X[X.unusualLineTerminators=127]="unusualLineTerminators",X[X.useShadowDOM=128]="useShadowDOM",X[X.useTabStops=129]="useTabStops",X[X.wordBreak=130]="wordBreak",X[X.wordSegmenterLocales=131]="wordSegmenterLocales",X[X.wordSeparators=132]="wordSeparators",X[X.wordWrap=133]="wordWrap",X[X.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=136]="wordWrapColumn",X[X.wordWrapOverride1=137]="wordWrapOverride1",X[X.wordWrapOverride2=138]="wordWrapOverride2",X[X.wrappingIndent=139]="wrappingIndent",X[X.wrappingStrategy=140]="wrappingStrategy",X[X.showDeprecated=141]="showDeprecated",X[X.inlayHints=142]="inlayHints",X[X.editorClassName=143]="editorClassName",X[X.pixelRatio=144]="pixelRatio",X[X.tabFocusMode=145]="tabFocusMode",X[X.layoutInfo=146]="layoutInfo",X[X.wrappingInfo=147]="wrappingInfo",X[X.defaultColorDecorators=148]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Fe||(e.EditorOption=Fe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(Fe.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:Le(new y(Fe.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:Le(new P),accessibilityPageSize:Le(new t(Fe.accessibilityPageSize,"accessibilityPageSize",10,1,N.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:Le(new a(Fe.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:Le(new o(Fe.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(Fe.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Le(new y(Fe.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:Le(new y(Fe.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:Le(new y(Fe.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:Le(new y(Fe.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:Le(new y(Fe.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:Le(new S(Fe.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:Le(new o(Fe.automaticLayout,"automaticLayout",!1)),autoSurround:Le(new y(Fe.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:Le(new Oe),bracketPairGuides:Le(new Ge),stickyTabStops:Le(new o(Fe.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:Le(new o(Fe.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:Le(new a(Fe.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:Le(new t(Fe.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:Le(new o(Fe.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:Le(new y(Fe.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:Le(new t(Fe.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:Le(new o(Fe.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:Le(new C),contextmenu:Le(new o(Fe.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(Fe.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:Le(new S(Fe.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:Le(new y(Fe.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:Le(new S(Fe.cursorStyle,"cursorStyle",O.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:l.localize(261,null)})),cursorSurroundingLines:Le(new t(Fe.cursorSurroundingLines,"cursorSurroundingLines",0,0,N.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:Le(new y(Fe.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:Le(new t(Fe.cursorWidth,"cursorWidth",0,0,N.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:Le(new o(Fe.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(Fe.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(Fe.domReadOnly,"domReadOnly",!1)),dragAndDrop:Le(new o(Fe.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:Le(new B),dropIntoEditor:Le(new ht),stickyScroll:Le(new W),experimentalWhitespaceRendering:Le(new y(Fe.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:Le(new a(Fe.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Le(new d(Fe.fastScrollSensitivity,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:l.localize(272,null)})),find:Le(new M),fixedOverflowWidgets:Le(new o(Fe.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Le(new o(Fe.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:Le(new y(Fe.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:Le(new o(Fe.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:Le(new o(Fe.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:Le(new t(Fe.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:Le(new o(Fe.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:Le(new a(Fe.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:Le(new re),fontLigatures2:Le(new z),fontSize:Le(new U),fontWeight:Le(new G),fontVariations:Le(new _),formatOnPaste:Le(new o(Fe.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:Le(new o(Fe.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:Le(new o(Fe.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:Le(new K),hideCursorInOverviewRuler:Le(new o(Fe.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:Le(new ee),inDiffEditor:Le(new o(Fe.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Le(new d(Fe.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:l.localize(286,null)})),lightbulb:Le(new J),lineDecorationsWidth:Le(new oe),lineHeight:Le(new te),lineNumbers:Le(new ke),lineNumbersMinChars:Le(new t(Fe.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(Fe.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:Le(new o(Fe.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:Le(new y(Fe.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:Le(new le),mouseStyle:Le(new y(Fe.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new d(Fe.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:Le(new o(Fe.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:A.$j?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:Le(new o(Fe.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:Le(new S(Fe.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:Le(new y(Fe.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:Le(new t(Fe.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:Le(new y(Fe.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:Le(new o(Fe.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:Le(new t(Fe.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Le(new Z),pasteAs:Le(new at),parameterHints:Le(new ae),peekWidgetDefaultFocus:Le(new y(Fe.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),placeholder:Le(new be),definitionLinkOpensInPeek:Le(new o(Fe.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:Le(new Me),quickSuggestionsDelay:Le(new t(Fe.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,N.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:Le(new o(Fe.readOnly,"readOnly",!1)),readOnlyMessage:Le(new V),renameOnType:Le(new o(Fe.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:Le(new o(Fe.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:Le(new y(Fe.renderFinalNewline,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:Le(new y(Fe.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(Fe.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:Le(new y(Fe.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new y(Fe.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:Le(new t(Fe.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(Fe.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:Le(new Te),scrollbar:Le(new Q),scrollBeyondLastColumn:Le(new t(Fe.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,N.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:Le(new o(Fe.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:Le(new o(Fe.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:Le(new o(Fe.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:A.$k})),selectionHighlight:Le(new o(Fe.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:Le(new o(Fe.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Le(new y(Fe.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:Le(new o(Fe.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:Le(new o(Fe.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:Le(new se),snippetSuggestions:Le(new y(Fe.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:Le(new rt),smoothScrolling:Le(new o(Fe.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:Le(new t(Fe.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,N.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Le(new tt),inlineSuggest:Le(new fe),inlineEdit:Le(new we),inlineCompletionsAccessibilityVerbose:Le(new o(Fe.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:Le(new t(Fe.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new t(Fe.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(Fe.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:Le(new y(Fe.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:Le(new y(Fe.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:Le(new t(Fe.tabIndex,"tabIndex",0,-1,N.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Le(new x),unusualLineTerminators:Le(new y(Fe.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:Le(new o(Fe.useShadowDOM,"useShadowDOM",!0)),useTabStops:Le(new o(Fe.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:Le(new y(Fe.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:Le(new ot),wordSeparators:Le(new a(Fe.wordSeparators,"wordSeparators",$.$ft,{description:l.localize(360,null)})),wordWrap:Le(new y(Fe.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:Le(new a(Fe.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new a(Fe.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new t(Fe.wordWrapColumn,"wordWrapColumn",80,1,N.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:Le(new y(Fe.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new y(Fe.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new j),defaultColorDecorators:Le(new o(Fe.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:Le(new pe),tabFocusMode:Le(new o(Fe.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:Le(new ne),wrappingInfo:Le(new $t),wrappingIndent:Le(new ct),wrappingStrategy:Le(new De)}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[266],Se([1,0,23,44,220,5,110,11,25]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$4w=e.$3w=e.$2w=void 0,e.$5w=k,e.$6w=b,h=zt(h),e.$2w=(0,R.$Ei)("dialogService");var l;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(l||(l={}));class I{a(g){return this.d(g,l.Confirmation)}b(g){return this.d(g,l.Prompt)}c(g){return this.d(g,l.Input)}d(g,f){const m=[];switch(f){case l.Confirmation:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(0,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(1,null));break}case l.Prompt:{const n=g;Array.isArray(n.buttons)&&n.buttons.length>0&&m.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?m.push((0,A.localize)(2,null)):typeof n.cancelButton=="string"?m.push(n.cancelButton):n.cancelButton.label?m.push(n.cancelButton.label):m.push((0,A.localize)(3,null))),m.length===0&&m.push((0,A.localize)(4,null));break}case l.Input:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(5,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(6,null));break}}return m}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===h.default.Info?"info":g===h.default.Error?"error":g===h.default.Warning?"warning":"none"}f(g,f,m){const n=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&n.push(g.cancelButton);let o=n[f]?.run({checkboxChecked:m});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:m}}}e.$3w=I,e.$4w=(0,R.$Ei)("fileDialogService");var E;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const u=10;function k(c){const g=[];return g.push(...c.slice(0,u).map(f=>typeof f=="string"?f:(0,r.$ch)(f))),c.length>u&&(c.length-u===1?g.push((0,A.localize)(7,null)):g.push((0,A.localize)(8,null,c.length-u))),g.push(""),g.join(`
`)}function b(c,g){const f=(0,$.$bo)(c);let m=(f.buttons??[]).map(t=>(0,N.$Yw)(t)),n=(c.buttons||[]).map((t,s)=>s),o=0,i=f.cancelId??m.length-1;if(m.length>1){const t=typeof i=="number"?m[i]:void 0;if(T.$k||T.$j){if(typeof t=="string"&&m.length>1&&i!==1){m.splice(i,1),m.splice(1,0,t);const s=n[i];n.splice(i,1),n.splice(1,0,s),i=1}T.$k&&m.length>1&&(m=m.reverse(),n=n.reverse(),o=m.length-1,typeof t=="string"&&(i=o-1))}else if(T.$i&&typeof t=="string"&&m.length>1&&i!==m.length-1){m.splice(i,1),m.push(t);const s=n[i];n.splice(i,1),n.push(s),i=m.length-1}}return f.buttons=m,f.defaultId=o,f.cancelId=i,f.noLink=!0,f.title=f.title||g.nameLong,{options:f,buttonIndeces:n}}}),define(Ee[144],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,r.$Ei)("environmentService"),e.$Mi=(0,r.$Fi)(e.$Li)}),define(Ee[267],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=e.$G8b=void 0,e.$G8b=(0,r.$Ei)("externalTerminal"),e.$H8b="Terminal.app"}),define(Ee[268],Se([1,0,58,59,15,16,11,109,34,112,223,267]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=e.$sec=void 0,r=We(r),R=We(R),N=We(N),$=We($),l=We(l),I=We(I);const u=I.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends k{static{this.b="cmd.exe"}openTerminal(i,t){return this.spawnTerminal(r,i,l.$wm(),t)}spawnTerminal(i,t,s,d){const a=t.windowsExec||b.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const w=R.$oc(a,".exe").toLowerCase();if(w==="cmder")return i.spawn(a,d?[d]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return a.indexOf(" ")>=0&&y.push('""'),y.push(a),w==="wt"&&y.push("-d ."),new Promise((S,D)=>{const P=f(process),C=i.spawn(s,y,{cwd:d,env:P,detached:!0});C.on("error",D),C.on("exit",()=>S())})}async runInTerminal(i,t,s,d,a){const w="windowsExec"in a&&a.windowsExec?a.windowsExec:b.getDefaultTerminalWindows(),y=await b.f();return new Promise((S,D)=>{const P=`"${t} - ${u}"`,C=`"${s.join('" "')}" & pause`,p=Object.assign({},f(process),d);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const v={cwd:t,env:p,windowsVerbatimArguments:!0};let O,L;R.$oc(w,".exe")==="wt"?(O=w,L=["-d",".",b.b,"/c",C]):y?(O=y,L=["-d",".",w,"/c",C]):(O=b.b,L=["/c","start",P,"/wait",w,"/c",`"${C}"`]),r.spawn(O,L,v).on("error",j=>{D(m(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!b.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return b.d}static async f(){try{const i=await l.win32.findExecutable("wt");return await $.Promises.exists(i)?i:void 0}catch{return}}}e.$sec=b,Qe([h.$9h],b,"f",null);class c extends k{static{this.b="/usr/bin/osascript"}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,d,a){const w=a.osxExec||E.$H8b;return new Promise((y,S)=>{if(w===E.$H8b||w==="iTerm.app"){const D=w===E.$H8b?"TerminalHelper":"iTermHelper",C=[A.$Yg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",i||u,"-w",t];for(const O of s)C.push("-a"),C.push(O);if(d){const O=Object.assign({},f(process),d);for(const L in O){const F=O[L];F===null?(C.push("-u"),C.push(L)):(C.push("-e"),C.push(`${L}=${F}`))}}let p="";const v=r.spawn(c.b,C);v.on("error",O=>{S(m(O))}),v.stderr.on("data",O=>{p+=O.toString()}),v.on("exit",O=>{if(O===0)y(void 0);else if(p){const L=p.split(`
`,1);S(new Error(L[0]))}else S(new Error(I.localize(1,null,D,O)))})}else S(new Error(I.localize(2,null,w)))})}spawnTerminal(i,t,s){const d=t.osxExec||E.$H8b;return new Promise((a,w)=>{const y=["-a",d];s&&y.push(s);const S=f(process),D=i.spawn("/usr/bin/open",y,{cwd:s,env:S});D.on("error",w),D.on("exit",()=>a())})}}e.$tec=c;class g extends k{static{this.b=I.localize(3,null)}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,d,a){const w=a.linuxExec?Promise.resolve(a.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((y,S)=>{const D=[];w.then(P=>{P.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const C=`${n(s)}; echo; read -p "${g.b}" -n1;`;D.push(`''${C}''`);const p=Object.assign({},f(process),d);Object.keys(p).filter(F=>p[F]===null).forEach(F=>delete p[F]);const v={cwd:t,env:p};let O="";const L=r.spawn(P,D,v);L.on("error",F=>{S(m(F))}),L.stderr.on("data",F=>{O+=F.toString()}),L.on("exit",F=>{if(F===0)y(void 0);else if(O){const j=O.split(`
`,1);S(new Error(j[0]))}else S(new Error(I.localize(4,null,P,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!N.$k)g.d=Promise.resolve("xterm");else{const i=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{i?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(i,t,s){const d=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,w)=>{d.then(y=>{const S=f(process),D=i.spawn(y,[],{cwd:s,env:S});D.on("error",w),D.on("exit",()=>a())})})}}e.$uec=g;function f(o){const i={...o.env};return(0,T.$jm)(i),i}function m(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function n(o){let i="";for(const t of o)t.indexOf(" ")>=0?i+='"'+t+'"':i+=t,i+=" ";return i}}),define(Ee[28],Se([1,0,85,16,13,18,2,224,5,11,15,49]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=u,e.$al=g,e.$bl=m,e.$cl=n,e.$dl=o,e.$el=i,e.$fl=t,e.$gl=s,e.$hl=d,e.$il=a,e.$jl=w,e.$ll=D,e.$ml=P,e.$nl=C,e.$ol=p,e.$pl=v,e.$sl=B,e.$El=G,e.$Fl=K,e.$Hl=ue,e.$$k=(0,$.$Ei)("fileService");function u(ne){return ne.create===!0}var k;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var b;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var c;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function g(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var f;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function m(ne){return!!(ne.capabilities&f.FileReadWrite)}function n(ne){return!!(ne.capabilities&f.FileFolderCopy)}function o(ne){return!!(ne.capabilities&f.FileClone)}function i(ne){return!!(ne.capabilities&f.FileOpenReadWriteClose)}function t(ne){return!!(ne.capabilities&f.FileReadStream)}function s(ne){return m(ne)?!!(ne.capabilities&f.FileAtomicRead):!1}function d(ne){return m(ne)?!!(ne.capabilities&f.FileAtomicWrite):!1}function a(ne){return!!(ne.capabilities&f.FileAtomicDelete)}function w(ne){return!!(ne.capabilities&f.Readonly)}var y;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class S extends Error{static create(De,$e){const J=new S(De.toString(),$e);return C(J,$e),J}constructor(De,$e){super(De),this.code=$e}}e.$kl=S;function D(ne,De){return S.create(ne,De)}function P(ne){return ne||D((0,T.localize)(0,null),y.Unknown)}function C(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function p(ne){if(!ne)return y.Unknown;if(ne instanceof S)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return y.Unknown;switch(De[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function v(ne){if(ne instanceof M)return ne.fileOperationResult;switch(p(ne)){case y.FileNotFound:return re.FILE_NOT_FOUND;case y.FileIsADirectory:return re.FILE_IS_DIRECTORY;case y.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return re.FILE_WRITE_LOCKED;case y.NoPermissions:return re.FILE_PERMISSION_DENIED;case y.FileExists:return re.FILE_MOVE_CONFLICT;case y.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var O;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class L{constructor(De,$e,J){this.resource=De,this.operation=$e,this.target=J}isOperation(De){return this.operation===De}}e.$ql=L;var F;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class j{static{this.a=null}constructor(De,$e){this.c=$e,this.b=void 0,this.d=new E.$W(()=>{const J=r.$Ki.forUris(()=>this.c);return J.fill(this.rawAdded.map(W=>[W,!0])),J}),this.f=new E.$W(()=>{const J=r.$Ki.forUris(()=>this.c);return J.fill(this.rawUpdated.map(W=>[W,!0])),J}),this.g=new E.$W(()=>{const J=r.$Ki.forUris(()=>this.c);return J.fill(this.rawDeleted.map(W=>[W,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of De){switch(J.type){case F.ADDED:this.rawAdded.push(J.resource);break;case F.UPDATED:this.rawUpdated.push(J.resource);break;case F.DELETED:this.rawDeleted.push(J.resource);break}this.b!==j.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(De,...$e){return this.h(De,{includeChildren:!1},...$e)}affects(De,...$e){return this.h(De,{includeChildren:!0},...$e)}h(De,$e,...J){if(!De)return!1;const W=J.length>0;return!!((!W||J.includes(F.ADDED))&&(this.d.value.get(De)||$e.includeChildren&&this.d.value.findSuperstr(De))||(!W||J.includes(F.UPDATED))&&(this.f.value.get(De)||$e.includeChildren&&this.f.value.findSuperstr(De))||(!W||J.includes(F.DELETED))&&(this.g.value.findSubstr(De)||$e.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$rl=j;function B(ne,De,$e){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==h.sep&&(De+=h.sep),$e?(0,A.$Gf)(ne,De):ne.indexOf(De)===0)}class M extends Error{constructor(De,$e,J){super(De),this.fileOperationResult=$e,this.options=J}}e.$tl=M;class z extends M{constructor(De,$e,J,W){super(De,$e,W),this.fileOperationResult=$e,this.size=J}}e.$ul=z;class _ extends M{constructor(De,$e,J){super(De,re.FILE_NOT_MODIFIED_SINCE,J),this.stat=$e}}e.$vl=_;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var U;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.$Dl="";function G(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function K(ne,De){if(!De.hasProvider(N.URI.from({scheme:ne.scheme})))return new Promise($e=>{const J=De.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(J.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,R.$ig)(De)||(De=0),De<ee.KB?(0,T.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,T.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,T.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,T.localize)(4,null,(De/ee.GB).toFixed(2)):(0,T.localize)(5,null,(De/ee.TB).toFixed(2))}}e.$Gl=ee;function ue(ne){const De=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*ee.MB:De?10*ee.MB:l.$o?50*ee.MB:1024*ee.MB}}),define(Ee[269],Se([1,0,22,14,225,28]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=N;async function N(I,E,u,k,b,c){let g;try{await T(I,E,u,k,b,c)}catch(f){g=f}finally{g&&b.errorTransformer&&(g=b.errorTransformer(g)),typeof g<"u"&&u.error(g),u.end()}}async function T(I,E,u,k,b,c){$(c);const g=await I.open(E,{create:!1});try{$(c);let f=0,m=0,n=b&&typeof b.length=="number"?b.length:void 0,o=r.$Ne.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),i=b&&typeof b.position=="number"?b.position:0,t=0;do m=await I.read(g,i,o.buffer,t,o.byteLength-t),i+=m,t+=m,f+=m,typeof n=="number"&&(n-=m),t===o.byteLength&&(await u.write(k(o)),o=r.$Ne.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),t=0);while(m>0&&(typeof n!="number"||n>0)&&$(c)&&l(f,b));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),u.write(k(o.slice(0,s)))}}catch(f){throw(0,R.$ml)(f)}finally{await I.close(g)}}function $(I){if(I.isCancellationRequested)throw(0,h.$7)();return!0}function l(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,R.$ll)((0,A.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[70],Se([1,0,39,3,16,11,2,28]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,e.$Wq=$,e.$Xq=l,e.$2q=k,e.$3q=b,e.$4q=c,e.$5q=g,e.$6q=m,e.$7q=n;function $(o){return typeof o.correlationId=="number"}function l(o){return o.recursive===!0}class I extends h.$Vc{static{this.a=5}constructor(i,t,s,d){super(),this.h=i,this.j=t,this.m=s,this.n=d,this.c=this.B(new h.$Wc),this.f=void 0,this.g=0}s(){const i=new h.$Uc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(t=>this.h(t))),i.add(this.b.onDidLogMessage(t=>this.j(t))),i.add(this.b.onDidError(t=>this.t(t.error,t.request)))}t(i,t){this.u(i,t)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${i}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${i}`):this.y(i)}u(i,t){return!(!this.n.restartOnError||t||i.indexOf("No space left on device")!==-1||i.indexOf("EMFILE")!==-1)}w(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}y(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}z(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Yq=I;class E extends I{constructor(i,t,s){super(i,t,s,{type:"node.js",restartOnError:!1})}}e.$Zq=E;class u extends I{constructor(i,t,s){super(i,t,s,{type:"universal",restartOnError:!0})}}e.$1q=u;function k(o){return o.map(i=>({type:i.type,resource:N.URI.revive(i.resource),cId:i.cId}))}function b(o){const i=new f;for(const t of o)i.processEvent(t);return i.coalesce()}function c(o,i){return typeof i=="string"&&!i.startsWith(r.$uk)&&!(0,A.$jc)(i)?{base:o,pattern:i}:i}function g(o,i){const t=[];for(const s of i)t.push((0,r.$yk)(c(o,s)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const t=this.b.get(this.c(i));let s=!1;if(t){const d=t.type,a=i.type;t.resource.fsPath!==i.resource.fsPath&&(i.type===T.FileChangeType.DELETED||i.type===T.FileChangeType.ADDED)?s=!0:d===T.FileChangeType.ADDED&&a===T.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(t)):d===T.FileChangeType.DELETED&&a===T.FileChangeType.ADDED?t.type=T.FileChangeType.UPDATED:d===T.FileChangeType.ADDED&&a===T.FileChangeType.UPDATED||(t.type=a)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],t=[];return Array.from(this.a).filter(s=>s.type!==T.FileChangeType.DELETED?(i.push(s),!1):!0).sort((s,d)=>s.resource.fsPath.length-d.resource.fsPath.length).filter(s=>t.some(d=>(0,T.$sl)(s.resource.fsPath,d,!R.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(i)}}function m(o,i){if(typeof i=="number")switch(o.type){case T.FileChangeType.ADDED:return(i&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(i&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(i&T.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const i=[];return o&T.FileChangeFilter.ADDED&&i.push("Added"),o&T.FileChangeFilter.DELETED&&i.push("Deleted"),o&T.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(Ee[270],Se([1,0,61,3,70,4,28,2,9]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class l extends h.$Vc{constructor(){super(),this.a=this.B(new R.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$5c),this.m=new Set,this.n=this.B(new $.$Ch(this.y())),this.r=5007,this.s=new $.$2h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,A.$Wq)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new $.$2h;try{this.h.clear(),this.g.clear();for(const u of E)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const u=new h.$Uc;this.j.set(E.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(E,u),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,u){this.F(E,u)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,u),this.m.add(E.correlationId))}F(E,u){const k=this.O?.subscribe(E.path,(b,c)=>{u.isDisposed||(b?this.D(E,u):c?.type===N.FileChangeType.ADDED&&this.H(E))});return k?(u.add(k),!0):!1}G(E,u){let k=!1;const b=(c,g)=>{if(u.isDisposed)return;const f=this.I(c),m=this.I(g),n=k;k=f,!f&&(m||n)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.watchFile)(E.path,{persistent:!1,interval:this.r},b)}catch(c){this.Q(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}u.add((0,h.$Tc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.unwatchFile)(E.path,b)}catch(c){this.Q(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const u={resource:T.URI.file(E.path),type:N.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([u]),this.J(u,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,u){if(this.R){const k=` >> normalized ${E.type===N.FileChangeType.ADDED?"[ADDED]":E.type===N.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(k,u)}}L(E,u){this.R&&this.P(`${E}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,A.$7q)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$dr=l}),define(Ee[271],Se([1,0,61,9,21,33,3,82,16,11,23,2,111,34,28,70]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,e.$jr=f;class g extends N.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,i,t,s,d){super(),this.s=n,this.t=o,this.u=i,this.w=t,this.y=s,this.z=d,this.c=this.B(new h.$Th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.u(a))),this.f=this.B(new h.$Sh(a=>this.M(a),g.b)),this.g=(0,c.$5q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$5q)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Wq)(this.s)?this.s.filter:void 0,this.m=new A.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await k.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await k.Promises.realpath(n.path),n.path===o&&(o=await(0,u.$fr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const i=new N.$Uc;return this.H(n,o,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,i)),i}H(n,o,i){if(o)return!1;const t=E.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(d,a)=>{if(!i.isDisposed)if(d){const w=await this.G(n,o);i.isDisposed?w.dispose():i.add(w)}else a&&(typeof a.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:a.type,cId:this.s.correlationId},!0)});return s?(i.add(s),!0):!1}async I(n,o,i){if(l.$j&&(0,R.$Dg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new A.$we(this.m.token);i.add((0,N.$Tc)(()=>t.dispose(!0)));const s=new N.$Uc;i.add(s);try{const d=E.URI.file(this.s.path),a=(0,$.$oc)(n),w=(0,r.watch)(n);s.add((0,N.$Tc)(()=>{w.removeAllListeners(),w.close()})),this.Q(`Started watching: '${n}'`);const y=new Set;if(o)try{for(const D of await k.Promises.readdir(n))y.add(D)}catch(D){this.O(D)}if(t.token.isCancellationRequested)return;const S=new Map;s.add((0,N.$Tc)(()=>{for(const[,D]of S)D.dispose();S.clear()})),w.on("error",(D,P)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${D}, ${P})`),this.D())}),w.on("change",(D,P)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${D}"] ${P}`);let C="";if(P&&(C=P.toString(),l.$j&&(C=(0,T.$lm)(C))),!(!C||D!=="change"&&D!=="rename"))if(o)if(D==="rename"){S.get(C)?.dispose();const p=setTimeout(async()=>{if(S.delete(C),C===a&&!await k.Promises.exists(n)){this.J(d);return}if(t.token.isCancellationRequested)return;const v=await this.N((0,$.$kc)(n,C));if(t.token.isCancellationRequested)return;let O;v?y.has(C)?O=b.FileChangeType.UPDATED:(O=b.FileChangeType.ADDED,y.add(C)):(y.delete(C),O=b.FileChangeType.DELETED),this.L({resource:(0,I.$fh)(d,C),type:O,cId:this.s.correlationId})},g.a);S.set(C,(0,N.$Tc)(()=>clearTimeout(p)))}else{let p;y.has(C)?p=b.FileChangeType.UPDATED:(p=b.FileChangeType.ADDED,y.add(C)),this.L({resource:(0,I.$fh)(d,C),type:p,cId:this.s.correlationId})}else if(D==="rename"||C!==a){const p=setTimeout(async()=>{const v=await k.Promises.exists(n);t.token.isCancellationRequested||(v?(this.L({resource:d,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(d))},g.a);s.clear(),s.add((0,N.$Tc)(()=>clearTimeout(p)))}else this.L({resource:d,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){t.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${d.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:b.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===b.FileChangeType.ADDED?"[ADDED]":n.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,c.$3q)(n),i=[];for(const s of o){if((0,c.$6q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}i.push(s)}if(i.length===0)return;if(this.z)for(const s of i)this.R(` >> normalized ${s.type===b.FileChangeType.ADDED?"[ADDED]":s.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(l.$k)return k.Promises.exists(n);try{const o=(0,$.$oc)(n);return(await k.Promises.readdir((0,$.$nc)(n))).some(t=>t===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$ir=g;async function f(m,n,o,i,t=512){const s=await k.Promises.open(m,"r"),d=Buffer.allocUnsafe(t),a=new A.$we(i);let w,y=!1;const S={path:m,excludes:[],recursive:!1},D=new g(S,void 0,P=>{(async()=>{for(const{type:C}of P)if(C===b.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:p}=await k.Promises.read(s,d,0,t,null);if(!p||a.token.isCancellationRequested)break;n(d.slice(0,p))}}catch(p){w=new Error(p),a.dispose(!0)}finally{y=!1}}})()});return await D.ready,o(),new Promise((P,C)=>{a.token.onCancellationRequested(async()=>{D.dispose();try{await k.Promises.close(s)}catch(p){w=new Error(p)}w?C(w):P()})})}}),define(Ee[272],Se([1,0,4,39,270,11,271,33]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class $ extends A.$dr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const E=[],u=new Set(Array.from(this.watchers));for(const k of I){const b=this.W(k);b&&(0,h.$Ck)(b.request.excludes,k.excludes)&&(0,h.$Ck)(b.request.includes,k.includes)?u.delete(b):E.push(k)}E.length&&this.P(`Request to start watching: ${E.map(k=>this.M(k)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(k=>this.M(k.request)).join(",")}`);for(const k of u)this.Y(k);for(const k of E)this.X(k)}W(I){for(const E of this.watchers)if(typeof I.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===I.correlationId)return E}else if((0,T.$Cg)(E.request.path,I.path,!R.$k))return E}X(I){const E=new N.$ir(I,this.O,k=>this.a.fire(k),()=>this.c.fire(I),k=>this.b.fire(k),this.R),u={request:I,instance:E};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const E=new Map;for(const u of I){const k=R.$k?u.path:u.path.toLowerCase();let b=E.get(u.correlationId);b||(b=new Map,E.set(u.correlationId,b)),b.has(k)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),b.set(k,u)}return Array.from(E.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const E of this.watchers)E.instance.setVerboseLogging(I)}P(I,E){this.R&&this.b.fire({type:"trace",message:this.bb(I,E)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,E){return E?`[File Watcher (node.js)] ${I} (${this.M(E.request)})`:`[File Watcher (node.js)] ${I}`}}e.$kr=$}),define(Ee[273],Se([1,0,70,272]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class A extends r.$Zq{constructor(N,T,$){super(N,T,$),this.s()}r(N){return N.add(new h.$kr(void 0))}}e.$lr=A}),define(Ee[274],Se([1,0,15,87,208,70]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class N extends R.$1q{constructor($,l,I){super($,l,I),this.s()}r($){const l=$.add(new A.$br(r.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(l.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$li)(l.getChannel("watcher")))}}e.$cr=N}),define(Ee[115],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class r{constructor(...A){this.a=new Map;for(const[R,N]of A)this.set(R,N)}set(A,R){const N=this.a.get(A);return this.a.set(A,R),N}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Ci=r}),define(Ee[275],Se([1,0,9,14,3,113,264,5,115,81]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const I=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class u{constructor(g=new $.$Ci,f=!1,m,n=I){this.i=g,this.j=f,this.k=m,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Di,this),this._globalGraph=n?m?._globalGraph??new N.$or(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,A.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g,f){this.m();const m=this,n=new class extends u{dispose(){m.h.delete(n),super.dispose()}}(g,this.j,this,this.l);return this.h.add(n),f?.add(n),n}invokeFunction(g,...f){this.m();const m=b.traceInvocation(this.l,g);let n=!1;try{return g({get:i=>{if(n)throw(0,h.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(i,m);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...f)}finally{n=!0,m.stop()}}createInstance(g,...f){this.m();let m,n;return g instanceof R.$Bi?(m=b.traceCreation(this.l,g.ctor),n=this.o(g.ctor,g.staticArguments.concat(f),m)):(m=b.traceCreation(this.l,g),n=this.o(g,f,m)),m.stop(),n}o(g,f=[],m){const n=T._util.getServiceDependencies(g).sort((t,s)=>t.index-s.index),o=[];for(const t of n){const s=this.s(t.id,m);s||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(s)}const i=n.length>0?n[0].index:f.length;if(f.length!==i){console.trace(`[createInstance] First service dependency of ${g.name} at position ${i+1} conflicts with ${f.length} static arguments`);const t=i-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,i)}return Reflect.construct(g,f.concat(o))}q(g,f){if(this.i.get(g)instanceof R.$Bi)this.i.set(g,f);else if(this.k)this.k.q(g,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const f=this.i.get(g);return!f&&this.k?this.k.r(g):f}s(g,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const m=this.r(g);return m instanceof R.$Bi?this.u(g,m,f.branch(g,!0)):(f.branch(g,!1),m)}u(g,f,m){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,f,m)}finally{this.t.delete(g)}}v(g,f,m){const n=new N.$or(t=>t.id.toString());let o=0;const i=[{id:g,desc:f,_trace:m}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new E(n);for(const s of T._util.getServiceDependencies(t.desc.ctor)){const d=this.r(s.id);if(d||this.y(`[createInstance] ${g} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),d instanceof R.$Bi){const a={id:s.id,desc:d,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,a),i.push(a)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:s}of t){if(this.r(s.id)instanceof R.$Bi){const a=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,a)}n.removeNode(s)}}return this.r(g)}w(g,f,m=[],n,o){if(this.i.get(g)instanceof R.$Bi)return this.x(g,f,m,n,o,this.g);if(this.k)return this.k.w(g,f,m,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(g,f,m=[],n,o,i){if(n){const t=new u(void 0,this.j,this,this.l);t.c=String(g);const s=new Map,d=new r.$Xh(()=>{const a=t.o(f,m,o);for(const[w,y]of s){const S=a[w];if(typeof S=="function")for(const D of y)D.disposable=S.apply(a,D.listener)}return s.clear(),i.add(a),a});return new Proxy(Object.create(null),{get(a,w){if(!d.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let D=s.get(w);return D||(D=new l.$6c,s.set(w,D)),(C,p,v)=>{if(d.isInitialized)return d.value[w](C,p,v);{const O={listener:[C,p,v],disposable:void 0},L=D.push(O);return(0,A.$Tc)(()=>{L(),O.disposable?.dispose()})}}}if(w in a)return a[w];const y=d.value;let S=y[w];return typeof S!="function"||(S=S.bind(y),a[w]=S),S},set(a,w,y){return d.value[w]=y,!0},getPrototypeOf(a){return f.prototype}})}else{const t=this.o(f,m,o);return i.add(t),t}}y(g,f){if(f&&console.warn(g),this.j)throw new Error(g)}}e.$pr=u;var k;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(k||(k={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(k.None,null)}stop(){}branch(){return this}}}static traceInvocation(g,f){return g?new b(k.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(g,f){return g?new b(k.Creation,f.name):b.c}static{this.f=0}constructor(g,f){this.type=g,this.name=f,this.g=Date.now(),this.h=[]}branch(g,f){const m=new b(k.Branch,g.toString());return this.h.push([g,f,m]),m}stop(){const g=Date.now()-this.g;b.f+=g;let f=!1;function m(o,i){const t=[],s=new Array(o+1).join("	");for(const[d,a,w]of i.h)if(a&&w){f=!0,t.push(`${s}CREATES -> ${d}`);const y=m(o+1,w);y&&t.push(y)}else t.push(`${s}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(g>2||f)&&b.all.add(n.join(`
`))}}e.$qr=b}),define(Ee[12],Se([1,0,227,55,4,60,3,29,11,23,18,2,36,5]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=c,e.log=f,e.$mk=S,e.$nk=D,e.$ok=P,e.$pk=C,r=We(r),e.$$j=(0,k.$Ei)("logService"),e.$_j=(0,k.$Ei)("loggerService");function b(){return new Date().toISOString()}function c(p){return(0,I.$ig)(p)}var g;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$bk=g.Info;function f(p,v,O){switch(v){case g.Trace:p.trace(O);break;case g.Debug:p.debug(O);break;case g.Info:p.info(O);break;case g.Warning:p.warn(O);break;case g.Error:p.error(O);break;case g.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function m(p,v=!1){let O="";for(let L=0;L<p.length;L++){let F=p[L];if(F instanceof Error&&(F=(0,h.$pj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}O+=(L>0?" ":"")+F}return O}class n extends N.$Vc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new A.$le),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==g.Off&&this.b<=v}}e.$dk=n;class o extends n{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...O){this.f(g.Trace)&&this.g(g.Trace,m([v,...O],!0))}debug(v,...O){this.f(g.Debug)&&this.g(g.Debug,m([v,...O]))}info(v,...O){this.f(g.Info)&&this.g(g.Info,m([v,...O]))}warn(v,...O){this.f(g.Warning)&&this.g(g.Warning,m([v,...O]))}error(v,...O){if(this.f(g.Error))if(v instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=v.stack,this.g(g.Error,m(L))}else this.g(g.Error,m([v,...O]))}flush(){}}e.$ek=o;class i extends n{constructor(v=e.$bk){super(),this.setLevel(v),this.g=!$.$i}trace(v,...O){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...O):console.log(`[main ${b()}]`,v,...O))}debug(v,...O){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...O):console.log(`[main ${b()}]`,v,...O))}info(v,...O){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...O):console.log(`[main ${b()}]`,v,...O))}warn(v,...O){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,v,...O):console.warn(`[main ${b()}]`,v,...O))}error(v,...O){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,v,...O):console.error(`[main ${b()}]`,v,...O))}flush(){}}e.$fk=i;class t extends n{constructor(v=e.$bk,O=!0){super(),this.g=O,this.setLevel(v)}trace(v,...O){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...O):console.log(v,...O))}debug(v,...O){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...O):console.log(v,...O))}info(v,...O){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...O):console.log(v,...O))}warn(v,...O){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...O):console.log(v,...O))}error(v,...O){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...O):console.error(v,...O))}flush(){}}e.$gk=t;class s extends n{constructor(v,O=e.$bk){super(),this.g=v,this.setLevel(O)}trace(v,...O){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(v),...O])}debug(v,...O){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(v),...O])}info(v,...O){this.f(g.Info)&&this.g.log(g.Info,[this.h(v),...O])}warn(v,...O){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(v),...O])}error(v,...O){this.f(g.Error)&&this.g.log(g.Error,[this.h(v),...O])}h(v){return typeof v=="string"?v:(0,h.$pj)(v,this.f(g.Trace))}flush(){}}e.$hk=s;class d extends n{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const O of this.g)O.setLevel(v);super.setLevel(v)}trace(v,...O){for(const L of this.g)L.trace(v,...O)}debug(v,...O){for(const L of this.g)L.debug(v,...O)}info(v,...O){for(const L of this.g)L.info(v,...O)}warn(v,...O){for(const L of this.g)L.warn(v,...O)}error(v,...O){for(const L of this.g)L.error(v,...O)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$ik=d;class a extends N.$Vc{constructor(v,O,L){if(super(),this.h=v,this.j=O,this.b=new T.$Bc,this.c=this.B(new A.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$le),this.onDidChangeVisibility=this.g.event,L)for(const F of L)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,I.$eg)(v)?[...this.b.values()].find(O=>O.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,O){const L=this.n(v),F=(0,I.$eg)(v)?v:O?.id??(0,R.$sj)(L.toString()).toString(16);let j=this.b.get(L)?.logger;const B=O?.logLevel==="always"?g.Trace:O?.logLevel;j||(j=this.s(L,B??this.getLogLevel(L)??this.h,{...O,id:F}));const M={logger:j,info:{resource:L,id:F,logLevel:B,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(M.info),this.b.set(L,M),j}n(v){return(0,I.$eg)(v)?(0,l.$fh)(this.j,`${v}.log`):v}setLogLevel(v,O){if(E.URI.isUri(v)){const L=v,F=O,j=this.b.get(L);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([L,F]))}else{this.h=v;for(const[L,F]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,O){const L=this.m(v);L&&O!==!L.info.hidden&&(L.info.hidden=!O,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,O]))}getLogLevel(v){let O;return v&&(O=this.b.get(v)?.info.logLevel),O??this.h}registerLogger(v){const O=this.b.get(v.resource);O?O.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const O=this.b.get(v);O&&(O.logger&&O.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=a;class w{constructor(){this.onDidChangeLogLevel=new A.$le().event}setLevel(v){}getLevel(){return g.Info}trace(v,...O){}debug(v,...O){}info(v,...O){}warn(v,...O){}error(v,...O){}critical(v,...O){}dispose(){}flush(){}}e.$kk=w;class y extends w{}e.$lk=y;function S(p){if(p.verbose)return g.Trace;if(typeof p.logLevel=="string"){const v=C(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$bk}function D(p){switch(p){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function P(p){switch(p){case g.Trace:return{original:"Trace",value:r.localize(0,null)};case g.Debug:return{original:"Debug",value:r.localize(1,null)};case g.Info:return{original:"Info",value:r.localize(2,null)};case g.Warning:return{original:"Warning",value:r.localize(3,null)};case g.Error:return{original:"Error",value:r.localize(4,null)};case g.Off:return{original:"Off",value:r.localize(5,null)}}}function C(p){switch(p){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$qk=new u.$Vj("logLevel",D(g.Info))}),define(Ee[276],Se([1,0,19,9,14,4,33,3,16,70,12]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class E extends T.$Vc{constructor(k,b){super(),this.a=k,this.b=b,this.c=this.B(new R.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ch(0)),this.w=[],this.y=this.B(new h.$Ch(0))}watch(k,b){return b.recursive||this.b?.watcher?.forceUniversal?this.n(k,b):this.z(k,b)}n(k,b){const c={path:this.J(k),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},g=(0,r.$Ub)(this.j,c);return this.r(),(0,T.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,A.$2)(k))}s(){this.h||(this.h=this.B(this.t(b=>this.c.fire((0,l.$2q)(b)),b=>this.G(b),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const b of this.j)(0,l.$Xq)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const b of this.j)(0,l.$Xq)(b)&&k.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,b){const c={path:this.J(k),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},g=(0,r.$Ub)(this.w,c);return this.C(),(0,T.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,A.$2)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,l.$2q)(k)),k=>this.G(k),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,$.$ic)(k.fsPath)}J(k){const b=this.I(k);return(0,N.$Gg)(b)}}e.$8q=E}),define(Ee[277],Se([1,0,9,29,22,4,33,3,16,11,23,104,34,226,28,269,276,274,273]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class n extends g.$8q{static{this.L=!1}constructor(i,t){super(i,t),this.onDidChangeCapabilities=R.Event.None,this.P=new h.$Bc(s=>I.$9g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=b.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(i){try{const{stat:t,symbolicLink:s}=await u.SymlinkSupport.stat(this.I(i));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:b.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await u.Promises.readdir(this.I(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async d=>{try{let a;d.isSymbolicLink()?a=(await this.stat((0,I.$fh)(i,d.name))).type:a=this.O(d),s.push([d.name,a])}catch(a){this.a.trace(a)}})),s}catch(t){throw this.hb(t)}}O(i,t){let s;return t?.dangling?s=b.FileType.Unknown:i.isFile()?s=b.FileType.File:i.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,t&&(s|=b.FileType.SymbolicLink),s}async Q(i){const t=this.I(i);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(i);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const d=new r.$Dh;return this.P.set(i,d),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,T.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(i)===d&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(i)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),d.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(i)})`),s=await this.Q(i));const d=this.I(i);return await u.Promises.readFile(d)}catch(d){throw this.hb(d)}finally{s?.dispose()}}R(i){n.L&&this.a.trace(i)}readFileStream(i,t,s){const d=(0,E.$Be)(a=>A.$Ne.concat(a.map(w=>A.$Ne.wrap(w))).buffer);return(0,c.$Uq)(this,i,d,a=>a.buffer,{...t,bufferSize:256*1024},s),d}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(i)?this.U(i,(0,I.$fh)((0,I.$eh)(i),`${(0,I.$ch)(i)}${s.atomic.postfix}`),t,s):this.W(i,t,s)}async S(i){try{const t=this.I(i),{symbolicLink:s}=await u.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(i,t,s,d){const a=new T.$Uc;try{a.add(await this.Q(i)),a.add(await this.Q(t)),await this.W(t,s,d,!0);try{await this.rename(t,i,{overwrite:!0})}catch(w){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{a.dispose()}}async W(i,t,s,d){let a;try{const w=this.I(i);if(!s.create||!s.overwrite){if(await u.Promises.exists(w)){if(!s.overwrite)throw(0,b.$ll)((0,k.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.$ll)((0,k.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock},d),await this.write(a,0,t,0,t.byteLength)}catch(w){throw await this.ib(i,w)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(i){n.$=i}async open(i,t,s){const d=this.I(i);let a;(0,b.$_k)(t)&&!s&&(a=await this.Q(i));let w;try{if((0,b.$_k)(t)&&t.unlock)try{const{stat:S}=await u.SymlinkSupport.stat(d);S.mode&128||await u.Promises.chmod(d,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let y;if((0,b.$_k)(t)){if(l.$i)try{await u.Promises.truncate(d,0),y="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}y||(y="w")}else y="r";w=await u.Promises.open(d,y)}catch(y){throw a?.dispose(),(0,b.$_k)(t)?await this.ib(i,y):this.hb(y)}if(this.X.set(w,0),(0,b.$_k)(t)&&this.Z.set(w,i),a){const y=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${d})`),this.Y.set(w,a),y&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${d})`),y.dispose())}return w}async close(i){const t=this.Y.get(i);try{if(this.X.delete(i),this.Z.delete(i)&&n.$)try{await u.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await u.Promises.close(i)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(i)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.Y.delete(i)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,d,a){const w=this.ab(i,t);let y=null;try{y=(await u.Promises.read(i,s,d,a,w)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(i,w,y)}return y}ab(i,t){return t===this.X.get(i)?null:t}bb(i,t,s){const d=this.X.get(i);typeof d=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(i,d+s):this.X.delete(i)))}async write(i,t,s,d,a){return(0,r.$Yh)(()=>this.cb(i,t,s,d,a),100,3)}async cb(i,t,s,d,a){const w=this.ab(i,t);let y=null;try{y=(await u.Promises.write(i,s,d,a,w)).bytesWritten}catch(S){throw await this.ib(this.Z.get(i),S)}finally{this.bb(i,w,y)}return y}async mkdir(i){try{await u.Promises.mkdir(this.I(i))}catch(t){throw this.hb(t)}}async delete(i,t){try{const s=this.I(i);if(t.recursive){let d;t?.atomic!==!1&&t.atomic.postfix&&(d=(0,$.$kc)((0,$.$nc)(s),`${(0,$.$oc)(s)}${t.atomic.postfix}`)),await u.Promises.rm(s,u.RimRafMode.MOVE,d)}else try{await u.Promises.unlink(s)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:y}=await u.SymlinkSupport.stat(s);a=w.isDirectory()&&!y}catch{}if(a)await u.Promises.rmdir(s);else throw d}else throw d}}catch(s){throw this.hb(s)}}async rename(i,t,s){const d=this.I(i),a=this.I(t);if(d!==a)try{await this.db(i,t,"move",s.overwrite),await u.Promises.rename(d,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(2,null,(0,$.$oc)(d),(0,$.$oc)((0,$.$nc)(a)),w.toString()))),this.hb(w)}}async copy(i,t,s){const d=this.I(i),a=this.I(t);if(d!==a)try{await this.db(i,t,"copy",s.overwrite),await u.Promises.copy(d,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(3,null,(0,$.$oc)(d),(0,$.$oc)((0,$.$nc)(a)),w.toString()))),this.hb(w)}}async db(i,t,s,d){const a=this.I(i),w=this.I(t);let y=!1;if(!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)||(y=(0,N.$Cg)(a,w,!0)),y){if(s==="copy")throw(0,b.$ll)((0,k.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.N(i);if(!D)throw(0,b.$ll)((0,k.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(t);if(P){if(!d)throw(0,b.$ll)((0,k.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);D.type&b.FileType.File&&P.type&b.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.eb(i,t,!1)}async eb(i,t,s){const d=this.I(i),a=this.I(t),w=!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive);if((0,N.$Cg)(d,a,!w))return;const y=new T.$Uc;try{y.add(await this.Q(i)),y.add(await this.Q(t)),s&&await u.Promises.mkdir((0,$.$nc)(a),{recursive:!0}),await u.Promises.copyFile(d,a)}catch(S){if(S.code==="ENOENT"&&!s)return this.eb(i,t,!0);throw this.hb(S)}finally{y.dispose()}}t(i,t,s){return new f.$cr(d=>i(d),d=>t(d),s)}F(i,t,s){return new m.$lr(d=>i(d),d=>t(d),s)}hb(i){if(i instanceof b.$kl)return i;let t=i,s;switch(i.code){case"ENOENT":s=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=b.FileSystemProviderErrorCode.Unknown;break;default:s=b.FileSystemProviderErrorCode.Unknown}return(0,b.$ll)(t,s)}async ib(i,t){let s=this.hb(t);if(i&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await u.SymlinkSupport.stat(this.I(i));d.mode&128||(s=(0,b.$ll)(t,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return s}}e.$mr=n}),define(Ee[278],Se([1,0,3,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;class A extends r.$Vc{constructor(N,T=[]){super(),this.a=new h.$ik([N,...T]),this.B(N.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...T){this.a.trace(N,...T)}debug(N,...T){this.a.debug(N,...T)}info(N,...T){this.a.info(N,...T)}warn(N,...T){this.a.warn(N,...T)}error(N,...T){this.a.error(N,...T)}flush(){this.a.flush()}}e.$UQ=A}),define(Ee[279],Se([1,0,28,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;var A;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(A||(A={}));async function R(l,I,E,u,k){try{const b=await new Promise((g,f)=>{ce(["@vscode/spdlog"],g,f)}).then(We);b.setFlushOn(A.Trace);const c=await b.createAsyncRotatingLogger(l,I,E,u);return k?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(b){console.error(b)}return null}function N(l,I,E){switch(I){case h.LogLevel.Trace:l.trace(E);break;case h.LogLevel.Debug:l.debug(E);break;case h.LogLevel.Info:l.info(E);break;case h.LogLevel.Warning:l.warn(E);break;case h.LogLevel.Error:l.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function T(l,I){switch(I){case h.LogLevel.Trace:l.setLevel(A.Trace);break;case h.LogLevel.Debug:l.setLevel(A.Debug);break;case h.LogLevel.Info:l.setLevel(A.Info);break;case h.LogLevel.Warning:l.setLevel(A.Warning);break;case h.LogLevel.Error:l.setLevel(A.Error);break;case h.LogLevel.Off:l.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class $ extends h.$ek{constructor(I,E,u,k,b){super(),this.m=[],this.setLevel(b),this.n=this.s(I,E,u,k),this.B(this.onDidChangeLogLevel(c=>{this.r&&T(this.r,c)}))}async s(I,E,u,k){const b=u?6:1,c=30/b*r.$Gl.MB,g=await R(I,E,c,b,k);if(g){this.r=g,T(this.r,this.getLevel());for(const{level:f,message:m}of this.m)N(this.r,f,m);this.m=[]}}g(I,E){this.r?N(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$JQ=$});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[145],Se([1,0,44,228,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=zt(r);var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var N;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(N||(e.MarkerSeverity=N={})),function($){function l(b,c){return c-b}$.compare=l;const I=Object.create(null);I[$.Error]=(0,h.localize)(0,null),I[$.Warning]=(0,h.localize)(1,null),I[$.Info]=(0,h.localize)(2,null);function E(b){return I[b]||""}$.toString=E;function u(b){switch(b){case r.default.Error:return $.Error;case r.default.Warning:return $.Warning;case r.default.Info:return $.Info;case r.default.Ignore:return $.Hint}}$.fromSeverity=u;function k(b){switch(b){case $.Error:return r.default.Error;case $.Warning:return r.default.Warning;case $.Info:return r.default.Info;case $.Hint:return r.default.Ignore}}$.toSeverity=k}(N||(e.MarkerSeverity=N={}));var T;(function($){const l="";function I(u){return E(u,!0)}$.makeKey=I;function E(u,k){const b=[l];return u.source?b.push(u.source.replace("\xA6","\\\xA6")):b.push(l),u.code?typeof u.code=="string"?b.push(u.code.replace("\xA6","\\\xA6")):b.push(u.code.value.replace("\xA6","\\\xA6")):b.push(l),u.severity!==void 0&&u.severity!==null?b.push(N.toString(u.severity)):b.push(l),u.message&&k?b.push(u.message.replace("\xA6","\\\xA6")):b.push(l),u.startLineNumber!==void 0&&u.startLineNumber!==null?b.push(u.startLineNumber.toString()):b.push(l),u.startColumn!==void 0&&u.startColumn!==null?b.push(u.startColumn.toString()):b.push(l),u.endLineNumber!==void 0&&u.endLineNumber!==null?b.push(u.endLineNumber.toString()):b.push(l),u.endColumn!==void 0&&u.endColumn!==null?b.push(u.endColumn.toString()):b.push(l),b.push(l),b.join("\xA6")}$.makeKeyOptionalMessage=E})(T||(e.IMarkerData=T={})),e.$yu=(0,A.$Ei)("markerService")});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[280],Se([1,0,4,44,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$lw=e.Severity=void 0,e.$mw=T,h=zt(h),e.Severity=h.default,e.$lw=(0,A.$Ei)("notificationService");var R;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var N;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(N||(e.NeverShowAgainScope=N={}));function T(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class l{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$nw=l;class I{infinite(){}done(){}total(u){}worked(u){}}e.$ow=I}),define(Ee[281],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Ee[116],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,r.$Ei)("productService"),e.$sk="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(ce,e){return function(r,h){e(r,h,ce)}};define(Ee[90],Se([1,0,9,21,3,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.$tw=e.$sw=e.$rw=e.$qw=e.ProgressLocation=e.$pw=void 0,e.$pw=(0,R.$Ei)("progressService");var N;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(N||(e.ProgressLocation=N={})),e.$qw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$rw=T;class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const k=this.d;this.d=()=>{k?.(),u()}}):Promise.resolve()}}e.$sw=$;let l=class extends A.$Vc{constructor(u,k){super(),this.a=new r.$2h,k.withProgress(u,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,A.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$tw=l,e.$tw=l=Qe([qe(1,e.$pw)],l);class I extends A.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Uc)}start(u){this.stop();const k=++this.a,b=new h.$we;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Tc)(()=>b.cancel())),this.b.add((0,A.$Tc)(()=>this.c?this.c.done():void 0)),{id:k,token:b.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$uw=I,e.$vw=(0,R.$Ei)("editorProgressService")}),define(Ee[37],Se([1,0,66,18]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,r=We(r),h=We(h);class A{constructor(){this.a=new Map}add(N,T){r.ok(h.$eg(N)),r.ok(h.$gg(T)),r.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,T)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$oo=new A}),define(Ee[117],Se([1,0,4,37]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,h=We(h),e.$po={JSONContribution:"base.contributions.json"};function A(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this.b=new r.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,l){this.a[A($)]=l,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const N=new R;h.$oo.add(e.$po.JSONContribution,N)}),define(Ee[71],Se([1,0,19,4,18,217,45,117,37]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=c,e.$Fo=g,e.$Go=f,e.$Ho=n,e.$Io=o,A=We(A),R=We(R);var l;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$to={Configuration:"base.contributions.configuration"};var I;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const E=$.$oo.as(T.$po.JSONContribution);class u{constructor(){this.h=new Set,this.i=new h.$le,this.onDidSchemaChange=this.i.event,this.j=new h.$le,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const d=new Set;this.n(t,s,d),E.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const s=new Set;this.o(t,s),E.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const d=new Set;this.o(s,d),this.n(t,!1,d),E.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const d=[];for(const{overrides:a,source:w}of t)for(const y in a)if(s.add(y),e.$Do.test(y)){const S=this.a.get(y),D=S?.valuesSources??new Map;if(w)for(const v of Object.keys(a[y]))D.set(v,w);const P={...S?.value||{},...a[y]};this.a.set(y,{source:w,value:P,valuesSources:D});const C=(0,N.$ij)(y),p={type:"object",default:P,description:R.localize(1,null,C),$ref:e.$Ao,defaultDefaultValue:P,source:A.$eg(w)?void 0:w,defaultValueSource:w};d.push(...c(y)),this.d[y]=p,this.b.properties[y]=p}else{this.a.set(y,{value:a[y],source:w});const S=this.d[y];S&&(this.w(y,S),this.r(y,S))}this.m(d)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:d,source:a}of t)for(const w in d){const y=this.a.get(w),S=A.$eg(a)?a:a?.id,D=A.$eg(y?.source)?y?.source:y?.source?.id;if(S===D)if(s.add(w),this.a.delete(w),e.$Do.test(w))delete this.d[w],delete this.b.properties[w];else{const P=this.d[w];P&&(this.w(w,P),this.r(w,P))}}this.u()}deltaConfiguration(t){let s=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,d){t.forEach(a=>{this.p(a,s,a.extensionInfo,a.restrictedProperties,void 0,d),this.c.push(a),this.q(a)})}o(t,s){const d=a=>{if(a.properties)for(const w in a.properties){s.add(w);const y=this.d[w];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[w],this.s(w,a.properties[w])}a.allOf?.forEach(w=>d(w))};for(const a of t){d(a);const w=this.c.indexOf(a);w!==-1&&this.c.splice(w,1)}}p(t,s=!0,d,a,w=I.WINDOW,y){w=A.$ng(t.scope)?w:t.scope;const S=t.properties;if(S)for(const P in S){const C=S[P];if(s&&n(P,C)){delete S[P];continue}if(C.source=d,C.defaultDefaultValue=S[P].default,this.w(P,C),e.$Do.test(P)?C.scope=void 0:(C.scope=A.$ng(C.scope)?w:C.scope,C.restricted=A.$ng(C.restricted)?!!a?.includes(P):C.restricted),S[P].hasOwnProperty("included")&&!S[P].included){this.f[P]=S[P],delete S[P];continue}else this.d[P]=S[P],S[P].policy?.name&&this.e.set(S[P].policy.name,P);!S[P].deprecationMessage&&S[P].markdownDeprecationMessage&&(S[P].deprecationMessage=S[P].markdownDeprecationMessage),y.add(P)}const D=t.allOf;if(D)for(const P of D)this.p(P,s,d,a,w,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=d=>{const a=d.properties;if(a)for(const y in a)this.r(y,a[y]);d.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$uo.properties[t]=s,s.scope){case I.APPLICATION:e.$vo.properties[t]=s;break;case I.MACHINE:e.$wo.properties[t]=s;break;case I.MACHINE_OVERRIDABLE:e.$xo.properties[t]=s;break;case I.WINDOW:e.$yo.properties[t]=s;break;case I.RESOURCE:e.$zo.properties[t]=s;break;case I.LANGUAGE_OVERRIDABLE:e.$zo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$uo.properties[t],s.scope){case I.APPLICATION:delete e.$vo.properties[t];break;case I.MACHINE:delete e.$wo.properties[t];break;case I.MACHINE_OVERRIDABLE:delete e.$xo.properties[t];break;case I.WINDOW:delete e.$yo.properties[t];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$Ao};this.w(s,d),e.$uo.properties[s]=d,e.$vo.properties[s]=d,e.$wo.properties[s]=d,e.$xo.properties[s]=d,e.$yo.properties[s]=d,e.$zo.properties[s]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=t,e.$vo.patternProperties[e.$Co]=t,e.$wo.patternProperties[e.$Co]=t,e.$xo.patternProperties[e.$Co]=t,e.$yo.patternProperties[e.$Co]=t,e.$zo.patternProperties[e.$Co]=t,this.i.fire()}w(t,s){const d=this.a.get(t);let a=d?.value,w=d?.source;A.$lg(a)&&(a=s.defaultDefaultValue,w=void 0),A.$lg(a)&&(a=f(s.type)),s.default=a,s.defaultValueSource=w}}const k="\\[([^\\]]+)\\]",b=new RegExp(k,"g");e.$Co=`^(${k})+$`,e.$Do=new RegExp(e.$Co);function c(i){const t=[];if(e.$Do.test(i)){let s=b.exec(i);for(;s?.length;){const d=s[1].trim();d&&t.push(d),s=b.exec(i)}}return(0,r.$Nb)(t)}function g(i){return i.reduce((t,s)=>`${t}[${s}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;$.$oo.add(e.$to.Configuration,m);function n(i,t){return i.trim()?e.$Do.test(i)?R.localize(7,null,i):m.getConfigurationProperties()[i]!==void 0?R.localize(8,null,i):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,i,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function o(){const i=[],t=m.getConfigurationProperties();for(const s of Object.keys(t))i.push([s,t[s].scope]);return i.push(["launch",I.RESOURCE]),i.push(["task",I.RESOURCE]),i}}),define(Ee[282],Se([1,0,19,4,175,3,29,25,18,2,45,71,28,37]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=o,r=We(r),A=We(A),T=We(T),$=We($);function b(d){return Object.isFrozen(d)?d:T.$co(d)}class c{static createEmptyModel(a){return new c({},[],[],void 0,a)}constructor(a,w,y,S,D){this.b=a,this.c=w,this.d=y,this.raw=S,this.f=D,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(w=>{if(w instanceof c)return w;const y=new g("",this.f);return y.parseRaw(w),y.configurationModel});this.g=a.reduce((w,y)=>y===w?y:w.merge(y),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,I.$gj)(this.contents,a):this.contents}inspect(a,w){const y=this;return{get value(){return b(y.rawConfiguration.getValue(a))},get override(){return w?b(y.rawConfiguration.getOverrideValue(a,w)):void 0},get merged(){return b(w?y.rawConfiguration.override(w).getValue(a):y.rawConfiguration.getValue(a))},get overrides(){const S=[];for(const{contents:D,identifiers:P,keys:C}of y.rawConfiguration.overrides){const p=new c(D,C,[],void 0,y.f).getValue(a);p!==void 0&&S.push({identifiers:P,value:p})}return S.length?b(S):void 0}}}getOverrideValue(a,w){const y=this.j(w);return y?a?(0,I.$gj)(y,a):y:void 0}getKeysForOverrideIdentifier(a){const w=[];for(const y of this.overrides)y.identifiers.includes(a)&&w.push(...y.keys);return r.$Nb(w)}getAllOverrideIdentifiers(){const a=[];for(const w of this.overrides)a.push(...w.identifiers);return r.$Nb(a)}override(a){let w=this.a.get(a);return w||(w=this.h(a),this.a.set(a,w)),w}merge(...a){const w=T.$bo(this.contents),y=T.$bo(this.overrides),S=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const P of a)if(D.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(w,P.contents);for(const C of P.overrides){const[p]=y.filter(v=>r.$vb(v.identifiers,C.identifiers));p?(this.i(p.contents,C.contents),p.keys.push(...C.keys),p.keys=r.$Nb(p.keys)):y.push(T.$bo(C))}for(const C of P.keys)S.indexOf(C)===-1&&S.push(C)}return new c(w,S,y,D.every(P=>P instanceof c)?void 0:D,this.f)}h(a){const w=this.j(a);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const y={};for(const S of r.$Nb([...Object.keys(this.contents),...Object.keys(w)])){let D=this.contents[S];const P=w[S];P&&(typeof D=="object"&&typeof P=="object"?(D=T.$bo(D),this.i(D,P)):D=P),y[S]=D}return new c(y,this.keys,this.overrides,void 0,this.f)}i(a,w){for(const y of Object.keys(w)){if(y in a&&$.$gg(a[y])&&$.$gg(w[y])){this.i(a[y],w[y]);continue}a[y]=T.$bo(w[y])}}j(a){let w=null,y=null;const S=D=>{D&&(y?this.i(y,D):y=T.$bo(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===a?w=D.contents:D.identifiers.includes(a)&&S(D.contents);return S(w),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,w){this.k(a,w,!0)}setValue(a,w){this.k(a,w,!1)}removeValue(a){const w=this.keys.indexOf(a);w!==-1&&(this.keys.splice(w,1),(0,I.$fj)(this.contents,a),E.$Do.test(a)&&this.overrides.splice(this.overrides.findIndex(y=>r.$vb(y.identifiers,(0,E.$Eo)(a))),1))}k(a,w,y){(0,I.$ej)(this.contents,a,w,S=>this.f.error(S)),y=y||this.keys.indexOf(a)===-1,y&&this.keys.push(a),E.$Do.test(a)&&this.overrides.push({identifiers:(0,E.$Eo)(a),keys:Object.keys(this.contents[a]),contents:(0,I.$dj)(this.contents[a],S=>this.f.error(S))})}}e.$Jo=c;class g{constructor(a,w){this.f=a,this.g=w,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,w){if(!$.$ng(a)){const y=this.h(a);this.parseRaw(y,w)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,w){this.a=a;const{contents:y,keys:S,overrides:D,restricted:P,hasExcludedProperties:C}=this.i(a,w);this.b=new c(y,S,D,C?[a]:void 0,this.g),this.c=P||[]}h(a){let w={},y=null,S=[];const D=[],P=[];function C(v){Array.isArray(S)?S.push(v):y!==null&&(S[y]=v)}const p={onObjectBegin:()=>{const v={};C(v),D.push(S),S=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{S=D.pop()},onArrayBegin:()=>{const v=[];C(v),D.push(S),S=v,y=null},onArrayEnd:()=>{S=D.pop()},onLiteralValue:C,onError:(v,O,L)=>{P.push({error:v,offset:O,length:L})}};if(a)try{A.$2n(a,p),w=S[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return w}i(a,w){const y=k.$oo.as(E.$to.Configuration).getConfigurationProperties(),S=this.j(a,y,!0,w);a=S.raw;const D=(0,I.$dj)(a,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),P=Object.keys(a),C=this.l(a,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:D,keys:P,overrides:C,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(a,w,y,S){let D=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:D};const P={},C=[];for(const p in a)if(E.$Do.test(p)&&y){const v=this.j(a[p],w,!1,S);P[p]=v.raw,D=D||v.hasExcludedProperties,C.push(...v.restricted)}else{const v=w[p],O=v?typeof v.scope<"u"?v.scope:E.ConfigurationScope.WINDOW:void 0;v?.restricted&&C.push(p),!S.exclude?.includes(p)&&(S.include?.includes(p)||(O===void 0||S.scopes===void 0||S.scopes.includes(O))&&!(S.skipRestricted&&v?.restricted))?P[p]=a[p]:D=!0}return{raw:P,restricted:C,hasExcludedProperties:D}}l(a,w){const y=[];for(const S of Object.keys(a))if(E.$Do.test(S)){const D={};for(const P in a[S])D[P]=a[S][P];y.push({identifiers:(0,E.$Eo)(S),keys:Object.keys(D),contents:(0,I.$dj)(D,w)})}return y}}e.$Ko=g;class f extends R.$Vc{constructor(a,w,y,S,D){super(),this.c=a,this.f=w,this.g=S,this.h=D,this.b=this.B(new h.$le),this.onDidChange=this.b.event,this.a=new g(this.c.toString(),D),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(u.FileOperation.CREATE)||P.isOperation(u.FileOperation.COPY)||P.isOperation(u.FileOperation.DELETE)||P.isOperation(u.FileOperation.WRITE))&&y.isEqual(P.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=f;class m{constructor(a,w,y,S,D,P,C,p,v,O,L,F,j){this.a=a,this.b=w,this.c=y,this.overrideIdentifiers=S,this.d=D,this.f=P,this.g=C,this.h=p,this.i=v,this.j=O,this.k=L,this.l=F,this.m=j}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,w,y,S,D,P,C,p,v,O){this.j=a,this.l=w,this.m=y,this.n=S,this.p=D,this.q=P,this.r=C,this.s=p,this.t=v,this.u=O,this.h=null,this.i=new N.$Bc,this.v=null}getValue(a,w,y){return this.w(a,w,y).getValue(a)}updateValue(a,w,y={}){let S;y.resource?(S=this.t.get(y.resource),S||(S=c.createEmptyModel(this.u),this.t.set(y.resource,S))):S=this.s,w===void 0?S.removeValue(a):S.setValue(a,w),y.resource||(this.h=null)}inspect(a,w,y){const S=this.w(a,w,y),D=this.A(w.resource,y),P=w.resource?this.t.get(w.resource)||this.s:this.s,C=new Set;for(const p of S.overrides)for(const v of p.identifiers)S.getOverrideValue(a,v)!==void 0&&C.add(v);return new m(a,w,S.getValue(a),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,D||void 0,P)}keys(a){const w=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,w){this.r.set(a,w),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,w){const y=[];if(!w){const{added:S,updated:D,removed:P}=t(this.j,a);w=[...S,...D,...P]}for(const S of w)for(const D of(0,E.$Eo)(S)){const P=this.j.getKeysForOverrideIdentifier(D),C=a.getKeysForOverrideIdentifier(D),p=[...C.filter(v=>P.indexOf(v)===-1),...P.filter(v=>C.indexOf(v)===-1),...P.filter(v=>!T.$fo(this.j.override(D).getValue(v),a.override(D).getValue(v)))];y.push([D,p])}return this.updateDefaultConfiguration(a),{keys:w,overrides:y}}compareAndUpdatePolicyConfiguration(a){const{added:w,updated:y,removed:S}=t(this.l,a),D=[...w,...y,...S];return D.length&&this.updatePolicyConfiguration(a),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.applicationConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateApplicationConfiguration(a),{keys:P,overrides:D}}compareAndUpdateLocalUserConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.localUserConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateLocalUserConfiguration(a),{keys:P,overrides:D}}compareAndUpdateRemoteUserConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.remoteUserConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateRemoteUserConfiguration(a),{keys:P,overrides:D}}compareAndUpdateWorkspaceConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.workspaceConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateWorkspaceConfiguration(a),{keys:P,overrides:D}}compareAndUpdateFolderConfiguration(a,w){const y=this.folderConfigurations.get(a),{added:S,updated:D,removed:P,overrides:C}=t(y,w),p=[...S,...D,...P];return(p.length||!y)&&this.updateFolderConfiguration(a,w),{keys:p,overrides:C}}compareAndDeleteFolderConfiguration(a){const w=this.folderConfigurations.get(a);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:y,updated:S,removed:D,overrides:P}=t(w,void 0);return{keys:[...y,...S,...D],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,w,y){let S=this.x(w,y);return w.overrideIdentifier&&(S=S.override(w.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(S=S.merge(this.l)),S}x({resource:a},w){let y=this.y();if(w&&a){const S=w.getFolder(a);S&&(y=this.z(S.uri)||y);const D=this.t.get(a);D&&(y=y.merge(D))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let w=this.i.get(a);if(!w){const y=this.y(),S=this.r.get(a);S?(w=y.merge(S),this.i.set(a,w)):w=y}return w}A(a,w){if(w&&a){const y=w.getFolder(a);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,w)=>{const{contents:y,overrides:S,keys:D}=this.r.get(w);return a.push([w,{contents:y,overrides:S,keys:D}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(w=>a.add(w)),this.userConfiguration.keys.forEach(w=>a.add(w)),this.q.keys.forEach(w=>a.add(w)),this.r.forEach(w=>w.keys.forEach(y=>a.add(y))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.q.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.r.forEach(w=>w.getAllOverrideIdentifiers().forEach(y=>a.add(y))),[...a.values()]}D(a){const w=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.q.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(a).forEach(S=>w.add(S))),[...w.values()]}static parse(a,w){const y=this.E(a.defaults,w),S=this.E(a.policy,w),D=this.E(a.application,w),P=this.E(a.user,w),C=this.E(a.workspace,w),p=a.folders.reduce((v,O)=>(v.set(l.URI.revive(O[0]),this.E(O[1],w)),v),new N.$Bc);return new n(y,S,D,P,c.createEmptyModel(w),C,p,c.createEmptyModel(w),new N.$Bc,w)}static E(a,w){return new c(a.contents,a.keys,a.overrides,void 0,w)}}e.$Mo=n;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const a=new Set,w=new Map;for(const S of d)S.keys.forEach(D=>a.add(D)),S.overrides.forEach(([D,P])=>{const C=(0,N.$yc)(w,D,new Set);P.forEach(p=>C.add(p))});const y=[];return w.forEach((S,D)=>y.push([D,[...S.values()]])),{keys:[...a.values()],overrides:y}}class i{constructor(a,w,y,S,D){this.change=a,this.f=w,this.g=y,this.h=S,this.i=D,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of a.keys)this.affectedKeys.add(P);for(const[,P]of a.overrides)for(const C of P)this.affectedKeys.add(C);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,w){const y=this.a+a,S=this.d.indexOf(y);if(S<0)return!1;const D=S+y.length;if(D>=this.d.length)return!1;const P=this.d.charCodeAt(D);if(P!==this.b&&P!==this.c)return!1;if(w){const C=this.previousConfiguration?this.previousConfiguration.getValue(a,w,this.f?.workspace):void 0,p=this.g.getValue(a,w,this.h);return!T.$fo(C,p)}return!0}}e.$Oo=i;function t(d,a){const{added:w,removed:y,updated:S}=s(a?.rawConfiguration,d?.rawConfiguration),D=[],P=d?.getAllOverrideIdentifiers()||[],C=a?.getAllOverrideIdentifiers()||[];if(a){const p=C.filter(v=>!P.includes(v));for(const v of p)D.push([v,a.getKeysForOverrideIdentifier(v)])}if(d){const p=P.filter(v=>!C.includes(v));for(const v of p)D.push([v,d.getKeysForOverrideIdentifier(v)])}if(a&&d){for(const p of P)if(C.includes(p)){const v=s({contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)},{contents:a.getOverrideValue(void 0,p)||{},keys:a.getKeysForOverrideIdentifier(p)});D.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:w,removed:y,updated:S,overrides:D}}function s(d,a){const w=d?a?d.keys.filter(D=>a.keys.indexOf(D)===-1):[...d.keys]:[],y=a?d?a.keys.filter(D=>d.keys.indexOf(D)===-1):[...a.keys]:[],S=[];if(d&&a){for(const D of a.keys)if(d.keys.indexOf(D)!==-1){const P=(0,I.$gj)(a.contents,D),C=(0,I.$gj)(d.contents,D);T.$fo(P,C)||S.push(D)}}return{added:w,removed:y,updated:S}}}),define(Ee[283],Se([1,0,22,4,3,69]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=e.$owb=e.$nwb=void 0,e.$pwb=T;const N=(l,I,E)=>{const u=new Uint8Array(16);for(let c=0;c<16;c++)u[c]=Math.round(Math.random()*256);const k=(0,r.$8e)(r.$Ne.wrap(u));return[`GET ws://localhost${l}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$nwb=N,e.$owb=r.$Ne.fromString(`\r
\r
`);async function T(l,I,E,u,k){l.write(r.$Ne.fromString((0,e.$nwb)(I,E,u)));const b=new A.$Uc;try{return await new Promise((c,g)=>{let f;b.add(l.onData(m=>{f?f=r.$Ne.concat([f,m],f.byteLength+m.byteLength):f=m;const n=f.indexOf(e.$owb);if(n===-1)return;c(l),l.pauseData();const o=f.slice(n+e.$owb.byteLength);o.byteLength&&k.onData.fire(o)})),b.add(l.onClose(m=>g(m??new Error("socket closed")))),b.add(l.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw l.dispose(),c}finally{b.dispose()}}class $ extends A.$Vc{constructor(I,E){super(),this.g=I,this.a=this.B(new h.$oe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$le),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(u=>this.a.fire(u))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,E){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$qwb=$}),define(Ee[72],Se([1,0,14,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=l,e.$Pl=(0,h.$Ei)("remoteAuthorityResolverService");var A;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(E){this.id=E,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=R;class N{constructor(E,u){this.host=E,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=N;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends r.$cb{static isNotAvailable(E){return E instanceof $&&E._code===T.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof $&&E._code===T.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof $&&E._code===T.NoResolverFound}static isInvalidAuthority(E){return E instanceof $&&E._code===T.InvalidAuthority}static isHandled(E){return E instanceof $&&E.isHandled}constructor(E,u=T.Unknown,k){super(E),this._message=E,this._code=u,this._detail=k,this.isHandled=u===T.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Sl=$;function l(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(Ee[284],Se([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Yl=D,e.$Zl=P,e.$1l=p,l=We(l);const b=30*1e3;var c;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g($e){switch($e){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function f($e){const J=new A.$we;return setTimeout(()=>J.cancel(),$e),J.token}function m($e,J){if($e.isCancellationRequested||J.isCancellationRequested)return A.CancellationToken.Cancelled;const W=new A.$we;return $e.onCancellationRequested(()=>W.cancel()),J.onCancellationRequested(()=>W.cancel()),W.token}class n{get didTimeout(){return this.c==="timedout"}constructor(J){this.c="pending",this.d=new T.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$xh)(),J.isCancellationRequested?this.h():this.d.add(J.onCancellationRequested(()=>this.h()))}registerDisposable(J){this.c==="pending"?this.d.add(J):J.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const J=new Error("Time limit reached");return J.code="ETIMEDOUT",J.syscall="connect",J}resolve(J){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(J))}reject(J){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(J))}}function o($e,J){const W=new n(J);return W.registerDisposable($e.onControlMessage(se=>{const oe=JSON.parse(se.toString()),te=G(oe);te?W.reject(te):W.resolve(oe)})),W.promise}function i($e,J,W,se,oe,te,le,he){const Z=new n(he),ae=I.$fe.create(!1);return $e.info(`Creating a socket (${le})...`),l.mark(`code/willCreateSocket/${te}`),J.connect(W,se,oe,le).then(pe=>{Z.didTimeout?(l.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(l.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${le}) was successful after ${ae.elapsed()} ms.`),Z.resolve(pe))},pe=>{l.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) returned an error after ${ae.elapsed()} ms.`),$e.error(pe),Z.reject(pe)}),Z.promise}function t($e,J){const W=new n(J);return $e.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function s($e,J,W,se){const oe=ne($e,J);$e.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let te;try{te=await i($e.logService,$e.remoteSocketFactoryService,$e.connectTo,$.$Rg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,g(J),`renderer-${g(J)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let le,he;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),le=$e.reconnectionProtocol,he=!1):(le=new u.$si({socket:te}),he=!0),$e.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const Z=await t($e.signService.createNewMessage((0,E.$1g)()),se),ae={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:Z.data};le.sendControl(h.$Ne.fromString(JSON.stringify(ae)));try{const pe=await o(le,m(se,f(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if($e.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await t($e.signService.validate(Z,pe.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Me=await t($e.signService.sign(pe.data),se),ze={type:"connectionType",commit:$e.commit,signedData:Me,desiredConnectionType:J};return W&&(ze.args=W),$e.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Ne.fromString(JSON.stringify(ze))),{protocol:le,ownsProtocol:he}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${oe} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${oe} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),he&&U(le),pe}}async function d($e,J,W,se){const oe=Date.now(),te=ne($e,J),{protocol:le,ownsProtocol:he}=await s($e,J,W,se),Z=new n(se);return Z.registerDisposable(le.onControlMessage(ae=>{const pe=JSON.parse(ae.toString()),be=G(pe);be?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(be),he&&U(le),Z.reject(be)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(oe)}!`),Z.resolve({protocol:le,firstMessage:pe}))})),Z.promise}async function a($e,J){const{protocol:W}=await d($e,c.Management,void 0,J);return{protocol:W}}async function w($e,J,W){const{protocol:se,firstMessage:oe}=await d($e,c.ExtensionHost,J,W),te=oe&&oe.debugPort;return{protocol:se,debugPort:te}}async function y($e,J,W){const se=Date.now(),oe=ne($e,c.Tunnel),{protocol:te}=await s($e,c.Tunnel,J,W);return $e.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function S($e,J,W){const{connectTo:se,connectionToken:oe}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:oe,reconnectionToken:J,reconnectionProtocol:W,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function D($e,J,W){return C($e,async se=>{const{protocol:oe}=await a(se,A.CancellationToken.None);return new _($e,J,W,se.reconnectionToken,oe)})}async function P($e,J){return C($e,async W=>{const{protocol:se,debugPort:oe}=await w(W,J,A.CancellationToken.None);return new re($e,J,W.reconnectionToken,se,oe)})}async function C($e,J){for(let se=1;;se++)try{const oe=(0,E.$1g)(),te=await S($e,oe,null);return await J(te)}catch(oe){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(oe);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(oe),z.triggerPermanentFailure(0,0,k.$Sl.isHandled(oe)),oe}}async function p($e,J,W){const se=await S($e,(0,E.$1g)(),null);return await y(se,{host:J,port:W},A.CancellationToken.None)}function v($e){return(0,r.$rh)(J=>new Promise((W,se)=>{const oe=setTimeout(W,$e*1e3);J.onCancellationRequested(()=>{clearTimeout(oe),W()})}))}var O;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class L{constructor(J,W){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.type=O.ConnectionLost}}e.$2l=L;class F{constructor(J,W,se,oe){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.c=oe,this.type=O.ReconnectionWait}skipWait(){this.c.cancel()}}e.$3l=F;class j{constructor(J,W,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=O.ReconnectionRunning}}e.$4l=j;class B{constructor(J,W,se){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=O.ConnectionGain}}e.$5l=B;class M{constructor(J,W,se,oe){this.reconnectionToken=J,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=oe,this.type=O.ReconnectionPermanentFailure}}e.$6l=M;class z extends T.$Vc{static triggerPermanentFailure(J,W,se){this._permanentFailure=!0,this.f=J,this.g=W,this.h=se,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(J=>J.y())}static debugPauseSocketWriting(){this.j.forEach(J=>J.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||z._permanentFailure}constructor(J,W,se,oe,te){super(),this.t=J,this.u=W,this.reconnectionToken=se,this.protocol=oe,this.w=te,this.m=this.B(new N.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new B(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(le=>{const he=ue(this.t,this.reconnectionToken,!0);le?le.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${he} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${he} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${he} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(le=>{const he=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${he} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),z.j.push(this),this.B((0,T.$Tc)(()=>{const le=z.j.indexOf(this);le>=0&&z.j.splice(le,1)})),this.n&&this.D(z.f,z.g,z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const J=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const oe=se<W.length?W[se]:W[W.length-1];try{if(oe>0){const le=v(oe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,le)),this.u.logService.info(`${J} waiting for ${oe} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${J} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${J} resolving connection...`);const te=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${J} connecting to ${te.connectTo}...`),await this.G(te,f(b)),this.u.logService.info(`${J} reconnected!`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${J} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${J} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(k.$Sl.isTemporarilyNotAvailable(te)){this.u.logService.info(`${J} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${J} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$5)(te)){this.u.logService.info(`${J} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof k.$Sl){this.u.logService.error(`${J} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,k.$Sl.isHandled(te));break}this.u.logService.error(`${J} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(J,W,se){this.w?z.triggerPermanentFailure(J,W,se):this.D(J,W,se)}D(J,W,se){this.m.fire(new M(this.reconnectionToken,J,W,se)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7l=z;class _ extends z{constructor(J,W,se,oe,te){super(c.Management,J,oe,te,!0),this.client=this.B(new u.$qi(te,{remoteAuthority:W,clientId:se},J.ipcLogger))}async G(J,W){await a(J,W)}}e.$8l=_;class re extends z{constructor(J,W,se,oe,te){super(c.ExtensionHost,J,se,oe,!1),this.H=W,this.debugPort=te}async G(J,W){await w(J,this.H,W)}}e.$9l=re;function U($e){try{$e.acceptDisconnect();const J=$e.getSocket();$e.dispose(),J.dispose()}catch(J){(0,R.$2)(J)}}function G($e){if($e&&$e.type==="error"){const J=new Error(`Connection error: ${$e.reason}`);return J.code="VSCODE_CONNECTION_ERROR",J}return null}function K($e,J){for(;$e.length<J;)$e+=" ";return $e}function ee($e,J){return`[remote-connection][${K(g($e),13)}][${J.substr(0,5)}\u2026]`}function ue($e,J,W){return`${ee($e,J)}[${W?"reconnect":"initial"}]`}function ne($e,J){return`${ue(J,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function De($e){return`${Date.now()-$e} ms`}}),define(Ee[91],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=h,e.$gn=A,e.$hn=R,e.$in=N;function h($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}function A($){if(!$)return;const l=$.indexOf("+");return l<0?$:$.substr(0,l)}function R($){const{host:l,port:I}=T($);if(typeof I>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:I}}function N($,l){let{host:I,port:E}=T($);return typeof E>"u"&&(E=l),{host:I,port:E}}function T($){const l=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=$.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:$,port:void 0}}}),define(Ee[24],Se([1,0,13,5,91]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=R,e.$sn=E,e.$tn=u,e.$un=k,e.$vn=b,r=We(r),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function R(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$on=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(N||(e.ExtensionType=N={}));var T;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,f){if(typeof g>"u"||g===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof g=="string"||typeof f=="string"){const m=typeof g=="string"?g:g.value,n=typeof f=="string"?f:f.value;return r.$Ff(m,n)}return g._lower===f._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$pn=$;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const f of g)this.add(f)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$qn=l;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,f){this.c.set($.toKey(g),f)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=I;function E(c){return u(c)}function u(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function k(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function b(c,g){if(g){const f=`onResolveRemoteAuthority:${(0,A.$gn)(g)}`;return!!c.activationEvents?.includes(f)}return!1}e.$wn=(0,h.$Ei)("IBuiltinExtensionsScannerService")}),define(Ee[146],Se([1,0,11,221,24,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=T,e.$bp=$,e.$cp=l,e.$dp=I,e.$ep=E,e.$fp=u,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var N;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(N||(e.ExtensionInstallSource=N={}));function T(i){switch(i){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function $(i){switch(i){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function l(i,t){switch(i){case r.Platform.Windows:return t==="x64"?A.TargetPlatform.WIN32_X64:t==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?A.TargetPlatform.LINUX_X64:t==="arm64"?A.TargetPlatform.LINUX_ARM64:t==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?A.TargetPlatform.ALPINE_X64:t==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?A.TargetPlatform.DARWIN_X64:t==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Web:return A.TargetPlatform.WEB}}function I(i,t){return t===A.TargetPlatform.WEB&&!i.includes(A.TargetPlatform.WEB)}function E(i,t,s){return I(t,s)?!1:i===A.TargetPlatform.UNDEFINED||i===A.TargetPlatform.UNIVERSAL?!0:i===A.TargetPlatform.UNKNOWN?!1:i===s}function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var k;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var b;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var c;(function(i){i.Install="install",i.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var g;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$gp=(0,R.$Ei)("extensionGalleryService");var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class m extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$hp=m;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$ip=o,e.$jp=(0,R.$Ei)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,R.$Ei)("IGlobalExtensionEnablementService"),e.$np=(0,R.$Ei)("IExtensionTipsService"),e.$op=(0,h.localize2)(0,"Extensions"),e.$pp=(0,h.localize2)(1,"Preferences")}),define(Ee[147],Se([1,0,14,24]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(N,T){this.a.set(N,T)}readActivationEvents(N){return this.b.has(N)||this.b.set(N,this.c(N)),this.b.get(N)}createActivationEventsMap(N){const T=Object.create(null);for(const $ of N){const l=this.readActivationEvents($);l.length>0&&(T[h.$pn.toKey($.identifier)]=l)}return T}c(N){if(typeof N.main>"u"&&typeof N.browser>"u")return[];const T=Array.isArray(N.activationEvents)?N.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${h.$pn.toKey(N.identifier)}`);if(!N.contributes)return T;for(const $ in N.contributes){const l=this.a.get($);if(!l)continue;const I=N.contributes[$],E=Array.isArray(I)?I:[I];try{l(E,T)}catch(u){(0,r.$2)(u)}}return T}}e.$HG=A,e.$IG=new A}),define(Ee[285],Se([1,0,3,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul=(0,h.$Ei)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(N,T){return this.a[N]??=[],this.a[N].push(T),(0,r.$Tc)(()=>{const $=this.a[N]?.indexOf(T);typeof $=="number"&&$>=0&&this.a[N]?.splice($,1)})}b(N){return(this.a[N.type]||[]).find($=>$.supports(N))}connect(N,T,$,l){const I=this.b(N);if(!I)throw new Error(`No socket factory found for ${N}`);return I.connect(N,T,$,l)}}e.$Vl=A}),define(Ee[286],Se([1,0,22,14,3,229,71,5,12,37]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=u,e.$4p=k,e.$5p=b,e.$6p=c,e.$7p=g,e.$8p=f,e.$1p=(0,T.$Ei)("requestService");class I{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class E extends A.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,R.localize)(0,null),when:$.$qk.isEqualTo((0,$.$nk)($.LogLevel.Trace)).serialize()})}async c(i,t,s){const d=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${d} - begin`,t.type,new I(t.headers??{}));try{const a=await s();return this.a.trace(`${d} - end`,t.type,a.res.statusCode,a.res.headers),a}catch(a){throw this.a.error(`${d} - error`,t.type,(0,h.$$)(a)),a}}}e.$2p=E;function u(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function k(o){return o.res.statusCode===204}async function b(o){return k(o)?null:(await(0,r.$Ze)(o.stream)).toString()}async function c(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);return b(o)}async function g(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);if(k(o))return null;const t=(await(0,r.$Ze)(o.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function f(o){n(o)}let m;function n(o){const i=l.$oo.as(N.$to.Configuration),t=m;m={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:t?[t]:[]})}n(N.ConfigurationScope.APPLICATION)}),define(Ee[287],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const R=await this.c();if(R){const N=String(r.a++);return this.b.set(N,R),{id:N,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const N=this.b.get(A.id);if(!N)return!1;this.b.delete(A.id);try{return N.validate(R)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$Eac=r}),define(Ee[118],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl="signService",e.$Xl=(0,r.$Ei)(e.$Wl)}),define(Ee[148],Se([1,0,287]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class h extends r.$Eac{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(N=>new N.signer().sign(R))}h(){return new Promise((R,N)=>ce(["vsda"],R,N))}}e.$Jfc=h}),define(Ee[288],Se([1,0,11,56,32]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=N,e.$rp=T;function R($){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function N($,l,I,E,u,k,b,c,g,f){const m=Object.create(null);m["common.machineId"]=k,m["common.sqmId"]=b,m["common.devDeviceId"]=c,m.sessionID=(0,A.$1g)()+Date.now(),m.commitHash=E,m.version=u,m["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,r.$h)(r.$u),m["common.nodePlatform"]=h.$ec,m["common.nodeArch"]=I,m["common.product"]=f||"desktop",g&&(m["common.msftInternal"]=g);let n=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(m["common.snap"]="true");const i=R(l);return i&&(m["common.platformDetail"]=i),m}function T($){const l=h.env.USERDNSDOMAIN;if(!l)return!1;const I=l.toLowerCase();return $.some(E=>I===E)}}),define(Ee[149],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,r.$Ei)("telemetryService"),e.$$l=(0,r.$Ei)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ee[92],Se([1,0,25,18,91,288,149]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=I,e.$Ap=E,e.$Bp=u,e.$Cp=k,e.$Dp=c,e.$Ep=f,e.$Fp=m,e.$Gp=i;class T{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$sp=T;class ${constructor(){this.telemetryLevel=N.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=$,e.$up=new $;class l{async publicLog(s,d,a){}async publicLogError(s,d,a){}}e.$vp=l,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function E(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const s=t.getValue(N.$gm),d=t.getValue(N.$hm);if(t.getValue(N.$im)===!1||d===!1)return N.TelemetryLevel.NONE;switch(s??N.TelemetryConfiguration.ON){case N.TelemetryConfiguration.ON:return N.TelemetryLevel.USAGE;case N.TelemetryConfiguration.ERROR:return N.TelemetryLevel.ERROR;case N.TelemetryConfiguration.CRASH:return N.TelemetryLevel.CRASH;case N.TelemetryConfiguration.OFF:return N.TelemetryLevel.NONE}}function k(t){const s={},d={},a={};g(t,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const y=a[w];typeof y=="number"?d[w]=y:typeof y=="boolean"?d[w]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${y.length}`),s[w]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[w]=y)}return{properties:s,measurements:d}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const s=(0,A.$gn)(t);return b.has(s)?s:"other"}function g(t,s,d=0,a){if(t)for(const w of Object.getOwnPropertyNames(t)){const y=t[w],S=a?a+w:w;Array.isArray(y)?s[S]=(0,r.$go)(y):y instanceof Date?s[S]=y.toISOString():(0,h.$gg)(y)?d<2?g(y,s,d+1,S+"."):s[S]=(0,r.$go)(y):s[S]=y}}function f(t,s){const d=t.msftInternalDomains||[],a=s.getValue("telemetry.internalTesting");return(0,R.$rp)(d)||a}function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const a=[];for(const D of s)for(;;){const P=D.exec(t);if(!P)break;a.push([P.index,D.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(d="";;){const D=y.exec(t);if(!D)break;const P=a.some(([C,p])=>D.index<p&&C<y.lastIndex);!w.test(D[0])&&!P&&(d+=t.substring(S,D.index)+"<REDACTED: user-file-path>",S=y.lastIndex)}return S<t.length&&(d+=t.substr(S)),d}function o(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of s)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function i(t,s){return(0,r.$do)(t,d=>{if(d instanceof T||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let a=d.replaceAll("%20"," ");a=n(a,s);for(const w of s)a=a.replace(w,"");return a=o(a),a}})}}),define(Ee[289],Se([1,0,13,146,24,11,2,14,56,92]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=I,e.$Jp=b,e.$Kp=c,e.$Lp=g,e.$Mp=f,e.$Np=m,e.$Op=n,e.$Pp=o,e.$Rp=i,e.$Sp=s;function I(d,a){return d.uuid&&a.uuid?d.uuid===a.uuid:d.id===a.id?!0:(0,r.$Af)(d.id,a.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(a){const w=a.manifest?a.manifest.version:a.version,y=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new u(a.identifier,w,y)}static parse(a){const w=E.exec(a);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(a,w,y=A.TargetPlatform.UNDEFINED){this.identifier=a,this.version=w,this.targetPlatform=y,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof u?I(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.$Ip=u;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(d){const a=k.exec(d);return a&&a[1]?[g(a[1]),a[2]]:[g(d),void 0]}function c(d,a){return`${d}.${a}`}function g(d){return d.toLowerCase()}function f(d,a){return g(c(d??A.$ln,a))}function m(d,a){const w=[],y=S=>{for(const D of w)if(D.some(P=>I(a(P),a(S))))return D;return null};for(const S of d){const D=y(S);D?D.push(S):w.push([S])}return w}function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function o(d){return{id:new l.$sp(d.identifier.id),name:new l.$sp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Qp=new A.$pn("pprice.better-merge");function i(d,a){const w=[],y=a.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const S=y.shift();if(S&&w.every(D=>!I(D.identifier,{id:S}))){const D=d.filter(P=>I(P.identifier,{id:S}));D.length===1&&(w.push(D[0]),y.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(d,a){if(!R.$k)return!1;let w;try{w=(await d.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await d.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){a.debug("Error while getting the os-release file.",(0,T.$$)(S))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,a){const w=await t(d,a),y=(0,h.$cp)(w?"alpine":R.$u,$.$fc);return a.debug("ComputeTargetPlatform:",y),y}}),define(Ee[290],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=r,e.$zs=h,e.$As=A,e.$Bs=R,e.$Cs=N,e.$Ds=T;function r($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function A($){return new Map($)}function R($){return new Map($??[])}function N($){return Array.from($.entries()).map(l=>[l[0],r(l[1].map),h(l[1].descriptionMap)])}function T($){return new Map($.map(l=>[l[0],{map:A(l[1]),descriptionMap:R(l[2])}]))}}),define(Ee[291],Se([1,0,5,36,37]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$is=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hs=void 0,e.$hs=new h.$Vj("terminalTabFocusMode",!1,!0);var R;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var N;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(N||(e.TerminalSettingId=N={}));var T;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})($||(e.WindowsShellType=$={}));var l;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var I;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var E;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$is=(0,r.$Ei)("ptyService");var u;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var k;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(k||(e.TerminalLocation=k={}));var b;(function(i){i.TerminalView="view",i.Editor="editor"})(b||(e.TerminalLocationString=b={}));var c;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var g;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var f;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var m;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$js={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}A.$oo.add(e.$js.Backend,new o),e.$ks=(0,r.$Ei)("localPtyService"),e.$ls=(0,r.$Ei)("terminalLogService")}),define(Ee[292],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iwb=void 0;class r{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,N=5){const T=R($=>{const l=typeof $=="string"?$:$.data;let I=this.a.get(A);if(I){I.data.push(l);return}const E=setTimeout(()=>this.flushBuffer(A),N);I={data:[l],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(A),T.dispose()}},this.a.set(A,I)});return T}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$Iwb=r}),define(Ee[293],Se([1,0,9,83,105,50,4,18,2,230,117,37]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ax=e.$zx=e.$yx=e.$xx=e.$wx=e.$vx=e.IconFontDefinition=e.IconContribution=e.$sx=void 0,e.$tx=g,e.$ux=f,E=We(E),e.$sx={IconContribution:"base.contributions.icons"};var u;(function(i){function t(s,d){let a=s.defaults;for(;R.ThemeIcon.isThemeIcon(a);){const w=c.getIcon(a.id);if(!w)return;a=w.defaults}return a}i.getDefinition=t})(u||(e.IconContribution=u={}));var k;(function(i){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(a=>({format:a.format,location:a.location.toString()}))}}i.toJSONObject=t;function s(d){const a=w=>(0,T.$eg)(w)?w:void 0;if(d&&Array.isArray(d.src)&&d.src.every(w=>(0,T.$eg)(w.format)&&(0,T.$eg)(w.location)))return{weight:a(d.weight),style:a(d.style),src:d.src.map(w=>({format:w.format,location:$.URI.parse(w.location)}))}}i.fromJSONObject=s})(k||(e.IconFontDefinition=k={}));class b{constructor(){this.a=new N.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,s,d,a){const w=this.b[t];if(w){if(d&&!w.description){w.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return w}const y={id:t,description:d,defaults:s,deprecationMessage:a};this.b[t]=y;const S={$ref:"#/definitions/icons"};return a&&(S.deprecationMessage=a),d&&(S.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=S,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const s=this.e.enum.indexOf(t);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,s){const d=this.f[t];return d||(this.f[t]=s,this.a.fire(),s)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,y)=>w.id.localeCompare(y.id),s=w=>{for(;R.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(w=>this.b[w]);for(const w of a.filter(y=>!!y.description).sort(t))d.push(`|<i class="${s(w)}"></i>|${w.id}|${R.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const w of a.filter(y=>!R.ThemeIcon.isThemeIcon(y.defaults)).sort(t))d.push(`|<i class="${s(w)}"></i>|${w.id}|`);return d.join(`
`)}}const c=new b;E.$oo.add(e.$sx.IconContribution,c);function g(i,t,s,d){return c.registerIcon(i,t,s,d)}function f(){return c}function m(){const i=(0,A.$Zj)();for(const t in i){const s="\\"+i[t].toString(16);c.registerIcon(t,{fontCharacter:s})}}m(),e.$vx="vscode://schemas/icons";const n=E.$oo.as(I.$po.JSONContribution);n.registerSchema(e.$vx,c.getIconSchema());const o=new r.$Qh(()=>n.notifySchemaChanged(e.$vx),200);c.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$wx=g("widget-close",h.$4j.close,(0,l.localize)(2,null)),e.$xx=g("goto-previous-location",h.$4j.arrowUp,(0,l.localize)(3,null)),e.$yx=g("goto-next-location",h.$4j.arrowDown,(0,l.localize)(4,null)),e.$zx=R.ThemeIcon.modify(h.$4j.sync,"spin"),e.$Ax=R.ThemeIcon.modify(h.$4j.loading,"spin")}),define(Ee[93],Se([1,0,4,3,11,2,45,5,12]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=E,e.$zw=k,e.$Aw=b,e.$Cw=c,e.$Ew=g,e.$Fw=f,e.$ww=(0,T.$Ei)("tunnelService"),e.$xw=(0,T.$Ei)("sharedTunnelsService");var l;(function(o){o.Http="http",o.Https="https"})(l||(e.TunnelProtocol=l={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(o){return!!o.forwardPort}var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(i)return{address:i[1],port:+i[2]}}function b(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const i=o.query.split("&");for(const t of i){const s=t.split("=")[1];if(/^https?:/.exec(s)){const d=k(R.URI.parse(s));if(d)return d}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function c(o){return e.$Bw.indexOf(o)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(o){return e.$Dw.indexOf(o)>=0}function f(o,i,t,s){if(t===A.OperatingSystem.Windows)return!1;if(t===A.OperatingSystem.Macintosh&&g(i)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(d?.length===4&&parseInt(d[1])>=18)return!1}return o<1024}class m{constructor(i,t,s){this.remoteAddress=i,this.localAddress=t,this.b=s,this.a=new r.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=m;let n=class extends h.$Vc{constructor(i,t){super(),this.r=i,this.s=t,this.a=new r.$le,this.onTunnelOpened=this.a.event,this.b=new r.$le,this.onTunnelClosed=this.b.event,this.c=new r.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],t=Array.from(this.f.values());for(const s of t){const d=Array.from(s.values());for(const a of d){const w=await a.value;w&&typeof w!="string"&&i.push(w)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:t}of i.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,t,s,d,a){this.z(i,t,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:t,localAddress:s,privacy:d,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,t){(g(i)||c(i))&&(i=e.$Bw[0]);const s=this.D(i,t);if(s)return++s.refcount,s.value}openTunnel(i,t,s,d,a,w=!1,y,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${a}.`);const D=this.g??i;if(!D)return;if(t||(t="localhost"),d||(d=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.F(D,t,s,d,a,w,y,S);return P?P.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(C);return(C.tunnelRemoteHost!==t||C.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&C.privacy!==y&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const t=this.f.get(i.tunnelRemoteHost);if(t){const s=t.get(i.tunnelRemotePort);s&&(s.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async y(i,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${t}.`);const d=s.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(t),d}}async closeTunnel(i,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${t} `);const s=this.f.get(i);if(s&&s.has(t)){const d=s.get(t);d.refcount=0,await this.y(i,t,d)}}z(i,t,s){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(t,{refcount:1,value:s})}async C(i,t){const s=this.f.get(i);if(s){const d=s.get(t),a=d?await d.value:void 0;(!a||typeof a=="string")&&s.delete(t),s.size===0&&this.f.delete(i)}}D(i,t){const s=[i];c(i)?(s.push(...e.$Bw),s.push(...e.$Dw)):g(i)&&s.push(...e.$Dw);const d=s.map(a=>this.f.get(a));for(const a of d){const w=a?.get(t);if(w)return w}}canTunnel(i){return!!k(i)}G(i,t,s,d,a,w,y){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${d}.`);const S=s;this.n.add(S);const D=d===void 0?s:d,P={elevationRequired:a?this.isPortPrivileged(D):!1},C={remoteAddress:{host:t,port:s},localAddressPort:d,privacy:w,public:w?w!==I.Private:void 0,protocol:y},p=i.forwardPort(C,P);return p?(this.z(t,s,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),p}};e.$Hw=n,e.$Hw=n=Qe([qe(0,$.$$j),qe(1,N.$$i)],n)}),define(Ee[294],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,r.$Ei)("IUriIdentityService")}),define(Ee[295],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Iw=void 0,e.$Iw=(0,r.$Ei)("editSessionIdentityService");var h;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Ee[296],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=h,e.$yM=A,e.$zM=R,e.$AM=N,e.$BM=T;function h($){return $.scheme!==r.Schemas.file&&$.scheme!==r.Schemas.vscodeRemote}function A($){if($.folders.length)return $.folders.every(l=>h(l.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function R($){return A($)?.scheme}function N($){return A($)?.authority}function T($){return A($)!==void 0}}),define(Ee[46],Se([1,0,232,16,85,23,2,5,15]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=l,e.$Pi=I,e.$Si=E,e.$Ti=u,e.$Ui=k,e.$Vi=c,e.$Wi=g,e.$Zi=n,e.$5i=o,e.$6i=i,e.$8i=t,e.$9i=s,e.$0i=d,e.$Ni=(0,T.$Ei)("contextService");function l(a){const w=a;return typeof w?.id=="string"&&N.URI.isUri(w.uri)}function I(a){return typeof a?.id=="string"&&!l(a)&&!u(a)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function E(a,w){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,h.$oc)(a)}:w?e.$Qi:e.$Ri;const y=a;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function u(a){const w=a;return typeof w?.id=="string"&&N.URI.isUri(w.configPath)}function k(a){const w=a;if(w?.uri)return{id:w.id,uri:N.URI.revive(w.uri)};const y=a;if(y?.configPath)return{id:y.id,configPath:N.URI.revive(y.configPath)};if(a?.id)return{id:a.id}}var b;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function c(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function g(a){const w=a;return!!(w&&typeof w=="object"&&N.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class f{constructor(w,y,S,D,P){this.h=w,this.j=S,this.k=D,this.l=P,this.c=A.$Ki.forUris(this.l,()=>!0),this.folders=y}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=A.$Ki.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=f;class m{constructor(w,y){this.raw=y,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,R.$fh)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=m;function n(a){return new m({uri:a,index:0,name:(0,R.$bh)(a)},{uri:a.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,r.localize)(0,null),extensions:[e.$1i]}],e.$4i="workspace.json";function o(a,w){return R.$9g.isEqualOrParent(a,w.untitledWorkspacesHome)}function i(a){let w;return N.URI.isUri(a)?w=a:w=a.configuration,w?.scheme===$.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.$7i}function s(a,w){return!o(a,w)&&!i(a)}function d(a){return(typeof a=="string"?(0,h.$pc)(a):(0,R.$dh)(a))===e.$2i}}),define(Ee[150],Se([1,0,60,4,3,23,2,231,144,28,5,12,46,29,294,9,32,13,18]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=o,e.$Ll=i,e.$Ml=t;var n;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&N.URI.isUri(w.location)&&N.URI.isUri(w.globalStorageHome)&&N.URI.isUri(w.settingsResource)&&N.URI.isUri(w.keybindingsResource)&&N.URI.isUri(w.tasksResource)&&N.URI.isUri(w.snippetsHome)&&N.URI.isUri(w.extensionsResource))}e.$Kl=(0,I.$Ei)("IUserDataProfilesService");function i(a,w){return{id:a.id,isDefault:a.isDefault,name:a.name,shortName:a.shortName,icon:a.icon,location:N.URI.revive(a.location).with({scheme:w}),globalStorageHome:N.URI.revive(a.globalStorageHome).with({scheme:w}),settingsResource:N.URI.revive(a.settingsResource).with({scheme:w}),keybindingsResource:N.URI.revive(a.keybindingsResource).with({scheme:w}),tasksResource:N.URI.revive(a.tasksResource).with({scheme:w}),snippetsHome:N.URI.revive(a.snippetsHome).with({scheme:w}),extensionsResource:N.URI.revive(a.extensionsResource).with({scheme:w}),cacheHome:N.URI.revive(a.cacheHome).with({scheme:w}),useDefaultFlags:a.useDefaultFlags,isTransient:a.isTransient}}function t(a,w,y,S,D,P){return{id:a,name:w,location:y,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:P&&D?.useDefaultFlags?.globalState?P.globalStorageHome:(0,R.$fh)(y,"globalStorage"),settingsResource:P&&D?.useDefaultFlags?.settings?P.settingsResource:(0,R.$fh)(y,"settings.json"),keybindingsResource:P&&D?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,R.$fh)(y,"keybindings.json"),tasksResource:P&&D?.useDefaultFlags?.tasks?P.tasksResource:(0,R.$fh)(y,"tasks.json"),snippetsHome:P&&D?.useDefaultFlags?.snippets?P.snippetsHome:(0,R.$fh)(y,"snippets"),extensionsResource:P&&D?.useDefaultFlags?.extensions?P.extensionsResource:(0,R.$fh)(y,"extensions.json"),cacheHome:(0,R.$fh)(S,a),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let s=class extends A.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,y,S,D){super(),this.t=w,this.u=y,this.w=S,this.y=D,this.f=!0,this.h=this.B(new h.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new k.$Bc,workspaces:new k.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),y=[w];if(this.f)try{for(const P of this.O()){if(!P.name||!(0,m.$eg)(P.name)||!P.location){this.y.warn("Skipping the invalid stored profile",P.location||P.name);continue}y.push(t((0,R.$ch)(P.location),P.name,P.location,this.g,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},w))}}catch(P){this.y.error(P)}const S=new k.$Bc,D=new Map;if(y.length)try{const P=this.Q();if(P.workspaces)for(const[C,p]of Object.entries(P.workspaces)){const v=N.URI.parse(C),O=y.find(L=>L.id===p);O&&S.set(v,O)}if(P.emptyWindows)for(const[C,p]of Object.entries(P.emptyWindows)){const v=y.find(O=>O.id===p);v&&D.set(C,v)}}catch(P){this.y.error(P)}this.z={profiles:y,workspaces:S,emptyWindows:D}}return this.z}D(){const w=t("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const y="Temp",S=new RegExp(`${(0,f.$hf)(y)}\\s(\\d+)`);let D=0;for(const C of this.profiles){const p=S.exec(C.name),v=p?parseInt(p[1]):0;D=v>D?v:D}const P=`${y} ${D+1}`;return this.createProfile((0,r.$sj)((0,g.$1g)()).toString(16),P,{transient:!0},w)}async createNamedProfile(w,y,S){return this.createProfile((0,r.$sj)((0,g.$1g)()).toString(16),w,y,S)}async createProfile(w,y,S,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=await this.F(w,y,S);return D&&await this.setProfileForWorkspace(D,P),P}async F(w,y,S){if(!(0,m.$eg)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(y);return D||(D=(async()=>{try{if(this.profiles.find(v=>v.name===y||v.id===w))throw new Error(`Profile with ${y} name already exists`);const C=t(w,y,(0,R.$fh)(this.profilesHome,w),this.g,S,this.defaultProfile);await this.u.createFolder(C.location);const p=[];return this.j.fire({profile:C,join(v){p.push(v)}}),await c.Promises.settled(p),this.I([C],[],[]),C}finally{this.r.delete(y)}})(),this.r.set(y,D)),D}async updateProfile(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(D=>D.id===w.id);if(!S)throw new Error(`Profile '${w.name}' does not exist`);return S=t(S.id,y.name??S.name,S.location,this.g,{shortName:y.shortName??S.shortName,icon:y.icon===null?void 0:y.icon??S.icon,transient:y.transient??S.isTransient,useDefaultFlags:y.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(D=>D.id===w.id);if(!y)throw new Error(`Profile '${w.name}' does not exist`);const S=[];this.m.fire({profile:y,join(D){S.push(D)}});try{await Promise.allSettled(S)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(D){(0,l.$pl)(D)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(D)}}async setProfileForWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(D=>D.id===y.id);if(!S)throw new Error(`Profile '${y.name}' does not exist`);this.L(w,S)}unsetWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,y)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(y=>y.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(w.map(y=>this.removeProfile(y)))}getProfileForWorkspace(w){const y=this.G(w),S=N.URI.isUri(y)?this.C.workspaces.get(y):this.C.emptyWindows.get(y);return S||((0,u.$Oi)(w)?this.s.folders.get(w.uri):(0,u.$Ti)(w)?this.s.workspaces.get(w.configPath):this.s.emptyWindows.get(w.id))}G(w){return(0,u.$Oi)(w)?w.uri:(0,u.$Ti)(w)?w.configPath:w.id}H(w){return!!([...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.folders.values()].some(y=>this.w.extUri.isEqual(y.location,w.location)))}I(w,y,S){const D=[...this.profiles,...w],P=[],C=this.s.profiles;this.s.profiles=[];for(let p of D){if(p.isDefault||y.some(O=>p.id===O.id))continue;p=S.find(O=>p.id===O.id)??p;const v=C.find(O=>p.id===O.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[O,L]of this.s.emptyWindows.entries())if(p.id===L.id){this.L({id:O},p);break}for(const[O,L]of this.s.workspaces.entries())if(p.id===L.id){this.L({id:"",configPath:O},p);break}for(const[O,L]of this.s.folders.entries())if(p.id===L.id){this.L({id:"",uri:O},p);break}}P.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(P),this.z=void 0,this.J(w,y,S)}J(w,y,S){this.h.fire({added:w,removed:y,updated:S,all:this.profiles})}L(w,y,S){if(S=y?.isTransient?!0:S,S)(0,u.$Oi)(w)?(this.s.folders.delete(w.uri),y&&this.s.folders.set(w.uri,y)):(0,u.$Ti)(w)?(this.s.workspaces.delete(w.configPath),y&&this.s.workspaces.set(w.configPath,y)):(this.s.emptyWindows.delete(w.id),y&&this.s.emptyWindows.set(w.id,y));else{this.L(w,void 0,!0);const D=this.G(w);N.URI.isUri(D)?(this.C.workspaces.delete(D),y&&this.C.workspaces.set(D,y)):(this.C.emptyWindows.delete(D),y&&this.C.emptyWindows.set(D,y)),this.M()}}M(){const w={};for(const[S,D]of this.C.workspaces.entries())w[S.toString()]=D.id;const y={};for(const[S,D]of this.C.emptyWindows.entries())y[S.toString()]=D.id;this.R({workspaces:w,emptyWindows:y}),this.z=void 0}N(w){const y={},S=this.D();if(w.workspaces)for(const[P,C]of Object.entries(w.workspaces)){const p=N.URI.parse(C);y[P]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}const D={};if(w.emptyWindows)for(const[P,C]of Object.entries(w.emptyWindows)){const p=N.URI.parse(C);D[P]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}return{workspaces:y,emptyWindows:D}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Nl=s,e.$Nl=s=Qe([qe(0,$.$Li),qe(1,l.$$k),qe(2,b.$Il),qe(3,E.$$j)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Ol=d}),define(Ee[151],Se([1,0,9,4,3,62,18,209,5,150]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=k,e.$eq=c,e.$gq=f,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,$.$Ei)("storageService");var I;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function k(m){const n=m.get(e.$aq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class b extends A.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:b.a}){super(),this.m=n,this.b=this.B(new h.$oe),this.c=this.B(new h.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$le),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,i){return h.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),i)}n(){this.j.value=(0,r.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:i,external:t}=o;if(i===e.$aq){switch(n){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,o,i){return this.P(o)?.get(n,i)}getBoolean(n,o,i){return this.P(o)?.getBoolean(n,i)}getNumber(n,o,i){return this.P(o)?.getNumber(n,i)}getObject(n,o,i){return this.P(o)?.getObject(n,i)}storeAll(n,o){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,o)})}store(n,o,i,t,s=!1){if((0,N.$ng)(o)){this.remove(n,i,s);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,o,s)})}remove(n,o,i=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const i=[],t=this.J(n);for(const s of Object.keys(t))t[s]===o&&i.push(s);return i}z(n,o,i,t=!1){const s=this.J(o);typeof i=="number"?s[n]!==i&&(s[n]=i,this.P(o)?.set(e.$aq,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$aq,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(n){switch(n){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?k(o):Object.create(null)}isNew(n){return this.getBoolean(e.$_p,n)===!0}async flush(n=I.NONE){this.f.fire({reason:n});const o=this.P(E.APPLICATION),i=this.P(E.PROFILE),t=this.P(E.WORKSPACE);switch(n){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,i=this.P(E.WORKSPACE)?.items??new Map;return f(n,o,i,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(I.NONE),(0,l.$Jl)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||c(o)&&c(n))}N(n,o,i){this.y(()=>{const t=new Set;for(const[s,d]of n)t.add(s),o.get(s)!==d&&this.u(i,{key:s,external:!0});for(const[s]of o.items)t.has(s)||this.u(i,{key:s,external:!0})})}}e.$dq=b;function c(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class g extends b{constructor(){super(),this.U=this.B(new T.$0p(new T.$$p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$0p(new T.$$p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$0p(new T.$$p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(E.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(E.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(E.APPLICATION,n)))}P(n){switch(n){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$fq=g;async function f(m,n,o,i,t,s){const d=v=>{try{return JSON.parse(v)}catch{return v}},a=new Map,w=new Map;m.forEach((v,O)=>{a.set(O,v),w.set(O,d(v))});const y=new Map,S=new Map;n.forEach((v,O)=>{y.set(O,v),S.set(O,d(v))});const D=new Map,P=new Map;o.forEach((v,O)=>{D.set(O,v),P.set(O,d(v))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const C=[];if(a.forEach((v,O)=>{C.push({key:O,value:v})}),console.table(C),console.groupEnd(),console.log(w),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const v=[];y.forEach((O,L)=>{v.push({key:L,value:O})}),console.table(v),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${s})`);const p=[];D.forEach((v,O)=>{p.push({key:O,value:v})}),console.table(p),console.groupEnd(),console.log(P)}}),define(Ee[119],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class r{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$$mc=r}),define(Ee[63],Se([1,0,15,23,28,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0;class N{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$7g($=>{const l=this.b.get($.scheme);return!(l===void 0||l&A.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,l){l===null?this.b.delete($.scheme):this.b.set($.scheme,l)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$dnc=N,e.$enc=(0,R.$Ei)("IExtHostFileSystemInfo")}),define(Ee[30],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=void 0,e.$KP=(0,r.$Ei)("IExtHostInitDataService")}),define(Ee[297],Se([1,0,237,12,278,30]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;let N=class extends A.$UQ{constructor($,l,I){const E=I.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(0,null):$?(0,r.localize)(1,null):(0,r.localize)(2,null);super(l.createLogger(E,{name:u}))}};e.$lpc=N,e.$lpc=N=Qe([qe(1,h.$_j),qe(2,R.$KP)],N)}),define(Ee[298],Se([1,0,9]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0;class h{constructor(N,T,$){this.h=new Map,this.a=N,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(l=>(this.f=l,this)),this.g=this.c.onDidChangeStorage(l=>{l.shared===this.b&&l.key===this.a&&(this.f=l.value)}),this.i=new r.$Qh(()=>{const l=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of l.values())I.complete()}catch(I){for(const E of l.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,N])=>N!==void 0).map(([N])=>N)}get whenReady(){return this.d}get(N,T){let $=this.f[N];return typeof $>"u"&&($=T),$}update(N,T){this.f[N]=T;const $=this.h.get(N);if($!==void 0)return $.p;const l=new r.$2h;return this.h.set(N,l),this.i.isScheduled()||this.i.schedule(),l.p}dispose(){this.g.dispose()}}e.$Vnc=h;class A extends h{setKeysForSync(N){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},N)}constructor(N,T){super(N.identifier.value,!0,T),this.j=N}}e.$Wnc=A}),define(Ee[299],Se([1,0,4,2]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=void 0;class A{constructor(N){this.c=N,this.a=new r.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(N,T,$,l){const E=this.c.getNotebookDocument(h.URI.revive(N)).acceptModelChanged(T.value,$,l);this.b.fire(E)}$acceptDirtyStateChanged(N,T){this.c.getNotebookDocument(h.URI.revive(N)).acceptDirty(T)}$acceptModelSaved(N){const T=this.c.getNotebookDocument(h.URI.revive(N));this.a.fire(T.apiNotebook)}}e.$Poc=A}),define(Ee[20],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0,e.$uP=(0,r.$Ei)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$vP=h}),define(Ee[300],Se([1,0,24,4]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class A{#e;constructor(N,T){this.b=new h.$le,this.onDidChange=this.b.event,this.a=r.$pn.toKey(N.identifier),this.#e=T,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(N){return this.#e.get(this.a,N)}store(N,T){return this.#e.store(this.a,N,T)}delete(N){return this.#e.delete(this.a,N)}}e.$6nc=A}),define(Ee[73],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0,e.$tnc=(0,r.$Ei)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=N=>N,this.transformOutgoing=N=>N,this.transformOutgoingURI=N=>N,this.transformOutgoingScheme=N=>N)}}e.$unc=h}),define(Ee[301],Se([1,0,302,412,413,67,2,12,414]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=I,r=We(r),h=We(h),A=We(A),R=We(R);const l=!1;function I(n,o,i,t,s,d){const a=d.environment.useHostProxy,w=typeof a=="boolean"?a:!d.remote.isRemote,y={resolveProxy:P=>n.resolveProxy(P),lookupProxyAuthorization:g.bind(void 0,t,s,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>u(o),addCertificatesV2:()=>k(o),log:t,getLogLevel:()=>{const P=t.getLevel();switch(P){case T.LogLevel.Trace:return $.LogLevel.Trace;case T.LogLevel.Debug:return $.LogLevel.Debug;case T.LogLevel.Info:return $.LogLevel.Info;case T.LogLevel.Warning:return $.LogLevel.Warning;case T.LogLevel.Error:return $.LogLevel.Error;case T.LogLevel.Off:return $.LogLevel.Off;default:return C(P)}function C(p){return t.error("Unknown log level",p),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:w,loadAdditionalCertificates:async()=>{const P=[];if(d.remote.isRemote&&P.push((0,$.loadSystemCertificates)({log:t})),w){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const C=n.loadCertificates();C.then(p=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),P.push(C)}return(await Promise.all(P)).flat()},env:process.env},S=(0,$.createProxyResolver)(y),D=E(y,S);return c(i,D)}function E(n,o){function i(t,s){return new Proxy(t,{get(d,a){return a in s?s[a]:d[a]}})}return{http:i(r,(0,$.createHttpPatch)(n,r,o)),https:i(h,(0,$.createHttpPatch)(n,h,o)),net:i(R,(0,$.createNetPatch)(n,R)),tls:i(A,(0,$.createTlsPatch)(n,A))}}function u(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}function k(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}const b=new Map;function c(n,o){return n.getExtensionPathIndex().then(i=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(a,w,y){if(a==="net")return o.net;if(a==="tls")return o.tls;if(a!=="http"&&a!=="https")return s.apply(this,arguments);const S=i.findSubstr(N.URI.file(w.filename));let D=b.get(S);if(D||b.set(S,D={}),!D[a]){const P=o[a];D[a]={...P}}return D[a]}})}async function g(n,o,i,t,s,d,a,w){const y=t[d];a&&(t[d]=a),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${a}`,`proxyAuthenticateCache:${y}`);const S=a||y,D=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(m(o,D,s),D.some(P=>/^(Negotiate|Kerberos)( |$)/i.test(P))&&!w.kerberosRequested)try{w.kerberosRequested=!0;const P=await new Promise((L,F)=>{ce(["kerberos"],L,F)}).then(We),C=new URL(d),p=i.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${C.hostname}`:`HTTP@${C.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${p}`),"Negotiate "+await(await P.initializeClient(p)).step("")}catch(P){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",P)}}let f=!1;function m(n,o,i){f||!o.length||(f=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:i?"remote":"local"}))}}),define(Ee[303],Se([1,0,142]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=A;function h(R){return{transformIncoming:N=>N.scheme==="vscode-remote"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="file"?{scheme:"vscode-local",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoing:N=>N.scheme==="file"?{scheme:"vscode-remote",authority:R,path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="vscode-local"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoingScheme:N=>N==="file"?"vscode-remote":N==="vscode-local"?"file":N}}function A(R){return new r.$In(h(R))}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[152],Se([1,0,247,18,2,3,5,37,28,15,55,201,44]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$aG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3F=e.EditorInputCapabilities=e.$2F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=void 0,e.$SF=c,e.$TF=g,e.$UF=f,e.$VF=m,e.$WF=n,e.$XF=o,e.$YF=i,e.$ZF=t,e.$1F=s,e.$4F=D,e.$5F=C,e.$6F=p,e.$7F=v,e.$8F=O,e.$9F=L,e.$0F=F,e.$$F=j,e.$_F=U,e.$bG=ee,e.$cG=ne,e.$dG=De,e.$eG=$e,u=zt(u),e.$NF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$OF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$PF="workbench.editor.sidebysideEditor",e.$QF="workbench.editors.textDiffEditor",e.$RF="workbench.editors.binaryResourceDiffEditor";var k;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var b;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function c(J){const W=J;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function g(J){const W=J;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function f(J,W,se){for(const oe of se.visibleEditorPanes)if(oe.group.id===W&&J.matches(oe.input))return oe.getViewState()}function m(J){if(D(J))return!1;const W=J;return A.URI.isUri(W?.resource)}function n(J){if(D(J))return!1;const W=J;return W?.original!==void 0&&W.modified!==void 0}function o(J){if(D(J))return!1;const W=J;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function i(J){if(D(J)||n(J))return!1;const W=J;return W?.primary!==void 0&&W.secondary!==void 0}function t(J){if(D(J))return!1;const W=J;return W?W.resource===void 0||W.resource.scheme===l.Schemas.untitled||W.forceUntitled===!0:!1}function s(J){if(D(J))return!1;const W=J;return A.URI.isUri(W?.base?.resource)&&A.URI.isUri(W?.input1?.resource)&&A.URI.isUri(W?.input2?.resource)&&A.URI.isUri(W?.result?.resource)}var d;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var a;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class w{constructor(){this.a=new Map}registerSource(W,se){let oe=this.a.get(W);return oe||(oe={source:W,label:se},this.a.set(W,oe)),oe.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$2F=new w;var y;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors",J[J.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class S extends R.$Vc{}e.$3F=S;function D(J){return J instanceof S}function P(J){const W=J;return A.URI.isUri(W?.preferredResource)}function C(J){const W=J;return D(W?.primary)&&D(W?.secondary)}function p(J){const W=J;return D(W?.modified)&&D(W?.original)}function v(J,W,se,oe,te){return $e(oe,[(0,E.$oj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};J.openEditor(W,le)}}),(0,E.$oj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function O(J){return D(J?.editor)}function L(J){const W=J;return O(J)&&W?.group!==void 0}function F(J){const W=J;return typeof W?.groupId=="number"&&D(W.editor)}function j(J){return typeof J?.groupId=="number"}var B;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var M;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LABEL=2]="GROUP_LABEL",J[J.GROUP_LOCKED=3]="GROUP_LOCKED",J[J.EDITORS_SELECTION=4]="EDITORS_SELECTION",J[J.EDITOR_OPEN=5]="EDITOR_OPEN",J[J.EDITOR_CLOSE=6]="EDITOR_CLOSE",J[J.EDITOR_MOVE=7]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=9]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=11]="EDITOR_PIN",J[J.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",J[J.EDITOR_STICKY=13]="EDITOR_STICKY",J[J.EDITOR_DIRTY=14]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var z;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class _{getOriginalUri(W,se){if(!W)return;if(s(W))return e.$aG.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===z.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===z.PRIMARY?te:le}}if(n(W)||o(W)||i(W)||s(W))return;const oe=P(W)?W.preferredResource:W.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}a(W){return C(W)||i(W)?{primary:W.primary,secondary:W.secondary}:p(W)||n(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(s(W))return e.$aG.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===z.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===z.PRIMARY?te:le}}if(n(W)||o(W)||i(W)||s(W))return;const oe=W.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}b(W,se){if(Array.isArray(se)){if(se.some(oe=>W.scheme===oe))return W}else if(se===W.scheme)return W}}var re;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.KEYBOARD=1]="KEYBOARD",J[J.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function U(J,W,se,oe){if(!J.isSticky(W))return!1;switch(oe.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.$aG=new _;var G;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class K{constructor(){this.c=new Map,this.d=new Map}start(W){const se=this.a=W.get(N.$Di);for(const[oe,te]of this.c)this.e(oe,te,se);this.c.clear()}e(W,se,oe){const te=oe.createInstance(se);this.d.set(W,te)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,h.$pg)(this.b)}registerEditorSerializer(W,se){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,se,this.a):this.c.set(W,se),(0,R.$Tc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}T.$oo.add(e.$NF.EditorFactory,new K);async function ee(J,W,se){return!J||!J.length?[]:await Promise.all(J.map(async oe=>{const te=A.URI.revive(oe.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",oe);return}if(!await W.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",oe);return}let he=oe.exists,Z=oe.type;if(typeof he!="boolean"||typeof Z!="number")try{Z=(await W.stat(te)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch(pe){se.error(pe),he=!1}if(!he&&oe.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",oe);return}if(Z===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",oe);return}const ae={...oe.options,pinned:!0};return he?{resource:te,options:ae}:{resource:te,options:ae,forceUntitled:!0}}))}var ue;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ne(J){const W=J;if(!W)return!1;const se=W;if(se.modified)return ne(se.modified);const oe=W;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}function De(J){return(0,I.$qj)(J)}function $e(J,W,se){const oe=(0,I.$rj)(J,W);return oe.forceMessage=se?.forceMessage,oe.forceSeverity=se?.forceSeverity,oe.allowDialog=se?.allowDialog,oe}}),define(Ee[304],Se([1,0,4,248,5,3,29,37,25,83,293]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mG=e.$lG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$kG=e.ViewContentGroups=e.$iG=e.ViewContainerLocation=e.Extensions=e.$hG=e.$gG=e.$fG=void 0,e.$jG=k,e.$fG="views",e.$gG=(0,h.localize)(0,null),e.$hG=(0,I.$tx)("default-view-icon",l.$4j.window,(0,h.localize)(1,null));var E;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var u;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$iG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function k(t){switch(t){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class b extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$le),this.onDidRegister=this.c.event,this.f=this.B(new r.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,d,a){const w=this.get(s.id);if(w)return w;const y=s;return y.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,N.$yc)(this.g,d,[]).push(y),a?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:d}),y}deregisterViewContainer(s){for(const d of this.g.keys()){const a=this.g.get(d),w=a?.indexOf(s);if(w!==-1){a?.splice(w,1),a.length===0&&this.g.delete(d),this.f.fire({viewContainer:s,viewContainerLocation:d});return}}}get(s){return this.all.filter(d=>d.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(d=>this.getViewContainerLocation(d)===s)}}T.$oo.add(E.ViewContainersRegistry,new b);var c;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(c||(e.ViewContentGroups=c={}));function g(t,s){const d=t.group??c.More,a=s.group??c.More;return d!==a?d.localeCompare(a):(t.order??5)-(s.order??5)}class f extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new N.$Ic}registerViews(s,d){this.registerViews2([{views:s,viewContainer:d}])}registerViews2(s){s.forEach(({views:d,viewContainer:a})=>this.r(d,a)),this.c.fire(s)}deregisterViews(s,d){const a=this.s(s,d);a.length&&this.f.fire({views:a,viewContainer:d})}moveViews(s,d){for(const a of this.m.keys())if(a!==d){const w=this.s(s,a);w.length&&(this.r(w,d),this.g.fire({views:w,from:a,to:d}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const d of this.j){const a=(this.m.get(d)||[]).filter(w=>w.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const d of this.j)if((this.m.get(d)||[]).filter(w=>w.id===s)[0])return d;return null}registerViewWelcomeContent(s,d){return this.n.add(s,d),this.h.fire(s),(0,R.$Tc)(()=>{this.n.delete(s,d),this.h.fire(s)})}registerViewWelcomeContent2(s,d){const a=new Map;for(const[w,y]of d)this.n.add(s,y),a.set(w,(0,R.$Tc)(()=>{this.n.delete(s,y),this.h.fire(s)}));return this.h.fire(s),a}getViewWelcomeContent(s){const d=[];return this.n.forEach(s,a=>d.push(a)),d.sort(g)}r(s,d){let a=this.m.get(d);a||(a=[],this.m.set(d,a),this.j.push(d));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,h.localize)(2,null,w.id));a.push(w)}}s(s,d){const a=this.m.get(d);if(!a)return[];const w=[],y=[];for(const S of a)s.includes(S)?w.push(S):y.push(S);return w.length&&(y.length?this.m.set(d,y):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),w}}T.$oo.add(E.ViewsRegistry,new f),e.$kG=(0,A.$Ei)("viewDescriptorService");var m;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(m||(e.ViewVisibilityState=m={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,d){this.c=!1,this.d=!1,(0,$.$eo)(this,s),this.d=!!d,this.resolve=async a=>{if(d&&!this.c){const w=await d(a);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$lG=o;class i extends Error{constructor(s){super((0,h.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$mG=i}),define(Ee[305],Se([1,0,249,36]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0,e.$qG=new h.$Vj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$rG=new h.$Vj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$sG=new h.$Vj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$tG=new h.$Vj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$uG=new h.$Vj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$vG=new h.$Vj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$wG=new h.$Vj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$xG=new h.$Vj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$yG=new h.$Vj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$zG=new h.$Vj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$AG=new h.$Vj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$BG=new h.$Vj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$CG=new h.$Vj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$DG=new h.$Vj("chatCursorAtTop",!1),e.$EG=new h.$Vj("chatInputHasAgent",!1),e.$FG=new h.$Vj("chatLocation",void 0),e.$GG=new h.$Vj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(Ee[306],Se([1,0,132,9,21,4,40,3,57,180,13,36,24,5,12,116,286,151,305]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.ChatAgentLocation=void 0,e.$LH=d,e.$MH=a;var o;(function(w){w.Panel="panel",w.Terminal="terminal",w.Notebook="notebook",w.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(w){function y(S){switch(S){case"panel":return w.Panel;case"terminal":return w.Terminal;case"notebook":return w.Notebook;case"editor":return w.Editor}return w.Panel}w.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.$GH=(0,k.$Ei)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(y){this.f=y,this.b=new Map,this.d=new R.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=m.$CG.bindTo(this.f)}registerAgent(y,S){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const P=this,C=S.slashCommands;S={...S,get slashCommands(){return C.filter(v=>!v.when||P.f.contextMatchesRules(E.$Cj.deserialize(v.when)))}};const p={data:S};return this.b.set(y,p),(0,T.$Tc)(()=>{this.b.delete(y),this.d.fire(void 0)})}registerAgentImplementation(y,S){const D=this.b.get(y);if(!D)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(D.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return D.data.isDefault&&this.e.set(!0),D.impl=S,this.d.fire(new t(D.data,S)),(0,T.$Tc)(()=>{D.impl=void 0,this.d.fire(void 0),D.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,S){y.isDynamic=!0;const D={data:y,impl:S};return this.b.set(y.id,D),this.d.fire(new t(y,S)),(0,T.$Tc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,S){return this.g.set(y,S),{dispose:()=>{this.g.delete(y)}}}async getAgentCompletionItems(y,S,D){return await this.g.get(y)?.(S,D)??[]}updateAgent(y,S){const D=this.b.get(y);if(!D?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);D.data.metadata={...D.data.metadata,...S},this.d.fire(new t(D.data,D.impl))}getDefaultAgent(y){return(0,r.$gb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(y))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.h(y))return this.b.get(y)?.data}h(y){const S=this.b.get(y);return!S?.data.when||this.f.contextMatchesRules(E.$Cj.deserialize(S.data.when))}getAgentByFullyQualifiedId(y){const S=N.Iterable.find(this.b.values(),D=>d(D.data)===y)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.h(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.h(y.data.id)).map(y=>new t(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(S=>S.name===y)}agentHasDupeName(y){const S=this.getAgent(y);return S?this.getAgentsByName(S.name).filter(D=>D.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(y,S,D,P,C){const p=this.b.get(y);if(!p?.impl)throw new Error(`No activated agent with id "${y}"`);return await p.impl.invoke(S,D,P,C)}async getFollowups(y,S,D,P,C){const p=this.b.get(y);if(!p?.impl)throw new Error(`No activated agent with id "${y}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(S,D,P,C):[]}};e.$HH=i,e.$HH=i=Qe([qe(0,E.$Wj)],i);class t{constructor(y,S){this.b=y,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,S,D,P){return this.d.invoke(y,S,D,P)}async provideFollowups(y,S,D,P){return this.d.provideFollowups?this.d.provideFollowups(y,S,D,P):[]}provideWelcomeMessage(y,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,S)}provideSampleQuestions(y,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,S)}}e.$IH=t,e.$JH=(0,k.$Ei)("chatAgentNameService");let s=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(y,S,D,P){if(this.g=S,this.h=D,this.i=P,this.e=(0,l.$6d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const C=P.get(n.b,f.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{P.remove(n.b,f.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,h.$Fh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,g.$7p)(y);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const D=S.restrictedChatParticipants;this.e.set(D,void 0),this.i.store(n.b,JSON.stringify(D),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getAgentNameRestriction(y){const S=this.l(y.name,y).get(),D=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return S&&D}l(y,S){return this.e.map(P=>P[y.toLowerCase()]).map(P=>P?P.some(C=>(0,I.$Ff)(C,C.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$KH=s,e.$KH=s=n=Qe([qe(0,c.$rk),qe(1,g.$1p),qe(2,b.$$j),qe(3,f.$bq)],s);function d(w){return`${w.extensionId.value}.${w.id}`}function a(w){const y="name"in w?w:{...w,name:w.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new u.$pn("")),(0,$.$bi)(y)}}),define(Ee[307],Se([1,0,2,31,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$cH=R,e.$dH=N;function R(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof r.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(h.$Ht.isIRange)}function N(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(R)}var T;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$eH=(0,A.$Ei)("IChatService"),e.$fH="accessibility.voice.keywordActivation"}),define(Ee[153],Se([1,0,4,9,251]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$le,this.o=new r.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,l,I){const E={command:T};if($&&Object.keys($).length>0&&(E.arguments=$),this.u("request",E),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const k=this.f.get(E.seq);if(k){this.f.delete(E.seq);const b={type:"response",seq:0,request_seq:E.seq,success:!1,command:T,message:(0,A.localize)(0,null,I,T)};k(b)}},I)}return l&&this.f.set(E.seq,l),E.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,h.$Fh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,l=this.f.get($.request_seq);l&&(this.f.delete($.request_seq),l($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,l)=>T.set(l,$)),await(0,h.$Fh)(500),T.forEach(($,l)=>{$({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.f.delete(l)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Usb=R}),define(Ee[120],Se([1,0,2,252,36,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$wK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$uK=e.MemoryRangeType=e.State=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0,e.$tK=$,e.$vK=I,h=We(h),e.$hJ="workbench.view.debug",e.$iJ="workbench.debug.variablesView",e.$jJ="workbench.debug.watchExpressionsView",e.$kJ="workbench.debug.callStackView",e.$lJ="workbench.debug.loadedScriptsView",e.$mJ="workbench.debug.breakPointsView",e.$nJ="workbench.debug.disassemblyView",e.$oJ="workbench.panel.repl",e.$pJ="workbench.panel.repl.view",e.$qJ=new A.$Vj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$rJ=new A.$Vj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$sJ=new A.$Vj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$tJ="debugUx",e.$uJ=new A.$Vj(e.$tJ,"default",{type:"string",description:h.localize(3,null)}),e.$vJ=new A.$Vj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$wJ=new A.$Vj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$xJ=new A.$Vj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$yJ=new A.$Vj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$zJ=new A.$Vj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$AJ=new A.$Vj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$BJ=new A.$Vj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$CJ=new A.$Vj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$DJ=new A.$Vj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$EJ=new A.$Vj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$FJ=new A.$Vj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$GJ=new A.$Vj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$HJ=new A.$Vj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$IJ=new A.$Vj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$JJ=new A.$Vj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$KJ=new A.$Vj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$LJ=new A.$Vj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$MJ=new A.$Vj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$NJ=new A.$Vj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$OJ=new A.$Vj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$PJ=new A.$Vj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$QJ=new A.$Vj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$RJ=new A.$Vj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$SJ=new A.$Vj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$TJ=new A.$Vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$UJ=new A.$Vj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$VJ=new A.$Vj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$WJ=new A.$Vj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$XJ=new A.$Vj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$YJ=new A.$Vj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$ZJ=new A.$Vj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$1J=new A.$Vj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$2J=new A.$Vj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$3J=new A.$Vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$4J=new A.$Vj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$5J=new A.$Vj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$6J=new A.$Vj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$7J=new A.$Vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$8J=new A.$Vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$9J=new A.$Vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$0J=new A.$Vj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$$J=new A.$Vj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$_J=new A.$Vj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$aK=new A.$Vj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$bK=new A.$Vj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$cK=new A.$Vj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$dK=new A.$Vj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$eK=new A.$Vj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$fK=new A.$Vj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$gK=new A.$Vj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$hK=new A.$Vj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$iK=new A.$Vj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$jK=new A.$Vj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$kK=new A.$Vj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$lK=new A.$Vj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$mK=new A.$Vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$nK=new A.$Vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const N=n=>h.localize(61,null,n);e.$oK=N,e.$pK="editor.contrib.debug",e.$qK="editor.contrib.breakpoint",e.$rK="debug",e.$sK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var T;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(T||(e.State=T={}));function $(n){switch(n){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var l;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.$uK="vscode-debug-memory";function I(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var E;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var u;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var k;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$wK=(0,R.$Ei)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var c;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var f;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(f||(e.IDebugVisualizationTreeItem=f={}));var m;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(m||(e.IDebugVisualization=m={}))}),define(Ee[308],Se([1,0,13,2,16,25,15,31,21,19]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2H=void 0,e.$PH=E,e.$QH=u,e.$RH=k,e.$SH=b,e.$TH=c,e.$UH=g,e.$VH=f,e.$WH=n,e.$XH=t,e.$YH=s,e.$ZH=a,e.$1H=y;const I=/{([^}]+)}/g;function E(D,P,C){return D.replace(I,function(p,v){return P&&v.length>0&&v[0]!=="_"?p:C&&C.hasOwnProperty(v)?C[v]:p})}function u(D){const P={};for(const C of Object.keys(D))C.startsWith("!")||(P[C]=D[C]);return P}function k(D){return D.configuration.request==="attach"&&!b(D)&&(!D.parentSession||k(D.parentSession))}function b(D){let P=D.configuration.type;if(P)return P==="vslsShare"&&(P=D.configuration.adapterProxy.configuration.type),(0,r.$Ff)(P,"extensionhost")||(0,r.$Ff)(P,"pwa-extensionhost")?D:D.parentSession?b(D.parentSession):void 0}function c(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,P,C){let p,v=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=O.exec(D);){const F=L.index+1,j=F+L[0].length;if(F<=P&&j>=C){p=L[0],v=F;break}}if(p){const F=/\w+/g;let j=null;for(;(j=F.exec(p))&&!(j.index+1+v+j[0].length>=C););j&&(p=p.substring(0,F.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function f(D,P,C,p){if(D.evaluatableExpressionProvider.has(P)){const v=D.evaluatableExpressionProvider.ordered(P),O=(0,l.$Ib)(await Promise.all(v.map(async L=>{try{return await L.provideEvaluatableExpression(P,C,p??$.CancellationToken.None)}catch{return}})));if(O.length>0){let L=O[0].expression;const F=O[0].range;return L||(L=P.getLineContent(C.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:L}}}else{const v=P.getLineContent(C.lineNumber),{start:O,end:L}=g(v,C.column,C.column),F=v.substring(O-1,L);return{matchingExpression:F,range:new T.$Ht(C.lineNumber,O,C.lineNumber,O+F.length)}}return null}const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(m))}function o(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return h.URI.parse(D.path);if((0,A.$jc)(D.path))return h.URI.file(D.path)}return D.path}function i(D){if(typeof D.path=="object"){const P=h.URI.revive(D.path);if(P)return P.scheme===N.Schemas.file?P.fsPath:P.toString()}return D.path}function t(D,P){const C=P?o:i,p=(0,R.$bo)(D);return d(p,(v,O)=>{v&&O&&(O.path=C(O))}),p}function s(D,P){const C=P?o:i,p=(0,R.$bo)(D);return d(p,(v,O)=>{!v&&O&&(O.path=C(O))}),p}function d(D,P){switch(D.type){case"event":{const C=D;switch(C.event){case"output":P(!1,C.body.source);break;case"loadedSource":P(!1,C.body.source);break;case"breakpoint":P(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=D;switch(C.command){case"setBreakpoints":P(!0,C.arguments.source);break;case"breakpointLocations":P(!0,C.arguments.source);break;case"source":P(!0,C.arguments.source);break;case"gotoTargets":P(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(p=>P(!1,p));break;default:break}break}case"response":{const C=D;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(p=>P(!1,p.source));break;case"loadedSources":C.body.sources.forEach(p=>P(!1,p));break;case"scopes":C.body.scopes.forEach(p=>P(!1,p.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(p=>P(!1,p.source));break;case"setBreakpoints":C.body.breakpoints.forEach(p=>P(!1,p.source));break;case"disassemble":C.body?.instructions.forEach(v=>P(!1,v.location));break;default:break}break}}}function a(D){return D.filter(P=>!P.presentation?.hidden).sort((P,C)=>P.presentation?C.presentation?P.presentation.group?C.presentation.group?P.presentation.group!==C.presentation.group?P.presentation.group.localeCompare(C.presentation.group):w(P.presentation.order,C.presentation.order):-1:C.presentation.group?1:w(P.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function w(D,P){return typeof D!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:D-P}async function y(D,P){const C=D.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(C!=="none"&&(await P.saveAll(),C==="allEditorsInActiveGroup")){const p=P.activeEditorPane;p&&p.input.resource?.scheme===N.Schemas.untitled&&await P.save({editor:p.input,groupId:p.group.id})}await D.reloadConfiguration()}const S=(D,P)=>!D||!P?D===P:D.name===P.name&&D.path===P.path&&D.sourceReference===P.sourceReference;e.$2H=S}),define(Ee[309],Se([1,0,58,67,25,16,11,13,34,253,153]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=e.$upc=e.$tpc=e.$spc=e.$rpc=void 0,r=We(r),h=We(h),A=We(A),R=We(R),N=We(N),T=We(T),l=We(l);class E extends I.$Usb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(f,m){this.l=m,this.p=Buffer.allocUnsafe(0),this.r=-1,f.on("data",n=>this.v(n))}sendMessage(f){if(this.l){const m=JSON.stringify(f);this.l.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${E.a}${m}`,"utf8")}}v(f){for(this.p=Buffer.concat([this.p,f]);;){if(this.r>=0){if(this.p.length>=this.r){const m=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(n){this.n.fire(new Error((n.message||n)+`
`+m))}continue}}else{const m=this.p.indexOf(E.a);if(m!==-1){const o=this.p.toString("utf8",0,m).split(E.b);for(const i of o){const t=i.split(E.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(m+E.a.length);continue}}break}}}e.$rpc=E;class u extends E{startSession(){return new Promise((f,m)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),f(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):m(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$spc=u;class k extends u{constructor(f){super(),this.z=f}y(f){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.$tpc=k;class b extends u{constructor(f){super(),this.z=f}y(f){return h.createConnection(this.z.path,f)}}e.$upc=b;class c extends E{constructor(f,m){super(),this.y=f,this.z=m}async startSession(){const f=this.y.command,m=this.y.args,n=this.y.options||{};try{if(f)if(R.$jc(f)){if(!await $.Promises.exists(f))throw new Error(l.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(l.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=A.$eo(A.$bo(process.env),n.env)),f==="node")if(Array.isArray(m)&&m.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=r.fork(m[0],m.slice(1),t);if(!s.pid)throw new Error(l.localize(2,null,m[0]));this.x=s}else throw new Error(l.localize(3,null));else{const i={env:o};n.cwd&&(i.cwd=n.cwd),this.x=r.spawn(f,m,i)}this.x.on("error",i=>{this.n.fire(i)}),this.x.on("exit",(i,t)=>{this.o.fire(i)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",i=>{this.n.fire(i)}),this.x.stdin.on("error",i=>{this.n.fire(i)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),N.$i?new Promise((f,m)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,i,t){if(o)return m(o)});n.on("exit",f),n.on("error",m)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,m){if(!f)return;const n=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?n.runtime=R.$kc(m,f.runtime):n.runtime=f.runtime),f.runtimeArgs&&(n.runtimeArgs=f.runtimeArgs),f.program&&(R.$jc(f.program)?n.program=f.program:n.program=R.$kc(m,f.program)),f.args&&(n.args=f.args);const o=f;return o.win&&(n.win=c.A(o.win,m)),o.winx86&&(n.winx86=c.A(o.winx86,m)),o.windows&&(n.windows=c.A(o.windows,m)),o.osx&&(n.osx=c.A(o.osx,m)),o.linux&&(n.linux=c.A(o.linux,m)),n}static platformAdapterExecutable(f,m){let n=Object.create(null);m=m.toLowerCase();for(const a of f)if(a.contributes){const w=a.contributes.debuggers;w&&w.length>0&&w.filter(y=>typeof y.type=="string"&&T.$Ff(y.type,m)).forEach(y=>{const S=c.A(y,a.extensionLocation.fsPath);n=A.$eo(n,S,a.isBuiltin)})}let o;N.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:N.$i?o=n.win||n.windows:N.$j?o=n.osx:N.$k&&(o=n.linux),o=o||n;const i=o.program||n.program,t=o.args||n.args,s=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof i=="string"?[i]:[]).concat(t||[])};if(i)return{type:"executable",command:i,args:t||[]}}}e.$vpc=c}),define(Ee[310],Se([1,0,58,33,11]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=N,e.$xpc=$,r=We(r),A=We(A);function R(l,I){return new Promise((E,u)=>{let k="";const b=r.spawn(l,I);b.pid&&b.stdout.on("data",c=>{k+=c.toString()}),b.on("error",c=>{u(c)}),b.on("close",c=>{E(k)})})}async function N(l){if(l)if(A.$i){const I=await new Promise((E,u)=>{ce(["@vscode/windows-process-tree"],E,u)}).then(We);return new Promise(E=>{I.getProcessTree(l,u=>{E(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(l)]).then(I=>{const E=I.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var T;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(T||(T={}));function $(l,I,E,u,k){l=l.trim().toLowerCase();let b;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?b=T.powershell:l.indexOf("cmd.exe")>=0?b=T.cmd:l.indexOf("bash")>=0?b=T.bash:A.$i?b=T.cmd:b=T.bash;let c,g=" ";switch(b){case T.powershell:if(c=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),u){const f=(0,h.$Jg)(u);f&&(g+=`${f}:; `),g+=`cd ${c(u)}; `}if(k)for(const f in k){const m=k[f];m===null?g+=`Remove-Item env:${f}; `:g+=`\${env:${f}}='${m}'; `}if(I.length>0){const f=I.shift(),m=E?f:c(f);g+=m[0]==="'"?`& ${m} `:`${m} `;for(const n of I)g+=n==="<"||n===">"||E?n:c(n),g+=" "}break;case T.cmd:if(c=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>f.includes(m))||f.length===0?`"${f}"`:f),u){const f=(0,h.$Jg)(u);f&&(g+=`${f}: && `),g+=`cd ${c(u)} && `}if(k){g+='cmd /C "';for(const f in k){let m=k[f];m===null?g+=`set "${f}=" && `:(m=m.replace(/[&^|<>]/g,n=>`^${n}`),g+=`set "${f}=${m}" && `)}}for(const f of I)g+=f==="<"||f===">"||E?f:c(f),g+=" ";k&&(g+='"');break;case T.bash:{c=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m);const f=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(u&&(g+=`cd ${c(u)} ; `),k){g+="/usr/bin/env";for(const m in k){const n=k[m];n===null?g+=` -u ${f(m)}`:g+=` ${f(`${m}=${n}`)}`}g+=" "}for(const m of I)g+=m==="<"||m===">"||E?m:c(m),g+=" ";break}}return g}}),define(Ee[311],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.CellExecutionUpdateType=void 0;var h;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$OK=(0,r.$Ei)("INotebookExecutionService")}),define(Ee[312],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jb=e.$9jb=e.ProxyKernelState=e.$8jb=void 0,e.$8jb=100;var h;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$9jb=(0,r.$Ei)("INotebookKernelService"),e.$0jb=(0,r.$Ei)("INotebookKernelHistoryService")}),define(Ee[313],Se([1,0,3,31,54,214,107]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wYb=void 0;class T extends r.$Vc{constructor(l,I,E){super(),this._source=l,this.b=I,this.c=E,this.a=void 0}f(l){const I=l.getLineCount();return new h.$Ht(1,1,I,this.g(l,I))}g(l,I){if(I<1||I>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const l=new R.$iD;l.acceptChunk(this._source);const I=l.finish(!0),{textBuffer:E,disposable:u}=I.create(A.DefaultEndOfLine.LF);this.b=E,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(l=>{const I=new R.$iD;I.acceptChunk(l);const E=I.finish(!0),{textBuffer:u,disposable:k}=E.create(A.DefaultEndOfLine.LF);return this.B(k),u})),this.a}findInInputs(l){const E=new N.$9C(l,!1,!1,null).parseSearchRequest();if(!E)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,E,!0,5e3)}findInOutputs(l){const E=new N.$9C(l,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(u=>{const k=u.findMatchesLineByLine(this.f(u),E,!0,5e3);if(k.length!==0)return{textBuffer:u,matches:k}}).filter(u=>!!u):[]}}e.$wYb=T}),define(Ee[74],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class A{static fromExtHostTestItem(N,T,$=N.parent){if(N._isRoot)return new A([T]);const l=[N.id];for(let I=$;I&&I.id!==T;I=I.parent)l.push(I.id);return l.push(T),new A(l.reverse())}static isRoot(N){return!N.includes(r.Delimiter)}static root(N){const T=N.indexOf(r.Delimiter);return T===-1?N:N.slice(0,T)}static fromString(N){return new A(N.split(r.Delimiter))}static join(N,T){return new A([...N.path,T])}static joinToString(N,T){return N.toString()+r.Delimiter+T}static parentId(N){const T=N.lastIndexOf(r.Delimiter);return T===-1?void 0:N.slice(0,T)}static localId(N){const T=N.lastIndexOf(r.Delimiter);return T===-1?N:N.slice(T+r.Delimiter.length)}static isChild(N,T){return T.startsWith(N)&&T[N.length]===r.Delimiter}static compare(N,T){return N===T?h.IsSame:A.isChild(N,T)?h.IsChild:A.isChild(T,N)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(N,T){if(N===0)return 0;let $=0;for(;$<N-1;){for(let l=1;l<N;l++){const I=T(l-1),E=T(l);if(I.path[$]!==E.path[$])return $}$++}return $}constructor(N,T=N.length){if(this.path=N,this.d=T,N.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let N=1;N<=this.d;N++)yield new A(this.path,N)}*idsToRoot(){for(let N=this.d;N>0;N--)yield new A(this.path,N)}compare(N){if(typeof N=="string")return A.compare(this.toString(),N);for(let T=0;T<N.d&&T<this.d;T++)if(N.path[T]!==this.path[T])return h.Disconnected;return N.d>this.d?h.IsChild:N.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let N=1;N<this.d;N++)this.c+=r.Delimiter,this.c+=this.path[N]}return this.c}}e.$OI=A}),define(Ee[75],Se([1,0,2,53,31,74]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$WI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$VI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$UI=e.$TI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$SI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$RI=e.$QI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$PI=e.TestResultState=void 0;var N;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(N||(e.TestResultState=N={})),e.$PI={[N.Unset]:"unset",[N.Queued]:"queued",[N.Running]:"running",[N.Passed]:"passed",[N.Failed]:"failed",[N.Skipped]:"skipped",[N.Errored]:"errored"};var T;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(B){B[B.Run=2]="Run",B[B.Debug=4]="Debug",B[B.Coverage=8]="Coverage",B[B.HasNonDefaultProfile=16]="HasNonDefaultProfile",B[B.HasConfigurable=32]="HasConfigurable",B[B.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$QI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const l=B=>"runId"in B;e.$RI=l;var I;(function(B){B.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),B.deserialize=(M,z)=>({range:A.$Ht.lift(z.range),uri:M.asCanonicalUri(r.URI.revive(z.uri))})})(I||(e.IRichLocation=I={}));var E;(function(B){B[B.Error=0]="Error",B[B.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(B){B.serialize=M=>({message:M.message,type:E.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&I.serialize(M.location)}),B.deserialize=(M,z)=>({message:z.message,type:E.Error,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&I.deserialize(M,z.location)})})(u||(e.ITestErrorMessage=u={}));const k=(B,M)=>`${M?"s":"e"}${B}`;e.$SI=k;var b;(function(B){B.serialize=M=>({message:M.message,type:E.Output,offset:M.offset,length:M.length,location:M.location&&I.serialize(M.location)}),B.deserialize=(M,z)=>({message:z.message,type:E.Output,offset:z.offset,length:z.length,location:z.location&&I.deserialize(M,z.location)})})(b||(e.ITestOutputMessage=b={}));var c;(function(B){B.serialize=M=>M.type===E.Error?u.serialize(M):b.serialize(M),B.deserialize=(M,z)=>z.type===E.Error?u.deserialize(M,z):b.deserialize(M,z)})(c||(e.ITestMessage=c={}));var g;(function(B){B.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),B.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(c.serialize)}),B.deserialize=(M,z)=>({state:z.state,duration:z.duration,messages:z.messages.map(_=>c.deserialize(M,_))})})(g||(e.ITestTaskState=g={}));const f="\0",m=(B,M)=>B+f+M;e.$TI=m;const n=B=>{const M=B.indexOf(f);return{ctrlId:B.slice(0,M),tagId:B.slice(M+1)}};e.$UI=n;var o;(function(B){B.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),B.deserialize=(M,z)=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?M.asCanonicalUri(r.URI.revive(z.uri)):void 0,range:z.range?A.$Ht.lift(z.range):null,description:z.description,error:z.error,sortText:z.sortText})})(o||(e.ITestItem=o={}));var i;(function(B){B[B.NotExpandable=0]="NotExpandable",B[B.Expandable=1]="Expandable",B[B.BusyExpanding=2]="BusyExpanding",B[B.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(B){B.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),B.deserialize=(M,z)=>({controllerId:R.$OI.root(z.item.extId),expand:z.expand,item:o.deserialize(M,z.item)})})(t||(e.InternalTestItem=t={}));var s;(function(B){B.serialize=M=>{let z;return M.item&&(z={},M.item.label!==void 0&&(z.label=M.item.label),M.item.tags!==void 0&&(z.tags=M.item.tags),M.item.busy!==void 0&&(z.busy=M.item.busy),M.item.uri!==void 0&&(z.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(z.range=M.item.range?.toJSON()),M.item.description!==void 0&&(z.description=M.item.description),M.item.error!==void 0&&(z.error=M.item.error),M.item.sortText!==void 0&&(z.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:z}},B.deserialize=M=>{let z;return M.item&&(z={},M.item.label!==void 0&&(z.label=M.item.label),M.item.tags!==void 0&&(z.tags=M.item.tags),M.item.busy!==void 0&&(z.busy=M.item.busy),M.item.range!==void 0&&(z.range=M.item.range?A.$Ht.lift(M.item.range):null),M.item.description!==void 0&&(z.description=M.item.description),M.item.error!==void 0&&(z.error=M.item.error),M.item.sortText!==void 0&&(z.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:z}}})(s||(e.ITestItemUpdate=s={}));const d=(B,M)=>{M.expand!==void 0&&(B.expand=M.expand),M.item!==void 0&&(B.item=B.item?Object.assign(B.item,M.item):M.item)};e.$VI=d;var a;(function(B){B.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(g.serializeWithoutMessages)}),B.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(g.serialize)}),B.deserialize=(M,z)=>({...t.deserialize(M,z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(_=>g.deserialize(M,_)),retired:!0})})(a||(e.TestResultItem=a={}));var w;(function(B){B.empty=()=>({covered:0,total:0}),B.sum=(M,z)=>{M.covered+=z.covered,M.total+=z.total}})(w||(e.ICoverageCount=w={}));var y;(function(B){B.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testId:M.testId?.toString(),uri:M.uri.toJSON()}),B.deserialize=(M,z)=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testId:z.testId?R.$OI.fromString(z.testId):void 0,uri:M.asCanonicalUri(r.URI.revive(z.uri))}),B.empty=(M,z)=>({id:M,uri:z,testId:void 0,statement:w.empty()})})(y||(e.IFileCoverage=y={}));function S(B){return{...B,location:B.location?.toJSON()}}function D(B){return B.location=B.location?h.$Gt.isIPosition(B.location)?h.$Gt.lift(B.location):A.$Ht.lift(B.location):void 0,B}e.$WI=3;var P;(function(B){B[B.Declaration=0]="Declaration",B[B.Statement=1]="Statement",B[B.Branch=2]="Branch"})(P||(e.DetailType=P={}));var C;(function(B){B.serialize=M=>M.type===P.Declaration?v.serialize(M):O.serialize(M),B.deserialize=M=>M.type===P.Declaration?v.deserialize(M):O.deserialize(M)})(C||(e.CoverageDetails=C={}));var p;(function(B){B.serialize=S,B.deserialize=D})(p||(e.IBranchCoverage=p={}));var v;(function(B){B.serialize=S,B.deserialize=D})(v||(e.IDeclarationCoverage=v={}));var O;(function(B){B.serialize=M=>({...S(M),branches:M.branches?.map(p.serialize)}),B.deserialize=M=>({...D(M),branches:M.branches?.map(p.deserialize)})})(O||(e.IStatementCoverage=O={}));var L;(function(B){B[B.Add=0]="Add",B[B.Update=1]="Update",B[B.DocumentSynced=2]="DocumentSynced",B[B.Remove=3]="Remove",B[B.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",B[B.Retire=5]="Retire",B[B.AddTag=6]="AddTag",B[B.RemoveTag=7]="RemoveTag"})(L||(e.TestDiffOpType=L={}));var F;(function(B){B.deserialize=(M,z)=>z.op===L.Add?{op:z.op,item:t.deserialize(M,z.item)}:z.op===L.Update?{op:z.op,item:s.deserialize(z.item)}:z.op===L.DocumentSynced?{op:z.op,uri:M.asCanonicalUri(r.URI.revive(z.uri)),docv:z.docv}:z,B.serialize=M=>M.op===L.Add?{op:M.op,item:t.serialize(M.item)}:M.op===L.Update?{op:M.op,item:s.serialize(M.item)}:M})(F||(e.TestsDiffOp=F={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const z=this.w();for(const _ of M)switch(_.op){case L.Add:this.l(t.deserialize(this.k,_.item),z);break;case L.Update:this.p(s.deserialize(_.item),z);break;case L.Remove:this.q(_.itemId,z);break;case L.Retire:this.v(_.itemId);break;case L.IncrementPendingExtHosts:this.updatePendingRoots(_.amount);break;case L.AddTag:this.c.set(_.tag.id,_.tag);break;case L.RemoveTag:this.c.delete(_.id);break}z.complete?.()}l(M,z){const _=R.$OI.parentId(M.item.extId)?.toString();let re;if(!_)re=this.x(M),this.g.add(re),this.f.set(M.item.extId,re);else if(this.f.has(_)){const U=this.f.get(_);U.children.add(M.item.extId),re=this.x(M,U),this.f.set(M.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return z.add?.(re),M.expand===i.BusyExpanding&&this.h++,re}p(M,z){const _=this.f.get(M.extId);if(_)return M.expand!==void 0&&(_.expand===i.BusyExpanding&&this.h--,M.expand===i.BusyExpanding&&this.h++),(0,e.$VI)(_,M),z.update?.(_),_}q(M,z){const _=this.f.get(M);if(!_)return;const re=R.$OI.parentId(_.item.extId)?.toString();re?this.f.get(re).children.delete(_.item.extId):this.g.delete(_);const U=[[M]];for(;U.length;)for(const G of U.pop()){const K=this.f.get(G);K&&(U.push(K.children),this.f.delete(G),z.remove?.(K,K!==_),K.expand===i.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$XI=j}),define(Ee[314],Se([1,0,136,256,75]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$uFb=e.$tFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var N;(function(E){E.List="list",E.Tree="true"})(N||(e.TestExplorerViewMode=N={}));var T;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[A.TestResultState.Errored]:(0,h.localize)(0,null),[A.TestResultState.Failed]:(0,h.localize)(1,null),[A.TestResultState.Passed]:(0,h.localize)(2,null),[A.TestResultState.Queued]:(0,h.localize)(3,null),[A.TestResultState.Running]:(0,h.localize)(4,null),[A.TestResultState.Skipped]:(0,h.localize)(5,null),[A.TestResultState.Unset]:(0,h.localize)(6,null)},l=(E,u)=>(0,h.localize)(7,null,(0,r.$Xk)(E),$[u]);e.$tFb=l,e.$uFb={[A.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[A.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[A.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ee[121],Se([1,0,9,4,3,66,75,74]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.TestItemEventOp=void 0;var $;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const l=(m,n)=>m===n,E=Object.entries({range:(m,n)=>m===n?!0:!m||!n?!1:m.equalsRange(n),busy:l,label:l,description:l,error:l,sortText:l,tags:(m,n)=>!(m.length!==n.length||m.some(o=>!n.includes(o)))}),u=(m,n)=>{let o;for(const[i,t]of E)t(m[i],n[i])||(o?o[i]=n[i]:o={[i]:n[i]});return o};class k extends A.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Qh(()=>this.flushDiff(),200)),this.g=this.B(new h.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case N.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===N.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case N.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===N.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,N.$VI)(o.item,n.item);return}if(o.op===N.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,N.$VI)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||o>i.expandLevels)&&(i.expandLevels=o),i.expand===N.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,o-1):t.wait().then(()=>this.L(i,o-1))}else if(i.expand===N.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,o-1)):this.L(i,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(T.$OI.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const i of o.ops)this.w(n,i);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:N.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,R.$fd)(o)}}y(n){n&&this.pushDiff({op:N.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const i=T.$OI.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(i.toString());if(!s){s={fullId:i,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:N.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:N.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,o);const d=this.s.getChildren(s.actual),a=s.actual,w=u(this.s.toITestItem(a),this.s.toITestItem(n));this.s.getApiFor(a).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=N.TestItemExpandState.NotExpandable,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,a.tags,i.toString()),delete w.tags),this.w(s,{op:$.SetProp,update:w})),this.I(n,s,o);for(const[S,D]of d)this.s.getChildren(n).get(D.id)||this.O(T.$OI.joinToString(i,D.id));const y=s.expandLevels;y!==void 0&&queueMicrotask(()=>{s.expand===N.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(i.toString(),y))}),this.y(s.actual.uri)}C(n,o,i){const t=new Set(o.map(s=>s.id));for(const s of n)t.delete(s.id)||this.D(s);this.pushDiff({op:N.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(s=>(0,N.$TI)(this.s.controllerId,s.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:N.TestDiffOpType.AddTag,tag:{id:(0,N.$TI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:N.TestDiffOpType.RemoveTag,id:(0,N.$TI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=s=>this.w(o,s),this.J(o)}I(n,o,i){this.H(n,o,i);for(const[t,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?N.TestItemExpandState.Expanded:N.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?N.TestItemExpandState.Expandable:N.TestItemExpandState.NotExpandable:o=N.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:N.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===N.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const i=[];for(const[t,s]of this.s.getChildren(n.actual)){const d=this.expand(T.$OI.joinToString(n.fullId,s.id),o);(0,r.$qh)(d)&&i.push(d)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Dh;return s.open(),s}n.expand=N.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Dh,i=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){i(s)}return(0,r.$qh)(t)?t.catch(i).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:N.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:N.TestDiffOpType.Remove,itemId:n});const i=[o];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.F(s.id);this.tree.delete(t.fullId.toString());for(const[s,d]of this.s.getChildren(t.actual))i.push(this.tree.get(T.$OI.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$kP=k;class b extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$lP=b;class c extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$mP=c;class g extends Error{constructor(n,o,i){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${i}".`)}}e.$nP=g;const f=(m,n,o)=>{let i=new Map;return{get size(){return i.size},forEach(t,s){for(const d of i.values())t.call(s,d,this)},[Symbol.iterator](){return i.entries()},replace(t){const s=new Map,d=new Set(i.keys()),a={op:$.Bulk,ops:[]};for(const w of t){if(!(w instanceof o))throw new c(w.id);const y=n(w).controllerId;if(y!==m.controllerId)throw new g(w.id,y,m.controllerId);if(s.has(w.id))throw new b(w.id);s.set(w.id,w),d.delete(w.id),a.ops.push({op:$.Upsert,item:w})}for(const w of d.keys())a.ops.push({op:$.RemoveChild,id:w});m.listener?.(a),i=s},add(t){if(!(t instanceof o))throw new c(t.id);i.set(t.id,t),m.listener?.({op:$.Upsert,item:t})},delete(t){i.delete(t)&&m.listener?.({op:$.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$oP=f}),define(Ee[154],Se([1,0,121]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=void 0;const h=new WeakMap,A=(N,T)=>{const $={controllerId:T};return h.set(N,$),$};e.$pP=A;const R=N=>{const T=h.get(N);if(!T)throw new r.$mP(N?.id||"<unknown>");return T};e.$qP=R}),define(Ee[122],Se([1,0,27,15,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jCb=e.$iCb=e.$hCb=void 0,e.$kCb=R,e.$lCb=T,e.$hCb="vscode-cdn.net",e.$iCb=`vscode-resource.${e.$hCb}`,e.$jCb=`'self' https://*.${e.$hCb}`;function R($,l){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(l&&l.authority&&l.isRemote&&$.scheme===h.Schemas.file&&($=A.URI.from({scheme:h.Schemas.vscodeRemote,authority:l.authority,path:$.path})),A.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${N($.authority)}.${e.$iCb}`,path:$.path,fragment:$.fragment,query:$.query}))}function N($){return $.replace(/./g,l=>{const I=l.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?l:"-"+I.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(l,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ee[315],Se([1,0,4,3,122]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class R{constructor(T,$,l){this.d=T,this.e=$,this.f=l,this.a=0,this.b=new h.$Uc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const I=$.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,l,I,E){let u;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===T){u=n;break}if(!u)throw new Error("not a visible editor");const k=this,b=this.a++,c=new r.$le,g=new r.$le,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$kCb)(n,k.f)}get cspSource(){return A.$jCb}set options(n){this.b=n,k.d.$setOptions(b,n)}get options(){return this.b}set html(n){this.a=n,k.d.$setHtml(b,n)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(n){return k.d.$postMessage(b,n)}},m=new class{constructor(){this.editor=T,this.line=$,this.height=l,this.webview=f,this.onDidDispose=g.event}dispose(){k.c.has(b)&&(k.c.delete(b),k.d.$disposeEditorInset(b),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(b,u.id,u.value.document.uri,$+1,l,I||{},E.identifier,E.extensionLocation),this.c.set(b,{editor:T,inset:m,onDidReceiveMessage:c}),m}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$rnc=R}),define(Ee[155],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0,e.$3L="__",e.$4L=(0,r.$Ei)("IAuthenticationService"),e.$5L=(0,r.$Ei)("IAuthenticationExtensionsService")}),define(Ee[316],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.VariableKind=e.$iQ=void 0,e.$iQ=(0,r.$Ei)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class A extends Error{constructor(N,T){super(T),this.variable=N}}e.$jQ=A}),define(Ee[317],Se([1,0,16,56,18,25,11,110,257,316,13]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0,r=We(r),h=We(h),A=We(A),R=We(R);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,b,c,g){this.h=new Map,this.a=k,this.b=b,this.g=c,g&&(this.c=g.then(f=>this.i(f)))}i(k){if(N.$i){const b=Object.create(null);return Object.keys(k).forEach(c=>{b[c.toLowerCase()]=k[c]}),b}return k}resolveWithEnvironment(k,b,c){return this.l({env:this.i(k),userHome:void 0},b?b.uri:void 0,c)}async resolveAsync(k,b){const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,b)}async j(k,b,c,g){const f=R.$bo(b);N.$i&&f.windows?Object.keys(f.windows).forEach(n=>f[n]=f.windows[n]):N.$j&&f.osx?Object.keys(f.osx).forEach(n=>f[n]=f.osx[n]):N.$k&&f.linux&&Object.keys(f.linux).forEach(n=>f[n]=f.linux[n]),delete f.windows,delete f.osx,delete f.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,k?k.uri:void 0,f,c,g)}async resolveAnyAsync(k,b,c){return this.j(k,b,c)}async resolveAnyMap(k,b,c){const g=new Map;return{newConfig:await this.j(k,b,c,g),resolvedVariables:g}}resolveWithInteractionReplace(k,b,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,b,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,b){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,b)}async l(k,b,c,g,f){if(A.$eg(c))return this.m(k,b,c,g,f);if(Array.isArray(c))return Promise.all(c.map(m=>this.l(k,b,m,g,f)));if(A.$gg(c)){const m=Object.create(null),n=await Promise.all(Object.keys(c).map(async o=>[await this.m(k,b,o,g,f),await this.l(k,b,c[o],g,f)]));for(const[o,i]of n)m[o]=i;return m}return c}m(k,b,c,g,f){return(0,I.$xf)(c,E.VARIABLE_REGEXP,async(m,n)=>{if(n.includes(E.VARIABLE_LHS))return m;let o=await this.o(k,m,n,b,g);return f?.set(n,o),o!==m&&A.$eg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(k,b,o,g,f)),o})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,b,c,g,f){let m;const n=c.split(":");n.length>1&&(c=n[0],m=n[1]);const o=s=>{const d=this.a.getFilePath();if(d)return(0,T.$Sw)(d);throw new l.$jQ(s,(0,$.localize)(0,null,b))},i=s=>{const d=o(s);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,T.$Sw)(a)}throw new l.$jQ(s,(0,$.localize)(1,null,b,r.$oc(d)))},t=s=>{if(m){const d=this.a.getFolderUri(m);if(d)return d;throw new l.$jQ(s,(0,$.localize)(2,null,b,m))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new l.$jQ(s,(0,$.localize)(3,null,b)):new l.$jQ(s,(0,$.localize)(4,null,b))};switch(c){case"env":if(m){if(k.env){const s=k.env[N.$i?m.toLowerCase():m];if(A.$eg(s))return s}return""}throw new l.$jQ(l.VariableKind.Env,(0,$.localize)(5,null,b));case"config":if(m){const s=this.a.getConfigurationValue(g,m);if(A.$ng(s))throw new l.$jQ(l.VariableKind.Config,(0,$.localize)(6,null,b,m));if(A.$gg(s))throw new l.$jQ(l.VariableKind.Config,(0,$.localize)(7,null,b,m));return s}throw new l.$jQ(l.VariableKind.Config,(0,$.localize)(8,null,b));case"command":return this.p(l.VariableKind.Command,b,m,f,"command");case"input":return this.p(l.VariableKind.Input,b,m,f,"input");case"extensionInstallFolder":if(m){const s=await this.a.getExtension(m);if(!s)throw new l.$jQ(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,b,m));return this.n(s.extensionLocation)}throw new l.$jQ(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,b));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,T.$Sw)(this.n(t(l.VariableKind.WorkspaceFolder)));case"cwd":return g||m?(0,T.$Sw)(this.n(t(l.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Sw)(r.$oc(this.n(t(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new l.$jQ(l.VariableKind.UserHome,(0,$.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new l.$jQ(l.VariableKind.LineNumber,(0,$.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new l.$jQ(l.VariableKind.SelectedText,(0,$.localize)(13,null,b))}case"file":return o(l.VariableKind.File);case"fileWorkspaceFolder":return i(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$oc(i(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||m?r.$mc(this.n(t(l.VariableKind.RelativeFile)),o(l.VariableKind.RelativeFile)):o(l.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$nc(o(l.VariableKind.RelativeFileDirname));if(g||m){const d=r.$mc(this.n(t(l.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return r.$nc(o(l.VariableKind.FileDirname));case"fileExtname":return r.$pc(o(l.VariableKind.FileExtname));case"fileBasename":return r.$oc(o(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$oc(o(l.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$pc(s).length)}case"fileDirnameBasename":return r.$oc(r.$nc(o(l.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":case"/":return r.sep;default:try{const s=m?`${c}:${m}`:c;return this.p(l.VariableKind.Unknown,b,s,f,void 0)}catch{return b}}}}p(k,b,c,g,f){if(c&&g){const m=f===void 0?g[c]:g[f+":"+c];if(typeof m=="string")return m;throw new l.$jQ(k,(0,$.localize)(14,null,b))}return b}}e.$yQ=E}),define(Ee[156],Se([1,0,5,152]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$fE=void 0,e.$gE=l,e.$hE=u,e.$iE=k,e.$fE=(0,r.$Ei)("editorGroupsService");var A;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var N;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(N||(e.GroupLocation=N={}));var T;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function l(b){const c=b;return(0,h.$4F)(c?.editor)&&(0,h.$4F)(c?.replacement)}var I;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(b){const c=b;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function k(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?A.DOWN:A.RIGHT}}),define(Ee[318],Se([1,0,5,156]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.$jE=void 0,e.$nE=A,e.$jE=(0,r.$Ei)("editorService"),e.$kE=-1,e.$lE=-2,e.$mE=-3;function A(R){const N=R;return typeof R=="number"||(0,h.$hE)(N)}}),define(Ee[157],Se([1,0,5,144]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0,e.$lM=(0,r.$Fi)(h.$Li)}),define(Ee[158],Se([1,0,24,4,16,3,9]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=e.$Ebc=e.$Dbc=void 0,A=We(A);class T{constructor(m,n){this.versionId=m,this.removedDueToLooping=n}}e.$Dbc=T;class ${static isHostExtension(m,n,o){if(n.getExtensionDescription(m))return!1;const i=o.getExtensionDescription(m);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(m,n){this.j=m,this.c=new h.$le,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(c),this.f=new r.$rn,this.g=[],this.h=new Map;for(const m of this.e){if(this.f.has(m.identifier)){console.error("Extension `"+m.identifier.value+"` is already registered");continue}this.f.set(m.identifier,m),this.g.push(m);const n=this.j.readActivationEvents(m);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(m)}}set(m){return this.e=m,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(m,n){this.e=g(this.e,n),this.e=this.e.concat(m);const o=$.l(this.e);return this.e=g(this.e,o.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,o)}static l(m){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,a){this.addNode(d),this.addNode(a),this.c.has(d)?this.c.get(d).push(a):this.c.set(d,[a])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,a){const w=n.getArcs(d);for(let y=0;y<w.length;y++)if(!a.has(w[y]))return!1;return!0}getNodes(){return this.e}},o=new r.$rn;for(const d of m)if(o.set(d.identifier,d),d.extensionDependencies)for(const a of d.extensionDependencies)n.addArc(r.$pn.toKey(d.identifier),r.$pn.toKey(a));const i=new Set;n.getNodes().filter(d=>n.getArcs(d).length===0).forEach(d=>i.add(d));const t=n.getNodes().filter(d=>!i.has(d));let s;do{s=!1;for(let d=0;d<t.length;d++){const a=t[d];n.hasOnlyGoodArcs(a,i)&&(t.splice(d,1),d--,i.add(a),s=!0)}}while(s);return t.map(d=>o.get(d))}containsActivationEvent(m){return this.h.has(m)}containsExtension(m){return this.f.has(m)}getExtensionDescriptionsForActivationEvent(m){const n=this.h.get(m);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new l(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(m){const n=this.f.get(m);return n||void 0}getExtensionDescriptionByUUID(m){for(const n of this.g)if(n.uuid===m)return n}getExtensionDescriptionByIdOrUUID(m,n){return this.getExtensionDescription(m)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Ebc=$;class l{constructor(m,n){this.versionId=m,this.extensions=n}}e.$Fbc=l;class I{constructor(m){this.d=new k,this.c=new $(m,[])}async acquireLock(m){const n=await this.d.acquire(m);return new E(this,n)}deltaExtensions(m,n,o){if(!m.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(m){return this.c.containsActivationEvent(m)}containsExtension(m){return this.c.containsExtension(m)}getExtensionDescriptionsForActivationEvent(m){return this.c.getExtensionDescriptionsForActivationEvent(m)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(m){return this.c.getExtensionDescription(m)}getExtensionDescriptionByUUID(m){return this.c.getExtensionDescriptionByUUID(m)}getExtensionDescriptionByIdOrUUID(m,n){return this.c.getExtensionDescriptionByIdOrUUID(m,n)}}e.$Gbc=I;class E extends R.$Vc{constructor(m,n){super(),this.f=m,this.c=!1,this.B(n)}isAcquiredFor(m){return!this.c&&this.f===m}}e.$Hbc=E;class u{constructor(m){this.name=m;const n=(0,N.$xh)();this.promise=n.promise,this.c=n.resolve}resolve(m){this.c(m)}}class k{constructor(){this.c=[],this.d=!1}async acquire(m){const n=new u(m);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const m=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${m.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};m.resolve((0,R.$Tc)(i))}}var b;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(b||(b={}));function c(f,m){const n=f.isBuiltin?b.Builtin:f.isUnderDevelopment?b.Dev:b.User,o=m.isBuiltin?b.Builtin:m.isUnderDevelopment?b.Dev:b.User;if(n!==o)return n-o;const i=A.$hc.basename(f.extensionLocation.path),t=A.$hc.basename(m.extensionLocation.path);return i<t?-1:i>t?1:0}function g(f,m){const n=new r.$qn(m);return f.filter(o=>!n.has(o.identifier))}}),define(Ee[319],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.ExtHostConnectionType=void 0,e.$dn=T,e.$en=$;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=r.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$an=h;class A{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[A.ENV_KEY]="1"}}e.$bn=A;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[R.ENV_KEY]="1"}}e.$cn=R;function N(I){delete I[h.ENV_KEY],delete I[A.ENV_KEY],delete I[R.ENV_KEY]}function T(I,E){N(E),I.serialize(E)}function $(I){if(I[h.ENV_KEY])return l(I,new h(I[h.ENV_KEY]));if(I[A.ENV_KEY])return l(I,new A);if(I[R.ENV_KEY])return l(I,new R);throw new Error("No connection information defined in environment!")}function l(I,E){return N(I),E}}),define(Ee[94],Se([1,0,22]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$xn=N,e.$yn=T;var h;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(h||(e.UIKind=h={}));var A;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function N(l){const I=r.$Ne.alloc(1);switch(l){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function T(l,I){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var $;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[95],Se([1,0,5,4,149,12,30,94,91,92,25,2,3,240]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$MP=e.$LP=void 0,e.$NP=g;let b=class extends u.$Vc{constructor(m,n){super(),this.s=m,this.t=n,this.a=this.B(new h.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=A.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:l.$xp,name:(0,k.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,R.$ak)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===A.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=A.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=A.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=A.TelemetryLevel.USAGE:!1}}instantiateLogger(m,n,o){const i=this.getTelemetryDetails(),t=new c(n,o,m,this.n,this.j,this.getBuiltInCommonProperties(m),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),s=this.r.get(m.identifier.value)??[];return this.r.set(m.identifier.value,[...s,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(m,n,o){this.f=m,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(m){const n=Object.create(null);switch(n["common.extname"]=`${m.publisher}.${m.name}`,n["common.extversion"]=m.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:n["common.uikind"]="web";break;case T.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$gn)((0,l.$Dp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(m){this.h=this.getTelemetryConfiguration(),this.f=m;const n=this.getTelemetryDetails();this.r.forEach((o,i)=>{const t=o.filter(s=>!s.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(o=>{for(const i of o)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(m,n){const i=this.r.get(m.value)?.filter(s=>!s.isDisposed);if(!i)return this.r.delete(m.value),!1;let t=!1;for(const s of i)s.ignoreUnhandledExtHostErrors||(s.logError(n),t=!0);return t}};e.$LP=b,e.$LP=b=Qe([qe(0,N.$KP),qe(1,R.$_j)],b);class c{static validateSender(m){if(typeof m!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof m.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof m.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof m.flush<"u"&&typeof m.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(m,n,o,i,t,s,d){this.g=o,this.h=i,this.i=t,this.j=s,this.a=new h.$le,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=m,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(m,n){this.e&&(this.d={isUsageEnabled:m,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(m){let n="properties"in m?m.properties??{}:m;return n=(0,l.$Gp)(n,[]),this.c&&(n=(0,I.$eo)(n,this.c)),this.b||(n=(0,I.$eo)(n,this.j)),"properties"in m?m.properties=n:m=n,m}k(m,n){this.f&&(this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(m,n),this.h.trace(m,n))}logUsage(m,n){this.d.isUsageEnabled&&this.k(m,n)}logError(m,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof m=="string")this.k(m,n);else{const o={name:m.name,message:m.message,stack:m.stack,cause:m.cause},i=(0,l.$Gp)(o,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const m=this,n={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.d.isUsageEnabled},get isErrorsEnabled(){return m.d.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.a.event.bind(m)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let m=this.f;this.f=void 0,Promise.resolve(m.flush()).then(m=void 0),this.e=void 0}else this.f=void 0}}e.$MP=c;function g(f){const m=Date.now()-new Date(f).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.$OP=(0,r.$Ei)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,289,147,24,5]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.ActivationKind=e.$6G=e.$5G=e.$2G=e.ExtensionHostStartup=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$3G=u,e.$4G=k,e.$7G=f,e.$8G=m,e.$XG=Object.freeze({identifier:new N.$pn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:N.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YG="extensions.webWorker",e.$ZG=(0,T.$Ei)("extensionService");class ${constructor(i){this.dependency=i}}e.$1G=$;var l;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,s){this.c=i,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$IG.createActivationEventsMap(this.d)}}set(i,t,s){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const d=[],a=[],w=[],y=[],S=E(this.d),D=E(t),P=(L,F)=>L.extensionLocation.toString()===F.extensionLocation.toString()||L.isBuiltin===F.isBuiltin||L.isUserBuiltin===F.isUserBuiltin||L.isUnderDevelopment===F.isUnderDevelopment;for(const L of this.d){const F=D.get(L.identifier);if(!F){d.push(L.identifier),S.delete(L.identifier);continue}if(!P(L,F)){d.push(L.identifier),S.delete(L.identifier);continue}}for(const L of t){const F=S.get(L.identifier);if(!F){a.push(L);continue}if(!P(F,L)){d.push(F.identifier),S.delete(F.identifier);continue}}const C=new N.$qn(this.e),p=new N.$qn(s);for(const L of this.e)p.has(L)||w.push(L);for(const L of s)C.has(L)||y.push(L);const v=R.$IG.createActivationEventsMap(a),O={versionId:i,toRemove:d,toAdd:a,addActivationEvents:v,myToRemove:w,myToAdd:y};return this.delta(O),O}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:d,myToAdd:a}=i,w=new N.$qn(t),y=new N.$qn(d);for(let S=0;S<this.d.length;S++)w.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)y.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of a)this.e.push(S);return this.f=null,i}containsExtension(i){for(const t of this.e)if(N.$pn.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$IG.readActivationEvents(t);for(const d of s)i.add(d)}return i}}e.$2G=I;function E(o){const i=new N.$rn;for(const t of o)i.set(t.identifier,t);return i}function u(o,i){return o.enabledApiProposals?o.enabledApiProposals.includes(i):!1}function k(o,i){if(!u(o,i))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class b{constructor(i,t,s,d){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=d}}e.$5G=b;class c{constructor(i,t){this.description=i,this.value=t}}e.$6G=c;var g;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function f(o){return{type:o.isBuiltin?N.ExtensionType.System:N.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.$Mp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function m(o,i){const t=(0,A.$Kp)(o.manifest.publisher,o.manifest.name);return{id:t,identifier:new N.$pn(t),isBuiltin:o.type===N.ExtensionType.System,isUserBuiltin:o.type===N.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!i,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9G=n}),define(Ee[320],Se([1,0,14,158,24,26,12,9]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=e.$Rnc=e.$Qnc=e.$Pnc=e.$Onc=e.$Nnc=void 0,r=We(r);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(f,m,n,o){this.startup=f,this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Nnc=$;class l{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,m){return f===-1||m===-1?-1:m-f}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Onc=l;class I{constructor(f,m,n,o,i,t){this.activationFailed=f,this.activationFailedError=m,this.activationTimes=n,this.module=o,this.exports=i,this.subscriptions=t}}e.$Pnc=I;class E extends I{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Qnc=E;class u extends I{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rnc=u;class k extends I{constructor(f){super(!0,f,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(f,m,n,o){this.g=o,this.a=f,this.b=m,this.c=n,this.d=new A.$rn,this.f=Object.create(null)}dispose(){for(const[f,m]of this.d)m.dispose()}async waitForActivatingExtensions(){const f=[];for(const[m,n]of this.d)f.push(n.wait());await Promise.all(f)}isActivated(f){const m=this.d.get(f);return!!(m&&m.value)}getActivatedExtension(f){const m=this.d.get(f);if(!m||!m.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return m.value}async activateByEvent(f,m){if(this.f[f])return;const n=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(n.map(o=>({id:o.identifier,reason:{startup:m,extensionId:o.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,m){const n=this.a.getExtensionDescription(f);if(!n)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:n.identifier,reason:m}])}async h(f){const m=f.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(m.map(n=>n.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const m=this.a.getExtensionDescription(f.id);if(!m){const i=new Error(`Cannot activate unknown extension '${f.id.value}'`),t=this.k(f,null,[],new k(i));return this.c.onExtensionActivationError(f.id,i,new R.$1G(f.id.value)),t}const n=[],o=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const i of o){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:f.reason}));continue}const s=this.a.getExtensionDescription(i);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:f.reason}));continue}const d=m.displayName||m.identifier.value,a=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${i}'`),w=this.k(f,m.displayName,[],new k(a));return this.c.onExtensionActivationError(m.identifier,a,new R.$1G(i)),w}return this.k(f,m.displayName,n,null)}k(f,m,n,o){const i=new c(f.id,m,f.reason,n,o,this.c,this.g);return this.d.set(f.id,i),i}l(f){return h.$Ebc.isHostExtension(f,this.a,this.b)}m(f){const m=this.b.getExtensionDescription(f);return m?!m.main&&!m.browser:!1}};e.$Snc=b,e.$Snc=b=Qe([qe(3,N.$$j)],b);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,m,n,o,i,t,s){this.c=f,this.d=m,this.f=n,this.g=o,this.h=i,this.j=t,this.k=s,this.a=new T.$Dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const m=this.g[f];if(m.value&&!m.value.activationFailed){this.g.splice(f,1),f--;continue}if(m.value&&m.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);n.detail=m.value.activationFailedError,this.h=new k(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const m=new Error;if(f&&f.name&&(m.name=f.name),f&&f.message?m.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(m.stack=f.stack),this.h=new k(m),this.b&&r.$5(f))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};c=Qe([qe(6,N.$$j)],c)}),define(Ee[321],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testRunInDebug:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRunInDebug.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[159],Se([1,0,259,14,44,146,117,37,24,321,116,147]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=void 0,r=We(r),A=zt(A);const u=T.$oo.as(N.$po.JSONContribution);class k{constructor(i,t,s){this.a=i,this.b=t,this.c=s}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(A.default.Error,i)}warn(i){this.d(A.default.Warning,i)}info(i){this.d(A.default.Info,i)}}e.$RG=k;class b{static a(i){const t=new $.$qn;for(let s=0,d=i.length;s<d;s++)t.add(i[s].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new b(t,[]);if(!t||!t.length)return new b([],i);const s=this.a(i),d=this.a(t),a=t.filter(y=>!s.has(y.description.identifier)),w=i.filter(y=>!d.has(y.description.identifier));return new b(a,w)}constructor(i,t){this.added=i,this.removed=t}}e.$SG=b;class c{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=b.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,h.$2)(i)}}}e.$TG=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.$UG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$on},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$6o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$6o}},extensionKind:{description:r.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class m{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new c(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&E.$IG.register(i.extensionPoint,i.activationEventsGenerator),e.$UG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,u.registerSchema(f,e.$UG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$VG=m;const n={ExtensionsRegistry:"ExtensionsRegistry"};T.$oo.add(n.ExtensionsRegistry,new m),e.$WG=T.$oo.as(n.ExtensionsRegistry),u.registerSchema(f,e.$UG),u.registerSchema(I.$sk,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(Ee[322],Se([1,0,4,40,3,13,250,24,5,12,26,159]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.ChatMessageRole=void 0;var u;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$0G=(0,$.$Ei)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,N.localize)(0,null)}}};e.$$G=E.$WG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,N.localize)(1,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(c,g)=>{for(const f of c)g.push(`onLanguageModelChat:${f.vendor}`)}});let b=class{constructor(g,f){this.e=g,this.f=f,this.a=new A.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$$G.setHandler(m=>{this.c.clear();for(const o of m){if(!(0,I.$3G)(o.description,"chatProvider")){o.collector.error((0,N.localize)(2,null));continue}for(const i of h.Iterable.wrap(o.value)){if(this.c.has(i.vendor)){o.collector.error((0,N.localize)(3,null,i.vendor));continue}if((0,R.$cf)(i.vendor)){o.collector.error((0,N.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){o.collector.error((0,N.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[o,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(g){return this.b.get(g)?.metadata}async selectLanguageModels(g){if(g.vendor)await this.e.activateByEvent(`onLanguageModelChat:${g.vendor}}`);else{const m=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(m)}const f=[];for(const[m,n]of this.b)(g.vendor===void 0||n.metadata.vendor===g.vendor)&&(g.family===void 0||n.metadata.family===g.family)&&(g.version===void 0||n.metadata.version===g.version)&&(g.identifier===void 0||n.metadata.id===g.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>T.$pn.equals(o,g.extension)))&&f.push(m);return this.f.trace("[LM] selected language models",g,f),f}registerLanguageModelChat(g,f){if(this.f.trace("[LM] registering language model chat",g,f.metadata),!this.c.has(f.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${f.metadata.vendor}.`);if(this.b.has(g))throw new Error(`Chat response provider with identifier ${g} is already registered.`);return this.b.set(g,f),this.d.fire({added:[{identifier:g,metadata:f.metadata}]}),(0,A.$Tc)(()=>{this.b.delete(g)&&(this.d.fire({removed:[g]}),this.f.trace("[LM] UNregistered language model chat",g,f.metadata))})}makeLanguageModelChatRequest(g,f,m,n,o,i){const t=this.b.get(g);if(!t)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return t.provideChatResponse(m,f,n,o,i)}computeTokenLength(g,f,m){const n=this.b.get(g);if(!n)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return n.provideTokenCount(f,m)}};e.$_G=b,e.$_G=b=Qe([qe(0,I.$ZG),qe(1,l.$$j)],b)}),define(Ee[323],Se([1,0,254,18,25,159,36,4]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=void 0,r=We(r),h=We(h),A=We(A);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var l;(function(u){function k(b,c,g){if(!b)return;const f=h.$eg(b.type)?b.type:void 0;if(!f||f.length===0){g.error(r.localize(3,null));return}const m=[];if(Array.isArray(b.required))for(const n of b.required)h.$eg(n)&&m.push(n);return{extensionId:c.value,taskType:f,required:m,properties:b.properties?A.$bo(b.properties):{},when:b.when?N.$Cj.deserialize(b.when):void 0}}u.from=k})(l||(l={}));const I=R.$WG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,k)=>{for(const b of u)b.type&&k.push(`onTaskType:${b.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:$}});class E{constructor(){this.d=new T.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,b)=>{I.setHandler((c,g)=>{this.c=void 0;try{for(const f of g.removed){const m=f.value;for(const n of m)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const f of g.added){const m=f.value;for(const n of m){const o=l.from(n,f.description.identifier,f.collector);o&&(this.a[o.taskType]=o)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const b of this.all()){const c={type:"object",additionalProperties:!1};b.required.length>0&&(c.required=b.required.slice(0)),b.properties!==void 0?c.properties=A.$bo(b.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[b.taskType]},k.push(c)}this.c={oneOf:k}}return this.c}}e.$CI=new E}),define(Ee[324],Se([1,0,255,18,23,25,36,323,45]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MI=e.JsonSchemaVersion=e.ExecutionEngine=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GI=e.ShellQuoting=e.$FI=e.$EI=e.$DI=void 0,r=We(r),h=We(h),A=We(A),R=We(R),e.$DI="settings",e.$EI=new N.$Vj("taskRunning",!1,r.localize(0,null)),e.$FI=r.localize2(2,"Tasks");var l;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.$GI="$customized",function(M){function z(_){if(!_)return M.Strong;switch(_.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=z}(l||(e.ShellQuoting=l={}));var I;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(E||(e.RevealKind=E={})),function(M){function z(_){switch(_.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=z}(E||(e.RevealKind=E={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function z(_){switch(_.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=z}(u||(e.RevealProblemKind=u={}));var k;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(k||(e.PanelKind=k={})),function(M){function z(_){switch(_.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=z}(k||(e.PanelKind=k={}));var b;(function(M){M.defaults={echo:!0,reveal:E.Always,revealProblems:u.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var c;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(c||(e.RuntimeType=c={})),function(M){function z(re){switch(re.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=z;function _(re){switch(re){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=_}(c||(e.RuntimeType=c={}));var g;(function(M){function z(_){return h.$eg(_)?_:_.value}M.value=z})(g||(e.CommandString=g={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function z(re){return re===M.Clean._id||re===M.Build._id||re===M.Rebuild._id||re===M.Test._id}M.is=z;function _(re){if(re!==void 0)return h.$eg(re)?z(re)?{_id:re,isDefault:!1}:void 0:re}M.from=_})(f||(e.TaskGroup=f={}));var m;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(m||(e.TaskScope=m={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function z(_){switch(_){case M.User:return $.ConfigurationTarget.USER;case M.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=z})(n||(e.TaskSourceKind=n={}));var o;(function(M){M.parallel="parallel",M.sequence="sequence"})(o||(e.DependsOrder=o={}));var i;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class s{constructor(z,_,re,U,G,K){this._label="",this._id=z,_&&(this._label=_),re&&(this.type=re),this.runOptions=U,this.configurationProperties=G,this._source=K}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,_=!1){if(z===void 0)return!1;if(h.$eg(z))return z===this._label||z===this.configurationProperties.identifier||_&&z===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$HI=s;class d extends s{constructor(z,_,re,U,G,K,ee,ue){super(z,re,void 0,ee,ue,_),this.command={},this._source=_,this.hasDefinedMatchers=K,G&&(this.command=G)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let _;switch(this.command?this.command.runtime:void 0){case c.Shell:_="shell";break;case c.Process:_="process";break;case c.CustomExecution:_="customExecution";break;case void 0:_="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:_,_key:this._id,id:this._id}}}static is(z){return z instanceof d}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$DI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$GI,folder:z,id:_};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$ch(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new d(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$II=d;class a extends s{constructor(z,_,re,U,G,K,ee){super(z,re,U,K,ee,_),this._source=_,this.configures=G}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$ch(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$DI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$GI,folder:z,id:_};return JSON.stringify(re)}}e.$JI=a;class w extends s{constructor(z,_,re,U,G,K,ee,ue,ne){super(z,re,U,ue,ne,_),this.defines=G,this.hasDefinedMatchers=ee,this.command=K,this.icon=ne.icon,this.hide=ne.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof w}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===m.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new w(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$KI=w;class y extends s{constructor(z,_,re,U,G,K){super(z,re,U,G,K,_),this._source=_}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new y(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$LI=y;var S;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(M){M._default=M.Terminal}(S||(e.ExecutionEngine=S={}));var D;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class P{constructor(z){this.c=new Map;for(let _=0;_<z.length;_++)this.c.set(z[_].uri.toString(),_)}compare(z,_){const re=z.getWorkspaceFolder(),U=_.getWorkspaceFolder();if(re&&U){let G=this.c.get(re.uri.toString());G=G===void 0?0:G+1;let K=this.c.get(U.uri.toString());return K=K===void 0?0:K+1,G===K?z._label.localeCompare(_._label):G-K}else return!re&&U?-1:re&&!U?1:0}}e.$MI=P;var C;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(C||(e.TaskEventKind=C={}));var p;(function(M){M.SingleRun="singleRun",M.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var O;(function(M){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function _(ue,ne,De){return{...z(ue),kind:C.Start,terminalId:ne,resolvedVariables:De}}M.start=_;function re(ue,ne,De){return{...z(ue),kind:C.ProcessStarted,terminalId:ne,processId:De}}M.processStarted=re;function U(ue,ne,De){return{...z(ue),kind:C.ProcessEnded,terminalId:ne,exitCode:De}}M.processEnded=U;function G(ue,ne,De){return{...z(ue),kind:C.Terminated,exitReason:De,terminalId:ne}}M.terminated=G;function K(ue,ne,De){return{...z(ne),kind:ue,terminalId:De}}M.general=K;function ee(){return{kind:C.Changed}}M.changed=ee})(O||(e.TaskEvent=O={}));var L;(function(M){function z(re){const U=Object.keys(re).sort();let G="";for(const K of U){let ee=re[K];ee instanceof Object?ee=z(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=K+","+ee+","}return G}function _(re){const G={_key:z(re),type:re.taskType};return Object.assign(G,re),G}M.create=_})(L||(e.KeyedTaskIdentifier=L={}));var F;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var B;(function(M){function z(_,re){const U=T.$CI.get(_.type);if(U===void 0){const ue=R.$bo(_);return delete ue._key,L.create(ue)}const G=Object.create(null);G.type=U.taskType;const K=new Set;U.required.forEach(ue=>K.add(ue));const ee=U.properties;for(const ue of Object.keys(ee)){const ne=_[ue];if(ne!=null)G[ue]=ne;else if(K.has(ue)){const De=ee[ue];if(De.default!==void 0)G[ue]=R.$bo(De.default);else switch(De.type){case"boolean":G[ue]=!1;break;case"number":case"integer":G[ue]=0;break;case"string":G[ue]="";break;default:re.error(r.localize(1,null,JSON.stringify(_,void 0,0),ue));return}}}return L.create(G)}M.createTaskIdentifier=z})(B||(e.TaskDefinition=B={}))}),define(Ee[325],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((N,T)=>{this.b=N,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(N){this.f||this.h||(this.f=!0,this.g=N,this.a&&this.b(N))}resolveErr(N){this.f||this.h||(this.h=!0,this.i=N,this.a?this.d(N):(0,r.$2)(N))}then(N,T){return this.j().then(N,T)}catch(N){return this.j().then(void 0,N)}finally(N){return this.j().finally(N)}}e.$Ibc=h;class A extends h{constructor(){super(),this.h=!0,this.i=new r.$6}}e.$Jbc=A}),define(Ee[51],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Mw=void 0,e.$Nw=A,e.$Ow=R;class r{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++r.count}}e.$Mw=r;const h=[];function A(T){const $=new r(T);return h[$.nid]=$,$}function R(T){return h[T].sid}class N{constructor($){this.value=$}}e.$Pw=N}),define(Ee[6],Se([1,0,51]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var A;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var N;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(N||(e.WebviewEditorCapabilities=N={}));var T;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var l;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this.a=0}static mixin(g){return g._id=E.a++,g}}e.$ZM=E;var u;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$1M={MainThreadAuthentication:(0,r.$Nw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Nw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Nw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Nw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Nw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Nw)("MainThreadChatVariables"),MainThreadClipboard:(0,r.$Nw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Nw)("MainThreadCommands"),MainThreadComments:(0,r.$Nw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Nw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Nw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Nw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Nw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Nw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Nw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Nw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Nw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Nw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Nw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Nw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Nw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Nw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Nw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Nw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Nw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Nw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Nw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Nw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Nw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Nw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Nw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Nw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Nw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Nw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Nw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Nw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Nw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Nw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Nw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Nw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Nw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Nw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Nw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Nw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Nw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Nw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Nw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Nw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Nw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Nw)("MainThreadSCM"),MainThreadSearch:(0,r.$Nw)("MainThreadSearch"),MainThreadShare:(0,r.$Nw)("MainThreadShare"),MainThreadTask:(0,r.$Nw)("MainThreadTask"),MainThreadWindow:(0,r.$Nw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Nw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Nw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Nw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Nw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Nw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Nw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Nw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Nw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Nw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Nw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Nw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Nw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Nw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Nw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Nw)("MainThreadAiEmbeddingVector")},e.$2M={ExtHostCommands:(0,r.$Nw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Nw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Nw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Nw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Nw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Nw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Nw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Nw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Nw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Nw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Nw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Nw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Nw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Nw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Nw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Nw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Nw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Nw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Nw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Nw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Nw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Nw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Nw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Nw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Nw)("ExtHostSCM"),ExtHostSearch:(0,r.$Nw)("ExtHostSearch"),ExtHostTask:(0,r.$Nw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Nw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Nw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Nw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Nw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Nw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Nw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Nw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Nw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Nw)("ExtHostProgress"),ExtHostComments:(0,r.$Nw)("ExtHostComments"),ExtHostSecretState:(0,r.$Nw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Nw)("ExtHostStorage"),ExtHostUrls:(0,r.$Nw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Nw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Nw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Nw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Nw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Nw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Nw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Nw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Nw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Nw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Nw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Nw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Nw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Nw)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.$Nw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Nw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Nw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Nw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Nw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Nw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Nw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Nw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Nw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Nw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Nw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Nw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Nw)("ExtHostLocalization")}}),define(Ee[96],Se([1,0,5,12,6,20]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=e.$anc=void 0,A=We(A),e.$anc=(0,r.$Ei)("IExtHostApiDeprecationService");let N=class{constructor($,l){this.c=l,this.a=new Set,this.b=$.getProxy(A.$1M.MainThreadTelemetry)}report($,l,I){const E=this.d($,l);this.a.has(E)||(this.a.add(E),l.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:$}))}d($,l){return`${$}-${l.identifier.value}`}};e.$bnc=N,e.$bnc=N=Qe([qe(0,R.$uP),qe(1,h.$$j)],N),e.$cnc=Object.freeze(new class{report(T,$,l){}})}),define(Ee[326],Se([1,0,6]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;class h{constructor(R){const N=R.getProxy(r.$1M.MainThreadClipboard);this.value=Object.freeze({readText(){return N.$readText()},writeText(T){return N.$writeText(T)}})}}e.$pnc=h}),define(Ee[327],Se([1,0,25,6,30,20]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0;let N=class{constructor(I,E){this.a=I.getProxy(h.$1M.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const u=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,E,k,arguments)}})}e(I,E,u,k){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:$(k,this.b)}),this.c&&this.f(I,u,k)}};e.$kpc=N,e.$kpc=N=Qe([qe(0,R.$uP),qe(1,A.$KP)],N);const T=1e5;function $(l,I){const E=[];if(l.length)for(let u=0;u<l.length;u++){let k=l[u];if(typeof k>"u")k="undefined";else if(k instanceof Error){const b=k;b.stack?k=b.stack:k=b.toString()}E.push(k)}if(I){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$go)(E);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ee[328],Se([1,0,2,6,26]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class R{constructor(T){this.a=T.getProxy(h.$1M.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,A.$4G)(T,"showLocal"),this.a.$showOpenDialog($).then(l=>l?l.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?r.URI.revive($):void 0)}}e.$roc=R}),define(Ee[329],Se([1,0,21,4,3,6]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0;class N{constructor($){this.b=new Map,this.c=new h.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(R.$1M.MainThreadEmbeddings)}registerEmbeddingsProvider($,l,I){if(this.d.has(l))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,l),this.b.set(E,{id:l,provider:I}),(0,A.$Tc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings($,l,I){I??=r.CancellationToken.None;let E=!1;typeof l=="string"&&(l=[l],E=!0);const u=await this.a.$computeEmbeddings($,l,I);if(u.length!==l.length)throw new Error;if(E){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,l,I){const E=this.b.get($);if(!E)return[];const u=await E.provider.provideEmbeddings(l,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$uoc=N}),define(Ee[330],Se([1,0,3,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;class A{constructor(N){this.b=0,this.a=N.getProxy(h.$1M.MainThreadLabelService)}$registerResourceLabelFormatter(N){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,N),(0,r.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Loc=A}),define(Ee[123],Se([1,0,11,13,2,5,12,6,30,20]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=e.$7nc=void 0;let I=class{constructor(u,k,b){this.f=b,this.d=new Map,this.a=k.getProxy(T.$1M.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$g}getMessage(u,k){const{message:b,args:c,comment:g}=k;if(this.c)return(0,h.$ef)(b,c??{});let f=b;g&&g.length>0&&(f+=`/${Array.isArray(g)?g.join(""):g}`);const m=this.d.get(u)?.contents[f];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,h.$ef)(m??b,c??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let k;const b=await this.g(u);if(!b){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(b),g=JSON.parse(c);k=u.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${u.identifier.value} from ${b}: ${c.message}`);return}k&&this.d.set(u.identifier.value,{contents:k,uri:b})}async g(u){if(u.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(k)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7nc=I,e.$7nc=I=Qe([qe(0,$.$KP),qe(1,l.$uP),qe(2,N.$$j)],I),e.$8nc=(0,R.$Ei)("IExtHostLocalizationService")}),define(Ee[160],Se([1,0,12,6,30,20,2,57]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0;let $=class extends r.$jk{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(k=>(0,T.$bi)(k))),this.r=E.getProxy(h.$1M.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(N.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,k){return new l(this.r,E,u,k)}};e.$jpc=$,e.$jpc=$=Qe([qe(0,R.$uP),qe(1,A.$KP)],$);class l extends r.$ek{constructor(E,u,k,b){super(b?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(u,b).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const k=[[E,u]];this.m?this.u(k):this.n.push(...k)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ee[124],Se([1,0,6,5,3,20,22]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=e.$9nc=void 0,e.$9nc=(0,h.$Ei)("IExtHostManagedSockets");let T=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(r.$1M.MainThreadManagedSockets)}setFactory(E,u){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,k=await this.c.makeConnection(),b=new A.$Uc;return this.d.set(u,new l(u,k,b)),b.add((0,A.$Tc)(()=>this.d.delete(u))),b.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),b.dispose()})),b.add(k.onDidClose(c=>{this.a.$onDidManagedSocketClose(u,c?.stack??c?.message),b.dispose()})),b.add(k.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(u,N.$Ne.wrap(c)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$0nc=T,e.$0nc=T=Qe([qe(0,R.$uP)],T);class ${constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class l extends A.$Vc{constructor(E,u,k){super(),this.socketId=E,this.actual=u,this.B(k)}}}),define(Ee[331],Se([1,0,6,12,26]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;function R(T){return T&&T.title}let N=class{constructor($,l){this.b=l,this.a=$.getProxy(r.$1M.MainThreadMessageService)}showMessage($,l,I,E,u){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let b;typeof E=="string"||R(E)?b=[E,...u]:(k.modal=E?.modal,k.useCustom=E?.useCustom,k.detail=E?.detail,b=u),k.useCustom&&(0,A.$4G)($,"resolvers");const c=[];let g=!1;for(let f=0;f<b.length;f++){const m=b[f];if(typeof m=="string")c.push({title:m,handle:f,isCloseAffordance:!1});else if(typeof m=="object"){const{title:n,isCloseAffordance:o}=m;c.push({title:n,isCloseAffordance:!!o,handle:f}),o&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,m):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,m)}return this.a.$showMessage(l,I,k,c).then(f=>{if(typeof f=="number")return b[f]})}};e.$Noc=N,e.$Noc=N=Qe([qe(1,h.$$j)],N)}),define(Ee[332],Se([1,0,3,18,2,26,6]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class T{constructor(l){this.b=new Map,this.a=l.getProxy(N.$1M.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,I,E){if((0,R.$4G)(l,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,l.identifier.value),(0,r.$Tc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(l,I,E,u){const k=this.b.get(l);if(!k)throw new Error(`Unknown handler with id: ${l}`);return k.saveProfile(I,E,u)}async $readProfile(l,I,E){const u=this.b.get(l);if(!u)throw new Error(`Unknown handler with id: ${l}`);return u.readProfile((0,h.$eg)(I)?I:A.URI.revive(I),E)}}e.$Woc=T}),define(Ee[125],Se([1,0,6,4,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0;class R{constructor(T){this.b=new h.$le,this.onDidChangePassword=this.b.event,this.a=T.getProxy(r.$1M.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,l){return this.a.$setPassword(T,$,l)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$4nc=R,e.$5nc=(0,A.$Ei)("IExtHostSecretState")}),define(Ee[333],Se([1,0,21,3,6]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=void 0;class R{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(A.$1M.MainThreadSpeech)}async $createSpeechToTextSession(T,$,l){const I=this.c.get(T);if(!I)return;const E=new h.$Uc,u=new r.$we;this.d.set($,u);const k=await I.provideSpeechToTextSession(u.token,l?{language:l}:void 0);k&&(E.add(k.onDidChange(b=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,b)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,l){const I=this.c.get(T);if(!I)return;const E=new h.$Uc,u=new r.$we;this.d.set($,u);const k=await I.provideTextToSpeechSession(u.token,l?{language:l}:void 0);k&&(this.f.set($,k),E.add(k.onDidChange(b=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,b)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const l=this.c.get(T);if(!l)return;const I=new h.$Uc,E=new r.$we;this.d.set($,E);const u=await l.provideKeywordRecognitionSession(E.token);u&&(I.add(u.onDidChange(k=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,l){const I=R.a++;return this.c.set(I,l),this.b.$registerProvider(I,$,{extension:T,displayName:T.value}),(0,h.$Tc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$4oc=R}),define(Ee[126],Se([1,0,6,4,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;class R{constructor(T,$){this.c=$,this.b=new h.$le,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(r.$1M.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,l){const I=await this.a.$initializeExtensionStorage(T,$);let E;return I&&(E=this.d(T,$,I)),E||l}setValue(T,$,l){return this.a.$setValue(T,$,l)}$acceptValue(T,$,l){const I=this.d(T,$,l);I&&this.b.fire({shared:T,key:$,value:I})}d(T,$,l){try{return JSON.parse(l)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${I}`)}}}e.$Tnc=R,e.$Unc=(0,A.$Ei)("IExtHostStorage")}),define(Ee[334],Se([1,0,3,15,2,6]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;class N{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$1M.MainThreadUriOpeners)}registerExternalUriOpener($,l,I,E){if(this.c.has(l))throw new Error(`Opener with id '${l}' already registered`);const u=E.schemes.find(k=>!N.a.has(k));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(l,I),this.b.$registerUriOpener(l,E.schemes,$,E.label),(0,r.$Tc)(()=>{this.c.delete(l),this.b.$unregisterUriOpener(l)})}async $canOpenUri($,l,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener with id: ${$}`);const u=A.URI.revive(l);return E.canOpenExternalUri(u,I)}async $openUri($,l,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener id: '${$}'`);return E.openExternalUri(A.URI.revive(l.resolvedUri),{sourceUri:A.URI.revive(l.sourceUri)},I)}}e.$dpc=N}),define(Ee[335],Se([1,0,6,2,3,14,24]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0;class T{static{this.a=0}constructor(l){this.c=new N.$qn,this.d=new Map,this.b=l.getProxy(r.$1M.MainThreadUrls)}registerUriHandler(l,I){const E=l.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=T.a++;return this.c.add(E),this.d.set(u,I),this.b.$registerUriHandler(u,E,l.displayName||l.name),(0,A.$Tc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(l,I){const E=this.d.get(l);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(I))}catch(u){(0,R.$2)(u)}return Promise.resolve(void 0)}async createAppUri(l){return h.URI.revive(await this.b.$createAppUri(l))}}e.$epc=T}),define(Ee[336],Se([1,0,22,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsb=R,e.$Isb=T,h=We(h);class A{constructor(){this.buffers=[]}add(l){let I=this.buffers.indexOf(l);return I<0&&(I=this.buffers.length,this.buffers.push(l)),I}}function R($,l){if(l.serializeBuffersForPostMessage){const I=new A,u=JSON.stringify($,(b,c)=>{if(c instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(c)};if(ArrayBuffer.isView(c)){const g=N(c);if(g)return{$$vscode_array_buffer_reference$$:!0,index:I.add(c.buffer),view:{type:g,byteLength:c.byteLength,byteOffset:c.byteOffset}}}return c}),k=I.buffers.map(b=>{const c=new Uint8Array(b);return r.$Ne.wrap(c)});return{message:u,buffers:k}}else return{message:JSON.stringify($),buffers:[]}}function N($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,l){const I=l.map(k=>{const b=new ArrayBuffer(k.byteLength);return new Uint8Array(b).set(k.buffer),b}),E=l.length?(k,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const c=b,{index:g}=c,f=I[g];if(c.view)switch(c.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(f,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(f,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(f,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(f,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(f,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(f,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(f,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(f,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(f,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(f,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(f,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return b}:void 0;return{message:JSON.parse($,E),arrayBuffers:I}}}),define(Ee[97],Se([1,0,4,3,15,25,2,263,336,122,6]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Enc=void 0,e.$Fnc=u,e.$Hnc=c,e.$Inc=g,R=We(R),I=We(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,i,t,s,d,a,w){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$le,this._onDidDispose=this.#h.event,this.#e=o,this.#t=i,this.#o=t,this.#n=s,this.#s=d,this.#r=a,this.#u=u(a),this.#d=k(a),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,l.$kCb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===A.Schemas.https||o.scheme===A.Schemas.http){let i=o.toString();return i.endsWith("/")||(i+="/"),i+" "+l.$jCb}return l.$jCb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),R.$fo(this.#o,o)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const i=(0,$.$Hsb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const i=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,a,w,y,S)=>{const D=N.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),P=(0,l.$kCb)(D,{isRemote:i,authority:t}).toString();return`${d}${P}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,a,w,y,S)=>{const D=N.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),P=(0,l.$kCb)(D,{isRemote:i,authority:t}).toString();return`${d}${P}${S}`})}}e.$Enc=E;function u(n){try{const o=(0,T.$Vp)((0,T.$Up)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function k(n){try{const o=(0,T.$Vp)((0,T.$Up)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class b extends h.$Vc{constructor(o,i,t,s,d){super(),this.c=i,this.f=t,this.g=s,this.h=d,this.b=new Map,this.a=o.getProxy(I.$1M.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,i,t){const s=this.j(o);if(s){const{message:d}=(0,$.$Isb)(i,t.value);s._onMessageEmitter.fire(d)}}$onMissingCsp(o,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,i,t){const s=new E(o,this.a,f(i),this.c,this.f,t,this.h);this.b.set(o,s);const d=s._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Gnc=b;function c(n){return{id:n.identifier,location:n.extensionLocation}}function g(n,o,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||m(n,o)}}function f(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>N.URI.from(o))}}function m(n,o){return[...(o?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(Ee[161],Se([1,0,4,15,13,2,5,20,6]),function(ce,e,r,h,A,R,N,T,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;let I=class{static{l=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$le,this.onDidChangeWindowState=this.c.event,this.d=l.a,this.b=u.getProxy($.$1M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:b})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,k){k!==this.d[u]&&(this.d={...this.d,[u]:k},this.c.fire(this.d))}openUri(u,k){let b;if(typeof u=="string"){b=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,A.$cf)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,b,k)}async asExternalUri(u,k){if((0,A.$cf)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(u,k);return R.URI.from(b)}};e.$gpc=I,e.$gpc=I=l=Qe([qe(0,T.$uP)],I),e.$hpc=(0,N.$Ei)("IExtHostWindow")}),define(Ee[337],Se([1,0,327,30,20,94]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0;const N=1024*1024;let T=class extends r.$kpc{constructor(l,I){super(l,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(l,I,E){const u=l==="error"||l==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,E),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(l,I){const E=process[l],u=E.write;let k="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(b,c,g)=>{if(!this.g){k+=b.toString(c);const f=k.length>N?k.length:k.lastIndexOf(`
`);f!==-1&&(console[I](k.slice(0,f)),k=k.slice(f+1))}u.call(E,b,c,g)}})}};e.$Vpc=T,e.$Vpc=T=Qe([qe(0,A.$uP),qe(1,h.$KP)],T)}),define(Ee[338],Se([1,0,160,15,279,32]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class N extends r.$jpc{s($,l,I){return $.scheme===h.Schemas.file?new A.$JQ(I?.name||(0,R.$1g)(),$.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,l):super.s($,l,I)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$8pc=N}),define(Ee[339],Se([1,0,9,22,21,27,14,4,3,41,142,325,51]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Kbc=m,e.$Lbc=n,N=We(N);function b(O,L){try{return JSON.stringify(O,L)}catch{return"null"}}const c="$$ref$$",g={[c]:-1};class f{constructor(L,F){this.jsonString=L,this.referencedBuffers=F}}function m(O,L=null,F=!1){const j=[];return{jsonString:(F?b:JSON.stringify)(O,(M,z)=>{if(typeof z>"u")return g;if(typeof z=="object"){if(z instanceof h.$Ne){const _=j.push(z)-1;return{[c]:_}}if(L)return L(M,z)}return z}),referencedBuffers:j}}function n(O,L,F){return JSON.parse(O,(j,B)=>{if(B){const M=B[c];if(typeof M=="number")return L[M];if(F&&B.$mid===l.MarshalledId.Uri)return F.transformIncoming(B)}return B})}function o(O,L){return JSON.stringify(O,L)}function i(O){return O?(L,F)=>F&&F.$mid===l.MarshalledId.Uri?O.transformOutgoing(F):F:null}var t;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var s;(function(O){O[O.Responsive=0]="Responsive",O[O.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const d=()=>{},a=Symbol.for("rpcProtocol"),w=Symbol.for("rpcProxy");class y extends $.$Vc{static{k=a}static{this.a=3*1e3}constructor(L,F=null,j=null){super(),this[k]=!0,this.b=this.B(new T.$le),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=F,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,M=u.$Mw.count;B<M;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Qh(()=>this.H(),1e3)),this.B(this.c.onMessage(B=>this.L(B)))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const F=this.w[L];delete this.w[L],F.resolveErr(N.$7())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,I.$Ln)(L,this.g):L}getProxy(L){const{nid:F,sid:j}=L;return this.s[F]||(this.s[F]=this.J(F,j)),this.s[F]}J(L,F){const j={get:(B,M)=>(typeof M=="string"&&!B[M]&&M.charCodeAt(0)===R.CharCode.DollarSign&&(B[M]=(...z)=>this.U(L,M,z)),M===w?F:B[M])};return new Proxy(Object.create(null),j)}set(L,F){return this.m[L.nid]=F,F}assertRegistered(L){for(let F=0,j=L.length;F<j;F++){const B=L[F];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(L){if(this.j)return;const F=L.byteLength,j=D.read(L,0),B=j.readUInt8(),M=j.readUInt32();switch(B){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:z,method:_,args:re}=C.deserializeRequestJSONArgs(j);this.g&&(re=(0,I.$Ln)(re,this.g)),this.M(F,M,z,_,re,B===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:z,method:_,args:re}=C.deserializeRequestMixedArgs(j);this.g&&(re=(0,I.$Ln)(re,this.g)),this.M(F,M,z,_,re,B===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(F,M,t.LocalSide,"ack"),this.G(M);break}case p.Cancel:{this.N(F,M);break}case p.ReplyOKEmpty:{this.O(F,M,void 0);break}case p.ReplyOKJSON:{let z=C.deserializeReplyOKJSON(j);this.g&&(z=(0,I.$Ln)(z,this.g)),this.O(F,M,z);break}case p.ReplyOKJSONWithBuffers:{const z=C.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(F,M,z);break}case p.ReplyOKVSBuffer:{const z=C.deserializeReplyOKVSBuffer(j);this.O(F,M,z);break}case p.ReplyErrError:{let z=C.deserializeReplyErrError(j);this.g&&(z=(0,I.$Ln)(z,this.g)),this.P(F,M,z);break}case p.ReplyErrEmpty:{this.P(F,M,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,F,j,B,M,z){this.f?.logIncoming(L,F,t.OtherSide,`receiveRequest ${(0,u.$Ow)(j)}.${B}(`,M);const _=String(F);let re,U;if(z){const K=new A.$we;M.push(K.token),re=this.Q(j,B,M),U=()=>K.cancel()}else re=this.Q(j,B,M),U=d;this.u[_]=U;const G=C.serializeAcknowledged(F);this.f?.logOutgoing(G.byteLength,F,t.OtherSide,"ack"),this.c.send(G),re.then(K=>{delete this.u[_];const ee=C.serializeReplyOK(F,K,this.h);this.f?.logOutgoing(ee.byteLength,F,t.OtherSide,"reply:",K),this.c.send(ee)},K=>{delete this.u[_];const ee=C.serializeReplyErr(F,K);this.f?.logOutgoing(ee.byteLength,F,t.OtherSide,"replyErr:",K),this.c.send(ee)})}N(L,F){this.f?.logIncoming(L,F,t.OtherSide,"receiveCancel");const j=String(F);this.u[j]?.()}O(L,F,j){this.f?.logIncoming(L,F,t.LocalSide,"receiveReply:",j);const B=String(F);if(!this.w.hasOwnProperty(B))return;const M=this.w[B];delete this.w[B],M.resolveOk(j)}P(L,F,j){this.f?.logIncoming(L,F,t.LocalSide,"receiveReplyErr:",j);const B=String(F);if(!this.w.hasOwnProperty(B))return;const M=this.w[B];delete this.w[B];let z;j&&(j.$isError?(z=new Error,z.name=j.name,z.message=j.message,z.stack=j.stack):z=j),M.resolveErr(z)}Q(L,F,j){try{return Promise.resolve(this.S(L,F,j))}catch(B){return Promise.reject(B)}}S(L,F,j){const B=this.m[L];if(!B)throw new Error("Unknown actor "+(0,u.$Ow)(L));const M=B[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,u.$Ow)(L));return M.apply(B,j)}U(L,F,j){if(this.j)return new E.$Jbc;let B=null;if(j.length>0&&A.CancellationToken.isCancellationToken(j[j.length-1])&&(B=j.pop()),B&&B.isCancellationRequested)return Promise.reject(N.$7());const M=C.serializeRequestArguments(j,this.h),z=++this.t,_=String(z),re=new E.$Ibc,U=new $.$Uc;B&&U.add(B.onCancellationRequested(()=>{const K=C.serializeCancel(z);this.f?.logOutgoing(K.byteLength,z,t.LocalSide,"cancel"),this.c.send(C.serializeCancel(z))})),this.w[_]=new S(re,U),this.F(z);const G=C.serializeRequest(z,L,F,M,!!B);return this.f?.logOutgoing(G.byteLength,z,t.LocalSide,`request: ${(0,u.$Ow)(L)}.${F}(`,j),this.c.send(G),re}}e.$Mbc=y;class S{constructor(L,F){this.a=L,this.b=F}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class D{static alloc(L,F,j){const B=new D(h.$Ne.alloc(j+1+4),0);return B.writeUInt8(L),B.writeUInt32(F),B}static read(L,F){return new D(L,F)}get buffer(){return this.a}constructor(L,F){this.a=L,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+L).toString();return this.b+=L,j}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+L).toString();return this.b+=L,j}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+L);return this.b+=L,F}static sizeMixedArray(L){let F=0;F+=1;for(let j=0,B=L.length;j<B;j++){const M=L[j];switch(F+=1,M.type){case v.String:F+=this.sizeLongString(M.value);break;case v.VSBuffer:F+=this.sizeVSBuffer(M.value);break;case v.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let z=0;z<M.buffers.length;++z)F+=this.sizeVSBuffer(M.buffers[z]);break;case v.Undefined:break}}return F}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let F=0,j=L.length;F<j;F++){const B=L[F];switch(B.type){case v.String:this.writeUInt8(v.String),this.writeLongString(B.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(B.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let M=0;M<B.buffers.length;++M)this.writeBuffer(B.buffers[M]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const F=new Array(L);for(let j=0;j<L;j++)switch(this.readUInt8()){case v.String:F[j]=this.readLongString();break;case v.VSBuffer:F[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const M=this.readUInt32(),z=this.readLongString(),_=[];for(let re=0;re<M;++re)_.push(this.readVSBuffer());F[j]=new u.$Pw(n(z,_,null));break}case v.Undefined:F[j]=void 0;break}return F}}var P;(function(O){O[O.Simple=0]="Simple",O[O.Mixed=1]="Mixed"})(P||(P={}));class C{static a(L){for(let F=0,j=L.length;F<j;F++)if(L[F]instanceof h.$Ne||L[F]instanceof u.$Pw||typeof L[F]>"u")return!0;return!1}static serializeRequestArguments(L,F){if(this.a(L)){const j=[];for(let B=0,M=L.length;B<M;B++){const z=L[B];if(z instanceof h.$Ne)j[B]={type:v.VSBuffer,value:z};else if(typeof z>"u")j[B]={type:v.Undefined};else if(z instanceof u.$Pw){const{jsonString:_,referencedBuffers:re}=m(z.value,F);j[B]={type:v.SerializedObjectWithBuffers,value:h.$Ne.fromString(_),buffers:re}}else j[B]={type:v.String,value:h.$Ne.fromString(o(z,F))}}return{type:P.Mixed,args:j}}return{type:P.Simple,args:o(L,F)}}static serializeRequest(L,F,j,B,M){switch(B.type){case P.Simple:return this.b(L,F,j,B.args,M);case P.Mixed:return this.c(L,F,j,B.args,M)}}static b(L,F,j,B,M){const z=h.$Ne.fromString(j),_=h.$Ne.fromString(B);let re=0;re+=D.sizeUInt8(),re+=D.sizeShortString(z),re+=D.sizeLongString(_);const U=D.alloc(M?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,L,re);return U.writeUInt8(F),U.writeShortString(z),U.writeLongString(_),U.buffer}static deserializeRequestJSONArgs(L){const F=L.readUInt8(),j=L.readShortString(),B=L.readLongString();return{rpcId:F,method:j,args:JSON.parse(B)}}static c(L,F,j,B,M){const z=h.$Ne.fromString(j);let _=0;_+=D.sizeUInt8(),_+=D.sizeShortString(z),_+=D.sizeMixedArray(B);const re=D.alloc(M?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,L,_);return re.writeUInt8(F),re.writeShortString(z),re.writeMixedArray(B),re.buffer}static deserializeRequestMixedArgs(L){const F=L.readUInt8(),j=L.readShortString(),B=L.readMixedArray(),M=new Array(B.length);for(let z=0,_=B.length;z<_;z++){const re=B[z];typeof re=="string"?M[z]=JSON.parse(re):M[z]=re}return{rpcId:F,method:j,args:M}}static serializeAcknowledged(L){return D.alloc(p.Acknowledged,L,0).buffer}static serializeCancel(L){return D.alloc(p.Cancel,L,0).buffer}static serializeReplyOK(L,F,j){if(typeof F>"u")return this.d(L);if(F instanceof h.$Ne)return this.e(L,F);if(F instanceof u.$Pw){const{jsonString:B,referencedBuffers:M}=m(F.value,j,!0);return this.g(L,B,M)}else return this.f(L,b(F,j))}static d(L){return D.alloc(p.ReplyOKEmpty,L,0).buffer}static e(L,F){let j=0;j+=D.sizeVSBuffer(F);const B=D.alloc(p.ReplyOKVSBuffer,L,j);return B.writeVSBuffer(F),B.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,F){const j=h.$Ne.fromString(F);let B=0;B+=D.sizeLongString(j);const M=D.alloc(p.ReplyOKJSON,L,B);return M.writeLongString(j),M.buffer}static g(L,F,j){const B=h.$Ne.fromString(F);let M=0;M+=D.sizeUInt32,M+=D.sizeLongString(B);for(const _ of j)M+=D.sizeVSBuffer(_);const z=D.alloc(p.ReplyOKJSONWithBuffers,L,M);z.writeUInt32(j.length),z.writeLongString(B);for(const _ of j)z.writeBuffer(_);return z.buffer}static deserializeReplyOKJSON(L){const F=L.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(L,F){const j=L.readUInt32(),B=L.readLongString(),M=[];for(let z=0;z<j;++z)M.push(L.readVSBuffer());return new u.$Pw(n(B,M,F))}static serializeReplyErr(L,F){const j=F?b(N.$4(F),null):void 0;if(typeof j!="string")return this.h(L);const B=h.$Ne.fromString(j);let M=0;M+=D.sizeLongString(B);const z=D.alloc(p.ReplyErrError,L,M);return z.writeLongString(B),z.buffer}static deserializeReplyErrError(L){const F=L.readLongString();return JSON.parse(F)}static h(L){return D.alloc(p.ReplyErrEmpty,L,0).buffer}}var p;(function(O){O[O.RequestJSONArgs=1]="RequestJSONArgs",O[O.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",O[O.RequestMixedArgs=3]="RequestMixedArgs",O[O.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",O[O.Acknowledged=5]="Acknowledged",O[O.Cancel=6]="Cancel",O[O.ReplyOKEmpty=7]="ReplyOKEmpty",O[O.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",O[O.ReplyOKJSON=9]="ReplyOKJSON",O[O.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",O[O.ReplyErrError=11]="ReplyErrError",O[O.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(O){O[O.String=1]="String",O[O.VSBuffer=2]="VSBuffer",O[O.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",O[O.Undefined=4]="Undefined"})(v||(v={}))}),define(Ee[340],Se([1,0,22,29,15,89,5]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$KK=void 0,e.$LK=I,e.$MK=E,e.$KK=(0,N.$Ei)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),l=7;function I(k){if(k.scheme!==A.Schemas.vscodeNotebookCell)return;const b=k.fragment.indexOf("s");if(b<0)return;const c=parseInt(k.fragment.substring(0,b).replace($,""),l),g=(0,r.$7e)(k.fragment.substring(b+1)).toString();if(!isNaN(c))return{handle:c,notebook:k.with({scheme:g,fragment:null})}}function E(k,b){const c=b.toString(l),f=`${c.length<T.length?T[c.length-1]:"z"}${c}s${(0,r.$8e)(r.$Ne.fromString(k.scheme),!0,!0)}`;return k.with({scheme:A.Schemas.vscodeNotebookCell,fragment:f})}class u{constructor(){this.a=new h.$Bc}getNotebook(b){if(b.scheme===A.Schemas.vscodeNotebookCell){const c=I(b);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(b)}addNotebookDocument(b){this.a.set(b.uri,b)}removeNotebookDocument(b){this.a.delete(b.uri)}}e.$NK=u,(0,R.$Ks)(e.$KK,u,R.InstantiationType.Delayed)}),define(Ee[127],Se([1,0,22,39,40,108,15,16,11,36,340]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$5K=e.CellStatusbarAlignment=e.$4K=e.NotebookEditorPriority=e.$1K=e.$ZK=e.$XK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WK=e.$VK=e.$UK=e.$TK=e.CellKind=e.$SK=e.$RK=e.$QK=void 0,e.$YK=s,e.$2K=a,e.$3K=w,e.$6K=D,e.$7K=C,h=We(h),e.$QK="workbench.editor.notebook",e.$RK="workbench.editor.notebookTextDiffEditor",e.$SK="workbench.editor.interactive";var E;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(E||(e.CellKind=E={})),e.$TK=["application/json","application/javascript","text/html","image/svg+xml",R.$4s.latex,R.$4s.markdown,"image/png","image/jpeg",R.$4s.text],e.$UK=[R.$4s.latex,R.$4s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$4s.text],e.$VK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WK="_notAvailable";var u;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var k;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var b;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var c;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var f;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var m;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var n;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(z){z.scheme=N.Schemas.vscodeNotebookCell;function _(ue,ne){return(0,I.$MK)(ue,ne)}z.generate=_;function re(ue){return(0,I.$LK)(ue)}z.parse=re;function U(ue,ne){return ue.with({scheme:N.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${ue.scheme!==N.Schemas.file?ue.scheme:""}`})}z.generateCellOutputUri=U;function G(ue){if(ue.scheme!==N.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ue.fragment);if(!ne)return;const De=ne[1]&&ne[1]!==""?ne[1]:void 0,$e=ne[2];return{outputId:De,notebook:ue.with({scheme:$e||N.Schemas.file,fragment:null})}}z.parseCellOutputUri=G;function K(ue,ne,De){return z.generate(ue,ne).with({scheme:De})}z.generateCellPropertyUri=K;function ee(ue,ne){if(ue.scheme===ne)return z.parse(ue.with({scheme:z.scheme}))}z.parseCellPropertyUri=ee})(o||(e.CellUri=o={}));const i=z=>$.$i?z.replace(/\//g,"\\"):z;class t{constructor(_=[],re=e.$TK){this.e=re,this.d=[...new Set(_)].map(U=>({pattern:U,matches:h.$yk(i(U))}))}sort(_){const re=new Map(A.Iterable.map(_,G=>[G,i(G)]));let U=[];for(const{matches:G}of this.d)for(const[K,ee]of re)if(G(ee)){U.push(K),re.delete(K);break}return re.size&&(U=U.concat([...re.keys()].sort((G,K)=>this.e.indexOf(G)-this.e.indexOf(K)))),U}prioritize(_,re){const U=this.f(_);if(U===-1){this.d.unshift({pattern:_,matches:h.$yk(i(_))});return}const G=new Set(re.map(ee=>this.f(ee,U)));G.delete(-1);const K=Array.from(G).sort();this.d.splice(U+1,0,...K.map(ee=>this.d[ee]));for(let ee=K.length-1;ee>=0;ee--)this.d.splice(K[ee],1)}toArray(){return this.d.map(_=>_.pattern)}f(_,re=this.d.length){const U=i(_);for(let G=0;G<re;G++)if(this.d[G].matches(U))return G;return-1}}e.$XK=t;function s(z,_,re,U=(G,K)=>G===K){const G=[];function K(ne,De,$e){if(De===0&&$e.length===0)return;const J=G[G.length-1];J&&J.start+J.deleteCount===ne?(J.deleteCount+=De,J.toInsert.push(...$e)):G.push({start:ne,deleteCount:De,toInsert:$e})}let ee=0,ue=0;for(;;){if(ee===z.length){K(ee,0,_.slice(ue));break}if(ue===_.length){K(ee,z.length-ee,[]);break}const ne=z[ee],De=_[ue];if(U(ne,De)){ee+=1,ue+=1;continue}re(De)?(K(ee,1,[]),ee+=1):(K(ee,0,[De]),ue+=1)}return G}e.$ZK=new l.$Vj("notebookEditorCursorAtBoundary","none"),e.$1K=new l.$Vj("notebookEditorCursorAtLineBoundary","none");var d;(function(z){z.default="default",z.option="option"})(d||(e.NotebookEditorPriority=d={}));function a(z){const _=z;return!!((typeof _.include=="string"||h.$zk(_.include))&&(typeof _.exclude=="string"||h.$zk(_.exclude)))}function w(z,_,re){if(Array.isArray(z.viewType)&&z.viewType.indexOf(_)>=0||z.viewType===_)return!0;if(z.filenamePattern){const U=a(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,G=a(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(h.$xk(U,(0,T.$oc)(re.fsPath).toLowerCase()))return!(G&&h.$xk(G,(0,T.$oc)(re.fsPath).toLowerCase()))}return!1}e.$4K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class S{static{this.d="notebook/"}static create(_){return`${S.d}${_}`}static parse(_){if(_.startsWith(S.d))return _.substring(S.d.length)}}e.$5K=S;function D(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}const P=new TextDecoder;function C(z){const _=[];let re=!1;for(const ee of z)(_.length===0||re)&&(_.push(ee),re=!0);let U=O(_);const G=r.$Ne.concat(_.map(ee=>r.$Ne.wrap(ee))),K=M(G);return U=U||K.byteLength!==G.byteLength,{data:K,didCompression:U}}e.$8K="\x1B[A";const p=e.$8K.split("").map(z=>z.charCodeAt(0)),v=10;function O(z){let _=!1;return z.forEach((re,U)=>{if(U===0||re.length<e.$8K.length)return;const G=z[U-1],K=re.subarray(0,e.$8K.length);if(K[0]===p[0]&&K[1]===p[1]&&K[2]===p[2]){const ee=G.lastIndexOf(v);if(ee===-1)return;_=!0,z[U-1]=G.subarray(0,ee),z[U]=re.subarray(e.$8K.length)}}),_}function L(z){let _=z;do z=_,_=z.replace(/[^\n]\x08/gm,"");while(_.length<z.length);return z}function F(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const _=z.match(/^(.*)\r+/m)[1];let re=z.match(/\r+(.*)$/m)[1];re=re+_.slice(re.length,_.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return z}const j=8,B=13;function M(z){return!z.buffer.includes(j)&&!z.buffer.includes(B)?z:r.$Ne.fromString(F(L(P.decode(z.buffer))))}}),define(Ee[10],Se([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b){"use strict";var c,g,f,m,n,o,i,t,s,d,a,w,y,S,D,P,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$jP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$YO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LO=e.$KO=e.$JO=e.$IO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestRunProfileKind=e.TestResultState=e.$CO=e.$BO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AO=e.NotebookVariablesRequestKind=e.$zO=e.$yO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.ColorThemeKind=e.$rO=e.$qO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pO=e.$oO=e.DebugConsoleMode=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$iO=e.$hO=e.FileChangeType=e.$gO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$fO=e.$eO=e.$dO=e.$cO=e.InlineCompletionTriggerKind=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$2N=e.ConfigurationTarget=e.$1N=e.$ZN=e.$YN=e.$XN=e.DocumentPasteTriggerKind=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$QN=e.ViewBadge=e.ProgressLocation=e.$PN=e.$ON=e.TaskScope=e.ShellQuoting=e.$NN=e.$MN=e.$LN=e.TaskPanelKind=e.TaskRevealKind=e.$KN=e.TerminalLocation=e.$JN=e.$IN=e.$HN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$GN=e.$FN=e.$EN=e.$DN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$BN=e.$AN=e.$zN=e.$yN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$xN=e.$wN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.LanguageStatusSeverity=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.CodeActionTriggerKind=e.$kN=e.$jN=e.SymbolTag=e.SymbolKind=e.$iN=e.$hN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.DiagnosticSeverity=e.DiagnosticTag=e.$bN=e.$aN=e.FileEditType=e.$_M=e.$$M=e.$0M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$CN=_e,e.$3N=Li,e.$HO=Dn;function p(Y){return Object.assign(Y,{apply:function(...me){if(me.length===0)return Reflect.construct(Y,[]);{const Ne=me.length===1?[]:me[1];return Reflect.construct(Y,Ne,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(Y,[]);{const[Ne,...Xe]=me;return Reflect.construct(Y,Xe,Ne.constructor)}}})}var v;(function(Y){Y[Y.Top=0]="Top",Y[Y.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var O;(function(Y){Y[Y.TerminalCommand=0]="TerminalCommand",Y[Y.Opener=1]="Opener",Y[Y.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let L=c=class{static from(...H){let me=H;return new c(function(){if(me){for(const Ne of me)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$3M=L,e.$3M=L=c=Qe([p],L);let F=g=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Ne=1;Ne<H.length;Ne++){const Xe=H[Ne];Xe.isBefore(me)&&(me=Xe)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Ne=1;Ne<H.length;Ne++){const Xe=H[Ne];Xe.isAfter(me)&&(me=Xe)}return me}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:me,character:Ne}=H;return typeof me=="number"&&typeof Ne=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,h.$8)("line must be non-negative");if(me<0)throw(0,h.$8)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,h.$8)();let Ne;return typeof H>"u"?Ne=0:typeof H=="number"?Ne=H:(Ne=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Ne===0&&me===0?this:new g(this.line+Ne,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,h.$8)();let Ne;return typeof H>"u"?Ne=this.line:typeof H=="number"?Ne=H:(Ne=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Ne===this.line&&me===this.character?this:new g(Ne,me)}toJSON(){return{line:this.line,character:this.character}}};e.$4M=F,e.$4M=F=g=Qe([p],F);let j=f=class{static isRange(H){return H instanceof f?!0:H?F.isPosition(H.start)&&F.isPosition(H.end):!1}static of(H){if(H instanceof f)return H;if(this.isRange(H))return new f(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Ne,Xe){let st,pt;if(typeof H=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(st=new F(H,me),pt=new F(Ne,Xe)):F.isPosition(H)&&F.isPosition(me)&&(st=F.of(H),pt=F.of(me)),!st||!pt)throw new Error("Invalid arguments");st.isBefore(pt)?(this.c=st,this.e=pt):(this.c=pt,this.e=st)}contains(H){return f.isRange(H)?this.contains(H.start)&&this.contains(H.end):F.isPosition(H)?!(F.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=F.Max(H.start,this.c),Ne=F.Min(H.end,this.e);if(!me.isAfter(Ne))return new f(me,Ne)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=F.Min(H.start,this.c),Ne=F.Max(H.end,this.end);return new f(me,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,h.$8)();let Ne;return H?F.isPosition(H)?Ne=H:(Ne=H.start||this.start,me=H.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&me.isEqual(this.end)?this:new f(Ne,me)}toJSON(){return[this.start,this.end]}};e.$5M=j,e.$5M=j=f=Qe([p],j);let B=m=class extends j{static isSelection(H){return H instanceof m?!0:H?j.isRange(H)&&F.isPosition(H.anchor)&&F.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Ne,Xe){let st,pt;if(typeof H=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(st=new F(H,me),pt=new F(Ne,Xe)):F.isPosition(H)&&F.isPosition(me)&&(st=F.of(H),pt=F.of(me)),!st||!pt)throw new Error("Invalid arguments");super(st,pt),this.f=st,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6M=B,e.$6M=B=m=Qe([p],B);const M=Y=>{if(typeof Y!="string"||Y.length===0||!/^[0-9A-Za-z_\-]+$/.test(Y))throw(0,h.$8)("connectionToken")};class z{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Ne){if(typeof H!="string"||H.length===0)throw(0,h.$8)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$8)("port");typeof Ne<"u"&&M(Ne),this.host=H,this.port=Math.round(me),this.connectionToken=Ne}}e.$7M=z;class _{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&M(me)}}e.$8M=_;class re extends Error{static NotAvailable(H,me){return new re(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new re(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=k.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(H),this._message=H,this._code=me,this._detail=Ne,Object.setPrototypeOf(this,re.prototype)}}e.$9M=re;var U;(function(Y){Y[Y.LF=1]="LF",Y[Y.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var G;(function(Y){Y[Y.Replace=1]="Replace",Y[Y.Append=2]="Append",Y[Y.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let K=n=class{static isTextEdit(H){return H instanceof n?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new j(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new j(new F(0,0),new F(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$8)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$8)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$8)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0M=K,e.$0M=K=n=Qe([p],K);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?Ei.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new o(H,me)}static insertCells(H,me){return new o(new Ei(H,H),me)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,me){const Ne=new o(new Ei(H,H),[]);return Ne.newCellMetadata=me,Ne}static updateNotebookMetadata(H){const me=new o(new Ei(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$$M=ee,e.$$M=ee=o=Qe([p],ee);class ue{static isSnippetTextEdit(H){return H instanceof ue?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,me){return new ue(H,me)}static insert(H,me){return ue.replace(new j(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$_M=ue;var ne;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.Cell=3]="Cell",Y[Y.CellReplace=5]="CellReplace",Y[Y.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Ne,Xe){this.c.push({_type:ne.File,from:H,to:me,options:Ne,metadata:Xe})}createFile(H,me,Ne){this.c.push({_type:ne.File,from:void 0,to:H,options:me,metadata:Ne})}deleteFile(H,me,Ne){this.c.push({_type:ne.File,from:H,to:void 0,options:me,metadata:Ne})}e(H,me,Ne){this.c.push({_type:ne.Cell,metadata:Ne,uri:H,edit:{editType:b.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(H,me,Ne,Xe){const st=me.start,pt=me.end;(st!==pt||Ne.length>0)&&this.c.push({_type:ne.CellReplace,uri:H,index:st,count:pt-st,cells:Ne,metadata:Xe})}g(H,me,Ne,Xe){this.c.push({_type:ne.Cell,metadata:Xe,uri:H,edit:{editType:b.CellEditType.Metadata,index:me,metadata:Ne}})}replace(H,me,Ne,Xe){this.c.push({_type:ne.Text,uri:H,edit:new K(me,Ne),metadata:Xe})}insert(H,me,Ne,Xe){this.replace(H,new j(me,me),Ne,Xe)}delete(H,me,Ne){this.replace(H,me,"",Ne)}has(H){return this.c.some(me=>me._type===ne.Text&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Ne of me){if(!Ne)continue;let Xe,st;Array.isArray(Ne)?(Xe=Ne[0],st=Ne[1]):Xe=Ne,ee.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(H,Xe.range.start,Xe.newCellMetadata,st):Xe.newNotebookMetadata?this.e(H,Xe.newNotebookMetadata,st):this.f(H,Xe.range,Xe.newCells,st):ue.isSnippetTextEdit(Xe)?this.c.push({_type:ne.Snippet,uri:H,range:Xe.range,edit:Xe.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:H,edit:Xe,metadata:st})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Xe=this.c[Ne];switch(Xe._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Xe.uri.toString()===H.toString()&&(this.c[Ne]=void 0);break}}(0,r.$Jb)(this.c)}}get(H){const me=[];for(const Ne of this.c)Ne._type===ne.Text&&Ne.uri.toString()===H.toString()&&me.push(Ne.edit);return me}entries(){const H=new R.$Bc;for(const me of this.c)if(me._type===ne.Text){let Ne=H.get(me.uri);Ne||(Ne=[me.uri,[]],H.set(me.uri,Ne)),Ne[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aN=De,e.$aN=De=Qe([p],De);let $e=i=class{static isSnippetString(H){return H instanceof i?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=i.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Ne=new i;Ne.e=this.e,H(Ne),this.e=Ne.e,H=Ne.value}else H=i.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Ne=H.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Ne=new i;Ne.e=this.e,me(Ne),this.e=Ne.e,me=Ne.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$bN=$e,e.$bN=$e=i=Qe([p],$e);var J;(function(Y){Y[Y.Unnecessary=1]="Unnecessary",Y[Y.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var W;(function(Y){Y[Y.Hint=3]="Hint",Y[Y.Information=2]="Information",Y[Y.Warning=1]="Warning",Y[Y.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=t=class{static isLocation(H){return H instanceof t?!0:H?j.isRange(H.range)&&l.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(j.isRange(me))this.range=j.of(me);else if(F.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cN=se,e.$cN=se=t=Qe([p],se);let oe=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&l.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$dN=oe,e.$dN=oe=Qe([p],oe);let te=class{constructor(H,me,Ne=W.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Ne}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,r.$vb)(H.tags,me.tags)&&(0,r.$vb)(H.relatedInformation,me.relatedInformation,oe.isEqual)}};e.$eN=te,e.$eN=te=Qe([p],te);let le=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$fN=le,e.$fN=le=Qe([p],le);let he=class extends le{constructor(H,me,Ne,Xe){super(H,me),this.canIncreaseHover=Ne,this.canDecreaseHover=Xe}};e.$gN=he,e.$gN=he=Qe([p],he);var Z;(function(Y){Y[Y.Increase=0]="Increase",Y[Y.Decrease=1]="Decrease"})(Z||(e.HoverVerbosityAction=Z={}));var ae;(function(Y){Y[Y.Text=0]="Text",Y[Y.Read=1]="Read",Y[Y.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let pe=class{constructor(H,me=ae.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$hN=pe,e.$hN=pe=Qe([p],pe);let be=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$iN=be,e.$iN=be=Qe([p],be);var Me;(function(Y){Y[Y.File=0]="File",Y[Y.Module=1]="Module",Y[Y.Namespace=2]="Namespace",Y[Y.Package=3]="Package",Y[Y.Class=4]="Class",Y[Y.Method=5]="Method",Y[Y.Property=6]="Property",Y[Y.Field=7]="Field",Y[Y.Constructor=8]="Constructor",Y[Y.Enum=9]="Enum",Y[Y.Interface=10]="Interface",Y[Y.Function=11]="Function",Y[Y.Variable=12]="Variable",Y[Y.Constant=13]="Constant",Y[Y.String=14]="String",Y[Y.Number=15]="Number",Y[Y.Boolean=16]="Boolean",Y[Y.Array=17]="Array",Y[Y.Object=18]="Object",Y[Y.Key=19]="Key",Y[Y.Null=20]="Null",Y[Y.EnumMember=21]="EnumMember",Y[Y.Struct=22]="Struct",Y[Y.Event=23]="Event",Y[Y.Operator=24]="Operator",Y[Y.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var ze;(function(Y){Y[Y.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ke=s=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Ne,Xe,st){this.name=H,this.kind=me,this.containerName=st,typeof Ne=="string"&&(this.containerName=Ne),Xe instanceof se?this.location=Xe:Ne instanceof j&&(this.location=new se(Xe,Ne)),s.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$jN=ke,e.$jN=ke=s=Qe([p],ke);let Ie=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(d.validate)}constructor(H,me,Ne,Xe,st){this.name=H,this.detail=me,this.kind=Ne,this.range=Xe,this.selectionRange=st,this.children=[],d.validate(this)}};e.$kN=Ie,e.$kN=Ie=d=Qe([p],Ie);var Te;(function(Y){Y[Y.Invoke=1]="Invoke",Y[Y.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let V=class{constructor(H,me){this.title=H,this.kind=me}};e.$lN=V,e.$lN=V=Qe([p],V);let q=class{static{a=this}static{this.c="."}constructor(H){this.value=H}append(H){return new a(this.value?this.value+a.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+a.c)}};e.$mN=q,e.$mN=q=a=Qe([p],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let Q=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$nN=Q,e.$nN=Q=Qe([p],Q);class x{constructor(H,me,Ne,Xe,st,pt){this.kind=H,this.name=me,this.detail=Ne,this.uri=Xe,this.range=st,this.selectionRange=pt}}e.$oN=x;class fe{constructor(H,me){this.fromRanges=me,this.from=H}}e.$pN=fe;class we{constructor(H,me){this.fromRanges=me,this.to=H}}e.$qN=we;var Oe;(function(Y){Y[Y.Information=0]="Information",Y[Y.Warning=1]="Warning",Y[Y.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ge=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$rN=Ge,e.$rN=Ge=Qe([p],Ge);let Ke=w=class{#e;static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new A.$2k(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$sN=Ke,e.$sN=Ke=w=Qe([p],Ke);let tt=class{constructor(H,me){this.label=H,this.documentation=me}};e.$tN=tt,e.$tN=tt=Qe([p],tt);let rt=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$uN=rt,e.$uN=rt=Qe([p],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$vN=ot,e.$vN=ot=Qe([p],ot);var nt;(function(Y){Y[Y.Invoke=1]="Invoke",Y[Y.TriggerCharacter=2]="TriggerCharacter",Y[Y.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var ct;(function(Y){Y[Y.Type=1]="Type",Y[Y.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let $t=class{constructor(H){this.value=H}};e.$wN=$t,e.$wN=$t=Qe([p],$t);let ht=class{constructor(H,me,Ne){this.position=H,this.label=me,this.kind=Ne}};e.$xN=ht,e.$xN=ht=Qe([p],ht);var at;(function(Y){Y[Y.Invoke=0]="Invoke",Y[Y.TriggerCharacter=1]="TriggerCharacter",Y[Y.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Pe;(function(Y){Y[Y.Text=0]="Text",Y[Y.Method=1]="Method",Y[Y.Function=2]="Function",Y[Y.Constructor=3]="Constructor",Y[Y.Field=4]="Field",Y[Y.Variable=5]="Variable",Y[Y.Class=6]="Class",Y[Y.Interface=7]="Interface",Y[Y.Module=8]="Module",Y[Y.Property=9]="Property",Y[Y.Unit=10]="Unit",Y[Y.Value=11]="Value",Y[Y.Enum=12]="Enum",Y[Y.Keyword=13]="Keyword",Y[Y.Snippet=14]="Snippet",Y[Y.Color=15]="Color",Y[Y.File=16]="File",Y[Y.Reference=17]="Reference",Y[Y.Folder=18]="Folder",Y[Y.EnumMember=19]="EnumMember",Y[Y.Constant=20]="Constant",Y[Y.Struct=21]="Struct",Y[Y.Event=22]="Event",Y[Y.Operator=23]="Operator",Y[Y.TypeParameter=24]="TypeParameter",Y[Y.User=25]="User",Y[Y.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var Be;(function(Y){Y[Y.Deprecated=1]="Deprecated"})(Be||(e.CompletionItemTag=Be={}));let Ye=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$yN=Ye,e.$yN=Ye=Qe([p],Ye);let Le=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$zN=Le,e.$zN=Le=Qe([p],Le);let Fe=class{constructor(H,me,Ne){this.insertText=H,this.range=me,this.command=Ne}};e.$AN=Fe,e.$AN=Fe=Qe([p],Fe);let X=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$BN=X,e.$BN=X=Qe([p],X);var de;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.Word=1]="Word",Y[Y.Line=2]="Line",Y[Y.Suggest=3]="Suggest"})(de||(e.PartialAcceptTriggerKind=de={}));var Ce;(function(Y){Y[Y.Active=-1]="Active",Y[Y.Beside=-2]="Beside",Y[Y.One=1]="One",Y[Y.Two=2]="Two",Y[Y.Three=3]="Three",Y[Y.Four=4]="Four",Y[Y.Five=5]="Five",Y[Y.Six=6]="Six",Y[Y.Seven=7]="Seven",Y[Y.Eight=8]="Eight",Y[Y.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Ze;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(Ze||(e.StatusBarAlignment=Ze={}));function _e(Y,H){return`${E.$pn.toKey(Y)}.${H}`}var lt;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval"})(lt||(e.TextEditorLineNumbersStyle=lt={}));var ft;(function(Y){Y[Y.Manual=1]="Manual",Y[Y.AfterDelay=2]="AfterDelay",Y[Y.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var kt;(function(Y){Y[Y.Default=0]="Default",Y[Y.InCenter=1]="InCenter",Y[Y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Y[Y.AtTop=3]="AtTop"})(kt||(e.TextEditorRevealType=kt={}));var Tt;(function(Y){Y[Y.Keyboard=1]="Keyboard",Y[Y.Mouse=2]="Mouse",Y[Y.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ut;(function(Y){Y[Y.Undo=1]="Undo",Y[Y.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var ui;(function(Y){Y[Y.OpenOpen=0]="OpenOpen",Y[Y.ClosedClosed=1]="ClosedClosed",Y[Y.OpenClosed=2]="OpenClosed",Y[Y.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(Y){function H(me){switch(me){case"keyboard":return Y.Keyboard;case"mouse":return Y.Mouse;case"api":return Y.Command}}Y.fromValue=H}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var it;(function(Y){Y[Y.Other=0]="Other",Y[Y.Comment=1]="Comment",Y[Y.String=2]="String",Y[Y.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(Y){function H(me){switch(me){case Y.Other:return"other";case Y.Comment:return"comment";case Y.String:return"string";case Y.RegEx:return"regex"}return"other"}Y.toString=H}(it||(e.SyntaxTokenType=it={}));let Ct=class{constructor(H,me){if(me&&!l.URI.isUri(me))throw(0,h.$8)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$8)("range");this.range=H,this.target=me}};e.$DN=Ct,e.$DN=Ct=Qe([p],Ct);let Yt=class{constructor(H,me,Ne,Xe){this.red=H,this.green=me,this.blue=Ne,this.alpha=Xe}};e.$EN=Yt,e.$EN=Yt=Qe([p],Yt);let mt=class{constructor(H,me){if(me&&!(me instanceof Yt))throw(0,h.$8)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$8)("range");this.range=H,this.color=me}};e.$FN=mt,e.$FN=mt=Qe([p],mt);let bt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$8)("label");this.label=H}};e.$GN=bt,e.$GN=bt=Qe([p],bt);var hi;(function(Y){Y[Y.RGB=0]="RGB",Y[Y.HEX=1]="HEX",Y[Y.HSL=2]="HSL"})(hi||(e.ColorFormat=hi={}));var ei;(function(Y){Y[Y.Error=0]="Error",Y[Y.Warning=1]="Warning",Y[Y.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var Wt;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.Shutdown=1]="Shutdown",Y[Y.Process=2]="Process",Y[Y.User=3]="User",Y[Y.Extension=4]="Extension"})(Wt||(e.TerminalExitReason=Wt={}));var wt;(function(Y){Y[Y.Low=0]="Low",Y[Y.Medium=1]="Medium",Y[Y.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Vt{constructor(H,me,Ne){if(this.startIndex=H,this.length=me,this.tooltip=Ne,typeof H!="number"||H<0)throw(0,h.$8)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$8)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,h.$8)("tooltip")}}e.$HN=Vt;class Qt{constructor(H){this.uri=H}}e.$IN=Qt;class Zt{constructor(H){this.terminalCommand=H}}e.$JN=Zt;var xe;(function(Y){Y[Y.Panel=1]="Panel",Y[Y.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class $i{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$8)("options")}}e.$KN=$i;var ti;(function(Y){Y[Y.Always=1]="Always",Y[Y.Silent=2]="Silent",Y[Y.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var si;(function(Y){Y[Y.Shared=1]="Shared",Y[Y.Dedicated=2]="Dedicated",Y[Y.New=3]="New"})(si||(e.TaskPanelKind=si={}));let Dt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(H){switch(H){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,h.$8)("name");this.c=H}get id(){return this.c}};e.$LN=Dt,e.$LN=Dt=y=Qe([p],Dt);function Kt(Y){let H="";for(let me=0;me<Y.length;me++)H+=Y[me].replace(/,/g,",,")+",";return H}let Nt=class{constructor(H,me,Ne){if(typeof H!="string")throw(0,h.$8)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Ne):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$8)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return Kt(H)}};e.$MN=Nt,e.$MN=Nt=Qe([p],Nt);let Ft=class{constructor(H,me,Ne){if(this.f=[],Array.isArray(me)){if(!H)throw(0,h.$8)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$8)("command");this.e=H,this.f=me,this.g=Ne}else{if(typeof H!="string")throw(0,h.$8)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$8)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$8)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return Kt(H)}};e.$NN=Ft,e.$NN=Ft=Qe([p],Ft);var ii;(function(Y){Y[Y.Escape=1]="Escape",Y[Y.Strong=2]="Strong",Y[Y.Weak=3]="Weak"})(ii||(e.ShellQuoting=ii={}));var ni;(function(Y){Y[Y.Global=1]="Global",Y[Y.Workspace=2]="Workspace"})(ni||(e.TaskScope=ni={}));class oi{constructor(H){this.c=H}computeId(){return"customExecution"+(0,I.$1g)()}set callback(H){this.c=H}get callback(){return this.c}}e.$ON=oi;let qt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Ne,Xe,st,pt){this.k=!1,this.l=this.definition=H;let Et;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Ne,this.execution=Xe,Et=st,this.k=!0):me===ni.Global||me===ni.Workspace?(this.target=me,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=st,Et=pt):(this.target=me,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=st,Et=pt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,I.$1g)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$8)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$8)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(S.g===me||S.e===me||S.f===me||S.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$8)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$PN=qt,e.$PN=qt=S=Qe([p],qt);var Jt;(function(Y){Y[Y.SourceControl=1]="SourceControl",Y[Y.Window=10]="Window",Y[Y.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var di;(function(Y){function H(me){const Ne=me;return(0,$.$ig)(Ne.value)?Ne.tooltip&&!(0,$.$eg)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}Y.isViewBadge=H})(di||(e.ViewBadge=di={}));let jt=D=class{static isTreeItem(H,me){const Ne=H;if(Ne.checkboxState!==void 0){const Xe=(0,$.$ig)(Ne.checkboxState)?Ne.checkboxState:(0,$.$gg)(Ne.checkboxState)&&(0,$.$ig)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,st=!(0,$.$ig)(Ne.checkboxState)&&(0,$.$gg)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Pt.Checked&&Xe!==Pt.Unchecked||st!==void 0&&!(0,$.$eg)(st))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(H instanceof D)return!0;if(Ne.label!==void 0&&!(0,$.$eg)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,$.$eg)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,$.$eg)(Ne.iconPath)&&!l.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,$.$eg)(Ne.iconPath.id))){const Xe=Ne.iconPath;if(!Xe||!(0,$.$eg)(Xe.light)&&!l.URI.isUri(Xe.light)&&!(0,$.$eg)(Xe.dark)&&!l.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,$.$eg)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!l.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,$.$eg)(Ne.tooltip)&&!(Ne.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<vt.None&&Ne.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,$.$eg)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(H,me=vt.None){this.collapsibleState=me,l.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$QN=jt,e.$QN=jt=D=Qe([p],jt);var vt;(function(Y){Y[Y.None=0]="None",Y[Y.Collapsed=1]="Collapsed",Y[Y.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Pt;(function(Y){Y[Y.Unchecked=0]="Unchecked",Y[Y.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let Lt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$RN=Lt,e.$RN=Lt=Qe([p],Lt);class It extends Lt{}e.$SN=It;class Xt extends It{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$TN=Xt;class Ht{constructor(H,me,Ne,Xe){this.name=H,this.uri=me,this._itemId=Ne,this.c=Xe}data(){return this.c()}}e.$UN=Ht;let pi=class{#e=new Map;constructor(H){for(const[me,Ne]of H??[]){const Xe=this.#e.get(this.#t(me));Xe?Xe.push(Ne):this.#e.set(this.#t(me),[Ne])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Ne,Xe]of this.#e)for(const st of Xe)H.call(me,st,Ne,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Ne of me)yield[H,Ne]}#t(H){return H.toLowerCase()}};e.$VN=pi,e.$VN=pi=Qe([p],pi);let fi=class{constructor(H,me,Ne){this.insertText=H,this.title=me,this.kind=Ne}};e.$WN=fi,e.$WN=fi=Qe([p],fi);var Ai;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Ot{static{this.c="."}constructor(H){this.value=H}append(...H){return new Ot((this.value?[this.value,...H]:H).join(Ot.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+Ot.c)}}e.$XN=Ot,Ot.Empty=new Ot("");class Ti{constructor(H,me,Ne){this.title=me,this.insertText=H,this.kind=Ne}}e.$YN=Ti;let ai=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$ZN=ai,e.$ZN=ai=Qe([p],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Rt=class{constructor(H){this.id=H}};e.$1N=Rt,e.$1N=Rt=Qe([p],Rt);var Si;(function(Y){Y[Y.Global=1]="Global",Y[Y.Workspace=2]="Workspace",Y[Y.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Di=class{get base(){return this.c}set base(H){this.c=H,this.e=l.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!l.URI.isUri(H)&&!l.URI.isUri(H.uri)))throw(0,h.$8)("base");if(typeof me!="string")throw(0,h.$8)("pattern");typeof H=="string"?this.baseUri=l.URI.file(H):l.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$2N=Di,e.$2N=Di=Qe([p],Di);const vi=new WeakMap;function Li(Y,H){vi.set(Y,H)}let gi=class{constructor(H,me,Ne,Xe,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Xe=="string"&&(this.logMessage=Xe),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=vi.get(this)??(0,I.$1g)()),this.c}};e.$4N=gi,e.$4N=gi=Qe([p],gi);let Gt=class extends gi{constructor(H,me,Ne,Xe,st,pt){if(super(me,Ne,Xe,st,pt),H===null)throw(0,h.$8)("location");this.location=H}};e.$5N=Gt,e.$5N=Gt=Qe([p],Gt);let Ae=class extends gi{constructor(H,me,Ne,Xe,st,pt){super(me,Ne,Xe,st,pt),this.functionName=H}};e.$6N=Ae,e.$6N=Ae=Qe([p],Ae);let je=class extends gi{constructor(H,me,Ne,Xe,st,pt,Et,_t){if(super(Xe,st,pt,Et,_t),!me)throw(0,h.$8)("dataId");this.label=H,this.dataId=me,this.canPersist=Ne}};e.$7N=je,e.$7N=je=Qe([p],je);let ve=class{constructor(H,me,Ne){this.command=H,this.args=me||[],this.options=Ne}};e.$8N=ve,e.$8N=ve=Qe([p],ve);let ie=class{constructor(H,me){this.port=H,this.host=me}};e.$9N=ie,e.$9N=ie=Qe([p],ie);let Re=class{constructor(H){this.path=H}};e.$0N=Re,e.$0N=Re=Qe([p],Re);let He=class{constructor(H){this.implementation=H}};e.$$N=He,e.$$N=He=Qe([p],He);class et{constructor(H,me,Ne){this.session=H,this.threadId=me,this.frameId=Ne}}e.$_N=et;class Je{constructor(H,me){this.session=H,this.threadId=me}}e.$aO=Je;let gt=class{constructor(H,me){this.range=H,this.expression=me}};e.$bO=gt,e.$bO=gt=Qe([p],gt);var At;(function(Y){Y[Y.Invoke=0]="Invoke",Y[Y.Automatic=1]="Automatic"})(At||(e.InlineCompletionTriggerKind=At={}));let xt=class{constructor(H,me){this.range=H,this.text=me}};e.$cO=xt,e.$cO=xt=Qe([p],xt);let ci=class{constructor(H,me,Ne=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Ne}};e.$dO=ci,e.$dO=ci=Qe([p],ci);let Bt=class{constructor(H,me){this.range=H,this.expression=me}};e.$eO=Bt,e.$eO=Bt=Qe([p],Bt);let ri=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$fO=ri,e.$fO=ri=Qe([p],ri);var zi;(function(Y){Y[Y.AIGenerated=1]="AIGenerated"})(zi||(e.NewSymbolNameTag=zi={}));var Xi;(function(Y){Y[Y.Invoke=0]="Invoke",Y[Y.Automatic=1]="Automatic"})(Xi||(e.NewSymbolNameTriggerKind=Xi={}));class Ui{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$gO=Ui;var Oi;(function(Y){Y[Y.Changed=1]="Changed",Y[Y.Created=2]="Created",Y[Y.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Wi=P=class extends Error{static FileExists(H){return new P(H,u.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(H){return new P(H,u.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(H){return new P(H,u.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(H){return new P(H,u.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(H){return new P(H,u.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(H){return new P(H,u.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(H,me=u.FileSystemProviderErrorCode.Unknown,Ne){super(l.URI.isUri(H)?H.toString(!0):H),this.code=Ne?.name??"Unknown",(0,u.$nl)(this,me),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$hO=Wi,e.$hO=Wi=P=Qe([p],Wi);let Vi=class{constructor(H,me,Ne){this.start=H,this.end=me,this.kind=Ne}};e.$iO=Vi,e.$iO=Vi=Qe([p],Vi);var ki;(function(Y){Y[Y.Comment=1]="Comment",Y[Y.Imports=2]="Imports",Y[Y.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(Y){Y[Y.Collapsed=0]="Collapsed",Y[Y.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(Y){Y[Y.Editing=0]="Editing",Y[Y.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Mi;(function(Y){Y[Y.Published=0]="Published",Y[Y.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var en;(function(Y){Y[Y.Unresolved=0]="Unresolved",Y[Y.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(Y){Y[Y.Current=0]="Current",Y[Y.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class $n{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$jO=$n;function tn(Y){return typeof Y>"u"||(0,$.$fg)(Y)}class Gi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Ne=H.tokenTypes.length;me<Ne;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Ne=H.tokenModifiers.length;me<Ne;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Ne,Xe,st){if(typeof H=="number"&&typeof me=="number"&&typeof Ne=="number"&&typeof Xe=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Ne,Xe,st);if(j.isRange(H)&&typeof me=="string"&&tn(Ne))return this.o(H,me,Ne);throw(0,h.$8)()}o(H,me,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Xe=H.start.line,st=H.start.character,pt=H.end.character-H.start.character,Et=this.k.get(me);let _t=0;if(Ne)for(const mi of Ne){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(mi);_t|=1<<wi>>>0}this.q(Xe,st,pt,Et,_t)}q(H,me,Ne,Xe,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const _t=this.g.length/5|0;let mi=0,wi=0;for(let yi=0;yi<_t;yi++){let Ci=this.g[5*yi],Qi=this.g[5*yi+1];Ci===0?(Ci=mi,Qi+=wi):Ci+=mi,this.g[5*yi]=Ci,this.g[5*yi+1]=Qi,mi=Ci,wi=Qi}}let pt=H,Et=me;this.f&&this.j>0&&(pt-=this.c,pt===0&&(Et-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=Et,this.g[this.j++]=Ne,this.g[this.j++]=Xe,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Ne=H.length/5|0;for(let Et=0;Et<Ne;Et++)me[Et]=Et;me.sort((Et,_t)=>{const mi=H[5*Et],wi=H[5*_t];if(mi===wi){const yi=H[5*Et+1],Ci=H[5*_t+1];return yi-Ci}return mi-wi});const Xe=new Uint32Array(H.length);let st=0,pt=0;for(let Et=0;Et<Ne;Et++){const _t=5*me[Et],mi=H[_t+0],wi=H[_t+1],yi=H[_t+2],Ci=H[_t+3],Qi=H[_t+4],zn=mi-st,kr=zn===0?wi-pt:wi,Zi=5*Et;Xe[Zi+0]=zn,Xe[Zi+1]=kr,Xe[Zi+2]=yi,Xe[Zi+3]=Ci,Xe[Zi+4]=Qi,st=mi,pt=wi}return Xe}build(H){return this.f?new Ii(new Uint32Array(this.g),H):new Ii(Gi.r(this.g),H)}}e.$kO=Gi;class Ii{constructor(H,me){this.resultId=me,this.data=H}}e.$lO=Ii;class pn{constructor(H,me,Ne){this.start=H,this.deleteCount=me,this.data=Ne}}e.$mO=pn;class bn{constructor(H,me){this.resultId=me,this.edits=H}}e.$nO=bn;var nn;(function(Y){Y[Y.Separate=0]="Separate",Y[Y.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Hi{constructor(H){this.name=H}}e.$oO=Hi;let Fi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$pO=Fi,e.$pO=Fi=Qe([p],Fi);var Ve;(function(Y){Y[Y.Separator=-1]="Separator",Y[Y.Default=0]="Default"})(Ve||(e.QuickPickItemKind=Ve={}));var bi;(function(Y){Y[Y.Info=1]="Info",Y[Y.Warning=2]="Warning",Y[Y.Error=3]="Error"})(bi||(e.InputBoxValidationSeverity=bi={}));var Yi;(function(Y){Y[Y.UI=1]="UI",Y[Y.Workspace=2]="Workspace"})(Yi||(e.ExtensionKind=Yi={}));class ut{static validate(H){if(typeof H.badge=="string"){let me=(0,T.$Pf)(H.badge,0);if(me<H.badge.length&&(me+=(0,T.$Pf)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Ne){this.badge=H,this.tooltip=me,this.color=Ne}}e.$qO=ut;let yt=class{constructor(H){this.kind=H}};e.$rO=yt,e.$rO=yt=Qe([p],yt);var rn;(function(Y){Y[Y.Light=1]="Light",Y[Y.Dark=2]="Dark",Y[Y.HighContrast=3]="HighContrast",Y[Y.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class Ei{static isNotebookRange(H){return H instanceof Ei?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,h.$8)("start must be positive");if(me<0)throw(0,h.$8)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Ne=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Ne=H.end),me===this.c&&Ne===this.e?this:new Ei(me,Ne)}}e.$sO=Ei;class Ni{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>Ni.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Ne,Xe,st,pt,Et){this.kind=H,this.value=me,this.languageId=Ne,this.mime=Xe,this.outputs=st??[],this.metadata=pt,this.executionSummary=Et,Ni.validate(this)}}e.$tO=Ni;class wn{constructor(H){this.cells=H}}e.$uO=wn;class li{static isNotebookCellOutputItem(H){return H instanceof li?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return li.json(me,"application/vnd.code.notebook.error")}static stdout(H){return li.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return li.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new li(H,me)}static#e=new TextEncoder;static text(H,me=N.$4s.text){const Ne=li.#e.encode(String(H));return new li(Ne,me)}static json(H,me="text/x-json"){const Ne=JSON.stringify(H,void 0,"	");return li.text(Ne,me)}constructor(H,me){this.data=H,this.mime=me;const Ne=(0,N.$8s)(me,!0);if(!Ne)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$vO=li;class ji{static isNotebookCellOutput(H){return H instanceof ji?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Ne=new Set,Xe=new Set;for(let st=0;st<H.length;st++){const pt=H[st],Et=(0,N.$8s)(pt.mime);if(!Ne.has(Et)||(0,b.$6K)(Et)){Ne.add(Et);continue}Xe.add(st),me&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Xe.size===0?H:H.filter((st,pt)=>!Xe.has(pt))}constructor(H,me,Ne){this.items=ji.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Ne):(this.id=(0,I.$1g)(),this.metadata=me??Ne)}}e.$wO=ji;var sn;(function(Y){Y[Y.Markup=1]="Markup",Y[Y.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(Y){Y[Y.Idle=1]="Idle",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ki;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(Ki||(e.NotebookCellStatusBarAlignment=Ki={}));var an;(function(Y){Y[Y.Default=0]="Default",Y[Y.InCenter=1]="InCenter",Y[Y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Y[Y.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(H,me){this.text=H,this.alignment=me}}e.$xO=vn;var cn;(function(Y){Y[Y.Default=1]="Default",Y[Y.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var ln;(function(Y){Y[Y.Default=1]="Default",Y[Y.Preferred=2]="Preferred",Y[Y.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class En{constructor(H,me=[]){this.uri=H,this.provides=(0,r.$3b)(me)}}e.$yO=En;class yn{constructor(H){this.label=H}}e.$zO=yn;var un;(function(Y){Y[Y.Named=1]="Named",Y[Y.Indexed=2]="Indexed"})(un||(e.NotebookVariablesRequestKind=un={}));let Ji=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$AO=Ji,e.$AO=Ji=Qe([p],Ji);var hn;(function(Y){Y[Y.Production=1]="Production",Y[Y.Development=2]="Development",Y[Y.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(Y){Y[Y.Node=1]="Node",Y[Y.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(Y){Y[Y.Other=0]="Other",Y[Y.Comment=1]="Comment",Y[Y.String=2]="String",Y[Y.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ge{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$BO=ge;class ye{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$CO=ye;var Ue;(function(Y){Y[Y.Queued=1]="Queued",Y[Y.Running=2]="Running",Y[Y.Passed=3]="Passed",Y[Y.Failed=4]="Failed",Y[Y.Skipped=5]="Skipped",Y[Y.Errored=6]="Errored"})(Ue||(e.TestResultState=Ue={}));var dt;(function(Y){Y[Y.Run=1]="Run",Y[Y.Debug=2]="Debug",Y[Y.Coverage=3]="Coverage"})(dt||(e.TestRunProfileKind=dt={}));let St=class{constructor(H=void 0,me=void 0,Ne=void 0,Xe=!1,st=!0){this.include=H,this.exclude=me,this.profile=Ne,this.continuous=Xe,this.preserveFocus=st}};e.$DO=St,e.$DO=St=Qe([p],St);let Mt=C=class{static diff(H,me,Ne){const Xe=new C(H);return Xe.expectedOutput=me,Xe.actualOutput=Ne,Xe}constructor(H){this.message=H}};e.$EO=Mt,e.$EO=Mt=C=Qe([p],Mt);let Pi=class{constructor(H){this.id=H}};e.$FO=Pi,e.$FO=Pi=Qe([p],Pi);class Bi{constructor(H,me){this.covered=H,this.total=me,Dn(this)}}e.$GO=Bi;function Dn(Y){if(Y){if(Y.covered>Y.total)throw new Error(`The total number of covered items (${Y.covered}) cannot be greater than the total (${Y.total})`);if(Y.total<0)throw new Error(`The number of covered items (${Y.total}) cannot be negative`)}}class Sn{static fromDetails(H,me){const Ne=new Bi(0,0),Xe=new Bi(0,0),st=new Bi(0,0);for(const Et of me)if("branches"in Et){Ne.total+=1,Ne.covered+=Et.executed?1:0;for(const _t of Et.branches)Xe.total+=1,Xe.covered+=_t.executed?1:0}else st.total+=1,st.covered+=Et.executed?1:0;const pt=new Sn(H,Ne,Xe.total>0?Xe:void 0,st.total>0?st:void 0);return pt.detailedCoverage=me,pt}constructor(H,me,Ne,Xe,st){this.uri=H,this.statementCoverage=me,this.branchCoverage=Ne,this.declarationCoverage=Xe,this.testItem=st}}e.$IO=Sn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Ne=[]){this.executed=H,this.location=me,this.branches=Ne}}e.$JO=Vn;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Ne){this.executed=H,this.location=me,this.label=Ne}}e.$KO=qn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Ne){this.name=H,this.executed=me,this.location=Ne}}e.$LO=Gn;var kn;(function(Y){Y[Y.None=0]="None",Y[Y.Option=1]="Option",Y[Y.Default=2]="Default",Y[Y.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(Y){Y[Y.Untrusted=0]="Untrusted",Y[Y.Trusted=1]="Trusted",Y[Y.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(Y){Y[Y.Notify=1]="Notify",Y[Y.OpenBrowser=2]="OpenBrowser",Y[Y.OpenPreview=3]="OpenPreview",Y[Y.Silent=4]="Silent",Y[Y.Ignore=5]="Ignore",Y[Y.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(H,me,Ne,Xe,st,pt){this.kind=H,this.name=me,this.detail=Ne,this.uri=Xe,this.range=st,this.selectionRange=pt}}e.$MO=Hn;class Yn{constructor(H){this.uri=H}}e.$NO=Yn;class Kn{constructor(H,me){this.original=H,this.modified=me}}e.$OO=Kn;class Jn{constructor(H,me,Ne,Xe){this.base=H,this.input1=me,this.input2=Ne,this.result=Xe}}e.$PO=Jn;class Qn{constructor(H,me){this.uri=H,this.viewType=me}}e.$QO=Qn;class Zn{constructor(H){this.viewType=H}}e.$RO=Zn;class Xn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$SO=Xn;class xn{constructor(H,me,Ne){this.original=H,this.modified=me,this.notebookType=Ne}}e.$TO=xn;class _n{constructor(){}}e.$UO=_n;class er{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$VO=er;class tr{constructor(){}}e.$WO=tr;class ir{constructor(H){this.textDiffs=H}}e.$XO=ir;var Cn;(function(Y){Y[Y.Down=0]="Down",Y[Y.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(Y){Y[Y.Action=1]="Action",Y[Y.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(Y){Y[Y.Short=1]="Short",Y[Y.Medium=2]="Medium",Y[Y.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,me,Ne){this.id=H,this.label=me,this.values=Ne}}e.$YO=nr;var Tn;(function(Y){Y[Y.Unhelpful=0]="Unhelpful",Y[Y.Helpful=1]="Helpful",Y[Y.Undone=2]="Undone",Y[Y.Accepted=3]="Accepted",Y[Y.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Nn;(function(Y){Y[Y.Unhelpful=0]="Unhelpful",Y[Y.Helpful=1]="Helpful"})(Nn||(e.ChatResultFeedbackKind=Nn={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$ZO=rr;class sr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H,this.vulnerabilities=me}}e.$1O=sr;class or{constructor(H,me){this.participant=H,this.command=me}}e.$2O=or;class ar{constructor(H,me,Ne){this.title=H,this.message=me,this.data=Ne}}e.$3O=ar;class cr{constructor(H,me){this.value=H,this.baseUri=me}}e.$4O=cr;class lr{constructor(H,me){this.value=H,this.title=me}}e.$5O=lr;class ur{constructor(H){this.value=H}}e.$6O=ur;class hr{constructor(H,me){this.value=H,this.task=me}}e.$7O=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$8O=dr;class fr{constructor(H){this.value=H}}e.$9O=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$0O=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$$O=mr;class $r{constructor(H,me,Ne,Xe){this.prompt=H,this.command=me,this.references=Ne,this.participant=Xe}}e.$_O=$r;class pr{constructor(H,me,Ne,Xe){this.response=H,this.result=me,this.participant=Ne,this.command=Xe}}e.$aP=pr;var Ln;(function(Y){Y[Y.Panel=1]="Panel",Y[Y.Terminal=2]="Terminal",Y[Y.Notebook=3]="Notebook",Y[Y.Editor=4]="Editor"})(Ln||(e.ChatLocation=Ln={}));var gn;(function(Y){Y[Y.User=1]="User",Y[Y.Assistant=2]="Assistant",Y[Y.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(H,me,Ne){this.name=H,this.content=me,this.isError=Ne??!1}}e.$bP=br;class mn{static User(H,me){const Ne=new mn(gn.User,typeof H=="string"?H:"",me);return Ne.content2=H,Ne}static Assistant(H,me){return new mn(gn.Assistant,H,me)}constructor(H,me,Ne){this.role=H,this.content=me,this.content2=me,this.name=Ne}}e.$cP=mn;class wr{constructor(H,me){this.name=H,this.parameters=me}}e.$dP=wr;class vr{constructor(H){this.value=H}}e.$eP=vr;class Er{constructor(H){this.content=H}}e.$fP=Er;class yr{constructor(H,me){this.content=H,this.name=me}}e.$gP=yr;class Sr{constructor(H,me){this.content=H,this.name=me}}e.$hP=Sr;class Ri extends Error{static NotFound(H){return new Ri(H,Ri.NotFound.name)}static NoPermissions(H){return new Ri(H,Ri.NoPermissions.name)}static Blocked(H){return new Ri(H,Ri.Blocked.name)}constructor(H,me,Ne){super(H,{cause:Ne}),this.name="LanguageModelError",this.code=me??""}}e.$iP=Ri;var On;(function(Y){Y[Y.SymbolInformation=1]="SymbolInformation",Y[Y.CommandInformation=2]="CommandInformation",Y[Y.SearchInformation=3]="SearchInformation",Y[Y.SettingInformation=4]="SettingInformation"})(On||(e.RelatedInformationType=On={}));var Mn;(function(Y){Y[Y.Started=1]="Started",Y[Y.Recognizing=2]="Recognizing",Y[Y.Recognized=3]="Recognized",Y[Y.Stopped=4]="Stopped",Y[Y.Error=5]="Error"})(Mn||(e.SpeechToTextStatus=Mn={}));var Fn;(function(Y){Y[Y.Started=1]="Started",Y[Y.Stopped=2]="Stopped",Y[Y.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var jn;(function(Y){Y[Y.Recognized=1]="Recognized",Y[Y.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(H,me){this.text=H,this.range=me}}e.$jP=Dr;var Bn;(function(Y){Y[Y.Invoke=0]="Invoke",Y[Y.Automatic=1]="Automatic"})(Bn||(e.InlineEditTriggerKind=Bn={}))}),define(Ee[341],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class A{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(r.$1M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(N,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const l=this.a.get(N);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(T,$)??[]}getRelatedInformation(N,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(N,T,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiRelatedInformationProvider(l,T),new h.$3M(()=>{this.c.$unregisterAiRelatedInformationProvider(l),this.a.delete(l)})}}e.$_mc=A}),define(Ee[128],Se([1,0,4,6,10,24,155,5,20]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=e.$knc=void 0,e.$knc=(0,T.$Ei)("IExtHostAuthentication");let l=class{constructor(u){this.b=new Map,this.c=new r.$le,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=u.getProxy(h.$1M.MainThreadAuthentication)}async getSession(u,k,b,c={}){const g=R.$pn.toKey(u.identifier),f=[...b].sort().join(" ");return await this.d.getOrCreate(`${g} ${k} ${f}`,async()=>{await this.a.$ensureProvider(k);const m=u.displayName||u.name;return this.a.$getSession(k,b,g,m,c)})}async getSessions(u,k,b){const c=R.$pn.toKey(u.identifier),g=[...b].sort().join(" ");return await this.f.getOrCreate(`${c} ${g}`,async()=>{await this.a.$ensureProvider(k);const f=u.displayName||u.name;return this.a.$getSessions(k,b,c,f)})}async removeSession(u,k){const b=this.b.get(u);return b?b.provider.removeSession(k):this.a.$removeSession(u,k)}registerAuthenticationProvider(u,k,b,c){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:k,provider:b,options:c??{supportsMultipleAccounts:!1}});const g=b.onDidChangeSessions(f=>this.a.$sendDidChangeSessions(u,f));return this.a.$registerAuthenticationProvider(u,k,c?.supportsMultipleAccounts??!1),new A.$3M(()=>{g.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,k,b){const c=this.b.get(u);if(c)return await c.provider.createSession(k,b);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,k){const b=this.b.get(u);if(b)return await b.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,k){const b=this.b.get(u);if(b)return await b.provider.getSessions(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,k){return u.startsWith(N.$3L)||this.c.fire({provider:{id:u,label:k}}),Promise.resolve()}};e.$lnc=l,e.$lnc=l=Qe([qe(0,$.$uP)],l);class I{constructor(){this.a=new Map}getOrCreate(u,k){const b=this.a.get(u);if(b)return b;const c=k().finally(()=>this.a.delete(u));return this.a.set(u,c),c}}}),define(Ee[162],Se([1,0,2,6,10,5,20,12,19,13,16,26]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=e.$poc=void 0;let k=class{static{u=this}static{this.c=0}static{this.d=250}constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(h.$1M.MainThreadDecorations)}registerFileDecorationProvider(c,g){const f=u.c++;this.f.set(f,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(f,g.identifier.value);const m=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(f,null);return}const o=(0,$.$3b)(n);if(o.length<=u.d){this.g.$onDidChange(f,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,o.length);const i=o.map(d=>({uri:d,rank:(0,l.$if)(d.path,"/")})),t=(0,$.$Ab)(i,(d,a)=>d.rank-a.rank||(0,l.$yf)(d.uri.path,a.uri.path)),s=[];e:for(const d of t){let a;for(const w of d){const y=(0,I.$nc)(w.uri.path);if(a!==y&&(a=y,s.push(w.uri)>=u.d))break e}}this.g.$onDidChange(f,s)});return new A.$3M(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(f),this.f.delete(f)})}async $provideDecorations(c,g,f){if(!this.f.has(c))return Object.create(null);const m=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(c);return await Promise.all(g.map(async i=>{try{const{uri:t,id:s}=i,d=await Promise.resolve(n.provideFileDecoration(r.URI.revive(t),f));if(!d)return;try{A.$qO.validate(d),d.badge&&typeof d.badge!="string"&&(0,E.$4G)(o,"codiconDecoration"),m[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(a){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${a}`)}}catch(t){this.h.error(t)}})),m}};e.$poc=k,e.$poc=k=u=Qe([qe(0,N.$uP),qe(1,T.$$j)],k),e.$qoc=(0,R.$Ei)("IExtHostDecorations")}),define(Ee[342],Se([1,0,14,2,10,6,15,21,13]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0;class l{static{this.a=0}constructor(E,u,k){this.d=u,this.e=k,this.b=new Map,this.c=E.getProxy(R.$1M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(N.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const k=l.a++;this.b.set(k,u),this.c.$registerTextContentProvider(k,E);let b;if(typeof u.onDidChange=="function"){let c;b=u.onDidChange(async g=>{if(g.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const f=this.$provideTextDocumentContent(k,g).then(async m=>{if(!m&&typeof m!="string")return;const n=this.d.getDocument(g);if(!n)return;const o=(0,$.$sf)(m);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(g,m)}).catch(r.$2).finally(()=>{c===f&&(c=void 0)});c=f})}return new A.$3M(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(E,u){const k=this.b.get(E);return k?Promise.resolve(k.provideTextDocumentContent(h.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$soc=l}),define(Ee[163],Se([1,0,66,15,13,197,138,10,19]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$wP=I;const l=new Map;function I(b,c){c?l.set(b,c):l.delete(b)}function E(b){return l.get(b)}class u extends R.$hw{constructor(c,g,f,m,n,o,i){super(g,f,m,n),this.c=c,this.m=o,this.q=i,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$vb)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===h.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,f){return c.y(g,f)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,r.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,r.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const f=this.g,m=g.start.line,n=g.end.line,o=[];o.push(this.f[m].substring(g.start.character));for(let i=m+1;i<n;i++)o.push(this.f[i]);return o.push(this.f[n].substring(0,g.end.character)),o.join(f)}t(c){let g;if(c instanceof T.$4M?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new k(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),f=this.f[g.index].length;return new T.$4M(g.index,Math.min(g.remainder,f))}w(c){if(!(c instanceof T.$5M))throw new Error("Invalid argument");const g=this.x(c.start),f=this.x(c.end);return g===c.start&&f===c.end?c:new T.$5M(g.line,g.character,f.line,f.character)}x(c){if(!(c instanceof T.$4M))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:f}=c,m=!1;if(g<0)g=0,f=0,m=!0;else if(g>=this.f.length)g=this.f.length-1,f=this.f[g].length,m=!0;else{const n=this.f[g].length;f<0?(f=0,m=!0):f>n&&(f=n,m=!0)}return m?new T.$4M(g,f):c}y(c,g){const f=this.x(c);if(!g)g=E(this.m);else if((0,A.$rf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const m=(0,N.$jt)(f.character+1,(0,N.$ht)(g),this.f[f.line],0);if(m)return new T.$5M(f.line,m.startColumn-1,f.line,m.endColumn-1)}}e.$xP=u;class k{constructor(c,g,f){this.a=c,this.b=g,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$5M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$5M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$yP=k}),define(Ee[343],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;class A{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(r.$1M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(N,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const l=this.a.get(N);if(!l)throw new Error("Embedding vector provider not found");const I=await l.provideEmbeddingVector(T,$);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(N,T,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiEmbeddingVectorProvider(T,l),new h.$3M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(l),this.a.delete(l)})}}e.$voc=A}),define(Ee[76],Se([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$Anc=void 0,h=We(h);let b=k=class{constructor(g,f){this.b=new Map,this.c=new I.$Nh,this.a=g.getProxy(r.$1M.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(n){try{let o;const i=m.b.get(n.scheme);return i?(await m.a.$ensureActivation(n.scheme),o=await i.impl.stat(n)):o=await m.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){k.e(o)}},async readDirectory(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await m.a.$readdir(n)}catch(o){return k.e(o)}},async createDirectory(n){try{const o=m.b.get(n.scheme);return o&&!o.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(o.impl,o.extUri,n)):await m.a.$mkdir(n)}catch(o){return k.e(o)}},async readFile(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await m.a.$readFile(n)).buffer}catch(o){return k.e(o)}},async writeFile(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(i.impl,i.extUri,i.extUri.dirname(n)),await m.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await m.a.$writeFile(n,R.$Ne.wrap(o))}catch(i){return k.e(i)}},async delete(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly&&!o?.useTrash?(await m.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...o})):await m.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(i){return k.e(i)}},async rename(n,o,i){try{return await m.a.$rename(n,o,{overwrite:!1,...i})}catch(t){return k.e(t)}},async copy(n,o,i){try{return await m.a.$copy(n,o,{overwrite:!1,...i})}catch(t){return k.e(t)}},isWritableFileSystem(n){const o=f.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(g,f,m){const n=[];for(;!f.isEqual(m,f.dirname(m));)try{if(!((await g.stat(m)).type&h.FileType.Directory))throw A.$hO.FileExists(`Unable to create folder '${m.scheme===u.Schemas.file?m.fsPath:m.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$ol(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(f.basename(m)),m=f.dirname(m)}for(let o=n.length-1;o>=0;o--){m=f.joinPath(m,n[o]);try{await g.createDirectory(m)}catch(i){if(h.$ol(i)!==h.FileSystemProviderErrorCode.FileExists)throw i}}}static e(g){if(g instanceof A.$hO)throw g;if(g instanceof h.$kl)switch(g.code){case h.FileSystemProviderErrorCode.FileExists:throw A.$hO.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$hO.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$hO.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$hO.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$hO.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$hO.Unavailable(g.message);default:throw new A.$hO(g.message,g.name)}if(!(g instanceof Error))throw new A.$hO(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw A.$hO.Unavailable(g.message);switch(g.name){case h.FileSystemProviderErrorCode.FileExists:throw A.$hO.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$hO.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$hO.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$hO.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$hO.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$hO.Unavailable(g.message);default:throw new A.$hO(g.message,g.name)}}addFileSystemProvider(g,f,m){return this.b.set(g,{impl:f,extUri:m?.isCaseSensitive?E.$8g:E.$0g,isReadonly:!!m?.isReadonly}),(0,l.$Tc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??E.$8g}};e.$Anc=b,e.$Anc=b=k=Qe([qe(0,T.$uP),qe(1,$.$enc)],b),e.$Bnc=(0,N.$Ei)("IExtHostConsumerFileSystem")}),define(Ee[98],Se([1,0,5,30,12,76,2]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=e.$Cnc=void 0,e.$Cnc=(0,r.$Ei)("IExtensionStoragePaths");let T=class{constructor(l,I,E){this.d=I,this.f=E,this.a=l.workspace??void 0,this.b=l.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(l){return N.URI.joinPath(this.b.workspaceStorageHome,l)}async h(){if(!this.a)return Promise.resolve(void 0);const l=this.a.id,I=await this.g(l);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(N.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:N.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(l){if(this.c)return N.URI.joinPath(this.c,l.identifier.value)}globalValue(l){return N.URI.joinPath(this.b.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Dnc=T,e.$Dnc=T=Qe([qe(0,h.$KP),qe(1,A.$$j),qe(2,R.$Bnc)],T)}),define(Ee[344],Se([1,0,10,20,4]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;let R=class{constructor(T){this.a=new r.$rO(r.ColorThemeKind.Dark),this.b=new A.$le}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=r.ColorThemeKind.Light;break;case"hcDark":$=r.ColorThemeKind.HighContrast;break;case"hcLight":$=r.ColorThemeKind.HighContrastLight;break;default:$=r.ColorThemeKind.Dark}this.a=new r.$rO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$_oc=R,e.$_oc=R=Qe([qe(0,h.$uP)],R)}),define(Ee[77],Se([1,0,21,4,3,243,5,12,93,6,30,20,10]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Eb=e.$4Eb=e.TunnelDtoConverter=void 0,R=We(R),u=We(u);class k extends $.$Gw{}var b;(function(g){function f(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}g.fromApiTunnel=f;function m(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}g.fromServiceTunnel=m})(b||(e.TunnelDtoConverter=b={})),e.$4Eb=(0,N.$Ei)("IExtHostTunnelService");let c=class extends A.$Vc{constructor(f,m,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=f.getProxy(l.$1M.MainThreadTunnelService)}async openTunnel(f,m){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const n=await this.a.$openTunnel(m,f.displayName);if(n){const o=new k(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(f,m){f.portRange===void 0&&f.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:f,provider:m}),this.a.$registerPortsAttributesProvider(f,n),new u.$3M(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(f,m,n,o,i){const t=[];for(const d of f){const a=this.r.get(d);if(!a)return[];t.push(...await Promise.all(m.map(async w=>{let y;try{y=await a.provider.providePortAttributes({port:w,pid:n,commandLine:o},i)}catch{y=await a.provider.providePortAttributes(w,n,o,i)}return{providedAttributes:y,port:w}})))}const s=t.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(f){}registerTunnelProvider(f,m){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,i)=>await f.provideTunnel(o,i,r.CancellationToken.None)??void 0;const n=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,privacyOptions:m.tunnelFeatures?.privacyOptions,protocol:m.tunnelFeatures.protocol===void 0?!0:m.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(f,m){if(f){f.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this.f=f.showCandidatePort,this.a.$setCandidateFilter());const n=f.tunnelFactory??(m?this.w(m):void 0);if(n){this.b=n;let o=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,A.$Tc)(()=>{this.b=void 0})}w(f){}async $closeTunnel(f,m){if(this.g.has(f.host)){const n=this.g.get(f.host);n.has(f.port)&&(m&&n.get(f.port).disposeListener.dispose(),await n.get(f.port).tunnel.dispose(),n.delete(f.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(f,m){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(f,m);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(f.remoteAddress.host)||this.g.set(f.remoteAddress.host,new Map);const i=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:o,disposeListener:i}),b.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(f){const m=await Promise.all(f.map(o=>this.f(o.host,o.port,o.detail??""))),n=f.filter((o,i)=>m[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$5Eb=c,e.$5Eb=c=Qe([qe(0,E.$uP),qe(1,I.$KP),qe(2,T.$$j)],c)}),define(Ee[17],Se([1,0,19,22,186,80,86,29,176,57,108,25,181,23,50,18,2,114,31,106,88,54,145,90,154,152,306,322,120,127,74,75,318,10]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a,w,y,S,D,P,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$rP=ee,e.$sP=ne,e.$tP=De,N=We(N),m=We(m),n=We(n),o=We(o),y=We(y),D=We(D),v=We(v);var O;(function(Ae){function je(ie){const{selectionStartLineNumber:Re,selectionStartColumn:He,positionLineNumber:et,positionColumn:Je}=ie,gt=new v.$4M(Re-1,He-1),At=new v.$4M(et-1,Je-1);return new v.$6M(gt,At)}Ae.to=je;function ve(ie){const{anchor:Re,active:He}=ie;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Ae.from=ve})(O||(e.Selection=O={}));var L;(function(Ae){function je(ie){if(!ie)return;const{start:Re,end:He}=ie;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Ae.from=je;function ve(ie){if(!ie)return;const{startLineNumber:Re,startColumn:He,endLineNumber:et,endColumn:Je}=ie;return new v.$5M(Re-1,He-1,et-1,Je-1)}Ae.to=ve})(L||(e.Range=L={}));var F;(function(Ae){function je(ie){return{uri:ie.uri,range:L.from(ie.range)}}Ae.from=je;function ve(ie){return new v.$cN(g.URI.revive(ie.uri),L.to(ie.range))}Ae.to=ve})(F||(e.Location=F={}));var j;(function(Ae){function je(ve){switch(ve){case n.StandardTokenType.Comment:return v.StandardTokenType.Comment;case n.StandardTokenType.Other:return v.StandardTokenType.Other;case n.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case n.StandardTokenType.String:return v.StandardTokenType.String}}Ae.to=je})(j||(e.TokenType=j={}));var B;(function(Ae){function je(ie){return new v.$4M(ie.lineNumber-1,ie.column-1)}Ae.to=je;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=ve})(B||(e.Position=B={}));var M;(function(Ae){function je(Re,He,et){return(0,r.$Ib)((0,r.$3b)(Re).map(Je=>ve(Je,He,et)))}Ae.from=je;function ve(Re,He,et){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:et?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ie(Re.scheme,He),pattern:_e.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:et?.isBuiltin}}function ie(Re,He){return He&&typeof Re=="string"?He.transformOutgoingScheme(Re):Re}})(M||(e.DocumentSelector=M={}));var z;(function(Ae){function je(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case t.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(z||(e.DiagnosticTag=z={}));var _;(function(Ae){function je(ie){let Re;return ie.code&&((0,c.$eg)(ie.code)||(0,c.$ig)(ie.code)?Re=String(ie.code):Re={value:String(ie.code.value),target:ie.code.target}),{...L.from(ie.range),message:ie.message,source:ie.source,code:Re,severity:U.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,r.$Ib)(ie.tags.map(z.from)):void 0}}Ae.from=je;function ve(ie){const Re=new v.$eN(L.to(ie),ie.message,U.to(ie.severity));return Re.source=ie.source,Re.code=(0,c.$eg)(ie.code)?ie.code:ie.code?.value,Re.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Re.tags=ie.tags&&(0,r.$Ib)(ie.tags.map(z.to)),Re}Ae.to=ve})(_||(e.Diagnostic=_={}));var re;(function(Ae){function je(ie){return{...L.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=je;function ve(ie){return new v.$dN(new v.$cN(ie.resource,L.to(ie)),ie.message)}Ae.to=ve})(re||(e.DiagnosticRelatedInformation=re={}));var U;(function(Ae){function je(ie){switch(ie){case v.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ae.from=je;function ve(ie){switch(ie){case t.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ae.to=ve})(U||(e.DiagnosticSeverity=U={}));var G;(function(Ae){function je(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?p.$lE:p.$kE}Ae.from=je;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(G||(e.ViewColumn=G={}));function K(Ae){return typeof Ae.range<"u"}function ee(Ae){return Ae.length===0?!0:!!K(Ae[0])}var ue;(function(Ae){function je(Je){return Je.map(Ae.from)}Ae.fromMany=je;function ve(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let gt;if(ve(Je)){const{language:Bt,value:ri}=Je;gt={value:"```"+Bt+`
`+ri+"\n```\n"}}else v.$sN.isMarkdownString(Je)?gt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?gt={value:Je}:gt={value:""};const At=Object.create(null);gt.uris=At;const xt=Bt=>{try{let ri=g.URI.parse(Bt,!0);ri=ri.with({query:Re(ri.query,At)}),At[Bt]=ri}catch{}return""},ci=new $.marked.Renderer;return ci.link=xt,ci.image=Bt=>typeof Bt=="string"?xt(N.$0k(Bt).href):"",(0,$.marked)(gt.value,{renderer:ci}),gt}Ae.from=ie;function Re(Je,gt){if(!Je)return Je;let At;try{At=(0,l.$ai)(Je)}catch{}if(!At)return Je;let xt=!1;return At=(0,E.$do)(At,ci=>{if(g.URI.isUri(ci)){const Bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[Bt]=ci,xt=!0,Bt}else return}),xt?JSON.stringify(At):Je}function He(Je){const gt=new v.$sN(Je.value,Je.supportThemeIcons);return gt.isTrusted=Je.isTrusted,gt.supportHtml=Je.supportHtml,gt.baseUri=Je.baseUri?g.URI.from(Je.baseUri):void 0,gt}Ae.to=He;function et(Je){if(Je)return typeof Je=="string"?Je:Ae.from(Je)}Ae.fromStrict=et})(ue||(e.MarkdownString=ue={}));function ne(Ae){return ee(Ae)?Ae.map(je=>({range:L.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?ue.fromMany(je.hoverMessage):je.hoverMessage?ue.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ae.map(je=>({range:L.from(je)}))}function De(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?g.URI.file(Ae):Ae}var $e;(function(Ae){function je(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?De(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=je})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var J;(function(Ae){function je(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=je})(J||(e.ThemableDecorationRenderOptions=J={}));var W;(function(Ae){function je(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=je})(W||(e.DecorationRangeBehavior=W={}));var se;(function(Ae){function je(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?W.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?J.from(ve.light):void 0,dark:ve.dark?J.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=je})(se||(e.DecorationRenderOptions=se={}));var oe;(function(Ae){function je(ie){return{text:ie.newText,eol:ie.newEol&&Fe.from(ie.newEol),range:L.from(ie.range)}}Ae.from=je;function ve(ie){const Re=new v.$0M(L.to(ie.range),ie.text);return Re.newEol=typeof ie.eol>"u"?void 0:Fe.to(ie.eol),Re}Ae.to=ve})(oe||(e.TextEdit=oe={}));var te;(function(Ae){function je(ie,Re){const He={edits:[]};if(ie instanceof v.$aN){const et=new T.$Cc;for(const Je of ie._allEntries())Je._type===v.FileEditType.File&&g.URI.isUri(Je.to)&&Je.from===void 0&&et.add(Je.to);for(const Je of ie._allEntries())if(Je._type===v.FileEditType.File){let gt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?gt={type:"base64",value:(0,h.$8e)(h.$Ne.wrap(Je.options.contents))}:gt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:gt},metadata:Je.metadata})}else Je._type===v.FileEditType.Text?He.edits.push({resource:Je.uri,textEdit:oe.from(Je.edit),versionId:et.has(Je.uri)?void 0:Re?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Snippet?He.edits.push({resource:Je.uri,textEdit:{range:L.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:et.has(Je.uri)?void 0:Re?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===v.FileEditType.Cell?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Je.uri)}):Je._type===v.FileEditType.CellReplace&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:D.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(Ct.from)}})}return He}Ae.from=je;function ve(ie){const Re=new v.$aN,He=new T.$Bc;for(const et of ie.edits)if(et.textEdit){const Je=et,gt=g.URI.revive(Je.resource),At=L.to(Je.textEdit.range),xt=Je.textEdit.text,ci=Je.textEdit.insertAsSnippet;let Bt;ci?Bt=v.$_M.replace(At,new v.$bN(xt)):Bt=v.$0M.replace(At,xt);const ri=He.get(gt);ri?ri.push(Bt):He.set(gt,[Bt])}else Re.renameFile(g.URI.revive(et.oldResource),g.URI.revive(et.newResource),et.options);for(const[et,Je]of He)Re.set(et,Je);return Re}Ae.to=ve})(te||(e.WorkspaceEdit=te={}));var le;(function(Ae){const je=Object.create(null);je[v.SymbolKind.File]=o.SymbolKind.File,je[v.SymbolKind.Module]=o.SymbolKind.Module,je[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[v.SymbolKind.Package]=o.SymbolKind.Package,je[v.SymbolKind.Class]=o.SymbolKind.Class,je[v.SymbolKind.Method]=o.SymbolKind.Method,je[v.SymbolKind.Property]=o.SymbolKind.Property,je[v.SymbolKind.Field]=o.SymbolKind.Field,je[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[v.SymbolKind.Enum]=o.SymbolKind.Enum,je[v.SymbolKind.Interface]=o.SymbolKind.Interface,je[v.SymbolKind.Function]=o.SymbolKind.Function,je[v.SymbolKind.Variable]=o.SymbolKind.Variable,je[v.SymbolKind.Constant]=o.SymbolKind.Constant,je[v.SymbolKind.String]=o.SymbolKind.String,je[v.SymbolKind.Number]=o.SymbolKind.Number,je[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[v.SymbolKind.Array]=o.SymbolKind.Array,je[v.SymbolKind.Object]=o.SymbolKind.Object,je[v.SymbolKind.Key]=o.SymbolKind.Key,je[v.SymbolKind.Null]=o.SymbolKind.Null,je[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[v.SymbolKind.Struct]=o.SymbolKind.Struct,je[v.SymbolKind.Event]=o.SymbolKind.Event,je[v.SymbolKind.Operator]=o.SymbolKind.Operator,je[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Re){return typeof je[Re]=="number"?je[Re]:o.SymbolKind.Property}Ae.from=ve;function ie(Re){for(const He in je)if(je[He]===Re)return Number(He);return v.SymbolKind.Property}Ae.to=ie})(le||(e.SymbolKind=le={}));var he;(function(Ae){function je(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ae.to=ve})(he||(e.SymbolTag=he={}));var Z;(function(Ae){function je(ie){return{name:ie.name,kind:le.from(ie.kind),tags:ie.tags&&ie.tags.map(he.from),containerName:ie.containerName,location:ze.from(ie.location)}}Ae.from=je;function ve(ie){const Re=new v.$jN(ie.name,le.to(ie.kind),ie.containerName,ze.to(ie.location));return Re.tags=ie.tags&&ie.tags.map(he.to),Re}Ae.to=ve})(Z||(e.WorkspaceSymbol=Z={}));var ae;(function(Ae){function je(ie){const Re={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:L.from(ie.range),selectionRange:L.from(ie.selectionRange),kind:le.from(ie.kind),tags:ie.tags?.map(he.from)??[]};return ie.children&&(Re.children=ie.children.map(je)),Re}Ae.from=je;function ve(ie){const Re=new v.$kN(ie.name,ie.detail,le.to(ie.kind),L.to(ie.range),L.to(ie.selectionRange));return(0,r.$Mb)(ie.tags)&&(Re.tags=ie.tags.map(he.to)),ie.children&&(Re.children=ie.children.map(ve)),Re}Ae.to=ve})(ae||(e.DocumentSymbol=ae={}));var pe;(function(Ae){function je(ie){const Re=new v.$oN(le.to(ie.kind),ie.name,ie.detail||"",g.URI.revive(ie.uri),L.to(ie.range),L.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=je;function ve(ie,Re,He){if(Re=Re??ie._sessionId,He=He??ie._itemId,Re===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:He,name:ie.name,detail:ie.detail,kind:le.from(ie.kind),uri:ie.uri,range:L.from(ie.range),selectionRange:L.from(ie.selectionRange),tags:ie.tags?.map(he.from)}}Ae.from=ve})(pe||(e.CallHierarchyItem=pe={}));var be;(function(Ae){function je(ve){return new v.$pN(pe.to(ve.from),ve.fromRanges.map(ie=>L.to(ie)))}Ae.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Me;(function(Ae){function je(ve){return new v.$qN(pe.to(ve.to),ve.fromRanges.map(ie=>L.to(ie)))}Ae.to=je})(Me||(e.CallHierarchyOutgoingCall=Me={}));var ze;(function(Ae){function je(ie){return{range:ie.range&&L.from(ie.range),uri:ie.uri}}Ae.from=je;function ve(ie){return new v.$cN(g.URI.revive(ie.uri),L.to(ie.range))}Ae.to=ve})(ze||(e.location=ze={}));var ke;(function(Ae){function je(ie){const Re=ie,He=ie;return{originSelectionRange:Re.originSelectionRange?L.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:He.uri,range:L.from(Re.targetRange?Re.targetRange:He.range),targetSelectionRange:Re.targetSelectionRange?L.from(Re.targetSelectionRange):void 0}}Ae.from=je;function ve(ie){return{targetUri:g.URI.revive(ie.uri),targetRange:L.to(ie.range),targetSelectionRange:ie.targetSelectionRange?L.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?L.to(ie.originSelectionRange):void 0}}Ae.to=ve})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Ae){function je(ie){return{range:L.from(ie.range),contents:ue.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ae.from=je;function ve(ie){const Re=ie.contents.map(ue.to),He=L.to(ie.range),et=ie.canIncreaseVerbosity,Je=ie.canDecreaseVerbosity;return new v.$gN(Re,He,et,Je)}Ae.to=ve})(Ie||(e.Hover=Ie={}));var Te;(function(Ae){function je(ie){return{range:L.from(ie.range),expression:ie.expression}}Ae.from=je;function ve(ie){return new v.$bO(L.to(ie.range),ie.expression)}Ae.to=ve})(Te||(e.EvaluatableExpression=Te={}));var V;(function(Ae){function je(ie){if(ie instanceof v.$cO)return{type:"text",range:L.from(ie.range),text:ie.text};if(ie instanceof v.$dO)return{type:"variable",range:L.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$eO)return{type:"expression",range:L.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=je;function ve(ie){switch(ie.type){case"text":return{range:L.to(ie.range),text:ie.text};case"variable":return{range:L.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:L.to(ie.range),expression:ie.expression}}}Ae.to=ve})(V||(e.InlineValue=V={}));var q;(function(Ae){function je(ie){return{frameId:ie.frameId,stoppedLocation:L.from(ie.stoppedLocation)}}Ae.from=je;function ve(ie){return new v.$fO(ie.frameId,L.to(ie.stoppedLocation))}Ae.to=ve})(q||(e.InlineValueContext=q={}));var Q;(function(Ae){function je(ie){return{range:L.from(ie.range),kind:ie.kind}}Ae.from=je;function ve(ie){return new v.$hN(L.to(ie.range),ie.kind)}Ae.to=ve})(Q||(e.DocumentHighlight=Q={}));var x;(function(Ae){function je(ie){return{uri:ie.uri,highlights:ie.highlights.map(Q.from)}}Ae.from=je;function ve(ie){return new v.$iN(g.URI.revive(ie.uri),ie.highlights.map(Q.to))}Ae.to=ve})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Ae){function je(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ae.to=je})(fe||(e.CompletionTriggerKind=fe={}));var we;(function(Ae){function je(ve){return{triggerKind:fe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=je})(we||(e.CompletionContext=we={}));var Oe;(function(Ae){function je(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ae.to=ve})(Oe||(e.CompletionItemTag=Oe={}));var Ge;(function(Ae){const je=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(He){return je.get(He)??o.CompletionItemKind.Property}Ae.from=ve;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(He){return ie.get(He)??v.CompletionItemKind.Property}Ae.to=Re})(Ge||(e.CompletionItemKind=Ge={}));var Ke;(function(Ae){function je(ve,ie){const Re=new v.$yN(ve.label);return Re.insertText=ve.insertText,Re.kind=Ge.to(ve.kind),Re.tags=ve.tags?.map(Oe.to),Re.detail=ve.detail,Re.documentation=N.$4k(ve.documentation)?ue.to(ve.documentation):ve.documentation,Re.sortText=ve.sortText,Re.filterText=ve.filterText,Re.preselect=ve.preselect,Re.commitCharacters=ve.commitCharacters,m.$Ht.isIRange(ve.range)?Re.range=L.to(ve.range):typeof ve.range=="object"&&(Re.range={inserting:L.to(ve.range.insert),replacing:L.to(ve.range.replace)}),Re.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$bN(ve.insertText):(Re.insertText=ve.insertText,Re.textEdit=Re.range instanceof v.$5M?new v.$0M(Re.range,Re.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Re.additionalTextEdits=ve.additionalTextEdits.map(He=>oe.to(He))),Re.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Re}Ae.to=je})(Ke||(e.CompletionItem=Ke={}));var tt;(function(Ae){function je(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ue.fromStrict(ie.documentation)}}Ae.from=je;function ve(ie){return{label:ie.label,documentation:N.$4k(ie.documentation)?ue.to(ie.documentation):ie.documentation}}Ae.to=ve})(tt||(e.ParameterInformation=tt={}));var rt;(function(Ae){function je(ie){return{label:ie.label,documentation:ue.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.from):[],activeParameter:ie.activeParameter}}Ae.from=je;function ve(ie){return{label:ie.label,documentation:N.$4k(ie.documentation)?ue.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.to):[],activeParameter:ie.activeParameter}}Ae.to=ve})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ae){function je(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ae.from=je;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ae.to=ve})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ae){function je(ve,ie){const Re=new v.$xN(B.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ct.to.bind(void 0,ve)),ie.kind&&$t.to(ie.kind));return Re.textEdits=ie.textEdits&&ie.textEdits.map(oe.to),Re.tooltip=N.$4k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,Re.paddingLeft=ie.paddingLeft,Re.paddingRight=ie.paddingRight,Re}Ae.to=je})(nt||(e.InlayHint=nt={}));var ct;(function(Ae){function je(ve,ie){const Re=new v.$wN(ie.label);return Re.tooltip=N.$4k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Re.command=ve.fromInternal(ie.command)),ie.location&&(Re.location=ze.to(ie.location)),Re}Ae.to=je})(ct||(e.InlayHintLabelPart=ct={}));var $t;(function(Ae){function je(ie){return ie}Ae.from=je;function ve(ie){return ie}Ae.to=ve})($t||(e.InlayHintKind=$t={}));var ht;(function(Ae){function je(ie){return{range:L.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=je;function ve(ie){let Re;if(ie.url)try{Re=typeof ie.url=="string"?g.URI.parse(ie.url,!0):g.URI.revive(ie.url)}catch{}const He=new v.$DN(L.to(ie.range),Re);return He.tooltip=ie.tooltip,He}Ae.to=ve})(ht||(e.DocumentLink=ht={}));var at;(function(Ae){function je(ie){const Re=new v.$GN(ie.label);return ie.textEdit&&(Re.textEdit=oe.to(ie.textEdit)),ie.additionalTextEdits&&(Re.additionalTextEdits=ie.additionalTextEdits.map(He=>oe.to(He))),Re}Ae.to=je;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?oe.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Re=>oe.from(Re)):void 0}}Ae.from=ve})(at||(e.ColorPresentation=at={}));var Pe;(function(Ae){function je(ie){return new v.$EN(ie[0],ie[1],ie[2],ie[3])}Ae.to=je;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=ve})(Pe||(e.Color=Pe={}));var Be;(function(Ae){function je(ie){return{range:L.from(ie.range)}}Ae.from=je;function ve(ie){return new v.$nN(L.to(ie.range))}Ae.to=ve})(Be||(e.SelectionRange=Be={}));var Ye;(function(Ae){function je(ve){switch(ve){case a.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case a.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case a.SaveReason.FOCUS_CHANGE:case a.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ae.to=je})(Ye||(e.TextDocumentSaveReason=Ye={}));var Le;(function(Ae){function je(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return f.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return f.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return f.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return f.RenderLineNumbersType.On}}Ae.from=je;function ve(ie){switch(ie){case f.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case f.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case f.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case f.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Le||(e.TextEditorLineNumbersStyle=Le={}));var Fe;(function(Ae){function je(ie){if(ie===v.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return i.EndOfLineSequence.LF}Ae.from=je;function ve(ie){if(ie===i.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===i.EndOfLineSequence.LF)return v.EndOfLine.LF}Ae.to=ve})(Fe||(e.EndOfLine=Fe={}));var X;(function(Ae){function je(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case v.ProgressLocation.Window:return s.ProgressLocation.Window;case v.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=je})(X||(e.ProgressLocation=X={}));var de;(function(Ae){function je(ie){const Re={start:ie.start+1,end:ie.end+1};return ie.kind&&(Re.kind=Ce.from(ie.kind)),Re}Ae.from=je;function ve(ie){const Re={start:ie.start-1,end:ie.end-1};return ie.kind&&(Re.kind=Ce.to(ie.kind)),Re}Ae.to=ve})(de||(e.FoldingRange=de={}));var Ce;(function(Ae){function je(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Hu.Comment;case v.FoldingRangeKind.Imports:return o.$Hu.Imports;case v.FoldingRangeKind.Region:return o.$Hu.Region}}Ae.from=je;function ve(ie){if(ie)switch(ie.value){case o.$Hu.Comment.value:return v.FoldingRangeKind.Comment;case o.$Hu.Imports.value:return v.FoldingRangeKind.Imports;case o.$Hu.Region.value:return v.FoldingRangeKind.Region}}Ae.to=ve})(Ce||(e.FoldingRangeKind=Ce={}));var Ze;(function(Ae){function je(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?L.from(ve.selection):void 0,override:typeof ve.override=="boolean"?a.$OF.id:void 0}}Ae.from=je})(Ze||(e.TextEditorOpenOptions=Ze={}));var _e;(function(Ae){function je(He){return He instanceof v.$2N?He.toJSON():typeof He=="string"?He:ve(He)||ie(He)?new v.$2N(He.baseUri??He.base,He.pattern).toJSON():He}Ae.from=je;function ve(He){const et=He;return et?g.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ie(He){const et=He;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Re(He){return typeof He=="string"?He:new v.$2N(g.URI.revive(He.baseUri),He.pattern)}Ae.to=Re})(_e||(e.GlobPattern=_e={}));var lt;(function(Ae){function je(ve){if(ve){if(Array.isArray(ve))return ve.map(je);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:_e.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=je})(lt||(e.LanguageSelector=lt={}));var ft;(function(Ae){function je(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Re=>Array.isArray(Re)&&Re.every(He=>He&&typeof He=="object"&&"uri"in He&&g.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(et=>et instanceof v.$5M)))}Ae.is=je;function ve(ie){return{documents:ie.documents.map(Re=>Re.map(He=>({uri:g.URI.from(He.uri),version:He.version,ranges:He.ranges.map(et=>L.from(et))})))}}Ae.from=ve})(ft||(e.MappedEditsContext=ft={}));var kt;(function(Ae){function je(ie){return{start:ie.start,end:ie.end}}Ae.from=je;function ve(ie){return new v.$sO(ie.start,ie.end)}Ae.to=ve})(kt||(e.NotebookRange=kt={}));var Tt;(function(Ae){function je(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=je;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=ve})(Tt||(e.NotebookCellExecutionSummary=Tt={}));var Ut;(function(Ae){function je(ve){if(ve===D.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===D.NotebookCellExecutionState.Pending)return;if(ve===D.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=je})(Ut||(e.NotebookCellExecutionState=Ut={}));var ui;(function(Ae){function je(ie){switch(ie){case v.NotebookCellKind.Markup:return D.CellKind.Markup;case v.NotebookCellKind.Code:default:return D.CellKind.Code}}Ae.from=je;function ve(ie){switch(ie){case D.CellKind.Markup:return v.NotebookCellKind.Markup;case D.CellKind.Code:default:return v.NotebookCellKind.Code}}Ae.to=ve})(ui||(e.NotebookCellKind=ui={}));var it;(function(Ae){function je(ie){const Re={metadata:ie.metadata??Object.create(null),cells:[]};for(const He of ie.cells)v.$tO.validate(He),Re.cells.push(Ct.from(He));return Re}Ae.from=je;function ve(ie){const Re=new v.$uO(ie.cells.map(Ct.to));return(0,c.$rg)(ie.metadata)||(Re.metadata=ie.metadata),Re}Ae.to=ve})(it||(e.NotebookData=it={}));var Ct;(function(Ae){function je(ie){return{cellKind:ui.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Tt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(mt.from):[]}}Ae.from=je;function ve(ie){return new v.$tO(ui.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(mt.to):void 0,ie.metadata,ie.internalMetadata?Tt.to(ie.internalMetadata):void 0)}Ae.to=ve})(Ct||(e.NotebookCellData=Ct={}));var Yt;(function(Ae){function je(ie){return{mime:ie.mime,valueBytes:h.$Ne.wrap(ie.data)}}Ae.from=je;function ve(ie){return new v.$vO(ie.valueBytes.buffer,ie.mime)}Ae.to=ve})(Yt||(e.NotebookCellOutputItem=Yt={}));var mt;(function(Ae){function je(ie){return{outputId:ie.id,items:ie.items.map(Yt.from),metadata:ie.metadata}}Ae.from=je;function ve(ie){const Re=ie.items.map(Yt.to);return new v.$wO(Re,ie.outputId,ie.metadata)}Ae.to=ve})(mt||(e.NotebookCellOutput=mt={}));var bt;(function(Ae){function je(Re){return ie(Re)?{include:_e.from(Re.include)??void 0,exclude:_e.from(Re.exclude)??void 0}:_e.from(Re)??void 0}Ae.from=je;function ve(Re){return ie(Re)?{include:_e.to(Re.include),exclude:_e.to(Re.exclude)}:_e.to(Re)}Ae.to=ve;function ie(Re){const He=Re;return He?!(0,c.$ng)(He.include)&&!(0,c.$ng)(He.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var hi;(function(Ae){function je(ve,ie,Re){const He=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?D.CellStatusbarAlignment.Left:D.CellStatusbarAlignment.Right,command:ie.toInternal(He,Re),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=je})(hi||(e.NotebookStatusBarItem=hi={}));var ei;(function(Ae){function je(ve,ie,Re){const He=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(He,Re),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=je})(ei||(e.NotebookKernelSourceAction=ei={}));var Wt;(function(Ae){function je(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=je})(Wt||(e.NotebookDocumentContentOptions=Wt={}));var wt;(function(Ae){function je(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=je;function ve(ie){return new v.$yO(g.URI.revive(ie.uri),ie.provides)}Ae.to=ve})(wt||(e.NotebookRendererScript=wt={}));var Vt;(function(Ae){function je(ie){return{message:ue.fromStrict(ie.message)||"",type:C.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:L.from(ie.location.range),uri:ie.location.uri}}}Ae.from=je;function ve(ie){const Re=new v.$EO(typeof ie.message=="string"?ie.message:ue.to(ie.message));return Re.actualOutput=ie.actual,Re.expectedOutput=ie.expected,Re.contextValue=ie.contextValue,Re.location=ie.location?ze.to(ie.location):void 0,Re}Ae.to=ve})(Vt||(e.TestMessage=Vt={}));var Qt;(function(Ae){Ae.namespace=C.$TI,Ae.denamespace=C.$UI})(Qt||(e.TestTag=Qt={}));var Zt;(function(Ae){function je(ie){const Re=(0,d.$qP)(ie).controllerId;return{extId:P.$OI.fromExtHostTestItem(ie,Re).toString(),label:ie.label,uri:g.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(He=>Qt.namespace(Re,He.id)),range:m.$Ht.lift(L.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ue.fromStrict(ie.error)||null}}Ae.from=je;function ve(ie){return{parent:void 0,error:void 0,id:P.$OI.fromString(ie.extId).localId,label:ie.label,uri:g.URI.revive(ie.uri),tags:(ie.tags||[]).map(Re=>{const{tagId:He}=Qt.denamespace(Re);return new v.$FO(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=ve})(Zt||(e.TestItem=Zt={})),function(Ae){function je(ie){return{id:ie.id}}Ae.from=je;function ve(ie){return new v.$FO(ie.id)}Ae.to=ve}(Qt||(e.TestTag=Qt={}));var xe;(function(Ae){const je=(ie,Re)=>{const He=ie.value;if(!He)return;const et={...Zt.toPlain(He.item),parent:Re,taskStates:He.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(gt=>gt.type===C.TestMessageType.Error).map(Vt.to)})),children:[]};if(ie.children)for(const Je of ie.children.values()){const gt=je(Je,et);gt&&et.children.push(gt)}return et};function ve(ie){const Re=new u.$NI;for(const Je of ie.items)Re.insert(P.$OI.fromString(Je.item.extId).path,Je);const He=[Re.nodes],et=[];for(;He.length;)for(const Je of He.pop())Je.value?et.push(Je):Je.children&&He.push(Je.children.values());return{completedAt:ie.completedAt,results:et.map(Je=>je(Je)).filter(c.$mg)}}Ae.to=ve})(xe||(e.TestResults=xe={}));var $i;(function(Ae){function je(He){return{covered:He.covered,total:He.total}}function ve(He){return"line"in He?B.from(He):L.from(He)}function ie(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:ve(He.location),type:C.DetailType.Statement,branches:He.branches.length?He.branches.map(et=>({count:et.executed,location:et.location&&ve(et.location),label:et.label})):void 0}:{type:C.DetailType.Declaration,name:He.name,count:He.executed,location:ve(He.location)}}Ae.fromDetails=ie;function Re(He,et,Je){return v.$HO(Je.statementCoverage),v.$HO(Je.branchCoverage),v.$HO(Je.declarationCoverage),{id:et,uri:Je.uri,statement:je(Je.statementCoverage),branch:Je.branchCoverage&&je(Je.branchCoverage),declaration:Je.declarationCoverage&&je(Je.declarationCoverage),testId:Je instanceof v.$IO&&Je.testItem?P.$OI.fromExtHostTestItem(Je.testItem,He).toString():void 0}}Ae.fromFile=Re})($i||(e.TestCoverage=$i={}));var ti;(function(Ae){function je(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ae.to=je})(ti||(e.CodeActionTriggerKind=ti={}));var si;(function(Ae){function je(ie){const Re=new v.$MO(le.to(ie.kind),ie.name,ie.detail||"",g.URI.revive(ie.uri),L.to(ie.range),L.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=je;function ve(ie,Re,He){if(Re=Re??ie._sessionId,He=He??ie._itemId,Re===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:He,kind:le.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:L.from(ie.range),selectionRange:L.from(ie.selectionRange),tags:ie.tags?.map(he.from)}}Ae.from=ve})(si||(e.TypeHierarchyItem=si={}));var Dt;(function(Ae){function je(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=je})(Dt||(e.ViewBadge=Dt={}));var Kt;(function(Ae){function je(He,et,Je){const gt=et.fileData;return gt?new v.$TN(new v.$UN(gt.name,g.URI.revive(gt.uri),gt.id,(0,R.$eb)(()=>Je(gt.id)))):He===I.$4s.uriList&&et.uriListData?new v.$SN(Re(et.uriListData)):new v.$SN(et.asString)}Ae.to=je;async function ve(He,et){const Je=await et.asString();if(He===I.$4s.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const gt=et.asFile();return{asString:Je,fileData:gt?{name:gt.name,uri:gt.uri,id:gt._itemId??gt.id}:void 0}}Ae.from=ve;function ie(He){return A.$lu.split(He).map(et=>{if(et.startsWith("#"))return et;try{return g.URI.parse(et)}catch{}return et})}function Re(He){return A.$lu.create(He.map(et=>typeof et=="string"?et:g.URI.revive(et)))}})(Kt||(e.DataTransferItem=Kt={}));var Nt;(function(Ae){function je(ie,Re){const He=ie.items.map(([et,Je])=>[et,Kt.to(et,Je,Re)]);return new v.$VN(He)}Ae.toDataTransfer=je;async function ve(ie){const Re={items:[]},He=[];for(const[et,Je]of ie)He.push((async()=>{Re.items.push([et,await Kt.from(et,Je)])})());return await Promise.all(He),Re}Ae.from=ve})(Nt||(e.DataTransfer=Nt={}));var Ft;(function(Ae){function je(ie,Re){return{kind:"reply",agentId:ie.participant??Re?.agentId??"",subCommand:ie.command??Re?.command,message:ie.prompt,title:ie.label}}Ae.from=je;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ae.to=ve})(Ft||(e.ChatFollowup=Ft={}));var ii;(function(Ae){function je(ie){switch(ie){case y.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ae.to=je;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}Ae.from=ve})(ii||(e.LanguageModelChatMessageRole=ii={}));var ni;(function(Ae){function je(ie){let Re="",He;ie.content.type==="text"?Re=ie.content.value:He=new v.$bP(ie.content.name,ie.content.value,ie.content.isError);const et=ii.to(ie.role),Je=new v.$cP(et,Re,ie.name);return He!==void 0&&(Je.content2=He),Je}Ae.to=je;function ve(ie){const Re=ii.from(ie.role),He=ie.name;let et;return ie.content2 instanceof v.$bP?et={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:et={type:"text",value:ie.content},{role:Re,name:He,content:et}}Ae.from=ve})(ni||(e.LanguageModelChatMessage=ni={}));var oi;(function(Ae){function je(ie){return{kind:"markdownContent",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$ZO(ue.to(ie.content))}Ae.to=ve})(oi||(e.ChatResponseMarkdownPart=oi={}));var qt;(function(Ae){function je(ie){return{kind:"markdownVuln",content:ue.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ae.from=je;function ve(ie){return new v.$1O(ue.to(ie.content),ie.vulnerabilities)}Ae.to=ve})(qt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=qt={}));var Jt;(function(Ae){function je(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ae.from=je;function ve(ie){return new v.$2O(ie.agentId,ie.command)}Ae.to=ve})(Jt||(e.ChatResponseDetectedParticipantPart=Jt={}));var di;(function(Ae){function je(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data}}Ae.from=je})(di||(e.ChatResponseConfirmationPart=di={}));var jt;(function(Ae){function je(ie){const{value:Re,baseUri:He}=ie;function et(Je,gt){return Je.map(At=>{const xt=g.URI.joinPath(gt,At.name);return{label:At.name,uri:xt,children:At.children&&et(At.children,xt)}})}return{kind:"treeData",treeData:{label:(0,k.$ch)(He),uri:He,children:et(Re,He)}}}Ae.from=je;function ve(ie){const Re=(0,l.$bi)(ie.treeData);function He(gt){return gt.map(At=>({name:At.label,children:At.children&&He(At.children)}))}const et=Re.uri,Je=Re.children?He(Re.children):[];return new v.$4O(Je,et)}Ae.to=ve})(jt||(e.ChatResponseFilesPart=jt={}));var vt;(function(Ae){function je(ie){const Re=He=>g.URI.isUri(He);return{kind:"inlineReference",name:ie.title,inlineReference:Re(ie.value)?ie.value:F.from(ie.value)}}Ae.from=je;function ve(ie){const Re=(0,l.$bi)(ie);return new v.$5O(g.URI.isUri(Re.inlineReference)?Re.inlineReference:F.to(Re.inlineReference),ie.name)}Ae.to=ve})(vt||(e.ChatResponseAnchorPart=vt={}));var Pt;(function(Ae){function je(ie){return{kind:"progressMessage",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$6O(ie.content.value)}Ae.to=ve})(Pt||(e.ChatResponseProgressPart=Pt={}));var Lt;(function(Ae){function je(ie){return{kind:"warning",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$8O(ie.content.value)}Ae.to=ve})(Lt||(e.ChatResponseWarningPart=Lt={}));var It;(function(Ae){function je(ve){return{kind:"progressTask",content:ue.from(ve.value)}}Ae.from=je})(It||(e.ChatTask=It={}));var Xt;(function(Ae){function je(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?ue.from(ve):void 0}}Ae.from=je})(Xt||(e.ChatTaskResult=Xt={}));var Ht;(function(Ae){function je(ie,Re,He){return{kind:"command",command:Re.toInternal(ie.value,He)??{command:ie.value.command,title:ie.value.title}}}Ae.from=je;function ve(ie,Re){return new v.$9O(Re.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ae.to=ve})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var pi;(function(Ae){function je(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Re=>oe.from(Re))}}Ae.from=je;function ve(ie){return new v.$$O(g.URI.revive(ie.uri),ie.edits.map(Re=>oe.to(Re)))}Ae.to=ve})(pi||(e.ChatResponseTextEditPart=pi={}));var fi;(function(Ae){function je(ie){const Re=b.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:g.URI.isUri(ie.iconPath)?{light:g.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&g.URI.isUri(ie.iconPath.light)&&g.URI.isUri(ie.iconPath.dark)?{light:g.URI.revive(ie.iconPath.light),dark:g.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:g.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:F.from(ie.value.value)},iconPath:Re}:{kind:"reference",reference:g.URI.isUri(ie.value)?ie.value:F.from(ie.value),iconPath:Re}}Ae.from=je;function ve(ie){const Re=(0,l.$bi)(ie),He=et=>g.URI.isUri(et)?et:F.to(et);return new v.$0O("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&He(Re.reference.value)}:He(Re.reference))}Ae.to=ve})(fi||(e.ChatResponseReferencePart=fi={}));var Ai;(function(Ae){function je(Re,He,et){return Re instanceof v.$ZO?oi.from(Re):Re instanceof v.$5O?vt.from(Re):Re instanceof v.$0O?fi.from(Re):Re instanceof v.$6O?Pt.from(Re):Re instanceof v.$4O?jt.from(Re):Re instanceof v.$9O?Ht.from(Re,He,et):Re instanceof v.$$O?pi.from(Re):Re instanceof v.$1O?qt.from(Re):Re instanceof v.$2O?Jt.from(Re):Re instanceof v.$8O?Lt.from(Re):{kind:"markdownContent",content:ue.from("")}}Ae.from=je;function ve(Re,He){switch(Re.kind){case"reference":return fi.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Re,He)}}Ae.to=ve;function ie(Re,He){switch(Re.kind){case"markdownContent":return oi.to(Re);case"inlineReference":return vt.to(Re);case"progressMessage":return;case"treeData":return jt.to(Re);case"command":return Ht.to(Re,He)}}Ae.toContent=ie})(Ai||(e.ChatResponsePart=Ai={}));var Ot;(function(Ae){function je(ve){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(ai.to),location:Ti.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData}}Ae.to=je})(Ot||(e.ChatAgentRequest=Ot={}));var Ti;(function(Ae){function je(ie){switch(ie){case w.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case w.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case w.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case w.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ae.to=je;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return w.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return w.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return w.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return w.ChatAgentLocation.Editor}}Ae.from=ve})(Ti||(e.ChatLocation=Ti={}));var ai;(function(Ae){function je(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,g.$wc)(ie)?g.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,g.$wc)(ie.uri)?F.to((0,l.$bi)(ie)):ie,modelDescription:ve.modelDescription}}Ae.to=je})(ai||(e.ChatAgentValueReference=ai={}));var Rt;(function(Ae){function je(ve,ie,Re){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Re)}}Ae.from=je})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Si;(function(Ae){function je(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ae.to=je})(Si||(e.ChatAgentResult=Si={}));var Di;(function(Ae){function je(ve,ie,Re){if(ie.action.kind==="vote")return;const He=Si.to(ve);if(ie.action.kind==="command"){const et=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(et)??{command:et.id,title:et.title}}},result:He}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(ie.action.followup)},result:He}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:He}:{action:ie.action,result:He}}Ae.to=je})(Di||(e.ChatAgentUserActionEvent=Di={}));var vi;(function(Ae){function je(ve,ie,Re){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Re)}Ae.from=je})(vi||(e.TerminalQuickFix=vi={}));var Li;(function(Ae){function je(ve){return{kind:gi.to(ve.kind)}}Ae.to=je})(Li||(e.PartialAcceptInfo=Li={}));var gi;(function(Ae){function je(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ae.to=je})(gi||(e.PartialAcceptTriggerKind=gi={}));var Gt;(function(Ae){function je(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Ae.from=je})(Gt||(e.DebugTreeItem=Gt={}))}),define(Ee[345],Se([1,0,6,20,17,51]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;let N=class{constructor($,l){this.a=$.getProxy(r.$1M.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>l.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,l,I){const E=new R.$Pw(A.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$mnc=N,e.$mnc=N=Qe([qe(0,h.$uP)],N)}),define(Ee[346],Se([1,0,19,9,55,4,40,3,43,18,2,24,6,17,10,307,26]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0,k=We(k),b=We(b);class f{constructor(i,t,s,d,a){this.j=i,this.k=t,this.l=s,this.m=d,this.n=a,this.b=$.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(d){if(i.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,d),a}};const i=this;this.b.reset();const s=(d,a)=>{if(typeof this.d>"u"&&"content"in d&&(this.d=this.b.elapsed()),a){const w=this.l.$handleProgressChunk(this.k.requestId,d),y={report:S=>{w?.then(D=>{D&&(b.$sN.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseWarningPart.from(S),D):this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseReferencePart.from(S),D))})}};Promise.all([w,a?.(y)]).then(([S,D])=>{S!==void 0&&D!==void 0&&this.l.$handleProgressChunk(this.k.requestId,k.ChatTaskResult.from(D),S)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){t(this.markdown);const a=new b.$ZO(d),w=k.ChatResponseMarkdownPart.from(a);return s(w),this},markdownWithVulnerabilities(d,a){t(this.markdown),a&&(0,g.$4G)(i.j,"chatParticipantAdditions");const w=new b.$1O(d,a),y=k.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return s(y),this},filetree(d,a){t(this.filetree);const w=new b.$4O(d,a),y=k.ChatResponseFilesPart.from(w);return s(y),this},anchor(d,a){t(this.anchor);const w=new b.$5O(d,a),y=k.ChatResponseAnchorPart.from(w);return s(y),this},button(d){t(this.anchor);const a=new b.$9O(d),w=k.ChatResponseCommandButtonPart.from(a,i.m,i.n);return s(w),this},progress(d,a){t(this.progress);const w=new b.$7O(d,a),y=a?k.ChatTask.from(w):k.ChatResponseProgressPart.from(w);return s(y,a),this},warning(d){t(this.progress),(0,g.$4G)(i.j,"chatParticipantAdditions");const a=new b.$8O(d),w=k.ChatResponseWarningPart.from(a);return s(w),this},reference(d,a){if(t(this.reference),"variableName"in d&&(0,g.$4G)(i.j,"chatParticipantAdditions"),"variableName"in d&&!d.value){const w=i.k.variables.variables.find(y=>y.name===d.variableName);if(w){let y;if(w.references?.length)y=w.references.map(S=>({kind:"reference",reference:{variableName:d.variableName,value:S.reference}}));else{const S=new b.$0O(d,a);y=[k.ChatResponseReferencePart.from(S)]}return y.forEach(S=>s(S)),this}}else{const w=new b.$0O(d,a),y=k.ChatResponseReferencePart.from(w);s(y)}return this},textEdit(d,a){t(this.textEdit),(0,g.$4G)(i.j,"chatParticipantAdditions");const w=new b.$$O(d,a),y=k.ChatResponseTextEditPart.from(w);return s(y),this},detectedParticipant(d,a){t(this.detectedParticipant),(0,g.$4G)(i.j,"chatParticipantAdditions");const w=new b.$2O(d,a),y=k.ChatResponseDetectedParticipantPart.from(w);return s(y),this},confirmation(d,a,w){t(this.confirmation),(0,g.$4G)(i.j,"chatParticipantAdditions");const y=new b.$3O(d,a,w),S=k.ChatResponseConfirmationPart.from(y);return s(S),this},push(d){if(t(this.push),(d instanceof b.$$O||d instanceof b.$1O||d instanceof b.$2O||d instanceof b.$8O||d instanceof b.$3O)&&(0,g.$4G)(i.j,"chatParticipantAdditions"),d instanceof b.$0O)this.reference(d.value,d.iconPath);else{const a=k.ChatResponsePart.from(d,i.m,i.n);s(a)}return this}}}return this.g}}class m extends T.$Vc{static{this.b=0}constructor(i,t,s,d){super(),this.n=t,this.s=s,this.t=d,this.c=new Map,this.j=this.B(new T.$5c),this.m=this.B(new T.$5c),this.g=i.getProxy(u.$1M.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,s){const d=m.b++,a=new n(i,this.t,t,this.g,d,s);return this.c.set(d,a),a.isAgentEnabled()&&this.g.$registerAgent(d,i.identifier,t,{},void 0),a.apiAgent}createDynamicChatAgent(i,t,s,d){const a=m.b++,w=new n(i,this.t,t,this.g,a,d);return this.c.set(a,w),this.g.$registerAgent(a,i.identifier,t,{isSticky:!0},s),w.apiAgent}async $invokeAgent(i,t,s,d){const a=this.c.get(i);if(!a)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(t.sessionId);w||(w=new T.$Uc,this.j.set(t.sessionId,w));const y=new f(a.extension,t,this.g,this.s.converter,w);try{const S=await this.u(t.agentId,s),D=a.invoke(k.ChatAgentRequest.to(t),{history:S},y.apiObject,d);return await(0,h.$sh)(Promise.resolve(D).then(P=>{if(P?.metadata)try{JSON.stringify(P.metadata)}catch(p){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${p.message}`;return this.n.error(`[${a.extension.identifier.value}] [@${a.id}] ${v}`,a.extension),{errorDetails:{message:v},timings:y.timings}}let C;return P?.errorDetails&&(C={...P.errorDetails,responseIsIncomplete:!0}),C?.responseIsRedacted&&(0,g.$4G)(a.extension,"chatParticipantPrivate"),{errorDetails:C,timings:y.timings,metadata:P?.metadata}}),d)}catch(S){return this.n.error(S,a.extension),S instanceof b.$iP&&S.cause&&(S=S.cause),{errorDetails:{message:(0,A.$pj)(S),responseIsIncomplete:!0}}}finally{y.close()}}async u(i,t){const s=[];for(const d of t.history){const a=k.ChatAgentResult.to(d.result),w=i===d.request.agentId?a:{...a,metadata:void 0};s.push(new b.$_O(d.request.message,d.request.command,d.request.variables.variables.map(k.ChatAgentValueReference.to),d.request.agentId));const y=(0,r.$Ib)(d.response.map(S=>k.ChatResponsePart.toContent(S,this.s.converter)));s.push(new b.$aP(y,w,d.request.agentId,d.request.command))}return s}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,s,d,a){const w=this.c.get(t);if(!w)return Promise.resolve([]);const y=await this.u(w.id,d),S=k.ChatAgentResult.to(s);return(await w.provideFollowups(S,{history:y},a)).filter(D=>{const P=!D.participant||N.Iterable.some(this.c.values(),C=>C.id===D.participant&&E.$pn.equals(C.extension.identifier,w.extension.identifier));return P||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),P}).map(D=>k.ChatFollowup.from(D,i))}$acceptFeedback(i,t,s,d){const a=this.c.get(i);if(!a)return;const w=k.ChatAgentResult.to(t);let y;switch(s){case c.ChatAgentVoteDirection.Down:y=b.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:y=b.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(d?{result:w,kind:y,reportIssue:d}:{result:w,kind:y}))}$acceptAction(i,t,s){const d=this.c.get(i);if(!d||s.action.kind==="vote")return;const a=k.ChatAgentUserActionEvent.to(t,s,this.s.converter);a&&d.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(i,t,s){const d=this.c.get(i);if(!d)return[];let a=this.m.get(i);return a?a.clear():(a=new T.$Uc,this.m.set(i,a)),(await d.invokeCompletionProvider(t,s)).map(y=>k.ChatAgentCompletionItem.from(y,this.s.converter,a))}async $provideWelcomeMessage(i,t,s){const d=this.c.get(i);if(d)return await d.provideWelcomeMessage(k.ChatLocation.to(t),s)}async $provideSampleQuestions(i,t,s){const d=this.c.get(i);if(d)return(await d.provideSampleQuestions(k.ChatLocation.to(t),s)).map(a=>k.ChatFollowup.from(a,void 0))}}e.$nnc=m;class n{constructor(i,t,s,d,a,w){this.extension=i,this.w=t,this.id=s,this.x=d,this.y=a,this.z=w,this.m=new R.$le,this.n=new R.$le}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,g.$3G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,s){if(!this.b)return[];const d=await this.b.provideFollowups(i,t,s);return d?d.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(i,t);return s?s.map(d=>typeof d=="string"?d:k.MarkdownString.from(d)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(i,t);return s||[]}get apiAgent(){let i=!1,t=!1;const s=()=>{i||t||(t=!0,queueMicrotask(()=>{d.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof b.$ZN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:k.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(a){d.c=a,s()},get requestHandler(){return d.z},set requestHandler(a){(0,l.$og)(typeof a=="function","Invalid request handler"),d.z=a},get followupProvider(){return d.b},set followupProvider(a){d.b=a,s()},get isDefault(){return(0,g.$4G)(d.extension,"defaultChatParticipant"),d.d},set isDefault(a){(0,g.$4G)(d.extension,"defaultChatParticipant"),d.d=a,s()},get helpTextPrefix(){return(0,g.$4G)(d.extension,"defaultChatParticipant"),d.g},set helpTextPrefix(a){(0,g.$4G)(d.extension,"defaultChatParticipant"),d.g=a,s()},get helpTextVariablesPrefix(){return(0,g.$4G)(d.extension,"defaultChatParticipant"),d.j},set helpTextVariablesPrefix(a){(0,g.$4G)(d.extension,"defaultChatParticipant"),d.j=a,s()},get helpTextPostfix(){return(0,g.$4G)(d.extension,"defaultChatParticipant"),d.k},set helpTextPostfix(a){(0,g.$4G)(d.extension,"defaultChatParticipant"),d.k=a,s()},get isSecondary(){return(0,g.$4G)(d.extension,"defaultChatParticipant"),d.l},set isSecondary(a){(0,g.$4G)(d.extension,"defaultChatParticipant"),d.l=a,s()},get supportIssueReporting(){return(0,g.$4G)(d.extension,"chatParticipantPrivate"),d.o},set supportIssueReporting(a){(0,g.$4G)(d.extension,"chatParticipantPrivate"),d.o=a,s()},get onDidReceiveFeedback(){return d.m.event},set participantVariableProvider(a){if((0,g.$4G)(d.extension,"chatParticipantAdditions"),d.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");d.x.$registerAgentCompletionsProvider(d.y,d.id,a.triggerCharacters)}else d.x.$unregisterAgentCompletionsProvider(d.y,d.id)},get participantVariableProvider(){return(0,g.$4G)(d.extension,"chatParticipantAdditions"),d.q},set welcomeMessageProvider(a){(0,g.$4G)(d.extension,"defaultChatParticipant"),d.s=a,s()},get welcomeMessageProvider(){return(0,g.$4G)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,g.$3G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(a){d.t=a,s()},get requester(){return d.t},set supportsSlowReferences(a){(0,g.$4G)(d.extension,"chatParticipantPrivate"),d.u=a,s()},get supportsSlowReferences(){return(0,g.$4G)(d.extension,"chatParticipantPrivate"),d.u},dispose(){i=!0,d.b=void 0,d.m.dispose(),d.x.$unregisterAgent(d.y)}}}invoke(i,t,s,d){return this.z(i,t,s,d)}}}),define(Ee[347],Se([1,0,14,3,50,6,17,10,26]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0,N=We(N),T=We(T);class l{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$1M.MainThreadChatVariables)}async $resolveVariable(u,k,b,c){const g=this.b.get(u);if(g)try{if(g.resolver.resolve2){(0,$.$4G)(g.extension,"chatParticipantAdditions");const f=new I(k,this.c),m=await g.resolver.resolve2(g.data.name,{prompt:b},f.apiObject,c);if(m&&m[0])return m[0].value}else{const f=await g.resolver.resolve(g.data.name,{prompt:b},c);if(f&&f[0])return f[0].value}}catch(f){(0,r.$3)(f)}}registerVariableResolver(u,k,b,c,g,f,m,n,o){const i=l.a++,t=o?A.ThemeIcon.fromId(o):void 0;return this.b.set(i,{extension:u,data:{id:k,name:b,description:c,modelDescription:g,icon:t},resolver:m}),this.c.$registerVariable(i,{id:k,name:b,description:c,modelDescription:g,isSlow:f,fullName:n,icon:t}),(0,h.$Tc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$onc=l;class I{constructor(u,k){this.c=u,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(c){if(u.a){const g=new Error("Response stream has been closed");throw Error.captureStackTrace(g,c),g}};const u=this,b=c=>{this.d.$handleProgressChunk(this.c,c)};this.b={progress(c){k(this.progress);const g=new T.$6O(c),f=N.ChatResponseProgressPart.from(g);return b(f),this},reference(c){k(this.reference);const g=new T.$0O(c),f=N.ChatResponseReferencePart.from(g);return b(f),this},push(c){return k(this.push),c instanceof T.$0O?b(N.ChatResponseReferencePart.from(c)):c instanceof T.$6O&&b(N.ChatResponseProgressPart.from(c)),this}}}return this.b}}}),define(Ee[348],Se([1,0,9,59,4,3,41,2,88,24,17,10,6,26]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=b,$=We($),I=We(I),E=We(E);function b(c,g,f){const m=c.getProxy(u.$1M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new l.$rn,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===N.MarshalledId.CommentController){const P=this.b.get(D.handle);return P?P.value:D}else if(D&&D.$mid===N.MarshalledId.CommentThread){const P=D,C=this.b.get(P.commentControlHandle);if(!C)return P;const p=C.getCommentThread(P.commentThreadHandle);return p?p.value:P}else if(D&&(D.$mid===N.MarshalledId.CommentThreadReply||D.$mid===N.MarshalledId.CommentThreadInstance)){const P=this.b.get(D.thread.commentControlHandle);if(!P)return D;const C=P.getCommentThread(D.thread.commentThreadHandle);return C?D.$mid===N.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:D.text}:D}else if(D&&D.$mid===N.MarshalledId.CommentNode){const P=this.b.get(D.thread.commentControlHandle);if(!P)return D;const C=P.getCommentThread(D.thread.commentThreadHandle);if(!C)return D;const p=D.commentUniqueId,v=C.getCommentByUniqueId(p);return v||D}else if(D&&D.$mid===N.MarshalledId.CommentThreadNode){const P=this.b.get(D.thread.commentControlHandle);if(!P)return D;const C=P.getCommentThread(D.thread.commentThreadHandle);if(!C)return D;const p=D.text,v=D.commentUniqueId,O=C.getCommentByUniqueId(v);return O?(typeof O.body=="string"?O.body=p:O.body=new E.$sN(p),O):D}return D}})}createCommentController(D,P,C){const p=n.a++,v=new i(D,p,P,C);this.b.set(v.handle,v);const O=this.c.get(D.identifier)||[];return O.push(v),this.c.set(D.identifier,O),v.value}async $createCommentThreadTemplate(D,P,C,p){const v=this.b.get(D);v&&v.$createCommentThreadTemplate(P,C,p)}async $setActiveComment(D,P){const C=this.b.get(D);C&&C.$setActiveComment(P??void 0)}async $updateCommentThreadTemplate(D,P,C){const p=this.b.get(D);p&&p.$updateCommentThreadTemplate(P,C)}$deleteCommentThread(D,P){this.b.get(D)?.$deleteCommentThread(P)}async $provideCommentingRanges(D,P,C){const p=this.b.get(D);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await f.ensureDocumentData(T.URI.revive(P));return(0,r.$wh)(async()=>{const O=await p.commentingRangeProvider.provideCommentingRanges(v.document,C);let L;return Array.isArray(O)?L={ranges:O,fileComments:!1}:O?L={ranges:O.ranges||[],fileComments:O.fileComments||!1}:L=O??void 0,L}).then(O=>{let L;return O&&(L={ranges:O.ranges.map(F=>I.Range.from(F)),fileComments:O.fileComments}),L})}$toggleReaction(D,P,C,p,v){const O=this.b.get(D);return!O||!O.reactionHandler?Promise.resolve(void 0):(0,r.$wh)(()=>{const L=O.getCommentThread(P);if(L){const F=L.getCommentByUniqueId(p.uniqueIdInThread);if(O!==void 0&&F&&O.reactionHandler)return O.reactionHandler(F,d(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(D){this.n=D}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(D){(D===void 0!=(this.p===void 0)||!D||!this.p||!D.isEqual(this.p))&&(this.p=D,this.b.range=D,this.c.fire())}get range(){return this.p}set canReply(D){this.d!==D&&(this.d=D,this.b.canReply=D,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(D){this.e=D,this.b.label=D,this.c.fire()}get contextValue(){return this.f}set contextValue(D){this.f=D,this.b.contextValue=D,this.c.fire()}get comments(){return this.q}set comments(D){this.q=D,this.b.comments=D,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(D){this.g=D,this.b.collapsibleState=D,this.c.fire()}get state(){return this.h}set state(D){this.h=D,typeof D=="object"?((0,k.$4G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=D.resolved,this.b.applicability=D.applicability):this.b.state=D,this.c.fire()}get isDisposed(){return this.j}constructor(D,P,C,p,v,O,L,F,j){this.m=P,this.n=C,this.o=p,this.p=v,this.q=O,this.extensionDescription=L,this.r=F,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${D}.${this.handle}`),m.$createCommentThread(P,this.handle,this.n,this.o,I.Range.from(this.p),L.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=O,this.i.push({dispose:()=>{m.$deleteCommentThread(P,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(M){B.range=M},get comments(){return B.comments},set comments(M){B.comments=M},get collapsibleState(){return B.collapsibleState},set collapsibleState(M){B.collapsibleState=M},get canReply(){return B.canReply},set canReply(M){B.canReply=M},get contextValue(){return B.contextValue},set contextValue(M){B.contextValue=M},get label(){return B.label},set label(M){B.label=M},get state(){return B.state},set state(M){B.state=M},reveal:M=>B.reveal(M),dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const D=C=>Object.prototype.hasOwnProperty.call(this.b,C),P={};D("range")&&(P.range=I.Range.from(this.p)),D("label")&&(P.label=this.label),D("contextValue")&&(P.contextValue=this.contextValue??null),D("comments")&&(P.comments=this.q.map(C=>t(this,C,this.k,this.extensionDescription))),D("collapsibleState")&&(P.collapseState=a(this.g)),D("canReply")&&(P.canReply=this.canReply),D("state")&&(P.state=w(this.h)),D("applicability")&&(P.applicability=y(this.h)),D("isTemplate")&&(P.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,P)}getCommentByUniqueId(D){for(const P of this.k){const C=P[0],p=P[1];if(D===p)return C}}async reveal(D){return(0,k.$4G)(this.extensionDescription,"commentReveal"),m.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...D})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(D=>D.dispose())}}Qe([(0,h.$0h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(D){this.b=D,D?.resourceHints&&(0,k.$4G)(this.h,"commentingRangeHint"),m.$updateCommentingRanges(this.handle,D?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(D){this.c=D,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!D})}get options(){return this.d}set options(D){this.d=D,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$4G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$4G)(this.h,"activeComment"),this.f}constructor(D,P,C,p){this.h=D,this.i=P,this.j=C,this.k=p,this.a=new Map,m.$registerCommentController(this.handle,C,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(O){v.options=O},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(O){v.commentingRangeProvider=O},get reactionHandler(){return v.reactionHandler},set reactionHandler(O){v.reactionHandler=O},get activeCommentThread(){return v.activeCommentThread},createCommentThread(O,L,F){return v.createCommentThread(O,L,F).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(D,P,C){P===void 0&&(0,k.$4G)(this.h,"fileComments");const p=new o(this.id,this.handle,void 0,D,P,C,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(D){if(!D){this.e=void 0,this.f=void 0;return}const P=this.a.get(D.commentThreadHandle);P&&(this.e=D.uniqueIdInThread?P.getCommentByUniqueId(D.uniqueIdInThread):void 0,this.f=P)}$createCommentThreadTemplate(D,P,C){const p=new o(this.id,this.handle,void 0,T.URI.revive(D),I.Range.to(P),[],this.h,!0,C);return p.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(D,P){const C=this.a.get(D);C&&(C.range=I.Range.to(P))}$deleteCommentThread(D){this.a.get(D)?.dispose(),this.a.delete(D)}getCommentThread(D){return this.a.get(D)}dispose(){this.a.forEach(D=>{D.dispose()}),this.g.forEach(D=>D.dispose())}}function t(S,D,P,C){let p=P.get(D);return p||(p=++S.commentHandle,P.set(D,p)),D.state!==void 0&&(0,k.$4G)(C,"commentsDraftState"),D.reactions?.some(v=>v.reactors!==void 0)&&(0,k.$4G)(C,"commentReactor"),{mode:D.mode,contextValue:D.contextValue,uniqueIdInThread:p,body:typeof D.body=="string"?D.body:I.MarkdownString.from(D.body),userName:D.author.name,userIconPath:D.author.iconPath,label:D.label,commentReactions:D.reactions?D.reactions.map(v=>s(v)):void 0,state:D.state,timestamp:D.timestamp?.toJSON()}}function s(S){return{label:S.label,iconPath:S.iconPath?I.$tP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(D=>D.name):S.reactors}}function d(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?T.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(D=>({name:D}))}}function a(S){if(S!==void 0)switch(S){case E.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function w(S){let D;if(typeof S=="object"?D=S.resolved:D=S,D!==void 0)switch(D){case E.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function y(S){let D;if(typeof S=="object"&&(D=S.applicability),D!==void 0)switch(D){case E.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Ee[349],Se([1,0,21,60,3,15,23,2,17,97,119,6,10]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=void 0,$=We($),E=We(E),u=We(u);class k{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new I.$$mc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=i(this.document.uri)+this.a++;return(0,N.$fh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class b{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,a){const w=this.b(s,d.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const y=new k(d,a);return this.a.set(w,y),y}delete(s,d){const a=this.b(s,d.uri);this.a.delete(a)}b(s,d){return`${s}@@@${d}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(s,d,a){return this.b(s,{type:c.Text,extension:d,provider:a})}addCustomProvider(s,d,a){return this.b(s,{type:c.Custom,extension:d,provider:a})}get(s){return this.a.get(s)}b(s,d){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,d),new u.$3M(()=>this.a.delete(s))}}class f{constructor(s,d,a,w,y){this.d=d,this.f=a,this.g=w,this.h=y,this.b=new g,this.c=new b,this.a=s.getProxy(E.$1M.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,a,w){const y=new A.$Uc;return n(a)?(y.add(this.b.addTextProvider(d,s,a)),this.a.$registerTextEditorProvider((0,l.$Hnc)(s),d,w.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,l.$Fnc)(s))):(y.add(this.b.addCustomProvider(d,s,a)),m(a)&&y.add(a.onDidChangeCustomDocument(S=>{const D=this.i(d,S.document.uri);if(o(S)){const P=D.addEdit(S);this.a.$onDidEdit(S.document.uri,d,P,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,l.$Hnc)(s),d,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,l.$Fnc)(s))),u.$3M.from(y,new u.$3M(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,a,w,y){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==c.Custom)throw new Error(`Invalid provide type for '${d}'`);const D=T.URI.revive(s),P=await S.provider.openCustomDocument(D,{backupId:a,untitledDocumentData:w?.buffer},y);let C;return m(S.provider)&&this.f&&(C=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,P,C),{editable:m(S.provider)}}async $disposeCustomDocument(s,d){const a=this.b.get(d);if(!a)throw new Error(`No provider found for '${d}'`);if(a.type!==c.Custom)throw new Error(`Invalid provider type for '${d}'`);const w=T.URI.revive(s),{document:y}=this.i(d,w);this.c.delete(d,y),y.dispose()}async $resolveCustomEditor(s,d,a,w,y,S){const D=this.b.get(a);if(!D)throw new Error(`No provider found for '${a}'`);const P=$.ViewColumn.to(y),C=this.g.createNewWebview(d,w.contentOptions,D.extension),p=this.h.createNewWebviewPanel(d,a,w.title,P,w.options,C,w.active),v=T.URI.revive(s);switch(D.type){case c.Custom:{const{document:O}=this.i(a,v);return D.provider.resolveCustomEditor(O,p,S)}case c.Text:{const O=this.d.getDocument(v);return D.provider.resolveCustomTextEditor(O,p,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,a){this.i(d,s).disposeEdits(a)}async $onMoveCustomEditor(s,d,a){const w=this.b.get(a);if(!w)throw new Error(`No provider found for '${a}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const y=this.h.getWebviewPanel(s);if(!y)throw new Error("No webview found");const S=T.URI.revive(d),D=this.d.getDocument(S);await w.provider.moveCustomTextEditor(D,y,r.CancellationToken.None)}async $undo(s,d,a,w){return this.i(d,s).undo(a,w)}async $redo(s,d,a,w){return this.i(d,s).redo(a,w)}async $revert(s,d,a){const w=this.i(d,s);await this.j(d).revertCustomDocument(w.document,a),w.disposeBackup()}async $onSave(s,d,a){const w=this.i(d,s);await this.j(d).saveCustomDocument(w.document,a),w.disposeBackup()}async $onSaveAs(s,d,a,w){const y=this.i(d,s);return this.j(d).saveCustomDocumentAs(y.document,T.URI.revive(a),w)}async $backup(s,d,a){const w=this.i(d,s),S=await this.j(d).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},a);return w.updateBackup(S),S.id}i(s,d){const a=this.c.get(s,T.URI.revive(d));if(!a)throw new Error("No custom document found");return a}j(s){const a=this.b.get(s)?.provider;if(!a||!m(a))throw new Error("Custom document is not editable");return a}}e.$Knc=f;function m(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,h.$sj)(s)+""}}),define(Ee[350],Se([1,0,233,145,2,6,10,17,4,12,29,63]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0,T=We(T);class k{#e;#t;#i;constructor(g,f,m,n,o,i,t,s){this.d=g,this.e=f,this.f=m,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,m),this.#i=new I.$Bc(d=>i.getComparisonKey(d)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,f){if(!g){this.clear();return}this.j();let m=[];if(A.URI.isUri(g)){if(!f){this.delete(g);return}this.#i.set(g,f.slice()),m=[g]}else if(Array.isArray(g)){m=[];let i;g=[...g].sort(k.k);for(const t of g){const[s,d]=t;if((!i||s.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=s,m.push(s),this.#i.set(s,[])),d)this.#i.get(s)?.push(...d);else{const a=this.#i.get(s);a&&(a.length=0)}}}if(this.#t.fire(m),!this.#e)return;const n=[];let o=0;for(const i of m){let t=[];const s=this.#i.get(i);if(s)if(s.length>this.g){t=[];const d=[N.DiagnosticSeverity.Error,N.DiagnosticSeverity.Warning,N.DiagnosticSeverity.Information,N.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const w of s)if(w.severity===d[a]&&t.push({...T.Diagnostic.from(w),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(d=>({...T.Diagnostic.from(d),modelVersionId:this.h(i)}));if(n.push([i,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,f){this.j();for(const[m,n]of this)g.call(f,m,n,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const f=this.#i.get(g);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,f){return g[0].toString()<f[0].toString()?-1:g[0].toString()>f[0].toString()?1:0}}e.$fnc=k;let b=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(g){const f=new I.$Bc;for(const m of g)f.set(m,m);return{uris:Object.freeze(Array.from(f.values()))}}constructor(g,f,m,n){this.j=f,this.k=m,this.l=n,this.g=new Map,this.h=new $.$pe({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=g.getProxy(R.$1M.MainThreadDiagnostics)}createDiagnosticCollection(g,f){const{g:m,f:n,h:o,j:i,k:t,l:s}=this,d=new class{$changeMany(y,S){n.$changeMany(y,S),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,y,S.length===0?"CLEARING":S)}$clear(y){n.$clear(y),i.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,y)}dispose(){n.dispose()}};let a;if(!f)f="_generated_diagnostic_collection_name_#"+u.c++,a=f;else if(!m.has(f))a=f;else{this.j.warn(`DiagnosticCollection with name '${f}' does already exist.`);do a=f+u.c++;while(m.has(a))}return new class extends k{constructor(){super(f,a,u.e,u.d,y=>s.getDocument(y)?.version,t.extUri,d,o),m.set(a,this)}dispose(){super.dispose(),m.delete(a)}}}getDiagnostics(g){if(g)return this.m(g);{const f=new Map,m=[];for(const n of this.g.values())n.forEach((o,i)=>{let t=f.get(o.toString());typeof t>"u"&&(t=m.length,f.set(o.toString(),t),m.push([o,[]])),m[t][1]=m[t][1].concat(...i)});return m}}m(g){let f=[];for(const m of this.g.values())m.has(g)&&(f=f.concat(m.get(g)));return f}$acceptMarkersChange(g){if(!this.n){const f="_generated_mirror",m=new k(f,f,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(f,m),this.n=m}for(const[f,m]of g)this.n.set(A.URI.revive(f),m.map(T.Diagnostic.to))}};e.$gnc=b,e.$gnc=b=u=Qe([qe(1,l.$$j),qe(2,E.$enc)],b)}),define(Ee[351],Se([1,0,2,14,10,17,81,51]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;class ${constructor(I,E,u,k={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=u,this.g=k,this.a=new N.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,u,k)=>{const c={dispose:this.a.push([E,u,I])};return Array.isArray(k)&&k.push(c),c}}async $participateInSave(I,E){const u=r.URI.revive(I);let k=!1;const b=setTimeout(()=>k=!0,this.g.timeout),c=[];try{for(const g of[...this.a]){if(k)break;const f=this.d.getDocument(u),m=await this.h(g,{document:f,reason:R.TextDocumentSaveReason.to(E)});c.push(m)}}finally{clearTimeout(b)}return c}h([I,E,u],k){const b=this.b.get(I);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(u,I,E,k).then(()=>!0,c=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const g=this.b.get(I);this.b.set(I,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,u,k){const b=[],c=Date.now(),{document:g,reason:f}=k,{version:m}=g,n=Object.freeze({document:g,reason:f,waitUntil(o){if(Object.isFrozen(b))throw(0,h.$9)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{E.apply(u,[n])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(b).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(t),o(s)}).catch(s=>{clearTimeout(t),i(s)})}).then(o=>{const i={edits:[]};for(const t of o)if(Array.isArray(t)&&t.every(s=>s instanceof A.$0M))for(const{newText:s,newEol:d,range:a}of t)i.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:s,eol:d&&R.EndOfLine.from(d)}});if(i.edits.length!==0)return m===g.version?this.f.$tryApplyWorkspaceEdit(new T.$Pw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$toc=$}),define(Ee[352],Se([1,0,4,3,2,6,163,17,18,25,10]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0,T=We(T);class E{constructor(k,b){this.a=new r.$le,this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Uc,this.h=new Map,this.f=k.getProxy(R.$1M.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const b=this.g.getDocument(k);if(b)return b}getDocument(k){const b=this.getDocumentData(k);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return b.document}ensureDocumentData(k){const b=this.g.getDocument(k);if(b)return Promise.resolve(b);let c=this.h.get(k.toString());return c||(c=this.f.$tryOpenDocument(k).then(g=>{this.h.delete(k.toString());const f=A.URI.revive(g);return(0,$.$pg)(this.g.getDocument(f))},g=>(this.h.delete(k.toString()),Promise.reject(g))),this.h.set(k.toString(),c)),c}createDocumentData(k){return this.f.$tryCreateDocument(k).then(b=>A.URI.revive(b))}$acceptModelLanguageChanged(k,b){const c=A.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(b),this.a.fire(g.document)}$acceptModelSaved(k){const b=A.URI.revive(k),c=this.g.getDocument(b);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(k,b){const c=A.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(b),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,b,c){const g=A.URI.revive(k),f=this.g.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(c),f.onEvents(b);let m;b.isUndoing?m=I.TextDocumentChangeReason.Undo:b.isRedoing&&(m=I.TextDocumentChangeReason.Redo),this.c.fire((0,l.$co)({document:f.document,contentChanges:b.changes.map(n=>({range:T.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:m}))}setWordDefinitionFor(k,b){(0,N.$wP)(k,b)}}e.$hnc=E}),define(Ee[78],Se([1,0,79,4,18,2,5,6,20,17,10]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=void 0,l=We(l),e.$Lnc=(0,N.$Ei)("IExtHostEditorTabs");class E{constructor(g,f,m){this.e=m,this.d=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,f={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$NO(R.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$OO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$PO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$QO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$RO(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$SO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$TO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$UO;case T.TabInputKind.InteractiveEditorInput:return new I.$VO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$WO;case T.TabInputKind.MultiDiffEditorInput:return new I.$XO(this.b.input.diffEditors.map(g=>new I.$OO(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class u{constructor(g,f){this.c=[],this.d="",this.b=g,this.e=f;for(const m of g.tabs)m.isActive&&(this.d=m.id),this.c.push(new E(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,f={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return l.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(m=>m.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(m=>m.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===T.TabModelOperationKind.TAB_OPEN){const m=new E(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,m),g.tabDto.isActive&&(this.d=m.tabId),m}else if(g.kind===T.TabModelOperationKind.TAB_CLOSE){const m=this.c.splice(g.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(g.kind===T.TabModelOperationKind.TAB_MOVE){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(g.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,m),m}const f=this.c.find(m=>m.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this.d}}let k=class{constructor(g){this.b=new h.$le,this.c=new h.$le,this.e=[],this.a=g.getProxy(T.$1M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,f={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(m=>m.apiObject))},get activeTabGroup(){const m=g.d;return(0,A.$pg)(g.e.find(o=>o.groupId===m)?.apiObject)},close:async(m,n)=>{const o=Array.isArray(m)?m:[m];return o.length?b(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(g){const f=new Set(this.e.map(d=>d.groupId)),m=new Set(g.map(d=>d.groupId)),n=(0,r.$L)(f,m),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),i=[],t=[];this.e=g.map(d=>{const a=new u(d,()=>this.d);return n.added.includes(a.groupId)?i.push(a.apiObject):t.push(a.apiObject),a});const s=(0,A.$pg)(g.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:i,closed:o,changed:t}))}$acceptTabGroupUpdate(g){const f=this.e.find(m=>m.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this.e.find(n=>n.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const m=f.acceptTabOperation(g);switch(g.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(g){for(const f of this.e)for(const m of f.tabs)if(m.apiObject===g)return m}h(g){return this.e.find(f=>f.apiObject===g)}async i(g,f){const m=[];for(const n of g){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");m.push(o.tabId)}return this.a.$closeTab(m,f)}async j(g,f){const m=[];for(const n of g){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");m.push(o.groupId)}return this.a.$closeGroup(m,f)}};e.$Mnc=k,e.$Mnc=k=Qe([qe(0,$.$uP)],k);function b(c){return c.tabs!==void 0}}),define(Ee[353],Se([1,0,2,6,28,3,10,17,194,13,27,22,26,86]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,A=We(A),T=We(T);class b{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const m=this.a.indexOf(f);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),m=[];let n,o,i=$.State.LastKnownState,t=$.State.LastKnownState;for(const s of f){let d=n?(0,l.$Hf)(n,s):0;for(d===0?o=$.State.Start:o=t;d<s.length;d++)d+1===s.length?(i=t,t=$.State.BeforeColon):t+=1,m.push([o,s.toUpperCase().charCodeAt(d),t]),m.push([o,s.toLowerCase().charCodeAt(d),t]),o=t;n=s,t=i}m.push([$.State.BeforeColon,I.CharCode.Colon,$.State.AfterColon]),m.push([$.State.AfterColon,I.CharCode.Slash,$.State.End]),this.b=new $.$F3(m)}}provideDocumentLinks(f){this.c();const m=[],n=$.$G3.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this.b);for(const o of n){const i=T.DocumentLink.to(o);i.target&&m.push(i)}return m}}class c{constructor(f,m){this.i=m,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(h.$1M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,m,n,o={}){if(c.j(n),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,n);let t=A.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(t+=A.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(t+=A.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=A.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,u.$4G)(f,"fsChunks"),t+=A.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,k.$4k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,t,s).catch(a=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${m}`),console.error(a)});const d=n.onDidChangeFile(a=>{const w=[];for(const y of a){const{uri:S,type:D}=y;if(S.scheme!==m)continue;let P;switch(D){case N.FileChangeType.Changed:P=A.FileChangeType.UPDATED;break;case N.FileChangeType.Created:P=A.FileChangeType.ADDED;break;case N.FileChangeType.Deleted:P=A.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:S,type:P})}this.a.$onFileSystemChange(i,w)});return(0,R.$Tc)(()=>{d.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:m,ctime:n,mtime:o,size:i,permissions:t}=f;return{type:m,ctime:n,mtime:o,size:i,permissions:t}}$stat(f,m){return Promise.resolve(this.l(f).stat(r.URI.revive(m))).then(n=>c.k(n))}$readdir(f,m){return Promise.resolve(this.l(f).readDirectory(r.URI.revive(m)))}$readFile(f,m){return Promise.resolve(this.l(f).readFile(r.URI.revive(m))).then(n=>E.$Ne.wrap(n))}$writeFile(f,m,n,o){return Promise.resolve(this.l(f).writeFile(r.URI.revive(m),n.buffer,o))}$delete(f,m,n){return Promise.resolve(this.l(f).delete(r.URI.revive(m),n))}$rename(f,m,n,o){return Promise.resolve(this.l(f).rename(r.URI.revive(m),r.URI.revive(n),o))}$copy(f,m,n,o){const i=this.l(f);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(r.URI.revive(m),r.URI.revive(n),o))}$mkdir(f,m){return Promise.resolve(this.l(f).createDirectory(r.URI.revive(m)))}$watch(f,m,n,o){const i=this.l(f).watch(r.URI.revive(n),o);this.f.set(m,i)}$unwatch(f,m){const n=this.f.get(m);n&&(n.dispose(),this.f.delete(m))}$open(f,m,n){const o=this.l(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(m),n))}$close(f,m){const n=this.l(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(m))}$read(f,m,n,o){const i=this.l(f);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=E.$Ne.alloc(o);return Promise.resolve(i.read(m,n,t.buffer,0,o)).then(s=>t.slice(0,s))}$write(f,m,n,o){const i=this.l(f);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,n,o.buffer,0,o.byteLength))}l(f){const m=this.c.get(f);if(!m){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return m}}e.$woc=c}),define(Ee[354],Se([1,0,4,39,2,6,17,10,28,49]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,N=We(N);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,c,g,f,m,n){this.a=Math.random(),this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$yk)(m),i=typeof m=="string",t=n?.correlate,s=f(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(t&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const a of d.created){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.b.fire(w)}if(!n?.ignoreChangeEvents)for(const a of d.changed){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.c.fire(w)}if(!n?.ignoreDeleteEvents)for(const a of d.deleted){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=T.$3M.from(this.i(b,g,m,n,n?.correlate),this.b,this.c,this.d,s)}i(b,c,g,f,m){const n=T.$3M.from();if(typeof g=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const o=b.getProxy(R.$1M.MainThreadFileSystemEventService);let i=!1;(g.pattern.includes(h.$uk)||g.pattern.includes(h.$vk))&&(i=!0);let t;return m&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(t=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,f?.ignoreChangeEvents&&(t&=~$.FileChangeFilter.UPDATED),f?.ignoreCreateEvents&&(t&=~$.FileChangeFilter.ADDED),f?.ignoreDeleteEvents&&(t&=~$.FileChangeFilter.DELETED)),o.$watch(c.identifier.value,this.a,g.baseUri,{recursive:i,excludes:f?.excludes??[],filter:t},!!m),T.$3M.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(b){this.a=b,this.session=this.a.session,this.b=new l.$W(()=>this.a.created.map(A.URI.revive)),this.c=new l.$W(()=>this.a.changed.map(A.URI.revive)),this.d=new l.$W(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(b,c,g){this.j=b,this.k=c,this.l=g,this.a=new r.$le,this.b=new r.$le,this.c=new r.$le,this.d=new r.$le,this.g=new r.$ne,this.h=new r.$ne,this.i=new r.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,c,g,f){return new I(this.j,b,c,this.a.event,N.GlobPattern.from(g),f)}$onFileEvent(b){this.a.fire(new E(b))}$onDidRunFileOperation(b,c){switch(b){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:c.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:c.map(g=>A.URI.revive(g.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:c.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,c){return(g,f,m)=>{const n=function(i){g.call(f,i)};return n.extension=b,c.event(n,void 0,m)}}async $onWillRunFileOperation(b,c,g,f){switch(b){case $.FileOperation.MOVE:return await this.n(this.g,{files:c.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))},g,f);case $.FileOperation.DELETE:return await this.n(this.i,{files:c.map(m=>A.URI.revive(m.target))},g,f);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:c.map(m=>A.URI.revive(m.target))},g,f)}}async n(b,c,g,f){const m=new Set,n=[];if(await b.fireAsync(c,f,async(i,t)=>{const s=Date.now(),d=await Promise.resolve(i);d instanceof T.$aN&&(n.push([t.extension,d]),m.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-s>g&&this.k.warn("SLOW file-participant",t.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,i]of n){const{edits:t}=N.WorkspaceEdit.from(i,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(t)}return{edit:o,extensionNames:Array.from(m)}}}e.$xoc=u}),define(Ee[355],Se([1,0,19,9,21,14,133,3,25,43,13,18,2,31,190,88,143,235,24,17,10,26,119,6]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0,c=We(c),n=We(n),s=We(s);class d{constructor(V,q){this.d=V,this.e=q}async provideDocumentSymbols(V,q){const Q=this.d.getDocument(V),x=await this.e.provideDocumentSymbols(Q,q);if(!(0,r.$Lb)(x))return x[0]instanceof o.$kN?x.map(n.DocumentSymbol.from):d.f(x)}static f(V){V=V.slice(0).sort((x,fe)=>{let we=x.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(x.location.range.end)),we});const q=[],Q=[];for(const x of V){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(Q.length===0){Q.push(fe),q.push(fe);break}const we=Q[Q.length-1];if(k.$Ht.containsRange(we.range,fe.range)&&!k.$Ht.equalsRange(we.range,fe.range)){we.children?.push(fe),Q.push(fe);break}Q.pop()}}return q}}class a{constructor(V,q,Q,x,fe,we){this.f=V,this.g=q,this.h=Q,this.j=x,this.k=fe,this.l=we,this.d=new t.$$mc("CodeLens"),this.e=new Map}async provideCodeLenses(V,q){const Q=this.f.getDocument(V),x=await this.h.provideCodeLenses(Q,q);if(!x||q.isCancellationRequested)return;const fe=this.d.add(x),we=new T.$Uc;this.e.set(fe,we);const Oe={cacheId:fe,lenses:[]};for(let Ge=0;Ge<x.length;Ge++)Oe.lenses.push({cacheId:[fe,Ge],range:n.Range.from(x[Ge].range),command:this.g.toInternal(x[Ge].command,we)});return Oe}async resolveCodeLens(V,q){const Q=V.cacheId&&this.d.get(...V.cacheId);if(!Q)return;let x;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?x=Q:x=await this.h.resolveCodeLens(Q,q),x||(x=Q),q.isCancellationRequested)return;const fe=V.cacheId&&this.e.get(V.cacheId[0]);if(fe){if(!x.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(x.command,fe),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function w(Te){return Array.isArray(Te)?Te.map(n.DefinitionLink.from):Te?[n.DefinitionLink.from(Te)]:[]}class y{constructor(V,q){this.d=V,this.e=q}async provideDefinition(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideDefinition(x,fe,Q);return w(we)}}class S{constructor(V,q){this.d=V,this.e=q}async provideDeclaration(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideDeclaration(x,fe,Q);return w(we)}}class D{constructor(V,q){this.d=V,this.e=q}async provideImplementation(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideImplementation(x,fe,Q);return w(we)}}class P{constructor(V,q){this.d=V,this.e=q}async provideTypeDefinition(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideTypeDefinition(x,fe,Q);return w(we)}}class C{static{this.f=10}constructor(V,q){this.g=V,this.h=q,this.d=0,this.e=new Map}async provideHover(V,q,Q,x){const fe=this.g.getDocument(V),we=n.Position.to(q);let Oe;if(Q&&Q.verbosityRequest){const rt=Q.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:Q.verbosityRequest.verbosityDelta,previousHover:ot};Oe=await this.h.provideHover(fe,we,x,nt)}else Oe=await this.h.provideHover(fe,we,x);if(!Oe||(0,r.$Lb)(Oe.contents))return;Oe.range||(Oe.range=fe.getWordRangeAtPosition(we)),Oe.range||(Oe.range=new o.$5M(we,we));const Ge=n.Hover.from(Oe),Ke=this.d;if(this.e.size===C.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Ke,Oe),this.d+=1,{...Ge,id:Ke}}releaseHover(V){this.e.delete(V)}}class p{constructor(V,q){this.d=V,this.e=q}async provideEvaluatableExpression(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideEvaluatableExpression(x,fe,Q);if(we)return n.EvaluatableExpression.from(we)}}class v{constructor(V,q){this.d=V,this.e=q}async provideInlineValues(V,q,Q,x){const fe=this.d.getDocument(V),we=await this.e.provideInlineValues(fe,n.Range.to(q),n.InlineValueContext.to(Q),x);if(Array.isArray(we))return we.map(Oe=>n.InlineValue.from(Oe))}}class O{constructor(V,q){this.d=V,this.e=q}async provideDocumentHighlights(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideDocumentHighlights(x,fe,Q);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class L{constructor(V,q){this.d=V,this.e=q}async provideMultiDocumentHighlights(V,q,Q,x){const fe=this.d.getDocument(V),we=Q.map(Ke=>this.d.getDocument(Ke)),Oe=n.Position.to(q),Ge=await this.e.provideMultiDocumentHighlights(fe,Oe,we,x);if(Array.isArray(Ge))return Ge.map(n.MultiDocumentHighlight.from)}}class F{constructor(V,q){this.d=V,this.e=q}async provideLinkedEditingRanges(V,q,Q){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideLinkedEditingRanges(x,fe,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.$Ib)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(V,q){this.d=V,this.e=q}async provideReferences(V,q,Q,x){const fe=this.d.getDocument(V),we=n.Position.to(q),Oe=await this.e.provideReferences(fe,we,Q,x);if(Array.isArray(Oe))return Oe.map(n.location.from)}}class B{static{this.d=1e3}constructor(V,q,Q,x,fe,we,Oe){this.g=V,this.h=q,this.j=Q,this.k=x,this.l=fe,this.m=we,this.n=Oe,this.e=new t.$$mc("CodeAction"),this.f=new Map}async provideCodeActions(V,q,Q,x){const fe=this.g.getDocument(V),we=b.$Jt.isISelection(q)?n.Selection.to(q):n.Range.to(q),Oe=[];for(const nt of this.j.getDiagnostics(V))if(we.intersection(nt.range)&&Oe.push(nt)>B.d)break;const Ge={diagnostics:Oe,only:Q.only?new o.$mN(Q.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Q.trigger)},Ke=await this.k.provideCodeActions(fe,we,Ge,x);if(!(0,r.$Mb)(Ke)||x.isCancellationRequested)return;const tt=this.e.add(Ke),rt=new T.$Uc;this.f.set(tt,rt);const ot=[];for(let nt=0;nt<Ke.length;nt++){const ct=Ke[nt];if(ct)if(B.o(ct))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:ct.title,command:this.h.toInternal(ct,rt)});else{Ge.only&&(ct.kind?Ge.only.contains(ct.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value} 'requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=ct.ranges??[];ot.push({cacheId:[tt,nt],title:ct.title,command:ct.command&&this.h.toInternal(ct.command,rt),diagnostics:ct.diagnostics&&ct.diagnostics.map(n.Diagnostic.from),edit:ct.edit&&n.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,i.$3G)(this.m,"codeActionAI")?ct.isAI:!1,ranges:(0,i.$3G)(this.m,"codeActionRanges")?(0,r.$Ib)($t.map(n.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:tt,actions:ot}}async resolveCodeAction(V,q){const[Q,x]=V,fe=this.e.get(Q,x);if(!fe||B.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,q)??fe;let Oe;we.edit&&(Oe=n.WorkspaceEdit.from(we.edit,void 0));let Ge;if(we.command){const Ke=this.f.get(Q);Ke&&(Ge=this.h.toInternal(we.command,Ke))}return{edit:Oe,command:Ge}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class M{constructor(V,q,Q,x,fe){this.e=V,this.f=q,this.g=Q,this.h=x,this.j=fe,this.d=new t.$$mc("DocumentPasteEdit")}async prepareDocumentPaste(V,q,Q,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(V),we=q.map(Ke=>n.Range.to(Ke)),Oe=n.DataTransfer.toDataTransfer(Q,()=>{throw new R.$_});if(await this.g.prepareDocumentPaste(fe,we,Oe,x),x.isCancellationRequested)return;const Ge=Array.from(Oe).filter(([,Ke])=>!(Ke instanceof o.$SN));return n.DataTransfer.from(Ge)}async providePasteEdits(V,q,Q,x,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(q),Ge=Q.map(ot=>n.Range.to(ot)),Ke=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolvePasteFileData(this.h,V,ot)).buffer),tt=await this.g.provideDocumentPasteEdits(Oe,Ge,Ke,{only:fe.only?new o.$XN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,f.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,q){const[Q,x]=V,fe=this.d.get(Q,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class z{constructor(V,q){this.d=V,this.e=q}async provideDocumentFormattingEdits(V,q,Q){const x=this.d.getDocument(V),fe=await this.e.provideDocumentFormattingEdits(x,q,Q);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class _{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeFormattingEdits(V,q,Q,x){const fe=this.d.getDocument(V),we=n.Range.to(q),Oe=await this.e.provideDocumentRangeFormattingEdits(fe,we,Q,x);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,q,Q,x){(0,E.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(V),we=q.map(n.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(fe,we,Q,x);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}}class re{constructor(V,q){this.d=V,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,q,Q,x,fe){const we=this.d.getDocument(V),Oe=n.Position.to(q),Ge=await this.e.provideOnTypeFormattingEdits(we,Oe,Q,x,fe);if(Array.isArray(Ge))return Ge.map(n.TextEdit.from)}}class U{constructor(V,q){this.e=V,this.f=q,this.d=new t.$$mc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,q){const Q=await this.e.provideWorkspaceSymbols(V,q);if(!(0,r.$Mb)(Q))return{symbols:[]};const x=this.d.add(Q),fe={cacheId:x,symbols:[]};for(let we=0;we<Q.length;we++){const Oe=Q[we];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Oe),cacheId:[x,we]})}return fe}async resolveWorkspaceSymbol(V,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Q=this.d.get(...V.cacheId);if(Q){const x=await this.e.resolveWorkspaceSymbol(Q,q);return x&&(0,$.$eo)(V,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class G{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideRenameEdits(V,q,Q,x){const fe=this.d.getDocument(V),we=n.Position.to(q);try{const Oe=await this.e.provideRenameEdits(fe,we,Q,x);return Oe?n.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Ge=G.g(Oe);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(V,q,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(V),fe=n.Position.to(q);try{const we=await this.e.prepareRename(x,fe,Q);let Oe,Ge;if(o.$5M.isRange(we)?(Oe=we,Ge=x.getText(we)):(0,E.$gg)(we)&&(Oe=we.range,Ge=we.placeholder),!Oe||!Ge)return;if(Oe.start.line>fe.line||Oe.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Oe),text:Ge}}catch(we){const Oe=G.g(we);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class K{static{this.d={[c.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[c.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(V,q,Q){this.e=V,this.f=q,this.g=Q}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,q,Q,x){const fe=this.e.getDocument(V),we=n.Range.to(q);try{const Oe=K.d[Q],Ge=await this.f.provideNewSymbolNames(fe,we,Oe,x);return Ge?Ge.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Oe){this.g.error(K.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ee{constructor(V,q){this.resultId=V,this.tokens=q}}class ue{constructor(V,q){this.f=V,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,q,Q){const x=this.f.getDocument(V),fe=q!==0?this.d.get(q):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,Q):await this.g.provideDocumentSemanticTokens(x,Q);return fe&&this.d.delete(q),we?(we=ue.h(we),this.o(ue.n(fe,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ue.j(V)?ue.k(V)?V:new o.$lO(new Uint32Array(V.data),V.resultId):ue.l(V)?ue.m(V)?V:new o.$nO(V.edits.map(q=>new o.$mO(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const q of V.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(V,q){if(!ue.j(q)||!V||!V.tokens)return q;const Q=V.tokens,x=Q.length,fe=q.data,we=fe.length;let Oe=0;const Ge=Math.min(x,we);for(;Oe<Ge&&Q[Oe]===fe[Oe];)Oe++;if(Oe===x&&Oe===we)return new o.$nO([],q.resultId);let Ke=0;const tt=Ge-Oe;for(;Ke<tt&&Q[x-Ke-1]===fe[we-Ke-1];)Ke++;return new o.$nO([{start:Oe,deleteCount:x-Oe-Ke,data:fe.subarray(Oe,we-Ke)}],q.resultId)}o(V,q){if(ue.j(V)){const Q=this.e++;return this.d.set(Q,new ee(V.resultId,V.data)),(0,g.$Gcb)({id:Q,type:"full",data:V.data})}if(ue.l(V)){const Q=this.e++;return ue.j(q)?this.d.set(Q,new ee(q.resultId,q.data)):this.d.set(Q,new ee(V.resultId)),(0,g.$Gcb)({id:Q,type:"delta",deltas:(V.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeSemanticTokens(V,q,Q){const x=this.d.getDocument(V),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(q),Q);return fe?this.f(fe):null}f(V){return(0,g.$Gcb)({id:0,type:"full",data:V.data})}}class De{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,q,Q,x,fe){this.f=V,this.g=q,this.h=Q,this.j=x,this.k=fe,this.d=new t.$$mc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,q,Q,x){const fe=this.f.getDocument(V),we=n.Position.to(q),Oe=fe.getWordRangeAtPosition(we)||new o.$5M(we,we),Ge=Oe.with({end:we}),Ke=new l.$fe,tt=await this.h.provideCompletionItems(fe,we,x,n.CompletionContext.to(Q));if(!tt||x.isCancellationRequested)return;const rt=Array.isArray(tt)?new o.$zN(tt):tt,ot=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new T.$Uc;this.e.set(ot,nt);const ct=[],$t={x:ot,[s.ISuggestResultDtoField.completions]:ct,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Oe),insert:n.Range.from(Ge)},[s.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<rt.items.length;ht++){const at=rt.items[ht],Pe=this.l(at,[ot,ht],Ge,Oe);ct.push(Pe)}return $t}async resolveCompletionItem(V,q){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...V);if(!Q)return;const x=this.l(Q,V),fe=await this.h.resolveCompletionItem(Q,q);if(!fe)return;const we=this.l(fe,V);return(x[s.ISuggestDataDtoField.insertText]!==we[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==we[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==we[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==we[s.ISuggestDataDtoField.commandId]||!(0,$.$fo)(x[s.ISuggestDataDtoField.commandArguments],we[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:we[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:we[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:we[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:we[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:we[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:we[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:we[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:we[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q,Q,x){const fe=this.e.get(q[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,fe),Oe={x:q,[s.ISuggestDataDtoField.label]:V.label,[s.ISuggestDataDtoField.kind]:V.kind!==void 0?n.CompletionItemKind.from(V.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:V.tags&&V.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:V.detail,[s.ISuggestDataDtoField.documentation]:typeof V.documentation>"u"?void 0:n.MarkdownString.fromStrict(V.documentation),[s.ISuggestDataDtoField.sortText]:V.sortText!==V.label?V.sortText:void 0,[s.ISuggestDataDtoField.filterText]:V.filterText!==V.label?V.filterText:void 0,[s.ISuggestDataDtoField.preselect]:V.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:V.keepWhitespace?c.CompletionItemInsertTextRule.KeepWhitespace:c.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:V.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:V.additionalTextEdits&&V.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:we?.$ident,[s.ISuggestDataDtoField.commandId]:we?.id,[s.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe[s.ISuggestDataDtoField.insertText]=V.textEdit.newText):typeof V.insertText=="string"?Oe[s.ISuggestDataDtoField.insertText]=V.insertText:V.insertText instanceof o.$bN&&(Oe[s.ISuggestDataDtoField.insertText]=V.insertText.value,Oe[s.ISuggestDataDtoField.insertTextRules]|=c.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return V.textEdit?Ge=V.textEdit.range:V.range&&(Ge=V.range),o.$5M.isRange(Ge)?Oe[s.ISuggestDataDtoField.range]=n.Range.from(Ge):Ge&&(!Q?.isEqual(Ge.inserting)||!x?.isEqual(Ge.replacing))&&(Oe[s.ISuggestDataDtoField.range]={insert:n.Range.from(Ge.inserting),replace:n.Range.from(Ge.replacing)}),Oe}}class $e{async provideInlineCompletions(V,q,Q,x){}disposeCompletions(V){}handleDidShowCompletionItem(V,q,Q){}handlePartialAccept(V,q,Q,x){}}class J extends $e{constructor(V,q,Q,x){super(),this.f=V,this.g=q,this.h=Q,this.j=x,this.d=new se,this.e=(0,i.$3G)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$3G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,q,Q,x){const fe=this.g.getDocument(V),we=n.Position.to(q),Oe=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:n.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},x);if(!Oe||x.isCancellationRequested)return;const Ge=Array.isArray(Oe)?Oe:Oe.items,Ke=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],tt=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,ct)=>{let $t;nt.command&&(rt||(rt=new T.$Uc),$t=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:$t,idx:ct,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new T.$Uc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,q,Q){const x=this.d.get(V)?.items[q];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,Q)}handlePartialAccept(V,q,Q,x){const fe=this.d.get(V)?.items[q];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Q),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class W{async provideInlineEdits(V,q,Q){const x=this.f.getDocument(V),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[q.triggerKind]},Q);if(!fe||Q.isCancellationRequested)return;let we;const Oe=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ge;fe.accepted&&(we||(we=new T.$Uc),Ge=this.h.toInternal(fe.accepted,we));let Ke;return fe.rejected&&(we||(we=new T.$Uc),Ke=this.h.toInternal(fe.rejected,we)),{pid:Oe,text:fe.text,range:n.Range.from(fe.range),accepted:Ge,rejected:Ke}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,q,Q,x){this.f=q,this.g=Q,this.h=x,this.d=new se,this.e={[c.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const q=this.e++;return this.d.set(q,V),q}disposeReferenceId(V){const q=this.d.get(V);return this.d.delete(V),q}get(V){return this.d.get(V)}}class oe{constructor(V,q){this.e=V,this.f=q,this.d=new t.$$mc("SignatureHelp")}async provideSignatureHelp(V,q,Q,x){const fe=this.e.getDocument(V),we=n.Position.to(q),Oe=this.g(Q),Ge=await this.f.provideSignatureHelp(fe,we,x,Oe);if(Ge){const Ke=this.d.add([Ge]);return{...n.SignatureHelp.from(Ge),id:Ke}}}g(V){let q;if(V.activeSignatureHelp){const Q=n.SignatureHelp.to(V.activeSignatureHelp),x=this.d.get(V.activeSignatureHelp.id,0);x?(q=x,q.activeSignature=Q.activeSignature,q.activeParameter=Q.activeParameter):q=Q}return{...V,activeSignatureHelp:q}}releaseSignatureHelp(V){this.d.delete(V)}}class te{constructor(V,q,Q,x,fe){this.f=V,this.g=q,this.h=Q,this.j=x,this.k=fe,this.d=new t.$$mc("InlayHints"),this.e=new Map}async provideInlayHints(V,q,Q){const x=this.f.getDocument(V),fe=n.Range.to(q),we=await this.h.provideInlayHints(x,fe,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Q.isCancellationRequested)return;const Oe=this.d.add(we);this.e.set(Oe,new T.$Uc);const Ge={hints:[],cacheId:Oe};for(let Ke=0;Ke<we.length;Ke++)this.l(we[Ke],fe)&&Ge.hints.push(this.m(we[Ke],[Oe,Ke]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Ge}async resolveInlayHint(V,q){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...V);if(!Q)return;const x=await this.h.resolveInlayHint(Q,q);if(x&&this.l(x))return this.m(x,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(q&&!q.contains(V.position))}m(V,q){const Q=this.e.get(q[0]);if(!Q)throw Error("DisposableStore is missing...");const x={label:"",cacheId:q,tooltip:n.MarkdownString.fromStrict(V.tooltip),position:n.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(n.TextEdit.from),kind:V.kind&&n.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")x.label=V.label;else{const fe=[];x.label=fe;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};o.$cN.isLocation(we.location)&&(Oe.location=n.location.from(we.location)),we.command&&(Oe.command=this.g.toInternal(we.command,Q)),fe.push(Oe)}}return x}}class le{constructor(V,q){this.e=V,this.f=q,this.d=new t.$$mc("DocumentLink")}async provideLinks(V,q){const Q=this.e.getDocument(V),x=await this.f.provideDocumentLinks(Q,q);if(!(!Array.isArray(x)||x.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),we={links:[],cacheId:fe};for(let Oe=0;Oe<x.length;Oe++){if(!le.g(x[Oe]))continue;const Ge=n.DocumentLink.from(x[Oe]);Ge.cacheId=[fe,Oe],we.links.push(Ge)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,q){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...V);if(!Q)return;const x=await this.f.resolveDocumentLink(Q,q);if(!(!x||!le.g(x)))return n.DocumentLink.from(x)}releaseLinks(V){this.d.delete(V)}}class he{constructor(V,q){this.d=V,this.e=q}async provideColors(V,q){const Q=this.d.getDocument(V),x=await this.e.provideDocumentColors(Q,q);return Array.isArray(x)?x.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(V,q,Q){const x=this.d.getDocument(V),fe=n.Range.to(q.range),we=n.Color.to(q.color),Oe=await this.e.provideColorPresentations(we,{document:x,range:fe},Q);if(Array.isArray(Oe))return Oe.map(n.ColorPresentation.from)}}class Z{constructor(V,q){this.d=V,this.e=q}async provideFoldingRanges(V,q,Q){const x=this.d.getDocument(V),fe=await this.e.provideFoldingRanges(x,q,Q);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class ae{constructor(V,q,Q){this.d=V,this.e=q,this.f=Q}async provideSelectionRanges(V,q,Q){const x=this.d.getDocument(V),fe=q.map(n.Position.to),we=await this.e.provideSelectionRanges(x,fe,Q);if(!(0,r.$Mb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Ge=0;Ge<fe.length;Ge++){const Ke=[];Oe.push(Ke);let tt=fe[Ge],rt=we[Ge];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return Oe}}class pe{constructor(V,q){this.f=V,this.g=q,this.d=new N.$zP(""),this.e=new Map}async prepareSession(V,q,Q){const x=this.f.getDocument(V),fe=n.Position.to(q),we=await this.g.prepareCallHierarchy(x,fe,Q);if(!we)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(we)?we.map(Ge=>this.h(Oe,Ge)):[this.h(Oe,we)]}async provideCallsTo(V,q,Q){const x=this.j(V,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,Q);if(fe)return fe.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Oe=>n.Range.from(Oe))}))}async provideCallsFrom(V,q,Q){const x=this.j(V,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,Q);if(fe)return fe.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Oe=>n.Range.from(Oe))}))}releaseSession(V){this.e.delete(V)}h(V,q){const Q=this.e.get(V),x=n.CallHierarchyItem.from(q,V,Q.size.toString(36));return Q.set(x._itemId,q),x}j(V,q){return this.e.get(V)?.get(q)}}class be{constructor(V,q){this.f=V,this.g=q,this.d=new N.$zP(""),this.e=new Map}async prepareSession(V,q,Q){const x=this.f.getDocument(V),fe=n.Position.to(q),we=await this.g.prepareTypeHierarchy(x,fe,Q);if(!we)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(we)?we.map(Ge=>this.h(Oe,Ge)):[this.h(Oe,we)]}async provideSupertypes(V,q,Q){const x=this.j(V,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,Q);if(fe)return fe.map(we=>this.h(V,we))}async provideSubtypes(V,q,Q){const x=this.j(V,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,Q);if(fe)return fe.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,q){const Q=this.e.get(V),x=n.TypeHierarchyItem.from(q,V,Q.size.toString(36));return Q.set(x._itemId,q),x}j(V,q){return this.e.get(V)?.get(q)}}class Me{constructor(V,q,Q,x,fe){this.e=V,this.f=q,this.g=Q,this.h=x,this.j=fe,this.d=new t.$$mc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,q,Q,x,fe){const we=this.f.getDocument(q),Oe=n.Position.to(Q),Ge=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,ot)).buffer),Ke=await this.g.provideDocumentDropEdits(we,Oe,Ge,fe);if(!Ke)return;const tt=(0,r.$3b)(Ke),rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,f.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,q){const[Q,x]=V,fe=this.d.get(Q,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class ze{constructor(V,q){this.d=V,this.e=q}async provideMappedEdits(V,q,Q,x){const fe=u.URI.revive(V),we=this.d.getDocument(fe),Oe=Q.documents.map(tt=>tt.map(rt=>({uri:u.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),Ge={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(we,q,Ge,x);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(V,q){this.adapter=V,this.extension=q}}class Ie{static{this.d=0}constructor(V,q,Q,x,fe,we,Oe,Ge){this.g=q,this.h=Q,this.j=x,this.k=fe,this.l=we,this.m=Oe,this.n=Ge,this.f=new Map,this.e=V.getProxy(s.$1M.MainThreadLanguageFeatures)}o(V,q){return n.DocumentSelector.from(V,this.g,q)}p(V){return new o.$3M(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ie.d++}async s(V,q,Q,x,fe,we=!1){const Oe=this.f.get(V);if(!Oe||!(Oe.adapter instanceof q))return x;const Ge=Date.now();we||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Ke=Q(Oe.adapter,Oe.extension);return Promise.resolve(Ke).catch(tt=>{(0,R.$5)(tt)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Oe.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),A.CancellationToken.isCancellationToken(fe)?(0,h.$th)(Ke,fe):Ke}t(V,q){const Q=this.q();return this.f.set(Q,new ke(V,q)),Q}static u(V){return V.displayName||V.name}static w(V){return V.identifier.value}registerDocumentSymbolProvider(V,q,Q,x){const fe=this.t(new d(this.h,Q),V),we=x&&x.label||Ie.u(V);return this.e.$registerDocumentSymbolProvider(fe,this.o(q,V),we),this.p(fe)}$provideDocumentSymbols(V,q,Q){return this.s(V,d,x=>x.provideDocumentSymbols(u.URI.revive(q),Q),void 0,Q)}registerCodeLensProvider(V,q,Q){const x=this.q(),fe=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new a(this.h,this.j.converter,Q,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(x,this.o(q,V),fe);let we=this.p(x);if(fe!==void 0){const Oe=Q.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(fe));we=o.$3M.from(we,Oe)}return we}$provideCodeLenses(V,q,Q){return this.s(V,a,x=>x.provideCodeLenses(u.URI.revive(q),Q),void 0,Q)}$resolveCodeLens(V,q,Q){return this.s(V,a,x=>x.resolveCodeLens(q,Q),void 0,void 0)}$releaseCodeLenses(V,q){this.s(V,a,Q=>Promise.resolve(Q.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(V,q,Q){const x=this.t(new y(this.h,Q),V);return this.e.$registerDefinitionSupport(x,this.o(q,V)),this.p(x)}$provideDefinition(V,q,Q,x){return this.s(V,y,fe=>fe.provideDefinition(u.URI.revive(q),Q,x),[],x)}registerDeclarationProvider(V,q,Q){const x=this.t(new S(this.h,Q),V);return this.e.$registerDeclarationSupport(x,this.o(q,V)),this.p(x)}$provideDeclaration(V,q,Q,x){return this.s(V,S,fe=>fe.provideDeclaration(u.URI.revive(q),Q,x),[],x)}registerImplementationProvider(V,q,Q){const x=this.t(new D(this.h,Q),V);return this.e.$registerImplementationSupport(x,this.o(q,V)),this.p(x)}$provideImplementation(V,q,Q,x){return this.s(V,D,fe=>fe.provideImplementation(u.URI.revive(q),Q,x),[],x)}registerTypeDefinitionProvider(V,q,Q){const x=this.t(new P(this.h,Q),V);return this.e.$registerTypeDefinitionSupport(x,this.o(q,V)),this.p(x)}$provideTypeDefinition(V,q,Q,x){return this.s(V,P,fe=>fe.provideTypeDefinition(u.URI.revive(q),Q,x),[],x)}registerHoverProvider(V,q,Q,x){const fe=this.t(new C(this.h,Q),V);return this.e.$registerHoverProvider(fe,this.o(q,V)),this.p(fe)}$provideHover(V,q,Q,x,fe){return this.s(V,C,we=>we.provideHover(u.URI.revive(q),Q,x,fe),void 0,fe)}$releaseHover(V,q){this.s(V,C,Q=>Promise.resolve(Q.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(V,q,Q,x){const fe=this.t(new p(this.h,Q),V);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(q,V)),this.p(fe)}$provideEvaluatableExpression(V,q,Q,x){return this.s(V,p,fe=>fe.provideEvaluatableExpression(u.URI.revive(q),Q,x),void 0,x)}registerInlineValuesProvider(V,q,Q,x){const fe=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new v(this.h,Q),V);this.e.$registerInlineValuesProvider(we,this.o(q,V),fe);let Oe=this.p(we);if(fe!==void 0){const Ge=Q.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(fe));Oe=o.$3M.from(Oe,Ge)}return Oe}$provideInlineValues(V,q,Q,x,fe){return this.s(V,v,we=>we.provideInlineValues(u.URI.revive(q),Q,x,fe),void 0,fe)}registerDocumentHighlightProvider(V,q,Q){const x=this.t(new O(this.h,Q),V);return this.e.$registerDocumentHighlightProvider(x,this.o(q,V)),this.p(x)}registerMultiDocumentHighlightProvider(V,q,Q){const x=this.t(new L(this.h,Q),V);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(q,V)),this.p(x)}$provideDocumentHighlights(V,q,Q,x){return this.s(V,O,fe=>fe.provideDocumentHighlights(u.URI.revive(q),Q,x),void 0,x)}$provideMultiDocumentHighlights(V,q,Q,x,fe){return this.s(V,L,we=>we.provideMultiDocumentHighlights(u.URI.revive(q),Q,x.map(Oe=>u.URI.revive(Oe)),fe),void 0,fe)}registerLinkedEditingRangeProvider(V,q,Q){const x=this.t(new F(this.h,Q),V);return this.e.$registerLinkedEditingRangeProvider(x,this.o(q,V)),this.p(x)}$provideLinkedEditingRanges(V,q,Q,x){return this.s(V,F,async fe=>{const we=await fe.provideLinkedEditingRanges(u.URI.revive(q),Q,x);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.y(we.wordPattern):void 0}},void 0,x)}registerReferenceProvider(V,q,Q){const x=this.t(new j(this.h,Q),V);return this.e.$registerReferenceSupport(x,this.o(q,V)),this.p(x)}$provideReferences(V,q,Q,x,fe){return this.s(V,j,we=>we.provideReferences(u.URI.revive(q),Q,x,fe),void 0,fe)}registerCodeActionProvider(V,q,Q,x){const fe=new T.$Uc,we=this.t(new B(this.h,this.j.converter,this.k,Q,this.l,V,this.m),V);return this.e.$registerCodeActionSupport(we,this.o(q,V),{providedKinds:x?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:x?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,fe)}))},Ie.u(V),Ie.w(V),!!Q.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(V,q,Q,x,fe){return this.s(V,B,we=>we.provideCodeActions(u.URI.revive(q),Q,x,fe),void 0,fe)}$resolveCodeAction(V,q,Q){return this.s(V,B,x=>x.resolveCodeAction(q,Q),{},void 0)}$releaseCodeActions(V,q){this.s(V,B,Q=>Promise.resolve(Q.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(V,q,Q){const x=this.t(new z(this.h,Q),V);return this.e.$registerDocumentFormattingSupport(x,this.o(q,V),V.identifier,V.displayName||V.name),this.p(x)}$provideDocumentFormattingEdits(V,q,Q,x){return this.s(V,z,fe=>fe.provideDocumentFormattingEdits(u.URI.revive(q),Q,x),void 0,x)}registerDocumentRangeFormattingEditProvider(V,q,Q){const x=typeof Q.provideDocumentRangesFormattingEdits=="function",fe=this.t(new _(this.h,Q),V);return this.e.$registerRangeFormattingSupport(fe,this.o(q,V),V.identifier,V.displayName||V.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(V,q,Q,x,fe){return this.s(V,_,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(q),Q,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(V,q,Q,x,fe){return this.s(V,_,we=>we.provideDocumentRangesFormattingEdits(u.URI.revive(q),Q,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(V,q,Q,x){const fe=this.t(new re(this.h,Q),V);return this.e.$registerOnTypeFormattingSupport(fe,this.o(q,V),x,V.identifier),this.p(fe)}$provideOnTypeFormattingEdits(V,q,Q,x,fe,we){return this.s(V,re,Oe=>Oe.provideOnTypeFormattingEdits(u.URI.revive(q),Q,x,fe,we),void 0,we)}registerWorkspaceSymbolProvider(V,q){const Q=this.t(new U(q,this.l),V);return this.e.$registerNavigateTypeSupport(Q,typeof q.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(V,q,Q){return this.s(V,U,x=>x.provideWorkspaceSymbols(q,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(V,q,Q){return this.s(V,U,x=>x.resolveWorkspaceSymbol(q,Q),void 0,void 0)}$releaseWorkspaceSymbols(V,q){this.s(V,U,Q=>Q.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(V,q,Q){const x=this.t(new G(this.h,Q,this.l),V);return this.e.$registerRenameSupport(x,this.o(q,V),G.supportsResolving(Q)),this.p(x)}$provideRenameEdits(V,q,Q,x,fe){return this.s(V,G,we=>we.provideRenameEdits(u.URI.revive(q),Q,x,fe),void 0,fe)}$resolveRenameLocation(V,q,Q,x){return this.s(V,G,fe=>fe.resolveRenameLocation(u.URI.revive(q),Q,x),void 0,x)}registerNewSymbolNamesProvider(V,q,Q){const x=this.t(new K(this.h,Q,this.l),V);return this.e.$registerNewSymbolNamesProvider(x,this.o(q,V)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,K,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,q,Q,x,fe){return this.s(V,K,we=>we.provideNewSymbolNames(u.URI.revive(q),Q,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(V,q,Q,x){const fe=this.t(new ue(this.h,Q),V),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(q,V),x,we);let Oe=this.p(fe);if(we){const Ge=Q.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(we));Oe=o.$3M.from(Oe,Ge)}return Oe}$provideDocumentSemanticTokens(V,q,Q,x){return this.s(V,ue,fe=>fe.provideDocumentSemanticTokens(u.URI.revive(q),Q,x),null,x)}$releaseDocumentSemanticTokens(V,q){this.s(V,ue,Q=>Q.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,q,Q,x){const fe=this.t(new ne(this.h,Q),V);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(q,V),x),this.p(fe)}$provideDocumentRangeSemanticTokens(V,q,Q,x){return this.s(V,ne,fe=>fe.provideDocumentRangeSemanticTokens(u.URI.revive(q),Q,x),null,x)}registerCompletionItemProvider(V,q,Q,x){const fe=this.t(new De(this.h,this.j.converter,Q,this.m,V),V);return this.e.$registerCompletionsProvider(fe,this.o(q,V),x,De.supportsResolving(Q),V.identifier),this.p(fe)}$provideCompletionItems(V,q,Q,x,fe){return this.s(V,De,we=>we.provideCompletionItems(u.URI.revive(q),Q,x,fe),void 0,fe)}$resolveCompletionItem(V,q,Q){return this.s(V,De,x=>x.resolveCompletionItem(q,Q),void 0,Q)}$releaseCompletionItems(V,q){this.s(V,De,Q=>Q.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(V,q,Q,x){const fe=new J(V,this.h,Q,this.j.converter),we=this.t(fe,V);return this.e.$registerInlineCompletionsSupport(we,this.o(q,V),fe.supportsHandleEvents,m.$pn.toKey(V.identifier.value),x?.yieldTo?.map(Oe=>m.$pn.toKey(Oe))||[]),this.p(we)}$provideInlineCompletions(V,q,Q,x,fe){return this.s(V,$e,we=>we.provideInlineCompletions(u.URI.revive(q),Q,x,fe),void 0,fe)}$handleInlineCompletionDidShow(V,q,Q,x){this.s(V,$e,async fe=>{fe.handleDidShowCompletionItem(q,Q,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,q,Q,x,fe){this.s(V,$e,async we=>{we.handlePartialAccept(q,Q,x,fe)},void 0,void 0)}$freeInlineCompletionsList(V,q){this.s(V,$e,async Q=>{Q.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(V,q,Q){const x=new W(V,this.h,Q,this.j.converter),fe=this.t(x,V);return this.e.$registerInlineEditProvider(fe,this.o(q,V),V.identifier),this.p(fe)}$provideInlineEdit(V,q,Q,x){return this.s(V,W,fe=>fe.provideInlineEdits(u.URI.revive(q),Q,x),void 0,x)}$freeInlineEdit(V,q){this.s(V,W,async Q=>{Q.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(V,q,Q,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,we=this.t(new oe(this.h,Q),V);return this.e.$registerSignatureHelpProvider(we,this.o(q,V),fe),this.p(we)}$provideSignatureHelp(V,q,Q,x,fe){return this.s(V,oe,we=>we.provideSignatureHelp(u.URI.revive(q),Q,x,fe),void 0,fe)}$releaseSignatureHelp(V,q){this.s(V,oe,Q=>Q.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(V,q,Q){const x=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new te(this.h,this.j.converter,Q,this.l,V),V);this.e.$registerInlayHintsProvider(fe,this.o(q,V),typeof Q.resolveInlayHint=="function",x,Ie.u(V));let we=this.p(fe);if(x!==void 0){const Oe=Q.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(x));we=o.$3M.from(we,Oe)}return we}$provideInlayHints(V,q,Q,x){return this.s(V,te,fe=>fe.provideInlayHints(u.URI.revive(q),Q,x),void 0,x)}$resolveInlayHint(V,q,Q){return this.s(V,te,x=>x.resolveInlayHint(q,Q),void 0,Q)}$releaseInlayHints(V,q){this.s(V,te,Q=>Q.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(V,q,Q){const x=this.t(new le(this.h,Q),V);return this.e.$registerDocumentLinkProvider(x,this.o(q,V),typeof Q.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(V,q,Q){return this.s(V,le,x=>x.provideLinks(u.URI.revive(q),Q),void 0,Q,q.scheme==="output")}$resolveDocumentLink(V,q,Q){return this.s(V,le,x=>x.resolveLink(q,Q),void 0,void 0,!0)}$releaseDocumentLinks(V,q){this.s(V,le,Q=>Q.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(V,q,Q){const x=this.t(new he(this.h,Q),V);return this.e.$registerDocumentColorProvider(x,this.o(q,V)),this.p(x)}$provideDocumentColors(V,q,Q){return this.s(V,he,x=>x.provideColors(u.URI.revive(q),Q),[],Q)}$provideColorPresentations(V,q,Q,x){return this.s(V,he,fe=>fe.provideColorPresentations(u.URI.revive(q),Q,x),void 0,x)}registerFoldingRangeProvider(V,q,Q){const x=this.q(),fe=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new Z(this.h,Q),V)),this.e.$registerFoldingRangeProvider(x,this.o(q,V),V.identifier,fe);let we=this.p(x);if(fe!==void 0){const Oe=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=o.$3M.from(we,Oe)}return we}$provideFoldingRanges(V,q,Q,x){return this.s(V,Z,fe=>fe.provideFoldingRanges(u.URI.revive(q),Q,x),void 0,x)}registerSelectionRangeProvider(V,q,Q){const x=this.t(new ae(this.h,Q,this.l),V);return this.e.$registerSelectionRangeProvider(x,this.o(q,V)),this.p(x)}$provideSelectionRanges(V,q,Q,x){return this.s(V,ae,fe=>fe.provideSelectionRanges(u.URI.revive(q),Q,x),[],x)}registerCallHierarchyProvider(V,q,Q){const x=this.t(new pe(this.h,Q),V);return this.e.$registerCallHierarchyProvider(x,this.o(q,V)),this.p(x)}$prepareCallHierarchy(V,q,Q,x){return this.s(V,pe,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(q),Q,x)),void 0,x)}$provideCallHierarchyIncomingCalls(V,q,Q,x){return this.s(V,pe,fe=>fe.provideCallsTo(q,Q,x),void 0,x)}$provideCallHierarchyOutgoingCalls(V,q,Q,x){return this.s(V,pe,fe=>fe.provideCallsFrom(q,Q,x),void 0,x)}$releaseCallHierarchy(V,q){this.s(V,pe,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(V,q,Q){const x=this.t(new be(this.h,Q),V);return this.e.$registerTypeHierarchyProvider(x,this.o(q,V)),this.p(x)}$prepareTypeHierarchy(V,q,Q,x){return this.s(V,be,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(q),Q,x)),void 0,x)}$provideTypeHierarchySupertypes(V,q,Q,x){return this.s(V,be,fe=>fe.provideSupertypes(q,Q,x),void 0,x)}$provideTypeHierarchySubtypes(V,q,Q,x){return this.s(V,be,fe=>fe.provideSubtypes(q,Q,x),void 0,x)}$releaseTypeHierarchy(V,q){this.s(V,be,Q=>Promise.resolve(Q.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(V,q,Q,x){const fe=this.q();return this.f.set(fe,new ke(new Me(this.e,this.h,Q,fe,V),V)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(q,V),(0,i.$3G)(V,"documentPaste")&&x?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(V,q,Q,x,fe,we){return this.s(V,Me,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(q,u.URI.revive(Q),x,fe,we)),void 0,void 0)}$resolveDropEdit(V,q,Q){return this.s(V,Me,x=>x.resolveDropEdit(q,Q),{},void 0)}$releaseDropEdits(V,q){this.s(V,Me,Q=>Promise.resolve(Q.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(V,q,Q){const x=this.t(new ze(this.h,Q),V);return this.e.$registerMappedEditsProvider(x,this.o(q,V)),this.p(x)}$provideMappedEdits(V,q,Q,x,fe){return this.s(V,ze,we=>Promise.resolve(we.provideMappedEdits(q,Q,x,fe)),null,fe)}registerDocumentPasteEditProvider(V,q,Q,x){const fe=this.q();return this.f.set(fe,new ke(new M(this.e,this.h,Q,fe,V),V)),this.e.$registerPasteEditProvider(fe,this.o(q,V),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(V,q,Q,x,fe){return this.s(V,M,we=>we.prepareDocumentPaste(u.URI.revive(q),Q,x,fe),void 0,fe)}$providePasteEdits(V,q,Q,x,fe,we,Oe){return this.s(V,M,Ge=>Ge.providePasteEdits(q,u.URI.revive(Q),x,fe,we,Oe),void 0,Oe)}$resolvePasteEdit(V,q,Q){return this.s(V,M,x=>x.resolvePasteEdit(q,Q),{},void 0)}$releasePasteEdits(V,q){this.s(V,M,Q=>Promise.resolve(Q.releasePasteEdits(q)),void 0,void 0)}static y(V){return{pattern:V.source,flags:V.flags}}static z(V){return{decreaseIndentPattern:Ie.y(V.decreaseIndentPattern),increaseIndentPattern:Ie.y(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie.y(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie.y(V.unIndentedLinePattern):void 0}}static B(V){return{beforeText:Ie.y(V.beforeText),afterText:V.afterText?Ie.y(V.afterText):void 0,previousLineText:V.previousLineText?Ie.y(V.previousLineText):void 0,action:V.action}}static C(V){return V.map(Ie.B)}static D(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(q=>o.SyntaxTokenType.toString(q)):void 0}}static E(V){return V.map(Ie.D)}setLanguageConfiguration(V,q,Q){const{wordPattern:x}=Q;if(x&&(0,I.$rf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(q,x):this.h.setWordDefinitionFor(q,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Ie.y(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Ie.z(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Ie.C(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Ie.E(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,q,we),this.p(fe)}$setWordDefinitions(V){for(const q of V)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$inc=Ie}),define(Ee[129],Se([1,0,9,21,14,4,40,3,236,24,5,12,90,6,128,20,17,10,155,26]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0,g=We(g),f=We(f),e.$2nc=(0,I.$Ei)("IExtHostLanguageModels");class i{constructor(a,w){this.option=a,this.stream=new r.$8h,this.stream=w??new r.$8h}}class t{constructor(){this.a=new Map,this.b=new r.$8h,this.c=!1,this.d=!1;const a=this;this.apiObject={stream:a.b.asyncIterable,text:r.$5h.map(a.b.asyncIterable,w=>{if(w instanceof f.$eP)return w.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,a]of this.a)yield a.stream;else yield this.b}handleFragment(a){if(this.c)return;this.d=!0;let w=this.a.get(a.index);w||(this.a.size===0?w=new i(a.index,this.b):w=new i(a.index),this.a.set(a.index,w));let y;a.part.type==="text"?y=new f.$eP(a.part.value):y=new f.$dP(a.part.name,a.part.parameters),w.stream.emitOne(y)}get isStreaming(){return this.d}reject(a){this.c=!0;for(const w of this.f())w.reject(a)}resolve(){this.c=!0;for(const a of this.f())a.resolve()}}let s=class{static{o=this}static{this.a=1}constructor(a,w,y){this.j=w,this.k=y,this.c=new R.$le,this.d=new R.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new l.$rn,this.i=new Map,this.r=new Set,this.b=a.getProxy(k.$1M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(a,w,y,S){const D=o.a++;this.f.set(D,{extension:a.identifier,provider:y,languageModelId:w});let P;S.auth&&(P={providerLabel:a.displayName||a.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,`${l.$pn.toKey(a.identifier)}/${D}/${w}`,{extension:a.identifier,id:w,vendor:S.vendor??l.$pn.toKey(a.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:P,targetExtensions:S.extensions});const C=y.onDidReceiveLanguageModelResponse2?.(({extensionId:p,participant:v,tokenCount:O})=>{this.b.$whenLanguageModelChatRequestMade(w,new l.$pn(p),v,O)});return(0,T.$Tc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D),C?.dispose()})}async $provideLanguageModelResponse(a,w,y,S,D,P){const C=this.f.get(a);if(!C)return;const p=new u.$rw(async v=>{if(P.isCancellationRequested){this.j.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let O;if(v.part instanceof f.$dP?O={type:"function_use",name:v.part.name,parameters:v.part.parameters}:v.part instanceof f.$eP&&(O={type:"text",value:v.part.value}),!O){this.j.warn(`[CHAT](${C.extension.value}) UNKNOWN part ${JSON.stringify(v)}`);return}this.b.$handleProgressChunk(w,{index:v.index,part:O})});if(C.provider.provideLanguageModelResponse2)return C.provider.provideLanguageModelResponse2(S.map(g.LanguageModelChatMessage.to),D,l.$pn.toKey(y),p,P);{const v=new u.$rw(async O=>{p.report({index:O.index,part:new f.$eP(O.part)})});return C.provider.provideLanguageModelResponse(S.map(g.LanguageModelChatMessage.to),D?.modelOptions??{},l.$pn.toKey(y),v,P)}}$provideTokenLength(a,w,y){const S=this.f.get(a);return S?Promise.resolve(S.provider.provideTokenCount(w,y)):Promise.resolve(0)}$acceptChatModelMetadata(a){if(a.added)for(const{identifier:w,metadata:y}of a.added)this.g.set(w,{metadata:y,apiObjects:new l.$rn});if(a.removed)for(const w of a.removed){this.g.delete(w);for(const[y,S]of this.i)S.languageModelId===w&&(S.res.reject(new A.$6),this.i.delete(y))}a.added?.forEach(w=>this.p(w.metadata)),this.d.fire(void 0)}async selectLanguageModels(a,w){const y=await this.b.$selectChatModels({...w,extension:a.identifier}),S=[],D=this;for(const P of y){const C=this.g.get(P);if(!C)continue;this.o(a.identifier,C.metadata)&&await this.p(C.metadata);let p=C.apiObjects.get(a.identifier);p||(p={id:P,vendor:C.metadata.vendor,family:C.metadata.family,version:C.metadata.version,name:C.metadata.name,maxInputTokens:C.metadata.maxInputTokens,countTokens(v,O){if(!D.g.has(P))throw f.$iP.NotFound(P);return D.q(P,v,O??h.CancellationToken.None)},sendRequest(v,O,L){if(!D.g.has(P))throw f.$iP.NotFound(P);return D.l(a,P,v,O??{},L??h.CancellationToken.None)}},Object.freeze(p),C.apiObjects.set(a.identifier,p)),S.push(p)}return S}async l(a,w,y,S,D){const P=this.m(a,y),C=a.identifier,p=this.g.get(w)?.metadata;if(!p||!this.g.has(w))throw f.$iP.NotFound(`Language model '${w}' is unknown.`);if(this.o(C,p)&&(!await this.n(a,{identifier:p.extension,displayName:p.auth.providerLabel},S.justification,!1)||!this.h.get(C)?.has(p.extension)))throw f.$iP.NoPermissions(`Language model '${w}' cannot be used by '${C.value}'.`);const v=Math.random()*1e6|0,O=this.b.$fetchResponse(C,w,v,P,S,D),L=new r.$Dh,F=new t;this.i.set(v,{languageModelId:w,res:F});let j;if(O.catch(B=>{L.isOpen()?F.reject(B):j=B}).finally(()=>{this.i.delete(v),F.resolve(),L.open()}),await L.wait(),j)throw j.name===f.$iP.name?j:new f.$iP(`Language model '${w}' errored, check cause for more details`,"Unknown",j);return F.apiObject}m(a,w){const y=[];for(const S of w)S.role===f.LanguageModelChatMessageRole.System&&(0,n.$4G)(a,"languageModelSystem"),S.content2 instanceof f.$bP&&(0,n.$4G)(a,"lmTools"),y.push(g.LanguageModelChatMessage.from(S));return y}async $handleResponseFragment(a,w){const y=this.i.get(a);y&&y.res.handleFragment(w)}async n(a,w,y,S){const D=m.$3L+w.identifier.value;if(await this.k.getSession(a,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:a.identifier,to:w.identifier,enabled:!0}]),!0;if(S)return!1;try{const C=y?(0,$.localize)(0,null,w.displayName,y):void 0;return await this.k.getSession(a,D,[],{forceNewSession:{detail:C}}),this.$updateModelAccesslist([{from:a.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}o(a,w){return!!w.auth&&!l.$pn.equals(w.extension,a)}async p(a){if(a.auth)for(const w of this.r)try{await this.n(w,{identifier:a.extension,displayName:""},void 0,!0)}catch(y){this.j.error("Fake Auth request failed"),this.j.error(y)}}async q(a,w,y){if(!this.g.get(a))throw f.$iP.NotFound(`Language model '${a}' is unknown.`);const D=N.Iterable.find(this.f.values(),P=>P.languageModelId===a);return D?D.provider.provideTokenCount(w,y):this.b.$countTokens(a,typeof w=="string"?w:g.LanguageModelChatMessage.from(w),y)}$updateModelAccesslist(a){const w=new Array;for(const{from:y,to:S,enabled:D}of a){const P=this.h.get(y)??new l.$qn;if(P.has(S)!==D){D?P.add(S):P.delete(S),this.h.set(y,P);const p={from:y,to:S};w.push(p),this.c.fire(p)}}}createLanguageModelAccessInformation(a){this.r.add(a);const w=this,y=R.Event.signal(R.Event.filter(this.c.event,D=>l.$pn.equals(D.from,a.identifier))),S=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(y,S)},canSendRequest(D){let P;e:for(const[p,v]of w.g)for(const O of v.apiObjects.values())if(O===D){P=v.metadata;break e}if(!P)return;if(!w.o(a.identifier,P))return!0;const C=w.h.get(a.identifier);if(C)return C.has(P.extension)}}}};e.$3nc=s,e.$3nc=s=o=Qe([qe(0,c.$uP),qe(1,E.$$j),qe(2,b.$knc)],s)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[356],Se([1,0,6,17,10,44,9,3,26]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0,h=We(h),R=zt(R);class l{constructor(E,u,k,b){this.c=u,this.d=k,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(r.$1M.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const k=this.c.getDocumentData(E);if(!k)throw new Error(`document '${E.toString()}' NOT found`);return k.document}async tokenAtPosition(E,u){const k=E.version,b=h.Position.from(u),c=await this.a.$tokensAtPosition(E.uri,b),g={type:A.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new A.$5M(u.line,u.character,u.line,u.character)};if(!c)return g;const f={range:h.Range.to(c.range),type:h.TokenType.to(c.type)};return!f.range.contains(u)||k!==E.version?g:f}createLanguageStatusItem(E,u,k){const b=this.f++,c=this.a,g=this.g,f=`${E.identifier.value}/${u}`;if(g.has(f))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);g.add(f);const m={selector:k,id:u,name:E.displayName??E.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new T.$Uc,i=()=>{if(n?.dispose(),!g.has(f)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,N.$Gh)(()=>{o.clear(),this.a.$setLanguageStatus(b,{id:f,name:m.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===A.LanguageStatusSeverity.Error?R.default.Error:m.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:m.command&&this.d.toInternal(m.command,o),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),c.$removeLanguageStatus(b),g.delete(f)},get id(){return m.id},get name(){return m.name},set name(s){m.name=s,i()},get selector(){return m.selector},set selector(s){m.selector=s,i()},get text(){return m.text},set text(s){m.text=s,i()},set text2(s){(0,$.$4G)(E,"languageStatusText"),m.text=s,i()},get text2(){return(0,$.$4G)(E,"languageStatusText"),m.text},get detail(){return m.detail},set detail(s){m.detail=s,i()},get severity(){return m.severity},set severity(s){m.severity=s,i()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(s){m.accessibilityInformation=s,i()},get command(){return m.command},set command(s){m.command=s,i()},get busy(){return m.busy},set busy(s){m.busy=s,i()}};return i(),t}}e.$Moc=l}),define(Ee[357],Se([1,0,15,2,17,10,127]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=void 0,A=We(A),N=We(N);class T{constructor(E,u,k,b){this.start=E,this.deletedCount=u,this.deletedItems=k,this.items=b}asApiEvent(){return{range:new R.$sO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,k){this.notebook=E,this.h=u,this.j=k,this.handle=k.handle,this.uri=h.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(A.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(b){E.g=b},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(k)}return this.f}setOutputs(E){this.a=E.map(A.NotebookCellOutput.to)}setOutputItems(E,u,k){const b=k.map(A.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===E);if(c&&(u||(c.items.length=0),c.items.push(...b),c.items.length>1&&c.items.every(g=>N.$6K(g.mime)))){const g=new Map,f=[];c.items.forEach(m=>{let n;g.has(m.mime)?n=g.get(m.mime):(n=[],g.set(m.mime,n),f.push(m.mime)),n.push(m.data)}),c.items.length=0,f.forEach(m=>{const n=N.$7K(g.get(m));c.items.push({mime:m,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$yoc=$;class l{static{this.a=0}constructor(E,u,k,b,c){this.k=E,this.l=u,this.m=k,this.uri=b,this.handle=l.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(k){return k=E.n(k),E.b[k].apiCell},getCells(k){return(k?E.p(k):E.b).map(c=>c.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,k){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:k});const b={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const f of E.rawEvents)f.kind===N.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,b.contentChanges):f.kind===N.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,b.contentChanges):f.kind===N.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),c.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===N.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),c.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===N.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),c.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===N.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===N.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===N.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),c.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===N.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),c.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<c.length;f++){const m=c[f],n=g.get(m.cell);if(n===void 0){const o=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});g.set(m.cell,o-1)}else b.cellChanges[n]={...b.cellChanges[n],...m}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,k=E.end|0;return u<0&&(u=0),k>this.b.length&&(k=this.b.length),E.with({start:u,end:k})}p(E){E=this.o(E);const u=[];for(let k=E.start;k<E.end;k++)u.push(this.b[k]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,k){if(this.j)return;const b=[],c=[],g=[];if(E.reverse().forEach(f=>{const n=f[2].map(t=>{const s=new $(this,this.l,t);return u||c.push($.asModelAddData(t)),s}),o=new T(f[0],f[1],[],n),i=this.b.splice(f[0],f[1],...n);for(const t of i)g.push(t.uri),o.deletedItems.push(t.apiCell);b.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),k)for(const f of b)k.push(f.asApiEvent())}s(E,u,k,b){const c=this.b.splice(E,u);this.b.splice(k,0,...c);const g=[new T(E,u,c.map(f=>f.apiCell),[]),new T(k,0,[],c)];for(const f of g)b.push(f.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,k,b){this.b[E].setOutputItems(u,k,b)}v(E,u){const k=this.b[E];k.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(k.uri,u)}w(E,u){const k=this.b[E];k.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$zoc=l}),define(Ee[358],Se([1,0,4,2,17,10,51]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class T{constructor(l,I,E,u={timeout:1500,errors:3}){this.b=l,this.c=I,this.d=E,this.f=u,this.a=new r.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(I,E,u)=>{const k=function(c){I.call(E,c)};return k.extension=l,this.a.event(k,void 0,u)}}async $participateInSave(l,I,E){const u=h.URI.revive(l),k=this.c.getNotebookDocument(u);if(!k)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:A.TextDocumentSaveReason.to(I)},E,async(g,f)=>{const m=Date.now(),n=await await Promise.resolve(g);Date.now()-m>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!E.isCancellationRequested&&n&&(n instanceof R.$aN?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(b.length===0)return!0;const c={edits:[]};for(const g of b){const{edits:f}=A.WorkspaceEdit.from(g);c.edits=c.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(new N.$Pw(c))}}e.$Ooc=T}),define(Ee[164],Se([1,0,14,17,10]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0,h=We(h),A=We(A);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,l,I,E,u){this.id=T,this.f=$,this.notebookData=l,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(A.$sO.isNotebookRange))throw(0,r.$8)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,l){T.f.$tryRevealRange(T.id,h.NotebookRange.from($),l??A.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(h.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Aoc=R}),define(Ee[359],Se([1,0,4,12,17]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=void 0,A=We(A);let R=class{constructor(T,$){this.c=T,this.d=$,this.a=new r.$le,this.b=new r.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const l=this.d.getEditorById(T);$.visibleRanges&&l._acceptVisibleRanges($.visibleRanges.ranges.map(A.NotebookRange.to)),$.selections&&l._acceptSelections($.selections.selections.map(A.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(A.ViewColumn.to(T[$]))}};e.$Qoc=R,e.$Qoc=R=Qe([qe(0,h.$$j)],R)}),define(Ee[360],Se([1,0,4,6,164]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class R{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(h.$1M.MainThreadNotebookRenderers)}$postRendererMessage(T,$,l){const I=this.c.getEditorById(T);this.a.get($)?.fire({editor:I.apiEditor,message:l})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(I=>I.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(I,E,u)=>this.d($).event(I,E,u),postMessage:(I,E)=>{A.$Aoc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const u=E&&A.$Aoc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,$,I)}}}d(T){let $=this.a.get(T);return $||($=new r.$le({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$Toc=R}),define(Ee[361],Se([1,0,17,90,21,59,14]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0;class T{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,k){const b=this.b++,{title:c,location:g,cancellable:f}=u,m={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(b,{location:r.ProgressLocation.from(g),title:c,source:m,cancellable:f},E.isUnderDevelopment?void 0:E.identifier.value).catch(N.$3),this.d(b,k,!!f)}d(E,u,k){let b;k&&(b=new A.$we,this.c.set(E,b));const c=f=>{this.a.$progressEnd(f),this.c.delete(f),b?.dispose()};let g;try{g=u(new l(this.a,E),k&&b?b.token:A.CancellationToken.None)}catch(f){throw c(E),f}return g.then(f=>c(E),f=>c(E)),g}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$Xoc=T;function $(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class l extends h.$rw{constructor(E,u){super(k=>this.throttledReport(k)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Qe([(0,R.$$h)(100,(I,E)=>$(I,E),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(Ee[362],Se([1,0,2,6,9,17]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=void 0;class N{static{this.a=0}constructor($,l){this.d=l,this.c=new Map,this.b=$.getProxy(h.$1M.MainThreadQuickDiff)}$provideOriginalResource($,l,I){const E=r.URI.revive(l),u=this.c.get($);return u?(0,A.$wh)(()=>u.provideOriginalResource(E,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,l,I,E){const u=N.a++;return this.c.set(u,l),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from($,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Yoc=N});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[363],Se([1,0,21,4,3,6,2,10,14,19,44,50,26,17]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=b,I=zt(I);function b(c,g,f){const m=c.getProxy(R.$1M.MainThreadQuickOpen);class n{constructor(S,D){this.e=new Map,this.f=0,this.a=S,this.b=D}showQuickPick(S,D,P,C=r.CancellationToken.None){this.c=void 0;const p=Promise.resolve(D),v=++this.f,O=m.$show(v,{title:P?.title,placeHolder:P?.placeHolder,matchOnDescription:P?.matchOnDescription,matchOnDetail:P?.matchOnDetail,ignoreFocusLost:P?.ignoreFocusOut,canPickMany:P?.canPickMany},C),L={},F=O.then(()=>L);return Promise.race([F,p]).then(j=>{if(j===L)return;const B=(0,u.$3G)(S,"quickPickItemTooltip");return p.then(M=>{const z=[];for(let _=0;_<M.length;_++){const re=M[_];if(typeof re=="string")z.push({label:re,handle:_});else if(re.kind===T.QuickPickItemKind.Separator)z.push({type:"separator",label:re.label});else{re.tooltip&&!B&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const U=re.iconPath?d(re.iconPath):void 0;z.push({label:re.label,iconPath:U?.iconPath,iconClass:U?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:B?k.MarkdownString.fromStrict(re.tooltip):void 0,handle:_})}}return P&&typeof P.onDidSelectItem=="function"&&(this.c=_=>{P.onDidSelectItem(M[_])}),m.$setItems(v,z),O.then(_=>{if(typeof _=="number")return M[_];if(Array.isArray(_))return _.map(re=>M[re])})})}).then(void 0,j=>{if(!(0,$.$5)(j))return m.$setError(v,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,D=r.CancellationToken.None){return this.d=S?.validateInput,m.$input(S,typeof this.d=="function",D).then(void 0,P=>{if(!(0,$.$5)(P))return Promise.reject(P)})}async $validateInput(S){if(!this.d)return;const D=await this.d(S);if(!D||typeof D=="string")return D;let P;switch(D.severity){case T.InputBoxValidationSeverity.Info:P=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:P=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:P=I.default.Error;break;default:P=D.message?I.default.Error:I.default.Ignore;break}return{content:D.message,severity:P}}async showWorkspaceFolderPick(S,D=r.CancellationToken.None){const P=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!P)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(p=>p.uri.toString()===P.uri.toString())}createQuickPick(S){const D=new a(S,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(S){const D=new w(S,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(S,D){this.e.get(S)?._fireDidChangeValue(D)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,D){const P=this.e.get(S);P instanceof a&&P._fireDidChangeActive(D)}$onDidChangeSelection(S,D){const P=this.e.get(S);P instanceof a&&P._fireDidChangeSelection(D)}$onDidTriggerButton(S,D){this.e.get(S)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(S,D,P){const C=this.e.get(S);C instanceof a&&C._fireDidTriggerItemButton(D,P)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,D){this.x=S,this.y=D,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$le,this.q=new h.$le,this.r=new h.$le,this.s=new h.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((D,P)=>{const C=D===T.$pO.Back?-1:P;this.o.set(C,D)}),this.z({buttons:S.map((D,P)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===T.$pO.Back?-1:P}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const D=this.o.get(S);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(S){if(!this.v){for(const D of Object.keys(S)){const P=S[D];this.u[D]=P===void 0?null:P}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}function i(y){if(y instanceof T.$ZN)return{id:y.id};const S=s(y),D=t(y);return{dark:typeof S=="string"?N.URI.file(S):S,light:typeof D=="string"?N.URI.file(D):D}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function s(y){return typeof y=="object"&&"dark"in y?y.dark:y}function d(y){const S=i(y);let D,P;return"id"in S?P=E.ThemeIcon.asClassName(S):D=S,{iconPath:D,iconClass:P}}class a extends o{constructor(S,D){super(S.identifier,D),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$le,this.L=[],this.M=new h.$le,this.N=new h.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((C,p)=>{this.C.set(p,C),this.D.set(C,p)});const D=(0,u.$3G)(this.O,"quickPickItemTooltip"),P=[];for(let C=0;C<S.length;C++){const p=S[C];if(p.kind===T.QuickPickItemKind.Separator)P.push({type:"separator",label:p.label});else{p.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=p.iconPath?d(p.iconPath):void 0;P.push({handle:C,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:D?k.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((O,L)=>({...d(O.iconPath),tooltip:O.tooltip,handle:L}))})}}this.z({items:P})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(S){const D=(0,l.$Ib)(S.map(P=>this.C.get(P)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(S){const D=(0,l.$Ib)(S.map(P=>this.C.get(P)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(S,D){const P=this.C.get(S);if(!P||!P.buttons||!P.buttons.length)return;const C=P.buttons[D];C&&this.N.fire({button:C,item:P})}}class w extends o{constructor(S,D){super(S.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:I.default.Error}):this.z({validationMessage:S.message,severity:S.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new n(g,f)}}),define(Ee[364],Se([1,0,2,4,59,3,9,6,19,140,12,24,41,50,17,26,15,11]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=void 0;function n(O){return O instanceof r.URI}function o(O,L){return O.scheme===g.Schemas.file&&L.scheme===g.Schemas.file&&f.$k?O.toString()===L.toString():O.toString().toLowerCase()===L.toString().toLowerCase()}function i(O){if(O)return typeof O.iconPath=="string"?r.URI.file(O.iconPath):r.URI.isUri(O.iconPath)||k.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function t(O){if(O.icon){if(r.URI.isUri(O.icon))return O.icon;if(k.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const L=O.icon;return{light:L.light,dark:L.dark}}}else return}function s(O,L){if(!O.iconPath&&!L.iconPath)return 0;if(O.iconPath){if(!L.iconPath)return 1}else return-1;const F=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,j=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,l.$Dr)(F,j)}function d(O,L){let F=0;if(O.strikeThrough!==L.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==L.faded)return O.faded?1:-1;if(O.tooltip!==L.tooltip)return(O.tooltip||"").localeCompare(L.tooltip||"");if(F=s(O,L),F!==0)return F;if(O.light&&L.light)F=s(O.light,L.light);else{if(O.light)return 1;if(L.light)return-1}if(F!==0)return F;if(O.dark&&L.dark)F=s(O.dark,L.dark);else{if(O.dark)return 1;if(L.dark)return-1}return F}function a(O,L){if(O.command!==L.command)return O.command<L.command?-1:1;if(O.title!==L.title)return O.title<L.title?-1:1;if(O.tooltip!==L.tooltip){if(O.tooltip!==void 0&&L.tooltip!==void 0)return O.tooltip<L.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(O.arguments===L.arguments)return 0;if(O.arguments)if(L.arguments){if(O.arguments.length!==L.arguments.length)return O.arguments.length-L.arguments.length}else return 1;else return-1;for(let F=0;F<O.arguments.length;F++){const j=O.arguments[F],B=L.arguments[F];if(j!==B&&!(n(j)&&n(B)&&o(j,B)))return j<B?-1:1}return 0}function w(O,L){let F=(0,l.$Dr)(O.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(F!==0)return F;if(O.command&&L.command)F=a(O.command,L.command);else{if(O.command)return 1;if(L.command)return-1}if(F!==0)return F;if(O.decorations&&L.decorations)F=d(O.decorations,L.decorations);else{if(O.decorations)return 1;if(L.decorations)return-1}if(O.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)F=(0,l.$Dr)(O.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(O.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(O.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)F=(0,l.$Dr)(O.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(O.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return F}function y(O,L){for(let F=0;F<O.length;F++)if(O[F]!==L[F])return!1;return!0}function S(O,L){return O.command===L.command&&O.title===L.title&&O.tooltip===L.tooltip&&(O.arguments&&L.arguments?y(O.arguments,L.arguments):O.arguments===L.arguments)}function D(O,L){return(0,$.$vb)(O,L,S)}class P{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.l,L),this.n(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.l,L),this.f=L}get validateInput(){return(0,c.$4G)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,c.$4G)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.l,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.l,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.l,L))}get document(){return(0,c.$4G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(L,F,j,B,M){this.k=L,this.l=B,this.m=M,this.d="",this.e=new h.$le,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=j}showValidationMessage(L,F){(0,c.$4G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,L,F)}$onInputBoxValueChange(L){this.n(L)}n(L){this.d=L,this.e.fire(L)}}e.$1oc=P;class C{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(L){this.v=L,this.q.$updateGroupLabel(this.t,this.handle,L)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(L){this.p=L,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,F,j,B,M,z,_){this.q=L,this.s=F,this.t=j,this.u=B,this.v=M,this.multiDiffEditorEnableViewChanges=z,this.w=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$le,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new h.$le,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=C.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,F){const j=this.h.get(L);return j?(0,N.$wh)(()=>this.s.executeCommand(j.command,...j.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(w),j=(0,$.$Eb)(this.o,L,w).map(z=>{const _=z.toInsert.map(re=>{const U=this.e++;this.g.set(U,re);const G=re.resourceUri;let K;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const Z=new R.$Uc;K=this.s.converter.toInternal(re.command,Z),this.j.set(U,Z)}else this.h.set(U,re.command);const ee=(0,c.$3G)(this.w,"scmMultiDiffEditor"),ue=ee?re.multiDiffEditorOriginalUri:void 0,ne=ee?re.multiFileDiffEditorModifiedUri:void 0,De=i(re.decorations),$e=re.decorations&&i(re.decorations.light)||De,J=re.decorations&&i(re.decorations.dark)||De,W=[$e,J],se=re.decorations&&re.decorations.tooltip||"",oe=re.decorations&&!!re.decorations.strikeThrough,te=re.decorations&&!!re.decorations.faded,le=re.contextValue||"";return{rawResource:[U,G,W,se,oe,te,le,K,ue,ne],handle:U}});return{start:z.start,deleteCount:z.deleteCount,toInsert:_}}),B=j.map(({start:z,deleteCount:_,toInsert:re})=>[z,_,re.map(U=>U.rawResource)]),M=j.reverse();for(const{start:z,deleteCount:_,toInsert:re}of M){const U=re.map(K=>K.handle),G=this.n.splice(z,_,...U);for(const K of G)this.g.delete(K),this.h.delete(K),this.j.get(K)?.dispose(),this.j.delete(K)}return this.o=L,B}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.w,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let F;(0,c.$3G)(this.x,"quickDiffProvider")&&(F=L?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!L,quickDiffLabel:F})}get historyProvider(){return(0,c.$4G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(L){(0,c.$4G)(this.x,"scmHistoryProvider"),this.j=L,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.l=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(L){L!==this.m&&(this.m=L,this.#e.$updateSourceControl(this.w,{commitTemplate:L}))}get acceptInputCommand(){return this.o}set acceptInputCommand(L){this.n.value=new R.$Uc,this.o=L;const F=this.y.converter.toInternal(L,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,c.$4G)(this.x,"scmActionButton"),this.q}set actionButton(L){(0,c.$4G)(this.x,"scmActionButton"),this.p.value=new R.$Uc,this.q=L;const F=L!==void 0?{command:this.y.converter.toInternal(L.command,this.p.value),secondaryCommands:L.secondaryCommands?.map(j=>j.map(B=>this.y.converter.toInternal(B,this.p.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(L){if(this.z.info("ExtHostSourceControl#statusBarCommands",(L??[]).map(j=>j.command).join(", ")),this.t&&L&&D(this.t,L)){this.z.info("ExtHostSourceControl#statusBarCommands are equal");return}this.s.value=new R.$Uc,this.t=L;const F=(L||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(L,F,j,B,M,z,_,re){this.x=L,this.y=B,this.z=M,this.A=z,this.B=_,this.C=re,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.m=void 0,this.n=new R.$Wc,this.o=void 0,this.p=new R.$Wc,this.s=new R.$Wc,this.t=void 0,this.u=!1,this.v=new h.$le,this.onDidChangeSelection=this.v.event,this.w=p.d++,this.D=new Map,this.E=new Set,this.#e=j;const U=r.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${z}/scm${this.w}/input`,query:re?`rootUri=${encodeURIComponent(re.toString())}`:void 0});this.f=new P(L,F,this.#e,this.w,U),this.#e.$registerSourceControl(this.w,z,_,re,U)}createResourceGroup(L,F,j){const B=(0,c.$3G)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new C(this.#e,this.y,this.w,L,F,B,this.x),z=h.Event.once(M.onDidDispose)(()=>this.D.delete(M));return this.D.set(M,z),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const L=[],F=[];for(const[j,B]of this.D){B.dispose();const M=j.onDidUpdateResourceStates(()=>{this.E.add(j),this.eventuallyUpdateResourceStates()});h.Event.once(j.onDidDispose)(()=>{this.E.delete(j),M.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),L.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const z=j._takeResourceStateSnapshot();z.length>0&&F.push([j.handle,z]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,L,F),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(F=>{const j=F._takeResourceStateSnapshot();j.length!==0&&L.push([F.handle,j])}),L.length>0&&this.#e.$spliceResourceStates(this.w,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.u=L,this.v.fire(L)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.w)}}Qe([(0,A.$0h)(100)],p.prototype,"eventuallyAddResourceGroups",null),Qe([(0,A.$0h)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{m=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,F,j,B){this.l=F,this.m=j,this.n=B,this.g=new Map,this.h=new E.$rn,this.j=new h.$le,this.e=L.getProxy(T.$1M.MainThreadSCM),this.f=L.getProxy(T.$1M.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===u.MarshalledId.ScmResource){const z=this.g.get(M.sourceControlHandle);if(!z)return M;const _=z.getResourceGroup(M.groupHandle);return _?_.getResourceState(M.handle):M}else if(M&&M.$mid===u.MarshalledId.ScmResourceGroup){const z=this.g.get(M.sourceControlHandle);return z?z.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===u.MarshalledId.ScmProvider){const z=this.g.get(M.handle);return z||M}return M}})}createSourceControl(L,F,j,B){this.n.trace("ExtHostSCM#createSourceControl",L.identifier.value,F,j,B),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const M=m.d++,z=new p(L,this.m,this.e,this.l,this.n,F,j,B);this.g.set(M,z);const _=this.h.get(L.identifier)||[];return _.push(z),this.h.set(L.identifier,_),z}getLastInputBox(L){this.n.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const F=this.h.get(L.identifier),j=F&&F[F.length-1];return j&&j.inputBox}$provideOriginalResource(L,F,j){const B=r.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",L,B.toString());const M=this.g.get(L);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,N.$wh)(()=>M.quickDiffProvider.provideOriginalResource(B,j)).then(z=>z||null)}$onInputBoxValueChange(L,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",L);const j=this.g.get(L);return j&&j.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(L,F,j,B){this.n.trace("ExtHostSCM#$executeResourceCommand",L,F,j);const M=this.g.get(L);if(!M)return Promise.resolve(void 0);const z=M.getResourceGroup(F);return z?z.$executeResourceCommand(j,B):Promise.resolve(void 0)}$validateInput(L,F,j){this.n.trace("ExtHostSCM#$validateInput",L);const B=this.g.get(L);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,N.$wh)(()=>B.inputBox.validateInput(F,j)).then(M=>{if(!M)return Promise.resolve(void 0);const z=b.MarkdownString.fromStrict(M.message);return z?Promise.resolve([z,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,F,j,B){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,j,B)??void 0}async $provideHistoryItems(L,F,j,B){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(F,j,B))?.map(_=>({..._,icon:t(_)}))??void 0}async $provideHistoryItemSummary(L,F,j,B){const M=this.g.get(L)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const z=await M.provideHistoryItemSummary(F,j,B);return z?{...z,icon:t(z)}:void 0}async $provideHistoryItemChanges(L,F,j,B){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(F,j,B)??void 0}};e.$2oc=v,e.$2oc=v=m=Qe([qe(3,I.$$j)],v)}),define(Ee[365],Se([1,0,6,17,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=void 0;class R{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(r.$1M.MainThreadShare)}async $provideShare(T,$,l){return await this.c.get(T)?.provideShare({selection:h.Range.to($.selection),resourceUri:A.URI.revive($.resourceUri)},l)??void 0}registerShareProvider(T,$){const l=R.a++;return this.c.set(l,$),this.b.$registerShareProvider(l,h.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(l),this.c.delete(l)}}}}e.$3oc=R}),define(Ee[366],Se([1,0,10,6,239,3,17,18]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$1N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$1N("statusBarItem.warningForeground")]])}#e;#t;constructor(u,k,b,c,g,f=r.StatusBarAlignment.Left,m){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=u,this.#t=k,g&&c){this.c=(0,r.$CN)(c.identifier,g);const n=b.get(this.c);n&&(f=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,m=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=g,this.g=f,this.h=this.u(m)}u(u){if((0,T.$ig)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!$.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let k;this.m?k=this.m:k=(0,A.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=$.b.get(this.o.id));const c=N.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,k,this.k,c,this.r?.internal,b,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5oc=$;class l{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const k={message:u};return this.b.unshift(k),this.c(),new r.$3M(()=>{const b=this.b.indexOf(k);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,k){this.e=new Map,this.a=u.getProxy(h.$1M.MainThreadStatusBar),this.b=k,this.c=new l(this)}$acceptStaticEntries(u){for(const k of u)this.e.set(k.entryId,k)}createStatusBarEntry(u,k,b,c){return new $(this.a,this.b,this.e,u,k,b,c)}setStatusBarMessage(u,k){const b=this.c.setMessage(u);let c;return typeof k=="number"?c=setTimeout(()=>b.dispose(),k):typeof k<"u"&&k.then(()=>b.dispose(),()=>b.dispose()),new r.$3M(()=>{b.dispose(),clearTimeout(c)})}}e.$6oc=I}),define(Ee[165],Se([1,0,31,154,74,121,75,17,2]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=e.$IP=e.$HP=e.$GP=void 0,r=We(r),T=We(T);const l=(n,o,i,t)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!i(s,d)){const a=s;s=d,n.listener?.(t(d,a))}}}},I=(n,o)=>n===o,E={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,o)=>!(n.length!==o.length||n.some(i=>!o.find(t=>i.id===t.id)))},u=n=>o=>({op:R.TestItemEventOp.SetProp,update:n(o)}),k=(n,o)=>({range:(()=>{let i;const t=u(s=>({range:r.$Ht.lift(T.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return i},set(s){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),E.range(i,s)||(i=s,n.listener?.(t(s)))}}})(),label:l(n,o,E.label,u(i=>({label:i}))),description:l(n,void 0,E.description,u(i=>({description:i}))),sortText:l(n,void 0,E.sortText,u(i=>({sortText:i}))),canResolveChildren:l(n,!1,E.canResolveChildren,i=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:l(n,!1,E.busy,u(i=>({busy:i}))),error:l(n,void 0,E.error,u(i=>({error:T.MarkdownString.fromStrict(i)||null}))),tags:l(n,[],E.tags,(i,t)=>({op:R.TestItemEventOp.SetTags,new:i.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),b=n=>{const o=A.$OI.fromString(n.extId),i=new g(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return i.range=T.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>T.TestTag.to({id:(0,N.$UI)(t).tagId})),i},c=n=>{let o;for(const i of n.tests){const t=b(i.item);(0,h.$qP)(t).parent=o,o=t}return o};e.$GP=c;class g{constructor(o,i,t,s){if(i.includes(A.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const d=(0,h.$pP)(this,o);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof f?void 0:d.parent}},children:{value:(0,R.$oP)(d,h.$qP,g),enumerable:!0,writable:!1},...k(d,t)})}}e.$HP=g;class f extends g{constructor(o,i){super(o,o,i,void 0),this._isRoot=!0}}e.$IP=f;class m extends R.$kP{constructor(o,i,t){super({controllerId:o,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:h.$qP,getChildren:s=>s.children,root:new f(o,i),toITestItem:T.TestItem.from})}}e.$JP=m}),define(Ee[35],Se([1,0,18,10,17,25,6,19,12,57,31,53,2,3,5,20,165,22,51,55,43,92,95,32]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=void 0,h=We(h),A=We(A);let d=class{#e;#t;#i;constructor(P,C,p){this.b=new Map,this.c=new Map,this.#e=P.getProxy(N.$1M.MainThreadCommands),this.d=C,this.#i=p,this.#t=P.getProxy(N.$1M.MainThreadTelemetry),this.converter=new a(this,v=>{const O=this.c.get(v);return O?.result===y.Void?O:void 0},C),this.f=[{processArgument(v){return(0,l.$bi)(v)}},{processArgument(v){return(0,R.$do)(v,function(O){if(I.$Ht.isIRange(O))return A.Range.to(O);if(E.$Gt.isIPosition(O))return A.Position.to(O);if(I.$Ht.isIRange(O.range)&&u.URI.isUri(O.uri))return A.location.to(O);if(O instanceof f.$Ne)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const C=this.registerCommand(!1,P.id,async(...p)=>{const v=P.args.map((L,F)=>{if(!L.validate(p[F]))throw new Error(`Invalid argument '${L.name}' when running '${P.id}', received: ${typeof p[F]=="object"?JSON.stringify(p[F],null,"	"):p[F]} `);return L.convert(p[F])}),O=await this.executeCommand(P.internalId,...v);return P.result.convert(O,p,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new h.$3M(()=>{C.dispose(),this.c.delete(P.id)})}registerCommand(P,C,p,v,O,L){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:p,thisArg:v,metadata:O,extension:L}),P&&this.#e.$registerCommand(C),new h.$3M(()=>{this.b.delete(C)&&P&&this.#e.$unregisterCommand(C)})}executeCommand(P,...C){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,C,!0)}async g(P,C,p){if(this.b.has(P))return this.#e.$fireCommandActivationEvent(P),this.h(P,C,!1);{let v=!1;const O=(0,R.$do)(C,function(L){if(L instanceof h.$4M)return A.Position.from(L);if(L instanceof h.$5M)return A.Range.from(L);if(L instanceof h.$cN)return A.location.from(L);if(h.$sO.isNotebookRange(L))return A.NotebookRange.from(L);if(L instanceof ArrayBuffer)return v=!0,f.$Ne.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return v=!0,f.$Ne.wrap(L);if(L instanceof f.$Ne)return v=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(P,v?new m.$Pw(O):O,p);return(0,l.$bi)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this.g(P,C,!1);throw L}}}async h(P,C,p){const v=this.b.get(P);if(!v)throw new Error("Unknown command");const{callback:O,thisArg:L,metadata:F}=v;if(F?.args)for(let B=0;B<F.args.length;B++)try{(0,r.$vg)(C[B],F.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${F.args[B].name}' - ${F.args[B].description}`)}const j=o.$fe.create();try{return await O.apply(L,C)}catch(B){if(P===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...C);M&&(P=M.command)}if(this.d.error(B,P,v.extension?.identifier),!p)throw B;if(v.extension?.identifier){const M=this.#i.onExtensionError(v.extension.identifier,B);this.d.trace("forwarded error to extension?",M,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$pj)(B)),this.id=P,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,P,j.elapsed())}}j(P,C,p){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new i.$sp(C),duration:p})}$executeContributedCommand(P,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const p=this.b.get(P);return p?(C=C.map(v=>this.f.reduce((O,L)=>L.processArgument(O,p.extension?.identifier),v)),this.h(P,C,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(C=>(P&&(C=C.filter(p=>p[0]!=="_")),C))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[C,p]of this.b){const{metadata:v}=p;v&&(P[C]=v)}return Promise.resolve(P)}};e.$PP=d,e.$PP=d=Qe([qe(0,c.$uP),qe(1,$.$$j),qe(2,t.$OP)],d),e.$QP=(0,b.$Ei)("IExtHostCommands");class a{constructor(P,C,p){this.d=P,this.f=C,this.g=p,this.delegatingCommandId=`__vsc${(0,s.$1g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,C){if(!P)return;const p={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return p;const v=this.f(P.command);if(v)p.id=v.internalId,p.arguments=v.args.map((O,L)=>O.convert(P.arguments&&P.arguments[L]));else if((0,T.$Mb)(P.arguments)){const O=`${P.command} /${++this.c}`;this.b.set(O,P),C.add((0,k.$Tc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),p.$ident=O,p.id=this.delegatingCommandId,p.arguments=[O],this.g.trace("CommandsConverter#CREATE",P.command,O)}return p}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const C=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$RP=a;class w{static{this.Uri=new w("uri","Uri of a text document",P=>u.URI.isUri(P),P=>P)}static{this.Position=new w("position","A position in a text document",P=>h.$4M.isPosition(P),A.Position.from)}static{this.Range=new w("range","A range in a text document",P=>h.$5M.isRange(P),A.Range.from)}static{this.Selection=new w("selection","A selection in a text document",P=>h.$6M.isSelection(P),A.Selection.from)}static{this.Number=new w("number","",P=>typeof P=="number",P=>P)}static{this.String=new w("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=w.Arr(w.String)}static Arr(P){return new w(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,C=>Array.isArray(C)&&C.every(p=>P.validate(p)),C=>C.map(p=>P.convert(p)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",P=>P instanceof h.$oN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",P=>P instanceof h.$MO,A.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",P=>P instanceof g.$HP,A.TestItem.from)}constructor(P,C,p,v){this.name=P,this.description=C,this.validate=p,this.convert=v}optional(){return new w(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,C){return new w(P??this.name,C??this.description,this.validate,this.convert)}}e.$SP=w;class y{static{this.Void=new y("no result",P=>P)}constructor(P,C){this.description=P,this.convert=C}}e.$TP=y;class S{constructor(P,C,p,v,O){this.id=P,this.internalId=C,this.description=p,this.args=v,this.result=O}}e.$UP=S}),define(Ee[367],Se([1,0,19,15,2,88,143,36,35,17,10]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0,R=We(R),l=We(l),I=We(I);const E=[new $.$UP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of DocumentHighlight-instances.",k(l.DocumentHighlight.to))),new $.$UP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$SP.Uri],new $.$TP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,r.$Lb)(c))return;class f extends I.$jN{static to(n){const o=new f(n.name,l.SymbolKind.to(n.kind),n.containerName||"",new I.$cN(g[0],l.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=l.Range.to(n.selectionRange),o.children=n.children?n.children.map(f.to):[],o}}return c.map(f.to)})),new $.$UP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$SP.Uri,new $.$SP("options","Formatting options",c=>!0,c=>c)],new $.$TP("A promise that resolves to an array of TextEdits.",k(l.TextEdit.to))),new $.$UP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$SP.Uri,$.$SP.Range,new $.$SP("options","Formatting options",c=>!0,c=>c)],new $.$TP("A promise that resolves to an array of TextEdits.",k(l.TextEdit.to))),new $.$UP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$SP.Uri,$.$SP.Position,new $.$SP("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$SP("options","Formatting options",c=>!0,c=>c)],new $.$TP("A promise that resolves to an array of TextEdits.",k(l.TextEdit.to))),new $.$UP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$UP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$UP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$UP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$UP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of Location-instances.",k(l.location.to))),new $.$UP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of Hover-instances.",k(l.Hover.to))),new $.$UP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$SP.Uri,new $.$SP("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>I.$4M.isPosition(g)),c=>c.map(l.Position.from))],new $.$TP("A promise that resolves to an array of ranges.",c=>c.map(g=>{let f;for(const m of g.reverse())f=new I.$nN(l.Range.to(m),f);return f}))),new $.$UP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$SP.String.with("query","Search string")],new $.$TP("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(l.WorkspaceSymbol.to))),new $.$UP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(l.CallHierarchyItem.to))),new $.$UP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$SP.CallHierarchyItem],new $.$TP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(l.CallHierarchyIncomingCall.to))),new $.$UP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$SP.CallHierarchyItem],new $.$TP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(l.CallHierarchyOutgoingCall.to))),new $.$UP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:l.Range.to(c.range),placeholder:c.text}})),new $.$UP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$SP.Uri,$.$SP.Position,$.$SP.String.with("newName","The new symbol name")],new $.$TP("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return l.WorkspaceEdit.to(c)}})),new $.$UP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$SP.Uri,$.$SP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$TP("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(l.DocumentLink.to))),new $.$UP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$SP.Uri],new $.$TP("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new I.$jO(c.tokenTypes,c.tokenModifiers)})),new $.$UP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$SP.Uri],new $.$TP("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,N.$Hcb)(c);if(g.type==="full")return new I.$lO(g.data,void 0)})),new $.$UP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$SP.Uri,$.$SP.Range.optional()],new $.$TP("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new I.$jO(c.tokenTypes,c.tokenModifiers)})),new $.$UP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$SP.Uri,$.$SP.Range],new $.$TP("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,N.$Hcb)(c);if(g.type==="full")return new I.$lO(g.data,void 0)})),new $.$UP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$SP.Uri,$.$SP.Position,$.$SP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$SP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$TP("A promise that resolves to a CompletionList-instance.",(c,g,f)=>{if(!c)return new I.$zN([]);const m=c.suggestions.map(n=>l.CompletionItem.to(n,f));return new I.$zN(m,c.incomplete)})),new $.$UP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$SP.Uri,$.$SP.Position,$.$SP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$TP("A promise that resolves to SignatureHelp.",c=>{if(c)return l.SignatureHelp.to(c)})),new $.$UP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$SP.Uri,$.$SP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$TP("A promise that resolves to an array of CodeLens-instances.",(c,g,f)=>k(m=>new I.$rN(l.Range.to(m.range),m.command&&f.fromInternal(m.command)))(c))),new $.$UP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$SP.Uri,new $.$SP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>I.$5M.isRange(c),c=>I.$6M.isSelection(c)?l.Selection.from(c):l.Range.from(c)),$.$SP.String.with("kind","Code action kind to return code actions for").optional(),$.$SP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$TP("A promise that resolves to an array of Command-instances.",(c,g,f)=>k(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(m.command)}else{const n=new I.$lN(m.title,m.kind?new I.$mN(m.kind):void 0);return m.edit&&(n.edit=l.WorkspaceEdit.to(m.edit)),m.command&&(n.command=f.fromInternal(m.command)),n.isPreferred=m.isPreferred,n}})(c))),new $.$UP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$SP.Uri],new $.$TP("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new I.$FN(l.Range.to(g.range),l.Color.to(g.color))):[])),new $.$UP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$SP("color","The color to show and insert",c=>c instanceof I.$EN,l.Color.from),new $.$SP("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:l.Range.from(c.range)}))],new $.$TP("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(l.ColorPresentation.to):[])),new $.$UP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$SP.Uri,$.$SP.Range],new $.$TP("A promise that resolves to an array of Inlay objects",(c,g,f)=>c.map(l.InlayHint.to.bind(void 0,f)))),new $.$UP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$SP.Uri],new $.$TP("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(l.FoldingRange.to)})),new $.$UP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$TP("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.to(g))})))),new $.$UP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$SP.Uri,$.$SP.Range,new $.$SP("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof I.$5M,c=>l.InlineValueContext.from(c))],new $.$TP("A promise that resolves to an array of InlineValue objects",c=>c.map(l.InlineValue.to))),new $.$UP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$SP("uriOrString","Uri-instance or string (only http/https)",c=>A.URI.isUri(c)||typeof c=="string"&&(0,h.$Og)(c,h.Schemas.http,h.Schemas.https),c=>c),new $.$SP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[l.ViewColumn.from(c),void 0]:[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)])).optional(),$.$SP.String.with("label","").optional()],$.$TP.Void),new $.$UP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$SP.Uri.with("resource","Resource to open"),$.$SP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$SP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[l.ViewColumn.from(c),void 0]:[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)])).optional()],$.$TP.Void),new $.$UP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$SP.Uri.with("left","Left-hand side resource of the diff editor"),$.$SP.Uri.with("right","Right-hand side resource of the diff editor"),$.$SP.String.with("title","Human readable title for the diff editor").optional(),new $.$SP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)]).optional()],$.$TP.Void),new $.$UP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$SP.String.with("title","Human readable title for the changes editor"),new $.$SP("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[f,m,n]=g;if(!A.URI.isUri(f)||!A.URI.isUri(m)&&m!==void 0&&m!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},c=>c)],$.$TP.Void),new $.$UP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$SP.Uri,$.$SP.Position],new $.$TP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$UP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$SP.TypeHierarchyItem],new $.$TP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$UP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$SP.TypeHierarchyItem],new $.$TP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$UP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$SP.TestItem],$.$TP.Void),new $.$UP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$SP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$TP.Void),new $.$UP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$SP.String.with("name","The context key name"),new $.$SP("value","The context key value",()=>!0,c=>c)],$.$TP.Void),new $.$UP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$SP.Uri,$.$SP.StringArray,new $.$SP("MappedEditsContext","Mapped Edits Context",c=>l.MappedEditsContext.is(c),c=>l.MappedEditsContext.from(c))],new $.$TP("A promise that resolves to a workspace edit or null",c=>c?l.WorkspaceEdit.to(c):null)),new $.$UP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$SP("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?l.Range.from(c.initialRange):void 0,initialSelection:I.$6M.isSelection(c.initialSelection)?l.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?l.Position.from(c.position):void 0}})],$.$TP.Void)];class u{static register(g){E.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",T.$Dj)}}e.$jnc=u;function k(c){return g=>{if(Array.isArray(g))return g.map(c)}}function b(c){if(!Array.isArray(c))return;const g=[];for(const f of c)R.$Du(f)?g.push(l.DefinitionLink.to(f)):g.push(l.location.to(f));return g}}),define(Ee[368],Se([1,0,2,35]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0;class A{constructor(N,T,$,l,I){this.a=T,this.b=$,this.c=l;const E=new h.$UP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$SP("showOptions","Show Options",u=>!0,u=>u),new h.$SP("resource","Interactive resource Uri",u=>!0,u=>u),new h.$SP("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$SP("title","Interactive editor title",u=>!0,u=>u)],new h.$TP("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const k=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(N,T,$,l){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:N,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(N,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[N]})}}e.$Koc=A}),define(Ee[369],Se([1,0,19,9,21,4,3,29,2,24,12,6,35,17,10,122,311,26,51,312]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=void 0,e.$Soc=w,k=We(k);let o=class{constructor(S,D,P,C,p){this.m=D,this.n=P,this.o=C,this.q=p,this.b=new T.$Bc,this.c=new T.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(E.$1M.MainThreadNotebookKernels);const v=new u.$UP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$SP("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const F=this.n.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:F}}else if(L&&"notebookEditor"in L){const F=this.n.getIdByEditor(L.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return L})],u.$TP.Void),O=new u.$UP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$SP.Uri],new u.$TP("A promise that resolves to an array of variables",(L,F)=>L.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(O)}createNotebookController(S,D,P,C,p,v){for(const ne of this.j.values())if(ne.controller.id===D&&l.$pn.equals(S.identifier,ne.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const O=this.k++,L=this;this.q.trace(`NotebookController[${O}], CREATED by ${S.identifier.value}, ${D}`);const F=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${S.identifier}'`);let j=!1;const B=new R.$le,M=new R.$le,z={id:w(S.identifier,D),notebookType:P,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:C||S.identifier.value,preloads:v?v.map(k.NotebookRendererScript.from):[]};let _=p??F,re,U;this.a.$addKernel(O,z).catch(ne=>{console.log(ne),j=!0});let G=0;const K=()=>{if(j)return;const ne=++G;Promise.resolve().then(()=>{ne===G&&this.a.$updateKernel(O,z)})},ee=new T.$Bc,ue={get id(){return D},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return z.label},set label(ne){z.label=ne??S.displayName??S.name,K()},get detail(){return z.detail??""},set detail(ne){z.detail=ne,K()},get description(){return z.description??""},set description(ne){z.description=ne,K()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ne){z.supportedLanguages=ne,K()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){z.supportsExecutionOrder=ne,K()},get rendererScripts(){return z.preloads?z.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return _},set executeHandler(ne){_=ne??F},get interruptHandler(){return re},set interruptHandler(ne){re=ne,z.supportsInterrupt=!!ne,K()},set variableProvider(ne){(0,f.$4G)(S,"notebookVariableProvider"),U=ne,z.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>L.a.$variablesUpdated(De.uri)),K()},get variableProvider(){return U},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw L.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return L._createNotebookCellExecution(ne,w(S.identifier,this.id))},createNotebookExecution(ne){if((0,f.$4G)(S,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw L.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return L._createNotebookExecution(ne,w(S.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),B.dispose(),M.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ne,De){De===b.NotebookControllerAffinity2.Hidden&&(0,f.$4G)(S,"notebookControllerAffinityHidden"),L.a.$updateNotebookPriority(O,ne.uri,De)},onDidReceiveMessage:M.event,postMessage(ne,De){return(0,f.$4G)(S,"notebookMessaging"),L.a.$postMessage(O,De&&L.n.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,f.$4G)(S,"notebookMessaging"),(0,c.$kCb)(ne,L.m.remote)}};return this.j.set(O,{extensionId:S.identifier,controller:ue,onDidReceiveMessage:M,onDidChangeSelection:B,associatedNotebooks:ee}),ue}getIdByController(S){for(const[D,P]of this.j)if(P.controller===S)return w(P.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,D){const P=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(P,D);const p={dispose:()=>{this.f.delete(P),C.a.$removeKernelDetectionTask(P)}};return this.f.set(P,p),p}registerKernelSourceActionProvider(S,D,P){const C=this.i++,p=typeof P.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,v=this;this.h.set(C,P),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,D);let O;return p!==void 0&&(O=P.onDidChangeNotebookKernelSourceActions(L=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(C),v.a.$removeKernelSourceActionProvider(C,C),O?.dispose()}}}async $provideKernelSourceActions(S,D){const P=this.h.get(S);if(P){const C=new N.$Uc;return(await P.provideNotebookKernelSourceActions(D)??[]).map(v=>k.NotebookKernelSourceAction.from(v,this.o.converter,C))}return[]}$acceptNotebookAssociation(S,D,P){const C=this.j.get(S);if(C){const p=this.n.getNotebookDocument($.URI.revive(D));P?C.associatedNotebooks.set(p.uri,!0):C.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,p.uri.toString(),P),C.onDidChangeSelection.fire({selected:P,notebook:p.apiNotebook})}}async $executeCells(S,D,P){const C=this.j.get(S);if(!C)return;const p=this.n.getNotebookDocument($.URI.revive(D)),v=[];for(const O of P){const L=p.getCell(O);L&&v.push(L.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,p.uri.toString(),v.length),await C.controller.executeHandler.call(C.controller,v,p.apiNotebook,C.controller)}catch(O){this.q.error(`NotebookController[${S}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(S,D,P){const C=this.j.get(S);if(!C)return;const p=this.n.getNotebookDocument($.URI.revive(D));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,p.apiNotebook);else for(const v of P){const O=p.getCell(v);O&&this.b.get(O.uri)?.cancel()}if(C.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),P.length&&Array.isArray(v)&&v.length&&v.forEach(O=>O.dispose())}}async $provideVariables(S,D,P,C,p,v,O){const L=this.j.get(S);if(!L)return;const F=this.n.getNotebookDocument($.URI.revive(P)),j=L.controller.variableProvider;if(!j)return;let B;if(C!==void 0){if(B=this.s[C],!B)return}else this.s={};const M=p==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,z=j.provideVariables(F.apiNotebook,B,M,v,O);let _=0;for await(const re of z){if(O.isCancellationRequested)return;const U={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:L.extensionId.value};if(this.s[U.id]=re.variable,this.a.$receiveVariable(D,U),_++>=n.$8jb)return}}$acceptKernelMessageFromRenderer(S,D,P){const C=this.j.get(S);if(!C)return;const p=this.n.getEditorById(D);C.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:P}))}$cellExecutionChanged(S,D,P){const p=this.n.getNotebookDocument($.URI.revive(S)).getCell(D);if(p){const v=P?k.NotebookCellExecutionState.to(P):b.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(S,D){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const p=new t(D,C,this.a);this.b.set(C.uri,p);const v=p.onDidChangeState(()=>{p.state===i.Resolved&&(p.dispose(),v.dispose(),this.b.delete(C.uri))});return p.asApiObject()}_createNotebookExecution(S,D){const P=this.n.getNotebookDocument(S.uri),C=S.getCells().find(O=>{const L=P.getCellFromApiCell(O);return L&&this.b.has(L.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const p=new d(D,P,this.a),v=p.onDidChangeState(()=>{p.state===s.Resolved&&(p.dispose(),v.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[p,v]),p.asApiObject()}};e.$Roc=o,e.$Roc=o=Qe([qe(4,I.$$j)],o);var i;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(i||(i={}));class t extends N.$Vc{static{this.a=0}get state(){return this.f}constructor(S,D,P){super(),this.m=D,this.n=P,this.b=t.a++,this.c=new R.$le,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new A.$we),this.h=new a(10,C=>this.s(C)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const D=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new m.$Pw(D))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let D=this.m;if(S&&(D=this.m.notebook.getCellFromApiCell(S)),!D)throw new Error("INVALID cell");return D.handle}y(S){return S.map(D=>{const P=b.$wO.ensureUniqueMimeTypes(D.items,!0);return P===D.items?k.NotebookCellOutput.from(D):k.NotebookCellOutput.from({items:P,id:D.id,metadata:D.metadata})})}async z(S,D,P){const C=this.w(D),p=this.y((0,r.$3b)(S));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:C,append:P,outputs:p})}async C(S,D,P){return S=b.$wO.ensureUniqueMimeTypes((0,r.$3b)(S),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:S.map(k.NotebookCellOutputItem.from),outputId:D.id,append:P})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(P){S.j=P,S.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(P){if(S.f===i.Resolved||S.f===i.Started)throw new Error("Cannot call start again");S.f=i.Started,S.c.fire(),S.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,C,p){if(S.f===i.Resolved)throw new Error("Cannot call resolve twice");S.f=i.Resolved,S.c.fire(),S.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;S.n.$completeExecution(S.b,new m.$Pw({runEndTime:C,lastRunSuccess:P,error:v}))},clearOutput(P){return S.t(),S.z([],P,!1)},appendOutput(P,C){return S.t(),S.z(P,C,!0)},replaceOutput(P,C){return S.t(),S.z(P,C,!1)},appendOutputItems(P,C){return S.t(),S.C(P,C,!0)},replaceOutputItems(P,C){return S.t(),S.C(P,C,!1)}})}}var s;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(s||(s={}));class d extends N.$Vc{static{this.a=0}get state(){return this.f}constructor(S,D,P){super(),this.h=D,this.j=P,this.b=d.a++,this.c=new R.$le,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new A.$we),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(S,D){this.f=S,this.g=D,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new h.$2h,this.b=Date.now(),(0,h.$Fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>S.complete())}}function w(y,S){return`${y.value}/${S}`}}),define(Ee[47],Se([1,0,4,6,5,2,20,3,10,241,14,290,21,32,291,292,50,9,17,35,41]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=e.$Znc=e.$Ync=e.$Xnc=void 0,e.$Xnc=(0,A.$Ei)("IExtHostTerminalService");class i extends T.$Vc{constructor(p,v,O,L){super(),this.u=p,this._id=v,this.w=O,this.y=L,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(j,B=!0){F.C(),F.u.$sendText(F._id,j,B)},show(j){F.C(),F.u.$show(F._id,j)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:S(p.iconPath)??void 0,color:g.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,O,L,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:L,color:g.ThemeColor.isThemeColor(F)?F.id:void 0,location:v?.location||this.z(p,O),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$Ync=i;class t{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new r.$le,this.onProcessData=this.a.event,this.b=new r.$le,this.d=new r.$le,this.onDidChangeProperty=this.d.event,this.f=new r.$le,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:b.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,d=class extends T.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,O){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$le,this.onDidCloseTerminal=this.H.event,this.I=new r.$le,this.onDidOpenTerminal=this.I.event,this.J=new r.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$le,this.onDidChangeTerminalState=this.M.event,this.N=new r.$le,this.onDidChangeShell=this.N.event,this.O=new r.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=O.getProxy(h.$1M.MainThreadTerminalService),this.y=new c.$Iwb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:L=>{const F=j=>{const B=j;return this.getTerminalById(B.instanceId)?.value};switch(L?.$mid){case o.MarshalledId.TerminalContext:return F(L);default:{if(Array.isArray(L))for(let j=0;j<L.length&&L[j].$mid===o.MarshalledId.TerminalContext;j++)L[j]=F(L[j]);return L}}}}),this.B({dispose:()=>{for(const[L,F]of this.g)F.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const O=new i(this.a,(0,k.$1g)(),p,p.name),L=new t(p.pty);return O.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,S(p.iconPath),D(p.color)).then(F=>{const j=this.S(F,L);this.h[F]=j}),this.f.push(O),O.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const O=p.location.parentTerminal;if(O){const L=this.f.find(F=>F.value===O);L&&(v.resolvedExtHostIdentifier=L._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const L=new t(v),F=this.S(p,L);this.h[p]=F}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const O=this.getTerminalById(p);O&&(this.b=O,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const O=this.getTerminalById(p);O&&this.O.fire({terminal:O.value,data:v})}async $acceptTerminalDimensions(p,v,O){const L=this.getTerminalById(p);L&&L.setDimensions(v,O)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(p,v){const O=this.getTerminalById(p);O&&this.P.fire({terminal:O.value,...v})}async $acceptTerminalMaximumDimensions(p,v,O){this.g.get(p)?.resize(v,O)}async $acceptTerminalTitleChange(p,v){const O=this.getTerminalById(p);O&&(O.name=v)}async $acceptTerminalClosed(p,v,O){const L=this.X(this.f,p);if(L!==null){const F=this.f.splice(L,1)[0];F.setExitStatus(v,O),this.H.fire(F.value)}}$acceptTerminalOpened(p,v,O,L){if(v){const B=this.X(this.f,v);if(B!==null){this.f[B]._id=p,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const F={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:R.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},j=new i(this.a,p,F,O);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const O=this.getTerminalById(p);if(!O)return{message:(0,l.localize)(0,null,p)};O.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async B=>{B===O.value&&(j.dispose(),F())})});const L=this.g.get(p);L?L.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const O=new T.$Uc;O.add(v.onProcessReady(F=>this.a.$sendProcessReady(p,F.pid,F.cwd,F.windowsPty))),O.add(v.onDidChangeProperty(F=>this.a.$sendProcessProperty(p,F))),this.y.startBuffering(p,v.onProcessData),O.add(v.onProcessExit(F=>this.U(p,F))),this.g.set(p,v);const L=this.j[p];return L&&v instanceof t&&(v.startSendingEvents(L.initialDimensions),delete this.j[p]),O}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,O){try{this.g.get(p)?.resize(v,O)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:b.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:b.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$3M(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,O){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,O),this.a.$registerProfileProvider(v,p.identifier.value),new $.$3M(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,O){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,O),this.a.$registerQuickFixProvider(p,v),new $.$3M(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const O=new u.$we().token;if(O.isCancellationRequested)return;const L=this.D.get(p);if(!L)return;const F=await L.provideTerminalQuickFixes(v,O);if(F===null||Array.isArray(F)&&F.length===0)return;const j=new T.$Uc;if(this.w.value=j,!Array.isArray(F))return F?m.TerminalQuickFix.from(F,this.Q.converter,j):void 0;const B=[];for(const M of F){const z=m.TerminalQuickFix.from(M,this.Q.converter,j);z&&B.push(z)}return B}async $createContributedProfileTerminal(p,v){const O=new u.$we().token;let L=await this.C.get(p)?.provideTerminalProfile(O);if(!O.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,v);return}this.createTerminalFromOptions(L.options,v)}}async $provideLinks(p,v){const O=this.getTerminalById(p);if(!O)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const F=new u.$we;this.G.set(p,F);const j=[],B={terminal:O.value,line:v},M=[];for(const re of this.z)M.push(f.Promises.withAsyncBody(async U=>{F.token.onCancellationRequested(()=>U({provider:re,links:[]}));const G=await re.provideTerminalLinks(B,F.token)||[];F.token.isCancellationRequested||U({provider:re,links:G})}));const z=await Promise.all(M);if(F.token.isCancellationRequested)return[];const _=new Map;for(const re of z)re&&re.links.length>0&&j.push(...re.links.map(U=>{const G={id:s++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return _.set(G.id,{provider:re.provider,link:U}),G}));return this.F.set(p,_),j}$activateLink(p,v){const O=this.F.get(p)?.get(v);O&&O.provider.handleTerminalLink(O.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const O=this.h[p];O&&(O.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(O=>O.value===p);return v>=0?v:null}W(p,v){const O=this.X(p,v);return O!==null?p[O]:null}X(p,v){const O=p.findIndex(L=>L._id===v);return O>=0?O:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new a),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const O=(0,E.$ys)(v.map),L=(0,E.$zs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,O.length===0?void 0:O,L)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const O=v[0],L=this.B(new a(v[1]));this.Z(O,L)})}$acceptDefaultProfile(p,v){const O=this.s;this.s=p,this.u=v,O?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$Znc=d,e.$Znc=d=Qe([qe(1,n.$QP),qe(2,N.$uP)],d);class a extends T.$Vc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$le,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let O=this.a.get(v);return O||(O=new w(this,p),this.a.set(v,O),this.B(O.onDidChangeCollection(()=>this.f.fire()))),O}replace(p,v,O,L){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:O??{applyAtProcessCreation:!0},scope:L})}append(p,v,O,L){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:O??{applyAtProcessCreation:!0},scope:L})}prepend(p,v,O,L){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:O??{applyAtProcessCreation:!0},scope:L})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const O=this.h(p,v.scope),L=this.map.get(O),F=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==v.value||L.type!==v.type||L.options?.applyAtProcessCreation!==F.applyAtProcessCreation||L.options?.applyAtShellIntegration!==F.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(p,v.scope),B={variable:p,...v,options:F};this.map.set(j,B),this.f.fire()}}get(p,v){const O=this.h(p,v),L=this.map.get(O);return L?P(L):void 0}h(p,v){const O=this.j(v);return O.length?`${p}:::${O}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[O,L]of this.map)this.j(L.scope)===this.j(p)&&v.set(L.variable,P(L));return v}delete(p,v){const O=this.h(p,v);this.map.delete(O),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,O]of this.map)O.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const O=this.j(v),L=this.descriptionMap.get(O);if(!L||L.description!==p){let F;typeof p=="string"?F=p:F=p?.value.split(`

`)[0];const j={description:F,scope:v};this.descriptionMap.set(O,j),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class w{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new r.$le}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,O){this.b.replace(p,v,O,this.d)}append(p,v,O){this.b.append(p,v,O,this.d)}prepend(p,v,O){this.b.prepend(p,v,O,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((O,L)=>p.call(v,L,O,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends d{constructor(p,v){super(!1,p,v)}createTerminal(p,v,O){throw new I.$ab}createTerminalFromOptions(p,v){throw new I.$ab}};e.$1nc=y,e.$1nc=y=Qe([qe(0,n.$QP),qe(1,N.$uP)],y);function S(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function D(C){return g.ThemeColor.isThemeColor(C)?C:void 0}function P(C){const p={...C};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Ee[166],Se([1,0,10,3,5,6,20,47,4,2,9]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=e.$0oc=void 0,e.$0oc=(0,A.$Ei)("IExtHostTerminalShellIntegration");let E=class extends h.$Vc{constructor(g,f){super(),this.h=f,this.b=new Map,this.c=new $.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$1M.MainThreadTerminalShellIntegration),this.B((0,h.$Tc)(()=>{for(const[m,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(g){const f=this.h.getTerminalById(g);if(!f)return;const m=f.value;let n=this.b.get(g);n||(n=new u(f.value,this.f),this.b.set(g,n),n.store.add(f.onWillDispose(()=>this.b.get(g)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(g,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),f.shellIntegration=n.value),this.c.fire({terminal:m,shellIntegration:n.value})}$shellExecutionStart(g,f,m,n,o){this.b.has(g)||this.$shellIntegrationChange(g);const i={value:f,confidence:m,isTrusted:n};this.b.get(g)?.startShellExecution(i,o)}$shellExecutionEnd(g,f,m,n,o){const i={value:f,confidence:m,isTrusted:n};this.b.get(g)?.endShellExecution(i,o)}$shellExecutionData(g,f){this.b.get(g)?.emitData(f)}$cwdChange(g,f){this.b.get(g)?.setCwd((0,l.$wc)(f)?l.URI.revive(f):f)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$$oc=E,e.$$oc=E=Qe([qe(0,N.$uP),qe(1,T.$Xnc)],E);class u extends h.$Vc{get currentExecution(){return this.a}constructor(g,f){super(),this.j=g,this.m=f,this.b=!1,this.store=this.B(new h.$Uc),this.f=this.B(new $.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$le),this.onDidRequestEndExecution=this.h.event;const m=this;this.value={get cwd(){return m.c},executeCommand(n,o){let i=n;o&&(i+=` "${o.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),m.g.fire(i);const t={value:i,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=m.startShellExecution(t,m.c,!0).value;return m.b=!0,s}}}startShellExecution(g,f,m){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new k(g,f);m?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,f){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:f}),this.a=void 0)}setCwd(g){let f=!1;l.URI.isUri(this.c)?f=!l.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(f=!0),f&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(g,f){this.c=g,this.cwd=f,this.b=!1;const m=this;this.value={get commandLine(){return m.c},get cwd(){return m.cwd},read(){return m.d()}}}d(){if(!this.a){if(this.b)return I.$5h.EMPTY;this.a=new b}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class b extends h.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Dh);const g=this.a;return new I.$5h(async m=>{this.b.push(m),await g.wait()})}emitData(g){for(const f of this.b)f.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ee[167],Se([1,0,66,14,133,17,10]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=void 0,R=We(R);class T{static{this.c=new A.$zP("TextEditorDecorationType")}constructor(u,k,b){const c=T.c.nextId();u.$registerTextEditorDecorationType(k.identifier,c,R.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:c,dispose(){u.$removeTextEditorDecorationType(c)}})}}e.$BP=T;class ${constructor(u,k){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,k){this.k();let b=null;if(u instanceof N.$4M)b=new N.$5M(u,u);else if(u instanceof N.$5M)b=u;else throw new Error("Unrecognized location");this.l(b,k,!1)}insert(u,k){this.k(),this.l(new N.$5M(u,u),k,!0)}delete(u){this.k();let k=null;if(u instanceof N.$5M)k=u;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(u,k,b){const c=this.c.validateRange(u);this.g.push({range:c,text:k,forceMoveMarkers:b})}setEndOfLine(u){if(this.k(),u!==N.EndOfLine.LF&&u!==N.EndOfLine.CRLF)throw(0,h.$8)("endOfLine");this.h=u}}class l{constructor(u,k,b,c){this.c=u,this.d=k,this._accept(b),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(f){g.n(f)},get indentSize(){return g.g},set indentSize(f){g.p(f)},get insertSpaces(){return g.j},set insertSpaces(f){g.s(f)},get cursorStyle(){return g.k},set cursorStyle(f){g.t(f)},get lineNumbers(){return g.l},set lineNumbers(f){g.u(f)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}n(u){const k=this.m(u);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}p(u){const k=this.o(u);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const k=this.q(u);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const k={};let b=!1;if(typeof u.tabSize<"u"){const c=this.m(u.tabSize);c==="auto"?(b=!0,k.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,b=!0,k.tabSize=c)}if(typeof u.indentSize<"u"){const c=this.o(u.indentSize);c==="tabSize"?(b=!0,k.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,b=!0,k.indentSize=c)}if(typeof u.insertSpaces<"u"){const c=this.q(u.insertSpaces);c==="auto"?(b=!0,k.insertSpaces=c):this.j!==c&&(this.j=c,b=!0,k.insertSpaces=c)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,b=!0,k.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,b=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(u,k){k.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(b)})}}e.$CP=l;class I{constructor(u,k,b,c,g,f,m,n){this.id=u,this.j=k,this.k=b,this.g=!1,this.h=new Set,this.c=g,this.d=new l(this.j,this.id,f,b),this.e=m,this.f=n;const o=this;this.value=Object.freeze({get document(){return c.value},set document(i){throw new h.$0("document")},get selection(){return o.c&&o.c[0]},set selection(i){if(!(i instanceof N.$6M))throw(0,h.$8)("selection");o.c=[i],o.l()},get selections(){return o.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof N.$6M)))throw(0,h.$8)("selections");o.c=i,o.l()},get visibleRanges(){return o.e},set visibleRanges(i){throw new h.$0("visibleRanges")},get options(){return o.d.value},set options(i){o.g||o.d.assign(i)},get viewColumn(){return o.f},set viewColumn(i){throw new h.$0("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new $(c.value,t);return i(s),o.m(s)},insertSnippet(i,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(a=>R.Range.from(a));else if(t instanceof N.$4M){const{lineNumber:a,column:w}=R.Position.from(t);d=[{startLineNumber:a,startColumn:w,endLineNumber:a,endColumn:w}]}else if(t instanceof N.$5M)d=[R.Range.from(t)];else{d=[];for(const a of t)if(a instanceof N.$5M)d.push(R.Range.from(a));else{const{lineNumber:w,column:y}=R.Position.from(a);d.push({startLineNumber:w,startColumn:y,endLineNumber:w,endColumn:y})}}return k.$tryInsertSnippet(u,c.value.version,i.value,d,s)},setDecorations(i,t){const s=t.length===0;s&&!o.h.has(i.key)||(s?o.h.delete(i.key):o.h.add(i.key),o.n(()=>{if(R.$rP(t))return k.$trySetDecorations(u,i.key,R.$sP(t));{const d=new Array(4*t.length);for(let a=0,w=t.length;a<w;a++){const y=t[a];d[4*a]=y.start.line+1,d[4*a+1]=y.start.character+1,d[4*a+2]=y.end.line+1,d[4*a+3]=y.end.character+1}return k.$trySetDecorationsFast(u,i.key,d)}}))},revealRange(i,t){o.n(()=>k.$tryRevealRange(u,R.Range.from(i),t||N.TextEditorRevealType.Default))},show(i){k.$tryShowEditor(u,R.ViewColumn.from(i))},hide(){k.$tryHideEditor(u)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const k=u.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const b=k.edits.map(g=>g.range);b.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=b.length-1;g<f;g++){const m=b[g].end;if(b[g+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$DP=I}),define(Ee[64],Se([1,0,66,4,3,2,5,6,163,20,167,17,12,29,15,40,49]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=void 0,r=We(r),E=We(E);class f{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(o,i){this.h=o,this.i=i,this.a=null,this.b=new Map,this.c=new k.$Bc,this.d=new h.$le,this.e=new h.$le,this.f=new h.$le,this.g=new h.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const i=[],t=[],s=[];if(o.removedDocuments)for(const d of o.removedDocuments){const a=R.URI.revive(d),w=this.c.get(a);w?.unref()&&(this.c.delete(a),i.push(w.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const a=R.URI.revive(d.uri);let w=this.c.get(a);if(w&&a.scheme!==b.Schemas.vscodeNotebookCell&&a.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);w||(w=new f(new $.$xP(this.h.getProxy(T.$1M.MainThreadDocuments),a,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(a,w),t.push(w.value)),w.ref()}if(o.removedEditors)for(const d of o.removedEditors){const a=this.b.get(d);this.b.delete(d),a&&s.push(a)}if(o.addedEditors)for(const d of o.addedEditors){const a=R.URI.revive(d.documentUri);r.ok(this.c.has(a),`document '${a}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const w=this.c.get(a).value,y=new I.$DP(d.id,this.h.getProxy(T.$1M.MainThreadTextEditors),this.i,new g.$W(()=>w.document),d.selections.map(E.Selection.to),d.options,d.visibleRanges.map(S=>E.Range.to(S)),typeof d.editorPosition=="number"?E.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,y)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,A.$Qc)(i),(0,A.$Qc)(s),o.removedDocuments&&this.e.fire(i),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return c.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const i=this.b.get(this.a);return o?i:i?.value}allEditors(){return[...this.b.values()]}};e.$EP=m,e.$EP=m=Qe([qe(0,l.$uP),qe(1,u.$$j)],m),e.$FP=(0,N.$Ei)("IExtHostDocumentsAndEditors")}),define(Ee[99],Se([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,165,17,10,314,74,121,75,26]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=e.$ioc=e.$hoc=e.$goc=e.$foc=void 0,n=We(n);let w=0;const y=new WeakMap;e.$foc=(0,u.$Ei)("IExtHostTesting");let S=class extends $.$Vc{constructor(U,G,K,ee){super(),this.C=G,this.D=K,this.F=ee,this.f=this.B(new R.$le),this.g=new Map,this.w=this.B(new R.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(b.$1M.MainThreadTesting),this.m=new j(this.h),this.j=new p(this.h,G),K.registerArgumentProcessor({processArgument:ue=>{switch(ue?.$mid){case l.MarshalledId.TestItemContext:{const ne=ue,De=ne.tests[ne.tests.length-1].item.extId;return this.g.get(t.$OI.root(De))?.collection.tree.get(De)?.actual??(0,m.$GP)(ue)}case l.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=ue,$e=ne.item.extId;return{test:this.g.get(t.$OI.root($e))?.collection.tree.get($e)?.actual??(0,m.$GP)({$mid:l.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return ue}}}),K.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ue=await K.executeCommand(i.TestCommandId.GetExplorerSelection),ne=De=>{const $e=this.g.get(t.$OI.root(De));if($e)return t.$OI.isRoot(De)?$e.controller:$e.collection.tree.get(De)?.actual};return{include:ue?.include.map(ne).filter(I.$mg)||[],exclude:ue?.exclude.map(ne).filter(I.$mg)||[]}})}createTestController(U,G,K,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const ue=new $.$Uc,ne=ue.add(new m.$JP(G,K,this.F));ne.root.label=K;const De=new Map,$e=new Set,J=this.h,W={items:ne.root.children,get label(){return K},set label(oe){K=oe,ne.root.label=oe,J.$updateController(G,{label:K})},get refreshHandler(){return ee},set refreshHandler(oe){ee=oe,J.$updateController(G,{canRefresh:!!oe})},get id(){return G},createRunProfile:(oe,te,le,he,Z,ae)=>{let pe=(0,T.$sj)(oe);for(;De.has(pe);)pe++;return new M(this.h,De,$e,this.w.event,G,pe,oe,te,le,he,Z,ae)},createTestItem(oe,te,le){return new m.$HP(G,oe,te,le)},createTestRun:(oe,te,le=!0)=>this.j.createTestRun(U,G,ne,oe,te,le),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const te=oe instanceof Array?oe:[oe];this.h.$markTestRetired(te.map(le=>t.$OI.fromExtHostTestItem(le,G).toString()))}},set resolveHandler(oe){ne.resolveHandler=oe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{ue.dispose()}};J.$registerTestController(G,K,!!ee),ue.add((0,$.$Tc)(()=>J.$unregisterTestController(G)));const se={controller:W,collection:ne,profiles:De,extension:U,activeProfiles:$e};return this.g.set(G,se),ue.add((0,$.$Tc)(()=>this.g.delete(G))),ue.add(ne.onDidGenerateDiff(oe=>J.$publishDiff(G,oe.map(d.TestsDiffOp.serialize)))),W}createTestObserver(){return this.m.checkout()}async runTests(U,G=A.CancellationToken.None){const K=v(U);if(!K)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(K.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:U.preserveFocus??!0,group:z[K.kind],targets:[{testIds:U.include?.map(ue=>t.$OI.fromExtHostTestItem(ue,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:K.profileId,controllerId:K.controllerId}],exclude:U.exclude?.map(ue=>ue.id)},G)}registerTestFollowupProvider(U){return this.y.add(U),{dispose:()=>{this.y.delete(U)}}}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $getCoverageDetails(U,G){return(await this.j.getCoverageDetails(U,G))?.map(n.TestCoverage.fromDetails)}async $disposeRun(U){this.j.disposeTestRun(U)}$configureRunProfile(U,G){this.g.get(U)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(U){const G=new Map;for(const[K,ee]of Object.entries(U)){const ue=this.g.get(K);if(!ue)continue;const ne=new Map,De=ee.filter(J=>!ue.activeProfiles.has(J)),$e=[...ue.activeProfiles].filter(J=>!ee.includes(J));for(const J of De)ne.set(J,!0),ue.activeProfiles.add(J);for(const J of $e)ne.set(J,!1),ue.activeProfiles.delete(J);ne.size&&G.set(K,ne)}this.w.fire(G)}async $refreshTests(U,G){await this.g.get(U)?.controller.refreshHandler?.(G)}$publishTestResults(U){this.results=Object.freeze(U.map(G=>{const K=n.TestResults.to(G);return y.set(K,G.id),K}).concat(this.results).sort((G,K)=>K.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,G){const K=this.g.get(t.$OI.fromString(U).controllerId)?.collection;K&&(await K.expand(U,G<0?1/0:G),K.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(G=>d.TestsDiffOp.deserialize({asCanonicalUri:K=>K},G)))}async $runControllerTests(U,G){return Promise.all(U.map(K=>this.G(K,!1,G)))}async $startContinuousRun(U,G){const K=new A.$we(G),ee=await Promise.all(U.map(ue=>this.G(ue,!0,K.token)));return!G.isCancellationRequested&&!ee.some(ue=>ue.error)&&await new Promise(ue=>G.onCancellationRequested(ue)),K.dispose(!0),ee}async $provideTestFollowups(U,G){const K=this.results.find(ne=>y.get(ne)===U.resultId),ee=K&&_(t.$OI.fromString(U.extId),K?.results);if(!ee)return[];let ue=[];return await Promise.all([...this.y].map(async ne=>{try{const De=await ne.provideFollowup(K,ee,U.taskIndex,U.messageIndex,G);De&&(ue=ue.concat(De))}catch(De){this.C.error("Error thrown while providing followup for test message",De)}})),G.isCancellationRequested?[]:ue.map(ne=>{const De=w++;return this.z.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(U){for(const G of U)this.z.delete(G)}$executeTestFollowup(U){const G=this.z.get(U);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}getMetadataForRun(U){for(const G of this.j.trackers){const K=G.getTaskIdForRun(U);return K?{taskId:K,runId:G.id}:void 0}}async G(U,G,K){const ee=this.g.get(U.controllerId);if(!ee)return{};const{collection:ue,profiles:ne,extension:De}=ee,$e=ne.get(U.profileId);if(!$e)return{};const J=U.testIds.map(te=>ue.tree.get(te)).filter(I.$mg),W=U.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.$mg).filter(te=>J.some(le=>le.fullId.compare(te.fullId)===t.TestPosition.IsChild));if(!J.length)return{};const se=new o.$DO(J.some(te=>te.actual instanceof m.$IP)?void 0:J.map(te=>te.actual),W.map(te=>te.actual),$e,G),oe=(0,d.$RI)(U)&&this.j.prepareForMainThreadTestRun(De,se,O.fromInternal(U,ee.collection),$e,K);try{return await $e.runHandler(se,K),{}}catch(te){return{error:String(te)}}finally{oe&&oe.hasRunningTasks&&!K.isCancellationRequested&&await R.Event.toPromise(oe.onEnd)}}};e.$goc=S,e.$goc=S=Qe([qe(0,f.$uP),qe(1,k.$$j),qe(2,c.$QP),qe(3,g.$FP)],S);const D=1e4;var P;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(P||(P={}));class C extends $.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(U,G,K,ee,ue,ne){super(),this.z=U,this.C=G,this.D=K,this.F=ee,this.G=ue,this.c=P.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$le),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$we(ne));const De=this.B(new r.$Qh(()=>this.H(),D));this.B(this.j.token.onCancellationRequested(()=>De.schedule()));const $e=new R.$le;this.w=$e.event,this.B((0,$.$Tc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(U){for(const[G,{run:K}]of this.g)if(K===U)return G}cancel(){this.c===P.Running?(this.j.cancel(),this.c=P.Cancelling):this.c===P.Cancelling&&this.H()}getCoverageDetails(U,G){const[,K]=t.$OI.fromString(U).path,ee=this.y.get(U);if(!ee)return[];const ue=this.g.get(K);if(!ue)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(ue.run,ee,G)??[]}createRun(U){const G=this.z.id,K=this.z.controllerId,ee=(0,E.$1g)(),ue=W=>(se,...oe)=>{if(De){this.D.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.J(se),W(se,...oe)},ne=(W,se)=>{const oe=se instanceof Array?se.map(n.TestMessage.from):[n.TestMessage.from(se)];if(W.uri&&W.range){const te={range:n.Range.from(W.range),uri:W.uri};for(const le of oe)le.location=le.location||te}this.C.$appendTestMessagesInRun(G,ee,t.$OI.fromExtHostTestItem(W,K).toString(),oe)};let De=!1;const $e=new Map,J={isPersisted:this.z.isPersisted,token:this.j.token,name:U,onDidDispose:this.w,addCoverage:W=>{if(De)return;const se=W instanceof o.$IO?W.testItem:void 0;let oe;se&&((0,a.$4G)(this.G,"attributableCoverage"),this.J(se),oe=$e.get(se),oe===void 0&&(oe=$e.size,$e.set(se,oe)));const te=W.uri.toString(),le=new t.$OI(oe!==void 0?[G,ee,te,String(oe)]:[G,ee,te]).toString();this.y.set(le,W),this.C.$appendCoverage(G,ee,n.TestCoverage.fromFile(K,le,W))},enqueued:ue(W=>{this.C.$updateTestStateInRun(G,ee,t.$OI.fromExtHostTestItem(W,K).toString(),d.TestResultState.Queued)}),skipped:ue(W=>{this.C.$updateTestStateInRun(G,ee,t.$OI.fromExtHostTestItem(W,K).toString(),d.TestResultState.Skipped)}),started:ue(W=>{this.C.$updateTestStateInRun(G,ee,t.$OI.fromExtHostTestItem(W,K).toString(),d.TestResultState.Running)}),errored:ue((W,se,oe)=>{ne(W,se),this.C.$updateTestStateInRun(G,ee,t.$OI.fromExtHostTestItem(W,K).toString(),d.TestResultState.Errored,oe)}),failed:ue((W,se,oe)=>{ne(W,se),this.C.$updateTestStateInRun(G,ee,t.$OI.fromExtHostTestItem(W,K).toString(),d.TestResultState.Failed,oe)}),passed:ue((W,se)=>{this.C.$updateTestStateInRun(G,ee,t.$OI.fromExtHostTestItem(W,this.z.controllerId).toString(),d.TestResultState.Passed,se)}),appendOutput:(W,se,oe)=>{De||(oe&&this.J(oe),this.C.$appendOutputToRun(G,ee,h.$Ne.fromString(W),se&&n.location.from(se),oe&&t.$OI.fromExtHostTestItem(oe,K).toString()))},end:()=>{De||(De=!0,$e.clear(),this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:J}),this.C.$startedTestRunTask(G,{id:ee,name:U,running:!0}),J}H(){for(const{run:U}of this.g.values())U.end()}I(){this.c!==P.Ended&&(this.c=P.Ended,this.m.fire())}J(U){if(!(U instanceof m.$HP))throw new s.$mP(U.id);if(this.h.has(t.$OI.fromExtHostTestItem(U,this.z.controllerId).toString()))return;const G=[],K=this.z.colllection.root;for(;;){const ee=n.TestItem.from(U);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),U===K))break;U=U.parent||K}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(U,G){this.g=U,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(U,G){const K=t.$OI.root(U);return this.f.get(K)?.getCoverageDetails(U,G)||[]}disposeTestRun(U){this.f.get(U)?.dispose(),this.f.delete(U);for(const[G,{id:K}]of this.c)K===U&&this.c.delete(G)}prepareForMainThreadTestRun(U,G,K,ee,ue){return this.j(G,K,ee,U,ue)}cancelRunById(U){this.f.get(U)?.cancel()}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,G,K,ee,ue,ne){const De=this.c.get(ee);if(De)return De.createRun(ue);const $e=O.fromPublic(G,K,ee,ne),J=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:J&&{group:z[J.kind],id:J.profileId},exclude:ee.exclude?.map(se=>t.$OI.fromExtHostTestItem(se,K.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>t.$OI.fromExtHostTestItem(se,K.root.id).toString())??[K.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const W=this.j(ee,$e,ee.profile,U);return R.Event.once(W.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),W.createRun(ue)}j(U,G,K,ee,ue){const ne=new C(G,this.g,this.h,K,ee,ue);return this.c.set(U,ne),this.f.set(ne.id,ne),ne}}e.$hoc=p;const v=re=>{if(re.profile){if(!(re.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class O{static fromPublic(U,G,K,ee){return new O(U,(0,E.$1g)(),ee,G)}static fromInternal(U,G){return new O(U.controllerId,U.runId,!0,G)}constructor(U,G,K,ee){this.controllerId=U,this.id=G,this.isPersisted=K,this.colllection=ee}}e.$ioc=O;class L{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const G=t.$OI.parentId(U.item.extId);if(G&&this.h.has(G.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:G,g:K}=this;return{get added(){return[...U].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...K].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class F extends d.$XI{constructor(){super(...arguments),this.y=new R.$le,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}x(U,G){return{...U,revived:n.TestItem.toPlain(U.item),depth:G?G.depth+1:0,children:new Set}}w(){return new L(this.y)}}class j{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(G=>G.revived)},dispose:(0,N.$eb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new F({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const B=(re,U,G,K)=>{G?Object.assign(G,K):U.$updateTestRunConfig(re.controllerId,re.profileId,K)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,B(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,B(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),B(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,B(this,this.#e,this.#n,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,B(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return R.Event.chain(this.#i,U=>U.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(I.$mg))}constructor(U,G,K,ee,ue,ne,De,$e,J,W=!1,se=void 0,oe=!1){this.controllerId=ue,this.profileId=ne,this.f=De,this.kind=$e,this.runHandler=J,this._tag=se,this.g=oe,this.#e=U,this.#s=G,this.#t=K,this.#i=ee,G.set(ne,this);const te=z[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);W&&K.add(ne),this.#n={profileId:ne,controllerId:ue,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:W,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$joc=M;const z={[o.TestRunProfileKind.Coverage]:d.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:d.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:d.TestRunProfileBitset.Run};function _(re,U){for(let G=0;G<re.path.length;G++){const K=U.find(ee=>ee.id===re.path[G]);if(!K)return;if(G===re.path.length-1)return K;U=K.children}}}),define(Ee[370],Se([1,0,19,4,3,6,167,17,10]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0,r=We(r),T=We(T);class l extends A.$Vc{constructor(E,u){super(),this.m=u,this.a=new h.$le,this.b=new h.$le,this.c=new h.$le,this.f=new h.$le,this.g=new h.$le,this.h=new h.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(R.$1M.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(k=>this.h.fire(k))),this.B(this.m.onDidChangeActiveTextEditor(k=>this.g.fire(k)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const u=this.m.allEditors();return E?u:u.map(k=>k.value)}async showTextDocument(E,u,k){let b;typeof u=="number"?b={position:T.ViewColumn.from(u),preserveFocus:k}:typeof u=="object"?b={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:b={preserveFocus:!1};const c=await this.j.$tryShowTextDocument(E.uri,b),g=c&&this.m.getEditor(c);if(g)return g.value;throw c?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,u){return new N.$BP(this.j,E,u).value}$acceptEditorPropertiesChanged(E,u){const k=this.m.getEditor(E);if(!k)throw new Error("unknown text editor");if(u.options&&k._acceptOptions(u.options),u.selections){const b=u.selections.selections.map(T.Selection.to);k._acceptSelections(b)}if(u.visibleRanges){const b=r.$Ib(u.visibleRanges.map(T.Range.to));k._acceptVisibleRanges(b)}if(u.options&&this.b.fire({textEditor:k.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const b=$.TextEditorSelectionChangeKind.fromValue(u.selections.source),c=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:k.value,selections:c,kind:b})}if(u.visibleRanges){const b=r.$Ib(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:k.value,visibleRanges:b})}}$acceptEditorPositionData(E){for(const u in E){const k=this.m.getEditor(u);if(!k)throw new Error("Unknown text editor");const b=T.ViewColumn.to(E[u]);k.value.viewColumn!==b&&(k._acceptViewColumn(b),this.f.fire({textEditor:k.value,viewColumn:b}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$qnc=l}),define(Ee[371],Se([1,0,2,5,6,3,10,17,24,41,18]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0,e.$apc=(0,h.$Ei)("IExtHostTimeline");class E{constructor(b,c){this.b=new Map,this.c=new Map,this.a=b.getProxy(A.$1M.MainThreadTimeline),c.registerArgumentProcessor({processArgument:(g,f)=>{if(g&&g.$mid===l.MarshalledId.TimelineActionContext)if(this.b.get(g.source)&&$.$pn.equals(f,this.b.get(g.source)?.extension)){const m=g.uri===void 0?void 0:r.URI.revive(g.uri);return this.c.get(g.source)?.get(u(m))?.get(g.handle)}else return;return g}})}async $getTimeline(b,c,g,f){return this.b.get(b)?.provider.provideTimeline(r.URI.revive(c),g,f)}registerTimelineProvider(b,c,g,f){const m=new R.$Uc,n=this.d(c.id,f,m).bind(this);let o;c.onDidChange&&(o=c.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:c.id}),this));const i=this.c;return this.f({...c,scheme:b,onDidChange:void 0,async provideTimeline(t,s,d){s?.resetCache&&(m.clear(),i.get(c.id)?.clear());const a=await c.provideTimeline(t,s,d);if(a==null)return;const w=n(t,s);return{...a,source:c.id,items:a.items.map(w)}},dispose(){for(const t of i.values())t.get(c.id)?.clear();o?.dispose(),m.dispose()}},g)}d(b,c,g){return(f,m)=>{let n;if(m?.cacheResults){let o=this.c.get(b);o===void 0&&(o=new Map,this.c.set(b,o));const i=u(f);n=o.get(i),n===void 0&&(n=new Map,o.set(i,n))}return o=>{const{iconPath:i,...t}=o,s=`${b}|${o.id??o.timestamp}`;n?.set(s,o);let d,a,w;o.iconPath&&(i instanceof N.$ZN?w={id:i.id,color:i.color}:r.URI.isUri(i)?(d=i,a=i):{light:d,dark:a}=i);let y;return N.$sN.isMarkdownString(t.tooltip)?y=T.MarkdownString.from(t.tooltip):(0,I.$eg)(t.tooltip)?y=t.tooltip:N.$sN.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=T.MarkdownString.from(t.detail)):(0,I.$eg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=t.detail),{...t,id:t.id??void 0,handle:s,source:b,command:o.command?c.toInternal(o.command,g):void 0,icon:d,iconDark:a,themeIcon:w,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f(b,c){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:c}),(0,R.$Tc)(()=>{for(const f of this.c.values())f.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$bpc=E;function u(k){return k?.toString()}}),define(Ee[372],Se([1,0,242,23,2,4,3,304,9,10,18,19,17,86,21,198,26]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0,l=We(l);function f(o,i){if((0,I.$eg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class m extends N.$Vc{constructor(i,t,s){super(),this.f=i,this.g=t,this.h=s,this.a=new Map,this.b=new c.$K$;function d(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>d(a)?this.r(a):Array.isArray(a)&&a.length>0?a.map(w=>d(w)?this.r(w):w):a})}registerTreeDataProvider(i,t,s){const d=this.createTreeView(i,{treeDataProvider:t},s);return{dispose:()=>d.dispose()}}createTreeView(i,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,S=this.m(i,t,s),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:a,hasHandleDrag:w,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},P=this.f.$registerTreeViewDataProvider(i,D),C={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,g.$4G)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,g.$4G)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(p){(0,k.$4k)(p)&&(0,g.$4G)(s,"treeViewMarkdownMessage"),S.message=p},get title(){return S.title},set title(p){S.title=p},get description(){return S.description},set description(p){S.description=p},get badge(){return S.badge},set badge(p){p!==void 0&&l.ViewBadge.isViewBadge(p)?S.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(S.badge=void 0)},reveal:(p,v)=>S.reveal(p,v),dispose:async()=>{await P,this.a.delete(i),S.dispose()}};return this.B(C),C}$getChildren(i,t){const s=this.a.get(i);return s?s.getChildren(t):Promise.reject(new T.$mG(i))}async $handleDrop(i,t,s,d,a,w,y,S){const D=this.a.get(i);if(!D)return Promise.reject(new T.$mG(i));const P=u.DataTransfer.toDataTransfer(s,async C=>(await this.f.$resolveDropFileData(i,t,C)).buffer);return y===i&&S&&await this.j(P,D,S,a,w),D.onDrop(P,d,a)}async j(i,t,s,d,a){const w=this.b.removeDragOperationTransfer(a);if(w)(await w)?.forEach((y,S)=>{y&&i.set(S,y)});else if(a&&t.handleDrag){const y=t.handleDrag(s,i,d);this.b.addDragOperationTransfer(a,y),await y}return i}async $handleDrag(i,t,s,d){const a=this.a.get(i);if(!a)return Promise.reject(new T.$mG(i));const w=await this.j(new l.$VN,a,t,d,s);if(!(!w||d.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new T.$mG(i);return t.hasResolve}$resolve(i,t,s){const d=this.a.get(i);if(!d)throw new T.$mG(i);return d.resolveTreeItem(t,s)}$setExpanded(i,t,s){const d=this.a.get(i);if(!d)throw new T.$mG(i);d.setExpanded(t,s)}$setSelectionAndFocus(i,t,s){const d=this.a.get(i);if(!d)throw new T.$mG(i);d.setSelectionAndFocus(t,s)}$setVisible(i,t){const s=this.a.get(i);if(!s){if(!t)return;throw new T.$mG(i)}s.setVisible(t)}$changeCheckboxState(i,t){const s=this.a.get(i);if(!s)throw new T.$mG(i);s.setCheckboxState(t)}m(i,t,s){const d=this.B(new n(i,t,this.f,this.g.converter,this.h,s));return this.a.set(i,d),d}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$cpc=m;class n extends N.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,I.$ng)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,s,d,a,w){if(super(),this.I=i,this.J=s,this.L=d,this.M=a,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$we,w.contributes&&w.contributes.views)for(const P in w.contributes.views)for(const C of w.contributes.views[P])C.id===i&&(this.P=C.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(P=>{Array.isArray(P)&&P.length===0||this.F.fire({message:!1,element:P})}));let y,S;const D=R.Event.debounce(this.F.event,(P,C)=>(P||(P={message:!1,elements:[]}),C.element!==!1&&(y||(y=new Promise(p=>S=p),this.G=this.G.then(()=>y)),Array.isArray(C.element)?P.elements.push(...C.element):P.elements.push(C.element)),C.message&&(P.message=!0),P),200,!0);this.B(D(({message:P,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const p=S;return y=null,this.$(C).then(()=>p())})),P&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let s=this.X(i);return s||(s=await this.Y(t)),s?s.map(d=>d.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const s=(0,I.$ng)(t.select)?!0:t.select,d=(0,I.$ng)(t.focus)?!1:t.focus,a=(0,I.$ng)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then(w=>this.W(i,w[w.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:w.map(S=>S.item)},{select:s,focus:d,expand:a})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:a})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=u.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const s=this.getExtensionElement(i);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(i,t){const s=!(0,E.$vb)(this.s,i);this.s=i;const d=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(i,t,s){const d=[];for(const a of i){const w=this.getExtensionElement(a);w&&d.push(w)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,s){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$wh)(()=>this.g?.handleDrop?this.g.handleDrop(d,i,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(i);if(s){const d=this.m.get(s);if(d){const a=await this.f.resolveTreeItem(d.extensionItem,s,t)??d.extensionItem;return this.hb(a),d.item.tooltip=this.eb(a.tooltip),d.item.command=this.fb(d.disposableStore,a.command),d.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$wh)(()=>this.f.getParent(i))}W(i,t){const s=this.m.get(i);return s?Promise.resolve(s):(0,$.$wh)(()=>this.f.getTreeItem(i)).then(d=>this.kb(i,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(d);if(a){const w=this.m.get(a);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const s=this.getExtensionElement(i);t=s?this.m.get(s):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new b.$we(this.Z.token);try{const s=i?this.m.get(i):void 0,d=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const a=(0,E.$Ib)(d||[]),w=await Promise.all((0,E.$Ib)(a).map(S=>this.f.getTreeItem(S)));if(t.token.isCancellationRequested)return;const y=w.map((S,D)=>S?this.db(a[D],S,s):null);return(0,E.$Ib)(y)}finally{t.dispose()}}$(i){if(i.some(s=>!s))return this.Z.dispose(!0),this.Z=new b.$we,this.tb(),this.J.$refresh(this.I);{const s=this.ab(i);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(i){const t=new Set,s=i.map(a=>this.m.get(a));for(const a of s)if(a&&!t.has(a.item.handle)){let w=a;for(;w&&w.parent&&s.findIndex(y=>w&&w.parent&&y&&y.item.handle===w.parent.item.handle)===-1;){const y=this.j.get(w.parent.item.handle);w=y?this.m.get(y):void 0}w&&!w.parent&&t.add(a.item.handle)}const d=[];return t.forEach(a=>{const w=this.j.get(a);if(w){const y=this.m.get(w);y&&(!y.parent||!t.has(y.parent.item.handle))&&d.push(a)}}),d}bb(i){const t={};return Promise.all(i.map(s=>this.cb(s).then(d=>{d&&(t[s]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,$.$wh)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const a=this.ib(t,d,s.parent);return this.pb(t,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}db(i,t,s){const d=this.ib(i,t,s);if(t.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.ob(i,d),this.qb(d,s),d}eb(i){return l.$sN.isMarkdownString(i)?u.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,s,d;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,s=i.checkboxState.tooltip,d=i.checkboxState.accessibilityInformation),{isChecked:t===l.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(i){if(!l.$QN.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,s){this.hb(t);const d=this.B(new N.$Uc),a=this.kb(i,t,s),w=this.lb(t);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:f(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,I.$ng)(t.collapsibleState)?l.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(i){return i.iconPath instanceof l.$ZN?i.iconPath:void 0}kb(i,{id:t,label:s,resourceUri:d},a,w){if(t)return`${n.b}/${t}`;const y=f(s,this.N),S=a?a.item.handle:n.a;let D=y?y.label:d?(0,h.$ch)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const P=this.m.has(i)?this.m.get(i).item.handle:void 0,C=this.X(a)||[];let p,v=0;do{if(p=`${S}/${v}:${D}`,w||!this.j.has(p)||P===p)break;v++}while(v<=C.length);return p}lb(i){if(i.iconPath&&!(i.iconPath instanceof l.$ZN))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof l.$ZN)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return A.URI.isUri(i)?i:A.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,s,d){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(i,t);const a=this.X(d)||[],w=a.filter(y=>y.item.handle===s.item.handle)[0];w&&a.splice(a.indexOf(w),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[373],Se([1,0,4,3,2,32,17,97,6,10]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0,N=We(N),$=We($),l=We(l);class I extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(b,c,g,f){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$le),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=c,this.#n=g,this.#i=f.viewType,this.#s=f.panelOptions,this.#o=f.viewColumn,this.#r=f.title,this.#l=f.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,A.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#l=b.active,this.#c=b.visible,this.#o=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:N.ViewColumn.from(b),preserveFocus:!!c})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Vc{static c(){return(0,R.$1g)()}constructor(b,c,g){super(),this.j=c,this.m=g,this.g=new Map,this.h=new Map,this.f=b.getProxy($.$1M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,c,g,f,m={}){const n=typeof f=="object"?f.viewColumn:f,o={viewColumn:N.ViewColumn.from(n),preserveFocus:typeof f=="object"&&!!f.preserveFocus},i=(0,T.$Fnc)(b),t=E.c();this.f.$createWebviewPanel((0,T.$Hnc)(b),t,c,{title:g,panelOptions:u(m),webviewOptions:(0,T.$Inc)(b,this.m,m),serializeBuffersForPostMessage:i},o);const s=this.j.createNewWebview(t,m,b);return this.createNewWebviewPanel(t,c,g,n,m,s,!0)}$onDidChangeWebviewPanelViewStates(b){const c=Object.keys(b);c.sort((g,f)=>{const m=b[g],n=b[f];return m.active?1:n.active?-1:+m.visible-+n.visible});for(const g of c){const f=this.getWebviewPanel(g);if(!f)continue;const m=b[g];f._updateViewState({active:m.active,visible:m.visible,viewColumn:N.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,c,g){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:g,extension:b}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,T.$Fnc)(b)}),new l.$3M(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(b,c,g,f){const m=this.h.get(c);if(!m)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:o}=m,i=this.j.createNewWebview(b,g.webviewOptions,o),t=this.createNewWebviewPanel(b,c,g.title,f,g.panelOptions,i,g.active);await n.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(b,c,g,f,m,n,o){const i=new I(b,this.f,n,{viewType:c,title:g,viewColumn:f,panelOptions:m,active:o});return this.g.set(b,i),i}getWebviewPanel(b){return this.g.get(b)}}e.$Jnc=E;function u(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Ee[374],Se([1,0,4,3,97,17,6,10]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0,N=We(N),T=We(T);class $ extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,k,b,c,g){super(),this.#s=!1,this.#l=this.B(new r.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$le),this.onDidDispose=this.#u.event,this.#i=k,this.#a=b,this.#e=E,this.#t=u,this.#n=c,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(N.$1M.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,k,b){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:k,extension:E}),this.a.$registerWebviewViewProvider((0,A.$Hnc)(E),u,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Fnc)(E)}),new T.$3M(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,k,b,c){const g=this.b.get(u);if(!g)throw new Error(`No view provider found for '${u}'`);const{provider:f,extension:m}=g,n=this.d.createNewWebview(E,{},m),o=new $(E,this.a,u,k,n,!0);this.c.set(E,o),await f.resolveWebviewView(o,{state:b},c)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$fpc=l}),define(Ee[375],Se([1,0,76,15,12,277,28,11]),function(ce,e,r,h,A,R,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0;let $=class{constructor(E,u){E.addFileSystemProvider(h.Schemas.file,new l(u),{isCaseSensitive:T.$k})}};e.$Wpc=$,e.$Wpc=$=Qe([qe(0,r.$Bnc),qe(1,A.$$j)],$);class l{constructor(E){this.b=E,this.a=new R.$mr(this.b)}async stat(E){const u=await this.a.stat(E);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===N.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,u,k){return this.a.writeFile(E,u,{...k,unlock:!1,atomic:!1})}delete(E,u){return this.a.delete(E,{...u,useTrash:!1,atomic:!1})}rename(E,u,k){return this.a.rename(E,u,k)}copy(E,u,k){return this.a.copy(E,u,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,u){throw new Error("Method not implemented.")}}}),define(Ee[376],Se([1,0,16,68,32,35,3,6,2,20]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0;let I=class extends N.$Vc{constructor(u,k){super();const b=u.getProxy(T.$1M.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=$.URI.file((0,r.$kc)((0,h.tmpdir)(),(0,A.$1g)()));return await b.$download(c,g),g})}};e.$Upc=I,e.$Upc=I=Qe([qe(0,l.$uP),qe(1,R.$QP)],I)}),define(Ee[377],Se([1,0,61,16,2,98,3,15,9,34]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,r=We(r),h=We(h);class I extends R.$Dnc{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==T.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let a=0;do{let w;a===0?w=d:w=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${a}`:`${d}-${a}`,await E(w);const y=h.$kc(w,"vscode.lock"),S=await c(this.d,y,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),A.URI.file(w);a++}while(a<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$7pc=I;async function E(i){try{await l.Promises.stat(i);return}catch{}try{await l.Promises.mkdir(i,{recursive:!0})}catch{}}const u=1e3,k=10*60*1e3;class b extends N.$Vc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new $.$Ph),this.a.cancelAndSet(async()=>{const d=await g(t,s);(!d||d.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await l.Promises.utimes(s,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${s}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await l.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function c(i,t,s){try{const a={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){i.error(a)}const d=await g(i,t);return!d||d.pid!==process.pid?s?(i.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(i.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(i,t)):(i.info(`Lock '${t}': Lock acquired.`),new b(i,t))}async function g(i,t){let s;try{s=await l.Promises.readFile(t)}catch(d){return i.error(d),null}try{return JSON.parse(String(s))}catch(d){return i.error(d),null}}async function f(i,t){let s;try{s=await l.Promises.stat(t)}catch(d){return i.error(d),0}return s.mtime.getTime()}function m(i){try{return process.kill(i,0),!0}catch{return!1}}async function n(i,t){const s=await g(i,t);if(!s)return i.info(`Lock '${t}': Could not read pid of lock holder.`),o(i,t);if(s.willReleaseAt){let S=s.willReleaseAt-Date.now();if(S<5e3){for(S>0?i.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):i.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,$.$Fh)(Math.min(100,S)),await f(i,t)===0)return o(i,t);S=s.willReleaseAt-Date.now()}return o(i,t)}}if(!m(s.pid))return i.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),o(i,t);const d=await f(i,t),a=Date.now()-d;if(a<=k)return i.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;i.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$Fh)(2e3);const w=await f(i,t),y=Date.now()-w;return y<=k?(i.info(`Lock '${t}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(i.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(i,t))}async function o(i,t){i.info(`Lock '${t}': Deleting a stale lock.`);try{await l.Promises.unlink(t)}catch{}return c(i,t,!0)}}),define(Ee[378],Se([1,0,32,20,47,35]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=void 0;let N=class extends A.$Znc{constructor($,l){super(!0,$,l)}createTerminal($,l,I){return this.createTerminalFromOptions({name:$,shellPath:l,shellArgs:I})}createTerminalFromOptions($,l){const I=new A.$Ync(this.a,(0,r.$1g)(),$,$.name);return this.f.push(I),I.create($,this.R($,l)),I.value}};e.$ppc=N,e.$ppc=N=Qe([qe(0,R.$QP),qe(1,h.$uP)],N)}),define(Ee[379],Se([1,0,4,37,36,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.OutputChannelUpdateMode=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=void 0,e.$9L="text/x-code-output",e.$0L="output",e.$$L="Log",e.$_L="text/x-code-log-output",e.$aM="log",e.$bM="workbench.panel.output",e.$cM=new A.$Vj("inOutput",!1),e.$dM=new A.$Vj("activeLogOutput",!1),e.$eM=new A.$Vj("activeLogOutput.levelSettable",!1),e.$fM=new A.$Vj("activeLogOutput.level",""),e.$gM=new A.$Vj("activeLogOutput.levelIsDefault",!1),e.$hM=new A.$Vj("outputView.scrollLock",!1),e.$iM=(0,R.$Ei)("outputService");var N;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(N||(e.OutputChannelUpdateMode=N={})),e.$jM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new r.$le,this.onDidRegisterChannel=this.b.event,this.c=new r.$le,this.onDidRemoveChannel=this.c.event}registerChannel(l){this.a.has(l.id)||(this.a.set(l.id,l),this.b.fire(l.id))}getChannels(){const l=[];return this.a.forEach(I=>l.push(I)),l}getChannel(l){return this.a.get(l)}removeChannel(l){this.a.delete(l),this.c.fire(l)}}h.$oo.add(e.$jM.OutputChannels,new T),e.$kM=new A.$Vj("activeOutputChannel","")}),define(Ee[168],Se([1,0,6,5,20,24,12,379,76,30,63,203,22,18,28,4,3]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0;class f extends N.$ek{get disposed(){return this.n}constructor(i,t,s,d,a){super(),this.id=i,this.name=t,this.r=s,this.s=d,this.extension=a,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=u.$Ne.fromString(t).byteLength,(0,N.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class m extends f{appendLine(i){this.append(i)}}let n=class{constructor(i,t,s,d,a,w){this.i=t,this.j=s,this.k=d,this.l=a,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(r.$1M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(i,t,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,a=(0,k.$eg)(t)?t:void 0;if((0,k.$eg)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const y=this.i.environment.extensionLogLevel?.find(([D])=>R.$pn.equals(s.identifier,D))?.[1];y&&(w=(0,N.$pk)(y));const S=d?this.o(i,w,s):this.n(i,a,s);return S.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(i,w??this.m.getLevel(),S):this.q(i,S)}async n(i,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,a=this.k.extUri.joinPath(d,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(i,a,t,s.identifier.value);return new f(y,i,w,this.a,s)}async o(i,t,s){const d=await this.p(s),a=i.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(d,`${a}.log`),y=`${s.identifier.value}.${a}`,S=this.l.createLogger(w,{id:y,name:i,logLevel:t,extensionId:s.identifier.value});return new m(y,i,S,this.a,s)}p(i){let t=this.d.get(i.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,b.$ol)(d)!==b.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return t}q(i,t){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return i},append(a){d(),t.then(w=>w.append(a))},appendLine(a){d(),t.then(w=>w.appendLine(a))},clear(){d(),t.then(a=>a.clear())},replace(a){d(),t.then(w=>w.replace(a))},show(a,w){d(),t.then(y=>y.show(a,w))},hide(){d(),t.then(a=>a.hide())},dispose(){s=!0,t.then(a=>a.dispose())}}}r(i,t,s){const d=new g.$Uc,a=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},w=d.add(new c.$le);function y(S){t=S,w.fire(S)}return s.then(S=>{d.add(S),S.logLevel!==t&&y(S.logLevel),d.add(S.onDidChangeLogLevel(D=>y(D)))}),{...this.q(i,s),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(S,...D){a(),s.then(P=>P.trace(S,...D))},debug(S,...D){a(),s.then(P=>P.debug(S,...D))},info(S,...D){a(),s.then(P=>P.info(S,...D))},warn(S,...D){a(),s.then(P=>P.warn(S,...D))},error(S,...D){a(),s.then(P=>P.error(S,...D))},dispose(){d.dispose()}}}};e.$Uoc=n,e.$Uoc=n=Qe([qe(0,A.$uP),qe(1,l.$KP),qe(2,$.$Bnc),qe(3,I.$enc),qe(4,N.$_j),qe(5,N.$$j)],n),e.$Voc=(0,h.$Ei)("IExtHostOutputService")}),define(Ee[169],Se([1,0,5,9]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=void 0,e.$Um=(0,r.$Ei)("remoteAgentService"),e.$Vm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await A.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,h.$Fh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let N;return this.initial.length<this.maxInitialCount?this.initial.push(R):N=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:N,current:R,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof N>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>N*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[380],Se([1,0,246,71,37,46,45,3,4,169,11,25,9,150]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hb=e.$3hb=e.$2hb=e.$1hb=e.$Zhb=e.$Yhb=e.$Xhb=e.$Whb=e.$Vhb=e.$Uhb=void 0,e.$Uhb=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$Vhb=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$Whb=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$Xhb=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$Yhb=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$Zhb={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new $.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const c=new b;A.$oo.add(e.$Zhb.ConfigurationMigration,c);let g=class extends T.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const s of t.added)await this.f(s,c.migrations)})),this.c(c.migrations),this.B(c.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(t=>this.g(t,o?.uri))])}async g(o,i){const t=this.a.inspect(o.key,{resource:i}),s=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",N.ConfigurationTarget.USER],["userLocal",N.ConfigurationTarget.USER_LOCAL],["userRemote",N.ConfigurationTarget.USER_REMOTE],["workspace",N.ConfigurationTarget.WORKSPACE],["workspaceFolder",N.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",N.ConfigurationTarget.USER],["userLocal",N.ConfigurationTarget.USER_LOCAL],["userRemote",N.ConfigurationTarget.USER_REMOTE],["workspace",N.ConfigurationTarget.WORKSPACE]];for(const[d,a]of s){const w=t[d];if(!w)continue;const y=[];if(w.value!==void 0){const S=await this.h(o,d,w.value,i,void 0);for(const D of S??[])y.push([D,[]])}for(const{identifiers:S,value:D}of w.overrides??[])if(D!==void 0){const P=await this.h(o,d,D,i,S);for(const C of P??[])y.push([C,S])}y.length&&await Promise.allSettled(y.map(async([[S,D],P])=>this.a.updateValue(S,D.value,{resource:i,overrideIdentifiers:P},a)))}}async h(o,i,t,s,d){const a=y=>{const D=this.a.inspect(y,{resource:s})[i];if(D)return d?D.overrides?.find(({identifiers:P})=>(0,E.$fo)(P,d))?.value:D.value},w=await o.migrateFn(t,a);return Array.isArray(w)?w:[[o.key,w]]}};e.$1hb=g,e.$1hb=g=Qe([qe(0,N.$$i),qe(1,R.$Ni)],g);let f=class extends T.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new u.$2h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$i&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;A.$oo.as(h.$to.Configuration).registerConfiguration({...e.$Whb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$2hb=f,e.$2hb=f=Qe([qe(0,l.$Um)],f),e.$3hb="window.newWindowProfile";let m=class extends T.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,i){super(),this.c=o,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(t=>{t.source!==N.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$3hb)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=A.$oo.as(h.$to.Configuration),i={...e.$Yhb,properties:{[e.$3hb]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[i],remove:[this.a]}):o.registerConfiguration(i),this.a=i}h(){const o=this.f.getValue(e.$3hb);this.b=o?this.c.profiles.find(i=>i.name===o):void 0}j(){const o=this.f.getValue(e.$3hb);if(!o)return;const i=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;o!==i?.name&&this.f.updateValue(e.$3hb,i?.name)}};e.$4hb=m,e.$4hb=m=Qe([qe(0,k.$Kl),qe(1,N.$$i)],m)}),define(Ee[381],Se([1,0,39,15,16,23,258,380,71,5,37]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$6hb=e.$5hb=void 0,e.$7hb=c,e.$8hb=g,r=We(r),e.$5hb=(0,l.$Ei)("editorResolverService"),e.$6hb="workbench.editorAssociations";const E=I.$oo.as($.$to.Configuration),u={...T.$Vhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,N.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var k;(function(f){f.builtin="builtin",f.option="option",f.exclusive="exclusive",f.default="default"})(k||(e.RegisteredEditorPriority=k={}));var b;(function(f){f[f.ABORT=1]="ABORT",f[f.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function c(f){switch(f){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function g(f,m){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(m.scheme))return!1;const i=typeof f=="string"&&f.indexOf(A.$hc.sep)>=0?`${m.scheme}:${m.path}`:(0,R.$ch)(m);return r.$xk(typeof f=="string"?f.toLowerCase():f,i.toLowerCase())}}),define(Ee[382],Se([1,0,33,15,16,11,23,2,5,296,46,157,169]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0,e.$CM=(0,$.$Ei)("pathService");let b=k=class{constructor(g,f,m,n){this.d=g,this.e=f,this.f=m,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??g})()}hasValidBasename(g,f,m){return typeof f=="string"||typeof f>"u"?this.a.then(n=>this.h(g,n,f)):this.h(g,f,m)}h(g,f,m){return g.scheme===h.Schemas.file||g.scheme===h.Schemas.vscodeRemote?(0,r.$Bg)(m??(0,N.$ch)(g),f===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,f){if(g.remoteAuthority)return h.Schemas.vscodeRemote;const m=(0,l.$zM)(f.getWorkspace());if(m)return m;const n=f.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=f.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===R.OperatingSystem.Windows?A.$gc:A.$hc)}async fileURI(g){let f="";if(await this.a===R.OperatingSystem.Windows&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const n=g.indexOf("/",2);n===-1?(f=g.substring(2),g="/"):(f=g.substring(2,n),g=g.substring(n)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:f,path:g,query:"",fragment:""})}};e.$DM=b,e.$DM=b=k=Qe([qe(1,u.$Um),qe(2,E.$lM),qe(3,I.$Ni)],b)}),define(Ee[383],Se([1,0,260,59,4,60,3,2,45,266,12,72,151,93,46,157,26,21,18,25,36]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.OnPortForward=e.$qM=e.$pM=e.TunnelSource=e.TunnelCloseReason=e.$nM=e.$mM=void 0,e.$oM=a,e.$rM=S,e.$sM=D,e.$tM=P,e.$uM=p,r=We(r);const i=10*1e3,t="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$mM="onTunnel",e.$nM=new o.$Vj("forwardedPortsViewEnabled",!1,r.localize(0,null));function a(L){const F=L.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}var w;(function(L){L.Other="Other",L.User="User",L.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var y;(function(L){L[L.User=0]="User",L[L.Auto=1]="Auto",L[L.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$pM={source:y.User,description:r.localize(1,null)},e.$qM={source:y.Auto,description:r.localize(2,null)};function S(L,F,j){const B=L.get(P(F,j));if(B)return B;if((0,k.$Cw)(F))for(const M of k.$Bw){const z=P(M,j);if(L.has(z))return L.get(z)}else if((0,k.$Ew)(F))for(const M of k.$Dw){const z=P(M,j);if(L.has(z))return L.get(z)}}function D(L,F,j){const B=S(L,F,j);if(B)return B;const M=(0,k.$Ew)(F)?"localhost":(0,k.$Cw)(F)?"0.0.0.0":void 0;if(M)return S(L,M,j)}function P(L,F){return L+":"+F}var C;(function(L){L.Notify="notify",L.OpenBrowser="openBrowser",L.OpenBrowserOnce="openBrowserOnce",L.OpenPreview="openPreview",L.Silent="silent",L.Ignore="ignore"})(C||(e.OnPortForward=C={}));function p(L){return L&&"host"in L&&typeof L.host=="string"&&"port"in L&&typeof L.port=="number"&&(!("detail"in L)||typeof L.detail=="string")&&(!("pid"in L)||typeof L.pid=="string")}class v extends N.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new A.$le,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,j,B){let M=this.w(F,j,B,this.j,0);const z={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const _=this.j[M];_.key===F?(z.onAutoForward=_.onAutoForward??z.onAutoForward,z.elevateIfNeeded=_.elevateIfNeeded!==void 0?_.elevateIfNeeded:z.elevateIfNeeded,z.label=_.label??z.label,z.requireLocalPort=_.requireLocalPort,z.protocol=_.protocol):(z.onAutoForward=z.onAutoForward??_.onAutoForward,z.elevateIfNeeded=z.elevateIfNeeded!==void 0?z.elevateIfNeeded:_.elevateIfNeeded,z.label=z.label??_.label,z.requireLocalPort=z.requireLocalPort!==void 0?z.requireLocalPort:void 0,z.protocol=z.protocol??_.protocol),M=this.w(F,j,B,this.j,M+1)}return z.onAutoForward!==void 0||z.elevateIfNeeded!==void 0||z.label!==void 0||z.requireLocalPort!==void 0||z.protocol!==void 0?z:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,m.$eg)(F.host)&&(0,m.$ig)(F.port)}w(F,j,B,M,z){if(z>=M.length)return-1;const _=!(0,k.$Cw)(j)&&!(0,k.$Ew)(j),U=M.slice(z).findIndex(G=>(0,m.$ig)(G.key)?_?!1:G.key===F:this.t(G.key)?_?!1:F>=G.key.start&&F<=G.key.end:this.u(G.key)?F===G.key.port&&j===G.key.host:B?G.key.test(B):!1);return U>=0?U+z:-1}y(){const F=this.r.getValue(v.c);if(!F||!(0,m.$gg)(F))return[];const j=[];for(const M in F){if(M===void 0)continue;const z=F[M];let _;if(Number(M))_=Number(M);else if((0,m.$eg)(M))if(v.g.test(M)){const re=M.match(v.g);_={start:Number(re[1]),end:Number(re[2])}}else if(v.h.test(M)){const re=M.match(v.h);_={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(M)}catch{}re&&(_=re)}_&&j.push({key:_,elevateIfNeeded:z.elevateIfNeeded,onAutoForward:z.onAutoForward,label:z.label,requireLocalPort:z.requireLocalPort,protocol:z.protocol})}const B=this.r.getValue(v.f);return B&&(this.m={elevateIfNeeded:B.elevateIfNeeded,label:B.label,onAutoForward:B.onAutoForward,requireLocalPort:B.requireLocalPort,protocol:B.protocol}),this.z(j)}z(F){function j(B,M){return(0,m.$ig)(B.key)?B.key:M.t(B.key)?B.key.start:M.u(B.key)?B.key.port:Number.MAX_VALUE}return F.sort((B,M)=>j(B,this)-j(M,this))}C(){return this.m}static providedActionToAction(F){switch(F){case k.ProvidedOnAutoForward.Notify:return C.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return C.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return C.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return C.OpenPreview;case k.ProvidedOnAutoForward.Silent:return C.Silent;case k.ProvidedOnAutoForward.Ignore:return C.Ignore;default:return}}async addAttributes(F,j,B){const z=this.r.inspect(v.c).userRemoteValue;let _;!z||!(0,m.$gg)(z)?_={}:_=(0,n.$bo)(z),_[`${F}`]||(_[`${F}`]={});for(const re in j)_[`${F}`][re]=j[re];return this.r.updateValue(v.c,_,B)}}e.$vM=v;let O=class extends N.$Vc{constructor(F,j,B,M,z,_,re,U,G,K){super(),this.H=F,this.I=j,this.J=B,this.L=M,this.M=z,this.N=_,this.O=re,this.P=U,this.Q=G,this.R=K,this.c=new Map,this.g=new A.$le,this.onForwardPort=this.g.event,this.h=new A.$le,this.onClosePort=this.h.event,this.j=new A.$le,this.onPortName=this.j.event,this.n=new A.$le,this.onCandidatesChanged=this.n.event,this.t=new A.$le,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$le,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(B),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const ue=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=P(ne.tunnelRemoteHost,ne.tunnelRemotePort),$e=D(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ue?.get(ne.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ue?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:ne.privacy,source:e.$pM}),this.f.set(De,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const ue=P(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!D(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!D(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!D(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=D(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.$pM})}await this.cb(),this.f.set(ue,ee),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,w.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$mM))?(this.R.createKey(e.$nM.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,j){const B=P(F.host,F.port);this.forwarded.has(B)&&(this.forwarded.delete(B),await this.cb(),this.h.fire(F))}X(F,j){if(F.startsWith("http"))return T.URI.parse(F);const B=j?.protocol??"http";return T.URI.parse(`${B}://${F}`)}async Y(F){const j=this.N.getWorkspace(),B=j.configuration?(0,R.$sj)(j.configuration.path):j.folders.length>0?(0,R.$sj)(j.folders[0].uri.path):void 0;if(B===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${B}`}async Z(){return this.Y(t)}async $(){return this.Y(s)}async ab(){const F=this.I.get(t,u.StorageScope.WORKSPACE);if(F)return this.I.remove(t,u.StorageScope.WORKSPACE),await this.cb(),F;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const j=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(B=>B.remotePort).join(", ")}`);for(const B of j){const M=D(this.detected,B.remoteHost,B.remotePort);B.source.source!==y.Extension&&!M||B.source.source===y.Extension&&M?await this.fb({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,elevateIfNeeded:!0,source:B.source}):B.source.source===y.Extension&&!M&&this.D.set(P(B.remoteHost,B.remotePort),B)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new N.$Uc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===F&&(this.s=Promise.resolve(this.I.get(F,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(s));for(const j of F){const B=this.I.getNumber(j,u.StorageScope.PROFILE);if(B&&B<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(s,t);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(M,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),j=F.map(_=>({remoteHost:_.remoteHost,remotePort:_.remotePort,localPort:_.localPort,name:_.name,localAddress:_.localAddress,localUri:_.localUri,protocol:_.protocol,source:_.source}));let B;F.length>0&&(B=JSON.stringify(j));const M=await this.Z(),z=await this.$();!B&&M&&z?(this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(z,u.StorageScope.PROFILE)):B!==this.y&&M&&z&&(this.I.store(M,B,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(z,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=B}}async eb(F,j,B){if(!F.tunnelLocalPort||!B?.requireLocalPort||F.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+i>M.getTime())return;this.db=M;const z=r.localize(3,null,j,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(z)}async forward(F,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(F,j)}async fb(F,j){await this.Q.activateByEvent(e.$mM);const B=D(this.forwarded,F.remote.host,F.remote.port);j=j??(j!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const M=F.local!==void 0?F.local:F.remote.port;let z;if(B)return this.hb(B,F,j);{const _=this.L.remoteAuthority,re=_?{getAddress:async()=>(await this.M.resolveAuthority(_)).authority}:void 0,U=P(F.remote.host,F.remote.port);this.c.set(U,!0),F=this.gb(U,F);const G=await this.H.openTunnel(re,F.remote.host,F.remote.port,void 0,M,F.elevateIfNeeded?F.elevateIfNeeded:j?.elevateIfNeeded,F.privacy,j?.protocol);if(typeof G=="string")z=G;else if(G&&G.localAddress){const K=D(this.m??new Map,F.remote.host,F.remote.port),ee=G.protocol?G.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:j?.protocol??k.TunnelProtocol.Http,ue={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??F.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:K?.detail,hasRunningProcess:!!K,pid:K?.pid,source:F.source??e.$pM,privacy:G.privacy};return this.forwarded.set(U,ue),this.f.set(U,G),this.c.delete(U),await this.cb(),await this.eb(G,M,j),this.g.fire(ue),G}this.c.delete(U)}return z}gb(F,j){const B=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(B){const M=B.get(F);B.delete(F),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(F,j,B){const M=B?.label??j.name;let z;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(z||(z={}));let _=z.None;switch(M!==F.name&&(F.name=M,_=z.Fire),(B?.protocol||F.protocol!==k.TunnelProtocol.Http)&&B?.protocol!==F.protocol&&(j.source=F.source,_=z.Reopen),j.privacy&&F.privacy!==j.privacy&&(_=z.Reopen),_){case z.Fire:{this.g.fire();break}case z.Reopen:await this.close(F.remoteHost,F.remotePort,w.User),await this.fb(j,B)}return D(this.f,j.remote.host,j.remote.port)}async name(F,j,B){const M=D(this.forwarded,F,j),z=P(F,j);if(M){M.name=B,await this.cb(),this.j.fire({host:F,port:j});return}else this.detected.has(z)&&(this.detected.get(z).name=B,this.j.fire({host:F,port:j}))}async close(F,j,B){const M=P(F,j),z=this.forwarded.get(M);return B===w.AutoForwardEnd&&z&&z.source.source===y.Auto&&this.F.set(M,{local:z.localPort,name:z.name,privacy:z.privacy}),await this.H.closeTunnel(F,j),this.W({host:F,port:j},B)}address(F,j){const B=P(F,j);return(this.forwarded.get(B)||this.detected.get(B))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const j of F){const B=D(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:P(j.localAddress.host,j.localAddress.port);this.detected.set(P(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:k.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let j=F;this.r&&(j=await this.r(F));const B=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(B.values()).map(M=>M.port).join(", ")}`),this.n.fire(B)}ib(F){const j=this.m??new Map,B=new Map;return this.m=B,F.forEach(M=>{const z=P(M.host,M.port);B.set(z,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(z)&&j.delete(z);const _=D(this.forwarded,M.host,M.port);_&&(_.runningProcess=M.detail,_.hasRunningProcess=!0,_.pid=M.pid)}),j.forEach((M,z)=>{const _=a(z);if(!_)return;const re=D(this.forwarded,_.host,_.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const U=D(this.detected,_.host,_.port);U&&(U.runningProcess=void 0,U.hasRunningProcess=!1,U.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),j=await this.getAttributes(F.map(B=>({port:B.remotePort,host:B.remoteHost})),!1);if(j)for(const B of F){const M=j.get(B.remotePort);(M?.protocol||B.protocol!==k.TunnelProtocol.Http)&&M?.protocol!==B.protocol&&await this.fb({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,source:B.source},M),M&&M.label&&M.label!==B.name&&await this.name(B.remoteHost,B.remotePort,M.label)}}async getAttributes(F,j=!0){const B=new Map,M=new Map;F.forEach(G=>{const K=D(this.m??new Map,k.$Bw[0],G.port)??G;if(K){B.set(G.port,K);const ee=p(K)?K.pid:void 0;M.has(ee)||M.set(ee,[]),M.get(ee)?.push(G.port)}});const z=new Map;if(F.forEach(G=>{const K=this.configPortsAttributes.getAttributes(G.port,G.host,B.get(G.port)?.detail);K&&z.set(G.port,K)}),this.G.length===0||!j)return z.size>0?z:void 0;const _=await Promise.all(this.G.flatMap(G=>Array.from(M.entries()).map(K=>{const ee=K[1],ue=B.get(ee[0]);return G.providePortAttributes(ee,ue?.pid,ue?.detail,f.CancellationToken.None)}))),re=new Map;if(_.forEach(G=>G.forEach(K=>{K&&re.set(K.port,K)})),!z&&!re)return;const U=new Map;return F.forEach(G=>{const K=z.get(G.port),ee=re.get(G.port);U.set(G.port,{elevateIfNeeded:K?.elevateIfNeeded,label:K?.label,onAutoForward:K?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:K?.requireLocalPort,protocol:K?.protocol})}),U}addAttributesProvider(F){this.G.push(F)}};e.$wM=O,Qe([(0,h.$0h)(1e3)],O.prototype,"cb",null),e.$wM=O=Qe([qe(0,k.$ww),qe(1,u.$bq),qe(2,$.$$i),qe(3,c.$lM),qe(4,E.$Pl),qe(5,b.$Ni),qe(6,I.$$j),qe(7,l.$2w),qe(8,g.$ZG),qe(9,o.$Wj)],O)}),define(Ee[100],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$eL=e.$dL=void 0;class r{constructor(N,T){this.line=N,this.character=T}isBefore(N){return!1}isBeforeOrEqual(N){return!1}isAfter(N){return!1}isAfterOrEqual(N){return!1}isEqual(N){return!1}compareTo(N){return 0}translate(N,T){return new r(0,0)}with(N){return new r(0,0)}}e.$dL=r;class h{constructor(N,T,$,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(N,T),this.end=new r($,l)}contains(N){return!1}isEqual(N){return!1}intersection(N){}union(N){return new h(0,0,0,0)}with(N){return new h(0,0,0,0)}}e.$eL=h;var A;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ee[38],Se([1,0,19,39,25,33,13,5,16,14,100,9]),function(ce,e,r,h,A,R,N,T,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.TextSearchCompleteMessageType=void 0,e.$mL=f,e.$nL=m,e.$oL=n,e.$tL=S,e.$uL=D,e.$wL=p,e.$xL=v,e.$yL=O,e.$zL=L,e.$AL=F,e.$BL=j,e.$DL=M,e.$FL=re,e.$GL=U,h=We(h),A=We(A),R=We(R),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$fL="workbench.view.search",e.$gL="workbench.panel.search",e.$hL="workbench.view.search",e.$iL="search-result",e.$jL="search.exclude",e.$kL=2e4;const u="\u27EA ",k=" characters skipped \u27EB",b=(u.length+k.length+5)*2;e.$lL=(0,T.$Ei)("searchService");var c;(function(K){K[K.file=0]="file",K[K.text=1]="text",K[K.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var g;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.aiText=3]="aiText"})(g||(e.QueryType=g={}));function f(K){return!!K.preview}function m(K){return!!K.resource}function n(K){return!!K.message}var o;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class i{constructor(ee){this.resource=ee,this.results=[]}}e.$pL=i;class t{constructor(ee,ue,ne,De){this.ranges=ue,this.webviewIndex=De;const $e=Array.isArray(ue)?ue:[ue];if(ne&&ne.matchLines===1&&s($e)){ee=(0,N.$0f)(ee,ne.matchLines);let J="",W=0,se=0;const oe=Math.floor(ne.charsPerLine/5),te=[];for(const le of $e){const he=Math.max(le.startColumn-oe,0),Z=le.startColumn+ne.charsPerLine;if(he>se+oe+b){const ae=u+(he-se)+k;J+=ae+ee.slice(he,Z),W+=he-(se+ae.length)}else J+=ee.slice(se,Z);te.push(new a(0,le.startColumn-W,le.endColumn-W)),se=Z}this.preview={text:J,matches:Array.isArray(this.ranges)?te:te[0]}}else{const J=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ee,matches:(0,r.$2b)(ue,W=>new d(W.startLineNumber-J,W.startColumn,W.endLineNumber-J,W.endColumn))}}}}e.$qL=t;function s(K){const ee=K[0].startLineNumber;for(const ue of K)if(ue.startLineNumber!==ee||ue.endLineNumber!==ee)return!1;return!0}class d{constructor(ee,ue,ne,De){this.startLineNumber=ee,this.startColumn=ue,this.endLineNumber=ne,this.endColumn=De}}e.$rL=d;class a extends d{constructor(ee,ue,ne){super(ee,ue,ee,ne)}}e.$sL=a;var w;(function(K){K.List="list",K.Tree="tree"})(w||(e.ViewMode=w={}));var y;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function S(K,ee=!0){const ue=K&&K.files&&K.files.exclude,ne=ee&&K&&K.search&&K.search.exclude;if(!ue&&!ne)return;if(!ue||!ne)return ue||ne;let De=Object.create(null);return De=A.$eo(De,A.$bo(ue)),De=A.$eo(De,A.$bo(ne),!0),De}function D(K,ee){return K.excludePattern&&h.$xk(K.excludePattern,ee)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&h.$xk(K.includePattern,ee)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(ue=>{const ne=ue.folder.fsPath;if(R.$Dg(ee,ne)){const De=$.$mc(ne,ee);return!ue.includePattern||!!h.$xk(ue.includePattern,De)}else return!1}):!1:!0}var P;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(P||(e.SearchErrorCode=P={}));class C extends Error{constructor(ee,ue){super(ee),this.code=ue}}e.$vL=C;function p(K){const ee=K.message;if((0,l.$5)(K))return new C(ee,P.canceled);try{const ue=JSON.parse(ee);return new C(ue.message,ue.code)}catch{return new C(ee,P.other)}}function v(K){const ee={message:K.message,code:K.code};return new Error(JSON.stringify(ee))}function O(K){return K.type==="error"?!0:K.type==="success"}function L(K){return K.type==="success"}function F(K){return!!K.path}function j(K,ee,ue=!0){const ne=K.searchPath?K.searchPath:K.relativePath;return ue?(0,N.$7f)(ne,ee):h.$xk(ee,ne)}class B{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=B;function M(K,ee){const ue={...K||{},...ee||{}};return Object.keys(ue).filter(ne=>{const De=ue[ne];return typeof De=="boolean"&&De})}class z{constructor(ee,ue){this.c=null,this.a={...ee.excludePattern||{},...ue.excludePattern||{}},this.b=h.$yk(this.a);let ne=ee.includePattern;ue.includePattern&&(ne?ne={...ne,...ue.includePattern}:ne=ue.includePattern),ne&&(this.c=h.$yk(ne))}matchesExcludesSync(ee,ue,ne){return!!(this.b&&this.b(ee,ue,ne))}includedInQuerySync(ee,ue,ne){return!(this.b&&this.b(ee,ue,ne)||this.c&&!this.c(ee,ue,ne))}includedInQuery(ee,ue,ne){const De=this.b(ee,ue,ne),$e=()=>this.c?!!this.c(ee,ue,ne):!0;return(0,E.$qh)(De)?De.then(J=>J?!1:$e()):$e()}hasSiblingExcludeClauses(){return _(this.a)}}e.$EL=z;function _(K){for(const ee in K)if(typeof K[ee]!="boolean")return!0;return!1}function re(K){if(!K)return;let ee;return ue=>(ee||(ee=(K()||Promise.resolve([])).then(ne=>ne?G(ne):{})),ee.then(ne=>!!ne[ue]))}function U(K){if(!K)return;let ee;return ue=>{if(!ee){const ne=K();ee=ne?G(ne):{}}return!!ee[ue]}}function G(K){const ee={};for(const ue of K)ee[ue]=!0;return ee}}),define(Ee[48],Se([1,0,19,9,21,4,3,85,15,134,23,13,2,244,28,5,12,280,46,63,30,20,17,10,73,38,6,57]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=e.$vnc=void 0;function S(F,j,B){return new I.$7g(M=>p(M,B)).isEqual(F,j)}function D(F,j,B){return S(F.uri,j.uri,B)?0:(0,E.$yf)(F.uri.toString(),j.uri.toString())}function P(F,j,B){return F.index!==j.index?F.index<j.index?-1:1:S(F.uri,j.uri,B)?(0,E.$yf)(F.name,j.name):(0,E.$yf)(F.uri.toString(),j.uri.toString())}function C(F,j,B,M){const z=F.slice(0).sort((re,U)=>B(re,U,M)),_=j.slice(0).sort((re,U)=>B(re,U,M));return(0,r.$Fb)(z,_,(re,U)=>B(re,U,M))}function p(F,j){const B=j.getCapabilities(F.scheme);return!(B&&B&b.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends m.$Xi{static toExtHostWorkspace(j,B,M,z){if(!j)return{workspace:null,added:[],removed:[]};const{id:_,name:re,folders:U,configuration:G,transient:K,isUntitled:ee}=j,ue=[],ne=B;B?U.forEach((W,se)=>{const oe=u.URI.revive(W.uri),te=v.o(M||B,oe,z);te?(te.name=W.name,te.index=W.index,ue.push(te)):ue.push({uri:oe,name:W.name,index:se})}):ue.push(...U.map(({uri:W,name:se,index:oe})=>({uri:u.URI.revive(W),name:se,index:oe}))),ue.sort((W,se)=>W.index<se.index?-1:1);const De=new v(_,re,ue,!!K,G?u.URI.revive(G):null,!!ee,W=>p(W,z)),{added:$e,removed:J}=C(ne?ne.workspaceFolders:[],De.workspaceFolders,D,z);return{workspace:De,added:$e,removed:J}}static o(j,B,M){for(let z=0;z<j.folders.length;z++){const _=j.workspaceFolders[z];if(S(_.uri,B,M))return _}}constructor(j,B,M,z,_,re,U){super(j,M.map(G=>new m.$Yi(G)),z,_,U),this.t=B,this.u=re,this.q=[],this.s=T.$Ki.forUris(U),M.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,B){return B&&this.s.get(j)&&(j=(0,I.$eh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let O=class{constructor(j,B,M,z,_){this.c=new R.$le,this.onDidChangeWorkspace=this.c.event,this.g=new R.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$ne,this.C=new Map,this.h=z,this.s=M,this.t=_,this.j=new l.$Lm,this.k=new h.$Dh,this.o=j.getProxy(w.$1M.MainThreadWorkspace),this.q=j.getProxy(w.$1M.MainThreadMessageService);const re=B.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,U=>p(U,M)):void 0}$initializeWorkspace(j,B){this.v=B,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,I.$ch)((0,I.$eh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,B,M,...z){const _=[];if(Array.isArray(z)&&z.forEach(ee=>{u.URI.isUri(ee.uri)&&!_.some(ue=>S(ue.uri,ee.uri,this.s))&&_.push({uri:ee.uri,name:ee.name||(0,I.$bh)(ee.uri)})}),this.n||[B,M].some(ee=>typeof ee!="number"||ee<0)||M===0&&_.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(B+M>re.length)return!1;const U=re.slice(0);U.splice(B,M,..._.map(ee=>({uri:ee.uri,name:ee.name||(0,I.$bh)(ee.uri),index:void 0})));for(let ee=0;ee<U.length;ee++){const ue=U[ee];if(U.some((ne,De)=>De!==ee&&S(ue.uri,ne.uri,this.s)))return!1}U.forEach((ee,ue)=>ee.index=ue);const{added:G,removed:K}=C(re,U,P,this.s);if(G.length===0&&K.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,B,M,_).then(void 0,ue=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,k.localize)(0,null,ee,ue.toString()),ne,[])})}return this.y(U),!0}getWorkspaceFolder(j,B){if(this.x)return this.x.getWorkspaceFolder(j,B)}async getWorkspaceFolder2(j,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,B)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,B){let M,z="";if(typeof j=="string"?(M=u.URI.file(j),z=j):typeof j<"u"&&(M=j,z=j.fsPath),!M)return z;const _=this.getWorkspaceFolder(M,!0);if(!_)return z;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let re=(0,I.$hh)(_.uri,M);return B&&_.name&&(re=`${_.name}/${re}`),re}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:B,added:M,removed:z}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:z}))}findFiles(j,B,M,z,_=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let re="",U=!0;return B===null?U=!1:B!==void 0&&(typeof B=="string"?re=B:re=B.pattern),this.z(j,void 0,{exclude:re,maxResults:M,useDefaultExcludes:U,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},_)}findFiles2(j,B={},M,z=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,B,z)}async z(j,B,M,z=A.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const _=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,re={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:_,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let U;if(j){const{includePattern:G,folder:K}=L(t.GlobPattern.from(j));U=K,re.includePattern=G}else{const{includePattern:G,folder:K}=L(t.GlobPattern.from(B));U=K,re.filePattern=G}return this.o.$startFileSearch(U??null,re,z).then(G=>Array.isArray(G)?G.map(K=>u.URI.revive(K)):[])}async findTextInFiles(j,B,M,z,_=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),U=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:G,folder:K}=L(t.GlobPattern.from(B.include)),ee=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ue={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:U,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:G,excludePattern:ee},ne=!1;if(this.u[re]=De=>{if(ne)return;const $e=u.URI.revive(De.resource);De.results.forEach(J=>{const W=(0,y.$bi)(J);(0,a.$mL)(W)?M({uri:$e,preview:{text:W.preview.text,matches:(0,r.$2b)(W.preview.matches,se=>new s.$5M(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$2b)(W.ranges,se=>new s.$5M(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:$e,text:W.text,lineNumber:W.lineNumber})})},_.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(j,K??null,ue,re,_);return delete this.u[re],De||{}}catch(De){throw delete this.u[re],De}}$handleTextSearchResult(j,B){this.u[B]?.(j)}async save(j){const B=await this.o.$save(j,{saveAs:!1});return u.URI.revive(B)}async saveAs(j){const B=await this.o.$save(j,{saveAs:!0});return u.URI.revive(B)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,B){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,B);const M=this.t.transformOutgoingScheme(j),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,M),(0,N.$Tc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(j,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const z=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!z),!z)return;const _=await z.provideEditSessionIdentity(M,B);if(this.h.info("Provider returned edit session identifier: ",_),!!_)return _}async $provideEditSessionIdentityMatch(j,B,M,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const _=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!_){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",_);const re=this.w.get(_.uri.scheme);if(this.h.info(`Provider for scheme ${_.uri.scheme} is defined: `,!!re),!re)return;const U=await re.provideEditSessionIdentityMatch?.(B,M,z);if(this.h.info("Provider returned edit session identifier match result: ",U),!!U)return U}getOnWillCreateEditSessionIdentityEvent(j){return(B,M,z)=>{const _=function(U){B.call(M,U)};return _.extension=j,this.B.event(_,void 0,z)}}async $onWillCreateEditSessionIdentity(j,B,M){const z=await this.resolveWorkspaceFolder(u.URI.revive(j));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},B,async(_,re)=>{const U=Date.now();await Promise.resolve(_),Date.now()-U>M&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(j,B){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,B);const M=this.t.transformOutgoingScheme(j),z=this.A++;return this.o.$registerCanonicalUriProvider(z,M),(0,N.$Tc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(j,B,M){const z=this.C.get(j.scheme);if(!z)return;const _=await z.provideCanonicalUri?.(u.URI.revive(j),B,M);if(_)return _}async $provideCanonicalUri(j,B,M){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:B},M)}};e.$vnc=O,e.$vnc=O=Qe([qe(0,i.$uP),qe(1,o.$KP),qe(2,n.$enc),qe(3,g.$$j),qe(4,d.$tnc)],O),e.$wnc=(0,c.$Ei)("IExtHostWorkspace");function L(F){let j,B;return F&&(typeof F=="string"?j=F:(j=F.pattern,B=u.URI.revive(F.baseUri))),{includePattern:j,folder:B}}}),define(Ee[42],Se([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=e.$ync=e.$xnc=void 0;function g(d,a){if(a){const w=a.split(".");let y=d;for(let S=0;y&&S<w.length;S++)y=y[w[S]];return y}}function f(d){return d instanceof c.URI}function m(d){return d&&d.uri instanceof c.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof c.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function i(d){if(f(d))return{resource:d};if(m(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let t=class{constructor(a,w,y){this.a=a.getProxy(R.$1M.MainThreadConfiguration),this.c=w,this.b=y,this.d=new E.$Dh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,w){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(a,w))}};e.$xnc=t,e.$xnc=t=Qe([qe(0,k.$uP),qe(1,A.$wnc),qe(2,b.$$j)],t);class s{constructor(a,w,y,S){this.a=new h.$le,this.b=a,this.f=S,this.c=w,this.e=$.$Mo.parse(y,S),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,w){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Mo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(w,y))}getConfiguration(a,w,y){const S=i(w)||{},D=this.g(a?g(this.e.getValue(void 0,S,this.c.workspace),a):this.e.getValue(void 0,S,this.c.workspace));a&&this.h(a,S,y?.identifier);function P(p){if(p==null)return null;if(typeof p=="boolean")return p?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(p){case N.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case N.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case N.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(p){return typeof g(D,p)<"u"},get:(p,v)=>{this.h(a?`${a}.${p}`:p,S,y?.identifier);let O=g(D,p);if(typeof O>"u")O=v;else{let L;const F=(j,B)=>{if((0,I.$gg)(j)){let M;const z=()=>{L=L||(0,r.$bo)(D),M=M||g(L,B)};return new Proxy(j,{get:(_,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return z(),()=>M;if(L)return M=M||g(L,B),M[re];const U=_[re];return typeof re=="string"?F(U,`${B}.${re}`):U},set:(_,re,U)=>(z(),M&&(M[re]=U),!0),deleteProperty:(_,re)=>(z(),M&&delete M[re],!0),defineProperty:(_,re,U)=>(z(),M&&Object.defineProperty(M,re,U),!0)})}return Array.isArray(j)?(0,r.$bo)(j):j};O=F(O,p)}return O},update:(p,v,O,L)=>{p=a?`${a}.${p}`:p;const F=P(O);return v!==void 0?this.b.$updateConfigurationOption(F,p,v,S,L):this.b.$removeConfigurationOption(F,p,S,L)},inspect:p=>{p=a?`${a}.${p}`:p;const v=this.e.inspect(p,S,this.c.workspace);if(v)return{key:p,defaultValue:(0,r.$bo)(v.policy?.value??v.default?.value),globalValue:(0,r.$bo)(v.user?.value??v.application?.value),workspaceValue:(0,r.$bo)(v.workspace?.value),workspaceFolderValue:(0,r.$bo)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$bo)(v.default?.override),globalLanguageValue:(0,r.$bo)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$bo)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$bo)(v.workspaceFolder?.override),languageIds:(0,r.$bo)(v.overrideIdentifiers)}}};return typeof D=="object"&&(0,r.$eo)(C,D,!1),Object.freeze(C)}g(a){const w=y=>(0,I.$gg)(y)?new Proxy(y,{get:(S,D)=>w(S[D]),set:(S,D,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(S,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(S,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return w(a)}h(a,w,y){const S=l.$Do.test(a)?l.ConfigurationScope.RESOURCE:this.d.get(a),D=y?`[${y.value}] `:"";if(l.ConfigurationScope.RESOURCE===S){typeof w?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===S){w?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,w){const y=new $.$Oo(a,w,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,D)=>y.affectsConfiguration(S,i(D))})}k(a){return a.reduce((w,y)=>(w.set(y[0],y[1]),w),new Map)}}e.$ync=s,e.$znc=(0,u.$Ei)("IExtHostConfiguration")}),define(Ee[101],Se([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=e.$8oc=e.$7oc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,N=We(N),g=We(g);var i;(function(L){function F(B){if(B!=null)return B}L.from=F;function j(B){if(B!=null)return B}L.to=j})(i||(i={}));var t;(function(L){function F(B){if(B!=null)return B}L.from=F;function j(B){if(B!=null)return B}L.to=j})(t||(t={}));var s;(function(L){function F(B){if(B!=null)return B}L.from=F;function j(B){if(B!=null)return B}L.to=j})(s||(s={}));var d;(function(L){function F(M){if(M){const z=M;return z&&!!z.process}else return!1}L.is=F;function j(M){if(M==null)return;const z={process:M.process,args:M.args};return M.options&&(z.options=s.from(M.options)),z}L.from=j;function B(M){if(M!=null)return new N.$MN(M.process,M.args,M.options)}L.to=B})(d||(d={}));var a;(function(L){function F(B){if(B!=null)return B}L.from=F;function j(B){if(B!=null)return B}L.to=j})(a||(a={}));var w;(function(L){function F(M){if(M){const z=M;return z&&(!!z.commandLine||!!z.command)}else return!1}L.is=F;function j(M){if(M==null)return;const z={};return M.commandLine!==void 0?z.commandLine=M.commandLine:(z.command=M.command,z.args=M.args),M.options&&(z.options=a.from(M.options)),z}L.from=j;function B(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new N.$NN(M.commandLine,M.options):new N.$NN(M.command,M.args?M.args:[],M.options)}L.to=B})(w||(w={}));var y;(function(L){function F(M){if(M){const z=M;return z&&z.customExecution==="customExecution"}else return!1}L.is=F;function j(M){return{customExecution:"customExecution"}}L.from=j;function B(M,z){return z.get(M)}L.to=B})(y||(e.CustomExecutionDTO=y={}));var S;(function(L){function F(j,B){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===N.TaskScope.Workspace&&B&&B.workspaceFile?M=B.workspaceFile:M=n.$DI),{id:j._id,workspaceFolder:M}}L.from=F})(S||(e.TaskHandleDTO=S={}));var D;(function(L){function F(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}L.from=F})(D||(D={}));var P;(function(L){function F(M,z){if(M==null)return[];const _=[];for(const re of M){const U=j(re,z);U&&_.push(U)}return _}L.fromMany=F;function j(M,z){if(M==null)return;let _;M.execution instanceof N.$MN?_=d.from(M.execution):M.execution instanceof N.$NN?_=w.from(M.execution):M.execution&&M.execution instanceof N.$ON&&(_=y.from(M.execution));const re=i.from(M.definition);let U;return M.scope?typeof M.scope=="number"?U=M.scope:U=M.scope.uri:U=N.TaskScope.Workspace,!re||!U?void 0:{_id:M._id,definition:re,name:M.name,source:{extensionId:z.identifier.value,label:M.source,scope:U},execution:_,isBackground:M.isBackground,group:D.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}L.from=j;async function B(M,z,_){if(M==null)return;let re;d.is(M.execution)?re=d.to(M.execution):w.is(M.execution)?re=w.to(M.execution):y.is(M.execution)&&(re=y.to(M._id,_));const U=i.to(M.definition);let G;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?G=M.source.scope:G=await z.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):G=N.TaskScope.Workspace),!U||!G)return;const K=new N.$PN(U,G,M.name,M.source.label,re,M.problemMatchers);return M.isBackground!==void 0&&(K.isBackground=M.isBackground),M.group!==void 0&&(K.group=N.$LN.from(M.group._id),K.group&&M.group.isDefault&&(K.group=new N.$LN(K.group.id,K.group.label),M.group.isDefault===!0&&(K.group.isDefault=M.group.isDefault))),M.presentationOptions&&(K.presentationOptions=t.to(M.presentationOptions)),M._id&&(K._id=M._id),M.detail&&(K.detail=M.detail),K}L.to=B})(P||(e.TaskDTO=P={}));var C;(function(L){function F(B){return B}L.from=F;function j(B){if(B)return Object.assign(Object.create(null),B)}L.to=j})(C||(C={}));class p{#e;constructor(F,j,B){this._id=j,this.a=B,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let v=class{constructor(F,j,B,M,z,_,re,U){this.q=new A.$le,this.r=new A.$le,this.s=new A.$le,this.u=new A.$le,this.a=F.getProxy(R.$1M.MainThreadTask),this.b=B,this.c=M,this.d=z,this.e=_,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=U,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,j,B){if(!B)return new N.$3M(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:B,extension:F}),this.a.$registerTaskProvider(M,j),new N.$3M(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(F,j){this.a.$registerTaskSystem(F,j)}fetchTasks(F){return this.a.$fetchTasks(C.from(F)).then(async j=>{const B=[];for(const M of j){const z=await P.to(M,this.b,this.m);z&&B.push(z)}return B})}get taskExecutions(){const F=[];return this.k.forEach(j=>F.push(j)),F}terminateTask(F){if(!(F instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,j,B){const M=this.m.get(F.id);M&&(this.o.set(F.id,M),this.e.attachPtyToTerminal(j,await M.callback(B))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const j=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const j=await this.z(F.id);this.s.fire({execution:j,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const j=await this.z(F.id);this.u.fire({execution:j,exitCode:F.exitCode})}$provideTasks(F,j){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));const M=[],z=(0,h.$wh)(()=>B.provider.provideTasks(I.CancellationToken.None)).then(_=>this.v(j,M,B,_));return new Promise(_=>{z.then(re=>{Promise.all(M).then(()=>{_(re)})})})}async $resolveTask(F,j){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(j.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${B.type}].`);const M=await P.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(M,I.CancellationToken.None);if(!z)return;this.A(z,B);const _=P.from(z,B.extension);if(!_)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(_.execution)&&await this.y(_,z,!0),await this.w(_)}x(){return this.h++}async y(F,j,B){const M=await this.a.$createTaskId(F);!B&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(F,j){if(typeof F=="string"){const z=this.l.get(F);if(!z)throw new o.$cb("Unexpected: The specified task is missing an execution");return z}const B=this.l.get(F.id);if(B)return B;let M;return j?M=Promise.resolve(new p(this,F.id,j)):M=P.to(F.task,this.b,this.m).then(z=>{if(!z)throw new o.$cb("Unexpected: Task does not exist.");return new p(this,F.id,z)}),this.l.set(F.id,M),M.then(z=>(this.k.set(F.id,z),z))}A(F,j){F._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const B=this.n.values();let M=B.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=B.next()}};e.$7oc=v,e.$7oc=v=Qe([qe(0,u.$uP),qe(1,k.$KP),qe(2,T.$wnc),qe(3,$.$FP),qe(4,l.$znc),qe(5,E.$Xnc),qe(6,f.$$j),qe(7,m.$anc)],v);let O=class extends v{constructor(F,j,B,M,z,_,re,U){super(F,j,B,M,z,_,re,U),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$h(g.Platform.Web)})}async executeTask(F,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const B=P.from(j,F);if(B===void 0)throw new Error("Task is not valid");if(y.is(B.execution))await this.y(B,j,!1);else throw new o.$ab;const M=await this.z(await this.a.$getTaskExecution(B),j);return this.a.$executeTask(B).catch(z=>{throw new Error(z)}),M}v(F,j,B,M){const z=[];if(M)for(const _ of M){if(this.A(_,B),!_.definition||!F[_.definition.type]){const U=_.source?_.source:"No task source";this.f.warn(`The task [${U}, ${_.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=P.from(_,B.extension);re&&y.is(re.execution)?(z.push(re),j.push(this.y(re,_,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async w(F){if(y.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,j,B){}};e.$8oc=O,e.$8oc=O=Qe([qe(0,u.$uP),qe(1,k.$KP),qe(2,T.$wnc),qe(3,$.$FP),qe(4,l.$znc),qe(5,E.$Xnc),qe(6,f.$$j),qe(7,m.$anc)],O),e.$9oc=(0,b.$Ei)("IExtHostTask")}),define(Ee[384],Se([1,0,38,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=A,e.$OL=R;function A(N){return"cellResults"in N}e.$NL="rawCell#";function R(N,T){let $=-1;const l=[];let I=[];return N.forEach(u=>{u.range.startLineNumber!==$&&I.length>0&&(l.push([...I]),I=[]),I.push(u),$=u.range.endLineNumber}),I.length>0&&l.push([...I]),l.map(u=>{const k=[],b=u[0].range.startLineNumber,c=u[u.length-1].range.endLineNumber;for(let g=b;g<=c;g++)k.push(T.getLineContent(g));return new r.$qL(k.join(`
`)+`
`,u.map(g=>new h.$Ht(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(Ee[385],Se([1,0,238,22,4,3,29,41,13,18,2,28,119,6,35,17,10,51,357,164,25,15,38,313,384,381]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0,E=We(E),c=We(c),g=We(g);class w{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,D,P,C,p,v,O){this.q=P,this.r=C,this.s=p,this.t=v,this.u=O,this.f=new Map,this.g=new N.$Bc,this.h=new Map,this.j=new A.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$$mc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(k.$1M.MainThreadNotebook),this.c=S.getProxy(k.$1M.MainThreadNotebookDocuments),this.d=S.getProxy(k.$1M.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===T.MarshalledId.NotebookCellActionContext){const F=L.notebookEditor?.notebookUri,j=L.cell.handle,M=this.g.get(F)?.getCell(j);if(M)return M.apiCell}if(L&&L.$mid===T.MarshalledId.NotebookActionContext){const F=L.uri,j=this.g.get(F);if(j)return j.apiNotebook}return L}}),w.C(D)}getEditorById(S){const D=this.h.get(S);if(!D)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(S){for(const[D,P]of this.h)if(P.apiEditor===S)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,D){const P=this.g.get(S);if(!P&&!D)throw new Error(`NO notebook document for '${S}'`);return P}static w(S,D){if(!D)return;const P=D.filenamePattern.map(C=>c.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(D.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:D.displayName,filenamePattern:P,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,D,P){const C=w.a++,p=typeof P.onDidChangeCellStatusBarItems=="function"?w.a++:void 0;this.f.set(C,P),this.b.$registerNotebookCellStatusBarItemProvider(C,p,D);let v;return p!==void 0&&(v=P.onDidChangeCellStatusBarItems(O=>this.b.$emitCellStatusBarEvent(p))),new g.$3M(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,p),v?.dispose()})}async createNotebookDocument(S){const D=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&c.NotebookData.from(S.content)});return I.URI.revive(D)}async openNotebookDocument(S){const D=this.g.get(S);if(D)return D.apiNotebook;const P=await this.c.$tryOpenNotebook(S),C=this.g.get(I.URI.revive(P));return(0,l.$pg)(C?.apiNotebook)}async showNotebookDocument(S,D){I.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let P;typeof D=="object"?P={position:c.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(c.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:P={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,P),p=C&&this.h.get(C)?.apiEditor;if(p)return p;throw C?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,D,P,C){const p=this.f.get(S),v=I.URI.revive(D),O=this.g.get(v);if(!O||!p)return;const L=O.getCellFromIndex(P);if(!L)return;const F=await p.provideCellStatusBarItems(L.apiCell,C);if(!F)return;const j=new R.$Uc,B=this.p.add([j]),z=(Array.isArray(F)?F:[F]).map(_=>c.NotebookStatusBarItem.from(_,this.i,j));return{cacheId:B,items:z}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,D,P,C,p){if((0,$.$cf)(D))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:D,serializer:P,options:C}),this.b.$registerNotebookSerializer(v,{id:S.identifier,location:S.extensionLocation},D,c.NotebookDocumentContentOptions.from(C),w.w(S,p)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(S,D,P){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const p=await C.serializer.deserializeNotebook(D.buffer,P);return new f.$Pw(c.NotebookData.from(p))}async $notebookToData(S,D,P){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const p=await C.serializer.serializeNotebook(c.NotebookData.to(D.value),P);return h.$Ne.wrap(p)}async $saveNotebook(S,D,P,C,p){const v=I.URI.revive(D),O=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${P}, ${v.toString()})`),!O)throw new Error("NO serializer found");const L=this.g.get(v);if(!L)throw new Error("Document NOT found");if(L.versionId!==P)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new E.$tl((0,r.localize)(0,null,this.A(v)),E.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,o.$jo)(L.apiNotebook.metadata,_=>!(O.options?.transientDocumentMetadata??{})[_]),cells:[]};for(const _ of L.apiNotebook.getCells()){const re=new g.$tO(_.kind,_.document.getText(),_.document.languageId,_.mime,O.options?.transientOutputs?[]:[..._.outputs],_.metadata,_.executionSummary);re.metadata=(0,o.$jo)(_.metadata,U=>!(O.options?.transientCellMetadata??{})[U]),F.cells.push(re)}if(await this.z(v,C),p.isCancellationRequested)throw new Error("canceled");const j=await O.serializer.serializeNotebook(F,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${P} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${P} ${v.toString()}`);const B=this.s.getFileSystemProviderExtUri(v.scheme),M=await this.s.value.stat(v),z={name:B.basename(v),isFile:(M.type&E.FileType.File)!==0,isDirectory:(M.type&E.FileType.Directory)!==0,isSymbolicLink:(M.type&E.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((M.permissions??0)&E.FilePermission.Locked),etag:E.$El({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${P}, ${v.toString()})`),z}async $searchInNotebooks(S,D,P,C,p){const v=this.y.get(S)?.serializer;if(!v)return{limitHit:!1,results:[]};const O=new N.$Cc;await(async(M,z,_)=>{await Promise.all(M.map(async re=>await Promise.all(re.filenamePatterns.map(U=>{const G={_reason:_._reason,folderQueries:_.folderQueries,includePattern:_.includePattern,excludePattern:_.excludePattern,maxResults:_.maxResults,type:t.QueryType.File,filePattern:U};return this.t.doInternalFileSearchWithCustomCallback(G,z,K=>{K.forEach(ee=>{O.has(ee)||C.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,a.$8hb)(De,ee)))||O.add(ee)})}).catch(K=>{if(K.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw K})}))))})(P,p,D);const F=new N.$Bc;let j=!1;const B=Array.from(O).map(async M=>{const z=[];try{if(p.isCancellationRequested)return;if(D.maxResults&&[...F.values()].reduce((G,K)=>G+K.cellResults.length,0)>D.maxResults){j=!0;return}const _=[],re=this.g.get(M);if(re)re.apiNotebook.getCells().forEach(K=>_.push({input:K.document.getText(),outputs:K.outputs.flatMap(ee=>ee.items.map(ue=>ue.data.toString()))}));else{const G=await this.s.value.readFile(M),K=h.$Ne.fromString(G.toString()),ee=await v.deserializeNotebook(K.buffer,p);if(p.isCancellationRequested)return;c.NotebookData.from(ee).cells.forEach(ne=>_.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map($e=>$e.valueBytes.toString()))}))}if(p.isCancellationRequested)return;_.forEach((G,K)=>{const ee=D.contentPattern.pattern,ue=new s.$wYb(G.input,void 0,G.outputs),ne=ue.findInInputs(ee),De=ue.findInOutputs(ee),$e=De.flatMap(J=>(0,d.$OL)(J.matches,J.textBuffer)).map((J,W)=>(J.webviewIndex=W,J));if(ne.length>0||De.length>0){const J={index:K,contentResults:(0,d.$OL)(ne,ue.inputTextBuffer),webviewResults:$e};z.push(J)}});const U={resource:M,cellResults:z};F.set(M,U);return}catch{return}});return await Promise.all(B),{limitHit:j,results:[...F.values()]}}async z(S,D){const P=await this.s.value.stat(S);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==E.$Dl&&typeof P.mtime=="number"&&typeof P.size=="number"&&D.mtime<P.mtime&&D.etag!==E.$El({mtime:D.mtime,size:P.size}))throw new E.$tl((0,r.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,D)}A(S){return S.scheme===i.Schemas.file?S.fsPath:S.toString()}B(S,D,P){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const C=new n.$Aoc(D,this.d,S,P.visibleRanges.map(c.NotebookRange.to),P.selections.map(c.NotebookRange.to),typeof P.viewColumn=="number"?c.ViewColumn.to(P.viewColumn):void 0);this.h.set(D,C)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const P of S.value.removedDocuments){const C=I.URI.revive(P),p=this.g.get(C);p&&(p.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===C.toString()&&this.h.delete(v.id)}if(S.value.addedDocuments){const P=[];for(const C of S.value.addedDocuments){const p=I.URI.revive(C.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new m.$zoc(this.c,this.q,this.r,p,C);P.push(...C.cells.map(O=>m.$yoc.asModelAddData(O))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this.m.fire(v.apiNotebook)}}if(S.value.addedEditors)for(const P of S.value.addedEditors){if(this.h.has(P.id))return;const C=I.URI.revive(P.documentUri),p=this.g.get(C);p&&this.B(p,P.id,P)}const D=[];if(S.value.removedEditors)for(const P of S.value.removedEditors){const C=this.h.get(P);C&&(this.h.delete(P),this.k?.id===C.id&&(this.k=void 0),D.push(C))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const P=new Set;this.l.forEach(C=>P.add(C.id));for(const C of this.h.values()){const p=P.has(C.id);C._acceptVisibility(p)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const D=b.$SP.String.with("notebookType","A notebook type"),P=new b.$UP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new b.$SP("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Ne.wrap(p))],new b.$TP("Notebook Data",p=>c.NotebookData.to(p.value))),C=new b.$UP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new b.$SP("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new f.$Pw(c.NotebookData.from(p)))],new b.$TP("Bytes",p=>p.buffer));S.registerApiCommand(P),S.registerApiCommand(C)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$Joc=w}),define(Ee[386],Se([1,0,16,21,55,39,23,43,38]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0,r=We(r),R=We(R),N=We(N);class l{constructor(u,k,b){this.k=u,this.l=k,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$yk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$yk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const k=this.k.folderQueries||[];return new Promise((b,c)=>{const g=f=>{this.f++,u(f)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const m=f.toString(),n=r.$oc(m);this.j&&this.j(m,n)||this.v(g,{base:f,basename:n})}),Promise.all(k.map(f=>this.p(f,g))).then(f=>{b({limitHit:this.e,stats:f[0]||void 0})},f=>{c(new Error((0,A.$pj)(f)))})})}async p(u,k){const b=new h.$we,c=this.q(u),g=this.r(),f=new $.$EL(this.k,u),m=!f.hasSiblingExcludeClauses();let n;try{this.h.add(b),n=T.$fe.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,b.token),i=n.elapsed(),t=T.$fe.create();return this.g&&!this.e||(o&&o.forEach(s=>{const d=r.$hc.relative(u.folder.path,s.path);if(m){const a=r.$oc(s.path);this.v(k,{base:u.folder,relativePath:d,basename:a});return}this.s(g,u.folder,d,k)}),this.g&&!this.e)?null:(this.u(g,f,k),{providerTime:i,postProcessTime:t.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(u){const k=(0,$.$DL)(this.k.includePattern,u.includePattern),b=(0,$.$DL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:b,includes:k,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},k,b,c){if(b===this.a){const f=r.$oc(this.a);this.v(c,{base:k,relativePath:this.a,basename:f})}function g(f){const m=r.$oc(f),n=r.$nc(f);let o=u[n];o||(o=u[n]=[],g(n)),o.push({base:k,relativePath:f,basename:m})}g(b)}u({rootEntries:u,pathToEntries:k},b,c){const g=this,f=this.a;function m(n){const o=(0,$.$GL)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const s=n[i],{relativePath:d,basename:a}=s;if(b.matchesExcludesSync(d,a,f!==a?o:void 0))continue;const w=k[d];if(w)m(w);else{if(d===f)continue;g.v(c,s)}if(g.e)break}}m(u)}v(u,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(k))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,k,b,c){const g=this.c(u.cacheKey),f=new l(u,k,g&&g.token);let m=0;const n=o=>{m+=o.length,b(o.map(i=>this.d(i)))};return this.e(f,I.a,n,c).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:o.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$we),this.b.get(u)}d(u){return u.relativePath?{resource:N.$fh(u.base,u.relativePath)}:{resource:u.base}}e(u,k,b,c){const g=c.onCancellationRequested(()=>{u.cancel()}),f=n=>{n&&(m.push(n),k>0&&m.length>=k&&(b(m),m=[]))};let m=[];return u.search(f).then(n=>(m.length&&b(m),g.dispose(),n),n=>(m.length&&b(m),g.dispose(),Promise.reject(n)))}}e.$Boc=I}),define(Ee[387],Se([1,0,19,79,39,110,29,15,16,23,13,18,2,107,261,45,12,46,156,382,38]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=void 0,e.$FM=D,r=We(r),h=We(h),A=We(A),$=We($),I=We(I),b=We(b);let i=class{constructor(C,p,v,O,L){this.a=C,this.b=p,this.c=v,this.d=O,this.e=L}text(C,p,v={}){C=this.f(C,v);const O=this.a.getValue(),L=p&&p.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(p?.map(f.$Zi),v),type:o.QueryType.Text,contentPattern:C,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:O.search.usePCRE2||L||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(C,p){const v=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const O={...C,wordSeparators:v.editor.wordSeparators};return this.j(C,p)&&(O.isCaseSensitive=!0),this.k(C)&&(O.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),O}file(C,p={}){return{...this.h(C,p),type:o.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(C,p){return C?(C=Array.isArray(C)?C.map(w):w(C),p?this.parseSearchPaths(C):{pattern:s(...Array.isArray(C)?C:[C])}):{}}h(C=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),O=this.g(p.excludePattern,p.expandPatterns),L=C.length>1,F=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.q(M,p,O)):C.map(M=>this.r(M,p,O,L))).filter(M=>!!M),j={_reason:p._reason,folderQueries:F,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:O.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const M=r.$Ib(this.c.groups.flatMap(re=>re.editors.map(U=>U.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const z=M.filter(re=>(0,o.$uL)(j,re.fsPath)),_=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(_)),{...j,..._}}const B=p.extraFileResources&&p.extraFileResources.filter(M=>(0,o.$uL)(j,M.fsPath));return j.extraFileResources=B&&B.length?B:void 0,j}i(C){const p=[],v=new N.$Bc,O={};let L=!1;return C.forEach(F=>{if(F.scheme===T.Schemas.walkThrough)return;if((0,l.$jh)(F)){const B=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$nc(F.fsPath)});let M=v.get(B);M||(L=!0,M={folder:B,includePattern:{}},p.push(M),v.set(B,M));const z=$.$mc(B.fsPath,F.fsPath);(0,E.$pg)(M.includePattern)[z.replace(/\\/g,"/")]=!0}else F.fsPath&&(L=!0,O[F.fsPath]=!0)}),{folderQueries:p,includePattern:O,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}j(C,p){if(p.isSmartCase){if(C.isRegExp){if(I.$8f(C.pattern,!0))return!0}else if(I.$8f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,k.$0C)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const p=_=>$.$jc(_)||/^\.\.?([\/\\]|$)/.test(_),O=(Array.isArray(C)?C:d(C)).map(_=>{const re=this.e.resolvedUserHome;return re?(0,R.$Uw)(_,re.scheme===T.Schemas.file?re.fsPath:re.path):_}),L=h.$K(O,_=>p(_)?"searchPaths":"exprSegments"),F=(L.exprSegments||[]).map(_=>I.$nf(_,"/")).map(_=>I.$nf(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),a(_))),j={},B=this.m(L.searchPaths||[]);B&&B.length&&(j.searchPaths=B);const M=F.flat(),z=s(...M);return z&&(j.pattern=z),j}l(C,p){return p.disregardExcludeSettings?void 0:(0,o.$tL)(C,!p.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const p=C.flatMap(O=>{let{pathPortion:L,globPortion:F}=t(O);return F&&(F=y(F)),this.n(L).flatMap(B=>this.o(B,F))}),v=new Map;return p.forEach(O=>{const L=O.searchPath.toString(),F=v.get(L);F?O.pattern&&(F.pattern=F.pattern||{},F.pattern[O.pattern]=!0):v.set(L,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(v.values())}n(C){if($.$jc(C)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==T.Schemas.file?[{searchPath:p[0].uri.with({path:C})}]:[{searchPath:u.URI.file($.$ic(C))}]}if(this.b.getWorkbenchState()===f.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(C=w(C),C.startsWith("../")||C===".."){const O=$.$hc.resolve(p.path,C);return[{searchPath:p.with({path:O})}]}const v=y(C);return[{searchPath:p,pattern:v}]}else{if(C==="./"||C===".\\")return[];{const p=C.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(L=>{const F=p.match(new RegExp(`^${I.$hf(L.name)}(?:/(.*)|$)`));return F?{match:F,folder:L}:null}).filter(E.$mg);if(O.length)return O.map(L=>{const F=L.match[1];return{searchPath:L.folder.uri,pattern:F&&y(F)}});{const L=C.match(/\.[\/\\](.+)[\/\\]?/),F=L?L[1]:C,j=b.localize(0,null,F);throw new Error(j)}}}}o(C,p){const v=C.pattern&&p?`${C.pattern}/${p}`:C.pattern||p,O=[{searchPath:C.searchPath,pattern:v}];return v&&!v.endsWith("**")&&O.push({searchPath:C.searchPath,pattern:v+"/**"}),O}q(C,p,v){const O=this.r((0,f.$Zi)(C.searchPath),p,v,!1);return O?{...O,includePattern:C.pattern}:null}r(C,p,v,O){let L;const F=u.URI.isUri(C)?C:C.uri;if(v.searchPaths){const _=v.searchPaths.filter(re=>(0,l.$$g)(re.searchPath,F))[0];if(_&&!_.pattern)return null;_&&(L=_.pattern)}const j=this.a.getValue({resource:F}),M={...this.l(j,p)||{},...L||{}},z=u.URI.isUri(C)?(0,l.$ch)(C):C.name;return{folder:F,folderName:O?z:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!j.search.followSymlinks}}};e.$EM=i,e.$EM=i=Qe([qe(0,c.$$i),qe(1,f.$Ni),qe(2,m.$fE),qe(3,g.$$j),qe(4,n.$CM)],i);function t(P){const C=P.match(/[\*\{\}\(\)\[\]\?]/);if(C){const p=C.index,v=P.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let O=P.substr(0,v.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:P.substr((v.index||0)+1)}}}return{pathPortion:P}}function s(...P){return P.length?P.reduce((C,p)=>(C[p]=!0,C),Object.create(null)):void 0}function d(P){return A.$wk(P,",").map(C=>C.trim()).filter(C=>!!C.length)}function a(P){return[`**/${P}/**`,`**/${P}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function w(P){return P.replace(/\\/g,"/")}function y(P){return w(P).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(P){return P.replace(/([?*[\]])/g,"[$1]")}function D(P,C){P=r.$Nb(P,O=>O.toString());const p=[],v=C.getWorkspace();return P&&P.forEach(O=>{let L;if(C.getWorkbenchState()===f.WorkbenchState.FOLDER)L=(0,l.$hh)(v.folders[0].uri,O),L&&L!=="."&&(L="./"+L);else{const F=C.getWorkspaceFolder(O);if(F){const j=F.name;if(v.folders.filter(M=>M.name===j).length===1){const M=(0,l.$hh)(F.uri,O);M===""?L=`./${F.name}`:L=`./${F.name}/${M}`}else L=O.fsPath}}L&&p.push(S(L))}),p}}),define(Ee[388],Se([1,0,23,2,21,14,5,387,38,46,9]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oxb=u,e.$pxb=c,r=We(r),R=We(R);const E=7e3;function u(g,f){const m=f.activationEvents;if(!m)return Promise.resolve(void 0);const n=[],o=[];for(const w of m)if(/^workspaceContains:/.test(w)){const y=w.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||g.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,I.$xh)(),s=w=>t({activationEvent:w}),d=Promise.all(n.map(w=>k(g,w,s))).then(()=>{}),a=b(g,f.identifier,o,s);return Promise.all([d,a]).then(()=>{t(void 0)}),i}async function k(g,f,m){for(const n of g.folders)if(await g.exists(r.$fh(h.URI.revive(n),f))){m(`workspaceContains:${f}`);return}}async function b(g,f,m,n){if(m.length===0)return Promise.resolve(void 0);const o=new A.$we,i=g.checkExists(g.folders,m,o.token),t=setTimeout(async()=>{o.cancel(),g.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},E);let s=!1;try{s=await i}catch(d){R.$5(d)||R.$2(d)}o.dispose(),clearTimeout(t),s&&n(`workspaceContains:${m.join(",")}`)}function c(g,f,m,n){const o=g.get(N.$Di),i=g.get($.$lL),s=o.createInstance(T.$EM).file(f.map(d=>(0,l.$Zi)(h.URI.revive(d))),{_reason:"checkExists",includePattern:m,exists:!0});return i.fileSearch(s,n).then(d=>!!d.limitHit,d=>R.$5(d)?!1:Promise.reject(d))}}),define(Ee[52],Se([1,0,234,16,62,23,9,3,85,2,12,6,42,320,126,48,26,158,14,24,22,298,10,72,5,30,98,20,115,77,47,129,4,388,125,300,15,123,43,11,124]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a,w,y,S,D,P,C,p,v,O,L,F,j,B,M,z){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=e.$boc=e.$aoc=e.$_nc=e.$$nc=void 0,r=We(r),h=We(h),A=We(A),m=We(m),e.$$nc=(0,d.$Ei)("IHostUtils");let re=_=class extends T.$Vc{constructor(J,W,se,oe,te,le,he,Z,ae,pe,be,Me,ze){super(),this.Y=Me,this.Z=ze,this.a=this.B(new p.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=se,this.f=he,this.j=oe,this.m=te,this.s=le,this.t=ae,this.u=pe,this.w=be,this.y=this.g.getProxy(E.$1M.MainThreadWorkspace),this.z=this.g.getProxy(E.$1M.MainThreadTelemetry),this.C=this.g.getProxy(E.$1M.MainThreadExtensionService),this.D=new N.$Dh,this.F=new N.$Dh,this.G=new N.$Dh,this.H=new N.$Dh,this.I=new De(this.f.extensions.activationEvents),this.L=new f.$Ebc(this.I,this.f.extensions.allExtensions);const ke=new n.$qn(this.f.extensions.myExtensions);this.J=new f.$Ebc(this.I,ue(this.L,ke)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${K(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${K(this.J)}`)),this.M=new b.$Tnc(this.g,this.s),this.N=new O.$4nc(this.g),this.O=Z,this.h=J.createChild(new S.$Ci([b.$Unc,this.M],[O.$5nc,this.N])),this.P=this.B(new k.$Snc(this.J,this.L,{onExtensionActivationError:(Ie,Te,V)=>{this.C.$onExtensionActivationError(Ie,m.$4(Te),V)},actualActivateExtension:async(Ie,Te)=>{if(f.$Ebc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Te),new k.$Rnc;const V=this.J.getExtensionDescription(Ie);return this.fb(V,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(J){m.$2(J)}}async $(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(J)}terminate(J,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),m.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,N.$Fh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const W=await this.C.$getExtension(J);return W&&{...W,identifier:new n.$pn(W.identifier.value),extensionLocation:l.URI.revive(W.extensionLocation)}}ab(J,W){return this.P.activateByEvent(J,W)}bb(J,W){return this.P.activateById(J,W)}activateByIdWithErrors(J,W){return this.bb(J,W).then(()=>{const se=this.P.getActivatedExtension(J);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async cb(J){if(J.scheme===F.Schemas.file&&this.c.fsRealpath){const W=J.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const se=await this.R.get(W);return l.URI.file(se)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(J=>new ne(J))),this.Q}async db(J){const W=$.$Ki.forUris(se=>R.$9g.ignorePathCasing(se));return await Promise.all(J.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);W.set(oe,se)}})),W}eb(J){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return W;const se=this.P.getActivatedExtension(J);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(oe)}try{(0,T.$Qc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(oe)}return W}async fb(J,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.hb(J,W).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension(J.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,W),this.gb(J,W,"success",oe),se},se=>{throw this.gb(J,W,"failure"),se})}gb(J,W,se,oe){const te=G(J,W);this.z.$publicLog2("extensionActivationTimes",{...te,...oe||{},outcome:se})}hb(J,W){const se=G(J,W);this.z.$publicLog2("activatePlugin",se);const oe=this.wb(J);if(!oe)return Promise.resolve(new k.$Qnc(k.$Nnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${J.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const te=new k.$Onc(W.startup);return Promise.all([this.xb(J,(0,R.$fh)(J.extensionLocation,oe),te),this.ib(J)]).then(le=>(A.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),_.jb(this.s,J.identifier,le[0],le[1],te))).then(le=>(A.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),le))}ib(J){const W=this.Z.createLanguageModelAccessInformation(J),se=new i.$Wnc(J,this.M),oe=new i.$Vnc(J.identifier.value,!1,this.M),te=new L.$6nc(J,this.N),le=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const Z=this;let ae,pe;const be=(0,g.$3G)(J,"ipc")?this.f.messagePorts?.get(n.$pn.toKey(J.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:te,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(Me){return h.$kc(J.extensionLocation.fsPath,Me)},get storagePath(){return Z.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return Z.O.globalValue(J).fsPath},get logPath(){return h.$kc(Z.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return l.URI.joinPath(Z.f.logsLocation,J.identifier.value)},get storageUri(){return Z.O.workspaceValue(J)},get globalStorageUri(){return Z.O.globalValue(J)},get extensionMode(){return le},get extension(){return ae===void 0&&(ae=new ee(Z,J.identifier,J,he,!1)),ae},get extensionRuntime(){return(0,g.$4G)(J,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!pe){if(!be)return;const Me=p.Event.buffer(p.Event.fromDOMEventEmitter(be,"message",ze=>ze.data));be.start(),pe={onDidReceiveMessage:Me,postMessage:be.postMessage.bind(be)}}return pe}})})}static jb(J,W,se,oe,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(J,W,se,oe,te).then(le=>new k.$Pnc(!1,null,te.build(),se,le,oe.subscriptions))}static kb(J,W,se,oe,te){if(typeof se.activate=="function")try{te.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${W.value}`);const le=typeof global=="object"?global:self,he=se.activate.apply(le,[oe]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(he).then(Z=>(te.activateResolveStop(),Z))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(J,W){this.bb(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:W}).then(void 0,se=>{this.s.error(se)})}mb(J,W=0){const oe=Date.now();(0,M.$B)(()=>{for(let te=W;te<J.length;te+=1){const le=J[te];for(const he of le.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-oe>50){this.mb(J,te);break}else this.lb(le,he)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(J=>{const W=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(W)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const te of oe.activationEvents)te==="onStartupFinished"&&this.lb(oe,te)})}ob(){const J=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const W=this.j.workspace?this.j.workspace.folders:[],se=this.pb(W),oe=this.rb(),te=Promise.all([oe,J,se]).then(()=>{});return Promise.race([te,(0,N.$Fh)(1e4)]).then(()=>{this.nb()}),te}pb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(J,W))).then(()=>{})}async qb(J,W){if(this.isActivated(W.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:J.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,he,Z)=>this.y.$checkExists(le,he,Z)},te=await(0,v.$oxb)(oe,W);if(te)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(J){throw console.error(J),J}}async sb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:W}=this.f.environment;if(!J||!W)throw new Error(r.localize(0,null));const se=await this.xb(null,W,new k.$Onc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,W.toString()));return new Promise((oe,te)=>{const le=(ae,pe)=>{ae?(M.$t&&this.s.error("Test runner called back with error",ae),te(ae)):(M.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof pe=="number"&&pe>0?1:0))},he=(0,R.$6g)(W),Z=se.run(he,le);Z&&Z.then&&Z.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),oe(0)}).catch(ae=>{M.$t&&this.s.error("Test runner finished with error",ae),te(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,N.$Fh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,W){return this.S[J]=W,(0,T.$Tc)(()=>{delete this.S[J]})}async getRemoteExecServer(J){const{resolver:W}=await this.ub(J);return W?.resolveExecServer?.(J,{resolveAttempt:0})}async ub(J){const W=J.indexOf("+");if(W===-1)throw new t.$9M("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=J.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(J,W){const se=B.$fe.create(!1),oe=()=>`[resolveAuthority(${(0,s.$Tl)(J)},${W})][${se.elapsed()}ms] `,te=q=>this.s.info(`${oe()}${q}`),le=q=>this.s.warn(`${oe()}${q}`),he=(q,Q=void 0)=>this.s.error(`${oe()}${q}`,Q),Z=q=>{if(q instanceof t.$9M)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},ae=async q=>{te(`activating resolver for ${q}...`);const{resolver:Q,authorityPrefix:x}=await this.ub(q);if(!Q)throw he(`no resolver for ${x}`),new t.$9M(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:x,remoteAuthority:q}},pe=J.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let be;try{be=await Promise.all(pe.map(ae)).catch(async q=>{if(!(q instanceof t.$9M)||q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return le(`resolving nested authorities failed: ${q.message}`),[await ae(J)]})}catch(q){return Z(q)}const Me=new N.$Ph;Me.cancelAndSet(()=>te("waiting..."),1e3);let ze,ke;for(const[q,{authorityPrefix:Q,resolver:x,remoteAuthority:fe}]of be.entries())try{if(q===be.length-1)te("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${Q}`),ze=await x.resolve(fe,{resolveAttempt:W,execServer:ke}),A.mark(`code/extHost/didResolveAuthorityOK/${Q}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,t.$8M.isManagedResolvedAuthority(ze)?ze:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),A.mark(`code/extHost/willResolveExecServer/${Q}`),ke=await x.resolveExecServer?.(fe,{resolveAttempt:W,execServer:ke}),!ke)throw new t.$9M(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(we){return A.mark(`code/extHost/didResolveAuthorityError/${Q}`),he("returned an error",we),Me.dispose(),Z(we)}Me.dispose();const Ie={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${t.$8M.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let V;if(t.$8M.isManagedResolvedAuthority(ze)){const q=W;this.Y.setFactory(q,ze.makeConnection),V={authority:J,connectTo:new s.$Ql(q),connectionToken:ze.connectionToken}}else V={authority:J,connectTo:new s.$Rl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:V,options:Te,tunnelInformation:Ie}}}async $getCanonicalURI(J,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Tl)(J)})`);const{resolver:se}=await this.ub(J);if(!se)return null;const oe=l.URI.revive(W);if(typeof se.getCanonicalURI>"u")return oe;const te=await(0,N.$wh)(()=>se.getCanonicalURI(oe));return te||oe}async $startExtensionHost(J){J.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,J),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${K(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${K(this.J)}`)),this.tb()}$activateByEvent(J,W){return W===g.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(J,!1)):this.G.wait().then(se=>this.ab(J,!1))}async $activate(J,W){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.bb(J,W),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,J),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${K(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${K(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const W=o.$Ne.alloc(J),se=Math.random()%256;for(let oe=0;oe<J;oe++)W.writeUInt8(se,oe);return W}async $updateRemoteConnectionData(J){this.X=J,this.a.fire()}};e.$_nc=re,e.$_nc=re=_=Qe([qe(0,d.$Di),qe(1,e.$$nc),qe(2,y.$uP),qe(3,c.$wnc),qe(4,u.$znc),qe(5,I.$$j),qe(6,a.$KP),qe(7,w.$Cnc),qe(8,D.$4Eb),qe(9,P.$Xnc),qe(10,j.$8nc),qe(11,z.$9nc),qe(12,C.$2nc)],re);function U($e,J,W,se){$e.addActivationEvents(se.addActivationEvents);const oe=new f.$Ebc($e,J.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const te=new n.$qn(W.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of se.myToRemove)te.delete(he);for(const he of se.myToAdd)te.add(he);const le=ue(oe,te);return{globalRegistry:oe,myExtensions:le}}function G($e,J){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function K($e){return $e.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$aoc=(0,d.$Ei)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(J,W,se,oe,te){this.#e=J,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$ic((0,R.$6g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$boc=ee;function ue($e,J){return $e.getAllExtensionDescriptions().filter(W=>J.has(W.identifier))}class ne{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$coc=ne;class De{constructor(J){this.a=new n.$rn,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const W of Object.keys(J))this.a.set(W,J[W])}}}),define(Ee[389],Se([1,0,62,2,6,42,26,24,20,30,5,52,12,13]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0,r=We(r);let c=class{constructor(o,i,t,s,d,a,w){this.c=o,this.d=i,this.e=t,this.f=s,this.g=d,this.h=a,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new f(this.c,i,this.d,o,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,i,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const i of o.nodeModuleName)this.a.set(i,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(i=>o.alternativeModuleName(i))}};e.$mpc=c,e.$mpc=c=Qe([qe(2,I.$Di),qe(3,R.$znc),qe(4,E.$aoc),qe(5,l.$KP),qe(6,u.$$j)],c);let g=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&b.a.size){const i=(0,k.$hf)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const i=this.b.exec(this.c(o));if(!i)return;const[,t,s,d]=i,a=b.a.get(s);if(a!==void 0)return console.warn(`${s} as been renamed to ${a}, please update your imports`),t+a+d}c(o){return o.replace(/\\/g,"/")}};g=b=Qe([qe(0,l.$KP)],g);class f{constructor(o,i,t,s,d){this.c=o,this.d=i,this.e=t,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new T.$rn}load(o,i){const t=this.d.findSubstr(i);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,a)=>s+=`	${a} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(N.$XG,this.e,this.f)}return this.b}}let m=class{constructor(o,i,t){this.e=o,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$1M.MainThreadTelemetry);const s=t.getProxy(A.$1M.MainThreadWindow);this.c=(d,a)=>{const w=h.URI.parse(d);return a?this.g(d,a):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,d,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,d,{}):this.g(d,a)}}load(o,i,t){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=t(o),this.c}g(o,i){return this.i(),this.b(o,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Qe([qe(2,$.$uP)],m)}),define(Ee[65],Se([1,0,49,3,16,56,5,64,78,52,10,48,317,42]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=e.$doc=void 0,A=We(A),R=We(R),e.$doc=(0,N.$Ei)("IExtHostVariableResolverProvider");class b extends u.$yQ{constructor(f,m,n,o,i,t,s){function d(){if(n){const a=n.activeEditor();if(a)return a.document.uri;const w=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof I.$OO||w.input instanceof I.$TO)return w.input.modified;if(w.input instanceof I.$NO||w.input instanceof I.$SO||w.input instanceof I.$QO)return w.input.uri}}}super({getFolderUri:a=>{const w=t.folders.filter(y=>y.name===a);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,w)=>i.getConfiguration(void 0,a).get(w),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=d();if(a)return A.$ic(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const a=d();if(a){const w=m.getWorkspaceFolder(a);if(w)return A.$ic(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const a=n.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(n){const a=n.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>f.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let c=class extends h.$Vc{constructor(f,m,n,o,i){super(),this.b=f,this.c=m,this.g=n,this.h=o,this.j=i,this.a=new r.$W(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$eoc=c,e.$eoc=c=Qe([qe(0,l.$aoc),qe(1,E.$wnc),qe(2,T.$FP),qe(3,k.$znc),qe(4,$.$Lnc)],c)}),define(Ee[102],Se([1,0,9,4,2,3,24,5,6,78,52,20,10,48,153,120,308,42,65,50,35,17,19,99]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=e.$moc=e.$loc=e.$koc=void 0,i=We(i),e.$koc=(0,T.$Ei)("IExtHostDebugService");let d=class extends R.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,p,v,O,L,F,j,B){super(),this.Y=p,this.Z=v,this.$=O,this.ab=L,this.bb=F,this.cb=j,this.db=B,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$le),this.z=this.B(new h.$le),this.C=this.B(new h.$le),this.F=this.B(new h.$le),this.u=C.getProxy($.$1M.MainThreadDebugService),this.I=this.B(new h.$le),this.L=this.B(new h.$le),this.G=new w(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(z=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(C,p){const v=this.gb(p);if(!v)return;const O=await this.Q.get(C)?.getTreeItem?.(v);return O?this.eb(C,O):void 0}registerDebugVisualizationTree(C,p,v){const O=N.$pn.toKey(C.identifier),L=this.ub(O,p);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(L,v),this.u.$registerDebugVisualizerTree(L,!!v.editItem),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(L),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(C,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(C)?.getChildren?.(v))?.map(L=>this.eb(C,L))||[]:[]}async $editVisualizerTreeItem(C,p){const v=this.S.get(C);if(!v)return;const O=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,O||v.item)}$disposeVisualizedTree(C){const p=this.S.get(C);if(!p)return;const v=[p.children];for(const O of v)if(O)for(const L of O)v.push(this.S.get(L)?.children),this.S.delete(L)}eb(C,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:C,item:p})),i.DebugTreeItem.from(p,v)}asDebugSourceUri(C,p){const v=C;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let O=`debug:${encodeURIComponent(v.path||"")}`,L="?";return p&&(O+=`${L}session=${encodeURIComponent(p.id)}`,L="&"),O+=`${L}ref=${v.sourceReference}`,A.URI.parse(O)}else{if(v.path)return A.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const p=[];for(const v of C.getAllExtensionDescriptions())if(v.contributes){const O=v.contributes.debuggers;if(O&&O.length>0)for(const L of O)(0,g.$TH)(L)&&p.push(L.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(p=>C.push(p)),C}async $resolveDebugVisualizer(C,p){const v=this.W.get(C);if(!v)throw new Error(`No debug visualizer found with id '${C}'`);let{v:O,provider:L,extensionId:F}=v;if(O.visualization||(O=await L.resolveDebugVisualization?.(O,p)||O,v.v=O),!O.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.vb(F,O.visualization)}async $executeDebugVisualizerCommand(C){const p=this.W.get(C);if(!p)throw new Error(`No debug visualizer found with id '${C}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(C){const p=this.w.get(C.sessionId);return p&&{session:p.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,p,v,O){const L=this.gb(v),F=this.ub(C,p),j=this.P.get(F);if(!L||!j)return[];const B=await j.provideDebugVisualization(L,O);return B?B.map(M=>{const z=++this.X;this.W.set(z,{v:M,provider:j,extensionId:C});const _=M.iconPath?this.wb(M.iconPath):void 0;return{id:z,name:M.name,iconClass:_?.iconClass,iconPath:_?.iconPath,visualization:this.vb(C,M.visualization)}}):[]}$disposeDebugVisualizers(C){for(const p of C)this.W.delete(p)}registerDebugVisualizationProvider(C,p,v){if(!C.contributes?.debugVisualizers?.some(F=>F.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const O=N.$pn.toKey(C.identifier),L=this.ub(O,p);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(L,v),this.u.$registerDebugVisualizer(O,p),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizer(O,p),this.P.delete(p)})}addBreakpoints(C){const p=C.filter(L=>{const F=L.id;return this.H.has(F)?!1:(this.H.set(F,L),!0)});this.rb(p,[],[]);const v=[],O=new Map;for(const L of p)if(L instanceof u.$5N){let F=O.get(L.location.uri.toString());F||(F={type:"sourceMulti",uri:L.location.uri,lines:[]},O.set(L.location.uri.toString(),F),v.push(F)),F.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof u.$6N&&v.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(C){const p=C.filter(F=>this.H.delete(F.id));this.rb([],p,[]);const v=p.filter(F=>F instanceof u.$5N).map(F=>F.id),O=p.filter(F=>F instanceof u.$6N).map(F=>F.id),L=p.filter(F=>F instanceof u.$7N).map(F=>F.id);return this.u.$unregisterBreakpoints(v,O,L)}startDebugging(C,p,v){const O=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(C?C.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:O&&{runId:O.runId,taskId:O.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,p,v){if(!p)return new u.$3M(()=>{});const O=this.f++;return this.g.push({type:C,handle:O,provider:p}),this.u.$registerDebugConfigurationProvider(C,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,O),new u.$3M(()=>{this.g=this.g.filter(L=>L.provider!==p),this.u.$unregisterDebugConfigurationProvider(O)})}registerDebugAdapterDescriptorFactory(C,p,v){if(!v)return new u.$3M(()=>{});if(!this.nb(C,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const O=this.h++;return this.j.push({type:p,handle:O,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,O),new u.$3M(()=>{this.j=this.j.filter(L=>L.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(O)})}registerDebugAdapterTrackerFactory(C,p){if(!p)return new u.$3M(()=>{});const v=this.m++;return this.n.push({type:C,handle:v,factory:p}),new u.$3M(()=>{this.n=this.n.filter(O=>O.factory!==p)})}async $runInTerminal(C,p){return Promise.resolve(void 0)}async $substituteVariables(C,p){let v;const O=await this.tb(C);return O&&(v={uri:O.uri,name:O.name,index:O.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(C,p){if(C.type==="implementation")return new S(C.implementation)}ib(){}async $startDASession(C,p){const v=this,O=await this.sb(p);return this.pb(this.kb(O.type),O).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${O.type}' (extension might have failed to activate)`);const F=this.jb(L),j=this.hb(F,O);if(!j)throw new Error(`Couldn't create a debug adapter for type '${O.type}'.`);const B=j;return this.M.set(C,B),this.ob(O).then(M=>(M&&this.N.set(C,M),B.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const _=z,re={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const U=await this.U.sign(_.arguments.value);re.body={signature:U},B.sendResponse(re)}else throw new Error("no signer")}catch(U){re.success=!1,re.message=U.message,B.sendResponse(re)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(z),z=(0,g.$YH)(z,!0),v.u.$acceptDAMessage(C,z)}),B.onError(z=>{M&&M.onError&&M.onError(z),this.u.$acceptDAError(C,z.name,z.message,z.stack)}),B.onExit(z=>{M&&M.onExit&&M.onExit(z??void 0,void 0),this.u.$acceptDAExit(C,z??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),B.startSession()))})}$sendDAMessage(C,p){p=(0,g.$XH)(p,!1);const v=this.N.get(C);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(C)?.sendMessage(p)}$stopDASession(C){const p=this.N.get(C);this.N.delete(C),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(C);return this.M.delete(C),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const p=[],v=[],O=[];if(C.added)for(const L of C.added){const F=L.id;if(F&&!this.H.has(F)){let j;if(L.type==="function")j=new u.$6N(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")j=new u.$7N(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const B=A.URI.revive(L.uri);j=new u.$5N(new u.$cN(B,new u.$4M(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,u.$3N)(j,F),this.H.set(F,j),p.push(j)}}if(C.removed)for(const L of C.removed){const F=this.H.get(L);F&&(this.H.delete(L),v.push(F))}if(C.changed){for(const L of C.changed)if(L.id){const F=this.H.get(L.id);if(F){if(F instanceof u.$6N&&L.type==="function"){const j=F;j.enabled=L.enabled,j.condition=L.condition,j.hitCondition=L.hitCondition,j.logMessage=L.logMessage,j.functionName=L.functionName}else if(F instanceof u.$5N&&L.type==="source"){const j=F;j.enabled=L.enabled,j.condition=L.condition,j.hitCondition=L.hitCondition,j.logMessage=L.logMessage,j.location=new u.$cN(A.URI.revive(L.uri),new u.$4M(L.line,L.character))}O.push(F)}}}this.rb(p,v,O)}async $acceptStackFrameFocus(C){let p;if(C){const v=await this.sb(C.sessionId);C.kind==="thread"?p=new u.$aO(v.api,C.threadId):p=new u.$_N(v.api,C.threadId,C.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(C,p,v){return(0,r.$wh)(async()=>{const O=this.mb(C);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.tb(p);return O.provideDebugConfigurations(L,v)}).then(O=>{if(!O)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return O})}$resolveDebugConfiguration(C,p,v,O){return(0,r.$wh)(async()=>{const L=this.mb(C);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb(p);return L.resolveDebugConfiguration(F,v,O)})}$resolveDebugConfigurationWithSubstitutedVariables(C,p,v,O){return(0,r.$wh)(async()=>{const L=this.mb(C);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb(p);return L.resolveDebugConfigurationWithSubstitutedVariables(F,v,O)})}async $provideDebugAdapter(C,p){const v=this.lb(C);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const O=await this.sb(p);return this.pb(v,O).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${O.type}'`);return this.jb(L)})}async $acceptDebugSessionStarted(C){const p=await this.sb(C);this.y.fire(p.api)}async $acceptDebugSessionTerminated(C){const p=await this.sb(C);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,p){(await this.sb(C))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(C,p){const O={session:(await this.sb(C)).api,event:p.event,body:p.body};this.F.fire(O)}jb(C){if(C instanceof u.$8N)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof u.$9N)return{type:"server",port:C.port,host:C.host};if(C instanceof u.$0N)return{type:"pipeServer",path:C.path};if(C instanceof u.$$N)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const p=this.j.filter(v=>v.type===C);if(p.length>0)return p[0].factory}lb(C){const p=this.j.filter(v=>v.handle===C);if(p.length>0)return p[0].factory}mb(C){const p=this.g.filter(v=>v.handle===C);if(p.length>0)return p[0].provider}nb(C,p){if(C.contributes){const v=C.contributes.debuggers;if(v&&v.length>0){for(const O of v)if(O.label&&O.type&&O.type===p)return!0}}return!1}ob(C){const v=C.configuration.type,O=this.n.filter(L=>L.type===v||L.type==="*").map(L=>(0,r.$wh)(()=>L.factory.createDebugAdapterTracker(C.api)).then(F=>F,F=>null));return Promise.race([Promise.all(O).then(L=>{const F=(0,t.$Ib)(L);if(F.length>0)return new y(F)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async pb(C,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$9N(v));if(C){const L=await this.Z.getExtensionRegistry();return(0,r.$wh)(()=>C.createDebugAdapterDescriptor(p.api,this.qb(p,L))).then(F=>{if(F)return F})}const O=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,O))}qb(C,p){}rb(C,p,v){(C.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:C,removed:p,changed:v}))}async sb(C){if(C)if(typeof C=="string"){const p=this.w.get(C);if(p)return p}else{let p=this.w.get(C.id);if(!p){const v=await this.tb(C.folderUri),O=C.parent?this.w.get(C.parent):void 0;p=new a(this.u,C.id,C.type,C.name,v,C.configuration,O?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(C){if(C){const p=A.URI.revive(C);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(C,p){return`${C}\0${p}`}vb(C,p){if(p){if("title"in p&&"command"in p)return{type:c.DebugVisualizationType.Command};if("treeId"in p)return{type:c.DebugVisualizationType.Tree,id:`${C}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const p=this.xb(C);let v,O;return"id"in p?O=n.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:O}}xb(C){if(C instanceof u.$ZN)return{id:C.id};const p=typeof C=="object"&&"dark"in C?C.dark:C,v=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof p=="string"?A.URI.file(p):p,light:typeof v=="string"?A.URI.file(v):v}}};e.$loc=d,e.$loc=d=Qe([qe(0,E.$uP),qe(1,k.$wnc),qe(2,I.$aoc),qe(3,f.$znc),qe(4,l.$Lnc),qe(5,m.$doc),qe(6,o.$QP),qe(7,s.$foc)],d);class a{constructor(C,p,v,O,L,F,j){this.f=C,this.g=p,this.h=v,this.j=O,this.k=L,this.l=F,this.m=j}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(p){C.j=p,C.f.$setDebugSessionName(C.g,p)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(p,v){return C.f.$customDebugAdapterRequest(C.g,p,v)},getDebugProtocolBreakpoint(p){return C.f.$getDebugProtocolBreakpoint(C.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$moc=a;class w{constructor(C){this.value=Object.freeze({append(p){C.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$noc=w;class y{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(p=>p.onError?p.onError(C):void 0)}onExit(C,p){this.d.forEach(v=>v.onExit?v.onExit(C,p):void 0)}}class S extends b.$Usb{constructor(C){super(),this.h=C,C.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let D=class extends d{constructor(C,p,v,O,L,F,j,B){super(C,p,v,O,L,F,j,B)}};e.$ooc=D,e.$ooc=D=Qe([qe(0,E.$uP),qe(1,k.$wnc),qe(2,I.$aoc),qe(3,f.$znc),qe(4,l.$Lnc),qe(5,m.$doc),qe(6,o.$QP),qe(7,s.$foc)],D)}),define(Ee[390],Se([1,0,14,62,2,6,339,12,89,115,30,275,20,73,52,95]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=e.$npc=void 0,r=We(r),h=We(h);class g{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(T.$$j),t=n.get(u.$uP).getProxy(R.$1M.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const d=r.$4(s);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(T.$$j),i=n.get(u.$uP),t=n.get(b.$aoc),s=n.get(c.$OP),d=i.getProxy(R.$1M.MainThreadExtensionService),a=i.getProxy(R.$1M.MainThreadErrors),w=await t.getExtensionPathIndex(),y=new WeakMap;function S(C,p){if(y.has(C))return y.get(C).stack;let v="",O,L;for(const j of p)v+=`
	at ${j.toString()}`,L=j.getFileName(),!O&&L&&(O=w.findSubstr(A.URI.file(L)));const F=`${C.name||"Error"}: ${C.message||""}${v}`;return y.set(C,{extensionIdentifier:O?.identifier,stack:F}),F}const D=Symbol("prepareStackTrace wrapped");let P=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(C){if(C===S||!C||C[D]){P=C||S;return}P=function(p,v){return S(p,v),C.call(Error,p,v)},Object.assign(P,{[D]:!0})}}),r.setUnexpectedErrorHandler(C=>{o.error(C);const p=r.$4(C),v=y.get(C);if(!v?.extensionIdentifier){a.$onUnexpectedError(p);return}d.$onExtensionRuntimeError(v.extensionIdentifier,p);const O=s.onExtensionError(v.extensionIdentifier,C);o.trace("forwarded error to extension?",O,v)})}}e.$npc=g;class f{constructor(n,o,i,t,s){this.a=i,this.b=new N.$Mbc(n,null,t),o=f.e(o,this.b);const d=new l.$Ci(...(0,$.$Ls)());d.set(I.$KP,{_serviceBrand:void 0,...o,messagePorts:s}),d.set(u.$uP,new u.$vP(this.b)),d.set(k.$tnc,new k.$unc(t)),d.set(b.$$nc,i);const a=new E.$pr(d,!0);a.invokeFunction(g.installEarlyHandler),this.d=a.invokeFunction(w=>w.get(T.$$j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=a.invokeFunction(w=>w.get(b.$aoc)),this.c.initialize(),a.invokeFunction(g.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(R.$1M.MainThreadExtensionService);return A.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>A.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$opc=f}),define(Ee[391],Se([1,0,9,11,245,268,148,102,78,52,20,47,10,65,48,309,310,42,35,99]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=void 0,h=We(h),A=We(A);let o=class extends T.$loc{constructor(a,w,y,S,D,P,C,p,v){super(a,w,y,S,P,C,p,v),this.Ab=D,this.yb=new s}hb(a,w){switch(a.type){case"server":return new c.$tpc(a);case"pipeServer":return new c.$upc(a);case"executable":return new c.$vpc(a,w.type)}return super.hb(a,w)}qb(a,w){const y=c.$vpc.platformAdapterExecutable(w.getAllExtensionDescriptions(),a.type);if(y)return new u.$8N(y.command,y.args,y.options)}ib(){return new N.$Jfc}async $runInTerminal(a,w){if(a.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(B=>{this.yb.onTerminalClosed(B)})));const y=await this.$.getConfigProvider(),S=this.Ab.getDefaultShell(!0),D=this.Ab.getDefaultShellArgs(!0),P=a.title||A.localize(0,null),C=JSON.stringify({shell:S,shellArgs:D});let p=await this.yb.checkout(C,P),v,O=!1;if(p)v=a.cwd;else{const B={shellPath:S,shellArgs:D,cwd:a.cwd,name:P,iconPath:new u.$ZN("debug")};O=!0,p=this.Ab.createTerminalFromOptions(B,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,C)}p.show(!0);const L=await p.processId;O?await new Promise(B=>setTimeout(B,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,r.$Fh)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?p.sendText("cls"):S.indexOf("bash")>=0?p.sendText("clear"):h.$i?p.sendText("cls"):p.sendText("clear")));const F=(0,g.$xpc)(S,a.args,!!a.argsCanBeInterpretedByShell,v,a.env);p.sendText(F);const j=this.onDidTerminateDebugSession(B=>{B.id===w&&(this.yb.free(p),j.dispose())});return L}else if(a.kind==="external")return t(a,await this.$.getConfigProvider());return super.$runInTerminal(a,w)}};e.$ypc=o,e.$ypc=o=Qe([qe(0,I.$uP),qe(1,b.$wnc),qe(2,l.$aoc),qe(3,f.$znc),qe(4,E.$Xnc),qe(5,$.$Lnc),qe(6,k.$doc),qe(7,m.$QP),qe(8,n.$foc)],o);let i;function t(d,a){if(!i)if(h.$i)i=new R.$sec;else if(h.$j)i=new R.$tec;else if(h.$k)i=new R.$uec;else throw new Error("external terminals not supported on this platform");const w=a.getConfiguration("terminal");return i.runInTerminal(d.title,d.cwd,d.args,d.env||{},w.external||{})}class s{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,w,y=!1){const D=[...this.b.entries()].map(([P,C])=>(0,r.$rh)(async p=>{if(P.name!==w||C.lastUsedAt!==-1&&await(0,g.$wpc)(await P.processId))return null;const v=Date.now();return C.lastUsedAt+s.a>v||p.isCancellationRequested?null:C.config!==a?(y&&P.dispose(),null):(C.lastUsedAt=v,P)}));return await(0,r.$Jh)(D,P=>!!P)}insert(a,w){this.b.set(a,{lastUsedAt:Date.now(),config:w})}free(a){const w=this.b.get(a);w&&(w.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(Ee[392],Se([1,0,16,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0,r=We(r),g=We(g);let n=class extends u.$7oc{constructor(i,t,s,d,a,w,y,S,D){super(i,t,s,d,a,w,y,S),this.C=s,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(i,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=u.TaskHandleDTO.from(s,this.C),a=await this.a.$getTaskExecution(d);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const w=await this.z(a,t);return this.a.$executeTask(d).catch(()=>{}),w}else{const d=u.TaskDTO.from(t,i);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const a=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),a}}v(i,t,s,d){const a=[];if(d)for(const w of d){this.A(w,s),(!w.definition||!i[w.definition.type])&&this.f.warn(`The task [${w.source}, ${w.name}] uses an undefined task type. The task will be ignored in the future.`);const y=u.TaskDTO.from(w,s.extension);y&&(a.push(y),u.CustomExecutionDTO.is(y.execution)&&t.push(this.y(y,w,!0)))}return{tasks:a,extension:s.extension}}async w(i){return i}async G(i){let t=i&&i.length>0?i[0]:void 0;if(!t){const s=h.URI.file((0,f.homedir)());t=new $.$Yi({uri:s,name:g.$ch(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(i,t){const s=h.URI.revive(i),d={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(s),w=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),S=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(w);for(const D of t.variables)d.variables[D]=await y.resolveAsync(S,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(r.$uc);for(let P=0;P<D.length;P++)D[P]=await y.resolveAsync(S,D[P])}d.process=await A.win32.findExecutable(await y.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await y.resolveAsync(S,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(i,t,s){return A.win32.findExecutable(i,t,s)}};e.$qpc=n,e.$qpc=n=Qe([qe(0,I.$uP),qe(1,E.$KP),qe(2,R.$wnc),qe(3,N.$FP),qe(4,T.$znc),qe(5,l.$Xnc),qe(6,b.$$j),qe(7,c.$anc),qe(8,m.$doc)],n)}),define(Ee[393],Se([1,0,68,65]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=void 0;class A extends h.$eoc{m(){return(0,r.homedir)()}}e.$9pc=A}),define(Ee[170],Se([1,0,19,9,21,55,15,16,23,2,38]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Doc=e.$Coc=void 0,e.$Eoc=c,T=We(T),$=We($);class E{constructor(m,n,o){this.d=m,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(m,n){const o=this.g.folderQueries||[],i=new A.$we(n);return new Promise((t,s)=>{this.a=new k(m);let d=!1;const a=(w,y)=>{if(!d&&!this.b){const S=this.h(w);c(w)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,d=!0,i.cancel(),w=this.j(w,this.g.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!c(w))&&this.a.add(w,y)}};Promise.all(o.map((w,y)=>this.k(w,S=>a(S,y),i.token))).then(w=>{i.dispose(),this.a.flush();const y=w.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||y,messages:w.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},w=>{i.dispose();const y=(0,R.$pj)(w);s(new Error(y))})})}h(m){return c(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,n){const o=Array.isArray(m.ranges)?m.ranges:[m.ranges],i=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:o.slice(0,n),preview:{matches:i.slice(0,n),text:m.preview.text},uri:m.uri}}async k(m,n,o){const i=new I.$EL(this.g,m),t=[],s={report:w=>{if(!this.l(w))return;const y=m.folder.scheme===N.Schemas.file?(0,I.$FL)(()=>this.e.readdir($.$eh(w.uri))):void 0,S=$.$hh(m.folder,w.uri);if(S){const D=i.includedInQuery(S,T.$oc(S),y);(0,h.$qh)(D)?t.push(D.then(P=>{P&&n(w)})):D&&n(w)}}},d=this.n(m);let a;return this.d.query.type===I.QueryType.aiText?a=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,s,o):a=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,s,o),t.length&&await Promise.all(t),a}l(m){if(c(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const n=(0,I.$DL)(this.g.includePattern,m.includePattern),o=(0,I.$DL)(this.g.excludePattern,m.excludePattern),i={folder:l.URI.from(m.folder),excludes:o,includes:n,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.e.toCanonicalName(m.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$kL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$Coc=E;function u(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class k{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new g(512,n=>this.g(n))}add(m,n){this.d&&(this.b!==n||!$.$$g(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:m.uri,results:[]}),this.d.results.push(b(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.$Doc=k;function b(f){return c(f)?{preview:{matches:(0,r.$2b)(f.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:f.preview.text},ranges:(0,r.$2b)(f.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function c(f){return!!f.preview}class g{static{this.a=4e3}static{this.b=50}constructor(m,n){this.g=m,this.h=n,this.c=0,this.d=[],this.e=0}addItem(m,n){m&&this.j(m,n)}addItems(m,n){m&&this.k(m,n)}j(m,n){this.d.push(m),this.e+=n,this.l()}k(m,n){this.d=this.d.concat(m),this.e+=n,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Foc=g}),define(Ee[103],Se([1,0,3,6,5,386,20,73,12,2,170]),function(ce,e,r,h,A,R,N,T,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=void 0,e.$Ioc=u,e.$Goc=(0,A.$Ei)("IExtHostSearch");let E=class{constructor(c,g,f){this.n=c,this.o=g,this.q=f,this.c=this.n.getProxy(h.$1M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$Boc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const f=this.d++;return this.e.set(f,g),this.c.$registerTextSearchProvider(f,this.s(c)),(0,r.$Tc)(()=>{this.g.delete(c),this.e.delete(f),this.c.$unregisterProvider(f)})}registerAITextSearchProvider(c,g){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const f=this.d++;return this.h.set(f,g),this.c.$registerAITextSearchProvider(f,this.s(c)),(0,r.$Tc)(()=>{this.i.delete(c),this.h.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(c,g){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const f=this.d++;return this.j.set(f,g),this.c.$registerFileSearchProvider(f,this.s(c)),(0,r.$Tc)(()=>{this.k.delete(c),this.j.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(c,g,f,m){const n=u(f),o=this.j.get(c);if(o)return this.l.fileSearch(n,o,i=>{this.c.$handleFileMatch(c,g,i.map(t=>t.resource))},m);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,f){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,f,m){const n=this.e.get(c);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${c}`);const o=u(f);return this.t(o,n).search(t=>this.c.$handleTextMatch(c,g,t),m)}$provideAITextSearchResults(c,g,f,m){const n=this.h.get(c);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${c}`);const o=u(f);return this.v(o,n).search(t=>this.c.$handleTextMatch(c,g,t),m)}$enableExtensionHostSearch(){}t(c,g){return new I.$Coc({query:c,provider:g},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}v(c,g){return new I.$Coc({query:c,provider:g},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"aiTextSearchProvider")}};e.$Hoc=E,e.$Hoc=E=Qe([qe(0,N.$uP),qe(1,T.$tnc),qe(2,$.$$j)],E);function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(k),extraFileResources:b.extraFileResources&&b.extraFileResources.map(c=>l.URI.revive(c))}}function k(b){return{...b,folder:l.URI.revive(b.folder)}}});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[394],Se([1,0,21,14,4,3,15,44,2,114,212,193,54,24,28,12,91,92,295,6,341,367,96,128,345,346,347,326,315,35,348,42,349,102,162,350,328,342,351,352,64,78,329,343,52,353,76,354,63,30,368,330,355,129,356,123,124,331,385,358,299,359,369,360,168,332,361,362,363,20,364,103,125,365,333,366,126,98,101,95,47,166,99,370,344,371,372,77,17,10,334,73,335,97,373,374,161,48,120,94,26,100]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a,w,y,S,D,P,C,p,v,O,L,F,j,B,M,z,_,re,U,G,K,ee,ue,ne,De,$e,J,W,se,oe,te,le,he,Z,ae,pe,be,Me,ze,ke,Ie,Te,V,q,Q,x,fe,we,Oe,Ge,Ke,tt,rt,ot,nt,ct,$t,ht,at,Pe,Be,Ye,Le,Fe,X,de,Ce,Ze,_e,lt,ft,kt,Tt,Ut,ui,it,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=Yt,h=We(h),T=zt(T),E=We(E),b=We(b),Fe=We(Fe),X=We(X);function Yt(mt){const bt=mt.get(De.$KP),hi=mt.get(ne.$enc),ei=mt.get(ee.$Bnc),Wt=mt.get(G.$aoc),wt=mt.get(Tt.$wnc),Vt=mt.get(nt.$OP),Qt=mt.get(C.$znc),Zt=mt.get(Ce.$tnc),xe=mt.get(Q.$uP),$i=mt.get(tt.$Unc),ti=mt.get(rt.$Cnc),si=mt.get(c.$_j),Dt=mt.get(c.$$j),Kt=mt.get(Le.$4Eb),Nt=mt.get(t.$anc),Ft=mt.get(kt.$hpc),ii=mt.get(we.$5nc),ni=mt.get(_.$Lnc),oi=mt.get(le.$9nc),qt=mt.get(s.$knc),Jt=mt.get(se.$2nc);xe.set(n.$2M.ExtHostFileSystemInfo,hi),xe.set(n.$2M.ExtHostLogLevelServiceShape,si),xe.set(n.$2M.ExtHostWorkspace,wt),xe.set(n.$2M.ExtHostConfiguration,Qt),xe.set(n.$2M.ExtHostExtensionService,Wt),xe.set(n.$2M.ExtHostStorage,$i),xe.set(n.$2M.ExtHostTunnelService,Kt),xe.set(n.$2M.ExtHostWindow,Ft),xe.set(n.$2M.ExtHostSecretState,ii),xe.set(n.$2M.ExtHostTelemetry,Vt),xe.set(n.$2M.ExtHostEditorTabs,ni),xe.set(n.$2M.ExtHostManagedSockets,oi),xe.set(n.$2M.ExtHostAuthentication,qt),xe.set(n.$2M.ExtHostChatProvider,Jt);const di=xe.set(n.$2M.ExtHostDecorations,mt.get(O.$qoc)),jt=xe.set(n.$2M.ExtHostDocumentsAndEditors,mt.get(z.$FP)),vt=xe.set(n.$2M.ExtHostCommands,mt.get(D.$QP)),Pt=xe.set(n.$2M.ExtHostTerminalService,mt.get(ct.$Xnc)),Lt=xe.set(n.$2M.ExtHostTerminalShellIntegration,mt.get($t.$0oc)),It=xe.set(n.$2M.ExtHostDebugService,mt.get(v.$koc)),Xt=xe.set(n.$2M.ExtHostSearch,mt.get(fe.$Goc)),Ht=xe.set(n.$2M.ExtHostTask,mt.get(ot.$9oc)),pi=xe.set(n.$2M.ExtHostOutputService,mt.get(ke.$Voc)),fi=xe.set(n.$2M.ExtHostLocalization,mt.get(te.$8nc)),Ai=xe.set(n.$2M.ExtHostUrls,new Ze.$epc(xe)),Ot=xe.set(n.$2M.ExtHostDocuments,new M.$hnc(xe,jt)),Ti=xe.set(n.$2M.ExtHostDocumentContentProviders,new j.$soc(xe,jt,Dt)),ai=xe.set(n.$2M.ExtHostDocumentSaveParticipant,new B.$toc(Dt,Ot,xe.getProxy(n.$1M.MainThreadBulkEdits))),Rt=xe.set(n.$2M.ExtHostNotebook,new Z.$Joc(xe,vt,jt,Ot,ei,Xt,Dt)),Si=xe.set(n.$2M.ExtHostNotebookDocuments,new pe.$Poc(Rt)),Di=xe.set(n.$2M.ExtHostNotebookEditors,new be.$Qoc(Dt,Rt)),vi=xe.set(n.$2M.ExtHostNotebookKernels,new Me.$Roc(xe,bt,Rt,vt,Dt)),Li=xe.set(n.$2M.ExtHostNotebookRenderers,new ze.$Toc(xe,Rt)),gi=xe.set(n.$2M.ExtHostNotebookDocumentSaveParticipant,new ae.$Ooc(Dt,Rt,xe.getProxy(n.$1M.MainThreadBulkEdits))),Gt=xe.set(n.$2M.ExtHostEditors,new at.$qnc(xe,jt)),Ae=xe.set(n.$2M.ExtHostTreeViews,new Ye.$cpc(xe.getProxy(n.$1M.MainThreadTreeViews),vt,Dt)),je=xe.set(n.$2M.ExtHostEditorInsets,new S.$rnc(xe.getProxy(n.$1M.MainThreadEditorInsets),Gt,bt.remote)),ve=xe.set(n.$2M.ExtHostDiagnostics,new L.$gnc(xe,Dt,hi,jt)),ie=xe.set(n.$2M.ExtHostLanguages,new oe.$Moc(xe,Ot,vt.converter,Zt)),Re=xe.set(n.$2M.ExtHostLanguageFeatures,new W.$inc(xe,Zt,Ot,vt,ve,Dt,Nt,Vt)),He=xe.set(n.$2M.ExtHostFileSystem,new K.$woc(xe,Re)),et=xe.set(n.$2M.ExtHostFileSystemEventService,new ue.$xoc(xe,Dt,jt)),Je=xe.set(n.$2M.ExtHostQuickOpen,(0,q.$Zoc)(xe,wt,vt)),gt=xe.set(n.$2M.ExtHostSCM,new x.$2oc(xe,vt,Ot,Dt)),At=xe.set(n.$2M.ExtHostQuickDiff,new V.$Yoc(xe,Zt)),xt=xe.set(n.$2M.ExtHostShare,new Oe.$3oc(xe,Zt)),ci=xe.set(n.$2M.ExtHostComments,(0,P.$snc)(xe,vt,Ot)),Bt=xe.set(n.$2M.ExtHostProgress,new Te.$Xoc(xe.getProxy(n.$1M.MainThreadProgress))),ri=xe.set(n.$2M.ExtHostLabelService,new J.$Loc(xe)),zi=xe.set(n.$2M.ExtHostTheming,new Pe.$_oc(xe)),Xi=xe.set(n.$2M.ExtHostTimeline,new Be.$bpc(xe,vt)),Ui=xe.set(n.$2M.ExtHostWebviews,new _e.$Gnc(xe,bt.remote,wt,Dt,Nt)),Oi=xe.set(n.$2M.ExtHostWebviewPanels,new lt.$Jnc(xe,Ui,wt)),Wi=xe.set(n.$2M.ExtHostCustomEditors,new p.$Knc(xe,Ot,ti,Ui,Oi)),Vi=xe.set(n.$2M.ExtHostWebviewViews,new ft.$fpc(xe,Ui)),ki=xe.set(n.$2M.ExtHostTesting,mt.get(ht.$foc)),xi=xe.set(n.$2M.ExtHostUriOpeners,new de.$dpc(xe)),_i=xe.set(n.$2M.ExtHostProfileContentHandlers,new Ie.$Woc(xe));xe.set(n.$2M.ExtHostInteractive,new $e.$Koc(xe,Rt,jt,vt,Dt));const Mi=xe.set(n.$2M.ExtHostChatAgents2,new a.$nnc(xe,Dt,vt,bt.quality)),en=xe.set(n.$2M.ExtHostChatVariables,new w.$onc(xe)),qi=xe.set(n.$2M.ExtHostAiRelatedInformation,new o.$_mc(xe)),$n=xe.set(n.$2M.ExtHostAiEmbeddingVector,new U.$voc(xe)),tn=xe.set(n.$2M.ExtHostStatusBar,new Ke.$6oc(xe,vt.converter)),Gi=xe.set(n.$2M.ExtHostSpeech,new Ge.$4oc(xe)),Ii=xe.set(n.$2M.ExtHostEmbeddings,new re.$uoc(xe)),pn=Object.values(n.$2M);xe.assertRegistered(pn);const bn=new d.$mnc(xe,jt),nn=new y.$pnc(xe),Hi=new he.$Noc(xe,Dt),Fi=new F.$roc(xe);return i.$jnc.register(vt),function(Ve,bi,Yi){function ut(ge){return(ye,Ue,dt)=>{const St=ge(Mt=>{try{ye.call(Ue,Mt)}catch(Pi){h.$3(new Error(`[ExtensionListenerError] Extension '${Ve.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Vt.onExtensionError(Ve.identifier,Pi)}});return dt?.push(St),St}}const yt=function(){let ge=!Ve.isUnderDevelopment;function ye(){ge||(Dt.info(`Extension '${Ve.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ue(dt){if(Array.isArray(dt))dt.forEach(Ue);else if(typeof dt=="string")ye();else{const St=dt;typeof St.scheme>"u"&&ye(),typeof St.exclusive=="boolean"&&(0,it.$4G)(Ve,"documentFiltersExclusive")}return dt}}(),rn={getSession(ge,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,it.$4G)(Ve,"authLearnMore"),qt.getSession(Ve,ge,ye,Ue)},getSessions(ge,ye){return(0,it.$4G)(Ve,"authGetSessions"),qt.getSessions(Ve,ge,ye)},async hasSession(ge,ye){return(0,it.$4G)(Ve,"authSession"),!!await qt.getSession(Ve,ge,ye,{silent:!0})},get onDidChangeSessions(){return ut(qt.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,Ue,dt){return qt.registerAuthenticationProvider(ge,ye,Ue,dt)}},Ei={registerCommand(ge,ye,Ue){return vt.registerCommand(!0,ge,ye,Ue,void 0,Ve)},registerTextEditorCommand(ge,ye,Ue){return vt.registerCommand(!0,ge,(...dt)=>{const St=Gt.getActiveTextEditor();if(!St){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Mt=>{ye.apply(Ue,[St,Mt,...dt])}).then(Mt=>{Mt||Dt.warn("Edits from command "+ge+" were not applied.")},Mt=>{Dt.warn("An error occurred while running command "+ge,Mt)})},void 0,void 0,Ve)},registerDiffInformationCommand:(ge,ye,Ue)=>((0,it.$4G)(Ve,"diffCommand"),vt.registerCommand(!0,ge,async(...dt)=>{const St=jt.activeEditor(!0);if(!St){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Mt=await Gt.getDiffInformation(St.id);ye.apply(Ue,[Mt,...dt])},void 0,void 0,Ve)),executeCommand(ge,...ye){return vt.executeCommand(ge,...ye)},getCommands(ge=!1){return vt.getCommands(ge)}},Ni={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return ut(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ut(Vt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$4G)(Ve,"telemetry"),Vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$4G)(Ve,"telemetry"),ut(Vt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$NP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return nt.$MP.validateSender(ge),Vt.instantiateLogger(Ve,ge,ye)},openExternal(ge,ye){return Ft.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return Ai.createAppUri(ge);try{return await Ft.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ye){if((0,N.$Ng)(ge,N.Schemas.http)||(0,N.$Ng)(ge,N.Schemas.https))return ge;throw ye}},get remoteName(){return(0,g.$gn)(bt.remote.authority)},get remoteAuthority(){return(0,it.$4G)(Ve,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return Dt.getLevel()},get onDidChangeLogLevel(){return ut(Dt.onDidChangeLogLevel)},get appQuality(){return(0,it.$4G)(Ve,"resolvers"),bt.quality},get appCommit(){return(0,it.$4G)(Ve,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Ni);const wn={createTestController(ge,ye,Ue){return ki.createTestController(Ve,ge,ye,Ue)},createTestObserver(){return(0,it.$4G)(Ve,"testObserver"),ki.createTestObserver()},runTests(ge){return(0,it.$4G)(Ve,"testObserver"),ki.runTests(ge)},registerTestFollowupProvider(ge){return(0,it.$4G)(Ve,"testObserver"),ki.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,it.$4G)(Ve,"testObserver"),ut(ki.onResultsChanged)},get testResults(){return(0,it.$4G)(Ve,"testObserver"),ki.results}},li=bt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,ji={getExtension(ge,ye){(0,it.$3G)(Ve,"extensionsAny")||(ye=!1);const Ue=bi.mine.getExtensionDescription(ge);if(Ue)return new G.$boc(Wt,Ve.identifier,Ue,li,!1);if(ye){const dt=bi.all.getExtensionDescription(ge);if(dt)return new G.$boc(Wt,Ve.identifier,dt,li,!0)}},get all(){const ge=[];for(const ye of bi.mine.getAllExtensionDescriptions())ge.push(new G.$boc(Wt,Ve.identifier,ye,li,!1));return ge},get allAcrossExtensionHosts(){(0,it.$4G)(Ve,"extensionsAny");const ge=new k.$qn(bi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of bi.all.getAllExtensionDescriptions()){const dt=!ge.has(Ue.identifier);ye.push(new G.$boc(Wt,Ve.identifier,Ue,li,dt))}return ye},get onDidChange(){return(0,it.$3G)(Ve,"extensionsAny")?ut(A.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ut(bi.mine.onDidChange)}},sn={createDiagnosticCollection(ge){return ve.createDiagnosticCollection(Ve.identifier,ge)},get onDidChangeDiagnostics(){return ut(ve.onDidChangeDiagnostics)},getDiagnostics:ge=>ve.getDiagnostics(ge),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(ge,ye){return ie.changeLanguage(ge.uri,ye)},match(ge,ye){const Ue=Fe.LanguageSelector.from(ge);let dt;return(0,I.$pu)(Ue)&&(dt=Rt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Mt=>Mt.document===ye))?.apiNotebook),(0,I.$ou)(Ue,ye.uri,ye.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,ye,Ue){return Re.registerCodeActionProvider(Ve,yt(ge),ye,Ue)},registerDocumentPasteEditProvider(ge,ye,Ue){return(0,it.$4G)(Ve,"documentPaste"),Re.registerDocumentPasteEditProvider(Ve,yt(ge),ye,Ue)},registerCodeLensProvider(ge,ye){return Re.registerCodeLensProvider(Ve,yt(ge),ye)},registerDefinitionProvider(ge,ye){return Re.registerDefinitionProvider(Ve,yt(ge),ye)},registerDeclarationProvider(ge,ye){return Re.registerDeclarationProvider(Ve,yt(ge),ye)},registerImplementationProvider(ge,ye){return Re.registerImplementationProvider(Ve,yt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return Re.registerTypeDefinitionProvider(Ve,yt(ge),ye)},registerHoverProvider(ge,ye){return Re.registerHoverProvider(Ve,yt(ge),ye,Ve.identifier)},registerEvaluatableExpressionProvider(ge,ye){return Re.registerEvaluatableExpressionProvider(Ve,yt(ge),ye,Ve.identifier)},registerInlineValuesProvider(ge,ye){return Re.registerInlineValuesProvider(Ve,yt(ge),ye,Ve.identifier)},registerDocumentHighlightProvider(ge,ye){return Re.registerDocumentHighlightProvider(Ve,yt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return Re.registerMultiDocumentHighlightProvider(Ve,yt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return Re.registerLinkedEditingRangeProvider(Ve,yt(ge),ye)},registerReferenceProvider(ge,ye){return Re.registerReferenceProvider(Ve,yt(ge),ye)},registerRenameProvider(ge,ye){return Re.registerRenameProvider(Ve,yt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,it.$4G)(Ve,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(Ve,yt(ge),ye)},registerDocumentSymbolProvider(ge,ye,Ue){return Re.registerDocumentSymbolProvider(Ve,yt(ge),ye,Ue)},registerWorkspaceSymbolProvider(ge){return Re.registerWorkspaceSymbolProvider(Ve,ge)},registerDocumentFormattingEditProvider(ge,ye){return Re.registerDocumentFormattingEditProvider(Ve,yt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return Re.registerDocumentRangeFormattingEditProvider(Ve,yt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,Ue,...dt){return Re.registerOnTypeFormattingEditProvider(Ve,yt(ge),ye,[Ue].concat(dt))},registerDocumentSemanticTokensProvider(ge,ye,Ue){return Re.registerDocumentSemanticTokensProvider(Ve,yt(ge),ye,Ue)},registerDocumentRangeSemanticTokensProvider(ge,ye,Ue){return Re.registerDocumentRangeSemanticTokensProvider(Ve,yt(ge),ye,Ue)},registerSignatureHelpProvider(ge,ye,Ue,...dt){return typeof Ue=="object"?Re.registerSignatureHelpProvider(Ve,yt(ge),ye,Ue):Re.registerSignatureHelpProvider(Ve,yt(ge),ye,typeof Ue>"u"?[]:[Ue,...dt])},registerCompletionItemProvider(ge,ye,...Ue){return Re.registerCompletionItemProvider(Ve,yt(ge),ye,Ue)},registerInlineCompletionItemProvider(ge,ye,Ue){return ye.handleDidShowCompletionItem&&(0,it.$4G)(Ve,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,it.$4G)(Ve,"inlineCompletionsAdditions"),Ue&&(0,it.$4G)(Ve,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(Ve,yt(ge),ye,Ue)},registerInlineEditProvider(ge,ye){return(0,it.$4G)(Ve,"inlineEdit"),Re.registerInlineEditProvider(Ve,yt(ge),ye)},registerDocumentLinkProvider(ge,ye){return Re.registerDocumentLinkProvider(Ve,yt(ge),ye)},registerColorProvider(ge,ye){return Re.registerColorProvider(Ve,yt(ge),ye)},registerFoldingRangeProvider(ge,ye){return Re.registerFoldingRangeProvider(Ve,yt(ge),ye)},registerSelectionRangeProvider(ge,ye){return Re.registerSelectionRangeProvider(Ve,ge,ye)},registerCallHierarchyProvider(ge,ye){return Re.registerCallHierarchyProvider(Ve,ge,ye)},registerTypeHierarchyProvider(ge,ye){return Re.registerTypeHierarchyProvider(Ve,ge,ye)},setLanguageConfiguration:(ge,ye)=>Re.setLanguageConfiguration(Ve,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,it.$4G)(Ve,"tokenInformation"),ie.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return Re.registerInlayHintsProvider(Ve,ge,ye)},createLanguageStatusItem(ge,ye){return ie.createLanguageStatusItem(Ve,ge,ye)},registerDocumentDropEditProvider(ge,ye,Ue){return Re.registerDocumentOnDropEditProvider(Ve,ge,ye,(0,it.$3G)(Ve,"documentPaste")?Ue:void 0)}},on={get activeTextEditor(){return Gt.getActiveTextEditor()},get visibleTextEditors(){return Gt.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(ge,ye,Ue){$.URI.isUri(ge)&&ge.scheme===N.Schemas.vscodeRemote&&!ge.authority&&Nt.report("workspace.showTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await($.URI.isUri(ge)?Promise.resolve(Ki.openTextDocument(ge)):Promise.resolve(ge));return Gt.showTextDocument(dt,ye,Ue)},createTextEditorDecorationType(ge){return Gt.createTextEditorDecorationType(Ve,ge)},onDidChangeActiveTextEditor(ge,ye,Ue){return ut(Gt.onDidChangeActiveTextEditor)(ge,ye,Ue)},onDidChangeVisibleTextEditors(ge,ye,Ue){return ut(Gt.onDidChangeVisibleTextEditors)(ge,ye,Ue)},onDidChangeTextEditorSelection(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorSelection)(ge,ye,Ue)},onDidChangeTextEditorOptions(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorOptions)(ge,ye,Ue)},onDidChangeTextEditorVisibleRanges(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorVisibleRanges)(ge,ye,Ue)},onDidChangeTextEditorViewColumn(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorViewColumn)(ge,ye,Ue)},onDidCloseTerminal(ge,ye,Ue){return ut(Pt.onDidCloseTerminal)(ge,ye,Ue)},onDidOpenTerminal(ge,ye,Ue){return ut(Pt.onDidOpenTerminal)(ge,ye,Ue)},onDidChangeActiveTerminal(ge,ye,Ue){return ut(Pt.onDidChangeActiveTerminal)(ge,ye,Ue)},onDidChangeTerminalDimensions(ge,ye,Ue){return(0,it.$4G)(Ve,"terminalDimensions"),ut(Pt.onDidChangeTerminalDimensions)(ge,ye,Ue)},onDidChangeTerminalState(ge,ye,Ue){return ut(Pt.onDidChangeTerminalState)(ge,ye,Ue)},onDidWriteTerminalData(ge,ye,Ue){return(0,it.$4G)(Ve,"terminalDataWriteEvent"),ut(Pt.onDidWriteTerminalData)(ge,ye,Ue)},onDidExecuteTerminalCommand(ge,ye,Ue){return(0,it.$4G)(Ve,"terminalExecuteCommandEvent"),ut(Pt.onDidExecuteTerminalCommand)(ge,ye,Ue)},onDidChangeTerminalShellIntegration(ge,ye,Ue){return(0,it.$4G)(Ve,"terminalShellIntegration"),ut(Lt.onDidChangeTerminalShellIntegration)(ge,ye,Ue)},onDidStartTerminalShellExecution(ge,ye,Ue){return(0,it.$4G)(Ve,"terminalShellIntegration"),ut(Lt.onDidStartTerminalShellExecution)(ge,ye,Ue)},onDidEndTerminalShellExecution(ge,ye,Ue){return(0,it.$4G)(Ve,"terminalShellIntegration"),ut(Lt.onDidEndTerminalShellExecution)(ge,ye,Ue)},get state(){return Ft.getState()},onDidChangeWindowState(ge,ye,Ue){return ut(Ft.onDidChangeWindowState)(ge,ye,Ue)},showInformationMessage(ge,...ye){return Hi.showMessage(Ve,T.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return Hi.showMessage(Ve,T.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return Hi.showMessage(Ve,T.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,Ue){return Je.showQuickPick(Ve,ge,ye,Ue)},showWorkspaceFolderPick(ge){return Je.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return Je.showInput(ge,ye)},showOpenDialog(ge){return Fi.showOpenDialog(Ve,ge)},showSaveDialog(ge){return Fi.showSaveDialog(ge)},createStatusBarItem(ge,ye,Ue){let dt,St,Mt;return typeof ge=="string"?(dt=ge,St=ye,Mt=Ue):(St=ge,Mt=ye),tn.createStatusBarEntry(Ve,dt,St,Mt)},setStatusBarMessage(ge,ye){return tn.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Nt.report("window.withScmProgress",Ve,"Use 'withProgress' instead."),Bt.withProgress(Ve,{location:X.ProgressLocation.SourceControl},(ye,Ue)=>ge({report(dt){}}))},withProgress(ge,ye){return Bt.withProgress(Ve,ge,ye)},createOutputChannel(ge,ye){return pi.createOutputChannel(ge,ye,Ve)},createWebviewPanel(ge,ye,Ue,dt){return Oi.createWebviewPanel(Ve,ge,ye,Ue,dt)},createWebviewTextEditorInset(ge,ye,Ue,dt){return(0,it.$4G)(Ve,"editorInsets"),je.createWebviewEditorInset(ge,ye,Ue,dt,Ve)},createTerminal(ge,ye,Ue){return typeof ge=="object"?"pty"in ge?Pt.createExtensionTerminal(ge):Pt.createTerminalFromOptions(ge):Pt.createTerminal(ge,ye,Ue)},registerTerminalLinkProvider(ge){return Pt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Pt.registerProfileProvider(Ve,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,it.$4G)(Ve,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(ge,Ve.identifier.value,ye)},registerTreeDataProvider(ge,ye){return Ae.registerTreeDataProvider(ge,ye,Ve)},createTreeView(ge,ye){return Ae.createTreeView(ge,ye,Ve)},registerWebviewPanelSerializer:(ge,ye)=>Oi.registerWebviewPanelSerializer(Ve,ge,ye),registerCustomEditorProvider:(ge,ye,Ue={})=>Wi.registerCustomEditorProvider(Ve,ge,ye,Ue),registerFileDecorationProvider(ge){return di.registerFileDecorationProvider(ge,Ve)},registerUriHandler(ge){return Ai.registerUriHandler(Ve,ge)},createQuickPick(){return Je.createQuickPick(Ve)},createInputBox(){return Je.createInputBox(Ve)},get activeColorTheme(){return zi.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,Ue){return ut(zi.onDidChangeActiveColorTheme)(ge,ye,Ue)},registerWebviewViewProvider(ge,ye,Ue){return Vi.registerWebviewViewProvider(Ve,ge,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,Ue){return ut(Rt.onDidChangeActiveNotebookEditor)(ge,ye,Ue)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ut(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,Ue){return ut(Di.onDidChangeNotebookEditorSelection)(ge,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(ge,ye,Ue){return ut(Di.onDidChangeNotebookEditorVisibleRanges)(ge,ye,Ue)},showNotebookDocument(ge,ye){return Rt.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,Ue){return(0,it.$4G)(Ve,"externalUriOpener"),xi.registerExternalUriOpener(Ve.identifier,ge,ye,Ue)},registerProfileContentHandler(ge,ye){return(0,it.$4G)(Ve,"profileContentHandlers"),_i.registerProfileContentHandler(Ve,ge,ye)},registerQuickDiffProvider(ge,ye,Ue,dt){return(0,it.$4G)(Ve,"quickDiffProvider"),At.registerQuickDiffProvider(yt(ge),ye,Ue,dt)},get tabGroups(){return ni.tabGroups},registerShareProvider(ge,ye){return(0,it.$4G)(Ve,"shareProvider"),xt.registerShareProvider(yt(ge),ye)}},Ki={get rootPath(){return Nt.report("workspace.rootPath",Ve,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ge){throw new h.$0("rootPath")},getWorkspaceFolder(ge){return wt.getWorkspaceFolder(ge)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ge){throw new h.$0("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ge){throw new h.$0("workspaceFile")},updateWorkspaceFolders:(ge,ye,...Ue)=>wt.updateWorkspaceFolders(Ve,ge,ye||0,...Ue),onDidChangeWorkspaceFolders:function(ge,ye,Ue){return ut(wt.onDidChangeWorkspace)(ge,ye,Ue)},asRelativePath:(ge,ye)=>wt.getRelativePath(ge,ye),findFiles:(ge,ye,Ue,dt)=>wt.findFiles(ge,ye,Ue,Ve.identifier,dt),findFiles2:(ge,ye,Ue)=>((0,it.$4G)(Ve,"findFiles2"),wt.findFiles2(ge,ye,Ve.identifier,Ue)),findTextInFiles:(ge,ye,Ue,dt)=>{(0,it.$4G)(Ve,"findTextInFiles");let St,Mt;return typeof ye=="object"?(St=ye,Mt=Ue):(St={},Mt=ye,dt=Ue),wt.findTextInFiles(ge,St||{},Mt,Ve.identifier,dt)},save:ge=>wt.save(ge),saveAs:ge=>wt.saveAs(ge),saveAll:ge=>wt.saveAll(ge),applyEdit(ge,ye){return bn.applyWorkspaceEdit(ge,Ve,ye)},createFileSystemWatcher:(ge,ye,Ue,dt)=>{let St;return typeof ye=="boolean"?St={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!dt,correlate:!1}:ye&&((0,it.$4G)(Ve,"createFileSystemWatcher"),St={...ye,correlate:!0}),et.createFileSystemWatcher(wt,Ve,ge,St)},get textDocuments(){return Ot.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$0("textDocuments")},openTextDocument(ge){let ye;const Ue=ge;if(typeof ge=="string")ye=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ye=Promise.resolve(ge);else if(!Ue||typeof Ue=="object")ye=Ot.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(dt=>(dt.scheme===N.Schemas.vscodeRemote&&!dt.authority&&Nt.report("workspace.openTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority."),Ot.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(ge,ye,Ue)=>ut(Ot.onDidAddDocument)(ge,ye,Ue),onDidCloseTextDocument:(ge,ye,Ue)=>ut(Ot.onDidRemoveDocument)(ge,ye,Ue),onDidChangeTextDocument:(ge,ye,Ue)=>ut(Ot.onDidChangeDocument)(ge,ye,Ue),onDidSaveTextDocument:(ge,ye,Ue)=>ut(Ot.onDidSaveDocument)(ge,ye,Ue),onWillSaveTextDocument:(ge,ye,Ue)=>ut(ai.getOnWillSaveTextDocumentEvent(Ve))(ge,ye,Ue),get notebookDocuments(){return Rt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let Ue;if($.URI.isUri(ge))Ue=ge,await Rt.openNotebookDocument(ge);else if(typeof ge=="string")Ue=$.URI.revive(await Rt.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ge,ye,Ue){return ut(Si.onDidSaveNotebookDocument)(ge,ye,Ue)},onDidChangeNotebookDocument(ge,ye,Ue){return ut(Si.onDidChangeNotebookDocument)(ge,ye,Ue)},onWillSaveNotebookDocument(ge,ye,Ue){return ut(gi.getOnWillSaveNotebookDocumentEvent(Ve))(ge,ye,Ue)},get onDidOpenNotebookDocument(){return ut(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ut(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,Ue,dt){return Rt.registerNotebookSerializer(Ve,ge,ye,Ue,(0,it.$3G)(Ve,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,ye,Ue)=>ut(Yi.onDidChangeConfiguration)(ge,ye,Ue),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,Yi.getConfiguration(ge,ye,Ve)},registerTextDocumentContentProvider(ge,ye){return Ti.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Nt.report("window.registerTaskProvider",Ve,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ve,ge,ye)),registerFileSystemProvider(ge,ye,Ue){return(0,R.$Sc)(He.registerFileSystemProvider(Ve,ge,ye,Ue),ei.addFileSystemProvider(ge,ye,Ue))},get fs(){return ei.value},registerFileSearchProvider:(ge,ye)=>((0,it.$4G)(Ve,"fileSearchProvider"),Xt.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,it.$4G)(Ve,"textSearchProvider"),Xt.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,it.$4G)(Ve,"aiTextSearchProvider"),(0,it.$4G)(Ve,"textSearchProvider"),Xt.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,it.$4G)(Ve,"resolvers"),Wt.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,it.$4G)(Ve,"resolvers"),ri.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,it.$4G)(Ve,"resolvers"),Wt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,Ue)=>ut(et.onDidCreateFile)(ge,ye,Ue),onDidDeleteFiles:(ge,ye,Ue)=>ut(et.onDidDeleteFile)(ge,ye,Ue),onDidRenameFiles:(ge,ye,Ue)=>ut(et.onDidRenameFile)(ge,ye,Ue),onWillCreateFiles:(ge,ye,Ue)=>ut(et.getOnWillCreateFileEvent(Ve))(ge,ye,Ue),onWillDeleteFiles:(ge,ye,Ue)=>ut(et.getOnWillDeleteFileEvent(Ve))(ge,ye,Ue),onWillRenameFiles:(ge,ye,Ue)=>ut(et.getOnWillRenameFileEvent(Ve))(ge,ye,Ue),openTunnel:ge=>((0,it.$4G)(Ve,"tunnels"),Kt.openTunnel(Ve,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,it.$4G)(Ve,"tunnels"),Kt.getTunnels()},onDidChangeTunnels:(ge,ye,Ue)=>((0,it.$4G)(Ve,"tunnels"),ut(Kt.onDidChangeTunnels)(ge,ye,Ue)),registerPortAttributesProvider:(ge,ye)=>((0,it.$4G)(Ve,"portsAttributes"),Kt.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,it.$4G)(Ve,"tunnelFactory"),Kt.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,it.$4G)(Ve,"timeline"),Xi.registerTimelineProvider(ge,ye,Ve.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ge=>((0,it.$4G)(Ve,"workspaceTrust"),wt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,Ue)=>ut(wt.onDidGrantWorkspaceTrust)(ge,ye,Ue),registerEditSessionIdentityProvider:(ge,ye)=>((0,it.$4G)(Ve,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,Ue)=>((0,it.$4G)(Ve,"editSessionIdentityProvider"),ut(wt.getOnWillCreateEditSessionIdentityEvent(Ve))(ge,ye,Ue)),registerCanonicalUriProvider:(ge,ye)=>((0,it.$4G)(Ve,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,Ue)=>((0,it.$4G)(Ve,"canonicalUriProvider"),wt.provideCanonicalUri(ge,ye,Ue))},an={get inputBox(){return Nt.report("scm.inputBox",Ve,"Use 'SourceControl.inputBox' instead"),gt.getLastInputBox(Ve)},createSourceControl(ge,ye,Ue){return gt.createSourceControl(Ve,ge,ye,Ue)}},vn={createCommentController(ge,ye){return ci.createCommentController(Ve,ge,ye)}},cn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,it.$4G)(Ve,"debugVisualization"),It.registerDebugVisualizationProvider(Ve,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,it.$4G)(Ve,"debugVisualization"),It.registerDebugVisualizationTree(Ve,ge,ye)},onDidStartDebugSession(ge,ye,Ue){return ut(It.onDidStartDebugSession)(ge,ye,Ue)},onDidTerminateDebugSession(ge,ye,Ue){return ut(It.onDidTerminateDebugSession)(ge,ye,Ue)},onDidChangeActiveDebugSession(ge,ye,Ue){return ut(It.onDidChangeActiveDebugSession)(ge,ye,Ue)},onDidReceiveDebugSessionCustomEvent(ge,ye,Ue){return ut(It.onDidReceiveDebugSessionCustomEvent)(ge,ye,Ue)},onDidChangeBreakpoints(ge,ye,Ue){return ut(It.onDidChangeBreakpoints)(ge,ye,Ue)},onDidChangeActiveStackItem(ge,ye,Ue){return ut(It.onDidChangeActiveStackItem)(ge,ye,Ue)},registerDebugConfigurationProvider(ge,ye,Ue){return It.registerDebugConfigurationProvider(ge,ye,Ue||Ut.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return It.registerDebugAdapterDescriptorFactory(Ve,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return It.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?It.startDebugging(ge,ye,{parentSession:Ue}):It.startDebugging(ge,ye,Ue||{})},stopDebugging(ge){return It.stopDebugging(ge)},addBreakpoints(ge){return It.addBreakpoints(ge)},removeBreakpoints(ge){return It.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return It.asDebugSourceUri(ge,ye)}},ln={registerTaskProvider:(ge,ye)=>Ht.registerTaskProvider(Ve,ge,ye),fetchTasks:ge=>Ht.fetchTasks(ge),executeTask:ge=>Ht.executeTask(Ve,ge),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ge,ye,Ue)=>ut(Ht.onDidStartTask)(ge,ye,Ue),onDidEndTask:(ge,ye,Ue)=>ut(Ht.onDidEndTask)(ge,ye,Ue),onDidStartTaskProcess:(ge,ye,Ue)=>ut(Ht.onDidStartTaskProcess)(ge,ye,Ue),onDidEndTaskProcess:(ge,ye,Ue)=>ut(Ht.onDidEndTaskProcess)(ge,ye,Ue)},En={createNotebookController(ge,ye,Ue,dt,St){return vi.createNotebookController(Ve,ge,ye,Ue,dt,(0,it.$3G)(Ve,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>Rt.registerNotebookCellStatusBarItemProvider(Ve,ge,ye),createRendererMessaging(ge){return Li.createRendererMessaging(Ve,ge)},createNotebookControllerDetectionTask(ge){return(0,it.$4G)(Ve,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(Ve,ge)},registerKernelSourceActionProvider(ge,ye){return(0,it.$4G)(Ve,"notebookKernelSource"),vi.registerKernelSourceActionProvider(Ve,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,Ue){return(0,it.$4G)(Ve,"notebookCellExecutionState"),ut(vi.onDidChangeNotebookCellExecutionState)(ge,ye,Ue)}},yn={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),Ue=!ge||typeof ge[0]!="object"?ge:ge[0];return fi.getMessage(Ve.identifier.value,{message:ye,args:Ue})}return fi.getMessage(Ve.identifier.value,ge[0])},get bundle(){return fi.getBundle(Ve.identifier.value)},get uri(){return fi.getBundleUri(Ve.identifier.value)}},un={_version:1,transferActiveChat(ge){return(0,it.$4G)(Ve,"interactive"),Mi.transferActiveChat(ge)}},Ji={getRelatedInformation(ge,ye){return(0,it.$4G)(Ve,"aiRelatedInformation"),qi.getRelatedInformation(Ve,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,it.$4G)(Ve,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Ve,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,it.$4G)(Ve,"aiRelatedInformation"),$n.registerEmbeddingVectorProvider(Ve,ge,ye)}},hn={_version:1,registerChatResponseProvider(ge,ye,Ue){return(0,it.$4G)(Ve,"chatProvider"),Jt.registerLanguageModel(Ve,ge,ye,Ue)},registerChatVariableResolver(ge,ye,Ue,dt,St,Mt,Pi,Bi){return(0,it.$4G)(Ve,"chatVariableResolver"),en.registerVariableResolver(Ve,ge,ye,Ue,dt,St,Mt,Pi,Bi?.id)},registerMappedEditsProvider(ge,ye){return(0,it.$4G)(Ve,"mappedEditsProvider"),Re.registerMappedEditsProvider(Ve,ge,ye)},createChatParticipant(ge,ye){return Mi.createChatAgent(Ve,ge,ye)},createDynamicChatParticipant(ge,ye,Ue){return(0,it.$4G)(Ve,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Ve,ge,ye,Ue)}},dn={selectChatModels:ge=>bt.quality==="stable"?(console.warn(`[${k.$pn.toKey(Ve.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):Jt.selectLanguageModels(Ve,ge??{}),onDidChangeChatModels:(ge,ye,Ue)=>bt.quality==="stable"?(console.warn(`[${k.$pn.toKey(Ve.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),A.Event.None(ge,ye,Ue)):Jt.onDidChangeProviders(ge,ye,Ue),registerChatModelProvider:(ge,ye,Ue)=>((0,it.$4G)(Ve,"chatProvider"),Jt.registerLanguageModel(Ve,ge,ye,Ue)),get embeddingModels(){return(0,it.$4G)(Ve,"embeddings"),Ii.embeddingsModels},onDidChangeEmbeddingModels:(ge,ye,Ue)=>((0,it.$4G)(Ve,"embeddings"),Ii.onDidChange(ge,ye,Ue)),registerEmbeddingsProvider(ge,ye){return(0,it.$4G)(Ve,"embeddings"),Ii.registerEmbeddingsProvider(Ve,ge,ye)},async computeEmbeddings(ge,ye,Ue){return(0,it.$4G)(Ve,"embeddings"),Ii.computeEmbeddings(ge,ye,Ue)}},fn={registerSpeechProvider(ge,ye){return(0,it.$4G)(Ve,"speech"),Gi.registerProvider(Ve.identifier,ge,ye)}};return{version:bt.version,ai:Ji,authentication:rn,commands:Ei,comments:vn,chat:hn,debug:cn,env:Ni,extensions:ji,interactive:un,l10n:yn,languages:sn,lm:dn,notebooks:En,scm:an,speech:fn,tasks:ln,tests:wn,window:on,workspace:Ki,Breakpoint:X.$4N,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatResultFeedbackKind:X.ChatResultFeedbackKind,ChatVariableLevel:X.ChatVariableLevel,ChatCompletionItem:X.$YO,CallHierarchyIncomingCall:X.$pN,CallHierarchyItem:X.$oN,CallHierarchyOutgoingCall:X.$qN,CancellationError:h.$6,CancellationTokenSource:r.$we,CandidatePortSource:n.CandidatePortSource,CodeAction:X.$lN,CodeActionKind:X.$mN,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$rN,Color:X.$EN,ColorInformation:X.$FN,ColorPresentation:X.$GN,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CommentThreadApplicability:X.CommentThreadApplicability,CompletionItem:X.$yN,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$zN,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$ON,DebugAdapterExecutable:X.$8N,DebugAdapterInlineImplementation:X.$$N,DebugAdapterNamedPipeServer:X.$0N,DebugAdapterServer:X.$9N,DebugConfigurationProviderTriggerKind:Ut.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DebugVisualization:X.$oO,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$eN,DiagnosticRelatedInformation:X.$dN,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$3M,DocumentHighlight:X.$hN,DocumentHighlightKind:X.DocumentHighlightKind,MultiDocumentHighlight:X.$iN,DocumentLink:X.$DN,DocumentSymbol:X.$kN,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$bO,InlineValueText:X.$cO,InlineValueVariableLookup:X.$dO,InlineValueEvaluatableExpression:X.$eO,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:A.$le,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$qO,FileDecoration2:X.$qO,FileSystemError:X.$hO,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:X.$iO,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$6N,InlineCompletionItem:X.$AN,InlineCompletionList:X.$BN,Hover:X.$fN,VerboseHover:X.$gN,HoverVerbosityAction:X.HoverVerbosityAction,IndentAction:E.IndentAction,Location:X.$cN,MarkdownString:X.$sN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:X.$tN,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$4M,ProcessExecution:X.$MN,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$pO,Range:X.$5M,RelativePattern:X.$2N,Selection:X.$6M,SelectionRange:X.$nN,SemanticTokens:X.$lO,SemanticTokensBuilder:X.$kO,SemanticTokensEdit:X.$mO,SemanticTokensEdits:X.$nO,SemanticTokensLegend:X.$jO,ShellExecution:X.$NN,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$vN,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$uN,SnippetString:X.$bN,SourceBreakpoint:X.$5N,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$jN,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$PN,TaskGroup:X.$LN,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$HN,TerminalQuickFixTerminalCommand:X.$JN,TerminalQuickFixOpener:X.$IN,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$KN,TerminalExitReason:X.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:X.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$0M,SnippetTextEdit:X.$_M,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$1N,ThemeIcon:X.$ZN,TreeItem:X.$QN,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$MO,UIKind:ui.UIKind,Uri:$.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$aN,DocumentPasteTriggerKind:X.DocumentPasteTriggerKind,DocumentDropEdit:X.$WN,DocumentDropOrPasteEditKind:X.$XN,DocumentPasteEdit:X.$YN,InlayHint:X.$xN,InlayHintLabelPart:X.$wN,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$9M,ResolvedAuthority:X.$7M,ManagedResolvedAuthority:X.$8M,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$AO,NotebookRange:X.$sO,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$tO,NotebookData:X.$uO,NotebookRendererScript:X.$yO,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$wO,NotebookCellOutputItem:X.$vO,NotebookCellStatusBarItem:X.$xO,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$$M,NotebookKernelSourceAction:X.$zO,NotebookVariablesRequestKind:X.NotebookVariablesRequestKind,PortAttributes:X.$CO,LinkedEditingRanges:X.$BO,TestResultState:X.TestResultState,TestRunRequest:X.$DO,TestMessage:X.$EO,TestTag:X.$FO,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:X.$VN,DataTransferItem:X.$RN,TestCoverageCount:X.$GO,FileCoverage:X.$IO,FileCoverage2:X.$IO,StatementCoverage:X.$JO,BranchCoverage:X.$KO,DeclarationCoverage:X.$LO,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$NO,TabInputTextDiff:X.$OO,TabInputTextMerge:X.$PO,TabInputCustom:X.$QO,TabInputNotebook:X.$SO,TabInputNotebookDiff:X.$TO,TabInputWebview:X.$RO,TabInputTerminal:X.$UO,TabInputInteractiveWindow:X.$VO,TabInputChat:X.$WO,TabInputTextMultiDiff:X.$XO,TelemetryTrustedValue:f.$sp,LogLevel:c.LogLevel,EditSessionIdentityMatch:m.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,ChatCopyKind:X.ChatCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,DebugStackFrame:X.$_N,DebugThread:X.$aO,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus,TextToSpeechStatus:X.TextToSpeechStatus,PartialAcceptTriggerKind:X.PartialAcceptTriggerKind,KeywordRecognitionStatus:X.KeywordRecognitionStatus,ChatResponseMarkdownPart:X.$ZO,ChatResponseFileTreePart:X.$4O,ChatResponseAnchorPart:X.$5O,ChatResponseProgressPart:X.$6O,ChatResponseProgressPart2:X.$7O,ChatResponseReferencePart:X.$0O,ChatResponseWarningPart:X.$8O,ChatResponseTextEditPart:X.$$O,ChatResponseMarkdownWithVulnerabilitiesPart:X.$1O,ChatResponseCommandButtonPart:X.$9O,ChatResponseDetectedParticipantPart:X.$2O,ChatResponseConfirmationPart:X.$3O,ChatRequestTurn:X.$_O,ChatResponseTurn:X.$aP,ChatLocation:X.ChatLocation,LanguageModelChatMessageRole:X.LanguageModelChatMessageRole,LanguageModelChatMessage:X.$cP,LanguageModelChatMessageFunctionResultPart:X.$bP,LanguageModelChatResponseTextPart:X.$eP,LanguageModelChatResponseFunctionUsePart:X.$dP,LanguageModelChatMessage2:X.$cP,LanguageModelChatSystemMessage:X.$fP,LanguageModelChatUserMessage:X.$gP,LanguageModelChatAssistantMessage:X.$hP,LanguageModelError:X.$iP,NewSymbolName:X.$gO,NewSymbolNameTag:X.NewSymbolNameTag,NewSymbolNameTriggerKind:X.NewSymbolNameTriggerKind,InlineEdit:X.$jP,InlineEditTriggerKind:X.InlineEditTriggerKind}}}}),define(Ee[395],Se([1,0,89,168,48,162,42,35,64,47,101,102,103,126,77,96,161,76,63,125,95,78,160,12,65,123,124,128,129,166,99]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d,a,w,y,S,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ks)(a.$8nc,a.$7nc,r.InstantiationType.Delayed),(0,r.$Ks)(s.$_j,t.$jpc,r.InstantiationType.Delayed),(0,r.$Ks)(c.$anc,c.$bnc,r.InstantiationType.Delayed),(0,r.$Ks)(T.$QP,T.$PP,r.InstantiationType.Eager),(0,r.$Ks)(y.$knc,y.$lnc,r.InstantiationType.Eager),(0,r.$Ks)(S.$2nc,S.$3nc,r.InstantiationType.Eager),(0,r.$Ks)(N.$znc,N.$xnc,r.InstantiationType.Eager),(0,r.$Ks)(f.$Bnc,f.$Anc,r.InstantiationType.Eager),(0,r.$Ks)(P.$foc,P.$goc,r.InstantiationType.Eager),(0,r.$Ks)(E.$koc,E.$ooc,r.InstantiationType.Eager),(0,r.$Ks)(R.$qoc,R.$poc,r.InstantiationType.Eager),(0,r.$Ks)($.$FP,$.$EP,r.InstantiationType.Eager),(0,r.$Ks)(w.$9nc,w.$0nc,r.InstantiationType.Eager),(0,r.$Ks)(m.$enc,m.$dnc,r.InstantiationType.Eager),(0,r.$Ks)(h.$Voc,h.$Uoc,r.InstantiationType.Delayed),(0,r.$Ks)(u.$Goc,u.$Hoc,r.InstantiationType.Eager),(0,r.$Ks)(k.$Unc,k.$Tnc,r.InstantiationType.Eager),(0,r.$Ks)(I.$9oc,I.$8oc,r.InstantiationType.Eager),(0,r.$Ks)(l.$Xnc,l.$1nc,r.InstantiationType.Eager),(0,r.$Ks)(D.$0oc,D.$$oc,r.InstantiationType.Eager),(0,r.$Ks)(b.$4Eb,b.$5Eb,r.InstantiationType.Eager),(0,r.$Ks)(g.$hpc,g.$gpc,r.InstantiationType.Eager),(0,r.$Ks)(A.$wnc,A.$vnc,r.InstantiationType.Eager),(0,r.$Ks)(n.$5nc,n.$4nc,r.InstantiationType.Eager),(0,r.$Ks)(o.$OP,o.$LP,r.InstantiationType.Eager),(0,r.$Ks)(i.$Lnc,i.$Mnc,r.InstantiationType.Eager),(0,r.$Ks)(d.$doc,d.$eoc,r.InstantiationType.Eager)}),define(Ee[130],Se([1,0,19,12,38,100]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0,e.$zpc=N,e.$Apc=T,R=We(R);function N(E){return E.startsWith("**")||E.startsWith("/")?E:`/${E}`}function T(E,u,k,b){const c=(0,r.$2b)(k,$),g=new A.$qL(u,c,b),f=g.preview.matches;return{ranges:(0,r.$2b)(c,l),uri:E,preview:{text:g.preview.text,matches:(0,r.$2b)(f,l)}}}function $(E){return new A.$rL(E.start.line,E.start.character,E.end.line,E.end.character)}function l(E){return new R.$eL(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn)}let I=class{constructor(u,k){this.a=u,this.b=k}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$Bpc=I,e.$Bpc=I=Qe([qe(1,h.$$j)],I)}),define(Ee[396],Se([1,0,58,16,82,33,11,13,130,397]),function(ce,e,r,h,A,R,N,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=E,e.$Dpc=g,e.$Epc=m,r=We(r),h=We(h),R=We(R),T=We(T);const I=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(n,o,i,t,s){const d=u(n,o,i,t,s),a=o.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:a}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:a}}function u(n,o,i,t,s){const d=["--files","--hidden","--case-sensitive","--no-require-git"];b([o],i,!1).forEach(w=>{const y=(0,$.$zpc)(w);if(d.push("-g",y),N.$j){const S=(0,A.$mm)(y);S!==y&&d.push("-g",S)}});const a=k([o],t,void 0,!1);return a.globArgs.forEach(w=>{const y=`!${(0,$.$zpc)(w)}`;if(d.push("-g",y),N.$j){const S=(0,A.$mm)(y);S!==y&&d.push("-g",S)}}),o.disregardIgnoreFiles!==!1?d.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),o.ignoreSymlinks||d.push("--follow"),n.exists&&d.push("--quiet"),s&&d.push("--threads",`${s}`),d.push("--no-config"),o.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:a.siblingClauses}}function k(n,o,i,t=!0){const s=[];let d={};return n.forEach(a=>{const w=Object.assign({},a.excludePattern||{},o||{}),y=c(w,t?a.folder.fsPath:void 0,i);s.push(...y.globArgs),y.siblingClauses&&(d=Object.assign(d,y.siblingClauses))}),{globArgs:s,siblingClauses:d}}function b(n,o,i=!0){const t=[];return n.forEach(s=>{const d=Object.assign({},o||{},s.includePattern||{}),a=c(d,i?s.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function c(n,o,i){const t=[],s={};return Object.keys(n).forEach(d=>{if(i&&i.has(d)||!d)return;const a=n[d];d=f(o?g(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof a=="boolean"&&a?(d.startsWith("\\\\")&&(d+="**"),t.push(m(d))):a&&a.when&&(s[d]=a)}),{globArgs:t,siblingClauses:s}}function g(n,o){return h.$jc(o)?o:h.$kc(n,o)}function f(n){return n=T.$nf(n,"\\"),T.$nf(n,"/")}function m(n){return R.$zg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[398],Se([1,0,58,61,16,399,19,55,39,82,33,11,43,13,18,34,38,396,141]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=e.$Fpc=void 0,r=We(r),h=We(h),A=We(A),N=We(N),$=We($),l=We(l),E=We(E),k=We(k),b=We(b);const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&$.$yk(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=a.shouldGlobMatchFilePattern?null:(0,m.$Kr)(this.b).normalizedLowercase),this.u=a.excludePattern&&$.$yk(a.excludePattern),this.t=new Map,a.folderQueries.forEach(w=>{const y=Object.assign({},w.excludePattern||{},this.a.excludePattern||{}),S=w.folder.fsPath;a.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==S).forEach(D=>{(0,I.$Dg)(D,S)&&(y[A.$mc(S,D)]=!0)}),this.t.set(S,new t(y,S))})}cancel(){this.l=!0,n.forEach(a=>a())}walk(a,w,y,S,D,P){if(this.m=u.$fe.create(!1),this.l)return P(null,this.j);w.forEach(C=>{const p=A.$oc(C.fsPath);this.u&&this.u(C.fsPath,p)||this.J(S,{relativePath:C.fsPath,searchPath:void 0})}),this.r=u.$fe.create(!1),this.w(a,(C,p)=>{this.x(this.y,this,C,y,S,D,v=>{if(v){const O=(0,T.$pj)(v);console.error(O),this.q.push(O),p(v,void 0)}else p(null,void 0)})},(C,p)=>{this.m.stop();const v=C?N.$Ib(C)[0]:null;P(v,this.j)})}w(a,w,y){const S=new Array(a.length),D=new Array(a.length);let P=!1,C=0;if(a.length===0)return y(null,[]);a.forEach((p,v)=>{w(p,(O,L)=>{if(O?(P=!0,S[v]=null,D[v]=O):(S[v]=L,D[v]=null),++C===a.length)return y(P?D:null,S)})})}x(a,w,...y){try{a.apply(w,y)}catch(S){y[y.length-1](S)}}y(a,w,y,S,D){const P=a.folder.fsPath,C=E.$j,p=()=>j&&j.kill();n.add(p);let v=_=>{n.delete(p),v=()=>{},D(_)},O="";const L=this.D(),F=(0,f.$Cpc)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression,w),j=F.cmd,B=!Object.keys(F.siblingClauses).length,M=F.rgArgs.args.map(_=>_.match(/^-/)?_:`'${_}'`).join(" ");let z=`${F.rgDiskPath} ${M}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),S({message:z}),this.s=0,this.z(j,"utf8",S,(_,re,U)=>{if(_){v(_);return}if(this.j){v();return}const K=(O+(C?l.$lm(re||""):re)).split(`
`);if(U){const ee=K.length;K[ee-1]=K[ee-1].trim(),K[ee-1]||K.pop()}else O=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=K.length,B){for(const ee of K)if(this.J(y,{base:P,relativePath:ee,searchPath:this.N(a,ee)}),this.j){p();break}(U||this.j)&&v();return}this.G(a,L,P,K,y),U&&(this.H(L,P,y),v())})}spawnFindCmd(a){const w=this.t.get(a.folder.fsPath),y=w.getBasenameTerms(),S=w.getPathTerms(),D=["-L","."];if(y.length||S.length){D.push("-not","(","(");for(const P of y)D.push("-name",P),D.push("-o");for(const P of S)D.push("-path",P),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),r.spawn("find",D,{cwd:a.folder.fsPath})}readStdout(a,w,y){let S="";this.z(a,w,()=>{},(D,P,C)=>{if(D){y(D);return}S+=P,C&&y(null,S)})}z(a,w,y,S){let D=(p,v,O)=>{(p||O)&&(D=()=>{},this.r?.stop()),S(p,v,O)},P=!1;a.stdout?(this.A(a.stdout,w,D),a.stdout.once("data",()=>P=!0)):y({message:"stdout is null"});let C;a.stderr?C=this.B(a.stderr):y({message:"stderr is null"}),a.on("error",p=>{D(p)}),a.on("close",p=>{let v;!P&&(v=this.C(C,w))&&s(v)?D(new Error(`command failed with error code ${p}: ${this.C(C,w)}`)):(this.g&&p===0&&(this.j=!0),D(null,"",!0))})}A(a,w,y){const S=new R.StringDecoder(w);return a.on("data",D=>{y(null,S.write(D))}),S}B(a){const w=[];return a.on("data",y=>{w.push(y)}),w}C(a,w){const y=new R.StringDecoder(w);return a.map(S=>y.write(S)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:w},y,S,D){S.indexOf(this.b)!==-1&&this.J(D,{base:y,relativePath:this.b,searchPath:this.N(a,this.b)});const P=C=>{const p=A.$oc(C),v=A.$nc(C);let O=w[v];O||(O=w[v]=[],P(v)),O.push({base:y,relativePath:C,basename:p,searchPath:this.N(a,C)})};S.forEach(P)}H({rootEntries:a,pathToEntries:w},y,S){const D=this,P=this.t.get(y),C=this.b;function p(v){D.o++;const O=(0,g.$GL)(()=>v.map(L=>L.basename));for(let L=0,F=v.length;L<F;L++){const j=v[L],{relativePath:B,basename:M}=j;if(P.test(B,M,C!==M?O:void 0))continue;const z=w[B];if(z)p(z);else{if(D.p++,B===C)continue;D.J(S,j)}if(D.j)break}}p(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,w,y,S,D){const P=a.folder,C=(0,g.$GL)(()=>y);this.w(y,(p,v)=>{if(this.l||this.j)return v(null);const O=w?[w,p].join(A.sep):p;if(this.t.get(a.folder.fsPath).test(O,p,this.a.filePattern!==p?C:void 0))return v(null);const L=[P.fsPath,O].join(A.sep);h.lstat(L,(F,j)=>{if(F||this.l||this.j)return v(null);this.L(L,j,(B,M)=>B||this.l||this.j?v(null):M.isDirectory()?(this.o++,this.M(L,j,(z,_)=>z||this.l||this.j||(_=_||"",this.v[_])?v(null):(this.v[_]=!0,c.Promises.readdir(L).then(re=>{if(this.l||this.j)return v(null);this.I(a,O,re,S,U=>v(U||null))},re=>{v(null)})))):(this.p++,O===this.b||this.h&&b.$ig(M.size)&&M.size>this.h||this.J(S,{base:P.fsPath,relativePath:O,searchPath:this.N(a,O)}),v(null,void 0)))})},p=>{const v=p&&N.$Ib(p);return D(v&&v.length>0?v[0]:void 0)})}J(a,w){this.K(w)&&(!this.d||this.d(w.relativePath,A.$oc(w.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(w))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$BL)(a,this.c);if(this.b)return(0,g.$BL)(a,this.b,!1)}return!0}L(a,w,y){return w.isSymbolicLink()?h.stat(a,y):y(null,w)}M(a,w,y){return w.isSymbolicLink()?h.realpath(a,(S,D)=>S?y(S):y(null,D)):y(null,a)}N(a,w){return a.folderName?A.$kc(a.folderName,w):w}}e.$Fpc=o;class i{constructor(a,w){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.d=w,this.c=new o(a)}search(a,w,y){this.c.walk(this.a,this.b,this.d,a,w,(S,D)=>{y(S,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Gpc=i;class t{constructor(a,w){this.expression=a,this.c=w,this.d(a)}d(a){let w,y;Object.keys(a).filter(S=>a[S]).forEach(S=>{A.$jc(S)?(w=w||$.$tk(),w[S]=a[S]):(y=y||$.$tk(),y[S]=a[S])}),this.a=w&&$.$yk(w,{trimForExclusions:!0}),this.b=y&&$.$yk(y,{trimForExclusions:!0})}test(a,w,y){return this.b&&this.b(a,w,y)||this.a&&this.a(A.$kc(this.c,a),w,y)}getBasenameTerms(){const a=[];return this.a&&a.push(...$.$Ak(this.a)),this.b&&a.push(...$.$Ak(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...$.$Bk(this.a)),this.b&&a.push(...$.$Bk(this.b)),a}}function s(d){const a=d.trim().split(`
`),w=a[0].trim();if(w.startsWith("Error parsing regex"))return w;if(w.startsWith("regex parse error"))return k.$9f(a[a.length-1].trim());if(w.startsWith("error parsing glob")||w.startsWith("unsupported encoding"))return w.charAt(0).toUpperCase()+w.substr(1);if(w==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(w.startsWith("Literal "))return w}}),define(Ee[400],Se([1,0,104,22,207,21,19]),function(ce,e,r,h,A,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GE=e.$FE=e.$xE=e.DecodeStreamErrorKind=e.$wE=e.$vE=e.$uE=e.$sE=e.$rE=e.$qE=e.$pE=void 0,e.$tE=T,e.$yE=c,e.$zE=g,e.$AE=f,e.$BE=m,e.$CE=n,e.$DE=y,e.$EE=S,e.$pE="utf8",e.$qE="utf8bom",e.$rE="utf16be",e.$sE="utf16le";function T(D){return[e.$pE,e.$qE,e.$rE,e.$sE].some(P=>P===D)}e.$uE=[254,255],e.$vE=[255,254],e.$wE=[239,187,191];const $=512,l=512,I=512*8,E=512*128;var u;(function(D){D[D.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class k extends Error{constructor(P,C){super(P),this.decodeStreamErrorKind=C}}e.$xE=k;class b{static async create(P){let C;if(P!==e.$pE)C=(await(0,A.$oE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(m(P));else{const p=new TextDecoder;C={write(v){return p.decode(v,{stream:!0})},end(){return p.decode()}}}return new b(C)}constructor(P){this.a=P}write(P){return this.a.write(P)}end(){return this.a.end()}}function c(D,P){const C=P.minBytesRequiredForDetection??P.guessEncoding?I:l;return new Promise((p,v)=>{const O=(0,r.$Be)(z=>z.join("")),L=[];let F=0,j;const B=new R.$we,M=async()=>{try{const z=await S({buffer:h.$Ne.concat(L),bytesRead:F},P.guessEncoding,P.candidateGuessEncodings);if(z.seemsBinary&&P.acceptTextOnly)throw new k("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);z.encoding=await P.overwriteEncoding(z.encoding),j=await b.create(z.encoding);const _=j.write(h.$Ne.concat(L).buffer);O.write(_),L.length=0,F=0,p({stream:O,detected:z})}catch(z){B.cancel(),O.destroy(),v(z)}};(0,r.$Fe)(D,{onData:async z=>{j?O.write(j.write(z.buffer)):(L.push(z),F+=z.byteLength,F>=C&&(D.pause(),await M(),setTimeout(()=>D.resume())))},onError:z=>O.error(z),onEnd:async()=>{j||await M(),O.end(j?.end())}},B.token)})}async function g(D,P,C){const v=(await(0,A.$oE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(m(P),C);let O=!1,L=!1;return{read(){if(L)return null;const F=D.read();if(typeof F!="string"){if(L=!0,!O&&C?.addBOM)switch(P){case e.$pE:case e.$qE:return h.$Ne.wrap(Uint8Array.from(e.$wE));case e.$rE:return h.$Ne.wrap(Uint8Array.from(e.$uE));case e.$sE:return h.$Ne.wrap(Uint8Array.from(e.$vE))}const j=v.end();return j&&j.length>0?(O=!0,h.$Ne.wrap(j)):null}return O=!0,h.$Ne.wrap(v.write(F))}}}async function f(D){return(await(0,A.$oE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(m(D))}function m(D){return D===e.$qE||D===null?e.$pE:D}function n(D,P){if(!D||P<e.$uE.length)return null;const C=D.readUInt8(0),p=D.readUInt8(1);if(C===e.$uE[0]&&p===e.$uE[1])return e.$rE;if(C===e.$vE[0]&&p===e.$vE[1])return e.$sE;if(P<e.$wE.length)return null;const v=D.readUInt8(2);return C===e.$wE[0]&&p===e.$wE[1]&&v===e.$wE[2]?e.$qE:null}const o=["ascii","utf-16","utf-32"];async function i(D,P){const C=await(0,A.$oE)("jschardet","dist/jschardet.min.js"),p=D.slice(0,E),v=w(p.buffer);P&&(P=(0,N.$Ib)(P.map(F=>a(F))),P.length===0&&(P=void 0));const O=C.detect(v,P?{detectEncodings:P}:void 0);if(!O||!O.encoding)return null;const L=O.encoding.toLowerCase();return 0<=o.indexOf(L)?null:d(O.encoding)}const t={ibm866:"cp866",big5:"cp950"};function s(D){return D.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(D){const P=s(D);return t[P]||P}function a(D){const P=s(D);return e.$GE[P].guessableName}function w(D){let P="";for(let C=0;C<D.length;C++)P+=String.fromCharCode(D[C]);return P}function y(D){switch(D){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const P=D.match(/windows(\d+)/);return P?"windows-"+P[1]:D}}}function S({buffer:D,bytesRead:P},C,p){let v=n(D,P),O=!1;if(v!==e.$rE&&v!==e.$sE&&D){let L=!0,F=!0,j=!1;for(let B=0;B<P&&B<$;B++){const M=B%2===1,z=D.readUInt8(B)===0;if(z&&(j=!0),L&&(M&&!z||!M&&z)&&(L=!1),F&&(M&&z||!M&&!z)&&(F=!1),z&&!L&&!F)break}j&&(L?v=e.$sE:F?v=e.$rE:O=!0)}return C&&!O&&!v&&D?i(D.slice(0,P),p).then(L=>({seemsBinary:!1,encoding:L})):{seemsBinary:O,encoding:v}}e.$FE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$GE=(()=>{const D={};for(const P in e.$FE)e.$FE[P].guessableName&&(D[P]=e.$FE[P]);return D})()}),define(Ee[171],Se([1,0,400,34,170]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0,h=We(h);class R extends A.$Coc{constructor(T,$,l=h,I="searchProcess"){super({query:T,provider:$},{readdir:E=>l.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,r.$DE)(E)},I)}}e.$Opc=R}),define(Ee[172],Se([1,0,58,415,399,19,79,39,13,2,38,100,416,397,130]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=e.$Hpc=void 0,e.$Jpc=t,e.$Kpc=d,e.$Lpc=w,e.$Mpc=y,e.$Npc=D,r=We(r);const c=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(C,p){this.a=C,this.b=p}provideTextSearchResults(C,p,v,O){return this.a.appendLine(`provideTextSearchResults ${C.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((L,F)=>{O.onCancellationRequested(()=>K());const j={...p,numThreads:this.b},B=t(C,j),M=p.folder.fsPath,z=B.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${c} ${z}
 - cwd: ${M}`);let _=r.spawn(c,B,{cwd:M});_.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),F((0,I.$xL)(new I.$vL($e&&$e.message,I.SearchErrorCode.rgProcessError)))});let re=!1;const U=new n(p.maxResults,p.folder,p.previewOptions);U.on("result",$e=>{re=!0,ue="",v.report($e)});let G=!1;const K=()=>{G=!0,_?.kill(),U?.cancel()};let ee=!1;U.on("hitLimit",()=>{ee=!0,K()});let ue="";_.stdout.on("data",$e=>{U.handleData($e),re||(ue+=$e)});let ne=!1;_.stdout.once("data",()=>ne=!0);let De="";_.stderr.on("data",$e=>{const J=$e.toString();this.a.appendLine(J),De.length+J.length<1e6&&(De+=J)}),_.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(re?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),G)L({limitHit:ee});else{U.flush(),_=null;let $e;De&&!ne&&($e=f(De))?F((0,I.$xL)(new I.$vL($e.message,$e.code))):L({limitHit:ee})}})})}}e.$Hpc=g;function f(P){const C=P.split(`
`),p=C[0].trim();if(C.some(O=>O.startsWith("regex parse error")))return new I.$vL(m(C),I.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$vL(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new I.$vL(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new I.$vL(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new I.$vL(p,I.SearchErrorCode.regexParseError)}function m(P){const C=["Regex parse error"],p=P.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const O=v.split(":")[1];C.push(":"+O)}}return C.join("")}class n extends h.EventEmitter{constructor(C,p,v){super(),this.g=C,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(C,p){return super.on(C,p),this}handleData(C){if(this.b)return;const p=typeof C=="string"?C:this.d.write(C);this.k(p)}k(C){let p=C.indexOf(`
`);const v=this.a+C;if(p>=0)p+=this.a.length;else{this.a=v;return}let O=0;for(;p>=0;)this.m(v.substring(O,p).trim()),O=p+1,p=v.indexOf(`
`,O);this.a=v.substring(O)}m(C){if(this.b||!C)return;let p;try{p=JSON.parse(C)}catch{throw new Error(`malformed line from rg: ${C}`)}if(p.type==="match"){const v=o(p.data.path),O=l.URI.joinPath(this.h,v),L=this.n(p.data,O);this.p(L),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=o(p.data.path),O=l.URI.joinPath(this.h,v);this.o(p.data,O).forEach(F=>this.p(F))}}n(C,p){const v=C.line_number-1,O=o(C.lines),L=Buffer.from(O);let F=0,j=0,B=v;C.submatches.length===0&&C.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.$Ib)(C.submatches.map((z,_)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=o(z.match),U=L.slice(F,z.start).toString(),G=i(U),K=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=i(re),ue=G.numLines+B,ne=ee.numLines+ue,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+K;return F=z.end,j=De,B=ne,new E.$eL(ue,K,ne,De)}));return(0,b.$Apc)(p,O,M,this.j)}o(C,p){const v=o(C.lines),O=C.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((L,F)=>({text:L,uri:p,lineNumber:O+F}))}p(C){this.emit("result",C)}}e.$Ipc=n;function o(P){return P.bytes?Buffer.from(P.bytes,"base64").toString():P.text}function i(P){const C=/\n/g;let p=0,v=-1,O;for(;O=C.exec(P);)p++,v=O.index;const L=v>=0?P.length-v-1:P.length;return{numLines:p,lastLineLength:L}}function t(P,C){const p=["--hidden","--no-require-git"];p.push(P.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:O}=(0,N.$K)(C.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const F=new Set;O.forEach(j=>{F.add(j)}),p.push("-g","!*"),F.forEach(j=>{s(j).map(b.$zpc).forEach(B=>{p.push("-g",B)})})}v&&v.length&&v.forEach(F=>{p.push("-g",F)}),C.excludes.map(b.$zpc).forEach(F=>p.push("-g",`!${F}`)),C.maxFileSize&&p.push("--max-filesize",C.maxFileSize+""),C.useIgnoreFiles?C.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),C.followSymlinks&&p.push("--follow"),C.encoding&&C.encoding!=="utf8"&&p.push("--encoding",C.encoding),C.numThreads&&p.push("--threads",`${C.numThreads}`),P.pattern==="--"&&(P.isRegExp=!0,P.pattern="\\-\\-"),P.isMultiline&&!P.isRegExp&&(P.pattern=(0,$.$hf)(P.pattern),P.isRegExp=!0),C.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),P.isRegExp&&(P.pattern=d(P.pattern),p.push("--engine","auto"));let L;if(P.isWordMatch){const j=(0,$.$qf)(P.pattern,!!P.isRegExp,{wholeWord:P.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(P.isRegExp){let F=w(P.pattern);F=y(F),p.push("--regexp",F)}else L=P.pattern,p.push("--fixed-strings");return p.push("--no-config"),C.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),P.isMultiline&&p.push("--multiline"),C.beforeContext&&p.push("--before-context",C.beforeContext+""),C.afterContext&&p.push("--after-context",C.afterContext+""),p.push("--"),L&&p.push(L),p.push("."),p}function s(P){return D(P).flatMap(p=>{const v=(0,T.$wk)(p,"/");return v.map((O,L)=>v.slice(0,L+1).join("/"))})}function d(P){const C=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;P.match(C);)P=P.replace(C,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;P.match(p);)P=P.replace(p,"$1\\x{$2}");return P}const a=P=>P.type==="Assertion"&&P.kind==="lookbehind";function w(P){let C;try{C=new u.RegExpParser().parsePattern(P)}catch{return P}let p="",v=0;const O=(j,B,M)=>{p+=P.slice(v,j)+M,v=B},L=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const B=L[0];if(!B)O(j.start,j.end,"\\r?\\n");else if(!L.some(a))if(B.type==="CharacterClass")if(B.negate){const M=P.slice(B.start+2,j.start)+P.slice(j.end,B.end-1);B.parent?.type==="Quantifier"?O(B.start,B.end,M?`[^${M}]`:"."):O(B.start,B.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=P.slice(B.start+1,j.start)+P.slice(j.end,B.end-1);O(B.start,B.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else B.type==="Quantifier"&&O(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){L.unshift(j)},onQuantifierLeave(){L.shift()},onCharacterClassRangeEnter(j){L.unshift(j)},onCharacterClassRangeLeave(){L.shift()},onCharacterClassEnter(j){L.unshift(j)},onCharacterClassLeave(){L.shift()},onAssertionEnter(j){a(j)&&L.push(j)},onAssertionLeave(j){L[0]===j&&L.shift()}}).visit(C),p+=P.slice(v),p}function y(P){return P.replace(/\n/g,"\\r?\\n")}function S(P){let C=!1,p=!1,v="",O="";for(let L=0;L<P.length;L++){const F=P[L];switch(F){case"\\":p?(C?O+="\\"+F:v+="\\"+F,p=!1):p=!0;break;case"{":if(p)C?O+=F:v+=F,p=!1;else{if(C)return{strInBraces:v+"{"+O+"{"+P.substring(L+1)};C=!0}break;case"}":if(p)C?O+=F:v+=F,p=!1;else{if(C)return{fixedStart:v,strInBraces:O,fixedEnd:P.substring(L+1)};v+=F}break;default:C?O+=(p?"\\":"")+F:v+=(p?"\\":"")+F,p=!1;break}}return{strInBraces:v+(C?"{"+O:"")}}function D(P){const{fixedStart:C,strInBraces:p,fixedEnd:v}=S(P);if(C===void 0||v===void 0)return[p];let O=(0,T.$wk)(p,",");O.length||(O=[""]);const L=D(v);return O.flatMap(F=>{const j=C+F;return L.map(B=>j+B)})}}),define(Ee[401],Se([1,0,21,172,90,15]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0;class N{constructor(l,I){this.b=l,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(l,I,E,u){const k=await this.c(),b=new h.$Hpc(this.b,k),c={...I,numThreads:k};if(I.folder.scheme===R.Schemas.vscodeUserData){const g={...c,folder:I.folder.with({scheme:R.Schemas.file})},f=new A.$rw(m=>E.report({...m,uri:m.uri.with({scheme:I.folder.scheme})}));return this.d(u,m=>b.provideTextSearchResults(l,g,f,m))}else return this.d(u,g=>b.provideTextSearchResults(l,c,E,g))}async d(l,I){const E=T(l);this.a.add(E);const u=await I(E.token);return this.a.delete(E),u}e(){this.a.forEach(l=>l.cancel())}}e.$Rpc=N;function T($){const l=new r.$we;return $.onCancellationRequested(()=>l.cancel()),l}}),define(Ee[402],Se([1,0,34,172,171]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0,r=We(r);class R{constructor($,l){this.a=$,this.b=l}search($,l,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const E={appendLine(k){I({message:k})}},u=new A.$Opc(this.a,new h.$Hpc(E,this.b),r);return new Promise((k,b)=>u.search(c=>{l(c.map(N))},$).then(c=>k({limitHit:c.limitHit??!1,type:"success",stats:c.stats,messages:[]}),b))}}e.$Ppc=R;function N(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce(($,l)=>{if(l.ranges){const I=l;return $+(Array.isArray(I.ranges)?I.ranges.length:1)}else return $+1},0)}}}),define(Ee[403],Se([1,0,19,9,14,4,141,16,43,2,28,38,398,402]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,r=We(r);class b{static{this.a=512}constructor(o="searchProcess",i){this.d=o,this.f=i,this.b=Object.create(null)}fileSearch(o){let i;const t=f(o),s=new R.$le({onDidAddFirstListener:()=>{i=(0,h.$rh)(async d=>{const a=await this.f?.();return this.doFileSearchWithEngine(u.$Gpc,t,w=>s.fire(w),d,b.a,a)}),i.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}textSearch(o){let i;const t=f(o),s=new R.$le({onDidAddFirstListener:()=>{i=(0,h.$rh)(d=>this.g(t,a=>s.fire(a),d)),i.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}async g(o,i,t){o.maxFileSize=this.h().maxFileSize;const s=await this.f?.();return new k.$Ppc(o,s).search(t,i,i)}h(){return{maxFileSize:16*I.$Gl.GB}}doFileSearch(o,i,t,s){return this.doFileSearchWithEngine(u.$Gpc,o,t,s,b.a,i)}doFileSearchWithEngine(o,i,t,s,d=b.a,a){let w=0;const y=D=>{Array.isArray(D)?(w+=D.length,t(D.map(P=>this.j(P)))):D.relativePath?(w++,t(this.j(D))):t(D)};if(i.sortByScore){let D=this.n(i,y,s);if(!D){const P=i.maxResults?Object.assign({},i,{maxResults:null}):i,C=new o(P,a);D=this.k(C,i,t,y,s)}return new Promise((P,C)=>{D.then(([p,v])=>{const O=v.map(L=>this.j(L));this.q(O,t,d),P(p)},C)})}const S=new o(i,a);return this.s(S,y,d,s).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.d,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,T.$kc)(o.base,o.relativePath):o.relativePath}}k(o,i,t,s,d){const a=new R.$le;let w=(0,h.$rh)(S=>{let D=[];const P=C=>{Array.isArray(C)?D=C:(s(C),a.fire(C))};return this.s(o,P,-1,S).then(C=>[C,D])}),y;if(i.cacheKey){y=this.l(i.cacheKey);const S={promise:w,event:a.event,resolved:!1};y.resultsToSearchCache[i.filePattern||""]=S,w.then(()=>{S.resolved=!0},D=>{delete y.resultsToSearchCache[i.filePattern||""]}),w=this.t(w)}return w.then(([S,D])=>{const P=y?y.scorerCache:Object.create(null),C=(typeof i.maxResults!="number"||i.maxResults>0)&&$.$fe.create(!1);return this.o(i,D,P,d).then(p=>{const v=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:S.messages,limitHit:S.limitHit||typeof i.maxResults=="number"&&D.length>i.maxResults},p]})})}l(o){const i=this.b[o];return i||(this.b[o]=new c)}n(o,i,t){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const d=this.r(s,o.filePattern||"",i,t);if(d)return d.then(([a,w,y])=>{const S=$.$fe.create(!1);return this.o(o,w,s.scorerCache,t).then(D=>{const P=S.elapsed(),C={fromCache:!0,detailStats:y,type:this.d,resultCount:w.length,sortingTime:P};return[{type:"success",limitHit:a.limitHit||typeof o.maxResults=="number"&&w.length>o.maxResults,stats:C,messages:[]},D]})})}o(o,i,t,s){const d=(0,N.$Kr)(o.filePattern||""),a=(y,S)=>(0,N.$Jr)(y,S,d,!0,g,t),w=typeof o.maxResults=="number"?o.maxResults:E.$kL;return r.$Hb(i,a,w,1e4,s)}q(o,i,t){if(t&&t>0)for(let s=0;s<o.length;s+=t)i(o.slice(s,s+t));else i(o)}r(o,i,t,s){const d=$.$fe.create(!1),a=i.indexOf(T.sep)>=0;let w;for(const P in o.resultsToSearchCache)if(i.startsWith(P)){if(a&&P.indexOf(T.sep)<0&&P!=="")continue;const C=o.resultsToSearchCache[P];w={promise:this.t(C.promise),event:C.event,resolved:C.resolved};break}if(!w)return null;const y=d.elapsed(),S=$.$fe.create(!1),D=w.event(t);return s&&s.onCancellationRequested(()=>{D.dispose()}),w.promise.then(([P,C])=>{if(s&&s.isCancellationRequested)throw(0,A.$7)();const p=[],v=(0,N.$Kr)(i).normalizedLowercase;for(const O of C)(0,E.$BL)(O,v)&&p.push(O);return[P,p,{cacheWasResolved:w.resolved,cacheLookupTime:y,cacheFilterTime:S.elapsed(),cacheEntryCount:C.length}]})}s(o,i,t,s){return new Promise((d,a)=>{let w=[];s?.onCancellationRequested(()=>o.cancel()),o.search(y=>{y&&(t?(w.push(y),t>0&&w.length>=t&&(i(w),w=[])):i(y))},y=>{i(y)},(y,S)=>{w.length&&i(w),y?(i({message:"Search finished. Error: "+y.message}),a(y)):(i({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),d(S))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,t){return o.then(i,t)}catch(i){return this.then(void 0,i)}finally(i){return o.finally(i)}}}}e.$Qpc=b;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(n){return(0,T.$oc)(n.relativePath)}getItemDescription(n){return(0,T.$nc)(n.relativePath)}getItemPath(n){return n.relativePath}};function f(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(m),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>l.URI.revive(o))}}function m(n){return{...n,folder:l.URI.revive(n.folder)}}}),define(Ee[404],Se([1,0,3,15,2,34,12,42,30,20,103,73,38,403,401,130,171]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0,R=We(R);let f=class extends I.$Hoc{constructor(n,o,i,t,s){super(n,i,s),this.D=t,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Uc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new c.$Bpc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new b.$Rpc(d,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),t.getConfigProvider().then(a=>{this.C||this.B.add(a.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new c.$Bpc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new b.$Rpc(n,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new k.$Qpc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const i=this.d++;return this.y=o,this.x=i,this.c.$registerFileSearchProvider(i,this.s(n)),(0,r.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(i)})}$provideFileSearchResults(n,o,i,t){const s=(0,I.$Ioc)(i);if(n===this.x){const d=Date.now();return this.H(n,o,s,t).then(a=>{const w=Date.now()-d;return this.q.debug(`Ext host file search time: ${w}ms`),a})}return super.$provideFileSearchResults(n,o,i,t)}async doInternalFileSearchWithCustomCallback(n,o,i){const t=d=>{if((0,u.$AL)(d)&&(d=[d]),Array.isArray(d)){i(d.map(a=>A.URI.file(a.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const s=await this.getNumThreadsCached();return this.y.doFileSearch(n,s,t,o)}async H(n,o,i,t){return this.doInternalFileSearchWithCustomCallback(i,t,s=>{this.c.$handleFileMatch(n,o,s)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new g.$Opc(n,o,void 0,"textSearchProvider")}};e.$Spc=f,e.$Spc=f=Qe([qe(0,l.$uP),qe(1,$.$KP),qe(2,E.$tnc),qe(3,T.$znc),qe(4,N.$$j)],f)}),define(Ee[131],Se([1,0,417,67,68,418,22,14,4,3,16,11,32,87,69]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$vi=e.$ui=e.$ti=void 0,e.$wi=a,e.$xi=w,e.$zi=D,e.$Ai=P;const c=3e4;class g{traceSocketEvent(p,v){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,T.$2)(L)}},this.socket.on("error",this.a);let O;this.b=L=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:L}),this.f=!1,O&&clearTimeout(O)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,O=setTimeout(()=>p.destroy(),c)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=O=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,O),p(N.$Ne.wrap(O))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=O=>{p({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:O,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,T.$2)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,T.$2)(v)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.$ti=g;var f;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var m;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(m||(m={}));class n extends l.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,O,L){super(),this.f=this.B(new $.$le),this.g=this.B(new $.$le),this.h=!1,this.j={state:m.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:O?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new o(this,v,O,L,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,T.$2)(F),this.g.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new b.$oi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+f.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:O}){if(this.h)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let L=f.MinHeaderByteSize;p.byteLength<126?L+=0:p.byteLength<2**16?L+=2:L+=8;const F=N.$Ne.alloc(L),j=v?64:0,B=O&15;if(F.writeUInt8(128|j|B,0),p.byteLength<126)F.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){F.writeUInt8(126,1);let M=1;F.writeUInt8(p.byteLength>>>8&255,++M),F.writeUInt8(p.byteLength>>>0&255,++M)}else{F.writeUInt8(127,1);let M=1;F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(p.byteLength>>>24&255,++M),F.writeUInt8(p.byteLength>>>16&255,++M),F.writeUInt8(p.byteLength>>>8&255,++M),F.writeUInt8(p.byteLength>>>0&255,++M)}this.socket.write(N.$Ne.concat([F,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===m.PeekHeader){const v=this.b.peek(this.j.readLen),O=v.readUInt8(0),L=(O&128)>>>7,F=(O&64)>>>6,j=O&15,B=v.readUInt8(1),M=(B&128)>>>7,z=B&127;this.j.state=m.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(M?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!L,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===m.ReadHeader){const v=this.b.read(this.j.readLen),O=v.readUInt8(1),L=(O&128)>>>7;let F=O&127,j=1;F===126?F=v.readUInt8(++j)*2**8+v.readUInt8(++j):F===127&&(F=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let B=0;L&&(B=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=m.ReadBody,this.j.readLen=F,this.j.mask=B,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===m.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),s(v,this.j.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=m.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$ui=n;class o extends l.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Ne.alloc(0)}constructor(p,v,O,L,F,j){super(),this.n=p,this.r=F,this.s=j,this.a=this.B(new $.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new i(this.n,L,O,{windowBits:15})),this.f=this.B(new t(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const O=await this.w(this.f,p);this.s(O,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((O,L)=>{p.write(v),p.flush(F=>O(F))})}acceptFrame(p,v,O){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:O}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,O){return new Promise((L,F)=>{p.write(v),O&&p.write(N.$Ne.fromByteArray([0,0,255,255])),p.flush(j=>L(j))})}}class i extends l.$Vc{get recordedInflateBytes(){return this.j?N.$Ne.concat(this.f):N.$Ne.alloc(0)}constructor(p,v,O,L){super(),this.h=p,this.j=v,this.a=this.B(new $.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(L),this.b.on("error",F=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(N.$Ne.wrap(F))}),O&&(this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,O.buffer),this.b.write(O.buffer),this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=N.$Ne.concat(this.g);this.g.length=0,p(v)})}}class t extends l.$Vc{constructor(p,v){super(),this.g=p,this.a=this.B(new $.$le),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",O=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,O),this.f.push(N.$Ne.wrap(O))})}write(p){this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=N.$Ne.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function s(C,p){if(p===0)return;const v=C.byteLength>>>2;for(let M=0;M<v;M++){const z=C.readUInt32BE(M*4);C.writeUInt32BE(z^p,M*4)}const O=v*4,L=C.byteLength-O,F=p>>>24&255,j=p>>>16&255,B=p>>>8&255;L>=1&&C.writeUInt8(C.readUInt8(O)^F,O),L>=2&&C.writeUInt8(C.readUInt8(O+1)^j,O+1),L>=3&&C.writeUInt8(C.readUInt8(O+2)^B,O+2)}e.$vi=process.env.XDG_RUNTIME_DIR;const d={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function a(){const C=(0,u.$1g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const p=process.platform!=="darwin"&&e.$vi?e.$vi:(0,A.tmpdir)(),v=(0,I.$kc)(p,`vscode-ipc-${C}.sock`);return y(v),v}function w(C,p,v){const L=(0,r.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${v}-${p}-sock`;const F=v.substr(0,4),j=p.substr(0,6);let B;return process.platform!=="darwin"&&e.$vi&&!process.env.VSCODE_PORTABLE?B=(0,I.$kc)(e.$vi,`vscode-${L}-${F}-${j}.sock`):B=(0,I.$kc)(C,`${F}-${j}.sock`),y(B),B}function y(C){const p=d[E.$u];typeof p=="number"&&C.length>=p&&console.warn(`WARNING: IPC handle "${C}" is longer than ${p} chars, try a shorter --user-data-dir`)}class S extends k.$ii{static b(p){const v=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(v,O=>({protocol:new b.$pi(new g(O,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(O,"close"))}))}constructor(p){super(S.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$yi=S;function D(C){return new Promise((p,v)=>{const O=(0,h.createServer)();O.on("error",v),O.listen(C,()=>{O.removeListener("error",v),p(new S(O))})})}function P(C,p){return new Promise((v,O)=>{const L=(0,h.createConnection)(C,()=>{L.removeListener("error",O),v(b.$qi.fromSocket(new g(L,`ipc-client${p}`),p))});L.once("error",O)})}}),define(Ee[405],Se([1,0,67,68,187,131,9,3,11,45,12,116,284,285,118,93,22]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=e.$Ffc=e.$Efc=void 0,r=We(r),h=We(h);async function f(t,s,d,a,w){let y;for(let S=3;S&&(y?.dispose(),y=await new m(t,s,d,a,w).waitForReady(),!(w&&A.$4g[w]||!A.$4g[y.tunnelLocalPort]));S--);return y}class m extends T.$Vc{constructor(s,d,a,w,y){super(),this.m=d,this.n=y,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new N.$Dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=w,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,c.$Ew)(this.m)?"0.0.0.0":"127.0.0.1";let a=await(0,A.$5g)(s,2,1e3,d),w=null;return this.b.listen(a,this.m),await this.c.wait(),w=this.b.address(),w||(a=0,this.b.listen(a,this.m),await this.c.wait(),w=this.b.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async r(s){s.pause();const d=(0,c.$Cw)(this.tunnelRemoteHost)||(0,c.$Ew)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,u.$1l)(this.a,d,this.tunnelRemotePort),w=a.getSocket(),y=a.readEntireBuffer();a.dispose(),y.byteLength>0&&s.write(y.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),w.end()}),s.on("close",()=>w.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),w instanceof R.$ti?w.socket.destroy():w.end()}),w instanceof R.$ti?this.t(s,w):this.s(s,w),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),w.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(a=>s.write(a.buffer)),s.on("data",a=>d.write(g.$Ne.wrap(a))),s.resume()}t(s,d){const a=d.socket;a.on("end",()=>s.end()),a.on("close",()=>s.end()),a.on("error",()=>{s.destroy()}),a.pipe(s),s.pipe(a)}}e.$Efc=m;let n=class extends c.$Hw{constructor(s,d,a,w,y){super(d,y),this.H=s,this.I=a,this.J=w}isPortPrivileged(s){return(0,c.$Fw)(s,this.t,$.OS,h.release())}F(s,d,a,w,y,S,D,P){const C=this.D(d,a);if(C)return++C.refcount,C.value;if((0,c.$yw)(s))return this.G(s,d,a,y,S,D,P);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${a} on local port ${y}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(p,w,d,a,y);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,a,v),v}}};e.$Ffc=n,e.$Ffc=n=Qe([qe(0,k.$Ul),qe(1,I.$$j),qe(2,b.$Xl),qe(3,E.$rk),qe(4,l.$$i)],n);let o=class extends n{constructor(s,d,a,w,y){super(s,d,a,w,y)}};e.$Gfc=o,e.$Gfc=o=Qe([qe(0,k.$Ul),qe(1,I.$$j),qe(2,b.$Xl),qe(3,E.$rk),qe(4,l.$$i)],o);let i=class extends T.$Vc{constructor(s,d,a,w,y){super(),this.b=s,this.c=d,this.f=a,this.g=w,this.h=y,this.a=new Map}async openTunnel(s,d,a,w,y,S,D,P,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${w} on local port ${S}.`),!this.a.has(s)){const p=new o(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(s,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,a,w,y,S,D,P,C)}};e.$Hfc=i,e.$Hfc=i=Qe([qe(0,k.$Ul),qe(1,I.$$j),qe(2,E.$rk),qe(3,b.$Xl),qe(4,l.$$i)],i)}),define(Ee[406],Se([1,0,131,302,61,35,2,12,46]),function(ce,e,r,h,A,R,N,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0,h=We(h),A=We(A);class l{constructor(u,k,b){this.b=u,this.c=k,this.f=b,this.a=h.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(k.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,k){const b=(g,f)=>{k.writeHead(g,{"content-type":"application/json"}),k.end(JSON.stringify(f||null),m=>m&&this.c.error(m))},c=[];u.setEncoding("utf8"),u.on("data",g=>c.push(g)),u.on("end",async()=>{try{const g=JSON.parse(c.join(""));let f;switch(g.type){case"open":f=await this.i(g);break;case"openExternal":f=await this.j(g);break;case"status":f=await this.l(g);break;case"extensionManagement":f=await this.k(g);break;default:b(404,`Unknown message type: ${g.type}`);break}b(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);b(500,f),this.c.error("Error while processing pipe request",g)}})}async i(u){const{fileURIs:k,folderURIs:b,forceNewWindow:c,diffMode:g,mergeMode:f,addMode:m,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:i,remoteAuthority:t}=u,s=[];if(Array.isArray(b))for(const y of b)try{s.push({folderUri:N.URI.parse(y)})}catch{}if(Array.isArray(k))for(const y of k)try{(0,$.$0i)(y)?s.push({workspaceUri:N.URI.parse(y)}):s.push({fileUri:N.URI.parse(y)})}catch{}const d=i?N.URI.file(i):void 0,w={forceNewWindow:c,diffMode:g,mergeMode:f,addMode:m,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!m,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,w)}async j(u){for(const k of u.uris){const b=N.URI.parse(k),c=b.scheme==="file"?b:k;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(u){const k=c=>c?.map(g=>/\.vsix$/i.test(g)?N.URI.parse(g):g),b={list:u.list,install:k(u.install),uninstall:k(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",b)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$VP=l;let I=class extends l{constructor(u,k){super(u,k,(0,r.$wi)())}};e.$WP=I,e.$WP=I=Qe([qe(0,R.$QP),qe(1,T.$$j)],I)}),define(Ee[407],Se([1,0,62,394,389,301,52,376,2,15,10,406,111,337,375]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0,r=We(r);class c extends A.$mpc{j(){const m=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,a,w){return d=t(d),m.a.has(d)?m.a.get(d).load(d,$.URI.file((0,u.$hr)(a.filename)),y=>o.apply(this,[y,a,w])):o.apply(this,arguments)};const i=n._resolveLookupPaths;n._resolveLookupPaths=(s,d)=>i.call(this,t(s),d);const t=s=>{for(const d of m.b){const a=d(s);if(a){s=a;break}}return s}}}class g extends N.$_nc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(k.$Vpc);const m=this.h.invokeFunction(h.$ipc);if(this.h.createInstance(T.$Upc),this.f.remote.isRemote&&this.f.remote.authority){const i=this.h.createInstance(E.$WP);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this.h.createInstance(b.$Wpc),await this.h.createInstance(c,m,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,R.$Tpc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(m){return m.main}async xb(m,n,o){if(n.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let i=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=m?.identifier.value;m&&await this.w.initializeLocalizedMessages(m);try{t&&r.mark(`code/extHost/willLoadExtensionCode/${t}`),i=ce.__$__nodeRequire(n.fsPath)}finally{t&&r.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return i}async $setRemoteEnvironment(m){if(this.f.remote.isRemote)for(const n in m){const o=m[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Xpc=g}),define(Ee[408],Se([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,405,30,20,77,383]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0,e.$Ypc=t,e.$Zpc=s,e.$1pc=d,e.$2pc=a,e.$3pc=y,e.$4pc=S,e.$5pc=D,$=We($),I=We(I);function t(p){const v=p.trim().split(`
`),O=[];return v.forEach(F=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);j&&j.length>=3&&O.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),O.reduce((F,j)=>(F[j.socket]=j,F),{})}function s(...p){const v=[].concat(...p.map(a));return[...new Map(v.filter(O=>O.st==="0A").map(O=>{const L=O.local_address.split(":");return{socket:parseInt(O.inode,10),ip:d(L[0]),port:parseInt(L[1],16)}}).map(O=>[O.ip+":"+O.port,O])).values()]}function d(p){let v="";if(p.length===8)for(let O=p.length-2;O>=0;O-=2)v+=parseInt(p.substr(O,2),16),O!==0&&(v+=".");else for(let O=0;O<p.length;O+=8){const L=p.substring(O,O+8);let F="";for(let j=8;j>=2;j-=2)F+=L.substring(j-2,j),(j===6||j===2)&&(F=parseInt(F,16).toString(16),v+=`${F}`,F="",O+j!==p.length-6&&(v+=":"))}return v}function a(p){const v=p.trim().split(`
`),O=v.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return v.map(F=>F.trim().split(/\s+/).reduce((j,B,M)=>(j[O[M]||M]=B,j),{}))}function w(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function y(p){const v=p.trim().split(`
`),O=[];return v.forEach(L=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(L);F&&F.length>=4&&O.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),O}async function S(p,v,O){const L=O.reduce((j,B)=>(j[B.pid]=B,j),{}),F=[];return p.forEach(({socket:j,ip:B,port:M})=>{const z=v[j]?v[j].pid:void 0,_=z?L[z]?.cmd:void 0;z&&_&&!w(_)&&F.push({host:B,port:M,detail:_,pid:z})}),F}function D(p,v,O){const L=new Map,F=y(v);for(const j of p){const B=O.get(j.port);if(B){L.set(j.port,B);continue}const M=F.find(z=>z.cmd.includes(`${j.port}`));if(M){let z=M,_;do _=F.find(re=>re.ppid===z.pid),_&&(z=_);while(_);L.set(j.port,{host:j.ip,port:j.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else L.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return L}let P=class extends o.$5Eb{constructor(v,O,L,F){super(v,O,L),this.D=O,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,T.$k&&O.remote.isRemote&&O.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let O;this.y&&(O=this.y,await this.a.$onFoundNewCandidates(this.y));const L=new N.$Mm;let F=0;for(;this.C;){const j=new Date().getTime(),B=(await this.I()).filter(_=>(0,g.$Cw)(_.host)||(0,g.$Ew)(_.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(_=>_.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),F++>3&&L.update(M),(!O||JSON.stringify(O)!==JSON.stringify(B))&&(O=B,await this.a.$onFoundNewCandidates(O));const z=this.G(L.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${z} ms.`),await new Promise(_=>setTimeout(()=>_(),z))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",O="";try{v=await I.Promises.readFile("/proc/net/tcp","utf8"),O=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const L=s(v,O),F=await new Promise(G=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(K,ee,ue)=>{G(ee)})}),j=t(F),B=await I.Promises.readdir("/proc"),M=[];for(const G of B)try{const K=Number(G),ee=$.$fh(l.URI.file("/proc"),G);if((await I.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(K)){const ne=await I.Promises.readlink($.$fh(ee,"cwd").fsPath),De=await I.Promises.readFile($.$fh(ee,"cmdline").fsPath,"utf8");M.push({pid:K,cwd:ne,cmd:De})}}catch{}const z=[],_=L.filter(G=>{const K=j[G.socket];return K||z.push(G),K}),re=S(_,j,M);let U;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const G=await new Promise(K=>{(0,r.exec)("ps -F -A -l | grep root",(ee,ue,ne)=>{K(ue)})});this.z=D(z,G,this.z),U=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(K=>K.port).join(", ")}`)}return re.then(G=>U?G.concat(U):G)}w(v){return async O=>{const L=new f.$Efc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,B,M,z){const _=await v.makeConnection();return C.connect(_,B,M,z)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new b.$Ql(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",O.remoteAddress.host||"localhost",O.remoteAddress.port,O.localAddressPort);await L.waitForReady();const F=new A.$le;return{localAddress:(0,i.$oM)(L.localAddress)??L.localAddress,remoteAddress:{port:L.tunnelRemotePort,host:L.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{L.dispose(),F.fire(),F.dispose()}}}}};e.$6pc=P,e.$6pc=P=Qe([qe(0,n.$uP),qe(1,m.$KP),qe(2,u.$$j),qe(3,c.$Xl)],P);class C extends k.$qwb{static connect(v,O,L,F){const j=new R.$Uc,B={onClose:j.add(new A.$le),onData:j.add(new A.$le),onEnd:j.add(new A.$le)};j.add(v.onDidReceiveMessage(z=>B.onData.fire(h.$Ne.wrap(z)))),j.add(v.onDidEnd(()=>B.onEnd.fire())),j.add(v.onDidClose(z=>B.onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,error:z,hadError:!!z})));const M=new C(v,F,B);return M.B(j),(0,k.$pwb)(M,O,L,F,B)}constructor(v,O,L){super(O,L),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[409],Se([1,0,89,378,392,391,404,407,408,102,52,103,101,47,77,98,377,338,12,393,65,297,113,118,148]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f,m,n,o,i,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ks)(I.$aoc,T.$Xpc,r.InstantiationType.Eager),(0,r.$Ks)(m.$_j,f.$8pc,r.InstantiationType.Delayed),(0,r.$Ks)(m.$$j,new t.$Bi(i.$lpc,[!1],!0)),(0,r.$Ks)(s.$Xl,d.$Jfc,r.InstantiationType.Delayed),(0,r.$Ks)(c.$Cnc,g.$7pc,r.InstantiationType.Eager),(0,r.$Ks)(l.$koc,R.$ypc,r.InstantiationType.Eager),(0,r.$Ks)(E.$Goc,N.$Spc,r.InstantiationType.Eager),(0,r.$Ks)(u.$9oc,A.$qpc,r.InstantiationType.Eager),(0,r.$Ks)(k.$Xnc,h.$ppc,r.InstantiationType.Eager),(0,r.$Ks)(b.$4Eb,$.$6pc,r.InstantiationType.Eager),(0,r.$Ks)(o.$doc,n.$9pc,r.InstantiationType.Eager)});var zt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[419],Se([1,0,420,67,9,22,14,62,111,34,69,131,114,281,390,303,319,94,395,409]),function(ce,e,r,h,A,R,N,T,$,l,I,E,u,k,b,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=zt(r),h=We(h),T=We(T),k=zt(k),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const m=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,S=y._load;y._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function i(y){process.exit=function(S){if(y)n(S);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(S,D){S==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),o(S,D)}}let t=function(y){n()};function s(){const y=(0,g.$en)(process.env);if(y.type===g.ExtHostConnectionType.MessagePort)return new Promise((S,D)=>{const P=C=>{const p=C[0],v=new I.$ri;p.on("message",O=>v.fire(R.$Ne.wrap(O.data))),p.on("close",()=>{t("renderer closed the MessagePort")}),p.start(),S({onMessage:v.event,send:O=>p.postMessage(O.buffer)})};process.parentPort.on("message",C=>P(C.ports))});if(y.type===g.ExtHostConnectionType.Socket)return new Promise((S,D)=>{let P=null;const C=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,O=new A.$Rh(()=>t("renderer disconnected for too long (1)"),p),L=new A.$Rh(()=>t("renderer disconnected for too long (2)"),v);process.on("message",(j,B)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const M=R.$Ne.wrap(Buffer.from(j.initialDataChunk,"base64"));let z;if(j.skipWebSocketFrames)z=new E.$ti(B,"extHost-socket");else{const _=R.$Ne.wrap(Buffer.from(j.inflateBytes,"base64"));z=new E.$ui(new E.$ti(B,"extHost-socket"),j.permessageDeflate,_,!1)}P?(O.cancel(),L.cancel(),P.beginAcceptReconnection(z,M),P.endAcceptReconnection(),P.sendResume()):(clearTimeout(C),P=new I.$si({socket:z,initialChunk:M}),P.sendResume(),P.onDidDispose(()=>t("renderer disconnected")),S(P),P.onSocketClose(()=>{O.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(L.isScheduled())return;O.isScheduled()&&L.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const S=y.pipeName;return new Promise((D,P)=>{const C=h.createConnection(S,()=>{C.removeListener("error",P);const p=new I.$si({socket:new E.$ti(C,"extHost-renderer")});p.sendResume(),D(p)});C.once("error",P),C.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const y=await s();return new class{constructor(){this.a=new I.$ri,this.onMessage=this.a.event,this.b=!1,this.d=y.onMessage(S=>{(0,f.$yn)(S,f.MessageType.Terminate)?(this.b=!0,this.d.dispose(),t("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||y.send(S)}async drain(){if(y.drain)return y.drain()}}}function a(y){return new Promise(S=>{const D=y.onMessage(P=>{D.dispose();const C=JSON.parse(P.toString()),p=C.commit,v=k.default.commit;if(p&&v&&p!==v&&n(f.ExtensionHostExitCode.VersionMismatch),C.parentPid){let O=0;setInterval(function(){try{process.kill(C.parentPid,0),O=0}catch(F){F&&F.code==="EPERM"?(O++,O>=3&&t(`parent process ${C.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${C.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let L;try{L=globalThis._VSCODE_NODE_MODULES["native-watchdog"],L.start(C.parentPid)}catch(F){(0,N.$2)(F)}}y.send((0,f.$xn)(f.MessageType.Initialized)),S({protocol:y,initData:C})});y.send((0,f.$xn)(f.MessageType.Ready))})}async function w(){const y=[];process.on("unhandledRejection",(O,L)=>{y.push(L),setTimeout(()=>{const F=y.indexOf(L);F>=0&&L.catch(j=>{y.splice(F,1),(0,N.$5)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),O&&(0,N.$2)(O))})},1e3)}),process.on("rejectionHandled",O=>{const L=y.indexOf(O);L>=0&&y.splice(L,1)}),process.on("uncaughtException",function(O){(0,N.$1)(O)||(0,N.$2)(O)}),T.mark("code/extHost/willConnectToRenderer");const S=await d();T.mark("code/extHost/didConnectToRenderer");const D=await a(S);T.mark("code/extHost/didWaitForInitData");const{initData:P}=D;i(!!P.environment.extensionTestsLocationURI),P.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,P.environment.skipWorkspaceStorageLock=(0,u.boolean)(m.skipWorkspaceStorageLock,!1);const C=new class{constructor(){this.pid=process.pid}exit(L){n(L)}fsExists(L){return l.Promises.exists(L)}fsRealpath(L){return(0,$.$gr)(L)}};let p=null;P.remote.authority&&m.transformURIs&&(p=(0,c.$Os)(P.remote.authority));const v=new b.$opc(D.protocol,P,C,p);t=O=>v.terminate(O)}w().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fc357074a7bba115fe44683d3f6050c63e591683/core/vs/workbench/api/node/extensionHostProcess.js.map
