/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(oe){for(var e=[],w=0,C=oe.length;w<C;w++)e[w]=Ce[oe[w]];return e};define(Ce[72],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=C,e.$0h=P,e.$$h=M;function w(A){return(N,p,c)=>{let R=null,v=null;if(typeof c.value=="function"?(R="value",v=c.value):typeof c.get=="function"&&(R="get",v=c.get),!v)throw new Error("not supported");c[R]=A(v,p)}}function C(A,N,p){let c=null,R=null;if(typeof p.value=="function"?(c="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",R=p.get),!R)throw new Error("not supported");const v=`$memoize$${N}`;p[c]=function(...l){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[v]}}function P(A,N,p){return w((c,R)=>{const v=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...E){this[l]||(this[l]=p?p():void 0),clearTimeout(this[v]),N&&(this[l]=N(this[l],...E),E=[this[l]]),this[v]=setTimeout(()=>{c.apply(this,E),this[l]=p?p():void 0},A)}})}function M(A,N,p){return w((c,R)=>{const v=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...r){if(this[l]||(this[l]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),N&&(this[l]=N(this[l],...r)),this[d])return;const o=this[E]+A;o<=Date.now()?(this[E]=Date.now(),c.apply(this,[this[l]]),this[l]=p?p():void 0):(this[d]=!0,this[v]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),c.apply(this,[this[l]]),this[l]=p?p():void 0},o-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,w,C){C===void 0&&(C=w);var P=Object.getOwnPropertyDescriptor(e,w);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(oe,C,P)}:function(oe,e,w,C){C===void 0&&(C=w),oe[C]=e[w]}),Vn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),qe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var w in oe)w!=="default"&&Object.prototype.hasOwnProperty.call(oe,w)&&Bn(e,oe,w);return Vn(e,oe),e};define(Ce[134],Ie([1,0,18]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=P,e.$9c=M,e.$0c=A,e.$$c=N,e.$_c=p,e.$ad=c,w=qe(w);const C=(E,d)=>E===d;e.$7c=C;function P(E=e.$7c){return(d,r)=>w.$vb(d,r,E)}function M(){return(E,d)=>JSON.stringify(E)===JSON.stringify(d)}function A(){return(E,d)=>E.equals(d)}function N(E,d,r){if(r!==void 0){const o=E;return o==null||d===void 0||d===null?d===o:r(o,d)}else{const o=E;return(a,h)=>a==null||h===void 0||h===null?h===a:o(a,h)}}function p(E,d){if(E===d)return!0;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let r=0;r<E.length;r++)if(!p(E[r],d[r]))return!1;return!0}if(E&&typeof E=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=E,o=d,a=Object.keys(r),h=Object.keys(o),n=new Set(h);if(a.length!==h.length)return!1;for(const s of a)if(!n.has(s)||!p(r[s],o[s]))return!1;return!0}return!1}function c(E){return JSON.stringify(l(E))}let R=0;const v=new WeakMap;function l(E){if(Array.isArray(E))return E.map(l);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const d=E,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=l(d[o]);return r}else{let d=v.get(E);return d===void 0&&(d=R++,v.set(E,d)),d+"----2b76a038c20c4bcc"}return E}}),define(Ce[97],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0;class w{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$zP=w,e.$AP=new w("id#")}),define(Ce[135],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Sn=A,e.$Tn=v,e.$Un=l,e.$Vn=E,e.$Wn=d,e.$Xn=r,e.$Yn=o,e.$Zn=a,e.$1n=h,e.$2n=n,e.$3n=s,e.$4n=i;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,m=!1){let f=0;const u=t.length;let $="",I=0,D=C.Unknown,y=w.None;function S(G){let V=0,O=0;for(;V<G;){const W=t.charCodeAt(f);if(W>=R._0&&W<=R._9)O=O*16+W-R._0;else if(W>=R.A&&W<=R.F)O=O*16+W-R.A+10;else if(W>=R.a&&W<=R.f)O=O*16+W-R.a+10;else break;f++,V++}return V<G&&(O=-1),O}function k(G){f=G,$="",I=0,D=C.Unknown,y=w.None}function g(){const G=f;if(t.charCodeAt(f)===R._0)f++;else for(f++;f<t.length&&c(t.charCodeAt(f));)f++;if(f<t.length&&t.charCodeAt(f)===R.dot)if(f++,f<t.length&&c(t.charCodeAt(f)))for(f++;f<t.length&&c(t.charCodeAt(f));)f++;else return y=w.UnexpectedEndOfNumber,t.substring(G,f);let V=f;if(f<t.length&&(t.charCodeAt(f)===R.E||t.charCodeAt(f)===R.e))if(f++,(f<t.length&&t.charCodeAt(f)===R.plus||t.charCodeAt(f)===R.minus)&&f++,f<t.length&&c(t.charCodeAt(f))){for(f++;f<t.length&&c(t.charCodeAt(f));)f++;V=f}else y=w.UnexpectedEndOfNumber;return t.substring(G,V)}function b(){let G="",V=f;for(;;){if(f>=u){G+=t.substring(V,f),y=w.UnexpectedEndOfString;break}const O=t.charCodeAt(f);if(O===R.doubleQuote){G+=t.substring(V,f),f++;break}if(O===R.backslash){if(G+=t.substring(V,f),f++,f>=u){y=w.UnexpectedEndOfString;break}switch(t.charCodeAt(f++)){case R.doubleQuote:G+='"';break;case R.backslash:G+="\\";break;case R.slash:G+="/";break;case R.b:G+="\b";break;case R.f:G+="\f";break;case R.n:G+=`
`;break;case R.r:G+="\r";break;case R.t:G+="	";break;case R.u:{const ce=S(4);ce>=0?G+=String.fromCharCode(ce):y=w.InvalidUnicode;break}default:y=w.InvalidEscapeCharacter}V=f;continue}if(O>=0&&O<=31)if(p(O)){G+=t.substring(V,f),y=w.UnexpectedEndOfString;break}else y=w.InvalidCharacter;f++}return G}function F(){if($="",y=w.None,I=f,f>=u)return I=u,D=C.EOF;let G=t.charCodeAt(f);if(N(G)){do f++,$+=String.fromCharCode(G),G=t.charCodeAt(f);while(N(G));return D=C.Trivia}if(p(G))return f++,$+=String.fromCharCode(G),G===R.carriageReturn&&t.charCodeAt(f)===R.lineFeed&&(f++,$+=`
`),D=C.LineBreakTrivia;switch(G){case R.openBrace:return f++,D=C.OpenBraceToken;case R.closeBrace:return f++,D=C.CloseBraceToken;case R.openBracket:return f++,D=C.OpenBracketToken;case R.closeBracket:return f++,D=C.CloseBracketToken;case R.colon:return f++,D=C.ColonToken;case R.comma:return f++,D=C.CommaToken;case R.doubleQuote:return f++,$=b(),D=C.StringLiteral;case R.slash:{const V=f-1;if(t.charCodeAt(f+1)===R.slash){for(f+=2;f<u&&!p(t.charCodeAt(f));)f++;return $=t.substring(V,f),D=C.LineCommentTrivia}if(t.charCodeAt(f+1)===R.asterisk){f+=2;const O=u-1;let W=!1;for(;f<O;){if(t.charCodeAt(f)===R.asterisk&&t.charCodeAt(f+1)===R.slash){f+=2,W=!0;break}f++}return W||(f++,y=w.UnexpectedEndOfComment),$=t.substring(V,f),D=C.BlockCommentTrivia}return $+=String.fromCharCode(G),f++,D=C.Unknown}case R.minus:if($+=String.fromCharCode(G),f++,f===u||!c(t.charCodeAt(f)))return D=C.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return $+=g(),D=C.NumericLiteral;default:for(;f<u&&T(G);)f++,G=t.charCodeAt(f);if(I!==f){switch($=t.substring(I,f),$){case"true":return D=C.TrueKeyword;case"false":return D=C.FalseKeyword;case"null":return D=C.NullKeyword}return D=C.Unknown}return $+=String.fromCharCode(G),f++,D=C.Unknown}}function T(G){if(N(G)||p(G))return!1;switch(G){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function q(){let G;do G=F();while(G>=C.LineCommentTrivia&&G<=C.Trivia);return G}return{setPosition:k,getPosition:()=>f,scan:m?q:F,getToken:()=>D,getTokenValue:()=>$,getTokenOffset:()=>I,getTokenLength:()=>f-I,getTokenError:()=>y}}function N(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function p(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function c(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function v(t,m){const f=[],u=new Object;let $;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function y(S,k,g,b){I.value=S,I.offset=k,I.length=g,I.type=b,I.colonOffset=void 0,$=I}try{n(t,{onObjectBegin:(S,k)=>{if(m<=S)throw u;$=void 0,D=m>S,f.push("")},onObjectProperty:(S,k,g)=>{if(m<k||(y(S,k,g,"property"),f[f.length-1]=S,m<=k+g))throw u},onObjectEnd:(S,k)=>{if(m<=S)throw u;$=void 0,f.pop()},onArrayBegin:(S,k)=>{if(m<=S)throw u;$=void 0,f.push(0)},onArrayEnd:(S,k)=>{if(m<=S)throw u;$=void 0,f.pop()},onLiteralValue:(S,k,g)=>{if(m<k||(y(S,k,g,i(S)),m<=k+g))throw u},onSeparator:(S,k,g)=>{if(m<=k)throw u;if(S===":"&&$&&$.type==="property")$.colonOffset=k,D=!1,$=void 0;else if(S===","){const b=f[f.length-1];typeof b=="number"?f[f.length-1]=b+1:(D=!0,f[f.length-1]=""),$=void 0}}})}catch(S){if(S!==u)throw S}return{path:f,previousNode:$,isAtPropertyKey:D,matches:S=>{let k=0;for(let g=0;k<S.length&&g<f.length;g++)if(S[k]===f[g]||S[k]==="*")k++;else if(S[k]!=="**")return!1;return k===S.length}}}function l(t,m=[],f=M.DEFAULT){let u=null,$=[];const I=[];function D(S){Array.isArray($)?$.push(S):u!==null&&($[u]=S)}return n(t,{onObjectBegin:()=>{const S={};D(S),I.push($),$=S,u=null},onObjectProperty:S=>{u=S},onObjectEnd:()=>{$=I.pop()},onArrayBegin:()=>{const S=[];D(S),I.push($),$=S,u=null},onArrayEnd:()=>{$=I.pop()},onLiteralValue:D,onError:(S,k,g)=>{m.push({error:S,offset:k,length:g})}},f),$[0]}function E(t,m=[],f=M.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(S){u.type==="property"&&(u.length=S-u.offset,u=u.parent)}function I(S){return u.children.push(S),S}n(t,{onObjectBegin:S=>{u=I({type:"object",offset:S,length:-1,parent:u,children:[]})},onObjectProperty:(S,k,g)=>{u=I({type:"property",offset:k,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:S,offset:k,length:g,parent:u})},onObjectEnd:(S,k)=>{u.length=S+k-u.offset,u=u.parent,$(S+k)},onArrayBegin:(S,k)=>{u=I({type:"array",offset:S,length:-1,parent:u,children:[]})},onArrayEnd:(S,k)=>{u.length=S+k-u.offset,u=u.parent,$(S+k)},onLiteralValue:(S,k,g)=>{I({type:i(S),offset:k,length:g,parent:u,value:S}),$(k+g)},onSeparator:(S,k,g)=>{u.type==="property"&&(S===":"?u.colonOffset=k:S===","&&$(k))},onError:(S,k,g)=>{m.push({error:S,offset:k,length:g})}},f);const y=u.children[0];return y&&delete y.parent,y}function d(t,m){if(!t)return;let f=t;for(const u of m)if(typeof u=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let $=!1;for(const I of f.children)if(Array.isArray(I.children)&&I.children[0].value===u){f=I.children[1],$=!0;break}if(!$)return}else{const $=u;if(f.type!=="array"||$<0||!Array.isArray(f.children)||$>=f.children.length)return;f=f.children[$]}return f}function r(t){if(!t.parent||!t.parent.children)return[];const m=r(t.parent);if(t.parent.type==="property"){const f=t.parent.children[0].value;m.push(f)}else if(t.parent.type==="array"){const f=t.parent.children.indexOf(t);f!==-1&&m.push(f)}return m}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const m=Object.create(null);for(const f of t.children){const u=f.children[1];u&&(m[f.children[0].value]=o(u))}return m}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,m,f=!1){return m>=t.offset&&m<t.offset+t.length||f&&m===t.offset+t.length}function h(t,m,f=!1){if(a(t,m,f)){const u=t.children;if(Array.isArray(u))for(let $=0;$<u.length&&u[$].offset<=m;$++){const I=h(u[$],m,f);if(I)return I}return t}}function n(t,m,f=M.DEFAULT){const u=A(t,!1);function $(be){return be?()=>be(u.getTokenOffset(),u.getTokenLength()):()=>!0}function I(be){return be?re=>be(re,u.getTokenOffset(),u.getTokenLength()):()=>!0}const D=$(m.onObjectBegin),y=I(m.onObjectProperty),S=$(m.onObjectEnd),k=$(m.onArrayBegin),g=$(m.onArrayEnd),b=I(m.onLiteralValue),F=I(m.onSeparator),T=$(m.onComment),q=I(m.onError),G=f&&f.disallowComments,V=f&&f.allowTrailingComma;function O(){for(;;){const be=u.scan();switch(u.getTokenError()){case w.InvalidUnicode:W(P.InvalidUnicode);break;case w.InvalidEscapeCharacter:W(P.InvalidEscapeCharacter);break;case w.UnexpectedEndOfNumber:W(P.UnexpectedEndOfNumber);break;case w.UnexpectedEndOfComment:G||W(P.UnexpectedEndOfComment);break;case w.UnexpectedEndOfString:W(P.UnexpectedEndOfString);break;case w.InvalidCharacter:W(P.InvalidCharacter);break}switch(be){case C.LineCommentTrivia:case C.BlockCommentTrivia:G?W(P.InvalidCommentToken):T();break;case C.Unknown:W(P.InvalidSymbol);break;case C.Trivia:case C.LineBreakTrivia:break;default:return be}}}function W(be,re=[],Pe=[]){if(q(be),re.length+Pe.length>0){let Fe=u.getToken();for(;Fe!==C.EOF;){if(re.indexOf(Fe)!==-1){O();break}else if(Pe.indexOf(Fe)!==-1)break;Fe=O()}}}function ce(be){const re=u.getTokenValue();return be?b(re):y(re),O(),!0}function ge(){switch(u.getToken()){case C.NumericLiteral:{let be=0;try{be=JSON.parse(u.getTokenValue()),typeof be!="number"&&(W(P.InvalidNumberFormat),be=0)}catch{W(P.InvalidNumberFormat)}b(be);break}case C.NullKeyword:b(null);break;case C.TrueKeyword:b(!0);break;case C.FalseKeyword:b(!1);break;default:return!1}return O(),!0}function te(){return u.getToken()!==C.StringLiteral?(W(P.PropertyNameExpected,[],[C.CloseBraceToken,C.CommaToken]),!1):(ce(!1),u.getToken()===C.ColonToken?(F(":"),O(),de()||W(P.ValueExpected,[],[C.CloseBraceToken,C.CommaToken])):W(P.ColonExpected,[],[C.CloseBraceToken,C.CommaToken]),!0)}function me(){D(),O();let be=!1;for(;u.getToken()!==C.CloseBraceToken&&u.getToken()!==C.EOF;){if(u.getToken()===C.CommaToken){if(be||W(P.ValueExpected,[],[]),F(","),O(),u.getToken()===C.CloseBraceToken&&V)break}else be&&W(P.CommaExpected,[],[]);te()||W(P.ValueExpected,[],[C.CloseBraceToken,C.CommaToken]),be=!0}return S(),u.getToken()!==C.CloseBraceToken?W(P.CloseBraceExpected,[C.CloseBraceToken],[]):O(),!0}function se(){k(),O();let be=!1;for(;u.getToken()!==C.CloseBracketToken&&u.getToken()!==C.EOF;){if(u.getToken()===C.CommaToken){if(be||W(P.ValueExpected,[],[]),F(","),O(),u.getToken()===C.CloseBracketToken&&V)break}else be&&W(P.CommaExpected,[],[]);de()||W(P.ValueExpected,[],[C.CloseBracketToken,C.CommaToken]),be=!0}return g(),u.getToken()!==C.CloseBracketToken?W(P.CloseBracketExpected,[C.CloseBracketToken],[]):O(),!0}function de(){switch(u.getToken()){case C.OpenBracketToken:return se();case C.OpenBraceToken:return me();case C.StringLiteral:return ce(!0);default:return ge()}}return O(),u.getToken()===C.EOF?f.allowEmptyContent?!0:(W(P.ValueExpected,[],[]),!1):de()?(u.getToken()!==C.EOF&&W(P.EndOfFileExpected,[],[]),!0):(W(P.ValueExpected,[],[]),!1)}function s(t,m){const f=A(t),u=[];let $,I=0,D;do switch(D=f.getPosition(),$=f.scan(),$){case C.LineCommentTrivia:case C.BlockCommentTrivia:case C.EOF:I!==D&&u.push(t.substring(I,D)),m!==void 0&&u.push(f.getTokenValue().replace(/[^\r\n]/g,m)),I=f.getPosition();break}while($!==C.EOF);return u.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(Ce[136],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ae,ve){for(var ue=0;ue<ve.length;ue++){var Z=ve[ue];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(ae,Z.key,Z)}}function w(ae,ve,ue){return ve&&e(ae.prototype,ve),ue&&e(ae,ue),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function C(ae,ve){if(ae){if(typeof ae=="string")return P(ae,ve);var ue=Object.prototype.toString.call(ae).slice(8,-1);if(ue==="Object"&&ae.constructor&&(ue=ae.constructor.name),ue==="Map"||ue==="Set")return Array.from(ae);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return P(ae,ve)}}function P(ae,ve){(ve==null||ve>ae.length)&&(ve=ae.length);for(var ue=0,Z=new Array(ve);ue<ve;ue++)Z[ue]=ae[ue];return Z}function M(ae,ve){var ue=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(ue)return(ue=ue.call(ae)).next.bind(ue);if(Array.isArray(ae)||(ue=C(ae))||ve&&ae&&typeof ae.length=="number"){ue&&(ae=ue);var Z=0;return function(){return Z>=ae.length?{done:!0}:{done:!1,value:ae[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=A();function N(ae){oe.defaults=ae}var p=/[&<>"']/,c=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ve){return l[ve]};function d(ae,ve){if(ve){if(p.test(ae))return ae.replace(c,E)}else if(R.test(ae))return ae.replace(v,E);return ae}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ae){return ae.replace(r,function(ve,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(ae,ve){ae=typeof ae=="string"?ae:ae.source,ve=ve||"";var ue={replace:function(Y,pe){return pe=pe.source||pe,pe=pe.replace(a,"$1"),ae=ae.replace(Y,pe),ue},getRegex:function(){return new RegExp(ae,ve)}};return ue}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(ae,ve,ue){if(ae){var Z;try{Z=decodeURIComponent(o(ue)).replace(n,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ve&&!s.test(ue)&&(ue=$(ve,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var t={},m=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ae,ve){t[" "+ae]||(m.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=S(ae,"/",!0)),ae=t[" "+ae];var ue=ae.indexOf(":")===-1;return ve.substring(0,2)==="//"?ue?ve:ae.replace(f,"$1")+ve:ve.charAt(0)==="/"?ue?ve:ae.replace(u,"$1")+ve:ae+ve}var I={exec:function(){}};function D(ae){for(var ve=1,ue,Z;ve<arguments.length;ve++){ue=arguments[ve];for(Z in ue)Object.prototype.hasOwnProperty.call(ue,Z)&&(ae[Z]=ue[Z])}return ae}function y(ae,ve){var ue=ae.replace(/\|/g,function(pe,$e,Ne){for(var Ue=!1,ke=$e;--ke>=0&&Ne[ke]==="\\";)Ue=!Ue;return Ue?"|":" |"}),Z=ue.split(/ \|/),Y=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ve)Z.splice(ve);else for(;Z.length<ve;)Z.push("");for(;Y<Z.length;Y++)Z[Y]=Z[Y].trim().replace(/\\\|/g,"|");return Z}function S(ae,ve,ue){var Z=ae.length;if(Z===0)return"";for(var Y=0;Y<Z;){var pe=ae.charAt(Z-Y-1);if(pe===ve&&!ue)Y++;else if(pe!==ve&&ue)Y++;else break}return ae.slice(0,Z-Y)}function k(ae,ve){if(ae.indexOf(ve[1])===-1)return-1;for(var ue=ae.length,Z=0,Y=0;Y<ue;Y++)if(ae[Y]==="\\")Y++;else if(ae[Y]===ve[0])Z++;else if(ae[Y]===ve[1]&&(Z--,Z<0))return Y;return-1}function g(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ae,ve){if(ve<1)return"";for(var ue="";ve>1;)ve&1&&(ue+=ae),ve>>=1,ae+=ae;return ue+ae}function F(ae,ve,ue,Z){var Y=ve.href,pe=ve.title?d(ve.title):null,$e=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ne={type:"link",raw:ue,href:Y,title:pe,text:$e,tokens:Z.inlineTokens($e)};return Z.state.inLink=!1,Ne}return{type:"image",raw:ue,href:Y,title:pe,text:d($e)}}function T(ae,ve){var ue=ae.match(/^(\s+)(?:```)/);if(ue===null)return ve;var Z=ue[1];return ve.split(`
`).map(function(Y){var pe=Y.match(/^\s+/);if(pe===null)return Y;var $e=pe[0];return $e.length>=Z.length?Y.slice(Z.length):Y}).join(`
`)}var q=function(){function ae(ue){this.options=ue||oe.defaults}var ve=ae.prototype;return ve.space=function(Z){var Y=this.rules.block.newline.exec(Z);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ve.code=function(Z){var Y=this.rules.block.code.exec(Z);if(Y){var pe=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:S(pe,`
`)}}},ve.fences=function(Z){var Y=this.rules.block.fences.exec(Z);if(Y){var pe=Y[0],$e=T(pe,Y[3]||"");return{type:"code",raw:pe,lang:Y[2]?Y[2].trim():Y[2],text:$e}}},ve.heading=function(Z){var Y=this.rules.block.heading.exec(Z);if(Y){var pe=Y[2].trim();if(/#$/.test(pe)){var $e=S(pe,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(pe=$e.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ve.hr=function(Z){var Y=this.rules.block.hr.exec(Z);if(Y)return{type:"hr",raw:Y[0]}},ve.blockquote=function(Z){var Y=this.rules.block.blockquote.exec(Z);if(Y){var pe=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ve.list=function(Z){var Y=this.rules.block.list.exec(Z);if(Y){var pe,$e,Ne,Ue,ke,Re,Me,z,U,K,J,ne,fe=Y[1].trim(),Ae=fe.length>1,ze={type:"list",raw:"",ordered:Ae,start:Ae?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Ae?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Ae?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(ne=!1,!(!(Y=Ke.exec(Z))||this.rules.block.hr.test(Z)));){if(pe=Y[0],Z=Z.substring(pe.length),z=Y[2].split(`
`,1)[0],U=Z.split(`
`,1)[0],this.options.pedantic?(Ue=2,J=z.trimLeft()):(Ue=Y[2].search(/[^ ]/),Ue=Ue>4?1:Ue,J=z.slice(Ue),Ue+=Y[1].length),Re=!1,!z&&/^ *$/.test(U)&&(pe+=U+`
`,Z=Z.substring(U.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");Z&&(K=Z.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(z)||tt.test(z)||_e.test(z)||it.test(Z)));){if(z.search(/[^ ]/)>=Ue||!z.trim())J+=`
`+z.slice(Ue);else if(!Re)J+=`
`+z;else break;!Re&&!z.trim()&&(Re=!0),pe+=K+`
`,Z=Z.substring(K.length+1)}ze.loose||(Me?ze.loose=!0:/\n *\n *$/.test(pe)&&(Me=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(J),$e&&(Ne=$e[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:pe,task:!!$e,checked:Ne,loose:!1,text:J}),ze.raw+=pe}ze.items[ze.items.length-1].raw=pe.trimRight(),ze.items[ze.items.length-1].text=J.trimRight(),ze.raw=ze.raw.trimRight();var rt=ze.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,ze.items[ke].tokens=this.lexer.blockTokens(ze.items[ke].text,[]);var $t=ze.items[ke].tokens.filter(function(st){return st.type==="space"}),ut=$t.every(function(st){for(var ct=st.raw.split(""),gt=0,mt=M(ct),Be;!(Be=mt()).done;){var je=Be.value;if(je===`
`&&(gt+=1),gt>1)return!0}return!1});!ze.loose&&$t.length&&ut&&(ze.loose=!0,ze.items[ke].loose=!0)}return ze}},ve.html=function(Z){var Y=this.rules.block.html.exec(Z);if(Y){var pe={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]);pe.type="paragraph",pe.text=$e,pe.tokens=this.lexer.inline($e)}return pe}},ve.def=function(Z){var Y=this.rules.block.def.exec(Z);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var pe=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:Y[0],href:Y[2],title:Y[3]}}},ve.table=function(Z){var Y=this.rules.block.table.exec(Z);if(Y){var pe={type:"table",header:y(Y[1]).map(function(Me){return{text:Me}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=Y[0];var $e=pe.align.length,Ne,Ue,ke,Re;for(Ne=0;Ne<$e;Ne++)/^ *-+: *$/.test(pe.align[Ne])?pe.align[Ne]="right":/^ *:-+: *$/.test(pe.align[Ne])?pe.align[Ne]="center":/^ *:-+ *$/.test(pe.align[Ne])?pe.align[Ne]="left":pe.align[Ne]=null;for($e=pe.rows.length,Ne=0;Ne<$e;Ne++)pe.rows[Ne]=y(pe.rows[Ne],pe.header.length).map(function(Me){return{text:Me}});for($e=pe.header.length,Ue=0;Ue<$e;Ue++)pe.header[Ue].tokens=this.lexer.inline(pe.header[Ue].text);for($e=pe.rows.length,Ue=0;Ue<$e;Ue++)for(Re=pe.rows[Ue],ke=0;ke<Re.length;ke++)Re[ke].tokens=this.lexer.inline(Re[ke].text);return pe}}},ve.lheading=function(Z){var Y=this.rules.block.lheading.exec(Z);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ve.paragraph=function(Z){var Y=this.rules.block.paragraph.exec(Z);if(Y){var pe=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:pe,tokens:this.lexer.inline(pe)}}},ve.text=function(Z){var Y=this.rules.block.text.exec(Z);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ve.escape=function(Z){var Y=this.rules.inline.escape.exec(Z);if(Y)return{type:"escape",raw:Y[0],text:d(Y[1])}},ve.tag=function(Z){var Y=this.rules.inline.tag.exec(Z);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]):Y[0]}},ve.link=function(Z){var Y=this.rules.inline.link.exec(Z);if(Y){var pe=Y[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var $e=S(pe.slice(0,-1),"\\");if((pe.length-$e.length)%2===0)return}else{var Ne=k(Y[2],"()");if(Ne>-1){var Ue=Y[0].indexOf("!")===0?5:4,ke=Ue+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,ke).trim(),Y[3]=""}}var Re=Y[2],Me="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);z&&(Re=z[1],Me=z[3])}else Me=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(pe)?Re=Re.slice(1):Re=Re.slice(1,-1)),F(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ve.reflink=function(Z,Y){var pe;if((pe=this.rules.inline.reflink.exec(Z))||(pe=this.rules.inline.nolink.exec(Z))){var $e=(pe[2]||pe[1]).replace(/\s+/g," ");if($e=Y[$e.toLowerCase()],!$e||!$e.href){var Ne=pe[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return F(pe,$e,pe[0],this.lexer)}},ve.emStrong=function(Z,Y,pe){pe===void 0&&(pe="");var $e=this.rules.inline.emStrong.lDelim.exec(Z);if($e&&!($e[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=$e[1]||$e[2]||"";if(!Ne||Ne&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Ue=$e[0].length-1,ke,Re,Me=Ue,z=0,U=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,Y=Y.slice(-1*Z.length+Ue);($e=U.exec(Y))!=null;)if(ke=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!ke){if(Re=ke.length,$e[3]||$e[4]){Me+=Re;continue}else if(($e[5]||$e[6])&&Ue%3&&!((Ue+Re)%3)){z+=Re;continue}if(Me-=Re,!(Me>0)){if(Re=Math.min(Re,Re+Me+z),Math.min(Ue,Re)%2){var K=Z.slice(1,Ue+$e.index+Re);return{type:"em",raw:Z.slice(0,Ue+$e.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var J=Z.slice(2,Ue+$e.index+Re-1);return{type:"strong",raw:Z.slice(0,Ue+$e.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ve.codespan=function(Z){var Y=this.rules.inline.code.exec(Z);if(Y){var pe=Y[2].replace(/\n/g," "),$e=/[^ ]/.test(pe),Ne=/^ /.test(pe)&&/ $/.test(pe);return $e&&Ne&&(pe=pe.substring(1,pe.length-1)),pe=d(pe,!0),{type:"codespan",raw:Y[0],text:pe}}},ve.br=function(Z){var Y=this.rules.inline.br.exec(Z);if(Y)return{type:"br",raw:Y[0]}},ve.del=function(Z){var Y=this.rules.inline.del.exec(Z);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ve.autolink=function(Z,Y){var pe=this.rules.inline.autolink.exec(Z);if(pe){var $e,Ne;return pe[2]==="@"?($e=d(this.options.mangle?Y(pe[1]):pe[1]),Ne="mailto:"+$e):($e=d(pe[1]),Ne=$e),{type:"link",raw:pe[0],text:$e,href:Ne,tokens:[{type:"text",raw:$e,text:$e}]}}},ve.url=function(Z,Y){var pe;if(pe=this.rules.inline.url.exec(Z)){var $e,Ne;if(pe[2]==="@")$e=d(this.options.mangle?Y(pe[0]):pe[0]),Ne="mailto:"+$e;else{var Ue;do Ue=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Ue!==pe[0]);$e=d(pe[0]),pe[1]==="www."?Ne="http://"+$e:Ne=$e}return{type:"link",raw:pe[0],text:$e,href:Ne,tokens:[{type:"text",raw:$e,text:$e}]}}},ve.inlineText=function(Z,Y){var pe=this.rules.inline.text.exec(Z);if(pe){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):d(pe[0]):pe[0]:$e=d(this.options.smartypants?Y(pe[0]):pe[0]),{type:"text",raw:pe[0],text:$e}}},ae}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=D({},G),G.gfm=D({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=D({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=h(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=h(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=h(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=h(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=h(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=h(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=h(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=h(V.reflink).replace("label",V._label).replace("ref",G._label).getRegex(),V.nolink=h(V.nolink).replace("ref",G._label).getRegex(),V.reflinkSearch=h(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=D({},V),V.pedantic=D({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=D({},V.normal,{escape:h(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=h(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=D({},V.gfm,{br:h(V.br).replace("{2,}","*").getRegex(),text:h(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ae){var ve="",ue,Z,Y=ae.length;for(ue=0;ue<Y;ue++)Z=ae.charCodeAt(ue),Math.random()>.5&&(Z="x"+Z.toString(16)),ve+="&#"+Z+";";return ve}var ce=function(){function ae(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||oe.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:G.normal,inline:V.normal};this.options.pedantic?(Z.block=G.pedantic,Z.inline=V.pedantic):this.options.gfm&&(Z.block=G.gfm,this.options.breaks?Z.inline=V.breaks:Z.inline=V.gfm),this.tokenizer.rules=Z}ae.lex=function(Z,Y){var pe=new ae(Y);return pe.lex(Z)},ae.lexInline=function(Z,Y){var pe=new ae(Y);return pe.inlineTokens(Z)};var ve=ae.prototype;return ve.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ve.blockTokens=function(Z,Y){var pe=this;Y===void 0&&(Y=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Me,z,U){return z+"    ".repeat(U.length)});for(var $e,Ne,Ue,ke;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return($e=Me.call({lexer:pe},Z,Y))?(Z=Z.substring($e.raw.length),Y.push($e),!0):!1}))){if($e=this.tokenizer.space(Z)){Z=Z.substring($e.raw.length),$e.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push($e);continue}if($e=this.tokenizer.code(Z)){Z=Z.substring($e.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push($e);continue}if($e=this.tokenizer.fences(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.heading(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.hr(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.blockquote(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.list(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.html(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.def(Z)){Z=Z.substring($e.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.lheading(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if(Ue=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,z=Z.slice(1),U=void 0;pe.options.extensions.startBlock.forEach(function(K){U=K.call({lexer:this},z),typeof U=="number"&&U>=0&&(Me=Math.min(Me,U))}),Me<1/0&&Me>=0&&(Ue=Z.substring(0,Me+1))}(),this.state.top&&($e=this.tokenizer.paragraph(Ue))){Ne=Y[Y.length-1],ke&&Ne.type==="paragraph"?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push($e),ke=Ue.length!==Z.length,Z=Z.substring($e.raw.length);continue}if($e=this.tokenizer.text(Z)){Z=Z.substring($e.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push($e);continue}if(Z){var Re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},ve.inline=function(Z,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Z,tokens:Y}),Y},ve.inlineTokens=function(Z,Y){var pe=this;Y===void 0&&(Y=[]);var $e,Ne,Ue,ke=Z,Re,Me,z;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)U.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Me||(z=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return($e=J.call({lexer:pe},Z,Y))?(Z=Z.substring($e.raw.length),Y.push($e),!0):!1}))){if($e=this.tokenizer.escape(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.tag(Z)){Z=Z.substring($e.raw.length),Ne=Y[Y.length-1],Ne&&$e.type==="text"&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):Y.push($e);continue}if($e=this.tokenizer.link(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring($e.raw.length),Ne=Y[Y.length-1],Ne&&$e.type==="text"&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):Y.push($e);continue}if($e=this.tokenizer.emStrong(Z,ke,z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.codespan(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.br(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.del(Z)){Z=Z.substring($e.raw.length),Y.push($e);continue}if($e=this.tokenizer.autolink(Z,W)){Z=Z.substring($e.raw.length),Y.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(Z,W))){Z=Z.substring($e.raw.length),Y.push($e);continue}if(Ue=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,ne=Z.slice(1),fe=void 0;pe.options.extensions.startInline.forEach(function(Ae){fe=Ae.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(J=Math.min(J,fe))}),J<1/0&&J>=0&&(Ue=Z.substring(0,J+1))}(),$e=this.tokenizer.inlineText(Ue,O)){Z=Z.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(z=$e.raw.slice(-1)),Me=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):Y.push($e);continue}if(Z){var K="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},w(ae,null,[{key:"rules",get:function(){return{block:G,inline:V}}}]),ae}(),ge=function(){function ae(ue){this.options=ue||oe.defaults}var ve=ae.prototype;return ve.code=function(Z,Y,pe){var $e=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Z,$e);Ne!=null&&Ne!==Z&&(pe=!0,Z=Ne)}return Z=Z.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(pe?Z:d(Z,!0))+`</code></pre>
`:"<pre><code>"+(pe?Z:d(Z,!0))+`</code></pre>
`},ve.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ve.html=function(Z){return Z},ve.heading=function(Z,Y,pe,$e){if(this.options.headerIds){var Ne=this.options.headerPrefix+$e.slug(pe);return"<h"+Y+' id="'+Ne+'">'+Z+"</h"+Y+`>
`}return"<h"+Y+">"+Z+"</h"+Y+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(Z,Y,pe){var $e=Y?"ol":"ul",Ne=Y&&pe!==1?' start="'+pe+'"':"";return"<"+$e+Ne+`>
`+Z+"</"+$e+`>
`},ve.listitem=function(Z){return"<li>"+Z+`</li>
`},ve.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(Z){return"<p>"+Z+`</p>
`},ve.table=function(Z,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+Y+`</table>
`},ve.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ve.tablecell=function(Z,Y){var pe=Y.header?"th":"td",$e=Y.align?"<"+pe+' align="'+Y.align+'">':"<"+pe+">";return $e+Z+("</"+pe+`>
`)},ve.strong=function(Z){return"<strong>"+Z+"</strong>"},ve.em=function(Z){return"<em>"+Z+"</em>"},ve.codespan=function(Z){return"<code>"+Z+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(Z){return"<del>"+Z+"</del>"},ve.link=function(Z,Y,pe){if(Z=i(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var $e='<a href="'+d(Z)+'"';return Y&&($e+=' title="'+Y+'"'),$e+=">"+pe+"</a>",$e},ve.image=function(Z,Y,pe){if(Z=i(this.options.sanitize,this.options.baseUrl,Z),Z===null)return pe;var $e='<img src="'+Z+'" alt="'+pe+'"';return Y&&($e+=' title="'+Y+'"'),$e+=this.options.xhtml?"/>":">",$e},ve.text=function(Z){return Z},ae}(),te=function(){function ae(){}var ve=ae.prototype;return ve.strong=function(Z){return Z},ve.em=function(Z){return Z},ve.codespan=function(Z){return Z},ve.del=function(Z){return Z},ve.html=function(Z){return Z},ve.text=function(Z){return Z},ve.link=function(Z,Y,pe){return""+pe},ve.image=function(Z,Y,pe){return""+pe},ve.br=function(){return""},ae}(),me=function(){function ae(){this.seen={}}var ve=ae.prototype;return ve.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(Z,Y){var pe=Z,$e=0;if(this.seen.hasOwnProperty(pe)){$e=this.seen[Z];do $e++,pe=Z+"-"+$e;while(this.seen.hasOwnProperty(pe))}return Y||(this.seen[Z]=$e,this.seen[pe]=0),pe},ve.slug=function(Z,Y){Y===void 0&&(Y={});var pe=this.serialize(Z);return this.getNextSafeSlug(pe,Y.dryrun)},ae}(),se=function(){function ae(ue){this.options=ue||oe.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new me}ae.parse=function(Z,Y){var pe=new ae(Y);return pe.parse(Z)},ae.parseInline=function(Z,Y){var pe=new ae(Y);return pe.parseInline(Z)};var ve=ae.prototype;return ve.parse=function(Z,Y){Y===void 0&&(Y=!0);var pe="",$e,Ne,Ue,ke,Re,Me,z,U,K,J,ne,fe,Ae,ze,Ke,_e,it,nt,tt,rt=Z.length;for($e=0;$e<rt;$e++){if(J=Z[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(tt=this.options.extensions.renderers[J.type].call({parser:this},J),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){pe+=tt||"";continue}switch(J.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(J.tokens),J.depth,o(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(U="",z="",ke=J.header.length,Ne=0;Ne<ke;Ne++)z+=this.renderer.tablecell(this.parseInline(J.header[Ne].tokens),{header:!0,align:J.align[Ne]});for(U+=this.renderer.tablerow(z),K="",ke=J.rows.length,Ne=0;Ne<ke;Ne++){for(Me=J.rows[Ne],z="",Re=Me.length,Ue=0;Ue<Re;Ue++)z+=this.renderer.tablecell(this.parseInline(Me[Ue].tokens),{header:!1,align:J.align[Ue]});K+=this.renderer.tablerow(z)}pe+=this.renderer.table(U,K);continue}case"blockquote":{K=this.parse(J.tokens),pe+=this.renderer.blockquote(K);continue}case"list":{for(ne=J.ordered,fe=J.start,Ae=J.loose,ke=J.items.length,K="",Ne=0;Ne<ke;Ne++)Ke=J.items[Ne],_e=Ke.checked,it=Ke.task,ze="",Ke.task&&(nt=this.renderer.checkbox(_e),Ae?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(Ke.tokens,Ae),K+=this.renderer.listitem(ze,it,_e);pe+=this.renderer.list(K,ne,fe);continue}case"html":{pe+=this.renderer.html(J.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(K=J.tokens?this.parseInline(J.tokens):J.text;$e+1<rt&&Z[$e+1].type==="text";)J=Z[++$e],K+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);pe+=Y?this.renderer.paragraph(K):K;continue}default:{var $t='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},ve.parseInline=function(Z,Y){Y=Y||this.renderer;var pe="",$e,Ne,Ue,ke=Z.length;for($e=0;$e<ke;$e++){if(Ne=Z[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(Ue=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){pe+=Ue||"";continue}switch(Ne.type){case"escape":{pe+=Y.text(Ne.text);break}case"html":{pe+=Y.html(Ne.text);break}case"link":{pe+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{pe+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{pe+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{pe+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{pe+=Y.codespan(Ne.text);break}case"br":{pe+=Y.br();break}case"del":{pe+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{pe+=Y.text(Ne.text);break}default:{var Re='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return pe},ae}();function de(ae,ve,ue){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof ve=="function"&&(ue=ve,ve=null),ve=D({},de.defaults,ve||{}),g(ve),ue){var Z=ve.highlight,Y;try{Y=ce.lex(ae,ve)}catch(ke){return ue(ke)}var pe=function(Re){var Me;if(!Re)try{ve.walkTokens&&de.walkTokens(Y,ve.walkTokens),Me=se.parse(Y,ve)}catch(z){Re=z}return ve.highlight=Z,Re?ue(Re):ue(null,Me)};if(!Z||Z.length<3||(delete ve.highlight,!Y.length))return pe();var $e=0;de.walkTokens(Y,function(ke){ke.type==="code"&&($e++,setTimeout(function(){Z(ke.text,ke.lang,function(Re,Me){if(Re)return pe(Re);Me!=null&&Me!==ke.text&&(ke.text=Me,ke.escaped=!0),$e--,$e===0&&pe()})},0))}),$e===0&&pe();return}function Ne(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var Ue=ce.lex(ae,ve);if(ve.walkTokens){if(ve.async)return Promise.all(de.walkTokens(Ue,ve.walkTokens)).then(function(){return se.parse(Ue,ve)}).catch(Ne);de.walkTokens(Ue,ve.walkTokens)}return se.parse(Ue,ve)}catch(ke){Ne(ke)}}de.options=de.setOptions=function(ae){return D(de.defaults,ae),N(de.defaults),de},de.getDefaults=A,de.defaults=oe.defaults,de.use=function(){for(var ae=arguments.length,ve=new Array(ae),ue=0;ue<ae;ue++)ve[ue]=arguments[ue];var Z=D.apply(void 0,[{}].concat(ve)),Y=de.defaults.extensions||{renderers:{},childTokens:{}},pe;ve.forEach(function($e){if($e.extensions&&(pe=!0,$e.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var ke=Y.renderers?Y.renderers[Ue.name]:null;ke?Y.renderers[Ue.name]=function(){for(var Re=arguments.length,Me=new Array(Re),z=0;z<Re;z++)Me[z]=arguments[z];var U=Ue.renderer.apply(this,Me);return U===!1&&(U=ke.apply(this,Me)),U}:Y.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[Ue.level]?Y[Ue.level].unshift(Ue.tokenizer):Y[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?Y.startBlock?Y.startBlock.push(Ue.start):Y.startBlock=[Ue.start]:Ue.level==="inline"&&(Y.startInline?Y.startInline.push(Ue.start):Y.startInline=[Ue.start]))}Ue.childTokens&&(Y.childTokens[Ue.name]=Ue.childTokens)})),$e.renderer&&function(){var Ue=de.defaults.renderer||new ge,ke=function(z){var U=Ue[z];Ue[z]=function(){for(var K=arguments.length,J=new Array(K),ne=0;ne<K;ne++)J[ne]=arguments[ne];var fe=$e.renderer[z].apply(Ue,J);return fe===!1&&(fe=U.apply(Ue,J)),fe}};for(var Re in $e.renderer)ke(Re);Z.renderer=Ue}(),$e.tokenizer&&function(){var Ue=de.defaults.tokenizer||new q,ke=function(z){var U=Ue[z];Ue[z]=function(){for(var K=arguments.length,J=new Array(K),ne=0;ne<K;ne++)J[ne]=arguments[ne];var fe=$e.tokenizer[z].apply(Ue,J);return fe===!1&&(fe=U.apply(Ue,J)),fe}};for(var Re in $e.tokenizer)ke(Re);Z.tokenizer=Ue}(),$e.walkTokens){var Ne=de.defaults.walkTokens;Z.walkTokens=function(Ue){var ke=[];return ke.push($e.walkTokens.call(this,Ue)),Ne&&(ke=ke.concat(Ne.call(this,Ue))),ke}}pe&&(Z.extensions=Y),de.setOptions(Z)})},de.walkTokens=function(ae,ve){for(var ue=[],Z=function(){var Ne=pe.value;switch(ue=ue.concat(ve.call(de,Ne)),Ne.type){case"table":{for(var Ue=M(Ne.header),ke;!(ke=Ue()).done;){var Re=ke.value;ue=ue.concat(de.walkTokens(Re.tokens,ve))}for(var Me=M(Ne.rows),z;!(z=Me()).done;)for(var U=z.value,K=M(U),J;!(J=K()).done;){var ne=J.value;ue=ue.concat(de.walkTokens(ne.tokens,ve))}break}case"list":{ue=ue.concat(de.walkTokens(Ne.items,ve));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[Ne.type]?de.defaults.extensions.childTokens[Ne.type].forEach(function(fe){ue=ue.concat(de.walkTokens(Ne[fe],ve))}):Ne.tokens&&(ue=ue.concat(de.walkTokens(Ne.tokens,ve)))}},Y=M(ae),pe;!(pe=Y()).done;)Z();return ue},de.parseInline=function(ae,ve){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");ve=D({},de.defaults,ve||{}),g(ve);try{var ue=ce.lexInline(ae,ve);return ve.walkTokens&&de.walkTokens(ue,ve.walkTokens),se.parseInline(ue,ve)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(Z.message+"",!0)+"</pre>";throw Z}},de.Parser=se,de.parser=se.parse,de.Renderer=ge,de.TextRenderer=te,de.Lexer=ce,de.lexer=ce.lex,de.Tokenizer=q,de.Slugger=me,de.parse=de;var be=de.options,re=de.setOptions,Pe=de.use,Fe=de.walkTokens,X=de.parseInline,B=de,_=se.parse,we=ce.lex;oe.Lexer=ce,oe.Parser=se,oe.Renderer=ge,oe.Slugger=me,oe.TextRenderer=te,oe.Tokenizer=q,oe.getDefaults=A,oe.lexer=we,oe.marked=de,oe.options=be,oe.parse=B,oe.parseInline=X,oe.parser=_,oe.setOptions=re,oe.use=Pe,oe.walkTokens=Fe,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ce[137],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=w;function w(r){const o=M(r);if(o&&o.length>0)return new Uint32Array(o)}let C=0;const P=new Uint32Array(10);function M(r){if(C=0,A(r,v,p.InitialConsonant),C>0||(A(r,l,p.Vowel),C>0)||(A(r,E,p.FinalConsonant),C>0)||(A(r,d,p.CompatibilityJamo),C))return P.subarray(0,C);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,h=Math.floor(o/588),n=Math.floor(a/28),s=a%28-1;if(h<v.length?A(h,v,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+h,d,p.CompatibilityJamo),n<l.length?A(n,l,0):p.Vowel+n-p.CompatibilityJamo<d.length&&A(p.Vowel+n-p.CompatibilityJamo,d,p.CompatibilityJamo),s>=0&&(s<E.length?A(s,E,0):p.FinalConsonant+s-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+s-p.CompatibilityJamo,d,p.CompatibilityJamo)),C>0)return P.subarray(0,C)}}function A(r,o,a){r>=a&&r<a+o.length&&N(o[r-a])}function N(r){r!==c.NUL&&(P[C++]=r&255,r>>8&&(P[C++]=r>>8&255),r>>16&&(P[C++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(c||(c={}));var R;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(R||(R={}));const v=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),l=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,R.hk,R.ho,R.hl,c.y,c.n,R.nj,R.np,R.nl,c.b,c.m,R.ml,c.l]),E=new Uint16Array([c.r,c.R,R.rt,c.s,R.sw,R.sg,c.e,c.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,c.a,c.q,R.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.r,c.R,R.rt,c.s,R.sw,R.sg,c.e,c.E,c.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,c.a,c.q,c.Q,R.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,R.hk,R.ho,R.hl,c.y,c.n,R.nj,R.np,R.nl,c.b,c.m,R.ml,c.l])}),define(Ce[138],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0,e.$Jm=w,e.rot=C,e.$Om=N;function w(p,c,R){return Math.min(Math.max(p,c),R)}function C(p,c){return(c+p%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Lm=P;class M{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Mm=M;class A{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const R=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nm=A;function N(p,c,R,v,l,E,d,r){const o=d-R,a=r-v,h=l-R,n=E-v,s=p-R,i=c-v,t=o*o+a*a,m=o*h+a*n,f=o*s+a*i,u=h*h+n*n,$=h*s+n*i,I=1/(t*u-m*m),D=(u*f-m*$)*I,y=(t*$-m*f)*I;return D>=0&&y>=0&&D+y<1}}),define(Ce[139],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=M,e.$dd=l;class w{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return M(d,this)}}e.$bd=w;const C=new Map,P=new WeakMap;function M(E,d){const r=P.get(E);if(r)return r;const o=A(E,d);if(o){let a=C.get(o)??0;a++,C.set(o,a);const h=a===1?o:`${o}#${a}`;return P.set(E,h),h}}function A(E,d){const r=P.get(E);if(r)return r;const o=d.owner?R(d.owner)+".":"";let a;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(a=h(),a!==void 0)return o+a}else return o+h;const n=d.referenceFn;if(n!==void 0&&(a=l(n),a!==void 0))return o+a;if(d.owner!==void 0){const s=N(d.owner,E);if(s!==void 0)return o+s}}function N(E,d){for(const r in E)if(E[r]===d)return r}const p=new Map,c=new WeakMap;function R(E){const d=c.get(E);if(d)return d;const r=v(E);let o=p.get(r)??0;o++,p.set(r,o);const a=o===1?r:`${r}#${o}`;return c.set(E,a),a}function v(E){const d=E.constructor;return d?d.name:"Object"}function l(E){const d=E.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Ce[140],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=C,e.$Ld=P;let w;function C(r){w=r}function P(){return w}class M{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([N(E("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[N(" "),c(R(o.oldValue,70),{color:"red",strikeThrough:!0}),N(" "),c(R(o.newValue,60),{color:"green"})]:[N(" (unchanged)")]:[N(" "),c(R(o.newValue,60),{color:"green"}),N(" (initial)")]}handleObservableChanged(o,a){console.log(...this.b([p("observable value changed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(o){if(o.size!==0)return c(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,n)=>(this.d.get(o).add(h),a.apply(o,[h,n]))}handleDerivedRecomputed(o,a){const h=this.d.get(o);console.log(...this.b([p("derived recomputed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.b([p("observable from event triggered"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,n)=>(this.d.get(o).add(h),a.apply(o,[h,n]))}handleAutorunTriggered(o){const a=this.d.get(o);console.log(...this.b([p("autorun"),c(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.b([p("transaction"),c(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=M;function A(r){const o=new Array,a=[];let h="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(h+=`%c${i.text}`,o.push(i.style),i.data&&a.push(...i.data)):"data"in i&&a.push(...i.data)}n(r);const s=[h,...o];return s.push(...a),s}function N(r){return c(r,{color:"black"})}function p(r){return c(d(`${r}: `,10),{color:"black",bold:!0})}function c(r,o={color:"black"}){function a(n){return Object.entries(n).reduce((s,[i,t])=>`${s}${i}:${t};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:r,style:a(h)}}function R(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?v(r,o):l(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function v(r,o){let a="[ ",h=!0;for(const n of r){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${R(n,o-a.length)}`}return a+=" ]",a}function l(r,o){let a="{ ",h=!0;for(const[n,s]of Object.entries(r)){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${n}: ${R(s,o-a.length)}`}return a+=" }",a}function E(r,o){let a="";for(let h=1;h<=o;h++)a+=r;return a}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ce[141],Ie([1,0,134,139,140]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=A,e.$Wd=p,e.$Xd=R,e.$1d=E,e.$2d=r,e.$3d=o,e.$4d=a,e.$6d=n,e.$8d=i;let M;function A(m){M=m}let N;function p(m){N=m}let c;function R(m){c=m}class v{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,u){const $=u===void 0?void 0:f,I=u===void 0?f:u;return c({owner:$,debugName:()=>{const D=(0,C.$dd)(I);if(D!==void 0)return D;const S=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(I.toString());if(S)return`${this.debugName}.${S[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:I},D=>I(this.read(D),D))}recomputeInitiallyAndOnChange(f,u){return f.add(M(this,u)),this}keepObserved(f){return f.add(N(this)),this}get a(){return this.get()}}e.$Yd=v;class l extends v{constructor(){super(...arguments),this.b=new Set}addObserver(f){const u=this.b.size;this.b.add(f),u===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=l;function E(m,f){const u=new h(m,f);try{m(u)}finally{u.finish()}}let d;function r(m){if(d)m(d);else{const f=new h(m,void 0);d=f;try{m(f)}finally{f.finish(),d=void 0}}}async function o(m,f){const u=new h(m,f);try{await m(u)}finally{u.finish()}}function a(m,f,u){m?f(m):E(f,u)}class h{constructor(f,u){this._fn=f,this.b=u,this.a=[],(0,P.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$dd)(this._fn)}updateObserver(f,u){this.a.push({observer:f,observable:u}),f.beginUpdate(u)}finish(){const f=this.a;for(let u=0;u<f.length;u++){const{observer:$,observable:I}=f[u];$.endUpdate(I)}this.a=null,(0,P.$Ld)()?.handleEndTransaction()}}e.$5d=h;function n(m,f){let u;return typeof m=="string"?u=new C.$bd(void 0,m,void 0):u=new C.$bd(m,void 0,void 0),new s(u,f,w.$7c)}class s extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,u,$){super(),this.e=f,this.g=$,this.d=u}get(){return this.d}set(f,u,$){if($===void 0&&this.g(this.d,f))return;let I;u||(u=I=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(f),(0,P.$Ld)()?.handleObservableChanged(this,{oldValue:D,newValue:f,change:$,didChange:!0,hadValue:!0});for(const y of this.b)u.updateObserver(y,this),y.handleChange(this,$)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$7d=s;function i(m,f){let u;return typeof m=="string"?u=new C.$bd(void 0,m,void 0):u=new C.$bd(m,void 0,void 0),new t(u,f,w.$7c)}class t extends s{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$9d=t}),function(){function oe(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function A(p){M.push(p,Date.now())}function N(){const p=[];for(let c=0;c<M.length;c+=2)p.push({name:M[c],startTime:M[c+1]});return p}return{mark:A,getMarks:N}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(P+A.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=w(C))}(),define(Ce[142],Ie([1,0,40]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=void 0;const C=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||w.Iterable.empty()}insert(p,c,R){this.d(p,v=>v._value=c,R)}mutate(p,c){this.d(p,R=>R._value=c(R._value===C?void 0:R._value))}mutatePath(p,c){this.d(p,()=>{},R=>c(R))}delete(p){const c=this.c(p);if(!c)return;let R=c.length-1;const v=c[R].node._value;if(v!==C){for(this.b--,c[R].node._value=C;R>0;R--){const{node:l,part:E}=c[R];if(l.children?.size||l._value!==C)break;c[R-1].node.children.delete(E)}return v}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const R=c[c.length-1].node;for(let v=c.length-1;v>0;v--){const l=c[v-1];if(l.node.children.delete(c[v].part),l.node.children.size>0||l.node._value!==C)break}for(const v of M(R))v._value!==C&&(this.b--,yield v._value)}find(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return;c=v}return c._value===C?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;if(v._value!==C)return!0;c=v}return!1}hasKeyOrChildren(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;c=v}return!0}hasKey(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;c=v}return c._value!==C}c(p){const c=[{part:"",node:this.a}];let R=0;for(const v of p){const l=c[R].node.children?.get(v);if(!l)return;c.push({part:v,node:l}),R++}return c}d(p,c,R){let v=this.a;for(const d of p){if(v.children)if(v.children.has(d))v=v.children.get(d);else{const r=new A;v.children.set(d,r),v=r}else{const r=new A;v.children=new Map([[d,r]]),v=r}R?.(v)}const l=v._value===C?0:1;c(v);const E=v._value===C?0:1;this.b+=E-l}*values(){for(const{_value:p}of M(this.a))p!==C&&(yield p)}}e.$NI=P;function*M(N){const p=[N];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const R of c.children.values())p.push(R)}}class A{constructor(){this._value=C}get value(){return this._value===C?void 0:this._value}set value(p){this._value=p===void 0?C:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var C in w)(typeof exports=="object"?exports:oe)[C]=w[C]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(C){if(e[C])return e[C].exports;var P=e[C]={i:C,l:!1,exports:{}};return oe[C].call(P.exports,P,P.exports,w),P.l=!0,P.exports}return w.m=oe,w.c=e,w.d=function(C,P,M){w.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:M})},w.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},w.t=function(C,P){if(1&P&&(C=w(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(w.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var A in C)w.d(M,A,function(N){return C[N]}.bind(null,A));return M},w.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return w.d(P,"a",P),P},w.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},w.p="",w(w.s=0)}([function(oe,e,w){(function(C){var P;e=oe.exports=Pe,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,N=e.re=[],p=e.src=[],c=0,R=c++;p[R]="0|[1-9]\\d*";var v=c++;p[v]="[0-9]+";var l=c++;p[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=c++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var d=c++;p[d]="("+p[v]+")\\.("+p[v]+")\\.("+p[v]+")";var r=c++;p[r]="(?:"+p[R]+"|"+p[l]+")";var o=c++;p[o]="(?:"+p[v]+"|"+p[l]+")";var a=c++;p[a]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var h=c++;p[h]="(?:-?("+p[o]+"(?:\\."+p[o]+")*))";var n=c++;p[n]="[0-9A-Za-z-]+";var s=c++;p[s]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var i=c++,t="v?"+p[E]+p[a]+"?"+p[s]+"?";p[i]="^"+t+"$";var m="[v=\\s]*"+p[d]+p[h]+"?"+p[s]+"?",f=c++;p[f]="^"+m+"$";var u=c++;p[u]="((?:<|>)?=?)";var $=c++;p[$]=p[v]+"|x|X|\\*";var I=c++;p[I]=p[R]+"|x|X|\\*";var D=c++;p[D]="[v=\\s]*("+p[I]+")(?:\\.("+p[I]+")(?:\\.("+p[I]+")(?:"+p[a]+")?"+p[s]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[s]+"?)?)?";var S=c++;p[S]="^"+p[u]+"\\s*"+p[D]+"$";var k=c++;p[k]="^"+p[u]+"\\s*"+p[y]+"$";var g=c++;p[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=c++;p[b]="(?:~>?)";var F=c++;p[F]="(\\s*)"+p[b]+"\\s+",N[F]=new RegExp(p[F],"g");var T=c++;p[T]="^"+p[b]+p[D]+"$";var q=c++;p[q]="^"+p[b]+p[y]+"$";var G=c++;p[G]="(?:\\^)";var V=c++;p[V]="(\\s*)"+p[G]+"\\s+",N[V]=new RegExp(p[V],"g");var O=c++;p[O]="^"+p[G]+p[D]+"$";var W=c++;p[W]="^"+p[G]+p[y]+"$";var ce=c++;p[ce]="^"+p[u]+"\\s*("+m+")$|^$";var ge=c++;p[ge]="^"+p[u]+"\\s*("+t+")$|^$";var te=c++;p[te]="(\\s*)"+p[u]+"\\s*("+m+"|"+p[D]+")",N[te]=new RegExp(p[te],"g");var me=c++;p[me]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var se=c++;p[se]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var de=c++;p[de]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)P(be,p[be]),N[be]||(N[be]=new RegExp(p[be]));function re(U,K){if(U instanceof Pe)return U;if(typeof U!="string"||U.length>M||!(K?N[f]:N[i]).test(U))return null;try{return new Pe(U,K)}catch{return null}}function Pe(U,K){if(U instanceof Pe){if(U.loose===K)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Pe))return new Pe(U,K);P("SemVer",U,K),this.loose=K;var J=U.trim().match(K?N[f]:N[i]);if(!J)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=re,e.valid=function(U,K){var J=re(U,K);return J?J.version:null},e.clean=function(U,K){var J=re(U.trim().replace(/^[=v]+/,""),K);return J?J.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(U){return P("SemVer.compare",this.version,this.loose,U),U instanceof Pe||(U=new Pe(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Pe.prototype.compareMain=function(U){return U instanceof Pe||(U=new Pe(U,this.loose)),X(this.major,U.major)||X(this.minor,U.minor)||X(this.patch,U.patch)},Pe.prototype.comparePre=function(U){if(U instanceof Pe||(U=new Pe(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],ne=U.prerelease[K];if(P("prerelease compare",K,J,ne),J===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(J===void 0)return-1;if(J!==ne)return X(J,ne)}while(++K)},Pe.prototype.inc=function(U,K){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,K,J,ne){typeof J=="string"&&(ne=J,J=void 0);try{return new Pe(U,J).inc(K,ne).version}catch{return null}},e.diff=function(U,K){if(ae(U,K))return null;var J=re(U),ne=re(K);if(J.prerelease.length||ne.prerelease.length){for(var fe in J)if((fe==="major"||fe==="minor"||fe==="patch")&&J[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in J)if((fe==="major"||fe==="minor"||fe==="patch")&&J[fe]!==ne[fe])return fe},e.compareIdentifiers=X;var Fe=/^[0-9]+$/;function X(U,K){var J=Fe.test(U),ne=Fe.test(K);return J&&ne&&(U=+U,K=+K),J&&!ne?-1:ne&&!J?1:U<K?-1:U>K?1:0}function B(U,K,J){return new Pe(U,J).compare(new Pe(K,J))}function _(U,K,J){return B(U,K,J)>0}function we(U,K,J){return B(U,K,J)<0}function ae(U,K,J){return B(U,K,J)===0}function ve(U,K,J){return B(U,K,J)!==0}function ue(U,K,J){return B(U,K,J)>=0}function Z(U,K,J){return B(U,K,J)<=0}function Y(U,K,J,ne){var fe;switch(K){case"===":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),fe=U===J;break;case"!==":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),fe=U!==J;break;case"":case"=":case"==":fe=ae(U,J,ne);break;case"!=":fe=ve(U,J,ne);break;case">":fe=_(U,J,ne);break;case">=":fe=ue(U,J,ne);break;case"<":fe=we(U,J,ne);break;case"<=":fe=Z(U,J,ne);break;default:throw new TypeError("Invalid operator: "+K)}return fe}function pe(U,K){if(U instanceof pe){if(U.loose===K)return U;U=U.value}if(!(this instanceof pe))return new pe(U,K);P("comparator",U,K),this.loose=K,this.parse(U),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(U,K){return X(K,U)},e.major=function(U,K){return new Pe(U,K).major},e.minor=function(U,K){return new Pe(U,K).minor},e.patch=function(U,K){return new Pe(U,K).patch},e.compare=B,e.compareLoose=function(U,K){return B(U,K,!0)},e.rcompare=function(U,K,J){return B(K,U,J)},e.sort=function(U,K){return U.sort(function(J,ne){return e.compare(J,ne,K)})},e.rsort=function(U,K){return U.sort(function(J,ne){return e.rcompare(J,ne,K)})},e.gt=_,e.lt=we,e.eq=ae,e.neq=ve,e.gte=ue,e.lte=Z,e.cmp=Y,e.Comparator=pe;var $e={};function Ne(U,K){if(U instanceof Ne)return U.loose===K?U:new Ne(U.raw,K);if(U instanceof pe)return new Ne(U.value,K);if(!(this instanceof Ne))return new Ne(U,K);if(this.loose=K,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function Ue(U){return!U||U.toLowerCase()==="x"||U==="*"}function ke(U,K,J,ne,fe,Ae,ze,Ke,_e,it,nt,tt,rt){return((K=Ue(J)?"":Ue(ne)?">="+J+".0.0":Ue(fe)?">="+J+"."+ne+".0":">="+K)+" "+(Ke=Ue(_e)?"":Ue(it)?"<"+(+_e+1)+".0.0":Ue(nt)?"<"+_e+"."+(+it+1)+".0":tt?"<="+_e+"."+it+"."+nt+"-"+tt:"<="+Ke)).trim()}function Re(U,K){for(var J=0;J<U.length;J++)if(!U[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<U.length;J++)if(P(U[J].semver),U[J].semver!==$e&&U[J].semver.prerelease.length>0){var ne=U[J].semver;if(ne.major===K.major&&ne.minor===K.minor&&ne.patch===K.patch)return!0}return!1}return!0}function Me(U,K,J){try{K=new Ne(K,J)}catch{return!1}return K.test(U)}function z(U,K,J,ne){var fe,Ae,ze,Ke,_e;switch(U=new Pe(U,ne),K=new Ne(K,ne),J){case">":fe=_,Ae=Z,ze=we,Ke=">",_e=">=";break;case"<":fe=we,Ae=ue,ze=_,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(U,K,ne))return!1;for(var it=0;it<K.set.length;++it){var nt=K.set[it],tt=null,rt=null;if(nt.forEach(function($t){$t.semver===$e&&($t=new pe(">=0.0.0")),tt=tt||$t,rt=rt||$t,fe($t.semver,tt.semver,ne)?tt=$t:ze($t.semver,rt.semver,ne)&&(rt=$t)}),tt.operator===Ke||tt.operator===_e||(!rt.operator||rt.operator===Ke)&&Ae(U,rt.semver)||rt.operator===_e&&ze(U,rt.semver))return!1}return!0}pe.prototype.parse=function(U){var K=this.loose?N[ce]:N[ge],J=U.match(K);if(!J)throw new TypeError("Invalid comparator: "+U);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Pe(J[2],this.loose):this.semver=$e},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(U){return P("Comparator.test",U,this.loose),this.semver===$e||(typeof U=="string"&&(U=new Pe(U,this.loose)),Y(U,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(U,K){if(!(U instanceof pe))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Ne(U.value,K),Me(this.value,J,K);if(U.operator==="")return J=new Ne(this.value,K),Me(U.semver,J,K);var ne=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Ae=this.semver.version===U.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ke=Y(this.semver,"<",U.semver,K)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),_e=Y(this.semver,">",U.semver,K)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ne||fe||Ae&&ze||Ke||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(U){var K=this.loose;U=U.trim(),P("range",U,K);var J=K?N[se]:N[me];U=U.replace(J,ke),P("hyphen replace",U),U=U.replace(N[te],"$1$2$3"),P("comparator trim",U,N[te]),U=(U=(U=U.replace(N[F],"$1~")).replace(N[V],"$1^")).split(/\s+/).join(" ");var ne=K?N[ce]:N[ge],fe=U.split(" ").map(function(Ae){return function(ze,Ke){return P("comp",ze),ze=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){P("caret",tt,rt);var $t=rt?N[W]:N[O];return tt.replace($t,function(ut,st,ct,gt,mt){var Be;return P("caret",tt,ut,st,ct,gt,mt),Ue(st)?Be="":Ue(ct)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(gt)?Be=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":mt?(P("replaceCaret pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),Be=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+mt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+mt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+mt+" <"+(+st+1)+".0.0"):(P("no pr"),Be=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+" <"+(+st+1)+".0.0"),P("caret return",Be),Be})}(nt,it)}).join(" ")}(ze,Ke),P("caret",ze),ze=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){var $t=rt?N[q]:N[T];return tt.replace($t,function(ut,st,ct,gt,mt){var Be;return P("tilde",tt,ut,st,ct,gt,mt),Ue(st)?Be="":Ue(ct)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(gt)?Be=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":mt?(P("replaceTilde pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),Be=">="+st+"."+ct+"."+gt+mt+" <"+st+"."+(+ct+1)+".0"):Be=">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0",P("tilde return",Be),Be})}(nt,it)}).join(" ")}(ze,Ke),P("tildes",ze),ze=function(_e,it){return P("replaceXRanges",_e,it),_e.split(/\s+/).map(function(nt){return function(tt,rt){tt=tt.trim();var $t=rt?N[k]:N[S];return tt.replace($t,function(ut,st,ct,gt,mt,Be){P("xRange",tt,ut,st,ct,gt,mt,Be);var je=Ue(ct),H=je||Ue(gt),x=H||Ue(mt);return st==="="&&x&&(st=""),je?ut=st===">"||st==="<"?"<0.0.0":"*":st&&x?(H&&(gt=0),x&&(mt=0),st===">"?(st=">=",H?(ct=+ct+1,gt=0,mt=0):x&&(gt=+gt+1,mt=0)):st==="<="&&(st="<",H?ct=+ct+1:gt=+gt+1),ut=st+ct+"."+gt+"."+mt):H?ut=">="+ct+".0.0 <"+(+ct+1)+".0.0":x&&(ut=">="+ct+"."+gt+".0 <"+ct+"."+(+gt+1)+".0"),P("xRange return",ut),ut})}(nt,it)}).join(" ")}(ze,Ke),P("xrange",ze),ze=function(_e,it){return P("replaceStars",_e,it),_e.trim().replace(N[de],"")}(ze,Ke),P("stars",ze),ze}(Ae,K)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ae){return!!Ae.match(ne)})),fe=fe.map(function(Ae){return new pe(Ae,K)})},Ne.prototype.intersects=function(U,K){if(!(U instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ne){return U.set.some(function(fe){return fe.every(function(Ae){return ne.intersects(Ae,K)})})})})},e.toComparators=function(U,K){return new Ne(U,K).set.map(function(J){return J.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Pe(U,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],U))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(U,K,J){var ne=null,fe=null;try{var Ae=new Ne(K,J)}catch{return null}return U.forEach(function(ze){Ae.test(ze)&&(ne&&fe.compare(ze)!==-1||(fe=new Pe(ne=ze,J)))}),ne},e.minSatisfying=function(U,K,J){var ne=null,fe=null;try{var Ae=new Ne(K,J)}catch{return null}return U.forEach(function(ze){Ae.test(ze)&&(ne&&fe.compare(ze)!==1||(fe=new Pe(ne=ze,J)))}),ne},e.validRange=function(U,K){try{return new Ne(U,K).range||"*"}catch{return null}},e.ltr=function(U,K,J){return z(U,K,"<",J)},e.gtr=function(U,K,J){return z(U,K,">",J)},e.outside=z,e.prerelease=function(U,K){var J=re(U,K);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(U,K,J){return U=new Ne(U,J),K=new Ne(K,J),U.intersects(K)},e.coerce=function(U){if(U instanceof Pe)return U;if(typeof U!="string")return null;var K=U.match(N[g]);return K==null?null:re((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,C,P=oe.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function N(o){if(w===setTimeout)return setTimeout(o,0);if((w===M||!w)&&setTimeout)return w=setTimeout,setTimeout(o,0);try{return w(o,0)}catch{try{return w.call(null,o,0)}catch{return w.call(this,o,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:M}catch{w=M}try{C=typeof clearTimeout=="function"?clearTimeout:A}catch{C=A}})();var p,c=[],R=!1,v=-1;function l(){R&&p&&(R=!1,p.length?c=p.concat(c):v=-1,c.length&&E())}function E(){if(!R){var o=N(l);R=!0;for(var a=c.length;a;){for(p=c,c=[];++v<a;)p&&p[v].run();v=-1,a=c.length}p=null,R=!1,function(h){if(C===clearTimeout)return clearTimeout(h);if((C===A||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(h);try{C(h)}catch{try{return C.call(null,h)}catch{return C.call(this,h)}}}(o)}}function d(o,a){this.fun=o,this.array=a}function r(){}P.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];c.push(new d(o,a)),c.length!==1||R||N(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ce[143],Ie([1,0,4,5]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$$s=e.$0s=e.$9s=e.ScrollbarVisibility=void 0;var P;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class M{constructor(d,r,o,a,h,n,s){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,a=a|0,h=h|0,n=n|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),h<0&&(h=0),s+h>n&&(s=n-h),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=h,this.scrollHeight=n,this.scrollTop=s}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new M(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new M(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,a=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,n=this.height!==d.height,s=this.scrollHeight!==d.scrollHeight,i=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:n,scrollHeightChanged:s,scrollTopChanged:i}}}e.$9s=M;class A extends C.$Vc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new w.$le),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new M(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let a;r?a=new R(this.h.from,o,this.h.startTime,this.h.duration):a=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=a}else{const o=this.g.withScrollPosition(d);this.h=R.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$0s=A;class N{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$$s=N;function p(E,d){const r=d-E;return function(o){return E+r*l(o)}}function c(E,d,r){return function(o){return o<r?E(o/r):d((o-r)/(1-r))}}class R{constructor(d,r,o,a){this.from=d,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let h,n;return d<r?(h=d+.75*o,n=r-.75*o):(h=d-.75*o,n=r+.75*o),c(p(d,h),p(n,r),.33)}return p(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),a=this.d(r);return new N(o,a,!1)}return new N(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return R.start(d,r,o)}static start(d,r,o){o=o+10;const a=Date.now()-10;return new R(d,r,a,o)}}e.$_s=R;function v(E){return Math.pow(E,3)}function l(E){return 1-v(1-E)}}),define(Ce[144],Ie([1,0,14,5]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=P,e.$ze=M,e.$Ae=A,e.$Be=N,e.$Ce=c,e.$De=R,e.$Ee=v,e.$Fe=l,e.$Ge=E,e.$He=d,e.$Ie=r,e.$Je=o,e.$Ke=a,e.$Le=h,e.$Me=n;function P(s){const i=s;return i?typeof i.read=="function":!1}function M(s){const i=s;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function A(s){const i=s;return i?M(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function N(s,i){return new p(s,i)}class p{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,w.$2)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let m;switch(i){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const f=m.indexOf(t);f>=0&&m.splice(f,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,i){const t=[];let m;for(;(m=s.read())!==null;)t.push(m);return i(t)}function R(s,i,t){const m=[];let f;for(;(f=s.read())!==null&&m.length<t;)m.push(f);return f===null&&m.length>0?i(m):{read:()=>{if(m.length>0)return m.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return s.read()}}}function v(s,i){return new Promise((t,m)=>{const f=[];l(s,{onData:u=>{i&&f.push(u)},onError:u=>{i?m(u):t(void 0)},onEnd:()=>{t(i?i(f):void 0)}})})}function l(s,i,t){s.on("error",m=>{t?.isCancellationRequested||i.onError(m)}),s.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),s.on("data",m=>{t?.isCancellationRequested||i.onData(m)})}function E(s,i){return new Promise((t,m)=>{const f=new C.$Uc,u=[],$=y=>{if(u.push(y),u.length>i)return f.dispose(),s.pause(),t({stream:s,buffer:u,ended:!1})},I=y=>(f.dispose(),m(y)),D=()=>(f.dispose(),t({stream:s,buffer:u,ended:!0}));f.add((0,C.$Tc)(()=>s.removeListener("error",I))),s.on("error",I),f.add((0,C.$Tc)(()=>s.removeListener("end",D))),s.on("end",D),f.add((0,C.$Tc)(()=>s.removeListener("data",$))),s.on("data",$)})}function d(s,i){const t=N(i);return t.end(s),t}function r(){const s=N(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let i=!1;return{read:()=>i?null:(i=!0,s)}}function a(s,i,t){const m=N(t);return l(s,{onData:f=>m.write(i.data(f)),onError:f=>m.error(i.error?i.error(f):f),onEnd:()=>m.end()}),m}function h(s,i,t){let m=!1;return{read:()=>{const f=i.read();return m?f:(m=!0,f!==null?t([s,f]):s)}}}function n(s,i,t){let m=!1;const f=N(t);return l(i,{onData:u=>m?f.write(u):(m=!0,f.write(t([s,u]))),onError:u=>f.error(u),onEnd:()=>{m||(m=!0,f.write(s)),f.end()}}),f}}),define(Ce[23],Ie([1,0,47,144]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=c,e.$Pe=R,e.$Qe=v,e.$Re=l,e.$Se=E,e.$Te=d,e.$Ue=r,e.$Ve=o,e.$We=a,e.$Xe=h,e.$Ye=n,e.$Ze=s,e.$1e=i,e.$2e=t,e.$3e=m,e.$4e=f,e.$5e=u,e.$6e=$,e.$7e=I,e.$8e=S,C=qe(C);const P=typeof Buffer<"u",M=new w.$W(()=>new Uint8Array(256));let A,N;class p{static alloc(g){return P?new p(Buffer.allocUnsafe(g)):new p(new Uint8Array(g))}static wrap(g){return P&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new p(g)}static fromString(g,b){return!(b?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(g)):(A||(A=new TextEncoder),new p(A.encode(g)))}static fromByteArray(g){const b=p.alloc(g.length);for(let F=0,T=g.length;F<T;F++)b.buffer[F]=g[F];return b}static concat(g,b){if(typeof b>"u"){b=0;for(let q=0,G=g.length;q<G;q++)b+=g[q].byteLength}const F=p.alloc(b);let T=0;for(let q=0,G=g.length;q<G;q++){const V=g[q];F.set(V,T),T+=V.byteLength}return F}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=p.alloc(this.byteLength);return g.set(this),g}toString(){return P?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(g,b){return new p(this.buffer.subarray(g,b))}set(g,b){if(g instanceof p)this.buffer.set(g.buffer,b);else if(g instanceof Uint8Array)this.buffer.set(g,b);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),b);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return l(this.buffer,g)}writeUInt32BE(g,b){E(this.buffer,g,b)}readUInt32LE(g){return d(this.buffer,g)}writeUInt32LE(g,b){r(this.buffer,g,b)}readUInt8(g){return o(this.buffer,g)}writeUInt8(g,b){a(this.buffer,g,b)}indexOf(g,b=0){return c(this.buffer,g instanceof p?g.buffer:g,b)}}e.$Ne=p;function c(k,g,b=0){const F=g.byteLength,T=k.byteLength;if(F===0)return 0;if(F===1)return k.indexOf(g[0]);if(F>T-b)return-1;const q=M.value;q.fill(g.length);for(let W=0;W<g.length;W++)q[g[W]]=g.length-W-1;let G=b+g.length-1,V=G,O=-1;for(;G<T;)if(k[G]===g[V]){if(V===0){O=G;break}G--,V--}else G+=Math.max(g.length-V,q[k[G]]),V=g.length-1;return O}function R(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0}function v(k,g,b){k[b+0]=g&255,g=g>>>8,k[b+1]=g&255}function l(k,g){return k[g]*2**24+k[g+1]*2**16+k[g+2]*2**8+k[g+3]}function E(k,g,b){k[b+3]=g,g=g>>>8,k[b+2]=g,g=g>>>8,k[b+1]=g,g=g>>>8,k[b]=g}function d(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0|k[g+2]<<16>>>0|k[g+3]<<24>>>0}function r(k,g,b){k[b+0]=g&255,g=g>>>8,k[b+1]=g&255,g=g>>>8,k[b+2]=g&255,g=g>>>8,k[b+3]=g&255}function o(k,g){return k[g]}function a(k,g,b){k[b]=g}function h(k){return C.$Ce(k,g=>p.concat(g))}function n(k){return C.$Je(k)}function s(k){return C.$Ee(k,g=>p.concat(g))}async function i(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await s(k.stream)])}function t(k){return C.$He(k,g=>p.concat(g))}function m(k){return C.$Ke(k,{data:g=>typeof g=="string"?p.fromString(g):p.wrap(g)},g=>p.concat(g))}function f(k){return C.$Be(g=>p.concat(g),k)}function u(k,g){return C.$Le(k,g,b=>p.concat(b))}function $(k,g){return C.$Me(k,g,b=>p.concat(b))}function I(k){let g=0,b=0,F=0;const T=new Uint8Array(Math.floor(k.length/4*3)),q=V=>{switch(b){case 3:T[F++]=g|V,b=0;break;case 2:T[F++]=g|V>>>2,g=V<<6,b=3;break;case 1:T[F++]=g|V>>>4,g=V<<4,b=2;break;default:g=V<<2,b=1}};for(let V=0;V<k.length;V++){const O=k.charCodeAt(V);if(O>=65&&O<=90)q(O-65);else if(O>=97&&O<=122)q(O-97+26);else if(O>=48&&O<=57)q(O-48+52);else if(O===43||O===45)q(62);else if(O===47||O===95)q(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${k[V]}`)}}const G=F;for(;b>0;)q(0);return p.wrap(T).slice(0,G)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:k},g=!0,b=!1){const F=b?y:D;let T="";const q=k.byteLength%3;let G=0;for(;G<k.byteLength-q;G+=3){const V=k[G+0],O=k[G+1],W=k[G+2];T+=F[V>>>2],T+=F[(V<<4|O>>>4)&63],T+=F[(O<<2|W>>>6)&63],T+=F[W&63]}if(q===1){const V=k[G+0];T+=F[V>>>2],T+=F[V<<4&63],g&&(T+="==")}else if(q===2){const V=k[G+0],O=k[G+1];T+=F[V>>>2],T+=F[(V<<4|O>>>4)&63],T+=F[O<<2&63],g&&(T+="=")}return T}}),define(Ce[145],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(Ce[35],Ie([1,0,98]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=P;var C;(function(A){function N(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=N})(C||(e.ThemeColor=C={}));function P(A){return{id:A}}var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const N=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const n=N.exec(h.id);if(!n)return p(w.$4j.error);const[,s,i]=n,t=["codicon","codicon-"+s];return i&&t.push("codicon-modifier-"+i.substring(1)),t}A.asClassNameArray=p;function c(h){return p(h).join(" ")}A.asClassName=c;function R(h){return"."+p(h).join(".")}A.asCSSSelector=R;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||C.isThemeColor(h.color))}A.isThemeIcon=v;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const n=l.exec(h);if(!n)return;const[,s]=n;return{id:s}}A.fromString=E;function d(h){return{id:h}}A.fromId=d;function r(h,n){let s=h.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}A.modify=r;function o(h){const n=h.id.lastIndexOf("~");if(n!==-1)return h.id.substring(n+1)}A.getModifier=o;function a(h,n){return h.id===n.id&&h.color?.id===n.color?.id}A.isEqual=a})(M||(e.ThemeIcon=M={}))}),define(Ce[146],Ie([1,0,28,29,137,13]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.FuzzyScore=e.$Gk=e.$Fk=void 0,e.or=A,e.$Hk=p,e.$Ik=c,e.$Jk=l,e.$Kk=D,e.$Lk=y,e.$Mk=T,e.$Nk=q,e.$Ok=G,e.$Pk=V,e.$Qk=_,e.$Sk=ue,e.$Tk=pe,e.$Uk=$e,M=qe(M);function A(...ke){return function(Re,Me){for(let z=0,U=ke.length;z<U;z++){const K=ke[z](Re,Me);if(K)return K}return null}}e.$Fk=N.bind(void 0,!1),e.$Gk=N.bind(void 0,!0);function N(ke,Re,Me){if(!Me||Me.length<Re.length)return null;let z;return ke?z=M.$Gf(Me,Re):z=Me.indexOf(Re)===0,z?Re.length>0?[{start:0,end:Re.length}]:[]:null}function p(ke,Re){const Me=Re.toLowerCase().indexOf(ke.toLowerCase());return Me===-1?null:[{start:Me,end:Me+ke.length}]}function c(ke,Re){return R(ke.toLowerCase(),Re.toLowerCase(),0,0)}function R(ke,Re,Me,z){if(Me===ke.length)return[];if(z===Re.length)return null;if(ke[Me]===Re[z]){let U=null;return(U=R(ke,Re,Me+1,z+1))?i({start:z,end:z+1},U):null}return R(ke,Re,Me,z+1)}function v(ke){return w.CharCode.a<=ke&&ke<=w.CharCode.z}function l(ke){return w.CharCode.A<=ke&&ke<=w.CharCode.Z}function E(ke){return w.CharCode.Digit0<=ke&&ke<=w.CharCode.Digit9}function d(ke){return ke===w.CharCode.Space||ke===w.CharCode.Tab||ke===w.CharCode.LineFeed||ke===w.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>r.add(ke.charCodeAt(0)));function o(ke){return d(ke)||r.has(ke)}function a(ke,Re){return ke===Re||o(ke)&&o(Re)}const h=new Map;function n(ke){if(h.has(ke))return h.get(ke);let Re;const Me=(0,P.$Dk)(ke);return Me&&(Re=Me),h.set(ke,Re),Re}function s(ke){return v(ke)||l(ke)||E(ke)}function i(ke,Re){return Re.length===0?Re=[ke]:ke.end===Re[0].start?Re[0].start=ke.start:Re.unshift(ke),Re}function t(ke,Re){for(let Me=Re;Me<ke.length;Me++){const z=ke.charCodeAt(Me);if(l(z)||E(z)||Me>0&&!s(ke.charCodeAt(Me-1)))return Me}return ke.length}function m(ke,Re,Me,z){if(Me===ke.length)return[];if(z===Re.length)return null;if(ke[Me]!==Re[z].toLowerCase())return null;{let U=null,K=z+1;for(U=m(ke,Re,Me+1,z+1);!U&&(K=t(Re,K))<Re.length;)U=m(ke,Re,Me+1,K),K++;return U===null?null:i({start:z,end:z+1},U)}}function f(ke){let Re=0,Me=0,z=0,U=0,K=0;for(let ze=0;ze<ke.length;ze++)K=ke.charCodeAt(ze),l(K)&&Re++,v(K)&&Me++,s(K)&&z++,E(K)&&U++;const J=Re/ke.length,ne=Me/ke.length,fe=z/ke.length,Ae=U/ke.length;return{upperPercent:J,lowerPercent:ne,alphaPercent:fe,numericPercent:Ae}}function u(ke){const{upperPercent:Re,lowerPercent:Me}=ke;return Me===0&&Re>.6}function $(ke){const{upperPercent:Re,lowerPercent:Me,alphaPercent:z,numericPercent:U}=ke;return Me>.2&&Re<.8&&z>.6&&U<.2}function I(ke){let Re=0,Me=0,z=0,U=0;for(let K=0;K<ke.length;K++)z=ke.charCodeAt(K),l(z)&&Re++,v(z)&&Me++,d(z)&&U++;return(Re===0||Me===0)&&U===0?ke.length<=30:Re<=5}function D(ke,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!I(ke))return null;Re.length>60&&(Re=Re.substring(0,60));const Me=f(Re);if(!$(Me)){if(!u(Me))return null;Re=Re.toLowerCase()}let z=null,U=0;for(ke=ke.toLowerCase();U<Re.length&&(z=m(ke,Re,0,U))===null;)U=t(Re,U+1);return z}function y(ke,Re,Me=!1){if(!Re||Re.length===0)return null;let z=null,U=0;for(ke=ke.toLowerCase(),Re=Re.toLowerCase();U<Re.length&&(z=S(ke,Re,0,U,Me),z===null);)U=k(Re,U+1);return z}function S(ke,Re,Me,z,U){let K=0;if(Me===ke.length)return[];if(z===Re.length)return null;if(!a(ke.charCodeAt(Me),Re.charCodeAt(z))){const fe=n(ke.charCodeAt(Me));if(!fe)return null;for(let Ae=0;Ae<fe.length;Ae++)if(!a(fe[Ae],Re.charCodeAt(z+Ae)))return null;K+=fe.length-1}let J=null,ne=z+K+1;if(J=S(ke,Re,Me+1,ne,U),!U)for(;!J&&(ne=k(Re,ne))<Re.length;)J=S(ke,Re,Me+1,ne,U),ne++;if(!J)return null;if(ke.charCodeAt(Me)!==Re.charCodeAt(z)){const fe=n(ke.charCodeAt(Me));if(!fe)return J;for(let Ae=0;Ae<fe.length;Ae++)if(fe[Ae]!==Re.charCodeAt(z+Ae))return J}return i({start:z,end:z+K+1},J)}function k(ke,Re){for(let Me=Re;Me<ke.length;Me++)if(o(ke.charCodeAt(Me))||Me>0&&o(ke.charCodeAt(Me-1)))return Me;return ke.length}const g=A(e.$Gk,D,p),b=A(e.$Gk,D,c),F=new C.$Ec(1e4);function T(ke,Re,Me=!1){if(typeof ke!="string"||typeof Re!="string")return null;let z=F.get(ke);z||(z=new RegExp(M.$of(ke),"i"),F.set(ke,z));const U=z.exec(Re);return U?[{start:U.index,end:U.index+U[0].length}]:Me?b(ke,Re):g(ke,Re)}function q(ke,Re){const Me=ue(ke,ke.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?V(Me):null}function G(ke,Re,Me,z,U,K){const J=Math.min(13,ke.length);for(;Me<J;Me++){const ne=ue(ke,Re,Me,z,U,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,K]}function V(ke){if(typeof ke>"u")return[];const Re=[],Me=ke[1];for(let z=ke.length-1;z>1;z--){const U=ke[z]+Me,K=Re[Re.length-1];K&&K.end===U?K.end=U+1:Re.push({start:U,end:U+1})}return Re}const O=128;function W(){const ke=[],Re=[];for(let Me=0;Me<=O;Me++)Re[Me]=0;for(let Me=0;Me<=O;Me++)ke.push(Re.slice(0));return ke}function ce(ke){const Re=[];for(let Me=0;Me<=ke;Me++)Re[Me]=0;return Re}const ge=ce(2*O),te=ce(2*O),me=W(),se=W(),de=W(),be=!1;function re(ke,Re,Me,z,U){function K(ne,fe,Ae=" "){for(;ne.length<fe;)ne=Ae+ne;return ne}let J=` |   |${z.split("").map(ne=>K(ne,3)).join("|")}
`;for(let ne=0;ne<=Me;ne++)ne===0?J+=" |":J+=`${Re[ne-1]}|`,J+=ke[ne].slice(0,U+1).map(fe=>K(fe.toString(),3)).join("|")+`
`;return J}function Pe(ke,Re,Me,z){ke=ke.substr(Re),Me=Me.substr(z),console.log(re(se,ke,ke.length,Me,Me.length)),console.log(re(de,ke,ke.length,Me,Me.length)),console.log(re(me,ke,ke.length,Me,Me.length))}function Fe(ke,Re){if(Re<0||Re>=ke.length)return!1;const Me=ke.codePointAt(Re);switch(Me){case w.CharCode.Underline:case w.CharCode.Dash:case w.CharCode.Period:case w.CharCode.Space:case w.CharCode.Slash:case w.CharCode.Backslash:case w.CharCode.SingleQuote:case w.CharCode.DoubleQuote:case w.CharCode.Colon:case w.CharCode.DollarSign:case w.CharCode.LessThan:case w.CharCode.GreaterThan:case w.CharCode.OpenParen:case w.CharCode.CloseParen:case w.CharCode.OpenSquareBracket:case w.CharCode.CloseSquareBracket:case w.CharCode.OpenCurlyBrace:case w.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!M.$Yf(Me)}}function X(ke,Re){if(Re<0||Re>=ke.length)return!1;switch(ke.charCodeAt(Re)){case w.CharCode.Space:case w.CharCode.Tab:return!0;default:return!1}}function B(ke,Re,Me){return Re[ke]!==Me[ke]}function _(ke,Re,Me,z,U,K,J=!1){for(;Re<Me&&U<K;)ke[Re]===z[U]&&(J&&(ge[Re]=U),Re+=1),U+=1;return Re===Me}var we;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(we||(we={}));var ae;(function(ke){ke.Default=[-100,0];function Re(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}ke.isDefault=Re})(ae||(e.FuzzyScore=ae={}));class ve{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Me){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Me}}e.$Rk=ve;function ue(ke,Re,Me,z,U,K,J=ve.default){const ne=ke.length>O?O:ke.length,fe=z.length>O?O:z.length;if(Me>=ne||K>=fe||ne-Me>fe-K||!_(Re,Me,ne,U,K,fe,!0))return;Z(ne,fe,Me,K,Re,U);let Ae=1,ze=1,Ke=Me,_e=K;const it=[!1];for(Ae=1,Ke=Me;Ke<ne;Ae++,Ke++){const ut=ge[Ke],st=te[Ke],ct=Ke+1<ne?te[Ke+1]:fe;for(ze=ut-K+1,_e=ut;_e<ct;ze++,_e++){let gt=Number.MIN_SAFE_INTEGER,mt=!1;_e<=st&&(gt=Y(ke,Re,Ke,Me,z,U,_e,fe,K,me[Ae-1][ze-1]===0,it));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(mt=!0,Be=gt+se[Ae-1][ze-1]);const je=_e>ut,H=je?se[Ae][ze-1]+(me[Ae][ze-1]>0?-5:0):0,x=_e>ut+1&&me[Ae][ze-1]>0,De=x?se[Ae][ze-2]+(me[Ae][ze-2]>0?-5:0):0;if(x&&(!je||De>=H)&&(!mt||De>=Be))se[Ae][ze]=De,de[Ae][ze]=we.LeftLeft,me[Ae][ze]=0;else if(je&&(!mt||H>=Be))se[Ae][ze]=H,de[Ae][ze]=we.Left,me[Ae][ze]=0;else if(mt)se[Ae][ze]=Be,de[Ae][ze]=we.Diag,me[Ae][ze]=me[Ae-1][ze-1]+1;else throw new Error("not possible")}}if(be&&Pe(ke,Me,z,K),!it[0]&&!J.firstMatchCanBeWeak)return;Ae--,ze--;const nt=[se[Ae][ze],K];let tt=0,rt=0;for(;Ae>=1;){let ut=ze;do{const st=de[Ae][ut];if(st===we.LeftLeft)ut=ut-2;else if(st===we.Left)ut=ut-1;else break}while(ut>=1);tt>1&&Re[Me+Ae-1]===U[K+ze-1]&&!B(ut+K-1,z,U)&&tt+1>me[Ae][ut]&&(ut=ze),ut===ze?tt++:tt=1,rt||(rt=ut),Ae--,ze=ut-1,nt.push(ze)}fe-K===ne&&J.boostFullMatch&&(nt[0]+=2);const $t=rt-ne;return nt[0]-=$t,nt}function Z(ke,Re,Me,z,U,K){let J=ke-1,ne=Re-1;for(;J>=Me&&ne>=z;)U[J]===K[ne]&&(te[J]=ne,J--),ne--}function Y(ke,Re,Me,z,U,K,J,ne,fe,Ae,ze){if(Re[Me]!==K[J])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return J===Me-z?Ke=ke[Me]===U[J]?7:5:B(J,U,K)&&(J===0||!B(J-1,U,K))?(Ke=ke[Me]===U[J]?7:5,_e=!0):Fe(K,J)&&(J===0||!Fe(K,J-1))?Ke=5:(Fe(K,J-1)||X(K,J-1))&&(Ke=5,_e=!0),Ke>1&&Me===z&&(ze[0]=!0),_e||(_e=B(J,U,K)||Fe(K,J-1)||X(K,J-1)),Me===z?J>fe&&(Ke-=_e?3:5):Ae?Ke+=_e?2:0:Ke+=_e?0:1,J+1===ne&&(Ke-=_e?3:5),Ke}function pe(ke,Re,Me,z,U,K,J){return Ne(ke,Re,Me,z,U,K,!0,J)}function $e(ke,Re,Me,z,U,K,J){return Ne(ke,Re,Me,z,U,K,!1,J)}function Ne(ke,Re,Me,z,U,K,J,ne){let fe=ue(ke,Re,Me,z,U,K,ne);if(fe&&!J)return fe;if(ke.length>=3){const Ae=Math.min(7,ke.length-1);for(let ze=Me+1;ze<Ae;ze++){const Ke=Ue(ke,ze);if(Ke){const _e=ue(Ke,Ke.toLowerCase(),Me,z,U,K,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function Ue(ke,Re){if(Re+1>=ke.length)return;const Me=ke[Re],z=ke[Re+1];if(Me!==z)return ke.slice(0,Re)+z+Me+ke.slice(Re+2)}}),define(Ce[99],Ie([1,0,146,13,35]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=p,e.$Wk=R,e.$Xk=l,e.$Yk=E,e.$Zk=r,e.$1k=o;const M="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),N=new RegExp(`(\\\\)?${A.source}`,"g");function p(a){return a.replace(N,(h,n)=>n?h:`\\${h}`)}const c=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(c,h=>`\\${h}`)}const v=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(a){return a.indexOf(M)===-1?a:a.replace(v,(h,n,s,i)=>s?h:n||i||"")}function E(a){return a?a.replace(/\$\((.*?)\)/g,(h,n)=>` ${n} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){d.lastIndex=0;let h="";const n=[];let s=0;for(;;){const i=d.lastIndex,t=d.exec(a),m=a.substring(i,t?.index);if(m.length>0){h+=m;for(let f=0;f<m.length;f++)n.push(s)}if(!t)break;s+=t[0].length}return{text:h,iconOffsets:n}}function o(a,h,n=!1){const{text:s,iconOffsets:i}=h;if(!i||i.length===0)return(0,w.$Mk)(a,s,n);const t=(0,C.$mf)(s," "),m=s.length-t.length,f=(0,w.$Mk)(a,t,n);if(f)for(const u of f){const $=i[u.start+m]+m;u.start+=$,u.end+=$}return f}}),define(Ce[36],Ie([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w=qe(w);var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const M="error",A="warning",N="warn",p="info",c="ignore";function R(l){return l?w.$Ff(M,l)?P.Error:w.$Ff(A,l)||w.$Ff(N,l)?P.Warning:w.$Ff(p,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function v(l){switch(l){case P.Error:return M;case P.Warning:return A;case P.Info:return p;default:return c}}P.toString=v}(C||(C={})),e.default=C}),define(Ce[59],Ie([1,0,18,28,13]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class M{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Gi=M;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===C.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$zf)(d,this.b,0,d.length,this.c,this.d):(0,P.$Bf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=A;class N{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===C.CharCode.Slash||this.f&&o===C.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===C.CharCode.Slash||this.f&&r===C.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$zf)(d,this.b,0,d.length,this.d,this.e):(0,P.$Bf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=N;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new N(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,P.$Af)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Af)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,P.$yf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$yf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ji=c;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(v||(v={}));class l{static forUris(d=()=>!1,r=()=>!1){return new l(new c(d,r))}static forPaths(d=!1){return new l(new N(void 0,!d))}static forStrings(){return new l(new M)}static forConfigKeys(){return new l(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,w.$Xb)(o);for(const a of o)this.set(a,d)}else{const o=d.slice(0);(0,w.$Xb)(o);for(const a of o)this.set(a[0],a[1])}}set(d,r){const o=this.b.reset(d);let a;this.c||(this.c=new R,this.c.segment=o.value());const h=[];for(a=this.c;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new R,a.left.segment=o.value()),h.push([v.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new R,a.right.segment=o.value()),h.push([v.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new R,a.mid.segment=o.value()),h.push([v.Mid,a]),a=a.mid;else break}const n=a.value;a.value=r,a.key=d;for(let s=h.length-1;s>=0;s--){const i=h[s][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const m=h[s][0],f=h[s+1][0];if(m===v.Right&&f===v.Right)h[s][1]=i.rotateLeft();else if(m===v.Left&&f===v.Left)h[s][1]=i.rotateRight();else if(m===v.Right&&f===v.Left)i.right=h[s+1][1]=h[s+1][1].rotateRight(),h[s][1]=i.rotateLeft();else if(m===v.Left&&f===v.Right)i.left=h[s+1][1]=h[s+1][1].rotateLeft(),h[s][1]=i.rotateRight();else throw new Error;if(s>0)switch(h[s-1][0]){case v.Left:h[s-1][1].left=h[s][1];break;case v.Right:h[s-1][1].right=h[s][1];break;case v.Mid:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}return n}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),a=[];let h=this.c;for(;h;){const n=o.cmp(h.segment);if(n>0)a.push([v.Left,h]),h=h.left;else if(n<0)a.push([v.Right,h]),h=h.right;else if(o.hasNext())o.next(),a.push([v.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const n=this.f(h.right);if(n.key){const{key:s,value:i,segment:t}=n;this.e(n.key,!1),h.key=s,h.value=i,h.segment=t}}else{const n=h.left??h.right;if(a.length>0){const[s,i]=a[a.length-1];switch(s){case v.Left:i.left=n;break;case v.Mid:i.mid=n;break;case v.Right:i.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const s=a[n][1];s.updateHeight();const i=s.balanceFactor();if(i>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[n][1]=s.rotateLeft()):i<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[n][1]=s.rotateRight()),n>0)switch(a[n-1][0]){case v.Left:a[n-1][1].left=a[n][1];break;case v.Right:a[n-1][1].right=a[n][1];break;case v.Mid:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,a;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let a=this.c;for(;a;){const h=o.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):r?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Ki=l}),define(Ce[37],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=C;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return w.test(P)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(N){for(let p=0;p<N.length;p++)N[p]=Math.floor(Math.random()*256);return N};const M=new Uint8Array(16),A=[];for(let N=0;N<256;N++)A.push(N.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let p=0,c="";return c+=A[M[p++]],c+=A[M[p++]],c+=A[M[p++]],c+=A[M[p++]],c+="-",c+=A[M[p++]],c+=A[M[p++]],c+="-",c+=A[M[p++]],c+=A[M[p++]],c+="-",c+=A[M[p++]],c+=A[M[p++]],c+="-",c+=A[M[p++]],c+=A[M[p++]],c+=A[M[p++]],c+=A[M[p++]],c+=A[M[p++]],c+=A[M[p++]],c}}()}),define(Ce[147],Ie([1,0,18,40,37]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ju=void 0,e.$hu=M,e.$iu=A,e.$ku=c;function M(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function A(v,l,E){const d={id:(0,P.$1g)(),name:v,uri:l,data:E};return{asString:async()=>"",asFile:()=>d,value:void 0}}class N{constructor(){this.a=new Map}get size(){let l=0;for(const E of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const E=[...this.a.keys()];return C.Iterable.some(this,([d,r])=>r.asFile())&&E.push("files"),R(p(l),E)}get(l){return this.a.get(this.b(l))?.[0]}append(l,E){const d=this.a.get(l);d?d.push(E):this.a.set(this.b(l),[E])}replace(l,E){this.a.set(this.b(l),[E])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,E]of this.a)for(const d of E)yield[l,d]}b(l){return p(l)}}e.$ju=N;function p(v){return v.toLowerCase()}function c(v,l){return R(p(v),l.map(p))}function R(v,l){if(v==="*/*")return l.length>0;if(l.includes(v))return!0;const E=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[d,r,o]=E;return o==="*"?l.some(a=>a.startsWith(r+"/")):!1}e.$lu=Object.freeze({create:v=>(0,w.$Nb)(v.map(l=>l.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$lu.split(v).filter(l=>!l.startsWith("#"))})}),define(Ce[148],Ie([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ru=P;var C;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function P(M){let A=0,N=0,p=0,c=C.Unknown;for(let R=0,v=M.length;R<v;R++){const l=M.charCodeAt(R);l===w.CharCode.CarriageReturn?(A===0&&(N=R),A++,R+1<v&&M.charCodeAt(R+1)===w.CharCode.LineFeed?(c|=C.CRLF,R++):c|=C.Invalid,p=R+1):l===w.CharCode.LineFeed&&(c|=C.LF,A===0&&(N=R),A++,p=R+1)}return A===0&&(N=M.length),[A,N,M.length-p,c]}}),define(Ce[149],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0,e.$et={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[150],Ie([1,0,28,151]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class M{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let R=0,v=c.notIn.length;R<v;R++)switch(c.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case C.StandardTokenType.Other:return!0;case C.StandardTokenType.Comment:return this.c;case C.StandardTokenType.String:return this.b;case C.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,R){if(c.getTokenCount()===0)return!0;const v=c.findTokenIndexAtOffset(R-2),l=c.getStandardTokenType(v);return this.isOK(l)}g(c,R){for(let v=c;v<=R;v++){const l=String.fromCharCode(v);if(!this.open.includes(l)&&!this.close.includes(l))return l}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(w.CharCode.Digit0,w.CharCode.Digit9)),this.e||(this.e=this.g(w.CharCode.a,w.CharCode.z)),this.e||(this.e=this.g(w.CharCode.A,w.CharCode.Z))),this.e}}e.$Ou=M;class A{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of c)N(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),N(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),N(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),N(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&N(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Pu=A;function N(p,c,R){p.has(c)?p.get(c).push(R):p.set(c,[R])}}),define(Ce[152],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.NodeColor=e.$YC=void 0,e.$1C=P,e.$2C=M,e.$3C=c,e.$4C=R,e.$5C=v,e.$6C=l,e.$7C=E,e.$8C=d;class w{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$ZC)return P(this.right);let o=this;for(;o.parent!==e.$ZC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$ZC?e.$ZC:o.parent}prev(){if(this.left!==e.$ZC)return M(this.left);let o=this;for(;o.parent!==e.$ZC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$ZC?e.$ZC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$YC=w;var C;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(C||(e.NodeColor=C={})),e.$ZC=new w(null,C.Black),e.$ZC.parent=e.$ZC,e.$ZC.left=e.$ZC,e.$ZC.right=e.$ZC,e.$ZC.color=C.Black;function P(r){for(;r.left!==e.$ZC;)r=r.left;return r}function M(r){for(;r.right!==e.$ZC;)r=r.right;return r}function A(r){return r===e.$ZC?0:r.size_left+r.piece.length+A(r.right)}function N(r){return r===e.$ZC?0:r.lf_left+r.piece.lineFeedCnt+N(r.right)}function p(){e.$ZC.parent=e.$ZC}function c(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.$ZC&&(a.left.parent=o),a.parent=o.parent,o.parent===e.$ZC?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function R(r,o){const a=o.left;o.left=a.right,a.right!==e.$ZC&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.$ZC?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function v(r,o){let a,h;if(o.left===e.$ZC?(h=o,a=h.right):o.right===e.$ZC?(h=o,a=h.left):(h=P(o.right),a=h.right),h===r.root){r.root=a,a.color=C.Black,o.detach(),p(),r.root.parent=e.$ZC;return}const n=h.color===C.Red;if(h===h.parent.left?h.parent.left=a:h.parent.right=a,h===o?(a.parent=h.parent,d(r,a)):(h.parent===o?a.parent=h:a.parent=h.parent,d(r,a),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===r.root?r.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$ZC&&(h.left.parent=h),h.right!==e.$ZC&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(r,h)),o.detach(),a.parent.left===a){const i=A(a),t=N(a);if(i!==a.parent.size_left||t!==a.parent.lf_left){const m=i-a.parent.size_left,f=t-a.parent.lf_left;a.parent.size_left=i,a.parent.lf_left=t,E(r,a.parent,m,f)}}if(d(r,a.parent),n){p();return}let s;for(;a!==r.root&&a.color===C.Black;)a===a.parent.left?(s=a.parent.right,s.color===C.Red&&(s.color=C.Black,a.parent.color=C.Red,c(r,a.parent),s=a.parent.right),s.left.color===C.Black&&s.right.color===C.Black?(s.color=C.Red,a=a.parent):(s.right.color===C.Black&&(s.left.color=C.Black,s.color=C.Red,R(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=C.Black,s.right.color=C.Black,c(r,a.parent),a=r.root)):(s=a.parent.left,s.color===C.Red&&(s.color=C.Black,a.parent.color=C.Red,R(r,a.parent),s=a.parent.left),s.left.color===C.Black&&s.right.color===C.Black?(s.color=C.Red,a=a.parent):(s.left.color===C.Black&&(s.right.color=C.Black,s.color=C.Red,c(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=C.Black,s.left.color=C.Black,R(r,a.parent),a=r.root));a.color=C.Black,p()}function l(r,o){for(d(r,o);o!==r.root&&o.parent.color===C.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===C.Red?(o.parent.color=C.Black,a.color=C.Black,o.parent.parent.color=C.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,c(r,o)),o.parent.color=C.Black,o.parent.parent.color=C.Red,R(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===C.Red?(o.parent.color=C.Black,a.color=C.Black,o.parent.parent.color=C.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(r,o)),o.parent.color=C.Black,o.parent.parent.color=C.Red,c(r,o.parent.parent))}r.root.color=C.Black}function E(r,o,a,h){for(;o!==r.root&&o!==e.$ZC;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}function d(r,o){let a=0,h=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=A(o.left)-o.size_left,h=N(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=h;o!==r.root&&(a!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}}}),define(Ce[100],Ie([1,0,28,101,33,52,152,102]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.$eD=void 0,e.$cD=v,e.$dD=l;const p=65535;function c(h){let n;return h[h.length-1]<65536?n=new Uint16Array(h.length):n=new Uint32Array(h.length),n.set(h,0),n}class R{constructor(n,s,i,t,m){this.lineStarts=n,this.cr=s,this.lf=i,this.crlf=t,this.isBasicASCII=m}}function v(h,n=!0){const s=[0];let i=1;for(let t=0,m=h.length;t<m;t++){const f=h.charCodeAt(t);f===w.CharCode.CarriageReturn?t+1<m&&h.charCodeAt(t+1)===w.CharCode.LineFeed?(s[i++]=t+2,t++):s[i++]=t+1:f===w.CharCode.LineFeed&&(s[i++]=t+1)}return n?c(s):s}function l(h,n){h.length=0,h[0]=0;let s=1,i=0,t=0,m=0,f=!0;for(let $=0,I=n.length;$<I;$++){const D=n.charCodeAt($);D===w.CharCode.CarriageReturn?$+1<I&&n.charCodeAt($+1)===w.CharCode.LineFeed?(m++,h[s++]=$+2,$++):(i++,h[s++]=$+1):D===w.CharCode.LineFeed?(t++,h[s++]=$+1):f&&D!==w.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const u=new R(c(h),i,t,m,f);return h.length=0,u}class E{constructor(n,s,i,t,m){this.bufferIndex=n,this.start=s,this.end=i,this.lineFeedCnt=t,this.length=m}}e.$eD=E;class d{constructor(n,s){this.buffer=n,this.lineStarts=s}}e.$fD=d;class r{constructor(n,s){this.a=[],this.c=n,this.d=s,this.b=0,n.root!==A.$ZC&&n.iterate(n.root,i=>(i!==A.$ZC&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(n){this.a=n,this.b=[]}get(n){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let s=!1;const i=this.b;for(let t=0;t<i.length;t++){const m=i[t];if(m.node.parent===null||m.nodeStartOffset>=n){i[t]=null,s=!0;continue}}if(s){const t=[];for(const m of i)m!==null&&t.push(m);this.b=t}}}class a{constructor(n,s,i){this.create(n,s,i)}create(n,s,i){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$ZC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=i;let t=null;for(let m=0,f=n.length;m<f;m++)if(n[m].buffer.length>0){n[m].lineStarts||(n[m].lineStarts=v(n[m].buffer));const u=new E(m+1,{line:0,column:0},{line:n[m].lineStarts.length-1,column:n[m].buffer.length-n[m].lineStarts[n[m].lineStarts.length-1]},n[m].lineStarts.length-1,n[m].buffer.length);this.a.push(n[m]),t=this.S(t,u)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const s=p,i=s-Math.floor(s/3),t=i*2;let m="",f=0;const u=[];if(this.iterate(this.root,$=>{const I=this.R($),D=I.length;if(f<=i||f+D<t)return m+=I,f+=D,!0;const y=m.replace(/\r\n|\r|\n/g,n);return u.push(new d(y,v(y))),m=I,f=D,!0}),f>0){const $=m.replace(/\r\n|\r|\n/g,n);u.push(new d($,v($)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new r(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let s=0;return this.iterate(this.root,t=>{if(t===A.$ZC)return!0;const m=this.R(t),f=m.length,u=n.G(s),$=n.G(s+f),I=n.getValueInRange2(u,$);return s+=f,m===I})}getOffsetAt(n,s){let i=0,t=this.root;for(;t!==A.$ZC;)if(t.left!==A.$ZC&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const m=this.B(t,n-t.lf_left-2);return i+=m+s-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let s=this.root,i=0;const t=n;for(;s!==A.$ZC;)if(s.size_left!==0&&s.size_left>=n)s=s.left;else if(s.size_left+s.piece.length>=n){const m=this.A(s,n-s.size_left);if(i+=s.lf_left+m.index,m.index===0){const f=this.getOffsetAt(i+1,1),u=t-f;return new C.$Gt(i+1,u+1)}return new C.$Gt(i+1,m.remainder+1)}else if(n-=s.size_left+s.piece.length,i+=s.lf_left+s.piece.lineFeedCnt,s.right===A.$ZC){const m=this.getOffsetAt(i+1,1),f=t-n-m;return new C.$Gt(i+1,f+1)}else s=s.right;return new C.$Gt(1,1)}getValueInRange(n,s){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),m=this.getValueInRange2(i,t);return s?s!==this.d||!this.f?m.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?m:m.replace(/\r\n|\r|\n/g,s):m}getValueInRange2(n,s){if(n.node===s.node){const u=n.node,$=this.a[u.piece.bufferIndex].buffer,I=this.u(u.piece.bufferIndex,u.piece.start);return $.substring(I+n.remainder,I+s.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,m=this.u(i.piece.bufferIndex,i.piece.start);let f=t.substring(m+n.remainder,m+i.piece.length);for(i=i.next();i!==A.$ZC;){const u=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(i===s.node){f+=u.substring($,$+s.remainder);break}else f+=u.substr($,i.piece.length);i=i.next()}return f}getLinesContent(){const n=[];let s=0,i="",t=!1;return this.iterate(this.root,m=>{if(m===A.$ZC)return!0;const f=m.piece;let u=f.length;if(u===0)return!0;const $=this.a[f.bufferIndex].buffer,I=this.a[f.bufferIndex].lineStarts,D=f.start.line,y=f.end.line;let S=I[D]+f.start.column;if(t&&($.charCodeAt(S)===w.CharCode.LineFeed&&(S++,u--),n[s++]=i,i="",t=!1,u===0))return!0;if(D===y)return!this.f&&$.charCodeAt(S+u-1)===w.CharCode.CarriageReturn?(t=!0,i+=$.substr(S,u-1)):i+=$.substr(S,u),!0;i+=this.f?$.substring(S,Math.max(S,I[D+1]-this.e)):$.substring(S,I[D+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;for(let k=D+1;k<y;k++)i=this.f?$.substring(I[k],I[k+1]-this.e):$.substring(I[k],I[k+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;return!this.f&&$.charCodeAt(I[y]+f.end.column-1)===w.CharCode.CarriageReturn?(t=!0,f.end.column===0?s--:i=$.substr(I[y],f.end.column-1)):i=$.substr(I[y],f.end.column),!0}),t&&(n[s++]=i,i=""),n[s++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const s=n.node.next();if(!s)return 0;const i=this.a[s.piece.bufferIndex],t=this.u(s.piece.bufferIndex,s.piece.start);return i.buffer.charCodeAt(t)}else{const s=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return s.buffer.charCodeAt(t)}}getLineCharCode(n,s){const i=this.H(n,s+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const s=this.getOffsetAt(n,1);return this.getLength()-s}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const s=this.G(n);return this.l(s)}getNearestChunk(n){const s=this.G(n);if(s.remainder===s.node.piece.length){const i=s.node.next();if(!i||i===A.$ZC)return"";const t=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start);return t.buffer.substring(m,m+i.piece.length)}else{const i=this.a[s.node.piece.bufferIndex],t=this.u(s.node.piece.bufferIndex,s.node.piece.start),m=t+s.remainder,f=t+s.node.piece.length;return i.buffer.substring(m,f)}}findMatchesInNode(n,s,i,t,m,f,u,$,I,D,y){const S=this.a[n.piece.bufferIndex],k=this.u(n.piece.bufferIndex,n.piece.start),g=this.u(n.piece.bufferIndex,m),b=this.u(n.piece.bufferIndex,f);let F;const T={line:0,column:0};let q,G;s._wordSeparators?(q=S.buffer.substring(g,b),G=V=>V+g,s.reset(0)):(q=S.buffer,G=V=>V,s.reset(g));do if(F=s.next(q),F){if(G(F.index)>=b)return D;this.s(n,G(F.index)-k,T);const V=this.t(n.piece.bufferIndex,m,T),O=T.line===m.line?T.column-m.column+t:T.column+1,W=O+F[0].length;if(y[D++]=(0,N.$$C)(new P.$Ht(i+V,O,i+V,W),F,$),G(F.index)+F[0].length>=b||D>=I)return D}while(F);return D}findMatchesLineByLine(n,s,i,t){const m=[];let f=0;const u=new N.$bD(s.wordSeparators,s.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const I=this.H(n.endLineNumber,n.endColumn);if(I===null)return[];let D=this.s($.node,$.remainder);const y=this.s(I.node,I.remainder);if($.node===I.node)return this.findMatchesInNode($.node,u,n.startLineNumber,n.startColumn,D,y,s,i,t,f,m),m;let S=n.startLineNumber,k=$.node;for(;k!==I.node;){const b=this.t(k.piece.bufferIndex,D,k.piece.end);if(b>=1){const T=this.a[k.piece.bufferIndex].lineStarts,q=this.u(k.piece.bufferIndex,k.piece.start),G=T[D.line+b],V=S===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(k,u,S,V,D,this.s(k,G-q),s,i,t,f,m),f>=t)return m;S+=b}const F=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const T=this.getLineContent(S).substring(F,n.endColumn-1);return f=this.n(s,u,T,n.endLineNumber,F,f,m,i,t),m}if(f=this.n(s,u,this.getLineContent(S).substr(F),S,F,f,m,i,t),f>=t)return m;S++,$=this.H(S,1),k=$.node,D=this.s($.node,$.remainder)}if(S===n.endLineNumber){const b=S===n.startLineNumber?n.startColumn-1:0,F=this.getLineContent(S).substring(b,n.endColumn-1);return f=this.n(s,u,F,n.endLineNumber,b,f,m,i,t),m}const g=S===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(I.node,u,S,g,D,y,s,i,t,f,m),m}n(n,s,i,t,m,f,u,$,I){const D=n.wordSeparators;if(!$&&n.simpleSearch){const S=n.simpleSearch,k=S.length,g=i.length;let b=-k;for(;(b=i.indexOf(S,b+k))!==-1;)if((!D||(0,N.$aD)(D,i,g,b,k))&&(u[f++]=new M.$9v(new P.$Ht(t,b+1+m,t,b+1+k+m),null),f>=I))return f;return f}let y;s.reset(0);do if(y=s.next(i),y&&(u[f++]=(0,N.$$C)(new P.$Ht(t,y.index+1+m,t,y.index+1+y[0].length+m),y,$),f>=I))return f;while(y);return f}insert(n,s,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==A.$ZC){const{node:t,remainder:m,nodeStartOffset:f}=this.G(n),u=t.piece,$=u.bufferIndex,I=this.s(t,m);if(t.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&f+u.length===n&&s.length<p){this.F(t,s),this.y();return}if(f===n)this.o(s,t),this.h.validate(n);else if(f+t.piece.length>n){const D=[];let y=new E(u.bufferIndex,I,u.end,this.t(u.bufferIndex,I,u.end),this.u($,u.end)-this.u($,I));if(this.K()&&this.M(s)&&this.I(t,m)===10){const b={line:y.start.line+1,column:0};y=new E(y.bufferIndex,b,y.end,this.t(y.bufferIndex,b,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(t,m-1)===13){const b=this.s(t,m-1);this.C(t,b),s="\r"+s,t.piece.length===0&&D.push(t)}else this.C(t,I);else this.C(t,I);const S=this.w(s);y.length>0&&this.S(t,y);let k=t;for(let g=0;g<S.length;g++)k=this.S(k,S[g]);this.v(D)}else this.q(s,t)}else{const t=this.w(s);let m=this.T(null,t[0]);for(let f=1;f<t.length;f++)m=this.S(m,t[f])}this.y()}delete(n,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===A.$ZC)return;const i=this.G(n),t=this.G(n+s),m=i.node,f=t.node;if(m===f){const S=this.s(m,i.remainder),k=this.s(m,t.remainder);if(i.nodeStartOffset===n){if(s===m.piece.length){const g=m.next();(0,A.$5C)(this,m),this.N(g),this.y();return}this.D(m,k),this.h.validate(n),this.N(m),this.y();return}if(i.nodeStartOffset+m.piece.length===n+s){this.C(m,S),this.O(m),this.y();return}this.E(m,S,k),this.y();return}const u=[],$=this.s(m,i.remainder);this.C(m,$),this.h.validate(n),m.piece.length===0&&u.push(m);const I=this.s(f,t.remainder);this.D(f,I),f.piece.length===0&&u.push(f);const D=m.next();for(let S=D;S!==A.$ZC&&S!==f;S=S.next())u.push(S);const y=m.piece.length===0?m.prev():m;this.v(u),this.O(y),this.y()}o(n,s){const i=[];if(this.K()&&this.M(n)&&this.L(s)){const f=s.piece,u={line:f.start.line+1,column:0},$=new E(f.bufferIndex,u,f.end,this.t(f.bufferIndex,u,f.end),f.length-1);s.piece=$,n+=`
`,(0,A.$7C)(this,s,-1,-1),s.piece.length===0&&i.push(s)}const t=this.w(n);let m=this.T(s,t[t.length-1]);for(let f=t.length-2;f>=0;f--)m=this.T(m,t[f]);this.N(m),this.v(i)}q(n,s){this.Q(n,s)&&(n+=`
`);const i=this.w(n),t=this.S(s,i[0]);let m=t;for(let f=1;f<i.length;f++)m=this.S(m,i[f]);this.N(t)}s(n,s,i){const t=n.piece,m=n.piece.bufferIndex,f=this.a[m].lineStarts,$=f[t.start.line]+t.start.column+s;let I=t.start.line,D=t.end.line,y=0,S=0,k=0;for(;I<=D&&(y=I+(D-I)/2|0,k=f[y],y!==D);)if(S=f[y+1],$<k)D=y-1;else if($>=S)I=y+1;else break;return i?(i.line=y,i.column=$-k,null):{line:y,column:$-k}}t(n,s,i){if(i.column===0)return i.line-s.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-s.line;const m=t[i.line+1],f=t[i.line]+i.column;if(m>f+1)return i.line-s.line;const u=f-1;return this.a[n].buffer.charCodeAt(u)===13?i.line-s.line+1:i.line-s.line}u(n,s){return this.a[n].lineStarts[s.line]+s.column}v(n){for(let s=0;s<n.length;s++)(0,A.$5C)(this,n[s])}w(n){if(n.length>p){const D=[];for(;n.length>p;){const S=n.charCodeAt(p-1);let k;S===w.CharCode.CarriageReturn||S>=55296&&S<=56319?(k=n.substring(0,p-1),n=n.substring(p-1)):(k=n.substring(0,p),n=n.substring(p));const g=v(k);D.push(new E(this.a.length,{line:0,column:0},{line:g.length-1,column:k.length-g[g.length-1]},g.length-1,k.length)),this.a.push(new d(k,g))}const y=v(n);return D.push(new E(this.a.length,{line:0,column:0},{line:y.length-1,column:n.length-y[y.length-1]},y.length-1,n.length)),this.a.push(new d(n,y)),D}let s=this.a[0].buffer.length;const i=v(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let D=0;D<i.length;D++)i[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,s+=1}else{if(s!==0)for(let D=0;D<i.length;D++)i[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const m=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,u=m-this.a[0].lineStarts[f],$={line:f,column:u},I=new E(0,t,$,this.t(0,t,$),m-s);return this.g=$,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,s=0){let i=this.root,t="";const m=this.h.get2(n);if(m){i=m.node;const f=this.B(i,n-m.nodeStartLineNumber-1),u=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(m.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=u.substring($+f,$+i.piece.length);else{const I=this.B(i,n-m.nodeStartLineNumber);return u.substring($+f,$+I-s)}}else{let f=0;const u=n;for(;i!==A.$ZC;)if(i.left!==A.$ZC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const $=this.B(i,n-i.lf_left-2),I=this.B(i,n-i.lf_left-1),D=this.a[i.piece.bufferIndex].buffer,y=this.u(i.piece.bufferIndex,i.piece.start);return f+=i.size_left,this.h.set({node:i,nodeStartOffset:f,nodeStartLineNumber:u-(n-1-i.lf_left)}),D.substring(y+$,y+I-s)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const $=this.B(i,n-i.lf_left-2),I=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);t=I.substring(D+$,D+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,f+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==A.$ZC;){const f=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const u=this.B(i,0),$=this.u(i.piece.bufferIndex,i.piece.start);return t+=f.substring($,$+u-s),t}else{const u=this.u(i.piece.bufferIndex,i.piece.start);t+=f.substr(u,i.piece.length)}i=i.next()}return t}y(){let n=this.root,s=1,i=0;for(;n!==A.$ZC;)s+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=s,this.c=i,this.h.validate(this.c)}A(n,s){const i=n.piece,t=this.s(n,s),m=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===s){const f=this.t(n.piece.bufferIndex,i.start,t);if(f!==m)return{index:f,remainder:0}}return{index:m,remainder:t.column}}B(n,s){if(s<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,m=i.start.line+s+1;return m>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[m]-t[i.start.line]-i.start.column}C(n,s){const i=n.piece,t=i.lineFeedCnt,m=this.u(i.bufferIndex,i.end),f=s,u=this.u(i.bufferIndex,f),$=this.t(i.bufferIndex,i.start,f),I=$-t,D=u-m,y=i.length+D;n.piece=new E(i.bufferIndex,i.start,f,$,y),(0,A.$7C)(this,n,D,I)}D(n,s){const i=n.piece,t=i.lineFeedCnt,m=this.u(i.bufferIndex,i.start),f=s,u=this.t(i.bufferIndex,f,i.end),$=this.u(i.bufferIndex,f),I=u-t,D=m-$,y=i.length+D;n.piece=new E(i.bufferIndex,f,i.end,u,y),(0,A.$7C)(this,n,D,I)}E(n,s,i){const t=n.piece,m=t.start,f=t.end,u=t.length,$=t.lineFeedCnt,I=s,D=this.t(t.bufferIndex,t.start,I),y=this.u(t.bufferIndex,s)-this.u(t.bufferIndex,m);n.piece=new E(t.bufferIndex,t.start,I,D,y),(0,A.$7C)(this,n,y-u,D-$);const S=new E(t.bufferIndex,i,f,this.t(t.bufferIndex,i,f),this.u(t.bufferIndex,f)-this.u(t.bufferIndex,i)),k=this.S(n,S);this.N(k)}F(n,s){this.Q(s,n)&&(s+=`
`);const i=this.K()&&this.L(s)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=s;const m=v(s,!1);for(let k=0;k<m.length;k++)m[k]+=t;if(i){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(m.slice(1));const f=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[f],$={line:f,column:u},I=n.piece.length+s.length,D=n.piece.lineFeedCnt,y=this.t(0,n.piece.start,$),S=y-D;n.piece=new E(n.piece.bufferIndex,n.piece.start,$,y,I),this.g=$,(0,A.$7C)(this,n,s.length,S)}G(n){let s=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;s!==A.$ZC;)if(s.size_left>n)s=s.left;else if(s.size_left+s.piece.length>=n){t+=s.size_left;const m={node:s,remainder:n-s.size_left,nodeStartOffset:t};return this.h.set(m),m}else n-=s.size_left+s.piece.length,t+=s.size_left+s.piece.length,s=s.right;return null}H(n,s){let i=this.root,t=0;for(;i!==A.$ZC;)if(i.left!==A.$ZC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const m=this.B(i,n-i.lf_left-2),f=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(m+s-1,f),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const m=this.B(i,n-i.lf_left-2);if(m+s-1<=i.piece.length)return{node:i,remainder:m+s-1,nodeStartOffset:t};s-=i.piece.length-m;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==A.$ZC;){if(i.piece.lineFeedCnt>0){const m=this.B(i,0),f=this.J(i);return{node:i,remainder:Math.min(s-1,m),nodeStartOffset:f}}else if(i.piece.length>=s-1){const m=this.J(i);return{node:i,remainder:s-1,nodeStartOffset:m}}else s-=i.piece.length;i=i.next()}return null}I(n,s){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+s;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let s=n.size_left;for(;n!==this.root;)n.parent.right===n&&(s+=n.parent.size_left+n.parent.piece.length),n=n.parent;return s}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$ZC||n.piece.lineFeedCnt===0)return!1;const s=n.piece,i=this.a[s.bufferIndex].lineStarts,t=s.start.line,m=i[t]+s.start.column;return t===i.length-1||i[t+1]>m+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(m)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$ZC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const s=n.prev();this.M(s)&&this.P(s,n)}}O(n){if(this.K()&&this.M(n)){const s=n.next();this.L(s)&&this.P(n,s)}}P(n,s){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let m;n.piece.end.column===0?m={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:m={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new E(n.piece.bufferIndex,n.piece.start,m,u,f),(0,A.$7C)(this,n,-1,-1),n.piece.length===0&&i.push(n);const $={line:s.piece.start.line+1,column:0},I=s.piece.length-1,D=this.t(s.piece.bufferIndex,$,s.piece.end);s.piece=new E(s.piece.bufferIndex,$,s.piece.end,D,I),(0,A.$7C)(this,s,-1,-1),s.piece.length===0&&i.push(s);const y=this.w(`\r
`);this.S(n,y[0]);for(let S=0;S<i.length;S++)(0,A.$5C)(this,i[S])}Q(n,s){if(this.K()&&this.M(n)){const i=s.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,A.$5C)(this,i);else{const t=i.piece,m={line:t.start.line+1,column:0},f=t.length-1,u=this.t(t.bufferIndex,m,t.end);i.piece=new E(t.bufferIndex,m,t.end,u,f),(0,A.$7C)(this,i,-1,-1)}return!0}}return!1}iterate(n,s){if(n===A.$ZC)return s(A.$ZC);const i=this.iterate(n.left,s);return i&&s(n)&&this.iterate(n.right,s)}R(n){if(n===A.$ZC)return"";const s=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),m=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,m)}getPieceContent(n){const s=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return s.buffer.substring(i,t)}S(n,s){const i=new A.$YC(s,A.NodeColor.Red);if(i.left=A.$ZC,i.right=A.$ZC,i.parent=A.$ZC,i.size_left=0,i.lf_left=0,this.root===A.$ZC)this.root=i,i.color=A.NodeColor.Black;else if(n.right===A.$ZC)n.right=i,i.parent=n;else{const m=(0,A.$1C)(n.right);m.left=i,i.parent=m}return(0,A.$6C)(this,i),i}T(n,s){const i=new A.$YC(s,A.NodeColor.Red);if(i.left=A.$ZC,i.right=A.$ZC,i.parent=A.$ZC,i.size_left=0,i.lf_left=0,this.root===A.$ZC)this.root=i,i.color=A.NodeColor.Black;else if(n.left===A.$ZC)n.left=i,i.parent=n;else{const t=(0,A.$2C)(n.left);t.right=i,i.parent=t}return(0,A.$6C)(this,i),i}U(n){let s="";return this.iterate(n,i=>(s+=this.R(i),!0)),s}}e.$gD=a}),define(Ce[153],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$=e.$K$=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$K$=w;class C{constructor(M){this.identifier=M}}e.$L$=C}),define(Ce[154],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ce[155],Ie([1,0,4,5,154]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=void 0,e.$oj=R,P=qe(P);class M extends C.$Vc{constructor(l,E="",d="",r=!0,o){super(),this.j=this.B(new w.$le),this.onDidChange=this.j.event,this.z=!0,this.m=l,this.n=E,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.j.fire({label:l}))}get tooltip(){return this.u||""}set tooltip(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.j.fire({tooltip:l}))}get class(){return this.w}set class(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.j.fire({class:l}))}get enabled(){return this.z}set enabled(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.j.fire({enabled:l}))}get checked(){return this.C}set checked(l){this.J(l)}J(l){this.C!==l&&(this.C=l,this.j.fire({checked:l}))}async run(l,E){this.D&&await this.D(l)}}e.$jj=M;class A extends C.$Vc{constructor(){super(...arguments),this.f=this.B(new w.$le),this.onWillRun=this.f.event,this.m=this.B(new w.$le),this.onDidRun=this.m.event}async run(l,E){if(!l.enabled)return;this.f.fire({action:l});let d;try{await this.u(l,E)}catch(r){d=r}this.m.fire({action:l,error:d})}async u(l,E){await l.run(E)}}e.$kj=A;class N{constructor(){this.id=N.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let E=[];for(const d of l)d.length&&(E.length?E=[...E,new N,...d]:E=d);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$lj=N;class p{get actions(){return this.a}constructor(l,E,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=E,this.class=r,this.a=d}async run(){}}e.$mj=p;class c extends M{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,P.localize(0,null),void 0,!1)}}e.$nj=c;function R(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...l)=>v.run(...l)}}}),define(Ce[156],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ce[157],Ie([1,0,156]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=c,e.$1m=R,e.$2m=v;const C=60,P=C*60,M=P*24,A=M*7,N=M*30,p=M*365;function c(l,E,d,r){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,w.localize)(0,null,c(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,w.localize)(1,null);let a;return o<C?(a=o,E?a===1?d?(0,w.localize)(2,null,a):(0,w.localize)(3,null,a):d?(0,w.localize)(4,null,a):(0,w.localize)(5,null,a):a===1?d?(0,w.localize)(6,null,a):(0,w.localize)(7,null,a):d?(0,w.localize)(8,null,a):(0,w.localize)(9,null,a)):o<P?(a=Math.floor(o/C),E?a===1?d?(0,w.localize)(10,null,a):(0,w.localize)(11,null,a):d?(0,w.localize)(12,null,a):(0,w.localize)(13,null,a):a===1?d?(0,w.localize)(14,null,a):(0,w.localize)(15,null,a):d?(0,w.localize)(16,null,a):(0,w.localize)(17,null,a)):o<M?(a=Math.floor(o/P),E?a===1?d?(0,w.localize)(18,null,a):(0,w.localize)(19,null,a):d?(0,w.localize)(20,null,a):(0,w.localize)(21,null,a):a===1?d?(0,w.localize)(22,null,a):(0,w.localize)(23,null,a):d?(0,w.localize)(24,null,a):(0,w.localize)(25,null,a)):o<A?(a=Math.floor(o/M),E?a===1?(0,w.localize)(26,null,a):(0,w.localize)(27,null,a):a===1?(0,w.localize)(28,null,a):(0,w.localize)(29,null,a)):o<N?(a=Math.floor(o/A),E?a===1?d?(0,w.localize)(30,null,a):(0,w.localize)(31,null,a):d?(0,w.localize)(32,null,a):(0,w.localize)(33,null,a):a===1?d?(0,w.localize)(34,null,a):(0,w.localize)(35,null,a):d?(0,w.localize)(36,null,a):(0,w.localize)(37,null,a)):o<p?(a=Math.floor(o/N),E?a===1?d?(0,w.localize)(38,null,a):(0,w.localize)(39,null,a):d?(0,w.localize)(40,null,a):(0,w.localize)(41,null,a):a===1?d?(0,w.localize)(42,null,a):(0,w.localize)(43,null,a):d?(0,w.localize)(44,null,a):(0,w.localize)(45,null,a)):(a=Math.floor(o/p),E?a===1?d?(0,w.localize)(46,null,a):(0,w.localize)(47,null,a):d?(0,w.localize)(48,null,a):(0,w.localize)(49,null,a):a===1?d?(0,w.localize)(50,null,a):(0,w.localize)(51,null,a):d?(0,w.localize)(52,null,a):(0,w.localize)(53,null,a))}function R(l,E){const d=Math.abs(l/1e3);return d<1?E?(0,w.localize)(54,null,l):(0,w.localize)(55,null,l):d<C?E?(0,w.localize)(56,null,Math.round(l)/1e3):(0,w.localize)(57,null,Math.round(l)/1e3):d<P?E?(0,w.localize)(58,null,Math.round(l/(1e3*C))):(0,w.localize)(59,null,Math.round(l/(1e3*C))):d<M?E?(0,w.localize)(60,null,Math.round(l/(1e3*P))):(0,w.localize)(61,null,Math.round(l/(1e3*P))):(0,w.localize)(62,null,Math.round(l/(1e3*M)))}function v(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[158],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ce[48],Ie([1,0,18,15,158]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=p,e.$qj=c,e.$rj=R,w=qe(w),C=qe(C),P=qe(P);function M(v,l){return l&&(v.stack||v.stacktrace)?P.localize(0,null,N(v),A(v.stack)||A(v.stacktrace)):N(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function N(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?P.localize(1,null,v.message):v.message||P.localize(2,null)}function p(v=null,l=!1){if(!v)return P.localize(3,null);if(Array.isArray(v)){const E=w.$Ib(v),d=p(E[0],l);return E.length>1?P.localize(4,null,d,E.length):d}if(C.$eg(v))return v;if(v.detail){const E=v.detail;if(E.error)return M(E.error,l);if(E.exception)return M(E.exception,l)}return v.stack?M(v,l):v.message?v.message:P.localize(5,null)}function c(v){const l=v;return l instanceof Error&&Array.isArray(l.actions)}function R(v,l){let E;return typeof v=="string"?E=new Error(v):E=v,E.actions=l,E}}),define(Ce[159],Ie([1,0,47,20]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=N,e.$ur=p,e.$vr=c,e.$wr=R,e.$xr=v,e.$yr=l,e.$zr=E,e.$Ar=d,e.$Br=r,e.$Cr=o,e.$Dr=$,e.$Er=I,e.$Fr=D;const P=new w.$W(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),M=new w.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function N(y,S,k=!1){const g=y||"",b=S||"",F=P.value.collator.compare(g,b);return P.value.collatorIsNumeric&&F===0&&g!==b?g<b?-1:1:F}function p(y,S){const k=M.value.collator;return y=y||"",S=S||"",s(k,y,S)}function c(y,S){const k=M.value.collator;return y=y||"",S=S||"",f(y,S)||s(k,y,S)}function R(y,S){const k=M.value.collator;return y=y||"",S=S||"",m(y,S)||s(k,y,S)}function v(y,S){return y=y||"",S=S||"",y===S?0:y<S?-1:1}function l(y,S){const[k,g]=h(y),[b,F]=h(S);let T=P.value.collator.compare(g,F);if(T===0){if(P.value.collatorIsNumeric&&g!==F)return g<F?-1:1;if(T=P.value.collator.compare(k,b),P.value.collatorIsNumeric&&T===0&&k!==b)return k<b?-1:1}return T}function E(y,S){y=y||"",S=S||"";const k=n(y),g=n(S),b=M.value.collator,F=A.value.collator;return s(F,k,g)||s(b,y,S)}function d(y,S){y=y||"",S=S||"";const k=n(y),g=n(S),b=M.value.collator,F=A.value.collator;return s(F,k,g)||f(y,S)||s(b,y,S)}function r(y,S){y=y||"",S=S||"";const k=n(y),g=n(S),b=M.value.collator,F=A.value.collator;return s(F,k,g)||m(y,S)||s(b,y,S)}function o(y,S){y=y||"",S=S||"";const k=n(y).toLowerCase(),g=n(S).toLowerCase();return k!==g?k<g?-1:1:y!==S?y<S?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function h(y,S=!1){const k=y?a.exec(y):[];let g=[k&&k[1]||"",k&&k[3]||""];return S&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function n(y){const S=y?a.exec(y):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function s(y,S,k){const g=y.compare(S,k);return g!==0?g:S.length!==k.length?S.length<k.length?-1:1:0}function i(y){const S=y.charAt(0);return S.toLocaleUpperCase()!==S}function t(y){const S=y.charAt(0);return S.toLocaleLowerCase()!==S}function m(y,S){return i(y)&&t(S)?-1:t(y)&&i(S)?1:0}function f(y,S){return t(y)&&i(S)?-1:i(y)&&t(S)?1:0}function u(y,S,k=!1){return k||(y=y&&y.toLowerCase(),S=S&&S.toLowerCase()),y===S?0:y<S?-1:1}function $(y,S,k=!1){const g=y.split(C.sep),b=S.split(C.sep),F=g.length-1,T=b.length-1;let q,G;for(let V=0;;V++){if(q=F===V,G=T===V,q&&G)return N(g[V],b[V],k);if(q)return-1;if(G)return 1;const O=u(g[V],b[V],k);if(O!==0)return O}}function I(y,S,k){const g=y.toLowerCase(),b=S.toLowerCase(),F=D(y,S,k);if(F)return F;const T=g.endsWith(k),q=b.endsWith(k);if(T!==q)return T?-1:1;const G=N(g,b);return G!==0?G:g.localeCompare(b)}function D(y,S,k){const g=y.toLowerCase(),b=S.toLowerCase(),F=g.startsWith(k),T=b.startsWith(k);if(F!==T)return F?-1:1;if(F&&T){if(g.length<b.length)return-1;if(g.length>b.length)return 1}return 0}}),define(Ce[53],Ie([1,0,28,20,21,13,15]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=N,e.$xg=p,e.$yg=c,e.$zg=R,e.$Ag=v,e.$Bg=r,e.$Cg=o,e.$Dg=a,e.$Eg=h,e.$Fg=n,e.$Gg=s,e.$Hg=i,e.$Ig=t,e.$Jg=m,e.$Kg=f,e.$Lg=u,e.$Mg=D;function N(y){return y===w.CharCode.Slash||y===w.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,C.$hc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function R(y,S=C.$hc.sep){if(!y)return"";const k=y.length,g=y.charCodeAt(0);if(N(g)){if(N(y.charCodeAt(1))&&!N(y.charCodeAt(2))){let F=3;const T=F;for(;F<k&&!N(y.charCodeAt(F));F++);if(T!==F&&!N(y.charCodeAt(F+1))){for(F+=1;F<k;F++)if(N(y.charCodeAt(F)))return y.slice(0,F+1).replace(/[\\/]/g,S)}}return S}else if(h(g)&&y.charCodeAt(1)===w.CharCode.Colon)return N(y.charCodeAt(2))?y.slice(0,2)+S:y.slice(0,2);let b=y.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(N(y.charCodeAt(b)))return y.slice(0,b+1)}return""}function v(y){if(!P.$i||!y||y.length<5)return!1;let S=y.charCodeAt(0);if(S!==w.CharCode.Backslash||(S=y.charCodeAt(1),S!==w.CharCode.Backslash))return!1;let k=2;const g=k;for(;k<y.length&&(S=y.charCodeAt(k),S!==w.CharCode.Backslash);k++);return!(g===k||(S=y.charCodeAt(k+1),isNaN(S)||S===w.CharCode.Backslash))}const l=/[\\/:\*\?"<>\|]/g,E=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(y,S=P.$i){const k=S?l:E;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||S&&d.test(y)||y==="."||y===".."||S&&y[y.length-1]==="."||S&&y.length!==y.trim().length||y.length>255)}function o(y,S,k){const g=y===S;return!k||g?g:!y||!S?!1:(0,M.$Ff)(y,S)}function a(y,S,k,g=C.sep){if(y===S)return!0;if(!y||!S||S.length>y.length)return!1;if(k){if(!(0,M.$Gf)(y,S))return!1;if(S.length===y.length)return!0;let F=S.length;return S.charAt(S.length-1)===g&&F--,y.charAt(F)===g}return S.charAt(S.length-1)!==g&&(S+=g),y.indexOf(S)===0}function h(y){return y>=w.CharCode.A&&y<=w.CharCode.Z||y>=w.CharCode.a&&y<=w.CharCode.z}function n(y,S){return P.$i&&y.endsWith(":")&&(y+=C.sep),(0,C.$jc)(y)||(y=(0,C.$kc)(S,y)),y=(0,C.$ic)(y),s(y)}function s(y){return P.$i?(y=(0,M.$nf)(y,C.sep),y.endsWith(":")&&(y+=C.sep)):(y=(0,M.$nf)(y,C.sep),y||(y=C.sep)),y}function i(y){const S=(0,C.$ic)(y);return P.$i?y.length>3?!1:t(S)&&(y.length===2||S.charCodeAt(2)===w.CharCode.Backslash):S===C.$hc.sep}function t(y,S=P.$i){return S?h(y.charCodeAt(0))&&y.charCodeAt(1)===w.CharCode.Colon:!1}function m(y,S=P.$i){return t(y,S)?y[0]:void 0}function f(y,S,k){return S.length>y.length?-1:y===S?0:(k&&(y=y.toLowerCase(),S=S.toLowerCase()),y.indexOf(S))}function u(y){const S=y.split(":");let k,g,b;for(const F of S){const T=Number(F);(0,A.$ig)(T)?g===void 0?g=T:b===void 0&&(b=T):k=k?[k,F].join(":"):F}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:g!==void 0?g:void 0,column:b!==void 0?b:g!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,S,k=8){let g="";for(let F=0;F<k;F++){let T;F===0&&P.$i&&!S&&(k===3||k===4)?T=I:T=$,g+=T.charAt(Math.floor(Math.random()*T.length))}let b;return S?b=`${S}-${g}`:b=g,y?(0,C.$kc)(y,b):b}}),define(Ce[73],Ie([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$5s=M,e.$6s=A,e.$7s=N,e.$8s=c,e.$4s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const v=(0,w.$pc)(R),l=C[v.toLowerCase()];return l!==void 0?l:A(R)}function A(R){const v=(0,w.$pc)(R);return P[v.toLowerCase()]}function N(R){for(const v in P)if(P[v]===R)return v}const p=/^(.+)\/(.+?)(;.+)?$/;function c(R,v){const l=p.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:v?void 0:R}}),define(Ce[49],Ie([1,0,23,2,38]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=M,e.$ai=A,e.$bi=p;function M(c){return JSON.stringify(c,N)}function A(c){let R=JSON.parse(c);return R=p(R),R}function N(c,R){return R instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function p(c,R=0){if(!c||R>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return C.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof w.$Ne||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let v=0;v<c.length;++v)c[v]=p(c[v],R+1);else for(const v in c)Object.hasOwnProperty.call(c,v)&&(c[v]=p(c[v],R+1))}return c}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=p,e.$Og=c,e.$Sg=v,w=qe(w),C=qe(C),A=qe(A);var N;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(N||(e.Schemas=N={}));function p(d,r){return M.URI.isUri(d)?(0,P.$Ff)(d.scheme,r):(0,P.$Gf)(d,r+":")}function c(d,...r){return r.some(o=>p(d,o))}e.$Pg="vscode-tkn",e.$Qg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=v(r,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,N.vscodeRemoteResource)}set(r,o,a){this.a[r]=o,this.b[r]=a}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(i){return w.$2(i),r}const o=r.authority;let a=this.a[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const h=this.b[o],n=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(s+=`&${e.$Qg}=${encodeURIComponent(n)}`),M.URI.from({scheme:C.$o?this.d:N.vscodeRemoteResource,authority:`${a}:${h}`,path:this.g,query:s})}}e.$Rg=new R;function v(d,r){return A.$hc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class l{static{this.a=e.$Xg}asBrowserUri(r){const o=this.b(r,oe);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===N.vscodeRemote?e.$Rg.rewrite(r):r.scheme===N.file&&(C.$m||C.$q===`${N.vscodeFileResource}://${l.a}`)?r.with({scheme:N.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,oe);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===N.vscodeFileResource?r.with({scheme:N.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return M.URI.isUri(r)?r:M.URI.parse(o.toUrl(r))}}e.$Yg=new l;var E;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(n){let s;typeof n=="string"?s=new URL(n).searchParams:n instanceof URL?s=n.searchParams:M.URI.isUri(n)&&(s=new URL(n.toString(!0)).searchParams);const i=s?.get(o);if(i)return r.get(i)}d.getHeadersFromQuery=a;function h(n,s,i){if(!globalThis.crossOriginIsolated)return;const t=s&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(o,t):n[o]=t}d.addSearchParam=h})(E||(e.COI=E={}))}),define(Ce[24],Ie([1,0,28,53,16,20,21,13,2]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=c,e.$oh=v,e.$ph=E,C=qe(C),M=qe(M);function c(d){return(0,p.$xc)(d,!0)}class R{constructor(r){this.a=r}compare(r,o,a=!1){return r===o?0:(0,N.$yf)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return C.$Dg(c(r),c(o),this.a(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.$kh)(r.authority,o.authority))return C.$Dg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return p.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$ch)(r)||r.authority}basename(r){return M.$hc.basename(r.path)}extname(r){return M.$hc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=p.URI.file(M.$nc(c(r))).path:(o=M.$hc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==w.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=p.URI.file(M.$ic(c(r))).path:o=M.$hc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$kh)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const n=M.$mc(c(r),c(o));return A.$i?C.$xg(n):n}let a=r.path||"/";const h=o.path||"/";if(this.a(r)){let n=0;for(const s=Math.min(a.length,h.length);n<s&&!(a.charCodeAt(n)!==h.charCodeAt(n)&&a.charAt(n).toLowerCase()!==h.charAt(n).toLowerCase());n++);a=h.substr(0,n)+a.substr(n)}return M.$hc.relative(a,h)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const a=p.URI.file(M.$lc(c(r),o));return r.with({authority:a.authority,path:a.path})}return o=C.$yg(o),r.with({path:M.$hc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,N.$Ff)(r,o)}hasTrailingPathSeparator(r,o=M.sep){if(r.scheme===P.Schemas.file){const a=c(r);return a.length>C.$zg(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===w.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=M.sep){return(0,e.$lh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=M.sep){let a=!1;if(r.scheme===P.Schemas.file){const h=c(r);a=h!==void 0&&h.length===C.$zg(h).length&&h[h.length-1]===o}else{o="/";const h=r.path;a=h.length===1&&h.charCodeAt(h.length-1)===w.CharCode.Slash}return!a&&!(0,e.$lh)(r,o)?r.with({path:r.path+"/"}):r}}e.$7g=R,e.$8g=new R(()=>!1),e.$9g=new R(d=>d.scheme===P.Schemas.file?!A.$k:!0),e.$0g=new R(d=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function v(d,r){const o=[];for(let a=0;a<d.length;a++){const h=r(d[a]);d.some((n,s)=>s===a?!1:(0,e.$_g)(h,r(n)))||o.push(d[a])}return o}var l;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[i,t]=s.split(":");i&&t&&a.set(i,t)});const n=o.path.substring(0,o.path.indexOf(";"));return n&&a.set(d.META_DATA_MIME,n),a}d.parseMetaData=r})(l||(e.DataUri=l={}));function E(d,r,o){if(r){let a=d.path;return a&&a[0]!==M.$hc.sep&&(a=M.$hc.sep+a),d.with({scheme:o,authority:r,path:a})}return d.with({scheme:o})}}),define(Ce[11],Ie([1,0,22,14,4,5,24,21,145,47]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=R,e.$rh=v,e.$sh=l,e.$th=E,e.$uh=d,e.$vh=r,e.$wh=o,e.$xh=a,e.$Fh=I,e.$Gh=D,e.$Hh=y,e.$Ih=S,e.$Jh=k,e.$Yh=me,e.$7h=ae;function R(ue){return!!ue&&typeof ue.then=="function"}function v(ue){const Z=new w.$we,Y=ue(Z.token),pe=new Promise(($e,Ne)=>{const Ue=Z.token.onCancellationRequested(()=>{Ue.dispose(),Ne(new C.$6)});Promise.resolve(Y).then(ke=>{Ue.dispose(),Z.dispose(),$e(ke)},ke=>{Ue.dispose(),Z.dispose(),Ne(ke)})});return new class{cancel(){Z.cancel(),Z.dispose()}then($e,Ne){return pe.then($e,Ne)}catch($e){return this.then(void 0,$e)}finally($e){return pe.finally($e)}}}function l(ue,Z,Y){return new Promise((pe,$e)=>{const Ne=Z.onCancellationRequested(()=>{Ne.dispose(),pe(Y)});ue.then(pe,$e).finally(()=>Ne.dispose())})}function E(ue,Z){return new Promise((Y,pe)=>{const $e=Z.onCancellationRequested(()=>{$e.dispose(),pe(new C.$6)});ue.then(Y,pe).finally(()=>$e.dispose())})}async function d(ue){let Z=-1;const Y=ue.map((pe,$e)=>pe.then(Ne=>(Z=$e,Ne)));try{return await Promise.race(Y)}finally{ue.forEach((pe,$e)=>{$e!==Z&&pe.cancel()})}}function r(ue,Z,Y){let pe;const $e=setTimeout(()=>{pe?.(void 0),Y?.()},Z);return Promise.race([ue.finally(()=>clearTimeout($e)),new Promise(Ne=>pe=Ne)])}function o(ue){return new Promise((Z,Y)=>{const pe=ue();R(pe)?pe.then(Z,Y):Z(pe)})}function a(){let ue,Z;return{promise:new Promise((pe,$e)=>{ue=pe,Z=$e}),resolve:ue,reject:Z}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const Y=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(Y,Y).then(pe)})}return new Promise((Y,pe)=>{this.b.then(Y,pe)})}return this.a=Z(),new Promise((Y,pe)=>{this.a.then($e=>{this.a=null,Y($e)},$e=>{this.a=null,pe($e)})})}dispose(){this.f=!0}}e.$yh=h;class n{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$zh=n;class s{constructor(){this.a=new Map}queue(Z,Y){const $e=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Z)===$e&&this.a.delete(Z)});return this.a.set(Z,$e),$e}}e.$Ah=s;const i=(ue,Z)=>{let Y=!0;const pe=setTimeout(()=>{Y=!1,Z()},ue);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(pe),Y=!1}}},t=ue=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,ue())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class m{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,Y=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise(($e,Ne)=>{this.d=$e,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=Y===p.$ge?t(pe):i(Y,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=m;class f{constructor(Z){this.a=new m(Z),this.b=new h}trigger(Z,Y){return this.a.trigger(()=>this.b.queue(Z),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=f;class u{constructor(){this.a=!1,this.b=new Promise((Z,Y)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=u;class $ extends u{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Eh=$;function I(ue,Z){return Z?new Promise((Y,pe)=>{const $e=setTimeout(()=>{Ne.dispose(),Y()},ue),Ne=Z.onCancellationRequested(()=>{clearTimeout($e),Ne.dispose(),pe(new C.$6)})}):v(Y=>I(ue,Y))}function D(ue,Z=0,Y){const pe=setTimeout(()=>{ue(),Y&&$e.dispose()},Z),$e=(0,M.$Tc)(()=>{clearTimeout(pe),Y?.deleteAndLeak($e)});return Y?.add($e),$e}function y(ue){const Z=[];let Y=0;const pe=ue.length;function $e(){return Y<pe?ue[Y++]():null}function Ne(Ue){Ue!=null&&Z.push(Ue);const ke=$e();return ke?ke.then(Ne):Promise.resolve(Z)}return Promise.resolve(null).then(Ne)}function S(ue,Z=pe=>!!pe,Y=null){let pe=0;const $e=ue.length,Ne=()=>{if(pe>=$e)return Promise.resolve(Y);const Ue=ue[pe++];return Promise.resolve(Ue()).then(Re=>Z(Re)?Promise.resolve(Re):Ne())};return Ne()}function k(ue,Z=pe=>!!pe,Y=null){if(ue.length===0)return Promise.resolve(Y);let pe=ue.length;const $e=()=>{pe=-1;for(const Ne of ue)Ne.cancel?.()};return new Promise((Ne,Ue)=>{for(const ke of ue)ke.then(Re=>{--pe>=0&&Z(Re)?($e(),Ne(Re)):pe===0&&Ne(Y)}).catch(Re=>{--pe>=0&&($e(),Ue(Re))})})}class g{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new P.$le}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,pe)=>{this.g.push({factory:Z,c:Y,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const Y=Z.factory();Y.then(Z.c,Z.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=g;class b extends g{constructor(){super(1)}}e.$Lh=b;class F{constructor(){this.a=new se,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Mh=F;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new re;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,Y=A.$8g){const pe=Y.getComparisonKey(Z);return this.a.get(pe)?.size??0}queueFor(Z,Y,pe=A.$8g){const $e=pe.getComparisonKey(Z);let Ne=this.a.get($e);if(!Ne){Ne=new b;const Ue=this.f++,ke=P.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$5c),this.d.set(Ue,ke),this.a.set($e,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=T;class q{constructor(Z,Y){this.b=!1,this.a=-1,typeof Z=="function"&&typeof Y=="number"&&this.setIfNotSet(Z,Y)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,Y){if(this.b)throw new C.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},Y)}setIfNotSet(Z,Y){if(this.b)throw new C.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},Y))}}e.$Oh=q;class G{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,Y,pe=globalThis){if(this.f)throw new C.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=pe.setInterval(()=>{Z()},Y);this.d=(0,M.$Tc)(()=>{pe.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=G;class V{constructor(Z,Y){this.b=-1,this.a=Z,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=V;class O{constructor(Z,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Z,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=O;class W extends V{constructor(Z,Y){super(Z,Y),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Sh=W;class ce extends M.$Vc{constructor(Z,Y){super(),this.g=Z,this.h=Y,this.a=[],this.b=this.B(new M.$Wc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Z)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(ue,Z)=>{(0,N.$B)(()=>{if(Y)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Vh=(ue,Z,Y)=>{const pe=ue.requestIdleCallback(Z,typeof Y=="number"?{timeout:Y}:void 0);let $e=!1;return{dispose(){$e||($e=!0,ue.cancelIdleCallback(pe))}}},e.$Uh=ue=>(0,e.$Vh)(globalThis,ue)}();class ge{constructor(Z,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Vh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ge;class te extends ge{constructor(Z){super(globalThis,Z)}}e.$Xh=te;async function me(ue,Z,Y){let pe;for(let $e=0;$e<Y;$e++)try{return await ue()}catch(Ne){pe=Ne,await I(Z)}throw pe}class se{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,Y,pe){return this.a={taskId:Z,cancel:()=>pe?.(),promise:Y},Y.then(()=>this.d(Z),()=>this.d(Z)),Y}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:Y,resolve:pe,reject:$e}=a();this.b={run:Z,promise:Y,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=se;class de{constructor(Z,Y=()=>Date.now()){this.d=Z,this.f=Y,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$1h=de;var be;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(be||(be={}));class re{get isRejected(){return this.d?.outcome===be.Rejected}get isResolved(){return this.d?.outcome===be.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===be.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,Y)=>{this.a=Z,this.b=Y})}complete(Z){return new Promise(Y=>{this.a(Z),this.d={outcome:be.Resolved,value:Z},Y()})}error(Z){return new Promise(Y=>{this.b(Z),this.d={outcome:be.Rejected,value:Z},Y()})}cancel(){return this.error(new C.$6)}}e.$2h=re;var Pe;(function(ue){async function Z(pe){let $e;const Ne=await Promise.all(pe.map(Ue=>Ue.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return Ne}ue.settled=Z;function Y(pe){return new Promise(async($e,Ne)=>{try{await pe($e,Ne)}catch(Ue){Ne(Ue)}})}ue.withAsyncBody=Y})(Pe||(e.Promises=Pe={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new C.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=Fe;class X{constructor(Z){this.b=Z,this.a=new c.$W(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=X;var B;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(B||(B={}));class _{static fromArray(Z){return new _(Y=>{Y.emitMany(Z)})}static fromPromise(Z){return new _(async Y=>{Y.emitMany(await Z)})}static fromPromises(Z){return new _(async Y=>{await Promise.all(Z.map(async pe=>Y.emitOne(await pe)))})}static merge(Z){return new _(async Y=>{await Promise.all(Z.map(async pe=>{for await(const $e of pe)Y.emitOne($e)}))})}static{this.EMPTY=_.fromArray([])}constructor(Z,Y){this.a=B.Initial,this.b=[],this.d=null,this.f=Y,this.g=new P.$le,queueMicrotask(async()=>{const pe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(Z(pe)),this.k()}catch($e){this.l($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,Y){return new _(async pe=>{for await(const $e of Z)pe.emitOne(Y($e))})}map(Z){return _.map(this,Z)}static filter(Z,Y){return new _(async pe=>{for await(const $e of Z)Y($e)&&pe.emitOne($e)})}filter(Z){return _.filter(this,Z)}static coalesce(Z){return _.filter(Z,Y=>!!Y)}coalesce(){return _.coalesce(this)}static async toPromise(Z){const Y=[];for await(const pe of Z)Y.push(pe);return Y}toPromise(){return _.toPromise(this)}h(Z){this.a===B.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===B.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(Z){this.a===B.Initial&&(this.a=B.DoneError,this.d=Z,this.g.fire())}}e.$5h=_;class we extends _{constructor(Z,Y){super(Y),this.m=Z}cancel(){this.m.cancel()}}e.$6h=we;function ae(ue){const Z=new w.$we,Y=ue(Z.token);return new we(Z,async pe=>{const $e=Z.token.onCancellationRequested(()=>{$e.dispose(),Z.dispose(),pe.reject(new C.$6)});try{for await(const Ne of Y){if(Z.token.isCancellationRequested)return;pe.emitOne(Ne)}$e.dispose(),Z.dispose()}catch(Ne){$e.dispose(),Z.dispose(),pe.reject(Ne)}})}class ve{constructor(Z){this.a=new re,this.b=new _($e=>{if(Y){$e.reject(Y);return}return pe&&$e.emitMany(pe),this.d=Ne=>$e.reject(Ne),this.f=Ne=>$e.emitOne(Ne),this.a.p},Z);let Y,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{Y||(Y=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$8h=ve}),define(Ce[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=void 0,e.$tk=R,e.$wk=r,e.$xk=F,e.$yk=T,e.$zk=q,e.$Ak=G,e.$Bk=V,e.$Ck=ge;function R(){return Object.create(null)}e.$uk="**",e.$vk="/";const v="[/\\\\]",l="[^/\\\\]",E=/\//g;function d(te,me){switch(te){case 0:return"";case 1:return`${l}*?`;default:return`(?:${v}|${l}+${v}${me?`|${v}${l}+`:""})*?`}}function r(te,me){if(!te)return[];const se=[];let de=!1,be=!1,re="";for(const Pe of te){switch(Pe){case me:if(!de&&!be){se.push(re),re="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":be=!0;break;case"]":be=!1;break}re+=Pe}return re&&se.push(re),se}function o(te){if(!te)return"";let me="";const se=r(te,e.$vk);if(se.every(de=>de===e.$uk))me=".*";else{let de=!1;se.forEach((be,re)=>{if(be===e.$uk){if(de)return;me+=d(2,re===se.length-1)}else{let Pe=!1,Fe="",X=!1,B="";for(const _ of be){if(_!=="}"&&Pe){Fe+=_;continue}if(X&&(_!=="]"||!B)){let we;_==="-"?we=_:(_==="^"||_==="!")&&!B?we="^":_===e.$vk?we="":we=(0,c.$hf)(_),B+=we;continue}switch(_){case"{":Pe=!0;continue;case"[":X=!0;continue;case"}":{const ae=`(?:${r(Fe,",").map(ve=>o(ve)).join("|")})`;me+=ae,Pe=!1,Fe="";break}case"]":{me+="["+B+"]",X=!1,B="";break}case"?":me+=l;continue;case"*":me+=d(1);continue;default:me+=(0,c.$hf)(_)}}re<se.length-1&&(se[re+1]!==e.$uk||re+2<se.length)&&(me+=v)}de=be===e.$uk})}return me}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,m=new A.$Ec(1e4),f=function(){return!1},u=function(){return null};function $(te,me){if(!te)return u;let se;typeof te!="string"?se=te.pattern:se=te,se=se.trim();const de=`${se}_${!!me.trimForExclusions}`;let be=m.get(de);if(be)return I(be,te);let re;return a.test(se)?be=y(se.substr(4),se):(re=h.exec(D(se,me)))?be=S(re[1],se):(me.trimForExclusions?s:n).test(se)?be=k(se,me):(re=i.exec(D(se,me)))?be=g(re[1].substr(1),se,!0):(re=t.exec(D(se,me)))?be=g(re[1],se,!1):be=b(se),m.set(de,be),I(be,te)}function I(te,me){if(typeof me=="string")return te;const se=function(de,be){return(0,M.$Dg)(de,me.base,!p.$k)?te((0,c.$mf)(de.substr(me.base.length),N.sep),be):null};return se.allBasenames=te.allBasenames,se.allPaths=te.allPaths,se.basenames=te.basenames,se.patterns=te.patterns,se}function D(te,me){return me.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function y(te,me){return function(se,de){return typeof se=="string"&&se.endsWith(te)?me:null}}function S(te,me){const se=`/${te}`,de=`\\${te}`,be=function(Pe,Fe){return typeof Pe!="string"?null:Fe?Fe===te?me:null:Pe===te||Pe.endsWith(se)||Pe.endsWith(de)?me:null},re=[te];return be.basenames=re,be.patterns=[me],be.allBasenames=re,be}function k(te,me){const se=ce(te.slice(1,-1).split(",").map(Fe=>$(Fe,me)).filter(Fe=>Fe!==u),te),de=se.length;if(!de)return u;if(de===1)return se[0];const be=function(Fe,X){for(let B=0,_=se.length;B<_;B++)if(se[B](Fe,X))return te;return null},re=se.find(Fe=>!!Fe.allBasenames);re&&(be.allBasenames=re.allBasenames);const Pe=se.reduce((Fe,X)=>X.allPaths?Fe.concat(X.allPaths):Fe,[]);return Pe.length&&(be.allPaths=Pe),be}function g(te,me,se){const de=N.sep===N.$hc.sep,be=de?te:te.replace(E,N.sep),re=N.sep+be,Pe=N.$hc.sep+te;let Fe;return se?Fe=function(X,B){return typeof X=="string"&&(X===be||X.endsWith(re)||!de&&(X===te||X.endsWith(Pe)))?me:null}:Fe=function(X,B){return typeof X=="string"&&(X===be||!de&&X===te)?me:null},Fe.allPaths=[(se?"*/":"./")+te],Fe}function b(te){try{const me=new RegExp(`^${o(te)}$`);return function(se){return me.lastIndex=0,typeof se=="string"&&me.test(se)?te:null}}catch{return u}}function F(te,me,se){return!te||typeof me!="string"?!1:T(te)(me,void 0,se)}function T(te,me={}){if(!te)return f;if(typeof te=="string"||q(te)){const se=$(te,me);if(se===u)return f;const de=function(be,re){return!!se(be,re)};return se.allBasenames&&(de.allBasenames=se.allBasenames),se.allPaths&&(de.allPaths=se.allPaths),de}return O(te,me)}function q(te){const me=te;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function G(te){return te.allBasenames||[]}function V(te){return te.allPaths||[]}function O(te,me){const se=ce(Object.getOwnPropertyNames(te).map(Fe=>W(Fe,te[Fe],me)).filter(Fe=>Fe!==u)),de=se.length;if(!de)return u;if(!se.some(Fe=>!!Fe.requiresSiblings)){if(de===1)return se[0];const Fe=function(_,we){let ae;for(let ve=0,ue=se.length;ve<ue;ve++){const Z=se[ve](_,we);if(typeof Z=="string")return Z;(0,C.$qh)(Z)&&(ae||(ae=[]),ae.push(Z))}return ae?(async()=>{for(const ve of ae){const ue=await ve;if(typeof ue=="string")return ue}return null})():null},X=se.find(_=>!!_.allBasenames);X&&(Fe.allBasenames=X.allBasenames);const B=se.reduce((_,we)=>we.allPaths?_.concat(we.allPaths):_,[]);return B.length&&(Fe.allPaths=B),Fe}const be=function(Fe,X,B){let _,we;for(let ae=0,ve=se.length;ae<ve;ae++){const ue=se[ae];ue.requiresSiblings&&B&&(X||(X=(0,N.$oc)(Fe)),_||(_=X.substr(0,X.length-(0,N.$pc)(Fe).length)));const Z=ue(Fe,X,_,B);if(typeof Z=="string")return Z;(0,C.$qh)(Z)&&(we||(we=[]),we.push(Z))}return we?(async()=>{for(const ae of we){const ve=await ae;if(typeof ve=="string")return ve}return null})():null},re=se.find(Fe=>!!Fe.allBasenames);re&&(be.allBasenames=re.allBasenames);const Pe=se.reduce((Fe,X)=>X.allPaths?Fe.concat(X.allPaths):Fe,[]);return Pe.length&&(be.allPaths=Pe),be}function W(te,me,se){if(me===!1)return u;const de=$(te,se);if(de===u)return u;if(typeof me=="boolean")return de;if(me){const be=me.when;if(typeof be=="string"){const re=(Pe,Fe,X,B)=>{if(!B||!de(Pe,Fe))return null;const _=be.replace("$(basename)",()=>X),we=B(_);return(0,C.$qh)(we)?we.then(ae=>ae?te:null):we?te:null};return re.requiresSiblings=!0,re}}return de}function ce(te,me){const se=te.filter(Fe=>!!Fe.basenames);if(se.length<2)return te;const de=se.reduce((Fe,X)=>{const B=X.basenames;return B?Fe.concat(B):Fe},[]);let be;if(me){be=[];for(let Fe=0,X=de.length;Fe<X;Fe++)be.push(me)}else be=se.reduce((Fe,X)=>{const B=X.patterns;return B?Fe.concat(B):Fe},[]);const re=function(Fe,X){if(typeof Fe!="string")return null;if(!X){let _;for(_=Fe.length;_>0;_--){const we=Fe.charCodeAt(_-1);if(we===P.CharCode.Slash||we===P.CharCode.Backslash)break}X=Fe.substr(_)}const B=de.indexOf(X);return B!==-1?be[B]:null};re.basenames=de,re.patterns=be,re.allBasenames=de;const Pe=te.filter(Fe=>!Fe.basenames);return Pe.push(re),Pe}function ge(te,me){return(0,w.$vb)(te,me,(se,de)=>typeof se=="string"&&typeof de=="string"?se===de:typeof se!="string"&&typeof de!="string"?se.base===de.base&&se.pattern===de.pattern:!1)}}),define(Ce[60],Ie([1,0,14,99,24,13,2]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.MarkdownStringTextNewlineStyle=void 0,e.$3k=c,e.$4k=R,e.$5k=v,e.$6k=l,e.$7k=E,e.$8k=d,e.$9k=r,e.$0k=o;var N;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(N||(e.MarkdownStringTextNewlineStyle=N={}));class p{constructor(h="",n=!1){if(this.value=h,typeof this.value!="string")throw(0,w.$8)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(h,n=N.Paragraph){return this.value+=l(this.supportThemeIcons?(0,C.$Vk)(h):h).replace(/([ \t]+)/g,(s,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===N.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,n){return this.value+=`
${E(n,h)}
`,this}appendLink(h,n,s){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(h),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(h,n){const s=new RegExp((0,M.$hf)(n),"g");return h.replace(s,(i,t)=>h.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$2k=p;function c(a){return R(a)?!a.value:Array.isArray(a)?a.every(c):!0}function R(a){return a instanceof p?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function v(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons&&a.supportHtml===h.supportHtml&&(a.baseUri===h.baseUri||!!a.baseUri&&!!h.baseUri&&(0,P.$$g)(A.URI.from(a.baseUri),A.URI.from(h.baseUri)))}function l(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(a,h){const n=a.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,s=n>=3?n+1:3;return[`${"`".repeat(s)}${h}`,a,`${"`".repeat(s)}`].join(`
`)}function d(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const h=[],n=a.split("|").map(i=>i.trim());a=n[0];const s=n[1];if(s){const i=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),m=i?i[1]:"",f=t?t[1]:"",u=isFinite(parseInt(f)),$=isFinite(parseInt(m));u&&h.push(`width="${f}"`),$&&h.push(`height="${m}"`)}return{href:a,dimensions:h}}}),define(Ce[103],Ie([1,0,18,53,20,21,24,13]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rw=p,e.$Sw=R,e.$Tw=l,e.$Uw=E,e.$Vw=a,e.$Ww=n,e.$Xw=s,e.$Yw=i,e.$Zw=t,e.$1w=m;function p(u,$){const{os:I,tildify:D,relative:y}=$;if(y){const g=c(u,y,I);if(typeof g=="string")return g}let S=u.fsPath;if(I===M.OperatingSystem.Windows&&!M.$i?S=S.replace(/\//g,"\\"):I!==M.OperatingSystem.Windows&&M.$i&&(S=S.replace(/\\/g,"/")),I!==M.OperatingSystem.Windows&&D?.userHome){const g=D.userHome.fsPath;let b;u.scheme!==D.userHome.scheme&&u.path[0]===P.$hc.sep&&u.path[1]!==P.$hc.sep?b=D.userHome.with({path:u.path}).fsPath:b=S,S=l(b,g,I)}return(I===M.OperatingSystem.Windows?P.$gc:P.$hc).normalize(R(S,I===M.OperatingSystem.Windows))}function c(u,$,I){const D=I===M.OperatingSystem.Windows?P.$gc:P.$hc,y=I===M.OperatingSystem.Linux?A.$8g:A.$0g,S=$.getWorkspace(),k=(0,w.$Pb)(S.folders);if(!k)return;u.scheme!==k.uri.scheme&&u.path[0]===P.$hc.sep&&u.path[1]!==P.$hc.sep&&(u=k.uri.with({path:u.path}));const g=$.getWorkspaceFolder(u);if(!g)return;let b;if(y.isEqual(g.uri,u)?b="":b=y.relativePath(g.uri,u)??"",b&&(b=D.normalize(b)),S.folders.length>1&&!$.noPrefix){const F=g.name?g.name:y.basenameOrAuthority(g.uri);b=b?`${F} \u2022 ${b}`:F}return b}function R(u,$=M.$i){return(0,C.$Ig)(u,$)?u.charAt(0).toUpperCase()+u.slice(1):u}let v=Object.create(null);function l(u,$,I=M.OS){if(I===M.OperatingSystem.Windows||!u||!$)return u;let D=v.original===$?v.normalized:void 0;D||(D=$,M.$i&&(D=(0,C.$xg)(D)),D=`${(0,N.$nf)(D,P.$hc.sep)}${P.$hc.sep}`,v={original:$,normalized:D});let y=u;return M.$i&&(y=(0,C.$xg)(y)),(I===M.OperatingSystem.Linux?y.startsWith(D):(0,N.$Gf)(y,D))?`~/${y.substr(D.length)}`:u}function E(u,$){return u.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",r="\\\\",o="~";function a(u,$=P.sep){const I=new Array(u.length);let D=!1;for(let y=0;y<u.length;y++){const S=u[y];if(S===""){I[y]=`.${$}`;continue}if(!S){I[y]=S;continue}D=!0;let k="",g=S;g.indexOf(r)===0?(k=g.substr(0,g.indexOf(r)+r.length),g=g.substr(g.indexOf(r)+r.length)):g.indexOf($)===0?(k=g.substr(0,g.indexOf($)+$.length),g=g.substr(g.indexOf($)+$.length)):g.indexOf(o)===0&&(k=g.substr(0,g.indexOf(o)+o.length),g=g.substr(g.indexOf(o)+o.length));const b=g.split($);for(let F=1;D&&F<=b.length;F++)for(let T=b.length-F;D&&T>=0;T--){D=!1;let q=b.slice(T,T+F).join($);for(let G=0;!D&&G<u.length;G++)if(G!==y&&u[G]&&u[G].indexOf(q)>-1){const V=T+F===b.length,O=T>0&&u[G].indexOf($)>-1?$+q:q,W=u[G].endsWith(O);D=!V||W}if(!D){let G="";(b[0].endsWith(":")||k!=="")&&(T===1&&(T=0,F++,q=b[0]+$+q),T>0&&(G=b[0]+$),G=k+G),T>0&&(G=G+d+$),G=G+q,T+F<b.length&&(G=G+$+d),I[y]=G}}D&&(I[y]=S)}return I}var h;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function n(u,$=Object.create(null)){const I=[];let D=!1,y="";for(const S of u)if(S==="$"||D&&S==="{")y&&I.push({value:y,type:h.TEXT}),y="",D=!0;else if(S==="}"&&D){const k=$[y];if(typeof k=="string")k.length&&I.push({value:k,type:h.VARIABLE});else if(k){const g=I[I.length-1];(!g||g.type!==h.SEPARATOR)&&I.push({value:k.label,type:h.SEPARATOR})}y="",D=!1}else y+=S;return y&&!D&&I.push({value:y,type:h.TEXT}),I.filter((S,k)=>{if(S.type===h.SEPARATOR){const g=I[k-1],b=I[k+1];return[g,b].every(F=>F&&(F.type===h.VARIABLE||F.type===h.TEXT)&&F.value.length>0)}return!0}).map(S=>S.value).join("")}function s(u,$){return M.$j||$?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):u.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function i(u,$){return M.$j||$?u.replace(/\(&&\w\)|&&/g,""):M.$i?u.replace(/&&|&/g,I=>I==="&"?"&&":"&"):u.replace(/&&/g,"_")}function t(u){return u.replace(/&/g,"&&")}function m(u){if(u.endsWith("]")){const $=u.lastIndexOf(" [",u.length-2);if($!==-1){const I=f(u.substring(0,$)),D=u.substring($);return{name:I.name+D,parentPath:I.parentPath}}}return f(u)}function f(u){const $=u.indexOf("/")!==-1?P.$hc:P.$gc,I=$.basename(u),D=$.dirname(u);return I.length?{name:I,parentPath:D}:{name:D,parentPath:""}}}),define(Ce[160],Ie([1,0,23,38,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=void 0,e.$Kn=p,e.$Ln=R,e.$Mn=v;function M(l){return l.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:M(P.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:M(P.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:P.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$In=A,e.$Jn=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function N(l,E,d){if(!l||d>200)return null;if(typeof l=="object"){if(l instanceof P.URI)return E.transformOutgoing(l);for(const r in l)if(Object.hasOwnProperty.call(l,r)){const o=N(l[r],E,d+1);o!==null&&(l[r]=o)}}return null}function p(l,E){const d=N(l,E,0);return d===null?l:d}function c(l,E,d,r){if(!l||r>200)return null;if(typeof l=="object"){if(l.$mid===C.MarshalledId.Uri)return d?P.URI.revive(E.transformIncoming(l)):E.transformIncoming(l);if(l instanceof w.$Ne)return null;for(const o in l)if(Object.hasOwnProperty.call(l,o)){const a=c(l[o],E,d,r+1);a!==null&&(l[o]=a)}}return null}function R(l,E){const d=c(l,E,!1,0);return d===null?l:d}function v(l,E){const d=c(l,E,!0,0);return d===null?l:d}}),define(Ce[161],Ie([1,0,11,4,5,49,15]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.StorageState=e.StorageHint=void 0,e.$9p=p;var N;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N||(e.StorageHint=N={}));function p(l){const E=l;return E?.changed instanceof Map||E?.deleted instanceof Set}var c;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(c||(e.StorageState=c={}));class R extends P.$Vc{static{this.a=100}constructor(E,d=Object.create(null)){super(),this.r=E,this.s=d,this.b=this.B(new C.$oe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new w.$Ch(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((d,r)=>this.w(r,d)),E.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(E,d){if(this.c===c.Closed)return;let r=!1;(0,A.$ng)(d)?r=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,d){const r=this.f.get(E);return(0,A.$ng)(r)?d:r}getBoolean(E,d){const r=this.get(E);return(0,A.$ng)(r)?d:r==="true"}getNumber(E,d){const r=this.get(E);return(0,A.$ng)(r)?d:parseInt(r,10)}getObject(E,d){const r=this.get(E);return(0,A.$ng)(r)?d:(0,M.$ai)(r)}async set(E,d,r=!1){if(this.c===c.Closed)return;if((0,A.$ng)(d))return this.delete(E,r);const o=(0,A.$gg)(d)||Array.isArray(d)?(0,M.$_h)(d):String(d);if(this.f.get(E)!==o)return this.f.set(E,o),this.j.set(E,o),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,d=!1){if(!(this.c===c.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===c.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===N.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===N.STORAGE_IN_MEMORY}}e.$0p=R;class v{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,r)=>this.a.set(r,d)),E.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$$p=v}),define(Ce[162],Ie([1,0,13,21,23]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9t=void 0,e.$7t=R,e.$8t=v,w=qe(w),C=qe(C),P=qe(P);let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let N;function p(){return N||(N=new TextDecoder("UTF-16BE")),N}let c;function R(){return c||(c=C.$D()?A():p()),c}function v(d,r,o){const a=new Uint16Array(d.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?l(d,r,o):A().decode(a)}function l(d,r,o){const a=[];let h=0;for(let n=0;n<o;n++){const s=P.$Pe(d,r);r+=2,a[h++]=String.fromCharCode(s)}return a.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return R().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||w.$Jf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let a=0;a<o;a++)this.b[this.d++]=r.charCodeAt(a)}}e.$9t=E}),define(Ce[163],Ie([1,0,23,162]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=void 0,e.$$t=A,w=qe(w);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,R,v,l){this.oldPosition=c,this.oldText=R,this.newPosition=v,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,R,v){const l=R.length;w.$Se(c,l,v),v+=4;for(let E=0;E<l;E++)w.$Qe(c,R.charCodeAt(E),v),v+=2;return v}static d(c,R){const v=w.$Re(c,R);return R+=4,(0,C.$8t)(c,R,v)}writeSize(){return 8+M.a(this.oldText)+M.a(this.newText)}write(c,R){return w.$Se(c,this.oldPosition,R),R+=4,w.$Se(c,this.newPosition,R),R+=4,R=M.c(c,this.oldText,R),R=M.c(c,this.newText,R),R}static read(c,R,v){const l=w.$Re(c,R);R+=4;const E=w.$Re(c,R);R+=4;const d=M.d(c,R);R+=M.a(d);const r=M.d(c,R);return R+=M.a(r),v.push(new M(l,d,E,r)),R}}e.$0t=M;function A(p,c){return p===null||p.length===0?c:new N(p,c).compress()}class N{constructor(c,R){this.a=c,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,R=0,v=this.n(c),l=this.l(R);for(;c<this.f||R<this.h;){if(v===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(v),v=this.n(++c);continue}if(l.oldEnd<=v.newPosition){this.k(l),l=this.l(++R);continue}if(v.newEnd<=l.oldPosition){this.m(v),v=this.n(++c);continue}if(l.oldPosition<v.newPosition){const[a,h]=N.r(l,v.newPosition-l.oldPosition);this.k(a),l=h;continue}if(v.newPosition<l.oldPosition){const[a,h]=N.q(v,l.oldPosition-v.newPosition);this.m(a),v=h;continue}let r,o;if(l.oldEnd===v.newEnd)r=v,o=l,v=this.n(++c),l=this.l(++R);else if(l.oldEnd<v.newEnd){const[a,h]=N.q(v,l.oldLength);r=a,o=l,v=h,l=this.l(++R)}else{const[a,h]=N.r(l,v.newLength);r=v,o=a,v=this.n(++c),l=h}this.d[this.e++]=new M(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const E=N.s(this.d);return N.t(E)}k(c){this.d[this.e++]=N.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=N.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,R){return new M(R.oldPosition-c,R.oldText,R.newPosition,R.newText)}static p(c,R){return new M(R.oldPosition,R.oldText,R.newPosition+c,R.newText)}static q(c,R){const v=c.newText.substr(0,R),l=c.newText.substr(R);return[new M(c.oldPosition,c.oldText,c.newPosition,v),new M(c.oldEnd,"",c.newPosition+R,l)]}static r(c,R){const v=c.oldText.substr(0,R),l=c.oldText.substr(R);return[new M(c.oldPosition,v,c.newPosition,c.newText),new M(c.oldPosition+R,l,c.newEnd,"")]}static s(c){if(c.length===0)return c;const R=[];let v=0,l=c[0];for(let E=1;E<c.length;E++){const d=c[E];l.oldEnd===d.oldPosition?l=new M(l.oldPosition,l.oldText+d.oldText,l.newPosition,l.newText+d.newText):(R[v++]=l,l=d)}return R[v++]=l,R}static t(c){if(c.length===0)return c;const R=[];let v=0;for(let l=0;l<c.length;l++){const E=c[l];E.oldText!==E.newText&&(R[v++]=E)}return R}}}),define(Ce[164],Ie([1,0,41,20]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=P,e.$pu=M;function P(A,N,p,c,R,v){if(Array.isArray(A)){let l=0;for(const E of A){const d=P(E,N,p,c,R,v);if(d===10)return d;d>l&&(l=d)}return l}else{if(typeof A=="string")return c?A==="*"?5:A===p?10:0:0;if(A){const{language:l,pattern:E,scheme:d,hasAccessToAllModels:r,notebookType:o}=A;if(!c&&!r)return 0;o&&R&&(N=R);let a=0;if(d)if(d===N.scheme)a=10;else if(d==="*")a=5;else return 0;if(l)if(l===p)a=10;else if(l==="*")a=Math.max(a,5);else return 0;if(o)if(o===v)a=10;else if(o==="*"&&v!==void 0)a=Math.max(a,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,C.$ic)(E.base)},h===N.fsPath||(0,w.$xk)(h,N.fsPath))a=10;else return 0}return a}else return 0}}function M(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(M):!!A.notebookType}}),define(Ce[165],Ie([1,0,4,13,33,52,100,148,163,5]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=void 0,C=qe(C);class R extends c.$Vc{constructor(l,E,d,r,o,a,h){super(),this.m=this.B(new w.$le),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=r,this.h=o,this.c=new A.$gD(l,d,h)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,E){return this.c.getOffsetAt(l,E)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,E){const d=l+E,r=this.getPositionAt(l),o=this.getPositionAt(d);return new P.$Ht(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,E=M.EndOfLinePreference.TextDefined){if(l.isEmpty())return"";const d=this.n(E);return this.c.getValueInRange(l,d)}getValueLengthInRange(l,E=M.EndOfLinePreference.TextDefined){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const d=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const a=this.n(E),h=this.getEOL();if(a.length!==h.length){const n=a.length-h.length,s=l.endLineNumber-l.startLineNumber;o=n*s}return r-d+o}getCharacterCountInRange(l,E=M.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=l.startLineNumber,o=l.endLineNumber;for(let a=r;a<=o;a++){const h=this.getLineContent(a),n=a===r?l.startColumn-1:0,s=a===o?l.endColumn-1:h.length;for(let i=n;i<s;i++)C.$Jf(h.charCodeAt(i))?(d=d+1,i=i+1):d=d+1}return d+=this.n(E).length*(o-r),d}return this.getValueLengthInRange(l,E)}getNearestChunk(l){return this.c.getNearestChunk(l)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,E){return this.c.getLineCharCode(l,E)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const E=C.$uf(this.getLineContent(l));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(l){const E=C.$wf(this.getLineContent(l));return E===-1?0:E+2}n(l){switch(l){case M.EndOfLinePreference.LF:return`
`;case M.EndOfLinePreference.CRLF:return`\r
`;case M.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,E,d){let r=this.g,o=this.h,a=this.j,h=!0,n=[];for(let $=0;$<l.length;$++){const I=l[$];h&&I._isTracked&&(h=!1);const D=I.range;if(I.text){let b=!0;a||(b=!C.$Uf(I.text),a=b),!r&&b&&(r=C.$Tf(I.text)),!o&&b&&(o=C.$Wf(I.text))}let y="",S=0,k=0,g=0;if(I.text){let b;[S,k,g,b]=(0,N.$ru)(I.text);const F=this.getEOL(),T=F===`\r
`?N.StringEOL.CRLF:N.StringEOL.LF;b===N.StringEOL.Unknown||b===T?y=I.text:y=I.text.replace(/\r\n|\r|\n/g,F)}n[$]={sortIndex:$,identifier:I.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:S,firstLineLength:k,lastLineLength:g,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}n.sort(R.u);let s=!1;for(let $=0,I=n.length-1;$<I;$++){const D=n[$].range.getEndPosition(),y=n[$+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}h&&(n=this.s(n));const i=d||E?R._getInverseEditRanges(n):[],t=[];if(E)for(let $=0;$<n.length;$++){const I=n[$],D=i[$];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let S="";y===D.startLineNumber&&(S=this.getLineContent(I.range.startLineNumber),C.$uf(S)!==-1)||t.push({lineNumber:y,oldContent:S})}}let m=null;if(d){let $=0;m=[];for(let I=0;I<n.length;I++){const D=n[I],y=i[I],S=this.getValueInRange(D.range),k=D.rangeOffset+$;$+=D.text.length-S.length,m[I]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:S,textChange:new p.$0t(D.rangeOffset,S,k,D.text)}}s||m.sort((I,D)=>I.sortIndex-D.sortIndex)}this.g=r,this.h=o,this.j=a;const f=this.t(n);let u=null;if(E&&t.length>0){t.sort(($,I)=>I.lineNumber-$.lineNumber),u=[];for(let $=0,I=t.length;$<I;$++){const D=t[$].lineNumber;if($>0&&t[$-1].lineNumber===D)continue;const y=t[$].oldContent,S=this.getLineContent(D);S.length===0||S===y||C.$uf(S)!==-1||u.push(D)}}return this.m.fire(),new M.$aw(m,f,u)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let E=!1;const d=l[0].range,r=l[l.length-1].range,o=new P.$Ht(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let a=d.startLineNumber,h=d.startColumn;const n=[];for(let f=0,u=l.length;f<u;f++){const $=l[f],I=$.range;E=E||$.forceMoveMarkers,n.push(this.getValueInRange(new P.$Ht(a,h,I.startLineNumber,I.startColumn))),$.text.length>0&&n.push($.text),a=I.endLineNumber,h=I.endColumn}const s=n.join(""),[i,t,m]=(0,N.$ru)(s);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,M.EndOfLinePreference.TextDefined),text:s,eolCount:i,firstLineLength:t,lastLineLength:m,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const E=[];for(let d=0;d<l.length;d++){const r=l[d],o=r.range.startLineNumber,a=r.range.startColumn,h=r.range.endLineNumber,n=r.range.endColumn;if(o===h&&a===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new P.$Ht(o,a,h,n);E.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(l,E,d,r){return this.c.findMatchesLineByLine(l,E,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,E){const d=l.startLineNumber,r=l.startColumn,[o,a,h]=(0,N.$ru)(E);let n;if(E.length>0){const s=o+1;s===1?n=new P.$Ht(d,r,d,r+a):n=new P.$Ht(d,r,d+s-1,h+1)}else n=new P.$Ht(d,r,d,r);return n}static _getInverseEditRanges(l){const E=[];let d=0,r=0,o=null;for(let a=0,h=l.length;a<h;a++){const n=l[a];let s,i;o?o.range.endLineNumber===n.range.startLineNumber?(s=d,i=r+(n.range.startColumn-o.range.endColumn)):(s=d+(n.range.startLineNumber-o.range.endLineNumber),i=n.range.startColumn):(s=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const m=n.eolCount+1;m===1?t=new P.$Ht(s,i,s,i+n.firstLineLength):t=new P.$Ht(s,i,s+m-1,n.lastLineLength+1)}else t=new P.$Ht(s,i,s,i);d=t.endLineNumber,r=t.endColumn,E.push(t),o=n}return E}static u(l,E){const d=P.$Ht.compareRangesUsingEnds(l.range,E.range);return d===0?l.sortIndex-E.sortIndex:d}static w(l,E){const d=P.$Ht.compareRangesUsingEnds(l.range,E.range);return d===0?E.sortIndex-l.sortIndex:-d}}e.$hD=R}),define(Ce[166],Ie([1,0,28,13,52,100,165]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0,C=qe(C);class N{constructor(R,v,l,E,d,r,o,a,h){this.a=R,this.b=v,this.c=l,this.d=E,this.e=d,this.f=r,this.g=o,this.h=a,this.j=h}k(R){const v=this.c+this.d+this.e,l=this.c+this.e;return v===0?R===P.DefaultEndOfLine.LF?`
`:`\r
`:l>v/2?`\r
`:`
`}create(R){const v=this.k(R),l=this.a;if(this.j&&(v===`\r
`&&(this.c>0||this.d>0)||v===`
`&&(this.c>0||this.e>0)))for(let d=0,r=l.length;d<r;d++){const o=l[d].buffer.replace(/\r\n|\r|\n/g,v),a=(0,M.$cD)(o);l[d]=new M.$fD(o,a)}const E=new A.$hD(l,this.b,v,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&C.$5f(R)&&(this.b=C.$4f,R=R.substr(1));const v=R.charCodeAt(R.length-1);v===w.CharCode.CarriageReturn||v>=55296&&v<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=v):(this.m(R,!1),this.c=!1,this.d=v)}m(R,v){!v&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const v=(0,M.$dD)(this.e,R);this.a.push(new M.$fD(R,v.lineStarts)),this.f+=v.cr,this.g+=v.lf,this.h+=v.crlf,v.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Tf(R)),this.k||(this.k=C.$Wf(R)))}finish(R=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const v=(0,M.$cD)(R.buffer);R.lineStarts=v,this.d===w.CharCode.CarriageReturn&&this.f++}}}e.$iD=p}),define(Ce[104],Ie([1,0,23,21]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcb=p,e.$Hcb=R,C=qe(C);var P;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(P||(P={}));function M(v){for(let l=0,E=v.length;l<E;l+=4){const d=v[l+0],r=v[l+1],o=v[l+2],a=v[l+3];v[l+0]=a,v[l+1]=o,v[l+2]=r,v[l+3]=d}}function A(v){const l=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return C.$D()||M(l),w.$Ne.wrap(l)}function N(v){const l=v.buffer;if(C.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const E=new Uint8Array(l.byteLength);return E.set(l),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(v){const l=new Uint32Array(c(v));let E=0;if(l[E++]=v.id,v.type==="full")l[E++]=P.Full,l[E++]=v.data.length,l.set(v.data,E),E+=v.data.length;else{l[E++]=P.Delta,l[E++]=v.deltas.length;for(const d of v.deltas)l[E++]=d.start,l[E++]=d.deleteCount,d.data?(l[E++]=d.data.length,l.set(d.data,E),E+=d.data.length):l[E++]=0}return A(l)}function c(v){let l=0;if(l+=2,v.type==="full")l+=1+v.data.length;else{l+=1,l+=3*v.deltas.length;for(const E of v.deltas)E.data&&(l+=E.data.length)}return l}function R(v){const l=N(v);let E=0;const d=l[E++];if(l[E++]===P.Full){const h=l[E++],n=l.subarray(E,E+h);return E+=h,{id:d,type:"full",data:n}}const o=l[E++],a=[];for(let h=0;h<o;h++){const n=l[E++],s=l[E++],i=l[E++];let t;i>0&&(t=l.subarray(E,E+i),E+=i),a[h]={start:n,deleteCount:s,data:t}}return{id:d,type:"delta",deltas:a}}}),define(Ce[167],Ie([8,9]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[168],Ie([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[169],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[170],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[171],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[172],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[173],Ie([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ce[174],Ie([8,9]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ce[175],Ie([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ce[176],Ie([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ce[177],Ie([8,9]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[178],Ie([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[179],Ie([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[180],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[181],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[182],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[183],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[184],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[185],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[186],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[187],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[188],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[189],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[190],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[191],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[192],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ce[193],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ce[194],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ce[195],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[196],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[197],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[198],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[199],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[200],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[201],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[202],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[203],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[204],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[205],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[206],Ie([1,0,28,14,170]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var M;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(M||(e.TokenType=M={}));function A(...R){switch(R.length){case 1:return(0,P.localize)(0,null,R[0]);case 2:return(0,P.localize)(1,null,R[0],R[1]);case 3:return(0,P.localize)(2,null,R[0],R[1],R[2]);default:return}}const N=(0,P.localize)(3,null),p=(0,P.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case M.LParen:return"(";case M.RParen:return")";case M.Neg:return"!";case M.Eq:return v.isTripleEq?"===":"==";case M.NotEq:return v.isTripleEq?"!==":"!=";case M.Lt:return"<";case M.LtEq:return"<=";case M.Gt:return">=";case M.GtEq:return">=";case M.RegexOp:return"=~";case M.RegexStr:return v.lexeme;case M.True:return"true";case M.False:return"false";case M.In:return"in";case M.Not:return"not";case M.And:return"&&";case M.Or:return"||";case M.Str:return v.lexeme;case M.QuotedStr:return v.lexeme;case M.Error:return v.lexeme;case M.EOF:return"EOF";default:throw(0,C.$9)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",M.Not],["in",M.In],["false",M.False],["true",M.True]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case w.CharCode.OpenParen:this.k(M.LParen);break;case w.CharCode.CloseParen:this.k(M.RParen);break;case w.CharCode.ExclamationMark:if(this.h(w.CharCode.Equals)){const l=this.h(w.CharCode.Equals);this.f.push({type:M.NotEq,offset:this.d,isTripleEq:l})}else this.k(M.Neg);break;case w.CharCode.SingleQuote:this.o();break;case w.CharCode.Slash:this.q();break;case w.CharCode.Equals:if(this.h(w.CharCode.Equals)){const l=this.h(w.CharCode.Equals);this.f.push({type:M.Eq,offset:this.d,isTripleEq:l})}else this.h(w.CharCode.Tilde)?this.k(M.RegexOp):this.l(A("==","=~"));break;case w.CharCode.LessThan:this.k(this.h(w.CharCode.Equals)?M.LtEq:M.Lt);break;case w.CharCode.GreaterThan:this.k(this.h(w.CharCode.Equals)?M.GtEq:M.Gt);break;case w.CharCode.Ampersand:this.h(w.CharCode.Ampersand)?this.k(M.And):this.l(A("&&"));break;case w.CharCode.Pipe:this.h(w.CharCode.Pipe)?this.k(M.Or):this.l(A("||"));break;case w.CharCode.Space:case w.CharCode.CarriageReturn:case w.CharCode.Tab:case w.CharCode.LineFeed:case w.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(M.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?w.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const l=this.d,E=this.c.substring(this.d,this.e),d={type:M.Error,offset:this.d,lexeme:E};this.g.push({offset:l,lexeme:E,additionalInfo:v}),this.f.push(d)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const l=this.c.substring(this.d,this.e),E=c.b.get(l);E?this.k(E):this.f.push({type:M.Str,lexeme:l,offset:this.d})}}o(){for(;this.j()!==w.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:M.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,l=!1,E=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(p);return}const r=this.c.charCodeAt(v);if(l)l=!1;else if(r===w.CharCode.Slash&&!E){v++;break}else r===w.CharCode.OpenSquareBracket?E=!0:r===w.CharCode.Backslash?l=!0:r===w.CharCode.CloseSquareBracket&&(E=!1);v++}for(;v<this.c.length&&c.a.has(this.c.charCodeAt(v));)v++;this.e=v;const d=this.c.substring(this.d,this.e);this.f.push({type:M.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=c});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[207],Ie([1,0,24,36,172,321]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=p,e.$Up=c,e.$Vp=R,e.$Wp=v,e.$Xp=l,e.$Yp=E,e.$Zp=d,C=ri(C),P=qe(P),M=qe(M);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,N=/^-(\d{4})(\d{2})(\d{2})$/;function p(a){return a=a.trim(),a==="*"||A.test(a)}function c(a){if(!p(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=a.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function R(a){if(!a)return null;const h=a.majorBase,n=a.majorMustEqual,s=a.minorBase;let i=a.minorMustEqual;const t=a.patchBase;let m=a.patchMustEqual;a.hasCaret&&(h===0||(i=!1),m=!1);let f=0;if(a.preRelease){const u=N.exec(a.preRelease);if(u){const[,$,I,D]=u;f=Date.UTC(Number($),Number(I)-1,Number(D))}}return{majorBase:h,majorMustEqual:n,minorBase:s,minorMustEqual:i,patchBase:t,patchMustEqual:m,isMinimum:a.hasGreaterEquals,notBefore:f}}function v(a,h,n){let s;typeof a=="string"?s=R(c(a)):s=a;let i;h instanceof Date?i=h.getTime():typeof h=="string"&&(i=new Date(h).getTime());let t;if(typeof n=="string"?t=R(c(n)):t=n,!s||!t)return!1;const m=s.majorBase,f=s.minorBase,u=s.patchBase;let $=t.majorBase,I=t.minorBase,D=t.patchBase;const y=t.notBefore;let S=t.majorMustEqual,k=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?m>$?!0:m<$?!1:f>I?!0:f<I||i&&i<y?!1:u>=D:(m===1&&$===0&&(!S||!k||!g)&&($=1,I=0,D=0,S=!0,k=!1,g=!1),m<$?!1:m>$?!S:f<I?!1:f>I?!k:u<D?!1:u>D?!g:!(i&&i<y))}function l(a,h,n,s,i){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([C.default.Error,P.localize(0,null)]),t;if(typeof s.name!="string")return t.push([C.default.Error,P.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([C.default.Error,P.localize(2,null,"version")]),t;if(!s.engines)return t.push([C.default.Error,P.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([C.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return t.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return t.push([C.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([C.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([C.default.Error,P.localize(9,null,"main")]),t;{const u=(0,w.$fh)(n,s.main);(0,w.$_g)(u,n)||t.push([C.default.Warning,P.localize(10,null,u.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([C.default.Error,P.localize(11,null,"browser")]),t;{const u=(0,w.$fh)(n,s.browser);(0,w.$_g)(u,n)||t.push([C.default.Warning,P.localize(12,null,u.path,n.path)])}}if(!M.valid(s.version))return t.push([C.default.Error,P.localize(13,null)]),t;const m=[];if(!E(a,h,s,i,m))for(const u of m)t.push([C.default.Error,u]);return t}function E(a,h,n,s,i){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(a,h,n.engines.vscode,i)}function d(a,h,n){return a==="*"||r(h,n,a)}function r(a,h,n,s=[]){const i=R(c(n));if(!i)return s.push(P.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return s.push(P.localize(15,null,n)),!1}else if(!i.majorMustEqual)return s.push(P.localize(16,null,n)),!1;return v(a,h,i)?!0:(s.push(P.localize(17,null,a,n)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let h=0,n=a.length;h<n;h++)if(typeof a[h]!="string")return!1;return!0}}),define(Ce[74],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class w{constructor(P,M=[],A=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Bi=w}),define(Ce[61],Ie([1,0,74]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ks=M,e.$Ls=A;const C=[];var P;(function(N){N[N.Eager=0]="Eager",N[N.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M(N,p,c){p instanceof w.$Bi||(p=new w.$Bi(p,[],!!c)),C.push([N,p])}function A(){return C}}),define(Ce[208],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;class w{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$nr=w;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const N=this.lookupOrInsertNode(M),p=this.lookupOrInsertNode(A);N.outgoing.set(p.key,p),p.incoming.set(N.key,N)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const N of this.a.values())N.outgoing.delete(A),N.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let N=this.a.get(A);return N||(N=new w(A,M),this.a.set(A,N)),N}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,N]of this.a)M.push(`${A}
	(-> incoming)[${[...N.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...N.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const N=new Set([M]),p=this.c(A,N);if(p)return p}}c(M,A){for(const[N,p]of M.outgoing){if(A.has(N))return[...A,N].join(" -> ");A.add(N);const c=this.c(p,A);if(c)return c;A.delete(N)}}}e.$or=C}),define(Ce[3],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=P,e.$Fi=M;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function N(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=N})(w||(e._util=w={})),e.$Di=P("instantiationService");function C(A,N,p){N[w.DI_TARGET]===N?N[w.DI_DEPENDENCIES].push({id:A,index:p}):(N[w.DI_DEPENDENCIES]=[{id:A,index:p}],N[w.DI_TARGET]=N)}function P(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const N=function(p,c,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(N,p,R)};return N.toString=()=>A,w.serviceIds.set(A,N),N}function M(A){return A}}),define(Ce[42],Ie([1,0,15,2,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=M,e.$aj=A,e.$bj=p,e.$cj=c,e.$dj=R,e.$ej=v,e.$fj=l,e.$gj=d,e.$hj=r,e.$ij=o,w=qe(w),e.$$i=(0,P.$Ei)("configurationService");function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof C.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof C.URI)}var N;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(N||(e.ConfigurationTarget=N={}));function p(a){switch(a){case N.APPLICATION:return"APPLICATION";case N.USER:return"USER";case N.USER_LOCAL:return"USER_LOCAL";case N.USER_REMOTE:return"USER_REMOTE";case N.WORKSPACE:return"WORKSPACE";case N.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case N.DEFAULT:return"DEFAULT";case N.MEMORY:return"MEMORY"}}function c(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function R(a,h){const n=Object.create(null);for(const s in a)v(n,s,a[s],h);return n}function v(a,h,n,s){const i=h.split("."),t=i.pop();let m=a;for(let f=0;f<i.length;f++){const u=i[f];let $=m[u];switch(typeof $){case"undefined":$=m[u]=Object.create(null);break;case"object":if($===null){s(`Ignoring ${h} as ${i.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${h} as ${i.slice(0,f+1).join(".")} is ${JSON.stringify($)}`);return}m=$}if(typeof m=="object"&&m!==null)try{m[t]=n}catch{s(`Ignoring ${h} as ${i.join(".")} is ${JSON.stringify(m)}`)}else s(`Ignoring ${h} as ${i.join(".")} is ${JSON.stringify(m)}`)}function l(a,h){const n=h.split(".");E(a,n)}function E(a,h){const n=h.shift();if(h.length===0){delete a[n];return}if(Object.keys(a).indexOf(n)!==-1){const s=a[n];typeof s=="object"&&!Array.isArray(s)&&(E(s,h),Object.keys(s).length===0&&delete a[n])}}function d(a,h,n){function s(m,f){let u=m;for(const $ of f){if(typeof u!="object"||u===null)return;u=u[$]}return u}const i=h.split("."),t=s(a,i);return typeof t>"u"?n:t}function r(a,h,n){Object.keys(h).forEach(s=>{s!=="__proto__"&&(s in a?w.$gg(a[s])&&w.$gg(h[s])?r(a[s],h[s],n):n&&(a[s]=h[s]):a[s]=h[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,206,3,169,14]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=R,e.$Dj=f,e.$Ej=u,e.$Xj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",C.$j),c.set("isLinux",C.$k),c.set("isWindows",C.$i),c.set("isWeb",C.$o),c.set("isMacNative",C.$j&&!C.$o),c.set("isEdge",C.$H),c.set("isFirefox",C.$F),c.set("isChrome",C.$E),c.set("isSafari",C.$G);function R(X,B){if(c.get(X)!==void 0)throw(0,p.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(X,B)}const v=Object.prototype.hasOwnProperty;var l;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const E={regexParsingWithErrorRecovery:!0},d=(0,N.localize)(0,null),r=(0,N.localize)(1,null),o=(0,N.localize)(2,null),a=(0,N.localize)(3,null),h=(0,N.localize)(4,null),n=(0,N.localize)(5,null),s=(0,N.localize)(6,null),i=(0,N.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=E){this.k=B,this.d=new M.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const we=this.D(),ae=we.type===M.TokenType.Str?n:void 0;throw this.h.push({message:h,offset:we.offset,lexeme:M.$zj.getLexeme(we),additionalInfo:ae}),t.c}return _}catch(_){if(_!==t.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(M.TokenType.Or);){const _=this.o();B.push(_)}return B.length===1?B[0]:m.or(...B)}o(){const B=[this.s()];for(;this.y(M.TokenType.And);){const _=this.s();B.push(_)}return B.length===1?B[0]:m.and(...B)}s(){if(this.y(M.TokenType.Neg)){const B=this.D();switch(B.type){case M.TokenType.True:return this.z(),I.INSTANCE;case M.TokenType.False:return this.z(),D.INSTANCE;case M.TokenType.LParen:{this.z();const _=this.l();return this.A(M.TokenType.RParen,a),_?.negate()}case M.TokenType.Str:return this.z(),F.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case M.TokenType.True:return this.z(),m.true();case M.TokenType.False:return this.z(),m.false();case M.TokenType.LParen:{this.z();const _=this.l();return this.A(M.TokenType.RParen,a),_}case M.TokenType.Str:{const _=B.lexeme;if(this.z(),this.y(M.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==M.TokenType.RegexStr)throw this.B("REGEX",ae);const ve=ae.lexeme,ue=ve.lastIndexOf("/"),Z=ue===ve.length-1?void 0:this.w(ve.substring(ue+1));let Y;try{Y=new RegExp(ve.substring(1,ue),Z)}catch{throw this.B("REGEX",ae)}return W.create(_,Y)}switch(ae.type){case M.TokenType.RegexStr:case M.TokenType.Error:{const ve=[ae.lexeme];this.z();let ue=this.D(),Z=0;for(let Ue=0;Ue<ae.lexeme.length;Ue++)ae.lexeme.charCodeAt(Ue)===w.CharCode.OpenParen?Z++:ae.lexeme.charCodeAt(Ue)===w.CharCode.CloseParen&&Z--;for(;!this.E()&&ue.type!==M.TokenType.And&&ue.type!==M.TokenType.Or;){switch(ue.type){case M.TokenType.LParen:Z++;break;case M.TokenType.RParen:Z--;break;case M.TokenType.RegexStr:case M.TokenType.QuotedStr:for(let Ue=0;Ue<ue.lexeme.length;Ue++)ue.lexeme.charCodeAt(Ue)===w.CharCode.OpenParen?Z++:ae.lexeme.charCodeAt(Ue)===w.CharCode.CloseParen&&Z--}if(Z<0)break;ve.push(M.$zj.getLexeme(ue)),this.z(),ue=this.D()}const Y=ve.join(""),pe=Y.lastIndexOf("/"),$e=pe===Y.length-1?void 0:this.w(Y.substring(pe+1));let Ne;try{Ne=new RegExp(Y.substring(1,pe),$e)}catch{throw this.B("REGEX",ae)}return m.regex(_,Ne)}case M.TokenType.QuotedStr:{const ve=ae.lexeme;this.z();let ue=null;if(!(0,P.$cf)(ve)){const Z=ve.indexOf("/"),Y=ve.lastIndexOf("/");if(Z!==Y&&Z>=0){const pe=ve.slice(Z+1,Y),$e=ve[Y+1]==="i"?"i":"";try{ue=new RegExp(pe,$e)}catch{throw this.B("REGEX",ae)}}}if(ue===null)throw this.B("REGEX",ae);return W.create(_,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(M.TokenType.Not)){this.A(M.TokenType.In,o);const ae=this.u();return m.notIn(_,ae)}switch(this.D().type){case M.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===M.TokenType.QuotedStr)return m.equals(_,ae);switch(ae){case"true":return m.has(_);case"false":return m.not(_);default:return m.equals(_,ae)}}case M.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===M.TokenType.QuotedStr)return m.notEquals(_,ae);switch(ae){case"true":return m.not(_);case"false":return m.has(_);default:return m.notEquals(_,ae)}}case M.TokenType.Lt:return this.z(),V.create(_,this.u());case M.TokenType.LtEq:return this.z(),O.create(_,this.u());case M.TokenType.Gt:return this.z(),q.create(_,this.u());case M.TokenType.GtEq:return this.z(),G.create(_,this.u());case M.TokenType.In:return this.z(),m.in(_,this.u());default:return m.has(_)}}case M.TokenType.EOF:throw this.h.push({message:s,offset:B.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case M.TokenType.Str:case M.TokenType.QuotedStr:return this.z(),B.lexeme;case M.TokenType.True:return this.z(),"true";case M.TokenType.False:return this.z(),"false";case M.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,we){const ae=(0,N.localize)(8,null,B,M.$zj.getLexeme(_)),ve=_.offset,ue=M.$zj.getLexeme(_);return this.h.push({message:ae,offset:ve,lexeme:ue,additionalInfo:we}),t.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===M.TokenType.EOF}}e.$Bj=t;class m{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(B){return y.create(B)}static equals(B,_){return S.create(B,_)}static notEquals(B,_){return b.create(B,_)}static regex(B,_){return W.create(B,_)}static in(B,_){return k.create(B,_)}static notIn(B,_){return g.create(B,_)}static not(B){return F.create(B)}static and(...B){return te.create(B,null,!0)}static or(...B){return me.create(B,null,!0)}static greater(B,_){return q.create(B,_)}static greaterEquals(B,_){return G.create(B,_)}static smaller(B,_){return V.create(B,_)}static smallerEquals(B,_){return O.create(B,_)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Cj=m;function f(X){const B=new t({regexParsingWithErrorRecovery:!1});return X.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(we=>({errorMessage:we.additionalInfo?(0,N.localize)(9,null,we.additionalInfo):(0,N.localize)(10,null),offset:we.offset,length:we.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(we=>({errorMessage:we.additionalInfo?`${we.message}. ${we.additionalInfo}`:we.message,offset:we.offset,length:we.lexeme.length})):[]))}function u(X,B){const _=X?X.substituteConstants():void 0,we=B?B.substituteConstants():void 0;return!_&&!we?!0:!_||!we?!1:_.equals(we)}function $(X,B){return X.cmp(B)}class I{static{this.INSTANCE=new I}constructor(){this.type=l.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return D.INSTANCE}}e.$Fj=I;class D{static{this.INSTANCE=new D}constructor(){this.type=l.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return I.INSTANCE}}e.$Gj=D;class y{static create(B,_=null){const we=c.get(B);return typeof we=="boolean"?we?D.INSTANCE:I.INSTANCE:new y(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=l.Defined}cmp(B){return B.type!==this.type?this.type-B.type:de(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=c.get(this.key);return typeof B=="boolean"?B?D.INSTANCE:I.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Hj=y;class S{static create(B,_,we=null){if(typeof _=="boolean")return _?y.create(B,we):F.create(B,we);const ae=c.get(B);return typeof ae=="boolean"?_===(ae?"true":"false")?D.INSTANCE:I.INSTANCE:new S(B,_,we)}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=l.Equals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?D.INSTANCE:I.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ij=S;class k{static create(B,_){return new k(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=l.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:be(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),we=B.getValue(this.d);return Array.isArray(_)?_.includes(we):typeof we=="string"&&typeof _=="object"&&_!==null?v.call(_,we):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Jj=k;class g{static create(B,_){return new g(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=l.NotIn,this.c=k.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=g;class b{static create(B,_,we=null){if(typeof _=="boolean")return _?F.create(B,we):y.create(B,we);const ae=c.get(B);return typeof ae=="boolean"?_===(ae?"true":"false")?I.INSTANCE:D.INSTANCE:new b(B,_,we)}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=l.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?I.INSTANCE:D.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Lj=b;class F{static create(B,_=null){const we=c.get(B);return typeof we=="boolean"?we?I.INSTANCE:D.INSTANCE:new F(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=l.Not}cmp(B){return B.type!==this.type?this.type-B.type:de(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=c.get(this.c);return typeof B=="boolean"?B?I.INSTANCE:D.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Mj=F;function T(X,B){if(typeof X=="string"){const _=parseFloat(X);isNaN(_)||(X=_)}return typeof X=="string"||typeof X=="number"?B(X):I.INSTANCE}class q{static create(B,_,we=null){return T(_,ae=>new q(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=l.Greater}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Nj=q;class G{static create(B,_,we=null){return T(_,ae=>new G(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=l.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Oj=G;class V{static create(B,_,we=null){return T(_,ae=>new V(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=l.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Pj=V;class O{static create(B,_,we=null){return T(_,ae=>new O(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=l.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Qj=O;class W{static create(B,_){return new W(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=l.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",we=B.f?B.f.source:"";return _<we?-1:_>we?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",we=B.f?B.f.source:"";return this.d===B.d&&_===we}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Rj=W;class ce{static create(B){return new ce(B)}constructor(B){this.c=B,this.type=l.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new ce(this.c.map(B))}negate(){return this.c}}e.$Sj=ce;function ge(X){let B=null;for(let _=0,we=X.length;_<we;_++){const ae=X[_].substituteConstants();if(X[_]!==ae&&B===null){B=[];for(let ve=0;ve<_;ve++)B[ve]=X[ve]}B!==null&&(B[_]=ae)}return B===null?X:B}class te{static create(B,_,we){return te.d(B,_,we)}constructor(B,_){this.expr=B,this.c=_,this.type=l.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,we=this.expr.length;_<we;_++){const ae=$(this.expr[_],B.expr[_]);if(ae!==0)return ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,we=this.expr.length;_<we;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=ge(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let _=0,we=this.expr.length;_<we;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,we){const ae=[];let ve=!1;for(const ue of B)if(ue){if(ue.type===l.True){ve=!0;continue}if(ue.type===l.False)return I.INSTANCE;if(ue.type===l.And){ae.push(...ue.expr);continue}ae.push(ue)}if(ae.length===0&&ve)return D.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort($);for(let ue=1;ue<ae.length;ue++)ae[ue-1].equals(ae[ue])&&(ae.splice(ue,1),ue--);if(ae.length===1)return ae[0];for(;ae.length>1;){const ue=ae[ae.length-1];if(ue.type!==l.Or)break;ae.pop();const Z=ae.pop(),Y=ae.length===0,pe=me.create(ue.expr.map($e=>te.create([$e,Z],null,we)),null,Y);pe&&(ae.push(pe),ae.sort($))}if(ae.length===1)return ae[0];if(we){for(let ue=0;ue<ae.length;ue++)for(let Z=ue+1;Z<ae.length;Z++)if(ae[ue].negate().equals(ae[Z]))return I.INSTANCE;if(ae.length===1)return ae[0]}return new te(ae,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new te(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=me.create(B,this,!0)}return this.c}}e.$Tj=te;class me{static create(B,_,we){return me.d(B,_,we)}constructor(B,_){this.expr=B,this.c=_,this.type=l.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,we=this.expr.length;_<we;_++){const ae=$(this.expr[_],B.expr[_]);if(ae!==0)return ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,we=this.expr.length;_<we;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=ge(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let _=0,we=this.expr.length;_<we;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,we){let ae=[],ve=!1;if(B){for(let ue=0,Z=B.length;ue<Z;ue++){const Y=B[ue];if(Y){if(Y.type===l.False){ve=!0;continue}if(Y.type===l.True)return D.INSTANCE;if(Y.type===l.Or){ae=ae.concat(Y.expr);continue}ae.push(Y)}}if(ae.length===0&&ve)return I.INSTANCE;ae.sort($)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let ue=1;ue<ae.length;ue++)ae[ue-1].equals(ae[ue])&&(ae.splice(ue,1),ue--);if(ae.length===1)return ae[0];if(we){for(let ue=0;ue<ae.length;ue++)for(let Z=ue+1;Z<ae.length;Z++)if(ae[ue].negate().equals(ae[Z]))return D.INSTANCE;if(ae.length===1)return ae[0]}return new me(ae,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new me(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),we=B.shift(),ae=[];for(const ve of Fe(_))for(const ue of Fe(we))ae.push(te.create([ve,ue],null,!1));B.unshift(me.create(ae,null,!1))}this.c=me.create(B,this,!0)}return this.c}}e.$Uj=me;class se extends y{static{this.d=[]}static all(){return se.d.values()}constructor(B,_,we){super(B,null),this.f=_,typeof we=="object"?se.d.push({...we,key:B}):we!==!0&&se.d.push({key:B,description:we,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return b.create(this.key,B)}}e.$Vj=se,e.$Wj=(0,A.$Ei)("contextKeyService");function de(X,B){return X<B?-1:X>B?1:0}function be(X,B,_,we){return X<_?-1:X>_?1:B<we?-1:B>we?1:0}function re(X,B){if(X.type===l.False||B.type===l.True)return!0;if(X.type===l.Or)return B.type===l.Or?Pe(X.expr,B.expr):!1;if(B.type===l.Or){for(const _ of B.expr)if(re(X,_))return!0;return!1}if(X.type===l.And){if(B.type===l.And)return Pe(B.expr,X.expr);for(const _ of X.expr)if(re(_,B))return!0;return!1}return X.equals(B)}function Pe(X,B){let _=0,we=0;for(;_<X.length&&we<B.length;){const ae=X[_].cmp(B[we]);if(ae<0)return!1;ae===0&&_++,we++}return _===X.length}function Fe(X){return X.type===l.Or?X.expr:[X]}}),define(Ce[209],Ie([1,0,32,3]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$lt=e.AccessibilitySupport=e.$kt=void 0,e.$mt=M,e.$kt=(0,C.$Ei)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$lt=new w.$Vj("accessibilityModeEnabled",!1);function M(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$nt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[105],Ie([1,0,18,26,21,143,322,149,210,167,209]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=m,e.stringSet=$,e.cursorStyleToString=T,e.filterValidationDecorations=Re,w=qe(w),C=qe(C),P=qe(P),c=qe(c);var v;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class l{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=l;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class d{constructor(x,De,Ze,Ye){this.id=x,this.name=De,this.defaultValue=Ze,this.schema=Ye}applyUpdate(x,De){return o(x,De)}compute(x,De,Ze){return Ze}}class r{constructor(x,De){this.newValue=x,this.didChange=De}}e.ApplyUpdateResult=r;function o(H,x){if(typeof H!="object"||typeof x!="object"||!H||!x)return new r(x,H!==x);if(Array.isArray(H)||Array.isArray(x)){const Ze=Array.isArray(H)&&Array.isArray(x)&&w.$vb(H,x);return new r(x,!Ze)}let De=!1;for(const Ze in x)if(x.hasOwnProperty(Ze)){const Ye=o(H[Ze],x[Ze]);Ye.didChange&&(H[Ze]=Ye.newValue,De=!0)}return new r(H,De)}class a{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,De){return o(x,De)}validate(x){return this.defaultValue}}class h{constructor(x,De,Ze,Ye){this.id=x,this.name=De,this.defaultValue=Ze,this.schema=Ye}applyUpdate(x,De){return o(x,De)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,De,Ze){return Ze}}function n(H,x){return typeof H>"u"?x:H==="false"?!1:!!H}class s extends h{constructor(x,De,Ze,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=Ze),super(x,De,Ze,Ye)}validate(x){return n(x,this.defaultValue)}}function i(H,x,De,Ze){if(typeof H>"u")return x;let Ye=parseInt(H,10);return isNaN(Ye)?x:(Ye=Math.max(De,Ye),Ye=Math.min(Ze,Ye),Ye|0)}class t extends h{static clampedInt(x,De,Ze,Ye){return i(x,De,Ze,Ye)}constructor(x,De,Ze,Ye,dt,pt=void 0){typeof pt<"u"&&(pt.type="integer",pt.default=Ze,pt.minimum=Ye,pt.maximum=dt),super(x,De,Ze,pt),this.minimum=Ye,this.maximum=dt}validate(x){return t.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function m(H,x,De,Ze){if(typeof H>"u")return x;const Ye=f.float(H,x);return f.clamp(Ye,De,Ze)}class f extends h{static clamp(x,De,Ze){return x<De?De:x>Ze?Ze:x}static float(x,De){if(typeof x=="number")return x;if(typeof x>"u")return De;const Ze=parseFloat(x);return isNaN(Ze)?De:Ze}constructor(x,De,Ze,Ye,dt){typeof dt<"u"&&(dt.type="number",dt.default=Ze),super(x,De,Ze,dt),this.validationFn=Ye}validate(x){return this.validationFn(f.float(x,this.defaultValue))}}class u extends h{static string(x,De){return typeof x!="string"?De:x}constructor(x,De,Ze,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=Ze),super(x,De,Ze,Ye)}validate(x){return u.string(x,this.defaultValue)}}function $(H,x,De,Ze){return typeof H!="string"?x:Ze&&H in Ze?Ze[H]:De.indexOf(H)===-1?x:H}class I extends h{constructor(x,De,Ze,Ye,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Ye,dt.default=Ze),super(x,De,Ze,dt),this.c=Ye}validate(x){return $(x,this.defaultValue,this.c)}}class D extends d{constructor(x,De,Ze,Ye,dt,pt,Ft=void 0){typeof Ft<"u"&&(Ft.type="string",Ft.enum=dt,Ft.default=Ye),super(x,De,Ze,Ft),this.c=dt,this.d=pt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function y(H){switch(H){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class S extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(x){switch(x){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,De,Ze){return Ze===R.AccessibilitySupport.Unknown?x.accessibilitySupport:Ze}}class k extends d{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:c.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertSpace:n(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(g||(e.TextEditorCursorBlinkingStyle=g={}));function b(H){switch(H){case"blink":return g.Blink;case"smooth":return g.Smooth;case"phase":return g.Phase;case"expand":return g.Expand;case"solid":return g.Solid}}var F;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(F||(e.TextEditorCursorStyle=F={}));function T(H){switch(H){case F.Line:return"line";case F.Block:return"block";case F.Underline:return"underline";case F.LineThin:return"line-thin";case F.BlockOutline:return"block-outline";case F.UnderlineThin:return"underline-thin"}}function q(H){switch(H){case"line":return F.Line;case"block":return F.Block;case"underline":return F.Underline;case"line-thin":return F.LineThin;case"block-outline":return F.BlockOutline;case"underline-thin":return F.UnderlineThin}}class G extends a{constructor(){super(je.editorClassName)}compute(x,De,Ze){const Ye=["monaco-editor"];return De.get(je.extraEditorClassName)&&Ye.push(De.get(je.extraEditorClassName)),x.extraEditorClassName&&Ye.push(x.extraEditorClassName),De.get(je.mouseStyle)==="default"?Ye.push("mouse-default"):De.get(je.mouseStyle)==="copy"&&Ye.push("mouse-copy"),De.get(je.showUnused)&&Ye.push("showUnused"),De.get(je.showDeprecated)&&Ye.push("showDeprecated"),Ye.join(" ")}}class V extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(x,De,Ze){return Ze&&x.emptySelectionClipboard}}class O extends d{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:c.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:c.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{cursorMoveOnType:n(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":$(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":$(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(De.loop,this.defaultValue.loop)}}}class W extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?W.OFF:x==="true"?W.ON:x:x?W.ON:W.OFF}}e.EditorFontLigatures=W;class ce extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",ce.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?ce.OFF:x==="true"?ce.TRANSLATE:x:x?ce.TRANSLATE:ce.OFF}compute(x,De,Ze){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=ce;class ge extends a{constructor(){super(je.fontInfo)}compute(x,De,Ze){return x.fontInfo}}class te extends h{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(x){const De=f.float(x,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(De,6,100)}compute(x,De,Ze){return x.fontInfo.fontSize}}class me extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.d,maximum:me.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(t.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,me.d,me.e))}}class se extends d{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ze,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ze,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ze,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ze,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ze,description:c.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{multiple:$(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??$(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??$(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??$(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??$(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??$(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends d{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:c.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),delay:t.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:n(De.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(De.above,this.defaultValue.above)}}}var be;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(be||(e.RenderMinimap=be={}));class re extends a{constructor(){super(je.layoutInfo)}compute(x,De,Ze){return re.computeLayout(De,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const De=x.height/x.lineHeight,Ze=Math.floor(x.paddingTop/x.lineHeight);let Ye=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Ye=Math.max(Ye,De-1));const dt=(Ze+x.viewLineCount+Ye)/(x.pixelRatio*x.height),pt=Math.floor(x.viewLineCount/dt);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:Ye,desiredRatio:dt,minimapLineCount:pt}}static c(x,De){const Ze=x.outerWidth,Ye=x.outerHeight,dt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:be.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(dt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const pt=De.stableMinimapLayoutInput,Ft=pt&&x.outerHeight===pt.outerHeight&&x.lineHeight===pt.lineHeight&&x.typicalHalfwidthCharacterWidth===pt.typicalHalfwidthCharacterWidth&&x.pixelRatio===pt.pixelRatio&&x.scrollBeyondLastLine===pt.scrollBeyondLastLine&&x.paddingTop===pt.paddingTop&&x.paddingBottom===pt.paddingBottom&&x.minimap.enabled===pt.minimap.enabled&&x.minimap.side===pt.minimap.side&&x.minimap.size===pt.minimap.size&&x.minimap.showSlider===pt.minimap.showSlider&&x.minimap.renderCharacters===pt.minimap.renderCharacters&&x.minimap.maxColumn===pt.minimap.maxColumn&&x.minimap.scale===pt.minimap.scale&&x.verticalScrollbarWidth===pt.verticalScrollbarWidth&&x.isViewportWrapping===pt.isViewportWrapping,zt=x.lineHeight,xt=x.typicalHalfwidthCharacterWidth,ui=x.scrollBeyondLastLine,xe=x.minimap.renderCharacters;let It=dt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Gt=x.minimap.maxColumn,ht=x.minimap.size,bt=x.minimap.side,hi=x.verticalScrollbarWidth,_t=x.viewLineCount,jt=x.remainingWidth,wt=x.isViewportWrapping,Bt=xe?2:3;let Jt=Math.floor(dt*Ye);const Qt=Jt/dt;let Qe=!1,pi=!1,ei=Bt*It,si=It/dt,St=1;if(ht==="fill"||ht==="fit"){const{typicalViewportLineCount:Vt,extraLinesBeforeFirstLine:Ht,extraLinesBeyondLastLine:di,desiredRatio:Lt,minimapLineCount:vt}=re.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:ui,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Ye,lineHeight:zt,pixelRatio:dt});if(_t/vt>1)Qe=!0,pi=!0,It=1,ei=1,si=It/dt;else{let Tt=!1,kt=It+1;if(ht==="fit"){const Zt=Math.ceil((Ht+_t+di)*ei);wt&&Ft&&jt<=De.stableFitRemainingWidth?(Tt=!0,kt=De.stableFitMaxMinimapScale):Tt=Zt>Jt}if(ht==="fill"||Tt){Qe=!0;const Zt=It;ei=Math.min(zt*dt,Math.max(1,Math.floor(1/Lt))),wt&&Ft&&jt<=De.stableFitRemainingWidth&&(kt=De.stableFitMaxMinimapScale),It=Math.min(kt,Math.max(1,Math.floor(ei/Bt))),It>Zt&&(St=Math.min(2,It/Zt)),si=It/dt/St,Jt=Math.ceil(Math.max(Vt,Ht+_t+di)*ei),wt?(De.stableMinimapLayoutInput=x,De.stableFitRemainingWidth=jt,De.stableFitMaxMinimapScale=It):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const Kt=Math.floor(Gt*si),At=Math.min(Kt,Math.max(0,Math.floor((jt-hi-2)*si/(xt+si)))+e.MINIMAP_GUTTER_WIDTH);let Ot=Math.floor(dt*At);const ti=Ot/dt;Ot=Math.floor(Ot*St);const ii=xe?be.Text:be.Blocks,oi=bt==="left"?0:Ze-At-hi;return{renderMinimap:ii,minimapLeft:oi,minimapWidth:At,minimapHeightIsEditorHeight:Qe,minimapIsSampling:pi,minimapScale:It,minimapLineHeight:ei,minimapCanvasInnerWidth:Ot,minimapCanvasInnerHeight:Jt,minimapCanvasOuterWidth:ti,minimapCanvasOuterHeight:Qt}}static computeLayout(x,De){const Ze=De.outerWidth|0,Ye=De.outerHeight|0,dt=De.lineHeight|0,pt=De.lineNumbersDigitCount|0,Ft=De.typicalHalfwidthCharacterWidth,zt=De.maxDigitWidth,xt=De.pixelRatio,ui=De.viewLineCount,xe=x.get(je.wordWrapOverride2),It=xe==="inherit"?x.get(je.wordWrapOverride1):xe,Gt=It==="inherit"?x.get(je.wordWrap):It,ht=x.get(je.wordWrapColumn),bt=De.isDominatedByLongLines,hi=x.get(je.glyphMargin),_t=x.get(je.lineNumbers).renderType!==Ue.Off,jt=x.get(je.lineNumbersMinChars),wt=x.get(je.scrollBeyondLastLine),Bt=x.get(je.padding),Jt=x.get(je.minimap),Qt=x.get(je.scrollbar),Qe=Qt.verticalScrollbarSize,pi=Qt.verticalHasArrows,ei=Qt.arrowSize,si=Qt.horizontalScrollbarSize,St=x.get(je.folding),Kt=x.get(je.showFoldingControls)!=="never";let At=x.get(je.lineDecorationsWidth);St&&Kt&&(At+=16);let Ot=0;if(_t){const $i=Math.max(pt,jt);Ot=Math.round($i*zt)}let ti=0;hi&&(ti=dt*De.glyphMarginDecorationLaneCount);let ii=0,oi=ii+ti,Vt=oi+Ot,Ht=Vt+At;const di=Ze-ti-Ot-At;let Lt=!1,vt=!1,Ct=-1;It==="inherit"&&bt?(Lt=!0,vt=!0):Gt==="on"||Gt==="bounded"?vt=!0:Gt==="wordWrapColumn"&&(Ct=ht);const Tt=re.c({outerWidth:Ze,outerHeight:Ye,lineHeight:dt,typicalHalfwidthCharacterWidth:Ft,pixelRatio:xt,scrollBeyondLastLine:wt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:Jt,verticalScrollbarWidth:Qe,viewLineCount:ui,remainingWidth:di,isViewportWrapping:vt},De.memory||new E);Tt.renderMinimap!==be.None&&Tt.minimapLeft===0&&(ii+=Tt.minimapWidth,oi+=Tt.minimapWidth,Vt+=Tt.minimapWidth,Ht+=Tt.minimapWidth);const kt=di-Tt.minimapWidth,Zt=Math.max(1,Math.floor((kt-Qe-2)/Ft)),qt=pi?ei:0;return vt&&(Ct=Math.max(1,Zt),Gt==="bounded"&&(Ct=Math.min(Ct,ht))),{width:Ze,height:Ye,glyphMarginLeft:ii,glyphMarginWidth:ti,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:oi,lineNumbersWidth:Ot,decorationsLeft:Vt,decorationsWidth:At,contentLeft:Ht,contentWidth:kt,minimap:Tt,viewportColumn:Zt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:Ct,verticalScrollbarWidth:Qe,horizontalScrollbarHeight:si,overviewRuler:{top:qt,width:Qe,height:Ye-2*qt,right:0}}}}e.EditorLayoutInfoComputer=re;class Pe extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(x){return $(x,"simple",["simple","advanced"])}compute(x,De,Ze){return De.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Ze}}var Fe;(function(H){H.Off="off",H.OnCode="onCode",H.On="on"})(Fe||(e.ShowLightbulbIconMode=Fe={}));class X extends d{constructor(){const x={enabled:Fe.On};super(je.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Fe.Off,Fe.OnCode,Fe.On],default:x.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:$(x.enabled,this.defaultValue.enabled,[Fe.Off,Fe.OnCode,Fe.On])}}}class B extends d{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:c.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends d{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:c.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:$(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(De.fontFamily,this.defaultValue.fontFamily),padding:n(De.padding,this.defaultValue.padding)}}}class we extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):t.clampedInt(x,this.defaultValue,0,1e3)}compute(x,De,Ze){return Ze<0?t.clampedInt(-Ze*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ze}}class ae extends f{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>f.clamp(x,0,150),{markdownDescription:c.localize(66,null)})}compute(x,De,Ze){return x.fontInfo.lineHeight}}class ve extends d{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:x.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),autohide:n(De.autohide,this.defaultValue.autohide),size:$(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(De.side,this.defaultValue.side,["right","left"]),showSlider:$(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(De.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(De.scale,1,1,3),maxColumn:t.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(H){return H==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Z extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{top:t.clampedInt(De.top,0,0,1e3),bottom:t.clampedInt(De.bottom,0,0,1e3)}}}class Y extends d{constructor(){const x={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:c.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),cycle:n(De.cycle,this.defaultValue.cycle)}}}class pe extends a{constructor(){super(je.pixelRatio)}compute(x,De,Ze){return x.pixelRatio}}class $e extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Ne extends d{constructor(){const x={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:x.strings,description:c.localize(89,null)},comments:{anyOf:De,default:x.comments,description:c.localize(90,null)},other:{anyOf:De,default:x.other,description:c.localize(91,null)}},default:x,markdownDescription:c.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const xt=x?"on":"off";return{comments:xt,strings:xt,other:xt}}if(!x||typeof x!="object")return this.defaultValue;const{other:De,comments:Ze,strings:Ye}=x,dt=["on","inline","off"];let pt,Ft,zt;return typeof De=="boolean"?pt=De?"on":"off":pt=$(De,this.defaultValue.other,dt),typeof Ze=="boolean"?Ft=Ze?"on":"off":Ft=$(Ze,this.defaultValue.comments,dt),typeof Ye=="boolean"?zt=Ye?"on":"off":zt=$(Ye,this.defaultValue.strings,dt),{other:pt,comments:Ft,strings:zt}}}var Ue;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class ke extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(x){let De=this.defaultValue.renderType,Ze=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(De=Ue.Custom,Ze=x):x==="interval"?De=Ue.Interval:x==="relative"?De=Ue.Relative:x==="on"?De=Ue.On:De=Ue.Off),{renderType:De,renderFn:Ze}}}function Re(H){const x=H.get(je.renderValidationDecorations);return x==="editable"?H.get(je.readOnly):x!=="on"}class Me extends d{constructor(){const x=[],De={type:"number",description:c.localize(98,null)};super(je.rulers,"rulers",x,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:x,description:c.localize(100,null)})}validate(x){if(Array.isArray(x)){const De=[];for(const Ze of x)if(typeof Ze=="number")De.push({column:t.clampedInt(Ze,0,0,1e4),color:null});else if(Ze&&typeof Ze=="object"){const Ye=Ze;De.push({column:t.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return De.sort((Ze,Ye)=>Ze.column-Ye.column),De}return this.defaultValue}}class z extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function U(H,x){if(typeof H!="string")return x;switch(H){case"hidden":return M.ScrollbarVisibility.Hidden;case"visible":return M.ScrollbarVisibility.Visible;default:return M.ScrollbarVisibility.Auto}}class K extends d{constructor(){const x={vertical:M.ScrollbarVisibility.Auto,horizontal:M.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x,Ze=t.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=t.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(De.vertical,this.defaultValue.vertical),horizontal:U(De.horizontal,this.defaultValue.horizontal),useShadows:n(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ze,horizontalSliderSize:t.clampedInt(De.horizontalSliderSize,Ze,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:t.clampedInt(De.verticalSliderSize,Ye,0,1e3),scrollByPage:n(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends d{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:c.localize(119,null)}})}applyUpdate(x,De){let Ze=!1;De.allowedCharacters&&x&&(C.$fo(x.allowedCharacters,De.allowedCharacters)||(x={...x,allowedCharacters:De.allowedCharacters},Ze=!0)),De.allowedLocales&&x&&(C.$fo(x.allowedLocales,De.allowedLocales)||(x={...x,allowedLocales:De.allowedLocales},Ze=!0));const Ye=super.applyUpdate(x,De);return Ze?new r(Ye.newValue,!0):Ye}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{nonBasicASCII:Ke(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,De){if(typeof x!="object"||!x)return De;const Ze={};for(const[Ye,dt]of Object.entries(x))dt===!0&&(Ze[Ye]=!0);return Ze}}class ne extends d{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),mode:$(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(De.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:c.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ae extends d{constructor(){const x={enabled:N.$et.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$et.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends d{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:x.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:x.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:x.highlightActiveIndentation,description:c.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{bracketPairs:Ke(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(H,x,De){const Ze=De.indexOf(H);return Ze===-1?x:De[Ze]}class _e extends d{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:x.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:x.selectionMode,markdownDescription:c.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertMode:$(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(De.showIcons,this.defaultValue.showIcons),showStatusBar:n(De.showStatusBar,this.defaultValue.showStatusBar),preview:n(De.preview,this.defaultValue.preview),previewMode:$(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(De.showMethods,this.defaultValue.showMethods),showFunctions:n(De.showFunctions,this.defaultValue.showFunctions),showConstructors:n(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(De.showFields,this.defaultValue.showFields),showVariables:n(De.showVariables,this.defaultValue.showVariables),showClasses:n(De.showClasses,this.defaultValue.showClasses),showStructs:n(De.showStructs,this.defaultValue.showStructs),showInterfaces:n(De.showInterfaces,this.defaultValue.showInterfaces),showModules:n(De.showModules,this.defaultValue.showModules),showProperties:n(De.showProperties,this.defaultValue.showProperties),showEvents:n(De.showEvents,this.defaultValue.showEvents),showOperators:n(De.showOperators,this.defaultValue.showOperators),showUnits:n(De.showUnits,this.defaultValue.showUnits),showValues:n(De.showValues,this.defaultValue.showValues),showConstants:n(De.showConstants,this.defaultValue.showConstants),showEnums:n(De.showEnums,this.defaultValue.showEnums),showEnumMembers:n(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(De.showKeywords,this.defaultValue.showKeywords),showWords:n(De.showWords,this.defaultValue.showWords),showColors:n(De.showColors,this.defaultValue.showColors),showFiles:n(De.showFiles,this.defaultValue.showFiles),showReferences:n(De.showReferences,this.defaultValue.showReferences),showFolders:n(De.showFolders,this.defaultValue.showFolders),showTypeParameters:n(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(De.showSnippets,this.defaultValue.showSnippets),showUsers:n(De.showUsers,this.defaultValue.showUsers),showIssues:n(De.showIssues,this.defaultValue.showIssues)}}}class it extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(x.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const x=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const De=[];for(const Ze of x)if(typeof Ze=="string")try{Intl.Segmenter.supportedLocalesOf(Ze).length>0&&De.push(Ze)}catch{}return De}return this.defaultValue}}var tt;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(x,De,Ze){return De.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?tt.None:Ze}}class $t extends a{constructor(){super(je.wrappingInfo)}compute(x,De,Ze){const Ye=De.get(je.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class ut extends d{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),showDropSelector:$(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),showPasteSelector:$(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?gt:P.$k?mt:ct,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(H){return e.editorOptionsRegistry[H.id]=H,H}var je;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.ariaRequired=5]="ariaRequired",H[H.autoClosingBrackets=6]="autoClosingBrackets",H[H.autoClosingComments=7]="autoClosingComments",H[H.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",H[H.autoClosingDelete=9]="autoClosingDelete",H[H.autoClosingOvertype=10]="autoClosingOvertype",H[H.autoClosingQuotes=11]="autoClosingQuotes",H[H.autoIndent=12]="autoIndent",H[H.automaticLayout=13]="automaticLayout",H[H.autoSurround=14]="autoSurround",H[H.bracketPairColorization=15]="bracketPairColorization",H[H.guides=16]="guides",H[H.codeLens=17]="codeLens",H[H.codeLensFontFamily=18]="codeLensFontFamily",H[H.codeLensFontSize=19]="codeLensFontSize",H[H.colorDecorators=20]="colorDecorators",H[H.colorDecoratorsLimit=21]="colorDecoratorsLimit",H[H.columnSelection=22]="columnSelection",H[H.comments=23]="comments",H[H.contextmenu=24]="contextmenu",H[H.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",H[H.cursorBlinking=26]="cursorBlinking",H[H.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",H[H.cursorStyle=28]="cursorStyle",H[H.cursorSurroundingLines=29]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",H[H.cursorWidth=31]="cursorWidth",H[H.disableLayerHinting=32]="disableLayerHinting",H[H.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",H[H.domReadOnly=34]="domReadOnly",H[H.dragAndDrop=35]="dragAndDrop",H[H.dropIntoEditor=36]="dropIntoEditor",H[H.emptySelectionClipboard=37]="emptySelectionClipboard",H[H.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",H[H.extraEditorClassName=39]="extraEditorClassName",H[H.fastScrollSensitivity=40]="fastScrollSensitivity",H[H.find=41]="find",H[H.fixedOverflowWidgets=42]="fixedOverflowWidgets",H[H.folding=43]="folding",H[H.foldingStrategy=44]="foldingStrategy",H[H.foldingHighlight=45]="foldingHighlight",H[H.foldingImportsByDefault=46]="foldingImportsByDefault",H[H.foldingMaximumRegions=47]="foldingMaximumRegions",H[H.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=49]="fontFamily",H[H.fontInfo=50]="fontInfo",H[H.fontLigatures=51]="fontLigatures",H[H.fontSize=52]="fontSize",H[H.fontWeight=53]="fontWeight",H[H.fontVariations=54]="fontVariations",H[H.formatOnPaste=55]="formatOnPaste",H[H.formatOnType=56]="formatOnType",H[H.glyphMargin=57]="glyphMargin",H[H.gotoLocation=58]="gotoLocation",H[H.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",H[H.hover=60]="hover",H[H.inDiffEditor=61]="inDiffEditor",H[H.inlineSuggest=62]="inlineSuggest",H[H.inlineEdit=63]="inlineEdit",H[H.letterSpacing=64]="letterSpacing",H[H.lightbulb=65]="lightbulb",H[H.lineDecorationsWidth=66]="lineDecorationsWidth",H[H.lineHeight=67]="lineHeight",H[H.lineNumbers=68]="lineNumbers",H[H.lineNumbersMinChars=69]="lineNumbersMinChars",H[H.linkedEditing=70]="linkedEditing",H[H.links=71]="links",H[H.matchBrackets=72]="matchBrackets",H[H.minimap=73]="minimap",H[H.mouseStyle=74]="mouseStyle",H[H.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=76]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",H[H.multiCursorModifier=78]="multiCursorModifier",H[H.multiCursorPaste=79]="multiCursorPaste",H[H.multiCursorLimit=80]="multiCursorLimit",H[H.occurrencesHighlight=81]="occurrencesHighlight",H[H.overviewRulerBorder=82]="overviewRulerBorder",H[H.overviewRulerLanes=83]="overviewRulerLanes",H[H.padding=84]="padding",H[H.pasteAs=85]="pasteAs",H[H.parameterHints=86]="parameterHints",H[H.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",H[H.placeholder=88]="placeholder",H[H.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",H[H.quickSuggestions=90]="quickSuggestions",H[H.quickSuggestionsDelay=91]="quickSuggestionsDelay",H[H.readOnly=92]="readOnly",H[H.readOnlyMessage=93]="readOnlyMessage",H[H.renameOnType=94]="renameOnType",H[H.renderControlCharacters=95]="renderControlCharacters",H[H.renderFinalNewline=96]="renderFinalNewline",H[H.renderLineHighlight=97]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=99]="renderValidationDecorations",H[H.renderWhitespace=100]="renderWhitespace",H[H.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",H[H.roundedSelection=102]="roundedSelection",H[H.rulers=103]="rulers",H[H.scrollbar=104]="scrollbar",H[H.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=106]="scrollBeyondLastLine",H[H.scrollPredominantAxis=107]="scrollPredominantAxis",H[H.selectionClipboard=108]="selectionClipboard",H[H.selectionHighlight=109]="selectionHighlight",H[H.selectOnLineNumbers=110]="selectOnLineNumbers",H[H.showFoldingControls=111]="showFoldingControls",H[H.showUnused=112]="showUnused",H[H.snippetSuggestions=113]="snippetSuggestions",H[H.smartSelect=114]="smartSelect",H[H.smoothScrolling=115]="smoothScrolling",H[H.stickyScroll=116]="stickyScroll",H[H.stickyTabStops=117]="stickyTabStops",H[H.stopRenderingLineAfter=118]="stopRenderingLineAfter",H[H.suggest=119]="suggest",H[H.suggestFontSize=120]="suggestFontSize",H[H.suggestLineHeight=121]="suggestLineHeight",H[H.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",H[H.suggestSelection=123]="suggestSelection",H[H.tabCompletion=124]="tabCompletion",H[H.tabIndex=125]="tabIndex",H[H.unicodeHighlighting=126]="unicodeHighlighting",H[H.unusualLineTerminators=127]="unusualLineTerminators",H[H.useShadowDOM=128]="useShadowDOM",H[H.useTabStops=129]="useTabStops",H[H.wordBreak=130]="wordBreak",H[H.wordSegmenterLocales=131]="wordSegmenterLocales",H[H.wordSeparators=132]="wordSeparators",H[H.wordWrap=133]="wordWrap",H[H.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=136]="wordWrapColumn",H[H.wordWrapOverride1=137]="wordWrapOverride1",H[H.wordWrapOverride2=138]="wordWrapOverride2",H[H.wrappingIndent=139]="wrappingIndent",H[H.wrappingStrategy=140]="wrappingStrategy",H[H.showDeprecated=141]="showDeprecated",H[H.inlayHints=142]="inlayHints",H[H.editorClassName=143]="editorClassName",H[H.pixelRatio=144]="pixelRatio",H[H.tabFocusMode=145]="tabFocusMode",H[H.layoutInfo=146]="layoutInfo",H[H.wrappingInfo=147]="wrappingInfo",H[H.defaultColorDecorators=148]="defaultColorDecorators",H[H.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",H[H.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Be(new I(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Be(new S),accessibilityPageSize:Be(new t(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new u(je.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Be(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new I(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Be(new I(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Be(new I(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Be(new I(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Be(new I(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Be(new D(je.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Be(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new I(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Be(new Ae),bracketPairGuides:Be(new ze),stickyTabStops:Be(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Be(new s(je.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Be(new u(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Be(new t(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Be(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Be(new I(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Be(new t(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Be(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Be(new k),contextmenu:Be(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Be(new D(je.cursorBlinking,"cursorBlinking",g.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Be(new I(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Be(new D(je.cursorStyle,"cursorStyle",F.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],q,{description:c.localize(261,null)})),cursorSurroundingLines:Be(new t(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Be(new I(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Be(new t(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Be(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Be(new V),dropIntoEditor:Be(new ut),stickyScroll:Be(new B),experimentalWhitespaceRendering:Be(new I(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Be(new u(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new f(je.fastScrollSensitivity,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:c.localize(272,null)})),find:Be(new O),fixedOverflowWidgets:Be(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new s(je.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Be(new I(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Be(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Be(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Be(new t(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Be(new u(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Be(new ge),fontLigatures2:Be(new W),fontSize:Be(new te),fontWeight:Be(new me),fontVariations:Be(new ce),formatOnPaste:Be(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Be(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Be(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Be(new de),inDiffEditor:Be(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new f(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>f.clamp(H,-5,20),{description:c.localize(286,null)})),lightbulb:Be(new X),lineDecorationsWidth:Be(new we),lineHeight:Be(new ae),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new t(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Be(new s(je.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Be(new I(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Be(new ve),mouseStyle:Be(new I(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new f(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Be(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Be(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Be(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Be(new I(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Be(new t(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Be(new I(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Be(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Be(new t(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new Z),pasteAs:Be(new st),parameterHints:Be(new Y),peekWidgetDefaultFocus:Be(new I(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),placeholder:Be(new $e),definitionLinkOpensInPeek:Be(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Be(new Ne),quickSuggestionsDelay:Be(new t(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Be(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Be(new z),renameOnType:Be(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Be(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Be(new I(je.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Be(new I(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Be(new I(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new I(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Be(new t(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Be(new Me),scrollbar:Be(new K),scrollBeyondLastColumn:Be(new t(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Be(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Be(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Be(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:P.$k})),selectionHighlight:Be(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Be(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new I(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Be(new s(je.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Be(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Be(new _),snippetSuggestions:Be(new I(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Be(new it),smoothScrolling:Be(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Be(new t(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ne),inlineEdit:Be(new fe),inlineCompletionsAccessibilityVerbose:Be(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Be(new t(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new t(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Be(new I(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Be(new I(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Be(new t(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new J),unusualLineTerminators:Be(new I(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Be(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Be(new I(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new u(je.wordSeparators,"wordSeparators",p.$ft,{description:c.localize(360,null)})),wordWrap:Be(new I(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new u(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new u(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new t(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Be(new I(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new I(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new G),defaultColorDecorators:Be(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Be(new pe),tabFocusMode:Be(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Be(new re),wrappingInfo:Be(new $t),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Pe)}}),define(Ce[106],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,w.$Ei)("environmentService"),e.$Mi=(0,w.$Fi)(e.$Li)}),define(Ce[30],Ie([1,0,59,20,13,15,2,173,3,21,16,47]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Dl=e.FileKind=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.FileOperationResult=e.$vl=e.$ul=e.$tl=e.$rl=e.FileChangeType=e.$ql=e.FileOperation=e.$kl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$$k=void 0,e.$_k=l,e.$al=o,e.$bl=h,e.$cl=n,e.$dl=s,e.$el=i,e.$fl=t,e.$gl=m,e.$hl=f,e.$il=u,e.$jl=$,e.$ll=y,e.$ml=S,e.$nl=k,e.$ol=g,e.$pl=b,e.$sl=V,e.$El=me,e.$Fl=se,e.$Hl=be,e.$$k=(0,p.$Ei)("fileService");function l(re){return re.create===!0}var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function h(re){return!!(re.capabilities&a.FileReadWrite)}function n(re){return!!(re.capabilities&a.FileFolderCopy)}function s(re){return!!(re.capabilities&a.FileClone)}function i(re){return!!(re.capabilities&a.FileOpenReadWriteClose)}function t(re){return!!(re.capabilities&a.FileReadStream)}function m(re){return h(re)?!!(re.capabilities&a.FileAtomicRead):!1}function f(re){return h(re)?!!(re.capabilities&a.FileAtomicWrite):!1}function u(re){return!!(re.capabilities&a.FileAtomicDelete)}function $(re){return!!(re.capabilities&a.Readonly)}var I;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class D extends Error{static create(Pe,Fe){const X=new D(Pe.toString(),Fe);return k(X,Fe),X}constructor(Pe,Fe){super(Pe),this.code=Fe}}e.$kl=D;function y(re,Pe){return D.create(re,Pe)}function S(re){return re||y((0,N.localize)(0,null),I.Unknown)}function k(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}function g(re){if(!re)return I.Unknown;if(re instanceof D)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return I.Unknown;switch(Pe[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function b(re){if(re instanceof O)return re.fileOperationResult;switch(g(re)){case I.FileNotFound:return ge.FILE_NOT_FOUND;case I.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case I.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case I.NoPermissions:return ge.FILE_PERMISSION_DENIED;case I.FileExists:return ge.FILE_MOVE_CONFLICT;case I.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var F;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class T{constructor(Pe,Fe,X){this.resource=Pe,this.operation=Fe,this.target=X}isOperation(Pe){return this.operation===Pe}}e.$ql=T;var q;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class G{static{this.a=null}constructor(Pe,Fe){this.c=Fe,this.b=void 0,this.d=new v.$W(()=>{const X=w.$Ki.forUris(()=>this.c);return X.fill(this.rawAdded.map(B=>[B,!0])),X}),this.f=new v.$W(()=>{const X=w.$Ki.forUris(()=>this.c);return X.fill(this.rawUpdated.map(B=>[B,!0])),X}),this.g=new v.$W(()=>{const X=w.$Ki.forUris(()=>this.c);return X.fill(this.rawDeleted.map(B=>[B,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Pe){switch(X.type){case q.ADDED:this.rawAdded.push(X.resource);break;case q.UPDATED:this.rawUpdated.push(X.resource);break;case q.DELETED:this.rawDeleted.push(X.resource);break}this.b!==G.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(Pe,...Fe){return this.h(Pe,{includeChildren:!1},...Fe)}affects(Pe,...Fe){return this.h(Pe,{includeChildren:!0},...Fe)}h(Pe,Fe,...X){if(!Pe)return!1;const B=X.length>0;return!!((!B||X.includes(q.ADDED))&&(this.d.value.get(Pe)||Fe.includeChildren&&this.d.value.findSuperstr(Pe))||(!B||X.includes(q.UPDATED))&&(this.f.value.get(Pe)||Fe.includeChildren&&this.f.value.findSuperstr(Pe))||(!B||X.includes(q.DELETED))&&(this.g.value.findSubstr(Pe)||Fe.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$rl=G;function V(re,Pe,Fe){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==C.sep&&(Pe+=C.sep),Fe?(0,P.$Gf)(re,Pe):re.indexOf(Pe)===0)}class O extends Error{constructor(Pe,Fe,X){super(Pe),this.fileOperationResult=Fe,this.options=X}}e.$tl=O;class W extends O{constructor(Pe,Fe,X,B){super(Pe,Fe,B),this.fileOperationResult=Fe,this.size=X}}e.$ul=W;class ce extends O{constructor(Pe,Fe,X){super(Pe,ge.FILE_NOT_MODIFIED_SINCE,X),this.stat=Fe}}e.$vl=ce;var ge;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$wl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yl="files.associations",e.$zl="files.exclude",e.$Al="files.readonlyInclude",e.$Bl="files.readonlyExclude",e.$Cl="files.readonlyFromPermissions";var te;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$Dl="";function me(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function se(re,Pe){if(!Pe.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(Fe=>{const X=Pe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===re.scheme&&B.added&&(X.dispose(),Fe())})})}class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Pe){return(0,M.$ig)(Pe)||(Pe=0),Pe<de.KB?(0,N.localize)(1,null,Pe.toFixed(0)):Pe<de.MB?(0,N.localize)(2,null,(Pe/de.KB).toFixed(2)):Pe<de.GB?(0,N.localize)(3,null,(Pe/de.MB).toFixed(2)):Pe<de.TB?(0,N.localize)(4,null,(Pe/de.GB).toFixed(2)):(0,N.localize)(5,null,(Pe/de.TB).toFixed(2))}}e.$Gl=de;function be(re){const Pe=typeof re=="string"||re?.scheme===R.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===R.Schemas.file?1024*de.MB:Pe?10*de.MB:c.$o?50*de.MB:1024*de.MB}}),define(Ce[75],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class w{constructor(...P){this.a=new Map;for(const[M,A]of P)this.set(M,A)}set(P,M){const A=this.a.get(P);return this.a.set(P,M),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ci=w}),define(Ce[211],Ie([1,0,11,14,5,74,208,3,75,212]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;const R=!1;class v extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new p.$Ci,a=!1,h,n=R){this.i=o,this.j=a,this.k=h,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(N.$Di,this),this._globalGraph=n?h?._globalGraph??new A.$or(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,a){this.m();const h=this,n=new class extends l{dispose(){h.h.delete(n),super.dispose()}}(o,this.j,this,this.l);return this.h.add(n),a?.add(n),n}invokeFunction(o,...a){this.m();const h=d.traceInvocation(this.l,o);let n=!1;try{return o({get:i=>{if(n)throw(0,C.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(i,h);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...a)}finally{n=!0,h.stop()}}createInstance(o,...a){this.m();let h,n;return o instanceof M.$Bi?(h=d.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(a),h)):(h=d.traceCreation(this.l,o),n=this.o(o,a,h)),h.stop(),n}o(o,a=[],h){const n=N._util.getServiceDependencies(o).sort((t,m)=>t.index-m.index),s=[];for(const t of n){const m=this.s(t.id,h);m||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(m)}const i=n.length>0?n[0].index:a.length;if(a.length!==i){console.trace(`[createInstance] First service dependency of ${o.name} at position ${i+1} conflicts with ${a.length} static arguments`);const t=i-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,i)}return Reflect.construct(o,a.concat(s))}q(o,a){if(this.i.get(o)instanceof M.$Bi)this.i.set(o,a);else if(this.k)this.k.q(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const a=this.i.get(o);return!a&&this.k?this.k.r(o):a}s(o,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof M.$Bi?this.u(o,h,a.branch(o,!0)):(a.branch(o,!1),h)}u(o,a,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,a,h)}finally{this.t.delete(o)}}v(o,a,h){const n=new A.$or(t=>t.id.toString());let s=0;const i=[{id:o,desc:a,_trace:h}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new v(n);for(const m of N._util.getServiceDependencies(t.desc.ctor)){const f=this.r(m.id);if(f||this.y(`[createInstance] ${o} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(m.id)),f instanceof M.$Bi){const u={id:m.id,desc:f,_trace:t._trace.branch(m.id,!0)};n.insertEdge(t,u),i.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new v(n);break}for(const{data:m}of t){if(this.r(m.id)instanceof M.$Bi){const u=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,u)}n.removeNode(m)}}return this.r(o)}w(o,a,h=[],n,s){if(this.i.get(o)instanceof M.$Bi)return this.x(o,a,h,n,s,this.g);if(this.k)return this.k.w(o,a,h,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(o,a,h=[],n,s,i){if(n){const t=new l(void 0,this.j,this,this.l);t.c=String(o);const m=new Map,f=new w.$Xh(()=>{const u=t.o(a,h,s);for(const[$,I]of m){const D=u[$];if(typeof D=="function")for(const y of I)y.disposable=D.apply(u,y.listener)}return m.clear(),i.add(u),u});return new Proxy(Object.create(null),{get(u,$){if(!f.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let y=m.get($);return y||(y=new c.$6c,m.set($,y)),(k,g,b)=>{if(f.isInitialized)return f.value[$](k,g,b);{const F={listener:[k,g,b],disposable:void 0},T=y.push(F);return(0,P.$Tc)(()=>{T(),F.disposable?.dispose()})}}}if($ in u)return u[$];const I=f.value;let D=I[$];return typeof D!="function"||(D=D.bind(I),u[$]=D),D},set(u,$,I){return f.value[$]=I,!0},getPrototypeOf(u){return a.prototype}})}else{const t=this.o(a,h,s);return i.add(t),t}}y(o,a){if(a&&console.warn(o),this.j)throw new Error(o)}}e.$pr=l;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new d(E.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,a){return o?new d(E.Creation,a.name):d.c}static{this.f=0}constructor(o,a){this.type=o,this.name=a,this.g=Date.now(),this.h=[]}branch(o,a){const h=new d(E.Branch,o.toString());return this.h.push([o,a,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let a=!1;function h(s,i){const t=[],m=new Array(s+1).join("	");for(const[f,u,$]of i.h)if(u&&$){a=!0,t.push(`${m}CREATES -> ${f}`);const I=h(s+1,$);I&&t.push(I)}else t.push(`${m}uses -> ${f}`);return t.join(`
`)}const n=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||a)&&d.all.add(n.join(`
`))}}e.$qr=d}),define(Ce[12],Ie([1,0,174,48,4,76,5,29,21,24,15,2,32,3]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=r,e.log=a,e.$mk=D,e.$nk=y,e.$ok=S,e.$pk=k,w=qe(w),e.$$j=(0,E.$Ei)("logService"),e.$_j=(0,E.$Ei)("loggerService");function d(){return new Date().toISOString()}function r(g){return(0,R.$ig)(g)}var o;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$bk=o.Info;function a(g,b,F){switch(b){case o.Trace:g.trace(F);break;case o.Debug:g.debug(F);break;case o.Info:g.info(F);break;case o.Warning:g.warn(F);break;case o.Error:g.error(F);break;case o.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function h(g,b=!1){let F="";for(let T=0;T<g.length;T++){let q=g[T];if(q instanceof Error&&(q=(0,C.$pj)(q,b)),typeof q=="object")try{q=JSON.stringify(q)}catch{}F+=(T>0?" ":"")+q}return F}class n extends A.$Vc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new P.$le),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==o.Off&&this.b<=b}}e.$dk=n;class s extends n{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...F){this.f(o.Trace)&&this.g(o.Trace,h([b,...F],!0))}debug(b,...F){this.f(o.Debug)&&this.g(o.Debug,h([b,...F]))}info(b,...F){this.f(o.Info)&&this.g(o.Info,h([b,...F]))}warn(b,...F){this.f(o.Warning)&&this.g(o.Warning,h([b,...F]))}error(b,...F){if(this.f(o.Error))if(b instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=b.stack,this.g(o.Error,h(T))}else this.g(o.Error,h([b,...F]))}flush(){}}e.$ek=s;class i extends n{constructor(b=e.$bk){super(),this.setLevel(b),this.g=!p.$i}trace(b,...F){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...F):console.log(`[main ${d()}]`,b,...F))}debug(b,...F){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...F):console.log(`[main ${d()}]`,b,...F))}info(b,...F){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...F):console.log(`[main ${d()}]`,b,...F))}warn(b,...F){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...F):console.warn(`[main ${d()}]`,b,...F))}error(b,...F){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...F):console.error(`[main ${d()}]`,b,...F))}flush(){}}e.$fk=i;class t extends n{constructor(b=e.$bk,F=!0){super(),this.g=F,this.setLevel(b)}trace(b,...F){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...F):console.log(b,...F))}debug(b,...F){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...F):console.log(b,...F))}info(b,...F){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...F):console.log(b,...F))}warn(b,...F){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...F):console.log(b,...F))}error(b,...F){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...F):console.error(b,...F))}flush(){}}e.$gk=t;class m extends n{constructor(b,F=e.$bk){super(),this.g=b,this.setLevel(F)}trace(b,...F){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(b),...F])}debug(b,...F){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(b),...F])}info(b,...F){this.f(o.Info)&&this.g.log(o.Info,[this.h(b),...F])}warn(b,...F){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(b),...F])}error(b,...F){this.f(o.Error)&&this.g.log(o.Error,[this.h(b),...F])}h(b){return typeof b=="string"?b:(0,C.$pj)(b,this.f(o.Trace))}flush(){}}e.$hk=m;class f extends n{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const F of this.g)F.setLevel(b);super.setLevel(b)}trace(b,...F){for(const T of this.g)T.trace(b,...F)}debug(b,...F){for(const T of this.g)T.debug(b,...F)}info(b,...F){for(const T of this.g)T.info(b,...F)}warn(b,...F){for(const T of this.g)T.warn(b,...F)}error(b,...F){for(const T of this.g)T.error(b,...F)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$ik=f;class u extends A.$Vc{constructor(b,F,T){if(super(),this.h=b,this.j=F,this.b=new N.$Bc,this.c=this.B(new P.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$le),this.onDidChangeVisibility=this.g.event,T)for(const q of T)this.b.set(q.resource,{logger:void 0,info:q})}m(b){return(0,R.$eg)(b)?[...this.b.values()].find(F=>F.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,F){const T=this.n(b),q=(0,R.$eg)(b)?b:F?.id??(0,M.$sj)(T.toString()).toString(16);let G=this.b.get(T)?.logger;const V=F?.logLevel==="always"?o.Trace:F?.logLevel;G||(G=this.s(T,V??this.getLogLevel(T)??this.h,{...F,id:q}));const O={logger:G,info:{resource:T,id:q,logLevel:V,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(O.info),this.b.set(T,O),G}n(b){return(0,R.$eg)(b)?(0,c.$fh)(this.j,`${b}.log`):b}setLogLevel(b,F){if(v.URI.isUri(b)){const T=b,q=F,G=this.b.get(T);G&&q!==G.info.logLevel&&(G.info.logLevel=q===this.h?void 0:q,G.logger?.setLevel(q),this.b.set(G.info.resource,G),this.f.fire([T,q]))}else{this.h=b;for(const[T,q]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,F){const T=this.m(b);T&&F!==!T.info.hidden&&(T.info.hidden=!F,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,F]))}getLogLevel(b){let F;return b&&(F=this.b.get(b)?.info.logLevel),F??this.h}registerLogger(b){const F=this.b.get(b.resource);F?F.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const F=this.b.get(b);F&&(F.logger&&F.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=u;class ${constructor(){this.onDidChangeLogLevel=new P.$le().event}setLevel(b){}getLevel(){return o.Info}trace(b,...F){}debug(b,...F){}info(b,...F){}warn(b,...F){}error(b,...F){}critical(b,...F){}dispose(){}flush(){}}e.$kk=$;class I extends ${}e.$lk=I;function D(g){if(g.verbose)return o.Trace;if(typeof g.logLevel=="string"){const b=k(g.logLevel.toLowerCase());if(b!==void 0)return b}return e.$bk}function y(g){switch(g){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function S(g){switch(g){case o.Trace:return{original:"Trace",value:w.localize(0,null)};case o.Debug:return{original:"Debug",value:w.localize(1,null)};case o.Info:return{original:"Info",value:w.localize(2,null)};case o.Warning:return{original:"Warning",value:w.localize(3,null)};case o.Error:return{original:"Error",value:w.localize(4,null)};case o.Off:return{original:"Off",value:w.localize(5,null)}}}function k(g){switch(g){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$qk=new l.$Vj("logLevel",y(o.Info))}),define(Ce[213],Ie([1,0,5,12]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;class P extends w.$Vc{constructor(A,N=[]){super(),this.a=new C.$ik([A,...N]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...N){this.a.trace(A,...N)}debug(A,...N){this.a.debug(A,...N)}info(A,...N){this.a.info(A,...N)}warn(A,...N){this.a.warn(A,...N)}error(A,...N){this.a.error(A,...N)}flush(){this.a.flush()}}e.$UQ=P});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[107],Ie([1,0,36,175,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,w=ri(w);var M;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function c(d,r){return r-d}p.compare=c;const R=Object.create(null);R[p.Error]=(0,C.localize)(0,null),R[p.Warning]=(0,C.localize)(1,null),R[p.Info]=(0,C.localize)(2,null);function v(d){return R[d]||""}p.toString=v;function l(d){switch(d){case w.default.Error:return p.Error;case w.default.Warning:return p.Warning;case w.default.Info:return p.Info;case w.default.Ignore:return p.Hint}}p.fromSeverity=l;function E(d){switch(d){case p.Error:return w.default.Error;case p.Warning:return w.default.Warning;case p.Info:return w.default.Info;case p.Hint:return w.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var N;(function(p){const c="";function R(l){return v(l,!0)}p.makeKey=R;function v(l,E){const d=[c];return l.source?d.push(l.source.replace("\xA6","\\\xA6")):d.push(c),l.code?typeof l.code=="string"?d.push(l.code.replace("\xA6","\\\xA6")):d.push(l.code.value.replace("\xA6","\\\xA6")):d.push(c),l.severity!==void 0&&l.severity!==null?d.push(A.toString(l.severity)):d.push(c),l.message&&E?d.push(l.message.replace("\xA6","\\\xA6")):d.push(c),l.startLineNumber!==void 0&&l.startLineNumber!==null?d.push(l.startLineNumber.toString()):d.push(c),l.startColumn!==void 0&&l.startColumn!==null?d.push(l.startColumn.toString()):d.push(c),l.endLineNumber!==void 0&&l.endLineNumber!==null?d.push(l.endLineNumber.toString()):d.push(c),l.endColumn!==void 0&&l.endColumn!==null?d.push(l.endColumn.toString()):d.push(c),d.push(c),d.join("\xA6")}p.makeKeyOptionalMessage=v})(N||(e.IMarkerData=N={})),e.$yu=(0,P.$Ei)("markerService")});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[214],Ie([1,0,4,36,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$lw=e.Severity=void 0,e.$mw=N,C=ri(C),e.Severity=C.default,e.$lw=(0,P.$Ei)("notificationService");var M;(function(v){v[v.DEFAULT=0]="DEFAULT",v[v.SILENT=1]="SILENT",v[v.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(v){v[v.WORKSPACE=0]="WORKSPACE",v[v.PROFILE=1]="PROFILE",v[v.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function N(v){if(v){const l=v;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var p;(function(v){v[v.OFF=0]="OFF",v[v.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new R,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$nw=c;class R{infinite(){}done(){}total(l){}worked(l){}}e.$ow=R}),define(Ce[108],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,w.$Ei)("productService"),e.$sk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(oe,e,w,C){var P=arguments.length,M=P<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,w):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(oe,e,w,C);else for(var N=oe.length-1;N>=0;N--)(A=oe[N])&&(M=(P<3?A(M):P>3?A(e,w,M):A(e,w))||M);return P>3&&M&&Object.defineProperty(e,w,M),M},We=this&&this.__param||function(oe,e){return function(w,C){e(w,C,oe)}};define(Ce[77],Ie([1,0,11,22,5,3]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.$tw=e.$sw=e.$rw=e.$qw=e.ProgressLocation=e.$pw=void 0,e.$pw=(0,M.$Ei)("progressService");var A;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$qw=Object.freeze({total(){},worked(){},done(){}});class N{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$rw=N;class p{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const E=this.d;this.d=()=>{E?.(),l()}}):Promise.resolve()}}e.$sw=p;let c=class extends P.$Vc{constructor(l,E){super(),this.a=new w.$2h,E.withProgress(l,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Tc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$tw=c,e.$tw=c=He([We(1,e.$pw)],c);class R extends P.$Vc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Uc)}start(l){this.stop();const E=++this.a,d=new C.$we;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Tc)(()=>d.cancel())),this.b.add((0,P.$Tc)(()=>this.c?this.c.done():void 0)),{id:E,token:d.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$uw=R,e.$vw=(0,M.$Ei)("editorProgressService")}),define(Ce[31],Ie([1,0,62,15]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,w=qe(w),C=qe(C);class P{constructor(){this.a=new Map}add(A,N){w.ok(C.$eg(A)),w.ok(C.$gg(N)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,N)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$oo=new P}),define(Ce[78],Ie([1,0,4,31]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,C=qe(C),e.$po={JSONContribution:"base.contributions.json"};function P(N){return N.length>0&&N.charAt(N.length-1)==="#"?N.substring(0,N.length-1):N}class M{constructor(){this.b=new w.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,c){this.a[P(p)]=c,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;C.$oo.add(e.$po.JSONContribution,A)}),define(Ce[54],Ie([1,0,18,4,15,168,42,78,31]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=r,e.$Fo=o,e.$Go=a,e.$Ho=n,e.$Io=s,P=qe(P),M=qe(M);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$to={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const v=p.$oo.as(N.$po.JSONContribution);class l{constructor(){this.h=new Set,this.i=new C.$le,this.onDidSchemaChange=this.i.event,this.j=new C.$le,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Ao,this.g),this.v()}registerConfiguration(t,m=!0){this.registerConfigurations([t],m)}registerConfigurations(t,m=!0){const f=new Set;this.n(t,m,f),v.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(t){const m=new Set;this.o(t,m),v.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:m})}updateConfigurations({add:t,remove:m}){const f=new Set;this.o(m,f),this.n(t,!1,f),v.registerSchema(e.$Ao,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(t){const m=new Set;this.k(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}k(t,m){const f=[];for(const{overrides:u,source:$}of t)for(const I in u)if(m.add(I),e.$Do.test(I)){const D=this.a.get(I),y=D?.valuesSources??new Map;if($)for(const b of Object.keys(u[I]))y.set(b,$);const S={...D?.value||{},...u[I]};this.a.set(I,{source:$,value:S,valuesSources:y});const k=(0,A.$ij)(I),g={type:"object",default:S,description:M.localize(1,null,k),$ref:e.$Ao,defaultDefaultValue:S,source:P.$eg($)?void 0:$,defaultValueSource:$};f.push(...r(I)),this.d[I]=g,this.b.properties[I]=g}else{this.a.set(I,{value:u[I],source:$});const D=this.d[I];D&&(this.w(I,D),this.r(I,D))}this.m(f)}deregisterDefaultConfigurations(t){const m=new Set;this.l(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}l(t,m){for(const{overrides:f,source:u}of t)for(const $ in f){const I=this.a.get($),D=P.$eg(u)?u:u?.id,y=P.$eg(I?.source)?I?.source:I?.source?.id;if(D===y)if(m.add($),this.a.delete($),e.$Do.test($))delete this.d[$],delete this.b.properties[$];else{const S=this.d[$];S&&(this.w($,S),this.r($,S))}}this.u()}deltaConfiguration(t){let m=!1;const f=new Set;t.removedDefaults&&(this.l(t.removedDefaults,f),m=!0),t.addedDefaults&&(this.k(t.addedDefaults,f),m=!0),t.removedConfigurations&&this.o(t.removedConfigurations,f),t.addedConfigurations&&this.n(t.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const m of t)this.h.add(m);this.u()}n(t,m,f){t.forEach(u=>{this.p(u,m,u.extensionInfo,u.restrictedProperties,void 0,f),this.c.push(u),this.q(u)})}o(t,m){const f=u=>{if(u.properties)for(const $ in u.properties){m.add($);const I=this.d[$];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[$],this.s($,u.properties[$])}u.allOf?.forEach($=>f($))};for(const u of t){f(u);const $=this.c.indexOf(u);$!==-1&&this.c.splice($,1)}}p(t,m=!0,f,u,$=R.WINDOW,I){$=P.$ng(t.scope)?$:t.scope;const D=t.properties;if(D)for(const S in D){const k=D[S];if(m&&n(S,k)){delete D[S];continue}if(k.source=f,k.defaultDefaultValue=D[S].default,this.w(S,k),e.$Do.test(S)?k.scope=void 0:(k.scope=P.$ng(k.scope)?$:k.scope,k.restricted=P.$ng(k.restricted)?!!u?.includes(S):k.restricted),D[S].hasOwnProperty("included")&&!D[S].included){this.f[S]=D[S],delete D[S];continue}else this.d[S]=D[S],D[S].policy?.name&&this.e.set(D[S].policy.name,S);!D[S].deprecationMessage&&D[S].markdownDeprecationMessage&&(D[S].deprecationMessage=D[S].markdownDeprecationMessage),I.add(S)}const y=t.allOf;if(y)for(const S of y)this.p(S,m,f,u,$,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const m=f=>{const u=f.properties;if(u)for(const I in u)this.r(I,u[I]);f.allOf?.forEach(m)};m(t)}r(t,m){switch(e.$uo.properties[t]=m,m.scope){case R.APPLICATION:e.$vo.properties[t]=m;break;case R.MACHINE:e.$wo.properties[t]=m;break;case R.MACHINE_OVERRIDABLE:e.$xo.properties[t]=m;break;case R.WINDOW:e.$yo.properties[t]=m;break;case R.RESOURCE:e.$zo.properties[t]=m;break;case R.LANGUAGE_OVERRIDABLE:e.$zo.properties[t]=m,this.g.properties[t]=m;break}}s(t,m){switch(delete e.$uo.properties[t],m.scope){case R.APPLICATION:delete e.$vo.properties[t];break;case R.MACHINE:delete e.$wo.properties[t];break;case R.MACHINE_OVERRIDABLE:delete e.$xo.properties[t];break;case R.WINDOW:delete e.$yo.properties[t];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const m=`[${t}]`,f={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Ao};this.w(m,f),e.$uo.properties[m]=f,e.$vo.properties[m]=f,e.$wo.properties[m]=f,e.$xo.properties[m]=f,e.$yo.properties[m]=f,e.$zo.properties[m]=f}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=t,e.$vo.patternProperties[e.$Co]=t,e.$wo.patternProperties[e.$Co]=t,e.$xo.patternProperties[e.$Co]=t,e.$yo.patternProperties[e.$Co]=t,e.$zo.patternProperties[e.$Co]=t,this.i.fire()}w(t,m){const f=this.a.get(t);let u=f?.value,$=f?.source;P.$lg(u)&&(u=m.defaultDefaultValue,$=void 0),P.$lg(u)&&(u=a(m.type)),m.default=u,m.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.$Co=`^(${E})+$`,e.$Do=new RegExp(e.$Co);function r(i){const t=[];if(e.$Do.test(i)){let m=d.exec(i);for(;m?.length;){const f=m[1].trim();f&&t.push(f),m=d.exec(i)}}return(0,w.$Nb)(t)}function o(i){return i.reduce((t,m)=>`${t}[${m}]`,"")}function a(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new l;p.$oo.add(e.$to.Configuration,h);function n(i,t){return i.trim()?e.$Do.test(i)?M.localize(7,null,i):h.getConfigurationProperties()[i]!==void 0?M.localize(8,null,i):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,i,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function s(){const i=[],t=h.getConfigurationProperties();for(const m of Object.keys(t))i.push([m,t[m].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}}),define(Ce[215],Ie([1,0,18,4,135,5,29,26,15,2,42,54,30,31]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$No=s,w=qe(w),P=qe(P),N=qe(N),p=qe(p);function d(f){return Object.isFrozen(f)?f:N.$co(f)}class r{static createEmptyModel(u){return new r({},[],[],void 0,u)}constructor(u,$,I,D,y){this.b=u,this.c=$,this.d=I,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const u=this.raw.map($=>{if($ instanceof r)return $;const I=new o("",this.f);return I.parseRaw($),I.configurationModel});this.g=u.reduce(($,I)=>I===$?I:$.merge(I),u[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,R.$gj)(this.contents,u):this.contents}inspect(u,$){const I=this;return{get value(){return d(I.rawConfiguration.getValue(u))},get override(){return $?d(I.rawConfiguration.getOverrideValue(u,$)):void 0},get merged(){return d($?I.rawConfiguration.override($).getValue(u):I.rawConfiguration.getValue(u))},get overrides(){const D=[];for(const{contents:y,identifiers:S,keys:k}of I.rawConfiguration.overrides){const g=new r(y,k,[],void 0,I.f).getValue(u);g!==void 0&&D.push({identifiers:S,value:g})}return D.length?d(D):void 0}}}getOverrideValue(u,$){const I=this.j($);return I?u?(0,R.$gj)(I,u):I:void 0}getKeysForOverrideIdentifier(u){const $=[];for(const I of this.overrides)I.identifiers.includes(u)&&$.push(...I.keys);return w.$Nb($)}getAllOverrideIdentifiers(){const u=[];for(const $ of this.overrides)u.push(...$.identifiers);return w.$Nb(u)}override(u){let $=this.a.get(u);return $||($=this.h(u),this.a.set(u,$)),$}merge(...u){const $=N.$bo(this.contents),I=N.$bo(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const S of u)if(y.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i($,S.contents);for(const k of S.overrides){const[g]=I.filter(b=>w.$vb(b.identifiers,k.identifiers));g?(this.i(g.contents,k.contents),g.keys.push(...k.keys),g.keys=w.$Nb(g.keys)):I.push(N.$bo(k))}for(const k of S.keys)D.indexOf(k)===-1&&D.push(k)}return new r($,D,I,y.every(S=>S instanceof r)?void 0:y,this.f)}h(u){const $=this.j(u);if(!$||typeof $!="object"||!Object.keys($).length)return this;const I={};for(const D of w.$Nb([...Object.keys(this.contents),...Object.keys($)])){let y=this.contents[D];const S=$[D];S&&(typeof y=="object"&&typeof S=="object"?(y=N.$bo(y),this.i(y,S)):y=S),I[D]=y}return new r(I,this.keys,this.overrides,void 0,this.f)}i(u,$){for(const I of Object.keys($)){if(I in u&&p.$gg(u[I])&&p.$gg($[I])){this.i(u[I],$[I]);continue}u[I]=N.$bo($[I])}}j(u){let $=null,I=null;const D=y=>{y&&(I?this.i(I,y):I=N.$bo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===u?$=y.contents:y.identifiers.includes(u)&&D(y.contents);return D($),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,$){this.k(u,$,!0)}setValue(u,$){this.k(u,$,!1)}removeValue(u){const $=this.keys.indexOf(u);$!==-1&&(this.keys.splice($,1),(0,R.$fj)(this.contents,u),v.$Do.test(u)&&this.overrides.splice(this.overrides.findIndex(I=>w.$vb(I.identifiers,(0,v.$Eo)(u))),1))}k(u,$,I){(0,R.$ej)(this.contents,u,$,D=>this.f.error(D)),I=I||this.keys.indexOf(u)===-1,I&&this.keys.push(u),v.$Do.test(u)&&this.overrides.push({identifiers:(0,v.$Eo)(u),keys:Object.keys(this.contents[u]),contents:(0,R.$dj)(this.contents[u],D=>this.f.error(D))})}}e.$Jo=r;class o{constructor(u,$){this.f=u,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,$){if(!p.$ng(u)){const I=this.h(u);this.parseRaw(I,$)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,$){this.a=u;const{contents:I,keys:D,overrides:y,restricted:S,hasExcludedProperties:k}=this.i(u,$);this.b=new r(I,D,y,k?[u]:void 0,this.g),this.c=S||[]}h(u){let $={},I=null,D=[];const y=[],S=[];function k(b){Array.isArray(D)?D.push(b):I!==null&&(D[I]=b)}const g={onObjectBegin:()=>{const b={};k(b),y.push(D),D=b,I=null},onObjectProperty:b=>{I=b},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const b=[];k(b),y.push(D),D=b,I=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:k,onError:(b,F,T)=>{S.push({error:b,offset:F,length:T})}};if(u)try{P.$2n(u,g),$=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return $}i(u,$){const I=E.$oo.as(v.$to.Configuration).getConfigurationProperties(),D=this.j(u,I,!0,$);u=D.raw;const y=(0,R.$dj)(u,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(u),k=this.l(u,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:y,keys:S,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(u,$,I,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:y};const S={},k=[];for(const g in u)if(v.$Do.test(g)&&I){const b=this.j(u[g],$,!1,D);S[g]=b.raw,y=y||b.hasExcludedProperties,k.push(...b.restricted)}else{const b=$[g],F=b?typeof b.scope<"u"?b.scope:v.ConfigurationScope.WINDOW:void 0;b?.restricted&&k.push(g),!D.exclude?.includes(g)&&(D.include?.includes(g)||(F===void 0||D.scopes===void 0||D.scopes.includes(F))&&!(D.skipRestricted&&b?.restricted))?S[g]=u[g]:y=!0}return{raw:S,restricted:k,hasExcludedProperties:y}}l(u,$){const I=[];for(const D of Object.keys(u))if(v.$Do.test(D)){const y={};for(const S in u[D])y[S]=u[D][S];I.push({identifiers:(0,v.$Eo)(D),keys:Object.keys(y),contents:(0,R.$dj)(y,$)})}return I}}e.$Ko=o;class a extends M.$Vc{constructor(u,$,I,D,y){super(),this.c=u,this.f=$,this.g=D,this.h=y,this.b=this.B(new C.$le),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),y),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(l.FileOperation.CREATE)||S.isOperation(l.FileOperation.COPY)||S.isOperation(l.FileOperation.DELETE)||S.isOperation(l.FileOperation.WRITE))&&I.isEqual(S.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Lo=a;class h{constructor(u,$,I,D,y,S,k,g,b,F,T,q,G){this.a=u,this.b=$,this.c=I,this.overrideIdentifiers=D,this.d=y,this.f=S,this.g=k,this.h=g,this.i=b,this.j=F,this.k=T,this.l=q,this.m=G}get value(){return d(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,$,I,D,y,S,k,g,b,F){this.j=u,this.l=$,this.m=I,this.n=D,this.p=y,this.q=S,this.r=k,this.s=g,this.t=b,this.u=F,this.h=null,this.i=new A.$Bc,this.v=null}getValue(u,$,I){return this.w(u,$,I).getValue(u)}updateValue(u,$,I={}){let D;I.resource?(D=this.t.get(I.resource),D||(D=r.createEmptyModel(this.u),this.t.set(I.resource,D))):D=this.s,$===void 0?D.removeValue(u):D.setValue(u,$),I.resource||(this.h=null)}inspect(u,$,I){const D=this.w(u,$,I),y=this.A($.resource,I),S=$.resource?this.t.get($.resource)||this.s:this.s,k=new Set;for(const g of D.overrides)for(const b of g.identifiers)D.getOverrideValue(u,b)!==void 0&&k.add(b);return new h(u,$,D.getValue(u),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,y||void 0,S)}keys(u){const $=this.A(void 0,u);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(u){this.j=u,this.h=null,this.i.clear()}updatePolicyConfiguration(u){this.l=u}updateApplicationConfiguration(u){this.m=u,this.h=null,this.i.clear()}updateLocalUserConfiguration(u){this.n=u,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(u){this.p=u,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(u){this.q=u,this.h=null,this.i.clear()}updateFolderConfiguration(u,$){this.r.set(u,$),this.i.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.i.delete(u)}compareAndUpdateDefaultConfiguration(u,$){const I=[];if(!$){const{added:D,updated:y,removed:S}=t(this.j,u);$=[...D,...y,...S]}for(const D of $)for(const y of(0,v.$Eo)(D)){const S=this.j.getKeysForOverrideIdentifier(y),k=u.getKeysForOverrideIdentifier(y),g=[...k.filter(b=>S.indexOf(b)===-1),...S.filter(b=>k.indexOf(b)===-1),...S.filter(b=>!N.$fo(this.j.override(y).getValue(b),u.override(y).getValue(b)))];I.push([y,g])}return this.updateDefaultConfiguration(u),{keys:$,overrides:I}}compareAndUpdatePolicyConfiguration(u){const{added:$,updated:I,removed:D}=t(this.l,u),y=[...$,...I,...D];return y.length&&this.updatePolicyConfiguration(u),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:$,updated:I,removed:D,overrides:y}=t(this.applicationConfiguration,u),S=[...$,...I,...D];return S.length&&this.updateApplicationConfiguration(u),{keys:S,overrides:y}}compareAndUpdateLocalUserConfiguration(u){const{added:$,updated:I,removed:D,overrides:y}=t(this.localUserConfiguration,u),S=[...$,...I,...D];return S.length&&this.updateLocalUserConfiguration(u),{keys:S,overrides:y}}compareAndUpdateRemoteUserConfiguration(u){const{added:$,updated:I,removed:D,overrides:y}=t(this.remoteUserConfiguration,u),S=[...$,...I,...D];return S.length&&this.updateRemoteUserConfiguration(u),{keys:S,overrides:y}}compareAndUpdateWorkspaceConfiguration(u){const{added:$,updated:I,removed:D,overrides:y}=t(this.workspaceConfiguration,u),S=[...$,...I,...D];return S.length&&this.updateWorkspaceConfiguration(u),{keys:S,overrides:y}}compareAndUpdateFolderConfiguration(u,$){const I=this.folderConfigurations.get(u),{added:D,updated:y,removed:S,overrides:k}=t(I,$),g=[...D,...y,...S];return(g.length||!I)&&this.updateFolderConfiguration(u,$),{keys:g,overrides:k}}compareAndDeleteFolderConfiguration(u){const $=this.folderConfigurations.get(u);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:I,updated:D,removed:y,overrides:S}=t($,void 0);return{keys:[...I,...D,...y],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(u,$,I){let D=this.x($,I);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(u)!==void 0&&(D=D.merge(this.l)),D}x({resource:u},$){let I=this.y();if($&&u){const D=$.getFolder(u);D&&(I=this.z(D.uri)||I);const y=this.t.get(u);y&&(I=I.merge(y))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(u){let $=this.i.get(u);if(!$){const I=this.y(),D=this.r.get(u);D?($=I.merge(D),this.i.set(u,$)):$=I}return $}A(u,$){if($&&u){const I=$.getFolder(u);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((u,$)=>{const{contents:I,overrides:D,keys:y}=this.r.get($);return u.push([$,{contents:I,overrides:D,keys:y}]),u},[])}}allKeys(){const u=new Set;return this.j.keys.forEach($=>u.add($)),this.userConfiguration.keys.forEach($=>u.add($)),this.q.keys.forEach($=>u.add($)),this.r.forEach($=>$.keys.forEach(I=>u.add(I))),[...u.values()]}B(){const u=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>u.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>u.add($)),this.q.getAllOverrideIdentifiers().forEach($=>u.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(I=>u.add(I))),[...u.values()]}D(u){const $=new Set;return this.j.getKeysForOverrideIdentifier(u).forEach(I=>$.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(I=>$.add(I)),this.q.getKeysForOverrideIdentifier(u).forEach(I=>$.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(u).forEach(D=>$.add(D))),[...$.values()]}static parse(u,$){const I=this.E(u.defaults,$),D=this.E(u.policy,$),y=this.E(u.application,$),S=this.E(u.user,$),k=this.E(u.workspace,$),g=u.folders.reduce((b,F)=>(b.set(c.URI.revive(F[0]),this.E(F[1],$)),b),new A.$Bc);return new n(I,D,y,S,r.createEmptyModel($),k,g,r.createEmptyModel($),new A.$Bc,$)}static E(u,$){return new r(u.contents,u.keys,u.overrides,void 0,$)}}e.$Mo=n;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const u=new Set,$=new Map;for(const D of f)D.keys.forEach(y=>u.add(y)),D.overrides.forEach(([y,S])=>{const k=(0,A.$yc)($,y,new Set);S.forEach(g=>k.add(g))});const I=[];return $.forEach((D,y)=>I.push([y,[...D.values()]])),{keys:[...u.values()],overrides:I}}class i{constructor(u,$,I,D,y){this.change=u,this.f=$,this.g=I,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of u.keys)this.affectedKeys.add(S);for(const[,S]of u.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(u,$){const I=this.a+u,D=this.d.indexOf(I);if(D<0)return!1;const y=D+I.length;if(y>=this.d.length)return!1;const S=this.d.charCodeAt(y);if(S!==this.b&&S!==this.c)return!1;if($){const k=this.previousConfiguration?this.previousConfiguration.getValue(u,$,this.f?.workspace):void 0,g=this.g.getValue(u,$,this.h);return!N.$fo(k,g)}return!0}}e.$Oo=i;function t(f,u){const{added:$,removed:I,updated:D}=m(u?.rawConfiguration,f?.rawConfiguration),y=[],S=f?.getAllOverrideIdentifiers()||[],k=u?.getAllOverrideIdentifiers()||[];if(u){const g=k.filter(b=>!S.includes(b));for(const b of g)y.push([b,u.getKeysForOverrideIdentifier(b)])}if(f){const g=S.filter(b=>!k.includes(b));for(const b of g)y.push([b,f.getKeysForOverrideIdentifier(b)])}if(u&&f){for(const g of S)if(k.includes(g)){const b=m({contents:f.getOverrideValue(void 0,g)||{},keys:f.getKeysForOverrideIdentifier(g)},{contents:u.getOverrideValue(void 0,g)||{},keys:u.getKeysForOverrideIdentifier(g)});y.push([g,[...b.added,...b.removed,...b.updated]])}}return{added:$,removed:I,updated:D,overrides:y}}function m(f,u){const $=f?u?f.keys.filter(y=>u.keys.indexOf(y)===-1):[...f.keys]:[],I=u?f?u.keys.filter(y=>f.keys.indexOf(y)===-1):[...u.keys]:[],D=[];if(f&&u){for(const y of u.keys)if(f.keys.indexOf(y)!==-1){const S=(0,R.$gj)(u.contents,y),k=(0,R.$gj)(f.contents,y);N.$fo(S,k)||D.push(y)}}return{added:$,removed:I,updated:D}}}),define(Ce[109],Ie([1,0,14,3]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.RemoteAuthorityResolverErrorCode=e.$Rl=e.$Ql=e.RemoteConnectionType=e.$Pl=void 0,e.$Tl=c,e.$Pl=(0,C.$Ei)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(v){this.id=v,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ql=M;class A{constructor(v,l){this.host=v,this.port=l,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rl=A;var N;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(N||(e.RemoteAuthorityResolverErrorCode=N={}));class p extends w.$cb{static isNotAvailable(v){return v instanceof p&&v._code===N.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof p&&v._code===N.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof p&&v._code===N.NoResolverFound}static isInvalidAuthority(v){return v instanceof p&&v._code===N.InvalidAuthority}static isHandled(v){return v instanceof p&&v.isHandled}constructor(v,l=N.Unknown,E){super(v),this._message=v,this._code=l,this._detail=E,this.isHandled=l===N.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Sl=p;function c(R){const v=R.indexOf("+");return v===-1?R:R.substring(0,v)}}),define(Ce[63],Ie([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=C,e.$gn=P,e.$hn=M,e.$in=A;function C(p){return p.scheme===w.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function M(p){const{host:c,port:R}=N(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:R}}function A(p,c){let{host:R,port:v}=N(p);return typeof v>"u"&&(v=c),{host:R,port:v}}function N(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const v=p.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:p,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,63]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=M,e.$sn=v,e.$tn=l,e.$un=E,e.$vn=d,w=qe(w),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function M(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$on=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var N;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(N||(e.TargetPlatform=N={}));class p{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const h=typeof o=="string"?o:o.value,n=typeof a=="string"?a:a.value;return w.$Ff(h,n)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$pn=p;class c{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const a of o)this.add(a)}add(o){this.c.add(p.toKey(o))}delete(o){return this.c.delete(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}}e.$qn=c;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(p.toKey(o))}get(o){return this.c.get(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}set(o,a){this.c.set(p.toKey(o),a)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=R;function v(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function E(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function d(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,P.$gn)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.$wn=(0,C.$Ei)("IBuiltinExtensionsScannerService")}),define(Ce[110],Ie([1,0,21,171,19,3]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.ExtensionManagementErrorCode=e.$hp=e.ExtensionGalleryErrorCode=e.$gp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$ap=N,e.$bp=p,e.$cp=c,e.$dp=R,e.$ep=v,e.$fp=l,e.$6o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$7o=new RegExp(e.$6o),e.$8o="__web_extension",e.$9o="skipWalkthrough",e.$0o="extensionInstallSource",e.$$o="dependecyOrPackExtensionInstall",e.$_o="clientTargetPlatform";var A;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function N(i){switch(i){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(i){switch(i){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(i,t){switch(i){case w.Platform.Windows:return t==="x64"?P.TargetPlatform.WIN32_X64:t==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Linux:return t==="x64"?P.TargetPlatform.LINUX_X64:t==="arm64"?P.TargetPlatform.LINUX_ARM64:t==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?P.TargetPlatform.ALPINE_X64:t==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Mac:return t==="x64"?P.TargetPlatform.DARWIN_X64:t==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Web:return P.TargetPlatform.WEB}}function R(i,t){return t===P.TargetPlatform.WEB&&!i.includes(P.TargetPlatform.WEB)}function v(i,t,m){return R(t,m)?!1:i===P.TargetPlatform.UNDEFINED||i===P.TargetPlatform.UNIVERSAL?!0:i===P.TargetPlatform.UNKNOWN?!1:i===m}function l(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var E;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(i){i.Install="install",i.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$gp=(0,M.$Ei)("extensionGalleryService");var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class h extends Error{constructor(t,m){super(t),this.code=m,this.name=m}}e.$hp=h;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class s extends Error{constructor(t,m){super(t),this.code=m,this.name=m}}e.$ip=s,e.$jp=(0,M.$Ei)("extensionManagementService"),e.$kp="extensionsIdentifiers/disabled",e.$lp="extensionsIdentifiers/enabled",e.$mp=(0,M.$Ei)("IGlobalExtensionEnablementService"),e.$np=(0,M.$Ei)("IExtensionTipsService"),e.$op=(0,C.localize2)(0,"Extensions"),e.$pp=(0,C.localize2)(1,"Preferences")}),define(Ce[111],Ie([1,0,14,19]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IG=e.$HG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,N){this.a.set(A,N)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const N=Object.create(null);for(const p of A){const c=this.readActivationEvents(p);c.length>0&&(N[C.$pn.toKey(p.identifier)]=c)}return N}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const N=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<N.length;p++)N[p]==="onUri"&&(N[p]=`onUri:${C.$pn.toKey(A.identifier)}`);if(!A.contributes)return N;for(const p in A.contributes){const c=this.a.get(p);if(!c)continue;const R=A.contributes[p],v=Array.isArray(R)?R:[R];try{c(v,N)}catch(l){(0,w.$2)(l)}}return N}}e.$HG=P,e.$IG=new P}),define(Ce[216],Ie([1,0,23,14,5,176,54,3,12,31]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0,e.$3p=l,e.$4p=E,e.$5p=d,e.$6p=r,e.$7p=o,e.$8p=a,e.$1p=(0,N.$Ei)("requestService");class R{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class v extends P.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,M.localize)(0,null),when:p.$qk.isEqualTo((0,p.$nk)(p.LogLevel.Trace)).serialize()})}async c(i,t,m){const f=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${f} - begin`,t.type,new R(t.headers??{}));try{const u=await m();return this.a.trace(`${f} - end`,t.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.a.error(`${f} - error`,t.type,(0,C.$$)(u)),u}}}e.$2p=v;function l(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function E(s){return s.res.statusCode===204}async function d(s){return E(s)?null:(await(0,w.$Ze)(s.stream)).toString()}async function r(s){if(!l(s))throw new Error("Server returned "+s.res.statusCode);return d(s)}async function o(s){if(!l(s))throw new Error("Server returned "+s.res.statusCode);if(E(s))return null;const t=(await(0,w.$Ze)(s.stream)).toString();try{return JSON.parse(t)}catch(m){throw m.message+=`:
`+t,m}}function a(s){n(s)}let h;function n(s){const i=c.$oo.as(A.$to.Configuration),t=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[h],remove:t?[t]:[]})}n(A.ConfigurationScope.APPLICATION)}),define(Ce[217],Ie([1,0,21,79,37]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=A,e.$rp=N;function M(p){if(w.$u===w.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,c,R,v,l,E,d,r,o,a){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=d,h["common.devDeviceId"]=r,h.sessionID=(0,P.$1g)()+Date.now(),h.commitHash=v,h.version=l,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,w.$h)(w.$u),h["common.nodePlatform"]=C.$ec,h["common.nodeArch"]=R,h["common.product"]=a||"desktop",o&&(h["common.msftInternal"]=o);let n=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.$l&&(h["common.snap"]="true");const i=M(c);return i&&(h["common.platformDetail"]=i),h}function N(p){const c=C.env.USERDNSDOMAIN;if(!c)return!1;const R=c.toLowerCase();return p.some(v=>R===v)}}),define(Ce[112],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,w.$Ei)("telemetryService"),e.$$l=(0,w.$Ei)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ce[64],Ie([1,0,26,15,63,217,112]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$zp=R,e.$Ap=v,e.$Bp=l,e.$Cp=E,e.$Dp=r,e.$Ep=a,e.$Fp=h,e.$Gp=i;class N{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$sp=N;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$tp=p,e.$up=new p;class c{async publicLog(m,f,u){}async publicLogError(m,f,u){}}e.$vp=c,e.$wp="telemetry",e.$xp="extensionTelemetryLog",e.$yp={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!t.enableTelemetry)}function v(t,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const m=t.getValue(A.$gm),f=t.getValue(A.$hm);if(t.getValue(A.$im)===!1||f===!1)return A.TelemetryLevel.NONE;switch(m??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(t){const m={},f={},u={};o(t,u);for(let $ in u){$=$.length>150?$.substr($.length-149):$;const I=u[$];typeof I=="number"?f[$]=I:typeof I=="boolean"?f[$]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${I.length}`),m[$]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(m[$]=I)}return{properties:m,measurements:f}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const m=(0,P.$gn)(t);return d.has(m)?m:"other"}function o(t,m,f=0,u){if(t)for(const $ of Object.getOwnPropertyNames(t)){const I=t[$],D=u?u+$:$;Array.isArray(I)?m[D]=(0,w.$go)(I):I instanceof Date?m[D]=I.toISOString():(0,C.$gg)(I)?f<2?o(I,m,f+1,D+"."):m[D]=(0,w.$go)(I):m[D]=I}}function a(t,m){const f=t.msftInternalDomains||[],u=m.getValue("telemetry.internalTesting");return(0,M.$rp)(f)||u}function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,m){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let f=t;const u=[];for(const y of m)for(;;){const S=y.exec(t);if(!S)break;u.push([S.index,y.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const y=I.exec(t);if(!y)break;const S=u.some(([k,g])=>y.index<g&&k<I.lastIndex);!$.test(y[0])&&!S&&(f+=t.substring(D,y.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<t.length&&(f+=t.substr(D)),f}function s(t){if(!t)return t;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(t))return`<REDACTED: ${f.label}>`;return t}function i(t,m){return(0,w.$do)(t,f=>{if(f instanceof N||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let u=f.replaceAll("%20"," ");u=n(u,m);for(const $ of m)u=u.replace($,"");return u=s(u),u}})}}),define(Ce[218],Ie([1,0,13,110,19,21,2,14,79,64]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Ip=void 0,e.$Hp=R,e.$Jp=d,e.$Kp=r,e.$Lp=o,e.$Mp=a,e.$Np=h,e.$Op=n,e.$Pp=s,e.$Rp=i,e.$Sp=m;function R(f,u){return f.uuid&&u.uuid?f.uuid===u.uuid:f.id===u.id?!0:(0,w.$Af)(f.id,u.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(u){const $=u.manifest?u.manifest.version:u.version,I=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new l(u.identifier,$,I)}static parse(u){const $=v.exec(u);return $&&$[1]&&$[2]?new l({id:$[1]},$[2],$[4]||void 0):null}constructor(u,$,I=P.TargetPlatform.UNDEFINED){this.identifier=u,this.version=$,this.targetPlatform=I,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof l?R(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Ip=l;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(f){const u=E.exec(f);return u&&u[1]?[o(u[1]),u[2]]:[o(f),void 0]}function r(f,u){return`${f}.${u}`}function o(f){return f.toLowerCase()}function a(f,u){return o(r(f??P.$ln,u))}function h(f,u){const $=[],I=D=>{for(const y of $)if(y.some(S=>R(u(S),u(D))))return y;return null};for(const D of f){const y=I(D);y?y.push(D):$.push([D])}return $}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new c.$sp(f.identifier.id),name:new c.$sp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Qp=new P.$pn("pprice.better-merge");function i(f,u){const $=[],I=u.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const D=I.shift();if(D&&$.every(y=>!R(y.identifier,{id:D}))){const y=f.filter(S=>R(S.identifier,{id:D}));y.length===1&&($.push(y[0]),I.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function t(f,u){if(!M.$k)return!1;let $;try{$=(await f.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await f.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){u.debug("Error while getting the os-release file.",(0,N.$$)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function m(f,u){const $=await t(f,u),I=(0,C.$cp)($?"alpine":M.$u,p.$fc);return u.debug("ComputeTargetPlatform:",I),I}}),define(Ce[219],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=w,e.$zs=C,e.$As=P,e.$Bs=M,e.$Cs=A,e.$Ds=N;function w(p){return[...p.entries()]}function C(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function M(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(c=>[c[0],w(c[1].map),C(c[1].descriptionMap)])}function N(p){return new Map(p.map(c=>[c[0],{map:P(c[1]),descriptionMap:M(c[2])}]))}}),define(Ce[220],Ie([1,0,3,32,31]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$is=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$hs=void 0,e.$hs=new C.$Vj("terminalTabFocusMode",!1,!0);var M;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var A;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var N;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(N||(e.PosixShellType=N={}));var p;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var R;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var v;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$is=(0,w.$Ei)("ptyService");var l;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(l||(e.HeartbeatConstants=l={}));var E;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(i){i.TerminalView="view",i.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$js={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const m=this.b(t.remoteAuthority);if(this.a.has(m))throw new Error(`A terminal backend with remote authority '${m}' was already registered.`);this.a.set(m,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$oo.add(e.$js.Backend,new s),e.$ks=(0,w.$Ei)("localPtyService"),e.$ls=(0,w.$Ei)("terminalLogService")}),define(Ce[221],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iwb=void 0;class w{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,A=5){const N=M(p=>{const c=typeof p=="string"?p:p.data;let R=this.a.get(P);if(R){R.data.push(c);return}const v=setTimeout(()=>this.flushBuffer(P),A);R={data:[c],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(P),N.dispose()}},this.a.set(P,R)});return N}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$Iwb=w}),define(Ce[222],Ie([1,0,11,98,323,35,4,15,2,177,78,31]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ax=e.$zx=e.$yx=e.$xx=e.$wx=e.$vx=e.IconFontDefinition=e.IconContribution=e.$sx=void 0,e.$tx=o,e.$ux=a,v=qe(v),e.$sx={IconContribution:"base.contributions.icons"};var l;(function(i){function t(m,f){let u=m.defaults;for(;M.ThemeIcon.isThemeIcon(u);){const $=r.getIcon(u.id);if(!$)return;u=$.defaults}return u}i.getDefinition=t})(l||(e.IconContribution=l={}));var E;(function(i){function t(f){return{weight:f.weight,style:f.style,src:f.src.map(u=>({format:u.format,location:u.location.toString()}))}}i.toJSONObject=t;function m(f){const u=$=>(0,N.$eg)($)?$:void 0;if(f&&Array.isArray(f.src)&&f.src.every($=>(0,N.$eg)($.format)&&(0,N.$eg)($.location)))return{weight:u(f.weight),style:u(f.style),src:f.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}i.fromJSONObject=m})(E||(e.IconFontDefinition=E={}));class d{constructor(){this.a=new A.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${M.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,m,f,u){const $=this.b[t];if($){if(f&&!$.description){$.description=f,this.d.properties[t].markdownDescription=`${f} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=f),this.a.fire()}return $}const I={id:t,description:f,defaults:m,deprecationMessage:u};this.b[t]=I;const D={$ref:"#/definitions/icons"};return u&&(D.deprecationMessage=u),f&&(D.markdownDescription=`${f}: $(${t})`),this.d.properties[t]=D,this.e.enum.push(t),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const m=this.e.enum.indexOf(t);m!==-1&&(this.e.enum.splice(m,1),this.e.enumDescriptions.splice(m,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,m){const f=this.f[t];return f||(this.f[t]=m,this.a.fire(),m)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=($,I)=>$.id.localeCompare(I.id),m=$=>{for(;M.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map($=>this.b[$]);for(const $ of u.filter(I=>!!I.description).sort(t))f.push(`|<i class="${m($)}"></i>|${$.id}|${M.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const $ of u.filter(I=>!M.ThemeIcon.isThemeIcon(I.defaults)).sort(t))f.push(`|<i class="${m($)}"></i>|${$.id}|`);return f.join(`
`)}}const r=new d;v.$oo.add(e.$sx.IconContribution,r);function o(i,t,m,f){return r.registerIcon(i,t,m,f)}function a(){return r}function h(){const i=(0,P.$Zj)();for(const t in i){const m="\\"+i[t].toString(16);r.registerIcon(t,{fontCharacter:m})}}h(),e.$vx="vscode://schemas/icons";const n=v.$oo.as(R.$po.JSONContribution);n.registerSchema(e.$vx,r.getIconSchema());const s=new w.$Qh(()=>n.notifySchemaChanged(e.$vx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$wx=o("widget-close",C.$4j.close,(0,c.localize)(2,null)),e.$xx=o("goto-previous-location",C.$4j.arrowUp,(0,c.localize)(3,null)),e.$yx=o("goto-next-location",C.$4j.arrowDown,(0,c.localize)(4,null)),e.$zx=M.ThemeIcon.modify(C.$4j.sync,"spin"),e.$Ax=M.ThemeIcon.modify(C.$4j.loading,"spin")}),define(Ce[223],Ie([1,0,4,5,21,2,42,3,12]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Dw=e.$Bw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$xw=e.$ww=void 0,e.$yw=v,e.$zw=E,e.$Aw=d,e.$Cw=r,e.$Ew=o,e.$Fw=a,e.$ww=(0,N.$Ei)("tunnelService"),e.$xw=(0,N.$Ei)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var R;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(R||(e.TunnelPrivacyId=R={}));function v(s){return!!s.forwardPort}var l;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function E(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(i)return{address:i[1],port:+i[2]}}function d(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const i=s.query.split("&");for(const t of i){const m=t.split("=")[1];if(/^https?:/.exec(m)){const f=E(M.URI.parse(m));if(f)return f}}}e.$Bw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(s){return e.$Bw.indexOf(s)>=0}e.$Dw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(s){return e.$Dw.indexOf(s)>=0}function a(s,i,t,m){if(t===P.OperatingSystem.Windows)return!1;if(t===P.OperatingSystem.Macintosh&&o(i)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(f?.length===4&&parseInt(f[1])>=18)return!1}return s<1024}class h{constructor(i,t,m){this.remoteAddress=i,this.localAddress=t,this.b=m,this.a=new w.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Gw=h;let n=class extends C.$Vc{constructor(i,t){super(),this.r=i,this.s=t,this.a=new w.$le,this.onTunnelOpened=this.a.event,this.b=new w.$le,this.onTunnelClosed=this.b.event,this.c=new w.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],t=Array.from(this.f.values());for(const m of t){const f=Array.from(m.values());for(const u of f){const $=await u.value;$&&typeof $!="string"&&i.push($)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:t}of i.values())await t.then(m=>typeof m!="string"?m?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,t,m,f,u){this.z(i,t,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:t,localAddress:m,privacy:f,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,t){(o(i)||r(i))&&(i=e.$Bw[0]);const m=this.D(i,t);if(m)return++m.refcount,m.value}openTunnel(i,t,m,f,u,$=!1,I,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${m} on local port ${u}.`);const y=this.g??i;if(!y)return;if(t||(t="localhost"),f||(f=this.t),this.g&&this.n.has(m)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.F(y,t,m,f,u,$,I,D);return S?S.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,m),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,m);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.w(k);return(k.tunnelRemoteHost!==t||k.tunnelRemotePort!==m)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),I&&k.privacy!==I&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const t=this.f.get(i.tunnelRemoteHost);if(t){const m=t.get(i.tunnelRemotePort);m&&(m.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async y(i,t,m){if(m.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${t}.`);const f=m.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(t),f}}async closeTunnel(i,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${t} `);const m=this.f.get(i);if(m&&m.has(t)){const f=m.get(t);f.refcount=0,await this.y(i,t,f)}}z(i,t,m){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(t,{refcount:1,value:m})}async C(i,t){const m=this.f.get(i);if(m){const f=m.get(t),u=f?await f.value:void 0;(!u||typeof u=="string")&&m.delete(t),m.size===0&&this.f.delete(i)}}D(i,t){const m=[i];r(i)?(m.push(...e.$Bw),m.push(...e.$Dw)):o(i)&&m.push(...e.$Dw);const f=m.map(u=>this.f.get(u));for(const u of f){const $=u?.get(t);if($)return $}}canTunnel(i){return!!E(i)}G(i,t,m,f,u,$,I){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${m} on local port ${f}.`);const D=m;this.n.add(D);const y=f===void 0?m:f,S={elevationRequired:u?this.isPortPrivileged(y):!1},k={remoteAddress:{host:t,port:m},localAddressPort:f,privacy:$,public:$?$!==R.Private:void 0,protocol:I},g=i.forwardPort(k,S);return g?(this.z(t,m,g),g.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),g}};e.$Hw=n,e.$Hw=n=He([We(0,p.$$j),We(1,A.$$i)],n)}),define(Ce[224],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,w.$Ei)("IUriIdentityService")}),define(Ce[225],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Iw=void 0,e.$Iw=(0,w.$Ei)("editSessionIdentityService");var C;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Ce[226],Ie([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=C,e.$yM=P,e.$zM=M,e.$AM=A,e.$BM=N;function C(p){return p.scheme!==w.Schemas.file&&p.scheme!==w.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(c=>C(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&C(p.configuration))return p.configuration}function M(p){return P(p)?.scheme}function A(p){return P(p)?.authority}function N(p){return P(p)!==void 0}}),define(Ce[50],Ie([1,0,179,20,59,24,2,3,16]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=c,e.$Pi=R,e.$Si=v,e.$Ti=l,e.$Ui=E,e.$Vi=r,e.$Wi=o,e.$Zi=n,e.$5i=s,e.$6i=i,e.$8i=t,e.$9i=m,e.$0i=f,e.$Ni=(0,N.$Ei)("contextService");function c(u){const $=u;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function R(u){return typeof u?.id=="string"&&!c(u)&&!l(u)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function v(u,$){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,C.$oc)(u)}:$?e.$Qi:e.$Ri;const I=u;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function l(u){const $=u;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(u){const $=u;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const I=u;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(u?.id)return{id:u.id}}var d;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(u){const $=u;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function o(u){const $=u;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class a{constructor($,I,D,y,S){this.h=$,this.j=D,this.k=y,this.l=S,this.c=P.$Ki.forUris(this.l,()=>!0),this.folders=I}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=P.$Ki.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=a;class h{constructor($,I){this.raw=I,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,M.$fh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=h;function n(u){return new h({uri:u,index:0,name:(0,M.$bh)(u)},{uri:u.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,w.localize)(0,null),extensions:[e.$1i]}],e.$4i="workspace.json";function s(u,$){return M.$9g.isEqualOrParent(u,$.untitledWorkspacesHome)}function i(u){let $;return A.URI.isUri(u)?$=u:$=u.configuration,$?.scheme===p.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$7i}function m(u,$){return!s(u,$)&&!i(u)}function f(u){return(typeof u=="string"?(0,C.$pc)(u):(0,M.$dh)(u))===e.$2i}}),define(Ce[113],Ie([1,0,76,4,5,24,2,178,106,30,3,12,50,29,224,11,37,13,15]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=s,e.$Ll=i,e.$Ml=t;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(u){const $=u;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Kl=(0,R.$Ei)("IUserDataProfilesService");function i(u,$){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:A.URI.revive(u.location).with({scheme:$}),globalStorageHome:A.URI.revive(u.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(u.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(u.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(u.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(u.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(u.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(u.cacheHome).with({scheme:$}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function t(u,$,I,D,y,S){return{id:u,name:$,location:I,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:S&&y?.useDefaultFlags?.globalState?S.globalStorageHome:(0,M.$fh)(I,"globalStorage"),settingsResource:S&&y?.useDefaultFlags?.settings?S.settingsResource:(0,M.$fh)(I,"settings.json"),keybindingsResource:S&&y?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,M.$fh)(I,"keybindings.json"),tasksResource:S&&y?.useDefaultFlags?.tasks?S.tasksResource:(0,M.$fh)(I,"tasks.json"),snippetsHome:S&&y?.useDefaultFlags?.snippets?S.snippetsHome:(0,M.$fh)(I,"snippets"),extensionsResource:S&&y?.useDefaultFlags?.extensions?S.extensionsResource:(0,M.$fh)(I,"extensions.json"),cacheHome:(0,M.$fh)(D,u),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let m=class extends P.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,I,D,y){super(),this.t=$,this.u=I,this.w=D,this.y=y,this.f=!0,this.h=this.B(new C.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Bc,workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,M.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),I=[$];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,h.$eg)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}I.push(t((0,M.$ch)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},$))}}catch(S){this.y.error(S)}const D=new E.$Bc,y=new Map;if(I.length)try{const S=this.Q();if(S.workspaces)for(const[k,g]of Object.entries(S.workspaces)){const b=A.URI.parse(k),F=I.find(T=>T.id===g);F&&D.set(b,F)}if(S.emptyWindows)for(const[k,g]of Object.entries(S.emptyWindows)){const b=I.find(F=>F.id===g);b&&y.set(k,b)}}catch(S){this.y.error(S)}this.z={profiles:I,workspaces:D,emptyWindows:y}}return this.z}D(){const $=t("__default__profile__",(0,N.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const I="Temp",D=new RegExp(`${(0,a.$hf)(I)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const g=D.exec(k.name),b=g?parseInt(g[1]):0;y=b>y?b:y}const S=`${I} ${y+1}`;return this.createProfile((0,w.$sj)((0,o.$1g)()).toString(16),S,{transient:!0},$)}async createNamedProfile($,I,D){return this.createProfile((0,w.$sj)((0,o.$1g)()).toString(16),$,I,D)}async createProfile($,I,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F($,I,D);return y&&await this.setProfileForWorkspace(y,S),S}async F($,I,D){if(!(0,h.$eg)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(I);return y||(y=(async()=>{try{if(this.profiles.find(b=>b.name===I||b.id===$))throw new Error(`Profile with ${I} name already exists`);const k=t($,I,(0,M.$fh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const g=[];return this.j.fire({profile:k,join(b){g.push(b)}}),await r.Promises.settled(g),this.I([k],[],[]),k}finally{this.r.delete(I)}})(),this.r.set(I,y)),y}async updateProfile($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=t(D.id,I.name??D.name,D.location,this.g,{shortName:I.shortName??D.shortName,icon:I.icon===null?void 0:I.icon??D.icon,transient:I.transient??D.isTransient,useDefaultFlags:I.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(y=>y.id===$.id);if(!I)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:I,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(y){(0,c.$pl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===I.id);if(!D)throw new Error(`Profile '${I.name}' does not exist`);this.L($,D)}unsetWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,I)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(I=>I.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled($.map(I=>this.removeProfile(I)))}getProfileForWorkspace($){const I=this.G($),D=A.URI.isUri(I)?this.C.workspaces.get(I):this.C.emptyWindows.get(I);return D||((0,l.$Oi)($)?this.s.folders.get($.uri):(0,l.$Ti)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,l.$Oi)($)?$.uri:(0,l.$Ti)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.folders.values()].some(I=>this.w.extUri.isEqual(I.location,$.location)))}I($,I,D){const y=[...this.profiles,...$],S=[],k=this.s.profiles;this.s.profiles=[];for(let g of y){if(g.isDefault||I.some(F=>g.id===F.id))continue;g=D.find(F=>g.id===F.id)??g;const b=k.find(F=>g.id===F.id);if(g.isTransient)this.s.profiles.push(g);else{if(b){for(const[F,T]of this.s.emptyWindows.entries())if(g.id===T.id){this.L({id:F},g);break}for(const[F,T]of this.s.workspaces.entries())if(g.id===T.id){this.L({id:"",configPath:F},g);break}for(const[F,T]of this.s.folders.entries())if(g.id===T.id){this.L({id:"",uri:F},g);break}}S.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags})}}this.P(S),this.z=void 0,this.J($,I,D)}J($,I,D){this.h.fire({added:$,removed:I,updated:D,all:this.profiles})}L($,I,D){if(D=I?.isTransient?!0:D,D)(0,l.$Oi)($)?(this.s.folders.delete($.uri),I&&this.s.folders.set($.uri,I)):(0,l.$Ti)($)?(this.s.workspaces.delete($.configPath),I&&this.s.workspaces.set($.configPath,I)):(this.s.emptyWindows.delete($.id),I&&this.s.emptyWindows.set($.id,I));else{this.L($,void 0,!0);const y=this.G($);A.URI.isUri(y)?(this.C.workspaces.delete(y),I&&this.C.workspaces.set(y,I)):(this.C.emptyWindows.delete(y),I&&this.C.emptyWindows.set(y,I)),this.M()}}M(){const $={};for(const[D,y]of this.C.workspaces.entries())$[D.toString()]=y.id;const I={};for(const[D,y]of this.C.emptyWindows.entries())I[D.toString()]=y.id;this.R({workspaces:$,emptyWindows:I}),this.z=void 0}N($){const I={},D=this.D();if($.workspaces)for(const[S,k]of Object.entries($.workspaces)){const g=A.URI.parse(k);I[S]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const y={};if($.emptyWindows)for(const[S,k]of Object.entries($.emptyWindows)){const g=A.URI.parse(k);y[S]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:I,emptyWindows:y}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Nl=m,e.$Nl=m=He([We(0,p.$Li),We(1,c.$$k),We(2,d.$Il),We(3,v.$$j)],m);class f extends m{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Ol=f}),define(Ce[227],Ie([1,0,11,4,5,65,15,161,3,113]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$dq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$bq=e.$aq=e.$_p=void 0,e.$cq=E,e.$eq=r,e.$gq=a,e.$_p="__$__isNewStorageMarker",e.$aq="__$__targetStorageMarker",e.$bq=(0,p.$Ei)("storageService");var R;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var v;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var l;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function E(h){const n=h.get(e.$aq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class d extends P.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:d.a}){super(),this.m=n,this.b=this.B(new C.$oe),this.c=this.B(new C.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$le),this.onWillSaveState=this.f.event,this.h=this.B(new w.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,s,i){return C.Event.filter(this.b.event,t=>t.scope===n&&(s===void 0||t.key===s),i)}n(){this.j.value=(0,w.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,s){const{key:i,external:t}=s;if(i===e.$aq){switch(n){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,s,i){return this.P(s)?.get(n,i)}getBoolean(n,s,i){return this.P(s)?.getBoolean(n,i)}getNumber(n,s,i){return this.P(s)?.getNumber(n,i)}getObject(n,s,i){return this.P(s)?.getObject(n,i)}storeAll(n,s){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,s)})}store(n,s,i,t,m=!1){if((0,A.$ng)(s)){this.remove(n,i,m);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,s,m)})}remove(n,s,i=!1){this.y(()=>{this.z(n,s,void 0),this.P(s)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,s){const i=[],t=this.J(n);for(const m of Object.keys(t))t[m]===s&&i.push(m);return i}z(n,s,i,t=!1){const m=this.J(s);typeof i=="number"?m[n]!==i&&(m[n]=i,this.P(s)?.set(e.$aq,JSON.stringify(m),t)):typeof m[n]=="number"&&(delete m[n],this.P(s)?.set(e.$aq,JSON.stringify(m),t))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(n){switch(n){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(n){const s=this.P(n);return s?E(s):Object.create(null)}isNew(n){return this.getBoolean(e.$_p,n)===!0}async flush(n=R.NONE){this.f.fire({reason:n});const s=this.P(v.APPLICATION),i=this.P(v.PROFILE),t=this.P(v.WORKSPACE);switch(n){case R.NONE:await w.Promises.settled([s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await w.Promises.settled([s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(v.APPLICATION)?.items??new Map,s=this.P(v.PROFILE)?.items??new Map,i=this.P(v.WORKSPACE)?.items??new Map;return a(n,s,i,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,s){return this.w(R.NONE),(0,c.$Jl)(n)?this.R(n,s):this.S(n,s)}M(n,s){return!(n.id===s.id||r(s)&&r(n))}N(n,s,i){this.y(()=>{const t=new Set;for(const[m,f]of n)t.add(m),s.get(m)!==f&&this.u(i,{key:m,external:!0});for(const[m]of s.items)t.has(m)||this.u(i,{key:m,external:!0})})}}e.$dq=d;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new N.$0p(new N.$$p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new N.$0p(new N.$$p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new N.$0p(new N.$$p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(v.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(v.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(v.APPLICATION,n)))}P(n){switch(n){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$fq=o;async function a(h,n,s,i,t,m){const f=b=>{try{return JSON.parse(b)}catch{return b}},u=new Map,$=new Map;h.forEach((b,F)=>{u.set(F,b),$.set(F,f(b))});const I=new Map,D=new Map;n.forEach((b,F)=>{I.set(F,b),D.set(F,f(b))});const y=new Map,S=new Map;s.forEach((b,F)=>{y.set(F,b),S.set(F,f(b))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const k=[];if(u.forEach((b,F)=>{k.push({key:F,value:b})}),console.table(k),console.groupEnd(),console.log($),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const b=[];I.forEach((F,T)=>{b.push({key:T,value:F})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${m})`);const g=[];y.forEach((b,F)=>{g.push({key:F,value:b})}),console.table(g),console.groupEnd(),console.log(S)}}),define(Ce[80],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class w{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$$mc=w}),define(Ce[51],Ie([1,0,16,24,30,3]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0;class A{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new C.$7g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$dnc=A,e.$enc=(0,M.$Ei)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=void 0,e.$KP=(0,w.$Ei)("IExtHostInitDataService")}),define(Ce[228],Ie([1,0,184,12,213,27]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;let A=class extends P.$UQ{constructor(p,c,R){const v=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",l=R.remote.isRemote?(0,w.localize)(0,null):p?(0,w.localize)(1,null):(0,w.localize)(2,null);super(c.createLogger(v,{name:l}))}};e.$lpc=A,e.$lpc=A=He([We(1,C.$_j),We(2,M.$KP)],A)}),define(Ce[229],Ie([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0;class C{constructor(A,N,p){this.h=new Map,this.a=A,this.b=N,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new w.$Qh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of c.values())R.complete()}catch(R){for(const v of c.values())v.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,N){let p=this.f[A];return typeof p>"u"&&(p=N),p}update(A,N){this.f[A]=N;const p=this.h.get(A);if(p!==void 0)return p.p;const c=new w.$2h;return this.h.set(A,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$Vnc=C;class P extends C{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,N){super(A.identifier.value,!0,N),this.j=A}}e.$Wnc=P}),define(Ce[230],Ie([1,0,4,2]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=void 0;class P{constructor(A){this.c=A,this.a=new w.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,N,p,c){const v=this.c.getNotebookDocument(C.URI.revive(A)).acceptModelChanged(N.value,p,c);this.b.fire(v)}$acceptDirtyStateChanged(A,N){this.c.getNotebookDocument(C.URI.revive(A)).acceptDirty(N)}$acceptModelSaved(A){const N=this.c.getNotebookDocument(C.URI.revive(A));this.a.fire(N.apiNotebook)}}e.$Poc=P}),define(Ce[17],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=void 0,e.$uP=(0,w.$Ei)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$vP=C}),define(Ce[231],Ie([1,0,19,4]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class P{#e;constructor(A,N){this.b=new C.$le,this.onDidChange=this.b.event,this.a=w.$pn.toKey(A.identifier),this.#e=N,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(A){return this.#e.get(this.a,A)}store(A,N){return this.#e.store(this.a,A,N)}delete(A){return this.#e.delete(this.a,A)}}e.$6nc=P}),define(Ce[66],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0,e.$tnc=(0,w.$Ei)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$unc=C});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[114],Ie([1,0,193,15,2,5,3,31,30,16,48,155,36]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$aG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3F=e.EditorInputCapabilities=e.$2F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=void 0,e.$SF=r,e.$TF=o,e.$UF=a,e.$VF=h,e.$WF=n,e.$XF=s,e.$YF=i,e.$ZF=t,e.$1F=m,e.$4F=y,e.$5F=k,e.$6F=g,e.$7F=b,e.$8F=F,e.$9F=T,e.$0F=q,e.$$F=G,e.$_F=te,e.$bG=de,e.$cG=re,e.$dG=Pe,e.$eG=Fe,l=ri(l),e.$NF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$OF={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$PF="workbench.editor.sidebysideEditor",e.$QF="workbench.editors.textDiffEditor",e.$RF="workbench.editors.binaryResourceDiffEditor";var E;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var d;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(X){const B=X;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function o(X){const B=X;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function a(X,B,_){for(const we of _.visibleEditorPanes)if(we.group.id===B&&X.matches(we.input))return we.getViewState()}function h(X){if(y(X))return!1;const B=X;return P.URI.isUri(B?.resource)}function n(X){if(y(X))return!1;const B=X;return B?.original!==void 0&&B.modified!==void 0}function s(X){if(y(X))return!1;const B=X;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function i(X){if(y(X)||n(X))return!1;const B=X;return B?.primary!==void 0&&B.secondary!==void 0}function t(X){if(y(X))return!1;const B=X;return B?B.resource===void 0||B.resource.scheme===c.Schemas.untitled||B.forceUntitled===!0:!1}function m(X){if(y(X))return!1;const B=X;return P.URI.isUri(B?.base?.resource)&&P.URI.isUri(B?.input1?.resource)&&P.URI.isUri(B?.input2?.resource)&&P.URI.isUri(B?.result?.resource)}var f;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var u;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class ${constructor(){this.a=new Map}registerSource(B,_){let we=this.a.get(B);return we||(we={source:B,label:_},this.a.set(B,we)),we.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$2F=new $;var I;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class D extends M.$Vc{}e.$3F=D;function y(X){return X instanceof D}function S(X){const B=X;return P.URI.isUri(B?.preferredResource)}function k(X){const B=X;return y(B?.primary)&&y(B?.secondary)}function g(X){const B=X;return y(B?.modified)&&y(B?.original)}function b(X,B,_,we,ae){return Fe(we,[(0,v.$oj)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ve={..._,limits:{size:Number.MAX_VALUE}};X.openEditor(B,ve)}}),(0,v.$oj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function F(X){return y(X?.editor)}function T(X){const B=X;return F(X)&&B?.group!==void 0}function q(X){const B=X;return typeof B?.groupId=="number"&&y(B.editor)}function G(X){return typeof X?.groupId=="number"}var V;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var O;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var W;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class ce{getOriginalUri(B,_){if(!B)return;if(m(B))return e.$aG.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:ve}=this.a(B);if(ae&&ve){if(_?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ve,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===W.ANY)return this.getOriginalUri(ae,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ve,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===W.PRIMARY?ae:ve}}if(n(B)||s(B)||i(B)||m(B))return;const we=S(B)?B.preferredResource:B.resource;return!we||!_||!_.filterByScheme?we:this.b(we,_.filterByScheme)}a(B){return k(B)||i(B)?{primary:B.primary,secondary:B.secondary}:g(B)||n(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(m(B))return e.$aG.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:ve}=this.a(B);if(ae&&ve){if(_?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ve,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===W.ANY)return this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ve,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===W.PRIMARY?ae:ve}}if(n(B)||s(B)||i(B)||m(B))return;const we=B.resource;return!we||!_||!_.filterByScheme?we:this.b(we,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(we=>B.scheme===we))return B}else if(_===B.scheme)return B}}var ge;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function te(X,B,_,we){if(!X.isSticky(B))return!1;switch(we.preventPinnedEditorClose){case"keyboardAndMouse":return _===ge.MOUSE||_===ge.KEYBOARD;case"mouse":return _===ge.MOUSE;case"keyboard":return _===ge.KEYBOARD}return!1}e.$aG=new ce;var me;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class se{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(A.$Di);for(const[we,ae]of this.c)this.e(we,ae,_);this.c.clear()}e(B,_,we){const ae=we.createInstance(_);this.d.set(B,ae)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,C.$pg)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,M.$Tc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}N.$oo.add(e.$NF.EditorFactory,new se);async function de(X,B,_){return!X||!X.length?[]:await Promise.all(X.map(async we=>{const ae=P.URI.revive(we.fileUri);if(!ae){_.info("Cannot resolve the path because it is not valid.",we);return}if(!await B.canHandleResource(ae)){_.info("Cannot resolve the path because it cannot be handled",we);return}let ue=we.exists,Z=we.type;if(typeof ue!="boolean"||typeof Z!="number")try{Z=(await B.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ue=!0}catch(pe){_.error(pe),ue=!1}if(!ue&&we.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",we);return}if(Z===p.FileType.Directory){_.info("Cannot resolve the path because it is a directory",we);return}const Y={...we.options,pinned:!0};return ue?{resource:ae,options:Y}:{resource:ae,options:Y,forceUntitled:!0}}))}var be;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function re(X){const B=X;if(!B)return!1;const _=B;if(_.modified)return re(_.modified);const we=B;return!!(we.contributionsState&&we.viewState&&Array.isArray(we.cursorState))}function Pe(X){return(0,R.$qj)(X)}function Fe(X,B,_){const we=(0,R.$rj)(X,B);return we.forceMessage=_?.forceMessage,we.forceSeverity=_?.forceSeverity,we.allowDialog=_?.allowDialog,we}}),define(Ce[232],Ie([1,0,4,194,3,5,29,31,26,98,222]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mG=e.$lG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$kG=e.ViewContentGroups=e.$iG=e.ViewContainerLocation=e.Extensions=e.$hG=e.$gG=e.$fG=void 0,e.$jG=E,e.$fG="views",e.$gG=(0,C.localize)(0,null),e.$hG=(0,R.$tx)("default-view-icon",c.$4j.window,(0,C.localize)(1,null));var v;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$iG=[l.Sidebar,l.Panel,l.AuxiliaryBar];function E(t){switch(t){case l.Sidebar:return"sidebar";case l.Panel:return"panel";case l.AuxiliaryBar:return"auxiliarybar"}}class d extends M.$Vc{constructor(){super(...arguments),this.c=this.B(new w.$le),this.onDidRegister=this.c.event,this.f=this.B(new w.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(m,f,u){const $=this.get(m.id);if($)return $;const I=m;return I.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$yc)(this.g,f,[]).push(I),u?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(m){for(const f of this.g.keys()){const u=this.g.get(f),$=u?.indexOf(m);if($!==-1){u?.splice($,1),u.length===0&&this.g.delete(f),this.f.fire({viewContainer:m,viewContainerLocation:f});return}}}get(m){return this.all.filter(f=>f.id===m)[0]}getViewContainers(m){return[...this.g.get(m)||[]]}getViewContainerLocation(m){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(u=>u?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.h.find(f=>this.getViewContainerLocation(f)===m)}}N.$oo.add(v.ViewContainersRegistry,new d);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(t,m){const f=t.group??r.More,u=m.group??r.More;return f!==u?f.localeCompare(u):(t.order??5)-(m.order??5)}class a extends M.$Vc{constructor(){super(...arguments),this.c=this.B(new w.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Ic}registerViews(m,f){this.registerViews2([{views:m,viewContainer:f}])}registerViews2(m){m.forEach(({views:f,viewContainer:u})=>this.r(f,u)),this.c.fire(m)}deregisterViews(m,f){const u=this.s(m,f);u.length&&this.f.fire({views:u,viewContainer:f})}moveViews(m,f){for(const u of this.m.keys())if(u!==f){const $=this.s(m,u);$.length&&(this.r($,f),this.g.fire({views:$,from:u,to:f}))}}getViews(m){return this.m.get(m)||[]}getView(m){for(const f of this.j){const u=(this.m.get(f)||[]).filter($=>$.id===m)[0];if(u)return u}return null}getViewContainer(m){for(const f of this.j)if((this.m.get(f)||[]).filter($=>$.id===m)[0])return f;return null}registerViewWelcomeContent(m,f){return this.n.add(m,f),this.h.fire(m),(0,M.$Tc)(()=>{this.n.delete(m,f),this.h.fire(m)})}registerViewWelcomeContent2(m,f){const u=new Map;for(const[$,I]of f)this.n.add(m,I),u.set($,(0,M.$Tc)(()=>{this.n.delete(m,I),this.h.fire(m)}));return this.h.fire(m),u}getViewWelcomeContent(m){const f=[];return this.n.forEach(m,u=>f.push(u)),f.sort(o)}r(m,f){let u=this.m.get(f);u||(u=[],this.m.set(f,u),this.j.push(f));for(const $ of m){if(this.getView($.id)!==null)throw new Error((0,C.localize)(2,null,$.id));u.push($)}}s(m,f){const u=this.m.get(f);if(!u)return[];const $=[],I=[];for(const D of u)m.includes(D)?$.push(D):I.push(D);return $.length&&(I.length?this.m.set(f,I):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),$}}N.$oo.add(v.ViewsRegistry,new a),e.$kG=(0,P.$Ei)("viewDescriptorService");var h;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class s{constructor(m,f){this.c=!1,this.d=!1,(0,p.$eo)(this,m),this.d=!!f,this.resolve=async u=>{if(f&&!this.c){const $=await f(u);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$lG=s;class i extends Error{constructor(m){super((0,C.localize)(3,null,m)),this.name="NoTreeViewError"}static is(m){return m.name==="NoTreeViewError"}}e.$mG=i}),define(Ce[233],Ie([1,0,195,32]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0,e.$qG=new C.$Vj("chatSessionResponseVote","",{type:"string",description:(0,w.localize)(0,null)}),e.$rG=new C.$Vj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,w.localize)(1,null)}),e.$sG=new C.$Vj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,w.localize)(2,null)}),e.$tG=new C.$Vj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,w.localize)(3,null)}),e.$uG=new C.$Vj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,w.localize)(4,null)}),e.$vG=new C.$Vj("chatResponse",!1,{type:"boolean",description:(0,w.localize)(5,null)}),e.$wG=new C.$Vj("chatRequest",!1,{type:"boolean",description:(0,w.localize)(6,null)}),e.$xG=new C.$Vj("chatEditApplied",!1,{type:"boolean",description:(0,w.localize)(7,null)}),e.$yG=new C.$Vj("chatInputHasText",!1,{type:"boolean",description:(0,w.localize)(8,null)}),e.$zG=new C.$Vj("chatInputHasFocus",!1,{type:"boolean",description:(0,w.localize)(9,null)}),e.$AG=new C.$Vj("inChatInput",!1,{type:"boolean",description:(0,w.localize)(10,null)}),e.$BG=new C.$Vj("inChat",!1,{type:"boolean",description:(0,w.localize)(11,null)}),e.$CG=new C.$Vj("chatIsEnabled",!1,{type:"boolean",description:(0,w.localize)(12,null)}),e.$DG=new C.$Vj("chatCursorAtTop",!1),e.$EG=new C.$Vj("chatInputHasAgent",!1),e.$FG=new C.$Vj("chatLocation",void 0),e.$GG=new C.$Vj("quickChatHasFocus",!1,{type:"boolean",description:(0,w.localize)(13,null)})}),define(Ce[234],Ie([1,0,324,11,22,4,40,5,49,141,13,32,19,3,12,108,216,227,233]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.ChatAgentLocation=void 0,e.$LH=f,e.$MH=u;var s;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function($){function I(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=I}(s||(e.ChatAgentLocation=s={})),e.$GH=(0,E.$Ei)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new M.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$CG.bindTo(this.f)}registerAgent(I,D){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const S=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(b=>!b.when||S.f.contextMatchesRules(v.$Cj.deserialize(b.when)))}};const g={data:D};return this.b.set(I,g),(0,N.$Tc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,D){const y=this.b.get(I);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new t(y.data,D)),(0,N.$Tc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,D){I.isDynamic=!0;const y={data:I,impl:D};return this.b.set(I.id,y),this.d.fire(new t(I,D)),(0,N.$Tc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,D){return this.g.set(I,D),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,D,y){return await this.g.get(I)?.(D,y)??[]}updateAgent(I,D){const y=this.b.get(I);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new t(y.data,y.impl))}getDefaultAgent(I){return(0,w.$gb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const D=this.b.get(I);return!D?.data.when||this.f.contextMatchesRules(v.$Cj.deserialize(D.data.when))}getAgentByFullyQualifiedId(I){const D=A.Iterable.find(this.b.values(),y=>f(y.data)===I)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new t(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(D=>D.name===I)}agentHasDupeName(I){const D=this.getAgent(I);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(I,D,y,S,k){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return await g.impl.invoke(D,y,S,k)}async getFollowups(I,D,y,S,k){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return g.impl?.provideFollowups?g.impl.provideFollowups(D,y,S,k):[]}};e.$HH=i,e.$HH=i=He([We(0,v.$Wj)],i);class t{constructor(I,D){this.b=I,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,D,y,S){return this.d.invoke(I,D,y,S)}async provideFollowups(I,D,y,S){return this.d.provideFollowups?this.d.provideFollowups(I,D,y,S):[]}provideWelcomeMessage(I,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,D)}provideSampleQuestions(I,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,D)}}e.$IH=t,e.$JH=(0,E.$Ei)("chatAgentNameService");let m=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(I,D,y,S){if(this.g=D,this.h=y,this.i=S,this.e=(0,c.$6d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const k=S.get(n.b,a.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{S.remove(n.b,a.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,C.$Fh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$7p)(I);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(n.b,JSON.stringify(y),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(I){const D=this.l(I.name,I).get(),y=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return D&&y}l(I,D){return this.e.map(S=>S[I.toLowerCase()]).map(S=>S?S.some(k=>(0,R.$Ff)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$KH=m,e.$KH=m=n=He([We(0,r.$rk),We(1,o.$1p),We(2,d.$$j),We(3,a.$bq)],m);function f($){return`${$.extensionId.value}.${$.id}`}function u($){const I="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new l.$pn("")),(0,p.$bi)(I)}}),define(Ce[235],Ie([1,0,2,33,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$cH=M,e.$dH=A;function M(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof w.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(C.$Ht.isIRange)}function A(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(M)}var N;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(N||(e.ChatAgentVoteDirection=N={}));var p;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$eH=(0,P.$Ei)("IChatService"),e.$fH="accessibility.voice.keywordActivation"}),define(Ce[236],Ie([1,0,4,11,197]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usb=void 0;class M{constructor(){this.f=new Map,this.m=[],this.n=new w.$le,this.o=new w.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(N){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=N}onEvent(N){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=N}onRequest(N){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=N}sendResponse(N){N.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${N.command}`)):this.u("response",N)}sendRequest(N,p,c,R){const v={command:N};if(p&&Object.keys(p).length>0&&(v.arguments=p),this.u("request",v),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const E=this.f.get(v.seq);if(E){this.f.delete(v.seq);const d={type:"response",seq:0,request_seq:v.seq,success:!1,command:N,message:(0,P.localize)(0,null,R,N)};E(d)}},R)}return c&&this.f.set(v.seq,c),v.seq}acceptMessage(N){this.k?this.k(N):(this.m.push(N),this.m.length===1&&this.s())}q(N,p){return N.type!=="event"||p.type!=="event"}async s(){let N;for(;this.m.length;){if((!N||this.q(this.m[0],N))&&await(0,C.$Fh)(0),N=this.m.shift(),!N)return;switch(N.type){case"event":this.j?.(N);break;case"request":this.g?.(N);break;case"response":{const p=N,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(N,p){p.type=N,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const N=new Map;this.f.forEach((p,c)=>N.set(c,p)),await(0,C.$Fh)(500),N.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Usb=M}),define(Ce[81],Ie([1,0,2,198,32,3]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$wK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$uK=e.MemoryRangeType=e.State=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0,e.$tK=p,e.$vK=R,C=qe(C),e.$hJ="workbench.view.debug",e.$iJ="workbench.debug.variablesView",e.$jJ="workbench.debug.watchExpressionsView",e.$kJ="workbench.debug.callStackView",e.$lJ="workbench.debug.loadedScriptsView",e.$mJ="workbench.debug.breakPointsView",e.$nJ="workbench.debug.disassemblyView",e.$oJ="workbench.panel.repl",e.$pJ="workbench.panel.repl.view",e.$qJ=new P.$Vj("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$rJ=new P.$Vj("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$sJ=new P.$Vj("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$tJ="debugUx",e.$uJ=new P.$Vj(e.$tJ,"default",{type:"string",description:C.localize(3,null)}),e.$vJ=new P.$Vj("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$wJ=new P.$Vj("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$xJ=new P.$Vj("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$yJ=new P.$Vj("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$zJ=new P.$Vj("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$AJ=new P.$Vj("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$BJ=new P.$Vj("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$CJ=new P.$Vj("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$DJ=new P.$Vj("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$EJ=new P.$Vj("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$FJ=new P.$Vj("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$GJ=new P.$Vj("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$HJ=new P.$Vj("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$IJ=new P.$Vj("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$JJ=new P.$Vj("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$KJ=new P.$Vj("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$LJ=new P.$Vj("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$MJ=new P.$Vj("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$NJ=new P.$Vj("breakpointItemBytes",void 0,{type:"boolean",description:C.localize(22,null)}),e.$OJ=new P.$Vj("breakpointHasModes",!1,{type:"boolean",description:C.localize(23,null)}),e.$PJ=new P.$Vj("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(24,null)}),e.$QJ=new P.$Vj("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(25,null)}),e.$RJ=new P.$Vj("loadedScriptsItemType",void 0,{type:"string",description:C.localize(26,null)}),e.$SJ=new P.$Vj("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(27,null)}),e.$TJ=new P.$Vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:C.localize(28,null)}),e.$UJ=new P.$Vj("stepBackSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$VJ=new P.$Vj("restartFrameSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$WJ=new P.$Vj("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(31,null)}),e.$XJ=new P.$Vj("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(32,null)}),e.$YJ=new P.$Vj("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(33,null)}),e.$ZJ=new P.$Vj("breakpointsExist",!1,{type:"boolean",description:C.localize(34,null)}),e.$1J=new P.$Vj("debuggersAvailable",!1,{type:"boolean",description:C.localize(35,null)}),e.$2J=new P.$Vj("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(36,null)}),e.$3J=new P.$Vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(37,null)}),e.$4J=new P.$Vj("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$5J=new P.$Vj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$6J=new P.$Vj("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$7J=new P.$Vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$8J=new P.$Vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(42,null)}),e.$9J=new P.$Vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(43,null)}),e.$0J=new P.$Vj("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(44,null)}),e.$$J=new P.$Vj("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(45,null)}),e.$_J=new P.$Vj("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(46,null)}),e.$aK=new P.$Vj("variableIsReadonly",!1,{type:"boolean",description:C.localize(47,null)}),e.$bK=new P.$Vj("variableValue",!1,{type:"string",description:C.localize(48,null)}),e.$cK=new P.$Vj("variableType",!1,{type:"string",description:C.localize(49,null)}),e.$dK=new P.$Vj("variableInterfaces",!1,{type:"array",description:C.localize(50,null)}),e.$eK=new P.$Vj("variableName",!1,{type:"string",description:C.localize(51,null)}),e.$fK=new P.$Vj("variableLanguage",!1,{type:"string",description:C.localize(52,null)}),e.$gK=new P.$Vj("variableExtensionId",!1,{type:"string",description:C.localize(53,null)}),e.$hK=new P.$Vj("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(54,null)}),e.$iK=new P.$Vj("multiSessionRepl",!1,{type:"boolean",description:C.localize(55,null)}),e.$jK=new P.$Vj("multiSessionDebug",!1,{type:"boolean",description:C.localize(56,null)}),e.$kK=new P.$Vj("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(57,null)}),e.$lK=new P.$Vj("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(58,null)}),e.$mK=new P.$Vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(59,null)}),e.$nK=new P.$Vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(60,null)});const A=n=>C.localize(61,null,n);e.$oK=A,e.$pK="editor.contrib.debug",e.$qK="editor.contrib.breakpoint",e.$rK="debug",e.$sK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(62,null)};var N;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(N||(e.State=N={}));function p(n){switch(n){case N.Initializing:return"initializing";case N.Stopped:return"stopped";case N.Running:return"running";default:return"inactive"}}var c;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$uK="vscode-debug-memory";function R(n){const s=n.presentationHint??n.source.presentationHint;return s==="deemphasize"||s==="subtle"}var v;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var E;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$wK=(0,M.$Ei)("debugService");var d;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(n){n.deserialize=s=>s,n.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var h;(function(n){n.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:w.URI.revive(s.iconPath.light),dark:w.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),n.serialize=s=>s})(h||(e.IDebugVisualization=h={}))}),define(Ce[237],Ie([1,0,13,2,20,26,16,33,22,18]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2H=void 0,e.$PH=v,e.$QH=l,e.$RH=E,e.$SH=d,e.$TH=r,e.$UH=o,e.$VH=a,e.$WH=n,e.$XH=t,e.$YH=m,e.$ZH=u,e.$1H=I;const R=/{([^}]+)}/g;function v(y,S,k){return y.replace(R,function(g,b){return S&&b.length>0&&b[0]!=="_"?g:k&&k.hasOwnProperty(b)?k[b]:g})}function l(y){const S={};for(const k of Object.keys(y))k.startsWith("!")||(S[k]=y[k]);return S}function E(y){return y.configuration.request==="attach"&&!d(y)&&(!y.parentSession||E(y.parentSession))}function d(y){let S=y.configuration.type;if(S)return S==="vslsShare"&&(S=y.configuration.adapterProxy.configuration.type),(0,w.$Ff)(S,"extensionhost")||(0,w.$Ff)(S,"pwa-extensionhost")?y:y.parentSession?d(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function o(y,S,k){let g,b=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=F.exec(y);){const q=T.index+1,G=q+T[0].length;if(q<=S&&G>=k){g=T[0],b=q;break}}if(g){const q=/\w+/g;let G=null;for(;(G=q.exec(g))&&!(G.index+1+b+G[0].length>=k););G&&(g=g.substring(0,q.lastIndex))}return g?{start:b,end:b+g.length-1}:{start:0,end:0}}async function a(y,S,k,g){if(y.evaluatableExpressionProvider.has(S)){const b=y.evaluatableExpressionProvider.ordered(S),F=(0,c.$Ib)(await Promise.all(b.map(async T=>{try{return await T.provideEvaluatableExpression(S,k,g??p.CancellationToken.None)}catch{return}})));if(F.length>0){let T=F[0].expression;const q=F[0].range;return T||(T=S.getLineContent(k.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:T}}}else{const b=S.getLineContent(k.lineNumber),{start:F,end:T}=o(b,k.column,k.column),q=b.substring(F-1,T);return{matchingExpression:q,range:new N.$Ht(k.lineNumber,F,k.lineNumber,F+q.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(h))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return C.URI.parse(y.path);if((0,P.$jc)(y.path))return C.URI.file(y.path)}return y.path}function i(y){if(typeof y.path=="object"){const S=C.URI.revive(y.path);if(S)return S.scheme===A.Schemas.file?S.fsPath:S.toString()}return y.path}function t(y,S){const k=S?s:i,g=(0,M.$bo)(y);return f(g,(b,F)=>{b&&F&&(F.path=k(F))}),g}function m(y,S){const k=S?s:i,g=(0,M.$bo)(y);return f(g,(b,F)=>{!b&&F&&(F.path=k(F))}),g}function f(y,S){switch(y.type){case"event":{const k=y;switch(k.event){case"output":S(!1,k.body.source);break;case"loadedSource":S(!1,k.body.source);break;case"breakpoint":S(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=y;switch(k.command){case"setBreakpoints":S(!0,k.arguments.source);break;case"breakpointLocations":S(!0,k.arguments.source);break;case"source":S(!0,k.arguments.source);break;case"gotoTargets":S(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(g=>S(!1,g));break;default:break}break}case"response":{const k=y;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(g=>S(!1,g.source));break;case"loadedSources":k.body.sources.forEach(g=>S(!1,g));break;case"scopes":k.body.scopes.forEach(g=>S(!1,g.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(g=>S(!1,g.source));break;case"setBreakpoints":k.body.breakpoints.forEach(g=>S(!1,g.source));break;case"disassemble":k.body?.instructions.forEach(b=>S(!1,b.location));break;default:break}break}}}function u(y){return y.filter(S=>!S.presentation?.hidden).sort((S,k)=>S.presentation?k.presentation?S.presentation.group?k.presentation.group?S.presentation.group!==k.presentation.group?S.presentation.group.localeCompare(k.presentation.group):$(S.presentation.order,k.presentation.order):-1:k.presentation.group?1:$(S.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function $(y,S){return typeof y!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:y-S}async function I(y,S){const k=y.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(k!=="none"&&(await S.saveAll(),k==="allEditorsInActiveGroup")){const g=S.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await S.save({editor:g.input,groupId:g.group.id})}await y.reloadConfiguration()}const D=(y,S)=>!y||!S?y===S:y.name===S.name&&y.path===S.path&&y.sourceReference===S.sourceReference;e.$2H=D}),define(Ce[238],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.CellExecutionUpdateType=void 0;var C;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.$OK=(0,w.$Ei)("INotebookExecutionService")}),define(Ce[239],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jb=e.$9jb=e.ProxyKernelState=e.$8jb=void 0,e.$8jb=100;var C;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(C||(e.ProxyKernelState=C={})),e.$9jb=(0,w.$Ei)("INotebookKernelService"),e.$0jb=(0,w.$Ei)("INotebookKernelHistoryService")}),define(Ce[240],Ie([1,0,5,33,52,166,102]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wYb=void 0;class N extends w.$Vc{constructor(c,R,v){super(),this._source=c,this.b=R,this.c=v,this.a=void 0}f(c){const R=c.getLineCount();return new C.$Ht(1,1,R,this.g(c,R))}g(c,R){if(R<1||R>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const c=new M.$iD;c.acceptChunk(this._source);const R=c.finish(!0),{textBuffer:v,disposable:l}=R.create(P.DefaultEndOfLine.LF);this.b=v,this.B(l)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const R=new M.$iD;R.acceptChunk(c);const v=R.finish(!0),{textBuffer:l,disposable:E}=v.create(P.DefaultEndOfLine.LF);return this.B(E),l})),this.a}findInInputs(c){const v=new A.$9C(c,!1,!1,null).parseSearchRequest();if(!v)return[];const l=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(l,v,!0,5e3)}findInOutputs(c){const v=new A.$9C(c,!1,!1,null).parseSearchRequest();return v?this.outputTextBuffers.map(l=>{const E=l.findMatchesLineByLine(this.f(l),v,!0,5e3);if(E.length!==0)return{textBuffer:l,matches:E}}).filter(l=>!!l):[]}}e.$wYb=N}),define(Ce[55],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(M){M.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class P{static fromExtHostTestItem(A,N,p=A.parent){if(A._isRoot)return new P([N]);const c=[A.id];for(let R=p;R&&R.id!==N;R=R.parent)c.push(R.id);return c.push(N),new P(c.reverse())}static isRoot(A){return!A.includes(w.Delimiter)}static root(A){const N=A.indexOf(w.Delimiter);return N===-1?A:A.slice(0,N)}static fromString(A){return new P(A.split(w.Delimiter))}static join(A,N){return new P([...A.path,N])}static joinToString(A,N){return A.toString()+w.Delimiter+N}static parentId(A){const N=A.lastIndexOf(w.Delimiter);return N===-1?void 0:A.slice(0,N)}static localId(A){const N=A.lastIndexOf(w.Delimiter);return N===-1?A:A.slice(N+w.Delimiter.length)}static isChild(A,N){return N.startsWith(A)&&N[A.length]===w.Delimiter}static compare(A,N){return A===N?C.IsSame:P.isChild(A,N)?C.IsChild:P.isChild(N,A)?C.IsParent:C.Disconnected}static getLengthOfCommonPrefix(A,N){if(A===0)return 0;let p=0;for(;p<A-1;){for(let c=1;c<A;c++){const R=N(c-1),v=N(c);if(R.path[p]!==v.path[p])return p}p++}return p}constructor(A,N=A.length){if(this.path=A,this.d=N,A.length===0||N<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let N=0;N<A.d&&N<this.d;N++)if(A.path[N]!==this.path[N])return C.Disconnected;return A.d>this.d?C.IsChild:A.d<this.d?C.IsParent:C.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=w.Delimiter,this.c+=this.path[A]}return this.c}}e.$OI=P}),define(Ce[56],Ie([1,0,2,101,33,55]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$WI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$VI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$UI=e.$TI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$SI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$RI=e.$QI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$PI=e.TestResultState=void 0;var A;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$PI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var N;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(N||(e.ExtTestRunProfileKind=N={}));var p;(function(V){V[V.Run=2]="Run",V[V.Debug=4]="Debug",V[V.Coverage=8]="Coverage",V[V.HasNonDefaultProfile=16]="HasNonDefaultProfile",V[V.HasConfigurable=32]="HasConfigurable",V[V.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$QI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const c=V=>"runId"in V;e.$RI=c;var R;(function(V){V.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),V.deserialize=(O,W)=>({range:P.$Ht.lift(W.range),uri:O.asCanonicalUri(w.URI.revive(W.uri))})})(R||(e.IRichLocation=R={}));var v;(function(V){V[V.Error=0]="Error",V[V.Output=1]="Output"})(v||(e.TestMessageType=v={}));var l;(function(V){V.serialize=O=>({message:O.message,type:v.Error,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&R.serialize(O.location)}),V.deserialize=(O,W)=>({message:W.message,type:v.Error,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&R.deserialize(O,W.location)})})(l||(e.ITestErrorMessage=l={}));const E=(V,O)=>`${O?"s":"e"}${V}`;e.$SI=E;var d;(function(V){V.serialize=O=>({message:O.message,type:v.Output,offset:O.offset,length:O.length,location:O.location&&R.serialize(O.location)}),V.deserialize=(O,W)=>({message:W.message,type:v.Output,offset:W.offset,length:W.length,location:W.location&&R.deserialize(O,W.location)})})(d||(e.ITestOutputMessage=d={}));var r;(function(V){V.serialize=O=>O.type===v.Error?l.serialize(O):d.serialize(O),V.deserialize=(O,W)=>W.type===v.Error?l.deserialize(O,W):d.deserialize(O,W)})(r||(e.ITestMessage=r={}));var o;(function(V){V.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),V.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(r.serialize)}),V.deserialize=(O,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(ce=>r.deserialize(O,ce))})})(o||(e.ITestTaskState=o={}));const a="\0",h=(V,O)=>V+a+O;e.$TI=h;const n=V=>{const O=V.indexOf(a);return{ctrlId:V.slice(0,O),tagId:V.slice(O+1)}};e.$UI=n;var s;(function(V){V.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),V.deserialize=(O,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?O.asCanonicalUri(w.URI.revive(W.uri)):void 0,range:W.range?P.$Ht.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(s||(e.ITestItem=s={}));var i;(function(V){V[V.NotExpandable=0]="NotExpandable",V[V.Expandable=1]="Expandable",V[V.BusyExpanding=2]="BusyExpanding",V[V.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(V){V.serialize=O=>({expand:O.expand,item:s.serialize(O.item)}),V.deserialize=(O,W)=>({controllerId:M.$OI.root(W.item.extId),expand:W.expand,item:s.deserialize(O,W.item)})})(t||(e.InternalTestItem=t={}));var m;(function(V){V.serialize=O=>{let W;return O.item&&(W={},O.item.label!==void 0&&(W.label=O.item.label),O.item.tags!==void 0&&(W.tags=O.item.tags),O.item.busy!==void 0&&(W.busy=O.item.busy),O.item.uri!==void 0&&(W.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(W.range=O.item.range?.toJSON()),O.item.description!==void 0&&(W.description=O.item.description),O.item.error!==void 0&&(W.error=O.item.error),O.item.sortText!==void 0&&(W.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:W}},V.deserialize=O=>{let W;return O.item&&(W={},O.item.label!==void 0&&(W.label=O.item.label),O.item.tags!==void 0&&(W.tags=O.item.tags),O.item.busy!==void 0&&(W.busy=O.item.busy),O.item.range!==void 0&&(W.range=O.item.range?P.$Ht.lift(O.item.range):null),O.item.description!==void 0&&(W.description=O.item.description),O.item.error!==void 0&&(W.error=O.item.error),O.item.sortText!==void 0&&(W.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:W}}})(m||(e.ITestItemUpdate=m={}));const f=(V,O)=>{O.expand!==void 0&&(V.expand=O.expand),O.item!==void 0&&(V.item=V.item?Object.assign(V.item,O.item):O.item)};e.$VI=f;var u;(function(V){V.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(o.serializeWithoutMessages)}),V.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(o.serialize)}),V.deserialize=(O,W)=>({...t.deserialize(O,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(ce=>o.deserialize(O,ce)),retired:!0})})(u||(e.TestResultItem=u={}));var $;(function(V){V.empty=()=>({covered:0,total:0}),V.sum=(O,W)=>{O.covered+=W.covered,O.total+=W.total}})($||(e.ICoverageCount=$={}));var I;(function(V){V.serialize=O=>({id:O.id,statement:O.statement,branch:O.branch,declaration:O.declaration,testId:O.testId?.toString(),uri:O.uri.toJSON()}),V.deserialize=(O,W)=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,testId:W.testId?M.$OI.fromString(W.testId):void 0,uri:O.asCanonicalUri(w.URI.revive(W.uri))}),V.empty=(O,W)=>({id:O,uri:W,testId:void 0,statement:$.empty()})})(I||(e.IFileCoverage=I={}));function D(V){return{...V,location:V.location?.toJSON()}}function y(V){return V.location=V.location?C.$Gt.isIPosition(V.location)?C.$Gt.lift(V.location):P.$Ht.lift(V.location):void 0,V}e.$WI=3;var S;(function(V){V[V.Declaration=0]="Declaration",V[V.Statement=1]="Statement",V[V.Branch=2]="Branch"})(S||(e.DetailType=S={}));var k;(function(V){V.serialize=O=>O.type===S.Declaration?b.serialize(O):F.serialize(O),V.deserialize=O=>O.type===S.Declaration?b.deserialize(O):F.deserialize(O)})(k||(e.CoverageDetails=k={}));var g;(function(V){V.serialize=D,V.deserialize=y})(g||(e.IBranchCoverage=g={}));var b;(function(V){V.serialize=D,V.deserialize=y})(b||(e.IDeclarationCoverage=b={}));var F;(function(V){V.serialize=O=>({...D(O),branches:O.branches?.map(g.serialize)}),V.deserialize=O=>({...y(O),branches:O.branches?.map(g.deserialize)})})(F||(e.IStatementCoverage=F={}));var T;(function(V){V[V.Add=0]="Add",V[V.Update=1]="Update",V[V.DocumentSynced=2]="DocumentSynced",V[V.Remove=3]="Remove",V[V.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",V[V.Retire=5]="Retire",V[V.AddTag=6]="AddTag",V[V.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var q;(function(V){V.deserialize=(O,W)=>W.op===T.Add?{op:W.op,item:t.deserialize(O,W.item)}:W.op===T.Update?{op:W.op,item:m.deserialize(W.item)}:W.op===T.DocumentSynced?{op:W.op,uri:O.asCanonicalUri(w.URI.revive(W.uri)),docv:W.docv}:W,V.serialize=O=>O.op===T.Add?{op:O.op,item:t.serialize(O.item)}:O.op===T.Update?{op:O.op,item:m.serialize(O.item)}:O})(q||(e.TestsDiffOp=q={}));class G{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const W=this.w();for(const ce of O)switch(ce.op){case T.Add:this.l(t.deserialize(this.k,ce.item),W);break;case T.Update:this.p(m.deserialize(ce.item),W);break;case T.Remove:this.q(ce.itemId,W);break;case T.Retire:this.v(ce.itemId);break;case T.IncrementPendingExtHosts:this.updatePendingRoots(ce.amount);break;case T.AddTag:this.c.set(ce.tag.id,ce.tag);break;case T.RemoveTag:this.c.delete(ce.id);break}W.complete?.()}l(O,W){const ce=M.$OI.parentId(O.item.extId)?.toString();let ge;if(!ce)ge=this.x(O),this.g.add(ge),this.f.set(O.item.extId,ge);else if(this.f.has(ce)){const te=this.f.get(ce);te.children.add(O.item.extId),ge=this.x(O,te),this.f.set(O.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return W.add?.(ge),O.expand===i.BusyExpanding&&this.h++,ge}p(O,W){const ce=this.f.get(O.extId);if(ce)return O.expand!==void 0&&(ce.expand===i.BusyExpanding&&this.h--,O.expand===i.BusyExpanding&&this.h++),(0,e.$VI)(ce,O),W.update?.(ce),ce}q(O,W){const ce=this.f.get(O);if(!ce)return;const ge=M.$OI.parentId(ce.item.extId)?.toString();ge?this.f.get(ge).children.delete(ce.item.extId):this.g.delete(ce);const te=[[O]];for(;te.length;)for(const me of te.pop()){const se=this.f.get(me);se&&(te.push(se.children),this.f.delete(me),W.remove?.(se,se!==ce),se.expand===i.BusyExpanding&&this.h--)}}v(O){}updatePendingRoots(O){this.j+=O}w(){return{}}}e.$XI=G}),define(Ce[241],Ie([1,0,99,201,56]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$uFb=e.$tFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var M;(function(v){v.ViewletId="workbench.view.extension.test",v.ExplorerViewId="workbench.view.testing",v.OutputPeekContributionId="editor.contrib.testingOutputPeek",v.DecorationsContributionId="editor.contrib.testingDecorations",v.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",v.CoverageViewId="workbench.view.testCoverage",v.ResultsPanelId="workbench.panel.testResults",v.ResultsViewId="workbench.panel.testResults.view",v.MessageLanguageId="vscodeInternalTestMessage"})(M||(e.Testing=M={}));var A;(function(v){v.List="list",v.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var N;(function(v){v.ByLocation="location",v.ByStatus="status",v.ByDuration="duration"})(N||(e.TestExplorerViewSorting=N={}));const p={[P.TestResultState.Errored]:(0,C.localize)(0,null),[P.TestResultState.Failed]:(0,C.localize)(1,null),[P.TestResultState.Passed]:(0,C.localize)(2,null),[P.TestResultState.Queued]:(0,C.localize)(3,null),[P.TestResultState.Running]:(0,C.localize)(4,null),[P.TestResultState.Skipped]:(0,C.localize)(5,null),[P.TestResultState.Unset]:(0,C.localize)(6,null)},c=(v,l)=>(0,C.localize)(7,null,(0,w.$Xk)(v),p[l]);e.$tFb=c,e.$uFb={[P.TestRunProfileBitset.Debug]:(0,C.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,C.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,C.localize)(10,null)};var R;(function(v){v.CancelTestRefreshAction="testing.cancelTestRefresh",v.CancelTestRunAction="testing.cancelRun",v.ClearTestResultsAction="testing.clearTestResults",v.CollapseAllAction="testing.collapseAll",v.ConfigureTestProfilesAction="testing.configureProfile",v.ContinousRunUsingForTest="testing.continuousRunUsingForTest",v.CoverageAtCursor="testing.coverageAtCursor",v.CoverageByUri="testing.coverage.uri",v.CoverageClear="testing.coverage.close",v.CoverageCurrentFile="testing.coverageCurrentFile",v.CoverageFilterToTest="testing.coverageFilterToTest",v.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",v.CoverageLastRun="testing.coverageLastRun",v.CoverageSelectedAction="testing.coverageSelected",v.CoverageToggleToolbar="testing.coverageToggleToolbar",v.CoverageViewChangeSorting="testing.coverageViewChangeSorting",v.DebugAction="testing.debug",v.DebugAllAction="testing.debugAll",v.DebugAtCursor="testing.debugAtCursor",v.DebugByUri="testing.debug.uri",v.DebugCurrentFile="testing.debugCurrentFile",v.DebugFailedTests="testing.debugFailTests",v.DebugLastRun="testing.debugLastRun",v.DebugSelectedAction="testing.debugSelected",v.FilterAction="workbench.actions.treeView.testExplorer.filter",v.GetExplorerSelection="_testing.getExplorerSelection",v.GetSelectedProfiles="testing.getSelectedProfiles",v.GoToTest="testing.editFocusedTest",v.HideTestAction="testing.hideTest",v.OpenCoverage="testing.openCoverage",v.OpenOutputPeek="testing.openOutputPeek",v.RefreshTestsAction="testing.refreshTests",v.ReRunFailedTests="testing.reRunFailTests",v.ReRunLastRun="testing.reRunLastRun",v.RunAction="testing.run",v.RunAllAction="testing.runAll",v.RunAllWithCoverageAction="testing.coverageAll",v.RunAtCursor="testing.runAtCursor",v.RunByUri="testing.run.uri",v.RunCurrentFile="testing.runCurrentFile",v.RunSelectedAction="testing.runSelected",v.RunUsingProfileAction="testing.runUsing",v.RunWithCoverageAction="testing.coverage",v.SearchForTestExtension="testing.searchForTestExtension",v.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",v.ShowMostRecentOutputAction="testing.showMostRecentOutput",v.StartContinousRun="testing.startContinuousRun",v.StopContinousRun="testing.stopContinuousRun",v.TestingSortByDurationAction="testing.sortByDuration",v.TestingSortByLocationAction="testing.sortByLocation",v.TestingSortByStatusAction="testing.sortByStatus",v.TestingViewAsListAction="testing.viewAsList",v.TestingViewAsTreeAction="testing.viewAsTree",v.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",v.ToggleInlineTestOutput="testing.toggleInlineTestOutput",v.UnhideAllTestsAction="testing.unhideAllTests",v.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Ce[82],Ie([1,0,11,4,5,62,56,55]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(h,n)=>h===n,v=Object.entries({range:(h,n)=>h===n?!0:!h||!n?!1:h.equalsRange(n),busy:c,label:c,description:c,error:c,sortText:c,tags:(h,n)=>!(h.length!==n.length||h.some(s=>!n.includes(s)))}),l=(h,n)=>{let s;for(const[i,t]of v)t(h[i],n[i])||(s?s[i]=n[i]:s={[i]:n[i]});return s};class E extends P.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new w.$Qh(()=>this.flushDiff(),200)),this.g=this.B(new C.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===n.uri){s.docv=n.docv;return}break}case A.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===n.item.extId){(0,A.$VI)(s.item,n.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===n.item.extId){(0,A.$VI)(s.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,s){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||s>i.expandLevels)&&(i.expandLevels=s),i.expand===A.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,s-1):t.wait().then(()=>this.L(i,s-1))}else if(i.expand===A.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,s-1)):this.L(i,s-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,s){switch(s.op){case p.RemoveChild:this.O(N.$OI.joinToString(n.fullId,s.id));break;case p.Upsert:this.z(s.item,n);break;case p.Bulk:for(const i of s.ops)this.w(n,i);break;case p.SetTags:this.C(s.new,s.old,n.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(n);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:s.update}});break;case p.DocumentSynced:this.y(n.actual.uri);break;default:(0,M.$fd)(s)}}y(n){n&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,s){const i=N.$OI.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(n.id);let m=this.tree.get(i.toString());if(!m){m={fullId:i,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(m.fullId.toString(),m),this.G(n,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:m.expand,item:this.s.toITestItem(n)}}),this.I(n,m,s);return}if(m.actual===n){this.H(n,m,s);return}if(m.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,s);const f=this.s.getChildren(m.actual),u=m.actual,$=l(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,m.actual=n,m.resolveBarrier=void 0,m.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,i.toString()),delete $.tags),this.w(m,{op:p.SetProp,update:$})),this.I(n,m,s);for(const[D,y]of f)this.s.getChildren(n).get(y.id)||this.O(N.$OI.joinToString(i,y.id));const I=m.expandLevels;I!==void 0&&queueMicrotask(()=>{m.expand===A.TestItemExpandState.Expandable&&(m.expandLevels=void 0,this.expand(i.toString(),I))}),this.y(m.actual.uri)}C(n,s,i){const t=new Set(s.map(m=>m.id));for(const m of n)t.delete(m.id)||this.D(m);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(m=>(0,A.$TI)(this.s.controllerId,m.id))}}}),t.forEach(this.F,this)}D(n){const s=this.j.get(n.id);s?s.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$TI)(this.s.controllerId,n.id)}}))}F(n){const s=this.j.get(n);s&&!--s.refCount&&(this.j.delete(n),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$TI)(this.s.controllerId,n)}))}G(n,s){this.s.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}H(n,s,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=m=>this.w(s,m),this.J(s)}I(n,s,i){this.H(n,s,i);for(const[t,m]of this.s.getChildren(n))this.z(m,s)}J(n){let s;this.h?n.resolveBarrier?s=n.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=n.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==n.expand&&(n.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,s){if(s<0)return;const i=[];for(const[t,m]of this.s.getChildren(n.actual)){const f=this.expand(N.$OI.joinToString(n.fullId,m.id),s);(0,w.$qh)(f)&&i.push(f)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const m=new w.$Dh;return m.open(),m}n.expand=A.TestItemExpandState.BusyExpanding,this.N(n);const s=n.resolveBarrier=new w.$Dh,i=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,m)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(m){i(m)}return(0,w.$qh)(t)?t.catch(i).then(()=>{s.open(),this.J(n)}):(s.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:n});const i=[s];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const m of t.actual.tags)this.F(m.id);this.tree.delete(t.fullId.toString());for(const[m,f]of this.s.getChildren(t.actual))i.push(this.tree.get(N.$OI.joinToString(t.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$kP=E;class d extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$lP=d;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$mP=r;class o extends Error{constructor(n,s,i){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${i}".`)}}e.$nP=o;const a=(h,n,s)=>{let i=new Map;return{get size(){return i.size},forEach(t,m){for(const f of i.values())t.call(m,f,this)},[Symbol.iterator](){return i.entries()},replace(t){const m=new Map,f=new Set(i.keys()),u={op:p.Bulk,ops:[]};for(const $ of t){if(!($ instanceof s))throw new r($.id);const I=n($).controllerId;if(I!==h.controllerId)throw new o($.id,I,h.controllerId);if(m.has($.id))throw new d($.id);m.set($.id,$),f.delete($.id),u.ops.push({op:p.Upsert,item:$})}for(const $ of f.keys())u.ops.push({op:p.RemoveChild,id:$});h.listener?.(u),i=m},add(t){if(!(t instanceof s))throw new r(t.id);i.set(t.id,t),h.listener?.({op:p.Upsert,item:t})},delete(t){i.delete(t)&&h.listener?.({op:p.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$oP=a}),define(Ce[115],Ie([1,0,82]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=void 0;const C=new WeakMap,P=(A,N)=>{const p={controllerId:N};return C.set(A,p),p};e.$pP=P;const M=A=>{const N=C.get(A);if(!N)throw new w.$mP(A?.id||"<unknown>");return N};e.$qP=M}),define(Ce[83],Ie([1,0,28,16,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jCb=e.$iCb=e.$hCb=void 0,e.$kCb=M,e.$lCb=N,e.$hCb="vscode-cdn.net",e.$iCb=`vscode-resource.${e.$hCb}`,e.$jCb=`'self' https://*.${e.$hCb}`;function M(p,c){return p.scheme===C.Schemas.http||p.scheme===C.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===C.Schemas.file&&(p=P.URI.from({scheme:C.Schemas.vscodeRemote,authority:c.authority,path:p.path})),P.URI.from({scheme:C.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$iCb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,c=>{const R=c.charCodeAt(0);return R>=w.CharCode.a&&R<=w.CharCode.z||R>=w.CharCode.A&&R<=w.CharCode.Z||R>=w.CharCode.Digit0&&R<=w.CharCode.Digit9?c:"-"+R.toString(16).padStart(4,"0")})}function N(p){return p.replace(/-([0-9a-f]{4})/g,(c,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Ce[242],Ie([1,0,4,5,83]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class M{constructor(N,p,c){this.d=N,this.e=p,this.f=c,this.a=0,this.b=new C.$Uc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const v of this.c.values())R.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this.c.forEach(N=>N.inset.dispose()),this.b.dispose()}createWebviewEditorInset(N,p,c,R,v){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===N){l=n;break}if(!l)throw new Error("not a visible editor");const E=this,d=this.a++,r=new w.$le,o=new w.$le,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$kCb)(n,E.f)}get cspSource(){return P.$jCb}set options(n){this.b=n,E.d.$setOptions(d,n)}get options(){return this.b}set html(n){this.a=n,E.d.$setHtml(d,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return E.d.$postMessage(d,n)}},h=new class{constructor(){this.editor=N,this.line=p,this.height=c,this.webview=a,this.onDidDispose=o.event}dispose(){E.c.has(d)&&(E.c.delete(d),E.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,l.id,l.value.document.uri,p+1,c,R||{},v.identifier,v.extensionLocation),this.c.set(d,{editor:N,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(N){const p=this.c.get(N);p&&p.inset.dispose()}$onDidReceiveMessage(N,p){this.c.get(N)?.onDidReceiveMessage.fire(p)}}e.$rnc=M}),define(Ce[116],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=e.$3L=void 0,e.$3L="__",e.$4L=(0,w.$Ei)("IAuthenticationService"),e.$5L=(0,w.$Ei)("IAuthenticationExtensionsService")}),define(Ce[243],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.VariableKind=e.$iQ=void 0,e.$iQ=(0,w.$Ei)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator",M.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class P extends Error{constructor(A,N){super(N),this.variable=A}}e.$jQ=P}),define(Ce[244],Ie([1,0,20,79,15,26,21,103,202,243,13]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0,w=qe(w),C=qe(C),P=qe(P),M=qe(M);class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,d,r,o){this.h=new Map,this.a=E,this.b=d,this.g=r,o&&(this.c=o.then(a=>this.i(a)))}i(E){if(A.$i){const d=Object.create(null);return Object.keys(E).forEach(r=>{d[r.toLowerCase()]=E[r]}),d}return E}resolveWithEnvironment(E,d,r){return this.l({env:this.i(E),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(E,d){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,d)}async j(E,d,r,o){const a=M.$bo(d);A.$i&&a.windows?Object.keys(a.windows).forEach(n=>a[n]=a.windows[n]):A.$j&&a.osx?Object.keys(a.osx).forEach(n=>a[n]=a.osx[n]):A.$k&&a.linux&&Object.keys(a.linux).forEach(n=>a[n]=a.linux[n]),delete a.windows,delete a.osx,delete a.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,a,r,o)}async resolveAnyAsync(E,d,r){return this.j(E,d,r)}async resolveAnyMap(E,d,r){const o=new Map;return{newConfig:await this.j(E,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(E,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,d){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,d)}async l(E,d,r,o,a){if(P.$eg(r))return this.m(E,d,r,o,a);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(E,d,h,o,a)));if(P.$gg(r)){const h=Object.create(null),n=await Promise.all(Object.keys(r).map(async s=>[await this.m(E,d,s,o,a),await this.l(E,d,r[s],o,a)]));for(const[s,i]of n)h[s]=i;return h}return r}m(E,d,r,o,a){return(0,R.$xf)(r,v.VARIABLE_REGEXP,async(h,n)=>{if(n.includes(v.VARIABLE_LHS))return h;let s=await this.o(E,h,n,d,o);return a?.set(n,s),s!==h&&P.$eg(s)&&s.match(v.VARIABLE_REGEXP)&&(s=await this.m(E,d,s,o,a)),s})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,d,r,o,a){let h;const n=r.split(":");n.length>1&&(r=n[0],h=n[1]);const s=m=>{const f=this.a.getFilePath();if(f)return(0,N.$Sw)(f);throw new c.$jQ(m,(0,p.localize)(0,null,d))},i=m=>{const f=s(m);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,N.$Sw)(u)}throw new c.$jQ(m,(0,p.localize)(1,null,d,w.$oc(f)))},t=m=>{if(h){const f=this.a.getFolderUri(h);if(f)return f;throw new c.$jQ(m,(0,p.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new c.$jQ(m,(0,p.localize)(3,null,d)):new c.$jQ(m,(0,p.localize)(4,null,d))};switch(r){case"env":if(h){if(E.env){const m=E.env[A.$i?h.toLowerCase():h];if(P.$eg(m))return m}return""}throw new c.$jQ(c.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const m=this.a.getConfigurationValue(o,h);if(P.$ng(m))throw new c.$jQ(c.VariableKind.Config,(0,p.localize)(6,null,d,h));if(P.$gg(m))throw new c.$jQ(c.VariableKind.Config,(0,p.localize)(7,null,d,h));return m}throw new c.$jQ(c.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(c.VariableKind.Command,d,h,a,"command");case"input":return this.p(c.VariableKind.Input,d,h,a,"input");case"extensionInstallFolder":if(h){const m=await this.a.getExtension(h);if(!m)throw new c.$jQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(m.extensionLocation)}throw new c.$jQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,N.$Sw)(this.n(t(c.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,N.$Sw)(this.n(t(c.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,N.$Sw)(w.$oc(this.n(t(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new c.$jQ(c.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const m=this.a.getLineNumber();if(m)return m;throw new c.$jQ(c.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const m=this.a.getSelectedText();if(m)return m;throw new c.$jQ(c.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return i(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return w.$oc(i(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?w.$mc(this.n(t(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const m=w.$nc(s(c.VariableKind.RelativeFileDirname));if(o||h){const f=w.$mc(this.n(t(c.VariableKind.RelativeFileDirname)),m);return f.length===0?".":f}return m}case"fileDirname":return w.$nc(s(c.VariableKind.FileDirname));case"fileExtname":return w.$pc(s(c.VariableKind.FileExtname));case"fileBasename":return w.$oc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const m=w.$oc(s(c.VariableKind.FileBasenameNoExtension));return m.slice(0,m.length-w.$pc(m).length)}case"fileDirnameBasename":return w.$oc(w.$nc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const m=this.a.getExecPath();return m||d}case"execInstallFolder":{const m=this.a.getAppRoot();return m||d}case"pathSeparator":case"/":return w.sep;default:try{const m=h?`${r}:${h}`:r;return this.p(c.VariableKind.Unknown,d,m,a,void 0)}catch{return d}}}}p(E,d,r,o,a){if(r&&o){const h=a===void 0?o[r]:o[a+":"+r];if(typeof h=="string")return h;throw new c.$jQ(E,(0,p.localize)(14,null,d))}return d}}e.$yQ=v}),define(Ce[117],Ie([1,0,3,114]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$fE=void 0,e.$gE=c,e.$hE=l,e.$iE=E,e.$fE=(0,w.$Ei)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var N;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(N||(e.GroupsArrangement=N={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(d){const r=d;return(0,C.$4F)(r?.editor)&&(0,C.$4F)(r?.replacement)}var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var v;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function l(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ce[245],Ie([1,0,3,117]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.$jE=void 0,e.$nE=P,e.$jE=(0,w.$Ei)("editorService"),e.$kE=-1,e.$lE=-2,e.$mE=-3;function P(M){const A=M;return typeof M=="number"||(0,C.$hE)(A)}}),define(Ce[246],Ie([1,0,3,106]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0,e.$lM=(0,w.$Fi)(C.$Li)}),define(Ce[118],Ie([1,0,19,4,20,5,11]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=e.$Ebc=e.$Dbc=void 0,P=qe(P);class N{constructor(h,n){this.versionId=h,this.removedDueToLooping=n}}e.$Dbc=N;class p{static isHostExtension(h,n,s){if(n.getExtensionDescription(h))return!1;const i=s.getExtensionDescription(h);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(h,n){this.j=h,this.c=new C.$le,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new w.$rn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const n=this.j.readActivationEvents(h);for(const s of n)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,n){this.e=o(this.e,n),this.e=this.e.concat(h);const s=p.l(this.e);return this.e=o(this.e,s.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new N(this.d,s)}static l(h){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,u){this.addNode(f),this.addNode(u),this.c.has(f)?this.c.get(f).push(u):this.c.set(f,[u])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,u){const $=n.getArcs(f);for(let I=0;I<$.length;I++)if(!u.has($[I]))return!1;return!0}getNodes(){return this.e}},s=new w.$rn;for(const f of h)if(s.set(f.identifier,f),f.extensionDependencies)for(const u of f.extensionDependencies)n.addArc(w.$pn.toKey(f.identifier),w.$pn.toKey(u));const i=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>i.add(f));const t=n.getNodes().filter(f=>!i.has(f));let m;do{m=!1;for(let f=0;f<t.length;f++){const u=t[f];n.hasOnlyGoodArcs(u,i)&&(t.splice(f,1),f--,i.add(u),m=!0)}}while(m);return t.map(f=>s.get(f))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const n=this.h.get(h);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const n=this.f.get(h);return n||void 0}getExtensionDescriptionByUUID(h){for(const n of this.g)if(n.uuid===h)return n}getExtensionDescriptionByIdOrUUID(h,n){return this.getExtensionDescription(h)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Ebc=p;class c{constructor(h,n){this.versionId=h,this.extensions=n}}e.$Fbc=c;class R{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const n=await this.d.acquire(h);return new v(this,n)}deltaExtensions(h,n,s){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,s)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,n){return this.c.getExtensionDescriptionByIdOrUUID(h,n)}}e.$Gbc=R;class v extends M.$Vc{constructor(h,n){super(),this.f=h,this.c=!1,this.B(n)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Hbc=v;class l{constructor(h){this.name=h;const n=(0,A.$xh)();this.promise=n.promise,this.c=n.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const n=new l(h);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let n=!0;const s=setTimeout(()=>{n&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(s),n=!1,this.d=!1,this.e())};h.resolve((0,M.$Tc)(i))}}var d;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(d||(d={}));function r(a,h){const n=a.isBuiltin?d.Builtin:a.isUnderDevelopment?d.Dev:d.User,s=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(n!==s)return n-s;const i=P.$hc.basename(a.extensionLocation.path),t=P.$hc.basename(h.extensionLocation.path);return i<t?-1:i>t?1:0}function o(a,h){const n=new w.$qn(h);return a.filter(s=>!n.has(s.identifier))}}),define(Ce[84],Ie([1,0,23]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$xn=A,e.$yn=N;var C;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(C||(e.UIKind=C={}));var P;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(c){const R=w.$Ne.alloc(1);switch(c){case M.Initialized:R.writeUInt8(1,0);break;case M.Ready:R.writeUInt8(2,0);break;case M.Terminate:R.writeUInt8(3,0);break}return R}function N(c,R){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return R===M.Initialized;case 2:return R===M.Ready;case 3:return R===M.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[67],Ie([1,0,3,4,112,12,27,84,63,64,26,2,5,187]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.$MP=e.$LP=void 0,e.$NP=o;let d=class extends l.$Vc{constructor(h,n){super(),this.s=h,this.t=n,this.a=this.B(new C.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:c.$xp,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(s=>{(0,M.$ak)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(h,n,s){const i=this.getTelemetryDetails(),t=new r(n,s,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),m=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...m,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(h,n,s){this.f=h,this.g=n,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const n=Object.create(null);switch(n["common.extname"]=`${h.publisher}.${h.name}`,n["common.extversion"]=h.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$gn)((0,c.$Dp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const n=this.getTelemetryDetails();this.r.forEach((s,i)=>{const t=s.filter(m=>!m.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(s=>{for(const i of s)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,n){const i=this.r.get(h.value)?.filter(m=>!m.isDisposed);if(!i)return this.r.delete(h.value),!1;let t=!1;for(const m of i)m.ignoreUnhandledExtHostErrors||(m.logError(n),t=!0);return t}};e.$LP=d,e.$LP=d=He([We(0,A.$KP),We(1,M.$_j)],d);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,n,s,i,t,m,f){this.g=s,this.h=i,this.i=t,this.j=m,this.a=new C.$le,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(h,n){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let n="properties"in h?h.properties??{}:h;return n=(0,c.$Gp)(n,[]),this.c&&(n=(0,R.$eo)(n,this.c)),this.b||(n=(0,R.$eo)(n,this.j)),"properties"in h?h.properties=n:h=n,h}k(h,n){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(h,n),this.h.trace(h,n))}logUsage(h,n){this.d.isUsageEnabled&&this.k(h,n)}logError(h,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,n);else{const s={name:h.name,message:h.message,stack:h.stack,cause:h.cause},i=(0,c.$Gp)(s,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const h=this,n={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$MP=r;function o(a){const h=Date.now()-new Date(a).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$OP=(0,w.$Ei)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,218,111,19,3]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.ActivationKind=e.$6G=e.$5G=e.$2G=e.ExtensionHostStartup=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$3G=l,e.$4G=E,e.$7G=a,e.$8G=h,e.$XG=Object.freeze({identifier:new A.$pn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$YG="extensions.webWorker",e.$ZG=(0,N.$Ei)("extensionService");class p{constructor(i){this.dependency=i}}e.$1G=p;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,m){this.c=i,this.d=t.slice(0),this.e=m.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$IG.createActivationEventsMap(this.d)}}set(i,t,m){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const f=[],u=[],$=[],I=[],D=v(this.d),y=v(t),S=(T,q)=>T.extensionLocation.toString()===q.extensionLocation.toString()||T.isBuiltin===q.isBuiltin||T.isUserBuiltin===q.isUserBuiltin||T.isUnderDevelopment===q.isUnderDevelopment;for(const T of this.d){const q=y.get(T.identifier);if(!q){f.push(T.identifier),D.delete(T.identifier);continue}if(!S(T,q)){f.push(T.identifier),D.delete(T.identifier);continue}}for(const T of t){const q=D.get(T.identifier);if(!q){u.push(T);continue}if(!S(q,T)){f.push(q.identifier),D.delete(q.identifier);continue}}const k=new A.$qn(this.e),g=new A.$qn(m);for(const T of this.e)g.has(T)||$.push(T);for(const T of m)k.has(T)||I.push(T);const b=M.$IG.createActivationEventsMap(u),F={versionId:i,toRemove:f,toAdd:u,addActivationEvents:b,myToRemove:$,myToAdd:I};return this.delta(F),F}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:m,myToRemove:f,myToAdd:u}=i,$=new A.$qn(t),I=new A.$qn(f);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)I.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of m)this.d.push(D);for(const D of u)this.e.push(D);return this.f=null,i}containsExtension(i){for(const t of this.e)if(A.$pn.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const m=M.$IG.readActivationEvents(t);for(const f of m)i.add(f)}return i}}e.$2G=R;function v(s){const i=new A.$rn;for(const t of s)i.set(t.identifier,t);return i}function l(s,i){return s.enabledApiProposals?s.enabledApiProposals.includes(i):!1}function E(s,i){if(!l(s,i))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class d{constructor(i,t,m,f){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=m,this.activationReason=f}}e.$5G=d;class r{constructor(i,t){this.description=i,this.value=t}}e.$6G=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.$Mp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function h(s,i){const t=(0,P.$Kp)(s.manifest.publisher,s.manifest.name);return{id:t,identifier:new A.$pn(t),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!i,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class n{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$9G=n}),define(Ce[247],Ie([1,0,14,118,19,25,12,11]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=e.$Rnc=e.$Qnc=e.$Pnc=e.$Onc=e.$Nnc=void 0,w=qe(w);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(a,h,n,s){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=n,this.activateResolvedTime=s}}e.$Nnc=p;class c{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,h){return a===-1||h===-1?-1:h-a}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Onc=c;class R{constructor(a,h,n,s,i,t){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=n,this.module=s,this.exports=i,this.subscriptions=t}}e.$Pnc=R;class v extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Qnc=v;class l extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rnc=l;class E extends R{constructor(a){super(!0,a,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(a,h,n,s){this.g=s,this.a=a,this.b=h,this.c=n,this.d=new P.$rn,this.f=Object.create(null)}dispose(){for(const[a,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const a=[];for(const[h,n]of this.d)a.push(n.wait());await Promise.all(a)}isActivated(a){const h=this.d.get(a);return!!(h&&h.value)}getActivatedExtension(a){const h=this.d.get(a);if(!h||!h.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return h.value}async activateByEvent(a,h){if(this.f[a])return;const n=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(n.map(s=>({id:s.identifier,reason:{startup:h,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,h){const n=this.a.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:n.identifier,reason:h}])}async h(a){const h=a.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(h.map(n=>n.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const h=this.a.getExtensionDescription(a.id);if(!h){const i=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(i));return this.c.onExtensionActivationError(a.id,i,new M.$1G(a.id.value)),t}const n=[],s=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const i of s){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:a.reason}));continue}const m=this.a.getExtensionDescription(i);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:a.reason}));continue}const f=h.displayName||h.identifier.value,u=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${i}'`),$=this.k(a,h.displayName,[],new E(u));return this.c.onExtensionActivationError(h.identifier,u,new M.$1G(i)),$}return this.k(a,h.displayName,n,null)}k(a,h,n,s){const i=new r(a.id,h,a.reason,n,s,this.c,this.g);return this.d.set(a.id,i),i}l(a){return C.$Ebc.isHostExtension(a,this.a,this.b)}m(a){const h=this.b.getExtensionDescription(a);return h?!h.main&&!h.browser:!1}};e.$Snc=d,e.$Snc=d=He([We(3,A.$$j)],d);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,h,n,s,i,t,m){this.c=a,this.d=h,this.f=n,this.g=s,this.h=i,this.j=t,this.k=m,this.a=new N.$Dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const h=this.g[a];if(h.value&&!h.value.activationFailed){this.g.splice(a,1),a--;continue}if(h.value&&h.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);n.detail=h.value.activationFailedError,this.h=new E(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const h=new Error;if(a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this.h=new E(h),this.b&&w.$5(a))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};r=He([We(6,A.$$j)],r)}),define(Ce[248],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testRunInDebug:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRunInDebug.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[119],Ie([1,0,204,14,36,110,78,31,19,248,108,111]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=void 0,w=qe(w),P=ri(P);const l=N.$oo.as(A.$po.JSONContribution);class E{constructor(i,t,m){this.a=i,this.b=t,this.c=m}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(P.default.Error,i)}warn(i){this.d(P.default.Warning,i)}info(i){this.d(P.default.Info,i)}}e.$RG=E;class d{static a(i){const t=new p.$qn;for(let m=0,f=i.length;m<f;m++)t.add(i[m].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new d(t,[]);if(!t||!t.length)return new d([],i);const m=this.a(i),f=this.a(t),u=t.filter(I=>!m.has(I.description.identifier)),$=i.filter(I=>!f.has(I.description.identifier));return new d(u,$)}constructor(i,t){this.added=i,this.removed=t}}e.$SG=d;class r{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=d.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,C.$2)(i)}}}e.$TG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$UG={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$on},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:w.localize(42,null)},{label:"*",description:w.localize(43,null),body:"*"}]}},badges:{type:"array",description:w.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(45,null)},href:{type:"string",description:w.localize(46,null)},description:{type:"string",description:w.localize(47,null)}}}},markdown:{type:"string",description:w.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$6o}},extensionPack:{description:w.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$6o}},extensionKind:{description:w.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(53,null)},{body:["workspace"],description:w.localize(54,null)},{body:["ui","workspace"],description:w.localize(55,null)},{body:["workspace","ui"],description:w.localize(56,null)},{body:[],description:w.localize(57,null)}]},capabilities:{description:w.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(61,null),w.localize(62,null),w.localize(63,null)]},description:{type:"string",markdownDescription:w.localize(64,null)}}},untrustedWorkspaces:{description:w.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(67,null),w.localize(68,null),w.localize(69,null)]},restrictedConfigurations:{description:w.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(71,null)}}}}},sponsor:{description:w.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(74,null),type:"string"},"vscode:uninstall":{description:w.localize(75,null),type:"string"}}},icon:{type:"string",description:w.localize(76,null)},l10n:{type:"string",description:w.localize(77,null)},pricing:{type:"string",markdownDescription:w.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new r(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&v.$IG.register(i.extensionPoint,i.activationEventsGenerator),e.$UG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,l.registerSchema(a,e.$UG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$VG=h;const n={ExtensionsRegistry:"ExtensionsRegistry"};N.$oo.add(n.ExtensionsRegistry,new h),e.$WG=N.$oo.as(n.ExtensionsRegistry),l.registerSchema(a,e.$UG),l.registerSchema(R.$sk,{properties:{extensionEnabledApiProposals:{description:w.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(Ce[249],Ie([1,0,4,40,5,13,196,19,3,12,25,119]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.ChatMessageRole=void 0;var l;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(l||(e.ChatMessageRole=l={})),e.$0G=(0,p.$Ei)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$$G=v.$WG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let d=class{constructor(o,a){this.e=o,this.f=a,this.a=new P.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new w.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$$G.setHandler(h=>{this.c.clear();for(const s of h){if(!(0,R.$3G)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const i of C.Iterable.wrap(s.value)){if(this.c.has(i.vendor)){s.collector.error((0,A.localize)(3,null,i.vendor));continue}if((0,M.$cf)(i.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){s.collector.error((0,A.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[s,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(s),n.push(s));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(h)}const a=[];for(const[h,n]of this.b)(o.vendor===void 0||n.metadata.vendor===o.vendor)&&(o.family===void 0||n.metadata.family===o.family)&&(o.version===void 0||n.metadata.version===o.version)&&(o.identifier===void 0||n.metadata.id===o.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(s=>N.$pn.equals(s,o.extension)))&&a.push(h);return this.f.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this.f.trace("[LM] registering language model chat",o,a.metadata),!this.c.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,a),this.d.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,P.$Tc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,h,n,s,i){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideChatResponse(h,a,n,s,i)}computeTokenLength(o,a,h){const n=this.b.get(o);if(!n)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return n.provideTokenCount(a,h)}};e.$_G=d,e.$_G=d=He([We(0,R.$ZG),We(1,c.$$j)],d)}),define(Ce[250],Ie([1,0,199,15,26,119,32,4]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=void 0,w=qe(w),C=qe(C),P=qe(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var c;(function(l){function E(d,r,o){if(!d)return;const a=C.$eg(d.type)?d.type:void 0;if(!a||a.length===0){o.error(w.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const n of d.required)C.$eg(n)&&h.push(n);return{extensionId:r.value,taskType:a,required:h,properties:d.properties?P.$bo(d.properties):{},when:d.when?A.$Cj.deserialize(d.when):void 0}}l.from=E})(c||(c={}));const R=M.$WG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,E)=>{for(const d of l)d.type&&E.push(`onTaskType:${d.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:p}});class v{constructor(){this.d=new N.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,d)=>{R.setHandler((r,o)=>{this.c=void 0;try{for(const a of o.removed){const h=a.value;for(const n of h)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const a of o.added){const h=a.value;for(const n of h){const s=c.from(n,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$bo(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$CI=new v}),define(Ce[251],Ie([1,0,200,15,24,26,32,250,42]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MI=e.JsonSchemaVersion=e.ExecutionEngine=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GI=e.ShellQuoting=e.$FI=e.$EI=e.$DI=void 0,w=qe(w),C=qe(C),P=qe(P),M=qe(M),e.$DI="settings",e.$EI=new A.$Vj("taskRunning",!1,w.localize(0,null)),e.$FI=w.localize2(2,"Tasks");var c;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$GI="$customized",function(O){function W(ce){if(!ce)return O.Strong;switch(ce.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=W}(c||(e.ShellQuoting=c={}));var R;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var v;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(v||(e.RevealKind=v={})),function(O){function W(ce){switch(ce.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=W}(v||(e.RevealKind=v={}));var l;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(l||(e.RevealProblemKind=l={})),function(O){function W(ce){switch(ce.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=W}(l||(e.RevealProblemKind=l={}));var E;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(E||(e.PanelKind=E={})),function(O){function W(ce){switch(ce.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=W}(E||(e.PanelKind=E={}));var d;(function(O){O.defaults={echo:!0,reveal:v.Always,revealProblems:l.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(O){function W(ge){switch(ge.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=W;function ce(ge){switch(ge){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ce}(r||(e.RuntimeType=r={}));var o;(function(O){function W(ce){return C.$eg(ce)?ce:ce.value}O.value=W})(o||(e.CommandString=o={}));var a;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function W(ge){return ge===O.Clean._id||ge===O.Build._id||ge===O.Rebuild._id||ge===O.Test._id}O.is=W;function ce(ge){if(ge!==void 0)return C.$eg(ge)?W(ge)?{_id:ge,isDefault:!1}:void 0:ge}O.from=ce})(a||(e.TaskGroup=a={}));var h;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function W(ce){switch(ce){case O.User:return p.ConfigurationTarget.USER;case O.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}O.toConfigurationTarget=W})(n||(e.TaskSourceKind=n={}));var s;(function(O){O.parallel="parallel",O.sequence="sequence"})(s||(e.DependsOrder=s={}));var i;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class m{constructor(W,ce,ge,te,me,se){this._label="",this._id=W,ce&&(this._label=ce),ge&&(this.type=ge),this.runOptions=te,this.configurationProperties=me,this._source=se}getDefinition(W){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const W={folder:this.d(),id:this._id};return JSON.stringify(W)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(W,ce=!1){if(W===void 0)return!1;if(C.$eg(W))return W===this._label||W===this.configurationProperties.identifier||ce&&W===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===W._key}getQualifiedLabel(){const W=this.getWorkspaceFolder();return W?`${this._label} (${W.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(W){this.c===void 0&&(this.c=[]),W&&(this.c=this.c.concat(W))}get taskLoadMessages(){return this.c}}e.$HI=m;class f extends m{constructor(W,ce,ge,te,me,se,de,be){super(W,ge,void 0,de,be,ce),this.command={},this._source=ce,this.hasDefinedMatchers=se,me&&(this.command=me)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(W=!1){if(W&&this._source.customizes!==void 0)return this._source.customizes;{let ce;switch(this.command?this.command.runtime:void 0){case r.Shell:ce="shell";break;case r.Process:ce="process";break;case r.CustomExecution:ce="customExecution";break;case void 0:ce="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ce,_key:this._id,id:this._id}}}static is(W){return W instanceof f}getMapKey(){const W=this._source.config.workspaceFolder;return W?`${W.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$DI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const W=this.d();if(!W)return;let ce=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(ce+=this._source.kind);const ge={type:e.$GI,folder:W,id:ce};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ch(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(W){return new f(W._id,W._source,W._label,W.type,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$II=f;class u extends m{constructor(W,ce,ge,te,me,se,de){super(W,ge,te,se,de,ce),this._source=ce,this.configures=me}static is(W){return W instanceof u}f(W){return W}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ch(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$DI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const W=this.d();if(!W)return;let ce=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(ce+=this._source.kind);const ge={type:e.$GI,folder:W,id:ce};return JSON.stringify(ge)}}e.$JI=u;class $ extends m{constructor(W,ce,ge,te,me,se,de,be,re){super(W,ge,te,be,re,ce),this.defines=me,this.hasDefinedMatchers=de,this.command=se,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(W){return W instanceof $}getMapKey(){const W=this._source.workspaceFolder;return W?`${this._source.scope.toString()}|${W.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const W={type:"contributed",scope:this._source.scope,id:this._id};return W.folder=this.d(),JSON.stringify(W)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(W){return new $(W._id,W._source,W._label,W.type,W.defines,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$KI=$;class I extends m{constructor(W,ce,ge,te,me,se){super(W,ge,te,me,se,ce),this._source=ce}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(W){return W instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(W){return new I(W._id,W._source,W._label,W.type,W.runOptions,W.configurationProperties)}}e.$LI=I;var D;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(O){O._default=O.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class S{constructor(W){this.c=new Map;for(let ce=0;ce<W.length;ce++)this.c.set(W[ce].uri.toString(),ce)}compare(W,ce){const ge=W.getWorkspaceFolder(),te=ce.getWorkspaceFolder();if(ge&&te){let me=this.c.get(ge.uri.toString());me=me===void 0?0:me+1;let se=this.c.get(te.uri.toString());return se=se===void 0?0:se+1,me===se?W._label.localeCompare(ce._label):me-se}else return!ge&&te?-1:ge&&!te?1:0}}e.$MI=S;var k;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(k||(e.TaskEventKind=k={}));var g;(function(O){O.SingleRun="singleRun",O.Background="background"})(g||(e.TaskRunType=g={}));var b;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var F;(function(O){function W(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?g.Background:g.SingleRun,group:be.configurationProperties.group,__task:be}}function ce(be,re,Pe){return{...W(be),kind:k.Start,terminalId:re,resolvedVariables:Pe}}O.start=ce;function ge(be,re,Pe){return{...W(be),kind:k.ProcessStarted,terminalId:re,processId:Pe}}O.processStarted=ge;function te(be,re,Pe){return{...W(be),kind:k.ProcessEnded,terminalId:re,exitCode:Pe}}O.processEnded=te;function me(be,re,Pe){return{...W(be),kind:k.Terminated,exitReason:Pe,terminalId:re}}O.terminated=me;function se(be,re,Pe){return{...W(re),kind:be,terminalId:Pe}}O.general=se;function de(){return{kind:k.Changed}}O.changed=de})(F||(e.TaskEvent=F={}));var T;(function(O){function W(ge){const te=Object.keys(ge).sort();let me="";for(const se of te){let de=ge[se];de instanceof Object?de=W(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),me+=se+","+de+","}return me}function ce(ge){const me={_key:W(ge),type:ge.taskType};return Object.assign(me,ge),me}O.create=ce})(T||(e.KeyedTaskIdentifier=T={}));var q;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(q||(e.TaskSettingId=q={}));var G;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var V;(function(O){function W(ce,ge){const te=N.$CI.get(ce.type);if(te===void 0){const be=M.$bo(ce);return delete be._key,T.create(be)}const me=Object.create(null);me.type=te.taskType;const se=new Set;te.required.forEach(be=>se.add(be));const de=te.properties;for(const be of Object.keys(de)){const re=ce[be];if(re!=null)me[be]=re;else if(se.has(be)){const Pe=de[be];if(Pe.default!==void 0)me[be]=M.$bo(Pe.default);else switch(Pe.type){case"boolean":me[be]=!1;break;case"number":case"integer":me[be]=0;break;case"string":me[be]="";break;default:ge.error(w.localize(1,null,JSON.stringify(ce,void 0,0),be));return}}}return T.create(me)}O.createTaskIdentifier=W})(V||(e.TaskDefinition=V={}))}),define(Ce[252],Ie([1,0,14]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,N)=>{this.b=A,this.d=N,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$2)(A))}then(A,N){return this.j().then(A,N)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Ibc=C;class P extends C{constructor(){super(),this.h=!0,this.i=new w.$6}}e.$Jbc=P}),define(Ce[39],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=e.$Mw=void 0,e.$Nw=P,e.$Ow=M;class w{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++w.count}}e.$Mw=w;const C=[];function P(N){const p=new w(N);return C[p.nid]=p,p}function M(N){return C[N].sid}class A{constructor(p){this.value=p}}e.$Pw=A}),define(Ce[6],Ie([1,0,39]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$ZM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var N;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(N||(e.WebviewMessageArrayBufferViewType=N={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var R;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class v{static{this.a=0}static mixin(o){return o._id=v.a++,o}}e.$ZM=v;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$1M={MainThreadAuthentication:(0,w.$Nw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Nw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,w.$Nw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,w.$Nw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,w.$Nw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.$Nw)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$Nw)("MainThreadClipboard"),MainThreadCommands:(0,w.$Nw)("MainThreadCommands"),MainThreadComments:(0,w.$Nw)("MainThreadComments"),MainThreadConfiguration:(0,w.$Nw)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Nw)("MainThreadConsole"),MainThreadDebugService:(0,w.$Nw)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Nw)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Nw)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Nw)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Nw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Nw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Nw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Nw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Nw)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Nw)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Nw)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Nw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$Nw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Nw)("MainThreadLanguages"),MainThreadLogger:(0,w.$Nw)("MainThreadLogger"),MainThreadMessageService:(0,w.$Nw)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Nw)("MainThreadOutputService"),MainThreadProgress:(0,w.$Nw)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Nw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Nw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Nw)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Nw)("MainThreadSecretState"),MainThreadStorage:(0,w.$Nw)("MainThreadStorage"),MainThreadSpeech:(0,w.$Nw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.$Nw)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Nw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,w.$Nw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,w.$Nw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Nw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Nw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Nw)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Nw)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Nw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Nw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Nw)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Nw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.$Nw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.$Nw)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Nw)("MainThreadSCM"),MainThreadSearch:(0,w.$Nw)("MainThreadSearch"),MainThreadShare:(0,w.$Nw)("MainThreadShare"),MainThreadTask:(0,w.$Nw)("MainThreadTask"),MainThreadWindow:(0,w.$Nw)("MainThreadWindow"),MainThreadLabelService:(0,w.$Nw)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Nw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Nw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Nw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Nw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Nw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Nw)("MainThreadInteractive"),MainThreadTheming:(0,w.$Nw)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Nw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Nw)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Nw)("MainThreadTimeline"),MainThreadTesting:(0,w.$Nw)("MainThreadTesting"),MainThreadLocalization:(0,w.$Nw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$Nw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$Nw)("MainThreadAiEmbeddingVector")},e.$2M={ExtHostCommands:(0,w.$Nw)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Nw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Nw)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Nw)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Nw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Nw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Nw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Nw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Nw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Nw)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Nw)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Nw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Nw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Nw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Nw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Nw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Nw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Nw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Nw)("ExtHostStatusBar"),ExtHostShare:(0,w.$Nw)("ExtHostShare"),ExtHostExtensionService:(0,w.$Nw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Nw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Nw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,w.$Nw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,w.$Nw)("ExtHostSCM"),ExtHostSearch:(0,w.$Nw)("ExtHostSearch"),ExtHostTask:(0,w.$Nw)("ExtHostTask"),ExtHostWorkspace:(0,w.$Nw)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Nw)("ExtHostWindow"),ExtHostWebviews:(0,w.$Nw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Nw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Nw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Nw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Nw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Nw)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Nw)("ExtHostProgress"),ExtHostComments:(0,w.$Nw)("ExtHostComments"),ExtHostSecretState:(0,w.$Nw)("ExtHostSecretState"),ExtHostStorage:(0,w.$Nw)("ExtHostStorage"),ExtHostUrls:(0,w.$Nw)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Nw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Nw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Nw)("ExtHostOutputService"),ExtHostLabelService:(0,w.$Nw)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Nw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Nw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Nw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Nw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Nw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Nw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Nw)("ExtHostInteractive"),ExtHostChatAgents2:(0,w.$Nw)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$Nw)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$Nw)("ExtHostChatProvider"),ExtHostSpeech:(0,w.$Nw)("ExtHostSpeech"),ExtHostEmbeddings:(0,w.$Nw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,w.$Nw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$Nw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$Nw)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Nw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Nw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Nw)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Nw)("ExtHostTimeline"),ExtHostTesting:(0,w.$Nw)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Nw)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Nw)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,6,17]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=e.$anc=void 0,P=qe(P),e.$anc=(0,w.$Ei)("IExtHostApiDeprecationService");let A=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(P.$1M.MainThreadTelemetry)}report(p,c,R){const v=this.d(p,c);this.a.has(v)||(this.a.add(v),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$bnc=A,e.$bnc=A=He([We(0,M.$uP),We(1,C.$$j)],A),e.$cnc=Object.freeze(new class{report(N,p,c){}})}),define(Ce[253],Ie([1,0,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;class C{constructor(M){const A=M.getProxy(w.$1M.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(N){return A.$writeText(N)}})}}e.$pnc=C}),define(Ce[254],Ie([1,0,26,6,27,17]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0;let A=class{constructor(R,v){this.a=R.getProxy(C.$1M.MainThreadConsole),this.b=v.consoleForward.includeStack,this.c=v.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,v){const l=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,v,E,arguments)}})}e(R,v,l,E){this.a.$logExtensionHostMessage({type:"__$console",severity:v,arguments:p(E,this.b)}),this.c&&this.f(R,l,E)}};e.$kpc=A,e.$kpc=A=He([We(0,M.$uP),We(1,P.$KP)],A);const N=1e5;function p(c,R){const v=[];if(c.length)for(let l=0;l<c.length;l++){let E=c[l];if(typeof E>"u")E="undefined";else if(E instanceof Error){const d=E;d.stack?E=d.stack:E=d.toString()}v.push(E)}if(R){const l=new Error().stack;l&&v.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,w.$go)(v);return l.length>N?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ce[255],Ie([1,0,2,6,25]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class M{constructor(N){this.a=N.getProxy(C.$1M.MainThreadDialogs)}showOpenDialog(N,p){return p?.allowUIResources&&(0,P.$4G)(N,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(N){return this.a.$showSaveDialog(N).then(p=>p?w.URI.revive(p):void 0)}}e.$roc=M}),define(Ce[256],Ie([1,0,22,4,5,6]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0;class A{constructor(p){this.b=new Map,this.c=new C.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(M.$1M.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,R){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const v=this.e++;return this.a.$registerEmbeddingProvider(v,c),this.b.set(v,{id:c,provider:R}),(0,P.$Tc)(()=>{this.a.$unregisterEmbeddingProvider(v),this.b.delete(v)})}async computeEmbeddings(p,c,R){R??=w.CancellationToken.None;let v=!1;typeof c=="string"&&(c=[c],v=!0);const l=await this.a.$computeEmbeddings(p,c,R);if(l.length!==c.length)throw new Error;if(v){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings(p,c,R){const v=this.b.get(p);if(!v)return[];const l=await v.provider.provideEmbeddings(c,R);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$uoc=A}),define(Ce[257],Ie([1,0,5,6]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(C.$1M.MainThreadLabelService)}$registerResourceLabelFormatter(A){const N=this.b++;return this.a.$registerResourceLabelFormatter(N,A),(0,w.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(N)})}}e.$Loc=P}),define(Ce[86],Ie([1,0,21,13,2,3,12,6,27,17]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=e.$7nc=void 0;let R=class{constructor(l,E,d){this.f=d,this.d=new Map,this.a=E.getProxy(N.$1M.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===w.$g}getMessage(l,E){const{message:d,args:r,comment:o}=E;if(this.c)return(0,C.$ef)(d,r??{});let a=d;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(l)?.contents[a];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,C.$ef)(h??d,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let E;const d=await this.g(l);if(!d){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);E=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${d}: ${r.message}`);return}E&&this.d.set(l.identifier.value,{contents:E,uri:d})}async g(l){if(l.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(E)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7nc=R,e.$7nc=R=He([We(0,p.$KP),We(1,c.$uP),We(2,A.$$j)],R),e.$8nc=(0,M.$Ei)("IExtHostLocalizationService")}),define(Ce[258],Ie([1,0,12,6,27,17,2,49]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0;let p=class extends w.$jk{constructor(v,l){super(l.logLevel,l.logsLocation,l.loggers.map(E=>(0,N.$bi)(E))),this.r=v.getProxy(C.$1M.MainThreadLogger)}$setLogLevel(v,l){l?this.setLogLevel(A.URI.revive(l),v):this.setLogLevel(v)}setVisibility(v,l){super.setVisibility(v,l),this.r.$setVisibility(v,l)}s(v,l,E){return new c(this.r,v,l,E)}};e.$jpc=p,e.$jpc=p=He([We(0,M.$uP),We(1,P.$KP)],p);class c extends w.$ek{constructor(v,l,E,d){super(d?.logLevel==="always"),this.r=v,this.s=l,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(l,d).then(()=>{this.u(this.n),this.m=!0})}g(v,l){const E=[[v,l]];this.m?this.u(E):this.n.push(...E)}u(v){this.r.$log(this.s,v)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,6,3,5,17,23]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=e.$9nc=void 0,e.$9nc=(0,C.$Ei)("IExtHostManagedSockets");let N=class{constructor(v){this.b=0,this.c=null,this.d=new Map,this.a=v.getProxy(w.$1M.MainThreadManagedSockets)}setFactory(v,l){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(v,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(v){if(!this.c||this.c.socketFactoryId!==v)throw new Error(`No socket factory with id ${v}`);const l=++this.b,E=await this.c.makeConnection(),d=new P.$Uc;return this.d.set(l,new c(l,E,d)),d.add((0,P.$Tc)(()=>this.d.delete(l))),d.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),d.dispose()})),d.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),d.dispose()})),d.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,A.$Ne.wrap(r)))),l}$remoteSocketWrite(v,l){this.d.get(v)?.actual.send(l.buffer)}$remoteSocketEnd(v){const l=this.d.get(v);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(v){await this.d.get(v)?.actual.drain?.()}};e.$0nc=N,e.$0nc=N=He([We(0,M.$uP)],N);class p{constructor(v,l){this.socketFactoryId=v,this.makeConnection=l}}class c extends P.$Vc{constructor(v,l,E){super(),this.socketId=v,this.actual=l,this.B(E)}}}),define(Ce[259],Ie([1,0,6,12,25]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;function M(N){return N&&N.title}let A=class{constructor(p,c){this.b=c,this.a=p.getProxy(w.$1M.MainThreadMessageService)}showMessage(p,c,R,v,l){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof v=="string"||M(v)?d=[v,...l]:(E.modal=v?.modal,E.useCustom=v?.useCustom,E.detail=v?.detail,d=l),E.useCustom&&(0,P.$4G)(p,"resolvers");const r=[];let o=!1;for(let a=0;a<d.length;a++){const h=d[a];if(typeof h=="string")r.push({title:h,handle:a,isCloseAffordance:!1});else if(typeof h=="object"){const{title:n,isCloseAffordance:s}=h;r.push({title:n,isCloseAffordance:!!s,handle:a}),s&&(o?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(c,R,E,r).then(a=>{if(typeof a=="number")return d[a]})}};e.$Noc=A,e.$Noc=A=He([We(1,C.$$j)],A)}),define(Ce[260],Ie([1,0,5,15,2,25,6]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class N{constructor(c){this.b=new Map,this.a=c.getProxy(A.$1M.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,R,v){if((0,M.$4G)(c,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,v),this.a.$registerProfileContentHandler(R,v.name,v.description,c.identifier.value),(0,w.$Tc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(c,R,v,l){const E=this.b.get(c);if(!E)throw new Error(`Unknown handler with id: ${c}`);return E.saveProfile(R,v,l)}async $readProfile(c,R,v){const l=this.b.get(c);if(!l)throw new Error(`Unknown handler with id: ${c}`);return l.readProfile((0,C.$eg)(R)?R:P.URI.revive(R),v)}}e.$Woc=N}),define(Ce[88],Ie([1,0,6,4,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0;class M{constructor(N){this.b=new C.$le,this.onDidChangePassword=this.b.event,this.a=N.getProxy(w.$1M.MainThreadSecretState)}async $onDidChangePassword(N){this.b.fire(N)}get(N,p){return this.a.$getPassword(N,p)}store(N,p,c){return this.a.$setPassword(N,p,c)}delete(N,p){return this.a.$deletePassword(N,p)}}e.$4nc=M,e.$5nc=(0,P.$Ei)("IExtHostSecretState")}),define(Ce[261],Ie([1,0,22,5,6]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=void 0;class M{static{this.a=1}constructor(N){this.c=new Map,this.d=new Map,this.f=new Map,this.b=N.getProxy(P.$1M.MainThreadSpeech)}async $createSpeechToTextSession(N,p,c){const R=this.c.get(N);if(!R)return;const v=new C.$Uc,l=new w.$we;this.d.set(p,l);const E=await R.provideSpeechToTextSession(l.token,c?{language:c}:void 0);E&&(v.add(E.onDidChange(d=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),v.add(l.token.onCancellationRequested(()=>v.dispose())))}async $cancelSpeechToTextSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}async $createTextToSpeechSession(N,p,c){const R=this.c.get(N);if(!R)return;const v=new C.$Uc,l=new w.$we;this.d.set(p,l);const E=await R.provideTextToSpeechSession(l.token,c?{language:c}:void 0);E&&(this.f.set(p,E),v.add(E.onDidChange(d=>{l.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),v.add(l.token.onCancellationRequested(()=>v.dispose())))}async $synthesizeSpeech(N,p){this.f.get(N)?.synthesize(p)}async $cancelTextToSpeechSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N),this.f.delete(N)}async $createKeywordRecognitionSession(N,p){const c=this.c.get(N);if(!c)return;const R=new C.$Uc,v=new w.$we;this.d.set(p,v);const l=await c.provideKeywordRecognitionSession(v.token);l&&(R.add(l.onDidChange(E=>{v.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(v.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}registerProvider(N,p,c){const R=M.a++;return this.c.set(R,c),this.b.$registerProvider(R,p,{extension:N,displayName:N.value}),(0,C.$Tc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$4oc=M}),define(Ce[89],Ie([1,0,6,4,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;class M{constructor(N,p){this.c=p,this.b=new C.$le,this.onDidChangeStorage=this.b.event,this.a=N.getProxy(w.$1M.MainThreadStorage)}registerExtensionStorageKeysToSync(N,p){this.a.$registerExtensionStorageKeysToSync(N,p)}async initializeExtensionStorage(N,p,c){const R=await this.a.$initializeExtensionStorage(N,p);let v;return R&&(v=this.d(N,p,R)),v||c}setValue(N,p,c){return this.a.$setValue(N,p,c)}$acceptValue(N,p,c){const R=this.d(N,p,c);R&&this.b.fire({shared:N,key:p,value:R})}d(N,p,c){try{return JSON.parse(c)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${N}): ${R}`)}}}e.$Tnc=M,e.$Unc=(0,P.$Ei)("IExtHostStorage")}),define(Ce[262],Ie([1,0,5,16,2,6]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;class A{static{this.a=new Set([C.Schemas.http,C.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(M.$1M.MainThreadUriOpeners)}registerExternalUriOpener(p,c,R,v){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const l=v.schemes.find(E=>!A.a.has(E));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(c,R),this.b.$registerUriOpener(c,v.schemes,p,v.label),(0,w.$Tc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,R){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener with id: ${p}`);const l=P.URI.revive(c);return v.canOpenExternalUri(l,R)}async $openUri(p,c,R){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener id: '${p}'`);return v.openExternalUri(P.URI.revive(c.resolvedUri),{sourceUri:P.URI.revive(c.sourceUri)},R)}}e.$dpc=A}),define(Ce[263],Ie([1,0,6,2,5,14,19]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0;class N{static{this.a=0}constructor(c){this.c=new A.$qn,this.d=new Map,this.b=c.getProxy(w.$1M.MainThreadUrls)}registerUriHandler(c,R){const v=c.identifier;if(this.c.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const l=N.a++;return this.c.add(v),this.d.set(l,R),this.b.$registerUriHandler(l,v,c.displayName||c.name),(0,P.$Tc)(()=>{this.c.delete(v),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(c,R){const v=this.d.get(c);if(!v)return Promise.resolve(void 0);try{v.handleUri(C.URI.revive(R))}catch(l){(0,M.$2)(l)}return Promise.resolve(void 0)}async createAppUri(c){return C.URI.revive(await this.b.$createAppUri(c))}}e.$epc=N}),define(Ce[264],Ie([1,0,23,6]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsb=M,e.$Isb=N,C=qe(C);class P{constructor(){this.buffers=[]}add(c){let R=this.buffers.indexOf(c);return R<0&&(R=this.buffers.length,this.buffers.push(c)),R}}function M(p,c){if(c.serializeBuffersForPostMessage){const R=new P,l=JSON.stringify(p,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:R.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=R.buffers.map(d=>{const r=new Uint8Array(d);return w.$Ne.wrap(r)});return{message:l,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return C.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return C.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return C.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return C.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return C.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return C.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return C.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return C.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return C.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return C.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return C.WebviewMessageArrayBufferViewType.BigUint64Array}}function N(p,c){const R=c.map(E=>{const d=new ArrayBuffer(E.byteLength);return new Uint8Array(d).set(E.buffer),d}),v=c.length?(E,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,a=R[o];if(r.view)switch(r.view.type){case C.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return d}:void 0;return{message:JSON.parse(p,v),arrayBuffers:R}}}),define(Ce[68],Ie([1,0,4,5,16,26,2,207,264,83,6]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Enc=void 0,e.$Fnc=l,e.$Hnc=r,e.$Inc=o,M=qe(M),R=qe(R);class v{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,i,t,m,f,u,$){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new w.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$le,this._onDidDispose=this.#h.event,this.#e=s,this.#t=i,this.#o=t,this.#n=m,this.#s=f,this.#r=u,this.#u=l(u),this.#d=E(u),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$kCb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let i=s.toString();return i.endsWith("/")||(i+="/"),i+" "+c.$jCb}return c.$jCb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),M.$fo(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const i=(0,p.$Hsb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const i=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,f,u,$,I,D)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),S=(0,c.$kCb)(y,{isRemote:i,authority:t}).toString();return`${f}${S}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,f,u,$,I,D)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),S=(0,c.$kCb)(y,{isRemote:i,authority:t}).toString();return`${f}${S}${D}`})}}e.$Enc=v;function l(n){try{const s=(0,N.$Vp)((0,N.$Up)(n.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function E(n){try{const s=(0,N.$Vp)((0,N.$Up)(n.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class d extends C.$Vc{constructor(s,i,t,m,f){super(),this.c=i,this.f=t,this.g=m,this.h=f,this.b=new Map,this.a=s.getProxy(R.$1M.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,i,t){const m=this.j(s);if(m){const{message:f}=(0,p.$Isb)(i,t.value);m._onMessageEmitter.fire(f)}}$onMissingCsp(s,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,i,t){const m=new v(s,this.a,a(i),this.c,this.f,t,this.h);this.b.set(s,m);const f=m._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return m}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Gnc=d;function r(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,s,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||h(n,s)}}function a(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(s=>A.URI.from(s))}}function h(n,s){return[...(s?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(Ce[120],Ie([1,0,4,16,13,2,3,17,6]),function(oe,e,w,C,P,M,A,N,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;let R=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new w.$le,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=l.getProxy(p.$1M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:d})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,E){E!==this.d[l]&&(this.d={...this.d,[l]:E},this.c.fire(this.d))}openUri(l,E){let d;if(typeof l=="string"){d=l;try{l=M.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,P.$cf)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,d,E)}async asExternalUri(l,E){if((0,P.$cf)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(l,E);return M.URI.from(d)}};e.$gpc=R,e.$gpc=R=c=He([We(0,N.$uP)],R),e.$hpc=(0,A.$Ei)("IExtHostWindow")}),define(Ce[265],Ie([1,0,254,27,17]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=void 0;let M=class extends w.$kpc{constructor(N,p){super(N,p)}f(N,p,c){p.apply(console,c)}};e.$urc=M,e.$urc=M=He([We(0,P.$uP),We(1,C.$KP)],M)}),define(Ce[266],Ie([1,0,11,23,22,28,14,4,5,38,160,252,39]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Kbc=h,e.$Lbc=n,A=qe(A);function d(F,T){try{return JSON.stringify(F,T)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(T,q){this.jsonString=T,this.referencedBuffers=q}}function h(F,T=null,q=!1){const G=[];return{jsonString:(q?d:JSON.stringify)(F,(O,W)=>{if(typeof W>"u")return o;if(typeof W=="object"){if(W instanceof C.$Ne){const ce=G.push(W)-1;return{[r]:ce}}if(T)return T(O,W)}return W}),referencedBuffers:G}}function n(F,T,q){return JSON.parse(F,(G,V)=>{if(V){const O=V[r];if(typeof O=="number")return T[O];if(q&&V.$mid===c.MarshalledId.Uri)return q.transformIncoming(V)}return V})}function s(F,T){return JSON.stringify(F,T)}function i(F){return F?(T,q)=>q&&q.$mid===c.MarshalledId.Uri?F.transformOutgoing(q):q:null}var t;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var m;(function(F){F[F.Responsive=0]="Responsive",F[F.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const f=()=>{},u=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class I extends p.$Vc{static{E=u}static{this.a=3*1e3}constructor(T,q=null,G=null){super(),this[E]=!0,this.b=this.B(new N.$le),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=q,this.g=G,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,O=l.$Mw.count;V<O;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=m.Responsive,this.z=0,this.C=0,this.D=this.B(new w.$Qh(()=>this.H(),1e3)),this.B(this.c.onMessage(V=>this.L(V)))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const q=this.w[T];delete this.w[T],q.resolveErr(A.$7())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(m.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(m.Unresponsive):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,R.$Ln)(T,this.g):T}getProxy(T){const{nid:q,sid:G}=T;return this.s[q]||(this.s[q]=this.J(q,G)),this.s[q]}J(T,q){const G={get:(V,O)=>(typeof O=="string"&&!V[O]&&O.charCodeAt(0)===M.CharCode.DollarSign&&(V[O]=(...W)=>this.U(T,O,W)),O===$?q:V[O])};return new Proxy(Object.create(null),G)}set(T,q){return this.m[T.nid]=q,q}assertRegistered(T){for(let q=0,G=T.length;q<G;q++){const V=T[q];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(T){if(this.j)return;const q=T.byteLength,G=y.read(T,0),V=G.readUInt8(),O=G.readUInt32();switch(V){case g.RequestJSONArgs:case g.RequestJSONArgsWithCancellation:{let{rpcId:W,method:ce,args:ge}=k.deserializeRequestJSONArgs(G);this.g&&(ge=(0,R.$Ln)(ge,this.g)),this.M(q,O,W,ce,ge,V===g.RequestJSONArgsWithCancellation);break}case g.RequestMixedArgs:case g.RequestMixedArgsWithCancellation:{let{rpcId:W,method:ce,args:ge}=k.deserializeRequestMixedArgs(G);this.g&&(ge=(0,R.$Ln)(ge,this.g)),this.M(q,O,W,ce,ge,V===g.RequestMixedArgsWithCancellation);break}case g.Acknowledged:{this.f?.logIncoming(q,O,t.LocalSide,"ack"),this.G(O);break}case g.Cancel:{this.N(q,O);break}case g.ReplyOKEmpty:{this.O(q,O,void 0);break}case g.ReplyOKJSON:{let W=k.deserializeReplyOKJSON(G);this.g&&(W=(0,R.$Ln)(W,this.g)),this.O(q,O,W);break}case g.ReplyOKJSONWithBuffers:{const W=k.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(q,O,W);break}case g.ReplyOKVSBuffer:{const W=k.deserializeReplyOKVSBuffer(G);this.O(q,O,W);break}case g.ReplyErrError:{let W=k.deserializeReplyErrError(G);this.g&&(W=(0,R.$Ln)(W,this.g)),this.P(q,O,W);break}case g.ReplyErrEmpty:{this.P(q,O,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,q,G,V,O,W){this.f?.logIncoming(T,q,t.OtherSide,`receiveRequest ${(0,l.$Ow)(G)}.${V}(`,O);const ce=String(q);let ge,te;if(W){const se=new P.$we;O.push(se.token),ge=this.Q(G,V,O),te=()=>se.cancel()}else ge=this.Q(G,V,O),te=f;this.u[ce]=te;const me=k.serializeAcknowledged(q);this.f?.logOutgoing(me.byteLength,q,t.OtherSide,"ack"),this.c.send(me),ge.then(se=>{delete this.u[ce];const de=k.serializeReplyOK(q,se,this.h);this.f?.logOutgoing(de.byteLength,q,t.OtherSide,"reply:",se),this.c.send(de)},se=>{delete this.u[ce];const de=k.serializeReplyErr(q,se);this.f?.logOutgoing(de.byteLength,q,t.OtherSide,"replyErr:",se),this.c.send(de)})}N(T,q){this.f?.logIncoming(T,q,t.OtherSide,"receiveCancel");const G=String(q);this.u[G]?.()}O(T,q,G){this.f?.logIncoming(T,q,t.LocalSide,"receiveReply:",G);const V=String(q);if(!this.w.hasOwnProperty(V))return;const O=this.w[V];delete this.w[V],O.resolveOk(G)}P(T,q,G){this.f?.logIncoming(T,q,t.LocalSide,"receiveReplyErr:",G);const V=String(q);if(!this.w.hasOwnProperty(V))return;const O=this.w[V];delete this.w[V];let W;G&&(G.$isError?(W=new Error,W.name=G.name,W.message=G.message,W.stack=G.stack):W=G),O.resolveErr(W)}Q(T,q,G){try{return Promise.resolve(this.S(T,q,G))}catch(V){return Promise.reject(V)}}S(T,q,G){const V=this.m[T];if(!V)throw new Error("Unknown actor "+(0,l.$Ow)(T));const O=V[q];if(typeof O!="function")throw new Error("Unknown method "+q+" on actor "+(0,l.$Ow)(T));return O.apply(V,G)}U(T,q,G){if(this.j)return new v.$Jbc;let V=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(V=G.pop()),V&&V.isCancellationRequested)return Promise.reject(A.$7());const O=k.serializeRequestArguments(G,this.h),W=++this.t,ce=String(W),ge=new v.$Ibc,te=new p.$Uc;V&&te.add(V.onCancellationRequested(()=>{const se=k.serializeCancel(W);this.f?.logOutgoing(se.byteLength,W,t.LocalSide,"cancel"),this.c.send(k.serializeCancel(W))})),this.w[ce]=new D(ge,te),this.F(W);const me=k.serializeRequest(W,T,q,O,!!V);return this.f?.logOutgoing(me.byteLength,W,t.LocalSide,`request: ${(0,l.$Ow)(T)}.${q}(`,G),this.c.send(me),ge}}e.$Mbc=I;class D{constructor(T,q){this.a=T,this.b=q}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class y{static alloc(T,q,G){const V=new y(C.$Ne.alloc(G+1+4),0);return V.writeUInt8(T),V.writeUInt32(q),V}static read(T,q){return new y(T,q)}get buffer(){return this.a}constructor(T,q){this.a=T,this.b=q}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+T);return this.b+=T,q}static sizeMixedArray(T){let q=0;q+=1;for(let G=0,V=T.length;G<V;G++){const O=T[G];switch(q+=1,O.type){case b.String:q+=this.sizeLongString(O.value);break;case b.VSBuffer:q+=this.sizeVSBuffer(O.value);break;case b.SerializedObjectWithBuffers:q+=this.sizeUInt32,q+=this.sizeLongString(O.value);for(let W=0;W<O.buffers.length;++W)q+=this.sizeVSBuffer(O.buffers[W]);break;case b.Undefined:break}}return q}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let q=0,G=T.length;q<G;q++){const V=T[q];switch(V.type){case b.String:this.writeUInt8(b.String),this.writeLongString(V.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(V.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let O=0;O<V.buffers.length;++O)this.writeBuffer(V.buffers[O]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const q=new Array(T);for(let G=0;G<T;G++)switch(this.readUInt8()){case b.String:q[G]=this.readLongString();break;case b.VSBuffer:q[G]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const O=this.readUInt32(),W=this.readLongString(),ce=[];for(let ge=0;ge<O;++ge)ce.push(this.readVSBuffer());q[G]=new l.$Pw(n(W,ce,null));break}case b.Undefined:q[G]=void 0;break}return q}}var S;(function(F){F[F.Simple=0]="Simple",F[F.Mixed=1]="Mixed"})(S||(S={}));class k{static a(T){for(let q=0,G=T.length;q<G;q++)if(T[q]instanceof C.$Ne||T[q]instanceof l.$Pw||typeof T[q]>"u")return!0;return!1}static serializeRequestArguments(T,q){if(this.a(T)){const G=[];for(let V=0,O=T.length;V<O;V++){const W=T[V];if(W instanceof C.$Ne)G[V]={type:b.VSBuffer,value:W};else if(typeof W>"u")G[V]={type:b.Undefined};else if(W instanceof l.$Pw){const{jsonString:ce,referencedBuffers:ge}=h(W.value,q);G[V]={type:b.SerializedObjectWithBuffers,value:C.$Ne.fromString(ce),buffers:ge}}else G[V]={type:b.String,value:C.$Ne.fromString(s(W,q))}}return{type:S.Mixed,args:G}}return{type:S.Simple,args:s(T,q)}}static serializeRequest(T,q,G,V,O){switch(V.type){case S.Simple:return this.b(T,q,G,V.args,O);case S.Mixed:return this.c(T,q,G,V.args,O)}}static b(T,q,G,V,O){const W=C.$Ne.fromString(G),ce=C.$Ne.fromString(V);let ge=0;ge+=y.sizeUInt8(),ge+=y.sizeShortString(W),ge+=y.sizeLongString(ce);const te=y.alloc(O?g.RequestJSONArgsWithCancellation:g.RequestJSONArgs,T,ge);return te.writeUInt8(q),te.writeShortString(W),te.writeLongString(ce),te.buffer}static deserializeRequestJSONArgs(T){const q=T.readUInt8(),G=T.readShortString(),V=T.readLongString();return{rpcId:q,method:G,args:JSON.parse(V)}}static c(T,q,G,V,O){const W=C.$Ne.fromString(G);let ce=0;ce+=y.sizeUInt8(),ce+=y.sizeShortString(W),ce+=y.sizeMixedArray(V);const ge=y.alloc(O?g.RequestMixedArgsWithCancellation:g.RequestMixedArgs,T,ce);return ge.writeUInt8(q),ge.writeShortString(W),ge.writeMixedArray(V),ge.buffer}static deserializeRequestMixedArgs(T){const q=T.readUInt8(),G=T.readShortString(),V=T.readMixedArray(),O=new Array(V.length);for(let W=0,ce=V.length;W<ce;W++){const ge=V[W];typeof ge=="string"?O[W]=JSON.parse(ge):O[W]=ge}return{rpcId:q,method:G,args:O}}static serializeAcknowledged(T){return y.alloc(g.Acknowledged,T,0).buffer}static serializeCancel(T){return y.alloc(g.Cancel,T,0).buffer}static serializeReplyOK(T,q,G){if(typeof q>"u")return this.d(T);if(q instanceof C.$Ne)return this.e(T,q);if(q instanceof l.$Pw){const{jsonString:V,referencedBuffers:O}=h(q.value,G,!0);return this.g(T,V,O)}else return this.f(T,d(q,G))}static d(T){return y.alloc(g.ReplyOKEmpty,T,0).buffer}static e(T,q){let G=0;G+=y.sizeVSBuffer(q);const V=y.alloc(g.ReplyOKVSBuffer,T,G);return V.writeVSBuffer(q),V.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,q){const G=C.$Ne.fromString(q);let V=0;V+=y.sizeLongString(G);const O=y.alloc(g.ReplyOKJSON,T,V);return O.writeLongString(G),O.buffer}static g(T,q,G){const V=C.$Ne.fromString(q);let O=0;O+=y.sizeUInt32,O+=y.sizeLongString(V);for(const ce of G)O+=y.sizeVSBuffer(ce);const W=y.alloc(g.ReplyOKJSONWithBuffers,T,O);W.writeUInt32(G.length),W.writeLongString(V);for(const ce of G)W.writeBuffer(ce);return W.buffer}static deserializeReplyOKJSON(T){const q=T.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(T,q){const G=T.readUInt32(),V=T.readLongString(),O=[];for(let W=0;W<G;++W)O.push(T.readVSBuffer());return new l.$Pw(n(V,O,q))}static serializeReplyErr(T,q){const G=q?d(A.$4(q),null):void 0;if(typeof G!="string")return this.h(T);const V=C.$Ne.fromString(G);let O=0;O+=y.sizeLongString(V);const W=y.alloc(g.ReplyErrError,T,O);return W.writeLongString(V),W.buffer}static deserializeReplyErrError(T){const q=T.readLongString();return JSON.parse(q)}static h(T){return y.alloc(g.ReplyErrEmpty,T,0).buffer}}var g;(function(F){F[F.RequestJSONArgs=1]="RequestJSONArgs",F[F.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",F[F.RequestMixedArgs=3]="RequestMixedArgs",F[F.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",F[F.Acknowledged=5]="Acknowledged",F[F.Cancel=6]="Cancel",F[F.ReplyOKEmpty=7]="ReplyOKEmpty",F[F.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",F[F.ReplyOKJSON=9]="ReplyOKJSON",F[F.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",F[F.ReplyErrError=11]="ReplyErrError",F[F.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var b;(function(F){F[F.String=1]="String",F[F.VSBuffer=2]="VSBuffer",F[F.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",F[F.Undefined=4]="Undefined"})(b||(b={}))}),define(Ce[267],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=void 0;const w=function(M){const A=N=>{globalThis.removeEventListener("message",A);const p=N.data;Object.defineProperties(globalThis,{postMessage:{value(c,R){p.postMessage(c,R)}},onmessage:{get(){return p.onmessage},set(c){p.onmessage=c}}}),p.addEventListener("message",c=>{globalThis.dispatchEvent(new MessageEvent("message",{data:c.data,ports:c.ports?[...c.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class C extends EventTarget{constructor(M,A,N){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${w})('${A}'))`,c=new Blob([p],{type:"application/javascript"}),R=URL.createObjectURL(c),v=new MessageChannel,l=R,E={type:"_newWorker",id:l,port:v.port2,url:R,options:N};M(E,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(d){v.port1.onmessage=d}},onmessageerror:{get(){return v.port1.onmessageerror},set(d){v.port1.onmessageerror=d}}}),v.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),v.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),v.port1.start()}}e.$wrc=C}),define(Ce[268],Ie([1,0,23,29,16,61,3]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$KK=void 0,e.$LK=R,e.$MK=v,e.$KK=(0,A.$Ei)("notebookDocumentService");const N=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${N.join("")}]+`),c=7;function R(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const d=E.fragment.indexOf("s");if(d<0)return;const r=parseInt(E.fragment.substring(0,d).replace(p,""),c),o=(0,w.$7e)(E.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:E.with({scheme:o,fragment:null})}}function v(E,d){const r=d.toString(c),a=`${r.length<N.length?N[r.length-1]:"z"}${r}s${(0,w.$8e)(w.$Ne.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:a})}class l{constructor(){this.a=new C.$Bc}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=R(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$NK=l,(0,M.$Ks)(e.$KK,l,M.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,41,40,73,16,20,21,32,268]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$5K=e.CellStatusbarAlignment=e.$4K=e.NotebookEditorPriority=e.$1K=e.$ZK=e.$XK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WK=e.$VK=e.$UK=e.$TK=e.CellKind=e.$SK=e.$RK=e.$QK=void 0,e.$YK=m,e.$2K=u,e.$3K=$,e.$6K=y,e.$7K=k,C=qe(C),e.$QK="workbench.editor.notebook",e.$RK="workbench.editor.notebookTextDiffEditor",e.$SK="workbench.editor.interactive";var v;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(v||(e.CellKind=v={})),e.$TK=["application/json","application/javascript","text/html","image/svg+xml",M.$4s.latex,M.$4s.markdown,"image/png","image/jpeg",M.$4s.text],e.$UK=[M.$4s.latex,M.$4s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$4s.text],e.$VK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WK="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var E;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var h;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var n;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var s;(function(W){W.scheme=A.Schemas.vscodeNotebookCell;function ce(be,re){return(0,R.$MK)(be,re)}W.generate=ce;function ge(be){return(0,R.$LK)(be)}W.parse=ge;function te(be,re){return be.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${be.scheme!==A.Schemas.file?be.scheme:""}`})}W.generateCellOutputUri=te;function me(be){if(be.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!re)return;const Pe=re[1]&&re[1]!==""?re[1]:void 0,Fe=re[2];return{outputId:Pe,notebook:be.with({scheme:Fe||A.Schemas.file,fragment:null})}}W.parseCellOutputUri=me;function se(be,re,Pe){return W.generate(be,re).with({scheme:Pe})}W.generateCellPropertyUri=se;function de(be,re){if(be.scheme===re)return W.parse(be.with({scheme:W.scheme}))}W.parseCellPropertyUri=de})(s||(e.CellUri=s={}));const i=W=>p.$i?W.replace(/\//g,"\\"):W;class t{constructor(ce=[],ge=e.$TK){this.e=ge,this.d=[...new Set(ce)].map(te=>({pattern:te,matches:C.$yk(i(te))}))}sort(ce){const ge=new Map(P.Iterable.map(ce,me=>[me,i(me)]));let te=[];for(const{matches:me}of this.d)for(const[se,de]of ge)if(me(de)){te.push(se),ge.delete(se);break}return ge.size&&(te=te.concat([...ge.keys()].sort((me,se)=>this.e.indexOf(me)-this.e.indexOf(se)))),te}prioritize(ce,ge){const te=this.f(ce);if(te===-1){this.d.unshift({pattern:ce,matches:C.$yk(i(ce))});return}const me=new Set(ge.map(de=>this.f(de,te)));me.delete(-1);const se=Array.from(me).sort();this.d.splice(te+1,0,...se.map(de=>this.d[de]));for(let de=se.length-1;de>=0;de--)this.d.splice(se[de],1)}toArray(){return this.d.map(ce=>ce.pattern)}f(ce,ge=this.d.length){const te=i(ce);for(let me=0;me<ge;me++)if(this.d[me].matches(te))return me;return-1}}e.$XK=t;function m(W,ce,ge,te=(me,se)=>me===se){const me=[];function se(re,Pe,Fe){if(Pe===0&&Fe.length===0)return;const X=me[me.length-1];X&&X.start+X.deleteCount===re?(X.deleteCount+=Pe,X.toInsert.push(...Fe)):me.push({start:re,deleteCount:Pe,toInsert:Fe})}let de=0,be=0;for(;;){if(de===W.length){se(de,0,ce.slice(be));break}if(be===ce.length){se(de,W.length-de,[]);break}const re=W[de],Pe=ce[be];if(te(re,Pe)){de+=1,be+=1;continue}ge(Pe)?(se(de,1,[]),de+=1):(se(de,0,[Pe]),be+=1)}return me}e.$ZK=new c.$Vj("notebookEditorCursorAtBoundary","none"),e.$1K=new c.$Vj("notebookEditorCursorAtLineBoundary","none");var f;(function(W){W.default="default",W.option="option"})(f||(e.NotebookEditorPriority=f={}));function u(W){const ce=W;return!!((typeof ce.include=="string"||C.$zk(ce.include))&&(typeof ce.exclude=="string"||C.$zk(ce.exclude)))}function $(W,ce,ge){if(Array.isArray(W.viewType)&&W.viewType.indexOf(ce)>=0||W.viewType===ce)return!0;if(W.filenamePattern){const te=u(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,me=u(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(C.$xk(te,(0,N.$oc)(ge.fsPath).toLowerCase()))return!(me&&C.$xk(me,(0,N.$oc)(ge.fsPath).toLowerCase()))}return!1}e.$4K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class D{static{this.d="notebook/"}static create(ce){return`${D.d}${ce}`}static parse(ce){if(ce.startsWith(D.d))return ce.substring(D.d.length)}}e.$5K=D;function y(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}const S=new TextDecoder;function k(W){const ce=[];let ge=!1;for(const de of W)(ce.length===0||ge)&&(ce.push(de),ge=!0);let te=F(ce);const me=w.$Ne.concat(ce.map(de=>w.$Ne.wrap(de))),se=O(me);return te=te||se.byteLength!==me.byteLength,{data:se,didCompression:te}}e.$8K="\x1B[A";const g=e.$8K.split("").map(W=>W.charCodeAt(0)),b=10;function F(W){let ce=!1;return W.forEach((ge,te)=>{if(te===0||ge.length<e.$8K.length)return;const me=W[te-1],se=ge.subarray(0,e.$8K.length);if(se[0]===g[0]&&se[1]===g[1]&&se[2]===g[2]){const de=me.lastIndexOf(b);if(de===-1)return;ce=!0,W[te-1]=me.subarray(0,de),W[te]=ge.subarray(e.$8K.length)}}),ce}function T(W){let ce=W;do W=ce,ce=W.replace(/[^\n]\x08/gm,"");while(ce.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const ce=W.match(/^(.*)\r+/m)[1];let ge=W.match(/\r+(.*)$/m)[1];ge=ge+ce.slice(ge.length,ce.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ge)}return W}const G=8,V=13;function O(W){return!W.buffer.includes(G)&&!W.buffer.includes(V)?W:w.$Ne.fromString(q(T(S.decode(W.buffer))))}}),define(Ce[7],Ie([1,0,18,14,60,29,73,13,15,2,37,19,30,109,90]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d){"use strict";var r,o,a,h,n,s,i,t,m,f,u,$,I,D,y,S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$jP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$YO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LO=e.$KO=e.$JO=e.$IO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestRunProfileKind=e.TestResultState=e.$CO=e.$BO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$AO=e.NotebookVariablesRequestKind=e.$zO=e.$yO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$xO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.ColorThemeKind=e.$rO=e.$qO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$pO=e.$oO=e.DebugConsoleMode=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$iO=e.$hO=e.FileChangeType=e.$gO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$fO=e.$eO=e.$dO=e.$cO=e.InlineCompletionTriggerKind=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$2N=e.ConfigurationTarget=e.$1N=e.$ZN=e.$YN=e.$XN=e.DocumentPasteTriggerKind=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$QN=e.ViewBadge=e.ProgressLocation=e.$PN=e.$ON=e.TaskScope=e.ShellQuoting=e.$NN=e.$MN=e.$LN=e.TaskPanelKind=e.TaskRevealKind=e.$KN=e.TerminalLocation=e.$JN=e.$IN=e.$HN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$GN=e.$FN=e.$EN=e.$DN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$BN=e.$AN=e.$zN=e.$yN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$xN=e.$wN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.LanguageStatusSeverity=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.CodeActionTriggerKind=e.$kN=e.$jN=e.SymbolTag=e.SymbolKind=e.$iN=e.$hN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.DiagnosticSeverity=e.DiagnosticTag=e.$bN=e.$aN=e.FileEditType=e.$_M=e.$$M=e.$0M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$CN=Ye,e.$3N=Mi,e.$HO=Sn;function g(j){return Object.assign(j,{apply:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const Se=ie.length===1?[]:ie[1];return Reflect.construct(j,Se,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const[Se,...Je]=ie;return Reflect.construct(j,Je,Se.constructor)}}})}var b;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var F;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let T=r=class{static from(...L){let ie=L;return new r(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$3M=T,e.$3M=T=r=He([g],T);let q=o=class{static Min(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let Se=1;Se<L.length;Se++){const Je=L[Se];Je.isBefore(ie)&&(ie=Je)}return ie}static Max(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let Se=1;Se<L.length;Se++){const Je=L[Se];Je.isAfter(ie)&&(ie=Je)}return ie}static isPosition(L){if(!L)return!1;if(L instanceof o)return!0;const{line:ie,character:Se}=L;return typeof ie=="number"&&typeof Se=="number"}static of(L){if(L instanceof o)return L;if(this.isPosition(L))return new o(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ie){if(L<0)throw(0,C.$8)("line must be non-negative");if(ie<0)throw(0,C.$8)("character must be non-negative");this.c=L,this.e=ie}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ie=0){if(L===null||ie===null)throw(0,C.$8)();let Se;return typeof L>"u"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,ie=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&ie===0?this:new o(this.line+Se,this.character+ie)}with(L,ie=this.character){if(L===null||ie===null)throw(0,C.$8)();let Se;return typeof L>"u"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,ie=typeof L.character=="number"?L.character:this.character),Se===this.line&&ie===this.character?this:new o(Se,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$4M=q,e.$4M=q=o=He([g],q);let G=a=class{static isRange(L){return L instanceof a?!0:L?q.isPosition(L.start)&&q.isPosition(L.end):!1}static of(L){if(L instanceof a)return L;if(this.isRange(L))return new a(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ie,Se,Je){let et,ft;if(typeof L=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new q(L,ie),ft=new q(Se,Je)):q.isPosition(L)&&q.isPosition(ie)&&(et=q.of(L),ft=q.of(ie)),!et||!ft)throw new Error("Invalid arguments");et.isBefore(ft)?(this.c=et,this.e=ft):(this.c=ft,this.e=et)}contains(L){return a.isRange(L)?this.contains(L.start)&&this.contains(L.end):q.isPosition(L)?!(q.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ie=q.Max(L.start,this.c),Se=q.Min(L.end,this.e);if(!ie.isAfter(Se))return new a(ie,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ie=q.Min(L.start,this.c),Se=q.Max(L.end,this.end);return new a(ie,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ie=this.end){if(L===null||ie===null)throw(0,C.$8)();let Se;return L?q.isPosition(L)?Se=L:(Se=L.start||this.start,ie=L.end||this.end):Se=this.start,Se.isEqual(this.c)&&ie.isEqual(this.end)?this:new a(Se,ie)}toJSON(){return[this.start,this.end]}};e.$5M=G,e.$5M=G=a=He([g],G);let V=h=class extends G{static isSelection(L){return L instanceof h?!0:L?G.isRange(L)&&q.isPosition(L.anchor)&&q.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ie,Se,Je){let et,ft;if(typeof L=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new q(L,ie),ft=new q(Se,Je)):q.isPosition(L)&&q.isPosition(ie)&&(et=q.of(L),ft=q.of(ie)),!et||!ft)throw new Error("Invalid arguments");super(et,ft),this.f=et,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$6M=V,e.$6M=V=h=He([g],V);const O=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,C.$8)("connectionToken")};class W{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ie,Se){if(typeof L!="string"||L.length===0)throw(0,C.$8)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.$8)("port");typeof Se<"u"&&O(Se),this.host=L,this.port=Math.round(ie),this.connectionToken=Se}}e.$7M=W;class ce{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ie){this.makeConnection=L,this.connectionToken=ie,typeof ie<"u"&&O(ie)}}e.$8M=ce;class ge extends Error{static NotAvailable(L,ie){return new ge(L,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(L){return new ge(L,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ie=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L),this._message=L,this._code=ie,this._detail=Se,Object.setPrototypeOf(this,ge.prototype)}}e.$9M=ge;var te;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(te||(e.EndOfLine=te={}));var me;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(me||(e.EnvironmentVariableMutatorType=me={}));let se=n=class{static isTextEdit(L){return L instanceof n?!0:L?G.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ie){return new n(L,ie)}static insert(L,ie){return n.replace(new G(L,L),ie)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const ie=new n(new G(new q(0,0),new q(0,0)),"");return ie.newEol=L,ie}get range(){return this.c}set range(L){if(L&&!G.isRange(L))throw(0,C.$8)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,C.$8)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,C.$8)("newEol");this.f=L}constructor(L,ie){this.c=L,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$0M=se,e.$0M=se=n=He([g],se);let de=s=class{static isNotebookCellEdit(L){return L instanceof s?!0:L?yi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ie){return new s(L,ie)}static insertCells(L,ie){return new s(new yi(L,L),ie)}static deleteCells(L){return new s(L,[])}static updateCellMetadata(L,ie){const Se=new s(new yi(L,L),[]);return Se.newCellMetadata=ie,Se}static updateNotebookMetadata(L){const ie=new s(new yi(0,0),[]);return ie.newNotebookMetadata=L,ie}constructor(L,ie){this.range=L,this.newCells=ie}};e.$$M=de,e.$$M=de=s=He([g],de);class be{static isSnippetTextEdit(L){return L instanceof be?!0:L?G.isRange(L.range)&&Fe.isSnippetString(L.snippet):!1}static replace(L,ie){return new be(L,ie)}static insert(L,ie){return be.replace(new G(L,L),ie)}constructor(L,ie){this.range=L,this.snippet=ie}}e.$_M=be;var re;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ie,Se,Je){this.c.push({_type:re.File,from:L,to:ie,options:Se,metadata:Je})}createFile(L,ie,Se){this.c.push({_type:re.File,from:void 0,to:L,options:ie,metadata:Se})}deleteFile(L,ie,Se){this.c.push({_type:re.File,from:L,to:void 0,options:ie,metadata:Se})}e(L,ie,Se){this.c.push({_type:re.Cell,metadata:Se,uri:L,edit:{editType:d.CellEditType.DocumentMetadata,metadata:ie},notebookMetadata:ie})}f(L,ie,Se,Je){const et=ie.start,ft=ie.end;(et!==ft||Se.length>0)&&this.c.push({_type:re.CellReplace,uri:L,index:et,count:ft-et,cells:Se,metadata:Je})}g(L,ie,Se,Je){this.c.push({_type:re.Cell,metadata:Je,uri:L,edit:{editType:d.CellEditType.Metadata,index:ie,metadata:Se}})}replace(L,ie,Se,Je){this.c.push({_type:re.Text,uri:L,edit:new se(ie,Se),metadata:Je})}insert(L,ie,Se,Je){this.replace(L,new G(ie,ie),Se,Je)}delete(L,ie,Se){this.replace(L,ie,"",Se)}has(L){return this.c.some(ie=>ie._type===re.Text&&ie.uri.toString()===L.toString())}set(L,ie){if(ie)for(const Se of ie){if(!Se)continue;let Je,et;Array.isArray(Se)?(Je=Se[0],et=Se[1]):Je=Se,de.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(L,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(L,Je.newNotebookMetadata,et):this.f(L,Je.range,Je.newCells,et):be.isSnippetTextEdit(Je)?this.c.push({_type:re.Snippet,uri:L,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:re.Text,uri:L,edit:Je,metadata:et})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Je.uri.toString()===L.toString()&&(this.c[Se]=void 0);break}}(0,w.$Jb)(this.c)}}get(L){const ie=[];for(const Se of this.c)Se._type===re.Text&&Se.uri.toString()===L.toString()&&ie.push(Se.edit);return ie}entries(){const L=new M.$Bc;for(const ie of this.c)if(ie._type===re.Text){let Se=L.get(ie.uri);Se||(Se=[ie.uri,[]],L.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$aN=Pe,e.$aN=Pe=He([g],Pe);let Fe=i=class{static isSnippetString(L){return L instanceof i?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=i.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ie=this.e++){if(typeof L=="function"){const Se=new i;Se.e=this.e,L(Se),this.e=Se.e,L=Se.value}else L=i.c(L);return this.value+="${",this.value+=ie,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ie=this.e++){const Se=L.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,ie){if(typeof ie=="function"){const Se=new i;Se.e=this.e,ie(Se),this.e=Se.e,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$bN=Fe,e.$bN=Fe=i=He([g],Fe);var X;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var B;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(B||(e.DiagnosticSeverity=B={}));let _=t=class{static isLocation(L){return L instanceof t?!0:L?G.isRange(L.range)&&c.URI.isUri(L.uri):!1}constructor(L,ie){if(this.uri=L,ie)if(G.isRange(ie))this.range=G.of(ie);else if(q.isPosition(ie))this.range=new G(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$cN=_,e.$cN=_=t=He([g],_);let we=class{static is(L){return L?typeof L.message=="string"&&L.location&&G.isRange(L.location.range)&&c.URI.isUri(L.location.uri):!1}constructor(L,ie){this.location=L,this.message=ie}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.location.range.isEqual(ie.location.range)&&L.location.uri.toString()===ie.location.uri.toString()}};e.$dN=we,e.$dN=we=He([g],we);let ae=class{constructor(L,ie,Se=B.Error){if(!G.isRange(L))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=L,this.message=ie,this.severity=Se}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.severity===ie.severity&&L.code===ie.code&&L.severity===ie.severity&&L.source===ie.source&&L.range.isEqual(ie.range)&&(0,w.$vb)(L.tags,ie.tags)&&(0,w.$vb)(L.relatedInformation,ie.relatedInformation,we.isEqual)}};e.$eN=ae,e.$eN=ae=He([g],ae);let ve=class{constructor(L,ie){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ie}};e.$fN=ve,e.$fN=ve=He([g],ve);let ue=class extends ve{constructor(L,ie,Se,Je){super(L,ie),this.canIncreaseHover=Se,this.canDecreaseHover=Je}};e.$gN=ue,e.$gN=ue=He([g],ue);var Z;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Z||(e.HoverVerbosityAction=Z={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let pe=class{constructor(L,ie=Y.Text){this.range=L,this.kind=ie}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$hN=pe,e.$hN=pe=He([g],pe);let $e=class{constructor(L,ie){this.uri=L,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$iN=$e,e.$iN=$e=He([g],$e);var Ne;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var Ue;(function(j){j[j.Deprecated=1]="Deprecated"})(Ue||(e.SymbolTag=Ue={}));let ke=m=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ie,Se,Je,et){this.name=L,this.kind=ie,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),Je instanceof _?this.location=Je:Se instanceof G&&(this.location=new _(Je,Se)),m.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$jN=ke,e.$jN=ke=m=He([g],ke);let Re=f=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(f.validate)}constructor(L,ie,Se,Je,et){this.name=L,this.detail=ie,this.kind=Se,this.range=Je,this.selectionRange=et,this.children=[],f.validate(this)}};e.$kN=Re,e.$kN=Re=f=He([g],Re);var Me;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Me||(e.CodeActionTriggerKind=Me={}));let z=class{constructor(L,ie){this.title=L,this.kind=ie}};e.$lN=z,e.$lN=z=He([g],z);let U=class{static{u=this}static{this.c="."}constructor(L){this.value=L}append(L){return new u(this.value?this.value+u.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+u.c)}};e.$mN=U,e.$mN=U=u=He([g],U),U.Empty=new U(""),U.QuickFix=U.Empty.append("quickfix"),U.Refactor=U.Empty.append("refactor"),U.RefactorExtract=U.Refactor.append("extract"),U.RefactorInline=U.Refactor.append("inline"),U.RefactorMove=U.Refactor.append("move"),U.RefactorRewrite=U.Refactor.append("rewrite"),U.Source=U.Empty.append("source"),U.SourceOrganizeImports=U.Source.append("organizeImports"),U.SourceFixAll=U.Source.append("fixAll"),U.Notebook=U.Empty.append("notebook");let K=class{constructor(L,ie){if(this.range=L,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$nN=K,e.$nN=K=He([g],K);class J{constructor(L,ie,Se,Je,et,ft){this.kind=L,this.name=ie,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=ft}}e.$oN=J;class ne{constructor(L,ie){this.fromRanges=ie,this.from=L}}e.$pN=ne;class fe{constructor(L,ie){this.fromRanges=ie,this.to=L}}e.$qN=fe;var Ae;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let ze=class{constructor(L,ie){this.range=L,this.command=ie}get isResolved(){return!!this.command}};e.$rN=ze,e.$rN=ze=He([g],ze);let Ke=$=class{#e;static isMarkdownString(L){return L instanceof $?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ie=!1){this.#e=new P.$2k(L,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ie){return this.#e.appendCodeblock(ie??"",L),this}};e.$sN=Ke,e.$sN=Ke=$=He([g],Ke);let _e=class{constructor(L,ie){this.label=L,this.documentation=ie}};e.$tN=_e,e.$tN=_e=He([g],_e);let it=class{constructor(L,ie){this.label=L,this.documentation=ie,this.parameters=[]}};e.$uN=it,e.$uN=it=He([g],it);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$vN=nt,e.$vN=nt=He([g],nt);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let $t=class{constructor(L){this.value=L}};e.$wN=$t,e.$wN=$t=He([g],$t);let ut=class{constructor(L,ie,Se){this.position=L,this.label=ie,this.kind=Se}};e.$xN=ut,e.$xN=ut=He([g],ut);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ct;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ct||(e.CompletionItemKind=ct={}));var gt;(function(j){j[j.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let mt=class{constructor(L,ie){this.label=L,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$yN=mt,e.$yN=mt=He([g],mt);let Be=class{constructor(L=[],ie=!1){this.items=L,this.isIncomplete=ie}};e.$zN=Be,e.$zN=Be=He([g],Be);let je=class{constructor(L,ie,Se){this.insertText=L,this.range=ie,this.command=Se}};e.$AN=je,e.$AN=je=He([g],je);let H=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$BN=H,e.$BN=H=He([g],H);var x;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var De;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(De||(e.ViewColumn=De={}));var Ze;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ze||(e.StatusBarAlignment=Ze={}));function Ye(j,L){return`${v.$pn.toKey(j)}.${L}`}var dt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(dt||(e.TextEditorLineNumbersStyle=dt={}));var pt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(pt||(e.TextDocumentSaveReason=pt={}));var Ft;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var zt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var xt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var ui;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(j){function L(ie){switch(ie){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(zt||(e.TextEditorSelectionChangeKind=zt={}));var xe;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(j){function L(ie){switch(ie){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(xe||(e.SyntaxTokenType=xe={}));let It=class{constructor(L,ie){if(ie&&!c.URI.isUri(ie))throw(0,C.$8)("target");if(!G.isRange(L)||L.isEmpty)throw(0,C.$8)("range");this.range=L,this.target=ie}};e.$DN=It,e.$DN=It=He([g],It);let Gt=class{constructor(L,ie,Se,Je){this.red=L,this.green=ie,this.blue=Se,this.alpha=Je}};e.$EN=Gt,e.$EN=Gt=He([g],Gt);let ht=class{constructor(L,ie){if(ie&&!(ie instanceof Gt))throw(0,C.$8)("color");if(!G.isRange(L)||L.isEmpty)throw(0,C.$8)("range");this.range=L,this.color=ie}};e.$FN=ht,e.$FN=ht=He([g],ht);let bt=class{constructor(L){if(!L||typeof L!="string")throw(0,C.$8)("label");this.label=L}};e.$GN=bt,e.$GN=bt=He([g],bt);var hi;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(hi||(e.ColorFormat=hi={}));var _t;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var jt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var wt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Bt{constructor(L,ie,Se){if(this.startIndex=L,this.length=ie,this.tooltip=Se,typeof L!="number"||L<0)throw(0,C.$8)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.$8)("length");if(Se!==void 0&&typeof Se!="string")throw(0,C.$8)("tooltip")}}e.$HN=Bt;class Jt{constructor(L){this.uri=L}}e.$IN=Jt;class Qt{constructor(L){this.terminalCommand=L}}e.$JN=Qt;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class pi{constructor(L){if(this.options=L,typeof L!="object")throw(0,C.$8)("options")}}e.$KN=pi;var ei;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ei||(e.TaskRevealKind=ei={}));var si;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(si||(e.TaskPanelKind=si={}));let St=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(L){switch(L){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(L,ie){if(this.label=ie,typeof L!="string"||typeof ie!="string")throw(0,C.$8)("name");this.c=L}get id(){return this.c}};e.$LN=St,e.$LN=St=I=He([g],St);function Kt(j){let L="";for(let ie=0;ie<j.length;ie++)L+=j[ie].replace(/,/g,",,")+",";return L}let At=class{constructor(L,ie,Se){if(typeof L!="string")throw(0,C.$8)("process");this.e=[],this.c=L,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Se):this.f=ie)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,C.$8)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)L.push(ie);return Kt(L)}};e.$MN=At,e.$MN=At=He([g],At);let Ot=class{constructor(L,ie,Se){if(this.f=[],Array.isArray(ie)){if(!L)throw(0,C.$8)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,C.$8)("command");this.e=L,this.f=ie,this.g=Se}else{if(typeof L!="string")throw(0,C.$8)("commandLine");this.c=L,this.g=ie}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,C.$8)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,C.$8)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)L.push(typeof ie=="string"?ie:ie.value);return Kt(L)}};e.$NN=Ot,e.$NN=Ot=He([g],Ot);var ti;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var ii;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ii||(e.TaskScope=ii={}));class oi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,R.$1g)()}set callback(L){this.c=L}get callback(){return this.c}}e.$ON=oi;let Vt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ie,Se,Je,et,ft){this.k=!1,this.l=this.definition=L;let yt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=Se,this.execution=Je,yt=et,this.k=!0):ie===ii.Global||ie===ii.Workspace?(this.target=ie,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,yt=ft):(this.target=ie,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,yt=ft),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$1g)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,C.$8)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,C.$8)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const ie=this.l.type;(D.g===ie||D.e===ie||D.f===ie||D.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,C.$8)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$PN=Vt,e.$PN=Vt=D=He([g],Vt);var Ht;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Ht||(e.ProgressLocation=Ht={}));var di;(function(j){function L(ie){const Se=ie;return(0,p.$ig)(Se.value)?Se.tooltip&&!(0,p.$eg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=L})(di||(e.ViewBadge=di={}));let Lt=y=class{static isTreeItem(L,ie){const Se=L;if(Se.checkboxState!==void 0){const Je=(0,p.$ig)(Se.checkboxState)?Se.checkboxState:(0,p.$gg)(Se.checkboxState)&&(0,p.$ig)(Se.checkboxState.state)?Se.checkboxState.state:void 0,et=!(0,p.$ig)(Se.checkboxState)&&(0,p.$gg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ct.Checked&&Je!==Ct.Unchecked||et!==void 0&&!(0,p.$eg)(et))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(L instanceof y)return!0;if(Se.label!==void 0&&!(0,p.$eg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$eg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$eg)(Se.iconPath)&&!c.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$eg)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,p.$eg)(Je.light)&&!c.URI.isUri(Je.light)&&!(0,p.$eg)(Je.dark)&&!c.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$eg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!c.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$eg)(Se.tooltip)&&!(Se.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$eg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(L,ie=vt.None){this.collapsibleState=ie,c.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$QN=Lt,e.$QN=Lt=y=He([g],Lt);var vt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Ct;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let Tt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$RN=Tt,e.$RN=Tt=He([g],Tt);class kt extends Tt{}e.$SN=kt;class Zt extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$TN=Zt;class qt{constructor(L,ie,Se,Je){this.name=L,this.uri=ie,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$UN=qt;let $i=class{#e=new Map;constructor(L){for(const[ie,Se]of L??[]){const Je=this.#e.get(this.#t(ie));Je?Je.push(Se):this.#e.set(this.#t(ie),[Se])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ie){this.#e.set(this.#t(L),[ie])}forEach(L,ie){for(const[Se,Je]of this.#e)for(const et of Je)L.call(ie,et,Se,this)}*[Symbol.iterator](){for(const[L,ie]of this.#e)for(const Se of ie)yield[L,Se]}#t(L){return L.toLowerCase()}};e.$VN=$i,e.$VN=$i=He([g],$i);let fi=class{constructor(L,ie,Se){this.insertText=L,this.title=ie,this.kind=Se}};e.$WN=fi,e.$WN=fi=He([g],fi);var Ri;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(Ri||(e.DocumentPasteTriggerKind=Ri={}));class Nt{static{this.c="."}constructor(L){this.value=L}append(...L){return new Nt((this.value?[this.value,...L]:L).join(Nt.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+Nt.c)}}e.$XN=Nt,Nt.Empty=new Nt("");class Ti{constructor(L,ie,Se){this.title=ie,this.insertText=L,this.kind=Se}}e.$YN=Ti;let ai=class{constructor(L,ie){this.id=L,this.color=ie}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$ZN=ai,e.$ZN=ai=He([g],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Rt=class{constructor(L){this.id=L}};e.$1N=Rt,e.$1N=Rt=He([g],Rt);var Di;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Di||(e.ConfigurationTarget=Di={}));let Si=class{get base(){return this.c}set base(L){this.c=L,this.e=c.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ie){if(typeof L!="string"&&(!L||!c.URI.isUri(L)&&!c.URI.isUri(L.uri)))throw(0,C.$8)("base");if(typeof ie!="string")throw(0,C.$8)("pattern");typeof L=="string"?this.baseUri=c.URI.file(L):c.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$2N=Si,e.$2N=Si=He([g],Si);const vi=new WeakMap;function Mi(j,L){vi.set(j,L)}let gi=class{constructor(L,ie,Se,Je,et){this.enabled=typeof L=="boolean"?L:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=vi.get(this)??(0,R.$1g)()),this.c}};e.$4N=gi,e.$4N=gi=He([g],gi);let Wt=class extends gi{constructor(L,ie,Se,Je,et,ft){if(super(ie,Se,Je,et,ft),L===null)throw(0,C.$8)("location");this.location=L}};e.$5N=Wt,e.$5N=Wt=He([g],Wt);let ye=class extends gi{constructor(L,ie,Se,Je,et,ft){super(ie,Se,Je,et,ft),this.functionName=L}};e.$6N=ye,e.$6N=ye=He([g],ye);let Te=class extends gi{constructor(L,ie,Se,Je,et,ft,yt,Yt){if(super(Je,et,ft,yt,Yt),!ie)throw(0,C.$8)("dataId");this.label=L,this.dataId=ie,this.canPersist=Se}};e.$7N=Te,e.$7N=Te=He([g],Te);let le=class{constructor(L,ie,Se){this.command=L,this.args=ie||[],this.options=Se}};e.$8N=le,e.$8N=le=He([g],le);let Q=class{constructor(L,ie){this.port=L,this.host=ie}};e.$9N=Q,e.$9N=Q=He([g],Q);let Ee=class{constructor(L){this.path=L}};e.$0N=Ee,e.$0N=Ee=He([g],Ee);let Ve=class{constructor(L){this.implementation=L}};e.$$N=Ve,e.$$N=Ve=He([g],Ve);class Xe{constructor(L,ie,Se){this.session=L,this.threadId=ie,this.frameId=Se}}e.$_N=Xe;class Ge{constructor(L,ie){this.session=L,this.threadId=ie}}e.$aO=Ge;let lt=class{constructor(L,ie){this.range=L,this.expression=ie}};e.$bO=lt,e.$bO=lt=He([g],lt);var Pt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Pt||(e.InlineCompletionTriggerKind=Pt={}));let Xt=class{constructor(L,ie){this.range=L,this.text=ie}};e.$cO=Xt,e.$cO=Xt=He([g],Xt);let ci=class{constructor(L,ie,Se=!0){this.range=L,this.variableName=ie,this.caseSensitiveLookup=Se}};e.$dO=ci,e.$dO=ci=He([g],ci);let Ut=class{constructor(L,ie){this.range=L,this.expression=ie}};e.$eO=Ut,e.$eO=Ut=He([g],Ut);let ni=class{constructor(L,ie){this.frameId=L,this.stoppedLocation=ie}};e.$fO=ni,e.$fO=ni=He([g],ni);var ji;(function(j){j[j.AIGenerated=1]="AIGenerated"})(ji||(e.NewSymbolNameTag=ji={}));var Yi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Yi||(e.NewSymbolNameTriggerKind=Yi={}));class Bi{constructor(L,ie){this.newSymbolName=L,this.tags=ie}}e.$gO=Bi;var Oi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Vi=S=class extends Error{static FileExists(L){return new S(L,l.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound(L){return new S(L,l.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory(L){return new S(L,l.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory(L){return new S(L,l.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions(L){return new S(L,l.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable(L){return new S(L,l.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}constructor(L,ie=l.FileSystemProviderErrorCode.Unknown,Se){super(c.URI.isUri(L)?L.toString(!0):L),this.code=Se?.name??"Unknown",(0,l.$nl)(this,ie),Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$hO=Vi,e.$hO=Vi=S=He([g],Vi);let Wi=class{constructor(L,ie,Se){this.start=L,this.end=ie,this.kind=Se}};e.$iO=Wi,e.$iO=Wi=He([g],Wi);var ki;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Fi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Fi||(e.CommentState=Fi={}));var en;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class pn{constructor(L,ie=[]){this.tokenTypes=L,this.tokenModifiers=ie}}e.$jO=pn;function tn(j){return typeof j>"u"||(0,p.$fg)(j)}class Gi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let ie=0,Se=L.tokenTypes.length;ie<Se;ie++)this.k.set(L.tokenTypes[ie],ie);for(let ie=0,Se=L.tokenModifiers.length;ie<Se;ie++)this.l.set(L.tokenModifiers[ie],ie)}}push(L,ie,Se,Je,et){if(typeof L=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(L,ie,Se,Je,et);if(G.isRange(L)&&typeof ie=="string"&&tn(Se))return this.o(L,ie,Se);throw(0,C.$8)()}o(L,ie,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Je=L.start.line,et=L.start.character,ft=L.end.character-L.start.character,yt=this.k.get(ie);let Yt=0;if(Se)for(const mi of Se){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(mi);Yt|=1<<wi>>>0}this.q(Je,et,ft,yt,Yt)}q(L,ie,Se,Je,et){if(this.f&&(L<this.c||L===this.c&&ie<this.e)){this.f=!1;const Yt=this.g.length/5|0;let mi=0,wi=0;for(let Ei=0;Ei<Yt;Ei++){let Pi=this.g[5*Ei],Zi=this.g[5*Ei+1];Pi===0?(Pi=mi,Zi+=wi):Pi+=mi,this.g[5*Ei]=Pi,this.g[5*Ei+1]=Zi,mi=Pi,wi=Zi}}let ft=L,yt=ie;this.f&&this.j>0&&(ft-=this.c,ft===0&&(yt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=et,this.c=L,this.e=ie}static r(L){const ie=[],Se=L.length/5|0;for(let yt=0;yt<Se;yt++)ie[yt]=yt;ie.sort((yt,Yt)=>{const mi=L[5*yt],wi=L[5*Yt];if(mi===wi){const Ei=L[5*yt+1],Pi=L[5*Yt+1];return Ei-Pi}return mi-wi});const Je=new Uint32Array(L.length);let et=0,ft=0;for(let yt=0;yt<Se;yt++){const Yt=5*ie[yt],mi=L[Yt+0],wi=L[Yt+1],Ei=L[Yt+2],Pi=L[Yt+3],Zi=L[Yt+4],jn=mi-et,kr=jn===0?wi-ft:wi,Xi=5*yt;Je[Xi+0]=jn,Je[Xi+1]=kr,Je[Xi+2]=Ei,Je[Xi+3]=Pi,Je[Xi+4]=Zi,et=mi,ft=wi}return Je}build(L){return this.f?new Ci(new Uint32Array(this.g),L):new Ci(Gi.r(this.g),L)}}e.$kO=Gi;class Ci{constructor(L,ie){this.resultId=ie,this.data=L}}e.$lO=Ci;class $n{constructor(L,ie,Se){this.start=L,this.deleteCount=ie,this.data=Se}}e.$mO=$n;class bn{constructor(L,ie){this.resultId=ie,this.edits=L}}e.$nO=bn;var nn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Ki{constructor(L){this.name=L}}e.$oO=Ki;let Li=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$pO=Li,e.$pO=Li=He([g],Li);var Le;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Le||(e.QuickPickItemKind=Le={}));var bi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(bi||(e.InputBoxValidationSeverity=bi={}));var Hi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Hi||(e.ExtensionKind=Hi={}));class ot{static validate(L){if(typeof L.badge=="string"){let ie=(0,N.$Pf)(L.badge,0);if(ie<L.badge.length&&(ie+=(0,N.$Pf)(L.badge,ie)),L.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!ai.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ie,Se){this.badge=L,this.tooltip=ie,this.color=Se}}e.$qO=ot;let Et=class{constructor(L){this.kind=L}};e.$rO=Et,e.$rO=Et=He([g],Et);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class yi{static isNotebookRange(L){return L instanceof yi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ie){if(L<0)throw(0,C.$8)("start must be positive");if(ie<0)throw(0,C.$8)("end must be positive");L<=ie?(this.c=L,this.e=ie):(this.c=ie,this.e=L)}with(L){let ie=this.c,Se=this.e;return L.start!==void 0&&(ie=L.start),L.end!==void 0&&(Se=L.end),ie===this.c&&Se===this.e?this:new yi(ie,Se)}}e.$sO=yi;class Ni{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ie=>Ni.isNotebookCellData(ie))}static isNotebookCellData(L){return!0}constructor(L,ie,Se,Je,et,ft,yt){this.kind=L,this.value=ie,this.languageId=Se,this.mime=Je,this.outputs=et??[],this.metadata=ft,this.executionSummary=yt,Ni.validate(this)}}e.$tO=Ni;class wn{constructor(L){this.cells=L}}e.$uO=wn;class li{static isNotebookCellOutputItem(L){return L instanceof li?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ie={name:L.name,message:L.message,stack:L.stack};return li.json(ie,"application/vnd.code.notebook.error")}static stdout(L){return li.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return li.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ie="application/octet-stream"){return new li(L,ie)}static#e=new TextEncoder;static text(L,ie=A.$4s.text){const Se=li.#e.encode(String(L));return new li(Se,ie)}static json(L,ie="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return li.text(Se,ie)}constructor(L,ie){this.data=L,this.mime=ie;const Se=(0,A.$8s)(ie,!0);if(!Se)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$vO=li;class Ui{static isNotebookCellOutput(L){return L instanceof Ui?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ie=!1){const Se=new Set,Je=new Set;for(let et=0;et<L.length;et++){const ft=L[et],yt=(0,A.$8s)(ft.mime);if(!Se.has(yt)||(0,d.$6K)(yt)){Se.add(yt);continue}Je.add(et),ie&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return Je.size===0?L:L.filter((et,ft)=>!Je.has(ft))}constructor(L,ie,Se){this.items=Ui.ensureUniqueMimeTypes(L,!0),typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=(0,R.$1g)(),this.metadata=ie??Se)}}e.$wO=Ui;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ji;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var an;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(L,ie){this.text=L,this.alignment=ie}}e.$xO=vn;var cn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var ln;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class yn{constructor(L,ie=[]){this.uri=L,this.provides=(0,w.$3b)(ie)}}e.$yO=yn;class En{constructor(L){this.label=L}}e.$zO=En;var un;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(un||(e.NotebookVariablesRequestKind=un={}));let Qi=class{constructor(L,ie){this.label=L,this.timestamp=ie}};e.$AO=Qi,e.$AO=Qi=He([g],Qi);var hn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ee{constructor(L,ie){this.ranges=L,this.wordPattern=ie}}e.$BO=ee;class he{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$CO=he;var Oe;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Oe||(e.TestResultState=Oe={}));var at;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let Dt=class{constructor(L=void 0,ie=void 0,Se=void 0,Je=!1,et=!0){this.include=L,this.exclude=ie,this.profile=Se,this.continuous=Je,this.preserveFocus=et}};e.$DO=Dt,e.$DO=Dt=He([g],Dt);let Mt=k=class{static diff(L,ie,Se){const Je=new k(L);return Je.expectedOutput=ie,Je.actualOutput=Se,Je}constructor(L){this.message=L}};e.$EO=Mt,e.$EO=Mt=k=He([g],Mt);let Ii=class{constructor(L){this.id=L}};e.$FO=Ii,e.$FO=Ii=He([g],Ii);class zi{constructor(L,ie){this.covered=L,this.total=ie,Sn(this)}}e.$GO=zi;function Sn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class Dn{static fromDetails(L,ie){const Se=new zi(0,0),Je=new zi(0,0),et=new zi(0,0);for(const yt of ie)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const Yt of yt.branches)Je.total+=1,Je.covered+=Yt.executed?1:0}else et.total+=1,et.covered+=yt.executed?1:0;const ft=new Dn(L,Se,Je.total>0?Je:void 0,et.total>0?et:void 0);return ft.detailedCoverage=ie,ft}constructor(L,ie,Se,Je,et){this.uri=L,this.statementCoverage=ie,this.branchCoverage=Se,this.declarationCoverage=Je,this.testItem=et}}e.$IO=Dn;class Wn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ie,Se=[]){this.executed=L,this.location=ie,this.branches=Se}}e.$JO=Wn;class qn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ie,Se){this.executed=L,this.location=ie,this.label=Se}}e.$KO=qn;class Gn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ie,Se){this.name=L,this.executed=ie,this.location=Se}}e.$LO=Gn;var kn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(L,ie,Se,Je,et,ft){this.kind=L,this.name=ie,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=ft}}e.$MO=Kn;class Hn{constructor(L){this.uri=L}}e.$NO=Hn;class Jn{constructor(L,ie){this.original=L,this.modified=ie}}e.$OO=Jn;class Qn{constructor(L,ie,Se,Je){this.base=L,this.input1=ie,this.input2=Se,this.result=Je}}e.$PO=Qn;class Zn{constructor(L,ie){this.uri=L,this.viewType=ie}}e.$QO=Zn;class Xn{constructor(L){this.viewType=L}}e.$RO=Xn;class Yn{constructor(L,ie){this.uri=L,this.notebookType=ie}}e.$SO=Yn;class xn{constructor(L,ie,Se){this.original=L,this.modified=ie,this.notebookType=Se}}e.$TO=xn;class _n{constructor(){}}e.$UO=_n;class er{constructor(L,ie){this.uri=L,this.inputBoxUri=ie}}e.$VO=er;class tr{constructor(){}}e.$WO=tr;class ir{constructor(L){this.textDiffs=L}}e.$XO=ir;var Pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(L,ie,Se){this.id=L,this.label=ie,this.values=Se}}e.$YO=nr;var Tn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Nn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Nn||(e.ChatResultFeedbackKind=Nn={}));class rr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L}}e.$ZO=rr;class sr{constructor(L,ie){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L,this.vulnerabilities=ie}}e.$1O=sr;class or{constructor(L,ie){this.participant=L,this.command=ie}}e.$2O=or;class ar{constructor(L,ie,Se){this.title=L,this.message=ie,this.data=Se}}e.$3O=ar;class cr{constructor(L,ie){this.value=L,this.baseUri=ie}}e.$4O=cr;class lr{constructor(L,ie){this.value=L,this.title=ie}}e.$5O=lr;class ur{constructor(L){this.value=L}}e.$6O=ur;class hr{constructor(L,ie){this.value=L,this.task=ie}}e.$7O=hr;class dr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L}}e.$8O=dr;class fr{constructor(L){this.value=L}}e.$9O=fr;class gr{constructor(L,ie){this.value=L,this.iconPath=ie}}e.$0O=gr;class mr{constructor(L,ie){this.uri=L,this.edits=Array.isArray(ie)?ie:[ie]}}e.$$O=mr;class pr{constructor(L,ie,Se,Je){this.prompt=L,this.command=ie,this.references=Se,this.participant=Je}}e.$_O=pr;class $r{constructor(L,ie,Se,Je){this.response=L,this.result=ie,this.participant=Se,this.command=Je}}e.$aP=$r;var Mn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));var gn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(L,ie,Se){this.name=L,this.content=ie,this.isError=Se??!1}}e.$bP=br;class mn{static User(L,ie){const Se=new mn(gn.User,typeof L=="string"?L:"",ie);return Se.content2=L,Se}static Assistant(L,ie){return new mn(gn.Assistant,L,ie)}constructor(L,ie,Se){this.role=L,this.content=ie,this.content2=ie,this.name=Se}}e.$cP=mn;class wr{constructor(L,ie){this.name=L,this.parameters=ie}}e.$dP=wr;class vr{constructor(L){this.value=L}}e.$eP=vr;class yr{constructor(L){this.content=L}}e.$fP=yr;class Er{constructor(L,ie){this.content=L,this.name=ie}}e.$gP=Er;class Dr{constructor(L,ie){this.content=L,this.name=ie}}e.$hP=Dr;class Ai extends Error{static NotFound(L){return new Ai(L,Ai.NotFound.name)}static NoPermissions(L){return new Ai(L,Ai.NoPermissions.name)}static Blocked(L){return new Ai(L,Ai.Blocked.name)}constructor(L,ie,Se){super(L,{cause:Se}),this.name="LanguageModelError",this.code=ie??""}}e.$iP=Ai;var On;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(On||(e.RelatedInformationType=On={}));var Fn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Ln;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Ln||(e.TextToSpeechStatus=Ln={}));var Un;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Un||(e.KeywordRecognitionStatus=Un={}));class Sr{constructor(L,ie){this.text=L,this.range=ie}}e.$jP=Sr;var zn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(Ce[269],Ie([1,0,6,7]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$1M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,N,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(A);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(N,p)??[]}getRelatedInformation(A,N,p){return this.c.$getAiRelatedInformation(N,p)}registerRelatedInformationProvider(A,N,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,N),new C.$3M(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$_mc=P}),define(Ce[91],Ie([1,0,4,6,7,19,116,3,17]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=e.$knc=void 0,e.$knc=(0,N.$Ei)("IExtHostAuthentication");let c=class{constructor(l){this.b=new Map,this.c=new w.$le,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=l.getProxy(C.$1M.MainThreadAuthentication)}async getSession(l,E,d,r={}){const o=M.$pn.toKey(l.identifier),a=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${E} ${a}`,async()=>{await this.a.$ensureProvider(E);const h=l.displayName||l.name;return this.a.$getSession(E,d,o,h,r)})}async getSessions(l,E,d){const r=M.$pn.toKey(l.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(E);const a=l.displayName||l.name;return this.a.$getSessions(E,d,r,a)})}async removeSession(l,E){const d=this.b.get(l);return d?d.provider.removeSession(E):this.a.$removeSession(l,E)}registerAuthenticationProvider(l,E,d,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:E,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(l,a));return this.a.$registerAuthenticationProvider(l,E,r?.supportsMultipleAccounts??!1),new P.$3M(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,E,d){const r=this.b.get(l);if(r)return await r.provider.createSession(E,d);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,E){const d=this.b.get(l);if(d)return await d.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,E){const d=this.b.get(l);if(d)return await d.provider.getSessions(E);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,E){return l.startsWith(A.$3L)||this.c.fire({provider:{id:l,label:E}}),Promise.resolve()}};e.$lnc=c,e.$lnc=c=He([We(0,p.$uP)],c);class R{constructor(){this.a=new Map}getOrCreate(l,E){const d=this.a.get(l);if(d)return d;const r=E().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(Ce[121],Ie([1,0,2,6,7,3,17,12,18,13,20,25]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=e.$poc=void 0;let E=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(C.$1M.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=l.c++;this.f.set(a,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(a,o.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(a,null);return}const s=(0,p.$3b)(n);if(s.length<=l.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const i=s.map(f=>({uri:f,rank:(0,c.$if)(f.path,"/")})),t=(0,p.$Ab)(i,(f,u)=>f.rank-u.rank||(0,c.$yf)(f.uri.path,u.uri.path)),m=[];e:for(const f of t){let u;for(const $ of f){const I=(0,R.$nc)($.uri.path);if(u!==I&&(u=I,m.push($.uri)>=l.d))break e}}this.g.$onDidChange(a,m)});return new P.$3M(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(r,o,a){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:n,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async i=>{try{const{uri:t,id:m}=i,f=await Promise.resolve(n.provideFileDecoration(w.URI.revive(t),a));if(!f)return;try{P.$qO.validate(f),f.badge&&typeof f.badge!="string"&&(0,v.$4G)(s,"codiconDecoration"),h[m]=[f.propagate,f.tooltip,f.badge,f.color]}catch(u){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),h}};e.$poc=E,e.$poc=E=l=He([We(0,A.$uP),We(1,N.$$j)],E),e.$qoc=(0,M.$Ei)("IExtHostDecorations")}),define(Ce[270],Ie([1,0,14,2,7,6,16,22,13]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0;class c{static{this.a=0}constructor(v,l,E){this.d=l,this.e=E,this.b=new Map,this.c=v.getProxy(M.$1M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,l){if(Object.keys(A.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const E=c.a++;this.b.set(E,l),this.c.$registerTextContentProvider(E,v);let d;if(typeof l.onDidChange=="function"){let r;d=l.onDidChange(async o=>{if(o.scheme!==v){this.e.warn(`Provider for scheme '${v}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(E,o).then(async h=>{if(!h&&typeof h!="string")return;const n=this.d.getDocument(o);if(!n)return;const s=(0,p.$sf)(h);if(!n.equalLines(s))return this.c.$onVirtualDocumentChange(o,h)}).catch(w.$2).finally(()=>{r===a&&(r=void 0)});r=a})}return new P.$3M(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(v,l){const E=this.b.get(v);return E?Promise.resolve(E.provideTextDocumentContent(C.URI.revive(l),N.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$soc=c}),define(Ce[122],Ie([1,0,62,16,13,325,210,7,18]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0,e.$wP=R;const c=new Map;function R(d,r){r?c.set(d,r):c.delete(d)}function v(d){return c.get(d)}class l extends M.$hw{constructor(r,o,a,h,n,s,i){super(o,a,h,n),this.c=r,this.m=s,this.q=i,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$vb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===C.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?N.EndOfLine.LF:N.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,a){return r.y(o,a)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,w.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,w.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const a=this.g,h=o.start.line,n=o.end.line,s=[];s.push(this.f[h].substring(o.start.character));for(let i=h+1;i<n;i++)s.push(this.f[i]);return s.push(this.f[n].substring(0,o.end.character)),s.join(a)}t(r){let o;if(r instanceof N.$4M?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),a=this.f[o.index].length;return new N.$4M(o.index,Math.min(o.remainder,a))}w(r){if(!(r instanceof N.$5M))throw new Error("Invalid argument");const o=this.x(r.start),a=this.x(r.end);return o===r.start&&a===r.end?r:new N.$5M(o.line,o.character,a.line,a.character)}x(r){if(!(r instanceof N.$4M))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:a}=r,h=!1;if(o<0)o=0,a=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,a=this.f[o].length,h=!0;else{const n=this.f[o].length;a<0?(a=0,h=!0):a>n&&(a=n,h=!0)}return h?new N.$4M(o,a):r}y(r,o){const a=this.x(r);if(!o)o=v(this.m);else if((0,P.$rf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,A.$jt)(a.character+1,(0,A.$ht)(o),this.f[a.line],0);if(h)return new N.$5M(a.line,h.startColumn-1,a.line,h.endColumn-1)}}e.$xP=l;class E{constructor(r,o,a){this.a=r,this.b=o,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new N.$5M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new N.$5M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$yP=E}),define(Ce[271],Ie([1,0,6,7]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$1M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,N,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(A);if(!c)throw new Error("Embedding vector provider not found");const R=await c.provideEmbeddingVector(N,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,N,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(N,c),new C.$3M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$voc=P}),define(Ce[69],Ie([1,0,6,30,7,23,3,17,51,5,11,24,16]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$Anc=void 0,C=qe(C);let d=E=class{constructor(o,a){this.b=new Map,this.c=new R.$Nh,this.a=o.getProxy(w.$1M.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(n){try{let s;const i=h.b.get(n.scheme);return i?(await h.a.$ensureActivation(n.scheme),s=await i.impl.stat(n)):s=await h.a.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===C.FilePermission.Readonly?1:void 0}}catch(s){E.e(s)}},async readDirectory(n){try{const s=h.b.get(n.scheme);return s?(await h.a.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await h.a.$readdir(n)}catch(s){return E.e(s)}},async createDirectory(n){try{const s=h.b.get(n.scheme);return s&&!s.isReadonly?(await h.a.$ensureActivation(n.scheme),await h.d(s.impl,s.extUri,n)):await h.a.$mkdir(n)}catch(s){return E.e(s)}},async readFile(n){try{const s=h.b.get(n.scheme);return s?(await h.a.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await h.a.$readFile(n)).buffer}catch(s){return E.e(s)}},async writeFile(n,s){try{const i=h.b.get(n.scheme);return i&&!i.isReadonly?(await h.a.$ensureActivation(n.scheme),await h.d(i.impl,i.extUri,i.extUri.dirname(n)),await h.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await h.a.$writeFile(n,M.$Ne.wrap(s))}catch(i){return E.e(i)}},async delete(n,s){try{const i=h.b.get(n.scheme);return i&&!i.isReadonly&&!s?.useTrash?(await h.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...s})):await h.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(i){return E.e(i)}},async rename(n,s,i){try{return await h.a.$rename(n,s,{overwrite:!1,...i})}catch(t){return E.e(t)}},async copy(n,s,i){try{return await h.a.$copy(n,s,{overwrite:!1,...i})}catch(t){return E.e(t)}},isWritableFileSystem(n){const s=a.getCapabilities(n);if(typeof s=="number")return!(s&C.FileSystemProviderCapabilities.Readonly)}})}async d(o,a,h){const n=[];for(;!a.isEqual(h,a.dirname(h));)try{if(!((await o.stat(h)).type&C.FileType.Directory))throw P.$hO.FileExists(`Unable to create folder '${h.scheme===l.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(C.$ol(s)!==C.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(a.basename(h)),h=a.dirname(h)}for(let s=n.length-1;s>=0;s--){h=a.joinPath(h,n[s]);try{await o.createDirectory(h)}catch(i){if(C.$ol(i)!==C.FileSystemProviderErrorCode.FileExists)throw i}}}static e(o){if(o instanceof P.$hO)throw o;if(o instanceof C.$kl)switch(o.code){case C.FileSystemProviderErrorCode.FileExists:throw P.$hO.FileExists(o.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.$hO.FileNotFound(o.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.$hO.FileNotADirectory(o.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.$hO.FileIsADirectory(o.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.$hO.NoPermissions(o.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.$hO.Unavailable(o.message);default:throw new P.$hO(o.message,o.name)}if(!(o instanceof Error))throw new P.$hO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$hO.Unavailable(o.message);switch(o.name){case C.FileSystemProviderErrorCode.FileExists:throw P.$hO.FileExists(o.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.$hO.FileNotFound(o.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.$hO.FileNotADirectory(o.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.$hO.FileIsADirectory(o.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.$hO.NoPermissions(o.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.$hO.Unavailable(o.message);default:throw new P.$hO(o.message,o.name)}}addFileSystemProvider(o,a,h){return this.b.set(o,{impl:a,extUri:h?.isCaseSensitive?v.$8g:v.$0g,isReadonly:!!h?.isReadonly}),(0,c.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??v.$8g}};e.$Anc=d,e.$Anc=d=E=He([We(0,N.$uP),We(1,p.$enc)],d),e.$Bnc=(0,A.$Ei)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,69,2]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=e.$Cnc=void 0,e.$Cnc=(0,w.$Ei)("IExtensionStoragePaths");let N=class{constructor(c,R,v){this.d=R,this.f=v,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(c){return A.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,R=await this.g(c);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(v){this.d.error("[ExtHostStorage]",v);return}}workspaceValue(c){if(this.c)return A.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return A.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Dnc=N,e.$Dnc=N=He([We(0,C.$KP),We(1,P.$$j),We(2,M.$Bnc)],N)}),define(Ce[272],Ie([1,0,7,17,4]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;let M=class{constructor(N){this.a=new w.$rO(w.ColorThemeKind.Dark),this.b=new P.$le}get activeColorTheme(){return this.a}$onColorThemeChange(N){let p;switch(N){case"light":p=w.ColorThemeKind.Light;break;case"hcDark":p=w.ColorThemeKind.HighContrast;break;case"hcLight":p=w.ColorThemeKind.HighContrastLight;break;default:p=w.ColorThemeKind.Dark}this.a=new w.$rO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$_oc=M,e.$_oc=M=He([We(0,C.$uP)],M)}),define(Ce[93],Ie([1,0,22,4,5,190,3,12,223,6,27,17,7]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Eb=e.$4Eb=e.TunnelDtoConverter=void 0,M=qe(M),l=qe(l);class E extends p.$Gw{}var d;(function(o){function a(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=a;function h(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$4Eb=(0,A.$Ei)("IExtHostTunnelService");let r=class extends P.$Vc{constructor(a,h,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(c.$1M.MainThreadTunnelService)}async openTunnel(a,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const n=await this.a.$openTunnel(h,a.displayName);if(n){const s=new E(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,h){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:a,provider:h}),this.a.$registerPortsAttributesProvider(a,n),new l.$3M(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(a,h,n,s,i){const t=[];for(const f of a){const u=this.r.get(f);if(!u)return[];t.push(...await Promise.all(h.map(async $=>{let I;try{I=await u.provider.providePortAttributes({port:$,pid:n,commandLine:s},i)}catch{I=await u.provider.providePortAttributes($,n,s,i)}return{providedAttributes:I,port:$}})))}const m=t.filter(f=>!!f.providedAttributes);return m.length>0?m.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,i)=>await a.provideTunnel(s,i,w.CancellationToken.None)??void 0;const n=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,h){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const n=a.tunnelFactory??(h?this.w(h):void 0);if(n){this.b=n;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const i=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,P.$Tc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,h){if(this.g.has(a.host)){const n=this.g.get(a.host);n.has(a.port)&&(h&&n.get(a.port).disposeListener.dispose(),await n.get(a.port).tunnel.dispose(),n.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(a,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const i=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:i}),d.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(a){const h=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),n=a.filter((s,i)=>h[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.$5Eb=r,e.$5Eb=r=He([We(0,v.$uP),We(1,R.$KP),We(2,N.$$j)],r)}),define(Ce[10],Ie([1,0,18,23,147,273,60,29,136,49,73,26,142,24,35,15,2,105,33,151,94,52,107,77,115,114,234,249,81,90,55,56,245,7]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u,$,I,D,y,S,k,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$rP=de,e.$sP=re,e.$tP=Pe,A=qe(A),h=qe(h),n=qe(n),s=qe(s),I=qe(I),y=qe(y),b=qe(b);var F;(function(ye){function Te(Q){const{selectionStartLineNumber:Ee,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:Ge}=Q,lt=new b.$4M(Ee-1,Ve-1),Pt=new b.$4M(Xe-1,Ge-1);return new b.$6M(lt,Pt)}ye.to=Te;function le(Q){const{anchor:Ee,active:Ve}=Q;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}ye.from=le})(F||(e.Selection=F={}));var T;(function(ye){function Te(Q){if(!Q)return;const{start:Ee,end:Ve}=Q;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}ye.from=Te;function le(Q){if(!Q)return;const{startLineNumber:Ee,startColumn:Ve,endLineNumber:Xe,endColumn:Ge}=Q;return new b.$5M(Ee-1,Ve-1,Xe-1,Ge-1)}ye.to=le})(T||(e.Range=T={}));var q;(function(ye){function Te(Q){return{uri:Q.uri,range:T.from(Q.range)}}ye.from=Te;function le(Q){return new b.$cN(o.URI.revive(Q.uri),T.to(Q.range))}ye.to=le})(q||(e.Location=q={}));var G;(function(ye){function Te(le){switch(le){case n.StandardTokenType.Comment:return b.StandardTokenType.Comment;case n.StandardTokenType.Other:return b.StandardTokenType.Other;case n.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case n.StandardTokenType.String:return b.StandardTokenType.String}}ye.to=Te})(G||(e.TokenType=G={}));var V;(function(ye){function Te(Q){return new b.$4M(Q.lineNumber-1,Q.column-1)}ye.to=Te;function le(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=le})(V||(e.Position=V={}));var O;(function(ye){function Te(Ee,Ve,Xe){return(0,w.$Ib)((0,w.$3b)(Ee).map(Ge=>le(Ge,Ve,Xe)))}ye.from=Te;function le(Ee,Ve,Xe){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Xe?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Q(Ee.scheme,Ve),pattern:Ye.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Xe?.isBuiltin}}function Q(Ee,Ve){return Ve&&typeof Ee=="string"?Ve.transformOutgoingScheme(Ee):Ee}})(O||(e.DocumentSelector=O={}));var W;(function(ye){function Te(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}ye.from=Te;function le(Q){switch(Q){case t.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}ye.to=le})(W||(e.DiagnosticTag=W={}));var ce;(function(ye){function Te(Q){let Ee;return Q.code&&((0,r.$eg)(Q.code)||(0,r.$ig)(Q.code)?Ee=String(Q.code):Ee={value:String(Q.code.value),target:Q.code.target}),{...T.from(Q.range),message:Q.message,source:Q.source,code:Ee,severity:te.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(ge.from),tags:Array.isArray(Q.tags)?(0,w.$Ib)(Q.tags.map(W.from)):void 0}}ye.from=Te;function le(Q){const Ee=new b.$eN(T.to(Q),Q.message,te.to(Q.severity));return Ee.source=Q.source,Ee.code=(0,r.$eg)(Q.code)?Q.code:Q.code?.value,Ee.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(ge.to),Ee.tags=Q.tags&&(0,w.$Ib)(Q.tags.map(W.to)),Ee}ye.to=le})(ce||(e.Diagnostic=ce={}));var ge;(function(ye){function Te(Q){return{...T.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=Te;function le(Q){return new b.$dN(new b.$cN(Q.resource,T.to(Q)),Q.message)}ye.to=le})(ge||(e.DiagnosticRelatedInformation=ge={}));var te;(function(ye){function Te(Q){switch(Q){case b.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ye.from=Te;function le(Q){switch(Q){case t.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ye.to=le})(te||(e.DiagnosticSeverity=te={}));var me;(function(ye){function Te(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?g.$lE:g.$kE}ye.from=Te;function le(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=le})(me||(e.ViewColumn=me={}));function se(ye){return typeof ye.range<"u"}function de(ye){return ye.length===0?!0:!!se(ye[0])}var be;(function(ye){function Te(Ge){return Ge.map(ye.from)}ye.fromMany=Te;function le(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let lt;if(le(Ge)){const{language:Ut,value:ni}=Ge;lt={value:"```"+Ut+`
`+ni+"\n```\n"}}else b.$sN.isMarkdownString(Ge)?lt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?lt={value:Ge}:lt={value:""};const Pt=Object.create(null);lt.uris=Pt;const Xt=Ut=>{try{let ni=o.URI.parse(Ut,!0);ni=ni.with({query:Ee(ni.query,Pt)}),Pt[Ut]=ni}catch{}return""},ci=new p.marked.Renderer;return ci.link=Xt,ci.image=Ut=>typeof Ut=="string"?Xt(A.$0k(Ut).href):"",(0,p.marked)(lt.value,{renderer:ci}),lt}ye.from=Q;function Ee(Ge,lt){if(!Ge)return Ge;let Pt;try{Pt=(0,c.$ai)(Ge)}catch{}if(!Pt)return Ge;let Xt=!1;return Pt=(0,v.$do)(Pt,ci=>{if(o.URI.isUri(ci)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Ut]=ci,Xt=!0,Ut}else return}),Xt?JSON.stringify(Pt):Ge}function Ve(Ge){const lt=new b.$sN(Ge.value,Ge.supportThemeIcons);return lt.isTrusted=Ge.isTrusted,lt.supportHtml=Ge.supportHtml,lt.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,lt}ye.to=Ve;function Xe(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Xe})(be||(e.MarkdownString=be={}));function re(ye){return de(ye)?ye.map(Te=>({range:T.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?be.fromMany(Te.hoverMessage):Te.hoverMessage?be.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):ye.map(Te=>({range:T.from(Te)}))}function Pe(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Fe;(function(ye){function Te(le){return typeof le>"u"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?Pe(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ye.from=Te})(Fe||(e.ThemableDecorationAttachmentRenderOptions=Fe={}));var X;(function(ye){function Te(le){return typeof le>"u"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Pe(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Fe.from(le.before):void 0,after:le.after?Fe.from(le.after):void 0}}ye.from=Te})(X||(e.ThemableDecorationRenderOptions=X={}));var B;(function(ye){function Te(le){if(typeof le>"u")return le;switch(le){case b.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Te})(B||(e.DecorationRangeBehavior=B={}));var _;(function(ye){function Te(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?B.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?X.from(le.light):void 0,dark:le.dark?X.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?Pe(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?Fe.from(le.before):void 0,after:le.after?Fe.from(le.after):void 0}}ye.from=Te})(_||(e.DecorationRenderOptions=_={}));var we;(function(ye){function Te(Q){return{text:Q.newText,eol:Q.newEol&&je.from(Q.newEol),range:T.from(Q.range)}}ye.from=Te;function le(Q){const Ee=new b.$0M(T.to(Q.range),Q.text);return Ee.newEol=typeof Q.eol>"u"?void 0:je.to(Q.eol),Ee}ye.to=le})(we||(e.TextEdit=we={}));var ae;(function(ye){function Te(Q,Ee){const Ve={edits:[]};if(Q instanceof b.$aN){const Xe=new N.$Cc;for(const Ge of Q._allEntries())Ge._type===b.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&Xe.add(Ge.to);for(const Ge of Q._allEntries())if(Ge._type===b.FileEditType.File){let lt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?lt={type:"base64",value:(0,C.$8e)(C.$Ne.wrap(Ge.options.contents))}:lt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:lt},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?Ve.edits.push({resource:Ge.uri,textEdit:we.from(Ge.edit),versionId:Xe.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?Ve.edits.push({resource:Ge.uri,textEdit:{range:T.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(It.from)}})}return Ve}ye.from=Te;function le(Q){const Ee=new b.$aN,Ve=new N.$Bc;for(const Xe of Q.edits)if(Xe.textEdit){const Ge=Xe,lt=o.URI.revive(Ge.resource),Pt=T.to(Ge.textEdit.range),Xt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let Ut;ci?Ut=b.$_M.replace(Pt,new b.$bN(Xt)):Ut=b.$0M.replace(Pt,Xt);const ni=Ve.get(lt);ni?ni.push(Ut):Ve.set(lt,[Ut])}else Ee.renameFile(o.URI.revive(Xe.oldResource),o.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ge]of Ve)Ee.set(Xe,Ge);return Ee}ye.to=le})(ae||(e.WorkspaceEdit=ae={}));var ve;(function(ye){const Te=Object.create(null);Te[b.SymbolKind.File]=s.SymbolKind.File,Te[b.SymbolKind.Module]=s.SymbolKind.Module,Te[b.SymbolKind.Namespace]=s.SymbolKind.Namespace,Te[b.SymbolKind.Package]=s.SymbolKind.Package,Te[b.SymbolKind.Class]=s.SymbolKind.Class,Te[b.SymbolKind.Method]=s.SymbolKind.Method,Te[b.SymbolKind.Property]=s.SymbolKind.Property,Te[b.SymbolKind.Field]=s.SymbolKind.Field,Te[b.SymbolKind.Constructor]=s.SymbolKind.Constructor,Te[b.SymbolKind.Enum]=s.SymbolKind.Enum,Te[b.SymbolKind.Interface]=s.SymbolKind.Interface,Te[b.SymbolKind.Function]=s.SymbolKind.Function,Te[b.SymbolKind.Variable]=s.SymbolKind.Variable,Te[b.SymbolKind.Constant]=s.SymbolKind.Constant,Te[b.SymbolKind.String]=s.SymbolKind.String,Te[b.SymbolKind.Number]=s.SymbolKind.Number,Te[b.SymbolKind.Boolean]=s.SymbolKind.Boolean,Te[b.SymbolKind.Array]=s.SymbolKind.Array,Te[b.SymbolKind.Object]=s.SymbolKind.Object,Te[b.SymbolKind.Key]=s.SymbolKind.Key,Te[b.SymbolKind.Null]=s.SymbolKind.Null,Te[b.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Te[b.SymbolKind.Struct]=s.SymbolKind.Struct,Te[b.SymbolKind.Event]=s.SymbolKind.Event,Te[b.SymbolKind.Operator]=s.SymbolKind.Operator,Te[b.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function le(Ee){return typeof Te[Ee]=="number"?Te[Ee]:s.SymbolKind.Property}ye.from=le;function Q(Ee){for(const Ve in Te)if(Te[Ve]===Ee)return Number(Ve);return b.SymbolKind.Property}ye.to=Q})(ve||(e.SymbolKind=ve={}));var ue;(function(ye){function Te(Q){switch(Q){case b.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}ye.from=Te;function le(Q){switch(Q){case s.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ye.to=le})(ue||(e.SymbolTag=ue={}));var Z;(function(ye){function Te(Q){return{name:Q.name,kind:ve.from(Q.kind),tags:Q.tags&&Q.tags.map(ue.from),containerName:Q.containerName,location:Ue.from(Q.location)}}ye.from=Te;function le(Q){const Ee=new b.$jN(Q.name,ve.to(Q.kind),Q.containerName,Ue.to(Q.location));return Ee.tags=Q.tags&&Q.tags.map(ue.to),Ee}ye.to=le})(Z||(e.WorkspaceSymbol=Z={}));var Y;(function(ye){function Te(Q){const Ee={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),kind:ve.from(Q.kind),tags:Q.tags?.map(ue.from)??[]};return Q.children&&(Ee.children=Q.children.map(Te)),Ee}ye.from=Te;function le(Q){const Ee=new b.$kN(Q.name,Q.detail,ve.to(Q.kind),T.to(Q.range),T.to(Q.selectionRange));return(0,w.$Mb)(Q.tags)&&(Ee.tags=Q.tags.map(ue.to)),Q.children&&(Ee.children=Q.children.map(le)),Ee}ye.to=le})(Y||(e.DocumentSymbol=Y={}));var pe;(function(ye){function Te(Q){const Ee=new b.$oN(ve.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),T.to(Q.range),T.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}ye.to=Te;function le(Q,Ee,Ve){if(Ee=Ee??Q._sessionId,Ve=Ve??Q._itemId,Ee===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ve,name:Q.name,detail:Q.detail,kind:ve.from(Q.kind),uri:Q.uri,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),tags:Q.tags?.map(ue.from)}}ye.from=le})(pe||(e.CallHierarchyItem=pe={}));var $e;(function(ye){function Te(le){return new b.$pN(pe.to(le.from),le.fromRanges.map(Q=>T.to(Q)))}ye.to=Te})($e||(e.CallHierarchyIncomingCall=$e={}));var Ne;(function(ye){function Te(le){return new b.$qN(pe.to(le.to),le.fromRanges.map(Q=>T.to(Q)))}ye.to=Te})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var Ue;(function(ye){function Te(Q){return{range:Q.range&&T.from(Q.range),uri:Q.uri}}ye.from=Te;function le(Q){return new b.$cN(o.URI.revive(Q.uri),T.to(Q.range))}ye.to=le})(Ue||(e.location=Ue={}));var ke;(function(ye){function Te(Q){const Ee=Q,Ve=Q;return{originSelectionRange:Ee.originSelectionRange?T.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Ve.uri,range:T.from(Ee.targetRange?Ee.targetRange:Ve.range),targetSelectionRange:Ee.targetSelectionRange?T.from(Ee.targetSelectionRange):void 0}}ye.from=Te;function le(Q){return{targetUri:o.URI.revive(Q.uri),targetRange:T.to(Q.range),targetSelectionRange:Q.targetSelectionRange?T.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?T.to(Q.originSelectionRange):void 0}}ye.to=le})(ke||(e.DefinitionLink=ke={}));var Re;(function(ye){function Te(Q){return{range:T.from(Q.range),contents:be.fromMany(Q.contents),canIncreaseVerbosity:Q.canIncreaseVerbosity,canDecreaseVerbosity:Q.canDecreaseVerbosity}}ye.from=Te;function le(Q){const Ee=Q.contents.map(be.to),Ve=T.to(Q.range),Xe=Q.canIncreaseVerbosity,Ge=Q.canDecreaseVerbosity;return new b.$gN(Ee,Ve,Xe,Ge)}ye.to=le})(Re||(e.Hover=Re={}));var Me;(function(ye){function Te(Q){return{range:T.from(Q.range),expression:Q.expression}}ye.from=Te;function le(Q){return new b.$bO(T.to(Q.range),Q.expression)}ye.to=le})(Me||(e.EvaluatableExpression=Me={}));var z;(function(ye){function Te(Q){if(Q instanceof b.$cO)return{type:"text",range:T.from(Q.range),text:Q.text};if(Q instanceof b.$dO)return{type:"variable",range:T.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.$eO)return{type:"expression",range:T.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Te;function le(Q){switch(Q.type){case"text":return{range:T.to(Q.range),text:Q.text};case"variable":return{range:T.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:T.to(Q.range),expression:Q.expression}}}ye.to=le})(z||(e.InlineValue=z={}));var U;(function(ye){function Te(Q){return{frameId:Q.frameId,stoppedLocation:T.from(Q.stoppedLocation)}}ye.from=Te;function le(Q){return new b.$fO(Q.frameId,T.to(Q.stoppedLocation))}ye.to=le})(U||(e.InlineValueContext=U={}));var K;(function(ye){function Te(Q){return{range:T.from(Q.range),kind:Q.kind}}ye.from=Te;function le(Q){return new b.$hN(T.to(Q.range),Q.kind)}ye.to=le})(K||(e.DocumentHighlight=K={}));var J;(function(ye){function Te(Q){return{uri:Q.uri,highlights:Q.highlights.map(K.from)}}ye.from=Te;function le(Q){return new b.$iN(o.URI.revive(Q.uri),Q.highlights.map(K.to))}ye.to=le})(J||(e.MultiDocumentHighlight=J={}));var ne;(function(ye){function Te(le){switch(le){case s.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}ye.to=Te})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(ye){function Te(le){return{triggerKind:ne.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ye.to=Te})(fe||(e.CompletionContext=fe={}));var Ae;(function(ye){function Te(Q){switch(Q){case b.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}ye.from=Te;function le(Q){switch(Q){case s.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ye.to=le})(Ae||(e.CompletionItemTag=Ae={}));var ze;(function(ye){const Te=new Map([[b.CompletionItemKind.Method,s.CompletionItemKind.Method],[b.CompletionItemKind.Function,s.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,s.CompletionItemKind.Field],[b.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[b.CompletionItemKind.Class,s.CompletionItemKind.Class],[b.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[b.CompletionItemKind.Module,s.CompletionItemKind.Module],[b.CompletionItemKind.Property,s.CompletionItemKind.Property],[b.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[b.CompletionItemKind.Value,s.CompletionItemKind.Value],[b.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,s.CompletionItemKind.Text],[b.CompletionItemKind.Color,s.CompletionItemKind.Color],[b.CompletionItemKind.File,s.CompletionItemKind.File],[b.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[b.CompletionItemKind.Event,s.CompletionItemKind.Event],[b.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[b.CompletionItemKind.User,s.CompletionItemKind.User]]);function le(Ve){return Te.get(Ve)??s.CompletionItemKind.Property}ye.from=le;const Q=new Map([[s.CompletionItemKind.Method,b.CompletionItemKind.Method],[s.CompletionItemKind.Function,b.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,b.CompletionItemKind.Field],[s.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[s.CompletionItemKind.Class,b.CompletionItemKind.Class],[s.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[s.CompletionItemKind.Module,b.CompletionItemKind.Module],[s.CompletionItemKind.Property,b.CompletionItemKind.Property],[s.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[s.CompletionItemKind.Value,b.CompletionItemKind.Value],[s.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,b.CompletionItemKind.Text],[s.CompletionItemKind.Color,b.CompletionItemKind.Color],[s.CompletionItemKind.File,b.CompletionItemKind.File],[s.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[s.CompletionItemKind.Event,b.CompletionItemKind.Event],[s.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,b.CompletionItemKind.User],[s.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ee(Ve){return Q.get(Ve)??b.CompletionItemKind.Property}ye.to=Ee})(ze||(e.CompletionItemKind=ze={}));var Ke;(function(ye){function Te(le,Q){const Ee=new b.$yN(le.label);return Ee.insertText=le.insertText,Ee.kind=ze.to(le.kind),Ee.tags=le.tags?.map(Ae.to),Ee.detail=le.detail,Ee.documentation=A.$4k(le.documentation)?be.to(le.documentation):le.documentation,Ee.sortText=le.sortText,Ee.filterText=le.filterText,Ee.preselect=le.preselect,Ee.commitCharacters=le.commitCharacters,h.$Ht.isIRange(le.range)?Ee.range=T.to(le.range):typeof le.range=="object"&&(Ee.range={inserting:T.to(le.range.insert),replacing:T.to(le.range.replace)}),Ee.keepWhitespace=typeof le.insertTextRules>"u"?!1:!!(le.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof le.insertTextRules<"u"&&le.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new b.$bN(le.insertText):(Ee.insertText=le.insertText,Ee.textEdit=Ee.range instanceof b.$5M?new b.$0M(Ee.range,Ee.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Ee.additionalTextEdits=le.additionalTextEdits.map(Ve=>we.to(Ve))),Ee.command=Q&&le.command?Q.fromInternal(le.command):void 0,Ee}ye.to=Te})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Te(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:be.fromStrict(Q.documentation)}}ye.from=Te;function le(Q){return{label:Q.label,documentation:A.$4k(Q.documentation)?be.to(Q.documentation):Q.documentation}}ye.to=le})(_e||(e.ParameterInformation=_e={}));var it;(function(ye){function Te(Q){return{label:Q.label,documentation:be.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(_e.from):[],activeParameter:Q.activeParameter}}ye.from=Te;function le(Q){return{label:Q.label,documentation:A.$4k(Q.documentation)?be.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(_e.to):[],activeParameter:Q.activeParameter}}ye.to=le})(it||(e.SignatureInformation=it={}));var nt;(function(ye){function Te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(it.from):[]}}ye.from=Te;function le(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(it.to):[]}}ye.to=le})(nt||(e.SignatureHelp=nt={}));var tt;(function(ye){function Te(le,Q){const Ee=new b.$xN(V.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(rt.to.bind(void 0,le)),Q.kind&&$t.to(Q.kind));return Ee.textEdits=Q.textEdits&&Q.textEdits.map(we.to),Ee.tooltip=A.$4k(Q.tooltip)?be.to(Q.tooltip):Q.tooltip,Ee.paddingLeft=Q.paddingLeft,Ee.paddingRight=Q.paddingRight,Ee}ye.to=Te})(tt||(e.InlayHint=tt={}));var rt;(function(ye){function Te(le,Q){const Ee=new b.$wN(Q.label);return Ee.tooltip=A.$4k(Q.tooltip)?be.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Ee.command=le.fromInternal(Q.command)),Q.location&&(Ee.location=Ue.to(Q.location)),Ee}ye.to=Te})(rt||(e.InlayHintLabelPart=rt={}));var $t;(function(ye){function Te(Q){return Q}ye.from=Te;function le(Q){return Q}ye.to=le})($t||(e.InlayHintKind=$t={}));var ut;(function(ye){function Te(Q){return{range:T.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=Te;function le(Q){let Ee;if(Q.url)try{Ee=typeof Q.url=="string"?o.URI.parse(Q.url,!0):o.URI.revive(Q.url)}catch{}const Ve=new b.$DN(T.to(Q.range),Ee);return Ve.tooltip=Q.tooltip,Ve}ye.to=le})(ut||(e.DocumentLink=ut={}));var st;(function(ye){function Te(Q){const Ee=new b.$GN(Q.label);return Q.textEdit&&(Ee.textEdit=we.to(Q.textEdit)),Q.additionalTextEdits&&(Ee.additionalTextEdits=Q.additionalTextEdits.map(Ve=>we.to(Ve))),Ee}ye.to=Te;function le(Q){return{label:Q.label,textEdit:Q.textEdit?we.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ee=>we.from(Ee)):void 0}}ye.from=le})(st||(e.ColorPresentation=st={}));var ct;(function(ye){function Te(Q){return new b.$EN(Q[0],Q[1],Q[2],Q[3])}ye.to=Te;function le(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=le})(ct||(e.Color=ct={}));var gt;(function(ye){function Te(Q){return{range:T.from(Q.range)}}ye.from=Te;function le(Q){return new b.$nN(T.to(Q.range))}ye.to=le})(gt||(e.SelectionRange=gt={}));var mt;(function(ye){function Te(le){switch(le){case u.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}ye.to=Te})(mt||(e.TextDocumentSaveReason=mt={}));var Be;(function(ye){function Te(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}ye.from=Te;function le(Q){switch(Q){case a.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}ye.to=le})(Be||(e.TextEditorLineNumbersStyle=Be={}));var je;(function(ye){function Te(Q){if(Q===b.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(Q===b.EndOfLine.LF)return i.EndOfLineSequence.LF}ye.from=Te;function le(Q){if(Q===i.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(Q===i.EndOfLineSequence.LF)return b.EndOfLine.LF}ye.to=le})(je||(e.EndOfLine=je={}));var H;(function(ye){function Te(le){if(typeof le=="object")return le.viewId;switch(le){case b.ProgressLocation.SourceControl:return m.ProgressLocation.Scm;case b.ProgressLocation.Window:return m.ProgressLocation.Window;case b.ProgressLocation.Notification:return m.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Te})(H||(e.ProgressLocation=H={}));var x;(function(ye){function Te(Q){const Ee={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ee.kind=De.from(Q.kind)),Ee}ye.from=Te;function le(Q){const Ee={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ee.kind=De.to(Q.kind)),Ee}ye.to=le})(x||(e.FoldingRange=x={}));var De;(function(ye){function Te(Q){if(Q)switch(Q){case b.FoldingRangeKind.Comment:return s.$Hu.Comment;case b.FoldingRangeKind.Imports:return s.$Hu.Imports;case b.FoldingRangeKind.Region:return s.$Hu.Region}}ye.from=Te;function le(Q){if(Q)switch(Q.value){case s.$Hu.Comment.value:return b.FoldingRangeKind.Comment;case s.$Hu.Imports.value:return b.FoldingRangeKind.Imports;case s.$Hu.Region.value:return b.FoldingRangeKind.Region}}ye.to=le})(De||(e.FoldingRangeKind=De={}));var Ze;(function(ye){function Te(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?T.from(le.selection):void 0,override:typeof le.override=="boolean"?u.$OF.id:void 0}}ye.from=Te})(Ze||(e.TextEditorOpenOptions=Ze={}));var Ye;(function(ye){function Te(Ve){return Ve instanceof b.$2N?Ve.toJSON():typeof Ve=="string"?Ve:le(Ve)||Q(Ve)?new b.$2N(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}ye.from=Te;function le(Ve){const Xe=Ve;return Xe?o.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Q(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ee(Ve){return typeof Ve=="string"?Ve:new b.$2N(o.URI.revive(Ve.baseUri),Ve.pattern)}ye.to=Ee})(Ye||(e.GlobPattern=Ye={}));var dt;(function(ye){function Te(le){if(le){if(Array.isArray(le))return le.map(Te);if(typeof le=="string")return le;{const Q=le;return{language:Q.language,scheme:Q.scheme,pattern:Ye.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=Te})(dt||(e.LanguageSelector=dt={}));var pt;(function(ye){function Te(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&o.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof b.$5M)))}ye.is=Te;function le(Q){return{documents:Q.documents.map(Ee=>Ee.map(Ve=>({uri:o.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>T.from(Xe))})))}}ye.from=le})(pt||(e.MappedEditsContext=pt={}));var Ft;(function(ye){function Te(Q){return{start:Q.start,end:Q.end}}ye.from=Te;function le(Q){return new b.$sO(Q.start,Q.end)}ye.to=le})(Ft||(e.NotebookRange=Ft={}));var zt;(function(ye){function Te(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=Te;function le(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=le})(zt||(e.NotebookCellExecutionSummary=zt={}));var xt;(function(ye){function Te(le){if(le===y.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(le===y.NotebookCellExecutionState.Pending)return;if(le===y.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${le}`)}ye.to=Te})(xt||(e.NotebookCellExecutionState=xt={}));var ui;(function(ye){function Te(Q){switch(Q){case b.NotebookCellKind.Markup:return y.CellKind.Markup;case b.NotebookCellKind.Code:default:return y.CellKind.Code}}ye.from=Te;function le(Q){switch(Q){case y.CellKind.Markup:return b.NotebookCellKind.Markup;case y.CellKind.Code:default:return b.NotebookCellKind.Code}}ye.to=le})(ui||(e.NotebookCellKind=ui={}));var xe;(function(ye){function Te(Q){const Ee={metadata:Q.metadata??Object.create(null),cells:[]};for(const Ve of Q.cells)b.$tO.validate(Ve),Ee.cells.push(It.from(Ve));return Ee}ye.from=Te;function le(Q){const Ee=new b.$uO(Q.cells.map(It.to));return(0,r.$rg)(Q.metadata)||(Ee.metadata=Q.metadata),Ee}ye.to=le})(xe||(e.NotebookData=xe={}));var It;(function(ye){function Te(Q){return{cellKind:ui.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:zt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(ht.from):[]}}ye.from=Te;function le(Q){return new b.$tO(ui.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(ht.to):void 0,Q.metadata,Q.internalMetadata?zt.to(Q.internalMetadata):void 0)}ye.to=le})(It||(e.NotebookCellData=It={}));var Gt;(function(ye){function Te(Q){return{mime:Q.mime,valueBytes:C.$Ne.wrap(Q.data)}}ye.from=Te;function le(Q){return new b.$vO(Q.valueBytes.buffer,Q.mime)}ye.to=le})(Gt||(e.NotebookCellOutputItem=Gt={}));var ht;(function(ye){function Te(Q){return{outputId:Q.id,items:Q.items.map(Gt.from),metadata:Q.metadata}}ye.from=Te;function le(Q){const Ee=Q.items.map(Gt.to);return new b.$wO(Ee,Q.outputId,Q.metadata)}ye.to=le})(ht||(e.NotebookCellOutput=ht={}));var bt;(function(ye){function Te(Ee){return Q(Ee)?{include:Ye.from(Ee.include)??void 0,exclude:Ye.from(Ee.exclude)??void 0}:Ye.from(Ee)??void 0}ye.from=Te;function le(Ee){return Q(Ee)?{include:Ye.to(Ee.include),exclude:Ye.to(Ee.exclude)}:Ye.to(Ee)}ye.to=le;function Q(Ee){const Ve=Ee;return Ve?!(0,r.$ng)(Ve.include)&&!(0,r.$ng)(Ve.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var hi;(function(ye){function Te(le,Q,Ee){const Ve=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===b.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:Q.toInternal(Ve,Ee),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ye.from=Te})(hi||(e.NotebookStatusBarItem=hi={}));var _t;(function(ye){function Te(le,Q,Ee){const Ve=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{command:Q.toInternal(Ve,Ee),label:le.label,description:le.description,detail:le.detail,documentation:le.documentation}}ye.from=Te})(_t||(e.NotebookKernelSourceAction=_t={}));var jt;(function(ye){function Te(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{},cellContentMetadata:le?.cellContentMetadata??{}}}ye.from=Te})(jt||(e.NotebookDocumentContentOptions=jt={}));var wt;(function(ye){function Te(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=Te;function le(Q){return new b.$yO(o.URI.revive(Q.uri),Q.provides)}ye.to=le})(wt||(e.NotebookRendererScript=wt={}));var Bt;(function(ye){function Te(Q){return{message:be.fromStrict(Q.message)||"",type:k.TestMessageType.Error,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:T.from(Q.location.range),uri:Q.location.uri}}}ye.from=Te;function le(Q){const Ee=new b.$EO(typeof Q.message=="string"?Q.message:be.to(Q.message));return Ee.actualOutput=Q.actual,Ee.expectedOutput=Q.expected,Ee.contextValue=Q.contextValue,Ee.location=Q.location?Ue.to(Q.location):void 0,Ee}ye.to=le})(Bt||(e.TestMessage=Bt={}));var Jt;(function(ye){ye.namespace=k.$TI,ye.denamespace=k.$UI})(Jt||(e.TestTag=Jt={}));var Qt;(function(ye){function Te(Q){const Ee=(0,f.$qP)(Q).controllerId;return{extId:S.$OI.fromExtHostTestItem(Q,Ee).toString(),label:Q.label,uri:o.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Ve=>Jt.namespace(Ee,Ve.id)),range:h.$Ht.lift(T.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&be.fromStrict(Q.error)||null}}ye.from=Te;function le(Q){return{parent:void 0,error:void 0,id:S.$OI.fromString(Q.extId).localId,label:Q.label,uri:o.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ee=>{const{tagId:Ve}=Jt.denamespace(Ee);return new b.$FO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:T.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=le})(Qt||(e.TestItem=Qt={})),function(ye){function Te(Q){return{id:Q.id}}ye.from=Te;function le(Q){return new b.$FO(Q.id)}ye.to=le}(Jt||(e.TestTag=Jt={}));var Qe;(function(ye){const Te=(Q,Ee)=>{const Ve=Q.value;if(!Ve)return;const Xe={...Qt.toPlain(Ve.item),parent:Ee,taskStates:Ve.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(lt=>lt.type===k.TestMessageType.Error).map(Bt.to)})),children:[]};if(Q.children)for(const Ge of Q.children.values()){const lt=Te(Ge,Xe);lt&&Xe.children.push(lt)}return Xe};function le(Q){const Ee=new l.$NI;for(const Ge of Q.items)Ee.insert(S.$OI.fromString(Ge.item.extId).path,Ge);const Ve=[Ee.nodes],Xe=[];for(;Ve.length;)for(const Ge of Ve.pop())Ge.value?Xe.push(Ge):Ge.children&&Ve.push(Ge.children.values());return{completedAt:Q.completedAt,results:Xe.map(Ge=>Te(Ge)).filter(r.$mg)}}ye.to=le})(Qe||(e.TestResults=Qe={}));var pi;(function(ye){function Te(Ve){return{covered:Ve.covered,total:Ve.total}}function le(Ve){return"line"in Ve?V.from(Ve):T.from(Ve)}function Q(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:le(Ve.location),type:k.DetailType.Statement,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&le(Xe.location),label:Xe.label})):void 0}:{type:k.DetailType.Declaration,name:Ve.name,count:Ve.executed,location:le(Ve.location)}}ye.fromDetails=Q;function Ee(Ve,Xe,Ge){return b.$HO(Ge.statementCoverage),b.$HO(Ge.branchCoverage),b.$HO(Ge.declarationCoverage),{id:Xe,uri:Ge.uri,statement:Te(Ge.statementCoverage),branch:Ge.branchCoverage&&Te(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Te(Ge.declarationCoverage),testId:Ge instanceof b.$IO&&Ge.testItem?S.$OI.fromExtHostTestItem(Ge.testItem,Ve).toString():void 0}}ye.fromFile=Ee})(pi||(e.TestCoverage=pi={}));var ei;(function(ye){function Te(le){switch(le){case s.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}ye.to=Te})(ei||(e.CodeActionTriggerKind=ei={}));var si;(function(ye){function Te(Q){const Ee=new b.$MO(ve.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),T.to(Q.range),T.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}ye.to=Te;function le(Q,Ee,Ve){if(Ee=Ee??Q._sessionId,Ve=Ve??Q._itemId,Ee===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ve,kind:ve.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),tags:Q.tags?.map(ue.from)}}ye.from=le})(si||(e.TypeHierarchyItem=si={}));var St;(function(ye){function Te(le){if(le)return{value:le.value,tooltip:le.tooltip}}ye.from=Te})(St||(e.ViewBadge=St={}));var Kt;(function(ye){function Te(Ve,Xe,Ge){const lt=Xe.fileData;return lt?new b.$TN(new b.$UN(lt.name,o.URI.revive(lt.uri),lt.id,(0,M.$eb)(()=>Ge(lt.id)))):Ve===R.$4s.uriList&&Xe.uriListData?new b.$SN(Ee(Xe.uriListData)):new b.$SN(Xe.asString)}ye.to=Te;async function le(Ve,Xe){const Ge=await Xe.asString();if(Ve===R.$4s.uriList)return{asString:Ge,fileData:void 0,uriListData:Q(Ge)};const lt=Xe.asFile();return{asString:Ge,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ye.from=le;function Q(Ve){return P.$lu.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return o.URI.parse(Xe)}catch{}return Xe})}function Ee(Ve){return P.$lu.create(Ve.map(Xe=>typeof Xe=="string"?Xe:o.URI.revive(Xe)))}})(Kt||(e.DataTransferItem=Kt={}));var At;(function(ye){function Te(Q,Ee){const Ve=Q.items.map(([Xe,Ge])=>[Xe,Kt.to(Xe,Ge,Ee)]);return new b.$VN(Ve)}ye.toDataTransfer=Te;async function le(Q){const Ee={items:[]},Ve=[];for(const[Xe,Ge]of Q)Ve.push((async()=>{Ee.items.push([Xe,await Kt.from(Xe,Ge)])})());return await Promise.all(Ve),Ee}ye.from=le})(At||(e.DataTransfer=At={}));var Ot;(function(ye){function Te(Q,Ee){return{kind:"reply",agentId:Q.participant??Ee?.agentId??"",subCommand:Q.command??Ee?.command,message:Q.prompt,title:Q.label}}ye.from=Te;function le(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}ye.to=le})(Ot||(e.ChatFollowup=Ot={}));var ti;(function(ye){function Te(Q){switch(Q){case I.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case I.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case I.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}ye.to=Te;function le(Q){switch(Q){case b.LanguageModelChatMessageRole.System:return I.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return I.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return I.ChatMessageRole.Assistant}return I.ChatMessageRole.User}ye.from=le})(ti||(e.LanguageModelChatMessageRole=ti={}));var ii;(function(ye){function Te(Q){let Ee="",Ve;Q.content.type==="text"?Ee=Q.content.value:Ve=new b.$bP(Q.content.name,Q.content.value,Q.content.isError);const Xe=ti.to(Q.role),Ge=new b.$cP(Xe,Ee,Q.name);return Ve!==void 0&&(Ge.content2=Ve),Ge}ye.to=Te;function le(Q){const Ee=ti.from(Q.role),Ve=Q.name;let Xe;return Q.content2 instanceof b.$bP?Xe={type:"function_result",name:Q.content2.name,value:Q.content2.content,isError:Q.content2.isError}:Xe={type:"text",value:Q.content},{role:Ee,name:Ve,content:Xe}}ye.from=le})(ii||(e.LanguageModelChatMessage=ii={}));var oi;(function(ye){function Te(Q){return{kind:"markdownContent",content:be.from(Q.value)}}ye.from=Te;function le(Q){return new b.$ZO(be.to(Q.content))}ye.to=le})(oi||(e.ChatResponseMarkdownPart=oi={}));var Vt;(function(ye){function Te(Q){return{kind:"markdownVuln",content:be.from(Q.value),vulnerabilities:Q.vulnerabilities}}ye.from=Te;function le(Q){return new b.$1O(be.to(Q.content),Q.vulnerabilities)}ye.to=le})(Vt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Vt={}));var Ht;(function(ye){function Te(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}ye.from=Te;function le(Q){return new b.$2O(Q.agentId,Q.command)}ye.to=le})(Ht||(e.ChatResponseDetectedParticipantPart=Ht={}));var di;(function(ye){function Te(le){return{kind:"confirmation",title:le.title,message:le.message,data:le.data}}ye.from=Te})(di||(e.ChatResponseConfirmationPart=di={}));var Lt;(function(ye){function Te(Q){const{value:Ee,baseUri:Ve}=Q;function Xe(Ge,lt){return Ge.map(Pt=>{const Xt=o.URI.joinPath(lt,Pt.name);return{label:Pt.name,uri:Xt,children:Pt.children&&Xe(Pt.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,E.$ch)(Ve),uri:Ve,children:Xe(Ee,Ve)}}}ye.from=Te;function le(Q){const Ee=(0,c.$bi)(Q.treeData);function Ve(lt){return lt.map(Pt=>({name:Pt.label,children:Pt.children&&Ve(Pt.children)}))}const Xe=Ee.uri,Ge=Ee.children?Ve(Ee.children):[];return new b.$4O(Ge,Xe)}ye.to=le})(Lt||(e.ChatResponseFilesPart=Lt={}));var vt;(function(ye){function Te(Q){const Ee=Ve=>o.URI.isUri(Ve);return{kind:"inlineReference",name:Q.title,inlineReference:Ee(Q.value)?Q.value:q.from(Q.value)}}ye.from=Te;function le(Q){const Ee=(0,c.$bi)(Q);return new b.$5O(o.URI.isUri(Ee.inlineReference)?Ee.inlineReference:q.to(Ee.inlineReference),Q.name)}ye.to=le})(vt||(e.ChatResponseAnchorPart=vt={}));var Ct;(function(ye){function Te(Q){return{kind:"progressMessage",content:be.from(Q.value)}}ye.from=Te;function le(Q){return new b.$6O(Q.content.value)}ye.to=le})(Ct||(e.ChatResponseProgressPart=Ct={}));var Tt;(function(ye){function Te(Q){return{kind:"warning",content:be.from(Q.value)}}ye.from=Te;function le(Q){return new b.$8O(Q.content.value)}ye.to=le})(Tt||(e.ChatResponseWarningPart=Tt={}));var kt;(function(ye){function Te(le){return{kind:"progressTask",content:be.from(le.value)}}ye.from=Te})(kt||(e.ChatTask=kt={}));var Zt;(function(ye){function Te(le){return{kind:"progressTaskResult",content:typeof le=="string"?be.from(le):void 0}}ye.from=Te})(Zt||(e.ChatTaskResult=Zt={}));var qt;(function(ye){function Te(Q,Ee,Ve){return{kind:"command",command:Ee.toInternal(Q.value,Ve)??{command:Q.value.command,title:Q.value.title}}}ye.from=Te;function le(Q,Ee){return new b.$9O(Ee.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}ye.to=le})(qt||(e.ChatResponseCommandButtonPart=qt={}));var $i;(function(ye){function Te(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Ee=>we.from(Ee))}}ye.from=Te;function le(Q){return new b.$$O(o.URI.revive(Q.uri),Q.edits.map(Ee=>we.to(Ee)))}ye.to=le})($i||(e.ChatResponseTextEditPart=$i={}));var fi;(function(ye){function Te(Q){const Ee=d.ThemeIcon.isThemeIcon(Q.iconPath)?Q.iconPath:o.URI.isUri(Q.iconPath)?{light:o.URI.revive(Q.iconPath)}:Q.iconPath&&"light"in Q.iconPath&&"dark"in Q.iconPath&&o.URI.isUri(Q.iconPath.light)&&o.URI.isUri(Q.iconPath.dark)?{light:o.URI.revive(Q.iconPath.light),dark:o.URI.revive(Q.iconPath.dark)}:void 0;return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:o.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:q.from(Q.value.value)},iconPath:Ee}:{kind:"reference",reference:o.URI.isUri(Q.value)?Q.value:q.from(Q.value),iconPath:Ee}}ye.from=Te;function le(Q){const Ee=(0,c.$bi)(Q),Ve=Xe=>o.URI.isUri(Xe)?Xe:q.to(Xe);return new b.$0O("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&Ve(Ee.reference.value)}:Ve(Ee.reference))}ye.to=le})(fi||(e.ChatResponseReferencePart=fi={}));var Ri;(function(ye){function Te(Ee,Ve,Xe){return Ee instanceof b.$ZO?oi.from(Ee):Ee instanceof b.$5O?vt.from(Ee):Ee instanceof b.$0O?fi.from(Ee):Ee instanceof b.$6O?Ct.from(Ee):Ee instanceof b.$4O?Lt.from(Ee):Ee instanceof b.$9O?qt.from(Ee,Ve,Xe):Ee instanceof b.$$O?$i.from(Ee):Ee instanceof b.$1O?Vt.from(Ee):Ee instanceof b.$2O?Ht.from(Ee):Ee instanceof b.$8O?Tt.from(Ee):{kind:"markdownContent",content:be.from("")}}ye.from=Te;function le(Ee,Ve){switch(Ee.kind){case"reference":return fi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ee,Ve)}}ye.to=le;function Q(Ee,Ve){switch(Ee.kind){case"markdownContent":return oi.to(Ee);case"inlineReference":return vt.to(Ee);case"progressMessage":return;case"treeData":return Lt.to(Ee);case"command":return qt.to(Ee,Ve)}}ye.toContent=Q})(Ri||(e.ChatResponsePart=Ri={}));var Nt;(function(ye){function Te(le){return{prompt:le.message,command:le.command,attempt:le.attempt??0,enableCommandDetection:le.enableCommandDetection??!0,references:le.variables.variables.map(ai.to),location:Ti.to(le.location),acceptedConfirmationData:le.acceptedConfirmationData,rejectedConfirmationData:le.rejectedConfirmationData}}ye.to=Te})(Nt||(e.ChatAgentRequest=Nt={}));var Ti;(function(ye){function Te(Q){switch(Q){case $.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}ye.to=Te;function le(Q){switch(Q){case b.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ye.from=le})(Ti||(e.ChatLocation=Ti={}));var ai;(function(ye){function Te(le){const Q=le.value;if(!Q)throw new Error("Invalid value reference");return{id:le.id,name:le.name,range:le.range&&[le.range.start,le.range.endExclusive],value:(0,o.$wc)(Q)?o.URI.revive(Q):Q&&typeof Q=="object"&&"uri"in Q&&"range"in Q&&(0,o.$wc)(Q.uri)?q.to((0,c.$bi)(Q)):Q,modelDescription:le.modelDescription}}ye.to=Te})(ai||(e.ChatAgentValueReference=ai={}));var Rt;(function(ye){function Te(le,Q,Ee){return{id:le.id,label:le.label,fullName:le.fullName,icon:le.icon?.id,value:le.values[0].value,insertText:le.insertText,detail:le.detail,documentation:le.documentation,command:Q.toInternal(le.command,Ee)}}ye.from=Te})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Di;(function(ye){function Te(le){return{errorDetails:le.errorDetails,metadata:le.metadata}}ye.to=Te})(Di||(e.ChatAgentResult=Di={}));var Si;(function(ye){function Te(le,Q,Ee){if(Q.action.kind==="vote")return;const Ve=Di.to(le);if(Q.action.kind==="command"){const Xe=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Ot.to(Q.action.followup)},result:Ve}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:Ve}:{action:Q.action,result:Ve}}ye.to=Te})(Si||(e.ChatAgentUserActionEvent=Si={}));var vi;(function(ye){function Te(le,Q,Ee){return"terminalCommand"in le?{terminalCommand:le.terminalCommand,shouldExecute:le.shouldExecute}:"uri"in le?{uri:le.uri}:Q.toInternal(le,Ee)}ye.from=Te})(vi||(e.TerminalQuickFix=vi={}));var Mi;(function(ye){function Te(le){return{kind:gi.to(le.kind)}}ye.to=Te})(Mi||(e.PartialAcceptInfo=Mi={}));var gi;(function(ye){function Te(le){switch(le){case s.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}ye.to=Te})(gi||(e.PartialAcceptTriggerKind=gi={}));var Wt;(function(ye){function Te(le,Q){return{id:Q,label:le.label,description:le.description,canEdit:le.canEdit,collapsibleState:le.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:le.contextValue}}ye.from=Te})(Wt||(e.DebugTreeItem=Wt={}))}),define(Ce[274],Ie([1,0,6,17,10,39]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;let A=class{constructor(p,c){this.a=p.getProxy(w.$1M.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>c.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,R){const v=new M.$Pw(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(v,void 0,R?.isRefactoring??!1)}};e.$mnc=A,e.$mnc=A=He([We(0,C.$uP)],A)}),define(Ce[275],Ie([1,0,18,11,48,4,40,5,70,15,2,19,6,10,7,235,25]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0,E=qe(E),d=qe(d);class a{constructor(i,t,m,f,u){this.j=i,this.k=t,this.l=m,this.m=f,this.n=u,this.b=p.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(f){if(i.c){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,f),u}};const i=this;this.b.reset();const m=(f,u)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),u){const $=this.l.$handleProgressChunk(this.k.requestId,f),I={report:D=>{$?.then(y=>{y&&(d.$sN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(D),y))})}};Promise.all([$,u?.(I)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){t(this.markdown);const u=new d.$ZO(f),$=E.ChatResponseMarkdownPart.from(u);return m($),this},markdownWithVulnerabilities(f,u){t(this.markdown),u&&(0,o.$4G)(i.j,"chatParticipantAdditions");const $=new d.$1O(f,u),I=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return m(I),this},filetree(f,u){t(this.filetree);const $=new d.$4O(f,u),I=E.ChatResponseFilesPart.from($);return m(I),this},anchor(f,u){t(this.anchor);const $=new d.$5O(f,u),I=E.ChatResponseAnchorPart.from($);return m(I),this},button(f){t(this.anchor);const u=new d.$9O(f),$=E.ChatResponseCommandButtonPart.from(u,i.m,i.n);return m($),this},progress(f,u){t(this.progress);const $=new d.$7O(f,u),I=u?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return m(I,u),this},warning(f){t(this.progress),(0,o.$4G)(i.j,"chatParticipantAdditions");const u=new d.$8O(f),$=E.ChatResponseWarningPart.from(u);return m($),this},reference(f,u){if(t(this.reference),"variableName"in f&&(0,o.$4G)(i.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const $=i.k.variables.variables.find(I=>I.name===f.variableName);if($){let I;if($.references?.length)I=$.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new d.$0O(f,u);I=[E.ChatResponseReferencePart.from(D)]}return I.forEach(D=>m(D)),this}}else{const $=new d.$0O(f,u),I=E.ChatResponseReferencePart.from($);m(I)}return this},textEdit(f,u){t(this.textEdit),(0,o.$4G)(i.j,"chatParticipantAdditions");const $=new d.$$O(f,u),I=E.ChatResponseTextEditPart.from($);return m(I),this},detectedParticipant(f,u){t(this.detectedParticipant),(0,o.$4G)(i.j,"chatParticipantAdditions");const $=new d.$2O(f,u),I=E.ChatResponseDetectedParticipantPart.from($);return m(I),this},confirmation(f,u,$){t(this.confirmation),(0,o.$4G)(i.j,"chatParticipantAdditions");const I=new d.$3O(f,u,$),D=E.ChatResponseConfirmationPart.from(I);return m(D),this},push(f){if(t(this.push),(f instanceof d.$$O||f instanceof d.$1O||f instanceof d.$2O||f instanceof d.$8O||f instanceof d.$3O)&&(0,o.$4G)(i.j,"chatParticipantAdditions"),f instanceof d.$0O)this.reference(f.value,f.iconPath);else{const u=E.ChatResponsePart.from(f,i.m,i.n);m(u)}return this}}}return this.g}}class h extends N.$Vc{static{this.b=0}constructor(i,t,m,f){super(),this.n=t,this.s=m,this.t=f,this.c=new Map,this.j=this.B(new N.$5c),this.m=this.B(new N.$5c),this.g=i.getProxy(l.$1M.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,m){const f=h.b++,u=new n(i,this.t,t,this.g,f,m);return this.c.set(f,u),u.isAgentEnabled()&&this.g.$registerAgent(f,i.identifier,t,{},void 0),u.apiAgent}createDynamicChatAgent(i,t,m,f){const u=h.b++,$=new n(i,this.t,t,this.g,u,f);return this.c.set(u,$),this.g.$registerAgent(u,i.identifier,t,{isSticky:!0},m),$.apiAgent}async $invokeAgent(i,t,m,f){const u=this.c.get(i);if(!u)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(t.sessionId);$||($=new N.$Uc,this.j.set(t.sessionId,$));const I=new a(u.extension,t,this.g,this.s.converter,$);try{const D=await this.u(t.agentId,m),y=u.invoke(E.ChatAgentRequest.to(t),{history:D},I.apiObject,f);return await(0,C.$sh)(Promise.resolve(y).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(g){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.n.error(`[${u.extension.identifier.value}] [@${u.id}] ${b}`,u.extension),{errorDetails:{message:b},timings:I.timings}}let k;return S?.errorDetails&&(k={...S.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,o.$4G)(u.extension,"chatParticipantPrivate"),{errorDetails:k,timings:I.timings,metadata:S?.metadata}}),f)}catch(D){return this.n.error(D,u.extension),D instanceof d.$iP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,P.$pj)(D),responseIsIncomplete:!0}}}finally{I.close()}}async u(i,t){const m=[];for(const f of t.history){const u=E.ChatAgentResult.to(f.result),$=i===f.request.agentId?u:{...u,metadata:void 0};m.push(new d.$_O(f.request.message,f.request.command,f.request.variables.variables.map(E.ChatAgentValueReference.to),f.request.agentId));const I=(0,w.$Ib)(f.response.map(D=>E.ChatResponsePart.toContent(D,this.s.converter)));m.push(new d.$aP(I,$,f.request.agentId,f.request.command))}return m}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,m,f,u){const $=this.c.get(t);if(!$)return Promise.resolve([]);const I=await this.u($.id,f),D=E.ChatAgentResult.to(m);return(await $.provideFollowups(D,{history:I},u)).filter(y=>{const S=!y.participant||A.Iterable.some(this.c.values(),k=>k.id===y.participant&&v.$pn.equals(k.extension.identifier,$.extension.identifier));return S||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),S}).map(y=>E.ChatFollowup.from(y,i))}$acceptFeedback(i,t,m,f){const u=this.c.get(i);if(!u)return;const $=E.ChatAgentResult.to(t);let I;switch(m){case r.ChatAgentVoteDirection.Down:I=d.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:I=d.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(f?{result:$,kind:I,reportIssue:f}:{result:$,kind:I}))}$acceptAction(i,t,m){const f=this.c.get(i);if(!f||m.action.kind==="vote")return;const u=E.ChatAgentUserActionEvent.to(t,m,this.s.converter);u&&f.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(i,t,m){const f=this.c.get(i);if(!f)return[];let u=this.m.get(i);return u?u.clear():(u=new N.$Uc,this.m.set(i,u)),(await f.invokeCompletionProvider(t,m)).map(I=>E.ChatAgentCompletionItem.from(I,this.s.converter,u))}async $provideWelcomeMessage(i,t,m){const f=this.c.get(i);if(f)return await f.provideWelcomeMessage(E.ChatLocation.to(t),m)}async $provideSampleQuestions(i,t,m){const f=this.c.get(i);if(f)return(await f.provideSampleQuestions(E.ChatLocation.to(t),m)).map(u=>E.ChatFollowup.from(u,void 0))}}e.$nnc=h;class n{constructor(i,t,m,f,u,$){this.extension=i,this.w=t,this.id=m,this.x=f,this.y=u,this.z=$,this.m=new M.$le,this.n=new M.$le}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$3G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,m){if(!this.b)return[];const f=await this.b.provideFollowups(i,t,m);return f?f.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(i,t);return m?m.map(f=>typeof f=="string"?f:E.MarkdownString.from(f)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(i,t);return m||[]}get apiAgent(){let i=!1,t=!1;const m=()=>{i||t||(t=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof R.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$ZN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(u){f.c=u,m()},get requestHandler(){return f.z},set requestHandler(u){(0,c.$og)(typeof u=="function","Invalid request handler"),f.z=u},get followupProvider(){return f.b},set followupProvider(u){f.b=u,m()},get isDefault(){return(0,o.$4G)(f.extension,"defaultChatParticipant"),f.d},set isDefault(u){(0,o.$4G)(f.extension,"defaultChatParticipant"),f.d=u,m()},get helpTextPrefix(){return(0,o.$4G)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(u){(0,o.$4G)(f.extension,"defaultChatParticipant"),f.g=u,m()},get helpTextVariablesPrefix(){return(0,o.$4G)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(u){(0,o.$4G)(f.extension,"defaultChatParticipant"),f.j=u,m()},get helpTextPostfix(){return(0,o.$4G)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(u){(0,o.$4G)(f.extension,"defaultChatParticipant"),f.k=u,m()},get isSecondary(){return(0,o.$4G)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(u){(0,o.$4G)(f.extension,"defaultChatParticipant"),f.l=u,m()},get supportIssueReporting(){return(0,o.$4G)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(u){(0,o.$4G)(f.extension,"chatParticipantPrivate"),f.o=u,m()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(u){if((0,o.$4G)(f.extension,"chatParticipantAdditions"),f.q=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,u.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,o.$4G)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(u){(0,o.$4G)(f.extension,"defaultChatParticipant"),f.s=u,m()},get welcomeMessageProvider(){return(0,o.$4G)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,o.$3G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(u){f.t=u,m()},get requester(){return f.t},set supportsSlowReferences(u){(0,o.$4G)(f.extension,"chatParticipantPrivate"),f.u=u,m()},get supportsSlowReferences(){return(0,o.$4G)(f.extension,"chatParticipantPrivate"),f.u},dispose(){i=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(i,t,m,f){return this.z(i,t,m,f)}}}),define(Ce[276],Ie([1,0,14,5,35,6,10,7,25]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0,A=qe(A),N=qe(N);class c{static{this.a=0}constructor(l){this.b=new Map,this.c=l.getProxy(M.$1M.MainThreadChatVariables)}async $resolveVariable(l,E,d,r){const o=this.b.get(l);if(o)try{if(o.resolver.resolve2){(0,p.$4G)(o.extension,"chatParticipantAdditions");const a=new R(E,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},a.apiObject,r);if(h&&h[0])return h[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:d},r);if(a&&a[0])return a[0].value}}catch(a){(0,w.$3)(a)}}registerVariableResolver(l,E,d,r,o,a,h,n,s){const i=c.a++,t=s?P.ThemeIcon.fromId(s):void 0;return this.b.set(i,{extension:l,data:{id:E,name:d,description:r,modelDescription:o,icon:t},resolver:h}),this.c.$registerVariable(i,{id:E,name:d,description:r,modelDescription:o,isSlow:a,fullName:n,icon:t}),(0,C.$Tc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$onc=c;class R{constructor(l,E){this.c=l,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(l.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const l=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const o=new N.$6O(r),a=A.ChatResponseProgressPart.from(o);return d(a),this},reference(r){E(this.reference);const o=new N.$0O(r),a=A.ChatResponseReferencePart.from(o);return d(a),this},push(r){return E(this.push),r instanceof N.$0O?d(A.ChatResponseReferencePart.from(r)):r instanceof N.$6O&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ce[277],Ie([1,0,11,72,4,5,38,2,94,19,10,7,6,25]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=d,p=qe(p),R=qe(R),v=qe(v);function d(r,o,a){const h=r.getProxy(l.$1M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$rn,o.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===A.MarshalledId.CommentController){const S=this.b.get(y.handle);return S?S.value:y}else if(y&&y.$mid===A.MarshalledId.CommentThread){const S=y,k=this.b.get(S.commentControlHandle);if(!k)return S;const g=k.getCommentThread(S.commentThreadHandle);return g?g.value:S}else if(y&&(y.$mid===A.MarshalledId.CommentThreadReply||y.$mid===A.MarshalledId.CommentThreadInstance)){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);return k?y.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:y.text}:y}else if(y&&y.$mid===A.MarshalledId.CommentNode){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const g=y.commentUniqueId,b=k.getCommentByUniqueId(g);return b||y}else if(y&&y.$mid===A.MarshalledId.CommentThreadNode){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const g=y.text,b=y.commentUniqueId,F=k.getCommentByUniqueId(b);return F?(typeof F.body=="string"?F.body=g:F.body=new v.$sN(g),F):y}return y}})}createCommentController(y,S,k){const g=n.a++,b=new i(y,g,S,k);this.b.set(b.handle,b);const F=this.c.get(y.identifier)||[];return F.push(b),this.c.set(y.identifier,F),b.value}async $createCommentThreadTemplate(y,S,k,g){const b=this.b.get(y);b&&b.$createCommentThreadTemplate(S,k,g)}async $setActiveComment(y,S){const k=this.b.get(y);k&&k.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(y,S,k){const g=this.b.get(y);g&&g.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(y,S){this.b.get(y)?.$deleteCommentThread(S)}async $provideCommentingRanges(y,S,k){const g=this.b.get(y);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const b=await a.ensureDocumentData(N.URI.revive(S));return(0,w.$wh)(async()=>{const F=await g.commentingRangeProvider.provideCommentingRanges(b.document,k);let T;return Array.isArray(F)?T={ranges:F,fileComments:!1}:F?T={ranges:F.ranges||[],fileComments:F.fileComments||!1}:T=F??void 0,T}).then(F=>{let T;return F&&(T={ranges:F.ranges.map(q=>R.Range.from(q)),fileComments:F.fileComments}),T})}$toggleReaction(y,S,k,g,b){const F=this.b.get(y);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,w.$wh)(()=>{const T=F.getCommentThread(S);if(T){const q=T.getCommentByUniqueId(g.uniqueIdInThread);if(F!==void 0&&q&&F.reactionHandler)return F.reactionHandler(q,f(b))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,E.$4G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,S,k,g,b,F,T,q,G){this.m=S,this.n=k,this.o=g,this.p=b,this.q=F,this.extensionDescription=T,this.r=q,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Wc,this.l.value=new M.$Uc,this.n===void 0&&(this.n=`${y}.${this.handle}`),h.$createCommentThread(S,this.handle,this.n,this.o,R.Range.from(this.p),T.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this.i.push({dispose:()=>{h.$deleteCommentThread(S,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(O){V.range=O},get comments(){return V.comments},set comments(O){V.comments=O},get collapsibleState(){return V.collapsibleState},set collapsibleState(O){V.collapsibleState=O},get canReply(){return V.canReply},set canReply(O){V.canReply=O},get contextValue(){return V.contextValue},set contextValue(O){V.contextValue=O},get label(){return V.label},set label(O){V.label=O},get state(){return V.state},set state(O){V.state=O},reveal:O=>V.reveal(O),dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Uc);const y=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};y("range")&&(S.range=R.Range.from(this.p)),y("label")&&(S.label=this.label),y("contextValue")&&(S.contextValue=this.contextValue??null),y("comments")&&(S.comments=this.q.map(k=>t(this,k,this.k,this.extensionDescription))),y("collapsibleState")&&(S.collapseState=u(this.g)),y("canReply")&&(S.canReply=this.canReply),y("state")&&(S.state=$(this.h)),y("applicability")&&(S.applicability=I(this.h)),y("isTemplate")&&(S.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(y){for(const S of this.k){const k=S[0],g=S[1];if(y===g)return k}}async reveal(y){return(0,E.$4G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}He([(0,C.$0h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,E.$4G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$4G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$4G)(this.h,"activeComment"),this.f}constructor(y,S,k,g){this.h=y,this.i=S,this.j=k,this.k=g,this.a=new Map,h.$registerCommentController(this.handle,k,g,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(F){b.options=F},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(F){b.commentingRangeProvider=F},get reactionHandler(){return b.reactionHandler},set reactionHandler(F){b.reactionHandler=F},get activeCommentThread(){return b.activeCommentThread},createCommentThread(F,T,q){return b.createCommentThread(F,T,q).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(y,S,k){S===void 0&&(0,E.$4G)(this.h,"fileComments");const g=new s(this.id,this.handle,void 0,y,S,k,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const S=this.a.get(y.commentThreadHandle);S&&(this.e=y.uniqueIdInThread?S.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(y,S,k){const g=new s(this.id,this.handle,void 0,N.URI.revive(y),R.Range.to(S),[],this.h,!0,k);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(y,S){const k=this.a.get(y);k&&(k.range=R.Range.to(S))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function t(D,y,S,k){let g=S.get(y);return g||(g=++D.commentHandle,S.set(y,g)),y.state!==void 0&&(0,E.$4G)(k,"commentsDraftState"),y.reactions?.some(b=>b.reactors!==void 0)&&(0,E.$4G)(k,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:g,body:typeof y.body=="string"?y.body:R.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(b=>m(b)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function m(D){return{label:D.label,iconPath:D.iconPath?R.$tP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?N.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function u(D){if(D!==void 0)switch(D){case v.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case v.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case v.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case v.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function I(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case v.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case v.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Ce[278],Ie([1,0,22,76,5,16,24,2,10,68,80,6,7]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=void 0,p=qe(p),v=qe(v),l=qe(l);class E{constructor(m,f){this.document=m,this.b=f,this.a=1,this.c=new R.$$mc("custom documents")}addEdit(m){return this.c.add([m])}async undo(m,f){await this.f(m).undo(),f||this.disposeBackup()}async redo(m,f){await this.f(m).redo(),f||this.disposeBackup()}disposeEdits(m){for(const f of m)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const m=i(this.document.uri)+this.a++;return(0,A.$fh)(this.b,m)}updateBackup(m){this.d?.delete(),this.d=m}disposeBackup(){this.d?.delete(),this.d=void 0}f(m){const f=this.c.get(m,0);if(!f)throw new Error("No edit found");return f}}class d{constructor(){this.a=new Map}get(m,f){return this.a.get(this.b(m,f))}add(m,f,u){const $=this.b(m,f.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${m} resource:${f.uri}`);const I=new E(f,u);return this.a.set($,I),I}delete(m,f){const u=this.b(m,f.uri);this.a.delete(u)}b(m,f){return`${m}@@@${f}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(m,f,u){return this.b(m,{type:r.Text,extension:f,provider:u})}addCustomProvider(m,f,u){return this.b(m,{type:r.Custom,extension:f,provider:u})}get(m){return this.a.get(m)}b(m,f){if(this.a.has(m))throw new Error(`Provider for viewType:${m} already registered`);return this.a.set(m,f),new l.$3M(()=>this.a.delete(m))}}class a{constructor(m,f,u,$,I){this.d=f,this.f=u,this.g=$,this.h=I,this.b=new o,this.c=new d,this.a=m.getProxy(v.$1M.MainThreadCustomEditors)}registerCustomEditorProvider(m,f,u,$){const I=new P.$Uc;return n(u)?(I.add(this.b.addTextProvider(f,m,u)),this.a.$registerTextEditorProvider((0,c.$Hnc)(m),f,$.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,c.$Fnc)(m))):(I.add(this.b.addCustomProvider(f,m,u)),h(u)&&I.add(u.onDidChangeCustomDocument(D=>{const y=this.i(f,D.document.uri);if(s(D)){const S=y.addEdit(D);this.a.$onDidEdit(D.document.uri,f,S,D.label)}else this.a.$onContentChange(D.document.uri,f)})),this.a.$registerCustomEditorProvider((0,c.$Hnc)(m),f,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,c.$Fnc)(m))),l.$3M.from(I,new l.$3M(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(m,f,u,$,I){const D=this.b.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const y=N.URI.revive(m),S=await D.provider.openCustomDocument(y,{backupId:u,untitledDocumentData:$?.buffer},I);let k;return h(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(f,S,k),{editable:h(D.provider)}}async $disposeCustomDocument(m,f){const u=this.b.get(f);if(!u)throw new Error(`No provider found for '${f}'`);if(u.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const $=N.URI.revive(m),{document:I}=this.i(f,$);this.c.delete(f,I),I.dispose()}async $resolveCustomEditor(m,f,u,$,I,D){const y=this.b.get(u);if(!y)throw new Error(`No provider found for '${u}'`);const S=p.ViewColumn.to(I),k=this.g.createNewWebview(f,$.contentOptions,y.extension),g=this.h.createNewWebviewPanel(f,u,$.title,S,$.options,k,$.active),b=N.URI.revive(m);switch(y.type){case r.Custom:{const{document:F}=this.i(u,b);return y.provider.resolveCustomEditor(F,g,D)}case r.Text:{const F=this.d.getDocument(b);return y.provider.resolveCustomTextEditor(F,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(m,f,u){this.i(f,m).disposeEdits(u)}async $onMoveCustomEditor(m,f,u){const $=this.b.get(u);if(!$)throw new Error(`No provider found for '${u}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const I=this.h.getWebviewPanel(m);if(!I)throw new Error("No webview found");const D=N.URI.revive(f),y=this.d.getDocument(D);await $.provider.moveCustomTextEditor(y,I,w.CancellationToken.None)}async $undo(m,f,u,$){return this.i(f,m).undo(u,$)}async $redo(m,f,u,$){return this.i(f,m).redo(u,$)}async $revert(m,f,u){const $=this.i(f,m);await this.j(f).revertCustomDocument($.document,u),$.disposeBackup()}async $onSave(m,f,u){const $=this.i(f,m);await this.j(f).saveCustomDocument($.document,u),$.disposeBackup()}async $onSaveAs(m,f,u,$){const I=this.i(f,m);return this.j(f).saveCustomDocumentAs(I.document,N.URI.revive(u),$)}async $backup(m,f,u){const $=this.i(f,m),D=await this.j(f).backupCustomDocument($.document,{destination:$.getNewBackupUri()},u);return $.updateBackup(D),D.id}i(m,f){const u=this.c.get(m,N.URI.revive(f));if(!u)throw new Error("No custom document found");return u}j(m){const u=this.b.get(m)?.provider;if(!u||!h(u))throw new Error("Custom document is not editable");return u}}e.$Knc=a;function h(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const m=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,C.$sj)(m)+""}}),define(Ce[279],Ie([1,0,180,107,2,6,7,10,4,12,29,51]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0,N=qe(N);class E{#e;#t;#i;constructor(o,a,h,n,s,i,t,m){this.d=o,this.e=a,this.f=h,this.g=n,this.h=s,this.c=!1,this.f=Math.max(n,h),this.#i=new R.$Bc(f=>i.getComparisonKey(f)),this.#e=t,this.#t=m}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,a){if(!o){this.clear();return}this.j();let h=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),h=[o]}else if(Array.isArray(o)){h=[];let i;o=[...o].sort(E.k);for(const t of o){const[m,f]=t;if((!i||m.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=m,h.push(m),this.#i.set(m,[])),f)this.#i.get(m)?.push(...f);else{const u=this.#i.get(m);u&&(u.length=0)}}}if(this.#t.fire(h),!this.#e)return;const n=[];let s=0;for(const i of h){let t=[];const m=this.#i.get(i);if(m)if(m.length>this.g){t=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const $ of m)if($.severity===f[u]&&t.push({...N.Diagnostic.from($),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:C.MarkerSeverity.Info,message:(0,w.localize)(0,null,m.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=m.map(f=>({...N.Diagnostic.from(f),modelVersionId:this.h(i)}));if(n.push([i,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,a){this.j();for(const[h,n]of this)o.call(a,h,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.$fnc=E;let d=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const a=new R.$Bc;for(const h of o)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,h,n){this.j=a,this.k=h,this.l=n,this.g=new Map,this.h=new p.$pe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,l._mapper),this.f=o.getProxy(M.$1M.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{g:h,f:n,h:s,j:i,k:t,l:m}=this,f=new class{$changeMany(I,D){n.$changeMany(I,D),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,I,D.length===0?"CLEARING":D)}$clear(I){n.$clear(I),i.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,I)}dispose(){n.dispose()}};let u;if(!a)a="_generated_diagnostic_collection_name_#"+l.c++,u=a;else if(!h.has(a))u=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do u=a+l.c++;while(h.has(u))}return new class extends E{constructor(){super(a,u,l.e,l.d,I=>m.getDocument(I)?.version,t.extUri,f,s),h.set(u,this)}dispose(){super.dispose(),h.delete(u)}}}getDiagnostics(o){if(o)return this.m(o);{const a=new Map,h=[];for(const n of this.g.values())n.forEach((s,i)=>{let t=a.get(s.toString());typeof t>"u"&&(t=h.length,a.set(s.toString(),t),h.push([s,[]])),h[t][1]=h[t][1].concat(...i)});return h}}m(o){let a=[];for(const h of this.g.values())h.has(o)&&(a=a.concat(h.get(o)));return a}$acceptMarkersChange(o){if(!this.n){const a="_generated_mirror",h=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of o)this.n.set(P.URI.revive(a),h.map(N.Diagnostic.to))}};e.$gnc=d,e.$gnc=d=l=He([We(1,c.$$j),We(2,v.$enc)],d)}),define(Ce[280],Ie([1,0,2,14,7,10,212,39]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;class p{constructor(R,v,l,E={timeout:1500,errors:3}){this.c=R,this.d=v,this.f=l,this.g=E,this.a=new A.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(v,l,E)=>{const r={dispose:this.a.push([v,l,R])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(R,v){const l=w.URI.revive(R);let E=!1;const d=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(E)break;const a=this.d.getDocument(l),h=await this.h(o,{document:a,reason:M.TextDocumentSaveReason.to(v)});r.push(h)}}finally{clearTimeout(d)}return r}h([R,v,l],E){const d=this.b.get(R);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(l,R,v,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(R);this.b.set(R,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,v,l,E){const d=[],r=Date.now(),{document:o,reason:a}=E,{version:h}=o,n=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(d))throw(0,C.$9)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{v.apply(l,[n])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(d).then(m=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),s(m)}).catch(m=>{clearTimeout(t),i(m)})}).then(s=>{const i={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(m=>m instanceof P.$0M))for(const{newText:m,newEol:f,range:u}of t)i.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:m,eol:f&&M.EndOfLine.from(f)}});if(i.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new N.$Pw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$toc=p}),define(Ce[281],Ie([1,0,4,5,2,6,122,10,15,26,7]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0,N=qe(N);class v{constructor(E,d){this.a=new w.$le,this.b=new w.$le,this.c=new w.$le,this.d=new w.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.$Uc,this.h=new Map,this.f=E.getProxy(M.$1M.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const d=this.g.getDocument(E);if(d)return d}getDocument(E){const d=this.getDocumentData(E);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return d.document}ensureDocumentData(E){const d=this.g.getDocument(E);if(d)return Promise.resolve(d);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(o=>{this.h.delete(E.toString());const a=P.URI.revive(o);return(0,p.$pg)(this.g.getDocument(a))},o=>(this.h.delete(E.toString()),Promise.reject(o))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(E,d){const r=P.URI.revive(E),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(E){const d=P.URI.revive(E),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,d){const r=P.URI.revive(E),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,d,r){const o=P.URI.revive(E),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(d);let h;d.isUndoing?h=R.TextDocumentChangeReason.Undo:d.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this.c.fire((0,c.$co)({document:a.document,contentChanges:d.changes.map(n=>({range:N.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:h}))}setWordDefinitionFor(E,d){(0,A.$wP)(E,d)}}e.$hnc=v}),define(Ce[71],Ie([1,0,282,4,15,2,3,6,17,10,7]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=void 0,c=qe(c),e.$Lnc=(0,A.$Ei)("IExtHostEditorTabs");class v{constructor(o,a,h){this.e=h,this.d=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case N.TabInputKind.TextInput:return new R.$NO(M.URI.revive(this.b.input.uri));case N.TabInputKind.TextDiffInput:return new R.$OO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case N.TabInputKind.TextMergeInput:return new R.$PO(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case N.TabInputKind.CustomEditorInput:return new R.$QO(M.URI.revive(this.b.input.uri),this.b.input.viewType);case N.TabInputKind.WebviewEditorInput:return new R.$RO(this.b.input.viewType);case N.TabInputKind.NotebookInput:return new R.$SO(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case N.TabInputKind.NotebookDiffInput:return new R.$TO(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case N.TabInputKind.TerminalEditorInput:return new R.$UO;case N.TabInputKind.InteractiveEditorInput:return new R.$VO(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case N.TabInputKind.ChatEditorInput:return new R.$WO;case N.TabInputKind.MultiDiffEditorInput:return new R.$XO(this.b.input.diffEditors.map(o=>new R.$OO(M.URI.revive(o.original),M.URI.revive(o.modified))));default:return}}}class l{constructor(o,a){this.c=[],this.d="",this.b=o,this.e=a;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new v(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return c.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===N.TabModelOperationKind.TAB_OPEN){const h=new v(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===N.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===N.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const a=this.c.find(h=>h.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(o){this.b=new C.$le,this.c=new C.$le,this.e=[],this.a=o.getProxy(N.$1M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,a={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,P.$pg)(o.e.find(s=>s.groupId===h)?.apiObject)},close:async(h,n)=>{const s=Array.isArray(h)?h:[h];return s.length?d(s[0])?this.j(s,n):this.i(s,n):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(o){const a=new Set(this.e.map(f=>f.groupId)),h=new Set(o.map(f=>f.groupId)),n=(0,w.$L)(a,h),s=this.e.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),i=[],t=[];this.e=o.map(f=>{const u=new l(f,()=>this.d);return n.added.includes(u.groupId)?i.push(u.apiObject):t.push(u.apiObject),u});const m=(0,P.$pg)(o.find(f=>f.isActive===!0)?.groupId);m!==void 0&&this.d!==m&&(this.d=m),this.c.fire(Object.freeze({opened:i,closed:s,changed:t}))}$acceptTabGroupUpdate(o){const a=this.e.find(h=>h.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this.e.find(n=>n.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const h=a.acceptTabOperation(o);switch(o.kind){case N.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case N.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case N.TabModelOperationKind.TAB_MOVE:case N.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const a of this.e)for(const h of a.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(a=>a.apiObject===o)}async i(o,a){const h=[];for(const n of o){const s=this.g(n);if(!s)throw new Error("Tab close: Invalid tab not found!");h.push(s.tabId)}return this.a.$closeTab(h,a)}async j(o,a){const h=[];for(const n of o){const s=this.h(n);if(!s)throw new Error("Group close: Invalid group not found!");h.push(s.groupId)}return this.a.$closeGroup(h,a)}};e.$Mnc=E,e.$Mnc=E=He([We(0,p.$uP)],E);function d(r){return r.tabs!==void 0}}),define(Ce[283],Ie([1,0,2,6,30,5,7,10,326,13,28,23,25,60]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0,P=qe(P),N=qe(N);class d{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const h=this.a.indexOf(a);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),h=[];let n,s,i=p.State.LastKnownState,t=p.State.LastKnownState;for(const m of a){let f=n?(0,c.$Hf)(n,m):0;for(f===0?s=p.State.Start:s=t;f<m.length;f++)f+1===m.length?(i=t,t=p.State.BeforeColon):t+=1,h.push([s,m.toUpperCase().charCodeAt(f),t]),h.push([s,m.toLowerCase().charCodeAt(f),t]),s=t;n=m,t=i}h.push([p.State.BeforeColon,R.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,R.CharCode.Slash,p.State.End]),this.b=new p.$F3(h)}}provideDocumentLinks(a){this.c();const h=[],n=p.$G3.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this.b);for(const s of n){const i=N.DocumentLink.to(s);i.target&&h.push(i)}return h}}class r{constructor(a,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(C.$1M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,h,n,s={}){if(r.j(n),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(h),this.d.add(h),this.c.set(i,n);let t=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(t+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(t+=P.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,l.$4G)(a,"fsChunks"),t+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let m;s.isReadonly&&(0,E.$4k)(s.isReadonly)&&s.isReadonly.value!==""&&(m={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(i,h,t,m).catch(u=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(u)});const f=n.onDidChangeFile(u=>{const $=[];for(const I of u){const{uri:D,type:y}=I;if(D.scheme!==h)continue;let S;switch(y){case A.FileChangeType.Changed:S=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:S=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:S=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:S})}this.a.$onFileSystemChange(i,$)});return(0,M.$Tc)(()=>{f.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:h,ctime:n,mtime:s,size:i,permissions:t}=a;return{type:h,ctime:n,mtime:s,size:i,permissions:t}}$stat(a,h){return Promise.resolve(this.l(a).stat(w.URI.revive(h))).then(n=>r.k(n))}$readdir(a,h){return Promise.resolve(this.l(a).readDirectory(w.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this.l(a).readFile(w.URI.revive(h))).then(n=>v.$Ne.wrap(n))}$writeFile(a,h,n,s){return Promise.resolve(this.l(a).writeFile(w.URI.revive(h),n.buffer,s))}$delete(a,h,n){return Promise.resolve(this.l(a).delete(w.URI.revive(h),n))}$rename(a,h,n,s){return Promise.resolve(this.l(a).rename(w.URI.revive(h),w.URI.revive(n),s))}$copy(a,h,n,s){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(w.URI.revive(h),w.URI.revive(n),s))}$mkdir(a,h){return Promise.resolve(this.l(a).createDirectory(w.URI.revive(h)))}$watch(a,h,n,s){const i=this.l(a).watch(w.URI.revive(n),s);this.f.set(h,i)}$unwatch(a,h){const n=this.f.get(h);n&&(n.dispose(),this.f.delete(h))}$open(a,h,n){const s=this.l(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(w.URI.revive(h),n))}$close(a,h){const n=this.l(a);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(h))}$read(a,h,n,s){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=v.$Ne.alloc(s);return Promise.resolve(i.read(h,n,t.buffer,0,s)).then(m=>t.slice(0,m))}$write(a,h,n,s){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(h,n,s.buffer,0,s.byteLength))}l(a){const h=this.c.get(a);if(!h){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return h}}e.$woc=r}),define(Ce[284],Ie([1,0,4,41,2,6,10,7,30,47]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0,A=qe(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,a,h,n){this.a=Math.random(),this.b=new w.$le,this.c=new w.$le,this.d=new w.$le,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const s=(0,C.$yk)(h),i=typeof h=="string",t=n?.correlate,m=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(t&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const u of f.created){const $=P.URI.revive(u);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const u of f.changed){const $=P.URI.revive(u);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const u of f.deleted){const $=P.URI.revive(u);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=N.$3M.from(this.i(d,o,h,n,n?.correlate),this.b,this.c,this.d,m)}i(d,r,o,a,h){const n=N.$3M.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return n;const s=d.getProxy(M.$1M.MainThreadFileSystemEventService);let i=!1;(o.pattern.includes(C.$uk)||o.pattern.includes(C.$vk))&&(i=!0);let t;return h&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(t=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(t&=~p.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(t&=~p.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(t&=~p.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:i,excludes:a?.excludes??[],filter:t},!!h),N.$3M.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class v{constructor(d){this.a=d,this.session=this.a.session,this.b=new c.$W(()=>this.a.created.map(P.URI.revive)),this.c=new c.$W(()=>this.a.changed.map(P.URI.revive)),this.d=new c.$W(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class l{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new w.$le,this.b=new w.$le,this.c=new w.$le,this.d=new w.$le,this.g=new w.$ne,this.h=new w.$ne,this.i=new w.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,a){return new R(this.j,d,r,this.a.event,A.GlobPattern.from(o),a)}$onFileEvent(d){this.a.fire(new v(d))}$onDidRunFileOperation(d,r){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,a,h)=>{const n=function(i){o.call(a,i)};return n.extension=d,r.event(n,void 0,h)}}async $onWillRunFileOperation(d,r,o,a){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},o,a);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>P.URI.revive(h.target))},o,a);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>P.URI.revive(h.target))},o,a)}}async n(d,r,o,a){const h=new Set,n=[];if(await d.fireAsync(r,a,async(i,t)=>{const m=Date.now(),f=await Promise.resolve(i);f instanceof N.$aN&&(n.push([t.extension,f]),h.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-m>o&&this.k.warn("SLOW file-participant",t.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const s={edits:[]};for(const[,i]of n){const{edits:t}=A.WorkspaceEdit.from(i,{getTextDocumentVersion:m=>this.l.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(t)}return{edit:s,extensionNames:Array.from(h)}}}e.$xoc=l}),define(Ce[285],Ie([1,0,18,11,22,14,97,5,26,70,13,15,2,33,327,94,104,182,19,10,7,25,80,6]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0,r=qe(r),n=qe(n),m=qe(m);class f{constructor(z,U){this.d=z,this.e=U}async provideDocumentSymbols(z,U){const K=this.d.getDocument(z),J=await this.e.provideDocumentSymbols(K,U);if(!(0,w.$Lb)(J))return J[0]instanceof s.$kN?J.map(n.DocumentSymbol.from):f.f(J)}static f(z){z=z.slice(0).sort((J,ne)=>{let fe=J.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(J.location.range.end)),fe});const U=[],K=[];for(const J of z){const ne={name:J.name||"!!MISSING: name!!",kind:n.SymbolKind.from(J.kind),tags:J.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:n.Range.from(J.location.range),selectionRange:n.Range.from(J.location.range),children:[]};for(;;){if(K.length===0){K.push(ne),U.push(ne);break}const fe=K[K.length-1];if(E.$Ht.containsRange(fe.range,ne.range)&&!E.$Ht.equalsRange(fe.range,ne.range)){fe.children?.push(ne),K.push(ne);break}K.pop()}}return U}}class u{constructor(z,U,K,J,ne,fe){this.f=z,this.g=U,this.h=K,this.j=J,this.k=ne,this.l=fe,this.d=new t.$$mc("CodeLens"),this.e=new Map}async provideCodeLenses(z,U){const K=this.f.getDocument(z),J=await this.h.provideCodeLenses(K,U);if(!J||U.isCancellationRequested)return;const ne=this.d.add(J),fe=new N.$Uc;this.e.set(ne,fe);const Ae={cacheId:ne,lenses:[]};for(let ze=0;ze<J.length;ze++)Ae.lenses.push({cacheId:[ne,ze],range:n.Range.from(J[ze].range),command:this.g.toInternal(J[ze].command,fe)});return Ae}async resolveCodeLens(z,U){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let J;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?J=K:J=await this.h.resolveCodeLens(K,U),J||(J=K),U.isCancellationRequested)return;const ne=z.cacheId&&this.e.get(z.cacheId[0]);if(ne){if(!J.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return z.command=this.g.toInternal(J.command,ne),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function $(Me){return Array.isArray(Me)?Me.map(n.DefinitionLink.from):Me?[n.DefinitionLink.from(Me)]:[]}class I{constructor(z,U){this.d=z,this.e=U}async provideDefinition(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideDefinition(J,ne,K);return $(fe)}}class D{constructor(z,U){this.d=z,this.e=U}async provideDeclaration(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideDeclaration(J,ne,K);return $(fe)}}class y{constructor(z,U){this.d=z,this.e=U}async provideImplementation(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideImplementation(J,ne,K);return $(fe)}}class S{constructor(z,U){this.d=z,this.e=U}async provideTypeDefinition(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideTypeDefinition(J,ne,K);return $(fe)}}class k{static{this.f=10}constructor(z,U){this.g=z,this.h=U,this.d=0,this.e=new Map}async provideHover(z,U,K,J){const ne=this.g.getDocument(z),fe=n.Position.to(U);let Ae;if(K&&K.verbosityRequest){const it=K.verbosityRequest.previousHover.id,nt=this.e.get(it);if(!nt)throw new Error(`Hover with id ${it} not found`);const tt={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Ae=await this.h.provideHover(ne,fe,J,tt)}else Ae=await this.h.provideHover(ne,fe,J);if(!Ae||(0,w.$Lb)(Ae.contents))return;Ae.range||(Ae.range=ne.getWordRangeAtPosition(fe)),Ae.range||(Ae.range=new s.$5M(fe,fe));const ze=n.Hover.from(Ae),Ke=this.d;if(this.e.size===k.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(Ke,Ae),this.d+=1,{...ze,id:Ke}}releaseHover(z){this.e.delete(z)}}class g{constructor(z,U){this.d=z,this.e=U}async provideEvaluatableExpression(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideEvaluatableExpression(J,ne,K);if(fe)return n.EvaluatableExpression.from(fe)}}class b{constructor(z,U){this.d=z,this.e=U}async provideInlineValues(z,U,K,J){const ne=this.d.getDocument(z),fe=await this.e.provideInlineValues(ne,n.Range.to(U),n.InlineValueContext.to(K),J);if(Array.isArray(fe))return fe.map(Ae=>n.InlineValue.from(Ae))}}class F{constructor(z,U){this.d=z,this.e=U}async provideDocumentHighlights(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideDocumentHighlights(J,ne,K);if(Array.isArray(fe))return fe.map(n.DocumentHighlight.from)}}class T{constructor(z,U){this.d=z,this.e=U}async provideMultiDocumentHighlights(z,U,K,J){const ne=this.d.getDocument(z),fe=K.map(Ke=>this.d.getDocument(Ke)),Ae=n.Position.to(U),ze=await this.e.provideMultiDocumentHighlights(ne,Ae,fe,J);if(Array.isArray(ze))return ze.map(n.MultiDocumentHighlight.from)}}class q{constructor(z,U){this.d=z,this.e=U}async provideLinkedEditingRanges(z,U,K){const J=this.d.getDocument(z),ne=n.Position.to(U),fe=await this.e.provideLinkedEditingRanges(J,ne,K);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,w.$Ib)(fe.ranges.map(n.Range.from)),wordPattern:fe.wordPattern}}}class G{constructor(z,U){this.d=z,this.e=U}async provideReferences(z,U,K,J){const ne=this.d.getDocument(z),fe=n.Position.to(U),Ae=await this.e.provideReferences(ne,fe,K,J);if(Array.isArray(Ae))return Ae.map(n.location.from)}}class V{static{this.d=1e3}constructor(z,U,K,J,ne,fe,Ae){this.g=z,this.h=U,this.j=K,this.k=J,this.l=ne,this.m=fe,this.n=Ae,this.e=new t.$$mc("CodeAction"),this.f=new Map}async provideCodeActions(z,U,K,J){const ne=this.g.getDocument(z),fe=d.$Jt.isISelection(U)?n.Selection.to(U):n.Range.to(U),Ae=[];for(const tt of this.j.getDiagnostics(z))if(fe.intersection(tt.range)&&Ae.push(tt)>V.d)break;const ze={diagnostics:Ae,only:K.only?new s.$mN(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ne,fe,ze,J);if(!(0,w.$Mb)(Ke)||J.isCancellationRequested)return;const _e=this.e.add(Ke),it=new N.$Uc;this.f.set(_e,it);const nt=[];for(let tt=0;tt<Ke.length;tt++){const rt=Ke[tt];if(rt)if(V.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,it)});else{ze.only&&(rt.kind?ze.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=rt.ranges??[];nt.push({cacheId:[_e,tt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,it),diagnostics:rt.diagnostics&&rt.diagnostics.map(n.Diagnostic.from),edit:rt.edit&&n.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,i.$3G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,i.$3G)(this.m,"codeActionRanges")?(0,w.$Ib)($t.map(n.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(z,U){const[K,J]=z,ne=this.e.get(K,J);if(!ne||V.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,U)??ne;let Ae;fe.edit&&(Ae=n.WorkspaceEdit.from(fe.edit,void 0));let ze;if(fe.command){const Ke=this.f.get(K);Ke&&(ze=this.h.toInternal(fe.command,Ke))}return{edit:Ae,command:ze}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class O{constructor(z,U,K,J,ne){this.e=z,this.f=U,this.g=K,this.h=J,this.j=ne,this.d=new t.$$mc("DocumentPasteEdit")}async prepareDocumentPaste(z,U,K,J){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(z),fe=U.map(Ke=>n.Range.to(Ke)),Ae=n.DataTransfer.toDataTransfer(K,()=>{throw new M.$_});if(await this.g.prepareDocumentPaste(ne,fe,Ae,J),J.isCancellationRequested)return;const ze=Array.from(Ae).filter(([,Ke])=>!(Ke instanceof s.$SN));return n.DataTransfer.from(ze)}async providePasteEdits(z,U,K,J,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(U),ze=K.map(nt=>n.Range.to(nt)),Ke=n.DataTransfer.toDataTransfer(J,async nt=>(await this.e.$resolvePasteFileData(this.h,z,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ae,ze,Ke,{only:ne.only?new s.$XN(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,U){const[K,J]=z,ne=this.d.get(K,J);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,U)??ne;return{additionalEdit:fe.additionalEdit?n.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class W{constructor(z,U){this.d=z,this.e=U}async provideDocumentFormattingEdits(z,U,K){const J=this.d.getDocument(z),ne=await this.e.provideDocumentFormattingEdits(J,U,K);if(Array.isArray(ne))return ne.map(n.TextEdit.from)}}class ce{constructor(z,U){this.d=z,this.e=U}async provideDocumentRangeFormattingEdits(z,U,K,J){const ne=this.d.getDocument(z),fe=n.Range.to(U),Ae=await this.e.provideDocumentRangeFormattingEdits(ne,fe,K,J);if(Array.isArray(Ae))return Ae.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,U,K,J){(0,v.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(z),fe=U.map(n.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ne,fe,K,J);if(Array.isArray(Ae))return Ae.map(n.TextEdit.from)}}class ge{constructor(z,U){this.d=z,this.e=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,U,K,J,ne){const fe=this.d.getDocument(z),Ae=n.Position.to(U),ze=await this.e.provideOnTypeFormattingEdits(fe,Ae,K,J,ne);if(Array.isArray(ze))return ze.map(n.TextEdit.from)}}class te{constructor(z,U){this.e=z,this.f=U,this.d=new t.$$mc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,U){const K=await this.e.provideWorkspaceSymbols(z,U);if(!(0,w.$Mb)(K))return{symbols:[]};const J=this.d.add(K),ne={cacheId:J,symbols:[]};for(let fe=0;fe<K.length;fe++){const Ae=K[fe];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ne.symbols.push({...n.WorkspaceSymbol.from(Ae),cacheId:[J,fe]})}return ne}async resolveWorkspaceSymbol(z,U){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const J=await this.e.resolveWorkspaceSymbol(K,U);return J&&(0,p.$eo)(z,n.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class me{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,U,K){this.d=z,this.e=U,this.f=K}async provideRenameEdits(z,U,K,J){const ne=this.d.getDocument(z),fe=n.Position.to(U);try{const Ae=await this.e.provideRenameEdits(ne,fe,K,J);return Ae?n.WorkspaceEdit.from(Ae):void 0}catch(Ae){const ze=me.g(Ae);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(z,U,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(z),ne=n.Position.to(U);try{const fe=await this.e.prepareRename(J,ne,K);let Ae,ze;if(s.$5M.isRange(fe)?(Ae=fe,ze=J.getText(fe)):(0,v.$gg)(fe)&&(Ae=fe.range,ze=fe.placeholder),!Ae||!ze)return;if(Ae.start.line>ne.line||Ae.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ae),text:ze}}catch(fe){const Ae=me.g(fe);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(fe)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class se{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(z,U,K){this.e=z,this.f=U,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,U,K,J){const ne=this.e.getDocument(z),fe=n.Range.to(U);try{const Ae=se.d[K],ze=await this.f.provideNewSymbolNames(ne,fe,Ae,J);return ze?ze.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ae){this.g.error(se.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class de{constructor(z,U){this.resultId=z,this.tokens=U}}class be{constructor(z,U){this.f=z,this.g=U,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,U,K){const J=this.f.getDocument(z),ne=U!==0?this.d.get(U):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,ne.resultId,K):await this.g.provideDocumentSemanticTokens(J,K);return ne&&this.d.delete(U),fe?(fe=be.h(fe),this.o(be.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return be.j(z)?be.k(z)?z:new s.$lO(new Uint32Array(z.data),z.resultId):be.l(z)?be.m(z)?z:new s.$nO(z.edits.map(U=>new s.$mO(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const U of z.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static n(z,U){if(!be.j(U)||!z||!z.tokens)return U;const K=z.tokens,J=K.length,ne=U.data,fe=ne.length;let Ae=0;const ze=Math.min(J,fe);for(;Ae<ze&&K[Ae]===ne[Ae];)Ae++;if(Ae===J&&Ae===fe)return new s.$nO([],U.resultId);let Ke=0;const _e=ze-Ae;for(;Ke<_e&&K[J-Ke-1]===ne[fe-Ke-1];)Ke++;return new s.$nO([{start:Ae,deleteCount:J-Ae-Ke,data:ne.subarray(Ae,fe-Ke)}],U.resultId)}o(z,U){if(be.j(z)){const K=this.e++;return this.d.set(K,new de(z.resultId,z.data)),(0,o.$Gcb)({id:K,type:"full",data:z.data})}if(be.l(z)){const K=this.e++;return be.j(U)?this.d.set(K,new de(U.resultId,U.data)):this.d.set(K,new de(z.resultId)),(0,o.$Gcb)({id:K,type:"delta",deltas:(z.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class re{constructor(z,U){this.d=z,this.e=U}async provideDocumentRangeSemanticTokens(z,U,K){const J=this.d.getDocument(z),ne=await this.e.provideDocumentRangeSemanticTokens(J,n.Range.to(U),K);return ne?this.f(ne):null}f(z){return(0,o.$Gcb)({id:0,type:"full",data:z.data})}}class Pe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,U,K,J,ne){this.f=z,this.g=U,this.h=K,this.j=J,this.k=ne,this.d=new t.$$mc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,U,K,J){const ne=this.f.getDocument(z),fe=n.Position.to(U),Ae=ne.getWordRangeAtPosition(fe)||new s.$5M(fe,fe),ze=Ae.with({end:fe}),Ke=new c.$fe,_e=await this.h.provideCompletionItems(ne,fe,J,n.CompletionContext.to(K));if(!_e||J.isCancellationRequested)return;const it=Array.isArray(_e)?new s.$zN(_e):_e,nt=Pe.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),tt=new N.$Uc;this.e.set(nt,tt);const rt=[],$t={x:nt,[m.ISuggestResultDtoField.completions]:rt,[m.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ae),insert:n.Range.from(ze)},[m.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[m.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ut=0;ut<it.items.length;ut++){const st=it.items[ut],ct=this.l(st,[nt,ut],ze,Ae);rt.push(ct)}return $t}async resolveCompletionItem(z,U){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const J=this.l(K,z),ne=await this.h.resolveCompletionItem(K,U);if(!ne)return;const fe=this.l(ne,z);return(J[m.ISuggestDataDtoField.insertText]!==fe[m.ISuggestDataDtoField.insertText]||J[m.ISuggestDataDtoField.insertTextRules]!==fe[m.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[m.ISuggestDataDtoField.commandIdent]!==fe[m.ISuggestDataDtoField.commandIdent]||J[m.ISuggestDataDtoField.commandId]!==fe[m.ISuggestDataDtoField.commandId]||!(0,p.$fo)(J[m.ISuggestDataDtoField.commandArguments],fe[m.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[m.ISuggestDataDtoField.documentation]:fe[m.ISuggestDataDtoField.documentation],[m.ISuggestDataDtoField.detail]:fe[m.ISuggestDataDtoField.detail],[m.ISuggestDataDtoField.additionalTextEdits]:fe[m.ISuggestDataDtoField.additionalTextEdits],[m.ISuggestDataDtoField.insertText]:fe[m.ISuggestDataDtoField.insertText],[m.ISuggestDataDtoField.insertTextRules]:fe[m.ISuggestDataDtoField.insertTextRules],[m.ISuggestDataDtoField.commandIdent]:fe[m.ISuggestDataDtoField.commandIdent],[m.ISuggestDataDtoField.commandId]:fe[m.ISuggestDataDtoField.commandId],[m.ISuggestDataDtoField.commandArguments]:fe[m.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,U,K,J){const ne=this.e.get(U[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(z.command,ne),Ae={x:U,[m.ISuggestDataDtoField.label]:z.label,[m.ISuggestDataDtoField.kind]:z.kind!==void 0?n.CompletionItemKind.from(z.kind):void 0,[m.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(n.CompletionItemTag.from),[m.ISuggestDataDtoField.detail]:z.detail,[m.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:n.MarkdownString.fromStrict(z.documentation),[m.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[m.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[m.ISuggestDataDtoField.preselect]:z.preselect||void 0,[m.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[m.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[m.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(n.TextEdit.from),[m.ISuggestDataDtoField.commandIdent]:fe?.$ident,[m.ISuggestDataDtoField.commandId]:fe?.id,[m.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[m.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Ae[m.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof s.$bN&&(Ae[m.ISuggestDataDtoField.insertText]=z.insertText.value,Ae[m.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return z.textEdit?ze=z.textEdit.range:z.range&&(ze=z.range),s.$5M.isRange(ze)?Ae[m.ISuggestDataDtoField.range]=n.Range.from(ze):ze&&(!K?.isEqual(ze.inserting)||!J?.isEqual(ze.replacing))&&(Ae[m.ISuggestDataDtoField.range]={insert:n.Range.from(ze.inserting),replace:n.Range.from(ze.replacing)}),Ae}}class Fe{async provideInlineCompletions(z,U,K,J){}disposeCompletions(z){}handleDidShowCompletionItem(z,U,K){}handlePartialAccept(z,U,K,J){}}class X extends Fe{constructor(z,U,K,J){super(),this.f=z,this.g=U,this.h=K,this.j=J,this.d=new _,this.e=(0,i.$3G)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$3G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,U,K,J){const ne=this.g.getDocument(z),fe=n.Position.to(U),Ae=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},J);if(!Ae||J.isCancellationRequested)return;const ze=Array.isArray(Ae)?Ae:Ae.items,Ke=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],_e=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:ze}),items:ze.map((tt,rt)=>{let $t;tt.command&&(it||(it=new N.$Uc),$t=this.j.toInternal(tt.command,it));const ut=tt.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:$t,idx:rt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ke.map(tt=>(it||(it=new N.$Uc),this.j.toInternal(tt,it))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,U,K){const J=this.d.get(z)?.items[U];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,K)}handlePartialAccept(z,U,K,J){const ne=this.d.get(z)?.items[U];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,K),this.h.handleDidPartiallyAcceptCompletionItem(ne,n.PartialAcceptInfo.to(J)))}}class B{async provideInlineEdits(z,U,K){const J=this.f.getDocument(z),ne=await this.g.provideInlineEdit(J,{triggerKind:this.e[U.triggerKind]},K);if(!ne||K.isCancellationRequested)return;let fe;const Ae=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let ze;ne.accepted&&(fe||(fe=new N.$Uc),ze=this.h.toInternal(ne.accepted,fe));let Ke;return ne.rejected&&(fe||(fe=new N.$Uc),Ke=this.h.toInternal(ne.rejected,fe)),{pid:Ae,text:ne.text,range:n.Range.from(ne.range),accepted:ze,rejected:Ke}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,U,K,J){this.f=U,this.g=K,this.h=J,this.d=new _,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const U=this.e++;return this.d.set(U,z),U}disposeReferenceId(z){const U=this.d.get(z);return this.d.delete(z),U}get(z){return this.d.get(z)}}class we{constructor(z,U){this.e=z,this.f=U,this.d=new t.$$mc("SignatureHelp")}async provideSignatureHelp(z,U,K,J){const ne=this.e.getDocument(z),fe=n.Position.to(U),Ae=this.g(K),ze=await this.f.provideSignatureHelp(ne,fe,J,Ae);if(ze){const Ke=this.d.add([ze]);return{...n.SignatureHelp.from(ze),id:Ke}}}g(z){let U;if(z.activeSignatureHelp){const K=n.SignatureHelp.to(z.activeSignatureHelp),J=this.d.get(z.activeSignatureHelp.id,0);J?(U=J,U.activeSignature=K.activeSignature,U.activeParameter=K.activeParameter):U=K}return{...z,activeSignatureHelp:U}}releaseSignatureHelp(z){this.d.delete(z)}}class ae{constructor(z,U,K,J,ne){this.f=z,this.g=U,this.h=K,this.j=J,this.k=ne,this.d=new t.$$mc("InlayHints"),this.e=new Map}async provideInlayHints(z,U,K){const J=this.f.getDocument(z),ne=n.Range.to(U),fe=await this.h.provideInlayHints(J,ne,K);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(fe);this.e.set(Ae,new N.$Uc);const ze={hints:[],cacheId:Ae};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ne)&&ze.hints.push(this.m(fe[Ke],[Ae,Ke]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(U)}`),ze}async resolveInlayHint(z,U){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const J=await this.h.resolveInlayHint(K,U);if(J&&this.l(J))return this.m(J,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,U){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(U&&!U.contains(z.position))}m(z,U){const K=this.e.get(U[0]);if(!K)throw Error("DisposableStore is missing...");const J={label:"",cacheId:U,tooltip:n.MarkdownString.fromStrict(z.tooltip),position:n.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(n.TextEdit.from),kind:z.kind&&n.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")J.label=z.label;else{const ne=[];J.label=ne;for(const fe of z.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:fe.value,tooltip:n.MarkdownString.fromStrict(fe.tooltip)};s.$cN.isLocation(fe.location)&&(Ae.location=n.location.from(fe.location)),fe.command&&(Ae.command=this.g.toInternal(fe.command,K)),ne.push(Ae)}}return J}}class ve{constructor(z,U){this.e=z,this.f=U,this.d=new t.$$mc("DocumentLink")}async provideLinks(z,U){const K=this.e.getDocument(z),J=await this.f.provideDocumentLinks(K,U);if(!(!Array.isArray(J)||J.length===0)&&!U.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ve.g).map(n.DocumentLink.from)};{const ne=this.d.add(J),fe={links:[],cacheId:ne};for(let Ae=0;Ae<J.length;Ae++){if(!ve.g(J[Ae]))continue;const ze=n.DocumentLink.from(J[Ae]);ze.cacheId=[ne,Ae],fe.links.push(ze)}return fe}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,U){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const J=await this.f.resolveDocumentLink(K,U);if(!(!J||!ve.g(J)))return n.DocumentLink.from(J)}releaseLinks(z){this.d.delete(z)}}class ue{constructor(z,U){this.d=z,this.e=U}async provideColors(z,U){const K=this.d.getDocument(z),J=await this.e.provideDocumentColors(K,U);return Array.isArray(J)?J.map(fe=>({color:n.Color.from(fe.color),range:n.Range.from(fe.range)})):[]}async provideColorPresentations(z,U,K){const J=this.d.getDocument(z),ne=n.Range.to(U.range),fe=n.Color.to(U.color),Ae=await this.e.provideColorPresentations(fe,{document:J,range:ne},K);if(Array.isArray(Ae))return Ae.map(n.ColorPresentation.from)}}class Z{constructor(z,U){this.d=z,this.e=U}async provideFoldingRanges(z,U,K){const J=this.d.getDocument(z),ne=await this.e.provideFoldingRanges(J,U,K);if(Array.isArray(ne))return ne.map(n.FoldingRange.from)}}class Y{constructor(z,U,K){this.d=z,this.e=U,this.f=K}async provideSelectionRanges(z,U,K){const J=this.d.getDocument(z),ne=U.map(n.Position.to),fe=await this.e.provideSelectionRanges(J,ne,K);if(!(0,w.$Mb)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let ze=0;ze<ne.length;ze++){const Ke=[];Ae.push(Ke);let _e=ne[ze],it=fe[ze];for(;;){if(!it.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(it)),!it.parent)break;_e=it.range,it=it.parent}}return Ae}}class pe{constructor(z,U){this.f=z,this.g=U,this.d=new A.$zP(""),this.e=new Map}async prepareSession(z,U,K){const J=this.f.getDocument(z),ne=n.Position.to(U),fe=await this.g.prepareCallHierarchy(J,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(ze=>this.h(Ae,ze)):[this.h(Ae,fe)]}async provideCallsTo(z,U,K){const J=this.j(z,U);if(!J)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(J,K);if(ne)return ne.map(fe=>({from:this.h(z,fe.from),fromRanges:fe.fromRanges.map(Ae=>n.Range.from(Ae))}))}async provideCallsFrom(z,U,K){const J=this.j(z,U);if(!J)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(J,K);if(ne)return ne.map(fe=>({to:this.h(z,fe.to),fromRanges:fe.fromRanges.map(Ae=>n.Range.from(Ae))}))}releaseSession(z){this.e.delete(z)}h(z,U){const K=this.e.get(z),J=n.CallHierarchyItem.from(U,z,K.size.toString(36));return K.set(J._itemId,U),J}j(z,U){return this.e.get(z)?.get(U)}}class $e{constructor(z,U){this.f=z,this.g=U,this.d=new A.$zP(""),this.e=new Map}async prepareSession(z,U,K){const J=this.f.getDocument(z),ne=n.Position.to(U),fe=await this.g.prepareTypeHierarchy(J,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(ze=>this.h(Ae,ze)):[this.h(Ae,fe)]}async provideSupertypes(z,U,K){const J=this.j(z,U);if(!J)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(J,K);if(ne)return ne.map(fe=>this.h(z,fe))}async provideSubtypes(z,U,K){const J=this.j(z,U);if(!J)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(J,K);if(ne)return ne.map(fe=>this.h(z,fe))}releaseSession(z){this.e.delete(z)}h(z,U){const K=this.e.get(z),J=n.TypeHierarchyItem.from(U,z,K.size.toString(36));return K.set(J._itemId,U),J}j(z,U){return this.e.get(z)?.get(U)}}class Ne{constructor(z,U,K,J,ne){this.e=z,this.f=U,this.g=K,this.h=J,this.j=ne,this.d=new t.$$mc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,U,K,J,ne){const fe=this.f.getDocument(U),Ae=n.Position.to(K),ze=n.DataTransfer.toDataTransfer(J,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Ae,ze,ne);if(!Ke)return;const _e=(0,w.$3b)(Ke),it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,U){const[K,J]=z,ne=this.d.get(K,J);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,U)??ne;return{additionalEdit:fe.additionalEdit?n.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class Ue{constructor(z,U){this.d=z,this.e=U}async provideMappedEdits(z,U,K,J){const ne=l.URI.revive(z),fe=this.d.getDocument(ne),Ae=K.documents.map(_e=>_e.map(it=>({uri:l.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(nt=>n.Range.to(nt))}))),ze={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,U,ze,J);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(z,U){this.adapter=z,this.extension=U}}class Re{static{this.d=0}constructor(z,U,K,J,ne,fe,Ae,ze){this.g=U,this.h=K,this.j=J,this.k=ne,this.l=fe,this.m=Ae,this.n=ze,this.f=new Map,this.e=z.getProxy(m.$1M.MainThreadLanguageFeatures)}o(z,U){return n.DocumentSelector.from(z,this.g,U)}p(z){return new s.$3M(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Re.d++}async s(z,U,K,J,ne,fe=!1){const Ae=this.f.get(z);if(!Ae||!(Ae.adapter instanceof U))return J;const ze=Date.now();fe||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Ae.adapter,Ae.extension);return Promise.resolve(Ke).catch(_e=>{(0,M.$5)(_e)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ae.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(ne)?(0,C.$th)(Ke,ne):Ke}t(z,U){const K=this.q();return this.f.set(K,new ke(z,U)),K}static u(z){return z.displayName||z.name}static w(z){return z.identifier.value}registerDocumentSymbolProvider(z,U,K,J){const ne=this.t(new f(this.h,K),z),fe=J&&J.label||Re.u(z);return this.e.$registerDocumentSymbolProvider(ne,this.o(U,z),fe),this.p(ne)}$provideDocumentSymbols(z,U,K){return this.s(z,f,J=>J.provideDocumentSymbols(l.URI.revive(U),K),void 0,K)}registerCodeLensProvider(z,U,K){const J=this.q(),ne=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ke(new u(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(J,this.o(U,z),ne);let fe=this.p(J);if(ne!==void 0){const Ae=K.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(ne));fe=s.$3M.from(fe,Ae)}return fe}$provideCodeLenses(z,U,K){return this.s(z,u,J=>J.provideCodeLenses(l.URI.revive(U),K),void 0,K)}$resolveCodeLens(z,U,K){return this.s(z,u,J=>J.resolveCodeLens(U,K),void 0,void 0)}$releaseCodeLenses(z,U){this.s(z,u,K=>Promise.resolve(K.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(z,U,K){const J=this.t(new I(this.h,K),z);return this.e.$registerDefinitionSupport(J,this.o(U,z)),this.p(J)}$provideDefinition(z,U,K,J){return this.s(z,I,ne=>ne.provideDefinition(l.URI.revive(U),K,J),[],J)}registerDeclarationProvider(z,U,K){const J=this.t(new D(this.h,K),z);return this.e.$registerDeclarationSupport(J,this.o(U,z)),this.p(J)}$provideDeclaration(z,U,K,J){return this.s(z,D,ne=>ne.provideDeclaration(l.URI.revive(U),K,J),[],J)}registerImplementationProvider(z,U,K){const J=this.t(new y(this.h,K),z);return this.e.$registerImplementationSupport(J,this.o(U,z)),this.p(J)}$provideImplementation(z,U,K,J){return this.s(z,y,ne=>ne.provideImplementation(l.URI.revive(U),K,J),[],J)}registerTypeDefinitionProvider(z,U,K){const J=this.t(new S(this.h,K),z);return this.e.$registerTypeDefinitionSupport(J,this.o(U,z)),this.p(J)}$provideTypeDefinition(z,U,K,J){return this.s(z,S,ne=>ne.provideTypeDefinition(l.URI.revive(U),K,J),[],J)}registerHoverProvider(z,U,K,J){const ne=this.t(new k(this.h,K),z);return this.e.$registerHoverProvider(ne,this.o(U,z)),this.p(ne)}$provideHover(z,U,K,J,ne){return this.s(z,k,fe=>fe.provideHover(l.URI.revive(U),K,J,ne),void 0,ne)}$releaseHover(z,U){this.s(z,k,K=>Promise.resolve(K.releaseHover(U)),void 0,void 0)}registerEvaluatableExpressionProvider(z,U,K,J){const ne=this.t(new g(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(U,z)),this.p(ne)}$provideEvaluatableExpression(z,U,K,J){return this.s(z,g,ne=>ne.provideEvaluatableExpression(l.URI.revive(U),K,J),void 0,J)}registerInlineValuesProvider(z,U,K,J){const ne=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new b(this.h,K),z);this.e.$registerInlineValuesProvider(fe,this.o(U,z),ne);let Ae=this.p(fe);if(ne!==void 0){const ze=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ne));Ae=s.$3M.from(Ae,ze)}return Ae}$provideInlineValues(z,U,K,J,ne){return this.s(z,b,fe=>fe.provideInlineValues(l.URI.revive(U),K,J,ne),void 0,ne)}registerDocumentHighlightProvider(z,U,K){const J=this.t(new F(this.h,K),z);return this.e.$registerDocumentHighlightProvider(J,this.o(U,z)),this.p(J)}registerMultiDocumentHighlightProvider(z,U,K){const J=this.t(new T(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(U,z)),this.p(J)}$provideDocumentHighlights(z,U,K,J){return this.s(z,F,ne=>ne.provideDocumentHighlights(l.URI.revive(U),K,J),void 0,J)}$provideMultiDocumentHighlights(z,U,K,J,ne){return this.s(z,T,fe=>fe.provideMultiDocumentHighlights(l.URI.revive(U),K,J.map(Ae=>l.URI.revive(Ae)),ne),void 0,ne)}registerLinkedEditingRangeProvider(z,U,K){const J=this.t(new q(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(J,this.o(U,z)),this.p(J)}$provideLinkedEditingRanges(z,U,K,J){return this.s(z,q,async ne=>{const fe=await ne.provideLinkedEditingRanges(l.URI.revive(U),K,J);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Re.y(fe.wordPattern):void 0}},void 0,J)}registerReferenceProvider(z,U,K){const J=this.t(new G(this.h,K),z);return this.e.$registerReferenceSupport(J,this.o(U,z)),this.p(J)}$provideReferences(z,U,K,J,ne){return this.s(z,G,fe=>fe.provideReferences(l.URI.revive(U),K,J,ne),void 0,ne)}registerCodeActionProvider(z,U,K,J){const ne=new N.$Uc,fe=this.t(new V(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerCodeActionSupport(fe,this.o(U,z),{providedKinds:J?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:J?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ne)}))},Re.u(z),Re.w(z),!!K.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(z,U,K,J,ne){return this.s(z,V,fe=>fe.provideCodeActions(l.URI.revive(U),K,J,ne),void 0,ne)}$resolveCodeAction(z,U,K){return this.s(z,V,J=>J.resolveCodeAction(U,K),{},void 0)}$releaseCodeActions(z,U){this.s(z,V,K=>Promise.resolve(K.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(z,U,K){const J=this.t(new W(this.h,K),z);return this.e.$registerDocumentFormattingSupport(J,this.o(U,z),z.identifier,z.displayName||z.name),this.p(J)}$provideDocumentFormattingEdits(z,U,K,J){return this.s(z,W,ne=>ne.provideDocumentFormattingEdits(l.URI.revive(U),K,J),void 0,J)}registerDocumentRangeFormattingEditProvider(z,U,K){const J=typeof K.provideDocumentRangesFormattingEdits=="function",ne=this.t(new ce(this.h,K),z);return this.e.$registerRangeFormattingSupport(ne,this.o(U,z),z.identifier,z.displayName||z.name,J),this.p(ne)}$provideDocumentRangeFormattingEdits(z,U,K,J,ne){return this.s(z,ce,fe=>fe.provideDocumentRangeFormattingEdits(l.URI.revive(U),K,J,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(z,U,K,J,ne){return this.s(z,ce,fe=>fe.provideDocumentRangesFormattingEdits(l.URI.revive(U),K,J,ne),void 0,ne)}registerOnTypeFormattingEditProvider(z,U,K,J){const ne=this.t(new ge(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(ne,this.o(U,z),J,z.identifier),this.p(ne)}$provideOnTypeFormattingEdits(z,U,K,J,ne,fe){return this.s(z,ge,Ae=>Ae.provideOnTypeFormattingEdits(l.URI.revive(U),K,J,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(z,U){const K=this.t(new te(U,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof U.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,U,K){return this.s(z,te,J=>J.provideWorkspaceSymbols(U,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,U,K){return this.s(z,te,J=>J.resolveWorkspaceSymbol(U,K),void 0,void 0)}$releaseWorkspaceSymbols(z,U){this.s(z,te,K=>K.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(z,U,K){const J=this.t(new me(this.h,K,this.l),z);return this.e.$registerRenameSupport(J,this.o(U,z),me.supportsResolving(K)),this.p(J)}$provideRenameEdits(z,U,K,J,ne){return this.s(z,me,fe=>fe.provideRenameEdits(l.URI.revive(U),K,J,ne),void 0,ne)}$resolveRenameLocation(z,U,K,J){return this.s(z,me,ne=>ne.resolveRenameLocation(l.URI.revive(U),K,J),void 0,J)}registerNewSymbolNamesProvider(z,U,K){const J=this.t(new se(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(J,this.o(U,z)),this.p(J)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this.s(z,se,U=>U.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,U,K,J,ne){return this.s(z,se,fe=>fe.provideNewSymbolNames(l.URI.revive(U),K,J,ne),void 0,ne)}registerDocumentSemanticTokensProvider(z,U,K,J){const ne=this.t(new be(this.h,K),z),fe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(U,z),J,fe);let Ae=this.p(ne);if(fe){const ze=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Ae=s.$3M.from(Ae,ze)}return Ae}$provideDocumentSemanticTokens(z,U,K,J){return this.s(z,be,ne=>ne.provideDocumentSemanticTokens(l.URI.revive(U),K,J),null,J)}$releaseDocumentSemanticTokens(z,U){this.s(z,be,K=>K.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,U,K,J){const ne=this.t(new re(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(U,z),J),this.p(ne)}$provideDocumentRangeSemanticTokens(z,U,K,J){return this.s(z,re,ne=>ne.provideDocumentRangeSemanticTokens(l.URI.revive(U),K,J),null,J)}registerCompletionItemProvider(z,U,K,J){const ne=this.t(new Pe(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(ne,this.o(U,z),J,Pe.supportsResolving(K),z.identifier),this.p(ne)}$provideCompletionItems(z,U,K,J,ne){return this.s(z,Pe,fe=>fe.provideCompletionItems(l.URI.revive(U),K,J,ne),void 0,ne)}$resolveCompletionItem(z,U,K){return this.s(z,Pe,J=>J.resolveCompletionItem(U,K),void 0,K)}$releaseCompletionItems(z,U){this.s(z,Pe,K=>K.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(z,U,K,J){const ne=new X(z,this.h,K,this.j.converter),fe=this.t(ne,z);return this.e.$registerInlineCompletionsSupport(fe,this.o(U,z),ne.supportsHandleEvents,h.$pn.toKey(z.identifier.value),J?.yieldTo?.map(Ae=>h.$pn.toKey(Ae))||[]),this.p(fe)}$provideInlineCompletions(z,U,K,J,ne){return this.s(z,Fe,fe=>fe.provideInlineCompletions(l.URI.revive(U),K,J,ne),void 0,ne)}$handleInlineCompletionDidShow(z,U,K,J){this.s(z,Fe,async ne=>{ne.handleDidShowCompletionItem(U,K,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,U,K,J,ne){this.s(z,Fe,async fe=>{fe.handlePartialAccept(U,K,J,ne)},void 0,void 0)}$freeInlineCompletionsList(z,U){this.s(z,Fe,async K=>{K.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(z,U,K){const J=new B(z,this.h,K,this.j.converter),ne=this.t(J,z);return this.e.$registerInlineEditProvider(ne,this.o(U,z),z.identifier),this.p(ne)}$provideInlineEdit(z,U,K,J){return this.s(z,B,ne=>ne.provideInlineEdits(l.URI.revive(U),K,J),void 0,J)}$freeInlineEdit(z,U){this.s(z,B,async K=>{K.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(z,U,K,J){const ne=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,fe=this.t(new we(this.h,K),z);return this.e.$registerSignatureHelpProvider(fe,this.o(U,z),ne),this.p(fe)}$provideSignatureHelp(z,U,K,J,ne){return this.s(z,we,fe=>fe.provideSignatureHelp(l.URI.revive(U),K,J,ne),void 0,ne)}$releaseSignatureHelp(z,U){this.s(z,we,K=>K.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(z,U,K){const J=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ae(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(ne,this.o(U,z),typeof K.resolveInlayHint=="function",J,Re.u(z));let fe=this.p(ne);if(J!==void 0){const Ae=K.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(J));fe=s.$3M.from(fe,Ae)}return fe}$provideInlayHints(z,U,K,J){return this.s(z,ae,ne=>ne.provideInlayHints(l.URI.revive(U),K,J),void 0,J)}$resolveInlayHint(z,U,K){return this.s(z,ae,J=>J.resolveInlayHint(U,K),void 0,K)}$releaseInlayHints(z,U){this.s(z,ae,K=>K.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(z,U,K){const J=this.t(new ve(this.h,K),z);return this.e.$registerDocumentLinkProvider(J,this.o(U,z),typeof K.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(z,U,K){return this.s(z,ve,J=>J.provideLinks(l.URI.revive(U),K),void 0,K,U.scheme==="output")}$resolveDocumentLink(z,U,K){return this.s(z,ve,J=>J.resolveLink(U,K),void 0,void 0,!0)}$releaseDocumentLinks(z,U){this.s(z,ve,K=>K.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(z,U,K){const J=this.t(new ue(this.h,K),z);return this.e.$registerDocumentColorProvider(J,this.o(U,z)),this.p(J)}$provideDocumentColors(z,U,K){return this.s(z,ue,J=>J.provideColors(l.URI.revive(U),K),[],K)}$provideColorPresentations(z,U,K,J){return this.s(z,ue,ne=>ne.provideColorPresentations(l.URI.revive(U),K,J),void 0,J)}registerFoldingRangeProvider(z,U,K){const J=this.q(),ne=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ke(new Z(this.h,K),z)),this.e.$registerFoldingRangeProvider(J,this.o(U,z),z.identifier,ne);let fe=this.p(J);if(ne!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=s.$3M.from(fe,Ae)}return fe}$provideFoldingRanges(z,U,K,J){return this.s(z,Z,ne=>ne.provideFoldingRanges(l.URI.revive(U),K,J),void 0,J)}registerSelectionRangeProvider(z,U,K){const J=this.t(new Y(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(J,this.o(U,z)),this.p(J)}$provideSelectionRanges(z,U,K,J){return this.s(z,Y,ne=>ne.provideSelectionRanges(l.URI.revive(U),K,J),[],J)}registerCallHierarchyProvider(z,U,K){const J=this.t(new pe(this.h,K),z);return this.e.$registerCallHierarchyProvider(J,this.o(U,z)),this.p(J)}$prepareCallHierarchy(z,U,K,J){return this.s(z,pe,ne=>Promise.resolve(ne.prepareSession(l.URI.revive(U),K,J)),void 0,J)}$provideCallHierarchyIncomingCalls(z,U,K,J){return this.s(z,pe,ne=>ne.provideCallsTo(U,K,J),void 0,J)}$provideCallHierarchyOutgoingCalls(z,U,K,J){return this.s(z,pe,ne=>ne.provideCallsFrom(U,K,J),void 0,J)}$releaseCallHierarchy(z,U){this.s(z,pe,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(z,U,K){const J=this.t(new $e(this.h,K),z);return this.e.$registerTypeHierarchyProvider(J,this.o(U,z)),this.p(J)}$prepareTypeHierarchy(z,U,K,J){return this.s(z,$e,ne=>Promise.resolve(ne.prepareSession(l.URI.revive(U),K,J)),void 0,J)}$provideTypeHierarchySupertypes(z,U,K,J){return this.s(z,$e,ne=>ne.provideSupertypes(U,K,J),void 0,J)}$provideTypeHierarchySubtypes(z,U,K,J){return this.s(z,$e,ne=>ne.provideSubtypes(U,K,J),void 0,J)}$releaseTypeHierarchy(z,U){this.s(z,$e,K=>Promise.resolve(K.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(z,U,K,J){const ne=this.q();return this.f.set(ne,new ke(new Ne(this.e,this.h,K,ne,z),z)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(U,z),(0,i.$3G)(z,"documentPaste")&&J?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(z,U,K,J,ne,fe){return this.s(z,Ne,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(U,l.URI.revive(K),J,ne,fe)),void 0,void 0)}$resolveDropEdit(z,U,K){return this.s(z,Ne,J=>J.resolveDropEdit(U,K),{},void 0)}$releaseDropEdits(z,U){this.s(z,Ne,K=>Promise.resolve(K.releaseDropEdits(U)),void 0,void 0)}registerMappedEditsProvider(z,U,K){const J=this.t(new Ue(this.h,K),z);return this.e.$registerMappedEditsProvider(J,this.o(U,z)),this.p(J)}$provideMappedEdits(z,U,K,J,ne){return this.s(z,Ue,fe=>Promise.resolve(fe.provideMappedEdits(U,K,J,ne)),null,ne)}registerDocumentPasteEditProvider(z,U,K,J){const ne=this.q();return this.f.set(ne,new ke(new O(this.e,this.h,K,ne,z),z)),this.e.$registerPasteEditProvider(ne,this.o(U,z),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(z,U,K,J,ne){return this.s(z,O,fe=>fe.prepareDocumentPaste(l.URI.revive(U),K,J,ne),void 0,ne)}$providePasteEdits(z,U,K,J,ne,fe,Ae){return this.s(z,O,ze=>ze.providePasteEdits(U,l.URI.revive(K),J,ne,fe,Ae),void 0,Ae)}$resolvePasteEdit(z,U,K){return this.s(z,O,J=>J.resolvePasteEdit(U,K),{},void 0)}$releasePasteEdits(z,U){this.s(z,O,K=>Promise.resolve(K.releasePasteEdits(U)),void 0,void 0)}static y(z){return{pattern:z.source,flags:z.flags}}static z(z){return{decreaseIndentPattern:Re.y(z.decreaseIndentPattern),increaseIndentPattern:Re.y(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Re.y(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Re.y(z.unIndentedLinePattern):void 0}}static B(z){return{beforeText:Re.y(z.beforeText),afterText:z.afterText?Re.y(z.afterText):void 0,previousLineText:z.previousLineText?Re.y(z.previousLineText):void 0,action:z.action}}static C(z){return z.map(Re.B)}static D(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(U=>s.SyntaxTokenType.toString(U)):void 0}}static E(z){return z.map(Re.D)}setLanguageConfiguration(z,U,K){const{wordPattern:J}=K;if(J&&(0,R.$rf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(U,J):this.h.setWordDefinitionFor(U,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ne=this.q(),fe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,U,fe),this.p(ne)}$setWordDefinitions(z){for(const U of z)this.h.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.$inc=Re}),define(Ce[95],Ie([1,0,11,22,14,4,40,5,183,19,3,12,77,6,91,17,10,7,116,25]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0,o=qe(o),a=qe(a),e.$2nc=(0,R.$Ei)("IExtHostLanguageModels");class i{constructor(u,$){this.option=u,this.stream=new w.$8h,this.stream=$??new w.$8h}}class t{constructor(){this.a=new Map,this.b=new w.$8h,this.c=!1,this.d=!1;const u=this;this.apiObject={stream:u.b.asyncIterable,text:w.$5h.map(u.b.asyncIterable,$=>{if($ instanceof a.$eP)return $.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,u]of this.a)yield u.stream;else yield this.b}handleFragment(u){if(this.c)return;this.d=!0;let $=this.a.get(u.index);$||(this.a.size===0?$=new i(u.index,this.b):$=new i(u.index),this.a.set(u.index,$));let I;u.part.type==="text"?I=new a.$eP(u.part.value):I=new a.$dP(u.part.name,u.part.parameters),$.stream.emitOne(I)}get isStreaming(){return this.d}reject(u){this.c=!0;for(const $ of this.f())$.reject(u)}resolve(){this.c=!0;for(const u of this.f())u.resolve()}}let m=class{static{s=this}static{this.a=1}constructor(u,$,I){this.j=$,this.k=I,this.c=new M.$le,this.d=new M.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$rn,this.i=new Map,this.r=new Set,this.b=u.getProxy(E.$1M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(u,$,I,D){const y=s.a++;this.f.set(y,{extension:u.identifier,provider:I,languageModelId:$});let S;D.auth&&(S={providerLabel:u.displayName||u.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${c.$pn.toKey(u.identifier)}/${y}/${$}`,{extension:u.identifier,id:$,vendor:D.vendor??c.$pn.toKey(u.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:S,targetExtensions:D.extensions});const k=I.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:b,tokenCount:F})=>{this.b.$whenLanguageModelChatRequestMade($,new c.$pn(g),b,F)});return(0,N.$Tc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),k?.dispose()})}async $provideLanguageModelResponse(u,$,I,D,y,S){const k=this.f.get(u);if(!k)return;const g=new l.$rw(async b=>{if(S.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(b.part instanceof a.$dP?F={type:"function_use",name:b.part.name,parameters:b.part.parameters}:b.part instanceof a.$eP&&(F={type:"text",value:b.part.value}),!F){this.j.warn(`[CHAT](${k.extension.value}) UNKNOWN part ${JSON.stringify(b)}`);return}this.b.$handleProgressChunk($,{index:b.index,part:F})});if(k.provider.provideLanguageModelResponse2)return k.provider.provideLanguageModelResponse2(D.map(o.LanguageModelChatMessage.to),y,c.$pn.toKey(I),g,S);{const b=new l.$rw(async F=>{g.report({index:F.index,part:new a.$eP(F.part)})});return k.provider.provideLanguageModelResponse(D.map(o.LanguageModelChatMessage.to),y?.modelOptions??{},c.$pn.toKey(I),b,S)}}$provideTokenLength(u,$,I){const D=this.f.get(u);return D?Promise.resolve(D.provider.provideTokenCount($,I)):Promise.resolve(0)}$acceptChatModelMetadata(u){if(u.added)for(const{identifier:$,metadata:I}of u.added)this.g.set($,{metadata:I,apiObjects:new c.$rn});if(u.removed)for(const $ of u.removed){this.g.delete($);for(const[I,D]of this.i)D.languageModelId===$&&(D.res.reject(new P.$6),this.i.delete(I))}u.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(u,$){const I=await this.b.$selectChatModels({...$,extension:u.identifier}),D=[],y=this;for(const S of I){const k=this.g.get(S);if(!k)continue;this.o(u.identifier,k.metadata)&&await this.p(k.metadata);let g=k.apiObjects.get(u.identifier);g||(g={id:S,vendor:k.metadata.vendor,family:k.metadata.family,version:k.metadata.version,name:k.metadata.name,maxInputTokens:k.metadata.maxInputTokens,countTokens(b,F){if(!y.g.has(S))throw a.$iP.NotFound(S);return y.q(S,b,F??C.CancellationToken.None)},sendRequest(b,F,T){if(!y.g.has(S))throw a.$iP.NotFound(S);return y.l(u,S,b,F??{},T??C.CancellationToken.None)}},Object.freeze(g),k.apiObjects.set(u.identifier,g)),D.push(g)}return D}async l(u,$,I,D,y){const S=this.m(u,I),k=u.identifier,g=this.g.get($)?.metadata;if(!g||!this.g.has($))throw a.$iP.NotFound(`Language model '${$}' is unknown.`);if(this.o(k,g)&&(!await this.n(u,{identifier:g.extension,displayName:g.auth.providerLabel},D.justification,!1)||!this.h.get(k)?.has(g.extension)))throw a.$iP.NoPermissions(`Language model '${$}' cannot be used by '${k.value}'.`);const b=Math.random()*1e6|0,F=this.b.$fetchResponse(k,$,b,S,D,y),T=new w.$Dh,q=new t;this.i.set(b,{languageModelId:$,res:q});let G;if(F.catch(V=>{T.isOpen()?q.reject(V):G=V}).finally(()=>{this.i.delete(b),q.resolve(),T.open()}),await T.wait(),G)throw G.name===a.$iP.name?G:new a.$iP(`Language model '${$}' errored, check cause for more details`,"Unknown",G);return q.apiObject}m(u,$){const I=[];for(const D of $)D.role===a.LanguageModelChatMessageRole.System&&(0,n.$4G)(u,"languageModelSystem"),D.content2 instanceof a.$bP&&(0,n.$4G)(u,"lmTools"),I.push(o.LanguageModelChatMessage.from(D));return I}async $handleResponseFragment(u,$){const I=this.i.get(u);I&&I.res.handleFragment($)}async n(u,$,I,D){const y=h.$3L+$.identifier.value;if(await this.k.getSession(u,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:u.identifier,to:$.identifier,enabled:!0}]),!0;if(D)return!1;try{const k=I?(0,p.localize)(0,null,$.displayName,I):void 0;return await this.k.getSession(u,y,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:u.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(u,$){return!!$.auth&&!c.$pn.equals($.extension,u)}async p(u){if(u.auth)for(const $ of this.r)try{await this.n($,{identifier:u.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(u,$,I){if(!this.g.get(u))throw a.$iP.NotFound(`Language model '${u}' is unknown.`);const y=A.Iterable.find(this.f.values(),S=>S.languageModelId===u);return y?y.provider.provideTokenCount($,I):this.b.$countTokens(u,typeof $=="string"?$:o.LanguageModelChatMessage.from($),I)}$updateModelAccesslist(u){const $=new Array;for(const{from:I,to:D,enabled:y}of u){const S=this.h.get(I)??new c.$qn;if(S.has(D)!==y){y?S.add(D):S.delete(D),this.h.set(I,S);const g={from:I,to:D};$.push(g),this.c.fire(g)}}}createLanguageModelAccessInformation(u){this.r.add(u);const $=this,I=M.Event.signal(M.Event.filter(this.c.event,y=>c.$pn.equals(y.from,u.identifier))),D=M.Event.signal(this.d.event);return{get onDidChange(){return M.Event.any(I,D)},canSendRequest(y){let S;e:for(const[g,b]of $.g)for(const F of b.apiObjects.values())if(F===y){S=b.metadata;break e}if(!S)return;if(!$.o(u.identifier,S))return!0;const k=$.h.get(u.identifier);if(k)return k.has(S.extension)}}}};e.$3nc=m,e.$3nc=m=s=He([We(0,r.$uP),We(1,v.$$j),We(2,d.$knc)],m)});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[286],Ie([1,0,6,10,7,36,11,5,25]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0,C=qe(C),M=ri(M);class c{constructor(v,l,E,d){this.c=l,this.d=E,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=v.getProxy(w.$1M.MainThreadLanguages)}$acceptLanguageIds(v){this.b=v}async getLanguages(){return this.b.slice(0)}async changeLanguage(v,l){await this.a.$changeLanguage(v,l);const E=this.c.getDocumentData(v);if(!E)throw new Error(`document '${v.toString()}' NOT found`);return E.document}async tokenAtPosition(v,l){const E=v.version,d=C.Position.from(l),r=await this.a.$tokensAtPosition(v.uri,d),o={type:P.StandardTokenType.Other,range:v.getWordRangeAtPosition(l)??new P.$5M(l.line,l.character,l.line,l.character)};if(!r)return o;const a={range:C.Range.to(r.range),type:C.TokenType.to(r.type)};return!a.range.contains(l)||E!==v.version?o:a}createLanguageStatusItem(v,l,E){const d=this.f++,r=this.a,o=this.g,a=`${v.identifier.value}/${l}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(a);const h={selector:E,id:l,name:v.displayName??v.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new N.$Uc,i=()=>{if(n?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${l}) from ${v.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.$Gh)(()=>{s.clear(),this.a.$setLanguageStatus(d,{id:a,name:h.name??v.displayName??v.name,source:v.displayName??v.name,selector:C.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===P.LanguageStatusSeverity.Error?M.default.Error:h.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:h.command&&this.d.toInternal(h.command,s),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),r.$removeLanguageStatus(d),o.delete(a)},get id(){return h.id},get name(){return h.name},set name(m){h.name=m,i()},get selector(){return h.selector},set selector(m){h.selector=m,i()},get text(){return h.text},set text(m){h.text=m,i()},set text2(m){(0,p.$4G)(v,"languageStatusText"),h.text=m,i()},get text2(){return(0,p.$4G)(v,"languageStatusText"),h.text},get detail(){return h.detail},set detail(m){h.detail=m,i()},get severity(){return h.severity},set severity(m){h.severity=m,i()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(m){h.accessibilityInformation=m,i()},get command(){return h.command},set command(m){h.command=m,i()},get busy(){return h.busy},set busy(m){h.busy=m,i()}};return i(),t}}e.$Moc=c}),define(Ce[287],Ie([1,0,16,2,10,7,90]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=void 0,P=qe(P),A=qe(A);class N{constructor(v,l,E,d){this.start=v,this.deletedCount=l,this.deletedItems=E,this.items=d}asApiEvent(){return{range:new M.$sO(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1}}constructor(v,l,E){this.notebook=v,this.h=l,this.j=E,this.handle=E.handle,this.uri=C.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const v=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return v.g},set mime(d){v.g=d},get outputs(){return v.a.slice(0)},get metadata(){return v.b},get executionSummary(){return v.d}};this.f=Object.freeze(E)}return this.f}setOutputs(v){this.a=v.map(P.NotebookCellOutput.to)}setOutputItems(v,l,E){const d=E.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===v);if(r&&(l||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>A.$6K(o.mime)))){const o=new Map,a=[];r.items.forEach(h=>{let n;o.has(h.mime)?n=o.get(h.mime):(n=[],o.set(h.mime,n),a.push(h.mime)),n.push(h.data)}),r.items.length=0,a.forEach(h=>{const n=A.$7K(o.get(h));r.items.push({mime:h,data:n.data.buffer})})}}setMetadata(v){this.b=Object.freeze(v)}setInternalMetadata(v){this.e=v,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.$yoc=p;class c{static{this.a=0}constructor(v,l,E,d,r){this.k=v,this.l=l,this.m=E,this.uri=d,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const v=this,l={get uri(){return v.uri},get version(){return v.g},get notebookType(){return v.d},get isDirty(){return v.h},get isUntitled(){return v.uri.scheme===w.Schemas.untitled},get isClosed(){return v.j},get metadata(){return v.f},get cellCount(){return v.b.length},cellAt(E){return E=v.n(E),v.b[E].apiCell},getCells(E){return(E?v.p(E):v.b).map(r=>r.apiCell)},save(){return v.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(v){v.metadata&&(this.f=Object.freeze({...this.f,...v.metadata}))}acceptDirty(v){this.h=v}acceptModelChanged(v,l,E){this.g=v.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:E});const d={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const a of v.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,d.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,d.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),r.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),r.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const h=r[a],n=o.get(h.cell);if(n===void 0){const s=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,s-1)}else d.cellChanges[n]={...d.cellChanges[n],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(v){return v=v|0,v<0?0:v>=this.b.length?this.b.length-1:v}o(v){let l=v.start|0,E=v.end|0;return l<0&&(l=0),E>this.b.length&&(E=this.b.length),v.with({start:l,end:E})}p(v){v=this.o(v);const l=[];for(let E=v.start;E<v.end;E++)l.push(this.b[E]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(v,l,E){if(this.j)return;const d=[],r=[],o=[];if(v.reverse().forEach(a=>{const n=a[2].map(t=>{const m=new p(this,this.l,t);return l||r.push(p.asModelAddData(t)),m}),s=new N(a[0],a[1],[],n),i=this.b.splice(a[0],a[1],...n);for(const t of i)o.push(t.uri),s.deletedItems.push(t.apiCell);d.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),E)for(const a of d)E.push(a.asApiEvent())}s(v,l,E,d){const r=this.b.splice(v,l);this.b.splice(E,0,...r);const o=[new N(v,l,r.map(a=>a.apiCell),[]),new N(E,0,[],r)];for(const a of o)d.push(a.asApiEvent())}t(v,l){this.b[v].setOutputs(l)}u(v,l,E,d){this.b[v].setOutputItems(l,E,d)}v(v,l){const E=this.b[v];E.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(E.uri,l)}w(v,l){const E=this.b[v];E.apiCell.mime=l}x(v,l){this.b[v].setMetadata(l)}y(v,l){this.b[v].setInternalMetadata(l)}getCellFromApiCell(v){return this.b.find(l=>l.apiCell===v)}getCellFromIndex(v){return this.b[v]}getCell(v){return this.b.find(l=>l.handle===v)}getCellIndex(v){return this.b.indexOf(v)}}e.$zoc=c}),define(Ce[288],Ie([1,0,4,2,10,7,39]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class N{constructor(c,R,v,l={timeout:1500,errors:3}){this.b=c,this.c=R,this.d=v,this.f=l,this.a=new w.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(R,v,l)=>{const E=function(r){R.call(v,r)};return E.extension=c,this.a.event(E,void 0,l)}}async $participateInSave(c,R,v){const l=C.URI.revive(c),E=this.c.getNotebookDocument(l);if(!E)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:P.TextDocumentSaveReason.to(R)},v,async(o,a)=>{const h=Date.now(),n=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!v.isCancellationRequested&&n&&(n instanceof M.$aN?d.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),v.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:a}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new A.$Pw(r))}}e.$Ooc=N}),define(Ce[123],Ie([1,0,14,10,7]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=void 0,C=qe(C),P=qe(P);class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(N,p,c,R,v,l){this.id=N,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=v,this.b=R,this.c=l}get apiEditor(){if(!this.e){const N=this;this.e={get notebook(){return N.notebookData.apiNotebook},get selection(){return N.a[0]},set selection(p){this.selections=[p]},get selections(){return N.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$sO.isNotebookRange))throw(0,w.$8)("selections");N.a=p,N.g(p)},get visibleRanges(){return N.b},revealRange(p,c){N.f.$tryRevealRange(N.id,C.NotebookRange.from(p),c??P.NotebookEditorRevealType.Default)},get viewColumn(){return N.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(N){this.d=N}_acceptVisibleRanges(N){this.b=N}_acceptSelections(N){this.a=N}g(N){this.f.$trySetSelections(this.id,N.map(C.NotebookRange.from))}_acceptViewColumn(N){this.c=N}}e.$Aoc=M}),define(Ce[289],Ie([1,0,4,12,10]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=void 0,P=qe(P);let M=class{constructor(N,p){this.c=N,this.d=p,this.a=new w.$le,this.b=new w.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(N,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",N,p);const c=this.d.getEditorById(N);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(N){for(const p in N)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(N[p]))}};e.$Qoc=M,e.$Qoc=M=He([We(0,C.$$j)],M)}),define(Ce[290],Ie([1,0,4,6,123]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class M{constructor(N,p){this.c=p,this.a=new Map,this.b=N.getProxy(C.$1M.MainThreadNotebookRenderers)}$postRendererMessage(N,p,c){const R=this.c.getEditorById(N);this.a.get(p)?.fire({editor:R.apiEditor,message:c})}createRendererMessaging(N,p){if(!N.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,v,l)=>this.d(p).event(R,v,l),postMessage:(R,v)=>{P.$Aoc.apiEditorsToExtHost.has(R)&&([R,v]=[v,R]);const l=v&&P.$Aoc.apiEditorsToExtHost.get(v);return this.b.$postMessage(l?.id,p,R)}}}d(N){let p=this.a.get(N);return p||(p=new w.$le({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(N)}}),this.a.set(N,p),p)}}e.$Toc=M}),define(Ce[291],Ie([1,0,10,77,22,72,14]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0;class N{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,l,E){const d=this.b++,{title:r,location:o,cancellable:a}=l,h={label:v.displayName||v.name,id:v.identifier.value};return this.a.$startProgress(d,{location:w.ProgressLocation.from(o),title:r,source:h,cancellable:a},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.$3),this.d(d,E,!!a)}d(v,l,E){let d;E&&(d=new P.$we,this.c.set(v,d));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),d?.dispose()};let o;try{o=l(new c(this.a,v),E&&d?d.token:P.CancellationToken.None)}catch(a){throw r(v),a}return o.then(a=>r(v),a=>r(v)),o}$acceptProgressCanceled(v){const l=this.c.get(v);l&&(l.cancel(),this.c.delete(v))}}e.$Xoc=N;function p(R,v){return R.message=v.message,typeof v.increment=="number"&&(typeof R.increment=="number"?R.increment+=v.increment:R.increment=v.increment),R}class c extends C.$rw{constructor(v,l){super(E=>this.throttledReport(E)),this.c=v,this.d=l}throttledReport(v){this.c.$progressReport(this.d,v)}}He([(0,M.$$h)(100,(R,v)=>p(R,v),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Ce[292],Ie([1,0,2,6,11,10]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=void 0;class A{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(C.$1M.MainThreadQuickDiff)}$provideOriginalResource(p,c,R){const v=w.URI.revive(c),l=this.c.get(p);return l?(0,P.$wh)(()=>l.provideOriginalResource(v,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,R,v){const l=A.a++;return this.c.set(l,c),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(p,this.d),R,v),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Yoc=A});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[293],Ie([1,0,22,4,5,6,2,7,14,18,36,35,25,10]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=d,R=ri(R);function d(r,o,a){const h=r.getProxy(M.$1M.MainThreadQuickOpen);class n{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,S,k=w.CancellationToken.None){this.c=void 0;const g=Promise.resolve(y),b=++this.f,F=h.$show(b,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},k),T={},q=F.then(()=>T);return Promise.race([q,g]).then(G=>{if(G===T)return;const V=(0,l.$3G)(D,"quickPickItemTooltip");return g.then(O=>{const W=[];for(let ce=0;ce<O.length;ce++){const ge=O[ce];if(typeof ge=="string")W.push({label:ge,handle:ce});else if(ge.kind===N.QuickPickItemKind.Separator)W.push({type:"separator",label:ge.label});else{ge.tooltip&&!V&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const te=ge.iconPath?f(ge.iconPath):void 0;W.push({label:ge.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:V?E.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ce})}}return S&&typeof S.onDidSelectItem=="function"&&(this.c=ce=>{S.onDidSelectItem(O[ce])}),h.$setItems(b,W),F.then(ce=>{if(typeof ce=="number")return O[ce];if(Array.isArray(ce))return ce.map(ge=>O[ge])})})}).then(void 0,G=>{if(!(0,p.$5)(G))return h.$setError(b,G),Promise.reject(G)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=w.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",y).then(void 0,S=>{if(!(0,p.$5)(S))return Promise.reject(S)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let S;switch(y.severity){case N.InputBoxValidationSeverity.Info:S=R.default.Info;break;case N.InputBoxValidationSeverity.Warning:S=R.default.Warning;break;case N.InputBoxValidationSeverity.Error:S=R.default.Error;break;default:S=y.message?R.default.Error:R.default.Ignore;break}return{content:y.message,severity:S}}async showWorkspaceFolderPick(D,y=w.CancellationToken.None){const S=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!S)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(g=>g.uri.toString()===S.uri.toString())}createQuickPick(D){const y=new u(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new $(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const S=this.e.get(D);S instanceof u&&S._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const S=this.e.get(D);S instanceof u&&S._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,S){const k=this.e.get(D);k instanceof u&&k._fireDidTriggerItemButton(y,S)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.$le,this.q=new C.$le,this.r=new C.$le,this.s=new C.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,S)=>{const k=y===N.$pO.Back?-1:S;this.o.set(k,y)}),this.z({buttons:D.map((y,S)=>({...f(y.iconPath),tooltip:y.tooltip,handle:y===N.$pO.Back?-1:S}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const S=D[y];this.u[y]=S===void 0?null:S}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function i(I){if(I instanceof N.$ZN)return{id:I.id};const D=m(I),y=t(I);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof y=="string"?A.URI.file(y):y}}function t(I){return typeof I=="object"&&"light"in I?I.light:I}function m(I){return typeof I=="object"&&"dark"in I?I.dark:I}function f(I){const D=i(I);let y,S;return"id"in D?S=v.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:S}}class u extends s{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.$le,this.L=[],this.M=new C.$le,this.N=new C.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,g)=>{this.C.set(g,k),this.D.set(k,g)});const y=(0,l.$3G)(this.O,"quickPickItemTooltip"),S=[];for(let k=0;k<D.length;k++){const g=D[k];if(g.kind===N.QuickPickItemKind.Separator)S.push({type:"separator",label:g.label});else{g.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=g.iconPath?f(g.iconPath):void 0;S.push({handle:k,label:g.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:y?E.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((F,T)=>({...f(F.iconPath),tooltip:F.tooltip,handle:T}))})}}this.z({items:S})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Ib)(D.map(S=>this.C.get(S)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Ib)(D.map(S=>this.C.get(S)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const S=this.C.get(D);if(!S||!S.buttons||!S.buttons.length)return;const k=S.buttons[y];k&&this.N.fire({button:k,item:S})}}class $ extends s{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new n(o,a)}}),define(Ce[294],Ie([1,0,2,4,72,5,11,6,18,159,12,19,38,35,10,25,16,21]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=e.$1oc=void 0;function n(F){return F instanceof w.URI}function s(F,T){return F.scheme===o.Schemas.file&&T.scheme===o.Schemas.file&&a.$k?F.toString()===T.toString():F.toString().toLowerCase()===T.toString().toLowerCase()}function i(F){if(F)return typeof F.iconPath=="string"?w.URI.file(F.iconPath):w.URI.isUri(F.iconPath)||E.ThemeIcon.isThemeIcon(F.iconPath)?F.iconPath:void 0}function t(F){if(F.icon){if(w.URI.isUri(F.icon))return F.icon;if(E.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const T=F.icon;return{light:T.light,dark:T.dark}}}else return}function m(F,T){if(!F.iconPath&&!T.iconPath)return 0;if(F.iconPath){if(!T.iconPath)return 1}else return-1;const q=typeof F.iconPath=="string"?F.iconPath:w.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id,G=typeof T.iconPath=="string"?T.iconPath:w.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,c.$Dr)(q,G)}function f(F,T){let q=0;if(F.strikeThrough!==T.strikeThrough)return F.strikeThrough?1:-1;if(F.faded!==T.faded)return F.faded?1:-1;if(F.tooltip!==T.tooltip)return(F.tooltip||"").localeCompare(T.tooltip||"");if(q=m(F,T),q!==0)return q;if(F.light&&T.light)q=m(F.light,T.light);else{if(F.light)return 1;if(T.light)return-1}if(q!==0)return q;if(F.dark&&T.dark)q=m(F.dark,T.dark);else{if(F.dark)return 1;if(T.dark)return-1}return q}function u(F,T){if(F.command!==T.command)return F.command<T.command?-1:1;if(F.title!==T.title)return F.title<T.title?-1:1;if(F.tooltip!==T.tooltip){if(F.tooltip!==void 0&&T.tooltip!==void 0)return F.tooltip<T.tooltip?-1:1;if(F.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(F.arguments===T.arguments)return 0;if(F.arguments)if(T.arguments){if(F.arguments.length!==T.arguments.length)return F.arguments.length-T.arguments.length}else return 1;else return-1;for(let q=0;q<F.arguments.length;q++){const G=F.arguments[q],V=T.arguments[q];if(G!==V&&!(n(G)&&n(V)&&s(G,V)))return G<V?-1:1}return 0}function $(F,T){let q=(0,c.$Dr)(F.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(q!==0)return q;if(F.command&&T.command)q=u(F.command,T.command);else{if(F.command)return 1;if(T.command)return-1}if(q!==0)return q;if(F.decorations&&T.decorations)q=f(F.decorations,T.decorations);else{if(F.decorations)return 1;if(T.decorations)return-1}if(F.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)q=(0,c.$Dr)(F.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(F.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(F.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)q=(0,c.$Dr)(F.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(F.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return q}function I(F,T){for(let q=0;q<F.length;q++)if(F[q]!==T[q])return!1;return!0}function D(F,T){return F.command===T.command&&F.title===T.title&&F.tooltip===T.tooltip&&(F.arguments&&T.arguments?I(F.arguments,T.arguments):F.arguments===T.arguments)}function y(F,T){return(0,p.$vb)(F,T,D)}class S{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,r.$4G)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,r.$4G)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,r.$4G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,q,G,V,O){this.k=T,this.l=V,this.m=O,this.d="",this.e=new C.$le,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=G}showValidationMessage(T,q){(0,r.$4G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,q)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$1oc=S;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,q,G,V,O,W,ce){this.q=T,this.s=q,this.t=G,this.u=V,this.v=O,this.multiDiffEditorEnableViewChanges=W,this.w=ce,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.$le,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.$le,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,q){const G=this.h.get(T);return G?(0,A.$wh)(()=>this.s.executeCommand(G.command,...G.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort($),G=(0,p.$Eb)(this.o,T,$).map(W=>{const ce=W.toInsert.map(ge=>{const te=this.e++;this.g.set(te,ge);const me=ge.resourceUri;let se;if(ge.command)if(ge.command.command==="vscode.open"||ge.command.command==="vscode.diff"||ge.command.command==="vscode.changes"){const Z=new M.$Uc;se=this.s.converter.toInternal(ge.command,Z),this.j.set(te,Z)}else this.h.set(te,ge.command);const de=(0,r.$3G)(this.w,"scmMultiDiffEditor"),be=de?ge.multiDiffEditorOriginalUri:void 0,re=de?ge.multiFileDiffEditorModifiedUri:void 0,Pe=i(ge.decorations),Fe=ge.decorations&&i(ge.decorations.light)||Pe,X=ge.decorations&&i(ge.decorations.dark)||Pe,B=[Fe,X],_=ge.decorations&&ge.decorations.tooltip||"",we=ge.decorations&&!!ge.decorations.strikeThrough,ae=ge.decorations&&!!ge.decorations.faded,ve=ge.contextValue||"";return{rawResource:[te,me,B,_,we,ae,ve,se,be,re],handle:te}});return{start:W.start,deleteCount:W.deleteCount,toInsert:ce}}),V=G.map(({start:W,deleteCount:ce,toInsert:ge})=>[W,ce,ge.map(te=>te.rawResource)]),O=G.reverse();for(const{start:W,deleteCount:ce,toInsert:ge}of O){const te=ge.map(se=>se.handle),me=this.n.splice(W,ce,...te);for(const se of me)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.o=T,V}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let q;(0,r.$3G)(this.x,"quickDiffProvider")&&(q=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:q})}get historyProvider(){return(0,r.$4G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,r.$4G)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new M.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new M.$Uc,this.o=T;const q=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:q})}get actionButton(){return(0,r.$4G)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,r.$4G)(this.x,"scmActionButton"),this.p.value=new M.$Uc,this.q=T;const q=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(G=>G.map(V=>this.y.converter.toInternal(V,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:q??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.z.info("ExtHostSourceControl#statusBarCommands",(T??[]).map(G=>G.command).join(", ")),this.t&&T&&y(this.t,T)){this.z.info("ExtHostSourceControl#statusBarCommands are equal");return}this.s.value=new M.$Uc,this.t=T;const q=(T||[]).map(G=>this.y.converter.toInternal(G,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:q})}get selected(){return this.u}constructor(T,q,G,V,O,W,ce,ge){this.x=T,this.y=V,this.z=O,this.A=W,this.B=ce,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Wc,this.m=void 0,this.n=new M.$Wc,this.o=void 0,this.p=new M.$Wc,this.s=new M.$Wc,this.t=void 0,this.u=!1,this.v=new C.$le,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.D=new Map,this.E=new Set,this.#e=G;const te=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${W}/scm${this.w}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new S(T,q,this.#e,this.w,te),this.#e.$registerSourceControl(this.w,W,ce,ge,te)}createResourceGroup(T,q,G){const V=(0,r.$3G)(this.x,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,O=new k(this.#e,this.y,this.w,T,q,V,this.x),W=C.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,W),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const T=[],q=[];for(const[G,V]of this.D){V.dispose();const O=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});C.Event.once(G.onDidDispose)(()=>{this.E.delete(G),O.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.w,G.handle)}),T.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const W=G._takeResourceStateSnapshot();W.length>0&&q.push([G.handle,W]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.w,T,q),this.D.clear()}eventuallyUpdateResourceStates(){const T=[];this.E.forEach(q=>{const G=q._takeResourceStateSnapshot();G.length!==0&&T.push([q.handle,G])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.E.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}He([(0,P.$0h)(100)],g.prototype,"eventuallyAddResourceGroups",null),He([(0,P.$0h)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,q,G,V){this.l=q,this.m=G,this.n=V,this.g=new Map,this.h=new v.$rn,this.j=new C.$le,this.e=T.getProxy(N.$1M.MainThreadSCM),this.f=T.getProxy(N.$1M.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===l.MarshalledId.ScmResource){const W=this.g.get(O.sourceControlHandle);if(!W)return O;const ce=W.getResourceGroup(O.groupHandle);return ce?ce.getResourceState(O.handle):O}else if(O&&O.$mid===l.MarshalledId.ScmResourceGroup){const W=this.g.get(O.sourceControlHandle);return W?W.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===l.MarshalledId.ScmProvider){const W=this.g.get(O.handle);return W||O}return O}})}createSourceControl(T,q,G,V){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,q,G,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const O=h.d++,W=new g(T,this.m,this.e,this.l,this.n,q,G,V);this.g.set(O,W);const ce=this.h.get(T.identifier)||[];return ce.push(W),this.h.set(T.identifier,ce),W}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const q=this.h.get(T.identifier),G=q&&q[q.length-1];return G&&G.inputBox}$provideOriginalResource(T,q,G){const V=w.URI.revive(q);this.n.trace("ExtHostSCM#$provideOriginalResource",T,V.toString());const O=this.g.get(T);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$wh)(()=>O.quickDiffProvider.provideOriginalResource(V,G)).then(W=>W||null)}$onInputBoxValueChange(T,q){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const G=this.g.get(T);return G&&G.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(T,q,G,V){this.n.trace("ExtHostSCM#$executeResourceCommand",T,q,G);const O=this.g.get(T);if(!O)return Promise.resolve(void 0);const W=O.getResourceGroup(q);return W?W.$executeResourceCommand(G,V):Promise.resolve(void 0)}$validateInput(T,q,G){this.n.trace("ExtHostSCM#$validateInput",T);const V=this.g.get(T);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$wh)(()=>V.inputBox.validateInput(q,G)).then(O=>{if(!O)return Promise.resolve(void 0);const W=d.MarkdownString.fromStrict(O.message);return W?Promise.resolve([W,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,q,G,V){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,G,V)??void 0}async $provideHistoryItems(T,q,G,V){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(q,G,V))?.map(ce=>({...ce,icon:t(ce)}))??void 0}async $provideHistoryItemSummary(T,q,G,V){const O=this.g.get(T)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const W=await O.provideHistoryItemSummary(q,G,V);return W?{...W,icon:t(W)}:void 0}async $provideHistoryItemChanges(T,q,G,V){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(q,G,V)??void 0}};e.$2oc=b,e.$2oc=b=h=He([We(3,R.$$j)],b)}),define(Ce[295],Ie([1,0,6,10,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=void 0;class M{static{this.a=0}constructor(N,p){this.d=p,this.c=new Map,this.b=N.getProxy(w.$1M.MainThreadShare)}async $provideShare(N,p,c){return await this.c.get(N)?.provideShare({selection:C.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(N,p){const c=M.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,C.DocumentSelector.from(N,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$3oc=M}),define(Ce[296],Ie([1,0,7,6,186,5,10,15]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$1N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$1N("statusBarItem.warningForeground")]])}#e;#t;constructor(l,E,d,r,o,a=w.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new M.$Uc,this.#e=l,this.#t=E,o&&r){this.c=(0,w.$CN)(r.identifier,o);const n=d.get(this.c);n&&(a=n.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,h=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=o,this.g=a,this.h=this.u(h)}u(l){if((0,N.$ig)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!p.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Uc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let E;this.m?E=this.m:E=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,E,this.k,r,this.r?.internal,d,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5oc=p;class c{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const E={message:l};return this.b.unshift(E),this.c(),new w.$3M(()=>{const d=this.b.indexOf(E);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,E){this.e=new Map,this.a=l.getProxy(C.$1M.MainThreadStatusBar),this.b=E,this.c=new c(this)}$acceptStaticEntries(l){for(const E of l)this.e.set(E.entryId,E)}createStatusBarEntry(l,E,d,r){return new p(this.a,this.b,this.e,l,E,d,r)}setStatusBarMessage(l,E){const d=this.c.setMessage(l);let r;return typeof E=="number"?r=setTimeout(()=>d.dispose(),E):typeof E<"u"&&E.then(()=>d.dispose(),()=>d.dispose()),new w.$3M(()=>{d.dispose(),clearTimeout(r)})}}e.$6oc=R}),define(Ce[124],Ie([1,0,33,115,55,82,56,10,2]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JP=e.$IP=e.$HP=e.$GP=void 0,w=qe(w),N=qe(N);const c=(n,s,i,t)=>{let m=s;return{enumerable:!0,configurable:!1,get(){return m},set(f){if(!i(m,f)){const u=m;m=f,n.listener?.(t(f,u))}}}},R=(n,s)=>n===s,v={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(n,s)=>!(n.length!==s.length||n.some(i=>!s.find(t=>i.id===t.id)))},l=n=>s=>({op:M.TestItemEventOp.SetProp,update:n(s)}),E=(n,s)=>({range:(()=>{let i;const t=l(m=>({range:w.$Ht.lift(N.Range.from(m))}));return{enumerable:!0,configurable:!1,get(){return i},set(m){n.listener?.({op:M.TestItemEventOp.DocumentSynced}),v.range(i,m)||(i=m,n.listener?.(t(m)))}}})(),label:c(n,s,v.label,l(i=>({label:i}))),description:c(n,void 0,v.description,l(i=>({description:i}))),sortText:c(n,void 0,v.sortText,l(i=>({sortText:i}))),canResolveChildren:c(n,!1,v.canResolveChildren,i=>({op:M.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:c(n,!1,v.busy,l(i=>({busy:i}))),error:c(n,void 0,v.error,l(i=>({error:N.MarkdownString.fromStrict(i)||null}))),tags:c(n,[],v.tags,(i,t)=>({op:M.TestItemEventOp.SetTags,new:i.map(N.TestTag.from),old:t.map(N.TestTag.from)}))}),d=n=>{const s=P.$OI.fromString(n.extId),i=new o(s.controllerId,s.localId,n.label,p.URI.revive(n.uri)||void 0);return i.range=N.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>N.TestTag.to({id:(0,A.$UI)(t).tagId})),i},r=n=>{let s;for(const i of n.tests){const t=d(i.item);(0,C.$qP)(t).parent=s,s=t}return s};e.$GP=r;class o{constructor(s,i,t,m){if(i.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const f=(0,C.$pP)(this,s);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:m,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,M.$oP)(f,C.$qP,o),enumerable:!0,writable:!1},...E(f,t)})}}e.$HP=o;class a extends o{constructor(s,i){super(s,s,i,void 0),this._isRoot=!0}}e.$IP=a;class h extends M.$kP{constructor(s,i,t){super({controllerId:s,getDocumentVersion:m=>m&&t.getDocument(m)?.version,getApiFor:C.$qP,getChildren:m=>m.children,root:new a(s,i),toITestItem:N.TestItem.from})}}e.$JP=h}),define(Ce[34],Ie([1,0,15,7,10,26,6,18,12,49,33,101,2,5,3,17,124,23,39,48,70,64,67,37]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=void 0,C=qe(C),P=qe(P);let f=class{#e;#t;#i;constructor(S,k,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$1M.MainThreadCommands),this.d=k,this.#i=g,this.#t=S.getProxy(A.$1M.MainThreadTelemetry),this.converter=new u(this,b=>{const F=this.c.get(b);return F?.result===I.Void?F:void 0},k),this.f=[{processArgument(b){return(0,c.$bi)(b)}},{processArgument(b){return(0,M.$do)(b,function(F){if(R.$Ht.isIRange(F))return P.Range.to(F);if(v.$Gt.isIPosition(F))return P.Position.to(F);if(R.$Ht.isIRange(F.range)&&l.URI.isUri(F.uri))return P.location.to(F);if(F instanceof a.$Ne)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const k=this.registerCommand(!1,S.id,async(...g)=>{const b=S.args.map((T,q)=>{if(!T.validate(g[q]))throw new Error(`Invalid argument '${T.name}' when running '${S.id}', received: ${typeof g[q]=="object"?JSON.stringify(g[q],null,"	"):g[q]} `);return T.convert(g[q])}),F=await this.executeCommand(S.internalId,...b);return S.result.convert(F,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new C.$3M(()=>{k.dispose(),this.c.delete(S.id)})}registerCommand(S,k,g,b,F,T){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:g,thisArg:b,metadata:F,extension:T}),S&&this.#e.$registerCommand(k),new C.$3M(()=>{this.b.delete(k)&&S&&this.#e.$unregisterCommand(k)})}executeCommand(S,...k){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,k,!0)}async g(S,k,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,k,!1);{let b=!1;const F=(0,M.$do)(k,function(T){if(T instanceof C.$4M)return P.Position.from(T);if(T instanceof C.$5M)return P.Range.from(T);if(T instanceof C.$cN)return P.location.from(T);if(C.$sO.isNotebookRange(T))return P.NotebookRange.from(T);if(T instanceof ArrayBuffer)return b=!0,a.$Ne.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return b=!0,a.$Ne.wrap(T);if(T instanceof a.$Ne)return b=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(S,b?new h.$Pw(F):F,g);return(0,c.$bi)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(S,k,!1);throw T}}}async h(S,k,g){const b=this.b.get(S);if(!b)throw new Error("Unknown command");const{callback:F,thisArg:T,metadata:q}=b;if(q?.args)for(let V=0;V<q.args.length;V++)try{(0,w.$vg)(k[V],q.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${q.args[V].name}' - ${q.args[V].description}`)}const G=s.$fe.create();try{return await F.apply(T,k)}catch(V){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...k);O&&(S=O.command)}if(this.d.error(V,S,b.extension?.identifier),!g)throw V;if(b.extension?.identifier){const O=this.#i.onExtensionError(b.extension.identifier,V);this.d.trace("forwarded error to extension?",O,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$pj)(V)),this.id=S,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,S,G.elapsed())}}j(S,k,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new i.$sp(k),duration:g})}$executeContributedCommand(S,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?(k=k.map(b=>this.f.reduce((F,T)=>T.processArgument(F,g.extension?.identifier),b)),this.h(S,k,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(k=>(S&&(k=k.filter(g=>g[0]!=="_")),k))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[k,g]of this.b){const{metadata:b}=g;b&&(S[k]=b)}return Promise.resolve(S)}};e.$PP=f,e.$PP=f=He([We(0,r.$uP),We(1,p.$$j),We(2,t.$OP)],f),e.$QP=(0,d.$Ei)("IExtHostCommands");class u{constructor(S,k,g){this.d=S,this.f=k,this.g=g,this.delegatingCommandId=`__vsc${(0,m.$1g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,k){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const b=this.f(S.command);if(b)g.id=b.internalId,g.arguments=b.args.map((F,T)=>F.convert(S.arguments&&S.arguments[T]));else if((0,N.$Mb)(S.arguments)){const F=`${S.command} /${++this.c}`;this.b.set(F,S),k.add((0,E.$Tc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),g.$ident=F,g.id=this.delegatingCommandId,g.arguments=[F],this.g.trace("CommandsConverter#CREATE",S.command,F)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const k=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$RP=u;class ${static{this.Uri=new $("uri","Uri of a text document",S=>l.URI.isUri(S),S=>S)}static{this.Position=new $("position","A position in a text document",S=>C.$4M.isPosition(S),P.Position.from)}static{this.Range=new $("range","A range in a text document",S=>C.$5M.isRange(S),P.Range.from)}static{this.Selection=new $("selection","A selection in a text document",S=>C.$6M.isSelection(S),P.Selection.from)}static{this.Number=new $("number","",S=>typeof S=="number",S=>S)}static{this.String=new $("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=$.Arr($.String)}static Arr(S){return new $(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,k=>Array.isArray(k)&&k.every(g=>S.validate(g)),k=>k.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",S=>S instanceof C.$oN,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",S=>S instanceof C.$MO,P.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",S=>S instanceof o.$HP,P.TestItem.from)}constructor(S,k,g,b){this.name=S,this.description=k,this.validate=g,this.convert=b}optional(){return new $(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,k){return new $(S??this.name,k??this.description,this.validate,this.convert)}}e.$SP=$;class I{static{this.Void=new I("no result",S=>S)}constructor(S,k){this.description=S,this.convert=k}}e.$TP=I;class D{constructor(S,k,g,b,F){this.id=S,this.internalId=k,this.description=g,this.args=b,this.result=F}}e.$UP=D}),define(Ce[297],Ie([1,0,18,16,2,94,104,32,34,10,7]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0,M=qe(M),c=qe(c),R=qe(R);const v=[new p.$UP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of DocumentHighlight-instances.",E(c.DocumentHighlight.to))),new p.$UP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$SP.Uri],new p.$TP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,w.$Lb)(r))return;class a extends R.$jN{static to(n){const s=new a(n.name,c.SymbolKind.to(n.kind),n.containerName||"",new R.$cN(o[0],c.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=c.Range.to(n.selectionRange),s.children=n.children?n.children.map(a.to):[],s}}return r.map(a.to)})),new p.$UP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$SP.Uri,new p.$SP("options","Formatting options",r=>!0,r=>r)],new p.$TP("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$UP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$SP.Uri,p.$SP.Range,new p.$SP("options","Formatting options",r=>!0,r=>r)],new p.$TP("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$UP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$SP.Uri,p.$SP.Position,new p.$SP("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$SP("options","Formatting options",r=>!0,r=>r)],new p.$TP("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$UP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$UP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$UP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$UP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$UP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of Location-instances.",E(c.location.to))),new p.$UP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of Hover-instances.",E(c.Hover.to))),new p.$UP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$SP.Uri,new p.$SP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>R.$4M.isPosition(o)),r=>r.map(c.Position.from))],new p.$TP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const h of o.reverse())a=new R.$nN(c.Range.to(h),a);return a}))),new p.$UP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$SP.String.with("query","Search string")],new p.$TP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new p.$UP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(c.CallHierarchyItem.to))),new p.$UP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$SP.CallHierarchyItem],new p.$TP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(c.CallHierarchyIncomingCall.to))),new p.$UP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$SP.CallHierarchyItem],new p.$TP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(c.CallHierarchyOutgoingCall.to))),new p.$UP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:c.Range.to(r.range),placeholder:r.text}})),new p.$UP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$SP.Uri,p.$SP.Position,p.$SP.String.with("newName","The new symbol name")],new p.$TP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new p.$UP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$SP.Uri,p.$SP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$TP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new p.$UP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$SP.Uri],new p.$TP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$jO(r.tokenTypes,r.tokenModifiers)})),new p.$UP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$SP.Uri],new p.$TP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Hcb)(r);if(o.type==="full")return new R.$lO(o.data,void 0)})),new p.$UP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$SP.Uri,p.$SP.Range.optional()],new p.$TP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$jO(r.tokenTypes,r.tokenModifiers)})),new p.$UP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$SP.Uri,p.$SP.Range],new p.$TP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Hcb)(r);if(o.type==="full")return new R.$lO(o.data,void 0)})),new p.$UP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$SP.Uri,p.$SP.Position,p.$SP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$SP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$TP("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new R.$zN([]);const h=r.suggestions.map(n=>c.CompletionItem.to(n,a));return new R.$zN(h,r.incomplete)})),new p.$UP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$SP.Uri,p.$SP.Position,p.$SP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$TP("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new p.$UP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$SP.Uri,p.$SP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$TP("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>E(h=>new R.$rN(c.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new p.$UP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$SP.Uri,new p.$SP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>R.$5M.isRange(r),r=>R.$6M.isSelection(r)?c.Selection.from(r):c.Range.from(r)),p.$SP.String.with("kind","Code action kind to return code actions for").optional(),p.$SP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$TP("A promise that resolves to an array of Command-instances.",(r,o,a)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const n=new R.$lN(h.title,h.kind?new R.$mN(h.kind):void 0);return h.edit&&(n.edit=c.WorkspaceEdit.to(h.edit)),h.command&&(n.command=a.fromInternal(h.command)),n.isPreferred=h.isPreferred,n}})(r))),new p.$UP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$SP.Uri],new p.$TP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new R.$FN(c.Range.to(o.range),c.Color.to(o.color))):[])),new p.$UP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$SP("color","The color to show and insert",r=>r instanceof R.$EN,c.Color.from),new p.$SP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new p.$TP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new p.$UP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$SP.Uri,p.$SP.Range],new p.$TP("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(c.InlayHint.to.bind(void 0,a)))),new p.$UP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$SP.Uri],new p.$TP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(c.FoldingRange.to)})),new p.$UP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$TP("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>c.NotebookExclusiveDocumentPattern.to(o))})))),new p.$UP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$SP.Uri,p.$SP.Range,new p.$SP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof R.$5M,r=>c.InlineValueContext.from(r))],new p.$TP("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new p.$UP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$SP("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,C.$Og)(r,C.Schemas.http,C.Schemas.https),r=>r),new p.$SP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),p.$SP.String.with("label","").optional()],p.$TP.Void),new p.$UP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$SP.Uri.with("resource","Resource to open"),p.$SP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$SP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],p.$TP.Void),new p.$UP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$SP.Uri.with("left","Left-hand side resource of the diff editor"),p.$SP.Uri.with("right","Right-hand side resource of the diff editor"),p.$SP.String.with("title","Human readable title for the diff editor").optional(),new p.$SP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],p.$TP.Void),new p.$UP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$SP.String.with("title","Human readable title for the changes editor"),new p.$SP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,h,n]=o;if(!P.URI.isUri(a)||!P.URI.isUri(h)&&h!==void 0&&h!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],p.$TP.Void),new p.$UP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$SP.Uri,p.$SP.Position],new p.$TP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$UP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$SP.TypeHierarchyItem],new p.$TP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$UP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$SP.TypeHierarchyItem],new p.$TP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$UP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$SP.TestItem],p.$TP.Void),new p.$UP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$SP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$TP.Void),new p.$UP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$SP.String.with("name","The context key name"),new p.$SP("value","The context key value",()=>!0,r=>r)],p.$TP.Void),new p.$UP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$SP.Uri,p.$SP.StringArray,new p.$SP("MappedEditsContext","Mapped Edits Context",r=>c.MappedEditsContext.is(r),r=>c.MappedEditsContext.from(r))],new p.$TP("A promise that resolves to a workspace edit or null",r=>r?c.WorkspaceEdit.to(r):null)),new p.$UP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$SP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?c.Range.from(r.initialRange):void 0,initialSelection:R.$6M.isSelection(r.initialSelection)?c.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?c.Position.from(r.position):void 0}})],p.$TP.Void)];class l{static register(o){v.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",N.$Dj)}}e.$jnc=l;function E(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const a of r)M.$Du(a)?o.push(c.DefinitionLink.to(a)):o.push(c.location.to(a));return o}}),define(Ce[298],Ie([1,0,2,34]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0;class P{constructor(A,N,p,c,R){this.a=N,this.b=p,this.c=c;const v=new C.$UP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.$SP("showOptions","Show Options",l=>!0,l=>l),new C.$SP("resource","Interactive resource Uri",l=>!0,l=>l),new C.$SP("controllerId","Notebook controller Id",l=>!0,l=>l),new C.$SP("title","Interactive editor title",l=>!0,l=>l)],new C.$TP("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const E=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:w.URI.revive(l.notebookUri),inputUri:w.URI.revive(l.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:w.URI.revive(l.notebookUri),inputUri:w.URI.revive(l.inputUri)}}));this.c.registerApiCommand(v)}$willAddInteractiveDocument(A,N,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:N,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,N){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Koc=P}),define(Ce[299],Ie([1,0,18,11,22,4,5,29,2,19,12,6,34,10,7,83,238,25,39,239]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=void 0,e.$Soc=$,E=qe(E);let s=class{constructor(D,y,S,k,g){this.m=y,this.n=S,this.o=k,this.q=g,this.b=new N.$Bc,this.c=new N.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(v.$1M.MainThreadNotebookKernels);const b=new l.$UP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$SP("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const q=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:q}}else if(T&&"notebookEditor"in T){const q=this.n.getIdByEditor(T.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return T})],l.$TP.Void),F=new l.$UP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$SP.Uri],new l.$TP("A promise that resolves to an array of variables",(T,q)=>T.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(F)}createNotebookController(D,y,S,k,g,b){for(const re of this.j.values())if(re.controller.id===y&&c.$pn.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const F=this.k++,T=this;this.q.trace(`NotebookController[${F}], CREATED by ${D.identifier.value}, ${y}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${D.identifier}'`);let G=!1;const V=new M.$le,O=new M.$le,W={id:$(D.identifier,y),notebookType:S,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let ce=g??q,ge,te;this.a.$addKernel(F,W).catch(re=>{console.log(re),G=!0});let me=0;const se=()=>{if(G)return;const re=++me;Promise.resolve().then(()=>{re===me&&this.a.$updateKernel(F,W)})},de=new N.$Bc,be={get id(){return y},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return W.label},set label(re){W.label=re??D.displayName??D.name,se()},get detail(){return W.detail??""},set detail(re){W.detail=re,se()},get description(){return W.description??""},set description(re){W.description=re,se()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(re){W.supportedLanguages=re,se()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(re){W.supportsExecutionOrder=re,se()},get rendererScripts(){return W.preloads?W.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ce},set executeHandler(re){ce=re??q},get interruptHandler(){return ge},set interruptHandler(re){ge=re,W.supportsInterrupt=!!re,se()},set variableProvider(re){(0,a.$4G)(D,"notebookVariableProvider"),te=re,W.hasVariableProvider=!!re,re?.onDidChangeVariables(Pe=>T.a.$variablesUpdated(Pe.uri)),se()},get variableProvider(){return te},createNotebookCellExecution(re){if(G)throw new Error("notebook controller is DISPOSED");if(!de.has(re.notebook.uri))throw T.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return T._createNotebookCellExecution(re,$(D.identifier,this.id))},createNotebookExecution(re){if((0,a.$4G)(D,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!de.has(re.uri))throw T.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return T._createNotebookExecution(re,$(D.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${F}], DISPOSED`),G=!0,this.j.delete(F),V.dispose(),O.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(re,Pe){Pe===d.NotebookControllerAffinity2.Hidden&&(0,a.$4G)(D,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(F,re.uri,Pe)},onDidReceiveMessage:O.event,postMessage(re,Pe){return(0,a.$4G)(D,"notebookMessaging"),T.a.$postMessage(F,Pe&&T.n.getIdByEditor(Pe),re)},asWebviewUri(re){return(0,a.$4G)(D,"notebookMessaging"),(0,r.$kCb)(re,T.m.remote)}};return this.j.set(F,{extensionId:D.identifier,controller:be,onDidReceiveMessage:O,onDidChangeSelection:V,associatedNotebooks:de}),be}getIdByController(D){for(const[y,S]of this.j)if(S.controller===D)return $(S.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const S=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(S,y);const g={dispose:()=>{this.f.delete(S),k.a.$removeKernelDetectionTask(S)}};return this.f.set(S,g),g}registerKernelSourceActionProvider(D,y,S){const k=this.i++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,b=this;this.h.set(k,S),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,y);let F;return g!==void 0&&(F=S.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.h.delete(k),b.a.$removeKernelSourceActionProvider(k,k),F?.dispose()}}}async $provideKernelSourceActions(D,y){const S=this.h.get(D);if(S){const k=new A.$Uc;return(await S.provideNotebookKernelSourceActions(y)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,y,S){const k=this.j.get(D);if(k){const g=this.n.getNotebookDocument(p.URI.revive(y));S?k.associatedNotebooks.set(g.uri,!0):k.associatedNotebooks.delete(g.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,g.uri.toString(),S),k.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getNotebookDocument(p.URI.revive(y)),b=[];for(const F of S){const T=g.getCell(F);T&&b.push(T.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,g.uri.toString(),b.length),await k.controller.executeHandler.call(k.controller,b,g.apiNotebook,k.controller)}catch(F){this.q.error(`NotebookController[${D}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getNotebookDocument(p.URI.revive(y));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,g.apiNotebook);else for(const b of S){const F=g.getCell(b);F&&this.b.get(F.uri)?.cancel()}if(k.controller.interruptHandler){const b=this.c.get(g.uri);this.c.delete(g.uri),S.length&&Array.isArray(b)&&b.length&&b.forEach(F=>F.dispose())}}async $provideVariables(D,y,S,k,g,b,F){const T=this.j.get(D);if(!T)return;const q=this.n.getNotebookDocument(p.URI.revive(S)),G=T.controller.variableProvider;if(!G)return;let V;if(k!==void 0){if(V=this.s[k],!V)return}else this.s={};const O=g==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,W=G.provideVariables(q.apiNotebook,V,O,b,F);let ce=0;for await(const ge of W){if(F.isCancellationRequested)return;const te={id:this.r++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[te.id]=ge.variable,this.a.$receiveVariable(y,te),ce++>=n.$8jb)return}}$acceptKernelMessageFromRenderer(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getEditorById(y);k.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(D,y,S){const g=this.n.getNotebookDocument(p.URI.revive(D)).getCell(y);if(g){const b=S?E.NotebookCellExecutionState.to(S):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:g.apiCell,state:b})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const g=new t(y,k,this.a);this.b.set(k.uri,g);const b=g.onDidChangeState(()=>{g.state===i.Resolved&&(g.dispose(),b.dispose(),this.b.delete(k.uri))});return g.asApiObject()}_createNotebookExecution(D,y){const S=this.n.getNotebookDocument(D.uri),k=D.getCells().find(F=>{const T=S.getCellFromApiCell(F);return T&&this.b.has(T.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new f(y,S,this.a),b=g.onDidChangeState(()=>{g.state===m.Resolved&&(g.dispose(),b.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,b]),g.asApiObject()}};e.$Roc=s,e.$Roc=s=He([We(4,R.$$j)],s);var i;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(i||(i={}));class t extends A.$Vc{static{this.a=0}get state(){return this.f}constructor(D,y,S){super(),this.m=y,this.n=S,this.b=t.a++,this.c=new M.$le,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new P.$we),this.h=new u(10,k=>this.s(k)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Pw(y))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const S=d.$wO.ensureUniqueMimeTypes(y.items,!0);return S===y.items?E.NotebookCellOutput.from(y):E.NotebookCellOutput.from({items:S,id:y.id,metadata:y.metadata})})}async z(D,y,S){const k=this.w(y),g=this.y((0,w.$3b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:S,outputs:g})}async C(D,y,S){return D=d.$wO.ensureUniqueMimeTypes((0,w.$3b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(E.NotebookCellOutputItem.from),outputId:y.id,append:S})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(S){D.j=S,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(S){if(D.f===i.Resolved||D.f===i.Started)throw new Error("Cannot call start again");D.f=i.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,k,g){if(D.f===i.Resolved)throw new Error("Cannot call resolve twice");D.f=i.Resolved,D.c.fire(),D.h.flush();const b=g?{message:g.message,stack:g.stack,location:g?.location?{startLineNumber:g.location.start.line,startColumn:g.location.start.character,endLineNumber:g.location.end.line,endColumn:g.location.end.character}:void 0,uri:g.uri}:void 0;D.n.$completeExecution(D.b,new h.$Pw({runEndTime:k,lastRunSuccess:S,error:b}))},clearOutput(S){return D.t(),D.z([],S,!1)},appendOutput(S,k){return D.t(),D.z(S,k,!0)},replaceOutput(S,k){return D.t(),D.z(S,k,!1)},appendOutputItems(S,k){return D.t(),D.C(S,k,!0)},replaceOutputItems(S,k){return D.t(),D.C(S,k,!1)}})}}var m;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(m||(m={}));class f extends A.$Vc{static{this.a=0}get state(){return this.f}constructor(D,y,S){super(),this.h=y,this.j=S,this.b=f.a++,this.c=new M.$le,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new P.$we),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===m.Resolved||this.f===m.Started)throw new Error("Cannot call start again");this.f=m.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===m.Resolved)throw new Error("Cannot call resolve twice");this.f=m.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new C.$2h,this.b=Date.now(),(0,C.$Fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function $(I,D){return`${I.value}/${D}`}}),define(Ce[57],Ie([1,0,4,6,3,2,17,5,7,188,14,219,22,37,220,221,35,11,10,34,38]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=e.$Znc=e.$Ync=e.$Xnc=void 0,e.$Xnc=(0,P.$Ei)("IExtHostTerminalService");class i extends N.$Vc{constructor(g,b,F,T){super(),this.u=g,this._id=b,this.w=F,this.y=T,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new w.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const q=this;this.value={get name(){return q.y||""},get processId(){return q.b},get creationOptions(){return q.w},get exitStatus(){return q.j},get state(){return q.m},get selection(){return q.n},get shellIntegration(){return q.shellIntegration},sendText(G,V=!0){q.C(),q.u.$sendText(q._id,G,V)},show(G){q.C(),q.u.$show(q._id,G)},hide(){q.C(),q.u.$hide(q._id)},dispose(){q.a||(q.a=!0,q.u.$dispose(q._id))},get dimensions(){if(!(q.f===void 0||q.h===void 0))return{columns:q.f,rows:q.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??b?.cwd??void 0,env:g.env??void 0,icon:D(g.iconPath)??void 0,color:o.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(g.location,b?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,b,F,T,q){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:T,color:o.ThemeColor.isThemeColor(q)?q.id:void 0,location:b?.location||this.z(g,F),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,b){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in g?{viewColumn:h.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,b){this.j=Object.freeze({code:g,reason:b})}setDimensions(g,b){return g===this.f&&b===this.h||g===0||b===0?!1:(this.f=g,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(b=>{b!==g&&(this.b=Promise.resolve(g))})}}e.$Ync=i;class t{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new w.$le,this.onProcessData=this.a.event,this.b=new w.$le,this.d=new w.$le,this.onDidChangeProperty=this.d.event,this.f=new w.$le,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,b){this.g.setDimensions?.({columns:g,rows:b})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,f=class extends N.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,b,F){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new N.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$le,this.onDidCloseTerminal=this.H.event,this.I=new w.$le,this.onDidOpenTerminal=this.I.event,this.J=new w.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$le,this.onDidChangeTerminalState=this.M.event,this.N=new w.$le,this.onDidChangeShell=this.N.event,this.O=new w.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=F.getProxy(C.$1M.MainThreadTerminalService),this.y=new r.$Iwb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:T=>{const q=G=>{const V=G;return this.getTerminalById(V.instanceId)?.value};switch(T?.$mid){case s.MarshalledId.TerminalContext:return q(T);default:{if(Array.isArray(T))for(let G=0;G<T.length&&T[G].$mid===s.MarshalledId.TerminalContext;G++)T[G]=q(T[G]);return T}}}}),this.B({dispose:()=>{for(const[T,q]of this.g)q.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,b){const F=new i(this.a,(0,E.$1g)(),g,g.name),T=new t(g.pty);return F.createExtensionTerminal(g.location,b,this.R(g,b).resolvedExtHostIdentifier,D(g.iconPath),y(g.color)).then(q=>{const G=this.S(q,T);this.h[q]=G}),this.f.push(F),F.value}R(g,b){if(b=b||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const F=g.location.parentTerminal;if(F){const T=this.f.find(q=>q.value===F);T&&(b.resolvedExtHostIdentifier=T._id)}}else g.location&&typeof g.location!="object"?b.location=g.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(g,b){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const T=new t(b),q=this.S(g,T);this.h[g]=q}async $acceptActiveTerminalChanged(g){const b=this.b;if(g===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const F=this.getTerminalById(g);F&&(this.b=F,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,b){const F=this.getTerminalById(g);F&&this.O.fire({terminal:F.value,data:b})}async $acceptTerminalDimensions(g,b,F){const T=this.getTerminalById(g);T&&T.setDimensions(b,F)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(g,b){const F=this.getTerminalById(g);F&&this.P.fire({terminal:F.value,...b})}async $acceptTerminalMaximumDimensions(g,b,F){this.g.get(g)?.resize(b,F)}async $acceptTerminalTitleChange(g,b){const F=this.getTerminalById(g);F&&(F.name=b)}async $acceptTerminalClosed(g,b,F){const T=this.X(this.f,g);if(T!==null){const q=this.f.splice(T,1)[0];q.setExitStatus(b,F),this.H.fire(q.value)}}$acceptTerminalOpened(g,b,F,T){if(b){const V=this.X(this.f,b);if(V!==null){this.f[V]._id=g,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const q={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:M.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},G=new i(this.a,g,q,F);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,b){this.getTerminalById(g)?._setProcessId(b)}async $startExtensionTerminal(g,b){const F=this.getTerminalById(g);if(!F)return{message:(0,c.localize)(0,null,g)};F.isOpen||await new Promise(q=>{const G=this.onDidOpenTerminal(async V=>{V===F.value&&(G.dispose(),q())})});const T=this.g.get(g);T?T.startSendingEvents(b):this.j[g]={initialDimensions:b}}S(g,b){const F=new N.$Uc;F.add(b.onProcessReady(q=>this.a.$sendProcessReady(g,q.pid,q.cwd,q.windowsPty))),F.add(b.onDidChangeProperty(q=>this.a.$sendProcessProperty(g,q))),this.y.startBuffering(g,b.onProcessData),F.add(b.onProcessExit(q=>this.U(g,q))),this.g.set(g,b);const T=this.j[g];return T&&b instanceof t&&(b.startSendingEvents(T.initialDimensions),delete this.j[g]),F}$acceptProcessAckDataEvent(g,b){this.g.get(g)?.acknowledgeDataEvent(b)}$acceptProcessInput(g,b){this.g.get(g)?.input(b)}$acceptTerminalInteraction(g){const b=this.getTerminalById(g);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(g,b){this.getTerminalById(g)?.setSelection(b)}$acceptProcessResize(g,b,F){try{this.g.get(g)?.resize(b,F)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(g,b){this.g.get(g)?.shutdown(b)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$3M(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,b,F){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,F),this.a.$registerProfileProvider(b,g.identifier.value),new p.$3M(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(g,b,F){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,F),this.a.$registerQuickFixProvider(g,b),new p.$3M(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,b){const F=new l.$we().token;if(F.isCancellationRequested)return;const T=this.D.get(g);if(!T)return;const q=await T.provideTerminalQuickFixes(b,F);if(q===null||Array.isArray(q)&&q.length===0)return;const G=new N.$Uc;if(this.w.value=G,!Array.isArray(q))return q?h.TerminalQuickFix.from(q,this.Q.converter,G):void 0;const V=[];for(const O of q){const W=h.TerminalQuickFix.from(O,this.Q.converter,G);W&&V.push(W)}return V}async $createContributedProfileTerminal(g,b){const F=new l.$we().token;let T=await this.C.get(g)?.provideTerminalProfile(F);if(!F.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,b);return}this.createTerminalFromOptions(T.options,b)}}async $provideLinks(g,b){const F=this.getTerminalById(g);if(!F)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const q=new l.$we;this.G.set(g,q);const G=[],V={terminal:F.value,line:b},O=[];for(const ge of this.z)O.push(a.Promises.withAsyncBody(async te=>{q.token.onCancellationRequested(()=>te({provider:ge,links:[]}));const me=await ge.provideTerminalLinks(V,q.token)||[];q.token.isCancellationRequested||te({provider:ge,links:me})}));const W=await Promise.all(O);if(q.token.isCancellationRequested)return[];const ce=new Map;for(const ge of W)ge&&ge.links.length>0&&G.push(...ge.links.map(te=>{const me={id:m++,startIndex:te.startIndex,length:te.length,label:te.tooltip};return ce.set(me.id,{provider:ge.provider,link:te}),me}));return this.F.set(g,ce),G}$activateLink(g,b){const F=this.F.get(g)?.get(b);F&&F.provider.handleTerminalLink(F.link)}U(g,b){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const F=this.h[g];F&&(F.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,b)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const b=this.f.findIndex(F=>F.value===g);return b>=0?b:null}W(g,b){const F=this.X(g,b);return F!==null?g[F]:null}X(g,b){const F=g.findIndex(T=>T._id===b);return F>=0?F:null}getEnvironmentVariableCollection(g){let b=this.n.get(g.identifier.value);return b||(b=this.B(new u),this.Z(g.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(g,b){const F=(0,v.$ys)(b.map),T=(0,v.$zs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(g,b.persistent,F.length===0?void 0:F,T)}$initEnvironmentVariableCollections(g){g.forEach(b=>{const F=b[0],T=this.B(new u(b[1]));this.Z(F,T)})}$acceptDefaultProfile(g,b){const F=this.s;this.s=g,this.u=b,F?.path!==g.path&&this.N.fire(g.path)}Z(g,b){this.n.set(g,b),this.B(b.onDidChangeCollection(()=>{this.Y(g,b)}))}};e.$Znc=f,e.$Znc=f=He([We(1,n.$QP),We(2,A.$uP)],f);class u extends N.$Vc{get persistent(){return this.b}set persistent(g){this.b=g,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(g){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new w.$le,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const b=this.j(g);let F=this.a.get(b);return F||(F=new $(this,g),this.a.set(b,F),this.B(F.onDidChangeCollection(()=>this.f.fire()))),F}replace(g,b,F,T){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:F??{applyAtProcessCreation:!0},scope:T})}append(g,b,F,T){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:F??{applyAtProcessCreation:!0},scope:T})}prepend(g,b,F,T){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:F??{applyAtProcessCreation:!0},scope:T})}g(g,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const F=this.h(g,b.scope),T=this.map.get(F),q=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==b.value||T.type!==b.type||T.options?.applyAtProcessCreation!==q.applyAtProcessCreation||T.options?.applyAtShellIntegration!==q.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const G=this.h(g,b.scope),V={variable:g,...b,options:q};this.map.set(G,V),this.f.fire()}}get(g,b){const F=this.h(g,b),T=this.map.get(F);return T?S(T):void 0}h(g,b){const F=this.j(b);return F.length?`${g}:::${F}`:g}j(g){return this.m(g?.workspaceFolder)??""}m(g){return g?g.uri.toString():void 0}getVariableMap(g){const b=new Map;for(const[F,T]of this.map)this.j(T.scope)===this.j(g)&&b.set(T.variable,S(T));return b}delete(g,b){const F=this.h(g,b);this.map.delete(F),this.f.fire()}clear(g){if(g?.workspaceFolder){for(const[b,F]of this.map)F.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(b);this.n(g)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(g,b){const F=this.j(b),T=this.descriptionMap.get(F);if(!T||T.description!==g){let q;typeof g=="string"?q=g:q=g?.value.split(`

`)[0];const G={description:q,scope:b};this.descriptionMap.set(F,G),this.f.fire()}}getDescription(g){const b=this.j(g);return this.descriptionMap.get(b)?.description}n(g){const b=this.j(g);this.descriptionMap.delete(b)}}class ${get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,b){this.b=g,this.d=b,this.a=new w.$le}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,b,F){this.b.replace(g,b,F,this.d)}append(g,b,F){this.b.append(g,b,F,this.d)}prepend(g,b,F){this.b.prepend(g,b,F,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,b){this.b.getVariableMap(this.d).forEach((F,T)=>g.call(b,T,F,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends f{constructor(g,b){super(!1,g,b)}createTerminal(g,b,F){throw new R.$ab}createTerminalFromOptions(g,b){throw new R.$ab}};e.$1nc=I,e.$1nc=I=He([We(0,n.$QP),We(1,A.$uP)],I);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function y(k){return o.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const g={...k};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[125],Ie([1,0,7,5,3,6,17,57,4,2,11]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=e.$0oc=void 0,e.$0oc=(0,P.$Ei)("IExtHostTerminalShellIntegration");let v=class extends C.$Vc{constructor(o,a){super(),this.h=a,this.b=new Map,this.c=new p.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(M.$1M.MainThreadTerminalShellIntegration),this.B((0,C.$Tc)(()=>{for(const[h,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const a=this.h.getTerminalById(o);if(!a)return;const h=a.value;let n=this.b.get(o);n||(n=new l(a.value,this.f),this.b.set(o,n),n.store.add(a.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),n.store.add(n.onDidRequestEndExecution(s=>this.g.fire(s))),n.store.add(n.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=n.value),this.c.fire({terminal:h,shellIntegration:n.value})}$shellExecutionStart(o,a,h,n,s){this.b.has(o)||this.$shellIntegrationChange(o);const i={value:a,confidence:h,isTrusted:n};this.b.get(o)?.startShellExecution(i,s)}$shellExecutionEnd(o,a,h,n,s){const i={value:a,confidence:h,isTrusted:n};this.b.get(o)?.endShellExecution(i,s)}$shellExecutionData(o,a){this.b.get(o)?.emitData(a)}$cwdChange(o,a){this.b.get(o)?.setCwd((0,c.$wc)(a)?c.URI.revive(a):a)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$$oc=v,e.$$oc=v=He([We(0,A.$uP),We(1,N.$Xnc)],v);class l extends C.$Vc{get currentExecution(){return this.a}constructor(o,a){super(),this.j=o,this.m=a,this.b=!1,this.store=this.B(new C.$Uc),this.f=this.B(new p.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$le),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(n,s){let i=n;s&&(i+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(i);const t={value:i,confidence:w.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},m=h.startShellExecution(t,h.c,!0).value;return h.b=!0,m}}}startShellExecution(o,a,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new E(o,a);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(o){let a=!1;c.URI.isUri(this.c)?a=!c.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(a=!0),a&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(o,a){this.c=o,this.cwd=a,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return R.$5h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends C.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Dh);const o=this.a;return new R.$5h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const a of this.b)a.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[126],Ie([1,0,62,14,97,10,7]),function(oe,e,w,C,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=void 0,M=qe(M);class N{static{this.c=new P.$zP("TextEditorDecorationType")}constructor(l,E,d){const r=N.c.nextId();l.$registerTextEditorDecorationType(E.identifier,r,M.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$BP=N;class p{constructor(l,E){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,E){this.k();let d=null;if(l instanceof A.$4M)d=new A.$5M(l,l);else if(l instanceof A.$5M)d=l;else throw new Error("Unrecognized location");this.l(d,E,!1)}insert(l,E){this.k(),this.l(new A.$5M(l,l),E,!0)}delete(l){this.k();let E=null;if(l instanceof A.$5M)E=l;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(l,E,d){const r=this.c.validateRange(l);this.g.push({range:r,text:E,forceMoveMarkers:d})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,C.$8)("endOfLine");this.h=l}}class c{constructor(l,E,d,r){this.c=l,this.d=E,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(a){o.n(a)},get indentSize(){return o.g},set indentSize(a){o.p(a)},get insertSpaces(){return o.j},set insertSpaces(a){o.s(a)},get cursorStyle(){return o.k},set cursorStyle(a){o.t(a)},get lineNumbers(){return o.l},set lineNumbers(a){o.u(a)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}n(l){const E=this.m(l);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}p(l){const E=this.o(l);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const E=this.q(l);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const E={};let d=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(d=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,E.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(d=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,E.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(d=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,E.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,d=!0,E.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,d=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(l,E){E.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(d)})}}e.$CP=c;class R{constructor(l,E,d,r,o,a,h,n){this.id=l,this.j=E,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new c(this.j,this.id,a,d),this.e=h,this.f=n;const s=this;this.value=Object.freeze({get document(){return r.value},set document(i){throw new C.$0("document")},get selection(){return s.c&&s.c[0]},set selection(i){if(!(i instanceof A.$6M))throw(0,C.$8)("selection");s.c=[i],s.l()},get selections(){return s.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof A.$6M)))throw(0,C.$8)("selections");s.c=i,s.l()},get visibleRanges(){return s.e},set visibleRanges(i){throw new C.$0("visibleRanges")},get options(){return s.d.value},set options(i){s.g||s.d.assign(i)},get viewColumn(){return s.f},set viewColumn(i){throw new C.$0("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const m=new p(r.value,t);return i(m),s.m(m)},insertSnippet(i,t,m={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!t||Array.isArray(t)&&t.length===0)f=s.c.map(u=>M.Range.from(u));else if(t instanceof A.$4M){const{lineNumber:u,column:$}=M.Position.from(t);f=[{startLineNumber:u,startColumn:$,endLineNumber:u,endColumn:$}]}else if(t instanceof A.$5M)f=[M.Range.from(t)];else{f=[];for(const u of t)if(u instanceof A.$5M)f.push(M.Range.from(u));else{const{lineNumber:$,column:I}=M.Position.from(u);f.push({startLineNumber:$,startColumn:I,endLineNumber:$,endColumn:I})}}return E.$tryInsertSnippet(l,r.value.version,i.value,f,m)},setDecorations(i,t){const m=t.length===0;m&&!s.h.has(i.key)||(m?s.h.delete(i.key):s.h.add(i.key),s.n(()=>{if(M.$rP(t))return E.$trySetDecorations(l,i.key,M.$sP(t));{const f=new Array(4*t.length);for(let u=0,$=t.length;u<$;u++){const I=t[u];f[4*u]=I.start.line+1,f[4*u+1]=I.start.character+1,f[4*u+2]=I.end.line+1,f[4*u+3]=I.end.character+1}return E.$trySetDecorationsFast(l,i.key,f)}}))},revealRange(i,t){s.n(()=>E.$tryRevealRange(l,M.Range.from(i),t||A.TextEditorRevealType.Default))},show(i){E.$tryShowEditor(l,M.ViewColumn.from(i))},hide(){E.$tryHideEditor(l)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,w.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,w.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,w.ok)(!this.g),this.f=l}_acceptSelections(l){(0,w.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const E=l.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const d=E.edits.map(o=>o.range);d.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=d.length-1;o<a;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$DP=R}),define(Ce[58],Ie([1,0,62,4,5,2,3,6,122,17,126,10,12,29,16,40,47]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=void 0,w=qe(w),v=qe(v);class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(s,i){this.h=s,this.i=i,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new C.$le,this.e=new C.$le,this.f=new C.$le,this.g=new C.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const i=[],t=[],m=[];if(s.removedDocuments)for(const f of s.removedDocuments){const u=M.URI.revive(f),$=this.c.get(u);$?.unref()&&(this.c.delete(u),i.push($.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const u=M.URI.revive(f.uri);let $=this.c.get(u);if($&&u.scheme!==d.Schemas.vscodeNotebookCell&&u.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);$||($=new a(new p.$xP(this.h.getProxy(N.$1M.MainThreadDocuments),u,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(u,$),t.push($.value)),$.ref()}if(s.removedEditors)for(const f of s.removedEditors){const u=this.b.get(f);this.b.delete(f),u&&m.push(u)}if(s.addedEditors)for(const f of s.addedEditors){const u=M.URI.revive(f.documentUri);w.ok(this.c.has(u),`document '${u}' does not exist`),w.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const $=this.c.get(u).value,I=new R.$DP(f.id,this.h.getProxy(N.$1M.MainThreadTextEditors),this.i,new o.$W(()=>$.document),f.selections.map(v.Selection.to),f.options,f.visibleRanges.map(D=>v.Range.to(D)),typeof f.editorPosition=="number"?v.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,I)}s.newActiveEditor!==void 0&&(w.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,P.$Qc)(i),(0,P.$Qc)(m),s.removedDocuments&&this.e.fire(i),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const i=this.b.get(this.a);return s?i:i?.value}allEditors(){return[...this.b.values()]}};e.$EP=h,e.$EP=h=He([We(0,c.$uP),We(1,l.$$j)],h),e.$FP=(0,A.$Ei)("IExtHostDocumentsAndEditors")}),define(Ce[96],Ie([1,0,11,23,22,4,273,76,5,38,15,37,3,12,6,34,58,17,124,10,7,241,55,82,56,25]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=e.$ioc=e.$hoc=e.$goc=e.$foc=void 0,n=qe(n);let $=0;const I=new WeakMap;e.$foc=(0,l.$Ei)("IExtHostTesting");let D=class extends p.$Vc{constructor(te,me,se,de){super(),this.C=me,this.D=se,this.F=de,this.f=this.B(new M.$le),this.g=new Map,this.w=this.B(new M.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=te.getProxy(d.$1M.MainThreadTesting),this.m=new G(this.h),this.j=new g(this.h,me),se.registerArgumentProcessor({processArgument:be=>{switch(be?.$mid){case c.MarshalledId.TestItemContext:{const re=be,Pe=re.tests[re.tests.length-1].item.extId;return this.g.get(t.$OI.root(Pe))?.collection.tree.get(Pe)?.actual??(0,h.$GP)(be)}case c.MarshalledId.TestMessageMenuArgs:{const{test:re,message:Pe}=be,Fe=re.item.extId;return{test:this.g.get(t.$OI.root(Fe))?.collection.tree.get(Fe)?.actual??(0,h.$GP)({$mid:c.MarshalledId.TestItemContext,tests:[re]}),message:n.TestMessage.to(Pe)}}default:return be}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const be=await se.executeCommand(i.TestCommandId.GetExplorerSelection),re=Pe=>{const Fe=this.g.get(t.$OI.root(Pe));if(Fe)return t.$OI.isRoot(Pe)?Fe.controller:Fe.collection.tree.get(Pe)?.actual};return{include:be?.include.map(re).filter(R.$mg)||[],exclude:be?.exclude.map(re).filter(R.$mg)||[]}})}createTestController(te,me,se,de){if(this.g.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const be=new p.$Uc,re=be.add(new h.$JP(me,se,this.F));re.root.label=se;const Pe=new Map,Fe=new Set,X=this.h,B={items:re.root.children,get label(){return se},set label(we){se=we,re.root.label=we,X.$updateController(me,{label:se})},get refreshHandler(){return de},set refreshHandler(we){de=we,X.$updateController(me,{canRefresh:!!we})},get id(){return me},createRunProfile:(we,ae,ve,ue,Z,Y)=>{let pe=(0,N.$sj)(we);for(;Pe.has(pe);)pe++;return new O(this.h,Pe,Fe,this.w.event,me,pe,we,ae,ve,ue,Z,Y)},createTestItem(we,ae,ve){return new h.$HP(me,we,ae,ve)},createTestRun:(we,ae,ve=!0)=>this.j.createTestRun(te,me,re,we,ae,ve),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const ae=we instanceof Array?we:[we];this.h.$markTestRetired(ae.map(ve=>t.$OI.fromExtHostTestItem(ve,me).toString()))}},set resolveHandler(we){re.resolveHandler=we},get resolveHandler(){return re.resolveHandler},dispose:()=>{be.dispose()}};X.$registerTestController(me,se,!!de),be.add((0,p.$Tc)(()=>X.$unregisterTestController(me)));const _={controller:B,collection:re,profiles:Pe,extension:te,activeProfiles:Fe};return this.g.set(me,_),be.add((0,p.$Tc)(()=>this.g.delete(me))),be.add(re.onDidGenerateDiff(we=>X.$publishDiff(me,we.map(f.TestsDiffOp.serialize)))),B}createTestObserver(){return this.m.checkout()}async runTests(te,me=P.CancellationToken.None){const se=b(te);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const de=this.g.get(se.controllerId);if(!de)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:te.preserveFocus??!0,group:W[se.kind],targets:[{testIds:te.include?.map(be=>t.$OI.fromExtHostTestItem(be,de.collection.root.id).toString())??[de.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:te.exclude?.map(be=>be.id)},me)}registerTestFollowupProvider(te){return this.y.add(te),{dispose:()=>{this.y.delete(te)}}}$syncTests(){for(const{collection:te}of this.g.values())te.flushDiff();return Promise.resolve()}async $getCoverageDetails(te,me){return(await this.j.getCoverageDetails(te,me))?.map(n.TestCoverage.fromDetails)}async $disposeRun(te){this.j.disposeTestRun(te)}$configureRunProfile(te,me){this.g.get(te)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(te){const me=new Map;for(const[se,de]of Object.entries(te)){const be=this.g.get(se);if(!be)continue;const re=new Map,Pe=de.filter(X=>!be.activeProfiles.has(X)),Fe=[...be.activeProfiles].filter(X=>!de.includes(X));for(const X of Pe)re.set(X,!0),be.activeProfiles.add(X);for(const X of Fe)re.set(X,!1),be.activeProfiles.delete(X);re.size&&me.set(se,re)}this.w.fire(me)}async $refreshTests(te,me){await this.g.get(te)?.controller.refreshHandler?.(me)}$publishTestResults(te){this.results=Object.freeze(te.map(me=>{const se=n.TestResults.to(me);return I.set(se,me.id),se}).concat(this.results).sort((me,se)=>se.completedAt-me.completedAt).slice(0,32)),this.f.fire()}async $expandTest(te,me){const se=this.g.get(t.$OI.fromString(te).controllerId)?.collection;se&&(await se.expand(te,me<0?1/0:me),se.flushDiff())}$acceptDiff(te){this.m.applyDiff(te.map(me=>f.TestsDiffOp.deserialize({asCanonicalUri:se=>se},me)))}async $runControllerTests(te,me){return Promise.all(te.map(se=>this.G(se,!1,me)))}async $startContinuousRun(te,me){const se=new P.$we(me),de=await Promise.all(te.map(be=>this.G(be,!0,se.token)));return!me.isCancellationRequested&&!de.some(be=>be.error)&&await new Promise(be=>me.onCancellationRequested(be)),se.dispose(!0),de}async $provideTestFollowups(te,me){const se=this.results.find(re=>I.get(re)===te.resultId),de=se&&ce(t.$OI.fromString(te.extId),se?.results);if(!de)return[];let be=[];return await Promise.all([...this.y].map(async re=>{try{const Pe=await re.provideFollowup(se,de,te.taskIndex,te.messageIndex,me);Pe&&(be=be.concat(Pe))}catch(Pe){this.C.error("Error thrown while providing followup for test message",Pe)}})),me.isCancellationRequested?[]:be.map(re=>{const Pe=$++;return this.z.set(Pe,re),{title:re.title,id:Pe}})}$disposeTestFollowups(te){for(const me of te)this.z.delete(me)}$executeTestFollowup(te){const me=this.z.get(te);return me?this.D.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(te){te===void 0?this.j.cancelAllRuns():this.j.cancelRunById(te)}getMetadataForRun(te){for(const me of this.j.trackers){const se=me.getTaskIdForRun(te);return se?{taskId:se,runId:me.id}:void 0}}async G(te,me,se){const de=this.g.get(te.controllerId);if(!de)return{};const{collection:be,profiles:re,extension:Pe}=de,Fe=re.get(te.profileId);if(!Fe)return{};const X=te.testIds.map(ae=>be.tree.get(ae)).filter(R.$mg),B=te.excludeExtIds.map(ae=>de.collection.tree.get(ae)).filter(R.$mg).filter(ae=>X.some(ve=>ve.fullId.compare(ae.fullId)===t.TestPosition.IsChild));if(!X.length)return{};const _=new s.$DO(X.some(ae=>ae.actual instanceof h.$IP)?void 0:X.map(ae=>ae.actual),B.map(ae=>ae.actual),Fe,me),we=(0,f.$RI)(te)&&this.j.prepareForMainThreadTestRun(Pe,_,F.fromInternal(te,de.collection),Fe,se);try{return await Fe.runHandler(_,se),{}}catch(ae){return{error:String(ae)}}finally{we&&we.hasRunningTasks&&!se.isCancellationRequested&&await M.Event.toPromise(we.onEnd)}}};e.$goc=D,e.$goc=D=He([We(0,a.$uP),We(1,E.$$j),We(2,r.$QP),We(3,o.$FP)],D);const y=1e4;var S;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(S||(S={}));class k extends p.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(te,me,se,de,be,re){super(),this.z=te,this.C=me,this.D=se,this.F=de,this.G=be,this.c=S.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new M.$le),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$we(re));const Pe=this.B(new w.$Qh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>Pe.schedule()));const Fe=new M.$le;this.w=Fe.event,this.B((0,p.$Tc)(()=>{Fe.fire(),Fe.dispose()}))}getTaskIdForRun(te){for(const[me,{run:se}]of this.g)if(se===te)return me}cancel(){this.c===S.Running?(this.j.cancel(),this.c=S.Cancelling):this.c===S.Cancelling&&this.H()}getCoverageDetails(te,me){const[,se]=t.$OI.fromString(te).path,de=this.y.get(te);if(!de)return[];const be=this.g.get(se);if(!be)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(be.run,de,me)??[]}createRun(te){const me=this.z.id,se=this.z.controllerId,de=(0,v.$1g)(),be=B=>(_,...we)=>{if(Pe){this.D.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.J(_),B(_,...we)},re=(B,_)=>{const we=_ instanceof Array?_.map(n.TestMessage.from):[n.TestMessage.from(_)];if(B.uri&&B.range){const ae={range:n.Range.from(B.range),uri:B.uri};for(const ve of we)ve.location=ve.location||ae}this.C.$appendTestMessagesInRun(me,de,t.$OI.fromExtHostTestItem(B,se).toString(),we)};let Pe=!1;const Fe=new Map,X={isPersisted:this.z.isPersisted,token:this.j.token,name:te,onDidDispose:this.w,addCoverage:B=>{if(Pe)return;const _=B instanceof s.$IO?B.testItem:void 0;let we;_&&((0,u.$4G)(this.G,"attributableCoverage"),this.J(_),we=Fe.get(_),we===void 0&&(we=Fe.size,Fe.set(_,we)));const ae=B.uri.toString(),ve=new t.$OI(we!==void 0?[me,de,ae,String(we)]:[me,de,ae]).toString();this.y.set(ve,B),this.C.$appendCoverage(me,de,n.TestCoverage.fromFile(se,ve,B))},enqueued:be(B=>{this.C.$updateTestStateInRun(me,de,t.$OI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Queued)}),skipped:be(B=>{this.C.$updateTestStateInRun(me,de,t.$OI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Skipped)}),started:be(B=>{this.C.$updateTestStateInRun(me,de,t.$OI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Running)}),errored:be((B,_,we)=>{re(B,_),this.C.$updateTestStateInRun(me,de,t.$OI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Errored,we)}),failed:be((B,_,we)=>{re(B,_),this.C.$updateTestStateInRun(me,de,t.$OI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Failed,we)}),passed:be((B,_)=>{this.C.$updateTestStateInRun(me,de,t.$OI.fromExtHostTestItem(B,this.z.controllerId).toString(),f.TestResultState.Passed,_)}),appendOutput:(B,_,we)=>{Pe||(we&&this.J(we),this.C.$appendOutputToRun(me,de,C.$Ne.fromString(B),_&&n.location.from(_),we&&t.$OI.fromExtHostTestItem(we,se).toString()))},end:()=>{Pe||(Pe=!0,Fe.clear(),this.C.$finishedTestRunTask(me,de),--this.f||this.I())}};return this.f++,this.g.set(de,{run:X}),this.C.$startedTestRunTask(me,{id:de,name:te,running:!0}),X}H(){for(const{run:te}of this.g.values())te.end()}I(){this.c!==S.Ended&&(this.c=S.Ended,this.m.fire())}J(te){if(!(te instanceof h.$HP))throw new m.$mP(te.id);if(this.h.has(t.$OI.fromExtHostTestItem(te,this.z.controllerId).toString()))return;const me=[],se=this.z.colllection.root;for(;;){const de=n.TestItem.from(te);if(me.unshift(de),this.h.has(de.extId)||(this.h.add(de.extId),te===se))break;te=te.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,me)}dispose(){this.I(),super.dispose()}}class g{get trackers(){return this.c.values()}constructor(te,me){this.g=te,this.h=me,this.c=new Map,this.f=new Map}getCoverageDetails(te,me){const se=t.$OI.root(te);return this.f.get(se)?.getCoverageDetails(te,me)||[]}disposeTestRun(te){this.f.get(te)?.dispose(),this.f.delete(te);for(const[me,{id:se}]of this.c)se===te&&this.c.delete(me)}prepareForMainThreadTestRun(te,me,se,de,be){return this.j(me,se,de,te,be)}cancelRunById(te){this.f.get(te)?.cancel()}cancelAllRuns(){for(const te of this.c.values())te.cancel()}createTestRun(te,me,se,de,be,re){const Pe=this.c.get(de);if(Pe)return Pe.createRun(be);const Fe=F.fromPublic(me,se,de,re),X=b(de);this.g.$startedExtensionTestRun({controllerId:me,continuous:!!de.continuous,profile:X&&{group:W[X.kind],id:X.profileId},exclude:de.exclude?.map(_=>t.$OI.fromExtHostTestItem(_,se.root.id).toString())??[],id:Fe.id,include:de.include?.map(_=>t.$OI.fromExtHostTestItem(_,se.root.id).toString())??[se.root.id],preserveFocus:de.preserveFocus??!0,persist:re});const B=this.j(de,Fe,de.profile,te);return M.Event.once(B.onEnd)(()=>{this.g.$finishedExtensionTestRun(Fe.id)}),B.createRun(be)}j(te,me,se,de,be){const re=new k(me,this.g,this.h,se,de,be);return this.c.set(te,re),this.f.set(re.id,re),re}}e.$hoc=g;const b=ge=>{if(ge.profile){if(!(ge.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class F{static fromPublic(te,me,se,de){return new F(te,(0,v.$1g)(),de,me)}static fromInternal(te,me){return new F(te.controllerId,te.runId,!0,me)}constructor(te,me,se,de){this.controllerId=te,this.id=me,this.isPersisted=se,this.colllection=de}}e.$ioc=F;class T{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(te){this.j=te,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(te){this.c.add(te)}update(te){Object.assign(te.revived,n.TestItem.toPlain(te.item)),this.c.has(te)||this.f.add(te)}remove(te){if(this.c.has(te)){this.c.delete(te);return}this.f.delete(te);const me=t.$OI.parentId(te.item.extId);if(me&&this.h.has(me.toString())){this.h.add(te.item.extId);return}this.g.add(te)}getChangeEvent(){const{c:te,f:me,g:se}=this;return{get added(){return[...te].map(de=>de.revived)},get updated(){return[...me].map(de=>de.revived)},get removed(){return[...se].map(de=>de.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class q extends f.$XI{constructor(){super(...arguments),this.y=new M.$le,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(te){return this.f.get(te)}getMirroredTestDataByReference(te){return this.f.get(te.id)}x(te,me){return{...te,revived:n.TestItem.toPlain(te.item),depth:me?me.depth+1:0,children:new Set}}w(){return new T(this.y)}}class G{constructor(te){this.f=te}checkout(){this.c||(this.c=this.g());const te=this.c;return te.observers++,{onDidChangeTest:te.tests.onDidChangeTests,get tests(){return[...te.tests.rootTests].map(me=>me.revived)},dispose:(0,A.$eb)(()=>{--te.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(te){return this.c?.tests.getMirroredTestDataByReference(te)}applyDiff(te){this.c?.tests.apply(te)}g(){const te=new q({asCanonicalUri:me=>me});return this.f.$subscribeToDiffs(),{observers:0,tests:te}}}const V=(ge,te,me,se)=>{me?Object.assign(me,se):te.$updateTestRunConfig(ge.controllerId,ge.profileId,se)};class O{#e;#t;#i;#n;#s;get label(){return this.f}set label(te){te!==this.f&&(this.f=te,V(this,this.#e,this.#n,{label:te}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(te){te!==this.g&&(this.g=te,V(this,this.#e,this.#n,{supportsContinuousRun:te}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(te){te!==this.isDefault&&(te?this.#t.add(this.profileId):this.#t.delete(this.profileId),V(this,this.#e,this.#n,{isDefault:te}))}get tag(){return this._tag}set tag(te){te?.id!==this._tag?.id&&(this._tag=te,V(this,this.#e,this.#n,{tag:te?n.TestTag.namespace(this.controllerId,te.id):null}))}get configureHandler(){return this.c}set configureHandler(te){te!==this.c&&(this.c=te,V(this,this.#e,this.#n,{hasConfigurationHandler:!!te}))}get onDidChangeDefault(){return M.Event.chain(this.#i,te=>te.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(R.$mg))}constructor(te,me,se,de,be,re,Pe,Fe,X,B=!1,_=void 0,we=!1){this.controllerId=be,this.profileId=re,this.f=Pe,this.kind=Fe,this.runHandler=X,this._tag=_,this.g=we,this.#e=te,this.#s=me,this.#t=se,this.#i=de,me.set(re,this);const ae=W[Fe];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Fe}`);B&&se.add(re),this.#n={profileId:re,controllerId:be,tag:_?n.TestTag.namespace(this.controllerId,_.id):null,label:Pe,group:ae,isDefault:B,hasConfigurationHandler:!1,supportsContinuousRun:we},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$joc=O;const W={[s.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[s.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[s.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function ce(ge,te){for(let me=0;me<ge.path.length;me++){const se=te.find(de=>de.id===ge.path[me]);if(!se)return;if(me===ge.path.length-1)return se;te=se.children}}}),define(Ce[300],Ie([1,0,18,4,5,6,126,10,7]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0,w=qe(w),N=qe(N);class c extends P.$Vc{constructor(v,l){super(),this.m=l,this.a=new C.$le,this.b=new C.$le,this.c=new C.$le,this.f=new C.$le,this.g=new C.$le,this.h=new C.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=v.getProxy(M.$1M.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(v){const l=this.m.allEditors();return v?l:l.map(E=>E.value)}async showTextDocument(v,l,E){let d;typeof l=="number"?d={position:N.ViewColumn.from(l),preserveFocus:E}:typeof l=="object"?d={position:N.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?N.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(v.uri,d),o=r&&this.m.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}createTextEditorDecorationType(v,l){return new A.$BP(this.j,v,l).value}$acceptEditorPropertiesChanged(v,l){const E=this.m.getEditor(v);if(!E)throw new Error("unknown text editor");if(l.options&&E._acceptOptions(l.options),l.selections){const d=l.selections.selections.map(N.Selection.to);E._acceptSelections(d)}if(l.visibleRanges){const d=w.$Ib(l.visibleRanges.map(N.Range.to));E._acceptVisibleRanges(d)}if(l.options&&this.b.fire({textEditor:E.value,options:{...l.options,lineNumbers:N.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const d=p.TextEditorSelectionChangeKind.fromValue(l.selections.source),r=l.selections.selections.map(N.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:d})}if(l.visibleRanges){const d=w.$Ib(l.visibleRanges.map(N.Range.to));this.c.fire({textEditor:E.value,visibleRanges:d})}}$acceptEditorPositionData(v){for(const l in v){const E=this.m.getEditor(l);if(!E)throw new Error("Unknown text editor");const d=N.ViewColumn.to(v[l]);E.value.viewColumn!==d&&(E._acceptViewColumn(d),this.f.fire({textEditor:E.value,viewColumn:d}))}}getDiffInformation(v){return Promise.resolve(this.j.$getDiffInformation(v))}}e.$qnc=c}),define(Ce[301],Ie([1,0,2,3,6,5,7,10,19,38,15]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=e.$apc=void 0,e.$apc=(0,C.$Ei)("IExtHostTimeline");class v{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$1M.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&p.$pn.equals(a,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:w.URI.revive(o.uri);return this.c.get(o.source)?.get(l(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,a){return this.b.get(d)?.provider.provideTimeline(w.URI.revive(r),o,a)}registerTimelineProvider(d,r,o,a){const h=new M.$Uc,n=this.d(r.id,a,h).bind(this);let s;r.onDidChange&&(s=r.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:r.id}),this));const i=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(t,m,f){m?.resetCache&&(h.clear(),i.get(r.id)?.clear());const u=await r.provideTimeline(t,m,f);if(u==null)return;const $=n(t,m);return{...u,source:r.id,items:u.items.map($)}},dispose(){for(const t of i.values())t.get(r.id)?.clear();s?.dispose(),h.dispose()}},o)}d(d,r,o){return(a,h)=>{let n;if(h?.cacheResults){let s=this.c.get(d);s===void 0&&(s=new Map,this.c.set(d,s));const i=l(a);n=s.get(i),n===void 0&&(n=new Map,s.set(i,n))}return s=>{const{iconPath:i,...t}=s,m=`${d}|${s.id??s.timestamp}`;n?.set(m,s);let f,u,$;s.iconPath&&(i instanceof A.$ZN?$={id:i.id,color:i.color}:w.URI.isUri(i)?(f=i,u=i):{light:f,dark:u}=i);let I;return A.$sN.isMarkdownString(t.tooltip)?I=N.MarkdownString.from(t.tooltip):(0,R.$eg)(t.tooltip)?I=t.tooltip:A.$sN.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=N.MarkdownString.from(t.detail)):(0,R.$eg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=t.detail),{...t,id:t.id??void 0,handle:m,source:d,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:u,themeIcon:$,tooltip:I,accessibilityInformation:s.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,M.$Tc)(()=>{for(const a of this.c.values())a.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$bpc=v;function l(E){return E?.toString()}}),define(Ce[302],Ie([1,0,189,24,2,4,5,232,11,7,15,18,10,60,22,153,25]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0,c=qe(c);function a(s,i){if((0,R.$eg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class h extends A.$Vc{constructor(i,t,m){super(),this.f=i,this.g=t,this.h=m,this.a=new Map,this.b=new r.$K$;function f(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>f(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map($=>f($)?this.r($):$):u})}registerTreeDataProvider(i,t,m){const f=this.createTreeView(i,{treeDataProvider:t},m);return{dispose:()=>f.dispose()}}createTreeView(i,t,m){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,I=!!t.dragAndDropController?.handleDrop,D=this.m(i,t,m),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:f,dragMimeTypes:u,hasHandleDrag:$,hasHandleDrop:I,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},S=this.f.$registerTreeViewDataProvider(i,y),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$4G)(m,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$4G)(m,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,E.$4k)(g)&&(0,o.$4G)(m,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&c.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,b)=>D.reveal(g,b),dispose:async()=>{await S,this.a.delete(i),D.dispose()}};return this.B(k),k}$getChildren(i,t){const m=this.a.get(i);return m?m.getChildren(t):Promise.reject(new N.$mG(i))}async $handleDrop(i,t,m,f,u,$,I,D){const y=this.a.get(i);if(!y)return Promise.reject(new N.$mG(i));const S=l.DataTransfer.toDataTransfer(m,async k=>(await this.f.$resolveDropFileData(i,t,k)).buffer);return I===i&&D&&await this.j(S,y,D,u,$),y.onDrop(S,f,u)}async j(i,t,m,f,u){const $=this.b.removeDragOperationTransfer(u);if($)(await $)?.forEach((I,D)=>{I&&i.set(D,I)});else if(u&&t.handleDrag){const I=t.handleDrag(m,i,f);this.b.addDragOperationTransfer(u,I),await I}return i}async $handleDrag(i,t,m,f){const u=this.a.get(i);if(!u)return Promise.reject(new N.$mG(i));const $=await this.j(new c.$VN,u,t,f,m);if(!(!$||f.isCancellationRequested))return l.DataTransfer.from($)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new N.$mG(i);return t.hasResolve}$resolve(i,t,m){const f=this.a.get(i);if(!f)throw new N.$mG(i);return f.resolveTreeItem(t,m)}$setExpanded(i,t,m){const f=this.a.get(i);if(!f)throw new N.$mG(i);f.setExpanded(t,m)}$setSelectionAndFocus(i,t,m){const f=this.a.get(i);if(!f)throw new N.$mG(i);f.setSelectionAndFocus(t,m)}$setVisible(i,t){const m=this.a.get(i);if(!m){if(!t)return;throw new N.$mG(i)}m.setVisible(t)}$changeCheckboxState(i,t){const m=this.a.get(i);if(!m)throw new N.$mG(i);m.setCheckboxState(t)}m(i,t,m){const f=this.B(new n(i,t,this.f,this.g.converter,this.h,m));return this.a.set(i,f),f}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$cpc=h;class n extends A.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,R.$ng)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,m,f,u,$){if(super(),this.I=i,this.J=m,this.L=f,this.M=u,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$we,$.contributes&&$.contributes.views)for(const S in $.contributes.views)for(const k of $.contributes.views[S])k.id===i&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(S=>{Array.isArray(S)&&S.length===0||this.F.fire({message:!1,element:S})}));let I,D;const y=M.Event.debounce(this.F.event,(S,k)=>(S||(S={message:!1,elements:[]}),k.element!==!1&&(I||(I=new Promise(g=>D=g),this.G=this.G.then(()=>I)),Array.isArray(k.element)?S.elements.push(...k.element):S.elements.push(k.element)),k.message&&(S.message=!0),S),200,!0);this.B(y(({message:S,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const g=D;return I=null,this.$(k).then(()=>g())})),S&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let m=this.X(i);return m||(m=await this.Y(t)),m?m.map(f=>f.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const m=(0,R.$ng)(t.select)?!0:t.select,f=(0,R.$ng)(t.focus)?!1:t.focus,u=(0,R.$ng)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then($=>this.W(i,$[$.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:$.map(D=>D.item)},{select:m,focus:f,expand:u})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:m,focus:f,expand:u})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=l.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const m=this.getExtensionElement(i);m&&(t?this.u.fire(Object.freeze({element:m})):this.w.fire(Object.freeze({element:m})))}setSelectionAndFocus(i,t){const m=!(0,v.$vb)(this.s,i);this.s=i;const f=this.t!==t;this.t=t,m&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async m=>{const f=this.getExtensionElement(m.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:m.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(m=>m!==void 0);t.forEach(m=>{m.treeItem.checkboxState=m.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(m=>[m.extensionItem,m.newState])})}async handleDrag(i,t,m){const f=[];for(const u of i){const $=this.getExtensionElement(u);$&&f.push($)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,t,m),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,m){const f=t?this.getExtensionElement(t):void 0;if(!(!f&&t||!this.g?.handleDrop))return(0,p.$wh)(()=>this.g?.handleDrop?this.g.handleDrop(f,i,m):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const m=this.j.get(i);if(m){const f=this.m.get(m);if(f){const u=await this.f.resolveTreeItem(f.extensionItem,m,t)??f.extensionItem;return this.hb(u),f.item.tooltip=this.eb(u.tooltip),f.item.command=this.fb(f.disposableStore,u.command),f.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(m=>this.W(t,m[m.length-1]).then(f=>(m.push(f),m))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$wh)(()=>this.f.getParent(i))}W(i,t){const m=this.m.get(i);return m?Promise.resolve(m):(0,p.$wh)(()=>this.f.getTreeItem(i)).then(f=>this.kb(i,f,t,!0)).then(f=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(f);if(u){const $=this.m.get(u);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const m=this.getExtensionElement(i);t=m?this.m.get(m):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new d.$we(this.Z.token);try{const m=i?this.m.get(i):void 0,f=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const u=(0,v.$Ib)(f||[]),$=await Promise.all((0,v.$Ib)(u).map(D=>this.f.getTreeItem(D)));if(t.token.isCancellationRequested)return;const I=$.map((D,y)=>D?this.db(u[y],D,m):null);return(0,v.$Ib)(I)}finally{t.dispose()}}$(i){if(i.some(m=>!m))return this.Z.dispose(!0),this.Z=new d.$we,this.tb(),this.J.$refresh(this.I);{const m=this.ab(i);if(m.length)return this.bb(m)}return Promise.resolve(void 0)}ab(i){const t=new Set,m=i.map(u=>this.m.get(u));for(const u of m)if(u&&!t.has(u.item.handle)){let $=u;for(;$&&$.parent&&m.findIndex(I=>$&&$.parent&&I&&I.item.handle===$.parent.item.handle)===-1;){const I=this.j.get($.parent.item.handle);$=I?this.m.get(I):void 0}$&&!$.parent&&t.add(u.item.handle)}const f=[];return t.forEach(u=>{const $=this.j.get(u);if($){const I=this.m.get($);I&&(!I.parent||!t.has(I.parent.item.handle))&&f.push(u)}}),f}bb(i){const t={};return Promise.all(i.map(m=>this.cb(m).then(f=>{f&&(t[m]=f.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const m=this.m.get(t);if(m)return this.rb(t),(0,p.$wh)(()=>this.f.getTreeItem(t)).then(f=>{if(f){const u=this.ib(t,f,m.parent);return this.pb(t,u,m,m.parent),m.dispose(),u}return null})}return Promise.resolve(null)}db(i,t,m){const f=this.ib(i,t,m);if(t.id&&this.j.has(f.item.handle))throw new Error((0,w.localize)(0,null,t.id));return this.ob(i,f),this.qb(f,m),f}eb(i){return c.$sN.isMarkdownString(i)?l.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,m,f;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,m=i.checkboxState.tooltip,f=i.checkboxState.accessibilityInformation),{isChecked:t===c.TreeItemCheckboxState.Checked,tooltip:m,accessibilityInformation:f}}hb(i){if(!c.$QN.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,m){this.hb(t);const f=this.B(new A.$Uc),u=this.kb(i,t,m),$=this.lb(t);return{item:{handle:u,parentHandle:m?m.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(f,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,R.$ng)(t.collapsibleState)?c.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:m,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(i){return i.iconPath instanceof c.$ZN?i.iconPath:void 0}kb(i,{id:t,label:m,resourceUri:f},u,$){if(t)return`${n.b}/${t}`;const I=a(m,this.N),D=u?u.item.handle:n.a;let y=I?I.label:f?(0,C.$ch)(f):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const S=this.m.has(i)?this.m.get(i).item.handle:void 0,k=this.X(u)||[];let g,b=0;do{if(g=`${D}/${b}:${y}`,$||!this.j.has(g)||S===g)break;b++}while(b<=k.length);return g}lb(i){if(i.iconPath&&!(i.iconPath instanceof c.$ZN))return typeof i.iconPath=="string"||P.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof c.$ZN)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return P.URI.isUri(i)?i:P.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,m,f){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==m.item.handle&&this.j.delete(m.item.handle),this.ob(i,t);const u=this.X(f)||[],$=u.filter(I=>I.item.handle===m.item.handle)[0];$&&u.splice(u.indexOf($),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const m of t.children){const f=this.j.get(m.item.handle);f&&this.sb(f)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const m of t.children){const f=this.j.get(m.item.handle);f&&this.sb(f)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[303],Ie([1,0,4,5,2,37,10,68,6,7]),function(oe,e,w,C,P,M,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0,A=qe(A),p=qe(p),c=qe(c);class R extends C.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,r,o,a){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new w.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$le),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#l=a.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class v extends C.$Vc{static c(){return(0,M.$1g)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$1M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,a,h={}){const n=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof a=="object"&&!!a.preserveFocus},i=(0,N.$Fnc)(d),t=v.c();this.f.$createWebviewPanel((0,N.$Hnc)(d),t,r,{title:o,panelOptions:l(h),webviewOptions:(0,N.$Inc)(d,this.m,h),serializeBuffersForPostMessage:i},s);const m=this.j.createNewWebview(t,h,d);return this.createNewWebviewPanel(t,r,o,n,h,m,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,a)=>{const h=d[o],n=d[a];return h.active?1:n.active?-1:+h.visible-+n.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const h=d[o];a._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,N.$Fnc)(d)}),new c.$3M(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,a){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:s}=h,i=this.j.createNewWebview(d,o.webviewOptions,s),t=this.createNewWebviewPanel(d,r,o.title,a,o.panelOptions,i,o.active);await n.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(d,r,o,a,h,n,s){const i=new R(d,this.f,n,{viewType:r,title:o,viewColumn:a,panelOptions:h,active:s});return this.g.set(d,i),i}getWebviewPanel(d){return this.g.get(d)}}e.$Jnc=v;function l(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[304],Ie([1,0,4,5,68,10,6,7]),function(oe,e,w,C,P,M,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0,A=qe(A),N=qe(N);class p extends C.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(v,l,E,d,r,o){super(),this.#s=!1,this.#l=this.B(new w.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new w.$le),this.onDidDispose=this.#u.event,this.#i=E,this.#a=d,this.#e=v,this.#t=l,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(v){this.a(),this.#a!==v&&(this.#a=v,this.#t.$setWebviewViewTitle(this.#e,v))}get description(){return this.a(),this.#o}set description(v){this.a(),this.#o!==v&&(this.#o=v,this.#t.$setWebviewViewDescription(this.#e,v))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(v){v===this.#r||this.#s||(this.#r=v,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(v){this.a(),!(v?.value===this.#c?.value&&v?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(v),this.#t.$setWebviewViewBadge(this.#e,v))}show(v){this.a(),this.#t.$show(this.#e,!!v)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(v,l){this.d=l,this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$1M.MainThreadWebviewViews)}registerWebviewViewProvider(v,l,E,d){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:E,extension:v}),this.a.$registerWebviewViewProvider((0,P.$Hnc)(v),l,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Fnc)(v)}),new N.$3M(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(v,l,E,d,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:a,extension:h}=o,n=this.d.createNewWebview(v,{},h),s=new p(v,this.a,l,E,n,!0);this.c.set(v,s),await a.resolveWebviewView(s,{state:d},r)}async $onDidChangeWebviewViewVisibility(v,l){this.e(v)._setVisible(l)}async $disposeWebviewView(v){const l=this.e(v);this.c.delete(v),l.dispose(),this.d.deleteWebview(v)}e(v){const l=this.c.get(v);if(!l)throw new Error("No webview found");return l}}e.$fpc=c}),define(Ce[305],Ie([1,0,4,31,32,3]),function(oe,e,w,C,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.OutputChannelUpdateMode=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=void 0,e.$9L="text/x-code-output",e.$0L="output",e.$$L="Log",e.$_L="text/x-code-log-output",e.$aM="log",e.$bM="workbench.panel.output",e.$cM=new P.$Vj("inOutput",!1),e.$dM=new P.$Vj("activeLogOutput",!1),e.$eM=new P.$Vj("activeLogOutput.levelSettable",!1),e.$fM=new P.$Vj("activeLogOutput.level",""),e.$gM=new P.$Vj("activeLogOutput.levelIsDefault",!1),e.$hM=new P.$Vj("outputView.scrollLock",!1),e.$iM=(0,M.$Ei)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$jM={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new w.$le,this.onDidRegisterChannel=this.b.event,this.c=new w.$le,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(R=>c.push(R)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}C.$oo.add(e.$jM.OutputChannels,new N),e.$kM=new P.$Vj("activeOutputChannel","")}),define(Ce[127],Ie([1,0,6,3,17,19,12,305,69,27,51,157,23,15,30,4,5]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=e.$Uoc=void 0;class a extends A.$ek{get disposed(){return this.n}constructor(i,t,m,f,u){super(),this.id=i,this.name=t,this.r=m,this.s=f,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(m.getLevel()),this.B(m.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,N.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=l.$Ne.fromString(t).byteLength,(0,A.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends a{appendLine(i){this.append(i)}}let n=class{constructor(i,t,m,f,u,$){this.i=t,this.j=m,this.k=f,this.l=u,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(w.$1M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,v.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,m]of this.g)m.visible=t===this.h}createOutputChannel(i,t,m){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const f=typeof t=="object"&&t.log,u=(0,E.$eg)(t)?t:void 0;if((0,E.$eg)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const I=this.i.environment.extensionLogLevel?.find(([y])=>M.$pn.equals(m.identifier,y))?.[1];I&&($=(0,A.$pk)(I));const D=f?this.o(i,$,m):this.n(i,u,m);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),f?this.r(i,$??this.m.getLevel(),D):this.q(i,D)}async n(i,t,m){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,u=this.k.extUri.joinPath(f,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(i,u,t,m.identifier.value);return new a(I,i,$,this.a,m)}async o(i,t,m){const f=await this.p(m),u=i.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(f,`${u}.log`),I=`${m.identifier.value}.${u}`,D=this.l.createLogger($,{id:I,name:i,logLevel:t,extensionId:m.identifier.value});return new h(I,i,D,this.a,m)}p(i){let t=this.d.get(i.identifier.value);if(!t){const m=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(m)}catch(f){if((0,d.$ol)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}return m})())}return t}q(i,t){let m=!1;const f=()=>{if(m)throw new Error("Channel has been closed")};return{get name(){return i},append(u){f(),t.then($=>$.append(u))},appendLine(u){f(),t.then($=>$.appendLine(u))},clear(){f(),t.then(u=>u.clear())},replace(u){f(),t.then($=>$.replace(u))},show(u,$){f(),t.then(I=>I.show(u,$))},hide(){f(),t.then(u=>u.hide())},dispose(){m=!0,t.then(u=>u.dispose())}}}r(i,t,m){const f=new o.$Uc,u=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},$=f.add(new r.$le);function I(D){t=D,$.fire(D)}return m.then(D=>{f.add(D),D.logLevel!==t&&I(D.logLevel),f.add(D.onDidChangeLogLevel(y=>I(y)))}),{...this.q(i,m),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(D,...y){u(),m.then(S=>S.trace(D,...y))},debug(D,...y){u(),m.then(S=>S.debug(D,...y))},info(D,...y){u(),m.then(S=>S.info(D,...y))},warn(D,...y){u(),m.then(S=>S.warn(D,...y))},error(D,...y){u(),m.then(S=>S.error(D,...y))},dispose(){f.dispose()}}}};e.$Uoc=n,e.$Uoc=n=He([We(0,P.$uP),We(1,c.$KP),We(2,p.$Bnc),We(3,R.$enc),We(4,A.$_j),We(5,A.$$j)],n),e.$Voc=(0,C.$Ei)("IExtHostOutputService")}),define(Ce[128],Ie([1,0,3,11]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=void 0,e.$Um=(0,w.$Ei)("remoteAgentService"),e.$Vm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let N=0;N<this.maxSampleCount;N++){const p=await P.getRoundTripTime();if(p===void 0)return;M=Math.min(M,p/2),await(0,C.$Fh)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((N,p)=>N+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((N,p)=>N+p,0)/this.average.length,high:typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[306],Ie([1,0,192,54,31,50,42,5,4,128,21,26,11,113]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hb=e.$3hb=e.$2hb=e.$1hb=e.$Zhb=e.$Yhb=e.$Xhb=e.$Whb=e.$Vhb=e.$Uhb=void 0,e.$Uhb=Object.freeze({id:"application",order:100,title:(0,w.localize)(0,null),type:"object"}),e.$Vhb=Object.freeze({id:"workbench",order:7,title:(0,w.localize)(1,null),type:"object"}),e.$Whb=Object.freeze({id:"security",scope:C.ConfigurationScope.APPLICATION,title:(0,w.localize)(2,null),type:"object",order:7}),e.$Xhb=Object.freeze({id:"problems",title:(0,w.localize)(3,null),type:"object",order:101}),e.$Yhb=Object.freeze({id:"window",order:8,title:(0,w.localize)(4,null),type:"object"}),e.$Zhb={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const r=new d;P.$oo.add(e.$Zhb.ConfigurationMigration,r);let o=class extends N.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const m of t.added)await this.f(m,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(t=>this.g(t,s?.uri))])}async g(s,i){const t=this.a.inspect(s.key,{resource:i}),m=this.b.getWorkbenchState()===M.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[f,u]of m){const $=t[f];if(!$)continue;const I=[];if($.value!==void 0){const D=await this.h(s,f,$.value,i,void 0);for(const y of D??[])I.push([y,[]])}for(const{identifiers:D,value:y}of $.overrides??[])if(y!==void 0){const S=await this.h(s,f,y,i,D);for(const k of S??[])I.push([k,D])}I.length&&await Promise.allSettled(I.map(async([[D,y],S])=>this.a.updateValue(D,y.value,{resource:i,overrideIdentifiers:S},u)))}}async h(s,i,t,m,f){const u=I=>{const y=this.a.inspect(I,{resource:m})[i];if(y)return f?y.overrides?.find(({identifiers:S})=>(0,v.$fo)(S,f))?.value:y.value},$=await s.migrateFn(t,u);return Array.isArray($)?$:[[s.key,$]]}};e.$1hb=o,e.$1hb=o=He([We(0,A.$$i),We(1,M.$Ni)],o);let a=class extends N.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new l.$2h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;P.$oo.as(C.$to.Configuration).registerConfiguration({...e.$Whb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,w.localize)(5,null)},default:[],markdownDescription:(0,w.localize)(6,null),scope:C.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,w.localize)(7,null),scope:C.ConfigurationScope.MACHINE}}})}};e.$2hb=a,e.$2hb=a=He([We(0,c.$Um)],a),e.$3hb="window.newWindowProfile";let h=class extends N.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,i){super(),this.c=s,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(t=>{t.source!==A.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$3hb)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=P.$oo.as(C.$to.Configuration),i={...e.$Yhb,properties:{[e.$3hb]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,w.localize)(8,null)],description:(0,w.localize)(9,null),scope:C.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[i],remove:[this.a]}):s.registerConfiguration(i),this.a=i}h(){const s=this.f.getValue(e.$3hb);this.b=s?this.c.profiles.find(i=>i.name===s):void 0}j(){const s=this.f.getValue(e.$3hb);if(!s)return;const i=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;s!==i?.name&&this.f.updateValue(e.$3hb,i?.name)}};e.$4hb=h,e.$4hb=h=He([We(0,E.$Kl),We(1,A.$$i)],h)}),define(Ce[307],Ie([1,0,41,16,20,24,203,306,54,3,31]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$6hb=e.$5hb=void 0,e.$7hb=r,e.$8hb=o,w=qe(w),e.$5hb=(0,c.$Ei)("editorResolverService"),e.$6hb="workbench.editorAssociations";const v=R.$oo.as(p.$to.Configuration),l={...N.$Vhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};v.registerConfiguration(l);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var d;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function o(a,h){if(new Set([C.Schemas.extension,C.Schemas.webviewPanel,C.Schemas.vscodeWorkspaceTrust,C.Schemas.vscodeSettings]).has(h.scheme))return!1;const i=typeof a=="string"&&a.indexOf(P.$hc.sep)>=0?`${h.scheme}:${h.path}`:(0,M.$ch)(h);return w.$xk(typeof a=="string"?a.toLowerCase():a,i.toLowerCase())}}),define(Ce[308],Ie([1,0,53,16,20,21,24,2,3,226,50,246,128]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0,e.$CM=(0,p.$Ei)("pathService");let d=E=class{constructor(o,a,h,n){this.d=o,this.e=a,this.f=h,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,a,h){return typeof a=="string"||typeof a>"u"?this.a.then(n=>this.h(o,n,a)):this.h(o,a,h)}h(o,a,h){return o.scheme===C.Schemas.file||o.scheme===C.Schemas.vscodeRemote?(0,w.$Bg)(h??(0,A.$ch)(o),a===M.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return C.Schemas.vscodeRemote;const h=(0,c.$zM)(a.getWorkspace());if(h)return h;const n=a.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:C.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===M.OperatingSystem.Windows?P.$gc:P.$hc)}async fileURI(o){let a="";if(await this.a===M.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(a=o.substring(2),o="/"):(a=o.substring(2,n),o=o.substring(n)||"/")}return N.URI.from({scheme:C.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.$DM=d,e.$DM=d=E=He([We(1,l.$Um),We(2,v.$lM),We(3,R.$Ni)],d)}),define(Ce[129],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$eL=e.$dL=void 0;class w{constructor(A,N){this.line=A,this.character=N}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,N){return new w(0,0)}with(A){return new w(0,0)}}e.$dL=w;class C{constructor(A,N,p,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,N),this.end=new w(p,c)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new C(0,0,0,0)}with(A){return new C(0,0,0,0)}}e.$eL=C;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ce[43],Ie([1,0,18,41,26,53,13,3,20,14,129,11]),function(oe,e,w,C,P,M,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=e.$CL=e.$vL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$sL=e.$rL=e.$qL=e.$pL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.TextSearchCompleteMessageType=void 0,e.$mL=a,e.$nL=h,e.$oL=n,e.$tL=D,e.$uL=y,e.$wL=g,e.$xL=b,e.$yL=F,e.$zL=T,e.$AL=q,e.$BL=G,e.$DL=O,e.$FL=ge,e.$GL=te,C=qe(C),P=qe(P),M=qe(M),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$fL="workbench.view.search",e.$gL="workbench.panel.search",e.$hL="workbench.view.search",e.$iL="search-result",e.$jL="search.exclude",e.$kL=2e4;const l="\u27EA ",E=" characters skipped \u27EB",d=(l.length+E.length+5)*2;e.$lL=(0,N.$Ei)("searchService");var r;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(se){return!!se.preview}function h(se){return!!se.resource}function n(se){return!!se.message}var s;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class i{constructor(de){this.resource=de,this.results=[]}}e.$pL=i;class t{constructor(de,be,re,Pe){this.ranges=be,this.webviewIndex=Pe;const Fe=Array.isArray(be)?be:[be];if(re&&re.matchLines===1&&m(Fe)){de=(0,A.$0f)(de,re.matchLines);let X="",B=0,_=0;const we=Math.floor(re.charsPerLine/5),ae=[];for(const ve of Fe){const ue=Math.max(ve.startColumn-we,0),Z=ve.startColumn+re.charsPerLine;if(ue>_+we+d){const Y=l+(ue-_)+E;X+=Y+de.slice(ue,Z),B+=ue-(_+Y.length)}else X+=de.slice(_,Z);ae.push(new u(0,ve.startColumn-B,ve.endColumn-B)),_=Z}this.preview={text:X,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const X=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:de,matches:(0,w.$2b)(be,B=>new f(B.startLineNumber-X,B.startColumn,B.endLineNumber-X,B.endColumn))}}}}e.$qL=t;function m(se){const de=se[0].startLineNumber;for(const be of se)if(be.startLineNumber!==de||be.endLineNumber!==de)return!1;return!0}class f{constructor(de,be,re,Pe){this.startLineNumber=de,this.startColumn=be,this.endLineNumber=re,this.endColumn=Pe}}e.$rL=f;class u extends f{constructor(de,be,re){super(de,be,de,re)}}e.$sL=u;var $;(function(se){se.List="list",se.Tree="tree"})($||(e.ViewMode=$={}));var I;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function D(se,de=!0){const be=se&&se.files&&se.files.exclude,re=de&&se&&se.search&&se.search.exclude;if(!be&&!re)return;if(!be||!re)return be||re;let Pe=Object.create(null);return Pe=P.$eo(Pe,P.$bo(be)),Pe=P.$eo(Pe,P.$bo(re),!0),Pe}function y(se,de){return se.excludePattern&&C.$xk(se.excludePattern,de)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&C.$xk(se.includePattern,de)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(be=>{const re=be.folder.fsPath;if(M.$Dg(de,re)){const Pe=p.$mc(re,de);return!be.includePattern||!!C.$xk(be.includePattern,Pe)}else return!1}):!1:!0}var S;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class k extends Error{constructor(de,be){super(de),this.code=be}}e.$vL=k;function g(se){const de=se.message;if((0,c.$5)(se))return new k(de,S.canceled);try{const be=JSON.parse(de);return new k(be.message,be.code)}catch{return new k(de,S.other)}}function b(se){const de={message:se.message,code:se.code};return new Error(JSON.stringify(de))}function F(se){return se.type==="error"?!0:se.type==="success"}function T(se){return se.type==="success"}function q(se){return!!se.path}function G(se,de,be=!0){const re=se.searchPath?se.searchPath:se.relativePath;return be?(0,A.$7f)(re,de):C.$xk(de,re)}class V{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$CL=V;function O(se,de){const be={...se||{},...de||{}};return Object.keys(be).filter(re=>{const Pe=be[re];return typeof Pe=="boolean"&&Pe})}class W{constructor(de,be){this.c=null,this.a={...de.excludePattern||{},...be.excludePattern||{}},this.b=C.$yk(this.a);let re=de.includePattern;be.includePattern&&(re?re={...re,...be.includePattern}:re=be.includePattern),re&&(this.c=C.$yk(re))}matchesExcludesSync(de,be,re){return!!(this.b&&this.b(de,be,re))}includedInQuerySync(de,be,re){return!(this.b&&this.b(de,be,re)||this.c&&!this.c(de,be,re))}includedInQuery(de,be,re){const Pe=this.b(de,be,re),Fe=()=>this.c?!!this.c(de,be,re):!0;return(0,v.$qh)(Pe)?Pe.then(X=>X?!1:Fe()):Fe()}hasSiblingExcludeClauses(){return ce(this.a)}}e.$EL=W;function ce(se){for(const de in se)if(typeof se[de]!="boolean")return!0;return!1}function ge(se){if(!se)return;let de;return be=>(de||(de=(se()||Promise.resolve([])).then(re=>re?me(re):{})),de.then(re=>!!re[be]))}function te(se){if(!se)return;let de;return be=>{if(!de){const re=se();de=re?me(re):{}}return!!de[be]}}function me(se){const de={};for(const be of se)de[be]=!0;return de}}),define(Ce[44],Ie([1,0,18,11,22,4,5,59,16,138,24,13,2,191,30,3,12,214,50,51,27,17,10,7,66,43,6,49]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=e.$vnc=void 0;function D(q,G,V){return new R.$7g(O=>g(O,V)).isEqual(q,G)}function y(q,G,V){return D(q.uri,G.uri,V)?0:(0,v.$yf)(q.uri.toString(),G.uri.toString())}function S(q,G,V){return q.index!==G.index?q.index<G.index?-1:1:D(q.uri,G.uri,V)?(0,v.$yf)(q.name,G.name):(0,v.$yf)(q.uri.toString(),G.uri.toString())}function k(q,G,V,O){const W=q.slice(0).sort((ge,te)=>V(ge,te,O)),ce=G.slice(0).sort((ge,te)=>V(ge,te,O));return(0,w.$Fb)(W,ce,(ge,te)=>V(ge,te,O))}function g(q,G){const V=G.getCapabilities(q.scheme);return!(V&&V&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends h.$Xi{static toExtHostWorkspace(G,V,O,W){if(!G)return{workspace:null,added:[],removed:[]};const{id:ce,name:ge,folders:te,configuration:me,transient:se,isUntitled:de}=G,be=[],re=V;V?te.forEach((B,_)=>{const we=l.URI.revive(B.uri),ae=b.o(O||V,we,W);ae?(ae.name=B.name,ae.index=B.index,be.push(ae)):be.push({uri:we,name:B.name,index:_})}):be.push(...te.map(({uri:B,name:_,index:we})=>({uri:l.URI.revive(B),name:_,index:we}))),be.sort((B,_)=>B.index<_.index?-1:1);const Pe=new b(ce,ge,be,!!se,me?l.URI.revive(me):null,!!de,B=>g(B,W)),{added:Fe,removed:X}=k(re?re.workspaceFolders:[],Pe.workspaceFolders,y,W);return{workspace:Pe,added:Fe,removed:X}}static o(G,V,O){for(let W=0;W<G.folders.length;W++){const ce=G.workspaceFolders[W];if(D(ce.uri,V,O))return ce}}constructor(G,V,O,W,ce,ge,te){super(G,O.map(me=>new h.$Yi(me)),W,ce,te),this.t=V,this.u=ge,this.q=[],this.s=N.$Ki.forUris(te),O.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,V){return V&&this.s.get(G)&&(G=(0,R.$eh)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let F=class{constructor(G,V,O,W,ce){this.c=new M.$le,this.onDidChangeWorkspace=this.c.event,this.g=new M.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new M.$ne,this.C=new Map,this.h=W,this.s=O,this.t=ce,this.j=new c.$Lm,this.k=new C.$Dh,this.o=G.getProxy($.$1M.MainThreadWorkspace),this.q=G.getProxy($.$1M.MainThreadMessageService);const ge=V.workspace;this.l=ge?new b(ge.id,ge.name,[],!!ge.transient,ge.configuration?l.URI.revive(ge.configuration):null,!!ge.isUntitled,te=>g(te,O)):void 0}$initializeWorkspace(G,V){this.v=V,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:p.Schemas.untitled,path:(0,R.$ch)((0,R.$eh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,V,O,...W){const ce=[];if(Array.isArray(W)&&W.forEach(de=>{l.URI.isUri(de.uri)&&!ce.some(be=>D(be.uri,de.uri,this.s))&&ce.push({uri:de.uri,name:de.name||(0,R.$bh)(de.uri)})}),this.n||[V,O].some(de=>typeof de!="number"||de<0)||O===0&&ce.length===0)return!1;const ge=this.x?this.x.workspaceFolders:[];if(V+O>ge.length)return!1;const te=ge.slice(0);te.splice(V,O,...ce.map(de=>({uri:de.uri,name:de.name||(0,R.$bh)(de.uri),index:void 0})));for(let de=0;de<te.length;de++){const be=te[de];if(te.some((re,Pe)=>Pe!==de&&D(be.uri,re.uri,this.s)))return!1}te.forEach((de,be)=>de.index=be);const{added:me,removed:se}=k(ge,te,S,this.s);if(me.length===0&&se.length===0)return!1;if(this.o){const de=G.displayName||G.name;this.o.$updateWorkspaceFolders(de,V,O,ce).then(void 0,be=>{this.n=void 0;const re={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(a.Severity.Error,(0,E.localize)(0,null,de,be.toString()),re,[])})}return this.y(te),!0}getWorkspaceFolder(G,V){if(this.x)return this.x.getWorkspaceFolder(G,V)}async getWorkspaceFolder2(G,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,V)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,V){let O,W="";if(typeof G=="string"?(O=l.URI.file(G),W=G):typeof G<"u"&&(O=G,W=G.fsPath),!O)return W;const ce=this.getWorkspaceFolder(O,!0);if(!ce)return W;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let ge=(0,R.$hh)(ce.uri,O);return V&&ce.name&&(ge=`${ce.name}/${ge}`),ge}y(G){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:V,added:O,removed:W}=b.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:W}))}findFiles(G,V,O,W,ce=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let ge="",te=!0;return V===null?te=!1:V!==void 0&&(typeof V=="string"?ge=V:ge=V.pattern),this.z(G,void 0,{exclude:ge,maxResults:O,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ce)}findFiles2(G,V={},O,W=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,G,V,W)}async z(G,V,O,W=P.CancellationToken.None){if(W&&W.isCancellationRequested)return Promise.resolve([]);const ce=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,ge={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:ce,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let te;if(G){const{includePattern:me,folder:se}=T(t.GlobPattern.from(G));te=se,ge.includePattern=me}else{const{includePattern:me,folder:se}=T(t.GlobPattern.from(V));te=se,ge.filePattern=me}return this.o.$startFileSearch(te??null,ge,W).then(me=>Array.isArray(me)?me.map(se=>l.URI.revive(se)):[])}async findTextInFiles(G,V,O,W,ce=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const ge=this.j.getNext(),te=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:me,folder:se}=T(t.GlobPattern.from(V.include)),de=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,be={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:te,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:me,excludePattern:de},re=!1;if(this.u[ge]=Pe=>{if(re)return;const Fe=l.URI.revive(Pe.resource);Pe.results.forEach(X=>{const B=(0,I.$bi)(X);(0,u.$mL)(B)?O({uri:Fe,preview:{text:B.preview.text,matches:(0,w.$2b)(B.preview.matches,_=>new m.$5M(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,w.$2b)(B.ranges,_=>new m.$5M(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):O({uri:Fe,text:B.text,lineNumber:B.lineNumber})})},ce.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(G,se??null,be,ge,ce);return delete this.u[ge],Pe||{}}catch(Pe){throw delete this.u[ge],Pe}}$handleTextSearchResult(G,V){this.u[V]?.(G)}async save(G){const V=await this.o.$save(G,{saveAs:!1});return l.URI.revive(V)}async saveAs(G){const V=await this.o.$save(G,{saveAs:!0});return l.URI.revive(V)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,V){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,V);const O=this.t.transformOutgoingScheme(G),W=this.A++;return this.o.$registerEditSessionIdentityProvider(W,O),(0,A.$Tc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(W)})}async $getEditSessionIdentifier(G,V){this.h.info("Getting edit session identifier for workspaceFolder",G);const O=await this.resolveWorkspaceFolder(l.URI.revive(G));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const W=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!W),!W)return;const ce=await W.provideEditSessionIdentity(O,V);if(this.h.info("Provider returned edit session identifier: ",ce),!!ce)return ce}async $provideEditSessionIdentityMatch(G,V,O,W){this.h.info("Getting edit session identifier for workspaceFolder",G);const ce=await this.resolveWorkspaceFolder(l.URI.revive(G));if(!ce){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ce);const ge=this.w.get(ce.uri.scheme);if(this.h.info(`Provider for scheme ${ce.uri.scheme} is defined: `,!!ge),!ge)return;const te=await ge.provideEditSessionIdentityMatch?.(V,O,W);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(G){return(V,O,W)=>{const ce=function(te){V.call(O,te)};return ce.extension=G,this.B.event(ce,void 0,W)}}async $onWillCreateEditSessionIdentity(G,V,O){const W=await this.resolveWorkspaceFolder(l.URI.revive(G));if(W===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:W},V,async(ce,ge)=>{const te=Date.now();await Promise.resolve(ce),Date.now()-te>O&&this.h.warn("SLOW edit session create-participant",ge.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(G,V){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,V);const O=this.t.transformOutgoingScheme(G),W=this.A++;return this.o.$registerCanonicalUriProvider(W,O),(0,A.$Tc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(W)})}async provideCanonicalUri(G,V,O){const W=this.C.get(G.scheme);if(!W)return;const ce=await W.provideCanonicalUri?.(l.URI.revive(G),V,O);if(ce)return ce}async $provideCanonicalUri(G,V,O){return this.provideCanonicalUri(l.URI.revive(G),{targetScheme:V},O)}};e.$vnc=F,e.$vnc=F=He([We(0,i.$uP),We(1,s.$KP),We(2,n.$enc),We(3,o.$$j),We(4,f.$tnc)],F),e.$wnc=(0,r.$Ei)("IExtHostWorkspace");function T(q){let G,V;return q&&(typeof q=="string"?G=q:(G=q.pattern,V=l.URI.revive(q.baseUri))),{includePattern:G,folder:V}}}),define(Ce[45],Ie([1,0,26,4,44,6,7,42,215,54,15,11,3,17,12,2]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=e.$ync=e.$xnc=void 0;function o(f,u){if(u){const $=u.split(".");let I=f;for(let D=0;I&&D<$.length;D++)I=I[$[D]];return I}}function a(f){return f instanceof r.URI}function h(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function i(f){if(a(f))return{resource:f};if(h(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let t=class{constructor(u,$,I){this.a=u.getProxy(M.$1M.MainThreadConfiguration),this.c=$,this.b=I,this.d=new v.$Dh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new m(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,$){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(u,$))}};e.$xnc=t,e.$xnc=t=He([We(0,E.$uP),We(1,P.$wnc),We(2,d.$$j)],t);class m{constructor(u,$,I,D){this.a=new C.$le,this.b=u,this.f=D,this.c=$,this.e=p.$Mo.parse(I,D),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,$){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Mo.parse(u,this.f),this.d=this.k(u.configurationScopes),this.a.fire(this.j($,I))}getConfiguration(u,$,I){const D=i($)||{},y=this.g(u?o(this.e.getValue(void 0,D,this.c.workspace),u):this.e.getValue(void 0,D,this.c.workspace));u&&this.h(u,D,I?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?N.ConfigurationTarget.USER:N.ConfigurationTarget.WORKSPACE;switch(g){case A.ConfigurationTarget.Global:return N.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return N.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return N.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(g){return typeof o(y,g)<"u"},get:(g,b)=>{this.h(u?`${u}.${g}`:g,D,I?.identifier);let F=o(y,g);if(typeof F>"u")F=b;else{let T;const q=(G,V)=>{if((0,R.$gg)(G)){let O;const W=()=>{T=T||(0,w.$bo)(y),O=O||o(T,V)};return new Proxy(G,{get:(ce,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return W(),()=>O;if(T)return O=O||o(T,V),O[ge];const te=ce[ge];return typeof ge=="string"?q(te,`${V}.${ge}`):te},set:(ce,ge,te)=>(W(),O&&(O[ge]=te),!0),deleteProperty:(ce,ge)=>(W(),O&&delete O[ge],!0),defineProperty:(ce,ge,te)=>(W(),O&&Object.defineProperty(O,ge,te),!0)})}return Array.isArray(G)?(0,w.$bo)(G):G};F=q(F,g)}return F},update:(g,b,F,T)=>{g=u?`${u}.${g}`:g;const q=S(F);return b!==void 0?this.b.$updateConfigurationOption(q,g,b,D,T):this.b.$removeConfigurationOption(q,g,D,T)},inspect:g=>{g=u?`${u}.${g}`:g;const b=this.e.inspect(g,D,this.c.workspace);if(b)return{key:g,defaultValue:(0,w.$bo)(b.policy?.value??b.default?.value),globalValue:(0,w.$bo)(b.user?.value??b.application?.value),workspaceValue:(0,w.$bo)(b.workspace?.value),workspaceFolderValue:(0,w.$bo)(b.workspaceFolder?.value),defaultLanguageValue:(0,w.$bo)(b.default?.override),globalLanguageValue:(0,w.$bo)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,w.$bo)(b.workspace?.override),workspaceFolderLanguageValue:(0,w.$bo)(b.workspaceFolder?.override),languageIds:(0,w.$bo)(b.overrideIdentifiers)}}};return typeof y=="object"&&(0,w.$eo)(k,y,!1),Object.freeze(k)}g(u){const $=I=>(0,R.$gg)(I)?new Proxy(I,{get:(D,y)=>$(D[y]),set:(D,y,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return $(u)}h(u,$,I){const D=c.$Do.test(u)?c.ConfigurationScope.RESOURCE:this.d.get(u),y=I?`[${I.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,$){const I=new p.$Oo(u,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>I.affectsConfiguration(D,i(y))})}k(u){return u.reduce(($,I)=>($.set(I[0],I[1]),$),new Map)}}e.$ync=m,e.$znc=(0,l.$Ei)("IExtHostConfiguration")}),define(Ce[130],Ie([1,0,2,11,4,6,7,44,58,45,22,57,17,27,3,16,21,12,85,251,14]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=e.$8oc=e.$7oc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),o=qe(o);var i;(function(T){function q(V){if(V!=null)return V}T.from=q;function G(V){if(V!=null)return V}T.to=G})(i||(i={}));var t;(function(T){function q(V){if(V!=null)return V}T.from=q;function G(V){if(V!=null)return V}T.to=G})(t||(t={}));var m;(function(T){function q(V){if(V!=null)return V}T.from=q;function G(V){if(V!=null)return V}T.to=G})(m||(m={}));var f;(function(T){function q(O){if(O){const W=O;return W&&!!W.process}else return!1}T.is=q;function G(O){if(O==null)return;const W={process:O.process,args:O.args};return O.options&&(W.options=m.from(O.options)),W}T.from=G;function V(O){if(O!=null)return new A.$MN(O.process,O.args,O.options)}T.to=V})(f||(f={}));var u;(function(T){function q(V){if(V!=null)return V}T.from=q;function G(V){if(V!=null)return V}T.to=G})(u||(u={}));var $;(function(T){function q(O){if(O){const W=O;return W&&(!!W.commandLine||!!W.command)}else return!1}T.is=q;function G(O){if(O==null)return;const W={};return O.commandLine!==void 0?W.commandLine=O.commandLine:(W.command=O.command,W.args=O.args),O.options&&(W.options=u.from(O.options)),W}T.from=G;function V(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$NN(O.commandLine,O.options):new A.$NN(O.command,O.args?O.args:[],O.options)}T.to=V})($||($={}));var I;(function(T){function q(O){if(O){const W=O;return W&&W.customExecution==="customExecution"}else return!1}T.is=q;function G(O){return{customExecution:"customExecution"}}T.from=G;function V(O,W){return W.get(O)}T.to=V})(I||(e.CustomExecutionDTO=I={}));var D;(function(T){function q(G,V){let O;return G.scope!==void 0&&typeof G.scope!="number"?O=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===A.TaskScope.Workspace&&V&&V.workspaceFile?O=V.workspaceFile:O=n.$DI),{id:G._id,workspaceFolder:O}}T.from=q})(D||(e.TaskHandleDTO=D={}));var y;(function(T){function q(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}T.from=q})(y||(y={}));var S;(function(T){function q(O,W){if(O==null)return[];const ce=[];for(const ge of O){const te=G(ge,W);te&&ce.push(te)}return ce}T.fromMany=q;function G(O,W){if(O==null)return;let ce;O.execution instanceof A.$MN?ce=f.from(O.execution):O.execution instanceof A.$NN?ce=$.from(O.execution):O.execution&&O.execution instanceof A.$ON&&(ce=I.from(O.execution));const ge=i.from(O.definition);let te;return O.scope?typeof O.scope=="number"?te=O.scope:te=O.scope.uri:te=A.TaskScope.Workspace,!ge||!te?void 0:{_id:O._id,definition:ge,name:O.name,source:{extensionId:W.identifier.value,label:O.source,scope:te},execution:ce,isBackground:O.isBackground,group:y.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}T.from=G;async function V(O,W,ce){if(O==null)return;let ge;f.is(O.execution)?ge=f.to(O.execution):$.is(O.execution)?ge=$.to(O.execution):I.is(O.execution)&&(ge=I.to(O._id,ce));const te=i.to(O.definition);let me;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?me=O.source.scope:me=await W.resolveWorkspaceFolder(w.URI.revive(O.source.scope)):me=A.TaskScope.Workspace),!te||!me)return;const se=new A.$PN(te,me,O.name,O.source.label,ge,O.problemMatchers);return O.isBackground!==void 0&&(se.isBackground=O.isBackground),O.group!==void 0&&(se.group=A.$LN.from(O.group._id),se.group&&O.group.isDefault&&(se.group=new A.$LN(se.group.id,se.group.label),O.group.isDefault===!0&&(se.group.isDefault=O.group.isDefault))),O.presentationOptions&&(se.presentationOptions=t.to(O.presentationOptions)),O._id&&(se._id=O._id),O.detail&&(se.detail=O.detail),se}T.to=V})(S||(e.TaskDTO=S={}));var k;(function(T){function q(V){return V}T.from=q;function G(V){if(V)return Object.assign(Object.create(null),V)}T.to=G})(k||(k={}));class g{#e;constructor(q,G,V){this._id=G,this.a=V,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let b=class{constructor(q,G,V,O,W,ce,ge,te){this.q=new P.$le,this.r=new P.$le,this.s=new P.$le,this.u=new P.$le,this.a=q.getProxy(M.$1M.MainThreadTask),this.b=V,this.c=O,this.d=W,this.e=ce,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,G,V){if(!V)return new A.$3M(()=>{});const O=this.x();return this.j.set(O,{type:G,provider:V,extension:q}),this.a.$registerTaskProvider(O,G),new A.$3M(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(q,G){this.a.$registerTaskSystem(q,G)}fetchTasks(q){return this.a.$fetchTasks(k.from(q)).then(async G=>{const V=[];for(const O of G){const W=await S.to(O,this.b,this.m);W&&V.push(W)}return V})}get taskExecutions(){const q=[];return this.k.forEach(G=>q.push(G)),q}terminateTask(q){if(!(q instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,G,V){const O=this.m.get(q.id);O&&(this.o.set(q.id,O),this.e.attachPtyToTerminal(G,await O.callback(V))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const G=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:G})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const G=await this.z(q.id);this.s.fire({execution:G,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const G=await this.z(q.id);this.u.fire({execution:G,exitCode:q.exitCode})}$provideTasks(q,G){const V=this.j.get(q);if(!V)return Promise.reject(new Error("no handler found"));const O=[],W=(0,C.$wh)(()=>V.provider.provideTasks(R.CancellationToken.None)).then(ce=>this.v(G,O,V,ce));return new Promise(ce=>{W.then(ge=>{Promise.all(O).then(()=>{ce(ge)})})})}async $resolveTask(q,G){const V=this.j.get(q);if(!V)return Promise.reject(new Error("no handler found"));if(G.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${V.type}].`);const O=await S.to(G,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const W=await V.provider.resolveTask(O,R.CancellationToken.None);if(!W)return;this.A(W,V);const ce=S.from(W,V.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(ce.execution)&&await this.y(ce,W,!0),await this.w(ce)}x(){return this.h++}async y(q,G,V){const O=await this.a.$createTaskId(q);!V&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,G.execution)),this.m.set(O,G.execution)}async z(q,G){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new s.$cb("Unexpected: The specified task is missing an execution");return W}const V=this.l.get(q.id);if(V)return V;let O;return G?O=Promise.resolve(new g(this,q.id,G)):O=S.to(q.task,this.b,this.m).then(W=>{if(!W)throw new s.$cb("Unexpected: Task does not exist.");return new g(this,q.id,W)}),this.l.set(q.id,O),O.then(W=>(this.k.set(q.id,W),W))}A(q,G){q._deprecated&&this.g.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const V=this.n.values();let O=V.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=V.next()}};e.$7oc=b,e.$7oc=b=He([We(0,l.$uP),We(1,E.$KP),We(2,N.$wnc),We(3,p.$FP),We(4,c.$znc),We(5,v.$Xnc),We(6,a.$$j),We(7,h.$anc)],b);let F=class extends b{constructor(q,G,V,O,W,ce,ge,te){super(q,G,V,O,W,ce,ge,te),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(o.Platform.Web)})}async executeTask(q,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const V=S.from(G,q);if(V===void 0)throw new Error("Task is not valid");if(I.is(V.execution))await this.y(V,G,!1);else throw new s.$ab;const O=await this.z(await this.a.$getTaskExecution(V),G);return this.a.$executeTask(V).catch(W=>{throw new Error(W)}),O}v(q,G,V,O){const W=[];if(O)for(const ce of O){if(this.A(ce,V),!ce.definition||!q[ce.definition.type]){const te=ce.source?ce.source:"No task source";this.f.warn(`The task [${te}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=S.from(ce,V.extension);ge&&I.is(ge.execution)?(W.push(ge),G.push(this.y(ge,ce,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:V.extension}}async w(q){if(I.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,G,V){}};e.$8oc=F,e.$8oc=F=He([We(0,l.$uP),We(1,E.$KP),We(2,N.$wnc),We(3,p.$FP),We(4,c.$znc),We(5,v.$Xnc),We(6,a.$$j),We(7,h.$anc)],F),e.$9oc=(0,d.$Ei)("IExtHostTask")}),define(Ce[309],Ie([1,0,43,33]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=void 0,e.$ML=P,e.$OL=M;function P(A){return"cellResults"in A}e.$NL="rawCell#";function M(A,N){let p=-1;const c=[];let R=[];return A.forEach(l=>{l.range.startLineNumber!==p&&R.length>0&&(c.push([...R]),R=[]),R.push(l),p=l.range.endLineNumber}),R.length>0&&c.push([...R]),c.map(l=>{const E=[],d=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=d;o<=r;o++)E.push(N.getLineContent(o));return new w.$qL(E.join(`
`)+`
`,l.map(o=>new C.$Ht(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[310],Ie([1,0,185,23,4,5,29,38,13,15,2,30,80,6,34,10,7,39,287,123,26,16,43,240,309,307]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0,v=qe(v),r=qe(r),o=qe(o);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,S,k,g,b,F){this.q=S,this.r=k,this.s=g,this.t=b,this.u=F,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new P.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new l.$$mc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(E.$1M.MainThreadNotebook),this.c=D.getProxy(E.$1M.MainThreadNotebookDocuments),this.d=D.getProxy(E.$1M.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===N.MarshalledId.NotebookCellActionContext){const q=T.notebookEditor?.notebookUri,G=T.cell.handle,O=this.g.get(q)?.getCell(G);if(O)return O.apiCell}if(T&&T.$mid===N.MarshalledId.NotebookActionContext){const q=T.uri,G=this.g.get(q);if(G)return G.apiNotebook}return T}}),$.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,S]of this.h)if(S.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const S=this.g.get(D);if(!S&&!y)throw new Error(`NO notebook document for '${D}'`);return S}static w(D,y){if(!y)return;const S=y.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(y.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:S,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,y,S){const k=$.a++,g=typeof S.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(k,S),this.b.$registerNotebookCellStatusBarItemProvider(k,g,y);let b;return g!==void 0&&(b=S.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(g))),new o.$3M(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,g),b?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return R.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const S=await this.c.$tryOpenNotebook(D),k=this.g.get(R.URI.revive(S));return(0,c.$pg)(k?.apiNotebook)}async showNotebookDocument(D,y){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let S;typeof y=="object"?S={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:S={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,S),g=k&&this.h.get(k)?.apiEditor;if(g)return g;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,S,k){const g=this.f.get(D),b=R.URI.revive(y),F=this.g.get(b);if(!F||!g)return;const T=F.getCellFromIndex(S);if(!T)return;const q=await g.provideCellStatusBarItems(T.apiCell,k);if(!q)return;const G=new M.$Uc,V=this.p.add([G]),W=(Array.isArray(q)?q:[q]).map(ce=>r.NotebookStatusBarItem.from(ce,this.i,G));return{cacheId:V,items:W}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,S,k,g){if((0,p.$cf)(y))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:y,serializer:S,options:k}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},y,r.NotebookDocumentContentOptions.from(k),$.w(D,g)),(0,M.$Tc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,y,S){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const g=await k.serializer.deserializeNotebook(y.buffer,S);return new a.$Pw(r.NotebookData.from(g))}async $notebookToData(D,y,S){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const g=await k.serializer.serializeNotebook(r.NotebookData.to(y.value),S);return C.$Ne.wrap(g)}async $saveNotebook(D,y,S,k,g){const b=R.URI.revive(y),F=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${S}, ${b.toString()})`),!F)throw new Error("NO serializer found");const T=this.g.get(b);if(!T)throw new Error("Document NOT found");if(T.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new v.$tl((0,w.localize)(0,null,this.A(b)),v.FileOperationResult.FILE_PERMISSION_DENIED);const q={metadata:(0,s.$jo)(T.apiNotebook.metadata,ce=>!(F.options?.transientDocumentMetadata??{})[ce]),cells:[]};for(const ce of T.apiNotebook.getCells()){const ge=new o.$tO(ce.kind,ce.document.getText(),ce.document.languageId,ce.mime,F.options?.transientOutputs?[]:[...ce.outputs],ce.metadata,ce.executionSummary);ge.metadata=(0,s.$jo)(ce.metadata,te=>!(F.options?.transientCellMetadata??{})[te]),q.cells.push(ge)}if(await this.z(b,k),g.isCancellationRequested)throw new Error("canceled");const G=await F.serializer.serializeNotebook(q,g);if(g.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${S} ${b.toString()}`),await this.s.value.writeFile(b,G),this.D(`Finished write versionId: ${S} ${b.toString()}`);const V=this.s.getFileSystemProviderExtUri(b.scheme),O=await this.s.value.stat(b),W={name:V.basename(b),isFile:(O.type&v.FileType.File)!==0,isDirectory:(O.type&v.FileType.Directory)!==0,isSymbolicLink:(O.type&v.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&v.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((O.permissions??0)&v.FilePermission.Locked),etag:v.$El({mtime:O.mtime,size:O.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${S}, ${b.toString()})`),W}async $searchInNotebooks(D,y,S,k,g){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const F=new A.$Cc;await(async(O,W,ce)=>{await Promise.all(O.map(async ge=>await Promise.all(ge.filenamePatterns.map(te=>{const me={_reason:ce._reason,folderQueries:ce.folderQueries,includePattern:ce.includePattern,excludePattern:ce.excludePattern,maxResults:ce.maxResults,type:t.QueryType.File,filePattern:te};return this.t.doInternalFileSearchWithCustomCallback(me,W,se=>{se.forEach(de=>{F.has(de)||k.some(re=>ge.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,u.$8hb)(Pe,de)))||F.add(de)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(S,g,y);const q=new A.$Bc;let G=!1;const V=Array.from(F).map(async O=>{const W=[];try{if(g.isCancellationRequested)return;if(y.maxResults&&[...q.values()].reduce((me,se)=>me+se.cellResults.length,0)>y.maxResults){G=!0;return}const ce=[],ge=this.g.get(O);if(ge)ge.apiNotebook.getCells().forEach(se=>ce.push({input:se.document.getText(),outputs:se.outputs.flatMap(de=>de.items.map(be=>be.data.toString()))}));else{const me=await this.s.value.readFile(O),se=C.$Ne.fromString(me.toString()),de=await b.deserializeNotebook(se.buffer,g);if(g.isCancellationRequested)return;r.NotebookData.from(de).cells.forEach(re=>ce.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(Fe=>Fe.valueBytes.toString()))}))}if(g.isCancellationRequested)return;ce.forEach((me,se)=>{const de=y.contentPattern.pattern,be=new m.$wYb(me.input,void 0,me.outputs),re=be.findInInputs(de),Pe=be.findInOutputs(de),Fe=Pe.flatMap(X=>(0,f.$OL)(X.matches,X.textBuffer)).map((X,B)=>(X.webviewIndex=B,X));if(re.length>0||Pe.length>0){const X={index:se,contentResults:(0,f.$OL)(re,be.inputTextBuffer),webviewResults:Fe};W.push(X)}});const te={resource:O,cellResults:W};q.set(O,te);return}catch{return}});return await Promise.all(V),{limitHit:G,results:[...q.values()]}}async z(D,y){const S=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==v.$Dl&&typeof S.mtime=="number"&&typeof S.size=="number"&&y.mtime<S.mtime&&y.etag!==v.$El({mtime:y.mtime,size:S.size}))throw new v.$tl((0,w.localize)(1,null),v.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===i.Schemas.file?D.fsPath:D.toString()}B(D,y,S){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const k=new n.$Aoc(y,this.d,D,S.visibleRanges.map(r.NotebookRange.to),S.selections.map(r.NotebookRange.to),typeof S.viewColumn=="number"?r.ViewColumn.to(S.viewColumn):void 0);this.h.set(y,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const S of D.value.removedDocuments){const k=R.URI.revive(S),g=this.g.get(k);g&&(g.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(g.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===k.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const S=[];for(const k of D.value.addedDocuments){const g=R.URI.revive(k.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const b=new h.$zoc(this.c,this.q,this.r,g,k);S.push(...k.cells.map(F=>h.$yoc.asModelAddData(F))),this.g.get(g)?.dispose(),this.g.set(g,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const S of D.value.addedEditors){if(this.h.has(S.id))return;const k=R.URI.revive(S.documentUri),g=this.g.get(k);g&&this.B(g,S.id,S)}const y=[];if(D.value.removedEditors)for(const S of D.value.removedEditors){const k=this.h.get(S);k&&(this.h.delete(S),this.k?.id===k.id&&(this.k=void 0),y.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const S=new Set;this.l.forEach(k=>S.add(k.id));for(const k of this.h.values()){const g=S.has(k.id);k._acceptVisibility(g)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=d.$SP.String.with("notebookType","A notebook type"),S=new d.$UP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new d.$SP("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>C.$Ne.wrap(g))],new d.$TP("Notebook Data",g=>r.NotebookData.to(g.value))),k=new d.$UP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new d.$SP("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new a.$Pw(r.NotebookData.from(g)))],new d.$TP("Bytes",g=>g.buffer));D.registerApiCommand(S),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Joc=$}),define(Ce[311],Ie([1,0,20,22,48,41,24,70,43]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=void 0,w=qe(w),M=qe(M),A=qe(A);class c{constructor(l,E,d){this.k=l,this.l=E,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$yk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$yk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const E=this.k.folderQueries||[];return new Promise((d,r)=>{const o=a=>{this.f++,l(a)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const h=a.toString(),n=w.$oc(h);this.j&&this.j(h,n)||this.v(o,{base:a,basename:n})}),Promise.all(E.map(a=>this.p(a,o))).then(a=>{d({limitHit:this.e,stats:a[0]||void 0})},a=>{r(new Error((0,P.$pj)(a)))})})}async p(l,E){const d=new C.$we,r=this.q(l),o=this.r(),a=new p.$EL(this.k,l),h=!a.hasSiblingExcludeClauses();let n;try{this.h.add(d),n=N.$fe.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),i=n.elapsed(),t=N.$fe.create();return this.g&&!this.e||(s&&s.forEach(m=>{const f=w.$hc.relative(l.folder.path,m.path);if(h){const u=w.$oc(m.path);this.v(E,{base:l.folder,relativePath:f,basename:u});return}this.s(o,l.folder,f,E)}),this.g&&!this.e)?null:(this.u(o,a,E),{providerTime:i,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(l){const E=(0,p.$DL)(this.k.includePattern,l.includePattern),d=(0,p.$DL)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:d,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},E,d,r){if(d===this.a){const a=w.$oc(this.a);this.v(r,{base:E,relativePath:this.a,basename:a})}function o(a){const h=w.$oc(a),n=w.$nc(a);let s=l[n];s||(s=l[n]=[],o(n)),s.push({base:E,relativePath:a,basename:h})}o(d)}u({rootEntries:l,pathToEntries:E},d,r){const o=this,a=this.a;function h(n){const s=(0,p.$GL)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const m=n[i],{relativePath:f,basename:u}=m;if(d.matchesExcludesSync(f,u,a!==u?s:void 0))continue;const $=E[f];if($)h($);else{if(f===a)continue;o.v(r,m)}if(o.e)break}}h(l)}v(l,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,E,d,r){const o=this.c(l.cacheKey),a=new c(l,E,o&&o.token);let h=0;const n=s=>{h+=s.length,d(s.map(i=>this.d(i)))};return this.e(a,R.a,n,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:s.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new C.$we),this.b.get(l)}d(l){return l.relativePath?{resource:A.$fh(l.base,l.relativePath)}:{resource:l.base}}e(l,E,d,r){const o=r.onCancellationRequested(()=>{l.cancel()}),a=n=>{n&&(h.push(n),E>0&&h.length>=E&&(d(h),h=[]))};let h=[];return l.search(a).then(n=>(h.length&&d(h),o.dispose(),n),n=>(h.length&&d(h),o.dispose(),Promise.reject(n)))}}e.$Boc=R}),define(Ce[312],Ie([1,0,18,282,41,103,29,16,20,24,13,15,2,102,205,42,12,50,117,308,43]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=void 0,e.$FM=y,w=qe(w),C=qe(C),P=qe(P),p=qe(p),R=qe(R),d=qe(d);let i=class{constructor(k,g,b,F,T){this.a=k,this.b=g,this.c=b,this.d=F,this.e=T}text(k,g,b={}){k=this.f(k,b);const F=this.a.getValue(),T=g&&g.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(g?.map(a.$Zi),b),type:s.QueryType.Text,contentPattern:k,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:F.search.usePCRE2||T||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(k,g){const b=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const F={...k,wordSeparators:b.editor.wordSeparators};return this.j(k,g)&&(F.isCaseSensitive=!0),this.k(k)&&(F.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),F}file(k,g={}){return{...this.h(k,g),type:s.QueryType.File,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey,shouldGlobMatchFilePattern:g.shouldGlobSearch}}g(k,g){return k?(k=Array.isArray(k)?k.map($):$(k),g?this.parseSearchPaths(k):{pattern:m(...Array.isArray(k)?k:[k])}):{}}h(k=[],g={}){const b=this.g(g.includePattern,g.expandPatterns),F=this.g(g.excludePattern,g.expandPatterns),T=k.length>1,q=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(O=>this.q(O,g,F)):k.map(O=>this.r(O,g,F,T))).filter(O=>!!O),G={_reason:g._reason,folderQueries:q,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:F.pattern,includePattern:b.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const O=w.$Ib(this.c.groups.flatMap(ge=>ge.editors.map(te=>te.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const W=O.filter(ge=>(0,s.$uL)(G,ge.fsPath)),ce=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ce)),{...G,...ce}}const V=g.extraFileResources&&g.extraFileResources.filter(O=>(0,s.$uL)(G,O.fsPath));return G.extraFileResources=V&&V.length?V:void 0,G}i(k){const g=[],b=new A.$Bc,F={};let T=!1;return k.forEach(q=>{if(q.scheme===N.Schemas.walkThrough)return;if((0,c.$jh)(q)){const V=this.b.getWorkspaceFolder(q)?.uri??q.with({path:p.$nc(q.fsPath)});let O=b.get(V);O||(T=!0,O={folder:V,includePattern:{}},g.push(O),b.set(V,O));const W=p.$mc(V.fsPath,q.fsPath);(0,v.$pg)(O.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(T=!0,F[q.fsPath]=!0)}),{folderQueries:g,includePattern:F,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(k,g){if(g.isSmartCase){if(k.isRegExp){if(R.$8f(k.pattern,!0))return!0}else if(R.$8f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,E.$0C)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const g=ce=>p.$jc(ce)||/^\.\.?([\/\\]|$)/.test(ce),F=(Array.isArray(k)?k:f(k)).map(ce=>{const ge=this.e.resolvedUserHome;return ge?(0,M.$Uw)(ce,ge.scheme===N.Schemas.file?ge.fsPath:ge.path):ce}),T=C.$K(F,ce=>g(ce)?"searchPaths":"exprSegments"),q=(T.exprSegments||[]).map(ce=>R.$nf(ce,"/")).map(ce=>R.$nf(ce,"\\")).map(ce=>(ce[0]==="."&&(ce="*"+ce),u(ce))),G={},V=this.m(T.searchPaths||[]);V&&V.length&&(G.searchPaths=V);const O=q.flat(),W=m(...O);return W&&(G.pattern=W),G}l(k,g){return g.disregardExcludeSettings?void 0:(0,s.$tL)(k,!g.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const g=k.flatMap(F=>{let{pathPortion:T,globPortion:q}=t(F);return q&&(q=I(q)),this.n(T).flatMap(V=>this.o(V,q))}),b=new Map;return g.forEach(F=>{const T=F.searchPath.toString(),q=b.get(T);q?F.pattern&&(q.pattern=q.pattern||{},q.pattern[F.pattern]=!0):b.set(T,{searchPath:F.searchPath,pattern:F.pattern?m(F.pattern):void 0})}),Array.from(b.values())}n(k){if(p.$jc(k)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==N.Schemas.file?[{searchPath:g[0].uri.with({path:k})}]:[{searchPath:l.URI.file(p.$ic(k))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const g=this.b.getWorkspace().folders[0].uri;if(k=$(k),k.startsWith("../")||k===".."){const F=p.$hc.resolve(g.path,k);return[{searchPath:g.with({path:F})}]}const b=I(k);return[{searchPath:g,pattern:b}]}else{if(k==="./"||k===".\\")return[];{const g=k.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(T=>{const q=g.match(new RegExp(`^${R.$hf(T.name)}(?:/(.*)|$)`));return q?{match:q,folder:T}:null}).filter(v.$mg);if(F.length)return F.map(T=>{const q=T.match[1];return{searchPath:T.folder.uri,pattern:q&&I(q)}});{const T=k.match(/\.[\/\\](.+)[\/\\]?/),q=T?T[1]:k,G=d.localize(0,null,q);throw new Error(G)}}}}o(k,g){const b=k.pattern&&g?`${k.pattern}/${g}`:k.pattern||g,F=[{searchPath:k.searchPath,pattern:b}];return b&&!b.endsWith("**")&&F.push({searchPath:k.searchPath,pattern:b+"/**"}),F}q(k,g,b){const F=this.r((0,a.$Zi)(k.searchPath),g,b,!1);return F?{...F,includePattern:k.pattern}:null}r(k,g,b,F){let T;const q=l.URI.isUri(k)?k:k.uri;if(b.searchPaths){const ce=b.searchPaths.filter(ge=>(0,c.$$g)(ge.searchPath,q))[0];if(ce&&!ce.pattern)return null;ce&&(T=ce.pattern)}const G=this.a.getValue({resource:q}),O={...this.l(G,g)||{},...T||{}},W=l.URI.isUri(k)?(0,c.$ch)(k):k.name;return{folder:q,folderName:F?W:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!G.search.followSymlinks}}};e.$EM=i,e.$EM=i=He([We(0,r.$$i),We(1,a.$Ni),We(2,h.$fE),We(3,o.$$j),We(4,n.$CM)],i);function t(S){const k=S.match(/[\*\{\}\(\)\[\]\?]/);if(k){const g=k.index,b=S.substr(0,g).match(/[/|\\][^/\\]*$/);if(b){let F=S.substr(0,b.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:S.substr((b.index||0)+1)}}}return{pathPortion:S}}function m(...S){return S.length?S.reduce((k,g)=>(k[g]=!0,k),Object.create(null)):void 0}function f(S){return P.$wk(S,",").map(k=>k.trim()).filter(k=>!!k.length)}function u(S){return[`**/${S}/**`,`**/${S}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function $(S){return S.replace(/\\/g,"/")}function I(S){return $(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(S){return S.replace(/([?*[\]])/g,"[$1]")}function y(S,k){S=w.$Nb(S,F=>F.toString());const g=[],b=k.getWorkspace();return S&&S.forEach(F=>{let T;if(k.getWorkbenchState()===a.WorkbenchState.FOLDER)T=(0,c.$hh)(b.folders[0].uri,F),T&&T!=="."&&(T="./"+T);else{const q=k.getWorkspaceFolder(F);if(q){const G=q.name;if(b.folders.filter(O=>O.name===G).length===1){const O=(0,c.$hh)(q.uri,F);O===""?T=`./${q.name}`:T=`./${q.name}/${O}`}else T=F.fsPath}}T&&g.push(D(T))}),g}}),define(Ce[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oxb=l,e.$pxb=r,w=qe(w),M=qe(M);const v=7e3;function l(o,a){const h=a.activationEvents;if(!h)return Promise.resolve(void 0);const n=[],s=[];for(const $ of h)if(/^workspaceContains:/.test($)){const I=$.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||o.forceUsingSearch?s.push(I):n.push(I)}if(n.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,R.$xh)(),m=$=>t({activationEvent:$}),f=Promise.all(n.map($=>E(o,$,m))).then(()=>{}),u=d(o,a.identifier,s,m);return Promise.all([f,u]).then(()=>{t(void 0)}),i}async function E(o,a,h){for(const n of o.folders)if(await o.exists(w.$fh(C.URI.revive(n),a))){h(`workspaceContains:${a}`);return}}async function d(o,a,h,n){if(h.length===0)return Promise.resolve(void 0);const s=new P.$we,i=o.checkExists(o.folders,h,s.token),t=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},v);let m=!1;try{m=await i}catch(f){M.$5(f)||M.$2(f)}s.dispose(),clearTimeout(t),m&&n(`workspaceContains:${h.join(",")}`)}function r(o,a,h,n){const s=o.get(A.$Di),i=o.get(p.$lL),m=s.createInstance(N.$EM).file(a.map(f=>(0,c.$Zi)(C.URI.revive(f))),{_reason:"checkExists",includePattern:h,exists:!0});return i.fileSearch(m,n).then(f=>!!f.limitHit,f=>M.$5(f)?!1:Promise.reject(f))}}),define(Ce[46],Ie([1,0,181,20,65,24,11,5,59,2,12,6,45,247,89,44,25,118,14,19,23,229,7,109,3,27,92,17,75,93,57,95,4,313,88,231,16,86,70,21,87]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u,$,I,D,y,S,k,g,b,F,T,q,G,V,O,W){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=e.$boc=e.$aoc=e.$_nc=e.$$nc=void 0,w=qe(w),C=qe(C),P=qe(P),h=qe(h),e.$$nc=(0,f.$Ei)("IHostUtils");let ge=ce=class extends N.$Vc{constructor(X,B,_,we,ae,ve,ue,Z,Y,pe,$e,Ne,Ue){super(),this.Y=Ne,this.Z=Ue,this.a=this.B(new g.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=_,this.f=ue,this.j=we,this.m=ae,this.s=ve,this.t=Y,this.u=pe,this.w=$e,this.y=this.g.getProxy(v.$1M.MainThreadWorkspace),this.z=this.g.getProxy(v.$1M.MainThreadTelemetry),this.C=this.g.getProxy(v.$1M.MainThreadExtensionService),this.D=new A.$Dh,this.F=new A.$Dh,this.G=new A.$Dh,this.H=new A.$Dh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new a.$Ebc(this.I,this.f.extensions.allExtensions);const ke=new n.$qn(this.f.extensions.myExtensions);this.J=new a.$Ebc(this.I,be(this.L,ke)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$Tnc(this.g,this.s),this.N=new F.$4nc(this.g),this.O=Z,this.h=X.createChild(new D.$Ci([d.$Unc,this.M],[F.$5nc,this.N])),this.P=this.B(new E.$Snc(this.J,this.L,{onExtensionActivationError:(Re,Me,z)=>{this.C.$onExtensionActivationError(Re,h.$4(Me),z)},actualActivateExtension:async(Re,Me)=>{if(a.$Ebc.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Me),new E.$Rnc;const z=this.J.getExtensionDescription(Re);return this.fb(z,Me)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){h.$2(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(X)}terminate(X,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(we=>{this.s.error(we)}),this.g.dispose();const _=this.$();Promise.race([(0,A.$Fh)(5e3),_]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const B=await this.C.$getExtension(X);return B&&{...B,identifier:new n.$pn(B.identifier.value),extensionLocation:c.URI.revive(B.extensionLocation)}}ab(X,B){return this.P.activateByEvent(X,B)}bb(X,B){return this.P.activateById(X,B)}activateByIdWithErrors(X,B){return this.bb(X,B).then(()=>{const _=this.P.getActivatedExtension(X);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===q.Schemas.file&&this.c.fsRealpath){const B=X.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const _=await this.R.get(B);return c.URI.file(_)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new re(X))),this.Q}async db(X){const B=p.$Ki.forUris(_=>M.$9g.ignorePathCasing(_));return await Promise.all(X.map(async _=>{if(this.wb(_)){const we=await this.cb(_.extensionLocation);B.set(we,_)}})),B}eb(X){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return B;const _=this.P.getActivatedExtension(X);if(!_)return B;try{typeof _.module.deactivate=="function"&&(B=Promise.resolve(_.module.deactivate()).then(void 0,we=>(this.s.error(we),Promise.resolve(void 0))))}catch(we){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(we)}try{(0,N.$Qc)(_.subscriptions)}catch(we){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(we)}return B}async fb(X,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,B).then(_=>{const we=_.activationTimes;return this.C.$onDidActivateExtension(X.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,B),this.gb(X,B,"success",we),_},_=>{throw this.gb(X,B,"failure"),_})}gb(X,B,_,we){const ae=me(X,B);this.z.$publicLog2("extensionActivationTimes",{...ae,...we||{},outcome:_})}hb(X,B){const _=me(X,B);this.z.$publicLog2("activatePlugin",_);const we=this.wb(X);if(!we)return Promise.resolve(new E.$Qnc(E.$Nnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${X.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ae=new E.$Onc(B.startup);return Promise.all([this.xb(X,(0,M.$fh)(X.extensionLocation,we),ae),this.ib(X)]).then(ve=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),ce.jb(this.s,X.identifier,ve[0],ve[1],ae))).then(ve=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),ve))}ib(X){const B=this.Z.createLanguageModelAccessInformation(X),_=new i.$Wnc(X,this.M),we=new i.$Vnc(X.identifier.value,!1,this.M),ae=new T.$6nc(X,this.N),ve=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ue=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([_.whenReady,we.whenReady,this.O.whenReady]).then(()=>{const Z=this;let Y,pe;const $e=(0,o.$3G)(X,"ipc")?this.f.messagePorts?.get(n.$pn.toKey(X.identifier)):void 0;return Object.freeze({globalState:_,workspaceState:we,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return B},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(Ne){return C.$kc(X.extensionLocation.fsPath,Ne)},get storagePath(){return Z.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return Z.O.globalValue(X).fsPath},get logPath(){return C.$kc(Z.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return c.URI.joinPath(Z.f.logsLocation,X.identifier.value)},get storageUri(){return Z.O.workspaceValue(X)},get globalStorageUri(){return Z.O.globalValue(X)},get extensionMode(){return ve},get extension(){return Y===void 0&&(Y=new de(Z,X.identifier,X,ue,!1)),Y},get extensionRuntime(){return(0,o.$4G)(X,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!pe){if(!$e)return;const Ne=g.Event.buffer(g.Event.fromDOMEventEmitter($e,"message",Ue=>Ue.data));$e.start(),pe={onDidReceiveMessage:Ne,postMessage:$e.postMessage.bind($e)}}return pe}})})}static jb(X,B,_,we,ae){return _=_||{activate:void 0,deactivate:void 0},this.kb(X,B,_,we,ae).then(ve=>new E.$Pnc(!1,null,ae.build(),_,ve,we.subscriptions))}static kb(X,B,_,we,ae){if(typeof _.activate=="function")try{ae.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ve=typeof global=="object"?global:self,ue=_.activate.apply(ve,[we]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(ue).then(Z=>(ae.activateResolveStop(),Z))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(_)}lb(X,B){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:B}).then(void 0,_=>{this.s.error(_)})}mb(X,B=0){const we=Date.now();(0,O.$B)(()=>{for(let ae=B;ae<X.length;ae+=1){const ve=X[ae];for(const ue of ve.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-we>50){this.mb(X,ae);break}else this.lb(ve,ue)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const B=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),_=this.J.getAllExtensionDescriptions();if(B)this.mb(_);else for(const we of _)if(we.activationEvents)for(const ae of we.activationEvents)ae==="onStartupFinished"&&this.lb(we,ae)})}ob(){const X=this.ab("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.pb(ve.added)));const B=this.j.workspace?this.j.workspace.folders:[],_=this.pb(B),we=this.rb(),ae=Promise.all([we,X,_]).then(()=>{});return Promise.race([ae,(0,A.$Fh)(1e4)]).then(()=>{this.nb()}),ae}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(X,B))).then(()=>{})}async qb(X,B){if(this.isActivated(B.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.s,folders:X.map(ve=>ve.uri),forceUsingSearch:_||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,ue,Z)=>this.y.$checkExists(ve,ue,Z)},ae=await(0,b.$oxb)(we,B);if(ae)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ae.activationEvent}).then(void 0,ve=>this.s.error(ve))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:B}=this.f.environment;if(!X||!B)throw new Error(w.localize(0,null));const _=await this.xb(null,B,new E.$Onc(!1));if(!_||typeof _.run!="function")throw new Error(w.localize(1,null,B.toString()));return new Promise((we,ae)=>{const ve=(Y,pe)=>{Y?(O.$t&&this.s.error("Test runner called back with error",Y),ae(Y)):(O.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),we(typeof pe=="number"&&pe>0?1:0))},ue=(0,M.$6g)(B),Z=_.run(ue,ve);Z&&Z.then&&Z.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),we(0)}).catch(Y=>{O.$t&&this.s.error("Test runner finished with error",Y),ae(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Fh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,B){return this.S[X]=B,(0,N.$Tc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:B}=await this.ub(X);return B?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const B=X.indexOf("+");if(B===-1)throw new t.$9M("Not an authority that can be resolved!",m.RemoteAuthorityResolverErrorCode.InvalidAuthority);const _=X.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.S[_]}}async $resolveAuthority(X,B){const _=V.$fe.create(!1),we=()=>`[resolveAuthority(${(0,m.$Tl)(X)},${B})][${_.elapsed()}ms] `,ae=U=>this.s.info(`${we()}${U}`),ve=U=>this.s.warn(`${we()}${U}`),ue=(U,K=void 0)=>this.s.error(`${we()}${U}`,K),Z=U=>{if(U instanceof t.$9M)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},Y=async U=>{ae(`activating resolver for ${U}...`);const{resolver:K,authorityPrefix:J}=await this.ub(U);if(!K)throw ue(`no resolver for ${J}`),new t.$9M(`No remote extension installed to resolve ${J}.`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:J,remoteAuthority:U}},pe=X.split(/@|%40/g).reverse();ae(`activating remote resolvers ${pe.join(" -> ")}`);let $e;try{$e=await Promise.all(pe.map(Y)).catch(async U=>{if(!(U instanceof t.$9M)||U._code!==m.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return ve(`resolving nested authorities failed: ${U.message}`),[await Y(X)]})}catch(U){return Z(U)}const Ne=new A.$Ph;Ne.cancelAndSet(()=>ae("waiting..."),1e3);let Ue,ke;for(const[U,{authorityPrefix:K,resolver:J,remoteAuthority:ne}]of $e.entries())try{if(U===$e.length-1)ae("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),Ue=await J.resolve(ne,{resolveAttempt:B,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$8M.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(ae(`invoking resolveExecServer() for ${ne}`),P.mark(`code/extHost/willResolveExecServer/${K}`),ke=await J.resolveExecServer?.(ne,{resolveAttempt:B,execServer:ke}),!ke)throw new t.$9M(`Exec server was not available for ${ne}`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(fe){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),ue("returned an error",fe),Ne.dispose(),Z(fe)}Ne.dispose();const Re={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Me={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$8M.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let z;if(t.$8M.isManagedResolvedAuthority(Ue)){const U=B;this.Y.setFactory(U,Ue.makeConnection),z={authority:X,connectTo:new m.$Ql(U),connectionToken:Ue.connectionToken}}else z={authority:X,connectTo:new m.$Rl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:z,options:Me,tunnelInformation:Re}}}async $getCanonicalURI(X,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,m.$Tl)(X)})`);const{resolver:_}=await this.ub(X);if(!_)return null;const we=c.URI.revive(B);if(typeof _.getCanonicalURI>"u")return we;const ae=await(0,A.$wh)(()=>_.getCanonicalURI(we));return ae||we}async $startExtensionHost(X){X.toAdd.forEach(ve=>ve.extensionLocation=c.URI.revive(ve.extensionLocation));const{globalRegistry:B,myExtensions:_}=te(this.I,this.L,this.J,X),we=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(B.getAllExtensionDescriptions()),this.J.set(_),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(X,B){return B===o.ActivationKind.Immediate?this.D.wait().then(_=>this.ab(X,!1)):this.G.wait().then(_=>this.ab(X,!1))}async $activate(X,B){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,B),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(ve=>ve.extensionLocation=c.URI.revive(ve.extensionLocation));const{globalRegistry:B,myExtensions:_}=te(this.I,this.L,this.J,X),we=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(B.getAllExtensionDescriptions()),this.J.set(_),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const B=s.$Ne.alloc(X),_=Math.random()%256;for(let we=0;we<X;we++)B.writeUInt8(_,we);return B}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$_nc=ge,e.$_nc=ge=ce=He([We(0,f.$Di),We(1,e.$$nc),We(2,I.$uP),We(3,r.$wnc),We(4,l.$znc),We(5,R.$$j),We(6,u.$KP),We(7,$.$Cnc),We(8,y.$4Eb),We(9,S.$Xnc),We(10,G.$8nc),We(11,W.$9nc),We(12,k.$2nc)],ge);function te(Fe,X,B,_){Fe.addActivationEvents(_.addActivationEvents);const we=new a.$Ebc(Fe,X.getAllExtensionDescriptions());we.deltaExtensions(_.toAdd,_.toRemove);const ae=new n.$qn(B.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of _.myToRemove)ae.delete(ue);for(const ue of _.myToAdd)ae.add(ue);const ve=be(we,ae);return{globalRegistry:we,myExtensions:ve}}function me(Fe,X){return{id:Fe.identifier.value,name:Fe.name,extensionVersion:Fe.version,publisherDisplayName:Fe.publisher,activationEvents:Fe.activationEvents?Fe.activationEvents.join(","):null,isBuiltin:Fe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function se(Fe){return Fe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$aoc=(0,f.$Ei)("IExtHostExtensionService");class de{#e;#t;#i;constructor(X,B,_,we,ae){this.#e=X,this.#t=B,this.#i=_.identifier,this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=C.$ic((0,M.$6g)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=we,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$boc=de;function be(Fe,X){return Fe.getAllExtensionDescriptions().filter(B=>X.has(B.identifier))}class re{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$coc=re;class Pe{constructor(X){this.a=new n.$rn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const B of Object.keys(X))this.a.set(B,X[B])}}}),define(Ce[314],Ie([1,0,65,2,6,45,25,19,17,27,3,46,12,13]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0,w=qe(w);let r=class{constructor(s,i,t,m,f,u,$){this.c=s,this.d=i,this.e=t,this.f=m,this.g=f,this.h=u,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,s,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,i,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const i of s.nodeModuleName)this.a.set(i,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(i=>s.alternativeModuleName(i))}};e.$mpc=r,e.$mpc=r=He([We(2,R.$Di),We(3,M.$znc),We(4,v.$aoc),We(5,c.$KP),We(6,l.$$j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&d.a.size){const i=(0,E.$hf)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",m=`@${t}+\\/${t}+|${t}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${f}\\/)(${m})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const i=this.b.exec(this.c(s));if(!i)return;const[,t,m,f]=i,u=d.a.get(m);if(u!==void 0)return console.warn(`${m} as been renamed to ${u}, please update your imports`),t+u+f}c(s){return s.replace(/\\/g,"/")}};o=d=He([We(0,c.$KP)],o);class a{constructor(s,i,t,m,f){this.c=s,this.d=i,this.e=t,this.f=m,this.g=f,this.nodeModuleName="vscode",this.a=new N.$rn}load(s,i){const t=this.d.findSubstr(i);if(t){let m=this.a.get(t.identifier);return m||(m=this.c(t,this.e,this.f),this.a.set(t.identifier,m)),m}if(!this.b){let m="";this.d.forEach((f,u)=>m+=`	${u} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${m}`),this.b=this.c(A.$XG,this.e,this.f)}return this.b}}let h=class{constructor(s,i,t){this.e=s,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$1M.MainThreadTelemetry);const m=t.getProxy(P.$1M.MainThreadWindow);this.c=(f,u)=>{const $=C.URI.parse(f);return u?this.g(f,u):$.scheme==="http"||$.scheme==="https"?m.$openUri($,f,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?m.$openUri($,f,{}):this.g(f,u)}}load(s,i,t){const m=this.e.findSubstr(i);return m&&(this.a=m.identifier.value,this.h()),this.b=t(s),this.c}g(s,i){return this.i(),this.b(s,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([We(2,p.$uP)],h)}),define(Ce[131],Ie([1,0,47,5,20,79,3,58,71,46,7,44,244,45]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=e.$doc=void 0,P=qe(P),M=qe(M),e.$doc=(0,A.$Ei)("IExtHostVariableResolverProvider");class d extends l.$yQ{constructor(a,h,n,s,i,t,m){function f(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const $=s.tabGroups.all.find(I=>I.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$OO||$.input instanceof R.$TO)return $.input.modified;if($.input instanceof R.$NO||$.input instanceof R.$SO||$.input instanceof R.$QO)return $.input.uri}}}super({getFolderUri:u=>{const $=t.folders.filter(I=>I.name===u);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,$)=>i.getConfiguration(void 0,u).get($),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=f();if(u)return P.$ic(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const u=f();if(u){const $=h.getWorkspaceFolder(u);if($)return P.$ic($.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>a.getExtension(u)},void 0,m?Promise.resolve(m):void 0,Promise.resolve(M.env))}}let r=class extends C.$Vc{constructor(a,h,n,s,i){super(),this.b=a,this.c=h,this.g=n,this.h=s,this.j=i,this.a=new w.$W(async()=>{const t=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$eoc=r,e.$eoc=r=He([We(0,c.$aoc),We(1,v.$wnc),We(2,N.$FP),We(3,E.$znc),We(4,p.$Lnc)],r)}),define(Ce[132],Ie([1,0,11,4,2,5,19,3,6,71,46,17,7,44,236,81,237,45,131,35,34,10,18,96]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=e.$moc=e.$loc=e.$koc=void 0,i=qe(i),e.$koc=(0,N.$Ei)("IExtHostDebugService");let f=class extends M.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(k,g,b,F,T,q,G,V){super(),this.Y=g,this.Z=b,this.$=F,this.ab=T,this.bb=q,this.cb=G,this.db=V,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new C.$le),this.z=this.B(new C.$le),this.C=this.B(new C.$le),this.F=this.B(new C.$le),this.u=k.getProxy(p.$1M.MainThreadDebugService),this.I=this.B(new C.$le),this.L=this.B(new C.$le),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(O=>{this.B(O.onDidChange(W=>{this.fb(O)})),this.fb(O)})}async $getVisualizerTreeItem(k,g){const b=this.gb(g);if(!b)return;const F=await this.Q.get(k)?.getTreeItem?.(b);return F?this.eb(k,F):void 0}registerDebugVisualizationTree(k,g,b){const F=A.$pn.toKey(k.identifier),T=this.ub(F,g);if(this.P.has(T))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.Q.set(T,b),this.u.$registerDebugVisualizerTree(T,!!b.editItem),(0,M.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(T),this.Q.delete(g)})}async $getVisualizerTreeItemChildren(k,g){const b=this.S.get(g)?.item;return b?(await this.Q.get(k)?.getChildren?.(b))?.map(T=>this.eb(k,T))||[]:[]}async $editVisualizerTreeItem(k,g){const b=this.S.get(k);if(!b)return;const F=await this.Q.get(b.provider)?.editItem?.(b.item,g);return this.eb(b.provider,F||b.item)}$disposeVisualizedTree(k){const g=this.S.get(k);if(!g)return;const b=[g.children];for(const F of b)if(F)for(const T of F)b.push(this.S.get(T)?.children),this.S.delete(T)}eb(k,g){let b=this.R.get(g);return b||(b=this.O++,this.R.set(g,b),this.S.set(b,{provider:k,item:g})),i.DebugTreeItem.from(g,b)}asDebugSourceUri(k,g){const b=k;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let F=`debug:${encodeURIComponent(b.path||"")}`,T="?";return g&&(F+=`${T}session=${encodeURIComponent(g.id)}`,T="&"),F+=`${T}ref=${b.sourceReference}`,P.URI.parse(F)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(k){const g=[];for(const b of k.getAllExtensionDescriptions())if(b.contributes){const F=b.contributes.debuggers;if(F&&F.length>0)for(const T of F)(0,o.$TH)(T)&&g.push(T.type)}this.u.$registerDebugTypes(g)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const k=[];return this.H.forEach(g=>k.push(g)),k}async $resolveDebugVisualizer(k,g){const b=this.W.get(k);if(!b)throw new Error(`No debug visualizer found with id '${k}'`);let{v:F,provider:T,extensionId:q}=b;if(F.visualization||(F=await T.resolveDebugVisualization?.(F,g)||F,b.v=F),!F.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${T}'`);return this.vb(q,F.visualization)}async $executeDebugVisualizerCommand(k){const g=this.W.get(k);if(!g)throw new Error(`No debug visualizer found with id '${k}'`);const b=g.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(k){const g=this.w.get(k.sessionId);return g&&{session:g.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,g,b,F){const T=this.gb(b),q=this.ub(k,g),G=this.P.get(q);if(!T||!G)return[];const V=await G.provideDebugVisualization(T,F);return V?V.map(O=>{const W=++this.X;this.W.set(W,{v:O,provider:G,extensionId:k});const ce=O.iconPath?this.wb(O.iconPath):void 0;return{id:W,name:O.name,iconClass:ce?.iconClass,iconPath:ce?.iconPath,visualization:this.vb(k,O.visualization)}}):[]}$disposeDebugVisualizers(k){for(const g of k)this.W.delete(g)}registerDebugVisualizationProvider(k,g,b){if(!k.contributes?.debugVisualizers?.some(q=>q.id===g))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${g})`);const F=A.$pn.toKey(k.identifier),T=this.ub(F,g);if(this.P.has(T))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.P.set(T,b),this.u.$registerDebugVisualizer(F,g),(0,M.$Tc)(()=>{this.u.$unregisterDebugVisualizer(F,g),this.P.delete(g)})}addBreakpoints(k){const g=k.filter(T=>{const q=T.id;return this.H.has(q)?!1:(this.H.set(q,T),!0)});this.rb(g,[],[]);const b=[],F=new Map;for(const T of g)if(T instanceof l.$5N){let q=F.get(T.location.uri.toString());q||(q={type:"sourceMulti",uri:T.location.uri,lines:[]},F.set(T.location.uri.toString(),q),b.push(q)),q.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character,mode:T.mode})}else T instanceof l.$6N&&b.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName,mode:T.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(k){const g=k.filter(q=>this.H.delete(q.id));this.rb([],g,[]);const b=g.filter(q=>q instanceof l.$5N).map(q=>q.id),F=g.filter(q=>q instanceof l.$6N).map(q=>q.id),T=g.filter(q=>q instanceof l.$7N).map(q=>q.id);return this.u.$unregisterBreakpoints(b,F,T)}startDebugging(k,g,b){const F=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(k?k.uri:void 0,g,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===l.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:F&&{runId:F.runId,taskId:F.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(k){return this.u.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,g,b){if(!g)return new l.$3M(()=>{});const F=this.f++;return this.g.push({type:k,handle:F,provider:g}),this.u.$registerDebugConfigurationProvider(k,b,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,F),new l.$3M(()=>{this.g=this.g.filter(T=>T.provider!==g),this.u.$unregisterDebugConfigurationProvider(F)})}registerDebugAdapterDescriptorFactory(k,g,b){if(!b)return new l.$3M(()=>{});if(!this.nb(k,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.kb(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const F=this.h++;return this.j.push({type:g,handle:F,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(g,F),new l.$3M(()=>{this.j=this.j.filter(T=>T.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(F)})}registerDebugAdapterTrackerFactory(k,g){if(!g)return new l.$3M(()=>{});const b=this.m++;return this.n.push({type:k,handle:b,factory:g}),new l.$3M(()=>{this.n=this.n.filter(F=>F.factory!==g)})}async $runInTerminal(k,g){return Promise.resolve(void 0)}async $substituteVariables(k,g){let b;const F=await this.tb(k);return F&&(b={uri:F.uri,name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,g)}hb(k,g){if(k.type==="implementation")return new D(k.implementation)}ib(){}async $startDASession(k,g){const b=this,F=await this.sb(g);return this.pb(this.kb(F.type),F).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}' (extension might have failed to activate)`);const q=this.jb(T),G=this.hb(q,F);if(!G)throw new Error(`Couldn't create a debug adapter for type '${F.type}'.`);const V=G;return this.M.set(k,V),this.ob(F).then(O=>(O&&this.N.set(k,O),V.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const ce=W,ge={type:"response",seq:0,command:ce.command,request_seq:ce.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const te=await this.U.sign(ce.arguments.value);ge.body={signature:te},V.sendResponse(ge)}else throw new Error("no signer")}catch(te){ge.success=!1,ge.message=te.message,V.sendResponse(ge)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(W),W=(0,o.$YH)(W,!0),b.u.$acceptDAMessage(k,W)}),V.onError(W=>{O&&O.onError&&O.onError(W),this.u.$acceptDAError(k,W.name,W.message,W.stack)}),V.onExit(W=>{O&&O.onExit&&O.onExit(W??void 0,void 0),this.u.$acceptDAExit(k,W??void 0,void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),V.startSession()))})}$sendDAMessage(k,g){g=(0,o.$XH)(g,!1);const b=this.N.get(k);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(g),this.M.get(k)?.sendMessage(g)}$stopDASession(k){const g=this.N.get(k);this.N.delete(k),g&&g.onWillStopSession&&g.onWillStopSession();const b=this.M.get(k);return this.M.delete(k),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const g=[],b=[],F=[];if(k.added)for(const T of k.added){const q=T.id;if(q&&!this.H.has(q)){let G;if(T.type==="function")G=new l.$6N(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage,T.mode);else if(T.type==="data")G=new l.$7N(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage,T.mode);else{const V=P.URI.revive(T.uri);G=new l.$5N(new l.$cN(V,new l.$4M(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage,T.mode)}(0,l.$3N)(G,q),this.H.set(q,G),g.push(G)}}if(k.removed)for(const T of k.removed){const q=this.H.get(T);q&&(this.H.delete(T),b.push(q))}if(k.changed){for(const T of k.changed)if(T.id){const q=this.H.get(T.id);if(q){if(q instanceof l.$6N&&T.type==="function"){const G=q;G.enabled=T.enabled,G.condition=T.condition,G.hitCondition=T.hitCondition,G.logMessage=T.logMessage,G.functionName=T.functionName}else if(q instanceof l.$5N&&T.type==="source"){const G=q;G.enabled=T.enabled,G.condition=T.condition,G.hitCondition=T.hitCondition,G.logMessage=T.logMessage,G.location=new l.$cN(P.URI.revive(T.uri),new l.$4M(T.line,T.character))}F.push(q)}}}this.rb(g,b,F)}async $acceptStackFrameFocus(k){let g;if(k){const b=await this.sb(k.sessionId);k.kind==="thread"?g=new l.$aO(b.api,k.threadId):g=new l.$_N(b.api,k.threadId,k.frameId)}this.J=g,this.L.fire(this.J)}$provideDebugConfigurations(k,g,b){return(0,w.$wh)(async()=>{const F=this.mb(k);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.tb(g);return F.provideDebugConfigurations(T,b)}).then(F=>{if(!F)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return F})}$resolveDebugConfiguration(k,g,b,F){return(0,w.$wh)(async()=>{const T=this.mb(k);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const q=await this.tb(g);return T.resolveDebugConfiguration(q,b,F)})}$resolveDebugConfigurationWithSubstitutedVariables(k,g,b,F){return(0,w.$wh)(async()=>{const T=this.mb(k);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const q=await this.tb(g);return T.resolveDebugConfigurationWithSubstitutedVariables(q,b,F)})}async $provideDebugAdapter(k,g){const b=this.lb(k);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const F=await this.sb(g);return this.pb(b,F).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${F.type}'`);return this.jb(T)})}async $acceptDebugSessionStarted(k){const g=await this.sb(k);this.y.fire(g.api)}async $acceptDebugSessionTerminated(k){const g=await this.sb(k);g&&(this.z.fire(g.api),this.w.delete(g.id))}async $acceptDebugSessionActiveChanged(k){this.D=k?await this.sb(k):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(k,g){(await this.sb(k))?._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(k,g){const F={session:(await this.sb(k)).api,event:g.event,body:g.body};this.F.fire(F)}jb(k){if(k instanceof l.$8N)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof l.$9N)return{type:"server",port:k.port,host:k.host};if(k instanceof l.$0N)return{type:"pipeServer",path:k.path};if(k instanceof l.$$N)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}kb(k){const g=this.j.filter(b=>b.type===k);if(g.length>0)return g[0].factory}lb(k){const g=this.j.filter(b=>b.handle===k);if(g.length>0)return g[0].factory}mb(k){const g=this.g.filter(b=>b.handle===k);if(g.length>0)return g[0].provider}nb(k,g){if(k.contributes){const b=k.contributes.debuggers;if(b&&b.length>0){for(const F of b)if(F.label&&F.type&&F.type===g)return!0}}return!1}ob(k){const b=k.configuration.type,F=this.n.filter(T=>T.type===b||T.type==="*").map(T=>(0,w.$wh)(()=>T.factory.createDebugAdapterTracker(k.api)).then(q=>q,q=>null));return Promise.race([Promise.all(F).then(T=>{const q=(0,t.$Ib)(T);if(q.length>0)return new I(q)}),new Promise(T=>setTimeout(()=>T(void 0),1e3))]).catch(T=>{})}async pb(k,g){const b=g.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new l.$9N(b));if(k){const T=await this.Z.getExtensionRegistry();return(0,w.$wh)(()=>k.createDebugAdapterDescriptor(g.api,this.qb(g,T))).then(q=>{if(q)return q})}const F=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(g,F))}qb(k,g){}rb(k,g,b){(k.length>0||g.length>0||b.length>0)&&this.I.fire(Object.freeze({added:k,removed:g,changed:b}))}async sb(k){if(k)if(typeof k=="string"){const g=this.w.get(k);if(g)return g}else{let g=this.w.get(k.id);if(!g){const b=await this.tb(k.folderUri),F=k.parent?this.w.get(k.parent):void 0;g=new u(this.u,k.id,k.type,k.name,b,k.configuration,F?.api),this.w.set(g.id,g),this.u.$sessionCached(g.id)}return g}throw new Error("cannot find session")}tb(k){if(k){const g=P.URI.revive(k);return this.Y.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}ub(k,g){return`${k}\0${g}`}vb(k,g){if(g){if("title"in g&&"command"in g)return{type:r.DebugVisualizationType.Command};if("treeId"in g)return{type:r.DebugVisualizationType.Tree,id:`${k}\0${g.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(k){const g=this.xb(k);let b,F;return"id"in g?F=n.ThemeIcon.asClassName(g):b=g,{iconPath:b,iconClass:F}}xb(k){if(k instanceof l.$ZN)return{id:k.id};const g=typeof k=="object"&&"dark"in k?k.dark:k,b=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof g=="string"?P.URI.file(g):g,light:typeof b=="string"?P.URI.file(b):b}}};e.$loc=f,e.$loc=f=He([We(0,v.$uP),We(1,E.$wnc),We(2,R.$aoc),We(3,a.$znc),We(4,c.$Lnc),We(5,h.$doc),We(6,s.$QP),We(7,m.$foc)],f);class u{constructor(k,g,b,F,T,q,G){this.f=k,this.g=g,this.h=b,this.j=F,this.k=T,this.l=q,this.m=G}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(g){k.j=g,k.f.$setDebugSessionName(k.g,g)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(g,b){return k.f.$customDebugAdapterRequest(k.g,g,b)},getDebugProtocolBreakpoint(g){return k.f.$getDebugProtocolBreakpoint(k.g,g.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$moc=u;class ${constructor(k){this.value=Object.freeze({append(g){k.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.$noc=$;class I{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(g=>g.onError?g.onError(k):void 0)}onExit(k,g){this.d.forEach(b=>b.onExit?b.onExit(k,g):void 0)}}class D extends d.$Usb{constructor(k){super(),this.h=k,k.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends f{constructor(k,g,b,F,T,q,G,V){super(k,g,b,F,T,q,G,V)}};e.$ooc=y,e.$ooc=y=He([We(0,v.$uP),We(1,E.$wnc),We(2,R.$aoc),We(3,a.$znc),We(4,c.$Lnc),We(5,h.$doc),We(6,s.$QP),We(7,m.$foc)],y)}),define(Ce[315],Ie([1,0,14,65,2,6,266,12,61,75,27,211,17,66,46,67]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=e.$npc=void 0,w=qe(w),C=qe(C);class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(N.$$j),t=n.get(l.$uP).getProxy(M.$1M.MainThreadErrors);w.setUnexpectedErrorHandler(m=>{s.error(m);const f=w.$4(m);t.$onUnexpectedError(f)})}static async installFullHandler(n){const s=n.get(N.$$j),i=n.get(l.$uP),t=n.get(d.$aoc),m=n.get(r.$OP),f=i.getProxy(M.$1M.MainThreadExtensionService),u=i.getProxy(M.$1M.MainThreadErrors),$=await t.getExtensionPathIndex(),I=new WeakMap;function D(k,g){if(I.has(k))return I.get(k).stack;let b="",F,T;for(const G of g)b+=`
	at ${G.toString()}`,T=G.getFileName(),!F&&T&&(F=$.findSubstr(P.URI.file(T)));const q=`${k.name||"Error"}: ${k.message||""}${b}`;return I.set(k,{extensionIdentifier:F?.identifier,stack:q}),q}const y=Symbol("prepareStackTrace wrapped");let S=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(k){if(k===D||!k||k[y]){S=k||D;return}S=function(g,b){return D(g,b),k.call(Error,g,b)},Object.assign(S,{[y]:!0})}}),w.setUnexpectedErrorHandler(k=>{s.error(k);const g=w.$4(k),b=I.get(k);if(!b?.extensionIdentifier){u.$onUnexpectedError(g);return}f.$onExtensionRuntimeError(b.extensionIdentifier,g);const F=m.onExtensionError(b.extensionIdentifier,k);s.trace("forwarded error to extension?",F,b)})}}e.$npc=o;class a{constructor(n,s,i,t,m){this.a=i,this.b=new A.$Mbc(n,null,t),s=a.e(s,this.b);const f=new c.$Ci(...(0,p.$Ls)());f.set(R.$KP,{_serviceBrand:void 0,...s,messagePorts:m}),f.set(l.$uP,new l.$vP(this.b)),f.set(E.$tnc,new E.$unc(t)),f.set(d.$$nc,i);const u=new v.$pr(f,!0);u.invokeFunction(o.installEarlyHandler),this.d=u.invokeFunction($=>$.get(N.$$j)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=u.invokeFunction($=>$.get(d.$aoc)),this.c.initialize(),u.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const s=this.b.getProxy(M.$1M.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=P.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>P.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.$opc=a}),define(Ce[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Doc=e.$Coc=void 0,e.$Eoc=r,N=qe(N),p=qe(p);class v{constructor(h,n,s){this.d=h,this.e=n,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,n){const s=this.g.folderQueries||[],i=new P.$we(n);return new Promise((t,m)=>{this.a=new E(h);let f=!1;const u=($,I)=>{if(!f&&!this.b){const D=this.h($);r($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,f=!0,i.cancel(),$=this.j($,this.g.maxResults-this.c));const y=this.h($);this.c+=y,(y>0||!r($))&&this.a.add($,I)}};Promise.all(s.map(($,I)=>this.k($,D=>u(D,I),i.token))).then($=>{i.dispose(),this.a.flush();const I=$.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||I,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{i.dispose();const I=(0,M.$pj)($);m(new Error(I))})})}h(h){return r(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,n){const s=Array.isArray(h.ranges)?h.ranges:[h.ranges],i=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:s.slice(0,n),preview:{matches:i.slice(0,n),text:h.preview.text},uri:h.uri}}async k(h,n,s){const i=new R.$EL(this.g,h),t=[],m={report:$=>{if(!this.l($))return;const I=h.folder.scheme===A.Schemas.file?(0,R.$FL)(()=>this.e.readdir(p.$eh($.uri))):void 0,D=p.$hh(h.folder,$.uri);if(D){const y=i.includedInQuery(D,N.$oc(D),I);(0,C.$qh)(y)?t.push(y.then(S=>{S&&n($)})):y&&n($)}}},f=this.n(h);let u;return this.d.query.type===R.QueryType.aiText?u=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,m,s):u=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),f,m,s),t.length&&await Promise.all(t),u}l(h){if(r(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const n=(0,R.$DL)(this.g.includePattern,h.includePattern),s=(0,R.$DL)(this.g.excludePattern,h.excludePattern),i={folder:c.URI.from(h.folder),excludes:s,includes:n,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$kL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$Coc=v;function l(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(h,n){this.d&&(this.b!==n||!p.$$g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$Doc=E;function d(a){return r(a)?{preview:{matches:(0,w.$2b)(a.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:a.preview.text},ranges:(0,w.$2b)(a.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.a=4e3}static{this.b=50}constructor(h,n){this.g=h,this.h=n,this.c=0,this.d=[],this.e=0}addItem(h,n){h&&this.j(h,n)}addItems(h,n){h&&this.k(h,n)}j(h,n){this.d.push(h),this.e+=n,this.l()}k(h,n){this.d=this.d.concat(h),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Foc=o}),define(Ce[133],Ie([1,0,5,6,3,311,17,66,12,2,316]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=void 0,e.$Ioc=l,e.$Goc=(0,P.$Ei)("IExtHostSearch");let v=class{constructor(r,o,a){this.n=r,this.o=o,this.q=a,this.c=this.n.getProxy(C.$1M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new M.$Boc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const a=this.d++;return this.e.set(a,o),this.c.$registerTextSearchProvider(a,this.s(r)),(0,w.$Tc)(()=>{this.g.delete(r),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const a=this.d++;return this.h.set(a,o),this.c.$registerAITextSearchProvider(a,this.s(r)),(0,w.$Tc)(()=>{this.i.delete(r),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const a=this.d++;return this.j.set(a,o),this.c.$registerFileSearchProvider(a,this.s(r)),(0,w.$Tc)(()=>{this.k.delete(r),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,h){const n=l(a),s=this.j.get(r);if(s)return this.l.fileSearch(n,s,i=>{this.c.$handleFileMatch(r,o,i.map(t=>t.resource))},h);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,h){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const s=l(a);return this.t(s,n).search(t=>this.c.$handleTextMatch(r,o,t),h)}$provideAITextSearchResults(r,o,a,h){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const s=l(a);return this.v(s,n).search(t=>this.c.$handleTextMatch(r,o,t),h)}$enableExtensionHostSearch(){}t(r,o){return new R.$Coc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(r,o){return new R.$Coc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$Hoc=v,e.$Hoc=v=He([We(0,A.$uP),We(1,N.$tnc),We(2,p.$$j)],v);function l(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(E),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>c.URI.revive(r))}}function E(d){return{...d,folder:c.URI.revive(d.folder)}}});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[317],Ie([1,0,22,14,4,5,16,36,2,105,164,150,52,19,30,12,63,64,225,6,269,297,85,91,274,275,276,253,242,34,277,45,278,132,121,279,255,270,280,281,58,71,256,271,46,283,69,284,51,27,298,257,285,95,286,86,87,259,310,288,230,289,299,290,127,260,291,292,293,17,294,133,88,295,261,296,89,92,130,67,57,125,96,300,272,301,302,93,10,7,262,66,263,68,303,304,120,44,81,84,25,129]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u,$,I,D,y,S,k,g,b,F,T,q,G,V,O,W,ce,ge,te,me,se,de,be,re,Pe,Fe,X,B,_,we,ae,ve,ue,Z,Y,pe,$e,Ne,Ue,ke,Re,Me,z,U,K,J,ne,fe,Ae,ze,Ke,_e,it,nt,tt,rt,$t,ut,st,ct,gt,mt,Be,je,H,x,De,Ze,Ye,dt,pt,Ft,zt,xt,ui,xe,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=Gt,C=qe(C),N=ri(N),v=qe(v),d=qe(d),je=qe(je),H=qe(H);function Gt(ht){const bt=ht.get(Pe.$KP),hi=ht.get(re.$enc),_t=ht.get(de.$Bnc),jt=ht.get(me.$aoc),wt=ht.get(zt.$wnc),Bt=ht.get(tt.$OP),Jt=ht.get(k.$znc),Qt=ht.get(De.$tnc),Qe=ht.get(K.$uP),pi=ht.get(_e.$Unc),ei=ht.get(it.$Cnc),si=ht.get(r.$_j),St=ht.get(r.$$j),Kt=ht.get(Be.$4Eb),At=ht.get(t.$anc),Ot=ht.get(Ft.$hpc),ti=ht.get(fe.$5nc),ii=ht.get(ce.$Lnc),oi=ht.get(ve.$9nc),Vt=ht.get(m.$knc),Ht=ht.get(_.$2nc);Qe.set(n.$2M.ExtHostFileSystemInfo,hi),Qe.set(n.$2M.ExtHostLogLevelServiceShape,si),Qe.set(n.$2M.ExtHostWorkspace,wt),Qe.set(n.$2M.ExtHostConfiguration,Jt),Qe.set(n.$2M.ExtHostExtensionService,jt),Qe.set(n.$2M.ExtHostStorage,pi),Qe.set(n.$2M.ExtHostTunnelService,Kt),Qe.set(n.$2M.ExtHostWindow,Ot),Qe.set(n.$2M.ExtHostSecretState,ti),Qe.set(n.$2M.ExtHostTelemetry,Bt),Qe.set(n.$2M.ExtHostEditorTabs,ii),Qe.set(n.$2M.ExtHostManagedSockets,oi),Qe.set(n.$2M.ExtHostAuthentication,Vt),Qe.set(n.$2M.ExtHostChatProvider,Ht);const di=Qe.set(n.$2M.ExtHostDecorations,ht.get(F.$qoc)),Lt=Qe.set(n.$2M.ExtHostDocumentsAndEditors,ht.get(W.$FP)),vt=Qe.set(n.$2M.ExtHostCommands,ht.get(y.$QP)),Ct=Qe.set(n.$2M.ExtHostTerminalService,ht.get(rt.$Xnc)),Tt=Qe.set(n.$2M.ExtHostTerminalShellIntegration,ht.get($t.$0oc)),kt=Qe.set(n.$2M.ExtHostDebugService,ht.get(b.$koc)),Zt=Qe.set(n.$2M.ExtHostSearch,ht.get(ne.$Goc)),qt=Qe.set(n.$2M.ExtHostTask,ht.get(nt.$9oc)),$i=Qe.set(n.$2M.ExtHostOutputService,ht.get(ke.$Voc)),fi=Qe.set(n.$2M.ExtHostLocalization,ht.get(ae.$8nc)),Ri=Qe.set(n.$2M.ExtHostUrls,new Ze.$epc(Qe)),Nt=Qe.set(n.$2M.ExtHostDocuments,new O.$hnc(Qe,Lt)),Ti=Qe.set(n.$2M.ExtHostDocumentContentProviders,new G.$soc(Qe,Lt,St)),ai=Qe.set(n.$2M.ExtHostDocumentSaveParticipant,new V.$toc(St,Nt,Qe.getProxy(n.$1M.MainThreadBulkEdits))),Rt=Qe.set(n.$2M.ExtHostNotebook,new Z.$Joc(Qe,vt,Lt,Nt,_t,Zt,St)),Di=Qe.set(n.$2M.ExtHostNotebookDocuments,new pe.$Poc(Rt)),Si=Qe.set(n.$2M.ExtHostNotebookEditors,new $e.$Qoc(St,Rt)),vi=Qe.set(n.$2M.ExtHostNotebookKernels,new Ne.$Roc(Qe,bt,Rt,vt,St)),Mi=Qe.set(n.$2M.ExtHostNotebookRenderers,new Ue.$Toc(Qe,Rt)),gi=Qe.set(n.$2M.ExtHostNotebookDocumentSaveParticipant,new Y.$Ooc(St,Rt,Qe.getProxy(n.$1M.MainThreadBulkEdits))),Wt=Qe.set(n.$2M.ExtHostEditors,new st.$qnc(Qe,Lt)),ye=Qe.set(n.$2M.ExtHostTreeViews,new mt.$cpc(Qe.getProxy(n.$1M.MainThreadTreeViews),vt,St)),Te=Qe.set(n.$2M.ExtHostEditorInsets,new D.$rnc(Qe.getProxy(n.$1M.MainThreadEditorInsets),Wt,bt.remote)),le=Qe.set(n.$2M.ExtHostDiagnostics,new T.$gnc(Qe,St,hi,Lt)),Q=Qe.set(n.$2M.ExtHostLanguages,new we.$Moc(Qe,Nt,vt.converter,Qt)),Ee=Qe.set(n.$2M.ExtHostLanguageFeatures,new B.$inc(Qe,Qt,Nt,vt,le,St,At,Bt)),Ve=Qe.set(n.$2M.ExtHostFileSystem,new se.$woc(Qe,Ee)),Xe=Qe.set(n.$2M.ExtHostFileSystemEventService,new be.$xoc(Qe,St,Lt)),Ge=Qe.set(n.$2M.ExtHostQuickOpen,(0,U.$Zoc)(Qe,wt,vt)),lt=Qe.set(n.$2M.ExtHostSCM,new J.$2oc(Qe,vt,Nt,St)),Pt=Qe.set(n.$2M.ExtHostQuickDiff,new z.$Yoc(Qe,Qt)),Xt=Qe.set(n.$2M.ExtHostShare,new Ae.$3oc(Qe,Qt)),ci=Qe.set(n.$2M.ExtHostComments,(0,S.$snc)(Qe,vt,Nt)),Ut=Qe.set(n.$2M.ExtHostProgress,new Me.$Xoc(Qe.getProxy(n.$1M.MainThreadProgress))),ni=Qe.set(n.$2M.ExtHostLabelService,new X.$Loc(Qe)),ji=Qe.set(n.$2M.ExtHostTheming,new ct.$_oc(Qe)),Yi=Qe.set(n.$2M.ExtHostTimeline,new gt.$bpc(Qe,vt)),Bi=Qe.set(n.$2M.ExtHostWebviews,new Ye.$Gnc(Qe,bt.remote,wt,St,At)),Oi=Qe.set(n.$2M.ExtHostWebviewPanels,new dt.$Jnc(Qe,Bi,wt)),Vi=Qe.set(n.$2M.ExtHostCustomEditors,new g.$Knc(Qe,Nt,ei,Bi,Oi)),Wi=Qe.set(n.$2M.ExtHostWebviewViews,new pt.$fpc(Qe,Bi)),ki=Qe.set(n.$2M.ExtHostTesting,ht.get(ut.$foc)),xi=Qe.set(n.$2M.ExtHostUriOpeners,new x.$dpc(Qe)),_i=Qe.set(n.$2M.ExtHostProfileContentHandlers,new Re.$Woc(Qe));Qe.set(n.$2M.ExtHostInteractive,new Fe.$Koc(Qe,Rt,Lt,vt,St));const Fi=Qe.set(n.$2M.ExtHostChatAgents2,new u.$nnc(Qe,St,vt,bt.quality)),en=Qe.set(n.$2M.ExtHostChatVariables,new $.$onc(Qe)),qi=Qe.set(n.$2M.ExtHostAiRelatedInformation,new s.$_mc(Qe)),pn=Qe.set(n.$2M.ExtHostAiEmbeddingVector,new te.$voc(Qe)),tn=Qe.set(n.$2M.ExtHostStatusBar,new Ke.$6oc(Qe,vt.converter)),Gi=Qe.set(n.$2M.ExtHostSpeech,new ze.$4oc(Qe)),Ci=Qe.set(n.$2M.ExtHostEmbeddings,new ge.$uoc(Qe)),$n=Object.values(n.$2M);Qe.assertRegistered($n);const bn=new f.$mnc(Qe,Lt),nn=new I.$pnc(Qe),Ki=new ue.$Noc(Qe,St),Li=new q.$roc(Qe);return i.$jnc.register(vt),function(Le,bi,Hi){function ot(ee){return(he,Oe,at)=>{const Dt=ee(Mt=>{try{he.call(Oe,Mt)}catch(Ii){C.$3(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ii.toString()}`,{cause:Ii})),Bt.onExtensionError(Le.identifier,Ii)}});return at?.push(Dt),Dt}}const Et=function(){let ee=!Le.isUnderDevelopment;function he(){ee||(St.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Oe(at){if(Array.isArray(at))at.forEach(Oe);else if(typeof at=="string")he();else{const Dt=at;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,xe.$4G)(Le,"documentFiltersExclusive")}return at}}(),rn={getSession(ee,he,Oe){return typeof Oe?.forceNewSession=="object"&&Oe.forceNewSession.learnMore&&(0,xe.$4G)(Le,"authLearnMore"),Vt.getSession(Le,ee,he,Oe)},getSessions(ee,he){return(0,xe.$4G)(Le,"authGetSessions"),Vt.getSessions(Le,ee,he)},async hasSession(ee,he){return(0,xe.$4G)(Le,"authSession"),!!await Vt.getSession(Le,ee,he,{silent:!0})},get onDidChangeSessions(){return ot(Vt.onDidChangeSessions)},registerAuthenticationProvider(ee,he,Oe,at){return Vt.registerAuthenticationProvider(ee,he,Oe,at)}},yi={registerCommand(ee,he,Oe){return vt.registerCommand(!0,ee,he,Oe,void 0,Le)},registerTextEditorCommand(ee,he,Oe){return vt.registerCommand(!0,ee,(...at)=>{const Dt=Wt.getActiveTextEditor();if(!Dt){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Dt.edit(Mt=>{he.apply(Oe,[Dt,Mt,...at])}).then(Mt=>{Mt||St.warn("Edits from command "+ee+" were not applied.")},Mt=>{St.warn("An error occurred while running command "+ee,Mt)})},void 0,void 0,Le)},registerDiffInformationCommand:(ee,he,Oe)=>((0,xe.$4G)(Le,"diffCommand"),vt.registerCommand(!0,ee,async(...at)=>{const Dt=Lt.activeEditor(!0);if(!Dt){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Mt=await Wt.getDiffInformation(Dt.id);he.apply(Oe,[Mt,...at])},void 0,void 0,Le)),executeCommand(ee,...he){return vt.executeCommand(ee,...he)},getCommands(ee=!1){return vt.getCommands(ee)}},Ni={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return ot(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$4G)(Le,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$4G)(Le,"telemetry"),ot(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$NP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,he){return tt.$MP.validateSender(ee),Bt.instantiateLogger(Le,ee,he)},openExternal(ee,he){return Ot.openUri(ee,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===bt.environment.appUriScheme)return Ri.createAppUri(ee);try{return await Ot.asExternalUri(ee,{allowTunneling:!!bt.remote.authority})}catch(he){if((0,A.$Ng)(ee,A.Schemas.http)||(0,A.$Ng)(ee,A.Schemas.https))return ee;throw he}},get remoteName(){return(0,o.$gn)(bt.remote.authority)},get remoteAuthority(){return(0,xe.$4G)(Le,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return ot(St.onDidChangeLogLevel)},get appQuality(){return(0,xe.$4G)(Le,"resolvers"),bt.quality},get appCommit(){return(0,xe.$4G)(Le,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Ni);const wn={createTestController(ee,he,Oe){return ki.createTestController(Le,ee,he,Oe)},createTestObserver(){return(0,xe.$4G)(Le,"testObserver"),ki.createTestObserver()},runTests(ee){return(0,xe.$4G)(Le,"testObserver"),ki.runTests(ee)},registerTestFollowupProvider(ee){return(0,xe.$4G)(Le,"testObserver"),ki.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,xe.$4G)(Le,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,xe.$4G)(Le,"testObserver"),ki.results}},li=bt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ui={getExtension(ee,he){(0,xe.$3G)(Le,"extensionsAny")||(he=!1);const Oe=bi.mine.getExtensionDescription(ee);if(Oe)return new me.$boc(jt,Le.identifier,Oe,li,!1);if(he){const at=bi.all.getExtensionDescription(ee);if(at)return new me.$boc(jt,Le.identifier,at,li,!0)}},get all(){const ee=[];for(const he of bi.mine.getAllExtensionDescriptions())ee.push(new me.$boc(jt,Le.identifier,he,li,!1));return ee},get allAcrossExtensionHosts(){(0,xe.$4G)(Le,"extensionsAny");const ee=new E.$qn(bi.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of bi.all.getAllExtensionDescriptions()){const at=!ee.has(Oe.identifier);he.push(new me.$boc(jt,Le.identifier,Oe,li,at))}return he},get onDidChange(){return(0,xe.$3G)(Le,"extensionsAny")?ot(P.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ot(bi.mine.onDidChange)}},sn={createDiagnosticCollection(ee){return le.createDiagnosticCollection(Le.identifier,ee)},get onDidChangeDiagnostics(){return ot(le.onDidChangeDiagnostics)},getDiagnostics:ee=>le.getDiagnostics(ee),getLanguages(){return Q.getLanguages()},setTextDocumentLanguage(ee,he){return Q.changeLanguage(ee.uri,he)},match(ee,he){const Oe=je.LanguageSelector.from(ee);let at;return(0,R.$pu)(Oe)&&(at=Rt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Mt=>Mt.document===he))?.apiNotebook),(0,R.$ou)(Oe,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ee,he,Oe){return Ee.registerCodeActionProvider(Le,Et(ee),he,Oe)},registerDocumentPasteEditProvider(ee,he,Oe){return(0,xe.$4G)(Le,"documentPaste"),Ee.registerDocumentPasteEditProvider(Le,Et(ee),he,Oe)},registerCodeLensProvider(ee,he){return Ee.registerCodeLensProvider(Le,Et(ee),he)},registerDefinitionProvider(ee,he){return Ee.registerDefinitionProvider(Le,Et(ee),he)},registerDeclarationProvider(ee,he){return Ee.registerDeclarationProvider(Le,Et(ee),he)},registerImplementationProvider(ee,he){return Ee.registerImplementationProvider(Le,Et(ee),he)},registerTypeDefinitionProvider(ee,he){return Ee.registerTypeDefinitionProvider(Le,Et(ee),he)},registerHoverProvider(ee,he){return Ee.registerHoverProvider(Le,Et(ee),he,Le.identifier)},registerEvaluatableExpressionProvider(ee,he){return Ee.registerEvaluatableExpressionProvider(Le,Et(ee),he,Le.identifier)},registerInlineValuesProvider(ee,he){return Ee.registerInlineValuesProvider(Le,Et(ee),he,Le.identifier)},registerDocumentHighlightProvider(ee,he){return Ee.registerDocumentHighlightProvider(Le,Et(ee),he)},registerMultiDocumentHighlightProvider(ee,he){return Ee.registerMultiDocumentHighlightProvider(Le,Et(ee),he)},registerLinkedEditingRangeProvider(ee,he){return Ee.registerLinkedEditingRangeProvider(Le,Et(ee),he)},registerReferenceProvider(ee,he){return Ee.registerReferenceProvider(Le,Et(ee),he)},registerRenameProvider(ee,he){return Ee.registerRenameProvider(Le,Et(ee),he)},registerNewSymbolNamesProvider(ee,he){return(0,xe.$4G)(Le,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Le,Et(ee),he)},registerDocumentSymbolProvider(ee,he,Oe){return Ee.registerDocumentSymbolProvider(Le,Et(ee),he,Oe)},registerWorkspaceSymbolProvider(ee){return Ee.registerWorkspaceSymbolProvider(Le,ee)},registerDocumentFormattingEditProvider(ee,he){return Ee.registerDocumentFormattingEditProvider(Le,Et(ee),he)},registerDocumentRangeFormattingEditProvider(ee,he){return Ee.registerDocumentRangeFormattingEditProvider(Le,Et(ee),he)},registerOnTypeFormattingEditProvider(ee,he,Oe,...at){return Ee.registerOnTypeFormattingEditProvider(Le,Et(ee),he,[Oe].concat(at))},registerDocumentSemanticTokensProvider(ee,he,Oe){return Ee.registerDocumentSemanticTokensProvider(Le,Et(ee),he,Oe)},registerDocumentRangeSemanticTokensProvider(ee,he,Oe){return Ee.registerDocumentRangeSemanticTokensProvider(Le,Et(ee),he,Oe)},registerSignatureHelpProvider(ee,he,Oe,...at){return typeof Oe=="object"?Ee.registerSignatureHelpProvider(Le,Et(ee),he,Oe):Ee.registerSignatureHelpProvider(Le,Et(ee),he,typeof Oe>"u"?[]:[Oe,...at])},registerCompletionItemProvider(ee,he,...Oe){return Ee.registerCompletionItemProvider(Le,Et(ee),he,Oe)},registerInlineCompletionItemProvider(ee,he,Oe){return he.handleDidShowCompletionItem&&(0,xe.$4G)(Le,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,xe.$4G)(Le,"inlineCompletionsAdditions"),Oe&&(0,xe.$4G)(Le,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Le,Et(ee),he,Oe)},registerInlineEditProvider(ee,he){return(0,xe.$4G)(Le,"inlineEdit"),Ee.registerInlineEditProvider(Le,Et(ee),he)},registerDocumentLinkProvider(ee,he){return Ee.registerDocumentLinkProvider(Le,Et(ee),he)},registerColorProvider(ee,he){return Ee.registerColorProvider(Le,Et(ee),he)},registerFoldingRangeProvider(ee,he){return Ee.registerFoldingRangeProvider(Le,Et(ee),he)},registerSelectionRangeProvider(ee,he){return Ee.registerSelectionRangeProvider(Le,ee,he)},registerCallHierarchyProvider(ee,he){return Ee.registerCallHierarchyProvider(Le,ee,he)},registerTypeHierarchyProvider(ee,he){return Ee.registerTypeHierarchyProvider(Le,ee,he)},setLanguageConfiguration:(ee,he)=>Ee.setLanguageConfiguration(Le,ee,he),getTokenInformationAtPosition(ee,he){return(0,xe.$4G)(Le,"tokenInformation"),Q.tokenAtPosition(ee,he)},registerInlayHintsProvider(ee,he){return Ee.registerInlayHintsProvider(Le,ee,he)},createLanguageStatusItem(ee,he){return Q.createLanguageStatusItem(Le,ee,he)},registerDocumentDropEditProvider(ee,he,Oe){return Ee.registerDocumentOnDropEditProvider(Le,ee,he,(0,xe.$3G)(Le,"documentPaste")?Oe:void 0)}},on={get activeTextEditor(){return Wt.getActiveTextEditor()},get visibleTextEditors(){return Wt.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(ee,he,Oe){p.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&At.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(ee)?Promise.resolve(Ji.openTextDocument(ee)):Promise.resolve(ee));return Wt.showTextDocument(at,he,Oe)},createTextEditorDecorationType(ee){return Wt.createTextEditorDecorationType(Le,ee)},onDidChangeActiveTextEditor(ee,he,Oe){return ot(Wt.onDidChangeActiveTextEditor)(ee,he,Oe)},onDidChangeVisibleTextEditors(ee,he,Oe){return ot(Wt.onDidChangeVisibleTextEditors)(ee,he,Oe)},onDidChangeTextEditorSelection(ee,he,Oe){return ot(Wt.onDidChangeTextEditorSelection)(ee,he,Oe)},onDidChangeTextEditorOptions(ee,he,Oe){return ot(Wt.onDidChangeTextEditorOptions)(ee,he,Oe)},onDidChangeTextEditorVisibleRanges(ee,he,Oe){return ot(Wt.onDidChangeTextEditorVisibleRanges)(ee,he,Oe)},onDidChangeTextEditorViewColumn(ee,he,Oe){return ot(Wt.onDidChangeTextEditorViewColumn)(ee,he,Oe)},onDidCloseTerminal(ee,he,Oe){return ot(Ct.onDidCloseTerminal)(ee,he,Oe)},onDidOpenTerminal(ee,he,Oe){return ot(Ct.onDidOpenTerminal)(ee,he,Oe)},onDidChangeActiveTerminal(ee,he,Oe){return ot(Ct.onDidChangeActiveTerminal)(ee,he,Oe)},onDidChangeTerminalDimensions(ee,he,Oe){return(0,xe.$4G)(Le,"terminalDimensions"),ot(Ct.onDidChangeTerminalDimensions)(ee,he,Oe)},onDidChangeTerminalState(ee,he,Oe){return ot(Ct.onDidChangeTerminalState)(ee,he,Oe)},onDidWriteTerminalData(ee,he,Oe){return(0,xe.$4G)(Le,"terminalDataWriteEvent"),ot(Ct.onDidWriteTerminalData)(ee,he,Oe)},onDidExecuteTerminalCommand(ee,he,Oe){return(0,xe.$4G)(Le,"terminalExecuteCommandEvent"),ot(Ct.onDidExecuteTerminalCommand)(ee,he,Oe)},onDidChangeTerminalShellIntegration(ee,he,Oe){return(0,xe.$4G)(Le,"terminalShellIntegration"),ot(Tt.onDidChangeTerminalShellIntegration)(ee,he,Oe)},onDidStartTerminalShellExecution(ee,he,Oe){return(0,xe.$4G)(Le,"terminalShellIntegration"),ot(Tt.onDidStartTerminalShellExecution)(ee,he,Oe)},onDidEndTerminalShellExecution(ee,he,Oe){return(0,xe.$4G)(Le,"terminalShellIntegration"),ot(Tt.onDidEndTerminalShellExecution)(ee,he,Oe)},get state(){return Ot.getState()},onDidChangeWindowState(ee,he,Oe){return ot(Ot.onDidChangeWindowState)(ee,he,Oe)},showInformationMessage(ee,...he){return Ki.showMessage(Le,N.default.Info,ee,he[0],he.slice(1))},showWarningMessage(ee,...he){return Ki.showMessage(Le,N.default.Warning,ee,he[0],he.slice(1))},showErrorMessage(ee,...he){return Ki.showMessage(Le,N.default.Error,ee,he[0],he.slice(1))},showQuickPick(ee,he,Oe){return Ge.showQuickPick(Le,ee,he,Oe)},showWorkspaceFolderPick(ee){return Ge.showWorkspaceFolderPick(ee)},showInputBox(ee,he){return Ge.showInput(ee,he)},showOpenDialog(ee){return Li.showOpenDialog(Le,ee)},showSaveDialog(ee){return Li.showSaveDialog(ee)},createStatusBarItem(ee,he,Oe){let at,Dt,Mt;return typeof ee=="string"?(at=ee,Dt=he,Mt=Oe):(Dt=ee,Mt=he),tn.createStatusBarEntry(Le,at,Dt,Mt)},setStatusBarMessage(ee,he){return tn.setStatusBarMessage(ee,he)},withScmProgress(ee){return At.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ut.withProgress(Le,{location:H.ProgressLocation.SourceControl},(he,Oe)=>ee({report(at){}}))},withProgress(ee,he){return Ut.withProgress(Le,ee,he)},createOutputChannel(ee,he){return $i.createOutputChannel(ee,he,Le)},createWebviewPanel(ee,he,Oe,at){return Oi.createWebviewPanel(Le,ee,he,Oe,at)},createWebviewTextEditorInset(ee,he,Oe,at){return(0,xe.$4G)(Le,"editorInsets"),Te.createWebviewEditorInset(ee,he,Oe,at,Le)},createTerminal(ee,he,Oe){return typeof ee=="object"?"pty"in ee?Ct.createExtensionTerminal(ee):Ct.createTerminalFromOptions(ee):Ct.createTerminal(ee,he,Oe)},registerTerminalLinkProvider(ee){return Ct.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,he){return Ct.registerProfileProvider(Le,ee,he)},registerTerminalQuickFixProvider(ee,he){return(0,xe.$4G)(Le,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(ee,Le.identifier.value,he)},registerTreeDataProvider(ee,he){return ye.registerTreeDataProvider(ee,he,Le)},createTreeView(ee,he){return ye.createTreeView(ee,he,Le)},registerWebviewPanelSerializer:(ee,he)=>Oi.registerWebviewPanelSerializer(Le,ee,he),registerCustomEditorProvider:(ee,he,Oe={})=>Vi.registerCustomEditorProvider(Le,ee,he,Oe),registerFileDecorationProvider(ee){return di.registerFileDecorationProvider(ee,Le)},registerUriHandler(ee){return Ri.registerUriHandler(Le,ee)},createQuickPick(){return Ge.createQuickPick(Le)},createInputBox(){return Ge.createInputBox(Le)},get activeColorTheme(){return ji.activeColorTheme},onDidChangeActiveColorTheme(ee,he,Oe){return ot(ji.onDidChangeActiveColorTheme)(ee,he,Oe)},registerWebviewViewProvider(ee,he,Oe){return Wi.registerWebviewViewProvider(Le,ee,he,Oe?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,he,Oe){return ot(Rt.onDidChangeActiveNotebookEditor)(ee,he,Oe)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,he,Oe){return ot(Si.onDidChangeNotebookEditorSelection)(ee,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ee,he,Oe){return ot(Si.onDidChangeNotebookEditorVisibleRanges)(ee,he,Oe)},showNotebookDocument(ee,he){return Rt.showNotebookDocument(ee,he)},registerExternalUriOpener(ee,he,Oe){return(0,xe.$4G)(Le,"externalUriOpener"),xi.registerExternalUriOpener(Le.identifier,ee,he,Oe)},registerProfileContentHandler(ee,he){return(0,xe.$4G)(Le,"profileContentHandlers"),_i.registerProfileContentHandler(Le,ee,he)},registerQuickDiffProvider(ee,he,Oe,at){return(0,xe.$4G)(Le,"quickDiffProvider"),Pt.registerQuickDiffProvider(Et(ee),he,Oe,at)},get tabGroups(){return ii.tabGroups},registerShareProvider(ee,he){return(0,xe.$4G)(Le,"shareProvider"),Xt.registerShareProvider(Et(ee),he)}},Ji={get rootPath(){return At.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ee){throw new C.$0("rootPath")},getWorkspaceFolder(ee){return wt.getWorkspaceFolder(ee)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ee){throw new C.$0("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ee){throw new C.$0("workspaceFile")},updateWorkspaceFolders:(ee,he,...Oe)=>wt.updateWorkspaceFolders(Le,ee,he||0,...Oe),onDidChangeWorkspaceFolders:function(ee,he,Oe){return ot(wt.onDidChangeWorkspace)(ee,he,Oe)},asRelativePath:(ee,he)=>wt.getRelativePath(ee,he),findFiles:(ee,he,Oe,at)=>wt.findFiles(ee,he,Oe,Le.identifier,at),findFiles2:(ee,he,Oe)=>((0,xe.$4G)(Le,"findFiles2"),wt.findFiles2(ee,he,Le.identifier,Oe)),findTextInFiles:(ee,he,Oe,at)=>{(0,xe.$4G)(Le,"findTextInFiles");let Dt,Mt;return typeof he=="object"?(Dt=he,Mt=Oe):(Dt={},Mt=he,at=Oe),wt.findTextInFiles(ee,Dt||{},Mt,Le.identifier,at)},save:ee=>wt.save(ee),saveAs:ee=>wt.saveAs(ee),saveAll:ee=>wt.saveAll(ee),applyEdit(ee,he){return bn.applyWorkspaceEdit(ee,Le,he)},createFileSystemWatcher:(ee,he,Oe,at)=>{let Dt;return typeof he=="boolean"?Dt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,xe.$4G)(Le,"createFileSystemWatcher"),Dt={...he,correlate:!0}),Xe.createFileSystemWatcher(wt,Le,ee,Dt)},get textDocuments(){return Nt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new C.$0("textDocuments")},openTextDocument(ee){let he;const Oe=ee;if(typeof ee=="string")he=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))he=Promise.resolve(ee);else if(!Oe||typeof Oe=="object")he=Nt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ee,he,Oe)=>ot(Nt.onDidAddDocument)(ee,he,Oe),onDidCloseTextDocument:(ee,he,Oe)=>ot(Nt.onDidRemoveDocument)(ee,he,Oe),onDidChangeTextDocument:(ee,he,Oe)=>ot(Nt.onDidChangeDocument)(ee,he,Oe),onDidSaveTextDocument:(ee,he,Oe)=>ot(Nt.onDidSaveDocument)(ee,he,Oe),onWillSaveTextDocument:(ee,he,Oe)=>ot(ai.getOnWillSaveTextDocumentEvent(Le))(ee,he,Oe),get notebookDocuments(){return Rt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,he){let Oe;if(p.URI.isUri(ee))Oe=ee,await Rt.openNotebookDocument(ee);else if(typeof ee=="string")Oe=p.URI.revive(await Rt.createNotebookDocument({viewType:ee,content:he}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ee,he,Oe){return ot(Di.onDidSaveNotebookDocument)(ee,he,Oe)},onDidChangeNotebookDocument(ee,he,Oe){return ot(Di.onDidChangeNotebookDocument)(ee,he,Oe)},onWillSaveNotebookDocument(ee,he,Oe){return ot(gi.getOnWillSaveNotebookDocumentEvent(Le))(ee,he,Oe)},get onDidOpenNotebookDocument(){return ot(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,he,Oe,at){return Rt.registerNotebookSerializer(Le,ee,he,Oe,(0,xe.$3G)(Le,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ee,he,Oe)=>ot(Hi.onDidChangeConfiguration)(ee,he,Oe),getConfiguration(ee,he){return he=arguments.length===1?void 0:he,Hi.getConfiguration(ee,he,Le)},registerTextDocumentContentProvider(ee,he){return Ti.registerTextDocumentContentProvider(ee,he)},registerTaskProvider:(ee,he)=>(At.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Le,ee,he)),registerFileSystemProvider(ee,he,Oe){return(0,M.$Sc)(Ve.registerFileSystemProvider(Le,ee,he,Oe),_t.addFileSystemProvider(ee,he,Oe))},get fs(){return _t.value},registerFileSearchProvider:(ee,he)=>((0,xe.$4G)(Le,"fileSearchProvider"),Zt.registerFileSearchProvider(ee,he)),registerTextSearchProvider:(ee,he)=>((0,xe.$4G)(Le,"textSearchProvider"),Zt.registerTextSearchProvider(ee,he)),registerAITextSearchProvider:(ee,he)=>((0,xe.$4G)(Le,"aiTextSearchProvider"),(0,xe.$4G)(Le,"textSearchProvider"),Zt.registerAITextSearchProvider(ee,he)),registerRemoteAuthorityResolver:(ee,he)=>((0,xe.$4G)(Le,"resolvers"),jt.registerRemoteAuthorityResolver(ee,he)),registerResourceLabelFormatter:ee=>((0,xe.$4G)(Le,"resolvers"),ni.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,xe.$4G)(Le,"resolvers"),jt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,he,Oe)=>ot(Xe.onDidCreateFile)(ee,he,Oe),onDidDeleteFiles:(ee,he,Oe)=>ot(Xe.onDidDeleteFile)(ee,he,Oe),onDidRenameFiles:(ee,he,Oe)=>ot(Xe.onDidRenameFile)(ee,he,Oe),onWillCreateFiles:(ee,he,Oe)=>ot(Xe.getOnWillCreateFileEvent(Le))(ee,he,Oe),onWillDeleteFiles:(ee,he,Oe)=>ot(Xe.getOnWillDeleteFileEvent(Le))(ee,he,Oe),onWillRenameFiles:(ee,he,Oe)=>ot(Xe.getOnWillRenameFileEvent(Le))(ee,he,Oe),openTunnel:ee=>((0,xe.$4G)(Le,"tunnels"),Kt.openTunnel(Le,ee).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,xe.$4G)(Le,"tunnels"),Kt.getTunnels()},onDidChangeTunnels:(ee,he,Oe)=>((0,xe.$4G)(Le,"tunnels"),ot(Kt.onDidChangeTunnels)(ee,he,Oe)),registerPortAttributesProvider:(ee,he)=>((0,xe.$4G)(Le,"portsAttributes"),Kt.registerPortsAttributesProvider(ee,he)),registerTunnelProvider:(ee,he)=>((0,xe.$4G)(Le,"tunnelFactory"),Kt.registerTunnelProvider(ee,he)),registerTimelineProvider:(ee,he)=>((0,xe.$4G)(Le,"timeline"),Yi.registerTimelineProvider(ee,he,Le.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ee=>((0,xe.$4G)(Le,"workspaceTrust"),wt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,he,Oe)=>ot(wt.onDidGrantWorkspaceTrust)(ee,he,Oe),registerEditSessionIdentityProvider:(ee,he)=>((0,xe.$4G)(Le,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ee,he)),onWillCreateEditSessionIdentity:(ee,he,Oe)=>((0,xe.$4G)(Le,"editSessionIdentityProvider"),ot(wt.getOnWillCreateEditSessionIdentityEvent(Le))(ee,he,Oe)),registerCanonicalUriProvider:(ee,he)=>((0,xe.$4G)(Le,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ee,he)),getCanonicalUri:(ee,he,Oe)=>((0,xe.$4G)(Le,"canonicalUriProvider"),wt.provideCanonicalUri(ee,he,Oe))},an={get inputBox(){return At.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),lt.getLastInputBox(Le)},createSourceControl(ee,he,Oe){return lt.createSourceControl(Le,ee,he,Oe)}},vn={createCommentController(ee,he){return ci.createCommentController(Le,ee,he)}},cn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(ee,he){return(0,xe.$4G)(Le,"debugVisualization"),kt.registerDebugVisualizationProvider(Le,ee,he)},registerDebugVisualizationTreeProvider(ee,he){return(0,xe.$4G)(Le,"debugVisualization"),kt.registerDebugVisualizationTree(Le,ee,he)},onDidStartDebugSession(ee,he,Oe){return ot(kt.onDidStartDebugSession)(ee,he,Oe)},onDidTerminateDebugSession(ee,he,Oe){return ot(kt.onDidTerminateDebugSession)(ee,he,Oe)},onDidChangeActiveDebugSession(ee,he,Oe){return ot(kt.onDidChangeActiveDebugSession)(ee,he,Oe)},onDidReceiveDebugSessionCustomEvent(ee,he,Oe){return ot(kt.onDidReceiveDebugSessionCustomEvent)(ee,he,Oe)},onDidChangeBreakpoints(ee,he,Oe){return ot(kt.onDidChangeBreakpoints)(ee,he,Oe)},onDidChangeActiveStackItem(ee,he,Oe){return ot(kt.onDidChangeActiveStackItem)(ee,he,Oe)},registerDebugConfigurationProvider(ee,he,Oe){return kt.registerDebugConfigurationProvider(ee,he,Oe||xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,he){return kt.registerDebugAdapterDescriptorFactory(Le,ee,he)},registerDebugAdapterTrackerFactory(ee,he){return kt.registerDebugAdapterTrackerFactory(ee,he)},startDebugging(ee,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?kt.startDebugging(ee,he,{parentSession:Oe}):kt.startDebugging(ee,he,Oe||{})},stopDebugging(ee){return kt.stopDebugging(ee)},addBreakpoints(ee){return kt.addBreakpoints(ee)},removeBreakpoints(ee){return kt.removeBreakpoints(ee)},asDebugSourceUri(ee,he){return kt.asDebugSourceUri(ee,he)}},ln={registerTaskProvider:(ee,he)=>qt.registerTaskProvider(Le,ee,he),fetchTasks:ee=>qt.fetchTasks(ee),executeTask:ee=>qt.executeTask(Le,ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ee,he,Oe)=>ot(qt.onDidStartTask)(ee,he,Oe),onDidEndTask:(ee,he,Oe)=>ot(qt.onDidEndTask)(ee,he,Oe),onDidStartTaskProcess:(ee,he,Oe)=>ot(qt.onDidStartTaskProcess)(ee,he,Oe),onDidEndTaskProcess:(ee,he,Oe)=>ot(qt.onDidEndTaskProcess)(ee,he,Oe)},yn={createNotebookController(ee,he,Oe,at,Dt){return vi.createNotebookController(Le,ee,he,Oe,at,(0,xe.$3G)(Le,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,he)=>Rt.registerNotebookCellStatusBarItemProvider(Le,ee,he),createRendererMessaging(ee){return Mi.createRendererMessaging(Le,ee)},createNotebookControllerDetectionTask(ee){return(0,xe.$4G)(Le,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(Le,ee)},registerKernelSourceActionProvider(ee,he){return(0,xe.$4G)(Le,"notebookKernelSource"),vi.registerKernelSourceActionProvider(Le,ee,he)},onDidChangeNotebookCellExecutionState(ee,he,Oe){return(0,xe.$4G)(Le,"notebookCellExecutionState"),ot(vi.onDidChangeNotebookCellExecutionState)(ee,he,Oe)}},En={t(...ee){if(typeof ee[0]=="string"){const he=ee.shift(),Oe=!ee||typeof ee[0]!="object"?ee:ee[0];return fi.getMessage(Le.identifier.value,{message:he,args:Oe})}return fi.getMessage(Le.identifier.value,ee[0])},get bundle(){return fi.getBundle(Le.identifier.value)},get uri(){return fi.getBundleUri(Le.identifier.value)}},un={_version:1,transferActiveChat(ee){return(0,xe.$4G)(Le,"interactive"),Fi.transferActiveChat(ee)}},Qi={getRelatedInformation(ee,he){return(0,xe.$4G)(Le,"aiRelatedInformation"),qi.getRelatedInformation(Le,ee,he)},registerRelatedInformationProvider(ee,he){return(0,xe.$4G)(Le,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Le,ee,he)},registerEmbeddingVectorProvider(ee,he){return(0,xe.$4G)(Le,"aiRelatedInformation"),pn.registerEmbeddingVectorProvider(Le,ee,he)}},hn={_version:1,registerChatResponseProvider(ee,he,Oe){return(0,xe.$4G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,ee,he,Oe)},registerChatVariableResolver(ee,he,Oe,at,Dt,Mt,Ii,zi){return(0,xe.$4G)(Le,"chatVariableResolver"),en.registerVariableResolver(Le,ee,he,Oe,at,Dt,Mt,Ii,zi?.id)},registerMappedEditsProvider(ee,he){return(0,xe.$4G)(Le,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Le,ee,he)},createChatParticipant(ee,he){return Fi.createChatAgent(Le,ee,he)},createDynamicChatParticipant(ee,he,Oe){return(0,xe.$4G)(Le,"chatParticipantPrivate"),Fi.createDynamicChatAgent(Le,ee,he,Oe)}},dn={selectChatModels:ee=>bt.quality==="stable"?(console.warn(`[${E.$pn.toKey(Le.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):Ht.selectLanguageModels(Le,ee??{}),onDidChangeChatModels:(ee,he,Oe)=>bt.quality==="stable"?(console.warn(`[${E.$pn.toKey(Le.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),P.Event.None(ee,he,Oe)):Ht.onDidChangeProviders(ee,he,Oe),registerChatModelProvider:(ee,he,Oe)=>((0,xe.$4G)(Le,"chatProvider"),Ht.registerLanguageModel(Le,ee,he,Oe)),get embeddingModels(){return(0,xe.$4G)(Le,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ee,he,Oe)=>((0,xe.$4G)(Le,"embeddings"),Ci.onDidChange(ee,he,Oe)),registerEmbeddingsProvider(ee,he){return(0,xe.$4G)(Le,"embeddings"),Ci.registerEmbeddingsProvider(Le,ee,he)},async computeEmbeddings(ee,he,Oe){return(0,xe.$4G)(Le,"embeddings"),Ci.computeEmbeddings(ee,he,Oe)}},fn={registerSpeechProvider(ee,he){return(0,xe.$4G)(Le,"speech"),Gi.registerProvider(Le.identifier,ee,he)}};return{version:bt.version,ai:Qi,authentication:rn,commands:yi,comments:vn,chat:hn,debug:cn,env:Ni,extensions:Ui,interactive:un,l10n:En,languages:sn,lm:dn,notebooks:yn,scm:an,speech:fn,tasks:ln,tests:wn,window:on,workspace:Ji,Breakpoint:H.$4N,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatResultFeedbackKind:H.ChatResultFeedbackKind,ChatVariableLevel:H.ChatVariableLevel,ChatCompletionItem:H.$YO,CallHierarchyIncomingCall:H.$pN,CallHierarchyItem:H.$oN,CallHierarchyOutgoingCall:H.$qN,CancellationError:C.$6,CancellationTokenSource:w.$we,CandidatePortSource:n.CandidatePortSource,CodeAction:H.$lN,CodeActionKind:H.$mN,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$rN,Color:H.$EN,ColorInformation:H.$FN,ColorPresentation:H.$GN,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CommentThreadApplicability:H.CommentThreadApplicability,CompletionItem:H.$yN,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$zN,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$ON,DebugAdapterExecutable:H.$8N,DebugAdapterInlineImplementation:H.$$N,DebugAdapterNamedPipeServer:H.$0N,DebugAdapterServer:H.$9N,DebugConfigurationProviderTriggerKind:xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DebugVisualization:H.$oO,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$eN,DiagnosticRelatedInformation:H.$dN,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$3M,DocumentHighlight:H.$hN,DocumentHighlightKind:H.DocumentHighlightKind,MultiDocumentHighlight:H.$iN,DocumentLink:H.$DN,DocumentSymbol:H.$kN,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$bO,InlineValueText:H.$cO,InlineValueVariableLookup:H.$dO,InlineValueEvaluatableExpression:H.$eO,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:P.$le,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$qO,FileDecoration2:H.$qO,FileSystemError:H.$hO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:H.$iO,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$6N,InlineCompletionItem:H.$AN,InlineCompletionList:H.$BN,Hover:H.$fN,VerboseHover:H.$gN,HoverVerbosityAction:H.HoverVerbosityAction,IndentAction:v.IndentAction,Location:H.$cN,MarkdownString:H.$sN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:H.$tN,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$4M,ProcessExecution:H.$MN,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$pO,Range:H.$5M,RelativePattern:H.$2N,Selection:H.$6M,SelectionRange:H.$nN,SemanticTokens:H.$lO,SemanticTokensBuilder:H.$kO,SemanticTokensEdit:H.$mO,SemanticTokensEdits:H.$nO,SemanticTokensLegend:H.$jO,ShellExecution:H.$NN,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$vN,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$uN,SnippetString:H.$bN,SourceBreakpoint:H.$5N,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$jN,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$PN,TaskGroup:H.$LN,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$HN,TerminalQuickFixTerminalCommand:H.$JN,TerminalQuickFixOpener:H.$IN,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$KN,TerminalExitReason:H.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:H.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$0M,SnippetTextEdit:H.$_M,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,SyntaxTokenType:H.SyntaxTokenType,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$1N,ThemeIcon:H.$ZN,TreeItem:H.$QN,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$MO,UIKind:ui.UIKind,Uri:p.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$aN,DocumentPasteTriggerKind:H.DocumentPasteTriggerKind,DocumentDropEdit:H.$WN,DocumentDropOrPasteEditKind:H.$XN,DocumentPasteEdit:H.$YN,InlayHint:H.$xN,InlayHintLabelPart:H.$wN,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$9M,ResolvedAuthority:H.$7M,ManagedResolvedAuthority:H.$8M,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$AO,NotebookRange:H.$sO,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$tO,NotebookData:H.$uO,NotebookRendererScript:H.$yO,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$wO,NotebookCellOutputItem:H.$vO,NotebookCellStatusBarItem:H.$xO,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$$M,NotebookKernelSourceAction:H.$zO,NotebookVariablesRequestKind:H.NotebookVariablesRequestKind,PortAttributes:H.$CO,LinkedEditingRanges:H.$BO,TestResultState:H.TestResultState,TestRunRequest:H.$DO,TestMessage:H.$EO,TestTag:H.$FO,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:It.TextSearchCompleteMessageType,DataTransfer:H.$VN,DataTransferItem:H.$RN,TestCoverageCount:H.$GO,FileCoverage:H.$IO,FileCoverage2:H.$IO,StatementCoverage:H.$JO,BranchCoverage:H.$KO,DeclarationCoverage:H.$LO,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$NO,TabInputTextDiff:H.$OO,TabInputTextMerge:H.$PO,TabInputCustom:H.$QO,TabInputNotebook:H.$SO,TabInputNotebookDiff:H.$TO,TabInputWebview:H.$RO,TabInputTerminal:H.$UO,TabInputInteractiveWindow:H.$VO,TabInputChat:H.$WO,TabInputTextMultiDiff:H.$XO,TelemetryTrustedValue:a.$sp,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,ChatCopyKind:H.ChatCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,DebugStackFrame:H.$_N,DebugThread:H.$aO,RelatedInformationType:H.RelatedInformationType,SpeechToTextStatus:H.SpeechToTextStatus,TextToSpeechStatus:H.TextToSpeechStatus,PartialAcceptTriggerKind:H.PartialAcceptTriggerKind,KeywordRecognitionStatus:H.KeywordRecognitionStatus,ChatResponseMarkdownPart:H.$ZO,ChatResponseFileTreePart:H.$4O,ChatResponseAnchorPart:H.$5O,ChatResponseProgressPart:H.$6O,ChatResponseProgressPart2:H.$7O,ChatResponseReferencePart:H.$0O,ChatResponseWarningPart:H.$8O,ChatResponseTextEditPart:H.$$O,ChatResponseMarkdownWithVulnerabilitiesPart:H.$1O,ChatResponseCommandButtonPart:H.$9O,ChatResponseDetectedParticipantPart:H.$2O,ChatResponseConfirmationPart:H.$3O,ChatRequestTurn:H.$_O,ChatResponseTurn:H.$aP,ChatLocation:H.ChatLocation,LanguageModelChatMessageRole:H.LanguageModelChatMessageRole,LanguageModelChatMessage:H.$cP,LanguageModelChatMessageFunctionResultPart:H.$bP,LanguageModelChatResponseTextPart:H.$eP,LanguageModelChatResponseFunctionUsePart:H.$dP,LanguageModelChatMessage2:H.$cP,LanguageModelChatSystemMessage:H.$fP,LanguageModelChatUserMessage:H.$gP,LanguageModelChatAssistantMessage:H.$hP,LanguageModelError:H.$iP,NewSymbolName:H.$gO,NewSymbolNameTag:H.NewSymbolNameTag,NewSymbolNameTriggerKind:H.NewSymbolNameTriggerKind,InlineEdit:H.$jP,InlineEditTriggerKind:H.InlineEditTriggerKind}}}}),define(Ce[318],Ie([1,0,61,127,44,121,45,34,58,57,130,132,133,89,93,85,120,69,51,88,67,71,258,12,131,86,87,91,95,125,96]),function(oe,e,w,C,P,M,A,N,p,c,R,v,l,E,d,r,o,a,h,n,s,i,t,m,f,u,$,I,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$Ks)(u.$8nc,u.$7nc,w.InstantiationType.Delayed),(0,w.$Ks)(m.$_j,t.$jpc,w.InstantiationType.Delayed),(0,w.$Ks)(r.$anc,r.$bnc,w.InstantiationType.Delayed),(0,w.$Ks)(N.$QP,N.$PP,w.InstantiationType.Eager),(0,w.$Ks)(I.$knc,I.$lnc,w.InstantiationType.Eager),(0,w.$Ks)(D.$2nc,D.$3nc,w.InstantiationType.Eager),(0,w.$Ks)(A.$znc,A.$xnc,w.InstantiationType.Eager),(0,w.$Ks)(a.$Bnc,a.$Anc,w.InstantiationType.Eager),(0,w.$Ks)(S.$foc,S.$goc,w.InstantiationType.Eager),(0,w.$Ks)(v.$koc,v.$ooc,w.InstantiationType.Eager),(0,w.$Ks)(M.$qoc,M.$poc,w.InstantiationType.Eager),(0,w.$Ks)(p.$FP,p.$EP,w.InstantiationType.Eager),(0,w.$Ks)($.$9nc,$.$0nc,w.InstantiationType.Eager),(0,w.$Ks)(h.$enc,h.$dnc,w.InstantiationType.Eager),(0,w.$Ks)(C.$Voc,C.$Uoc,w.InstantiationType.Delayed),(0,w.$Ks)(l.$Goc,l.$Hoc,w.InstantiationType.Eager),(0,w.$Ks)(E.$Unc,E.$Tnc,w.InstantiationType.Eager),(0,w.$Ks)(R.$9oc,R.$8oc,w.InstantiationType.Eager),(0,w.$Ks)(c.$Xnc,c.$1nc,w.InstantiationType.Eager),(0,w.$Ks)(y.$0oc,y.$$oc,w.InstantiationType.Eager),(0,w.$Ks)(d.$4Eb,d.$5Eb,w.InstantiationType.Eager),(0,w.$Ks)(o.$hpc,o.$gpc,w.InstantiationType.Eager),(0,w.$Ks)(P.$wnc,P.$vnc,w.InstantiationType.Eager),(0,w.$Ks)(n.$5nc,n.$4nc,w.InstantiationType.Eager),(0,w.$Ks)(s.$OP,s.$LP,w.InstantiationType.Eager),(0,w.$Ks)(i.$Lnc,i.$Mnc,w.InstantiationType.Eager),(0,w.$Ks)(f.$doc,f.$eoc,w.InstantiationType.Eager)}),define(Ce[319],Ie([1,0,317,46,2,314,7,11,265]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0;class c extends M.$mpc{j(){}getModule(E,d){for(const r of this.b){const o=r(E);if(o){E=o;break}}if(this.a.has(E))return this.a.get(E).load(E,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.$_nc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$urc);const E=this.h.invokeFunction(w.$ipc);this.r=this.h.createInstance(c,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,d,r){d=d.with({path:v(d.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=P.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const n=await h.text(),s=`${d.toString(!0)}#vscode-extension`,i=`${n}
//# sourceURL=${s}`;let t;try{t=new Function("module","exports","require",i)}catch($){throw console.error(o?`Loading code for extension ${o} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const m={},f={exports:m},u=$=>{const I=this.r.getModule($,d);if(I===void 0)throw new Error(`Cannot load module '${$}'`);return I};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(f,m,u),f.exports!==m?f.exports:m}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+E;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,N.$Fh)(10)}}e.$vrc=R;function v(l,E){return l.endsWith(E)?l:l+E}}),define(Ce[320],Ie([1,0,74,61,12,46,228,92,319]),function(oe,e,w,C,P,M,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Ks)(P.$$j,new w.$Bi(A.$lpc,[!0],!0)),(0,C.$Ks)(M.$aoc,p.$vrc,C.InstantiationType.Eager),(0,C.$Ks)(N.$Cnc,N.$Dnc,C.InstantiationType.Eager)}),define(Ce[328],Ie([1,0,23,4,84,315,267,20,65,16,2,318,320]),function(oe,e,w,C,P,M,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=i,N=qe(N),p=qe(p);const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function r(t){self.fetch=async function(m,f){return m instanceof Request||E(String(m))&&(m=(await t(R.URI.parse(String(m)))).toString(!0)),d(m,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,f,u,$,I){(async()=>(E(f.toString())&&(f=(await t(R.URI.parse(f.toString()))).toString(!0)),super.open(m,f,u??!0,$,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(m,f){if(/^file:/i.test(m.toString()))m=c.$Yg.uriToBrowserUri(R.URI.parse(m.toString())).toString(!0);else if(/^vscode-remote:/i.test(m.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(S){function k(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const g=fetch.bind(self);self.fetch=function(F,T){return F instanceof Request?g(F,T):g(k(F),T)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,T,q,G,V){return super.open(F,k(T),q??!0,G,V)}};const b=importScripts.bind(self);self.importScripts=(...F)=>{b(...F.map(k))},b(S)}.toString()}('${m}'))`;f=f||{},f.name=`${name} -> ${f.name||N.$oc(m.toString())}`;const I=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(I);return new t(D,f)}}else self.Worker=class extends A.$wrc{constructor(t,m){super(l,t,{name:N.$oc(t.toString()),...m})}};const o=new class{constructor(){this.pid=void 0}exit(t){v()}};class a{constructor(){const m=new MessageChannel,f=new C.$le;let u=!1;l(m.port2,[m.port2]),m.port1.onmessage=$=>{const{data:I}=$;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const D=w.$Ne.wrap(new Uint8Array(I,0,I.byteLength));if((0,P.$yn)(D,P.MessageType.Terminate)){u=!0,n("received terminate message from renderer");return}f.fire(D)},this.protocol={onMessage:f.event,send:$=>{if(!u){const I=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);m.port1.postMessage(I,[I])}}}}}function h(t){return new Promise(m=>{const f=t.onMessage(u=>{f.dispose();const $=JSON.parse(u.toString());t.send((0,P.$xn)(P.MessageType.Initialized)),m({protocol:t,initData:$})});t.send((0,P.$xn)(P.MessageType.Ready))})}let n=t=>v();function s(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function i(){p.mark("code/extHost/willConnectToRenderer");const t=new a;return{onmessage(m){s(m)&&h(t.protocol).then(f=>{p.mark("code/extHost/didWaitForInitData");const u=new M.$opc(f.protocol,f.initData,o,null,m.data);r($=>u.asBrowserUri($)),n=$=>u.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/fc357074a7bba115fe44683d3f6050c63e591683/core/vs/workbench/api/worker/extensionHostWorker.js.map
